#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 2517
#define LARGE_STATE_COUNT 907
#define SYMBOL_COUNT 259
#define ALIAS_COUNT 1
#define TOKEN_COUNT 138
#define EXTERNAL_TOKEN_COUNT 3
#define FIELD_COUNT 10
#define MAX_ALIAS_SEQUENCE_LENGTH 15
#define PRODUCTION_ID_COUNT 27

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_use = 2,
  anon_sym_EQ = 3,
  anon_sym_AT = 4,
  anon_sym_LBRACK = 5,
  anon_sym_RBRACK = 6,
  anon_sym_QMARK = 7,
  anon_sym_type = 8,
  anon_sym_is = 9,
  anon_sym_actor = 10,
  anon_sym_class = 11,
  anon_sym_primitive = 12,
  anon_sym_interface = 13,
  anon_sym_trait = 14,
  anon_sym_struct = 15,
  anon_sym_embed = 16,
  anon_sym_let = 17,
  anon_sym_var = 18,
  anon_sym_COLON = 19,
  anon_sym_new = 20,
  anon_sym_EQ_GT = 21,
  anon_sym_fun = 22,
  anon_sym_be = 23,
  anon_sym_BSLASH = 24,
  anon_sym_COMMA = 25,
  anon_sym_iso = 26,
  anon_sym_trn = 27,
  anon_sym_ref = 28,
  anon_sym_val = 29,
  anon_sym_box = 30,
  anon_sym_tag = 31,
  anon_sym_LPAREN = 32,
  anon_sym_RPAREN = 33,
  anon_sym_DOT_DOT_DOT = 34,
  anon_sym_DOT = 35,
  anon_sym_POUNDread = 36,
  anon_sym_POUNDsend = 37,
  anon_sym_POUNDshare = 38,
  anon_sym_POUNDalias = 39,
  anon_sym_POUNDany = 40,
  anon_sym_BANG = 41,
  anon_sym_CARET = 42,
  anon_sym_PIPE = 43,
  anon_sym_AMP = 44,
  anon_sym_DASH_GT = 45,
  anon_sym_LBRACE = 46,
  anon_sym_RBRACE = 47,
  anon_sym_SEMI = 48,
  sym_error = 49,
  sym_compile_intrinsic = 50,
  anon_sym_compile_error = 51,
  sym_location = 52,
  anon_sym_DASH = 53,
  anon_sym_not = 54,
  anon_sym_DASH_TILDE = 55,
  anon_sym_addressof = 56,
  anon_sym_digestof = 57,
  anon_sym_PLUS = 58,
  anon_sym_STAR = 59,
  anon_sym_SLASH = 60,
  anon_sym_PERCENT = 61,
  anon_sym_PERCENT_PERCENT = 62,
  anon_sym_LT_LT = 63,
  anon_sym_GT_GT = 64,
  anon_sym_and = 65,
  anon_sym_or = 66,
  anon_sym_xor = 67,
  anon_sym_isnt = 68,
  anon_sym_EQ_EQ = 69,
  anon_sym_BANG_EQ = 70,
  anon_sym_GT = 71,
  anon_sym_GT_EQ = 72,
  anon_sym_LT_EQ = 73,
  anon_sym_LT = 74,
  anon_sym_PLUS_TILDE = 75,
  anon_sym_STAR_TILDE = 76,
  anon_sym_SLASH_TILDE = 77,
  anon_sym_PERCENT_TILDE = 78,
  anon_sym_PERCENT_PERCENT_TILDE = 79,
  anon_sym_LT_LT_TILDE = 80,
  anon_sym_GT_GT_TILDE = 81,
  anon_sym_EQ_EQ_TILDE = 82,
  anon_sym_BANG_EQ_TILDE = 83,
  anon_sym_GT_TILDE = 84,
  anon_sym_GT_EQ_TILDE = 85,
  anon_sym_LT_EQ_TILDE = 86,
  anon_sym_LT_TILDE = 87,
  anon_sym_PLUS_QMARK = 88,
  anon_sym_DASH_QMARK = 89,
  anon_sym_STAR_QMARK = 90,
  anon_sym_SLASH_QMARK = 91,
  anon_sym_PERCENT_QMARK = 92,
  anon_sym_PERCENT_PERCENT_QMARK = 93,
  anon_sym_as = 94,
  anon_sym_LPAREN2 = 95,
  anon_sym_DOT_GT = 96,
  anon_sym_where = 97,
  anon_sym_TILDE = 98,
  anon_sym_end = 99,
  anon_sym_if = 100,
  anon_sym_ifdef = 101,
  anon_sym_then = 102,
  anon_sym_elseif = 103,
  anon_sym_iftype = 104,
  anon_sym_LT_COLON = 105,
  anon_sym_else = 106,
  anon_sym_for = 107,
  anon_sym_in = 108,
  anon_sym_while = 109,
  anon_sym_try = 110,
  anon_sym_with = 111,
  anon_sym_repeat = 112,
  anon_sym_until = 113,
  anon_sym_do = 114,
  anon_sym_recover = 115,
  anon_sym_match = 116,
  anon_sym_return = 117,
  anon_sym_continue = 118,
  anon_sym_break = 119,
  anon_sym_consume = 120,
  anon_sym_object = 121,
  sym_number = 122,
  sym_float = 123,
  anon_sym_DQUOTE = 124,
  anon_sym_DQUOTE_DQUOTE_DQUOTE = 125,
  anon_sym_SQUOTE = 126,
  sym_character_content = 127,
  sym_string_content = 128,
  aux_sym__escape_sequence_token1 = 129,
  sym_escape_sequence = 130,
  anon_sym_true = 131,
  anon_sym_false = 132,
  sym_this = 133,
  sym_line_comment = 134,
  sym__type_args_start = 135,
  sym_block_comment = 136,
  sym__multiline_string_content = 137,
  sym_source_file = 138,
  sym_statement = 139,
  sym_use_statement = 140,
  sym_ffi_method = 141,
  sym_platform_specifier = 142,
  sym_type_alias = 143,
  sym_members = 144,
  sym_actor_definition = 145,
  sym_class_definition = 146,
  sym_primitive_definition = 147,
  sym_interface_definition = 148,
  sym_trait_definition = 149,
  sym_struct_definition = 150,
  sym_field = 151,
  sym_constructor = 152,
  sym_method = 153,
  sym_behavior = 154,
  sym_annotation = 155,
  sym_capability = 156,
  sym_parameters = 157,
  sym_parameter = 158,
  sym_type = 159,
  sym_base_type = 160,
  sym_type_args = 161,
  sym_read_type = 162,
  sym_send_type = 163,
  sym_share_type = 164,
  sym_alias_type = 165,
  sym_any_type = 166,
  sym_iso_type = 167,
  sym_trn_type = 168,
  sym_ref_type = 169,
  sym_val_type = 170,
  sym_box_type = 171,
  sym_tag_type = 172,
  sym_aliased_type = 173,
  sym_ephemeral_type = 174,
  sym_tuple_type = 175,
  sym_union_type = 176,
  sym_intersection_type = 177,
  sym_viewpoint_type = 178,
  sym_lambda_parameters = 179,
  sym_lambda_type = 180,
  sym_block = 181,
  sym_expression = 182,
  sym_compile_error = 183,
  sym_unary_expression = 184,
  sym_binary_expression = 185,
  sym_tuple_expression = 186,
  sym_generic_expression = 187,
  sym_assignment_expression = 188,
  sym_variable_declaration = 189,
  sym_cast_expression = 190,
  sym_call_expression = 191,
  sym_arguments = 192,
  sym_chain_expression = 193,
  sym_named_arguments = 194,
  sym_named_argument = 195,
  sym_lambda_expression = 196,
  sym_lambda_parameter = 197,
  sym_lambda_captures = 198,
  sym_partial_application = 199,
  sym_member_expression = 200,
  sym_parenthesized_expression = 201,
  sym_if_statement = 202,
  sym_if_block = 203,
  sym_then_block = 204,
  sym_elseif_block = 205,
  sym_iftype_statement = 206,
  sym_elseiftype_block = 207,
  sym_else_block = 208,
  sym_for_statement = 209,
  sym_while_statement = 210,
  sym_try_statement = 211,
  sym_with_statement = 212,
  sym_with_elem = 213,
  sym_repeat_statement = 214,
  sym_do_block = 215,
  sym_recover_statement = 216,
  sym_match_statement = 217,
  sym_case_statement = 218,
  sym_return_statement = 219,
  sym_continue_statement = 220,
  sym_break_statement = 221,
  sym_consume_statement = 222,
  sym_generic_parameter = 223,
  sym_generic_parameters = 224,
  sym_literal = 225,
  sym_array_literal = 226,
  sym_object_literal = 227,
  sym_string = 228,
  sym__string_literal = 229,
  sym__multiline_string_literal = 230,
  sym_character = 231,
  sym__escape_sequence = 232,
  sym_boolean = 233,
  sym_ffi_identifier = 234,
  aux_sym_source_file_repeat1 = 235,
  aux_sym_members_repeat1 = 236,
  aux_sym_members_repeat2 = 237,
  aux_sym_annotation_repeat1 = 238,
  aux_sym_parameters_repeat1 = 239,
  aux_sym_base_type_repeat1 = 240,
  aux_sym_type_args_repeat1 = 241,
  aux_sym_union_type_repeat1 = 242,
  aux_sym_intersection_type_repeat1 = 243,
  aux_sym_block_repeat1 = 244,
  aux_sym_tuple_expression_repeat1 = 245,
  aux_sym_named_arguments_repeat1 = 246,
  aux_sym_lambda_expression_repeat1 = 247,
  aux_sym_lambda_captures_repeat1 = 248,
  aux_sym_if_statement_repeat1 = 249,
  aux_sym_iftype_statement_repeat1 = 250,
  aux_sym_while_statement_repeat1 = 251,
  aux_sym_with_statement_repeat1 = 252,
  aux_sym_match_statement_repeat1 = 253,
  aux_sym_case_statement_repeat1 = 254,
  aux_sym_generic_parameters_repeat1 = 255,
  aux_sym__string_literal_repeat1 = 256,
  aux_sym__multiline_string_literal_repeat1 = 257,
  aux_sym_character_repeat1 = 258,
  alias_sym_type_parameters = 259,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_use] = "use",
  [anon_sym_EQ] = "=",
  [anon_sym_AT] = "@",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_QMARK] = "\?",
  [anon_sym_type] = "type",
  [anon_sym_is] = "is",
  [anon_sym_actor] = "actor",
  [anon_sym_class] = "class",
  [anon_sym_primitive] = "primitive",
  [anon_sym_interface] = "interface",
  [anon_sym_trait] = "trait",
  [anon_sym_struct] = "struct",
  [anon_sym_embed] = "embed",
  [anon_sym_let] = "let",
  [anon_sym_var] = "var",
  [anon_sym_COLON] = ":",
  [anon_sym_new] = "new",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_fun] = "fun",
  [anon_sym_be] = "be",
  [anon_sym_BSLASH] = "\\",
  [anon_sym_COMMA] = ",",
  [anon_sym_iso] = "iso",
  [anon_sym_trn] = "trn",
  [anon_sym_ref] = "ref",
  [anon_sym_val] = "val",
  [anon_sym_box] = "box",
  [anon_sym_tag] = "tag",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_DOT] = ".",
  [anon_sym_POUNDread] = "#read",
  [anon_sym_POUNDsend] = "#send",
  [anon_sym_POUNDshare] = "#share",
  [anon_sym_POUNDalias] = "#alias",
  [anon_sym_POUNDany] = "#any",
  [anon_sym_BANG] = "!",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP] = "&",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_SEMI] = ";",
  [sym_error] = "error",
  [sym_compile_intrinsic] = "compile_intrinsic",
  [anon_sym_compile_error] = "compile_error",
  [sym_location] = "location",
  [anon_sym_DASH] = "-",
  [anon_sym_not] = "not",
  [anon_sym_DASH_TILDE] = "-~",
  [anon_sym_addressof] = "addressof",
  [anon_sym_digestof] = "digestof",
  [anon_sym_PLUS] = "+",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_PERCENT_PERCENT] = "%%",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_xor] = "xor",
  [anon_sym_isnt] = "isnt",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_LT] = "<",
  [anon_sym_PLUS_TILDE] = "+~",
  [anon_sym_STAR_TILDE] = "*~",
  [anon_sym_SLASH_TILDE] = "/~",
  [anon_sym_PERCENT_TILDE] = "%~",
  [anon_sym_PERCENT_PERCENT_TILDE] = "%%~",
  [anon_sym_LT_LT_TILDE] = "<<~",
  [anon_sym_GT_GT_TILDE] = ">>~",
  [anon_sym_EQ_EQ_TILDE] = "==~",
  [anon_sym_BANG_EQ_TILDE] = "!=~",
  [anon_sym_GT_TILDE] = ">~",
  [anon_sym_GT_EQ_TILDE] = ">=~",
  [anon_sym_LT_EQ_TILDE] = "<=~",
  [anon_sym_LT_TILDE] = "<~",
  [anon_sym_PLUS_QMARK] = "+\?",
  [anon_sym_DASH_QMARK] = "-\?",
  [anon_sym_STAR_QMARK] = "*\?",
  [anon_sym_SLASH_QMARK] = "/\?",
  [anon_sym_PERCENT_QMARK] = "%\?",
  [anon_sym_PERCENT_PERCENT_QMARK] = "%%\?",
  [anon_sym_as] = "as",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_DOT_GT] = ".>",
  [anon_sym_where] = "where",
  [anon_sym_TILDE] = "~",
  [anon_sym_end] = "end",
  [anon_sym_if] = "if",
  [anon_sym_ifdef] = "ifdef",
  [anon_sym_then] = "then",
  [anon_sym_elseif] = "elseif",
  [anon_sym_iftype] = "iftype",
  [anon_sym_LT_COLON] = "<:",
  [anon_sym_else] = "else",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_while] = "while",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_repeat] = "repeat",
  [anon_sym_until] = "until",
  [anon_sym_do] = "do",
  [anon_sym_recover] = "recover",
  [anon_sym_match] = "match",
  [anon_sym_return] = "return",
  [anon_sym_continue] = "continue",
  [anon_sym_break] = "break",
  [anon_sym_consume] = "consume",
  [anon_sym_object] = "object",
  [sym_number] = "number",
  [sym_float] = "float",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = "\"\"\"",
  [anon_sym_SQUOTE] = "'",
  [sym_character_content] = "character_content",
  [sym_string_content] = "string_content",
  [aux_sym__escape_sequence_token1] = "_escape_sequence_token1",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [sym_this] = "this",
  [sym_line_comment] = "line_comment",
  [sym__type_args_start] = "[",
  [sym_block_comment] = "block_comment",
  [sym__multiline_string_content] = "string_content",
  [sym_source_file] = "source_file",
  [sym_statement] = "statement",
  [sym_use_statement] = "use_statement",
  [sym_ffi_method] = "ffi_method",
  [sym_platform_specifier] = "platform_specifier",
  [sym_type_alias] = "type_alias",
  [sym_members] = "members",
  [sym_actor_definition] = "actor_definition",
  [sym_class_definition] = "class_definition",
  [sym_primitive_definition] = "primitive_definition",
  [sym_interface_definition] = "interface_definition",
  [sym_trait_definition] = "trait_definition",
  [sym_struct_definition] = "struct_definition",
  [sym_field] = "field",
  [sym_constructor] = "constructor",
  [sym_method] = "method",
  [sym_behavior] = "behavior",
  [sym_annotation] = "annotation",
  [sym_capability] = "capability",
  [sym_parameters] = "parameters",
  [sym_parameter] = "parameter",
  [sym_type] = "type",
  [sym_base_type] = "base_type",
  [sym_type_args] = "type_args",
  [sym_read_type] = "read_type",
  [sym_send_type] = "send_type",
  [sym_share_type] = "share_type",
  [sym_alias_type] = "alias_type",
  [sym_any_type] = "any_type",
  [sym_iso_type] = "iso_type",
  [sym_trn_type] = "trn_type",
  [sym_ref_type] = "ref_type",
  [sym_val_type] = "val_type",
  [sym_box_type] = "box_type",
  [sym_tag_type] = "tag_type",
  [sym_aliased_type] = "aliased_type",
  [sym_ephemeral_type] = "ephemeral_type",
  [sym_tuple_type] = "tuple_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_viewpoint_type] = "viewpoint_type",
  [sym_lambda_parameters] = "lambda_parameters",
  [sym_lambda_type] = "lambda_type",
  [sym_block] = "block",
  [sym_expression] = "expression",
  [sym_compile_error] = "compile_error",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_tuple_expression] = "tuple_expression",
  [sym_generic_expression] = "generic_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_variable_declaration] = "variable_declaration",
  [sym_cast_expression] = "cast_expression",
  [sym_call_expression] = "call_expression",
  [sym_arguments] = "arguments",
  [sym_chain_expression] = "chain_expression",
  [sym_named_arguments] = "named_arguments",
  [sym_named_argument] = "named_argument",
  [sym_lambda_expression] = "lambda_expression",
  [sym_lambda_parameter] = "lambda_parameter",
  [sym_lambda_captures] = "lambda_captures",
  [sym_partial_application] = "partial_application",
  [sym_member_expression] = "member_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_if_statement] = "if_statement",
  [sym_if_block] = "if_block",
  [sym_then_block] = "then_block",
  [sym_elseif_block] = "elseif_block",
  [sym_iftype_statement] = "iftype_statement",
  [sym_elseiftype_block] = "elseiftype_block",
  [sym_else_block] = "else_block",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_with_elem] = "with_elem",
  [sym_repeat_statement] = "repeat_statement",
  [sym_do_block] = "do_block",
  [sym_recover_statement] = "recover_statement",
  [sym_match_statement] = "match_statement",
  [sym_case_statement] = "case_statement",
  [sym_return_statement] = "return_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_break_statement] = "break_statement",
  [sym_consume_statement] = "consume_statement",
  [sym_generic_parameter] = "generic_parameter",
  [sym_generic_parameters] = "generic_parameters",
  [sym_literal] = "literal",
  [sym_array_literal] = "array_literal",
  [sym_object_literal] = "object_literal",
  [sym_string] = "string",
  [sym__string_literal] = "_string_literal",
  [sym__multiline_string_literal] = "_multiline_string_literal",
  [sym_character] = "character",
  [sym__escape_sequence] = "_escape_sequence",
  [sym_boolean] = "boolean",
  [sym_ffi_identifier] = "ffi_identifier",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_members_repeat1] = "members_repeat1",
  [aux_sym_members_repeat2] = "members_repeat2",
  [aux_sym_annotation_repeat1] = "annotation_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
  [aux_sym_base_type_repeat1] = "base_type_repeat1",
  [aux_sym_type_args_repeat1] = "type_args_repeat1",
  [aux_sym_union_type_repeat1] = "union_type_repeat1",
  [aux_sym_intersection_type_repeat1] = "intersection_type_repeat1",
  [aux_sym_block_repeat1] = "block_repeat1",
  [aux_sym_tuple_expression_repeat1] = "tuple_expression_repeat1",
  [aux_sym_named_arguments_repeat1] = "named_arguments_repeat1",
  [aux_sym_lambda_expression_repeat1] = "lambda_expression_repeat1",
  [aux_sym_lambda_captures_repeat1] = "lambda_captures_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_iftype_statement_repeat1] = "iftype_statement_repeat1",
  [aux_sym_while_statement_repeat1] = "while_statement_repeat1",
  [aux_sym_with_statement_repeat1] = "with_statement_repeat1",
  [aux_sym_match_statement_repeat1] = "match_statement_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_generic_parameters_repeat1] = "generic_parameters_repeat1",
  [aux_sym__string_literal_repeat1] = "_string_literal_repeat1",
  [aux_sym__multiline_string_literal_repeat1] = "_multiline_string_literal_repeat1",
  [aux_sym_character_repeat1] = "character_repeat1",
  [alias_sym_type_parameters] = "type_parameters",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_use] = anon_sym_use,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_actor] = anon_sym_actor,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_primitive] = anon_sym_primitive,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_trait] = anon_sym_trait,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_embed] = anon_sym_embed,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_fun] = anon_sym_fun,
  [anon_sym_be] = anon_sym_be,
  [anon_sym_BSLASH] = anon_sym_BSLASH,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_iso] = anon_sym_iso,
  [anon_sym_trn] = anon_sym_trn,
  [anon_sym_ref] = anon_sym_ref,
  [anon_sym_val] = anon_sym_val,
  [anon_sym_box] = anon_sym_box,
  [anon_sym_tag] = anon_sym_tag,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_POUNDread] = anon_sym_POUNDread,
  [anon_sym_POUNDsend] = anon_sym_POUNDsend,
  [anon_sym_POUNDshare] = anon_sym_POUNDshare,
  [anon_sym_POUNDalias] = anon_sym_POUNDalias,
  [anon_sym_POUNDany] = anon_sym_POUNDany,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [sym_error] = sym_error,
  [sym_compile_intrinsic] = sym_compile_intrinsic,
  [anon_sym_compile_error] = anon_sym_compile_error,
  [sym_location] = sym_location,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_DASH_TILDE] = anon_sym_DASH_TILDE,
  [anon_sym_addressof] = anon_sym_addressof,
  [anon_sym_digestof] = anon_sym_digestof,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_PERCENT_PERCENT] = anon_sym_PERCENT_PERCENT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_xor] = anon_sym_xor,
  [anon_sym_isnt] = anon_sym_isnt,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_PLUS_TILDE] = anon_sym_PLUS_TILDE,
  [anon_sym_STAR_TILDE] = anon_sym_STAR_TILDE,
  [anon_sym_SLASH_TILDE] = anon_sym_SLASH_TILDE,
  [anon_sym_PERCENT_TILDE] = anon_sym_PERCENT_TILDE,
  [anon_sym_PERCENT_PERCENT_TILDE] = anon_sym_PERCENT_PERCENT_TILDE,
  [anon_sym_LT_LT_TILDE] = anon_sym_LT_LT_TILDE,
  [anon_sym_GT_GT_TILDE] = anon_sym_GT_GT_TILDE,
  [anon_sym_EQ_EQ_TILDE] = anon_sym_EQ_EQ_TILDE,
  [anon_sym_BANG_EQ_TILDE] = anon_sym_BANG_EQ_TILDE,
  [anon_sym_GT_TILDE] = anon_sym_GT_TILDE,
  [anon_sym_GT_EQ_TILDE] = anon_sym_GT_EQ_TILDE,
  [anon_sym_LT_EQ_TILDE] = anon_sym_LT_EQ_TILDE,
  [anon_sym_LT_TILDE] = anon_sym_LT_TILDE,
  [anon_sym_PLUS_QMARK] = anon_sym_PLUS_QMARK,
  [anon_sym_DASH_QMARK] = anon_sym_DASH_QMARK,
  [anon_sym_STAR_QMARK] = anon_sym_STAR_QMARK,
  [anon_sym_SLASH_QMARK] = anon_sym_SLASH_QMARK,
  [anon_sym_PERCENT_QMARK] = anon_sym_PERCENT_QMARK,
  [anon_sym_PERCENT_PERCENT_QMARK] = anon_sym_PERCENT_PERCENT_QMARK,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_LPAREN2] = anon_sym_LPAREN,
  [anon_sym_DOT_GT] = anon_sym_DOT_GT,
  [anon_sym_where] = anon_sym_where,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_end] = anon_sym_end,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_ifdef] = anon_sym_ifdef,
  [anon_sym_then] = anon_sym_then,
  [anon_sym_elseif] = anon_sym_elseif,
  [anon_sym_iftype] = anon_sym_iftype,
  [anon_sym_LT_COLON] = anon_sym_LT_COLON,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_repeat] = anon_sym_repeat,
  [anon_sym_until] = anon_sym_until,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_recover] = anon_sym_recover,
  [anon_sym_match] = anon_sym_match,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_consume] = anon_sym_consume,
  [anon_sym_object] = anon_sym_object,
  [sym_number] = sym_number,
  [sym_float] = sym_float,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [sym_character_content] = sym_character_content,
  [sym_string_content] = sym_string_content,
  [aux_sym__escape_sequence_token1] = aux_sym__escape_sequence_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [sym_this] = sym_this,
  [sym_line_comment] = sym_line_comment,
  [sym__type_args_start] = anon_sym_LBRACK,
  [sym_block_comment] = sym_block_comment,
  [sym__multiline_string_content] = sym_string_content,
  [sym_source_file] = sym_source_file,
  [sym_statement] = sym_statement,
  [sym_use_statement] = sym_use_statement,
  [sym_ffi_method] = sym_ffi_method,
  [sym_platform_specifier] = sym_platform_specifier,
  [sym_type_alias] = sym_type_alias,
  [sym_members] = sym_members,
  [sym_actor_definition] = sym_actor_definition,
  [sym_class_definition] = sym_class_definition,
  [sym_primitive_definition] = sym_primitive_definition,
  [sym_interface_definition] = sym_interface_definition,
  [sym_trait_definition] = sym_trait_definition,
  [sym_struct_definition] = sym_struct_definition,
  [sym_field] = sym_field,
  [sym_constructor] = sym_constructor,
  [sym_method] = sym_method,
  [sym_behavior] = sym_behavior,
  [sym_annotation] = sym_annotation,
  [sym_capability] = sym_capability,
  [sym_parameters] = sym_parameters,
  [sym_parameter] = sym_parameter,
  [sym_type] = sym_type,
  [sym_base_type] = sym_base_type,
  [sym_type_args] = sym_type_args,
  [sym_read_type] = sym_read_type,
  [sym_send_type] = sym_send_type,
  [sym_share_type] = sym_share_type,
  [sym_alias_type] = sym_alias_type,
  [sym_any_type] = sym_any_type,
  [sym_iso_type] = sym_iso_type,
  [sym_trn_type] = sym_trn_type,
  [sym_ref_type] = sym_ref_type,
  [sym_val_type] = sym_val_type,
  [sym_box_type] = sym_box_type,
  [sym_tag_type] = sym_tag_type,
  [sym_aliased_type] = sym_aliased_type,
  [sym_ephemeral_type] = sym_ephemeral_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_union_type] = sym_union_type,
  [sym_intersection_type] = sym_intersection_type,
  [sym_viewpoint_type] = sym_viewpoint_type,
  [sym_lambda_parameters] = sym_lambda_parameters,
  [sym_lambda_type] = sym_lambda_type,
  [sym_block] = sym_block,
  [sym_expression] = sym_expression,
  [sym_compile_error] = sym_compile_error,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_tuple_expression] = sym_tuple_expression,
  [sym_generic_expression] = sym_generic_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_cast_expression] = sym_cast_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_arguments] = sym_arguments,
  [sym_chain_expression] = sym_chain_expression,
  [sym_named_arguments] = sym_named_arguments,
  [sym_named_argument] = sym_named_argument,
  [sym_lambda_expression] = sym_lambda_expression,
  [sym_lambda_parameter] = sym_lambda_parameter,
  [sym_lambda_captures] = sym_lambda_captures,
  [sym_partial_application] = sym_partial_application,
  [sym_member_expression] = sym_member_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_if_statement] = sym_if_statement,
  [sym_if_block] = sym_if_block,
  [sym_then_block] = sym_then_block,
  [sym_elseif_block] = sym_elseif_block,
  [sym_iftype_statement] = sym_iftype_statement,
  [sym_elseiftype_block] = sym_elseiftype_block,
  [sym_else_block] = sym_else_block,
  [sym_for_statement] = sym_for_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_with_statement] = sym_with_statement,
  [sym_with_elem] = sym_with_elem,
  [sym_repeat_statement] = sym_repeat_statement,
  [sym_do_block] = sym_do_block,
  [sym_recover_statement] = sym_recover_statement,
  [sym_match_statement] = sym_match_statement,
  [sym_case_statement] = sym_case_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_consume_statement] = sym_consume_statement,
  [sym_generic_parameter] = sym_generic_parameter,
  [sym_generic_parameters] = sym_generic_parameters,
  [sym_literal] = sym_literal,
  [sym_array_literal] = sym_array_literal,
  [sym_object_literal] = sym_object_literal,
  [sym_string] = sym_string,
  [sym__string_literal] = sym__string_literal,
  [sym__multiline_string_literal] = sym__multiline_string_literal,
  [sym_character] = sym_character,
  [sym__escape_sequence] = sym__escape_sequence,
  [sym_boolean] = sym_boolean,
  [sym_ffi_identifier] = sym_ffi_identifier,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_members_repeat1] = aux_sym_members_repeat1,
  [aux_sym_members_repeat2] = aux_sym_members_repeat2,
  [aux_sym_annotation_repeat1] = aux_sym_annotation_repeat1,
  [aux_sym_parameters_repeat1] = aux_sym_parameters_repeat1,
  [aux_sym_base_type_repeat1] = aux_sym_base_type_repeat1,
  [aux_sym_type_args_repeat1] = aux_sym_type_args_repeat1,
  [aux_sym_union_type_repeat1] = aux_sym_union_type_repeat1,
  [aux_sym_intersection_type_repeat1] = aux_sym_intersection_type_repeat1,
  [aux_sym_block_repeat1] = aux_sym_block_repeat1,
  [aux_sym_tuple_expression_repeat1] = aux_sym_tuple_expression_repeat1,
  [aux_sym_named_arguments_repeat1] = aux_sym_named_arguments_repeat1,
  [aux_sym_lambda_expression_repeat1] = aux_sym_lambda_expression_repeat1,
  [aux_sym_lambda_captures_repeat1] = aux_sym_lambda_captures_repeat1,
  [aux_sym_if_statement_repeat1] = aux_sym_if_statement_repeat1,
  [aux_sym_iftype_statement_repeat1] = aux_sym_iftype_statement_repeat1,
  [aux_sym_while_statement_repeat1] = aux_sym_while_statement_repeat1,
  [aux_sym_with_statement_repeat1] = aux_sym_with_statement_repeat1,
  [aux_sym_match_statement_repeat1] = aux_sym_match_statement_repeat1,
  [aux_sym_case_statement_repeat1] = aux_sym_case_statement_repeat1,
  [aux_sym_generic_parameters_repeat1] = aux_sym_generic_parameters_repeat1,
  [aux_sym__string_literal_repeat1] = aux_sym__string_literal_repeat1,
  [aux_sym__multiline_string_literal_repeat1] = aux_sym__multiline_string_literal_repeat1,
  [aux_sym_character_repeat1] = aux_sym_character_repeat1,
  [alias_sym_type_parameters] = alias_sym_type_parameters,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_use] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_actor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_primitive] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_trait] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_embed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fun] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_be] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_iso] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_trn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_val] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_box] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_tag] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUNDread] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUNDsend] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUNDshare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUNDalias] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUNDany] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [sym_error] = {
    .visible = true,
    .named = true,
  },
  [sym_compile_intrinsic] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_compile_error] = {
    .visible = true,
    .named = false,
  },
  [sym_location] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_addressof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_digestof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_isnt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_PERCENT_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_PERCENT_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_where] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ifdef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elseif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_iftype] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_repeat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_until] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_recover] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_match] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_consume] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_object] = {
    .visible = true,
    .named = false,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_character_content] = {
    .visible = true,
    .named = true,
  },
  [sym_string_content] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__escape_sequence_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__type_args_start] = {
    .visible = true,
    .named = false,
  },
  [sym_block_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__multiline_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_use_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_ffi_method] = {
    .visible = true,
    .named = true,
  },
  [sym_platform_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_members] = {
    .visible = true,
    .named = true,
  },
  [sym_actor_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_class_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_primitive_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_trait_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_field] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym_method] = {
    .visible = true,
    .named = true,
  },
  [sym_behavior] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_capability] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_base_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_args] = {
    .visible = true,
    .named = true,
  },
  [sym_read_type] = {
    .visible = true,
    .named = true,
  },
  [sym_send_type] = {
    .visible = true,
    .named = true,
  },
  [sym_share_type] = {
    .visible = true,
    .named = true,
  },
  [sym_alias_type] = {
    .visible = true,
    .named = true,
  },
  [sym_any_type] = {
    .visible = true,
    .named = true,
  },
  [sym_iso_type] = {
    .visible = true,
    .named = true,
  },
  [sym_trn_type] = {
    .visible = true,
    .named = true,
  },
  [sym_ref_type] = {
    .visible = true,
    .named = true,
  },
  [sym_val_type] = {
    .visible = true,
    .named = true,
  },
  [sym_box_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tag_type] = {
    .visible = true,
    .named = true,
  },
  [sym_aliased_type] = {
    .visible = true,
    .named = true,
  },
  [sym_ephemeral_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_viewpoint_type] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_type] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_compile_error] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_chain_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_named_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_named_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_captures] = {
    .visible = true,
    .named = true,
  },
  [sym_partial_application] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_block] = {
    .visible = true,
    .named = true,
  },
  [sym_then_block] = {
    .visible = true,
    .named = true,
  },
  [sym_elseif_block] = {
    .visible = true,
    .named = true,
  },
  [sym_iftype_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elseiftype_block] = {
    .visible = true,
    .named = true,
  },
  [sym_else_block] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_elem] = {
    .visible = true,
    .named = true,
  },
  [sym_repeat_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_block] = {
    .visible = true,
    .named = true,
  },
  [sym_recover_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_match_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_consume_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_literal] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_array_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_object_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym__string_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__multiline_string_literal] = {
    .visible = false,
    .named = true,
  },
  [sym_character] = {
    .visible = true,
    .named = true,
  },
  [sym__escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [sym_boolean] = {
    .visible = true,
    .named = true,
  },
  [sym_ffi_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_members_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_members_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_annotation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_base_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_args_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_union_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_intersection_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_lambda_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_lambda_captures_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_iftype_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_while_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_with_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_generic_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__multiline_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_character_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_argument = 1,
  field_callee = 2,
  field_collection = 3,
  field_default = 4,
  field_left = 5,
  field_name = 6,
  field_operator = 7,
  field_positional = 8,
  field_returns = 9,
  field_right = 10,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_argument] = "argument",
  [field_callee] = "callee",
  [field_collection] = "collection",
  [field_default] = "default",
  [field_left] = "left",
  [field_name] = "name",
  [field_operator] = "operator",
  [field_positional] = "positional",
  [field_returns] = "returns",
  [field_right] = "right",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 2},
  [3] = {.index = 3, .length = 1},
  [4] = {.index = 4, .length = 2},
  [6] = {.index = 6, .length = 3},
  [7] = {.index = 9, .length = 1},
  [8] = {.index = 10, .length = 1},
  [9] = {.index = 11, .length = 3},
  [10] = {.index = 14, .length = 1},
  [12] = {.index = 15, .length = 1},
  [13] = {.index = 16, .length = 1},
  [14] = {.index = 17, .length = 2},
  [15] = {.index = 19, .length = 1},
  [16] = {.index = 20, .length = 1},
  [17] = {.index = 21, .length = 1},
  [19] = {.index = 15, .length = 1},
  [20] = {.index = 22, .length = 1},
  [22] = {.index = 21, .length = 1},
  [23] = {.index = 23, .length = 1},
  [24] = {.index = 22, .length = 1},
  [25] = {.index = 24, .length = 1},
  [26] = {.index = 23, .length = 1},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 0},
  [1] =
    {field_argument, 1},
    {field_operator, 0},
  [3] =
    {field_callee, 0},
  [4] =
    {field_name, 0},
    {field_name, 1},
  [6] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [9] =
    {field_default, 2},
  [10] =
    {field_name, 1},
  [11] =
    {field_returns, 2},
    {field_returns, 3},
    {field_returns, 4},
  [14] =
    {field_positional, 1},
  [15] =
    {field_returns, 4},
  [16] =
    {field_collection, 3},
  [17] =
    {field_positional, 1},
    {field_positional, 2},
  [19] =
    {field_default, 4},
  [20] =
    {field_returns, 3},
  [21] =
    {field_returns, 5},
  [22] =
    {field_returns, 6},
  [23] =
    {field_returns, 7},
  [24] =
    {field_returns, 8},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [5] = {
    [2] = alias_sym_type_parameters,
  },
  [11] = {
    [1] = alias_sym_type_parameters,
  },
  [18] = {
    [3] = alias_sym_type_parameters,
  },
  [19] = {
    [1] = alias_sym_type_parameters,
  },
  [21] = {
    [4] = alias_sym_type_parameters,
  },
  [22] = {
    [2] = alias_sym_type_parameters,
  },
  [24] = {
    [3] = alias_sym_type_parameters,
  },
  [26] = {
    [4] = alias_sym_type_parameters,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_generic_parameters, 2,
    sym_generic_parameters,
    alias_sym_type_parameters,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 2,
  [9] = 2,
  [10] = 7,
  [11] = 4,
  [12] = 3,
  [13] = 5,
  [14] = 6,
  [15] = 2,
  [16] = 7,
  [17] = 2,
  [18] = 5,
  [19] = 4,
  [20] = 3,
  [21] = 2,
  [22] = 2,
  [23] = 7,
  [24] = 7,
  [25] = 3,
  [26] = 5,
  [27] = 2,
  [28] = 4,
  [29] = 4,
  [30] = 2,
  [31] = 5,
  [32] = 3,
  [33] = 4,
  [34] = 2,
  [35] = 2,
  [36] = 6,
  [37] = 7,
  [38] = 5,
  [39] = 3,
  [40] = 7,
  [41] = 5,
  [42] = 6,
  [43] = 2,
  [44] = 3,
  [45] = 4,
  [46] = 7,
  [47] = 2,
  [48] = 7,
  [49] = 5,
  [50] = 4,
  [51] = 3,
  [52] = 5,
  [53] = 4,
  [54] = 3,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 55,
  [94] = 56,
  [95] = 57,
  [96] = 58,
  [97] = 71,
  [98] = 78,
  [99] = 83,
  [100] = 82,
  [101] = 81,
  [102] = 80,
  [103] = 60,
  [104] = 59,
  [105] = 76,
  [106] = 75,
  [107] = 74,
  [108] = 73,
  [109] = 68,
  [110] = 70,
  [111] = 69,
  [112] = 79,
  [113] = 67,
  [114] = 77,
  [115] = 66,
  [116] = 84,
  [117] = 85,
  [118] = 62,
  [119] = 64,
  [120] = 86,
  [121] = 88,
  [122] = 89,
  [123] = 90,
  [124] = 91,
  [125] = 92,
  [126] = 65,
  [127] = 63,
  [128] = 72,
  [129] = 87,
  [130] = 61,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 141,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 133,
  [168] = 139,
  [169] = 132,
  [170] = 134,
  [171] = 135,
  [172] = 136,
  [173] = 140,
  [174] = 142,
  [175] = 137,
  [176] = 141,
  [177] = 138,
  [178] = 131,
  [179] = 143,
  [180] = 144,
  [181] = 55,
  [182] = 56,
  [183] = 148,
  [184] = 146,
  [185] = 57,
  [186] = 186,
  [187] = 145,
  [188] = 147,
  [189] = 189,
  [190] = 190,
  [191] = 159,
  [192] = 166,
  [193] = 193,
  [194] = 163,
  [195] = 161,
  [196] = 157,
  [197] = 197,
  [198] = 153,
  [199] = 151,
  [200] = 152,
  [201] = 201,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 154,
  [206] = 156,
  [207] = 207,
  [208] = 155,
  [209] = 209,
  [210] = 210,
  [211] = 149,
  [212] = 162,
  [213] = 213,
  [214] = 214,
  [215] = 215,
  [216] = 158,
  [217] = 164,
  [218] = 165,
  [219] = 150,
  [220] = 160,
  [221] = 58,
  [222] = 222,
  [223] = 223,
  [224] = 76,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 62,
  [231] = 231,
  [232] = 64,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 61,
  [255] = 77,
  [256] = 71,
  [257] = 257,
  [258] = 67,
  [259] = 259,
  [260] = 260,
  [261] = 78,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 68,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 270,
  [271] = 271,
  [272] = 272,
  [273] = 273,
  [274] = 274,
  [275] = 275,
  [276] = 276,
  [277] = 277,
  [278] = 278,
  [279] = 279,
  [280] = 280,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 61,
  [285] = 68,
  [286] = 286,
  [287] = 287,
  [288] = 87,
  [289] = 72,
  [290] = 63,
  [291] = 65,
  [292] = 92,
  [293] = 91,
  [294] = 90,
  [295] = 89,
  [296] = 88,
  [297] = 297,
  [298] = 86,
  [299] = 85,
  [300] = 84,
  [301] = 83,
  [302] = 82,
  [303] = 81,
  [304] = 80,
  [305] = 60,
  [306] = 59,
  [307] = 307,
  [308] = 308,
  [309] = 75,
  [310] = 74,
  [311] = 73,
  [312] = 70,
  [313] = 69,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 66,
  [318] = 318,
  [319] = 319,
  [320] = 79,
  [321] = 321,
  [322] = 322,
  [323] = 323,
  [324] = 186,
  [325] = 204,
  [326] = 201,
  [327] = 202,
  [328] = 203,
  [329] = 210,
  [330] = 193,
  [331] = 197,
  [332] = 223,
  [333] = 209,
  [334] = 207,
  [335] = 189,
  [336] = 248,
  [337] = 215,
  [338] = 222,
  [339] = 190,
  [340] = 278,
  [341] = 213,
  [342] = 214,
  [343] = 243,
  [344] = 314,
  [345] = 247,
  [346] = 246,
  [347] = 253,
  [348] = 281,
  [349] = 257,
  [350] = 279,
  [351] = 269,
  [352] = 271,
  [353] = 238,
  [354] = 241,
  [355] = 245,
  [356] = 262,
  [357] = 252,
  [358] = 268,
  [359] = 267,
  [360] = 240,
  [361] = 277,
  [362] = 264,
  [363] = 266,
  [364] = 280,
  [365] = 263,
  [366] = 250,
  [367] = 239,
  [368] = 276,
  [369] = 282,
  [370] = 210,
  [371] = 318,
  [372] = 225,
  [373] = 203,
  [374] = 202,
  [375] = 201,
  [376] = 204,
  [377] = 321,
  [378] = 286,
  [379] = 379,
  [380] = 234,
  [381] = 287,
  [382] = 231,
  [383] = 229,
  [384] = 228,
  [385] = 227,
  [386] = 226,
  [387] = 323,
  [388] = 388,
  [389] = 315,
  [390] = 270,
  [391] = 316,
  [392] = 308,
  [393] = 283,
  [394] = 394,
  [395] = 395,
  [396] = 275,
  [397] = 397,
  [398] = 398,
  [399] = 319,
  [400] = 274,
  [401] = 260,
  [402] = 322,
  [403] = 297,
  [404] = 259,
  [405] = 249,
  [406] = 68,
  [407] = 61,
  [408] = 233,
  [409] = 235,
  [410] = 273,
  [411] = 272,
  [412] = 237,
  [413] = 242,
  [414] = 244,
  [415] = 236,
  [416] = 307,
  [417] = 251,
  [418] = 379,
  [419] = 394,
  [420] = 395,
  [421] = 397,
  [422] = 398,
  [423] = 388,
  [424] = 210,
  [425] = 203,
  [426] = 202,
  [427] = 201,
  [428] = 204,
  [429] = 142,
  [430] = 139,
  [431] = 136,
  [432] = 140,
  [433] = 133,
  [434] = 143,
  [435] = 141,
  [436] = 135,
  [437] = 144,
  [438] = 131,
  [439] = 137,
  [440] = 143,
  [441] = 132,
  [442] = 138,
  [443] = 134,
  [444] = 146,
  [445] = 147,
  [446] = 145,
  [447] = 148,
  [448] = 152,
  [449] = 154,
  [450] = 7,
  [451] = 158,
  [452] = 166,
  [453] = 163,
  [454] = 161,
  [455] = 156,
  [456] = 7,
  [457] = 165,
  [458] = 151,
  [459] = 150,
  [460] = 149,
  [461] = 159,
  [462] = 164,
  [463] = 162,
  [464] = 153,
  [465] = 155,
  [466] = 157,
  [467] = 6,
  [468] = 160,
  [469] = 6,
  [470] = 321,
  [471] = 397,
  [472] = 186,
  [473] = 398,
  [474] = 394,
  [475] = 395,
  [476] = 388,
  [477] = 379,
  [478] = 478,
  [479] = 478,
  [480] = 398,
  [481] = 379,
  [482] = 197,
  [483] = 193,
  [484] = 207,
  [485] = 388,
  [486] = 209,
  [487] = 189,
  [488] = 214,
  [489] = 190,
  [490] = 478,
  [491] = 394,
  [492] = 395,
  [493] = 397,
  [494] = 223,
  [495] = 204,
  [496] = 201,
  [497] = 202,
  [498] = 203,
  [499] = 210,
  [500] = 478,
  [501] = 222,
  [502] = 215,
  [503] = 213,
  [504] = 249,
  [505] = 250,
  [506] = 279,
  [507] = 297,
  [508] = 245,
  [509] = 240,
  [510] = 243,
  [511] = 283,
  [512] = 263,
  [513] = 259,
  [514] = 271,
  [515] = 281,
  [516] = 315,
  [517] = 307,
  [518] = 239,
  [519] = 236,
  [520] = 244,
  [521] = 287,
  [522] = 61,
  [523] = 276,
  [524] = 68,
  [525] = 318,
  [526] = 238,
  [527] = 204,
  [528] = 201,
  [529] = 202,
  [530] = 286,
  [531] = 203,
  [532] = 241,
  [533] = 210,
  [534] = 262,
  [535] = 225,
  [536] = 282,
  [537] = 280,
  [538] = 252,
  [539] = 278,
  [540] = 277,
  [541] = 257,
  [542] = 253,
  [543] = 246,
  [544] = 247,
  [545] = 264,
  [546] = 233,
  [547] = 235,
  [548] = 237,
  [549] = 242,
  [550] = 248,
  [551] = 251,
  [552] = 260,
  [553] = 266,
  [554] = 234,
  [555] = 267,
  [556] = 268,
  [557] = 269,
  [558] = 272,
  [559] = 273,
  [560] = 270,
  [561] = 274,
  [562] = 275,
  [563] = 322,
  [564] = 231,
  [565] = 319,
  [566] = 308,
  [567] = 314,
  [568] = 226,
  [569] = 227,
  [570] = 316,
  [571] = 228,
  [572] = 323,
  [573] = 229,
  [574] = 574,
  [575] = 574,
  [576] = 574,
  [577] = 574,
  [578] = 578,
  [579] = 398,
  [580] = 388,
  [581] = 394,
  [582] = 6,
  [583] = 7,
  [584] = 6,
  [585] = 7,
  [586] = 586,
  [587] = 587,
  [588] = 586,
  [589] = 589,
  [590] = 590,
  [591] = 591,
  [592] = 591,
  [593] = 590,
  [594] = 594,
  [595] = 591,
  [596] = 596,
  [597] = 597,
  [598] = 590,
  [599] = 599,
  [600] = 600,
  [601] = 587,
  [602] = 600,
  [603] = 603,
  [604] = 591,
  [605] = 600,
  [606] = 606,
  [607] = 594,
  [608] = 587,
  [609] = 586,
  [610] = 589,
  [611] = 606,
  [612] = 587,
  [613] = 600,
  [614] = 599,
  [615] = 590,
  [616] = 597,
  [617] = 599,
  [618] = 594,
  [619] = 599,
  [620] = 597,
  [621] = 597,
  [622] = 586,
  [623] = 594,
  [624] = 624,
  [625] = 624,
  [626] = 626,
  [627] = 626,
  [628] = 628,
  [629] = 629,
  [630] = 630,
  [631] = 626,
  [632] = 629,
  [633] = 626,
  [634] = 624,
  [635] = 624,
  [636] = 629,
  [637] = 629,
  [638] = 638,
  [639] = 639,
  [640] = 640,
  [641] = 641,
  [642] = 642,
  [643] = 643,
  [644] = 644,
  [645] = 645,
  [646] = 646,
  [647] = 647,
  [648] = 648,
  [649] = 638,
  [650] = 650,
  [651] = 651,
  [652] = 652,
  [653] = 653,
  [654] = 654,
  [655] = 642,
  [656] = 656,
  [657] = 644,
  [658] = 658,
  [659] = 659,
  [660] = 660,
  [661] = 661,
  [662] = 662,
  [663] = 644,
  [664] = 664,
  [665] = 665,
  [666] = 666,
  [667] = 667,
  [668] = 668,
  [669] = 639,
  [670] = 670,
  [671] = 671,
  [672] = 672,
  [673] = 642,
  [674] = 674,
  [675] = 643,
  [676] = 647,
  [677] = 648,
  [678] = 678,
  [679] = 679,
  [680] = 650,
  [681] = 643,
  [682] = 651,
  [683] = 683,
  [684] = 643,
  [685] = 685,
  [686] = 644,
  [687] = 687,
  [688] = 650,
  [689] = 652,
  [690] = 690,
  [691] = 691,
  [692] = 644,
  [693] = 693,
  [694] = 651,
  [695] = 644,
  [696] = 672,
  [697] = 697,
  [698] = 668,
  [699] = 652,
  [700] = 700,
  [701] = 671,
  [702] = 653,
  [703] = 662,
  [704] = 667,
  [705] = 705,
  [706] = 674,
  [707] = 697,
  [708] = 678,
  [709] = 644,
  [710] = 670,
  [711] = 693,
  [712] = 691,
  [713] = 687,
  [714] = 670,
  [715] = 705,
  [716] = 716,
  [717] = 672,
  [718] = 639,
  [719] = 641,
  [720] = 667,
  [721] = 683,
  [722] = 662,
  [723] = 644,
  [724] = 700,
  [725] = 642,
  [726] = 653,
  [727] = 652,
  [728] = 683,
  [729] = 644,
  [730] = 651,
  [731] = 690,
  [732] = 683,
  [733] = 638,
  [734] = 672,
  [735] = 735,
  [736] = 736,
  [737] = 670,
  [738] = 658,
  [739] = 739,
  [740] = 666,
  [741] = 639,
  [742] = 742,
  [743] = 743,
  [744] = 665,
  [745] = 664,
  [746] = 735,
  [747] = 667,
  [748] = 748,
  [749] = 648,
  [750] = 736,
  [751] = 661,
  [752] = 742,
  [753] = 660,
  [754] = 743,
  [755] = 659,
  [756] = 756,
  [757] = 650,
  [758] = 658,
  [759] = 647,
  [760] = 748,
  [761] = 662,
  [762] = 658,
  [763] = 654,
  [764] = 646,
  [765] = 645,
  [766] = 679,
  [767] = 653,
  [768] = 638,
  [769] = 769,
  [770] = 648,
  [771] = 647,
  [772] = 772,
  [773] = 773,
  [774] = 774,
  [775] = 773,
  [776] = 776,
  [777] = 774,
  [778] = 778,
  [779] = 778,
  [780] = 780,
  [781] = 781,
  [782] = 782,
  [783] = 776,
  [784] = 780,
  [785] = 781,
  [786] = 782,
  [787] = 776,
  [788] = 788,
  [789] = 789,
  [790] = 790,
  [791] = 773,
  [792] = 789,
  [793] = 793,
  [794] = 794,
  [795] = 795,
  [796] = 796,
  [797] = 773,
  [798] = 774,
  [799] = 776,
  [800] = 776,
  [801] = 782,
  [802] = 802,
  [803] = 778,
  [804] = 804,
  [805] = 788,
  [806] = 789,
  [807] = 795,
  [808] = 796,
  [809] = 774,
  [810] = 804,
  [811] = 782,
  [812] = 795,
  [813] = 796,
  [814] = 782,
  [815] = 773,
  [816] = 773,
  [817] = 788,
  [818] = 818,
  [819] = 788,
  [820] = 778,
  [821] = 789,
  [822] = 778,
  [823] = 774,
  [824] = 795,
  [825] = 796,
  [826] = 776,
  [827] = 782,
  [828] = 828,
  [829] = 829,
  [830] = 778,
  [831] = 804,
  [832] = 774,
  [833] = 774,
  [834] = 778,
  [835] = 780,
  [836] = 774,
  [837] = 778,
  [838] = 780,
  [839] = 781,
  [840] = 840,
  [841] = 782,
  [842] = 776,
  [843] = 781,
  [844] = 782,
  [845] = 776,
  [846] = 773,
  [847] = 847,
  [848] = 848,
  [849] = 849,
  [850] = 773,
  [851] = 776,
  [852] = 782,
  [853] = 778,
  [854] = 774,
  [855] = 804,
  [856] = 773,
  [857] = 802,
  [858] = 858,
  [859] = 201,
  [860] = 204,
  [861] = 202,
  [862] = 203,
  [863] = 210,
  [864] = 55,
  [865] = 56,
  [866] = 866,
  [867] = 57,
  [868] = 321,
  [869] = 58,
  [870] = 91,
  [871] = 76,
  [872] = 92,
  [873] = 86,
  [874] = 87,
  [875] = 85,
  [876] = 88,
  [877] = 65,
  [878] = 89,
  [879] = 90,
  [880] = 63,
  [881] = 84,
  [882] = 71,
  [883] = 83,
  [884] = 82,
  [885] = 81,
  [886] = 80,
  [887] = 60,
  [888] = 59,
  [889] = 69,
  [890] = 75,
  [891] = 64,
  [892] = 62,
  [893] = 61,
  [894] = 68,
  [895] = 70,
  [896] = 74,
  [897] = 72,
  [898] = 73,
  [899] = 78,
  [900] = 66,
  [901] = 67,
  [902] = 79,
  [903] = 77,
  [904] = 398,
  [905] = 394,
  [906] = 388,
  [907] = 866,
  [908] = 139,
  [909] = 132,
  [910] = 133,
  [911] = 321,
  [912] = 134,
  [913] = 135,
  [914] = 136,
  [915] = 140,
  [916] = 142,
  [917] = 137,
  [918] = 394,
  [919] = 138,
  [920] = 398,
  [921] = 388,
  [922] = 141,
  [923] = 144,
  [924] = 131,
  [925] = 143,
  [926] = 146,
  [927] = 148,
  [928] = 145,
  [929] = 147,
  [930] = 321,
  [931] = 163,
  [932] = 165,
  [933] = 155,
  [934] = 162,
  [935] = 160,
  [936] = 156,
  [937] = 158,
  [938] = 153,
  [939] = 166,
  [940] = 161,
  [941] = 152,
  [942] = 159,
  [943] = 149,
  [944] = 164,
  [945] = 150,
  [946] = 157,
  [947] = 154,
  [948] = 151,
  [949] = 388,
  [950] = 950,
  [951] = 394,
  [952] = 398,
  [953] = 953,
  [954] = 954,
  [955] = 954,
  [956] = 954,
  [957] = 954,
  [958] = 186,
  [959] = 202,
  [960] = 960,
  [961] = 197,
  [962] = 388,
  [963] = 223,
  [964] = 215,
  [965] = 204,
  [966] = 201,
  [967] = 190,
  [968] = 203,
  [969] = 213,
  [970] = 210,
  [971] = 214,
  [972] = 193,
  [973] = 209,
  [974] = 207,
  [975] = 394,
  [976] = 189,
  [977] = 398,
  [978] = 222,
  [979] = 244,
  [980] = 234,
  [981] = 981,
  [982] = 266,
  [983] = 267,
  [984] = 268,
  [985] = 269,
  [986] = 272,
  [987] = 273,
  [988] = 322,
  [989] = 319,
  [990] = 990,
  [991] = 991,
  [992] = 316,
  [993] = 315,
  [994] = 281,
  [995] = 279,
  [996] = 271,
  [997] = 238,
  [998] = 241,
  [999] = 262,
  [1000] = 252,
  [1001] = 1001,
  [1002] = 264,
  [1003] = 260,
  [1004] = 251,
  [1005] = 248,
  [1006] = 242,
  [1007] = 237,
  [1008] = 235,
  [1009] = 990,
  [1010] = 991,
  [1011] = 233,
  [1012] = 991,
  [1013] = 250,
  [1014] = 1014,
  [1015] = 247,
  [1016] = 246,
  [1017] = 1017,
  [1018] = 253,
  [1019] = 1014,
  [1020] = 257,
  [1021] = 277,
  [1022] = 278,
  [1023] = 1017,
  [1024] = 280,
  [1025] = 1017,
  [1026] = 231,
  [1027] = 990,
  [1028] = 991,
  [1029] = 1014,
  [1030] = 229,
  [1031] = 228,
  [1032] = 227,
  [1033] = 226,
  [1034] = 314,
  [1035] = 308,
  [1036] = 282,
  [1037] = 225,
  [1038] = 286,
  [1039] = 1039,
  [1040] = 287,
  [1041] = 275,
  [1042] = 274,
  [1043] = 323,
  [1044] = 270,
  [1045] = 236,
  [1046] = 307,
  [1047] = 1014,
  [1048] = 249,
  [1049] = 259,
  [1050] = 297,
  [1051] = 283,
  [1052] = 245,
  [1053] = 240,
  [1054] = 990,
  [1055] = 61,
  [1056] = 263,
  [1057] = 243,
  [1058] = 68,
  [1059] = 239,
  [1060] = 1017,
  [1061] = 276,
  [1062] = 318,
  [1063] = 1063,
  [1064] = 1063,
  [1065] = 1065,
  [1066] = 1065,
  [1067] = 1065,
  [1068] = 1065,
  [1069] = 1063,
  [1070] = 56,
  [1071] = 1063,
  [1072] = 55,
  [1073] = 1073,
  [1074] = 1074,
  [1075] = 1075,
  [1076] = 1076,
  [1077] = 1077,
  [1078] = 1078,
  [1079] = 1079,
  [1080] = 57,
  [1081] = 58,
  [1082] = 318,
  [1083] = 1083,
  [1084] = 1084,
  [1085] = 90,
  [1086] = 72,
  [1087] = 83,
  [1088] = 78,
  [1089] = 68,
  [1090] = 88,
  [1091] = 89,
  [1092] = 75,
  [1093] = 91,
  [1094] = 70,
  [1095] = 92,
  [1096] = 84,
  [1097] = 74,
  [1098] = 85,
  [1099] = 86,
  [1100] = 66,
  [1101] = 67,
  [1102] = 64,
  [1103] = 79,
  [1104] = 77,
  [1105] = 60,
  [1106] = 61,
  [1107] = 63,
  [1108] = 76,
  [1109] = 82,
  [1110] = 62,
  [1111] = 65,
  [1112] = 71,
  [1113] = 81,
  [1114] = 80,
  [1115] = 87,
  [1116] = 59,
  [1117] = 73,
  [1118] = 69,
  [1119] = 131,
  [1120] = 144,
  [1121] = 141,
  [1122] = 1122,
  [1123] = 1123,
  [1124] = 145,
  [1125] = 1125,
  [1126] = 148,
  [1127] = 146,
  [1128] = 1128,
  [1129] = 1129,
  [1130] = 1130,
  [1131] = 147,
  [1132] = 1132,
  [1133] = 1133,
  [1134] = 1134,
  [1135] = 1135,
  [1136] = 1136,
  [1137] = 1137,
  [1138] = 1138,
  [1139] = 1139,
  [1140] = 1140,
  [1141] = 1141,
  [1142] = 1142,
  [1143] = 1143,
  [1144] = 1144,
  [1145] = 1145,
  [1146] = 1146,
  [1147] = 1147,
  [1148] = 152,
  [1149] = 165,
  [1150] = 161,
  [1151] = 163,
  [1152] = 166,
  [1153] = 160,
  [1154] = 158,
  [1155] = 164,
  [1156] = 149,
  [1157] = 150,
  [1158] = 156,
  [1159] = 159,
  [1160] = 153,
  [1161] = 162,
  [1162] = 155,
  [1163] = 151,
  [1164] = 157,
  [1165] = 154,
  [1166] = 1166,
  [1167] = 1167,
  [1168] = 1168,
  [1169] = 1169,
  [1170] = 1170,
  [1171] = 1171,
  [1172] = 1172,
  [1173] = 1173,
  [1174] = 1174,
  [1175] = 1175,
  [1176] = 1176,
  [1177] = 1177,
  [1178] = 1178,
  [1179] = 1179,
  [1180] = 1180,
  [1181] = 1181,
  [1182] = 1182,
  [1183] = 1183,
  [1184] = 1184,
  [1185] = 1185,
  [1186] = 1186,
  [1187] = 1187,
  [1188] = 1188,
  [1189] = 1189,
  [1190] = 1190,
  [1191] = 1191,
  [1192] = 1192,
  [1193] = 1193,
  [1194] = 1194,
  [1195] = 1195,
  [1196] = 1196,
  [1197] = 1197,
  [1198] = 1198,
  [1199] = 1199,
  [1200] = 1200,
  [1201] = 1201,
  [1202] = 1202,
  [1203] = 1203,
  [1204] = 1204,
  [1205] = 1205,
  [1206] = 1206,
  [1207] = 1207,
  [1208] = 1208,
  [1209] = 1209,
  [1210] = 1210,
  [1211] = 1211,
  [1212] = 1212,
  [1213] = 1213,
  [1214] = 1214,
  [1215] = 1215,
  [1216] = 1216,
  [1217] = 1217,
  [1218] = 1218,
  [1219] = 1219,
  [1220] = 1220,
  [1221] = 1221,
  [1222] = 1222,
  [1223] = 1223,
  [1224] = 1224,
  [1225] = 1207,
  [1226] = 1226,
  [1227] = 1227,
  [1228] = 1228,
  [1229] = 1229,
  [1230] = 1230,
  [1231] = 1207,
  [1232] = 1232,
  [1233] = 1233,
  [1234] = 1232,
  [1235] = 1229,
  [1236] = 1227,
  [1237] = 1237,
  [1238] = 1238,
  [1239] = 1239,
  [1240] = 1240,
  [1241] = 1219,
  [1242] = 1242,
  [1243] = 1243,
  [1244] = 1244,
  [1245] = 1245,
  [1246] = 1240,
  [1247] = 1247,
  [1248] = 1219,
  [1249] = 1249,
  [1250] = 1250,
  [1251] = 1251,
  [1252] = 1252,
  [1253] = 1253,
  [1254] = 1254,
  [1255] = 1209,
  [1256] = 1245,
  [1257] = 1237,
  [1258] = 1226,
  [1259] = 1238,
  [1260] = 1260,
  [1261] = 1250,
  [1262] = 1239,
  [1263] = 1251,
  [1264] = 1252,
  [1265] = 1232,
  [1266] = 1209,
  [1267] = 1226,
  [1268] = 1260,
  [1269] = 1239,
  [1270] = 1250,
  [1271] = 1238,
  [1272] = 1272,
  [1273] = 1237,
  [1274] = 1240,
  [1275] = 1275,
  [1276] = 1216,
  [1277] = 1277,
  [1278] = 1239,
  [1279] = 1251,
  [1280] = 1252,
  [1281] = 1209,
  [1282] = 1243,
  [1283] = 1283,
  [1284] = 1226,
  [1285] = 1260,
  [1286] = 1250,
  [1287] = 1245,
  [1288] = 1238,
  [1289] = 1229,
  [1290] = 1232,
  [1291] = 1237,
  [1292] = 1292,
  [1293] = 1216,
  [1294] = 1228,
  [1295] = 1227,
  [1296] = 1219,
  [1297] = 1297,
  [1298] = 1221,
  [1299] = 1251,
  [1300] = 1252,
  [1301] = 1301,
  [1302] = 1228,
  [1303] = 1221,
  [1304] = 1222,
  [1305] = 1212,
  [1306] = 1216,
  [1307] = 1224,
  [1308] = 1223,
  [1309] = 1206,
  [1310] = 1224,
  [1311] = 1311,
  [1312] = 1221,
  [1313] = 1224,
  [1314] = 1207,
  [1315] = 1315,
  [1316] = 1245,
  [1317] = 1222,
  [1318] = 1318,
  [1319] = 1223,
  [1320] = 1213,
  [1321] = 1212,
  [1322] = 1227,
  [1323] = 1224,
  [1324] = 1277,
  [1325] = 1223,
  [1326] = 1207,
  [1327] = 1228,
  [1328] = 1328,
  [1329] = 1222,
  [1330] = 1232,
  [1331] = 1232,
  [1332] = 1227,
  [1333] = 1333,
  [1334] = 1242,
  [1335] = 1223,
  [1336] = 1228,
  [1337] = 1239,
  [1338] = 1238,
  [1339] = 1237,
  [1340] = 1232,
  [1341] = 1341,
  [1342] = 1232,
  [1343] = 1222,
  [1344] = 1344,
  [1345] = 1221,
  [1346] = 1318,
  [1347] = 1347,
  [1348] = 1216,
  [1349] = 1213,
  [1350] = 1350,
  [1351] = 1245,
  [1352] = 1350,
  [1353] = 1315,
  [1354] = 1315,
  [1355] = 1341,
  [1356] = 1356,
  [1357] = 1315,
  [1358] = 1213,
  [1359] = 1240,
  [1360] = 1212,
  [1361] = 1361,
  [1362] = 1243,
  [1363] = 1243,
  [1364] = 1232,
  [1365] = 1229,
  [1366] = 1366,
  [1367] = 1367,
  [1368] = 1368,
  [1369] = 1369,
  [1370] = 1240,
  [1371] = 1260,
  [1372] = 1372,
  [1373] = 1373,
  [1374] = 1374,
  [1375] = 1375,
  [1376] = 1376,
  [1377] = 1377,
  [1378] = 1378,
  [1379] = 1379,
  [1380] = 1380,
  [1381] = 1381,
  [1382] = 1382,
  [1383] = 1383,
  [1384] = 1384,
  [1385] = 1382,
  [1386] = 1386,
  [1387] = 1387,
  [1388] = 1388,
  [1389] = 1389,
  [1390] = 1390,
  [1391] = 1391,
  [1392] = 1392,
  [1393] = 1393,
  [1394] = 1394,
  [1395] = 1382,
  [1396] = 1396,
  [1397] = 1397,
  [1398] = 1398,
  [1399] = 1399,
  [1400] = 1400,
  [1401] = 1401,
  [1402] = 1402,
  [1403] = 1382,
  [1404] = 1404,
  [1405] = 1405,
  [1406] = 1406,
  [1407] = 1407,
  [1408] = 1408,
  [1409] = 1409,
  [1410] = 1410,
  [1411] = 1411,
  [1412] = 1412,
  [1413] = 1413,
  [1414] = 1414,
  [1415] = 1415,
  [1416] = 1416,
  [1417] = 1415,
  [1418] = 1416,
  [1419] = 1416,
  [1420] = 1420,
  [1421] = 1415,
  [1422] = 1416,
  [1423] = 1423,
  [1424] = 1415,
  [1425] = 1425,
  [1426] = 1426,
  [1427] = 1427,
  [1428] = 1428,
  [1429] = 1429,
  [1430] = 1197,
  [1431] = 1431,
  [1432] = 1432,
  [1433] = 1433,
  [1434] = 1434,
  [1435] = 1435,
  [1436] = 1436,
  [1437] = 1437,
  [1438] = 1438,
  [1439] = 1439,
  [1440] = 1440,
  [1441] = 1441,
  [1442] = 1442,
  [1443] = 1443,
  [1444] = 1201,
  [1445] = 1445,
  [1446] = 1446,
  [1447] = 1447,
  [1448] = 1448,
  [1449] = 1204,
  [1450] = 1450,
  [1451] = 1451,
  [1452] = 1200,
  [1453] = 1203,
  [1454] = 1205,
  [1455] = 1455,
  [1456] = 1456,
  [1457] = 1457,
  [1458] = 1458,
  [1459] = 1459,
  [1460] = 1460,
  [1461] = 1461,
  [1462] = 1462,
  [1463] = 1463,
  [1464] = 1464,
  [1465] = 1465,
  [1466] = 1466,
  [1467] = 1467,
  [1468] = 1468,
  [1469] = 1469,
  [1470] = 1470,
  [1471] = 1471,
  [1472] = 1472,
  [1473] = 1473,
  [1474] = 1473,
  [1475] = 1473,
  [1476] = 1473,
  [1477] = 1477,
  [1478] = 1478,
  [1479] = 1479,
  [1480] = 1480,
  [1481] = 1481,
  [1482] = 1482,
  [1483] = 1483,
  [1484] = 1484,
  [1485] = 1485,
  [1486] = 1486,
  [1487] = 1487,
  [1488] = 1488,
  [1489] = 1489,
  [1490] = 1490,
  [1491] = 1491,
  [1492] = 1492,
  [1493] = 1493,
  [1494] = 1423,
  [1495] = 1495,
  [1496] = 1496,
  [1497] = 1497,
  [1498] = 1498,
  [1499] = 1499,
  [1500] = 1500,
  [1501] = 1501,
  [1502] = 1502,
  [1503] = 1503,
  [1504] = 1504,
  [1505] = 1505,
  [1506] = 1506,
  [1507] = 1507,
  [1508] = 1508,
  [1509] = 1509,
  [1510] = 1510,
  [1511] = 1511,
  [1512] = 1512,
  [1513] = 1513,
  [1514] = 1514,
  [1515] = 1515,
  [1516] = 1515,
  [1517] = 1429,
  [1518] = 1515,
  [1519] = 1426,
  [1520] = 1513,
  [1521] = 1515,
  [1522] = 1513,
  [1523] = 1513,
  [1524] = 1513,
  [1525] = 1515,
  [1526] = 1432,
  [1527] = 1427,
  [1528] = 1433,
  [1529] = 1529,
  [1530] = 1442,
  [1531] = 1531,
  [1532] = 1435,
  [1533] = 1533,
  [1534] = 1534,
  [1535] = 1436,
  [1536] = 1536,
  [1537] = 1533,
  [1538] = 1440,
  [1539] = 1460,
  [1540] = 1540,
  [1541] = 1458,
  [1542] = 1465,
  [1543] = 1459,
  [1544] = 1463,
  [1545] = 1461,
  [1546] = 1445,
  [1547] = 1540,
  [1548] = 1455,
  [1549] = 1466,
  [1550] = 1464,
  [1551] = 1447,
  [1552] = 1552,
  [1553] = 1540,
  [1554] = 1554,
  [1555] = 1451,
  [1556] = 1462,
  [1557] = 1557,
  [1558] = 1540,
  [1559] = 1450,
  [1560] = 1457,
  [1561] = 1561,
  [1562] = 1456,
  [1563] = 1563,
  [1564] = 1448,
  [1565] = 1565,
  [1566] = 1446,
  [1567] = 1561,
  [1568] = 1568,
  [1569] = 1569,
  [1570] = 1570,
  [1571] = 1561,
  [1572] = 1540,
  [1573] = 1561,
  [1574] = 1540,
  [1575] = 1540,
  [1576] = 1554,
  [1577] = 1540,
  [1578] = 1552,
  [1579] = 1561,
  [1580] = 1580,
  [1581] = 1540,
  [1582] = 1582,
  [1583] = 1583,
  [1584] = 1584,
  [1585] = 1585,
  [1586] = 1586,
  [1587] = 1587,
  [1588] = 1588,
  [1589] = 1589,
  [1590] = 1590,
  [1591] = 1591,
  [1592] = 1592,
  [1593] = 1593,
  [1594] = 1594,
  [1595] = 1595,
  [1596] = 1596,
  [1597] = 1597,
  [1598] = 1598,
  [1599] = 1599,
  [1600] = 1600,
  [1601] = 1601,
  [1602] = 1602,
  [1603] = 1603,
  [1604] = 1604,
  [1605] = 1596,
  [1606] = 1606,
  [1607] = 1585,
  [1608] = 1608,
  [1609] = 1604,
  [1610] = 1610,
  [1611] = 1599,
  [1612] = 1612,
  [1613] = 1590,
  [1614] = 1614,
  [1615] = 1615,
  [1616] = 1606,
  [1617] = 1596,
  [1618] = 1591,
  [1619] = 1619,
  [1620] = 1620,
  [1621] = 1601,
  [1622] = 1622,
  [1623] = 1623,
  [1624] = 1601,
  [1625] = 1625,
  [1626] = 1606,
  [1627] = 1620,
  [1628] = 1628,
  [1629] = 1629,
  [1630] = 1602,
  [1631] = 1628,
  [1632] = 1600,
  [1633] = 1633,
  [1634] = 1612,
  [1635] = 1635,
  [1636] = 1599,
  [1637] = 1625,
  [1638] = 1602,
  [1639] = 1639,
  [1640] = 1640,
  [1641] = 1608,
  [1642] = 1608,
  [1643] = 1467,
  [1644] = 1608,
  [1645] = 1640,
  [1646] = 1646,
  [1647] = 1606,
  [1648] = 1591,
  [1649] = 1599,
  [1650] = 1650,
  [1651] = 1625,
  [1652] = 1590,
  [1653] = 1612,
  [1654] = 1612,
  [1655] = 1600,
  [1656] = 1601,
  [1657] = 1604,
  [1658] = 1612,
  [1659] = 1659,
  [1660] = 1640,
  [1661] = 1590,
  [1662] = 1599,
  [1663] = 1591,
  [1664] = 1664,
  [1665] = 1596,
  [1666] = 1628,
  [1667] = 1667,
  [1668] = 1591,
  [1669] = 1669,
  [1670] = 1640,
  [1671] = 1620,
  [1672] = 1672,
  [1673] = 1673,
  [1674] = 1674,
  [1675] = 1675,
  [1676] = 1676,
  [1677] = 1677,
  [1678] = 1678,
  [1679] = 1679,
  [1680] = 1604,
  [1681] = 1681,
  [1682] = 1682,
  [1683] = 1683,
  [1684] = 1684,
  [1685] = 1685,
  [1686] = 1686,
  [1687] = 1687,
  [1688] = 1688,
  [1689] = 1689,
  [1690] = 1690,
  [1691] = 1691,
  [1692] = 1692,
  [1693] = 1596,
  [1694] = 1625,
  [1695] = 1606,
  [1696] = 1590,
  [1697] = 1600,
  [1698] = 1698,
  [1699] = 1699,
  [1700] = 1700,
  [1701] = 1604,
  [1702] = 1602,
  [1703] = 1628,
  [1704] = 1620,
  [1705] = 1608,
  [1706] = 1706,
  [1707] = 1707,
  [1708] = 1706,
  [1709] = 1709,
  [1710] = 1710,
  [1711] = 1711,
  [1712] = 1712,
  [1713] = 1710,
  [1714] = 1714,
  [1715] = 1715,
  [1716] = 1716,
  [1717] = 1717,
  [1718] = 1716,
  [1719] = 1710,
  [1720] = 1720,
  [1721] = 1711,
  [1722] = 1710,
  [1723] = 1716,
  [1724] = 1724,
  [1725] = 1707,
  [1726] = 1726,
  [1727] = 1711,
  [1728] = 1728,
  [1729] = 1729,
  [1730] = 1706,
  [1731] = 1469,
  [1732] = 1706,
  [1733] = 1733,
  [1734] = 1724,
  [1735] = 1707,
  [1736] = 1706,
  [1737] = 1724,
  [1738] = 1714,
  [1739] = 1739,
  [1740] = 1707,
  [1741] = 1724,
  [1742] = 1472,
  [1743] = 1733,
  [1744] = 1729,
  [1745] = 1707,
  [1746] = 1468,
  [1747] = 1716,
  [1748] = 1714,
  [1749] = 1714,
  [1750] = 1711,
  [1751] = 1751,
  [1752] = 1751,
  [1753] = 1753,
  [1754] = 1751,
  [1755] = 1751,
  [1756] = 1756,
  [1757] = 1757,
  [1758] = 1758,
  [1759] = 1759,
  [1760] = 1757,
  [1761] = 1761,
  [1762] = 1762,
  [1763] = 1757,
  [1764] = 1762,
  [1765] = 1765,
  [1766] = 1766,
  [1767] = 1767,
  [1768] = 1765,
  [1769] = 1769,
  [1770] = 1761,
  [1771] = 1757,
  [1772] = 1761,
  [1773] = 1757,
  [1774] = 1761,
  [1775] = 1761,
  [1776] = 1776,
  [1777] = 1757,
  [1778] = 1758,
  [1779] = 1759,
  [1780] = 1756,
  [1781] = 1776,
  [1782] = 1757,
  [1783] = 1761,
  [1784] = 1761,
  [1785] = 1766,
  [1786] = 1757,
  [1787] = 1761,
  [1788] = 1776,
  [1789] = 1789,
  [1790] = 1765,
  [1791] = 1766,
  [1792] = 1759,
  [1793] = 1759,
  [1794] = 1758,
  [1795] = 1756,
  [1796] = 1776,
  [1797] = 1765,
  [1798] = 1762,
  [1799] = 1766,
  [1800] = 1758,
  [1801] = 1756,
  [1802] = 1762,
  [1803] = 1803,
  [1804] = 1804,
  [1805] = 1805,
  [1806] = 1806,
  [1807] = 1807,
  [1808] = 1808,
  [1809] = 1809,
  [1810] = 1810,
  [1811] = 1811,
  [1812] = 1812,
  [1813] = 1813,
  [1814] = 1814,
  [1815] = 1811,
  [1816] = 1816,
  [1817] = 1817,
  [1818] = 1818,
  [1819] = 1813,
  [1820] = 1820,
  [1821] = 1816,
  [1822] = 1805,
  [1823] = 1806,
  [1824] = 1814,
  [1825] = 1805,
  [1826] = 1826,
  [1827] = 1820,
  [1828] = 1813,
  [1829] = 1808,
  [1830] = 1816,
  [1831] = 1807,
  [1832] = 1809,
  [1833] = 1807,
  [1834] = 1820,
  [1835] = 1817,
  [1836] = 1811,
  [1837] = 1820,
  [1838] = 1806,
  [1839] = 1839,
  [1840] = 1805,
  [1841] = 1817,
  [1842] = 1808,
  [1843] = 1809,
  [1844] = 1809,
  [1845] = 1814,
  [1846] = 1811,
  [1847] = 1814,
  [1848] = 1814,
  [1849] = 1809,
  [1850] = 1816,
  [1851] = 1807,
  [1852] = 1817,
  [1853] = 1808,
  [1854] = 1813,
  [1855] = 1806,
  [1856] = 1856,
  [1857] = 1857,
  [1858] = 1858,
  [1859] = 1859,
  [1860] = 1860,
  [1861] = 1861,
  [1862] = 1862,
  [1863] = 1863,
  [1864] = 1864,
  [1865] = 1865,
  [1866] = 1865,
  [1867] = 1867,
  [1868] = 1868,
  [1869] = 1861,
  [1870] = 1870,
  [1871] = 1871,
  [1872] = 1871,
  [1873] = 1858,
  [1874] = 1856,
  [1875] = 1875,
  [1876] = 1858,
  [1877] = 1877,
  [1878] = 1861,
  [1879] = 1858,
  [1880] = 1863,
  [1881] = 1881,
  [1882] = 1882,
  [1883] = 1883,
  [1884] = 1877,
  [1885] = 1885,
  [1886] = 1862,
  [1887] = 1863,
  [1888] = 1885,
  [1889] = 1857,
  [1890] = 1883,
  [1891] = 1891,
  [1892] = 1859,
  [1893] = 1856,
  [1894] = 1877,
  [1895] = 1861,
  [1896] = 1883,
  [1897] = 1897,
  [1898] = 1898,
  [1899] = 1881,
  [1900] = 1863,
  [1901] = 1871,
  [1902] = 1877,
  [1903] = 1871,
  [1904] = 1897,
  [1905] = 1898,
  [1906] = 1877,
  [1907] = 1907,
  [1908] = 1885,
  [1909] = 1883,
  [1910] = 1907,
  [1911] = 1856,
  [1912] = 1858,
  [1913] = 1885,
  [1914] = 1861,
  [1915] = 1870,
  [1916] = 1860,
  [1917] = 1917,
  [1918] = 1918,
  [1919] = 1919,
  [1920] = 1920,
  [1921] = 1921,
  [1922] = 1922,
  [1923] = 1923,
  [1924] = 1924,
  [1925] = 1925,
  [1926] = 1926,
  [1927] = 1927,
  [1928] = 1928,
  [1929] = 1924,
  [1930] = 1930,
  [1931] = 1922,
  [1932] = 1921,
  [1933] = 1933,
  [1934] = 1934,
  [1935] = 1935,
  [1936] = 1936,
  [1937] = 1937,
  [1938] = 1938,
  [1939] = 1939,
  [1940] = 1940,
  [1941] = 1925,
  [1942] = 1942,
  [1943] = 1943,
  [1944] = 1927,
  [1945] = 1928,
  [1946] = 1946,
  [1947] = 1947,
  [1948] = 1924,
  [1949] = 1949,
  [1950] = 1922,
  [1951] = 1921,
  [1952] = 1952,
  [1953] = 1953,
  [1954] = 1933,
  [1955] = 1947,
  [1956] = 1934,
  [1957] = 1926,
  [1958] = 1937,
  [1959] = 1930,
  [1960] = 1960,
  [1961] = 1939,
  [1962] = 1962,
  [1963] = 1963,
  [1964] = 1953,
  [1965] = 1925,
  [1966] = 1966,
  [1967] = 1967,
  [1968] = 1968,
  [1969] = 1927,
  [1970] = 1928,
  [1971] = 1971,
  [1972] = 1924,
  [1973] = 1973,
  [1974] = 1922,
  [1975] = 1921,
  [1976] = 1933,
  [1977] = 1934,
  [1978] = 1937,
  [1979] = 1966,
  [1980] = 1917,
  [1981] = 1981,
  [1982] = 1939,
  [1983] = 1983,
  [1984] = 1952,
  [1985] = 1985,
  [1986] = 1986,
  [1987] = 1918,
  [1988] = 1968,
  [1989] = 1989,
  [1990] = 1990,
  [1991] = 1923,
  [1992] = 1992,
  [1993] = 1918,
  [1994] = 1963,
  [1995] = 1995,
  [1996] = 1996,
  [1997] = 1935,
  [1998] = 1983,
  [1999] = 1985,
  [2000] = 2000,
  [2001] = 2001,
  [2002] = 1989,
  [2003] = 1946,
  [2004] = 1990,
  [2005] = 1923,
  [2006] = 1933,
  [2007] = 1934,
  [2008] = 2008,
  [2009] = 2009,
  [2010] = 1990,
  [2011] = 1985,
  [2012] = 1928,
  [2013] = 1927,
  [2014] = 1971,
  [2015] = 1983,
  [2016] = 1981,
  [2017] = 1935,
  [2018] = 1985,
  [2019] = 1936,
  [2020] = 1989,
  [2021] = 2021,
  [2022] = 1943,
  [2023] = 1990,
  [2024] = 1923,
  [2025] = 1952,
  [2026] = 1953,
  [2027] = 2027,
  [2028] = 2028,
  [2029] = 2029,
  [2030] = 1947,
  [2031] = 1963,
  [2032] = 1966,
  [2033] = 2033,
  [2034] = 1968,
  [2035] = 2035,
  [2036] = 2036,
  [2037] = 2037,
  [2038] = 1917,
  [2039] = 1981,
  [2040] = 1917,
  [2041] = 1981,
  [2042] = 2042,
  [2043] = 1971,
  [2044] = 2044,
  [2045] = 1943,
  [2046] = 2046,
  [2047] = 1918,
  [2048] = 2048,
  [2049] = 1989,
  [2050] = 1925,
  [2051] = 2051,
  [2052] = 1968,
  [2053] = 1937,
  [2054] = 2054,
  [2055] = 1996,
  [2056] = 2056,
  [2057] = 2057,
  [2058] = 1966,
  [2059] = 2059,
  [2060] = 1918,
  [2061] = 2051,
  [2062] = 1935,
  [2063] = 2063,
  [2064] = 1936,
  [2065] = 1963,
  [2066] = 1963,
  [2067] = 2067,
  [2068] = 1935,
  [2069] = 2069,
  [2070] = 1936,
  [2071] = 1936,
  [2072] = 1963,
  [2073] = 1930,
  [2074] = 1935,
  [2075] = 2075,
  [2076] = 1936,
  [2077] = 1926,
  [2078] = 1963,
  [2079] = 2079,
  [2080] = 1963,
  [2081] = 2081,
  [2082] = 1947,
  [2083] = 2083,
  [2084] = 1953,
  [2085] = 1952,
  [2086] = 2086,
  [2087] = 1935,
  [2088] = 1936,
  [2089] = 2089,
  [2090] = 1943,
  [2091] = 1946,
  [2092] = 1996,
  [2093] = 2093,
  [2094] = 1946,
  [2095] = 1952,
  [2096] = 2051,
  [2097] = 2097,
  [2098] = 2051,
  [2099] = 1943,
  [2100] = 1953,
  [2101] = 1947,
  [2102] = 1926,
  [2103] = 1930,
  [2104] = 1963,
  [2105] = 1966,
  [2106] = 1981,
  [2107] = 1917,
  [2108] = 1971,
  [2109] = 1968,
  [2110] = 1936,
  [2111] = 1935,
  [2112] = 2112,
  [2113] = 1983,
  [2114] = 1939,
  [2115] = 2115,
  [2116] = 2116,
  [2117] = 1996,
  [2118] = 2118,
  [2119] = 2119,
  [2120] = 2120,
  [2121] = 2121,
  [2122] = 2122,
  [2123] = 2123,
  [2124] = 2124,
  [2125] = 2125,
  [2126] = 2126,
  [2127] = 2127,
  [2128] = 2128,
  [2129] = 2129,
  [2130] = 2130,
  [2131] = 2121,
  [2132] = 2132,
  [2133] = 2120,
  [2134] = 2134,
  [2135] = 2128,
  [2136] = 2136,
  [2137] = 2137,
  [2138] = 2138,
  [2139] = 2136,
  [2140] = 2140,
  [2141] = 2134,
  [2142] = 2142,
  [2143] = 2143,
  [2144] = 2123,
  [2145] = 2140,
  [2146] = 2146,
  [2147] = 2147,
  [2148] = 2122,
  [2149] = 2142,
  [2150] = 2150,
  [2151] = 2151,
  [2152] = 2152,
  [2153] = 2146,
  [2154] = 2154,
  [2155] = 2155,
  [2156] = 2156,
  [2157] = 2157,
  [2158] = 2151,
  [2159] = 2159,
  [2160] = 2160,
  [2161] = 2152,
  [2162] = 2152,
  [2163] = 2163,
  [2164] = 2134,
  [2165] = 2128,
  [2166] = 2147,
  [2167] = 2167,
  [2168] = 2167,
  [2169] = 2169,
  [2170] = 2152,
  [2171] = 2171,
  [2172] = 2134,
  [2173] = 2128,
  [2174] = 2155,
  [2175] = 2175,
  [2176] = 2167,
  [2177] = 2152,
  [2178] = 2119,
  [2179] = 2171,
  [2180] = 2119,
  [2181] = 2167,
  [2182] = 2119,
  [2183] = 2167,
  [2184] = 2156,
  [2185] = 2171,
  [2186] = 2171,
  [2187] = 2134,
  [2188] = 2128,
  [2189] = 2189,
  [2190] = 2190,
  [2191] = 2191,
  [2192] = 2192,
  [2193] = 2193,
  [2194] = 2194,
  [2195] = 2195,
  [2196] = 2196,
  [2197] = 2197,
  [2198] = 2198,
  [2199] = 2199,
  [2200] = 2200,
  [2201] = 2201,
  [2202] = 2202,
  [2203] = 2203,
  [2204] = 2204,
  [2205] = 2205,
  [2206] = 2189,
  [2207] = 2207,
  [2208] = 2208,
  [2209] = 2207,
  [2210] = 2204,
  [2211] = 2198,
  [2212] = 2197,
  [2213] = 2213,
  [2214] = 2195,
  [2215] = 2215,
  [2216] = 2216,
  [2217] = 2217,
  [2218] = 2218,
  [2219] = 2203,
  [2220] = 2220,
  [2221] = 2221,
  [2222] = 2202,
  [2223] = 2201,
  [2224] = 2224,
  [2225] = 2200,
  [2226] = 2226,
  [2227] = 2196,
  [2228] = 2228,
  [2229] = 2229,
  [2230] = 2218,
  [2231] = 2193,
  [2232] = 2192,
  [2233] = 2233,
  [2234] = 2234,
  [2235] = 2235,
  [2236] = 2236,
  [2237] = 2237,
  [2238] = 2238,
  [2239] = 2220,
  [2240] = 2240,
  [2241] = 2241,
  [2242] = 2242,
  [2243] = 2243,
  [2244] = 2244,
  [2245] = 2245,
  [2246] = 2246,
  [2247] = 2247,
  [2248] = 2248,
  [2249] = 2238,
  [2250] = 2242,
  [2251] = 2237,
  [2252] = 2252,
  [2253] = 2253,
  [2254] = 2254,
  [2255] = 2255,
  [2256] = 2256,
  [2257] = 2257,
  [2258] = 2258,
  [2259] = 2259,
  [2260] = 2220,
  [2261] = 2244,
  [2262] = 2216,
  [2263] = 2263,
  [2264] = 2253,
  [2265] = 2265,
  [2266] = 2266,
  [2267] = 2245,
  [2268] = 2268,
  [2269] = 2269,
  [2270] = 2270,
  [2271] = 2271,
  [2272] = 2272,
  [2273] = 2273,
  [2274] = 2274,
  [2275] = 2195,
  [2276] = 2270,
  [2277] = 2266,
  [2278] = 2233,
  [2279] = 2279,
  [2280] = 2280,
  [2281] = 2197,
  [2282] = 2274,
  [2283] = 2259,
  [2284] = 2284,
  [2285] = 2198,
  [2286] = 2286,
  [2287] = 2287,
  [2288] = 2288,
  [2289] = 2289,
  [2290] = 2290,
  [2291] = 2291,
  [2292] = 2292,
  [2293] = 2207,
  [2294] = 2294,
  [2295] = 2295,
  [2296] = 2246,
  [2297] = 2297,
  [2298] = 2298,
  [2299] = 2299,
  [2300] = 2300,
  [2301] = 2288,
  [2302] = 2302,
  [2303] = 2303,
  [2304] = 2304,
  [2305] = 2300,
  [2306] = 2303,
  [2307] = 2292,
  [2308] = 2287,
  [2309] = 2287,
  [2310] = 2304,
  [2311] = 2274,
  [2312] = 2303,
  [2313] = 2302,
  [2314] = 2298,
  [2315] = 2315,
  [2316] = 2316,
  [2317] = 2300,
  [2318] = 2294,
  [2319] = 2319,
  [2320] = 2228,
  [2321] = 2286,
  [2322] = 2258,
  [2323] = 2299,
  [2324] = 2290,
  [2325] = 2297,
  [2326] = 2319,
  [2327] = 2295,
  [2328] = 2268,
  [2329] = 2273,
  [2330] = 2270,
  [2331] = 2294,
  [2332] = 2332,
  [2333] = 2190,
  [2334] = 2255,
  [2335] = 2335,
  [2336] = 2196,
  [2337] = 2295,
  [2338] = 2338,
  [2339] = 2339,
  [2340] = 2298,
  [2341] = 2341,
  [2342] = 2253,
  [2343] = 2343,
  [2344] = 2299,
  [2345] = 2332,
  [2346] = 2246,
  [2347] = 2207,
  [2348] = 2280,
  [2349] = 2302,
  [2350] = 2289,
  [2351] = 2221,
  [2352] = 2236,
  [2353] = 2304,
  [2354] = 2220,
  [2355] = 2355,
  [2356] = 2233,
  [2357] = 2287,
  [2358] = 2194,
  [2359] = 2335,
  [2360] = 2217,
  [2361] = 2292,
  [2362] = 2235,
  [2363] = 2303,
  [2364] = 2364,
  [2365] = 2288,
  [2366] = 2247,
  [2367] = 2241,
  [2368] = 2368,
  [2369] = 2234,
  [2370] = 2215,
  [2371] = 2343,
  [2372] = 2238,
  [2373] = 2208,
  [2374] = 2191,
  [2375] = 2297,
  [2376] = 2189,
  [2377] = 2377,
  [2378] = 2268,
  [2379] = 2273,
  [2380] = 2380,
  [2381] = 2252,
  [2382] = 2368,
  [2383] = 2338,
  [2384] = 2204,
  [2385] = 2341,
  [2386] = 2257,
  [2387] = 2343,
  [2388] = 2233,
  [2389] = 2216,
  [2390] = 2355,
  [2391] = 2242,
  [2392] = 2280,
  [2393] = 2253,
  [2394] = 2286,
  [2395] = 2221,
  [2396] = 2258,
  [2397] = 2266,
  [2398] = 2398,
  [2399] = 2355,
  [2400] = 2274,
  [2401] = 2259,
  [2402] = 2194,
  [2403] = 2338,
  [2404] = 2217,
  [2405] = 2203,
  [2406] = 2235,
  [2407] = 2368,
  [2408] = 2189,
  [2409] = 2191,
  [2410] = 2268,
  [2411] = 2273,
  [2412] = 2202,
  [2413] = 2233,
  [2414] = 2255,
  [2415] = 2338,
  [2416] = 2220,
  [2417] = 2341,
  [2418] = 2246,
  [2419] = 2343,
  [2420] = 2298,
  [2421] = 2201,
  [2422] = 2200,
  [2423] = 2266,
  [2424] = 2280,
  [2425] = 2298,
  [2426] = 2255,
  [2427] = 2221,
  [2428] = 2246,
  [2429] = 2258,
  [2430] = 2286,
  [2431] = 2355,
  [2432] = 2242,
  [2433] = 2300,
  [2434] = 2194,
  [2435] = 2270,
  [2436] = 2217,
  [2437] = 2289,
  [2438] = 2235,
  [2439] = 2189,
  [2440] = 2300,
  [2441] = 2303,
  [2442] = 2226,
  [2443] = 2287,
  [2444] = 2245,
  [2445] = 2257,
  [2446] = 2304,
  [2447] = 2302,
  [2448] = 2299,
  [2449] = 2297,
  [2450] = 2295,
  [2451] = 2294,
  [2452] = 2244,
  [2453] = 2292,
  [2454] = 2288,
  [2455] = 2274,
  [2456] = 2270,
  [2457] = 2245,
  [2458] = 2458,
  [2459] = 2339,
  [2460] = 2244,
  [2461] = 2196,
  [2462] = 2237,
  [2463] = 2236,
  [2464] = 2192,
  [2465] = 2237,
  [2466] = 2236,
  [2467] = 2193,
  [2468] = 2257,
  [2469] = 2196,
  [2470] = 2200,
  [2471] = 2201,
  [2472] = 2252,
  [2473] = 2202,
  [2474] = 2203,
  [2475] = 2204,
  [2476] = 2192,
  [2477] = 2207,
  [2478] = 2198,
  [2479] = 2252,
  [2480] = 2208,
  [2481] = 2197,
  [2482] = 2195,
  [2483] = 2216,
  [2484] = 2238,
  [2485] = 2485,
  [2486] = 2218,
  [2487] = 2247,
  [2488] = 2241,
  [2489] = 2234,
  [2490] = 2215,
  [2491] = 2238,
  [2492] = 2193,
  [2493] = 2208,
  [2494] = 2252,
  [2495] = 2257,
  [2496] = 2289,
  [2497] = 2242,
  [2498] = 2215,
  [2499] = 2253,
  [2500] = 2205,
  [2501] = 2234,
  [2502] = 2341,
  [2503] = 2266,
  [2504] = 2259,
  [2505] = 2265,
  [2506] = 2377,
  [2507] = 2241,
  [2508] = 2508,
  [2509] = 2368,
  [2510] = 2265,
  [2511] = 2377,
  [2512] = 2247,
  [2513] = 2218,
  [2514] = 2191,
  [2515] = 2265,
  [2516] = 2377,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(45);
      ADVANCE_MAP(
        '!', 68,
        '"', 123,
        '#', 11,
        '%', 82,
        '&', 71,
        '\'', 125,
        '(', 112,
        ')', 57,
        '*', 80,
        '+', 79,
        ',', 55,
        '-', 76,
        '.', 60,
        '/', 81,
        '0', 116,
        ':', 52,
        ';', 75,
        '<', 91,
        '=', 46,
        '>', 88,
        '?', 51,
        '@', 48,
        '[', 49,
        '\\', 54,
        ']', 50,
        '^', 69,
        '{', 73,
        '|', 70,
        '}', 74,
        '~', 114,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(42);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(117);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(139);
      END_STATE();
    case 1:
      if (lookahead == '\r') ADVANCE(141);
      if (lookahead != 0) ADVANCE(140);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(124);
      END_STATE();
    case 3:
      if (lookahead == '"') ADVANCE(122);
      if (lookahead == '/') ADVANCE(132);
      if (lookahead == '\\') ADVANCE(10);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(131);
      if (lookahead != 0) ADVANCE(133);
      END_STATE();
    case 4:
      if (lookahead == '\'') ADVANCE(125);
      if (lookahead == '/') ADVANCE(128);
      if (lookahead == '\\') ADVANCE(10);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(127);
      if (lookahead != 0) ADVANCE(129);
      END_STATE();
    case 5:
      if (lookahead == ')') ADVANCE(57);
      if (lookahead == '.') ADVANCE(6);
      if (lookahead == '/') ADVANCE(8);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(5);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(139);
      END_STATE();
    case 6:
      if (lookahead == '.') ADVANCE(7);
      END_STATE();
    case 7:
      if (lookahead == '.') ADVANCE(58);
      END_STATE();
    case 8:
      if (lookahead == '/') ADVANCE(140);
      END_STATE();
    case 9:
      if (lookahead == ':') ADVANCE(115);
      END_STATE();
    case 10:
      if (lookahead == 'U') ADVANCE(136);
      if (lookahead == 'u') ADVANCE(26);
      if (lookahead == 'x') ADVANCE(36);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(135);
      if (lookahead == '"' ||
          lookahead == '\'' ||
          lookahead == '?' ||
          lookahead == '\\' ||
          lookahead == 'a' ||
          lookahead == 'b' ||
          lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          ('t' <= lookahead && lookahead <= 'v')) ADVANCE(137);
      if (lookahead != 0) ADVANCE(134);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(21);
      if (lookahead == 'r') ADVANCE(17);
      if (lookahead == 's') ADVANCE(18);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(15);
      END_STATE();
    case 13:
      if (lookahead == 'a') ADVANCE(23);
      END_STATE();
    case 14:
      if (lookahead == 'a') ADVANCE(24);
      END_STATE();
    case 15:
      if (lookahead == 'd') ADVANCE(62);
      END_STATE();
    case 16:
      if (lookahead == 'd') ADVANCE(63);
      END_STATE();
    case 17:
      if (lookahead == 'e') ADVANCE(12);
      END_STATE();
    case 18:
      if (lookahead == 'e') ADVANCE(22);
      if (lookahead == 'h') ADVANCE(13);
      END_STATE();
    case 19:
      if (lookahead == 'e') ADVANCE(64);
      END_STATE();
    case 20:
      if (lookahead == 'i') ADVANCE(14);
      END_STATE();
    case 21:
      if (lookahead == 'l') ADVANCE(20);
      if (lookahead == 'n') ADVANCE(25);
      END_STATE();
    case 22:
      if (lookahead == 'n') ADVANCE(16);
      END_STATE();
    case 23:
      if (lookahead == 'r') ADVANCE(19);
      END_STATE();
    case 24:
      if (lookahead == 's') ADVANCE(65);
      END_STATE();
    case 25:
      if (lookahead == 'y') ADVANCE(66);
      END_STATE();
    case 26:
      if (lookahead == '{') ADVANCE(34);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(35);
      END_STATE();
    case 27:
      if (lookahead == '}') ADVANCE(137);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(27);
      END_STATE();
    case 28:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(31);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(121);
      END_STATE();
    case 29:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(118);
      END_STATE();
    case 30:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(120);
      END_STATE();
    case 31:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(121);
      END_STATE();
    case 32:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(119);
      END_STATE();
    case 33:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(137);
      END_STATE();
    case 34:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(27);
      END_STATE();
    case 35:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(36);
      END_STATE();
    case 36:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(33);
      END_STATE();
    case 37:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(35);
      END_STATE();
    case 38:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(37);
      END_STATE();
    case 39:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(38);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(39);
      END_STATE();
    case 41:
      if (eof) ADVANCE(45);
      ADVANCE_MAP(
        '!', 68,
        '"', 123,
        '#', 11,
        '%', 82,
        '&', 71,
        '\'', 125,
        '(', 112,
        ')', 57,
        '*', 80,
        '+', 79,
        ',', 55,
        '-', 76,
        '.', 61,
        '/', 81,
        '0', 116,
        ':', 52,
        ';', 75,
        '<', 92,
        '=', 46,
        '>', 88,
        '?', 51,
        '@', 48,
        '[', 49,
        ']', 50,
        '^', 69,
        '{', 73,
        '|', 70,
        '}', 74,
        '~', 114,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(43);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(117);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(139);
      END_STATE();
    case 42:
      if (eof) ADVANCE(45);
      ADVANCE_MAP(
        '!', 68,
        '"', 123,
        '#', 11,
        '%', 82,
        '&', 71,
        '\'', 125,
        '(', 56,
        ')', 57,
        '*', 80,
        '+', 79,
        ',', 55,
        '-', 76,
        '.', 60,
        '/', 81,
        '0', 116,
        ':', 52,
        ';', 75,
        '<', 91,
        '=', 46,
        '>', 88,
        '?', 51,
        '@', 48,
        '[', 49,
        '\\', 54,
        ']', 50,
        '^', 69,
        '{', 73,
        '|', 70,
        '}', 74,
        '~', 114,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(42);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(117);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(139);
      END_STATE();
    case 43:
      if (eof) ADVANCE(45);
      ADVANCE_MAP(
        '!', 68,
        '"', 123,
        '#', 11,
        '%', 82,
        '&', 71,
        '\'', 125,
        '(', 56,
        ')', 57,
        '*', 80,
        '+', 79,
        ',', 55,
        '-', 76,
        '.', 61,
        '/', 81,
        '0', 116,
        ':', 52,
        ';', 75,
        '<', 92,
        '=', 46,
        '>', 88,
        '?', 51,
        '@', 48,
        '[', 49,
        ']', 50,
        '^', 69,
        '{', 73,
        '|', 70,
        '}', 74,
        '~', 114,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(43);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(117);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(139);
      END_STATE();
    case 44:
      if (eof) ADVANCE(45);
      ADVANCE_MAP(
        '!', 67,
        '"', 123,
        '#', 11,
        '&', 71,
        '\'', 125,
        '(', 56,
        ')', 57,
        ',', 55,
        '-', 77,
        '.', 59,
        '/', 8,
        '0', 116,
        ':', 52,
        ';', 75,
        '<', 9,
        '=', 47,
        '?', 51,
        '@', 48,
        '[', 49,
        '\\', 54,
        ']', 50,
        '^', 69,
        '{', 73,
        '|', 70,
        '}', 74,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(44);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(117);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(139);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(86);
      if (lookahead == '>') ADVANCE(53);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(53);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(7);
      if (lookahead == '>') ADVANCE(113);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '>') ADVANCE(113);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_POUNDread);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_POUNDsend);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_POUNDshare);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_POUNDalias);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_POUNDany);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(87);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(72);
      if (lookahead == '?') ADVANCE(107);
      if (lookahead == '~') ADVANCE(78);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(72);
      if (lookahead == '~') ADVANCE(78);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_DASH_TILDE);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '~') ADVANCE(93);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '?') ADVANCE(108);
      if (lookahead == '~') ADVANCE(94);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(140);
      if (lookahead == '?') ADVANCE(109);
      if (lookahead == '~') ADVANCE(95);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '%') ADVANCE(83);
      if (lookahead == '?') ADVANCE(110);
      if (lookahead == '~') ADVANCE(96);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_PERCENT_PERCENT);
      if (lookahead == '?') ADVANCE(111);
      if (lookahead == '~') ADVANCE(97);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '~') ADVANCE(98);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '~') ADVANCE(99);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '~') ADVANCE(100);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '~') ADVANCE(101);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(89);
      if (lookahead == '>') ADVANCE(85);
      if (lookahead == '~') ADVANCE(102);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      if (lookahead == '~') ADVANCE(103);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '~') ADVANCE(104);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == ':') ADVANCE(115);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == '=') ADVANCE(90);
      if (lookahead == '~') ADVANCE(105);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == '=') ADVANCE(90);
      if (lookahead == '~') ADVANCE(105);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_PLUS_TILDE);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_STAR_TILDE);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_SLASH_TILDE);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_PERCENT_TILDE);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_PERCENT_PERCENT_TILDE);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_LT_LT_TILDE);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_GT_GT_TILDE);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_TILDE);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_TILDE);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_GT_TILDE);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_GT_EQ_TILDE);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_LT_EQ_TILDE);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_LT_TILDE);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_PLUS_QMARK);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_DASH_QMARK);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_STAR_QMARK);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_SLASH_QMARK);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_PERCENT_QMARK);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_PERCENT_PERCENT_QMARK);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_DOT_GT);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_LT_COLON);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(30);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(29);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(28);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(32);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(117);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(30);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(28);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(117);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(118);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(119);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(28);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(120);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_float);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(121);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      if (lookahead == '"') ADVANCE(2);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_DQUOTE_DQUOTE_DQUOTE);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_character_content);
      if (lookahead == '\n') ADVANCE(129);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(126);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_character_content);
      if (lookahead == '/') ADVANCE(128);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(127);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(129);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym_character_content);
      if (lookahead == '/') ADVANCE(126);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(129);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(sym_character_content);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(129);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead == '\n') ADVANCE(133);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(130);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead == '/') ADVANCE(132);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(131);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(133);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead == '/') ADVANCE(130);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(133);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(133);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(aux_sym__escape_sequence_token1);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(aux_sym__escape_sequence_token1);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(138);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(aux_sym__escape_sequence_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(137);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(139);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead == '\\') ADVANCE(1);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(140);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead == '\\') ADVANCE(1);
      if (lookahead != 0) ADVANCE(140);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        '_', 1,
        'a', 2,
        'b', 3,
        'c', 4,
        'd', 5,
        'e', 6,
        'f', 7,
        'i', 8,
        'l', 9,
        'm', 10,
        'n', 11,
        'o', 12,
        'p', 13,
        'r', 14,
        's', 15,
        't', 16,
        'u', 17,
        'v', 18,
        'w', 19,
        'x', 20,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == '_') ADVANCE(21);
      END_STATE();
    case 2:
      if (lookahead == 'c') ADVANCE(22);
      if (lookahead == 'd') ADVANCE(23);
      if (lookahead == 'n') ADVANCE(24);
      if (lookahead == 's') ADVANCE(25);
      END_STATE();
    case 3:
      if (lookahead == 'e') ADVANCE(26);
      if (lookahead == 'o') ADVANCE(27);
      if (lookahead == 'r') ADVANCE(28);
      END_STATE();
    case 4:
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 5:
      if (lookahead == 'i') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 6:
      if (lookahead == 'l') ADVANCE(33);
      if (lookahead == 'm') ADVANCE(34);
      if (lookahead == 'n') ADVANCE(35);
      if (lookahead == 'r') ADVANCE(36);
      END_STATE();
    case 7:
      if (lookahead == 'a') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      if (lookahead == 'u') ADVANCE(39);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(40);
      if (lookahead == 'n') ADVANCE(41);
      if (lookahead == 's') ADVANCE(42);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(43);
      END_STATE();
    case 10:
      if (lookahead == 'a') ADVANCE(44);
      END_STATE();
    case 11:
      if (lookahead == 'e') ADVANCE(45);
      if (lookahead == 'o') ADVANCE(46);
      END_STATE();
    case 12:
      if (lookahead == 'b') ADVANCE(47);
      if (lookahead == 'r') ADVANCE(48);
      END_STATE();
    case 13:
      if (lookahead == 'r') ADVANCE(49);
      END_STATE();
    case 14:
      if (lookahead == 'e') ADVANCE(50);
      END_STATE();
    case 15:
      if (lookahead == 't') ADVANCE(51);
      END_STATE();
    case 16:
      if (lookahead == 'a') ADVANCE(52);
      if (lookahead == 'h') ADVANCE(53);
      if (lookahead == 'r') ADVANCE(54);
      if (lookahead == 'y') ADVANCE(55);
      END_STATE();
    case 17:
      if (lookahead == 'n') ADVANCE(56);
      if (lookahead == 's') ADVANCE(57);
      END_STATE();
    case 18:
      if (lookahead == 'a') ADVANCE(58);
      END_STATE();
    case 19:
      if (lookahead == 'h') ADVANCE(59);
      if (lookahead == 'i') ADVANCE(60);
      END_STATE();
    case 20:
      if (lookahead == 'o') ADVANCE(61);
      END_STATE();
    case 21:
      if (lookahead == 'l') ADVANCE(62);
      END_STATE();
    case 22:
      if (lookahead == 't') ADVANCE(63);
      END_STATE();
    case 23:
      if (lookahead == 'd') ADVANCE(64);
      END_STATE();
    case 24:
      if (lookahead == 'd') ADVANCE(65);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_be);
      END_STATE();
    case 27:
      if (lookahead == 'x') ADVANCE(66);
      END_STATE();
    case 28:
      if (lookahead == 'e') ADVANCE(67);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(68);
      END_STATE();
    case 30:
      if (lookahead == 'm') ADVANCE(69);
      if (lookahead == 'n') ADVANCE(70);
      END_STATE();
    case 31:
      if (lookahead == 'g') ADVANCE(71);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 33:
      if (lookahead == 's') ADVANCE(72);
      END_STATE();
    case 34:
      if (lookahead == 'b') ADVANCE(73);
      END_STATE();
    case 35:
      if (lookahead == 'd') ADVANCE(74);
      END_STATE();
    case 36:
      if (lookahead == 'r') ADVANCE(75);
      END_STATE();
    case 37:
      if (lookahead == 'l') ADVANCE(76);
      END_STATE();
    case 38:
      if (lookahead == 'r') ADVANCE(77);
      END_STATE();
    case 39:
      if (lookahead == 'n') ADVANCE(78);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_if);
      if (lookahead == 'd') ADVANCE(79);
      if (lookahead == 't') ADVANCE(80);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 't') ADVANCE(81);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_is);
      if (lookahead == 'n') ADVANCE(82);
      if (lookahead == 'o') ADVANCE(83);
      END_STATE();
    case 43:
      if (lookahead == 't') ADVANCE(84);
      END_STATE();
    case 44:
      if (lookahead == 't') ADVANCE(85);
      END_STATE();
    case 45:
      if (lookahead == 'w') ADVANCE(86);
      END_STATE();
    case 46:
      if (lookahead == 't') ADVANCE(87);
      END_STATE();
    case 47:
      if (lookahead == 'j') ADVANCE(88);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 49:
      if (lookahead == 'i') ADVANCE(89);
      END_STATE();
    case 50:
      if (lookahead == 'c') ADVANCE(90);
      if (lookahead == 'f') ADVANCE(91);
      if (lookahead == 'p') ADVANCE(92);
      if (lookahead == 't') ADVANCE(93);
      END_STATE();
    case 51:
      if (lookahead == 'r') ADVANCE(94);
      END_STATE();
    case 52:
      if (lookahead == 'g') ADVANCE(95);
      END_STATE();
    case 53:
      if (lookahead == 'e') ADVANCE(96);
      if (lookahead == 'i') ADVANCE(97);
      END_STATE();
    case 54:
      if (lookahead == 'a') ADVANCE(98);
      if (lookahead == 'n') ADVANCE(99);
      if (lookahead == 'u') ADVANCE(100);
      if (lookahead == 'y') ADVANCE(101);
      END_STATE();
    case 55:
      if (lookahead == 'p') ADVANCE(102);
      END_STATE();
    case 56:
      if (lookahead == 't') ADVANCE(103);
      END_STATE();
    case 57:
      if (lookahead == 'e') ADVANCE(104);
      END_STATE();
    case 58:
      if (lookahead == 'l') ADVANCE(105);
      if (lookahead == 'r') ADVANCE(106);
      END_STATE();
    case 59:
      if (lookahead == 'e') ADVANCE(107);
      if (lookahead == 'i') ADVANCE(108);
      END_STATE();
    case 60:
      if (lookahead == 't') ADVANCE(109);
      END_STATE();
    case 61:
      if (lookahead == 'r') ADVANCE(110);
      END_STATE();
    case 62:
      if (lookahead == 'o') ADVANCE(111);
      END_STATE();
    case 63:
      if (lookahead == 'o') ADVANCE(112);
      END_STATE();
    case 64:
      if (lookahead == 'r') ADVANCE(113);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_box);
      END_STATE();
    case 67:
      if (lookahead == 'a') ADVANCE(114);
      END_STATE();
    case 68:
      if (lookahead == 's') ADVANCE(115);
      END_STATE();
    case 69:
      if (lookahead == 'p') ADVANCE(116);
      END_STATE();
    case 70:
      if (lookahead == 's') ADVANCE(117);
      if (lookahead == 't') ADVANCE(118);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(119);
      END_STATE();
    case 72:
      if (lookahead == 'e') ADVANCE(120);
      END_STATE();
    case 73:
      if (lookahead == 'e') ADVANCE(121);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 75:
      if (lookahead == 'o') ADVANCE(122);
      END_STATE();
    case 76:
      if (lookahead == 's') ADVANCE(123);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_fun);
      END_STATE();
    case 79:
      if (lookahead == 'e') ADVANCE(124);
      END_STATE();
    case 80:
      if (lookahead == 'y') ADVANCE(125);
      END_STATE();
    case 81:
      if (lookahead == 'e') ADVANCE(126);
      END_STATE();
    case 82:
      if (lookahead == 't') ADVANCE(127);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_iso);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 85:
      if (lookahead == 'c') ADVANCE(128);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 88:
      if (lookahead == 'e') ADVANCE(129);
      END_STATE();
    case 89:
      if (lookahead == 'm') ADVANCE(130);
      END_STATE();
    case 90:
      if (lookahead == 'o') ADVANCE(131);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_ref);
      END_STATE();
    case 92:
      if (lookahead == 'e') ADVANCE(132);
      END_STATE();
    case 93:
      if (lookahead == 'u') ADVANCE(133);
      END_STATE();
    case 94:
      if (lookahead == 'u') ADVANCE(134);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_tag);
      END_STATE();
    case 96:
      if (lookahead == 'n') ADVANCE(135);
      END_STATE();
    case 97:
      if (lookahead == 's') ADVANCE(136);
      END_STATE();
    case 98:
      if (lookahead == 'i') ADVANCE(137);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_trn);
      END_STATE();
    case 100:
      if (lookahead == 'e') ADVANCE(138);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 102:
      if (lookahead == 'e') ADVANCE(139);
      END_STATE();
    case 103:
      if (lookahead == 'i') ADVANCE(140);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_use);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_val);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 107:
      if (lookahead == 'r') ADVANCE(141);
      END_STATE();
    case 108:
      if (lookahead == 'l') ADVANCE(142);
      END_STATE();
    case 109:
      if (lookahead == 'h') ADVANCE(143);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_xor);
      END_STATE();
    case 111:
      if (lookahead == 'c') ADVANCE(144);
      END_STATE();
    case 112:
      if (lookahead == 'r') ADVANCE(145);
      END_STATE();
    case 113:
      if (lookahead == 'e') ADVANCE(146);
      END_STATE();
    case 114:
      if (lookahead == 'k') ADVANCE(147);
      END_STATE();
    case 115:
      if (lookahead == 's') ADVANCE(148);
      END_STATE();
    case 116:
      if (lookahead == 'i') ADVANCE(149);
      END_STATE();
    case 117:
      if (lookahead == 'u') ADVANCE(150);
      END_STATE();
    case 118:
      if (lookahead == 'i') ADVANCE(151);
      END_STATE();
    case 119:
      if (lookahead == 's') ADVANCE(152);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == 'i') ADVANCE(153);
      END_STATE();
    case 121:
      if (lookahead == 'd') ADVANCE(154);
      END_STATE();
    case 122:
      if (lookahead == 'r') ADVANCE(155);
      END_STATE();
    case 123:
      if (lookahead == 'e') ADVANCE(156);
      END_STATE();
    case 124:
      if (lookahead == 'f') ADVANCE(157);
      END_STATE();
    case 125:
      if (lookahead == 'p') ADVANCE(158);
      END_STATE();
    case 126:
      if (lookahead == 'r') ADVANCE(159);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_isnt);
      END_STATE();
    case 128:
      if (lookahead == 'h') ADVANCE(160);
      END_STATE();
    case 129:
      if (lookahead == 'c') ADVANCE(161);
      END_STATE();
    case 130:
      if (lookahead == 'i') ADVANCE(162);
      END_STATE();
    case 131:
      if (lookahead == 'v') ADVANCE(163);
      END_STATE();
    case 132:
      if (lookahead == 'a') ADVANCE(164);
      END_STATE();
    case 133:
      if (lookahead == 'r') ADVANCE(165);
      END_STATE();
    case 134:
      if (lookahead == 'c') ADVANCE(166);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 137:
      if (lookahead == 't') ADVANCE(167);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 140:
      if (lookahead == 'l') ADVANCE(168);
      END_STATE();
    case 141:
      if (lookahead == 'e') ADVANCE(169);
      END_STATE();
    case 142:
      if (lookahead == 'e') ADVANCE(170);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_location);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_actor);
      END_STATE();
    case 146:
      if (lookahead == 's') ADVANCE(171);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 149:
      if (lookahead == 'l') ADVANCE(172);
      END_STATE();
    case 150:
      if (lookahead == 'm') ADVANCE(173);
      END_STATE();
    case 151:
      if (lookahead == 'n') ADVANCE(174);
      END_STATE();
    case 152:
      if (lookahead == 't') ADVANCE(175);
      END_STATE();
    case 153:
      if (lookahead == 'f') ADVANCE(176);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_embed);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_error);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_ifdef);
      END_STATE();
    case 158:
      if (lookahead == 'e') ADVANCE(177);
      END_STATE();
    case 159:
      if (lookahead == 'f') ADVANCE(178);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_match);
      END_STATE();
    case 161:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 162:
      if (lookahead == 't') ADVANCE(180);
      END_STATE();
    case 163:
      if (lookahead == 'e') ADVANCE(181);
      END_STATE();
    case 164:
      if (lookahead == 't') ADVANCE(182);
      END_STATE();
    case 165:
      if (lookahead == 'n') ADVANCE(183);
      END_STATE();
    case 166:
      if (lookahead == 't') ADVANCE(184);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_trait);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_until);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_where);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 171:
      if (lookahead == 's') ADVANCE(185);
      END_STATE();
    case 172:
      if (lookahead == 'e') ADVANCE(186);
      END_STATE();
    case 173:
      if (lookahead == 'e') ADVANCE(187);
      END_STATE();
    case 174:
      if (lookahead == 'u') ADVANCE(188);
      END_STATE();
    case 175:
      if (lookahead == 'o') ADVANCE(189);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_elseif);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_iftype);
      END_STATE();
    case 178:
      if (lookahead == 'a') ADVANCE(190);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_object);
      END_STATE();
    case 180:
      if (lookahead == 'i') ADVANCE(191);
      END_STATE();
    case 181:
      if (lookahead == 'r') ADVANCE(192);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_repeat);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 185:
      if (lookahead == 'o') ADVANCE(193);
      END_STATE();
    case 186:
      if (lookahead == '_') ADVANCE(194);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_consume);
      END_STATE();
    case 188:
      if (lookahead == 'e') ADVANCE(195);
      END_STATE();
    case 189:
      if (lookahead == 'f') ADVANCE(196);
      END_STATE();
    case 190:
      if (lookahead == 'c') ADVANCE(197);
      END_STATE();
    case 191:
      if (lookahead == 'v') ADVANCE(198);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_recover);
      END_STATE();
    case 193:
      if (lookahead == 'f') ADVANCE(199);
      END_STATE();
    case 194:
      if (lookahead == 'e') ADVANCE(200);
      if (lookahead == 'i') ADVANCE(201);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_digestof);
      END_STATE();
    case 197:
      if (lookahead == 'e') ADVANCE(202);
      END_STATE();
    case 198:
      if (lookahead == 'e') ADVANCE(203);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_addressof);
      END_STATE();
    case 200:
      if (lookahead == 'r') ADVANCE(204);
      END_STATE();
    case 201:
      if (lookahead == 'n') ADVANCE(205);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_primitive);
      END_STATE();
    case 204:
      if (lookahead == 'r') ADVANCE(206);
      END_STATE();
    case 205:
      if (lookahead == 't') ADVANCE(207);
      END_STATE();
    case 206:
      if (lookahead == 'o') ADVANCE(208);
      END_STATE();
    case 207:
      if (lookahead == 'r') ADVANCE(209);
      END_STATE();
    case 208:
      if (lookahead == 'r') ADVANCE(210);
      END_STATE();
    case 209:
      if (lookahead == 'i') ADVANCE(211);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_compile_error);
      END_STATE();
    case 211:
      if (lookahead == 'n') ADVANCE(212);
      END_STATE();
    case 212:
      if (lookahead == 's') ADVANCE(213);
      END_STATE();
    case 213:
      if (lookahead == 'i') ADVANCE(214);
      END_STATE();
    case 214:
      if (lookahead == 'c') ADVANCE(215);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(sym_compile_intrinsic);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 0, .external_lex_state = 2},
  [2] = {.lex_state = 41, .external_lex_state = 2},
  [3] = {.lex_state = 41, .external_lex_state = 2},
  [4] = {.lex_state = 41, .external_lex_state = 2},
  [5] = {.lex_state = 41, .external_lex_state = 2},
  [6] = {.lex_state = 41, .external_lex_state = 2},
  [7] = {.lex_state = 41, .external_lex_state = 2},
  [8] = {.lex_state = 41, .external_lex_state = 2},
  [9] = {.lex_state = 41, .external_lex_state = 2},
  [10] = {.lex_state = 41, .external_lex_state = 2},
  [11] = {.lex_state = 41, .external_lex_state = 2},
  [12] = {.lex_state = 41, .external_lex_state = 2},
  [13] = {.lex_state = 41, .external_lex_state = 2},
  [14] = {.lex_state = 41, .external_lex_state = 2},
  [15] = {.lex_state = 41, .external_lex_state = 2},
  [16] = {.lex_state = 41, .external_lex_state = 2},
  [17] = {.lex_state = 41, .external_lex_state = 2},
  [18] = {.lex_state = 41, .external_lex_state = 2},
  [19] = {.lex_state = 41, .external_lex_state = 2},
  [20] = {.lex_state = 41, .external_lex_state = 2},
  [21] = {.lex_state = 41, .external_lex_state = 2},
  [22] = {.lex_state = 41, .external_lex_state = 2},
  [23] = {.lex_state = 41, .external_lex_state = 2},
  [24] = {.lex_state = 41, .external_lex_state = 2},
  [25] = {.lex_state = 41, .external_lex_state = 2},
  [26] = {.lex_state = 41, .external_lex_state = 2},
  [27] = {.lex_state = 41, .external_lex_state = 2},
  [28] = {.lex_state = 41, .external_lex_state = 2},
  [29] = {.lex_state = 41, .external_lex_state = 2},
  [30] = {.lex_state = 41, .external_lex_state = 2},
  [31] = {.lex_state = 41, .external_lex_state = 2},
  [32] = {.lex_state = 41, .external_lex_state = 2},
  [33] = {.lex_state = 41, .external_lex_state = 2},
  [34] = {.lex_state = 41, .external_lex_state = 2},
  [35] = {.lex_state = 41, .external_lex_state = 2},
  [36] = {.lex_state = 41, .external_lex_state = 2},
  [37] = {.lex_state = 41, .external_lex_state = 2},
  [38] = {.lex_state = 41, .external_lex_state = 2},
  [39] = {.lex_state = 41, .external_lex_state = 2},
  [40] = {.lex_state = 41, .external_lex_state = 2},
  [41] = {.lex_state = 41, .external_lex_state = 2},
  [42] = {.lex_state = 41, .external_lex_state = 2},
  [43] = {.lex_state = 41, .external_lex_state = 2},
  [44] = {.lex_state = 41, .external_lex_state = 2},
  [45] = {.lex_state = 41, .external_lex_state = 2},
  [46] = {.lex_state = 41, .external_lex_state = 2},
  [47] = {.lex_state = 41, .external_lex_state = 2},
  [48] = {.lex_state = 41, .external_lex_state = 2},
  [49] = {.lex_state = 41, .external_lex_state = 2},
  [50] = {.lex_state = 41, .external_lex_state = 2},
  [51] = {.lex_state = 41, .external_lex_state = 2},
  [52] = {.lex_state = 41, .external_lex_state = 2},
  [53] = {.lex_state = 41, .external_lex_state = 2},
  [54] = {.lex_state = 41, .external_lex_state = 2},
  [55] = {.lex_state = 41, .external_lex_state = 3},
  [56] = {.lex_state = 41, .external_lex_state = 3},
  [57] = {.lex_state = 41, .external_lex_state = 3},
  [58] = {.lex_state = 41, .external_lex_state = 3},
  [59] = {.lex_state = 41, .external_lex_state = 2},
  [60] = {.lex_state = 41, .external_lex_state = 2},
  [61] = {.lex_state = 41, .external_lex_state = 2},
  [62] = {.lex_state = 41, .external_lex_state = 2},
  [63] = {.lex_state = 41, .external_lex_state = 2},
  [64] = {.lex_state = 41, .external_lex_state = 2},
  [65] = {.lex_state = 41, .external_lex_state = 2},
  [66] = {.lex_state = 41, .external_lex_state = 2},
  [67] = {.lex_state = 41, .external_lex_state = 2},
  [68] = {.lex_state = 41, .external_lex_state = 2},
  [69] = {.lex_state = 41, .external_lex_state = 2},
  [70] = {.lex_state = 41, .external_lex_state = 2},
  [71] = {.lex_state = 41, .external_lex_state = 2},
  [72] = {.lex_state = 41, .external_lex_state = 2},
  [73] = {.lex_state = 41, .external_lex_state = 2},
  [74] = {.lex_state = 41, .external_lex_state = 2},
  [75] = {.lex_state = 41, .external_lex_state = 2},
  [76] = {.lex_state = 41, .external_lex_state = 2},
  [77] = {.lex_state = 41, .external_lex_state = 2},
  [78] = {.lex_state = 41, .external_lex_state = 2},
  [79] = {.lex_state = 41, .external_lex_state = 2},
  [80] = {.lex_state = 41, .external_lex_state = 2},
  [81] = {.lex_state = 41, .external_lex_state = 2},
  [82] = {.lex_state = 41, .external_lex_state = 2},
  [83] = {.lex_state = 41, .external_lex_state = 2},
  [84] = {.lex_state = 41, .external_lex_state = 2},
  [85] = {.lex_state = 41, .external_lex_state = 2},
  [86] = {.lex_state = 41, .external_lex_state = 2},
  [87] = {.lex_state = 41, .external_lex_state = 2},
  [88] = {.lex_state = 41, .external_lex_state = 2},
  [89] = {.lex_state = 41, .external_lex_state = 2},
  [90] = {.lex_state = 41, .external_lex_state = 2},
  [91] = {.lex_state = 41, .external_lex_state = 2},
  [92] = {.lex_state = 41, .external_lex_state = 2},
  [93] = {.lex_state = 41, .external_lex_state = 3},
  [94] = {.lex_state = 41, .external_lex_state = 3},
  [95] = {.lex_state = 41, .external_lex_state = 3},
  [96] = {.lex_state = 41, .external_lex_state = 3},
  [97] = {.lex_state = 41, .external_lex_state = 2},
  [98] = {.lex_state = 41, .external_lex_state = 2},
  [99] = {.lex_state = 41, .external_lex_state = 2},
  [100] = {.lex_state = 41, .external_lex_state = 2},
  [101] = {.lex_state = 41, .external_lex_state = 2},
  [102] = {.lex_state = 41, .external_lex_state = 2},
  [103] = {.lex_state = 41, .external_lex_state = 2},
  [104] = {.lex_state = 41, .external_lex_state = 2},
  [105] = {.lex_state = 41, .external_lex_state = 2},
  [106] = {.lex_state = 41, .external_lex_state = 2},
  [107] = {.lex_state = 41, .external_lex_state = 2},
  [108] = {.lex_state = 41, .external_lex_state = 2},
  [109] = {.lex_state = 41, .external_lex_state = 2},
  [110] = {.lex_state = 41, .external_lex_state = 2},
  [111] = {.lex_state = 41, .external_lex_state = 2},
  [112] = {.lex_state = 41, .external_lex_state = 2},
  [113] = {.lex_state = 41, .external_lex_state = 2},
  [114] = {.lex_state = 41, .external_lex_state = 2},
  [115] = {.lex_state = 41, .external_lex_state = 2},
  [116] = {.lex_state = 41, .external_lex_state = 2},
  [117] = {.lex_state = 41, .external_lex_state = 2},
  [118] = {.lex_state = 41, .external_lex_state = 2},
  [119] = {.lex_state = 41, .external_lex_state = 2},
  [120] = {.lex_state = 41, .external_lex_state = 2},
  [121] = {.lex_state = 41, .external_lex_state = 2},
  [122] = {.lex_state = 41, .external_lex_state = 2},
  [123] = {.lex_state = 41, .external_lex_state = 2},
  [124] = {.lex_state = 41, .external_lex_state = 2},
  [125] = {.lex_state = 41, .external_lex_state = 2},
  [126] = {.lex_state = 41, .external_lex_state = 2},
  [127] = {.lex_state = 41, .external_lex_state = 2},
  [128] = {.lex_state = 41, .external_lex_state = 2},
  [129] = {.lex_state = 41, .external_lex_state = 2},
  [130] = {.lex_state = 41, .external_lex_state = 2},
  [131] = {.lex_state = 41, .external_lex_state = 2},
  [132] = {.lex_state = 41, .external_lex_state = 2},
  [133] = {.lex_state = 41, .external_lex_state = 2},
  [134] = {.lex_state = 41, .external_lex_state = 2},
  [135] = {.lex_state = 41, .external_lex_state = 2},
  [136] = {.lex_state = 41, .external_lex_state = 2},
  [137] = {.lex_state = 41, .external_lex_state = 2},
  [138] = {.lex_state = 41, .external_lex_state = 2},
  [139] = {.lex_state = 41, .external_lex_state = 2},
  [140] = {.lex_state = 41, .external_lex_state = 2},
  [141] = {.lex_state = 41, .external_lex_state = 2},
  [142] = {.lex_state = 41, .external_lex_state = 2},
  [143] = {.lex_state = 41, .external_lex_state = 2},
  [144] = {.lex_state = 41, .external_lex_state = 2},
  [145] = {.lex_state = 41, .external_lex_state = 2},
  [146] = {.lex_state = 41, .external_lex_state = 2},
  [147] = {.lex_state = 41, .external_lex_state = 2},
  [148] = {.lex_state = 41, .external_lex_state = 2},
  [149] = {.lex_state = 41, .external_lex_state = 2},
  [150] = {.lex_state = 41, .external_lex_state = 2},
  [151] = {.lex_state = 41, .external_lex_state = 2},
  [152] = {.lex_state = 41, .external_lex_state = 2},
  [153] = {.lex_state = 41, .external_lex_state = 2},
  [154] = {.lex_state = 41, .external_lex_state = 2},
  [155] = {.lex_state = 41, .external_lex_state = 2},
  [156] = {.lex_state = 41, .external_lex_state = 2},
  [157] = {.lex_state = 41, .external_lex_state = 2},
  [158] = {.lex_state = 41, .external_lex_state = 2},
  [159] = {.lex_state = 41, .external_lex_state = 2},
  [160] = {.lex_state = 41, .external_lex_state = 2},
  [161] = {.lex_state = 41, .external_lex_state = 2},
  [162] = {.lex_state = 41, .external_lex_state = 2},
  [163] = {.lex_state = 41, .external_lex_state = 2},
  [164] = {.lex_state = 41, .external_lex_state = 2},
  [165] = {.lex_state = 41, .external_lex_state = 2},
  [166] = {.lex_state = 41, .external_lex_state = 2},
  [167] = {.lex_state = 41, .external_lex_state = 2},
  [168] = {.lex_state = 41, .external_lex_state = 2},
  [169] = {.lex_state = 41, .external_lex_state = 2},
  [170] = {.lex_state = 41, .external_lex_state = 2},
  [171] = {.lex_state = 41, .external_lex_state = 2},
  [172] = {.lex_state = 41, .external_lex_state = 2},
  [173] = {.lex_state = 41, .external_lex_state = 2},
  [174] = {.lex_state = 41, .external_lex_state = 2},
  [175] = {.lex_state = 41, .external_lex_state = 2},
  [176] = {.lex_state = 41, .external_lex_state = 2},
  [177] = {.lex_state = 41, .external_lex_state = 2},
  [178] = {.lex_state = 41, .external_lex_state = 2},
  [179] = {.lex_state = 41, .external_lex_state = 2},
  [180] = {.lex_state = 41, .external_lex_state = 2},
  [181] = {.lex_state = 41, .external_lex_state = 3},
  [182] = {.lex_state = 41, .external_lex_state = 3},
  [183] = {.lex_state = 41, .external_lex_state = 2},
  [184] = {.lex_state = 41, .external_lex_state = 2},
  [185] = {.lex_state = 41, .external_lex_state = 3},
  [186] = {.lex_state = 41, .external_lex_state = 3},
  [187] = {.lex_state = 41, .external_lex_state = 2},
  [188] = {.lex_state = 41, .external_lex_state = 2},
  [189] = {.lex_state = 41, .external_lex_state = 2},
  [190] = {.lex_state = 41, .external_lex_state = 2},
  [191] = {.lex_state = 41, .external_lex_state = 2},
  [192] = {.lex_state = 41, .external_lex_state = 2},
  [193] = {.lex_state = 41, .external_lex_state = 3},
  [194] = {.lex_state = 41, .external_lex_state = 2},
  [195] = {.lex_state = 41, .external_lex_state = 2},
  [196] = {.lex_state = 41, .external_lex_state = 2},
  [197] = {.lex_state = 41, .external_lex_state = 2},
  [198] = {.lex_state = 41, .external_lex_state = 2},
  [199] = {.lex_state = 41, .external_lex_state = 2},
  [200] = {.lex_state = 41, .external_lex_state = 2},
  [201] = {.lex_state = 41, .external_lex_state = 3},
  [202] = {.lex_state = 41, .external_lex_state = 3},
  [203] = {.lex_state = 41, .external_lex_state = 3},
  [204] = {.lex_state = 41, .external_lex_state = 3},
  [205] = {.lex_state = 41, .external_lex_state = 2},
  [206] = {.lex_state = 41, .external_lex_state = 2},
  [207] = {.lex_state = 41, .external_lex_state = 2},
  [208] = {.lex_state = 41, .external_lex_state = 2},
  [209] = {.lex_state = 41, .external_lex_state = 2},
  [210] = {.lex_state = 41, .external_lex_state = 3},
  [211] = {.lex_state = 41, .external_lex_state = 2},
  [212] = {.lex_state = 41, .external_lex_state = 2},
  [213] = {.lex_state = 41, .external_lex_state = 2},
  [214] = {.lex_state = 41, .external_lex_state = 2},
  [215] = {.lex_state = 41, .external_lex_state = 2},
  [216] = {.lex_state = 41, .external_lex_state = 2},
  [217] = {.lex_state = 41, .external_lex_state = 2},
  [218] = {.lex_state = 41, .external_lex_state = 2},
  [219] = {.lex_state = 41, .external_lex_state = 2},
  [220] = {.lex_state = 41, .external_lex_state = 2},
  [221] = {.lex_state = 41, .external_lex_state = 3},
  [222] = {.lex_state = 41, .external_lex_state = 2},
  [223] = {.lex_state = 41, .external_lex_state = 2},
  [224] = {.lex_state = 41, .external_lex_state = 2},
  [225] = {.lex_state = 41, .external_lex_state = 2},
  [226] = {.lex_state = 41, .external_lex_state = 2},
  [227] = {.lex_state = 41, .external_lex_state = 2},
  [228] = {.lex_state = 41, .external_lex_state = 2},
  [229] = {.lex_state = 41, .external_lex_state = 2},
  [230] = {.lex_state = 41, .external_lex_state = 2},
  [231] = {.lex_state = 41, .external_lex_state = 2},
  [232] = {.lex_state = 41, .external_lex_state = 2},
  [233] = {.lex_state = 41, .external_lex_state = 2},
  [234] = {.lex_state = 41, .external_lex_state = 2},
  [235] = {.lex_state = 41, .external_lex_state = 2},
  [236] = {.lex_state = 41, .external_lex_state = 2},
  [237] = {.lex_state = 41, .external_lex_state = 2},
  [238] = {.lex_state = 41, .external_lex_state = 2},
  [239] = {.lex_state = 41, .external_lex_state = 2},
  [240] = {.lex_state = 41, .external_lex_state = 2},
  [241] = {.lex_state = 41, .external_lex_state = 2},
  [242] = {.lex_state = 41, .external_lex_state = 2},
  [243] = {.lex_state = 41, .external_lex_state = 2},
  [244] = {.lex_state = 41, .external_lex_state = 2},
  [245] = {.lex_state = 41, .external_lex_state = 2},
  [246] = {.lex_state = 41, .external_lex_state = 2},
  [247] = {.lex_state = 41, .external_lex_state = 2},
  [248] = {.lex_state = 41, .external_lex_state = 2},
  [249] = {.lex_state = 41, .external_lex_state = 2},
  [250] = {.lex_state = 41, .external_lex_state = 2},
  [251] = {.lex_state = 41, .external_lex_state = 2},
  [252] = {.lex_state = 41, .external_lex_state = 2},
  [253] = {.lex_state = 41, .external_lex_state = 2},
  [254] = {.lex_state = 41, .external_lex_state = 2},
  [255] = {.lex_state = 41, .external_lex_state = 2},
  [256] = {.lex_state = 41, .external_lex_state = 2},
  [257] = {.lex_state = 41, .external_lex_state = 2},
  [258] = {.lex_state = 41, .external_lex_state = 2},
  [259] = {.lex_state = 41, .external_lex_state = 2},
  [260] = {.lex_state = 41, .external_lex_state = 2},
  [261] = {.lex_state = 41, .external_lex_state = 2},
  [262] = {.lex_state = 41, .external_lex_state = 2},
  [263] = {.lex_state = 41, .external_lex_state = 2},
  [264] = {.lex_state = 41, .external_lex_state = 2},
  [265] = {.lex_state = 41, .external_lex_state = 2},
  [266] = {.lex_state = 41, .external_lex_state = 2},
  [267] = {.lex_state = 41, .external_lex_state = 2},
  [268] = {.lex_state = 41, .external_lex_state = 2},
  [269] = {.lex_state = 41, .external_lex_state = 2},
  [270] = {.lex_state = 41, .external_lex_state = 2},
  [271] = {.lex_state = 41, .external_lex_state = 2},
  [272] = {.lex_state = 41, .external_lex_state = 2},
  [273] = {.lex_state = 41, .external_lex_state = 2},
  [274] = {.lex_state = 41, .external_lex_state = 2},
  [275] = {.lex_state = 41, .external_lex_state = 2},
  [276] = {.lex_state = 41, .external_lex_state = 2},
  [277] = {.lex_state = 41, .external_lex_state = 2},
  [278] = {.lex_state = 41, .external_lex_state = 2},
  [279] = {.lex_state = 41, .external_lex_state = 2},
  [280] = {.lex_state = 41, .external_lex_state = 2},
  [281] = {.lex_state = 41, .external_lex_state = 2},
  [282] = {.lex_state = 41, .external_lex_state = 2},
  [283] = {.lex_state = 41, .external_lex_state = 2},
  [284] = {.lex_state = 41, .external_lex_state = 2},
  [285] = {.lex_state = 41, .external_lex_state = 2},
  [286] = {.lex_state = 41, .external_lex_state = 2},
  [287] = {.lex_state = 41, .external_lex_state = 2},
  [288] = {.lex_state = 41, .external_lex_state = 2},
  [289] = {.lex_state = 41, .external_lex_state = 2},
  [290] = {.lex_state = 41, .external_lex_state = 2},
  [291] = {.lex_state = 41, .external_lex_state = 2},
  [292] = {.lex_state = 41, .external_lex_state = 2},
  [293] = {.lex_state = 41, .external_lex_state = 2},
  [294] = {.lex_state = 41, .external_lex_state = 2},
  [295] = {.lex_state = 41, .external_lex_state = 2},
  [296] = {.lex_state = 41, .external_lex_state = 2},
  [297] = {.lex_state = 41, .external_lex_state = 2},
  [298] = {.lex_state = 41, .external_lex_state = 2},
  [299] = {.lex_state = 41, .external_lex_state = 2},
  [300] = {.lex_state = 41, .external_lex_state = 2},
  [301] = {.lex_state = 41, .external_lex_state = 2},
  [302] = {.lex_state = 41, .external_lex_state = 2},
  [303] = {.lex_state = 41, .external_lex_state = 2},
  [304] = {.lex_state = 41, .external_lex_state = 2},
  [305] = {.lex_state = 41, .external_lex_state = 2},
  [306] = {.lex_state = 41, .external_lex_state = 2},
  [307] = {.lex_state = 41, .external_lex_state = 2},
  [308] = {.lex_state = 41, .external_lex_state = 2},
  [309] = {.lex_state = 41, .external_lex_state = 2},
  [310] = {.lex_state = 41, .external_lex_state = 2},
  [311] = {.lex_state = 41, .external_lex_state = 2},
  [312] = {.lex_state = 41, .external_lex_state = 2},
  [313] = {.lex_state = 41, .external_lex_state = 2},
  [314] = {.lex_state = 41, .external_lex_state = 2},
  [315] = {.lex_state = 41, .external_lex_state = 2},
  [316] = {.lex_state = 41, .external_lex_state = 2},
  [317] = {.lex_state = 41, .external_lex_state = 2},
  [318] = {.lex_state = 41, .external_lex_state = 2},
  [319] = {.lex_state = 41, .external_lex_state = 2},
  [320] = {.lex_state = 41, .external_lex_state = 2},
  [321] = {.lex_state = 41, .external_lex_state = 2},
  [322] = {.lex_state = 41, .external_lex_state = 2},
  [323] = {.lex_state = 41, .external_lex_state = 2},
  [324] = {.lex_state = 41, .external_lex_state = 3},
  [325] = {.lex_state = 41, .external_lex_state = 3},
  [326] = {.lex_state = 41, .external_lex_state = 3},
  [327] = {.lex_state = 41, .external_lex_state = 3},
  [328] = {.lex_state = 41, .external_lex_state = 3},
  [329] = {.lex_state = 41, .external_lex_state = 3},
  [330] = {.lex_state = 41, .external_lex_state = 3},
  [331] = {.lex_state = 41, .external_lex_state = 2},
  [332] = {.lex_state = 41, .external_lex_state = 2},
  [333] = {.lex_state = 41, .external_lex_state = 2},
  [334] = {.lex_state = 41, .external_lex_state = 2},
  [335] = {.lex_state = 41, .external_lex_state = 2},
  [336] = {.lex_state = 41, .external_lex_state = 2},
  [337] = {.lex_state = 41, .external_lex_state = 2},
  [338] = {.lex_state = 41, .external_lex_state = 2},
  [339] = {.lex_state = 41, .external_lex_state = 2},
  [340] = {.lex_state = 41, .external_lex_state = 2},
  [341] = {.lex_state = 41, .external_lex_state = 2},
  [342] = {.lex_state = 41, .external_lex_state = 2},
  [343] = {.lex_state = 41, .external_lex_state = 2},
  [344] = {.lex_state = 41, .external_lex_state = 2},
  [345] = {.lex_state = 41, .external_lex_state = 2},
  [346] = {.lex_state = 41, .external_lex_state = 2},
  [347] = {.lex_state = 41, .external_lex_state = 2},
  [348] = {.lex_state = 41, .external_lex_state = 2},
  [349] = {.lex_state = 41, .external_lex_state = 2},
  [350] = {.lex_state = 41, .external_lex_state = 2},
  [351] = {.lex_state = 41, .external_lex_state = 2},
  [352] = {.lex_state = 41, .external_lex_state = 2},
  [353] = {.lex_state = 41, .external_lex_state = 2},
  [354] = {.lex_state = 41, .external_lex_state = 2},
  [355] = {.lex_state = 41, .external_lex_state = 2},
  [356] = {.lex_state = 41, .external_lex_state = 2},
  [357] = {.lex_state = 41, .external_lex_state = 2},
  [358] = {.lex_state = 41, .external_lex_state = 2},
  [359] = {.lex_state = 41, .external_lex_state = 2},
  [360] = {.lex_state = 41, .external_lex_state = 2},
  [361] = {.lex_state = 41, .external_lex_state = 2},
  [362] = {.lex_state = 41, .external_lex_state = 2},
  [363] = {.lex_state = 41, .external_lex_state = 2},
  [364] = {.lex_state = 41, .external_lex_state = 2},
  [365] = {.lex_state = 41, .external_lex_state = 2},
  [366] = {.lex_state = 41, .external_lex_state = 2},
  [367] = {.lex_state = 41, .external_lex_state = 2},
  [368] = {.lex_state = 41, .external_lex_state = 2},
  [369] = {.lex_state = 41, .external_lex_state = 2},
  [370] = {.lex_state = 41, .external_lex_state = 2},
  [371] = {.lex_state = 41, .external_lex_state = 2},
  [372] = {.lex_state = 41, .external_lex_state = 2},
  [373] = {.lex_state = 41, .external_lex_state = 2},
  [374] = {.lex_state = 41, .external_lex_state = 2},
  [375] = {.lex_state = 41, .external_lex_state = 2},
  [376] = {.lex_state = 41, .external_lex_state = 2},
  [377] = {.lex_state = 41, .external_lex_state = 2},
  [378] = {.lex_state = 41, .external_lex_state = 2},
  [379] = {.lex_state = 41, .external_lex_state = 2},
  [380] = {.lex_state = 41, .external_lex_state = 2},
  [381] = {.lex_state = 41, .external_lex_state = 2},
  [382] = {.lex_state = 41, .external_lex_state = 2},
  [383] = {.lex_state = 41, .external_lex_state = 2},
  [384] = {.lex_state = 41, .external_lex_state = 2},
  [385] = {.lex_state = 41, .external_lex_state = 2},
  [386] = {.lex_state = 41, .external_lex_state = 2},
  [387] = {.lex_state = 41, .external_lex_state = 2},
  [388] = {.lex_state = 41, .external_lex_state = 2},
  [389] = {.lex_state = 41, .external_lex_state = 2},
  [390] = {.lex_state = 41, .external_lex_state = 2},
  [391] = {.lex_state = 41, .external_lex_state = 2},
  [392] = {.lex_state = 41, .external_lex_state = 2},
  [393] = {.lex_state = 41, .external_lex_state = 2},
  [394] = {.lex_state = 41, .external_lex_state = 2},
  [395] = {.lex_state = 41, .external_lex_state = 2},
  [396] = {.lex_state = 41, .external_lex_state = 2},
  [397] = {.lex_state = 41, .external_lex_state = 2},
  [398] = {.lex_state = 41, .external_lex_state = 2},
  [399] = {.lex_state = 41, .external_lex_state = 2},
  [400] = {.lex_state = 41, .external_lex_state = 2},
  [401] = {.lex_state = 41, .external_lex_state = 2},
  [402] = {.lex_state = 41, .external_lex_state = 2},
  [403] = {.lex_state = 41, .external_lex_state = 2},
  [404] = {.lex_state = 41, .external_lex_state = 2},
  [405] = {.lex_state = 41, .external_lex_state = 2},
  [406] = {.lex_state = 41, .external_lex_state = 2},
  [407] = {.lex_state = 41, .external_lex_state = 2},
  [408] = {.lex_state = 41, .external_lex_state = 2},
  [409] = {.lex_state = 41, .external_lex_state = 2},
  [410] = {.lex_state = 41, .external_lex_state = 2},
  [411] = {.lex_state = 41, .external_lex_state = 2},
  [412] = {.lex_state = 41, .external_lex_state = 2},
  [413] = {.lex_state = 41, .external_lex_state = 2},
  [414] = {.lex_state = 41, .external_lex_state = 2},
  [415] = {.lex_state = 41, .external_lex_state = 2},
  [416] = {.lex_state = 41, .external_lex_state = 2},
  [417] = {.lex_state = 41, .external_lex_state = 2},
  [418] = {.lex_state = 41, .external_lex_state = 2},
  [419] = {.lex_state = 41, .external_lex_state = 2},
  [420] = {.lex_state = 41, .external_lex_state = 2},
  [421] = {.lex_state = 41, .external_lex_state = 2},
  [422] = {.lex_state = 41, .external_lex_state = 2},
  [423] = {.lex_state = 41, .external_lex_state = 2},
  [424] = {.lex_state = 41, .external_lex_state = 2},
  [425] = {.lex_state = 41, .external_lex_state = 2},
  [426] = {.lex_state = 41, .external_lex_state = 2},
  [427] = {.lex_state = 41, .external_lex_state = 2},
  [428] = {.lex_state = 41, .external_lex_state = 2},
  [429] = {.lex_state = 41, .external_lex_state = 2},
  [430] = {.lex_state = 41, .external_lex_state = 2},
  [431] = {.lex_state = 41, .external_lex_state = 2},
  [432] = {.lex_state = 41, .external_lex_state = 2},
  [433] = {.lex_state = 41, .external_lex_state = 2},
  [434] = {.lex_state = 41, .external_lex_state = 2},
  [435] = {.lex_state = 41, .external_lex_state = 2},
  [436] = {.lex_state = 41, .external_lex_state = 2},
  [437] = {.lex_state = 41, .external_lex_state = 2},
  [438] = {.lex_state = 41, .external_lex_state = 2},
  [439] = {.lex_state = 41, .external_lex_state = 2},
  [440] = {.lex_state = 41, .external_lex_state = 2},
  [441] = {.lex_state = 41, .external_lex_state = 2},
  [442] = {.lex_state = 41, .external_lex_state = 2},
  [443] = {.lex_state = 41, .external_lex_state = 2},
  [444] = {.lex_state = 41, .external_lex_state = 2},
  [445] = {.lex_state = 41, .external_lex_state = 2},
  [446] = {.lex_state = 41, .external_lex_state = 2},
  [447] = {.lex_state = 41, .external_lex_state = 2},
  [448] = {.lex_state = 41, .external_lex_state = 2},
  [449] = {.lex_state = 41, .external_lex_state = 2},
  [450] = {.lex_state = 44, .external_lex_state = 2},
  [451] = {.lex_state = 41, .external_lex_state = 2},
  [452] = {.lex_state = 41, .external_lex_state = 2},
  [453] = {.lex_state = 41, .external_lex_state = 2},
  [454] = {.lex_state = 41, .external_lex_state = 2},
  [455] = {.lex_state = 41, .external_lex_state = 2},
  [456] = {.lex_state = 44, .external_lex_state = 2},
  [457] = {.lex_state = 41, .external_lex_state = 2},
  [458] = {.lex_state = 41, .external_lex_state = 2},
  [459] = {.lex_state = 41, .external_lex_state = 2},
  [460] = {.lex_state = 41, .external_lex_state = 2},
  [461] = {.lex_state = 41, .external_lex_state = 2},
  [462] = {.lex_state = 41, .external_lex_state = 2},
  [463] = {.lex_state = 41, .external_lex_state = 2},
  [464] = {.lex_state = 41, .external_lex_state = 2},
  [465] = {.lex_state = 41, .external_lex_state = 2},
  [466] = {.lex_state = 41, .external_lex_state = 2},
  [467] = {.lex_state = 44, .external_lex_state = 2},
  [468] = {.lex_state = 41, .external_lex_state = 2},
  [469] = {.lex_state = 44, .external_lex_state = 2},
  [470] = {.lex_state = 41, .external_lex_state = 2},
  [471] = {.lex_state = 41, .external_lex_state = 2},
  [472] = {.lex_state = 41, .external_lex_state = 3},
  [473] = {.lex_state = 41, .external_lex_state = 2},
  [474] = {.lex_state = 41, .external_lex_state = 2},
  [475] = {.lex_state = 41, .external_lex_state = 2},
  [476] = {.lex_state = 41, .external_lex_state = 2},
  [477] = {.lex_state = 41, .external_lex_state = 2},
  [478] = {.lex_state = 44, .external_lex_state = 2},
  [479] = {.lex_state = 44, .external_lex_state = 2},
  [480] = {.lex_state = 41, .external_lex_state = 2},
  [481] = {.lex_state = 41, .external_lex_state = 2},
  [482] = {.lex_state = 41, .external_lex_state = 2},
  [483] = {.lex_state = 41, .external_lex_state = 3},
  [484] = {.lex_state = 41, .external_lex_state = 2},
  [485] = {.lex_state = 41, .external_lex_state = 2},
  [486] = {.lex_state = 41, .external_lex_state = 2},
  [487] = {.lex_state = 41, .external_lex_state = 2},
  [488] = {.lex_state = 41, .external_lex_state = 2},
  [489] = {.lex_state = 41, .external_lex_state = 2},
  [490] = {.lex_state = 44, .external_lex_state = 2},
  [491] = {.lex_state = 41, .external_lex_state = 2},
  [492] = {.lex_state = 41, .external_lex_state = 2},
  [493] = {.lex_state = 41, .external_lex_state = 2},
  [494] = {.lex_state = 41, .external_lex_state = 2},
  [495] = {.lex_state = 41, .external_lex_state = 3},
  [496] = {.lex_state = 41, .external_lex_state = 3},
  [497] = {.lex_state = 41, .external_lex_state = 3},
  [498] = {.lex_state = 41, .external_lex_state = 3},
  [499] = {.lex_state = 41, .external_lex_state = 3},
  [500] = {.lex_state = 44, .external_lex_state = 2},
  [501] = {.lex_state = 41, .external_lex_state = 2},
  [502] = {.lex_state = 41, .external_lex_state = 2},
  [503] = {.lex_state = 41, .external_lex_state = 2},
  [504] = {.lex_state = 41, .external_lex_state = 2},
  [505] = {.lex_state = 41, .external_lex_state = 2},
  [506] = {.lex_state = 41, .external_lex_state = 2},
  [507] = {.lex_state = 41, .external_lex_state = 2},
  [508] = {.lex_state = 41, .external_lex_state = 2},
  [509] = {.lex_state = 41, .external_lex_state = 2},
  [510] = {.lex_state = 41, .external_lex_state = 2},
  [511] = {.lex_state = 41, .external_lex_state = 2},
  [512] = {.lex_state = 41, .external_lex_state = 2},
  [513] = {.lex_state = 41, .external_lex_state = 2},
  [514] = {.lex_state = 41, .external_lex_state = 2},
  [515] = {.lex_state = 41, .external_lex_state = 2},
  [516] = {.lex_state = 41, .external_lex_state = 2},
  [517] = {.lex_state = 41, .external_lex_state = 2},
  [518] = {.lex_state = 41, .external_lex_state = 2},
  [519] = {.lex_state = 41, .external_lex_state = 2},
  [520] = {.lex_state = 41, .external_lex_state = 2},
  [521] = {.lex_state = 41, .external_lex_state = 2},
  [522] = {.lex_state = 41, .external_lex_state = 2},
  [523] = {.lex_state = 41, .external_lex_state = 2},
  [524] = {.lex_state = 41, .external_lex_state = 2},
  [525] = {.lex_state = 41, .external_lex_state = 2},
  [526] = {.lex_state = 41, .external_lex_state = 2},
  [527] = {.lex_state = 41, .external_lex_state = 2},
  [528] = {.lex_state = 41, .external_lex_state = 2},
  [529] = {.lex_state = 41, .external_lex_state = 2},
  [530] = {.lex_state = 41, .external_lex_state = 2},
  [531] = {.lex_state = 41, .external_lex_state = 2},
  [532] = {.lex_state = 41, .external_lex_state = 2},
  [533] = {.lex_state = 41, .external_lex_state = 2},
  [534] = {.lex_state = 41, .external_lex_state = 2},
  [535] = {.lex_state = 41, .external_lex_state = 2},
  [536] = {.lex_state = 41, .external_lex_state = 2},
  [537] = {.lex_state = 41, .external_lex_state = 2},
  [538] = {.lex_state = 41, .external_lex_state = 2},
  [539] = {.lex_state = 41, .external_lex_state = 2},
  [540] = {.lex_state = 41, .external_lex_state = 2},
  [541] = {.lex_state = 41, .external_lex_state = 2},
  [542] = {.lex_state = 41, .external_lex_state = 2},
  [543] = {.lex_state = 41, .external_lex_state = 2},
  [544] = {.lex_state = 41, .external_lex_state = 2},
  [545] = {.lex_state = 41, .external_lex_state = 2},
  [546] = {.lex_state = 41, .external_lex_state = 2},
  [547] = {.lex_state = 41, .external_lex_state = 2},
  [548] = {.lex_state = 41, .external_lex_state = 2},
  [549] = {.lex_state = 41, .external_lex_state = 2},
  [550] = {.lex_state = 41, .external_lex_state = 2},
  [551] = {.lex_state = 41, .external_lex_state = 2},
  [552] = {.lex_state = 41, .external_lex_state = 2},
  [553] = {.lex_state = 41, .external_lex_state = 2},
  [554] = {.lex_state = 41, .external_lex_state = 2},
  [555] = {.lex_state = 41, .external_lex_state = 2},
  [556] = {.lex_state = 41, .external_lex_state = 2},
  [557] = {.lex_state = 41, .external_lex_state = 2},
  [558] = {.lex_state = 41, .external_lex_state = 2},
  [559] = {.lex_state = 41, .external_lex_state = 2},
  [560] = {.lex_state = 41, .external_lex_state = 2},
  [561] = {.lex_state = 41, .external_lex_state = 2},
  [562] = {.lex_state = 41, .external_lex_state = 2},
  [563] = {.lex_state = 41, .external_lex_state = 2},
  [564] = {.lex_state = 41, .external_lex_state = 2},
  [565] = {.lex_state = 41, .external_lex_state = 2},
  [566] = {.lex_state = 41, .external_lex_state = 2},
  [567] = {.lex_state = 41, .external_lex_state = 2},
  [568] = {.lex_state = 41, .external_lex_state = 2},
  [569] = {.lex_state = 41, .external_lex_state = 2},
  [570] = {.lex_state = 41, .external_lex_state = 2},
  [571] = {.lex_state = 41, .external_lex_state = 2},
  [572] = {.lex_state = 41, .external_lex_state = 2},
  [573] = {.lex_state = 41, .external_lex_state = 2},
  [574] = {.lex_state = 44, .external_lex_state = 2},
  [575] = {.lex_state = 44, .external_lex_state = 2},
  [576] = {.lex_state = 44, .external_lex_state = 2},
  [577] = {.lex_state = 44, .external_lex_state = 2},
  [578] = {.lex_state = 41, .external_lex_state = 2},
  [579] = {.lex_state = 41, .external_lex_state = 2},
  [580] = {.lex_state = 41, .external_lex_state = 2},
  [581] = {.lex_state = 41, .external_lex_state = 2},
  [582] = {.lex_state = 44, .external_lex_state = 2},
  [583] = {.lex_state = 44, .external_lex_state = 2},
  [584] = {.lex_state = 44, .external_lex_state = 2},
  [585] = {.lex_state = 44, .external_lex_state = 2},
  [586] = {.lex_state = 44, .external_lex_state = 2},
  [587] = {.lex_state = 44, .external_lex_state = 2},
  [588] = {.lex_state = 44, .external_lex_state = 2},
  [589] = {.lex_state = 44, .external_lex_state = 2},
  [590] = {.lex_state = 44, .external_lex_state = 2},
  [591] = {.lex_state = 44, .external_lex_state = 2},
  [592] = {.lex_state = 44, .external_lex_state = 2},
  [593] = {.lex_state = 44, .external_lex_state = 2},
  [594] = {.lex_state = 44, .external_lex_state = 2},
  [595] = {.lex_state = 44, .external_lex_state = 2},
  [596] = {.lex_state = 44, .external_lex_state = 2},
  [597] = {.lex_state = 44, .external_lex_state = 2},
  [598] = {.lex_state = 44, .external_lex_state = 2},
  [599] = {.lex_state = 44, .external_lex_state = 2},
  [600] = {.lex_state = 44, .external_lex_state = 2},
  [601] = {.lex_state = 44, .external_lex_state = 2},
  [602] = {.lex_state = 44, .external_lex_state = 2},
  [603] = {.lex_state = 44, .external_lex_state = 2},
  [604] = {.lex_state = 44, .external_lex_state = 2},
  [605] = {.lex_state = 44, .external_lex_state = 2},
  [606] = {.lex_state = 44, .external_lex_state = 2},
  [607] = {.lex_state = 44, .external_lex_state = 2},
  [608] = {.lex_state = 44, .external_lex_state = 2},
  [609] = {.lex_state = 44, .external_lex_state = 2},
  [610] = {.lex_state = 44, .external_lex_state = 2},
  [611] = {.lex_state = 44, .external_lex_state = 2},
  [612] = {.lex_state = 44, .external_lex_state = 2},
  [613] = {.lex_state = 44, .external_lex_state = 2},
  [614] = {.lex_state = 44, .external_lex_state = 2},
  [615] = {.lex_state = 44, .external_lex_state = 2},
  [616] = {.lex_state = 44, .external_lex_state = 2},
  [617] = {.lex_state = 44, .external_lex_state = 2},
  [618] = {.lex_state = 44, .external_lex_state = 2},
  [619] = {.lex_state = 44, .external_lex_state = 2},
  [620] = {.lex_state = 44, .external_lex_state = 2},
  [621] = {.lex_state = 44, .external_lex_state = 2},
  [622] = {.lex_state = 44, .external_lex_state = 2},
  [623] = {.lex_state = 44, .external_lex_state = 2},
  [624] = {.lex_state = 44, .external_lex_state = 2},
  [625] = {.lex_state = 44, .external_lex_state = 2},
  [626] = {.lex_state = 44, .external_lex_state = 2},
  [627] = {.lex_state = 44, .external_lex_state = 2},
  [628] = {.lex_state = 44, .external_lex_state = 2},
  [629] = {.lex_state = 44, .external_lex_state = 2},
  [630] = {.lex_state = 44, .external_lex_state = 2},
  [631] = {.lex_state = 44, .external_lex_state = 2},
  [632] = {.lex_state = 44, .external_lex_state = 2},
  [633] = {.lex_state = 44, .external_lex_state = 2},
  [634] = {.lex_state = 44, .external_lex_state = 2},
  [635] = {.lex_state = 44, .external_lex_state = 2},
  [636] = {.lex_state = 44, .external_lex_state = 2},
  [637] = {.lex_state = 44, .external_lex_state = 2},
  [638] = {.lex_state = 44, .external_lex_state = 2},
  [639] = {.lex_state = 44, .external_lex_state = 2},
  [640] = {.lex_state = 44, .external_lex_state = 2},
  [641] = {.lex_state = 44, .external_lex_state = 2},
  [642] = {.lex_state = 44, .external_lex_state = 2},
  [643] = {.lex_state = 44, .external_lex_state = 2},
  [644] = {.lex_state = 44, .external_lex_state = 2},
  [645] = {.lex_state = 44, .external_lex_state = 2},
  [646] = {.lex_state = 44, .external_lex_state = 2},
  [647] = {.lex_state = 44, .external_lex_state = 2},
  [648] = {.lex_state = 44, .external_lex_state = 2},
  [649] = {.lex_state = 44, .external_lex_state = 2},
  [650] = {.lex_state = 44, .external_lex_state = 2},
  [651] = {.lex_state = 44, .external_lex_state = 2},
  [652] = {.lex_state = 44, .external_lex_state = 2},
  [653] = {.lex_state = 44, .external_lex_state = 2},
  [654] = {.lex_state = 44, .external_lex_state = 2},
  [655] = {.lex_state = 44, .external_lex_state = 2},
  [656] = {.lex_state = 44, .external_lex_state = 2},
  [657] = {.lex_state = 44, .external_lex_state = 2},
  [658] = {.lex_state = 44, .external_lex_state = 2},
  [659] = {.lex_state = 44, .external_lex_state = 2},
  [660] = {.lex_state = 44, .external_lex_state = 2},
  [661] = {.lex_state = 44, .external_lex_state = 2},
  [662] = {.lex_state = 44, .external_lex_state = 2},
  [663] = {.lex_state = 44, .external_lex_state = 2},
  [664] = {.lex_state = 44, .external_lex_state = 2},
  [665] = {.lex_state = 44, .external_lex_state = 2},
  [666] = {.lex_state = 44, .external_lex_state = 2},
  [667] = {.lex_state = 44, .external_lex_state = 2},
  [668] = {.lex_state = 44, .external_lex_state = 2},
  [669] = {.lex_state = 44, .external_lex_state = 2},
  [670] = {.lex_state = 44, .external_lex_state = 2},
  [671] = {.lex_state = 44, .external_lex_state = 2},
  [672] = {.lex_state = 44, .external_lex_state = 2},
  [673] = {.lex_state = 44, .external_lex_state = 2},
  [674] = {.lex_state = 44, .external_lex_state = 2},
  [675] = {.lex_state = 44, .external_lex_state = 2},
  [676] = {.lex_state = 44, .external_lex_state = 2},
  [677] = {.lex_state = 44, .external_lex_state = 2},
  [678] = {.lex_state = 44, .external_lex_state = 2},
  [679] = {.lex_state = 44, .external_lex_state = 2},
  [680] = {.lex_state = 44, .external_lex_state = 2},
  [681] = {.lex_state = 44, .external_lex_state = 2},
  [682] = {.lex_state = 44, .external_lex_state = 2},
  [683] = {.lex_state = 44, .external_lex_state = 2},
  [684] = {.lex_state = 44, .external_lex_state = 2},
  [685] = {.lex_state = 44, .external_lex_state = 2},
  [686] = {.lex_state = 44, .external_lex_state = 2},
  [687] = {.lex_state = 44, .external_lex_state = 2},
  [688] = {.lex_state = 44, .external_lex_state = 2},
  [689] = {.lex_state = 44, .external_lex_state = 2},
  [690] = {.lex_state = 44, .external_lex_state = 2},
  [691] = {.lex_state = 44, .external_lex_state = 2},
  [692] = {.lex_state = 44, .external_lex_state = 2},
  [693] = {.lex_state = 44, .external_lex_state = 2},
  [694] = {.lex_state = 44, .external_lex_state = 2},
  [695] = {.lex_state = 44, .external_lex_state = 2},
  [696] = {.lex_state = 44, .external_lex_state = 2},
  [697] = {.lex_state = 44, .external_lex_state = 2},
  [698] = {.lex_state = 44, .external_lex_state = 2},
  [699] = {.lex_state = 44, .external_lex_state = 2},
  [700] = {.lex_state = 44, .external_lex_state = 2},
  [701] = {.lex_state = 44, .external_lex_state = 2},
  [702] = {.lex_state = 44, .external_lex_state = 2},
  [703] = {.lex_state = 44, .external_lex_state = 2},
  [704] = {.lex_state = 44, .external_lex_state = 2},
  [705] = {.lex_state = 44, .external_lex_state = 2},
  [706] = {.lex_state = 44, .external_lex_state = 2},
  [707] = {.lex_state = 44, .external_lex_state = 2},
  [708] = {.lex_state = 44, .external_lex_state = 2},
  [709] = {.lex_state = 44, .external_lex_state = 2},
  [710] = {.lex_state = 44, .external_lex_state = 2},
  [711] = {.lex_state = 44, .external_lex_state = 2},
  [712] = {.lex_state = 44, .external_lex_state = 2},
  [713] = {.lex_state = 44, .external_lex_state = 2},
  [714] = {.lex_state = 44, .external_lex_state = 2},
  [715] = {.lex_state = 44, .external_lex_state = 2},
  [716] = {.lex_state = 44, .external_lex_state = 2},
  [717] = {.lex_state = 44, .external_lex_state = 2},
  [718] = {.lex_state = 44, .external_lex_state = 2},
  [719] = {.lex_state = 44, .external_lex_state = 2},
  [720] = {.lex_state = 44, .external_lex_state = 2},
  [721] = {.lex_state = 44, .external_lex_state = 2},
  [722] = {.lex_state = 44, .external_lex_state = 2},
  [723] = {.lex_state = 44, .external_lex_state = 2},
  [724] = {.lex_state = 44, .external_lex_state = 2},
  [725] = {.lex_state = 44, .external_lex_state = 2},
  [726] = {.lex_state = 44, .external_lex_state = 2},
  [727] = {.lex_state = 44, .external_lex_state = 2},
  [728] = {.lex_state = 44, .external_lex_state = 2},
  [729] = {.lex_state = 44, .external_lex_state = 2},
  [730] = {.lex_state = 44, .external_lex_state = 2},
  [731] = {.lex_state = 44, .external_lex_state = 2},
  [732] = {.lex_state = 44, .external_lex_state = 2},
  [733] = {.lex_state = 44, .external_lex_state = 2},
  [734] = {.lex_state = 44, .external_lex_state = 2},
  [735] = {.lex_state = 44, .external_lex_state = 2},
  [736] = {.lex_state = 44, .external_lex_state = 2},
  [737] = {.lex_state = 44, .external_lex_state = 2},
  [738] = {.lex_state = 44, .external_lex_state = 2},
  [739] = {.lex_state = 44, .external_lex_state = 2},
  [740] = {.lex_state = 44, .external_lex_state = 2},
  [741] = {.lex_state = 44, .external_lex_state = 2},
  [742] = {.lex_state = 44, .external_lex_state = 2},
  [743] = {.lex_state = 44, .external_lex_state = 2},
  [744] = {.lex_state = 44, .external_lex_state = 2},
  [745] = {.lex_state = 44, .external_lex_state = 2},
  [746] = {.lex_state = 44, .external_lex_state = 2},
  [747] = {.lex_state = 44, .external_lex_state = 2},
  [748] = {.lex_state = 44, .external_lex_state = 2},
  [749] = {.lex_state = 44, .external_lex_state = 2},
  [750] = {.lex_state = 44, .external_lex_state = 2},
  [751] = {.lex_state = 44, .external_lex_state = 2},
  [752] = {.lex_state = 44, .external_lex_state = 2},
  [753] = {.lex_state = 44, .external_lex_state = 2},
  [754] = {.lex_state = 44, .external_lex_state = 2},
  [755] = {.lex_state = 44, .external_lex_state = 2},
  [756] = {.lex_state = 44, .external_lex_state = 2},
  [757] = {.lex_state = 44, .external_lex_state = 2},
  [758] = {.lex_state = 44, .external_lex_state = 2},
  [759] = {.lex_state = 44, .external_lex_state = 2},
  [760] = {.lex_state = 44, .external_lex_state = 2},
  [761] = {.lex_state = 44, .external_lex_state = 2},
  [762] = {.lex_state = 44, .external_lex_state = 2},
  [763] = {.lex_state = 44, .external_lex_state = 2},
  [764] = {.lex_state = 44, .external_lex_state = 2},
  [765] = {.lex_state = 44, .external_lex_state = 2},
  [766] = {.lex_state = 44, .external_lex_state = 2},
  [767] = {.lex_state = 44, .external_lex_state = 2},
  [768] = {.lex_state = 44, .external_lex_state = 2},
  [769] = {.lex_state = 44, .external_lex_state = 2},
  [770] = {.lex_state = 44, .external_lex_state = 2},
  [771] = {.lex_state = 44, .external_lex_state = 2},
  [772] = {.lex_state = 44, .external_lex_state = 2},
  [773] = {.lex_state = 44, .external_lex_state = 2},
  [774] = {.lex_state = 44, .external_lex_state = 2},
  [775] = {.lex_state = 44, .external_lex_state = 2},
  [776] = {.lex_state = 44, .external_lex_state = 2},
  [777] = {.lex_state = 44, .external_lex_state = 2},
  [778] = {.lex_state = 44, .external_lex_state = 2},
  [779] = {.lex_state = 44, .external_lex_state = 2},
  [780] = {.lex_state = 44, .external_lex_state = 2},
  [781] = {.lex_state = 44, .external_lex_state = 2},
  [782] = {.lex_state = 44, .external_lex_state = 2},
  [783] = {.lex_state = 44, .external_lex_state = 2},
  [784] = {.lex_state = 44, .external_lex_state = 2},
  [785] = {.lex_state = 44, .external_lex_state = 2},
  [786] = {.lex_state = 44, .external_lex_state = 2},
  [787] = {.lex_state = 44, .external_lex_state = 2},
  [788] = {.lex_state = 44, .external_lex_state = 2},
  [789] = {.lex_state = 44, .external_lex_state = 2},
  [790] = {.lex_state = 44, .external_lex_state = 2},
  [791] = {.lex_state = 44, .external_lex_state = 2},
  [792] = {.lex_state = 44, .external_lex_state = 2},
  [793] = {.lex_state = 44, .external_lex_state = 2},
  [794] = {.lex_state = 44, .external_lex_state = 2},
  [795] = {.lex_state = 44, .external_lex_state = 2},
  [796] = {.lex_state = 44, .external_lex_state = 2},
  [797] = {.lex_state = 44, .external_lex_state = 2},
  [798] = {.lex_state = 44, .external_lex_state = 2},
  [799] = {.lex_state = 44, .external_lex_state = 2},
  [800] = {.lex_state = 44, .external_lex_state = 2},
  [801] = {.lex_state = 44, .external_lex_state = 2},
  [802] = {.lex_state = 44, .external_lex_state = 2},
  [803] = {.lex_state = 44, .external_lex_state = 2},
  [804] = {.lex_state = 44, .external_lex_state = 2},
  [805] = {.lex_state = 44, .external_lex_state = 2},
  [806] = {.lex_state = 44, .external_lex_state = 2},
  [807] = {.lex_state = 44, .external_lex_state = 2},
  [808] = {.lex_state = 44, .external_lex_state = 2},
  [809] = {.lex_state = 44, .external_lex_state = 2},
  [810] = {.lex_state = 44, .external_lex_state = 2},
  [811] = {.lex_state = 44, .external_lex_state = 2},
  [812] = {.lex_state = 44, .external_lex_state = 2},
  [813] = {.lex_state = 44, .external_lex_state = 2},
  [814] = {.lex_state = 44, .external_lex_state = 2},
  [815] = {.lex_state = 44, .external_lex_state = 2},
  [816] = {.lex_state = 44, .external_lex_state = 2},
  [817] = {.lex_state = 44, .external_lex_state = 2},
  [818] = {.lex_state = 44, .external_lex_state = 2},
  [819] = {.lex_state = 44, .external_lex_state = 2},
  [820] = {.lex_state = 44, .external_lex_state = 2},
  [821] = {.lex_state = 44, .external_lex_state = 2},
  [822] = {.lex_state = 44, .external_lex_state = 2},
  [823] = {.lex_state = 44, .external_lex_state = 2},
  [824] = {.lex_state = 44, .external_lex_state = 2},
  [825] = {.lex_state = 44, .external_lex_state = 2},
  [826] = {.lex_state = 44, .external_lex_state = 2},
  [827] = {.lex_state = 44, .external_lex_state = 2},
  [828] = {.lex_state = 44, .external_lex_state = 2},
  [829] = {.lex_state = 44, .external_lex_state = 2},
  [830] = {.lex_state = 44, .external_lex_state = 2},
  [831] = {.lex_state = 44, .external_lex_state = 2},
  [832] = {.lex_state = 44, .external_lex_state = 2},
  [833] = {.lex_state = 44, .external_lex_state = 2},
  [834] = {.lex_state = 44, .external_lex_state = 2},
  [835] = {.lex_state = 44, .external_lex_state = 2},
  [836] = {.lex_state = 44, .external_lex_state = 2},
  [837] = {.lex_state = 44, .external_lex_state = 2},
  [838] = {.lex_state = 44, .external_lex_state = 2},
  [839] = {.lex_state = 44, .external_lex_state = 2},
  [840] = {.lex_state = 44, .external_lex_state = 2},
  [841] = {.lex_state = 44, .external_lex_state = 2},
  [842] = {.lex_state = 44, .external_lex_state = 2},
  [843] = {.lex_state = 44, .external_lex_state = 2},
  [844] = {.lex_state = 44, .external_lex_state = 2},
  [845] = {.lex_state = 44, .external_lex_state = 2},
  [846] = {.lex_state = 44, .external_lex_state = 2},
  [847] = {.lex_state = 44, .external_lex_state = 2},
  [848] = {.lex_state = 44, .external_lex_state = 2},
  [849] = {.lex_state = 44, .external_lex_state = 2},
  [850] = {.lex_state = 44, .external_lex_state = 2},
  [851] = {.lex_state = 44, .external_lex_state = 2},
  [852] = {.lex_state = 44, .external_lex_state = 2},
  [853] = {.lex_state = 44, .external_lex_state = 2},
  [854] = {.lex_state = 44, .external_lex_state = 2},
  [855] = {.lex_state = 44, .external_lex_state = 2},
  [856] = {.lex_state = 44, .external_lex_state = 2},
  [857] = {.lex_state = 44, .external_lex_state = 2},
  [858] = {.lex_state = 44, .external_lex_state = 2},
  [859] = {.lex_state = 41, .external_lex_state = 2},
  [860] = {.lex_state = 41, .external_lex_state = 2},
  [861] = {.lex_state = 41, .external_lex_state = 2},
  [862] = {.lex_state = 41, .external_lex_state = 2},
  [863] = {.lex_state = 41, .external_lex_state = 2},
  [864] = {.lex_state = 41, .external_lex_state = 3},
  [865] = {.lex_state = 41, .external_lex_state = 3},
  [866] = {.lex_state = 41, .external_lex_state = 2},
  [867] = {.lex_state = 41, .external_lex_state = 3},
  [868] = {.lex_state = 41, .external_lex_state = 2},
  [869] = {.lex_state = 41, .external_lex_state = 3},
  [870] = {.lex_state = 41, .external_lex_state = 2},
  [871] = {.lex_state = 41, .external_lex_state = 2},
  [872] = {.lex_state = 41, .external_lex_state = 2},
  [873] = {.lex_state = 41, .external_lex_state = 2},
  [874] = {.lex_state = 41, .external_lex_state = 2},
  [875] = {.lex_state = 41, .external_lex_state = 2},
  [876] = {.lex_state = 41, .external_lex_state = 2},
  [877] = {.lex_state = 41, .external_lex_state = 2},
  [878] = {.lex_state = 41, .external_lex_state = 2},
  [879] = {.lex_state = 41, .external_lex_state = 2},
  [880] = {.lex_state = 41, .external_lex_state = 2},
  [881] = {.lex_state = 41, .external_lex_state = 2},
  [882] = {.lex_state = 41, .external_lex_state = 2},
  [883] = {.lex_state = 41, .external_lex_state = 2},
  [884] = {.lex_state = 41, .external_lex_state = 2},
  [885] = {.lex_state = 41, .external_lex_state = 2},
  [886] = {.lex_state = 41, .external_lex_state = 2},
  [887] = {.lex_state = 41, .external_lex_state = 2},
  [888] = {.lex_state = 41, .external_lex_state = 2},
  [889] = {.lex_state = 41, .external_lex_state = 2},
  [890] = {.lex_state = 41, .external_lex_state = 2},
  [891] = {.lex_state = 41, .external_lex_state = 2},
  [892] = {.lex_state = 41, .external_lex_state = 2},
  [893] = {.lex_state = 41, .external_lex_state = 2},
  [894] = {.lex_state = 41, .external_lex_state = 2},
  [895] = {.lex_state = 41, .external_lex_state = 2},
  [896] = {.lex_state = 41, .external_lex_state = 2},
  [897] = {.lex_state = 41, .external_lex_state = 2},
  [898] = {.lex_state = 41, .external_lex_state = 2},
  [899] = {.lex_state = 41, .external_lex_state = 2},
  [900] = {.lex_state = 41, .external_lex_state = 2},
  [901] = {.lex_state = 41, .external_lex_state = 2},
  [902] = {.lex_state = 41, .external_lex_state = 2},
  [903] = {.lex_state = 41, .external_lex_state = 2},
  [904] = {.lex_state = 41, .external_lex_state = 2},
  [905] = {.lex_state = 41, .external_lex_state = 2},
  [906] = {.lex_state = 41, .external_lex_state = 2},
  [907] = {.lex_state = 41, .external_lex_state = 2},
  [908] = {.lex_state = 41, .external_lex_state = 2},
  [909] = {.lex_state = 41, .external_lex_state = 2},
  [910] = {.lex_state = 41, .external_lex_state = 2},
  [911] = {.lex_state = 41, .external_lex_state = 2},
  [912] = {.lex_state = 41, .external_lex_state = 2},
  [913] = {.lex_state = 41, .external_lex_state = 2},
  [914] = {.lex_state = 41, .external_lex_state = 2},
  [915] = {.lex_state = 41, .external_lex_state = 2},
  [916] = {.lex_state = 41, .external_lex_state = 2},
  [917] = {.lex_state = 41, .external_lex_state = 2},
  [918] = {.lex_state = 41, .external_lex_state = 2},
  [919] = {.lex_state = 41, .external_lex_state = 2},
  [920] = {.lex_state = 41, .external_lex_state = 2},
  [921] = {.lex_state = 41, .external_lex_state = 2},
  [922] = {.lex_state = 41, .external_lex_state = 2},
  [923] = {.lex_state = 41, .external_lex_state = 2},
  [924] = {.lex_state = 41, .external_lex_state = 2},
  [925] = {.lex_state = 41, .external_lex_state = 2},
  [926] = {.lex_state = 41, .external_lex_state = 2},
  [927] = {.lex_state = 41, .external_lex_state = 2},
  [928] = {.lex_state = 41, .external_lex_state = 2},
  [929] = {.lex_state = 41, .external_lex_state = 2},
  [930] = {.lex_state = 41, .external_lex_state = 2},
  [931] = {.lex_state = 41, .external_lex_state = 2},
  [932] = {.lex_state = 41, .external_lex_state = 2},
  [933] = {.lex_state = 41, .external_lex_state = 2},
  [934] = {.lex_state = 41, .external_lex_state = 2},
  [935] = {.lex_state = 41, .external_lex_state = 2},
  [936] = {.lex_state = 41, .external_lex_state = 2},
  [937] = {.lex_state = 41, .external_lex_state = 2},
  [938] = {.lex_state = 41, .external_lex_state = 2},
  [939] = {.lex_state = 41, .external_lex_state = 2},
  [940] = {.lex_state = 41, .external_lex_state = 2},
  [941] = {.lex_state = 41, .external_lex_state = 2},
  [942] = {.lex_state = 41, .external_lex_state = 2},
  [943] = {.lex_state = 41, .external_lex_state = 2},
  [944] = {.lex_state = 41, .external_lex_state = 2},
  [945] = {.lex_state = 41, .external_lex_state = 2},
  [946] = {.lex_state = 41, .external_lex_state = 2},
  [947] = {.lex_state = 41, .external_lex_state = 2},
  [948] = {.lex_state = 41, .external_lex_state = 2},
  [949] = {.lex_state = 41, .external_lex_state = 2},
  [950] = {.lex_state = 41, .external_lex_state = 2},
  [951] = {.lex_state = 41, .external_lex_state = 2},
  [952] = {.lex_state = 41, .external_lex_state = 2},
  [953] = {.lex_state = 41, .external_lex_state = 2},
  [954] = {.lex_state = 41, .external_lex_state = 2},
  [955] = {.lex_state = 41, .external_lex_state = 2},
  [956] = {.lex_state = 41, .external_lex_state = 2},
  [957] = {.lex_state = 41, .external_lex_state = 2},
  [958] = {.lex_state = 41, .external_lex_state = 3},
  [959] = {.lex_state = 41, .external_lex_state = 3},
  [960] = {.lex_state = 41, .external_lex_state = 2},
  [961] = {.lex_state = 41, .external_lex_state = 2},
  [962] = {.lex_state = 41, .external_lex_state = 2},
  [963] = {.lex_state = 41, .external_lex_state = 2},
  [964] = {.lex_state = 41, .external_lex_state = 2},
  [965] = {.lex_state = 41, .external_lex_state = 3},
  [966] = {.lex_state = 41, .external_lex_state = 3},
  [967] = {.lex_state = 41, .external_lex_state = 2},
  [968] = {.lex_state = 41, .external_lex_state = 3},
  [969] = {.lex_state = 41, .external_lex_state = 2},
  [970] = {.lex_state = 41, .external_lex_state = 3},
  [971] = {.lex_state = 41, .external_lex_state = 2},
  [972] = {.lex_state = 41, .external_lex_state = 3},
  [973] = {.lex_state = 41, .external_lex_state = 2},
  [974] = {.lex_state = 41, .external_lex_state = 2},
  [975] = {.lex_state = 41, .external_lex_state = 2},
  [976] = {.lex_state = 41, .external_lex_state = 2},
  [977] = {.lex_state = 41, .external_lex_state = 2},
  [978] = {.lex_state = 41, .external_lex_state = 2},
  [979] = {.lex_state = 41, .external_lex_state = 2},
  [980] = {.lex_state = 41, .external_lex_state = 2},
  [981] = {.lex_state = 41, .external_lex_state = 2},
  [982] = {.lex_state = 41, .external_lex_state = 2},
  [983] = {.lex_state = 41, .external_lex_state = 2},
  [984] = {.lex_state = 41, .external_lex_state = 2},
  [985] = {.lex_state = 41, .external_lex_state = 2},
  [986] = {.lex_state = 41, .external_lex_state = 2},
  [987] = {.lex_state = 41, .external_lex_state = 2},
  [988] = {.lex_state = 41, .external_lex_state = 2},
  [989] = {.lex_state = 41, .external_lex_state = 2},
  [990] = {.lex_state = 41, .external_lex_state = 2},
  [991] = {.lex_state = 41, .external_lex_state = 2},
  [992] = {.lex_state = 41, .external_lex_state = 2},
  [993] = {.lex_state = 41, .external_lex_state = 2},
  [994] = {.lex_state = 41, .external_lex_state = 2},
  [995] = {.lex_state = 41, .external_lex_state = 2},
  [996] = {.lex_state = 41, .external_lex_state = 2},
  [997] = {.lex_state = 41, .external_lex_state = 2},
  [998] = {.lex_state = 41, .external_lex_state = 2},
  [999] = {.lex_state = 41, .external_lex_state = 2},
  [1000] = {.lex_state = 41, .external_lex_state = 2},
  [1001] = {.lex_state = 41, .external_lex_state = 2},
  [1002] = {.lex_state = 41, .external_lex_state = 2},
  [1003] = {.lex_state = 41, .external_lex_state = 2},
  [1004] = {.lex_state = 41, .external_lex_state = 2},
  [1005] = {.lex_state = 41, .external_lex_state = 2},
  [1006] = {.lex_state = 41, .external_lex_state = 2},
  [1007] = {.lex_state = 41, .external_lex_state = 2},
  [1008] = {.lex_state = 41, .external_lex_state = 2},
  [1009] = {.lex_state = 41, .external_lex_state = 2},
  [1010] = {.lex_state = 41, .external_lex_state = 2},
  [1011] = {.lex_state = 41, .external_lex_state = 2},
  [1012] = {.lex_state = 41, .external_lex_state = 2},
  [1013] = {.lex_state = 41, .external_lex_state = 2},
  [1014] = {.lex_state = 41, .external_lex_state = 2},
  [1015] = {.lex_state = 41, .external_lex_state = 2},
  [1016] = {.lex_state = 41, .external_lex_state = 2},
  [1017] = {.lex_state = 41, .external_lex_state = 2},
  [1018] = {.lex_state = 41, .external_lex_state = 2},
  [1019] = {.lex_state = 41, .external_lex_state = 2},
  [1020] = {.lex_state = 41, .external_lex_state = 2},
  [1021] = {.lex_state = 41, .external_lex_state = 2},
  [1022] = {.lex_state = 41, .external_lex_state = 2},
  [1023] = {.lex_state = 41, .external_lex_state = 2},
  [1024] = {.lex_state = 41, .external_lex_state = 2},
  [1025] = {.lex_state = 41, .external_lex_state = 2},
  [1026] = {.lex_state = 41, .external_lex_state = 2},
  [1027] = {.lex_state = 41, .external_lex_state = 2},
  [1028] = {.lex_state = 41, .external_lex_state = 2},
  [1029] = {.lex_state = 41, .external_lex_state = 2},
  [1030] = {.lex_state = 41, .external_lex_state = 2},
  [1031] = {.lex_state = 41, .external_lex_state = 2},
  [1032] = {.lex_state = 41, .external_lex_state = 2},
  [1033] = {.lex_state = 41, .external_lex_state = 2},
  [1034] = {.lex_state = 41, .external_lex_state = 2},
  [1035] = {.lex_state = 41, .external_lex_state = 2},
  [1036] = {.lex_state = 41, .external_lex_state = 2},
  [1037] = {.lex_state = 41, .external_lex_state = 2},
  [1038] = {.lex_state = 41, .external_lex_state = 2},
  [1039] = {.lex_state = 41, .external_lex_state = 2},
  [1040] = {.lex_state = 41, .external_lex_state = 2},
  [1041] = {.lex_state = 41, .external_lex_state = 2},
  [1042] = {.lex_state = 41, .external_lex_state = 2},
  [1043] = {.lex_state = 41, .external_lex_state = 2},
  [1044] = {.lex_state = 41, .external_lex_state = 2},
  [1045] = {.lex_state = 41, .external_lex_state = 2},
  [1046] = {.lex_state = 41, .external_lex_state = 2},
  [1047] = {.lex_state = 41, .external_lex_state = 2},
  [1048] = {.lex_state = 41, .external_lex_state = 2},
  [1049] = {.lex_state = 41, .external_lex_state = 2},
  [1050] = {.lex_state = 41, .external_lex_state = 2},
  [1051] = {.lex_state = 41, .external_lex_state = 2},
  [1052] = {.lex_state = 41, .external_lex_state = 2},
  [1053] = {.lex_state = 41, .external_lex_state = 2},
  [1054] = {.lex_state = 41, .external_lex_state = 2},
  [1055] = {.lex_state = 41, .external_lex_state = 2},
  [1056] = {.lex_state = 41, .external_lex_state = 2},
  [1057] = {.lex_state = 41, .external_lex_state = 2},
  [1058] = {.lex_state = 41, .external_lex_state = 2},
  [1059] = {.lex_state = 41, .external_lex_state = 2},
  [1060] = {.lex_state = 41, .external_lex_state = 2},
  [1061] = {.lex_state = 41, .external_lex_state = 2},
  [1062] = {.lex_state = 41, .external_lex_state = 2},
  [1063] = {.lex_state = 41, .external_lex_state = 2},
  [1064] = {.lex_state = 41, .external_lex_state = 2},
  [1065] = {.lex_state = 41, .external_lex_state = 2},
  [1066] = {.lex_state = 41, .external_lex_state = 2},
  [1067] = {.lex_state = 41, .external_lex_state = 2},
  [1068] = {.lex_state = 41, .external_lex_state = 2},
  [1069] = {.lex_state = 41, .external_lex_state = 2},
  [1070] = {.lex_state = 44, .external_lex_state = 3},
  [1071] = {.lex_state = 41, .external_lex_state = 2},
  [1072] = {.lex_state = 44, .external_lex_state = 3},
  [1073] = {.lex_state = 41, .external_lex_state = 2},
  [1074] = {.lex_state = 41, .external_lex_state = 2},
  [1075] = {.lex_state = 41, .external_lex_state = 2},
  [1076] = {.lex_state = 41, .external_lex_state = 2},
  [1077] = {.lex_state = 41, .external_lex_state = 2},
  [1078] = {.lex_state = 41, .external_lex_state = 2},
  [1079] = {.lex_state = 41, .external_lex_state = 2},
  [1080] = {.lex_state = 44, .external_lex_state = 3},
  [1081] = {.lex_state = 44, .external_lex_state = 3},
  [1082] = {.lex_state = 44, .external_lex_state = 2},
  [1083] = {.lex_state = 44, .external_lex_state = 2},
  [1084] = {.lex_state = 44, .external_lex_state = 2},
  [1085] = {.lex_state = 44, .external_lex_state = 2},
  [1086] = {.lex_state = 44, .external_lex_state = 2},
  [1087] = {.lex_state = 44, .external_lex_state = 2},
  [1088] = {.lex_state = 44, .external_lex_state = 2},
  [1089] = {.lex_state = 44, .external_lex_state = 2},
  [1090] = {.lex_state = 44, .external_lex_state = 2},
  [1091] = {.lex_state = 44, .external_lex_state = 2},
  [1092] = {.lex_state = 44, .external_lex_state = 2},
  [1093] = {.lex_state = 44, .external_lex_state = 2},
  [1094] = {.lex_state = 44, .external_lex_state = 2},
  [1095] = {.lex_state = 44, .external_lex_state = 2},
  [1096] = {.lex_state = 44, .external_lex_state = 2},
  [1097] = {.lex_state = 44, .external_lex_state = 2},
  [1098] = {.lex_state = 44, .external_lex_state = 2},
  [1099] = {.lex_state = 44, .external_lex_state = 2},
  [1100] = {.lex_state = 44, .external_lex_state = 2},
  [1101] = {.lex_state = 44, .external_lex_state = 2},
  [1102] = {.lex_state = 44, .external_lex_state = 2},
  [1103] = {.lex_state = 44, .external_lex_state = 2},
  [1104] = {.lex_state = 44, .external_lex_state = 2},
  [1105] = {.lex_state = 44, .external_lex_state = 2},
  [1106] = {.lex_state = 44, .external_lex_state = 2},
  [1107] = {.lex_state = 44, .external_lex_state = 2},
  [1108] = {.lex_state = 44, .external_lex_state = 2},
  [1109] = {.lex_state = 44, .external_lex_state = 2},
  [1110] = {.lex_state = 44, .external_lex_state = 2},
  [1111] = {.lex_state = 44, .external_lex_state = 2},
  [1112] = {.lex_state = 44, .external_lex_state = 2},
  [1113] = {.lex_state = 44, .external_lex_state = 2},
  [1114] = {.lex_state = 44, .external_lex_state = 2},
  [1115] = {.lex_state = 44, .external_lex_state = 2},
  [1116] = {.lex_state = 44, .external_lex_state = 2},
  [1117] = {.lex_state = 44, .external_lex_state = 2},
  [1118] = {.lex_state = 44, .external_lex_state = 2},
  [1119] = {.lex_state = 44, .external_lex_state = 2},
  [1120] = {.lex_state = 44, .external_lex_state = 2},
  [1121] = {.lex_state = 44, .external_lex_state = 2},
  [1122] = {.lex_state = 44, .external_lex_state = 2},
  [1123] = {.lex_state = 44, .external_lex_state = 2},
  [1124] = {.lex_state = 44, .external_lex_state = 2},
  [1125] = {.lex_state = 44, .external_lex_state = 2},
  [1126] = {.lex_state = 44, .external_lex_state = 2},
  [1127] = {.lex_state = 44, .external_lex_state = 2},
  [1128] = {.lex_state = 44, .external_lex_state = 2},
  [1129] = {.lex_state = 44, .external_lex_state = 2},
  [1130] = {.lex_state = 44, .external_lex_state = 2},
  [1131] = {.lex_state = 44, .external_lex_state = 2},
  [1132] = {.lex_state = 44, .external_lex_state = 2},
  [1133] = {.lex_state = 44, .external_lex_state = 2},
  [1134] = {.lex_state = 44, .external_lex_state = 2},
  [1135] = {.lex_state = 44, .external_lex_state = 2},
  [1136] = {.lex_state = 44, .external_lex_state = 2},
  [1137] = {.lex_state = 44, .external_lex_state = 2},
  [1138] = {.lex_state = 44, .external_lex_state = 2},
  [1139] = {.lex_state = 44, .external_lex_state = 2},
  [1140] = {.lex_state = 44, .external_lex_state = 2},
  [1141] = {.lex_state = 44, .external_lex_state = 2},
  [1142] = {.lex_state = 44, .external_lex_state = 2},
  [1143] = {.lex_state = 44, .external_lex_state = 2},
  [1144] = {.lex_state = 44, .external_lex_state = 2},
  [1145] = {.lex_state = 44, .external_lex_state = 2},
  [1146] = {.lex_state = 44, .external_lex_state = 2},
  [1147] = {.lex_state = 44, .external_lex_state = 2},
  [1148] = {.lex_state = 44, .external_lex_state = 2},
  [1149] = {.lex_state = 44, .external_lex_state = 2},
  [1150] = {.lex_state = 44, .external_lex_state = 2},
  [1151] = {.lex_state = 44, .external_lex_state = 2},
  [1152] = {.lex_state = 44, .external_lex_state = 2},
  [1153] = {.lex_state = 44, .external_lex_state = 2},
  [1154] = {.lex_state = 44, .external_lex_state = 2},
  [1155] = {.lex_state = 44, .external_lex_state = 2},
  [1156] = {.lex_state = 44, .external_lex_state = 2},
  [1157] = {.lex_state = 44, .external_lex_state = 2},
  [1158] = {.lex_state = 44, .external_lex_state = 2},
  [1159] = {.lex_state = 44, .external_lex_state = 2},
  [1160] = {.lex_state = 44, .external_lex_state = 2},
  [1161] = {.lex_state = 44, .external_lex_state = 2},
  [1162] = {.lex_state = 44, .external_lex_state = 2},
  [1163] = {.lex_state = 44, .external_lex_state = 2},
  [1164] = {.lex_state = 44, .external_lex_state = 2},
  [1165] = {.lex_state = 44, .external_lex_state = 2},
  [1166] = {.lex_state = 0, .external_lex_state = 2},
  [1167] = {.lex_state = 0, .external_lex_state = 2},
  [1168] = {.lex_state = 0, .external_lex_state = 2},
  [1169] = {.lex_state = 0, .external_lex_state = 2},
  [1170] = {.lex_state = 0, .external_lex_state = 2},
  [1171] = {.lex_state = 0, .external_lex_state = 2},
  [1172] = {.lex_state = 0, .external_lex_state = 2},
  [1173] = {.lex_state = 0, .external_lex_state = 2},
  [1174] = {.lex_state = 0, .external_lex_state = 2},
  [1175] = {.lex_state = 0, .external_lex_state = 2},
  [1176] = {.lex_state = 0, .external_lex_state = 2},
  [1177] = {.lex_state = 0, .external_lex_state = 2},
  [1178] = {.lex_state = 0, .external_lex_state = 2},
  [1179] = {.lex_state = 0, .external_lex_state = 2},
  [1180] = {.lex_state = 0, .external_lex_state = 2},
  [1181] = {.lex_state = 0, .external_lex_state = 2},
  [1182] = {.lex_state = 0, .external_lex_state = 2},
  [1183] = {.lex_state = 0, .external_lex_state = 2},
  [1184] = {.lex_state = 0, .external_lex_state = 2},
  [1185] = {.lex_state = 0, .external_lex_state = 2},
  [1186] = {.lex_state = 0, .external_lex_state = 2},
  [1187] = {.lex_state = 0, .external_lex_state = 2},
  [1188] = {.lex_state = 0, .external_lex_state = 2},
  [1189] = {.lex_state = 0, .external_lex_state = 2},
  [1190] = {.lex_state = 0, .external_lex_state = 2},
  [1191] = {.lex_state = 0, .external_lex_state = 2},
  [1192] = {.lex_state = 0, .external_lex_state = 2},
  [1193] = {.lex_state = 0, .external_lex_state = 2},
  [1194] = {.lex_state = 0, .external_lex_state = 2},
  [1195] = {.lex_state = 0, .external_lex_state = 2},
  [1196] = {.lex_state = 0, .external_lex_state = 2},
  [1197] = {.lex_state = 44, .external_lex_state = 2},
  [1198] = {.lex_state = 0, .external_lex_state = 2},
  [1199] = {.lex_state = 44, .external_lex_state = 2},
  [1200] = {.lex_state = 44, .external_lex_state = 2},
  [1201] = {.lex_state = 44, .external_lex_state = 2},
  [1202] = {.lex_state = 44, .external_lex_state = 2},
  [1203] = {.lex_state = 44, .external_lex_state = 2},
  [1204] = {.lex_state = 44, .external_lex_state = 2},
  [1205] = {.lex_state = 44, .external_lex_state = 2},
  [1206] = {.lex_state = 44, .external_lex_state = 2},
  [1207] = {.lex_state = 44, .external_lex_state = 2},
  [1208] = {.lex_state = 44, .external_lex_state = 2},
  [1209] = {.lex_state = 44, .external_lex_state = 2},
  [1210] = {.lex_state = 44, .external_lex_state = 2},
  [1211] = {.lex_state = 44, .external_lex_state = 2},
  [1212] = {.lex_state = 44, .external_lex_state = 2},
  [1213] = {.lex_state = 44, .external_lex_state = 2},
  [1214] = {.lex_state = 44, .external_lex_state = 2},
  [1215] = {.lex_state = 44, .external_lex_state = 2},
  [1216] = {.lex_state = 44, .external_lex_state = 2},
  [1217] = {.lex_state = 44, .external_lex_state = 2},
  [1218] = {.lex_state = 44, .external_lex_state = 2},
  [1219] = {.lex_state = 44, .external_lex_state = 2},
  [1220] = {.lex_state = 44, .external_lex_state = 2},
  [1221] = {.lex_state = 44, .external_lex_state = 2},
  [1222] = {.lex_state = 44, .external_lex_state = 2},
  [1223] = {.lex_state = 44, .external_lex_state = 2},
  [1224] = {.lex_state = 44, .external_lex_state = 2},
  [1225] = {.lex_state = 44, .external_lex_state = 2},
  [1226] = {.lex_state = 44, .external_lex_state = 2},
  [1227] = {.lex_state = 44, .external_lex_state = 2},
  [1228] = {.lex_state = 44, .external_lex_state = 2},
  [1229] = {.lex_state = 44, .external_lex_state = 2},
  [1230] = {.lex_state = 44, .external_lex_state = 2},
  [1231] = {.lex_state = 44, .external_lex_state = 2},
  [1232] = {.lex_state = 44, .external_lex_state = 2},
  [1233] = {.lex_state = 44, .external_lex_state = 2},
  [1234] = {.lex_state = 44, .external_lex_state = 2},
  [1235] = {.lex_state = 44, .external_lex_state = 2},
  [1236] = {.lex_state = 44, .external_lex_state = 2},
  [1237] = {.lex_state = 44, .external_lex_state = 2},
  [1238] = {.lex_state = 44, .external_lex_state = 2},
  [1239] = {.lex_state = 44, .external_lex_state = 2},
  [1240] = {.lex_state = 44, .external_lex_state = 2},
  [1241] = {.lex_state = 44, .external_lex_state = 2},
  [1242] = {.lex_state = 44, .external_lex_state = 2},
  [1243] = {.lex_state = 44, .external_lex_state = 2},
  [1244] = {.lex_state = 44, .external_lex_state = 2},
  [1245] = {.lex_state = 44, .external_lex_state = 2},
  [1246] = {.lex_state = 44, .external_lex_state = 2},
  [1247] = {.lex_state = 44, .external_lex_state = 2},
  [1248] = {.lex_state = 44, .external_lex_state = 2},
  [1249] = {.lex_state = 44, .external_lex_state = 2},
  [1250] = {.lex_state = 44, .external_lex_state = 2},
  [1251] = {.lex_state = 44, .external_lex_state = 2},
  [1252] = {.lex_state = 44, .external_lex_state = 2},
  [1253] = {.lex_state = 44, .external_lex_state = 2},
  [1254] = {.lex_state = 44, .external_lex_state = 2},
  [1255] = {.lex_state = 44, .external_lex_state = 2},
  [1256] = {.lex_state = 44, .external_lex_state = 2},
  [1257] = {.lex_state = 44, .external_lex_state = 2},
  [1258] = {.lex_state = 44, .external_lex_state = 2},
  [1259] = {.lex_state = 44, .external_lex_state = 2},
  [1260] = {.lex_state = 44, .external_lex_state = 2},
  [1261] = {.lex_state = 44, .external_lex_state = 2},
  [1262] = {.lex_state = 44, .external_lex_state = 2},
  [1263] = {.lex_state = 44, .external_lex_state = 2},
  [1264] = {.lex_state = 44, .external_lex_state = 2},
  [1265] = {.lex_state = 44, .external_lex_state = 2},
  [1266] = {.lex_state = 44, .external_lex_state = 2},
  [1267] = {.lex_state = 44, .external_lex_state = 2},
  [1268] = {.lex_state = 44, .external_lex_state = 2},
  [1269] = {.lex_state = 44, .external_lex_state = 2},
  [1270] = {.lex_state = 44, .external_lex_state = 2},
  [1271] = {.lex_state = 44, .external_lex_state = 2},
  [1272] = {.lex_state = 44, .external_lex_state = 2},
  [1273] = {.lex_state = 44, .external_lex_state = 2},
  [1274] = {.lex_state = 44, .external_lex_state = 2},
  [1275] = {.lex_state = 44, .external_lex_state = 2},
  [1276] = {.lex_state = 44, .external_lex_state = 2},
  [1277] = {.lex_state = 44, .external_lex_state = 2},
  [1278] = {.lex_state = 44, .external_lex_state = 2},
  [1279] = {.lex_state = 44, .external_lex_state = 2},
  [1280] = {.lex_state = 44, .external_lex_state = 2},
  [1281] = {.lex_state = 44, .external_lex_state = 2},
  [1282] = {.lex_state = 44, .external_lex_state = 2},
  [1283] = {.lex_state = 44, .external_lex_state = 2},
  [1284] = {.lex_state = 44, .external_lex_state = 2},
  [1285] = {.lex_state = 44, .external_lex_state = 2},
  [1286] = {.lex_state = 44, .external_lex_state = 2},
  [1287] = {.lex_state = 44, .external_lex_state = 2},
  [1288] = {.lex_state = 44, .external_lex_state = 2},
  [1289] = {.lex_state = 44, .external_lex_state = 2},
  [1290] = {.lex_state = 44, .external_lex_state = 2},
  [1291] = {.lex_state = 44, .external_lex_state = 2},
  [1292] = {.lex_state = 44, .external_lex_state = 2},
  [1293] = {.lex_state = 44, .external_lex_state = 2},
  [1294] = {.lex_state = 44, .external_lex_state = 2},
  [1295] = {.lex_state = 44, .external_lex_state = 2},
  [1296] = {.lex_state = 44, .external_lex_state = 2},
  [1297] = {.lex_state = 44, .external_lex_state = 2},
  [1298] = {.lex_state = 44, .external_lex_state = 2},
  [1299] = {.lex_state = 44, .external_lex_state = 2},
  [1300] = {.lex_state = 44, .external_lex_state = 2},
  [1301] = {.lex_state = 44, .external_lex_state = 2},
  [1302] = {.lex_state = 44, .external_lex_state = 2},
  [1303] = {.lex_state = 44, .external_lex_state = 2},
  [1304] = {.lex_state = 44, .external_lex_state = 2},
  [1305] = {.lex_state = 44, .external_lex_state = 2},
  [1306] = {.lex_state = 44, .external_lex_state = 2},
  [1307] = {.lex_state = 44, .external_lex_state = 2},
  [1308] = {.lex_state = 44, .external_lex_state = 2},
  [1309] = {.lex_state = 44, .external_lex_state = 2},
  [1310] = {.lex_state = 44, .external_lex_state = 2},
  [1311] = {.lex_state = 44, .external_lex_state = 2},
  [1312] = {.lex_state = 44, .external_lex_state = 2},
  [1313] = {.lex_state = 44, .external_lex_state = 2},
  [1314] = {.lex_state = 44, .external_lex_state = 2},
  [1315] = {.lex_state = 44, .external_lex_state = 2},
  [1316] = {.lex_state = 44, .external_lex_state = 2},
  [1317] = {.lex_state = 44, .external_lex_state = 2},
  [1318] = {.lex_state = 44, .external_lex_state = 2},
  [1319] = {.lex_state = 44, .external_lex_state = 2},
  [1320] = {.lex_state = 44, .external_lex_state = 2},
  [1321] = {.lex_state = 44, .external_lex_state = 2},
  [1322] = {.lex_state = 44, .external_lex_state = 2},
  [1323] = {.lex_state = 44, .external_lex_state = 2},
  [1324] = {.lex_state = 44, .external_lex_state = 2},
  [1325] = {.lex_state = 44, .external_lex_state = 2},
  [1326] = {.lex_state = 44, .external_lex_state = 2},
  [1327] = {.lex_state = 44, .external_lex_state = 2},
  [1328] = {.lex_state = 44, .external_lex_state = 2},
  [1329] = {.lex_state = 44, .external_lex_state = 2},
  [1330] = {.lex_state = 44, .external_lex_state = 2},
  [1331] = {.lex_state = 44, .external_lex_state = 2},
  [1332] = {.lex_state = 44, .external_lex_state = 2},
  [1333] = {.lex_state = 44, .external_lex_state = 2},
  [1334] = {.lex_state = 44, .external_lex_state = 2},
  [1335] = {.lex_state = 44, .external_lex_state = 2},
  [1336] = {.lex_state = 44, .external_lex_state = 2},
  [1337] = {.lex_state = 44, .external_lex_state = 2},
  [1338] = {.lex_state = 44, .external_lex_state = 2},
  [1339] = {.lex_state = 44, .external_lex_state = 2},
  [1340] = {.lex_state = 44, .external_lex_state = 2},
  [1341] = {.lex_state = 44, .external_lex_state = 2},
  [1342] = {.lex_state = 44, .external_lex_state = 2},
  [1343] = {.lex_state = 44, .external_lex_state = 2},
  [1344] = {.lex_state = 44, .external_lex_state = 2},
  [1345] = {.lex_state = 44, .external_lex_state = 2},
  [1346] = {.lex_state = 44, .external_lex_state = 2},
  [1347] = {.lex_state = 44, .external_lex_state = 2},
  [1348] = {.lex_state = 44, .external_lex_state = 2},
  [1349] = {.lex_state = 44, .external_lex_state = 2},
  [1350] = {.lex_state = 44, .external_lex_state = 2},
  [1351] = {.lex_state = 44, .external_lex_state = 2},
  [1352] = {.lex_state = 44, .external_lex_state = 2},
  [1353] = {.lex_state = 44, .external_lex_state = 2},
  [1354] = {.lex_state = 44, .external_lex_state = 2},
  [1355] = {.lex_state = 44, .external_lex_state = 2},
  [1356] = {.lex_state = 44, .external_lex_state = 2},
  [1357] = {.lex_state = 44, .external_lex_state = 2},
  [1358] = {.lex_state = 44, .external_lex_state = 2},
  [1359] = {.lex_state = 44, .external_lex_state = 2},
  [1360] = {.lex_state = 44, .external_lex_state = 2},
  [1361] = {.lex_state = 44, .external_lex_state = 2},
  [1362] = {.lex_state = 44, .external_lex_state = 2},
  [1363] = {.lex_state = 44, .external_lex_state = 2},
  [1364] = {.lex_state = 44, .external_lex_state = 2},
  [1365] = {.lex_state = 44, .external_lex_state = 2},
  [1366] = {.lex_state = 44, .external_lex_state = 2},
  [1367] = {.lex_state = 44, .external_lex_state = 2},
  [1368] = {.lex_state = 44, .external_lex_state = 2},
  [1369] = {.lex_state = 44, .external_lex_state = 2},
  [1370] = {.lex_state = 44, .external_lex_state = 2},
  [1371] = {.lex_state = 44, .external_lex_state = 2},
  [1372] = {.lex_state = 44, .external_lex_state = 2},
  [1373] = {.lex_state = 44, .external_lex_state = 2},
  [1374] = {.lex_state = 44, .external_lex_state = 2},
  [1375] = {.lex_state = 44, .external_lex_state = 2},
  [1376] = {.lex_state = 0, .external_lex_state = 2},
  [1377] = {.lex_state = 0, .external_lex_state = 2},
  [1378] = {.lex_state = 0, .external_lex_state = 2},
  [1379] = {.lex_state = 0, .external_lex_state = 2},
  [1380] = {.lex_state = 0, .external_lex_state = 2},
  [1381] = {.lex_state = 0, .external_lex_state = 2},
  [1382] = {.lex_state = 0, .external_lex_state = 2},
  [1383] = {.lex_state = 0, .external_lex_state = 2},
  [1384] = {.lex_state = 0, .external_lex_state = 2},
  [1385] = {.lex_state = 0, .external_lex_state = 2},
  [1386] = {.lex_state = 0, .external_lex_state = 2},
  [1387] = {.lex_state = 0, .external_lex_state = 2},
  [1388] = {.lex_state = 0, .external_lex_state = 2},
  [1389] = {.lex_state = 0, .external_lex_state = 2},
  [1390] = {.lex_state = 0, .external_lex_state = 2},
  [1391] = {.lex_state = 0, .external_lex_state = 2},
  [1392] = {.lex_state = 0, .external_lex_state = 2},
  [1393] = {.lex_state = 0, .external_lex_state = 2},
  [1394] = {.lex_state = 0, .external_lex_state = 2},
  [1395] = {.lex_state = 0, .external_lex_state = 2},
  [1396] = {.lex_state = 0, .external_lex_state = 2},
  [1397] = {.lex_state = 0, .external_lex_state = 2},
  [1398] = {.lex_state = 0, .external_lex_state = 2},
  [1399] = {.lex_state = 0, .external_lex_state = 2},
  [1400] = {.lex_state = 0, .external_lex_state = 2},
  [1401] = {.lex_state = 0, .external_lex_state = 2},
  [1402] = {.lex_state = 0, .external_lex_state = 2},
  [1403] = {.lex_state = 0, .external_lex_state = 2},
  [1404] = {.lex_state = 0, .external_lex_state = 2},
  [1405] = {.lex_state = 0, .external_lex_state = 2},
  [1406] = {.lex_state = 0, .external_lex_state = 2},
  [1407] = {.lex_state = 0, .external_lex_state = 2},
  [1408] = {.lex_state = 0, .external_lex_state = 2},
  [1409] = {.lex_state = 0, .external_lex_state = 2},
  [1410] = {.lex_state = 0, .external_lex_state = 2},
  [1411] = {.lex_state = 0, .external_lex_state = 2},
  [1412] = {.lex_state = 0, .external_lex_state = 2},
  [1413] = {.lex_state = 0, .external_lex_state = 2},
  [1414] = {.lex_state = 44, .external_lex_state = 2},
  [1415] = {.lex_state = 44, .external_lex_state = 2},
  [1416] = {.lex_state = 44, .external_lex_state = 2},
  [1417] = {.lex_state = 44, .external_lex_state = 2},
  [1418] = {.lex_state = 44, .external_lex_state = 2},
  [1419] = {.lex_state = 44, .external_lex_state = 2},
  [1420] = {.lex_state = 44, .external_lex_state = 2},
  [1421] = {.lex_state = 44, .external_lex_state = 2},
  [1422] = {.lex_state = 44, .external_lex_state = 2},
  [1423] = {.lex_state = 0, .external_lex_state = 2},
  [1424] = {.lex_state = 44, .external_lex_state = 2},
  [1425] = {.lex_state = 0, .external_lex_state = 2},
  [1426] = {.lex_state = 0, .external_lex_state = 2},
  [1427] = {.lex_state = 0, .external_lex_state = 2},
  [1428] = {.lex_state = 0, .external_lex_state = 2},
  [1429] = {.lex_state = 0, .external_lex_state = 2},
  [1430] = {.lex_state = 44, .external_lex_state = 2},
  [1431] = {.lex_state = 0, .external_lex_state = 2},
  [1432] = {.lex_state = 0, .external_lex_state = 2},
  [1433] = {.lex_state = 0, .external_lex_state = 2},
  [1434] = {.lex_state = 44, .external_lex_state = 2},
  [1435] = {.lex_state = 0, .external_lex_state = 2},
  [1436] = {.lex_state = 0, .external_lex_state = 2},
  [1437] = {.lex_state = 0, .external_lex_state = 2},
  [1438] = {.lex_state = 0, .external_lex_state = 2},
  [1439] = {.lex_state = 0, .external_lex_state = 2},
  [1440] = {.lex_state = 0, .external_lex_state = 2},
  [1441] = {.lex_state = 44, .external_lex_state = 2},
  [1442] = {.lex_state = 0, .external_lex_state = 2},
  [1443] = {.lex_state = 0, .external_lex_state = 2},
  [1444] = {.lex_state = 44, .external_lex_state = 2},
  [1445] = {.lex_state = 0, .external_lex_state = 2},
  [1446] = {.lex_state = 0, .external_lex_state = 2},
  [1447] = {.lex_state = 0, .external_lex_state = 2},
  [1448] = {.lex_state = 0, .external_lex_state = 2},
  [1449] = {.lex_state = 44, .external_lex_state = 2},
  [1450] = {.lex_state = 0, .external_lex_state = 2},
  [1451] = {.lex_state = 0, .external_lex_state = 2},
  [1452] = {.lex_state = 44, .external_lex_state = 2},
  [1453] = {.lex_state = 44, .external_lex_state = 2},
  [1454] = {.lex_state = 44, .external_lex_state = 2},
  [1455] = {.lex_state = 0, .external_lex_state = 2},
  [1456] = {.lex_state = 0, .external_lex_state = 2},
  [1457] = {.lex_state = 0, .external_lex_state = 2},
  [1458] = {.lex_state = 0, .external_lex_state = 2},
  [1459] = {.lex_state = 0, .external_lex_state = 2},
  [1460] = {.lex_state = 0, .external_lex_state = 2},
  [1461] = {.lex_state = 0, .external_lex_state = 2},
  [1462] = {.lex_state = 0, .external_lex_state = 2},
  [1463] = {.lex_state = 0, .external_lex_state = 2},
  [1464] = {.lex_state = 0, .external_lex_state = 2},
  [1465] = {.lex_state = 0, .external_lex_state = 2},
  [1466] = {.lex_state = 0, .external_lex_state = 2},
  [1467] = {.lex_state = 0, .external_lex_state = 2},
  [1468] = {.lex_state = 0, .external_lex_state = 2},
  [1469] = {.lex_state = 0, .external_lex_state = 2},
  [1470] = {.lex_state = 0, .external_lex_state = 2},
  [1471] = {.lex_state = 0, .external_lex_state = 2},
  [1472] = {.lex_state = 0, .external_lex_state = 2},
  [1473] = {.lex_state = 0, .external_lex_state = 2},
  [1474] = {.lex_state = 0, .external_lex_state = 2},
  [1475] = {.lex_state = 0, .external_lex_state = 2},
  [1476] = {.lex_state = 0, .external_lex_state = 2},
  [1477] = {.lex_state = 0, .external_lex_state = 2},
  [1478] = {.lex_state = 0, .external_lex_state = 2},
  [1479] = {.lex_state = 0, .external_lex_state = 2},
  [1480] = {.lex_state = 0, .external_lex_state = 2},
  [1481] = {.lex_state = 0, .external_lex_state = 2},
  [1482] = {.lex_state = 0, .external_lex_state = 2},
  [1483] = {.lex_state = 0, .external_lex_state = 2},
  [1484] = {.lex_state = 0, .external_lex_state = 2},
  [1485] = {.lex_state = 0, .external_lex_state = 2},
  [1486] = {.lex_state = 0, .external_lex_state = 2},
  [1487] = {.lex_state = 0, .external_lex_state = 2},
  [1488] = {.lex_state = 0, .external_lex_state = 2},
  [1489] = {.lex_state = 0, .external_lex_state = 2},
  [1490] = {.lex_state = 0, .external_lex_state = 2},
  [1491] = {.lex_state = 0, .external_lex_state = 2},
  [1492] = {.lex_state = 0, .external_lex_state = 2},
  [1493] = {.lex_state = 0, .external_lex_state = 2},
  [1494] = {.lex_state = 0, .external_lex_state = 2},
  [1495] = {.lex_state = 0, .external_lex_state = 2},
  [1496] = {.lex_state = 0, .external_lex_state = 2},
  [1497] = {.lex_state = 0, .external_lex_state = 2},
  [1498] = {.lex_state = 0, .external_lex_state = 2},
  [1499] = {.lex_state = 0, .external_lex_state = 2},
  [1500] = {.lex_state = 0, .external_lex_state = 2},
  [1501] = {.lex_state = 0, .external_lex_state = 2},
  [1502] = {.lex_state = 0, .external_lex_state = 2},
  [1503] = {.lex_state = 0, .external_lex_state = 2},
  [1504] = {.lex_state = 0, .external_lex_state = 2},
  [1505] = {.lex_state = 0, .external_lex_state = 2},
  [1506] = {.lex_state = 0, .external_lex_state = 2},
  [1507] = {.lex_state = 0, .external_lex_state = 2},
  [1508] = {.lex_state = 0, .external_lex_state = 2},
  [1509] = {.lex_state = 0, .external_lex_state = 2},
  [1510] = {.lex_state = 0, .external_lex_state = 2},
  [1511] = {.lex_state = 0, .external_lex_state = 2},
  [1512] = {.lex_state = 0, .external_lex_state = 2},
  [1513] = {.lex_state = 44, .external_lex_state = 2},
  [1514] = {.lex_state = 0, .external_lex_state = 2},
  [1515] = {.lex_state = 44, .external_lex_state = 2},
  [1516] = {.lex_state = 44, .external_lex_state = 2},
  [1517] = {.lex_state = 0, .external_lex_state = 2},
  [1518] = {.lex_state = 44, .external_lex_state = 2},
  [1519] = {.lex_state = 0, .external_lex_state = 2},
  [1520] = {.lex_state = 44, .external_lex_state = 2},
  [1521] = {.lex_state = 44, .external_lex_state = 2},
  [1522] = {.lex_state = 44, .external_lex_state = 2},
  [1523] = {.lex_state = 44, .external_lex_state = 2},
  [1524] = {.lex_state = 44, .external_lex_state = 2},
  [1525] = {.lex_state = 44, .external_lex_state = 2},
  [1526] = {.lex_state = 0, .external_lex_state = 2},
  [1527] = {.lex_state = 0, .external_lex_state = 2},
  [1528] = {.lex_state = 0, .external_lex_state = 2},
  [1529] = {.lex_state = 0, .external_lex_state = 2},
  [1530] = {.lex_state = 0, .external_lex_state = 2},
  [1531] = {.lex_state = 44, .external_lex_state = 2},
  [1532] = {.lex_state = 0, .external_lex_state = 2},
  [1533] = {.lex_state = 0, .external_lex_state = 2},
  [1534] = {.lex_state = 0, .external_lex_state = 2},
  [1535] = {.lex_state = 0, .external_lex_state = 2},
  [1536] = {.lex_state = 0, .external_lex_state = 2},
  [1537] = {.lex_state = 0, .external_lex_state = 2},
  [1538] = {.lex_state = 0, .external_lex_state = 2},
  [1539] = {.lex_state = 0, .external_lex_state = 2},
  [1540] = {.lex_state = 44, .external_lex_state = 2},
  [1541] = {.lex_state = 0, .external_lex_state = 2},
  [1542] = {.lex_state = 0, .external_lex_state = 2},
  [1543] = {.lex_state = 0, .external_lex_state = 2},
  [1544] = {.lex_state = 0, .external_lex_state = 2},
  [1545] = {.lex_state = 0, .external_lex_state = 2},
  [1546] = {.lex_state = 0, .external_lex_state = 2},
  [1547] = {.lex_state = 44, .external_lex_state = 2},
  [1548] = {.lex_state = 0, .external_lex_state = 2},
  [1549] = {.lex_state = 0, .external_lex_state = 2},
  [1550] = {.lex_state = 0, .external_lex_state = 2},
  [1551] = {.lex_state = 0, .external_lex_state = 2},
  [1552] = {.lex_state = 0, .external_lex_state = 2},
  [1553] = {.lex_state = 44, .external_lex_state = 2},
  [1554] = {.lex_state = 0, .external_lex_state = 2},
  [1555] = {.lex_state = 0, .external_lex_state = 2},
  [1556] = {.lex_state = 0, .external_lex_state = 2},
  [1557] = {.lex_state = 44, .external_lex_state = 2},
  [1558] = {.lex_state = 44, .external_lex_state = 2},
  [1559] = {.lex_state = 0, .external_lex_state = 2},
  [1560] = {.lex_state = 0, .external_lex_state = 2},
  [1561] = {.lex_state = 44, .external_lex_state = 2},
  [1562] = {.lex_state = 0, .external_lex_state = 2},
  [1563] = {.lex_state = 44, .external_lex_state = 2},
  [1564] = {.lex_state = 0, .external_lex_state = 2},
  [1565] = {.lex_state = 44, .external_lex_state = 2},
  [1566] = {.lex_state = 0, .external_lex_state = 2},
  [1567] = {.lex_state = 44, .external_lex_state = 2},
  [1568] = {.lex_state = 44, .external_lex_state = 2},
  [1569] = {.lex_state = 0, .external_lex_state = 2},
  [1570] = {.lex_state = 0, .external_lex_state = 2},
  [1571] = {.lex_state = 44, .external_lex_state = 2},
  [1572] = {.lex_state = 44, .external_lex_state = 2},
  [1573] = {.lex_state = 44, .external_lex_state = 2},
  [1574] = {.lex_state = 44, .external_lex_state = 2},
  [1575] = {.lex_state = 44, .external_lex_state = 2},
  [1576] = {.lex_state = 0, .external_lex_state = 2},
  [1577] = {.lex_state = 44, .external_lex_state = 2},
  [1578] = {.lex_state = 0, .external_lex_state = 2},
  [1579] = {.lex_state = 44, .external_lex_state = 2},
  [1580] = {.lex_state = 44, .external_lex_state = 2},
  [1581] = {.lex_state = 44, .external_lex_state = 2},
  [1582] = {.lex_state = 44, .external_lex_state = 2},
  [1583] = {.lex_state = 0, .external_lex_state = 2},
  [1584] = {.lex_state = 0, .external_lex_state = 2},
  [1585] = {.lex_state = 0, .external_lex_state = 2},
  [1586] = {.lex_state = 44, .external_lex_state = 2},
  [1587] = {.lex_state = 0, .external_lex_state = 2},
  [1588] = {.lex_state = 0, .external_lex_state = 2},
  [1589] = {.lex_state = 0, .external_lex_state = 2},
  [1590] = {.lex_state = 44, .external_lex_state = 2},
  [1591] = {.lex_state = 44, .external_lex_state = 2},
  [1592] = {.lex_state = 0, .external_lex_state = 2},
  [1593] = {.lex_state = 0, .external_lex_state = 2},
  [1594] = {.lex_state = 0, .external_lex_state = 2},
  [1595] = {.lex_state = 0, .external_lex_state = 2},
  [1596] = {.lex_state = 44, .external_lex_state = 2},
  [1597] = {.lex_state = 0, .external_lex_state = 2},
  [1598] = {.lex_state = 0, .external_lex_state = 2},
  [1599] = {.lex_state = 44, .external_lex_state = 2},
  [1600] = {.lex_state = 44, .external_lex_state = 2},
  [1601] = {.lex_state = 44, .external_lex_state = 2},
  [1602] = {.lex_state = 44, .external_lex_state = 2},
  [1603] = {.lex_state = 0, .external_lex_state = 2},
  [1604] = {.lex_state = 44, .external_lex_state = 2},
  [1605] = {.lex_state = 44, .external_lex_state = 2},
  [1606] = {.lex_state = 44, .external_lex_state = 2},
  [1607] = {.lex_state = 0, .external_lex_state = 2},
  [1608] = {.lex_state = 44, .external_lex_state = 2},
  [1609] = {.lex_state = 44, .external_lex_state = 2},
  [1610] = {.lex_state = 0, .external_lex_state = 2},
  [1611] = {.lex_state = 44, .external_lex_state = 2},
  [1612] = {.lex_state = 44, .external_lex_state = 2},
  [1613] = {.lex_state = 44, .external_lex_state = 2},
  [1614] = {.lex_state = 44, .external_lex_state = 2},
  [1615] = {.lex_state = 0, .external_lex_state = 2},
  [1616] = {.lex_state = 44, .external_lex_state = 2},
  [1617] = {.lex_state = 44, .external_lex_state = 2},
  [1618] = {.lex_state = 44, .external_lex_state = 2},
  [1619] = {.lex_state = 44, .external_lex_state = 2},
  [1620] = {.lex_state = 44, .external_lex_state = 2},
  [1621] = {.lex_state = 44, .external_lex_state = 2},
  [1622] = {.lex_state = 0, .external_lex_state = 2},
  [1623] = {.lex_state = 0, .external_lex_state = 2},
  [1624] = {.lex_state = 44, .external_lex_state = 2},
  [1625] = {.lex_state = 44, .external_lex_state = 2},
  [1626] = {.lex_state = 44, .external_lex_state = 2},
  [1627] = {.lex_state = 44, .external_lex_state = 2},
  [1628] = {.lex_state = 44, .external_lex_state = 2},
  [1629] = {.lex_state = 0, .external_lex_state = 2},
  [1630] = {.lex_state = 44, .external_lex_state = 2},
  [1631] = {.lex_state = 44, .external_lex_state = 2},
  [1632] = {.lex_state = 44, .external_lex_state = 2},
  [1633] = {.lex_state = 0, .external_lex_state = 2},
  [1634] = {.lex_state = 44, .external_lex_state = 2},
  [1635] = {.lex_state = 44, .external_lex_state = 2},
  [1636] = {.lex_state = 44, .external_lex_state = 2},
  [1637] = {.lex_state = 44, .external_lex_state = 2},
  [1638] = {.lex_state = 44, .external_lex_state = 2},
  [1639] = {.lex_state = 0, .external_lex_state = 2},
  [1640] = {.lex_state = 44, .external_lex_state = 2},
  [1641] = {.lex_state = 44, .external_lex_state = 2},
  [1642] = {.lex_state = 44, .external_lex_state = 2},
  [1643] = {.lex_state = 0, .external_lex_state = 2},
  [1644] = {.lex_state = 44, .external_lex_state = 2},
  [1645] = {.lex_state = 44, .external_lex_state = 2},
  [1646] = {.lex_state = 0, .external_lex_state = 2},
  [1647] = {.lex_state = 44, .external_lex_state = 2},
  [1648] = {.lex_state = 44, .external_lex_state = 2},
  [1649] = {.lex_state = 44, .external_lex_state = 2},
  [1650] = {.lex_state = 0, .external_lex_state = 2},
  [1651] = {.lex_state = 44, .external_lex_state = 2},
  [1652] = {.lex_state = 44, .external_lex_state = 2},
  [1653] = {.lex_state = 44, .external_lex_state = 2},
  [1654] = {.lex_state = 44, .external_lex_state = 2},
  [1655] = {.lex_state = 44, .external_lex_state = 2},
  [1656] = {.lex_state = 44, .external_lex_state = 2},
  [1657] = {.lex_state = 44, .external_lex_state = 2},
  [1658] = {.lex_state = 44, .external_lex_state = 2},
  [1659] = {.lex_state = 0, .external_lex_state = 2},
  [1660] = {.lex_state = 44, .external_lex_state = 2},
  [1661] = {.lex_state = 44, .external_lex_state = 2},
  [1662] = {.lex_state = 44, .external_lex_state = 2},
  [1663] = {.lex_state = 44, .external_lex_state = 2},
  [1664] = {.lex_state = 0, .external_lex_state = 2},
  [1665] = {.lex_state = 44, .external_lex_state = 2},
  [1666] = {.lex_state = 44, .external_lex_state = 2},
  [1667] = {.lex_state = 0, .external_lex_state = 2},
  [1668] = {.lex_state = 44, .external_lex_state = 2},
  [1669] = {.lex_state = 0, .external_lex_state = 2},
  [1670] = {.lex_state = 44, .external_lex_state = 2},
  [1671] = {.lex_state = 44, .external_lex_state = 2},
  [1672] = {.lex_state = 0, .external_lex_state = 2},
  [1673] = {.lex_state = 0, .external_lex_state = 2},
  [1674] = {.lex_state = 0, .external_lex_state = 2},
  [1675] = {.lex_state = 0, .external_lex_state = 2},
  [1676] = {.lex_state = 0, .external_lex_state = 2},
  [1677] = {.lex_state = 0, .external_lex_state = 2},
  [1678] = {.lex_state = 0, .external_lex_state = 2},
  [1679] = {.lex_state = 0, .external_lex_state = 2},
  [1680] = {.lex_state = 44, .external_lex_state = 2},
  [1681] = {.lex_state = 0, .external_lex_state = 2},
  [1682] = {.lex_state = 0, .external_lex_state = 2},
  [1683] = {.lex_state = 0, .external_lex_state = 2},
  [1684] = {.lex_state = 0, .external_lex_state = 2},
  [1685] = {.lex_state = 0, .external_lex_state = 2},
  [1686] = {.lex_state = 0, .external_lex_state = 2},
  [1687] = {.lex_state = 0, .external_lex_state = 2},
  [1688] = {.lex_state = 0, .external_lex_state = 2},
  [1689] = {.lex_state = 0, .external_lex_state = 2},
  [1690] = {.lex_state = 0, .external_lex_state = 2},
  [1691] = {.lex_state = 0, .external_lex_state = 2},
  [1692] = {.lex_state = 0, .external_lex_state = 2},
  [1693] = {.lex_state = 44, .external_lex_state = 2},
  [1694] = {.lex_state = 44, .external_lex_state = 2},
  [1695] = {.lex_state = 44, .external_lex_state = 2},
  [1696] = {.lex_state = 44, .external_lex_state = 2},
  [1697] = {.lex_state = 44, .external_lex_state = 2},
  [1698] = {.lex_state = 0, .external_lex_state = 2},
  [1699] = {.lex_state = 0, .external_lex_state = 2},
  [1700] = {.lex_state = 0, .external_lex_state = 2},
  [1701] = {.lex_state = 44, .external_lex_state = 2},
  [1702] = {.lex_state = 44, .external_lex_state = 2},
  [1703] = {.lex_state = 44, .external_lex_state = 2},
  [1704] = {.lex_state = 44, .external_lex_state = 2},
  [1705] = {.lex_state = 44, .external_lex_state = 2},
  [1706] = {.lex_state = 44, .external_lex_state = 2},
  [1707] = {.lex_state = 44, .external_lex_state = 2},
  [1708] = {.lex_state = 44, .external_lex_state = 2},
  [1709] = {.lex_state = 0, .external_lex_state = 2},
  [1710] = {.lex_state = 44, .external_lex_state = 2},
  [1711] = {.lex_state = 44, .external_lex_state = 2},
  [1712] = {.lex_state = 44, .external_lex_state = 2},
  [1713] = {.lex_state = 44, .external_lex_state = 2},
  [1714] = {.lex_state = 0, .external_lex_state = 2},
  [1715] = {.lex_state = 0, .external_lex_state = 2},
  [1716] = {.lex_state = 44, .external_lex_state = 2},
  [1717] = {.lex_state = 0, .external_lex_state = 2},
  [1718] = {.lex_state = 44, .external_lex_state = 2},
  [1719] = {.lex_state = 44, .external_lex_state = 2},
  [1720] = {.lex_state = 44, .external_lex_state = 2},
  [1721] = {.lex_state = 44, .external_lex_state = 2},
  [1722] = {.lex_state = 44, .external_lex_state = 2},
  [1723] = {.lex_state = 44, .external_lex_state = 2},
  [1724] = {.lex_state = 44, .external_lex_state = 2},
  [1725] = {.lex_state = 44, .external_lex_state = 2},
  [1726] = {.lex_state = 0, .external_lex_state = 2},
  [1727] = {.lex_state = 44, .external_lex_state = 2},
  [1728] = {.lex_state = 0, .external_lex_state = 2},
  [1729] = {.lex_state = 0, .external_lex_state = 2},
  [1730] = {.lex_state = 44, .external_lex_state = 2},
  [1731] = {.lex_state = 0, .external_lex_state = 2},
  [1732] = {.lex_state = 44, .external_lex_state = 2},
  [1733] = {.lex_state = 0, .external_lex_state = 2},
  [1734] = {.lex_state = 44, .external_lex_state = 2},
  [1735] = {.lex_state = 44, .external_lex_state = 2},
  [1736] = {.lex_state = 44, .external_lex_state = 2},
  [1737] = {.lex_state = 44, .external_lex_state = 2},
  [1738] = {.lex_state = 0, .external_lex_state = 2},
  [1739] = {.lex_state = 44, .external_lex_state = 2},
  [1740] = {.lex_state = 44, .external_lex_state = 2},
  [1741] = {.lex_state = 44, .external_lex_state = 2},
  [1742] = {.lex_state = 0, .external_lex_state = 2},
  [1743] = {.lex_state = 0, .external_lex_state = 2},
  [1744] = {.lex_state = 0, .external_lex_state = 2},
  [1745] = {.lex_state = 44, .external_lex_state = 2},
  [1746] = {.lex_state = 0, .external_lex_state = 2},
  [1747] = {.lex_state = 44, .external_lex_state = 2},
  [1748] = {.lex_state = 0, .external_lex_state = 2},
  [1749] = {.lex_state = 0, .external_lex_state = 2},
  [1750] = {.lex_state = 44, .external_lex_state = 2},
  [1751] = {.lex_state = 0, .external_lex_state = 2},
  [1752] = {.lex_state = 0, .external_lex_state = 2},
  [1753] = {.lex_state = 0, .external_lex_state = 2},
  [1754] = {.lex_state = 0, .external_lex_state = 2},
  [1755] = {.lex_state = 0, .external_lex_state = 2},
  [1756] = {.lex_state = 0, .external_lex_state = 2},
  [1757] = {.lex_state = 3, .external_lex_state = 2},
  [1758] = {.lex_state = 4, .external_lex_state = 2},
  [1759] = {.lex_state = 0, .external_lex_state = 2},
  [1760] = {.lex_state = 3, .external_lex_state = 2},
  [1761] = {.lex_state = 3, .external_lex_state = 2},
  [1762] = {.lex_state = 0, .external_lex_state = 2},
  [1763] = {.lex_state = 3, .external_lex_state = 2},
  [1764] = {.lex_state = 0, .external_lex_state = 2},
  [1765] = {.lex_state = 0, .external_lex_state = 2},
  [1766] = {.lex_state = 0, .external_lex_state = 2},
  [1767] = {.lex_state = 0, .external_lex_state = 2},
  [1768] = {.lex_state = 0, .external_lex_state = 2},
  [1769] = {.lex_state = 4, .external_lex_state = 2},
  [1770] = {.lex_state = 3, .external_lex_state = 2},
  [1771] = {.lex_state = 3, .external_lex_state = 2},
  [1772] = {.lex_state = 3, .external_lex_state = 2},
  [1773] = {.lex_state = 3, .external_lex_state = 2},
  [1774] = {.lex_state = 3, .external_lex_state = 2},
  [1775] = {.lex_state = 3, .external_lex_state = 2},
  [1776] = {.lex_state = 0, .external_lex_state = 2},
  [1777] = {.lex_state = 3, .external_lex_state = 2},
  [1778] = {.lex_state = 4, .external_lex_state = 2},
  [1779] = {.lex_state = 0, .external_lex_state = 2},
  [1780] = {.lex_state = 0, .external_lex_state = 2},
  [1781] = {.lex_state = 0, .external_lex_state = 2},
  [1782] = {.lex_state = 3, .external_lex_state = 2},
  [1783] = {.lex_state = 3, .external_lex_state = 2},
  [1784] = {.lex_state = 3, .external_lex_state = 2},
  [1785] = {.lex_state = 0, .external_lex_state = 2},
  [1786] = {.lex_state = 3, .external_lex_state = 2},
  [1787] = {.lex_state = 3, .external_lex_state = 2},
  [1788] = {.lex_state = 0, .external_lex_state = 2},
  [1789] = {.lex_state = 0, .external_lex_state = 2},
  [1790] = {.lex_state = 0, .external_lex_state = 2},
  [1791] = {.lex_state = 0, .external_lex_state = 2},
  [1792] = {.lex_state = 0, .external_lex_state = 2},
  [1793] = {.lex_state = 0, .external_lex_state = 2},
  [1794] = {.lex_state = 4, .external_lex_state = 2},
  [1795] = {.lex_state = 0, .external_lex_state = 2},
  [1796] = {.lex_state = 0, .external_lex_state = 2},
  [1797] = {.lex_state = 0, .external_lex_state = 2},
  [1798] = {.lex_state = 0, .external_lex_state = 2},
  [1799] = {.lex_state = 0, .external_lex_state = 2},
  [1800] = {.lex_state = 4, .external_lex_state = 2},
  [1801] = {.lex_state = 0, .external_lex_state = 2},
  [1802] = {.lex_state = 0, .external_lex_state = 2},
  [1803] = {.lex_state = 3, .external_lex_state = 2},
  [1804] = {.lex_state = 0, .external_lex_state = 2},
  [1805] = {.lex_state = 44, .external_lex_state = 2},
  [1806] = {.lex_state = 44, .external_lex_state = 2},
  [1807] = {.lex_state = 0, .external_lex_state = 2},
  [1808] = {.lex_state = 0, .external_lex_state = 2},
  [1809] = {.lex_state = 44, .external_lex_state = 2},
  [1810] = {.lex_state = 0, .external_lex_state = 2},
  [1811] = {.lex_state = 44, .external_lex_state = 2},
  [1812] = {.lex_state = 0, .external_lex_state = 2},
  [1813] = {.lex_state = 44, .external_lex_state = 2},
  [1814] = {.lex_state = 44, .external_lex_state = 2},
  [1815] = {.lex_state = 44, .external_lex_state = 2},
  [1816] = {.lex_state = 0, .external_lex_state = 2},
  [1817] = {.lex_state = 4, .external_lex_state = 2},
  [1818] = {.lex_state = 0, .external_lex_state = 2},
  [1819] = {.lex_state = 44, .external_lex_state = 2},
  [1820] = {.lex_state = 44, .external_lex_state = 2},
  [1821] = {.lex_state = 0, .external_lex_state = 2},
  [1822] = {.lex_state = 44, .external_lex_state = 2},
  [1823] = {.lex_state = 44, .external_lex_state = 2},
  [1824] = {.lex_state = 44, .external_lex_state = 2},
  [1825] = {.lex_state = 44, .external_lex_state = 2},
  [1826] = {.lex_state = 0, .external_lex_state = 2},
  [1827] = {.lex_state = 44, .external_lex_state = 2},
  [1828] = {.lex_state = 44, .external_lex_state = 2},
  [1829] = {.lex_state = 0, .external_lex_state = 2},
  [1830] = {.lex_state = 0, .external_lex_state = 2},
  [1831] = {.lex_state = 0, .external_lex_state = 2},
  [1832] = {.lex_state = 44, .external_lex_state = 2},
  [1833] = {.lex_state = 0, .external_lex_state = 2},
  [1834] = {.lex_state = 44, .external_lex_state = 2},
  [1835] = {.lex_state = 4, .external_lex_state = 2},
  [1836] = {.lex_state = 44, .external_lex_state = 2},
  [1837] = {.lex_state = 44, .external_lex_state = 2},
  [1838] = {.lex_state = 44, .external_lex_state = 2},
  [1839] = {.lex_state = 0, .external_lex_state = 2},
  [1840] = {.lex_state = 44, .external_lex_state = 2},
  [1841] = {.lex_state = 4, .external_lex_state = 2},
  [1842] = {.lex_state = 0, .external_lex_state = 2},
  [1843] = {.lex_state = 44, .external_lex_state = 2},
  [1844] = {.lex_state = 44, .external_lex_state = 2},
  [1845] = {.lex_state = 44, .external_lex_state = 2},
  [1846] = {.lex_state = 44, .external_lex_state = 2},
  [1847] = {.lex_state = 44, .external_lex_state = 2},
  [1848] = {.lex_state = 44, .external_lex_state = 2},
  [1849] = {.lex_state = 44, .external_lex_state = 2},
  [1850] = {.lex_state = 0, .external_lex_state = 2},
  [1851] = {.lex_state = 0, .external_lex_state = 2},
  [1852] = {.lex_state = 4, .external_lex_state = 2},
  [1853] = {.lex_state = 0, .external_lex_state = 2},
  [1854] = {.lex_state = 44, .external_lex_state = 2},
  [1855] = {.lex_state = 44, .external_lex_state = 2},
  [1856] = {.lex_state = 0, .external_lex_state = 2},
  [1857] = {.lex_state = 44, .external_lex_state = 2},
  [1858] = {.lex_state = 44, .external_lex_state = 2},
  [1859] = {.lex_state = 44, .external_lex_state = 2},
  [1860] = {.lex_state = 44, .external_lex_state = 2},
  [1861] = {.lex_state = 44, .external_lex_state = 2},
  [1862] = {.lex_state = 44, .external_lex_state = 2},
  [1863] = {.lex_state = 0, .external_lex_state = 2},
  [1864] = {.lex_state = 0, .external_lex_state = 2},
  [1865] = {.lex_state = 44, .external_lex_state = 2},
  [1866] = {.lex_state = 44, .external_lex_state = 2},
  [1867] = {.lex_state = 5, .external_lex_state = 2},
  [1868] = {.lex_state = 0, .external_lex_state = 2},
  [1869] = {.lex_state = 44, .external_lex_state = 2},
  [1870] = {.lex_state = 44, .external_lex_state = 2},
  [1871] = {.lex_state = 0, .external_lex_state = 2},
  [1872] = {.lex_state = 0, .external_lex_state = 2},
  [1873] = {.lex_state = 44, .external_lex_state = 2},
  [1874] = {.lex_state = 0, .external_lex_state = 2},
  [1875] = {.lex_state = 0, .external_lex_state = 2},
  [1876] = {.lex_state = 44, .external_lex_state = 2},
  [1877] = {.lex_state = 44, .external_lex_state = 2},
  [1878] = {.lex_state = 44, .external_lex_state = 2},
  [1879] = {.lex_state = 44, .external_lex_state = 2},
  [1880] = {.lex_state = 0, .external_lex_state = 2},
  [1881] = {.lex_state = 44, .external_lex_state = 2},
  [1882] = {.lex_state = 0, .external_lex_state = 2},
  [1883] = {.lex_state = 0, .external_lex_state = 2},
  [1884] = {.lex_state = 44, .external_lex_state = 2},
  [1885] = {.lex_state = 0, .external_lex_state = 2},
  [1886] = {.lex_state = 44, .external_lex_state = 2},
  [1887] = {.lex_state = 0, .external_lex_state = 2},
  [1888] = {.lex_state = 0, .external_lex_state = 2},
  [1889] = {.lex_state = 44, .external_lex_state = 2},
  [1890] = {.lex_state = 0, .external_lex_state = 2},
  [1891] = {.lex_state = 0, .external_lex_state = 2},
  [1892] = {.lex_state = 44, .external_lex_state = 2},
  [1893] = {.lex_state = 0, .external_lex_state = 2},
  [1894] = {.lex_state = 44, .external_lex_state = 2},
  [1895] = {.lex_state = 44, .external_lex_state = 2},
  [1896] = {.lex_state = 0, .external_lex_state = 2},
  [1897] = {.lex_state = 44, .external_lex_state = 2},
  [1898] = {.lex_state = 44, .external_lex_state = 2},
  [1899] = {.lex_state = 44, .external_lex_state = 2},
  [1900] = {.lex_state = 0, .external_lex_state = 2},
  [1901] = {.lex_state = 0, .external_lex_state = 2},
  [1902] = {.lex_state = 44, .external_lex_state = 2},
  [1903] = {.lex_state = 0, .external_lex_state = 2},
  [1904] = {.lex_state = 44, .external_lex_state = 2},
  [1905] = {.lex_state = 44, .external_lex_state = 2},
  [1906] = {.lex_state = 44, .external_lex_state = 2},
  [1907] = {.lex_state = 44, .external_lex_state = 2},
  [1908] = {.lex_state = 0, .external_lex_state = 2},
  [1909] = {.lex_state = 0, .external_lex_state = 2},
  [1910] = {.lex_state = 44, .external_lex_state = 2},
  [1911] = {.lex_state = 0, .external_lex_state = 2},
  [1912] = {.lex_state = 44, .external_lex_state = 2},
  [1913] = {.lex_state = 0, .external_lex_state = 2},
  [1914] = {.lex_state = 44, .external_lex_state = 2},
  [1915] = {.lex_state = 44, .external_lex_state = 2},
  [1916] = {.lex_state = 44, .external_lex_state = 2},
  [1917] = {.lex_state = 0, .external_lex_state = 2},
  [1918] = {.lex_state = 0, .external_lex_state = 2},
  [1919] = {.lex_state = 0, .external_lex_state = 2},
  [1920] = {.lex_state = 0, .external_lex_state = 2},
  [1921] = {.lex_state = 0, .external_lex_state = 2},
  [1922] = {.lex_state = 0, .external_lex_state = 2},
  [1923] = {.lex_state = 0, .external_lex_state = 2},
  [1924] = {.lex_state = 0, .external_lex_state = 2},
  [1925] = {.lex_state = 0, .external_lex_state = 2},
  [1926] = {.lex_state = 0, .external_lex_state = 2},
  [1927] = {.lex_state = 0, .external_lex_state = 2},
  [1928] = {.lex_state = 0, .external_lex_state = 2},
  [1929] = {.lex_state = 0, .external_lex_state = 2},
  [1930] = {.lex_state = 0, .external_lex_state = 2},
  [1931] = {.lex_state = 0, .external_lex_state = 2},
  [1932] = {.lex_state = 0, .external_lex_state = 2},
  [1933] = {.lex_state = 0, .external_lex_state = 2},
  [1934] = {.lex_state = 0, .external_lex_state = 2},
  [1935] = {.lex_state = 0, .external_lex_state = 4},
  [1936] = {.lex_state = 0, .external_lex_state = 4},
  [1937] = {.lex_state = 0, .external_lex_state = 2},
  [1938] = {.lex_state = 0, .external_lex_state = 2},
  [1939] = {.lex_state = 44, .external_lex_state = 2},
  [1940] = {.lex_state = 0, .external_lex_state = 2},
  [1941] = {.lex_state = 0, .external_lex_state = 2},
  [1942] = {.lex_state = 0, .external_lex_state = 4},
  [1943] = {.lex_state = 0, .external_lex_state = 2},
  [1944] = {.lex_state = 0, .external_lex_state = 2},
  [1945] = {.lex_state = 0, .external_lex_state = 2},
  [1946] = {.lex_state = 0, .external_lex_state = 2},
  [1947] = {.lex_state = 0, .external_lex_state = 2},
  [1948] = {.lex_state = 0, .external_lex_state = 2},
  [1949] = {.lex_state = 0, .external_lex_state = 2},
  [1950] = {.lex_state = 0, .external_lex_state = 2},
  [1951] = {.lex_state = 0, .external_lex_state = 2},
  [1952] = {.lex_state = 0, .external_lex_state = 2},
  [1953] = {.lex_state = 0, .external_lex_state = 2},
  [1954] = {.lex_state = 0, .external_lex_state = 2},
  [1955] = {.lex_state = 0, .external_lex_state = 2},
  [1956] = {.lex_state = 0, .external_lex_state = 2},
  [1957] = {.lex_state = 0, .external_lex_state = 2},
  [1958] = {.lex_state = 0, .external_lex_state = 2},
  [1959] = {.lex_state = 0, .external_lex_state = 2},
  [1960] = {.lex_state = 0, .external_lex_state = 2},
  [1961] = {.lex_state = 44, .external_lex_state = 2},
  [1962] = {.lex_state = 0, .external_lex_state = 2},
  [1963] = {.lex_state = 0, .external_lex_state = 2},
  [1964] = {.lex_state = 0, .external_lex_state = 2},
  [1965] = {.lex_state = 0, .external_lex_state = 2},
  [1966] = {.lex_state = 0, .external_lex_state = 2},
  [1967] = {.lex_state = 0, .external_lex_state = 2},
  [1968] = {.lex_state = 0, .external_lex_state = 2},
  [1969] = {.lex_state = 0, .external_lex_state = 2},
  [1970] = {.lex_state = 0, .external_lex_state = 2},
  [1971] = {.lex_state = 0, .external_lex_state = 2},
  [1972] = {.lex_state = 0, .external_lex_state = 2},
  [1973] = {.lex_state = 0, .external_lex_state = 2},
  [1974] = {.lex_state = 0, .external_lex_state = 2},
  [1975] = {.lex_state = 0, .external_lex_state = 2},
  [1976] = {.lex_state = 0, .external_lex_state = 2},
  [1977] = {.lex_state = 0, .external_lex_state = 2},
  [1978] = {.lex_state = 0, .external_lex_state = 2},
  [1979] = {.lex_state = 0, .external_lex_state = 2},
  [1980] = {.lex_state = 0, .external_lex_state = 2},
  [1981] = {.lex_state = 0, .external_lex_state = 2},
  [1982] = {.lex_state = 44, .external_lex_state = 2},
  [1983] = {.lex_state = 0, .external_lex_state = 2},
  [1984] = {.lex_state = 0, .external_lex_state = 2},
  [1985] = {.lex_state = 0, .external_lex_state = 2},
  [1986] = {.lex_state = 0, .external_lex_state = 2},
  [1987] = {.lex_state = 0, .external_lex_state = 2},
  [1988] = {.lex_state = 0, .external_lex_state = 2},
  [1989] = {.lex_state = 0, .external_lex_state = 2},
  [1990] = {.lex_state = 0, .external_lex_state = 2},
  [1991] = {.lex_state = 0, .external_lex_state = 2},
  [1992] = {.lex_state = 0, .external_lex_state = 2},
  [1993] = {.lex_state = 0, .external_lex_state = 2},
  [1994] = {.lex_state = 0, .external_lex_state = 2},
  [1995] = {.lex_state = 0, .external_lex_state = 2},
  [1996] = {.lex_state = 0, .external_lex_state = 2},
  [1997] = {.lex_state = 0, .external_lex_state = 4},
  [1998] = {.lex_state = 0, .external_lex_state = 2},
  [1999] = {.lex_state = 0, .external_lex_state = 2},
  [2000] = {.lex_state = 5, .external_lex_state = 2},
  [2001] = {.lex_state = 0, .external_lex_state = 2},
  [2002] = {.lex_state = 0, .external_lex_state = 2},
  [2003] = {.lex_state = 0, .external_lex_state = 2},
  [2004] = {.lex_state = 0, .external_lex_state = 2},
  [2005] = {.lex_state = 0, .external_lex_state = 2},
  [2006] = {.lex_state = 0, .external_lex_state = 2},
  [2007] = {.lex_state = 0, .external_lex_state = 2},
  [2008] = {.lex_state = 0, .external_lex_state = 2},
  [2009] = {.lex_state = 0, .external_lex_state = 2},
  [2010] = {.lex_state = 0, .external_lex_state = 2},
  [2011] = {.lex_state = 0, .external_lex_state = 2},
  [2012] = {.lex_state = 0, .external_lex_state = 2},
  [2013] = {.lex_state = 0, .external_lex_state = 2},
  [2014] = {.lex_state = 0, .external_lex_state = 2},
  [2015] = {.lex_state = 0, .external_lex_state = 2},
  [2016] = {.lex_state = 0, .external_lex_state = 2},
  [2017] = {.lex_state = 0, .external_lex_state = 4},
  [2018] = {.lex_state = 0, .external_lex_state = 2},
  [2019] = {.lex_state = 0, .external_lex_state = 4},
  [2020] = {.lex_state = 0, .external_lex_state = 2},
  [2021] = {.lex_state = 0, .external_lex_state = 2},
  [2022] = {.lex_state = 0, .external_lex_state = 2},
  [2023] = {.lex_state = 0, .external_lex_state = 2},
  [2024] = {.lex_state = 0, .external_lex_state = 2},
  [2025] = {.lex_state = 0, .external_lex_state = 2},
  [2026] = {.lex_state = 0, .external_lex_state = 2},
  [2027] = {.lex_state = 0, .external_lex_state = 2},
  [2028] = {.lex_state = 0, .external_lex_state = 2},
  [2029] = {.lex_state = 0, .external_lex_state = 2},
  [2030] = {.lex_state = 0, .external_lex_state = 2},
  [2031] = {.lex_state = 0, .external_lex_state = 2},
  [2032] = {.lex_state = 0, .external_lex_state = 2},
  [2033] = {.lex_state = 0, .external_lex_state = 2},
  [2034] = {.lex_state = 0, .external_lex_state = 2},
  [2035] = {.lex_state = 0, .external_lex_state = 2},
  [2036] = {.lex_state = 0, .external_lex_state = 2},
  [2037] = {.lex_state = 0, .external_lex_state = 2},
  [2038] = {.lex_state = 0, .external_lex_state = 2},
  [2039] = {.lex_state = 0, .external_lex_state = 2},
  [2040] = {.lex_state = 0, .external_lex_state = 2},
  [2041] = {.lex_state = 0, .external_lex_state = 2},
  [2042] = {.lex_state = 0, .external_lex_state = 2},
  [2043] = {.lex_state = 0, .external_lex_state = 2},
  [2044] = {.lex_state = 0, .external_lex_state = 2},
  [2045] = {.lex_state = 0, .external_lex_state = 2},
  [2046] = {.lex_state = 0, .external_lex_state = 2},
  [2047] = {.lex_state = 0, .external_lex_state = 2},
  [2048] = {.lex_state = 0, .external_lex_state = 2},
  [2049] = {.lex_state = 0, .external_lex_state = 2},
  [2050] = {.lex_state = 0, .external_lex_state = 2},
  [2051] = {.lex_state = 0, .external_lex_state = 2},
  [2052] = {.lex_state = 0, .external_lex_state = 2},
  [2053] = {.lex_state = 0, .external_lex_state = 2},
  [2054] = {.lex_state = 0, .external_lex_state = 2},
  [2055] = {.lex_state = 0, .external_lex_state = 2},
  [2056] = {.lex_state = 0, .external_lex_state = 2},
  [2057] = {.lex_state = 0, .external_lex_state = 2},
  [2058] = {.lex_state = 0, .external_lex_state = 2},
  [2059] = {.lex_state = 0, .external_lex_state = 2},
  [2060] = {.lex_state = 0, .external_lex_state = 2},
  [2061] = {.lex_state = 0, .external_lex_state = 2},
  [2062] = {.lex_state = 0, .external_lex_state = 4},
  [2063] = {.lex_state = 0, .external_lex_state = 2},
  [2064] = {.lex_state = 0, .external_lex_state = 4},
  [2065] = {.lex_state = 0, .external_lex_state = 2},
  [2066] = {.lex_state = 0, .external_lex_state = 2},
  [2067] = {.lex_state = 0, .external_lex_state = 2},
  [2068] = {.lex_state = 0, .external_lex_state = 4},
  [2069] = {.lex_state = 0, .external_lex_state = 2},
  [2070] = {.lex_state = 0, .external_lex_state = 4},
  [2071] = {.lex_state = 0, .external_lex_state = 4},
  [2072] = {.lex_state = 0, .external_lex_state = 2},
  [2073] = {.lex_state = 0, .external_lex_state = 2},
  [2074] = {.lex_state = 0, .external_lex_state = 4},
  [2075] = {.lex_state = 0, .external_lex_state = 2},
  [2076] = {.lex_state = 0, .external_lex_state = 4},
  [2077] = {.lex_state = 0, .external_lex_state = 2},
  [2078] = {.lex_state = 0, .external_lex_state = 2},
  [2079] = {.lex_state = 0, .external_lex_state = 2},
  [2080] = {.lex_state = 0, .external_lex_state = 2},
  [2081] = {.lex_state = 0, .external_lex_state = 2},
  [2082] = {.lex_state = 0, .external_lex_state = 2},
  [2083] = {.lex_state = 0, .external_lex_state = 2},
  [2084] = {.lex_state = 0, .external_lex_state = 2},
  [2085] = {.lex_state = 0, .external_lex_state = 2},
  [2086] = {.lex_state = 0, .external_lex_state = 2},
  [2087] = {.lex_state = 0, .external_lex_state = 4},
  [2088] = {.lex_state = 0, .external_lex_state = 4},
  [2089] = {.lex_state = 0, .external_lex_state = 2},
  [2090] = {.lex_state = 0, .external_lex_state = 2},
  [2091] = {.lex_state = 0, .external_lex_state = 2},
  [2092] = {.lex_state = 0, .external_lex_state = 2},
  [2093] = {.lex_state = 0, .external_lex_state = 2},
  [2094] = {.lex_state = 0, .external_lex_state = 2},
  [2095] = {.lex_state = 0, .external_lex_state = 2},
  [2096] = {.lex_state = 0, .external_lex_state = 2},
  [2097] = {.lex_state = 0, .external_lex_state = 2},
  [2098] = {.lex_state = 0, .external_lex_state = 2},
  [2099] = {.lex_state = 0, .external_lex_state = 2},
  [2100] = {.lex_state = 0, .external_lex_state = 2},
  [2101] = {.lex_state = 0, .external_lex_state = 2},
  [2102] = {.lex_state = 0, .external_lex_state = 2},
  [2103] = {.lex_state = 0, .external_lex_state = 2},
  [2104] = {.lex_state = 0, .external_lex_state = 2},
  [2105] = {.lex_state = 0, .external_lex_state = 2},
  [2106] = {.lex_state = 0, .external_lex_state = 2},
  [2107] = {.lex_state = 0, .external_lex_state = 2},
  [2108] = {.lex_state = 0, .external_lex_state = 2},
  [2109] = {.lex_state = 0, .external_lex_state = 2},
  [2110] = {.lex_state = 0, .external_lex_state = 4},
  [2111] = {.lex_state = 0, .external_lex_state = 4},
  [2112] = {.lex_state = 0, .external_lex_state = 2},
  [2113] = {.lex_state = 0, .external_lex_state = 2},
  [2114] = {.lex_state = 44, .external_lex_state = 2},
  [2115] = {.lex_state = 0, .external_lex_state = 2},
  [2116] = {.lex_state = 0, .external_lex_state = 2},
  [2117] = {.lex_state = 0, .external_lex_state = 2},
  [2118] = {.lex_state = 0, .external_lex_state = 2},
  [2119] = {.lex_state = 0, .external_lex_state = 2},
  [2120] = {.lex_state = 44, .external_lex_state = 2},
  [2121] = {.lex_state = 44, .external_lex_state = 2},
  [2122] = {.lex_state = 44, .external_lex_state = 2},
  [2123] = {.lex_state = 44, .external_lex_state = 2},
  [2124] = {.lex_state = 0, .external_lex_state = 2},
  [2125] = {.lex_state = 0, .external_lex_state = 2},
  [2126] = {.lex_state = 0, .external_lex_state = 2},
  [2127] = {.lex_state = 0, .external_lex_state = 2},
  [2128] = {.lex_state = 44, .external_lex_state = 2},
  [2129] = {.lex_state = 0, .external_lex_state = 2},
  [2130] = {.lex_state = 0, .external_lex_state = 2},
  [2131] = {.lex_state = 44, .external_lex_state = 2},
  [2132] = {.lex_state = 0, .external_lex_state = 2},
  [2133] = {.lex_state = 44, .external_lex_state = 2},
  [2134] = {.lex_state = 44, .external_lex_state = 2},
  [2135] = {.lex_state = 44, .external_lex_state = 2},
  [2136] = {.lex_state = 44, .external_lex_state = 2},
  [2137] = {.lex_state = 0, .external_lex_state = 2},
  [2138] = {.lex_state = 0, .external_lex_state = 2},
  [2139] = {.lex_state = 44, .external_lex_state = 2},
  [2140] = {.lex_state = 44, .external_lex_state = 2},
  [2141] = {.lex_state = 44, .external_lex_state = 2},
  [2142] = {.lex_state = 44, .external_lex_state = 2},
  [2143] = {.lex_state = 44, .external_lex_state = 2},
  [2144] = {.lex_state = 44, .external_lex_state = 2},
  [2145] = {.lex_state = 44, .external_lex_state = 2},
  [2146] = {.lex_state = 0, .external_lex_state = 2},
  [2147] = {.lex_state = 44, .external_lex_state = 2},
  [2148] = {.lex_state = 44, .external_lex_state = 2},
  [2149] = {.lex_state = 44, .external_lex_state = 2},
  [2150] = {.lex_state = 0, .external_lex_state = 2},
  [2151] = {.lex_state = 44, .external_lex_state = 2},
  [2152] = {.lex_state = 44, .external_lex_state = 2},
  [2153] = {.lex_state = 0, .external_lex_state = 2},
  [2154] = {.lex_state = 0, .external_lex_state = 2},
  [2155] = {.lex_state = 44, .external_lex_state = 2},
  [2156] = {.lex_state = 0, .external_lex_state = 2},
  [2157] = {.lex_state = 0, .external_lex_state = 2},
  [2158] = {.lex_state = 44, .external_lex_state = 2},
  [2159] = {.lex_state = 0, .external_lex_state = 2},
  [2160] = {.lex_state = 0, .external_lex_state = 2},
  [2161] = {.lex_state = 44, .external_lex_state = 2},
  [2162] = {.lex_state = 44, .external_lex_state = 2},
  [2163] = {.lex_state = 0, .external_lex_state = 2},
  [2164] = {.lex_state = 44, .external_lex_state = 2},
  [2165] = {.lex_state = 44, .external_lex_state = 2},
  [2166] = {.lex_state = 44, .external_lex_state = 2},
  [2167] = {.lex_state = 44, .external_lex_state = 2},
  [2168] = {.lex_state = 44, .external_lex_state = 2},
  [2169] = {.lex_state = 0, .external_lex_state = 2},
  [2170] = {.lex_state = 44, .external_lex_state = 2},
  [2171] = {.lex_state = 0, .external_lex_state = 2},
  [2172] = {.lex_state = 44, .external_lex_state = 2},
  [2173] = {.lex_state = 44, .external_lex_state = 2},
  [2174] = {.lex_state = 44, .external_lex_state = 2},
  [2175] = {.lex_state = 0, .external_lex_state = 2},
  [2176] = {.lex_state = 44, .external_lex_state = 2},
  [2177] = {.lex_state = 44, .external_lex_state = 2},
  [2178] = {.lex_state = 0, .external_lex_state = 2},
  [2179] = {.lex_state = 0, .external_lex_state = 2},
  [2180] = {.lex_state = 0, .external_lex_state = 2},
  [2181] = {.lex_state = 44, .external_lex_state = 2},
  [2182] = {.lex_state = 0, .external_lex_state = 2},
  [2183] = {.lex_state = 44, .external_lex_state = 2},
  [2184] = {.lex_state = 0, .external_lex_state = 2},
  [2185] = {.lex_state = 0, .external_lex_state = 2},
  [2186] = {.lex_state = 0, .external_lex_state = 2},
  [2187] = {.lex_state = 44, .external_lex_state = 2},
  [2188] = {.lex_state = 44, .external_lex_state = 2},
  [2189] = {.lex_state = 0, .external_lex_state = 2},
  [2190] = {.lex_state = 0, .external_lex_state = 2},
  [2191] = {.lex_state = 0, .external_lex_state = 2},
  [2192] = {.lex_state = 0, .external_lex_state = 2},
  [2193] = {.lex_state = 0, .external_lex_state = 2},
  [2194] = {.lex_state = 0, .external_lex_state = 2},
  [2195] = {.lex_state = 0, .external_lex_state = 2},
  [2196] = {.lex_state = 0, .external_lex_state = 2},
  [2197] = {.lex_state = 0, .external_lex_state = 2},
  [2198] = {.lex_state = 0, .external_lex_state = 2},
  [2199] = {.lex_state = 0, .external_lex_state = 2},
  [2200] = {.lex_state = 0, .external_lex_state = 2},
  [2201] = {.lex_state = 0, .external_lex_state = 2},
  [2202] = {.lex_state = 0, .external_lex_state = 2},
  [2203] = {.lex_state = 0, .external_lex_state = 2},
  [2204] = {.lex_state = 0, .external_lex_state = 2},
  [2205] = {.lex_state = 0, .external_lex_state = 2},
  [2206] = {.lex_state = 0, .external_lex_state = 2},
  [2207] = {.lex_state = 0, .external_lex_state = 2},
  [2208] = {.lex_state = 0, .external_lex_state = 2},
  [2209] = {.lex_state = 0, .external_lex_state = 2},
  [2210] = {.lex_state = 0, .external_lex_state = 2},
  [2211] = {.lex_state = 0, .external_lex_state = 2},
  [2212] = {.lex_state = 0, .external_lex_state = 2},
  [2213] = {.lex_state = 0, .external_lex_state = 2},
  [2214] = {.lex_state = 0, .external_lex_state = 2},
  [2215] = {.lex_state = 0, .external_lex_state = 2},
  [2216] = {.lex_state = 0, .external_lex_state = 2},
  [2217] = {.lex_state = 0, .external_lex_state = 2},
  [2218] = {.lex_state = 0, .external_lex_state = 2},
  [2219] = {.lex_state = 0, .external_lex_state = 2},
  [2220] = {.lex_state = 0, .external_lex_state = 2},
  [2221] = {.lex_state = 0, .external_lex_state = 2},
  [2222] = {.lex_state = 0, .external_lex_state = 2},
  [2223] = {.lex_state = 0, .external_lex_state = 2},
  [2224] = {.lex_state = 0, .external_lex_state = 2},
  [2225] = {.lex_state = 0, .external_lex_state = 2},
  [2226] = {.lex_state = 0, .external_lex_state = 2},
  [2227] = {.lex_state = 0, .external_lex_state = 2},
  [2228] = {.lex_state = 0, .external_lex_state = 2},
  [2229] = {.lex_state = 0, .external_lex_state = 2},
  [2230] = {.lex_state = 0, .external_lex_state = 2},
  [2231] = {.lex_state = 0, .external_lex_state = 2},
  [2232] = {.lex_state = 0, .external_lex_state = 2},
  [2233] = {.lex_state = 0, .external_lex_state = 2},
  [2234] = {.lex_state = 0, .external_lex_state = 2},
  [2235] = {.lex_state = 0, .external_lex_state = 2},
  [2236] = {.lex_state = 0, .external_lex_state = 2},
  [2237] = {.lex_state = 0, .external_lex_state = 2},
  [2238] = {.lex_state = 0, .external_lex_state = 2},
  [2239] = {.lex_state = 0, .external_lex_state = 2},
  [2240] = {.lex_state = 0, .external_lex_state = 2},
  [2241] = {.lex_state = 0, .external_lex_state = 2},
  [2242] = {.lex_state = 0, .external_lex_state = 2},
  [2243] = {.lex_state = 0, .external_lex_state = 2},
  [2244] = {.lex_state = 0, .external_lex_state = 2},
  [2245] = {.lex_state = 0, .external_lex_state = 2},
  [2246] = {.lex_state = 0, .external_lex_state = 2},
  [2247] = {.lex_state = 0, .external_lex_state = 2},
  [2248] = {.lex_state = 0, .external_lex_state = 2},
  [2249] = {.lex_state = 0, .external_lex_state = 2},
  [2250] = {.lex_state = 0, .external_lex_state = 2},
  [2251] = {.lex_state = 0, .external_lex_state = 2},
  [2252] = {.lex_state = 0, .external_lex_state = 2},
  [2253] = {.lex_state = 0, .external_lex_state = 2},
  [2254] = {.lex_state = 0, .external_lex_state = 2},
  [2255] = {.lex_state = 0, .external_lex_state = 2},
  [2256] = {.lex_state = 0, .external_lex_state = 2},
  [2257] = {.lex_state = 0, .external_lex_state = 2},
  [2258] = {.lex_state = 0, .external_lex_state = 2},
  [2259] = {.lex_state = 0, .external_lex_state = 2},
  [2260] = {.lex_state = 0, .external_lex_state = 2},
  [2261] = {.lex_state = 0, .external_lex_state = 2},
  [2262] = {.lex_state = 0, .external_lex_state = 2},
  [2263] = {.lex_state = 0, .external_lex_state = 2},
  [2264] = {.lex_state = 0, .external_lex_state = 2},
  [2265] = {.lex_state = 44, .external_lex_state = 2},
  [2266] = {.lex_state = 0, .external_lex_state = 2},
  [2267] = {.lex_state = 0, .external_lex_state = 2},
  [2268] = {.lex_state = 0, .external_lex_state = 2},
  [2269] = {.lex_state = 0, .external_lex_state = 2},
  [2270] = {.lex_state = 0, .external_lex_state = 2},
  [2271] = {.lex_state = 0, .external_lex_state = 2},
  [2272] = {.lex_state = 0, .external_lex_state = 2},
  [2273] = {.lex_state = 0, .external_lex_state = 2},
  [2274] = {.lex_state = 0, .external_lex_state = 2},
  [2275] = {.lex_state = 0, .external_lex_state = 2},
  [2276] = {.lex_state = 0, .external_lex_state = 2},
  [2277] = {.lex_state = 0, .external_lex_state = 2},
  [2278] = {.lex_state = 0, .external_lex_state = 2},
  [2279] = {.lex_state = 0, .external_lex_state = 2},
  [2280] = {.lex_state = 0, .external_lex_state = 2},
  [2281] = {.lex_state = 0, .external_lex_state = 2},
  [2282] = {.lex_state = 0, .external_lex_state = 2},
  [2283] = {.lex_state = 0, .external_lex_state = 2},
  [2284] = {.lex_state = 0, .external_lex_state = 2},
  [2285] = {.lex_state = 0, .external_lex_state = 2},
  [2286] = {.lex_state = 0, .external_lex_state = 2},
  [2287] = {.lex_state = 0, .external_lex_state = 2},
  [2288] = {.lex_state = 0, .external_lex_state = 2},
  [2289] = {.lex_state = 0, .external_lex_state = 2},
  [2290] = {.lex_state = 0, .external_lex_state = 2},
  [2291] = {.lex_state = 0, .external_lex_state = 2},
  [2292] = {.lex_state = 0, .external_lex_state = 2},
  [2293] = {.lex_state = 0, .external_lex_state = 2},
  [2294] = {.lex_state = 0, .external_lex_state = 2},
  [2295] = {.lex_state = 0, .external_lex_state = 2},
  [2296] = {.lex_state = 0, .external_lex_state = 2},
  [2297] = {.lex_state = 0, .external_lex_state = 2},
  [2298] = {.lex_state = 0, .external_lex_state = 2},
  [2299] = {.lex_state = 0, .external_lex_state = 2},
  [2300] = {.lex_state = 0, .external_lex_state = 2},
  [2301] = {.lex_state = 0, .external_lex_state = 2},
  [2302] = {.lex_state = 0, .external_lex_state = 2},
  [2303] = {.lex_state = 0, .external_lex_state = 2},
  [2304] = {.lex_state = 0, .external_lex_state = 2},
  [2305] = {.lex_state = 0, .external_lex_state = 2},
  [2306] = {.lex_state = 0, .external_lex_state = 2},
  [2307] = {.lex_state = 0, .external_lex_state = 2},
  [2308] = {.lex_state = 0, .external_lex_state = 2},
  [2309] = {.lex_state = 0, .external_lex_state = 2},
  [2310] = {.lex_state = 0, .external_lex_state = 2},
  [2311] = {.lex_state = 0, .external_lex_state = 2},
  [2312] = {.lex_state = 0, .external_lex_state = 2},
  [2313] = {.lex_state = 0, .external_lex_state = 2},
  [2314] = {.lex_state = 0, .external_lex_state = 2},
  [2315] = {.lex_state = 0, .external_lex_state = 2},
  [2316] = {.lex_state = 0, .external_lex_state = 2},
  [2317] = {.lex_state = 0, .external_lex_state = 2},
  [2318] = {.lex_state = 0, .external_lex_state = 2},
  [2319] = {.lex_state = 0, .external_lex_state = 2},
  [2320] = {.lex_state = 0, .external_lex_state = 2},
  [2321] = {.lex_state = 0, .external_lex_state = 2},
  [2322] = {.lex_state = 0, .external_lex_state = 2},
  [2323] = {.lex_state = 0, .external_lex_state = 2},
  [2324] = {.lex_state = 0, .external_lex_state = 2},
  [2325] = {.lex_state = 0, .external_lex_state = 2},
  [2326] = {.lex_state = 0, .external_lex_state = 2},
  [2327] = {.lex_state = 0, .external_lex_state = 2},
  [2328] = {.lex_state = 0, .external_lex_state = 2},
  [2329] = {.lex_state = 0, .external_lex_state = 2},
  [2330] = {.lex_state = 0, .external_lex_state = 2},
  [2331] = {.lex_state = 0, .external_lex_state = 2},
  [2332] = {.lex_state = 0, .external_lex_state = 2},
  [2333] = {.lex_state = 0, .external_lex_state = 2},
  [2334] = {.lex_state = 0, .external_lex_state = 2},
  [2335] = {.lex_state = 0, .external_lex_state = 2},
  [2336] = {.lex_state = 0, .external_lex_state = 2},
  [2337] = {.lex_state = 0, .external_lex_state = 2},
  [2338] = {.lex_state = 0, .external_lex_state = 2},
  [2339] = {.lex_state = 0, .external_lex_state = 2},
  [2340] = {.lex_state = 0, .external_lex_state = 2},
  [2341] = {.lex_state = 0, .external_lex_state = 2},
  [2342] = {.lex_state = 0, .external_lex_state = 2},
  [2343] = {.lex_state = 0, .external_lex_state = 2},
  [2344] = {.lex_state = 0, .external_lex_state = 2},
  [2345] = {.lex_state = 0, .external_lex_state = 2},
  [2346] = {.lex_state = 0, .external_lex_state = 2},
  [2347] = {.lex_state = 0, .external_lex_state = 2},
  [2348] = {.lex_state = 0, .external_lex_state = 2},
  [2349] = {.lex_state = 0, .external_lex_state = 2},
  [2350] = {.lex_state = 0, .external_lex_state = 2},
  [2351] = {.lex_state = 0, .external_lex_state = 2},
  [2352] = {.lex_state = 0, .external_lex_state = 2},
  [2353] = {.lex_state = 0, .external_lex_state = 2},
  [2354] = {.lex_state = 0, .external_lex_state = 2},
  [2355] = {.lex_state = 0, .external_lex_state = 2},
  [2356] = {.lex_state = 0, .external_lex_state = 2},
  [2357] = {.lex_state = 0, .external_lex_state = 2},
  [2358] = {.lex_state = 0, .external_lex_state = 2},
  [2359] = {.lex_state = 0, .external_lex_state = 2},
  [2360] = {.lex_state = 0, .external_lex_state = 2},
  [2361] = {.lex_state = 0, .external_lex_state = 2},
  [2362] = {.lex_state = 0, .external_lex_state = 2},
  [2363] = {.lex_state = 0, .external_lex_state = 2},
  [2364] = {.lex_state = 0, .external_lex_state = 2},
  [2365] = {.lex_state = 0, .external_lex_state = 2},
  [2366] = {.lex_state = 0, .external_lex_state = 2},
  [2367] = {.lex_state = 0, .external_lex_state = 2},
  [2368] = {.lex_state = 0, .external_lex_state = 2},
  [2369] = {.lex_state = 0, .external_lex_state = 2},
  [2370] = {.lex_state = 0, .external_lex_state = 2},
  [2371] = {.lex_state = 0, .external_lex_state = 2},
  [2372] = {.lex_state = 0, .external_lex_state = 2},
  [2373] = {.lex_state = 0, .external_lex_state = 2},
  [2374] = {.lex_state = 0, .external_lex_state = 2},
  [2375] = {.lex_state = 0, .external_lex_state = 2},
  [2376] = {.lex_state = 0, .external_lex_state = 2},
  [2377] = {.lex_state = 44, .external_lex_state = 2},
  [2378] = {.lex_state = 0, .external_lex_state = 2},
  [2379] = {.lex_state = 0, .external_lex_state = 2},
  [2380] = {.lex_state = 0, .external_lex_state = 2},
  [2381] = {.lex_state = 0, .external_lex_state = 2},
  [2382] = {.lex_state = 0, .external_lex_state = 2},
  [2383] = {.lex_state = 0, .external_lex_state = 2},
  [2384] = {.lex_state = 0, .external_lex_state = 2},
  [2385] = {.lex_state = 0, .external_lex_state = 2},
  [2386] = {.lex_state = 0, .external_lex_state = 2},
  [2387] = {.lex_state = 0, .external_lex_state = 2},
  [2388] = {.lex_state = 0, .external_lex_state = 2},
  [2389] = {.lex_state = 0, .external_lex_state = 2},
  [2390] = {.lex_state = 0, .external_lex_state = 2},
  [2391] = {.lex_state = 0, .external_lex_state = 2},
  [2392] = {.lex_state = 0, .external_lex_state = 2},
  [2393] = {.lex_state = 0, .external_lex_state = 2},
  [2394] = {.lex_state = 0, .external_lex_state = 2},
  [2395] = {.lex_state = 0, .external_lex_state = 2},
  [2396] = {.lex_state = 0, .external_lex_state = 2},
  [2397] = {.lex_state = 0, .external_lex_state = 2},
  [2398] = {.lex_state = 0, .external_lex_state = 2},
  [2399] = {.lex_state = 0, .external_lex_state = 2},
  [2400] = {.lex_state = 0, .external_lex_state = 2},
  [2401] = {.lex_state = 0, .external_lex_state = 2},
  [2402] = {.lex_state = 0, .external_lex_state = 2},
  [2403] = {.lex_state = 0, .external_lex_state = 2},
  [2404] = {.lex_state = 0, .external_lex_state = 2},
  [2405] = {.lex_state = 0, .external_lex_state = 2},
  [2406] = {.lex_state = 0, .external_lex_state = 2},
  [2407] = {.lex_state = 0, .external_lex_state = 2},
  [2408] = {.lex_state = 0, .external_lex_state = 2},
  [2409] = {.lex_state = 0, .external_lex_state = 2},
  [2410] = {.lex_state = 0, .external_lex_state = 2},
  [2411] = {.lex_state = 0, .external_lex_state = 2},
  [2412] = {.lex_state = 0, .external_lex_state = 2},
  [2413] = {.lex_state = 0, .external_lex_state = 2},
  [2414] = {.lex_state = 0, .external_lex_state = 2},
  [2415] = {.lex_state = 0, .external_lex_state = 2},
  [2416] = {.lex_state = 0, .external_lex_state = 2},
  [2417] = {.lex_state = 0, .external_lex_state = 2},
  [2418] = {.lex_state = 0, .external_lex_state = 2},
  [2419] = {.lex_state = 0, .external_lex_state = 2},
  [2420] = {.lex_state = 0, .external_lex_state = 2},
  [2421] = {.lex_state = 0, .external_lex_state = 2},
  [2422] = {.lex_state = 0, .external_lex_state = 2},
  [2423] = {.lex_state = 0, .external_lex_state = 2},
  [2424] = {.lex_state = 0, .external_lex_state = 2},
  [2425] = {.lex_state = 0, .external_lex_state = 2},
  [2426] = {.lex_state = 0, .external_lex_state = 2},
  [2427] = {.lex_state = 0, .external_lex_state = 2},
  [2428] = {.lex_state = 0, .external_lex_state = 2},
  [2429] = {.lex_state = 0, .external_lex_state = 2},
  [2430] = {.lex_state = 0, .external_lex_state = 2},
  [2431] = {.lex_state = 0, .external_lex_state = 2},
  [2432] = {.lex_state = 0, .external_lex_state = 2},
  [2433] = {.lex_state = 0, .external_lex_state = 2},
  [2434] = {.lex_state = 0, .external_lex_state = 2},
  [2435] = {.lex_state = 0, .external_lex_state = 2},
  [2436] = {.lex_state = 0, .external_lex_state = 2},
  [2437] = {.lex_state = 0, .external_lex_state = 2},
  [2438] = {.lex_state = 0, .external_lex_state = 2},
  [2439] = {.lex_state = 0, .external_lex_state = 2},
  [2440] = {.lex_state = 0, .external_lex_state = 2},
  [2441] = {.lex_state = 0, .external_lex_state = 2},
  [2442] = {.lex_state = 0, .external_lex_state = 2},
  [2443] = {.lex_state = 0, .external_lex_state = 2},
  [2444] = {.lex_state = 0, .external_lex_state = 2},
  [2445] = {.lex_state = 0, .external_lex_state = 2},
  [2446] = {.lex_state = 0, .external_lex_state = 2},
  [2447] = {.lex_state = 0, .external_lex_state = 2},
  [2448] = {.lex_state = 0, .external_lex_state = 2},
  [2449] = {.lex_state = 0, .external_lex_state = 2},
  [2450] = {.lex_state = 0, .external_lex_state = 2},
  [2451] = {.lex_state = 0, .external_lex_state = 2},
  [2452] = {.lex_state = 0, .external_lex_state = 2},
  [2453] = {.lex_state = 0, .external_lex_state = 2},
  [2454] = {.lex_state = 0, .external_lex_state = 2},
  [2455] = {.lex_state = 0, .external_lex_state = 2},
  [2456] = {.lex_state = 0, .external_lex_state = 2},
  [2457] = {.lex_state = 0, .external_lex_state = 2},
  [2458] = {.lex_state = 0, .external_lex_state = 2},
  [2459] = {.lex_state = 0, .external_lex_state = 2},
  [2460] = {.lex_state = 0, .external_lex_state = 2},
  [2461] = {.lex_state = 0, .external_lex_state = 2},
  [2462] = {.lex_state = 0, .external_lex_state = 2},
  [2463] = {.lex_state = 0, .external_lex_state = 2},
  [2464] = {.lex_state = 0, .external_lex_state = 2},
  [2465] = {.lex_state = 0, .external_lex_state = 2},
  [2466] = {.lex_state = 0, .external_lex_state = 2},
  [2467] = {.lex_state = 0, .external_lex_state = 2},
  [2468] = {.lex_state = 0, .external_lex_state = 2},
  [2469] = {.lex_state = 0, .external_lex_state = 2},
  [2470] = {.lex_state = 0, .external_lex_state = 2},
  [2471] = {.lex_state = 0, .external_lex_state = 2},
  [2472] = {.lex_state = 0, .external_lex_state = 2},
  [2473] = {.lex_state = 0, .external_lex_state = 2},
  [2474] = {.lex_state = 0, .external_lex_state = 2},
  [2475] = {.lex_state = 0, .external_lex_state = 2},
  [2476] = {.lex_state = 0, .external_lex_state = 2},
  [2477] = {.lex_state = 0, .external_lex_state = 2},
  [2478] = {.lex_state = 0, .external_lex_state = 2},
  [2479] = {.lex_state = 0, .external_lex_state = 2},
  [2480] = {.lex_state = 0, .external_lex_state = 2},
  [2481] = {.lex_state = 0, .external_lex_state = 2},
  [2482] = {.lex_state = 0, .external_lex_state = 2},
  [2483] = {.lex_state = 0, .external_lex_state = 2},
  [2484] = {.lex_state = 0, .external_lex_state = 2},
  [2485] = {.lex_state = 0, .external_lex_state = 2},
  [2486] = {.lex_state = 0, .external_lex_state = 2},
  [2487] = {.lex_state = 0, .external_lex_state = 2},
  [2488] = {.lex_state = 0, .external_lex_state = 2},
  [2489] = {.lex_state = 0, .external_lex_state = 2},
  [2490] = {.lex_state = 0, .external_lex_state = 2},
  [2491] = {.lex_state = 0, .external_lex_state = 2},
  [2492] = {.lex_state = 0, .external_lex_state = 2},
  [2493] = {.lex_state = 0, .external_lex_state = 2},
  [2494] = {.lex_state = 0, .external_lex_state = 2},
  [2495] = {.lex_state = 0, .external_lex_state = 2},
  [2496] = {.lex_state = 0, .external_lex_state = 2},
  [2497] = {.lex_state = 0, .external_lex_state = 2},
  [2498] = {.lex_state = 0, .external_lex_state = 2},
  [2499] = {.lex_state = 0, .external_lex_state = 2},
  [2500] = {.lex_state = 0, .external_lex_state = 2},
  [2501] = {.lex_state = 0, .external_lex_state = 2},
  [2502] = {.lex_state = 0, .external_lex_state = 2},
  [2503] = {.lex_state = 0, .external_lex_state = 2},
  [2504] = {.lex_state = 0, .external_lex_state = 2},
  [2505] = {.lex_state = 44, .external_lex_state = 2},
  [2506] = {.lex_state = 44, .external_lex_state = 2},
  [2507] = {.lex_state = 0, .external_lex_state = 2},
  [2508] = {.lex_state = 0, .external_lex_state = 2},
  [2509] = {.lex_state = 0, .external_lex_state = 2},
  [2510] = {.lex_state = 44, .external_lex_state = 2},
  [2511] = {.lex_state = 44, .external_lex_state = 2},
  [2512] = {.lex_state = 0, .external_lex_state = 2},
  [2513] = {.lex_state = 0, .external_lex_state = 2},
  [2514] = {.lex_state = 0, .external_lex_state = 2},
  [2515] = {.lex_state = 44, .external_lex_state = 2},
  [2516] = {.lex_state = 44, .external_lex_state = 2},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_use] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_actor] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_primitive] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_trait] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_embed] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_fun] = ACTIONS(1),
    [anon_sym_be] = ACTIONS(1),
    [anon_sym_BSLASH] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_iso] = ACTIONS(1),
    [anon_sym_trn] = ACTIONS(1),
    [anon_sym_ref] = ACTIONS(1),
    [anon_sym_val] = ACTIONS(1),
    [anon_sym_box] = ACTIONS(1),
    [anon_sym_tag] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_POUNDread] = ACTIONS(1),
    [anon_sym_POUNDsend] = ACTIONS(1),
    [anon_sym_POUNDshare] = ACTIONS(1),
    [anon_sym_POUNDalias] = ACTIONS(1),
    [anon_sym_POUNDany] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [sym_error] = ACTIONS(1),
    [sym_compile_intrinsic] = ACTIONS(1),
    [anon_sym_compile_error] = ACTIONS(1),
    [sym_location] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_DASH_TILDE] = ACTIONS(1),
    [anon_sym_addressof] = ACTIONS(1),
    [anon_sym_digestof] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_xor] = ACTIONS(1),
    [anon_sym_isnt] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_PLUS_TILDE] = ACTIONS(1),
    [anon_sym_STAR_TILDE] = ACTIONS(1),
    [anon_sym_SLASH_TILDE] = ACTIONS(1),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1),
    [anon_sym_GT_TILDE] = ACTIONS(1),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1),
    [anon_sym_LT_TILDE] = ACTIONS(1),
    [anon_sym_PLUS_QMARK] = ACTIONS(1),
    [anon_sym_DASH_QMARK] = ACTIONS(1),
    [anon_sym_STAR_QMARK] = ACTIONS(1),
    [anon_sym_SLASH_QMARK] = ACTIONS(1),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_DOT_GT] = ACTIONS(1),
    [anon_sym_where] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_end] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_ifdef] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_elseif] = ACTIONS(1),
    [anon_sym_iftype] = ACTIONS(1),
    [anon_sym_LT_COLON] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_repeat] = ACTIONS(1),
    [anon_sym_until] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_recover] = ACTIONS(1),
    [anon_sym_match] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_consume] = ACTIONS(1),
    [anon_sym_object] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(1),
    [sym_block_comment] = ACTIONS(3),
    [sym__multiline_string_content] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(2380),
    [sym_statement] = STATE(1439),
    [sym_use_statement] = STATE(1686),
    [sym_type_alias] = STATE(1686),
    [sym_actor_definition] = STATE(1686),
    [sym_class_definition] = STATE(1686),
    [sym_primitive_definition] = STATE(1686),
    [sym_interface_definition] = STATE(1686),
    [sym_trait_definition] = STATE(1686),
    [sym_struct_definition] = STATE(1686),
    [sym_string] = STATE(1443),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [aux_sym_source_file_repeat1] = STATE(1439),
    [ts_builtin_sym_end] = ACTIONS(5),
    [anon_sym_use] = ACTIONS(7),
    [anon_sym_type] = ACTIONS(9),
    [anon_sym_actor] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(13),
    [anon_sym_primitive] = ACTIONS(15),
    [anon_sym_interface] = ACTIONS(17),
    [anon_sym_trait] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2] = {
    [sym_expression] = STATE(379),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_arguments] = STATE(332),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_block_repeat1] = STATE(7),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_EQ] = ACTIONS(29),
    [anon_sym_AT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_RBRACK] = ACTIONS(31),
    [anon_sym_is] = ACTIONS(33),
    [anon_sym_embed] = ACTIONS(31),
    [anon_sym_let] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_new] = ACTIONS(31),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_fun] = ACTIONS(31),
    [anon_sym_be] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_DOT] = ACTIONS(35),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(31),
    [sym_error] = ACTIONS(31),
    [sym_compile_intrinsic] = ACTIONS(31),
    [anon_sym_compile_error] = ACTIONS(31),
    [sym_location] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(37),
    [anon_sym_not] = ACTIONS(31),
    [anon_sym_DASH_TILDE] = ACTIONS(39),
    [anon_sym_addressof] = ACTIONS(31),
    [anon_sym_digestof] = ACTIONS(31),
    [anon_sym_PLUS] = ACTIONS(33),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_SLASH] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(33),
    [anon_sym_LT_LT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(33),
    [anon_sym_and] = ACTIONS(41),
    [anon_sym_or] = ACTIONS(41),
    [anon_sym_xor] = ACTIONS(41),
    [anon_sym_isnt] = ACTIONS(41),
    [anon_sym_EQ_EQ] = ACTIONS(33),
    [anon_sym_BANG_EQ] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(33),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_PLUS_TILDE] = ACTIONS(41),
    [anon_sym_STAR_TILDE] = ACTIONS(41),
    [anon_sym_SLASH_TILDE] = ACTIONS(41),
    [anon_sym_PERCENT_TILDE] = ACTIONS(41),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(41),
    [anon_sym_LT_LT_TILDE] = ACTIONS(41),
    [anon_sym_GT_GT_TILDE] = ACTIONS(41),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(41),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(41),
    [anon_sym_GT_TILDE] = ACTIONS(41),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(41),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(41),
    [anon_sym_LT_TILDE] = ACTIONS(41),
    [anon_sym_PLUS_QMARK] = ACTIONS(41),
    [anon_sym_DASH_QMARK] = ACTIONS(41),
    [anon_sym_STAR_QMARK] = ACTIONS(41),
    [anon_sym_SLASH_QMARK] = ACTIONS(41),
    [anon_sym_PERCENT_QMARK] = ACTIONS(41),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(41),
    [anon_sym_as] = ACTIONS(43),
    [anon_sym_LPAREN2] = ACTIONS(45),
    [anon_sym_DOT_GT] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(31),
    [anon_sym_TILDE] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_ifdef] = ACTIONS(31),
    [anon_sym_then] = ACTIONS(31),
    [anon_sym_iftype] = ACTIONS(31),
    [anon_sym_else] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(31),
    [anon_sym_with] = ACTIONS(31),
    [anon_sym_repeat] = ACTIONS(31),
    [anon_sym_until] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_recover] = ACTIONS(31),
    [anon_sym_match] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_consume] = ACTIONS(31),
    [anon_sym_object] = ACTIONS(31),
    [sym_number] = ACTIONS(27),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(27),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(31),
    [anon_sym_true] = ACTIONS(31),
    [anon_sym_false] = ACTIONS(31),
    [sym_this] = ACTIONS(31),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [3] = {
    [sym_block] = STATE(384),
    [sym_expression] = STATE(2),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(51),
    [anon_sym_EQ] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_RBRACK] = ACTIONS(53),
    [anon_sym_is] = ACTIONS(51),
    [anon_sym_embed] = ACTIONS(53),
    [anon_sym_let] = ACTIONS(53),
    [anon_sym_var] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(53),
    [anon_sym_EQ_GT] = ACTIONS(53),
    [anon_sym_fun] = ACTIONS(53),
    [anon_sym_be] = ACTIONS(53),
    [anon_sym_COMMA] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(53),
    [anon_sym_DOT] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(53),
    [sym_error] = ACTIONS(53),
    [sym_compile_intrinsic] = ACTIONS(53),
    [anon_sym_compile_error] = ACTIONS(53),
    [sym_location] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_not] = ACTIONS(53),
    [anon_sym_DASH_TILDE] = ACTIONS(53),
    [anon_sym_addressof] = ACTIONS(53),
    [anon_sym_digestof] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_PERCENT] = ACTIONS(51),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(51),
    [anon_sym_LT_LT] = ACTIONS(51),
    [anon_sym_GT_GT] = ACTIONS(51),
    [anon_sym_and] = ACTIONS(53),
    [anon_sym_or] = ACTIONS(53),
    [anon_sym_xor] = ACTIONS(53),
    [anon_sym_isnt] = ACTIONS(53),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(51),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_PLUS_TILDE] = ACTIONS(53),
    [anon_sym_STAR_TILDE] = ACTIONS(53),
    [anon_sym_SLASH_TILDE] = ACTIONS(53),
    [anon_sym_PERCENT_TILDE] = ACTIONS(53),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(53),
    [anon_sym_LT_LT_TILDE] = ACTIONS(53),
    [anon_sym_GT_GT_TILDE] = ACTIONS(53),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(53),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(53),
    [anon_sym_GT_TILDE] = ACTIONS(53),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(53),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(53),
    [anon_sym_LT_TILDE] = ACTIONS(53),
    [anon_sym_PLUS_QMARK] = ACTIONS(53),
    [anon_sym_DASH_QMARK] = ACTIONS(53),
    [anon_sym_STAR_QMARK] = ACTIONS(53),
    [anon_sym_SLASH_QMARK] = ACTIONS(53),
    [anon_sym_PERCENT_QMARK] = ACTIONS(53),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(53),
    [anon_sym_as] = ACTIONS(53),
    [anon_sym_LPAREN2] = ACTIONS(53),
    [anon_sym_DOT_GT] = ACTIONS(53),
    [anon_sym_where] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_end] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_ifdef] = ACTIONS(53),
    [anon_sym_then] = ACTIONS(53),
    [anon_sym_iftype] = ACTIONS(53),
    [anon_sym_else] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_repeat] = ACTIONS(53),
    [anon_sym_until] = ACTIONS(53),
    [anon_sym_do] = ACTIONS(53),
    [anon_sym_recover] = ACTIONS(53),
    [anon_sym_match] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_continue] = ACTIONS(53),
    [anon_sym_break] = ACTIONS(53),
    [anon_sym_consume] = ACTIONS(53),
    [anon_sym_object] = ACTIONS(53),
    [sym_number] = ACTIONS(51),
    [sym_float] = ACTIONS(53),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [sym_this] = ACTIONS(53),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [4] = {
    [sym_block] = STATE(385),
    [sym_expression] = STATE(2),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(55),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_RBRACK] = ACTIONS(57),
    [anon_sym_is] = ACTIONS(55),
    [anon_sym_embed] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_var] = ACTIONS(57),
    [anon_sym_new] = ACTIONS(57),
    [anon_sym_EQ_GT] = ACTIONS(57),
    [anon_sym_fun] = ACTIONS(57),
    [anon_sym_be] = ACTIONS(57),
    [anon_sym_COMMA] = ACTIONS(57),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_RPAREN] = ACTIONS(57),
    [anon_sym_DOT] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(57),
    [sym_error] = ACTIONS(57),
    [sym_compile_intrinsic] = ACTIONS(57),
    [anon_sym_compile_error] = ACTIONS(57),
    [sym_location] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_DASH_TILDE] = ACTIONS(57),
    [anon_sym_addressof] = ACTIONS(57),
    [anon_sym_digestof] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(55),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(55),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(55),
    [anon_sym_and] = ACTIONS(57),
    [anon_sym_or] = ACTIONS(57),
    [anon_sym_xor] = ACTIONS(57),
    [anon_sym_isnt] = ACTIONS(57),
    [anon_sym_EQ_EQ] = ACTIONS(55),
    [anon_sym_BANG_EQ] = ACTIONS(55),
    [anon_sym_GT] = ACTIONS(55),
    [anon_sym_GT_EQ] = ACTIONS(55),
    [anon_sym_LT_EQ] = ACTIONS(55),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_PLUS_TILDE] = ACTIONS(57),
    [anon_sym_STAR_TILDE] = ACTIONS(57),
    [anon_sym_SLASH_TILDE] = ACTIONS(57),
    [anon_sym_PERCENT_TILDE] = ACTIONS(57),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(57),
    [anon_sym_LT_LT_TILDE] = ACTIONS(57),
    [anon_sym_GT_GT_TILDE] = ACTIONS(57),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(57),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(57),
    [anon_sym_GT_TILDE] = ACTIONS(57),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(57),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(57),
    [anon_sym_LT_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_QMARK] = ACTIONS(57),
    [anon_sym_DASH_QMARK] = ACTIONS(57),
    [anon_sym_STAR_QMARK] = ACTIONS(57),
    [anon_sym_SLASH_QMARK] = ACTIONS(57),
    [anon_sym_PERCENT_QMARK] = ACTIONS(57),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(57),
    [anon_sym_as] = ACTIONS(57),
    [anon_sym_LPAREN2] = ACTIONS(57),
    [anon_sym_DOT_GT] = ACTIONS(57),
    [anon_sym_where] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_end] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_ifdef] = ACTIONS(57),
    [anon_sym_then] = ACTIONS(57),
    [anon_sym_iftype] = ACTIONS(57),
    [anon_sym_else] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_try] = ACTIONS(57),
    [anon_sym_with] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(57),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_recover] = ACTIONS(57),
    [anon_sym_match] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(57),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_consume] = ACTIONS(57),
    [anon_sym_object] = ACTIONS(57),
    [sym_number] = ACTIONS(55),
    [sym_float] = ACTIONS(57),
    [anon_sym_DQUOTE] = ACTIONS(55),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(57),
    [anon_sym_SQUOTE] = ACTIONS(57),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [sym_this] = ACTIONS(57),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [5] = {
    [sym_block] = STATE(386),
    [sym_expression] = STATE(2),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(59),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_RBRACK] = ACTIONS(61),
    [anon_sym_is] = ACTIONS(59),
    [anon_sym_embed] = ACTIONS(61),
    [anon_sym_let] = ACTIONS(61),
    [anon_sym_var] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(61),
    [anon_sym_fun] = ACTIONS(61),
    [anon_sym_be] = ACTIONS(61),
    [anon_sym_COMMA] = ACTIONS(61),
    [anon_sym_LPAREN] = ACTIONS(59),
    [anon_sym_RPAREN] = ACTIONS(61),
    [anon_sym_DOT] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_RBRACE] = ACTIONS(61),
    [anon_sym_SEMI] = ACTIONS(61),
    [sym_error] = ACTIONS(61),
    [sym_compile_intrinsic] = ACTIONS(61),
    [anon_sym_compile_error] = ACTIONS(61),
    [sym_location] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(61),
    [anon_sym_DASH_TILDE] = ACTIONS(61),
    [anon_sym_addressof] = ACTIONS(61),
    [anon_sym_digestof] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(59),
    [anon_sym_PERCENT] = ACTIONS(59),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(59),
    [anon_sym_LT_LT] = ACTIONS(59),
    [anon_sym_GT_GT] = ACTIONS(59),
    [anon_sym_and] = ACTIONS(61),
    [anon_sym_or] = ACTIONS(61),
    [anon_sym_xor] = ACTIONS(61),
    [anon_sym_isnt] = ACTIONS(61),
    [anon_sym_EQ_EQ] = ACTIONS(59),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_PLUS_TILDE] = ACTIONS(61),
    [anon_sym_STAR_TILDE] = ACTIONS(61),
    [anon_sym_SLASH_TILDE] = ACTIONS(61),
    [anon_sym_PERCENT_TILDE] = ACTIONS(61),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(61),
    [anon_sym_LT_LT_TILDE] = ACTIONS(61),
    [anon_sym_GT_GT_TILDE] = ACTIONS(61),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(61),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(61),
    [anon_sym_GT_TILDE] = ACTIONS(61),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(61),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(61),
    [anon_sym_LT_TILDE] = ACTIONS(61),
    [anon_sym_PLUS_QMARK] = ACTIONS(61),
    [anon_sym_DASH_QMARK] = ACTIONS(61),
    [anon_sym_STAR_QMARK] = ACTIONS(61),
    [anon_sym_SLASH_QMARK] = ACTIONS(61),
    [anon_sym_PERCENT_QMARK] = ACTIONS(61),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(61),
    [anon_sym_as] = ACTIONS(61),
    [anon_sym_LPAREN2] = ACTIONS(61),
    [anon_sym_DOT_GT] = ACTIONS(61),
    [anon_sym_where] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(61),
    [anon_sym_end] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_ifdef] = ACTIONS(61),
    [anon_sym_then] = ACTIONS(61),
    [anon_sym_iftype] = ACTIONS(61),
    [anon_sym_else] = ACTIONS(61),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_try] = ACTIONS(61),
    [anon_sym_with] = ACTIONS(61),
    [anon_sym_repeat] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(61),
    [anon_sym_recover] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(61),
    [anon_sym_consume] = ACTIONS(61),
    [anon_sym_object] = ACTIONS(61),
    [sym_number] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(59),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(61),
    [anon_sym_SQUOTE] = ACTIONS(61),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [sym_this] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [6] = {
    [sym_expression] = STATE(379),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_block_repeat1] = STATE(6),
    [sym_identifier] = ACTIONS(63),
    [anon_sym_EQ] = ACTIONS(66),
    [anon_sym_AT] = ACTIONS(68),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_RBRACK] = ACTIONS(74),
    [anon_sym_is] = ACTIONS(66),
    [anon_sym_embed] = ACTIONS(74),
    [anon_sym_let] = ACTIONS(76),
    [anon_sym_var] = ACTIONS(76),
    [anon_sym_new] = ACTIONS(74),
    [anon_sym_EQ_GT] = ACTIONS(74),
    [anon_sym_fun] = ACTIONS(74),
    [anon_sym_be] = ACTIONS(74),
    [anon_sym_COMMA] = ACTIONS(74),
    [anon_sym_LPAREN] = ACTIONS(79),
    [anon_sym_RPAREN] = ACTIONS(74),
    [anon_sym_DOT] = ACTIONS(66),
    [anon_sym_LBRACE] = ACTIONS(82),
    [anon_sym_RBRACE] = ACTIONS(74),
    [anon_sym_SEMI] = ACTIONS(85),
    [sym_error] = ACTIONS(88),
    [sym_compile_intrinsic] = ACTIONS(88),
    [anon_sym_compile_error] = ACTIONS(91),
    [sym_location] = ACTIONS(88),
    [anon_sym_DASH] = ACTIONS(94),
    [anon_sym_not] = ACTIONS(97),
    [anon_sym_DASH_TILDE] = ACTIONS(97),
    [anon_sym_addressof] = ACTIONS(97),
    [anon_sym_digestof] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(66),
    [anon_sym_STAR] = ACTIONS(66),
    [anon_sym_SLASH] = ACTIONS(66),
    [anon_sym_PERCENT] = ACTIONS(66),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(66),
    [anon_sym_LT_LT] = ACTIONS(66),
    [anon_sym_GT_GT] = ACTIONS(66),
    [anon_sym_and] = ACTIONS(74),
    [anon_sym_or] = ACTIONS(74),
    [anon_sym_xor] = ACTIONS(74),
    [anon_sym_isnt] = ACTIONS(74),
    [anon_sym_EQ_EQ] = ACTIONS(66),
    [anon_sym_BANG_EQ] = ACTIONS(66),
    [anon_sym_GT] = ACTIONS(66),
    [anon_sym_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_EQ] = ACTIONS(66),
    [anon_sym_LT] = ACTIONS(66),
    [anon_sym_PLUS_TILDE] = ACTIONS(74),
    [anon_sym_STAR_TILDE] = ACTIONS(74),
    [anon_sym_SLASH_TILDE] = ACTIONS(74),
    [anon_sym_PERCENT_TILDE] = ACTIONS(74),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(74),
    [anon_sym_LT_LT_TILDE] = ACTIONS(74),
    [anon_sym_GT_GT_TILDE] = ACTIONS(74),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(74),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(74),
    [anon_sym_GT_TILDE] = ACTIONS(74),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(74),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(74),
    [anon_sym_LT_TILDE] = ACTIONS(74),
    [anon_sym_PLUS_QMARK] = ACTIONS(74),
    [anon_sym_DASH_QMARK] = ACTIONS(74),
    [anon_sym_STAR_QMARK] = ACTIONS(74),
    [anon_sym_SLASH_QMARK] = ACTIONS(74),
    [anon_sym_PERCENT_QMARK] = ACTIONS(74),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(74),
    [anon_sym_as] = ACTIONS(74),
    [anon_sym_LPAREN2] = ACTIONS(74),
    [anon_sym_DOT_GT] = ACTIONS(74),
    [anon_sym_where] = ACTIONS(74),
    [anon_sym_TILDE] = ACTIONS(74),
    [anon_sym_end] = ACTIONS(74),
    [anon_sym_if] = ACTIONS(100),
    [anon_sym_ifdef] = ACTIONS(103),
    [anon_sym_then] = ACTIONS(74),
    [anon_sym_iftype] = ACTIONS(106),
    [anon_sym_else] = ACTIONS(74),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_while] = ACTIONS(112),
    [anon_sym_try] = ACTIONS(115),
    [anon_sym_with] = ACTIONS(118),
    [anon_sym_repeat] = ACTIONS(121),
    [anon_sym_until] = ACTIONS(74),
    [anon_sym_do] = ACTIONS(74),
    [anon_sym_recover] = ACTIONS(124),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(130),
    [anon_sym_continue] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(136),
    [anon_sym_consume] = ACTIONS(139),
    [anon_sym_object] = ACTIONS(142),
    [sym_number] = ACTIONS(145),
    [sym_float] = ACTIONS(148),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(154),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(160),
    [anon_sym_false] = ACTIONS(160),
    [sym_this] = ACTIONS(88),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [7] = {
    [sym_expression] = STATE(379),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_block_repeat1] = STATE(6),
    [sym_identifier] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(163),
    [anon_sym_AT] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(165),
    [anon_sym_RBRACK] = ACTIONS(165),
    [anon_sym_is] = ACTIONS(163),
    [anon_sym_embed] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_new] = ACTIONS(165),
    [anon_sym_EQ_GT] = ACTIONS(165),
    [anon_sym_fun] = ACTIONS(165),
    [anon_sym_be] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_RPAREN] = ACTIONS(165),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_RBRACE] = ACTIONS(165),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_error] = ACTIONS(165),
    [sym_compile_intrinsic] = ACTIONS(165),
    [anon_sym_compile_error] = ACTIONS(165),
    [sym_location] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_not] = ACTIONS(165),
    [anon_sym_DASH_TILDE] = ACTIONS(165),
    [anon_sym_addressof] = ACTIONS(165),
    [anon_sym_digestof] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_PERCENT] = ACTIONS(163),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(163),
    [anon_sym_LT_LT] = ACTIONS(163),
    [anon_sym_GT_GT] = ACTIONS(163),
    [anon_sym_and] = ACTIONS(165),
    [anon_sym_or] = ACTIONS(165),
    [anon_sym_xor] = ACTIONS(165),
    [anon_sym_isnt] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(163),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(163),
    [anon_sym_PLUS_TILDE] = ACTIONS(165),
    [anon_sym_STAR_TILDE] = ACTIONS(165),
    [anon_sym_SLASH_TILDE] = ACTIONS(165),
    [anon_sym_PERCENT_TILDE] = ACTIONS(165),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(165),
    [anon_sym_LT_LT_TILDE] = ACTIONS(165),
    [anon_sym_GT_GT_TILDE] = ACTIONS(165),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(165),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(165),
    [anon_sym_GT_TILDE] = ACTIONS(165),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(165),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(165),
    [anon_sym_LT_TILDE] = ACTIONS(165),
    [anon_sym_PLUS_QMARK] = ACTIONS(165),
    [anon_sym_DASH_QMARK] = ACTIONS(165),
    [anon_sym_STAR_QMARK] = ACTIONS(165),
    [anon_sym_SLASH_QMARK] = ACTIONS(165),
    [anon_sym_PERCENT_QMARK] = ACTIONS(165),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(165),
    [anon_sym_as] = ACTIONS(165),
    [anon_sym_LPAREN2] = ACTIONS(165),
    [anon_sym_DOT_GT] = ACTIONS(165),
    [anon_sym_where] = ACTIONS(165),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_end] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(163),
    [anon_sym_ifdef] = ACTIONS(165),
    [anon_sym_then] = ACTIONS(165),
    [anon_sym_iftype] = ACTIONS(165),
    [anon_sym_else] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_try] = ACTIONS(165),
    [anon_sym_with] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_until] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(165),
    [anon_sym_recover] = ACTIONS(165),
    [anon_sym_match] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_consume] = ACTIONS(165),
    [anon_sym_object] = ACTIONS(165),
    [sym_number] = ACTIONS(163),
    [sym_float] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(165),
    [anon_sym_true] = ACTIONS(165),
    [anon_sym_false] = ACTIONS(165),
    [sym_this] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [8] = {
    [sym_expression] = STATE(418),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_arguments] = STATE(223),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [aux_sym_block_repeat1] = STATE(16),
    [ts_builtin_sym_end] = ACTIONS(31),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_use] = ACTIONS(31),
    [anon_sym_EQ] = ACTIONS(169),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_type] = ACTIONS(31),
    [anon_sym_is] = ACTIONS(175),
    [anon_sym_actor] = ACTIONS(31),
    [anon_sym_class] = ACTIONS(31),
    [anon_sym_primitive] = ACTIONS(31),
    [anon_sym_interface] = ACTIONS(31),
    [anon_sym_trait] = ACTIONS(31),
    [anon_sym_struct] = ACTIONS(31),
    [anon_sym_embed] = ACTIONS(31),
    [anon_sym_let] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_new] = ACTIONS(31),
    [anon_sym_fun] = ACTIONS(31),
    [anon_sym_be] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(177),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(193),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_PLUS] = ACTIONS(175),
    [anon_sym_STAR] = ACTIONS(175),
    [anon_sym_SLASH] = ACTIONS(175),
    [anon_sym_PERCENT] = ACTIONS(175),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(175),
    [anon_sym_LT_LT] = ACTIONS(175),
    [anon_sym_GT_GT] = ACTIONS(175),
    [anon_sym_and] = ACTIONS(195),
    [anon_sym_or] = ACTIONS(195),
    [anon_sym_xor] = ACTIONS(195),
    [anon_sym_isnt] = ACTIONS(195),
    [anon_sym_EQ_EQ] = ACTIONS(175),
    [anon_sym_BANG_EQ] = ACTIONS(175),
    [anon_sym_GT] = ACTIONS(175),
    [anon_sym_GT_EQ] = ACTIONS(175),
    [anon_sym_LT_EQ] = ACTIONS(175),
    [anon_sym_LT] = ACTIONS(175),
    [anon_sym_PLUS_TILDE] = ACTIONS(195),
    [anon_sym_STAR_TILDE] = ACTIONS(195),
    [anon_sym_SLASH_TILDE] = ACTIONS(195),
    [anon_sym_PERCENT_TILDE] = ACTIONS(195),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(195),
    [anon_sym_LT_LT_TILDE] = ACTIONS(195),
    [anon_sym_GT_GT_TILDE] = ACTIONS(195),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(195),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(195),
    [anon_sym_GT_TILDE] = ACTIONS(195),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(195),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(195),
    [anon_sym_LT_TILDE] = ACTIONS(195),
    [anon_sym_PLUS_QMARK] = ACTIONS(195),
    [anon_sym_DASH_QMARK] = ACTIONS(195),
    [anon_sym_STAR_QMARK] = ACTIONS(195),
    [anon_sym_SLASH_QMARK] = ACTIONS(195),
    [anon_sym_PERCENT_QMARK] = ACTIONS(195),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(195),
    [anon_sym_as] = ACTIONS(197),
    [anon_sym_LPAREN2] = ACTIONS(199),
    [anon_sym_DOT_GT] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(27),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [9] = {
    [sym_expression] = STATE(418),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_arguments] = STATE(223),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [aux_sym_block_repeat1] = STATE(10),
    [ts_builtin_sym_end] = ACTIONS(31),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_use] = ACTIONS(31),
    [anon_sym_EQ] = ACTIONS(169),
    [anon_sym_AT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_type] = ACTIONS(31),
    [anon_sym_is] = ACTIONS(175),
    [anon_sym_actor] = ACTIONS(31),
    [anon_sym_class] = ACTIONS(31),
    [anon_sym_primitive] = ACTIONS(31),
    [anon_sym_interface] = ACTIONS(31),
    [anon_sym_trait] = ACTIONS(31),
    [anon_sym_struct] = ACTIONS(31),
    [anon_sym_embed] = ACTIONS(31),
    [anon_sym_let] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_new] = ACTIONS(31),
    [anon_sym_fun] = ACTIONS(31),
    [anon_sym_be] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(31),
    [sym_error] = ACTIONS(31),
    [sym_compile_intrinsic] = ACTIONS(31),
    [anon_sym_compile_error] = ACTIONS(31),
    [sym_location] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_not] = ACTIONS(31),
    [anon_sym_DASH_TILDE] = ACTIONS(193),
    [anon_sym_addressof] = ACTIONS(31),
    [anon_sym_digestof] = ACTIONS(31),
    [anon_sym_PLUS] = ACTIONS(175),
    [anon_sym_STAR] = ACTIONS(175),
    [anon_sym_SLASH] = ACTIONS(175),
    [anon_sym_PERCENT] = ACTIONS(175),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(175),
    [anon_sym_LT_LT] = ACTIONS(175),
    [anon_sym_GT_GT] = ACTIONS(175),
    [anon_sym_and] = ACTIONS(195),
    [anon_sym_or] = ACTIONS(195),
    [anon_sym_xor] = ACTIONS(195),
    [anon_sym_isnt] = ACTIONS(195),
    [anon_sym_EQ_EQ] = ACTIONS(175),
    [anon_sym_BANG_EQ] = ACTIONS(175),
    [anon_sym_GT] = ACTIONS(175),
    [anon_sym_GT_EQ] = ACTIONS(175),
    [anon_sym_LT_EQ] = ACTIONS(175),
    [anon_sym_LT] = ACTIONS(175),
    [anon_sym_PLUS_TILDE] = ACTIONS(195),
    [anon_sym_STAR_TILDE] = ACTIONS(195),
    [anon_sym_SLASH_TILDE] = ACTIONS(195),
    [anon_sym_PERCENT_TILDE] = ACTIONS(195),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(195),
    [anon_sym_LT_LT_TILDE] = ACTIONS(195),
    [anon_sym_GT_GT_TILDE] = ACTIONS(195),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(195),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(195),
    [anon_sym_GT_TILDE] = ACTIONS(195),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(195),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(195),
    [anon_sym_LT_TILDE] = ACTIONS(195),
    [anon_sym_PLUS_QMARK] = ACTIONS(195),
    [anon_sym_DASH_QMARK] = ACTIONS(195),
    [anon_sym_STAR_QMARK] = ACTIONS(195),
    [anon_sym_SLASH_QMARK] = ACTIONS(195),
    [anon_sym_PERCENT_QMARK] = ACTIONS(195),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(195),
    [anon_sym_as] = ACTIONS(197),
    [anon_sym_LPAREN2] = ACTIONS(199),
    [anon_sym_DOT_GT] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_ifdef] = ACTIONS(31),
    [anon_sym_iftype] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(31),
    [anon_sym_with] = ACTIONS(31),
    [anon_sym_repeat] = ACTIONS(31),
    [anon_sym_recover] = ACTIONS(31),
    [anon_sym_match] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_consume] = ACTIONS(31),
    [anon_sym_object] = ACTIONS(31),
    [sym_number] = ACTIONS(27),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(27),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(31),
    [anon_sym_true] = ACTIONS(31),
    [anon_sym_false] = ACTIONS(31),
    [sym_this] = ACTIONS(31),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [10] = {
    [sym_expression] = STATE(418),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [aux_sym_block_repeat1] = STATE(14),
    [ts_builtin_sym_end] = ACTIONS(165),
    [sym_identifier] = ACTIONS(163),
    [anon_sym_use] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(163),
    [anon_sym_AT] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(165),
    [anon_sym_type] = ACTIONS(165),
    [anon_sym_is] = ACTIONS(163),
    [anon_sym_actor] = ACTIONS(165),
    [anon_sym_class] = ACTIONS(165),
    [anon_sym_primitive] = ACTIONS(165),
    [anon_sym_interface] = ACTIONS(165),
    [anon_sym_trait] = ACTIONS(165),
    [anon_sym_struct] = ACTIONS(165),
    [anon_sym_embed] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_new] = ACTIONS(165),
    [anon_sym_fun] = ACTIONS(165),
    [anon_sym_be] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_error] = ACTIONS(165),
    [sym_compile_intrinsic] = ACTIONS(165),
    [anon_sym_compile_error] = ACTIONS(165),
    [sym_location] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_not] = ACTIONS(165),
    [anon_sym_DASH_TILDE] = ACTIONS(165),
    [anon_sym_addressof] = ACTIONS(165),
    [anon_sym_digestof] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_PERCENT] = ACTIONS(163),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(163),
    [anon_sym_LT_LT] = ACTIONS(163),
    [anon_sym_GT_GT] = ACTIONS(163),
    [anon_sym_and] = ACTIONS(165),
    [anon_sym_or] = ACTIONS(165),
    [anon_sym_xor] = ACTIONS(165),
    [anon_sym_isnt] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(163),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(163),
    [anon_sym_PLUS_TILDE] = ACTIONS(165),
    [anon_sym_STAR_TILDE] = ACTIONS(165),
    [anon_sym_SLASH_TILDE] = ACTIONS(165),
    [anon_sym_PERCENT_TILDE] = ACTIONS(165),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(165),
    [anon_sym_LT_LT_TILDE] = ACTIONS(165),
    [anon_sym_GT_GT_TILDE] = ACTIONS(165),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(165),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(165),
    [anon_sym_GT_TILDE] = ACTIONS(165),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(165),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(165),
    [anon_sym_LT_TILDE] = ACTIONS(165),
    [anon_sym_PLUS_QMARK] = ACTIONS(165),
    [anon_sym_DASH_QMARK] = ACTIONS(165),
    [anon_sym_STAR_QMARK] = ACTIONS(165),
    [anon_sym_SLASH_QMARK] = ACTIONS(165),
    [anon_sym_PERCENT_QMARK] = ACTIONS(165),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(165),
    [anon_sym_as] = ACTIONS(165),
    [anon_sym_LPAREN2] = ACTIONS(165),
    [anon_sym_DOT_GT] = ACTIONS(165),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(163),
    [anon_sym_ifdef] = ACTIONS(165),
    [anon_sym_iftype] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_try] = ACTIONS(165),
    [anon_sym_with] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_recover] = ACTIONS(165),
    [anon_sym_match] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_consume] = ACTIONS(165),
    [anon_sym_object] = ACTIONS(165),
    [sym_number] = ACTIONS(163),
    [sym_float] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(165),
    [anon_sym_true] = ACTIONS(165),
    [anon_sym_false] = ACTIONS(165),
    [sym_this] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [11] = {
    [sym_block] = STATE(227),
    [sym_expression] = STATE(9),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [ts_builtin_sym_end] = ACTIONS(57),
    [sym_identifier] = ACTIONS(55),
    [anon_sym_use] = ACTIONS(57),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_is] = ACTIONS(55),
    [anon_sym_actor] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_primitive] = ACTIONS(57),
    [anon_sym_interface] = ACTIONS(57),
    [anon_sym_trait] = ACTIONS(57),
    [anon_sym_struct] = ACTIONS(57),
    [anon_sym_embed] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_var] = ACTIONS(57),
    [anon_sym_new] = ACTIONS(57),
    [anon_sym_fun] = ACTIONS(57),
    [anon_sym_be] = ACTIONS(57),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(57),
    [sym_error] = ACTIONS(57),
    [sym_compile_intrinsic] = ACTIONS(57),
    [anon_sym_compile_error] = ACTIONS(57),
    [sym_location] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_DASH_TILDE] = ACTIONS(57),
    [anon_sym_addressof] = ACTIONS(57),
    [anon_sym_digestof] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(55),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(55),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(55),
    [anon_sym_and] = ACTIONS(57),
    [anon_sym_or] = ACTIONS(57),
    [anon_sym_xor] = ACTIONS(57),
    [anon_sym_isnt] = ACTIONS(57),
    [anon_sym_EQ_EQ] = ACTIONS(55),
    [anon_sym_BANG_EQ] = ACTIONS(55),
    [anon_sym_GT] = ACTIONS(55),
    [anon_sym_GT_EQ] = ACTIONS(55),
    [anon_sym_LT_EQ] = ACTIONS(55),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_PLUS_TILDE] = ACTIONS(57),
    [anon_sym_STAR_TILDE] = ACTIONS(57),
    [anon_sym_SLASH_TILDE] = ACTIONS(57),
    [anon_sym_PERCENT_TILDE] = ACTIONS(57),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(57),
    [anon_sym_LT_LT_TILDE] = ACTIONS(57),
    [anon_sym_GT_GT_TILDE] = ACTIONS(57),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(57),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(57),
    [anon_sym_GT_TILDE] = ACTIONS(57),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(57),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(57),
    [anon_sym_LT_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_QMARK] = ACTIONS(57),
    [anon_sym_DASH_QMARK] = ACTIONS(57),
    [anon_sym_STAR_QMARK] = ACTIONS(57),
    [anon_sym_SLASH_QMARK] = ACTIONS(57),
    [anon_sym_PERCENT_QMARK] = ACTIONS(57),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(57),
    [anon_sym_as] = ACTIONS(57),
    [anon_sym_LPAREN2] = ACTIONS(57),
    [anon_sym_DOT_GT] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_ifdef] = ACTIONS(57),
    [anon_sym_iftype] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_try] = ACTIONS(57),
    [anon_sym_with] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(57),
    [anon_sym_recover] = ACTIONS(57),
    [anon_sym_match] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(57),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_consume] = ACTIONS(57),
    [anon_sym_object] = ACTIONS(57),
    [sym_number] = ACTIONS(55),
    [sym_float] = ACTIONS(57),
    [anon_sym_DQUOTE] = ACTIONS(55),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(57),
    [anon_sym_SQUOTE] = ACTIONS(57),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [sym_this] = ACTIONS(57),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [12] = {
    [sym_block] = STATE(228),
    [sym_expression] = STATE(9),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [ts_builtin_sym_end] = ACTIONS(53),
    [sym_identifier] = ACTIONS(51),
    [anon_sym_use] = ACTIONS(53),
    [anon_sym_EQ] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_type] = ACTIONS(53),
    [anon_sym_is] = ACTIONS(51),
    [anon_sym_actor] = ACTIONS(53),
    [anon_sym_class] = ACTIONS(53),
    [anon_sym_primitive] = ACTIONS(53),
    [anon_sym_interface] = ACTIONS(53),
    [anon_sym_trait] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_embed] = ACTIONS(53),
    [anon_sym_let] = ACTIONS(53),
    [anon_sym_var] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(53),
    [anon_sym_fun] = ACTIONS(53),
    [anon_sym_be] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_DOT] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(53),
    [sym_error] = ACTIONS(53),
    [sym_compile_intrinsic] = ACTIONS(53),
    [anon_sym_compile_error] = ACTIONS(53),
    [sym_location] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_not] = ACTIONS(53),
    [anon_sym_DASH_TILDE] = ACTIONS(53),
    [anon_sym_addressof] = ACTIONS(53),
    [anon_sym_digestof] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_PERCENT] = ACTIONS(51),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(51),
    [anon_sym_LT_LT] = ACTIONS(51),
    [anon_sym_GT_GT] = ACTIONS(51),
    [anon_sym_and] = ACTIONS(53),
    [anon_sym_or] = ACTIONS(53),
    [anon_sym_xor] = ACTIONS(53),
    [anon_sym_isnt] = ACTIONS(53),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(51),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_PLUS_TILDE] = ACTIONS(53),
    [anon_sym_STAR_TILDE] = ACTIONS(53),
    [anon_sym_SLASH_TILDE] = ACTIONS(53),
    [anon_sym_PERCENT_TILDE] = ACTIONS(53),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(53),
    [anon_sym_LT_LT_TILDE] = ACTIONS(53),
    [anon_sym_GT_GT_TILDE] = ACTIONS(53),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(53),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(53),
    [anon_sym_GT_TILDE] = ACTIONS(53),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(53),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(53),
    [anon_sym_LT_TILDE] = ACTIONS(53),
    [anon_sym_PLUS_QMARK] = ACTIONS(53),
    [anon_sym_DASH_QMARK] = ACTIONS(53),
    [anon_sym_STAR_QMARK] = ACTIONS(53),
    [anon_sym_SLASH_QMARK] = ACTIONS(53),
    [anon_sym_PERCENT_QMARK] = ACTIONS(53),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(53),
    [anon_sym_as] = ACTIONS(53),
    [anon_sym_LPAREN2] = ACTIONS(53),
    [anon_sym_DOT_GT] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_ifdef] = ACTIONS(53),
    [anon_sym_iftype] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_repeat] = ACTIONS(53),
    [anon_sym_recover] = ACTIONS(53),
    [anon_sym_match] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_continue] = ACTIONS(53),
    [anon_sym_break] = ACTIONS(53),
    [anon_sym_consume] = ACTIONS(53),
    [anon_sym_object] = ACTIONS(53),
    [sym_number] = ACTIONS(51),
    [sym_float] = ACTIONS(53),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [sym_this] = ACTIONS(53),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [13] = {
    [sym_block] = STATE(226),
    [sym_expression] = STATE(9),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [ts_builtin_sym_end] = ACTIONS(61),
    [sym_identifier] = ACTIONS(59),
    [anon_sym_use] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(61),
    [anon_sym_is] = ACTIONS(59),
    [anon_sym_actor] = ACTIONS(61),
    [anon_sym_class] = ACTIONS(61),
    [anon_sym_primitive] = ACTIONS(61),
    [anon_sym_interface] = ACTIONS(61),
    [anon_sym_trait] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_embed] = ACTIONS(61),
    [anon_sym_let] = ACTIONS(61),
    [anon_sym_var] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(61),
    [anon_sym_fun] = ACTIONS(61),
    [anon_sym_be] = ACTIONS(61),
    [anon_sym_LPAREN] = ACTIONS(59),
    [anon_sym_DOT] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_SEMI] = ACTIONS(61),
    [sym_error] = ACTIONS(61),
    [sym_compile_intrinsic] = ACTIONS(61),
    [anon_sym_compile_error] = ACTIONS(61),
    [sym_location] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(61),
    [anon_sym_DASH_TILDE] = ACTIONS(61),
    [anon_sym_addressof] = ACTIONS(61),
    [anon_sym_digestof] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(59),
    [anon_sym_PERCENT] = ACTIONS(59),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(59),
    [anon_sym_LT_LT] = ACTIONS(59),
    [anon_sym_GT_GT] = ACTIONS(59),
    [anon_sym_and] = ACTIONS(61),
    [anon_sym_or] = ACTIONS(61),
    [anon_sym_xor] = ACTIONS(61),
    [anon_sym_isnt] = ACTIONS(61),
    [anon_sym_EQ_EQ] = ACTIONS(59),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_PLUS_TILDE] = ACTIONS(61),
    [anon_sym_STAR_TILDE] = ACTIONS(61),
    [anon_sym_SLASH_TILDE] = ACTIONS(61),
    [anon_sym_PERCENT_TILDE] = ACTIONS(61),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(61),
    [anon_sym_LT_LT_TILDE] = ACTIONS(61),
    [anon_sym_GT_GT_TILDE] = ACTIONS(61),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(61),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(61),
    [anon_sym_GT_TILDE] = ACTIONS(61),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(61),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(61),
    [anon_sym_LT_TILDE] = ACTIONS(61),
    [anon_sym_PLUS_QMARK] = ACTIONS(61),
    [anon_sym_DASH_QMARK] = ACTIONS(61),
    [anon_sym_STAR_QMARK] = ACTIONS(61),
    [anon_sym_SLASH_QMARK] = ACTIONS(61),
    [anon_sym_PERCENT_QMARK] = ACTIONS(61),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(61),
    [anon_sym_as] = ACTIONS(61),
    [anon_sym_LPAREN2] = ACTIONS(61),
    [anon_sym_DOT_GT] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_ifdef] = ACTIONS(61),
    [anon_sym_iftype] = ACTIONS(61),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_try] = ACTIONS(61),
    [anon_sym_with] = ACTIONS(61),
    [anon_sym_repeat] = ACTIONS(61),
    [anon_sym_recover] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(61),
    [anon_sym_consume] = ACTIONS(61),
    [anon_sym_object] = ACTIONS(61),
    [sym_number] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(59),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(61),
    [anon_sym_SQUOTE] = ACTIONS(61),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [sym_this] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [14] = {
    [sym_expression] = STATE(418),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [aux_sym_block_repeat1] = STATE(14),
    [ts_builtin_sym_end] = ACTIONS(74),
    [sym_identifier] = ACTIONS(243),
    [anon_sym_use] = ACTIONS(74),
    [anon_sym_EQ] = ACTIONS(66),
    [anon_sym_AT] = ACTIONS(246),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_type] = ACTIONS(74),
    [anon_sym_is] = ACTIONS(66),
    [anon_sym_actor] = ACTIONS(74),
    [anon_sym_class] = ACTIONS(74),
    [anon_sym_primitive] = ACTIONS(74),
    [anon_sym_interface] = ACTIONS(74),
    [anon_sym_trait] = ACTIONS(74),
    [anon_sym_struct] = ACTIONS(74),
    [anon_sym_embed] = ACTIONS(74),
    [anon_sym_let] = ACTIONS(252),
    [anon_sym_var] = ACTIONS(252),
    [anon_sym_new] = ACTIONS(74),
    [anon_sym_fun] = ACTIONS(74),
    [anon_sym_be] = ACTIONS(74),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_DOT] = ACTIONS(66),
    [anon_sym_LBRACE] = ACTIONS(258),
    [anon_sym_SEMI] = ACTIONS(261),
    [sym_error] = ACTIONS(264),
    [sym_compile_intrinsic] = ACTIONS(264),
    [anon_sym_compile_error] = ACTIONS(267),
    [sym_location] = ACTIONS(264),
    [anon_sym_DASH] = ACTIONS(270),
    [anon_sym_not] = ACTIONS(273),
    [anon_sym_DASH_TILDE] = ACTIONS(273),
    [anon_sym_addressof] = ACTIONS(273),
    [anon_sym_digestof] = ACTIONS(273),
    [anon_sym_PLUS] = ACTIONS(66),
    [anon_sym_STAR] = ACTIONS(66),
    [anon_sym_SLASH] = ACTIONS(66),
    [anon_sym_PERCENT] = ACTIONS(66),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(66),
    [anon_sym_LT_LT] = ACTIONS(66),
    [anon_sym_GT_GT] = ACTIONS(66),
    [anon_sym_and] = ACTIONS(74),
    [anon_sym_or] = ACTIONS(74),
    [anon_sym_xor] = ACTIONS(74),
    [anon_sym_isnt] = ACTIONS(74),
    [anon_sym_EQ_EQ] = ACTIONS(66),
    [anon_sym_BANG_EQ] = ACTIONS(66),
    [anon_sym_GT] = ACTIONS(66),
    [anon_sym_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_EQ] = ACTIONS(66),
    [anon_sym_LT] = ACTIONS(66),
    [anon_sym_PLUS_TILDE] = ACTIONS(74),
    [anon_sym_STAR_TILDE] = ACTIONS(74),
    [anon_sym_SLASH_TILDE] = ACTIONS(74),
    [anon_sym_PERCENT_TILDE] = ACTIONS(74),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(74),
    [anon_sym_LT_LT_TILDE] = ACTIONS(74),
    [anon_sym_GT_GT_TILDE] = ACTIONS(74),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(74),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(74),
    [anon_sym_GT_TILDE] = ACTIONS(74),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(74),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(74),
    [anon_sym_LT_TILDE] = ACTIONS(74),
    [anon_sym_PLUS_QMARK] = ACTIONS(74),
    [anon_sym_DASH_QMARK] = ACTIONS(74),
    [anon_sym_STAR_QMARK] = ACTIONS(74),
    [anon_sym_SLASH_QMARK] = ACTIONS(74),
    [anon_sym_PERCENT_QMARK] = ACTIONS(74),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(74),
    [anon_sym_as] = ACTIONS(74),
    [anon_sym_LPAREN2] = ACTIONS(74),
    [anon_sym_DOT_GT] = ACTIONS(74),
    [anon_sym_TILDE] = ACTIONS(74),
    [anon_sym_if] = ACTIONS(100),
    [anon_sym_ifdef] = ACTIONS(103),
    [anon_sym_iftype] = ACTIONS(276),
    [anon_sym_for] = ACTIONS(279),
    [anon_sym_while] = ACTIONS(282),
    [anon_sym_try] = ACTIONS(285),
    [anon_sym_with] = ACTIONS(288),
    [anon_sym_repeat] = ACTIONS(291),
    [anon_sym_recover] = ACTIONS(294),
    [anon_sym_match] = ACTIONS(297),
    [anon_sym_return] = ACTIONS(300),
    [anon_sym_continue] = ACTIONS(303),
    [anon_sym_break] = ACTIONS(306),
    [anon_sym_consume] = ACTIONS(309),
    [anon_sym_object] = ACTIONS(312),
    [sym_number] = ACTIONS(315),
    [sym_float] = ACTIONS(318),
    [anon_sym_DQUOTE] = ACTIONS(321),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(324),
    [anon_sym_SQUOTE] = ACTIONS(327),
    [anon_sym_true] = ACTIONS(330),
    [anon_sym_false] = ACTIONS(330),
    [sym_this] = ACTIONS(264),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [15] = {
    [sym_expression] = STATE(379),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_arguments] = STATE(332),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_block_repeat1] = STATE(456),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_EQ] = ACTIONS(29),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_RBRACK] = ACTIONS(31),
    [anon_sym_is] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_new] = ACTIONS(31),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_fun] = ACTIONS(31),
    [anon_sym_be] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(341),
    [anon_sym_DOT] = ACTIONS(35),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_RBRACE] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(345),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(37),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(39),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_PLUS] = ACTIONS(33),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_SLASH] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(33),
    [anon_sym_LT_LT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(33),
    [anon_sym_and] = ACTIONS(41),
    [anon_sym_or] = ACTIONS(41),
    [anon_sym_xor] = ACTIONS(41),
    [anon_sym_isnt] = ACTIONS(41),
    [anon_sym_EQ_EQ] = ACTIONS(33),
    [anon_sym_BANG_EQ] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(33),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_PLUS_TILDE] = ACTIONS(41),
    [anon_sym_STAR_TILDE] = ACTIONS(41),
    [anon_sym_SLASH_TILDE] = ACTIONS(41),
    [anon_sym_PERCENT_TILDE] = ACTIONS(41),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(41),
    [anon_sym_LT_LT_TILDE] = ACTIONS(41),
    [anon_sym_GT_GT_TILDE] = ACTIONS(41),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(41),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(41),
    [anon_sym_GT_TILDE] = ACTIONS(41),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(41),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(41),
    [anon_sym_LT_TILDE] = ACTIONS(41),
    [anon_sym_PLUS_QMARK] = ACTIONS(41),
    [anon_sym_DASH_QMARK] = ACTIONS(41),
    [anon_sym_STAR_QMARK] = ACTIONS(41),
    [anon_sym_SLASH_QMARK] = ACTIONS(41),
    [anon_sym_PERCENT_QMARK] = ACTIONS(41),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(41),
    [anon_sym_as] = ACTIONS(43),
    [anon_sym_LPAREN2] = ACTIONS(45),
    [anon_sym_DOT_GT] = ACTIONS(47),
    [anon_sym_TILDE] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_then] = ACTIONS(31),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_else] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_until] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [16] = {
    [sym_expression] = STATE(418),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [aux_sym_block_repeat1] = STATE(14),
    [ts_builtin_sym_end] = ACTIONS(165),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_use] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(163),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_type] = ACTIONS(165),
    [anon_sym_is] = ACTIONS(163),
    [anon_sym_actor] = ACTIONS(165),
    [anon_sym_class] = ACTIONS(165),
    [anon_sym_primitive] = ACTIONS(165),
    [anon_sym_interface] = ACTIONS(165),
    [anon_sym_trait] = ACTIONS(165),
    [anon_sym_struct] = ACTIONS(165),
    [anon_sym_embed] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_new] = ACTIONS(165),
    [anon_sym_fun] = ACTIONS(165),
    [anon_sym_be] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(177),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(165),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_PERCENT] = ACTIONS(163),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(163),
    [anon_sym_LT_LT] = ACTIONS(163),
    [anon_sym_GT_GT] = ACTIONS(163),
    [anon_sym_and] = ACTIONS(165),
    [anon_sym_or] = ACTIONS(165),
    [anon_sym_xor] = ACTIONS(165),
    [anon_sym_isnt] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(163),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(163),
    [anon_sym_PLUS_TILDE] = ACTIONS(165),
    [anon_sym_STAR_TILDE] = ACTIONS(165),
    [anon_sym_SLASH_TILDE] = ACTIONS(165),
    [anon_sym_PERCENT_TILDE] = ACTIONS(165),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(165),
    [anon_sym_LT_LT_TILDE] = ACTIONS(165),
    [anon_sym_GT_GT_TILDE] = ACTIONS(165),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(165),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(165),
    [anon_sym_GT_TILDE] = ACTIONS(165),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(165),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(165),
    [anon_sym_LT_TILDE] = ACTIONS(165),
    [anon_sym_PLUS_QMARK] = ACTIONS(165),
    [anon_sym_DASH_QMARK] = ACTIONS(165),
    [anon_sym_STAR_QMARK] = ACTIONS(165),
    [anon_sym_SLASH_QMARK] = ACTIONS(165),
    [anon_sym_PERCENT_QMARK] = ACTIONS(165),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(165),
    [anon_sym_as] = ACTIONS(165),
    [anon_sym_LPAREN2] = ACTIONS(165),
    [anon_sym_DOT_GT] = ACTIONS(165),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [17] = {
    [sym_expression] = STATE(418),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_arguments] = STATE(223),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [aux_sym_block_repeat1] = STATE(450),
    [ts_builtin_sym_end] = ACTIONS(31),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_use] = ACTIONS(31),
    [anon_sym_EQ] = ACTIONS(169),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_type] = ACTIONS(31),
    [anon_sym_is] = ACTIONS(175),
    [anon_sym_actor] = ACTIONS(31),
    [anon_sym_class] = ACTIONS(31),
    [anon_sym_primitive] = ACTIONS(31),
    [anon_sym_interface] = ACTIONS(31),
    [anon_sym_trait] = ACTIONS(31),
    [anon_sym_struct] = ACTIONS(31),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_new] = ACTIONS(31),
    [anon_sym_fun] = ACTIONS(31),
    [anon_sym_be] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(177),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(193),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_PLUS] = ACTIONS(175),
    [anon_sym_STAR] = ACTIONS(175),
    [anon_sym_SLASH] = ACTIONS(175),
    [anon_sym_PERCENT] = ACTIONS(175),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(175),
    [anon_sym_LT_LT] = ACTIONS(175),
    [anon_sym_GT_GT] = ACTIONS(175),
    [anon_sym_and] = ACTIONS(195),
    [anon_sym_or] = ACTIONS(195),
    [anon_sym_xor] = ACTIONS(195),
    [anon_sym_isnt] = ACTIONS(195),
    [anon_sym_EQ_EQ] = ACTIONS(175),
    [anon_sym_BANG_EQ] = ACTIONS(175),
    [anon_sym_GT] = ACTIONS(175),
    [anon_sym_GT_EQ] = ACTIONS(175),
    [anon_sym_LT_EQ] = ACTIONS(175),
    [anon_sym_LT] = ACTIONS(175),
    [anon_sym_PLUS_TILDE] = ACTIONS(195),
    [anon_sym_STAR_TILDE] = ACTIONS(195),
    [anon_sym_SLASH_TILDE] = ACTIONS(195),
    [anon_sym_PERCENT_TILDE] = ACTIONS(195),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(195),
    [anon_sym_LT_LT_TILDE] = ACTIONS(195),
    [anon_sym_GT_GT_TILDE] = ACTIONS(195),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(195),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(195),
    [anon_sym_GT_TILDE] = ACTIONS(195),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(195),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(195),
    [anon_sym_LT_TILDE] = ACTIONS(195),
    [anon_sym_PLUS_QMARK] = ACTIONS(195),
    [anon_sym_DASH_QMARK] = ACTIONS(195),
    [anon_sym_STAR_QMARK] = ACTIONS(195),
    [anon_sym_SLASH_QMARK] = ACTIONS(195),
    [anon_sym_PERCENT_QMARK] = ACTIONS(195),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(195),
    [anon_sym_as] = ACTIONS(197),
    [anon_sym_LPAREN2] = ACTIONS(199),
    [anon_sym_DOT_GT] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [18] = {
    [sym_block] = STATE(226),
    [sym_expression] = STATE(8),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [ts_builtin_sym_end] = ACTIONS(61),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_use] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_type] = ACTIONS(61),
    [anon_sym_is] = ACTIONS(59),
    [anon_sym_actor] = ACTIONS(61),
    [anon_sym_class] = ACTIONS(61),
    [anon_sym_primitive] = ACTIONS(61),
    [anon_sym_interface] = ACTIONS(61),
    [anon_sym_trait] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_embed] = ACTIONS(61),
    [anon_sym_let] = ACTIONS(61),
    [anon_sym_var] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(61),
    [anon_sym_fun] = ACTIONS(61),
    [anon_sym_be] = ACTIONS(61),
    [anon_sym_LPAREN] = ACTIONS(177),
    [anon_sym_DOT] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(61),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(59),
    [anon_sym_PERCENT] = ACTIONS(59),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(59),
    [anon_sym_LT_LT] = ACTIONS(59),
    [anon_sym_GT_GT] = ACTIONS(59),
    [anon_sym_and] = ACTIONS(61),
    [anon_sym_or] = ACTIONS(61),
    [anon_sym_xor] = ACTIONS(61),
    [anon_sym_isnt] = ACTIONS(61),
    [anon_sym_EQ_EQ] = ACTIONS(59),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_PLUS_TILDE] = ACTIONS(61),
    [anon_sym_STAR_TILDE] = ACTIONS(61),
    [anon_sym_SLASH_TILDE] = ACTIONS(61),
    [anon_sym_PERCENT_TILDE] = ACTIONS(61),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(61),
    [anon_sym_LT_LT_TILDE] = ACTIONS(61),
    [anon_sym_GT_GT_TILDE] = ACTIONS(61),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(61),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(61),
    [anon_sym_GT_TILDE] = ACTIONS(61),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(61),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(61),
    [anon_sym_LT_TILDE] = ACTIONS(61),
    [anon_sym_PLUS_QMARK] = ACTIONS(61),
    [anon_sym_DASH_QMARK] = ACTIONS(61),
    [anon_sym_STAR_QMARK] = ACTIONS(61),
    [anon_sym_SLASH_QMARK] = ACTIONS(61),
    [anon_sym_PERCENT_QMARK] = ACTIONS(61),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(61),
    [anon_sym_as] = ACTIONS(61),
    [anon_sym_LPAREN2] = ACTIONS(61),
    [anon_sym_DOT_GT] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(59),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(61),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [19] = {
    [sym_block] = STATE(227),
    [sym_expression] = STATE(8),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [ts_builtin_sym_end] = ACTIONS(57),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_use] = ACTIONS(57),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_is] = ACTIONS(55),
    [anon_sym_actor] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_primitive] = ACTIONS(57),
    [anon_sym_interface] = ACTIONS(57),
    [anon_sym_trait] = ACTIONS(57),
    [anon_sym_struct] = ACTIONS(57),
    [anon_sym_embed] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_var] = ACTIONS(57),
    [anon_sym_new] = ACTIONS(57),
    [anon_sym_fun] = ACTIONS(57),
    [anon_sym_be] = ACTIONS(57),
    [anon_sym_LPAREN] = ACTIONS(177),
    [anon_sym_DOT] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(57),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(55),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(55),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(55),
    [anon_sym_and] = ACTIONS(57),
    [anon_sym_or] = ACTIONS(57),
    [anon_sym_xor] = ACTIONS(57),
    [anon_sym_isnt] = ACTIONS(57),
    [anon_sym_EQ_EQ] = ACTIONS(55),
    [anon_sym_BANG_EQ] = ACTIONS(55),
    [anon_sym_GT] = ACTIONS(55),
    [anon_sym_GT_EQ] = ACTIONS(55),
    [anon_sym_LT_EQ] = ACTIONS(55),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_PLUS_TILDE] = ACTIONS(57),
    [anon_sym_STAR_TILDE] = ACTIONS(57),
    [anon_sym_SLASH_TILDE] = ACTIONS(57),
    [anon_sym_PERCENT_TILDE] = ACTIONS(57),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(57),
    [anon_sym_LT_LT_TILDE] = ACTIONS(57),
    [anon_sym_GT_GT_TILDE] = ACTIONS(57),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(57),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(57),
    [anon_sym_GT_TILDE] = ACTIONS(57),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(57),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(57),
    [anon_sym_LT_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_QMARK] = ACTIONS(57),
    [anon_sym_DASH_QMARK] = ACTIONS(57),
    [anon_sym_STAR_QMARK] = ACTIONS(57),
    [anon_sym_SLASH_QMARK] = ACTIONS(57),
    [anon_sym_PERCENT_QMARK] = ACTIONS(57),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(57),
    [anon_sym_as] = ACTIONS(57),
    [anon_sym_LPAREN2] = ACTIONS(57),
    [anon_sym_DOT_GT] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(55),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(57),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [20] = {
    [sym_block] = STATE(228),
    [sym_expression] = STATE(8),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [ts_builtin_sym_end] = ACTIONS(53),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_use] = ACTIONS(53),
    [anon_sym_EQ] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_type] = ACTIONS(53),
    [anon_sym_is] = ACTIONS(51),
    [anon_sym_actor] = ACTIONS(53),
    [anon_sym_class] = ACTIONS(53),
    [anon_sym_primitive] = ACTIONS(53),
    [anon_sym_interface] = ACTIONS(53),
    [anon_sym_trait] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_embed] = ACTIONS(53),
    [anon_sym_let] = ACTIONS(53),
    [anon_sym_var] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(53),
    [anon_sym_fun] = ACTIONS(53),
    [anon_sym_be] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(177),
    [anon_sym_DOT] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(53),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_PERCENT] = ACTIONS(51),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(51),
    [anon_sym_LT_LT] = ACTIONS(51),
    [anon_sym_GT_GT] = ACTIONS(51),
    [anon_sym_and] = ACTIONS(53),
    [anon_sym_or] = ACTIONS(53),
    [anon_sym_xor] = ACTIONS(53),
    [anon_sym_isnt] = ACTIONS(53),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(51),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_PLUS_TILDE] = ACTIONS(53),
    [anon_sym_STAR_TILDE] = ACTIONS(53),
    [anon_sym_SLASH_TILDE] = ACTIONS(53),
    [anon_sym_PERCENT_TILDE] = ACTIONS(53),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(53),
    [anon_sym_LT_LT_TILDE] = ACTIONS(53),
    [anon_sym_GT_GT_TILDE] = ACTIONS(53),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(53),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(53),
    [anon_sym_GT_TILDE] = ACTIONS(53),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(53),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(53),
    [anon_sym_LT_TILDE] = ACTIONS(53),
    [anon_sym_PLUS_QMARK] = ACTIONS(53),
    [anon_sym_DASH_QMARK] = ACTIONS(53),
    [anon_sym_STAR_QMARK] = ACTIONS(53),
    [anon_sym_SLASH_QMARK] = ACTIONS(53),
    [anon_sym_PERCENT_QMARK] = ACTIONS(53),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(53),
    [anon_sym_as] = ACTIONS(53),
    [anon_sym_LPAREN2] = ACTIONS(53),
    [anon_sym_DOT_GT] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [21] = {
    [sym_expression] = STATE(379),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_arguments] = STATE(332),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_block_repeat1] = STATE(23),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_EQ] = ACTIONS(29),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_is] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(341),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_DOT] = ACTIONS(35),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_SEMI] = ACTIONS(345),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(37),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(39),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_PLUS] = ACTIONS(33),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_SLASH] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(33),
    [anon_sym_LT_LT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(33),
    [anon_sym_and] = ACTIONS(41),
    [anon_sym_or] = ACTIONS(41),
    [anon_sym_xor] = ACTIONS(41),
    [anon_sym_isnt] = ACTIONS(41),
    [anon_sym_EQ_EQ] = ACTIONS(33),
    [anon_sym_BANG_EQ] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(33),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_PLUS_TILDE] = ACTIONS(41),
    [anon_sym_STAR_TILDE] = ACTIONS(41),
    [anon_sym_SLASH_TILDE] = ACTIONS(41),
    [anon_sym_PERCENT_TILDE] = ACTIONS(41),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(41),
    [anon_sym_LT_LT_TILDE] = ACTIONS(41),
    [anon_sym_GT_GT_TILDE] = ACTIONS(41),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(41),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(41),
    [anon_sym_GT_TILDE] = ACTIONS(41),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(41),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(41),
    [anon_sym_LT_TILDE] = ACTIONS(41),
    [anon_sym_PLUS_QMARK] = ACTIONS(41),
    [anon_sym_DASH_QMARK] = ACTIONS(41),
    [anon_sym_STAR_QMARK] = ACTIONS(41),
    [anon_sym_SLASH_QMARK] = ACTIONS(41),
    [anon_sym_PERCENT_QMARK] = ACTIONS(41),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(41),
    [anon_sym_as] = ACTIONS(43),
    [anon_sym_LPAREN2] = ACTIONS(45),
    [anon_sym_DOT_GT] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(31),
    [anon_sym_TILDE] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_else] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [22] = {
    [sym_expression] = STATE(379),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_arguments] = STATE(332),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_block_repeat1] = STATE(24),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_EQ] = ACTIONS(29),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_is] = ACTIONS(33),
    [anon_sym_embed] = ACTIONS(31),
    [anon_sym_let] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_new] = ACTIONS(31),
    [anon_sym_fun] = ACTIONS(31),
    [anon_sym_be] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(341),
    [anon_sym_DOT] = ACTIONS(35),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_SEMI] = ACTIONS(345),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(37),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(39),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_PLUS] = ACTIONS(33),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_SLASH] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(33),
    [anon_sym_LT_LT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(33),
    [anon_sym_and] = ACTIONS(41),
    [anon_sym_or] = ACTIONS(41),
    [anon_sym_xor] = ACTIONS(41),
    [anon_sym_isnt] = ACTIONS(41),
    [anon_sym_EQ_EQ] = ACTIONS(33),
    [anon_sym_BANG_EQ] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(33),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_PLUS_TILDE] = ACTIONS(41),
    [anon_sym_STAR_TILDE] = ACTIONS(41),
    [anon_sym_SLASH_TILDE] = ACTIONS(41),
    [anon_sym_PERCENT_TILDE] = ACTIONS(41),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(41),
    [anon_sym_LT_LT_TILDE] = ACTIONS(41),
    [anon_sym_GT_GT_TILDE] = ACTIONS(41),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(41),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(41),
    [anon_sym_GT_TILDE] = ACTIONS(41),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(41),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(41),
    [anon_sym_LT_TILDE] = ACTIONS(41),
    [anon_sym_PLUS_QMARK] = ACTIONS(41),
    [anon_sym_DASH_QMARK] = ACTIONS(41),
    [anon_sym_STAR_QMARK] = ACTIONS(41),
    [anon_sym_SLASH_QMARK] = ACTIONS(41),
    [anon_sym_PERCENT_QMARK] = ACTIONS(41),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(41),
    [anon_sym_as] = ACTIONS(43),
    [anon_sym_LPAREN2] = ACTIONS(45),
    [anon_sym_DOT_GT] = ACTIONS(47),
    [anon_sym_TILDE] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(27),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [23] = {
    [sym_expression] = STATE(379),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_block_repeat1] = STATE(6),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_EQ] = ACTIONS(163),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_is] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(341),
    [anon_sym_RPAREN] = ACTIONS(165),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_SEMI] = ACTIONS(345),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(165),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_PERCENT] = ACTIONS(163),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(163),
    [anon_sym_LT_LT] = ACTIONS(163),
    [anon_sym_GT_GT] = ACTIONS(163),
    [anon_sym_and] = ACTIONS(165),
    [anon_sym_or] = ACTIONS(165),
    [anon_sym_xor] = ACTIONS(165),
    [anon_sym_isnt] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(163),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(163),
    [anon_sym_PLUS_TILDE] = ACTIONS(165),
    [anon_sym_STAR_TILDE] = ACTIONS(165),
    [anon_sym_SLASH_TILDE] = ACTIONS(165),
    [anon_sym_PERCENT_TILDE] = ACTIONS(165),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(165),
    [anon_sym_LT_LT_TILDE] = ACTIONS(165),
    [anon_sym_GT_GT_TILDE] = ACTIONS(165),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(165),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(165),
    [anon_sym_GT_TILDE] = ACTIONS(165),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(165),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(165),
    [anon_sym_LT_TILDE] = ACTIONS(165),
    [anon_sym_PLUS_QMARK] = ACTIONS(165),
    [anon_sym_DASH_QMARK] = ACTIONS(165),
    [anon_sym_STAR_QMARK] = ACTIONS(165),
    [anon_sym_SLASH_QMARK] = ACTIONS(165),
    [anon_sym_PERCENT_QMARK] = ACTIONS(165),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(165),
    [anon_sym_as] = ACTIONS(165),
    [anon_sym_LPAREN2] = ACTIONS(165),
    [anon_sym_DOT_GT] = ACTIONS(165),
    [anon_sym_where] = ACTIONS(165),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_end] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_else] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_do] = ACTIONS(165),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [24] = {
    [sym_expression] = STATE(379),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_block_repeat1] = STATE(6),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_EQ] = ACTIONS(163),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_is] = ACTIONS(163),
    [anon_sym_embed] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_new] = ACTIONS(165),
    [anon_sym_fun] = ACTIONS(165),
    [anon_sym_be] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(341),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_SEMI] = ACTIONS(345),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(165),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_PERCENT] = ACTIONS(163),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(163),
    [anon_sym_LT_LT] = ACTIONS(163),
    [anon_sym_GT_GT] = ACTIONS(163),
    [anon_sym_and] = ACTIONS(165),
    [anon_sym_or] = ACTIONS(165),
    [anon_sym_xor] = ACTIONS(165),
    [anon_sym_isnt] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(163),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(163),
    [anon_sym_PLUS_TILDE] = ACTIONS(165),
    [anon_sym_STAR_TILDE] = ACTIONS(165),
    [anon_sym_SLASH_TILDE] = ACTIONS(165),
    [anon_sym_PERCENT_TILDE] = ACTIONS(165),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(165),
    [anon_sym_LT_LT_TILDE] = ACTIONS(165),
    [anon_sym_GT_GT_TILDE] = ACTIONS(165),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(165),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(165),
    [anon_sym_GT_TILDE] = ACTIONS(165),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(165),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(165),
    [anon_sym_LT_TILDE] = ACTIONS(165),
    [anon_sym_PLUS_QMARK] = ACTIONS(165),
    [anon_sym_DASH_QMARK] = ACTIONS(165),
    [anon_sym_STAR_QMARK] = ACTIONS(165),
    [anon_sym_SLASH_QMARK] = ACTIONS(165),
    [anon_sym_PERCENT_QMARK] = ACTIONS(165),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(165),
    [anon_sym_as] = ACTIONS(165),
    [anon_sym_LPAREN2] = ACTIONS(165),
    [anon_sym_DOT_GT] = ACTIONS(165),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_end] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [25] = {
    [sym_block] = STATE(228),
    [sym_expression] = STATE(21),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_EQ] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_is] = ACTIONS(51),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(341),
    [anon_sym_RPAREN] = ACTIONS(53),
    [anon_sym_DOT] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(53),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_PERCENT] = ACTIONS(51),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(51),
    [anon_sym_LT_LT] = ACTIONS(51),
    [anon_sym_GT_GT] = ACTIONS(51),
    [anon_sym_and] = ACTIONS(53),
    [anon_sym_or] = ACTIONS(53),
    [anon_sym_xor] = ACTIONS(53),
    [anon_sym_isnt] = ACTIONS(53),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(51),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_PLUS_TILDE] = ACTIONS(53),
    [anon_sym_STAR_TILDE] = ACTIONS(53),
    [anon_sym_SLASH_TILDE] = ACTIONS(53),
    [anon_sym_PERCENT_TILDE] = ACTIONS(53),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(53),
    [anon_sym_LT_LT_TILDE] = ACTIONS(53),
    [anon_sym_GT_GT_TILDE] = ACTIONS(53),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(53),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(53),
    [anon_sym_GT_TILDE] = ACTIONS(53),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(53),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(53),
    [anon_sym_LT_TILDE] = ACTIONS(53),
    [anon_sym_PLUS_QMARK] = ACTIONS(53),
    [anon_sym_DASH_QMARK] = ACTIONS(53),
    [anon_sym_STAR_QMARK] = ACTIONS(53),
    [anon_sym_SLASH_QMARK] = ACTIONS(53),
    [anon_sym_PERCENT_QMARK] = ACTIONS(53),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(53),
    [anon_sym_as] = ACTIONS(53),
    [anon_sym_LPAREN2] = ACTIONS(53),
    [anon_sym_DOT_GT] = ACTIONS(53),
    [anon_sym_where] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_end] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_else] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_do] = ACTIONS(53),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [26] = {
    [sym_block] = STATE(226),
    [sym_expression] = STATE(21),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_is] = ACTIONS(59),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(61),
    [anon_sym_LPAREN] = ACTIONS(341),
    [anon_sym_RPAREN] = ACTIONS(61),
    [anon_sym_DOT] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(61),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(59),
    [anon_sym_PERCENT] = ACTIONS(59),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(59),
    [anon_sym_LT_LT] = ACTIONS(59),
    [anon_sym_GT_GT] = ACTIONS(59),
    [anon_sym_and] = ACTIONS(61),
    [anon_sym_or] = ACTIONS(61),
    [anon_sym_xor] = ACTIONS(61),
    [anon_sym_isnt] = ACTIONS(61),
    [anon_sym_EQ_EQ] = ACTIONS(59),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_PLUS_TILDE] = ACTIONS(61),
    [anon_sym_STAR_TILDE] = ACTIONS(61),
    [anon_sym_SLASH_TILDE] = ACTIONS(61),
    [anon_sym_PERCENT_TILDE] = ACTIONS(61),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(61),
    [anon_sym_LT_LT_TILDE] = ACTIONS(61),
    [anon_sym_GT_GT_TILDE] = ACTIONS(61),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(61),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(61),
    [anon_sym_GT_TILDE] = ACTIONS(61),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(61),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(61),
    [anon_sym_LT_TILDE] = ACTIONS(61),
    [anon_sym_PLUS_QMARK] = ACTIONS(61),
    [anon_sym_DASH_QMARK] = ACTIONS(61),
    [anon_sym_STAR_QMARK] = ACTIONS(61),
    [anon_sym_SLASH_QMARK] = ACTIONS(61),
    [anon_sym_PERCENT_QMARK] = ACTIONS(61),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(61),
    [anon_sym_as] = ACTIONS(61),
    [anon_sym_LPAREN2] = ACTIONS(61),
    [anon_sym_DOT_GT] = ACTIONS(61),
    [anon_sym_where] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(61),
    [anon_sym_end] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_else] = ACTIONS(61),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_do] = ACTIONS(61),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [27] = {
    [sym_expression] = STATE(477),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_arguments] = STATE(332),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_block_repeat1] = STATE(37),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_EQ] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_is] = ACTIONS(399),
    [anon_sym_let] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_DOT] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(31),
    [sym_error] = ACTIONS(31),
    [sym_compile_intrinsic] = ACTIONS(31),
    [anon_sym_compile_error] = ACTIONS(31),
    [sym_location] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_not] = ACTIONS(31),
    [anon_sym_DASH_TILDE] = ACTIONS(405),
    [anon_sym_addressof] = ACTIONS(31),
    [anon_sym_digestof] = ACTIONS(31),
    [anon_sym_PLUS] = ACTIONS(399),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(399),
    [anon_sym_PERCENT] = ACTIONS(399),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(399),
    [anon_sym_LT_LT] = ACTIONS(399),
    [anon_sym_GT_GT] = ACTIONS(399),
    [anon_sym_and] = ACTIONS(407),
    [anon_sym_or] = ACTIONS(407),
    [anon_sym_xor] = ACTIONS(407),
    [anon_sym_isnt] = ACTIONS(407),
    [anon_sym_EQ_EQ] = ACTIONS(399),
    [anon_sym_BANG_EQ] = ACTIONS(399),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(399),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_PLUS_TILDE] = ACTIONS(407),
    [anon_sym_STAR_TILDE] = ACTIONS(407),
    [anon_sym_SLASH_TILDE] = ACTIONS(407),
    [anon_sym_PERCENT_TILDE] = ACTIONS(407),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(407),
    [anon_sym_LT_LT_TILDE] = ACTIONS(407),
    [anon_sym_GT_GT_TILDE] = ACTIONS(407),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(407),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(407),
    [anon_sym_GT_TILDE] = ACTIONS(407),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(407),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(407),
    [anon_sym_LT_TILDE] = ACTIONS(407),
    [anon_sym_PLUS_QMARK] = ACTIONS(407),
    [anon_sym_DASH_QMARK] = ACTIONS(407),
    [anon_sym_STAR_QMARK] = ACTIONS(407),
    [anon_sym_SLASH_QMARK] = ACTIONS(407),
    [anon_sym_PERCENT_QMARK] = ACTIONS(407),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(407),
    [anon_sym_as] = ACTIONS(409),
    [anon_sym_LPAREN2] = ACTIONS(45),
    [anon_sym_DOT_GT] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_end] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_ifdef] = ACTIONS(31),
    [anon_sym_iftype] = ACTIONS(31),
    [anon_sym_else] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(31),
    [anon_sym_with] = ACTIONS(31),
    [anon_sym_repeat] = ACTIONS(31),
    [anon_sym_recover] = ACTIONS(31),
    [anon_sym_match] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_consume] = ACTIONS(31),
    [anon_sym_object] = ACTIONS(31),
    [sym_number] = ACTIONS(27),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(27),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(31),
    [anon_sym_true] = ACTIONS(31),
    [anon_sym_false] = ACTIONS(31),
    [sym_this] = ACTIONS(31),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [28] = {
    [sym_block] = STATE(227),
    [sym_expression] = STATE(21),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_is] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(57),
    [anon_sym_LPAREN] = ACTIONS(341),
    [anon_sym_RPAREN] = ACTIONS(57),
    [anon_sym_DOT] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(57),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(55),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(55),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(55),
    [anon_sym_and] = ACTIONS(57),
    [anon_sym_or] = ACTIONS(57),
    [anon_sym_xor] = ACTIONS(57),
    [anon_sym_isnt] = ACTIONS(57),
    [anon_sym_EQ_EQ] = ACTIONS(55),
    [anon_sym_BANG_EQ] = ACTIONS(55),
    [anon_sym_GT] = ACTIONS(55),
    [anon_sym_GT_EQ] = ACTIONS(55),
    [anon_sym_LT_EQ] = ACTIONS(55),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_PLUS_TILDE] = ACTIONS(57),
    [anon_sym_STAR_TILDE] = ACTIONS(57),
    [anon_sym_SLASH_TILDE] = ACTIONS(57),
    [anon_sym_PERCENT_TILDE] = ACTIONS(57),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(57),
    [anon_sym_LT_LT_TILDE] = ACTIONS(57),
    [anon_sym_GT_GT_TILDE] = ACTIONS(57),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(57),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(57),
    [anon_sym_GT_TILDE] = ACTIONS(57),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(57),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(57),
    [anon_sym_LT_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_QMARK] = ACTIONS(57),
    [anon_sym_DASH_QMARK] = ACTIONS(57),
    [anon_sym_STAR_QMARK] = ACTIONS(57),
    [anon_sym_SLASH_QMARK] = ACTIONS(57),
    [anon_sym_PERCENT_QMARK] = ACTIONS(57),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(57),
    [anon_sym_as] = ACTIONS(57),
    [anon_sym_LPAREN2] = ACTIONS(57),
    [anon_sym_DOT_GT] = ACTIONS(57),
    [anon_sym_where] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_end] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_else] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [29] = {
    [sym_block] = STATE(227),
    [sym_expression] = STATE(22),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_is] = ACTIONS(55),
    [anon_sym_embed] = ACTIONS(57),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_var] = ACTIONS(57),
    [anon_sym_new] = ACTIONS(57),
    [anon_sym_fun] = ACTIONS(57),
    [anon_sym_be] = ACTIONS(57),
    [anon_sym_LPAREN] = ACTIONS(341),
    [anon_sym_DOT] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(57),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(55),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(55),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(55),
    [anon_sym_and] = ACTIONS(57),
    [anon_sym_or] = ACTIONS(57),
    [anon_sym_xor] = ACTIONS(57),
    [anon_sym_isnt] = ACTIONS(57),
    [anon_sym_EQ_EQ] = ACTIONS(55),
    [anon_sym_BANG_EQ] = ACTIONS(55),
    [anon_sym_GT] = ACTIONS(55),
    [anon_sym_GT_EQ] = ACTIONS(55),
    [anon_sym_LT_EQ] = ACTIONS(55),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_PLUS_TILDE] = ACTIONS(57),
    [anon_sym_STAR_TILDE] = ACTIONS(57),
    [anon_sym_SLASH_TILDE] = ACTIONS(57),
    [anon_sym_PERCENT_TILDE] = ACTIONS(57),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(57),
    [anon_sym_LT_LT_TILDE] = ACTIONS(57),
    [anon_sym_GT_GT_TILDE] = ACTIONS(57),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(57),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(57),
    [anon_sym_GT_TILDE] = ACTIONS(57),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(57),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(57),
    [anon_sym_LT_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_QMARK] = ACTIONS(57),
    [anon_sym_DASH_QMARK] = ACTIONS(57),
    [anon_sym_STAR_QMARK] = ACTIONS(57),
    [anon_sym_SLASH_QMARK] = ACTIONS(57),
    [anon_sym_PERCENT_QMARK] = ACTIONS(57),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(57),
    [anon_sym_as] = ACTIONS(57),
    [anon_sym_LPAREN2] = ACTIONS(57),
    [anon_sym_DOT_GT] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_end] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(55),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(57),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [30] = {
    [sym_expression] = STATE(481),
    [sym_compile_error] = STATE(560),
    [sym_unary_expression] = STATE(560),
    [sym_binary_expression] = STATE(560),
    [sym_tuple_expression] = STATE(560),
    [sym_generic_expression] = STATE(560),
    [sym_assignment_expression] = STATE(560),
    [sym_variable_declaration] = STATE(560),
    [sym_cast_expression] = STATE(560),
    [sym_call_expression] = STATE(560),
    [sym_arguments] = STATE(494),
    [sym_chain_expression] = STATE(560),
    [sym_lambda_expression] = STATE(560),
    [sym_partial_application] = STATE(560),
    [sym_member_expression] = STATE(560),
    [sym_parenthesized_expression] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_if_block] = STATE(2180),
    [sym_iftype_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_try_statement] = STATE(560),
    [sym_with_statement] = STATE(560),
    [sym_repeat_statement] = STATE(560),
    [sym_recover_statement] = STATE(560),
    [sym_match_statement] = STATE(560),
    [sym_return_statement] = STATE(560),
    [sym_continue_statement] = STATE(560),
    [sym_break_statement] = STATE(560),
    [sym_consume_statement] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_array_literal] = STATE(561),
    [sym_object_literal] = STATE(561),
    [sym_string] = STATE(561),
    [sym__string_literal] = STATE(533),
    [sym__multiline_string_literal] = STATE(533),
    [sym_character] = STATE(561),
    [sym_boolean] = STATE(561),
    [sym_ffi_identifier] = STATE(472),
    [aux_sym_block_repeat1] = STATE(585),
    [sym_identifier] = ACTIONS(415),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_AT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_is] = ACTIONS(423),
    [anon_sym_let] = ACTIONS(425),
    [anon_sym_var] = ACTIONS(425),
    [anon_sym_LPAREN] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(431),
    [anon_sym_SEMI] = ACTIONS(433),
    [sym_error] = ACTIONS(435),
    [sym_compile_intrinsic] = ACTIONS(435),
    [anon_sym_compile_error] = ACTIONS(437),
    [sym_location] = ACTIONS(435),
    [anon_sym_DASH] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_DASH_TILDE] = ACTIONS(443),
    [anon_sym_addressof] = ACTIONS(441),
    [anon_sym_digestof] = ACTIONS(441),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(445),
    [anon_sym_or] = ACTIONS(445),
    [anon_sym_xor] = ACTIONS(445),
    [anon_sym_isnt] = ACTIONS(445),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_PLUS_TILDE] = ACTIONS(445),
    [anon_sym_STAR_TILDE] = ACTIONS(445),
    [anon_sym_SLASH_TILDE] = ACTIONS(445),
    [anon_sym_PERCENT_TILDE] = ACTIONS(445),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(445),
    [anon_sym_LT_LT_TILDE] = ACTIONS(445),
    [anon_sym_GT_GT_TILDE] = ACTIONS(445),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(445),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(445),
    [anon_sym_GT_TILDE] = ACTIONS(445),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(445),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(445),
    [anon_sym_LT_TILDE] = ACTIONS(445),
    [anon_sym_PLUS_QMARK] = ACTIONS(445),
    [anon_sym_DASH_QMARK] = ACTIONS(445),
    [anon_sym_STAR_QMARK] = ACTIONS(445),
    [anon_sym_SLASH_QMARK] = ACTIONS(445),
    [anon_sym_PERCENT_QMARK] = ACTIONS(445),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(445),
    [anon_sym_as] = ACTIONS(447),
    [anon_sym_LPAREN2] = ACTIONS(449),
    [anon_sym_DOT_GT] = ACTIONS(451),
    [anon_sym_TILDE] = ACTIONS(453),
    [anon_sym_end] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_elseif] = ACTIONS(31),
    [anon_sym_iftype] = ACTIONS(455),
    [anon_sym_else] = ACTIONS(27),
    [anon_sym_for] = ACTIONS(457),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(461),
    [anon_sym_with] = ACTIONS(463),
    [anon_sym_repeat] = ACTIONS(465),
    [anon_sym_recover] = ACTIONS(467),
    [anon_sym_match] = ACTIONS(469),
    [anon_sym_return] = ACTIONS(471),
    [anon_sym_continue] = ACTIONS(473),
    [anon_sym_break] = ACTIONS(475),
    [anon_sym_consume] = ACTIONS(477),
    [anon_sym_object] = ACTIONS(479),
    [sym_number] = ACTIONS(481),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [anon_sym_SQUOTE] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_this] = ACTIONS(435),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [31] = {
    [sym_block] = STATE(226),
    [sym_expression] = STATE(22),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_is] = ACTIONS(59),
    [anon_sym_embed] = ACTIONS(61),
    [anon_sym_let] = ACTIONS(61),
    [anon_sym_var] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(61),
    [anon_sym_fun] = ACTIONS(61),
    [anon_sym_be] = ACTIONS(61),
    [anon_sym_LPAREN] = ACTIONS(341),
    [anon_sym_DOT] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(61),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(59),
    [anon_sym_PERCENT] = ACTIONS(59),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(59),
    [anon_sym_LT_LT] = ACTIONS(59),
    [anon_sym_GT_GT] = ACTIONS(59),
    [anon_sym_and] = ACTIONS(61),
    [anon_sym_or] = ACTIONS(61),
    [anon_sym_xor] = ACTIONS(61),
    [anon_sym_isnt] = ACTIONS(61),
    [anon_sym_EQ_EQ] = ACTIONS(59),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_PLUS_TILDE] = ACTIONS(61),
    [anon_sym_STAR_TILDE] = ACTIONS(61),
    [anon_sym_SLASH_TILDE] = ACTIONS(61),
    [anon_sym_PERCENT_TILDE] = ACTIONS(61),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(61),
    [anon_sym_LT_LT_TILDE] = ACTIONS(61),
    [anon_sym_GT_GT_TILDE] = ACTIONS(61),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(61),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(61),
    [anon_sym_GT_TILDE] = ACTIONS(61),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(61),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(61),
    [anon_sym_LT_TILDE] = ACTIONS(61),
    [anon_sym_PLUS_QMARK] = ACTIONS(61),
    [anon_sym_DASH_QMARK] = ACTIONS(61),
    [anon_sym_STAR_QMARK] = ACTIONS(61),
    [anon_sym_SLASH_QMARK] = ACTIONS(61),
    [anon_sym_PERCENT_QMARK] = ACTIONS(61),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(61),
    [anon_sym_as] = ACTIONS(61),
    [anon_sym_LPAREN2] = ACTIONS(61),
    [anon_sym_DOT_GT] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(61),
    [anon_sym_end] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(59),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(61),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [32] = {
    [sym_block] = STATE(384),
    [sym_expression] = STATE(27),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(51),
    [anon_sym_EQ] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_is] = ACTIONS(51),
    [anon_sym_let] = ACTIONS(53),
    [anon_sym_var] = ACTIONS(53),
    [anon_sym_EQ_GT] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_DOT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(53),
    [sym_error] = ACTIONS(53),
    [sym_compile_intrinsic] = ACTIONS(53),
    [anon_sym_compile_error] = ACTIONS(53),
    [sym_location] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_not] = ACTIONS(53),
    [anon_sym_DASH_TILDE] = ACTIONS(53),
    [anon_sym_addressof] = ACTIONS(53),
    [anon_sym_digestof] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_PERCENT] = ACTIONS(51),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(51),
    [anon_sym_LT_LT] = ACTIONS(51),
    [anon_sym_GT_GT] = ACTIONS(51),
    [anon_sym_and] = ACTIONS(53),
    [anon_sym_or] = ACTIONS(53),
    [anon_sym_xor] = ACTIONS(53),
    [anon_sym_isnt] = ACTIONS(53),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(51),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_PLUS_TILDE] = ACTIONS(53),
    [anon_sym_STAR_TILDE] = ACTIONS(53),
    [anon_sym_SLASH_TILDE] = ACTIONS(53),
    [anon_sym_PERCENT_TILDE] = ACTIONS(53),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(53),
    [anon_sym_LT_LT_TILDE] = ACTIONS(53),
    [anon_sym_GT_GT_TILDE] = ACTIONS(53),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(53),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(53),
    [anon_sym_GT_TILDE] = ACTIONS(53),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(53),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(53),
    [anon_sym_LT_TILDE] = ACTIONS(53),
    [anon_sym_PLUS_QMARK] = ACTIONS(53),
    [anon_sym_DASH_QMARK] = ACTIONS(53),
    [anon_sym_STAR_QMARK] = ACTIONS(53),
    [anon_sym_SLASH_QMARK] = ACTIONS(53),
    [anon_sym_PERCENT_QMARK] = ACTIONS(53),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(53),
    [anon_sym_as] = ACTIONS(53),
    [anon_sym_LPAREN2] = ACTIONS(53),
    [anon_sym_DOT_GT] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_end] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_ifdef] = ACTIONS(53),
    [anon_sym_iftype] = ACTIONS(53),
    [anon_sym_else] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_repeat] = ACTIONS(53),
    [anon_sym_recover] = ACTIONS(53),
    [anon_sym_match] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_continue] = ACTIONS(53),
    [anon_sym_break] = ACTIONS(53),
    [anon_sym_consume] = ACTIONS(53),
    [anon_sym_object] = ACTIONS(53),
    [sym_number] = ACTIONS(51),
    [sym_float] = ACTIONS(53),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [sym_this] = ACTIONS(53),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [33] = {
    [sym_block] = STATE(385),
    [sym_expression] = STATE(27),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(55),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_is] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_var] = ACTIONS(57),
    [anon_sym_EQ_GT] = ACTIONS(57),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(55),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(57),
    [sym_error] = ACTIONS(57),
    [sym_compile_intrinsic] = ACTIONS(57),
    [anon_sym_compile_error] = ACTIONS(57),
    [sym_location] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_DASH_TILDE] = ACTIONS(57),
    [anon_sym_addressof] = ACTIONS(57),
    [anon_sym_digestof] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(55),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(55),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(55),
    [anon_sym_and] = ACTIONS(57),
    [anon_sym_or] = ACTIONS(57),
    [anon_sym_xor] = ACTIONS(57),
    [anon_sym_isnt] = ACTIONS(57),
    [anon_sym_EQ_EQ] = ACTIONS(55),
    [anon_sym_BANG_EQ] = ACTIONS(55),
    [anon_sym_GT] = ACTIONS(55),
    [anon_sym_GT_EQ] = ACTIONS(55),
    [anon_sym_LT_EQ] = ACTIONS(55),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_PLUS_TILDE] = ACTIONS(57),
    [anon_sym_STAR_TILDE] = ACTIONS(57),
    [anon_sym_SLASH_TILDE] = ACTIONS(57),
    [anon_sym_PERCENT_TILDE] = ACTIONS(57),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(57),
    [anon_sym_LT_LT_TILDE] = ACTIONS(57),
    [anon_sym_GT_GT_TILDE] = ACTIONS(57),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(57),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(57),
    [anon_sym_GT_TILDE] = ACTIONS(57),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(57),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(57),
    [anon_sym_LT_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_QMARK] = ACTIONS(57),
    [anon_sym_DASH_QMARK] = ACTIONS(57),
    [anon_sym_STAR_QMARK] = ACTIONS(57),
    [anon_sym_SLASH_QMARK] = ACTIONS(57),
    [anon_sym_PERCENT_QMARK] = ACTIONS(57),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(57),
    [anon_sym_as] = ACTIONS(57),
    [anon_sym_LPAREN2] = ACTIONS(57),
    [anon_sym_DOT_GT] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_end] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_ifdef] = ACTIONS(57),
    [anon_sym_iftype] = ACTIONS(57),
    [anon_sym_else] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_try] = ACTIONS(57),
    [anon_sym_with] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(57),
    [anon_sym_recover] = ACTIONS(57),
    [anon_sym_match] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(57),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_consume] = ACTIONS(57),
    [anon_sym_object] = ACTIONS(57),
    [sym_number] = ACTIONS(55),
    [sym_float] = ACTIONS(57),
    [anon_sym_DQUOTE] = ACTIONS(55),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(57),
    [anon_sym_SQUOTE] = ACTIONS(57),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [sym_this] = ACTIONS(57),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [34] = {
    [sym_expression] = STATE(481),
    [sym_compile_error] = STATE(560),
    [sym_unary_expression] = STATE(560),
    [sym_binary_expression] = STATE(560),
    [sym_tuple_expression] = STATE(560),
    [sym_generic_expression] = STATE(560),
    [sym_assignment_expression] = STATE(560),
    [sym_variable_declaration] = STATE(560),
    [sym_cast_expression] = STATE(560),
    [sym_call_expression] = STATE(560),
    [sym_arguments] = STATE(494),
    [sym_chain_expression] = STATE(560),
    [sym_lambda_expression] = STATE(560),
    [sym_partial_application] = STATE(560),
    [sym_member_expression] = STATE(560),
    [sym_parenthesized_expression] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_if_block] = STATE(2180),
    [sym_iftype_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_try_statement] = STATE(560),
    [sym_with_statement] = STATE(560),
    [sym_repeat_statement] = STATE(560),
    [sym_recover_statement] = STATE(560),
    [sym_match_statement] = STATE(560),
    [sym_return_statement] = STATE(560),
    [sym_continue_statement] = STATE(560),
    [sym_break_statement] = STATE(560),
    [sym_consume_statement] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_array_literal] = STATE(561),
    [sym_object_literal] = STATE(561),
    [sym_string] = STATE(561),
    [sym__string_literal] = STATE(533),
    [sym__multiline_string_literal] = STATE(533),
    [sym_character] = STATE(561),
    [sym_boolean] = STATE(561),
    [sym_ffi_identifier] = STATE(472),
    [aux_sym_block_repeat1] = STATE(40),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_AT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_is] = ACTIONS(423),
    [anon_sym_let] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(31),
    [sym_error] = ACTIONS(31),
    [sym_compile_intrinsic] = ACTIONS(31),
    [anon_sym_compile_error] = ACTIONS(31),
    [sym_location] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(31),
    [anon_sym_DASH_TILDE] = ACTIONS(443),
    [anon_sym_addressof] = ACTIONS(31),
    [anon_sym_digestof] = ACTIONS(31),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(445),
    [anon_sym_or] = ACTIONS(445),
    [anon_sym_xor] = ACTIONS(445),
    [anon_sym_isnt] = ACTIONS(445),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_PLUS_TILDE] = ACTIONS(445),
    [anon_sym_STAR_TILDE] = ACTIONS(445),
    [anon_sym_SLASH_TILDE] = ACTIONS(445),
    [anon_sym_PERCENT_TILDE] = ACTIONS(445),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(445),
    [anon_sym_LT_LT_TILDE] = ACTIONS(445),
    [anon_sym_GT_GT_TILDE] = ACTIONS(445),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(445),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(445),
    [anon_sym_GT_TILDE] = ACTIONS(445),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(445),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(445),
    [anon_sym_LT_TILDE] = ACTIONS(445),
    [anon_sym_PLUS_QMARK] = ACTIONS(445),
    [anon_sym_DASH_QMARK] = ACTIONS(445),
    [anon_sym_STAR_QMARK] = ACTIONS(445),
    [anon_sym_SLASH_QMARK] = ACTIONS(445),
    [anon_sym_PERCENT_QMARK] = ACTIONS(445),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(445),
    [anon_sym_as] = ACTIONS(447),
    [anon_sym_LPAREN2] = ACTIONS(449),
    [anon_sym_DOT_GT] = ACTIONS(451),
    [anon_sym_TILDE] = ACTIONS(453),
    [anon_sym_end] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_ifdef] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(31),
    [anon_sym_iftype] = ACTIONS(31),
    [anon_sym_else] = ACTIONS(27),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(31),
    [anon_sym_with] = ACTIONS(31),
    [anon_sym_repeat] = ACTIONS(31),
    [anon_sym_recover] = ACTIONS(31),
    [anon_sym_match] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_consume] = ACTIONS(31),
    [anon_sym_object] = ACTIONS(31),
    [sym_number] = ACTIONS(27),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(27),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(31),
    [anon_sym_true] = ACTIONS(31),
    [anon_sym_false] = ACTIONS(31),
    [sym_this] = ACTIONS(31),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [35] = {
    [sym_expression] = STATE(477),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_arguments] = STATE(332),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_block_repeat1] = STATE(583),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_EQ] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_is] = ACTIONS(399),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(341),
    [anon_sym_DOT] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_SEMI] = ACTIONS(493),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_not] = ACTIONS(495),
    [anon_sym_DASH_TILDE] = ACTIONS(405),
    [anon_sym_addressof] = ACTIONS(495),
    [anon_sym_digestof] = ACTIONS(495),
    [anon_sym_PLUS] = ACTIONS(399),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(399),
    [anon_sym_PERCENT] = ACTIONS(399),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(399),
    [anon_sym_LT_LT] = ACTIONS(399),
    [anon_sym_GT_GT] = ACTIONS(399),
    [anon_sym_and] = ACTIONS(407),
    [anon_sym_or] = ACTIONS(407),
    [anon_sym_xor] = ACTIONS(407),
    [anon_sym_isnt] = ACTIONS(407),
    [anon_sym_EQ_EQ] = ACTIONS(399),
    [anon_sym_BANG_EQ] = ACTIONS(399),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(399),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_PLUS_TILDE] = ACTIONS(407),
    [anon_sym_STAR_TILDE] = ACTIONS(407),
    [anon_sym_SLASH_TILDE] = ACTIONS(407),
    [anon_sym_PERCENT_TILDE] = ACTIONS(407),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(407),
    [anon_sym_LT_LT_TILDE] = ACTIONS(407),
    [anon_sym_GT_GT_TILDE] = ACTIONS(407),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(407),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(407),
    [anon_sym_GT_TILDE] = ACTIONS(407),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(407),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(407),
    [anon_sym_LT_TILDE] = ACTIONS(407),
    [anon_sym_PLUS_QMARK] = ACTIONS(407),
    [anon_sym_DASH_QMARK] = ACTIONS(407),
    [anon_sym_STAR_QMARK] = ACTIONS(407),
    [anon_sym_SLASH_QMARK] = ACTIONS(407),
    [anon_sym_PERCENT_QMARK] = ACTIONS(407),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(407),
    [anon_sym_as] = ACTIONS(409),
    [anon_sym_LPAREN2] = ACTIONS(45),
    [anon_sym_DOT_GT] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_end] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_else] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [36] = {
    [sym_expression] = STATE(477),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_block_repeat1] = STATE(36),
    [sym_identifier] = ACTIONS(63),
    [anon_sym_EQ] = ACTIONS(66),
    [anon_sym_AT] = ACTIONS(68),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_is] = ACTIONS(66),
    [anon_sym_let] = ACTIONS(76),
    [anon_sym_var] = ACTIONS(76),
    [anon_sym_EQ_GT] = ACTIONS(74),
    [anon_sym_LPAREN] = ACTIONS(79),
    [anon_sym_DOT] = ACTIONS(66),
    [anon_sym_PIPE] = ACTIONS(74),
    [anon_sym_LBRACE] = ACTIONS(82),
    [anon_sym_SEMI] = ACTIONS(503),
    [sym_error] = ACTIONS(88),
    [sym_compile_intrinsic] = ACTIONS(88),
    [anon_sym_compile_error] = ACTIONS(91),
    [sym_location] = ACTIONS(88),
    [anon_sym_DASH] = ACTIONS(506),
    [anon_sym_not] = ACTIONS(509),
    [anon_sym_DASH_TILDE] = ACTIONS(509),
    [anon_sym_addressof] = ACTIONS(509),
    [anon_sym_digestof] = ACTIONS(509),
    [anon_sym_PLUS] = ACTIONS(66),
    [anon_sym_STAR] = ACTIONS(66),
    [anon_sym_SLASH] = ACTIONS(66),
    [anon_sym_PERCENT] = ACTIONS(66),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(66),
    [anon_sym_LT_LT] = ACTIONS(66),
    [anon_sym_GT_GT] = ACTIONS(66),
    [anon_sym_and] = ACTIONS(74),
    [anon_sym_or] = ACTIONS(74),
    [anon_sym_xor] = ACTIONS(74),
    [anon_sym_isnt] = ACTIONS(74),
    [anon_sym_EQ_EQ] = ACTIONS(66),
    [anon_sym_BANG_EQ] = ACTIONS(66),
    [anon_sym_GT] = ACTIONS(66),
    [anon_sym_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_EQ] = ACTIONS(66),
    [anon_sym_LT] = ACTIONS(66),
    [anon_sym_PLUS_TILDE] = ACTIONS(74),
    [anon_sym_STAR_TILDE] = ACTIONS(74),
    [anon_sym_SLASH_TILDE] = ACTIONS(74),
    [anon_sym_PERCENT_TILDE] = ACTIONS(74),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(74),
    [anon_sym_LT_LT_TILDE] = ACTIONS(74),
    [anon_sym_GT_GT_TILDE] = ACTIONS(74),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(74),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(74),
    [anon_sym_GT_TILDE] = ACTIONS(74),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(74),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(74),
    [anon_sym_LT_TILDE] = ACTIONS(74),
    [anon_sym_PLUS_QMARK] = ACTIONS(74),
    [anon_sym_DASH_QMARK] = ACTIONS(74),
    [anon_sym_STAR_QMARK] = ACTIONS(74),
    [anon_sym_SLASH_QMARK] = ACTIONS(74),
    [anon_sym_PERCENT_QMARK] = ACTIONS(74),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(74),
    [anon_sym_as] = ACTIONS(74),
    [anon_sym_LPAREN2] = ACTIONS(74),
    [anon_sym_DOT_GT] = ACTIONS(74),
    [anon_sym_TILDE] = ACTIONS(74),
    [anon_sym_end] = ACTIONS(74),
    [anon_sym_if] = ACTIONS(100),
    [anon_sym_ifdef] = ACTIONS(103),
    [anon_sym_iftype] = ACTIONS(106),
    [anon_sym_else] = ACTIONS(74),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_while] = ACTIONS(112),
    [anon_sym_try] = ACTIONS(115),
    [anon_sym_with] = ACTIONS(118),
    [anon_sym_repeat] = ACTIONS(121),
    [anon_sym_recover] = ACTIONS(124),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(512),
    [anon_sym_continue] = ACTIONS(515),
    [anon_sym_break] = ACTIONS(518),
    [anon_sym_consume] = ACTIONS(139),
    [anon_sym_object] = ACTIONS(142),
    [sym_number] = ACTIONS(145),
    [sym_float] = ACTIONS(148),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(154),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(160),
    [anon_sym_false] = ACTIONS(160),
    [sym_this] = ACTIONS(88),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [37] = {
    [sym_expression] = STATE(477),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_block_repeat1] = STATE(36),
    [sym_identifier] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(163),
    [anon_sym_AT] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(165),
    [anon_sym_is] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_EQ_GT] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_error] = ACTIONS(165),
    [sym_compile_intrinsic] = ACTIONS(165),
    [anon_sym_compile_error] = ACTIONS(165),
    [sym_location] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_not] = ACTIONS(165),
    [anon_sym_DASH_TILDE] = ACTIONS(165),
    [anon_sym_addressof] = ACTIONS(165),
    [anon_sym_digestof] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_PERCENT] = ACTIONS(163),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(163),
    [anon_sym_LT_LT] = ACTIONS(163),
    [anon_sym_GT_GT] = ACTIONS(163),
    [anon_sym_and] = ACTIONS(165),
    [anon_sym_or] = ACTIONS(165),
    [anon_sym_xor] = ACTIONS(165),
    [anon_sym_isnt] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(163),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(163),
    [anon_sym_PLUS_TILDE] = ACTIONS(165),
    [anon_sym_STAR_TILDE] = ACTIONS(165),
    [anon_sym_SLASH_TILDE] = ACTIONS(165),
    [anon_sym_PERCENT_TILDE] = ACTIONS(165),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(165),
    [anon_sym_LT_LT_TILDE] = ACTIONS(165),
    [anon_sym_GT_GT_TILDE] = ACTIONS(165),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(165),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(165),
    [anon_sym_GT_TILDE] = ACTIONS(165),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(165),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(165),
    [anon_sym_LT_TILDE] = ACTIONS(165),
    [anon_sym_PLUS_QMARK] = ACTIONS(165),
    [anon_sym_DASH_QMARK] = ACTIONS(165),
    [anon_sym_STAR_QMARK] = ACTIONS(165),
    [anon_sym_SLASH_QMARK] = ACTIONS(165),
    [anon_sym_PERCENT_QMARK] = ACTIONS(165),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(165),
    [anon_sym_as] = ACTIONS(165),
    [anon_sym_LPAREN2] = ACTIONS(165),
    [anon_sym_DOT_GT] = ACTIONS(165),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_end] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(163),
    [anon_sym_ifdef] = ACTIONS(165),
    [anon_sym_iftype] = ACTIONS(165),
    [anon_sym_else] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_try] = ACTIONS(165),
    [anon_sym_with] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_recover] = ACTIONS(165),
    [anon_sym_match] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_consume] = ACTIONS(165),
    [anon_sym_object] = ACTIONS(165),
    [sym_number] = ACTIONS(163),
    [sym_float] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(165),
    [anon_sym_true] = ACTIONS(165),
    [anon_sym_false] = ACTIONS(165),
    [sym_this] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [38] = {
    [sym_block] = STATE(386),
    [sym_expression] = STATE(27),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(59),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_is] = ACTIONS(59),
    [anon_sym_let] = ACTIONS(61),
    [anon_sym_var] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(61),
    [anon_sym_LPAREN] = ACTIONS(59),
    [anon_sym_DOT] = ACTIONS(59),
    [anon_sym_PIPE] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_SEMI] = ACTIONS(61),
    [sym_error] = ACTIONS(61),
    [sym_compile_intrinsic] = ACTIONS(61),
    [anon_sym_compile_error] = ACTIONS(61),
    [sym_location] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(61),
    [anon_sym_DASH_TILDE] = ACTIONS(61),
    [anon_sym_addressof] = ACTIONS(61),
    [anon_sym_digestof] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(59),
    [anon_sym_PERCENT] = ACTIONS(59),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(59),
    [anon_sym_LT_LT] = ACTIONS(59),
    [anon_sym_GT_GT] = ACTIONS(59),
    [anon_sym_and] = ACTIONS(61),
    [anon_sym_or] = ACTIONS(61),
    [anon_sym_xor] = ACTIONS(61),
    [anon_sym_isnt] = ACTIONS(61),
    [anon_sym_EQ_EQ] = ACTIONS(59),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_PLUS_TILDE] = ACTIONS(61),
    [anon_sym_STAR_TILDE] = ACTIONS(61),
    [anon_sym_SLASH_TILDE] = ACTIONS(61),
    [anon_sym_PERCENT_TILDE] = ACTIONS(61),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(61),
    [anon_sym_LT_LT_TILDE] = ACTIONS(61),
    [anon_sym_GT_GT_TILDE] = ACTIONS(61),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(61),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(61),
    [anon_sym_GT_TILDE] = ACTIONS(61),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(61),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(61),
    [anon_sym_LT_TILDE] = ACTIONS(61),
    [anon_sym_PLUS_QMARK] = ACTIONS(61),
    [anon_sym_DASH_QMARK] = ACTIONS(61),
    [anon_sym_STAR_QMARK] = ACTIONS(61),
    [anon_sym_SLASH_QMARK] = ACTIONS(61),
    [anon_sym_PERCENT_QMARK] = ACTIONS(61),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(61),
    [anon_sym_as] = ACTIONS(61),
    [anon_sym_LPAREN2] = ACTIONS(61),
    [anon_sym_DOT_GT] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(61),
    [anon_sym_end] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_ifdef] = ACTIONS(61),
    [anon_sym_iftype] = ACTIONS(61),
    [anon_sym_else] = ACTIONS(61),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_try] = ACTIONS(61),
    [anon_sym_with] = ACTIONS(61),
    [anon_sym_repeat] = ACTIONS(61),
    [anon_sym_recover] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(61),
    [anon_sym_consume] = ACTIONS(61),
    [anon_sym_object] = ACTIONS(61),
    [sym_number] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(59),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(61),
    [anon_sym_SQUOTE] = ACTIONS(61),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [sym_this] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [39] = {
    [sym_block] = STATE(228),
    [sym_expression] = STATE(22),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_EQ] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_is] = ACTIONS(51),
    [anon_sym_embed] = ACTIONS(53),
    [anon_sym_let] = ACTIONS(53),
    [anon_sym_var] = ACTIONS(53),
    [anon_sym_new] = ACTIONS(53),
    [anon_sym_fun] = ACTIONS(53),
    [anon_sym_be] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(341),
    [anon_sym_DOT] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(53),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_PERCENT] = ACTIONS(51),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(51),
    [anon_sym_LT_LT] = ACTIONS(51),
    [anon_sym_GT_GT] = ACTIONS(51),
    [anon_sym_and] = ACTIONS(53),
    [anon_sym_or] = ACTIONS(53),
    [anon_sym_xor] = ACTIONS(53),
    [anon_sym_isnt] = ACTIONS(53),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(51),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_PLUS_TILDE] = ACTIONS(53),
    [anon_sym_STAR_TILDE] = ACTIONS(53),
    [anon_sym_SLASH_TILDE] = ACTIONS(53),
    [anon_sym_PERCENT_TILDE] = ACTIONS(53),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(53),
    [anon_sym_LT_LT_TILDE] = ACTIONS(53),
    [anon_sym_GT_GT_TILDE] = ACTIONS(53),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(53),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(53),
    [anon_sym_GT_TILDE] = ACTIONS(53),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(53),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(53),
    [anon_sym_LT_TILDE] = ACTIONS(53),
    [anon_sym_PLUS_QMARK] = ACTIONS(53),
    [anon_sym_DASH_QMARK] = ACTIONS(53),
    [anon_sym_STAR_QMARK] = ACTIONS(53),
    [anon_sym_SLASH_QMARK] = ACTIONS(53),
    [anon_sym_PERCENT_QMARK] = ACTIONS(53),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(53),
    [anon_sym_as] = ACTIONS(53),
    [anon_sym_LPAREN2] = ACTIONS(53),
    [anon_sym_DOT_GT] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_end] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [40] = {
    [sym_expression] = STATE(481),
    [sym_compile_error] = STATE(560),
    [sym_unary_expression] = STATE(560),
    [sym_binary_expression] = STATE(560),
    [sym_tuple_expression] = STATE(560),
    [sym_generic_expression] = STATE(560),
    [sym_assignment_expression] = STATE(560),
    [sym_variable_declaration] = STATE(560),
    [sym_cast_expression] = STATE(560),
    [sym_call_expression] = STATE(560),
    [sym_chain_expression] = STATE(560),
    [sym_lambda_expression] = STATE(560),
    [sym_partial_application] = STATE(560),
    [sym_member_expression] = STATE(560),
    [sym_parenthesized_expression] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_if_block] = STATE(2180),
    [sym_iftype_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_try_statement] = STATE(560),
    [sym_with_statement] = STATE(560),
    [sym_repeat_statement] = STATE(560),
    [sym_recover_statement] = STATE(560),
    [sym_match_statement] = STATE(560),
    [sym_return_statement] = STATE(560),
    [sym_continue_statement] = STATE(560),
    [sym_break_statement] = STATE(560),
    [sym_consume_statement] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_array_literal] = STATE(561),
    [sym_object_literal] = STATE(561),
    [sym_string] = STATE(561),
    [sym__string_literal] = STATE(533),
    [sym__multiline_string_literal] = STATE(533),
    [sym_character] = STATE(561),
    [sym_boolean] = STATE(561),
    [sym_ffi_identifier] = STATE(472),
    [aux_sym_block_repeat1] = STATE(42),
    [sym_identifier] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(163),
    [anon_sym_AT] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(165),
    [anon_sym_is] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_error] = ACTIONS(165),
    [sym_compile_intrinsic] = ACTIONS(165),
    [anon_sym_compile_error] = ACTIONS(165),
    [sym_location] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_not] = ACTIONS(165),
    [anon_sym_DASH_TILDE] = ACTIONS(165),
    [anon_sym_addressof] = ACTIONS(165),
    [anon_sym_digestof] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_PERCENT] = ACTIONS(163),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(163),
    [anon_sym_LT_LT] = ACTIONS(163),
    [anon_sym_GT_GT] = ACTIONS(163),
    [anon_sym_and] = ACTIONS(165),
    [anon_sym_or] = ACTIONS(165),
    [anon_sym_xor] = ACTIONS(165),
    [anon_sym_isnt] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(163),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(163),
    [anon_sym_PLUS_TILDE] = ACTIONS(165),
    [anon_sym_STAR_TILDE] = ACTIONS(165),
    [anon_sym_SLASH_TILDE] = ACTIONS(165),
    [anon_sym_PERCENT_TILDE] = ACTIONS(165),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(165),
    [anon_sym_LT_LT_TILDE] = ACTIONS(165),
    [anon_sym_GT_GT_TILDE] = ACTIONS(165),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(165),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(165),
    [anon_sym_GT_TILDE] = ACTIONS(165),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(165),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(165),
    [anon_sym_LT_TILDE] = ACTIONS(165),
    [anon_sym_PLUS_QMARK] = ACTIONS(165),
    [anon_sym_DASH_QMARK] = ACTIONS(165),
    [anon_sym_STAR_QMARK] = ACTIONS(165),
    [anon_sym_SLASH_QMARK] = ACTIONS(165),
    [anon_sym_PERCENT_QMARK] = ACTIONS(165),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(165),
    [anon_sym_as] = ACTIONS(165),
    [anon_sym_LPAREN2] = ACTIONS(165),
    [anon_sym_DOT_GT] = ACTIONS(165),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_end] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(163),
    [anon_sym_ifdef] = ACTIONS(165),
    [anon_sym_elseif] = ACTIONS(165),
    [anon_sym_iftype] = ACTIONS(165),
    [anon_sym_else] = ACTIONS(163),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_try] = ACTIONS(165),
    [anon_sym_with] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_recover] = ACTIONS(165),
    [anon_sym_match] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_consume] = ACTIONS(165),
    [anon_sym_object] = ACTIONS(165),
    [sym_number] = ACTIONS(163),
    [sym_float] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(165),
    [anon_sym_true] = ACTIONS(165),
    [anon_sym_false] = ACTIONS(165),
    [sym_this] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [41] = {
    [sym_block] = STATE(568),
    [sym_expression] = STATE(34),
    [sym_compile_error] = STATE(560),
    [sym_unary_expression] = STATE(560),
    [sym_binary_expression] = STATE(560),
    [sym_tuple_expression] = STATE(560),
    [sym_generic_expression] = STATE(560),
    [sym_assignment_expression] = STATE(560),
    [sym_variable_declaration] = STATE(560),
    [sym_cast_expression] = STATE(560),
    [sym_call_expression] = STATE(560),
    [sym_chain_expression] = STATE(560),
    [sym_lambda_expression] = STATE(560),
    [sym_partial_application] = STATE(560),
    [sym_member_expression] = STATE(560),
    [sym_parenthesized_expression] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_if_block] = STATE(2180),
    [sym_iftype_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_try_statement] = STATE(560),
    [sym_with_statement] = STATE(560),
    [sym_repeat_statement] = STATE(560),
    [sym_recover_statement] = STATE(560),
    [sym_match_statement] = STATE(560),
    [sym_return_statement] = STATE(560),
    [sym_continue_statement] = STATE(560),
    [sym_break_statement] = STATE(560),
    [sym_consume_statement] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_array_literal] = STATE(561),
    [sym_object_literal] = STATE(561),
    [sym_string] = STATE(561),
    [sym__string_literal] = STATE(533),
    [sym__multiline_string_literal] = STATE(533),
    [sym_character] = STATE(561),
    [sym_boolean] = STATE(561),
    [sym_ffi_identifier] = STATE(472),
    [sym_identifier] = ACTIONS(59),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_is] = ACTIONS(59),
    [anon_sym_let] = ACTIONS(61),
    [anon_sym_var] = ACTIONS(61),
    [anon_sym_LPAREN] = ACTIONS(59),
    [anon_sym_DOT] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_SEMI] = ACTIONS(61),
    [sym_error] = ACTIONS(61),
    [sym_compile_intrinsic] = ACTIONS(61),
    [anon_sym_compile_error] = ACTIONS(61),
    [sym_location] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(61),
    [anon_sym_DASH_TILDE] = ACTIONS(61),
    [anon_sym_addressof] = ACTIONS(61),
    [anon_sym_digestof] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(59),
    [anon_sym_PERCENT] = ACTIONS(59),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(59),
    [anon_sym_LT_LT] = ACTIONS(59),
    [anon_sym_GT_GT] = ACTIONS(59),
    [anon_sym_and] = ACTIONS(61),
    [anon_sym_or] = ACTIONS(61),
    [anon_sym_xor] = ACTIONS(61),
    [anon_sym_isnt] = ACTIONS(61),
    [anon_sym_EQ_EQ] = ACTIONS(59),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_PLUS_TILDE] = ACTIONS(61),
    [anon_sym_STAR_TILDE] = ACTIONS(61),
    [anon_sym_SLASH_TILDE] = ACTIONS(61),
    [anon_sym_PERCENT_TILDE] = ACTIONS(61),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(61),
    [anon_sym_LT_LT_TILDE] = ACTIONS(61),
    [anon_sym_GT_GT_TILDE] = ACTIONS(61),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(61),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(61),
    [anon_sym_GT_TILDE] = ACTIONS(61),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(61),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(61),
    [anon_sym_LT_TILDE] = ACTIONS(61),
    [anon_sym_PLUS_QMARK] = ACTIONS(61),
    [anon_sym_DASH_QMARK] = ACTIONS(61),
    [anon_sym_STAR_QMARK] = ACTIONS(61),
    [anon_sym_SLASH_QMARK] = ACTIONS(61),
    [anon_sym_PERCENT_QMARK] = ACTIONS(61),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(61),
    [anon_sym_as] = ACTIONS(61),
    [anon_sym_LPAREN2] = ACTIONS(61),
    [anon_sym_DOT_GT] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(61),
    [anon_sym_end] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_ifdef] = ACTIONS(61),
    [anon_sym_elseif] = ACTIONS(61),
    [anon_sym_iftype] = ACTIONS(61),
    [anon_sym_else] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_try] = ACTIONS(61),
    [anon_sym_with] = ACTIONS(61),
    [anon_sym_repeat] = ACTIONS(61),
    [anon_sym_recover] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(61),
    [anon_sym_consume] = ACTIONS(61),
    [anon_sym_object] = ACTIONS(61),
    [sym_number] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(59),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(61),
    [anon_sym_SQUOTE] = ACTIONS(61),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [sym_this] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [42] = {
    [sym_expression] = STATE(481),
    [sym_compile_error] = STATE(560),
    [sym_unary_expression] = STATE(560),
    [sym_binary_expression] = STATE(560),
    [sym_tuple_expression] = STATE(560),
    [sym_generic_expression] = STATE(560),
    [sym_assignment_expression] = STATE(560),
    [sym_variable_declaration] = STATE(560),
    [sym_cast_expression] = STATE(560),
    [sym_call_expression] = STATE(560),
    [sym_chain_expression] = STATE(560),
    [sym_lambda_expression] = STATE(560),
    [sym_partial_application] = STATE(560),
    [sym_member_expression] = STATE(560),
    [sym_parenthesized_expression] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_if_block] = STATE(2180),
    [sym_iftype_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_try_statement] = STATE(560),
    [sym_with_statement] = STATE(560),
    [sym_repeat_statement] = STATE(560),
    [sym_recover_statement] = STATE(560),
    [sym_match_statement] = STATE(560),
    [sym_return_statement] = STATE(560),
    [sym_continue_statement] = STATE(560),
    [sym_break_statement] = STATE(560),
    [sym_consume_statement] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_array_literal] = STATE(561),
    [sym_object_literal] = STATE(561),
    [sym_string] = STATE(561),
    [sym__string_literal] = STATE(533),
    [sym__multiline_string_literal] = STATE(533),
    [sym_character] = STATE(561),
    [sym_boolean] = STATE(561),
    [sym_ffi_identifier] = STATE(472),
    [aux_sym_block_repeat1] = STATE(42),
    [sym_identifier] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(66),
    [anon_sym_AT] = ACTIONS(524),
    [anon_sym_LBRACK] = ACTIONS(527),
    [anon_sym_is] = ACTIONS(66),
    [anon_sym_let] = ACTIONS(530),
    [anon_sym_var] = ACTIONS(530),
    [anon_sym_LPAREN] = ACTIONS(533),
    [anon_sym_DOT] = ACTIONS(66),
    [anon_sym_LBRACE] = ACTIONS(536),
    [anon_sym_SEMI] = ACTIONS(539),
    [sym_error] = ACTIONS(542),
    [sym_compile_intrinsic] = ACTIONS(542),
    [anon_sym_compile_error] = ACTIONS(545),
    [sym_location] = ACTIONS(542),
    [anon_sym_DASH] = ACTIONS(548),
    [anon_sym_not] = ACTIONS(551),
    [anon_sym_DASH_TILDE] = ACTIONS(551),
    [anon_sym_addressof] = ACTIONS(551),
    [anon_sym_digestof] = ACTIONS(551),
    [anon_sym_PLUS] = ACTIONS(66),
    [anon_sym_STAR] = ACTIONS(66),
    [anon_sym_SLASH] = ACTIONS(66),
    [anon_sym_PERCENT] = ACTIONS(66),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(66),
    [anon_sym_LT_LT] = ACTIONS(66),
    [anon_sym_GT_GT] = ACTIONS(66),
    [anon_sym_and] = ACTIONS(74),
    [anon_sym_or] = ACTIONS(74),
    [anon_sym_xor] = ACTIONS(74),
    [anon_sym_isnt] = ACTIONS(74),
    [anon_sym_EQ_EQ] = ACTIONS(66),
    [anon_sym_BANG_EQ] = ACTIONS(66),
    [anon_sym_GT] = ACTIONS(66),
    [anon_sym_GT_EQ] = ACTIONS(66),
    [anon_sym_LT_EQ] = ACTIONS(66),
    [anon_sym_LT] = ACTIONS(66),
    [anon_sym_PLUS_TILDE] = ACTIONS(74),
    [anon_sym_STAR_TILDE] = ACTIONS(74),
    [anon_sym_SLASH_TILDE] = ACTIONS(74),
    [anon_sym_PERCENT_TILDE] = ACTIONS(74),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(74),
    [anon_sym_LT_LT_TILDE] = ACTIONS(74),
    [anon_sym_GT_GT_TILDE] = ACTIONS(74),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(74),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(74),
    [anon_sym_GT_TILDE] = ACTIONS(74),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(74),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(74),
    [anon_sym_LT_TILDE] = ACTIONS(74),
    [anon_sym_PLUS_QMARK] = ACTIONS(74),
    [anon_sym_DASH_QMARK] = ACTIONS(74),
    [anon_sym_STAR_QMARK] = ACTIONS(74),
    [anon_sym_SLASH_QMARK] = ACTIONS(74),
    [anon_sym_PERCENT_QMARK] = ACTIONS(74),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(74),
    [anon_sym_as] = ACTIONS(74),
    [anon_sym_LPAREN2] = ACTIONS(74),
    [anon_sym_DOT_GT] = ACTIONS(74),
    [anon_sym_TILDE] = ACTIONS(74),
    [anon_sym_end] = ACTIONS(74),
    [anon_sym_if] = ACTIONS(100),
    [anon_sym_ifdef] = ACTIONS(103),
    [anon_sym_elseif] = ACTIONS(74),
    [anon_sym_iftype] = ACTIONS(554),
    [anon_sym_else] = ACTIONS(66),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_while] = ACTIONS(560),
    [anon_sym_try] = ACTIONS(563),
    [anon_sym_with] = ACTIONS(566),
    [anon_sym_repeat] = ACTIONS(569),
    [anon_sym_recover] = ACTIONS(572),
    [anon_sym_match] = ACTIONS(575),
    [anon_sym_return] = ACTIONS(578),
    [anon_sym_continue] = ACTIONS(581),
    [anon_sym_break] = ACTIONS(584),
    [anon_sym_consume] = ACTIONS(587),
    [anon_sym_object] = ACTIONS(590),
    [sym_number] = ACTIONS(593),
    [sym_float] = ACTIONS(596),
    [anon_sym_DQUOTE] = ACTIONS(599),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(602),
    [anon_sym_SQUOTE] = ACTIONS(605),
    [anon_sym_true] = ACTIONS(608),
    [anon_sym_false] = ACTIONS(608),
    [sym_this] = ACTIONS(542),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [43] = {
    [sym_expression] = STATE(477),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_arguments] = STATE(332),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_block_repeat1] = STATE(46),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_EQ] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_is] = ACTIONS(399),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(341),
    [anon_sym_DOT] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_SEMI] = ACTIONS(493),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_not] = ACTIONS(495),
    [anon_sym_DASH_TILDE] = ACTIONS(405),
    [anon_sym_addressof] = ACTIONS(495),
    [anon_sym_digestof] = ACTIONS(495),
    [anon_sym_PLUS] = ACTIONS(399),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(399),
    [anon_sym_PERCENT] = ACTIONS(399),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(399),
    [anon_sym_LT_LT] = ACTIONS(399),
    [anon_sym_GT_GT] = ACTIONS(399),
    [anon_sym_and] = ACTIONS(407),
    [anon_sym_or] = ACTIONS(407),
    [anon_sym_xor] = ACTIONS(407),
    [anon_sym_isnt] = ACTIONS(407),
    [anon_sym_EQ_EQ] = ACTIONS(399),
    [anon_sym_BANG_EQ] = ACTIONS(399),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(399),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_PLUS_TILDE] = ACTIONS(407),
    [anon_sym_STAR_TILDE] = ACTIONS(407),
    [anon_sym_SLASH_TILDE] = ACTIONS(407),
    [anon_sym_PERCENT_TILDE] = ACTIONS(407),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(407),
    [anon_sym_LT_LT_TILDE] = ACTIONS(407),
    [anon_sym_GT_GT_TILDE] = ACTIONS(407),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(407),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(407),
    [anon_sym_GT_TILDE] = ACTIONS(407),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(407),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(407),
    [anon_sym_LT_TILDE] = ACTIONS(407),
    [anon_sym_PLUS_QMARK] = ACTIONS(407),
    [anon_sym_DASH_QMARK] = ACTIONS(407),
    [anon_sym_STAR_QMARK] = ACTIONS(407),
    [anon_sym_SLASH_QMARK] = ACTIONS(407),
    [anon_sym_PERCENT_QMARK] = ACTIONS(407),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(407),
    [anon_sym_as] = ACTIONS(409),
    [anon_sym_LPAREN2] = ACTIONS(45),
    [anon_sym_DOT_GT] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_ifdef] = ACTIONS(31),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [44] = {
    [sym_block] = STATE(571),
    [sym_expression] = STATE(34),
    [sym_compile_error] = STATE(560),
    [sym_unary_expression] = STATE(560),
    [sym_binary_expression] = STATE(560),
    [sym_tuple_expression] = STATE(560),
    [sym_generic_expression] = STATE(560),
    [sym_assignment_expression] = STATE(560),
    [sym_variable_declaration] = STATE(560),
    [sym_cast_expression] = STATE(560),
    [sym_call_expression] = STATE(560),
    [sym_chain_expression] = STATE(560),
    [sym_lambda_expression] = STATE(560),
    [sym_partial_application] = STATE(560),
    [sym_member_expression] = STATE(560),
    [sym_parenthesized_expression] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_if_block] = STATE(2180),
    [sym_iftype_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_try_statement] = STATE(560),
    [sym_with_statement] = STATE(560),
    [sym_repeat_statement] = STATE(560),
    [sym_recover_statement] = STATE(560),
    [sym_match_statement] = STATE(560),
    [sym_return_statement] = STATE(560),
    [sym_continue_statement] = STATE(560),
    [sym_break_statement] = STATE(560),
    [sym_consume_statement] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_array_literal] = STATE(561),
    [sym_object_literal] = STATE(561),
    [sym_string] = STATE(561),
    [sym__string_literal] = STATE(533),
    [sym__multiline_string_literal] = STATE(533),
    [sym_character] = STATE(561),
    [sym_boolean] = STATE(561),
    [sym_ffi_identifier] = STATE(472),
    [sym_identifier] = ACTIONS(51),
    [anon_sym_EQ] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_is] = ACTIONS(51),
    [anon_sym_let] = ACTIONS(53),
    [anon_sym_var] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_DOT] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(53),
    [sym_error] = ACTIONS(53),
    [sym_compile_intrinsic] = ACTIONS(53),
    [anon_sym_compile_error] = ACTIONS(53),
    [sym_location] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_not] = ACTIONS(53),
    [anon_sym_DASH_TILDE] = ACTIONS(53),
    [anon_sym_addressof] = ACTIONS(53),
    [anon_sym_digestof] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_PERCENT] = ACTIONS(51),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(51),
    [anon_sym_LT_LT] = ACTIONS(51),
    [anon_sym_GT_GT] = ACTIONS(51),
    [anon_sym_and] = ACTIONS(53),
    [anon_sym_or] = ACTIONS(53),
    [anon_sym_xor] = ACTIONS(53),
    [anon_sym_isnt] = ACTIONS(53),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(51),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_PLUS_TILDE] = ACTIONS(53),
    [anon_sym_STAR_TILDE] = ACTIONS(53),
    [anon_sym_SLASH_TILDE] = ACTIONS(53),
    [anon_sym_PERCENT_TILDE] = ACTIONS(53),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(53),
    [anon_sym_LT_LT_TILDE] = ACTIONS(53),
    [anon_sym_GT_GT_TILDE] = ACTIONS(53),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(53),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(53),
    [anon_sym_GT_TILDE] = ACTIONS(53),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(53),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(53),
    [anon_sym_LT_TILDE] = ACTIONS(53),
    [anon_sym_PLUS_QMARK] = ACTIONS(53),
    [anon_sym_DASH_QMARK] = ACTIONS(53),
    [anon_sym_STAR_QMARK] = ACTIONS(53),
    [anon_sym_SLASH_QMARK] = ACTIONS(53),
    [anon_sym_PERCENT_QMARK] = ACTIONS(53),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(53),
    [anon_sym_as] = ACTIONS(53),
    [anon_sym_LPAREN2] = ACTIONS(53),
    [anon_sym_DOT_GT] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_end] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_ifdef] = ACTIONS(53),
    [anon_sym_elseif] = ACTIONS(53),
    [anon_sym_iftype] = ACTIONS(53),
    [anon_sym_else] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_repeat] = ACTIONS(53),
    [anon_sym_recover] = ACTIONS(53),
    [anon_sym_match] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_continue] = ACTIONS(53),
    [anon_sym_break] = ACTIONS(53),
    [anon_sym_consume] = ACTIONS(53),
    [anon_sym_object] = ACTIONS(53),
    [sym_number] = ACTIONS(51),
    [sym_float] = ACTIONS(53),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [sym_this] = ACTIONS(53),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [45] = {
    [sym_block] = STATE(569),
    [sym_expression] = STATE(34),
    [sym_compile_error] = STATE(560),
    [sym_unary_expression] = STATE(560),
    [sym_binary_expression] = STATE(560),
    [sym_tuple_expression] = STATE(560),
    [sym_generic_expression] = STATE(560),
    [sym_assignment_expression] = STATE(560),
    [sym_variable_declaration] = STATE(560),
    [sym_cast_expression] = STATE(560),
    [sym_call_expression] = STATE(560),
    [sym_chain_expression] = STATE(560),
    [sym_lambda_expression] = STATE(560),
    [sym_partial_application] = STATE(560),
    [sym_member_expression] = STATE(560),
    [sym_parenthesized_expression] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_if_block] = STATE(2180),
    [sym_iftype_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_try_statement] = STATE(560),
    [sym_with_statement] = STATE(560),
    [sym_repeat_statement] = STATE(560),
    [sym_recover_statement] = STATE(560),
    [sym_match_statement] = STATE(560),
    [sym_return_statement] = STATE(560),
    [sym_continue_statement] = STATE(560),
    [sym_break_statement] = STATE(560),
    [sym_consume_statement] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_array_literal] = STATE(561),
    [sym_object_literal] = STATE(561),
    [sym_string] = STATE(561),
    [sym__string_literal] = STATE(533),
    [sym__multiline_string_literal] = STATE(533),
    [sym_character] = STATE(561),
    [sym_boolean] = STATE(561),
    [sym_ffi_identifier] = STATE(472),
    [sym_identifier] = ACTIONS(55),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_is] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_var] = ACTIONS(57),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(57),
    [sym_error] = ACTIONS(57),
    [sym_compile_intrinsic] = ACTIONS(57),
    [anon_sym_compile_error] = ACTIONS(57),
    [sym_location] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_DASH_TILDE] = ACTIONS(57),
    [anon_sym_addressof] = ACTIONS(57),
    [anon_sym_digestof] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(55),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(55),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(55),
    [anon_sym_and] = ACTIONS(57),
    [anon_sym_or] = ACTIONS(57),
    [anon_sym_xor] = ACTIONS(57),
    [anon_sym_isnt] = ACTIONS(57),
    [anon_sym_EQ_EQ] = ACTIONS(55),
    [anon_sym_BANG_EQ] = ACTIONS(55),
    [anon_sym_GT] = ACTIONS(55),
    [anon_sym_GT_EQ] = ACTIONS(55),
    [anon_sym_LT_EQ] = ACTIONS(55),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_PLUS_TILDE] = ACTIONS(57),
    [anon_sym_STAR_TILDE] = ACTIONS(57),
    [anon_sym_SLASH_TILDE] = ACTIONS(57),
    [anon_sym_PERCENT_TILDE] = ACTIONS(57),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(57),
    [anon_sym_LT_LT_TILDE] = ACTIONS(57),
    [anon_sym_GT_GT_TILDE] = ACTIONS(57),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(57),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(57),
    [anon_sym_GT_TILDE] = ACTIONS(57),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(57),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(57),
    [anon_sym_LT_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_QMARK] = ACTIONS(57),
    [anon_sym_DASH_QMARK] = ACTIONS(57),
    [anon_sym_STAR_QMARK] = ACTIONS(57),
    [anon_sym_SLASH_QMARK] = ACTIONS(57),
    [anon_sym_PERCENT_QMARK] = ACTIONS(57),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(57),
    [anon_sym_as] = ACTIONS(57),
    [anon_sym_LPAREN2] = ACTIONS(57),
    [anon_sym_DOT_GT] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_end] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_ifdef] = ACTIONS(57),
    [anon_sym_elseif] = ACTIONS(57),
    [anon_sym_iftype] = ACTIONS(57),
    [anon_sym_else] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_try] = ACTIONS(57),
    [anon_sym_with] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(57),
    [anon_sym_recover] = ACTIONS(57),
    [anon_sym_match] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(57),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_consume] = ACTIONS(57),
    [anon_sym_object] = ACTIONS(57),
    [sym_number] = ACTIONS(55),
    [sym_float] = ACTIONS(57),
    [anon_sym_DQUOTE] = ACTIONS(55),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(57),
    [anon_sym_SQUOTE] = ACTIONS(57),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [sym_this] = ACTIONS(57),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [46] = {
    [sym_expression] = STATE(477),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_block_repeat1] = STATE(36),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_EQ] = ACTIONS(163),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_is] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_EQ_GT] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(341),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_SEMI] = ACTIONS(493),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_not] = ACTIONS(495),
    [anon_sym_DASH_TILDE] = ACTIONS(165),
    [anon_sym_addressof] = ACTIONS(495),
    [anon_sym_digestof] = ACTIONS(495),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_PERCENT] = ACTIONS(163),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(163),
    [anon_sym_LT_LT] = ACTIONS(163),
    [anon_sym_GT_GT] = ACTIONS(163),
    [anon_sym_and] = ACTIONS(165),
    [anon_sym_or] = ACTIONS(165),
    [anon_sym_xor] = ACTIONS(165),
    [anon_sym_isnt] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(163),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(163),
    [anon_sym_PLUS_TILDE] = ACTIONS(165),
    [anon_sym_STAR_TILDE] = ACTIONS(165),
    [anon_sym_SLASH_TILDE] = ACTIONS(165),
    [anon_sym_PERCENT_TILDE] = ACTIONS(165),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(165),
    [anon_sym_LT_LT_TILDE] = ACTIONS(165),
    [anon_sym_GT_GT_TILDE] = ACTIONS(165),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(165),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(165),
    [anon_sym_GT_TILDE] = ACTIONS(165),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(165),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(165),
    [anon_sym_LT_TILDE] = ACTIONS(165),
    [anon_sym_PLUS_QMARK] = ACTIONS(165),
    [anon_sym_DASH_QMARK] = ACTIONS(165),
    [anon_sym_STAR_QMARK] = ACTIONS(165),
    [anon_sym_SLASH_QMARK] = ACTIONS(165),
    [anon_sym_PERCENT_QMARK] = ACTIONS(165),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(165),
    [anon_sym_as] = ACTIONS(165),
    [anon_sym_LPAREN2] = ACTIONS(165),
    [anon_sym_DOT_GT] = ACTIONS(165),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(163),
    [anon_sym_ifdef] = ACTIONS(165),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [47] = {
    [sym_expression] = STATE(379),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_arguments] = STATE(332),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_block_repeat1] = STATE(48),
    [sym_identifier] = ACTIONS(27),
    [anon_sym_EQ] = ACTIONS(29),
    [anon_sym_AT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_is] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_DOT] = ACTIONS(35),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(345),
    [sym_error] = ACTIONS(31),
    [sym_compile_intrinsic] = ACTIONS(31),
    [anon_sym_compile_error] = ACTIONS(31),
    [sym_location] = ACTIONS(31),
    [anon_sym_DASH] = ACTIONS(37),
    [anon_sym_not] = ACTIONS(31),
    [anon_sym_DASH_TILDE] = ACTIONS(39),
    [anon_sym_addressof] = ACTIONS(31),
    [anon_sym_digestof] = ACTIONS(31),
    [anon_sym_PLUS] = ACTIONS(33),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_SLASH] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(33),
    [anon_sym_LT_LT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(33),
    [anon_sym_and] = ACTIONS(41),
    [anon_sym_or] = ACTIONS(41),
    [anon_sym_xor] = ACTIONS(41),
    [anon_sym_isnt] = ACTIONS(41),
    [anon_sym_EQ_EQ] = ACTIONS(33),
    [anon_sym_BANG_EQ] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(33),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_PLUS_TILDE] = ACTIONS(41),
    [anon_sym_STAR_TILDE] = ACTIONS(41),
    [anon_sym_SLASH_TILDE] = ACTIONS(41),
    [anon_sym_PERCENT_TILDE] = ACTIONS(41),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(41),
    [anon_sym_LT_LT_TILDE] = ACTIONS(41),
    [anon_sym_GT_GT_TILDE] = ACTIONS(41),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(41),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(41),
    [anon_sym_GT_TILDE] = ACTIONS(41),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(41),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(41),
    [anon_sym_LT_TILDE] = ACTIONS(41),
    [anon_sym_PLUS_QMARK] = ACTIONS(41),
    [anon_sym_DASH_QMARK] = ACTIONS(41),
    [anon_sym_STAR_QMARK] = ACTIONS(41),
    [anon_sym_SLASH_QMARK] = ACTIONS(41),
    [anon_sym_PERCENT_QMARK] = ACTIONS(41),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(41),
    [anon_sym_as] = ACTIONS(43),
    [anon_sym_LPAREN2] = ACTIONS(45),
    [anon_sym_DOT_GT] = ACTIONS(47),
    [anon_sym_TILDE] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_ifdef] = ACTIONS(31),
    [anon_sym_iftype] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(31),
    [anon_sym_with] = ACTIONS(31),
    [anon_sym_repeat] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_recover] = ACTIONS(31),
    [anon_sym_match] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_consume] = ACTIONS(31),
    [anon_sym_object] = ACTIONS(31),
    [sym_number] = ACTIONS(27),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(27),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(31),
    [anon_sym_true] = ACTIONS(31),
    [anon_sym_false] = ACTIONS(31),
    [sym_this] = ACTIONS(31),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [48] = {
    [sym_expression] = STATE(379),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_block_repeat1] = STATE(6),
    [sym_identifier] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(163),
    [anon_sym_AT] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(165),
    [anon_sym_is] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_SEMI] = ACTIONS(345),
    [sym_error] = ACTIONS(165),
    [sym_compile_intrinsic] = ACTIONS(165),
    [anon_sym_compile_error] = ACTIONS(165),
    [sym_location] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_not] = ACTIONS(165),
    [anon_sym_DASH_TILDE] = ACTIONS(165),
    [anon_sym_addressof] = ACTIONS(165),
    [anon_sym_digestof] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_PERCENT] = ACTIONS(163),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(163),
    [anon_sym_LT_LT] = ACTIONS(163),
    [anon_sym_GT_GT] = ACTIONS(163),
    [anon_sym_and] = ACTIONS(165),
    [anon_sym_or] = ACTIONS(165),
    [anon_sym_xor] = ACTIONS(165),
    [anon_sym_isnt] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(163),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(163),
    [anon_sym_PLUS_TILDE] = ACTIONS(165),
    [anon_sym_STAR_TILDE] = ACTIONS(165),
    [anon_sym_SLASH_TILDE] = ACTIONS(165),
    [anon_sym_PERCENT_TILDE] = ACTIONS(165),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(165),
    [anon_sym_LT_LT_TILDE] = ACTIONS(165),
    [anon_sym_GT_GT_TILDE] = ACTIONS(165),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(165),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(165),
    [anon_sym_GT_TILDE] = ACTIONS(165),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(165),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(165),
    [anon_sym_LT_TILDE] = ACTIONS(165),
    [anon_sym_PLUS_QMARK] = ACTIONS(165),
    [anon_sym_DASH_QMARK] = ACTIONS(165),
    [anon_sym_STAR_QMARK] = ACTIONS(165),
    [anon_sym_SLASH_QMARK] = ACTIONS(165),
    [anon_sym_PERCENT_QMARK] = ACTIONS(165),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(165),
    [anon_sym_as] = ACTIONS(165),
    [anon_sym_LPAREN2] = ACTIONS(165),
    [anon_sym_DOT_GT] = ACTIONS(165),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(163),
    [anon_sym_ifdef] = ACTIONS(165),
    [anon_sym_iftype] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_try] = ACTIONS(165),
    [anon_sym_with] = ACTIONS(165),
    [anon_sym_repeat] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(165),
    [anon_sym_recover] = ACTIONS(165),
    [anon_sym_match] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_consume] = ACTIONS(165),
    [anon_sym_object] = ACTIONS(165),
    [sym_number] = ACTIONS(163),
    [sym_float] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(165),
    [anon_sym_true] = ACTIONS(165),
    [anon_sym_false] = ACTIONS(165),
    [sym_this] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [49] = {
    [sym_block] = STATE(1033),
    [sym_expression] = STATE(43),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_is] = ACTIONS(59),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_EQ_GT] = ACTIONS(61),
    [anon_sym_LPAREN] = ACTIONS(341),
    [anon_sym_DOT] = ACTIONS(59),
    [anon_sym_PIPE] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(495),
    [anon_sym_DASH_TILDE] = ACTIONS(61),
    [anon_sym_addressof] = ACTIONS(495),
    [anon_sym_digestof] = ACTIONS(495),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(59),
    [anon_sym_PERCENT] = ACTIONS(59),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(59),
    [anon_sym_LT_LT] = ACTIONS(59),
    [anon_sym_GT_GT] = ACTIONS(59),
    [anon_sym_and] = ACTIONS(61),
    [anon_sym_or] = ACTIONS(61),
    [anon_sym_xor] = ACTIONS(61),
    [anon_sym_isnt] = ACTIONS(61),
    [anon_sym_EQ_EQ] = ACTIONS(59),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_PLUS_TILDE] = ACTIONS(61),
    [anon_sym_STAR_TILDE] = ACTIONS(61),
    [anon_sym_SLASH_TILDE] = ACTIONS(61),
    [anon_sym_PERCENT_TILDE] = ACTIONS(61),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(61),
    [anon_sym_LT_LT_TILDE] = ACTIONS(61),
    [anon_sym_GT_GT_TILDE] = ACTIONS(61),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(61),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(61),
    [anon_sym_GT_TILDE] = ACTIONS(61),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(61),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(61),
    [anon_sym_LT_TILDE] = ACTIONS(61),
    [anon_sym_PLUS_QMARK] = ACTIONS(61),
    [anon_sym_DASH_QMARK] = ACTIONS(61),
    [anon_sym_STAR_QMARK] = ACTIONS(61),
    [anon_sym_SLASH_QMARK] = ACTIONS(61),
    [anon_sym_PERCENT_QMARK] = ACTIONS(61),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(61),
    [anon_sym_as] = ACTIONS(61),
    [anon_sym_LPAREN2] = ACTIONS(61),
    [anon_sym_DOT_GT] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_ifdef] = ACTIONS(61),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [50] = {
    [sym_block] = STATE(1032),
    [sym_expression] = STATE(43),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_is] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_EQ_GT] = ACTIONS(57),
    [anon_sym_LPAREN] = ACTIONS(341),
    [anon_sym_DOT] = ACTIONS(55),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_not] = ACTIONS(495),
    [anon_sym_DASH_TILDE] = ACTIONS(57),
    [anon_sym_addressof] = ACTIONS(495),
    [anon_sym_digestof] = ACTIONS(495),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(55),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(55),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(55),
    [anon_sym_and] = ACTIONS(57),
    [anon_sym_or] = ACTIONS(57),
    [anon_sym_xor] = ACTIONS(57),
    [anon_sym_isnt] = ACTIONS(57),
    [anon_sym_EQ_EQ] = ACTIONS(55),
    [anon_sym_BANG_EQ] = ACTIONS(55),
    [anon_sym_GT] = ACTIONS(55),
    [anon_sym_GT_EQ] = ACTIONS(55),
    [anon_sym_LT_EQ] = ACTIONS(55),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_PLUS_TILDE] = ACTIONS(57),
    [anon_sym_STAR_TILDE] = ACTIONS(57),
    [anon_sym_SLASH_TILDE] = ACTIONS(57),
    [anon_sym_PERCENT_TILDE] = ACTIONS(57),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(57),
    [anon_sym_LT_LT_TILDE] = ACTIONS(57),
    [anon_sym_GT_GT_TILDE] = ACTIONS(57),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(57),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(57),
    [anon_sym_GT_TILDE] = ACTIONS(57),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(57),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(57),
    [anon_sym_LT_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_QMARK] = ACTIONS(57),
    [anon_sym_DASH_QMARK] = ACTIONS(57),
    [anon_sym_STAR_QMARK] = ACTIONS(57),
    [anon_sym_SLASH_QMARK] = ACTIONS(57),
    [anon_sym_PERCENT_QMARK] = ACTIONS(57),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(57),
    [anon_sym_as] = ACTIONS(57),
    [anon_sym_LPAREN2] = ACTIONS(57),
    [anon_sym_DOT_GT] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_ifdef] = ACTIONS(57),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [51] = {
    [sym_block] = STATE(1031),
    [sym_expression] = STATE(43),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_EQ] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_is] = ACTIONS(51),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_EQ_GT] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(341),
    [anon_sym_DOT] = ACTIONS(51),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_not] = ACTIONS(495),
    [anon_sym_DASH_TILDE] = ACTIONS(53),
    [anon_sym_addressof] = ACTIONS(495),
    [anon_sym_digestof] = ACTIONS(495),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_PERCENT] = ACTIONS(51),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(51),
    [anon_sym_LT_LT] = ACTIONS(51),
    [anon_sym_GT_GT] = ACTIONS(51),
    [anon_sym_and] = ACTIONS(53),
    [anon_sym_or] = ACTIONS(53),
    [anon_sym_xor] = ACTIONS(53),
    [anon_sym_isnt] = ACTIONS(53),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(51),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_PLUS_TILDE] = ACTIONS(53),
    [anon_sym_STAR_TILDE] = ACTIONS(53),
    [anon_sym_SLASH_TILDE] = ACTIONS(53),
    [anon_sym_PERCENT_TILDE] = ACTIONS(53),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(53),
    [anon_sym_LT_LT_TILDE] = ACTIONS(53),
    [anon_sym_GT_GT_TILDE] = ACTIONS(53),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(53),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(53),
    [anon_sym_GT_TILDE] = ACTIONS(53),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(53),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(53),
    [anon_sym_LT_TILDE] = ACTIONS(53),
    [anon_sym_PLUS_QMARK] = ACTIONS(53),
    [anon_sym_DASH_QMARK] = ACTIONS(53),
    [anon_sym_STAR_QMARK] = ACTIONS(53),
    [anon_sym_SLASH_QMARK] = ACTIONS(53),
    [anon_sym_PERCENT_QMARK] = ACTIONS(53),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(53),
    [anon_sym_as] = ACTIONS(53),
    [anon_sym_LPAREN2] = ACTIONS(53),
    [anon_sym_DOT_GT] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_ifdef] = ACTIONS(53),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [52] = {
    [sym_block] = STATE(386),
    [sym_expression] = STATE(47),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(59),
    [anon_sym_EQ] = ACTIONS(59),
    [anon_sym_AT] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_is] = ACTIONS(59),
    [anon_sym_let] = ACTIONS(61),
    [anon_sym_var] = ACTIONS(61),
    [anon_sym_LPAREN] = ACTIONS(59),
    [anon_sym_DOT] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [sym_error] = ACTIONS(61),
    [sym_compile_intrinsic] = ACTIONS(61),
    [anon_sym_compile_error] = ACTIONS(61),
    [sym_location] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_not] = ACTIONS(61),
    [anon_sym_DASH_TILDE] = ACTIONS(61),
    [anon_sym_addressof] = ACTIONS(61),
    [anon_sym_digestof] = ACTIONS(61),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_STAR] = ACTIONS(59),
    [anon_sym_SLASH] = ACTIONS(59),
    [anon_sym_PERCENT] = ACTIONS(59),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(59),
    [anon_sym_LT_LT] = ACTIONS(59),
    [anon_sym_GT_GT] = ACTIONS(59),
    [anon_sym_and] = ACTIONS(61),
    [anon_sym_or] = ACTIONS(61),
    [anon_sym_xor] = ACTIONS(61),
    [anon_sym_isnt] = ACTIONS(61),
    [anon_sym_EQ_EQ] = ACTIONS(59),
    [anon_sym_BANG_EQ] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_EQ] = ACTIONS(59),
    [anon_sym_LT_EQ] = ACTIONS(59),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_PLUS_TILDE] = ACTIONS(61),
    [anon_sym_STAR_TILDE] = ACTIONS(61),
    [anon_sym_SLASH_TILDE] = ACTIONS(61),
    [anon_sym_PERCENT_TILDE] = ACTIONS(61),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(61),
    [anon_sym_LT_LT_TILDE] = ACTIONS(61),
    [anon_sym_GT_GT_TILDE] = ACTIONS(61),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(61),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(61),
    [anon_sym_GT_TILDE] = ACTIONS(61),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(61),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(61),
    [anon_sym_LT_TILDE] = ACTIONS(61),
    [anon_sym_PLUS_QMARK] = ACTIONS(61),
    [anon_sym_DASH_QMARK] = ACTIONS(61),
    [anon_sym_STAR_QMARK] = ACTIONS(61),
    [anon_sym_SLASH_QMARK] = ACTIONS(61),
    [anon_sym_PERCENT_QMARK] = ACTIONS(61),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(61),
    [anon_sym_as] = ACTIONS(61),
    [anon_sym_LPAREN2] = ACTIONS(61),
    [anon_sym_DOT_GT] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_ifdef] = ACTIONS(61),
    [anon_sym_iftype] = ACTIONS(61),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_try] = ACTIONS(61),
    [anon_sym_with] = ACTIONS(61),
    [anon_sym_repeat] = ACTIONS(61),
    [anon_sym_do] = ACTIONS(61),
    [anon_sym_recover] = ACTIONS(61),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(61),
    [anon_sym_continue] = ACTIONS(61),
    [anon_sym_break] = ACTIONS(61),
    [anon_sym_consume] = ACTIONS(61),
    [anon_sym_object] = ACTIONS(61),
    [sym_number] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(59),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(61),
    [anon_sym_SQUOTE] = ACTIONS(61),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(61),
    [sym_this] = ACTIONS(61),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [53] = {
    [sym_block] = STATE(385),
    [sym_expression] = STATE(47),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(55),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_is] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_var] = ACTIONS(57),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [sym_error] = ACTIONS(57),
    [sym_compile_intrinsic] = ACTIONS(57),
    [anon_sym_compile_error] = ACTIONS(57),
    [sym_location] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_DASH_TILDE] = ACTIONS(57),
    [anon_sym_addressof] = ACTIONS(57),
    [anon_sym_digestof] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(55),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(55),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(55),
    [anon_sym_and] = ACTIONS(57),
    [anon_sym_or] = ACTIONS(57),
    [anon_sym_xor] = ACTIONS(57),
    [anon_sym_isnt] = ACTIONS(57),
    [anon_sym_EQ_EQ] = ACTIONS(55),
    [anon_sym_BANG_EQ] = ACTIONS(55),
    [anon_sym_GT] = ACTIONS(55),
    [anon_sym_GT_EQ] = ACTIONS(55),
    [anon_sym_LT_EQ] = ACTIONS(55),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_PLUS_TILDE] = ACTIONS(57),
    [anon_sym_STAR_TILDE] = ACTIONS(57),
    [anon_sym_SLASH_TILDE] = ACTIONS(57),
    [anon_sym_PERCENT_TILDE] = ACTIONS(57),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(57),
    [anon_sym_LT_LT_TILDE] = ACTIONS(57),
    [anon_sym_GT_GT_TILDE] = ACTIONS(57),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(57),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(57),
    [anon_sym_GT_TILDE] = ACTIONS(57),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(57),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(57),
    [anon_sym_LT_TILDE] = ACTIONS(57),
    [anon_sym_PLUS_QMARK] = ACTIONS(57),
    [anon_sym_DASH_QMARK] = ACTIONS(57),
    [anon_sym_STAR_QMARK] = ACTIONS(57),
    [anon_sym_SLASH_QMARK] = ACTIONS(57),
    [anon_sym_PERCENT_QMARK] = ACTIONS(57),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(57),
    [anon_sym_as] = ACTIONS(57),
    [anon_sym_LPAREN2] = ACTIONS(57),
    [anon_sym_DOT_GT] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_ifdef] = ACTIONS(57),
    [anon_sym_iftype] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_while] = ACTIONS(57),
    [anon_sym_try] = ACTIONS(57),
    [anon_sym_with] = ACTIONS(57),
    [anon_sym_repeat] = ACTIONS(57),
    [anon_sym_do] = ACTIONS(57),
    [anon_sym_recover] = ACTIONS(57),
    [anon_sym_match] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(57),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_consume] = ACTIONS(57),
    [anon_sym_object] = ACTIONS(57),
    [sym_number] = ACTIONS(55),
    [sym_float] = ACTIONS(57),
    [anon_sym_DQUOTE] = ACTIONS(55),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(57),
    [anon_sym_SQUOTE] = ACTIONS(57),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [sym_this] = ACTIONS(57),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [54] = {
    [sym_block] = STATE(384),
    [sym_expression] = STATE(47),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(51),
    [anon_sym_EQ] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_is] = ACTIONS(51),
    [anon_sym_let] = ACTIONS(53),
    [anon_sym_var] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_DOT] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [sym_error] = ACTIONS(53),
    [sym_compile_intrinsic] = ACTIONS(53),
    [anon_sym_compile_error] = ACTIONS(53),
    [sym_location] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_not] = ACTIONS(53),
    [anon_sym_DASH_TILDE] = ACTIONS(53),
    [anon_sym_addressof] = ACTIONS(53),
    [anon_sym_digestof] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_PERCENT] = ACTIONS(51),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(51),
    [anon_sym_LT_LT] = ACTIONS(51),
    [anon_sym_GT_GT] = ACTIONS(51),
    [anon_sym_and] = ACTIONS(53),
    [anon_sym_or] = ACTIONS(53),
    [anon_sym_xor] = ACTIONS(53),
    [anon_sym_isnt] = ACTIONS(53),
    [anon_sym_EQ_EQ] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(51),
    [anon_sym_GT_EQ] = ACTIONS(51),
    [anon_sym_LT_EQ] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_PLUS_TILDE] = ACTIONS(53),
    [anon_sym_STAR_TILDE] = ACTIONS(53),
    [anon_sym_SLASH_TILDE] = ACTIONS(53),
    [anon_sym_PERCENT_TILDE] = ACTIONS(53),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(53),
    [anon_sym_LT_LT_TILDE] = ACTIONS(53),
    [anon_sym_GT_GT_TILDE] = ACTIONS(53),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(53),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(53),
    [anon_sym_GT_TILDE] = ACTIONS(53),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(53),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(53),
    [anon_sym_LT_TILDE] = ACTIONS(53),
    [anon_sym_PLUS_QMARK] = ACTIONS(53),
    [anon_sym_DASH_QMARK] = ACTIONS(53),
    [anon_sym_STAR_QMARK] = ACTIONS(53),
    [anon_sym_SLASH_QMARK] = ACTIONS(53),
    [anon_sym_PERCENT_QMARK] = ACTIONS(53),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(53),
    [anon_sym_as] = ACTIONS(53),
    [anon_sym_LPAREN2] = ACTIONS(53),
    [anon_sym_DOT_GT] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_ifdef] = ACTIONS(53),
    [anon_sym_iftype] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_repeat] = ACTIONS(53),
    [anon_sym_do] = ACTIONS(53),
    [anon_sym_recover] = ACTIONS(53),
    [anon_sym_match] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_continue] = ACTIONS(53),
    [anon_sym_break] = ACTIONS(53),
    [anon_sym_consume] = ACTIONS(53),
    [anon_sym_object] = ACTIONS(53),
    [sym_number] = ACTIONS(51),
    [sym_float] = ACTIONS(53),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [sym_this] = ACTIONS(53),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [55] = {
    [sym_type_args] = STATE(62),
    [aux_sym_base_type_repeat1] = STATE(57),
    [ts_builtin_sym_end] = ACTIONS(611),
    [sym_identifier] = ACTIONS(613),
    [anon_sym_use] = ACTIONS(611),
    [anon_sym_EQ] = ACTIONS(613),
    [anon_sym_AT] = ACTIONS(611),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_type] = ACTIONS(611),
    [anon_sym_is] = ACTIONS(613),
    [anon_sym_actor] = ACTIONS(611),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_primitive] = ACTIONS(611),
    [anon_sym_interface] = ACTIONS(611),
    [anon_sym_trait] = ACTIONS(611),
    [anon_sym_struct] = ACTIONS(611),
    [anon_sym_embed] = ACTIONS(611),
    [anon_sym_let] = ACTIONS(611),
    [anon_sym_var] = ACTIONS(611),
    [anon_sym_new] = ACTIONS(611),
    [anon_sym_fun] = ACTIONS(611),
    [anon_sym_be] = ACTIONS(611),
    [anon_sym_COMMA] = ACTIONS(611),
    [anon_sym_iso] = ACTIONS(611),
    [anon_sym_trn] = ACTIONS(611),
    [anon_sym_ref] = ACTIONS(611),
    [anon_sym_val] = ACTIONS(611),
    [anon_sym_box] = ACTIONS(611),
    [anon_sym_tag] = ACTIONS(611),
    [anon_sym_LPAREN] = ACTIONS(613),
    [anon_sym_RPAREN] = ACTIONS(611),
    [anon_sym_DOT] = ACTIONS(615),
    [anon_sym_POUNDread] = ACTIONS(611),
    [anon_sym_POUNDsend] = ACTIONS(611),
    [anon_sym_POUNDshare] = ACTIONS(611),
    [anon_sym_POUNDalias] = ACTIONS(611),
    [anon_sym_POUNDany] = ACTIONS(611),
    [anon_sym_BANG] = ACTIONS(613),
    [anon_sym_CARET] = ACTIONS(611),
    [anon_sym_PIPE] = ACTIONS(611),
    [anon_sym_AMP] = ACTIONS(611),
    [anon_sym_DASH_GT] = ACTIONS(611),
    [anon_sym_LBRACE] = ACTIONS(611),
    [anon_sym_SEMI] = ACTIONS(611),
    [sym_error] = ACTIONS(611),
    [sym_compile_intrinsic] = ACTIONS(611),
    [anon_sym_compile_error] = ACTIONS(611),
    [sym_location] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(613),
    [anon_sym_not] = ACTIONS(611),
    [anon_sym_DASH_TILDE] = ACTIONS(611),
    [anon_sym_addressof] = ACTIONS(611),
    [anon_sym_digestof] = ACTIONS(611),
    [anon_sym_PLUS] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(613),
    [anon_sym_SLASH] = ACTIONS(613),
    [anon_sym_PERCENT] = ACTIONS(613),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(613),
    [anon_sym_LT_LT] = ACTIONS(613),
    [anon_sym_GT_GT] = ACTIONS(613),
    [anon_sym_and] = ACTIONS(611),
    [anon_sym_or] = ACTIONS(611),
    [anon_sym_xor] = ACTIONS(611),
    [anon_sym_isnt] = ACTIONS(611),
    [anon_sym_EQ_EQ] = ACTIONS(613),
    [anon_sym_BANG_EQ] = ACTIONS(613),
    [anon_sym_GT] = ACTIONS(613),
    [anon_sym_GT_EQ] = ACTIONS(613),
    [anon_sym_LT_EQ] = ACTIONS(613),
    [anon_sym_LT] = ACTIONS(613),
    [anon_sym_PLUS_TILDE] = ACTIONS(611),
    [anon_sym_STAR_TILDE] = ACTIONS(611),
    [anon_sym_SLASH_TILDE] = ACTIONS(611),
    [anon_sym_PERCENT_TILDE] = ACTIONS(611),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(611),
    [anon_sym_LT_LT_TILDE] = ACTIONS(611),
    [anon_sym_GT_GT_TILDE] = ACTIONS(611),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(611),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(611),
    [anon_sym_GT_TILDE] = ACTIONS(611),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(611),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(611),
    [anon_sym_LT_TILDE] = ACTIONS(611),
    [anon_sym_PLUS_QMARK] = ACTIONS(611),
    [anon_sym_DASH_QMARK] = ACTIONS(611),
    [anon_sym_STAR_QMARK] = ACTIONS(611),
    [anon_sym_SLASH_QMARK] = ACTIONS(611),
    [anon_sym_PERCENT_QMARK] = ACTIONS(611),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(611),
    [anon_sym_as] = ACTIONS(611),
    [anon_sym_LPAREN2] = ACTIONS(611),
    [anon_sym_DOT_GT] = ACTIONS(611),
    [anon_sym_where] = ACTIONS(611),
    [anon_sym_TILDE] = ACTIONS(611),
    [anon_sym_end] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(613),
    [anon_sym_ifdef] = ACTIONS(611),
    [anon_sym_iftype] = ACTIONS(611),
    [anon_sym_else] = ACTIONS(611),
    [anon_sym_for] = ACTIONS(611),
    [anon_sym_while] = ACTIONS(611),
    [anon_sym_try] = ACTIONS(611),
    [anon_sym_with] = ACTIONS(611),
    [anon_sym_repeat] = ACTIONS(611),
    [anon_sym_do] = ACTIONS(611),
    [anon_sym_recover] = ACTIONS(611),
    [anon_sym_match] = ACTIONS(611),
    [anon_sym_return] = ACTIONS(611),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_consume] = ACTIONS(611),
    [anon_sym_object] = ACTIONS(611),
    [sym_number] = ACTIONS(613),
    [sym_float] = ACTIONS(611),
    [anon_sym_DQUOTE] = ACTIONS(613),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(611),
    [anon_sym_SQUOTE] = ACTIONS(611),
    [anon_sym_true] = ACTIONS(611),
    [anon_sym_false] = ACTIONS(611),
    [sym_this] = ACTIONS(611),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(617),
    [sym_block_comment] = ACTIONS(3),
  },
  [56] = {
    [sym_type_args] = STATE(77),
    [aux_sym_base_type_repeat1] = STATE(55),
    [ts_builtin_sym_end] = ACTIONS(619),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_use] = ACTIONS(619),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_AT] = ACTIONS(619),
    [anon_sym_LBRACK] = ACTIONS(619),
    [anon_sym_type] = ACTIONS(619),
    [anon_sym_is] = ACTIONS(621),
    [anon_sym_actor] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(619),
    [anon_sym_primitive] = ACTIONS(619),
    [anon_sym_interface] = ACTIONS(619),
    [anon_sym_trait] = ACTIONS(619),
    [anon_sym_struct] = ACTIONS(619),
    [anon_sym_embed] = ACTIONS(619),
    [anon_sym_let] = ACTIONS(619),
    [anon_sym_var] = ACTIONS(619),
    [anon_sym_new] = ACTIONS(619),
    [anon_sym_fun] = ACTIONS(619),
    [anon_sym_be] = ACTIONS(619),
    [anon_sym_COMMA] = ACTIONS(619),
    [anon_sym_iso] = ACTIONS(619),
    [anon_sym_trn] = ACTIONS(619),
    [anon_sym_ref] = ACTIONS(619),
    [anon_sym_val] = ACTIONS(619),
    [anon_sym_box] = ACTIONS(619),
    [anon_sym_tag] = ACTIONS(619),
    [anon_sym_LPAREN] = ACTIONS(621),
    [anon_sym_RPAREN] = ACTIONS(619),
    [anon_sym_DOT] = ACTIONS(615),
    [anon_sym_POUNDread] = ACTIONS(619),
    [anon_sym_POUNDsend] = ACTIONS(619),
    [anon_sym_POUNDshare] = ACTIONS(619),
    [anon_sym_POUNDalias] = ACTIONS(619),
    [anon_sym_POUNDany] = ACTIONS(619),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_CARET] = ACTIONS(619),
    [anon_sym_PIPE] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(619),
    [anon_sym_DASH_GT] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_SEMI] = ACTIONS(619),
    [sym_error] = ACTIONS(619),
    [sym_compile_intrinsic] = ACTIONS(619),
    [anon_sym_compile_error] = ACTIONS(619),
    [sym_location] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(621),
    [anon_sym_not] = ACTIONS(619),
    [anon_sym_DASH_TILDE] = ACTIONS(619),
    [anon_sym_addressof] = ACTIONS(619),
    [anon_sym_digestof] = ACTIONS(619),
    [anon_sym_PLUS] = ACTIONS(621),
    [anon_sym_STAR] = ACTIONS(621),
    [anon_sym_SLASH] = ACTIONS(621),
    [anon_sym_PERCENT] = ACTIONS(621),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(621),
    [anon_sym_LT_LT] = ACTIONS(621),
    [anon_sym_GT_GT] = ACTIONS(621),
    [anon_sym_and] = ACTIONS(619),
    [anon_sym_or] = ACTIONS(619),
    [anon_sym_xor] = ACTIONS(619),
    [anon_sym_isnt] = ACTIONS(619),
    [anon_sym_EQ_EQ] = ACTIONS(621),
    [anon_sym_BANG_EQ] = ACTIONS(621),
    [anon_sym_GT] = ACTIONS(621),
    [anon_sym_GT_EQ] = ACTIONS(621),
    [anon_sym_LT_EQ] = ACTIONS(621),
    [anon_sym_LT] = ACTIONS(621),
    [anon_sym_PLUS_TILDE] = ACTIONS(619),
    [anon_sym_STAR_TILDE] = ACTIONS(619),
    [anon_sym_SLASH_TILDE] = ACTIONS(619),
    [anon_sym_PERCENT_TILDE] = ACTIONS(619),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(619),
    [anon_sym_LT_LT_TILDE] = ACTIONS(619),
    [anon_sym_GT_GT_TILDE] = ACTIONS(619),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(619),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(619),
    [anon_sym_GT_TILDE] = ACTIONS(619),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(619),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(619),
    [anon_sym_LT_TILDE] = ACTIONS(619),
    [anon_sym_PLUS_QMARK] = ACTIONS(619),
    [anon_sym_DASH_QMARK] = ACTIONS(619),
    [anon_sym_STAR_QMARK] = ACTIONS(619),
    [anon_sym_SLASH_QMARK] = ACTIONS(619),
    [anon_sym_PERCENT_QMARK] = ACTIONS(619),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(619),
    [anon_sym_as] = ACTIONS(619),
    [anon_sym_LPAREN2] = ACTIONS(619),
    [anon_sym_DOT_GT] = ACTIONS(619),
    [anon_sym_where] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(619),
    [anon_sym_end] = ACTIONS(619),
    [anon_sym_if] = ACTIONS(621),
    [anon_sym_ifdef] = ACTIONS(619),
    [anon_sym_iftype] = ACTIONS(619),
    [anon_sym_else] = ACTIONS(619),
    [anon_sym_for] = ACTIONS(619),
    [anon_sym_while] = ACTIONS(619),
    [anon_sym_try] = ACTIONS(619),
    [anon_sym_with] = ACTIONS(619),
    [anon_sym_repeat] = ACTIONS(619),
    [anon_sym_do] = ACTIONS(619),
    [anon_sym_recover] = ACTIONS(619),
    [anon_sym_match] = ACTIONS(619),
    [anon_sym_return] = ACTIONS(619),
    [anon_sym_continue] = ACTIONS(619),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_consume] = ACTIONS(619),
    [anon_sym_object] = ACTIONS(619),
    [sym_number] = ACTIONS(621),
    [sym_float] = ACTIONS(619),
    [anon_sym_DQUOTE] = ACTIONS(621),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(619),
    [anon_sym_SQUOTE] = ACTIONS(619),
    [anon_sym_true] = ACTIONS(619),
    [anon_sym_false] = ACTIONS(619),
    [sym_this] = ACTIONS(619),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(617),
    [sym_block_comment] = ACTIONS(3),
  },
  [57] = {
    [aux_sym_base_type_repeat1] = STATE(57),
    [ts_builtin_sym_end] = ACTIONS(623),
    [sym_identifier] = ACTIONS(625),
    [anon_sym_use] = ACTIONS(623),
    [anon_sym_EQ] = ACTIONS(625),
    [anon_sym_AT] = ACTIONS(623),
    [anon_sym_LBRACK] = ACTIONS(623),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_is] = ACTIONS(625),
    [anon_sym_actor] = ACTIONS(623),
    [anon_sym_class] = ACTIONS(623),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_interface] = ACTIONS(623),
    [anon_sym_trait] = ACTIONS(623),
    [anon_sym_struct] = ACTIONS(623),
    [anon_sym_embed] = ACTIONS(623),
    [anon_sym_let] = ACTIONS(623),
    [anon_sym_var] = ACTIONS(623),
    [anon_sym_new] = ACTIONS(623),
    [anon_sym_fun] = ACTIONS(623),
    [anon_sym_be] = ACTIONS(623),
    [anon_sym_COMMA] = ACTIONS(623),
    [anon_sym_iso] = ACTIONS(623),
    [anon_sym_trn] = ACTIONS(623),
    [anon_sym_ref] = ACTIONS(623),
    [anon_sym_val] = ACTIONS(623),
    [anon_sym_box] = ACTIONS(623),
    [anon_sym_tag] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(623),
    [anon_sym_DOT] = ACTIONS(627),
    [anon_sym_POUNDread] = ACTIONS(623),
    [anon_sym_POUNDsend] = ACTIONS(623),
    [anon_sym_POUNDshare] = ACTIONS(623),
    [anon_sym_POUNDalias] = ACTIONS(623),
    [anon_sym_POUNDany] = ACTIONS(623),
    [anon_sym_BANG] = ACTIONS(625),
    [anon_sym_CARET] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(623),
    [anon_sym_AMP] = ACTIONS(623),
    [anon_sym_DASH_GT] = ACTIONS(623),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(623),
    [sym_error] = ACTIONS(623),
    [sym_compile_intrinsic] = ACTIONS(623),
    [anon_sym_compile_error] = ACTIONS(623),
    [sym_location] = ACTIONS(623),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_not] = ACTIONS(623),
    [anon_sym_DASH_TILDE] = ACTIONS(623),
    [anon_sym_addressof] = ACTIONS(623),
    [anon_sym_digestof] = ACTIONS(623),
    [anon_sym_PLUS] = ACTIONS(625),
    [anon_sym_STAR] = ACTIONS(625),
    [anon_sym_SLASH] = ACTIONS(625),
    [anon_sym_PERCENT] = ACTIONS(625),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(625),
    [anon_sym_LT_LT] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(625),
    [anon_sym_and] = ACTIONS(623),
    [anon_sym_or] = ACTIONS(623),
    [anon_sym_xor] = ACTIONS(623),
    [anon_sym_isnt] = ACTIONS(623),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(625),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_LT] = ACTIONS(625),
    [anon_sym_PLUS_TILDE] = ACTIONS(623),
    [anon_sym_STAR_TILDE] = ACTIONS(623),
    [anon_sym_SLASH_TILDE] = ACTIONS(623),
    [anon_sym_PERCENT_TILDE] = ACTIONS(623),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(623),
    [anon_sym_LT_LT_TILDE] = ACTIONS(623),
    [anon_sym_GT_GT_TILDE] = ACTIONS(623),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(623),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(623),
    [anon_sym_GT_TILDE] = ACTIONS(623),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(623),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(623),
    [anon_sym_LT_TILDE] = ACTIONS(623),
    [anon_sym_PLUS_QMARK] = ACTIONS(623),
    [anon_sym_DASH_QMARK] = ACTIONS(623),
    [anon_sym_STAR_QMARK] = ACTIONS(623),
    [anon_sym_SLASH_QMARK] = ACTIONS(623),
    [anon_sym_PERCENT_QMARK] = ACTIONS(623),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(623),
    [anon_sym_as] = ACTIONS(623),
    [anon_sym_LPAREN2] = ACTIONS(623),
    [anon_sym_DOT_GT] = ACTIONS(623),
    [anon_sym_where] = ACTIONS(623),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_end] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_ifdef] = ACTIONS(623),
    [anon_sym_iftype] = ACTIONS(623),
    [anon_sym_else] = ACTIONS(623),
    [anon_sym_for] = ACTIONS(623),
    [anon_sym_while] = ACTIONS(623),
    [anon_sym_try] = ACTIONS(623),
    [anon_sym_with] = ACTIONS(623),
    [anon_sym_repeat] = ACTIONS(623),
    [anon_sym_do] = ACTIONS(623),
    [anon_sym_recover] = ACTIONS(623),
    [anon_sym_match] = ACTIONS(623),
    [anon_sym_return] = ACTIONS(623),
    [anon_sym_continue] = ACTIONS(623),
    [anon_sym_break] = ACTIONS(623),
    [anon_sym_consume] = ACTIONS(623),
    [anon_sym_object] = ACTIONS(623),
    [sym_number] = ACTIONS(625),
    [sym_float] = ACTIONS(623),
    [anon_sym_DQUOTE] = ACTIONS(625),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(623),
    [anon_sym_SQUOTE] = ACTIONS(623),
    [anon_sym_true] = ACTIONS(623),
    [anon_sym_false] = ACTIONS(623),
    [sym_this] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(623),
    [sym_block_comment] = ACTIONS(3),
  },
  [58] = {
    [ts_builtin_sym_end] = ACTIONS(623),
    [sym_identifier] = ACTIONS(625),
    [anon_sym_use] = ACTIONS(623),
    [anon_sym_EQ] = ACTIONS(625),
    [anon_sym_AT] = ACTIONS(623),
    [anon_sym_LBRACK] = ACTIONS(623),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_is] = ACTIONS(625),
    [anon_sym_actor] = ACTIONS(623),
    [anon_sym_class] = ACTIONS(623),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_interface] = ACTIONS(623),
    [anon_sym_trait] = ACTIONS(623),
    [anon_sym_struct] = ACTIONS(623),
    [anon_sym_embed] = ACTIONS(623),
    [anon_sym_let] = ACTIONS(623),
    [anon_sym_var] = ACTIONS(623),
    [anon_sym_new] = ACTIONS(623),
    [anon_sym_fun] = ACTIONS(623),
    [anon_sym_be] = ACTIONS(623),
    [anon_sym_COMMA] = ACTIONS(623),
    [anon_sym_iso] = ACTIONS(623),
    [anon_sym_trn] = ACTIONS(623),
    [anon_sym_ref] = ACTIONS(623),
    [anon_sym_val] = ACTIONS(623),
    [anon_sym_box] = ACTIONS(623),
    [anon_sym_tag] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(623),
    [anon_sym_DOT] = ACTIONS(625),
    [anon_sym_POUNDread] = ACTIONS(623),
    [anon_sym_POUNDsend] = ACTIONS(623),
    [anon_sym_POUNDshare] = ACTIONS(623),
    [anon_sym_POUNDalias] = ACTIONS(623),
    [anon_sym_POUNDany] = ACTIONS(623),
    [anon_sym_BANG] = ACTIONS(625),
    [anon_sym_CARET] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(623),
    [anon_sym_AMP] = ACTIONS(623),
    [anon_sym_DASH_GT] = ACTIONS(623),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(623),
    [sym_error] = ACTIONS(623),
    [sym_compile_intrinsic] = ACTIONS(623),
    [anon_sym_compile_error] = ACTIONS(623),
    [sym_location] = ACTIONS(623),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_not] = ACTIONS(623),
    [anon_sym_DASH_TILDE] = ACTIONS(623),
    [anon_sym_addressof] = ACTIONS(623),
    [anon_sym_digestof] = ACTIONS(623),
    [anon_sym_PLUS] = ACTIONS(625),
    [anon_sym_STAR] = ACTIONS(625),
    [anon_sym_SLASH] = ACTIONS(625),
    [anon_sym_PERCENT] = ACTIONS(625),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(625),
    [anon_sym_LT_LT] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(625),
    [anon_sym_and] = ACTIONS(623),
    [anon_sym_or] = ACTIONS(623),
    [anon_sym_xor] = ACTIONS(623),
    [anon_sym_isnt] = ACTIONS(623),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(625),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_LT] = ACTIONS(625),
    [anon_sym_PLUS_TILDE] = ACTIONS(623),
    [anon_sym_STAR_TILDE] = ACTIONS(623),
    [anon_sym_SLASH_TILDE] = ACTIONS(623),
    [anon_sym_PERCENT_TILDE] = ACTIONS(623),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(623),
    [anon_sym_LT_LT_TILDE] = ACTIONS(623),
    [anon_sym_GT_GT_TILDE] = ACTIONS(623),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(623),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(623),
    [anon_sym_GT_TILDE] = ACTIONS(623),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(623),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(623),
    [anon_sym_LT_TILDE] = ACTIONS(623),
    [anon_sym_PLUS_QMARK] = ACTIONS(623),
    [anon_sym_DASH_QMARK] = ACTIONS(623),
    [anon_sym_STAR_QMARK] = ACTIONS(623),
    [anon_sym_SLASH_QMARK] = ACTIONS(623),
    [anon_sym_PERCENT_QMARK] = ACTIONS(623),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(623),
    [anon_sym_as] = ACTIONS(623),
    [anon_sym_LPAREN2] = ACTIONS(623),
    [anon_sym_DOT_GT] = ACTIONS(623),
    [anon_sym_where] = ACTIONS(623),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_end] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_ifdef] = ACTIONS(623),
    [anon_sym_iftype] = ACTIONS(623),
    [anon_sym_else] = ACTIONS(623),
    [anon_sym_for] = ACTIONS(623),
    [anon_sym_while] = ACTIONS(623),
    [anon_sym_try] = ACTIONS(623),
    [anon_sym_with] = ACTIONS(623),
    [anon_sym_repeat] = ACTIONS(623),
    [anon_sym_do] = ACTIONS(623),
    [anon_sym_recover] = ACTIONS(623),
    [anon_sym_match] = ACTIONS(623),
    [anon_sym_return] = ACTIONS(623),
    [anon_sym_continue] = ACTIONS(623),
    [anon_sym_break] = ACTIONS(623),
    [anon_sym_consume] = ACTIONS(623),
    [anon_sym_object] = ACTIONS(623),
    [sym_number] = ACTIONS(625),
    [sym_float] = ACTIONS(623),
    [anon_sym_DQUOTE] = ACTIONS(625),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(623),
    [anon_sym_SQUOTE] = ACTIONS(623),
    [anon_sym_true] = ACTIONS(623),
    [anon_sym_false] = ACTIONS(623),
    [sym_this] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(623),
    [sym_block_comment] = ACTIONS(3),
  },
  [59] = {
    [ts_builtin_sym_end] = ACTIONS(630),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_use] = ACTIONS(630),
    [anon_sym_EQ] = ACTIONS(632),
    [anon_sym_AT] = ACTIONS(630),
    [anon_sym_LBRACK] = ACTIONS(630),
    [anon_sym_type] = ACTIONS(630),
    [anon_sym_is] = ACTIONS(632),
    [anon_sym_actor] = ACTIONS(630),
    [anon_sym_class] = ACTIONS(630),
    [anon_sym_primitive] = ACTIONS(630),
    [anon_sym_interface] = ACTIONS(630),
    [anon_sym_trait] = ACTIONS(630),
    [anon_sym_struct] = ACTIONS(630),
    [anon_sym_embed] = ACTIONS(630),
    [anon_sym_let] = ACTIONS(630),
    [anon_sym_var] = ACTIONS(630),
    [anon_sym_new] = ACTIONS(630),
    [anon_sym_fun] = ACTIONS(630),
    [anon_sym_be] = ACTIONS(630),
    [anon_sym_COMMA] = ACTIONS(630),
    [anon_sym_iso] = ACTIONS(630),
    [anon_sym_trn] = ACTIONS(630),
    [anon_sym_ref] = ACTIONS(630),
    [anon_sym_val] = ACTIONS(630),
    [anon_sym_box] = ACTIONS(630),
    [anon_sym_tag] = ACTIONS(630),
    [anon_sym_LPAREN] = ACTIONS(632),
    [anon_sym_RPAREN] = ACTIONS(630),
    [anon_sym_DOT] = ACTIONS(632),
    [anon_sym_POUNDread] = ACTIONS(630),
    [anon_sym_POUNDsend] = ACTIONS(630),
    [anon_sym_POUNDshare] = ACTIONS(630),
    [anon_sym_POUNDalias] = ACTIONS(630),
    [anon_sym_POUNDany] = ACTIONS(630),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_CARET] = ACTIONS(630),
    [anon_sym_PIPE] = ACTIONS(630),
    [anon_sym_AMP] = ACTIONS(630),
    [anon_sym_DASH_GT] = ACTIONS(630),
    [anon_sym_LBRACE] = ACTIONS(630),
    [anon_sym_SEMI] = ACTIONS(630),
    [sym_error] = ACTIONS(630),
    [sym_compile_intrinsic] = ACTIONS(630),
    [anon_sym_compile_error] = ACTIONS(630),
    [sym_location] = ACTIONS(630),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_not] = ACTIONS(630),
    [anon_sym_DASH_TILDE] = ACTIONS(630),
    [anon_sym_addressof] = ACTIONS(630),
    [anon_sym_digestof] = ACTIONS(630),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_STAR] = ACTIONS(632),
    [anon_sym_SLASH] = ACTIONS(632),
    [anon_sym_PERCENT] = ACTIONS(632),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(632),
    [anon_sym_LT_LT] = ACTIONS(632),
    [anon_sym_GT_GT] = ACTIONS(632),
    [anon_sym_and] = ACTIONS(630),
    [anon_sym_or] = ACTIONS(630),
    [anon_sym_xor] = ACTIONS(630),
    [anon_sym_isnt] = ACTIONS(630),
    [anon_sym_EQ_EQ] = ACTIONS(632),
    [anon_sym_BANG_EQ] = ACTIONS(632),
    [anon_sym_GT] = ACTIONS(632),
    [anon_sym_GT_EQ] = ACTIONS(632),
    [anon_sym_LT_EQ] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(632),
    [anon_sym_PLUS_TILDE] = ACTIONS(630),
    [anon_sym_STAR_TILDE] = ACTIONS(630),
    [anon_sym_SLASH_TILDE] = ACTIONS(630),
    [anon_sym_PERCENT_TILDE] = ACTIONS(630),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(630),
    [anon_sym_LT_LT_TILDE] = ACTIONS(630),
    [anon_sym_GT_GT_TILDE] = ACTIONS(630),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(630),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(630),
    [anon_sym_GT_TILDE] = ACTIONS(630),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(630),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(630),
    [anon_sym_LT_TILDE] = ACTIONS(630),
    [anon_sym_PLUS_QMARK] = ACTIONS(630),
    [anon_sym_DASH_QMARK] = ACTIONS(630),
    [anon_sym_STAR_QMARK] = ACTIONS(630),
    [anon_sym_SLASH_QMARK] = ACTIONS(630),
    [anon_sym_PERCENT_QMARK] = ACTIONS(630),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(630),
    [anon_sym_as] = ACTIONS(630),
    [anon_sym_LPAREN2] = ACTIONS(630),
    [anon_sym_DOT_GT] = ACTIONS(630),
    [anon_sym_where] = ACTIONS(630),
    [anon_sym_TILDE] = ACTIONS(630),
    [anon_sym_end] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(632),
    [anon_sym_ifdef] = ACTIONS(630),
    [anon_sym_iftype] = ACTIONS(630),
    [anon_sym_else] = ACTIONS(630),
    [anon_sym_for] = ACTIONS(630),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(630),
    [anon_sym_with] = ACTIONS(630),
    [anon_sym_repeat] = ACTIONS(630),
    [anon_sym_do] = ACTIONS(630),
    [anon_sym_recover] = ACTIONS(630),
    [anon_sym_match] = ACTIONS(630),
    [anon_sym_return] = ACTIONS(630),
    [anon_sym_continue] = ACTIONS(630),
    [anon_sym_break] = ACTIONS(630),
    [anon_sym_consume] = ACTIONS(630),
    [anon_sym_object] = ACTIONS(630),
    [sym_number] = ACTIONS(632),
    [sym_float] = ACTIONS(630),
    [anon_sym_DQUOTE] = ACTIONS(632),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(630),
    [anon_sym_SQUOTE] = ACTIONS(630),
    [anon_sym_true] = ACTIONS(630),
    [anon_sym_false] = ACTIONS(630),
    [sym_this] = ACTIONS(630),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [60] = {
    [ts_builtin_sym_end] = ACTIONS(634),
    [sym_identifier] = ACTIONS(636),
    [anon_sym_use] = ACTIONS(634),
    [anon_sym_EQ] = ACTIONS(636),
    [anon_sym_AT] = ACTIONS(634),
    [anon_sym_LBRACK] = ACTIONS(634),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_is] = ACTIONS(636),
    [anon_sym_actor] = ACTIONS(634),
    [anon_sym_class] = ACTIONS(634),
    [anon_sym_primitive] = ACTIONS(634),
    [anon_sym_interface] = ACTIONS(634),
    [anon_sym_trait] = ACTIONS(634),
    [anon_sym_struct] = ACTIONS(634),
    [anon_sym_embed] = ACTIONS(634),
    [anon_sym_let] = ACTIONS(634),
    [anon_sym_var] = ACTIONS(634),
    [anon_sym_new] = ACTIONS(634),
    [anon_sym_fun] = ACTIONS(634),
    [anon_sym_be] = ACTIONS(634),
    [anon_sym_COMMA] = ACTIONS(634),
    [anon_sym_iso] = ACTIONS(634),
    [anon_sym_trn] = ACTIONS(634),
    [anon_sym_ref] = ACTIONS(634),
    [anon_sym_val] = ACTIONS(634),
    [anon_sym_box] = ACTIONS(634),
    [anon_sym_tag] = ACTIONS(634),
    [anon_sym_LPAREN] = ACTIONS(636),
    [anon_sym_RPAREN] = ACTIONS(634),
    [anon_sym_DOT] = ACTIONS(636),
    [anon_sym_POUNDread] = ACTIONS(634),
    [anon_sym_POUNDsend] = ACTIONS(634),
    [anon_sym_POUNDshare] = ACTIONS(634),
    [anon_sym_POUNDalias] = ACTIONS(634),
    [anon_sym_POUNDany] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_CARET] = ACTIONS(634),
    [anon_sym_PIPE] = ACTIONS(634),
    [anon_sym_AMP] = ACTIONS(634),
    [anon_sym_DASH_GT] = ACTIONS(634),
    [anon_sym_LBRACE] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(634),
    [sym_error] = ACTIONS(634),
    [sym_compile_intrinsic] = ACTIONS(634),
    [anon_sym_compile_error] = ACTIONS(634),
    [sym_location] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(636),
    [anon_sym_not] = ACTIONS(634),
    [anon_sym_DASH_TILDE] = ACTIONS(634),
    [anon_sym_addressof] = ACTIONS(634),
    [anon_sym_digestof] = ACTIONS(634),
    [anon_sym_PLUS] = ACTIONS(636),
    [anon_sym_STAR] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(636),
    [anon_sym_PERCENT] = ACTIONS(636),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(636),
    [anon_sym_LT_LT] = ACTIONS(636),
    [anon_sym_GT_GT] = ACTIONS(636),
    [anon_sym_and] = ACTIONS(634),
    [anon_sym_or] = ACTIONS(634),
    [anon_sym_xor] = ACTIONS(634),
    [anon_sym_isnt] = ACTIONS(634),
    [anon_sym_EQ_EQ] = ACTIONS(636),
    [anon_sym_BANG_EQ] = ACTIONS(636),
    [anon_sym_GT] = ACTIONS(636),
    [anon_sym_GT_EQ] = ACTIONS(636),
    [anon_sym_LT_EQ] = ACTIONS(636),
    [anon_sym_LT] = ACTIONS(636),
    [anon_sym_PLUS_TILDE] = ACTIONS(634),
    [anon_sym_STAR_TILDE] = ACTIONS(634),
    [anon_sym_SLASH_TILDE] = ACTIONS(634),
    [anon_sym_PERCENT_TILDE] = ACTIONS(634),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(634),
    [anon_sym_LT_LT_TILDE] = ACTIONS(634),
    [anon_sym_GT_GT_TILDE] = ACTIONS(634),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(634),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(634),
    [anon_sym_GT_TILDE] = ACTIONS(634),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(634),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(634),
    [anon_sym_LT_TILDE] = ACTIONS(634),
    [anon_sym_PLUS_QMARK] = ACTIONS(634),
    [anon_sym_DASH_QMARK] = ACTIONS(634),
    [anon_sym_STAR_QMARK] = ACTIONS(634),
    [anon_sym_SLASH_QMARK] = ACTIONS(634),
    [anon_sym_PERCENT_QMARK] = ACTIONS(634),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(634),
    [anon_sym_as] = ACTIONS(634),
    [anon_sym_LPAREN2] = ACTIONS(634),
    [anon_sym_DOT_GT] = ACTIONS(634),
    [anon_sym_where] = ACTIONS(634),
    [anon_sym_TILDE] = ACTIONS(634),
    [anon_sym_end] = ACTIONS(634),
    [anon_sym_if] = ACTIONS(636),
    [anon_sym_ifdef] = ACTIONS(634),
    [anon_sym_iftype] = ACTIONS(634),
    [anon_sym_else] = ACTIONS(634),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(634),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_with] = ACTIONS(634),
    [anon_sym_repeat] = ACTIONS(634),
    [anon_sym_do] = ACTIONS(634),
    [anon_sym_recover] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(634),
    [anon_sym_return] = ACTIONS(634),
    [anon_sym_continue] = ACTIONS(634),
    [anon_sym_break] = ACTIONS(634),
    [anon_sym_consume] = ACTIONS(634),
    [anon_sym_object] = ACTIONS(634),
    [sym_number] = ACTIONS(636),
    [sym_float] = ACTIONS(634),
    [anon_sym_DQUOTE] = ACTIONS(636),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(634),
    [anon_sym_SQUOTE] = ACTIONS(634),
    [anon_sym_true] = ACTIONS(634),
    [anon_sym_false] = ACTIONS(634),
    [sym_this] = ACTIONS(634),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [61] = {
    [ts_builtin_sym_end] = ACTIONS(638),
    [sym_identifier] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(638),
    [anon_sym_EQ] = ACTIONS(640),
    [anon_sym_AT] = ACTIONS(638),
    [anon_sym_LBRACK] = ACTIONS(638),
    [anon_sym_type] = ACTIONS(638),
    [anon_sym_is] = ACTIONS(640),
    [anon_sym_actor] = ACTIONS(638),
    [anon_sym_class] = ACTIONS(638),
    [anon_sym_primitive] = ACTIONS(638),
    [anon_sym_interface] = ACTIONS(638),
    [anon_sym_trait] = ACTIONS(638),
    [anon_sym_struct] = ACTIONS(638),
    [anon_sym_embed] = ACTIONS(638),
    [anon_sym_let] = ACTIONS(638),
    [anon_sym_var] = ACTIONS(638),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_fun] = ACTIONS(638),
    [anon_sym_be] = ACTIONS(638),
    [anon_sym_COMMA] = ACTIONS(638),
    [anon_sym_iso] = ACTIONS(638),
    [anon_sym_trn] = ACTIONS(638),
    [anon_sym_ref] = ACTIONS(638),
    [anon_sym_val] = ACTIONS(638),
    [anon_sym_box] = ACTIONS(638),
    [anon_sym_tag] = ACTIONS(638),
    [anon_sym_LPAREN] = ACTIONS(640),
    [anon_sym_RPAREN] = ACTIONS(638),
    [anon_sym_DOT] = ACTIONS(640),
    [anon_sym_POUNDread] = ACTIONS(638),
    [anon_sym_POUNDsend] = ACTIONS(638),
    [anon_sym_POUNDshare] = ACTIONS(638),
    [anon_sym_POUNDalias] = ACTIONS(638),
    [anon_sym_POUNDany] = ACTIONS(638),
    [anon_sym_BANG] = ACTIONS(640),
    [anon_sym_CARET] = ACTIONS(638),
    [anon_sym_PIPE] = ACTIONS(638),
    [anon_sym_AMP] = ACTIONS(638),
    [anon_sym_DASH_GT] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(638),
    [anon_sym_SEMI] = ACTIONS(638),
    [sym_error] = ACTIONS(638),
    [sym_compile_intrinsic] = ACTIONS(638),
    [anon_sym_compile_error] = ACTIONS(638),
    [sym_location] = ACTIONS(638),
    [anon_sym_DASH] = ACTIONS(640),
    [anon_sym_not] = ACTIONS(638),
    [anon_sym_DASH_TILDE] = ACTIONS(638),
    [anon_sym_addressof] = ACTIONS(638),
    [anon_sym_digestof] = ACTIONS(638),
    [anon_sym_PLUS] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(640),
    [anon_sym_SLASH] = ACTIONS(640),
    [anon_sym_PERCENT] = ACTIONS(640),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(640),
    [anon_sym_LT_LT] = ACTIONS(640),
    [anon_sym_GT_GT] = ACTIONS(640),
    [anon_sym_and] = ACTIONS(638),
    [anon_sym_or] = ACTIONS(638),
    [anon_sym_xor] = ACTIONS(638),
    [anon_sym_isnt] = ACTIONS(638),
    [anon_sym_EQ_EQ] = ACTIONS(640),
    [anon_sym_BANG_EQ] = ACTIONS(640),
    [anon_sym_GT] = ACTIONS(640),
    [anon_sym_GT_EQ] = ACTIONS(640),
    [anon_sym_LT_EQ] = ACTIONS(640),
    [anon_sym_LT] = ACTIONS(640),
    [anon_sym_PLUS_TILDE] = ACTIONS(638),
    [anon_sym_STAR_TILDE] = ACTIONS(638),
    [anon_sym_SLASH_TILDE] = ACTIONS(638),
    [anon_sym_PERCENT_TILDE] = ACTIONS(638),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(638),
    [anon_sym_LT_LT_TILDE] = ACTIONS(638),
    [anon_sym_GT_GT_TILDE] = ACTIONS(638),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(638),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(638),
    [anon_sym_GT_TILDE] = ACTIONS(638),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(638),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(638),
    [anon_sym_LT_TILDE] = ACTIONS(638),
    [anon_sym_PLUS_QMARK] = ACTIONS(638),
    [anon_sym_DASH_QMARK] = ACTIONS(638),
    [anon_sym_STAR_QMARK] = ACTIONS(638),
    [anon_sym_SLASH_QMARK] = ACTIONS(638),
    [anon_sym_PERCENT_QMARK] = ACTIONS(638),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(638),
    [anon_sym_as] = ACTIONS(638),
    [anon_sym_LPAREN2] = ACTIONS(638),
    [anon_sym_DOT_GT] = ACTIONS(638),
    [anon_sym_where] = ACTIONS(638),
    [anon_sym_TILDE] = ACTIONS(638),
    [anon_sym_end] = ACTIONS(638),
    [anon_sym_if] = ACTIONS(640),
    [anon_sym_ifdef] = ACTIONS(638),
    [anon_sym_iftype] = ACTIONS(638),
    [anon_sym_else] = ACTIONS(638),
    [anon_sym_for] = ACTIONS(638),
    [anon_sym_while] = ACTIONS(638),
    [anon_sym_try] = ACTIONS(638),
    [anon_sym_with] = ACTIONS(638),
    [anon_sym_repeat] = ACTIONS(638),
    [anon_sym_do] = ACTIONS(638),
    [anon_sym_recover] = ACTIONS(638),
    [anon_sym_match] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(638),
    [anon_sym_continue] = ACTIONS(638),
    [anon_sym_break] = ACTIONS(638),
    [anon_sym_consume] = ACTIONS(638),
    [anon_sym_object] = ACTIONS(638),
    [sym_number] = ACTIONS(640),
    [sym_float] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(640),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(638),
    [anon_sym_SQUOTE] = ACTIONS(638),
    [anon_sym_true] = ACTIONS(638),
    [anon_sym_false] = ACTIONS(638),
    [sym_this] = ACTIONS(638),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [62] = {
    [ts_builtin_sym_end] = ACTIONS(642),
    [sym_identifier] = ACTIONS(644),
    [anon_sym_use] = ACTIONS(642),
    [anon_sym_EQ] = ACTIONS(644),
    [anon_sym_AT] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(642),
    [anon_sym_is] = ACTIONS(644),
    [anon_sym_actor] = ACTIONS(642),
    [anon_sym_class] = ACTIONS(642),
    [anon_sym_primitive] = ACTIONS(642),
    [anon_sym_interface] = ACTIONS(642),
    [anon_sym_trait] = ACTIONS(642),
    [anon_sym_struct] = ACTIONS(642),
    [anon_sym_embed] = ACTIONS(642),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_var] = ACTIONS(642),
    [anon_sym_new] = ACTIONS(642),
    [anon_sym_fun] = ACTIONS(642),
    [anon_sym_be] = ACTIONS(642),
    [anon_sym_COMMA] = ACTIONS(642),
    [anon_sym_iso] = ACTIONS(642),
    [anon_sym_trn] = ACTIONS(642),
    [anon_sym_ref] = ACTIONS(642),
    [anon_sym_val] = ACTIONS(642),
    [anon_sym_box] = ACTIONS(642),
    [anon_sym_tag] = ACTIONS(642),
    [anon_sym_LPAREN] = ACTIONS(644),
    [anon_sym_RPAREN] = ACTIONS(642),
    [anon_sym_DOT] = ACTIONS(644),
    [anon_sym_POUNDread] = ACTIONS(642),
    [anon_sym_POUNDsend] = ACTIONS(642),
    [anon_sym_POUNDshare] = ACTIONS(642),
    [anon_sym_POUNDalias] = ACTIONS(642),
    [anon_sym_POUNDany] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(644),
    [anon_sym_CARET] = ACTIONS(642),
    [anon_sym_PIPE] = ACTIONS(642),
    [anon_sym_AMP] = ACTIONS(642),
    [anon_sym_DASH_GT] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(642),
    [anon_sym_SEMI] = ACTIONS(642),
    [sym_error] = ACTIONS(642),
    [sym_compile_intrinsic] = ACTIONS(642),
    [anon_sym_compile_error] = ACTIONS(642),
    [sym_location] = ACTIONS(642),
    [anon_sym_DASH] = ACTIONS(644),
    [anon_sym_not] = ACTIONS(642),
    [anon_sym_DASH_TILDE] = ACTIONS(642),
    [anon_sym_addressof] = ACTIONS(642),
    [anon_sym_digestof] = ACTIONS(642),
    [anon_sym_PLUS] = ACTIONS(644),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_SLASH] = ACTIONS(644),
    [anon_sym_PERCENT] = ACTIONS(644),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(644),
    [anon_sym_LT_LT] = ACTIONS(644),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_and] = ACTIONS(642),
    [anon_sym_or] = ACTIONS(642),
    [anon_sym_xor] = ACTIONS(642),
    [anon_sym_isnt] = ACTIONS(642),
    [anon_sym_EQ_EQ] = ACTIONS(644),
    [anon_sym_BANG_EQ] = ACTIONS(644),
    [anon_sym_GT] = ACTIONS(644),
    [anon_sym_GT_EQ] = ACTIONS(644),
    [anon_sym_LT_EQ] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(644),
    [anon_sym_PLUS_TILDE] = ACTIONS(642),
    [anon_sym_STAR_TILDE] = ACTIONS(642),
    [anon_sym_SLASH_TILDE] = ACTIONS(642),
    [anon_sym_PERCENT_TILDE] = ACTIONS(642),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(642),
    [anon_sym_LT_LT_TILDE] = ACTIONS(642),
    [anon_sym_GT_GT_TILDE] = ACTIONS(642),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(642),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(642),
    [anon_sym_GT_TILDE] = ACTIONS(642),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(642),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(642),
    [anon_sym_LT_TILDE] = ACTIONS(642),
    [anon_sym_PLUS_QMARK] = ACTIONS(642),
    [anon_sym_DASH_QMARK] = ACTIONS(642),
    [anon_sym_STAR_QMARK] = ACTIONS(642),
    [anon_sym_SLASH_QMARK] = ACTIONS(642),
    [anon_sym_PERCENT_QMARK] = ACTIONS(642),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(642),
    [anon_sym_as] = ACTIONS(642),
    [anon_sym_LPAREN2] = ACTIONS(642),
    [anon_sym_DOT_GT] = ACTIONS(642),
    [anon_sym_where] = ACTIONS(642),
    [anon_sym_TILDE] = ACTIONS(642),
    [anon_sym_end] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(644),
    [anon_sym_ifdef] = ACTIONS(642),
    [anon_sym_iftype] = ACTIONS(642),
    [anon_sym_else] = ACTIONS(642),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(642),
    [anon_sym_try] = ACTIONS(642),
    [anon_sym_with] = ACTIONS(642),
    [anon_sym_repeat] = ACTIONS(642),
    [anon_sym_do] = ACTIONS(642),
    [anon_sym_recover] = ACTIONS(642),
    [anon_sym_match] = ACTIONS(642),
    [anon_sym_return] = ACTIONS(642),
    [anon_sym_continue] = ACTIONS(642),
    [anon_sym_break] = ACTIONS(642),
    [anon_sym_consume] = ACTIONS(642),
    [anon_sym_object] = ACTIONS(642),
    [sym_number] = ACTIONS(644),
    [sym_float] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(642),
    [anon_sym_SQUOTE] = ACTIONS(642),
    [anon_sym_true] = ACTIONS(642),
    [anon_sym_false] = ACTIONS(642),
    [sym_this] = ACTIONS(642),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [63] = {
    [ts_builtin_sym_end] = ACTIONS(646),
    [sym_identifier] = ACTIONS(648),
    [anon_sym_use] = ACTIONS(646),
    [anon_sym_EQ] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(646),
    [anon_sym_LBRACK] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_is] = ACTIONS(648),
    [anon_sym_actor] = ACTIONS(646),
    [anon_sym_class] = ACTIONS(646),
    [anon_sym_primitive] = ACTIONS(646),
    [anon_sym_interface] = ACTIONS(646),
    [anon_sym_trait] = ACTIONS(646),
    [anon_sym_struct] = ACTIONS(646),
    [anon_sym_embed] = ACTIONS(646),
    [anon_sym_let] = ACTIONS(646),
    [anon_sym_var] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(646),
    [anon_sym_fun] = ACTIONS(646),
    [anon_sym_be] = ACTIONS(646),
    [anon_sym_COMMA] = ACTIONS(646),
    [anon_sym_iso] = ACTIONS(646),
    [anon_sym_trn] = ACTIONS(646),
    [anon_sym_ref] = ACTIONS(646),
    [anon_sym_val] = ACTIONS(646),
    [anon_sym_box] = ACTIONS(646),
    [anon_sym_tag] = ACTIONS(646),
    [anon_sym_LPAREN] = ACTIONS(648),
    [anon_sym_RPAREN] = ACTIONS(646),
    [anon_sym_DOT] = ACTIONS(648),
    [anon_sym_POUNDread] = ACTIONS(646),
    [anon_sym_POUNDsend] = ACTIONS(646),
    [anon_sym_POUNDshare] = ACTIONS(646),
    [anon_sym_POUNDalias] = ACTIONS(646),
    [anon_sym_POUNDany] = ACTIONS(646),
    [anon_sym_BANG] = ACTIONS(648),
    [anon_sym_CARET] = ACTIONS(646),
    [anon_sym_PIPE] = ACTIONS(646),
    [anon_sym_AMP] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(646),
    [anon_sym_SEMI] = ACTIONS(646),
    [sym_error] = ACTIONS(646),
    [sym_compile_intrinsic] = ACTIONS(646),
    [anon_sym_compile_error] = ACTIONS(646),
    [sym_location] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(648),
    [anon_sym_not] = ACTIONS(646),
    [anon_sym_DASH_TILDE] = ACTIONS(646),
    [anon_sym_addressof] = ACTIONS(646),
    [anon_sym_digestof] = ACTIONS(646),
    [anon_sym_PLUS] = ACTIONS(648),
    [anon_sym_STAR] = ACTIONS(648),
    [anon_sym_SLASH] = ACTIONS(648),
    [anon_sym_PERCENT] = ACTIONS(648),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(648),
    [anon_sym_LT_LT] = ACTIONS(648),
    [anon_sym_GT_GT] = ACTIONS(648),
    [anon_sym_and] = ACTIONS(646),
    [anon_sym_or] = ACTIONS(646),
    [anon_sym_xor] = ACTIONS(646),
    [anon_sym_isnt] = ACTIONS(646),
    [anon_sym_EQ_EQ] = ACTIONS(648),
    [anon_sym_BANG_EQ] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(648),
    [anon_sym_GT_EQ] = ACTIONS(648),
    [anon_sym_LT_EQ] = ACTIONS(648),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_PLUS_TILDE] = ACTIONS(646),
    [anon_sym_STAR_TILDE] = ACTIONS(646),
    [anon_sym_SLASH_TILDE] = ACTIONS(646),
    [anon_sym_PERCENT_TILDE] = ACTIONS(646),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(646),
    [anon_sym_LT_LT_TILDE] = ACTIONS(646),
    [anon_sym_GT_GT_TILDE] = ACTIONS(646),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(646),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(646),
    [anon_sym_GT_TILDE] = ACTIONS(646),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(646),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(646),
    [anon_sym_LT_TILDE] = ACTIONS(646),
    [anon_sym_PLUS_QMARK] = ACTIONS(646),
    [anon_sym_DASH_QMARK] = ACTIONS(646),
    [anon_sym_STAR_QMARK] = ACTIONS(646),
    [anon_sym_SLASH_QMARK] = ACTIONS(646),
    [anon_sym_PERCENT_QMARK] = ACTIONS(646),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(646),
    [anon_sym_as] = ACTIONS(646),
    [anon_sym_LPAREN2] = ACTIONS(646),
    [anon_sym_DOT_GT] = ACTIONS(646),
    [anon_sym_where] = ACTIONS(646),
    [anon_sym_TILDE] = ACTIONS(646),
    [anon_sym_end] = ACTIONS(646),
    [anon_sym_if] = ACTIONS(648),
    [anon_sym_ifdef] = ACTIONS(646),
    [anon_sym_iftype] = ACTIONS(646),
    [anon_sym_else] = ACTIONS(646),
    [anon_sym_for] = ACTIONS(646),
    [anon_sym_while] = ACTIONS(646),
    [anon_sym_try] = ACTIONS(646),
    [anon_sym_with] = ACTIONS(646),
    [anon_sym_repeat] = ACTIONS(646),
    [anon_sym_do] = ACTIONS(646),
    [anon_sym_recover] = ACTIONS(646),
    [anon_sym_match] = ACTIONS(646),
    [anon_sym_return] = ACTIONS(646),
    [anon_sym_continue] = ACTIONS(646),
    [anon_sym_break] = ACTIONS(646),
    [anon_sym_consume] = ACTIONS(646),
    [anon_sym_object] = ACTIONS(646),
    [sym_number] = ACTIONS(648),
    [sym_float] = ACTIONS(646),
    [anon_sym_DQUOTE] = ACTIONS(648),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(646),
    [anon_sym_SQUOTE] = ACTIONS(646),
    [anon_sym_true] = ACTIONS(646),
    [anon_sym_false] = ACTIONS(646),
    [sym_this] = ACTIONS(646),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [64] = {
    [ts_builtin_sym_end] = ACTIONS(650),
    [sym_identifier] = ACTIONS(652),
    [anon_sym_use] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(652),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_LBRACK] = ACTIONS(650),
    [anon_sym_type] = ACTIONS(650),
    [anon_sym_is] = ACTIONS(652),
    [anon_sym_actor] = ACTIONS(650),
    [anon_sym_class] = ACTIONS(650),
    [anon_sym_primitive] = ACTIONS(650),
    [anon_sym_interface] = ACTIONS(650),
    [anon_sym_trait] = ACTIONS(650),
    [anon_sym_struct] = ACTIONS(650),
    [anon_sym_embed] = ACTIONS(650),
    [anon_sym_let] = ACTIONS(650),
    [anon_sym_var] = ACTIONS(650),
    [anon_sym_new] = ACTIONS(650),
    [anon_sym_fun] = ACTIONS(650),
    [anon_sym_be] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_iso] = ACTIONS(650),
    [anon_sym_trn] = ACTIONS(650),
    [anon_sym_ref] = ACTIONS(650),
    [anon_sym_val] = ACTIONS(650),
    [anon_sym_box] = ACTIONS(650),
    [anon_sym_tag] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(652),
    [anon_sym_RPAREN] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(652),
    [anon_sym_POUNDread] = ACTIONS(650),
    [anon_sym_POUNDsend] = ACTIONS(650),
    [anon_sym_POUNDshare] = ACTIONS(650),
    [anon_sym_POUNDalias] = ACTIONS(650),
    [anon_sym_POUNDany] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(650),
    [anon_sym_DASH_GT] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [sym_error] = ACTIONS(650),
    [sym_compile_intrinsic] = ACTIONS(650),
    [anon_sym_compile_error] = ACTIONS(650),
    [sym_location] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_not] = ACTIONS(650),
    [anon_sym_DASH_TILDE] = ACTIONS(650),
    [anon_sym_addressof] = ACTIONS(650),
    [anon_sym_digestof] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_STAR] = ACTIONS(652),
    [anon_sym_SLASH] = ACTIONS(652),
    [anon_sym_PERCENT] = ACTIONS(652),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(652),
    [anon_sym_LT_LT] = ACTIONS(652),
    [anon_sym_GT_GT] = ACTIONS(652),
    [anon_sym_and] = ACTIONS(650),
    [anon_sym_or] = ACTIONS(650),
    [anon_sym_xor] = ACTIONS(650),
    [anon_sym_isnt] = ACTIONS(650),
    [anon_sym_EQ_EQ] = ACTIONS(652),
    [anon_sym_BANG_EQ] = ACTIONS(652),
    [anon_sym_GT] = ACTIONS(652),
    [anon_sym_GT_EQ] = ACTIONS(652),
    [anon_sym_LT_EQ] = ACTIONS(652),
    [anon_sym_LT] = ACTIONS(652),
    [anon_sym_PLUS_TILDE] = ACTIONS(650),
    [anon_sym_STAR_TILDE] = ACTIONS(650),
    [anon_sym_SLASH_TILDE] = ACTIONS(650),
    [anon_sym_PERCENT_TILDE] = ACTIONS(650),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(650),
    [anon_sym_LT_LT_TILDE] = ACTIONS(650),
    [anon_sym_GT_GT_TILDE] = ACTIONS(650),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(650),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(650),
    [anon_sym_GT_TILDE] = ACTIONS(650),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(650),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(650),
    [anon_sym_LT_TILDE] = ACTIONS(650),
    [anon_sym_PLUS_QMARK] = ACTIONS(650),
    [anon_sym_DASH_QMARK] = ACTIONS(650),
    [anon_sym_STAR_QMARK] = ACTIONS(650),
    [anon_sym_SLASH_QMARK] = ACTIONS(650),
    [anon_sym_PERCENT_QMARK] = ACTIONS(650),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(650),
    [anon_sym_as] = ACTIONS(650),
    [anon_sym_LPAREN2] = ACTIONS(650),
    [anon_sym_DOT_GT] = ACTIONS(650),
    [anon_sym_where] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_end] = ACTIONS(650),
    [anon_sym_if] = ACTIONS(652),
    [anon_sym_ifdef] = ACTIONS(650),
    [anon_sym_iftype] = ACTIONS(650),
    [anon_sym_else] = ACTIONS(650),
    [anon_sym_for] = ACTIONS(650),
    [anon_sym_while] = ACTIONS(650),
    [anon_sym_try] = ACTIONS(650),
    [anon_sym_with] = ACTIONS(650),
    [anon_sym_repeat] = ACTIONS(650),
    [anon_sym_do] = ACTIONS(650),
    [anon_sym_recover] = ACTIONS(650),
    [anon_sym_match] = ACTIONS(650),
    [anon_sym_return] = ACTIONS(650),
    [anon_sym_continue] = ACTIONS(650),
    [anon_sym_break] = ACTIONS(650),
    [anon_sym_consume] = ACTIONS(650),
    [anon_sym_object] = ACTIONS(650),
    [sym_number] = ACTIONS(652),
    [sym_float] = ACTIONS(650),
    [anon_sym_DQUOTE] = ACTIONS(652),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(650),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_true] = ACTIONS(650),
    [anon_sym_false] = ACTIONS(650),
    [sym_this] = ACTIONS(650),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [65] = {
    [ts_builtin_sym_end] = ACTIONS(654),
    [sym_identifier] = ACTIONS(656),
    [anon_sym_use] = ACTIONS(654),
    [anon_sym_EQ] = ACTIONS(656),
    [anon_sym_AT] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(654),
    [anon_sym_type] = ACTIONS(654),
    [anon_sym_is] = ACTIONS(656),
    [anon_sym_actor] = ACTIONS(654),
    [anon_sym_class] = ACTIONS(654),
    [anon_sym_primitive] = ACTIONS(654),
    [anon_sym_interface] = ACTIONS(654),
    [anon_sym_trait] = ACTIONS(654),
    [anon_sym_struct] = ACTIONS(654),
    [anon_sym_embed] = ACTIONS(654),
    [anon_sym_let] = ACTIONS(654),
    [anon_sym_var] = ACTIONS(654),
    [anon_sym_new] = ACTIONS(654),
    [anon_sym_fun] = ACTIONS(654),
    [anon_sym_be] = ACTIONS(654),
    [anon_sym_COMMA] = ACTIONS(654),
    [anon_sym_iso] = ACTIONS(654),
    [anon_sym_trn] = ACTIONS(654),
    [anon_sym_ref] = ACTIONS(654),
    [anon_sym_val] = ACTIONS(654),
    [anon_sym_box] = ACTIONS(654),
    [anon_sym_tag] = ACTIONS(654),
    [anon_sym_LPAREN] = ACTIONS(656),
    [anon_sym_RPAREN] = ACTIONS(654),
    [anon_sym_DOT] = ACTIONS(656),
    [anon_sym_POUNDread] = ACTIONS(654),
    [anon_sym_POUNDsend] = ACTIONS(654),
    [anon_sym_POUNDshare] = ACTIONS(654),
    [anon_sym_POUNDalias] = ACTIONS(654),
    [anon_sym_POUNDany] = ACTIONS(654),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(654),
    [anon_sym_PIPE] = ACTIONS(654),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_DASH_GT] = ACTIONS(654),
    [anon_sym_LBRACE] = ACTIONS(654),
    [anon_sym_SEMI] = ACTIONS(654),
    [sym_error] = ACTIONS(654),
    [sym_compile_intrinsic] = ACTIONS(654),
    [anon_sym_compile_error] = ACTIONS(654),
    [sym_location] = ACTIONS(654),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_not] = ACTIONS(654),
    [anon_sym_DASH_TILDE] = ACTIONS(654),
    [anon_sym_addressof] = ACTIONS(654),
    [anon_sym_digestof] = ACTIONS(654),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_STAR] = ACTIONS(656),
    [anon_sym_SLASH] = ACTIONS(656),
    [anon_sym_PERCENT] = ACTIONS(656),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(656),
    [anon_sym_LT_LT] = ACTIONS(656),
    [anon_sym_GT_GT] = ACTIONS(656),
    [anon_sym_and] = ACTIONS(654),
    [anon_sym_or] = ACTIONS(654),
    [anon_sym_xor] = ACTIONS(654),
    [anon_sym_isnt] = ACTIONS(654),
    [anon_sym_EQ_EQ] = ACTIONS(656),
    [anon_sym_BANG_EQ] = ACTIONS(656),
    [anon_sym_GT] = ACTIONS(656),
    [anon_sym_GT_EQ] = ACTIONS(656),
    [anon_sym_LT_EQ] = ACTIONS(656),
    [anon_sym_LT] = ACTIONS(656),
    [anon_sym_PLUS_TILDE] = ACTIONS(654),
    [anon_sym_STAR_TILDE] = ACTIONS(654),
    [anon_sym_SLASH_TILDE] = ACTIONS(654),
    [anon_sym_PERCENT_TILDE] = ACTIONS(654),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(654),
    [anon_sym_LT_LT_TILDE] = ACTIONS(654),
    [anon_sym_GT_GT_TILDE] = ACTIONS(654),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(654),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(654),
    [anon_sym_GT_TILDE] = ACTIONS(654),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(654),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(654),
    [anon_sym_LT_TILDE] = ACTIONS(654),
    [anon_sym_PLUS_QMARK] = ACTIONS(654),
    [anon_sym_DASH_QMARK] = ACTIONS(654),
    [anon_sym_STAR_QMARK] = ACTIONS(654),
    [anon_sym_SLASH_QMARK] = ACTIONS(654),
    [anon_sym_PERCENT_QMARK] = ACTIONS(654),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(654),
    [anon_sym_as] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(654),
    [anon_sym_DOT_GT] = ACTIONS(654),
    [anon_sym_where] = ACTIONS(654),
    [anon_sym_TILDE] = ACTIONS(654),
    [anon_sym_end] = ACTIONS(654),
    [anon_sym_if] = ACTIONS(656),
    [anon_sym_ifdef] = ACTIONS(654),
    [anon_sym_iftype] = ACTIONS(654),
    [anon_sym_else] = ACTIONS(654),
    [anon_sym_for] = ACTIONS(654),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_try] = ACTIONS(654),
    [anon_sym_with] = ACTIONS(654),
    [anon_sym_repeat] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(654),
    [anon_sym_recover] = ACTIONS(654),
    [anon_sym_match] = ACTIONS(654),
    [anon_sym_return] = ACTIONS(654),
    [anon_sym_continue] = ACTIONS(654),
    [anon_sym_break] = ACTIONS(654),
    [anon_sym_consume] = ACTIONS(654),
    [anon_sym_object] = ACTIONS(654),
    [sym_number] = ACTIONS(656),
    [sym_float] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(654),
    [anon_sym_true] = ACTIONS(654),
    [anon_sym_false] = ACTIONS(654),
    [sym_this] = ACTIONS(654),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [66] = {
    [ts_builtin_sym_end] = ACTIONS(658),
    [sym_identifier] = ACTIONS(660),
    [anon_sym_use] = ACTIONS(658),
    [anon_sym_EQ] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(658),
    [anon_sym_type] = ACTIONS(658),
    [anon_sym_is] = ACTIONS(660),
    [anon_sym_actor] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(658),
    [anon_sym_primitive] = ACTIONS(658),
    [anon_sym_interface] = ACTIONS(658),
    [anon_sym_trait] = ACTIONS(658),
    [anon_sym_struct] = ACTIONS(658),
    [anon_sym_embed] = ACTIONS(658),
    [anon_sym_let] = ACTIONS(658),
    [anon_sym_var] = ACTIONS(658),
    [anon_sym_new] = ACTIONS(658),
    [anon_sym_fun] = ACTIONS(658),
    [anon_sym_be] = ACTIONS(658),
    [anon_sym_COMMA] = ACTIONS(658),
    [anon_sym_iso] = ACTIONS(658),
    [anon_sym_trn] = ACTIONS(658),
    [anon_sym_ref] = ACTIONS(658),
    [anon_sym_val] = ACTIONS(658),
    [anon_sym_box] = ACTIONS(658),
    [anon_sym_tag] = ACTIONS(658),
    [anon_sym_LPAREN] = ACTIONS(660),
    [anon_sym_RPAREN] = ACTIONS(658),
    [anon_sym_DOT] = ACTIONS(660),
    [anon_sym_POUNDread] = ACTIONS(658),
    [anon_sym_POUNDsend] = ACTIONS(658),
    [anon_sym_POUNDshare] = ACTIONS(658),
    [anon_sym_POUNDalias] = ACTIONS(658),
    [anon_sym_POUNDany] = ACTIONS(658),
    [anon_sym_BANG] = ACTIONS(660),
    [anon_sym_CARET] = ACTIONS(658),
    [anon_sym_PIPE] = ACTIONS(658),
    [anon_sym_AMP] = ACTIONS(658),
    [anon_sym_DASH_GT] = ACTIONS(658),
    [anon_sym_LBRACE] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(658),
    [sym_error] = ACTIONS(658),
    [sym_compile_intrinsic] = ACTIONS(658),
    [anon_sym_compile_error] = ACTIONS(658),
    [sym_location] = ACTIONS(658),
    [anon_sym_DASH] = ACTIONS(660),
    [anon_sym_not] = ACTIONS(658),
    [anon_sym_DASH_TILDE] = ACTIONS(658),
    [anon_sym_addressof] = ACTIONS(658),
    [anon_sym_digestof] = ACTIONS(658),
    [anon_sym_PLUS] = ACTIONS(660),
    [anon_sym_STAR] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(660),
    [anon_sym_PERCENT] = ACTIONS(660),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(660),
    [anon_sym_LT_LT] = ACTIONS(660),
    [anon_sym_GT_GT] = ACTIONS(660),
    [anon_sym_and] = ACTIONS(658),
    [anon_sym_or] = ACTIONS(658),
    [anon_sym_xor] = ACTIONS(658),
    [anon_sym_isnt] = ACTIONS(658),
    [anon_sym_EQ_EQ] = ACTIONS(660),
    [anon_sym_BANG_EQ] = ACTIONS(660),
    [anon_sym_GT] = ACTIONS(660),
    [anon_sym_GT_EQ] = ACTIONS(660),
    [anon_sym_LT_EQ] = ACTIONS(660),
    [anon_sym_LT] = ACTIONS(660),
    [anon_sym_PLUS_TILDE] = ACTIONS(658),
    [anon_sym_STAR_TILDE] = ACTIONS(658),
    [anon_sym_SLASH_TILDE] = ACTIONS(658),
    [anon_sym_PERCENT_TILDE] = ACTIONS(658),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(658),
    [anon_sym_LT_LT_TILDE] = ACTIONS(658),
    [anon_sym_GT_GT_TILDE] = ACTIONS(658),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(658),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(658),
    [anon_sym_GT_TILDE] = ACTIONS(658),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(658),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(658),
    [anon_sym_LT_TILDE] = ACTIONS(658),
    [anon_sym_PLUS_QMARK] = ACTIONS(658),
    [anon_sym_DASH_QMARK] = ACTIONS(658),
    [anon_sym_STAR_QMARK] = ACTIONS(658),
    [anon_sym_SLASH_QMARK] = ACTIONS(658),
    [anon_sym_PERCENT_QMARK] = ACTIONS(658),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(658),
    [anon_sym_as] = ACTIONS(658),
    [anon_sym_LPAREN2] = ACTIONS(658),
    [anon_sym_DOT_GT] = ACTIONS(658),
    [anon_sym_where] = ACTIONS(658),
    [anon_sym_TILDE] = ACTIONS(658),
    [anon_sym_end] = ACTIONS(658),
    [anon_sym_if] = ACTIONS(660),
    [anon_sym_ifdef] = ACTIONS(658),
    [anon_sym_iftype] = ACTIONS(658),
    [anon_sym_else] = ACTIONS(658),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_while] = ACTIONS(658),
    [anon_sym_try] = ACTIONS(658),
    [anon_sym_with] = ACTIONS(658),
    [anon_sym_repeat] = ACTIONS(658),
    [anon_sym_do] = ACTIONS(658),
    [anon_sym_recover] = ACTIONS(658),
    [anon_sym_match] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(658),
    [anon_sym_continue] = ACTIONS(658),
    [anon_sym_break] = ACTIONS(658),
    [anon_sym_consume] = ACTIONS(658),
    [anon_sym_object] = ACTIONS(658),
    [sym_number] = ACTIONS(660),
    [sym_float] = ACTIONS(658),
    [anon_sym_DQUOTE] = ACTIONS(660),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(658),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_true] = ACTIONS(658),
    [anon_sym_false] = ACTIONS(658),
    [sym_this] = ACTIONS(658),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [67] = {
    [ts_builtin_sym_end] = ACTIONS(662),
    [sym_identifier] = ACTIONS(664),
    [anon_sym_use] = ACTIONS(662),
    [anon_sym_EQ] = ACTIONS(664),
    [anon_sym_AT] = ACTIONS(662),
    [anon_sym_LBRACK] = ACTIONS(662),
    [anon_sym_type] = ACTIONS(662),
    [anon_sym_is] = ACTIONS(664),
    [anon_sym_actor] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(662),
    [anon_sym_primitive] = ACTIONS(662),
    [anon_sym_interface] = ACTIONS(662),
    [anon_sym_trait] = ACTIONS(662),
    [anon_sym_struct] = ACTIONS(662),
    [anon_sym_embed] = ACTIONS(662),
    [anon_sym_let] = ACTIONS(662),
    [anon_sym_var] = ACTIONS(662),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_fun] = ACTIONS(662),
    [anon_sym_be] = ACTIONS(662),
    [anon_sym_COMMA] = ACTIONS(662),
    [anon_sym_iso] = ACTIONS(662),
    [anon_sym_trn] = ACTIONS(662),
    [anon_sym_ref] = ACTIONS(662),
    [anon_sym_val] = ACTIONS(662),
    [anon_sym_box] = ACTIONS(662),
    [anon_sym_tag] = ACTIONS(662),
    [anon_sym_LPAREN] = ACTIONS(664),
    [anon_sym_RPAREN] = ACTIONS(662),
    [anon_sym_DOT] = ACTIONS(664),
    [anon_sym_POUNDread] = ACTIONS(662),
    [anon_sym_POUNDsend] = ACTIONS(662),
    [anon_sym_POUNDshare] = ACTIONS(662),
    [anon_sym_POUNDalias] = ACTIONS(662),
    [anon_sym_POUNDany] = ACTIONS(662),
    [anon_sym_BANG] = ACTIONS(664),
    [anon_sym_CARET] = ACTIONS(662),
    [anon_sym_PIPE] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(662),
    [anon_sym_DASH_GT] = ACTIONS(662),
    [anon_sym_LBRACE] = ACTIONS(662),
    [anon_sym_SEMI] = ACTIONS(662),
    [sym_error] = ACTIONS(662),
    [sym_compile_intrinsic] = ACTIONS(662),
    [anon_sym_compile_error] = ACTIONS(662),
    [sym_location] = ACTIONS(662),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_not] = ACTIONS(662),
    [anon_sym_DASH_TILDE] = ACTIONS(662),
    [anon_sym_addressof] = ACTIONS(662),
    [anon_sym_digestof] = ACTIONS(662),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_STAR] = ACTIONS(664),
    [anon_sym_SLASH] = ACTIONS(664),
    [anon_sym_PERCENT] = ACTIONS(664),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(664),
    [anon_sym_LT_LT] = ACTIONS(664),
    [anon_sym_GT_GT] = ACTIONS(664),
    [anon_sym_and] = ACTIONS(662),
    [anon_sym_or] = ACTIONS(662),
    [anon_sym_xor] = ACTIONS(662),
    [anon_sym_isnt] = ACTIONS(662),
    [anon_sym_EQ_EQ] = ACTIONS(664),
    [anon_sym_BANG_EQ] = ACTIONS(664),
    [anon_sym_GT] = ACTIONS(664),
    [anon_sym_GT_EQ] = ACTIONS(664),
    [anon_sym_LT_EQ] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(664),
    [anon_sym_PLUS_TILDE] = ACTIONS(662),
    [anon_sym_STAR_TILDE] = ACTIONS(662),
    [anon_sym_SLASH_TILDE] = ACTIONS(662),
    [anon_sym_PERCENT_TILDE] = ACTIONS(662),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(662),
    [anon_sym_LT_LT_TILDE] = ACTIONS(662),
    [anon_sym_GT_GT_TILDE] = ACTIONS(662),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(662),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(662),
    [anon_sym_GT_TILDE] = ACTIONS(662),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(662),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(662),
    [anon_sym_LT_TILDE] = ACTIONS(662),
    [anon_sym_PLUS_QMARK] = ACTIONS(662),
    [anon_sym_DASH_QMARK] = ACTIONS(662),
    [anon_sym_STAR_QMARK] = ACTIONS(662),
    [anon_sym_SLASH_QMARK] = ACTIONS(662),
    [anon_sym_PERCENT_QMARK] = ACTIONS(662),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(662),
    [anon_sym_as] = ACTIONS(662),
    [anon_sym_LPAREN2] = ACTIONS(662),
    [anon_sym_DOT_GT] = ACTIONS(662),
    [anon_sym_where] = ACTIONS(662),
    [anon_sym_TILDE] = ACTIONS(662),
    [anon_sym_end] = ACTIONS(662),
    [anon_sym_if] = ACTIONS(664),
    [anon_sym_ifdef] = ACTIONS(662),
    [anon_sym_iftype] = ACTIONS(662),
    [anon_sym_else] = ACTIONS(662),
    [anon_sym_for] = ACTIONS(662),
    [anon_sym_while] = ACTIONS(662),
    [anon_sym_try] = ACTIONS(662),
    [anon_sym_with] = ACTIONS(662),
    [anon_sym_repeat] = ACTIONS(662),
    [anon_sym_do] = ACTIONS(662),
    [anon_sym_recover] = ACTIONS(662),
    [anon_sym_match] = ACTIONS(662),
    [anon_sym_return] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(662),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_consume] = ACTIONS(662),
    [anon_sym_object] = ACTIONS(662),
    [sym_number] = ACTIONS(664),
    [sym_float] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(662),
    [anon_sym_SQUOTE] = ACTIONS(662),
    [anon_sym_true] = ACTIONS(662),
    [anon_sym_false] = ACTIONS(662),
    [sym_this] = ACTIONS(662),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [68] = {
    [ts_builtin_sym_end] = ACTIONS(666),
    [sym_identifier] = ACTIONS(668),
    [anon_sym_use] = ACTIONS(666),
    [anon_sym_EQ] = ACTIONS(668),
    [anon_sym_AT] = ACTIONS(666),
    [anon_sym_LBRACK] = ACTIONS(666),
    [anon_sym_type] = ACTIONS(666),
    [anon_sym_is] = ACTIONS(668),
    [anon_sym_actor] = ACTIONS(666),
    [anon_sym_class] = ACTIONS(666),
    [anon_sym_primitive] = ACTIONS(666),
    [anon_sym_interface] = ACTIONS(666),
    [anon_sym_trait] = ACTIONS(666),
    [anon_sym_struct] = ACTIONS(666),
    [anon_sym_embed] = ACTIONS(666),
    [anon_sym_let] = ACTIONS(666),
    [anon_sym_var] = ACTIONS(666),
    [anon_sym_new] = ACTIONS(666),
    [anon_sym_fun] = ACTIONS(666),
    [anon_sym_be] = ACTIONS(666),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_iso] = ACTIONS(666),
    [anon_sym_trn] = ACTIONS(666),
    [anon_sym_ref] = ACTIONS(666),
    [anon_sym_val] = ACTIONS(666),
    [anon_sym_box] = ACTIONS(666),
    [anon_sym_tag] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(668),
    [anon_sym_RPAREN] = ACTIONS(666),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_POUNDread] = ACTIONS(666),
    [anon_sym_POUNDsend] = ACTIONS(666),
    [anon_sym_POUNDshare] = ACTIONS(666),
    [anon_sym_POUNDalias] = ACTIONS(666),
    [anon_sym_POUNDany] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(666),
    [anon_sym_DASH_GT] = ACTIONS(666),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(666),
    [sym_error] = ACTIONS(666),
    [sym_compile_intrinsic] = ACTIONS(666),
    [anon_sym_compile_error] = ACTIONS(666),
    [sym_location] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(668),
    [anon_sym_not] = ACTIONS(666),
    [anon_sym_DASH_TILDE] = ACTIONS(666),
    [anon_sym_addressof] = ACTIONS(666),
    [anon_sym_digestof] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(668),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(668),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(668),
    [anon_sym_LT_LT] = ACTIONS(668),
    [anon_sym_GT_GT] = ACTIONS(668),
    [anon_sym_and] = ACTIONS(666),
    [anon_sym_or] = ACTIONS(666),
    [anon_sym_xor] = ACTIONS(666),
    [anon_sym_isnt] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(668),
    [anon_sym_BANG_EQ] = ACTIONS(668),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_GT_EQ] = ACTIONS(668),
    [anon_sym_LT_EQ] = ACTIONS(668),
    [anon_sym_LT] = ACTIONS(668),
    [anon_sym_PLUS_TILDE] = ACTIONS(666),
    [anon_sym_STAR_TILDE] = ACTIONS(666),
    [anon_sym_SLASH_TILDE] = ACTIONS(666),
    [anon_sym_PERCENT_TILDE] = ACTIONS(666),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(666),
    [anon_sym_LT_LT_TILDE] = ACTIONS(666),
    [anon_sym_GT_GT_TILDE] = ACTIONS(666),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(666),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(666),
    [anon_sym_GT_TILDE] = ACTIONS(666),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(666),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(666),
    [anon_sym_LT_TILDE] = ACTIONS(666),
    [anon_sym_PLUS_QMARK] = ACTIONS(666),
    [anon_sym_DASH_QMARK] = ACTIONS(666),
    [anon_sym_STAR_QMARK] = ACTIONS(666),
    [anon_sym_SLASH_QMARK] = ACTIONS(666),
    [anon_sym_PERCENT_QMARK] = ACTIONS(666),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(666),
    [anon_sym_LPAREN2] = ACTIONS(666),
    [anon_sym_DOT_GT] = ACTIONS(666),
    [anon_sym_where] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_end] = ACTIONS(666),
    [anon_sym_if] = ACTIONS(668),
    [anon_sym_ifdef] = ACTIONS(666),
    [anon_sym_iftype] = ACTIONS(666),
    [anon_sym_else] = ACTIONS(666),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_while] = ACTIONS(666),
    [anon_sym_try] = ACTIONS(666),
    [anon_sym_with] = ACTIONS(666),
    [anon_sym_repeat] = ACTIONS(666),
    [anon_sym_do] = ACTIONS(666),
    [anon_sym_recover] = ACTIONS(666),
    [anon_sym_match] = ACTIONS(666),
    [anon_sym_return] = ACTIONS(666),
    [anon_sym_continue] = ACTIONS(666),
    [anon_sym_break] = ACTIONS(666),
    [anon_sym_consume] = ACTIONS(666),
    [anon_sym_object] = ACTIONS(666),
    [sym_number] = ACTIONS(668),
    [sym_float] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(666),
    [anon_sym_SQUOTE] = ACTIONS(666),
    [anon_sym_true] = ACTIONS(666),
    [anon_sym_false] = ACTIONS(666),
    [sym_this] = ACTIONS(666),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [69] = {
    [ts_builtin_sym_end] = ACTIONS(670),
    [sym_identifier] = ACTIONS(672),
    [anon_sym_use] = ACTIONS(670),
    [anon_sym_EQ] = ACTIONS(672),
    [anon_sym_AT] = ACTIONS(670),
    [anon_sym_LBRACK] = ACTIONS(670),
    [anon_sym_type] = ACTIONS(670),
    [anon_sym_is] = ACTIONS(672),
    [anon_sym_actor] = ACTIONS(670),
    [anon_sym_class] = ACTIONS(670),
    [anon_sym_primitive] = ACTIONS(670),
    [anon_sym_interface] = ACTIONS(670),
    [anon_sym_trait] = ACTIONS(670),
    [anon_sym_struct] = ACTIONS(670),
    [anon_sym_embed] = ACTIONS(670),
    [anon_sym_let] = ACTIONS(670),
    [anon_sym_var] = ACTIONS(670),
    [anon_sym_new] = ACTIONS(670),
    [anon_sym_fun] = ACTIONS(670),
    [anon_sym_be] = ACTIONS(670),
    [anon_sym_COMMA] = ACTIONS(670),
    [anon_sym_iso] = ACTIONS(670),
    [anon_sym_trn] = ACTIONS(670),
    [anon_sym_ref] = ACTIONS(670),
    [anon_sym_val] = ACTIONS(670),
    [anon_sym_box] = ACTIONS(670),
    [anon_sym_tag] = ACTIONS(670),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RPAREN] = ACTIONS(670),
    [anon_sym_DOT] = ACTIONS(672),
    [anon_sym_POUNDread] = ACTIONS(670),
    [anon_sym_POUNDsend] = ACTIONS(670),
    [anon_sym_POUNDshare] = ACTIONS(670),
    [anon_sym_POUNDalias] = ACTIONS(670),
    [anon_sym_POUNDany] = ACTIONS(670),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_CARET] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(670),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_DASH_GT] = ACTIONS(670),
    [anon_sym_LBRACE] = ACTIONS(670),
    [anon_sym_SEMI] = ACTIONS(670),
    [sym_error] = ACTIONS(670),
    [sym_compile_intrinsic] = ACTIONS(670),
    [anon_sym_compile_error] = ACTIONS(670),
    [sym_location] = ACTIONS(670),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_not] = ACTIONS(670),
    [anon_sym_DASH_TILDE] = ACTIONS(670),
    [anon_sym_addressof] = ACTIONS(670),
    [anon_sym_digestof] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_SLASH] = ACTIONS(672),
    [anon_sym_PERCENT] = ACTIONS(672),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(672),
    [anon_sym_LT_LT] = ACTIONS(672),
    [anon_sym_GT_GT] = ACTIONS(672),
    [anon_sym_and] = ACTIONS(670),
    [anon_sym_or] = ACTIONS(670),
    [anon_sym_xor] = ACTIONS(670),
    [anon_sym_isnt] = ACTIONS(670),
    [anon_sym_EQ_EQ] = ACTIONS(672),
    [anon_sym_BANG_EQ] = ACTIONS(672),
    [anon_sym_GT] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(672),
    [anon_sym_LT_EQ] = ACTIONS(672),
    [anon_sym_LT] = ACTIONS(672),
    [anon_sym_PLUS_TILDE] = ACTIONS(670),
    [anon_sym_STAR_TILDE] = ACTIONS(670),
    [anon_sym_SLASH_TILDE] = ACTIONS(670),
    [anon_sym_PERCENT_TILDE] = ACTIONS(670),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(670),
    [anon_sym_LT_LT_TILDE] = ACTIONS(670),
    [anon_sym_GT_GT_TILDE] = ACTIONS(670),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(670),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(670),
    [anon_sym_GT_TILDE] = ACTIONS(670),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(670),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(670),
    [anon_sym_LT_TILDE] = ACTIONS(670),
    [anon_sym_PLUS_QMARK] = ACTIONS(670),
    [anon_sym_DASH_QMARK] = ACTIONS(670),
    [anon_sym_STAR_QMARK] = ACTIONS(670),
    [anon_sym_SLASH_QMARK] = ACTIONS(670),
    [anon_sym_PERCENT_QMARK] = ACTIONS(670),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(670),
    [anon_sym_as] = ACTIONS(670),
    [anon_sym_LPAREN2] = ACTIONS(670),
    [anon_sym_DOT_GT] = ACTIONS(670),
    [anon_sym_where] = ACTIONS(670),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_end] = ACTIONS(670),
    [anon_sym_if] = ACTIONS(672),
    [anon_sym_ifdef] = ACTIONS(670),
    [anon_sym_iftype] = ACTIONS(670),
    [anon_sym_else] = ACTIONS(670),
    [anon_sym_for] = ACTIONS(670),
    [anon_sym_while] = ACTIONS(670),
    [anon_sym_try] = ACTIONS(670),
    [anon_sym_with] = ACTIONS(670),
    [anon_sym_repeat] = ACTIONS(670),
    [anon_sym_do] = ACTIONS(670),
    [anon_sym_recover] = ACTIONS(670),
    [anon_sym_match] = ACTIONS(670),
    [anon_sym_return] = ACTIONS(670),
    [anon_sym_continue] = ACTIONS(670),
    [anon_sym_break] = ACTIONS(670),
    [anon_sym_consume] = ACTIONS(670),
    [anon_sym_object] = ACTIONS(670),
    [sym_number] = ACTIONS(672),
    [sym_float] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(672),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [anon_sym_SQUOTE] = ACTIONS(670),
    [anon_sym_true] = ACTIONS(670),
    [anon_sym_false] = ACTIONS(670),
    [sym_this] = ACTIONS(670),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [70] = {
    [ts_builtin_sym_end] = ACTIONS(674),
    [sym_identifier] = ACTIONS(676),
    [anon_sym_use] = ACTIONS(674),
    [anon_sym_EQ] = ACTIONS(676),
    [anon_sym_AT] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(674),
    [anon_sym_type] = ACTIONS(674),
    [anon_sym_is] = ACTIONS(676),
    [anon_sym_actor] = ACTIONS(674),
    [anon_sym_class] = ACTIONS(674),
    [anon_sym_primitive] = ACTIONS(674),
    [anon_sym_interface] = ACTIONS(674),
    [anon_sym_trait] = ACTIONS(674),
    [anon_sym_struct] = ACTIONS(674),
    [anon_sym_embed] = ACTIONS(674),
    [anon_sym_let] = ACTIONS(674),
    [anon_sym_var] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(674),
    [anon_sym_fun] = ACTIONS(674),
    [anon_sym_be] = ACTIONS(674),
    [anon_sym_COMMA] = ACTIONS(674),
    [anon_sym_iso] = ACTIONS(674),
    [anon_sym_trn] = ACTIONS(674),
    [anon_sym_ref] = ACTIONS(674),
    [anon_sym_val] = ACTIONS(674),
    [anon_sym_box] = ACTIONS(674),
    [anon_sym_tag] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(676),
    [anon_sym_RPAREN] = ACTIONS(674),
    [anon_sym_DOT] = ACTIONS(676),
    [anon_sym_POUNDread] = ACTIONS(674),
    [anon_sym_POUNDsend] = ACTIONS(674),
    [anon_sym_POUNDshare] = ACTIONS(674),
    [anon_sym_POUNDalias] = ACTIONS(674),
    [anon_sym_POUNDany] = ACTIONS(674),
    [anon_sym_BANG] = ACTIONS(676),
    [anon_sym_CARET] = ACTIONS(674),
    [anon_sym_PIPE] = ACTIONS(674),
    [anon_sym_AMP] = ACTIONS(674),
    [anon_sym_DASH_GT] = ACTIONS(674),
    [anon_sym_LBRACE] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(674),
    [sym_error] = ACTIONS(674),
    [sym_compile_intrinsic] = ACTIONS(674),
    [anon_sym_compile_error] = ACTIONS(674),
    [sym_location] = ACTIONS(674),
    [anon_sym_DASH] = ACTIONS(676),
    [anon_sym_not] = ACTIONS(674),
    [anon_sym_DASH_TILDE] = ACTIONS(674),
    [anon_sym_addressof] = ACTIONS(674),
    [anon_sym_digestof] = ACTIONS(674),
    [anon_sym_PLUS] = ACTIONS(676),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_SLASH] = ACTIONS(676),
    [anon_sym_PERCENT] = ACTIONS(676),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(676),
    [anon_sym_LT_LT] = ACTIONS(676),
    [anon_sym_GT_GT] = ACTIONS(676),
    [anon_sym_and] = ACTIONS(674),
    [anon_sym_or] = ACTIONS(674),
    [anon_sym_xor] = ACTIONS(674),
    [anon_sym_isnt] = ACTIONS(674),
    [anon_sym_EQ_EQ] = ACTIONS(676),
    [anon_sym_BANG_EQ] = ACTIONS(676),
    [anon_sym_GT] = ACTIONS(676),
    [anon_sym_GT_EQ] = ACTIONS(676),
    [anon_sym_LT_EQ] = ACTIONS(676),
    [anon_sym_LT] = ACTIONS(676),
    [anon_sym_PLUS_TILDE] = ACTIONS(674),
    [anon_sym_STAR_TILDE] = ACTIONS(674),
    [anon_sym_SLASH_TILDE] = ACTIONS(674),
    [anon_sym_PERCENT_TILDE] = ACTIONS(674),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(674),
    [anon_sym_LT_LT_TILDE] = ACTIONS(674),
    [anon_sym_GT_GT_TILDE] = ACTIONS(674),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(674),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(674),
    [anon_sym_GT_TILDE] = ACTIONS(674),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(674),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(674),
    [anon_sym_LT_TILDE] = ACTIONS(674),
    [anon_sym_PLUS_QMARK] = ACTIONS(674),
    [anon_sym_DASH_QMARK] = ACTIONS(674),
    [anon_sym_STAR_QMARK] = ACTIONS(674),
    [anon_sym_SLASH_QMARK] = ACTIONS(674),
    [anon_sym_PERCENT_QMARK] = ACTIONS(674),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(674),
    [anon_sym_as] = ACTIONS(674),
    [anon_sym_LPAREN2] = ACTIONS(674),
    [anon_sym_DOT_GT] = ACTIONS(674),
    [anon_sym_where] = ACTIONS(674),
    [anon_sym_TILDE] = ACTIONS(674),
    [anon_sym_end] = ACTIONS(674),
    [anon_sym_if] = ACTIONS(676),
    [anon_sym_ifdef] = ACTIONS(674),
    [anon_sym_iftype] = ACTIONS(674),
    [anon_sym_else] = ACTIONS(674),
    [anon_sym_for] = ACTIONS(674),
    [anon_sym_while] = ACTIONS(674),
    [anon_sym_try] = ACTIONS(674),
    [anon_sym_with] = ACTIONS(674),
    [anon_sym_repeat] = ACTIONS(674),
    [anon_sym_do] = ACTIONS(674),
    [anon_sym_recover] = ACTIONS(674),
    [anon_sym_match] = ACTIONS(674),
    [anon_sym_return] = ACTIONS(674),
    [anon_sym_continue] = ACTIONS(674),
    [anon_sym_break] = ACTIONS(674),
    [anon_sym_consume] = ACTIONS(674),
    [anon_sym_object] = ACTIONS(674),
    [sym_number] = ACTIONS(676),
    [sym_float] = ACTIONS(674),
    [anon_sym_DQUOTE] = ACTIONS(676),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(674),
    [anon_sym_SQUOTE] = ACTIONS(674),
    [anon_sym_true] = ACTIONS(674),
    [anon_sym_false] = ACTIONS(674),
    [sym_this] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [71] = {
    [ts_builtin_sym_end] = ACTIONS(678),
    [sym_identifier] = ACTIONS(680),
    [anon_sym_use] = ACTIONS(678),
    [anon_sym_EQ] = ACTIONS(680),
    [anon_sym_AT] = ACTIONS(678),
    [anon_sym_LBRACK] = ACTIONS(678),
    [anon_sym_type] = ACTIONS(678),
    [anon_sym_is] = ACTIONS(680),
    [anon_sym_actor] = ACTIONS(678),
    [anon_sym_class] = ACTIONS(678),
    [anon_sym_primitive] = ACTIONS(678),
    [anon_sym_interface] = ACTIONS(678),
    [anon_sym_trait] = ACTIONS(678),
    [anon_sym_struct] = ACTIONS(678),
    [anon_sym_embed] = ACTIONS(678),
    [anon_sym_let] = ACTIONS(678),
    [anon_sym_var] = ACTIONS(678),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_fun] = ACTIONS(678),
    [anon_sym_be] = ACTIONS(678),
    [anon_sym_COMMA] = ACTIONS(678),
    [anon_sym_iso] = ACTIONS(682),
    [anon_sym_trn] = ACTIONS(684),
    [anon_sym_ref] = ACTIONS(686),
    [anon_sym_val] = ACTIONS(688),
    [anon_sym_box] = ACTIONS(690),
    [anon_sym_tag] = ACTIONS(692),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_RPAREN] = ACTIONS(678),
    [anon_sym_DOT] = ACTIONS(680),
    [anon_sym_POUNDread] = ACTIONS(694),
    [anon_sym_POUNDsend] = ACTIONS(696),
    [anon_sym_POUNDshare] = ACTIONS(698),
    [anon_sym_POUNDalias] = ACTIONS(700),
    [anon_sym_POUNDany] = ACTIONS(702),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_CARET] = ACTIONS(678),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_AMP] = ACTIONS(678),
    [anon_sym_DASH_GT] = ACTIONS(678),
    [anon_sym_LBRACE] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(678),
    [sym_error] = ACTIONS(678),
    [sym_compile_intrinsic] = ACTIONS(678),
    [anon_sym_compile_error] = ACTIONS(678),
    [sym_location] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(680),
    [anon_sym_not] = ACTIONS(678),
    [anon_sym_DASH_TILDE] = ACTIONS(678),
    [anon_sym_addressof] = ACTIONS(678),
    [anon_sym_digestof] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(680),
    [anon_sym_STAR] = ACTIONS(680),
    [anon_sym_SLASH] = ACTIONS(680),
    [anon_sym_PERCENT] = ACTIONS(680),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(680),
    [anon_sym_LT_LT] = ACTIONS(680),
    [anon_sym_GT_GT] = ACTIONS(680),
    [anon_sym_and] = ACTIONS(678),
    [anon_sym_or] = ACTIONS(678),
    [anon_sym_xor] = ACTIONS(678),
    [anon_sym_isnt] = ACTIONS(678),
    [anon_sym_EQ_EQ] = ACTIONS(680),
    [anon_sym_BANG_EQ] = ACTIONS(680),
    [anon_sym_GT] = ACTIONS(680),
    [anon_sym_GT_EQ] = ACTIONS(680),
    [anon_sym_LT_EQ] = ACTIONS(680),
    [anon_sym_LT] = ACTIONS(680),
    [anon_sym_PLUS_TILDE] = ACTIONS(678),
    [anon_sym_STAR_TILDE] = ACTIONS(678),
    [anon_sym_SLASH_TILDE] = ACTIONS(678),
    [anon_sym_PERCENT_TILDE] = ACTIONS(678),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(678),
    [anon_sym_LT_LT_TILDE] = ACTIONS(678),
    [anon_sym_GT_GT_TILDE] = ACTIONS(678),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(678),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(678),
    [anon_sym_GT_TILDE] = ACTIONS(678),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(678),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(678),
    [anon_sym_LT_TILDE] = ACTIONS(678),
    [anon_sym_PLUS_QMARK] = ACTIONS(678),
    [anon_sym_DASH_QMARK] = ACTIONS(678),
    [anon_sym_STAR_QMARK] = ACTIONS(678),
    [anon_sym_SLASH_QMARK] = ACTIONS(678),
    [anon_sym_PERCENT_QMARK] = ACTIONS(678),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(678),
    [anon_sym_as] = ACTIONS(678),
    [anon_sym_LPAREN2] = ACTIONS(678),
    [anon_sym_DOT_GT] = ACTIONS(678),
    [anon_sym_where] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(678),
    [anon_sym_end] = ACTIONS(678),
    [anon_sym_if] = ACTIONS(680),
    [anon_sym_ifdef] = ACTIONS(678),
    [anon_sym_iftype] = ACTIONS(678),
    [anon_sym_else] = ACTIONS(678),
    [anon_sym_for] = ACTIONS(678),
    [anon_sym_while] = ACTIONS(678),
    [anon_sym_try] = ACTIONS(678),
    [anon_sym_with] = ACTIONS(678),
    [anon_sym_repeat] = ACTIONS(678),
    [anon_sym_do] = ACTIONS(678),
    [anon_sym_recover] = ACTIONS(678),
    [anon_sym_match] = ACTIONS(678),
    [anon_sym_return] = ACTIONS(678),
    [anon_sym_continue] = ACTIONS(678),
    [anon_sym_break] = ACTIONS(678),
    [anon_sym_consume] = ACTIONS(678),
    [anon_sym_object] = ACTIONS(678),
    [sym_number] = ACTIONS(680),
    [sym_float] = ACTIONS(678),
    [anon_sym_DQUOTE] = ACTIONS(680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(678),
    [anon_sym_true] = ACTIONS(678),
    [anon_sym_false] = ACTIONS(678),
    [sym_this] = ACTIONS(678),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [72] = {
    [ts_builtin_sym_end] = ACTIONS(704),
    [sym_identifier] = ACTIONS(706),
    [anon_sym_use] = ACTIONS(704),
    [anon_sym_EQ] = ACTIONS(706),
    [anon_sym_AT] = ACTIONS(704),
    [anon_sym_LBRACK] = ACTIONS(704),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_is] = ACTIONS(706),
    [anon_sym_actor] = ACTIONS(704),
    [anon_sym_class] = ACTIONS(704),
    [anon_sym_primitive] = ACTIONS(704),
    [anon_sym_interface] = ACTIONS(704),
    [anon_sym_trait] = ACTIONS(704),
    [anon_sym_struct] = ACTIONS(704),
    [anon_sym_embed] = ACTIONS(704),
    [anon_sym_let] = ACTIONS(704),
    [anon_sym_var] = ACTIONS(704),
    [anon_sym_new] = ACTIONS(704),
    [anon_sym_fun] = ACTIONS(704),
    [anon_sym_be] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(704),
    [anon_sym_iso] = ACTIONS(704),
    [anon_sym_trn] = ACTIONS(704),
    [anon_sym_ref] = ACTIONS(704),
    [anon_sym_val] = ACTIONS(704),
    [anon_sym_box] = ACTIONS(704),
    [anon_sym_tag] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(706),
    [anon_sym_RPAREN] = ACTIONS(704),
    [anon_sym_DOT] = ACTIONS(706),
    [anon_sym_POUNDread] = ACTIONS(704),
    [anon_sym_POUNDsend] = ACTIONS(704),
    [anon_sym_POUNDshare] = ACTIONS(704),
    [anon_sym_POUNDalias] = ACTIONS(704),
    [anon_sym_POUNDany] = ACTIONS(704),
    [anon_sym_BANG] = ACTIONS(706),
    [anon_sym_CARET] = ACTIONS(704),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_DASH_GT] = ACTIONS(704),
    [anon_sym_LBRACE] = ACTIONS(704),
    [anon_sym_SEMI] = ACTIONS(704),
    [sym_error] = ACTIONS(704),
    [sym_compile_intrinsic] = ACTIONS(704),
    [anon_sym_compile_error] = ACTIONS(704),
    [sym_location] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(706),
    [anon_sym_not] = ACTIONS(704),
    [anon_sym_DASH_TILDE] = ACTIONS(704),
    [anon_sym_addressof] = ACTIONS(704),
    [anon_sym_digestof] = ACTIONS(704),
    [anon_sym_PLUS] = ACTIONS(706),
    [anon_sym_STAR] = ACTIONS(706),
    [anon_sym_SLASH] = ACTIONS(706),
    [anon_sym_PERCENT] = ACTIONS(706),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(706),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_GT_GT] = ACTIONS(706),
    [anon_sym_and] = ACTIONS(704),
    [anon_sym_or] = ACTIONS(704),
    [anon_sym_xor] = ACTIONS(704),
    [anon_sym_isnt] = ACTIONS(704),
    [anon_sym_EQ_EQ] = ACTIONS(706),
    [anon_sym_BANG_EQ] = ACTIONS(706),
    [anon_sym_GT] = ACTIONS(706),
    [anon_sym_GT_EQ] = ACTIONS(706),
    [anon_sym_LT_EQ] = ACTIONS(706),
    [anon_sym_LT] = ACTIONS(706),
    [anon_sym_PLUS_TILDE] = ACTIONS(704),
    [anon_sym_STAR_TILDE] = ACTIONS(704),
    [anon_sym_SLASH_TILDE] = ACTIONS(704),
    [anon_sym_PERCENT_TILDE] = ACTIONS(704),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(704),
    [anon_sym_LT_LT_TILDE] = ACTIONS(704),
    [anon_sym_GT_GT_TILDE] = ACTIONS(704),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(704),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(704),
    [anon_sym_GT_TILDE] = ACTIONS(704),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(704),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(704),
    [anon_sym_LT_TILDE] = ACTIONS(704),
    [anon_sym_PLUS_QMARK] = ACTIONS(704),
    [anon_sym_DASH_QMARK] = ACTIONS(704),
    [anon_sym_STAR_QMARK] = ACTIONS(704),
    [anon_sym_SLASH_QMARK] = ACTIONS(704),
    [anon_sym_PERCENT_QMARK] = ACTIONS(704),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(704),
    [anon_sym_as] = ACTIONS(704),
    [anon_sym_LPAREN2] = ACTIONS(704),
    [anon_sym_DOT_GT] = ACTIONS(704),
    [anon_sym_where] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_end] = ACTIONS(704),
    [anon_sym_if] = ACTIONS(706),
    [anon_sym_ifdef] = ACTIONS(704),
    [anon_sym_iftype] = ACTIONS(704),
    [anon_sym_else] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(704),
    [anon_sym_while] = ACTIONS(704),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_with] = ACTIONS(704),
    [anon_sym_repeat] = ACTIONS(704),
    [anon_sym_do] = ACTIONS(704),
    [anon_sym_recover] = ACTIONS(704),
    [anon_sym_match] = ACTIONS(704),
    [anon_sym_return] = ACTIONS(704),
    [anon_sym_continue] = ACTIONS(704),
    [anon_sym_break] = ACTIONS(704),
    [anon_sym_consume] = ACTIONS(704),
    [anon_sym_object] = ACTIONS(704),
    [sym_number] = ACTIONS(706),
    [sym_float] = ACTIONS(704),
    [anon_sym_DQUOTE] = ACTIONS(706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(704),
    [anon_sym_SQUOTE] = ACTIONS(704),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(704),
    [sym_this] = ACTIONS(704),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [73] = {
    [ts_builtin_sym_end] = ACTIONS(708),
    [sym_identifier] = ACTIONS(710),
    [anon_sym_use] = ACTIONS(708),
    [anon_sym_EQ] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(708),
    [anon_sym_LBRACK] = ACTIONS(708),
    [anon_sym_type] = ACTIONS(708),
    [anon_sym_is] = ACTIONS(710),
    [anon_sym_actor] = ACTIONS(708),
    [anon_sym_class] = ACTIONS(708),
    [anon_sym_primitive] = ACTIONS(708),
    [anon_sym_interface] = ACTIONS(708),
    [anon_sym_trait] = ACTIONS(708),
    [anon_sym_struct] = ACTIONS(708),
    [anon_sym_embed] = ACTIONS(708),
    [anon_sym_let] = ACTIONS(708),
    [anon_sym_var] = ACTIONS(708),
    [anon_sym_new] = ACTIONS(708),
    [anon_sym_fun] = ACTIONS(708),
    [anon_sym_be] = ACTIONS(708),
    [anon_sym_COMMA] = ACTIONS(708),
    [anon_sym_iso] = ACTIONS(708),
    [anon_sym_trn] = ACTIONS(708),
    [anon_sym_ref] = ACTIONS(708),
    [anon_sym_val] = ACTIONS(708),
    [anon_sym_box] = ACTIONS(708),
    [anon_sym_tag] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_RPAREN] = ACTIONS(708),
    [anon_sym_DOT] = ACTIONS(710),
    [anon_sym_POUNDread] = ACTIONS(708),
    [anon_sym_POUNDsend] = ACTIONS(708),
    [anon_sym_POUNDshare] = ACTIONS(708),
    [anon_sym_POUNDalias] = ACTIONS(708),
    [anon_sym_POUNDany] = ACTIONS(708),
    [anon_sym_BANG] = ACTIONS(710),
    [anon_sym_CARET] = ACTIONS(708),
    [anon_sym_PIPE] = ACTIONS(708),
    [anon_sym_AMP] = ACTIONS(708),
    [anon_sym_DASH_GT] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(708),
    [anon_sym_SEMI] = ACTIONS(708),
    [sym_error] = ACTIONS(708),
    [sym_compile_intrinsic] = ACTIONS(708),
    [anon_sym_compile_error] = ACTIONS(708),
    [sym_location] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_not] = ACTIONS(708),
    [anon_sym_DASH_TILDE] = ACTIONS(708),
    [anon_sym_addressof] = ACTIONS(708),
    [anon_sym_digestof] = ACTIONS(708),
    [anon_sym_PLUS] = ACTIONS(710),
    [anon_sym_STAR] = ACTIONS(710),
    [anon_sym_SLASH] = ACTIONS(710),
    [anon_sym_PERCENT] = ACTIONS(710),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(710),
    [anon_sym_LT_LT] = ACTIONS(710),
    [anon_sym_GT_GT] = ACTIONS(710),
    [anon_sym_and] = ACTIONS(708),
    [anon_sym_or] = ACTIONS(708),
    [anon_sym_xor] = ACTIONS(708),
    [anon_sym_isnt] = ACTIONS(708),
    [anon_sym_EQ_EQ] = ACTIONS(710),
    [anon_sym_BANG_EQ] = ACTIONS(710),
    [anon_sym_GT] = ACTIONS(710),
    [anon_sym_GT_EQ] = ACTIONS(710),
    [anon_sym_LT_EQ] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(710),
    [anon_sym_PLUS_TILDE] = ACTIONS(708),
    [anon_sym_STAR_TILDE] = ACTIONS(708),
    [anon_sym_SLASH_TILDE] = ACTIONS(708),
    [anon_sym_PERCENT_TILDE] = ACTIONS(708),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(708),
    [anon_sym_LT_LT_TILDE] = ACTIONS(708),
    [anon_sym_GT_GT_TILDE] = ACTIONS(708),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(708),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(708),
    [anon_sym_GT_TILDE] = ACTIONS(708),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(708),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(708),
    [anon_sym_LT_TILDE] = ACTIONS(708),
    [anon_sym_PLUS_QMARK] = ACTIONS(708),
    [anon_sym_DASH_QMARK] = ACTIONS(708),
    [anon_sym_STAR_QMARK] = ACTIONS(708),
    [anon_sym_SLASH_QMARK] = ACTIONS(708),
    [anon_sym_PERCENT_QMARK] = ACTIONS(708),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(708),
    [anon_sym_as] = ACTIONS(708),
    [anon_sym_LPAREN2] = ACTIONS(708),
    [anon_sym_DOT_GT] = ACTIONS(708),
    [anon_sym_where] = ACTIONS(708),
    [anon_sym_TILDE] = ACTIONS(708),
    [anon_sym_end] = ACTIONS(708),
    [anon_sym_if] = ACTIONS(710),
    [anon_sym_ifdef] = ACTIONS(708),
    [anon_sym_iftype] = ACTIONS(708),
    [anon_sym_else] = ACTIONS(708),
    [anon_sym_for] = ACTIONS(708),
    [anon_sym_while] = ACTIONS(708),
    [anon_sym_try] = ACTIONS(708),
    [anon_sym_with] = ACTIONS(708),
    [anon_sym_repeat] = ACTIONS(708),
    [anon_sym_do] = ACTIONS(708),
    [anon_sym_recover] = ACTIONS(708),
    [anon_sym_match] = ACTIONS(708),
    [anon_sym_return] = ACTIONS(708),
    [anon_sym_continue] = ACTIONS(708),
    [anon_sym_break] = ACTIONS(708),
    [anon_sym_consume] = ACTIONS(708),
    [anon_sym_object] = ACTIONS(708),
    [sym_number] = ACTIONS(710),
    [sym_float] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(708),
    [anon_sym_true] = ACTIONS(708),
    [anon_sym_false] = ACTIONS(708),
    [sym_this] = ACTIONS(708),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [74] = {
    [ts_builtin_sym_end] = ACTIONS(712),
    [sym_identifier] = ACTIONS(714),
    [anon_sym_use] = ACTIONS(712),
    [anon_sym_EQ] = ACTIONS(714),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_LBRACK] = ACTIONS(712),
    [anon_sym_type] = ACTIONS(712),
    [anon_sym_is] = ACTIONS(714),
    [anon_sym_actor] = ACTIONS(712),
    [anon_sym_class] = ACTIONS(712),
    [anon_sym_primitive] = ACTIONS(712),
    [anon_sym_interface] = ACTIONS(712),
    [anon_sym_trait] = ACTIONS(712),
    [anon_sym_struct] = ACTIONS(712),
    [anon_sym_embed] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(712),
    [anon_sym_var] = ACTIONS(712),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_fun] = ACTIONS(712),
    [anon_sym_be] = ACTIONS(712),
    [anon_sym_COMMA] = ACTIONS(712),
    [anon_sym_iso] = ACTIONS(712),
    [anon_sym_trn] = ACTIONS(712),
    [anon_sym_ref] = ACTIONS(712),
    [anon_sym_val] = ACTIONS(712),
    [anon_sym_box] = ACTIONS(712),
    [anon_sym_tag] = ACTIONS(712),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_RPAREN] = ACTIONS(712),
    [anon_sym_DOT] = ACTIONS(714),
    [anon_sym_POUNDread] = ACTIONS(712),
    [anon_sym_POUNDsend] = ACTIONS(712),
    [anon_sym_POUNDshare] = ACTIONS(712),
    [anon_sym_POUNDalias] = ACTIONS(712),
    [anon_sym_POUNDany] = ACTIONS(712),
    [anon_sym_BANG] = ACTIONS(714),
    [anon_sym_CARET] = ACTIONS(712),
    [anon_sym_PIPE] = ACTIONS(712),
    [anon_sym_AMP] = ACTIONS(712),
    [anon_sym_DASH_GT] = ACTIONS(712),
    [anon_sym_LBRACE] = ACTIONS(712),
    [anon_sym_SEMI] = ACTIONS(712),
    [sym_error] = ACTIONS(712),
    [sym_compile_intrinsic] = ACTIONS(712),
    [anon_sym_compile_error] = ACTIONS(712),
    [sym_location] = ACTIONS(712),
    [anon_sym_DASH] = ACTIONS(714),
    [anon_sym_not] = ACTIONS(712),
    [anon_sym_DASH_TILDE] = ACTIONS(712),
    [anon_sym_addressof] = ACTIONS(712),
    [anon_sym_digestof] = ACTIONS(712),
    [anon_sym_PLUS] = ACTIONS(714),
    [anon_sym_STAR] = ACTIONS(714),
    [anon_sym_SLASH] = ACTIONS(714),
    [anon_sym_PERCENT] = ACTIONS(714),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(714),
    [anon_sym_LT_LT] = ACTIONS(714),
    [anon_sym_GT_GT] = ACTIONS(714),
    [anon_sym_and] = ACTIONS(712),
    [anon_sym_or] = ACTIONS(712),
    [anon_sym_xor] = ACTIONS(712),
    [anon_sym_isnt] = ACTIONS(712),
    [anon_sym_EQ_EQ] = ACTIONS(714),
    [anon_sym_BANG_EQ] = ACTIONS(714),
    [anon_sym_GT] = ACTIONS(714),
    [anon_sym_GT_EQ] = ACTIONS(714),
    [anon_sym_LT_EQ] = ACTIONS(714),
    [anon_sym_LT] = ACTIONS(714),
    [anon_sym_PLUS_TILDE] = ACTIONS(712),
    [anon_sym_STAR_TILDE] = ACTIONS(712),
    [anon_sym_SLASH_TILDE] = ACTIONS(712),
    [anon_sym_PERCENT_TILDE] = ACTIONS(712),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(712),
    [anon_sym_LT_LT_TILDE] = ACTIONS(712),
    [anon_sym_GT_GT_TILDE] = ACTIONS(712),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(712),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(712),
    [anon_sym_GT_TILDE] = ACTIONS(712),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(712),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(712),
    [anon_sym_LT_TILDE] = ACTIONS(712),
    [anon_sym_PLUS_QMARK] = ACTIONS(712),
    [anon_sym_DASH_QMARK] = ACTIONS(712),
    [anon_sym_STAR_QMARK] = ACTIONS(712),
    [anon_sym_SLASH_QMARK] = ACTIONS(712),
    [anon_sym_PERCENT_QMARK] = ACTIONS(712),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(712),
    [anon_sym_as] = ACTIONS(712),
    [anon_sym_LPAREN2] = ACTIONS(712),
    [anon_sym_DOT_GT] = ACTIONS(712),
    [anon_sym_where] = ACTIONS(712),
    [anon_sym_TILDE] = ACTIONS(712),
    [anon_sym_end] = ACTIONS(712),
    [anon_sym_if] = ACTIONS(714),
    [anon_sym_ifdef] = ACTIONS(712),
    [anon_sym_iftype] = ACTIONS(712),
    [anon_sym_else] = ACTIONS(712),
    [anon_sym_for] = ACTIONS(712),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_try] = ACTIONS(712),
    [anon_sym_with] = ACTIONS(712),
    [anon_sym_repeat] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(712),
    [anon_sym_recover] = ACTIONS(712),
    [anon_sym_match] = ACTIONS(712),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_continue] = ACTIONS(712),
    [anon_sym_break] = ACTIONS(712),
    [anon_sym_consume] = ACTIONS(712),
    [anon_sym_object] = ACTIONS(712),
    [sym_number] = ACTIONS(714),
    [sym_float] = ACTIONS(712),
    [anon_sym_DQUOTE] = ACTIONS(714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [anon_sym_true] = ACTIONS(712),
    [anon_sym_false] = ACTIONS(712),
    [sym_this] = ACTIONS(712),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [75] = {
    [ts_builtin_sym_end] = ACTIONS(716),
    [sym_identifier] = ACTIONS(718),
    [anon_sym_use] = ACTIONS(716),
    [anon_sym_EQ] = ACTIONS(718),
    [anon_sym_AT] = ACTIONS(716),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_type] = ACTIONS(716),
    [anon_sym_is] = ACTIONS(718),
    [anon_sym_actor] = ACTIONS(716),
    [anon_sym_class] = ACTIONS(716),
    [anon_sym_primitive] = ACTIONS(716),
    [anon_sym_interface] = ACTIONS(716),
    [anon_sym_trait] = ACTIONS(716),
    [anon_sym_struct] = ACTIONS(716),
    [anon_sym_embed] = ACTIONS(716),
    [anon_sym_let] = ACTIONS(716),
    [anon_sym_var] = ACTIONS(716),
    [anon_sym_new] = ACTIONS(716),
    [anon_sym_fun] = ACTIONS(716),
    [anon_sym_be] = ACTIONS(716),
    [anon_sym_COMMA] = ACTIONS(716),
    [anon_sym_iso] = ACTIONS(716),
    [anon_sym_trn] = ACTIONS(716),
    [anon_sym_ref] = ACTIONS(716),
    [anon_sym_val] = ACTIONS(716),
    [anon_sym_box] = ACTIONS(716),
    [anon_sym_tag] = ACTIONS(716),
    [anon_sym_LPAREN] = ACTIONS(718),
    [anon_sym_RPAREN] = ACTIONS(716),
    [anon_sym_DOT] = ACTIONS(718),
    [anon_sym_POUNDread] = ACTIONS(716),
    [anon_sym_POUNDsend] = ACTIONS(716),
    [anon_sym_POUNDshare] = ACTIONS(716),
    [anon_sym_POUNDalias] = ACTIONS(716),
    [anon_sym_POUNDany] = ACTIONS(716),
    [anon_sym_BANG] = ACTIONS(718),
    [anon_sym_CARET] = ACTIONS(716),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_AMP] = ACTIONS(716),
    [anon_sym_DASH_GT] = ACTIONS(716),
    [anon_sym_LBRACE] = ACTIONS(716),
    [anon_sym_SEMI] = ACTIONS(716),
    [sym_error] = ACTIONS(716),
    [sym_compile_intrinsic] = ACTIONS(716),
    [anon_sym_compile_error] = ACTIONS(716),
    [sym_location] = ACTIONS(716),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_not] = ACTIONS(716),
    [anon_sym_DASH_TILDE] = ACTIONS(716),
    [anon_sym_addressof] = ACTIONS(716),
    [anon_sym_digestof] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_STAR] = ACTIONS(718),
    [anon_sym_SLASH] = ACTIONS(718),
    [anon_sym_PERCENT] = ACTIONS(718),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(718),
    [anon_sym_LT_LT] = ACTIONS(718),
    [anon_sym_GT_GT] = ACTIONS(718),
    [anon_sym_and] = ACTIONS(716),
    [anon_sym_or] = ACTIONS(716),
    [anon_sym_xor] = ACTIONS(716),
    [anon_sym_isnt] = ACTIONS(716),
    [anon_sym_EQ_EQ] = ACTIONS(718),
    [anon_sym_BANG_EQ] = ACTIONS(718),
    [anon_sym_GT] = ACTIONS(718),
    [anon_sym_GT_EQ] = ACTIONS(718),
    [anon_sym_LT_EQ] = ACTIONS(718),
    [anon_sym_LT] = ACTIONS(718),
    [anon_sym_PLUS_TILDE] = ACTIONS(716),
    [anon_sym_STAR_TILDE] = ACTIONS(716),
    [anon_sym_SLASH_TILDE] = ACTIONS(716),
    [anon_sym_PERCENT_TILDE] = ACTIONS(716),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(716),
    [anon_sym_LT_LT_TILDE] = ACTIONS(716),
    [anon_sym_GT_GT_TILDE] = ACTIONS(716),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(716),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(716),
    [anon_sym_GT_TILDE] = ACTIONS(716),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(716),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(716),
    [anon_sym_LT_TILDE] = ACTIONS(716),
    [anon_sym_PLUS_QMARK] = ACTIONS(716),
    [anon_sym_DASH_QMARK] = ACTIONS(716),
    [anon_sym_STAR_QMARK] = ACTIONS(716),
    [anon_sym_SLASH_QMARK] = ACTIONS(716),
    [anon_sym_PERCENT_QMARK] = ACTIONS(716),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(716),
    [anon_sym_as] = ACTIONS(716),
    [anon_sym_LPAREN2] = ACTIONS(716),
    [anon_sym_DOT_GT] = ACTIONS(716),
    [anon_sym_where] = ACTIONS(716),
    [anon_sym_TILDE] = ACTIONS(716),
    [anon_sym_end] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(718),
    [anon_sym_ifdef] = ACTIONS(716),
    [anon_sym_iftype] = ACTIONS(716),
    [anon_sym_else] = ACTIONS(716),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(716),
    [anon_sym_try] = ACTIONS(716),
    [anon_sym_with] = ACTIONS(716),
    [anon_sym_repeat] = ACTIONS(716),
    [anon_sym_do] = ACTIONS(716),
    [anon_sym_recover] = ACTIONS(716),
    [anon_sym_match] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(716),
    [anon_sym_continue] = ACTIONS(716),
    [anon_sym_break] = ACTIONS(716),
    [anon_sym_consume] = ACTIONS(716),
    [anon_sym_object] = ACTIONS(716),
    [sym_number] = ACTIONS(718),
    [sym_float] = ACTIONS(716),
    [anon_sym_DQUOTE] = ACTIONS(718),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(716),
    [anon_sym_SQUOTE] = ACTIONS(716),
    [anon_sym_true] = ACTIONS(716),
    [anon_sym_false] = ACTIONS(716),
    [sym_this] = ACTIONS(716),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [76] = {
    [ts_builtin_sym_end] = ACTIONS(720),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_use] = ACTIONS(720),
    [anon_sym_EQ] = ACTIONS(722),
    [anon_sym_AT] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(720),
    [anon_sym_type] = ACTIONS(720),
    [anon_sym_is] = ACTIONS(722),
    [anon_sym_actor] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(720),
    [anon_sym_primitive] = ACTIONS(720),
    [anon_sym_interface] = ACTIONS(720),
    [anon_sym_trait] = ACTIONS(720),
    [anon_sym_struct] = ACTIONS(720),
    [anon_sym_embed] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(720),
    [anon_sym_var] = ACTIONS(720),
    [anon_sym_new] = ACTIONS(720),
    [anon_sym_fun] = ACTIONS(720),
    [anon_sym_be] = ACTIONS(720),
    [anon_sym_COMMA] = ACTIONS(720),
    [anon_sym_iso] = ACTIONS(720),
    [anon_sym_trn] = ACTIONS(720),
    [anon_sym_ref] = ACTIONS(720),
    [anon_sym_val] = ACTIONS(720),
    [anon_sym_box] = ACTIONS(720),
    [anon_sym_tag] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(720),
    [anon_sym_DOT] = ACTIONS(722),
    [anon_sym_POUNDread] = ACTIONS(720),
    [anon_sym_POUNDsend] = ACTIONS(720),
    [anon_sym_POUNDshare] = ACTIONS(720),
    [anon_sym_POUNDalias] = ACTIONS(720),
    [anon_sym_POUNDany] = ACTIONS(720),
    [anon_sym_BANG] = ACTIONS(722),
    [anon_sym_CARET] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(720),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_DASH_GT] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(720),
    [sym_error] = ACTIONS(720),
    [sym_compile_intrinsic] = ACTIONS(720),
    [anon_sym_compile_error] = ACTIONS(720),
    [sym_location] = ACTIONS(720),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_not] = ACTIONS(720),
    [anon_sym_DASH_TILDE] = ACTIONS(720),
    [anon_sym_addressof] = ACTIONS(720),
    [anon_sym_digestof] = ACTIONS(720),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_STAR] = ACTIONS(722),
    [anon_sym_SLASH] = ACTIONS(722),
    [anon_sym_PERCENT] = ACTIONS(722),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(722),
    [anon_sym_LT_LT] = ACTIONS(722),
    [anon_sym_GT_GT] = ACTIONS(722),
    [anon_sym_and] = ACTIONS(720),
    [anon_sym_or] = ACTIONS(720),
    [anon_sym_xor] = ACTIONS(720),
    [anon_sym_isnt] = ACTIONS(720),
    [anon_sym_EQ_EQ] = ACTIONS(722),
    [anon_sym_BANG_EQ] = ACTIONS(722),
    [anon_sym_GT] = ACTIONS(722),
    [anon_sym_GT_EQ] = ACTIONS(722),
    [anon_sym_LT_EQ] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(722),
    [anon_sym_PLUS_TILDE] = ACTIONS(720),
    [anon_sym_STAR_TILDE] = ACTIONS(720),
    [anon_sym_SLASH_TILDE] = ACTIONS(720),
    [anon_sym_PERCENT_TILDE] = ACTIONS(720),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(720),
    [anon_sym_LT_LT_TILDE] = ACTIONS(720),
    [anon_sym_GT_GT_TILDE] = ACTIONS(720),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(720),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(720),
    [anon_sym_GT_TILDE] = ACTIONS(720),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(720),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(720),
    [anon_sym_LT_TILDE] = ACTIONS(720),
    [anon_sym_PLUS_QMARK] = ACTIONS(720),
    [anon_sym_DASH_QMARK] = ACTIONS(720),
    [anon_sym_STAR_QMARK] = ACTIONS(720),
    [anon_sym_SLASH_QMARK] = ACTIONS(720),
    [anon_sym_PERCENT_QMARK] = ACTIONS(720),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(720),
    [anon_sym_as] = ACTIONS(720),
    [anon_sym_LPAREN2] = ACTIONS(720),
    [anon_sym_DOT_GT] = ACTIONS(720),
    [anon_sym_where] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(720),
    [anon_sym_end] = ACTIONS(720),
    [anon_sym_if] = ACTIONS(722),
    [anon_sym_ifdef] = ACTIONS(720),
    [anon_sym_iftype] = ACTIONS(720),
    [anon_sym_else] = ACTIONS(720),
    [anon_sym_for] = ACTIONS(720),
    [anon_sym_while] = ACTIONS(720),
    [anon_sym_try] = ACTIONS(720),
    [anon_sym_with] = ACTIONS(720),
    [anon_sym_repeat] = ACTIONS(720),
    [anon_sym_do] = ACTIONS(720),
    [anon_sym_recover] = ACTIONS(720),
    [anon_sym_match] = ACTIONS(720),
    [anon_sym_return] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(720),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_consume] = ACTIONS(720),
    [anon_sym_object] = ACTIONS(720),
    [sym_number] = ACTIONS(722),
    [sym_float] = ACTIONS(720),
    [anon_sym_DQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_SQUOTE] = ACTIONS(720),
    [anon_sym_true] = ACTIONS(720),
    [anon_sym_false] = ACTIONS(720),
    [sym_this] = ACTIONS(720),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [77] = {
    [ts_builtin_sym_end] = ACTIONS(724),
    [sym_identifier] = ACTIONS(726),
    [anon_sym_use] = ACTIONS(724),
    [anon_sym_EQ] = ACTIONS(726),
    [anon_sym_AT] = ACTIONS(724),
    [anon_sym_LBRACK] = ACTIONS(724),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_is] = ACTIONS(726),
    [anon_sym_actor] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(724),
    [anon_sym_primitive] = ACTIONS(724),
    [anon_sym_interface] = ACTIONS(724),
    [anon_sym_trait] = ACTIONS(724),
    [anon_sym_struct] = ACTIONS(724),
    [anon_sym_embed] = ACTIONS(724),
    [anon_sym_let] = ACTIONS(724),
    [anon_sym_var] = ACTIONS(724),
    [anon_sym_new] = ACTIONS(724),
    [anon_sym_fun] = ACTIONS(724),
    [anon_sym_be] = ACTIONS(724),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_iso] = ACTIONS(724),
    [anon_sym_trn] = ACTIONS(724),
    [anon_sym_ref] = ACTIONS(724),
    [anon_sym_val] = ACTIONS(724),
    [anon_sym_box] = ACTIONS(724),
    [anon_sym_tag] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(726),
    [anon_sym_RPAREN] = ACTIONS(724),
    [anon_sym_DOT] = ACTIONS(726),
    [anon_sym_POUNDread] = ACTIONS(724),
    [anon_sym_POUNDsend] = ACTIONS(724),
    [anon_sym_POUNDshare] = ACTIONS(724),
    [anon_sym_POUNDalias] = ACTIONS(724),
    [anon_sym_POUNDany] = ACTIONS(724),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_CARET] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(724),
    [anon_sym_DASH_GT] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(724),
    [sym_error] = ACTIONS(724),
    [sym_compile_intrinsic] = ACTIONS(724),
    [anon_sym_compile_error] = ACTIONS(724),
    [sym_location] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(726),
    [anon_sym_not] = ACTIONS(724),
    [anon_sym_DASH_TILDE] = ACTIONS(724),
    [anon_sym_addressof] = ACTIONS(724),
    [anon_sym_digestof] = ACTIONS(724),
    [anon_sym_PLUS] = ACTIONS(726),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_SLASH] = ACTIONS(726),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(726),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_GT_GT] = ACTIONS(726),
    [anon_sym_and] = ACTIONS(724),
    [anon_sym_or] = ACTIONS(724),
    [anon_sym_xor] = ACTIONS(724),
    [anon_sym_isnt] = ACTIONS(724),
    [anon_sym_EQ_EQ] = ACTIONS(726),
    [anon_sym_BANG_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(726),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(726),
    [anon_sym_PLUS_TILDE] = ACTIONS(724),
    [anon_sym_STAR_TILDE] = ACTIONS(724),
    [anon_sym_SLASH_TILDE] = ACTIONS(724),
    [anon_sym_PERCENT_TILDE] = ACTIONS(724),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(724),
    [anon_sym_LT_LT_TILDE] = ACTIONS(724),
    [anon_sym_GT_GT_TILDE] = ACTIONS(724),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(724),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(724),
    [anon_sym_GT_TILDE] = ACTIONS(724),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(724),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(724),
    [anon_sym_LT_TILDE] = ACTIONS(724),
    [anon_sym_PLUS_QMARK] = ACTIONS(724),
    [anon_sym_DASH_QMARK] = ACTIONS(724),
    [anon_sym_STAR_QMARK] = ACTIONS(724),
    [anon_sym_SLASH_QMARK] = ACTIONS(724),
    [anon_sym_PERCENT_QMARK] = ACTIONS(724),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(724),
    [anon_sym_as] = ACTIONS(724),
    [anon_sym_LPAREN2] = ACTIONS(724),
    [anon_sym_DOT_GT] = ACTIONS(724),
    [anon_sym_where] = ACTIONS(724),
    [anon_sym_TILDE] = ACTIONS(724),
    [anon_sym_end] = ACTIONS(724),
    [anon_sym_if] = ACTIONS(726),
    [anon_sym_ifdef] = ACTIONS(724),
    [anon_sym_iftype] = ACTIONS(724),
    [anon_sym_else] = ACTIONS(724),
    [anon_sym_for] = ACTIONS(724),
    [anon_sym_while] = ACTIONS(724),
    [anon_sym_try] = ACTIONS(724),
    [anon_sym_with] = ACTIONS(724),
    [anon_sym_repeat] = ACTIONS(724),
    [anon_sym_do] = ACTIONS(724),
    [anon_sym_recover] = ACTIONS(724),
    [anon_sym_match] = ACTIONS(724),
    [anon_sym_return] = ACTIONS(724),
    [anon_sym_continue] = ACTIONS(724),
    [anon_sym_break] = ACTIONS(724),
    [anon_sym_consume] = ACTIONS(724),
    [anon_sym_object] = ACTIONS(724),
    [sym_number] = ACTIONS(726),
    [sym_float] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(724),
    [anon_sym_SQUOTE] = ACTIONS(724),
    [anon_sym_true] = ACTIONS(724),
    [anon_sym_false] = ACTIONS(724),
    [sym_this] = ACTIONS(724),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [78] = {
    [ts_builtin_sym_end] = ACTIONS(728),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_use] = ACTIONS(728),
    [anon_sym_EQ] = ACTIONS(730),
    [anon_sym_AT] = ACTIONS(728),
    [anon_sym_LBRACK] = ACTIONS(728),
    [anon_sym_type] = ACTIONS(728),
    [anon_sym_is] = ACTIONS(730),
    [anon_sym_actor] = ACTIONS(728),
    [anon_sym_class] = ACTIONS(728),
    [anon_sym_primitive] = ACTIONS(728),
    [anon_sym_interface] = ACTIONS(728),
    [anon_sym_trait] = ACTIONS(728),
    [anon_sym_struct] = ACTIONS(728),
    [anon_sym_embed] = ACTIONS(728),
    [anon_sym_let] = ACTIONS(728),
    [anon_sym_var] = ACTIONS(728),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_fun] = ACTIONS(728),
    [anon_sym_be] = ACTIONS(728),
    [anon_sym_COMMA] = ACTIONS(728),
    [anon_sym_iso] = ACTIONS(728),
    [anon_sym_trn] = ACTIONS(728),
    [anon_sym_ref] = ACTIONS(728),
    [anon_sym_val] = ACTIONS(728),
    [anon_sym_box] = ACTIONS(728),
    [anon_sym_tag] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(730),
    [anon_sym_RPAREN] = ACTIONS(728),
    [anon_sym_DOT] = ACTIONS(730),
    [anon_sym_POUNDread] = ACTIONS(728),
    [anon_sym_POUNDsend] = ACTIONS(728),
    [anon_sym_POUNDshare] = ACTIONS(728),
    [anon_sym_POUNDalias] = ACTIONS(728),
    [anon_sym_POUNDany] = ACTIONS(728),
    [anon_sym_BANG] = ACTIONS(730),
    [anon_sym_CARET] = ACTIONS(728),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_DASH_GT] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(728),
    [anon_sym_SEMI] = ACTIONS(728),
    [sym_error] = ACTIONS(728),
    [sym_compile_intrinsic] = ACTIONS(728),
    [anon_sym_compile_error] = ACTIONS(728),
    [sym_location] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(730),
    [anon_sym_not] = ACTIONS(728),
    [anon_sym_DASH_TILDE] = ACTIONS(728),
    [anon_sym_addressof] = ACTIONS(728),
    [anon_sym_digestof] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(730),
    [anon_sym_STAR] = ACTIONS(730),
    [anon_sym_SLASH] = ACTIONS(730),
    [anon_sym_PERCENT] = ACTIONS(730),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(730),
    [anon_sym_LT_LT] = ACTIONS(730),
    [anon_sym_GT_GT] = ACTIONS(730),
    [anon_sym_and] = ACTIONS(728),
    [anon_sym_or] = ACTIONS(728),
    [anon_sym_xor] = ACTIONS(728),
    [anon_sym_isnt] = ACTIONS(728),
    [anon_sym_EQ_EQ] = ACTIONS(730),
    [anon_sym_BANG_EQ] = ACTIONS(730),
    [anon_sym_GT] = ACTIONS(730),
    [anon_sym_GT_EQ] = ACTIONS(730),
    [anon_sym_LT_EQ] = ACTIONS(730),
    [anon_sym_LT] = ACTIONS(730),
    [anon_sym_PLUS_TILDE] = ACTIONS(728),
    [anon_sym_STAR_TILDE] = ACTIONS(728),
    [anon_sym_SLASH_TILDE] = ACTIONS(728),
    [anon_sym_PERCENT_TILDE] = ACTIONS(728),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(728),
    [anon_sym_LT_LT_TILDE] = ACTIONS(728),
    [anon_sym_GT_GT_TILDE] = ACTIONS(728),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(728),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(728),
    [anon_sym_GT_TILDE] = ACTIONS(728),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(728),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(728),
    [anon_sym_LT_TILDE] = ACTIONS(728),
    [anon_sym_PLUS_QMARK] = ACTIONS(728),
    [anon_sym_DASH_QMARK] = ACTIONS(728),
    [anon_sym_STAR_QMARK] = ACTIONS(728),
    [anon_sym_SLASH_QMARK] = ACTIONS(728),
    [anon_sym_PERCENT_QMARK] = ACTIONS(728),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(728),
    [anon_sym_as] = ACTIONS(728),
    [anon_sym_LPAREN2] = ACTIONS(728),
    [anon_sym_DOT_GT] = ACTIONS(728),
    [anon_sym_where] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_end] = ACTIONS(728),
    [anon_sym_if] = ACTIONS(730),
    [anon_sym_ifdef] = ACTIONS(728),
    [anon_sym_iftype] = ACTIONS(728),
    [anon_sym_else] = ACTIONS(728),
    [anon_sym_for] = ACTIONS(728),
    [anon_sym_while] = ACTIONS(728),
    [anon_sym_try] = ACTIONS(728),
    [anon_sym_with] = ACTIONS(728),
    [anon_sym_repeat] = ACTIONS(728),
    [anon_sym_do] = ACTIONS(728),
    [anon_sym_recover] = ACTIONS(728),
    [anon_sym_match] = ACTIONS(728),
    [anon_sym_return] = ACTIONS(728),
    [anon_sym_continue] = ACTIONS(728),
    [anon_sym_break] = ACTIONS(728),
    [anon_sym_consume] = ACTIONS(728),
    [anon_sym_object] = ACTIONS(728),
    [sym_number] = ACTIONS(730),
    [sym_float] = ACTIONS(728),
    [anon_sym_DQUOTE] = ACTIONS(730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(728),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_true] = ACTIONS(728),
    [anon_sym_false] = ACTIONS(728),
    [sym_this] = ACTIONS(728),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [79] = {
    [ts_builtin_sym_end] = ACTIONS(732),
    [sym_identifier] = ACTIONS(734),
    [anon_sym_use] = ACTIONS(732),
    [anon_sym_EQ] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_type] = ACTIONS(732),
    [anon_sym_is] = ACTIONS(734),
    [anon_sym_actor] = ACTIONS(732),
    [anon_sym_class] = ACTIONS(732),
    [anon_sym_primitive] = ACTIONS(732),
    [anon_sym_interface] = ACTIONS(732),
    [anon_sym_trait] = ACTIONS(732),
    [anon_sym_struct] = ACTIONS(732),
    [anon_sym_embed] = ACTIONS(732),
    [anon_sym_let] = ACTIONS(732),
    [anon_sym_var] = ACTIONS(732),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_fun] = ACTIONS(732),
    [anon_sym_be] = ACTIONS(732),
    [anon_sym_COMMA] = ACTIONS(732),
    [anon_sym_iso] = ACTIONS(732),
    [anon_sym_trn] = ACTIONS(732),
    [anon_sym_ref] = ACTIONS(732),
    [anon_sym_val] = ACTIONS(732),
    [anon_sym_box] = ACTIONS(732),
    [anon_sym_tag] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(734),
    [anon_sym_RPAREN] = ACTIONS(732),
    [anon_sym_DOT] = ACTIONS(734),
    [anon_sym_POUNDread] = ACTIONS(732),
    [anon_sym_POUNDsend] = ACTIONS(732),
    [anon_sym_POUNDshare] = ACTIONS(732),
    [anon_sym_POUNDalias] = ACTIONS(732),
    [anon_sym_POUNDany] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(734),
    [anon_sym_CARET] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(732),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_DASH_GT] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(732),
    [sym_error] = ACTIONS(732),
    [sym_compile_intrinsic] = ACTIONS(732),
    [anon_sym_compile_error] = ACTIONS(732),
    [sym_location] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(734),
    [anon_sym_not] = ACTIONS(732),
    [anon_sym_DASH_TILDE] = ACTIONS(732),
    [anon_sym_addressof] = ACTIONS(732),
    [anon_sym_digestof] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(734),
    [anon_sym_STAR] = ACTIONS(734),
    [anon_sym_SLASH] = ACTIONS(734),
    [anon_sym_PERCENT] = ACTIONS(734),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(734),
    [anon_sym_LT_LT] = ACTIONS(734),
    [anon_sym_GT_GT] = ACTIONS(734),
    [anon_sym_and] = ACTIONS(732),
    [anon_sym_or] = ACTIONS(732),
    [anon_sym_xor] = ACTIONS(732),
    [anon_sym_isnt] = ACTIONS(732),
    [anon_sym_EQ_EQ] = ACTIONS(734),
    [anon_sym_BANG_EQ] = ACTIONS(734),
    [anon_sym_GT] = ACTIONS(734),
    [anon_sym_GT_EQ] = ACTIONS(734),
    [anon_sym_LT_EQ] = ACTIONS(734),
    [anon_sym_LT] = ACTIONS(734),
    [anon_sym_PLUS_TILDE] = ACTIONS(732),
    [anon_sym_STAR_TILDE] = ACTIONS(732),
    [anon_sym_SLASH_TILDE] = ACTIONS(732),
    [anon_sym_PERCENT_TILDE] = ACTIONS(732),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(732),
    [anon_sym_LT_LT_TILDE] = ACTIONS(732),
    [anon_sym_GT_GT_TILDE] = ACTIONS(732),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(732),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(732),
    [anon_sym_GT_TILDE] = ACTIONS(732),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(732),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(732),
    [anon_sym_LT_TILDE] = ACTIONS(732),
    [anon_sym_PLUS_QMARK] = ACTIONS(732),
    [anon_sym_DASH_QMARK] = ACTIONS(732),
    [anon_sym_STAR_QMARK] = ACTIONS(732),
    [anon_sym_SLASH_QMARK] = ACTIONS(732),
    [anon_sym_PERCENT_QMARK] = ACTIONS(732),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(732),
    [anon_sym_as] = ACTIONS(732),
    [anon_sym_LPAREN2] = ACTIONS(732),
    [anon_sym_DOT_GT] = ACTIONS(732),
    [anon_sym_where] = ACTIONS(732),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_end] = ACTIONS(732),
    [anon_sym_if] = ACTIONS(734),
    [anon_sym_ifdef] = ACTIONS(732),
    [anon_sym_iftype] = ACTIONS(732),
    [anon_sym_else] = ACTIONS(732),
    [anon_sym_for] = ACTIONS(732),
    [anon_sym_while] = ACTIONS(732),
    [anon_sym_try] = ACTIONS(732),
    [anon_sym_with] = ACTIONS(732),
    [anon_sym_repeat] = ACTIONS(732),
    [anon_sym_do] = ACTIONS(732),
    [anon_sym_recover] = ACTIONS(732),
    [anon_sym_match] = ACTIONS(732),
    [anon_sym_return] = ACTIONS(732),
    [anon_sym_continue] = ACTIONS(732),
    [anon_sym_break] = ACTIONS(732),
    [anon_sym_consume] = ACTIONS(732),
    [anon_sym_object] = ACTIONS(732),
    [sym_number] = ACTIONS(734),
    [sym_float] = ACTIONS(732),
    [anon_sym_DQUOTE] = ACTIONS(734),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(732),
    [anon_sym_true] = ACTIONS(732),
    [anon_sym_false] = ACTIONS(732),
    [sym_this] = ACTIONS(732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [80] = {
    [ts_builtin_sym_end] = ACTIONS(736),
    [sym_identifier] = ACTIONS(738),
    [anon_sym_use] = ACTIONS(736),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(736),
    [anon_sym_type] = ACTIONS(736),
    [anon_sym_is] = ACTIONS(738),
    [anon_sym_actor] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(736),
    [anon_sym_primitive] = ACTIONS(736),
    [anon_sym_interface] = ACTIONS(736),
    [anon_sym_trait] = ACTIONS(736),
    [anon_sym_struct] = ACTIONS(736),
    [anon_sym_embed] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(736),
    [anon_sym_var] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(736),
    [anon_sym_fun] = ACTIONS(736),
    [anon_sym_be] = ACTIONS(736),
    [anon_sym_COMMA] = ACTIONS(736),
    [anon_sym_iso] = ACTIONS(736),
    [anon_sym_trn] = ACTIONS(736),
    [anon_sym_ref] = ACTIONS(736),
    [anon_sym_val] = ACTIONS(736),
    [anon_sym_box] = ACTIONS(736),
    [anon_sym_tag] = ACTIONS(736),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(736),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_POUNDread] = ACTIONS(736),
    [anon_sym_POUNDsend] = ACTIONS(736),
    [anon_sym_POUNDshare] = ACTIONS(736),
    [anon_sym_POUNDalias] = ACTIONS(736),
    [anon_sym_POUNDany] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(738),
    [anon_sym_CARET] = ACTIONS(736),
    [anon_sym_PIPE] = ACTIONS(736),
    [anon_sym_AMP] = ACTIONS(736),
    [anon_sym_DASH_GT] = ACTIONS(736),
    [anon_sym_LBRACE] = ACTIONS(736),
    [anon_sym_SEMI] = ACTIONS(736),
    [sym_error] = ACTIONS(736),
    [sym_compile_intrinsic] = ACTIONS(736),
    [anon_sym_compile_error] = ACTIONS(736),
    [sym_location] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_not] = ACTIONS(736),
    [anon_sym_DASH_TILDE] = ACTIONS(736),
    [anon_sym_addressof] = ACTIONS(736),
    [anon_sym_digestof] = ACTIONS(736),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(738),
    [anon_sym_LT_LT] = ACTIONS(738),
    [anon_sym_GT_GT] = ACTIONS(738),
    [anon_sym_and] = ACTIONS(736),
    [anon_sym_or] = ACTIONS(736),
    [anon_sym_xor] = ACTIONS(736),
    [anon_sym_isnt] = ACTIONS(736),
    [anon_sym_EQ_EQ] = ACTIONS(738),
    [anon_sym_BANG_EQ] = ACTIONS(738),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_EQ] = ACTIONS(738),
    [anon_sym_LT] = ACTIONS(738),
    [anon_sym_PLUS_TILDE] = ACTIONS(736),
    [anon_sym_STAR_TILDE] = ACTIONS(736),
    [anon_sym_SLASH_TILDE] = ACTIONS(736),
    [anon_sym_PERCENT_TILDE] = ACTIONS(736),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(736),
    [anon_sym_LT_LT_TILDE] = ACTIONS(736),
    [anon_sym_GT_GT_TILDE] = ACTIONS(736),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(736),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(736),
    [anon_sym_GT_TILDE] = ACTIONS(736),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(736),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(736),
    [anon_sym_LT_TILDE] = ACTIONS(736),
    [anon_sym_PLUS_QMARK] = ACTIONS(736),
    [anon_sym_DASH_QMARK] = ACTIONS(736),
    [anon_sym_STAR_QMARK] = ACTIONS(736),
    [anon_sym_SLASH_QMARK] = ACTIONS(736),
    [anon_sym_PERCENT_QMARK] = ACTIONS(736),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(736),
    [anon_sym_as] = ACTIONS(736),
    [anon_sym_LPAREN2] = ACTIONS(736),
    [anon_sym_DOT_GT] = ACTIONS(736),
    [anon_sym_where] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_end] = ACTIONS(736),
    [anon_sym_if] = ACTIONS(738),
    [anon_sym_ifdef] = ACTIONS(736),
    [anon_sym_iftype] = ACTIONS(736),
    [anon_sym_else] = ACTIONS(736),
    [anon_sym_for] = ACTIONS(736),
    [anon_sym_while] = ACTIONS(736),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_with] = ACTIONS(736),
    [anon_sym_repeat] = ACTIONS(736),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_recover] = ACTIONS(736),
    [anon_sym_match] = ACTIONS(736),
    [anon_sym_return] = ACTIONS(736),
    [anon_sym_continue] = ACTIONS(736),
    [anon_sym_break] = ACTIONS(736),
    [anon_sym_consume] = ACTIONS(736),
    [anon_sym_object] = ACTIONS(736),
    [sym_number] = ACTIONS(738),
    [sym_float] = ACTIONS(736),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(736),
    [anon_sym_SQUOTE] = ACTIONS(736),
    [anon_sym_true] = ACTIONS(736),
    [anon_sym_false] = ACTIONS(736),
    [sym_this] = ACTIONS(736),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [81] = {
    [ts_builtin_sym_end] = ACTIONS(740),
    [sym_identifier] = ACTIONS(742),
    [anon_sym_use] = ACTIONS(740),
    [anon_sym_EQ] = ACTIONS(742),
    [anon_sym_AT] = ACTIONS(740),
    [anon_sym_LBRACK] = ACTIONS(740),
    [anon_sym_type] = ACTIONS(740),
    [anon_sym_is] = ACTIONS(742),
    [anon_sym_actor] = ACTIONS(740),
    [anon_sym_class] = ACTIONS(740),
    [anon_sym_primitive] = ACTIONS(740),
    [anon_sym_interface] = ACTIONS(740),
    [anon_sym_trait] = ACTIONS(740),
    [anon_sym_struct] = ACTIONS(740),
    [anon_sym_embed] = ACTIONS(740),
    [anon_sym_let] = ACTIONS(740),
    [anon_sym_var] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_fun] = ACTIONS(740),
    [anon_sym_be] = ACTIONS(740),
    [anon_sym_COMMA] = ACTIONS(740),
    [anon_sym_iso] = ACTIONS(740),
    [anon_sym_trn] = ACTIONS(740),
    [anon_sym_ref] = ACTIONS(740),
    [anon_sym_val] = ACTIONS(740),
    [anon_sym_box] = ACTIONS(740),
    [anon_sym_tag] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(742),
    [anon_sym_RPAREN] = ACTIONS(740),
    [anon_sym_DOT] = ACTIONS(742),
    [anon_sym_POUNDread] = ACTIONS(740),
    [anon_sym_POUNDsend] = ACTIONS(740),
    [anon_sym_POUNDshare] = ACTIONS(740),
    [anon_sym_POUNDalias] = ACTIONS(740),
    [anon_sym_POUNDany] = ACTIONS(740),
    [anon_sym_BANG] = ACTIONS(742),
    [anon_sym_CARET] = ACTIONS(740),
    [anon_sym_PIPE] = ACTIONS(740),
    [anon_sym_AMP] = ACTIONS(740),
    [anon_sym_DASH_GT] = ACTIONS(740),
    [anon_sym_LBRACE] = ACTIONS(740),
    [anon_sym_SEMI] = ACTIONS(740),
    [sym_error] = ACTIONS(740),
    [sym_compile_intrinsic] = ACTIONS(740),
    [anon_sym_compile_error] = ACTIONS(740),
    [sym_location] = ACTIONS(740),
    [anon_sym_DASH] = ACTIONS(742),
    [anon_sym_not] = ACTIONS(740),
    [anon_sym_DASH_TILDE] = ACTIONS(740),
    [anon_sym_addressof] = ACTIONS(740),
    [anon_sym_digestof] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(742),
    [anon_sym_STAR] = ACTIONS(742),
    [anon_sym_SLASH] = ACTIONS(742),
    [anon_sym_PERCENT] = ACTIONS(742),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(742),
    [anon_sym_LT_LT] = ACTIONS(742),
    [anon_sym_GT_GT] = ACTIONS(742),
    [anon_sym_and] = ACTIONS(740),
    [anon_sym_or] = ACTIONS(740),
    [anon_sym_xor] = ACTIONS(740),
    [anon_sym_isnt] = ACTIONS(740),
    [anon_sym_EQ_EQ] = ACTIONS(742),
    [anon_sym_BANG_EQ] = ACTIONS(742),
    [anon_sym_GT] = ACTIONS(742),
    [anon_sym_GT_EQ] = ACTIONS(742),
    [anon_sym_LT_EQ] = ACTIONS(742),
    [anon_sym_LT] = ACTIONS(742),
    [anon_sym_PLUS_TILDE] = ACTIONS(740),
    [anon_sym_STAR_TILDE] = ACTIONS(740),
    [anon_sym_SLASH_TILDE] = ACTIONS(740),
    [anon_sym_PERCENT_TILDE] = ACTIONS(740),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(740),
    [anon_sym_LT_LT_TILDE] = ACTIONS(740),
    [anon_sym_GT_GT_TILDE] = ACTIONS(740),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(740),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(740),
    [anon_sym_GT_TILDE] = ACTIONS(740),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(740),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(740),
    [anon_sym_LT_TILDE] = ACTIONS(740),
    [anon_sym_PLUS_QMARK] = ACTIONS(740),
    [anon_sym_DASH_QMARK] = ACTIONS(740),
    [anon_sym_STAR_QMARK] = ACTIONS(740),
    [anon_sym_SLASH_QMARK] = ACTIONS(740),
    [anon_sym_PERCENT_QMARK] = ACTIONS(740),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(740),
    [anon_sym_as] = ACTIONS(740),
    [anon_sym_LPAREN2] = ACTIONS(740),
    [anon_sym_DOT_GT] = ACTIONS(740),
    [anon_sym_where] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_end] = ACTIONS(740),
    [anon_sym_if] = ACTIONS(742),
    [anon_sym_ifdef] = ACTIONS(740),
    [anon_sym_iftype] = ACTIONS(740),
    [anon_sym_else] = ACTIONS(740),
    [anon_sym_for] = ACTIONS(740),
    [anon_sym_while] = ACTIONS(740),
    [anon_sym_try] = ACTIONS(740),
    [anon_sym_with] = ACTIONS(740),
    [anon_sym_repeat] = ACTIONS(740),
    [anon_sym_do] = ACTIONS(740),
    [anon_sym_recover] = ACTIONS(740),
    [anon_sym_match] = ACTIONS(740),
    [anon_sym_return] = ACTIONS(740),
    [anon_sym_continue] = ACTIONS(740),
    [anon_sym_break] = ACTIONS(740),
    [anon_sym_consume] = ACTIONS(740),
    [anon_sym_object] = ACTIONS(740),
    [sym_number] = ACTIONS(742),
    [sym_float] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(740),
    [anon_sym_SQUOTE] = ACTIONS(740),
    [anon_sym_true] = ACTIONS(740),
    [anon_sym_false] = ACTIONS(740),
    [sym_this] = ACTIONS(740),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [82] = {
    [ts_builtin_sym_end] = ACTIONS(744),
    [sym_identifier] = ACTIONS(746),
    [anon_sym_use] = ACTIONS(744),
    [anon_sym_EQ] = ACTIONS(746),
    [anon_sym_AT] = ACTIONS(744),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_type] = ACTIONS(744),
    [anon_sym_is] = ACTIONS(746),
    [anon_sym_actor] = ACTIONS(744),
    [anon_sym_class] = ACTIONS(744),
    [anon_sym_primitive] = ACTIONS(744),
    [anon_sym_interface] = ACTIONS(744),
    [anon_sym_trait] = ACTIONS(744),
    [anon_sym_struct] = ACTIONS(744),
    [anon_sym_embed] = ACTIONS(744),
    [anon_sym_let] = ACTIONS(744),
    [anon_sym_var] = ACTIONS(744),
    [anon_sym_new] = ACTIONS(744),
    [anon_sym_fun] = ACTIONS(744),
    [anon_sym_be] = ACTIONS(744),
    [anon_sym_COMMA] = ACTIONS(744),
    [anon_sym_iso] = ACTIONS(744),
    [anon_sym_trn] = ACTIONS(744),
    [anon_sym_ref] = ACTIONS(744),
    [anon_sym_val] = ACTIONS(744),
    [anon_sym_box] = ACTIONS(744),
    [anon_sym_tag] = ACTIONS(744),
    [anon_sym_LPAREN] = ACTIONS(746),
    [anon_sym_RPAREN] = ACTIONS(744),
    [anon_sym_DOT] = ACTIONS(746),
    [anon_sym_POUNDread] = ACTIONS(744),
    [anon_sym_POUNDsend] = ACTIONS(744),
    [anon_sym_POUNDshare] = ACTIONS(744),
    [anon_sym_POUNDalias] = ACTIONS(744),
    [anon_sym_POUNDany] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_CARET] = ACTIONS(744),
    [anon_sym_PIPE] = ACTIONS(744),
    [anon_sym_AMP] = ACTIONS(744),
    [anon_sym_DASH_GT] = ACTIONS(744),
    [anon_sym_LBRACE] = ACTIONS(744),
    [anon_sym_SEMI] = ACTIONS(744),
    [sym_error] = ACTIONS(744),
    [sym_compile_intrinsic] = ACTIONS(744),
    [anon_sym_compile_error] = ACTIONS(744),
    [sym_location] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_not] = ACTIONS(744),
    [anon_sym_DASH_TILDE] = ACTIONS(744),
    [anon_sym_addressof] = ACTIONS(744),
    [anon_sym_digestof] = ACTIONS(744),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(746),
    [anon_sym_SLASH] = ACTIONS(746),
    [anon_sym_PERCENT] = ACTIONS(746),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(746),
    [anon_sym_LT_LT] = ACTIONS(746),
    [anon_sym_GT_GT] = ACTIONS(746),
    [anon_sym_and] = ACTIONS(744),
    [anon_sym_or] = ACTIONS(744),
    [anon_sym_xor] = ACTIONS(744),
    [anon_sym_isnt] = ACTIONS(744),
    [anon_sym_EQ_EQ] = ACTIONS(746),
    [anon_sym_BANG_EQ] = ACTIONS(746),
    [anon_sym_GT] = ACTIONS(746),
    [anon_sym_GT_EQ] = ACTIONS(746),
    [anon_sym_LT_EQ] = ACTIONS(746),
    [anon_sym_LT] = ACTIONS(746),
    [anon_sym_PLUS_TILDE] = ACTIONS(744),
    [anon_sym_STAR_TILDE] = ACTIONS(744),
    [anon_sym_SLASH_TILDE] = ACTIONS(744),
    [anon_sym_PERCENT_TILDE] = ACTIONS(744),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(744),
    [anon_sym_LT_LT_TILDE] = ACTIONS(744),
    [anon_sym_GT_GT_TILDE] = ACTIONS(744),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(744),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(744),
    [anon_sym_GT_TILDE] = ACTIONS(744),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(744),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(744),
    [anon_sym_LT_TILDE] = ACTIONS(744),
    [anon_sym_PLUS_QMARK] = ACTIONS(744),
    [anon_sym_DASH_QMARK] = ACTIONS(744),
    [anon_sym_STAR_QMARK] = ACTIONS(744),
    [anon_sym_SLASH_QMARK] = ACTIONS(744),
    [anon_sym_PERCENT_QMARK] = ACTIONS(744),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(744),
    [anon_sym_as] = ACTIONS(744),
    [anon_sym_LPAREN2] = ACTIONS(744),
    [anon_sym_DOT_GT] = ACTIONS(744),
    [anon_sym_where] = ACTIONS(744),
    [anon_sym_TILDE] = ACTIONS(744),
    [anon_sym_end] = ACTIONS(744),
    [anon_sym_if] = ACTIONS(746),
    [anon_sym_ifdef] = ACTIONS(744),
    [anon_sym_iftype] = ACTIONS(744),
    [anon_sym_else] = ACTIONS(744),
    [anon_sym_for] = ACTIONS(744),
    [anon_sym_while] = ACTIONS(744),
    [anon_sym_try] = ACTIONS(744),
    [anon_sym_with] = ACTIONS(744),
    [anon_sym_repeat] = ACTIONS(744),
    [anon_sym_do] = ACTIONS(744),
    [anon_sym_recover] = ACTIONS(744),
    [anon_sym_match] = ACTIONS(744),
    [anon_sym_return] = ACTIONS(744),
    [anon_sym_continue] = ACTIONS(744),
    [anon_sym_break] = ACTIONS(744),
    [anon_sym_consume] = ACTIONS(744),
    [anon_sym_object] = ACTIONS(744),
    [sym_number] = ACTIONS(746),
    [sym_float] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(744),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [anon_sym_true] = ACTIONS(744),
    [anon_sym_false] = ACTIONS(744),
    [sym_this] = ACTIONS(744),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [83] = {
    [ts_builtin_sym_end] = ACTIONS(748),
    [sym_identifier] = ACTIONS(750),
    [anon_sym_use] = ACTIONS(748),
    [anon_sym_EQ] = ACTIONS(750),
    [anon_sym_AT] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(748),
    [anon_sym_type] = ACTIONS(748),
    [anon_sym_is] = ACTIONS(750),
    [anon_sym_actor] = ACTIONS(748),
    [anon_sym_class] = ACTIONS(748),
    [anon_sym_primitive] = ACTIONS(748),
    [anon_sym_interface] = ACTIONS(748),
    [anon_sym_trait] = ACTIONS(748),
    [anon_sym_struct] = ACTIONS(748),
    [anon_sym_embed] = ACTIONS(748),
    [anon_sym_let] = ACTIONS(748),
    [anon_sym_var] = ACTIONS(748),
    [anon_sym_new] = ACTIONS(748),
    [anon_sym_fun] = ACTIONS(748),
    [anon_sym_be] = ACTIONS(748),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_iso] = ACTIONS(748),
    [anon_sym_trn] = ACTIONS(748),
    [anon_sym_ref] = ACTIONS(748),
    [anon_sym_val] = ACTIONS(748),
    [anon_sym_box] = ACTIONS(748),
    [anon_sym_tag] = ACTIONS(748),
    [anon_sym_LPAREN] = ACTIONS(750),
    [anon_sym_RPAREN] = ACTIONS(748),
    [anon_sym_DOT] = ACTIONS(750),
    [anon_sym_POUNDread] = ACTIONS(748),
    [anon_sym_POUNDsend] = ACTIONS(748),
    [anon_sym_POUNDshare] = ACTIONS(748),
    [anon_sym_POUNDalias] = ACTIONS(748),
    [anon_sym_POUNDany] = ACTIONS(748),
    [anon_sym_BANG] = ACTIONS(750),
    [anon_sym_CARET] = ACTIONS(748),
    [anon_sym_PIPE] = ACTIONS(748),
    [anon_sym_AMP] = ACTIONS(748),
    [anon_sym_DASH_GT] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_SEMI] = ACTIONS(748),
    [sym_error] = ACTIONS(748),
    [sym_compile_intrinsic] = ACTIONS(748),
    [anon_sym_compile_error] = ACTIONS(748),
    [sym_location] = ACTIONS(748),
    [anon_sym_DASH] = ACTIONS(750),
    [anon_sym_not] = ACTIONS(748),
    [anon_sym_DASH_TILDE] = ACTIONS(748),
    [anon_sym_addressof] = ACTIONS(748),
    [anon_sym_digestof] = ACTIONS(748),
    [anon_sym_PLUS] = ACTIONS(750),
    [anon_sym_STAR] = ACTIONS(750),
    [anon_sym_SLASH] = ACTIONS(750),
    [anon_sym_PERCENT] = ACTIONS(750),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(750),
    [anon_sym_LT_LT] = ACTIONS(750),
    [anon_sym_GT_GT] = ACTIONS(750),
    [anon_sym_and] = ACTIONS(748),
    [anon_sym_or] = ACTIONS(748),
    [anon_sym_xor] = ACTIONS(748),
    [anon_sym_isnt] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(750),
    [anon_sym_BANG_EQ] = ACTIONS(750),
    [anon_sym_GT] = ACTIONS(750),
    [anon_sym_GT_EQ] = ACTIONS(750),
    [anon_sym_LT_EQ] = ACTIONS(750),
    [anon_sym_LT] = ACTIONS(750),
    [anon_sym_PLUS_TILDE] = ACTIONS(748),
    [anon_sym_STAR_TILDE] = ACTIONS(748),
    [anon_sym_SLASH_TILDE] = ACTIONS(748),
    [anon_sym_PERCENT_TILDE] = ACTIONS(748),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(748),
    [anon_sym_LT_LT_TILDE] = ACTIONS(748),
    [anon_sym_GT_GT_TILDE] = ACTIONS(748),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(748),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(748),
    [anon_sym_GT_TILDE] = ACTIONS(748),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(748),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(748),
    [anon_sym_LT_TILDE] = ACTIONS(748),
    [anon_sym_PLUS_QMARK] = ACTIONS(748),
    [anon_sym_DASH_QMARK] = ACTIONS(748),
    [anon_sym_STAR_QMARK] = ACTIONS(748),
    [anon_sym_SLASH_QMARK] = ACTIONS(748),
    [anon_sym_PERCENT_QMARK] = ACTIONS(748),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(748),
    [anon_sym_LPAREN2] = ACTIONS(748),
    [anon_sym_DOT_GT] = ACTIONS(748),
    [anon_sym_where] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_end] = ACTIONS(748),
    [anon_sym_if] = ACTIONS(750),
    [anon_sym_ifdef] = ACTIONS(748),
    [anon_sym_iftype] = ACTIONS(748),
    [anon_sym_else] = ACTIONS(748),
    [anon_sym_for] = ACTIONS(748),
    [anon_sym_while] = ACTIONS(748),
    [anon_sym_try] = ACTIONS(748),
    [anon_sym_with] = ACTIONS(748),
    [anon_sym_repeat] = ACTIONS(748),
    [anon_sym_do] = ACTIONS(748),
    [anon_sym_recover] = ACTIONS(748),
    [anon_sym_match] = ACTIONS(748),
    [anon_sym_return] = ACTIONS(748),
    [anon_sym_continue] = ACTIONS(748),
    [anon_sym_break] = ACTIONS(748),
    [anon_sym_consume] = ACTIONS(748),
    [anon_sym_object] = ACTIONS(748),
    [sym_number] = ACTIONS(750),
    [sym_float] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(748),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [anon_sym_true] = ACTIONS(748),
    [anon_sym_false] = ACTIONS(748),
    [sym_this] = ACTIONS(748),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [84] = {
    [ts_builtin_sym_end] = ACTIONS(752),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_use] = ACTIONS(752),
    [anon_sym_EQ] = ACTIONS(754),
    [anon_sym_AT] = ACTIONS(752),
    [anon_sym_LBRACK] = ACTIONS(752),
    [anon_sym_type] = ACTIONS(752),
    [anon_sym_is] = ACTIONS(754),
    [anon_sym_actor] = ACTIONS(752),
    [anon_sym_class] = ACTIONS(752),
    [anon_sym_primitive] = ACTIONS(752),
    [anon_sym_interface] = ACTIONS(752),
    [anon_sym_trait] = ACTIONS(752),
    [anon_sym_struct] = ACTIONS(752),
    [anon_sym_embed] = ACTIONS(752),
    [anon_sym_let] = ACTIONS(752),
    [anon_sym_var] = ACTIONS(752),
    [anon_sym_new] = ACTIONS(752),
    [anon_sym_fun] = ACTIONS(752),
    [anon_sym_be] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(752),
    [anon_sym_iso] = ACTIONS(752),
    [anon_sym_trn] = ACTIONS(752),
    [anon_sym_ref] = ACTIONS(752),
    [anon_sym_val] = ACTIONS(752),
    [anon_sym_box] = ACTIONS(752),
    [anon_sym_tag] = ACTIONS(752),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_RPAREN] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_POUNDread] = ACTIONS(752),
    [anon_sym_POUNDsend] = ACTIONS(752),
    [anon_sym_POUNDshare] = ACTIONS(752),
    [anon_sym_POUNDalias] = ACTIONS(752),
    [anon_sym_POUNDany] = ACTIONS(752),
    [anon_sym_BANG] = ACTIONS(754),
    [anon_sym_CARET] = ACTIONS(752),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_AMP] = ACTIONS(752),
    [anon_sym_DASH_GT] = ACTIONS(752),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_SEMI] = ACTIONS(752),
    [sym_error] = ACTIONS(752),
    [sym_compile_intrinsic] = ACTIONS(752),
    [anon_sym_compile_error] = ACTIONS(752),
    [sym_location] = ACTIONS(752),
    [anon_sym_DASH] = ACTIONS(754),
    [anon_sym_not] = ACTIONS(752),
    [anon_sym_DASH_TILDE] = ACTIONS(752),
    [anon_sym_addressof] = ACTIONS(752),
    [anon_sym_digestof] = ACTIONS(752),
    [anon_sym_PLUS] = ACTIONS(754),
    [anon_sym_STAR] = ACTIONS(754),
    [anon_sym_SLASH] = ACTIONS(754),
    [anon_sym_PERCENT] = ACTIONS(754),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(754),
    [anon_sym_LT_LT] = ACTIONS(754),
    [anon_sym_GT_GT] = ACTIONS(754),
    [anon_sym_and] = ACTIONS(752),
    [anon_sym_or] = ACTIONS(752),
    [anon_sym_xor] = ACTIONS(752),
    [anon_sym_isnt] = ACTIONS(752),
    [anon_sym_EQ_EQ] = ACTIONS(754),
    [anon_sym_BANG_EQ] = ACTIONS(754),
    [anon_sym_GT] = ACTIONS(754),
    [anon_sym_GT_EQ] = ACTIONS(754),
    [anon_sym_LT_EQ] = ACTIONS(754),
    [anon_sym_LT] = ACTIONS(754),
    [anon_sym_PLUS_TILDE] = ACTIONS(752),
    [anon_sym_STAR_TILDE] = ACTIONS(752),
    [anon_sym_SLASH_TILDE] = ACTIONS(752),
    [anon_sym_PERCENT_TILDE] = ACTIONS(752),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(752),
    [anon_sym_LT_LT_TILDE] = ACTIONS(752),
    [anon_sym_GT_GT_TILDE] = ACTIONS(752),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(752),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(752),
    [anon_sym_GT_TILDE] = ACTIONS(752),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(752),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(752),
    [anon_sym_LT_TILDE] = ACTIONS(752),
    [anon_sym_PLUS_QMARK] = ACTIONS(752),
    [anon_sym_DASH_QMARK] = ACTIONS(752),
    [anon_sym_STAR_QMARK] = ACTIONS(752),
    [anon_sym_SLASH_QMARK] = ACTIONS(752),
    [anon_sym_PERCENT_QMARK] = ACTIONS(752),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(752),
    [anon_sym_as] = ACTIONS(752),
    [anon_sym_LPAREN2] = ACTIONS(752),
    [anon_sym_DOT_GT] = ACTIONS(752),
    [anon_sym_where] = ACTIONS(752),
    [anon_sym_TILDE] = ACTIONS(752),
    [anon_sym_end] = ACTIONS(752),
    [anon_sym_if] = ACTIONS(754),
    [anon_sym_ifdef] = ACTIONS(752),
    [anon_sym_iftype] = ACTIONS(752),
    [anon_sym_else] = ACTIONS(752),
    [anon_sym_for] = ACTIONS(752),
    [anon_sym_while] = ACTIONS(752),
    [anon_sym_try] = ACTIONS(752),
    [anon_sym_with] = ACTIONS(752),
    [anon_sym_repeat] = ACTIONS(752),
    [anon_sym_do] = ACTIONS(752),
    [anon_sym_recover] = ACTIONS(752),
    [anon_sym_match] = ACTIONS(752),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_continue] = ACTIONS(752),
    [anon_sym_break] = ACTIONS(752),
    [anon_sym_consume] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [sym_number] = ACTIONS(754),
    [sym_float] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(754),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(752),
    [anon_sym_true] = ACTIONS(752),
    [anon_sym_false] = ACTIONS(752),
    [sym_this] = ACTIONS(752),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [85] = {
    [ts_builtin_sym_end] = ACTIONS(756),
    [sym_identifier] = ACTIONS(758),
    [anon_sym_use] = ACTIONS(756),
    [anon_sym_EQ] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(756),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_is] = ACTIONS(758),
    [anon_sym_actor] = ACTIONS(756),
    [anon_sym_class] = ACTIONS(756),
    [anon_sym_primitive] = ACTIONS(756),
    [anon_sym_interface] = ACTIONS(756),
    [anon_sym_trait] = ACTIONS(756),
    [anon_sym_struct] = ACTIONS(756),
    [anon_sym_embed] = ACTIONS(756),
    [anon_sym_let] = ACTIONS(756),
    [anon_sym_var] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(756),
    [anon_sym_fun] = ACTIONS(756),
    [anon_sym_be] = ACTIONS(756),
    [anon_sym_COMMA] = ACTIONS(756),
    [anon_sym_iso] = ACTIONS(756),
    [anon_sym_trn] = ACTIONS(756),
    [anon_sym_ref] = ACTIONS(756),
    [anon_sym_val] = ACTIONS(756),
    [anon_sym_box] = ACTIONS(756),
    [anon_sym_tag] = ACTIONS(756),
    [anon_sym_LPAREN] = ACTIONS(758),
    [anon_sym_RPAREN] = ACTIONS(756),
    [anon_sym_DOT] = ACTIONS(758),
    [anon_sym_POUNDread] = ACTIONS(756),
    [anon_sym_POUNDsend] = ACTIONS(756),
    [anon_sym_POUNDshare] = ACTIONS(756),
    [anon_sym_POUNDalias] = ACTIONS(756),
    [anon_sym_POUNDany] = ACTIONS(756),
    [anon_sym_BANG] = ACTIONS(758),
    [anon_sym_CARET] = ACTIONS(756),
    [anon_sym_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(756),
    [anon_sym_DASH_GT] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_SEMI] = ACTIONS(756),
    [sym_error] = ACTIONS(756),
    [sym_compile_intrinsic] = ACTIONS(756),
    [anon_sym_compile_error] = ACTIONS(756),
    [sym_location] = ACTIONS(756),
    [anon_sym_DASH] = ACTIONS(758),
    [anon_sym_not] = ACTIONS(756),
    [anon_sym_DASH_TILDE] = ACTIONS(756),
    [anon_sym_addressof] = ACTIONS(756),
    [anon_sym_digestof] = ACTIONS(756),
    [anon_sym_PLUS] = ACTIONS(758),
    [anon_sym_STAR] = ACTIONS(758),
    [anon_sym_SLASH] = ACTIONS(758),
    [anon_sym_PERCENT] = ACTIONS(758),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(758),
    [anon_sym_LT_LT] = ACTIONS(758),
    [anon_sym_GT_GT] = ACTIONS(758),
    [anon_sym_and] = ACTIONS(756),
    [anon_sym_or] = ACTIONS(756),
    [anon_sym_xor] = ACTIONS(756),
    [anon_sym_isnt] = ACTIONS(756),
    [anon_sym_EQ_EQ] = ACTIONS(758),
    [anon_sym_BANG_EQ] = ACTIONS(758),
    [anon_sym_GT] = ACTIONS(758),
    [anon_sym_GT_EQ] = ACTIONS(758),
    [anon_sym_LT_EQ] = ACTIONS(758),
    [anon_sym_LT] = ACTIONS(758),
    [anon_sym_PLUS_TILDE] = ACTIONS(756),
    [anon_sym_STAR_TILDE] = ACTIONS(756),
    [anon_sym_SLASH_TILDE] = ACTIONS(756),
    [anon_sym_PERCENT_TILDE] = ACTIONS(756),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(756),
    [anon_sym_LT_LT_TILDE] = ACTIONS(756),
    [anon_sym_GT_GT_TILDE] = ACTIONS(756),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(756),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(756),
    [anon_sym_GT_TILDE] = ACTIONS(756),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(756),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(756),
    [anon_sym_LT_TILDE] = ACTIONS(756),
    [anon_sym_PLUS_QMARK] = ACTIONS(756),
    [anon_sym_DASH_QMARK] = ACTIONS(756),
    [anon_sym_STAR_QMARK] = ACTIONS(756),
    [anon_sym_SLASH_QMARK] = ACTIONS(756),
    [anon_sym_PERCENT_QMARK] = ACTIONS(756),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(756),
    [anon_sym_as] = ACTIONS(756),
    [anon_sym_LPAREN2] = ACTIONS(756),
    [anon_sym_DOT_GT] = ACTIONS(756),
    [anon_sym_where] = ACTIONS(756),
    [anon_sym_TILDE] = ACTIONS(756),
    [anon_sym_end] = ACTIONS(756),
    [anon_sym_if] = ACTIONS(758),
    [anon_sym_ifdef] = ACTIONS(756),
    [anon_sym_iftype] = ACTIONS(756),
    [anon_sym_else] = ACTIONS(756),
    [anon_sym_for] = ACTIONS(756),
    [anon_sym_while] = ACTIONS(756),
    [anon_sym_try] = ACTIONS(756),
    [anon_sym_with] = ACTIONS(756),
    [anon_sym_repeat] = ACTIONS(756),
    [anon_sym_do] = ACTIONS(756),
    [anon_sym_recover] = ACTIONS(756),
    [anon_sym_match] = ACTIONS(756),
    [anon_sym_return] = ACTIONS(756),
    [anon_sym_continue] = ACTIONS(756),
    [anon_sym_break] = ACTIONS(756),
    [anon_sym_consume] = ACTIONS(756),
    [anon_sym_object] = ACTIONS(756),
    [sym_number] = ACTIONS(758),
    [sym_float] = ACTIONS(756),
    [anon_sym_DQUOTE] = ACTIONS(758),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(756),
    [anon_sym_SQUOTE] = ACTIONS(756),
    [anon_sym_true] = ACTIONS(756),
    [anon_sym_false] = ACTIONS(756),
    [sym_this] = ACTIONS(756),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [86] = {
    [ts_builtin_sym_end] = ACTIONS(760),
    [sym_identifier] = ACTIONS(762),
    [anon_sym_use] = ACTIONS(760),
    [anon_sym_EQ] = ACTIONS(762),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_LBRACK] = ACTIONS(760),
    [anon_sym_type] = ACTIONS(760),
    [anon_sym_is] = ACTIONS(762),
    [anon_sym_actor] = ACTIONS(760),
    [anon_sym_class] = ACTIONS(760),
    [anon_sym_primitive] = ACTIONS(760),
    [anon_sym_interface] = ACTIONS(760),
    [anon_sym_trait] = ACTIONS(760),
    [anon_sym_struct] = ACTIONS(760),
    [anon_sym_embed] = ACTIONS(760),
    [anon_sym_let] = ACTIONS(760),
    [anon_sym_var] = ACTIONS(760),
    [anon_sym_new] = ACTIONS(760),
    [anon_sym_fun] = ACTIONS(760),
    [anon_sym_be] = ACTIONS(760),
    [anon_sym_COMMA] = ACTIONS(760),
    [anon_sym_iso] = ACTIONS(760),
    [anon_sym_trn] = ACTIONS(760),
    [anon_sym_ref] = ACTIONS(760),
    [anon_sym_val] = ACTIONS(760),
    [anon_sym_box] = ACTIONS(760),
    [anon_sym_tag] = ACTIONS(760),
    [anon_sym_LPAREN] = ACTIONS(762),
    [anon_sym_RPAREN] = ACTIONS(760),
    [anon_sym_DOT] = ACTIONS(762),
    [anon_sym_POUNDread] = ACTIONS(760),
    [anon_sym_POUNDsend] = ACTIONS(760),
    [anon_sym_POUNDshare] = ACTIONS(760),
    [anon_sym_POUNDalias] = ACTIONS(760),
    [anon_sym_POUNDany] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(762),
    [anon_sym_CARET] = ACTIONS(760),
    [anon_sym_PIPE] = ACTIONS(760),
    [anon_sym_AMP] = ACTIONS(760),
    [anon_sym_DASH_GT] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(760),
    [anon_sym_SEMI] = ACTIONS(760),
    [sym_error] = ACTIONS(760),
    [sym_compile_intrinsic] = ACTIONS(760),
    [anon_sym_compile_error] = ACTIONS(760),
    [sym_location] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_not] = ACTIONS(760),
    [anon_sym_DASH_TILDE] = ACTIONS(760),
    [anon_sym_addressof] = ACTIONS(760),
    [anon_sym_digestof] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_STAR] = ACTIONS(762),
    [anon_sym_SLASH] = ACTIONS(762),
    [anon_sym_PERCENT] = ACTIONS(762),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(762),
    [anon_sym_LT_LT] = ACTIONS(762),
    [anon_sym_GT_GT] = ACTIONS(762),
    [anon_sym_and] = ACTIONS(760),
    [anon_sym_or] = ACTIONS(760),
    [anon_sym_xor] = ACTIONS(760),
    [anon_sym_isnt] = ACTIONS(760),
    [anon_sym_EQ_EQ] = ACTIONS(762),
    [anon_sym_BANG_EQ] = ACTIONS(762),
    [anon_sym_GT] = ACTIONS(762),
    [anon_sym_GT_EQ] = ACTIONS(762),
    [anon_sym_LT_EQ] = ACTIONS(762),
    [anon_sym_LT] = ACTIONS(762),
    [anon_sym_PLUS_TILDE] = ACTIONS(760),
    [anon_sym_STAR_TILDE] = ACTIONS(760),
    [anon_sym_SLASH_TILDE] = ACTIONS(760),
    [anon_sym_PERCENT_TILDE] = ACTIONS(760),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(760),
    [anon_sym_LT_LT_TILDE] = ACTIONS(760),
    [anon_sym_GT_GT_TILDE] = ACTIONS(760),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(760),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(760),
    [anon_sym_GT_TILDE] = ACTIONS(760),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(760),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(760),
    [anon_sym_LT_TILDE] = ACTIONS(760),
    [anon_sym_PLUS_QMARK] = ACTIONS(760),
    [anon_sym_DASH_QMARK] = ACTIONS(760),
    [anon_sym_STAR_QMARK] = ACTIONS(760),
    [anon_sym_SLASH_QMARK] = ACTIONS(760),
    [anon_sym_PERCENT_QMARK] = ACTIONS(760),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(760),
    [anon_sym_as] = ACTIONS(760),
    [anon_sym_LPAREN2] = ACTIONS(760),
    [anon_sym_DOT_GT] = ACTIONS(760),
    [anon_sym_where] = ACTIONS(760),
    [anon_sym_TILDE] = ACTIONS(760),
    [anon_sym_end] = ACTIONS(760),
    [anon_sym_if] = ACTIONS(762),
    [anon_sym_ifdef] = ACTIONS(760),
    [anon_sym_iftype] = ACTIONS(760),
    [anon_sym_else] = ACTIONS(760),
    [anon_sym_for] = ACTIONS(760),
    [anon_sym_while] = ACTIONS(760),
    [anon_sym_try] = ACTIONS(760),
    [anon_sym_with] = ACTIONS(760),
    [anon_sym_repeat] = ACTIONS(760),
    [anon_sym_do] = ACTIONS(760),
    [anon_sym_recover] = ACTIONS(760),
    [anon_sym_match] = ACTIONS(760),
    [anon_sym_return] = ACTIONS(760),
    [anon_sym_continue] = ACTIONS(760),
    [anon_sym_break] = ACTIONS(760),
    [anon_sym_consume] = ACTIONS(760),
    [anon_sym_object] = ACTIONS(760),
    [sym_number] = ACTIONS(762),
    [sym_float] = ACTIONS(760),
    [anon_sym_DQUOTE] = ACTIONS(762),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(760),
    [anon_sym_true] = ACTIONS(760),
    [anon_sym_false] = ACTIONS(760),
    [sym_this] = ACTIONS(760),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [87] = {
    [ts_builtin_sym_end] = ACTIONS(764),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_use] = ACTIONS(764),
    [anon_sym_EQ] = ACTIONS(766),
    [anon_sym_AT] = ACTIONS(764),
    [anon_sym_LBRACK] = ACTIONS(764),
    [anon_sym_type] = ACTIONS(764),
    [anon_sym_is] = ACTIONS(766),
    [anon_sym_actor] = ACTIONS(764),
    [anon_sym_class] = ACTIONS(764),
    [anon_sym_primitive] = ACTIONS(764),
    [anon_sym_interface] = ACTIONS(764),
    [anon_sym_trait] = ACTIONS(764),
    [anon_sym_struct] = ACTIONS(764),
    [anon_sym_embed] = ACTIONS(764),
    [anon_sym_let] = ACTIONS(764),
    [anon_sym_var] = ACTIONS(764),
    [anon_sym_new] = ACTIONS(764),
    [anon_sym_fun] = ACTIONS(764),
    [anon_sym_be] = ACTIONS(764),
    [anon_sym_COMMA] = ACTIONS(764),
    [anon_sym_iso] = ACTIONS(764),
    [anon_sym_trn] = ACTIONS(764),
    [anon_sym_ref] = ACTIONS(764),
    [anon_sym_val] = ACTIONS(764),
    [anon_sym_box] = ACTIONS(764),
    [anon_sym_tag] = ACTIONS(764),
    [anon_sym_LPAREN] = ACTIONS(766),
    [anon_sym_RPAREN] = ACTIONS(764),
    [anon_sym_DOT] = ACTIONS(766),
    [anon_sym_POUNDread] = ACTIONS(764),
    [anon_sym_POUNDsend] = ACTIONS(764),
    [anon_sym_POUNDshare] = ACTIONS(764),
    [anon_sym_POUNDalias] = ACTIONS(764),
    [anon_sym_POUNDany] = ACTIONS(764),
    [anon_sym_BANG] = ACTIONS(766),
    [anon_sym_CARET] = ACTIONS(764),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_AMP] = ACTIONS(764),
    [anon_sym_DASH_GT] = ACTIONS(764),
    [anon_sym_LBRACE] = ACTIONS(764),
    [anon_sym_SEMI] = ACTIONS(764),
    [sym_error] = ACTIONS(764),
    [sym_compile_intrinsic] = ACTIONS(764),
    [anon_sym_compile_error] = ACTIONS(764),
    [sym_location] = ACTIONS(764),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_not] = ACTIONS(764),
    [anon_sym_DASH_TILDE] = ACTIONS(764),
    [anon_sym_addressof] = ACTIONS(764),
    [anon_sym_digestof] = ACTIONS(764),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(766),
    [anon_sym_SLASH] = ACTIONS(766),
    [anon_sym_PERCENT] = ACTIONS(766),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(766),
    [anon_sym_LT_LT] = ACTIONS(766),
    [anon_sym_GT_GT] = ACTIONS(766),
    [anon_sym_and] = ACTIONS(764),
    [anon_sym_or] = ACTIONS(764),
    [anon_sym_xor] = ACTIONS(764),
    [anon_sym_isnt] = ACTIONS(764),
    [anon_sym_EQ_EQ] = ACTIONS(766),
    [anon_sym_BANG_EQ] = ACTIONS(766),
    [anon_sym_GT] = ACTIONS(766),
    [anon_sym_GT_EQ] = ACTIONS(766),
    [anon_sym_LT_EQ] = ACTIONS(766),
    [anon_sym_LT] = ACTIONS(766),
    [anon_sym_PLUS_TILDE] = ACTIONS(764),
    [anon_sym_STAR_TILDE] = ACTIONS(764),
    [anon_sym_SLASH_TILDE] = ACTIONS(764),
    [anon_sym_PERCENT_TILDE] = ACTIONS(764),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(764),
    [anon_sym_LT_LT_TILDE] = ACTIONS(764),
    [anon_sym_GT_GT_TILDE] = ACTIONS(764),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(764),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(764),
    [anon_sym_GT_TILDE] = ACTIONS(764),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(764),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(764),
    [anon_sym_LT_TILDE] = ACTIONS(764),
    [anon_sym_PLUS_QMARK] = ACTIONS(764),
    [anon_sym_DASH_QMARK] = ACTIONS(764),
    [anon_sym_STAR_QMARK] = ACTIONS(764),
    [anon_sym_SLASH_QMARK] = ACTIONS(764),
    [anon_sym_PERCENT_QMARK] = ACTIONS(764),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(764),
    [anon_sym_as] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(764),
    [anon_sym_DOT_GT] = ACTIONS(764),
    [anon_sym_where] = ACTIONS(764),
    [anon_sym_TILDE] = ACTIONS(764),
    [anon_sym_end] = ACTIONS(764),
    [anon_sym_if] = ACTIONS(766),
    [anon_sym_ifdef] = ACTIONS(764),
    [anon_sym_iftype] = ACTIONS(764),
    [anon_sym_else] = ACTIONS(764),
    [anon_sym_for] = ACTIONS(764),
    [anon_sym_while] = ACTIONS(764),
    [anon_sym_try] = ACTIONS(764),
    [anon_sym_with] = ACTIONS(764),
    [anon_sym_repeat] = ACTIONS(764),
    [anon_sym_do] = ACTIONS(764),
    [anon_sym_recover] = ACTIONS(764),
    [anon_sym_match] = ACTIONS(764),
    [anon_sym_return] = ACTIONS(764),
    [anon_sym_continue] = ACTIONS(764),
    [anon_sym_break] = ACTIONS(764),
    [anon_sym_consume] = ACTIONS(764),
    [anon_sym_object] = ACTIONS(764),
    [sym_number] = ACTIONS(766),
    [sym_float] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(766),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(764),
    [anon_sym_SQUOTE] = ACTIONS(764),
    [anon_sym_true] = ACTIONS(764),
    [anon_sym_false] = ACTIONS(764),
    [sym_this] = ACTIONS(764),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [88] = {
    [ts_builtin_sym_end] = ACTIONS(768),
    [sym_identifier] = ACTIONS(770),
    [anon_sym_use] = ACTIONS(768),
    [anon_sym_EQ] = ACTIONS(770),
    [anon_sym_AT] = ACTIONS(768),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_is] = ACTIONS(770),
    [anon_sym_actor] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(768),
    [anon_sym_primitive] = ACTIONS(768),
    [anon_sym_interface] = ACTIONS(768),
    [anon_sym_trait] = ACTIONS(768),
    [anon_sym_struct] = ACTIONS(768),
    [anon_sym_embed] = ACTIONS(768),
    [anon_sym_let] = ACTIONS(768),
    [anon_sym_var] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(768),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_be] = ACTIONS(768),
    [anon_sym_COMMA] = ACTIONS(768),
    [anon_sym_iso] = ACTIONS(768),
    [anon_sym_trn] = ACTIONS(768),
    [anon_sym_ref] = ACTIONS(768),
    [anon_sym_val] = ACTIONS(768),
    [anon_sym_box] = ACTIONS(768),
    [anon_sym_tag] = ACTIONS(768),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_RPAREN] = ACTIONS(768),
    [anon_sym_DOT] = ACTIONS(770),
    [anon_sym_POUNDread] = ACTIONS(768),
    [anon_sym_POUNDsend] = ACTIONS(768),
    [anon_sym_POUNDshare] = ACTIONS(768),
    [anon_sym_POUNDalias] = ACTIONS(768),
    [anon_sym_POUNDany] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(770),
    [anon_sym_CARET] = ACTIONS(768),
    [anon_sym_PIPE] = ACTIONS(768),
    [anon_sym_AMP] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(768),
    [anon_sym_LBRACE] = ACTIONS(768),
    [anon_sym_SEMI] = ACTIONS(768),
    [sym_error] = ACTIONS(768),
    [sym_compile_intrinsic] = ACTIONS(768),
    [anon_sym_compile_error] = ACTIONS(768),
    [sym_location] = ACTIONS(768),
    [anon_sym_DASH] = ACTIONS(770),
    [anon_sym_not] = ACTIONS(768),
    [anon_sym_DASH_TILDE] = ACTIONS(768),
    [anon_sym_addressof] = ACTIONS(768),
    [anon_sym_digestof] = ACTIONS(768),
    [anon_sym_PLUS] = ACTIONS(770),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_SLASH] = ACTIONS(770),
    [anon_sym_PERCENT] = ACTIONS(770),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(770),
    [anon_sym_LT_LT] = ACTIONS(770),
    [anon_sym_GT_GT] = ACTIONS(770),
    [anon_sym_and] = ACTIONS(768),
    [anon_sym_or] = ACTIONS(768),
    [anon_sym_xor] = ACTIONS(768),
    [anon_sym_isnt] = ACTIONS(768),
    [anon_sym_EQ_EQ] = ACTIONS(770),
    [anon_sym_BANG_EQ] = ACTIONS(770),
    [anon_sym_GT] = ACTIONS(770),
    [anon_sym_GT_EQ] = ACTIONS(770),
    [anon_sym_LT_EQ] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(770),
    [anon_sym_PLUS_TILDE] = ACTIONS(768),
    [anon_sym_STAR_TILDE] = ACTIONS(768),
    [anon_sym_SLASH_TILDE] = ACTIONS(768),
    [anon_sym_PERCENT_TILDE] = ACTIONS(768),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(768),
    [anon_sym_LT_LT_TILDE] = ACTIONS(768),
    [anon_sym_GT_GT_TILDE] = ACTIONS(768),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(768),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(768),
    [anon_sym_GT_TILDE] = ACTIONS(768),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(768),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(768),
    [anon_sym_LT_TILDE] = ACTIONS(768),
    [anon_sym_PLUS_QMARK] = ACTIONS(768),
    [anon_sym_DASH_QMARK] = ACTIONS(768),
    [anon_sym_STAR_QMARK] = ACTIONS(768),
    [anon_sym_SLASH_QMARK] = ACTIONS(768),
    [anon_sym_PERCENT_QMARK] = ACTIONS(768),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(768),
    [anon_sym_as] = ACTIONS(768),
    [anon_sym_LPAREN2] = ACTIONS(768),
    [anon_sym_DOT_GT] = ACTIONS(768),
    [anon_sym_where] = ACTIONS(768),
    [anon_sym_TILDE] = ACTIONS(768),
    [anon_sym_end] = ACTIONS(768),
    [anon_sym_if] = ACTIONS(770),
    [anon_sym_ifdef] = ACTIONS(768),
    [anon_sym_iftype] = ACTIONS(768),
    [anon_sym_else] = ACTIONS(768),
    [anon_sym_for] = ACTIONS(768),
    [anon_sym_while] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(768),
    [anon_sym_with] = ACTIONS(768),
    [anon_sym_repeat] = ACTIONS(768),
    [anon_sym_do] = ACTIONS(768),
    [anon_sym_recover] = ACTIONS(768),
    [anon_sym_match] = ACTIONS(768),
    [anon_sym_return] = ACTIONS(768),
    [anon_sym_continue] = ACTIONS(768),
    [anon_sym_break] = ACTIONS(768),
    [anon_sym_consume] = ACTIONS(768),
    [anon_sym_object] = ACTIONS(768),
    [sym_number] = ACTIONS(770),
    [sym_float] = ACTIONS(768),
    [anon_sym_DQUOTE] = ACTIONS(770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(768),
    [anon_sym_SQUOTE] = ACTIONS(768),
    [anon_sym_true] = ACTIONS(768),
    [anon_sym_false] = ACTIONS(768),
    [sym_this] = ACTIONS(768),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [89] = {
    [ts_builtin_sym_end] = ACTIONS(772),
    [sym_identifier] = ACTIONS(774),
    [anon_sym_use] = ACTIONS(772),
    [anon_sym_EQ] = ACTIONS(774),
    [anon_sym_AT] = ACTIONS(772),
    [anon_sym_LBRACK] = ACTIONS(772),
    [anon_sym_type] = ACTIONS(772),
    [anon_sym_is] = ACTIONS(774),
    [anon_sym_actor] = ACTIONS(772),
    [anon_sym_class] = ACTIONS(772),
    [anon_sym_primitive] = ACTIONS(772),
    [anon_sym_interface] = ACTIONS(772),
    [anon_sym_trait] = ACTIONS(772),
    [anon_sym_struct] = ACTIONS(772),
    [anon_sym_embed] = ACTIONS(772),
    [anon_sym_let] = ACTIONS(772),
    [anon_sym_var] = ACTIONS(772),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_fun] = ACTIONS(772),
    [anon_sym_be] = ACTIONS(772),
    [anon_sym_COMMA] = ACTIONS(772),
    [anon_sym_iso] = ACTIONS(772),
    [anon_sym_trn] = ACTIONS(772),
    [anon_sym_ref] = ACTIONS(772),
    [anon_sym_val] = ACTIONS(772),
    [anon_sym_box] = ACTIONS(772),
    [anon_sym_tag] = ACTIONS(772),
    [anon_sym_LPAREN] = ACTIONS(774),
    [anon_sym_RPAREN] = ACTIONS(772),
    [anon_sym_DOT] = ACTIONS(774),
    [anon_sym_POUNDread] = ACTIONS(772),
    [anon_sym_POUNDsend] = ACTIONS(772),
    [anon_sym_POUNDshare] = ACTIONS(772),
    [anon_sym_POUNDalias] = ACTIONS(772),
    [anon_sym_POUNDany] = ACTIONS(772),
    [anon_sym_BANG] = ACTIONS(774),
    [anon_sym_CARET] = ACTIONS(772),
    [anon_sym_PIPE] = ACTIONS(772),
    [anon_sym_AMP] = ACTIONS(772),
    [anon_sym_DASH_GT] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(772),
    [anon_sym_SEMI] = ACTIONS(772),
    [sym_error] = ACTIONS(772),
    [sym_compile_intrinsic] = ACTIONS(772),
    [anon_sym_compile_error] = ACTIONS(772),
    [sym_location] = ACTIONS(772),
    [anon_sym_DASH] = ACTIONS(774),
    [anon_sym_not] = ACTIONS(772),
    [anon_sym_DASH_TILDE] = ACTIONS(772),
    [anon_sym_addressof] = ACTIONS(772),
    [anon_sym_digestof] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(774),
    [anon_sym_STAR] = ACTIONS(774),
    [anon_sym_SLASH] = ACTIONS(774),
    [anon_sym_PERCENT] = ACTIONS(774),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(774),
    [anon_sym_LT_LT] = ACTIONS(774),
    [anon_sym_GT_GT] = ACTIONS(774),
    [anon_sym_and] = ACTIONS(772),
    [anon_sym_or] = ACTIONS(772),
    [anon_sym_xor] = ACTIONS(772),
    [anon_sym_isnt] = ACTIONS(772),
    [anon_sym_EQ_EQ] = ACTIONS(774),
    [anon_sym_BANG_EQ] = ACTIONS(774),
    [anon_sym_GT] = ACTIONS(774),
    [anon_sym_GT_EQ] = ACTIONS(774),
    [anon_sym_LT_EQ] = ACTIONS(774),
    [anon_sym_LT] = ACTIONS(774),
    [anon_sym_PLUS_TILDE] = ACTIONS(772),
    [anon_sym_STAR_TILDE] = ACTIONS(772),
    [anon_sym_SLASH_TILDE] = ACTIONS(772),
    [anon_sym_PERCENT_TILDE] = ACTIONS(772),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(772),
    [anon_sym_LT_LT_TILDE] = ACTIONS(772),
    [anon_sym_GT_GT_TILDE] = ACTIONS(772),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(772),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(772),
    [anon_sym_GT_TILDE] = ACTIONS(772),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(772),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(772),
    [anon_sym_LT_TILDE] = ACTIONS(772),
    [anon_sym_PLUS_QMARK] = ACTIONS(772),
    [anon_sym_DASH_QMARK] = ACTIONS(772),
    [anon_sym_STAR_QMARK] = ACTIONS(772),
    [anon_sym_SLASH_QMARK] = ACTIONS(772),
    [anon_sym_PERCENT_QMARK] = ACTIONS(772),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(772),
    [anon_sym_as] = ACTIONS(772),
    [anon_sym_LPAREN2] = ACTIONS(772),
    [anon_sym_DOT_GT] = ACTIONS(772),
    [anon_sym_where] = ACTIONS(772),
    [anon_sym_TILDE] = ACTIONS(772),
    [anon_sym_end] = ACTIONS(772),
    [anon_sym_if] = ACTIONS(774),
    [anon_sym_ifdef] = ACTIONS(772),
    [anon_sym_iftype] = ACTIONS(772),
    [anon_sym_else] = ACTIONS(772),
    [anon_sym_for] = ACTIONS(772),
    [anon_sym_while] = ACTIONS(772),
    [anon_sym_try] = ACTIONS(772),
    [anon_sym_with] = ACTIONS(772),
    [anon_sym_repeat] = ACTIONS(772),
    [anon_sym_do] = ACTIONS(772),
    [anon_sym_recover] = ACTIONS(772),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_return] = ACTIONS(772),
    [anon_sym_continue] = ACTIONS(772),
    [anon_sym_break] = ACTIONS(772),
    [anon_sym_consume] = ACTIONS(772),
    [anon_sym_object] = ACTIONS(772),
    [sym_number] = ACTIONS(774),
    [sym_float] = ACTIONS(772),
    [anon_sym_DQUOTE] = ACTIONS(774),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(772),
    [anon_sym_SQUOTE] = ACTIONS(772),
    [anon_sym_true] = ACTIONS(772),
    [anon_sym_false] = ACTIONS(772),
    [sym_this] = ACTIONS(772),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [90] = {
    [ts_builtin_sym_end] = ACTIONS(776),
    [sym_identifier] = ACTIONS(778),
    [anon_sym_use] = ACTIONS(776),
    [anon_sym_EQ] = ACTIONS(778),
    [anon_sym_AT] = ACTIONS(776),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_type] = ACTIONS(776),
    [anon_sym_is] = ACTIONS(778),
    [anon_sym_actor] = ACTIONS(776),
    [anon_sym_class] = ACTIONS(776),
    [anon_sym_primitive] = ACTIONS(776),
    [anon_sym_interface] = ACTIONS(776),
    [anon_sym_trait] = ACTIONS(776),
    [anon_sym_struct] = ACTIONS(776),
    [anon_sym_embed] = ACTIONS(776),
    [anon_sym_let] = ACTIONS(776),
    [anon_sym_var] = ACTIONS(776),
    [anon_sym_new] = ACTIONS(776),
    [anon_sym_fun] = ACTIONS(776),
    [anon_sym_be] = ACTIONS(776),
    [anon_sym_COMMA] = ACTIONS(776),
    [anon_sym_iso] = ACTIONS(776),
    [anon_sym_trn] = ACTIONS(776),
    [anon_sym_ref] = ACTIONS(776),
    [anon_sym_val] = ACTIONS(776),
    [anon_sym_box] = ACTIONS(776),
    [anon_sym_tag] = ACTIONS(776),
    [anon_sym_LPAREN] = ACTIONS(778),
    [anon_sym_RPAREN] = ACTIONS(776),
    [anon_sym_DOT] = ACTIONS(778),
    [anon_sym_POUNDread] = ACTIONS(776),
    [anon_sym_POUNDsend] = ACTIONS(776),
    [anon_sym_POUNDshare] = ACTIONS(776),
    [anon_sym_POUNDalias] = ACTIONS(776),
    [anon_sym_POUNDany] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_CARET] = ACTIONS(776),
    [anon_sym_PIPE] = ACTIONS(776),
    [anon_sym_AMP] = ACTIONS(776),
    [anon_sym_DASH_GT] = ACTIONS(776),
    [anon_sym_LBRACE] = ACTIONS(776),
    [anon_sym_SEMI] = ACTIONS(776),
    [sym_error] = ACTIONS(776),
    [sym_compile_intrinsic] = ACTIONS(776),
    [anon_sym_compile_error] = ACTIONS(776),
    [sym_location] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(778),
    [anon_sym_not] = ACTIONS(776),
    [anon_sym_DASH_TILDE] = ACTIONS(776),
    [anon_sym_addressof] = ACTIONS(776),
    [anon_sym_digestof] = ACTIONS(776),
    [anon_sym_PLUS] = ACTIONS(778),
    [anon_sym_STAR] = ACTIONS(778),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_PERCENT] = ACTIONS(778),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(778),
    [anon_sym_LT_LT] = ACTIONS(778),
    [anon_sym_GT_GT] = ACTIONS(778),
    [anon_sym_and] = ACTIONS(776),
    [anon_sym_or] = ACTIONS(776),
    [anon_sym_xor] = ACTIONS(776),
    [anon_sym_isnt] = ACTIONS(776),
    [anon_sym_EQ_EQ] = ACTIONS(778),
    [anon_sym_BANG_EQ] = ACTIONS(778),
    [anon_sym_GT] = ACTIONS(778),
    [anon_sym_GT_EQ] = ACTIONS(778),
    [anon_sym_LT_EQ] = ACTIONS(778),
    [anon_sym_LT] = ACTIONS(778),
    [anon_sym_PLUS_TILDE] = ACTIONS(776),
    [anon_sym_STAR_TILDE] = ACTIONS(776),
    [anon_sym_SLASH_TILDE] = ACTIONS(776),
    [anon_sym_PERCENT_TILDE] = ACTIONS(776),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(776),
    [anon_sym_LT_LT_TILDE] = ACTIONS(776),
    [anon_sym_GT_GT_TILDE] = ACTIONS(776),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(776),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(776),
    [anon_sym_GT_TILDE] = ACTIONS(776),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(776),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(776),
    [anon_sym_LT_TILDE] = ACTIONS(776),
    [anon_sym_PLUS_QMARK] = ACTIONS(776),
    [anon_sym_DASH_QMARK] = ACTIONS(776),
    [anon_sym_STAR_QMARK] = ACTIONS(776),
    [anon_sym_SLASH_QMARK] = ACTIONS(776),
    [anon_sym_PERCENT_QMARK] = ACTIONS(776),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(776),
    [anon_sym_as] = ACTIONS(776),
    [anon_sym_LPAREN2] = ACTIONS(776),
    [anon_sym_DOT_GT] = ACTIONS(776),
    [anon_sym_where] = ACTIONS(776),
    [anon_sym_TILDE] = ACTIONS(776),
    [anon_sym_end] = ACTIONS(776),
    [anon_sym_if] = ACTIONS(778),
    [anon_sym_ifdef] = ACTIONS(776),
    [anon_sym_iftype] = ACTIONS(776),
    [anon_sym_else] = ACTIONS(776),
    [anon_sym_for] = ACTIONS(776),
    [anon_sym_while] = ACTIONS(776),
    [anon_sym_try] = ACTIONS(776),
    [anon_sym_with] = ACTIONS(776),
    [anon_sym_repeat] = ACTIONS(776),
    [anon_sym_do] = ACTIONS(776),
    [anon_sym_recover] = ACTIONS(776),
    [anon_sym_match] = ACTIONS(776),
    [anon_sym_return] = ACTIONS(776),
    [anon_sym_continue] = ACTIONS(776),
    [anon_sym_break] = ACTIONS(776),
    [anon_sym_consume] = ACTIONS(776),
    [anon_sym_object] = ACTIONS(776),
    [sym_number] = ACTIONS(778),
    [sym_float] = ACTIONS(776),
    [anon_sym_DQUOTE] = ACTIONS(778),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(776),
    [anon_sym_SQUOTE] = ACTIONS(776),
    [anon_sym_true] = ACTIONS(776),
    [anon_sym_false] = ACTIONS(776),
    [sym_this] = ACTIONS(776),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [91] = {
    [ts_builtin_sym_end] = ACTIONS(780),
    [sym_identifier] = ACTIONS(782),
    [anon_sym_use] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(782),
    [anon_sym_AT] = ACTIONS(780),
    [anon_sym_LBRACK] = ACTIONS(780),
    [anon_sym_type] = ACTIONS(780),
    [anon_sym_is] = ACTIONS(782),
    [anon_sym_actor] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_primitive] = ACTIONS(780),
    [anon_sym_interface] = ACTIONS(780),
    [anon_sym_trait] = ACTIONS(780),
    [anon_sym_struct] = ACTIONS(780),
    [anon_sym_embed] = ACTIONS(780),
    [anon_sym_let] = ACTIONS(780),
    [anon_sym_var] = ACTIONS(780),
    [anon_sym_new] = ACTIONS(780),
    [anon_sym_fun] = ACTIONS(780),
    [anon_sym_be] = ACTIONS(780),
    [anon_sym_COMMA] = ACTIONS(780),
    [anon_sym_iso] = ACTIONS(780),
    [anon_sym_trn] = ACTIONS(780),
    [anon_sym_ref] = ACTIONS(780),
    [anon_sym_val] = ACTIONS(780),
    [anon_sym_box] = ACTIONS(780),
    [anon_sym_tag] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(782),
    [anon_sym_RPAREN] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(782),
    [anon_sym_POUNDread] = ACTIONS(780),
    [anon_sym_POUNDsend] = ACTIONS(780),
    [anon_sym_POUNDshare] = ACTIONS(780),
    [anon_sym_POUNDalias] = ACTIONS(780),
    [anon_sym_POUNDany] = ACTIONS(780),
    [anon_sym_BANG] = ACTIONS(782),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_DASH_GT] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(780),
    [sym_error] = ACTIONS(780),
    [sym_compile_intrinsic] = ACTIONS(780),
    [anon_sym_compile_error] = ACTIONS(780),
    [sym_location] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(782),
    [anon_sym_not] = ACTIONS(780),
    [anon_sym_DASH_TILDE] = ACTIONS(780),
    [anon_sym_addressof] = ACTIONS(780),
    [anon_sym_digestof] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(782),
    [anon_sym_STAR] = ACTIONS(782),
    [anon_sym_SLASH] = ACTIONS(782),
    [anon_sym_PERCENT] = ACTIONS(782),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(782),
    [anon_sym_LT_LT] = ACTIONS(782),
    [anon_sym_GT_GT] = ACTIONS(782),
    [anon_sym_and] = ACTIONS(780),
    [anon_sym_or] = ACTIONS(780),
    [anon_sym_xor] = ACTIONS(780),
    [anon_sym_isnt] = ACTIONS(780),
    [anon_sym_EQ_EQ] = ACTIONS(782),
    [anon_sym_BANG_EQ] = ACTIONS(782),
    [anon_sym_GT] = ACTIONS(782),
    [anon_sym_GT_EQ] = ACTIONS(782),
    [anon_sym_LT_EQ] = ACTIONS(782),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_PLUS_TILDE] = ACTIONS(780),
    [anon_sym_STAR_TILDE] = ACTIONS(780),
    [anon_sym_SLASH_TILDE] = ACTIONS(780),
    [anon_sym_PERCENT_TILDE] = ACTIONS(780),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(780),
    [anon_sym_LT_LT_TILDE] = ACTIONS(780),
    [anon_sym_GT_GT_TILDE] = ACTIONS(780),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(780),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(780),
    [anon_sym_GT_TILDE] = ACTIONS(780),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(780),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(780),
    [anon_sym_LT_TILDE] = ACTIONS(780),
    [anon_sym_PLUS_QMARK] = ACTIONS(780),
    [anon_sym_DASH_QMARK] = ACTIONS(780),
    [anon_sym_STAR_QMARK] = ACTIONS(780),
    [anon_sym_SLASH_QMARK] = ACTIONS(780),
    [anon_sym_PERCENT_QMARK] = ACTIONS(780),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(780),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_LPAREN2] = ACTIONS(780),
    [anon_sym_DOT_GT] = ACTIONS(780),
    [anon_sym_where] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_end] = ACTIONS(780),
    [anon_sym_if] = ACTIONS(782),
    [anon_sym_ifdef] = ACTIONS(780),
    [anon_sym_iftype] = ACTIONS(780),
    [anon_sym_else] = ACTIONS(780),
    [anon_sym_for] = ACTIONS(780),
    [anon_sym_while] = ACTIONS(780),
    [anon_sym_try] = ACTIONS(780),
    [anon_sym_with] = ACTIONS(780),
    [anon_sym_repeat] = ACTIONS(780),
    [anon_sym_do] = ACTIONS(780),
    [anon_sym_recover] = ACTIONS(780),
    [anon_sym_match] = ACTIONS(780),
    [anon_sym_return] = ACTIONS(780),
    [anon_sym_continue] = ACTIONS(780),
    [anon_sym_break] = ACTIONS(780),
    [anon_sym_consume] = ACTIONS(780),
    [anon_sym_object] = ACTIONS(780),
    [sym_number] = ACTIONS(782),
    [sym_float] = ACTIONS(780),
    [anon_sym_DQUOTE] = ACTIONS(782),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(780),
    [anon_sym_SQUOTE] = ACTIONS(780),
    [anon_sym_true] = ACTIONS(780),
    [anon_sym_false] = ACTIONS(780),
    [sym_this] = ACTIONS(780),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [92] = {
    [ts_builtin_sym_end] = ACTIONS(784),
    [sym_identifier] = ACTIONS(786),
    [anon_sym_use] = ACTIONS(784),
    [anon_sym_EQ] = ACTIONS(786),
    [anon_sym_AT] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(784),
    [anon_sym_type] = ACTIONS(784),
    [anon_sym_is] = ACTIONS(786),
    [anon_sym_actor] = ACTIONS(784),
    [anon_sym_class] = ACTIONS(784),
    [anon_sym_primitive] = ACTIONS(784),
    [anon_sym_interface] = ACTIONS(784),
    [anon_sym_trait] = ACTIONS(784),
    [anon_sym_struct] = ACTIONS(784),
    [anon_sym_embed] = ACTIONS(784),
    [anon_sym_let] = ACTIONS(784),
    [anon_sym_var] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_fun] = ACTIONS(784),
    [anon_sym_be] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(784),
    [anon_sym_iso] = ACTIONS(784),
    [anon_sym_trn] = ACTIONS(784),
    [anon_sym_ref] = ACTIONS(784),
    [anon_sym_val] = ACTIONS(784),
    [anon_sym_box] = ACTIONS(784),
    [anon_sym_tag] = ACTIONS(784),
    [anon_sym_LPAREN] = ACTIONS(786),
    [anon_sym_RPAREN] = ACTIONS(784),
    [anon_sym_DOT] = ACTIONS(786),
    [anon_sym_POUNDread] = ACTIONS(784),
    [anon_sym_POUNDsend] = ACTIONS(784),
    [anon_sym_POUNDshare] = ACTIONS(784),
    [anon_sym_POUNDalias] = ACTIONS(784),
    [anon_sym_POUNDany] = ACTIONS(784),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_CARET] = ACTIONS(784),
    [anon_sym_PIPE] = ACTIONS(784),
    [anon_sym_AMP] = ACTIONS(784),
    [anon_sym_DASH_GT] = ACTIONS(784),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_SEMI] = ACTIONS(784),
    [sym_error] = ACTIONS(784),
    [sym_compile_intrinsic] = ACTIONS(784),
    [anon_sym_compile_error] = ACTIONS(784),
    [sym_location] = ACTIONS(784),
    [anon_sym_DASH] = ACTIONS(786),
    [anon_sym_not] = ACTIONS(784),
    [anon_sym_DASH_TILDE] = ACTIONS(784),
    [anon_sym_addressof] = ACTIONS(784),
    [anon_sym_digestof] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(786),
    [anon_sym_STAR] = ACTIONS(786),
    [anon_sym_SLASH] = ACTIONS(786),
    [anon_sym_PERCENT] = ACTIONS(786),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(786),
    [anon_sym_LT_LT] = ACTIONS(786),
    [anon_sym_GT_GT] = ACTIONS(786),
    [anon_sym_and] = ACTIONS(784),
    [anon_sym_or] = ACTIONS(784),
    [anon_sym_xor] = ACTIONS(784),
    [anon_sym_isnt] = ACTIONS(784),
    [anon_sym_EQ_EQ] = ACTIONS(786),
    [anon_sym_BANG_EQ] = ACTIONS(786),
    [anon_sym_GT] = ACTIONS(786),
    [anon_sym_GT_EQ] = ACTIONS(786),
    [anon_sym_LT_EQ] = ACTIONS(786),
    [anon_sym_LT] = ACTIONS(786),
    [anon_sym_PLUS_TILDE] = ACTIONS(784),
    [anon_sym_STAR_TILDE] = ACTIONS(784),
    [anon_sym_SLASH_TILDE] = ACTIONS(784),
    [anon_sym_PERCENT_TILDE] = ACTIONS(784),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(784),
    [anon_sym_LT_LT_TILDE] = ACTIONS(784),
    [anon_sym_GT_GT_TILDE] = ACTIONS(784),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(784),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(784),
    [anon_sym_GT_TILDE] = ACTIONS(784),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(784),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(784),
    [anon_sym_LT_TILDE] = ACTIONS(784),
    [anon_sym_PLUS_QMARK] = ACTIONS(784),
    [anon_sym_DASH_QMARK] = ACTIONS(784),
    [anon_sym_STAR_QMARK] = ACTIONS(784),
    [anon_sym_SLASH_QMARK] = ACTIONS(784),
    [anon_sym_PERCENT_QMARK] = ACTIONS(784),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(784),
    [anon_sym_as] = ACTIONS(784),
    [anon_sym_LPAREN2] = ACTIONS(784),
    [anon_sym_DOT_GT] = ACTIONS(784),
    [anon_sym_where] = ACTIONS(784),
    [anon_sym_TILDE] = ACTIONS(784),
    [anon_sym_end] = ACTIONS(784),
    [anon_sym_if] = ACTIONS(786),
    [anon_sym_ifdef] = ACTIONS(784),
    [anon_sym_iftype] = ACTIONS(784),
    [anon_sym_else] = ACTIONS(784),
    [anon_sym_for] = ACTIONS(784),
    [anon_sym_while] = ACTIONS(784),
    [anon_sym_try] = ACTIONS(784),
    [anon_sym_with] = ACTIONS(784),
    [anon_sym_repeat] = ACTIONS(784),
    [anon_sym_do] = ACTIONS(784),
    [anon_sym_recover] = ACTIONS(784),
    [anon_sym_match] = ACTIONS(784),
    [anon_sym_return] = ACTIONS(784),
    [anon_sym_continue] = ACTIONS(784),
    [anon_sym_break] = ACTIONS(784),
    [anon_sym_consume] = ACTIONS(784),
    [anon_sym_object] = ACTIONS(784),
    [sym_number] = ACTIONS(786),
    [sym_float] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(784),
    [anon_sym_SQUOTE] = ACTIONS(784),
    [anon_sym_true] = ACTIONS(784),
    [anon_sym_false] = ACTIONS(784),
    [sym_this] = ACTIONS(784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [93] = {
    [sym_type_args] = STATE(118),
    [aux_sym_base_type_repeat1] = STATE(95),
    [sym_identifier] = ACTIONS(613),
    [anon_sym_EQ] = ACTIONS(613),
    [anon_sym_AT] = ACTIONS(611),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_RBRACK] = ACTIONS(611),
    [anon_sym_is] = ACTIONS(613),
    [anon_sym_embed] = ACTIONS(611),
    [anon_sym_let] = ACTIONS(611),
    [anon_sym_var] = ACTIONS(611),
    [anon_sym_new] = ACTIONS(611),
    [anon_sym_EQ_GT] = ACTIONS(611),
    [anon_sym_fun] = ACTIONS(611),
    [anon_sym_be] = ACTIONS(611),
    [anon_sym_COMMA] = ACTIONS(611),
    [anon_sym_iso] = ACTIONS(611),
    [anon_sym_trn] = ACTIONS(611),
    [anon_sym_ref] = ACTIONS(611),
    [anon_sym_val] = ACTIONS(611),
    [anon_sym_box] = ACTIONS(611),
    [anon_sym_tag] = ACTIONS(611),
    [anon_sym_LPAREN] = ACTIONS(613),
    [anon_sym_RPAREN] = ACTIONS(611),
    [anon_sym_DOT] = ACTIONS(788),
    [anon_sym_POUNDread] = ACTIONS(611),
    [anon_sym_POUNDsend] = ACTIONS(611),
    [anon_sym_POUNDshare] = ACTIONS(611),
    [anon_sym_POUNDalias] = ACTIONS(611),
    [anon_sym_POUNDany] = ACTIONS(611),
    [anon_sym_BANG] = ACTIONS(613),
    [anon_sym_CARET] = ACTIONS(611),
    [anon_sym_PIPE] = ACTIONS(611),
    [anon_sym_AMP] = ACTIONS(611),
    [anon_sym_DASH_GT] = ACTIONS(611),
    [anon_sym_LBRACE] = ACTIONS(611),
    [anon_sym_RBRACE] = ACTIONS(611),
    [anon_sym_SEMI] = ACTIONS(611),
    [sym_error] = ACTIONS(611),
    [sym_compile_intrinsic] = ACTIONS(611),
    [anon_sym_compile_error] = ACTIONS(611),
    [sym_location] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(613),
    [anon_sym_not] = ACTIONS(611),
    [anon_sym_DASH_TILDE] = ACTIONS(611),
    [anon_sym_addressof] = ACTIONS(611),
    [anon_sym_digestof] = ACTIONS(611),
    [anon_sym_PLUS] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(613),
    [anon_sym_SLASH] = ACTIONS(613),
    [anon_sym_PERCENT] = ACTIONS(613),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(613),
    [anon_sym_LT_LT] = ACTIONS(613),
    [anon_sym_GT_GT] = ACTIONS(613),
    [anon_sym_and] = ACTIONS(611),
    [anon_sym_or] = ACTIONS(611),
    [anon_sym_xor] = ACTIONS(611),
    [anon_sym_isnt] = ACTIONS(611),
    [anon_sym_EQ_EQ] = ACTIONS(613),
    [anon_sym_BANG_EQ] = ACTIONS(613),
    [anon_sym_GT] = ACTIONS(613),
    [anon_sym_GT_EQ] = ACTIONS(613),
    [anon_sym_LT_EQ] = ACTIONS(613),
    [anon_sym_LT] = ACTIONS(613),
    [anon_sym_PLUS_TILDE] = ACTIONS(611),
    [anon_sym_STAR_TILDE] = ACTIONS(611),
    [anon_sym_SLASH_TILDE] = ACTIONS(611),
    [anon_sym_PERCENT_TILDE] = ACTIONS(611),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(611),
    [anon_sym_LT_LT_TILDE] = ACTIONS(611),
    [anon_sym_GT_GT_TILDE] = ACTIONS(611),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(611),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(611),
    [anon_sym_GT_TILDE] = ACTIONS(611),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(611),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(611),
    [anon_sym_LT_TILDE] = ACTIONS(611),
    [anon_sym_PLUS_QMARK] = ACTIONS(611),
    [anon_sym_DASH_QMARK] = ACTIONS(611),
    [anon_sym_STAR_QMARK] = ACTIONS(611),
    [anon_sym_SLASH_QMARK] = ACTIONS(611),
    [anon_sym_PERCENT_QMARK] = ACTIONS(611),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(611),
    [anon_sym_as] = ACTIONS(611),
    [anon_sym_LPAREN2] = ACTIONS(611),
    [anon_sym_DOT_GT] = ACTIONS(611),
    [anon_sym_where] = ACTIONS(611),
    [anon_sym_TILDE] = ACTIONS(611),
    [anon_sym_end] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(613),
    [anon_sym_ifdef] = ACTIONS(611),
    [anon_sym_then] = ACTIONS(611),
    [anon_sym_iftype] = ACTIONS(611),
    [anon_sym_else] = ACTIONS(611),
    [anon_sym_for] = ACTIONS(611),
    [anon_sym_while] = ACTIONS(611),
    [anon_sym_try] = ACTIONS(611),
    [anon_sym_with] = ACTIONS(611),
    [anon_sym_repeat] = ACTIONS(611),
    [anon_sym_until] = ACTIONS(611),
    [anon_sym_do] = ACTIONS(611),
    [anon_sym_recover] = ACTIONS(611),
    [anon_sym_match] = ACTIONS(611),
    [anon_sym_return] = ACTIONS(611),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_consume] = ACTIONS(611),
    [anon_sym_object] = ACTIONS(611),
    [sym_number] = ACTIONS(613),
    [sym_float] = ACTIONS(611),
    [anon_sym_DQUOTE] = ACTIONS(613),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(611),
    [anon_sym_SQUOTE] = ACTIONS(611),
    [anon_sym_true] = ACTIONS(611),
    [anon_sym_false] = ACTIONS(611),
    [sym_this] = ACTIONS(611),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(790),
    [sym_block_comment] = ACTIONS(3),
  },
  [94] = {
    [sym_type_args] = STATE(114),
    [aux_sym_base_type_repeat1] = STATE(93),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_AT] = ACTIONS(619),
    [anon_sym_LBRACK] = ACTIONS(619),
    [anon_sym_RBRACK] = ACTIONS(619),
    [anon_sym_is] = ACTIONS(621),
    [anon_sym_embed] = ACTIONS(619),
    [anon_sym_let] = ACTIONS(619),
    [anon_sym_var] = ACTIONS(619),
    [anon_sym_new] = ACTIONS(619),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_fun] = ACTIONS(619),
    [anon_sym_be] = ACTIONS(619),
    [anon_sym_COMMA] = ACTIONS(619),
    [anon_sym_iso] = ACTIONS(619),
    [anon_sym_trn] = ACTIONS(619),
    [anon_sym_ref] = ACTIONS(619),
    [anon_sym_val] = ACTIONS(619),
    [anon_sym_box] = ACTIONS(619),
    [anon_sym_tag] = ACTIONS(619),
    [anon_sym_LPAREN] = ACTIONS(621),
    [anon_sym_RPAREN] = ACTIONS(619),
    [anon_sym_DOT] = ACTIONS(788),
    [anon_sym_POUNDread] = ACTIONS(619),
    [anon_sym_POUNDsend] = ACTIONS(619),
    [anon_sym_POUNDshare] = ACTIONS(619),
    [anon_sym_POUNDalias] = ACTIONS(619),
    [anon_sym_POUNDany] = ACTIONS(619),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_CARET] = ACTIONS(619),
    [anon_sym_PIPE] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(619),
    [anon_sym_DASH_GT] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(619),
    [anon_sym_SEMI] = ACTIONS(619),
    [sym_error] = ACTIONS(619),
    [sym_compile_intrinsic] = ACTIONS(619),
    [anon_sym_compile_error] = ACTIONS(619),
    [sym_location] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(621),
    [anon_sym_not] = ACTIONS(619),
    [anon_sym_DASH_TILDE] = ACTIONS(619),
    [anon_sym_addressof] = ACTIONS(619),
    [anon_sym_digestof] = ACTIONS(619),
    [anon_sym_PLUS] = ACTIONS(621),
    [anon_sym_STAR] = ACTIONS(621),
    [anon_sym_SLASH] = ACTIONS(621),
    [anon_sym_PERCENT] = ACTIONS(621),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(621),
    [anon_sym_LT_LT] = ACTIONS(621),
    [anon_sym_GT_GT] = ACTIONS(621),
    [anon_sym_and] = ACTIONS(619),
    [anon_sym_or] = ACTIONS(619),
    [anon_sym_xor] = ACTIONS(619),
    [anon_sym_isnt] = ACTIONS(619),
    [anon_sym_EQ_EQ] = ACTIONS(621),
    [anon_sym_BANG_EQ] = ACTIONS(621),
    [anon_sym_GT] = ACTIONS(621),
    [anon_sym_GT_EQ] = ACTIONS(621),
    [anon_sym_LT_EQ] = ACTIONS(621),
    [anon_sym_LT] = ACTIONS(621),
    [anon_sym_PLUS_TILDE] = ACTIONS(619),
    [anon_sym_STAR_TILDE] = ACTIONS(619),
    [anon_sym_SLASH_TILDE] = ACTIONS(619),
    [anon_sym_PERCENT_TILDE] = ACTIONS(619),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(619),
    [anon_sym_LT_LT_TILDE] = ACTIONS(619),
    [anon_sym_GT_GT_TILDE] = ACTIONS(619),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(619),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(619),
    [anon_sym_GT_TILDE] = ACTIONS(619),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(619),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(619),
    [anon_sym_LT_TILDE] = ACTIONS(619),
    [anon_sym_PLUS_QMARK] = ACTIONS(619),
    [anon_sym_DASH_QMARK] = ACTIONS(619),
    [anon_sym_STAR_QMARK] = ACTIONS(619),
    [anon_sym_SLASH_QMARK] = ACTIONS(619),
    [anon_sym_PERCENT_QMARK] = ACTIONS(619),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(619),
    [anon_sym_as] = ACTIONS(619),
    [anon_sym_LPAREN2] = ACTIONS(619),
    [anon_sym_DOT_GT] = ACTIONS(619),
    [anon_sym_where] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(619),
    [anon_sym_end] = ACTIONS(619),
    [anon_sym_if] = ACTIONS(621),
    [anon_sym_ifdef] = ACTIONS(619),
    [anon_sym_then] = ACTIONS(619),
    [anon_sym_iftype] = ACTIONS(619),
    [anon_sym_else] = ACTIONS(619),
    [anon_sym_for] = ACTIONS(619),
    [anon_sym_while] = ACTIONS(619),
    [anon_sym_try] = ACTIONS(619),
    [anon_sym_with] = ACTIONS(619),
    [anon_sym_repeat] = ACTIONS(619),
    [anon_sym_until] = ACTIONS(619),
    [anon_sym_do] = ACTIONS(619),
    [anon_sym_recover] = ACTIONS(619),
    [anon_sym_match] = ACTIONS(619),
    [anon_sym_return] = ACTIONS(619),
    [anon_sym_continue] = ACTIONS(619),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_consume] = ACTIONS(619),
    [anon_sym_object] = ACTIONS(619),
    [sym_number] = ACTIONS(621),
    [sym_float] = ACTIONS(619),
    [anon_sym_DQUOTE] = ACTIONS(621),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(619),
    [anon_sym_SQUOTE] = ACTIONS(619),
    [anon_sym_true] = ACTIONS(619),
    [anon_sym_false] = ACTIONS(619),
    [sym_this] = ACTIONS(619),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(790),
    [sym_block_comment] = ACTIONS(3),
  },
  [95] = {
    [aux_sym_base_type_repeat1] = STATE(95),
    [sym_identifier] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(625),
    [anon_sym_AT] = ACTIONS(623),
    [anon_sym_LBRACK] = ACTIONS(623),
    [anon_sym_RBRACK] = ACTIONS(623),
    [anon_sym_is] = ACTIONS(625),
    [anon_sym_embed] = ACTIONS(623),
    [anon_sym_let] = ACTIONS(623),
    [anon_sym_var] = ACTIONS(623),
    [anon_sym_new] = ACTIONS(623),
    [anon_sym_EQ_GT] = ACTIONS(623),
    [anon_sym_fun] = ACTIONS(623),
    [anon_sym_be] = ACTIONS(623),
    [anon_sym_COMMA] = ACTIONS(623),
    [anon_sym_iso] = ACTIONS(623),
    [anon_sym_trn] = ACTIONS(623),
    [anon_sym_ref] = ACTIONS(623),
    [anon_sym_val] = ACTIONS(623),
    [anon_sym_box] = ACTIONS(623),
    [anon_sym_tag] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(623),
    [anon_sym_DOT] = ACTIONS(792),
    [anon_sym_POUNDread] = ACTIONS(623),
    [anon_sym_POUNDsend] = ACTIONS(623),
    [anon_sym_POUNDshare] = ACTIONS(623),
    [anon_sym_POUNDalias] = ACTIONS(623),
    [anon_sym_POUNDany] = ACTIONS(623),
    [anon_sym_BANG] = ACTIONS(625),
    [anon_sym_CARET] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(623),
    [anon_sym_AMP] = ACTIONS(623),
    [anon_sym_DASH_GT] = ACTIONS(623),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(623),
    [sym_error] = ACTIONS(623),
    [sym_compile_intrinsic] = ACTIONS(623),
    [anon_sym_compile_error] = ACTIONS(623),
    [sym_location] = ACTIONS(623),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_not] = ACTIONS(623),
    [anon_sym_DASH_TILDE] = ACTIONS(623),
    [anon_sym_addressof] = ACTIONS(623),
    [anon_sym_digestof] = ACTIONS(623),
    [anon_sym_PLUS] = ACTIONS(625),
    [anon_sym_STAR] = ACTIONS(625),
    [anon_sym_SLASH] = ACTIONS(625),
    [anon_sym_PERCENT] = ACTIONS(625),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(625),
    [anon_sym_LT_LT] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(625),
    [anon_sym_and] = ACTIONS(623),
    [anon_sym_or] = ACTIONS(623),
    [anon_sym_xor] = ACTIONS(623),
    [anon_sym_isnt] = ACTIONS(623),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(625),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_LT] = ACTIONS(625),
    [anon_sym_PLUS_TILDE] = ACTIONS(623),
    [anon_sym_STAR_TILDE] = ACTIONS(623),
    [anon_sym_SLASH_TILDE] = ACTIONS(623),
    [anon_sym_PERCENT_TILDE] = ACTIONS(623),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(623),
    [anon_sym_LT_LT_TILDE] = ACTIONS(623),
    [anon_sym_GT_GT_TILDE] = ACTIONS(623),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(623),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(623),
    [anon_sym_GT_TILDE] = ACTIONS(623),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(623),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(623),
    [anon_sym_LT_TILDE] = ACTIONS(623),
    [anon_sym_PLUS_QMARK] = ACTIONS(623),
    [anon_sym_DASH_QMARK] = ACTIONS(623),
    [anon_sym_STAR_QMARK] = ACTIONS(623),
    [anon_sym_SLASH_QMARK] = ACTIONS(623),
    [anon_sym_PERCENT_QMARK] = ACTIONS(623),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(623),
    [anon_sym_as] = ACTIONS(623),
    [anon_sym_LPAREN2] = ACTIONS(623),
    [anon_sym_DOT_GT] = ACTIONS(623),
    [anon_sym_where] = ACTIONS(623),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_end] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_ifdef] = ACTIONS(623),
    [anon_sym_then] = ACTIONS(623),
    [anon_sym_iftype] = ACTIONS(623),
    [anon_sym_else] = ACTIONS(623),
    [anon_sym_for] = ACTIONS(623),
    [anon_sym_while] = ACTIONS(623),
    [anon_sym_try] = ACTIONS(623),
    [anon_sym_with] = ACTIONS(623),
    [anon_sym_repeat] = ACTIONS(623),
    [anon_sym_until] = ACTIONS(623),
    [anon_sym_do] = ACTIONS(623),
    [anon_sym_recover] = ACTIONS(623),
    [anon_sym_match] = ACTIONS(623),
    [anon_sym_return] = ACTIONS(623),
    [anon_sym_continue] = ACTIONS(623),
    [anon_sym_break] = ACTIONS(623),
    [anon_sym_consume] = ACTIONS(623),
    [anon_sym_object] = ACTIONS(623),
    [sym_number] = ACTIONS(625),
    [sym_float] = ACTIONS(623),
    [anon_sym_DQUOTE] = ACTIONS(625),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(623),
    [anon_sym_SQUOTE] = ACTIONS(623),
    [anon_sym_true] = ACTIONS(623),
    [anon_sym_false] = ACTIONS(623),
    [sym_this] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(623),
    [sym_block_comment] = ACTIONS(3),
  },
  [96] = {
    [sym_identifier] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(625),
    [anon_sym_AT] = ACTIONS(623),
    [anon_sym_LBRACK] = ACTIONS(623),
    [anon_sym_RBRACK] = ACTIONS(623),
    [anon_sym_is] = ACTIONS(625),
    [anon_sym_embed] = ACTIONS(623),
    [anon_sym_let] = ACTIONS(623),
    [anon_sym_var] = ACTIONS(623),
    [anon_sym_new] = ACTIONS(623),
    [anon_sym_EQ_GT] = ACTIONS(623),
    [anon_sym_fun] = ACTIONS(623),
    [anon_sym_be] = ACTIONS(623),
    [anon_sym_COMMA] = ACTIONS(623),
    [anon_sym_iso] = ACTIONS(623),
    [anon_sym_trn] = ACTIONS(623),
    [anon_sym_ref] = ACTIONS(623),
    [anon_sym_val] = ACTIONS(623),
    [anon_sym_box] = ACTIONS(623),
    [anon_sym_tag] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(623),
    [anon_sym_DOT] = ACTIONS(625),
    [anon_sym_POUNDread] = ACTIONS(623),
    [anon_sym_POUNDsend] = ACTIONS(623),
    [anon_sym_POUNDshare] = ACTIONS(623),
    [anon_sym_POUNDalias] = ACTIONS(623),
    [anon_sym_POUNDany] = ACTIONS(623),
    [anon_sym_BANG] = ACTIONS(625),
    [anon_sym_CARET] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(623),
    [anon_sym_AMP] = ACTIONS(623),
    [anon_sym_DASH_GT] = ACTIONS(623),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(623),
    [sym_error] = ACTIONS(623),
    [sym_compile_intrinsic] = ACTIONS(623),
    [anon_sym_compile_error] = ACTIONS(623),
    [sym_location] = ACTIONS(623),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_not] = ACTIONS(623),
    [anon_sym_DASH_TILDE] = ACTIONS(623),
    [anon_sym_addressof] = ACTIONS(623),
    [anon_sym_digestof] = ACTIONS(623),
    [anon_sym_PLUS] = ACTIONS(625),
    [anon_sym_STAR] = ACTIONS(625),
    [anon_sym_SLASH] = ACTIONS(625),
    [anon_sym_PERCENT] = ACTIONS(625),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(625),
    [anon_sym_LT_LT] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(625),
    [anon_sym_and] = ACTIONS(623),
    [anon_sym_or] = ACTIONS(623),
    [anon_sym_xor] = ACTIONS(623),
    [anon_sym_isnt] = ACTIONS(623),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(625),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_LT] = ACTIONS(625),
    [anon_sym_PLUS_TILDE] = ACTIONS(623),
    [anon_sym_STAR_TILDE] = ACTIONS(623),
    [anon_sym_SLASH_TILDE] = ACTIONS(623),
    [anon_sym_PERCENT_TILDE] = ACTIONS(623),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(623),
    [anon_sym_LT_LT_TILDE] = ACTIONS(623),
    [anon_sym_GT_GT_TILDE] = ACTIONS(623),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(623),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(623),
    [anon_sym_GT_TILDE] = ACTIONS(623),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(623),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(623),
    [anon_sym_LT_TILDE] = ACTIONS(623),
    [anon_sym_PLUS_QMARK] = ACTIONS(623),
    [anon_sym_DASH_QMARK] = ACTIONS(623),
    [anon_sym_STAR_QMARK] = ACTIONS(623),
    [anon_sym_SLASH_QMARK] = ACTIONS(623),
    [anon_sym_PERCENT_QMARK] = ACTIONS(623),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(623),
    [anon_sym_as] = ACTIONS(623),
    [anon_sym_LPAREN2] = ACTIONS(623),
    [anon_sym_DOT_GT] = ACTIONS(623),
    [anon_sym_where] = ACTIONS(623),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_end] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_ifdef] = ACTIONS(623),
    [anon_sym_then] = ACTIONS(623),
    [anon_sym_iftype] = ACTIONS(623),
    [anon_sym_else] = ACTIONS(623),
    [anon_sym_for] = ACTIONS(623),
    [anon_sym_while] = ACTIONS(623),
    [anon_sym_try] = ACTIONS(623),
    [anon_sym_with] = ACTIONS(623),
    [anon_sym_repeat] = ACTIONS(623),
    [anon_sym_until] = ACTIONS(623),
    [anon_sym_do] = ACTIONS(623),
    [anon_sym_recover] = ACTIONS(623),
    [anon_sym_match] = ACTIONS(623),
    [anon_sym_return] = ACTIONS(623),
    [anon_sym_continue] = ACTIONS(623),
    [anon_sym_break] = ACTIONS(623),
    [anon_sym_consume] = ACTIONS(623),
    [anon_sym_object] = ACTIONS(623),
    [sym_number] = ACTIONS(625),
    [sym_float] = ACTIONS(623),
    [anon_sym_DQUOTE] = ACTIONS(625),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(623),
    [anon_sym_SQUOTE] = ACTIONS(623),
    [anon_sym_true] = ACTIONS(623),
    [anon_sym_false] = ACTIONS(623),
    [sym_this] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(623),
    [sym_block_comment] = ACTIONS(3),
  },
  [97] = {
    [sym_identifier] = ACTIONS(680),
    [anon_sym_EQ] = ACTIONS(680),
    [anon_sym_AT] = ACTIONS(678),
    [anon_sym_LBRACK] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(678),
    [anon_sym_is] = ACTIONS(680),
    [anon_sym_embed] = ACTIONS(678),
    [anon_sym_let] = ACTIONS(678),
    [anon_sym_var] = ACTIONS(678),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_EQ_GT] = ACTIONS(678),
    [anon_sym_fun] = ACTIONS(678),
    [anon_sym_be] = ACTIONS(678),
    [anon_sym_COMMA] = ACTIONS(678),
    [anon_sym_iso] = ACTIONS(795),
    [anon_sym_trn] = ACTIONS(797),
    [anon_sym_ref] = ACTIONS(799),
    [anon_sym_val] = ACTIONS(801),
    [anon_sym_box] = ACTIONS(803),
    [anon_sym_tag] = ACTIONS(805),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_RPAREN] = ACTIONS(678),
    [anon_sym_DOT] = ACTIONS(680),
    [anon_sym_POUNDread] = ACTIONS(807),
    [anon_sym_POUNDsend] = ACTIONS(809),
    [anon_sym_POUNDshare] = ACTIONS(811),
    [anon_sym_POUNDalias] = ACTIONS(813),
    [anon_sym_POUNDany] = ACTIONS(815),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_CARET] = ACTIONS(678),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_AMP] = ACTIONS(678),
    [anon_sym_DASH_GT] = ACTIONS(678),
    [anon_sym_LBRACE] = ACTIONS(678),
    [anon_sym_RBRACE] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(678),
    [sym_error] = ACTIONS(678),
    [sym_compile_intrinsic] = ACTIONS(678),
    [anon_sym_compile_error] = ACTIONS(678),
    [sym_location] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(680),
    [anon_sym_not] = ACTIONS(678),
    [anon_sym_DASH_TILDE] = ACTIONS(678),
    [anon_sym_addressof] = ACTIONS(678),
    [anon_sym_digestof] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(680),
    [anon_sym_STAR] = ACTIONS(680),
    [anon_sym_SLASH] = ACTIONS(680),
    [anon_sym_PERCENT] = ACTIONS(680),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(680),
    [anon_sym_LT_LT] = ACTIONS(680),
    [anon_sym_GT_GT] = ACTIONS(680),
    [anon_sym_and] = ACTIONS(678),
    [anon_sym_or] = ACTIONS(678),
    [anon_sym_xor] = ACTIONS(678),
    [anon_sym_isnt] = ACTIONS(678),
    [anon_sym_EQ_EQ] = ACTIONS(680),
    [anon_sym_BANG_EQ] = ACTIONS(680),
    [anon_sym_GT] = ACTIONS(680),
    [anon_sym_GT_EQ] = ACTIONS(680),
    [anon_sym_LT_EQ] = ACTIONS(680),
    [anon_sym_LT] = ACTIONS(680),
    [anon_sym_PLUS_TILDE] = ACTIONS(678),
    [anon_sym_STAR_TILDE] = ACTIONS(678),
    [anon_sym_SLASH_TILDE] = ACTIONS(678),
    [anon_sym_PERCENT_TILDE] = ACTIONS(678),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(678),
    [anon_sym_LT_LT_TILDE] = ACTIONS(678),
    [anon_sym_GT_GT_TILDE] = ACTIONS(678),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(678),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(678),
    [anon_sym_GT_TILDE] = ACTIONS(678),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(678),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(678),
    [anon_sym_LT_TILDE] = ACTIONS(678),
    [anon_sym_PLUS_QMARK] = ACTIONS(678),
    [anon_sym_DASH_QMARK] = ACTIONS(678),
    [anon_sym_STAR_QMARK] = ACTIONS(678),
    [anon_sym_SLASH_QMARK] = ACTIONS(678),
    [anon_sym_PERCENT_QMARK] = ACTIONS(678),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(678),
    [anon_sym_as] = ACTIONS(678),
    [anon_sym_LPAREN2] = ACTIONS(678),
    [anon_sym_DOT_GT] = ACTIONS(678),
    [anon_sym_where] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(678),
    [anon_sym_end] = ACTIONS(678),
    [anon_sym_if] = ACTIONS(680),
    [anon_sym_ifdef] = ACTIONS(678),
    [anon_sym_then] = ACTIONS(678),
    [anon_sym_iftype] = ACTIONS(678),
    [anon_sym_else] = ACTIONS(678),
    [anon_sym_for] = ACTIONS(678),
    [anon_sym_while] = ACTIONS(678),
    [anon_sym_try] = ACTIONS(678),
    [anon_sym_with] = ACTIONS(678),
    [anon_sym_repeat] = ACTIONS(678),
    [anon_sym_until] = ACTIONS(678),
    [anon_sym_do] = ACTIONS(678),
    [anon_sym_recover] = ACTIONS(678),
    [anon_sym_match] = ACTIONS(678),
    [anon_sym_return] = ACTIONS(678),
    [anon_sym_continue] = ACTIONS(678),
    [anon_sym_break] = ACTIONS(678),
    [anon_sym_consume] = ACTIONS(678),
    [anon_sym_object] = ACTIONS(678),
    [sym_number] = ACTIONS(680),
    [sym_float] = ACTIONS(678),
    [anon_sym_DQUOTE] = ACTIONS(680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(678),
    [anon_sym_true] = ACTIONS(678),
    [anon_sym_false] = ACTIONS(678),
    [sym_this] = ACTIONS(678),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [98] = {
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(730),
    [anon_sym_AT] = ACTIONS(728),
    [anon_sym_LBRACK] = ACTIONS(728),
    [anon_sym_RBRACK] = ACTIONS(728),
    [anon_sym_is] = ACTIONS(730),
    [anon_sym_embed] = ACTIONS(728),
    [anon_sym_let] = ACTIONS(728),
    [anon_sym_var] = ACTIONS(728),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_EQ_GT] = ACTIONS(728),
    [anon_sym_fun] = ACTIONS(728),
    [anon_sym_be] = ACTIONS(728),
    [anon_sym_COMMA] = ACTIONS(728),
    [anon_sym_iso] = ACTIONS(728),
    [anon_sym_trn] = ACTIONS(728),
    [anon_sym_ref] = ACTIONS(728),
    [anon_sym_val] = ACTIONS(728),
    [anon_sym_box] = ACTIONS(728),
    [anon_sym_tag] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(730),
    [anon_sym_RPAREN] = ACTIONS(728),
    [anon_sym_DOT] = ACTIONS(730),
    [anon_sym_POUNDread] = ACTIONS(728),
    [anon_sym_POUNDsend] = ACTIONS(728),
    [anon_sym_POUNDshare] = ACTIONS(728),
    [anon_sym_POUNDalias] = ACTIONS(728),
    [anon_sym_POUNDany] = ACTIONS(728),
    [anon_sym_BANG] = ACTIONS(730),
    [anon_sym_CARET] = ACTIONS(728),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_DASH_GT] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(728),
    [anon_sym_RBRACE] = ACTIONS(728),
    [anon_sym_SEMI] = ACTIONS(728),
    [sym_error] = ACTIONS(728),
    [sym_compile_intrinsic] = ACTIONS(728),
    [anon_sym_compile_error] = ACTIONS(728),
    [sym_location] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(730),
    [anon_sym_not] = ACTIONS(728),
    [anon_sym_DASH_TILDE] = ACTIONS(728),
    [anon_sym_addressof] = ACTIONS(728),
    [anon_sym_digestof] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(730),
    [anon_sym_STAR] = ACTIONS(730),
    [anon_sym_SLASH] = ACTIONS(730),
    [anon_sym_PERCENT] = ACTIONS(730),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(730),
    [anon_sym_LT_LT] = ACTIONS(730),
    [anon_sym_GT_GT] = ACTIONS(730),
    [anon_sym_and] = ACTIONS(728),
    [anon_sym_or] = ACTIONS(728),
    [anon_sym_xor] = ACTIONS(728),
    [anon_sym_isnt] = ACTIONS(728),
    [anon_sym_EQ_EQ] = ACTIONS(730),
    [anon_sym_BANG_EQ] = ACTIONS(730),
    [anon_sym_GT] = ACTIONS(730),
    [anon_sym_GT_EQ] = ACTIONS(730),
    [anon_sym_LT_EQ] = ACTIONS(730),
    [anon_sym_LT] = ACTIONS(730),
    [anon_sym_PLUS_TILDE] = ACTIONS(728),
    [anon_sym_STAR_TILDE] = ACTIONS(728),
    [anon_sym_SLASH_TILDE] = ACTIONS(728),
    [anon_sym_PERCENT_TILDE] = ACTIONS(728),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(728),
    [anon_sym_LT_LT_TILDE] = ACTIONS(728),
    [anon_sym_GT_GT_TILDE] = ACTIONS(728),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(728),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(728),
    [anon_sym_GT_TILDE] = ACTIONS(728),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(728),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(728),
    [anon_sym_LT_TILDE] = ACTIONS(728),
    [anon_sym_PLUS_QMARK] = ACTIONS(728),
    [anon_sym_DASH_QMARK] = ACTIONS(728),
    [anon_sym_STAR_QMARK] = ACTIONS(728),
    [anon_sym_SLASH_QMARK] = ACTIONS(728),
    [anon_sym_PERCENT_QMARK] = ACTIONS(728),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(728),
    [anon_sym_as] = ACTIONS(728),
    [anon_sym_LPAREN2] = ACTIONS(728),
    [anon_sym_DOT_GT] = ACTIONS(728),
    [anon_sym_where] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_end] = ACTIONS(728),
    [anon_sym_if] = ACTIONS(730),
    [anon_sym_ifdef] = ACTIONS(728),
    [anon_sym_then] = ACTIONS(728),
    [anon_sym_iftype] = ACTIONS(728),
    [anon_sym_else] = ACTIONS(728),
    [anon_sym_for] = ACTIONS(728),
    [anon_sym_while] = ACTIONS(728),
    [anon_sym_try] = ACTIONS(728),
    [anon_sym_with] = ACTIONS(728),
    [anon_sym_repeat] = ACTIONS(728),
    [anon_sym_until] = ACTIONS(728),
    [anon_sym_do] = ACTIONS(728),
    [anon_sym_recover] = ACTIONS(728),
    [anon_sym_match] = ACTIONS(728),
    [anon_sym_return] = ACTIONS(728),
    [anon_sym_continue] = ACTIONS(728),
    [anon_sym_break] = ACTIONS(728),
    [anon_sym_consume] = ACTIONS(728),
    [anon_sym_object] = ACTIONS(728),
    [sym_number] = ACTIONS(730),
    [sym_float] = ACTIONS(728),
    [anon_sym_DQUOTE] = ACTIONS(730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(728),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_true] = ACTIONS(728),
    [anon_sym_false] = ACTIONS(728),
    [sym_this] = ACTIONS(728),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [99] = {
    [sym_identifier] = ACTIONS(750),
    [anon_sym_EQ] = ACTIONS(750),
    [anon_sym_AT] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(748),
    [anon_sym_RBRACK] = ACTIONS(748),
    [anon_sym_is] = ACTIONS(750),
    [anon_sym_embed] = ACTIONS(748),
    [anon_sym_let] = ACTIONS(748),
    [anon_sym_var] = ACTIONS(748),
    [anon_sym_new] = ACTIONS(748),
    [anon_sym_EQ_GT] = ACTIONS(748),
    [anon_sym_fun] = ACTIONS(748),
    [anon_sym_be] = ACTIONS(748),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_iso] = ACTIONS(748),
    [anon_sym_trn] = ACTIONS(748),
    [anon_sym_ref] = ACTIONS(748),
    [anon_sym_val] = ACTIONS(748),
    [anon_sym_box] = ACTIONS(748),
    [anon_sym_tag] = ACTIONS(748),
    [anon_sym_LPAREN] = ACTIONS(750),
    [anon_sym_RPAREN] = ACTIONS(748),
    [anon_sym_DOT] = ACTIONS(750),
    [anon_sym_POUNDread] = ACTIONS(748),
    [anon_sym_POUNDsend] = ACTIONS(748),
    [anon_sym_POUNDshare] = ACTIONS(748),
    [anon_sym_POUNDalias] = ACTIONS(748),
    [anon_sym_POUNDany] = ACTIONS(748),
    [anon_sym_BANG] = ACTIONS(750),
    [anon_sym_CARET] = ACTIONS(748),
    [anon_sym_PIPE] = ACTIONS(748),
    [anon_sym_AMP] = ACTIONS(748),
    [anon_sym_DASH_GT] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(748),
    [anon_sym_SEMI] = ACTIONS(748),
    [sym_error] = ACTIONS(748),
    [sym_compile_intrinsic] = ACTIONS(748),
    [anon_sym_compile_error] = ACTIONS(748),
    [sym_location] = ACTIONS(748),
    [anon_sym_DASH] = ACTIONS(750),
    [anon_sym_not] = ACTIONS(748),
    [anon_sym_DASH_TILDE] = ACTIONS(748),
    [anon_sym_addressof] = ACTIONS(748),
    [anon_sym_digestof] = ACTIONS(748),
    [anon_sym_PLUS] = ACTIONS(750),
    [anon_sym_STAR] = ACTIONS(750),
    [anon_sym_SLASH] = ACTIONS(750),
    [anon_sym_PERCENT] = ACTIONS(750),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(750),
    [anon_sym_LT_LT] = ACTIONS(750),
    [anon_sym_GT_GT] = ACTIONS(750),
    [anon_sym_and] = ACTIONS(748),
    [anon_sym_or] = ACTIONS(748),
    [anon_sym_xor] = ACTIONS(748),
    [anon_sym_isnt] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(750),
    [anon_sym_BANG_EQ] = ACTIONS(750),
    [anon_sym_GT] = ACTIONS(750),
    [anon_sym_GT_EQ] = ACTIONS(750),
    [anon_sym_LT_EQ] = ACTIONS(750),
    [anon_sym_LT] = ACTIONS(750),
    [anon_sym_PLUS_TILDE] = ACTIONS(748),
    [anon_sym_STAR_TILDE] = ACTIONS(748),
    [anon_sym_SLASH_TILDE] = ACTIONS(748),
    [anon_sym_PERCENT_TILDE] = ACTIONS(748),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(748),
    [anon_sym_LT_LT_TILDE] = ACTIONS(748),
    [anon_sym_GT_GT_TILDE] = ACTIONS(748),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(748),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(748),
    [anon_sym_GT_TILDE] = ACTIONS(748),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(748),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(748),
    [anon_sym_LT_TILDE] = ACTIONS(748),
    [anon_sym_PLUS_QMARK] = ACTIONS(748),
    [anon_sym_DASH_QMARK] = ACTIONS(748),
    [anon_sym_STAR_QMARK] = ACTIONS(748),
    [anon_sym_SLASH_QMARK] = ACTIONS(748),
    [anon_sym_PERCENT_QMARK] = ACTIONS(748),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(748),
    [anon_sym_LPAREN2] = ACTIONS(748),
    [anon_sym_DOT_GT] = ACTIONS(748),
    [anon_sym_where] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_end] = ACTIONS(748),
    [anon_sym_if] = ACTIONS(750),
    [anon_sym_ifdef] = ACTIONS(748),
    [anon_sym_then] = ACTIONS(748),
    [anon_sym_iftype] = ACTIONS(748),
    [anon_sym_else] = ACTIONS(748),
    [anon_sym_for] = ACTIONS(748),
    [anon_sym_while] = ACTIONS(748),
    [anon_sym_try] = ACTIONS(748),
    [anon_sym_with] = ACTIONS(748),
    [anon_sym_repeat] = ACTIONS(748),
    [anon_sym_until] = ACTIONS(748),
    [anon_sym_do] = ACTIONS(748),
    [anon_sym_recover] = ACTIONS(748),
    [anon_sym_match] = ACTIONS(748),
    [anon_sym_return] = ACTIONS(748),
    [anon_sym_continue] = ACTIONS(748),
    [anon_sym_break] = ACTIONS(748),
    [anon_sym_consume] = ACTIONS(748),
    [anon_sym_object] = ACTIONS(748),
    [sym_number] = ACTIONS(750),
    [sym_float] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(748),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [anon_sym_true] = ACTIONS(748),
    [anon_sym_false] = ACTIONS(748),
    [sym_this] = ACTIONS(748),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [100] = {
    [sym_identifier] = ACTIONS(746),
    [anon_sym_EQ] = ACTIONS(746),
    [anon_sym_AT] = ACTIONS(744),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_RBRACK] = ACTIONS(744),
    [anon_sym_is] = ACTIONS(746),
    [anon_sym_embed] = ACTIONS(744),
    [anon_sym_let] = ACTIONS(744),
    [anon_sym_var] = ACTIONS(744),
    [anon_sym_new] = ACTIONS(744),
    [anon_sym_EQ_GT] = ACTIONS(744),
    [anon_sym_fun] = ACTIONS(744),
    [anon_sym_be] = ACTIONS(744),
    [anon_sym_COMMA] = ACTIONS(744),
    [anon_sym_iso] = ACTIONS(744),
    [anon_sym_trn] = ACTIONS(744),
    [anon_sym_ref] = ACTIONS(744),
    [anon_sym_val] = ACTIONS(744),
    [anon_sym_box] = ACTIONS(744),
    [anon_sym_tag] = ACTIONS(744),
    [anon_sym_LPAREN] = ACTIONS(746),
    [anon_sym_RPAREN] = ACTIONS(744),
    [anon_sym_DOT] = ACTIONS(746),
    [anon_sym_POUNDread] = ACTIONS(744),
    [anon_sym_POUNDsend] = ACTIONS(744),
    [anon_sym_POUNDshare] = ACTIONS(744),
    [anon_sym_POUNDalias] = ACTIONS(744),
    [anon_sym_POUNDany] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_CARET] = ACTIONS(744),
    [anon_sym_PIPE] = ACTIONS(744),
    [anon_sym_AMP] = ACTIONS(744),
    [anon_sym_DASH_GT] = ACTIONS(744),
    [anon_sym_LBRACE] = ACTIONS(744),
    [anon_sym_RBRACE] = ACTIONS(744),
    [anon_sym_SEMI] = ACTIONS(744),
    [sym_error] = ACTIONS(744),
    [sym_compile_intrinsic] = ACTIONS(744),
    [anon_sym_compile_error] = ACTIONS(744),
    [sym_location] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_not] = ACTIONS(744),
    [anon_sym_DASH_TILDE] = ACTIONS(744),
    [anon_sym_addressof] = ACTIONS(744),
    [anon_sym_digestof] = ACTIONS(744),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(746),
    [anon_sym_SLASH] = ACTIONS(746),
    [anon_sym_PERCENT] = ACTIONS(746),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(746),
    [anon_sym_LT_LT] = ACTIONS(746),
    [anon_sym_GT_GT] = ACTIONS(746),
    [anon_sym_and] = ACTIONS(744),
    [anon_sym_or] = ACTIONS(744),
    [anon_sym_xor] = ACTIONS(744),
    [anon_sym_isnt] = ACTIONS(744),
    [anon_sym_EQ_EQ] = ACTIONS(746),
    [anon_sym_BANG_EQ] = ACTIONS(746),
    [anon_sym_GT] = ACTIONS(746),
    [anon_sym_GT_EQ] = ACTIONS(746),
    [anon_sym_LT_EQ] = ACTIONS(746),
    [anon_sym_LT] = ACTIONS(746),
    [anon_sym_PLUS_TILDE] = ACTIONS(744),
    [anon_sym_STAR_TILDE] = ACTIONS(744),
    [anon_sym_SLASH_TILDE] = ACTIONS(744),
    [anon_sym_PERCENT_TILDE] = ACTIONS(744),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(744),
    [anon_sym_LT_LT_TILDE] = ACTIONS(744),
    [anon_sym_GT_GT_TILDE] = ACTIONS(744),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(744),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(744),
    [anon_sym_GT_TILDE] = ACTIONS(744),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(744),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(744),
    [anon_sym_LT_TILDE] = ACTIONS(744),
    [anon_sym_PLUS_QMARK] = ACTIONS(744),
    [anon_sym_DASH_QMARK] = ACTIONS(744),
    [anon_sym_STAR_QMARK] = ACTIONS(744),
    [anon_sym_SLASH_QMARK] = ACTIONS(744),
    [anon_sym_PERCENT_QMARK] = ACTIONS(744),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(744),
    [anon_sym_as] = ACTIONS(744),
    [anon_sym_LPAREN2] = ACTIONS(744),
    [anon_sym_DOT_GT] = ACTIONS(744),
    [anon_sym_where] = ACTIONS(744),
    [anon_sym_TILDE] = ACTIONS(744),
    [anon_sym_end] = ACTIONS(744),
    [anon_sym_if] = ACTIONS(746),
    [anon_sym_ifdef] = ACTIONS(744),
    [anon_sym_then] = ACTIONS(744),
    [anon_sym_iftype] = ACTIONS(744),
    [anon_sym_else] = ACTIONS(744),
    [anon_sym_for] = ACTIONS(744),
    [anon_sym_while] = ACTIONS(744),
    [anon_sym_try] = ACTIONS(744),
    [anon_sym_with] = ACTIONS(744),
    [anon_sym_repeat] = ACTIONS(744),
    [anon_sym_until] = ACTIONS(744),
    [anon_sym_do] = ACTIONS(744),
    [anon_sym_recover] = ACTIONS(744),
    [anon_sym_match] = ACTIONS(744),
    [anon_sym_return] = ACTIONS(744),
    [anon_sym_continue] = ACTIONS(744),
    [anon_sym_break] = ACTIONS(744),
    [anon_sym_consume] = ACTIONS(744),
    [anon_sym_object] = ACTIONS(744),
    [sym_number] = ACTIONS(746),
    [sym_float] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(744),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [anon_sym_true] = ACTIONS(744),
    [anon_sym_false] = ACTIONS(744),
    [sym_this] = ACTIONS(744),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [101] = {
    [sym_identifier] = ACTIONS(742),
    [anon_sym_EQ] = ACTIONS(742),
    [anon_sym_AT] = ACTIONS(740),
    [anon_sym_LBRACK] = ACTIONS(740),
    [anon_sym_RBRACK] = ACTIONS(740),
    [anon_sym_is] = ACTIONS(742),
    [anon_sym_embed] = ACTIONS(740),
    [anon_sym_let] = ACTIONS(740),
    [anon_sym_var] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_EQ_GT] = ACTIONS(740),
    [anon_sym_fun] = ACTIONS(740),
    [anon_sym_be] = ACTIONS(740),
    [anon_sym_COMMA] = ACTIONS(740),
    [anon_sym_iso] = ACTIONS(740),
    [anon_sym_trn] = ACTIONS(740),
    [anon_sym_ref] = ACTIONS(740),
    [anon_sym_val] = ACTIONS(740),
    [anon_sym_box] = ACTIONS(740),
    [anon_sym_tag] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(742),
    [anon_sym_RPAREN] = ACTIONS(740),
    [anon_sym_DOT] = ACTIONS(742),
    [anon_sym_POUNDread] = ACTIONS(740),
    [anon_sym_POUNDsend] = ACTIONS(740),
    [anon_sym_POUNDshare] = ACTIONS(740),
    [anon_sym_POUNDalias] = ACTIONS(740),
    [anon_sym_POUNDany] = ACTIONS(740),
    [anon_sym_BANG] = ACTIONS(742),
    [anon_sym_CARET] = ACTIONS(740),
    [anon_sym_PIPE] = ACTIONS(740),
    [anon_sym_AMP] = ACTIONS(740),
    [anon_sym_DASH_GT] = ACTIONS(740),
    [anon_sym_LBRACE] = ACTIONS(740),
    [anon_sym_RBRACE] = ACTIONS(740),
    [anon_sym_SEMI] = ACTIONS(740),
    [sym_error] = ACTIONS(740),
    [sym_compile_intrinsic] = ACTIONS(740),
    [anon_sym_compile_error] = ACTIONS(740),
    [sym_location] = ACTIONS(740),
    [anon_sym_DASH] = ACTIONS(742),
    [anon_sym_not] = ACTIONS(740),
    [anon_sym_DASH_TILDE] = ACTIONS(740),
    [anon_sym_addressof] = ACTIONS(740),
    [anon_sym_digestof] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(742),
    [anon_sym_STAR] = ACTIONS(742),
    [anon_sym_SLASH] = ACTIONS(742),
    [anon_sym_PERCENT] = ACTIONS(742),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(742),
    [anon_sym_LT_LT] = ACTIONS(742),
    [anon_sym_GT_GT] = ACTIONS(742),
    [anon_sym_and] = ACTIONS(740),
    [anon_sym_or] = ACTIONS(740),
    [anon_sym_xor] = ACTIONS(740),
    [anon_sym_isnt] = ACTIONS(740),
    [anon_sym_EQ_EQ] = ACTIONS(742),
    [anon_sym_BANG_EQ] = ACTIONS(742),
    [anon_sym_GT] = ACTIONS(742),
    [anon_sym_GT_EQ] = ACTIONS(742),
    [anon_sym_LT_EQ] = ACTIONS(742),
    [anon_sym_LT] = ACTIONS(742),
    [anon_sym_PLUS_TILDE] = ACTIONS(740),
    [anon_sym_STAR_TILDE] = ACTIONS(740),
    [anon_sym_SLASH_TILDE] = ACTIONS(740),
    [anon_sym_PERCENT_TILDE] = ACTIONS(740),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(740),
    [anon_sym_LT_LT_TILDE] = ACTIONS(740),
    [anon_sym_GT_GT_TILDE] = ACTIONS(740),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(740),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(740),
    [anon_sym_GT_TILDE] = ACTIONS(740),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(740),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(740),
    [anon_sym_LT_TILDE] = ACTIONS(740),
    [anon_sym_PLUS_QMARK] = ACTIONS(740),
    [anon_sym_DASH_QMARK] = ACTIONS(740),
    [anon_sym_STAR_QMARK] = ACTIONS(740),
    [anon_sym_SLASH_QMARK] = ACTIONS(740),
    [anon_sym_PERCENT_QMARK] = ACTIONS(740),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(740),
    [anon_sym_as] = ACTIONS(740),
    [anon_sym_LPAREN2] = ACTIONS(740),
    [anon_sym_DOT_GT] = ACTIONS(740),
    [anon_sym_where] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_end] = ACTIONS(740),
    [anon_sym_if] = ACTIONS(742),
    [anon_sym_ifdef] = ACTIONS(740),
    [anon_sym_then] = ACTIONS(740),
    [anon_sym_iftype] = ACTIONS(740),
    [anon_sym_else] = ACTIONS(740),
    [anon_sym_for] = ACTIONS(740),
    [anon_sym_while] = ACTIONS(740),
    [anon_sym_try] = ACTIONS(740),
    [anon_sym_with] = ACTIONS(740),
    [anon_sym_repeat] = ACTIONS(740),
    [anon_sym_until] = ACTIONS(740),
    [anon_sym_do] = ACTIONS(740),
    [anon_sym_recover] = ACTIONS(740),
    [anon_sym_match] = ACTIONS(740),
    [anon_sym_return] = ACTIONS(740),
    [anon_sym_continue] = ACTIONS(740),
    [anon_sym_break] = ACTIONS(740),
    [anon_sym_consume] = ACTIONS(740),
    [anon_sym_object] = ACTIONS(740),
    [sym_number] = ACTIONS(742),
    [sym_float] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(740),
    [anon_sym_SQUOTE] = ACTIONS(740),
    [anon_sym_true] = ACTIONS(740),
    [anon_sym_false] = ACTIONS(740),
    [sym_this] = ACTIONS(740),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [102] = {
    [sym_identifier] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(736),
    [anon_sym_RBRACK] = ACTIONS(736),
    [anon_sym_is] = ACTIONS(738),
    [anon_sym_embed] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(736),
    [anon_sym_var] = ACTIONS(736),
    [anon_sym_new] = ACTIONS(736),
    [anon_sym_EQ_GT] = ACTIONS(736),
    [anon_sym_fun] = ACTIONS(736),
    [anon_sym_be] = ACTIONS(736),
    [anon_sym_COMMA] = ACTIONS(736),
    [anon_sym_iso] = ACTIONS(736),
    [anon_sym_trn] = ACTIONS(736),
    [anon_sym_ref] = ACTIONS(736),
    [anon_sym_val] = ACTIONS(736),
    [anon_sym_box] = ACTIONS(736),
    [anon_sym_tag] = ACTIONS(736),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(736),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_POUNDread] = ACTIONS(736),
    [anon_sym_POUNDsend] = ACTIONS(736),
    [anon_sym_POUNDshare] = ACTIONS(736),
    [anon_sym_POUNDalias] = ACTIONS(736),
    [anon_sym_POUNDany] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(738),
    [anon_sym_CARET] = ACTIONS(736),
    [anon_sym_PIPE] = ACTIONS(736),
    [anon_sym_AMP] = ACTIONS(736),
    [anon_sym_DASH_GT] = ACTIONS(736),
    [anon_sym_LBRACE] = ACTIONS(736),
    [anon_sym_RBRACE] = ACTIONS(736),
    [anon_sym_SEMI] = ACTIONS(736),
    [sym_error] = ACTIONS(736),
    [sym_compile_intrinsic] = ACTIONS(736),
    [anon_sym_compile_error] = ACTIONS(736),
    [sym_location] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_not] = ACTIONS(736),
    [anon_sym_DASH_TILDE] = ACTIONS(736),
    [anon_sym_addressof] = ACTIONS(736),
    [anon_sym_digestof] = ACTIONS(736),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(738),
    [anon_sym_LT_LT] = ACTIONS(738),
    [anon_sym_GT_GT] = ACTIONS(738),
    [anon_sym_and] = ACTIONS(736),
    [anon_sym_or] = ACTIONS(736),
    [anon_sym_xor] = ACTIONS(736),
    [anon_sym_isnt] = ACTIONS(736),
    [anon_sym_EQ_EQ] = ACTIONS(738),
    [anon_sym_BANG_EQ] = ACTIONS(738),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_EQ] = ACTIONS(738),
    [anon_sym_LT] = ACTIONS(738),
    [anon_sym_PLUS_TILDE] = ACTIONS(736),
    [anon_sym_STAR_TILDE] = ACTIONS(736),
    [anon_sym_SLASH_TILDE] = ACTIONS(736),
    [anon_sym_PERCENT_TILDE] = ACTIONS(736),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(736),
    [anon_sym_LT_LT_TILDE] = ACTIONS(736),
    [anon_sym_GT_GT_TILDE] = ACTIONS(736),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(736),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(736),
    [anon_sym_GT_TILDE] = ACTIONS(736),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(736),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(736),
    [anon_sym_LT_TILDE] = ACTIONS(736),
    [anon_sym_PLUS_QMARK] = ACTIONS(736),
    [anon_sym_DASH_QMARK] = ACTIONS(736),
    [anon_sym_STAR_QMARK] = ACTIONS(736),
    [anon_sym_SLASH_QMARK] = ACTIONS(736),
    [anon_sym_PERCENT_QMARK] = ACTIONS(736),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(736),
    [anon_sym_as] = ACTIONS(736),
    [anon_sym_LPAREN2] = ACTIONS(736),
    [anon_sym_DOT_GT] = ACTIONS(736),
    [anon_sym_where] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_end] = ACTIONS(736),
    [anon_sym_if] = ACTIONS(738),
    [anon_sym_ifdef] = ACTIONS(736),
    [anon_sym_then] = ACTIONS(736),
    [anon_sym_iftype] = ACTIONS(736),
    [anon_sym_else] = ACTIONS(736),
    [anon_sym_for] = ACTIONS(736),
    [anon_sym_while] = ACTIONS(736),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_with] = ACTIONS(736),
    [anon_sym_repeat] = ACTIONS(736),
    [anon_sym_until] = ACTIONS(736),
    [anon_sym_do] = ACTIONS(736),
    [anon_sym_recover] = ACTIONS(736),
    [anon_sym_match] = ACTIONS(736),
    [anon_sym_return] = ACTIONS(736),
    [anon_sym_continue] = ACTIONS(736),
    [anon_sym_break] = ACTIONS(736),
    [anon_sym_consume] = ACTIONS(736),
    [anon_sym_object] = ACTIONS(736),
    [sym_number] = ACTIONS(738),
    [sym_float] = ACTIONS(736),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(736),
    [anon_sym_SQUOTE] = ACTIONS(736),
    [anon_sym_true] = ACTIONS(736),
    [anon_sym_false] = ACTIONS(736),
    [sym_this] = ACTIONS(736),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [103] = {
    [sym_identifier] = ACTIONS(636),
    [anon_sym_EQ] = ACTIONS(636),
    [anon_sym_AT] = ACTIONS(634),
    [anon_sym_LBRACK] = ACTIONS(634),
    [anon_sym_RBRACK] = ACTIONS(634),
    [anon_sym_is] = ACTIONS(636),
    [anon_sym_embed] = ACTIONS(634),
    [anon_sym_let] = ACTIONS(634),
    [anon_sym_var] = ACTIONS(634),
    [anon_sym_new] = ACTIONS(634),
    [anon_sym_EQ_GT] = ACTIONS(634),
    [anon_sym_fun] = ACTIONS(634),
    [anon_sym_be] = ACTIONS(634),
    [anon_sym_COMMA] = ACTIONS(634),
    [anon_sym_iso] = ACTIONS(634),
    [anon_sym_trn] = ACTIONS(634),
    [anon_sym_ref] = ACTIONS(634),
    [anon_sym_val] = ACTIONS(634),
    [anon_sym_box] = ACTIONS(634),
    [anon_sym_tag] = ACTIONS(634),
    [anon_sym_LPAREN] = ACTIONS(636),
    [anon_sym_RPAREN] = ACTIONS(634),
    [anon_sym_DOT] = ACTIONS(636),
    [anon_sym_POUNDread] = ACTIONS(634),
    [anon_sym_POUNDsend] = ACTIONS(634),
    [anon_sym_POUNDshare] = ACTIONS(634),
    [anon_sym_POUNDalias] = ACTIONS(634),
    [anon_sym_POUNDany] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_CARET] = ACTIONS(634),
    [anon_sym_PIPE] = ACTIONS(634),
    [anon_sym_AMP] = ACTIONS(634),
    [anon_sym_DASH_GT] = ACTIONS(634),
    [anon_sym_LBRACE] = ACTIONS(634),
    [anon_sym_RBRACE] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(634),
    [sym_error] = ACTIONS(634),
    [sym_compile_intrinsic] = ACTIONS(634),
    [anon_sym_compile_error] = ACTIONS(634),
    [sym_location] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(636),
    [anon_sym_not] = ACTIONS(634),
    [anon_sym_DASH_TILDE] = ACTIONS(634),
    [anon_sym_addressof] = ACTIONS(634),
    [anon_sym_digestof] = ACTIONS(634),
    [anon_sym_PLUS] = ACTIONS(636),
    [anon_sym_STAR] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(636),
    [anon_sym_PERCENT] = ACTIONS(636),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(636),
    [anon_sym_LT_LT] = ACTIONS(636),
    [anon_sym_GT_GT] = ACTIONS(636),
    [anon_sym_and] = ACTIONS(634),
    [anon_sym_or] = ACTIONS(634),
    [anon_sym_xor] = ACTIONS(634),
    [anon_sym_isnt] = ACTIONS(634),
    [anon_sym_EQ_EQ] = ACTIONS(636),
    [anon_sym_BANG_EQ] = ACTIONS(636),
    [anon_sym_GT] = ACTIONS(636),
    [anon_sym_GT_EQ] = ACTIONS(636),
    [anon_sym_LT_EQ] = ACTIONS(636),
    [anon_sym_LT] = ACTIONS(636),
    [anon_sym_PLUS_TILDE] = ACTIONS(634),
    [anon_sym_STAR_TILDE] = ACTIONS(634),
    [anon_sym_SLASH_TILDE] = ACTIONS(634),
    [anon_sym_PERCENT_TILDE] = ACTIONS(634),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(634),
    [anon_sym_LT_LT_TILDE] = ACTIONS(634),
    [anon_sym_GT_GT_TILDE] = ACTIONS(634),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(634),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(634),
    [anon_sym_GT_TILDE] = ACTIONS(634),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(634),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(634),
    [anon_sym_LT_TILDE] = ACTIONS(634),
    [anon_sym_PLUS_QMARK] = ACTIONS(634),
    [anon_sym_DASH_QMARK] = ACTIONS(634),
    [anon_sym_STAR_QMARK] = ACTIONS(634),
    [anon_sym_SLASH_QMARK] = ACTIONS(634),
    [anon_sym_PERCENT_QMARK] = ACTIONS(634),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(634),
    [anon_sym_as] = ACTIONS(634),
    [anon_sym_LPAREN2] = ACTIONS(634),
    [anon_sym_DOT_GT] = ACTIONS(634),
    [anon_sym_where] = ACTIONS(634),
    [anon_sym_TILDE] = ACTIONS(634),
    [anon_sym_end] = ACTIONS(634),
    [anon_sym_if] = ACTIONS(636),
    [anon_sym_ifdef] = ACTIONS(634),
    [anon_sym_then] = ACTIONS(634),
    [anon_sym_iftype] = ACTIONS(634),
    [anon_sym_else] = ACTIONS(634),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(634),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_with] = ACTIONS(634),
    [anon_sym_repeat] = ACTIONS(634),
    [anon_sym_until] = ACTIONS(634),
    [anon_sym_do] = ACTIONS(634),
    [anon_sym_recover] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(634),
    [anon_sym_return] = ACTIONS(634),
    [anon_sym_continue] = ACTIONS(634),
    [anon_sym_break] = ACTIONS(634),
    [anon_sym_consume] = ACTIONS(634),
    [anon_sym_object] = ACTIONS(634),
    [sym_number] = ACTIONS(636),
    [sym_float] = ACTIONS(634),
    [anon_sym_DQUOTE] = ACTIONS(636),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(634),
    [anon_sym_SQUOTE] = ACTIONS(634),
    [anon_sym_true] = ACTIONS(634),
    [anon_sym_false] = ACTIONS(634),
    [sym_this] = ACTIONS(634),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [104] = {
    [sym_identifier] = ACTIONS(632),
    [anon_sym_EQ] = ACTIONS(632),
    [anon_sym_AT] = ACTIONS(630),
    [anon_sym_LBRACK] = ACTIONS(630),
    [anon_sym_RBRACK] = ACTIONS(630),
    [anon_sym_is] = ACTIONS(632),
    [anon_sym_embed] = ACTIONS(630),
    [anon_sym_let] = ACTIONS(630),
    [anon_sym_var] = ACTIONS(630),
    [anon_sym_new] = ACTIONS(630),
    [anon_sym_EQ_GT] = ACTIONS(630),
    [anon_sym_fun] = ACTIONS(630),
    [anon_sym_be] = ACTIONS(630),
    [anon_sym_COMMA] = ACTIONS(630),
    [anon_sym_iso] = ACTIONS(630),
    [anon_sym_trn] = ACTIONS(630),
    [anon_sym_ref] = ACTIONS(630),
    [anon_sym_val] = ACTIONS(630),
    [anon_sym_box] = ACTIONS(630),
    [anon_sym_tag] = ACTIONS(630),
    [anon_sym_LPAREN] = ACTIONS(632),
    [anon_sym_RPAREN] = ACTIONS(630),
    [anon_sym_DOT] = ACTIONS(632),
    [anon_sym_POUNDread] = ACTIONS(630),
    [anon_sym_POUNDsend] = ACTIONS(630),
    [anon_sym_POUNDshare] = ACTIONS(630),
    [anon_sym_POUNDalias] = ACTIONS(630),
    [anon_sym_POUNDany] = ACTIONS(630),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_CARET] = ACTIONS(630),
    [anon_sym_PIPE] = ACTIONS(630),
    [anon_sym_AMP] = ACTIONS(630),
    [anon_sym_DASH_GT] = ACTIONS(630),
    [anon_sym_LBRACE] = ACTIONS(630),
    [anon_sym_RBRACE] = ACTIONS(630),
    [anon_sym_SEMI] = ACTIONS(630),
    [sym_error] = ACTIONS(630),
    [sym_compile_intrinsic] = ACTIONS(630),
    [anon_sym_compile_error] = ACTIONS(630),
    [sym_location] = ACTIONS(630),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_not] = ACTIONS(630),
    [anon_sym_DASH_TILDE] = ACTIONS(630),
    [anon_sym_addressof] = ACTIONS(630),
    [anon_sym_digestof] = ACTIONS(630),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_STAR] = ACTIONS(632),
    [anon_sym_SLASH] = ACTIONS(632),
    [anon_sym_PERCENT] = ACTIONS(632),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(632),
    [anon_sym_LT_LT] = ACTIONS(632),
    [anon_sym_GT_GT] = ACTIONS(632),
    [anon_sym_and] = ACTIONS(630),
    [anon_sym_or] = ACTIONS(630),
    [anon_sym_xor] = ACTIONS(630),
    [anon_sym_isnt] = ACTIONS(630),
    [anon_sym_EQ_EQ] = ACTIONS(632),
    [anon_sym_BANG_EQ] = ACTIONS(632),
    [anon_sym_GT] = ACTIONS(632),
    [anon_sym_GT_EQ] = ACTIONS(632),
    [anon_sym_LT_EQ] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(632),
    [anon_sym_PLUS_TILDE] = ACTIONS(630),
    [anon_sym_STAR_TILDE] = ACTIONS(630),
    [anon_sym_SLASH_TILDE] = ACTIONS(630),
    [anon_sym_PERCENT_TILDE] = ACTIONS(630),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(630),
    [anon_sym_LT_LT_TILDE] = ACTIONS(630),
    [anon_sym_GT_GT_TILDE] = ACTIONS(630),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(630),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(630),
    [anon_sym_GT_TILDE] = ACTIONS(630),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(630),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(630),
    [anon_sym_LT_TILDE] = ACTIONS(630),
    [anon_sym_PLUS_QMARK] = ACTIONS(630),
    [anon_sym_DASH_QMARK] = ACTIONS(630),
    [anon_sym_STAR_QMARK] = ACTIONS(630),
    [anon_sym_SLASH_QMARK] = ACTIONS(630),
    [anon_sym_PERCENT_QMARK] = ACTIONS(630),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(630),
    [anon_sym_as] = ACTIONS(630),
    [anon_sym_LPAREN2] = ACTIONS(630),
    [anon_sym_DOT_GT] = ACTIONS(630),
    [anon_sym_where] = ACTIONS(630),
    [anon_sym_TILDE] = ACTIONS(630),
    [anon_sym_end] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(632),
    [anon_sym_ifdef] = ACTIONS(630),
    [anon_sym_then] = ACTIONS(630),
    [anon_sym_iftype] = ACTIONS(630),
    [anon_sym_else] = ACTIONS(630),
    [anon_sym_for] = ACTIONS(630),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(630),
    [anon_sym_with] = ACTIONS(630),
    [anon_sym_repeat] = ACTIONS(630),
    [anon_sym_until] = ACTIONS(630),
    [anon_sym_do] = ACTIONS(630),
    [anon_sym_recover] = ACTIONS(630),
    [anon_sym_match] = ACTIONS(630),
    [anon_sym_return] = ACTIONS(630),
    [anon_sym_continue] = ACTIONS(630),
    [anon_sym_break] = ACTIONS(630),
    [anon_sym_consume] = ACTIONS(630),
    [anon_sym_object] = ACTIONS(630),
    [sym_number] = ACTIONS(632),
    [sym_float] = ACTIONS(630),
    [anon_sym_DQUOTE] = ACTIONS(632),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(630),
    [anon_sym_SQUOTE] = ACTIONS(630),
    [anon_sym_true] = ACTIONS(630),
    [anon_sym_false] = ACTIONS(630),
    [sym_this] = ACTIONS(630),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [105] = {
    [sym_identifier] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(722),
    [anon_sym_AT] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(720),
    [anon_sym_RBRACK] = ACTIONS(720),
    [anon_sym_is] = ACTIONS(722),
    [anon_sym_embed] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(720),
    [anon_sym_var] = ACTIONS(720),
    [anon_sym_new] = ACTIONS(720),
    [anon_sym_EQ_GT] = ACTIONS(720),
    [anon_sym_fun] = ACTIONS(720),
    [anon_sym_be] = ACTIONS(720),
    [anon_sym_COMMA] = ACTIONS(720),
    [anon_sym_iso] = ACTIONS(720),
    [anon_sym_trn] = ACTIONS(720),
    [anon_sym_ref] = ACTIONS(720),
    [anon_sym_val] = ACTIONS(720),
    [anon_sym_box] = ACTIONS(720),
    [anon_sym_tag] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(722),
    [anon_sym_RPAREN] = ACTIONS(720),
    [anon_sym_DOT] = ACTIONS(722),
    [anon_sym_POUNDread] = ACTIONS(720),
    [anon_sym_POUNDsend] = ACTIONS(720),
    [anon_sym_POUNDshare] = ACTIONS(720),
    [anon_sym_POUNDalias] = ACTIONS(720),
    [anon_sym_POUNDany] = ACTIONS(720),
    [anon_sym_BANG] = ACTIONS(722),
    [anon_sym_CARET] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(720),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_DASH_GT] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(720),
    [anon_sym_RBRACE] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(720),
    [sym_error] = ACTIONS(720),
    [sym_compile_intrinsic] = ACTIONS(720),
    [anon_sym_compile_error] = ACTIONS(720),
    [sym_location] = ACTIONS(720),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_not] = ACTIONS(720),
    [anon_sym_DASH_TILDE] = ACTIONS(720),
    [anon_sym_addressof] = ACTIONS(720),
    [anon_sym_digestof] = ACTIONS(720),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_STAR] = ACTIONS(722),
    [anon_sym_SLASH] = ACTIONS(722),
    [anon_sym_PERCENT] = ACTIONS(722),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(722),
    [anon_sym_LT_LT] = ACTIONS(722),
    [anon_sym_GT_GT] = ACTIONS(722),
    [anon_sym_and] = ACTIONS(720),
    [anon_sym_or] = ACTIONS(720),
    [anon_sym_xor] = ACTIONS(720),
    [anon_sym_isnt] = ACTIONS(720),
    [anon_sym_EQ_EQ] = ACTIONS(722),
    [anon_sym_BANG_EQ] = ACTIONS(722),
    [anon_sym_GT] = ACTIONS(722),
    [anon_sym_GT_EQ] = ACTIONS(722),
    [anon_sym_LT_EQ] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(722),
    [anon_sym_PLUS_TILDE] = ACTIONS(720),
    [anon_sym_STAR_TILDE] = ACTIONS(720),
    [anon_sym_SLASH_TILDE] = ACTIONS(720),
    [anon_sym_PERCENT_TILDE] = ACTIONS(720),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(720),
    [anon_sym_LT_LT_TILDE] = ACTIONS(720),
    [anon_sym_GT_GT_TILDE] = ACTIONS(720),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(720),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(720),
    [anon_sym_GT_TILDE] = ACTIONS(720),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(720),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(720),
    [anon_sym_LT_TILDE] = ACTIONS(720),
    [anon_sym_PLUS_QMARK] = ACTIONS(720),
    [anon_sym_DASH_QMARK] = ACTIONS(720),
    [anon_sym_STAR_QMARK] = ACTIONS(720),
    [anon_sym_SLASH_QMARK] = ACTIONS(720),
    [anon_sym_PERCENT_QMARK] = ACTIONS(720),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(720),
    [anon_sym_as] = ACTIONS(720),
    [anon_sym_LPAREN2] = ACTIONS(720),
    [anon_sym_DOT_GT] = ACTIONS(720),
    [anon_sym_where] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(720),
    [anon_sym_end] = ACTIONS(720),
    [anon_sym_if] = ACTIONS(722),
    [anon_sym_ifdef] = ACTIONS(720),
    [anon_sym_then] = ACTIONS(720),
    [anon_sym_iftype] = ACTIONS(720),
    [anon_sym_else] = ACTIONS(720),
    [anon_sym_for] = ACTIONS(720),
    [anon_sym_while] = ACTIONS(720),
    [anon_sym_try] = ACTIONS(720),
    [anon_sym_with] = ACTIONS(720),
    [anon_sym_repeat] = ACTIONS(720),
    [anon_sym_until] = ACTIONS(720),
    [anon_sym_do] = ACTIONS(720),
    [anon_sym_recover] = ACTIONS(720),
    [anon_sym_match] = ACTIONS(720),
    [anon_sym_return] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(720),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_consume] = ACTIONS(720),
    [anon_sym_object] = ACTIONS(720),
    [sym_number] = ACTIONS(722),
    [sym_float] = ACTIONS(720),
    [anon_sym_DQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_SQUOTE] = ACTIONS(720),
    [anon_sym_true] = ACTIONS(720),
    [anon_sym_false] = ACTIONS(720),
    [sym_this] = ACTIONS(720),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [106] = {
    [sym_identifier] = ACTIONS(718),
    [anon_sym_EQ] = ACTIONS(718),
    [anon_sym_AT] = ACTIONS(716),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_RBRACK] = ACTIONS(716),
    [anon_sym_is] = ACTIONS(718),
    [anon_sym_embed] = ACTIONS(716),
    [anon_sym_let] = ACTIONS(716),
    [anon_sym_var] = ACTIONS(716),
    [anon_sym_new] = ACTIONS(716),
    [anon_sym_EQ_GT] = ACTIONS(716),
    [anon_sym_fun] = ACTIONS(716),
    [anon_sym_be] = ACTIONS(716),
    [anon_sym_COMMA] = ACTIONS(716),
    [anon_sym_iso] = ACTIONS(716),
    [anon_sym_trn] = ACTIONS(716),
    [anon_sym_ref] = ACTIONS(716),
    [anon_sym_val] = ACTIONS(716),
    [anon_sym_box] = ACTIONS(716),
    [anon_sym_tag] = ACTIONS(716),
    [anon_sym_LPAREN] = ACTIONS(718),
    [anon_sym_RPAREN] = ACTIONS(716),
    [anon_sym_DOT] = ACTIONS(718),
    [anon_sym_POUNDread] = ACTIONS(716),
    [anon_sym_POUNDsend] = ACTIONS(716),
    [anon_sym_POUNDshare] = ACTIONS(716),
    [anon_sym_POUNDalias] = ACTIONS(716),
    [anon_sym_POUNDany] = ACTIONS(716),
    [anon_sym_BANG] = ACTIONS(718),
    [anon_sym_CARET] = ACTIONS(716),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_AMP] = ACTIONS(716),
    [anon_sym_DASH_GT] = ACTIONS(716),
    [anon_sym_LBRACE] = ACTIONS(716),
    [anon_sym_RBRACE] = ACTIONS(716),
    [anon_sym_SEMI] = ACTIONS(716),
    [sym_error] = ACTIONS(716),
    [sym_compile_intrinsic] = ACTIONS(716),
    [anon_sym_compile_error] = ACTIONS(716),
    [sym_location] = ACTIONS(716),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_not] = ACTIONS(716),
    [anon_sym_DASH_TILDE] = ACTIONS(716),
    [anon_sym_addressof] = ACTIONS(716),
    [anon_sym_digestof] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_STAR] = ACTIONS(718),
    [anon_sym_SLASH] = ACTIONS(718),
    [anon_sym_PERCENT] = ACTIONS(718),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(718),
    [anon_sym_LT_LT] = ACTIONS(718),
    [anon_sym_GT_GT] = ACTIONS(718),
    [anon_sym_and] = ACTIONS(716),
    [anon_sym_or] = ACTIONS(716),
    [anon_sym_xor] = ACTIONS(716),
    [anon_sym_isnt] = ACTIONS(716),
    [anon_sym_EQ_EQ] = ACTIONS(718),
    [anon_sym_BANG_EQ] = ACTIONS(718),
    [anon_sym_GT] = ACTIONS(718),
    [anon_sym_GT_EQ] = ACTIONS(718),
    [anon_sym_LT_EQ] = ACTIONS(718),
    [anon_sym_LT] = ACTIONS(718),
    [anon_sym_PLUS_TILDE] = ACTIONS(716),
    [anon_sym_STAR_TILDE] = ACTIONS(716),
    [anon_sym_SLASH_TILDE] = ACTIONS(716),
    [anon_sym_PERCENT_TILDE] = ACTIONS(716),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(716),
    [anon_sym_LT_LT_TILDE] = ACTIONS(716),
    [anon_sym_GT_GT_TILDE] = ACTIONS(716),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(716),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(716),
    [anon_sym_GT_TILDE] = ACTIONS(716),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(716),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(716),
    [anon_sym_LT_TILDE] = ACTIONS(716),
    [anon_sym_PLUS_QMARK] = ACTIONS(716),
    [anon_sym_DASH_QMARK] = ACTIONS(716),
    [anon_sym_STAR_QMARK] = ACTIONS(716),
    [anon_sym_SLASH_QMARK] = ACTIONS(716),
    [anon_sym_PERCENT_QMARK] = ACTIONS(716),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(716),
    [anon_sym_as] = ACTIONS(716),
    [anon_sym_LPAREN2] = ACTIONS(716),
    [anon_sym_DOT_GT] = ACTIONS(716),
    [anon_sym_where] = ACTIONS(716),
    [anon_sym_TILDE] = ACTIONS(716),
    [anon_sym_end] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(718),
    [anon_sym_ifdef] = ACTIONS(716),
    [anon_sym_then] = ACTIONS(716),
    [anon_sym_iftype] = ACTIONS(716),
    [anon_sym_else] = ACTIONS(716),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(716),
    [anon_sym_try] = ACTIONS(716),
    [anon_sym_with] = ACTIONS(716),
    [anon_sym_repeat] = ACTIONS(716),
    [anon_sym_until] = ACTIONS(716),
    [anon_sym_do] = ACTIONS(716),
    [anon_sym_recover] = ACTIONS(716),
    [anon_sym_match] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(716),
    [anon_sym_continue] = ACTIONS(716),
    [anon_sym_break] = ACTIONS(716),
    [anon_sym_consume] = ACTIONS(716),
    [anon_sym_object] = ACTIONS(716),
    [sym_number] = ACTIONS(718),
    [sym_float] = ACTIONS(716),
    [anon_sym_DQUOTE] = ACTIONS(718),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(716),
    [anon_sym_SQUOTE] = ACTIONS(716),
    [anon_sym_true] = ACTIONS(716),
    [anon_sym_false] = ACTIONS(716),
    [sym_this] = ACTIONS(716),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [107] = {
    [sym_identifier] = ACTIONS(714),
    [anon_sym_EQ] = ACTIONS(714),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_LBRACK] = ACTIONS(712),
    [anon_sym_RBRACK] = ACTIONS(712),
    [anon_sym_is] = ACTIONS(714),
    [anon_sym_embed] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(712),
    [anon_sym_var] = ACTIONS(712),
    [anon_sym_new] = ACTIONS(712),
    [anon_sym_EQ_GT] = ACTIONS(712),
    [anon_sym_fun] = ACTIONS(712),
    [anon_sym_be] = ACTIONS(712),
    [anon_sym_COMMA] = ACTIONS(712),
    [anon_sym_iso] = ACTIONS(712),
    [anon_sym_trn] = ACTIONS(712),
    [anon_sym_ref] = ACTIONS(712),
    [anon_sym_val] = ACTIONS(712),
    [anon_sym_box] = ACTIONS(712),
    [anon_sym_tag] = ACTIONS(712),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_RPAREN] = ACTIONS(712),
    [anon_sym_DOT] = ACTIONS(714),
    [anon_sym_POUNDread] = ACTIONS(712),
    [anon_sym_POUNDsend] = ACTIONS(712),
    [anon_sym_POUNDshare] = ACTIONS(712),
    [anon_sym_POUNDalias] = ACTIONS(712),
    [anon_sym_POUNDany] = ACTIONS(712),
    [anon_sym_BANG] = ACTIONS(714),
    [anon_sym_CARET] = ACTIONS(712),
    [anon_sym_PIPE] = ACTIONS(712),
    [anon_sym_AMP] = ACTIONS(712),
    [anon_sym_DASH_GT] = ACTIONS(712),
    [anon_sym_LBRACE] = ACTIONS(712),
    [anon_sym_RBRACE] = ACTIONS(712),
    [anon_sym_SEMI] = ACTIONS(712),
    [sym_error] = ACTIONS(712),
    [sym_compile_intrinsic] = ACTIONS(712),
    [anon_sym_compile_error] = ACTIONS(712),
    [sym_location] = ACTIONS(712),
    [anon_sym_DASH] = ACTIONS(714),
    [anon_sym_not] = ACTIONS(712),
    [anon_sym_DASH_TILDE] = ACTIONS(712),
    [anon_sym_addressof] = ACTIONS(712),
    [anon_sym_digestof] = ACTIONS(712),
    [anon_sym_PLUS] = ACTIONS(714),
    [anon_sym_STAR] = ACTIONS(714),
    [anon_sym_SLASH] = ACTIONS(714),
    [anon_sym_PERCENT] = ACTIONS(714),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(714),
    [anon_sym_LT_LT] = ACTIONS(714),
    [anon_sym_GT_GT] = ACTIONS(714),
    [anon_sym_and] = ACTIONS(712),
    [anon_sym_or] = ACTIONS(712),
    [anon_sym_xor] = ACTIONS(712),
    [anon_sym_isnt] = ACTIONS(712),
    [anon_sym_EQ_EQ] = ACTIONS(714),
    [anon_sym_BANG_EQ] = ACTIONS(714),
    [anon_sym_GT] = ACTIONS(714),
    [anon_sym_GT_EQ] = ACTIONS(714),
    [anon_sym_LT_EQ] = ACTIONS(714),
    [anon_sym_LT] = ACTIONS(714),
    [anon_sym_PLUS_TILDE] = ACTIONS(712),
    [anon_sym_STAR_TILDE] = ACTIONS(712),
    [anon_sym_SLASH_TILDE] = ACTIONS(712),
    [anon_sym_PERCENT_TILDE] = ACTIONS(712),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(712),
    [anon_sym_LT_LT_TILDE] = ACTIONS(712),
    [anon_sym_GT_GT_TILDE] = ACTIONS(712),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(712),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(712),
    [anon_sym_GT_TILDE] = ACTIONS(712),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(712),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(712),
    [anon_sym_LT_TILDE] = ACTIONS(712),
    [anon_sym_PLUS_QMARK] = ACTIONS(712),
    [anon_sym_DASH_QMARK] = ACTIONS(712),
    [anon_sym_STAR_QMARK] = ACTIONS(712),
    [anon_sym_SLASH_QMARK] = ACTIONS(712),
    [anon_sym_PERCENT_QMARK] = ACTIONS(712),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(712),
    [anon_sym_as] = ACTIONS(712),
    [anon_sym_LPAREN2] = ACTIONS(712),
    [anon_sym_DOT_GT] = ACTIONS(712),
    [anon_sym_where] = ACTIONS(712),
    [anon_sym_TILDE] = ACTIONS(712),
    [anon_sym_end] = ACTIONS(712),
    [anon_sym_if] = ACTIONS(714),
    [anon_sym_ifdef] = ACTIONS(712),
    [anon_sym_then] = ACTIONS(712),
    [anon_sym_iftype] = ACTIONS(712),
    [anon_sym_else] = ACTIONS(712),
    [anon_sym_for] = ACTIONS(712),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_try] = ACTIONS(712),
    [anon_sym_with] = ACTIONS(712),
    [anon_sym_repeat] = ACTIONS(712),
    [anon_sym_until] = ACTIONS(712),
    [anon_sym_do] = ACTIONS(712),
    [anon_sym_recover] = ACTIONS(712),
    [anon_sym_match] = ACTIONS(712),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_continue] = ACTIONS(712),
    [anon_sym_break] = ACTIONS(712),
    [anon_sym_consume] = ACTIONS(712),
    [anon_sym_object] = ACTIONS(712),
    [sym_number] = ACTIONS(714),
    [sym_float] = ACTIONS(712),
    [anon_sym_DQUOTE] = ACTIONS(714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [anon_sym_true] = ACTIONS(712),
    [anon_sym_false] = ACTIONS(712),
    [sym_this] = ACTIONS(712),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [108] = {
    [sym_identifier] = ACTIONS(710),
    [anon_sym_EQ] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(708),
    [anon_sym_LBRACK] = ACTIONS(708),
    [anon_sym_RBRACK] = ACTIONS(708),
    [anon_sym_is] = ACTIONS(710),
    [anon_sym_embed] = ACTIONS(708),
    [anon_sym_let] = ACTIONS(708),
    [anon_sym_var] = ACTIONS(708),
    [anon_sym_new] = ACTIONS(708),
    [anon_sym_EQ_GT] = ACTIONS(708),
    [anon_sym_fun] = ACTIONS(708),
    [anon_sym_be] = ACTIONS(708),
    [anon_sym_COMMA] = ACTIONS(708),
    [anon_sym_iso] = ACTIONS(708),
    [anon_sym_trn] = ACTIONS(708),
    [anon_sym_ref] = ACTIONS(708),
    [anon_sym_val] = ACTIONS(708),
    [anon_sym_box] = ACTIONS(708),
    [anon_sym_tag] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_RPAREN] = ACTIONS(708),
    [anon_sym_DOT] = ACTIONS(710),
    [anon_sym_POUNDread] = ACTIONS(708),
    [anon_sym_POUNDsend] = ACTIONS(708),
    [anon_sym_POUNDshare] = ACTIONS(708),
    [anon_sym_POUNDalias] = ACTIONS(708),
    [anon_sym_POUNDany] = ACTIONS(708),
    [anon_sym_BANG] = ACTIONS(710),
    [anon_sym_CARET] = ACTIONS(708),
    [anon_sym_PIPE] = ACTIONS(708),
    [anon_sym_AMP] = ACTIONS(708),
    [anon_sym_DASH_GT] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(708),
    [anon_sym_RBRACE] = ACTIONS(708),
    [anon_sym_SEMI] = ACTIONS(708),
    [sym_error] = ACTIONS(708),
    [sym_compile_intrinsic] = ACTIONS(708),
    [anon_sym_compile_error] = ACTIONS(708),
    [sym_location] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_not] = ACTIONS(708),
    [anon_sym_DASH_TILDE] = ACTIONS(708),
    [anon_sym_addressof] = ACTIONS(708),
    [anon_sym_digestof] = ACTIONS(708),
    [anon_sym_PLUS] = ACTIONS(710),
    [anon_sym_STAR] = ACTIONS(710),
    [anon_sym_SLASH] = ACTIONS(710),
    [anon_sym_PERCENT] = ACTIONS(710),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(710),
    [anon_sym_LT_LT] = ACTIONS(710),
    [anon_sym_GT_GT] = ACTIONS(710),
    [anon_sym_and] = ACTIONS(708),
    [anon_sym_or] = ACTIONS(708),
    [anon_sym_xor] = ACTIONS(708),
    [anon_sym_isnt] = ACTIONS(708),
    [anon_sym_EQ_EQ] = ACTIONS(710),
    [anon_sym_BANG_EQ] = ACTIONS(710),
    [anon_sym_GT] = ACTIONS(710),
    [anon_sym_GT_EQ] = ACTIONS(710),
    [anon_sym_LT_EQ] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(710),
    [anon_sym_PLUS_TILDE] = ACTIONS(708),
    [anon_sym_STAR_TILDE] = ACTIONS(708),
    [anon_sym_SLASH_TILDE] = ACTIONS(708),
    [anon_sym_PERCENT_TILDE] = ACTIONS(708),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(708),
    [anon_sym_LT_LT_TILDE] = ACTIONS(708),
    [anon_sym_GT_GT_TILDE] = ACTIONS(708),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(708),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(708),
    [anon_sym_GT_TILDE] = ACTIONS(708),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(708),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(708),
    [anon_sym_LT_TILDE] = ACTIONS(708),
    [anon_sym_PLUS_QMARK] = ACTIONS(708),
    [anon_sym_DASH_QMARK] = ACTIONS(708),
    [anon_sym_STAR_QMARK] = ACTIONS(708),
    [anon_sym_SLASH_QMARK] = ACTIONS(708),
    [anon_sym_PERCENT_QMARK] = ACTIONS(708),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(708),
    [anon_sym_as] = ACTIONS(708),
    [anon_sym_LPAREN2] = ACTIONS(708),
    [anon_sym_DOT_GT] = ACTIONS(708),
    [anon_sym_where] = ACTIONS(708),
    [anon_sym_TILDE] = ACTIONS(708),
    [anon_sym_end] = ACTIONS(708),
    [anon_sym_if] = ACTIONS(710),
    [anon_sym_ifdef] = ACTIONS(708),
    [anon_sym_then] = ACTIONS(708),
    [anon_sym_iftype] = ACTIONS(708),
    [anon_sym_else] = ACTIONS(708),
    [anon_sym_for] = ACTIONS(708),
    [anon_sym_while] = ACTIONS(708),
    [anon_sym_try] = ACTIONS(708),
    [anon_sym_with] = ACTIONS(708),
    [anon_sym_repeat] = ACTIONS(708),
    [anon_sym_until] = ACTIONS(708),
    [anon_sym_do] = ACTIONS(708),
    [anon_sym_recover] = ACTIONS(708),
    [anon_sym_match] = ACTIONS(708),
    [anon_sym_return] = ACTIONS(708),
    [anon_sym_continue] = ACTIONS(708),
    [anon_sym_break] = ACTIONS(708),
    [anon_sym_consume] = ACTIONS(708),
    [anon_sym_object] = ACTIONS(708),
    [sym_number] = ACTIONS(710),
    [sym_float] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(708),
    [anon_sym_true] = ACTIONS(708),
    [anon_sym_false] = ACTIONS(708),
    [sym_this] = ACTIONS(708),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [109] = {
    [sym_identifier] = ACTIONS(668),
    [anon_sym_EQ] = ACTIONS(668),
    [anon_sym_AT] = ACTIONS(666),
    [anon_sym_LBRACK] = ACTIONS(666),
    [anon_sym_RBRACK] = ACTIONS(666),
    [anon_sym_is] = ACTIONS(668),
    [anon_sym_embed] = ACTIONS(666),
    [anon_sym_let] = ACTIONS(666),
    [anon_sym_var] = ACTIONS(666),
    [anon_sym_new] = ACTIONS(666),
    [anon_sym_EQ_GT] = ACTIONS(666),
    [anon_sym_fun] = ACTIONS(666),
    [anon_sym_be] = ACTIONS(666),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_iso] = ACTIONS(666),
    [anon_sym_trn] = ACTIONS(666),
    [anon_sym_ref] = ACTIONS(666),
    [anon_sym_val] = ACTIONS(666),
    [anon_sym_box] = ACTIONS(666),
    [anon_sym_tag] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(668),
    [anon_sym_RPAREN] = ACTIONS(666),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_POUNDread] = ACTIONS(666),
    [anon_sym_POUNDsend] = ACTIONS(666),
    [anon_sym_POUNDshare] = ACTIONS(666),
    [anon_sym_POUNDalias] = ACTIONS(666),
    [anon_sym_POUNDany] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(666),
    [anon_sym_DASH_GT] = ACTIONS(666),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_RBRACE] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(666),
    [sym_error] = ACTIONS(666),
    [sym_compile_intrinsic] = ACTIONS(666),
    [anon_sym_compile_error] = ACTIONS(666),
    [sym_location] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(668),
    [anon_sym_not] = ACTIONS(666),
    [anon_sym_DASH_TILDE] = ACTIONS(666),
    [anon_sym_addressof] = ACTIONS(666),
    [anon_sym_digestof] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(668),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(668),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(668),
    [anon_sym_LT_LT] = ACTIONS(668),
    [anon_sym_GT_GT] = ACTIONS(668),
    [anon_sym_and] = ACTIONS(666),
    [anon_sym_or] = ACTIONS(666),
    [anon_sym_xor] = ACTIONS(666),
    [anon_sym_isnt] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(668),
    [anon_sym_BANG_EQ] = ACTIONS(668),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_GT_EQ] = ACTIONS(668),
    [anon_sym_LT_EQ] = ACTIONS(668),
    [anon_sym_LT] = ACTIONS(668),
    [anon_sym_PLUS_TILDE] = ACTIONS(666),
    [anon_sym_STAR_TILDE] = ACTIONS(666),
    [anon_sym_SLASH_TILDE] = ACTIONS(666),
    [anon_sym_PERCENT_TILDE] = ACTIONS(666),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(666),
    [anon_sym_LT_LT_TILDE] = ACTIONS(666),
    [anon_sym_GT_GT_TILDE] = ACTIONS(666),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(666),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(666),
    [anon_sym_GT_TILDE] = ACTIONS(666),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(666),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(666),
    [anon_sym_LT_TILDE] = ACTIONS(666),
    [anon_sym_PLUS_QMARK] = ACTIONS(666),
    [anon_sym_DASH_QMARK] = ACTIONS(666),
    [anon_sym_STAR_QMARK] = ACTIONS(666),
    [anon_sym_SLASH_QMARK] = ACTIONS(666),
    [anon_sym_PERCENT_QMARK] = ACTIONS(666),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(666),
    [anon_sym_LPAREN2] = ACTIONS(666),
    [anon_sym_DOT_GT] = ACTIONS(666),
    [anon_sym_where] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_end] = ACTIONS(666),
    [anon_sym_if] = ACTIONS(668),
    [anon_sym_ifdef] = ACTIONS(666),
    [anon_sym_then] = ACTIONS(666),
    [anon_sym_iftype] = ACTIONS(666),
    [anon_sym_else] = ACTIONS(666),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_while] = ACTIONS(666),
    [anon_sym_try] = ACTIONS(666),
    [anon_sym_with] = ACTIONS(666),
    [anon_sym_repeat] = ACTIONS(666),
    [anon_sym_until] = ACTIONS(666),
    [anon_sym_do] = ACTIONS(666),
    [anon_sym_recover] = ACTIONS(666),
    [anon_sym_match] = ACTIONS(666),
    [anon_sym_return] = ACTIONS(666),
    [anon_sym_continue] = ACTIONS(666),
    [anon_sym_break] = ACTIONS(666),
    [anon_sym_consume] = ACTIONS(666),
    [anon_sym_object] = ACTIONS(666),
    [sym_number] = ACTIONS(668),
    [sym_float] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(666),
    [anon_sym_SQUOTE] = ACTIONS(666),
    [anon_sym_true] = ACTIONS(666),
    [anon_sym_false] = ACTIONS(666),
    [sym_this] = ACTIONS(666),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [110] = {
    [sym_identifier] = ACTIONS(676),
    [anon_sym_EQ] = ACTIONS(676),
    [anon_sym_AT] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(674),
    [anon_sym_RBRACK] = ACTIONS(674),
    [anon_sym_is] = ACTIONS(676),
    [anon_sym_embed] = ACTIONS(674),
    [anon_sym_let] = ACTIONS(674),
    [anon_sym_var] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(674),
    [anon_sym_EQ_GT] = ACTIONS(674),
    [anon_sym_fun] = ACTIONS(674),
    [anon_sym_be] = ACTIONS(674),
    [anon_sym_COMMA] = ACTIONS(674),
    [anon_sym_iso] = ACTIONS(674),
    [anon_sym_trn] = ACTIONS(674),
    [anon_sym_ref] = ACTIONS(674),
    [anon_sym_val] = ACTIONS(674),
    [anon_sym_box] = ACTIONS(674),
    [anon_sym_tag] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(676),
    [anon_sym_RPAREN] = ACTIONS(674),
    [anon_sym_DOT] = ACTIONS(676),
    [anon_sym_POUNDread] = ACTIONS(674),
    [anon_sym_POUNDsend] = ACTIONS(674),
    [anon_sym_POUNDshare] = ACTIONS(674),
    [anon_sym_POUNDalias] = ACTIONS(674),
    [anon_sym_POUNDany] = ACTIONS(674),
    [anon_sym_BANG] = ACTIONS(676),
    [anon_sym_CARET] = ACTIONS(674),
    [anon_sym_PIPE] = ACTIONS(674),
    [anon_sym_AMP] = ACTIONS(674),
    [anon_sym_DASH_GT] = ACTIONS(674),
    [anon_sym_LBRACE] = ACTIONS(674),
    [anon_sym_RBRACE] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(674),
    [sym_error] = ACTIONS(674),
    [sym_compile_intrinsic] = ACTIONS(674),
    [anon_sym_compile_error] = ACTIONS(674),
    [sym_location] = ACTIONS(674),
    [anon_sym_DASH] = ACTIONS(676),
    [anon_sym_not] = ACTIONS(674),
    [anon_sym_DASH_TILDE] = ACTIONS(674),
    [anon_sym_addressof] = ACTIONS(674),
    [anon_sym_digestof] = ACTIONS(674),
    [anon_sym_PLUS] = ACTIONS(676),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_SLASH] = ACTIONS(676),
    [anon_sym_PERCENT] = ACTIONS(676),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(676),
    [anon_sym_LT_LT] = ACTIONS(676),
    [anon_sym_GT_GT] = ACTIONS(676),
    [anon_sym_and] = ACTIONS(674),
    [anon_sym_or] = ACTIONS(674),
    [anon_sym_xor] = ACTIONS(674),
    [anon_sym_isnt] = ACTIONS(674),
    [anon_sym_EQ_EQ] = ACTIONS(676),
    [anon_sym_BANG_EQ] = ACTIONS(676),
    [anon_sym_GT] = ACTIONS(676),
    [anon_sym_GT_EQ] = ACTIONS(676),
    [anon_sym_LT_EQ] = ACTIONS(676),
    [anon_sym_LT] = ACTIONS(676),
    [anon_sym_PLUS_TILDE] = ACTIONS(674),
    [anon_sym_STAR_TILDE] = ACTIONS(674),
    [anon_sym_SLASH_TILDE] = ACTIONS(674),
    [anon_sym_PERCENT_TILDE] = ACTIONS(674),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(674),
    [anon_sym_LT_LT_TILDE] = ACTIONS(674),
    [anon_sym_GT_GT_TILDE] = ACTIONS(674),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(674),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(674),
    [anon_sym_GT_TILDE] = ACTIONS(674),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(674),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(674),
    [anon_sym_LT_TILDE] = ACTIONS(674),
    [anon_sym_PLUS_QMARK] = ACTIONS(674),
    [anon_sym_DASH_QMARK] = ACTIONS(674),
    [anon_sym_STAR_QMARK] = ACTIONS(674),
    [anon_sym_SLASH_QMARK] = ACTIONS(674),
    [anon_sym_PERCENT_QMARK] = ACTIONS(674),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(674),
    [anon_sym_as] = ACTIONS(674),
    [anon_sym_LPAREN2] = ACTIONS(674),
    [anon_sym_DOT_GT] = ACTIONS(674),
    [anon_sym_where] = ACTIONS(674),
    [anon_sym_TILDE] = ACTIONS(674),
    [anon_sym_end] = ACTIONS(674),
    [anon_sym_if] = ACTIONS(676),
    [anon_sym_ifdef] = ACTIONS(674),
    [anon_sym_then] = ACTIONS(674),
    [anon_sym_iftype] = ACTIONS(674),
    [anon_sym_else] = ACTIONS(674),
    [anon_sym_for] = ACTIONS(674),
    [anon_sym_while] = ACTIONS(674),
    [anon_sym_try] = ACTIONS(674),
    [anon_sym_with] = ACTIONS(674),
    [anon_sym_repeat] = ACTIONS(674),
    [anon_sym_until] = ACTIONS(674),
    [anon_sym_do] = ACTIONS(674),
    [anon_sym_recover] = ACTIONS(674),
    [anon_sym_match] = ACTIONS(674),
    [anon_sym_return] = ACTIONS(674),
    [anon_sym_continue] = ACTIONS(674),
    [anon_sym_break] = ACTIONS(674),
    [anon_sym_consume] = ACTIONS(674),
    [anon_sym_object] = ACTIONS(674),
    [sym_number] = ACTIONS(676),
    [sym_float] = ACTIONS(674),
    [anon_sym_DQUOTE] = ACTIONS(676),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(674),
    [anon_sym_SQUOTE] = ACTIONS(674),
    [anon_sym_true] = ACTIONS(674),
    [anon_sym_false] = ACTIONS(674),
    [sym_this] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [111] = {
    [sym_identifier] = ACTIONS(672),
    [anon_sym_EQ] = ACTIONS(672),
    [anon_sym_AT] = ACTIONS(670),
    [anon_sym_LBRACK] = ACTIONS(670),
    [anon_sym_RBRACK] = ACTIONS(670),
    [anon_sym_is] = ACTIONS(672),
    [anon_sym_embed] = ACTIONS(670),
    [anon_sym_let] = ACTIONS(670),
    [anon_sym_var] = ACTIONS(670),
    [anon_sym_new] = ACTIONS(670),
    [anon_sym_EQ_GT] = ACTIONS(670),
    [anon_sym_fun] = ACTIONS(670),
    [anon_sym_be] = ACTIONS(670),
    [anon_sym_COMMA] = ACTIONS(670),
    [anon_sym_iso] = ACTIONS(670),
    [anon_sym_trn] = ACTIONS(670),
    [anon_sym_ref] = ACTIONS(670),
    [anon_sym_val] = ACTIONS(670),
    [anon_sym_box] = ACTIONS(670),
    [anon_sym_tag] = ACTIONS(670),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RPAREN] = ACTIONS(670),
    [anon_sym_DOT] = ACTIONS(672),
    [anon_sym_POUNDread] = ACTIONS(670),
    [anon_sym_POUNDsend] = ACTIONS(670),
    [anon_sym_POUNDshare] = ACTIONS(670),
    [anon_sym_POUNDalias] = ACTIONS(670),
    [anon_sym_POUNDany] = ACTIONS(670),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_CARET] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(670),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_DASH_GT] = ACTIONS(670),
    [anon_sym_LBRACE] = ACTIONS(670),
    [anon_sym_RBRACE] = ACTIONS(670),
    [anon_sym_SEMI] = ACTIONS(670),
    [sym_error] = ACTIONS(670),
    [sym_compile_intrinsic] = ACTIONS(670),
    [anon_sym_compile_error] = ACTIONS(670),
    [sym_location] = ACTIONS(670),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_not] = ACTIONS(670),
    [anon_sym_DASH_TILDE] = ACTIONS(670),
    [anon_sym_addressof] = ACTIONS(670),
    [anon_sym_digestof] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_SLASH] = ACTIONS(672),
    [anon_sym_PERCENT] = ACTIONS(672),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(672),
    [anon_sym_LT_LT] = ACTIONS(672),
    [anon_sym_GT_GT] = ACTIONS(672),
    [anon_sym_and] = ACTIONS(670),
    [anon_sym_or] = ACTIONS(670),
    [anon_sym_xor] = ACTIONS(670),
    [anon_sym_isnt] = ACTIONS(670),
    [anon_sym_EQ_EQ] = ACTIONS(672),
    [anon_sym_BANG_EQ] = ACTIONS(672),
    [anon_sym_GT] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(672),
    [anon_sym_LT_EQ] = ACTIONS(672),
    [anon_sym_LT] = ACTIONS(672),
    [anon_sym_PLUS_TILDE] = ACTIONS(670),
    [anon_sym_STAR_TILDE] = ACTIONS(670),
    [anon_sym_SLASH_TILDE] = ACTIONS(670),
    [anon_sym_PERCENT_TILDE] = ACTIONS(670),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(670),
    [anon_sym_LT_LT_TILDE] = ACTIONS(670),
    [anon_sym_GT_GT_TILDE] = ACTIONS(670),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(670),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(670),
    [anon_sym_GT_TILDE] = ACTIONS(670),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(670),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(670),
    [anon_sym_LT_TILDE] = ACTIONS(670),
    [anon_sym_PLUS_QMARK] = ACTIONS(670),
    [anon_sym_DASH_QMARK] = ACTIONS(670),
    [anon_sym_STAR_QMARK] = ACTIONS(670),
    [anon_sym_SLASH_QMARK] = ACTIONS(670),
    [anon_sym_PERCENT_QMARK] = ACTIONS(670),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(670),
    [anon_sym_as] = ACTIONS(670),
    [anon_sym_LPAREN2] = ACTIONS(670),
    [anon_sym_DOT_GT] = ACTIONS(670),
    [anon_sym_where] = ACTIONS(670),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_end] = ACTIONS(670),
    [anon_sym_if] = ACTIONS(672),
    [anon_sym_ifdef] = ACTIONS(670),
    [anon_sym_then] = ACTIONS(670),
    [anon_sym_iftype] = ACTIONS(670),
    [anon_sym_else] = ACTIONS(670),
    [anon_sym_for] = ACTIONS(670),
    [anon_sym_while] = ACTIONS(670),
    [anon_sym_try] = ACTIONS(670),
    [anon_sym_with] = ACTIONS(670),
    [anon_sym_repeat] = ACTIONS(670),
    [anon_sym_until] = ACTIONS(670),
    [anon_sym_do] = ACTIONS(670),
    [anon_sym_recover] = ACTIONS(670),
    [anon_sym_match] = ACTIONS(670),
    [anon_sym_return] = ACTIONS(670),
    [anon_sym_continue] = ACTIONS(670),
    [anon_sym_break] = ACTIONS(670),
    [anon_sym_consume] = ACTIONS(670),
    [anon_sym_object] = ACTIONS(670),
    [sym_number] = ACTIONS(672),
    [sym_float] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(672),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [anon_sym_SQUOTE] = ACTIONS(670),
    [anon_sym_true] = ACTIONS(670),
    [anon_sym_false] = ACTIONS(670),
    [sym_this] = ACTIONS(670),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [112] = {
    [sym_identifier] = ACTIONS(734),
    [anon_sym_EQ] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_RBRACK] = ACTIONS(732),
    [anon_sym_is] = ACTIONS(734),
    [anon_sym_embed] = ACTIONS(732),
    [anon_sym_let] = ACTIONS(732),
    [anon_sym_var] = ACTIONS(732),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_EQ_GT] = ACTIONS(732),
    [anon_sym_fun] = ACTIONS(732),
    [anon_sym_be] = ACTIONS(732),
    [anon_sym_COMMA] = ACTIONS(732),
    [anon_sym_iso] = ACTIONS(732),
    [anon_sym_trn] = ACTIONS(732),
    [anon_sym_ref] = ACTIONS(732),
    [anon_sym_val] = ACTIONS(732),
    [anon_sym_box] = ACTIONS(732),
    [anon_sym_tag] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(734),
    [anon_sym_RPAREN] = ACTIONS(732),
    [anon_sym_DOT] = ACTIONS(734),
    [anon_sym_POUNDread] = ACTIONS(732),
    [anon_sym_POUNDsend] = ACTIONS(732),
    [anon_sym_POUNDshare] = ACTIONS(732),
    [anon_sym_POUNDalias] = ACTIONS(732),
    [anon_sym_POUNDany] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(734),
    [anon_sym_CARET] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(732),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_DASH_GT] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [anon_sym_RBRACE] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(732),
    [sym_error] = ACTIONS(732),
    [sym_compile_intrinsic] = ACTIONS(732),
    [anon_sym_compile_error] = ACTIONS(732),
    [sym_location] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(734),
    [anon_sym_not] = ACTIONS(732),
    [anon_sym_DASH_TILDE] = ACTIONS(732),
    [anon_sym_addressof] = ACTIONS(732),
    [anon_sym_digestof] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(734),
    [anon_sym_STAR] = ACTIONS(734),
    [anon_sym_SLASH] = ACTIONS(734),
    [anon_sym_PERCENT] = ACTIONS(734),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(734),
    [anon_sym_LT_LT] = ACTIONS(734),
    [anon_sym_GT_GT] = ACTIONS(734),
    [anon_sym_and] = ACTIONS(732),
    [anon_sym_or] = ACTIONS(732),
    [anon_sym_xor] = ACTIONS(732),
    [anon_sym_isnt] = ACTIONS(732),
    [anon_sym_EQ_EQ] = ACTIONS(734),
    [anon_sym_BANG_EQ] = ACTIONS(734),
    [anon_sym_GT] = ACTIONS(734),
    [anon_sym_GT_EQ] = ACTIONS(734),
    [anon_sym_LT_EQ] = ACTIONS(734),
    [anon_sym_LT] = ACTIONS(734),
    [anon_sym_PLUS_TILDE] = ACTIONS(732),
    [anon_sym_STAR_TILDE] = ACTIONS(732),
    [anon_sym_SLASH_TILDE] = ACTIONS(732),
    [anon_sym_PERCENT_TILDE] = ACTIONS(732),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(732),
    [anon_sym_LT_LT_TILDE] = ACTIONS(732),
    [anon_sym_GT_GT_TILDE] = ACTIONS(732),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(732),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(732),
    [anon_sym_GT_TILDE] = ACTIONS(732),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(732),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(732),
    [anon_sym_LT_TILDE] = ACTIONS(732),
    [anon_sym_PLUS_QMARK] = ACTIONS(732),
    [anon_sym_DASH_QMARK] = ACTIONS(732),
    [anon_sym_STAR_QMARK] = ACTIONS(732),
    [anon_sym_SLASH_QMARK] = ACTIONS(732),
    [anon_sym_PERCENT_QMARK] = ACTIONS(732),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(732),
    [anon_sym_as] = ACTIONS(732),
    [anon_sym_LPAREN2] = ACTIONS(732),
    [anon_sym_DOT_GT] = ACTIONS(732),
    [anon_sym_where] = ACTIONS(732),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_end] = ACTIONS(732),
    [anon_sym_if] = ACTIONS(734),
    [anon_sym_ifdef] = ACTIONS(732),
    [anon_sym_then] = ACTIONS(732),
    [anon_sym_iftype] = ACTIONS(732),
    [anon_sym_else] = ACTIONS(732),
    [anon_sym_for] = ACTIONS(732),
    [anon_sym_while] = ACTIONS(732),
    [anon_sym_try] = ACTIONS(732),
    [anon_sym_with] = ACTIONS(732),
    [anon_sym_repeat] = ACTIONS(732),
    [anon_sym_until] = ACTIONS(732),
    [anon_sym_do] = ACTIONS(732),
    [anon_sym_recover] = ACTIONS(732),
    [anon_sym_match] = ACTIONS(732),
    [anon_sym_return] = ACTIONS(732),
    [anon_sym_continue] = ACTIONS(732),
    [anon_sym_break] = ACTIONS(732),
    [anon_sym_consume] = ACTIONS(732),
    [anon_sym_object] = ACTIONS(732),
    [sym_number] = ACTIONS(734),
    [sym_float] = ACTIONS(732),
    [anon_sym_DQUOTE] = ACTIONS(734),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(732),
    [anon_sym_true] = ACTIONS(732),
    [anon_sym_false] = ACTIONS(732),
    [sym_this] = ACTIONS(732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [113] = {
    [sym_identifier] = ACTIONS(664),
    [anon_sym_EQ] = ACTIONS(664),
    [anon_sym_AT] = ACTIONS(662),
    [anon_sym_LBRACK] = ACTIONS(662),
    [anon_sym_RBRACK] = ACTIONS(662),
    [anon_sym_is] = ACTIONS(664),
    [anon_sym_embed] = ACTIONS(662),
    [anon_sym_let] = ACTIONS(662),
    [anon_sym_var] = ACTIONS(662),
    [anon_sym_new] = ACTIONS(662),
    [anon_sym_EQ_GT] = ACTIONS(662),
    [anon_sym_fun] = ACTIONS(662),
    [anon_sym_be] = ACTIONS(662),
    [anon_sym_COMMA] = ACTIONS(662),
    [anon_sym_iso] = ACTIONS(662),
    [anon_sym_trn] = ACTIONS(662),
    [anon_sym_ref] = ACTIONS(662),
    [anon_sym_val] = ACTIONS(662),
    [anon_sym_box] = ACTIONS(662),
    [anon_sym_tag] = ACTIONS(662),
    [anon_sym_LPAREN] = ACTIONS(664),
    [anon_sym_RPAREN] = ACTIONS(662),
    [anon_sym_DOT] = ACTIONS(664),
    [anon_sym_POUNDread] = ACTIONS(662),
    [anon_sym_POUNDsend] = ACTIONS(662),
    [anon_sym_POUNDshare] = ACTIONS(662),
    [anon_sym_POUNDalias] = ACTIONS(662),
    [anon_sym_POUNDany] = ACTIONS(662),
    [anon_sym_BANG] = ACTIONS(664),
    [anon_sym_CARET] = ACTIONS(662),
    [anon_sym_PIPE] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(662),
    [anon_sym_DASH_GT] = ACTIONS(662),
    [anon_sym_LBRACE] = ACTIONS(662),
    [anon_sym_RBRACE] = ACTIONS(662),
    [anon_sym_SEMI] = ACTIONS(662),
    [sym_error] = ACTIONS(662),
    [sym_compile_intrinsic] = ACTIONS(662),
    [anon_sym_compile_error] = ACTIONS(662),
    [sym_location] = ACTIONS(662),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_not] = ACTIONS(662),
    [anon_sym_DASH_TILDE] = ACTIONS(662),
    [anon_sym_addressof] = ACTIONS(662),
    [anon_sym_digestof] = ACTIONS(662),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_STAR] = ACTIONS(664),
    [anon_sym_SLASH] = ACTIONS(664),
    [anon_sym_PERCENT] = ACTIONS(664),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(664),
    [anon_sym_LT_LT] = ACTIONS(664),
    [anon_sym_GT_GT] = ACTIONS(664),
    [anon_sym_and] = ACTIONS(662),
    [anon_sym_or] = ACTIONS(662),
    [anon_sym_xor] = ACTIONS(662),
    [anon_sym_isnt] = ACTIONS(662),
    [anon_sym_EQ_EQ] = ACTIONS(664),
    [anon_sym_BANG_EQ] = ACTIONS(664),
    [anon_sym_GT] = ACTIONS(664),
    [anon_sym_GT_EQ] = ACTIONS(664),
    [anon_sym_LT_EQ] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(664),
    [anon_sym_PLUS_TILDE] = ACTIONS(662),
    [anon_sym_STAR_TILDE] = ACTIONS(662),
    [anon_sym_SLASH_TILDE] = ACTIONS(662),
    [anon_sym_PERCENT_TILDE] = ACTIONS(662),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(662),
    [anon_sym_LT_LT_TILDE] = ACTIONS(662),
    [anon_sym_GT_GT_TILDE] = ACTIONS(662),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(662),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(662),
    [anon_sym_GT_TILDE] = ACTIONS(662),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(662),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(662),
    [anon_sym_LT_TILDE] = ACTIONS(662),
    [anon_sym_PLUS_QMARK] = ACTIONS(662),
    [anon_sym_DASH_QMARK] = ACTIONS(662),
    [anon_sym_STAR_QMARK] = ACTIONS(662),
    [anon_sym_SLASH_QMARK] = ACTIONS(662),
    [anon_sym_PERCENT_QMARK] = ACTIONS(662),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(662),
    [anon_sym_as] = ACTIONS(662),
    [anon_sym_LPAREN2] = ACTIONS(662),
    [anon_sym_DOT_GT] = ACTIONS(662),
    [anon_sym_where] = ACTIONS(662),
    [anon_sym_TILDE] = ACTIONS(662),
    [anon_sym_end] = ACTIONS(662),
    [anon_sym_if] = ACTIONS(664),
    [anon_sym_ifdef] = ACTIONS(662),
    [anon_sym_then] = ACTIONS(662),
    [anon_sym_iftype] = ACTIONS(662),
    [anon_sym_else] = ACTIONS(662),
    [anon_sym_for] = ACTIONS(662),
    [anon_sym_while] = ACTIONS(662),
    [anon_sym_try] = ACTIONS(662),
    [anon_sym_with] = ACTIONS(662),
    [anon_sym_repeat] = ACTIONS(662),
    [anon_sym_until] = ACTIONS(662),
    [anon_sym_do] = ACTIONS(662),
    [anon_sym_recover] = ACTIONS(662),
    [anon_sym_match] = ACTIONS(662),
    [anon_sym_return] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(662),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_consume] = ACTIONS(662),
    [anon_sym_object] = ACTIONS(662),
    [sym_number] = ACTIONS(664),
    [sym_float] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(662),
    [anon_sym_SQUOTE] = ACTIONS(662),
    [anon_sym_true] = ACTIONS(662),
    [anon_sym_false] = ACTIONS(662),
    [sym_this] = ACTIONS(662),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [114] = {
    [sym_identifier] = ACTIONS(726),
    [anon_sym_EQ] = ACTIONS(726),
    [anon_sym_AT] = ACTIONS(724),
    [anon_sym_LBRACK] = ACTIONS(724),
    [anon_sym_RBRACK] = ACTIONS(724),
    [anon_sym_is] = ACTIONS(726),
    [anon_sym_embed] = ACTIONS(724),
    [anon_sym_let] = ACTIONS(724),
    [anon_sym_var] = ACTIONS(724),
    [anon_sym_new] = ACTIONS(724),
    [anon_sym_EQ_GT] = ACTIONS(724),
    [anon_sym_fun] = ACTIONS(724),
    [anon_sym_be] = ACTIONS(724),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_iso] = ACTIONS(724),
    [anon_sym_trn] = ACTIONS(724),
    [anon_sym_ref] = ACTIONS(724),
    [anon_sym_val] = ACTIONS(724),
    [anon_sym_box] = ACTIONS(724),
    [anon_sym_tag] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(726),
    [anon_sym_RPAREN] = ACTIONS(724),
    [anon_sym_DOT] = ACTIONS(726),
    [anon_sym_POUNDread] = ACTIONS(724),
    [anon_sym_POUNDsend] = ACTIONS(724),
    [anon_sym_POUNDshare] = ACTIONS(724),
    [anon_sym_POUNDalias] = ACTIONS(724),
    [anon_sym_POUNDany] = ACTIONS(724),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_CARET] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(724),
    [anon_sym_DASH_GT] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_RBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(724),
    [sym_error] = ACTIONS(724),
    [sym_compile_intrinsic] = ACTIONS(724),
    [anon_sym_compile_error] = ACTIONS(724),
    [sym_location] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(726),
    [anon_sym_not] = ACTIONS(724),
    [anon_sym_DASH_TILDE] = ACTIONS(724),
    [anon_sym_addressof] = ACTIONS(724),
    [anon_sym_digestof] = ACTIONS(724),
    [anon_sym_PLUS] = ACTIONS(726),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_SLASH] = ACTIONS(726),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(726),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_GT_GT] = ACTIONS(726),
    [anon_sym_and] = ACTIONS(724),
    [anon_sym_or] = ACTIONS(724),
    [anon_sym_xor] = ACTIONS(724),
    [anon_sym_isnt] = ACTIONS(724),
    [anon_sym_EQ_EQ] = ACTIONS(726),
    [anon_sym_BANG_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(726),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(726),
    [anon_sym_PLUS_TILDE] = ACTIONS(724),
    [anon_sym_STAR_TILDE] = ACTIONS(724),
    [anon_sym_SLASH_TILDE] = ACTIONS(724),
    [anon_sym_PERCENT_TILDE] = ACTIONS(724),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(724),
    [anon_sym_LT_LT_TILDE] = ACTIONS(724),
    [anon_sym_GT_GT_TILDE] = ACTIONS(724),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(724),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(724),
    [anon_sym_GT_TILDE] = ACTIONS(724),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(724),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(724),
    [anon_sym_LT_TILDE] = ACTIONS(724),
    [anon_sym_PLUS_QMARK] = ACTIONS(724),
    [anon_sym_DASH_QMARK] = ACTIONS(724),
    [anon_sym_STAR_QMARK] = ACTIONS(724),
    [anon_sym_SLASH_QMARK] = ACTIONS(724),
    [anon_sym_PERCENT_QMARK] = ACTIONS(724),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(724),
    [anon_sym_as] = ACTIONS(724),
    [anon_sym_LPAREN2] = ACTIONS(724),
    [anon_sym_DOT_GT] = ACTIONS(724),
    [anon_sym_where] = ACTIONS(724),
    [anon_sym_TILDE] = ACTIONS(724),
    [anon_sym_end] = ACTIONS(724),
    [anon_sym_if] = ACTIONS(726),
    [anon_sym_ifdef] = ACTIONS(724),
    [anon_sym_then] = ACTIONS(724),
    [anon_sym_iftype] = ACTIONS(724),
    [anon_sym_else] = ACTIONS(724),
    [anon_sym_for] = ACTIONS(724),
    [anon_sym_while] = ACTIONS(724),
    [anon_sym_try] = ACTIONS(724),
    [anon_sym_with] = ACTIONS(724),
    [anon_sym_repeat] = ACTIONS(724),
    [anon_sym_until] = ACTIONS(724),
    [anon_sym_do] = ACTIONS(724),
    [anon_sym_recover] = ACTIONS(724),
    [anon_sym_match] = ACTIONS(724),
    [anon_sym_return] = ACTIONS(724),
    [anon_sym_continue] = ACTIONS(724),
    [anon_sym_break] = ACTIONS(724),
    [anon_sym_consume] = ACTIONS(724),
    [anon_sym_object] = ACTIONS(724),
    [sym_number] = ACTIONS(726),
    [sym_float] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(724),
    [anon_sym_SQUOTE] = ACTIONS(724),
    [anon_sym_true] = ACTIONS(724),
    [anon_sym_false] = ACTIONS(724),
    [sym_this] = ACTIONS(724),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [115] = {
    [sym_identifier] = ACTIONS(660),
    [anon_sym_EQ] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(658),
    [anon_sym_RBRACK] = ACTIONS(658),
    [anon_sym_is] = ACTIONS(660),
    [anon_sym_embed] = ACTIONS(658),
    [anon_sym_let] = ACTIONS(658),
    [anon_sym_var] = ACTIONS(658),
    [anon_sym_new] = ACTIONS(658),
    [anon_sym_EQ_GT] = ACTIONS(658),
    [anon_sym_fun] = ACTIONS(658),
    [anon_sym_be] = ACTIONS(658),
    [anon_sym_COMMA] = ACTIONS(658),
    [anon_sym_iso] = ACTIONS(658),
    [anon_sym_trn] = ACTIONS(658),
    [anon_sym_ref] = ACTIONS(658),
    [anon_sym_val] = ACTIONS(658),
    [anon_sym_box] = ACTIONS(658),
    [anon_sym_tag] = ACTIONS(658),
    [anon_sym_LPAREN] = ACTIONS(660),
    [anon_sym_RPAREN] = ACTIONS(658),
    [anon_sym_DOT] = ACTIONS(660),
    [anon_sym_POUNDread] = ACTIONS(658),
    [anon_sym_POUNDsend] = ACTIONS(658),
    [anon_sym_POUNDshare] = ACTIONS(658),
    [anon_sym_POUNDalias] = ACTIONS(658),
    [anon_sym_POUNDany] = ACTIONS(658),
    [anon_sym_BANG] = ACTIONS(660),
    [anon_sym_CARET] = ACTIONS(658),
    [anon_sym_PIPE] = ACTIONS(658),
    [anon_sym_AMP] = ACTIONS(658),
    [anon_sym_DASH_GT] = ACTIONS(658),
    [anon_sym_LBRACE] = ACTIONS(658),
    [anon_sym_RBRACE] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(658),
    [sym_error] = ACTIONS(658),
    [sym_compile_intrinsic] = ACTIONS(658),
    [anon_sym_compile_error] = ACTIONS(658),
    [sym_location] = ACTIONS(658),
    [anon_sym_DASH] = ACTIONS(660),
    [anon_sym_not] = ACTIONS(658),
    [anon_sym_DASH_TILDE] = ACTIONS(658),
    [anon_sym_addressof] = ACTIONS(658),
    [anon_sym_digestof] = ACTIONS(658),
    [anon_sym_PLUS] = ACTIONS(660),
    [anon_sym_STAR] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(660),
    [anon_sym_PERCENT] = ACTIONS(660),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(660),
    [anon_sym_LT_LT] = ACTIONS(660),
    [anon_sym_GT_GT] = ACTIONS(660),
    [anon_sym_and] = ACTIONS(658),
    [anon_sym_or] = ACTIONS(658),
    [anon_sym_xor] = ACTIONS(658),
    [anon_sym_isnt] = ACTIONS(658),
    [anon_sym_EQ_EQ] = ACTIONS(660),
    [anon_sym_BANG_EQ] = ACTIONS(660),
    [anon_sym_GT] = ACTIONS(660),
    [anon_sym_GT_EQ] = ACTIONS(660),
    [anon_sym_LT_EQ] = ACTIONS(660),
    [anon_sym_LT] = ACTIONS(660),
    [anon_sym_PLUS_TILDE] = ACTIONS(658),
    [anon_sym_STAR_TILDE] = ACTIONS(658),
    [anon_sym_SLASH_TILDE] = ACTIONS(658),
    [anon_sym_PERCENT_TILDE] = ACTIONS(658),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(658),
    [anon_sym_LT_LT_TILDE] = ACTIONS(658),
    [anon_sym_GT_GT_TILDE] = ACTIONS(658),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(658),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(658),
    [anon_sym_GT_TILDE] = ACTIONS(658),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(658),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(658),
    [anon_sym_LT_TILDE] = ACTIONS(658),
    [anon_sym_PLUS_QMARK] = ACTIONS(658),
    [anon_sym_DASH_QMARK] = ACTIONS(658),
    [anon_sym_STAR_QMARK] = ACTIONS(658),
    [anon_sym_SLASH_QMARK] = ACTIONS(658),
    [anon_sym_PERCENT_QMARK] = ACTIONS(658),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(658),
    [anon_sym_as] = ACTIONS(658),
    [anon_sym_LPAREN2] = ACTIONS(658),
    [anon_sym_DOT_GT] = ACTIONS(658),
    [anon_sym_where] = ACTIONS(658),
    [anon_sym_TILDE] = ACTIONS(658),
    [anon_sym_end] = ACTIONS(658),
    [anon_sym_if] = ACTIONS(660),
    [anon_sym_ifdef] = ACTIONS(658),
    [anon_sym_then] = ACTIONS(658),
    [anon_sym_iftype] = ACTIONS(658),
    [anon_sym_else] = ACTIONS(658),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_while] = ACTIONS(658),
    [anon_sym_try] = ACTIONS(658),
    [anon_sym_with] = ACTIONS(658),
    [anon_sym_repeat] = ACTIONS(658),
    [anon_sym_until] = ACTIONS(658),
    [anon_sym_do] = ACTIONS(658),
    [anon_sym_recover] = ACTIONS(658),
    [anon_sym_match] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(658),
    [anon_sym_continue] = ACTIONS(658),
    [anon_sym_break] = ACTIONS(658),
    [anon_sym_consume] = ACTIONS(658),
    [anon_sym_object] = ACTIONS(658),
    [sym_number] = ACTIONS(660),
    [sym_float] = ACTIONS(658),
    [anon_sym_DQUOTE] = ACTIONS(660),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(658),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_true] = ACTIONS(658),
    [anon_sym_false] = ACTIONS(658),
    [sym_this] = ACTIONS(658),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [116] = {
    [sym_identifier] = ACTIONS(754),
    [anon_sym_EQ] = ACTIONS(754),
    [anon_sym_AT] = ACTIONS(752),
    [anon_sym_LBRACK] = ACTIONS(752),
    [anon_sym_RBRACK] = ACTIONS(752),
    [anon_sym_is] = ACTIONS(754),
    [anon_sym_embed] = ACTIONS(752),
    [anon_sym_let] = ACTIONS(752),
    [anon_sym_var] = ACTIONS(752),
    [anon_sym_new] = ACTIONS(752),
    [anon_sym_EQ_GT] = ACTIONS(752),
    [anon_sym_fun] = ACTIONS(752),
    [anon_sym_be] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(752),
    [anon_sym_iso] = ACTIONS(752),
    [anon_sym_trn] = ACTIONS(752),
    [anon_sym_ref] = ACTIONS(752),
    [anon_sym_val] = ACTIONS(752),
    [anon_sym_box] = ACTIONS(752),
    [anon_sym_tag] = ACTIONS(752),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_RPAREN] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_POUNDread] = ACTIONS(752),
    [anon_sym_POUNDsend] = ACTIONS(752),
    [anon_sym_POUNDshare] = ACTIONS(752),
    [anon_sym_POUNDalias] = ACTIONS(752),
    [anon_sym_POUNDany] = ACTIONS(752),
    [anon_sym_BANG] = ACTIONS(754),
    [anon_sym_CARET] = ACTIONS(752),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_AMP] = ACTIONS(752),
    [anon_sym_DASH_GT] = ACTIONS(752),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_RBRACE] = ACTIONS(752),
    [anon_sym_SEMI] = ACTIONS(752),
    [sym_error] = ACTIONS(752),
    [sym_compile_intrinsic] = ACTIONS(752),
    [anon_sym_compile_error] = ACTIONS(752),
    [sym_location] = ACTIONS(752),
    [anon_sym_DASH] = ACTIONS(754),
    [anon_sym_not] = ACTIONS(752),
    [anon_sym_DASH_TILDE] = ACTIONS(752),
    [anon_sym_addressof] = ACTIONS(752),
    [anon_sym_digestof] = ACTIONS(752),
    [anon_sym_PLUS] = ACTIONS(754),
    [anon_sym_STAR] = ACTIONS(754),
    [anon_sym_SLASH] = ACTIONS(754),
    [anon_sym_PERCENT] = ACTIONS(754),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(754),
    [anon_sym_LT_LT] = ACTIONS(754),
    [anon_sym_GT_GT] = ACTIONS(754),
    [anon_sym_and] = ACTIONS(752),
    [anon_sym_or] = ACTIONS(752),
    [anon_sym_xor] = ACTIONS(752),
    [anon_sym_isnt] = ACTIONS(752),
    [anon_sym_EQ_EQ] = ACTIONS(754),
    [anon_sym_BANG_EQ] = ACTIONS(754),
    [anon_sym_GT] = ACTIONS(754),
    [anon_sym_GT_EQ] = ACTIONS(754),
    [anon_sym_LT_EQ] = ACTIONS(754),
    [anon_sym_LT] = ACTIONS(754),
    [anon_sym_PLUS_TILDE] = ACTIONS(752),
    [anon_sym_STAR_TILDE] = ACTIONS(752),
    [anon_sym_SLASH_TILDE] = ACTIONS(752),
    [anon_sym_PERCENT_TILDE] = ACTIONS(752),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(752),
    [anon_sym_LT_LT_TILDE] = ACTIONS(752),
    [anon_sym_GT_GT_TILDE] = ACTIONS(752),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(752),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(752),
    [anon_sym_GT_TILDE] = ACTIONS(752),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(752),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(752),
    [anon_sym_LT_TILDE] = ACTIONS(752),
    [anon_sym_PLUS_QMARK] = ACTIONS(752),
    [anon_sym_DASH_QMARK] = ACTIONS(752),
    [anon_sym_STAR_QMARK] = ACTIONS(752),
    [anon_sym_SLASH_QMARK] = ACTIONS(752),
    [anon_sym_PERCENT_QMARK] = ACTIONS(752),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(752),
    [anon_sym_as] = ACTIONS(752),
    [anon_sym_LPAREN2] = ACTIONS(752),
    [anon_sym_DOT_GT] = ACTIONS(752),
    [anon_sym_where] = ACTIONS(752),
    [anon_sym_TILDE] = ACTIONS(752),
    [anon_sym_end] = ACTIONS(752),
    [anon_sym_if] = ACTIONS(754),
    [anon_sym_ifdef] = ACTIONS(752),
    [anon_sym_then] = ACTIONS(752),
    [anon_sym_iftype] = ACTIONS(752),
    [anon_sym_else] = ACTIONS(752),
    [anon_sym_for] = ACTIONS(752),
    [anon_sym_while] = ACTIONS(752),
    [anon_sym_try] = ACTIONS(752),
    [anon_sym_with] = ACTIONS(752),
    [anon_sym_repeat] = ACTIONS(752),
    [anon_sym_until] = ACTIONS(752),
    [anon_sym_do] = ACTIONS(752),
    [anon_sym_recover] = ACTIONS(752),
    [anon_sym_match] = ACTIONS(752),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_continue] = ACTIONS(752),
    [anon_sym_break] = ACTIONS(752),
    [anon_sym_consume] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [sym_number] = ACTIONS(754),
    [sym_float] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(754),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(752),
    [anon_sym_true] = ACTIONS(752),
    [anon_sym_false] = ACTIONS(752),
    [sym_this] = ACTIONS(752),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [117] = {
    [sym_identifier] = ACTIONS(758),
    [anon_sym_EQ] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(756),
    [anon_sym_RBRACK] = ACTIONS(756),
    [anon_sym_is] = ACTIONS(758),
    [anon_sym_embed] = ACTIONS(756),
    [anon_sym_let] = ACTIONS(756),
    [anon_sym_var] = ACTIONS(756),
    [anon_sym_new] = ACTIONS(756),
    [anon_sym_EQ_GT] = ACTIONS(756),
    [anon_sym_fun] = ACTIONS(756),
    [anon_sym_be] = ACTIONS(756),
    [anon_sym_COMMA] = ACTIONS(756),
    [anon_sym_iso] = ACTIONS(756),
    [anon_sym_trn] = ACTIONS(756),
    [anon_sym_ref] = ACTIONS(756),
    [anon_sym_val] = ACTIONS(756),
    [anon_sym_box] = ACTIONS(756),
    [anon_sym_tag] = ACTIONS(756),
    [anon_sym_LPAREN] = ACTIONS(758),
    [anon_sym_RPAREN] = ACTIONS(756),
    [anon_sym_DOT] = ACTIONS(758),
    [anon_sym_POUNDread] = ACTIONS(756),
    [anon_sym_POUNDsend] = ACTIONS(756),
    [anon_sym_POUNDshare] = ACTIONS(756),
    [anon_sym_POUNDalias] = ACTIONS(756),
    [anon_sym_POUNDany] = ACTIONS(756),
    [anon_sym_BANG] = ACTIONS(758),
    [anon_sym_CARET] = ACTIONS(756),
    [anon_sym_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(756),
    [anon_sym_DASH_GT] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_RBRACE] = ACTIONS(756),
    [anon_sym_SEMI] = ACTIONS(756),
    [sym_error] = ACTIONS(756),
    [sym_compile_intrinsic] = ACTIONS(756),
    [anon_sym_compile_error] = ACTIONS(756),
    [sym_location] = ACTIONS(756),
    [anon_sym_DASH] = ACTIONS(758),
    [anon_sym_not] = ACTIONS(756),
    [anon_sym_DASH_TILDE] = ACTIONS(756),
    [anon_sym_addressof] = ACTIONS(756),
    [anon_sym_digestof] = ACTIONS(756),
    [anon_sym_PLUS] = ACTIONS(758),
    [anon_sym_STAR] = ACTIONS(758),
    [anon_sym_SLASH] = ACTIONS(758),
    [anon_sym_PERCENT] = ACTIONS(758),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(758),
    [anon_sym_LT_LT] = ACTIONS(758),
    [anon_sym_GT_GT] = ACTIONS(758),
    [anon_sym_and] = ACTIONS(756),
    [anon_sym_or] = ACTIONS(756),
    [anon_sym_xor] = ACTIONS(756),
    [anon_sym_isnt] = ACTIONS(756),
    [anon_sym_EQ_EQ] = ACTIONS(758),
    [anon_sym_BANG_EQ] = ACTIONS(758),
    [anon_sym_GT] = ACTIONS(758),
    [anon_sym_GT_EQ] = ACTIONS(758),
    [anon_sym_LT_EQ] = ACTIONS(758),
    [anon_sym_LT] = ACTIONS(758),
    [anon_sym_PLUS_TILDE] = ACTIONS(756),
    [anon_sym_STAR_TILDE] = ACTIONS(756),
    [anon_sym_SLASH_TILDE] = ACTIONS(756),
    [anon_sym_PERCENT_TILDE] = ACTIONS(756),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(756),
    [anon_sym_LT_LT_TILDE] = ACTIONS(756),
    [anon_sym_GT_GT_TILDE] = ACTIONS(756),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(756),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(756),
    [anon_sym_GT_TILDE] = ACTIONS(756),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(756),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(756),
    [anon_sym_LT_TILDE] = ACTIONS(756),
    [anon_sym_PLUS_QMARK] = ACTIONS(756),
    [anon_sym_DASH_QMARK] = ACTIONS(756),
    [anon_sym_STAR_QMARK] = ACTIONS(756),
    [anon_sym_SLASH_QMARK] = ACTIONS(756),
    [anon_sym_PERCENT_QMARK] = ACTIONS(756),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(756),
    [anon_sym_as] = ACTIONS(756),
    [anon_sym_LPAREN2] = ACTIONS(756),
    [anon_sym_DOT_GT] = ACTIONS(756),
    [anon_sym_where] = ACTIONS(756),
    [anon_sym_TILDE] = ACTIONS(756),
    [anon_sym_end] = ACTIONS(756),
    [anon_sym_if] = ACTIONS(758),
    [anon_sym_ifdef] = ACTIONS(756),
    [anon_sym_then] = ACTIONS(756),
    [anon_sym_iftype] = ACTIONS(756),
    [anon_sym_else] = ACTIONS(756),
    [anon_sym_for] = ACTIONS(756),
    [anon_sym_while] = ACTIONS(756),
    [anon_sym_try] = ACTIONS(756),
    [anon_sym_with] = ACTIONS(756),
    [anon_sym_repeat] = ACTIONS(756),
    [anon_sym_until] = ACTIONS(756),
    [anon_sym_do] = ACTIONS(756),
    [anon_sym_recover] = ACTIONS(756),
    [anon_sym_match] = ACTIONS(756),
    [anon_sym_return] = ACTIONS(756),
    [anon_sym_continue] = ACTIONS(756),
    [anon_sym_break] = ACTIONS(756),
    [anon_sym_consume] = ACTIONS(756),
    [anon_sym_object] = ACTIONS(756),
    [sym_number] = ACTIONS(758),
    [sym_float] = ACTIONS(756),
    [anon_sym_DQUOTE] = ACTIONS(758),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(756),
    [anon_sym_SQUOTE] = ACTIONS(756),
    [anon_sym_true] = ACTIONS(756),
    [anon_sym_false] = ACTIONS(756),
    [sym_this] = ACTIONS(756),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [118] = {
    [sym_identifier] = ACTIONS(644),
    [anon_sym_EQ] = ACTIONS(644),
    [anon_sym_AT] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_RBRACK] = ACTIONS(642),
    [anon_sym_is] = ACTIONS(644),
    [anon_sym_embed] = ACTIONS(642),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_var] = ACTIONS(642),
    [anon_sym_new] = ACTIONS(642),
    [anon_sym_EQ_GT] = ACTIONS(642),
    [anon_sym_fun] = ACTIONS(642),
    [anon_sym_be] = ACTIONS(642),
    [anon_sym_COMMA] = ACTIONS(642),
    [anon_sym_iso] = ACTIONS(642),
    [anon_sym_trn] = ACTIONS(642),
    [anon_sym_ref] = ACTIONS(642),
    [anon_sym_val] = ACTIONS(642),
    [anon_sym_box] = ACTIONS(642),
    [anon_sym_tag] = ACTIONS(642),
    [anon_sym_LPAREN] = ACTIONS(644),
    [anon_sym_RPAREN] = ACTIONS(642),
    [anon_sym_DOT] = ACTIONS(644),
    [anon_sym_POUNDread] = ACTIONS(642),
    [anon_sym_POUNDsend] = ACTIONS(642),
    [anon_sym_POUNDshare] = ACTIONS(642),
    [anon_sym_POUNDalias] = ACTIONS(642),
    [anon_sym_POUNDany] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(644),
    [anon_sym_CARET] = ACTIONS(642),
    [anon_sym_PIPE] = ACTIONS(642),
    [anon_sym_AMP] = ACTIONS(642),
    [anon_sym_DASH_GT] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(642),
    [anon_sym_RBRACE] = ACTIONS(642),
    [anon_sym_SEMI] = ACTIONS(642),
    [sym_error] = ACTIONS(642),
    [sym_compile_intrinsic] = ACTIONS(642),
    [anon_sym_compile_error] = ACTIONS(642),
    [sym_location] = ACTIONS(642),
    [anon_sym_DASH] = ACTIONS(644),
    [anon_sym_not] = ACTIONS(642),
    [anon_sym_DASH_TILDE] = ACTIONS(642),
    [anon_sym_addressof] = ACTIONS(642),
    [anon_sym_digestof] = ACTIONS(642),
    [anon_sym_PLUS] = ACTIONS(644),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_SLASH] = ACTIONS(644),
    [anon_sym_PERCENT] = ACTIONS(644),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(644),
    [anon_sym_LT_LT] = ACTIONS(644),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_and] = ACTIONS(642),
    [anon_sym_or] = ACTIONS(642),
    [anon_sym_xor] = ACTIONS(642),
    [anon_sym_isnt] = ACTIONS(642),
    [anon_sym_EQ_EQ] = ACTIONS(644),
    [anon_sym_BANG_EQ] = ACTIONS(644),
    [anon_sym_GT] = ACTIONS(644),
    [anon_sym_GT_EQ] = ACTIONS(644),
    [anon_sym_LT_EQ] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(644),
    [anon_sym_PLUS_TILDE] = ACTIONS(642),
    [anon_sym_STAR_TILDE] = ACTIONS(642),
    [anon_sym_SLASH_TILDE] = ACTIONS(642),
    [anon_sym_PERCENT_TILDE] = ACTIONS(642),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(642),
    [anon_sym_LT_LT_TILDE] = ACTIONS(642),
    [anon_sym_GT_GT_TILDE] = ACTIONS(642),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(642),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(642),
    [anon_sym_GT_TILDE] = ACTIONS(642),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(642),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(642),
    [anon_sym_LT_TILDE] = ACTIONS(642),
    [anon_sym_PLUS_QMARK] = ACTIONS(642),
    [anon_sym_DASH_QMARK] = ACTIONS(642),
    [anon_sym_STAR_QMARK] = ACTIONS(642),
    [anon_sym_SLASH_QMARK] = ACTIONS(642),
    [anon_sym_PERCENT_QMARK] = ACTIONS(642),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(642),
    [anon_sym_as] = ACTIONS(642),
    [anon_sym_LPAREN2] = ACTIONS(642),
    [anon_sym_DOT_GT] = ACTIONS(642),
    [anon_sym_where] = ACTIONS(642),
    [anon_sym_TILDE] = ACTIONS(642),
    [anon_sym_end] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(644),
    [anon_sym_ifdef] = ACTIONS(642),
    [anon_sym_then] = ACTIONS(642),
    [anon_sym_iftype] = ACTIONS(642),
    [anon_sym_else] = ACTIONS(642),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(642),
    [anon_sym_try] = ACTIONS(642),
    [anon_sym_with] = ACTIONS(642),
    [anon_sym_repeat] = ACTIONS(642),
    [anon_sym_until] = ACTIONS(642),
    [anon_sym_do] = ACTIONS(642),
    [anon_sym_recover] = ACTIONS(642),
    [anon_sym_match] = ACTIONS(642),
    [anon_sym_return] = ACTIONS(642),
    [anon_sym_continue] = ACTIONS(642),
    [anon_sym_break] = ACTIONS(642),
    [anon_sym_consume] = ACTIONS(642),
    [anon_sym_object] = ACTIONS(642),
    [sym_number] = ACTIONS(644),
    [sym_float] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(642),
    [anon_sym_SQUOTE] = ACTIONS(642),
    [anon_sym_true] = ACTIONS(642),
    [anon_sym_false] = ACTIONS(642),
    [sym_this] = ACTIONS(642),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [119] = {
    [sym_identifier] = ACTIONS(652),
    [anon_sym_EQ] = ACTIONS(652),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_LBRACK] = ACTIONS(650),
    [anon_sym_RBRACK] = ACTIONS(650),
    [anon_sym_is] = ACTIONS(652),
    [anon_sym_embed] = ACTIONS(650),
    [anon_sym_let] = ACTIONS(650),
    [anon_sym_var] = ACTIONS(650),
    [anon_sym_new] = ACTIONS(650),
    [anon_sym_EQ_GT] = ACTIONS(650),
    [anon_sym_fun] = ACTIONS(650),
    [anon_sym_be] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_iso] = ACTIONS(650),
    [anon_sym_trn] = ACTIONS(650),
    [anon_sym_ref] = ACTIONS(650),
    [anon_sym_val] = ACTIONS(650),
    [anon_sym_box] = ACTIONS(650),
    [anon_sym_tag] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(652),
    [anon_sym_RPAREN] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(652),
    [anon_sym_POUNDread] = ACTIONS(650),
    [anon_sym_POUNDsend] = ACTIONS(650),
    [anon_sym_POUNDshare] = ACTIONS(650),
    [anon_sym_POUNDalias] = ACTIONS(650),
    [anon_sym_POUNDany] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(650),
    [anon_sym_DASH_GT] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [sym_error] = ACTIONS(650),
    [sym_compile_intrinsic] = ACTIONS(650),
    [anon_sym_compile_error] = ACTIONS(650),
    [sym_location] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_not] = ACTIONS(650),
    [anon_sym_DASH_TILDE] = ACTIONS(650),
    [anon_sym_addressof] = ACTIONS(650),
    [anon_sym_digestof] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_STAR] = ACTIONS(652),
    [anon_sym_SLASH] = ACTIONS(652),
    [anon_sym_PERCENT] = ACTIONS(652),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(652),
    [anon_sym_LT_LT] = ACTIONS(652),
    [anon_sym_GT_GT] = ACTIONS(652),
    [anon_sym_and] = ACTIONS(650),
    [anon_sym_or] = ACTIONS(650),
    [anon_sym_xor] = ACTIONS(650),
    [anon_sym_isnt] = ACTIONS(650),
    [anon_sym_EQ_EQ] = ACTIONS(652),
    [anon_sym_BANG_EQ] = ACTIONS(652),
    [anon_sym_GT] = ACTIONS(652),
    [anon_sym_GT_EQ] = ACTIONS(652),
    [anon_sym_LT_EQ] = ACTIONS(652),
    [anon_sym_LT] = ACTIONS(652),
    [anon_sym_PLUS_TILDE] = ACTIONS(650),
    [anon_sym_STAR_TILDE] = ACTIONS(650),
    [anon_sym_SLASH_TILDE] = ACTIONS(650),
    [anon_sym_PERCENT_TILDE] = ACTIONS(650),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(650),
    [anon_sym_LT_LT_TILDE] = ACTIONS(650),
    [anon_sym_GT_GT_TILDE] = ACTIONS(650),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(650),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(650),
    [anon_sym_GT_TILDE] = ACTIONS(650),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(650),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(650),
    [anon_sym_LT_TILDE] = ACTIONS(650),
    [anon_sym_PLUS_QMARK] = ACTIONS(650),
    [anon_sym_DASH_QMARK] = ACTIONS(650),
    [anon_sym_STAR_QMARK] = ACTIONS(650),
    [anon_sym_SLASH_QMARK] = ACTIONS(650),
    [anon_sym_PERCENT_QMARK] = ACTIONS(650),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(650),
    [anon_sym_as] = ACTIONS(650),
    [anon_sym_LPAREN2] = ACTIONS(650),
    [anon_sym_DOT_GT] = ACTIONS(650),
    [anon_sym_where] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_end] = ACTIONS(650),
    [anon_sym_if] = ACTIONS(652),
    [anon_sym_ifdef] = ACTIONS(650),
    [anon_sym_then] = ACTIONS(650),
    [anon_sym_iftype] = ACTIONS(650),
    [anon_sym_else] = ACTIONS(650),
    [anon_sym_for] = ACTIONS(650),
    [anon_sym_while] = ACTIONS(650),
    [anon_sym_try] = ACTIONS(650),
    [anon_sym_with] = ACTIONS(650),
    [anon_sym_repeat] = ACTIONS(650),
    [anon_sym_until] = ACTIONS(650),
    [anon_sym_do] = ACTIONS(650),
    [anon_sym_recover] = ACTIONS(650),
    [anon_sym_match] = ACTIONS(650),
    [anon_sym_return] = ACTIONS(650),
    [anon_sym_continue] = ACTIONS(650),
    [anon_sym_break] = ACTIONS(650),
    [anon_sym_consume] = ACTIONS(650),
    [anon_sym_object] = ACTIONS(650),
    [sym_number] = ACTIONS(652),
    [sym_float] = ACTIONS(650),
    [anon_sym_DQUOTE] = ACTIONS(652),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(650),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_true] = ACTIONS(650),
    [anon_sym_false] = ACTIONS(650),
    [sym_this] = ACTIONS(650),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [120] = {
    [sym_identifier] = ACTIONS(762),
    [anon_sym_EQ] = ACTIONS(762),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_LBRACK] = ACTIONS(760),
    [anon_sym_RBRACK] = ACTIONS(760),
    [anon_sym_is] = ACTIONS(762),
    [anon_sym_embed] = ACTIONS(760),
    [anon_sym_let] = ACTIONS(760),
    [anon_sym_var] = ACTIONS(760),
    [anon_sym_new] = ACTIONS(760),
    [anon_sym_EQ_GT] = ACTIONS(760),
    [anon_sym_fun] = ACTIONS(760),
    [anon_sym_be] = ACTIONS(760),
    [anon_sym_COMMA] = ACTIONS(760),
    [anon_sym_iso] = ACTIONS(760),
    [anon_sym_trn] = ACTIONS(760),
    [anon_sym_ref] = ACTIONS(760),
    [anon_sym_val] = ACTIONS(760),
    [anon_sym_box] = ACTIONS(760),
    [anon_sym_tag] = ACTIONS(760),
    [anon_sym_LPAREN] = ACTIONS(762),
    [anon_sym_RPAREN] = ACTIONS(760),
    [anon_sym_DOT] = ACTIONS(762),
    [anon_sym_POUNDread] = ACTIONS(760),
    [anon_sym_POUNDsend] = ACTIONS(760),
    [anon_sym_POUNDshare] = ACTIONS(760),
    [anon_sym_POUNDalias] = ACTIONS(760),
    [anon_sym_POUNDany] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(762),
    [anon_sym_CARET] = ACTIONS(760),
    [anon_sym_PIPE] = ACTIONS(760),
    [anon_sym_AMP] = ACTIONS(760),
    [anon_sym_DASH_GT] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(760),
    [anon_sym_RBRACE] = ACTIONS(760),
    [anon_sym_SEMI] = ACTIONS(760),
    [sym_error] = ACTIONS(760),
    [sym_compile_intrinsic] = ACTIONS(760),
    [anon_sym_compile_error] = ACTIONS(760),
    [sym_location] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_not] = ACTIONS(760),
    [anon_sym_DASH_TILDE] = ACTIONS(760),
    [anon_sym_addressof] = ACTIONS(760),
    [anon_sym_digestof] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_STAR] = ACTIONS(762),
    [anon_sym_SLASH] = ACTIONS(762),
    [anon_sym_PERCENT] = ACTIONS(762),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(762),
    [anon_sym_LT_LT] = ACTIONS(762),
    [anon_sym_GT_GT] = ACTIONS(762),
    [anon_sym_and] = ACTIONS(760),
    [anon_sym_or] = ACTIONS(760),
    [anon_sym_xor] = ACTIONS(760),
    [anon_sym_isnt] = ACTIONS(760),
    [anon_sym_EQ_EQ] = ACTIONS(762),
    [anon_sym_BANG_EQ] = ACTIONS(762),
    [anon_sym_GT] = ACTIONS(762),
    [anon_sym_GT_EQ] = ACTIONS(762),
    [anon_sym_LT_EQ] = ACTIONS(762),
    [anon_sym_LT] = ACTIONS(762),
    [anon_sym_PLUS_TILDE] = ACTIONS(760),
    [anon_sym_STAR_TILDE] = ACTIONS(760),
    [anon_sym_SLASH_TILDE] = ACTIONS(760),
    [anon_sym_PERCENT_TILDE] = ACTIONS(760),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(760),
    [anon_sym_LT_LT_TILDE] = ACTIONS(760),
    [anon_sym_GT_GT_TILDE] = ACTIONS(760),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(760),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(760),
    [anon_sym_GT_TILDE] = ACTIONS(760),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(760),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(760),
    [anon_sym_LT_TILDE] = ACTIONS(760),
    [anon_sym_PLUS_QMARK] = ACTIONS(760),
    [anon_sym_DASH_QMARK] = ACTIONS(760),
    [anon_sym_STAR_QMARK] = ACTIONS(760),
    [anon_sym_SLASH_QMARK] = ACTIONS(760),
    [anon_sym_PERCENT_QMARK] = ACTIONS(760),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(760),
    [anon_sym_as] = ACTIONS(760),
    [anon_sym_LPAREN2] = ACTIONS(760),
    [anon_sym_DOT_GT] = ACTIONS(760),
    [anon_sym_where] = ACTIONS(760),
    [anon_sym_TILDE] = ACTIONS(760),
    [anon_sym_end] = ACTIONS(760),
    [anon_sym_if] = ACTIONS(762),
    [anon_sym_ifdef] = ACTIONS(760),
    [anon_sym_then] = ACTIONS(760),
    [anon_sym_iftype] = ACTIONS(760),
    [anon_sym_else] = ACTIONS(760),
    [anon_sym_for] = ACTIONS(760),
    [anon_sym_while] = ACTIONS(760),
    [anon_sym_try] = ACTIONS(760),
    [anon_sym_with] = ACTIONS(760),
    [anon_sym_repeat] = ACTIONS(760),
    [anon_sym_until] = ACTIONS(760),
    [anon_sym_do] = ACTIONS(760),
    [anon_sym_recover] = ACTIONS(760),
    [anon_sym_match] = ACTIONS(760),
    [anon_sym_return] = ACTIONS(760),
    [anon_sym_continue] = ACTIONS(760),
    [anon_sym_break] = ACTIONS(760),
    [anon_sym_consume] = ACTIONS(760),
    [anon_sym_object] = ACTIONS(760),
    [sym_number] = ACTIONS(762),
    [sym_float] = ACTIONS(760),
    [anon_sym_DQUOTE] = ACTIONS(762),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(760),
    [anon_sym_true] = ACTIONS(760),
    [anon_sym_false] = ACTIONS(760),
    [sym_this] = ACTIONS(760),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [121] = {
    [sym_identifier] = ACTIONS(770),
    [anon_sym_EQ] = ACTIONS(770),
    [anon_sym_AT] = ACTIONS(768),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_RBRACK] = ACTIONS(768),
    [anon_sym_is] = ACTIONS(770),
    [anon_sym_embed] = ACTIONS(768),
    [anon_sym_let] = ACTIONS(768),
    [anon_sym_var] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(768),
    [anon_sym_EQ_GT] = ACTIONS(768),
    [anon_sym_fun] = ACTIONS(768),
    [anon_sym_be] = ACTIONS(768),
    [anon_sym_COMMA] = ACTIONS(768),
    [anon_sym_iso] = ACTIONS(768),
    [anon_sym_trn] = ACTIONS(768),
    [anon_sym_ref] = ACTIONS(768),
    [anon_sym_val] = ACTIONS(768),
    [anon_sym_box] = ACTIONS(768),
    [anon_sym_tag] = ACTIONS(768),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_RPAREN] = ACTIONS(768),
    [anon_sym_DOT] = ACTIONS(770),
    [anon_sym_POUNDread] = ACTIONS(768),
    [anon_sym_POUNDsend] = ACTIONS(768),
    [anon_sym_POUNDshare] = ACTIONS(768),
    [anon_sym_POUNDalias] = ACTIONS(768),
    [anon_sym_POUNDany] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(770),
    [anon_sym_CARET] = ACTIONS(768),
    [anon_sym_PIPE] = ACTIONS(768),
    [anon_sym_AMP] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(768),
    [anon_sym_LBRACE] = ACTIONS(768),
    [anon_sym_RBRACE] = ACTIONS(768),
    [anon_sym_SEMI] = ACTIONS(768),
    [sym_error] = ACTIONS(768),
    [sym_compile_intrinsic] = ACTIONS(768),
    [anon_sym_compile_error] = ACTIONS(768),
    [sym_location] = ACTIONS(768),
    [anon_sym_DASH] = ACTIONS(770),
    [anon_sym_not] = ACTIONS(768),
    [anon_sym_DASH_TILDE] = ACTIONS(768),
    [anon_sym_addressof] = ACTIONS(768),
    [anon_sym_digestof] = ACTIONS(768),
    [anon_sym_PLUS] = ACTIONS(770),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_SLASH] = ACTIONS(770),
    [anon_sym_PERCENT] = ACTIONS(770),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(770),
    [anon_sym_LT_LT] = ACTIONS(770),
    [anon_sym_GT_GT] = ACTIONS(770),
    [anon_sym_and] = ACTIONS(768),
    [anon_sym_or] = ACTIONS(768),
    [anon_sym_xor] = ACTIONS(768),
    [anon_sym_isnt] = ACTIONS(768),
    [anon_sym_EQ_EQ] = ACTIONS(770),
    [anon_sym_BANG_EQ] = ACTIONS(770),
    [anon_sym_GT] = ACTIONS(770),
    [anon_sym_GT_EQ] = ACTIONS(770),
    [anon_sym_LT_EQ] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(770),
    [anon_sym_PLUS_TILDE] = ACTIONS(768),
    [anon_sym_STAR_TILDE] = ACTIONS(768),
    [anon_sym_SLASH_TILDE] = ACTIONS(768),
    [anon_sym_PERCENT_TILDE] = ACTIONS(768),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(768),
    [anon_sym_LT_LT_TILDE] = ACTIONS(768),
    [anon_sym_GT_GT_TILDE] = ACTIONS(768),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(768),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(768),
    [anon_sym_GT_TILDE] = ACTIONS(768),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(768),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(768),
    [anon_sym_LT_TILDE] = ACTIONS(768),
    [anon_sym_PLUS_QMARK] = ACTIONS(768),
    [anon_sym_DASH_QMARK] = ACTIONS(768),
    [anon_sym_STAR_QMARK] = ACTIONS(768),
    [anon_sym_SLASH_QMARK] = ACTIONS(768),
    [anon_sym_PERCENT_QMARK] = ACTIONS(768),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(768),
    [anon_sym_as] = ACTIONS(768),
    [anon_sym_LPAREN2] = ACTIONS(768),
    [anon_sym_DOT_GT] = ACTIONS(768),
    [anon_sym_where] = ACTIONS(768),
    [anon_sym_TILDE] = ACTIONS(768),
    [anon_sym_end] = ACTIONS(768),
    [anon_sym_if] = ACTIONS(770),
    [anon_sym_ifdef] = ACTIONS(768),
    [anon_sym_then] = ACTIONS(768),
    [anon_sym_iftype] = ACTIONS(768),
    [anon_sym_else] = ACTIONS(768),
    [anon_sym_for] = ACTIONS(768),
    [anon_sym_while] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(768),
    [anon_sym_with] = ACTIONS(768),
    [anon_sym_repeat] = ACTIONS(768),
    [anon_sym_until] = ACTIONS(768),
    [anon_sym_do] = ACTIONS(768),
    [anon_sym_recover] = ACTIONS(768),
    [anon_sym_match] = ACTIONS(768),
    [anon_sym_return] = ACTIONS(768),
    [anon_sym_continue] = ACTIONS(768),
    [anon_sym_break] = ACTIONS(768),
    [anon_sym_consume] = ACTIONS(768),
    [anon_sym_object] = ACTIONS(768),
    [sym_number] = ACTIONS(770),
    [sym_float] = ACTIONS(768),
    [anon_sym_DQUOTE] = ACTIONS(770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(768),
    [anon_sym_SQUOTE] = ACTIONS(768),
    [anon_sym_true] = ACTIONS(768),
    [anon_sym_false] = ACTIONS(768),
    [sym_this] = ACTIONS(768),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [122] = {
    [sym_identifier] = ACTIONS(774),
    [anon_sym_EQ] = ACTIONS(774),
    [anon_sym_AT] = ACTIONS(772),
    [anon_sym_LBRACK] = ACTIONS(772),
    [anon_sym_RBRACK] = ACTIONS(772),
    [anon_sym_is] = ACTIONS(774),
    [anon_sym_embed] = ACTIONS(772),
    [anon_sym_let] = ACTIONS(772),
    [anon_sym_var] = ACTIONS(772),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_EQ_GT] = ACTIONS(772),
    [anon_sym_fun] = ACTIONS(772),
    [anon_sym_be] = ACTIONS(772),
    [anon_sym_COMMA] = ACTIONS(772),
    [anon_sym_iso] = ACTIONS(772),
    [anon_sym_trn] = ACTIONS(772),
    [anon_sym_ref] = ACTIONS(772),
    [anon_sym_val] = ACTIONS(772),
    [anon_sym_box] = ACTIONS(772),
    [anon_sym_tag] = ACTIONS(772),
    [anon_sym_LPAREN] = ACTIONS(774),
    [anon_sym_RPAREN] = ACTIONS(772),
    [anon_sym_DOT] = ACTIONS(774),
    [anon_sym_POUNDread] = ACTIONS(772),
    [anon_sym_POUNDsend] = ACTIONS(772),
    [anon_sym_POUNDshare] = ACTIONS(772),
    [anon_sym_POUNDalias] = ACTIONS(772),
    [anon_sym_POUNDany] = ACTIONS(772),
    [anon_sym_BANG] = ACTIONS(774),
    [anon_sym_CARET] = ACTIONS(772),
    [anon_sym_PIPE] = ACTIONS(772),
    [anon_sym_AMP] = ACTIONS(772),
    [anon_sym_DASH_GT] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(772),
    [anon_sym_RBRACE] = ACTIONS(772),
    [anon_sym_SEMI] = ACTIONS(772),
    [sym_error] = ACTIONS(772),
    [sym_compile_intrinsic] = ACTIONS(772),
    [anon_sym_compile_error] = ACTIONS(772),
    [sym_location] = ACTIONS(772),
    [anon_sym_DASH] = ACTIONS(774),
    [anon_sym_not] = ACTIONS(772),
    [anon_sym_DASH_TILDE] = ACTIONS(772),
    [anon_sym_addressof] = ACTIONS(772),
    [anon_sym_digestof] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(774),
    [anon_sym_STAR] = ACTIONS(774),
    [anon_sym_SLASH] = ACTIONS(774),
    [anon_sym_PERCENT] = ACTIONS(774),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(774),
    [anon_sym_LT_LT] = ACTIONS(774),
    [anon_sym_GT_GT] = ACTIONS(774),
    [anon_sym_and] = ACTIONS(772),
    [anon_sym_or] = ACTIONS(772),
    [anon_sym_xor] = ACTIONS(772),
    [anon_sym_isnt] = ACTIONS(772),
    [anon_sym_EQ_EQ] = ACTIONS(774),
    [anon_sym_BANG_EQ] = ACTIONS(774),
    [anon_sym_GT] = ACTIONS(774),
    [anon_sym_GT_EQ] = ACTIONS(774),
    [anon_sym_LT_EQ] = ACTIONS(774),
    [anon_sym_LT] = ACTIONS(774),
    [anon_sym_PLUS_TILDE] = ACTIONS(772),
    [anon_sym_STAR_TILDE] = ACTIONS(772),
    [anon_sym_SLASH_TILDE] = ACTIONS(772),
    [anon_sym_PERCENT_TILDE] = ACTIONS(772),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(772),
    [anon_sym_LT_LT_TILDE] = ACTIONS(772),
    [anon_sym_GT_GT_TILDE] = ACTIONS(772),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(772),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(772),
    [anon_sym_GT_TILDE] = ACTIONS(772),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(772),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(772),
    [anon_sym_LT_TILDE] = ACTIONS(772),
    [anon_sym_PLUS_QMARK] = ACTIONS(772),
    [anon_sym_DASH_QMARK] = ACTIONS(772),
    [anon_sym_STAR_QMARK] = ACTIONS(772),
    [anon_sym_SLASH_QMARK] = ACTIONS(772),
    [anon_sym_PERCENT_QMARK] = ACTIONS(772),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(772),
    [anon_sym_as] = ACTIONS(772),
    [anon_sym_LPAREN2] = ACTIONS(772),
    [anon_sym_DOT_GT] = ACTIONS(772),
    [anon_sym_where] = ACTIONS(772),
    [anon_sym_TILDE] = ACTIONS(772),
    [anon_sym_end] = ACTIONS(772),
    [anon_sym_if] = ACTIONS(774),
    [anon_sym_ifdef] = ACTIONS(772),
    [anon_sym_then] = ACTIONS(772),
    [anon_sym_iftype] = ACTIONS(772),
    [anon_sym_else] = ACTIONS(772),
    [anon_sym_for] = ACTIONS(772),
    [anon_sym_while] = ACTIONS(772),
    [anon_sym_try] = ACTIONS(772),
    [anon_sym_with] = ACTIONS(772),
    [anon_sym_repeat] = ACTIONS(772),
    [anon_sym_until] = ACTIONS(772),
    [anon_sym_do] = ACTIONS(772),
    [anon_sym_recover] = ACTIONS(772),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_return] = ACTIONS(772),
    [anon_sym_continue] = ACTIONS(772),
    [anon_sym_break] = ACTIONS(772),
    [anon_sym_consume] = ACTIONS(772),
    [anon_sym_object] = ACTIONS(772),
    [sym_number] = ACTIONS(774),
    [sym_float] = ACTIONS(772),
    [anon_sym_DQUOTE] = ACTIONS(774),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(772),
    [anon_sym_SQUOTE] = ACTIONS(772),
    [anon_sym_true] = ACTIONS(772),
    [anon_sym_false] = ACTIONS(772),
    [sym_this] = ACTIONS(772),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [123] = {
    [sym_identifier] = ACTIONS(778),
    [anon_sym_EQ] = ACTIONS(778),
    [anon_sym_AT] = ACTIONS(776),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_RBRACK] = ACTIONS(776),
    [anon_sym_is] = ACTIONS(778),
    [anon_sym_embed] = ACTIONS(776),
    [anon_sym_let] = ACTIONS(776),
    [anon_sym_var] = ACTIONS(776),
    [anon_sym_new] = ACTIONS(776),
    [anon_sym_EQ_GT] = ACTIONS(776),
    [anon_sym_fun] = ACTIONS(776),
    [anon_sym_be] = ACTIONS(776),
    [anon_sym_COMMA] = ACTIONS(776),
    [anon_sym_iso] = ACTIONS(776),
    [anon_sym_trn] = ACTIONS(776),
    [anon_sym_ref] = ACTIONS(776),
    [anon_sym_val] = ACTIONS(776),
    [anon_sym_box] = ACTIONS(776),
    [anon_sym_tag] = ACTIONS(776),
    [anon_sym_LPAREN] = ACTIONS(778),
    [anon_sym_RPAREN] = ACTIONS(776),
    [anon_sym_DOT] = ACTIONS(778),
    [anon_sym_POUNDread] = ACTIONS(776),
    [anon_sym_POUNDsend] = ACTIONS(776),
    [anon_sym_POUNDshare] = ACTIONS(776),
    [anon_sym_POUNDalias] = ACTIONS(776),
    [anon_sym_POUNDany] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_CARET] = ACTIONS(776),
    [anon_sym_PIPE] = ACTIONS(776),
    [anon_sym_AMP] = ACTIONS(776),
    [anon_sym_DASH_GT] = ACTIONS(776),
    [anon_sym_LBRACE] = ACTIONS(776),
    [anon_sym_RBRACE] = ACTIONS(776),
    [anon_sym_SEMI] = ACTIONS(776),
    [sym_error] = ACTIONS(776),
    [sym_compile_intrinsic] = ACTIONS(776),
    [anon_sym_compile_error] = ACTIONS(776),
    [sym_location] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(778),
    [anon_sym_not] = ACTIONS(776),
    [anon_sym_DASH_TILDE] = ACTIONS(776),
    [anon_sym_addressof] = ACTIONS(776),
    [anon_sym_digestof] = ACTIONS(776),
    [anon_sym_PLUS] = ACTIONS(778),
    [anon_sym_STAR] = ACTIONS(778),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_PERCENT] = ACTIONS(778),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(778),
    [anon_sym_LT_LT] = ACTIONS(778),
    [anon_sym_GT_GT] = ACTIONS(778),
    [anon_sym_and] = ACTIONS(776),
    [anon_sym_or] = ACTIONS(776),
    [anon_sym_xor] = ACTIONS(776),
    [anon_sym_isnt] = ACTIONS(776),
    [anon_sym_EQ_EQ] = ACTIONS(778),
    [anon_sym_BANG_EQ] = ACTIONS(778),
    [anon_sym_GT] = ACTIONS(778),
    [anon_sym_GT_EQ] = ACTIONS(778),
    [anon_sym_LT_EQ] = ACTIONS(778),
    [anon_sym_LT] = ACTIONS(778),
    [anon_sym_PLUS_TILDE] = ACTIONS(776),
    [anon_sym_STAR_TILDE] = ACTIONS(776),
    [anon_sym_SLASH_TILDE] = ACTIONS(776),
    [anon_sym_PERCENT_TILDE] = ACTIONS(776),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(776),
    [anon_sym_LT_LT_TILDE] = ACTIONS(776),
    [anon_sym_GT_GT_TILDE] = ACTIONS(776),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(776),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(776),
    [anon_sym_GT_TILDE] = ACTIONS(776),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(776),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(776),
    [anon_sym_LT_TILDE] = ACTIONS(776),
    [anon_sym_PLUS_QMARK] = ACTIONS(776),
    [anon_sym_DASH_QMARK] = ACTIONS(776),
    [anon_sym_STAR_QMARK] = ACTIONS(776),
    [anon_sym_SLASH_QMARK] = ACTIONS(776),
    [anon_sym_PERCENT_QMARK] = ACTIONS(776),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(776),
    [anon_sym_as] = ACTIONS(776),
    [anon_sym_LPAREN2] = ACTIONS(776),
    [anon_sym_DOT_GT] = ACTIONS(776),
    [anon_sym_where] = ACTIONS(776),
    [anon_sym_TILDE] = ACTIONS(776),
    [anon_sym_end] = ACTIONS(776),
    [anon_sym_if] = ACTIONS(778),
    [anon_sym_ifdef] = ACTIONS(776),
    [anon_sym_then] = ACTIONS(776),
    [anon_sym_iftype] = ACTIONS(776),
    [anon_sym_else] = ACTIONS(776),
    [anon_sym_for] = ACTIONS(776),
    [anon_sym_while] = ACTIONS(776),
    [anon_sym_try] = ACTIONS(776),
    [anon_sym_with] = ACTIONS(776),
    [anon_sym_repeat] = ACTIONS(776),
    [anon_sym_until] = ACTIONS(776),
    [anon_sym_do] = ACTIONS(776),
    [anon_sym_recover] = ACTIONS(776),
    [anon_sym_match] = ACTIONS(776),
    [anon_sym_return] = ACTIONS(776),
    [anon_sym_continue] = ACTIONS(776),
    [anon_sym_break] = ACTIONS(776),
    [anon_sym_consume] = ACTIONS(776),
    [anon_sym_object] = ACTIONS(776),
    [sym_number] = ACTIONS(778),
    [sym_float] = ACTIONS(776),
    [anon_sym_DQUOTE] = ACTIONS(778),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(776),
    [anon_sym_SQUOTE] = ACTIONS(776),
    [anon_sym_true] = ACTIONS(776),
    [anon_sym_false] = ACTIONS(776),
    [sym_this] = ACTIONS(776),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [124] = {
    [sym_identifier] = ACTIONS(782),
    [anon_sym_EQ] = ACTIONS(782),
    [anon_sym_AT] = ACTIONS(780),
    [anon_sym_LBRACK] = ACTIONS(780),
    [anon_sym_RBRACK] = ACTIONS(780),
    [anon_sym_is] = ACTIONS(782),
    [anon_sym_embed] = ACTIONS(780),
    [anon_sym_let] = ACTIONS(780),
    [anon_sym_var] = ACTIONS(780),
    [anon_sym_new] = ACTIONS(780),
    [anon_sym_EQ_GT] = ACTIONS(780),
    [anon_sym_fun] = ACTIONS(780),
    [anon_sym_be] = ACTIONS(780),
    [anon_sym_COMMA] = ACTIONS(780),
    [anon_sym_iso] = ACTIONS(780),
    [anon_sym_trn] = ACTIONS(780),
    [anon_sym_ref] = ACTIONS(780),
    [anon_sym_val] = ACTIONS(780),
    [anon_sym_box] = ACTIONS(780),
    [anon_sym_tag] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(782),
    [anon_sym_RPAREN] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(782),
    [anon_sym_POUNDread] = ACTIONS(780),
    [anon_sym_POUNDsend] = ACTIONS(780),
    [anon_sym_POUNDshare] = ACTIONS(780),
    [anon_sym_POUNDalias] = ACTIONS(780),
    [anon_sym_POUNDany] = ACTIONS(780),
    [anon_sym_BANG] = ACTIONS(782),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_DASH_GT] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(780),
    [anon_sym_RBRACE] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(780),
    [sym_error] = ACTIONS(780),
    [sym_compile_intrinsic] = ACTIONS(780),
    [anon_sym_compile_error] = ACTIONS(780),
    [sym_location] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(782),
    [anon_sym_not] = ACTIONS(780),
    [anon_sym_DASH_TILDE] = ACTIONS(780),
    [anon_sym_addressof] = ACTIONS(780),
    [anon_sym_digestof] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(782),
    [anon_sym_STAR] = ACTIONS(782),
    [anon_sym_SLASH] = ACTIONS(782),
    [anon_sym_PERCENT] = ACTIONS(782),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(782),
    [anon_sym_LT_LT] = ACTIONS(782),
    [anon_sym_GT_GT] = ACTIONS(782),
    [anon_sym_and] = ACTIONS(780),
    [anon_sym_or] = ACTIONS(780),
    [anon_sym_xor] = ACTIONS(780),
    [anon_sym_isnt] = ACTIONS(780),
    [anon_sym_EQ_EQ] = ACTIONS(782),
    [anon_sym_BANG_EQ] = ACTIONS(782),
    [anon_sym_GT] = ACTIONS(782),
    [anon_sym_GT_EQ] = ACTIONS(782),
    [anon_sym_LT_EQ] = ACTIONS(782),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_PLUS_TILDE] = ACTIONS(780),
    [anon_sym_STAR_TILDE] = ACTIONS(780),
    [anon_sym_SLASH_TILDE] = ACTIONS(780),
    [anon_sym_PERCENT_TILDE] = ACTIONS(780),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(780),
    [anon_sym_LT_LT_TILDE] = ACTIONS(780),
    [anon_sym_GT_GT_TILDE] = ACTIONS(780),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(780),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(780),
    [anon_sym_GT_TILDE] = ACTIONS(780),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(780),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(780),
    [anon_sym_LT_TILDE] = ACTIONS(780),
    [anon_sym_PLUS_QMARK] = ACTIONS(780),
    [anon_sym_DASH_QMARK] = ACTIONS(780),
    [anon_sym_STAR_QMARK] = ACTIONS(780),
    [anon_sym_SLASH_QMARK] = ACTIONS(780),
    [anon_sym_PERCENT_QMARK] = ACTIONS(780),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(780),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_LPAREN2] = ACTIONS(780),
    [anon_sym_DOT_GT] = ACTIONS(780),
    [anon_sym_where] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_end] = ACTIONS(780),
    [anon_sym_if] = ACTIONS(782),
    [anon_sym_ifdef] = ACTIONS(780),
    [anon_sym_then] = ACTIONS(780),
    [anon_sym_iftype] = ACTIONS(780),
    [anon_sym_else] = ACTIONS(780),
    [anon_sym_for] = ACTIONS(780),
    [anon_sym_while] = ACTIONS(780),
    [anon_sym_try] = ACTIONS(780),
    [anon_sym_with] = ACTIONS(780),
    [anon_sym_repeat] = ACTIONS(780),
    [anon_sym_until] = ACTIONS(780),
    [anon_sym_do] = ACTIONS(780),
    [anon_sym_recover] = ACTIONS(780),
    [anon_sym_match] = ACTIONS(780),
    [anon_sym_return] = ACTIONS(780),
    [anon_sym_continue] = ACTIONS(780),
    [anon_sym_break] = ACTIONS(780),
    [anon_sym_consume] = ACTIONS(780),
    [anon_sym_object] = ACTIONS(780),
    [sym_number] = ACTIONS(782),
    [sym_float] = ACTIONS(780),
    [anon_sym_DQUOTE] = ACTIONS(782),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(780),
    [anon_sym_SQUOTE] = ACTIONS(780),
    [anon_sym_true] = ACTIONS(780),
    [anon_sym_false] = ACTIONS(780),
    [sym_this] = ACTIONS(780),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [125] = {
    [sym_identifier] = ACTIONS(786),
    [anon_sym_EQ] = ACTIONS(786),
    [anon_sym_AT] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(784),
    [anon_sym_RBRACK] = ACTIONS(784),
    [anon_sym_is] = ACTIONS(786),
    [anon_sym_embed] = ACTIONS(784),
    [anon_sym_let] = ACTIONS(784),
    [anon_sym_var] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_EQ_GT] = ACTIONS(784),
    [anon_sym_fun] = ACTIONS(784),
    [anon_sym_be] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(784),
    [anon_sym_iso] = ACTIONS(784),
    [anon_sym_trn] = ACTIONS(784),
    [anon_sym_ref] = ACTIONS(784),
    [anon_sym_val] = ACTIONS(784),
    [anon_sym_box] = ACTIONS(784),
    [anon_sym_tag] = ACTIONS(784),
    [anon_sym_LPAREN] = ACTIONS(786),
    [anon_sym_RPAREN] = ACTIONS(784),
    [anon_sym_DOT] = ACTIONS(786),
    [anon_sym_POUNDread] = ACTIONS(784),
    [anon_sym_POUNDsend] = ACTIONS(784),
    [anon_sym_POUNDshare] = ACTIONS(784),
    [anon_sym_POUNDalias] = ACTIONS(784),
    [anon_sym_POUNDany] = ACTIONS(784),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_CARET] = ACTIONS(784),
    [anon_sym_PIPE] = ACTIONS(784),
    [anon_sym_AMP] = ACTIONS(784),
    [anon_sym_DASH_GT] = ACTIONS(784),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_RBRACE] = ACTIONS(784),
    [anon_sym_SEMI] = ACTIONS(784),
    [sym_error] = ACTIONS(784),
    [sym_compile_intrinsic] = ACTIONS(784),
    [anon_sym_compile_error] = ACTIONS(784),
    [sym_location] = ACTIONS(784),
    [anon_sym_DASH] = ACTIONS(786),
    [anon_sym_not] = ACTIONS(784),
    [anon_sym_DASH_TILDE] = ACTIONS(784),
    [anon_sym_addressof] = ACTIONS(784),
    [anon_sym_digestof] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(786),
    [anon_sym_STAR] = ACTIONS(786),
    [anon_sym_SLASH] = ACTIONS(786),
    [anon_sym_PERCENT] = ACTIONS(786),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(786),
    [anon_sym_LT_LT] = ACTIONS(786),
    [anon_sym_GT_GT] = ACTIONS(786),
    [anon_sym_and] = ACTIONS(784),
    [anon_sym_or] = ACTIONS(784),
    [anon_sym_xor] = ACTIONS(784),
    [anon_sym_isnt] = ACTIONS(784),
    [anon_sym_EQ_EQ] = ACTIONS(786),
    [anon_sym_BANG_EQ] = ACTIONS(786),
    [anon_sym_GT] = ACTIONS(786),
    [anon_sym_GT_EQ] = ACTIONS(786),
    [anon_sym_LT_EQ] = ACTIONS(786),
    [anon_sym_LT] = ACTIONS(786),
    [anon_sym_PLUS_TILDE] = ACTIONS(784),
    [anon_sym_STAR_TILDE] = ACTIONS(784),
    [anon_sym_SLASH_TILDE] = ACTIONS(784),
    [anon_sym_PERCENT_TILDE] = ACTIONS(784),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(784),
    [anon_sym_LT_LT_TILDE] = ACTIONS(784),
    [anon_sym_GT_GT_TILDE] = ACTIONS(784),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(784),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(784),
    [anon_sym_GT_TILDE] = ACTIONS(784),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(784),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(784),
    [anon_sym_LT_TILDE] = ACTIONS(784),
    [anon_sym_PLUS_QMARK] = ACTIONS(784),
    [anon_sym_DASH_QMARK] = ACTIONS(784),
    [anon_sym_STAR_QMARK] = ACTIONS(784),
    [anon_sym_SLASH_QMARK] = ACTIONS(784),
    [anon_sym_PERCENT_QMARK] = ACTIONS(784),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(784),
    [anon_sym_as] = ACTIONS(784),
    [anon_sym_LPAREN2] = ACTIONS(784),
    [anon_sym_DOT_GT] = ACTIONS(784),
    [anon_sym_where] = ACTIONS(784),
    [anon_sym_TILDE] = ACTIONS(784),
    [anon_sym_end] = ACTIONS(784),
    [anon_sym_if] = ACTIONS(786),
    [anon_sym_ifdef] = ACTIONS(784),
    [anon_sym_then] = ACTIONS(784),
    [anon_sym_iftype] = ACTIONS(784),
    [anon_sym_else] = ACTIONS(784),
    [anon_sym_for] = ACTIONS(784),
    [anon_sym_while] = ACTIONS(784),
    [anon_sym_try] = ACTIONS(784),
    [anon_sym_with] = ACTIONS(784),
    [anon_sym_repeat] = ACTIONS(784),
    [anon_sym_until] = ACTIONS(784),
    [anon_sym_do] = ACTIONS(784),
    [anon_sym_recover] = ACTIONS(784),
    [anon_sym_match] = ACTIONS(784),
    [anon_sym_return] = ACTIONS(784),
    [anon_sym_continue] = ACTIONS(784),
    [anon_sym_break] = ACTIONS(784),
    [anon_sym_consume] = ACTIONS(784),
    [anon_sym_object] = ACTIONS(784),
    [sym_number] = ACTIONS(786),
    [sym_float] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(784),
    [anon_sym_SQUOTE] = ACTIONS(784),
    [anon_sym_true] = ACTIONS(784),
    [anon_sym_false] = ACTIONS(784),
    [sym_this] = ACTIONS(784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [126] = {
    [sym_identifier] = ACTIONS(656),
    [anon_sym_EQ] = ACTIONS(656),
    [anon_sym_AT] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(654),
    [anon_sym_RBRACK] = ACTIONS(654),
    [anon_sym_is] = ACTIONS(656),
    [anon_sym_embed] = ACTIONS(654),
    [anon_sym_let] = ACTIONS(654),
    [anon_sym_var] = ACTIONS(654),
    [anon_sym_new] = ACTIONS(654),
    [anon_sym_EQ_GT] = ACTIONS(654),
    [anon_sym_fun] = ACTIONS(654),
    [anon_sym_be] = ACTIONS(654),
    [anon_sym_COMMA] = ACTIONS(654),
    [anon_sym_iso] = ACTIONS(654),
    [anon_sym_trn] = ACTIONS(654),
    [anon_sym_ref] = ACTIONS(654),
    [anon_sym_val] = ACTIONS(654),
    [anon_sym_box] = ACTIONS(654),
    [anon_sym_tag] = ACTIONS(654),
    [anon_sym_LPAREN] = ACTIONS(656),
    [anon_sym_RPAREN] = ACTIONS(654),
    [anon_sym_DOT] = ACTIONS(656),
    [anon_sym_POUNDread] = ACTIONS(654),
    [anon_sym_POUNDsend] = ACTIONS(654),
    [anon_sym_POUNDshare] = ACTIONS(654),
    [anon_sym_POUNDalias] = ACTIONS(654),
    [anon_sym_POUNDany] = ACTIONS(654),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(654),
    [anon_sym_PIPE] = ACTIONS(654),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_DASH_GT] = ACTIONS(654),
    [anon_sym_LBRACE] = ACTIONS(654),
    [anon_sym_RBRACE] = ACTIONS(654),
    [anon_sym_SEMI] = ACTIONS(654),
    [sym_error] = ACTIONS(654),
    [sym_compile_intrinsic] = ACTIONS(654),
    [anon_sym_compile_error] = ACTIONS(654),
    [sym_location] = ACTIONS(654),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_not] = ACTIONS(654),
    [anon_sym_DASH_TILDE] = ACTIONS(654),
    [anon_sym_addressof] = ACTIONS(654),
    [anon_sym_digestof] = ACTIONS(654),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_STAR] = ACTIONS(656),
    [anon_sym_SLASH] = ACTIONS(656),
    [anon_sym_PERCENT] = ACTIONS(656),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(656),
    [anon_sym_LT_LT] = ACTIONS(656),
    [anon_sym_GT_GT] = ACTIONS(656),
    [anon_sym_and] = ACTIONS(654),
    [anon_sym_or] = ACTIONS(654),
    [anon_sym_xor] = ACTIONS(654),
    [anon_sym_isnt] = ACTIONS(654),
    [anon_sym_EQ_EQ] = ACTIONS(656),
    [anon_sym_BANG_EQ] = ACTIONS(656),
    [anon_sym_GT] = ACTIONS(656),
    [anon_sym_GT_EQ] = ACTIONS(656),
    [anon_sym_LT_EQ] = ACTIONS(656),
    [anon_sym_LT] = ACTIONS(656),
    [anon_sym_PLUS_TILDE] = ACTIONS(654),
    [anon_sym_STAR_TILDE] = ACTIONS(654),
    [anon_sym_SLASH_TILDE] = ACTIONS(654),
    [anon_sym_PERCENT_TILDE] = ACTIONS(654),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(654),
    [anon_sym_LT_LT_TILDE] = ACTIONS(654),
    [anon_sym_GT_GT_TILDE] = ACTIONS(654),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(654),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(654),
    [anon_sym_GT_TILDE] = ACTIONS(654),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(654),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(654),
    [anon_sym_LT_TILDE] = ACTIONS(654),
    [anon_sym_PLUS_QMARK] = ACTIONS(654),
    [anon_sym_DASH_QMARK] = ACTIONS(654),
    [anon_sym_STAR_QMARK] = ACTIONS(654),
    [anon_sym_SLASH_QMARK] = ACTIONS(654),
    [anon_sym_PERCENT_QMARK] = ACTIONS(654),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(654),
    [anon_sym_as] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(654),
    [anon_sym_DOT_GT] = ACTIONS(654),
    [anon_sym_where] = ACTIONS(654),
    [anon_sym_TILDE] = ACTIONS(654),
    [anon_sym_end] = ACTIONS(654),
    [anon_sym_if] = ACTIONS(656),
    [anon_sym_ifdef] = ACTIONS(654),
    [anon_sym_then] = ACTIONS(654),
    [anon_sym_iftype] = ACTIONS(654),
    [anon_sym_else] = ACTIONS(654),
    [anon_sym_for] = ACTIONS(654),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_try] = ACTIONS(654),
    [anon_sym_with] = ACTIONS(654),
    [anon_sym_repeat] = ACTIONS(654),
    [anon_sym_until] = ACTIONS(654),
    [anon_sym_do] = ACTIONS(654),
    [anon_sym_recover] = ACTIONS(654),
    [anon_sym_match] = ACTIONS(654),
    [anon_sym_return] = ACTIONS(654),
    [anon_sym_continue] = ACTIONS(654),
    [anon_sym_break] = ACTIONS(654),
    [anon_sym_consume] = ACTIONS(654),
    [anon_sym_object] = ACTIONS(654),
    [sym_number] = ACTIONS(656),
    [sym_float] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(654),
    [anon_sym_true] = ACTIONS(654),
    [anon_sym_false] = ACTIONS(654),
    [sym_this] = ACTIONS(654),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [127] = {
    [sym_identifier] = ACTIONS(648),
    [anon_sym_EQ] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(646),
    [anon_sym_LBRACK] = ACTIONS(646),
    [anon_sym_RBRACK] = ACTIONS(646),
    [anon_sym_is] = ACTIONS(648),
    [anon_sym_embed] = ACTIONS(646),
    [anon_sym_let] = ACTIONS(646),
    [anon_sym_var] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(646),
    [anon_sym_EQ_GT] = ACTIONS(646),
    [anon_sym_fun] = ACTIONS(646),
    [anon_sym_be] = ACTIONS(646),
    [anon_sym_COMMA] = ACTIONS(646),
    [anon_sym_iso] = ACTIONS(646),
    [anon_sym_trn] = ACTIONS(646),
    [anon_sym_ref] = ACTIONS(646),
    [anon_sym_val] = ACTIONS(646),
    [anon_sym_box] = ACTIONS(646),
    [anon_sym_tag] = ACTIONS(646),
    [anon_sym_LPAREN] = ACTIONS(648),
    [anon_sym_RPAREN] = ACTIONS(646),
    [anon_sym_DOT] = ACTIONS(648),
    [anon_sym_POUNDread] = ACTIONS(646),
    [anon_sym_POUNDsend] = ACTIONS(646),
    [anon_sym_POUNDshare] = ACTIONS(646),
    [anon_sym_POUNDalias] = ACTIONS(646),
    [anon_sym_POUNDany] = ACTIONS(646),
    [anon_sym_BANG] = ACTIONS(648),
    [anon_sym_CARET] = ACTIONS(646),
    [anon_sym_PIPE] = ACTIONS(646),
    [anon_sym_AMP] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(646),
    [anon_sym_RBRACE] = ACTIONS(646),
    [anon_sym_SEMI] = ACTIONS(646),
    [sym_error] = ACTIONS(646),
    [sym_compile_intrinsic] = ACTIONS(646),
    [anon_sym_compile_error] = ACTIONS(646),
    [sym_location] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(648),
    [anon_sym_not] = ACTIONS(646),
    [anon_sym_DASH_TILDE] = ACTIONS(646),
    [anon_sym_addressof] = ACTIONS(646),
    [anon_sym_digestof] = ACTIONS(646),
    [anon_sym_PLUS] = ACTIONS(648),
    [anon_sym_STAR] = ACTIONS(648),
    [anon_sym_SLASH] = ACTIONS(648),
    [anon_sym_PERCENT] = ACTIONS(648),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(648),
    [anon_sym_LT_LT] = ACTIONS(648),
    [anon_sym_GT_GT] = ACTIONS(648),
    [anon_sym_and] = ACTIONS(646),
    [anon_sym_or] = ACTIONS(646),
    [anon_sym_xor] = ACTIONS(646),
    [anon_sym_isnt] = ACTIONS(646),
    [anon_sym_EQ_EQ] = ACTIONS(648),
    [anon_sym_BANG_EQ] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(648),
    [anon_sym_GT_EQ] = ACTIONS(648),
    [anon_sym_LT_EQ] = ACTIONS(648),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_PLUS_TILDE] = ACTIONS(646),
    [anon_sym_STAR_TILDE] = ACTIONS(646),
    [anon_sym_SLASH_TILDE] = ACTIONS(646),
    [anon_sym_PERCENT_TILDE] = ACTIONS(646),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(646),
    [anon_sym_LT_LT_TILDE] = ACTIONS(646),
    [anon_sym_GT_GT_TILDE] = ACTIONS(646),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(646),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(646),
    [anon_sym_GT_TILDE] = ACTIONS(646),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(646),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(646),
    [anon_sym_LT_TILDE] = ACTIONS(646),
    [anon_sym_PLUS_QMARK] = ACTIONS(646),
    [anon_sym_DASH_QMARK] = ACTIONS(646),
    [anon_sym_STAR_QMARK] = ACTIONS(646),
    [anon_sym_SLASH_QMARK] = ACTIONS(646),
    [anon_sym_PERCENT_QMARK] = ACTIONS(646),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(646),
    [anon_sym_as] = ACTIONS(646),
    [anon_sym_LPAREN2] = ACTIONS(646),
    [anon_sym_DOT_GT] = ACTIONS(646),
    [anon_sym_where] = ACTIONS(646),
    [anon_sym_TILDE] = ACTIONS(646),
    [anon_sym_end] = ACTIONS(646),
    [anon_sym_if] = ACTIONS(648),
    [anon_sym_ifdef] = ACTIONS(646),
    [anon_sym_then] = ACTIONS(646),
    [anon_sym_iftype] = ACTIONS(646),
    [anon_sym_else] = ACTIONS(646),
    [anon_sym_for] = ACTIONS(646),
    [anon_sym_while] = ACTIONS(646),
    [anon_sym_try] = ACTIONS(646),
    [anon_sym_with] = ACTIONS(646),
    [anon_sym_repeat] = ACTIONS(646),
    [anon_sym_until] = ACTIONS(646),
    [anon_sym_do] = ACTIONS(646),
    [anon_sym_recover] = ACTIONS(646),
    [anon_sym_match] = ACTIONS(646),
    [anon_sym_return] = ACTIONS(646),
    [anon_sym_continue] = ACTIONS(646),
    [anon_sym_break] = ACTIONS(646),
    [anon_sym_consume] = ACTIONS(646),
    [anon_sym_object] = ACTIONS(646),
    [sym_number] = ACTIONS(648),
    [sym_float] = ACTIONS(646),
    [anon_sym_DQUOTE] = ACTIONS(648),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(646),
    [anon_sym_SQUOTE] = ACTIONS(646),
    [anon_sym_true] = ACTIONS(646),
    [anon_sym_false] = ACTIONS(646),
    [sym_this] = ACTIONS(646),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [128] = {
    [sym_identifier] = ACTIONS(706),
    [anon_sym_EQ] = ACTIONS(706),
    [anon_sym_AT] = ACTIONS(704),
    [anon_sym_LBRACK] = ACTIONS(704),
    [anon_sym_RBRACK] = ACTIONS(704),
    [anon_sym_is] = ACTIONS(706),
    [anon_sym_embed] = ACTIONS(704),
    [anon_sym_let] = ACTIONS(704),
    [anon_sym_var] = ACTIONS(704),
    [anon_sym_new] = ACTIONS(704),
    [anon_sym_EQ_GT] = ACTIONS(704),
    [anon_sym_fun] = ACTIONS(704),
    [anon_sym_be] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(704),
    [anon_sym_iso] = ACTIONS(704),
    [anon_sym_trn] = ACTIONS(704),
    [anon_sym_ref] = ACTIONS(704),
    [anon_sym_val] = ACTIONS(704),
    [anon_sym_box] = ACTIONS(704),
    [anon_sym_tag] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(706),
    [anon_sym_RPAREN] = ACTIONS(704),
    [anon_sym_DOT] = ACTIONS(706),
    [anon_sym_POUNDread] = ACTIONS(704),
    [anon_sym_POUNDsend] = ACTIONS(704),
    [anon_sym_POUNDshare] = ACTIONS(704),
    [anon_sym_POUNDalias] = ACTIONS(704),
    [anon_sym_POUNDany] = ACTIONS(704),
    [anon_sym_BANG] = ACTIONS(706),
    [anon_sym_CARET] = ACTIONS(704),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_DASH_GT] = ACTIONS(704),
    [anon_sym_LBRACE] = ACTIONS(704),
    [anon_sym_RBRACE] = ACTIONS(704),
    [anon_sym_SEMI] = ACTIONS(704),
    [sym_error] = ACTIONS(704),
    [sym_compile_intrinsic] = ACTIONS(704),
    [anon_sym_compile_error] = ACTIONS(704),
    [sym_location] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(706),
    [anon_sym_not] = ACTIONS(704),
    [anon_sym_DASH_TILDE] = ACTIONS(704),
    [anon_sym_addressof] = ACTIONS(704),
    [anon_sym_digestof] = ACTIONS(704),
    [anon_sym_PLUS] = ACTIONS(706),
    [anon_sym_STAR] = ACTIONS(706),
    [anon_sym_SLASH] = ACTIONS(706),
    [anon_sym_PERCENT] = ACTIONS(706),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(706),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_GT_GT] = ACTIONS(706),
    [anon_sym_and] = ACTIONS(704),
    [anon_sym_or] = ACTIONS(704),
    [anon_sym_xor] = ACTIONS(704),
    [anon_sym_isnt] = ACTIONS(704),
    [anon_sym_EQ_EQ] = ACTIONS(706),
    [anon_sym_BANG_EQ] = ACTIONS(706),
    [anon_sym_GT] = ACTIONS(706),
    [anon_sym_GT_EQ] = ACTIONS(706),
    [anon_sym_LT_EQ] = ACTIONS(706),
    [anon_sym_LT] = ACTIONS(706),
    [anon_sym_PLUS_TILDE] = ACTIONS(704),
    [anon_sym_STAR_TILDE] = ACTIONS(704),
    [anon_sym_SLASH_TILDE] = ACTIONS(704),
    [anon_sym_PERCENT_TILDE] = ACTIONS(704),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(704),
    [anon_sym_LT_LT_TILDE] = ACTIONS(704),
    [anon_sym_GT_GT_TILDE] = ACTIONS(704),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(704),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(704),
    [anon_sym_GT_TILDE] = ACTIONS(704),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(704),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(704),
    [anon_sym_LT_TILDE] = ACTIONS(704),
    [anon_sym_PLUS_QMARK] = ACTIONS(704),
    [anon_sym_DASH_QMARK] = ACTIONS(704),
    [anon_sym_STAR_QMARK] = ACTIONS(704),
    [anon_sym_SLASH_QMARK] = ACTIONS(704),
    [anon_sym_PERCENT_QMARK] = ACTIONS(704),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(704),
    [anon_sym_as] = ACTIONS(704),
    [anon_sym_LPAREN2] = ACTIONS(704),
    [anon_sym_DOT_GT] = ACTIONS(704),
    [anon_sym_where] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_end] = ACTIONS(704),
    [anon_sym_if] = ACTIONS(706),
    [anon_sym_ifdef] = ACTIONS(704),
    [anon_sym_then] = ACTIONS(704),
    [anon_sym_iftype] = ACTIONS(704),
    [anon_sym_else] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(704),
    [anon_sym_while] = ACTIONS(704),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_with] = ACTIONS(704),
    [anon_sym_repeat] = ACTIONS(704),
    [anon_sym_until] = ACTIONS(704),
    [anon_sym_do] = ACTIONS(704),
    [anon_sym_recover] = ACTIONS(704),
    [anon_sym_match] = ACTIONS(704),
    [anon_sym_return] = ACTIONS(704),
    [anon_sym_continue] = ACTIONS(704),
    [anon_sym_break] = ACTIONS(704),
    [anon_sym_consume] = ACTIONS(704),
    [anon_sym_object] = ACTIONS(704),
    [sym_number] = ACTIONS(706),
    [sym_float] = ACTIONS(704),
    [anon_sym_DQUOTE] = ACTIONS(706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(704),
    [anon_sym_SQUOTE] = ACTIONS(704),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(704),
    [sym_this] = ACTIONS(704),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [129] = {
    [sym_identifier] = ACTIONS(766),
    [anon_sym_EQ] = ACTIONS(766),
    [anon_sym_AT] = ACTIONS(764),
    [anon_sym_LBRACK] = ACTIONS(764),
    [anon_sym_RBRACK] = ACTIONS(764),
    [anon_sym_is] = ACTIONS(766),
    [anon_sym_embed] = ACTIONS(764),
    [anon_sym_let] = ACTIONS(764),
    [anon_sym_var] = ACTIONS(764),
    [anon_sym_new] = ACTIONS(764),
    [anon_sym_EQ_GT] = ACTIONS(764),
    [anon_sym_fun] = ACTIONS(764),
    [anon_sym_be] = ACTIONS(764),
    [anon_sym_COMMA] = ACTIONS(764),
    [anon_sym_iso] = ACTIONS(764),
    [anon_sym_trn] = ACTIONS(764),
    [anon_sym_ref] = ACTIONS(764),
    [anon_sym_val] = ACTIONS(764),
    [anon_sym_box] = ACTIONS(764),
    [anon_sym_tag] = ACTIONS(764),
    [anon_sym_LPAREN] = ACTIONS(766),
    [anon_sym_RPAREN] = ACTIONS(764),
    [anon_sym_DOT] = ACTIONS(766),
    [anon_sym_POUNDread] = ACTIONS(764),
    [anon_sym_POUNDsend] = ACTIONS(764),
    [anon_sym_POUNDshare] = ACTIONS(764),
    [anon_sym_POUNDalias] = ACTIONS(764),
    [anon_sym_POUNDany] = ACTIONS(764),
    [anon_sym_BANG] = ACTIONS(766),
    [anon_sym_CARET] = ACTIONS(764),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_AMP] = ACTIONS(764),
    [anon_sym_DASH_GT] = ACTIONS(764),
    [anon_sym_LBRACE] = ACTIONS(764),
    [anon_sym_RBRACE] = ACTIONS(764),
    [anon_sym_SEMI] = ACTIONS(764),
    [sym_error] = ACTIONS(764),
    [sym_compile_intrinsic] = ACTIONS(764),
    [anon_sym_compile_error] = ACTIONS(764),
    [sym_location] = ACTIONS(764),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_not] = ACTIONS(764),
    [anon_sym_DASH_TILDE] = ACTIONS(764),
    [anon_sym_addressof] = ACTIONS(764),
    [anon_sym_digestof] = ACTIONS(764),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(766),
    [anon_sym_SLASH] = ACTIONS(766),
    [anon_sym_PERCENT] = ACTIONS(766),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(766),
    [anon_sym_LT_LT] = ACTIONS(766),
    [anon_sym_GT_GT] = ACTIONS(766),
    [anon_sym_and] = ACTIONS(764),
    [anon_sym_or] = ACTIONS(764),
    [anon_sym_xor] = ACTIONS(764),
    [anon_sym_isnt] = ACTIONS(764),
    [anon_sym_EQ_EQ] = ACTIONS(766),
    [anon_sym_BANG_EQ] = ACTIONS(766),
    [anon_sym_GT] = ACTIONS(766),
    [anon_sym_GT_EQ] = ACTIONS(766),
    [anon_sym_LT_EQ] = ACTIONS(766),
    [anon_sym_LT] = ACTIONS(766),
    [anon_sym_PLUS_TILDE] = ACTIONS(764),
    [anon_sym_STAR_TILDE] = ACTIONS(764),
    [anon_sym_SLASH_TILDE] = ACTIONS(764),
    [anon_sym_PERCENT_TILDE] = ACTIONS(764),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(764),
    [anon_sym_LT_LT_TILDE] = ACTIONS(764),
    [anon_sym_GT_GT_TILDE] = ACTIONS(764),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(764),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(764),
    [anon_sym_GT_TILDE] = ACTIONS(764),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(764),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(764),
    [anon_sym_LT_TILDE] = ACTIONS(764),
    [anon_sym_PLUS_QMARK] = ACTIONS(764),
    [anon_sym_DASH_QMARK] = ACTIONS(764),
    [anon_sym_STAR_QMARK] = ACTIONS(764),
    [anon_sym_SLASH_QMARK] = ACTIONS(764),
    [anon_sym_PERCENT_QMARK] = ACTIONS(764),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(764),
    [anon_sym_as] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(764),
    [anon_sym_DOT_GT] = ACTIONS(764),
    [anon_sym_where] = ACTIONS(764),
    [anon_sym_TILDE] = ACTIONS(764),
    [anon_sym_end] = ACTIONS(764),
    [anon_sym_if] = ACTIONS(766),
    [anon_sym_ifdef] = ACTIONS(764),
    [anon_sym_then] = ACTIONS(764),
    [anon_sym_iftype] = ACTIONS(764),
    [anon_sym_else] = ACTIONS(764),
    [anon_sym_for] = ACTIONS(764),
    [anon_sym_while] = ACTIONS(764),
    [anon_sym_try] = ACTIONS(764),
    [anon_sym_with] = ACTIONS(764),
    [anon_sym_repeat] = ACTIONS(764),
    [anon_sym_until] = ACTIONS(764),
    [anon_sym_do] = ACTIONS(764),
    [anon_sym_recover] = ACTIONS(764),
    [anon_sym_match] = ACTIONS(764),
    [anon_sym_return] = ACTIONS(764),
    [anon_sym_continue] = ACTIONS(764),
    [anon_sym_break] = ACTIONS(764),
    [anon_sym_consume] = ACTIONS(764),
    [anon_sym_object] = ACTIONS(764),
    [sym_number] = ACTIONS(766),
    [sym_float] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(766),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(764),
    [anon_sym_SQUOTE] = ACTIONS(764),
    [anon_sym_true] = ACTIONS(764),
    [anon_sym_false] = ACTIONS(764),
    [sym_this] = ACTIONS(764),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [130] = {
    [sym_identifier] = ACTIONS(640),
    [anon_sym_EQ] = ACTIONS(640),
    [anon_sym_AT] = ACTIONS(638),
    [anon_sym_LBRACK] = ACTIONS(638),
    [anon_sym_RBRACK] = ACTIONS(638),
    [anon_sym_is] = ACTIONS(640),
    [anon_sym_embed] = ACTIONS(638),
    [anon_sym_let] = ACTIONS(638),
    [anon_sym_var] = ACTIONS(638),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_EQ_GT] = ACTIONS(638),
    [anon_sym_fun] = ACTIONS(638),
    [anon_sym_be] = ACTIONS(638),
    [anon_sym_COMMA] = ACTIONS(638),
    [anon_sym_iso] = ACTIONS(638),
    [anon_sym_trn] = ACTIONS(638),
    [anon_sym_ref] = ACTIONS(638),
    [anon_sym_val] = ACTIONS(638),
    [anon_sym_box] = ACTIONS(638),
    [anon_sym_tag] = ACTIONS(638),
    [anon_sym_LPAREN] = ACTIONS(640),
    [anon_sym_RPAREN] = ACTIONS(638),
    [anon_sym_DOT] = ACTIONS(640),
    [anon_sym_POUNDread] = ACTIONS(638),
    [anon_sym_POUNDsend] = ACTIONS(638),
    [anon_sym_POUNDshare] = ACTIONS(638),
    [anon_sym_POUNDalias] = ACTIONS(638),
    [anon_sym_POUNDany] = ACTIONS(638),
    [anon_sym_BANG] = ACTIONS(640),
    [anon_sym_CARET] = ACTIONS(638),
    [anon_sym_PIPE] = ACTIONS(638),
    [anon_sym_AMP] = ACTIONS(638),
    [anon_sym_DASH_GT] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(638),
    [anon_sym_RBRACE] = ACTIONS(638),
    [anon_sym_SEMI] = ACTIONS(638),
    [sym_error] = ACTIONS(638),
    [sym_compile_intrinsic] = ACTIONS(638),
    [anon_sym_compile_error] = ACTIONS(638),
    [sym_location] = ACTIONS(638),
    [anon_sym_DASH] = ACTIONS(640),
    [anon_sym_not] = ACTIONS(638),
    [anon_sym_DASH_TILDE] = ACTIONS(638),
    [anon_sym_addressof] = ACTIONS(638),
    [anon_sym_digestof] = ACTIONS(638),
    [anon_sym_PLUS] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(640),
    [anon_sym_SLASH] = ACTIONS(640),
    [anon_sym_PERCENT] = ACTIONS(640),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(640),
    [anon_sym_LT_LT] = ACTIONS(640),
    [anon_sym_GT_GT] = ACTIONS(640),
    [anon_sym_and] = ACTIONS(638),
    [anon_sym_or] = ACTIONS(638),
    [anon_sym_xor] = ACTIONS(638),
    [anon_sym_isnt] = ACTIONS(638),
    [anon_sym_EQ_EQ] = ACTIONS(640),
    [anon_sym_BANG_EQ] = ACTIONS(640),
    [anon_sym_GT] = ACTIONS(640),
    [anon_sym_GT_EQ] = ACTIONS(640),
    [anon_sym_LT_EQ] = ACTIONS(640),
    [anon_sym_LT] = ACTIONS(640),
    [anon_sym_PLUS_TILDE] = ACTIONS(638),
    [anon_sym_STAR_TILDE] = ACTIONS(638),
    [anon_sym_SLASH_TILDE] = ACTIONS(638),
    [anon_sym_PERCENT_TILDE] = ACTIONS(638),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(638),
    [anon_sym_LT_LT_TILDE] = ACTIONS(638),
    [anon_sym_GT_GT_TILDE] = ACTIONS(638),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(638),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(638),
    [anon_sym_GT_TILDE] = ACTIONS(638),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(638),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(638),
    [anon_sym_LT_TILDE] = ACTIONS(638),
    [anon_sym_PLUS_QMARK] = ACTIONS(638),
    [anon_sym_DASH_QMARK] = ACTIONS(638),
    [anon_sym_STAR_QMARK] = ACTIONS(638),
    [anon_sym_SLASH_QMARK] = ACTIONS(638),
    [anon_sym_PERCENT_QMARK] = ACTIONS(638),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(638),
    [anon_sym_as] = ACTIONS(638),
    [anon_sym_LPAREN2] = ACTIONS(638),
    [anon_sym_DOT_GT] = ACTIONS(638),
    [anon_sym_where] = ACTIONS(638),
    [anon_sym_TILDE] = ACTIONS(638),
    [anon_sym_end] = ACTIONS(638),
    [anon_sym_if] = ACTIONS(640),
    [anon_sym_ifdef] = ACTIONS(638),
    [anon_sym_then] = ACTIONS(638),
    [anon_sym_iftype] = ACTIONS(638),
    [anon_sym_else] = ACTIONS(638),
    [anon_sym_for] = ACTIONS(638),
    [anon_sym_while] = ACTIONS(638),
    [anon_sym_try] = ACTIONS(638),
    [anon_sym_with] = ACTIONS(638),
    [anon_sym_repeat] = ACTIONS(638),
    [anon_sym_until] = ACTIONS(638),
    [anon_sym_do] = ACTIONS(638),
    [anon_sym_recover] = ACTIONS(638),
    [anon_sym_match] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(638),
    [anon_sym_continue] = ACTIONS(638),
    [anon_sym_break] = ACTIONS(638),
    [anon_sym_consume] = ACTIONS(638),
    [anon_sym_object] = ACTIONS(638),
    [sym_number] = ACTIONS(640),
    [sym_float] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(640),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(638),
    [anon_sym_SQUOTE] = ACTIONS(638),
    [anon_sym_true] = ACTIONS(638),
    [anon_sym_false] = ACTIONS(638),
    [sym_this] = ACTIONS(638),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [131] = {
    [aux_sym_union_type_repeat1] = STATE(145),
    [aux_sym_intersection_type_repeat1] = STATE(147),
    [ts_builtin_sym_end] = ACTIONS(817),
    [sym_identifier] = ACTIONS(819),
    [anon_sym_use] = ACTIONS(817),
    [anon_sym_EQ] = ACTIONS(819),
    [anon_sym_AT] = ACTIONS(817),
    [anon_sym_LBRACK] = ACTIONS(817),
    [anon_sym_type] = ACTIONS(817),
    [anon_sym_is] = ACTIONS(819),
    [anon_sym_actor] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(817),
    [anon_sym_primitive] = ACTIONS(817),
    [anon_sym_interface] = ACTIONS(817),
    [anon_sym_trait] = ACTIONS(817),
    [anon_sym_struct] = ACTIONS(817),
    [anon_sym_embed] = ACTIONS(817),
    [anon_sym_let] = ACTIONS(817),
    [anon_sym_var] = ACTIONS(817),
    [anon_sym_new] = ACTIONS(817),
    [anon_sym_fun] = ACTIONS(817),
    [anon_sym_be] = ACTIONS(817),
    [anon_sym_COMMA] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_RPAREN] = ACTIONS(817),
    [anon_sym_DOT] = ACTIONS(819),
    [anon_sym_BANG] = ACTIONS(821),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_AMP] = ACTIONS(827),
    [anon_sym_DASH_GT] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(817),
    [anon_sym_SEMI] = ACTIONS(817),
    [sym_error] = ACTIONS(817),
    [sym_compile_intrinsic] = ACTIONS(817),
    [anon_sym_compile_error] = ACTIONS(817),
    [sym_location] = ACTIONS(817),
    [anon_sym_DASH] = ACTIONS(819),
    [anon_sym_not] = ACTIONS(817),
    [anon_sym_DASH_TILDE] = ACTIONS(817),
    [anon_sym_addressof] = ACTIONS(817),
    [anon_sym_digestof] = ACTIONS(817),
    [anon_sym_PLUS] = ACTIONS(819),
    [anon_sym_STAR] = ACTIONS(819),
    [anon_sym_SLASH] = ACTIONS(819),
    [anon_sym_PERCENT] = ACTIONS(819),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(819),
    [anon_sym_LT_LT] = ACTIONS(819),
    [anon_sym_GT_GT] = ACTIONS(819),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_or] = ACTIONS(817),
    [anon_sym_xor] = ACTIONS(817),
    [anon_sym_isnt] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(819),
    [anon_sym_BANG_EQ] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(819),
    [anon_sym_GT_EQ] = ACTIONS(819),
    [anon_sym_LT_EQ] = ACTIONS(819),
    [anon_sym_LT] = ACTIONS(819),
    [anon_sym_PLUS_TILDE] = ACTIONS(817),
    [anon_sym_STAR_TILDE] = ACTIONS(817),
    [anon_sym_SLASH_TILDE] = ACTIONS(817),
    [anon_sym_PERCENT_TILDE] = ACTIONS(817),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(817),
    [anon_sym_LT_LT_TILDE] = ACTIONS(817),
    [anon_sym_GT_GT_TILDE] = ACTIONS(817),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(817),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(817),
    [anon_sym_GT_TILDE] = ACTIONS(817),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(817),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(817),
    [anon_sym_LT_TILDE] = ACTIONS(817),
    [anon_sym_PLUS_QMARK] = ACTIONS(817),
    [anon_sym_DASH_QMARK] = ACTIONS(817),
    [anon_sym_STAR_QMARK] = ACTIONS(817),
    [anon_sym_SLASH_QMARK] = ACTIONS(817),
    [anon_sym_PERCENT_QMARK] = ACTIONS(817),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(817),
    [anon_sym_as] = ACTIONS(817),
    [anon_sym_LPAREN2] = ACTIONS(817),
    [anon_sym_DOT_GT] = ACTIONS(817),
    [anon_sym_where] = ACTIONS(817),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_end] = ACTIONS(817),
    [anon_sym_if] = ACTIONS(819),
    [anon_sym_ifdef] = ACTIONS(817),
    [anon_sym_iftype] = ACTIONS(817),
    [anon_sym_else] = ACTIONS(817),
    [anon_sym_for] = ACTIONS(817),
    [anon_sym_while] = ACTIONS(817),
    [anon_sym_try] = ACTIONS(817),
    [anon_sym_with] = ACTIONS(817),
    [anon_sym_repeat] = ACTIONS(817),
    [anon_sym_do] = ACTIONS(817),
    [anon_sym_recover] = ACTIONS(817),
    [anon_sym_match] = ACTIONS(817),
    [anon_sym_return] = ACTIONS(817),
    [anon_sym_continue] = ACTIONS(817),
    [anon_sym_break] = ACTIONS(817),
    [anon_sym_consume] = ACTIONS(817),
    [anon_sym_object] = ACTIONS(817),
    [sym_number] = ACTIONS(819),
    [sym_float] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(817),
    [anon_sym_false] = ACTIONS(817),
    [sym_this] = ACTIONS(817),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [132] = {
    [sym_capability] = STATE(276),
    [ts_builtin_sym_end] = ACTIONS(831),
    [sym_identifier] = ACTIONS(833),
    [anon_sym_use] = ACTIONS(831),
    [anon_sym_EQ] = ACTIONS(833),
    [anon_sym_AT] = ACTIONS(831),
    [anon_sym_LBRACK] = ACTIONS(831),
    [anon_sym_type] = ACTIONS(831),
    [anon_sym_is] = ACTIONS(833),
    [anon_sym_actor] = ACTIONS(831),
    [anon_sym_class] = ACTIONS(831),
    [anon_sym_primitive] = ACTIONS(831),
    [anon_sym_interface] = ACTIONS(831),
    [anon_sym_trait] = ACTIONS(831),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_embed] = ACTIONS(831),
    [anon_sym_let] = ACTIONS(831),
    [anon_sym_var] = ACTIONS(831),
    [anon_sym_new] = ACTIONS(831),
    [anon_sym_fun] = ACTIONS(831),
    [anon_sym_be] = ACTIONS(831),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_iso] = ACTIONS(835),
    [anon_sym_trn] = ACTIONS(835),
    [anon_sym_ref] = ACTIONS(835),
    [anon_sym_val] = ACTIONS(835),
    [anon_sym_box] = ACTIONS(835),
    [anon_sym_tag] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_RPAREN] = ACTIONS(831),
    [anon_sym_DOT] = ACTIONS(833),
    [anon_sym_LBRACE] = ACTIONS(831),
    [anon_sym_SEMI] = ACTIONS(831),
    [sym_error] = ACTIONS(831),
    [sym_compile_intrinsic] = ACTIONS(831),
    [anon_sym_compile_error] = ACTIONS(831),
    [sym_location] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_not] = ACTIONS(831),
    [anon_sym_DASH_TILDE] = ACTIONS(831),
    [anon_sym_addressof] = ACTIONS(831),
    [anon_sym_digestof] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_STAR] = ACTIONS(833),
    [anon_sym_SLASH] = ACTIONS(833),
    [anon_sym_PERCENT] = ACTIONS(833),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(833),
    [anon_sym_LT_LT] = ACTIONS(833),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_and] = ACTIONS(831),
    [anon_sym_or] = ACTIONS(831),
    [anon_sym_xor] = ACTIONS(831),
    [anon_sym_isnt] = ACTIONS(831),
    [anon_sym_EQ_EQ] = ACTIONS(833),
    [anon_sym_BANG_EQ] = ACTIONS(833),
    [anon_sym_GT] = ACTIONS(833),
    [anon_sym_GT_EQ] = ACTIONS(833),
    [anon_sym_LT_EQ] = ACTIONS(833),
    [anon_sym_LT] = ACTIONS(833),
    [anon_sym_PLUS_TILDE] = ACTIONS(831),
    [anon_sym_STAR_TILDE] = ACTIONS(831),
    [anon_sym_SLASH_TILDE] = ACTIONS(831),
    [anon_sym_PERCENT_TILDE] = ACTIONS(831),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(831),
    [anon_sym_LT_LT_TILDE] = ACTIONS(831),
    [anon_sym_GT_GT_TILDE] = ACTIONS(831),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(831),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(831),
    [anon_sym_GT_TILDE] = ACTIONS(831),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(831),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(831),
    [anon_sym_LT_TILDE] = ACTIONS(831),
    [anon_sym_PLUS_QMARK] = ACTIONS(831),
    [anon_sym_DASH_QMARK] = ACTIONS(831),
    [anon_sym_STAR_QMARK] = ACTIONS(831),
    [anon_sym_SLASH_QMARK] = ACTIONS(831),
    [anon_sym_PERCENT_QMARK] = ACTIONS(831),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(831),
    [anon_sym_as] = ACTIONS(831),
    [anon_sym_LPAREN2] = ACTIONS(831),
    [anon_sym_DOT_GT] = ACTIONS(831),
    [anon_sym_where] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(831),
    [anon_sym_end] = ACTIONS(831),
    [anon_sym_if] = ACTIONS(833),
    [anon_sym_ifdef] = ACTIONS(831),
    [anon_sym_iftype] = ACTIONS(831),
    [anon_sym_else] = ACTIONS(831),
    [anon_sym_for] = ACTIONS(831),
    [anon_sym_while] = ACTIONS(831),
    [anon_sym_try] = ACTIONS(831),
    [anon_sym_with] = ACTIONS(831),
    [anon_sym_repeat] = ACTIONS(831),
    [anon_sym_do] = ACTIONS(831),
    [anon_sym_recover] = ACTIONS(831),
    [anon_sym_match] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_continue] = ACTIONS(831),
    [anon_sym_break] = ACTIONS(831),
    [anon_sym_consume] = ACTIONS(831),
    [anon_sym_object] = ACTIONS(831),
    [sym_number] = ACTIONS(833),
    [sym_float] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(831),
    [anon_sym_SQUOTE] = ACTIONS(831),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_this] = ACTIONS(831),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [133] = {
    [sym_capability] = STATE(239),
    [ts_builtin_sym_end] = ACTIONS(837),
    [sym_identifier] = ACTIONS(839),
    [anon_sym_use] = ACTIONS(837),
    [anon_sym_EQ] = ACTIONS(839),
    [anon_sym_AT] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(837),
    [anon_sym_is] = ACTIONS(839),
    [anon_sym_actor] = ACTIONS(837),
    [anon_sym_class] = ACTIONS(837),
    [anon_sym_primitive] = ACTIONS(837),
    [anon_sym_interface] = ACTIONS(837),
    [anon_sym_trait] = ACTIONS(837),
    [anon_sym_struct] = ACTIONS(837),
    [anon_sym_embed] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_var] = ACTIONS(837),
    [anon_sym_new] = ACTIONS(837),
    [anon_sym_fun] = ACTIONS(837),
    [anon_sym_be] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_iso] = ACTIONS(835),
    [anon_sym_trn] = ACTIONS(835),
    [anon_sym_ref] = ACTIONS(835),
    [anon_sym_val] = ACTIONS(835),
    [anon_sym_box] = ACTIONS(835),
    [anon_sym_tag] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(839),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_SEMI] = ACTIONS(837),
    [sym_error] = ACTIONS(837),
    [sym_compile_intrinsic] = ACTIONS(837),
    [anon_sym_compile_error] = ACTIONS(837),
    [sym_location] = ACTIONS(837),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(837),
    [anon_sym_DASH_TILDE] = ACTIONS(837),
    [anon_sym_addressof] = ACTIONS(837),
    [anon_sym_digestof] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_STAR] = ACTIONS(839),
    [anon_sym_SLASH] = ACTIONS(839),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_GT_GT] = ACTIONS(839),
    [anon_sym_and] = ACTIONS(837),
    [anon_sym_or] = ACTIONS(837),
    [anon_sym_xor] = ACTIONS(837),
    [anon_sym_isnt] = ACTIONS(837),
    [anon_sym_EQ_EQ] = ACTIONS(839),
    [anon_sym_BANG_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(839),
    [anon_sym_PLUS_TILDE] = ACTIONS(837),
    [anon_sym_STAR_TILDE] = ACTIONS(837),
    [anon_sym_SLASH_TILDE] = ACTIONS(837),
    [anon_sym_PERCENT_TILDE] = ACTIONS(837),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(837),
    [anon_sym_LT_LT_TILDE] = ACTIONS(837),
    [anon_sym_GT_GT_TILDE] = ACTIONS(837),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(837),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(837),
    [anon_sym_GT_TILDE] = ACTIONS(837),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(837),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(837),
    [anon_sym_LT_TILDE] = ACTIONS(837),
    [anon_sym_PLUS_QMARK] = ACTIONS(837),
    [anon_sym_DASH_QMARK] = ACTIONS(837),
    [anon_sym_STAR_QMARK] = ACTIONS(837),
    [anon_sym_SLASH_QMARK] = ACTIONS(837),
    [anon_sym_PERCENT_QMARK] = ACTIONS(837),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(837),
    [anon_sym_as] = ACTIONS(837),
    [anon_sym_LPAREN2] = ACTIONS(837),
    [anon_sym_DOT_GT] = ACTIONS(837),
    [anon_sym_where] = ACTIONS(837),
    [anon_sym_TILDE] = ACTIONS(837),
    [anon_sym_end] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_ifdef] = ACTIONS(837),
    [anon_sym_iftype] = ACTIONS(837),
    [anon_sym_else] = ACTIONS(837),
    [anon_sym_for] = ACTIONS(837),
    [anon_sym_while] = ACTIONS(837),
    [anon_sym_try] = ACTIONS(837),
    [anon_sym_with] = ACTIONS(837),
    [anon_sym_repeat] = ACTIONS(837),
    [anon_sym_do] = ACTIONS(837),
    [anon_sym_recover] = ACTIONS(837),
    [anon_sym_match] = ACTIONS(837),
    [anon_sym_return] = ACTIONS(837),
    [anon_sym_continue] = ACTIONS(837),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_consume] = ACTIONS(837),
    [anon_sym_object] = ACTIONS(837),
    [sym_number] = ACTIONS(839),
    [sym_float] = ACTIONS(837),
    [anon_sym_DQUOTE] = ACTIONS(839),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(837),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_true] = ACTIONS(837),
    [anon_sym_false] = ACTIONS(837),
    [sym_this] = ACTIONS(837),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [134] = {
    [sym_capability] = STATE(243),
    [ts_builtin_sym_end] = ACTIONS(841),
    [sym_identifier] = ACTIONS(843),
    [anon_sym_use] = ACTIONS(841),
    [anon_sym_EQ] = ACTIONS(843),
    [anon_sym_AT] = ACTIONS(841),
    [anon_sym_LBRACK] = ACTIONS(841),
    [anon_sym_type] = ACTIONS(841),
    [anon_sym_is] = ACTIONS(843),
    [anon_sym_actor] = ACTIONS(841),
    [anon_sym_class] = ACTIONS(841),
    [anon_sym_primitive] = ACTIONS(841),
    [anon_sym_interface] = ACTIONS(841),
    [anon_sym_trait] = ACTIONS(841),
    [anon_sym_struct] = ACTIONS(841),
    [anon_sym_embed] = ACTIONS(841),
    [anon_sym_let] = ACTIONS(841),
    [anon_sym_var] = ACTIONS(841),
    [anon_sym_new] = ACTIONS(841),
    [anon_sym_fun] = ACTIONS(841),
    [anon_sym_be] = ACTIONS(841),
    [anon_sym_COMMA] = ACTIONS(841),
    [anon_sym_iso] = ACTIONS(835),
    [anon_sym_trn] = ACTIONS(835),
    [anon_sym_ref] = ACTIONS(835),
    [anon_sym_val] = ACTIONS(835),
    [anon_sym_box] = ACTIONS(835),
    [anon_sym_tag] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_RPAREN] = ACTIONS(841),
    [anon_sym_DOT] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(841),
    [anon_sym_SEMI] = ACTIONS(841),
    [sym_error] = ACTIONS(841),
    [sym_compile_intrinsic] = ACTIONS(841),
    [anon_sym_compile_error] = ACTIONS(841),
    [sym_location] = ACTIONS(841),
    [anon_sym_DASH] = ACTIONS(843),
    [anon_sym_not] = ACTIONS(841),
    [anon_sym_DASH_TILDE] = ACTIONS(841),
    [anon_sym_addressof] = ACTIONS(841),
    [anon_sym_digestof] = ACTIONS(841),
    [anon_sym_PLUS] = ACTIONS(843),
    [anon_sym_STAR] = ACTIONS(843),
    [anon_sym_SLASH] = ACTIONS(843),
    [anon_sym_PERCENT] = ACTIONS(843),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(843),
    [anon_sym_LT_LT] = ACTIONS(843),
    [anon_sym_GT_GT] = ACTIONS(843),
    [anon_sym_and] = ACTIONS(841),
    [anon_sym_or] = ACTIONS(841),
    [anon_sym_xor] = ACTIONS(841),
    [anon_sym_isnt] = ACTIONS(841),
    [anon_sym_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(843),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_PLUS_TILDE] = ACTIONS(841),
    [anon_sym_STAR_TILDE] = ACTIONS(841),
    [anon_sym_SLASH_TILDE] = ACTIONS(841),
    [anon_sym_PERCENT_TILDE] = ACTIONS(841),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(841),
    [anon_sym_LT_LT_TILDE] = ACTIONS(841),
    [anon_sym_GT_GT_TILDE] = ACTIONS(841),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(841),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(841),
    [anon_sym_GT_TILDE] = ACTIONS(841),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(841),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(841),
    [anon_sym_LT_TILDE] = ACTIONS(841),
    [anon_sym_PLUS_QMARK] = ACTIONS(841),
    [anon_sym_DASH_QMARK] = ACTIONS(841),
    [anon_sym_STAR_QMARK] = ACTIONS(841),
    [anon_sym_SLASH_QMARK] = ACTIONS(841),
    [anon_sym_PERCENT_QMARK] = ACTIONS(841),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(841),
    [anon_sym_as] = ACTIONS(841),
    [anon_sym_LPAREN2] = ACTIONS(841),
    [anon_sym_DOT_GT] = ACTIONS(841),
    [anon_sym_where] = ACTIONS(841),
    [anon_sym_TILDE] = ACTIONS(841),
    [anon_sym_end] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_ifdef] = ACTIONS(841),
    [anon_sym_iftype] = ACTIONS(841),
    [anon_sym_else] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(841),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_with] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(841),
    [anon_sym_do] = ACTIONS(841),
    [anon_sym_recover] = ACTIONS(841),
    [anon_sym_match] = ACTIONS(841),
    [anon_sym_return] = ACTIONS(841),
    [anon_sym_continue] = ACTIONS(841),
    [anon_sym_break] = ACTIONS(841),
    [anon_sym_consume] = ACTIONS(841),
    [anon_sym_object] = ACTIONS(841),
    [sym_number] = ACTIONS(843),
    [sym_float] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(843),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(841),
    [anon_sym_SQUOTE] = ACTIONS(841),
    [anon_sym_true] = ACTIONS(841),
    [anon_sym_false] = ACTIONS(841),
    [sym_this] = ACTIONS(841),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [135] = {
    [sym_capability] = STATE(263),
    [ts_builtin_sym_end] = ACTIONS(845),
    [sym_identifier] = ACTIONS(847),
    [anon_sym_use] = ACTIONS(845),
    [anon_sym_EQ] = ACTIONS(847),
    [anon_sym_AT] = ACTIONS(845),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_type] = ACTIONS(845),
    [anon_sym_is] = ACTIONS(847),
    [anon_sym_actor] = ACTIONS(845),
    [anon_sym_class] = ACTIONS(845),
    [anon_sym_primitive] = ACTIONS(845),
    [anon_sym_interface] = ACTIONS(845),
    [anon_sym_trait] = ACTIONS(845),
    [anon_sym_struct] = ACTIONS(845),
    [anon_sym_embed] = ACTIONS(845),
    [anon_sym_let] = ACTIONS(845),
    [anon_sym_var] = ACTIONS(845),
    [anon_sym_new] = ACTIONS(845),
    [anon_sym_fun] = ACTIONS(845),
    [anon_sym_be] = ACTIONS(845),
    [anon_sym_COMMA] = ACTIONS(845),
    [anon_sym_iso] = ACTIONS(835),
    [anon_sym_trn] = ACTIONS(835),
    [anon_sym_ref] = ACTIONS(835),
    [anon_sym_val] = ACTIONS(835),
    [anon_sym_box] = ACTIONS(835),
    [anon_sym_tag] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(845),
    [anon_sym_DOT] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(845),
    [anon_sym_SEMI] = ACTIONS(845),
    [sym_error] = ACTIONS(845),
    [sym_compile_intrinsic] = ACTIONS(845),
    [anon_sym_compile_error] = ACTIONS(845),
    [sym_location] = ACTIONS(845),
    [anon_sym_DASH] = ACTIONS(847),
    [anon_sym_not] = ACTIONS(845),
    [anon_sym_DASH_TILDE] = ACTIONS(845),
    [anon_sym_addressof] = ACTIONS(845),
    [anon_sym_digestof] = ACTIONS(845),
    [anon_sym_PLUS] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(847),
    [anon_sym_SLASH] = ACTIONS(847),
    [anon_sym_PERCENT] = ACTIONS(847),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(847),
    [anon_sym_LT_LT] = ACTIONS(847),
    [anon_sym_GT_GT] = ACTIONS(847),
    [anon_sym_and] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(845),
    [anon_sym_xor] = ACTIONS(845),
    [anon_sym_isnt] = ACTIONS(845),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_GT_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(847),
    [anon_sym_PLUS_TILDE] = ACTIONS(845),
    [anon_sym_STAR_TILDE] = ACTIONS(845),
    [anon_sym_SLASH_TILDE] = ACTIONS(845),
    [anon_sym_PERCENT_TILDE] = ACTIONS(845),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(845),
    [anon_sym_LT_LT_TILDE] = ACTIONS(845),
    [anon_sym_GT_GT_TILDE] = ACTIONS(845),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(845),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(845),
    [anon_sym_GT_TILDE] = ACTIONS(845),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(845),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(845),
    [anon_sym_LT_TILDE] = ACTIONS(845),
    [anon_sym_PLUS_QMARK] = ACTIONS(845),
    [anon_sym_DASH_QMARK] = ACTIONS(845),
    [anon_sym_STAR_QMARK] = ACTIONS(845),
    [anon_sym_SLASH_QMARK] = ACTIONS(845),
    [anon_sym_PERCENT_QMARK] = ACTIONS(845),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(845),
    [anon_sym_as] = ACTIONS(845),
    [anon_sym_LPAREN2] = ACTIONS(845),
    [anon_sym_DOT_GT] = ACTIONS(845),
    [anon_sym_where] = ACTIONS(845),
    [anon_sym_TILDE] = ACTIONS(845),
    [anon_sym_end] = ACTIONS(845),
    [anon_sym_if] = ACTIONS(847),
    [anon_sym_ifdef] = ACTIONS(845),
    [anon_sym_iftype] = ACTIONS(845),
    [anon_sym_else] = ACTIONS(845),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(845),
    [anon_sym_try] = ACTIONS(845),
    [anon_sym_with] = ACTIONS(845),
    [anon_sym_repeat] = ACTIONS(845),
    [anon_sym_do] = ACTIONS(845),
    [anon_sym_recover] = ACTIONS(845),
    [anon_sym_match] = ACTIONS(845),
    [anon_sym_return] = ACTIONS(845),
    [anon_sym_continue] = ACTIONS(845),
    [anon_sym_break] = ACTIONS(845),
    [anon_sym_consume] = ACTIONS(845),
    [anon_sym_object] = ACTIONS(845),
    [sym_number] = ACTIONS(847),
    [sym_float] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(845),
    [anon_sym_SQUOTE] = ACTIONS(845),
    [anon_sym_true] = ACTIONS(845),
    [anon_sym_false] = ACTIONS(845),
    [sym_this] = ACTIONS(845),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [136] = {
    [sym_capability] = STATE(240),
    [ts_builtin_sym_end] = ACTIONS(849),
    [sym_identifier] = ACTIONS(851),
    [anon_sym_use] = ACTIONS(849),
    [anon_sym_EQ] = ACTIONS(851),
    [anon_sym_AT] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(849),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_is] = ACTIONS(851),
    [anon_sym_actor] = ACTIONS(849),
    [anon_sym_class] = ACTIONS(849),
    [anon_sym_primitive] = ACTIONS(849),
    [anon_sym_interface] = ACTIONS(849),
    [anon_sym_trait] = ACTIONS(849),
    [anon_sym_struct] = ACTIONS(849),
    [anon_sym_embed] = ACTIONS(849),
    [anon_sym_let] = ACTIONS(849),
    [anon_sym_var] = ACTIONS(849),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_fun] = ACTIONS(849),
    [anon_sym_be] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(849),
    [anon_sym_iso] = ACTIONS(835),
    [anon_sym_trn] = ACTIONS(835),
    [anon_sym_ref] = ACTIONS(835),
    [anon_sym_val] = ACTIONS(835),
    [anon_sym_box] = ACTIONS(835),
    [anon_sym_tag] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_RPAREN] = ACTIONS(849),
    [anon_sym_DOT] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(849),
    [anon_sym_SEMI] = ACTIONS(849),
    [sym_error] = ACTIONS(849),
    [sym_compile_intrinsic] = ACTIONS(849),
    [anon_sym_compile_error] = ACTIONS(849),
    [sym_location] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_not] = ACTIONS(849),
    [anon_sym_DASH_TILDE] = ACTIONS(849),
    [anon_sym_addressof] = ACTIONS(849),
    [anon_sym_digestof] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(851),
    [anon_sym_SLASH] = ACTIONS(851),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(851),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_GT_GT] = ACTIONS(851),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_isnt] = ACTIONS(849),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(851),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_LT] = ACTIONS(851),
    [anon_sym_PLUS_TILDE] = ACTIONS(849),
    [anon_sym_STAR_TILDE] = ACTIONS(849),
    [anon_sym_SLASH_TILDE] = ACTIONS(849),
    [anon_sym_PERCENT_TILDE] = ACTIONS(849),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(849),
    [anon_sym_LT_LT_TILDE] = ACTIONS(849),
    [anon_sym_GT_GT_TILDE] = ACTIONS(849),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(849),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(849),
    [anon_sym_GT_TILDE] = ACTIONS(849),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(849),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(849),
    [anon_sym_LT_TILDE] = ACTIONS(849),
    [anon_sym_PLUS_QMARK] = ACTIONS(849),
    [anon_sym_DASH_QMARK] = ACTIONS(849),
    [anon_sym_STAR_QMARK] = ACTIONS(849),
    [anon_sym_SLASH_QMARK] = ACTIONS(849),
    [anon_sym_PERCENT_QMARK] = ACTIONS(849),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(849),
    [anon_sym_as] = ACTIONS(849),
    [anon_sym_LPAREN2] = ACTIONS(849),
    [anon_sym_DOT_GT] = ACTIONS(849),
    [anon_sym_where] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(849),
    [anon_sym_end] = ACTIONS(849),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_ifdef] = ACTIONS(849),
    [anon_sym_iftype] = ACTIONS(849),
    [anon_sym_else] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(849),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_try] = ACTIONS(849),
    [anon_sym_with] = ACTIONS(849),
    [anon_sym_repeat] = ACTIONS(849),
    [anon_sym_do] = ACTIONS(849),
    [anon_sym_recover] = ACTIONS(849),
    [anon_sym_match] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_continue] = ACTIONS(849),
    [anon_sym_break] = ACTIONS(849),
    [anon_sym_consume] = ACTIONS(849),
    [anon_sym_object] = ACTIONS(849),
    [sym_number] = ACTIONS(851),
    [sym_float] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(851),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(849),
    [anon_sym_SQUOTE] = ACTIONS(849),
    [anon_sym_true] = ACTIONS(849),
    [anon_sym_false] = ACTIONS(849),
    [sym_this] = ACTIONS(849),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [137] = {
    [sym_capability] = STATE(249),
    [ts_builtin_sym_end] = ACTIONS(853),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_use] = ACTIONS(853),
    [anon_sym_EQ] = ACTIONS(855),
    [anon_sym_AT] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_type] = ACTIONS(853),
    [anon_sym_is] = ACTIONS(855),
    [anon_sym_actor] = ACTIONS(853),
    [anon_sym_class] = ACTIONS(853),
    [anon_sym_primitive] = ACTIONS(853),
    [anon_sym_interface] = ACTIONS(853),
    [anon_sym_trait] = ACTIONS(853),
    [anon_sym_struct] = ACTIONS(853),
    [anon_sym_embed] = ACTIONS(853),
    [anon_sym_let] = ACTIONS(853),
    [anon_sym_var] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(853),
    [anon_sym_fun] = ACTIONS(853),
    [anon_sym_be] = ACTIONS(853),
    [anon_sym_COMMA] = ACTIONS(853),
    [anon_sym_iso] = ACTIONS(835),
    [anon_sym_trn] = ACTIONS(835),
    [anon_sym_ref] = ACTIONS(835),
    [anon_sym_val] = ACTIONS(835),
    [anon_sym_box] = ACTIONS(835),
    [anon_sym_tag] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(855),
    [anon_sym_RPAREN] = ACTIONS(853),
    [anon_sym_DOT] = ACTIONS(855),
    [anon_sym_LBRACE] = ACTIONS(853),
    [anon_sym_SEMI] = ACTIONS(853),
    [sym_error] = ACTIONS(853),
    [sym_compile_intrinsic] = ACTIONS(853),
    [anon_sym_compile_error] = ACTIONS(853),
    [sym_location] = ACTIONS(853),
    [anon_sym_DASH] = ACTIONS(855),
    [anon_sym_not] = ACTIONS(853),
    [anon_sym_DASH_TILDE] = ACTIONS(853),
    [anon_sym_addressof] = ACTIONS(853),
    [anon_sym_digestof] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_PERCENT] = ACTIONS(855),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(855),
    [anon_sym_LT_LT] = ACTIONS(855),
    [anon_sym_GT_GT] = ACTIONS(855),
    [anon_sym_and] = ACTIONS(853),
    [anon_sym_or] = ACTIONS(853),
    [anon_sym_xor] = ACTIONS(853),
    [anon_sym_isnt] = ACTIONS(853),
    [anon_sym_EQ_EQ] = ACTIONS(855),
    [anon_sym_BANG_EQ] = ACTIONS(855),
    [anon_sym_GT] = ACTIONS(855),
    [anon_sym_GT_EQ] = ACTIONS(855),
    [anon_sym_LT_EQ] = ACTIONS(855),
    [anon_sym_LT] = ACTIONS(855),
    [anon_sym_PLUS_TILDE] = ACTIONS(853),
    [anon_sym_STAR_TILDE] = ACTIONS(853),
    [anon_sym_SLASH_TILDE] = ACTIONS(853),
    [anon_sym_PERCENT_TILDE] = ACTIONS(853),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(853),
    [anon_sym_LT_LT_TILDE] = ACTIONS(853),
    [anon_sym_GT_GT_TILDE] = ACTIONS(853),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(853),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(853),
    [anon_sym_GT_TILDE] = ACTIONS(853),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(853),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(853),
    [anon_sym_LT_TILDE] = ACTIONS(853),
    [anon_sym_PLUS_QMARK] = ACTIONS(853),
    [anon_sym_DASH_QMARK] = ACTIONS(853),
    [anon_sym_STAR_QMARK] = ACTIONS(853),
    [anon_sym_SLASH_QMARK] = ACTIONS(853),
    [anon_sym_PERCENT_QMARK] = ACTIONS(853),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(853),
    [anon_sym_as] = ACTIONS(853),
    [anon_sym_LPAREN2] = ACTIONS(853),
    [anon_sym_DOT_GT] = ACTIONS(853),
    [anon_sym_where] = ACTIONS(853),
    [anon_sym_TILDE] = ACTIONS(853),
    [anon_sym_end] = ACTIONS(853),
    [anon_sym_if] = ACTIONS(855),
    [anon_sym_ifdef] = ACTIONS(853),
    [anon_sym_iftype] = ACTIONS(853),
    [anon_sym_else] = ACTIONS(853),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_while] = ACTIONS(853),
    [anon_sym_try] = ACTIONS(853),
    [anon_sym_with] = ACTIONS(853),
    [anon_sym_repeat] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(853),
    [anon_sym_recover] = ACTIONS(853),
    [anon_sym_match] = ACTIONS(853),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_continue] = ACTIONS(853),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_consume] = ACTIONS(853),
    [anon_sym_object] = ACTIONS(853),
    [sym_number] = ACTIONS(855),
    [sym_float] = ACTIONS(853),
    [anon_sym_DQUOTE] = ACTIONS(855),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(853),
    [anon_sym_true] = ACTIONS(853),
    [anon_sym_false] = ACTIONS(853),
    [sym_this] = ACTIONS(853),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [138] = {
    [aux_sym_union_type_repeat1] = STATE(145),
    [aux_sym_intersection_type_repeat1] = STATE(147),
    [ts_builtin_sym_end] = ACTIONS(857),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_use] = ACTIONS(857),
    [anon_sym_EQ] = ACTIONS(859),
    [anon_sym_AT] = ACTIONS(857),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(857),
    [anon_sym_is] = ACTIONS(859),
    [anon_sym_actor] = ACTIONS(857),
    [anon_sym_class] = ACTIONS(857),
    [anon_sym_primitive] = ACTIONS(857),
    [anon_sym_interface] = ACTIONS(857),
    [anon_sym_trait] = ACTIONS(857),
    [anon_sym_struct] = ACTIONS(857),
    [anon_sym_embed] = ACTIONS(857),
    [anon_sym_let] = ACTIONS(857),
    [anon_sym_var] = ACTIONS(857),
    [anon_sym_new] = ACTIONS(857),
    [anon_sym_fun] = ACTIONS(857),
    [anon_sym_be] = ACTIONS(857),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(857),
    [anon_sym_DOT] = ACTIONS(859),
    [anon_sym_BANG] = ACTIONS(821),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_AMP] = ACTIONS(827),
    [anon_sym_DASH_GT] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(857),
    [anon_sym_SEMI] = ACTIONS(857),
    [sym_error] = ACTIONS(857),
    [sym_compile_intrinsic] = ACTIONS(857),
    [anon_sym_compile_error] = ACTIONS(857),
    [sym_location] = ACTIONS(857),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_not] = ACTIONS(857),
    [anon_sym_DASH_TILDE] = ACTIONS(857),
    [anon_sym_addressof] = ACTIONS(857),
    [anon_sym_digestof] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(859),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(859),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_and] = ACTIONS(857),
    [anon_sym_or] = ACTIONS(857),
    [anon_sym_xor] = ACTIONS(857),
    [anon_sym_isnt] = ACTIONS(857),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(859),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(859),
    [anon_sym_PLUS_TILDE] = ACTIONS(857),
    [anon_sym_STAR_TILDE] = ACTIONS(857),
    [anon_sym_SLASH_TILDE] = ACTIONS(857),
    [anon_sym_PERCENT_TILDE] = ACTIONS(857),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(857),
    [anon_sym_LT_LT_TILDE] = ACTIONS(857),
    [anon_sym_GT_GT_TILDE] = ACTIONS(857),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(857),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(857),
    [anon_sym_GT_TILDE] = ACTIONS(857),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(857),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(857),
    [anon_sym_LT_TILDE] = ACTIONS(857),
    [anon_sym_PLUS_QMARK] = ACTIONS(857),
    [anon_sym_DASH_QMARK] = ACTIONS(857),
    [anon_sym_STAR_QMARK] = ACTIONS(857),
    [anon_sym_SLASH_QMARK] = ACTIONS(857),
    [anon_sym_PERCENT_QMARK] = ACTIONS(857),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(857),
    [anon_sym_as] = ACTIONS(857),
    [anon_sym_LPAREN2] = ACTIONS(857),
    [anon_sym_DOT_GT] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(857),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_end] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_ifdef] = ACTIONS(857),
    [anon_sym_iftype] = ACTIONS(857),
    [anon_sym_else] = ACTIONS(857),
    [anon_sym_for] = ACTIONS(857),
    [anon_sym_while] = ACTIONS(857),
    [anon_sym_try] = ACTIONS(857),
    [anon_sym_with] = ACTIONS(857),
    [anon_sym_repeat] = ACTIONS(857),
    [anon_sym_do] = ACTIONS(857),
    [anon_sym_recover] = ACTIONS(857),
    [anon_sym_match] = ACTIONS(857),
    [anon_sym_return] = ACTIONS(857),
    [anon_sym_continue] = ACTIONS(857),
    [anon_sym_break] = ACTIONS(857),
    [anon_sym_consume] = ACTIONS(857),
    [anon_sym_object] = ACTIONS(857),
    [sym_number] = ACTIONS(859),
    [sym_float] = ACTIONS(857),
    [anon_sym_DQUOTE] = ACTIONS(859),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(857),
    [anon_sym_SQUOTE] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(857),
    [sym_this] = ACTIONS(857),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [139] = {
    [sym_capability] = STATE(244),
    [ts_builtin_sym_end] = ACTIONS(861),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_use] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_is] = ACTIONS(863),
    [anon_sym_actor] = ACTIONS(861),
    [anon_sym_class] = ACTIONS(861),
    [anon_sym_primitive] = ACTIONS(861),
    [anon_sym_interface] = ACTIONS(861),
    [anon_sym_trait] = ACTIONS(861),
    [anon_sym_struct] = ACTIONS(861),
    [anon_sym_embed] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_var] = ACTIONS(861),
    [anon_sym_new] = ACTIONS(861),
    [anon_sym_fun] = ACTIONS(861),
    [anon_sym_be] = ACTIONS(861),
    [anon_sym_COMMA] = ACTIONS(861),
    [anon_sym_iso] = ACTIONS(835),
    [anon_sym_trn] = ACTIONS(835),
    [anon_sym_ref] = ACTIONS(835),
    [anon_sym_val] = ACTIONS(835),
    [anon_sym_box] = ACTIONS(835),
    [anon_sym_tag] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(863),
    [anon_sym_RPAREN] = ACTIONS(861),
    [anon_sym_DOT] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(861),
    [sym_error] = ACTIONS(861),
    [sym_compile_intrinsic] = ACTIONS(861),
    [anon_sym_compile_error] = ACTIONS(861),
    [sym_location] = ACTIONS(861),
    [anon_sym_DASH] = ACTIONS(863),
    [anon_sym_not] = ACTIONS(861),
    [anon_sym_DASH_TILDE] = ACTIONS(861),
    [anon_sym_addressof] = ACTIONS(861),
    [anon_sym_digestof] = ACTIONS(861),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_STAR] = ACTIONS(863),
    [anon_sym_SLASH] = ACTIONS(863),
    [anon_sym_PERCENT] = ACTIONS(863),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(863),
    [anon_sym_LT_LT] = ACTIONS(863),
    [anon_sym_GT_GT] = ACTIONS(863),
    [anon_sym_and] = ACTIONS(861),
    [anon_sym_or] = ACTIONS(861),
    [anon_sym_xor] = ACTIONS(861),
    [anon_sym_isnt] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(863),
    [anon_sym_BANG_EQ] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(863),
    [anon_sym_GT_EQ] = ACTIONS(863),
    [anon_sym_LT_EQ] = ACTIONS(863),
    [anon_sym_LT] = ACTIONS(863),
    [anon_sym_PLUS_TILDE] = ACTIONS(861),
    [anon_sym_STAR_TILDE] = ACTIONS(861),
    [anon_sym_SLASH_TILDE] = ACTIONS(861),
    [anon_sym_PERCENT_TILDE] = ACTIONS(861),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(861),
    [anon_sym_LT_LT_TILDE] = ACTIONS(861),
    [anon_sym_GT_GT_TILDE] = ACTIONS(861),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(861),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(861),
    [anon_sym_GT_TILDE] = ACTIONS(861),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(861),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(861),
    [anon_sym_LT_TILDE] = ACTIONS(861),
    [anon_sym_PLUS_QMARK] = ACTIONS(861),
    [anon_sym_DASH_QMARK] = ACTIONS(861),
    [anon_sym_STAR_QMARK] = ACTIONS(861),
    [anon_sym_SLASH_QMARK] = ACTIONS(861),
    [anon_sym_PERCENT_QMARK] = ACTIONS(861),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(861),
    [anon_sym_as] = ACTIONS(861),
    [anon_sym_LPAREN2] = ACTIONS(861),
    [anon_sym_DOT_GT] = ACTIONS(861),
    [anon_sym_where] = ACTIONS(861),
    [anon_sym_TILDE] = ACTIONS(861),
    [anon_sym_end] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(863),
    [anon_sym_ifdef] = ACTIONS(861),
    [anon_sym_iftype] = ACTIONS(861),
    [anon_sym_else] = ACTIONS(861),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_while] = ACTIONS(861),
    [anon_sym_try] = ACTIONS(861),
    [anon_sym_with] = ACTIONS(861),
    [anon_sym_repeat] = ACTIONS(861),
    [anon_sym_do] = ACTIONS(861),
    [anon_sym_recover] = ACTIONS(861),
    [anon_sym_match] = ACTIONS(861),
    [anon_sym_return] = ACTIONS(861),
    [anon_sym_continue] = ACTIONS(861),
    [anon_sym_break] = ACTIONS(861),
    [anon_sym_consume] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [sym_number] = ACTIONS(863),
    [sym_float] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(863),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(861),
    [anon_sym_SQUOTE] = ACTIONS(861),
    [anon_sym_true] = ACTIONS(861),
    [anon_sym_false] = ACTIONS(861),
    [sym_this] = ACTIONS(861),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [140] = {
    [sym_capability] = STATE(245),
    [ts_builtin_sym_end] = ACTIONS(865),
    [sym_identifier] = ACTIONS(867),
    [anon_sym_use] = ACTIONS(865),
    [anon_sym_EQ] = ACTIONS(867),
    [anon_sym_AT] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(865),
    [anon_sym_type] = ACTIONS(865),
    [anon_sym_is] = ACTIONS(867),
    [anon_sym_actor] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(865),
    [anon_sym_primitive] = ACTIONS(865),
    [anon_sym_interface] = ACTIONS(865),
    [anon_sym_trait] = ACTIONS(865),
    [anon_sym_struct] = ACTIONS(865),
    [anon_sym_embed] = ACTIONS(865),
    [anon_sym_let] = ACTIONS(865),
    [anon_sym_var] = ACTIONS(865),
    [anon_sym_new] = ACTIONS(865),
    [anon_sym_fun] = ACTIONS(865),
    [anon_sym_be] = ACTIONS(865),
    [anon_sym_COMMA] = ACTIONS(865),
    [anon_sym_iso] = ACTIONS(835),
    [anon_sym_trn] = ACTIONS(835),
    [anon_sym_ref] = ACTIONS(835),
    [anon_sym_val] = ACTIONS(835),
    [anon_sym_box] = ACTIONS(835),
    [anon_sym_tag] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(867),
    [anon_sym_RPAREN] = ACTIONS(865),
    [anon_sym_DOT] = ACTIONS(867),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_SEMI] = ACTIONS(865),
    [sym_error] = ACTIONS(865),
    [sym_compile_intrinsic] = ACTIONS(865),
    [anon_sym_compile_error] = ACTIONS(865),
    [sym_location] = ACTIONS(865),
    [anon_sym_DASH] = ACTIONS(867),
    [anon_sym_not] = ACTIONS(865),
    [anon_sym_DASH_TILDE] = ACTIONS(865),
    [anon_sym_addressof] = ACTIONS(865),
    [anon_sym_digestof] = ACTIONS(865),
    [anon_sym_PLUS] = ACTIONS(867),
    [anon_sym_STAR] = ACTIONS(867),
    [anon_sym_SLASH] = ACTIONS(867),
    [anon_sym_PERCENT] = ACTIONS(867),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(867),
    [anon_sym_LT_LT] = ACTIONS(867),
    [anon_sym_GT_GT] = ACTIONS(867),
    [anon_sym_and] = ACTIONS(865),
    [anon_sym_or] = ACTIONS(865),
    [anon_sym_xor] = ACTIONS(865),
    [anon_sym_isnt] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(867),
    [anon_sym_BANG_EQ] = ACTIONS(867),
    [anon_sym_GT] = ACTIONS(867),
    [anon_sym_GT_EQ] = ACTIONS(867),
    [anon_sym_LT_EQ] = ACTIONS(867),
    [anon_sym_LT] = ACTIONS(867),
    [anon_sym_PLUS_TILDE] = ACTIONS(865),
    [anon_sym_STAR_TILDE] = ACTIONS(865),
    [anon_sym_SLASH_TILDE] = ACTIONS(865),
    [anon_sym_PERCENT_TILDE] = ACTIONS(865),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(865),
    [anon_sym_LT_LT_TILDE] = ACTIONS(865),
    [anon_sym_GT_GT_TILDE] = ACTIONS(865),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(865),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(865),
    [anon_sym_GT_TILDE] = ACTIONS(865),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(865),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(865),
    [anon_sym_LT_TILDE] = ACTIONS(865),
    [anon_sym_PLUS_QMARK] = ACTIONS(865),
    [anon_sym_DASH_QMARK] = ACTIONS(865),
    [anon_sym_STAR_QMARK] = ACTIONS(865),
    [anon_sym_SLASH_QMARK] = ACTIONS(865),
    [anon_sym_PERCENT_QMARK] = ACTIONS(865),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(865),
    [anon_sym_LPAREN2] = ACTIONS(865),
    [anon_sym_DOT_GT] = ACTIONS(865),
    [anon_sym_where] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [anon_sym_end] = ACTIONS(865),
    [anon_sym_if] = ACTIONS(867),
    [anon_sym_ifdef] = ACTIONS(865),
    [anon_sym_iftype] = ACTIONS(865),
    [anon_sym_else] = ACTIONS(865),
    [anon_sym_for] = ACTIONS(865),
    [anon_sym_while] = ACTIONS(865),
    [anon_sym_try] = ACTIONS(865),
    [anon_sym_with] = ACTIONS(865),
    [anon_sym_repeat] = ACTIONS(865),
    [anon_sym_do] = ACTIONS(865),
    [anon_sym_recover] = ACTIONS(865),
    [anon_sym_match] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(865),
    [anon_sym_continue] = ACTIONS(865),
    [anon_sym_break] = ACTIONS(865),
    [anon_sym_consume] = ACTIONS(865),
    [anon_sym_object] = ACTIONS(865),
    [sym_number] = ACTIONS(867),
    [sym_float] = ACTIONS(865),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(865),
    [anon_sym_false] = ACTIONS(865),
    [sym_this] = ACTIONS(865),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [141] = {
    [aux_sym_union_type_repeat1] = STATE(145),
    [aux_sym_intersection_type_repeat1] = STATE(147),
    [ts_builtin_sym_end] = ACTIONS(869),
    [sym_identifier] = ACTIONS(871),
    [anon_sym_use] = ACTIONS(869),
    [anon_sym_EQ] = ACTIONS(871),
    [anon_sym_AT] = ACTIONS(869),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_is] = ACTIONS(871),
    [anon_sym_actor] = ACTIONS(869),
    [anon_sym_class] = ACTIONS(869),
    [anon_sym_primitive] = ACTIONS(869),
    [anon_sym_interface] = ACTIONS(869),
    [anon_sym_trait] = ACTIONS(869),
    [anon_sym_struct] = ACTIONS(869),
    [anon_sym_embed] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_var] = ACTIONS(869),
    [anon_sym_new] = ACTIONS(869),
    [anon_sym_fun] = ACTIONS(869),
    [anon_sym_be] = ACTIONS(869),
    [anon_sym_COMMA] = ACTIONS(869),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(869),
    [anon_sym_DOT] = ACTIONS(871),
    [anon_sym_BANG] = ACTIONS(821),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_AMP] = ACTIONS(827),
    [anon_sym_DASH_GT] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(869),
    [anon_sym_SEMI] = ACTIONS(869),
    [sym_error] = ACTIONS(869),
    [sym_compile_intrinsic] = ACTIONS(869),
    [anon_sym_compile_error] = ACTIONS(869),
    [sym_location] = ACTIONS(869),
    [anon_sym_DASH] = ACTIONS(871),
    [anon_sym_not] = ACTIONS(869),
    [anon_sym_DASH_TILDE] = ACTIONS(869),
    [anon_sym_addressof] = ACTIONS(869),
    [anon_sym_digestof] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(871),
    [anon_sym_STAR] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(871),
    [anon_sym_PERCENT] = ACTIONS(871),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(871),
    [anon_sym_LT_LT] = ACTIONS(871),
    [anon_sym_GT_GT] = ACTIONS(871),
    [anon_sym_and] = ACTIONS(869),
    [anon_sym_or] = ACTIONS(869),
    [anon_sym_xor] = ACTIONS(869),
    [anon_sym_isnt] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(871),
    [anon_sym_BANG_EQ] = ACTIONS(871),
    [anon_sym_GT] = ACTIONS(871),
    [anon_sym_GT_EQ] = ACTIONS(871),
    [anon_sym_LT_EQ] = ACTIONS(871),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_PLUS_TILDE] = ACTIONS(869),
    [anon_sym_STAR_TILDE] = ACTIONS(869),
    [anon_sym_SLASH_TILDE] = ACTIONS(869),
    [anon_sym_PERCENT_TILDE] = ACTIONS(869),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(869),
    [anon_sym_LT_LT_TILDE] = ACTIONS(869),
    [anon_sym_GT_GT_TILDE] = ACTIONS(869),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(869),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(869),
    [anon_sym_GT_TILDE] = ACTIONS(869),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(869),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(869),
    [anon_sym_LT_TILDE] = ACTIONS(869),
    [anon_sym_PLUS_QMARK] = ACTIONS(869),
    [anon_sym_DASH_QMARK] = ACTIONS(869),
    [anon_sym_STAR_QMARK] = ACTIONS(869),
    [anon_sym_SLASH_QMARK] = ACTIONS(869),
    [anon_sym_PERCENT_QMARK] = ACTIONS(869),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(869),
    [anon_sym_as] = ACTIONS(869),
    [anon_sym_LPAREN2] = ACTIONS(869),
    [anon_sym_DOT_GT] = ACTIONS(869),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [anon_sym_end] = ACTIONS(869),
    [anon_sym_if] = ACTIONS(871),
    [anon_sym_ifdef] = ACTIONS(869),
    [anon_sym_iftype] = ACTIONS(869),
    [anon_sym_else] = ACTIONS(869),
    [anon_sym_for] = ACTIONS(869),
    [anon_sym_while] = ACTIONS(869),
    [anon_sym_try] = ACTIONS(869),
    [anon_sym_with] = ACTIONS(869),
    [anon_sym_repeat] = ACTIONS(869),
    [anon_sym_do] = ACTIONS(869),
    [anon_sym_recover] = ACTIONS(869),
    [anon_sym_match] = ACTIONS(869),
    [anon_sym_return] = ACTIONS(869),
    [anon_sym_continue] = ACTIONS(869),
    [anon_sym_break] = ACTIONS(869),
    [anon_sym_consume] = ACTIONS(869),
    [anon_sym_object] = ACTIONS(869),
    [sym_number] = ACTIONS(871),
    [sym_float] = ACTIONS(869),
    [anon_sym_DQUOTE] = ACTIONS(871),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(869),
    [anon_sym_SQUOTE] = ACTIONS(869),
    [anon_sym_true] = ACTIONS(869),
    [anon_sym_false] = ACTIONS(869),
    [sym_this] = ACTIONS(869),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [142] = {
    [sym_capability] = STATE(283),
    [ts_builtin_sym_end] = ACTIONS(873),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_use] = ACTIONS(873),
    [anon_sym_EQ] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_type] = ACTIONS(873),
    [anon_sym_is] = ACTIONS(875),
    [anon_sym_actor] = ACTIONS(873),
    [anon_sym_class] = ACTIONS(873),
    [anon_sym_primitive] = ACTIONS(873),
    [anon_sym_interface] = ACTIONS(873),
    [anon_sym_trait] = ACTIONS(873),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_embed] = ACTIONS(873),
    [anon_sym_let] = ACTIONS(873),
    [anon_sym_var] = ACTIONS(873),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_fun] = ACTIONS(873),
    [anon_sym_be] = ACTIONS(873),
    [anon_sym_COMMA] = ACTIONS(873),
    [anon_sym_iso] = ACTIONS(835),
    [anon_sym_trn] = ACTIONS(835),
    [anon_sym_ref] = ACTIONS(835),
    [anon_sym_val] = ACTIONS(835),
    [anon_sym_box] = ACTIONS(835),
    [anon_sym_tag] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(875),
    [anon_sym_RPAREN] = ACTIONS(873),
    [anon_sym_DOT] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(873),
    [anon_sym_SEMI] = ACTIONS(873),
    [sym_error] = ACTIONS(873),
    [sym_compile_intrinsic] = ACTIONS(873),
    [anon_sym_compile_error] = ACTIONS(873),
    [sym_location] = ACTIONS(873),
    [anon_sym_DASH] = ACTIONS(875),
    [anon_sym_not] = ACTIONS(873),
    [anon_sym_DASH_TILDE] = ACTIONS(873),
    [anon_sym_addressof] = ACTIONS(873),
    [anon_sym_digestof] = ACTIONS(873),
    [anon_sym_PLUS] = ACTIONS(875),
    [anon_sym_STAR] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(875),
    [anon_sym_PERCENT] = ACTIONS(875),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(875),
    [anon_sym_LT_LT] = ACTIONS(875),
    [anon_sym_GT_GT] = ACTIONS(875),
    [anon_sym_and] = ACTIONS(873),
    [anon_sym_or] = ACTIONS(873),
    [anon_sym_xor] = ACTIONS(873),
    [anon_sym_isnt] = ACTIONS(873),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_BANG_EQ] = ACTIONS(875),
    [anon_sym_GT] = ACTIONS(875),
    [anon_sym_GT_EQ] = ACTIONS(875),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(875),
    [anon_sym_PLUS_TILDE] = ACTIONS(873),
    [anon_sym_STAR_TILDE] = ACTIONS(873),
    [anon_sym_SLASH_TILDE] = ACTIONS(873),
    [anon_sym_PERCENT_TILDE] = ACTIONS(873),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(873),
    [anon_sym_LT_LT_TILDE] = ACTIONS(873),
    [anon_sym_GT_GT_TILDE] = ACTIONS(873),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(873),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(873),
    [anon_sym_GT_TILDE] = ACTIONS(873),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(873),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(873),
    [anon_sym_LT_TILDE] = ACTIONS(873),
    [anon_sym_PLUS_QMARK] = ACTIONS(873),
    [anon_sym_DASH_QMARK] = ACTIONS(873),
    [anon_sym_STAR_QMARK] = ACTIONS(873),
    [anon_sym_SLASH_QMARK] = ACTIONS(873),
    [anon_sym_PERCENT_QMARK] = ACTIONS(873),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(873),
    [anon_sym_as] = ACTIONS(873),
    [anon_sym_LPAREN2] = ACTIONS(873),
    [anon_sym_DOT_GT] = ACTIONS(873),
    [anon_sym_where] = ACTIONS(873),
    [anon_sym_TILDE] = ACTIONS(873),
    [anon_sym_end] = ACTIONS(873),
    [anon_sym_if] = ACTIONS(875),
    [anon_sym_ifdef] = ACTIONS(873),
    [anon_sym_iftype] = ACTIONS(873),
    [anon_sym_else] = ACTIONS(873),
    [anon_sym_for] = ACTIONS(873),
    [anon_sym_while] = ACTIONS(873),
    [anon_sym_try] = ACTIONS(873),
    [anon_sym_with] = ACTIONS(873),
    [anon_sym_repeat] = ACTIONS(873),
    [anon_sym_do] = ACTIONS(873),
    [anon_sym_recover] = ACTIONS(873),
    [anon_sym_match] = ACTIONS(873),
    [anon_sym_return] = ACTIONS(873),
    [anon_sym_continue] = ACTIONS(873),
    [anon_sym_break] = ACTIONS(873),
    [anon_sym_consume] = ACTIONS(873),
    [anon_sym_object] = ACTIONS(873),
    [sym_number] = ACTIONS(875),
    [sym_float] = ACTIONS(873),
    [anon_sym_DQUOTE] = ACTIONS(875),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(873),
    [anon_sym_SQUOTE] = ACTIONS(873),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [sym_this] = ACTIONS(873),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [143] = {
    [aux_sym_union_type_repeat1] = STATE(145),
    [aux_sym_intersection_type_repeat1] = STATE(147),
    [ts_builtin_sym_end] = ACTIONS(877),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_use] = ACTIONS(877),
    [anon_sym_EQ] = ACTIONS(879),
    [anon_sym_AT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(877),
    [anon_sym_type] = ACTIONS(877),
    [anon_sym_is] = ACTIONS(879),
    [anon_sym_actor] = ACTIONS(877),
    [anon_sym_class] = ACTIONS(877),
    [anon_sym_primitive] = ACTIONS(877),
    [anon_sym_interface] = ACTIONS(877),
    [anon_sym_trait] = ACTIONS(877),
    [anon_sym_struct] = ACTIONS(877),
    [anon_sym_embed] = ACTIONS(877),
    [anon_sym_let] = ACTIONS(877),
    [anon_sym_var] = ACTIONS(877),
    [anon_sym_new] = ACTIONS(877),
    [anon_sym_fun] = ACTIONS(877),
    [anon_sym_be] = ACTIONS(877),
    [anon_sym_COMMA] = ACTIONS(877),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(877),
    [anon_sym_DOT] = ACTIONS(879),
    [anon_sym_BANG] = ACTIONS(821),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_AMP] = ACTIONS(827),
    [anon_sym_DASH_GT] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(877),
    [sym_error] = ACTIONS(877),
    [sym_compile_intrinsic] = ACTIONS(877),
    [anon_sym_compile_error] = ACTIONS(877),
    [sym_location] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(879),
    [anon_sym_not] = ACTIONS(877),
    [anon_sym_DASH_TILDE] = ACTIONS(877),
    [anon_sym_addressof] = ACTIONS(877),
    [anon_sym_digestof] = ACTIONS(877),
    [anon_sym_PLUS] = ACTIONS(879),
    [anon_sym_STAR] = ACTIONS(879),
    [anon_sym_SLASH] = ACTIONS(879),
    [anon_sym_PERCENT] = ACTIONS(879),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(879),
    [anon_sym_LT_LT] = ACTIONS(879),
    [anon_sym_GT_GT] = ACTIONS(879),
    [anon_sym_and] = ACTIONS(877),
    [anon_sym_or] = ACTIONS(877),
    [anon_sym_xor] = ACTIONS(877),
    [anon_sym_isnt] = ACTIONS(877),
    [anon_sym_EQ_EQ] = ACTIONS(879),
    [anon_sym_BANG_EQ] = ACTIONS(879),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_GT_EQ] = ACTIONS(879),
    [anon_sym_LT_EQ] = ACTIONS(879),
    [anon_sym_LT] = ACTIONS(879),
    [anon_sym_PLUS_TILDE] = ACTIONS(877),
    [anon_sym_STAR_TILDE] = ACTIONS(877),
    [anon_sym_SLASH_TILDE] = ACTIONS(877),
    [anon_sym_PERCENT_TILDE] = ACTIONS(877),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(877),
    [anon_sym_LT_LT_TILDE] = ACTIONS(877),
    [anon_sym_GT_GT_TILDE] = ACTIONS(877),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(877),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(877),
    [anon_sym_GT_TILDE] = ACTIONS(877),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(877),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(877),
    [anon_sym_LT_TILDE] = ACTIONS(877),
    [anon_sym_PLUS_QMARK] = ACTIONS(877),
    [anon_sym_DASH_QMARK] = ACTIONS(877),
    [anon_sym_STAR_QMARK] = ACTIONS(877),
    [anon_sym_SLASH_QMARK] = ACTIONS(877),
    [anon_sym_PERCENT_QMARK] = ACTIONS(877),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(877),
    [anon_sym_as] = ACTIONS(877),
    [anon_sym_LPAREN2] = ACTIONS(877),
    [anon_sym_DOT_GT] = ACTIONS(877),
    [anon_sym_where] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(877),
    [anon_sym_end] = ACTIONS(877),
    [anon_sym_if] = ACTIONS(879),
    [anon_sym_ifdef] = ACTIONS(877),
    [anon_sym_iftype] = ACTIONS(877),
    [anon_sym_else] = ACTIONS(877),
    [anon_sym_for] = ACTIONS(877),
    [anon_sym_while] = ACTIONS(877),
    [anon_sym_try] = ACTIONS(877),
    [anon_sym_with] = ACTIONS(877),
    [anon_sym_repeat] = ACTIONS(877),
    [anon_sym_do] = ACTIONS(877),
    [anon_sym_recover] = ACTIONS(877),
    [anon_sym_match] = ACTIONS(877),
    [anon_sym_return] = ACTIONS(877),
    [anon_sym_continue] = ACTIONS(877),
    [anon_sym_break] = ACTIONS(877),
    [anon_sym_consume] = ACTIONS(877),
    [anon_sym_object] = ACTIONS(877),
    [sym_number] = ACTIONS(879),
    [sym_float] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(877),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(877),
    [sym_this] = ACTIONS(877),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [144] = {
    [aux_sym_union_type_repeat1] = STATE(145),
    [aux_sym_intersection_type_repeat1] = STATE(147),
    [ts_builtin_sym_end] = ACTIONS(881),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_use] = ACTIONS(881),
    [anon_sym_EQ] = ACTIONS(883),
    [anon_sym_AT] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_is] = ACTIONS(883),
    [anon_sym_actor] = ACTIONS(881),
    [anon_sym_class] = ACTIONS(881),
    [anon_sym_primitive] = ACTIONS(881),
    [anon_sym_interface] = ACTIONS(881),
    [anon_sym_trait] = ACTIONS(881),
    [anon_sym_struct] = ACTIONS(881),
    [anon_sym_embed] = ACTIONS(881),
    [anon_sym_let] = ACTIONS(881),
    [anon_sym_var] = ACTIONS(881),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_fun] = ACTIONS(881),
    [anon_sym_be] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_LPAREN] = ACTIONS(883),
    [anon_sym_RPAREN] = ACTIONS(881),
    [anon_sym_DOT] = ACTIONS(883),
    [anon_sym_BANG] = ACTIONS(821),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_AMP] = ACTIONS(827),
    [anon_sym_DASH_GT] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(881),
    [sym_error] = ACTIONS(881),
    [sym_compile_intrinsic] = ACTIONS(881),
    [anon_sym_compile_error] = ACTIONS(881),
    [sym_location] = ACTIONS(881),
    [anon_sym_DASH] = ACTIONS(883),
    [anon_sym_not] = ACTIONS(881),
    [anon_sym_DASH_TILDE] = ACTIONS(881),
    [anon_sym_addressof] = ACTIONS(881),
    [anon_sym_digestof] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(883),
    [anon_sym_STAR] = ACTIONS(883),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_PERCENT] = ACTIONS(883),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(881),
    [anon_sym_or] = ACTIONS(881),
    [anon_sym_xor] = ACTIONS(881),
    [anon_sym_isnt] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_PLUS_TILDE] = ACTIONS(881),
    [anon_sym_STAR_TILDE] = ACTIONS(881),
    [anon_sym_SLASH_TILDE] = ACTIONS(881),
    [anon_sym_PERCENT_TILDE] = ACTIONS(881),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(881),
    [anon_sym_LT_LT_TILDE] = ACTIONS(881),
    [anon_sym_GT_GT_TILDE] = ACTIONS(881),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(881),
    [anon_sym_GT_TILDE] = ACTIONS(881),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(881),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(881),
    [anon_sym_LT_TILDE] = ACTIONS(881),
    [anon_sym_PLUS_QMARK] = ACTIONS(881),
    [anon_sym_DASH_QMARK] = ACTIONS(881),
    [anon_sym_STAR_QMARK] = ACTIONS(881),
    [anon_sym_SLASH_QMARK] = ACTIONS(881),
    [anon_sym_PERCENT_QMARK] = ACTIONS(881),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(881),
    [anon_sym_as] = ACTIONS(881),
    [anon_sym_LPAREN2] = ACTIONS(881),
    [anon_sym_DOT_GT] = ACTIONS(881),
    [anon_sym_where] = ACTIONS(881),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_end] = ACTIONS(881),
    [anon_sym_if] = ACTIONS(883),
    [anon_sym_ifdef] = ACTIONS(881),
    [anon_sym_iftype] = ACTIONS(881),
    [anon_sym_else] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(881),
    [anon_sym_while] = ACTIONS(881),
    [anon_sym_try] = ACTIONS(881),
    [anon_sym_with] = ACTIONS(881),
    [anon_sym_repeat] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(881),
    [anon_sym_recover] = ACTIONS(881),
    [anon_sym_match] = ACTIONS(881),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_continue] = ACTIONS(881),
    [anon_sym_break] = ACTIONS(881),
    [anon_sym_consume] = ACTIONS(881),
    [anon_sym_object] = ACTIONS(881),
    [sym_number] = ACTIONS(883),
    [sym_float] = ACTIONS(881),
    [anon_sym_DQUOTE] = ACTIONS(883),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(881),
    [anon_sym_SQUOTE] = ACTIONS(881),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [sym_this] = ACTIONS(881),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [145] = {
    [aux_sym_union_type_repeat1] = STATE(148),
    [ts_builtin_sym_end] = ACTIONS(885),
    [sym_identifier] = ACTIONS(887),
    [anon_sym_use] = ACTIONS(885),
    [anon_sym_EQ] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(885),
    [anon_sym_LBRACK] = ACTIONS(885),
    [anon_sym_type] = ACTIONS(885),
    [anon_sym_is] = ACTIONS(887),
    [anon_sym_actor] = ACTIONS(885),
    [anon_sym_class] = ACTIONS(885),
    [anon_sym_primitive] = ACTIONS(885),
    [anon_sym_interface] = ACTIONS(885),
    [anon_sym_trait] = ACTIONS(885),
    [anon_sym_struct] = ACTIONS(885),
    [anon_sym_embed] = ACTIONS(885),
    [anon_sym_let] = ACTIONS(885),
    [anon_sym_var] = ACTIONS(885),
    [anon_sym_new] = ACTIONS(885),
    [anon_sym_fun] = ACTIONS(885),
    [anon_sym_be] = ACTIONS(885),
    [anon_sym_COMMA] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(887),
    [anon_sym_RPAREN] = ACTIONS(885),
    [anon_sym_DOT] = ACTIONS(887),
    [anon_sym_BANG] = ACTIONS(887),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(885),
    [sym_error] = ACTIONS(885),
    [sym_compile_intrinsic] = ACTIONS(885),
    [anon_sym_compile_error] = ACTIONS(885),
    [sym_location] = ACTIONS(885),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_not] = ACTIONS(885),
    [anon_sym_DASH_TILDE] = ACTIONS(885),
    [anon_sym_addressof] = ACTIONS(885),
    [anon_sym_digestof] = ACTIONS(885),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(887),
    [anon_sym_SLASH] = ACTIONS(887),
    [anon_sym_PERCENT] = ACTIONS(887),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(887),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_and] = ACTIONS(885),
    [anon_sym_or] = ACTIONS(885),
    [anon_sym_xor] = ACTIONS(885),
    [anon_sym_isnt] = ACTIONS(885),
    [anon_sym_EQ_EQ] = ACTIONS(887),
    [anon_sym_BANG_EQ] = ACTIONS(887),
    [anon_sym_GT] = ACTIONS(887),
    [anon_sym_GT_EQ] = ACTIONS(887),
    [anon_sym_LT_EQ] = ACTIONS(887),
    [anon_sym_LT] = ACTIONS(887),
    [anon_sym_PLUS_TILDE] = ACTIONS(885),
    [anon_sym_STAR_TILDE] = ACTIONS(885),
    [anon_sym_SLASH_TILDE] = ACTIONS(885),
    [anon_sym_PERCENT_TILDE] = ACTIONS(885),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(885),
    [anon_sym_LT_LT_TILDE] = ACTIONS(885),
    [anon_sym_GT_GT_TILDE] = ACTIONS(885),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(885),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(885),
    [anon_sym_GT_TILDE] = ACTIONS(885),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(885),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(885),
    [anon_sym_LT_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_QMARK] = ACTIONS(885),
    [anon_sym_DASH_QMARK] = ACTIONS(885),
    [anon_sym_STAR_QMARK] = ACTIONS(885),
    [anon_sym_SLASH_QMARK] = ACTIONS(885),
    [anon_sym_PERCENT_QMARK] = ACTIONS(885),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(885),
    [anon_sym_as] = ACTIONS(885),
    [anon_sym_LPAREN2] = ACTIONS(885),
    [anon_sym_DOT_GT] = ACTIONS(885),
    [anon_sym_where] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_end] = ACTIONS(885),
    [anon_sym_if] = ACTIONS(887),
    [anon_sym_ifdef] = ACTIONS(885),
    [anon_sym_iftype] = ACTIONS(885),
    [anon_sym_else] = ACTIONS(885),
    [anon_sym_for] = ACTIONS(885),
    [anon_sym_while] = ACTIONS(885),
    [anon_sym_try] = ACTIONS(885),
    [anon_sym_with] = ACTIONS(885),
    [anon_sym_repeat] = ACTIONS(885),
    [anon_sym_do] = ACTIONS(885),
    [anon_sym_recover] = ACTIONS(885),
    [anon_sym_match] = ACTIONS(885),
    [anon_sym_return] = ACTIONS(885),
    [anon_sym_continue] = ACTIONS(885),
    [anon_sym_break] = ACTIONS(885),
    [anon_sym_consume] = ACTIONS(885),
    [anon_sym_object] = ACTIONS(885),
    [sym_number] = ACTIONS(887),
    [sym_float] = ACTIONS(885),
    [anon_sym_DQUOTE] = ACTIONS(887),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(885),
    [anon_sym_SQUOTE] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(885),
    [anon_sym_false] = ACTIONS(885),
    [sym_this] = ACTIONS(885),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [146] = {
    [aux_sym_intersection_type_repeat1] = STATE(146),
    [ts_builtin_sym_end] = ACTIONS(881),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_use] = ACTIONS(881),
    [anon_sym_EQ] = ACTIONS(883),
    [anon_sym_AT] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_is] = ACTIONS(883),
    [anon_sym_actor] = ACTIONS(881),
    [anon_sym_class] = ACTIONS(881),
    [anon_sym_primitive] = ACTIONS(881),
    [anon_sym_interface] = ACTIONS(881),
    [anon_sym_trait] = ACTIONS(881),
    [anon_sym_struct] = ACTIONS(881),
    [anon_sym_embed] = ACTIONS(881),
    [anon_sym_let] = ACTIONS(881),
    [anon_sym_var] = ACTIONS(881),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_fun] = ACTIONS(881),
    [anon_sym_be] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_LPAREN] = ACTIONS(883),
    [anon_sym_RPAREN] = ACTIONS(881),
    [anon_sym_DOT] = ACTIONS(883),
    [anon_sym_BANG] = ACTIONS(883),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(881),
    [anon_sym_AMP] = ACTIONS(889),
    [anon_sym_DASH_GT] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(881),
    [sym_error] = ACTIONS(881),
    [sym_compile_intrinsic] = ACTIONS(881),
    [anon_sym_compile_error] = ACTIONS(881),
    [sym_location] = ACTIONS(881),
    [anon_sym_DASH] = ACTIONS(883),
    [anon_sym_not] = ACTIONS(881),
    [anon_sym_DASH_TILDE] = ACTIONS(881),
    [anon_sym_addressof] = ACTIONS(881),
    [anon_sym_digestof] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(883),
    [anon_sym_STAR] = ACTIONS(883),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_PERCENT] = ACTIONS(883),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(881),
    [anon_sym_or] = ACTIONS(881),
    [anon_sym_xor] = ACTIONS(881),
    [anon_sym_isnt] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_PLUS_TILDE] = ACTIONS(881),
    [anon_sym_STAR_TILDE] = ACTIONS(881),
    [anon_sym_SLASH_TILDE] = ACTIONS(881),
    [anon_sym_PERCENT_TILDE] = ACTIONS(881),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(881),
    [anon_sym_LT_LT_TILDE] = ACTIONS(881),
    [anon_sym_GT_GT_TILDE] = ACTIONS(881),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(881),
    [anon_sym_GT_TILDE] = ACTIONS(881),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(881),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(881),
    [anon_sym_LT_TILDE] = ACTIONS(881),
    [anon_sym_PLUS_QMARK] = ACTIONS(881),
    [anon_sym_DASH_QMARK] = ACTIONS(881),
    [anon_sym_STAR_QMARK] = ACTIONS(881),
    [anon_sym_SLASH_QMARK] = ACTIONS(881),
    [anon_sym_PERCENT_QMARK] = ACTIONS(881),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(881),
    [anon_sym_as] = ACTIONS(881),
    [anon_sym_LPAREN2] = ACTIONS(881),
    [anon_sym_DOT_GT] = ACTIONS(881),
    [anon_sym_where] = ACTIONS(881),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_end] = ACTIONS(881),
    [anon_sym_if] = ACTIONS(883),
    [anon_sym_ifdef] = ACTIONS(881),
    [anon_sym_iftype] = ACTIONS(881),
    [anon_sym_else] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(881),
    [anon_sym_while] = ACTIONS(881),
    [anon_sym_try] = ACTIONS(881),
    [anon_sym_with] = ACTIONS(881),
    [anon_sym_repeat] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(881),
    [anon_sym_recover] = ACTIONS(881),
    [anon_sym_match] = ACTIONS(881),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_continue] = ACTIONS(881),
    [anon_sym_break] = ACTIONS(881),
    [anon_sym_consume] = ACTIONS(881),
    [anon_sym_object] = ACTIONS(881),
    [sym_number] = ACTIONS(883),
    [sym_float] = ACTIONS(881),
    [anon_sym_DQUOTE] = ACTIONS(883),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(881),
    [anon_sym_SQUOTE] = ACTIONS(881),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [sym_this] = ACTIONS(881),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [147] = {
    [aux_sym_intersection_type_repeat1] = STATE(146),
    [ts_builtin_sym_end] = ACTIONS(892),
    [sym_identifier] = ACTIONS(894),
    [anon_sym_use] = ACTIONS(892),
    [anon_sym_EQ] = ACTIONS(894),
    [anon_sym_AT] = ACTIONS(892),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_is] = ACTIONS(894),
    [anon_sym_actor] = ACTIONS(892),
    [anon_sym_class] = ACTIONS(892),
    [anon_sym_primitive] = ACTIONS(892),
    [anon_sym_interface] = ACTIONS(892),
    [anon_sym_trait] = ACTIONS(892),
    [anon_sym_struct] = ACTIONS(892),
    [anon_sym_embed] = ACTIONS(892),
    [anon_sym_let] = ACTIONS(892),
    [anon_sym_var] = ACTIONS(892),
    [anon_sym_new] = ACTIONS(892),
    [anon_sym_fun] = ACTIONS(892),
    [anon_sym_be] = ACTIONS(892),
    [anon_sym_COMMA] = ACTIONS(892),
    [anon_sym_LPAREN] = ACTIONS(894),
    [anon_sym_RPAREN] = ACTIONS(892),
    [anon_sym_DOT] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(894),
    [anon_sym_CARET] = ACTIONS(892),
    [anon_sym_PIPE] = ACTIONS(892),
    [anon_sym_AMP] = ACTIONS(827),
    [anon_sym_DASH_GT] = ACTIONS(892),
    [anon_sym_LBRACE] = ACTIONS(892),
    [anon_sym_SEMI] = ACTIONS(892),
    [sym_error] = ACTIONS(892),
    [sym_compile_intrinsic] = ACTIONS(892),
    [anon_sym_compile_error] = ACTIONS(892),
    [sym_location] = ACTIONS(892),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_not] = ACTIONS(892),
    [anon_sym_DASH_TILDE] = ACTIONS(892),
    [anon_sym_addressof] = ACTIONS(892),
    [anon_sym_digestof] = ACTIONS(892),
    [anon_sym_PLUS] = ACTIONS(894),
    [anon_sym_STAR] = ACTIONS(894),
    [anon_sym_SLASH] = ACTIONS(894),
    [anon_sym_PERCENT] = ACTIONS(894),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(894),
    [anon_sym_LT_LT] = ACTIONS(894),
    [anon_sym_GT_GT] = ACTIONS(894),
    [anon_sym_and] = ACTIONS(892),
    [anon_sym_or] = ACTIONS(892),
    [anon_sym_xor] = ACTIONS(892),
    [anon_sym_isnt] = ACTIONS(892),
    [anon_sym_EQ_EQ] = ACTIONS(894),
    [anon_sym_BANG_EQ] = ACTIONS(894),
    [anon_sym_GT] = ACTIONS(894),
    [anon_sym_GT_EQ] = ACTIONS(894),
    [anon_sym_LT_EQ] = ACTIONS(894),
    [anon_sym_LT] = ACTIONS(894),
    [anon_sym_PLUS_TILDE] = ACTIONS(892),
    [anon_sym_STAR_TILDE] = ACTIONS(892),
    [anon_sym_SLASH_TILDE] = ACTIONS(892),
    [anon_sym_PERCENT_TILDE] = ACTIONS(892),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(892),
    [anon_sym_LT_LT_TILDE] = ACTIONS(892),
    [anon_sym_GT_GT_TILDE] = ACTIONS(892),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(892),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(892),
    [anon_sym_GT_TILDE] = ACTIONS(892),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(892),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(892),
    [anon_sym_LT_TILDE] = ACTIONS(892),
    [anon_sym_PLUS_QMARK] = ACTIONS(892),
    [anon_sym_DASH_QMARK] = ACTIONS(892),
    [anon_sym_STAR_QMARK] = ACTIONS(892),
    [anon_sym_SLASH_QMARK] = ACTIONS(892),
    [anon_sym_PERCENT_QMARK] = ACTIONS(892),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(892),
    [anon_sym_as] = ACTIONS(892),
    [anon_sym_LPAREN2] = ACTIONS(892),
    [anon_sym_DOT_GT] = ACTIONS(892),
    [anon_sym_where] = ACTIONS(892),
    [anon_sym_TILDE] = ACTIONS(892),
    [anon_sym_end] = ACTIONS(892),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_ifdef] = ACTIONS(892),
    [anon_sym_iftype] = ACTIONS(892),
    [anon_sym_else] = ACTIONS(892),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(892),
    [anon_sym_try] = ACTIONS(892),
    [anon_sym_with] = ACTIONS(892),
    [anon_sym_repeat] = ACTIONS(892),
    [anon_sym_do] = ACTIONS(892),
    [anon_sym_recover] = ACTIONS(892),
    [anon_sym_match] = ACTIONS(892),
    [anon_sym_return] = ACTIONS(892),
    [anon_sym_continue] = ACTIONS(892),
    [anon_sym_break] = ACTIONS(892),
    [anon_sym_consume] = ACTIONS(892),
    [anon_sym_object] = ACTIONS(892),
    [sym_number] = ACTIONS(894),
    [sym_float] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(894),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(892),
    [anon_sym_SQUOTE] = ACTIONS(892),
    [anon_sym_true] = ACTIONS(892),
    [anon_sym_false] = ACTIONS(892),
    [sym_this] = ACTIONS(892),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [148] = {
    [aux_sym_union_type_repeat1] = STATE(148),
    [ts_builtin_sym_end] = ACTIONS(869),
    [sym_identifier] = ACTIONS(871),
    [anon_sym_use] = ACTIONS(869),
    [anon_sym_EQ] = ACTIONS(871),
    [anon_sym_AT] = ACTIONS(869),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_type] = ACTIONS(869),
    [anon_sym_is] = ACTIONS(871),
    [anon_sym_actor] = ACTIONS(869),
    [anon_sym_class] = ACTIONS(869),
    [anon_sym_primitive] = ACTIONS(869),
    [anon_sym_interface] = ACTIONS(869),
    [anon_sym_trait] = ACTIONS(869),
    [anon_sym_struct] = ACTIONS(869),
    [anon_sym_embed] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_var] = ACTIONS(869),
    [anon_sym_new] = ACTIONS(869),
    [anon_sym_fun] = ACTIONS(869),
    [anon_sym_be] = ACTIONS(869),
    [anon_sym_COMMA] = ACTIONS(869),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(869),
    [anon_sym_DOT] = ACTIONS(871),
    [anon_sym_BANG] = ACTIONS(871),
    [anon_sym_CARET] = ACTIONS(869),
    [anon_sym_PIPE] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(869),
    [anon_sym_DASH_GT] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(869),
    [anon_sym_SEMI] = ACTIONS(869),
    [sym_error] = ACTIONS(869),
    [sym_compile_intrinsic] = ACTIONS(869),
    [anon_sym_compile_error] = ACTIONS(869),
    [sym_location] = ACTIONS(869),
    [anon_sym_DASH] = ACTIONS(871),
    [anon_sym_not] = ACTIONS(869),
    [anon_sym_DASH_TILDE] = ACTIONS(869),
    [anon_sym_addressof] = ACTIONS(869),
    [anon_sym_digestof] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(871),
    [anon_sym_STAR] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(871),
    [anon_sym_PERCENT] = ACTIONS(871),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(871),
    [anon_sym_LT_LT] = ACTIONS(871),
    [anon_sym_GT_GT] = ACTIONS(871),
    [anon_sym_and] = ACTIONS(869),
    [anon_sym_or] = ACTIONS(869),
    [anon_sym_xor] = ACTIONS(869),
    [anon_sym_isnt] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(871),
    [anon_sym_BANG_EQ] = ACTIONS(871),
    [anon_sym_GT] = ACTIONS(871),
    [anon_sym_GT_EQ] = ACTIONS(871),
    [anon_sym_LT_EQ] = ACTIONS(871),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_PLUS_TILDE] = ACTIONS(869),
    [anon_sym_STAR_TILDE] = ACTIONS(869),
    [anon_sym_SLASH_TILDE] = ACTIONS(869),
    [anon_sym_PERCENT_TILDE] = ACTIONS(869),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(869),
    [anon_sym_LT_LT_TILDE] = ACTIONS(869),
    [anon_sym_GT_GT_TILDE] = ACTIONS(869),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(869),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(869),
    [anon_sym_GT_TILDE] = ACTIONS(869),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(869),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(869),
    [anon_sym_LT_TILDE] = ACTIONS(869),
    [anon_sym_PLUS_QMARK] = ACTIONS(869),
    [anon_sym_DASH_QMARK] = ACTIONS(869),
    [anon_sym_STAR_QMARK] = ACTIONS(869),
    [anon_sym_SLASH_QMARK] = ACTIONS(869),
    [anon_sym_PERCENT_QMARK] = ACTIONS(869),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(869),
    [anon_sym_as] = ACTIONS(869),
    [anon_sym_LPAREN2] = ACTIONS(869),
    [anon_sym_DOT_GT] = ACTIONS(869),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [anon_sym_end] = ACTIONS(869),
    [anon_sym_if] = ACTIONS(871),
    [anon_sym_ifdef] = ACTIONS(869),
    [anon_sym_iftype] = ACTIONS(869),
    [anon_sym_else] = ACTIONS(869),
    [anon_sym_for] = ACTIONS(869),
    [anon_sym_while] = ACTIONS(869),
    [anon_sym_try] = ACTIONS(869),
    [anon_sym_with] = ACTIONS(869),
    [anon_sym_repeat] = ACTIONS(869),
    [anon_sym_do] = ACTIONS(869),
    [anon_sym_recover] = ACTIONS(869),
    [anon_sym_match] = ACTIONS(869),
    [anon_sym_return] = ACTIONS(869),
    [anon_sym_continue] = ACTIONS(869),
    [anon_sym_break] = ACTIONS(869),
    [anon_sym_consume] = ACTIONS(869),
    [anon_sym_object] = ACTIONS(869),
    [sym_number] = ACTIONS(871),
    [sym_float] = ACTIONS(869),
    [anon_sym_DQUOTE] = ACTIONS(871),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(869),
    [anon_sym_SQUOTE] = ACTIONS(869),
    [anon_sym_true] = ACTIONS(869),
    [anon_sym_false] = ACTIONS(869),
    [sym_this] = ACTIONS(869),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [149] = {
    [ts_builtin_sym_end] = ACTIONS(899),
    [sym_identifier] = ACTIONS(901),
    [anon_sym_use] = ACTIONS(899),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_AT] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(899),
    [anon_sym_type] = ACTIONS(899),
    [anon_sym_is] = ACTIONS(901),
    [anon_sym_actor] = ACTIONS(899),
    [anon_sym_class] = ACTIONS(899),
    [anon_sym_primitive] = ACTIONS(899),
    [anon_sym_interface] = ACTIONS(899),
    [anon_sym_trait] = ACTIONS(899),
    [anon_sym_struct] = ACTIONS(899),
    [anon_sym_embed] = ACTIONS(899),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_var] = ACTIONS(899),
    [anon_sym_new] = ACTIONS(899),
    [anon_sym_fun] = ACTIONS(899),
    [anon_sym_be] = ACTIONS(899),
    [anon_sym_COMMA] = ACTIONS(899),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_RPAREN] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_CARET] = ACTIONS(899),
    [anon_sym_PIPE] = ACTIONS(899),
    [anon_sym_AMP] = ACTIONS(899),
    [anon_sym_DASH_GT] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(899),
    [anon_sym_SEMI] = ACTIONS(899),
    [sym_error] = ACTIONS(899),
    [sym_compile_intrinsic] = ACTIONS(899),
    [anon_sym_compile_error] = ACTIONS(899),
    [sym_location] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_not] = ACTIONS(899),
    [anon_sym_DASH_TILDE] = ACTIONS(899),
    [anon_sym_addressof] = ACTIONS(899),
    [anon_sym_digestof] = ACTIONS(899),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_STAR] = ACTIONS(901),
    [anon_sym_SLASH] = ACTIONS(901),
    [anon_sym_PERCENT] = ACTIONS(901),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(901),
    [anon_sym_LT_LT] = ACTIONS(901),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_and] = ACTIONS(899),
    [anon_sym_or] = ACTIONS(899),
    [anon_sym_xor] = ACTIONS(899),
    [anon_sym_isnt] = ACTIONS(899),
    [anon_sym_EQ_EQ] = ACTIONS(901),
    [anon_sym_BANG_EQ] = ACTIONS(901),
    [anon_sym_GT] = ACTIONS(901),
    [anon_sym_GT_EQ] = ACTIONS(901),
    [anon_sym_LT_EQ] = ACTIONS(901),
    [anon_sym_LT] = ACTIONS(901),
    [anon_sym_PLUS_TILDE] = ACTIONS(899),
    [anon_sym_STAR_TILDE] = ACTIONS(899),
    [anon_sym_SLASH_TILDE] = ACTIONS(899),
    [anon_sym_PERCENT_TILDE] = ACTIONS(899),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(899),
    [anon_sym_LT_LT_TILDE] = ACTIONS(899),
    [anon_sym_GT_GT_TILDE] = ACTIONS(899),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(899),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(899),
    [anon_sym_GT_TILDE] = ACTIONS(899),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(899),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(899),
    [anon_sym_LT_TILDE] = ACTIONS(899),
    [anon_sym_PLUS_QMARK] = ACTIONS(899),
    [anon_sym_DASH_QMARK] = ACTIONS(899),
    [anon_sym_STAR_QMARK] = ACTIONS(899),
    [anon_sym_SLASH_QMARK] = ACTIONS(899),
    [anon_sym_PERCENT_QMARK] = ACTIONS(899),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(899),
    [anon_sym_as] = ACTIONS(899),
    [anon_sym_LPAREN2] = ACTIONS(899),
    [anon_sym_DOT_GT] = ACTIONS(899),
    [anon_sym_where] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(899),
    [anon_sym_end] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(901),
    [anon_sym_ifdef] = ACTIONS(899),
    [anon_sym_iftype] = ACTIONS(899),
    [anon_sym_else] = ACTIONS(899),
    [anon_sym_for] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(899),
    [anon_sym_try] = ACTIONS(899),
    [anon_sym_with] = ACTIONS(899),
    [anon_sym_repeat] = ACTIONS(899),
    [anon_sym_do] = ACTIONS(899),
    [anon_sym_recover] = ACTIONS(899),
    [anon_sym_match] = ACTIONS(899),
    [anon_sym_return] = ACTIONS(899),
    [anon_sym_continue] = ACTIONS(899),
    [anon_sym_break] = ACTIONS(899),
    [anon_sym_consume] = ACTIONS(899),
    [anon_sym_object] = ACTIONS(899),
    [sym_number] = ACTIONS(901),
    [sym_float] = ACTIONS(899),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(899),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [anon_sym_true] = ACTIONS(899),
    [anon_sym_false] = ACTIONS(899),
    [sym_this] = ACTIONS(899),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [150] = {
    [ts_builtin_sym_end] = ACTIONS(678),
    [sym_identifier] = ACTIONS(680),
    [anon_sym_use] = ACTIONS(678),
    [anon_sym_EQ] = ACTIONS(680),
    [anon_sym_AT] = ACTIONS(678),
    [anon_sym_LBRACK] = ACTIONS(678),
    [anon_sym_type] = ACTIONS(678),
    [anon_sym_is] = ACTIONS(680),
    [anon_sym_actor] = ACTIONS(678),
    [anon_sym_class] = ACTIONS(678),
    [anon_sym_primitive] = ACTIONS(678),
    [anon_sym_interface] = ACTIONS(678),
    [anon_sym_trait] = ACTIONS(678),
    [anon_sym_struct] = ACTIONS(678),
    [anon_sym_embed] = ACTIONS(678),
    [anon_sym_let] = ACTIONS(678),
    [anon_sym_var] = ACTIONS(678),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_fun] = ACTIONS(678),
    [anon_sym_be] = ACTIONS(678),
    [anon_sym_COMMA] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_RPAREN] = ACTIONS(678),
    [anon_sym_DOT] = ACTIONS(680),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_CARET] = ACTIONS(678),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_AMP] = ACTIONS(678),
    [anon_sym_DASH_GT] = ACTIONS(678),
    [anon_sym_LBRACE] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(678),
    [sym_error] = ACTIONS(678),
    [sym_compile_intrinsic] = ACTIONS(678),
    [anon_sym_compile_error] = ACTIONS(678),
    [sym_location] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(680),
    [anon_sym_not] = ACTIONS(678),
    [anon_sym_DASH_TILDE] = ACTIONS(678),
    [anon_sym_addressof] = ACTIONS(678),
    [anon_sym_digestof] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(680),
    [anon_sym_STAR] = ACTIONS(680),
    [anon_sym_SLASH] = ACTIONS(680),
    [anon_sym_PERCENT] = ACTIONS(680),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(680),
    [anon_sym_LT_LT] = ACTIONS(680),
    [anon_sym_GT_GT] = ACTIONS(680),
    [anon_sym_and] = ACTIONS(678),
    [anon_sym_or] = ACTIONS(678),
    [anon_sym_xor] = ACTIONS(678),
    [anon_sym_isnt] = ACTIONS(678),
    [anon_sym_EQ_EQ] = ACTIONS(680),
    [anon_sym_BANG_EQ] = ACTIONS(680),
    [anon_sym_GT] = ACTIONS(680),
    [anon_sym_GT_EQ] = ACTIONS(680),
    [anon_sym_LT_EQ] = ACTIONS(680),
    [anon_sym_LT] = ACTIONS(680),
    [anon_sym_PLUS_TILDE] = ACTIONS(678),
    [anon_sym_STAR_TILDE] = ACTIONS(678),
    [anon_sym_SLASH_TILDE] = ACTIONS(678),
    [anon_sym_PERCENT_TILDE] = ACTIONS(678),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(678),
    [anon_sym_LT_LT_TILDE] = ACTIONS(678),
    [anon_sym_GT_GT_TILDE] = ACTIONS(678),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(678),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(678),
    [anon_sym_GT_TILDE] = ACTIONS(678),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(678),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(678),
    [anon_sym_LT_TILDE] = ACTIONS(678),
    [anon_sym_PLUS_QMARK] = ACTIONS(678),
    [anon_sym_DASH_QMARK] = ACTIONS(678),
    [anon_sym_STAR_QMARK] = ACTIONS(678),
    [anon_sym_SLASH_QMARK] = ACTIONS(678),
    [anon_sym_PERCENT_QMARK] = ACTIONS(678),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(678),
    [anon_sym_as] = ACTIONS(678),
    [anon_sym_LPAREN2] = ACTIONS(678),
    [anon_sym_DOT_GT] = ACTIONS(678),
    [anon_sym_where] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(678),
    [anon_sym_end] = ACTIONS(678),
    [anon_sym_if] = ACTIONS(680),
    [anon_sym_ifdef] = ACTIONS(678),
    [anon_sym_iftype] = ACTIONS(678),
    [anon_sym_else] = ACTIONS(678),
    [anon_sym_for] = ACTIONS(678),
    [anon_sym_while] = ACTIONS(678),
    [anon_sym_try] = ACTIONS(678),
    [anon_sym_with] = ACTIONS(678),
    [anon_sym_repeat] = ACTIONS(678),
    [anon_sym_do] = ACTIONS(678),
    [anon_sym_recover] = ACTIONS(678),
    [anon_sym_match] = ACTIONS(678),
    [anon_sym_return] = ACTIONS(678),
    [anon_sym_continue] = ACTIONS(678),
    [anon_sym_break] = ACTIONS(678),
    [anon_sym_consume] = ACTIONS(678),
    [anon_sym_object] = ACTIONS(678),
    [sym_number] = ACTIONS(680),
    [sym_float] = ACTIONS(678),
    [anon_sym_DQUOTE] = ACTIONS(680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(678),
    [anon_sym_true] = ACTIONS(678),
    [anon_sym_false] = ACTIONS(678),
    [sym_this] = ACTIONS(678),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [151] = {
    [ts_builtin_sym_end] = ACTIONS(903),
    [sym_identifier] = ACTIONS(905),
    [anon_sym_use] = ACTIONS(903),
    [anon_sym_EQ] = ACTIONS(905),
    [anon_sym_AT] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(903),
    [anon_sym_type] = ACTIONS(903),
    [anon_sym_is] = ACTIONS(905),
    [anon_sym_actor] = ACTIONS(903),
    [anon_sym_class] = ACTIONS(903),
    [anon_sym_primitive] = ACTIONS(903),
    [anon_sym_interface] = ACTIONS(903),
    [anon_sym_trait] = ACTIONS(903),
    [anon_sym_struct] = ACTIONS(903),
    [anon_sym_embed] = ACTIONS(903),
    [anon_sym_let] = ACTIONS(903),
    [anon_sym_var] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(903),
    [anon_sym_fun] = ACTIONS(903),
    [anon_sym_be] = ACTIONS(903),
    [anon_sym_COMMA] = ACTIONS(903),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(903),
    [anon_sym_DOT] = ACTIONS(905),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_CARET] = ACTIONS(903),
    [anon_sym_PIPE] = ACTIONS(903),
    [anon_sym_AMP] = ACTIONS(903),
    [anon_sym_DASH_GT] = ACTIONS(903),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_SEMI] = ACTIONS(903),
    [sym_error] = ACTIONS(903),
    [sym_compile_intrinsic] = ACTIONS(903),
    [anon_sym_compile_error] = ACTIONS(903),
    [sym_location] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_not] = ACTIONS(903),
    [anon_sym_DASH_TILDE] = ACTIONS(903),
    [anon_sym_addressof] = ACTIONS(903),
    [anon_sym_digestof] = ACTIONS(903),
    [anon_sym_PLUS] = ACTIONS(905),
    [anon_sym_STAR] = ACTIONS(905),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_PERCENT] = ACTIONS(905),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(905),
    [anon_sym_LT_LT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(905),
    [anon_sym_and] = ACTIONS(903),
    [anon_sym_or] = ACTIONS(903),
    [anon_sym_xor] = ACTIONS(903),
    [anon_sym_isnt] = ACTIONS(903),
    [anon_sym_EQ_EQ] = ACTIONS(905),
    [anon_sym_BANG_EQ] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_EQ] = ACTIONS(905),
    [anon_sym_LT_EQ] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_PLUS_TILDE] = ACTIONS(903),
    [anon_sym_STAR_TILDE] = ACTIONS(903),
    [anon_sym_SLASH_TILDE] = ACTIONS(903),
    [anon_sym_PERCENT_TILDE] = ACTIONS(903),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(903),
    [anon_sym_LT_LT_TILDE] = ACTIONS(903),
    [anon_sym_GT_GT_TILDE] = ACTIONS(903),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(903),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(903),
    [anon_sym_GT_TILDE] = ACTIONS(903),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(903),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(903),
    [anon_sym_LT_TILDE] = ACTIONS(903),
    [anon_sym_PLUS_QMARK] = ACTIONS(903),
    [anon_sym_DASH_QMARK] = ACTIONS(903),
    [anon_sym_STAR_QMARK] = ACTIONS(903),
    [anon_sym_SLASH_QMARK] = ACTIONS(903),
    [anon_sym_PERCENT_QMARK] = ACTIONS(903),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(903),
    [anon_sym_as] = ACTIONS(903),
    [anon_sym_LPAREN2] = ACTIONS(903),
    [anon_sym_DOT_GT] = ACTIONS(903),
    [anon_sym_where] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(903),
    [anon_sym_end] = ACTIONS(903),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_ifdef] = ACTIONS(903),
    [anon_sym_iftype] = ACTIONS(903),
    [anon_sym_else] = ACTIONS(903),
    [anon_sym_for] = ACTIONS(903),
    [anon_sym_while] = ACTIONS(903),
    [anon_sym_try] = ACTIONS(903),
    [anon_sym_with] = ACTIONS(903),
    [anon_sym_repeat] = ACTIONS(903),
    [anon_sym_do] = ACTIONS(903),
    [anon_sym_recover] = ACTIONS(903),
    [anon_sym_match] = ACTIONS(903),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_continue] = ACTIONS(903),
    [anon_sym_break] = ACTIONS(903),
    [anon_sym_consume] = ACTIONS(903),
    [anon_sym_object] = ACTIONS(903),
    [sym_number] = ACTIONS(905),
    [sym_float] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(903),
    [anon_sym_SQUOTE] = ACTIONS(903),
    [anon_sym_true] = ACTIONS(903),
    [anon_sym_false] = ACTIONS(903),
    [sym_this] = ACTIONS(903),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [152] = {
    [ts_builtin_sym_end] = ACTIONS(907),
    [sym_identifier] = ACTIONS(909),
    [anon_sym_use] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(909),
    [anon_sym_AT] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(907),
    [anon_sym_type] = ACTIONS(907),
    [anon_sym_is] = ACTIONS(909),
    [anon_sym_actor] = ACTIONS(907),
    [anon_sym_class] = ACTIONS(907),
    [anon_sym_primitive] = ACTIONS(907),
    [anon_sym_interface] = ACTIONS(907),
    [anon_sym_trait] = ACTIONS(907),
    [anon_sym_struct] = ACTIONS(907),
    [anon_sym_embed] = ACTIONS(907),
    [anon_sym_let] = ACTIONS(907),
    [anon_sym_var] = ACTIONS(907),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_fun] = ACTIONS(907),
    [anon_sym_be] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(907),
    [anon_sym_LPAREN] = ACTIONS(909),
    [anon_sym_RPAREN] = ACTIONS(907),
    [anon_sym_DOT] = ACTIONS(909),
    [anon_sym_BANG] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(907),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_DASH_GT] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(907),
    [sym_error] = ACTIONS(907),
    [sym_compile_intrinsic] = ACTIONS(907),
    [anon_sym_compile_error] = ACTIONS(907),
    [sym_location] = ACTIONS(907),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_not] = ACTIONS(907),
    [anon_sym_DASH_TILDE] = ACTIONS(907),
    [anon_sym_addressof] = ACTIONS(907),
    [anon_sym_digestof] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_STAR] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_and] = ACTIONS(907),
    [anon_sym_or] = ACTIONS(907),
    [anon_sym_xor] = ACTIONS(907),
    [anon_sym_isnt] = ACTIONS(907),
    [anon_sym_EQ_EQ] = ACTIONS(909),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_GT] = ACTIONS(909),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(909),
    [anon_sym_PLUS_TILDE] = ACTIONS(907),
    [anon_sym_STAR_TILDE] = ACTIONS(907),
    [anon_sym_SLASH_TILDE] = ACTIONS(907),
    [anon_sym_PERCENT_TILDE] = ACTIONS(907),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(907),
    [anon_sym_LT_LT_TILDE] = ACTIONS(907),
    [anon_sym_GT_GT_TILDE] = ACTIONS(907),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(907),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(907),
    [anon_sym_GT_TILDE] = ACTIONS(907),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(907),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(907),
    [anon_sym_LT_TILDE] = ACTIONS(907),
    [anon_sym_PLUS_QMARK] = ACTIONS(907),
    [anon_sym_DASH_QMARK] = ACTIONS(907),
    [anon_sym_STAR_QMARK] = ACTIONS(907),
    [anon_sym_SLASH_QMARK] = ACTIONS(907),
    [anon_sym_PERCENT_QMARK] = ACTIONS(907),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(907),
    [anon_sym_as] = ACTIONS(907),
    [anon_sym_LPAREN2] = ACTIONS(907),
    [anon_sym_DOT_GT] = ACTIONS(907),
    [anon_sym_where] = ACTIONS(907),
    [anon_sym_TILDE] = ACTIONS(907),
    [anon_sym_end] = ACTIONS(907),
    [anon_sym_if] = ACTIONS(909),
    [anon_sym_ifdef] = ACTIONS(907),
    [anon_sym_iftype] = ACTIONS(907),
    [anon_sym_else] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(907),
    [anon_sym_while] = ACTIONS(907),
    [anon_sym_try] = ACTIONS(907),
    [anon_sym_with] = ACTIONS(907),
    [anon_sym_repeat] = ACTIONS(907),
    [anon_sym_do] = ACTIONS(907),
    [anon_sym_recover] = ACTIONS(907),
    [anon_sym_match] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(907),
    [anon_sym_continue] = ACTIONS(907),
    [anon_sym_break] = ACTIONS(907),
    [anon_sym_consume] = ACTIONS(907),
    [anon_sym_object] = ACTIONS(907),
    [sym_number] = ACTIONS(909),
    [sym_float] = ACTIONS(907),
    [anon_sym_DQUOTE] = ACTIONS(909),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(907),
    [anon_sym_SQUOTE] = ACTIONS(907),
    [anon_sym_true] = ACTIONS(907),
    [anon_sym_false] = ACTIONS(907),
    [sym_this] = ACTIONS(907),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [153] = {
    [ts_builtin_sym_end] = ACTIONS(911),
    [sym_identifier] = ACTIONS(913),
    [anon_sym_use] = ACTIONS(911),
    [anon_sym_EQ] = ACTIONS(913),
    [anon_sym_AT] = ACTIONS(911),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_type] = ACTIONS(911),
    [anon_sym_is] = ACTIONS(913),
    [anon_sym_actor] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(911),
    [anon_sym_primitive] = ACTIONS(911),
    [anon_sym_interface] = ACTIONS(911),
    [anon_sym_trait] = ACTIONS(911),
    [anon_sym_struct] = ACTIONS(911),
    [anon_sym_embed] = ACTIONS(911),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_var] = ACTIONS(911),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_fun] = ACTIONS(911),
    [anon_sym_be] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(911),
    [anon_sym_LPAREN] = ACTIONS(913),
    [anon_sym_RPAREN] = ACTIONS(911),
    [anon_sym_DOT] = ACTIONS(913),
    [anon_sym_BANG] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_DASH_GT] = ACTIONS(911),
    [anon_sym_LBRACE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(911),
    [sym_error] = ACTIONS(911),
    [sym_compile_intrinsic] = ACTIONS(911),
    [anon_sym_compile_error] = ACTIONS(911),
    [sym_location] = ACTIONS(911),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_DASH_TILDE] = ACTIONS(911),
    [anon_sym_addressof] = ACTIONS(911),
    [anon_sym_digestof] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(913),
    [anon_sym_SLASH] = ACTIONS(913),
    [anon_sym_PERCENT] = ACTIONS(913),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(913),
    [anon_sym_LT_LT] = ACTIONS(913),
    [anon_sym_GT_GT] = ACTIONS(913),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_xor] = ACTIONS(911),
    [anon_sym_isnt] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(913),
    [anon_sym_BANG_EQ] = ACTIONS(913),
    [anon_sym_GT] = ACTIONS(913),
    [anon_sym_GT_EQ] = ACTIONS(913),
    [anon_sym_LT_EQ] = ACTIONS(913),
    [anon_sym_LT] = ACTIONS(913),
    [anon_sym_PLUS_TILDE] = ACTIONS(911),
    [anon_sym_STAR_TILDE] = ACTIONS(911),
    [anon_sym_SLASH_TILDE] = ACTIONS(911),
    [anon_sym_PERCENT_TILDE] = ACTIONS(911),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(911),
    [anon_sym_LT_LT_TILDE] = ACTIONS(911),
    [anon_sym_GT_GT_TILDE] = ACTIONS(911),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(911),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(911),
    [anon_sym_GT_TILDE] = ACTIONS(911),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(911),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(911),
    [anon_sym_LT_TILDE] = ACTIONS(911),
    [anon_sym_PLUS_QMARK] = ACTIONS(911),
    [anon_sym_DASH_QMARK] = ACTIONS(911),
    [anon_sym_STAR_QMARK] = ACTIONS(911),
    [anon_sym_SLASH_QMARK] = ACTIONS(911),
    [anon_sym_PERCENT_QMARK] = ACTIONS(911),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(911),
    [anon_sym_LPAREN2] = ACTIONS(911),
    [anon_sym_DOT_GT] = ACTIONS(911),
    [anon_sym_where] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(911),
    [anon_sym_end] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(913),
    [anon_sym_ifdef] = ACTIONS(911),
    [anon_sym_iftype] = ACTIONS(911),
    [anon_sym_else] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(911),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_try] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(911),
    [anon_sym_repeat] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_recover] = ACTIONS(911),
    [anon_sym_match] = ACTIONS(911),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_continue] = ACTIONS(911),
    [anon_sym_break] = ACTIONS(911),
    [anon_sym_consume] = ACTIONS(911),
    [anon_sym_object] = ACTIONS(911),
    [sym_number] = ACTIONS(913),
    [sym_float] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(911),
    [anon_sym_SQUOTE] = ACTIONS(911),
    [anon_sym_true] = ACTIONS(911),
    [anon_sym_false] = ACTIONS(911),
    [sym_this] = ACTIONS(911),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [154] = {
    [ts_builtin_sym_end] = ACTIONS(915),
    [sym_identifier] = ACTIONS(917),
    [anon_sym_use] = ACTIONS(915),
    [anon_sym_EQ] = ACTIONS(917),
    [anon_sym_AT] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(915),
    [anon_sym_type] = ACTIONS(915),
    [anon_sym_is] = ACTIONS(917),
    [anon_sym_actor] = ACTIONS(915),
    [anon_sym_class] = ACTIONS(915),
    [anon_sym_primitive] = ACTIONS(915),
    [anon_sym_interface] = ACTIONS(915),
    [anon_sym_trait] = ACTIONS(915),
    [anon_sym_struct] = ACTIONS(915),
    [anon_sym_embed] = ACTIONS(915),
    [anon_sym_let] = ACTIONS(915),
    [anon_sym_var] = ACTIONS(915),
    [anon_sym_new] = ACTIONS(915),
    [anon_sym_fun] = ACTIONS(915),
    [anon_sym_be] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(915),
    [anon_sym_DOT] = ACTIONS(917),
    [anon_sym_BANG] = ACTIONS(917),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_AMP] = ACTIONS(915),
    [anon_sym_DASH_GT] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_SEMI] = ACTIONS(915),
    [sym_error] = ACTIONS(915),
    [sym_compile_intrinsic] = ACTIONS(915),
    [anon_sym_compile_error] = ACTIONS(915),
    [sym_location] = ACTIONS(915),
    [anon_sym_DASH] = ACTIONS(917),
    [anon_sym_not] = ACTIONS(915),
    [anon_sym_DASH_TILDE] = ACTIONS(915),
    [anon_sym_addressof] = ACTIONS(915),
    [anon_sym_digestof] = ACTIONS(915),
    [anon_sym_PLUS] = ACTIONS(917),
    [anon_sym_STAR] = ACTIONS(917),
    [anon_sym_SLASH] = ACTIONS(917),
    [anon_sym_PERCENT] = ACTIONS(917),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(917),
    [anon_sym_LT_LT] = ACTIONS(917),
    [anon_sym_GT_GT] = ACTIONS(917),
    [anon_sym_and] = ACTIONS(915),
    [anon_sym_or] = ACTIONS(915),
    [anon_sym_xor] = ACTIONS(915),
    [anon_sym_isnt] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_GT] = ACTIONS(917),
    [anon_sym_GT_EQ] = ACTIONS(917),
    [anon_sym_LT_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(917),
    [anon_sym_PLUS_TILDE] = ACTIONS(915),
    [anon_sym_STAR_TILDE] = ACTIONS(915),
    [anon_sym_SLASH_TILDE] = ACTIONS(915),
    [anon_sym_PERCENT_TILDE] = ACTIONS(915),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(915),
    [anon_sym_LT_LT_TILDE] = ACTIONS(915),
    [anon_sym_GT_GT_TILDE] = ACTIONS(915),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(915),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(915),
    [anon_sym_GT_TILDE] = ACTIONS(915),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(915),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(915),
    [anon_sym_LT_TILDE] = ACTIONS(915),
    [anon_sym_PLUS_QMARK] = ACTIONS(915),
    [anon_sym_DASH_QMARK] = ACTIONS(915),
    [anon_sym_STAR_QMARK] = ACTIONS(915),
    [anon_sym_SLASH_QMARK] = ACTIONS(915),
    [anon_sym_PERCENT_QMARK] = ACTIONS(915),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(915),
    [anon_sym_as] = ACTIONS(915),
    [anon_sym_LPAREN2] = ACTIONS(915),
    [anon_sym_DOT_GT] = ACTIONS(915),
    [anon_sym_where] = ACTIONS(915),
    [anon_sym_TILDE] = ACTIONS(915),
    [anon_sym_end] = ACTIONS(915),
    [anon_sym_if] = ACTIONS(917),
    [anon_sym_ifdef] = ACTIONS(915),
    [anon_sym_iftype] = ACTIONS(915),
    [anon_sym_else] = ACTIONS(915),
    [anon_sym_for] = ACTIONS(915),
    [anon_sym_while] = ACTIONS(915),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_with] = ACTIONS(915),
    [anon_sym_repeat] = ACTIONS(915),
    [anon_sym_do] = ACTIONS(915),
    [anon_sym_recover] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(915),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_continue] = ACTIONS(915),
    [anon_sym_break] = ACTIONS(915),
    [anon_sym_consume] = ACTIONS(915),
    [anon_sym_object] = ACTIONS(915),
    [sym_number] = ACTIONS(917),
    [sym_float] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(917),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(915),
    [anon_sym_SQUOTE] = ACTIONS(915),
    [anon_sym_true] = ACTIONS(915),
    [anon_sym_false] = ACTIONS(915),
    [sym_this] = ACTIONS(915),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [155] = {
    [ts_builtin_sym_end] = ACTIONS(919),
    [sym_identifier] = ACTIONS(921),
    [anon_sym_use] = ACTIONS(919),
    [anon_sym_EQ] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_is] = ACTIONS(921),
    [anon_sym_actor] = ACTIONS(919),
    [anon_sym_class] = ACTIONS(919),
    [anon_sym_primitive] = ACTIONS(919),
    [anon_sym_interface] = ACTIONS(919),
    [anon_sym_trait] = ACTIONS(919),
    [anon_sym_struct] = ACTIONS(919),
    [anon_sym_embed] = ACTIONS(919),
    [anon_sym_let] = ACTIONS(919),
    [anon_sym_var] = ACTIONS(919),
    [anon_sym_new] = ACTIONS(919),
    [anon_sym_fun] = ACTIONS(919),
    [anon_sym_be] = ACTIONS(919),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(921),
    [anon_sym_RPAREN] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(919),
    [anon_sym_DASH_GT] = ACTIONS(919),
    [anon_sym_LBRACE] = ACTIONS(919),
    [anon_sym_SEMI] = ACTIONS(919),
    [sym_error] = ACTIONS(919),
    [sym_compile_intrinsic] = ACTIONS(919),
    [anon_sym_compile_error] = ACTIONS(919),
    [sym_location] = ACTIONS(919),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_DASH_TILDE] = ACTIONS(919),
    [anon_sym_addressof] = ACTIONS(919),
    [anon_sym_digestof] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_STAR] = ACTIONS(921),
    [anon_sym_SLASH] = ACTIONS(921),
    [anon_sym_PERCENT] = ACTIONS(921),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(921),
    [anon_sym_GT_GT] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(919),
    [anon_sym_or] = ACTIONS(919),
    [anon_sym_xor] = ACTIONS(919),
    [anon_sym_isnt] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_PLUS_TILDE] = ACTIONS(919),
    [anon_sym_STAR_TILDE] = ACTIONS(919),
    [anon_sym_SLASH_TILDE] = ACTIONS(919),
    [anon_sym_PERCENT_TILDE] = ACTIONS(919),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(919),
    [anon_sym_LT_LT_TILDE] = ACTIONS(919),
    [anon_sym_GT_GT_TILDE] = ACTIONS(919),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(919),
    [anon_sym_GT_TILDE] = ACTIONS(919),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(919),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(919),
    [anon_sym_LT_TILDE] = ACTIONS(919),
    [anon_sym_PLUS_QMARK] = ACTIONS(919),
    [anon_sym_DASH_QMARK] = ACTIONS(919),
    [anon_sym_STAR_QMARK] = ACTIONS(919),
    [anon_sym_SLASH_QMARK] = ACTIONS(919),
    [anon_sym_PERCENT_QMARK] = ACTIONS(919),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(919),
    [anon_sym_as] = ACTIONS(919),
    [anon_sym_LPAREN2] = ACTIONS(919),
    [anon_sym_DOT_GT] = ACTIONS(919),
    [anon_sym_where] = ACTIONS(919),
    [anon_sym_TILDE] = ACTIONS(919),
    [anon_sym_end] = ACTIONS(919),
    [anon_sym_if] = ACTIONS(921),
    [anon_sym_ifdef] = ACTIONS(919),
    [anon_sym_iftype] = ACTIONS(919),
    [anon_sym_else] = ACTIONS(919),
    [anon_sym_for] = ACTIONS(919),
    [anon_sym_while] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(919),
    [anon_sym_with] = ACTIONS(919),
    [anon_sym_repeat] = ACTIONS(919),
    [anon_sym_do] = ACTIONS(919),
    [anon_sym_recover] = ACTIONS(919),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_return] = ACTIONS(919),
    [anon_sym_continue] = ACTIONS(919),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_consume] = ACTIONS(919),
    [anon_sym_object] = ACTIONS(919),
    [sym_number] = ACTIONS(921),
    [sym_float] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(921),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(919),
    [anon_sym_SQUOTE] = ACTIONS(919),
    [anon_sym_true] = ACTIONS(919),
    [anon_sym_false] = ACTIONS(919),
    [sym_this] = ACTIONS(919),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [156] = {
    [ts_builtin_sym_end] = ACTIONS(923),
    [sym_identifier] = ACTIONS(925),
    [anon_sym_use] = ACTIONS(923),
    [anon_sym_EQ] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_type] = ACTIONS(923),
    [anon_sym_is] = ACTIONS(925),
    [anon_sym_actor] = ACTIONS(923),
    [anon_sym_class] = ACTIONS(923),
    [anon_sym_primitive] = ACTIONS(923),
    [anon_sym_interface] = ACTIONS(923),
    [anon_sym_trait] = ACTIONS(923),
    [anon_sym_struct] = ACTIONS(923),
    [anon_sym_embed] = ACTIONS(923),
    [anon_sym_let] = ACTIONS(923),
    [anon_sym_var] = ACTIONS(923),
    [anon_sym_new] = ACTIONS(923),
    [anon_sym_fun] = ACTIONS(923),
    [anon_sym_be] = ACTIONS(923),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_LPAREN] = ACTIONS(925),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_DOT] = ACTIONS(925),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_CARET] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_AMP] = ACTIONS(923),
    [anon_sym_DASH_GT] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_SEMI] = ACTIONS(923),
    [sym_error] = ACTIONS(923),
    [sym_compile_intrinsic] = ACTIONS(923),
    [anon_sym_compile_error] = ACTIONS(923),
    [sym_location] = ACTIONS(923),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_DASH_TILDE] = ACTIONS(923),
    [anon_sym_addressof] = ACTIONS(923),
    [anon_sym_digestof] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_STAR] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(925),
    [anon_sym_PERCENT] = ACTIONS(925),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(925),
    [anon_sym_LT_LT] = ACTIONS(925),
    [anon_sym_GT_GT] = ACTIONS(925),
    [anon_sym_and] = ACTIONS(923),
    [anon_sym_or] = ACTIONS(923),
    [anon_sym_xor] = ACTIONS(923),
    [anon_sym_isnt] = ACTIONS(923),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_BANG_EQ] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(925),
    [anon_sym_GT_EQ] = ACTIONS(925),
    [anon_sym_LT_EQ] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_PLUS_TILDE] = ACTIONS(923),
    [anon_sym_STAR_TILDE] = ACTIONS(923),
    [anon_sym_SLASH_TILDE] = ACTIONS(923),
    [anon_sym_PERCENT_TILDE] = ACTIONS(923),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(923),
    [anon_sym_LT_LT_TILDE] = ACTIONS(923),
    [anon_sym_GT_GT_TILDE] = ACTIONS(923),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(923),
    [anon_sym_GT_TILDE] = ACTIONS(923),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(923),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(923),
    [anon_sym_LT_TILDE] = ACTIONS(923),
    [anon_sym_PLUS_QMARK] = ACTIONS(923),
    [anon_sym_DASH_QMARK] = ACTIONS(923),
    [anon_sym_STAR_QMARK] = ACTIONS(923),
    [anon_sym_SLASH_QMARK] = ACTIONS(923),
    [anon_sym_PERCENT_QMARK] = ACTIONS(923),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(923),
    [anon_sym_as] = ACTIONS(923),
    [anon_sym_LPAREN2] = ACTIONS(923),
    [anon_sym_DOT_GT] = ACTIONS(923),
    [anon_sym_where] = ACTIONS(923),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_end] = ACTIONS(923),
    [anon_sym_if] = ACTIONS(925),
    [anon_sym_ifdef] = ACTIONS(923),
    [anon_sym_iftype] = ACTIONS(923),
    [anon_sym_else] = ACTIONS(923),
    [anon_sym_for] = ACTIONS(923),
    [anon_sym_while] = ACTIONS(923),
    [anon_sym_try] = ACTIONS(923),
    [anon_sym_with] = ACTIONS(923),
    [anon_sym_repeat] = ACTIONS(923),
    [anon_sym_do] = ACTIONS(923),
    [anon_sym_recover] = ACTIONS(923),
    [anon_sym_match] = ACTIONS(923),
    [anon_sym_return] = ACTIONS(923),
    [anon_sym_continue] = ACTIONS(923),
    [anon_sym_break] = ACTIONS(923),
    [anon_sym_consume] = ACTIONS(923),
    [anon_sym_object] = ACTIONS(923),
    [sym_number] = ACTIONS(925),
    [sym_float] = ACTIONS(923),
    [anon_sym_DQUOTE] = ACTIONS(925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(923),
    [anon_sym_SQUOTE] = ACTIONS(923),
    [anon_sym_true] = ACTIONS(923),
    [anon_sym_false] = ACTIONS(923),
    [sym_this] = ACTIONS(923),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [157] = {
    [ts_builtin_sym_end] = ACTIONS(927),
    [sym_identifier] = ACTIONS(929),
    [anon_sym_use] = ACTIONS(927),
    [anon_sym_EQ] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(927),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_type] = ACTIONS(927),
    [anon_sym_is] = ACTIONS(929),
    [anon_sym_actor] = ACTIONS(927),
    [anon_sym_class] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(927),
    [anon_sym_interface] = ACTIONS(927),
    [anon_sym_trait] = ACTIONS(927),
    [anon_sym_struct] = ACTIONS(927),
    [anon_sym_embed] = ACTIONS(927),
    [anon_sym_let] = ACTIONS(927),
    [anon_sym_var] = ACTIONS(927),
    [anon_sym_new] = ACTIONS(927),
    [anon_sym_fun] = ACTIONS(927),
    [anon_sym_be] = ACTIONS(927),
    [anon_sym_COMMA] = ACTIONS(927),
    [anon_sym_LPAREN] = ACTIONS(929),
    [anon_sym_RPAREN] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_CARET] = ACTIONS(927),
    [anon_sym_PIPE] = ACTIONS(927),
    [anon_sym_AMP] = ACTIONS(927),
    [anon_sym_DASH_GT] = ACTIONS(927),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_SEMI] = ACTIONS(927),
    [sym_error] = ACTIONS(927),
    [sym_compile_intrinsic] = ACTIONS(927),
    [anon_sym_compile_error] = ACTIONS(927),
    [sym_location] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_not] = ACTIONS(927),
    [anon_sym_DASH_TILDE] = ACTIONS(927),
    [anon_sym_addressof] = ACTIONS(927),
    [anon_sym_digestof] = ACTIONS(927),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_PERCENT] = ACTIONS(929),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(929),
    [anon_sym_LT_LT] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(929),
    [anon_sym_and] = ACTIONS(927),
    [anon_sym_or] = ACTIONS(927),
    [anon_sym_xor] = ACTIONS(927),
    [anon_sym_isnt] = ACTIONS(927),
    [anon_sym_EQ_EQ] = ACTIONS(929),
    [anon_sym_BANG_EQ] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_GT_EQ] = ACTIONS(929),
    [anon_sym_LT_EQ] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_PLUS_TILDE] = ACTIONS(927),
    [anon_sym_STAR_TILDE] = ACTIONS(927),
    [anon_sym_SLASH_TILDE] = ACTIONS(927),
    [anon_sym_PERCENT_TILDE] = ACTIONS(927),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(927),
    [anon_sym_LT_LT_TILDE] = ACTIONS(927),
    [anon_sym_GT_GT_TILDE] = ACTIONS(927),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(927),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(927),
    [anon_sym_GT_TILDE] = ACTIONS(927),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(927),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(927),
    [anon_sym_LT_TILDE] = ACTIONS(927),
    [anon_sym_PLUS_QMARK] = ACTIONS(927),
    [anon_sym_DASH_QMARK] = ACTIONS(927),
    [anon_sym_STAR_QMARK] = ACTIONS(927),
    [anon_sym_SLASH_QMARK] = ACTIONS(927),
    [anon_sym_PERCENT_QMARK] = ACTIONS(927),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(927),
    [anon_sym_as] = ACTIONS(927),
    [anon_sym_LPAREN2] = ACTIONS(927),
    [anon_sym_DOT_GT] = ACTIONS(927),
    [anon_sym_where] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(927),
    [anon_sym_end] = ACTIONS(927),
    [anon_sym_if] = ACTIONS(929),
    [anon_sym_ifdef] = ACTIONS(927),
    [anon_sym_iftype] = ACTIONS(927),
    [anon_sym_else] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(927),
    [anon_sym_try] = ACTIONS(927),
    [anon_sym_with] = ACTIONS(927),
    [anon_sym_repeat] = ACTIONS(927),
    [anon_sym_do] = ACTIONS(927),
    [anon_sym_recover] = ACTIONS(927),
    [anon_sym_match] = ACTIONS(927),
    [anon_sym_return] = ACTIONS(927),
    [anon_sym_continue] = ACTIONS(927),
    [anon_sym_break] = ACTIONS(927),
    [anon_sym_consume] = ACTIONS(927),
    [anon_sym_object] = ACTIONS(927),
    [sym_number] = ACTIONS(929),
    [sym_float] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(929),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(927),
    [anon_sym_true] = ACTIONS(927),
    [anon_sym_false] = ACTIONS(927),
    [sym_this] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [158] = {
    [ts_builtin_sym_end] = ACTIONS(931),
    [sym_identifier] = ACTIONS(933),
    [anon_sym_use] = ACTIONS(931),
    [anon_sym_EQ] = ACTIONS(933),
    [anon_sym_AT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_type] = ACTIONS(931),
    [anon_sym_is] = ACTIONS(933),
    [anon_sym_actor] = ACTIONS(931),
    [anon_sym_class] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(931),
    [anon_sym_interface] = ACTIONS(931),
    [anon_sym_trait] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(931),
    [anon_sym_embed] = ACTIONS(931),
    [anon_sym_let] = ACTIONS(931),
    [anon_sym_var] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(931),
    [anon_sym_fun] = ACTIONS(931),
    [anon_sym_be] = ACTIONS(931),
    [anon_sym_COMMA] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(933),
    [anon_sym_RPAREN] = ACTIONS(931),
    [anon_sym_DOT] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_CARET] = ACTIONS(931),
    [anon_sym_PIPE] = ACTIONS(931),
    [anon_sym_AMP] = ACTIONS(931),
    [anon_sym_DASH_GT] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(931),
    [anon_sym_SEMI] = ACTIONS(931),
    [sym_error] = ACTIONS(931),
    [sym_compile_intrinsic] = ACTIONS(931),
    [anon_sym_compile_error] = ACTIONS(931),
    [sym_location] = ACTIONS(931),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_not] = ACTIONS(931),
    [anon_sym_DASH_TILDE] = ACTIONS(931),
    [anon_sym_addressof] = ACTIONS(931),
    [anon_sym_digestof] = ACTIONS(931),
    [anon_sym_PLUS] = ACTIONS(933),
    [anon_sym_STAR] = ACTIONS(933),
    [anon_sym_SLASH] = ACTIONS(933),
    [anon_sym_PERCENT] = ACTIONS(933),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(933),
    [anon_sym_LT_LT] = ACTIONS(933),
    [anon_sym_GT_GT] = ACTIONS(933),
    [anon_sym_and] = ACTIONS(931),
    [anon_sym_or] = ACTIONS(931),
    [anon_sym_xor] = ACTIONS(931),
    [anon_sym_isnt] = ACTIONS(931),
    [anon_sym_EQ_EQ] = ACTIONS(933),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_GT] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_LT] = ACTIONS(933),
    [anon_sym_PLUS_TILDE] = ACTIONS(931),
    [anon_sym_STAR_TILDE] = ACTIONS(931),
    [anon_sym_SLASH_TILDE] = ACTIONS(931),
    [anon_sym_PERCENT_TILDE] = ACTIONS(931),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(931),
    [anon_sym_LT_LT_TILDE] = ACTIONS(931),
    [anon_sym_GT_GT_TILDE] = ACTIONS(931),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(931),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(931),
    [anon_sym_GT_TILDE] = ACTIONS(931),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(931),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(931),
    [anon_sym_LT_TILDE] = ACTIONS(931),
    [anon_sym_PLUS_QMARK] = ACTIONS(931),
    [anon_sym_DASH_QMARK] = ACTIONS(931),
    [anon_sym_STAR_QMARK] = ACTIONS(931),
    [anon_sym_SLASH_QMARK] = ACTIONS(931),
    [anon_sym_PERCENT_QMARK] = ACTIONS(931),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(931),
    [anon_sym_as] = ACTIONS(931),
    [anon_sym_LPAREN2] = ACTIONS(931),
    [anon_sym_DOT_GT] = ACTIONS(931),
    [anon_sym_where] = ACTIONS(931),
    [anon_sym_TILDE] = ACTIONS(931),
    [anon_sym_end] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(933),
    [anon_sym_ifdef] = ACTIONS(931),
    [anon_sym_iftype] = ACTIONS(931),
    [anon_sym_else] = ACTIONS(931),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_try] = ACTIONS(931),
    [anon_sym_with] = ACTIONS(931),
    [anon_sym_repeat] = ACTIONS(931),
    [anon_sym_do] = ACTIONS(931),
    [anon_sym_recover] = ACTIONS(931),
    [anon_sym_match] = ACTIONS(931),
    [anon_sym_return] = ACTIONS(931),
    [anon_sym_continue] = ACTIONS(931),
    [anon_sym_break] = ACTIONS(931),
    [anon_sym_consume] = ACTIONS(931),
    [anon_sym_object] = ACTIONS(931),
    [sym_number] = ACTIONS(933),
    [sym_float] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(933),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(931),
    [anon_sym_SQUOTE] = ACTIONS(931),
    [anon_sym_true] = ACTIONS(931),
    [anon_sym_false] = ACTIONS(931),
    [sym_this] = ACTIONS(931),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [159] = {
    [ts_builtin_sym_end] = ACTIONS(935),
    [sym_identifier] = ACTIONS(937),
    [anon_sym_use] = ACTIONS(935),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_AT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_type] = ACTIONS(935),
    [anon_sym_is] = ACTIONS(937),
    [anon_sym_actor] = ACTIONS(935),
    [anon_sym_class] = ACTIONS(935),
    [anon_sym_primitive] = ACTIONS(935),
    [anon_sym_interface] = ACTIONS(935),
    [anon_sym_trait] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(935),
    [anon_sym_embed] = ACTIONS(935),
    [anon_sym_let] = ACTIONS(935),
    [anon_sym_var] = ACTIONS(935),
    [anon_sym_new] = ACTIONS(935),
    [anon_sym_fun] = ACTIONS(935),
    [anon_sym_be] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_BANG] = ACTIONS(937),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym_AMP] = ACTIONS(935),
    [anon_sym_DASH_GT] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_SEMI] = ACTIONS(935),
    [sym_error] = ACTIONS(935),
    [sym_compile_intrinsic] = ACTIONS(935),
    [anon_sym_compile_error] = ACTIONS(935),
    [sym_location] = ACTIONS(935),
    [anon_sym_DASH] = ACTIONS(937),
    [anon_sym_not] = ACTIONS(935),
    [anon_sym_DASH_TILDE] = ACTIONS(935),
    [anon_sym_addressof] = ACTIONS(935),
    [anon_sym_digestof] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_STAR] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_xor] = ACTIONS(935),
    [anon_sym_isnt] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_PLUS_TILDE] = ACTIONS(935),
    [anon_sym_STAR_TILDE] = ACTIONS(935),
    [anon_sym_SLASH_TILDE] = ACTIONS(935),
    [anon_sym_PERCENT_TILDE] = ACTIONS(935),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(935),
    [anon_sym_LT_LT_TILDE] = ACTIONS(935),
    [anon_sym_GT_GT_TILDE] = ACTIONS(935),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(935),
    [anon_sym_GT_TILDE] = ACTIONS(935),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(935),
    [anon_sym_LT_TILDE] = ACTIONS(935),
    [anon_sym_PLUS_QMARK] = ACTIONS(935),
    [anon_sym_DASH_QMARK] = ACTIONS(935),
    [anon_sym_STAR_QMARK] = ACTIONS(935),
    [anon_sym_SLASH_QMARK] = ACTIONS(935),
    [anon_sym_PERCENT_QMARK] = ACTIONS(935),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(935),
    [anon_sym_as] = ACTIONS(935),
    [anon_sym_LPAREN2] = ACTIONS(935),
    [anon_sym_DOT_GT] = ACTIONS(935),
    [anon_sym_where] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(937),
    [anon_sym_ifdef] = ACTIONS(935),
    [anon_sym_iftype] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_try] = ACTIONS(935),
    [anon_sym_with] = ACTIONS(935),
    [anon_sym_repeat] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_recover] = ACTIONS(935),
    [anon_sym_match] = ACTIONS(935),
    [anon_sym_return] = ACTIONS(935),
    [anon_sym_continue] = ACTIONS(935),
    [anon_sym_break] = ACTIONS(935),
    [anon_sym_consume] = ACTIONS(935),
    [anon_sym_object] = ACTIONS(935),
    [sym_number] = ACTIONS(937),
    [sym_float] = ACTIONS(935),
    [anon_sym_DQUOTE] = ACTIONS(937),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(935),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_true] = ACTIONS(935),
    [anon_sym_false] = ACTIONS(935),
    [sym_this] = ACTIONS(935),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [160] = {
    [ts_builtin_sym_end] = ACTIONS(939),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_use] = ACTIONS(939),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_AT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_type] = ACTIONS(939),
    [anon_sym_is] = ACTIONS(941),
    [anon_sym_actor] = ACTIONS(939),
    [anon_sym_class] = ACTIONS(939),
    [anon_sym_primitive] = ACTIONS(939),
    [anon_sym_interface] = ACTIONS(939),
    [anon_sym_trait] = ACTIONS(939),
    [anon_sym_struct] = ACTIONS(939),
    [anon_sym_embed] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(939),
    [anon_sym_var] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(939),
    [anon_sym_fun] = ACTIONS(939),
    [anon_sym_be] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_LPAREN] = ACTIONS(941),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_BANG] = ACTIONS(941),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_DASH_GT] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_error] = ACTIONS(939),
    [sym_compile_intrinsic] = ACTIONS(939),
    [anon_sym_compile_error] = ACTIONS(939),
    [sym_location] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(941),
    [anon_sym_not] = ACTIONS(939),
    [anon_sym_DASH_TILDE] = ACTIONS(939),
    [anon_sym_addressof] = ACTIONS(939),
    [anon_sym_digestof] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_xor] = ACTIONS(939),
    [anon_sym_isnt] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_PLUS_TILDE] = ACTIONS(939),
    [anon_sym_STAR_TILDE] = ACTIONS(939),
    [anon_sym_SLASH_TILDE] = ACTIONS(939),
    [anon_sym_PERCENT_TILDE] = ACTIONS(939),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(939),
    [anon_sym_LT_LT_TILDE] = ACTIONS(939),
    [anon_sym_GT_GT_TILDE] = ACTIONS(939),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(939),
    [anon_sym_GT_TILDE] = ACTIONS(939),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(939),
    [anon_sym_LT_TILDE] = ACTIONS(939),
    [anon_sym_PLUS_QMARK] = ACTIONS(939),
    [anon_sym_DASH_QMARK] = ACTIONS(939),
    [anon_sym_STAR_QMARK] = ACTIONS(939),
    [anon_sym_SLASH_QMARK] = ACTIONS(939),
    [anon_sym_PERCENT_QMARK] = ACTIONS(939),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(939),
    [anon_sym_as] = ACTIONS(939),
    [anon_sym_LPAREN2] = ACTIONS(939),
    [anon_sym_DOT_GT] = ACTIONS(939),
    [anon_sym_where] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(939),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(941),
    [anon_sym_ifdef] = ACTIONS(939),
    [anon_sym_iftype] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_for] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_try] = ACTIONS(939),
    [anon_sym_with] = ACTIONS(939),
    [anon_sym_repeat] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_recover] = ACTIONS(939),
    [anon_sym_match] = ACTIONS(939),
    [anon_sym_return] = ACTIONS(939),
    [anon_sym_continue] = ACTIONS(939),
    [anon_sym_break] = ACTIONS(939),
    [anon_sym_consume] = ACTIONS(939),
    [anon_sym_object] = ACTIONS(939),
    [sym_number] = ACTIONS(941),
    [sym_float] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(939),
    [anon_sym_SQUOTE] = ACTIONS(939),
    [anon_sym_true] = ACTIONS(939),
    [anon_sym_false] = ACTIONS(939),
    [sym_this] = ACTIONS(939),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [161] = {
    [ts_builtin_sym_end] = ACTIONS(943),
    [sym_identifier] = ACTIONS(945),
    [anon_sym_use] = ACTIONS(943),
    [anon_sym_EQ] = ACTIONS(945),
    [anon_sym_AT] = ACTIONS(943),
    [anon_sym_LBRACK] = ACTIONS(943),
    [anon_sym_type] = ACTIONS(943),
    [anon_sym_is] = ACTIONS(945),
    [anon_sym_actor] = ACTIONS(943),
    [anon_sym_class] = ACTIONS(943),
    [anon_sym_primitive] = ACTIONS(943),
    [anon_sym_interface] = ACTIONS(943),
    [anon_sym_trait] = ACTIONS(943),
    [anon_sym_struct] = ACTIONS(943),
    [anon_sym_embed] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(943),
    [anon_sym_var] = ACTIONS(943),
    [anon_sym_new] = ACTIONS(943),
    [anon_sym_fun] = ACTIONS(943),
    [anon_sym_be] = ACTIONS(943),
    [anon_sym_COMMA] = ACTIONS(943),
    [anon_sym_LPAREN] = ACTIONS(945),
    [anon_sym_RPAREN] = ACTIONS(943),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_BANG] = ACTIONS(945),
    [anon_sym_CARET] = ACTIONS(943),
    [anon_sym_PIPE] = ACTIONS(943),
    [anon_sym_AMP] = ACTIONS(943),
    [anon_sym_DASH_GT] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(943),
    [anon_sym_SEMI] = ACTIONS(943),
    [sym_error] = ACTIONS(943),
    [sym_compile_intrinsic] = ACTIONS(943),
    [anon_sym_compile_error] = ACTIONS(943),
    [sym_location] = ACTIONS(943),
    [anon_sym_DASH] = ACTIONS(945),
    [anon_sym_not] = ACTIONS(943),
    [anon_sym_DASH_TILDE] = ACTIONS(943),
    [anon_sym_addressof] = ACTIONS(943),
    [anon_sym_digestof] = ACTIONS(943),
    [anon_sym_PLUS] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(945),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_PERCENT] = ACTIONS(945),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(945),
    [anon_sym_LT_LT] = ACTIONS(945),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_and] = ACTIONS(943),
    [anon_sym_or] = ACTIONS(943),
    [anon_sym_xor] = ACTIONS(943),
    [anon_sym_isnt] = ACTIONS(943),
    [anon_sym_EQ_EQ] = ACTIONS(945),
    [anon_sym_BANG_EQ] = ACTIONS(945),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_GT_EQ] = ACTIONS(945),
    [anon_sym_LT_EQ] = ACTIONS(945),
    [anon_sym_LT] = ACTIONS(945),
    [anon_sym_PLUS_TILDE] = ACTIONS(943),
    [anon_sym_STAR_TILDE] = ACTIONS(943),
    [anon_sym_SLASH_TILDE] = ACTIONS(943),
    [anon_sym_PERCENT_TILDE] = ACTIONS(943),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(943),
    [anon_sym_LT_LT_TILDE] = ACTIONS(943),
    [anon_sym_GT_GT_TILDE] = ACTIONS(943),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(943),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(943),
    [anon_sym_GT_TILDE] = ACTIONS(943),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(943),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(943),
    [anon_sym_LT_TILDE] = ACTIONS(943),
    [anon_sym_PLUS_QMARK] = ACTIONS(943),
    [anon_sym_DASH_QMARK] = ACTIONS(943),
    [anon_sym_STAR_QMARK] = ACTIONS(943),
    [anon_sym_SLASH_QMARK] = ACTIONS(943),
    [anon_sym_PERCENT_QMARK] = ACTIONS(943),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(943),
    [anon_sym_as] = ACTIONS(943),
    [anon_sym_LPAREN2] = ACTIONS(943),
    [anon_sym_DOT_GT] = ACTIONS(943),
    [anon_sym_where] = ACTIONS(943),
    [anon_sym_TILDE] = ACTIONS(943),
    [anon_sym_end] = ACTIONS(943),
    [anon_sym_if] = ACTIONS(945),
    [anon_sym_ifdef] = ACTIONS(943),
    [anon_sym_iftype] = ACTIONS(943),
    [anon_sym_else] = ACTIONS(943),
    [anon_sym_for] = ACTIONS(943),
    [anon_sym_while] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_with] = ACTIONS(943),
    [anon_sym_repeat] = ACTIONS(943),
    [anon_sym_do] = ACTIONS(943),
    [anon_sym_recover] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(943),
    [anon_sym_return] = ACTIONS(943),
    [anon_sym_continue] = ACTIONS(943),
    [anon_sym_break] = ACTIONS(943),
    [anon_sym_consume] = ACTIONS(943),
    [anon_sym_object] = ACTIONS(943),
    [sym_number] = ACTIONS(945),
    [sym_float] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_true] = ACTIONS(943),
    [anon_sym_false] = ACTIONS(943),
    [sym_this] = ACTIONS(943),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [162] = {
    [ts_builtin_sym_end] = ACTIONS(947),
    [sym_identifier] = ACTIONS(949),
    [anon_sym_use] = ACTIONS(947),
    [anon_sym_EQ] = ACTIONS(949),
    [anon_sym_AT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_type] = ACTIONS(947),
    [anon_sym_is] = ACTIONS(949),
    [anon_sym_actor] = ACTIONS(947),
    [anon_sym_class] = ACTIONS(947),
    [anon_sym_primitive] = ACTIONS(947),
    [anon_sym_interface] = ACTIONS(947),
    [anon_sym_trait] = ACTIONS(947),
    [anon_sym_struct] = ACTIONS(947),
    [anon_sym_embed] = ACTIONS(947),
    [anon_sym_let] = ACTIONS(947),
    [anon_sym_var] = ACTIONS(947),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_fun] = ACTIONS(947),
    [anon_sym_be] = ACTIONS(947),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(947),
    [anon_sym_DASH_GT] = ACTIONS(947),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_SEMI] = ACTIONS(947),
    [sym_error] = ACTIONS(947),
    [sym_compile_intrinsic] = ACTIONS(947),
    [anon_sym_compile_error] = ACTIONS(947),
    [sym_location] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_not] = ACTIONS(947),
    [anon_sym_DASH_TILDE] = ACTIONS(947),
    [anon_sym_addressof] = ACTIONS(947),
    [anon_sym_digestof] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_STAR] = ACTIONS(949),
    [anon_sym_SLASH] = ACTIONS(949),
    [anon_sym_PERCENT] = ACTIONS(949),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(949),
    [anon_sym_LT_LT] = ACTIONS(949),
    [anon_sym_GT_GT] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(947),
    [anon_sym_or] = ACTIONS(947),
    [anon_sym_xor] = ACTIONS(947),
    [anon_sym_isnt] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(949),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_PLUS_TILDE] = ACTIONS(947),
    [anon_sym_STAR_TILDE] = ACTIONS(947),
    [anon_sym_SLASH_TILDE] = ACTIONS(947),
    [anon_sym_PERCENT_TILDE] = ACTIONS(947),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(947),
    [anon_sym_LT_LT_TILDE] = ACTIONS(947),
    [anon_sym_GT_GT_TILDE] = ACTIONS(947),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(947),
    [anon_sym_GT_TILDE] = ACTIONS(947),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(947),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(947),
    [anon_sym_LT_TILDE] = ACTIONS(947),
    [anon_sym_PLUS_QMARK] = ACTIONS(947),
    [anon_sym_DASH_QMARK] = ACTIONS(947),
    [anon_sym_STAR_QMARK] = ACTIONS(947),
    [anon_sym_SLASH_QMARK] = ACTIONS(947),
    [anon_sym_PERCENT_QMARK] = ACTIONS(947),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(947),
    [anon_sym_as] = ACTIONS(947),
    [anon_sym_LPAREN2] = ACTIONS(947),
    [anon_sym_DOT_GT] = ACTIONS(947),
    [anon_sym_where] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(947),
    [anon_sym_end] = ACTIONS(947),
    [anon_sym_if] = ACTIONS(949),
    [anon_sym_ifdef] = ACTIONS(947),
    [anon_sym_iftype] = ACTIONS(947),
    [anon_sym_else] = ACTIONS(947),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(947),
    [anon_sym_with] = ACTIONS(947),
    [anon_sym_repeat] = ACTIONS(947),
    [anon_sym_do] = ACTIONS(947),
    [anon_sym_recover] = ACTIONS(947),
    [anon_sym_match] = ACTIONS(947),
    [anon_sym_return] = ACTIONS(947),
    [anon_sym_continue] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(947),
    [anon_sym_consume] = ACTIONS(947),
    [anon_sym_object] = ACTIONS(947),
    [sym_number] = ACTIONS(949),
    [sym_float] = ACTIONS(947),
    [anon_sym_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(947),
    [anon_sym_SQUOTE] = ACTIONS(947),
    [anon_sym_true] = ACTIONS(947),
    [anon_sym_false] = ACTIONS(947),
    [sym_this] = ACTIONS(947),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [163] = {
    [ts_builtin_sym_end] = ACTIONS(951),
    [sym_identifier] = ACTIONS(953),
    [anon_sym_use] = ACTIONS(951),
    [anon_sym_EQ] = ACTIONS(953),
    [anon_sym_AT] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(951),
    [anon_sym_type] = ACTIONS(951),
    [anon_sym_is] = ACTIONS(953),
    [anon_sym_actor] = ACTIONS(951),
    [anon_sym_class] = ACTIONS(951),
    [anon_sym_primitive] = ACTIONS(951),
    [anon_sym_interface] = ACTIONS(951),
    [anon_sym_trait] = ACTIONS(951),
    [anon_sym_struct] = ACTIONS(951),
    [anon_sym_embed] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_var] = ACTIONS(951),
    [anon_sym_new] = ACTIONS(951),
    [anon_sym_fun] = ACTIONS(951),
    [anon_sym_be] = ACTIONS(951),
    [anon_sym_COMMA] = ACTIONS(951),
    [anon_sym_LPAREN] = ACTIONS(953),
    [anon_sym_RPAREN] = ACTIONS(951),
    [anon_sym_DOT] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_CARET] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(951),
    [anon_sym_AMP] = ACTIONS(951),
    [anon_sym_DASH_GT] = ACTIONS(951),
    [anon_sym_LBRACE] = ACTIONS(951),
    [anon_sym_SEMI] = ACTIONS(951),
    [sym_error] = ACTIONS(951),
    [sym_compile_intrinsic] = ACTIONS(951),
    [anon_sym_compile_error] = ACTIONS(951),
    [sym_location] = ACTIONS(951),
    [anon_sym_DASH] = ACTIONS(953),
    [anon_sym_not] = ACTIONS(951),
    [anon_sym_DASH_TILDE] = ACTIONS(951),
    [anon_sym_addressof] = ACTIONS(951),
    [anon_sym_digestof] = ACTIONS(951),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_STAR] = ACTIONS(953),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_PERCENT] = ACTIONS(953),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(953),
    [anon_sym_LT_LT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(953),
    [anon_sym_and] = ACTIONS(951),
    [anon_sym_or] = ACTIONS(951),
    [anon_sym_xor] = ACTIONS(951),
    [anon_sym_isnt] = ACTIONS(951),
    [anon_sym_EQ_EQ] = ACTIONS(953),
    [anon_sym_BANG_EQ] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_EQ] = ACTIONS(953),
    [anon_sym_LT_EQ] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_PLUS_TILDE] = ACTIONS(951),
    [anon_sym_STAR_TILDE] = ACTIONS(951),
    [anon_sym_SLASH_TILDE] = ACTIONS(951),
    [anon_sym_PERCENT_TILDE] = ACTIONS(951),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(951),
    [anon_sym_LT_LT_TILDE] = ACTIONS(951),
    [anon_sym_GT_GT_TILDE] = ACTIONS(951),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(951),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(951),
    [anon_sym_GT_TILDE] = ACTIONS(951),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(951),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(951),
    [anon_sym_LT_TILDE] = ACTIONS(951),
    [anon_sym_PLUS_QMARK] = ACTIONS(951),
    [anon_sym_DASH_QMARK] = ACTIONS(951),
    [anon_sym_STAR_QMARK] = ACTIONS(951),
    [anon_sym_SLASH_QMARK] = ACTIONS(951),
    [anon_sym_PERCENT_QMARK] = ACTIONS(951),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(951),
    [anon_sym_as] = ACTIONS(951),
    [anon_sym_LPAREN2] = ACTIONS(951),
    [anon_sym_DOT_GT] = ACTIONS(951),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_TILDE] = ACTIONS(951),
    [anon_sym_end] = ACTIONS(951),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_ifdef] = ACTIONS(951),
    [anon_sym_iftype] = ACTIONS(951),
    [anon_sym_else] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(951),
    [anon_sym_try] = ACTIONS(951),
    [anon_sym_with] = ACTIONS(951),
    [anon_sym_repeat] = ACTIONS(951),
    [anon_sym_do] = ACTIONS(951),
    [anon_sym_recover] = ACTIONS(951),
    [anon_sym_match] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(951),
    [anon_sym_continue] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(951),
    [anon_sym_consume] = ACTIONS(951),
    [anon_sym_object] = ACTIONS(951),
    [sym_number] = ACTIONS(953),
    [sym_float] = ACTIONS(951),
    [anon_sym_DQUOTE] = ACTIONS(953),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [anon_sym_SQUOTE] = ACTIONS(951),
    [anon_sym_true] = ACTIONS(951),
    [anon_sym_false] = ACTIONS(951),
    [sym_this] = ACTIONS(951),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [164] = {
    [ts_builtin_sym_end] = ACTIONS(955),
    [sym_identifier] = ACTIONS(957),
    [anon_sym_use] = ACTIONS(955),
    [anon_sym_EQ] = ACTIONS(957),
    [anon_sym_AT] = ACTIONS(955),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_is] = ACTIONS(957),
    [anon_sym_actor] = ACTIONS(955),
    [anon_sym_class] = ACTIONS(955),
    [anon_sym_primitive] = ACTIONS(955),
    [anon_sym_interface] = ACTIONS(955),
    [anon_sym_trait] = ACTIONS(955),
    [anon_sym_struct] = ACTIONS(955),
    [anon_sym_embed] = ACTIONS(955),
    [anon_sym_let] = ACTIONS(955),
    [anon_sym_var] = ACTIONS(955),
    [anon_sym_new] = ACTIONS(955),
    [anon_sym_fun] = ACTIONS(955),
    [anon_sym_be] = ACTIONS(955),
    [anon_sym_COMMA] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_RPAREN] = ACTIONS(955),
    [anon_sym_DOT] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(955),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_DASH_GT] = ACTIONS(955),
    [anon_sym_LBRACE] = ACTIONS(955),
    [anon_sym_SEMI] = ACTIONS(955),
    [sym_error] = ACTIONS(955),
    [sym_compile_intrinsic] = ACTIONS(955),
    [anon_sym_compile_error] = ACTIONS(955),
    [sym_location] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_not] = ACTIONS(955),
    [anon_sym_DASH_TILDE] = ACTIONS(955),
    [anon_sym_addressof] = ACTIONS(955),
    [anon_sym_digestof] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(957),
    [anon_sym_SLASH] = ACTIONS(957),
    [anon_sym_PERCENT] = ACTIONS(957),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(957),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_and] = ACTIONS(955),
    [anon_sym_or] = ACTIONS(955),
    [anon_sym_xor] = ACTIONS(955),
    [anon_sym_isnt] = ACTIONS(955),
    [anon_sym_EQ_EQ] = ACTIONS(957),
    [anon_sym_BANG_EQ] = ACTIONS(957),
    [anon_sym_GT] = ACTIONS(957),
    [anon_sym_GT_EQ] = ACTIONS(957),
    [anon_sym_LT_EQ] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(957),
    [anon_sym_PLUS_TILDE] = ACTIONS(955),
    [anon_sym_STAR_TILDE] = ACTIONS(955),
    [anon_sym_SLASH_TILDE] = ACTIONS(955),
    [anon_sym_PERCENT_TILDE] = ACTIONS(955),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(955),
    [anon_sym_LT_LT_TILDE] = ACTIONS(955),
    [anon_sym_GT_GT_TILDE] = ACTIONS(955),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(955),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(955),
    [anon_sym_GT_TILDE] = ACTIONS(955),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(955),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(955),
    [anon_sym_LT_TILDE] = ACTIONS(955),
    [anon_sym_PLUS_QMARK] = ACTIONS(955),
    [anon_sym_DASH_QMARK] = ACTIONS(955),
    [anon_sym_STAR_QMARK] = ACTIONS(955),
    [anon_sym_SLASH_QMARK] = ACTIONS(955),
    [anon_sym_PERCENT_QMARK] = ACTIONS(955),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(955),
    [anon_sym_as] = ACTIONS(955),
    [anon_sym_LPAREN2] = ACTIONS(955),
    [anon_sym_DOT_GT] = ACTIONS(955),
    [anon_sym_where] = ACTIONS(955),
    [anon_sym_TILDE] = ACTIONS(955),
    [anon_sym_end] = ACTIONS(955),
    [anon_sym_if] = ACTIONS(957),
    [anon_sym_ifdef] = ACTIONS(955),
    [anon_sym_iftype] = ACTIONS(955),
    [anon_sym_else] = ACTIONS(955),
    [anon_sym_for] = ACTIONS(955),
    [anon_sym_while] = ACTIONS(955),
    [anon_sym_try] = ACTIONS(955),
    [anon_sym_with] = ACTIONS(955),
    [anon_sym_repeat] = ACTIONS(955),
    [anon_sym_do] = ACTIONS(955),
    [anon_sym_recover] = ACTIONS(955),
    [anon_sym_match] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(955),
    [anon_sym_continue] = ACTIONS(955),
    [anon_sym_break] = ACTIONS(955),
    [anon_sym_consume] = ACTIONS(955),
    [anon_sym_object] = ACTIONS(955),
    [sym_number] = ACTIONS(957),
    [sym_float] = ACTIONS(955),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(955),
    [anon_sym_SQUOTE] = ACTIONS(955),
    [anon_sym_true] = ACTIONS(955),
    [anon_sym_false] = ACTIONS(955),
    [sym_this] = ACTIONS(955),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [165] = {
    [ts_builtin_sym_end] = ACTIONS(959),
    [sym_identifier] = ACTIONS(961),
    [anon_sym_use] = ACTIONS(959),
    [anon_sym_EQ] = ACTIONS(961),
    [anon_sym_AT] = ACTIONS(959),
    [anon_sym_LBRACK] = ACTIONS(959),
    [anon_sym_type] = ACTIONS(959),
    [anon_sym_is] = ACTIONS(961),
    [anon_sym_actor] = ACTIONS(959),
    [anon_sym_class] = ACTIONS(959),
    [anon_sym_primitive] = ACTIONS(959),
    [anon_sym_interface] = ACTIONS(959),
    [anon_sym_trait] = ACTIONS(959),
    [anon_sym_struct] = ACTIONS(959),
    [anon_sym_embed] = ACTIONS(959),
    [anon_sym_let] = ACTIONS(959),
    [anon_sym_var] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(959),
    [anon_sym_fun] = ACTIONS(959),
    [anon_sym_be] = ACTIONS(959),
    [anon_sym_COMMA] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_RPAREN] = ACTIONS(959),
    [anon_sym_DOT] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_CARET] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_AMP] = ACTIONS(959),
    [anon_sym_DASH_GT] = ACTIONS(959),
    [anon_sym_LBRACE] = ACTIONS(959),
    [anon_sym_SEMI] = ACTIONS(959),
    [sym_error] = ACTIONS(959),
    [sym_compile_intrinsic] = ACTIONS(959),
    [anon_sym_compile_error] = ACTIONS(959),
    [sym_location] = ACTIONS(959),
    [anon_sym_DASH] = ACTIONS(961),
    [anon_sym_not] = ACTIONS(959),
    [anon_sym_DASH_TILDE] = ACTIONS(959),
    [anon_sym_addressof] = ACTIONS(959),
    [anon_sym_digestof] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_STAR] = ACTIONS(961),
    [anon_sym_SLASH] = ACTIONS(961),
    [anon_sym_PERCENT] = ACTIONS(961),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(961),
    [anon_sym_LT_LT] = ACTIONS(961),
    [anon_sym_GT_GT] = ACTIONS(961),
    [anon_sym_and] = ACTIONS(959),
    [anon_sym_or] = ACTIONS(959),
    [anon_sym_xor] = ACTIONS(959),
    [anon_sym_isnt] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(961),
    [anon_sym_BANG_EQ] = ACTIONS(961),
    [anon_sym_GT] = ACTIONS(961),
    [anon_sym_GT_EQ] = ACTIONS(961),
    [anon_sym_LT_EQ] = ACTIONS(961),
    [anon_sym_LT] = ACTIONS(961),
    [anon_sym_PLUS_TILDE] = ACTIONS(959),
    [anon_sym_STAR_TILDE] = ACTIONS(959),
    [anon_sym_SLASH_TILDE] = ACTIONS(959),
    [anon_sym_PERCENT_TILDE] = ACTIONS(959),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(959),
    [anon_sym_LT_LT_TILDE] = ACTIONS(959),
    [anon_sym_GT_GT_TILDE] = ACTIONS(959),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(959),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(959),
    [anon_sym_GT_TILDE] = ACTIONS(959),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(959),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(959),
    [anon_sym_LT_TILDE] = ACTIONS(959),
    [anon_sym_PLUS_QMARK] = ACTIONS(959),
    [anon_sym_DASH_QMARK] = ACTIONS(959),
    [anon_sym_STAR_QMARK] = ACTIONS(959),
    [anon_sym_SLASH_QMARK] = ACTIONS(959),
    [anon_sym_PERCENT_QMARK] = ACTIONS(959),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(959),
    [anon_sym_as] = ACTIONS(959),
    [anon_sym_LPAREN2] = ACTIONS(959),
    [anon_sym_DOT_GT] = ACTIONS(959),
    [anon_sym_where] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_end] = ACTIONS(959),
    [anon_sym_if] = ACTIONS(961),
    [anon_sym_ifdef] = ACTIONS(959),
    [anon_sym_iftype] = ACTIONS(959),
    [anon_sym_else] = ACTIONS(959),
    [anon_sym_for] = ACTIONS(959),
    [anon_sym_while] = ACTIONS(959),
    [anon_sym_try] = ACTIONS(959),
    [anon_sym_with] = ACTIONS(959),
    [anon_sym_repeat] = ACTIONS(959),
    [anon_sym_do] = ACTIONS(959),
    [anon_sym_recover] = ACTIONS(959),
    [anon_sym_match] = ACTIONS(959),
    [anon_sym_return] = ACTIONS(959),
    [anon_sym_continue] = ACTIONS(959),
    [anon_sym_break] = ACTIONS(959),
    [anon_sym_consume] = ACTIONS(959),
    [anon_sym_object] = ACTIONS(959),
    [sym_number] = ACTIONS(961),
    [sym_float] = ACTIONS(959),
    [anon_sym_DQUOTE] = ACTIONS(961),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(959),
    [anon_sym_SQUOTE] = ACTIONS(959),
    [anon_sym_true] = ACTIONS(959),
    [anon_sym_false] = ACTIONS(959),
    [sym_this] = ACTIONS(959),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [166] = {
    [ts_builtin_sym_end] = ACTIONS(963),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_use] = ACTIONS(963),
    [anon_sym_EQ] = ACTIONS(965),
    [anon_sym_AT] = ACTIONS(963),
    [anon_sym_LBRACK] = ACTIONS(963),
    [anon_sym_type] = ACTIONS(963),
    [anon_sym_is] = ACTIONS(965),
    [anon_sym_actor] = ACTIONS(963),
    [anon_sym_class] = ACTIONS(963),
    [anon_sym_primitive] = ACTIONS(963),
    [anon_sym_interface] = ACTIONS(963),
    [anon_sym_trait] = ACTIONS(963),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_embed] = ACTIONS(963),
    [anon_sym_let] = ACTIONS(963),
    [anon_sym_var] = ACTIONS(963),
    [anon_sym_new] = ACTIONS(963),
    [anon_sym_fun] = ACTIONS(963),
    [anon_sym_be] = ACTIONS(963),
    [anon_sym_COMMA] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(965),
    [anon_sym_RPAREN] = ACTIONS(963),
    [anon_sym_DOT] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(965),
    [anon_sym_CARET] = ACTIONS(963),
    [anon_sym_PIPE] = ACTIONS(963),
    [anon_sym_AMP] = ACTIONS(963),
    [anon_sym_DASH_GT] = ACTIONS(963),
    [anon_sym_LBRACE] = ACTIONS(963),
    [anon_sym_SEMI] = ACTIONS(963),
    [sym_error] = ACTIONS(963),
    [sym_compile_intrinsic] = ACTIONS(963),
    [anon_sym_compile_error] = ACTIONS(963),
    [sym_location] = ACTIONS(963),
    [anon_sym_DASH] = ACTIONS(965),
    [anon_sym_not] = ACTIONS(963),
    [anon_sym_DASH_TILDE] = ACTIONS(963),
    [anon_sym_addressof] = ACTIONS(963),
    [anon_sym_digestof] = ACTIONS(963),
    [anon_sym_PLUS] = ACTIONS(965),
    [anon_sym_STAR] = ACTIONS(965),
    [anon_sym_SLASH] = ACTIONS(965),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(965),
    [anon_sym_LT_LT] = ACTIONS(965),
    [anon_sym_GT_GT] = ACTIONS(965),
    [anon_sym_and] = ACTIONS(963),
    [anon_sym_or] = ACTIONS(963),
    [anon_sym_xor] = ACTIONS(963),
    [anon_sym_isnt] = ACTIONS(963),
    [anon_sym_EQ_EQ] = ACTIONS(965),
    [anon_sym_BANG_EQ] = ACTIONS(965),
    [anon_sym_GT] = ACTIONS(965),
    [anon_sym_GT_EQ] = ACTIONS(965),
    [anon_sym_LT_EQ] = ACTIONS(965),
    [anon_sym_LT] = ACTIONS(965),
    [anon_sym_PLUS_TILDE] = ACTIONS(963),
    [anon_sym_STAR_TILDE] = ACTIONS(963),
    [anon_sym_SLASH_TILDE] = ACTIONS(963),
    [anon_sym_PERCENT_TILDE] = ACTIONS(963),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(963),
    [anon_sym_LT_LT_TILDE] = ACTIONS(963),
    [anon_sym_GT_GT_TILDE] = ACTIONS(963),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(963),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(963),
    [anon_sym_GT_TILDE] = ACTIONS(963),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(963),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(963),
    [anon_sym_LT_TILDE] = ACTIONS(963),
    [anon_sym_PLUS_QMARK] = ACTIONS(963),
    [anon_sym_DASH_QMARK] = ACTIONS(963),
    [anon_sym_STAR_QMARK] = ACTIONS(963),
    [anon_sym_SLASH_QMARK] = ACTIONS(963),
    [anon_sym_PERCENT_QMARK] = ACTIONS(963),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(963),
    [anon_sym_as] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(963),
    [anon_sym_DOT_GT] = ACTIONS(963),
    [anon_sym_where] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [anon_sym_end] = ACTIONS(963),
    [anon_sym_if] = ACTIONS(965),
    [anon_sym_ifdef] = ACTIONS(963),
    [anon_sym_iftype] = ACTIONS(963),
    [anon_sym_else] = ACTIONS(963),
    [anon_sym_for] = ACTIONS(963),
    [anon_sym_while] = ACTIONS(963),
    [anon_sym_try] = ACTIONS(963),
    [anon_sym_with] = ACTIONS(963),
    [anon_sym_repeat] = ACTIONS(963),
    [anon_sym_do] = ACTIONS(963),
    [anon_sym_recover] = ACTIONS(963),
    [anon_sym_match] = ACTIONS(963),
    [anon_sym_return] = ACTIONS(963),
    [anon_sym_continue] = ACTIONS(963),
    [anon_sym_break] = ACTIONS(963),
    [anon_sym_consume] = ACTIONS(963),
    [anon_sym_object] = ACTIONS(963),
    [sym_number] = ACTIONS(965),
    [sym_float] = ACTIONS(963),
    [anon_sym_DQUOTE] = ACTIONS(965),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(963),
    [anon_sym_SQUOTE] = ACTIONS(963),
    [anon_sym_true] = ACTIONS(963),
    [anon_sym_false] = ACTIONS(963),
    [sym_this] = ACTIONS(963),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [167] = {
    [sym_capability] = STATE(367),
    [sym_identifier] = ACTIONS(839),
    [anon_sym_EQ] = ACTIONS(839),
    [anon_sym_AT] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(837),
    [anon_sym_RBRACK] = ACTIONS(837),
    [anon_sym_is] = ACTIONS(839),
    [anon_sym_embed] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_var] = ACTIONS(837),
    [anon_sym_new] = ACTIONS(837),
    [anon_sym_EQ_GT] = ACTIONS(837),
    [anon_sym_fun] = ACTIONS(837),
    [anon_sym_be] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_iso] = ACTIONS(967),
    [anon_sym_trn] = ACTIONS(967),
    [anon_sym_ref] = ACTIONS(967),
    [anon_sym_val] = ACTIONS(967),
    [anon_sym_box] = ACTIONS(967),
    [anon_sym_tag] = ACTIONS(967),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_SEMI] = ACTIONS(837),
    [sym_error] = ACTIONS(837),
    [sym_compile_intrinsic] = ACTIONS(837),
    [anon_sym_compile_error] = ACTIONS(837),
    [sym_location] = ACTIONS(837),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(837),
    [anon_sym_DASH_TILDE] = ACTIONS(837),
    [anon_sym_addressof] = ACTIONS(837),
    [anon_sym_digestof] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_STAR] = ACTIONS(839),
    [anon_sym_SLASH] = ACTIONS(839),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_GT_GT] = ACTIONS(839),
    [anon_sym_and] = ACTIONS(837),
    [anon_sym_or] = ACTIONS(837),
    [anon_sym_xor] = ACTIONS(837),
    [anon_sym_isnt] = ACTIONS(837),
    [anon_sym_EQ_EQ] = ACTIONS(839),
    [anon_sym_BANG_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(839),
    [anon_sym_PLUS_TILDE] = ACTIONS(837),
    [anon_sym_STAR_TILDE] = ACTIONS(837),
    [anon_sym_SLASH_TILDE] = ACTIONS(837),
    [anon_sym_PERCENT_TILDE] = ACTIONS(837),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(837),
    [anon_sym_LT_LT_TILDE] = ACTIONS(837),
    [anon_sym_GT_GT_TILDE] = ACTIONS(837),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(837),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(837),
    [anon_sym_GT_TILDE] = ACTIONS(837),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(837),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(837),
    [anon_sym_LT_TILDE] = ACTIONS(837),
    [anon_sym_PLUS_QMARK] = ACTIONS(837),
    [anon_sym_DASH_QMARK] = ACTIONS(837),
    [anon_sym_STAR_QMARK] = ACTIONS(837),
    [anon_sym_SLASH_QMARK] = ACTIONS(837),
    [anon_sym_PERCENT_QMARK] = ACTIONS(837),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(837),
    [anon_sym_as] = ACTIONS(837),
    [anon_sym_LPAREN2] = ACTIONS(837),
    [anon_sym_DOT_GT] = ACTIONS(837),
    [anon_sym_where] = ACTIONS(837),
    [anon_sym_TILDE] = ACTIONS(837),
    [anon_sym_end] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_ifdef] = ACTIONS(837),
    [anon_sym_then] = ACTIONS(837),
    [anon_sym_iftype] = ACTIONS(837),
    [anon_sym_else] = ACTIONS(837),
    [anon_sym_for] = ACTIONS(837),
    [anon_sym_while] = ACTIONS(837),
    [anon_sym_try] = ACTIONS(837),
    [anon_sym_with] = ACTIONS(837),
    [anon_sym_repeat] = ACTIONS(837),
    [anon_sym_until] = ACTIONS(837),
    [anon_sym_do] = ACTIONS(837),
    [anon_sym_recover] = ACTIONS(837),
    [anon_sym_match] = ACTIONS(837),
    [anon_sym_return] = ACTIONS(837),
    [anon_sym_continue] = ACTIONS(837),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_consume] = ACTIONS(837),
    [anon_sym_object] = ACTIONS(837),
    [sym_number] = ACTIONS(839),
    [sym_float] = ACTIONS(837),
    [anon_sym_DQUOTE] = ACTIONS(839),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(837),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_true] = ACTIONS(837),
    [anon_sym_false] = ACTIONS(837),
    [sym_this] = ACTIONS(837),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [168] = {
    [sym_capability] = STATE(414),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(861),
    [anon_sym_RBRACK] = ACTIONS(861),
    [anon_sym_is] = ACTIONS(863),
    [anon_sym_embed] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_var] = ACTIONS(861),
    [anon_sym_new] = ACTIONS(861),
    [anon_sym_EQ_GT] = ACTIONS(861),
    [anon_sym_fun] = ACTIONS(861),
    [anon_sym_be] = ACTIONS(861),
    [anon_sym_COMMA] = ACTIONS(861),
    [anon_sym_iso] = ACTIONS(967),
    [anon_sym_trn] = ACTIONS(967),
    [anon_sym_ref] = ACTIONS(967),
    [anon_sym_val] = ACTIONS(967),
    [anon_sym_box] = ACTIONS(967),
    [anon_sym_tag] = ACTIONS(967),
    [anon_sym_LPAREN] = ACTIONS(863),
    [anon_sym_RPAREN] = ACTIONS(861),
    [anon_sym_DOT] = ACTIONS(863),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_LBRACE] = ACTIONS(861),
    [anon_sym_RBRACE] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(861),
    [sym_error] = ACTIONS(861),
    [sym_compile_intrinsic] = ACTIONS(861),
    [anon_sym_compile_error] = ACTIONS(861),
    [sym_location] = ACTIONS(861),
    [anon_sym_DASH] = ACTIONS(863),
    [anon_sym_not] = ACTIONS(861),
    [anon_sym_DASH_TILDE] = ACTIONS(861),
    [anon_sym_addressof] = ACTIONS(861),
    [anon_sym_digestof] = ACTIONS(861),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_STAR] = ACTIONS(863),
    [anon_sym_SLASH] = ACTIONS(863),
    [anon_sym_PERCENT] = ACTIONS(863),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(863),
    [anon_sym_LT_LT] = ACTIONS(863),
    [anon_sym_GT_GT] = ACTIONS(863),
    [anon_sym_and] = ACTIONS(861),
    [anon_sym_or] = ACTIONS(861),
    [anon_sym_xor] = ACTIONS(861),
    [anon_sym_isnt] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(863),
    [anon_sym_BANG_EQ] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(863),
    [anon_sym_GT_EQ] = ACTIONS(863),
    [anon_sym_LT_EQ] = ACTIONS(863),
    [anon_sym_LT] = ACTIONS(863),
    [anon_sym_PLUS_TILDE] = ACTIONS(861),
    [anon_sym_STAR_TILDE] = ACTIONS(861),
    [anon_sym_SLASH_TILDE] = ACTIONS(861),
    [anon_sym_PERCENT_TILDE] = ACTIONS(861),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(861),
    [anon_sym_LT_LT_TILDE] = ACTIONS(861),
    [anon_sym_GT_GT_TILDE] = ACTIONS(861),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(861),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(861),
    [anon_sym_GT_TILDE] = ACTIONS(861),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(861),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(861),
    [anon_sym_LT_TILDE] = ACTIONS(861),
    [anon_sym_PLUS_QMARK] = ACTIONS(861),
    [anon_sym_DASH_QMARK] = ACTIONS(861),
    [anon_sym_STAR_QMARK] = ACTIONS(861),
    [anon_sym_SLASH_QMARK] = ACTIONS(861),
    [anon_sym_PERCENT_QMARK] = ACTIONS(861),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(861),
    [anon_sym_as] = ACTIONS(861),
    [anon_sym_LPAREN2] = ACTIONS(861),
    [anon_sym_DOT_GT] = ACTIONS(861),
    [anon_sym_where] = ACTIONS(861),
    [anon_sym_TILDE] = ACTIONS(861),
    [anon_sym_end] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(863),
    [anon_sym_ifdef] = ACTIONS(861),
    [anon_sym_then] = ACTIONS(861),
    [anon_sym_iftype] = ACTIONS(861),
    [anon_sym_else] = ACTIONS(861),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_while] = ACTIONS(861),
    [anon_sym_try] = ACTIONS(861),
    [anon_sym_with] = ACTIONS(861),
    [anon_sym_repeat] = ACTIONS(861),
    [anon_sym_until] = ACTIONS(861),
    [anon_sym_do] = ACTIONS(861),
    [anon_sym_recover] = ACTIONS(861),
    [anon_sym_match] = ACTIONS(861),
    [anon_sym_return] = ACTIONS(861),
    [anon_sym_continue] = ACTIONS(861),
    [anon_sym_break] = ACTIONS(861),
    [anon_sym_consume] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [sym_number] = ACTIONS(863),
    [sym_float] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(863),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(861),
    [anon_sym_SQUOTE] = ACTIONS(861),
    [anon_sym_true] = ACTIONS(861),
    [anon_sym_false] = ACTIONS(861),
    [sym_this] = ACTIONS(861),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [169] = {
    [sym_capability] = STATE(368),
    [sym_identifier] = ACTIONS(833),
    [anon_sym_EQ] = ACTIONS(833),
    [anon_sym_AT] = ACTIONS(831),
    [anon_sym_LBRACK] = ACTIONS(831),
    [anon_sym_RBRACK] = ACTIONS(831),
    [anon_sym_is] = ACTIONS(833),
    [anon_sym_embed] = ACTIONS(831),
    [anon_sym_let] = ACTIONS(831),
    [anon_sym_var] = ACTIONS(831),
    [anon_sym_new] = ACTIONS(831),
    [anon_sym_EQ_GT] = ACTIONS(831),
    [anon_sym_fun] = ACTIONS(831),
    [anon_sym_be] = ACTIONS(831),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_iso] = ACTIONS(967),
    [anon_sym_trn] = ACTIONS(967),
    [anon_sym_ref] = ACTIONS(967),
    [anon_sym_val] = ACTIONS(967),
    [anon_sym_box] = ACTIONS(967),
    [anon_sym_tag] = ACTIONS(967),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_RPAREN] = ACTIONS(831),
    [anon_sym_DOT] = ACTIONS(833),
    [anon_sym_PIPE] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(831),
    [anon_sym_RBRACE] = ACTIONS(831),
    [anon_sym_SEMI] = ACTIONS(831),
    [sym_error] = ACTIONS(831),
    [sym_compile_intrinsic] = ACTIONS(831),
    [anon_sym_compile_error] = ACTIONS(831),
    [sym_location] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_not] = ACTIONS(831),
    [anon_sym_DASH_TILDE] = ACTIONS(831),
    [anon_sym_addressof] = ACTIONS(831),
    [anon_sym_digestof] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_STAR] = ACTIONS(833),
    [anon_sym_SLASH] = ACTIONS(833),
    [anon_sym_PERCENT] = ACTIONS(833),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(833),
    [anon_sym_LT_LT] = ACTIONS(833),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_and] = ACTIONS(831),
    [anon_sym_or] = ACTIONS(831),
    [anon_sym_xor] = ACTIONS(831),
    [anon_sym_isnt] = ACTIONS(831),
    [anon_sym_EQ_EQ] = ACTIONS(833),
    [anon_sym_BANG_EQ] = ACTIONS(833),
    [anon_sym_GT] = ACTIONS(833),
    [anon_sym_GT_EQ] = ACTIONS(833),
    [anon_sym_LT_EQ] = ACTIONS(833),
    [anon_sym_LT] = ACTIONS(833),
    [anon_sym_PLUS_TILDE] = ACTIONS(831),
    [anon_sym_STAR_TILDE] = ACTIONS(831),
    [anon_sym_SLASH_TILDE] = ACTIONS(831),
    [anon_sym_PERCENT_TILDE] = ACTIONS(831),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(831),
    [anon_sym_LT_LT_TILDE] = ACTIONS(831),
    [anon_sym_GT_GT_TILDE] = ACTIONS(831),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(831),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(831),
    [anon_sym_GT_TILDE] = ACTIONS(831),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(831),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(831),
    [anon_sym_LT_TILDE] = ACTIONS(831),
    [anon_sym_PLUS_QMARK] = ACTIONS(831),
    [anon_sym_DASH_QMARK] = ACTIONS(831),
    [anon_sym_STAR_QMARK] = ACTIONS(831),
    [anon_sym_SLASH_QMARK] = ACTIONS(831),
    [anon_sym_PERCENT_QMARK] = ACTIONS(831),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(831),
    [anon_sym_as] = ACTIONS(831),
    [anon_sym_LPAREN2] = ACTIONS(831),
    [anon_sym_DOT_GT] = ACTIONS(831),
    [anon_sym_where] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(831),
    [anon_sym_end] = ACTIONS(831),
    [anon_sym_if] = ACTIONS(833),
    [anon_sym_ifdef] = ACTIONS(831),
    [anon_sym_then] = ACTIONS(831),
    [anon_sym_iftype] = ACTIONS(831),
    [anon_sym_else] = ACTIONS(831),
    [anon_sym_for] = ACTIONS(831),
    [anon_sym_while] = ACTIONS(831),
    [anon_sym_try] = ACTIONS(831),
    [anon_sym_with] = ACTIONS(831),
    [anon_sym_repeat] = ACTIONS(831),
    [anon_sym_until] = ACTIONS(831),
    [anon_sym_do] = ACTIONS(831),
    [anon_sym_recover] = ACTIONS(831),
    [anon_sym_match] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_continue] = ACTIONS(831),
    [anon_sym_break] = ACTIONS(831),
    [anon_sym_consume] = ACTIONS(831),
    [anon_sym_object] = ACTIONS(831),
    [sym_number] = ACTIONS(833),
    [sym_float] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(831),
    [anon_sym_SQUOTE] = ACTIONS(831),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_this] = ACTIONS(831),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [170] = {
    [sym_capability] = STATE(343),
    [sym_identifier] = ACTIONS(843),
    [anon_sym_EQ] = ACTIONS(843),
    [anon_sym_AT] = ACTIONS(841),
    [anon_sym_LBRACK] = ACTIONS(841),
    [anon_sym_RBRACK] = ACTIONS(841),
    [anon_sym_is] = ACTIONS(843),
    [anon_sym_embed] = ACTIONS(841),
    [anon_sym_let] = ACTIONS(841),
    [anon_sym_var] = ACTIONS(841),
    [anon_sym_new] = ACTIONS(841),
    [anon_sym_EQ_GT] = ACTIONS(841),
    [anon_sym_fun] = ACTIONS(841),
    [anon_sym_be] = ACTIONS(841),
    [anon_sym_COMMA] = ACTIONS(841),
    [anon_sym_iso] = ACTIONS(967),
    [anon_sym_trn] = ACTIONS(967),
    [anon_sym_ref] = ACTIONS(967),
    [anon_sym_val] = ACTIONS(967),
    [anon_sym_box] = ACTIONS(967),
    [anon_sym_tag] = ACTIONS(967),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_RPAREN] = ACTIONS(841),
    [anon_sym_DOT] = ACTIONS(843),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(841),
    [anon_sym_RBRACE] = ACTIONS(841),
    [anon_sym_SEMI] = ACTIONS(841),
    [sym_error] = ACTIONS(841),
    [sym_compile_intrinsic] = ACTIONS(841),
    [anon_sym_compile_error] = ACTIONS(841),
    [sym_location] = ACTIONS(841),
    [anon_sym_DASH] = ACTIONS(843),
    [anon_sym_not] = ACTIONS(841),
    [anon_sym_DASH_TILDE] = ACTIONS(841),
    [anon_sym_addressof] = ACTIONS(841),
    [anon_sym_digestof] = ACTIONS(841),
    [anon_sym_PLUS] = ACTIONS(843),
    [anon_sym_STAR] = ACTIONS(843),
    [anon_sym_SLASH] = ACTIONS(843),
    [anon_sym_PERCENT] = ACTIONS(843),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(843),
    [anon_sym_LT_LT] = ACTIONS(843),
    [anon_sym_GT_GT] = ACTIONS(843),
    [anon_sym_and] = ACTIONS(841),
    [anon_sym_or] = ACTIONS(841),
    [anon_sym_xor] = ACTIONS(841),
    [anon_sym_isnt] = ACTIONS(841),
    [anon_sym_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(843),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_PLUS_TILDE] = ACTIONS(841),
    [anon_sym_STAR_TILDE] = ACTIONS(841),
    [anon_sym_SLASH_TILDE] = ACTIONS(841),
    [anon_sym_PERCENT_TILDE] = ACTIONS(841),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(841),
    [anon_sym_LT_LT_TILDE] = ACTIONS(841),
    [anon_sym_GT_GT_TILDE] = ACTIONS(841),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(841),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(841),
    [anon_sym_GT_TILDE] = ACTIONS(841),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(841),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(841),
    [anon_sym_LT_TILDE] = ACTIONS(841),
    [anon_sym_PLUS_QMARK] = ACTIONS(841),
    [anon_sym_DASH_QMARK] = ACTIONS(841),
    [anon_sym_STAR_QMARK] = ACTIONS(841),
    [anon_sym_SLASH_QMARK] = ACTIONS(841),
    [anon_sym_PERCENT_QMARK] = ACTIONS(841),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(841),
    [anon_sym_as] = ACTIONS(841),
    [anon_sym_LPAREN2] = ACTIONS(841),
    [anon_sym_DOT_GT] = ACTIONS(841),
    [anon_sym_where] = ACTIONS(841),
    [anon_sym_TILDE] = ACTIONS(841),
    [anon_sym_end] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_ifdef] = ACTIONS(841),
    [anon_sym_then] = ACTIONS(841),
    [anon_sym_iftype] = ACTIONS(841),
    [anon_sym_else] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(841),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_with] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(841),
    [anon_sym_until] = ACTIONS(841),
    [anon_sym_do] = ACTIONS(841),
    [anon_sym_recover] = ACTIONS(841),
    [anon_sym_match] = ACTIONS(841),
    [anon_sym_return] = ACTIONS(841),
    [anon_sym_continue] = ACTIONS(841),
    [anon_sym_break] = ACTIONS(841),
    [anon_sym_consume] = ACTIONS(841),
    [anon_sym_object] = ACTIONS(841),
    [sym_number] = ACTIONS(843),
    [sym_float] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(843),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(841),
    [anon_sym_SQUOTE] = ACTIONS(841),
    [anon_sym_true] = ACTIONS(841),
    [anon_sym_false] = ACTIONS(841),
    [sym_this] = ACTIONS(841),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [171] = {
    [sym_capability] = STATE(365),
    [sym_identifier] = ACTIONS(847),
    [anon_sym_EQ] = ACTIONS(847),
    [anon_sym_AT] = ACTIONS(845),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(845),
    [anon_sym_is] = ACTIONS(847),
    [anon_sym_embed] = ACTIONS(845),
    [anon_sym_let] = ACTIONS(845),
    [anon_sym_var] = ACTIONS(845),
    [anon_sym_new] = ACTIONS(845),
    [anon_sym_EQ_GT] = ACTIONS(845),
    [anon_sym_fun] = ACTIONS(845),
    [anon_sym_be] = ACTIONS(845),
    [anon_sym_COMMA] = ACTIONS(845),
    [anon_sym_iso] = ACTIONS(967),
    [anon_sym_trn] = ACTIONS(967),
    [anon_sym_ref] = ACTIONS(967),
    [anon_sym_val] = ACTIONS(967),
    [anon_sym_box] = ACTIONS(967),
    [anon_sym_tag] = ACTIONS(967),
    [anon_sym_LPAREN] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(845),
    [anon_sym_DOT] = ACTIONS(847),
    [anon_sym_PIPE] = ACTIONS(845),
    [anon_sym_LBRACE] = ACTIONS(845),
    [anon_sym_RBRACE] = ACTIONS(845),
    [anon_sym_SEMI] = ACTIONS(845),
    [sym_error] = ACTIONS(845),
    [sym_compile_intrinsic] = ACTIONS(845),
    [anon_sym_compile_error] = ACTIONS(845),
    [sym_location] = ACTIONS(845),
    [anon_sym_DASH] = ACTIONS(847),
    [anon_sym_not] = ACTIONS(845),
    [anon_sym_DASH_TILDE] = ACTIONS(845),
    [anon_sym_addressof] = ACTIONS(845),
    [anon_sym_digestof] = ACTIONS(845),
    [anon_sym_PLUS] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(847),
    [anon_sym_SLASH] = ACTIONS(847),
    [anon_sym_PERCENT] = ACTIONS(847),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(847),
    [anon_sym_LT_LT] = ACTIONS(847),
    [anon_sym_GT_GT] = ACTIONS(847),
    [anon_sym_and] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(845),
    [anon_sym_xor] = ACTIONS(845),
    [anon_sym_isnt] = ACTIONS(845),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_GT_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(847),
    [anon_sym_PLUS_TILDE] = ACTIONS(845),
    [anon_sym_STAR_TILDE] = ACTIONS(845),
    [anon_sym_SLASH_TILDE] = ACTIONS(845),
    [anon_sym_PERCENT_TILDE] = ACTIONS(845),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(845),
    [anon_sym_LT_LT_TILDE] = ACTIONS(845),
    [anon_sym_GT_GT_TILDE] = ACTIONS(845),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(845),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(845),
    [anon_sym_GT_TILDE] = ACTIONS(845),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(845),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(845),
    [anon_sym_LT_TILDE] = ACTIONS(845),
    [anon_sym_PLUS_QMARK] = ACTIONS(845),
    [anon_sym_DASH_QMARK] = ACTIONS(845),
    [anon_sym_STAR_QMARK] = ACTIONS(845),
    [anon_sym_SLASH_QMARK] = ACTIONS(845),
    [anon_sym_PERCENT_QMARK] = ACTIONS(845),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(845),
    [anon_sym_as] = ACTIONS(845),
    [anon_sym_LPAREN2] = ACTIONS(845),
    [anon_sym_DOT_GT] = ACTIONS(845),
    [anon_sym_where] = ACTIONS(845),
    [anon_sym_TILDE] = ACTIONS(845),
    [anon_sym_end] = ACTIONS(845),
    [anon_sym_if] = ACTIONS(847),
    [anon_sym_ifdef] = ACTIONS(845),
    [anon_sym_then] = ACTIONS(845),
    [anon_sym_iftype] = ACTIONS(845),
    [anon_sym_else] = ACTIONS(845),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(845),
    [anon_sym_try] = ACTIONS(845),
    [anon_sym_with] = ACTIONS(845),
    [anon_sym_repeat] = ACTIONS(845),
    [anon_sym_until] = ACTIONS(845),
    [anon_sym_do] = ACTIONS(845),
    [anon_sym_recover] = ACTIONS(845),
    [anon_sym_match] = ACTIONS(845),
    [anon_sym_return] = ACTIONS(845),
    [anon_sym_continue] = ACTIONS(845),
    [anon_sym_break] = ACTIONS(845),
    [anon_sym_consume] = ACTIONS(845),
    [anon_sym_object] = ACTIONS(845),
    [sym_number] = ACTIONS(847),
    [sym_float] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(845),
    [anon_sym_SQUOTE] = ACTIONS(845),
    [anon_sym_true] = ACTIONS(845),
    [anon_sym_false] = ACTIONS(845),
    [sym_this] = ACTIONS(845),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [172] = {
    [sym_capability] = STATE(360),
    [sym_identifier] = ACTIONS(851),
    [anon_sym_EQ] = ACTIONS(851),
    [anon_sym_AT] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(849),
    [anon_sym_RBRACK] = ACTIONS(849),
    [anon_sym_is] = ACTIONS(851),
    [anon_sym_embed] = ACTIONS(849),
    [anon_sym_let] = ACTIONS(849),
    [anon_sym_var] = ACTIONS(849),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_EQ_GT] = ACTIONS(849),
    [anon_sym_fun] = ACTIONS(849),
    [anon_sym_be] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(849),
    [anon_sym_iso] = ACTIONS(967),
    [anon_sym_trn] = ACTIONS(967),
    [anon_sym_ref] = ACTIONS(967),
    [anon_sym_val] = ACTIONS(967),
    [anon_sym_box] = ACTIONS(967),
    [anon_sym_tag] = ACTIONS(967),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_RPAREN] = ACTIONS(849),
    [anon_sym_DOT] = ACTIONS(851),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_LBRACE] = ACTIONS(849),
    [anon_sym_RBRACE] = ACTIONS(849),
    [anon_sym_SEMI] = ACTIONS(849),
    [sym_error] = ACTIONS(849),
    [sym_compile_intrinsic] = ACTIONS(849),
    [anon_sym_compile_error] = ACTIONS(849),
    [sym_location] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_not] = ACTIONS(849),
    [anon_sym_DASH_TILDE] = ACTIONS(849),
    [anon_sym_addressof] = ACTIONS(849),
    [anon_sym_digestof] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(851),
    [anon_sym_SLASH] = ACTIONS(851),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(851),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_GT_GT] = ACTIONS(851),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_isnt] = ACTIONS(849),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(851),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_LT] = ACTIONS(851),
    [anon_sym_PLUS_TILDE] = ACTIONS(849),
    [anon_sym_STAR_TILDE] = ACTIONS(849),
    [anon_sym_SLASH_TILDE] = ACTIONS(849),
    [anon_sym_PERCENT_TILDE] = ACTIONS(849),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(849),
    [anon_sym_LT_LT_TILDE] = ACTIONS(849),
    [anon_sym_GT_GT_TILDE] = ACTIONS(849),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(849),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(849),
    [anon_sym_GT_TILDE] = ACTIONS(849),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(849),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(849),
    [anon_sym_LT_TILDE] = ACTIONS(849),
    [anon_sym_PLUS_QMARK] = ACTIONS(849),
    [anon_sym_DASH_QMARK] = ACTIONS(849),
    [anon_sym_STAR_QMARK] = ACTIONS(849),
    [anon_sym_SLASH_QMARK] = ACTIONS(849),
    [anon_sym_PERCENT_QMARK] = ACTIONS(849),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(849),
    [anon_sym_as] = ACTIONS(849),
    [anon_sym_LPAREN2] = ACTIONS(849),
    [anon_sym_DOT_GT] = ACTIONS(849),
    [anon_sym_where] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(849),
    [anon_sym_end] = ACTIONS(849),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_ifdef] = ACTIONS(849),
    [anon_sym_then] = ACTIONS(849),
    [anon_sym_iftype] = ACTIONS(849),
    [anon_sym_else] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(849),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_try] = ACTIONS(849),
    [anon_sym_with] = ACTIONS(849),
    [anon_sym_repeat] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_do] = ACTIONS(849),
    [anon_sym_recover] = ACTIONS(849),
    [anon_sym_match] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_continue] = ACTIONS(849),
    [anon_sym_break] = ACTIONS(849),
    [anon_sym_consume] = ACTIONS(849),
    [anon_sym_object] = ACTIONS(849),
    [sym_number] = ACTIONS(851),
    [sym_float] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(851),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(849),
    [anon_sym_SQUOTE] = ACTIONS(849),
    [anon_sym_true] = ACTIONS(849),
    [anon_sym_false] = ACTIONS(849),
    [sym_this] = ACTIONS(849),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [173] = {
    [sym_capability] = STATE(355),
    [sym_identifier] = ACTIONS(867),
    [anon_sym_EQ] = ACTIONS(867),
    [anon_sym_AT] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(865),
    [anon_sym_RBRACK] = ACTIONS(865),
    [anon_sym_is] = ACTIONS(867),
    [anon_sym_embed] = ACTIONS(865),
    [anon_sym_let] = ACTIONS(865),
    [anon_sym_var] = ACTIONS(865),
    [anon_sym_new] = ACTIONS(865),
    [anon_sym_EQ_GT] = ACTIONS(865),
    [anon_sym_fun] = ACTIONS(865),
    [anon_sym_be] = ACTIONS(865),
    [anon_sym_COMMA] = ACTIONS(865),
    [anon_sym_iso] = ACTIONS(967),
    [anon_sym_trn] = ACTIONS(967),
    [anon_sym_ref] = ACTIONS(967),
    [anon_sym_val] = ACTIONS(967),
    [anon_sym_box] = ACTIONS(967),
    [anon_sym_tag] = ACTIONS(967),
    [anon_sym_LPAREN] = ACTIONS(867),
    [anon_sym_RPAREN] = ACTIONS(865),
    [anon_sym_DOT] = ACTIONS(867),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(865),
    [anon_sym_SEMI] = ACTIONS(865),
    [sym_error] = ACTIONS(865),
    [sym_compile_intrinsic] = ACTIONS(865),
    [anon_sym_compile_error] = ACTIONS(865),
    [sym_location] = ACTIONS(865),
    [anon_sym_DASH] = ACTIONS(867),
    [anon_sym_not] = ACTIONS(865),
    [anon_sym_DASH_TILDE] = ACTIONS(865),
    [anon_sym_addressof] = ACTIONS(865),
    [anon_sym_digestof] = ACTIONS(865),
    [anon_sym_PLUS] = ACTIONS(867),
    [anon_sym_STAR] = ACTIONS(867),
    [anon_sym_SLASH] = ACTIONS(867),
    [anon_sym_PERCENT] = ACTIONS(867),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(867),
    [anon_sym_LT_LT] = ACTIONS(867),
    [anon_sym_GT_GT] = ACTIONS(867),
    [anon_sym_and] = ACTIONS(865),
    [anon_sym_or] = ACTIONS(865),
    [anon_sym_xor] = ACTIONS(865),
    [anon_sym_isnt] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(867),
    [anon_sym_BANG_EQ] = ACTIONS(867),
    [anon_sym_GT] = ACTIONS(867),
    [anon_sym_GT_EQ] = ACTIONS(867),
    [anon_sym_LT_EQ] = ACTIONS(867),
    [anon_sym_LT] = ACTIONS(867),
    [anon_sym_PLUS_TILDE] = ACTIONS(865),
    [anon_sym_STAR_TILDE] = ACTIONS(865),
    [anon_sym_SLASH_TILDE] = ACTIONS(865),
    [anon_sym_PERCENT_TILDE] = ACTIONS(865),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(865),
    [anon_sym_LT_LT_TILDE] = ACTIONS(865),
    [anon_sym_GT_GT_TILDE] = ACTIONS(865),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(865),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(865),
    [anon_sym_GT_TILDE] = ACTIONS(865),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(865),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(865),
    [anon_sym_LT_TILDE] = ACTIONS(865),
    [anon_sym_PLUS_QMARK] = ACTIONS(865),
    [anon_sym_DASH_QMARK] = ACTIONS(865),
    [anon_sym_STAR_QMARK] = ACTIONS(865),
    [anon_sym_SLASH_QMARK] = ACTIONS(865),
    [anon_sym_PERCENT_QMARK] = ACTIONS(865),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(865),
    [anon_sym_LPAREN2] = ACTIONS(865),
    [anon_sym_DOT_GT] = ACTIONS(865),
    [anon_sym_where] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [anon_sym_end] = ACTIONS(865),
    [anon_sym_if] = ACTIONS(867),
    [anon_sym_ifdef] = ACTIONS(865),
    [anon_sym_then] = ACTIONS(865),
    [anon_sym_iftype] = ACTIONS(865),
    [anon_sym_else] = ACTIONS(865),
    [anon_sym_for] = ACTIONS(865),
    [anon_sym_while] = ACTIONS(865),
    [anon_sym_try] = ACTIONS(865),
    [anon_sym_with] = ACTIONS(865),
    [anon_sym_repeat] = ACTIONS(865),
    [anon_sym_until] = ACTIONS(865),
    [anon_sym_do] = ACTIONS(865),
    [anon_sym_recover] = ACTIONS(865),
    [anon_sym_match] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(865),
    [anon_sym_continue] = ACTIONS(865),
    [anon_sym_break] = ACTIONS(865),
    [anon_sym_consume] = ACTIONS(865),
    [anon_sym_object] = ACTIONS(865),
    [sym_number] = ACTIONS(867),
    [sym_float] = ACTIONS(865),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(865),
    [anon_sym_false] = ACTIONS(865),
    [sym_this] = ACTIONS(865),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [174] = {
    [sym_capability] = STATE(393),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_EQ] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_RBRACK] = ACTIONS(873),
    [anon_sym_is] = ACTIONS(875),
    [anon_sym_embed] = ACTIONS(873),
    [anon_sym_let] = ACTIONS(873),
    [anon_sym_var] = ACTIONS(873),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_EQ_GT] = ACTIONS(873),
    [anon_sym_fun] = ACTIONS(873),
    [anon_sym_be] = ACTIONS(873),
    [anon_sym_COMMA] = ACTIONS(873),
    [anon_sym_iso] = ACTIONS(967),
    [anon_sym_trn] = ACTIONS(967),
    [anon_sym_ref] = ACTIONS(967),
    [anon_sym_val] = ACTIONS(967),
    [anon_sym_box] = ACTIONS(967),
    [anon_sym_tag] = ACTIONS(967),
    [anon_sym_LPAREN] = ACTIONS(875),
    [anon_sym_RPAREN] = ACTIONS(873),
    [anon_sym_DOT] = ACTIONS(875),
    [anon_sym_PIPE] = ACTIONS(873),
    [anon_sym_LBRACE] = ACTIONS(873),
    [anon_sym_RBRACE] = ACTIONS(873),
    [anon_sym_SEMI] = ACTIONS(873),
    [sym_error] = ACTIONS(873),
    [sym_compile_intrinsic] = ACTIONS(873),
    [anon_sym_compile_error] = ACTIONS(873),
    [sym_location] = ACTIONS(873),
    [anon_sym_DASH] = ACTIONS(875),
    [anon_sym_not] = ACTIONS(873),
    [anon_sym_DASH_TILDE] = ACTIONS(873),
    [anon_sym_addressof] = ACTIONS(873),
    [anon_sym_digestof] = ACTIONS(873),
    [anon_sym_PLUS] = ACTIONS(875),
    [anon_sym_STAR] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(875),
    [anon_sym_PERCENT] = ACTIONS(875),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(875),
    [anon_sym_LT_LT] = ACTIONS(875),
    [anon_sym_GT_GT] = ACTIONS(875),
    [anon_sym_and] = ACTIONS(873),
    [anon_sym_or] = ACTIONS(873),
    [anon_sym_xor] = ACTIONS(873),
    [anon_sym_isnt] = ACTIONS(873),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_BANG_EQ] = ACTIONS(875),
    [anon_sym_GT] = ACTIONS(875),
    [anon_sym_GT_EQ] = ACTIONS(875),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(875),
    [anon_sym_PLUS_TILDE] = ACTIONS(873),
    [anon_sym_STAR_TILDE] = ACTIONS(873),
    [anon_sym_SLASH_TILDE] = ACTIONS(873),
    [anon_sym_PERCENT_TILDE] = ACTIONS(873),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(873),
    [anon_sym_LT_LT_TILDE] = ACTIONS(873),
    [anon_sym_GT_GT_TILDE] = ACTIONS(873),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(873),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(873),
    [anon_sym_GT_TILDE] = ACTIONS(873),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(873),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(873),
    [anon_sym_LT_TILDE] = ACTIONS(873),
    [anon_sym_PLUS_QMARK] = ACTIONS(873),
    [anon_sym_DASH_QMARK] = ACTIONS(873),
    [anon_sym_STAR_QMARK] = ACTIONS(873),
    [anon_sym_SLASH_QMARK] = ACTIONS(873),
    [anon_sym_PERCENT_QMARK] = ACTIONS(873),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(873),
    [anon_sym_as] = ACTIONS(873),
    [anon_sym_LPAREN2] = ACTIONS(873),
    [anon_sym_DOT_GT] = ACTIONS(873),
    [anon_sym_where] = ACTIONS(873),
    [anon_sym_TILDE] = ACTIONS(873),
    [anon_sym_end] = ACTIONS(873),
    [anon_sym_if] = ACTIONS(875),
    [anon_sym_ifdef] = ACTIONS(873),
    [anon_sym_then] = ACTIONS(873),
    [anon_sym_iftype] = ACTIONS(873),
    [anon_sym_else] = ACTIONS(873),
    [anon_sym_for] = ACTIONS(873),
    [anon_sym_while] = ACTIONS(873),
    [anon_sym_try] = ACTIONS(873),
    [anon_sym_with] = ACTIONS(873),
    [anon_sym_repeat] = ACTIONS(873),
    [anon_sym_until] = ACTIONS(873),
    [anon_sym_do] = ACTIONS(873),
    [anon_sym_recover] = ACTIONS(873),
    [anon_sym_match] = ACTIONS(873),
    [anon_sym_return] = ACTIONS(873),
    [anon_sym_continue] = ACTIONS(873),
    [anon_sym_break] = ACTIONS(873),
    [anon_sym_consume] = ACTIONS(873),
    [anon_sym_object] = ACTIONS(873),
    [sym_number] = ACTIONS(875),
    [sym_float] = ACTIONS(873),
    [anon_sym_DQUOTE] = ACTIONS(875),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(873),
    [anon_sym_SQUOTE] = ACTIONS(873),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [sym_this] = ACTIONS(873),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [175] = {
    [sym_capability] = STATE(405),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_EQ] = ACTIONS(855),
    [anon_sym_AT] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_RBRACK] = ACTIONS(853),
    [anon_sym_is] = ACTIONS(855),
    [anon_sym_embed] = ACTIONS(853),
    [anon_sym_let] = ACTIONS(853),
    [anon_sym_var] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(853),
    [anon_sym_EQ_GT] = ACTIONS(853),
    [anon_sym_fun] = ACTIONS(853),
    [anon_sym_be] = ACTIONS(853),
    [anon_sym_COMMA] = ACTIONS(853),
    [anon_sym_iso] = ACTIONS(967),
    [anon_sym_trn] = ACTIONS(967),
    [anon_sym_ref] = ACTIONS(967),
    [anon_sym_val] = ACTIONS(967),
    [anon_sym_box] = ACTIONS(967),
    [anon_sym_tag] = ACTIONS(967),
    [anon_sym_LPAREN] = ACTIONS(855),
    [anon_sym_RPAREN] = ACTIONS(853),
    [anon_sym_DOT] = ACTIONS(855),
    [anon_sym_PIPE] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(853),
    [anon_sym_RBRACE] = ACTIONS(853),
    [anon_sym_SEMI] = ACTIONS(853),
    [sym_error] = ACTIONS(853),
    [sym_compile_intrinsic] = ACTIONS(853),
    [anon_sym_compile_error] = ACTIONS(853),
    [sym_location] = ACTIONS(853),
    [anon_sym_DASH] = ACTIONS(855),
    [anon_sym_not] = ACTIONS(853),
    [anon_sym_DASH_TILDE] = ACTIONS(853),
    [anon_sym_addressof] = ACTIONS(853),
    [anon_sym_digestof] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_PERCENT] = ACTIONS(855),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(855),
    [anon_sym_LT_LT] = ACTIONS(855),
    [anon_sym_GT_GT] = ACTIONS(855),
    [anon_sym_and] = ACTIONS(853),
    [anon_sym_or] = ACTIONS(853),
    [anon_sym_xor] = ACTIONS(853),
    [anon_sym_isnt] = ACTIONS(853),
    [anon_sym_EQ_EQ] = ACTIONS(855),
    [anon_sym_BANG_EQ] = ACTIONS(855),
    [anon_sym_GT] = ACTIONS(855),
    [anon_sym_GT_EQ] = ACTIONS(855),
    [anon_sym_LT_EQ] = ACTIONS(855),
    [anon_sym_LT] = ACTIONS(855),
    [anon_sym_PLUS_TILDE] = ACTIONS(853),
    [anon_sym_STAR_TILDE] = ACTIONS(853),
    [anon_sym_SLASH_TILDE] = ACTIONS(853),
    [anon_sym_PERCENT_TILDE] = ACTIONS(853),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(853),
    [anon_sym_LT_LT_TILDE] = ACTIONS(853),
    [anon_sym_GT_GT_TILDE] = ACTIONS(853),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(853),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(853),
    [anon_sym_GT_TILDE] = ACTIONS(853),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(853),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(853),
    [anon_sym_LT_TILDE] = ACTIONS(853),
    [anon_sym_PLUS_QMARK] = ACTIONS(853),
    [anon_sym_DASH_QMARK] = ACTIONS(853),
    [anon_sym_STAR_QMARK] = ACTIONS(853),
    [anon_sym_SLASH_QMARK] = ACTIONS(853),
    [anon_sym_PERCENT_QMARK] = ACTIONS(853),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(853),
    [anon_sym_as] = ACTIONS(853),
    [anon_sym_LPAREN2] = ACTIONS(853),
    [anon_sym_DOT_GT] = ACTIONS(853),
    [anon_sym_where] = ACTIONS(853),
    [anon_sym_TILDE] = ACTIONS(853),
    [anon_sym_end] = ACTIONS(853),
    [anon_sym_if] = ACTIONS(855),
    [anon_sym_ifdef] = ACTIONS(853),
    [anon_sym_then] = ACTIONS(853),
    [anon_sym_iftype] = ACTIONS(853),
    [anon_sym_else] = ACTIONS(853),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_while] = ACTIONS(853),
    [anon_sym_try] = ACTIONS(853),
    [anon_sym_with] = ACTIONS(853),
    [anon_sym_repeat] = ACTIONS(853),
    [anon_sym_until] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(853),
    [anon_sym_recover] = ACTIONS(853),
    [anon_sym_match] = ACTIONS(853),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_continue] = ACTIONS(853),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_consume] = ACTIONS(853),
    [anon_sym_object] = ACTIONS(853),
    [sym_number] = ACTIONS(855),
    [sym_float] = ACTIONS(853),
    [anon_sym_DQUOTE] = ACTIONS(855),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(853),
    [anon_sym_true] = ACTIONS(853),
    [anon_sym_false] = ACTIONS(853),
    [sym_this] = ACTIONS(853),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [176] = {
    [aux_sym_union_type_repeat1] = STATE(187),
    [aux_sym_intersection_type_repeat1] = STATE(188),
    [sym_identifier] = ACTIONS(871),
    [anon_sym_EQ] = ACTIONS(871),
    [anon_sym_AT] = ACTIONS(869),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(869),
    [anon_sym_is] = ACTIONS(871),
    [anon_sym_embed] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_var] = ACTIONS(869),
    [anon_sym_new] = ACTIONS(869),
    [anon_sym_EQ_GT] = ACTIONS(869),
    [anon_sym_fun] = ACTIONS(869),
    [anon_sym_be] = ACTIONS(869),
    [anon_sym_COMMA] = ACTIONS(869),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(869),
    [anon_sym_DOT] = ACTIONS(871),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_CARET] = ACTIONS(971),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH_GT] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(869),
    [anon_sym_RBRACE] = ACTIONS(869),
    [anon_sym_SEMI] = ACTIONS(869),
    [sym_error] = ACTIONS(869),
    [sym_compile_intrinsic] = ACTIONS(869),
    [anon_sym_compile_error] = ACTIONS(869),
    [sym_location] = ACTIONS(869),
    [anon_sym_DASH] = ACTIONS(871),
    [anon_sym_not] = ACTIONS(869),
    [anon_sym_DASH_TILDE] = ACTIONS(869),
    [anon_sym_addressof] = ACTIONS(869),
    [anon_sym_digestof] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(871),
    [anon_sym_STAR] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(871),
    [anon_sym_PERCENT] = ACTIONS(871),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(871),
    [anon_sym_LT_LT] = ACTIONS(871),
    [anon_sym_GT_GT] = ACTIONS(871),
    [anon_sym_and] = ACTIONS(869),
    [anon_sym_or] = ACTIONS(869),
    [anon_sym_xor] = ACTIONS(869),
    [anon_sym_isnt] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(871),
    [anon_sym_BANG_EQ] = ACTIONS(871),
    [anon_sym_GT] = ACTIONS(871),
    [anon_sym_GT_EQ] = ACTIONS(871),
    [anon_sym_LT_EQ] = ACTIONS(871),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_PLUS_TILDE] = ACTIONS(869),
    [anon_sym_STAR_TILDE] = ACTIONS(869),
    [anon_sym_SLASH_TILDE] = ACTIONS(869),
    [anon_sym_PERCENT_TILDE] = ACTIONS(869),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(869),
    [anon_sym_LT_LT_TILDE] = ACTIONS(869),
    [anon_sym_GT_GT_TILDE] = ACTIONS(869),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(869),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(869),
    [anon_sym_GT_TILDE] = ACTIONS(869),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(869),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(869),
    [anon_sym_LT_TILDE] = ACTIONS(869),
    [anon_sym_PLUS_QMARK] = ACTIONS(869),
    [anon_sym_DASH_QMARK] = ACTIONS(869),
    [anon_sym_STAR_QMARK] = ACTIONS(869),
    [anon_sym_SLASH_QMARK] = ACTIONS(869),
    [anon_sym_PERCENT_QMARK] = ACTIONS(869),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(869),
    [anon_sym_as] = ACTIONS(869),
    [anon_sym_LPAREN2] = ACTIONS(869),
    [anon_sym_DOT_GT] = ACTIONS(869),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [anon_sym_end] = ACTIONS(869),
    [anon_sym_if] = ACTIONS(871),
    [anon_sym_ifdef] = ACTIONS(869),
    [anon_sym_then] = ACTIONS(869),
    [anon_sym_iftype] = ACTIONS(869),
    [anon_sym_else] = ACTIONS(869),
    [anon_sym_for] = ACTIONS(869),
    [anon_sym_while] = ACTIONS(869),
    [anon_sym_try] = ACTIONS(869),
    [anon_sym_with] = ACTIONS(869),
    [anon_sym_repeat] = ACTIONS(869),
    [anon_sym_until] = ACTIONS(869),
    [anon_sym_do] = ACTIONS(869),
    [anon_sym_recover] = ACTIONS(869),
    [anon_sym_match] = ACTIONS(869),
    [anon_sym_return] = ACTIONS(869),
    [anon_sym_continue] = ACTIONS(869),
    [anon_sym_break] = ACTIONS(869),
    [anon_sym_consume] = ACTIONS(869),
    [anon_sym_object] = ACTIONS(869),
    [sym_number] = ACTIONS(871),
    [sym_float] = ACTIONS(869),
    [anon_sym_DQUOTE] = ACTIONS(871),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(869),
    [anon_sym_SQUOTE] = ACTIONS(869),
    [anon_sym_true] = ACTIONS(869),
    [anon_sym_false] = ACTIONS(869),
    [sym_this] = ACTIONS(869),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [177] = {
    [aux_sym_union_type_repeat1] = STATE(187),
    [aux_sym_intersection_type_repeat1] = STATE(188),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_EQ] = ACTIONS(859),
    [anon_sym_AT] = ACTIONS(857),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(857),
    [anon_sym_is] = ACTIONS(859),
    [anon_sym_embed] = ACTIONS(857),
    [anon_sym_let] = ACTIONS(857),
    [anon_sym_var] = ACTIONS(857),
    [anon_sym_new] = ACTIONS(857),
    [anon_sym_EQ_GT] = ACTIONS(857),
    [anon_sym_fun] = ACTIONS(857),
    [anon_sym_be] = ACTIONS(857),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(857),
    [anon_sym_DOT] = ACTIONS(859),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_CARET] = ACTIONS(971),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH_GT] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(857),
    [anon_sym_RBRACE] = ACTIONS(857),
    [anon_sym_SEMI] = ACTIONS(857),
    [sym_error] = ACTIONS(857),
    [sym_compile_intrinsic] = ACTIONS(857),
    [anon_sym_compile_error] = ACTIONS(857),
    [sym_location] = ACTIONS(857),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_not] = ACTIONS(857),
    [anon_sym_DASH_TILDE] = ACTIONS(857),
    [anon_sym_addressof] = ACTIONS(857),
    [anon_sym_digestof] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(859),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(859),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_and] = ACTIONS(857),
    [anon_sym_or] = ACTIONS(857),
    [anon_sym_xor] = ACTIONS(857),
    [anon_sym_isnt] = ACTIONS(857),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(859),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(859),
    [anon_sym_PLUS_TILDE] = ACTIONS(857),
    [anon_sym_STAR_TILDE] = ACTIONS(857),
    [anon_sym_SLASH_TILDE] = ACTIONS(857),
    [anon_sym_PERCENT_TILDE] = ACTIONS(857),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(857),
    [anon_sym_LT_LT_TILDE] = ACTIONS(857),
    [anon_sym_GT_GT_TILDE] = ACTIONS(857),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(857),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(857),
    [anon_sym_GT_TILDE] = ACTIONS(857),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(857),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(857),
    [anon_sym_LT_TILDE] = ACTIONS(857),
    [anon_sym_PLUS_QMARK] = ACTIONS(857),
    [anon_sym_DASH_QMARK] = ACTIONS(857),
    [anon_sym_STAR_QMARK] = ACTIONS(857),
    [anon_sym_SLASH_QMARK] = ACTIONS(857),
    [anon_sym_PERCENT_QMARK] = ACTIONS(857),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(857),
    [anon_sym_as] = ACTIONS(857),
    [anon_sym_LPAREN2] = ACTIONS(857),
    [anon_sym_DOT_GT] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(857),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_end] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_ifdef] = ACTIONS(857),
    [anon_sym_then] = ACTIONS(857),
    [anon_sym_iftype] = ACTIONS(857),
    [anon_sym_else] = ACTIONS(857),
    [anon_sym_for] = ACTIONS(857),
    [anon_sym_while] = ACTIONS(857),
    [anon_sym_try] = ACTIONS(857),
    [anon_sym_with] = ACTIONS(857),
    [anon_sym_repeat] = ACTIONS(857),
    [anon_sym_until] = ACTIONS(857),
    [anon_sym_do] = ACTIONS(857),
    [anon_sym_recover] = ACTIONS(857),
    [anon_sym_match] = ACTIONS(857),
    [anon_sym_return] = ACTIONS(857),
    [anon_sym_continue] = ACTIONS(857),
    [anon_sym_break] = ACTIONS(857),
    [anon_sym_consume] = ACTIONS(857),
    [anon_sym_object] = ACTIONS(857),
    [sym_number] = ACTIONS(859),
    [sym_float] = ACTIONS(857),
    [anon_sym_DQUOTE] = ACTIONS(859),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(857),
    [anon_sym_SQUOTE] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(857),
    [sym_this] = ACTIONS(857),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [178] = {
    [aux_sym_union_type_repeat1] = STATE(187),
    [aux_sym_intersection_type_repeat1] = STATE(188),
    [sym_identifier] = ACTIONS(819),
    [anon_sym_EQ] = ACTIONS(819),
    [anon_sym_AT] = ACTIONS(817),
    [anon_sym_LBRACK] = ACTIONS(817),
    [anon_sym_RBRACK] = ACTIONS(817),
    [anon_sym_is] = ACTIONS(819),
    [anon_sym_embed] = ACTIONS(817),
    [anon_sym_let] = ACTIONS(817),
    [anon_sym_var] = ACTIONS(817),
    [anon_sym_new] = ACTIONS(817),
    [anon_sym_EQ_GT] = ACTIONS(817),
    [anon_sym_fun] = ACTIONS(817),
    [anon_sym_be] = ACTIONS(817),
    [anon_sym_COMMA] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_RPAREN] = ACTIONS(817),
    [anon_sym_DOT] = ACTIONS(819),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_CARET] = ACTIONS(971),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH_GT] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(817),
    [anon_sym_RBRACE] = ACTIONS(817),
    [anon_sym_SEMI] = ACTIONS(817),
    [sym_error] = ACTIONS(817),
    [sym_compile_intrinsic] = ACTIONS(817),
    [anon_sym_compile_error] = ACTIONS(817),
    [sym_location] = ACTIONS(817),
    [anon_sym_DASH] = ACTIONS(819),
    [anon_sym_not] = ACTIONS(817),
    [anon_sym_DASH_TILDE] = ACTIONS(817),
    [anon_sym_addressof] = ACTIONS(817),
    [anon_sym_digestof] = ACTIONS(817),
    [anon_sym_PLUS] = ACTIONS(819),
    [anon_sym_STAR] = ACTIONS(819),
    [anon_sym_SLASH] = ACTIONS(819),
    [anon_sym_PERCENT] = ACTIONS(819),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(819),
    [anon_sym_LT_LT] = ACTIONS(819),
    [anon_sym_GT_GT] = ACTIONS(819),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_or] = ACTIONS(817),
    [anon_sym_xor] = ACTIONS(817),
    [anon_sym_isnt] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(819),
    [anon_sym_BANG_EQ] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(819),
    [anon_sym_GT_EQ] = ACTIONS(819),
    [anon_sym_LT_EQ] = ACTIONS(819),
    [anon_sym_LT] = ACTIONS(819),
    [anon_sym_PLUS_TILDE] = ACTIONS(817),
    [anon_sym_STAR_TILDE] = ACTIONS(817),
    [anon_sym_SLASH_TILDE] = ACTIONS(817),
    [anon_sym_PERCENT_TILDE] = ACTIONS(817),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(817),
    [anon_sym_LT_LT_TILDE] = ACTIONS(817),
    [anon_sym_GT_GT_TILDE] = ACTIONS(817),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(817),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(817),
    [anon_sym_GT_TILDE] = ACTIONS(817),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(817),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(817),
    [anon_sym_LT_TILDE] = ACTIONS(817),
    [anon_sym_PLUS_QMARK] = ACTIONS(817),
    [anon_sym_DASH_QMARK] = ACTIONS(817),
    [anon_sym_STAR_QMARK] = ACTIONS(817),
    [anon_sym_SLASH_QMARK] = ACTIONS(817),
    [anon_sym_PERCENT_QMARK] = ACTIONS(817),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(817),
    [anon_sym_as] = ACTIONS(817),
    [anon_sym_LPAREN2] = ACTIONS(817),
    [anon_sym_DOT_GT] = ACTIONS(817),
    [anon_sym_where] = ACTIONS(817),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_end] = ACTIONS(817),
    [anon_sym_if] = ACTIONS(819),
    [anon_sym_ifdef] = ACTIONS(817),
    [anon_sym_then] = ACTIONS(817),
    [anon_sym_iftype] = ACTIONS(817),
    [anon_sym_else] = ACTIONS(817),
    [anon_sym_for] = ACTIONS(817),
    [anon_sym_while] = ACTIONS(817),
    [anon_sym_try] = ACTIONS(817),
    [anon_sym_with] = ACTIONS(817),
    [anon_sym_repeat] = ACTIONS(817),
    [anon_sym_until] = ACTIONS(817),
    [anon_sym_do] = ACTIONS(817),
    [anon_sym_recover] = ACTIONS(817),
    [anon_sym_match] = ACTIONS(817),
    [anon_sym_return] = ACTIONS(817),
    [anon_sym_continue] = ACTIONS(817),
    [anon_sym_break] = ACTIONS(817),
    [anon_sym_consume] = ACTIONS(817),
    [anon_sym_object] = ACTIONS(817),
    [sym_number] = ACTIONS(819),
    [sym_float] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(817),
    [anon_sym_false] = ACTIONS(817),
    [sym_this] = ACTIONS(817),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [179] = {
    [aux_sym_union_type_repeat1] = STATE(187),
    [aux_sym_intersection_type_repeat1] = STATE(188),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_EQ] = ACTIONS(879),
    [anon_sym_AT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(877),
    [anon_sym_RBRACK] = ACTIONS(877),
    [anon_sym_is] = ACTIONS(879),
    [anon_sym_embed] = ACTIONS(877),
    [anon_sym_let] = ACTIONS(877),
    [anon_sym_var] = ACTIONS(877),
    [anon_sym_new] = ACTIONS(877),
    [anon_sym_EQ_GT] = ACTIONS(877),
    [anon_sym_fun] = ACTIONS(877),
    [anon_sym_be] = ACTIONS(877),
    [anon_sym_COMMA] = ACTIONS(877),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(877),
    [anon_sym_DOT] = ACTIONS(879),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_CARET] = ACTIONS(971),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH_GT] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(877),
    [anon_sym_RBRACE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(877),
    [sym_error] = ACTIONS(877),
    [sym_compile_intrinsic] = ACTIONS(877),
    [anon_sym_compile_error] = ACTIONS(877),
    [sym_location] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(879),
    [anon_sym_not] = ACTIONS(877),
    [anon_sym_DASH_TILDE] = ACTIONS(877),
    [anon_sym_addressof] = ACTIONS(877),
    [anon_sym_digestof] = ACTIONS(877),
    [anon_sym_PLUS] = ACTIONS(879),
    [anon_sym_STAR] = ACTIONS(879),
    [anon_sym_SLASH] = ACTIONS(879),
    [anon_sym_PERCENT] = ACTIONS(879),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(879),
    [anon_sym_LT_LT] = ACTIONS(879),
    [anon_sym_GT_GT] = ACTIONS(879),
    [anon_sym_and] = ACTIONS(877),
    [anon_sym_or] = ACTIONS(877),
    [anon_sym_xor] = ACTIONS(877),
    [anon_sym_isnt] = ACTIONS(877),
    [anon_sym_EQ_EQ] = ACTIONS(879),
    [anon_sym_BANG_EQ] = ACTIONS(879),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_GT_EQ] = ACTIONS(879),
    [anon_sym_LT_EQ] = ACTIONS(879),
    [anon_sym_LT] = ACTIONS(879),
    [anon_sym_PLUS_TILDE] = ACTIONS(877),
    [anon_sym_STAR_TILDE] = ACTIONS(877),
    [anon_sym_SLASH_TILDE] = ACTIONS(877),
    [anon_sym_PERCENT_TILDE] = ACTIONS(877),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(877),
    [anon_sym_LT_LT_TILDE] = ACTIONS(877),
    [anon_sym_GT_GT_TILDE] = ACTIONS(877),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(877),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(877),
    [anon_sym_GT_TILDE] = ACTIONS(877),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(877),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(877),
    [anon_sym_LT_TILDE] = ACTIONS(877),
    [anon_sym_PLUS_QMARK] = ACTIONS(877),
    [anon_sym_DASH_QMARK] = ACTIONS(877),
    [anon_sym_STAR_QMARK] = ACTIONS(877),
    [anon_sym_SLASH_QMARK] = ACTIONS(877),
    [anon_sym_PERCENT_QMARK] = ACTIONS(877),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(877),
    [anon_sym_as] = ACTIONS(877),
    [anon_sym_LPAREN2] = ACTIONS(877),
    [anon_sym_DOT_GT] = ACTIONS(877),
    [anon_sym_where] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(877),
    [anon_sym_end] = ACTIONS(877),
    [anon_sym_if] = ACTIONS(879),
    [anon_sym_ifdef] = ACTIONS(877),
    [anon_sym_then] = ACTIONS(877),
    [anon_sym_iftype] = ACTIONS(877),
    [anon_sym_else] = ACTIONS(877),
    [anon_sym_for] = ACTIONS(877),
    [anon_sym_while] = ACTIONS(877),
    [anon_sym_try] = ACTIONS(877),
    [anon_sym_with] = ACTIONS(877),
    [anon_sym_repeat] = ACTIONS(877),
    [anon_sym_until] = ACTIONS(877),
    [anon_sym_do] = ACTIONS(877),
    [anon_sym_recover] = ACTIONS(877),
    [anon_sym_match] = ACTIONS(877),
    [anon_sym_return] = ACTIONS(877),
    [anon_sym_continue] = ACTIONS(877),
    [anon_sym_break] = ACTIONS(877),
    [anon_sym_consume] = ACTIONS(877),
    [anon_sym_object] = ACTIONS(877),
    [sym_number] = ACTIONS(879),
    [sym_float] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(877),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(877),
    [sym_this] = ACTIONS(877),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [180] = {
    [aux_sym_union_type_repeat1] = STATE(187),
    [aux_sym_intersection_type_repeat1] = STATE(188),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_EQ] = ACTIONS(883),
    [anon_sym_AT] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(881),
    [anon_sym_RBRACK] = ACTIONS(881),
    [anon_sym_is] = ACTIONS(883),
    [anon_sym_embed] = ACTIONS(881),
    [anon_sym_let] = ACTIONS(881),
    [anon_sym_var] = ACTIONS(881),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_EQ_GT] = ACTIONS(881),
    [anon_sym_fun] = ACTIONS(881),
    [anon_sym_be] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_LPAREN] = ACTIONS(883),
    [anon_sym_RPAREN] = ACTIONS(881),
    [anon_sym_DOT] = ACTIONS(883),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_CARET] = ACTIONS(971),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH_GT] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(881),
    [anon_sym_RBRACE] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(881),
    [sym_error] = ACTIONS(881),
    [sym_compile_intrinsic] = ACTIONS(881),
    [anon_sym_compile_error] = ACTIONS(881),
    [sym_location] = ACTIONS(881),
    [anon_sym_DASH] = ACTIONS(883),
    [anon_sym_not] = ACTIONS(881),
    [anon_sym_DASH_TILDE] = ACTIONS(881),
    [anon_sym_addressof] = ACTIONS(881),
    [anon_sym_digestof] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(883),
    [anon_sym_STAR] = ACTIONS(883),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_PERCENT] = ACTIONS(883),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(881),
    [anon_sym_or] = ACTIONS(881),
    [anon_sym_xor] = ACTIONS(881),
    [anon_sym_isnt] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_PLUS_TILDE] = ACTIONS(881),
    [anon_sym_STAR_TILDE] = ACTIONS(881),
    [anon_sym_SLASH_TILDE] = ACTIONS(881),
    [anon_sym_PERCENT_TILDE] = ACTIONS(881),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(881),
    [anon_sym_LT_LT_TILDE] = ACTIONS(881),
    [anon_sym_GT_GT_TILDE] = ACTIONS(881),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(881),
    [anon_sym_GT_TILDE] = ACTIONS(881),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(881),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(881),
    [anon_sym_LT_TILDE] = ACTIONS(881),
    [anon_sym_PLUS_QMARK] = ACTIONS(881),
    [anon_sym_DASH_QMARK] = ACTIONS(881),
    [anon_sym_STAR_QMARK] = ACTIONS(881),
    [anon_sym_SLASH_QMARK] = ACTIONS(881),
    [anon_sym_PERCENT_QMARK] = ACTIONS(881),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(881),
    [anon_sym_as] = ACTIONS(881),
    [anon_sym_LPAREN2] = ACTIONS(881),
    [anon_sym_DOT_GT] = ACTIONS(881),
    [anon_sym_where] = ACTIONS(881),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_end] = ACTIONS(881),
    [anon_sym_if] = ACTIONS(883),
    [anon_sym_ifdef] = ACTIONS(881),
    [anon_sym_then] = ACTIONS(881),
    [anon_sym_iftype] = ACTIONS(881),
    [anon_sym_else] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(881),
    [anon_sym_while] = ACTIONS(881),
    [anon_sym_try] = ACTIONS(881),
    [anon_sym_with] = ACTIONS(881),
    [anon_sym_repeat] = ACTIONS(881),
    [anon_sym_until] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(881),
    [anon_sym_recover] = ACTIONS(881),
    [anon_sym_match] = ACTIONS(881),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_continue] = ACTIONS(881),
    [anon_sym_break] = ACTIONS(881),
    [anon_sym_consume] = ACTIONS(881),
    [anon_sym_object] = ACTIONS(881),
    [sym_number] = ACTIONS(883),
    [sym_float] = ACTIONS(881),
    [anon_sym_DQUOTE] = ACTIONS(883),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(881),
    [anon_sym_SQUOTE] = ACTIONS(881),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [sym_this] = ACTIONS(881),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [181] = {
    [sym_type_args] = STATE(230),
    [aux_sym_base_type_repeat1] = STATE(185),
    [sym_identifier] = ACTIONS(613),
    [anon_sym_EQ] = ACTIONS(613),
    [anon_sym_AT] = ACTIONS(611),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_is] = ACTIONS(613),
    [anon_sym_let] = ACTIONS(611),
    [anon_sym_var] = ACTIONS(611),
    [anon_sym_iso] = ACTIONS(611),
    [anon_sym_trn] = ACTIONS(611),
    [anon_sym_ref] = ACTIONS(611),
    [anon_sym_val] = ACTIONS(611),
    [anon_sym_box] = ACTIONS(611),
    [anon_sym_tag] = ACTIONS(611),
    [anon_sym_LPAREN] = ACTIONS(613),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_POUNDread] = ACTIONS(611),
    [anon_sym_POUNDsend] = ACTIONS(611),
    [anon_sym_POUNDshare] = ACTIONS(611),
    [anon_sym_POUNDalias] = ACTIONS(611),
    [anon_sym_POUNDany] = ACTIONS(611),
    [anon_sym_BANG] = ACTIONS(613),
    [anon_sym_CARET] = ACTIONS(611),
    [anon_sym_PIPE] = ACTIONS(611),
    [anon_sym_AMP] = ACTIONS(611),
    [anon_sym_DASH_GT] = ACTIONS(611),
    [anon_sym_LBRACE] = ACTIONS(611),
    [anon_sym_SEMI] = ACTIONS(611),
    [sym_error] = ACTIONS(611),
    [sym_compile_intrinsic] = ACTIONS(611),
    [anon_sym_compile_error] = ACTIONS(611),
    [sym_location] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(613),
    [anon_sym_not] = ACTIONS(611),
    [anon_sym_DASH_TILDE] = ACTIONS(611),
    [anon_sym_addressof] = ACTIONS(611),
    [anon_sym_digestof] = ACTIONS(611),
    [anon_sym_PLUS] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(613),
    [anon_sym_SLASH] = ACTIONS(613),
    [anon_sym_PERCENT] = ACTIONS(613),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(613),
    [anon_sym_LT_LT] = ACTIONS(613),
    [anon_sym_GT_GT] = ACTIONS(613),
    [anon_sym_and] = ACTIONS(611),
    [anon_sym_or] = ACTIONS(611),
    [anon_sym_xor] = ACTIONS(611),
    [anon_sym_isnt] = ACTIONS(611),
    [anon_sym_EQ_EQ] = ACTIONS(613),
    [anon_sym_BANG_EQ] = ACTIONS(613),
    [anon_sym_GT] = ACTIONS(613),
    [anon_sym_GT_EQ] = ACTIONS(613),
    [anon_sym_LT_EQ] = ACTIONS(613),
    [anon_sym_LT] = ACTIONS(613),
    [anon_sym_PLUS_TILDE] = ACTIONS(611),
    [anon_sym_STAR_TILDE] = ACTIONS(611),
    [anon_sym_SLASH_TILDE] = ACTIONS(611),
    [anon_sym_PERCENT_TILDE] = ACTIONS(611),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(611),
    [anon_sym_LT_LT_TILDE] = ACTIONS(611),
    [anon_sym_GT_GT_TILDE] = ACTIONS(611),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(611),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(611),
    [anon_sym_GT_TILDE] = ACTIONS(611),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(611),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(611),
    [anon_sym_LT_TILDE] = ACTIONS(611),
    [anon_sym_PLUS_QMARK] = ACTIONS(611),
    [anon_sym_DASH_QMARK] = ACTIONS(611),
    [anon_sym_STAR_QMARK] = ACTIONS(611),
    [anon_sym_SLASH_QMARK] = ACTIONS(611),
    [anon_sym_PERCENT_QMARK] = ACTIONS(611),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(611),
    [anon_sym_as] = ACTIONS(611),
    [anon_sym_LPAREN2] = ACTIONS(611),
    [anon_sym_DOT_GT] = ACTIONS(611),
    [anon_sym_TILDE] = ACTIONS(611),
    [anon_sym_end] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(613),
    [anon_sym_ifdef] = ACTIONS(611),
    [anon_sym_elseif] = ACTIONS(611),
    [anon_sym_iftype] = ACTIONS(611),
    [anon_sym_else] = ACTIONS(613),
    [anon_sym_for] = ACTIONS(611),
    [anon_sym_while] = ACTIONS(611),
    [anon_sym_try] = ACTIONS(611),
    [anon_sym_with] = ACTIONS(611),
    [anon_sym_repeat] = ACTIONS(611),
    [anon_sym_recover] = ACTIONS(611),
    [anon_sym_match] = ACTIONS(611),
    [anon_sym_return] = ACTIONS(611),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_consume] = ACTIONS(611),
    [anon_sym_object] = ACTIONS(611),
    [sym_number] = ACTIONS(613),
    [sym_float] = ACTIONS(611),
    [anon_sym_DQUOTE] = ACTIONS(613),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(611),
    [anon_sym_SQUOTE] = ACTIONS(611),
    [anon_sym_true] = ACTIONS(611),
    [anon_sym_false] = ACTIONS(611),
    [sym_this] = ACTIONS(611),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(981),
    [sym_block_comment] = ACTIONS(3),
  },
  [182] = {
    [sym_type_args] = STATE(255),
    [aux_sym_base_type_repeat1] = STATE(181),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_AT] = ACTIONS(619),
    [anon_sym_LBRACK] = ACTIONS(619),
    [anon_sym_is] = ACTIONS(621),
    [anon_sym_let] = ACTIONS(619),
    [anon_sym_var] = ACTIONS(619),
    [anon_sym_iso] = ACTIONS(619),
    [anon_sym_trn] = ACTIONS(619),
    [anon_sym_ref] = ACTIONS(619),
    [anon_sym_val] = ACTIONS(619),
    [anon_sym_box] = ACTIONS(619),
    [anon_sym_tag] = ACTIONS(619),
    [anon_sym_LPAREN] = ACTIONS(621),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_POUNDread] = ACTIONS(619),
    [anon_sym_POUNDsend] = ACTIONS(619),
    [anon_sym_POUNDshare] = ACTIONS(619),
    [anon_sym_POUNDalias] = ACTIONS(619),
    [anon_sym_POUNDany] = ACTIONS(619),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_CARET] = ACTIONS(619),
    [anon_sym_PIPE] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(619),
    [anon_sym_DASH_GT] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_SEMI] = ACTIONS(619),
    [sym_error] = ACTIONS(619),
    [sym_compile_intrinsic] = ACTIONS(619),
    [anon_sym_compile_error] = ACTIONS(619),
    [sym_location] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(621),
    [anon_sym_not] = ACTIONS(619),
    [anon_sym_DASH_TILDE] = ACTIONS(619),
    [anon_sym_addressof] = ACTIONS(619),
    [anon_sym_digestof] = ACTIONS(619),
    [anon_sym_PLUS] = ACTIONS(621),
    [anon_sym_STAR] = ACTIONS(621),
    [anon_sym_SLASH] = ACTIONS(621),
    [anon_sym_PERCENT] = ACTIONS(621),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(621),
    [anon_sym_LT_LT] = ACTIONS(621),
    [anon_sym_GT_GT] = ACTIONS(621),
    [anon_sym_and] = ACTIONS(619),
    [anon_sym_or] = ACTIONS(619),
    [anon_sym_xor] = ACTIONS(619),
    [anon_sym_isnt] = ACTIONS(619),
    [anon_sym_EQ_EQ] = ACTIONS(621),
    [anon_sym_BANG_EQ] = ACTIONS(621),
    [anon_sym_GT] = ACTIONS(621),
    [anon_sym_GT_EQ] = ACTIONS(621),
    [anon_sym_LT_EQ] = ACTIONS(621),
    [anon_sym_LT] = ACTIONS(621),
    [anon_sym_PLUS_TILDE] = ACTIONS(619),
    [anon_sym_STAR_TILDE] = ACTIONS(619),
    [anon_sym_SLASH_TILDE] = ACTIONS(619),
    [anon_sym_PERCENT_TILDE] = ACTIONS(619),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(619),
    [anon_sym_LT_LT_TILDE] = ACTIONS(619),
    [anon_sym_GT_GT_TILDE] = ACTIONS(619),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(619),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(619),
    [anon_sym_GT_TILDE] = ACTIONS(619),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(619),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(619),
    [anon_sym_LT_TILDE] = ACTIONS(619),
    [anon_sym_PLUS_QMARK] = ACTIONS(619),
    [anon_sym_DASH_QMARK] = ACTIONS(619),
    [anon_sym_STAR_QMARK] = ACTIONS(619),
    [anon_sym_SLASH_QMARK] = ACTIONS(619),
    [anon_sym_PERCENT_QMARK] = ACTIONS(619),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(619),
    [anon_sym_as] = ACTIONS(619),
    [anon_sym_LPAREN2] = ACTIONS(619),
    [anon_sym_DOT_GT] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(619),
    [anon_sym_end] = ACTIONS(619),
    [anon_sym_if] = ACTIONS(621),
    [anon_sym_ifdef] = ACTIONS(619),
    [anon_sym_elseif] = ACTIONS(619),
    [anon_sym_iftype] = ACTIONS(619),
    [anon_sym_else] = ACTIONS(621),
    [anon_sym_for] = ACTIONS(619),
    [anon_sym_while] = ACTIONS(619),
    [anon_sym_try] = ACTIONS(619),
    [anon_sym_with] = ACTIONS(619),
    [anon_sym_repeat] = ACTIONS(619),
    [anon_sym_recover] = ACTIONS(619),
    [anon_sym_match] = ACTIONS(619),
    [anon_sym_return] = ACTIONS(619),
    [anon_sym_continue] = ACTIONS(619),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_consume] = ACTIONS(619),
    [anon_sym_object] = ACTIONS(619),
    [sym_number] = ACTIONS(621),
    [sym_float] = ACTIONS(619),
    [anon_sym_DQUOTE] = ACTIONS(621),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(619),
    [anon_sym_SQUOTE] = ACTIONS(619),
    [anon_sym_true] = ACTIONS(619),
    [anon_sym_false] = ACTIONS(619),
    [sym_this] = ACTIONS(619),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(981),
    [sym_block_comment] = ACTIONS(3),
  },
  [183] = {
    [aux_sym_union_type_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(871),
    [anon_sym_EQ] = ACTIONS(871),
    [anon_sym_AT] = ACTIONS(869),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(869),
    [anon_sym_is] = ACTIONS(871),
    [anon_sym_embed] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_var] = ACTIONS(869),
    [anon_sym_new] = ACTIONS(869),
    [anon_sym_EQ_GT] = ACTIONS(869),
    [anon_sym_fun] = ACTIONS(869),
    [anon_sym_be] = ACTIONS(869),
    [anon_sym_COMMA] = ACTIONS(869),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(869),
    [anon_sym_DOT] = ACTIONS(871),
    [anon_sym_BANG] = ACTIONS(871),
    [anon_sym_CARET] = ACTIONS(869),
    [anon_sym_PIPE] = ACTIONS(983),
    [anon_sym_AMP] = ACTIONS(869),
    [anon_sym_DASH_GT] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(869),
    [anon_sym_RBRACE] = ACTIONS(869),
    [anon_sym_SEMI] = ACTIONS(869),
    [sym_error] = ACTIONS(869),
    [sym_compile_intrinsic] = ACTIONS(869),
    [anon_sym_compile_error] = ACTIONS(869),
    [sym_location] = ACTIONS(869),
    [anon_sym_DASH] = ACTIONS(871),
    [anon_sym_not] = ACTIONS(869),
    [anon_sym_DASH_TILDE] = ACTIONS(869),
    [anon_sym_addressof] = ACTIONS(869),
    [anon_sym_digestof] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(871),
    [anon_sym_STAR] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(871),
    [anon_sym_PERCENT] = ACTIONS(871),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(871),
    [anon_sym_LT_LT] = ACTIONS(871),
    [anon_sym_GT_GT] = ACTIONS(871),
    [anon_sym_and] = ACTIONS(869),
    [anon_sym_or] = ACTIONS(869),
    [anon_sym_xor] = ACTIONS(869),
    [anon_sym_isnt] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(871),
    [anon_sym_BANG_EQ] = ACTIONS(871),
    [anon_sym_GT] = ACTIONS(871),
    [anon_sym_GT_EQ] = ACTIONS(871),
    [anon_sym_LT_EQ] = ACTIONS(871),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_PLUS_TILDE] = ACTIONS(869),
    [anon_sym_STAR_TILDE] = ACTIONS(869),
    [anon_sym_SLASH_TILDE] = ACTIONS(869),
    [anon_sym_PERCENT_TILDE] = ACTIONS(869),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(869),
    [anon_sym_LT_LT_TILDE] = ACTIONS(869),
    [anon_sym_GT_GT_TILDE] = ACTIONS(869),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(869),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(869),
    [anon_sym_GT_TILDE] = ACTIONS(869),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(869),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(869),
    [anon_sym_LT_TILDE] = ACTIONS(869),
    [anon_sym_PLUS_QMARK] = ACTIONS(869),
    [anon_sym_DASH_QMARK] = ACTIONS(869),
    [anon_sym_STAR_QMARK] = ACTIONS(869),
    [anon_sym_SLASH_QMARK] = ACTIONS(869),
    [anon_sym_PERCENT_QMARK] = ACTIONS(869),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(869),
    [anon_sym_as] = ACTIONS(869),
    [anon_sym_LPAREN2] = ACTIONS(869),
    [anon_sym_DOT_GT] = ACTIONS(869),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [anon_sym_end] = ACTIONS(869),
    [anon_sym_if] = ACTIONS(871),
    [anon_sym_ifdef] = ACTIONS(869),
    [anon_sym_then] = ACTIONS(869),
    [anon_sym_iftype] = ACTIONS(869),
    [anon_sym_else] = ACTIONS(869),
    [anon_sym_for] = ACTIONS(869),
    [anon_sym_while] = ACTIONS(869),
    [anon_sym_try] = ACTIONS(869),
    [anon_sym_with] = ACTIONS(869),
    [anon_sym_repeat] = ACTIONS(869),
    [anon_sym_until] = ACTIONS(869),
    [anon_sym_do] = ACTIONS(869),
    [anon_sym_recover] = ACTIONS(869),
    [anon_sym_match] = ACTIONS(869),
    [anon_sym_return] = ACTIONS(869),
    [anon_sym_continue] = ACTIONS(869),
    [anon_sym_break] = ACTIONS(869),
    [anon_sym_consume] = ACTIONS(869),
    [anon_sym_object] = ACTIONS(869),
    [sym_number] = ACTIONS(871),
    [sym_float] = ACTIONS(869),
    [anon_sym_DQUOTE] = ACTIONS(871),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(869),
    [anon_sym_SQUOTE] = ACTIONS(869),
    [anon_sym_true] = ACTIONS(869),
    [anon_sym_false] = ACTIONS(869),
    [sym_this] = ACTIONS(869),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [184] = {
    [aux_sym_intersection_type_repeat1] = STATE(184),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_EQ] = ACTIONS(883),
    [anon_sym_AT] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(881),
    [anon_sym_RBRACK] = ACTIONS(881),
    [anon_sym_is] = ACTIONS(883),
    [anon_sym_embed] = ACTIONS(881),
    [anon_sym_let] = ACTIONS(881),
    [anon_sym_var] = ACTIONS(881),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_EQ_GT] = ACTIONS(881),
    [anon_sym_fun] = ACTIONS(881),
    [anon_sym_be] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_LPAREN] = ACTIONS(883),
    [anon_sym_RPAREN] = ACTIONS(881),
    [anon_sym_DOT] = ACTIONS(883),
    [anon_sym_BANG] = ACTIONS(883),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(881),
    [anon_sym_AMP] = ACTIONS(986),
    [anon_sym_DASH_GT] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(881),
    [anon_sym_RBRACE] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(881),
    [sym_error] = ACTIONS(881),
    [sym_compile_intrinsic] = ACTIONS(881),
    [anon_sym_compile_error] = ACTIONS(881),
    [sym_location] = ACTIONS(881),
    [anon_sym_DASH] = ACTIONS(883),
    [anon_sym_not] = ACTIONS(881),
    [anon_sym_DASH_TILDE] = ACTIONS(881),
    [anon_sym_addressof] = ACTIONS(881),
    [anon_sym_digestof] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(883),
    [anon_sym_STAR] = ACTIONS(883),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_PERCENT] = ACTIONS(883),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(881),
    [anon_sym_or] = ACTIONS(881),
    [anon_sym_xor] = ACTIONS(881),
    [anon_sym_isnt] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_PLUS_TILDE] = ACTIONS(881),
    [anon_sym_STAR_TILDE] = ACTIONS(881),
    [anon_sym_SLASH_TILDE] = ACTIONS(881),
    [anon_sym_PERCENT_TILDE] = ACTIONS(881),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(881),
    [anon_sym_LT_LT_TILDE] = ACTIONS(881),
    [anon_sym_GT_GT_TILDE] = ACTIONS(881),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(881),
    [anon_sym_GT_TILDE] = ACTIONS(881),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(881),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(881),
    [anon_sym_LT_TILDE] = ACTIONS(881),
    [anon_sym_PLUS_QMARK] = ACTIONS(881),
    [anon_sym_DASH_QMARK] = ACTIONS(881),
    [anon_sym_STAR_QMARK] = ACTIONS(881),
    [anon_sym_SLASH_QMARK] = ACTIONS(881),
    [anon_sym_PERCENT_QMARK] = ACTIONS(881),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(881),
    [anon_sym_as] = ACTIONS(881),
    [anon_sym_LPAREN2] = ACTIONS(881),
    [anon_sym_DOT_GT] = ACTIONS(881),
    [anon_sym_where] = ACTIONS(881),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_end] = ACTIONS(881),
    [anon_sym_if] = ACTIONS(883),
    [anon_sym_ifdef] = ACTIONS(881),
    [anon_sym_then] = ACTIONS(881),
    [anon_sym_iftype] = ACTIONS(881),
    [anon_sym_else] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(881),
    [anon_sym_while] = ACTIONS(881),
    [anon_sym_try] = ACTIONS(881),
    [anon_sym_with] = ACTIONS(881),
    [anon_sym_repeat] = ACTIONS(881),
    [anon_sym_until] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(881),
    [anon_sym_recover] = ACTIONS(881),
    [anon_sym_match] = ACTIONS(881),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_continue] = ACTIONS(881),
    [anon_sym_break] = ACTIONS(881),
    [anon_sym_consume] = ACTIONS(881),
    [anon_sym_object] = ACTIONS(881),
    [sym_number] = ACTIONS(883),
    [sym_float] = ACTIONS(881),
    [anon_sym_DQUOTE] = ACTIONS(883),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(881),
    [anon_sym_SQUOTE] = ACTIONS(881),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [sym_this] = ACTIONS(881),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [185] = {
    [aux_sym_base_type_repeat1] = STATE(185),
    [sym_identifier] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(625),
    [anon_sym_AT] = ACTIONS(623),
    [anon_sym_LBRACK] = ACTIONS(623),
    [anon_sym_is] = ACTIONS(625),
    [anon_sym_let] = ACTIONS(623),
    [anon_sym_var] = ACTIONS(623),
    [anon_sym_iso] = ACTIONS(623),
    [anon_sym_trn] = ACTIONS(623),
    [anon_sym_ref] = ACTIONS(623),
    [anon_sym_val] = ACTIONS(623),
    [anon_sym_box] = ACTIONS(623),
    [anon_sym_tag] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOT] = ACTIONS(989),
    [anon_sym_POUNDread] = ACTIONS(623),
    [anon_sym_POUNDsend] = ACTIONS(623),
    [anon_sym_POUNDshare] = ACTIONS(623),
    [anon_sym_POUNDalias] = ACTIONS(623),
    [anon_sym_POUNDany] = ACTIONS(623),
    [anon_sym_BANG] = ACTIONS(625),
    [anon_sym_CARET] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(623),
    [anon_sym_AMP] = ACTIONS(623),
    [anon_sym_DASH_GT] = ACTIONS(623),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(623),
    [sym_error] = ACTIONS(623),
    [sym_compile_intrinsic] = ACTIONS(623),
    [anon_sym_compile_error] = ACTIONS(623),
    [sym_location] = ACTIONS(623),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_not] = ACTIONS(623),
    [anon_sym_DASH_TILDE] = ACTIONS(623),
    [anon_sym_addressof] = ACTIONS(623),
    [anon_sym_digestof] = ACTIONS(623),
    [anon_sym_PLUS] = ACTIONS(625),
    [anon_sym_STAR] = ACTIONS(625),
    [anon_sym_SLASH] = ACTIONS(625),
    [anon_sym_PERCENT] = ACTIONS(625),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(625),
    [anon_sym_LT_LT] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(625),
    [anon_sym_and] = ACTIONS(623),
    [anon_sym_or] = ACTIONS(623),
    [anon_sym_xor] = ACTIONS(623),
    [anon_sym_isnt] = ACTIONS(623),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(625),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_LT] = ACTIONS(625),
    [anon_sym_PLUS_TILDE] = ACTIONS(623),
    [anon_sym_STAR_TILDE] = ACTIONS(623),
    [anon_sym_SLASH_TILDE] = ACTIONS(623),
    [anon_sym_PERCENT_TILDE] = ACTIONS(623),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(623),
    [anon_sym_LT_LT_TILDE] = ACTIONS(623),
    [anon_sym_GT_GT_TILDE] = ACTIONS(623),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(623),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(623),
    [anon_sym_GT_TILDE] = ACTIONS(623),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(623),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(623),
    [anon_sym_LT_TILDE] = ACTIONS(623),
    [anon_sym_PLUS_QMARK] = ACTIONS(623),
    [anon_sym_DASH_QMARK] = ACTIONS(623),
    [anon_sym_STAR_QMARK] = ACTIONS(623),
    [anon_sym_SLASH_QMARK] = ACTIONS(623),
    [anon_sym_PERCENT_QMARK] = ACTIONS(623),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(623),
    [anon_sym_as] = ACTIONS(623),
    [anon_sym_LPAREN2] = ACTIONS(623),
    [anon_sym_DOT_GT] = ACTIONS(623),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_end] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_ifdef] = ACTIONS(623),
    [anon_sym_elseif] = ACTIONS(623),
    [anon_sym_iftype] = ACTIONS(623),
    [anon_sym_else] = ACTIONS(625),
    [anon_sym_for] = ACTIONS(623),
    [anon_sym_while] = ACTIONS(623),
    [anon_sym_try] = ACTIONS(623),
    [anon_sym_with] = ACTIONS(623),
    [anon_sym_repeat] = ACTIONS(623),
    [anon_sym_recover] = ACTIONS(623),
    [anon_sym_match] = ACTIONS(623),
    [anon_sym_return] = ACTIONS(623),
    [anon_sym_continue] = ACTIONS(623),
    [anon_sym_break] = ACTIONS(623),
    [anon_sym_consume] = ACTIONS(623),
    [anon_sym_object] = ACTIONS(623),
    [sym_number] = ACTIONS(625),
    [sym_float] = ACTIONS(623),
    [anon_sym_DQUOTE] = ACTIONS(625),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(623),
    [anon_sym_SQUOTE] = ACTIONS(623),
    [anon_sym_true] = ACTIONS(623),
    [anon_sym_false] = ACTIONS(623),
    [sym_this] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(623),
    [sym_block_comment] = ACTIONS(3),
  },
  [186] = {
    [sym_type_args] = STATE(234),
    [ts_builtin_sym_end] = ACTIONS(992),
    [sym_identifier] = ACTIONS(994),
    [anon_sym_use] = ACTIONS(992),
    [anon_sym_EQ] = ACTIONS(994),
    [anon_sym_AT] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(992),
    [anon_sym_type] = ACTIONS(992),
    [anon_sym_is] = ACTIONS(994),
    [anon_sym_actor] = ACTIONS(992),
    [anon_sym_class] = ACTIONS(992),
    [anon_sym_primitive] = ACTIONS(992),
    [anon_sym_interface] = ACTIONS(992),
    [anon_sym_trait] = ACTIONS(992),
    [anon_sym_struct] = ACTIONS(992),
    [anon_sym_embed] = ACTIONS(992),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_var] = ACTIONS(992),
    [anon_sym_new] = ACTIONS(992),
    [anon_sym_fun] = ACTIONS(992),
    [anon_sym_be] = ACTIONS(992),
    [anon_sym_COMMA] = ACTIONS(992),
    [anon_sym_LPAREN] = ACTIONS(994),
    [anon_sym_RPAREN] = ACTIONS(992),
    [anon_sym_DOT] = ACTIONS(994),
    [anon_sym_LBRACE] = ACTIONS(992),
    [anon_sym_SEMI] = ACTIONS(992),
    [sym_error] = ACTIONS(992),
    [sym_compile_intrinsic] = ACTIONS(992),
    [anon_sym_compile_error] = ACTIONS(992),
    [sym_location] = ACTIONS(992),
    [anon_sym_DASH] = ACTIONS(994),
    [anon_sym_not] = ACTIONS(992),
    [anon_sym_DASH_TILDE] = ACTIONS(992),
    [anon_sym_addressof] = ACTIONS(992),
    [anon_sym_digestof] = ACTIONS(992),
    [anon_sym_PLUS] = ACTIONS(994),
    [anon_sym_STAR] = ACTIONS(994),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_PERCENT] = ACTIONS(994),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(994),
    [anon_sym_LT_LT] = ACTIONS(994),
    [anon_sym_GT_GT] = ACTIONS(994),
    [anon_sym_and] = ACTIONS(992),
    [anon_sym_or] = ACTIONS(992),
    [anon_sym_xor] = ACTIONS(992),
    [anon_sym_isnt] = ACTIONS(992),
    [anon_sym_EQ_EQ] = ACTIONS(994),
    [anon_sym_BANG_EQ] = ACTIONS(994),
    [anon_sym_GT] = ACTIONS(994),
    [anon_sym_GT_EQ] = ACTIONS(994),
    [anon_sym_LT_EQ] = ACTIONS(994),
    [anon_sym_LT] = ACTIONS(994),
    [anon_sym_PLUS_TILDE] = ACTIONS(992),
    [anon_sym_STAR_TILDE] = ACTIONS(992),
    [anon_sym_SLASH_TILDE] = ACTIONS(992),
    [anon_sym_PERCENT_TILDE] = ACTIONS(992),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(992),
    [anon_sym_LT_LT_TILDE] = ACTIONS(992),
    [anon_sym_GT_GT_TILDE] = ACTIONS(992),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(992),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(992),
    [anon_sym_GT_TILDE] = ACTIONS(992),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(992),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(992),
    [anon_sym_LT_TILDE] = ACTIONS(992),
    [anon_sym_PLUS_QMARK] = ACTIONS(992),
    [anon_sym_DASH_QMARK] = ACTIONS(992),
    [anon_sym_STAR_QMARK] = ACTIONS(992),
    [anon_sym_SLASH_QMARK] = ACTIONS(992),
    [anon_sym_PERCENT_QMARK] = ACTIONS(992),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(992),
    [anon_sym_as] = ACTIONS(992),
    [anon_sym_LPAREN2] = ACTIONS(992),
    [anon_sym_DOT_GT] = ACTIONS(992),
    [anon_sym_where] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(992),
    [anon_sym_end] = ACTIONS(992),
    [anon_sym_if] = ACTIONS(994),
    [anon_sym_ifdef] = ACTIONS(992),
    [anon_sym_iftype] = ACTIONS(992),
    [anon_sym_else] = ACTIONS(992),
    [anon_sym_for] = ACTIONS(992),
    [anon_sym_while] = ACTIONS(992),
    [anon_sym_try] = ACTIONS(992),
    [anon_sym_with] = ACTIONS(992),
    [anon_sym_repeat] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(992),
    [anon_sym_recover] = ACTIONS(992),
    [anon_sym_match] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(992),
    [anon_sym_continue] = ACTIONS(992),
    [anon_sym_break] = ACTIONS(992),
    [anon_sym_consume] = ACTIONS(992),
    [anon_sym_object] = ACTIONS(992),
    [sym_number] = ACTIONS(994),
    [sym_float] = ACTIONS(992),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(992),
    [anon_sym_SQUOTE] = ACTIONS(992),
    [anon_sym_true] = ACTIONS(992),
    [anon_sym_false] = ACTIONS(992),
    [sym_this] = ACTIONS(992),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(996),
    [sym_block_comment] = ACTIONS(3),
  },
  [187] = {
    [aux_sym_union_type_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(887),
    [anon_sym_EQ] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(885),
    [anon_sym_LBRACK] = ACTIONS(885),
    [anon_sym_RBRACK] = ACTIONS(885),
    [anon_sym_is] = ACTIONS(887),
    [anon_sym_embed] = ACTIONS(885),
    [anon_sym_let] = ACTIONS(885),
    [anon_sym_var] = ACTIONS(885),
    [anon_sym_new] = ACTIONS(885),
    [anon_sym_EQ_GT] = ACTIONS(885),
    [anon_sym_fun] = ACTIONS(885),
    [anon_sym_be] = ACTIONS(885),
    [anon_sym_COMMA] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(887),
    [anon_sym_RPAREN] = ACTIONS(885),
    [anon_sym_DOT] = ACTIONS(887),
    [anon_sym_BANG] = ACTIONS(887),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(885),
    [anon_sym_RBRACE] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(885),
    [sym_error] = ACTIONS(885),
    [sym_compile_intrinsic] = ACTIONS(885),
    [anon_sym_compile_error] = ACTIONS(885),
    [sym_location] = ACTIONS(885),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_not] = ACTIONS(885),
    [anon_sym_DASH_TILDE] = ACTIONS(885),
    [anon_sym_addressof] = ACTIONS(885),
    [anon_sym_digestof] = ACTIONS(885),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(887),
    [anon_sym_SLASH] = ACTIONS(887),
    [anon_sym_PERCENT] = ACTIONS(887),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(887),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_and] = ACTIONS(885),
    [anon_sym_or] = ACTIONS(885),
    [anon_sym_xor] = ACTIONS(885),
    [anon_sym_isnt] = ACTIONS(885),
    [anon_sym_EQ_EQ] = ACTIONS(887),
    [anon_sym_BANG_EQ] = ACTIONS(887),
    [anon_sym_GT] = ACTIONS(887),
    [anon_sym_GT_EQ] = ACTIONS(887),
    [anon_sym_LT_EQ] = ACTIONS(887),
    [anon_sym_LT] = ACTIONS(887),
    [anon_sym_PLUS_TILDE] = ACTIONS(885),
    [anon_sym_STAR_TILDE] = ACTIONS(885),
    [anon_sym_SLASH_TILDE] = ACTIONS(885),
    [anon_sym_PERCENT_TILDE] = ACTIONS(885),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(885),
    [anon_sym_LT_LT_TILDE] = ACTIONS(885),
    [anon_sym_GT_GT_TILDE] = ACTIONS(885),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(885),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(885),
    [anon_sym_GT_TILDE] = ACTIONS(885),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(885),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(885),
    [anon_sym_LT_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_QMARK] = ACTIONS(885),
    [anon_sym_DASH_QMARK] = ACTIONS(885),
    [anon_sym_STAR_QMARK] = ACTIONS(885),
    [anon_sym_SLASH_QMARK] = ACTIONS(885),
    [anon_sym_PERCENT_QMARK] = ACTIONS(885),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(885),
    [anon_sym_as] = ACTIONS(885),
    [anon_sym_LPAREN2] = ACTIONS(885),
    [anon_sym_DOT_GT] = ACTIONS(885),
    [anon_sym_where] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_end] = ACTIONS(885),
    [anon_sym_if] = ACTIONS(887),
    [anon_sym_ifdef] = ACTIONS(885),
    [anon_sym_then] = ACTIONS(885),
    [anon_sym_iftype] = ACTIONS(885),
    [anon_sym_else] = ACTIONS(885),
    [anon_sym_for] = ACTIONS(885),
    [anon_sym_while] = ACTIONS(885),
    [anon_sym_try] = ACTIONS(885),
    [anon_sym_with] = ACTIONS(885),
    [anon_sym_repeat] = ACTIONS(885),
    [anon_sym_until] = ACTIONS(885),
    [anon_sym_do] = ACTIONS(885),
    [anon_sym_recover] = ACTIONS(885),
    [anon_sym_match] = ACTIONS(885),
    [anon_sym_return] = ACTIONS(885),
    [anon_sym_continue] = ACTIONS(885),
    [anon_sym_break] = ACTIONS(885),
    [anon_sym_consume] = ACTIONS(885),
    [anon_sym_object] = ACTIONS(885),
    [sym_number] = ACTIONS(887),
    [sym_float] = ACTIONS(885),
    [anon_sym_DQUOTE] = ACTIONS(887),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(885),
    [anon_sym_SQUOTE] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(885),
    [anon_sym_false] = ACTIONS(885),
    [sym_this] = ACTIONS(885),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [188] = {
    [aux_sym_intersection_type_repeat1] = STATE(184),
    [sym_identifier] = ACTIONS(894),
    [anon_sym_EQ] = ACTIONS(894),
    [anon_sym_AT] = ACTIONS(892),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_RBRACK] = ACTIONS(892),
    [anon_sym_is] = ACTIONS(894),
    [anon_sym_embed] = ACTIONS(892),
    [anon_sym_let] = ACTIONS(892),
    [anon_sym_var] = ACTIONS(892),
    [anon_sym_new] = ACTIONS(892),
    [anon_sym_EQ_GT] = ACTIONS(892),
    [anon_sym_fun] = ACTIONS(892),
    [anon_sym_be] = ACTIONS(892),
    [anon_sym_COMMA] = ACTIONS(892),
    [anon_sym_LPAREN] = ACTIONS(894),
    [anon_sym_RPAREN] = ACTIONS(892),
    [anon_sym_DOT] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(894),
    [anon_sym_CARET] = ACTIONS(892),
    [anon_sym_PIPE] = ACTIONS(892),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH_GT] = ACTIONS(892),
    [anon_sym_LBRACE] = ACTIONS(892),
    [anon_sym_RBRACE] = ACTIONS(892),
    [anon_sym_SEMI] = ACTIONS(892),
    [sym_error] = ACTIONS(892),
    [sym_compile_intrinsic] = ACTIONS(892),
    [anon_sym_compile_error] = ACTIONS(892),
    [sym_location] = ACTIONS(892),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_not] = ACTIONS(892),
    [anon_sym_DASH_TILDE] = ACTIONS(892),
    [anon_sym_addressof] = ACTIONS(892),
    [anon_sym_digestof] = ACTIONS(892),
    [anon_sym_PLUS] = ACTIONS(894),
    [anon_sym_STAR] = ACTIONS(894),
    [anon_sym_SLASH] = ACTIONS(894),
    [anon_sym_PERCENT] = ACTIONS(894),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(894),
    [anon_sym_LT_LT] = ACTIONS(894),
    [anon_sym_GT_GT] = ACTIONS(894),
    [anon_sym_and] = ACTIONS(892),
    [anon_sym_or] = ACTIONS(892),
    [anon_sym_xor] = ACTIONS(892),
    [anon_sym_isnt] = ACTIONS(892),
    [anon_sym_EQ_EQ] = ACTIONS(894),
    [anon_sym_BANG_EQ] = ACTIONS(894),
    [anon_sym_GT] = ACTIONS(894),
    [anon_sym_GT_EQ] = ACTIONS(894),
    [anon_sym_LT_EQ] = ACTIONS(894),
    [anon_sym_LT] = ACTIONS(894),
    [anon_sym_PLUS_TILDE] = ACTIONS(892),
    [anon_sym_STAR_TILDE] = ACTIONS(892),
    [anon_sym_SLASH_TILDE] = ACTIONS(892),
    [anon_sym_PERCENT_TILDE] = ACTIONS(892),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(892),
    [anon_sym_LT_LT_TILDE] = ACTIONS(892),
    [anon_sym_GT_GT_TILDE] = ACTIONS(892),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(892),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(892),
    [anon_sym_GT_TILDE] = ACTIONS(892),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(892),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(892),
    [anon_sym_LT_TILDE] = ACTIONS(892),
    [anon_sym_PLUS_QMARK] = ACTIONS(892),
    [anon_sym_DASH_QMARK] = ACTIONS(892),
    [anon_sym_STAR_QMARK] = ACTIONS(892),
    [anon_sym_SLASH_QMARK] = ACTIONS(892),
    [anon_sym_PERCENT_QMARK] = ACTIONS(892),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(892),
    [anon_sym_as] = ACTIONS(892),
    [anon_sym_LPAREN2] = ACTIONS(892),
    [anon_sym_DOT_GT] = ACTIONS(892),
    [anon_sym_where] = ACTIONS(892),
    [anon_sym_TILDE] = ACTIONS(892),
    [anon_sym_end] = ACTIONS(892),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_ifdef] = ACTIONS(892),
    [anon_sym_then] = ACTIONS(892),
    [anon_sym_iftype] = ACTIONS(892),
    [anon_sym_else] = ACTIONS(892),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(892),
    [anon_sym_try] = ACTIONS(892),
    [anon_sym_with] = ACTIONS(892),
    [anon_sym_repeat] = ACTIONS(892),
    [anon_sym_until] = ACTIONS(892),
    [anon_sym_do] = ACTIONS(892),
    [anon_sym_recover] = ACTIONS(892),
    [anon_sym_match] = ACTIONS(892),
    [anon_sym_return] = ACTIONS(892),
    [anon_sym_continue] = ACTIONS(892),
    [anon_sym_break] = ACTIONS(892),
    [anon_sym_consume] = ACTIONS(892),
    [anon_sym_object] = ACTIONS(892),
    [sym_number] = ACTIONS(894),
    [sym_float] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(894),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(892),
    [anon_sym_SQUOTE] = ACTIONS(892),
    [anon_sym_true] = ACTIONS(892),
    [anon_sym_false] = ACTIONS(892),
    [sym_this] = ACTIONS(892),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [189] = {
    [sym_arguments] = STATE(223),
    [ts_builtin_sym_end] = ACTIONS(998),
    [sym_identifier] = ACTIONS(1000),
    [anon_sym_use] = ACTIONS(998),
    [anon_sym_EQ] = ACTIONS(1000),
    [anon_sym_AT] = ACTIONS(998),
    [anon_sym_LBRACK] = ACTIONS(998),
    [anon_sym_type] = ACTIONS(998),
    [anon_sym_is] = ACTIONS(1000),
    [anon_sym_actor] = ACTIONS(998),
    [anon_sym_class] = ACTIONS(998),
    [anon_sym_primitive] = ACTIONS(998),
    [anon_sym_interface] = ACTIONS(998),
    [anon_sym_trait] = ACTIONS(998),
    [anon_sym_struct] = ACTIONS(998),
    [anon_sym_embed] = ACTIONS(998),
    [anon_sym_let] = ACTIONS(998),
    [anon_sym_var] = ACTIONS(998),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_fun] = ACTIONS(998),
    [anon_sym_be] = ACTIONS(998),
    [anon_sym_COMMA] = ACTIONS(998),
    [anon_sym_LPAREN] = ACTIONS(1000),
    [anon_sym_RPAREN] = ACTIONS(998),
    [anon_sym_DOT] = ACTIONS(1000),
    [anon_sym_LBRACE] = ACTIONS(998),
    [anon_sym_SEMI] = ACTIONS(998),
    [sym_error] = ACTIONS(998),
    [sym_compile_intrinsic] = ACTIONS(998),
    [anon_sym_compile_error] = ACTIONS(998),
    [sym_location] = ACTIONS(998),
    [anon_sym_DASH] = ACTIONS(1000),
    [anon_sym_not] = ACTIONS(998),
    [anon_sym_DASH_TILDE] = ACTIONS(998),
    [anon_sym_addressof] = ACTIONS(998),
    [anon_sym_digestof] = ACTIONS(998),
    [anon_sym_PLUS] = ACTIONS(1000),
    [anon_sym_STAR] = ACTIONS(1000),
    [anon_sym_SLASH] = ACTIONS(1000),
    [anon_sym_PERCENT] = ACTIONS(1000),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1000),
    [anon_sym_LT_LT] = ACTIONS(1000),
    [anon_sym_GT_GT] = ACTIONS(1000),
    [anon_sym_and] = ACTIONS(998),
    [anon_sym_or] = ACTIONS(998),
    [anon_sym_xor] = ACTIONS(998),
    [anon_sym_isnt] = ACTIONS(998),
    [anon_sym_EQ_EQ] = ACTIONS(1000),
    [anon_sym_BANG_EQ] = ACTIONS(1000),
    [anon_sym_GT] = ACTIONS(1000),
    [anon_sym_GT_EQ] = ACTIONS(1000),
    [anon_sym_LT_EQ] = ACTIONS(1000),
    [anon_sym_LT] = ACTIONS(1000),
    [anon_sym_PLUS_TILDE] = ACTIONS(998),
    [anon_sym_STAR_TILDE] = ACTIONS(998),
    [anon_sym_SLASH_TILDE] = ACTIONS(998),
    [anon_sym_PERCENT_TILDE] = ACTIONS(998),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(998),
    [anon_sym_LT_LT_TILDE] = ACTIONS(998),
    [anon_sym_GT_GT_TILDE] = ACTIONS(998),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(998),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(998),
    [anon_sym_GT_TILDE] = ACTIONS(998),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(998),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(998),
    [anon_sym_LT_TILDE] = ACTIONS(998),
    [anon_sym_PLUS_QMARK] = ACTIONS(998),
    [anon_sym_DASH_QMARK] = ACTIONS(998),
    [anon_sym_STAR_QMARK] = ACTIONS(998),
    [anon_sym_SLASH_QMARK] = ACTIONS(998),
    [anon_sym_PERCENT_QMARK] = ACTIONS(998),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(998),
    [anon_sym_as] = ACTIONS(998),
    [anon_sym_LPAREN2] = ACTIONS(998),
    [anon_sym_DOT_GT] = ACTIONS(998),
    [anon_sym_where] = ACTIONS(998),
    [anon_sym_TILDE] = ACTIONS(998),
    [anon_sym_end] = ACTIONS(998),
    [anon_sym_if] = ACTIONS(1000),
    [anon_sym_ifdef] = ACTIONS(998),
    [anon_sym_iftype] = ACTIONS(998),
    [anon_sym_else] = ACTIONS(998),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_while] = ACTIONS(998),
    [anon_sym_try] = ACTIONS(998),
    [anon_sym_with] = ACTIONS(998),
    [anon_sym_repeat] = ACTIONS(998),
    [anon_sym_do] = ACTIONS(998),
    [anon_sym_recover] = ACTIONS(998),
    [anon_sym_match] = ACTIONS(998),
    [anon_sym_return] = ACTIONS(998),
    [anon_sym_continue] = ACTIONS(998),
    [anon_sym_break] = ACTIONS(998),
    [anon_sym_consume] = ACTIONS(998),
    [anon_sym_object] = ACTIONS(998),
    [sym_number] = ACTIONS(1000),
    [sym_float] = ACTIONS(998),
    [anon_sym_DQUOTE] = ACTIONS(1000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(998),
    [anon_sym_SQUOTE] = ACTIONS(998),
    [anon_sym_true] = ACTIONS(998),
    [anon_sym_false] = ACTIONS(998),
    [sym_this] = ACTIONS(998),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [190] = {
    [ts_builtin_sym_end] = ACTIONS(1002),
    [sym_identifier] = ACTIONS(1004),
    [anon_sym_use] = ACTIONS(1002),
    [anon_sym_EQ] = ACTIONS(1004),
    [anon_sym_AT] = ACTIONS(1002),
    [anon_sym_LBRACK] = ACTIONS(1002),
    [anon_sym_QMARK] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_is] = ACTIONS(1004),
    [anon_sym_actor] = ACTIONS(1002),
    [anon_sym_class] = ACTIONS(1002),
    [anon_sym_primitive] = ACTIONS(1002),
    [anon_sym_interface] = ACTIONS(1002),
    [anon_sym_trait] = ACTIONS(1002),
    [anon_sym_struct] = ACTIONS(1002),
    [anon_sym_embed] = ACTIONS(1002),
    [anon_sym_let] = ACTIONS(1002),
    [anon_sym_var] = ACTIONS(1002),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_fun] = ACTIONS(1002),
    [anon_sym_be] = ACTIONS(1002),
    [anon_sym_COMMA] = ACTIONS(1002),
    [anon_sym_LPAREN] = ACTIONS(1004),
    [anon_sym_RPAREN] = ACTIONS(1002),
    [anon_sym_DOT] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1002),
    [anon_sym_SEMI] = ACTIONS(1002),
    [sym_error] = ACTIONS(1002),
    [sym_compile_intrinsic] = ACTIONS(1002),
    [anon_sym_compile_error] = ACTIONS(1002),
    [sym_location] = ACTIONS(1002),
    [anon_sym_DASH] = ACTIONS(1004),
    [anon_sym_not] = ACTIONS(1002),
    [anon_sym_DASH_TILDE] = ACTIONS(1002),
    [anon_sym_addressof] = ACTIONS(1002),
    [anon_sym_digestof] = ACTIONS(1002),
    [anon_sym_PLUS] = ACTIONS(1004),
    [anon_sym_STAR] = ACTIONS(1004),
    [anon_sym_SLASH] = ACTIONS(1004),
    [anon_sym_PERCENT] = ACTIONS(1004),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1004),
    [anon_sym_LT_LT] = ACTIONS(1004),
    [anon_sym_GT_GT] = ACTIONS(1004),
    [anon_sym_and] = ACTIONS(1002),
    [anon_sym_or] = ACTIONS(1002),
    [anon_sym_xor] = ACTIONS(1002),
    [anon_sym_isnt] = ACTIONS(1002),
    [anon_sym_EQ_EQ] = ACTIONS(1004),
    [anon_sym_BANG_EQ] = ACTIONS(1004),
    [anon_sym_GT] = ACTIONS(1004),
    [anon_sym_GT_EQ] = ACTIONS(1004),
    [anon_sym_LT_EQ] = ACTIONS(1004),
    [anon_sym_LT] = ACTIONS(1004),
    [anon_sym_PLUS_TILDE] = ACTIONS(1002),
    [anon_sym_STAR_TILDE] = ACTIONS(1002),
    [anon_sym_SLASH_TILDE] = ACTIONS(1002),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1002),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1002),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1002),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1002),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1002),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1002),
    [anon_sym_GT_TILDE] = ACTIONS(1002),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1002),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1002),
    [anon_sym_LT_TILDE] = ACTIONS(1002),
    [anon_sym_PLUS_QMARK] = ACTIONS(1002),
    [anon_sym_DASH_QMARK] = ACTIONS(1002),
    [anon_sym_STAR_QMARK] = ACTIONS(1002),
    [anon_sym_SLASH_QMARK] = ACTIONS(1002),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1002),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1002),
    [anon_sym_as] = ACTIONS(1002),
    [anon_sym_LPAREN2] = ACTIONS(1002),
    [anon_sym_DOT_GT] = ACTIONS(1002),
    [anon_sym_where] = ACTIONS(1002),
    [anon_sym_TILDE] = ACTIONS(1002),
    [anon_sym_end] = ACTIONS(1002),
    [anon_sym_if] = ACTIONS(1004),
    [anon_sym_ifdef] = ACTIONS(1002),
    [anon_sym_iftype] = ACTIONS(1002),
    [anon_sym_else] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1002),
    [anon_sym_while] = ACTIONS(1002),
    [anon_sym_try] = ACTIONS(1002),
    [anon_sym_with] = ACTIONS(1002),
    [anon_sym_repeat] = ACTIONS(1002),
    [anon_sym_do] = ACTIONS(1002),
    [anon_sym_recover] = ACTIONS(1002),
    [anon_sym_match] = ACTIONS(1002),
    [anon_sym_return] = ACTIONS(1002),
    [anon_sym_continue] = ACTIONS(1002),
    [anon_sym_break] = ACTIONS(1002),
    [anon_sym_consume] = ACTIONS(1002),
    [anon_sym_object] = ACTIONS(1002),
    [sym_number] = ACTIONS(1004),
    [sym_float] = ACTIONS(1002),
    [anon_sym_DQUOTE] = ACTIONS(1004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1002),
    [anon_sym_SQUOTE] = ACTIONS(1002),
    [anon_sym_true] = ACTIONS(1002),
    [anon_sym_false] = ACTIONS(1002),
    [sym_this] = ACTIONS(1002),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [191] = {
    [sym_identifier] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_AT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_is] = ACTIONS(937),
    [anon_sym_embed] = ACTIONS(935),
    [anon_sym_let] = ACTIONS(935),
    [anon_sym_var] = ACTIONS(935),
    [anon_sym_new] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_fun] = ACTIONS(935),
    [anon_sym_be] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_BANG] = ACTIONS(937),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym_AMP] = ACTIONS(935),
    [anon_sym_DASH_GT] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_SEMI] = ACTIONS(935),
    [sym_error] = ACTIONS(935),
    [sym_compile_intrinsic] = ACTIONS(935),
    [anon_sym_compile_error] = ACTIONS(935),
    [sym_location] = ACTIONS(935),
    [anon_sym_DASH] = ACTIONS(937),
    [anon_sym_not] = ACTIONS(935),
    [anon_sym_DASH_TILDE] = ACTIONS(935),
    [anon_sym_addressof] = ACTIONS(935),
    [anon_sym_digestof] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_STAR] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_xor] = ACTIONS(935),
    [anon_sym_isnt] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_PLUS_TILDE] = ACTIONS(935),
    [anon_sym_STAR_TILDE] = ACTIONS(935),
    [anon_sym_SLASH_TILDE] = ACTIONS(935),
    [anon_sym_PERCENT_TILDE] = ACTIONS(935),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(935),
    [anon_sym_LT_LT_TILDE] = ACTIONS(935),
    [anon_sym_GT_GT_TILDE] = ACTIONS(935),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(935),
    [anon_sym_GT_TILDE] = ACTIONS(935),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(935),
    [anon_sym_LT_TILDE] = ACTIONS(935),
    [anon_sym_PLUS_QMARK] = ACTIONS(935),
    [anon_sym_DASH_QMARK] = ACTIONS(935),
    [anon_sym_STAR_QMARK] = ACTIONS(935),
    [anon_sym_SLASH_QMARK] = ACTIONS(935),
    [anon_sym_PERCENT_QMARK] = ACTIONS(935),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(935),
    [anon_sym_as] = ACTIONS(935),
    [anon_sym_LPAREN2] = ACTIONS(935),
    [anon_sym_DOT_GT] = ACTIONS(935),
    [anon_sym_where] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(937),
    [anon_sym_ifdef] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_iftype] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_try] = ACTIONS(935),
    [anon_sym_with] = ACTIONS(935),
    [anon_sym_repeat] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_recover] = ACTIONS(935),
    [anon_sym_match] = ACTIONS(935),
    [anon_sym_return] = ACTIONS(935),
    [anon_sym_continue] = ACTIONS(935),
    [anon_sym_break] = ACTIONS(935),
    [anon_sym_consume] = ACTIONS(935),
    [anon_sym_object] = ACTIONS(935),
    [sym_number] = ACTIONS(937),
    [sym_float] = ACTIONS(935),
    [anon_sym_DQUOTE] = ACTIONS(937),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(935),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_true] = ACTIONS(935),
    [anon_sym_false] = ACTIONS(935),
    [sym_this] = ACTIONS(935),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [192] = {
    [sym_identifier] = ACTIONS(965),
    [anon_sym_EQ] = ACTIONS(965),
    [anon_sym_AT] = ACTIONS(963),
    [anon_sym_LBRACK] = ACTIONS(963),
    [anon_sym_RBRACK] = ACTIONS(963),
    [anon_sym_is] = ACTIONS(965),
    [anon_sym_embed] = ACTIONS(963),
    [anon_sym_let] = ACTIONS(963),
    [anon_sym_var] = ACTIONS(963),
    [anon_sym_new] = ACTIONS(963),
    [anon_sym_EQ_GT] = ACTIONS(963),
    [anon_sym_fun] = ACTIONS(963),
    [anon_sym_be] = ACTIONS(963),
    [anon_sym_COMMA] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(965),
    [anon_sym_RPAREN] = ACTIONS(963),
    [anon_sym_DOT] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(965),
    [anon_sym_CARET] = ACTIONS(963),
    [anon_sym_PIPE] = ACTIONS(963),
    [anon_sym_AMP] = ACTIONS(963),
    [anon_sym_DASH_GT] = ACTIONS(963),
    [anon_sym_LBRACE] = ACTIONS(963),
    [anon_sym_RBRACE] = ACTIONS(963),
    [anon_sym_SEMI] = ACTIONS(963),
    [sym_error] = ACTIONS(963),
    [sym_compile_intrinsic] = ACTIONS(963),
    [anon_sym_compile_error] = ACTIONS(963),
    [sym_location] = ACTIONS(963),
    [anon_sym_DASH] = ACTIONS(965),
    [anon_sym_not] = ACTIONS(963),
    [anon_sym_DASH_TILDE] = ACTIONS(963),
    [anon_sym_addressof] = ACTIONS(963),
    [anon_sym_digestof] = ACTIONS(963),
    [anon_sym_PLUS] = ACTIONS(965),
    [anon_sym_STAR] = ACTIONS(965),
    [anon_sym_SLASH] = ACTIONS(965),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(965),
    [anon_sym_LT_LT] = ACTIONS(965),
    [anon_sym_GT_GT] = ACTIONS(965),
    [anon_sym_and] = ACTIONS(963),
    [anon_sym_or] = ACTIONS(963),
    [anon_sym_xor] = ACTIONS(963),
    [anon_sym_isnt] = ACTIONS(963),
    [anon_sym_EQ_EQ] = ACTIONS(965),
    [anon_sym_BANG_EQ] = ACTIONS(965),
    [anon_sym_GT] = ACTIONS(965),
    [anon_sym_GT_EQ] = ACTIONS(965),
    [anon_sym_LT_EQ] = ACTIONS(965),
    [anon_sym_LT] = ACTIONS(965),
    [anon_sym_PLUS_TILDE] = ACTIONS(963),
    [anon_sym_STAR_TILDE] = ACTIONS(963),
    [anon_sym_SLASH_TILDE] = ACTIONS(963),
    [anon_sym_PERCENT_TILDE] = ACTIONS(963),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(963),
    [anon_sym_LT_LT_TILDE] = ACTIONS(963),
    [anon_sym_GT_GT_TILDE] = ACTIONS(963),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(963),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(963),
    [anon_sym_GT_TILDE] = ACTIONS(963),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(963),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(963),
    [anon_sym_LT_TILDE] = ACTIONS(963),
    [anon_sym_PLUS_QMARK] = ACTIONS(963),
    [anon_sym_DASH_QMARK] = ACTIONS(963),
    [anon_sym_STAR_QMARK] = ACTIONS(963),
    [anon_sym_SLASH_QMARK] = ACTIONS(963),
    [anon_sym_PERCENT_QMARK] = ACTIONS(963),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(963),
    [anon_sym_as] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(963),
    [anon_sym_DOT_GT] = ACTIONS(963),
    [anon_sym_where] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [anon_sym_end] = ACTIONS(963),
    [anon_sym_if] = ACTIONS(965),
    [anon_sym_ifdef] = ACTIONS(963),
    [anon_sym_then] = ACTIONS(963),
    [anon_sym_iftype] = ACTIONS(963),
    [anon_sym_else] = ACTIONS(963),
    [anon_sym_for] = ACTIONS(963),
    [anon_sym_while] = ACTIONS(963),
    [anon_sym_try] = ACTIONS(963),
    [anon_sym_with] = ACTIONS(963),
    [anon_sym_repeat] = ACTIONS(963),
    [anon_sym_until] = ACTIONS(963),
    [anon_sym_do] = ACTIONS(963),
    [anon_sym_recover] = ACTIONS(963),
    [anon_sym_match] = ACTIONS(963),
    [anon_sym_return] = ACTIONS(963),
    [anon_sym_continue] = ACTIONS(963),
    [anon_sym_break] = ACTIONS(963),
    [anon_sym_consume] = ACTIONS(963),
    [anon_sym_object] = ACTIONS(963),
    [sym_number] = ACTIONS(965),
    [sym_float] = ACTIONS(963),
    [anon_sym_DQUOTE] = ACTIONS(965),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(963),
    [anon_sym_SQUOTE] = ACTIONS(963),
    [anon_sym_true] = ACTIONS(963),
    [anon_sym_false] = ACTIONS(963),
    [sym_this] = ACTIONS(963),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [193] = {
    [ts_builtin_sym_end] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1008),
    [anon_sym_use] = ACTIONS(1006),
    [anon_sym_EQ] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_is] = ACTIONS(1008),
    [anon_sym_actor] = ACTIONS(1006),
    [anon_sym_class] = ACTIONS(1006),
    [anon_sym_primitive] = ACTIONS(1006),
    [anon_sym_interface] = ACTIONS(1006),
    [anon_sym_trait] = ACTIONS(1006),
    [anon_sym_struct] = ACTIONS(1006),
    [anon_sym_embed] = ACTIONS(1006),
    [anon_sym_let] = ACTIONS(1006),
    [anon_sym_var] = ACTIONS(1006),
    [anon_sym_new] = ACTIONS(1006),
    [anon_sym_fun] = ACTIONS(1006),
    [anon_sym_be] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(1008),
    [anon_sym_RPAREN] = ACTIONS(1006),
    [anon_sym_DOT] = ACTIONS(1008),
    [anon_sym_LBRACE] = ACTIONS(1006),
    [anon_sym_SEMI] = ACTIONS(1006),
    [sym_error] = ACTIONS(1006),
    [sym_compile_intrinsic] = ACTIONS(1006),
    [anon_sym_compile_error] = ACTIONS(1006),
    [sym_location] = ACTIONS(1006),
    [anon_sym_DASH] = ACTIONS(1008),
    [anon_sym_not] = ACTIONS(1006),
    [anon_sym_DASH_TILDE] = ACTIONS(1006),
    [anon_sym_addressof] = ACTIONS(1006),
    [anon_sym_digestof] = ACTIONS(1006),
    [anon_sym_PLUS] = ACTIONS(1008),
    [anon_sym_STAR] = ACTIONS(1008),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_PERCENT] = ACTIONS(1008),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1008),
    [anon_sym_LT_LT] = ACTIONS(1008),
    [anon_sym_GT_GT] = ACTIONS(1008),
    [anon_sym_and] = ACTIONS(1006),
    [anon_sym_or] = ACTIONS(1006),
    [anon_sym_xor] = ACTIONS(1006),
    [anon_sym_isnt] = ACTIONS(1006),
    [anon_sym_EQ_EQ] = ACTIONS(1008),
    [anon_sym_BANG_EQ] = ACTIONS(1008),
    [anon_sym_GT] = ACTIONS(1008),
    [anon_sym_GT_EQ] = ACTIONS(1008),
    [anon_sym_LT_EQ] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(1008),
    [anon_sym_PLUS_TILDE] = ACTIONS(1006),
    [anon_sym_STAR_TILDE] = ACTIONS(1006),
    [anon_sym_SLASH_TILDE] = ACTIONS(1006),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1006),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1006),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1006),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1006),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1006),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1006),
    [anon_sym_GT_TILDE] = ACTIONS(1006),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1006),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1006),
    [anon_sym_LT_TILDE] = ACTIONS(1006),
    [anon_sym_PLUS_QMARK] = ACTIONS(1006),
    [anon_sym_DASH_QMARK] = ACTIONS(1006),
    [anon_sym_STAR_QMARK] = ACTIONS(1006),
    [anon_sym_SLASH_QMARK] = ACTIONS(1006),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1006),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1006),
    [anon_sym_as] = ACTIONS(1006),
    [anon_sym_LPAREN2] = ACTIONS(1006),
    [anon_sym_DOT_GT] = ACTIONS(1006),
    [anon_sym_where] = ACTIONS(1006),
    [anon_sym_TILDE] = ACTIONS(1006),
    [anon_sym_end] = ACTIONS(1006),
    [anon_sym_if] = ACTIONS(1008),
    [anon_sym_ifdef] = ACTIONS(1006),
    [anon_sym_iftype] = ACTIONS(1006),
    [anon_sym_else] = ACTIONS(1006),
    [anon_sym_for] = ACTIONS(1006),
    [anon_sym_while] = ACTIONS(1006),
    [anon_sym_try] = ACTIONS(1006),
    [anon_sym_with] = ACTIONS(1006),
    [anon_sym_repeat] = ACTIONS(1006),
    [anon_sym_do] = ACTIONS(1006),
    [anon_sym_recover] = ACTIONS(1006),
    [anon_sym_match] = ACTIONS(1006),
    [anon_sym_return] = ACTIONS(1006),
    [anon_sym_continue] = ACTIONS(1006),
    [anon_sym_break] = ACTIONS(1006),
    [anon_sym_consume] = ACTIONS(1006),
    [anon_sym_object] = ACTIONS(1006),
    [sym_number] = ACTIONS(1008),
    [sym_float] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(1006),
    [anon_sym_true] = ACTIONS(1006),
    [anon_sym_false] = ACTIONS(1006),
    [sym_this] = ACTIONS(1006),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(1006),
    [sym_block_comment] = ACTIONS(3),
  },
  [194] = {
    [sym_identifier] = ACTIONS(953),
    [anon_sym_EQ] = ACTIONS(953),
    [anon_sym_AT] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(951),
    [anon_sym_RBRACK] = ACTIONS(951),
    [anon_sym_is] = ACTIONS(953),
    [anon_sym_embed] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_var] = ACTIONS(951),
    [anon_sym_new] = ACTIONS(951),
    [anon_sym_EQ_GT] = ACTIONS(951),
    [anon_sym_fun] = ACTIONS(951),
    [anon_sym_be] = ACTIONS(951),
    [anon_sym_COMMA] = ACTIONS(951),
    [anon_sym_LPAREN] = ACTIONS(953),
    [anon_sym_RPAREN] = ACTIONS(951),
    [anon_sym_DOT] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_CARET] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(951),
    [anon_sym_AMP] = ACTIONS(951),
    [anon_sym_DASH_GT] = ACTIONS(951),
    [anon_sym_LBRACE] = ACTIONS(951),
    [anon_sym_RBRACE] = ACTIONS(951),
    [anon_sym_SEMI] = ACTIONS(951),
    [sym_error] = ACTIONS(951),
    [sym_compile_intrinsic] = ACTIONS(951),
    [anon_sym_compile_error] = ACTIONS(951),
    [sym_location] = ACTIONS(951),
    [anon_sym_DASH] = ACTIONS(953),
    [anon_sym_not] = ACTIONS(951),
    [anon_sym_DASH_TILDE] = ACTIONS(951),
    [anon_sym_addressof] = ACTIONS(951),
    [anon_sym_digestof] = ACTIONS(951),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_STAR] = ACTIONS(953),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_PERCENT] = ACTIONS(953),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(953),
    [anon_sym_LT_LT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(953),
    [anon_sym_and] = ACTIONS(951),
    [anon_sym_or] = ACTIONS(951),
    [anon_sym_xor] = ACTIONS(951),
    [anon_sym_isnt] = ACTIONS(951),
    [anon_sym_EQ_EQ] = ACTIONS(953),
    [anon_sym_BANG_EQ] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_EQ] = ACTIONS(953),
    [anon_sym_LT_EQ] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_PLUS_TILDE] = ACTIONS(951),
    [anon_sym_STAR_TILDE] = ACTIONS(951),
    [anon_sym_SLASH_TILDE] = ACTIONS(951),
    [anon_sym_PERCENT_TILDE] = ACTIONS(951),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(951),
    [anon_sym_LT_LT_TILDE] = ACTIONS(951),
    [anon_sym_GT_GT_TILDE] = ACTIONS(951),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(951),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(951),
    [anon_sym_GT_TILDE] = ACTIONS(951),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(951),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(951),
    [anon_sym_LT_TILDE] = ACTIONS(951),
    [anon_sym_PLUS_QMARK] = ACTIONS(951),
    [anon_sym_DASH_QMARK] = ACTIONS(951),
    [anon_sym_STAR_QMARK] = ACTIONS(951),
    [anon_sym_SLASH_QMARK] = ACTIONS(951),
    [anon_sym_PERCENT_QMARK] = ACTIONS(951),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(951),
    [anon_sym_as] = ACTIONS(951),
    [anon_sym_LPAREN2] = ACTIONS(951),
    [anon_sym_DOT_GT] = ACTIONS(951),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_TILDE] = ACTIONS(951),
    [anon_sym_end] = ACTIONS(951),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_ifdef] = ACTIONS(951),
    [anon_sym_then] = ACTIONS(951),
    [anon_sym_iftype] = ACTIONS(951),
    [anon_sym_else] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(951),
    [anon_sym_try] = ACTIONS(951),
    [anon_sym_with] = ACTIONS(951),
    [anon_sym_repeat] = ACTIONS(951),
    [anon_sym_until] = ACTIONS(951),
    [anon_sym_do] = ACTIONS(951),
    [anon_sym_recover] = ACTIONS(951),
    [anon_sym_match] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(951),
    [anon_sym_continue] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(951),
    [anon_sym_consume] = ACTIONS(951),
    [anon_sym_object] = ACTIONS(951),
    [sym_number] = ACTIONS(953),
    [sym_float] = ACTIONS(951),
    [anon_sym_DQUOTE] = ACTIONS(953),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [anon_sym_SQUOTE] = ACTIONS(951),
    [anon_sym_true] = ACTIONS(951),
    [anon_sym_false] = ACTIONS(951),
    [sym_this] = ACTIONS(951),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [195] = {
    [sym_identifier] = ACTIONS(945),
    [anon_sym_EQ] = ACTIONS(945),
    [anon_sym_AT] = ACTIONS(943),
    [anon_sym_LBRACK] = ACTIONS(943),
    [anon_sym_RBRACK] = ACTIONS(943),
    [anon_sym_is] = ACTIONS(945),
    [anon_sym_embed] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(943),
    [anon_sym_var] = ACTIONS(943),
    [anon_sym_new] = ACTIONS(943),
    [anon_sym_EQ_GT] = ACTIONS(943),
    [anon_sym_fun] = ACTIONS(943),
    [anon_sym_be] = ACTIONS(943),
    [anon_sym_COMMA] = ACTIONS(943),
    [anon_sym_LPAREN] = ACTIONS(945),
    [anon_sym_RPAREN] = ACTIONS(943),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_BANG] = ACTIONS(945),
    [anon_sym_CARET] = ACTIONS(943),
    [anon_sym_PIPE] = ACTIONS(943),
    [anon_sym_AMP] = ACTIONS(943),
    [anon_sym_DASH_GT] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(943),
    [anon_sym_RBRACE] = ACTIONS(943),
    [anon_sym_SEMI] = ACTIONS(943),
    [sym_error] = ACTIONS(943),
    [sym_compile_intrinsic] = ACTIONS(943),
    [anon_sym_compile_error] = ACTIONS(943),
    [sym_location] = ACTIONS(943),
    [anon_sym_DASH] = ACTIONS(945),
    [anon_sym_not] = ACTIONS(943),
    [anon_sym_DASH_TILDE] = ACTIONS(943),
    [anon_sym_addressof] = ACTIONS(943),
    [anon_sym_digestof] = ACTIONS(943),
    [anon_sym_PLUS] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(945),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_PERCENT] = ACTIONS(945),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(945),
    [anon_sym_LT_LT] = ACTIONS(945),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_and] = ACTIONS(943),
    [anon_sym_or] = ACTIONS(943),
    [anon_sym_xor] = ACTIONS(943),
    [anon_sym_isnt] = ACTIONS(943),
    [anon_sym_EQ_EQ] = ACTIONS(945),
    [anon_sym_BANG_EQ] = ACTIONS(945),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_GT_EQ] = ACTIONS(945),
    [anon_sym_LT_EQ] = ACTIONS(945),
    [anon_sym_LT] = ACTIONS(945),
    [anon_sym_PLUS_TILDE] = ACTIONS(943),
    [anon_sym_STAR_TILDE] = ACTIONS(943),
    [anon_sym_SLASH_TILDE] = ACTIONS(943),
    [anon_sym_PERCENT_TILDE] = ACTIONS(943),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(943),
    [anon_sym_LT_LT_TILDE] = ACTIONS(943),
    [anon_sym_GT_GT_TILDE] = ACTIONS(943),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(943),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(943),
    [anon_sym_GT_TILDE] = ACTIONS(943),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(943),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(943),
    [anon_sym_LT_TILDE] = ACTIONS(943),
    [anon_sym_PLUS_QMARK] = ACTIONS(943),
    [anon_sym_DASH_QMARK] = ACTIONS(943),
    [anon_sym_STAR_QMARK] = ACTIONS(943),
    [anon_sym_SLASH_QMARK] = ACTIONS(943),
    [anon_sym_PERCENT_QMARK] = ACTIONS(943),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(943),
    [anon_sym_as] = ACTIONS(943),
    [anon_sym_LPAREN2] = ACTIONS(943),
    [anon_sym_DOT_GT] = ACTIONS(943),
    [anon_sym_where] = ACTIONS(943),
    [anon_sym_TILDE] = ACTIONS(943),
    [anon_sym_end] = ACTIONS(943),
    [anon_sym_if] = ACTIONS(945),
    [anon_sym_ifdef] = ACTIONS(943),
    [anon_sym_then] = ACTIONS(943),
    [anon_sym_iftype] = ACTIONS(943),
    [anon_sym_else] = ACTIONS(943),
    [anon_sym_for] = ACTIONS(943),
    [anon_sym_while] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_with] = ACTIONS(943),
    [anon_sym_repeat] = ACTIONS(943),
    [anon_sym_until] = ACTIONS(943),
    [anon_sym_do] = ACTIONS(943),
    [anon_sym_recover] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(943),
    [anon_sym_return] = ACTIONS(943),
    [anon_sym_continue] = ACTIONS(943),
    [anon_sym_break] = ACTIONS(943),
    [anon_sym_consume] = ACTIONS(943),
    [anon_sym_object] = ACTIONS(943),
    [sym_number] = ACTIONS(945),
    [sym_float] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_true] = ACTIONS(943),
    [anon_sym_false] = ACTIONS(943),
    [sym_this] = ACTIONS(943),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [196] = {
    [sym_identifier] = ACTIONS(929),
    [anon_sym_EQ] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(927),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(927),
    [anon_sym_is] = ACTIONS(929),
    [anon_sym_embed] = ACTIONS(927),
    [anon_sym_let] = ACTIONS(927),
    [anon_sym_var] = ACTIONS(927),
    [anon_sym_new] = ACTIONS(927),
    [anon_sym_EQ_GT] = ACTIONS(927),
    [anon_sym_fun] = ACTIONS(927),
    [anon_sym_be] = ACTIONS(927),
    [anon_sym_COMMA] = ACTIONS(927),
    [anon_sym_LPAREN] = ACTIONS(929),
    [anon_sym_RPAREN] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_CARET] = ACTIONS(927),
    [anon_sym_PIPE] = ACTIONS(927),
    [anon_sym_AMP] = ACTIONS(927),
    [anon_sym_DASH_GT] = ACTIONS(927),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_RBRACE] = ACTIONS(927),
    [anon_sym_SEMI] = ACTIONS(927),
    [sym_error] = ACTIONS(927),
    [sym_compile_intrinsic] = ACTIONS(927),
    [anon_sym_compile_error] = ACTIONS(927),
    [sym_location] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_not] = ACTIONS(927),
    [anon_sym_DASH_TILDE] = ACTIONS(927),
    [anon_sym_addressof] = ACTIONS(927),
    [anon_sym_digestof] = ACTIONS(927),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_PERCENT] = ACTIONS(929),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(929),
    [anon_sym_LT_LT] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(929),
    [anon_sym_and] = ACTIONS(927),
    [anon_sym_or] = ACTIONS(927),
    [anon_sym_xor] = ACTIONS(927),
    [anon_sym_isnt] = ACTIONS(927),
    [anon_sym_EQ_EQ] = ACTIONS(929),
    [anon_sym_BANG_EQ] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_GT_EQ] = ACTIONS(929),
    [anon_sym_LT_EQ] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_PLUS_TILDE] = ACTIONS(927),
    [anon_sym_STAR_TILDE] = ACTIONS(927),
    [anon_sym_SLASH_TILDE] = ACTIONS(927),
    [anon_sym_PERCENT_TILDE] = ACTIONS(927),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(927),
    [anon_sym_LT_LT_TILDE] = ACTIONS(927),
    [anon_sym_GT_GT_TILDE] = ACTIONS(927),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(927),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(927),
    [anon_sym_GT_TILDE] = ACTIONS(927),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(927),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(927),
    [anon_sym_LT_TILDE] = ACTIONS(927),
    [anon_sym_PLUS_QMARK] = ACTIONS(927),
    [anon_sym_DASH_QMARK] = ACTIONS(927),
    [anon_sym_STAR_QMARK] = ACTIONS(927),
    [anon_sym_SLASH_QMARK] = ACTIONS(927),
    [anon_sym_PERCENT_QMARK] = ACTIONS(927),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(927),
    [anon_sym_as] = ACTIONS(927),
    [anon_sym_LPAREN2] = ACTIONS(927),
    [anon_sym_DOT_GT] = ACTIONS(927),
    [anon_sym_where] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(927),
    [anon_sym_end] = ACTIONS(927),
    [anon_sym_if] = ACTIONS(929),
    [anon_sym_ifdef] = ACTIONS(927),
    [anon_sym_then] = ACTIONS(927),
    [anon_sym_iftype] = ACTIONS(927),
    [anon_sym_else] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(927),
    [anon_sym_try] = ACTIONS(927),
    [anon_sym_with] = ACTIONS(927),
    [anon_sym_repeat] = ACTIONS(927),
    [anon_sym_until] = ACTIONS(927),
    [anon_sym_do] = ACTIONS(927),
    [anon_sym_recover] = ACTIONS(927),
    [anon_sym_match] = ACTIONS(927),
    [anon_sym_return] = ACTIONS(927),
    [anon_sym_continue] = ACTIONS(927),
    [anon_sym_break] = ACTIONS(927),
    [anon_sym_consume] = ACTIONS(927),
    [anon_sym_object] = ACTIONS(927),
    [sym_number] = ACTIONS(929),
    [sym_float] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(929),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(927),
    [anon_sym_true] = ACTIONS(927),
    [anon_sym_false] = ACTIONS(927),
    [sym_this] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [197] = {
    [ts_builtin_sym_end] = ACTIONS(1010),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_use] = ACTIONS(1010),
    [anon_sym_EQ] = ACTIONS(1012),
    [anon_sym_AT] = ACTIONS(1010),
    [anon_sym_LBRACK] = ACTIONS(1010),
    [anon_sym_type] = ACTIONS(1010),
    [anon_sym_is] = ACTIONS(1012),
    [anon_sym_actor] = ACTIONS(1010),
    [anon_sym_class] = ACTIONS(1010),
    [anon_sym_primitive] = ACTIONS(1010),
    [anon_sym_interface] = ACTIONS(1010),
    [anon_sym_trait] = ACTIONS(1010),
    [anon_sym_struct] = ACTIONS(1010),
    [anon_sym_embed] = ACTIONS(1010),
    [anon_sym_let] = ACTIONS(1010),
    [anon_sym_var] = ACTIONS(1010),
    [anon_sym_COLON] = ACTIONS(1014),
    [anon_sym_new] = ACTIONS(1010),
    [anon_sym_fun] = ACTIONS(1010),
    [anon_sym_be] = ACTIONS(1010),
    [anon_sym_COMMA] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1012),
    [anon_sym_RPAREN] = ACTIONS(1010),
    [anon_sym_DOT] = ACTIONS(1012),
    [anon_sym_LBRACE] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(1010),
    [sym_error] = ACTIONS(1010),
    [sym_compile_intrinsic] = ACTIONS(1010),
    [anon_sym_compile_error] = ACTIONS(1010),
    [sym_location] = ACTIONS(1010),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_not] = ACTIONS(1010),
    [anon_sym_DASH_TILDE] = ACTIONS(1010),
    [anon_sym_addressof] = ACTIONS(1010),
    [anon_sym_digestof] = ACTIONS(1010),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_STAR] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1012),
    [anon_sym_PERCENT] = ACTIONS(1012),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1012),
    [anon_sym_LT_LT] = ACTIONS(1012),
    [anon_sym_GT_GT] = ACTIONS(1012),
    [anon_sym_and] = ACTIONS(1010),
    [anon_sym_or] = ACTIONS(1010),
    [anon_sym_xor] = ACTIONS(1010),
    [anon_sym_isnt] = ACTIONS(1010),
    [anon_sym_EQ_EQ] = ACTIONS(1012),
    [anon_sym_BANG_EQ] = ACTIONS(1012),
    [anon_sym_GT] = ACTIONS(1012),
    [anon_sym_GT_EQ] = ACTIONS(1012),
    [anon_sym_LT_EQ] = ACTIONS(1012),
    [anon_sym_LT] = ACTIONS(1012),
    [anon_sym_PLUS_TILDE] = ACTIONS(1010),
    [anon_sym_STAR_TILDE] = ACTIONS(1010),
    [anon_sym_SLASH_TILDE] = ACTIONS(1010),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1010),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1010),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1010),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1010),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1010),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1010),
    [anon_sym_GT_TILDE] = ACTIONS(1010),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1010),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1010),
    [anon_sym_LT_TILDE] = ACTIONS(1010),
    [anon_sym_PLUS_QMARK] = ACTIONS(1010),
    [anon_sym_DASH_QMARK] = ACTIONS(1010),
    [anon_sym_STAR_QMARK] = ACTIONS(1010),
    [anon_sym_SLASH_QMARK] = ACTIONS(1010),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1010),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1010),
    [anon_sym_as] = ACTIONS(1010),
    [anon_sym_LPAREN2] = ACTIONS(1010),
    [anon_sym_DOT_GT] = ACTIONS(1010),
    [anon_sym_where] = ACTIONS(1010),
    [anon_sym_TILDE] = ACTIONS(1010),
    [anon_sym_end] = ACTIONS(1010),
    [anon_sym_if] = ACTIONS(1012),
    [anon_sym_ifdef] = ACTIONS(1010),
    [anon_sym_iftype] = ACTIONS(1010),
    [anon_sym_else] = ACTIONS(1010),
    [anon_sym_for] = ACTIONS(1010),
    [anon_sym_while] = ACTIONS(1010),
    [anon_sym_try] = ACTIONS(1010),
    [anon_sym_with] = ACTIONS(1010),
    [anon_sym_repeat] = ACTIONS(1010),
    [anon_sym_do] = ACTIONS(1010),
    [anon_sym_recover] = ACTIONS(1010),
    [anon_sym_match] = ACTIONS(1010),
    [anon_sym_return] = ACTIONS(1010),
    [anon_sym_continue] = ACTIONS(1010),
    [anon_sym_break] = ACTIONS(1010),
    [anon_sym_consume] = ACTIONS(1010),
    [anon_sym_object] = ACTIONS(1010),
    [sym_number] = ACTIONS(1012),
    [sym_float] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1012),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1010),
    [anon_sym_SQUOTE] = ACTIONS(1010),
    [anon_sym_true] = ACTIONS(1010),
    [anon_sym_false] = ACTIONS(1010),
    [sym_this] = ACTIONS(1010),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [198] = {
    [sym_identifier] = ACTIONS(913),
    [anon_sym_EQ] = ACTIONS(913),
    [anon_sym_AT] = ACTIONS(911),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_RBRACK] = ACTIONS(911),
    [anon_sym_is] = ACTIONS(913),
    [anon_sym_embed] = ACTIONS(911),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_var] = ACTIONS(911),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_EQ_GT] = ACTIONS(911),
    [anon_sym_fun] = ACTIONS(911),
    [anon_sym_be] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(911),
    [anon_sym_LPAREN] = ACTIONS(913),
    [anon_sym_RPAREN] = ACTIONS(911),
    [anon_sym_DOT] = ACTIONS(913),
    [anon_sym_BANG] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_DASH_GT] = ACTIONS(911),
    [anon_sym_LBRACE] = ACTIONS(911),
    [anon_sym_RBRACE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(911),
    [sym_error] = ACTIONS(911),
    [sym_compile_intrinsic] = ACTIONS(911),
    [anon_sym_compile_error] = ACTIONS(911),
    [sym_location] = ACTIONS(911),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_DASH_TILDE] = ACTIONS(911),
    [anon_sym_addressof] = ACTIONS(911),
    [anon_sym_digestof] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(913),
    [anon_sym_SLASH] = ACTIONS(913),
    [anon_sym_PERCENT] = ACTIONS(913),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(913),
    [anon_sym_LT_LT] = ACTIONS(913),
    [anon_sym_GT_GT] = ACTIONS(913),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_xor] = ACTIONS(911),
    [anon_sym_isnt] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(913),
    [anon_sym_BANG_EQ] = ACTIONS(913),
    [anon_sym_GT] = ACTIONS(913),
    [anon_sym_GT_EQ] = ACTIONS(913),
    [anon_sym_LT_EQ] = ACTIONS(913),
    [anon_sym_LT] = ACTIONS(913),
    [anon_sym_PLUS_TILDE] = ACTIONS(911),
    [anon_sym_STAR_TILDE] = ACTIONS(911),
    [anon_sym_SLASH_TILDE] = ACTIONS(911),
    [anon_sym_PERCENT_TILDE] = ACTIONS(911),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(911),
    [anon_sym_LT_LT_TILDE] = ACTIONS(911),
    [anon_sym_GT_GT_TILDE] = ACTIONS(911),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(911),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(911),
    [anon_sym_GT_TILDE] = ACTIONS(911),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(911),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(911),
    [anon_sym_LT_TILDE] = ACTIONS(911),
    [anon_sym_PLUS_QMARK] = ACTIONS(911),
    [anon_sym_DASH_QMARK] = ACTIONS(911),
    [anon_sym_STAR_QMARK] = ACTIONS(911),
    [anon_sym_SLASH_QMARK] = ACTIONS(911),
    [anon_sym_PERCENT_QMARK] = ACTIONS(911),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(911),
    [anon_sym_LPAREN2] = ACTIONS(911),
    [anon_sym_DOT_GT] = ACTIONS(911),
    [anon_sym_where] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(911),
    [anon_sym_end] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(913),
    [anon_sym_ifdef] = ACTIONS(911),
    [anon_sym_then] = ACTIONS(911),
    [anon_sym_iftype] = ACTIONS(911),
    [anon_sym_else] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(911),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_try] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(911),
    [anon_sym_repeat] = ACTIONS(911),
    [anon_sym_until] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_recover] = ACTIONS(911),
    [anon_sym_match] = ACTIONS(911),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_continue] = ACTIONS(911),
    [anon_sym_break] = ACTIONS(911),
    [anon_sym_consume] = ACTIONS(911),
    [anon_sym_object] = ACTIONS(911),
    [sym_number] = ACTIONS(913),
    [sym_float] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(911),
    [anon_sym_SQUOTE] = ACTIONS(911),
    [anon_sym_true] = ACTIONS(911),
    [anon_sym_false] = ACTIONS(911),
    [sym_this] = ACTIONS(911),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [199] = {
    [sym_identifier] = ACTIONS(905),
    [anon_sym_EQ] = ACTIONS(905),
    [anon_sym_AT] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(903),
    [anon_sym_RBRACK] = ACTIONS(903),
    [anon_sym_is] = ACTIONS(905),
    [anon_sym_embed] = ACTIONS(903),
    [anon_sym_let] = ACTIONS(903),
    [anon_sym_var] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(903),
    [anon_sym_EQ_GT] = ACTIONS(903),
    [anon_sym_fun] = ACTIONS(903),
    [anon_sym_be] = ACTIONS(903),
    [anon_sym_COMMA] = ACTIONS(903),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(903),
    [anon_sym_DOT] = ACTIONS(905),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_CARET] = ACTIONS(903),
    [anon_sym_PIPE] = ACTIONS(903),
    [anon_sym_AMP] = ACTIONS(903),
    [anon_sym_DASH_GT] = ACTIONS(903),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_RBRACE] = ACTIONS(903),
    [anon_sym_SEMI] = ACTIONS(903),
    [sym_error] = ACTIONS(903),
    [sym_compile_intrinsic] = ACTIONS(903),
    [anon_sym_compile_error] = ACTIONS(903),
    [sym_location] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_not] = ACTIONS(903),
    [anon_sym_DASH_TILDE] = ACTIONS(903),
    [anon_sym_addressof] = ACTIONS(903),
    [anon_sym_digestof] = ACTIONS(903),
    [anon_sym_PLUS] = ACTIONS(905),
    [anon_sym_STAR] = ACTIONS(905),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_PERCENT] = ACTIONS(905),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(905),
    [anon_sym_LT_LT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(905),
    [anon_sym_and] = ACTIONS(903),
    [anon_sym_or] = ACTIONS(903),
    [anon_sym_xor] = ACTIONS(903),
    [anon_sym_isnt] = ACTIONS(903),
    [anon_sym_EQ_EQ] = ACTIONS(905),
    [anon_sym_BANG_EQ] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_EQ] = ACTIONS(905),
    [anon_sym_LT_EQ] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_PLUS_TILDE] = ACTIONS(903),
    [anon_sym_STAR_TILDE] = ACTIONS(903),
    [anon_sym_SLASH_TILDE] = ACTIONS(903),
    [anon_sym_PERCENT_TILDE] = ACTIONS(903),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(903),
    [anon_sym_LT_LT_TILDE] = ACTIONS(903),
    [anon_sym_GT_GT_TILDE] = ACTIONS(903),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(903),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(903),
    [anon_sym_GT_TILDE] = ACTIONS(903),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(903),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(903),
    [anon_sym_LT_TILDE] = ACTIONS(903),
    [anon_sym_PLUS_QMARK] = ACTIONS(903),
    [anon_sym_DASH_QMARK] = ACTIONS(903),
    [anon_sym_STAR_QMARK] = ACTIONS(903),
    [anon_sym_SLASH_QMARK] = ACTIONS(903),
    [anon_sym_PERCENT_QMARK] = ACTIONS(903),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(903),
    [anon_sym_as] = ACTIONS(903),
    [anon_sym_LPAREN2] = ACTIONS(903),
    [anon_sym_DOT_GT] = ACTIONS(903),
    [anon_sym_where] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(903),
    [anon_sym_end] = ACTIONS(903),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_ifdef] = ACTIONS(903),
    [anon_sym_then] = ACTIONS(903),
    [anon_sym_iftype] = ACTIONS(903),
    [anon_sym_else] = ACTIONS(903),
    [anon_sym_for] = ACTIONS(903),
    [anon_sym_while] = ACTIONS(903),
    [anon_sym_try] = ACTIONS(903),
    [anon_sym_with] = ACTIONS(903),
    [anon_sym_repeat] = ACTIONS(903),
    [anon_sym_until] = ACTIONS(903),
    [anon_sym_do] = ACTIONS(903),
    [anon_sym_recover] = ACTIONS(903),
    [anon_sym_match] = ACTIONS(903),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_continue] = ACTIONS(903),
    [anon_sym_break] = ACTIONS(903),
    [anon_sym_consume] = ACTIONS(903),
    [anon_sym_object] = ACTIONS(903),
    [sym_number] = ACTIONS(905),
    [sym_float] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(903),
    [anon_sym_SQUOTE] = ACTIONS(903),
    [anon_sym_true] = ACTIONS(903),
    [anon_sym_false] = ACTIONS(903),
    [sym_this] = ACTIONS(903),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [200] = {
    [sym_identifier] = ACTIONS(909),
    [anon_sym_EQ] = ACTIONS(909),
    [anon_sym_AT] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(907),
    [anon_sym_RBRACK] = ACTIONS(907),
    [anon_sym_is] = ACTIONS(909),
    [anon_sym_embed] = ACTIONS(907),
    [anon_sym_let] = ACTIONS(907),
    [anon_sym_var] = ACTIONS(907),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_EQ_GT] = ACTIONS(907),
    [anon_sym_fun] = ACTIONS(907),
    [anon_sym_be] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(907),
    [anon_sym_LPAREN] = ACTIONS(909),
    [anon_sym_RPAREN] = ACTIONS(907),
    [anon_sym_DOT] = ACTIONS(909),
    [anon_sym_BANG] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(907),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_DASH_GT] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_RBRACE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(907),
    [sym_error] = ACTIONS(907),
    [sym_compile_intrinsic] = ACTIONS(907),
    [anon_sym_compile_error] = ACTIONS(907),
    [sym_location] = ACTIONS(907),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_not] = ACTIONS(907),
    [anon_sym_DASH_TILDE] = ACTIONS(907),
    [anon_sym_addressof] = ACTIONS(907),
    [anon_sym_digestof] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_STAR] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_and] = ACTIONS(907),
    [anon_sym_or] = ACTIONS(907),
    [anon_sym_xor] = ACTIONS(907),
    [anon_sym_isnt] = ACTIONS(907),
    [anon_sym_EQ_EQ] = ACTIONS(909),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_GT] = ACTIONS(909),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(909),
    [anon_sym_PLUS_TILDE] = ACTIONS(907),
    [anon_sym_STAR_TILDE] = ACTIONS(907),
    [anon_sym_SLASH_TILDE] = ACTIONS(907),
    [anon_sym_PERCENT_TILDE] = ACTIONS(907),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(907),
    [anon_sym_LT_LT_TILDE] = ACTIONS(907),
    [anon_sym_GT_GT_TILDE] = ACTIONS(907),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(907),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(907),
    [anon_sym_GT_TILDE] = ACTIONS(907),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(907),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(907),
    [anon_sym_LT_TILDE] = ACTIONS(907),
    [anon_sym_PLUS_QMARK] = ACTIONS(907),
    [anon_sym_DASH_QMARK] = ACTIONS(907),
    [anon_sym_STAR_QMARK] = ACTIONS(907),
    [anon_sym_SLASH_QMARK] = ACTIONS(907),
    [anon_sym_PERCENT_QMARK] = ACTIONS(907),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(907),
    [anon_sym_as] = ACTIONS(907),
    [anon_sym_LPAREN2] = ACTIONS(907),
    [anon_sym_DOT_GT] = ACTIONS(907),
    [anon_sym_where] = ACTIONS(907),
    [anon_sym_TILDE] = ACTIONS(907),
    [anon_sym_end] = ACTIONS(907),
    [anon_sym_if] = ACTIONS(909),
    [anon_sym_ifdef] = ACTIONS(907),
    [anon_sym_then] = ACTIONS(907),
    [anon_sym_iftype] = ACTIONS(907),
    [anon_sym_else] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(907),
    [anon_sym_while] = ACTIONS(907),
    [anon_sym_try] = ACTIONS(907),
    [anon_sym_with] = ACTIONS(907),
    [anon_sym_repeat] = ACTIONS(907),
    [anon_sym_until] = ACTIONS(907),
    [anon_sym_do] = ACTIONS(907),
    [anon_sym_recover] = ACTIONS(907),
    [anon_sym_match] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(907),
    [anon_sym_continue] = ACTIONS(907),
    [anon_sym_break] = ACTIONS(907),
    [anon_sym_consume] = ACTIONS(907),
    [anon_sym_object] = ACTIONS(907),
    [sym_number] = ACTIONS(909),
    [sym_float] = ACTIONS(907),
    [anon_sym_DQUOTE] = ACTIONS(909),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(907),
    [anon_sym_SQUOTE] = ACTIONS(907),
    [anon_sym_true] = ACTIONS(907),
    [anon_sym_false] = ACTIONS(907),
    [sym_this] = ACTIONS(907),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [201] = {
    [ts_builtin_sym_end] = ACTIONS(1016),
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_use] = ACTIONS(1016),
    [anon_sym_EQ] = ACTIONS(1018),
    [anon_sym_AT] = ACTIONS(1016),
    [anon_sym_LBRACK] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1016),
    [anon_sym_is] = ACTIONS(1018),
    [anon_sym_actor] = ACTIONS(1016),
    [anon_sym_class] = ACTIONS(1016),
    [anon_sym_primitive] = ACTIONS(1016),
    [anon_sym_interface] = ACTIONS(1016),
    [anon_sym_trait] = ACTIONS(1016),
    [anon_sym_struct] = ACTIONS(1016),
    [anon_sym_embed] = ACTIONS(1016),
    [anon_sym_let] = ACTIONS(1016),
    [anon_sym_var] = ACTIONS(1016),
    [anon_sym_new] = ACTIONS(1016),
    [anon_sym_fun] = ACTIONS(1016),
    [anon_sym_be] = ACTIONS(1016),
    [anon_sym_COMMA] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(1016),
    [anon_sym_DOT] = ACTIONS(1018),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_SEMI] = ACTIONS(1016),
    [sym_error] = ACTIONS(1016),
    [sym_compile_intrinsic] = ACTIONS(1016),
    [anon_sym_compile_error] = ACTIONS(1016),
    [sym_location] = ACTIONS(1016),
    [anon_sym_DASH] = ACTIONS(1018),
    [anon_sym_not] = ACTIONS(1016),
    [anon_sym_DASH_TILDE] = ACTIONS(1016),
    [anon_sym_addressof] = ACTIONS(1016),
    [anon_sym_digestof] = ACTIONS(1016),
    [anon_sym_PLUS] = ACTIONS(1018),
    [anon_sym_STAR] = ACTIONS(1018),
    [anon_sym_SLASH] = ACTIONS(1018),
    [anon_sym_PERCENT] = ACTIONS(1018),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1018),
    [anon_sym_LT_LT] = ACTIONS(1018),
    [anon_sym_GT_GT] = ACTIONS(1018),
    [anon_sym_and] = ACTIONS(1016),
    [anon_sym_or] = ACTIONS(1016),
    [anon_sym_xor] = ACTIONS(1016),
    [anon_sym_isnt] = ACTIONS(1016),
    [anon_sym_EQ_EQ] = ACTIONS(1018),
    [anon_sym_BANG_EQ] = ACTIONS(1018),
    [anon_sym_GT] = ACTIONS(1018),
    [anon_sym_GT_EQ] = ACTIONS(1018),
    [anon_sym_LT_EQ] = ACTIONS(1018),
    [anon_sym_LT] = ACTIONS(1018),
    [anon_sym_PLUS_TILDE] = ACTIONS(1016),
    [anon_sym_STAR_TILDE] = ACTIONS(1016),
    [anon_sym_SLASH_TILDE] = ACTIONS(1016),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1016),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1016),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1016),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1016),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1016),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1016),
    [anon_sym_GT_TILDE] = ACTIONS(1016),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1016),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1016),
    [anon_sym_LT_TILDE] = ACTIONS(1016),
    [anon_sym_PLUS_QMARK] = ACTIONS(1016),
    [anon_sym_DASH_QMARK] = ACTIONS(1016),
    [anon_sym_STAR_QMARK] = ACTIONS(1016),
    [anon_sym_SLASH_QMARK] = ACTIONS(1016),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1016),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1016),
    [anon_sym_as] = ACTIONS(1016),
    [anon_sym_LPAREN2] = ACTIONS(1016),
    [anon_sym_DOT_GT] = ACTIONS(1016),
    [anon_sym_where] = ACTIONS(1016),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_end] = ACTIONS(1016),
    [anon_sym_if] = ACTIONS(1018),
    [anon_sym_ifdef] = ACTIONS(1016),
    [anon_sym_iftype] = ACTIONS(1016),
    [anon_sym_else] = ACTIONS(1016),
    [anon_sym_for] = ACTIONS(1016),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_try] = ACTIONS(1016),
    [anon_sym_with] = ACTIONS(1016),
    [anon_sym_repeat] = ACTIONS(1016),
    [anon_sym_do] = ACTIONS(1016),
    [anon_sym_recover] = ACTIONS(1016),
    [anon_sym_match] = ACTIONS(1016),
    [anon_sym_return] = ACTIONS(1016),
    [anon_sym_continue] = ACTIONS(1016),
    [anon_sym_break] = ACTIONS(1016),
    [anon_sym_consume] = ACTIONS(1016),
    [anon_sym_object] = ACTIONS(1016),
    [sym_number] = ACTIONS(1018),
    [sym_float] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(1018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1016),
    [anon_sym_SQUOTE] = ACTIONS(1016),
    [anon_sym_true] = ACTIONS(1016),
    [anon_sym_false] = ACTIONS(1016),
    [sym_this] = ACTIONS(1016),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(1016),
    [sym_block_comment] = ACTIONS(3),
  },
  [202] = {
    [ts_builtin_sym_end] = ACTIONS(1020),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_use] = ACTIONS(1020),
    [anon_sym_EQ] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_type] = ACTIONS(1020),
    [anon_sym_is] = ACTIONS(1022),
    [anon_sym_actor] = ACTIONS(1020),
    [anon_sym_class] = ACTIONS(1020),
    [anon_sym_primitive] = ACTIONS(1020),
    [anon_sym_interface] = ACTIONS(1020),
    [anon_sym_trait] = ACTIONS(1020),
    [anon_sym_struct] = ACTIONS(1020),
    [anon_sym_embed] = ACTIONS(1020),
    [anon_sym_let] = ACTIONS(1020),
    [anon_sym_var] = ACTIONS(1020),
    [anon_sym_new] = ACTIONS(1020),
    [anon_sym_fun] = ACTIONS(1020),
    [anon_sym_be] = ACTIONS(1020),
    [anon_sym_COMMA] = ACTIONS(1020),
    [anon_sym_LPAREN] = ACTIONS(1022),
    [anon_sym_RPAREN] = ACTIONS(1020),
    [anon_sym_DOT] = ACTIONS(1022),
    [anon_sym_LBRACE] = ACTIONS(1020),
    [anon_sym_SEMI] = ACTIONS(1020),
    [sym_error] = ACTIONS(1020),
    [sym_compile_intrinsic] = ACTIONS(1020),
    [anon_sym_compile_error] = ACTIONS(1020),
    [sym_location] = ACTIONS(1020),
    [anon_sym_DASH] = ACTIONS(1022),
    [anon_sym_not] = ACTIONS(1020),
    [anon_sym_DASH_TILDE] = ACTIONS(1020),
    [anon_sym_addressof] = ACTIONS(1020),
    [anon_sym_digestof] = ACTIONS(1020),
    [anon_sym_PLUS] = ACTIONS(1022),
    [anon_sym_STAR] = ACTIONS(1022),
    [anon_sym_SLASH] = ACTIONS(1022),
    [anon_sym_PERCENT] = ACTIONS(1022),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1022),
    [anon_sym_LT_LT] = ACTIONS(1022),
    [anon_sym_GT_GT] = ACTIONS(1022),
    [anon_sym_and] = ACTIONS(1020),
    [anon_sym_or] = ACTIONS(1020),
    [anon_sym_xor] = ACTIONS(1020),
    [anon_sym_isnt] = ACTIONS(1020),
    [anon_sym_EQ_EQ] = ACTIONS(1022),
    [anon_sym_BANG_EQ] = ACTIONS(1022),
    [anon_sym_GT] = ACTIONS(1022),
    [anon_sym_GT_EQ] = ACTIONS(1022),
    [anon_sym_LT_EQ] = ACTIONS(1022),
    [anon_sym_LT] = ACTIONS(1022),
    [anon_sym_PLUS_TILDE] = ACTIONS(1020),
    [anon_sym_STAR_TILDE] = ACTIONS(1020),
    [anon_sym_SLASH_TILDE] = ACTIONS(1020),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1020),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1020),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1020),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1020),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1020),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1020),
    [anon_sym_GT_TILDE] = ACTIONS(1020),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1020),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1020),
    [anon_sym_LT_TILDE] = ACTIONS(1020),
    [anon_sym_PLUS_QMARK] = ACTIONS(1020),
    [anon_sym_DASH_QMARK] = ACTIONS(1020),
    [anon_sym_STAR_QMARK] = ACTIONS(1020),
    [anon_sym_SLASH_QMARK] = ACTIONS(1020),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1020),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1020),
    [anon_sym_as] = ACTIONS(1020),
    [anon_sym_LPAREN2] = ACTIONS(1020),
    [anon_sym_DOT_GT] = ACTIONS(1020),
    [anon_sym_where] = ACTIONS(1020),
    [anon_sym_TILDE] = ACTIONS(1020),
    [anon_sym_end] = ACTIONS(1020),
    [anon_sym_if] = ACTIONS(1022),
    [anon_sym_ifdef] = ACTIONS(1020),
    [anon_sym_iftype] = ACTIONS(1020),
    [anon_sym_else] = ACTIONS(1020),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_while] = ACTIONS(1020),
    [anon_sym_try] = ACTIONS(1020),
    [anon_sym_with] = ACTIONS(1020),
    [anon_sym_repeat] = ACTIONS(1020),
    [anon_sym_do] = ACTIONS(1020),
    [anon_sym_recover] = ACTIONS(1020),
    [anon_sym_match] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(1020),
    [anon_sym_continue] = ACTIONS(1020),
    [anon_sym_break] = ACTIONS(1020),
    [anon_sym_consume] = ACTIONS(1020),
    [anon_sym_object] = ACTIONS(1020),
    [sym_number] = ACTIONS(1022),
    [sym_float] = ACTIONS(1020),
    [anon_sym_DQUOTE] = ACTIONS(1022),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1020),
    [anon_sym_SQUOTE] = ACTIONS(1020),
    [anon_sym_true] = ACTIONS(1020),
    [anon_sym_false] = ACTIONS(1020),
    [sym_this] = ACTIONS(1020),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(1020),
    [sym_block_comment] = ACTIONS(3),
  },
  [203] = {
    [ts_builtin_sym_end] = ACTIONS(1024),
    [sym_identifier] = ACTIONS(1026),
    [anon_sym_use] = ACTIONS(1024),
    [anon_sym_EQ] = ACTIONS(1026),
    [anon_sym_AT] = ACTIONS(1024),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_type] = ACTIONS(1024),
    [anon_sym_is] = ACTIONS(1026),
    [anon_sym_actor] = ACTIONS(1024),
    [anon_sym_class] = ACTIONS(1024),
    [anon_sym_primitive] = ACTIONS(1024),
    [anon_sym_interface] = ACTIONS(1024),
    [anon_sym_trait] = ACTIONS(1024),
    [anon_sym_struct] = ACTIONS(1024),
    [anon_sym_embed] = ACTIONS(1024),
    [anon_sym_let] = ACTIONS(1024),
    [anon_sym_var] = ACTIONS(1024),
    [anon_sym_new] = ACTIONS(1024),
    [anon_sym_fun] = ACTIONS(1024),
    [anon_sym_be] = ACTIONS(1024),
    [anon_sym_COMMA] = ACTIONS(1024),
    [anon_sym_LPAREN] = ACTIONS(1026),
    [anon_sym_RPAREN] = ACTIONS(1024),
    [anon_sym_DOT] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1024),
    [anon_sym_SEMI] = ACTIONS(1024),
    [sym_error] = ACTIONS(1024),
    [sym_compile_intrinsic] = ACTIONS(1024),
    [anon_sym_compile_error] = ACTIONS(1024),
    [sym_location] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1026),
    [anon_sym_not] = ACTIONS(1024),
    [anon_sym_DASH_TILDE] = ACTIONS(1024),
    [anon_sym_addressof] = ACTIONS(1024),
    [anon_sym_digestof] = ACTIONS(1024),
    [anon_sym_PLUS] = ACTIONS(1026),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_SLASH] = ACTIONS(1026),
    [anon_sym_PERCENT] = ACTIONS(1026),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1026),
    [anon_sym_LT_LT] = ACTIONS(1026),
    [anon_sym_GT_GT] = ACTIONS(1026),
    [anon_sym_and] = ACTIONS(1024),
    [anon_sym_or] = ACTIONS(1024),
    [anon_sym_xor] = ACTIONS(1024),
    [anon_sym_isnt] = ACTIONS(1024),
    [anon_sym_EQ_EQ] = ACTIONS(1026),
    [anon_sym_BANG_EQ] = ACTIONS(1026),
    [anon_sym_GT] = ACTIONS(1026),
    [anon_sym_GT_EQ] = ACTIONS(1026),
    [anon_sym_LT_EQ] = ACTIONS(1026),
    [anon_sym_LT] = ACTIONS(1026),
    [anon_sym_PLUS_TILDE] = ACTIONS(1024),
    [anon_sym_STAR_TILDE] = ACTIONS(1024),
    [anon_sym_SLASH_TILDE] = ACTIONS(1024),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1024),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1024),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1024),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1024),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1024),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1024),
    [anon_sym_GT_TILDE] = ACTIONS(1024),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1024),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1024),
    [anon_sym_LT_TILDE] = ACTIONS(1024),
    [anon_sym_PLUS_QMARK] = ACTIONS(1024),
    [anon_sym_DASH_QMARK] = ACTIONS(1024),
    [anon_sym_STAR_QMARK] = ACTIONS(1024),
    [anon_sym_SLASH_QMARK] = ACTIONS(1024),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1024),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1024),
    [anon_sym_as] = ACTIONS(1024),
    [anon_sym_LPAREN2] = ACTIONS(1024),
    [anon_sym_DOT_GT] = ACTIONS(1024),
    [anon_sym_where] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1024),
    [anon_sym_end] = ACTIONS(1024),
    [anon_sym_if] = ACTIONS(1026),
    [anon_sym_ifdef] = ACTIONS(1024),
    [anon_sym_iftype] = ACTIONS(1024),
    [anon_sym_else] = ACTIONS(1024),
    [anon_sym_for] = ACTIONS(1024),
    [anon_sym_while] = ACTIONS(1024),
    [anon_sym_try] = ACTIONS(1024),
    [anon_sym_with] = ACTIONS(1024),
    [anon_sym_repeat] = ACTIONS(1024),
    [anon_sym_do] = ACTIONS(1024),
    [anon_sym_recover] = ACTIONS(1024),
    [anon_sym_match] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1024),
    [anon_sym_continue] = ACTIONS(1024),
    [anon_sym_break] = ACTIONS(1024),
    [anon_sym_consume] = ACTIONS(1024),
    [anon_sym_object] = ACTIONS(1024),
    [sym_number] = ACTIONS(1026),
    [sym_float] = ACTIONS(1024),
    [anon_sym_DQUOTE] = ACTIONS(1026),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1024),
    [anon_sym_SQUOTE] = ACTIONS(1024),
    [anon_sym_true] = ACTIONS(1024),
    [anon_sym_false] = ACTIONS(1024),
    [sym_this] = ACTIONS(1024),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(1024),
    [sym_block_comment] = ACTIONS(3),
  },
  [204] = {
    [ts_builtin_sym_end] = ACTIONS(1028),
    [sym_identifier] = ACTIONS(1030),
    [anon_sym_use] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(1030),
    [anon_sym_AT] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(1028),
    [anon_sym_type] = ACTIONS(1028),
    [anon_sym_is] = ACTIONS(1030),
    [anon_sym_actor] = ACTIONS(1028),
    [anon_sym_class] = ACTIONS(1028),
    [anon_sym_primitive] = ACTIONS(1028),
    [anon_sym_interface] = ACTIONS(1028),
    [anon_sym_trait] = ACTIONS(1028),
    [anon_sym_struct] = ACTIONS(1028),
    [anon_sym_embed] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(1028),
    [anon_sym_var] = ACTIONS(1028),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_fun] = ACTIONS(1028),
    [anon_sym_be] = ACTIONS(1028),
    [anon_sym_COMMA] = ACTIONS(1028),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_RPAREN] = ACTIONS(1028),
    [anon_sym_DOT] = ACTIONS(1030),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_SEMI] = ACTIONS(1028),
    [sym_error] = ACTIONS(1028),
    [sym_compile_intrinsic] = ACTIONS(1028),
    [anon_sym_compile_error] = ACTIONS(1028),
    [sym_location] = ACTIONS(1028),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_not] = ACTIONS(1028),
    [anon_sym_DASH_TILDE] = ACTIONS(1028),
    [anon_sym_addressof] = ACTIONS(1028),
    [anon_sym_digestof] = ACTIONS(1028),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_STAR] = ACTIONS(1030),
    [anon_sym_SLASH] = ACTIONS(1030),
    [anon_sym_PERCENT] = ACTIONS(1030),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1030),
    [anon_sym_LT_LT] = ACTIONS(1030),
    [anon_sym_GT_GT] = ACTIONS(1030),
    [anon_sym_and] = ACTIONS(1028),
    [anon_sym_or] = ACTIONS(1028),
    [anon_sym_xor] = ACTIONS(1028),
    [anon_sym_isnt] = ACTIONS(1028),
    [anon_sym_EQ_EQ] = ACTIONS(1030),
    [anon_sym_BANG_EQ] = ACTIONS(1030),
    [anon_sym_GT] = ACTIONS(1030),
    [anon_sym_GT_EQ] = ACTIONS(1030),
    [anon_sym_LT_EQ] = ACTIONS(1030),
    [anon_sym_LT] = ACTIONS(1030),
    [anon_sym_PLUS_TILDE] = ACTIONS(1028),
    [anon_sym_STAR_TILDE] = ACTIONS(1028),
    [anon_sym_SLASH_TILDE] = ACTIONS(1028),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1028),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1028),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1028),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1028),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1028),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1028),
    [anon_sym_GT_TILDE] = ACTIONS(1028),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1028),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1028),
    [anon_sym_LT_TILDE] = ACTIONS(1028),
    [anon_sym_PLUS_QMARK] = ACTIONS(1028),
    [anon_sym_DASH_QMARK] = ACTIONS(1028),
    [anon_sym_STAR_QMARK] = ACTIONS(1028),
    [anon_sym_SLASH_QMARK] = ACTIONS(1028),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1028),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1028),
    [anon_sym_as] = ACTIONS(1028),
    [anon_sym_LPAREN2] = ACTIONS(1028),
    [anon_sym_DOT_GT] = ACTIONS(1028),
    [anon_sym_where] = ACTIONS(1028),
    [anon_sym_TILDE] = ACTIONS(1028),
    [anon_sym_end] = ACTIONS(1028),
    [anon_sym_if] = ACTIONS(1030),
    [anon_sym_ifdef] = ACTIONS(1028),
    [anon_sym_iftype] = ACTIONS(1028),
    [anon_sym_else] = ACTIONS(1028),
    [anon_sym_for] = ACTIONS(1028),
    [anon_sym_while] = ACTIONS(1028),
    [anon_sym_try] = ACTIONS(1028),
    [anon_sym_with] = ACTIONS(1028),
    [anon_sym_repeat] = ACTIONS(1028),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_recover] = ACTIONS(1028),
    [anon_sym_match] = ACTIONS(1028),
    [anon_sym_return] = ACTIONS(1028),
    [anon_sym_continue] = ACTIONS(1028),
    [anon_sym_break] = ACTIONS(1028),
    [anon_sym_consume] = ACTIONS(1028),
    [anon_sym_object] = ACTIONS(1028),
    [sym_number] = ACTIONS(1030),
    [sym_float] = ACTIONS(1028),
    [anon_sym_DQUOTE] = ACTIONS(1030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1028),
    [anon_sym_SQUOTE] = ACTIONS(1028),
    [anon_sym_true] = ACTIONS(1028),
    [anon_sym_false] = ACTIONS(1028),
    [sym_this] = ACTIONS(1028),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(1028),
    [sym_block_comment] = ACTIONS(3),
  },
  [205] = {
    [sym_identifier] = ACTIONS(917),
    [anon_sym_EQ] = ACTIONS(917),
    [anon_sym_AT] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(915),
    [anon_sym_RBRACK] = ACTIONS(915),
    [anon_sym_is] = ACTIONS(917),
    [anon_sym_embed] = ACTIONS(915),
    [anon_sym_let] = ACTIONS(915),
    [anon_sym_var] = ACTIONS(915),
    [anon_sym_new] = ACTIONS(915),
    [anon_sym_EQ_GT] = ACTIONS(915),
    [anon_sym_fun] = ACTIONS(915),
    [anon_sym_be] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(915),
    [anon_sym_DOT] = ACTIONS(917),
    [anon_sym_BANG] = ACTIONS(917),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_AMP] = ACTIONS(915),
    [anon_sym_DASH_GT] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_RBRACE] = ACTIONS(915),
    [anon_sym_SEMI] = ACTIONS(915),
    [sym_error] = ACTIONS(915),
    [sym_compile_intrinsic] = ACTIONS(915),
    [anon_sym_compile_error] = ACTIONS(915),
    [sym_location] = ACTIONS(915),
    [anon_sym_DASH] = ACTIONS(917),
    [anon_sym_not] = ACTIONS(915),
    [anon_sym_DASH_TILDE] = ACTIONS(915),
    [anon_sym_addressof] = ACTIONS(915),
    [anon_sym_digestof] = ACTIONS(915),
    [anon_sym_PLUS] = ACTIONS(917),
    [anon_sym_STAR] = ACTIONS(917),
    [anon_sym_SLASH] = ACTIONS(917),
    [anon_sym_PERCENT] = ACTIONS(917),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(917),
    [anon_sym_LT_LT] = ACTIONS(917),
    [anon_sym_GT_GT] = ACTIONS(917),
    [anon_sym_and] = ACTIONS(915),
    [anon_sym_or] = ACTIONS(915),
    [anon_sym_xor] = ACTIONS(915),
    [anon_sym_isnt] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_GT] = ACTIONS(917),
    [anon_sym_GT_EQ] = ACTIONS(917),
    [anon_sym_LT_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(917),
    [anon_sym_PLUS_TILDE] = ACTIONS(915),
    [anon_sym_STAR_TILDE] = ACTIONS(915),
    [anon_sym_SLASH_TILDE] = ACTIONS(915),
    [anon_sym_PERCENT_TILDE] = ACTIONS(915),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(915),
    [anon_sym_LT_LT_TILDE] = ACTIONS(915),
    [anon_sym_GT_GT_TILDE] = ACTIONS(915),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(915),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(915),
    [anon_sym_GT_TILDE] = ACTIONS(915),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(915),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(915),
    [anon_sym_LT_TILDE] = ACTIONS(915),
    [anon_sym_PLUS_QMARK] = ACTIONS(915),
    [anon_sym_DASH_QMARK] = ACTIONS(915),
    [anon_sym_STAR_QMARK] = ACTIONS(915),
    [anon_sym_SLASH_QMARK] = ACTIONS(915),
    [anon_sym_PERCENT_QMARK] = ACTIONS(915),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(915),
    [anon_sym_as] = ACTIONS(915),
    [anon_sym_LPAREN2] = ACTIONS(915),
    [anon_sym_DOT_GT] = ACTIONS(915),
    [anon_sym_where] = ACTIONS(915),
    [anon_sym_TILDE] = ACTIONS(915),
    [anon_sym_end] = ACTIONS(915),
    [anon_sym_if] = ACTIONS(917),
    [anon_sym_ifdef] = ACTIONS(915),
    [anon_sym_then] = ACTIONS(915),
    [anon_sym_iftype] = ACTIONS(915),
    [anon_sym_else] = ACTIONS(915),
    [anon_sym_for] = ACTIONS(915),
    [anon_sym_while] = ACTIONS(915),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_with] = ACTIONS(915),
    [anon_sym_repeat] = ACTIONS(915),
    [anon_sym_until] = ACTIONS(915),
    [anon_sym_do] = ACTIONS(915),
    [anon_sym_recover] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(915),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_continue] = ACTIONS(915),
    [anon_sym_break] = ACTIONS(915),
    [anon_sym_consume] = ACTIONS(915),
    [anon_sym_object] = ACTIONS(915),
    [sym_number] = ACTIONS(917),
    [sym_float] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(917),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(915),
    [anon_sym_SQUOTE] = ACTIONS(915),
    [anon_sym_true] = ACTIONS(915),
    [anon_sym_false] = ACTIONS(915),
    [sym_this] = ACTIONS(915),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [206] = {
    [sym_identifier] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_RBRACK] = ACTIONS(923),
    [anon_sym_is] = ACTIONS(925),
    [anon_sym_embed] = ACTIONS(923),
    [anon_sym_let] = ACTIONS(923),
    [anon_sym_var] = ACTIONS(923),
    [anon_sym_new] = ACTIONS(923),
    [anon_sym_EQ_GT] = ACTIONS(923),
    [anon_sym_fun] = ACTIONS(923),
    [anon_sym_be] = ACTIONS(923),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_LPAREN] = ACTIONS(925),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_DOT] = ACTIONS(925),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_CARET] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_AMP] = ACTIONS(923),
    [anon_sym_DASH_GT] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_SEMI] = ACTIONS(923),
    [sym_error] = ACTIONS(923),
    [sym_compile_intrinsic] = ACTIONS(923),
    [anon_sym_compile_error] = ACTIONS(923),
    [sym_location] = ACTIONS(923),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_DASH_TILDE] = ACTIONS(923),
    [anon_sym_addressof] = ACTIONS(923),
    [anon_sym_digestof] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_STAR] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(925),
    [anon_sym_PERCENT] = ACTIONS(925),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(925),
    [anon_sym_LT_LT] = ACTIONS(925),
    [anon_sym_GT_GT] = ACTIONS(925),
    [anon_sym_and] = ACTIONS(923),
    [anon_sym_or] = ACTIONS(923),
    [anon_sym_xor] = ACTIONS(923),
    [anon_sym_isnt] = ACTIONS(923),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_BANG_EQ] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(925),
    [anon_sym_GT_EQ] = ACTIONS(925),
    [anon_sym_LT_EQ] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_PLUS_TILDE] = ACTIONS(923),
    [anon_sym_STAR_TILDE] = ACTIONS(923),
    [anon_sym_SLASH_TILDE] = ACTIONS(923),
    [anon_sym_PERCENT_TILDE] = ACTIONS(923),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(923),
    [anon_sym_LT_LT_TILDE] = ACTIONS(923),
    [anon_sym_GT_GT_TILDE] = ACTIONS(923),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(923),
    [anon_sym_GT_TILDE] = ACTIONS(923),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(923),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(923),
    [anon_sym_LT_TILDE] = ACTIONS(923),
    [anon_sym_PLUS_QMARK] = ACTIONS(923),
    [anon_sym_DASH_QMARK] = ACTIONS(923),
    [anon_sym_STAR_QMARK] = ACTIONS(923),
    [anon_sym_SLASH_QMARK] = ACTIONS(923),
    [anon_sym_PERCENT_QMARK] = ACTIONS(923),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(923),
    [anon_sym_as] = ACTIONS(923),
    [anon_sym_LPAREN2] = ACTIONS(923),
    [anon_sym_DOT_GT] = ACTIONS(923),
    [anon_sym_where] = ACTIONS(923),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_end] = ACTIONS(923),
    [anon_sym_if] = ACTIONS(925),
    [anon_sym_ifdef] = ACTIONS(923),
    [anon_sym_then] = ACTIONS(923),
    [anon_sym_iftype] = ACTIONS(923),
    [anon_sym_else] = ACTIONS(923),
    [anon_sym_for] = ACTIONS(923),
    [anon_sym_while] = ACTIONS(923),
    [anon_sym_try] = ACTIONS(923),
    [anon_sym_with] = ACTIONS(923),
    [anon_sym_repeat] = ACTIONS(923),
    [anon_sym_until] = ACTIONS(923),
    [anon_sym_do] = ACTIONS(923),
    [anon_sym_recover] = ACTIONS(923),
    [anon_sym_match] = ACTIONS(923),
    [anon_sym_return] = ACTIONS(923),
    [anon_sym_continue] = ACTIONS(923),
    [anon_sym_break] = ACTIONS(923),
    [anon_sym_consume] = ACTIONS(923),
    [anon_sym_object] = ACTIONS(923),
    [sym_number] = ACTIONS(925),
    [sym_float] = ACTIONS(923),
    [anon_sym_DQUOTE] = ACTIONS(925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(923),
    [anon_sym_SQUOTE] = ACTIONS(923),
    [anon_sym_true] = ACTIONS(923),
    [anon_sym_false] = ACTIONS(923),
    [sym_this] = ACTIONS(923),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [207] = {
    [ts_builtin_sym_end] = ACTIONS(1032),
    [sym_identifier] = ACTIONS(1034),
    [anon_sym_use] = ACTIONS(1032),
    [anon_sym_EQ] = ACTIONS(1034),
    [anon_sym_AT] = ACTIONS(1032),
    [anon_sym_LBRACK] = ACTIONS(1032),
    [anon_sym_QMARK] = ACTIONS(1032),
    [anon_sym_type] = ACTIONS(1032),
    [anon_sym_is] = ACTIONS(1034),
    [anon_sym_actor] = ACTIONS(1032),
    [anon_sym_class] = ACTIONS(1032),
    [anon_sym_primitive] = ACTIONS(1032),
    [anon_sym_interface] = ACTIONS(1032),
    [anon_sym_trait] = ACTIONS(1032),
    [anon_sym_struct] = ACTIONS(1032),
    [anon_sym_embed] = ACTIONS(1032),
    [anon_sym_let] = ACTIONS(1032),
    [anon_sym_var] = ACTIONS(1032),
    [anon_sym_new] = ACTIONS(1032),
    [anon_sym_fun] = ACTIONS(1032),
    [anon_sym_be] = ACTIONS(1032),
    [anon_sym_COMMA] = ACTIONS(1032),
    [anon_sym_LPAREN] = ACTIONS(1034),
    [anon_sym_RPAREN] = ACTIONS(1032),
    [anon_sym_DOT] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [anon_sym_SEMI] = ACTIONS(1032),
    [sym_error] = ACTIONS(1032),
    [sym_compile_intrinsic] = ACTIONS(1032),
    [anon_sym_compile_error] = ACTIONS(1032),
    [sym_location] = ACTIONS(1032),
    [anon_sym_DASH] = ACTIONS(1034),
    [anon_sym_not] = ACTIONS(1032),
    [anon_sym_DASH_TILDE] = ACTIONS(1032),
    [anon_sym_addressof] = ACTIONS(1032),
    [anon_sym_digestof] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_STAR] = ACTIONS(1034),
    [anon_sym_SLASH] = ACTIONS(1034),
    [anon_sym_PERCENT] = ACTIONS(1034),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1034),
    [anon_sym_LT_LT] = ACTIONS(1034),
    [anon_sym_GT_GT] = ACTIONS(1034),
    [anon_sym_and] = ACTIONS(1032),
    [anon_sym_or] = ACTIONS(1032),
    [anon_sym_xor] = ACTIONS(1032),
    [anon_sym_isnt] = ACTIONS(1032),
    [anon_sym_EQ_EQ] = ACTIONS(1034),
    [anon_sym_BANG_EQ] = ACTIONS(1034),
    [anon_sym_GT] = ACTIONS(1034),
    [anon_sym_GT_EQ] = ACTIONS(1034),
    [anon_sym_LT_EQ] = ACTIONS(1034),
    [anon_sym_LT] = ACTIONS(1034),
    [anon_sym_PLUS_TILDE] = ACTIONS(1032),
    [anon_sym_STAR_TILDE] = ACTIONS(1032),
    [anon_sym_SLASH_TILDE] = ACTIONS(1032),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1032),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1032),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1032),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1032),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1032),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1032),
    [anon_sym_GT_TILDE] = ACTIONS(1032),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1032),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1032),
    [anon_sym_LT_TILDE] = ACTIONS(1032),
    [anon_sym_PLUS_QMARK] = ACTIONS(1032),
    [anon_sym_DASH_QMARK] = ACTIONS(1032),
    [anon_sym_STAR_QMARK] = ACTIONS(1032),
    [anon_sym_SLASH_QMARK] = ACTIONS(1032),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1032),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1032),
    [anon_sym_as] = ACTIONS(1032),
    [anon_sym_LPAREN2] = ACTIONS(1032),
    [anon_sym_DOT_GT] = ACTIONS(1032),
    [anon_sym_where] = ACTIONS(1032),
    [anon_sym_TILDE] = ACTIONS(1032),
    [anon_sym_end] = ACTIONS(1032),
    [anon_sym_if] = ACTIONS(1034),
    [anon_sym_ifdef] = ACTIONS(1032),
    [anon_sym_iftype] = ACTIONS(1032),
    [anon_sym_else] = ACTIONS(1032),
    [anon_sym_for] = ACTIONS(1032),
    [anon_sym_while] = ACTIONS(1032),
    [anon_sym_try] = ACTIONS(1032),
    [anon_sym_with] = ACTIONS(1032),
    [anon_sym_repeat] = ACTIONS(1032),
    [anon_sym_do] = ACTIONS(1032),
    [anon_sym_recover] = ACTIONS(1032),
    [anon_sym_match] = ACTIONS(1032),
    [anon_sym_return] = ACTIONS(1032),
    [anon_sym_continue] = ACTIONS(1032),
    [anon_sym_break] = ACTIONS(1032),
    [anon_sym_consume] = ACTIONS(1032),
    [anon_sym_object] = ACTIONS(1032),
    [sym_number] = ACTIONS(1034),
    [sym_float] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(1034),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1032),
    [anon_sym_true] = ACTIONS(1032),
    [anon_sym_false] = ACTIONS(1032),
    [sym_this] = ACTIONS(1032),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [208] = {
    [sym_identifier] = ACTIONS(921),
    [anon_sym_EQ] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_RBRACK] = ACTIONS(919),
    [anon_sym_is] = ACTIONS(921),
    [anon_sym_embed] = ACTIONS(919),
    [anon_sym_let] = ACTIONS(919),
    [anon_sym_var] = ACTIONS(919),
    [anon_sym_new] = ACTIONS(919),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_fun] = ACTIONS(919),
    [anon_sym_be] = ACTIONS(919),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(921),
    [anon_sym_RPAREN] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(919),
    [anon_sym_DASH_GT] = ACTIONS(919),
    [anon_sym_LBRACE] = ACTIONS(919),
    [anon_sym_RBRACE] = ACTIONS(919),
    [anon_sym_SEMI] = ACTIONS(919),
    [sym_error] = ACTIONS(919),
    [sym_compile_intrinsic] = ACTIONS(919),
    [anon_sym_compile_error] = ACTIONS(919),
    [sym_location] = ACTIONS(919),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_DASH_TILDE] = ACTIONS(919),
    [anon_sym_addressof] = ACTIONS(919),
    [anon_sym_digestof] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_STAR] = ACTIONS(921),
    [anon_sym_SLASH] = ACTIONS(921),
    [anon_sym_PERCENT] = ACTIONS(921),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(921),
    [anon_sym_GT_GT] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(919),
    [anon_sym_or] = ACTIONS(919),
    [anon_sym_xor] = ACTIONS(919),
    [anon_sym_isnt] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_PLUS_TILDE] = ACTIONS(919),
    [anon_sym_STAR_TILDE] = ACTIONS(919),
    [anon_sym_SLASH_TILDE] = ACTIONS(919),
    [anon_sym_PERCENT_TILDE] = ACTIONS(919),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(919),
    [anon_sym_LT_LT_TILDE] = ACTIONS(919),
    [anon_sym_GT_GT_TILDE] = ACTIONS(919),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(919),
    [anon_sym_GT_TILDE] = ACTIONS(919),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(919),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(919),
    [anon_sym_LT_TILDE] = ACTIONS(919),
    [anon_sym_PLUS_QMARK] = ACTIONS(919),
    [anon_sym_DASH_QMARK] = ACTIONS(919),
    [anon_sym_STAR_QMARK] = ACTIONS(919),
    [anon_sym_SLASH_QMARK] = ACTIONS(919),
    [anon_sym_PERCENT_QMARK] = ACTIONS(919),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(919),
    [anon_sym_as] = ACTIONS(919),
    [anon_sym_LPAREN2] = ACTIONS(919),
    [anon_sym_DOT_GT] = ACTIONS(919),
    [anon_sym_where] = ACTIONS(919),
    [anon_sym_TILDE] = ACTIONS(919),
    [anon_sym_end] = ACTIONS(919),
    [anon_sym_if] = ACTIONS(921),
    [anon_sym_ifdef] = ACTIONS(919),
    [anon_sym_then] = ACTIONS(919),
    [anon_sym_iftype] = ACTIONS(919),
    [anon_sym_else] = ACTIONS(919),
    [anon_sym_for] = ACTIONS(919),
    [anon_sym_while] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(919),
    [anon_sym_with] = ACTIONS(919),
    [anon_sym_repeat] = ACTIONS(919),
    [anon_sym_until] = ACTIONS(919),
    [anon_sym_do] = ACTIONS(919),
    [anon_sym_recover] = ACTIONS(919),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_return] = ACTIONS(919),
    [anon_sym_continue] = ACTIONS(919),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_consume] = ACTIONS(919),
    [anon_sym_object] = ACTIONS(919),
    [sym_number] = ACTIONS(921),
    [sym_float] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(921),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(919),
    [anon_sym_SQUOTE] = ACTIONS(919),
    [anon_sym_true] = ACTIONS(919),
    [anon_sym_false] = ACTIONS(919),
    [sym_this] = ACTIONS(919),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [209] = {
    [sym_arguments] = STATE(223),
    [ts_builtin_sym_end] = ACTIONS(1036),
    [sym_identifier] = ACTIONS(1038),
    [anon_sym_use] = ACTIONS(1036),
    [anon_sym_EQ] = ACTIONS(1038),
    [anon_sym_AT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_type] = ACTIONS(1036),
    [anon_sym_is] = ACTIONS(1038),
    [anon_sym_actor] = ACTIONS(1036),
    [anon_sym_class] = ACTIONS(1036),
    [anon_sym_primitive] = ACTIONS(1036),
    [anon_sym_interface] = ACTIONS(1036),
    [anon_sym_trait] = ACTIONS(1036),
    [anon_sym_struct] = ACTIONS(1036),
    [anon_sym_embed] = ACTIONS(1036),
    [anon_sym_let] = ACTIONS(1036),
    [anon_sym_var] = ACTIONS(1036),
    [anon_sym_new] = ACTIONS(1036),
    [anon_sym_fun] = ACTIONS(1036),
    [anon_sym_be] = ACTIONS(1036),
    [anon_sym_COMMA] = ACTIONS(1036),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [anon_sym_RPAREN] = ACTIONS(1036),
    [anon_sym_DOT] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(1036),
    [anon_sym_SEMI] = ACTIONS(1036),
    [sym_error] = ACTIONS(1036),
    [sym_compile_intrinsic] = ACTIONS(1036),
    [anon_sym_compile_error] = ACTIONS(1036),
    [sym_location] = ACTIONS(1036),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_not] = ACTIONS(1036),
    [anon_sym_DASH_TILDE] = ACTIONS(1036),
    [anon_sym_addressof] = ACTIONS(1036),
    [anon_sym_digestof] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_PERCENT] = ACTIONS(1038),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1038),
    [anon_sym_LT_LT] = ACTIONS(1038),
    [anon_sym_GT_GT] = ACTIONS(1038),
    [anon_sym_and] = ACTIONS(1036),
    [anon_sym_or] = ACTIONS(1036),
    [anon_sym_xor] = ACTIONS(1036),
    [anon_sym_isnt] = ACTIONS(1036),
    [anon_sym_EQ_EQ] = ACTIONS(1038),
    [anon_sym_BANG_EQ] = ACTIONS(1038),
    [anon_sym_GT] = ACTIONS(1038),
    [anon_sym_GT_EQ] = ACTIONS(1038),
    [anon_sym_LT_EQ] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1038),
    [anon_sym_PLUS_TILDE] = ACTIONS(1036),
    [anon_sym_STAR_TILDE] = ACTIONS(1036),
    [anon_sym_SLASH_TILDE] = ACTIONS(1036),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1036),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1036),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1036),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1036),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1036),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1036),
    [anon_sym_GT_TILDE] = ACTIONS(1036),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1036),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1036),
    [anon_sym_LT_TILDE] = ACTIONS(1036),
    [anon_sym_PLUS_QMARK] = ACTIONS(1036),
    [anon_sym_DASH_QMARK] = ACTIONS(1036),
    [anon_sym_STAR_QMARK] = ACTIONS(1036),
    [anon_sym_SLASH_QMARK] = ACTIONS(1036),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1036),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1036),
    [anon_sym_as] = ACTIONS(1036),
    [anon_sym_LPAREN2] = ACTIONS(1036),
    [anon_sym_DOT_GT] = ACTIONS(1036),
    [anon_sym_where] = ACTIONS(1036),
    [anon_sym_TILDE] = ACTIONS(1036),
    [anon_sym_end] = ACTIONS(1036),
    [anon_sym_if] = ACTIONS(1038),
    [anon_sym_ifdef] = ACTIONS(1036),
    [anon_sym_iftype] = ACTIONS(1036),
    [anon_sym_else] = ACTIONS(1036),
    [anon_sym_for] = ACTIONS(1036),
    [anon_sym_while] = ACTIONS(1036),
    [anon_sym_try] = ACTIONS(1036),
    [anon_sym_with] = ACTIONS(1036),
    [anon_sym_repeat] = ACTIONS(1036),
    [anon_sym_do] = ACTIONS(1036),
    [anon_sym_recover] = ACTIONS(1036),
    [anon_sym_match] = ACTIONS(1036),
    [anon_sym_return] = ACTIONS(1036),
    [anon_sym_continue] = ACTIONS(1036),
    [anon_sym_break] = ACTIONS(1036),
    [anon_sym_consume] = ACTIONS(1036),
    [anon_sym_object] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_float] = ACTIONS(1036),
    [anon_sym_DQUOTE] = ACTIONS(1038),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1036),
    [anon_sym_SQUOTE] = ACTIONS(1036),
    [anon_sym_true] = ACTIONS(1036),
    [anon_sym_false] = ACTIONS(1036),
    [sym_this] = ACTIONS(1036),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [210] = {
    [ts_builtin_sym_end] = ACTIONS(1040),
    [sym_identifier] = ACTIONS(1042),
    [anon_sym_use] = ACTIONS(1040),
    [anon_sym_EQ] = ACTIONS(1042),
    [anon_sym_AT] = ACTIONS(1040),
    [anon_sym_LBRACK] = ACTIONS(1040),
    [anon_sym_type] = ACTIONS(1040),
    [anon_sym_is] = ACTIONS(1042),
    [anon_sym_actor] = ACTIONS(1040),
    [anon_sym_class] = ACTIONS(1040),
    [anon_sym_primitive] = ACTIONS(1040),
    [anon_sym_interface] = ACTIONS(1040),
    [anon_sym_trait] = ACTIONS(1040),
    [anon_sym_struct] = ACTIONS(1040),
    [anon_sym_embed] = ACTIONS(1040),
    [anon_sym_let] = ACTIONS(1040),
    [anon_sym_var] = ACTIONS(1040),
    [anon_sym_new] = ACTIONS(1040),
    [anon_sym_fun] = ACTIONS(1040),
    [anon_sym_be] = ACTIONS(1040),
    [anon_sym_COMMA] = ACTIONS(1040),
    [anon_sym_LPAREN] = ACTIONS(1042),
    [anon_sym_RPAREN] = ACTIONS(1040),
    [anon_sym_DOT] = ACTIONS(1042),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_SEMI] = ACTIONS(1040),
    [sym_error] = ACTIONS(1040),
    [sym_compile_intrinsic] = ACTIONS(1040),
    [anon_sym_compile_error] = ACTIONS(1040),
    [sym_location] = ACTIONS(1040),
    [anon_sym_DASH] = ACTIONS(1042),
    [anon_sym_not] = ACTIONS(1040),
    [anon_sym_DASH_TILDE] = ACTIONS(1040),
    [anon_sym_addressof] = ACTIONS(1040),
    [anon_sym_digestof] = ACTIONS(1040),
    [anon_sym_PLUS] = ACTIONS(1042),
    [anon_sym_STAR] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(1042),
    [anon_sym_PERCENT] = ACTIONS(1042),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1042),
    [anon_sym_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_GT] = ACTIONS(1042),
    [anon_sym_and] = ACTIONS(1040),
    [anon_sym_or] = ACTIONS(1040),
    [anon_sym_xor] = ACTIONS(1040),
    [anon_sym_isnt] = ACTIONS(1040),
    [anon_sym_EQ_EQ] = ACTIONS(1042),
    [anon_sym_BANG_EQ] = ACTIONS(1042),
    [anon_sym_GT] = ACTIONS(1042),
    [anon_sym_GT_EQ] = ACTIONS(1042),
    [anon_sym_LT_EQ] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_PLUS_TILDE] = ACTIONS(1040),
    [anon_sym_STAR_TILDE] = ACTIONS(1040),
    [anon_sym_SLASH_TILDE] = ACTIONS(1040),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1040),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1040),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1040),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1040),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1040),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1040),
    [anon_sym_GT_TILDE] = ACTIONS(1040),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1040),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1040),
    [anon_sym_LT_TILDE] = ACTIONS(1040),
    [anon_sym_PLUS_QMARK] = ACTIONS(1040),
    [anon_sym_DASH_QMARK] = ACTIONS(1040),
    [anon_sym_STAR_QMARK] = ACTIONS(1040),
    [anon_sym_SLASH_QMARK] = ACTIONS(1040),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1040),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1040),
    [anon_sym_as] = ACTIONS(1040),
    [anon_sym_LPAREN2] = ACTIONS(1040),
    [anon_sym_DOT_GT] = ACTIONS(1040),
    [anon_sym_where] = ACTIONS(1040),
    [anon_sym_TILDE] = ACTIONS(1040),
    [anon_sym_end] = ACTIONS(1040),
    [anon_sym_if] = ACTIONS(1042),
    [anon_sym_ifdef] = ACTIONS(1040),
    [anon_sym_iftype] = ACTIONS(1040),
    [anon_sym_else] = ACTIONS(1040),
    [anon_sym_for] = ACTIONS(1040),
    [anon_sym_while] = ACTIONS(1040),
    [anon_sym_try] = ACTIONS(1040),
    [anon_sym_with] = ACTIONS(1040),
    [anon_sym_repeat] = ACTIONS(1040),
    [anon_sym_do] = ACTIONS(1040),
    [anon_sym_recover] = ACTIONS(1040),
    [anon_sym_match] = ACTIONS(1040),
    [anon_sym_return] = ACTIONS(1040),
    [anon_sym_continue] = ACTIONS(1040),
    [anon_sym_break] = ACTIONS(1040),
    [anon_sym_consume] = ACTIONS(1040),
    [anon_sym_object] = ACTIONS(1040),
    [sym_number] = ACTIONS(1042),
    [sym_float] = ACTIONS(1040),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym_true] = ACTIONS(1040),
    [anon_sym_false] = ACTIONS(1040),
    [sym_this] = ACTIONS(1040),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(1040),
    [sym_block_comment] = ACTIONS(3),
  },
  [211] = {
    [sym_identifier] = ACTIONS(901),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_AT] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(899),
    [anon_sym_RBRACK] = ACTIONS(899),
    [anon_sym_is] = ACTIONS(901),
    [anon_sym_embed] = ACTIONS(899),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_var] = ACTIONS(899),
    [anon_sym_new] = ACTIONS(899),
    [anon_sym_EQ_GT] = ACTIONS(899),
    [anon_sym_fun] = ACTIONS(899),
    [anon_sym_be] = ACTIONS(899),
    [anon_sym_COMMA] = ACTIONS(899),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_RPAREN] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_CARET] = ACTIONS(899),
    [anon_sym_PIPE] = ACTIONS(899),
    [anon_sym_AMP] = ACTIONS(899),
    [anon_sym_DASH_GT] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(899),
    [anon_sym_RBRACE] = ACTIONS(899),
    [anon_sym_SEMI] = ACTIONS(899),
    [sym_error] = ACTIONS(899),
    [sym_compile_intrinsic] = ACTIONS(899),
    [anon_sym_compile_error] = ACTIONS(899),
    [sym_location] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_not] = ACTIONS(899),
    [anon_sym_DASH_TILDE] = ACTIONS(899),
    [anon_sym_addressof] = ACTIONS(899),
    [anon_sym_digestof] = ACTIONS(899),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_STAR] = ACTIONS(901),
    [anon_sym_SLASH] = ACTIONS(901),
    [anon_sym_PERCENT] = ACTIONS(901),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(901),
    [anon_sym_LT_LT] = ACTIONS(901),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_and] = ACTIONS(899),
    [anon_sym_or] = ACTIONS(899),
    [anon_sym_xor] = ACTIONS(899),
    [anon_sym_isnt] = ACTIONS(899),
    [anon_sym_EQ_EQ] = ACTIONS(901),
    [anon_sym_BANG_EQ] = ACTIONS(901),
    [anon_sym_GT] = ACTIONS(901),
    [anon_sym_GT_EQ] = ACTIONS(901),
    [anon_sym_LT_EQ] = ACTIONS(901),
    [anon_sym_LT] = ACTIONS(901),
    [anon_sym_PLUS_TILDE] = ACTIONS(899),
    [anon_sym_STAR_TILDE] = ACTIONS(899),
    [anon_sym_SLASH_TILDE] = ACTIONS(899),
    [anon_sym_PERCENT_TILDE] = ACTIONS(899),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(899),
    [anon_sym_LT_LT_TILDE] = ACTIONS(899),
    [anon_sym_GT_GT_TILDE] = ACTIONS(899),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(899),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(899),
    [anon_sym_GT_TILDE] = ACTIONS(899),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(899),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(899),
    [anon_sym_LT_TILDE] = ACTIONS(899),
    [anon_sym_PLUS_QMARK] = ACTIONS(899),
    [anon_sym_DASH_QMARK] = ACTIONS(899),
    [anon_sym_STAR_QMARK] = ACTIONS(899),
    [anon_sym_SLASH_QMARK] = ACTIONS(899),
    [anon_sym_PERCENT_QMARK] = ACTIONS(899),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(899),
    [anon_sym_as] = ACTIONS(899),
    [anon_sym_LPAREN2] = ACTIONS(899),
    [anon_sym_DOT_GT] = ACTIONS(899),
    [anon_sym_where] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(899),
    [anon_sym_end] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(901),
    [anon_sym_ifdef] = ACTIONS(899),
    [anon_sym_then] = ACTIONS(899),
    [anon_sym_iftype] = ACTIONS(899),
    [anon_sym_else] = ACTIONS(899),
    [anon_sym_for] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(899),
    [anon_sym_try] = ACTIONS(899),
    [anon_sym_with] = ACTIONS(899),
    [anon_sym_repeat] = ACTIONS(899),
    [anon_sym_until] = ACTIONS(899),
    [anon_sym_do] = ACTIONS(899),
    [anon_sym_recover] = ACTIONS(899),
    [anon_sym_match] = ACTIONS(899),
    [anon_sym_return] = ACTIONS(899),
    [anon_sym_continue] = ACTIONS(899),
    [anon_sym_break] = ACTIONS(899),
    [anon_sym_consume] = ACTIONS(899),
    [anon_sym_object] = ACTIONS(899),
    [sym_number] = ACTIONS(901),
    [sym_float] = ACTIONS(899),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(899),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [anon_sym_true] = ACTIONS(899),
    [anon_sym_false] = ACTIONS(899),
    [sym_this] = ACTIONS(899),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [212] = {
    [sym_identifier] = ACTIONS(949),
    [anon_sym_EQ] = ACTIONS(949),
    [anon_sym_AT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_RBRACK] = ACTIONS(947),
    [anon_sym_is] = ACTIONS(949),
    [anon_sym_embed] = ACTIONS(947),
    [anon_sym_let] = ACTIONS(947),
    [anon_sym_var] = ACTIONS(947),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_fun] = ACTIONS(947),
    [anon_sym_be] = ACTIONS(947),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(947),
    [anon_sym_DASH_GT] = ACTIONS(947),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_SEMI] = ACTIONS(947),
    [sym_error] = ACTIONS(947),
    [sym_compile_intrinsic] = ACTIONS(947),
    [anon_sym_compile_error] = ACTIONS(947),
    [sym_location] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_not] = ACTIONS(947),
    [anon_sym_DASH_TILDE] = ACTIONS(947),
    [anon_sym_addressof] = ACTIONS(947),
    [anon_sym_digestof] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_STAR] = ACTIONS(949),
    [anon_sym_SLASH] = ACTIONS(949),
    [anon_sym_PERCENT] = ACTIONS(949),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(949),
    [anon_sym_LT_LT] = ACTIONS(949),
    [anon_sym_GT_GT] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(947),
    [anon_sym_or] = ACTIONS(947),
    [anon_sym_xor] = ACTIONS(947),
    [anon_sym_isnt] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(949),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_PLUS_TILDE] = ACTIONS(947),
    [anon_sym_STAR_TILDE] = ACTIONS(947),
    [anon_sym_SLASH_TILDE] = ACTIONS(947),
    [anon_sym_PERCENT_TILDE] = ACTIONS(947),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(947),
    [anon_sym_LT_LT_TILDE] = ACTIONS(947),
    [anon_sym_GT_GT_TILDE] = ACTIONS(947),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(947),
    [anon_sym_GT_TILDE] = ACTIONS(947),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(947),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(947),
    [anon_sym_LT_TILDE] = ACTIONS(947),
    [anon_sym_PLUS_QMARK] = ACTIONS(947),
    [anon_sym_DASH_QMARK] = ACTIONS(947),
    [anon_sym_STAR_QMARK] = ACTIONS(947),
    [anon_sym_SLASH_QMARK] = ACTIONS(947),
    [anon_sym_PERCENT_QMARK] = ACTIONS(947),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(947),
    [anon_sym_as] = ACTIONS(947),
    [anon_sym_LPAREN2] = ACTIONS(947),
    [anon_sym_DOT_GT] = ACTIONS(947),
    [anon_sym_where] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(947),
    [anon_sym_end] = ACTIONS(947),
    [anon_sym_if] = ACTIONS(949),
    [anon_sym_ifdef] = ACTIONS(947),
    [anon_sym_then] = ACTIONS(947),
    [anon_sym_iftype] = ACTIONS(947),
    [anon_sym_else] = ACTIONS(947),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(947),
    [anon_sym_with] = ACTIONS(947),
    [anon_sym_repeat] = ACTIONS(947),
    [anon_sym_until] = ACTIONS(947),
    [anon_sym_do] = ACTIONS(947),
    [anon_sym_recover] = ACTIONS(947),
    [anon_sym_match] = ACTIONS(947),
    [anon_sym_return] = ACTIONS(947),
    [anon_sym_continue] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(947),
    [anon_sym_consume] = ACTIONS(947),
    [anon_sym_object] = ACTIONS(947),
    [sym_number] = ACTIONS(949),
    [sym_float] = ACTIONS(947),
    [anon_sym_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(947),
    [anon_sym_SQUOTE] = ACTIONS(947),
    [anon_sym_true] = ACTIONS(947),
    [anon_sym_false] = ACTIONS(947),
    [sym_this] = ACTIONS(947),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [213] = {
    [ts_builtin_sym_end] = ACTIONS(1044),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_use] = ACTIONS(1044),
    [anon_sym_EQ] = ACTIONS(1046),
    [anon_sym_AT] = ACTIONS(1044),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(1044),
    [anon_sym_type] = ACTIONS(1044),
    [anon_sym_is] = ACTIONS(1046),
    [anon_sym_actor] = ACTIONS(1044),
    [anon_sym_class] = ACTIONS(1044),
    [anon_sym_primitive] = ACTIONS(1044),
    [anon_sym_interface] = ACTIONS(1044),
    [anon_sym_trait] = ACTIONS(1044),
    [anon_sym_struct] = ACTIONS(1044),
    [anon_sym_embed] = ACTIONS(1044),
    [anon_sym_let] = ACTIONS(1044),
    [anon_sym_var] = ACTIONS(1044),
    [anon_sym_new] = ACTIONS(1044),
    [anon_sym_fun] = ACTIONS(1044),
    [anon_sym_be] = ACTIONS(1044),
    [anon_sym_COMMA] = ACTIONS(1044),
    [anon_sym_LPAREN] = ACTIONS(1046),
    [anon_sym_RPAREN] = ACTIONS(1044),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_LBRACE] = ACTIONS(1044),
    [anon_sym_SEMI] = ACTIONS(1044),
    [sym_error] = ACTIONS(1044),
    [sym_compile_intrinsic] = ACTIONS(1044),
    [anon_sym_compile_error] = ACTIONS(1044),
    [sym_location] = ACTIONS(1044),
    [anon_sym_DASH] = ACTIONS(1046),
    [anon_sym_not] = ACTIONS(1044),
    [anon_sym_DASH_TILDE] = ACTIONS(1044),
    [anon_sym_addressof] = ACTIONS(1044),
    [anon_sym_digestof] = ACTIONS(1044),
    [anon_sym_PLUS] = ACTIONS(1046),
    [anon_sym_STAR] = ACTIONS(1046),
    [anon_sym_SLASH] = ACTIONS(1046),
    [anon_sym_PERCENT] = ACTIONS(1046),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1046),
    [anon_sym_LT_LT] = ACTIONS(1046),
    [anon_sym_GT_GT] = ACTIONS(1046),
    [anon_sym_and] = ACTIONS(1044),
    [anon_sym_or] = ACTIONS(1044),
    [anon_sym_xor] = ACTIONS(1044),
    [anon_sym_isnt] = ACTIONS(1044),
    [anon_sym_EQ_EQ] = ACTIONS(1046),
    [anon_sym_BANG_EQ] = ACTIONS(1046),
    [anon_sym_GT] = ACTIONS(1046),
    [anon_sym_GT_EQ] = ACTIONS(1046),
    [anon_sym_LT_EQ] = ACTIONS(1046),
    [anon_sym_LT] = ACTIONS(1046),
    [anon_sym_PLUS_TILDE] = ACTIONS(1044),
    [anon_sym_STAR_TILDE] = ACTIONS(1044),
    [anon_sym_SLASH_TILDE] = ACTIONS(1044),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1044),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1044),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1044),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1044),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1044),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1044),
    [anon_sym_GT_TILDE] = ACTIONS(1044),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1044),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1044),
    [anon_sym_LT_TILDE] = ACTIONS(1044),
    [anon_sym_PLUS_QMARK] = ACTIONS(1044),
    [anon_sym_DASH_QMARK] = ACTIONS(1044),
    [anon_sym_STAR_QMARK] = ACTIONS(1044),
    [anon_sym_SLASH_QMARK] = ACTIONS(1044),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1044),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1044),
    [anon_sym_as] = ACTIONS(1044),
    [anon_sym_LPAREN2] = ACTIONS(1044),
    [anon_sym_DOT_GT] = ACTIONS(1044),
    [anon_sym_where] = ACTIONS(1044),
    [anon_sym_TILDE] = ACTIONS(1044),
    [anon_sym_end] = ACTIONS(1044),
    [anon_sym_if] = ACTIONS(1046),
    [anon_sym_ifdef] = ACTIONS(1044),
    [anon_sym_iftype] = ACTIONS(1044),
    [anon_sym_else] = ACTIONS(1044),
    [anon_sym_for] = ACTIONS(1044),
    [anon_sym_while] = ACTIONS(1044),
    [anon_sym_try] = ACTIONS(1044),
    [anon_sym_with] = ACTIONS(1044),
    [anon_sym_repeat] = ACTIONS(1044),
    [anon_sym_do] = ACTIONS(1044),
    [anon_sym_recover] = ACTIONS(1044),
    [anon_sym_match] = ACTIONS(1044),
    [anon_sym_return] = ACTIONS(1044),
    [anon_sym_continue] = ACTIONS(1044),
    [anon_sym_break] = ACTIONS(1044),
    [anon_sym_consume] = ACTIONS(1044),
    [anon_sym_object] = ACTIONS(1044),
    [sym_number] = ACTIONS(1046),
    [sym_float] = ACTIONS(1044),
    [anon_sym_DQUOTE] = ACTIONS(1046),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1044),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_true] = ACTIONS(1044),
    [anon_sym_false] = ACTIONS(1044),
    [sym_this] = ACTIONS(1044),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [214] = {
    [ts_builtin_sym_end] = ACTIONS(1048),
    [sym_identifier] = ACTIONS(1050),
    [anon_sym_use] = ACTIONS(1048),
    [anon_sym_EQ] = ACTIONS(1050),
    [anon_sym_AT] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(1048),
    [anon_sym_QMARK] = ACTIONS(1048),
    [anon_sym_type] = ACTIONS(1048),
    [anon_sym_is] = ACTIONS(1050),
    [anon_sym_actor] = ACTIONS(1048),
    [anon_sym_class] = ACTIONS(1048),
    [anon_sym_primitive] = ACTIONS(1048),
    [anon_sym_interface] = ACTIONS(1048),
    [anon_sym_trait] = ACTIONS(1048),
    [anon_sym_struct] = ACTIONS(1048),
    [anon_sym_embed] = ACTIONS(1048),
    [anon_sym_let] = ACTIONS(1048),
    [anon_sym_var] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1048),
    [anon_sym_fun] = ACTIONS(1048),
    [anon_sym_be] = ACTIONS(1048),
    [anon_sym_COMMA] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(1050),
    [anon_sym_RPAREN] = ACTIONS(1048),
    [anon_sym_DOT] = ACTIONS(1050),
    [anon_sym_LBRACE] = ACTIONS(1048),
    [anon_sym_SEMI] = ACTIONS(1048),
    [sym_error] = ACTIONS(1048),
    [sym_compile_intrinsic] = ACTIONS(1048),
    [anon_sym_compile_error] = ACTIONS(1048),
    [sym_location] = ACTIONS(1048),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_not] = ACTIONS(1048),
    [anon_sym_DASH_TILDE] = ACTIONS(1048),
    [anon_sym_addressof] = ACTIONS(1048),
    [anon_sym_digestof] = ACTIONS(1048),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_STAR] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(1050),
    [anon_sym_PERCENT] = ACTIONS(1050),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1050),
    [anon_sym_LT_LT] = ACTIONS(1050),
    [anon_sym_GT_GT] = ACTIONS(1050),
    [anon_sym_and] = ACTIONS(1048),
    [anon_sym_or] = ACTIONS(1048),
    [anon_sym_xor] = ACTIONS(1048),
    [anon_sym_isnt] = ACTIONS(1048),
    [anon_sym_EQ_EQ] = ACTIONS(1050),
    [anon_sym_BANG_EQ] = ACTIONS(1050),
    [anon_sym_GT] = ACTIONS(1050),
    [anon_sym_GT_EQ] = ACTIONS(1050),
    [anon_sym_LT_EQ] = ACTIONS(1050),
    [anon_sym_LT] = ACTIONS(1050),
    [anon_sym_PLUS_TILDE] = ACTIONS(1048),
    [anon_sym_STAR_TILDE] = ACTIONS(1048),
    [anon_sym_SLASH_TILDE] = ACTIONS(1048),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1048),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1048),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1048),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1048),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1048),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1048),
    [anon_sym_GT_TILDE] = ACTIONS(1048),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1048),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1048),
    [anon_sym_LT_TILDE] = ACTIONS(1048),
    [anon_sym_PLUS_QMARK] = ACTIONS(1048),
    [anon_sym_DASH_QMARK] = ACTIONS(1048),
    [anon_sym_STAR_QMARK] = ACTIONS(1048),
    [anon_sym_SLASH_QMARK] = ACTIONS(1048),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1048),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1048),
    [anon_sym_as] = ACTIONS(1048),
    [anon_sym_LPAREN2] = ACTIONS(1048),
    [anon_sym_DOT_GT] = ACTIONS(1048),
    [anon_sym_where] = ACTIONS(1048),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_end] = ACTIONS(1048),
    [anon_sym_if] = ACTIONS(1050),
    [anon_sym_ifdef] = ACTIONS(1048),
    [anon_sym_iftype] = ACTIONS(1048),
    [anon_sym_else] = ACTIONS(1048),
    [anon_sym_for] = ACTIONS(1048),
    [anon_sym_while] = ACTIONS(1048),
    [anon_sym_try] = ACTIONS(1048),
    [anon_sym_with] = ACTIONS(1048),
    [anon_sym_repeat] = ACTIONS(1048),
    [anon_sym_do] = ACTIONS(1048),
    [anon_sym_recover] = ACTIONS(1048),
    [anon_sym_match] = ACTIONS(1048),
    [anon_sym_return] = ACTIONS(1048),
    [anon_sym_continue] = ACTIONS(1048),
    [anon_sym_break] = ACTIONS(1048),
    [anon_sym_consume] = ACTIONS(1048),
    [anon_sym_object] = ACTIONS(1048),
    [sym_number] = ACTIONS(1050),
    [sym_float] = ACTIONS(1048),
    [anon_sym_DQUOTE] = ACTIONS(1050),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1048),
    [anon_sym_SQUOTE] = ACTIONS(1048),
    [anon_sym_true] = ACTIONS(1048),
    [anon_sym_false] = ACTIONS(1048),
    [sym_this] = ACTIONS(1048),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [215] = {
    [ts_builtin_sym_end] = ACTIONS(1052),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_use] = ACTIONS(1052),
    [anon_sym_EQ] = ACTIONS(1054),
    [anon_sym_AT] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(1052),
    [anon_sym_QMARK] = ACTIONS(1052),
    [anon_sym_type] = ACTIONS(1052),
    [anon_sym_is] = ACTIONS(1054),
    [anon_sym_actor] = ACTIONS(1052),
    [anon_sym_class] = ACTIONS(1052),
    [anon_sym_primitive] = ACTIONS(1052),
    [anon_sym_interface] = ACTIONS(1052),
    [anon_sym_trait] = ACTIONS(1052),
    [anon_sym_struct] = ACTIONS(1052),
    [anon_sym_embed] = ACTIONS(1052),
    [anon_sym_let] = ACTIONS(1052),
    [anon_sym_var] = ACTIONS(1052),
    [anon_sym_new] = ACTIONS(1052),
    [anon_sym_fun] = ACTIONS(1052),
    [anon_sym_be] = ACTIONS(1052),
    [anon_sym_COMMA] = ACTIONS(1052),
    [anon_sym_LPAREN] = ACTIONS(1054),
    [anon_sym_RPAREN] = ACTIONS(1052),
    [anon_sym_DOT] = ACTIONS(1054),
    [anon_sym_LBRACE] = ACTIONS(1052),
    [anon_sym_SEMI] = ACTIONS(1052),
    [sym_error] = ACTIONS(1052),
    [sym_compile_intrinsic] = ACTIONS(1052),
    [anon_sym_compile_error] = ACTIONS(1052),
    [sym_location] = ACTIONS(1052),
    [anon_sym_DASH] = ACTIONS(1054),
    [anon_sym_not] = ACTIONS(1052),
    [anon_sym_DASH_TILDE] = ACTIONS(1052),
    [anon_sym_addressof] = ACTIONS(1052),
    [anon_sym_digestof] = ACTIONS(1052),
    [anon_sym_PLUS] = ACTIONS(1054),
    [anon_sym_STAR] = ACTIONS(1054),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_PERCENT] = ACTIONS(1054),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1054),
    [anon_sym_LT_LT] = ACTIONS(1054),
    [anon_sym_GT_GT] = ACTIONS(1054),
    [anon_sym_and] = ACTIONS(1052),
    [anon_sym_or] = ACTIONS(1052),
    [anon_sym_xor] = ACTIONS(1052),
    [anon_sym_isnt] = ACTIONS(1052),
    [anon_sym_EQ_EQ] = ACTIONS(1054),
    [anon_sym_BANG_EQ] = ACTIONS(1054),
    [anon_sym_GT] = ACTIONS(1054),
    [anon_sym_GT_EQ] = ACTIONS(1054),
    [anon_sym_LT_EQ] = ACTIONS(1054),
    [anon_sym_LT] = ACTIONS(1054),
    [anon_sym_PLUS_TILDE] = ACTIONS(1052),
    [anon_sym_STAR_TILDE] = ACTIONS(1052),
    [anon_sym_SLASH_TILDE] = ACTIONS(1052),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1052),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1052),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1052),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1052),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1052),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1052),
    [anon_sym_GT_TILDE] = ACTIONS(1052),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1052),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1052),
    [anon_sym_LT_TILDE] = ACTIONS(1052),
    [anon_sym_PLUS_QMARK] = ACTIONS(1052),
    [anon_sym_DASH_QMARK] = ACTIONS(1052),
    [anon_sym_STAR_QMARK] = ACTIONS(1052),
    [anon_sym_SLASH_QMARK] = ACTIONS(1052),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1052),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1052),
    [anon_sym_as] = ACTIONS(1052),
    [anon_sym_LPAREN2] = ACTIONS(1052),
    [anon_sym_DOT_GT] = ACTIONS(1052),
    [anon_sym_where] = ACTIONS(1052),
    [anon_sym_TILDE] = ACTIONS(1052),
    [anon_sym_end] = ACTIONS(1052),
    [anon_sym_if] = ACTIONS(1054),
    [anon_sym_ifdef] = ACTIONS(1052),
    [anon_sym_iftype] = ACTIONS(1052),
    [anon_sym_else] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1052),
    [anon_sym_while] = ACTIONS(1052),
    [anon_sym_try] = ACTIONS(1052),
    [anon_sym_with] = ACTIONS(1052),
    [anon_sym_repeat] = ACTIONS(1052),
    [anon_sym_do] = ACTIONS(1052),
    [anon_sym_recover] = ACTIONS(1052),
    [anon_sym_match] = ACTIONS(1052),
    [anon_sym_return] = ACTIONS(1052),
    [anon_sym_continue] = ACTIONS(1052),
    [anon_sym_break] = ACTIONS(1052),
    [anon_sym_consume] = ACTIONS(1052),
    [anon_sym_object] = ACTIONS(1052),
    [sym_number] = ACTIONS(1054),
    [sym_float] = ACTIONS(1052),
    [anon_sym_DQUOTE] = ACTIONS(1054),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1052),
    [anon_sym_SQUOTE] = ACTIONS(1052),
    [anon_sym_true] = ACTIONS(1052),
    [anon_sym_false] = ACTIONS(1052),
    [sym_this] = ACTIONS(1052),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [216] = {
    [sym_identifier] = ACTIONS(933),
    [anon_sym_EQ] = ACTIONS(933),
    [anon_sym_AT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_RBRACK] = ACTIONS(931),
    [anon_sym_is] = ACTIONS(933),
    [anon_sym_embed] = ACTIONS(931),
    [anon_sym_let] = ACTIONS(931),
    [anon_sym_var] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(931),
    [anon_sym_EQ_GT] = ACTIONS(931),
    [anon_sym_fun] = ACTIONS(931),
    [anon_sym_be] = ACTIONS(931),
    [anon_sym_COMMA] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(933),
    [anon_sym_RPAREN] = ACTIONS(931),
    [anon_sym_DOT] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_CARET] = ACTIONS(931),
    [anon_sym_PIPE] = ACTIONS(931),
    [anon_sym_AMP] = ACTIONS(931),
    [anon_sym_DASH_GT] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(931),
    [anon_sym_RBRACE] = ACTIONS(931),
    [anon_sym_SEMI] = ACTIONS(931),
    [sym_error] = ACTIONS(931),
    [sym_compile_intrinsic] = ACTIONS(931),
    [anon_sym_compile_error] = ACTIONS(931),
    [sym_location] = ACTIONS(931),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_not] = ACTIONS(931),
    [anon_sym_DASH_TILDE] = ACTIONS(931),
    [anon_sym_addressof] = ACTIONS(931),
    [anon_sym_digestof] = ACTIONS(931),
    [anon_sym_PLUS] = ACTIONS(933),
    [anon_sym_STAR] = ACTIONS(933),
    [anon_sym_SLASH] = ACTIONS(933),
    [anon_sym_PERCENT] = ACTIONS(933),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(933),
    [anon_sym_LT_LT] = ACTIONS(933),
    [anon_sym_GT_GT] = ACTIONS(933),
    [anon_sym_and] = ACTIONS(931),
    [anon_sym_or] = ACTIONS(931),
    [anon_sym_xor] = ACTIONS(931),
    [anon_sym_isnt] = ACTIONS(931),
    [anon_sym_EQ_EQ] = ACTIONS(933),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_GT] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_LT] = ACTIONS(933),
    [anon_sym_PLUS_TILDE] = ACTIONS(931),
    [anon_sym_STAR_TILDE] = ACTIONS(931),
    [anon_sym_SLASH_TILDE] = ACTIONS(931),
    [anon_sym_PERCENT_TILDE] = ACTIONS(931),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(931),
    [anon_sym_LT_LT_TILDE] = ACTIONS(931),
    [anon_sym_GT_GT_TILDE] = ACTIONS(931),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(931),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(931),
    [anon_sym_GT_TILDE] = ACTIONS(931),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(931),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(931),
    [anon_sym_LT_TILDE] = ACTIONS(931),
    [anon_sym_PLUS_QMARK] = ACTIONS(931),
    [anon_sym_DASH_QMARK] = ACTIONS(931),
    [anon_sym_STAR_QMARK] = ACTIONS(931),
    [anon_sym_SLASH_QMARK] = ACTIONS(931),
    [anon_sym_PERCENT_QMARK] = ACTIONS(931),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(931),
    [anon_sym_as] = ACTIONS(931),
    [anon_sym_LPAREN2] = ACTIONS(931),
    [anon_sym_DOT_GT] = ACTIONS(931),
    [anon_sym_where] = ACTIONS(931),
    [anon_sym_TILDE] = ACTIONS(931),
    [anon_sym_end] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(933),
    [anon_sym_ifdef] = ACTIONS(931),
    [anon_sym_then] = ACTIONS(931),
    [anon_sym_iftype] = ACTIONS(931),
    [anon_sym_else] = ACTIONS(931),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_try] = ACTIONS(931),
    [anon_sym_with] = ACTIONS(931),
    [anon_sym_repeat] = ACTIONS(931),
    [anon_sym_until] = ACTIONS(931),
    [anon_sym_do] = ACTIONS(931),
    [anon_sym_recover] = ACTIONS(931),
    [anon_sym_match] = ACTIONS(931),
    [anon_sym_return] = ACTIONS(931),
    [anon_sym_continue] = ACTIONS(931),
    [anon_sym_break] = ACTIONS(931),
    [anon_sym_consume] = ACTIONS(931),
    [anon_sym_object] = ACTIONS(931),
    [sym_number] = ACTIONS(933),
    [sym_float] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(933),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(931),
    [anon_sym_SQUOTE] = ACTIONS(931),
    [anon_sym_true] = ACTIONS(931),
    [anon_sym_false] = ACTIONS(931),
    [sym_this] = ACTIONS(931),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [217] = {
    [sym_identifier] = ACTIONS(957),
    [anon_sym_EQ] = ACTIONS(957),
    [anon_sym_AT] = ACTIONS(955),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_RBRACK] = ACTIONS(955),
    [anon_sym_is] = ACTIONS(957),
    [anon_sym_embed] = ACTIONS(955),
    [anon_sym_let] = ACTIONS(955),
    [anon_sym_var] = ACTIONS(955),
    [anon_sym_new] = ACTIONS(955),
    [anon_sym_EQ_GT] = ACTIONS(955),
    [anon_sym_fun] = ACTIONS(955),
    [anon_sym_be] = ACTIONS(955),
    [anon_sym_COMMA] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_RPAREN] = ACTIONS(955),
    [anon_sym_DOT] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(955),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_DASH_GT] = ACTIONS(955),
    [anon_sym_LBRACE] = ACTIONS(955),
    [anon_sym_RBRACE] = ACTIONS(955),
    [anon_sym_SEMI] = ACTIONS(955),
    [sym_error] = ACTIONS(955),
    [sym_compile_intrinsic] = ACTIONS(955),
    [anon_sym_compile_error] = ACTIONS(955),
    [sym_location] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_not] = ACTIONS(955),
    [anon_sym_DASH_TILDE] = ACTIONS(955),
    [anon_sym_addressof] = ACTIONS(955),
    [anon_sym_digestof] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(957),
    [anon_sym_SLASH] = ACTIONS(957),
    [anon_sym_PERCENT] = ACTIONS(957),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(957),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_and] = ACTIONS(955),
    [anon_sym_or] = ACTIONS(955),
    [anon_sym_xor] = ACTIONS(955),
    [anon_sym_isnt] = ACTIONS(955),
    [anon_sym_EQ_EQ] = ACTIONS(957),
    [anon_sym_BANG_EQ] = ACTIONS(957),
    [anon_sym_GT] = ACTIONS(957),
    [anon_sym_GT_EQ] = ACTIONS(957),
    [anon_sym_LT_EQ] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(957),
    [anon_sym_PLUS_TILDE] = ACTIONS(955),
    [anon_sym_STAR_TILDE] = ACTIONS(955),
    [anon_sym_SLASH_TILDE] = ACTIONS(955),
    [anon_sym_PERCENT_TILDE] = ACTIONS(955),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(955),
    [anon_sym_LT_LT_TILDE] = ACTIONS(955),
    [anon_sym_GT_GT_TILDE] = ACTIONS(955),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(955),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(955),
    [anon_sym_GT_TILDE] = ACTIONS(955),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(955),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(955),
    [anon_sym_LT_TILDE] = ACTIONS(955),
    [anon_sym_PLUS_QMARK] = ACTIONS(955),
    [anon_sym_DASH_QMARK] = ACTIONS(955),
    [anon_sym_STAR_QMARK] = ACTIONS(955),
    [anon_sym_SLASH_QMARK] = ACTIONS(955),
    [anon_sym_PERCENT_QMARK] = ACTIONS(955),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(955),
    [anon_sym_as] = ACTIONS(955),
    [anon_sym_LPAREN2] = ACTIONS(955),
    [anon_sym_DOT_GT] = ACTIONS(955),
    [anon_sym_where] = ACTIONS(955),
    [anon_sym_TILDE] = ACTIONS(955),
    [anon_sym_end] = ACTIONS(955),
    [anon_sym_if] = ACTIONS(957),
    [anon_sym_ifdef] = ACTIONS(955),
    [anon_sym_then] = ACTIONS(955),
    [anon_sym_iftype] = ACTIONS(955),
    [anon_sym_else] = ACTIONS(955),
    [anon_sym_for] = ACTIONS(955),
    [anon_sym_while] = ACTIONS(955),
    [anon_sym_try] = ACTIONS(955),
    [anon_sym_with] = ACTIONS(955),
    [anon_sym_repeat] = ACTIONS(955),
    [anon_sym_until] = ACTIONS(955),
    [anon_sym_do] = ACTIONS(955),
    [anon_sym_recover] = ACTIONS(955),
    [anon_sym_match] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(955),
    [anon_sym_continue] = ACTIONS(955),
    [anon_sym_break] = ACTIONS(955),
    [anon_sym_consume] = ACTIONS(955),
    [anon_sym_object] = ACTIONS(955),
    [sym_number] = ACTIONS(957),
    [sym_float] = ACTIONS(955),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(955),
    [anon_sym_SQUOTE] = ACTIONS(955),
    [anon_sym_true] = ACTIONS(955),
    [anon_sym_false] = ACTIONS(955),
    [sym_this] = ACTIONS(955),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [218] = {
    [sym_identifier] = ACTIONS(961),
    [anon_sym_EQ] = ACTIONS(961),
    [anon_sym_AT] = ACTIONS(959),
    [anon_sym_LBRACK] = ACTIONS(959),
    [anon_sym_RBRACK] = ACTIONS(959),
    [anon_sym_is] = ACTIONS(961),
    [anon_sym_embed] = ACTIONS(959),
    [anon_sym_let] = ACTIONS(959),
    [anon_sym_var] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(959),
    [anon_sym_EQ_GT] = ACTIONS(959),
    [anon_sym_fun] = ACTIONS(959),
    [anon_sym_be] = ACTIONS(959),
    [anon_sym_COMMA] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_RPAREN] = ACTIONS(959),
    [anon_sym_DOT] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_CARET] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_AMP] = ACTIONS(959),
    [anon_sym_DASH_GT] = ACTIONS(959),
    [anon_sym_LBRACE] = ACTIONS(959),
    [anon_sym_RBRACE] = ACTIONS(959),
    [anon_sym_SEMI] = ACTIONS(959),
    [sym_error] = ACTIONS(959),
    [sym_compile_intrinsic] = ACTIONS(959),
    [anon_sym_compile_error] = ACTIONS(959),
    [sym_location] = ACTIONS(959),
    [anon_sym_DASH] = ACTIONS(961),
    [anon_sym_not] = ACTIONS(959),
    [anon_sym_DASH_TILDE] = ACTIONS(959),
    [anon_sym_addressof] = ACTIONS(959),
    [anon_sym_digestof] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_STAR] = ACTIONS(961),
    [anon_sym_SLASH] = ACTIONS(961),
    [anon_sym_PERCENT] = ACTIONS(961),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(961),
    [anon_sym_LT_LT] = ACTIONS(961),
    [anon_sym_GT_GT] = ACTIONS(961),
    [anon_sym_and] = ACTIONS(959),
    [anon_sym_or] = ACTIONS(959),
    [anon_sym_xor] = ACTIONS(959),
    [anon_sym_isnt] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(961),
    [anon_sym_BANG_EQ] = ACTIONS(961),
    [anon_sym_GT] = ACTIONS(961),
    [anon_sym_GT_EQ] = ACTIONS(961),
    [anon_sym_LT_EQ] = ACTIONS(961),
    [anon_sym_LT] = ACTIONS(961),
    [anon_sym_PLUS_TILDE] = ACTIONS(959),
    [anon_sym_STAR_TILDE] = ACTIONS(959),
    [anon_sym_SLASH_TILDE] = ACTIONS(959),
    [anon_sym_PERCENT_TILDE] = ACTIONS(959),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(959),
    [anon_sym_LT_LT_TILDE] = ACTIONS(959),
    [anon_sym_GT_GT_TILDE] = ACTIONS(959),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(959),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(959),
    [anon_sym_GT_TILDE] = ACTIONS(959),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(959),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(959),
    [anon_sym_LT_TILDE] = ACTIONS(959),
    [anon_sym_PLUS_QMARK] = ACTIONS(959),
    [anon_sym_DASH_QMARK] = ACTIONS(959),
    [anon_sym_STAR_QMARK] = ACTIONS(959),
    [anon_sym_SLASH_QMARK] = ACTIONS(959),
    [anon_sym_PERCENT_QMARK] = ACTIONS(959),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(959),
    [anon_sym_as] = ACTIONS(959),
    [anon_sym_LPAREN2] = ACTIONS(959),
    [anon_sym_DOT_GT] = ACTIONS(959),
    [anon_sym_where] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_end] = ACTIONS(959),
    [anon_sym_if] = ACTIONS(961),
    [anon_sym_ifdef] = ACTIONS(959),
    [anon_sym_then] = ACTIONS(959),
    [anon_sym_iftype] = ACTIONS(959),
    [anon_sym_else] = ACTIONS(959),
    [anon_sym_for] = ACTIONS(959),
    [anon_sym_while] = ACTIONS(959),
    [anon_sym_try] = ACTIONS(959),
    [anon_sym_with] = ACTIONS(959),
    [anon_sym_repeat] = ACTIONS(959),
    [anon_sym_until] = ACTIONS(959),
    [anon_sym_do] = ACTIONS(959),
    [anon_sym_recover] = ACTIONS(959),
    [anon_sym_match] = ACTIONS(959),
    [anon_sym_return] = ACTIONS(959),
    [anon_sym_continue] = ACTIONS(959),
    [anon_sym_break] = ACTIONS(959),
    [anon_sym_consume] = ACTIONS(959),
    [anon_sym_object] = ACTIONS(959),
    [sym_number] = ACTIONS(961),
    [sym_float] = ACTIONS(959),
    [anon_sym_DQUOTE] = ACTIONS(961),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(959),
    [anon_sym_SQUOTE] = ACTIONS(959),
    [anon_sym_true] = ACTIONS(959),
    [anon_sym_false] = ACTIONS(959),
    [sym_this] = ACTIONS(959),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [219] = {
    [sym_identifier] = ACTIONS(680),
    [anon_sym_EQ] = ACTIONS(680),
    [anon_sym_AT] = ACTIONS(678),
    [anon_sym_LBRACK] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(678),
    [anon_sym_is] = ACTIONS(680),
    [anon_sym_embed] = ACTIONS(678),
    [anon_sym_let] = ACTIONS(678),
    [anon_sym_var] = ACTIONS(678),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_EQ_GT] = ACTIONS(678),
    [anon_sym_fun] = ACTIONS(678),
    [anon_sym_be] = ACTIONS(678),
    [anon_sym_COMMA] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_RPAREN] = ACTIONS(678),
    [anon_sym_DOT] = ACTIONS(680),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_CARET] = ACTIONS(678),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_AMP] = ACTIONS(678),
    [anon_sym_DASH_GT] = ACTIONS(678),
    [anon_sym_LBRACE] = ACTIONS(678),
    [anon_sym_RBRACE] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(678),
    [sym_error] = ACTIONS(678),
    [sym_compile_intrinsic] = ACTIONS(678),
    [anon_sym_compile_error] = ACTIONS(678),
    [sym_location] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(680),
    [anon_sym_not] = ACTIONS(678),
    [anon_sym_DASH_TILDE] = ACTIONS(678),
    [anon_sym_addressof] = ACTIONS(678),
    [anon_sym_digestof] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(680),
    [anon_sym_STAR] = ACTIONS(680),
    [anon_sym_SLASH] = ACTIONS(680),
    [anon_sym_PERCENT] = ACTIONS(680),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(680),
    [anon_sym_LT_LT] = ACTIONS(680),
    [anon_sym_GT_GT] = ACTIONS(680),
    [anon_sym_and] = ACTIONS(678),
    [anon_sym_or] = ACTIONS(678),
    [anon_sym_xor] = ACTIONS(678),
    [anon_sym_isnt] = ACTIONS(678),
    [anon_sym_EQ_EQ] = ACTIONS(680),
    [anon_sym_BANG_EQ] = ACTIONS(680),
    [anon_sym_GT] = ACTIONS(680),
    [anon_sym_GT_EQ] = ACTIONS(680),
    [anon_sym_LT_EQ] = ACTIONS(680),
    [anon_sym_LT] = ACTIONS(680),
    [anon_sym_PLUS_TILDE] = ACTIONS(678),
    [anon_sym_STAR_TILDE] = ACTIONS(678),
    [anon_sym_SLASH_TILDE] = ACTIONS(678),
    [anon_sym_PERCENT_TILDE] = ACTIONS(678),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(678),
    [anon_sym_LT_LT_TILDE] = ACTIONS(678),
    [anon_sym_GT_GT_TILDE] = ACTIONS(678),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(678),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(678),
    [anon_sym_GT_TILDE] = ACTIONS(678),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(678),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(678),
    [anon_sym_LT_TILDE] = ACTIONS(678),
    [anon_sym_PLUS_QMARK] = ACTIONS(678),
    [anon_sym_DASH_QMARK] = ACTIONS(678),
    [anon_sym_STAR_QMARK] = ACTIONS(678),
    [anon_sym_SLASH_QMARK] = ACTIONS(678),
    [anon_sym_PERCENT_QMARK] = ACTIONS(678),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(678),
    [anon_sym_as] = ACTIONS(678),
    [anon_sym_LPAREN2] = ACTIONS(678),
    [anon_sym_DOT_GT] = ACTIONS(678),
    [anon_sym_where] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(678),
    [anon_sym_end] = ACTIONS(678),
    [anon_sym_if] = ACTIONS(680),
    [anon_sym_ifdef] = ACTIONS(678),
    [anon_sym_then] = ACTIONS(678),
    [anon_sym_iftype] = ACTIONS(678),
    [anon_sym_else] = ACTIONS(678),
    [anon_sym_for] = ACTIONS(678),
    [anon_sym_while] = ACTIONS(678),
    [anon_sym_try] = ACTIONS(678),
    [anon_sym_with] = ACTIONS(678),
    [anon_sym_repeat] = ACTIONS(678),
    [anon_sym_until] = ACTIONS(678),
    [anon_sym_do] = ACTIONS(678),
    [anon_sym_recover] = ACTIONS(678),
    [anon_sym_match] = ACTIONS(678),
    [anon_sym_return] = ACTIONS(678),
    [anon_sym_continue] = ACTIONS(678),
    [anon_sym_break] = ACTIONS(678),
    [anon_sym_consume] = ACTIONS(678),
    [anon_sym_object] = ACTIONS(678),
    [sym_number] = ACTIONS(680),
    [sym_float] = ACTIONS(678),
    [anon_sym_DQUOTE] = ACTIONS(680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(678),
    [anon_sym_true] = ACTIONS(678),
    [anon_sym_false] = ACTIONS(678),
    [sym_this] = ACTIONS(678),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [220] = {
    [sym_identifier] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_AT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_RBRACK] = ACTIONS(939),
    [anon_sym_is] = ACTIONS(941),
    [anon_sym_embed] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(939),
    [anon_sym_var] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_fun] = ACTIONS(939),
    [anon_sym_be] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_LPAREN] = ACTIONS(941),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_BANG] = ACTIONS(941),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_DASH_GT] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_error] = ACTIONS(939),
    [sym_compile_intrinsic] = ACTIONS(939),
    [anon_sym_compile_error] = ACTIONS(939),
    [sym_location] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(941),
    [anon_sym_not] = ACTIONS(939),
    [anon_sym_DASH_TILDE] = ACTIONS(939),
    [anon_sym_addressof] = ACTIONS(939),
    [anon_sym_digestof] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_xor] = ACTIONS(939),
    [anon_sym_isnt] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_PLUS_TILDE] = ACTIONS(939),
    [anon_sym_STAR_TILDE] = ACTIONS(939),
    [anon_sym_SLASH_TILDE] = ACTIONS(939),
    [anon_sym_PERCENT_TILDE] = ACTIONS(939),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(939),
    [anon_sym_LT_LT_TILDE] = ACTIONS(939),
    [anon_sym_GT_GT_TILDE] = ACTIONS(939),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(939),
    [anon_sym_GT_TILDE] = ACTIONS(939),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(939),
    [anon_sym_LT_TILDE] = ACTIONS(939),
    [anon_sym_PLUS_QMARK] = ACTIONS(939),
    [anon_sym_DASH_QMARK] = ACTIONS(939),
    [anon_sym_STAR_QMARK] = ACTIONS(939),
    [anon_sym_SLASH_QMARK] = ACTIONS(939),
    [anon_sym_PERCENT_QMARK] = ACTIONS(939),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(939),
    [anon_sym_as] = ACTIONS(939),
    [anon_sym_LPAREN2] = ACTIONS(939),
    [anon_sym_DOT_GT] = ACTIONS(939),
    [anon_sym_where] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(939),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(941),
    [anon_sym_ifdef] = ACTIONS(939),
    [anon_sym_then] = ACTIONS(939),
    [anon_sym_iftype] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_for] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_try] = ACTIONS(939),
    [anon_sym_with] = ACTIONS(939),
    [anon_sym_repeat] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_recover] = ACTIONS(939),
    [anon_sym_match] = ACTIONS(939),
    [anon_sym_return] = ACTIONS(939),
    [anon_sym_continue] = ACTIONS(939),
    [anon_sym_break] = ACTIONS(939),
    [anon_sym_consume] = ACTIONS(939),
    [anon_sym_object] = ACTIONS(939),
    [sym_number] = ACTIONS(941),
    [sym_float] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(939),
    [anon_sym_SQUOTE] = ACTIONS(939),
    [anon_sym_true] = ACTIONS(939),
    [anon_sym_false] = ACTIONS(939),
    [sym_this] = ACTIONS(939),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [221] = {
    [sym_identifier] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(625),
    [anon_sym_AT] = ACTIONS(623),
    [anon_sym_LBRACK] = ACTIONS(623),
    [anon_sym_is] = ACTIONS(625),
    [anon_sym_let] = ACTIONS(623),
    [anon_sym_var] = ACTIONS(623),
    [anon_sym_iso] = ACTIONS(623),
    [anon_sym_trn] = ACTIONS(623),
    [anon_sym_ref] = ACTIONS(623),
    [anon_sym_val] = ACTIONS(623),
    [anon_sym_box] = ACTIONS(623),
    [anon_sym_tag] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOT] = ACTIONS(625),
    [anon_sym_POUNDread] = ACTIONS(623),
    [anon_sym_POUNDsend] = ACTIONS(623),
    [anon_sym_POUNDshare] = ACTIONS(623),
    [anon_sym_POUNDalias] = ACTIONS(623),
    [anon_sym_POUNDany] = ACTIONS(623),
    [anon_sym_BANG] = ACTIONS(625),
    [anon_sym_CARET] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(623),
    [anon_sym_AMP] = ACTIONS(623),
    [anon_sym_DASH_GT] = ACTIONS(623),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(623),
    [sym_error] = ACTIONS(623),
    [sym_compile_intrinsic] = ACTIONS(623),
    [anon_sym_compile_error] = ACTIONS(623),
    [sym_location] = ACTIONS(623),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_not] = ACTIONS(623),
    [anon_sym_DASH_TILDE] = ACTIONS(623),
    [anon_sym_addressof] = ACTIONS(623),
    [anon_sym_digestof] = ACTIONS(623),
    [anon_sym_PLUS] = ACTIONS(625),
    [anon_sym_STAR] = ACTIONS(625),
    [anon_sym_SLASH] = ACTIONS(625),
    [anon_sym_PERCENT] = ACTIONS(625),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(625),
    [anon_sym_LT_LT] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(625),
    [anon_sym_and] = ACTIONS(623),
    [anon_sym_or] = ACTIONS(623),
    [anon_sym_xor] = ACTIONS(623),
    [anon_sym_isnt] = ACTIONS(623),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(625),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_LT] = ACTIONS(625),
    [anon_sym_PLUS_TILDE] = ACTIONS(623),
    [anon_sym_STAR_TILDE] = ACTIONS(623),
    [anon_sym_SLASH_TILDE] = ACTIONS(623),
    [anon_sym_PERCENT_TILDE] = ACTIONS(623),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(623),
    [anon_sym_LT_LT_TILDE] = ACTIONS(623),
    [anon_sym_GT_GT_TILDE] = ACTIONS(623),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(623),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(623),
    [anon_sym_GT_TILDE] = ACTIONS(623),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(623),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(623),
    [anon_sym_LT_TILDE] = ACTIONS(623),
    [anon_sym_PLUS_QMARK] = ACTIONS(623),
    [anon_sym_DASH_QMARK] = ACTIONS(623),
    [anon_sym_STAR_QMARK] = ACTIONS(623),
    [anon_sym_SLASH_QMARK] = ACTIONS(623),
    [anon_sym_PERCENT_QMARK] = ACTIONS(623),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(623),
    [anon_sym_as] = ACTIONS(623),
    [anon_sym_LPAREN2] = ACTIONS(623),
    [anon_sym_DOT_GT] = ACTIONS(623),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_end] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_ifdef] = ACTIONS(623),
    [anon_sym_elseif] = ACTIONS(623),
    [anon_sym_iftype] = ACTIONS(623),
    [anon_sym_else] = ACTIONS(625),
    [anon_sym_for] = ACTIONS(623),
    [anon_sym_while] = ACTIONS(623),
    [anon_sym_try] = ACTIONS(623),
    [anon_sym_with] = ACTIONS(623),
    [anon_sym_repeat] = ACTIONS(623),
    [anon_sym_recover] = ACTIONS(623),
    [anon_sym_match] = ACTIONS(623),
    [anon_sym_return] = ACTIONS(623),
    [anon_sym_continue] = ACTIONS(623),
    [anon_sym_break] = ACTIONS(623),
    [anon_sym_consume] = ACTIONS(623),
    [anon_sym_object] = ACTIONS(623),
    [sym_number] = ACTIONS(625),
    [sym_float] = ACTIONS(623),
    [anon_sym_DQUOTE] = ACTIONS(625),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(623),
    [anon_sym_SQUOTE] = ACTIONS(623),
    [anon_sym_true] = ACTIONS(623),
    [anon_sym_false] = ACTIONS(623),
    [sym_this] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(623),
    [sym_block_comment] = ACTIONS(3),
  },
  [222] = {
    [ts_builtin_sym_end] = ACTIONS(1056),
    [sym_identifier] = ACTIONS(1058),
    [anon_sym_use] = ACTIONS(1056),
    [anon_sym_EQ] = ACTIONS(1058),
    [anon_sym_AT] = ACTIONS(1056),
    [anon_sym_LBRACK] = ACTIONS(1056),
    [anon_sym_QMARK] = ACTIONS(1056),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_is] = ACTIONS(1058),
    [anon_sym_actor] = ACTIONS(1056),
    [anon_sym_class] = ACTIONS(1056),
    [anon_sym_primitive] = ACTIONS(1056),
    [anon_sym_interface] = ACTIONS(1056),
    [anon_sym_trait] = ACTIONS(1056),
    [anon_sym_struct] = ACTIONS(1056),
    [anon_sym_embed] = ACTIONS(1056),
    [anon_sym_let] = ACTIONS(1056),
    [anon_sym_var] = ACTIONS(1056),
    [anon_sym_new] = ACTIONS(1056),
    [anon_sym_fun] = ACTIONS(1056),
    [anon_sym_be] = ACTIONS(1056),
    [anon_sym_COMMA] = ACTIONS(1056),
    [anon_sym_LPAREN] = ACTIONS(1058),
    [anon_sym_RPAREN] = ACTIONS(1056),
    [anon_sym_DOT] = ACTIONS(1058),
    [anon_sym_LBRACE] = ACTIONS(1056),
    [anon_sym_SEMI] = ACTIONS(1056),
    [sym_error] = ACTIONS(1056),
    [sym_compile_intrinsic] = ACTIONS(1056),
    [anon_sym_compile_error] = ACTIONS(1056),
    [sym_location] = ACTIONS(1056),
    [anon_sym_DASH] = ACTIONS(1058),
    [anon_sym_not] = ACTIONS(1056),
    [anon_sym_DASH_TILDE] = ACTIONS(1056),
    [anon_sym_addressof] = ACTIONS(1056),
    [anon_sym_digestof] = ACTIONS(1056),
    [anon_sym_PLUS] = ACTIONS(1058),
    [anon_sym_STAR] = ACTIONS(1058),
    [anon_sym_SLASH] = ACTIONS(1058),
    [anon_sym_PERCENT] = ACTIONS(1058),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1058),
    [anon_sym_LT_LT] = ACTIONS(1058),
    [anon_sym_GT_GT] = ACTIONS(1058),
    [anon_sym_and] = ACTIONS(1056),
    [anon_sym_or] = ACTIONS(1056),
    [anon_sym_xor] = ACTIONS(1056),
    [anon_sym_isnt] = ACTIONS(1056),
    [anon_sym_EQ_EQ] = ACTIONS(1058),
    [anon_sym_BANG_EQ] = ACTIONS(1058),
    [anon_sym_GT] = ACTIONS(1058),
    [anon_sym_GT_EQ] = ACTIONS(1058),
    [anon_sym_LT_EQ] = ACTIONS(1058),
    [anon_sym_LT] = ACTIONS(1058),
    [anon_sym_PLUS_TILDE] = ACTIONS(1056),
    [anon_sym_STAR_TILDE] = ACTIONS(1056),
    [anon_sym_SLASH_TILDE] = ACTIONS(1056),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1056),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1056),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1056),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1056),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1056),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1056),
    [anon_sym_GT_TILDE] = ACTIONS(1056),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1056),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1056),
    [anon_sym_LT_TILDE] = ACTIONS(1056),
    [anon_sym_PLUS_QMARK] = ACTIONS(1056),
    [anon_sym_DASH_QMARK] = ACTIONS(1056),
    [anon_sym_STAR_QMARK] = ACTIONS(1056),
    [anon_sym_SLASH_QMARK] = ACTIONS(1056),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1056),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1056),
    [anon_sym_as] = ACTIONS(1056),
    [anon_sym_LPAREN2] = ACTIONS(1056),
    [anon_sym_DOT_GT] = ACTIONS(1056),
    [anon_sym_where] = ACTIONS(1056),
    [anon_sym_TILDE] = ACTIONS(1056),
    [anon_sym_end] = ACTIONS(1056),
    [anon_sym_if] = ACTIONS(1058),
    [anon_sym_ifdef] = ACTIONS(1056),
    [anon_sym_iftype] = ACTIONS(1056),
    [anon_sym_else] = ACTIONS(1056),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1056),
    [anon_sym_try] = ACTIONS(1056),
    [anon_sym_with] = ACTIONS(1056),
    [anon_sym_repeat] = ACTIONS(1056),
    [anon_sym_do] = ACTIONS(1056),
    [anon_sym_recover] = ACTIONS(1056),
    [anon_sym_match] = ACTIONS(1056),
    [anon_sym_return] = ACTIONS(1056),
    [anon_sym_continue] = ACTIONS(1056),
    [anon_sym_break] = ACTIONS(1056),
    [anon_sym_consume] = ACTIONS(1056),
    [anon_sym_object] = ACTIONS(1056),
    [sym_number] = ACTIONS(1058),
    [sym_float] = ACTIONS(1056),
    [anon_sym_DQUOTE] = ACTIONS(1058),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1056),
    [anon_sym_SQUOTE] = ACTIONS(1056),
    [anon_sym_true] = ACTIONS(1056),
    [anon_sym_false] = ACTIONS(1056),
    [sym_this] = ACTIONS(1056),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [223] = {
    [ts_builtin_sym_end] = ACTIONS(1060),
    [sym_identifier] = ACTIONS(1062),
    [anon_sym_use] = ACTIONS(1060),
    [anon_sym_EQ] = ACTIONS(1062),
    [anon_sym_AT] = ACTIONS(1060),
    [anon_sym_LBRACK] = ACTIONS(1060),
    [anon_sym_QMARK] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1060),
    [anon_sym_is] = ACTIONS(1062),
    [anon_sym_actor] = ACTIONS(1060),
    [anon_sym_class] = ACTIONS(1060),
    [anon_sym_primitive] = ACTIONS(1060),
    [anon_sym_interface] = ACTIONS(1060),
    [anon_sym_trait] = ACTIONS(1060),
    [anon_sym_struct] = ACTIONS(1060),
    [anon_sym_embed] = ACTIONS(1060),
    [anon_sym_let] = ACTIONS(1060),
    [anon_sym_var] = ACTIONS(1060),
    [anon_sym_new] = ACTIONS(1060),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_be] = ACTIONS(1060),
    [anon_sym_COMMA] = ACTIONS(1060),
    [anon_sym_LPAREN] = ACTIONS(1062),
    [anon_sym_RPAREN] = ACTIONS(1060),
    [anon_sym_DOT] = ACTIONS(1062),
    [anon_sym_LBRACE] = ACTIONS(1060),
    [anon_sym_SEMI] = ACTIONS(1060),
    [sym_error] = ACTIONS(1060),
    [sym_compile_intrinsic] = ACTIONS(1060),
    [anon_sym_compile_error] = ACTIONS(1060),
    [sym_location] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1062),
    [anon_sym_not] = ACTIONS(1060),
    [anon_sym_DASH_TILDE] = ACTIONS(1060),
    [anon_sym_addressof] = ACTIONS(1060),
    [anon_sym_digestof] = ACTIONS(1060),
    [anon_sym_PLUS] = ACTIONS(1062),
    [anon_sym_STAR] = ACTIONS(1062),
    [anon_sym_SLASH] = ACTIONS(1062),
    [anon_sym_PERCENT] = ACTIONS(1062),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1062),
    [anon_sym_LT_LT] = ACTIONS(1062),
    [anon_sym_GT_GT] = ACTIONS(1062),
    [anon_sym_and] = ACTIONS(1060),
    [anon_sym_or] = ACTIONS(1060),
    [anon_sym_xor] = ACTIONS(1060),
    [anon_sym_isnt] = ACTIONS(1060),
    [anon_sym_EQ_EQ] = ACTIONS(1062),
    [anon_sym_BANG_EQ] = ACTIONS(1062),
    [anon_sym_GT] = ACTIONS(1062),
    [anon_sym_GT_EQ] = ACTIONS(1062),
    [anon_sym_LT_EQ] = ACTIONS(1062),
    [anon_sym_LT] = ACTIONS(1062),
    [anon_sym_PLUS_TILDE] = ACTIONS(1060),
    [anon_sym_STAR_TILDE] = ACTIONS(1060),
    [anon_sym_SLASH_TILDE] = ACTIONS(1060),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1060),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1060),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1060),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1060),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1060),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1060),
    [anon_sym_GT_TILDE] = ACTIONS(1060),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1060),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1060),
    [anon_sym_LT_TILDE] = ACTIONS(1060),
    [anon_sym_PLUS_QMARK] = ACTIONS(1060),
    [anon_sym_DASH_QMARK] = ACTIONS(1060),
    [anon_sym_STAR_QMARK] = ACTIONS(1060),
    [anon_sym_SLASH_QMARK] = ACTIONS(1060),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1060),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1060),
    [anon_sym_as] = ACTIONS(1060),
    [anon_sym_LPAREN2] = ACTIONS(1060),
    [anon_sym_DOT_GT] = ACTIONS(1060),
    [anon_sym_where] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1060),
    [anon_sym_end] = ACTIONS(1060),
    [anon_sym_if] = ACTIONS(1062),
    [anon_sym_ifdef] = ACTIONS(1060),
    [anon_sym_iftype] = ACTIONS(1060),
    [anon_sym_else] = ACTIONS(1060),
    [anon_sym_for] = ACTIONS(1060),
    [anon_sym_while] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1060),
    [anon_sym_with] = ACTIONS(1060),
    [anon_sym_repeat] = ACTIONS(1060),
    [anon_sym_do] = ACTIONS(1060),
    [anon_sym_recover] = ACTIONS(1060),
    [anon_sym_match] = ACTIONS(1060),
    [anon_sym_return] = ACTIONS(1060),
    [anon_sym_continue] = ACTIONS(1060),
    [anon_sym_break] = ACTIONS(1060),
    [anon_sym_consume] = ACTIONS(1060),
    [anon_sym_object] = ACTIONS(1060),
    [sym_number] = ACTIONS(1062),
    [sym_float] = ACTIONS(1060),
    [anon_sym_DQUOTE] = ACTIONS(1062),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1060),
    [anon_sym_SQUOTE] = ACTIONS(1060),
    [anon_sym_true] = ACTIONS(1060),
    [anon_sym_false] = ACTIONS(1060),
    [sym_this] = ACTIONS(1060),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [224] = {
    [sym_identifier] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(722),
    [anon_sym_AT] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(720),
    [anon_sym_is] = ACTIONS(722),
    [anon_sym_let] = ACTIONS(720),
    [anon_sym_var] = ACTIONS(720),
    [anon_sym_iso] = ACTIONS(720),
    [anon_sym_trn] = ACTIONS(720),
    [anon_sym_ref] = ACTIONS(720),
    [anon_sym_val] = ACTIONS(720),
    [anon_sym_box] = ACTIONS(720),
    [anon_sym_tag] = ACTIONS(720),
    [anon_sym_LPAREN] = ACTIONS(722),
    [anon_sym_DOT] = ACTIONS(722),
    [anon_sym_POUNDread] = ACTIONS(720),
    [anon_sym_POUNDsend] = ACTIONS(720),
    [anon_sym_POUNDshare] = ACTIONS(720),
    [anon_sym_POUNDalias] = ACTIONS(720),
    [anon_sym_POUNDany] = ACTIONS(720),
    [anon_sym_BANG] = ACTIONS(722),
    [anon_sym_CARET] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(720),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_DASH_GT] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(720),
    [sym_error] = ACTIONS(720),
    [sym_compile_intrinsic] = ACTIONS(720),
    [anon_sym_compile_error] = ACTIONS(720),
    [sym_location] = ACTIONS(720),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_not] = ACTIONS(720),
    [anon_sym_DASH_TILDE] = ACTIONS(720),
    [anon_sym_addressof] = ACTIONS(720),
    [anon_sym_digestof] = ACTIONS(720),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_STAR] = ACTIONS(722),
    [anon_sym_SLASH] = ACTIONS(722),
    [anon_sym_PERCENT] = ACTIONS(722),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(722),
    [anon_sym_LT_LT] = ACTIONS(722),
    [anon_sym_GT_GT] = ACTIONS(722),
    [anon_sym_and] = ACTIONS(720),
    [anon_sym_or] = ACTIONS(720),
    [anon_sym_xor] = ACTIONS(720),
    [anon_sym_isnt] = ACTIONS(720),
    [anon_sym_EQ_EQ] = ACTIONS(722),
    [anon_sym_BANG_EQ] = ACTIONS(722),
    [anon_sym_GT] = ACTIONS(722),
    [anon_sym_GT_EQ] = ACTIONS(722),
    [anon_sym_LT_EQ] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(722),
    [anon_sym_PLUS_TILDE] = ACTIONS(720),
    [anon_sym_STAR_TILDE] = ACTIONS(720),
    [anon_sym_SLASH_TILDE] = ACTIONS(720),
    [anon_sym_PERCENT_TILDE] = ACTIONS(720),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(720),
    [anon_sym_LT_LT_TILDE] = ACTIONS(720),
    [anon_sym_GT_GT_TILDE] = ACTIONS(720),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(720),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(720),
    [anon_sym_GT_TILDE] = ACTIONS(720),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(720),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(720),
    [anon_sym_LT_TILDE] = ACTIONS(720),
    [anon_sym_PLUS_QMARK] = ACTIONS(720),
    [anon_sym_DASH_QMARK] = ACTIONS(720),
    [anon_sym_STAR_QMARK] = ACTIONS(720),
    [anon_sym_SLASH_QMARK] = ACTIONS(720),
    [anon_sym_PERCENT_QMARK] = ACTIONS(720),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(720),
    [anon_sym_as] = ACTIONS(720),
    [anon_sym_LPAREN2] = ACTIONS(720),
    [anon_sym_DOT_GT] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(720),
    [anon_sym_end] = ACTIONS(720),
    [anon_sym_if] = ACTIONS(722),
    [anon_sym_ifdef] = ACTIONS(720),
    [anon_sym_elseif] = ACTIONS(720),
    [anon_sym_iftype] = ACTIONS(720),
    [anon_sym_else] = ACTIONS(722),
    [anon_sym_for] = ACTIONS(720),
    [anon_sym_while] = ACTIONS(720),
    [anon_sym_try] = ACTIONS(720),
    [anon_sym_with] = ACTIONS(720),
    [anon_sym_repeat] = ACTIONS(720),
    [anon_sym_recover] = ACTIONS(720),
    [anon_sym_match] = ACTIONS(720),
    [anon_sym_return] = ACTIONS(720),
    [anon_sym_continue] = ACTIONS(720),
    [anon_sym_break] = ACTIONS(720),
    [anon_sym_consume] = ACTIONS(720),
    [anon_sym_object] = ACTIONS(720),
    [sym_number] = ACTIONS(722),
    [sym_float] = ACTIONS(720),
    [anon_sym_DQUOTE] = ACTIONS(722),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_SQUOTE] = ACTIONS(720),
    [anon_sym_true] = ACTIONS(720),
    [anon_sym_false] = ACTIONS(720),
    [sym_this] = ACTIONS(720),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [225] = {
    [ts_builtin_sym_end] = ACTIONS(1066),
    [sym_identifier] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1066),
    [anon_sym_EQ] = ACTIONS(1068),
    [anon_sym_AT] = ACTIONS(1066),
    [anon_sym_LBRACK] = ACTIONS(1066),
    [anon_sym_type] = ACTIONS(1066),
    [anon_sym_is] = ACTIONS(1068),
    [anon_sym_actor] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(1066),
    [anon_sym_primitive] = ACTIONS(1066),
    [anon_sym_interface] = ACTIONS(1066),
    [anon_sym_trait] = ACTIONS(1066),
    [anon_sym_struct] = ACTIONS(1066),
    [anon_sym_embed] = ACTIONS(1066),
    [anon_sym_let] = ACTIONS(1066),
    [anon_sym_var] = ACTIONS(1066),
    [anon_sym_new] = ACTIONS(1066),
    [anon_sym_fun] = ACTIONS(1066),
    [anon_sym_be] = ACTIONS(1066),
    [anon_sym_COMMA] = ACTIONS(1066),
    [anon_sym_LPAREN] = ACTIONS(1068),
    [anon_sym_RPAREN] = ACTIONS(1066),
    [anon_sym_DOT] = ACTIONS(1068),
    [anon_sym_LBRACE] = ACTIONS(1066),
    [anon_sym_SEMI] = ACTIONS(1066),
    [sym_error] = ACTIONS(1066),
    [sym_compile_intrinsic] = ACTIONS(1066),
    [anon_sym_compile_error] = ACTIONS(1066),
    [sym_location] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1068),
    [anon_sym_not] = ACTIONS(1066),
    [anon_sym_DASH_TILDE] = ACTIONS(1066),
    [anon_sym_addressof] = ACTIONS(1066),
    [anon_sym_digestof] = ACTIONS(1066),
    [anon_sym_PLUS] = ACTIONS(1068),
    [anon_sym_STAR] = ACTIONS(1068),
    [anon_sym_SLASH] = ACTIONS(1068),
    [anon_sym_PERCENT] = ACTIONS(1068),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1068),
    [anon_sym_LT_LT] = ACTIONS(1068),
    [anon_sym_GT_GT] = ACTIONS(1068),
    [anon_sym_and] = ACTIONS(1066),
    [anon_sym_or] = ACTIONS(1066),
    [anon_sym_xor] = ACTIONS(1066),
    [anon_sym_isnt] = ACTIONS(1066),
    [anon_sym_EQ_EQ] = ACTIONS(1068),
    [anon_sym_BANG_EQ] = ACTIONS(1068),
    [anon_sym_GT] = ACTIONS(1068),
    [anon_sym_GT_EQ] = ACTIONS(1068),
    [anon_sym_LT_EQ] = ACTIONS(1068),
    [anon_sym_LT] = ACTIONS(1068),
    [anon_sym_PLUS_TILDE] = ACTIONS(1066),
    [anon_sym_STAR_TILDE] = ACTIONS(1066),
    [anon_sym_SLASH_TILDE] = ACTIONS(1066),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1066),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1066),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1066),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1066),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1066),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1066),
    [anon_sym_GT_TILDE] = ACTIONS(1066),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1066),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1066),
    [anon_sym_LT_TILDE] = ACTIONS(1066),
    [anon_sym_PLUS_QMARK] = ACTIONS(1066),
    [anon_sym_DASH_QMARK] = ACTIONS(1066),
    [anon_sym_STAR_QMARK] = ACTIONS(1066),
    [anon_sym_SLASH_QMARK] = ACTIONS(1066),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1066),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1066),
    [anon_sym_as] = ACTIONS(1066),
    [anon_sym_LPAREN2] = ACTIONS(1066),
    [anon_sym_DOT_GT] = ACTIONS(1066),
    [anon_sym_where] = ACTIONS(1066),
    [anon_sym_TILDE] = ACTIONS(1066),
    [anon_sym_end] = ACTIONS(1066),
    [anon_sym_if] = ACTIONS(1068),
    [anon_sym_ifdef] = ACTIONS(1066),
    [anon_sym_iftype] = ACTIONS(1066),
    [anon_sym_else] = ACTIONS(1066),
    [anon_sym_for] = ACTIONS(1066),
    [anon_sym_while] = ACTIONS(1066),
    [anon_sym_try] = ACTIONS(1066),
    [anon_sym_with] = ACTIONS(1066),
    [anon_sym_repeat] = ACTIONS(1066),
    [anon_sym_do] = ACTIONS(1066),
    [anon_sym_recover] = ACTIONS(1066),
    [anon_sym_match] = ACTIONS(1066),
    [anon_sym_return] = ACTIONS(1066),
    [anon_sym_continue] = ACTIONS(1066),
    [anon_sym_break] = ACTIONS(1066),
    [anon_sym_consume] = ACTIONS(1066),
    [anon_sym_object] = ACTIONS(1066),
    [sym_number] = ACTIONS(1068),
    [sym_float] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(1068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(1066),
    [anon_sym_true] = ACTIONS(1066),
    [anon_sym_false] = ACTIONS(1066),
    [sym_this] = ACTIONS(1066),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [226] = {
    [ts_builtin_sym_end] = ACTIONS(1070),
    [sym_identifier] = ACTIONS(1072),
    [anon_sym_use] = ACTIONS(1070),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_AT] = ACTIONS(1070),
    [anon_sym_LBRACK] = ACTIONS(1070),
    [anon_sym_type] = ACTIONS(1070),
    [anon_sym_is] = ACTIONS(1072),
    [anon_sym_actor] = ACTIONS(1070),
    [anon_sym_class] = ACTIONS(1070),
    [anon_sym_primitive] = ACTIONS(1070),
    [anon_sym_interface] = ACTIONS(1070),
    [anon_sym_trait] = ACTIONS(1070),
    [anon_sym_struct] = ACTIONS(1070),
    [anon_sym_embed] = ACTIONS(1070),
    [anon_sym_let] = ACTIONS(1070),
    [anon_sym_var] = ACTIONS(1070),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_fun] = ACTIONS(1070),
    [anon_sym_be] = ACTIONS(1070),
    [anon_sym_COMMA] = ACTIONS(1070),
    [anon_sym_LPAREN] = ACTIONS(1072),
    [anon_sym_RPAREN] = ACTIONS(1070),
    [anon_sym_DOT] = ACTIONS(1072),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_SEMI] = ACTIONS(1070),
    [sym_error] = ACTIONS(1070),
    [sym_compile_intrinsic] = ACTIONS(1070),
    [anon_sym_compile_error] = ACTIONS(1070),
    [sym_location] = ACTIONS(1070),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_not] = ACTIONS(1070),
    [anon_sym_DASH_TILDE] = ACTIONS(1070),
    [anon_sym_addressof] = ACTIONS(1070),
    [anon_sym_digestof] = ACTIONS(1070),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_STAR] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1072),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_and] = ACTIONS(1070),
    [anon_sym_or] = ACTIONS(1070),
    [anon_sym_xor] = ACTIONS(1070),
    [anon_sym_isnt] = ACTIONS(1070),
    [anon_sym_EQ_EQ] = ACTIONS(1072),
    [anon_sym_BANG_EQ] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_GT_EQ] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_PLUS_TILDE] = ACTIONS(1070),
    [anon_sym_STAR_TILDE] = ACTIONS(1070),
    [anon_sym_SLASH_TILDE] = ACTIONS(1070),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1070),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1070),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1070),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1070),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1070),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1070),
    [anon_sym_GT_TILDE] = ACTIONS(1070),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1070),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1070),
    [anon_sym_LT_TILDE] = ACTIONS(1070),
    [anon_sym_PLUS_QMARK] = ACTIONS(1070),
    [anon_sym_DASH_QMARK] = ACTIONS(1070),
    [anon_sym_STAR_QMARK] = ACTIONS(1070),
    [anon_sym_SLASH_QMARK] = ACTIONS(1070),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1070),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1070),
    [anon_sym_as] = ACTIONS(1070),
    [anon_sym_LPAREN2] = ACTIONS(1070),
    [anon_sym_DOT_GT] = ACTIONS(1070),
    [anon_sym_where] = ACTIONS(1070),
    [anon_sym_TILDE] = ACTIONS(1070),
    [anon_sym_end] = ACTIONS(1070),
    [anon_sym_if] = ACTIONS(1072),
    [anon_sym_ifdef] = ACTIONS(1070),
    [anon_sym_iftype] = ACTIONS(1070),
    [anon_sym_else] = ACTIONS(1070),
    [anon_sym_for] = ACTIONS(1070),
    [anon_sym_while] = ACTIONS(1070),
    [anon_sym_try] = ACTIONS(1070),
    [anon_sym_with] = ACTIONS(1070),
    [anon_sym_repeat] = ACTIONS(1070),
    [anon_sym_do] = ACTIONS(1070),
    [anon_sym_recover] = ACTIONS(1070),
    [anon_sym_match] = ACTIONS(1070),
    [anon_sym_return] = ACTIONS(1070),
    [anon_sym_continue] = ACTIONS(1070),
    [anon_sym_break] = ACTIONS(1070),
    [anon_sym_consume] = ACTIONS(1070),
    [anon_sym_object] = ACTIONS(1070),
    [sym_number] = ACTIONS(1072),
    [sym_float] = ACTIONS(1070),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1070),
    [anon_sym_SQUOTE] = ACTIONS(1070),
    [anon_sym_true] = ACTIONS(1070),
    [anon_sym_false] = ACTIONS(1070),
    [sym_this] = ACTIONS(1070),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [227] = {
    [ts_builtin_sym_end] = ACTIONS(1074),
    [sym_identifier] = ACTIONS(1076),
    [anon_sym_use] = ACTIONS(1074),
    [anon_sym_EQ] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1074),
    [anon_sym_type] = ACTIONS(1074),
    [anon_sym_is] = ACTIONS(1076),
    [anon_sym_actor] = ACTIONS(1074),
    [anon_sym_class] = ACTIONS(1074),
    [anon_sym_primitive] = ACTIONS(1074),
    [anon_sym_interface] = ACTIONS(1074),
    [anon_sym_trait] = ACTIONS(1074),
    [anon_sym_struct] = ACTIONS(1074),
    [anon_sym_embed] = ACTIONS(1074),
    [anon_sym_let] = ACTIONS(1074),
    [anon_sym_var] = ACTIONS(1074),
    [anon_sym_new] = ACTIONS(1074),
    [anon_sym_fun] = ACTIONS(1074),
    [anon_sym_be] = ACTIONS(1074),
    [anon_sym_COMMA] = ACTIONS(1074),
    [anon_sym_LPAREN] = ACTIONS(1076),
    [anon_sym_RPAREN] = ACTIONS(1074),
    [anon_sym_DOT] = ACTIONS(1076),
    [anon_sym_LBRACE] = ACTIONS(1074),
    [anon_sym_SEMI] = ACTIONS(1074),
    [sym_error] = ACTIONS(1074),
    [sym_compile_intrinsic] = ACTIONS(1074),
    [anon_sym_compile_error] = ACTIONS(1074),
    [sym_location] = ACTIONS(1074),
    [anon_sym_DASH] = ACTIONS(1076),
    [anon_sym_not] = ACTIONS(1074),
    [anon_sym_DASH_TILDE] = ACTIONS(1074),
    [anon_sym_addressof] = ACTIONS(1074),
    [anon_sym_digestof] = ACTIONS(1074),
    [anon_sym_PLUS] = ACTIONS(1076),
    [anon_sym_STAR] = ACTIONS(1076),
    [anon_sym_SLASH] = ACTIONS(1076),
    [anon_sym_PERCENT] = ACTIONS(1076),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1076),
    [anon_sym_LT_LT] = ACTIONS(1076),
    [anon_sym_GT_GT] = ACTIONS(1076),
    [anon_sym_and] = ACTIONS(1074),
    [anon_sym_or] = ACTIONS(1074),
    [anon_sym_xor] = ACTIONS(1074),
    [anon_sym_isnt] = ACTIONS(1074),
    [anon_sym_EQ_EQ] = ACTIONS(1076),
    [anon_sym_BANG_EQ] = ACTIONS(1076),
    [anon_sym_GT] = ACTIONS(1076),
    [anon_sym_GT_EQ] = ACTIONS(1076),
    [anon_sym_LT_EQ] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1076),
    [anon_sym_PLUS_TILDE] = ACTIONS(1074),
    [anon_sym_STAR_TILDE] = ACTIONS(1074),
    [anon_sym_SLASH_TILDE] = ACTIONS(1074),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1074),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1074),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1074),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1074),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1074),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1074),
    [anon_sym_GT_TILDE] = ACTIONS(1074),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1074),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1074),
    [anon_sym_LT_TILDE] = ACTIONS(1074),
    [anon_sym_PLUS_QMARK] = ACTIONS(1074),
    [anon_sym_DASH_QMARK] = ACTIONS(1074),
    [anon_sym_STAR_QMARK] = ACTIONS(1074),
    [anon_sym_SLASH_QMARK] = ACTIONS(1074),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1074),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1074),
    [anon_sym_as] = ACTIONS(1074),
    [anon_sym_LPAREN2] = ACTIONS(1074),
    [anon_sym_DOT_GT] = ACTIONS(1074),
    [anon_sym_where] = ACTIONS(1074),
    [anon_sym_TILDE] = ACTIONS(1074),
    [anon_sym_end] = ACTIONS(1074),
    [anon_sym_if] = ACTIONS(1076),
    [anon_sym_ifdef] = ACTIONS(1074),
    [anon_sym_iftype] = ACTIONS(1074),
    [anon_sym_else] = ACTIONS(1074),
    [anon_sym_for] = ACTIONS(1074),
    [anon_sym_while] = ACTIONS(1074),
    [anon_sym_try] = ACTIONS(1074),
    [anon_sym_with] = ACTIONS(1074),
    [anon_sym_repeat] = ACTIONS(1074),
    [anon_sym_do] = ACTIONS(1074),
    [anon_sym_recover] = ACTIONS(1074),
    [anon_sym_match] = ACTIONS(1074),
    [anon_sym_return] = ACTIONS(1074),
    [anon_sym_continue] = ACTIONS(1074),
    [anon_sym_break] = ACTIONS(1074),
    [anon_sym_consume] = ACTIONS(1074),
    [anon_sym_object] = ACTIONS(1074),
    [sym_number] = ACTIONS(1076),
    [sym_float] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1074),
    [anon_sym_SQUOTE] = ACTIONS(1074),
    [anon_sym_true] = ACTIONS(1074),
    [anon_sym_false] = ACTIONS(1074),
    [sym_this] = ACTIONS(1074),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [228] = {
    [ts_builtin_sym_end] = ACTIONS(1078),
    [sym_identifier] = ACTIONS(1080),
    [anon_sym_use] = ACTIONS(1078),
    [anon_sym_EQ] = ACTIONS(1080),
    [anon_sym_AT] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1078),
    [anon_sym_type] = ACTIONS(1078),
    [anon_sym_is] = ACTIONS(1080),
    [anon_sym_actor] = ACTIONS(1078),
    [anon_sym_class] = ACTIONS(1078),
    [anon_sym_primitive] = ACTIONS(1078),
    [anon_sym_interface] = ACTIONS(1078),
    [anon_sym_trait] = ACTIONS(1078),
    [anon_sym_struct] = ACTIONS(1078),
    [anon_sym_embed] = ACTIONS(1078),
    [anon_sym_let] = ACTIONS(1078),
    [anon_sym_var] = ACTIONS(1078),
    [anon_sym_new] = ACTIONS(1078),
    [anon_sym_fun] = ACTIONS(1078),
    [anon_sym_be] = ACTIONS(1078),
    [anon_sym_COMMA] = ACTIONS(1078),
    [anon_sym_LPAREN] = ACTIONS(1080),
    [anon_sym_RPAREN] = ACTIONS(1078),
    [anon_sym_DOT] = ACTIONS(1080),
    [anon_sym_LBRACE] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(1078),
    [sym_error] = ACTIONS(1078),
    [sym_compile_intrinsic] = ACTIONS(1078),
    [anon_sym_compile_error] = ACTIONS(1078),
    [sym_location] = ACTIONS(1078),
    [anon_sym_DASH] = ACTIONS(1080),
    [anon_sym_not] = ACTIONS(1078),
    [anon_sym_DASH_TILDE] = ACTIONS(1078),
    [anon_sym_addressof] = ACTIONS(1078),
    [anon_sym_digestof] = ACTIONS(1078),
    [anon_sym_PLUS] = ACTIONS(1080),
    [anon_sym_STAR] = ACTIONS(1080),
    [anon_sym_SLASH] = ACTIONS(1080),
    [anon_sym_PERCENT] = ACTIONS(1080),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1080),
    [anon_sym_LT_LT] = ACTIONS(1080),
    [anon_sym_GT_GT] = ACTIONS(1080),
    [anon_sym_and] = ACTIONS(1078),
    [anon_sym_or] = ACTIONS(1078),
    [anon_sym_xor] = ACTIONS(1078),
    [anon_sym_isnt] = ACTIONS(1078),
    [anon_sym_EQ_EQ] = ACTIONS(1080),
    [anon_sym_BANG_EQ] = ACTIONS(1080),
    [anon_sym_GT] = ACTIONS(1080),
    [anon_sym_GT_EQ] = ACTIONS(1080),
    [anon_sym_LT_EQ] = ACTIONS(1080),
    [anon_sym_LT] = ACTIONS(1080),
    [anon_sym_PLUS_TILDE] = ACTIONS(1078),
    [anon_sym_STAR_TILDE] = ACTIONS(1078),
    [anon_sym_SLASH_TILDE] = ACTIONS(1078),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1078),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1078),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1078),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1078),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1078),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1078),
    [anon_sym_GT_TILDE] = ACTIONS(1078),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1078),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1078),
    [anon_sym_LT_TILDE] = ACTIONS(1078),
    [anon_sym_PLUS_QMARK] = ACTIONS(1078),
    [anon_sym_DASH_QMARK] = ACTIONS(1078),
    [anon_sym_STAR_QMARK] = ACTIONS(1078),
    [anon_sym_SLASH_QMARK] = ACTIONS(1078),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1078),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1078),
    [anon_sym_as] = ACTIONS(1078),
    [anon_sym_LPAREN2] = ACTIONS(1078),
    [anon_sym_DOT_GT] = ACTIONS(1078),
    [anon_sym_where] = ACTIONS(1078),
    [anon_sym_TILDE] = ACTIONS(1078),
    [anon_sym_end] = ACTIONS(1078),
    [anon_sym_if] = ACTIONS(1080),
    [anon_sym_ifdef] = ACTIONS(1078),
    [anon_sym_iftype] = ACTIONS(1078),
    [anon_sym_else] = ACTIONS(1078),
    [anon_sym_for] = ACTIONS(1078),
    [anon_sym_while] = ACTIONS(1078),
    [anon_sym_try] = ACTIONS(1078),
    [anon_sym_with] = ACTIONS(1078),
    [anon_sym_repeat] = ACTIONS(1078),
    [anon_sym_do] = ACTIONS(1078),
    [anon_sym_recover] = ACTIONS(1078),
    [anon_sym_match] = ACTIONS(1078),
    [anon_sym_return] = ACTIONS(1078),
    [anon_sym_continue] = ACTIONS(1078),
    [anon_sym_break] = ACTIONS(1078),
    [anon_sym_consume] = ACTIONS(1078),
    [anon_sym_object] = ACTIONS(1078),
    [sym_number] = ACTIONS(1080),
    [sym_float] = ACTIONS(1078),
    [anon_sym_DQUOTE] = ACTIONS(1080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1078),
    [anon_sym_SQUOTE] = ACTIONS(1078),
    [anon_sym_true] = ACTIONS(1078),
    [anon_sym_false] = ACTIONS(1078),
    [sym_this] = ACTIONS(1078),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [229] = {
    [ts_builtin_sym_end] = ACTIONS(1082),
    [sym_identifier] = ACTIONS(1084),
    [anon_sym_use] = ACTIONS(1082),
    [anon_sym_EQ] = ACTIONS(1084),
    [anon_sym_AT] = ACTIONS(1082),
    [anon_sym_LBRACK] = ACTIONS(1082),
    [anon_sym_type] = ACTIONS(1082),
    [anon_sym_is] = ACTIONS(1084),
    [anon_sym_actor] = ACTIONS(1082),
    [anon_sym_class] = ACTIONS(1082),
    [anon_sym_primitive] = ACTIONS(1082),
    [anon_sym_interface] = ACTIONS(1082),
    [anon_sym_trait] = ACTIONS(1082),
    [anon_sym_struct] = ACTIONS(1082),
    [anon_sym_embed] = ACTIONS(1082),
    [anon_sym_let] = ACTIONS(1082),
    [anon_sym_var] = ACTIONS(1082),
    [anon_sym_new] = ACTIONS(1082),
    [anon_sym_fun] = ACTIONS(1082),
    [anon_sym_be] = ACTIONS(1082),
    [anon_sym_COMMA] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1084),
    [anon_sym_RPAREN] = ACTIONS(1082),
    [anon_sym_DOT] = ACTIONS(1084),
    [anon_sym_LBRACE] = ACTIONS(1082),
    [anon_sym_SEMI] = ACTIONS(1082),
    [sym_error] = ACTIONS(1082),
    [sym_compile_intrinsic] = ACTIONS(1082),
    [anon_sym_compile_error] = ACTIONS(1082),
    [sym_location] = ACTIONS(1082),
    [anon_sym_DASH] = ACTIONS(1084),
    [anon_sym_not] = ACTIONS(1082),
    [anon_sym_DASH_TILDE] = ACTIONS(1082),
    [anon_sym_addressof] = ACTIONS(1082),
    [anon_sym_digestof] = ACTIONS(1082),
    [anon_sym_PLUS] = ACTIONS(1084),
    [anon_sym_STAR] = ACTIONS(1084),
    [anon_sym_SLASH] = ACTIONS(1084),
    [anon_sym_PERCENT] = ACTIONS(1084),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1084),
    [anon_sym_LT_LT] = ACTIONS(1084),
    [anon_sym_GT_GT] = ACTIONS(1084),
    [anon_sym_and] = ACTIONS(1082),
    [anon_sym_or] = ACTIONS(1082),
    [anon_sym_xor] = ACTIONS(1082),
    [anon_sym_isnt] = ACTIONS(1082),
    [anon_sym_EQ_EQ] = ACTIONS(1084),
    [anon_sym_BANG_EQ] = ACTIONS(1084),
    [anon_sym_GT] = ACTIONS(1084),
    [anon_sym_GT_EQ] = ACTIONS(1084),
    [anon_sym_LT_EQ] = ACTIONS(1084),
    [anon_sym_LT] = ACTIONS(1084),
    [anon_sym_PLUS_TILDE] = ACTIONS(1082),
    [anon_sym_STAR_TILDE] = ACTIONS(1082),
    [anon_sym_SLASH_TILDE] = ACTIONS(1082),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1082),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1082),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1082),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1082),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1082),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1082),
    [anon_sym_GT_TILDE] = ACTIONS(1082),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1082),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1082),
    [anon_sym_LT_TILDE] = ACTIONS(1082),
    [anon_sym_PLUS_QMARK] = ACTIONS(1082),
    [anon_sym_DASH_QMARK] = ACTIONS(1082),
    [anon_sym_STAR_QMARK] = ACTIONS(1082),
    [anon_sym_SLASH_QMARK] = ACTIONS(1082),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1082),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1082),
    [anon_sym_as] = ACTIONS(1082),
    [anon_sym_LPAREN2] = ACTIONS(1082),
    [anon_sym_DOT_GT] = ACTIONS(1082),
    [anon_sym_where] = ACTIONS(1082),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_end] = ACTIONS(1082),
    [anon_sym_if] = ACTIONS(1084),
    [anon_sym_ifdef] = ACTIONS(1082),
    [anon_sym_iftype] = ACTIONS(1082),
    [anon_sym_else] = ACTIONS(1082),
    [anon_sym_for] = ACTIONS(1082),
    [anon_sym_while] = ACTIONS(1082),
    [anon_sym_try] = ACTIONS(1082),
    [anon_sym_with] = ACTIONS(1082),
    [anon_sym_repeat] = ACTIONS(1082),
    [anon_sym_do] = ACTIONS(1082),
    [anon_sym_recover] = ACTIONS(1082),
    [anon_sym_match] = ACTIONS(1082),
    [anon_sym_return] = ACTIONS(1082),
    [anon_sym_continue] = ACTIONS(1082),
    [anon_sym_break] = ACTIONS(1082),
    [anon_sym_consume] = ACTIONS(1082),
    [anon_sym_object] = ACTIONS(1082),
    [sym_number] = ACTIONS(1084),
    [sym_float] = ACTIONS(1082),
    [anon_sym_DQUOTE] = ACTIONS(1084),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1082),
    [anon_sym_SQUOTE] = ACTIONS(1082),
    [anon_sym_true] = ACTIONS(1082),
    [anon_sym_false] = ACTIONS(1082),
    [sym_this] = ACTIONS(1082),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [230] = {
    [sym_identifier] = ACTIONS(644),
    [anon_sym_EQ] = ACTIONS(644),
    [anon_sym_AT] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_is] = ACTIONS(644),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_var] = ACTIONS(642),
    [anon_sym_iso] = ACTIONS(642),
    [anon_sym_trn] = ACTIONS(642),
    [anon_sym_ref] = ACTIONS(642),
    [anon_sym_val] = ACTIONS(642),
    [anon_sym_box] = ACTIONS(642),
    [anon_sym_tag] = ACTIONS(642),
    [anon_sym_LPAREN] = ACTIONS(644),
    [anon_sym_DOT] = ACTIONS(644),
    [anon_sym_POUNDread] = ACTIONS(642),
    [anon_sym_POUNDsend] = ACTIONS(642),
    [anon_sym_POUNDshare] = ACTIONS(642),
    [anon_sym_POUNDalias] = ACTIONS(642),
    [anon_sym_POUNDany] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(644),
    [anon_sym_CARET] = ACTIONS(642),
    [anon_sym_PIPE] = ACTIONS(642),
    [anon_sym_AMP] = ACTIONS(642),
    [anon_sym_DASH_GT] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(642),
    [anon_sym_SEMI] = ACTIONS(642),
    [sym_error] = ACTIONS(642),
    [sym_compile_intrinsic] = ACTIONS(642),
    [anon_sym_compile_error] = ACTIONS(642),
    [sym_location] = ACTIONS(642),
    [anon_sym_DASH] = ACTIONS(644),
    [anon_sym_not] = ACTIONS(642),
    [anon_sym_DASH_TILDE] = ACTIONS(642),
    [anon_sym_addressof] = ACTIONS(642),
    [anon_sym_digestof] = ACTIONS(642),
    [anon_sym_PLUS] = ACTIONS(644),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_SLASH] = ACTIONS(644),
    [anon_sym_PERCENT] = ACTIONS(644),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(644),
    [anon_sym_LT_LT] = ACTIONS(644),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_and] = ACTIONS(642),
    [anon_sym_or] = ACTIONS(642),
    [anon_sym_xor] = ACTIONS(642),
    [anon_sym_isnt] = ACTIONS(642),
    [anon_sym_EQ_EQ] = ACTIONS(644),
    [anon_sym_BANG_EQ] = ACTIONS(644),
    [anon_sym_GT] = ACTIONS(644),
    [anon_sym_GT_EQ] = ACTIONS(644),
    [anon_sym_LT_EQ] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(644),
    [anon_sym_PLUS_TILDE] = ACTIONS(642),
    [anon_sym_STAR_TILDE] = ACTIONS(642),
    [anon_sym_SLASH_TILDE] = ACTIONS(642),
    [anon_sym_PERCENT_TILDE] = ACTIONS(642),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(642),
    [anon_sym_LT_LT_TILDE] = ACTIONS(642),
    [anon_sym_GT_GT_TILDE] = ACTIONS(642),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(642),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(642),
    [anon_sym_GT_TILDE] = ACTIONS(642),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(642),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(642),
    [anon_sym_LT_TILDE] = ACTIONS(642),
    [anon_sym_PLUS_QMARK] = ACTIONS(642),
    [anon_sym_DASH_QMARK] = ACTIONS(642),
    [anon_sym_STAR_QMARK] = ACTIONS(642),
    [anon_sym_SLASH_QMARK] = ACTIONS(642),
    [anon_sym_PERCENT_QMARK] = ACTIONS(642),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(642),
    [anon_sym_as] = ACTIONS(642),
    [anon_sym_LPAREN2] = ACTIONS(642),
    [anon_sym_DOT_GT] = ACTIONS(642),
    [anon_sym_TILDE] = ACTIONS(642),
    [anon_sym_end] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(644),
    [anon_sym_ifdef] = ACTIONS(642),
    [anon_sym_elseif] = ACTIONS(642),
    [anon_sym_iftype] = ACTIONS(642),
    [anon_sym_else] = ACTIONS(644),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(642),
    [anon_sym_try] = ACTIONS(642),
    [anon_sym_with] = ACTIONS(642),
    [anon_sym_repeat] = ACTIONS(642),
    [anon_sym_recover] = ACTIONS(642),
    [anon_sym_match] = ACTIONS(642),
    [anon_sym_return] = ACTIONS(642),
    [anon_sym_continue] = ACTIONS(642),
    [anon_sym_break] = ACTIONS(642),
    [anon_sym_consume] = ACTIONS(642),
    [anon_sym_object] = ACTIONS(642),
    [sym_number] = ACTIONS(644),
    [sym_float] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(642),
    [anon_sym_SQUOTE] = ACTIONS(642),
    [anon_sym_true] = ACTIONS(642),
    [anon_sym_false] = ACTIONS(642),
    [sym_this] = ACTIONS(642),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [231] = {
    [ts_builtin_sym_end] = ACTIONS(1086),
    [sym_identifier] = ACTIONS(1088),
    [anon_sym_use] = ACTIONS(1086),
    [anon_sym_EQ] = ACTIONS(1088),
    [anon_sym_AT] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_type] = ACTIONS(1086),
    [anon_sym_is] = ACTIONS(1088),
    [anon_sym_actor] = ACTIONS(1086),
    [anon_sym_class] = ACTIONS(1086),
    [anon_sym_primitive] = ACTIONS(1086),
    [anon_sym_interface] = ACTIONS(1086),
    [anon_sym_trait] = ACTIONS(1086),
    [anon_sym_struct] = ACTIONS(1086),
    [anon_sym_embed] = ACTIONS(1086),
    [anon_sym_let] = ACTIONS(1086),
    [anon_sym_var] = ACTIONS(1086),
    [anon_sym_new] = ACTIONS(1086),
    [anon_sym_fun] = ACTIONS(1086),
    [anon_sym_be] = ACTIONS(1086),
    [anon_sym_COMMA] = ACTIONS(1086),
    [anon_sym_LPAREN] = ACTIONS(1088),
    [anon_sym_RPAREN] = ACTIONS(1086),
    [anon_sym_DOT] = ACTIONS(1088),
    [anon_sym_LBRACE] = ACTIONS(1086),
    [anon_sym_SEMI] = ACTIONS(1086),
    [sym_error] = ACTIONS(1086),
    [sym_compile_intrinsic] = ACTIONS(1086),
    [anon_sym_compile_error] = ACTIONS(1086),
    [sym_location] = ACTIONS(1086),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_not] = ACTIONS(1086),
    [anon_sym_DASH_TILDE] = ACTIONS(1086),
    [anon_sym_addressof] = ACTIONS(1086),
    [anon_sym_digestof] = ACTIONS(1086),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_STAR] = ACTIONS(1088),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_PERCENT] = ACTIONS(1088),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1088),
    [anon_sym_LT_LT] = ACTIONS(1088),
    [anon_sym_GT_GT] = ACTIONS(1088),
    [anon_sym_and] = ACTIONS(1086),
    [anon_sym_or] = ACTIONS(1086),
    [anon_sym_xor] = ACTIONS(1086),
    [anon_sym_isnt] = ACTIONS(1086),
    [anon_sym_EQ_EQ] = ACTIONS(1088),
    [anon_sym_BANG_EQ] = ACTIONS(1088),
    [anon_sym_GT] = ACTIONS(1088),
    [anon_sym_GT_EQ] = ACTIONS(1088),
    [anon_sym_LT_EQ] = ACTIONS(1088),
    [anon_sym_LT] = ACTIONS(1088),
    [anon_sym_PLUS_TILDE] = ACTIONS(1086),
    [anon_sym_STAR_TILDE] = ACTIONS(1086),
    [anon_sym_SLASH_TILDE] = ACTIONS(1086),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1086),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1086),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1086),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1086),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1086),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1086),
    [anon_sym_GT_TILDE] = ACTIONS(1086),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1086),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1086),
    [anon_sym_LT_TILDE] = ACTIONS(1086),
    [anon_sym_PLUS_QMARK] = ACTIONS(1086),
    [anon_sym_DASH_QMARK] = ACTIONS(1086),
    [anon_sym_STAR_QMARK] = ACTIONS(1086),
    [anon_sym_SLASH_QMARK] = ACTIONS(1086),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1086),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1086),
    [anon_sym_as] = ACTIONS(1086),
    [anon_sym_LPAREN2] = ACTIONS(1086),
    [anon_sym_DOT_GT] = ACTIONS(1086),
    [anon_sym_where] = ACTIONS(1086),
    [anon_sym_TILDE] = ACTIONS(1086),
    [anon_sym_end] = ACTIONS(1086),
    [anon_sym_if] = ACTIONS(1088),
    [anon_sym_ifdef] = ACTIONS(1086),
    [anon_sym_iftype] = ACTIONS(1086),
    [anon_sym_else] = ACTIONS(1086),
    [anon_sym_for] = ACTIONS(1086),
    [anon_sym_while] = ACTIONS(1086),
    [anon_sym_try] = ACTIONS(1086),
    [anon_sym_with] = ACTIONS(1086),
    [anon_sym_repeat] = ACTIONS(1086),
    [anon_sym_do] = ACTIONS(1086),
    [anon_sym_recover] = ACTIONS(1086),
    [anon_sym_match] = ACTIONS(1086),
    [anon_sym_return] = ACTIONS(1086),
    [anon_sym_continue] = ACTIONS(1086),
    [anon_sym_break] = ACTIONS(1086),
    [anon_sym_consume] = ACTIONS(1086),
    [anon_sym_object] = ACTIONS(1086),
    [sym_number] = ACTIONS(1088),
    [sym_float] = ACTIONS(1086),
    [anon_sym_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1086),
    [anon_sym_true] = ACTIONS(1086),
    [anon_sym_false] = ACTIONS(1086),
    [sym_this] = ACTIONS(1086),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [232] = {
    [sym_identifier] = ACTIONS(652),
    [anon_sym_EQ] = ACTIONS(652),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_LBRACK] = ACTIONS(650),
    [anon_sym_is] = ACTIONS(652),
    [anon_sym_let] = ACTIONS(650),
    [anon_sym_var] = ACTIONS(650),
    [anon_sym_iso] = ACTIONS(650),
    [anon_sym_trn] = ACTIONS(650),
    [anon_sym_ref] = ACTIONS(650),
    [anon_sym_val] = ACTIONS(650),
    [anon_sym_box] = ACTIONS(650),
    [anon_sym_tag] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(652),
    [anon_sym_DOT] = ACTIONS(652),
    [anon_sym_POUNDread] = ACTIONS(650),
    [anon_sym_POUNDsend] = ACTIONS(650),
    [anon_sym_POUNDshare] = ACTIONS(650),
    [anon_sym_POUNDalias] = ACTIONS(650),
    [anon_sym_POUNDany] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(650),
    [anon_sym_DASH_GT] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [sym_error] = ACTIONS(650),
    [sym_compile_intrinsic] = ACTIONS(650),
    [anon_sym_compile_error] = ACTIONS(650),
    [sym_location] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_not] = ACTIONS(650),
    [anon_sym_DASH_TILDE] = ACTIONS(650),
    [anon_sym_addressof] = ACTIONS(650),
    [anon_sym_digestof] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_STAR] = ACTIONS(652),
    [anon_sym_SLASH] = ACTIONS(652),
    [anon_sym_PERCENT] = ACTIONS(652),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(652),
    [anon_sym_LT_LT] = ACTIONS(652),
    [anon_sym_GT_GT] = ACTIONS(652),
    [anon_sym_and] = ACTIONS(650),
    [anon_sym_or] = ACTIONS(650),
    [anon_sym_xor] = ACTIONS(650),
    [anon_sym_isnt] = ACTIONS(650),
    [anon_sym_EQ_EQ] = ACTIONS(652),
    [anon_sym_BANG_EQ] = ACTIONS(652),
    [anon_sym_GT] = ACTIONS(652),
    [anon_sym_GT_EQ] = ACTIONS(652),
    [anon_sym_LT_EQ] = ACTIONS(652),
    [anon_sym_LT] = ACTIONS(652),
    [anon_sym_PLUS_TILDE] = ACTIONS(650),
    [anon_sym_STAR_TILDE] = ACTIONS(650),
    [anon_sym_SLASH_TILDE] = ACTIONS(650),
    [anon_sym_PERCENT_TILDE] = ACTIONS(650),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(650),
    [anon_sym_LT_LT_TILDE] = ACTIONS(650),
    [anon_sym_GT_GT_TILDE] = ACTIONS(650),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(650),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(650),
    [anon_sym_GT_TILDE] = ACTIONS(650),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(650),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(650),
    [anon_sym_LT_TILDE] = ACTIONS(650),
    [anon_sym_PLUS_QMARK] = ACTIONS(650),
    [anon_sym_DASH_QMARK] = ACTIONS(650),
    [anon_sym_STAR_QMARK] = ACTIONS(650),
    [anon_sym_SLASH_QMARK] = ACTIONS(650),
    [anon_sym_PERCENT_QMARK] = ACTIONS(650),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(650),
    [anon_sym_as] = ACTIONS(650),
    [anon_sym_LPAREN2] = ACTIONS(650),
    [anon_sym_DOT_GT] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_end] = ACTIONS(650),
    [anon_sym_if] = ACTIONS(652),
    [anon_sym_ifdef] = ACTIONS(650),
    [anon_sym_elseif] = ACTIONS(650),
    [anon_sym_iftype] = ACTIONS(650),
    [anon_sym_else] = ACTIONS(652),
    [anon_sym_for] = ACTIONS(650),
    [anon_sym_while] = ACTIONS(650),
    [anon_sym_try] = ACTIONS(650),
    [anon_sym_with] = ACTIONS(650),
    [anon_sym_repeat] = ACTIONS(650),
    [anon_sym_recover] = ACTIONS(650),
    [anon_sym_match] = ACTIONS(650),
    [anon_sym_return] = ACTIONS(650),
    [anon_sym_continue] = ACTIONS(650),
    [anon_sym_break] = ACTIONS(650),
    [anon_sym_consume] = ACTIONS(650),
    [anon_sym_object] = ACTIONS(650),
    [sym_number] = ACTIONS(652),
    [sym_float] = ACTIONS(650),
    [anon_sym_DQUOTE] = ACTIONS(652),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(650),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_true] = ACTIONS(650),
    [anon_sym_false] = ACTIONS(650),
    [sym_this] = ACTIONS(650),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [233] = {
    [ts_builtin_sym_end] = ACTIONS(1090),
    [sym_identifier] = ACTIONS(1092),
    [anon_sym_use] = ACTIONS(1090),
    [anon_sym_EQ] = ACTIONS(1092),
    [anon_sym_AT] = ACTIONS(1090),
    [anon_sym_LBRACK] = ACTIONS(1090),
    [anon_sym_type] = ACTIONS(1090),
    [anon_sym_is] = ACTIONS(1092),
    [anon_sym_actor] = ACTIONS(1090),
    [anon_sym_class] = ACTIONS(1090),
    [anon_sym_primitive] = ACTIONS(1090),
    [anon_sym_interface] = ACTIONS(1090),
    [anon_sym_trait] = ACTIONS(1090),
    [anon_sym_struct] = ACTIONS(1090),
    [anon_sym_embed] = ACTIONS(1090),
    [anon_sym_let] = ACTIONS(1090),
    [anon_sym_var] = ACTIONS(1090),
    [anon_sym_new] = ACTIONS(1090),
    [anon_sym_fun] = ACTIONS(1090),
    [anon_sym_be] = ACTIONS(1090),
    [anon_sym_COMMA] = ACTIONS(1090),
    [anon_sym_LPAREN] = ACTIONS(1092),
    [anon_sym_RPAREN] = ACTIONS(1090),
    [anon_sym_DOT] = ACTIONS(1092),
    [anon_sym_LBRACE] = ACTIONS(1090),
    [anon_sym_SEMI] = ACTIONS(1090),
    [sym_error] = ACTIONS(1090),
    [sym_compile_intrinsic] = ACTIONS(1090),
    [anon_sym_compile_error] = ACTIONS(1090),
    [sym_location] = ACTIONS(1090),
    [anon_sym_DASH] = ACTIONS(1092),
    [anon_sym_not] = ACTIONS(1090),
    [anon_sym_DASH_TILDE] = ACTIONS(1090),
    [anon_sym_addressof] = ACTIONS(1090),
    [anon_sym_digestof] = ACTIONS(1090),
    [anon_sym_PLUS] = ACTIONS(1092),
    [anon_sym_STAR] = ACTIONS(1092),
    [anon_sym_SLASH] = ACTIONS(1092),
    [anon_sym_PERCENT] = ACTIONS(1092),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1092),
    [anon_sym_LT_LT] = ACTIONS(1092),
    [anon_sym_GT_GT] = ACTIONS(1092),
    [anon_sym_and] = ACTIONS(1090),
    [anon_sym_or] = ACTIONS(1090),
    [anon_sym_xor] = ACTIONS(1090),
    [anon_sym_isnt] = ACTIONS(1090),
    [anon_sym_EQ_EQ] = ACTIONS(1092),
    [anon_sym_BANG_EQ] = ACTIONS(1092),
    [anon_sym_GT] = ACTIONS(1092),
    [anon_sym_GT_EQ] = ACTIONS(1092),
    [anon_sym_LT_EQ] = ACTIONS(1092),
    [anon_sym_LT] = ACTIONS(1092),
    [anon_sym_PLUS_TILDE] = ACTIONS(1090),
    [anon_sym_STAR_TILDE] = ACTIONS(1090),
    [anon_sym_SLASH_TILDE] = ACTIONS(1090),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1090),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1090),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1090),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1090),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1090),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1090),
    [anon_sym_GT_TILDE] = ACTIONS(1090),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1090),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1090),
    [anon_sym_LT_TILDE] = ACTIONS(1090),
    [anon_sym_PLUS_QMARK] = ACTIONS(1090),
    [anon_sym_DASH_QMARK] = ACTIONS(1090),
    [anon_sym_STAR_QMARK] = ACTIONS(1090),
    [anon_sym_SLASH_QMARK] = ACTIONS(1090),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1090),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1090),
    [anon_sym_as] = ACTIONS(1090),
    [anon_sym_LPAREN2] = ACTIONS(1090),
    [anon_sym_DOT_GT] = ACTIONS(1090),
    [anon_sym_where] = ACTIONS(1090),
    [anon_sym_TILDE] = ACTIONS(1090),
    [anon_sym_end] = ACTIONS(1090),
    [anon_sym_if] = ACTIONS(1092),
    [anon_sym_ifdef] = ACTIONS(1090),
    [anon_sym_iftype] = ACTIONS(1090),
    [anon_sym_else] = ACTIONS(1090),
    [anon_sym_for] = ACTIONS(1090),
    [anon_sym_while] = ACTIONS(1090),
    [anon_sym_try] = ACTIONS(1090),
    [anon_sym_with] = ACTIONS(1090),
    [anon_sym_repeat] = ACTIONS(1090),
    [anon_sym_do] = ACTIONS(1090),
    [anon_sym_recover] = ACTIONS(1090),
    [anon_sym_match] = ACTIONS(1090),
    [anon_sym_return] = ACTIONS(1090),
    [anon_sym_continue] = ACTIONS(1090),
    [anon_sym_break] = ACTIONS(1090),
    [anon_sym_consume] = ACTIONS(1090),
    [anon_sym_object] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_float] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1090),
    [anon_sym_true] = ACTIONS(1090),
    [anon_sym_false] = ACTIONS(1090),
    [sym_this] = ACTIONS(1090),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [234] = {
    [ts_builtin_sym_end] = ACTIONS(1094),
    [sym_identifier] = ACTIONS(1096),
    [anon_sym_use] = ACTIONS(1094),
    [anon_sym_EQ] = ACTIONS(1096),
    [anon_sym_AT] = ACTIONS(1094),
    [anon_sym_LBRACK] = ACTIONS(1094),
    [anon_sym_type] = ACTIONS(1094),
    [anon_sym_is] = ACTIONS(1096),
    [anon_sym_actor] = ACTIONS(1094),
    [anon_sym_class] = ACTIONS(1094),
    [anon_sym_primitive] = ACTIONS(1094),
    [anon_sym_interface] = ACTIONS(1094),
    [anon_sym_trait] = ACTIONS(1094),
    [anon_sym_struct] = ACTIONS(1094),
    [anon_sym_embed] = ACTIONS(1094),
    [anon_sym_let] = ACTIONS(1094),
    [anon_sym_var] = ACTIONS(1094),
    [anon_sym_new] = ACTIONS(1094),
    [anon_sym_fun] = ACTIONS(1094),
    [anon_sym_be] = ACTIONS(1094),
    [anon_sym_COMMA] = ACTIONS(1094),
    [anon_sym_LPAREN] = ACTIONS(1096),
    [anon_sym_RPAREN] = ACTIONS(1094),
    [anon_sym_DOT] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(1094),
    [anon_sym_SEMI] = ACTIONS(1094),
    [sym_error] = ACTIONS(1094),
    [sym_compile_intrinsic] = ACTIONS(1094),
    [anon_sym_compile_error] = ACTIONS(1094),
    [sym_location] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1096),
    [anon_sym_not] = ACTIONS(1094),
    [anon_sym_DASH_TILDE] = ACTIONS(1094),
    [anon_sym_addressof] = ACTIONS(1094),
    [anon_sym_digestof] = ACTIONS(1094),
    [anon_sym_PLUS] = ACTIONS(1096),
    [anon_sym_STAR] = ACTIONS(1096),
    [anon_sym_SLASH] = ACTIONS(1096),
    [anon_sym_PERCENT] = ACTIONS(1096),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1096),
    [anon_sym_LT_LT] = ACTIONS(1096),
    [anon_sym_GT_GT] = ACTIONS(1096),
    [anon_sym_and] = ACTIONS(1094),
    [anon_sym_or] = ACTIONS(1094),
    [anon_sym_xor] = ACTIONS(1094),
    [anon_sym_isnt] = ACTIONS(1094),
    [anon_sym_EQ_EQ] = ACTIONS(1096),
    [anon_sym_BANG_EQ] = ACTIONS(1096),
    [anon_sym_GT] = ACTIONS(1096),
    [anon_sym_GT_EQ] = ACTIONS(1096),
    [anon_sym_LT_EQ] = ACTIONS(1096),
    [anon_sym_LT] = ACTIONS(1096),
    [anon_sym_PLUS_TILDE] = ACTIONS(1094),
    [anon_sym_STAR_TILDE] = ACTIONS(1094),
    [anon_sym_SLASH_TILDE] = ACTIONS(1094),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1094),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1094),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1094),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1094),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1094),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1094),
    [anon_sym_GT_TILDE] = ACTIONS(1094),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1094),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1094),
    [anon_sym_LT_TILDE] = ACTIONS(1094),
    [anon_sym_PLUS_QMARK] = ACTIONS(1094),
    [anon_sym_DASH_QMARK] = ACTIONS(1094),
    [anon_sym_STAR_QMARK] = ACTIONS(1094),
    [anon_sym_SLASH_QMARK] = ACTIONS(1094),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1094),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1094),
    [anon_sym_as] = ACTIONS(1094),
    [anon_sym_LPAREN2] = ACTIONS(1094),
    [anon_sym_DOT_GT] = ACTIONS(1094),
    [anon_sym_where] = ACTIONS(1094),
    [anon_sym_TILDE] = ACTIONS(1094),
    [anon_sym_end] = ACTIONS(1094),
    [anon_sym_if] = ACTIONS(1096),
    [anon_sym_ifdef] = ACTIONS(1094),
    [anon_sym_iftype] = ACTIONS(1094),
    [anon_sym_else] = ACTIONS(1094),
    [anon_sym_for] = ACTIONS(1094),
    [anon_sym_while] = ACTIONS(1094),
    [anon_sym_try] = ACTIONS(1094),
    [anon_sym_with] = ACTIONS(1094),
    [anon_sym_repeat] = ACTIONS(1094),
    [anon_sym_do] = ACTIONS(1094),
    [anon_sym_recover] = ACTIONS(1094),
    [anon_sym_match] = ACTIONS(1094),
    [anon_sym_return] = ACTIONS(1094),
    [anon_sym_continue] = ACTIONS(1094),
    [anon_sym_break] = ACTIONS(1094),
    [anon_sym_consume] = ACTIONS(1094),
    [anon_sym_object] = ACTIONS(1094),
    [sym_number] = ACTIONS(1096),
    [sym_float] = ACTIONS(1094),
    [anon_sym_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_SQUOTE] = ACTIONS(1094),
    [anon_sym_true] = ACTIONS(1094),
    [anon_sym_false] = ACTIONS(1094),
    [sym_this] = ACTIONS(1094),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [235] = {
    [ts_builtin_sym_end] = ACTIONS(1098),
    [sym_identifier] = ACTIONS(1100),
    [anon_sym_use] = ACTIONS(1098),
    [anon_sym_EQ] = ACTIONS(1100),
    [anon_sym_AT] = ACTIONS(1098),
    [anon_sym_LBRACK] = ACTIONS(1098),
    [anon_sym_type] = ACTIONS(1098),
    [anon_sym_is] = ACTIONS(1100),
    [anon_sym_actor] = ACTIONS(1098),
    [anon_sym_class] = ACTIONS(1098),
    [anon_sym_primitive] = ACTIONS(1098),
    [anon_sym_interface] = ACTIONS(1098),
    [anon_sym_trait] = ACTIONS(1098),
    [anon_sym_struct] = ACTIONS(1098),
    [anon_sym_embed] = ACTIONS(1098),
    [anon_sym_let] = ACTIONS(1098),
    [anon_sym_var] = ACTIONS(1098),
    [anon_sym_new] = ACTIONS(1098),
    [anon_sym_fun] = ACTIONS(1098),
    [anon_sym_be] = ACTIONS(1098),
    [anon_sym_COMMA] = ACTIONS(1098),
    [anon_sym_LPAREN] = ACTIONS(1100),
    [anon_sym_RPAREN] = ACTIONS(1098),
    [anon_sym_DOT] = ACTIONS(1100),
    [anon_sym_LBRACE] = ACTIONS(1098),
    [anon_sym_SEMI] = ACTIONS(1098),
    [sym_error] = ACTIONS(1098),
    [sym_compile_intrinsic] = ACTIONS(1098),
    [anon_sym_compile_error] = ACTIONS(1098),
    [sym_location] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1100),
    [anon_sym_not] = ACTIONS(1098),
    [anon_sym_DASH_TILDE] = ACTIONS(1098),
    [anon_sym_addressof] = ACTIONS(1098),
    [anon_sym_digestof] = ACTIONS(1098),
    [anon_sym_PLUS] = ACTIONS(1100),
    [anon_sym_STAR] = ACTIONS(1100),
    [anon_sym_SLASH] = ACTIONS(1100),
    [anon_sym_PERCENT] = ACTIONS(1100),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1100),
    [anon_sym_LT_LT] = ACTIONS(1100),
    [anon_sym_GT_GT] = ACTIONS(1100),
    [anon_sym_and] = ACTIONS(1098),
    [anon_sym_or] = ACTIONS(1098),
    [anon_sym_xor] = ACTIONS(1098),
    [anon_sym_isnt] = ACTIONS(1098),
    [anon_sym_EQ_EQ] = ACTIONS(1100),
    [anon_sym_BANG_EQ] = ACTIONS(1100),
    [anon_sym_GT] = ACTIONS(1100),
    [anon_sym_GT_EQ] = ACTIONS(1100),
    [anon_sym_LT_EQ] = ACTIONS(1100),
    [anon_sym_LT] = ACTIONS(1100),
    [anon_sym_PLUS_TILDE] = ACTIONS(1098),
    [anon_sym_STAR_TILDE] = ACTIONS(1098),
    [anon_sym_SLASH_TILDE] = ACTIONS(1098),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1098),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1098),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1098),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1098),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1098),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1098),
    [anon_sym_GT_TILDE] = ACTIONS(1098),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1098),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1098),
    [anon_sym_LT_TILDE] = ACTIONS(1098),
    [anon_sym_PLUS_QMARK] = ACTIONS(1098),
    [anon_sym_DASH_QMARK] = ACTIONS(1098),
    [anon_sym_STAR_QMARK] = ACTIONS(1098),
    [anon_sym_SLASH_QMARK] = ACTIONS(1098),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1098),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1098),
    [anon_sym_as] = ACTIONS(1098),
    [anon_sym_LPAREN2] = ACTIONS(1098),
    [anon_sym_DOT_GT] = ACTIONS(1098),
    [anon_sym_where] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1098),
    [anon_sym_end] = ACTIONS(1098),
    [anon_sym_if] = ACTIONS(1100),
    [anon_sym_ifdef] = ACTIONS(1098),
    [anon_sym_iftype] = ACTIONS(1098),
    [anon_sym_else] = ACTIONS(1098),
    [anon_sym_for] = ACTIONS(1098),
    [anon_sym_while] = ACTIONS(1098),
    [anon_sym_try] = ACTIONS(1098),
    [anon_sym_with] = ACTIONS(1098),
    [anon_sym_repeat] = ACTIONS(1098),
    [anon_sym_do] = ACTIONS(1098),
    [anon_sym_recover] = ACTIONS(1098),
    [anon_sym_match] = ACTIONS(1098),
    [anon_sym_return] = ACTIONS(1098),
    [anon_sym_continue] = ACTIONS(1098),
    [anon_sym_break] = ACTIONS(1098),
    [anon_sym_consume] = ACTIONS(1098),
    [anon_sym_object] = ACTIONS(1098),
    [sym_number] = ACTIONS(1100),
    [sym_float] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(1100),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_SQUOTE] = ACTIONS(1098),
    [anon_sym_true] = ACTIONS(1098),
    [anon_sym_false] = ACTIONS(1098),
    [sym_this] = ACTIONS(1098),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [236] = {
    [ts_builtin_sym_end] = ACTIONS(1102),
    [sym_identifier] = ACTIONS(1104),
    [anon_sym_use] = ACTIONS(1102),
    [anon_sym_EQ] = ACTIONS(1104),
    [anon_sym_AT] = ACTIONS(1102),
    [anon_sym_LBRACK] = ACTIONS(1102),
    [anon_sym_type] = ACTIONS(1102),
    [anon_sym_is] = ACTIONS(1104),
    [anon_sym_actor] = ACTIONS(1102),
    [anon_sym_class] = ACTIONS(1102),
    [anon_sym_primitive] = ACTIONS(1102),
    [anon_sym_interface] = ACTIONS(1102),
    [anon_sym_trait] = ACTIONS(1102),
    [anon_sym_struct] = ACTIONS(1102),
    [anon_sym_embed] = ACTIONS(1102),
    [anon_sym_let] = ACTIONS(1102),
    [anon_sym_var] = ACTIONS(1102),
    [anon_sym_new] = ACTIONS(1102),
    [anon_sym_fun] = ACTIONS(1102),
    [anon_sym_be] = ACTIONS(1102),
    [anon_sym_COMMA] = ACTIONS(1102),
    [anon_sym_LPAREN] = ACTIONS(1104),
    [anon_sym_RPAREN] = ACTIONS(1102),
    [anon_sym_DOT] = ACTIONS(1104),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1102),
    [sym_error] = ACTIONS(1102),
    [sym_compile_intrinsic] = ACTIONS(1102),
    [anon_sym_compile_error] = ACTIONS(1102),
    [sym_location] = ACTIONS(1102),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_not] = ACTIONS(1102),
    [anon_sym_DASH_TILDE] = ACTIONS(1102),
    [anon_sym_addressof] = ACTIONS(1102),
    [anon_sym_digestof] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1104),
    [anon_sym_SLASH] = ACTIONS(1104),
    [anon_sym_PERCENT] = ACTIONS(1104),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1104),
    [anon_sym_LT_LT] = ACTIONS(1104),
    [anon_sym_GT_GT] = ACTIONS(1104),
    [anon_sym_and] = ACTIONS(1102),
    [anon_sym_or] = ACTIONS(1102),
    [anon_sym_xor] = ACTIONS(1102),
    [anon_sym_isnt] = ACTIONS(1102),
    [anon_sym_EQ_EQ] = ACTIONS(1104),
    [anon_sym_BANG_EQ] = ACTIONS(1104),
    [anon_sym_GT] = ACTIONS(1104),
    [anon_sym_GT_EQ] = ACTIONS(1104),
    [anon_sym_LT_EQ] = ACTIONS(1104),
    [anon_sym_LT] = ACTIONS(1104),
    [anon_sym_PLUS_TILDE] = ACTIONS(1102),
    [anon_sym_STAR_TILDE] = ACTIONS(1102),
    [anon_sym_SLASH_TILDE] = ACTIONS(1102),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1102),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1102),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1102),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1102),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1102),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1102),
    [anon_sym_GT_TILDE] = ACTIONS(1102),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1102),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1102),
    [anon_sym_LT_TILDE] = ACTIONS(1102),
    [anon_sym_PLUS_QMARK] = ACTIONS(1102),
    [anon_sym_DASH_QMARK] = ACTIONS(1102),
    [anon_sym_STAR_QMARK] = ACTIONS(1102),
    [anon_sym_SLASH_QMARK] = ACTIONS(1102),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1102),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1102),
    [anon_sym_as] = ACTIONS(1102),
    [anon_sym_LPAREN2] = ACTIONS(1102),
    [anon_sym_DOT_GT] = ACTIONS(1102),
    [anon_sym_where] = ACTIONS(1102),
    [anon_sym_TILDE] = ACTIONS(1102),
    [anon_sym_end] = ACTIONS(1102),
    [anon_sym_if] = ACTIONS(1104),
    [anon_sym_ifdef] = ACTIONS(1102),
    [anon_sym_iftype] = ACTIONS(1102),
    [anon_sym_else] = ACTIONS(1102),
    [anon_sym_for] = ACTIONS(1102),
    [anon_sym_while] = ACTIONS(1102),
    [anon_sym_try] = ACTIONS(1102),
    [anon_sym_with] = ACTIONS(1102),
    [anon_sym_repeat] = ACTIONS(1102),
    [anon_sym_do] = ACTIONS(1102),
    [anon_sym_recover] = ACTIONS(1102),
    [anon_sym_match] = ACTIONS(1102),
    [anon_sym_return] = ACTIONS(1102),
    [anon_sym_continue] = ACTIONS(1102),
    [anon_sym_break] = ACTIONS(1102),
    [anon_sym_consume] = ACTIONS(1102),
    [anon_sym_object] = ACTIONS(1102),
    [sym_number] = ACTIONS(1104),
    [sym_float] = ACTIONS(1102),
    [anon_sym_DQUOTE] = ACTIONS(1104),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1102),
    [anon_sym_SQUOTE] = ACTIONS(1102),
    [anon_sym_true] = ACTIONS(1102),
    [anon_sym_false] = ACTIONS(1102),
    [sym_this] = ACTIONS(1102),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [237] = {
    [ts_builtin_sym_end] = ACTIONS(1106),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_use] = ACTIONS(1106),
    [anon_sym_EQ] = ACTIONS(1108),
    [anon_sym_AT] = ACTIONS(1106),
    [anon_sym_LBRACK] = ACTIONS(1106),
    [anon_sym_type] = ACTIONS(1106),
    [anon_sym_is] = ACTIONS(1108),
    [anon_sym_actor] = ACTIONS(1106),
    [anon_sym_class] = ACTIONS(1106),
    [anon_sym_primitive] = ACTIONS(1106),
    [anon_sym_interface] = ACTIONS(1106),
    [anon_sym_trait] = ACTIONS(1106),
    [anon_sym_struct] = ACTIONS(1106),
    [anon_sym_embed] = ACTIONS(1106),
    [anon_sym_let] = ACTIONS(1106),
    [anon_sym_var] = ACTIONS(1106),
    [anon_sym_new] = ACTIONS(1106),
    [anon_sym_fun] = ACTIONS(1106),
    [anon_sym_be] = ACTIONS(1106),
    [anon_sym_COMMA] = ACTIONS(1106),
    [anon_sym_LPAREN] = ACTIONS(1108),
    [anon_sym_RPAREN] = ACTIONS(1106),
    [anon_sym_DOT] = ACTIONS(1108),
    [anon_sym_LBRACE] = ACTIONS(1106),
    [anon_sym_SEMI] = ACTIONS(1106),
    [sym_error] = ACTIONS(1106),
    [sym_compile_intrinsic] = ACTIONS(1106),
    [anon_sym_compile_error] = ACTIONS(1106),
    [sym_location] = ACTIONS(1106),
    [anon_sym_DASH] = ACTIONS(1108),
    [anon_sym_not] = ACTIONS(1106),
    [anon_sym_DASH_TILDE] = ACTIONS(1106),
    [anon_sym_addressof] = ACTIONS(1106),
    [anon_sym_digestof] = ACTIONS(1106),
    [anon_sym_PLUS] = ACTIONS(1108),
    [anon_sym_STAR] = ACTIONS(1108),
    [anon_sym_SLASH] = ACTIONS(1108),
    [anon_sym_PERCENT] = ACTIONS(1108),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1108),
    [anon_sym_LT_LT] = ACTIONS(1108),
    [anon_sym_GT_GT] = ACTIONS(1108),
    [anon_sym_and] = ACTIONS(1106),
    [anon_sym_or] = ACTIONS(1106),
    [anon_sym_xor] = ACTIONS(1106),
    [anon_sym_isnt] = ACTIONS(1106),
    [anon_sym_EQ_EQ] = ACTIONS(1108),
    [anon_sym_BANG_EQ] = ACTIONS(1108),
    [anon_sym_GT] = ACTIONS(1108),
    [anon_sym_GT_EQ] = ACTIONS(1108),
    [anon_sym_LT_EQ] = ACTIONS(1108),
    [anon_sym_LT] = ACTIONS(1108),
    [anon_sym_PLUS_TILDE] = ACTIONS(1106),
    [anon_sym_STAR_TILDE] = ACTIONS(1106),
    [anon_sym_SLASH_TILDE] = ACTIONS(1106),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1106),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1106),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1106),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1106),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1106),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1106),
    [anon_sym_GT_TILDE] = ACTIONS(1106),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1106),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1106),
    [anon_sym_LT_TILDE] = ACTIONS(1106),
    [anon_sym_PLUS_QMARK] = ACTIONS(1106),
    [anon_sym_DASH_QMARK] = ACTIONS(1106),
    [anon_sym_STAR_QMARK] = ACTIONS(1106),
    [anon_sym_SLASH_QMARK] = ACTIONS(1106),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1106),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1106),
    [anon_sym_as] = ACTIONS(1106),
    [anon_sym_LPAREN2] = ACTIONS(1106),
    [anon_sym_DOT_GT] = ACTIONS(1106),
    [anon_sym_where] = ACTIONS(1106),
    [anon_sym_TILDE] = ACTIONS(1106),
    [anon_sym_end] = ACTIONS(1106),
    [anon_sym_if] = ACTIONS(1108),
    [anon_sym_ifdef] = ACTIONS(1106),
    [anon_sym_iftype] = ACTIONS(1106),
    [anon_sym_else] = ACTIONS(1106),
    [anon_sym_for] = ACTIONS(1106),
    [anon_sym_while] = ACTIONS(1106),
    [anon_sym_try] = ACTIONS(1106),
    [anon_sym_with] = ACTIONS(1106),
    [anon_sym_repeat] = ACTIONS(1106),
    [anon_sym_do] = ACTIONS(1106),
    [anon_sym_recover] = ACTIONS(1106),
    [anon_sym_match] = ACTIONS(1106),
    [anon_sym_return] = ACTIONS(1106),
    [anon_sym_continue] = ACTIONS(1106),
    [anon_sym_break] = ACTIONS(1106),
    [anon_sym_consume] = ACTIONS(1106),
    [anon_sym_object] = ACTIONS(1106),
    [sym_number] = ACTIONS(1108),
    [sym_float] = ACTIONS(1106),
    [anon_sym_DQUOTE] = ACTIONS(1108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1106),
    [anon_sym_SQUOTE] = ACTIONS(1106),
    [anon_sym_true] = ACTIONS(1106),
    [anon_sym_false] = ACTIONS(1106),
    [sym_this] = ACTIONS(1106),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [238] = {
    [ts_builtin_sym_end] = ACTIONS(1110),
    [sym_identifier] = ACTIONS(1112),
    [anon_sym_use] = ACTIONS(1110),
    [anon_sym_EQ] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1110),
    [anon_sym_LBRACK] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_is] = ACTIONS(1112),
    [anon_sym_actor] = ACTIONS(1110),
    [anon_sym_class] = ACTIONS(1110),
    [anon_sym_primitive] = ACTIONS(1110),
    [anon_sym_interface] = ACTIONS(1110),
    [anon_sym_trait] = ACTIONS(1110),
    [anon_sym_struct] = ACTIONS(1110),
    [anon_sym_embed] = ACTIONS(1110),
    [anon_sym_let] = ACTIONS(1110),
    [anon_sym_var] = ACTIONS(1110),
    [anon_sym_new] = ACTIONS(1110),
    [anon_sym_fun] = ACTIONS(1110),
    [anon_sym_be] = ACTIONS(1110),
    [anon_sym_COMMA] = ACTIONS(1110),
    [anon_sym_LPAREN] = ACTIONS(1112),
    [anon_sym_RPAREN] = ACTIONS(1110),
    [anon_sym_DOT] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1110),
    [anon_sym_SEMI] = ACTIONS(1110),
    [sym_error] = ACTIONS(1110),
    [sym_compile_intrinsic] = ACTIONS(1110),
    [anon_sym_compile_error] = ACTIONS(1110),
    [sym_location] = ACTIONS(1110),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_not] = ACTIONS(1110),
    [anon_sym_DASH_TILDE] = ACTIONS(1110),
    [anon_sym_addressof] = ACTIONS(1110),
    [anon_sym_digestof] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1112),
    [anon_sym_PERCENT] = ACTIONS(1112),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1112),
    [anon_sym_LT_LT] = ACTIONS(1112),
    [anon_sym_GT_GT] = ACTIONS(1112),
    [anon_sym_and] = ACTIONS(1110),
    [anon_sym_or] = ACTIONS(1110),
    [anon_sym_xor] = ACTIONS(1110),
    [anon_sym_isnt] = ACTIONS(1110),
    [anon_sym_EQ_EQ] = ACTIONS(1112),
    [anon_sym_BANG_EQ] = ACTIONS(1112),
    [anon_sym_GT] = ACTIONS(1112),
    [anon_sym_GT_EQ] = ACTIONS(1112),
    [anon_sym_LT_EQ] = ACTIONS(1112),
    [anon_sym_LT] = ACTIONS(1112),
    [anon_sym_PLUS_TILDE] = ACTIONS(1110),
    [anon_sym_STAR_TILDE] = ACTIONS(1110),
    [anon_sym_SLASH_TILDE] = ACTIONS(1110),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1110),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1110),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1110),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1110),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1110),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1110),
    [anon_sym_GT_TILDE] = ACTIONS(1110),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1110),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1110),
    [anon_sym_LT_TILDE] = ACTIONS(1110),
    [anon_sym_PLUS_QMARK] = ACTIONS(1110),
    [anon_sym_DASH_QMARK] = ACTIONS(1110),
    [anon_sym_STAR_QMARK] = ACTIONS(1110),
    [anon_sym_SLASH_QMARK] = ACTIONS(1110),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1110),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1110),
    [anon_sym_as] = ACTIONS(1110),
    [anon_sym_LPAREN2] = ACTIONS(1110),
    [anon_sym_DOT_GT] = ACTIONS(1110),
    [anon_sym_where] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(1110),
    [anon_sym_end] = ACTIONS(1110),
    [anon_sym_if] = ACTIONS(1112),
    [anon_sym_ifdef] = ACTIONS(1110),
    [anon_sym_iftype] = ACTIONS(1110),
    [anon_sym_else] = ACTIONS(1110),
    [anon_sym_for] = ACTIONS(1110),
    [anon_sym_while] = ACTIONS(1110),
    [anon_sym_try] = ACTIONS(1110),
    [anon_sym_with] = ACTIONS(1110),
    [anon_sym_repeat] = ACTIONS(1110),
    [anon_sym_do] = ACTIONS(1110),
    [anon_sym_recover] = ACTIONS(1110),
    [anon_sym_match] = ACTIONS(1110),
    [anon_sym_return] = ACTIONS(1110),
    [anon_sym_continue] = ACTIONS(1110),
    [anon_sym_break] = ACTIONS(1110),
    [anon_sym_consume] = ACTIONS(1110),
    [anon_sym_object] = ACTIONS(1110),
    [sym_number] = ACTIONS(1112),
    [sym_float] = ACTIONS(1110),
    [anon_sym_DQUOTE] = ACTIONS(1112),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1110),
    [anon_sym_SQUOTE] = ACTIONS(1110),
    [anon_sym_true] = ACTIONS(1110),
    [anon_sym_false] = ACTIONS(1110),
    [sym_this] = ACTIONS(1110),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [239] = {
    [ts_builtin_sym_end] = ACTIONS(831),
    [sym_identifier] = ACTIONS(833),
    [anon_sym_use] = ACTIONS(831),
    [anon_sym_EQ] = ACTIONS(833),
    [anon_sym_AT] = ACTIONS(831),
    [anon_sym_LBRACK] = ACTIONS(831),
    [anon_sym_type] = ACTIONS(831),
    [anon_sym_is] = ACTIONS(833),
    [anon_sym_actor] = ACTIONS(831),
    [anon_sym_class] = ACTIONS(831),
    [anon_sym_primitive] = ACTIONS(831),
    [anon_sym_interface] = ACTIONS(831),
    [anon_sym_trait] = ACTIONS(831),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_embed] = ACTIONS(831),
    [anon_sym_let] = ACTIONS(831),
    [anon_sym_var] = ACTIONS(831),
    [anon_sym_new] = ACTIONS(831),
    [anon_sym_fun] = ACTIONS(831),
    [anon_sym_be] = ACTIONS(831),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_RPAREN] = ACTIONS(831),
    [anon_sym_DOT] = ACTIONS(833),
    [anon_sym_LBRACE] = ACTIONS(831),
    [anon_sym_SEMI] = ACTIONS(831),
    [sym_error] = ACTIONS(831),
    [sym_compile_intrinsic] = ACTIONS(831),
    [anon_sym_compile_error] = ACTIONS(831),
    [sym_location] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_not] = ACTIONS(831),
    [anon_sym_DASH_TILDE] = ACTIONS(831),
    [anon_sym_addressof] = ACTIONS(831),
    [anon_sym_digestof] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_STAR] = ACTIONS(833),
    [anon_sym_SLASH] = ACTIONS(833),
    [anon_sym_PERCENT] = ACTIONS(833),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(833),
    [anon_sym_LT_LT] = ACTIONS(833),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_and] = ACTIONS(831),
    [anon_sym_or] = ACTIONS(831),
    [anon_sym_xor] = ACTIONS(831),
    [anon_sym_isnt] = ACTIONS(831),
    [anon_sym_EQ_EQ] = ACTIONS(833),
    [anon_sym_BANG_EQ] = ACTIONS(833),
    [anon_sym_GT] = ACTIONS(833),
    [anon_sym_GT_EQ] = ACTIONS(833),
    [anon_sym_LT_EQ] = ACTIONS(833),
    [anon_sym_LT] = ACTIONS(833),
    [anon_sym_PLUS_TILDE] = ACTIONS(831),
    [anon_sym_STAR_TILDE] = ACTIONS(831),
    [anon_sym_SLASH_TILDE] = ACTIONS(831),
    [anon_sym_PERCENT_TILDE] = ACTIONS(831),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(831),
    [anon_sym_LT_LT_TILDE] = ACTIONS(831),
    [anon_sym_GT_GT_TILDE] = ACTIONS(831),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(831),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(831),
    [anon_sym_GT_TILDE] = ACTIONS(831),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(831),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(831),
    [anon_sym_LT_TILDE] = ACTIONS(831),
    [anon_sym_PLUS_QMARK] = ACTIONS(831),
    [anon_sym_DASH_QMARK] = ACTIONS(831),
    [anon_sym_STAR_QMARK] = ACTIONS(831),
    [anon_sym_SLASH_QMARK] = ACTIONS(831),
    [anon_sym_PERCENT_QMARK] = ACTIONS(831),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(831),
    [anon_sym_as] = ACTIONS(831),
    [anon_sym_LPAREN2] = ACTIONS(831),
    [anon_sym_DOT_GT] = ACTIONS(831),
    [anon_sym_where] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(831),
    [anon_sym_end] = ACTIONS(831),
    [anon_sym_if] = ACTIONS(833),
    [anon_sym_ifdef] = ACTIONS(831),
    [anon_sym_iftype] = ACTIONS(831),
    [anon_sym_else] = ACTIONS(831),
    [anon_sym_for] = ACTIONS(831),
    [anon_sym_while] = ACTIONS(831),
    [anon_sym_try] = ACTIONS(831),
    [anon_sym_with] = ACTIONS(831),
    [anon_sym_repeat] = ACTIONS(831),
    [anon_sym_do] = ACTIONS(831),
    [anon_sym_recover] = ACTIONS(831),
    [anon_sym_match] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_continue] = ACTIONS(831),
    [anon_sym_break] = ACTIONS(831),
    [anon_sym_consume] = ACTIONS(831),
    [anon_sym_object] = ACTIONS(831),
    [sym_number] = ACTIONS(833),
    [sym_float] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(831),
    [anon_sym_SQUOTE] = ACTIONS(831),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_this] = ACTIONS(831),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [240] = {
    [ts_builtin_sym_end] = ACTIONS(845),
    [sym_identifier] = ACTIONS(847),
    [anon_sym_use] = ACTIONS(845),
    [anon_sym_EQ] = ACTIONS(847),
    [anon_sym_AT] = ACTIONS(845),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_type] = ACTIONS(845),
    [anon_sym_is] = ACTIONS(847),
    [anon_sym_actor] = ACTIONS(845),
    [anon_sym_class] = ACTIONS(845),
    [anon_sym_primitive] = ACTIONS(845),
    [anon_sym_interface] = ACTIONS(845),
    [anon_sym_trait] = ACTIONS(845),
    [anon_sym_struct] = ACTIONS(845),
    [anon_sym_embed] = ACTIONS(845),
    [anon_sym_let] = ACTIONS(845),
    [anon_sym_var] = ACTIONS(845),
    [anon_sym_new] = ACTIONS(845),
    [anon_sym_fun] = ACTIONS(845),
    [anon_sym_be] = ACTIONS(845),
    [anon_sym_COMMA] = ACTIONS(845),
    [anon_sym_LPAREN] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(845),
    [anon_sym_DOT] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(845),
    [anon_sym_SEMI] = ACTIONS(845),
    [sym_error] = ACTIONS(845),
    [sym_compile_intrinsic] = ACTIONS(845),
    [anon_sym_compile_error] = ACTIONS(845),
    [sym_location] = ACTIONS(845),
    [anon_sym_DASH] = ACTIONS(847),
    [anon_sym_not] = ACTIONS(845),
    [anon_sym_DASH_TILDE] = ACTIONS(845),
    [anon_sym_addressof] = ACTIONS(845),
    [anon_sym_digestof] = ACTIONS(845),
    [anon_sym_PLUS] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(847),
    [anon_sym_SLASH] = ACTIONS(847),
    [anon_sym_PERCENT] = ACTIONS(847),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(847),
    [anon_sym_LT_LT] = ACTIONS(847),
    [anon_sym_GT_GT] = ACTIONS(847),
    [anon_sym_and] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(845),
    [anon_sym_xor] = ACTIONS(845),
    [anon_sym_isnt] = ACTIONS(845),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_GT_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(847),
    [anon_sym_PLUS_TILDE] = ACTIONS(845),
    [anon_sym_STAR_TILDE] = ACTIONS(845),
    [anon_sym_SLASH_TILDE] = ACTIONS(845),
    [anon_sym_PERCENT_TILDE] = ACTIONS(845),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(845),
    [anon_sym_LT_LT_TILDE] = ACTIONS(845),
    [anon_sym_GT_GT_TILDE] = ACTIONS(845),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(845),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(845),
    [anon_sym_GT_TILDE] = ACTIONS(845),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(845),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(845),
    [anon_sym_LT_TILDE] = ACTIONS(845),
    [anon_sym_PLUS_QMARK] = ACTIONS(845),
    [anon_sym_DASH_QMARK] = ACTIONS(845),
    [anon_sym_STAR_QMARK] = ACTIONS(845),
    [anon_sym_SLASH_QMARK] = ACTIONS(845),
    [anon_sym_PERCENT_QMARK] = ACTIONS(845),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(845),
    [anon_sym_as] = ACTIONS(845),
    [anon_sym_LPAREN2] = ACTIONS(845),
    [anon_sym_DOT_GT] = ACTIONS(845),
    [anon_sym_where] = ACTIONS(845),
    [anon_sym_TILDE] = ACTIONS(845),
    [anon_sym_end] = ACTIONS(845),
    [anon_sym_if] = ACTIONS(847),
    [anon_sym_ifdef] = ACTIONS(845),
    [anon_sym_iftype] = ACTIONS(845),
    [anon_sym_else] = ACTIONS(845),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(845),
    [anon_sym_try] = ACTIONS(845),
    [anon_sym_with] = ACTIONS(845),
    [anon_sym_repeat] = ACTIONS(845),
    [anon_sym_do] = ACTIONS(845),
    [anon_sym_recover] = ACTIONS(845),
    [anon_sym_match] = ACTIONS(845),
    [anon_sym_return] = ACTIONS(845),
    [anon_sym_continue] = ACTIONS(845),
    [anon_sym_break] = ACTIONS(845),
    [anon_sym_consume] = ACTIONS(845),
    [anon_sym_object] = ACTIONS(845),
    [sym_number] = ACTIONS(847),
    [sym_float] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(845),
    [anon_sym_SQUOTE] = ACTIONS(845),
    [anon_sym_true] = ACTIONS(845),
    [anon_sym_false] = ACTIONS(845),
    [sym_this] = ACTIONS(845),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [241] = {
    [ts_builtin_sym_end] = ACTIONS(1114),
    [sym_identifier] = ACTIONS(1116),
    [anon_sym_use] = ACTIONS(1114),
    [anon_sym_EQ] = ACTIONS(1116),
    [anon_sym_AT] = ACTIONS(1114),
    [anon_sym_LBRACK] = ACTIONS(1114),
    [anon_sym_type] = ACTIONS(1114),
    [anon_sym_is] = ACTIONS(1116),
    [anon_sym_actor] = ACTIONS(1114),
    [anon_sym_class] = ACTIONS(1114),
    [anon_sym_primitive] = ACTIONS(1114),
    [anon_sym_interface] = ACTIONS(1114),
    [anon_sym_trait] = ACTIONS(1114),
    [anon_sym_struct] = ACTIONS(1114),
    [anon_sym_embed] = ACTIONS(1114),
    [anon_sym_let] = ACTIONS(1114),
    [anon_sym_var] = ACTIONS(1114),
    [anon_sym_new] = ACTIONS(1114),
    [anon_sym_fun] = ACTIONS(1114),
    [anon_sym_be] = ACTIONS(1114),
    [anon_sym_COMMA] = ACTIONS(1114),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1114),
    [anon_sym_SEMI] = ACTIONS(1114),
    [sym_error] = ACTIONS(1114),
    [sym_compile_intrinsic] = ACTIONS(1114),
    [anon_sym_compile_error] = ACTIONS(1114),
    [sym_location] = ACTIONS(1114),
    [anon_sym_DASH] = ACTIONS(1116),
    [anon_sym_not] = ACTIONS(1114),
    [anon_sym_DASH_TILDE] = ACTIONS(1114),
    [anon_sym_addressof] = ACTIONS(1114),
    [anon_sym_digestof] = ACTIONS(1114),
    [anon_sym_PLUS] = ACTIONS(1116),
    [anon_sym_STAR] = ACTIONS(1116),
    [anon_sym_SLASH] = ACTIONS(1116),
    [anon_sym_PERCENT] = ACTIONS(1116),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1116),
    [anon_sym_LT_LT] = ACTIONS(1116),
    [anon_sym_GT_GT] = ACTIONS(1116),
    [anon_sym_and] = ACTIONS(1114),
    [anon_sym_or] = ACTIONS(1114),
    [anon_sym_xor] = ACTIONS(1114),
    [anon_sym_isnt] = ACTIONS(1114),
    [anon_sym_EQ_EQ] = ACTIONS(1116),
    [anon_sym_BANG_EQ] = ACTIONS(1116),
    [anon_sym_GT] = ACTIONS(1116),
    [anon_sym_GT_EQ] = ACTIONS(1116),
    [anon_sym_LT_EQ] = ACTIONS(1116),
    [anon_sym_LT] = ACTIONS(1116),
    [anon_sym_PLUS_TILDE] = ACTIONS(1114),
    [anon_sym_STAR_TILDE] = ACTIONS(1114),
    [anon_sym_SLASH_TILDE] = ACTIONS(1114),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1114),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1114),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1114),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1114),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1114),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1114),
    [anon_sym_GT_TILDE] = ACTIONS(1114),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1114),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1114),
    [anon_sym_LT_TILDE] = ACTIONS(1114),
    [anon_sym_PLUS_QMARK] = ACTIONS(1114),
    [anon_sym_DASH_QMARK] = ACTIONS(1114),
    [anon_sym_STAR_QMARK] = ACTIONS(1114),
    [anon_sym_SLASH_QMARK] = ACTIONS(1114),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1114),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1114),
    [anon_sym_as] = ACTIONS(1114),
    [anon_sym_LPAREN2] = ACTIONS(1114),
    [anon_sym_DOT_GT] = ACTIONS(1114),
    [anon_sym_where] = ACTIONS(1114),
    [anon_sym_TILDE] = ACTIONS(1114),
    [anon_sym_end] = ACTIONS(1114),
    [anon_sym_if] = ACTIONS(1116),
    [anon_sym_ifdef] = ACTIONS(1114),
    [anon_sym_iftype] = ACTIONS(1114),
    [anon_sym_else] = ACTIONS(1114),
    [anon_sym_for] = ACTIONS(1114),
    [anon_sym_while] = ACTIONS(1114),
    [anon_sym_try] = ACTIONS(1114),
    [anon_sym_with] = ACTIONS(1114),
    [anon_sym_repeat] = ACTIONS(1114),
    [anon_sym_do] = ACTIONS(1114),
    [anon_sym_recover] = ACTIONS(1114),
    [anon_sym_match] = ACTIONS(1114),
    [anon_sym_return] = ACTIONS(1114),
    [anon_sym_continue] = ACTIONS(1114),
    [anon_sym_break] = ACTIONS(1114),
    [anon_sym_consume] = ACTIONS(1114),
    [anon_sym_object] = ACTIONS(1114),
    [sym_number] = ACTIONS(1116),
    [sym_float] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1114),
    [anon_sym_SQUOTE] = ACTIONS(1114),
    [anon_sym_true] = ACTIONS(1114),
    [anon_sym_false] = ACTIONS(1114),
    [sym_this] = ACTIONS(1114),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [242] = {
    [ts_builtin_sym_end] = ACTIONS(1118),
    [sym_identifier] = ACTIONS(1120),
    [anon_sym_use] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(1120),
    [anon_sym_AT] = ACTIONS(1118),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_type] = ACTIONS(1118),
    [anon_sym_is] = ACTIONS(1120),
    [anon_sym_actor] = ACTIONS(1118),
    [anon_sym_class] = ACTIONS(1118),
    [anon_sym_primitive] = ACTIONS(1118),
    [anon_sym_interface] = ACTIONS(1118),
    [anon_sym_trait] = ACTIONS(1118),
    [anon_sym_struct] = ACTIONS(1118),
    [anon_sym_embed] = ACTIONS(1118),
    [anon_sym_let] = ACTIONS(1118),
    [anon_sym_var] = ACTIONS(1118),
    [anon_sym_new] = ACTIONS(1118),
    [anon_sym_fun] = ACTIONS(1118),
    [anon_sym_be] = ACTIONS(1118),
    [anon_sym_COMMA] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1120),
    [anon_sym_RPAREN] = ACTIONS(1118),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_SEMI] = ACTIONS(1118),
    [sym_error] = ACTIONS(1118),
    [sym_compile_intrinsic] = ACTIONS(1118),
    [anon_sym_compile_error] = ACTIONS(1118),
    [sym_location] = ACTIONS(1118),
    [anon_sym_DASH] = ACTIONS(1120),
    [anon_sym_not] = ACTIONS(1118),
    [anon_sym_DASH_TILDE] = ACTIONS(1118),
    [anon_sym_addressof] = ACTIONS(1118),
    [anon_sym_digestof] = ACTIONS(1118),
    [anon_sym_PLUS] = ACTIONS(1120),
    [anon_sym_STAR] = ACTIONS(1120),
    [anon_sym_SLASH] = ACTIONS(1120),
    [anon_sym_PERCENT] = ACTIONS(1120),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1120),
    [anon_sym_LT_LT] = ACTIONS(1120),
    [anon_sym_GT_GT] = ACTIONS(1120),
    [anon_sym_and] = ACTIONS(1118),
    [anon_sym_or] = ACTIONS(1118),
    [anon_sym_xor] = ACTIONS(1118),
    [anon_sym_isnt] = ACTIONS(1118),
    [anon_sym_EQ_EQ] = ACTIONS(1120),
    [anon_sym_BANG_EQ] = ACTIONS(1120),
    [anon_sym_GT] = ACTIONS(1120),
    [anon_sym_GT_EQ] = ACTIONS(1120),
    [anon_sym_LT_EQ] = ACTIONS(1120),
    [anon_sym_LT] = ACTIONS(1120),
    [anon_sym_PLUS_TILDE] = ACTIONS(1118),
    [anon_sym_STAR_TILDE] = ACTIONS(1118),
    [anon_sym_SLASH_TILDE] = ACTIONS(1118),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1118),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1118),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1118),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1118),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1118),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1118),
    [anon_sym_GT_TILDE] = ACTIONS(1118),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1118),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1118),
    [anon_sym_LT_TILDE] = ACTIONS(1118),
    [anon_sym_PLUS_QMARK] = ACTIONS(1118),
    [anon_sym_DASH_QMARK] = ACTIONS(1118),
    [anon_sym_STAR_QMARK] = ACTIONS(1118),
    [anon_sym_SLASH_QMARK] = ACTIONS(1118),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1118),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1118),
    [anon_sym_as] = ACTIONS(1118),
    [anon_sym_LPAREN2] = ACTIONS(1118),
    [anon_sym_DOT_GT] = ACTIONS(1118),
    [anon_sym_where] = ACTIONS(1118),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_end] = ACTIONS(1118),
    [anon_sym_if] = ACTIONS(1120),
    [anon_sym_ifdef] = ACTIONS(1118),
    [anon_sym_iftype] = ACTIONS(1118),
    [anon_sym_else] = ACTIONS(1118),
    [anon_sym_for] = ACTIONS(1118),
    [anon_sym_while] = ACTIONS(1118),
    [anon_sym_try] = ACTIONS(1118),
    [anon_sym_with] = ACTIONS(1118),
    [anon_sym_repeat] = ACTIONS(1118),
    [anon_sym_do] = ACTIONS(1118),
    [anon_sym_recover] = ACTIONS(1118),
    [anon_sym_match] = ACTIONS(1118),
    [anon_sym_return] = ACTIONS(1118),
    [anon_sym_continue] = ACTIONS(1118),
    [anon_sym_break] = ACTIONS(1118),
    [anon_sym_consume] = ACTIONS(1118),
    [anon_sym_object] = ACTIONS(1118),
    [sym_number] = ACTIONS(1120),
    [sym_float] = ACTIONS(1118),
    [anon_sym_DQUOTE] = ACTIONS(1120),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1118),
    [anon_sym_SQUOTE] = ACTIONS(1118),
    [anon_sym_true] = ACTIONS(1118),
    [anon_sym_false] = ACTIONS(1118),
    [sym_this] = ACTIONS(1118),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [243] = {
    [ts_builtin_sym_end] = ACTIONS(837),
    [sym_identifier] = ACTIONS(839),
    [anon_sym_use] = ACTIONS(837),
    [anon_sym_EQ] = ACTIONS(839),
    [anon_sym_AT] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(837),
    [anon_sym_is] = ACTIONS(839),
    [anon_sym_actor] = ACTIONS(837),
    [anon_sym_class] = ACTIONS(837),
    [anon_sym_primitive] = ACTIONS(837),
    [anon_sym_interface] = ACTIONS(837),
    [anon_sym_trait] = ACTIONS(837),
    [anon_sym_struct] = ACTIONS(837),
    [anon_sym_embed] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_var] = ACTIONS(837),
    [anon_sym_new] = ACTIONS(837),
    [anon_sym_fun] = ACTIONS(837),
    [anon_sym_be] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(839),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_SEMI] = ACTIONS(837),
    [sym_error] = ACTIONS(837),
    [sym_compile_intrinsic] = ACTIONS(837),
    [anon_sym_compile_error] = ACTIONS(837),
    [sym_location] = ACTIONS(837),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(837),
    [anon_sym_DASH_TILDE] = ACTIONS(837),
    [anon_sym_addressof] = ACTIONS(837),
    [anon_sym_digestof] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_STAR] = ACTIONS(839),
    [anon_sym_SLASH] = ACTIONS(839),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_GT_GT] = ACTIONS(839),
    [anon_sym_and] = ACTIONS(837),
    [anon_sym_or] = ACTIONS(837),
    [anon_sym_xor] = ACTIONS(837),
    [anon_sym_isnt] = ACTIONS(837),
    [anon_sym_EQ_EQ] = ACTIONS(839),
    [anon_sym_BANG_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(839),
    [anon_sym_PLUS_TILDE] = ACTIONS(837),
    [anon_sym_STAR_TILDE] = ACTIONS(837),
    [anon_sym_SLASH_TILDE] = ACTIONS(837),
    [anon_sym_PERCENT_TILDE] = ACTIONS(837),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(837),
    [anon_sym_LT_LT_TILDE] = ACTIONS(837),
    [anon_sym_GT_GT_TILDE] = ACTIONS(837),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(837),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(837),
    [anon_sym_GT_TILDE] = ACTIONS(837),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(837),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(837),
    [anon_sym_LT_TILDE] = ACTIONS(837),
    [anon_sym_PLUS_QMARK] = ACTIONS(837),
    [anon_sym_DASH_QMARK] = ACTIONS(837),
    [anon_sym_STAR_QMARK] = ACTIONS(837),
    [anon_sym_SLASH_QMARK] = ACTIONS(837),
    [anon_sym_PERCENT_QMARK] = ACTIONS(837),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(837),
    [anon_sym_as] = ACTIONS(837),
    [anon_sym_LPAREN2] = ACTIONS(837),
    [anon_sym_DOT_GT] = ACTIONS(837),
    [anon_sym_where] = ACTIONS(837),
    [anon_sym_TILDE] = ACTIONS(837),
    [anon_sym_end] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_ifdef] = ACTIONS(837),
    [anon_sym_iftype] = ACTIONS(837),
    [anon_sym_else] = ACTIONS(837),
    [anon_sym_for] = ACTIONS(837),
    [anon_sym_while] = ACTIONS(837),
    [anon_sym_try] = ACTIONS(837),
    [anon_sym_with] = ACTIONS(837),
    [anon_sym_repeat] = ACTIONS(837),
    [anon_sym_do] = ACTIONS(837),
    [anon_sym_recover] = ACTIONS(837),
    [anon_sym_match] = ACTIONS(837),
    [anon_sym_return] = ACTIONS(837),
    [anon_sym_continue] = ACTIONS(837),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_consume] = ACTIONS(837),
    [anon_sym_object] = ACTIONS(837),
    [sym_number] = ACTIONS(839),
    [sym_float] = ACTIONS(837),
    [anon_sym_DQUOTE] = ACTIONS(839),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(837),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_true] = ACTIONS(837),
    [anon_sym_false] = ACTIONS(837),
    [sym_this] = ACTIONS(837),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [244] = {
    [ts_builtin_sym_end] = ACTIONS(853),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_use] = ACTIONS(853),
    [anon_sym_EQ] = ACTIONS(855),
    [anon_sym_AT] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_type] = ACTIONS(853),
    [anon_sym_is] = ACTIONS(855),
    [anon_sym_actor] = ACTIONS(853),
    [anon_sym_class] = ACTIONS(853),
    [anon_sym_primitive] = ACTIONS(853),
    [anon_sym_interface] = ACTIONS(853),
    [anon_sym_trait] = ACTIONS(853),
    [anon_sym_struct] = ACTIONS(853),
    [anon_sym_embed] = ACTIONS(853),
    [anon_sym_let] = ACTIONS(853),
    [anon_sym_var] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(853),
    [anon_sym_fun] = ACTIONS(853),
    [anon_sym_be] = ACTIONS(853),
    [anon_sym_COMMA] = ACTIONS(853),
    [anon_sym_LPAREN] = ACTIONS(855),
    [anon_sym_RPAREN] = ACTIONS(853),
    [anon_sym_DOT] = ACTIONS(855),
    [anon_sym_LBRACE] = ACTIONS(853),
    [anon_sym_SEMI] = ACTIONS(853),
    [sym_error] = ACTIONS(853),
    [sym_compile_intrinsic] = ACTIONS(853),
    [anon_sym_compile_error] = ACTIONS(853),
    [sym_location] = ACTIONS(853),
    [anon_sym_DASH] = ACTIONS(855),
    [anon_sym_not] = ACTIONS(853),
    [anon_sym_DASH_TILDE] = ACTIONS(853),
    [anon_sym_addressof] = ACTIONS(853),
    [anon_sym_digestof] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_PERCENT] = ACTIONS(855),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(855),
    [anon_sym_LT_LT] = ACTIONS(855),
    [anon_sym_GT_GT] = ACTIONS(855),
    [anon_sym_and] = ACTIONS(853),
    [anon_sym_or] = ACTIONS(853),
    [anon_sym_xor] = ACTIONS(853),
    [anon_sym_isnt] = ACTIONS(853),
    [anon_sym_EQ_EQ] = ACTIONS(855),
    [anon_sym_BANG_EQ] = ACTIONS(855),
    [anon_sym_GT] = ACTIONS(855),
    [anon_sym_GT_EQ] = ACTIONS(855),
    [anon_sym_LT_EQ] = ACTIONS(855),
    [anon_sym_LT] = ACTIONS(855),
    [anon_sym_PLUS_TILDE] = ACTIONS(853),
    [anon_sym_STAR_TILDE] = ACTIONS(853),
    [anon_sym_SLASH_TILDE] = ACTIONS(853),
    [anon_sym_PERCENT_TILDE] = ACTIONS(853),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(853),
    [anon_sym_LT_LT_TILDE] = ACTIONS(853),
    [anon_sym_GT_GT_TILDE] = ACTIONS(853),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(853),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(853),
    [anon_sym_GT_TILDE] = ACTIONS(853),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(853),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(853),
    [anon_sym_LT_TILDE] = ACTIONS(853),
    [anon_sym_PLUS_QMARK] = ACTIONS(853),
    [anon_sym_DASH_QMARK] = ACTIONS(853),
    [anon_sym_STAR_QMARK] = ACTIONS(853),
    [anon_sym_SLASH_QMARK] = ACTIONS(853),
    [anon_sym_PERCENT_QMARK] = ACTIONS(853),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(853),
    [anon_sym_as] = ACTIONS(853),
    [anon_sym_LPAREN2] = ACTIONS(853),
    [anon_sym_DOT_GT] = ACTIONS(853),
    [anon_sym_where] = ACTIONS(853),
    [anon_sym_TILDE] = ACTIONS(853),
    [anon_sym_end] = ACTIONS(853),
    [anon_sym_if] = ACTIONS(855),
    [anon_sym_ifdef] = ACTIONS(853),
    [anon_sym_iftype] = ACTIONS(853),
    [anon_sym_else] = ACTIONS(853),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_while] = ACTIONS(853),
    [anon_sym_try] = ACTIONS(853),
    [anon_sym_with] = ACTIONS(853),
    [anon_sym_repeat] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(853),
    [anon_sym_recover] = ACTIONS(853),
    [anon_sym_match] = ACTIONS(853),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_continue] = ACTIONS(853),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_consume] = ACTIONS(853),
    [anon_sym_object] = ACTIONS(853),
    [sym_number] = ACTIONS(855),
    [sym_float] = ACTIONS(853),
    [anon_sym_DQUOTE] = ACTIONS(855),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(853),
    [anon_sym_true] = ACTIONS(853),
    [anon_sym_false] = ACTIONS(853),
    [sym_this] = ACTIONS(853),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [245] = {
    [ts_builtin_sym_end] = ACTIONS(849),
    [sym_identifier] = ACTIONS(851),
    [anon_sym_use] = ACTIONS(849),
    [anon_sym_EQ] = ACTIONS(851),
    [anon_sym_AT] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(849),
    [anon_sym_type] = ACTIONS(849),
    [anon_sym_is] = ACTIONS(851),
    [anon_sym_actor] = ACTIONS(849),
    [anon_sym_class] = ACTIONS(849),
    [anon_sym_primitive] = ACTIONS(849),
    [anon_sym_interface] = ACTIONS(849),
    [anon_sym_trait] = ACTIONS(849),
    [anon_sym_struct] = ACTIONS(849),
    [anon_sym_embed] = ACTIONS(849),
    [anon_sym_let] = ACTIONS(849),
    [anon_sym_var] = ACTIONS(849),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_fun] = ACTIONS(849),
    [anon_sym_be] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_RPAREN] = ACTIONS(849),
    [anon_sym_DOT] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(849),
    [anon_sym_SEMI] = ACTIONS(849),
    [sym_error] = ACTIONS(849),
    [sym_compile_intrinsic] = ACTIONS(849),
    [anon_sym_compile_error] = ACTIONS(849),
    [sym_location] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_not] = ACTIONS(849),
    [anon_sym_DASH_TILDE] = ACTIONS(849),
    [anon_sym_addressof] = ACTIONS(849),
    [anon_sym_digestof] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(851),
    [anon_sym_SLASH] = ACTIONS(851),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(851),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_GT_GT] = ACTIONS(851),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_isnt] = ACTIONS(849),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(851),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_LT] = ACTIONS(851),
    [anon_sym_PLUS_TILDE] = ACTIONS(849),
    [anon_sym_STAR_TILDE] = ACTIONS(849),
    [anon_sym_SLASH_TILDE] = ACTIONS(849),
    [anon_sym_PERCENT_TILDE] = ACTIONS(849),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(849),
    [anon_sym_LT_LT_TILDE] = ACTIONS(849),
    [anon_sym_GT_GT_TILDE] = ACTIONS(849),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(849),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(849),
    [anon_sym_GT_TILDE] = ACTIONS(849),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(849),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(849),
    [anon_sym_LT_TILDE] = ACTIONS(849),
    [anon_sym_PLUS_QMARK] = ACTIONS(849),
    [anon_sym_DASH_QMARK] = ACTIONS(849),
    [anon_sym_STAR_QMARK] = ACTIONS(849),
    [anon_sym_SLASH_QMARK] = ACTIONS(849),
    [anon_sym_PERCENT_QMARK] = ACTIONS(849),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(849),
    [anon_sym_as] = ACTIONS(849),
    [anon_sym_LPAREN2] = ACTIONS(849),
    [anon_sym_DOT_GT] = ACTIONS(849),
    [anon_sym_where] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(849),
    [anon_sym_end] = ACTIONS(849),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_ifdef] = ACTIONS(849),
    [anon_sym_iftype] = ACTIONS(849),
    [anon_sym_else] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(849),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_try] = ACTIONS(849),
    [anon_sym_with] = ACTIONS(849),
    [anon_sym_repeat] = ACTIONS(849),
    [anon_sym_do] = ACTIONS(849),
    [anon_sym_recover] = ACTIONS(849),
    [anon_sym_match] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_continue] = ACTIONS(849),
    [anon_sym_break] = ACTIONS(849),
    [anon_sym_consume] = ACTIONS(849),
    [anon_sym_object] = ACTIONS(849),
    [sym_number] = ACTIONS(851),
    [sym_float] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(851),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(849),
    [anon_sym_SQUOTE] = ACTIONS(849),
    [anon_sym_true] = ACTIONS(849),
    [anon_sym_false] = ACTIONS(849),
    [sym_this] = ACTIONS(849),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [246] = {
    [ts_builtin_sym_end] = ACTIONS(1122),
    [sym_identifier] = ACTIONS(1124),
    [anon_sym_use] = ACTIONS(1122),
    [anon_sym_EQ] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1122),
    [anon_sym_type] = ACTIONS(1122),
    [anon_sym_is] = ACTIONS(1124),
    [anon_sym_actor] = ACTIONS(1122),
    [anon_sym_class] = ACTIONS(1122),
    [anon_sym_primitive] = ACTIONS(1122),
    [anon_sym_interface] = ACTIONS(1122),
    [anon_sym_trait] = ACTIONS(1122),
    [anon_sym_struct] = ACTIONS(1122),
    [anon_sym_embed] = ACTIONS(1122),
    [anon_sym_let] = ACTIONS(1122),
    [anon_sym_var] = ACTIONS(1122),
    [anon_sym_new] = ACTIONS(1122),
    [anon_sym_fun] = ACTIONS(1122),
    [anon_sym_be] = ACTIONS(1122),
    [anon_sym_COMMA] = ACTIONS(1122),
    [anon_sym_LPAREN] = ACTIONS(1124),
    [anon_sym_RPAREN] = ACTIONS(1122),
    [anon_sym_DOT] = ACTIONS(1124),
    [anon_sym_LBRACE] = ACTIONS(1122),
    [anon_sym_SEMI] = ACTIONS(1122),
    [sym_error] = ACTIONS(1122),
    [sym_compile_intrinsic] = ACTIONS(1122),
    [anon_sym_compile_error] = ACTIONS(1122),
    [sym_location] = ACTIONS(1122),
    [anon_sym_DASH] = ACTIONS(1124),
    [anon_sym_not] = ACTIONS(1122),
    [anon_sym_DASH_TILDE] = ACTIONS(1122),
    [anon_sym_addressof] = ACTIONS(1122),
    [anon_sym_digestof] = ACTIONS(1122),
    [anon_sym_PLUS] = ACTIONS(1124),
    [anon_sym_STAR] = ACTIONS(1124),
    [anon_sym_SLASH] = ACTIONS(1124),
    [anon_sym_PERCENT] = ACTIONS(1124),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1124),
    [anon_sym_LT_LT] = ACTIONS(1124),
    [anon_sym_GT_GT] = ACTIONS(1124),
    [anon_sym_and] = ACTIONS(1122),
    [anon_sym_or] = ACTIONS(1122),
    [anon_sym_xor] = ACTIONS(1122),
    [anon_sym_isnt] = ACTIONS(1122),
    [anon_sym_EQ_EQ] = ACTIONS(1124),
    [anon_sym_BANG_EQ] = ACTIONS(1124),
    [anon_sym_GT] = ACTIONS(1124),
    [anon_sym_GT_EQ] = ACTIONS(1124),
    [anon_sym_LT_EQ] = ACTIONS(1124),
    [anon_sym_LT] = ACTIONS(1124),
    [anon_sym_PLUS_TILDE] = ACTIONS(1122),
    [anon_sym_STAR_TILDE] = ACTIONS(1122),
    [anon_sym_SLASH_TILDE] = ACTIONS(1122),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1122),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1122),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1122),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1122),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1122),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1122),
    [anon_sym_GT_TILDE] = ACTIONS(1122),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1122),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1122),
    [anon_sym_LT_TILDE] = ACTIONS(1122),
    [anon_sym_PLUS_QMARK] = ACTIONS(1122),
    [anon_sym_DASH_QMARK] = ACTIONS(1122),
    [anon_sym_STAR_QMARK] = ACTIONS(1122),
    [anon_sym_SLASH_QMARK] = ACTIONS(1122),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1122),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1122),
    [anon_sym_as] = ACTIONS(1122),
    [anon_sym_LPAREN2] = ACTIONS(1122),
    [anon_sym_DOT_GT] = ACTIONS(1122),
    [anon_sym_where] = ACTIONS(1122),
    [anon_sym_TILDE] = ACTIONS(1122),
    [anon_sym_end] = ACTIONS(1122),
    [anon_sym_if] = ACTIONS(1124),
    [anon_sym_ifdef] = ACTIONS(1122),
    [anon_sym_iftype] = ACTIONS(1122),
    [anon_sym_else] = ACTIONS(1122),
    [anon_sym_for] = ACTIONS(1122),
    [anon_sym_while] = ACTIONS(1122),
    [anon_sym_try] = ACTIONS(1122),
    [anon_sym_with] = ACTIONS(1122),
    [anon_sym_repeat] = ACTIONS(1122),
    [anon_sym_do] = ACTIONS(1122),
    [anon_sym_recover] = ACTIONS(1122),
    [anon_sym_match] = ACTIONS(1122),
    [anon_sym_return] = ACTIONS(1122),
    [anon_sym_continue] = ACTIONS(1122),
    [anon_sym_break] = ACTIONS(1122),
    [anon_sym_consume] = ACTIONS(1122),
    [anon_sym_object] = ACTIONS(1122),
    [sym_number] = ACTIONS(1124),
    [sym_float] = ACTIONS(1122),
    [anon_sym_DQUOTE] = ACTIONS(1124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1122),
    [anon_sym_SQUOTE] = ACTIONS(1122),
    [anon_sym_true] = ACTIONS(1122),
    [anon_sym_false] = ACTIONS(1122),
    [sym_this] = ACTIONS(1122),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [247] = {
    [ts_builtin_sym_end] = ACTIONS(1126),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_use] = ACTIONS(1126),
    [anon_sym_EQ] = ACTIONS(1128),
    [anon_sym_AT] = ACTIONS(1126),
    [anon_sym_LBRACK] = ACTIONS(1126),
    [anon_sym_type] = ACTIONS(1126),
    [anon_sym_is] = ACTIONS(1128),
    [anon_sym_actor] = ACTIONS(1126),
    [anon_sym_class] = ACTIONS(1126),
    [anon_sym_primitive] = ACTIONS(1126),
    [anon_sym_interface] = ACTIONS(1126),
    [anon_sym_trait] = ACTIONS(1126),
    [anon_sym_struct] = ACTIONS(1126),
    [anon_sym_embed] = ACTIONS(1126),
    [anon_sym_let] = ACTIONS(1126),
    [anon_sym_var] = ACTIONS(1126),
    [anon_sym_new] = ACTIONS(1126),
    [anon_sym_fun] = ACTIONS(1126),
    [anon_sym_be] = ACTIONS(1126),
    [anon_sym_COMMA] = ACTIONS(1126),
    [anon_sym_LPAREN] = ACTIONS(1128),
    [anon_sym_RPAREN] = ACTIONS(1126),
    [anon_sym_DOT] = ACTIONS(1128),
    [anon_sym_LBRACE] = ACTIONS(1126),
    [anon_sym_SEMI] = ACTIONS(1126),
    [sym_error] = ACTIONS(1126),
    [sym_compile_intrinsic] = ACTIONS(1126),
    [anon_sym_compile_error] = ACTIONS(1126),
    [sym_location] = ACTIONS(1126),
    [anon_sym_DASH] = ACTIONS(1128),
    [anon_sym_not] = ACTIONS(1126),
    [anon_sym_DASH_TILDE] = ACTIONS(1126),
    [anon_sym_addressof] = ACTIONS(1126),
    [anon_sym_digestof] = ACTIONS(1126),
    [anon_sym_PLUS] = ACTIONS(1128),
    [anon_sym_STAR] = ACTIONS(1128),
    [anon_sym_SLASH] = ACTIONS(1128),
    [anon_sym_PERCENT] = ACTIONS(1128),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1128),
    [anon_sym_LT_LT] = ACTIONS(1128),
    [anon_sym_GT_GT] = ACTIONS(1128),
    [anon_sym_and] = ACTIONS(1126),
    [anon_sym_or] = ACTIONS(1126),
    [anon_sym_xor] = ACTIONS(1126),
    [anon_sym_isnt] = ACTIONS(1126),
    [anon_sym_EQ_EQ] = ACTIONS(1128),
    [anon_sym_BANG_EQ] = ACTIONS(1128),
    [anon_sym_GT] = ACTIONS(1128),
    [anon_sym_GT_EQ] = ACTIONS(1128),
    [anon_sym_LT_EQ] = ACTIONS(1128),
    [anon_sym_LT] = ACTIONS(1128),
    [anon_sym_PLUS_TILDE] = ACTIONS(1126),
    [anon_sym_STAR_TILDE] = ACTIONS(1126),
    [anon_sym_SLASH_TILDE] = ACTIONS(1126),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1126),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1126),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1126),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1126),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1126),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1126),
    [anon_sym_GT_TILDE] = ACTIONS(1126),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1126),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1126),
    [anon_sym_LT_TILDE] = ACTIONS(1126),
    [anon_sym_PLUS_QMARK] = ACTIONS(1126),
    [anon_sym_DASH_QMARK] = ACTIONS(1126),
    [anon_sym_STAR_QMARK] = ACTIONS(1126),
    [anon_sym_SLASH_QMARK] = ACTIONS(1126),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1126),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1126),
    [anon_sym_as] = ACTIONS(1126),
    [anon_sym_LPAREN2] = ACTIONS(1126),
    [anon_sym_DOT_GT] = ACTIONS(1126),
    [anon_sym_where] = ACTIONS(1126),
    [anon_sym_TILDE] = ACTIONS(1126),
    [anon_sym_end] = ACTIONS(1126),
    [anon_sym_if] = ACTIONS(1128),
    [anon_sym_ifdef] = ACTIONS(1126),
    [anon_sym_iftype] = ACTIONS(1126),
    [anon_sym_else] = ACTIONS(1126),
    [anon_sym_for] = ACTIONS(1126),
    [anon_sym_while] = ACTIONS(1126),
    [anon_sym_try] = ACTIONS(1126),
    [anon_sym_with] = ACTIONS(1126),
    [anon_sym_repeat] = ACTIONS(1126),
    [anon_sym_do] = ACTIONS(1126),
    [anon_sym_recover] = ACTIONS(1126),
    [anon_sym_match] = ACTIONS(1126),
    [anon_sym_return] = ACTIONS(1126),
    [anon_sym_continue] = ACTIONS(1126),
    [anon_sym_break] = ACTIONS(1126),
    [anon_sym_consume] = ACTIONS(1126),
    [anon_sym_object] = ACTIONS(1126),
    [sym_number] = ACTIONS(1128),
    [sym_float] = ACTIONS(1126),
    [anon_sym_DQUOTE] = ACTIONS(1128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1126),
    [anon_sym_SQUOTE] = ACTIONS(1126),
    [anon_sym_true] = ACTIONS(1126),
    [anon_sym_false] = ACTIONS(1126),
    [sym_this] = ACTIONS(1126),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [248] = {
    [ts_builtin_sym_end] = ACTIONS(1130),
    [sym_identifier] = ACTIONS(1132),
    [anon_sym_use] = ACTIONS(1130),
    [anon_sym_EQ] = ACTIONS(1132),
    [anon_sym_AT] = ACTIONS(1130),
    [anon_sym_LBRACK] = ACTIONS(1130),
    [anon_sym_type] = ACTIONS(1130),
    [anon_sym_is] = ACTIONS(1132),
    [anon_sym_actor] = ACTIONS(1130),
    [anon_sym_class] = ACTIONS(1130),
    [anon_sym_primitive] = ACTIONS(1130),
    [anon_sym_interface] = ACTIONS(1130),
    [anon_sym_trait] = ACTIONS(1130),
    [anon_sym_struct] = ACTIONS(1130),
    [anon_sym_embed] = ACTIONS(1130),
    [anon_sym_let] = ACTIONS(1130),
    [anon_sym_var] = ACTIONS(1130),
    [anon_sym_new] = ACTIONS(1130),
    [anon_sym_fun] = ACTIONS(1130),
    [anon_sym_be] = ACTIONS(1130),
    [anon_sym_COMMA] = ACTIONS(1130),
    [anon_sym_LPAREN] = ACTIONS(1132),
    [anon_sym_RPAREN] = ACTIONS(1130),
    [anon_sym_DOT] = ACTIONS(1132),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_SEMI] = ACTIONS(1130),
    [sym_error] = ACTIONS(1130),
    [sym_compile_intrinsic] = ACTIONS(1130),
    [anon_sym_compile_error] = ACTIONS(1130),
    [sym_location] = ACTIONS(1130),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_not] = ACTIONS(1130),
    [anon_sym_DASH_TILDE] = ACTIONS(1130),
    [anon_sym_addressof] = ACTIONS(1130),
    [anon_sym_digestof] = ACTIONS(1130),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_STAR] = ACTIONS(1132),
    [anon_sym_SLASH] = ACTIONS(1132),
    [anon_sym_PERCENT] = ACTIONS(1132),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1132),
    [anon_sym_LT_LT] = ACTIONS(1132),
    [anon_sym_GT_GT] = ACTIONS(1132),
    [anon_sym_and] = ACTIONS(1130),
    [anon_sym_or] = ACTIONS(1130),
    [anon_sym_xor] = ACTIONS(1130),
    [anon_sym_isnt] = ACTIONS(1130),
    [anon_sym_EQ_EQ] = ACTIONS(1132),
    [anon_sym_BANG_EQ] = ACTIONS(1132),
    [anon_sym_GT] = ACTIONS(1132),
    [anon_sym_GT_EQ] = ACTIONS(1132),
    [anon_sym_LT_EQ] = ACTIONS(1132),
    [anon_sym_LT] = ACTIONS(1132),
    [anon_sym_PLUS_TILDE] = ACTIONS(1130),
    [anon_sym_STAR_TILDE] = ACTIONS(1130),
    [anon_sym_SLASH_TILDE] = ACTIONS(1130),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1130),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1130),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1130),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1130),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1130),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1130),
    [anon_sym_GT_TILDE] = ACTIONS(1130),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1130),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1130),
    [anon_sym_LT_TILDE] = ACTIONS(1130),
    [anon_sym_PLUS_QMARK] = ACTIONS(1130),
    [anon_sym_DASH_QMARK] = ACTIONS(1130),
    [anon_sym_STAR_QMARK] = ACTIONS(1130),
    [anon_sym_SLASH_QMARK] = ACTIONS(1130),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1130),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1130),
    [anon_sym_as] = ACTIONS(1130),
    [anon_sym_LPAREN2] = ACTIONS(1130),
    [anon_sym_DOT_GT] = ACTIONS(1130),
    [anon_sym_where] = ACTIONS(1130),
    [anon_sym_TILDE] = ACTIONS(1130),
    [anon_sym_end] = ACTIONS(1130),
    [anon_sym_if] = ACTIONS(1132),
    [anon_sym_ifdef] = ACTIONS(1130),
    [anon_sym_iftype] = ACTIONS(1130),
    [anon_sym_else] = ACTIONS(1130),
    [anon_sym_for] = ACTIONS(1130),
    [anon_sym_while] = ACTIONS(1130),
    [anon_sym_try] = ACTIONS(1130),
    [anon_sym_with] = ACTIONS(1130),
    [anon_sym_repeat] = ACTIONS(1130),
    [anon_sym_do] = ACTIONS(1130),
    [anon_sym_recover] = ACTIONS(1130),
    [anon_sym_match] = ACTIONS(1130),
    [anon_sym_return] = ACTIONS(1130),
    [anon_sym_continue] = ACTIONS(1130),
    [anon_sym_break] = ACTIONS(1130),
    [anon_sym_consume] = ACTIONS(1130),
    [anon_sym_object] = ACTIONS(1130),
    [sym_number] = ACTIONS(1132),
    [sym_float] = ACTIONS(1130),
    [anon_sym_DQUOTE] = ACTIONS(1132),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1130),
    [anon_sym_SQUOTE] = ACTIONS(1130),
    [anon_sym_true] = ACTIONS(1130),
    [anon_sym_false] = ACTIONS(1130),
    [sym_this] = ACTIONS(1130),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [249] = {
    [ts_builtin_sym_end] = ACTIONS(873),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_use] = ACTIONS(873),
    [anon_sym_EQ] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_type] = ACTIONS(873),
    [anon_sym_is] = ACTIONS(875),
    [anon_sym_actor] = ACTIONS(873),
    [anon_sym_class] = ACTIONS(873),
    [anon_sym_primitive] = ACTIONS(873),
    [anon_sym_interface] = ACTIONS(873),
    [anon_sym_trait] = ACTIONS(873),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_embed] = ACTIONS(873),
    [anon_sym_let] = ACTIONS(873),
    [anon_sym_var] = ACTIONS(873),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_fun] = ACTIONS(873),
    [anon_sym_be] = ACTIONS(873),
    [anon_sym_COMMA] = ACTIONS(873),
    [anon_sym_LPAREN] = ACTIONS(875),
    [anon_sym_RPAREN] = ACTIONS(873),
    [anon_sym_DOT] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(873),
    [anon_sym_SEMI] = ACTIONS(873),
    [sym_error] = ACTIONS(873),
    [sym_compile_intrinsic] = ACTIONS(873),
    [anon_sym_compile_error] = ACTIONS(873),
    [sym_location] = ACTIONS(873),
    [anon_sym_DASH] = ACTIONS(875),
    [anon_sym_not] = ACTIONS(873),
    [anon_sym_DASH_TILDE] = ACTIONS(873),
    [anon_sym_addressof] = ACTIONS(873),
    [anon_sym_digestof] = ACTIONS(873),
    [anon_sym_PLUS] = ACTIONS(875),
    [anon_sym_STAR] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(875),
    [anon_sym_PERCENT] = ACTIONS(875),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(875),
    [anon_sym_LT_LT] = ACTIONS(875),
    [anon_sym_GT_GT] = ACTIONS(875),
    [anon_sym_and] = ACTIONS(873),
    [anon_sym_or] = ACTIONS(873),
    [anon_sym_xor] = ACTIONS(873),
    [anon_sym_isnt] = ACTIONS(873),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_BANG_EQ] = ACTIONS(875),
    [anon_sym_GT] = ACTIONS(875),
    [anon_sym_GT_EQ] = ACTIONS(875),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(875),
    [anon_sym_PLUS_TILDE] = ACTIONS(873),
    [anon_sym_STAR_TILDE] = ACTIONS(873),
    [anon_sym_SLASH_TILDE] = ACTIONS(873),
    [anon_sym_PERCENT_TILDE] = ACTIONS(873),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(873),
    [anon_sym_LT_LT_TILDE] = ACTIONS(873),
    [anon_sym_GT_GT_TILDE] = ACTIONS(873),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(873),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(873),
    [anon_sym_GT_TILDE] = ACTIONS(873),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(873),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(873),
    [anon_sym_LT_TILDE] = ACTIONS(873),
    [anon_sym_PLUS_QMARK] = ACTIONS(873),
    [anon_sym_DASH_QMARK] = ACTIONS(873),
    [anon_sym_STAR_QMARK] = ACTIONS(873),
    [anon_sym_SLASH_QMARK] = ACTIONS(873),
    [anon_sym_PERCENT_QMARK] = ACTIONS(873),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(873),
    [anon_sym_as] = ACTIONS(873),
    [anon_sym_LPAREN2] = ACTIONS(873),
    [anon_sym_DOT_GT] = ACTIONS(873),
    [anon_sym_where] = ACTIONS(873),
    [anon_sym_TILDE] = ACTIONS(873),
    [anon_sym_end] = ACTIONS(873),
    [anon_sym_if] = ACTIONS(875),
    [anon_sym_ifdef] = ACTIONS(873),
    [anon_sym_iftype] = ACTIONS(873),
    [anon_sym_else] = ACTIONS(873),
    [anon_sym_for] = ACTIONS(873),
    [anon_sym_while] = ACTIONS(873),
    [anon_sym_try] = ACTIONS(873),
    [anon_sym_with] = ACTIONS(873),
    [anon_sym_repeat] = ACTIONS(873),
    [anon_sym_do] = ACTIONS(873),
    [anon_sym_recover] = ACTIONS(873),
    [anon_sym_match] = ACTIONS(873),
    [anon_sym_return] = ACTIONS(873),
    [anon_sym_continue] = ACTIONS(873),
    [anon_sym_break] = ACTIONS(873),
    [anon_sym_consume] = ACTIONS(873),
    [anon_sym_object] = ACTIONS(873),
    [sym_number] = ACTIONS(875),
    [sym_float] = ACTIONS(873),
    [anon_sym_DQUOTE] = ACTIONS(875),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(873),
    [anon_sym_SQUOTE] = ACTIONS(873),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [sym_this] = ACTIONS(873),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [250] = {
    [ts_builtin_sym_end] = ACTIONS(1134),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_use] = ACTIONS(1134),
    [anon_sym_EQ] = ACTIONS(1136),
    [anon_sym_AT] = ACTIONS(1134),
    [anon_sym_LBRACK] = ACTIONS(1134),
    [anon_sym_type] = ACTIONS(1134),
    [anon_sym_is] = ACTIONS(1136),
    [anon_sym_actor] = ACTIONS(1134),
    [anon_sym_class] = ACTIONS(1134),
    [anon_sym_primitive] = ACTIONS(1134),
    [anon_sym_interface] = ACTIONS(1134),
    [anon_sym_trait] = ACTIONS(1134),
    [anon_sym_struct] = ACTIONS(1134),
    [anon_sym_embed] = ACTIONS(1134),
    [anon_sym_let] = ACTIONS(1134),
    [anon_sym_var] = ACTIONS(1134),
    [anon_sym_new] = ACTIONS(1134),
    [anon_sym_fun] = ACTIONS(1134),
    [anon_sym_be] = ACTIONS(1134),
    [anon_sym_COMMA] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [anon_sym_RPAREN] = ACTIONS(1134),
    [anon_sym_DOT] = ACTIONS(1136),
    [anon_sym_LBRACE] = ACTIONS(1134),
    [anon_sym_SEMI] = ACTIONS(1134),
    [sym_error] = ACTIONS(1134),
    [sym_compile_intrinsic] = ACTIONS(1134),
    [anon_sym_compile_error] = ACTIONS(1134),
    [sym_location] = ACTIONS(1134),
    [anon_sym_DASH] = ACTIONS(1136),
    [anon_sym_not] = ACTIONS(1134),
    [anon_sym_DASH_TILDE] = ACTIONS(1134),
    [anon_sym_addressof] = ACTIONS(1134),
    [anon_sym_digestof] = ACTIONS(1134),
    [anon_sym_PLUS] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_SLASH] = ACTIONS(1136),
    [anon_sym_PERCENT] = ACTIONS(1136),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1136),
    [anon_sym_LT_LT] = ACTIONS(1136),
    [anon_sym_GT_GT] = ACTIONS(1136),
    [anon_sym_and] = ACTIONS(1134),
    [anon_sym_or] = ACTIONS(1134),
    [anon_sym_xor] = ACTIONS(1134),
    [anon_sym_isnt] = ACTIONS(1134),
    [anon_sym_EQ_EQ] = ACTIONS(1136),
    [anon_sym_BANG_EQ] = ACTIONS(1136),
    [anon_sym_GT] = ACTIONS(1136),
    [anon_sym_GT_EQ] = ACTIONS(1136),
    [anon_sym_LT_EQ] = ACTIONS(1136),
    [anon_sym_LT] = ACTIONS(1136),
    [anon_sym_PLUS_TILDE] = ACTIONS(1134),
    [anon_sym_STAR_TILDE] = ACTIONS(1134),
    [anon_sym_SLASH_TILDE] = ACTIONS(1134),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1134),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1134),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1134),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1134),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1134),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1134),
    [anon_sym_GT_TILDE] = ACTIONS(1134),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1134),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1134),
    [anon_sym_LT_TILDE] = ACTIONS(1134),
    [anon_sym_PLUS_QMARK] = ACTIONS(1134),
    [anon_sym_DASH_QMARK] = ACTIONS(1134),
    [anon_sym_STAR_QMARK] = ACTIONS(1134),
    [anon_sym_SLASH_QMARK] = ACTIONS(1134),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1134),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1134),
    [anon_sym_as] = ACTIONS(1134),
    [anon_sym_LPAREN2] = ACTIONS(1134),
    [anon_sym_DOT_GT] = ACTIONS(1134),
    [anon_sym_where] = ACTIONS(1134),
    [anon_sym_TILDE] = ACTIONS(1134),
    [anon_sym_end] = ACTIONS(1134),
    [anon_sym_if] = ACTIONS(1136),
    [anon_sym_ifdef] = ACTIONS(1134),
    [anon_sym_iftype] = ACTIONS(1134),
    [anon_sym_else] = ACTIONS(1134),
    [anon_sym_for] = ACTIONS(1134),
    [anon_sym_while] = ACTIONS(1134),
    [anon_sym_try] = ACTIONS(1134),
    [anon_sym_with] = ACTIONS(1134),
    [anon_sym_repeat] = ACTIONS(1134),
    [anon_sym_do] = ACTIONS(1134),
    [anon_sym_recover] = ACTIONS(1134),
    [anon_sym_match] = ACTIONS(1134),
    [anon_sym_return] = ACTIONS(1134),
    [anon_sym_continue] = ACTIONS(1134),
    [anon_sym_break] = ACTIONS(1134),
    [anon_sym_consume] = ACTIONS(1134),
    [anon_sym_object] = ACTIONS(1134),
    [sym_number] = ACTIONS(1136),
    [sym_float] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(1136),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1134),
    [anon_sym_SQUOTE] = ACTIONS(1134),
    [anon_sym_true] = ACTIONS(1134),
    [anon_sym_false] = ACTIONS(1134),
    [sym_this] = ACTIONS(1134),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [251] = {
    [ts_builtin_sym_end] = ACTIONS(1138),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_use] = ACTIONS(1138),
    [anon_sym_EQ] = ACTIONS(1140),
    [anon_sym_AT] = ACTIONS(1138),
    [anon_sym_LBRACK] = ACTIONS(1138),
    [anon_sym_type] = ACTIONS(1138),
    [anon_sym_is] = ACTIONS(1140),
    [anon_sym_actor] = ACTIONS(1138),
    [anon_sym_class] = ACTIONS(1138),
    [anon_sym_primitive] = ACTIONS(1138),
    [anon_sym_interface] = ACTIONS(1138),
    [anon_sym_trait] = ACTIONS(1138),
    [anon_sym_struct] = ACTIONS(1138),
    [anon_sym_embed] = ACTIONS(1138),
    [anon_sym_let] = ACTIONS(1138),
    [anon_sym_var] = ACTIONS(1138),
    [anon_sym_new] = ACTIONS(1138),
    [anon_sym_fun] = ACTIONS(1138),
    [anon_sym_be] = ACTIONS(1138),
    [anon_sym_COMMA] = ACTIONS(1138),
    [anon_sym_LPAREN] = ACTIONS(1140),
    [anon_sym_RPAREN] = ACTIONS(1138),
    [anon_sym_DOT] = ACTIONS(1140),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_SEMI] = ACTIONS(1138),
    [sym_error] = ACTIONS(1138),
    [sym_compile_intrinsic] = ACTIONS(1138),
    [anon_sym_compile_error] = ACTIONS(1138),
    [sym_location] = ACTIONS(1138),
    [anon_sym_DASH] = ACTIONS(1140),
    [anon_sym_not] = ACTIONS(1138),
    [anon_sym_DASH_TILDE] = ACTIONS(1138),
    [anon_sym_addressof] = ACTIONS(1138),
    [anon_sym_digestof] = ACTIONS(1138),
    [anon_sym_PLUS] = ACTIONS(1140),
    [anon_sym_STAR] = ACTIONS(1140),
    [anon_sym_SLASH] = ACTIONS(1140),
    [anon_sym_PERCENT] = ACTIONS(1140),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1140),
    [anon_sym_LT_LT] = ACTIONS(1140),
    [anon_sym_GT_GT] = ACTIONS(1140),
    [anon_sym_and] = ACTIONS(1138),
    [anon_sym_or] = ACTIONS(1138),
    [anon_sym_xor] = ACTIONS(1138),
    [anon_sym_isnt] = ACTIONS(1138),
    [anon_sym_EQ_EQ] = ACTIONS(1140),
    [anon_sym_BANG_EQ] = ACTIONS(1140),
    [anon_sym_GT] = ACTIONS(1140),
    [anon_sym_GT_EQ] = ACTIONS(1140),
    [anon_sym_LT_EQ] = ACTIONS(1140),
    [anon_sym_LT] = ACTIONS(1140),
    [anon_sym_PLUS_TILDE] = ACTIONS(1138),
    [anon_sym_STAR_TILDE] = ACTIONS(1138),
    [anon_sym_SLASH_TILDE] = ACTIONS(1138),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1138),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1138),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1138),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1138),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1138),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1138),
    [anon_sym_GT_TILDE] = ACTIONS(1138),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1138),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1138),
    [anon_sym_LT_TILDE] = ACTIONS(1138),
    [anon_sym_PLUS_QMARK] = ACTIONS(1138),
    [anon_sym_DASH_QMARK] = ACTIONS(1138),
    [anon_sym_STAR_QMARK] = ACTIONS(1138),
    [anon_sym_SLASH_QMARK] = ACTIONS(1138),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1138),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1138),
    [anon_sym_as] = ACTIONS(1138),
    [anon_sym_LPAREN2] = ACTIONS(1138),
    [anon_sym_DOT_GT] = ACTIONS(1138),
    [anon_sym_where] = ACTIONS(1138),
    [anon_sym_TILDE] = ACTIONS(1138),
    [anon_sym_end] = ACTIONS(1138),
    [anon_sym_if] = ACTIONS(1140),
    [anon_sym_ifdef] = ACTIONS(1138),
    [anon_sym_iftype] = ACTIONS(1138),
    [anon_sym_else] = ACTIONS(1138),
    [anon_sym_for] = ACTIONS(1138),
    [anon_sym_while] = ACTIONS(1138),
    [anon_sym_try] = ACTIONS(1138),
    [anon_sym_with] = ACTIONS(1138),
    [anon_sym_repeat] = ACTIONS(1138),
    [anon_sym_do] = ACTIONS(1138),
    [anon_sym_recover] = ACTIONS(1138),
    [anon_sym_match] = ACTIONS(1138),
    [anon_sym_return] = ACTIONS(1138),
    [anon_sym_continue] = ACTIONS(1138),
    [anon_sym_break] = ACTIONS(1138),
    [anon_sym_consume] = ACTIONS(1138),
    [anon_sym_object] = ACTIONS(1138),
    [sym_number] = ACTIONS(1140),
    [sym_float] = ACTIONS(1138),
    [anon_sym_DQUOTE] = ACTIONS(1140),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1138),
    [anon_sym_SQUOTE] = ACTIONS(1138),
    [anon_sym_true] = ACTIONS(1138),
    [anon_sym_false] = ACTIONS(1138),
    [sym_this] = ACTIONS(1138),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [252] = {
    [ts_builtin_sym_end] = ACTIONS(1142),
    [sym_identifier] = ACTIONS(1144),
    [anon_sym_use] = ACTIONS(1142),
    [anon_sym_EQ] = ACTIONS(1144),
    [anon_sym_AT] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_type] = ACTIONS(1142),
    [anon_sym_is] = ACTIONS(1144),
    [anon_sym_actor] = ACTIONS(1142),
    [anon_sym_class] = ACTIONS(1142),
    [anon_sym_primitive] = ACTIONS(1142),
    [anon_sym_interface] = ACTIONS(1142),
    [anon_sym_trait] = ACTIONS(1142),
    [anon_sym_struct] = ACTIONS(1142),
    [anon_sym_embed] = ACTIONS(1142),
    [anon_sym_let] = ACTIONS(1142),
    [anon_sym_var] = ACTIONS(1142),
    [anon_sym_new] = ACTIONS(1142),
    [anon_sym_fun] = ACTIONS(1142),
    [anon_sym_be] = ACTIONS(1142),
    [anon_sym_COMMA] = ACTIONS(1142),
    [anon_sym_LPAREN] = ACTIONS(1144),
    [anon_sym_RPAREN] = ACTIONS(1142),
    [anon_sym_DOT] = ACTIONS(1144),
    [anon_sym_LBRACE] = ACTIONS(1142),
    [anon_sym_SEMI] = ACTIONS(1142),
    [sym_error] = ACTIONS(1142),
    [sym_compile_intrinsic] = ACTIONS(1142),
    [anon_sym_compile_error] = ACTIONS(1142),
    [sym_location] = ACTIONS(1142),
    [anon_sym_DASH] = ACTIONS(1144),
    [anon_sym_not] = ACTIONS(1142),
    [anon_sym_DASH_TILDE] = ACTIONS(1142),
    [anon_sym_addressof] = ACTIONS(1142),
    [anon_sym_digestof] = ACTIONS(1142),
    [anon_sym_PLUS] = ACTIONS(1144),
    [anon_sym_STAR] = ACTIONS(1144),
    [anon_sym_SLASH] = ACTIONS(1144),
    [anon_sym_PERCENT] = ACTIONS(1144),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1144),
    [anon_sym_LT_LT] = ACTIONS(1144),
    [anon_sym_GT_GT] = ACTIONS(1144),
    [anon_sym_and] = ACTIONS(1142),
    [anon_sym_or] = ACTIONS(1142),
    [anon_sym_xor] = ACTIONS(1142),
    [anon_sym_isnt] = ACTIONS(1142),
    [anon_sym_EQ_EQ] = ACTIONS(1144),
    [anon_sym_BANG_EQ] = ACTIONS(1144),
    [anon_sym_GT] = ACTIONS(1144),
    [anon_sym_GT_EQ] = ACTIONS(1144),
    [anon_sym_LT_EQ] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(1144),
    [anon_sym_PLUS_TILDE] = ACTIONS(1142),
    [anon_sym_STAR_TILDE] = ACTIONS(1142),
    [anon_sym_SLASH_TILDE] = ACTIONS(1142),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1142),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1142),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1142),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1142),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1142),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1142),
    [anon_sym_GT_TILDE] = ACTIONS(1142),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1142),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1142),
    [anon_sym_LT_TILDE] = ACTIONS(1142),
    [anon_sym_PLUS_QMARK] = ACTIONS(1142),
    [anon_sym_DASH_QMARK] = ACTIONS(1142),
    [anon_sym_STAR_QMARK] = ACTIONS(1142),
    [anon_sym_SLASH_QMARK] = ACTIONS(1142),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1142),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1142),
    [anon_sym_as] = ACTIONS(1142),
    [anon_sym_LPAREN2] = ACTIONS(1142),
    [anon_sym_DOT_GT] = ACTIONS(1142),
    [anon_sym_where] = ACTIONS(1142),
    [anon_sym_TILDE] = ACTIONS(1142),
    [anon_sym_end] = ACTIONS(1142),
    [anon_sym_if] = ACTIONS(1144),
    [anon_sym_ifdef] = ACTIONS(1142),
    [anon_sym_iftype] = ACTIONS(1142),
    [anon_sym_else] = ACTIONS(1142),
    [anon_sym_for] = ACTIONS(1142),
    [anon_sym_while] = ACTIONS(1142),
    [anon_sym_try] = ACTIONS(1142),
    [anon_sym_with] = ACTIONS(1142),
    [anon_sym_repeat] = ACTIONS(1142),
    [anon_sym_do] = ACTIONS(1142),
    [anon_sym_recover] = ACTIONS(1142),
    [anon_sym_match] = ACTIONS(1142),
    [anon_sym_return] = ACTIONS(1142),
    [anon_sym_continue] = ACTIONS(1142),
    [anon_sym_break] = ACTIONS(1142),
    [anon_sym_consume] = ACTIONS(1142),
    [anon_sym_object] = ACTIONS(1142),
    [sym_number] = ACTIONS(1144),
    [sym_float] = ACTIONS(1142),
    [anon_sym_DQUOTE] = ACTIONS(1144),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1142),
    [anon_sym_SQUOTE] = ACTIONS(1142),
    [anon_sym_true] = ACTIONS(1142),
    [anon_sym_false] = ACTIONS(1142),
    [sym_this] = ACTIONS(1142),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [253] = {
    [ts_builtin_sym_end] = ACTIONS(1146),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_use] = ACTIONS(1146),
    [anon_sym_EQ] = ACTIONS(1148),
    [anon_sym_AT] = ACTIONS(1146),
    [anon_sym_LBRACK] = ACTIONS(1146),
    [anon_sym_type] = ACTIONS(1146),
    [anon_sym_is] = ACTIONS(1148),
    [anon_sym_actor] = ACTIONS(1146),
    [anon_sym_class] = ACTIONS(1146),
    [anon_sym_primitive] = ACTIONS(1146),
    [anon_sym_interface] = ACTIONS(1146),
    [anon_sym_trait] = ACTIONS(1146),
    [anon_sym_struct] = ACTIONS(1146),
    [anon_sym_embed] = ACTIONS(1146),
    [anon_sym_let] = ACTIONS(1146),
    [anon_sym_var] = ACTIONS(1146),
    [anon_sym_new] = ACTIONS(1146),
    [anon_sym_fun] = ACTIONS(1146),
    [anon_sym_be] = ACTIONS(1146),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_LPAREN] = ACTIONS(1148),
    [anon_sym_RPAREN] = ACTIONS(1146),
    [anon_sym_DOT] = ACTIONS(1148),
    [anon_sym_LBRACE] = ACTIONS(1146),
    [anon_sym_SEMI] = ACTIONS(1146),
    [sym_error] = ACTIONS(1146),
    [sym_compile_intrinsic] = ACTIONS(1146),
    [anon_sym_compile_error] = ACTIONS(1146),
    [sym_location] = ACTIONS(1146),
    [anon_sym_DASH] = ACTIONS(1148),
    [anon_sym_not] = ACTIONS(1146),
    [anon_sym_DASH_TILDE] = ACTIONS(1146),
    [anon_sym_addressof] = ACTIONS(1146),
    [anon_sym_digestof] = ACTIONS(1146),
    [anon_sym_PLUS] = ACTIONS(1148),
    [anon_sym_STAR] = ACTIONS(1148),
    [anon_sym_SLASH] = ACTIONS(1148),
    [anon_sym_PERCENT] = ACTIONS(1148),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(1148),
    [anon_sym_GT_GT] = ACTIONS(1148),
    [anon_sym_and] = ACTIONS(1146),
    [anon_sym_or] = ACTIONS(1146),
    [anon_sym_xor] = ACTIONS(1146),
    [anon_sym_isnt] = ACTIONS(1146),
    [anon_sym_EQ_EQ] = ACTIONS(1148),
    [anon_sym_BANG_EQ] = ACTIONS(1148),
    [anon_sym_GT] = ACTIONS(1148),
    [anon_sym_GT_EQ] = ACTIONS(1148),
    [anon_sym_LT_EQ] = ACTIONS(1148),
    [anon_sym_LT] = ACTIONS(1148),
    [anon_sym_PLUS_TILDE] = ACTIONS(1146),
    [anon_sym_STAR_TILDE] = ACTIONS(1146),
    [anon_sym_SLASH_TILDE] = ACTIONS(1146),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1146),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1146),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1146),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1146),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1146),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1146),
    [anon_sym_GT_TILDE] = ACTIONS(1146),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1146),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1146),
    [anon_sym_LT_TILDE] = ACTIONS(1146),
    [anon_sym_PLUS_QMARK] = ACTIONS(1146),
    [anon_sym_DASH_QMARK] = ACTIONS(1146),
    [anon_sym_STAR_QMARK] = ACTIONS(1146),
    [anon_sym_SLASH_QMARK] = ACTIONS(1146),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1146),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1146),
    [anon_sym_as] = ACTIONS(1146),
    [anon_sym_LPAREN2] = ACTIONS(1146),
    [anon_sym_DOT_GT] = ACTIONS(1146),
    [anon_sym_where] = ACTIONS(1146),
    [anon_sym_TILDE] = ACTIONS(1146),
    [anon_sym_end] = ACTIONS(1146),
    [anon_sym_if] = ACTIONS(1148),
    [anon_sym_ifdef] = ACTIONS(1146),
    [anon_sym_iftype] = ACTIONS(1146),
    [anon_sym_else] = ACTIONS(1146),
    [anon_sym_for] = ACTIONS(1146),
    [anon_sym_while] = ACTIONS(1146),
    [anon_sym_try] = ACTIONS(1146),
    [anon_sym_with] = ACTIONS(1146),
    [anon_sym_repeat] = ACTIONS(1146),
    [anon_sym_do] = ACTIONS(1146),
    [anon_sym_recover] = ACTIONS(1146),
    [anon_sym_match] = ACTIONS(1146),
    [anon_sym_return] = ACTIONS(1146),
    [anon_sym_continue] = ACTIONS(1146),
    [anon_sym_break] = ACTIONS(1146),
    [anon_sym_consume] = ACTIONS(1146),
    [anon_sym_object] = ACTIONS(1146),
    [sym_number] = ACTIONS(1148),
    [sym_float] = ACTIONS(1146),
    [anon_sym_DQUOTE] = ACTIONS(1148),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1146),
    [anon_sym_SQUOTE] = ACTIONS(1146),
    [anon_sym_true] = ACTIONS(1146),
    [anon_sym_false] = ACTIONS(1146),
    [sym_this] = ACTIONS(1146),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [254] = {
    [ts_builtin_sym_end] = ACTIONS(638),
    [sym_identifier] = ACTIONS(640),
    [anon_sym_use] = ACTIONS(638),
    [anon_sym_EQ] = ACTIONS(640),
    [anon_sym_AT] = ACTIONS(638),
    [anon_sym_LBRACK] = ACTIONS(638),
    [anon_sym_type] = ACTIONS(638),
    [anon_sym_is] = ACTIONS(640),
    [anon_sym_actor] = ACTIONS(638),
    [anon_sym_class] = ACTIONS(638),
    [anon_sym_primitive] = ACTIONS(638),
    [anon_sym_interface] = ACTIONS(638),
    [anon_sym_trait] = ACTIONS(638),
    [anon_sym_struct] = ACTIONS(638),
    [anon_sym_embed] = ACTIONS(638),
    [anon_sym_let] = ACTIONS(638),
    [anon_sym_var] = ACTIONS(638),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_fun] = ACTIONS(638),
    [anon_sym_be] = ACTIONS(638),
    [anon_sym_COMMA] = ACTIONS(638),
    [anon_sym_LPAREN] = ACTIONS(640),
    [anon_sym_RPAREN] = ACTIONS(638),
    [anon_sym_DOT] = ACTIONS(640),
    [anon_sym_LBRACE] = ACTIONS(638),
    [anon_sym_SEMI] = ACTIONS(638),
    [sym_error] = ACTIONS(638),
    [sym_compile_intrinsic] = ACTIONS(638),
    [anon_sym_compile_error] = ACTIONS(638),
    [sym_location] = ACTIONS(638),
    [anon_sym_DASH] = ACTIONS(640),
    [anon_sym_not] = ACTIONS(638),
    [anon_sym_DASH_TILDE] = ACTIONS(638),
    [anon_sym_addressof] = ACTIONS(638),
    [anon_sym_digestof] = ACTIONS(638),
    [anon_sym_PLUS] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(640),
    [anon_sym_SLASH] = ACTIONS(640),
    [anon_sym_PERCENT] = ACTIONS(640),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(640),
    [anon_sym_LT_LT] = ACTIONS(640),
    [anon_sym_GT_GT] = ACTIONS(640),
    [anon_sym_and] = ACTIONS(638),
    [anon_sym_or] = ACTIONS(638),
    [anon_sym_xor] = ACTIONS(638),
    [anon_sym_isnt] = ACTIONS(638),
    [anon_sym_EQ_EQ] = ACTIONS(640),
    [anon_sym_BANG_EQ] = ACTIONS(640),
    [anon_sym_GT] = ACTIONS(640),
    [anon_sym_GT_EQ] = ACTIONS(640),
    [anon_sym_LT_EQ] = ACTIONS(640),
    [anon_sym_LT] = ACTIONS(640),
    [anon_sym_PLUS_TILDE] = ACTIONS(638),
    [anon_sym_STAR_TILDE] = ACTIONS(638),
    [anon_sym_SLASH_TILDE] = ACTIONS(638),
    [anon_sym_PERCENT_TILDE] = ACTIONS(638),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(638),
    [anon_sym_LT_LT_TILDE] = ACTIONS(638),
    [anon_sym_GT_GT_TILDE] = ACTIONS(638),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(638),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(638),
    [anon_sym_GT_TILDE] = ACTIONS(638),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(638),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(638),
    [anon_sym_LT_TILDE] = ACTIONS(638),
    [anon_sym_PLUS_QMARK] = ACTIONS(638),
    [anon_sym_DASH_QMARK] = ACTIONS(638),
    [anon_sym_STAR_QMARK] = ACTIONS(638),
    [anon_sym_SLASH_QMARK] = ACTIONS(638),
    [anon_sym_PERCENT_QMARK] = ACTIONS(638),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(638),
    [anon_sym_as] = ACTIONS(638),
    [anon_sym_LPAREN2] = ACTIONS(638),
    [anon_sym_DOT_GT] = ACTIONS(638),
    [anon_sym_where] = ACTIONS(638),
    [anon_sym_TILDE] = ACTIONS(638),
    [anon_sym_end] = ACTIONS(638),
    [anon_sym_if] = ACTIONS(640),
    [anon_sym_ifdef] = ACTIONS(638),
    [anon_sym_iftype] = ACTIONS(638),
    [anon_sym_else] = ACTIONS(638),
    [anon_sym_for] = ACTIONS(638),
    [anon_sym_while] = ACTIONS(638),
    [anon_sym_try] = ACTIONS(638),
    [anon_sym_with] = ACTIONS(638),
    [anon_sym_repeat] = ACTIONS(638),
    [anon_sym_do] = ACTIONS(638),
    [anon_sym_recover] = ACTIONS(638),
    [anon_sym_match] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(638),
    [anon_sym_continue] = ACTIONS(638),
    [anon_sym_break] = ACTIONS(638),
    [anon_sym_consume] = ACTIONS(638),
    [anon_sym_object] = ACTIONS(638),
    [sym_number] = ACTIONS(640),
    [sym_float] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(640),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(638),
    [anon_sym_SQUOTE] = ACTIONS(638),
    [anon_sym_true] = ACTIONS(638),
    [anon_sym_false] = ACTIONS(638),
    [sym_this] = ACTIONS(638),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [255] = {
    [sym_identifier] = ACTIONS(726),
    [anon_sym_EQ] = ACTIONS(726),
    [anon_sym_AT] = ACTIONS(724),
    [anon_sym_LBRACK] = ACTIONS(724),
    [anon_sym_is] = ACTIONS(726),
    [anon_sym_let] = ACTIONS(724),
    [anon_sym_var] = ACTIONS(724),
    [anon_sym_iso] = ACTIONS(724),
    [anon_sym_trn] = ACTIONS(724),
    [anon_sym_ref] = ACTIONS(724),
    [anon_sym_val] = ACTIONS(724),
    [anon_sym_box] = ACTIONS(724),
    [anon_sym_tag] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(726),
    [anon_sym_DOT] = ACTIONS(726),
    [anon_sym_POUNDread] = ACTIONS(724),
    [anon_sym_POUNDsend] = ACTIONS(724),
    [anon_sym_POUNDshare] = ACTIONS(724),
    [anon_sym_POUNDalias] = ACTIONS(724),
    [anon_sym_POUNDany] = ACTIONS(724),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_CARET] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(724),
    [anon_sym_DASH_GT] = ACTIONS(724),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_SEMI] = ACTIONS(724),
    [sym_error] = ACTIONS(724),
    [sym_compile_intrinsic] = ACTIONS(724),
    [anon_sym_compile_error] = ACTIONS(724),
    [sym_location] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(726),
    [anon_sym_not] = ACTIONS(724),
    [anon_sym_DASH_TILDE] = ACTIONS(724),
    [anon_sym_addressof] = ACTIONS(724),
    [anon_sym_digestof] = ACTIONS(724),
    [anon_sym_PLUS] = ACTIONS(726),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_SLASH] = ACTIONS(726),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(726),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_GT_GT] = ACTIONS(726),
    [anon_sym_and] = ACTIONS(724),
    [anon_sym_or] = ACTIONS(724),
    [anon_sym_xor] = ACTIONS(724),
    [anon_sym_isnt] = ACTIONS(724),
    [anon_sym_EQ_EQ] = ACTIONS(726),
    [anon_sym_BANG_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(726),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(726),
    [anon_sym_PLUS_TILDE] = ACTIONS(724),
    [anon_sym_STAR_TILDE] = ACTIONS(724),
    [anon_sym_SLASH_TILDE] = ACTIONS(724),
    [anon_sym_PERCENT_TILDE] = ACTIONS(724),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(724),
    [anon_sym_LT_LT_TILDE] = ACTIONS(724),
    [anon_sym_GT_GT_TILDE] = ACTIONS(724),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(724),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(724),
    [anon_sym_GT_TILDE] = ACTIONS(724),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(724),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(724),
    [anon_sym_LT_TILDE] = ACTIONS(724),
    [anon_sym_PLUS_QMARK] = ACTIONS(724),
    [anon_sym_DASH_QMARK] = ACTIONS(724),
    [anon_sym_STAR_QMARK] = ACTIONS(724),
    [anon_sym_SLASH_QMARK] = ACTIONS(724),
    [anon_sym_PERCENT_QMARK] = ACTIONS(724),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(724),
    [anon_sym_as] = ACTIONS(724),
    [anon_sym_LPAREN2] = ACTIONS(724),
    [anon_sym_DOT_GT] = ACTIONS(724),
    [anon_sym_TILDE] = ACTIONS(724),
    [anon_sym_end] = ACTIONS(724),
    [anon_sym_if] = ACTIONS(726),
    [anon_sym_ifdef] = ACTIONS(724),
    [anon_sym_elseif] = ACTIONS(724),
    [anon_sym_iftype] = ACTIONS(724),
    [anon_sym_else] = ACTIONS(726),
    [anon_sym_for] = ACTIONS(724),
    [anon_sym_while] = ACTIONS(724),
    [anon_sym_try] = ACTIONS(724),
    [anon_sym_with] = ACTIONS(724),
    [anon_sym_repeat] = ACTIONS(724),
    [anon_sym_recover] = ACTIONS(724),
    [anon_sym_match] = ACTIONS(724),
    [anon_sym_return] = ACTIONS(724),
    [anon_sym_continue] = ACTIONS(724),
    [anon_sym_break] = ACTIONS(724),
    [anon_sym_consume] = ACTIONS(724),
    [anon_sym_object] = ACTIONS(724),
    [sym_number] = ACTIONS(726),
    [sym_float] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(724),
    [anon_sym_SQUOTE] = ACTIONS(724),
    [anon_sym_true] = ACTIONS(724),
    [anon_sym_false] = ACTIONS(724),
    [sym_this] = ACTIONS(724),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [256] = {
    [sym_identifier] = ACTIONS(680),
    [anon_sym_EQ] = ACTIONS(680),
    [anon_sym_AT] = ACTIONS(678),
    [anon_sym_LBRACK] = ACTIONS(678),
    [anon_sym_is] = ACTIONS(680),
    [anon_sym_let] = ACTIONS(678),
    [anon_sym_var] = ACTIONS(678),
    [anon_sym_iso] = ACTIONS(1150),
    [anon_sym_trn] = ACTIONS(1152),
    [anon_sym_ref] = ACTIONS(1154),
    [anon_sym_val] = ACTIONS(1156),
    [anon_sym_box] = ACTIONS(1158),
    [anon_sym_tag] = ACTIONS(1160),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_DOT] = ACTIONS(680),
    [anon_sym_POUNDread] = ACTIONS(1162),
    [anon_sym_POUNDsend] = ACTIONS(1164),
    [anon_sym_POUNDshare] = ACTIONS(1166),
    [anon_sym_POUNDalias] = ACTIONS(1168),
    [anon_sym_POUNDany] = ACTIONS(1170),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_CARET] = ACTIONS(678),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_AMP] = ACTIONS(678),
    [anon_sym_DASH_GT] = ACTIONS(678),
    [anon_sym_LBRACE] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(678),
    [sym_error] = ACTIONS(678),
    [sym_compile_intrinsic] = ACTIONS(678),
    [anon_sym_compile_error] = ACTIONS(678),
    [sym_location] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(680),
    [anon_sym_not] = ACTIONS(678),
    [anon_sym_DASH_TILDE] = ACTIONS(678),
    [anon_sym_addressof] = ACTIONS(678),
    [anon_sym_digestof] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(680),
    [anon_sym_STAR] = ACTIONS(680),
    [anon_sym_SLASH] = ACTIONS(680),
    [anon_sym_PERCENT] = ACTIONS(680),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(680),
    [anon_sym_LT_LT] = ACTIONS(680),
    [anon_sym_GT_GT] = ACTIONS(680),
    [anon_sym_and] = ACTIONS(678),
    [anon_sym_or] = ACTIONS(678),
    [anon_sym_xor] = ACTIONS(678),
    [anon_sym_isnt] = ACTIONS(678),
    [anon_sym_EQ_EQ] = ACTIONS(680),
    [anon_sym_BANG_EQ] = ACTIONS(680),
    [anon_sym_GT] = ACTIONS(680),
    [anon_sym_GT_EQ] = ACTIONS(680),
    [anon_sym_LT_EQ] = ACTIONS(680),
    [anon_sym_LT] = ACTIONS(680),
    [anon_sym_PLUS_TILDE] = ACTIONS(678),
    [anon_sym_STAR_TILDE] = ACTIONS(678),
    [anon_sym_SLASH_TILDE] = ACTIONS(678),
    [anon_sym_PERCENT_TILDE] = ACTIONS(678),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(678),
    [anon_sym_LT_LT_TILDE] = ACTIONS(678),
    [anon_sym_GT_GT_TILDE] = ACTIONS(678),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(678),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(678),
    [anon_sym_GT_TILDE] = ACTIONS(678),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(678),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(678),
    [anon_sym_LT_TILDE] = ACTIONS(678),
    [anon_sym_PLUS_QMARK] = ACTIONS(678),
    [anon_sym_DASH_QMARK] = ACTIONS(678),
    [anon_sym_STAR_QMARK] = ACTIONS(678),
    [anon_sym_SLASH_QMARK] = ACTIONS(678),
    [anon_sym_PERCENT_QMARK] = ACTIONS(678),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(678),
    [anon_sym_as] = ACTIONS(678),
    [anon_sym_LPAREN2] = ACTIONS(678),
    [anon_sym_DOT_GT] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(678),
    [anon_sym_end] = ACTIONS(678),
    [anon_sym_if] = ACTIONS(680),
    [anon_sym_ifdef] = ACTIONS(678),
    [anon_sym_elseif] = ACTIONS(678),
    [anon_sym_iftype] = ACTIONS(678),
    [anon_sym_else] = ACTIONS(680),
    [anon_sym_for] = ACTIONS(678),
    [anon_sym_while] = ACTIONS(678),
    [anon_sym_try] = ACTIONS(678),
    [anon_sym_with] = ACTIONS(678),
    [anon_sym_repeat] = ACTIONS(678),
    [anon_sym_recover] = ACTIONS(678),
    [anon_sym_match] = ACTIONS(678),
    [anon_sym_return] = ACTIONS(678),
    [anon_sym_continue] = ACTIONS(678),
    [anon_sym_break] = ACTIONS(678),
    [anon_sym_consume] = ACTIONS(678),
    [anon_sym_object] = ACTIONS(678),
    [sym_number] = ACTIONS(680),
    [sym_float] = ACTIONS(678),
    [anon_sym_DQUOTE] = ACTIONS(680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(678),
    [anon_sym_true] = ACTIONS(678),
    [anon_sym_false] = ACTIONS(678),
    [sym_this] = ACTIONS(678),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [257] = {
    [ts_builtin_sym_end] = ACTIONS(1172),
    [sym_identifier] = ACTIONS(1174),
    [anon_sym_use] = ACTIONS(1172),
    [anon_sym_EQ] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(1172),
    [anon_sym_LBRACK] = ACTIONS(1172),
    [anon_sym_type] = ACTIONS(1172),
    [anon_sym_is] = ACTIONS(1174),
    [anon_sym_actor] = ACTIONS(1172),
    [anon_sym_class] = ACTIONS(1172),
    [anon_sym_primitive] = ACTIONS(1172),
    [anon_sym_interface] = ACTIONS(1172),
    [anon_sym_trait] = ACTIONS(1172),
    [anon_sym_struct] = ACTIONS(1172),
    [anon_sym_embed] = ACTIONS(1172),
    [anon_sym_let] = ACTIONS(1172),
    [anon_sym_var] = ACTIONS(1172),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_fun] = ACTIONS(1172),
    [anon_sym_be] = ACTIONS(1172),
    [anon_sym_COMMA] = ACTIONS(1172),
    [anon_sym_LPAREN] = ACTIONS(1174),
    [anon_sym_RPAREN] = ACTIONS(1172),
    [anon_sym_DOT] = ACTIONS(1174),
    [anon_sym_LBRACE] = ACTIONS(1172),
    [anon_sym_SEMI] = ACTIONS(1172),
    [sym_error] = ACTIONS(1172),
    [sym_compile_intrinsic] = ACTIONS(1172),
    [anon_sym_compile_error] = ACTIONS(1172),
    [sym_location] = ACTIONS(1172),
    [anon_sym_DASH] = ACTIONS(1174),
    [anon_sym_not] = ACTIONS(1172),
    [anon_sym_DASH_TILDE] = ACTIONS(1172),
    [anon_sym_addressof] = ACTIONS(1172),
    [anon_sym_digestof] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(1174),
    [anon_sym_STAR] = ACTIONS(1174),
    [anon_sym_SLASH] = ACTIONS(1174),
    [anon_sym_PERCENT] = ACTIONS(1174),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1174),
    [anon_sym_LT_LT] = ACTIONS(1174),
    [anon_sym_GT_GT] = ACTIONS(1174),
    [anon_sym_and] = ACTIONS(1172),
    [anon_sym_or] = ACTIONS(1172),
    [anon_sym_xor] = ACTIONS(1172),
    [anon_sym_isnt] = ACTIONS(1172),
    [anon_sym_EQ_EQ] = ACTIONS(1174),
    [anon_sym_BANG_EQ] = ACTIONS(1174),
    [anon_sym_GT] = ACTIONS(1174),
    [anon_sym_GT_EQ] = ACTIONS(1174),
    [anon_sym_LT_EQ] = ACTIONS(1174),
    [anon_sym_LT] = ACTIONS(1174),
    [anon_sym_PLUS_TILDE] = ACTIONS(1172),
    [anon_sym_STAR_TILDE] = ACTIONS(1172),
    [anon_sym_SLASH_TILDE] = ACTIONS(1172),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1172),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1172),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1172),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1172),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1172),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1172),
    [anon_sym_GT_TILDE] = ACTIONS(1172),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1172),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1172),
    [anon_sym_LT_TILDE] = ACTIONS(1172),
    [anon_sym_PLUS_QMARK] = ACTIONS(1172),
    [anon_sym_DASH_QMARK] = ACTIONS(1172),
    [anon_sym_STAR_QMARK] = ACTIONS(1172),
    [anon_sym_SLASH_QMARK] = ACTIONS(1172),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1172),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1172),
    [anon_sym_as] = ACTIONS(1172),
    [anon_sym_LPAREN2] = ACTIONS(1172),
    [anon_sym_DOT_GT] = ACTIONS(1172),
    [anon_sym_where] = ACTIONS(1172),
    [anon_sym_TILDE] = ACTIONS(1172),
    [anon_sym_end] = ACTIONS(1172),
    [anon_sym_if] = ACTIONS(1174),
    [anon_sym_ifdef] = ACTIONS(1172),
    [anon_sym_iftype] = ACTIONS(1172),
    [anon_sym_else] = ACTIONS(1172),
    [anon_sym_for] = ACTIONS(1172),
    [anon_sym_while] = ACTIONS(1172),
    [anon_sym_try] = ACTIONS(1172),
    [anon_sym_with] = ACTIONS(1172),
    [anon_sym_repeat] = ACTIONS(1172),
    [anon_sym_do] = ACTIONS(1172),
    [anon_sym_recover] = ACTIONS(1172),
    [anon_sym_match] = ACTIONS(1172),
    [anon_sym_return] = ACTIONS(1172),
    [anon_sym_continue] = ACTIONS(1172),
    [anon_sym_break] = ACTIONS(1172),
    [anon_sym_consume] = ACTIONS(1172),
    [anon_sym_object] = ACTIONS(1172),
    [sym_number] = ACTIONS(1174),
    [sym_float] = ACTIONS(1172),
    [anon_sym_DQUOTE] = ACTIONS(1174),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1172),
    [anon_sym_SQUOTE] = ACTIONS(1172),
    [anon_sym_true] = ACTIONS(1172),
    [anon_sym_false] = ACTIONS(1172),
    [sym_this] = ACTIONS(1172),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [258] = {
    [sym_identifier] = ACTIONS(664),
    [anon_sym_EQ] = ACTIONS(664),
    [anon_sym_AT] = ACTIONS(662),
    [anon_sym_LBRACK] = ACTIONS(662),
    [anon_sym_is] = ACTIONS(664),
    [anon_sym_let] = ACTIONS(662),
    [anon_sym_var] = ACTIONS(662),
    [anon_sym_iso] = ACTIONS(662),
    [anon_sym_trn] = ACTIONS(662),
    [anon_sym_ref] = ACTIONS(662),
    [anon_sym_val] = ACTIONS(662),
    [anon_sym_box] = ACTIONS(662),
    [anon_sym_tag] = ACTIONS(662),
    [anon_sym_LPAREN] = ACTIONS(664),
    [anon_sym_DOT] = ACTIONS(664),
    [anon_sym_POUNDread] = ACTIONS(662),
    [anon_sym_POUNDsend] = ACTIONS(662),
    [anon_sym_POUNDshare] = ACTIONS(662),
    [anon_sym_POUNDalias] = ACTIONS(662),
    [anon_sym_POUNDany] = ACTIONS(662),
    [anon_sym_BANG] = ACTIONS(664),
    [anon_sym_CARET] = ACTIONS(662),
    [anon_sym_PIPE] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(662),
    [anon_sym_DASH_GT] = ACTIONS(662),
    [anon_sym_LBRACE] = ACTIONS(662),
    [anon_sym_SEMI] = ACTIONS(662),
    [sym_error] = ACTIONS(662),
    [sym_compile_intrinsic] = ACTIONS(662),
    [anon_sym_compile_error] = ACTIONS(662),
    [sym_location] = ACTIONS(662),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_not] = ACTIONS(662),
    [anon_sym_DASH_TILDE] = ACTIONS(662),
    [anon_sym_addressof] = ACTIONS(662),
    [anon_sym_digestof] = ACTIONS(662),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_STAR] = ACTIONS(664),
    [anon_sym_SLASH] = ACTIONS(664),
    [anon_sym_PERCENT] = ACTIONS(664),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(664),
    [anon_sym_LT_LT] = ACTIONS(664),
    [anon_sym_GT_GT] = ACTIONS(664),
    [anon_sym_and] = ACTIONS(662),
    [anon_sym_or] = ACTIONS(662),
    [anon_sym_xor] = ACTIONS(662),
    [anon_sym_isnt] = ACTIONS(662),
    [anon_sym_EQ_EQ] = ACTIONS(664),
    [anon_sym_BANG_EQ] = ACTIONS(664),
    [anon_sym_GT] = ACTIONS(664),
    [anon_sym_GT_EQ] = ACTIONS(664),
    [anon_sym_LT_EQ] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(664),
    [anon_sym_PLUS_TILDE] = ACTIONS(662),
    [anon_sym_STAR_TILDE] = ACTIONS(662),
    [anon_sym_SLASH_TILDE] = ACTIONS(662),
    [anon_sym_PERCENT_TILDE] = ACTIONS(662),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(662),
    [anon_sym_LT_LT_TILDE] = ACTIONS(662),
    [anon_sym_GT_GT_TILDE] = ACTIONS(662),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(662),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(662),
    [anon_sym_GT_TILDE] = ACTIONS(662),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(662),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(662),
    [anon_sym_LT_TILDE] = ACTIONS(662),
    [anon_sym_PLUS_QMARK] = ACTIONS(662),
    [anon_sym_DASH_QMARK] = ACTIONS(662),
    [anon_sym_STAR_QMARK] = ACTIONS(662),
    [anon_sym_SLASH_QMARK] = ACTIONS(662),
    [anon_sym_PERCENT_QMARK] = ACTIONS(662),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(662),
    [anon_sym_as] = ACTIONS(662),
    [anon_sym_LPAREN2] = ACTIONS(662),
    [anon_sym_DOT_GT] = ACTIONS(662),
    [anon_sym_TILDE] = ACTIONS(662),
    [anon_sym_end] = ACTIONS(662),
    [anon_sym_if] = ACTIONS(664),
    [anon_sym_ifdef] = ACTIONS(662),
    [anon_sym_elseif] = ACTIONS(662),
    [anon_sym_iftype] = ACTIONS(662),
    [anon_sym_else] = ACTIONS(664),
    [anon_sym_for] = ACTIONS(662),
    [anon_sym_while] = ACTIONS(662),
    [anon_sym_try] = ACTIONS(662),
    [anon_sym_with] = ACTIONS(662),
    [anon_sym_repeat] = ACTIONS(662),
    [anon_sym_recover] = ACTIONS(662),
    [anon_sym_match] = ACTIONS(662),
    [anon_sym_return] = ACTIONS(662),
    [anon_sym_continue] = ACTIONS(662),
    [anon_sym_break] = ACTIONS(662),
    [anon_sym_consume] = ACTIONS(662),
    [anon_sym_object] = ACTIONS(662),
    [sym_number] = ACTIONS(664),
    [sym_float] = ACTIONS(662),
    [anon_sym_DQUOTE] = ACTIONS(664),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(662),
    [anon_sym_SQUOTE] = ACTIONS(662),
    [anon_sym_true] = ACTIONS(662),
    [anon_sym_false] = ACTIONS(662),
    [sym_this] = ACTIONS(662),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [259] = {
    [ts_builtin_sym_end] = ACTIONS(1176),
    [sym_identifier] = ACTIONS(1178),
    [anon_sym_use] = ACTIONS(1176),
    [anon_sym_EQ] = ACTIONS(1178),
    [anon_sym_AT] = ACTIONS(1176),
    [anon_sym_LBRACK] = ACTIONS(1176),
    [anon_sym_type] = ACTIONS(1176),
    [anon_sym_is] = ACTIONS(1178),
    [anon_sym_actor] = ACTIONS(1176),
    [anon_sym_class] = ACTIONS(1176),
    [anon_sym_primitive] = ACTIONS(1176),
    [anon_sym_interface] = ACTIONS(1176),
    [anon_sym_trait] = ACTIONS(1176),
    [anon_sym_struct] = ACTIONS(1176),
    [anon_sym_embed] = ACTIONS(1176),
    [anon_sym_let] = ACTIONS(1176),
    [anon_sym_var] = ACTIONS(1176),
    [anon_sym_new] = ACTIONS(1176),
    [anon_sym_fun] = ACTIONS(1176),
    [anon_sym_be] = ACTIONS(1176),
    [anon_sym_COMMA] = ACTIONS(1176),
    [anon_sym_LPAREN] = ACTIONS(1178),
    [anon_sym_RPAREN] = ACTIONS(1176),
    [anon_sym_DOT] = ACTIONS(1178),
    [anon_sym_LBRACE] = ACTIONS(1176),
    [anon_sym_SEMI] = ACTIONS(1176),
    [sym_error] = ACTIONS(1176),
    [sym_compile_intrinsic] = ACTIONS(1176),
    [anon_sym_compile_error] = ACTIONS(1176),
    [sym_location] = ACTIONS(1176),
    [anon_sym_DASH] = ACTIONS(1178),
    [anon_sym_not] = ACTIONS(1176),
    [anon_sym_DASH_TILDE] = ACTIONS(1176),
    [anon_sym_addressof] = ACTIONS(1176),
    [anon_sym_digestof] = ACTIONS(1176),
    [anon_sym_PLUS] = ACTIONS(1178),
    [anon_sym_STAR] = ACTIONS(1178),
    [anon_sym_SLASH] = ACTIONS(1178),
    [anon_sym_PERCENT] = ACTIONS(1178),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1178),
    [anon_sym_LT_LT] = ACTIONS(1178),
    [anon_sym_GT_GT] = ACTIONS(1178),
    [anon_sym_and] = ACTIONS(1176),
    [anon_sym_or] = ACTIONS(1176),
    [anon_sym_xor] = ACTIONS(1176),
    [anon_sym_isnt] = ACTIONS(1176),
    [anon_sym_EQ_EQ] = ACTIONS(1178),
    [anon_sym_BANG_EQ] = ACTIONS(1178),
    [anon_sym_GT] = ACTIONS(1178),
    [anon_sym_GT_EQ] = ACTIONS(1178),
    [anon_sym_LT_EQ] = ACTIONS(1178),
    [anon_sym_LT] = ACTIONS(1178),
    [anon_sym_PLUS_TILDE] = ACTIONS(1176),
    [anon_sym_STAR_TILDE] = ACTIONS(1176),
    [anon_sym_SLASH_TILDE] = ACTIONS(1176),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1176),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1176),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1176),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1176),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1176),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1176),
    [anon_sym_GT_TILDE] = ACTIONS(1176),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1176),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1176),
    [anon_sym_LT_TILDE] = ACTIONS(1176),
    [anon_sym_PLUS_QMARK] = ACTIONS(1176),
    [anon_sym_DASH_QMARK] = ACTIONS(1176),
    [anon_sym_STAR_QMARK] = ACTIONS(1176),
    [anon_sym_SLASH_QMARK] = ACTIONS(1176),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1176),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1176),
    [anon_sym_as] = ACTIONS(1176),
    [anon_sym_LPAREN2] = ACTIONS(1176),
    [anon_sym_DOT_GT] = ACTIONS(1176),
    [anon_sym_where] = ACTIONS(1176),
    [anon_sym_TILDE] = ACTIONS(1176),
    [anon_sym_end] = ACTIONS(1176),
    [anon_sym_if] = ACTIONS(1178),
    [anon_sym_ifdef] = ACTIONS(1176),
    [anon_sym_iftype] = ACTIONS(1176),
    [anon_sym_else] = ACTIONS(1176),
    [anon_sym_for] = ACTIONS(1176),
    [anon_sym_while] = ACTIONS(1176),
    [anon_sym_try] = ACTIONS(1176),
    [anon_sym_with] = ACTIONS(1176),
    [anon_sym_repeat] = ACTIONS(1176),
    [anon_sym_do] = ACTIONS(1176),
    [anon_sym_recover] = ACTIONS(1176),
    [anon_sym_match] = ACTIONS(1176),
    [anon_sym_return] = ACTIONS(1176),
    [anon_sym_continue] = ACTIONS(1176),
    [anon_sym_break] = ACTIONS(1176),
    [anon_sym_consume] = ACTIONS(1176),
    [anon_sym_object] = ACTIONS(1176),
    [sym_number] = ACTIONS(1178),
    [sym_float] = ACTIONS(1176),
    [anon_sym_DQUOTE] = ACTIONS(1178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1176),
    [anon_sym_SQUOTE] = ACTIONS(1176),
    [anon_sym_true] = ACTIONS(1176),
    [anon_sym_false] = ACTIONS(1176),
    [sym_this] = ACTIONS(1176),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [260] = {
    [ts_builtin_sym_end] = ACTIONS(1180),
    [sym_identifier] = ACTIONS(1182),
    [anon_sym_use] = ACTIONS(1180),
    [anon_sym_EQ] = ACTIONS(1182),
    [anon_sym_AT] = ACTIONS(1180),
    [anon_sym_LBRACK] = ACTIONS(1180),
    [anon_sym_type] = ACTIONS(1180),
    [anon_sym_is] = ACTIONS(1182),
    [anon_sym_actor] = ACTIONS(1180),
    [anon_sym_class] = ACTIONS(1180),
    [anon_sym_primitive] = ACTIONS(1180),
    [anon_sym_interface] = ACTIONS(1180),
    [anon_sym_trait] = ACTIONS(1180),
    [anon_sym_struct] = ACTIONS(1180),
    [anon_sym_embed] = ACTIONS(1180),
    [anon_sym_let] = ACTIONS(1180),
    [anon_sym_var] = ACTIONS(1180),
    [anon_sym_new] = ACTIONS(1180),
    [anon_sym_fun] = ACTIONS(1180),
    [anon_sym_be] = ACTIONS(1180),
    [anon_sym_COMMA] = ACTIONS(1180),
    [anon_sym_LPAREN] = ACTIONS(1182),
    [anon_sym_RPAREN] = ACTIONS(1180),
    [anon_sym_DOT] = ACTIONS(1182),
    [anon_sym_LBRACE] = ACTIONS(1180),
    [anon_sym_SEMI] = ACTIONS(1180),
    [sym_error] = ACTIONS(1180),
    [sym_compile_intrinsic] = ACTIONS(1180),
    [anon_sym_compile_error] = ACTIONS(1180),
    [sym_location] = ACTIONS(1180),
    [anon_sym_DASH] = ACTIONS(1182),
    [anon_sym_not] = ACTIONS(1180),
    [anon_sym_DASH_TILDE] = ACTIONS(1180),
    [anon_sym_addressof] = ACTIONS(1180),
    [anon_sym_digestof] = ACTIONS(1180),
    [anon_sym_PLUS] = ACTIONS(1182),
    [anon_sym_STAR] = ACTIONS(1182),
    [anon_sym_SLASH] = ACTIONS(1182),
    [anon_sym_PERCENT] = ACTIONS(1182),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1182),
    [anon_sym_LT_LT] = ACTIONS(1182),
    [anon_sym_GT_GT] = ACTIONS(1182),
    [anon_sym_and] = ACTIONS(1180),
    [anon_sym_or] = ACTIONS(1180),
    [anon_sym_xor] = ACTIONS(1180),
    [anon_sym_isnt] = ACTIONS(1180),
    [anon_sym_EQ_EQ] = ACTIONS(1182),
    [anon_sym_BANG_EQ] = ACTIONS(1182),
    [anon_sym_GT] = ACTIONS(1182),
    [anon_sym_GT_EQ] = ACTIONS(1182),
    [anon_sym_LT_EQ] = ACTIONS(1182),
    [anon_sym_LT] = ACTIONS(1182),
    [anon_sym_PLUS_TILDE] = ACTIONS(1180),
    [anon_sym_STAR_TILDE] = ACTIONS(1180),
    [anon_sym_SLASH_TILDE] = ACTIONS(1180),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1180),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1180),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1180),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1180),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1180),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1180),
    [anon_sym_GT_TILDE] = ACTIONS(1180),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1180),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1180),
    [anon_sym_LT_TILDE] = ACTIONS(1180),
    [anon_sym_PLUS_QMARK] = ACTIONS(1180),
    [anon_sym_DASH_QMARK] = ACTIONS(1180),
    [anon_sym_STAR_QMARK] = ACTIONS(1180),
    [anon_sym_SLASH_QMARK] = ACTIONS(1180),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1180),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1180),
    [anon_sym_as] = ACTIONS(1180),
    [anon_sym_LPAREN2] = ACTIONS(1180),
    [anon_sym_DOT_GT] = ACTIONS(1180),
    [anon_sym_where] = ACTIONS(1180),
    [anon_sym_TILDE] = ACTIONS(1180),
    [anon_sym_end] = ACTIONS(1180),
    [anon_sym_if] = ACTIONS(1182),
    [anon_sym_ifdef] = ACTIONS(1180),
    [anon_sym_iftype] = ACTIONS(1180),
    [anon_sym_else] = ACTIONS(1180),
    [anon_sym_for] = ACTIONS(1180),
    [anon_sym_while] = ACTIONS(1180),
    [anon_sym_try] = ACTIONS(1180),
    [anon_sym_with] = ACTIONS(1180),
    [anon_sym_repeat] = ACTIONS(1180),
    [anon_sym_do] = ACTIONS(1180),
    [anon_sym_recover] = ACTIONS(1180),
    [anon_sym_match] = ACTIONS(1180),
    [anon_sym_return] = ACTIONS(1180),
    [anon_sym_continue] = ACTIONS(1180),
    [anon_sym_break] = ACTIONS(1180),
    [anon_sym_consume] = ACTIONS(1180),
    [anon_sym_object] = ACTIONS(1180),
    [sym_number] = ACTIONS(1182),
    [sym_float] = ACTIONS(1180),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1180),
    [anon_sym_SQUOTE] = ACTIONS(1180),
    [anon_sym_true] = ACTIONS(1180),
    [anon_sym_false] = ACTIONS(1180),
    [sym_this] = ACTIONS(1180),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [261] = {
    [sym_identifier] = ACTIONS(730),
    [anon_sym_EQ] = ACTIONS(730),
    [anon_sym_AT] = ACTIONS(728),
    [anon_sym_LBRACK] = ACTIONS(728),
    [anon_sym_is] = ACTIONS(730),
    [anon_sym_let] = ACTIONS(728),
    [anon_sym_var] = ACTIONS(728),
    [anon_sym_iso] = ACTIONS(728),
    [anon_sym_trn] = ACTIONS(728),
    [anon_sym_ref] = ACTIONS(728),
    [anon_sym_val] = ACTIONS(728),
    [anon_sym_box] = ACTIONS(728),
    [anon_sym_tag] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(730),
    [anon_sym_DOT] = ACTIONS(730),
    [anon_sym_POUNDread] = ACTIONS(728),
    [anon_sym_POUNDsend] = ACTIONS(728),
    [anon_sym_POUNDshare] = ACTIONS(728),
    [anon_sym_POUNDalias] = ACTIONS(728),
    [anon_sym_POUNDany] = ACTIONS(728),
    [anon_sym_BANG] = ACTIONS(730),
    [anon_sym_CARET] = ACTIONS(728),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_DASH_GT] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(728),
    [anon_sym_SEMI] = ACTIONS(728),
    [sym_error] = ACTIONS(728),
    [sym_compile_intrinsic] = ACTIONS(728),
    [anon_sym_compile_error] = ACTIONS(728),
    [sym_location] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(730),
    [anon_sym_not] = ACTIONS(728),
    [anon_sym_DASH_TILDE] = ACTIONS(728),
    [anon_sym_addressof] = ACTIONS(728),
    [anon_sym_digestof] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(730),
    [anon_sym_STAR] = ACTIONS(730),
    [anon_sym_SLASH] = ACTIONS(730),
    [anon_sym_PERCENT] = ACTIONS(730),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(730),
    [anon_sym_LT_LT] = ACTIONS(730),
    [anon_sym_GT_GT] = ACTIONS(730),
    [anon_sym_and] = ACTIONS(728),
    [anon_sym_or] = ACTIONS(728),
    [anon_sym_xor] = ACTIONS(728),
    [anon_sym_isnt] = ACTIONS(728),
    [anon_sym_EQ_EQ] = ACTIONS(730),
    [anon_sym_BANG_EQ] = ACTIONS(730),
    [anon_sym_GT] = ACTIONS(730),
    [anon_sym_GT_EQ] = ACTIONS(730),
    [anon_sym_LT_EQ] = ACTIONS(730),
    [anon_sym_LT] = ACTIONS(730),
    [anon_sym_PLUS_TILDE] = ACTIONS(728),
    [anon_sym_STAR_TILDE] = ACTIONS(728),
    [anon_sym_SLASH_TILDE] = ACTIONS(728),
    [anon_sym_PERCENT_TILDE] = ACTIONS(728),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(728),
    [anon_sym_LT_LT_TILDE] = ACTIONS(728),
    [anon_sym_GT_GT_TILDE] = ACTIONS(728),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(728),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(728),
    [anon_sym_GT_TILDE] = ACTIONS(728),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(728),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(728),
    [anon_sym_LT_TILDE] = ACTIONS(728),
    [anon_sym_PLUS_QMARK] = ACTIONS(728),
    [anon_sym_DASH_QMARK] = ACTIONS(728),
    [anon_sym_STAR_QMARK] = ACTIONS(728),
    [anon_sym_SLASH_QMARK] = ACTIONS(728),
    [anon_sym_PERCENT_QMARK] = ACTIONS(728),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(728),
    [anon_sym_as] = ACTIONS(728),
    [anon_sym_LPAREN2] = ACTIONS(728),
    [anon_sym_DOT_GT] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_end] = ACTIONS(728),
    [anon_sym_if] = ACTIONS(730),
    [anon_sym_ifdef] = ACTIONS(728),
    [anon_sym_elseif] = ACTIONS(728),
    [anon_sym_iftype] = ACTIONS(728),
    [anon_sym_else] = ACTIONS(730),
    [anon_sym_for] = ACTIONS(728),
    [anon_sym_while] = ACTIONS(728),
    [anon_sym_try] = ACTIONS(728),
    [anon_sym_with] = ACTIONS(728),
    [anon_sym_repeat] = ACTIONS(728),
    [anon_sym_recover] = ACTIONS(728),
    [anon_sym_match] = ACTIONS(728),
    [anon_sym_return] = ACTIONS(728),
    [anon_sym_continue] = ACTIONS(728),
    [anon_sym_break] = ACTIONS(728),
    [anon_sym_consume] = ACTIONS(728),
    [anon_sym_object] = ACTIONS(728),
    [sym_number] = ACTIONS(730),
    [sym_float] = ACTIONS(728),
    [anon_sym_DQUOTE] = ACTIONS(730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(728),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_true] = ACTIONS(728),
    [anon_sym_false] = ACTIONS(728),
    [sym_this] = ACTIONS(728),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [262] = {
    [ts_builtin_sym_end] = ACTIONS(1184),
    [sym_identifier] = ACTIONS(1186),
    [anon_sym_use] = ACTIONS(1184),
    [anon_sym_EQ] = ACTIONS(1186),
    [anon_sym_AT] = ACTIONS(1184),
    [anon_sym_LBRACK] = ACTIONS(1184),
    [anon_sym_type] = ACTIONS(1184),
    [anon_sym_is] = ACTIONS(1186),
    [anon_sym_actor] = ACTIONS(1184),
    [anon_sym_class] = ACTIONS(1184),
    [anon_sym_primitive] = ACTIONS(1184),
    [anon_sym_interface] = ACTIONS(1184),
    [anon_sym_trait] = ACTIONS(1184),
    [anon_sym_struct] = ACTIONS(1184),
    [anon_sym_embed] = ACTIONS(1184),
    [anon_sym_let] = ACTIONS(1184),
    [anon_sym_var] = ACTIONS(1184),
    [anon_sym_new] = ACTIONS(1184),
    [anon_sym_fun] = ACTIONS(1184),
    [anon_sym_be] = ACTIONS(1184),
    [anon_sym_COMMA] = ACTIONS(1184),
    [anon_sym_LPAREN] = ACTIONS(1186),
    [anon_sym_RPAREN] = ACTIONS(1184),
    [anon_sym_DOT] = ACTIONS(1186),
    [anon_sym_LBRACE] = ACTIONS(1184),
    [anon_sym_SEMI] = ACTIONS(1184),
    [sym_error] = ACTIONS(1184),
    [sym_compile_intrinsic] = ACTIONS(1184),
    [anon_sym_compile_error] = ACTIONS(1184),
    [sym_location] = ACTIONS(1184),
    [anon_sym_DASH] = ACTIONS(1186),
    [anon_sym_not] = ACTIONS(1184),
    [anon_sym_DASH_TILDE] = ACTIONS(1184),
    [anon_sym_addressof] = ACTIONS(1184),
    [anon_sym_digestof] = ACTIONS(1184),
    [anon_sym_PLUS] = ACTIONS(1186),
    [anon_sym_STAR] = ACTIONS(1186),
    [anon_sym_SLASH] = ACTIONS(1186),
    [anon_sym_PERCENT] = ACTIONS(1186),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1186),
    [anon_sym_LT_LT] = ACTIONS(1186),
    [anon_sym_GT_GT] = ACTIONS(1186),
    [anon_sym_and] = ACTIONS(1184),
    [anon_sym_or] = ACTIONS(1184),
    [anon_sym_xor] = ACTIONS(1184),
    [anon_sym_isnt] = ACTIONS(1184),
    [anon_sym_EQ_EQ] = ACTIONS(1186),
    [anon_sym_BANG_EQ] = ACTIONS(1186),
    [anon_sym_GT] = ACTIONS(1186),
    [anon_sym_GT_EQ] = ACTIONS(1186),
    [anon_sym_LT_EQ] = ACTIONS(1186),
    [anon_sym_LT] = ACTIONS(1186),
    [anon_sym_PLUS_TILDE] = ACTIONS(1184),
    [anon_sym_STAR_TILDE] = ACTIONS(1184),
    [anon_sym_SLASH_TILDE] = ACTIONS(1184),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1184),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1184),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1184),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1184),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1184),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1184),
    [anon_sym_GT_TILDE] = ACTIONS(1184),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1184),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1184),
    [anon_sym_LT_TILDE] = ACTIONS(1184),
    [anon_sym_PLUS_QMARK] = ACTIONS(1184),
    [anon_sym_DASH_QMARK] = ACTIONS(1184),
    [anon_sym_STAR_QMARK] = ACTIONS(1184),
    [anon_sym_SLASH_QMARK] = ACTIONS(1184),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1184),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1184),
    [anon_sym_as] = ACTIONS(1184),
    [anon_sym_LPAREN2] = ACTIONS(1184),
    [anon_sym_DOT_GT] = ACTIONS(1184),
    [anon_sym_where] = ACTIONS(1184),
    [anon_sym_TILDE] = ACTIONS(1184),
    [anon_sym_end] = ACTIONS(1184),
    [anon_sym_if] = ACTIONS(1186),
    [anon_sym_ifdef] = ACTIONS(1184),
    [anon_sym_iftype] = ACTIONS(1184),
    [anon_sym_else] = ACTIONS(1184),
    [anon_sym_for] = ACTIONS(1184),
    [anon_sym_while] = ACTIONS(1184),
    [anon_sym_try] = ACTIONS(1184),
    [anon_sym_with] = ACTIONS(1184),
    [anon_sym_repeat] = ACTIONS(1184),
    [anon_sym_do] = ACTIONS(1184),
    [anon_sym_recover] = ACTIONS(1184),
    [anon_sym_match] = ACTIONS(1184),
    [anon_sym_return] = ACTIONS(1184),
    [anon_sym_continue] = ACTIONS(1184),
    [anon_sym_break] = ACTIONS(1184),
    [anon_sym_consume] = ACTIONS(1184),
    [anon_sym_object] = ACTIONS(1184),
    [sym_number] = ACTIONS(1186),
    [sym_float] = ACTIONS(1184),
    [anon_sym_DQUOTE] = ACTIONS(1186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1184),
    [anon_sym_SQUOTE] = ACTIONS(1184),
    [anon_sym_true] = ACTIONS(1184),
    [anon_sym_false] = ACTIONS(1184),
    [sym_this] = ACTIONS(1184),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [263] = {
    [ts_builtin_sym_end] = ACTIONS(841),
    [sym_identifier] = ACTIONS(843),
    [anon_sym_use] = ACTIONS(841),
    [anon_sym_EQ] = ACTIONS(843),
    [anon_sym_AT] = ACTIONS(841),
    [anon_sym_LBRACK] = ACTIONS(841),
    [anon_sym_type] = ACTIONS(841),
    [anon_sym_is] = ACTIONS(843),
    [anon_sym_actor] = ACTIONS(841),
    [anon_sym_class] = ACTIONS(841),
    [anon_sym_primitive] = ACTIONS(841),
    [anon_sym_interface] = ACTIONS(841),
    [anon_sym_trait] = ACTIONS(841),
    [anon_sym_struct] = ACTIONS(841),
    [anon_sym_embed] = ACTIONS(841),
    [anon_sym_let] = ACTIONS(841),
    [anon_sym_var] = ACTIONS(841),
    [anon_sym_new] = ACTIONS(841),
    [anon_sym_fun] = ACTIONS(841),
    [anon_sym_be] = ACTIONS(841),
    [anon_sym_COMMA] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_RPAREN] = ACTIONS(841),
    [anon_sym_DOT] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(841),
    [anon_sym_SEMI] = ACTIONS(841),
    [sym_error] = ACTIONS(841),
    [sym_compile_intrinsic] = ACTIONS(841),
    [anon_sym_compile_error] = ACTIONS(841),
    [sym_location] = ACTIONS(841),
    [anon_sym_DASH] = ACTIONS(843),
    [anon_sym_not] = ACTIONS(841),
    [anon_sym_DASH_TILDE] = ACTIONS(841),
    [anon_sym_addressof] = ACTIONS(841),
    [anon_sym_digestof] = ACTIONS(841),
    [anon_sym_PLUS] = ACTIONS(843),
    [anon_sym_STAR] = ACTIONS(843),
    [anon_sym_SLASH] = ACTIONS(843),
    [anon_sym_PERCENT] = ACTIONS(843),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(843),
    [anon_sym_LT_LT] = ACTIONS(843),
    [anon_sym_GT_GT] = ACTIONS(843),
    [anon_sym_and] = ACTIONS(841),
    [anon_sym_or] = ACTIONS(841),
    [anon_sym_xor] = ACTIONS(841),
    [anon_sym_isnt] = ACTIONS(841),
    [anon_sym_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(843),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_PLUS_TILDE] = ACTIONS(841),
    [anon_sym_STAR_TILDE] = ACTIONS(841),
    [anon_sym_SLASH_TILDE] = ACTIONS(841),
    [anon_sym_PERCENT_TILDE] = ACTIONS(841),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(841),
    [anon_sym_LT_LT_TILDE] = ACTIONS(841),
    [anon_sym_GT_GT_TILDE] = ACTIONS(841),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(841),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(841),
    [anon_sym_GT_TILDE] = ACTIONS(841),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(841),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(841),
    [anon_sym_LT_TILDE] = ACTIONS(841),
    [anon_sym_PLUS_QMARK] = ACTIONS(841),
    [anon_sym_DASH_QMARK] = ACTIONS(841),
    [anon_sym_STAR_QMARK] = ACTIONS(841),
    [anon_sym_SLASH_QMARK] = ACTIONS(841),
    [anon_sym_PERCENT_QMARK] = ACTIONS(841),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(841),
    [anon_sym_as] = ACTIONS(841),
    [anon_sym_LPAREN2] = ACTIONS(841),
    [anon_sym_DOT_GT] = ACTIONS(841),
    [anon_sym_where] = ACTIONS(841),
    [anon_sym_TILDE] = ACTIONS(841),
    [anon_sym_end] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_ifdef] = ACTIONS(841),
    [anon_sym_iftype] = ACTIONS(841),
    [anon_sym_else] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(841),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_with] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(841),
    [anon_sym_do] = ACTIONS(841),
    [anon_sym_recover] = ACTIONS(841),
    [anon_sym_match] = ACTIONS(841),
    [anon_sym_return] = ACTIONS(841),
    [anon_sym_continue] = ACTIONS(841),
    [anon_sym_break] = ACTIONS(841),
    [anon_sym_consume] = ACTIONS(841),
    [anon_sym_object] = ACTIONS(841),
    [sym_number] = ACTIONS(843),
    [sym_float] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(843),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(841),
    [anon_sym_SQUOTE] = ACTIONS(841),
    [anon_sym_true] = ACTIONS(841),
    [anon_sym_false] = ACTIONS(841),
    [sym_this] = ACTIONS(841),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [264] = {
    [ts_builtin_sym_end] = ACTIONS(1188),
    [sym_identifier] = ACTIONS(1190),
    [anon_sym_use] = ACTIONS(1188),
    [anon_sym_EQ] = ACTIONS(1190),
    [anon_sym_AT] = ACTIONS(1188),
    [anon_sym_LBRACK] = ACTIONS(1188),
    [anon_sym_type] = ACTIONS(1188),
    [anon_sym_is] = ACTIONS(1190),
    [anon_sym_actor] = ACTIONS(1188),
    [anon_sym_class] = ACTIONS(1188),
    [anon_sym_primitive] = ACTIONS(1188),
    [anon_sym_interface] = ACTIONS(1188),
    [anon_sym_trait] = ACTIONS(1188),
    [anon_sym_struct] = ACTIONS(1188),
    [anon_sym_embed] = ACTIONS(1188),
    [anon_sym_let] = ACTIONS(1188),
    [anon_sym_var] = ACTIONS(1188),
    [anon_sym_new] = ACTIONS(1188),
    [anon_sym_fun] = ACTIONS(1188),
    [anon_sym_be] = ACTIONS(1188),
    [anon_sym_COMMA] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1190),
    [anon_sym_RPAREN] = ACTIONS(1188),
    [anon_sym_DOT] = ACTIONS(1190),
    [anon_sym_LBRACE] = ACTIONS(1188),
    [anon_sym_SEMI] = ACTIONS(1188),
    [sym_error] = ACTIONS(1188),
    [sym_compile_intrinsic] = ACTIONS(1188),
    [anon_sym_compile_error] = ACTIONS(1188),
    [sym_location] = ACTIONS(1188),
    [anon_sym_DASH] = ACTIONS(1190),
    [anon_sym_not] = ACTIONS(1188),
    [anon_sym_DASH_TILDE] = ACTIONS(1188),
    [anon_sym_addressof] = ACTIONS(1188),
    [anon_sym_digestof] = ACTIONS(1188),
    [anon_sym_PLUS] = ACTIONS(1190),
    [anon_sym_STAR] = ACTIONS(1190),
    [anon_sym_SLASH] = ACTIONS(1190),
    [anon_sym_PERCENT] = ACTIONS(1190),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1190),
    [anon_sym_LT_LT] = ACTIONS(1190),
    [anon_sym_GT_GT] = ACTIONS(1190),
    [anon_sym_and] = ACTIONS(1188),
    [anon_sym_or] = ACTIONS(1188),
    [anon_sym_xor] = ACTIONS(1188),
    [anon_sym_isnt] = ACTIONS(1188),
    [anon_sym_EQ_EQ] = ACTIONS(1190),
    [anon_sym_BANG_EQ] = ACTIONS(1190),
    [anon_sym_GT] = ACTIONS(1190),
    [anon_sym_GT_EQ] = ACTIONS(1190),
    [anon_sym_LT_EQ] = ACTIONS(1190),
    [anon_sym_LT] = ACTIONS(1190),
    [anon_sym_PLUS_TILDE] = ACTIONS(1188),
    [anon_sym_STAR_TILDE] = ACTIONS(1188),
    [anon_sym_SLASH_TILDE] = ACTIONS(1188),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1188),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1188),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1188),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1188),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1188),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1188),
    [anon_sym_GT_TILDE] = ACTIONS(1188),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1188),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1188),
    [anon_sym_LT_TILDE] = ACTIONS(1188),
    [anon_sym_PLUS_QMARK] = ACTIONS(1188),
    [anon_sym_DASH_QMARK] = ACTIONS(1188),
    [anon_sym_STAR_QMARK] = ACTIONS(1188),
    [anon_sym_SLASH_QMARK] = ACTIONS(1188),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1188),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1188),
    [anon_sym_as] = ACTIONS(1188),
    [anon_sym_LPAREN2] = ACTIONS(1188),
    [anon_sym_DOT_GT] = ACTIONS(1188),
    [anon_sym_where] = ACTIONS(1188),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_end] = ACTIONS(1188),
    [anon_sym_if] = ACTIONS(1190),
    [anon_sym_ifdef] = ACTIONS(1188),
    [anon_sym_iftype] = ACTIONS(1188),
    [anon_sym_else] = ACTIONS(1188),
    [anon_sym_for] = ACTIONS(1188),
    [anon_sym_while] = ACTIONS(1188),
    [anon_sym_try] = ACTIONS(1188),
    [anon_sym_with] = ACTIONS(1188),
    [anon_sym_repeat] = ACTIONS(1188),
    [anon_sym_do] = ACTIONS(1188),
    [anon_sym_recover] = ACTIONS(1188),
    [anon_sym_match] = ACTIONS(1188),
    [anon_sym_return] = ACTIONS(1188),
    [anon_sym_continue] = ACTIONS(1188),
    [anon_sym_break] = ACTIONS(1188),
    [anon_sym_consume] = ACTIONS(1188),
    [anon_sym_object] = ACTIONS(1188),
    [sym_number] = ACTIONS(1190),
    [sym_float] = ACTIONS(1188),
    [anon_sym_DQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1188),
    [anon_sym_true] = ACTIONS(1188),
    [anon_sym_false] = ACTIONS(1188),
    [sym_this] = ACTIONS(1188),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [265] = {
    [ts_builtin_sym_end] = ACTIONS(666),
    [sym_identifier] = ACTIONS(668),
    [anon_sym_use] = ACTIONS(666),
    [anon_sym_EQ] = ACTIONS(668),
    [anon_sym_AT] = ACTIONS(666),
    [anon_sym_LBRACK] = ACTIONS(666),
    [anon_sym_type] = ACTIONS(666),
    [anon_sym_is] = ACTIONS(668),
    [anon_sym_actor] = ACTIONS(666),
    [anon_sym_class] = ACTIONS(666),
    [anon_sym_primitive] = ACTIONS(666),
    [anon_sym_interface] = ACTIONS(666),
    [anon_sym_trait] = ACTIONS(666),
    [anon_sym_struct] = ACTIONS(666),
    [anon_sym_embed] = ACTIONS(666),
    [anon_sym_let] = ACTIONS(666),
    [anon_sym_var] = ACTIONS(666),
    [anon_sym_new] = ACTIONS(666),
    [anon_sym_fun] = ACTIONS(666),
    [anon_sym_be] = ACTIONS(666),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(668),
    [anon_sym_RPAREN] = ACTIONS(666),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(666),
    [sym_error] = ACTIONS(666),
    [sym_compile_intrinsic] = ACTIONS(666),
    [anon_sym_compile_error] = ACTIONS(666),
    [sym_location] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(668),
    [anon_sym_not] = ACTIONS(666),
    [anon_sym_DASH_TILDE] = ACTIONS(666),
    [anon_sym_addressof] = ACTIONS(666),
    [anon_sym_digestof] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(668),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(668),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(668),
    [anon_sym_LT_LT] = ACTIONS(668),
    [anon_sym_GT_GT] = ACTIONS(668),
    [anon_sym_and] = ACTIONS(666),
    [anon_sym_or] = ACTIONS(666),
    [anon_sym_xor] = ACTIONS(666),
    [anon_sym_isnt] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(668),
    [anon_sym_BANG_EQ] = ACTIONS(668),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_GT_EQ] = ACTIONS(668),
    [anon_sym_LT_EQ] = ACTIONS(668),
    [anon_sym_LT] = ACTIONS(668),
    [anon_sym_PLUS_TILDE] = ACTIONS(666),
    [anon_sym_STAR_TILDE] = ACTIONS(666),
    [anon_sym_SLASH_TILDE] = ACTIONS(666),
    [anon_sym_PERCENT_TILDE] = ACTIONS(666),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(666),
    [anon_sym_LT_LT_TILDE] = ACTIONS(666),
    [anon_sym_GT_GT_TILDE] = ACTIONS(666),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(666),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(666),
    [anon_sym_GT_TILDE] = ACTIONS(666),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(666),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(666),
    [anon_sym_LT_TILDE] = ACTIONS(666),
    [anon_sym_PLUS_QMARK] = ACTIONS(666),
    [anon_sym_DASH_QMARK] = ACTIONS(666),
    [anon_sym_STAR_QMARK] = ACTIONS(666),
    [anon_sym_SLASH_QMARK] = ACTIONS(666),
    [anon_sym_PERCENT_QMARK] = ACTIONS(666),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(666),
    [anon_sym_LPAREN2] = ACTIONS(666),
    [anon_sym_DOT_GT] = ACTIONS(666),
    [anon_sym_where] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_end] = ACTIONS(666),
    [anon_sym_if] = ACTIONS(668),
    [anon_sym_ifdef] = ACTIONS(666),
    [anon_sym_iftype] = ACTIONS(666),
    [anon_sym_else] = ACTIONS(666),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_while] = ACTIONS(666),
    [anon_sym_try] = ACTIONS(666),
    [anon_sym_with] = ACTIONS(666),
    [anon_sym_repeat] = ACTIONS(666),
    [anon_sym_do] = ACTIONS(666),
    [anon_sym_recover] = ACTIONS(666),
    [anon_sym_match] = ACTIONS(666),
    [anon_sym_return] = ACTIONS(666),
    [anon_sym_continue] = ACTIONS(666),
    [anon_sym_break] = ACTIONS(666),
    [anon_sym_consume] = ACTIONS(666),
    [anon_sym_object] = ACTIONS(666),
    [sym_number] = ACTIONS(668),
    [sym_float] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(666),
    [anon_sym_SQUOTE] = ACTIONS(666),
    [anon_sym_true] = ACTIONS(666),
    [anon_sym_false] = ACTIONS(666),
    [sym_this] = ACTIONS(666),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [266] = {
    [ts_builtin_sym_end] = ACTIONS(1192),
    [sym_identifier] = ACTIONS(1194),
    [anon_sym_use] = ACTIONS(1192),
    [anon_sym_EQ] = ACTIONS(1194),
    [anon_sym_AT] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1192),
    [anon_sym_type] = ACTIONS(1192),
    [anon_sym_is] = ACTIONS(1194),
    [anon_sym_actor] = ACTIONS(1192),
    [anon_sym_class] = ACTIONS(1192),
    [anon_sym_primitive] = ACTIONS(1192),
    [anon_sym_interface] = ACTIONS(1192),
    [anon_sym_trait] = ACTIONS(1192),
    [anon_sym_struct] = ACTIONS(1192),
    [anon_sym_embed] = ACTIONS(1192),
    [anon_sym_let] = ACTIONS(1192),
    [anon_sym_var] = ACTIONS(1192),
    [anon_sym_new] = ACTIONS(1192),
    [anon_sym_fun] = ACTIONS(1192),
    [anon_sym_be] = ACTIONS(1192),
    [anon_sym_COMMA] = ACTIONS(1192),
    [anon_sym_LPAREN] = ACTIONS(1194),
    [anon_sym_RPAREN] = ACTIONS(1192),
    [anon_sym_DOT] = ACTIONS(1194),
    [anon_sym_LBRACE] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1192),
    [sym_error] = ACTIONS(1192),
    [sym_compile_intrinsic] = ACTIONS(1192),
    [anon_sym_compile_error] = ACTIONS(1192),
    [sym_location] = ACTIONS(1192),
    [anon_sym_DASH] = ACTIONS(1194),
    [anon_sym_not] = ACTIONS(1192),
    [anon_sym_DASH_TILDE] = ACTIONS(1192),
    [anon_sym_addressof] = ACTIONS(1192),
    [anon_sym_digestof] = ACTIONS(1192),
    [anon_sym_PLUS] = ACTIONS(1194),
    [anon_sym_STAR] = ACTIONS(1194),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_PERCENT] = ACTIONS(1194),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1194),
    [anon_sym_LT_LT] = ACTIONS(1194),
    [anon_sym_GT_GT] = ACTIONS(1194),
    [anon_sym_and] = ACTIONS(1192),
    [anon_sym_or] = ACTIONS(1192),
    [anon_sym_xor] = ACTIONS(1192),
    [anon_sym_isnt] = ACTIONS(1192),
    [anon_sym_EQ_EQ] = ACTIONS(1194),
    [anon_sym_BANG_EQ] = ACTIONS(1194),
    [anon_sym_GT] = ACTIONS(1194),
    [anon_sym_GT_EQ] = ACTIONS(1194),
    [anon_sym_LT_EQ] = ACTIONS(1194),
    [anon_sym_LT] = ACTIONS(1194),
    [anon_sym_PLUS_TILDE] = ACTIONS(1192),
    [anon_sym_STAR_TILDE] = ACTIONS(1192),
    [anon_sym_SLASH_TILDE] = ACTIONS(1192),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1192),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1192),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1192),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1192),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1192),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1192),
    [anon_sym_GT_TILDE] = ACTIONS(1192),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1192),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1192),
    [anon_sym_LT_TILDE] = ACTIONS(1192),
    [anon_sym_PLUS_QMARK] = ACTIONS(1192),
    [anon_sym_DASH_QMARK] = ACTIONS(1192),
    [anon_sym_STAR_QMARK] = ACTIONS(1192),
    [anon_sym_SLASH_QMARK] = ACTIONS(1192),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1192),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1192),
    [anon_sym_as] = ACTIONS(1192),
    [anon_sym_LPAREN2] = ACTIONS(1192),
    [anon_sym_DOT_GT] = ACTIONS(1192),
    [anon_sym_where] = ACTIONS(1192),
    [anon_sym_TILDE] = ACTIONS(1192),
    [anon_sym_end] = ACTIONS(1192),
    [anon_sym_if] = ACTIONS(1194),
    [anon_sym_ifdef] = ACTIONS(1192),
    [anon_sym_iftype] = ACTIONS(1192),
    [anon_sym_else] = ACTIONS(1192),
    [anon_sym_for] = ACTIONS(1192),
    [anon_sym_while] = ACTIONS(1192),
    [anon_sym_try] = ACTIONS(1192),
    [anon_sym_with] = ACTIONS(1192),
    [anon_sym_repeat] = ACTIONS(1192),
    [anon_sym_do] = ACTIONS(1192),
    [anon_sym_recover] = ACTIONS(1192),
    [anon_sym_match] = ACTIONS(1192),
    [anon_sym_return] = ACTIONS(1192),
    [anon_sym_continue] = ACTIONS(1192),
    [anon_sym_break] = ACTIONS(1192),
    [anon_sym_consume] = ACTIONS(1192),
    [anon_sym_object] = ACTIONS(1192),
    [sym_number] = ACTIONS(1194),
    [sym_float] = ACTIONS(1192),
    [anon_sym_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1192),
    [anon_sym_SQUOTE] = ACTIONS(1192),
    [anon_sym_true] = ACTIONS(1192),
    [anon_sym_false] = ACTIONS(1192),
    [sym_this] = ACTIONS(1192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [267] = {
    [ts_builtin_sym_end] = ACTIONS(1196),
    [sym_identifier] = ACTIONS(1198),
    [anon_sym_use] = ACTIONS(1196),
    [anon_sym_EQ] = ACTIONS(1198),
    [anon_sym_AT] = ACTIONS(1196),
    [anon_sym_LBRACK] = ACTIONS(1196),
    [anon_sym_type] = ACTIONS(1196),
    [anon_sym_is] = ACTIONS(1198),
    [anon_sym_actor] = ACTIONS(1196),
    [anon_sym_class] = ACTIONS(1196),
    [anon_sym_primitive] = ACTIONS(1196),
    [anon_sym_interface] = ACTIONS(1196),
    [anon_sym_trait] = ACTIONS(1196),
    [anon_sym_struct] = ACTIONS(1196),
    [anon_sym_embed] = ACTIONS(1196),
    [anon_sym_let] = ACTIONS(1196),
    [anon_sym_var] = ACTIONS(1196),
    [anon_sym_new] = ACTIONS(1196),
    [anon_sym_fun] = ACTIONS(1196),
    [anon_sym_be] = ACTIONS(1196),
    [anon_sym_COMMA] = ACTIONS(1196),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_RPAREN] = ACTIONS(1196),
    [anon_sym_DOT] = ACTIONS(1198),
    [anon_sym_LBRACE] = ACTIONS(1196),
    [anon_sym_SEMI] = ACTIONS(1196),
    [sym_error] = ACTIONS(1196),
    [sym_compile_intrinsic] = ACTIONS(1196),
    [anon_sym_compile_error] = ACTIONS(1196),
    [sym_location] = ACTIONS(1196),
    [anon_sym_DASH] = ACTIONS(1198),
    [anon_sym_not] = ACTIONS(1196),
    [anon_sym_DASH_TILDE] = ACTIONS(1196),
    [anon_sym_addressof] = ACTIONS(1196),
    [anon_sym_digestof] = ACTIONS(1196),
    [anon_sym_PLUS] = ACTIONS(1198),
    [anon_sym_STAR] = ACTIONS(1198),
    [anon_sym_SLASH] = ACTIONS(1198),
    [anon_sym_PERCENT] = ACTIONS(1198),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1198),
    [anon_sym_LT_LT] = ACTIONS(1198),
    [anon_sym_GT_GT] = ACTIONS(1198),
    [anon_sym_and] = ACTIONS(1196),
    [anon_sym_or] = ACTIONS(1196),
    [anon_sym_xor] = ACTIONS(1196),
    [anon_sym_isnt] = ACTIONS(1196),
    [anon_sym_EQ_EQ] = ACTIONS(1198),
    [anon_sym_BANG_EQ] = ACTIONS(1198),
    [anon_sym_GT] = ACTIONS(1198),
    [anon_sym_GT_EQ] = ACTIONS(1198),
    [anon_sym_LT_EQ] = ACTIONS(1198),
    [anon_sym_LT] = ACTIONS(1198),
    [anon_sym_PLUS_TILDE] = ACTIONS(1196),
    [anon_sym_STAR_TILDE] = ACTIONS(1196),
    [anon_sym_SLASH_TILDE] = ACTIONS(1196),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1196),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1196),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1196),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1196),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1196),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1196),
    [anon_sym_GT_TILDE] = ACTIONS(1196),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1196),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1196),
    [anon_sym_LT_TILDE] = ACTIONS(1196),
    [anon_sym_PLUS_QMARK] = ACTIONS(1196),
    [anon_sym_DASH_QMARK] = ACTIONS(1196),
    [anon_sym_STAR_QMARK] = ACTIONS(1196),
    [anon_sym_SLASH_QMARK] = ACTIONS(1196),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1196),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1196),
    [anon_sym_as] = ACTIONS(1196),
    [anon_sym_LPAREN2] = ACTIONS(1196),
    [anon_sym_DOT_GT] = ACTIONS(1196),
    [anon_sym_where] = ACTIONS(1196),
    [anon_sym_TILDE] = ACTIONS(1196),
    [anon_sym_end] = ACTIONS(1196),
    [anon_sym_if] = ACTIONS(1198),
    [anon_sym_ifdef] = ACTIONS(1196),
    [anon_sym_iftype] = ACTIONS(1196),
    [anon_sym_else] = ACTIONS(1196),
    [anon_sym_for] = ACTIONS(1196),
    [anon_sym_while] = ACTIONS(1196),
    [anon_sym_try] = ACTIONS(1196),
    [anon_sym_with] = ACTIONS(1196),
    [anon_sym_repeat] = ACTIONS(1196),
    [anon_sym_do] = ACTIONS(1196),
    [anon_sym_recover] = ACTIONS(1196),
    [anon_sym_match] = ACTIONS(1196),
    [anon_sym_return] = ACTIONS(1196),
    [anon_sym_continue] = ACTIONS(1196),
    [anon_sym_break] = ACTIONS(1196),
    [anon_sym_consume] = ACTIONS(1196),
    [anon_sym_object] = ACTIONS(1196),
    [sym_number] = ACTIONS(1198),
    [sym_float] = ACTIONS(1196),
    [anon_sym_DQUOTE] = ACTIONS(1198),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_SQUOTE] = ACTIONS(1196),
    [anon_sym_true] = ACTIONS(1196),
    [anon_sym_false] = ACTIONS(1196),
    [sym_this] = ACTIONS(1196),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [268] = {
    [ts_builtin_sym_end] = ACTIONS(1200),
    [sym_identifier] = ACTIONS(1202),
    [anon_sym_use] = ACTIONS(1200),
    [anon_sym_EQ] = ACTIONS(1202),
    [anon_sym_AT] = ACTIONS(1200),
    [anon_sym_LBRACK] = ACTIONS(1200),
    [anon_sym_type] = ACTIONS(1200),
    [anon_sym_is] = ACTIONS(1202),
    [anon_sym_actor] = ACTIONS(1200),
    [anon_sym_class] = ACTIONS(1200),
    [anon_sym_primitive] = ACTIONS(1200),
    [anon_sym_interface] = ACTIONS(1200),
    [anon_sym_trait] = ACTIONS(1200),
    [anon_sym_struct] = ACTIONS(1200),
    [anon_sym_embed] = ACTIONS(1200),
    [anon_sym_let] = ACTIONS(1200),
    [anon_sym_var] = ACTIONS(1200),
    [anon_sym_new] = ACTIONS(1200),
    [anon_sym_fun] = ACTIONS(1200),
    [anon_sym_be] = ACTIONS(1200),
    [anon_sym_COMMA] = ACTIONS(1200),
    [anon_sym_LPAREN] = ACTIONS(1202),
    [anon_sym_RPAREN] = ACTIONS(1200),
    [anon_sym_DOT] = ACTIONS(1202),
    [anon_sym_LBRACE] = ACTIONS(1200),
    [anon_sym_SEMI] = ACTIONS(1200),
    [sym_error] = ACTIONS(1200),
    [sym_compile_intrinsic] = ACTIONS(1200),
    [anon_sym_compile_error] = ACTIONS(1200),
    [sym_location] = ACTIONS(1200),
    [anon_sym_DASH] = ACTIONS(1202),
    [anon_sym_not] = ACTIONS(1200),
    [anon_sym_DASH_TILDE] = ACTIONS(1200),
    [anon_sym_addressof] = ACTIONS(1200),
    [anon_sym_digestof] = ACTIONS(1200),
    [anon_sym_PLUS] = ACTIONS(1202),
    [anon_sym_STAR] = ACTIONS(1202),
    [anon_sym_SLASH] = ACTIONS(1202),
    [anon_sym_PERCENT] = ACTIONS(1202),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1202),
    [anon_sym_LT_LT] = ACTIONS(1202),
    [anon_sym_GT_GT] = ACTIONS(1202),
    [anon_sym_and] = ACTIONS(1200),
    [anon_sym_or] = ACTIONS(1200),
    [anon_sym_xor] = ACTIONS(1200),
    [anon_sym_isnt] = ACTIONS(1200),
    [anon_sym_EQ_EQ] = ACTIONS(1202),
    [anon_sym_BANG_EQ] = ACTIONS(1202),
    [anon_sym_GT] = ACTIONS(1202),
    [anon_sym_GT_EQ] = ACTIONS(1202),
    [anon_sym_LT_EQ] = ACTIONS(1202),
    [anon_sym_LT] = ACTIONS(1202),
    [anon_sym_PLUS_TILDE] = ACTIONS(1200),
    [anon_sym_STAR_TILDE] = ACTIONS(1200),
    [anon_sym_SLASH_TILDE] = ACTIONS(1200),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1200),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1200),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1200),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1200),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1200),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1200),
    [anon_sym_GT_TILDE] = ACTIONS(1200),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1200),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1200),
    [anon_sym_LT_TILDE] = ACTIONS(1200),
    [anon_sym_PLUS_QMARK] = ACTIONS(1200),
    [anon_sym_DASH_QMARK] = ACTIONS(1200),
    [anon_sym_STAR_QMARK] = ACTIONS(1200),
    [anon_sym_SLASH_QMARK] = ACTIONS(1200),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1200),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1200),
    [anon_sym_as] = ACTIONS(1200),
    [anon_sym_LPAREN2] = ACTIONS(1200),
    [anon_sym_DOT_GT] = ACTIONS(1200),
    [anon_sym_where] = ACTIONS(1200),
    [anon_sym_TILDE] = ACTIONS(1200),
    [anon_sym_end] = ACTIONS(1200),
    [anon_sym_if] = ACTIONS(1202),
    [anon_sym_ifdef] = ACTIONS(1200),
    [anon_sym_iftype] = ACTIONS(1200),
    [anon_sym_else] = ACTIONS(1200),
    [anon_sym_for] = ACTIONS(1200),
    [anon_sym_while] = ACTIONS(1200),
    [anon_sym_try] = ACTIONS(1200),
    [anon_sym_with] = ACTIONS(1200),
    [anon_sym_repeat] = ACTIONS(1200),
    [anon_sym_do] = ACTIONS(1200),
    [anon_sym_recover] = ACTIONS(1200),
    [anon_sym_match] = ACTIONS(1200),
    [anon_sym_return] = ACTIONS(1200),
    [anon_sym_continue] = ACTIONS(1200),
    [anon_sym_break] = ACTIONS(1200),
    [anon_sym_consume] = ACTIONS(1200),
    [anon_sym_object] = ACTIONS(1200),
    [sym_number] = ACTIONS(1202),
    [sym_float] = ACTIONS(1200),
    [anon_sym_DQUOTE] = ACTIONS(1202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1200),
    [anon_sym_SQUOTE] = ACTIONS(1200),
    [anon_sym_true] = ACTIONS(1200),
    [anon_sym_false] = ACTIONS(1200),
    [sym_this] = ACTIONS(1200),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [269] = {
    [ts_builtin_sym_end] = ACTIONS(1204),
    [sym_identifier] = ACTIONS(1206),
    [anon_sym_use] = ACTIONS(1204),
    [anon_sym_EQ] = ACTIONS(1206),
    [anon_sym_AT] = ACTIONS(1204),
    [anon_sym_LBRACK] = ACTIONS(1204),
    [anon_sym_type] = ACTIONS(1204),
    [anon_sym_is] = ACTIONS(1206),
    [anon_sym_actor] = ACTIONS(1204),
    [anon_sym_class] = ACTIONS(1204),
    [anon_sym_primitive] = ACTIONS(1204),
    [anon_sym_interface] = ACTIONS(1204),
    [anon_sym_trait] = ACTIONS(1204),
    [anon_sym_struct] = ACTIONS(1204),
    [anon_sym_embed] = ACTIONS(1204),
    [anon_sym_let] = ACTIONS(1204),
    [anon_sym_var] = ACTIONS(1204),
    [anon_sym_new] = ACTIONS(1204),
    [anon_sym_fun] = ACTIONS(1204),
    [anon_sym_be] = ACTIONS(1204),
    [anon_sym_COMMA] = ACTIONS(1204),
    [anon_sym_LPAREN] = ACTIONS(1206),
    [anon_sym_RPAREN] = ACTIONS(1204),
    [anon_sym_DOT] = ACTIONS(1206),
    [anon_sym_LBRACE] = ACTIONS(1204),
    [anon_sym_SEMI] = ACTIONS(1204),
    [sym_error] = ACTIONS(1204),
    [sym_compile_intrinsic] = ACTIONS(1204),
    [anon_sym_compile_error] = ACTIONS(1204),
    [sym_location] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1206),
    [anon_sym_not] = ACTIONS(1204),
    [anon_sym_DASH_TILDE] = ACTIONS(1204),
    [anon_sym_addressof] = ACTIONS(1204),
    [anon_sym_digestof] = ACTIONS(1204),
    [anon_sym_PLUS] = ACTIONS(1206),
    [anon_sym_STAR] = ACTIONS(1206),
    [anon_sym_SLASH] = ACTIONS(1206),
    [anon_sym_PERCENT] = ACTIONS(1206),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1206),
    [anon_sym_LT_LT] = ACTIONS(1206),
    [anon_sym_GT_GT] = ACTIONS(1206),
    [anon_sym_and] = ACTIONS(1204),
    [anon_sym_or] = ACTIONS(1204),
    [anon_sym_xor] = ACTIONS(1204),
    [anon_sym_isnt] = ACTIONS(1204),
    [anon_sym_EQ_EQ] = ACTIONS(1206),
    [anon_sym_BANG_EQ] = ACTIONS(1206),
    [anon_sym_GT] = ACTIONS(1206),
    [anon_sym_GT_EQ] = ACTIONS(1206),
    [anon_sym_LT_EQ] = ACTIONS(1206),
    [anon_sym_LT] = ACTIONS(1206),
    [anon_sym_PLUS_TILDE] = ACTIONS(1204),
    [anon_sym_STAR_TILDE] = ACTIONS(1204),
    [anon_sym_SLASH_TILDE] = ACTIONS(1204),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1204),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1204),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1204),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1204),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1204),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1204),
    [anon_sym_GT_TILDE] = ACTIONS(1204),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1204),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1204),
    [anon_sym_LT_TILDE] = ACTIONS(1204),
    [anon_sym_PLUS_QMARK] = ACTIONS(1204),
    [anon_sym_DASH_QMARK] = ACTIONS(1204),
    [anon_sym_STAR_QMARK] = ACTIONS(1204),
    [anon_sym_SLASH_QMARK] = ACTIONS(1204),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1204),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1204),
    [anon_sym_as] = ACTIONS(1204),
    [anon_sym_LPAREN2] = ACTIONS(1204),
    [anon_sym_DOT_GT] = ACTIONS(1204),
    [anon_sym_where] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1204),
    [anon_sym_end] = ACTIONS(1204),
    [anon_sym_if] = ACTIONS(1206),
    [anon_sym_ifdef] = ACTIONS(1204),
    [anon_sym_iftype] = ACTIONS(1204),
    [anon_sym_else] = ACTIONS(1204),
    [anon_sym_for] = ACTIONS(1204),
    [anon_sym_while] = ACTIONS(1204),
    [anon_sym_try] = ACTIONS(1204),
    [anon_sym_with] = ACTIONS(1204),
    [anon_sym_repeat] = ACTIONS(1204),
    [anon_sym_do] = ACTIONS(1204),
    [anon_sym_recover] = ACTIONS(1204),
    [anon_sym_match] = ACTIONS(1204),
    [anon_sym_return] = ACTIONS(1204),
    [anon_sym_continue] = ACTIONS(1204),
    [anon_sym_break] = ACTIONS(1204),
    [anon_sym_consume] = ACTIONS(1204),
    [anon_sym_object] = ACTIONS(1204),
    [sym_number] = ACTIONS(1206),
    [sym_float] = ACTIONS(1204),
    [anon_sym_DQUOTE] = ACTIONS(1206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1204),
    [anon_sym_SQUOTE] = ACTIONS(1204),
    [anon_sym_true] = ACTIONS(1204),
    [anon_sym_false] = ACTIONS(1204),
    [sym_this] = ACTIONS(1204),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [270] = {
    [ts_builtin_sym_end] = ACTIONS(992),
    [sym_identifier] = ACTIONS(994),
    [anon_sym_use] = ACTIONS(992),
    [anon_sym_EQ] = ACTIONS(994),
    [anon_sym_AT] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(992),
    [anon_sym_type] = ACTIONS(992),
    [anon_sym_is] = ACTIONS(994),
    [anon_sym_actor] = ACTIONS(992),
    [anon_sym_class] = ACTIONS(992),
    [anon_sym_primitive] = ACTIONS(992),
    [anon_sym_interface] = ACTIONS(992),
    [anon_sym_trait] = ACTIONS(992),
    [anon_sym_struct] = ACTIONS(992),
    [anon_sym_embed] = ACTIONS(992),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_var] = ACTIONS(992),
    [anon_sym_new] = ACTIONS(992),
    [anon_sym_fun] = ACTIONS(992),
    [anon_sym_be] = ACTIONS(992),
    [anon_sym_COMMA] = ACTIONS(992),
    [anon_sym_LPAREN] = ACTIONS(994),
    [anon_sym_RPAREN] = ACTIONS(992),
    [anon_sym_DOT] = ACTIONS(994),
    [anon_sym_LBRACE] = ACTIONS(992),
    [anon_sym_SEMI] = ACTIONS(992),
    [sym_error] = ACTIONS(992),
    [sym_compile_intrinsic] = ACTIONS(992),
    [anon_sym_compile_error] = ACTIONS(992),
    [sym_location] = ACTIONS(992),
    [anon_sym_DASH] = ACTIONS(994),
    [anon_sym_not] = ACTIONS(992),
    [anon_sym_DASH_TILDE] = ACTIONS(992),
    [anon_sym_addressof] = ACTIONS(992),
    [anon_sym_digestof] = ACTIONS(992),
    [anon_sym_PLUS] = ACTIONS(994),
    [anon_sym_STAR] = ACTIONS(994),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_PERCENT] = ACTIONS(994),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(994),
    [anon_sym_LT_LT] = ACTIONS(994),
    [anon_sym_GT_GT] = ACTIONS(994),
    [anon_sym_and] = ACTIONS(992),
    [anon_sym_or] = ACTIONS(992),
    [anon_sym_xor] = ACTIONS(992),
    [anon_sym_isnt] = ACTIONS(992),
    [anon_sym_EQ_EQ] = ACTIONS(994),
    [anon_sym_BANG_EQ] = ACTIONS(994),
    [anon_sym_GT] = ACTIONS(994),
    [anon_sym_GT_EQ] = ACTIONS(994),
    [anon_sym_LT_EQ] = ACTIONS(994),
    [anon_sym_LT] = ACTIONS(994),
    [anon_sym_PLUS_TILDE] = ACTIONS(992),
    [anon_sym_STAR_TILDE] = ACTIONS(992),
    [anon_sym_SLASH_TILDE] = ACTIONS(992),
    [anon_sym_PERCENT_TILDE] = ACTIONS(992),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(992),
    [anon_sym_LT_LT_TILDE] = ACTIONS(992),
    [anon_sym_GT_GT_TILDE] = ACTIONS(992),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(992),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(992),
    [anon_sym_GT_TILDE] = ACTIONS(992),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(992),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(992),
    [anon_sym_LT_TILDE] = ACTIONS(992),
    [anon_sym_PLUS_QMARK] = ACTIONS(992),
    [anon_sym_DASH_QMARK] = ACTIONS(992),
    [anon_sym_STAR_QMARK] = ACTIONS(992),
    [anon_sym_SLASH_QMARK] = ACTIONS(992),
    [anon_sym_PERCENT_QMARK] = ACTIONS(992),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(992),
    [anon_sym_as] = ACTIONS(992),
    [anon_sym_LPAREN2] = ACTIONS(992),
    [anon_sym_DOT_GT] = ACTIONS(992),
    [anon_sym_where] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(992),
    [anon_sym_end] = ACTIONS(992),
    [anon_sym_if] = ACTIONS(994),
    [anon_sym_ifdef] = ACTIONS(992),
    [anon_sym_iftype] = ACTIONS(992),
    [anon_sym_else] = ACTIONS(992),
    [anon_sym_for] = ACTIONS(992),
    [anon_sym_while] = ACTIONS(992),
    [anon_sym_try] = ACTIONS(992),
    [anon_sym_with] = ACTIONS(992),
    [anon_sym_repeat] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(992),
    [anon_sym_recover] = ACTIONS(992),
    [anon_sym_match] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(992),
    [anon_sym_continue] = ACTIONS(992),
    [anon_sym_break] = ACTIONS(992),
    [anon_sym_consume] = ACTIONS(992),
    [anon_sym_object] = ACTIONS(992),
    [sym_number] = ACTIONS(994),
    [sym_float] = ACTIONS(992),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(992),
    [anon_sym_SQUOTE] = ACTIONS(992),
    [anon_sym_true] = ACTIONS(992),
    [anon_sym_false] = ACTIONS(992),
    [sym_this] = ACTIONS(992),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [271] = {
    [ts_builtin_sym_end] = ACTIONS(1208),
    [sym_identifier] = ACTIONS(1210),
    [anon_sym_use] = ACTIONS(1208),
    [anon_sym_EQ] = ACTIONS(1210),
    [anon_sym_AT] = ACTIONS(1208),
    [anon_sym_LBRACK] = ACTIONS(1208),
    [anon_sym_type] = ACTIONS(1208),
    [anon_sym_is] = ACTIONS(1210),
    [anon_sym_actor] = ACTIONS(1208),
    [anon_sym_class] = ACTIONS(1208),
    [anon_sym_primitive] = ACTIONS(1208),
    [anon_sym_interface] = ACTIONS(1208),
    [anon_sym_trait] = ACTIONS(1208),
    [anon_sym_struct] = ACTIONS(1208),
    [anon_sym_embed] = ACTIONS(1208),
    [anon_sym_let] = ACTIONS(1208),
    [anon_sym_var] = ACTIONS(1208),
    [anon_sym_new] = ACTIONS(1208),
    [anon_sym_fun] = ACTIONS(1208),
    [anon_sym_be] = ACTIONS(1208),
    [anon_sym_COMMA] = ACTIONS(1208),
    [anon_sym_LPAREN] = ACTIONS(1210),
    [anon_sym_RPAREN] = ACTIONS(1208),
    [anon_sym_DOT] = ACTIONS(1210),
    [anon_sym_LBRACE] = ACTIONS(1208),
    [anon_sym_SEMI] = ACTIONS(1208),
    [sym_error] = ACTIONS(1208),
    [sym_compile_intrinsic] = ACTIONS(1208),
    [anon_sym_compile_error] = ACTIONS(1208),
    [sym_location] = ACTIONS(1208),
    [anon_sym_DASH] = ACTIONS(1210),
    [anon_sym_not] = ACTIONS(1208),
    [anon_sym_DASH_TILDE] = ACTIONS(1208),
    [anon_sym_addressof] = ACTIONS(1208),
    [anon_sym_digestof] = ACTIONS(1208),
    [anon_sym_PLUS] = ACTIONS(1210),
    [anon_sym_STAR] = ACTIONS(1210),
    [anon_sym_SLASH] = ACTIONS(1210),
    [anon_sym_PERCENT] = ACTIONS(1210),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1210),
    [anon_sym_LT_LT] = ACTIONS(1210),
    [anon_sym_GT_GT] = ACTIONS(1210),
    [anon_sym_and] = ACTIONS(1208),
    [anon_sym_or] = ACTIONS(1208),
    [anon_sym_xor] = ACTIONS(1208),
    [anon_sym_isnt] = ACTIONS(1208),
    [anon_sym_EQ_EQ] = ACTIONS(1210),
    [anon_sym_BANG_EQ] = ACTIONS(1210),
    [anon_sym_GT] = ACTIONS(1210),
    [anon_sym_GT_EQ] = ACTIONS(1210),
    [anon_sym_LT_EQ] = ACTIONS(1210),
    [anon_sym_LT] = ACTIONS(1210),
    [anon_sym_PLUS_TILDE] = ACTIONS(1208),
    [anon_sym_STAR_TILDE] = ACTIONS(1208),
    [anon_sym_SLASH_TILDE] = ACTIONS(1208),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1208),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1208),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1208),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1208),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1208),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1208),
    [anon_sym_GT_TILDE] = ACTIONS(1208),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1208),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1208),
    [anon_sym_LT_TILDE] = ACTIONS(1208),
    [anon_sym_PLUS_QMARK] = ACTIONS(1208),
    [anon_sym_DASH_QMARK] = ACTIONS(1208),
    [anon_sym_STAR_QMARK] = ACTIONS(1208),
    [anon_sym_SLASH_QMARK] = ACTIONS(1208),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1208),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1208),
    [anon_sym_as] = ACTIONS(1208),
    [anon_sym_LPAREN2] = ACTIONS(1208),
    [anon_sym_DOT_GT] = ACTIONS(1208),
    [anon_sym_where] = ACTIONS(1208),
    [anon_sym_TILDE] = ACTIONS(1208),
    [anon_sym_end] = ACTIONS(1208),
    [anon_sym_if] = ACTIONS(1210),
    [anon_sym_ifdef] = ACTIONS(1208),
    [anon_sym_iftype] = ACTIONS(1208),
    [anon_sym_else] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1208),
    [anon_sym_while] = ACTIONS(1208),
    [anon_sym_try] = ACTIONS(1208),
    [anon_sym_with] = ACTIONS(1208),
    [anon_sym_repeat] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1208),
    [anon_sym_recover] = ACTIONS(1208),
    [anon_sym_match] = ACTIONS(1208),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_continue] = ACTIONS(1208),
    [anon_sym_break] = ACTIONS(1208),
    [anon_sym_consume] = ACTIONS(1208),
    [anon_sym_object] = ACTIONS(1208),
    [sym_number] = ACTIONS(1210),
    [sym_float] = ACTIONS(1208),
    [anon_sym_DQUOTE] = ACTIONS(1210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1208),
    [anon_sym_SQUOTE] = ACTIONS(1208),
    [anon_sym_true] = ACTIONS(1208),
    [anon_sym_false] = ACTIONS(1208),
    [sym_this] = ACTIONS(1208),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [272] = {
    [ts_builtin_sym_end] = ACTIONS(1212),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_use] = ACTIONS(1212),
    [anon_sym_EQ] = ACTIONS(1214),
    [anon_sym_AT] = ACTIONS(1212),
    [anon_sym_LBRACK] = ACTIONS(1212),
    [anon_sym_type] = ACTIONS(1212),
    [anon_sym_is] = ACTIONS(1214),
    [anon_sym_actor] = ACTIONS(1212),
    [anon_sym_class] = ACTIONS(1212),
    [anon_sym_primitive] = ACTIONS(1212),
    [anon_sym_interface] = ACTIONS(1212),
    [anon_sym_trait] = ACTIONS(1212),
    [anon_sym_struct] = ACTIONS(1212),
    [anon_sym_embed] = ACTIONS(1212),
    [anon_sym_let] = ACTIONS(1212),
    [anon_sym_var] = ACTIONS(1212),
    [anon_sym_new] = ACTIONS(1212),
    [anon_sym_fun] = ACTIONS(1212),
    [anon_sym_be] = ACTIONS(1212),
    [anon_sym_COMMA] = ACTIONS(1212),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_RPAREN] = ACTIONS(1212),
    [anon_sym_DOT] = ACTIONS(1214),
    [anon_sym_LBRACE] = ACTIONS(1212),
    [anon_sym_SEMI] = ACTIONS(1212),
    [sym_error] = ACTIONS(1212),
    [sym_compile_intrinsic] = ACTIONS(1212),
    [anon_sym_compile_error] = ACTIONS(1212),
    [sym_location] = ACTIONS(1212),
    [anon_sym_DASH] = ACTIONS(1214),
    [anon_sym_not] = ACTIONS(1212),
    [anon_sym_DASH_TILDE] = ACTIONS(1212),
    [anon_sym_addressof] = ACTIONS(1212),
    [anon_sym_digestof] = ACTIONS(1212),
    [anon_sym_PLUS] = ACTIONS(1214),
    [anon_sym_STAR] = ACTIONS(1214),
    [anon_sym_SLASH] = ACTIONS(1214),
    [anon_sym_PERCENT] = ACTIONS(1214),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1214),
    [anon_sym_LT_LT] = ACTIONS(1214),
    [anon_sym_GT_GT] = ACTIONS(1214),
    [anon_sym_and] = ACTIONS(1212),
    [anon_sym_or] = ACTIONS(1212),
    [anon_sym_xor] = ACTIONS(1212),
    [anon_sym_isnt] = ACTIONS(1212),
    [anon_sym_EQ_EQ] = ACTIONS(1214),
    [anon_sym_BANG_EQ] = ACTIONS(1214),
    [anon_sym_GT] = ACTIONS(1214),
    [anon_sym_GT_EQ] = ACTIONS(1214),
    [anon_sym_LT_EQ] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1214),
    [anon_sym_PLUS_TILDE] = ACTIONS(1212),
    [anon_sym_STAR_TILDE] = ACTIONS(1212),
    [anon_sym_SLASH_TILDE] = ACTIONS(1212),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1212),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1212),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1212),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1212),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1212),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1212),
    [anon_sym_GT_TILDE] = ACTIONS(1212),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1212),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1212),
    [anon_sym_LT_TILDE] = ACTIONS(1212),
    [anon_sym_PLUS_QMARK] = ACTIONS(1212),
    [anon_sym_DASH_QMARK] = ACTIONS(1212),
    [anon_sym_STAR_QMARK] = ACTIONS(1212),
    [anon_sym_SLASH_QMARK] = ACTIONS(1212),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1212),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1212),
    [anon_sym_as] = ACTIONS(1212),
    [anon_sym_LPAREN2] = ACTIONS(1212),
    [anon_sym_DOT_GT] = ACTIONS(1212),
    [anon_sym_where] = ACTIONS(1212),
    [anon_sym_TILDE] = ACTIONS(1212),
    [anon_sym_end] = ACTIONS(1212),
    [anon_sym_if] = ACTIONS(1214),
    [anon_sym_ifdef] = ACTIONS(1212),
    [anon_sym_iftype] = ACTIONS(1212),
    [anon_sym_else] = ACTIONS(1212),
    [anon_sym_for] = ACTIONS(1212),
    [anon_sym_while] = ACTIONS(1212),
    [anon_sym_try] = ACTIONS(1212),
    [anon_sym_with] = ACTIONS(1212),
    [anon_sym_repeat] = ACTIONS(1212),
    [anon_sym_do] = ACTIONS(1212),
    [anon_sym_recover] = ACTIONS(1212),
    [anon_sym_match] = ACTIONS(1212),
    [anon_sym_return] = ACTIONS(1212),
    [anon_sym_continue] = ACTIONS(1212),
    [anon_sym_break] = ACTIONS(1212),
    [anon_sym_consume] = ACTIONS(1212),
    [anon_sym_object] = ACTIONS(1212),
    [sym_number] = ACTIONS(1214),
    [sym_float] = ACTIONS(1212),
    [anon_sym_DQUOTE] = ACTIONS(1214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1212),
    [anon_sym_SQUOTE] = ACTIONS(1212),
    [anon_sym_true] = ACTIONS(1212),
    [anon_sym_false] = ACTIONS(1212),
    [sym_this] = ACTIONS(1212),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [273] = {
    [ts_builtin_sym_end] = ACTIONS(1216),
    [sym_identifier] = ACTIONS(1218),
    [anon_sym_use] = ACTIONS(1216),
    [anon_sym_EQ] = ACTIONS(1218),
    [anon_sym_AT] = ACTIONS(1216),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_type] = ACTIONS(1216),
    [anon_sym_is] = ACTIONS(1218),
    [anon_sym_actor] = ACTIONS(1216),
    [anon_sym_class] = ACTIONS(1216),
    [anon_sym_primitive] = ACTIONS(1216),
    [anon_sym_interface] = ACTIONS(1216),
    [anon_sym_trait] = ACTIONS(1216),
    [anon_sym_struct] = ACTIONS(1216),
    [anon_sym_embed] = ACTIONS(1216),
    [anon_sym_let] = ACTIONS(1216),
    [anon_sym_var] = ACTIONS(1216),
    [anon_sym_new] = ACTIONS(1216),
    [anon_sym_fun] = ACTIONS(1216),
    [anon_sym_be] = ACTIONS(1216),
    [anon_sym_COMMA] = ACTIONS(1216),
    [anon_sym_LPAREN] = ACTIONS(1218),
    [anon_sym_RPAREN] = ACTIONS(1216),
    [anon_sym_DOT] = ACTIONS(1218),
    [anon_sym_LBRACE] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1216),
    [sym_error] = ACTIONS(1216),
    [sym_compile_intrinsic] = ACTIONS(1216),
    [anon_sym_compile_error] = ACTIONS(1216),
    [sym_location] = ACTIONS(1216),
    [anon_sym_DASH] = ACTIONS(1218),
    [anon_sym_not] = ACTIONS(1216),
    [anon_sym_DASH_TILDE] = ACTIONS(1216),
    [anon_sym_addressof] = ACTIONS(1216),
    [anon_sym_digestof] = ACTIONS(1216),
    [anon_sym_PLUS] = ACTIONS(1218),
    [anon_sym_STAR] = ACTIONS(1218),
    [anon_sym_SLASH] = ACTIONS(1218),
    [anon_sym_PERCENT] = ACTIONS(1218),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1218),
    [anon_sym_LT_LT] = ACTIONS(1218),
    [anon_sym_GT_GT] = ACTIONS(1218),
    [anon_sym_and] = ACTIONS(1216),
    [anon_sym_or] = ACTIONS(1216),
    [anon_sym_xor] = ACTIONS(1216),
    [anon_sym_isnt] = ACTIONS(1216),
    [anon_sym_EQ_EQ] = ACTIONS(1218),
    [anon_sym_BANG_EQ] = ACTIONS(1218),
    [anon_sym_GT] = ACTIONS(1218),
    [anon_sym_GT_EQ] = ACTIONS(1218),
    [anon_sym_LT_EQ] = ACTIONS(1218),
    [anon_sym_LT] = ACTIONS(1218),
    [anon_sym_PLUS_TILDE] = ACTIONS(1216),
    [anon_sym_STAR_TILDE] = ACTIONS(1216),
    [anon_sym_SLASH_TILDE] = ACTIONS(1216),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1216),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1216),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1216),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1216),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1216),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1216),
    [anon_sym_GT_TILDE] = ACTIONS(1216),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1216),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1216),
    [anon_sym_LT_TILDE] = ACTIONS(1216),
    [anon_sym_PLUS_QMARK] = ACTIONS(1216),
    [anon_sym_DASH_QMARK] = ACTIONS(1216),
    [anon_sym_STAR_QMARK] = ACTIONS(1216),
    [anon_sym_SLASH_QMARK] = ACTIONS(1216),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1216),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1216),
    [anon_sym_as] = ACTIONS(1216),
    [anon_sym_LPAREN2] = ACTIONS(1216),
    [anon_sym_DOT_GT] = ACTIONS(1216),
    [anon_sym_where] = ACTIONS(1216),
    [anon_sym_TILDE] = ACTIONS(1216),
    [anon_sym_end] = ACTIONS(1216),
    [anon_sym_if] = ACTIONS(1218),
    [anon_sym_ifdef] = ACTIONS(1216),
    [anon_sym_iftype] = ACTIONS(1216),
    [anon_sym_else] = ACTIONS(1216),
    [anon_sym_for] = ACTIONS(1216),
    [anon_sym_while] = ACTIONS(1216),
    [anon_sym_try] = ACTIONS(1216),
    [anon_sym_with] = ACTIONS(1216),
    [anon_sym_repeat] = ACTIONS(1216),
    [anon_sym_do] = ACTIONS(1216),
    [anon_sym_recover] = ACTIONS(1216),
    [anon_sym_match] = ACTIONS(1216),
    [anon_sym_return] = ACTIONS(1216),
    [anon_sym_continue] = ACTIONS(1216),
    [anon_sym_break] = ACTIONS(1216),
    [anon_sym_consume] = ACTIONS(1216),
    [anon_sym_object] = ACTIONS(1216),
    [sym_number] = ACTIONS(1218),
    [sym_float] = ACTIONS(1216),
    [anon_sym_DQUOTE] = ACTIONS(1218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1216),
    [anon_sym_SQUOTE] = ACTIONS(1216),
    [anon_sym_true] = ACTIONS(1216),
    [anon_sym_false] = ACTIONS(1216),
    [sym_this] = ACTIONS(1216),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [274] = {
    [ts_builtin_sym_end] = ACTIONS(1220),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_use] = ACTIONS(1220),
    [anon_sym_EQ] = ACTIONS(1222),
    [anon_sym_AT] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1220),
    [anon_sym_type] = ACTIONS(1220),
    [anon_sym_is] = ACTIONS(1222),
    [anon_sym_actor] = ACTIONS(1220),
    [anon_sym_class] = ACTIONS(1220),
    [anon_sym_primitive] = ACTIONS(1220),
    [anon_sym_interface] = ACTIONS(1220),
    [anon_sym_trait] = ACTIONS(1220),
    [anon_sym_struct] = ACTIONS(1220),
    [anon_sym_embed] = ACTIONS(1220),
    [anon_sym_let] = ACTIONS(1220),
    [anon_sym_var] = ACTIONS(1220),
    [anon_sym_new] = ACTIONS(1220),
    [anon_sym_fun] = ACTIONS(1220),
    [anon_sym_be] = ACTIONS(1220),
    [anon_sym_COMMA] = ACTIONS(1220),
    [anon_sym_LPAREN] = ACTIONS(1222),
    [anon_sym_RPAREN] = ACTIONS(1220),
    [anon_sym_DOT] = ACTIONS(1222),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_SEMI] = ACTIONS(1220),
    [sym_error] = ACTIONS(1220),
    [sym_compile_intrinsic] = ACTIONS(1220),
    [anon_sym_compile_error] = ACTIONS(1220),
    [sym_location] = ACTIONS(1220),
    [anon_sym_DASH] = ACTIONS(1222),
    [anon_sym_not] = ACTIONS(1220),
    [anon_sym_DASH_TILDE] = ACTIONS(1220),
    [anon_sym_addressof] = ACTIONS(1220),
    [anon_sym_digestof] = ACTIONS(1220),
    [anon_sym_PLUS] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(1222),
    [anon_sym_SLASH] = ACTIONS(1222),
    [anon_sym_PERCENT] = ACTIONS(1222),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1222),
    [anon_sym_LT_LT] = ACTIONS(1222),
    [anon_sym_GT_GT] = ACTIONS(1222),
    [anon_sym_and] = ACTIONS(1220),
    [anon_sym_or] = ACTIONS(1220),
    [anon_sym_xor] = ACTIONS(1220),
    [anon_sym_isnt] = ACTIONS(1220),
    [anon_sym_EQ_EQ] = ACTIONS(1222),
    [anon_sym_BANG_EQ] = ACTIONS(1222),
    [anon_sym_GT] = ACTIONS(1222),
    [anon_sym_GT_EQ] = ACTIONS(1222),
    [anon_sym_LT_EQ] = ACTIONS(1222),
    [anon_sym_LT] = ACTIONS(1222),
    [anon_sym_PLUS_TILDE] = ACTIONS(1220),
    [anon_sym_STAR_TILDE] = ACTIONS(1220),
    [anon_sym_SLASH_TILDE] = ACTIONS(1220),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1220),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1220),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1220),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1220),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1220),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1220),
    [anon_sym_GT_TILDE] = ACTIONS(1220),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1220),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1220),
    [anon_sym_LT_TILDE] = ACTIONS(1220),
    [anon_sym_PLUS_QMARK] = ACTIONS(1220),
    [anon_sym_DASH_QMARK] = ACTIONS(1220),
    [anon_sym_STAR_QMARK] = ACTIONS(1220),
    [anon_sym_SLASH_QMARK] = ACTIONS(1220),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1220),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1220),
    [anon_sym_as] = ACTIONS(1220),
    [anon_sym_LPAREN2] = ACTIONS(1220),
    [anon_sym_DOT_GT] = ACTIONS(1220),
    [anon_sym_where] = ACTIONS(1220),
    [anon_sym_TILDE] = ACTIONS(1220),
    [anon_sym_end] = ACTIONS(1220),
    [anon_sym_if] = ACTIONS(1222),
    [anon_sym_ifdef] = ACTIONS(1220),
    [anon_sym_iftype] = ACTIONS(1220),
    [anon_sym_else] = ACTIONS(1220),
    [anon_sym_for] = ACTIONS(1220),
    [anon_sym_while] = ACTIONS(1220),
    [anon_sym_try] = ACTIONS(1220),
    [anon_sym_with] = ACTIONS(1220),
    [anon_sym_repeat] = ACTIONS(1220),
    [anon_sym_do] = ACTIONS(1220),
    [anon_sym_recover] = ACTIONS(1220),
    [anon_sym_match] = ACTIONS(1220),
    [anon_sym_return] = ACTIONS(1220),
    [anon_sym_continue] = ACTIONS(1220),
    [anon_sym_break] = ACTIONS(1220),
    [anon_sym_consume] = ACTIONS(1220),
    [anon_sym_object] = ACTIONS(1220),
    [sym_number] = ACTIONS(1222),
    [sym_float] = ACTIONS(1220),
    [anon_sym_DQUOTE] = ACTIONS(1222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1220),
    [anon_sym_SQUOTE] = ACTIONS(1220),
    [anon_sym_true] = ACTIONS(1220),
    [anon_sym_false] = ACTIONS(1220),
    [sym_this] = ACTIONS(1220),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [275] = {
    [ts_builtin_sym_end] = ACTIONS(1224),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_use] = ACTIONS(1224),
    [anon_sym_EQ] = ACTIONS(1226),
    [anon_sym_AT] = ACTIONS(1224),
    [anon_sym_LBRACK] = ACTIONS(1224),
    [anon_sym_type] = ACTIONS(1224),
    [anon_sym_is] = ACTIONS(1226),
    [anon_sym_actor] = ACTIONS(1224),
    [anon_sym_class] = ACTIONS(1224),
    [anon_sym_primitive] = ACTIONS(1224),
    [anon_sym_interface] = ACTIONS(1224),
    [anon_sym_trait] = ACTIONS(1224),
    [anon_sym_struct] = ACTIONS(1224),
    [anon_sym_embed] = ACTIONS(1224),
    [anon_sym_let] = ACTIONS(1224),
    [anon_sym_var] = ACTIONS(1224),
    [anon_sym_new] = ACTIONS(1224),
    [anon_sym_fun] = ACTIONS(1224),
    [anon_sym_be] = ACTIONS(1224),
    [anon_sym_COMMA] = ACTIONS(1224),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_RPAREN] = ACTIONS(1224),
    [anon_sym_DOT] = ACTIONS(1226),
    [anon_sym_LBRACE] = ACTIONS(1224),
    [anon_sym_SEMI] = ACTIONS(1224),
    [sym_error] = ACTIONS(1224),
    [sym_compile_intrinsic] = ACTIONS(1224),
    [anon_sym_compile_error] = ACTIONS(1224),
    [sym_location] = ACTIONS(1224),
    [anon_sym_DASH] = ACTIONS(1226),
    [anon_sym_not] = ACTIONS(1224),
    [anon_sym_DASH_TILDE] = ACTIONS(1224),
    [anon_sym_addressof] = ACTIONS(1224),
    [anon_sym_digestof] = ACTIONS(1224),
    [anon_sym_PLUS] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(1226),
    [anon_sym_SLASH] = ACTIONS(1226),
    [anon_sym_PERCENT] = ACTIONS(1226),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1226),
    [anon_sym_LT_LT] = ACTIONS(1226),
    [anon_sym_GT_GT] = ACTIONS(1226),
    [anon_sym_and] = ACTIONS(1224),
    [anon_sym_or] = ACTIONS(1224),
    [anon_sym_xor] = ACTIONS(1224),
    [anon_sym_isnt] = ACTIONS(1224),
    [anon_sym_EQ_EQ] = ACTIONS(1226),
    [anon_sym_BANG_EQ] = ACTIONS(1226),
    [anon_sym_GT] = ACTIONS(1226),
    [anon_sym_GT_EQ] = ACTIONS(1226),
    [anon_sym_LT_EQ] = ACTIONS(1226),
    [anon_sym_LT] = ACTIONS(1226),
    [anon_sym_PLUS_TILDE] = ACTIONS(1224),
    [anon_sym_STAR_TILDE] = ACTIONS(1224),
    [anon_sym_SLASH_TILDE] = ACTIONS(1224),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1224),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1224),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1224),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1224),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1224),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1224),
    [anon_sym_GT_TILDE] = ACTIONS(1224),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1224),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1224),
    [anon_sym_LT_TILDE] = ACTIONS(1224),
    [anon_sym_PLUS_QMARK] = ACTIONS(1224),
    [anon_sym_DASH_QMARK] = ACTIONS(1224),
    [anon_sym_STAR_QMARK] = ACTIONS(1224),
    [anon_sym_SLASH_QMARK] = ACTIONS(1224),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1224),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1224),
    [anon_sym_as] = ACTIONS(1224),
    [anon_sym_LPAREN2] = ACTIONS(1224),
    [anon_sym_DOT_GT] = ACTIONS(1224),
    [anon_sym_where] = ACTIONS(1224),
    [anon_sym_TILDE] = ACTIONS(1224),
    [anon_sym_end] = ACTIONS(1224),
    [anon_sym_if] = ACTIONS(1226),
    [anon_sym_ifdef] = ACTIONS(1224),
    [anon_sym_iftype] = ACTIONS(1224),
    [anon_sym_else] = ACTIONS(1224),
    [anon_sym_for] = ACTIONS(1224),
    [anon_sym_while] = ACTIONS(1224),
    [anon_sym_try] = ACTIONS(1224),
    [anon_sym_with] = ACTIONS(1224),
    [anon_sym_repeat] = ACTIONS(1224),
    [anon_sym_do] = ACTIONS(1224),
    [anon_sym_recover] = ACTIONS(1224),
    [anon_sym_match] = ACTIONS(1224),
    [anon_sym_return] = ACTIONS(1224),
    [anon_sym_continue] = ACTIONS(1224),
    [anon_sym_break] = ACTIONS(1224),
    [anon_sym_consume] = ACTIONS(1224),
    [anon_sym_object] = ACTIONS(1224),
    [sym_number] = ACTIONS(1226),
    [sym_float] = ACTIONS(1224),
    [anon_sym_DQUOTE] = ACTIONS(1226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1224),
    [anon_sym_SQUOTE] = ACTIONS(1224),
    [anon_sym_true] = ACTIONS(1224),
    [anon_sym_false] = ACTIONS(1224),
    [sym_this] = ACTIONS(1224),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [276] = {
    [ts_builtin_sym_end] = ACTIONS(1228),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_use] = ACTIONS(1228),
    [anon_sym_EQ] = ACTIONS(1230),
    [anon_sym_AT] = ACTIONS(1228),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_type] = ACTIONS(1228),
    [anon_sym_is] = ACTIONS(1230),
    [anon_sym_actor] = ACTIONS(1228),
    [anon_sym_class] = ACTIONS(1228),
    [anon_sym_primitive] = ACTIONS(1228),
    [anon_sym_interface] = ACTIONS(1228),
    [anon_sym_trait] = ACTIONS(1228),
    [anon_sym_struct] = ACTIONS(1228),
    [anon_sym_embed] = ACTIONS(1228),
    [anon_sym_let] = ACTIONS(1228),
    [anon_sym_var] = ACTIONS(1228),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_fun] = ACTIONS(1228),
    [anon_sym_be] = ACTIONS(1228),
    [anon_sym_COMMA] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_RPAREN] = ACTIONS(1228),
    [anon_sym_DOT] = ACTIONS(1230),
    [anon_sym_LBRACE] = ACTIONS(1228),
    [anon_sym_SEMI] = ACTIONS(1228),
    [sym_error] = ACTIONS(1228),
    [sym_compile_intrinsic] = ACTIONS(1228),
    [anon_sym_compile_error] = ACTIONS(1228),
    [sym_location] = ACTIONS(1228),
    [anon_sym_DASH] = ACTIONS(1230),
    [anon_sym_not] = ACTIONS(1228),
    [anon_sym_DASH_TILDE] = ACTIONS(1228),
    [anon_sym_addressof] = ACTIONS(1228),
    [anon_sym_digestof] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(1230),
    [anon_sym_STAR] = ACTIONS(1230),
    [anon_sym_SLASH] = ACTIONS(1230),
    [anon_sym_PERCENT] = ACTIONS(1230),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1230),
    [anon_sym_LT_LT] = ACTIONS(1230),
    [anon_sym_GT_GT] = ACTIONS(1230),
    [anon_sym_and] = ACTIONS(1228),
    [anon_sym_or] = ACTIONS(1228),
    [anon_sym_xor] = ACTIONS(1228),
    [anon_sym_isnt] = ACTIONS(1228),
    [anon_sym_EQ_EQ] = ACTIONS(1230),
    [anon_sym_BANG_EQ] = ACTIONS(1230),
    [anon_sym_GT] = ACTIONS(1230),
    [anon_sym_GT_EQ] = ACTIONS(1230),
    [anon_sym_LT_EQ] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1230),
    [anon_sym_PLUS_TILDE] = ACTIONS(1228),
    [anon_sym_STAR_TILDE] = ACTIONS(1228),
    [anon_sym_SLASH_TILDE] = ACTIONS(1228),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1228),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1228),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1228),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1228),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1228),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1228),
    [anon_sym_GT_TILDE] = ACTIONS(1228),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1228),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1228),
    [anon_sym_LT_TILDE] = ACTIONS(1228),
    [anon_sym_PLUS_QMARK] = ACTIONS(1228),
    [anon_sym_DASH_QMARK] = ACTIONS(1228),
    [anon_sym_STAR_QMARK] = ACTIONS(1228),
    [anon_sym_SLASH_QMARK] = ACTIONS(1228),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1228),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1228),
    [anon_sym_as] = ACTIONS(1228),
    [anon_sym_LPAREN2] = ACTIONS(1228),
    [anon_sym_DOT_GT] = ACTIONS(1228),
    [anon_sym_where] = ACTIONS(1228),
    [anon_sym_TILDE] = ACTIONS(1228),
    [anon_sym_end] = ACTIONS(1228),
    [anon_sym_if] = ACTIONS(1230),
    [anon_sym_ifdef] = ACTIONS(1228),
    [anon_sym_iftype] = ACTIONS(1228),
    [anon_sym_else] = ACTIONS(1228),
    [anon_sym_for] = ACTIONS(1228),
    [anon_sym_while] = ACTIONS(1228),
    [anon_sym_try] = ACTIONS(1228),
    [anon_sym_with] = ACTIONS(1228),
    [anon_sym_repeat] = ACTIONS(1228),
    [anon_sym_do] = ACTIONS(1228),
    [anon_sym_recover] = ACTIONS(1228),
    [anon_sym_match] = ACTIONS(1228),
    [anon_sym_return] = ACTIONS(1228),
    [anon_sym_continue] = ACTIONS(1228),
    [anon_sym_break] = ACTIONS(1228),
    [anon_sym_consume] = ACTIONS(1228),
    [anon_sym_object] = ACTIONS(1228),
    [sym_number] = ACTIONS(1230),
    [sym_float] = ACTIONS(1228),
    [anon_sym_DQUOTE] = ACTIONS(1230),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1228),
    [anon_sym_SQUOTE] = ACTIONS(1228),
    [anon_sym_true] = ACTIONS(1228),
    [anon_sym_false] = ACTIONS(1228),
    [sym_this] = ACTIONS(1228),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [277] = {
    [ts_builtin_sym_end] = ACTIONS(1232),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_use] = ACTIONS(1232),
    [anon_sym_EQ] = ACTIONS(1234),
    [anon_sym_AT] = ACTIONS(1232),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_type] = ACTIONS(1232),
    [anon_sym_is] = ACTIONS(1234),
    [anon_sym_actor] = ACTIONS(1232),
    [anon_sym_class] = ACTIONS(1232),
    [anon_sym_primitive] = ACTIONS(1232),
    [anon_sym_interface] = ACTIONS(1232),
    [anon_sym_trait] = ACTIONS(1232),
    [anon_sym_struct] = ACTIONS(1232),
    [anon_sym_embed] = ACTIONS(1232),
    [anon_sym_let] = ACTIONS(1232),
    [anon_sym_var] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_fun] = ACTIONS(1232),
    [anon_sym_be] = ACTIONS(1232),
    [anon_sym_COMMA] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_RPAREN] = ACTIONS(1232),
    [anon_sym_DOT] = ACTIONS(1234),
    [anon_sym_LBRACE] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1232),
    [sym_error] = ACTIONS(1232),
    [sym_compile_intrinsic] = ACTIONS(1232),
    [anon_sym_compile_error] = ACTIONS(1232),
    [sym_location] = ACTIONS(1232),
    [anon_sym_DASH] = ACTIONS(1234),
    [anon_sym_not] = ACTIONS(1232),
    [anon_sym_DASH_TILDE] = ACTIONS(1232),
    [anon_sym_addressof] = ACTIONS(1232),
    [anon_sym_digestof] = ACTIONS(1232),
    [anon_sym_PLUS] = ACTIONS(1234),
    [anon_sym_STAR] = ACTIONS(1234),
    [anon_sym_SLASH] = ACTIONS(1234),
    [anon_sym_PERCENT] = ACTIONS(1234),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1234),
    [anon_sym_LT_LT] = ACTIONS(1234),
    [anon_sym_GT_GT] = ACTIONS(1234),
    [anon_sym_and] = ACTIONS(1232),
    [anon_sym_or] = ACTIONS(1232),
    [anon_sym_xor] = ACTIONS(1232),
    [anon_sym_isnt] = ACTIONS(1232),
    [anon_sym_EQ_EQ] = ACTIONS(1234),
    [anon_sym_BANG_EQ] = ACTIONS(1234),
    [anon_sym_GT] = ACTIONS(1234),
    [anon_sym_GT_EQ] = ACTIONS(1234),
    [anon_sym_LT_EQ] = ACTIONS(1234),
    [anon_sym_LT] = ACTIONS(1234),
    [anon_sym_PLUS_TILDE] = ACTIONS(1232),
    [anon_sym_STAR_TILDE] = ACTIONS(1232),
    [anon_sym_SLASH_TILDE] = ACTIONS(1232),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1232),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1232),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1232),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1232),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1232),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1232),
    [anon_sym_GT_TILDE] = ACTIONS(1232),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1232),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1232),
    [anon_sym_LT_TILDE] = ACTIONS(1232),
    [anon_sym_PLUS_QMARK] = ACTIONS(1232),
    [anon_sym_DASH_QMARK] = ACTIONS(1232),
    [anon_sym_STAR_QMARK] = ACTIONS(1232),
    [anon_sym_SLASH_QMARK] = ACTIONS(1232),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1232),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1232),
    [anon_sym_as] = ACTIONS(1232),
    [anon_sym_LPAREN2] = ACTIONS(1232),
    [anon_sym_DOT_GT] = ACTIONS(1232),
    [anon_sym_where] = ACTIONS(1232),
    [anon_sym_TILDE] = ACTIONS(1232),
    [anon_sym_end] = ACTIONS(1232),
    [anon_sym_if] = ACTIONS(1234),
    [anon_sym_ifdef] = ACTIONS(1232),
    [anon_sym_iftype] = ACTIONS(1232),
    [anon_sym_else] = ACTIONS(1232),
    [anon_sym_for] = ACTIONS(1232),
    [anon_sym_while] = ACTIONS(1232),
    [anon_sym_try] = ACTIONS(1232),
    [anon_sym_with] = ACTIONS(1232),
    [anon_sym_repeat] = ACTIONS(1232),
    [anon_sym_do] = ACTIONS(1232),
    [anon_sym_recover] = ACTIONS(1232),
    [anon_sym_match] = ACTIONS(1232),
    [anon_sym_return] = ACTIONS(1232),
    [anon_sym_continue] = ACTIONS(1232),
    [anon_sym_break] = ACTIONS(1232),
    [anon_sym_consume] = ACTIONS(1232),
    [anon_sym_object] = ACTIONS(1232),
    [sym_number] = ACTIONS(1234),
    [sym_float] = ACTIONS(1232),
    [anon_sym_DQUOTE] = ACTIONS(1234),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1232),
    [anon_sym_SQUOTE] = ACTIONS(1232),
    [anon_sym_true] = ACTIONS(1232),
    [anon_sym_false] = ACTIONS(1232),
    [sym_this] = ACTIONS(1232),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [278] = {
    [ts_builtin_sym_end] = ACTIONS(1236),
    [sym_identifier] = ACTIONS(1238),
    [anon_sym_use] = ACTIONS(1236),
    [anon_sym_EQ] = ACTIONS(1238),
    [anon_sym_AT] = ACTIONS(1236),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_type] = ACTIONS(1236),
    [anon_sym_is] = ACTIONS(1238),
    [anon_sym_actor] = ACTIONS(1236),
    [anon_sym_class] = ACTIONS(1236),
    [anon_sym_primitive] = ACTIONS(1236),
    [anon_sym_interface] = ACTIONS(1236),
    [anon_sym_trait] = ACTIONS(1236),
    [anon_sym_struct] = ACTIONS(1236),
    [anon_sym_embed] = ACTIONS(1236),
    [anon_sym_let] = ACTIONS(1236),
    [anon_sym_var] = ACTIONS(1236),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_fun] = ACTIONS(1236),
    [anon_sym_be] = ACTIONS(1236),
    [anon_sym_COMMA] = ACTIONS(1236),
    [anon_sym_LPAREN] = ACTIONS(1238),
    [anon_sym_RPAREN] = ACTIONS(1236),
    [anon_sym_DOT] = ACTIONS(1238),
    [anon_sym_LBRACE] = ACTIONS(1236),
    [anon_sym_SEMI] = ACTIONS(1236),
    [sym_error] = ACTIONS(1236),
    [sym_compile_intrinsic] = ACTIONS(1236),
    [anon_sym_compile_error] = ACTIONS(1236),
    [sym_location] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_not] = ACTIONS(1236),
    [anon_sym_DASH_TILDE] = ACTIONS(1236),
    [anon_sym_addressof] = ACTIONS(1236),
    [anon_sym_digestof] = ACTIONS(1236),
    [anon_sym_PLUS] = ACTIONS(1238),
    [anon_sym_STAR] = ACTIONS(1238),
    [anon_sym_SLASH] = ACTIONS(1238),
    [anon_sym_PERCENT] = ACTIONS(1238),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1238),
    [anon_sym_LT_LT] = ACTIONS(1238),
    [anon_sym_GT_GT] = ACTIONS(1238),
    [anon_sym_and] = ACTIONS(1236),
    [anon_sym_or] = ACTIONS(1236),
    [anon_sym_xor] = ACTIONS(1236),
    [anon_sym_isnt] = ACTIONS(1236),
    [anon_sym_EQ_EQ] = ACTIONS(1238),
    [anon_sym_BANG_EQ] = ACTIONS(1238),
    [anon_sym_GT] = ACTIONS(1238),
    [anon_sym_GT_EQ] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(1238),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_PLUS_TILDE] = ACTIONS(1236),
    [anon_sym_STAR_TILDE] = ACTIONS(1236),
    [anon_sym_SLASH_TILDE] = ACTIONS(1236),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1236),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1236),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1236),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1236),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1236),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1236),
    [anon_sym_GT_TILDE] = ACTIONS(1236),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1236),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1236),
    [anon_sym_LT_TILDE] = ACTIONS(1236),
    [anon_sym_PLUS_QMARK] = ACTIONS(1236),
    [anon_sym_DASH_QMARK] = ACTIONS(1236),
    [anon_sym_STAR_QMARK] = ACTIONS(1236),
    [anon_sym_SLASH_QMARK] = ACTIONS(1236),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1236),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1236),
    [anon_sym_as] = ACTIONS(1236),
    [anon_sym_LPAREN2] = ACTIONS(1236),
    [anon_sym_DOT_GT] = ACTIONS(1236),
    [anon_sym_where] = ACTIONS(1236),
    [anon_sym_TILDE] = ACTIONS(1236),
    [anon_sym_end] = ACTIONS(1236),
    [anon_sym_if] = ACTIONS(1238),
    [anon_sym_ifdef] = ACTIONS(1236),
    [anon_sym_iftype] = ACTIONS(1236),
    [anon_sym_else] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1236),
    [anon_sym_while] = ACTIONS(1236),
    [anon_sym_try] = ACTIONS(1236),
    [anon_sym_with] = ACTIONS(1236),
    [anon_sym_repeat] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(1236),
    [anon_sym_recover] = ACTIONS(1236),
    [anon_sym_match] = ACTIONS(1236),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_continue] = ACTIONS(1236),
    [anon_sym_break] = ACTIONS(1236),
    [anon_sym_consume] = ACTIONS(1236),
    [anon_sym_object] = ACTIONS(1236),
    [sym_number] = ACTIONS(1238),
    [sym_float] = ACTIONS(1236),
    [anon_sym_DQUOTE] = ACTIONS(1238),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1236),
    [anon_sym_SQUOTE] = ACTIONS(1236),
    [anon_sym_true] = ACTIONS(1236),
    [anon_sym_false] = ACTIONS(1236),
    [sym_this] = ACTIONS(1236),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [279] = {
    [ts_builtin_sym_end] = ACTIONS(1240),
    [sym_identifier] = ACTIONS(1242),
    [anon_sym_use] = ACTIONS(1240),
    [anon_sym_EQ] = ACTIONS(1242),
    [anon_sym_AT] = ACTIONS(1240),
    [anon_sym_LBRACK] = ACTIONS(1240),
    [anon_sym_type] = ACTIONS(1240),
    [anon_sym_is] = ACTIONS(1242),
    [anon_sym_actor] = ACTIONS(1240),
    [anon_sym_class] = ACTIONS(1240),
    [anon_sym_primitive] = ACTIONS(1240),
    [anon_sym_interface] = ACTIONS(1240),
    [anon_sym_trait] = ACTIONS(1240),
    [anon_sym_struct] = ACTIONS(1240),
    [anon_sym_embed] = ACTIONS(1240),
    [anon_sym_let] = ACTIONS(1240),
    [anon_sym_var] = ACTIONS(1240),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_fun] = ACTIONS(1240),
    [anon_sym_be] = ACTIONS(1240),
    [anon_sym_COMMA] = ACTIONS(1240),
    [anon_sym_LPAREN] = ACTIONS(1242),
    [anon_sym_RPAREN] = ACTIONS(1240),
    [anon_sym_DOT] = ACTIONS(1242),
    [anon_sym_LBRACE] = ACTIONS(1240),
    [anon_sym_SEMI] = ACTIONS(1240),
    [sym_error] = ACTIONS(1240),
    [sym_compile_intrinsic] = ACTIONS(1240),
    [anon_sym_compile_error] = ACTIONS(1240),
    [sym_location] = ACTIONS(1240),
    [anon_sym_DASH] = ACTIONS(1242),
    [anon_sym_not] = ACTIONS(1240),
    [anon_sym_DASH_TILDE] = ACTIONS(1240),
    [anon_sym_addressof] = ACTIONS(1240),
    [anon_sym_digestof] = ACTIONS(1240),
    [anon_sym_PLUS] = ACTIONS(1242),
    [anon_sym_STAR] = ACTIONS(1242),
    [anon_sym_SLASH] = ACTIONS(1242),
    [anon_sym_PERCENT] = ACTIONS(1242),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1242),
    [anon_sym_LT_LT] = ACTIONS(1242),
    [anon_sym_GT_GT] = ACTIONS(1242),
    [anon_sym_and] = ACTIONS(1240),
    [anon_sym_or] = ACTIONS(1240),
    [anon_sym_xor] = ACTIONS(1240),
    [anon_sym_isnt] = ACTIONS(1240),
    [anon_sym_EQ_EQ] = ACTIONS(1242),
    [anon_sym_BANG_EQ] = ACTIONS(1242),
    [anon_sym_GT] = ACTIONS(1242),
    [anon_sym_GT_EQ] = ACTIONS(1242),
    [anon_sym_LT_EQ] = ACTIONS(1242),
    [anon_sym_LT] = ACTIONS(1242),
    [anon_sym_PLUS_TILDE] = ACTIONS(1240),
    [anon_sym_STAR_TILDE] = ACTIONS(1240),
    [anon_sym_SLASH_TILDE] = ACTIONS(1240),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1240),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1240),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1240),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1240),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1240),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1240),
    [anon_sym_GT_TILDE] = ACTIONS(1240),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1240),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1240),
    [anon_sym_LT_TILDE] = ACTIONS(1240),
    [anon_sym_PLUS_QMARK] = ACTIONS(1240),
    [anon_sym_DASH_QMARK] = ACTIONS(1240),
    [anon_sym_STAR_QMARK] = ACTIONS(1240),
    [anon_sym_SLASH_QMARK] = ACTIONS(1240),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1240),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1240),
    [anon_sym_as] = ACTIONS(1240),
    [anon_sym_LPAREN2] = ACTIONS(1240),
    [anon_sym_DOT_GT] = ACTIONS(1240),
    [anon_sym_where] = ACTIONS(1240),
    [anon_sym_TILDE] = ACTIONS(1240),
    [anon_sym_end] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(1242),
    [anon_sym_ifdef] = ACTIONS(1240),
    [anon_sym_iftype] = ACTIONS(1240),
    [anon_sym_else] = ACTIONS(1240),
    [anon_sym_for] = ACTIONS(1240),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_try] = ACTIONS(1240),
    [anon_sym_with] = ACTIONS(1240),
    [anon_sym_repeat] = ACTIONS(1240),
    [anon_sym_do] = ACTIONS(1240),
    [anon_sym_recover] = ACTIONS(1240),
    [anon_sym_match] = ACTIONS(1240),
    [anon_sym_return] = ACTIONS(1240),
    [anon_sym_continue] = ACTIONS(1240),
    [anon_sym_break] = ACTIONS(1240),
    [anon_sym_consume] = ACTIONS(1240),
    [anon_sym_object] = ACTIONS(1240),
    [sym_number] = ACTIONS(1242),
    [sym_float] = ACTIONS(1240),
    [anon_sym_DQUOTE] = ACTIONS(1242),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1240),
    [anon_sym_true] = ACTIONS(1240),
    [anon_sym_false] = ACTIONS(1240),
    [sym_this] = ACTIONS(1240),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [280] = {
    [ts_builtin_sym_end] = ACTIONS(1244),
    [sym_identifier] = ACTIONS(1246),
    [anon_sym_use] = ACTIONS(1244),
    [anon_sym_EQ] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(1244),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_type] = ACTIONS(1244),
    [anon_sym_is] = ACTIONS(1246),
    [anon_sym_actor] = ACTIONS(1244),
    [anon_sym_class] = ACTIONS(1244),
    [anon_sym_primitive] = ACTIONS(1244),
    [anon_sym_interface] = ACTIONS(1244),
    [anon_sym_trait] = ACTIONS(1244),
    [anon_sym_struct] = ACTIONS(1244),
    [anon_sym_embed] = ACTIONS(1244),
    [anon_sym_let] = ACTIONS(1244),
    [anon_sym_var] = ACTIONS(1244),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_fun] = ACTIONS(1244),
    [anon_sym_be] = ACTIONS(1244),
    [anon_sym_COMMA] = ACTIONS(1244),
    [anon_sym_LPAREN] = ACTIONS(1246),
    [anon_sym_RPAREN] = ACTIONS(1244),
    [anon_sym_DOT] = ACTIONS(1246),
    [anon_sym_LBRACE] = ACTIONS(1244),
    [anon_sym_SEMI] = ACTIONS(1244),
    [sym_error] = ACTIONS(1244),
    [sym_compile_intrinsic] = ACTIONS(1244),
    [anon_sym_compile_error] = ACTIONS(1244),
    [sym_location] = ACTIONS(1244),
    [anon_sym_DASH] = ACTIONS(1246),
    [anon_sym_not] = ACTIONS(1244),
    [anon_sym_DASH_TILDE] = ACTIONS(1244),
    [anon_sym_addressof] = ACTIONS(1244),
    [anon_sym_digestof] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1246),
    [anon_sym_STAR] = ACTIONS(1246),
    [anon_sym_SLASH] = ACTIONS(1246),
    [anon_sym_PERCENT] = ACTIONS(1246),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1246),
    [anon_sym_LT_LT] = ACTIONS(1246),
    [anon_sym_GT_GT] = ACTIONS(1246),
    [anon_sym_and] = ACTIONS(1244),
    [anon_sym_or] = ACTIONS(1244),
    [anon_sym_xor] = ACTIONS(1244),
    [anon_sym_isnt] = ACTIONS(1244),
    [anon_sym_EQ_EQ] = ACTIONS(1246),
    [anon_sym_BANG_EQ] = ACTIONS(1246),
    [anon_sym_GT] = ACTIONS(1246),
    [anon_sym_GT_EQ] = ACTIONS(1246),
    [anon_sym_LT_EQ] = ACTIONS(1246),
    [anon_sym_LT] = ACTIONS(1246),
    [anon_sym_PLUS_TILDE] = ACTIONS(1244),
    [anon_sym_STAR_TILDE] = ACTIONS(1244),
    [anon_sym_SLASH_TILDE] = ACTIONS(1244),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1244),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1244),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1244),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1244),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1244),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1244),
    [anon_sym_GT_TILDE] = ACTIONS(1244),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1244),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1244),
    [anon_sym_LT_TILDE] = ACTIONS(1244),
    [anon_sym_PLUS_QMARK] = ACTIONS(1244),
    [anon_sym_DASH_QMARK] = ACTIONS(1244),
    [anon_sym_STAR_QMARK] = ACTIONS(1244),
    [anon_sym_SLASH_QMARK] = ACTIONS(1244),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1244),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1244),
    [anon_sym_as] = ACTIONS(1244),
    [anon_sym_LPAREN2] = ACTIONS(1244),
    [anon_sym_DOT_GT] = ACTIONS(1244),
    [anon_sym_where] = ACTIONS(1244),
    [anon_sym_TILDE] = ACTIONS(1244),
    [anon_sym_end] = ACTIONS(1244),
    [anon_sym_if] = ACTIONS(1246),
    [anon_sym_ifdef] = ACTIONS(1244),
    [anon_sym_iftype] = ACTIONS(1244),
    [anon_sym_else] = ACTIONS(1244),
    [anon_sym_for] = ACTIONS(1244),
    [anon_sym_while] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_with] = ACTIONS(1244),
    [anon_sym_repeat] = ACTIONS(1244),
    [anon_sym_do] = ACTIONS(1244),
    [anon_sym_recover] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1244),
    [anon_sym_return] = ACTIONS(1244),
    [anon_sym_continue] = ACTIONS(1244),
    [anon_sym_break] = ACTIONS(1244),
    [anon_sym_consume] = ACTIONS(1244),
    [anon_sym_object] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_float] = ACTIONS(1244),
    [anon_sym_DQUOTE] = ACTIONS(1246),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1244),
    [anon_sym_true] = ACTIONS(1244),
    [anon_sym_false] = ACTIONS(1244),
    [sym_this] = ACTIONS(1244),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [281] = {
    [ts_builtin_sym_end] = ACTIONS(1248),
    [sym_identifier] = ACTIONS(1250),
    [anon_sym_use] = ACTIONS(1248),
    [anon_sym_EQ] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1248),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_type] = ACTIONS(1248),
    [anon_sym_is] = ACTIONS(1250),
    [anon_sym_actor] = ACTIONS(1248),
    [anon_sym_class] = ACTIONS(1248),
    [anon_sym_primitive] = ACTIONS(1248),
    [anon_sym_interface] = ACTIONS(1248),
    [anon_sym_trait] = ACTIONS(1248),
    [anon_sym_struct] = ACTIONS(1248),
    [anon_sym_embed] = ACTIONS(1248),
    [anon_sym_let] = ACTIONS(1248),
    [anon_sym_var] = ACTIONS(1248),
    [anon_sym_new] = ACTIONS(1248),
    [anon_sym_fun] = ACTIONS(1248),
    [anon_sym_be] = ACTIONS(1248),
    [anon_sym_COMMA] = ACTIONS(1248),
    [anon_sym_LPAREN] = ACTIONS(1250),
    [anon_sym_RPAREN] = ACTIONS(1248),
    [anon_sym_DOT] = ACTIONS(1250),
    [anon_sym_LBRACE] = ACTIONS(1248),
    [anon_sym_SEMI] = ACTIONS(1248),
    [sym_error] = ACTIONS(1248),
    [sym_compile_intrinsic] = ACTIONS(1248),
    [anon_sym_compile_error] = ACTIONS(1248),
    [sym_location] = ACTIONS(1248),
    [anon_sym_DASH] = ACTIONS(1250),
    [anon_sym_not] = ACTIONS(1248),
    [anon_sym_DASH_TILDE] = ACTIONS(1248),
    [anon_sym_addressof] = ACTIONS(1248),
    [anon_sym_digestof] = ACTIONS(1248),
    [anon_sym_PLUS] = ACTIONS(1250),
    [anon_sym_STAR] = ACTIONS(1250),
    [anon_sym_SLASH] = ACTIONS(1250),
    [anon_sym_PERCENT] = ACTIONS(1250),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1250),
    [anon_sym_LT_LT] = ACTIONS(1250),
    [anon_sym_GT_GT] = ACTIONS(1250),
    [anon_sym_and] = ACTIONS(1248),
    [anon_sym_or] = ACTIONS(1248),
    [anon_sym_xor] = ACTIONS(1248),
    [anon_sym_isnt] = ACTIONS(1248),
    [anon_sym_EQ_EQ] = ACTIONS(1250),
    [anon_sym_BANG_EQ] = ACTIONS(1250),
    [anon_sym_GT] = ACTIONS(1250),
    [anon_sym_GT_EQ] = ACTIONS(1250),
    [anon_sym_LT_EQ] = ACTIONS(1250),
    [anon_sym_LT] = ACTIONS(1250),
    [anon_sym_PLUS_TILDE] = ACTIONS(1248),
    [anon_sym_STAR_TILDE] = ACTIONS(1248),
    [anon_sym_SLASH_TILDE] = ACTIONS(1248),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1248),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1248),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1248),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1248),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1248),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1248),
    [anon_sym_GT_TILDE] = ACTIONS(1248),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1248),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1248),
    [anon_sym_LT_TILDE] = ACTIONS(1248),
    [anon_sym_PLUS_QMARK] = ACTIONS(1248),
    [anon_sym_DASH_QMARK] = ACTIONS(1248),
    [anon_sym_STAR_QMARK] = ACTIONS(1248),
    [anon_sym_SLASH_QMARK] = ACTIONS(1248),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1248),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1248),
    [anon_sym_as] = ACTIONS(1248),
    [anon_sym_LPAREN2] = ACTIONS(1248),
    [anon_sym_DOT_GT] = ACTIONS(1248),
    [anon_sym_where] = ACTIONS(1248),
    [anon_sym_TILDE] = ACTIONS(1248),
    [anon_sym_end] = ACTIONS(1248),
    [anon_sym_if] = ACTIONS(1250),
    [anon_sym_ifdef] = ACTIONS(1248),
    [anon_sym_iftype] = ACTIONS(1248),
    [anon_sym_else] = ACTIONS(1248),
    [anon_sym_for] = ACTIONS(1248),
    [anon_sym_while] = ACTIONS(1248),
    [anon_sym_try] = ACTIONS(1248),
    [anon_sym_with] = ACTIONS(1248),
    [anon_sym_repeat] = ACTIONS(1248),
    [anon_sym_do] = ACTIONS(1248),
    [anon_sym_recover] = ACTIONS(1248),
    [anon_sym_match] = ACTIONS(1248),
    [anon_sym_return] = ACTIONS(1248),
    [anon_sym_continue] = ACTIONS(1248),
    [anon_sym_break] = ACTIONS(1248),
    [anon_sym_consume] = ACTIONS(1248),
    [anon_sym_object] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_float] = ACTIONS(1248),
    [anon_sym_DQUOTE] = ACTIONS(1250),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_true] = ACTIONS(1248),
    [anon_sym_false] = ACTIONS(1248),
    [sym_this] = ACTIONS(1248),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [282] = {
    [ts_builtin_sym_end] = ACTIONS(1252),
    [sym_identifier] = ACTIONS(1254),
    [anon_sym_use] = ACTIONS(1252),
    [anon_sym_EQ] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_LBRACK] = ACTIONS(1252),
    [anon_sym_type] = ACTIONS(1252),
    [anon_sym_is] = ACTIONS(1254),
    [anon_sym_actor] = ACTIONS(1252),
    [anon_sym_class] = ACTIONS(1252),
    [anon_sym_primitive] = ACTIONS(1252),
    [anon_sym_interface] = ACTIONS(1252),
    [anon_sym_trait] = ACTIONS(1252),
    [anon_sym_struct] = ACTIONS(1252),
    [anon_sym_embed] = ACTIONS(1252),
    [anon_sym_let] = ACTIONS(1252),
    [anon_sym_var] = ACTIONS(1252),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_fun] = ACTIONS(1252),
    [anon_sym_be] = ACTIONS(1252),
    [anon_sym_COMMA] = ACTIONS(1252),
    [anon_sym_LPAREN] = ACTIONS(1254),
    [anon_sym_RPAREN] = ACTIONS(1252),
    [anon_sym_DOT] = ACTIONS(1254),
    [anon_sym_LBRACE] = ACTIONS(1252),
    [anon_sym_SEMI] = ACTIONS(1252),
    [sym_error] = ACTIONS(1252),
    [sym_compile_intrinsic] = ACTIONS(1252),
    [anon_sym_compile_error] = ACTIONS(1252),
    [sym_location] = ACTIONS(1252),
    [anon_sym_DASH] = ACTIONS(1254),
    [anon_sym_not] = ACTIONS(1252),
    [anon_sym_DASH_TILDE] = ACTIONS(1252),
    [anon_sym_addressof] = ACTIONS(1252),
    [anon_sym_digestof] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1254),
    [anon_sym_STAR] = ACTIONS(1254),
    [anon_sym_SLASH] = ACTIONS(1254),
    [anon_sym_PERCENT] = ACTIONS(1254),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1254),
    [anon_sym_LT_LT] = ACTIONS(1254),
    [anon_sym_GT_GT] = ACTIONS(1254),
    [anon_sym_and] = ACTIONS(1252),
    [anon_sym_or] = ACTIONS(1252),
    [anon_sym_xor] = ACTIONS(1252),
    [anon_sym_isnt] = ACTIONS(1252),
    [anon_sym_EQ_EQ] = ACTIONS(1254),
    [anon_sym_BANG_EQ] = ACTIONS(1254),
    [anon_sym_GT] = ACTIONS(1254),
    [anon_sym_GT_EQ] = ACTIONS(1254),
    [anon_sym_LT_EQ] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1254),
    [anon_sym_PLUS_TILDE] = ACTIONS(1252),
    [anon_sym_STAR_TILDE] = ACTIONS(1252),
    [anon_sym_SLASH_TILDE] = ACTIONS(1252),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1252),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1252),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1252),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1252),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1252),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1252),
    [anon_sym_GT_TILDE] = ACTIONS(1252),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1252),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1252),
    [anon_sym_LT_TILDE] = ACTIONS(1252),
    [anon_sym_PLUS_QMARK] = ACTIONS(1252),
    [anon_sym_DASH_QMARK] = ACTIONS(1252),
    [anon_sym_STAR_QMARK] = ACTIONS(1252),
    [anon_sym_SLASH_QMARK] = ACTIONS(1252),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1252),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1252),
    [anon_sym_as] = ACTIONS(1252),
    [anon_sym_LPAREN2] = ACTIONS(1252),
    [anon_sym_DOT_GT] = ACTIONS(1252),
    [anon_sym_where] = ACTIONS(1252),
    [anon_sym_TILDE] = ACTIONS(1252),
    [anon_sym_end] = ACTIONS(1252),
    [anon_sym_if] = ACTIONS(1254),
    [anon_sym_ifdef] = ACTIONS(1252),
    [anon_sym_iftype] = ACTIONS(1252),
    [anon_sym_else] = ACTIONS(1252),
    [anon_sym_for] = ACTIONS(1252),
    [anon_sym_while] = ACTIONS(1252),
    [anon_sym_try] = ACTIONS(1252),
    [anon_sym_with] = ACTIONS(1252),
    [anon_sym_repeat] = ACTIONS(1252),
    [anon_sym_do] = ACTIONS(1252),
    [anon_sym_recover] = ACTIONS(1252),
    [anon_sym_match] = ACTIONS(1252),
    [anon_sym_return] = ACTIONS(1252),
    [anon_sym_continue] = ACTIONS(1252),
    [anon_sym_break] = ACTIONS(1252),
    [anon_sym_consume] = ACTIONS(1252),
    [anon_sym_object] = ACTIONS(1252),
    [sym_number] = ACTIONS(1254),
    [sym_float] = ACTIONS(1252),
    [anon_sym_DQUOTE] = ACTIONS(1254),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1252),
    [anon_sym_SQUOTE] = ACTIONS(1252),
    [anon_sym_true] = ACTIONS(1252),
    [anon_sym_false] = ACTIONS(1252),
    [sym_this] = ACTIONS(1252),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [283] = {
    [ts_builtin_sym_end] = ACTIONS(865),
    [sym_identifier] = ACTIONS(867),
    [anon_sym_use] = ACTIONS(865),
    [anon_sym_EQ] = ACTIONS(867),
    [anon_sym_AT] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(865),
    [anon_sym_type] = ACTIONS(865),
    [anon_sym_is] = ACTIONS(867),
    [anon_sym_actor] = ACTIONS(865),
    [anon_sym_class] = ACTIONS(865),
    [anon_sym_primitive] = ACTIONS(865),
    [anon_sym_interface] = ACTIONS(865),
    [anon_sym_trait] = ACTIONS(865),
    [anon_sym_struct] = ACTIONS(865),
    [anon_sym_embed] = ACTIONS(865),
    [anon_sym_let] = ACTIONS(865),
    [anon_sym_var] = ACTIONS(865),
    [anon_sym_new] = ACTIONS(865),
    [anon_sym_fun] = ACTIONS(865),
    [anon_sym_be] = ACTIONS(865),
    [anon_sym_COMMA] = ACTIONS(865),
    [anon_sym_LPAREN] = ACTIONS(867),
    [anon_sym_RPAREN] = ACTIONS(865),
    [anon_sym_DOT] = ACTIONS(867),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_SEMI] = ACTIONS(865),
    [sym_error] = ACTIONS(865),
    [sym_compile_intrinsic] = ACTIONS(865),
    [anon_sym_compile_error] = ACTIONS(865),
    [sym_location] = ACTIONS(865),
    [anon_sym_DASH] = ACTIONS(867),
    [anon_sym_not] = ACTIONS(865),
    [anon_sym_DASH_TILDE] = ACTIONS(865),
    [anon_sym_addressof] = ACTIONS(865),
    [anon_sym_digestof] = ACTIONS(865),
    [anon_sym_PLUS] = ACTIONS(867),
    [anon_sym_STAR] = ACTIONS(867),
    [anon_sym_SLASH] = ACTIONS(867),
    [anon_sym_PERCENT] = ACTIONS(867),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(867),
    [anon_sym_LT_LT] = ACTIONS(867),
    [anon_sym_GT_GT] = ACTIONS(867),
    [anon_sym_and] = ACTIONS(865),
    [anon_sym_or] = ACTIONS(865),
    [anon_sym_xor] = ACTIONS(865),
    [anon_sym_isnt] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(867),
    [anon_sym_BANG_EQ] = ACTIONS(867),
    [anon_sym_GT] = ACTIONS(867),
    [anon_sym_GT_EQ] = ACTIONS(867),
    [anon_sym_LT_EQ] = ACTIONS(867),
    [anon_sym_LT] = ACTIONS(867),
    [anon_sym_PLUS_TILDE] = ACTIONS(865),
    [anon_sym_STAR_TILDE] = ACTIONS(865),
    [anon_sym_SLASH_TILDE] = ACTIONS(865),
    [anon_sym_PERCENT_TILDE] = ACTIONS(865),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(865),
    [anon_sym_LT_LT_TILDE] = ACTIONS(865),
    [anon_sym_GT_GT_TILDE] = ACTIONS(865),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(865),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(865),
    [anon_sym_GT_TILDE] = ACTIONS(865),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(865),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(865),
    [anon_sym_LT_TILDE] = ACTIONS(865),
    [anon_sym_PLUS_QMARK] = ACTIONS(865),
    [anon_sym_DASH_QMARK] = ACTIONS(865),
    [anon_sym_STAR_QMARK] = ACTIONS(865),
    [anon_sym_SLASH_QMARK] = ACTIONS(865),
    [anon_sym_PERCENT_QMARK] = ACTIONS(865),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(865),
    [anon_sym_LPAREN2] = ACTIONS(865),
    [anon_sym_DOT_GT] = ACTIONS(865),
    [anon_sym_where] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [anon_sym_end] = ACTIONS(865),
    [anon_sym_if] = ACTIONS(867),
    [anon_sym_ifdef] = ACTIONS(865),
    [anon_sym_iftype] = ACTIONS(865),
    [anon_sym_else] = ACTIONS(865),
    [anon_sym_for] = ACTIONS(865),
    [anon_sym_while] = ACTIONS(865),
    [anon_sym_try] = ACTIONS(865),
    [anon_sym_with] = ACTIONS(865),
    [anon_sym_repeat] = ACTIONS(865),
    [anon_sym_do] = ACTIONS(865),
    [anon_sym_recover] = ACTIONS(865),
    [anon_sym_match] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(865),
    [anon_sym_continue] = ACTIONS(865),
    [anon_sym_break] = ACTIONS(865),
    [anon_sym_consume] = ACTIONS(865),
    [anon_sym_object] = ACTIONS(865),
    [sym_number] = ACTIONS(867),
    [sym_float] = ACTIONS(865),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(865),
    [anon_sym_false] = ACTIONS(865),
    [sym_this] = ACTIONS(865),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [284] = {
    [sym_identifier] = ACTIONS(640),
    [anon_sym_EQ] = ACTIONS(640),
    [anon_sym_AT] = ACTIONS(638),
    [anon_sym_LBRACK] = ACTIONS(638),
    [anon_sym_is] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(638),
    [anon_sym_var] = ACTIONS(638),
    [anon_sym_iso] = ACTIONS(638),
    [anon_sym_trn] = ACTIONS(638),
    [anon_sym_ref] = ACTIONS(638),
    [anon_sym_val] = ACTIONS(638),
    [anon_sym_box] = ACTIONS(638),
    [anon_sym_tag] = ACTIONS(638),
    [anon_sym_LPAREN] = ACTIONS(640),
    [anon_sym_DOT] = ACTIONS(640),
    [anon_sym_POUNDread] = ACTIONS(638),
    [anon_sym_POUNDsend] = ACTIONS(638),
    [anon_sym_POUNDshare] = ACTIONS(638),
    [anon_sym_POUNDalias] = ACTIONS(638),
    [anon_sym_POUNDany] = ACTIONS(638),
    [anon_sym_BANG] = ACTIONS(640),
    [anon_sym_CARET] = ACTIONS(638),
    [anon_sym_PIPE] = ACTIONS(638),
    [anon_sym_AMP] = ACTIONS(638),
    [anon_sym_DASH_GT] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(638),
    [anon_sym_SEMI] = ACTIONS(638),
    [sym_error] = ACTIONS(638),
    [sym_compile_intrinsic] = ACTIONS(638),
    [anon_sym_compile_error] = ACTIONS(638),
    [sym_location] = ACTIONS(638),
    [anon_sym_DASH] = ACTIONS(640),
    [anon_sym_not] = ACTIONS(638),
    [anon_sym_DASH_TILDE] = ACTIONS(638),
    [anon_sym_addressof] = ACTIONS(638),
    [anon_sym_digestof] = ACTIONS(638),
    [anon_sym_PLUS] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(640),
    [anon_sym_SLASH] = ACTIONS(640),
    [anon_sym_PERCENT] = ACTIONS(640),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(640),
    [anon_sym_LT_LT] = ACTIONS(640),
    [anon_sym_GT_GT] = ACTIONS(640),
    [anon_sym_and] = ACTIONS(638),
    [anon_sym_or] = ACTIONS(638),
    [anon_sym_xor] = ACTIONS(638),
    [anon_sym_isnt] = ACTIONS(638),
    [anon_sym_EQ_EQ] = ACTIONS(640),
    [anon_sym_BANG_EQ] = ACTIONS(640),
    [anon_sym_GT] = ACTIONS(640),
    [anon_sym_GT_EQ] = ACTIONS(640),
    [anon_sym_LT_EQ] = ACTIONS(640),
    [anon_sym_LT] = ACTIONS(640),
    [anon_sym_PLUS_TILDE] = ACTIONS(638),
    [anon_sym_STAR_TILDE] = ACTIONS(638),
    [anon_sym_SLASH_TILDE] = ACTIONS(638),
    [anon_sym_PERCENT_TILDE] = ACTIONS(638),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(638),
    [anon_sym_LT_LT_TILDE] = ACTIONS(638),
    [anon_sym_GT_GT_TILDE] = ACTIONS(638),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(638),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(638),
    [anon_sym_GT_TILDE] = ACTIONS(638),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(638),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(638),
    [anon_sym_LT_TILDE] = ACTIONS(638),
    [anon_sym_PLUS_QMARK] = ACTIONS(638),
    [anon_sym_DASH_QMARK] = ACTIONS(638),
    [anon_sym_STAR_QMARK] = ACTIONS(638),
    [anon_sym_SLASH_QMARK] = ACTIONS(638),
    [anon_sym_PERCENT_QMARK] = ACTIONS(638),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(638),
    [anon_sym_as] = ACTIONS(638),
    [anon_sym_LPAREN2] = ACTIONS(638),
    [anon_sym_DOT_GT] = ACTIONS(638),
    [anon_sym_TILDE] = ACTIONS(638),
    [anon_sym_end] = ACTIONS(638),
    [anon_sym_if] = ACTIONS(640),
    [anon_sym_ifdef] = ACTIONS(638),
    [anon_sym_elseif] = ACTIONS(638),
    [anon_sym_iftype] = ACTIONS(638),
    [anon_sym_else] = ACTIONS(640),
    [anon_sym_for] = ACTIONS(638),
    [anon_sym_while] = ACTIONS(638),
    [anon_sym_try] = ACTIONS(638),
    [anon_sym_with] = ACTIONS(638),
    [anon_sym_repeat] = ACTIONS(638),
    [anon_sym_recover] = ACTIONS(638),
    [anon_sym_match] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(638),
    [anon_sym_continue] = ACTIONS(638),
    [anon_sym_break] = ACTIONS(638),
    [anon_sym_consume] = ACTIONS(638),
    [anon_sym_object] = ACTIONS(638),
    [sym_number] = ACTIONS(640),
    [sym_float] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(640),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(638),
    [anon_sym_SQUOTE] = ACTIONS(638),
    [anon_sym_true] = ACTIONS(638),
    [anon_sym_false] = ACTIONS(638),
    [sym_this] = ACTIONS(638),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [285] = {
    [sym_identifier] = ACTIONS(668),
    [anon_sym_EQ] = ACTIONS(668),
    [anon_sym_AT] = ACTIONS(666),
    [anon_sym_LBRACK] = ACTIONS(666),
    [anon_sym_is] = ACTIONS(668),
    [anon_sym_let] = ACTIONS(666),
    [anon_sym_var] = ACTIONS(666),
    [anon_sym_iso] = ACTIONS(666),
    [anon_sym_trn] = ACTIONS(666),
    [anon_sym_ref] = ACTIONS(666),
    [anon_sym_val] = ACTIONS(666),
    [anon_sym_box] = ACTIONS(666),
    [anon_sym_tag] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(668),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_POUNDread] = ACTIONS(666),
    [anon_sym_POUNDsend] = ACTIONS(666),
    [anon_sym_POUNDshare] = ACTIONS(666),
    [anon_sym_POUNDalias] = ACTIONS(666),
    [anon_sym_POUNDany] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(666),
    [anon_sym_DASH_GT] = ACTIONS(666),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(666),
    [sym_error] = ACTIONS(666),
    [sym_compile_intrinsic] = ACTIONS(666),
    [anon_sym_compile_error] = ACTIONS(666),
    [sym_location] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(668),
    [anon_sym_not] = ACTIONS(666),
    [anon_sym_DASH_TILDE] = ACTIONS(666),
    [anon_sym_addressof] = ACTIONS(666),
    [anon_sym_digestof] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(668),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(668),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(668),
    [anon_sym_LT_LT] = ACTIONS(668),
    [anon_sym_GT_GT] = ACTIONS(668),
    [anon_sym_and] = ACTIONS(666),
    [anon_sym_or] = ACTIONS(666),
    [anon_sym_xor] = ACTIONS(666),
    [anon_sym_isnt] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(668),
    [anon_sym_BANG_EQ] = ACTIONS(668),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_GT_EQ] = ACTIONS(668),
    [anon_sym_LT_EQ] = ACTIONS(668),
    [anon_sym_LT] = ACTIONS(668),
    [anon_sym_PLUS_TILDE] = ACTIONS(666),
    [anon_sym_STAR_TILDE] = ACTIONS(666),
    [anon_sym_SLASH_TILDE] = ACTIONS(666),
    [anon_sym_PERCENT_TILDE] = ACTIONS(666),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(666),
    [anon_sym_LT_LT_TILDE] = ACTIONS(666),
    [anon_sym_GT_GT_TILDE] = ACTIONS(666),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(666),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(666),
    [anon_sym_GT_TILDE] = ACTIONS(666),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(666),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(666),
    [anon_sym_LT_TILDE] = ACTIONS(666),
    [anon_sym_PLUS_QMARK] = ACTIONS(666),
    [anon_sym_DASH_QMARK] = ACTIONS(666),
    [anon_sym_STAR_QMARK] = ACTIONS(666),
    [anon_sym_SLASH_QMARK] = ACTIONS(666),
    [anon_sym_PERCENT_QMARK] = ACTIONS(666),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(666),
    [anon_sym_LPAREN2] = ACTIONS(666),
    [anon_sym_DOT_GT] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_end] = ACTIONS(666),
    [anon_sym_if] = ACTIONS(668),
    [anon_sym_ifdef] = ACTIONS(666),
    [anon_sym_elseif] = ACTIONS(666),
    [anon_sym_iftype] = ACTIONS(666),
    [anon_sym_else] = ACTIONS(668),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_while] = ACTIONS(666),
    [anon_sym_try] = ACTIONS(666),
    [anon_sym_with] = ACTIONS(666),
    [anon_sym_repeat] = ACTIONS(666),
    [anon_sym_recover] = ACTIONS(666),
    [anon_sym_match] = ACTIONS(666),
    [anon_sym_return] = ACTIONS(666),
    [anon_sym_continue] = ACTIONS(666),
    [anon_sym_break] = ACTIONS(666),
    [anon_sym_consume] = ACTIONS(666),
    [anon_sym_object] = ACTIONS(666),
    [sym_number] = ACTIONS(668),
    [sym_float] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(666),
    [anon_sym_SQUOTE] = ACTIONS(666),
    [anon_sym_true] = ACTIONS(666),
    [anon_sym_false] = ACTIONS(666),
    [sym_this] = ACTIONS(666),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [286] = {
    [ts_builtin_sym_end] = ACTIONS(1256),
    [sym_identifier] = ACTIONS(1258),
    [anon_sym_use] = ACTIONS(1256),
    [anon_sym_EQ] = ACTIONS(1258),
    [anon_sym_AT] = ACTIONS(1256),
    [anon_sym_LBRACK] = ACTIONS(1256),
    [anon_sym_type] = ACTIONS(1256),
    [anon_sym_is] = ACTIONS(1258),
    [anon_sym_actor] = ACTIONS(1256),
    [anon_sym_class] = ACTIONS(1256),
    [anon_sym_primitive] = ACTIONS(1256),
    [anon_sym_interface] = ACTIONS(1256),
    [anon_sym_trait] = ACTIONS(1256),
    [anon_sym_struct] = ACTIONS(1256),
    [anon_sym_embed] = ACTIONS(1256),
    [anon_sym_let] = ACTIONS(1256),
    [anon_sym_var] = ACTIONS(1256),
    [anon_sym_new] = ACTIONS(1256),
    [anon_sym_fun] = ACTIONS(1256),
    [anon_sym_be] = ACTIONS(1256),
    [anon_sym_COMMA] = ACTIONS(1256),
    [anon_sym_LPAREN] = ACTIONS(1258),
    [anon_sym_RPAREN] = ACTIONS(1256),
    [anon_sym_DOT] = ACTIONS(1258),
    [anon_sym_LBRACE] = ACTIONS(1256),
    [anon_sym_SEMI] = ACTIONS(1256),
    [sym_error] = ACTIONS(1256),
    [sym_compile_intrinsic] = ACTIONS(1256),
    [anon_sym_compile_error] = ACTIONS(1256),
    [sym_location] = ACTIONS(1256),
    [anon_sym_DASH] = ACTIONS(1258),
    [anon_sym_not] = ACTIONS(1256),
    [anon_sym_DASH_TILDE] = ACTIONS(1256),
    [anon_sym_addressof] = ACTIONS(1256),
    [anon_sym_digestof] = ACTIONS(1256),
    [anon_sym_PLUS] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_SLASH] = ACTIONS(1258),
    [anon_sym_PERCENT] = ACTIONS(1258),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1258),
    [anon_sym_LT_LT] = ACTIONS(1258),
    [anon_sym_GT_GT] = ACTIONS(1258),
    [anon_sym_and] = ACTIONS(1256),
    [anon_sym_or] = ACTIONS(1256),
    [anon_sym_xor] = ACTIONS(1256),
    [anon_sym_isnt] = ACTIONS(1256),
    [anon_sym_EQ_EQ] = ACTIONS(1258),
    [anon_sym_BANG_EQ] = ACTIONS(1258),
    [anon_sym_GT] = ACTIONS(1258),
    [anon_sym_GT_EQ] = ACTIONS(1258),
    [anon_sym_LT_EQ] = ACTIONS(1258),
    [anon_sym_LT] = ACTIONS(1258),
    [anon_sym_PLUS_TILDE] = ACTIONS(1256),
    [anon_sym_STAR_TILDE] = ACTIONS(1256),
    [anon_sym_SLASH_TILDE] = ACTIONS(1256),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1256),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1256),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1256),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1256),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1256),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1256),
    [anon_sym_GT_TILDE] = ACTIONS(1256),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1256),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1256),
    [anon_sym_LT_TILDE] = ACTIONS(1256),
    [anon_sym_PLUS_QMARK] = ACTIONS(1256),
    [anon_sym_DASH_QMARK] = ACTIONS(1256),
    [anon_sym_STAR_QMARK] = ACTIONS(1256),
    [anon_sym_SLASH_QMARK] = ACTIONS(1256),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1256),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1256),
    [anon_sym_as] = ACTIONS(1256),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_DOT_GT] = ACTIONS(1256),
    [anon_sym_where] = ACTIONS(1256),
    [anon_sym_TILDE] = ACTIONS(1256),
    [anon_sym_end] = ACTIONS(1256),
    [anon_sym_if] = ACTIONS(1258),
    [anon_sym_ifdef] = ACTIONS(1256),
    [anon_sym_iftype] = ACTIONS(1256),
    [anon_sym_else] = ACTIONS(1256),
    [anon_sym_for] = ACTIONS(1256),
    [anon_sym_while] = ACTIONS(1256),
    [anon_sym_try] = ACTIONS(1256),
    [anon_sym_with] = ACTIONS(1256),
    [anon_sym_repeat] = ACTIONS(1256),
    [anon_sym_do] = ACTIONS(1256),
    [anon_sym_recover] = ACTIONS(1256),
    [anon_sym_match] = ACTIONS(1256),
    [anon_sym_return] = ACTIONS(1256),
    [anon_sym_continue] = ACTIONS(1256),
    [anon_sym_break] = ACTIONS(1256),
    [anon_sym_consume] = ACTIONS(1256),
    [anon_sym_object] = ACTIONS(1256),
    [sym_number] = ACTIONS(1258),
    [sym_float] = ACTIONS(1256),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1256),
    [anon_sym_SQUOTE] = ACTIONS(1256),
    [anon_sym_true] = ACTIONS(1256),
    [anon_sym_false] = ACTIONS(1256),
    [sym_this] = ACTIONS(1256),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [287] = {
    [ts_builtin_sym_end] = ACTIONS(1260),
    [sym_identifier] = ACTIONS(1262),
    [anon_sym_use] = ACTIONS(1260),
    [anon_sym_EQ] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(1260),
    [anon_sym_LBRACK] = ACTIONS(1260),
    [anon_sym_type] = ACTIONS(1260),
    [anon_sym_is] = ACTIONS(1262),
    [anon_sym_actor] = ACTIONS(1260),
    [anon_sym_class] = ACTIONS(1260),
    [anon_sym_primitive] = ACTIONS(1260),
    [anon_sym_interface] = ACTIONS(1260),
    [anon_sym_trait] = ACTIONS(1260),
    [anon_sym_struct] = ACTIONS(1260),
    [anon_sym_embed] = ACTIONS(1260),
    [anon_sym_let] = ACTIONS(1260),
    [anon_sym_var] = ACTIONS(1260),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_fun] = ACTIONS(1260),
    [anon_sym_be] = ACTIONS(1260),
    [anon_sym_COMMA] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1262),
    [anon_sym_RPAREN] = ACTIONS(1260),
    [anon_sym_DOT] = ACTIONS(1262),
    [anon_sym_LBRACE] = ACTIONS(1260),
    [anon_sym_SEMI] = ACTIONS(1260),
    [sym_error] = ACTIONS(1260),
    [sym_compile_intrinsic] = ACTIONS(1260),
    [anon_sym_compile_error] = ACTIONS(1260),
    [sym_location] = ACTIONS(1260),
    [anon_sym_DASH] = ACTIONS(1262),
    [anon_sym_not] = ACTIONS(1260),
    [anon_sym_DASH_TILDE] = ACTIONS(1260),
    [anon_sym_addressof] = ACTIONS(1260),
    [anon_sym_digestof] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(1262),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_SLASH] = ACTIONS(1262),
    [anon_sym_PERCENT] = ACTIONS(1262),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1262),
    [anon_sym_LT_LT] = ACTIONS(1262),
    [anon_sym_GT_GT] = ACTIONS(1262),
    [anon_sym_and] = ACTIONS(1260),
    [anon_sym_or] = ACTIONS(1260),
    [anon_sym_xor] = ACTIONS(1260),
    [anon_sym_isnt] = ACTIONS(1260),
    [anon_sym_EQ_EQ] = ACTIONS(1262),
    [anon_sym_BANG_EQ] = ACTIONS(1262),
    [anon_sym_GT] = ACTIONS(1262),
    [anon_sym_GT_EQ] = ACTIONS(1262),
    [anon_sym_LT_EQ] = ACTIONS(1262),
    [anon_sym_LT] = ACTIONS(1262),
    [anon_sym_PLUS_TILDE] = ACTIONS(1260),
    [anon_sym_STAR_TILDE] = ACTIONS(1260),
    [anon_sym_SLASH_TILDE] = ACTIONS(1260),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1260),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1260),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1260),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1260),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1260),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1260),
    [anon_sym_GT_TILDE] = ACTIONS(1260),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1260),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1260),
    [anon_sym_LT_TILDE] = ACTIONS(1260),
    [anon_sym_PLUS_QMARK] = ACTIONS(1260),
    [anon_sym_DASH_QMARK] = ACTIONS(1260),
    [anon_sym_STAR_QMARK] = ACTIONS(1260),
    [anon_sym_SLASH_QMARK] = ACTIONS(1260),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1260),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(1260),
    [anon_sym_LPAREN2] = ACTIONS(1260),
    [anon_sym_DOT_GT] = ACTIONS(1260),
    [anon_sym_where] = ACTIONS(1260),
    [anon_sym_TILDE] = ACTIONS(1260),
    [anon_sym_end] = ACTIONS(1260),
    [anon_sym_if] = ACTIONS(1262),
    [anon_sym_ifdef] = ACTIONS(1260),
    [anon_sym_iftype] = ACTIONS(1260),
    [anon_sym_else] = ACTIONS(1260),
    [anon_sym_for] = ACTIONS(1260),
    [anon_sym_while] = ACTIONS(1260),
    [anon_sym_try] = ACTIONS(1260),
    [anon_sym_with] = ACTIONS(1260),
    [anon_sym_repeat] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_recover] = ACTIONS(1260),
    [anon_sym_match] = ACTIONS(1260),
    [anon_sym_return] = ACTIONS(1260),
    [anon_sym_continue] = ACTIONS(1260),
    [anon_sym_break] = ACTIONS(1260),
    [anon_sym_consume] = ACTIONS(1260),
    [anon_sym_object] = ACTIONS(1260),
    [sym_number] = ACTIONS(1262),
    [sym_float] = ACTIONS(1260),
    [anon_sym_DQUOTE] = ACTIONS(1262),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1260),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [anon_sym_true] = ACTIONS(1260),
    [anon_sym_false] = ACTIONS(1260),
    [sym_this] = ACTIONS(1260),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [288] = {
    [sym_identifier] = ACTIONS(766),
    [anon_sym_EQ] = ACTIONS(766),
    [anon_sym_AT] = ACTIONS(764),
    [anon_sym_LBRACK] = ACTIONS(764),
    [anon_sym_is] = ACTIONS(766),
    [anon_sym_let] = ACTIONS(764),
    [anon_sym_var] = ACTIONS(764),
    [anon_sym_iso] = ACTIONS(764),
    [anon_sym_trn] = ACTIONS(764),
    [anon_sym_ref] = ACTIONS(764),
    [anon_sym_val] = ACTIONS(764),
    [anon_sym_box] = ACTIONS(764),
    [anon_sym_tag] = ACTIONS(764),
    [anon_sym_LPAREN] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(766),
    [anon_sym_POUNDread] = ACTIONS(764),
    [anon_sym_POUNDsend] = ACTIONS(764),
    [anon_sym_POUNDshare] = ACTIONS(764),
    [anon_sym_POUNDalias] = ACTIONS(764),
    [anon_sym_POUNDany] = ACTIONS(764),
    [anon_sym_BANG] = ACTIONS(766),
    [anon_sym_CARET] = ACTIONS(764),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_AMP] = ACTIONS(764),
    [anon_sym_DASH_GT] = ACTIONS(764),
    [anon_sym_LBRACE] = ACTIONS(764),
    [anon_sym_SEMI] = ACTIONS(764),
    [sym_error] = ACTIONS(764),
    [sym_compile_intrinsic] = ACTIONS(764),
    [anon_sym_compile_error] = ACTIONS(764),
    [sym_location] = ACTIONS(764),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_not] = ACTIONS(764),
    [anon_sym_DASH_TILDE] = ACTIONS(764),
    [anon_sym_addressof] = ACTIONS(764),
    [anon_sym_digestof] = ACTIONS(764),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(766),
    [anon_sym_SLASH] = ACTIONS(766),
    [anon_sym_PERCENT] = ACTIONS(766),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(766),
    [anon_sym_LT_LT] = ACTIONS(766),
    [anon_sym_GT_GT] = ACTIONS(766),
    [anon_sym_and] = ACTIONS(764),
    [anon_sym_or] = ACTIONS(764),
    [anon_sym_xor] = ACTIONS(764),
    [anon_sym_isnt] = ACTIONS(764),
    [anon_sym_EQ_EQ] = ACTIONS(766),
    [anon_sym_BANG_EQ] = ACTIONS(766),
    [anon_sym_GT] = ACTIONS(766),
    [anon_sym_GT_EQ] = ACTIONS(766),
    [anon_sym_LT_EQ] = ACTIONS(766),
    [anon_sym_LT] = ACTIONS(766),
    [anon_sym_PLUS_TILDE] = ACTIONS(764),
    [anon_sym_STAR_TILDE] = ACTIONS(764),
    [anon_sym_SLASH_TILDE] = ACTIONS(764),
    [anon_sym_PERCENT_TILDE] = ACTIONS(764),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(764),
    [anon_sym_LT_LT_TILDE] = ACTIONS(764),
    [anon_sym_GT_GT_TILDE] = ACTIONS(764),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(764),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(764),
    [anon_sym_GT_TILDE] = ACTIONS(764),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(764),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(764),
    [anon_sym_LT_TILDE] = ACTIONS(764),
    [anon_sym_PLUS_QMARK] = ACTIONS(764),
    [anon_sym_DASH_QMARK] = ACTIONS(764),
    [anon_sym_STAR_QMARK] = ACTIONS(764),
    [anon_sym_SLASH_QMARK] = ACTIONS(764),
    [anon_sym_PERCENT_QMARK] = ACTIONS(764),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(764),
    [anon_sym_as] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(764),
    [anon_sym_DOT_GT] = ACTIONS(764),
    [anon_sym_TILDE] = ACTIONS(764),
    [anon_sym_end] = ACTIONS(764),
    [anon_sym_if] = ACTIONS(766),
    [anon_sym_ifdef] = ACTIONS(764),
    [anon_sym_elseif] = ACTIONS(764),
    [anon_sym_iftype] = ACTIONS(764),
    [anon_sym_else] = ACTIONS(766),
    [anon_sym_for] = ACTIONS(764),
    [anon_sym_while] = ACTIONS(764),
    [anon_sym_try] = ACTIONS(764),
    [anon_sym_with] = ACTIONS(764),
    [anon_sym_repeat] = ACTIONS(764),
    [anon_sym_recover] = ACTIONS(764),
    [anon_sym_match] = ACTIONS(764),
    [anon_sym_return] = ACTIONS(764),
    [anon_sym_continue] = ACTIONS(764),
    [anon_sym_break] = ACTIONS(764),
    [anon_sym_consume] = ACTIONS(764),
    [anon_sym_object] = ACTIONS(764),
    [sym_number] = ACTIONS(766),
    [sym_float] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(766),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(764),
    [anon_sym_SQUOTE] = ACTIONS(764),
    [anon_sym_true] = ACTIONS(764),
    [anon_sym_false] = ACTIONS(764),
    [sym_this] = ACTIONS(764),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [289] = {
    [sym_identifier] = ACTIONS(706),
    [anon_sym_EQ] = ACTIONS(706),
    [anon_sym_AT] = ACTIONS(704),
    [anon_sym_LBRACK] = ACTIONS(704),
    [anon_sym_is] = ACTIONS(706),
    [anon_sym_let] = ACTIONS(704),
    [anon_sym_var] = ACTIONS(704),
    [anon_sym_iso] = ACTIONS(704),
    [anon_sym_trn] = ACTIONS(704),
    [anon_sym_ref] = ACTIONS(704),
    [anon_sym_val] = ACTIONS(704),
    [anon_sym_box] = ACTIONS(704),
    [anon_sym_tag] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(706),
    [anon_sym_DOT] = ACTIONS(706),
    [anon_sym_POUNDread] = ACTIONS(704),
    [anon_sym_POUNDsend] = ACTIONS(704),
    [anon_sym_POUNDshare] = ACTIONS(704),
    [anon_sym_POUNDalias] = ACTIONS(704),
    [anon_sym_POUNDany] = ACTIONS(704),
    [anon_sym_BANG] = ACTIONS(706),
    [anon_sym_CARET] = ACTIONS(704),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_DASH_GT] = ACTIONS(704),
    [anon_sym_LBRACE] = ACTIONS(704),
    [anon_sym_SEMI] = ACTIONS(704),
    [sym_error] = ACTIONS(704),
    [sym_compile_intrinsic] = ACTIONS(704),
    [anon_sym_compile_error] = ACTIONS(704),
    [sym_location] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(706),
    [anon_sym_not] = ACTIONS(704),
    [anon_sym_DASH_TILDE] = ACTIONS(704),
    [anon_sym_addressof] = ACTIONS(704),
    [anon_sym_digestof] = ACTIONS(704),
    [anon_sym_PLUS] = ACTIONS(706),
    [anon_sym_STAR] = ACTIONS(706),
    [anon_sym_SLASH] = ACTIONS(706),
    [anon_sym_PERCENT] = ACTIONS(706),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(706),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_GT_GT] = ACTIONS(706),
    [anon_sym_and] = ACTIONS(704),
    [anon_sym_or] = ACTIONS(704),
    [anon_sym_xor] = ACTIONS(704),
    [anon_sym_isnt] = ACTIONS(704),
    [anon_sym_EQ_EQ] = ACTIONS(706),
    [anon_sym_BANG_EQ] = ACTIONS(706),
    [anon_sym_GT] = ACTIONS(706),
    [anon_sym_GT_EQ] = ACTIONS(706),
    [anon_sym_LT_EQ] = ACTIONS(706),
    [anon_sym_LT] = ACTIONS(706),
    [anon_sym_PLUS_TILDE] = ACTIONS(704),
    [anon_sym_STAR_TILDE] = ACTIONS(704),
    [anon_sym_SLASH_TILDE] = ACTIONS(704),
    [anon_sym_PERCENT_TILDE] = ACTIONS(704),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(704),
    [anon_sym_LT_LT_TILDE] = ACTIONS(704),
    [anon_sym_GT_GT_TILDE] = ACTIONS(704),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(704),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(704),
    [anon_sym_GT_TILDE] = ACTIONS(704),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(704),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(704),
    [anon_sym_LT_TILDE] = ACTIONS(704),
    [anon_sym_PLUS_QMARK] = ACTIONS(704),
    [anon_sym_DASH_QMARK] = ACTIONS(704),
    [anon_sym_STAR_QMARK] = ACTIONS(704),
    [anon_sym_SLASH_QMARK] = ACTIONS(704),
    [anon_sym_PERCENT_QMARK] = ACTIONS(704),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(704),
    [anon_sym_as] = ACTIONS(704),
    [anon_sym_LPAREN2] = ACTIONS(704),
    [anon_sym_DOT_GT] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_end] = ACTIONS(704),
    [anon_sym_if] = ACTIONS(706),
    [anon_sym_ifdef] = ACTIONS(704),
    [anon_sym_elseif] = ACTIONS(704),
    [anon_sym_iftype] = ACTIONS(704),
    [anon_sym_else] = ACTIONS(706),
    [anon_sym_for] = ACTIONS(704),
    [anon_sym_while] = ACTIONS(704),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_with] = ACTIONS(704),
    [anon_sym_repeat] = ACTIONS(704),
    [anon_sym_recover] = ACTIONS(704),
    [anon_sym_match] = ACTIONS(704),
    [anon_sym_return] = ACTIONS(704),
    [anon_sym_continue] = ACTIONS(704),
    [anon_sym_break] = ACTIONS(704),
    [anon_sym_consume] = ACTIONS(704),
    [anon_sym_object] = ACTIONS(704),
    [sym_number] = ACTIONS(706),
    [sym_float] = ACTIONS(704),
    [anon_sym_DQUOTE] = ACTIONS(706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(704),
    [anon_sym_SQUOTE] = ACTIONS(704),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(704),
    [sym_this] = ACTIONS(704),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [290] = {
    [sym_identifier] = ACTIONS(648),
    [anon_sym_EQ] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(646),
    [anon_sym_LBRACK] = ACTIONS(646),
    [anon_sym_is] = ACTIONS(648),
    [anon_sym_let] = ACTIONS(646),
    [anon_sym_var] = ACTIONS(646),
    [anon_sym_iso] = ACTIONS(646),
    [anon_sym_trn] = ACTIONS(646),
    [anon_sym_ref] = ACTIONS(646),
    [anon_sym_val] = ACTIONS(646),
    [anon_sym_box] = ACTIONS(646),
    [anon_sym_tag] = ACTIONS(646),
    [anon_sym_LPAREN] = ACTIONS(648),
    [anon_sym_DOT] = ACTIONS(648),
    [anon_sym_POUNDread] = ACTIONS(646),
    [anon_sym_POUNDsend] = ACTIONS(646),
    [anon_sym_POUNDshare] = ACTIONS(646),
    [anon_sym_POUNDalias] = ACTIONS(646),
    [anon_sym_POUNDany] = ACTIONS(646),
    [anon_sym_BANG] = ACTIONS(648),
    [anon_sym_CARET] = ACTIONS(646),
    [anon_sym_PIPE] = ACTIONS(646),
    [anon_sym_AMP] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(646),
    [anon_sym_SEMI] = ACTIONS(646),
    [sym_error] = ACTIONS(646),
    [sym_compile_intrinsic] = ACTIONS(646),
    [anon_sym_compile_error] = ACTIONS(646),
    [sym_location] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(648),
    [anon_sym_not] = ACTIONS(646),
    [anon_sym_DASH_TILDE] = ACTIONS(646),
    [anon_sym_addressof] = ACTIONS(646),
    [anon_sym_digestof] = ACTIONS(646),
    [anon_sym_PLUS] = ACTIONS(648),
    [anon_sym_STAR] = ACTIONS(648),
    [anon_sym_SLASH] = ACTIONS(648),
    [anon_sym_PERCENT] = ACTIONS(648),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(648),
    [anon_sym_LT_LT] = ACTIONS(648),
    [anon_sym_GT_GT] = ACTIONS(648),
    [anon_sym_and] = ACTIONS(646),
    [anon_sym_or] = ACTIONS(646),
    [anon_sym_xor] = ACTIONS(646),
    [anon_sym_isnt] = ACTIONS(646),
    [anon_sym_EQ_EQ] = ACTIONS(648),
    [anon_sym_BANG_EQ] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(648),
    [anon_sym_GT_EQ] = ACTIONS(648),
    [anon_sym_LT_EQ] = ACTIONS(648),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_PLUS_TILDE] = ACTIONS(646),
    [anon_sym_STAR_TILDE] = ACTIONS(646),
    [anon_sym_SLASH_TILDE] = ACTIONS(646),
    [anon_sym_PERCENT_TILDE] = ACTIONS(646),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(646),
    [anon_sym_LT_LT_TILDE] = ACTIONS(646),
    [anon_sym_GT_GT_TILDE] = ACTIONS(646),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(646),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(646),
    [anon_sym_GT_TILDE] = ACTIONS(646),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(646),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(646),
    [anon_sym_LT_TILDE] = ACTIONS(646),
    [anon_sym_PLUS_QMARK] = ACTIONS(646),
    [anon_sym_DASH_QMARK] = ACTIONS(646),
    [anon_sym_STAR_QMARK] = ACTIONS(646),
    [anon_sym_SLASH_QMARK] = ACTIONS(646),
    [anon_sym_PERCENT_QMARK] = ACTIONS(646),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(646),
    [anon_sym_as] = ACTIONS(646),
    [anon_sym_LPAREN2] = ACTIONS(646),
    [anon_sym_DOT_GT] = ACTIONS(646),
    [anon_sym_TILDE] = ACTIONS(646),
    [anon_sym_end] = ACTIONS(646),
    [anon_sym_if] = ACTIONS(648),
    [anon_sym_ifdef] = ACTIONS(646),
    [anon_sym_elseif] = ACTIONS(646),
    [anon_sym_iftype] = ACTIONS(646),
    [anon_sym_else] = ACTIONS(648),
    [anon_sym_for] = ACTIONS(646),
    [anon_sym_while] = ACTIONS(646),
    [anon_sym_try] = ACTIONS(646),
    [anon_sym_with] = ACTIONS(646),
    [anon_sym_repeat] = ACTIONS(646),
    [anon_sym_recover] = ACTIONS(646),
    [anon_sym_match] = ACTIONS(646),
    [anon_sym_return] = ACTIONS(646),
    [anon_sym_continue] = ACTIONS(646),
    [anon_sym_break] = ACTIONS(646),
    [anon_sym_consume] = ACTIONS(646),
    [anon_sym_object] = ACTIONS(646),
    [sym_number] = ACTIONS(648),
    [sym_float] = ACTIONS(646),
    [anon_sym_DQUOTE] = ACTIONS(648),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(646),
    [anon_sym_SQUOTE] = ACTIONS(646),
    [anon_sym_true] = ACTIONS(646),
    [anon_sym_false] = ACTIONS(646),
    [sym_this] = ACTIONS(646),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [291] = {
    [sym_identifier] = ACTIONS(656),
    [anon_sym_EQ] = ACTIONS(656),
    [anon_sym_AT] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(654),
    [anon_sym_is] = ACTIONS(656),
    [anon_sym_let] = ACTIONS(654),
    [anon_sym_var] = ACTIONS(654),
    [anon_sym_iso] = ACTIONS(654),
    [anon_sym_trn] = ACTIONS(654),
    [anon_sym_ref] = ACTIONS(654),
    [anon_sym_val] = ACTIONS(654),
    [anon_sym_box] = ACTIONS(654),
    [anon_sym_tag] = ACTIONS(654),
    [anon_sym_LPAREN] = ACTIONS(656),
    [anon_sym_DOT] = ACTIONS(656),
    [anon_sym_POUNDread] = ACTIONS(654),
    [anon_sym_POUNDsend] = ACTIONS(654),
    [anon_sym_POUNDshare] = ACTIONS(654),
    [anon_sym_POUNDalias] = ACTIONS(654),
    [anon_sym_POUNDany] = ACTIONS(654),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(654),
    [anon_sym_PIPE] = ACTIONS(654),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_DASH_GT] = ACTIONS(654),
    [anon_sym_LBRACE] = ACTIONS(654),
    [anon_sym_SEMI] = ACTIONS(654),
    [sym_error] = ACTIONS(654),
    [sym_compile_intrinsic] = ACTIONS(654),
    [anon_sym_compile_error] = ACTIONS(654),
    [sym_location] = ACTIONS(654),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_not] = ACTIONS(654),
    [anon_sym_DASH_TILDE] = ACTIONS(654),
    [anon_sym_addressof] = ACTIONS(654),
    [anon_sym_digestof] = ACTIONS(654),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_STAR] = ACTIONS(656),
    [anon_sym_SLASH] = ACTIONS(656),
    [anon_sym_PERCENT] = ACTIONS(656),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(656),
    [anon_sym_LT_LT] = ACTIONS(656),
    [anon_sym_GT_GT] = ACTIONS(656),
    [anon_sym_and] = ACTIONS(654),
    [anon_sym_or] = ACTIONS(654),
    [anon_sym_xor] = ACTIONS(654),
    [anon_sym_isnt] = ACTIONS(654),
    [anon_sym_EQ_EQ] = ACTIONS(656),
    [anon_sym_BANG_EQ] = ACTIONS(656),
    [anon_sym_GT] = ACTIONS(656),
    [anon_sym_GT_EQ] = ACTIONS(656),
    [anon_sym_LT_EQ] = ACTIONS(656),
    [anon_sym_LT] = ACTIONS(656),
    [anon_sym_PLUS_TILDE] = ACTIONS(654),
    [anon_sym_STAR_TILDE] = ACTIONS(654),
    [anon_sym_SLASH_TILDE] = ACTIONS(654),
    [anon_sym_PERCENT_TILDE] = ACTIONS(654),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(654),
    [anon_sym_LT_LT_TILDE] = ACTIONS(654),
    [anon_sym_GT_GT_TILDE] = ACTIONS(654),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(654),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(654),
    [anon_sym_GT_TILDE] = ACTIONS(654),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(654),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(654),
    [anon_sym_LT_TILDE] = ACTIONS(654),
    [anon_sym_PLUS_QMARK] = ACTIONS(654),
    [anon_sym_DASH_QMARK] = ACTIONS(654),
    [anon_sym_STAR_QMARK] = ACTIONS(654),
    [anon_sym_SLASH_QMARK] = ACTIONS(654),
    [anon_sym_PERCENT_QMARK] = ACTIONS(654),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(654),
    [anon_sym_as] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(654),
    [anon_sym_DOT_GT] = ACTIONS(654),
    [anon_sym_TILDE] = ACTIONS(654),
    [anon_sym_end] = ACTIONS(654),
    [anon_sym_if] = ACTIONS(656),
    [anon_sym_ifdef] = ACTIONS(654),
    [anon_sym_elseif] = ACTIONS(654),
    [anon_sym_iftype] = ACTIONS(654),
    [anon_sym_else] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(654),
    [anon_sym_while] = ACTIONS(654),
    [anon_sym_try] = ACTIONS(654),
    [anon_sym_with] = ACTIONS(654),
    [anon_sym_repeat] = ACTIONS(654),
    [anon_sym_recover] = ACTIONS(654),
    [anon_sym_match] = ACTIONS(654),
    [anon_sym_return] = ACTIONS(654),
    [anon_sym_continue] = ACTIONS(654),
    [anon_sym_break] = ACTIONS(654),
    [anon_sym_consume] = ACTIONS(654),
    [anon_sym_object] = ACTIONS(654),
    [sym_number] = ACTIONS(656),
    [sym_float] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(654),
    [anon_sym_true] = ACTIONS(654),
    [anon_sym_false] = ACTIONS(654),
    [sym_this] = ACTIONS(654),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [292] = {
    [sym_identifier] = ACTIONS(786),
    [anon_sym_EQ] = ACTIONS(786),
    [anon_sym_AT] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(784),
    [anon_sym_is] = ACTIONS(786),
    [anon_sym_let] = ACTIONS(784),
    [anon_sym_var] = ACTIONS(784),
    [anon_sym_iso] = ACTIONS(784),
    [anon_sym_trn] = ACTIONS(784),
    [anon_sym_ref] = ACTIONS(784),
    [anon_sym_val] = ACTIONS(784),
    [anon_sym_box] = ACTIONS(784),
    [anon_sym_tag] = ACTIONS(784),
    [anon_sym_LPAREN] = ACTIONS(786),
    [anon_sym_DOT] = ACTIONS(786),
    [anon_sym_POUNDread] = ACTIONS(784),
    [anon_sym_POUNDsend] = ACTIONS(784),
    [anon_sym_POUNDshare] = ACTIONS(784),
    [anon_sym_POUNDalias] = ACTIONS(784),
    [anon_sym_POUNDany] = ACTIONS(784),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_CARET] = ACTIONS(784),
    [anon_sym_PIPE] = ACTIONS(784),
    [anon_sym_AMP] = ACTIONS(784),
    [anon_sym_DASH_GT] = ACTIONS(784),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_SEMI] = ACTIONS(784),
    [sym_error] = ACTIONS(784),
    [sym_compile_intrinsic] = ACTIONS(784),
    [anon_sym_compile_error] = ACTIONS(784),
    [sym_location] = ACTIONS(784),
    [anon_sym_DASH] = ACTIONS(786),
    [anon_sym_not] = ACTIONS(784),
    [anon_sym_DASH_TILDE] = ACTIONS(784),
    [anon_sym_addressof] = ACTIONS(784),
    [anon_sym_digestof] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(786),
    [anon_sym_STAR] = ACTIONS(786),
    [anon_sym_SLASH] = ACTIONS(786),
    [anon_sym_PERCENT] = ACTIONS(786),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(786),
    [anon_sym_LT_LT] = ACTIONS(786),
    [anon_sym_GT_GT] = ACTIONS(786),
    [anon_sym_and] = ACTIONS(784),
    [anon_sym_or] = ACTIONS(784),
    [anon_sym_xor] = ACTIONS(784),
    [anon_sym_isnt] = ACTIONS(784),
    [anon_sym_EQ_EQ] = ACTIONS(786),
    [anon_sym_BANG_EQ] = ACTIONS(786),
    [anon_sym_GT] = ACTIONS(786),
    [anon_sym_GT_EQ] = ACTIONS(786),
    [anon_sym_LT_EQ] = ACTIONS(786),
    [anon_sym_LT] = ACTIONS(786),
    [anon_sym_PLUS_TILDE] = ACTIONS(784),
    [anon_sym_STAR_TILDE] = ACTIONS(784),
    [anon_sym_SLASH_TILDE] = ACTIONS(784),
    [anon_sym_PERCENT_TILDE] = ACTIONS(784),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(784),
    [anon_sym_LT_LT_TILDE] = ACTIONS(784),
    [anon_sym_GT_GT_TILDE] = ACTIONS(784),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(784),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(784),
    [anon_sym_GT_TILDE] = ACTIONS(784),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(784),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(784),
    [anon_sym_LT_TILDE] = ACTIONS(784),
    [anon_sym_PLUS_QMARK] = ACTIONS(784),
    [anon_sym_DASH_QMARK] = ACTIONS(784),
    [anon_sym_STAR_QMARK] = ACTIONS(784),
    [anon_sym_SLASH_QMARK] = ACTIONS(784),
    [anon_sym_PERCENT_QMARK] = ACTIONS(784),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(784),
    [anon_sym_as] = ACTIONS(784),
    [anon_sym_LPAREN2] = ACTIONS(784),
    [anon_sym_DOT_GT] = ACTIONS(784),
    [anon_sym_TILDE] = ACTIONS(784),
    [anon_sym_end] = ACTIONS(784),
    [anon_sym_if] = ACTIONS(786),
    [anon_sym_ifdef] = ACTIONS(784),
    [anon_sym_elseif] = ACTIONS(784),
    [anon_sym_iftype] = ACTIONS(784),
    [anon_sym_else] = ACTIONS(786),
    [anon_sym_for] = ACTIONS(784),
    [anon_sym_while] = ACTIONS(784),
    [anon_sym_try] = ACTIONS(784),
    [anon_sym_with] = ACTIONS(784),
    [anon_sym_repeat] = ACTIONS(784),
    [anon_sym_recover] = ACTIONS(784),
    [anon_sym_match] = ACTIONS(784),
    [anon_sym_return] = ACTIONS(784),
    [anon_sym_continue] = ACTIONS(784),
    [anon_sym_break] = ACTIONS(784),
    [anon_sym_consume] = ACTIONS(784),
    [anon_sym_object] = ACTIONS(784),
    [sym_number] = ACTIONS(786),
    [sym_float] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(784),
    [anon_sym_SQUOTE] = ACTIONS(784),
    [anon_sym_true] = ACTIONS(784),
    [anon_sym_false] = ACTIONS(784),
    [sym_this] = ACTIONS(784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [293] = {
    [sym_identifier] = ACTIONS(782),
    [anon_sym_EQ] = ACTIONS(782),
    [anon_sym_AT] = ACTIONS(780),
    [anon_sym_LBRACK] = ACTIONS(780),
    [anon_sym_is] = ACTIONS(782),
    [anon_sym_let] = ACTIONS(780),
    [anon_sym_var] = ACTIONS(780),
    [anon_sym_iso] = ACTIONS(780),
    [anon_sym_trn] = ACTIONS(780),
    [anon_sym_ref] = ACTIONS(780),
    [anon_sym_val] = ACTIONS(780),
    [anon_sym_box] = ACTIONS(780),
    [anon_sym_tag] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(782),
    [anon_sym_DOT] = ACTIONS(782),
    [anon_sym_POUNDread] = ACTIONS(780),
    [anon_sym_POUNDsend] = ACTIONS(780),
    [anon_sym_POUNDshare] = ACTIONS(780),
    [anon_sym_POUNDalias] = ACTIONS(780),
    [anon_sym_POUNDany] = ACTIONS(780),
    [anon_sym_BANG] = ACTIONS(782),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_DASH_GT] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(780),
    [sym_error] = ACTIONS(780),
    [sym_compile_intrinsic] = ACTIONS(780),
    [anon_sym_compile_error] = ACTIONS(780),
    [sym_location] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(782),
    [anon_sym_not] = ACTIONS(780),
    [anon_sym_DASH_TILDE] = ACTIONS(780),
    [anon_sym_addressof] = ACTIONS(780),
    [anon_sym_digestof] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(782),
    [anon_sym_STAR] = ACTIONS(782),
    [anon_sym_SLASH] = ACTIONS(782),
    [anon_sym_PERCENT] = ACTIONS(782),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(782),
    [anon_sym_LT_LT] = ACTIONS(782),
    [anon_sym_GT_GT] = ACTIONS(782),
    [anon_sym_and] = ACTIONS(780),
    [anon_sym_or] = ACTIONS(780),
    [anon_sym_xor] = ACTIONS(780),
    [anon_sym_isnt] = ACTIONS(780),
    [anon_sym_EQ_EQ] = ACTIONS(782),
    [anon_sym_BANG_EQ] = ACTIONS(782),
    [anon_sym_GT] = ACTIONS(782),
    [anon_sym_GT_EQ] = ACTIONS(782),
    [anon_sym_LT_EQ] = ACTIONS(782),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_PLUS_TILDE] = ACTIONS(780),
    [anon_sym_STAR_TILDE] = ACTIONS(780),
    [anon_sym_SLASH_TILDE] = ACTIONS(780),
    [anon_sym_PERCENT_TILDE] = ACTIONS(780),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(780),
    [anon_sym_LT_LT_TILDE] = ACTIONS(780),
    [anon_sym_GT_GT_TILDE] = ACTIONS(780),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(780),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(780),
    [anon_sym_GT_TILDE] = ACTIONS(780),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(780),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(780),
    [anon_sym_LT_TILDE] = ACTIONS(780),
    [anon_sym_PLUS_QMARK] = ACTIONS(780),
    [anon_sym_DASH_QMARK] = ACTIONS(780),
    [anon_sym_STAR_QMARK] = ACTIONS(780),
    [anon_sym_SLASH_QMARK] = ACTIONS(780),
    [anon_sym_PERCENT_QMARK] = ACTIONS(780),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(780),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_LPAREN2] = ACTIONS(780),
    [anon_sym_DOT_GT] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_end] = ACTIONS(780),
    [anon_sym_if] = ACTIONS(782),
    [anon_sym_ifdef] = ACTIONS(780),
    [anon_sym_elseif] = ACTIONS(780),
    [anon_sym_iftype] = ACTIONS(780),
    [anon_sym_else] = ACTIONS(782),
    [anon_sym_for] = ACTIONS(780),
    [anon_sym_while] = ACTIONS(780),
    [anon_sym_try] = ACTIONS(780),
    [anon_sym_with] = ACTIONS(780),
    [anon_sym_repeat] = ACTIONS(780),
    [anon_sym_recover] = ACTIONS(780),
    [anon_sym_match] = ACTIONS(780),
    [anon_sym_return] = ACTIONS(780),
    [anon_sym_continue] = ACTIONS(780),
    [anon_sym_break] = ACTIONS(780),
    [anon_sym_consume] = ACTIONS(780),
    [anon_sym_object] = ACTIONS(780),
    [sym_number] = ACTIONS(782),
    [sym_float] = ACTIONS(780),
    [anon_sym_DQUOTE] = ACTIONS(782),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(780),
    [anon_sym_SQUOTE] = ACTIONS(780),
    [anon_sym_true] = ACTIONS(780),
    [anon_sym_false] = ACTIONS(780),
    [sym_this] = ACTIONS(780),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [294] = {
    [sym_identifier] = ACTIONS(778),
    [anon_sym_EQ] = ACTIONS(778),
    [anon_sym_AT] = ACTIONS(776),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_is] = ACTIONS(778),
    [anon_sym_let] = ACTIONS(776),
    [anon_sym_var] = ACTIONS(776),
    [anon_sym_iso] = ACTIONS(776),
    [anon_sym_trn] = ACTIONS(776),
    [anon_sym_ref] = ACTIONS(776),
    [anon_sym_val] = ACTIONS(776),
    [anon_sym_box] = ACTIONS(776),
    [anon_sym_tag] = ACTIONS(776),
    [anon_sym_LPAREN] = ACTIONS(778),
    [anon_sym_DOT] = ACTIONS(778),
    [anon_sym_POUNDread] = ACTIONS(776),
    [anon_sym_POUNDsend] = ACTIONS(776),
    [anon_sym_POUNDshare] = ACTIONS(776),
    [anon_sym_POUNDalias] = ACTIONS(776),
    [anon_sym_POUNDany] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_CARET] = ACTIONS(776),
    [anon_sym_PIPE] = ACTIONS(776),
    [anon_sym_AMP] = ACTIONS(776),
    [anon_sym_DASH_GT] = ACTIONS(776),
    [anon_sym_LBRACE] = ACTIONS(776),
    [anon_sym_SEMI] = ACTIONS(776),
    [sym_error] = ACTIONS(776),
    [sym_compile_intrinsic] = ACTIONS(776),
    [anon_sym_compile_error] = ACTIONS(776),
    [sym_location] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(778),
    [anon_sym_not] = ACTIONS(776),
    [anon_sym_DASH_TILDE] = ACTIONS(776),
    [anon_sym_addressof] = ACTIONS(776),
    [anon_sym_digestof] = ACTIONS(776),
    [anon_sym_PLUS] = ACTIONS(778),
    [anon_sym_STAR] = ACTIONS(778),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_PERCENT] = ACTIONS(778),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(778),
    [anon_sym_LT_LT] = ACTIONS(778),
    [anon_sym_GT_GT] = ACTIONS(778),
    [anon_sym_and] = ACTIONS(776),
    [anon_sym_or] = ACTIONS(776),
    [anon_sym_xor] = ACTIONS(776),
    [anon_sym_isnt] = ACTIONS(776),
    [anon_sym_EQ_EQ] = ACTIONS(778),
    [anon_sym_BANG_EQ] = ACTIONS(778),
    [anon_sym_GT] = ACTIONS(778),
    [anon_sym_GT_EQ] = ACTIONS(778),
    [anon_sym_LT_EQ] = ACTIONS(778),
    [anon_sym_LT] = ACTIONS(778),
    [anon_sym_PLUS_TILDE] = ACTIONS(776),
    [anon_sym_STAR_TILDE] = ACTIONS(776),
    [anon_sym_SLASH_TILDE] = ACTIONS(776),
    [anon_sym_PERCENT_TILDE] = ACTIONS(776),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(776),
    [anon_sym_LT_LT_TILDE] = ACTIONS(776),
    [anon_sym_GT_GT_TILDE] = ACTIONS(776),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(776),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(776),
    [anon_sym_GT_TILDE] = ACTIONS(776),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(776),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(776),
    [anon_sym_LT_TILDE] = ACTIONS(776),
    [anon_sym_PLUS_QMARK] = ACTIONS(776),
    [anon_sym_DASH_QMARK] = ACTIONS(776),
    [anon_sym_STAR_QMARK] = ACTIONS(776),
    [anon_sym_SLASH_QMARK] = ACTIONS(776),
    [anon_sym_PERCENT_QMARK] = ACTIONS(776),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(776),
    [anon_sym_as] = ACTIONS(776),
    [anon_sym_LPAREN2] = ACTIONS(776),
    [anon_sym_DOT_GT] = ACTIONS(776),
    [anon_sym_TILDE] = ACTIONS(776),
    [anon_sym_end] = ACTIONS(776),
    [anon_sym_if] = ACTIONS(778),
    [anon_sym_ifdef] = ACTIONS(776),
    [anon_sym_elseif] = ACTIONS(776),
    [anon_sym_iftype] = ACTIONS(776),
    [anon_sym_else] = ACTIONS(778),
    [anon_sym_for] = ACTIONS(776),
    [anon_sym_while] = ACTIONS(776),
    [anon_sym_try] = ACTIONS(776),
    [anon_sym_with] = ACTIONS(776),
    [anon_sym_repeat] = ACTIONS(776),
    [anon_sym_recover] = ACTIONS(776),
    [anon_sym_match] = ACTIONS(776),
    [anon_sym_return] = ACTIONS(776),
    [anon_sym_continue] = ACTIONS(776),
    [anon_sym_break] = ACTIONS(776),
    [anon_sym_consume] = ACTIONS(776),
    [anon_sym_object] = ACTIONS(776),
    [sym_number] = ACTIONS(778),
    [sym_float] = ACTIONS(776),
    [anon_sym_DQUOTE] = ACTIONS(778),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(776),
    [anon_sym_SQUOTE] = ACTIONS(776),
    [anon_sym_true] = ACTIONS(776),
    [anon_sym_false] = ACTIONS(776),
    [sym_this] = ACTIONS(776),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [295] = {
    [sym_identifier] = ACTIONS(774),
    [anon_sym_EQ] = ACTIONS(774),
    [anon_sym_AT] = ACTIONS(772),
    [anon_sym_LBRACK] = ACTIONS(772),
    [anon_sym_is] = ACTIONS(774),
    [anon_sym_let] = ACTIONS(772),
    [anon_sym_var] = ACTIONS(772),
    [anon_sym_iso] = ACTIONS(772),
    [anon_sym_trn] = ACTIONS(772),
    [anon_sym_ref] = ACTIONS(772),
    [anon_sym_val] = ACTIONS(772),
    [anon_sym_box] = ACTIONS(772),
    [anon_sym_tag] = ACTIONS(772),
    [anon_sym_LPAREN] = ACTIONS(774),
    [anon_sym_DOT] = ACTIONS(774),
    [anon_sym_POUNDread] = ACTIONS(772),
    [anon_sym_POUNDsend] = ACTIONS(772),
    [anon_sym_POUNDshare] = ACTIONS(772),
    [anon_sym_POUNDalias] = ACTIONS(772),
    [anon_sym_POUNDany] = ACTIONS(772),
    [anon_sym_BANG] = ACTIONS(774),
    [anon_sym_CARET] = ACTIONS(772),
    [anon_sym_PIPE] = ACTIONS(772),
    [anon_sym_AMP] = ACTIONS(772),
    [anon_sym_DASH_GT] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(772),
    [anon_sym_SEMI] = ACTIONS(772),
    [sym_error] = ACTIONS(772),
    [sym_compile_intrinsic] = ACTIONS(772),
    [anon_sym_compile_error] = ACTIONS(772),
    [sym_location] = ACTIONS(772),
    [anon_sym_DASH] = ACTIONS(774),
    [anon_sym_not] = ACTIONS(772),
    [anon_sym_DASH_TILDE] = ACTIONS(772),
    [anon_sym_addressof] = ACTIONS(772),
    [anon_sym_digestof] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(774),
    [anon_sym_STAR] = ACTIONS(774),
    [anon_sym_SLASH] = ACTIONS(774),
    [anon_sym_PERCENT] = ACTIONS(774),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(774),
    [anon_sym_LT_LT] = ACTIONS(774),
    [anon_sym_GT_GT] = ACTIONS(774),
    [anon_sym_and] = ACTIONS(772),
    [anon_sym_or] = ACTIONS(772),
    [anon_sym_xor] = ACTIONS(772),
    [anon_sym_isnt] = ACTIONS(772),
    [anon_sym_EQ_EQ] = ACTIONS(774),
    [anon_sym_BANG_EQ] = ACTIONS(774),
    [anon_sym_GT] = ACTIONS(774),
    [anon_sym_GT_EQ] = ACTIONS(774),
    [anon_sym_LT_EQ] = ACTIONS(774),
    [anon_sym_LT] = ACTIONS(774),
    [anon_sym_PLUS_TILDE] = ACTIONS(772),
    [anon_sym_STAR_TILDE] = ACTIONS(772),
    [anon_sym_SLASH_TILDE] = ACTIONS(772),
    [anon_sym_PERCENT_TILDE] = ACTIONS(772),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(772),
    [anon_sym_LT_LT_TILDE] = ACTIONS(772),
    [anon_sym_GT_GT_TILDE] = ACTIONS(772),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(772),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(772),
    [anon_sym_GT_TILDE] = ACTIONS(772),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(772),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(772),
    [anon_sym_LT_TILDE] = ACTIONS(772),
    [anon_sym_PLUS_QMARK] = ACTIONS(772),
    [anon_sym_DASH_QMARK] = ACTIONS(772),
    [anon_sym_STAR_QMARK] = ACTIONS(772),
    [anon_sym_SLASH_QMARK] = ACTIONS(772),
    [anon_sym_PERCENT_QMARK] = ACTIONS(772),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(772),
    [anon_sym_as] = ACTIONS(772),
    [anon_sym_LPAREN2] = ACTIONS(772),
    [anon_sym_DOT_GT] = ACTIONS(772),
    [anon_sym_TILDE] = ACTIONS(772),
    [anon_sym_end] = ACTIONS(772),
    [anon_sym_if] = ACTIONS(774),
    [anon_sym_ifdef] = ACTIONS(772),
    [anon_sym_elseif] = ACTIONS(772),
    [anon_sym_iftype] = ACTIONS(772),
    [anon_sym_else] = ACTIONS(774),
    [anon_sym_for] = ACTIONS(772),
    [anon_sym_while] = ACTIONS(772),
    [anon_sym_try] = ACTIONS(772),
    [anon_sym_with] = ACTIONS(772),
    [anon_sym_repeat] = ACTIONS(772),
    [anon_sym_recover] = ACTIONS(772),
    [anon_sym_match] = ACTIONS(772),
    [anon_sym_return] = ACTIONS(772),
    [anon_sym_continue] = ACTIONS(772),
    [anon_sym_break] = ACTIONS(772),
    [anon_sym_consume] = ACTIONS(772),
    [anon_sym_object] = ACTIONS(772),
    [sym_number] = ACTIONS(774),
    [sym_float] = ACTIONS(772),
    [anon_sym_DQUOTE] = ACTIONS(774),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(772),
    [anon_sym_SQUOTE] = ACTIONS(772),
    [anon_sym_true] = ACTIONS(772),
    [anon_sym_false] = ACTIONS(772),
    [sym_this] = ACTIONS(772),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [296] = {
    [sym_identifier] = ACTIONS(770),
    [anon_sym_EQ] = ACTIONS(770),
    [anon_sym_AT] = ACTIONS(768),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_is] = ACTIONS(770),
    [anon_sym_let] = ACTIONS(768),
    [anon_sym_var] = ACTIONS(768),
    [anon_sym_iso] = ACTIONS(768),
    [anon_sym_trn] = ACTIONS(768),
    [anon_sym_ref] = ACTIONS(768),
    [anon_sym_val] = ACTIONS(768),
    [anon_sym_box] = ACTIONS(768),
    [anon_sym_tag] = ACTIONS(768),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_DOT] = ACTIONS(770),
    [anon_sym_POUNDread] = ACTIONS(768),
    [anon_sym_POUNDsend] = ACTIONS(768),
    [anon_sym_POUNDshare] = ACTIONS(768),
    [anon_sym_POUNDalias] = ACTIONS(768),
    [anon_sym_POUNDany] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(770),
    [anon_sym_CARET] = ACTIONS(768),
    [anon_sym_PIPE] = ACTIONS(768),
    [anon_sym_AMP] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(768),
    [anon_sym_LBRACE] = ACTIONS(768),
    [anon_sym_SEMI] = ACTIONS(768),
    [sym_error] = ACTIONS(768),
    [sym_compile_intrinsic] = ACTIONS(768),
    [anon_sym_compile_error] = ACTIONS(768),
    [sym_location] = ACTIONS(768),
    [anon_sym_DASH] = ACTIONS(770),
    [anon_sym_not] = ACTIONS(768),
    [anon_sym_DASH_TILDE] = ACTIONS(768),
    [anon_sym_addressof] = ACTIONS(768),
    [anon_sym_digestof] = ACTIONS(768),
    [anon_sym_PLUS] = ACTIONS(770),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_SLASH] = ACTIONS(770),
    [anon_sym_PERCENT] = ACTIONS(770),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(770),
    [anon_sym_LT_LT] = ACTIONS(770),
    [anon_sym_GT_GT] = ACTIONS(770),
    [anon_sym_and] = ACTIONS(768),
    [anon_sym_or] = ACTIONS(768),
    [anon_sym_xor] = ACTIONS(768),
    [anon_sym_isnt] = ACTIONS(768),
    [anon_sym_EQ_EQ] = ACTIONS(770),
    [anon_sym_BANG_EQ] = ACTIONS(770),
    [anon_sym_GT] = ACTIONS(770),
    [anon_sym_GT_EQ] = ACTIONS(770),
    [anon_sym_LT_EQ] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(770),
    [anon_sym_PLUS_TILDE] = ACTIONS(768),
    [anon_sym_STAR_TILDE] = ACTIONS(768),
    [anon_sym_SLASH_TILDE] = ACTIONS(768),
    [anon_sym_PERCENT_TILDE] = ACTIONS(768),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(768),
    [anon_sym_LT_LT_TILDE] = ACTIONS(768),
    [anon_sym_GT_GT_TILDE] = ACTIONS(768),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(768),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(768),
    [anon_sym_GT_TILDE] = ACTIONS(768),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(768),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(768),
    [anon_sym_LT_TILDE] = ACTIONS(768),
    [anon_sym_PLUS_QMARK] = ACTIONS(768),
    [anon_sym_DASH_QMARK] = ACTIONS(768),
    [anon_sym_STAR_QMARK] = ACTIONS(768),
    [anon_sym_SLASH_QMARK] = ACTIONS(768),
    [anon_sym_PERCENT_QMARK] = ACTIONS(768),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(768),
    [anon_sym_as] = ACTIONS(768),
    [anon_sym_LPAREN2] = ACTIONS(768),
    [anon_sym_DOT_GT] = ACTIONS(768),
    [anon_sym_TILDE] = ACTIONS(768),
    [anon_sym_end] = ACTIONS(768),
    [anon_sym_if] = ACTIONS(770),
    [anon_sym_ifdef] = ACTIONS(768),
    [anon_sym_elseif] = ACTIONS(768),
    [anon_sym_iftype] = ACTIONS(768),
    [anon_sym_else] = ACTIONS(770),
    [anon_sym_for] = ACTIONS(768),
    [anon_sym_while] = ACTIONS(768),
    [anon_sym_try] = ACTIONS(768),
    [anon_sym_with] = ACTIONS(768),
    [anon_sym_repeat] = ACTIONS(768),
    [anon_sym_recover] = ACTIONS(768),
    [anon_sym_match] = ACTIONS(768),
    [anon_sym_return] = ACTIONS(768),
    [anon_sym_continue] = ACTIONS(768),
    [anon_sym_break] = ACTIONS(768),
    [anon_sym_consume] = ACTIONS(768),
    [anon_sym_object] = ACTIONS(768),
    [sym_number] = ACTIONS(770),
    [sym_float] = ACTIONS(768),
    [anon_sym_DQUOTE] = ACTIONS(770),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(768),
    [anon_sym_SQUOTE] = ACTIONS(768),
    [anon_sym_true] = ACTIONS(768),
    [anon_sym_false] = ACTIONS(768),
    [sym_this] = ACTIONS(768),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [297] = {
    [ts_builtin_sym_end] = ACTIONS(1264),
    [sym_identifier] = ACTIONS(1266),
    [anon_sym_use] = ACTIONS(1264),
    [anon_sym_EQ] = ACTIONS(1266),
    [anon_sym_AT] = ACTIONS(1264),
    [anon_sym_LBRACK] = ACTIONS(1264),
    [anon_sym_type] = ACTIONS(1264),
    [anon_sym_is] = ACTIONS(1266),
    [anon_sym_actor] = ACTIONS(1264),
    [anon_sym_class] = ACTIONS(1264),
    [anon_sym_primitive] = ACTIONS(1264),
    [anon_sym_interface] = ACTIONS(1264),
    [anon_sym_trait] = ACTIONS(1264),
    [anon_sym_struct] = ACTIONS(1264),
    [anon_sym_embed] = ACTIONS(1264),
    [anon_sym_let] = ACTIONS(1264),
    [anon_sym_var] = ACTIONS(1264),
    [anon_sym_new] = ACTIONS(1264),
    [anon_sym_fun] = ACTIONS(1264),
    [anon_sym_be] = ACTIONS(1264),
    [anon_sym_COMMA] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [anon_sym_RPAREN] = ACTIONS(1264),
    [anon_sym_DOT] = ACTIONS(1266),
    [anon_sym_LBRACE] = ACTIONS(1264),
    [anon_sym_SEMI] = ACTIONS(1264),
    [sym_error] = ACTIONS(1264),
    [sym_compile_intrinsic] = ACTIONS(1264),
    [anon_sym_compile_error] = ACTIONS(1264),
    [sym_location] = ACTIONS(1264),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_not] = ACTIONS(1264),
    [anon_sym_DASH_TILDE] = ACTIONS(1264),
    [anon_sym_addressof] = ACTIONS(1264),
    [anon_sym_digestof] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1266),
    [anon_sym_SLASH] = ACTIONS(1266),
    [anon_sym_PERCENT] = ACTIONS(1266),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1266),
    [anon_sym_LT_LT] = ACTIONS(1266),
    [anon_sym_GT_GT] = ACTIONS(1266),
    [anon_sym_and] = ACTIONS(1264),
    [anon_sym_or] = ACTIONS(1264),
    [anon_sym_xor] = ACTIONS(1264),
    [anon_sym_isnt] = ACTIONS(1264),
    [anon_sym_EQ_EQ] = ACTIONS(1266),
    [anon_sym_BANG_EQ] = ACTIONS(1266),
    [anon_sym_GT] = ACTIONS(1266),
    [anon_sym_GT_EQ] = ACTIONS(1266),
    [anon_sym_LT_EQ] = ACTIONS(1266),
    [anon_sym_LT] = ACTIONS(1266),
    [anon_sym_PLUS_TILDE] = ACTIONS(1264),
    [anon_sym_STAR_TILDE] = ACTIONS(1264),
    [anon_sym_SLASH_TILDE] = ACTIONS(1264),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1264),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1264),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1264),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1264),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1264),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1264),
    [anon_sym_GT_TILDE] = ACTIONS(1264),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1264),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1264),
    [anon_sym_LT_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS_QMARK] = ACTIONS(1264),
    [anon_sym_DASH_QMARK] = ACTIONS(1264),
    [anon_sym_STAR_QMARK] = ACTIONS(1264),
    [anon_sym_SLASH_QMARK] = ACTIONS(1264),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1264),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1264),
    [anon_sym_as] = ACTIONS(1264),
    [anon_sym_LPAREN2] = ACTIONS(1264),
    [anon_sym_DOT_GT] = ACTIONS(1264),
    [anon_sym_where] = ACTIONS(1264),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_end] = ACTIONS(1264),
    [anon_sym_if] = ACTIONS(1266),
    [anon_sym_ifdef] = ACTIONS(1264),
    [anon_sym_iftype] = ACTIONS(1264),
    [anon_sym_else] = ACTIONS(1264),
    [anon_sym_for] = ACTIONS(1264),
    [anon_sym_while] = ACTIONS(1264),
    [anon_sym_try] = ACTIONS(1264),
    [anon_sym_with] = ACTIONS(1264),
    [anon_sym_repeat] = ACTIONS(1264),
    [anon_sym_do] = ACTIONS(1264),
    [anon_sym_recover] = ACTIONS(1264),
    [anon_sym_match] = ACTIONS(1264),
    [anon_sym_return] = ACTIONS(1264),
    [anon_sym_continue] = ACTIONS(1264),
    [anon_sym_break] = ACTIONS(1264),
    [anon_sym_consume] = ACTIONS(1264),
    [anon_sym_object] = ACTIONS(1264),
    [sym_number] = ACTIONS(1266),
    [sym_float] = ACTIONS(1264),
    [anon_sym_DQUOTE] = ACTIONS(1266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1264),
    [anon_sym_SQUOTE] = ACTIONS(1264),
    [anon_sym_true] = ACTIONS(1264),
    [anon_sym_false] = ACTIONS(1264),
    [sym_this] = ACTIONS(1264),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [298] = {
    [sym_identifier] = ACTIONS(762),
    [anon_sym_EQ] = ACTIONS(762),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_LBRACK] = ACTIONS(760),
    [anon_sym_is] = ACTIONS(762),
    [anon_sym_let] = ACTIONS(760),
    [anon_sym_var] = ACTIONS(760),
    [anon_sym_iso] = ACTIONS(760),
    [anon_sym_trn] = ACTIONS(760),
    [anon_sym_ref] = ACTIONS(760),
    [anon_sym_val] = ACTIONS(760),
    [anon_sym_box] = ACTIONS(760),
    [anon_sym_tag] = ACTIONS(760),
    [anon_sym_LPAREN] = ACTIONS(762),
    [anon_sym_DOT] = ACTIONS(762),
    [anon_sym_POUNDread] = ACTIONS(760),
    [anon_sym_POUNDsend] = ACTIONS(760),
    [anon_sym_POUNDshare] = ACTIONS(760),
    [anon_sym_POUNDalias] = ACTIONS(760),
    [anon_sym_POUNDany] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(762),
    [anon_sym_CARET] = ACTIONS(760),
    [anon_sym_PIPE] = ACTIONS(760),
    [anon_sym_AMP] = ACTIONS(760),
    [anon_sym_DASH_GT] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(760),
    [anon_sym_SEMI] = ACTIONS(760),
    [sym_error] = ACTIONS(760),
    [sym_compile_intrinsic] = ACTIONS(760),
    [anon_sym_compile_error] = ACTIONS(760),
    [sym_location] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_not] = ACTIONS(760),
    [anon_sym_DASH_TILDE] = ACTIONS(760),
    [anon_sym_addressof] = ACTIONS(760),
    [anon_sym_digestof] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_STAR] = ACTIONS(762),
    [anon_sym_SLASH] = ACTIONS(762),
    [anon_sym_PERCENT] = ACTIONS(762),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(762),
    [anon_sym_LT_LT] = ACTIONS(762),
    [anon_sym_GT_GT] = ACTIONS(762),
    [anon_sym_and] = ACTIONS(760),
    [anon_sym_or] = ACTIONS(760),
    [anon_sym_xor] = ACTIONS(760),
    [anon_sym_isnt] = ACTIONS(760),
    [anon_sym_EQ_EQ] = ACTIONS(762),
    [anon_sym_BANG_EQ] = ACTIONS(762),
    [anon_sym_GT] = ACTIONS(762),
    [anon_sym_GT_EQ] = ACTIONS(762),
    [anon_sym_LT_EQ] = ACTIONS(762),
    [anon_sym_LT] = ACTIONS(762),
    [anon_sym_PLUS_TILDE] = ACTIONS(760),
    [anon_sym_STAR_TILDE] = ACTIONS(760),
    [anon_sym_SLASH_TILDE] = ACTIONS(760),
    [anon_sym_PERCENT_TILDE] = ACTIONS(760),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(760),
    [anon_sym_LT_LT_TILDE] = ACTIONS(760),
    [anon_sym_GT_GT_TILDE] = ACTIONS(760),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(760),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(760),
    [anon_sym_GT_TILDE] = ACTIONS(760),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(760),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(760),
    [anon_sym_LT_TILDE] = ACTIONS(760),
    [anon_sym_PLUS_QMARK] = ACTIONS(760),
    [anon_sym_DASH_QMARK] = ACTIONS(760),
    [anon_sym_STAR_QMARK] = ACTIONS(760),
    [anon_sym_SLASH_QMARK] = ACTIONS(760),
    [anon_sym_PERCENT_QMARK] = ACTIONS(760),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(760),
    [anon_sym_as] = ACTIONS(760),
    [anon_sym_LPAREN2] = ACTIONS(760),
    [anon_sym_DOT_GT] = ACTIONS(760),
    [anon_sym_TILDE] = ACTIONS(760),
    [anon_sym_end] = ACTIONS(760),
    [anon_sym_if] = ACTIONS(762),
    [anon_sym_ifdef] = ACTIONS(760),
    [anon_sym_elseif] = ACTIONS(760),
    [anon_sym_iftype] = ACTIONS(760),
    [anon_sym_else] = ACTIONS(762),
    [anon_sym_for] = ACTIONS(760),
    [anon_sym_while] = ACTIONS(760),
    [anon_sym_try] = ACTIONS(760),
    [anon_sym_with] = ACTIONS(760),
    [anon_sym_repeat] = ACTIONS(760),
    [anon_sym_recover] = ACTIONS(760),
    [anon_sym_match] = ACTIONS(760),
    [anon_sym_return] = ACTIONS(760),
    [anon_sym_continue] = ACTIONS(760),
    [anon_sym_break] = ACTIONS(760),
    [anon_sym_consume] = ACTIONS(760),
    [anon_sym_object] = ACTIONS(760),
    [sym_number] = ACTIONS(762),
    [sym_float] = ACTIONS(760),
    [anon_sym_DQUOTE] = ACTIONS(762),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(760),
    [anon_sym_SQUOTE] = ACTIONS(760),
    [anon_sym_true] = ACTIONS(760),
    [anon_sym_false] = ACTIONS(760),
    [sym_this] = ACTIONS(760),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [299] = {
    [sym_identifier] = ACTIONS(758),
    [anon_sym_EQ] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(756),
    [anon_sym_is] = ACTIONS(758),
    [anon_sym_let] = ACTIONS(756),
    [anon_sym_var] = ACTIONS(756),
    [anon_sym_iso] = ACTIONS(756),
    [anon_sym_trn] = ACTIONS(756),
    [anon_sym_ref] = ACTIONS(756),
    [anon_sym_val] = ACTIONS(756),
    [anon_sym_box] = ACTIONS(756),
    [anon_sym_tag] = ACTIONS(756),
    [anon_sym_LPAREN] = ACTIONS(758),
    [anon_sym_DOT] = ACTIONS(758),
    [anon_sym_POUNDread] = ACTIONS(756),
    [anon_sym_POUNDsend] = ACTIONS(756),
    [anon_sym_POUNDshare] = ACTIONS(756),
    [anon_sym_POUNDalias] = ACTIONS(756),
    [anon_sym_POUNDany] = ACTIONS(756),
    [anon_sym_BANG] = ACTIONS(758),
    [anon_sym_CARET] = ACTIONS(756),
    [anon_sym_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(756),
    [anon_sym_DASH_GT] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_SEMI] = ACTIONS(756),
    [sym_error] = ACTIONS(756),
    [sym_compile_intrinsic] = ACTIONS(756),
    [anon_sym_compile_error] = ACTIONS(756),
    [sym_location] = ACTIONS(756),
    [anon_sym_DASH] = ACTIONS(758),
    [anon_sym_not] = ACTIONS(756),
    [anon_sym_DASH_TILDE] = ACTIONS(756),
    [anon_sym_addressof] = ACTIONS(756),
    [anon_sym_digestof] = ACTIONS(756),
    [anon_sym_PLUS] = ACTIONS(758),
    [anon_sym_STAR] = ACTIONS(758),
    [anon_sym_SLASH] = ACTIONS(758),
    [anon_sym_PERCENT] = ACTIONS(758),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(758),
    [anon_sym_LT_LT] = ACTIONS(758),
    [anon_sym_GT_GT] = ACTIONS(758),
    [anon_sym_and] = ACTIONS(756),
    [anon_sym_or] = ACTIONS(756),
    [anon_sym_xor] = ACTIONS(756),
    [anon_sym_isnt] = ACTIONS(756),
    [anon_sym_EQ_EQ] = ACTIONS(758),
    [anon_sym_BANG_EQ] = ACTIONS(758),
    [anon_sym_GT] = ACTIONS(758),
    [anon_sym_GT_EQ] = ACTIONS(758),
    [anon_sym_LT_EQ] = ACTIONS(758),
    [anon_sym_LT] = ACTIONS(758),
    [anon_sym_PLUS_TILDE] = ACTIONS(756),
    [anon_sym_STAR_TILDE] = ACTIONS(756),
    [anon_sym_SLASH_TILDE] = ACTIONS(756),
    [anon_sym_PERCENT_TILDE] = ACTIONS(756),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(756),
    [anon_sym_LT_LT_TILDE] = ACTIONS(756),
    [anon_sym_GT_GT_TILDE] = ACTIONS(756),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(756),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(756),
    [anon_sym_GT_TILDE] = ACTIONS(756),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(756),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(756),
    [anon_sym_LT_TILDE] = ACTIONS(756),
    [anon_sym_PLUS_QMARK] = ACTIONS(756),
    [anon_sym_DASH_QMARK] = ACTIONS(756),
    [anon_sym_STAR_QMARK] = ACTIONS(756),
    [anon_sym_SLASH_QMARK] = ACTIONS(756),
    [anon_sym_PERCENT_QMARK] = ACTIONS(756),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(756),
    [anon_sym_as] = ACTIONS(756),
    [anon_sym_LPAREN2] = ACTIONS(756),
    [anon_sym_DOT_GT] = ACTIONS(756),
    [anon_sym_TILDE] = ACTIONS(756),
    [anon_sym_end] = ACTIONS(756),
    [anon_sym_if] = ACTIONS(758),
    [anon_sym_ifdef] = ACTIONS(756),
    [anon_sym_elseif] = ACTIONS(756),
    [anon_sym_iftype] = ACTIONS(756),
    [anon_sym_else] = ACTIONS(758),
    [anon_sym_for] = ACTIONS(756),
    [anon_sym_while] = ACTIONS(756),
    [anon_sym_try] = ACTIONS(756),
    [anon_sym_with] = ACTIONS(756),
    [anon_sym_repeat] = ACTIONS(756),
    [anon_sym_recover] = ACTIONS(756),
    [anon_sym_match] = ACTIONS(756),
    [anon_sym_return] = ACTIONS(756),
    [anon_sym_continue] = ACTIONS(756),
    [anon_sym_break] = ACTIONS(756),
    [anon_sym_consume] = ACTIONS(756),
    [anon_sym_object] = ACTIONS(756),
    [sym_number] = ACTIONS(758),
    [sym_float] = ACTIONS(756),
    [anon_sym_DQUOTE] = ACTIONS(758),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(756),
    [anon_sym_SQUOTE] = ACTIONS(756),
    [anon_sym_true] = ACTIONS(756),
    [anon_sym_false] = ACTIONS(756),
    [sym_this] = ACTIONS(756),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [300] = {
    [sym_identifier] = ACTIONS(754),
    [anon_sym_EQ] = ACTIONS(754),
    [anon_sym_AT] = ACTIONS(752),
    [anon_sym_LBRACK] = ACTIONS(752),
    [anon_sym_is] = ACTIONS(754),
    [anon_sym_let] = ACTIONS(752),
    [anon_sym_var] = ACTIONS(752),
    [anon_sym_iso] = ACTIONS(752),
    [anon_sym_trn] = ACTIONS(752),
    [anon_sym_ref] = ACTIONS(752),
    [anon_sym_val] = ACTIONS(752),
    [anon_sym_box] = ACTIONS(752),
    [anon_sym_tag] = ACTIONS(752),
    [anon_sym_LPAREN] = ACTIONS(754),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_POUNDread] = ACTIONS(752),
    [anon_sym_POUNDsend] = ACTIONS(752),
    [anon_sym_POUNDshare] = ACTIONS(752),
    [anon_sym_POUNDalias] = ACTIONS(752),
    [anon_sym_POUNDany] = ACTIONS(752),
    [anon_sym_BANG] = ACTIONS(754),
    [anon_sym_CARET] = ACTIONS(752),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_AMP] = ACTIONS(752),
    [anon_sym_DASH_GT] = ACTIONS(752),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_SEMI] = ACTIONS(752),
    [sym_error] = ACTIONS(752),
    [sym_compile_intrinsic] = ACTIONS(752),
    [anon_sym_compile_error] = ACTIONS(752),
    [sym_location] = ACTIONS(752),
    [anon_sym_DASH] = ACTIONS(754),
    [anon_sym_not] = ACTIONS(752),
    [anon_sym_DASH_TILDE] = ACTIONS(752),
    [anon_sym_addressof] = ACTIONS(752),
    [anon_sym_digestof] = ACTIONS(752),
    [anon_sym_PLUS] = ACTIONS(754),
    [anon_sym_STAR] = ACTIONS(754),
    [anon_sym_SLASH] = ACTIONS(754),
    [anon_sym_PERCENT] = ACTIONS(754),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(754),
    [anon_sym_LT_LT] = ACTIONS(754),
    [anon_sym_GT_GT] = ACTIONS(754),
    [anon_sym_and] = ACTIONS(752),
    [anon_sym_or] = ACTIONS(752),
    [anon_sym_xor] = ACTIONS(752),
    [anon_sym_isnt] = ACTIONS(752),
    [anon_sym_EQ_EQ] = ACTIONS(754),
    [anon_sym_BANG_EQ] = ACTIONS(754),
    [anon_sym_GT] = ACTIONS(754),
    [anon_sym_GT_EQ] = ACTIONS(754),
    [anon_sym_LT_EQ] = ACTIONS(754),
    [anon_sym_LT] = ACTIONS(754),
    [anon_sym_PLUS_TILDE] = ACTIONS(752),
    [anon_sym_STAR_TILDE] = ACTIONS(752),
    [anon_sym_SLASH_TILDE] = ACTIONS(752),
    [anon_sym_PERCENT_TILDE] = ACTIONS(752),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(752),
    [anon_sym_LT_LT_TILDE] = ACTIONS(752),
    [anon_sym_GT_GT_TILDE] = ACTIONS(752),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(752),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(752),
    [anon_sym_GT_TILDE] = ACTIONS(752),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(752),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(752),
    [anon_sym_LT_TILDE] = ACTIONS(752),
    [anon_sym_PLUS_QMARK] = ACTIONS(752),
    [anon_sym_DASH_QMARK] = ACTIONS(752),
    [anon_sym_STAR_QMARK] = ACTIONS(752),
    [anon_sym_SLASH_QMARK] = ACTIONS(752),
    [anon_sym_PERCENT_QMARK] = ACTIONS(752),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(752),
    [anon_sym_as] = ACTIONS(752),
    [anon_sym_LPAREN2] = ACTIONS(752),
    [anon_sym_DOT_GT] = ACTIONS(752),
    [anon_sym_TILDE] = ACTIONS(752),
    [anon_sym_end] = ACTIONS(752),
    [anon_sym_if] = ACTIONS(754),
    [anon_sym_ifdef] = ACTIONS(752),
    [anon_sym_elseif] = ACTIONS(752),
    [anon_sym_iftype] = ACTIONS(752),
    [anon_sym_else] = ACTIONS(754),
    [anon_sym_for] = ACTIONS(752),
    [anon_sym_while] = ACTIONS(752),
    [anon_sym_try] = ACTIONS(752),
    [anon_sym_with] = ACTIONS(752),
    [anon_sym_repeat] = ACTIONS(752),
    [anon_sym_recover] = ACTIONS(752),
    [anon_sym_match] = ACTIONS(752),
    [anon_sym_return] = ACTIONS(752),
    [anon_sym_continue] = ACTIONS(752),
    [anon_sym_break] = ACTIONS(752),
    [anon_sym_consume] = ACTIONS(752),
    [anon_sym_object] = ACTIONS(752),
    [sym_number] = ACTIONS(754),
    [sym_float] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(754),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(752),
    [anon_sym_true] = ACTIONS(752),
    [anon_sym_false] = ACTIONS(752),
    [sym_this] = ACTIONS(752),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [301] = {
    [sym_identifier] = ACTIONS(750),
    [anon_sym_EQ] = ACTIONS(750),
    [anon_sym_AT] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(748),
    [anon_sym_is] = ACTIONS(750),
    [anon_sym_let] = ACTIONS(748),
    [anon_sym_var] = ACTIONS(748),
    [anon_sym_iso] = ACTIONS(748),
    [anon_sym_trn] = ACTIONS(748),
    [anon_sym_ref] = ACTIONS(748),
    [anon_sym_val] = ACTIONS(748),
    [anon_sym_box] = ACTIONS(748),
    [anon_sym_tag] = ACTIONS(748),
    [anon_sym_LPAREN] = ACTIONS(750),
    [anon_sym_DOT] = ACTIONS(750),
    [anon_sym_POUNDread] = ACTIONS(748),
    [anon_sym_POUNDsend] = ACTIONS(748),
    [anon_sym_POUNDshare] = ACTIONS(748),
    [anon_sym_POUNDalias] = ACTIONS(748),
    [anon_sym_POUNDany] = ACTIONS(748),
    [anon_sym_BANG] = ACTIONS(750),
    [anon_sym_CARET] = ACTIONS(748),
    [anon_sym_PIPE] = ACTIONS(748),
    [anon_sym_AMP] = ACTIONS(748),
    [anon_sym_DASH_GT] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_SEMI] = ACTIONS(748),
    [sym_error] = ACTIONS(748),
    [sym_compile_intrinsic] = ACTIONS(748),
    [anon_sym_compile_error] = ACTIONS(748),
    [sym_location] = ACTIONS(748),
    [anon_sym_DASH] = ACTIONS(750),
    [anon_sym_not] = ACTIONS(748),
    [anon_sym_DASH_TILDE] = ACTIONS(748),
    [anon_sym_addressof] = ACTIONS(748),
    [anon_sym_digestof] = ACTIONS(748),
    [anon_sym_PLUS] = ACTIONS(750),
    [anon_sym_STAR] = ACTIONS(750),
    [anon_sym_SLASH] = ACTIONS(750),
    [anon_sym_PERCENT] = ACTIONS(750),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(750),
    [anon_sym_LT_LT] = ACTIONS(750),
    [anon_sym_GT_GT] = ACTIONS(750),
    [anon_sym_and] = ACTIONS(748),
    [anon_sym_or] = ACTIONS(748),
    [anon_sym_xor] = ACTIONS(748),
    [anon_sym_isnt] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(750),
    [anon_sym_BANG_EQ] = ACTIONS(750),
    [anon_sym_GT] = ACTIONS(750),
    [anon_sym_GT_EQ] = ACTIONS(750),
    [anon_sym_LT_EQ] = ACTIONS(750),
    [anon_sym_LT] = ACTIONS(750),
    [anon_sym_PLUS_TILDE] = ACTIONS(748),
    [anon_sym_STAR_TILDE] = ACTIONS(748),
    [anon_sym_SLASH_TILDE] = ACTIONS(748),
    [anon_sym_PERCENT_TILDE] = ACTIONS(748),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(748),
    [anon_sym_LT_LT_TILDE] = ACTIONS(748),
    [anon_sym_GT_GT_TILDE] = ACTIONS(748),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(748),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(748),
    [anon_sym_GT_TILDE] = ACTIONS(748),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(748),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(748),
    [anon_sym_LT_TILDE] = ACTIONS(748),
    [anon_sym_PLUS_QMARK] = ACTIONS(748),
    [anon_sym_DASH_QMARK] = ACTIONS(748),
    [anon_sym_STAR_QMARK] = ACTIONS(748),
    [anon_sym_SLASH_QMARK] = ACTIONS(748),
    [anon_sym_PERCENT_QMARK] = ACTIONS(748),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(748),
    [anon_sym_LPAREN2] = ACTIONS(748),
    [anon_sym_DOT_GT] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_end] = ACTIONS(748),
    [anon_sym_if] = ACTIONS(750),
    [anon_sym_ifdef] = ACTIONS(748),
    [anon_sym_elseif] = ACTIONS(748),
    [anon_sym_iftype] = ACTIONS(748),
    [anon_sym_else] = ACTIONS(750),
    [anon_sym_for] = ACTIONS(748),
    [anon_sym_while] = ACTIONS(748),
    [anon_sym_try] = ACTIONS(748),
    [anon_sym_with] = ACTIONS(748),
    [anon_sym_repeat] = ACTIONS(748),
    [anon_sym_recover] = ACTIONS(748),
    [anon_sym_match] = ACTIONS(748),
    [anon_sym_return] = ACTIONS(748),
    [anon_sym_continue] = ACTIONS(748),
    [anon_sym_break] = ACTIONS(748),
    [anon_sym_consume] = ACTIONS(748),
    [anon_sym_object] = ACTIONS(748),
    [sym_number] = ACTIONS(750),
    [sym_float] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(748),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [anon_sym_true] = ACTIONS(748),
    [anon_sym_false] = ACTIONS(748),
    [sym_this] = ACTIONS(748),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [302] = {
    [sym_identifier] = ACTIONS(746),
    [anon_sym_EQ] = ACTIONS(746),
    [anon_sym_AT] = ACTIONS(744),
    [anon_sym_LBRACK] = ACTIONS(744),
    [anon_sym_is] = ACTIONS(746),
    [anon_sym_let] = ACTIONS(744),
    [anon_sym_var] = ACTIONS(744),
    [anon_sym_iso] = ACTIONS(744),
    [anon_sym_trn] = ACTIONS(744),
    [anon_sym_ref] = ACTIONS(744),
    [anon_sym_val] = ACTIONS(744),
    [anon_sym_box] = ACTIONS(744),
    [anon_sym_tag] = ACTIONS(744),
    [anon_sym_LPAREN] = ACTIONS(746),
    [anon_sym_DOT] = ACTIONS(746),
    [anon_sym_POUNDread] = ACTIONS(744),
    [anon_sym_POUNDsend] = ACTIONS(744),
    [anon_sym_POUNDshare] = ACTIONS(744),
    [anon_sym_POUNDalias] = ACTIONS(744),
    [anon_sym_POUNDany] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_CARET] = ACTIONS(744),
    [anon_sym_PIPE] = ACTIONS(744),
    [anon_sym_AMP] = ACTIONS(744),
    [anon_sym_DASH_GT] = ACTIONS(744),
    [anon_sym_LBRACE] = ACTIONS(744),
    [anon_sym_SEMI] = ACTIONS(744),
    [sym_error] = ACTIONS(744),
    [sym_compile_intrinsic] = ACTIONS(744),
    [anon_sym_compile_error] = ACTIONS(744),
    [sym_location] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_not] = ACTIONS(744),
    [anon_sym_DASH_TILDE] = ACTIONS(744),
    [anon_sym_addressof] = ACTIONS(744),
    [anon_sym_digestof] = ACTIONS(744),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(746),
    [anon_sym_SLASH] = ACTIONS(746),
    [anon_sym_PERCENT] = ACTIONS(746),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(746),
    [anon_sym_LT_LT] = ACTIONS(746),
    [anon_sym_GT_GT] = ACTIONS(746),
    [anon_sym_and] = ACTIONS(744),
    [anon_sym_or] = ACTIONS(744),
    [anon_sym_xor] = ACTIONS(744),
    [anon_sym_isnt] = ACTIONS(744),
    [anon_sym_EQ_EQ] = ACTIONS(746),
    [anon_sym_BANG_EQ] = ACTIONS(746),
    [anon_sym_GT] = ACTIONS(746),
    [anon_sym_GT_EQ] = ACTIONS(746),
    [anon_sym_LT_EQ] = ACTIONS(746),
    [anon_sym_LT] = ACTIONS(746),
    [anon_sym_PLUS_TILDE] = ACTIONS(744),
    [anon_sym_STAR_TILDE] = ACTIONS(744),
    [anon_sym_SLASH_TILDE] = ACTIONS(744),
    [anon_sym_PERCENT_TILDE] = ACTIONS(744),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(744),
    [anon_sym_LT_LT_TILDE] = ACTIONS(744),
    [anon_sym_GT_GT_TILDE] = ACTIONS(744),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(744),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(744),
    [anon_sym_GT_TILDE] = ACTIONS(744),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(744),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(744),
    [anon_sym_LT_TILDE] = ACTIONS(744),
    [anon_sym_PLUS_QMARK] = ACTIONS(744),
    [anon_sym_DASH_QMARK] = ACTIONS(744),
    [anon_sym_STAR_QMARK] = ACTIONS(744),
    [anon_sym_SLASH_QMARK] = ACTIONS(744),
    [anon_sym_PERCENT_QMARK] = ACTIONS(744),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(744),
    [anon_sym_as] = ACTIONS(744),
    [anon_sym_LPAREN2] = ACTIONS(744),
    [anon_sym_DOT_GT] = ACTIONS(744),
    [anon_sym_TILDE] = ACTIONS(744),
    [anon_sym_end] = ACTIONS(744),
    [anon_sym_if] = ACTIONS(746),
    [anon_sym_ifdef] = ACTIONS(744),
    [anon_sym_elseif] = ACTIONS(744),
    [anon_sym_iftype] = ACTIONS(744),
    [anon_sym_else] = ACTIONS(746),
    [anon_sym_for] = ACTIONS(744),
    [anon_sym_while] = ACTIONS(744),
    [anon_sym_try] = ACTIONS(744),
    [anon_sym_with] = ACTIONS(744),
    [anon_sym_repeat] = ACTIONS(744),
    [anon_sym_recover] = ACTIONS(744),
    [anon_sym_match] = ACTIONS(744),
    [anon_sym_return] = ACTIONS(744),
    [anon_sym_continue] = ACTIONS(744),
    [anon_sym_break] = ACTIONS(744),
    [anon_sym_consume] = ACTIONS(744),
    [anon_sym_object] = ACTIONS(744),
    [sym_number] = ACTIONS(746),
    [sym_float] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(744),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [anon_sym_true] = ACTIONS(744),
    [anon_sym_false] = ACTIONS(744),
    [sym_this] = ACTIONS(744),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [303] = {
    [sym_identifier] = ACTIONS(742),
    [anon_sym_EQ] = ACTIONS(742),
    [anon_sym_AT] = ACTIONS(740),
    [anon_sym_LBRACK] = ACTIONS(740),
    [anon_sym_is] = ACTIONS(742),
    [anon_sym_let] = ACTIONS(740),
    [anon_sym_var] = ACTIONS(740),
    [anon_sym_iso] = ACTIONS(740),
    [anon_sym_trn] = ACTIONS(740),
    [anon_sym_ref] = ACTIONS(740),
    [anon_sym_val] = ACTIONS(740),
    [anon_sym_box] = ACTIONS(740),
    [anon_sym_tag] = ACTIONS(740),
    [anon_sym_LPAREN] = ACTIONS(742),
    [anon_sym_DOT] = ACTIONS(742),
    [anon_sym_POUNDread] = ACTIONS(740),
    [anon_sym_POUNDsend] = ACTIONS(740),
    [anon_sym_POUNDshare] = ACTIONS(740),
    [anon_sym_POUNDalias] = ACTIONS(740),
    [anon_sym_POUNDany] = ACTIONS(740),
    [anon_sym_BANG] = ACTIONS(742),
    [anon_sym_CARET] = ACTIONS(740),
    [anon_sym_PIPE] = ACTIONS(740),
    [anon_sym_AMP] = ACTIONS(740),
    [anon_sym_DASH_GT] = ACTIONS(740),
    [anon_sym_LBRACE] = ACTIONS(740),
    [anon_sym_SEMI] = ACTIONS(740),
    [sym_error] = ACTIONS(740),
    [sym_compile_intrinsic] = ACTIONS(740),
    [anon_sym_compile_error] = ACTIONS(740),
    [sym_location] = ACTIONS(740),
    [anon_sym_DASH] = ACTIONS(742),
    [anon_sym_not] = ACTIONS(740),
    [anon_sym_DASH_TILDE] = ACTIONS(740),
    [anon_sym_addressof] = ACTIONS(740),
    [anon_sym_digestof] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(742),
    [anon_sym_STAR] = ACTIONS(742),
    [anon_sym_SLASH] = ACTIONS(742),
    [anon_sym_PERCENT] = ACTIONS(742),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(742),
    [anon_sym_LT_LT] = ACTIONS(742),
    [anon_sym_GT_GT] = ACTIONS(742),
    [anon_sym_and] = ACTIONS(740),
    [anon_sym_or] = ACTIONS(740),
    [anon_sym_xor] = ACTIONS(740),
    [anon_sym_isnt] = ACTIONS(740),
    [anon_sym_EQ_EQ] = ACTIONS(742),
    [anon_sym_BANG_EQ] = ACTIONS(742),
    [anon_sym_GT] = ACTIONS(742),
    [anon_sym_GT_EQ] = ACTIONS(742),
    [anon_sym_LT_EQ] = ACTIONS(742),
    [anon_sym_LT] = ACTIONS(742),
    [anon_sym_PLUS_TILDE] = ACTIONS(740),
    [anon_sym_STAR_TILDE] = ACTIONS(740),
    [anon_sym_SLASH_TILDE] = ACTIONS(740),
    [anon_sym_PERCENT_TILDE] = ACTIONS(740),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(740),
    [anon_sym_LT_LT_TILDE] = ACTIONS(740),
    [anon_sym_GT_GT_TILDE] = ACTIONS(740),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(740),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(740),
    [anon_sym_GT_TILDE] = ACTIONS(740),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(740),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(740),
    [anon_sym_LT_TILDE] = ACTIONS(740),
    [anon_sym_PLUS_QMARK] = ACTIONS(740),
    [anon_sym_DASH_QMARK] = ACTIONS(740),
    [anon_sym_STAR_QMARK] = ACTIONS(740),
    [anon_sym_SLASH_QMARK] = ACTIONS(740),
    [anon_sym_PERCENT_QMARK] = ACTIONS(740),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(740),
    [anon_sym_as] = ACTIONS(740),
    [anon_sym_LPAREN2] = ACTIONS(740),
    [anon_sym_DOT_GT] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_end] = ACTIONS(740),
    [anon_sym_if] = ACTIONS(742),
    [anon_sym_ifdef] = ACTIONS(740),
    [anon_sym_elseif] = ACTIONS(740),
    [anon_sym_iftype] = ACTIONS(740),
    [anon_sym_else] = ACTIONS(742),
    [anon_sym_for] = ACTIONS(740),
    [anon_sym_while] = ACTIONS(740),
    [anon_sym_try] = ACTIONS(740),
    [anon_sym_with] = ACTIONS(740),
    [anon_sym_repeat] = ACTIONS(740),
    [anon_sym_recover] = ACTIONS(740),
    [anon_sym_match] = ACTIONS(740),
    [anon_sym_return] = ACTIONS(740),
    [anon_sym_continue] = ACTIONS(740),
    [anon_sym_break] = ACTIONS(740),
    [anon_sym_consume] = ACTIONS(740),
    [anon_sym_object] = ACTIONS(740),
    [sym_number] = ACTIONS(742),
    [sym_float] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(740),
    [anon_sym_SQUOTE] = ACTIONS(740),
    [anon_sym_true] = ACTIONS(740),
    [anon_sym_false] = ACTIONS(740),
    [sym_this] = ACTIONS(740),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [304] = {
    [sym_identifier] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(736),
    [anon_sym_is] = ACTIONS(738),
    [anon_sym_let] = ACTIONS(736),
    [anon_sym_var] = ACTIONS(736),
    [anon_sym_iso] = ACTIONS(736),
    [anon_sym_trn] = ACTIONS(736),
    [anon_sym_ref] = ACTIONS(736),
    [anon_sym_val] = ACTIONS(736),
    [anon_sym_box] = ACTIONS(736),
    [anon_sym_tag] = ACTIONS(736),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_POUNDread] = ACTIONS(736),
    [anon_sym_POUNDsend] = ACTIONS(736),
    [anon_sym_POUNDshare] = ACTIONS(736),
    [anon_sym_POUNDalias] = ACTIONS(736),
    [anon_sym_POUNDany] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(738),
    [anon_sym_CARET] = ACTIONS(736),
    [anon_sym_PIPE] = ACTIONS(736),
    [anon_sym_AMP] = ACTIONS(736),
    [anon_sym_DASH_GT] = ACTIONS(736),
    [anon_sym_LBRACE] = ACTIONS(736),
    [anon_sym_SEMI] = ACTIONS(736),
    [sym_error] = ACTIONS(736),
    [sym_compile_intrinsic] = ACTIONS(736),
    [anon_sym_compile_error] = ACTIONS(736),
    [sym_location] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_not] = ACTIONS(736),
    [anon_sym_DASH_TILDE] = ACTIONS(736),
    [anon_sym_addressof] = ACTIONS(736),
    [anon_sym_digestof] = ACTIONS(736),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(738),
    [anon_sym_LT_LT] = ACTIONS(738),
    [anon_sym_GT_GT] = ACTIONS(738),
    [anon_sym_and] = ACTIONS(736),
    [anon_sym_or] = ACTIONS(736),
    [anon_sym_xor] = ACTIONS(736),
    [anon_sym_isnt] = ACTIONS(736),
    [anon_sym_EQ_EQ] = ACTIONS(738),
    [anon_sym_BANG_EQ] = ACTIONS(738),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_EQ] = ACTIONS(738),
    [anon_sym_LT] = ACTIONS(738),
    [anon_sym_PLUS_TILDE] = ACTIONS(736),
    [anon_sym_STAR_TILDE] = ACTIONS(736),
    [anon_sym_SLASH_TILDE] = ACTIONS(736),
    [anon_sym_PERCENT_TILDE] = ACTIONS(736),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(736),
    [anon_sym_LT_LT_TILDE] = ACTIONS(736),
    [anon_sym_GT_GT_TILDE] = ACTIONS(736),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(736),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(736),
    [anon_sym_GT_TILDE] = ACTIONS(736),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(736),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(736),
    [anon_sym_LT_TILDE] = ACTIONS(736),
    [anon_sym_PLUS_QMARK] = ACTIONS(736),
    [anon_sym_DASH_QMARK] = ACTIONS(736),
    [anon_sym_STAR_QMARK] = ACTIONS(736),
    [anon_sym_SLASH_QMARK] = ACTIONS(736),
    [anon_sym_PERCENT_QMARK] = ACTIONS(736),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(736),
    [anon_sym_as] = ACTIONS(736),
    [anon_sym_LPAREN2] = ACTIONS(736),
    [anon_sym_DOT_GT] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_end] = ACTIONS(736),
    [anon_sym_if] = ACTIONS(738),
    [anon_sym_ifdef] = ACTIONS(736),
    [anon_sym_elseif] = ACTIONS(736),
    [anon_sym_iftype] = ACTIONS(736),
    [anon_sym_else] = ACTIONS(738),
    [anon_sym_for] = ACTIONS(736),
    [anon_sym_while] = ACTIONS(736),
    [anon_sym_try] = ACTIONS(736),
    [anon_sym_with] = ACTIONS(736),
    [anon_sym_repeat] = ACTIONS(736),
    [anon_sym_recover] = ACTIONS(736),
    [anon_sym_match] = ACTIONS(736),
    [anon_sym_return] = ACTIONS(736),
    [anon_sym_continue] = ACTIONS(736),
    [anon_sym_break] = ACTIONS(736),
    [anon_sym_consume] = ACTIONS(736),
    [anon_sym_object] = ACTIONS(736),
    [sym_number] = ACTIONS(738),
    [sym_float] = ACTIONS(736),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(736),
    [anon_sym_SQUOTE] = ACTIONS(736),
    [anon_sym_true] = ACTIONS(736),
    [anon_sym_false] = ACTIONS(736),
    [sym_this] = ACTIONS(736),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [305] = {
    [sym_identifier] = ACTIONS(636),
    [anon_sym_EQ] = ACTIONS(636),
    [anon_sym_AT] = ACTIONS(634),
    [anon_sym_LBRACK] = ACTIONS(634),
    [anon_sym_is] = ACTIONS(636),
    [anon_sym_let] = ACTIONS(634),
    [anon_sym_var] = ACTIONS(634),
    [anon_sym_iso] = ACTIONS(634),
    [anon_sym_trn] = ACTIONS(634),
    [anon_sym_ref] = ACTIONS(634),
    [anon_sym_val] = ACTIONS(634),
    [anon_sym_box] = ACTIONS(634),
    [anon_sym_tag] = ACTIONS(634),
    [anon_sym_LPAREN] = ACTIONS(636),
    [anon_sym_DOT] = ACTIONS(636),
    [anon_sym_POUNDread] = ACTIONS(634),
    [anon_sym_POUNDsend] = ACTIONS(634),
    [anon_sym_POUNDshare] = ACTIONS(634),
    [anon_sym_POUNDalias] = ACTIONS(634),
    [anon_sym_POUNDany] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_CARET] = ACTIONS(634),
    [anon_sym_PIPE] = ACTIONS(634),
    [anon_sym_AMP] = ACTIONS(634),
    [anon_sym_DASH_GT] = ACTIONS(634),
    [anon_sym_LBRACE] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(634),
    [sym_error] = ACTIONS(634),
    [sym_compile_intrinsic] = ACTIONS(634),
    [anon_sym_compile_error] = ACTIONS(634),
    [sym_location] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(636),
    [anon_sym_not] = ACTIONS(634),
    [anon_sym_DASH_TILDE] = ACTIONS(634),
    [anon_sym_addressof] = ACTIONS(634),
    [anon_sym_digestof] = ACTIONS(634),
    [anon_sym_PLUS] = ACTIONS(636),
    [anon_sym_STAR] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(636),
    [anon_sym_PERCENT] = ACTIONS(636),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(636),
    [anon_sym_LT_LT] = ACTIONS(636),
    [anon_sym_GT_GT] = ACTIONS(636),
    [anon_sym_and] = ACTIONS(634),
    [anon_sym_or] = ACTIONS(634),
    [anon_sym_xor] = ACTIONS(634),
    [anon_sym_isnt] = ACTIONS(634),
    [anon_sym_EQ_EQ] = ACTIONS(636),
    [anon_sym_BANG_EQ] = ACTIONS(636),
    [anon_sym_GT] = ACTIONS(636),
    [anon_sym_GT_EQ] = ACTIONS(636),
    [anon_sym_LT_EQ] = ACTIONS(636),
    [anon_sym_LT] = ACTIONS(636),
    [anon_sym_PLUS_TILDE] = ACTIONS(634),
    [anon_sym_STAR_TILDE] = ACTIONS(634),
    [anon_sym_SLASH_TILDE] = ACTIONS(634),
    [anon_sym_PERCENT_TILDE] = ACTIONS(634),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(634),
    [anon_sym_LT_LT_TILDE] = ACTIONS(634),
    [anon_sym_GT_GT_TILDE] = ACTIONS(634),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(634),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(634),
    [anon_sym_GT_TILDE] = ACTIONS(634),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(634),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(634),
    [anon_sym_LT_TILDE] = ACTIONS(634),
    [anon_sym_PLUS_QMARK] = ACTIONS(634),
    [anon_sym_DASH_QMARK] = ACTIONS(634),
    [anon_sym_STAR_QMARK] = ACTIONS(634),
    [anon_sym_SLASH_QMARK] = ACTIONS(634),
    [anon_sym_PERCENT_QMARK] = ACTIONS(634),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(634),
    [anon_sym_as] = ACTIONS(634),
    [anon_sym_LPAREN2] = ACTIONS(634),
    [anon_sym_DOT_GT] = ACTIONS(634),
    [anon_sym_TILDE] = ACTIONS(634),
    [anon_sym_end] = ACTIONS(634),
    [anon_sym_if] = ACTIONS(636),
    [anon_sym_ifdef] = ACTIONS(634),
    [anon_sym_elseif] = ACTIONS(634),
    [anon_sym_iftype] = ACTIONS(634),
    [anon_sym_else] = ACTIONS(636),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(634),
    [anon_sym_try] = ACTIONS(634),
    [anon_sym_with] = ACTIONS(634),
    [anon_sym_repeat] = ACTIONS(634),
    [anon_sym_recover] = ACTIONS(634),
    [anon_sym_match] = ACTIONS(634),
    [anon_sym_return] = ACTIONS(634),
    [anon_sym_continue] = ACTIONS(634),
    [anon_sym_break] = ACTIONS(634),
    [anon_sym_consume] = ACTIONS(634),
    [anon_sym_object] = ACTIONS(634),
    [sym_number] = ACTIONS(636),
    [sym_float] = ACTIONS(634),
    [anon_sym_DQUOTE] = ACTIONS(636),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(634),
    [anon_sym_SQUOTE] = ACTIONS(634),
    [anon_sym_true] = ACTIONS(634),
    [anon_sym_false] = ACTIONS(634),
    [sym_this] = ACTIONS(634),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [306] = {
    [sym_identifier] = ACTIONS(632),
    [anon_sym_EQ] = ACTIONS(632),
    [anon_sym_AT] = ACTIONS(630),
    [anon_sym_LBRACK] = ACTIONS(630),
    [anon_sym_is] = ACTIONS(632),
    [anon_sym_let] = ACTIONS(630),
    [anon_sym_var] = ACTIONS(630),
    [anon_sym_iso] = ACTIONS(630),
    [anon_sym_trn] = ACTIONS(630),
    [anon_sym_ref] = ACTIONS(630),
    [anon_sym_val] = ACTIONS(630),
    [anon_sym_box] = ACTIONS(630),
    [anon_sym_tag] = ACTIONS(630),
    [anon_sym_LPAREN] = ACTIONS(632),
    [anon_sym_DOT] = ACTIONS(632),
    [anon_sym_POUNDread] = ACTIONS(630),
    [anon_sym_POUNDsend] = ACTIONS(630),
    [anon_sym_POUNDshare] = ACTIONS(630),
    [anon_sym_POUNDalias] = ACTIONS(630),
    [anon_sym_POUNDany] = ACTIONS(630),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_CARET] = ACTIONS(630),
    [anon_sym_PIPE] = ACTIONS(630),
    [anon_sym_AMP] = ACTIONS(630),
    [anon_sym_DASH_GT] = ACTIONS(630),
    [anon_sym_LBRACE] = ACTIONS(630),
    [anon_sym_SEMI] = ACTIONS(630),
    [sym_error] = ACTIONS(630),
    [sym_compile_intrinsic] = ACTIONS(630),
    [anon_sym_compile_error] = ACTIONS(630),
    [sym_location] = ACTIONS(630),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_not] = ACTIONS(630),
    [anon_sym_DASH_TILDE] = ACTIONS(630),
    [anon_sym_addressof] = ACTIONS(630),
    [anon_sym_digestof] = ACTIONS(630),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_STAR] = ACTIONS(632),
    [anon_sym_SLASH] = ACTIONS(632),
    [anon_sym_PERCENT] = ACTIONS(632),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(632),
    [anon_sym_LT_LT] = ACTIONS(632),
    [anon_sym_GT_GT] = ACTIONS(632),
    [anon_sym_and] = ACTIONS(630),
    [anon_sym_or] = ACTIONS(630),
    [anon_sym_xor] = ACTIONS(630),
    [anon_sym_isnt] = ACTIONS(630),
    [anon_sym_EQ_EQ] = ACTIONS(632),
    [anon_sym_BANG_EQ] = ACTIONS(632),
    [anon_sym_GT] = ACTIONS(632),
    [anon_sym_GT_EQ] = ACTIONS(632),
    [anon_sym_LT_EQ] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(632),
    [anon_sym_PLUS_TILDE] = ACTIONS(630),
    [anon_sym_STAR_TILDE] = ACTIONS(630),
    [anon_sym_SLASH_TILDE] = ACTIONS(630),
    [anon_sym_PERCENT_TILDE] = ACTIONS(630),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(630),
    [anon_sym_LT_LT_TILDE] = ACTIONS(630),
    [anon_sym_GT_GT_TILDE] = ACTIONS(630),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(630),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(630),
    [anon_sym_GT_TILDE] = ACTIONS(630),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(630),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(630),
    [anon_sym_LT_TILDE] = ACTIONS(630),
    [anon_sym_PLUS_QMARK] = ACTIONS(630),
    [anon_sym_DASH_QMARK] = ACTIONS(630),
    [anon_sym_STAR_QMARK] = ACTIONS(630),
    [anon_sym_SLASH_QMARK] = ACTIONS(630),
    [anon_sym_PERCENT_QMARK] = ACTIONS(630),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(630),
    [anon_sym_as] = ACTIONS(630),
    [anon_sym_LPAREN2] = ACTIONS(630),
    [anon_sym_DOT_GT] = ACTIONS(630),
    [anon_sym_TILDE] = ACTIONS(630),
    [anon_sym_end] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(632),
    [anon_sym_ifdef] = ACTIONS(630),
    [anon_sym_elseif] = ACTIONS(630),
    [anon_sym_iftype] = ACTIONS(630),
    [anon_sym_else] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(630),
    [anon_sym_while] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(630),
    [anon_sym_with] = ACTIONS(630),
    [anon_sym_repeat] = ACTIONS(630),
    [anon_sym_recover] = ACTIONS(630),
    [anon_sym_match] = ACTIONS(630),
    [anon_sym_return] = ACTIONS(630),
    [anon_sym_continue] = ACTIONS(630),
    [anon_sym_break] = ACTIONS(630),
    [anon_sym_consume] = ACTIONS(630),
    [anon_sym_object] = ACTIONS(630),
    [sym_number] = ACTIONS(632),
    [sym_float] = ACTIONS(630),
    [anon_sym_DQUOTE] = ACTIONS(632),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(630),
    [anon_sym_SQUOTE] = ACTIONS(630),
    [anon_sym_true] = ACTIONS(630),
    [anon_sym_false] = ACTIONS(630),
    [sym_this] = ACTIONS(630),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [307] = {
    [ts_builtin_sym_end] = ACTIONS(1268),
    [sym_identifier] = ACTIONS(1270),
    [anon_sym_use] = ACTIONS(1268),
    [anon_sym_EQ] = ACTIONS(1270),
    [anon_sym_AT] = ACTIONS(1268),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [anon_sym_type] = ACTIONS(1268),
    [anon_sym_is] = ACTIONS(1270),
    [anon_sym_actor] = ACTIONS(1268),
    [anon_sym_class] = ACTIONS(1268),
    [anon_sym_primitive] = ACTIONS(1268),
    [anon_sym_interface] = ACTIONS(1268),
    [anon_sym_trait] = ACTIONS(1268),
    [anon_sym_struct] = ACTIONS(1268),
    [anon_sym_embed] = ACTIONS(1268),
    [anon_sym_let] = ACTIONS(1268),
    [anon_sym_var] = ACTIONS(1268),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_fun] = ACTIONS(1268),
    [anon_sym_be] = ACTIONS(1268),
    [anon_sym_COMMA] = ACTIONS(1268),
    [anon_sym_LPAREN] = ACTIONS(1270),
    [anon_sym_RPAREN] = ACTIONS(1268),
    [anon_sym_DOT] = ACTIONS(1270),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_SEMI] = ACTIONS(1268),
    [sym_error] = ACTIONS(1268),
    [sym_compile_intrinsic] = ACTIONS(1268),
    [anon_sym_compile_error] = ACTIONS(1268),
    [sym_location] = ACTIONS(1268),
    [anon_sym_DASH] = ACTIONS(1270),
    [anon_sym_not] = ACTIONS(1268),
    [anon_sym_DASH_TILDE] = ACTIONS(1268),
    [anon_sym_addressof] = ACTIONS(1268),
    [anon_sym_digestof] = ACTIONS(1268),
    [anon_sym_PLUS] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1270),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_PERCENT] = ACTIONS(1270),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1270),
    [anon_sym_LT_LT] = ACTIONS(1270),
    [anon_sym_GT_GT] = ACTIONS(1270),
    [anon_sym_and] = ACTIONS(1268),
    [anon_sym_or] = ACTIONS(1268),
    [anon_sym_xor] = ACTIONS(1268),
    [anon_sym_isnt] = ACTIONS(1268),
    [anon_sym_EQ_EQ] = ACTIONS(1270),
    [anon_sym_BANG_EQ] = ACTIONS(1270),
    [anon_sym_GT] = ACTIONS(1270),
    [anon_sym_GT_EQ] = ACTIONS(1270),
    [anon_sym_LT_EQ] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(1270),
    [anon_sym_PLUS_TILDE] = ACTIONS(1268),
    [anon_sym_STAR_TILDE] = ACTIONS(1268),
    [anon_sym_SLASH_TILDE] = ACTIONS(1268),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1268),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1268),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1268),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1268),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1268),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1268),
    [anon_sym_GT_TILDE] = ACTIONS(1268),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1268),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1268),
    [anon_sym_LT_TILDE] = ACTIONS(1268),
    [anon_sym_PLUS_QMARK] = ACTIONS(1268),
    [anon_sym_DASH_QMARK] = ACTIONS(1268),
    [anon_sym_STAR_QMARK] = ACTIONS(1268),
    [anon_sym_SLASH_QMARK] = ACTIONS(1268),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1268),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1268),
    [anon_sym_as] = ACTIONS(1268),
    [anon_sym_LPAREN2] = ACTIONS(1268),
    [anon_sym_DOT_GT] = ACTIONS(1268),
    [anon_sym_where] = ACTIONS(1268),
    [anon_sym_TILDE] = ACTIONS(1268),
    [anon_sym_end] = ACTIONS(1268),
    [anon_sym_if] = ACTIONS(1270),
    [anon_sym_ifdef] = ACTIONS(1268),
    [anon_sym_iftype] = ACTIONS(1268),
    [anon_sym_else] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(1268),
    [anon_sym_while] = ACTIONS(1268),
    [anon_sym_try] = ACTIONS(1268),
    [anon_sym_with] = ACTIONS(1268),
    [anon_sym_repeat] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(1268),
    [anon_sym_recover] = ACTIONS(1268),
    [anon_sym_match] = ACTIONS(1268),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_continue] = ACTIONS(1268),
    [anon_sym_break] = ACTIONS(1268),
    [anon_sym_consume] = ACTIONS(1268),
    [anon_sym_object] = ACTIONS(1268),
    [sym_number] = ACTIONS(1270),
    [sym_float] = ACTIONS(1268),
    [anon_sym_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1268),
    [anon_sym_SQUOTE] = ACTIONS(1268),
    [anon_sym_true] = ACTIONS(1268),
    [anon_sym_false] = ACTIONS(1268),
    [sym_this] = ACTIONS(1268),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [308] = {
    [ts_builtin_sym_end] = ACTIONS(1272),
    [sym_identifier] = ACTIONS(1274),
    [anon_sym_use] = ACTIONS(1272),
    [anon_sym_EQ] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(1272),
    [anon_sym_LBRACK] = ACTIONS(1272),
    [anon_sym_type] = ACTIONS(1272),
    [anon_sym_is] = ACTIONS(1274),
    [anon_sym_actor] = ACTIONS(1272),
    [anon_sym_class] = ACTIONS(1272),
    [anon_sym_primitive] = ACTIONS(1272),
    [anon_sym_interface] = ACTIONS(1272),
    [anon_sym_trait] = ACTIONS(1272),
    [anon_sym_struct] = ACTIONS(1272),
    [anon_sym_embed] = ACTIONS(1272),
    [anon_sym_let] = ACTIONS(1272),
    [anon_sym_var] = ACTIONS(1272),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_fun] = ACTIONS(1272),
    [anon_sym_be] = ACTIONS(1272),
    [anon_sym_COMMA] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(1274),
    [anon_sym_RPAREN] = ACTIONS(1272),
    [anon_sym_DOT] = ACTIONS(1274),
    [anon_sym_LBRACE] = ACTIONS(1272),
    [anon_sym_SEMI] = ACTIONS(1272),
    [sym_error] = ACTIONS(1272),
    [sym_compile_intrinsic] = ACTIONS(1272),
    [anon_sym_compile_error] = ACTIONS(1272),
    [sym_location] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_not] = ACTIONS(1272),
    [anon_sym_DASH_TILDE] = ACTIONS(1272),
    [anon_sym_addressof] = ACTIONS(1272),
    [anon_sym_digestof] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1274),
    [anon_sym_STAR] = ACTIONS(1274),
    [anon_sym_SLASH] = ACTIONS(1274),
    [anon_sym_PERCENT] = ACTIONS(1274),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1274),
    [anon_sym_LT_LT] = ACTIONS(1274),
    [anon_sym_GT_GT] = ACTIONS(1274),
    [anon_sym_and] = ACTIONS(1272),
    [anon_sym_or] = ACTIONS(1272),
    [anon_sym_xor] = ACTIONS(1272),
    [anon_sym_isnt] = ACTIONS(1272),
    [anon_sym_EQ_EQ] = ACTIONS(1274),
    [anon_sym_BANG_EQ] = ACTIONS(1274),
    [anon_sym_GT] = ACTIONS(1274),
    [anon_sym_GT_EQ] = ACTIONS(1274),
    [anon_sym_LT_EQ] = ACTIONS(1274),
    [anon_sym_LT] = ACTIONS(1274),
    [anon_sym_PLUS_TILDE] = ACTIONS(1272),
    [anon_sym_STAR_TILDE] = ACTIONS(1272),
    [anon_sym_SLASH_TILDE] = ACTIONS(1272),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1272),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1272),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1272),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1272),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1272),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1272),
    [anon_sym_GT_TILDE] = ACTIONS(1272),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1272),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1272),
    [anon_sym_LT_TILDE] = ACTIONS(1272),
    [anon_sym_PLUS_QMARK] = ACTIONS(1272),
    [anon_sym_DASH_QMARK] = ACTIONS(1272),
    [anon_sym_STAR_QMARK] = ACTIONS(1272),
    [anon_sym_SLASH_QMARK] = ACTIONS(1272),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1272),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1272),
    [anon_sym_as] = ACTIONS(1272),
    [anon_sym_LPAREN2] = ACTIONS(1272),
    [anon_sym_DOT_GT] = ACTIONS(1272),
    [anon_sym_where] = ACTIONS(1272),
    [anon_sym_TILDE] = ACTIONS(1272),
    [anon_sym_end] = ACTIONS(1272),
    [anon_sym_if] = ACTIONS(1274),
    [anon_sym_ifdef] = ACTIONS(1272),
    [anon_sym_iftype] = ACTIONS(1272),
    [anon_sym_else] = ACTIONS(1272),
    [anon_sym_for] = ACTIONS(1272),
    [anon_sym_while] = ACTIONS(1272),
    [anon_sym_try] = ACTIONS(1272),
    [anon_sym_with] = ACTIONS(1272),
    [anon_sym_repeat] = ACTIONS(1272),
    [anon_sym_do] = ACTIONS(1272),
    [anon_sym_recover] = ACTIONS(1272),
    [anon_sym_match] = ACTIONS(1272),
    [anon_sym_return] = ACTIONS(1272),
    [anon_sym_continue] = ACTIONS(1272),
    [anon_sym_break] = ACTIONS(1272),
    [anon_sym_consume] = ACTIONS(1272),
    [anon_sym_object] = ACTIONS(1272),
    [sym_number] = ACTIONS(1274),
    [sym_float] = ACTIONS(1272),
    [anon_sym_DQUOTE] = ACTIONS(1274),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1272),
    [anon_sym_SQUOTE] = ACTIONS(1272),
    [anon_sym_true] = ACTIONS(1272),
    [anon_sym_false] = ACTIONS(1272),
    [sym_this] = ACTIONS(1272),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [309] = {
    [sym_identifier] = ACTIONS(718),
    [anon_sym_EQ] = ACTIONS(718),
    [anon_sym_AT] = ACTIONS(716),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_is] = ACTIONS(718),
    [anon_sym_let] = ACTIONS(716),
    [anon_sym_var] = ACTIONS(716),
    [anon_sym_iso] = ACTIONS(716),
    [anon_sym_trn] = ACTIONS(716),
    [anon_sym_ref] = ACTIONS(716),
    [anon_sym_val] = ACTIONS(716),
    [anon_sym_box] = ACTIONS(716),
    [anon_sym_tag] = ACTIONS(716),
    [anon_sym_LPAREN] = ACTIONS(718),
    [anon_sym_DOT] = ACTIONS(718),
    [anon_sym_POUNDread] = ACTIONS(716),
    [anon_sym_POUNDsend] = ACTIONS(716),
    [anon_sym_POUNDshare] = ACTIONS(716),
    [anon_sym_POUNDalias] = ACTIONS(716),
    [anon_sym_POUNDany] = ACTIONS(716),
    [anon_sym_BANG] = ACTIONS(718),
    [anon_sym_CARET] = ACTIONS(716),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_AMP] = ACTIONS(716),
    [anon_sym_DASH_GT] = ACTIONS(716),
    [anon_sym_LBRACE] = ACTIONS(716),
    [anon_sym_SEMI] = ACTIONS(716),
    [sym_error] = ACTIONS(716),
    [sym_compile_intrinsic] = ACTIONS(716),
    [anon_sym_compile_error] = ACTIONS(716),
    [sym_location] = ACTIONS(716),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_not] = ACTIONS(716),
    [anon_sym_DASH_TILDE] = ACTIONS(716),
    [anon_sym_addressof] = ACTIONS(716),
    [anon_sym_digestof] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_STAR] = ACTIONS(718),
    [anon_sym_SLASH] = ACTIONS(718),
    [anon_sym_PERCENT] = ACTIONS(718),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(718),
    [anon_sym_LT_LT] = ACTIONS(718),
    [anon_sym_GT_GT] = ACTIONS(718),
    [anon_sym_and] = ACTIONS(716),
    [anon_sym_or] = ACTIONS(716),
    [anon_sym_xor] = ACTIONS(716),
    [anon_sym_isnt] = ACTIONS(716),
    [anon_sym_EQ_EQ] = ACTIONS(718),
    [anon_sym_BANG_EQ] = ACTIONS(718),
    [anon_sym_GT] = ACTIONS(718),
    [anon_sym_GT_EQ] = ACTIONS(718),
    [anon_sym_LT_EQ] = ACTIONS(718),
    [anon_sym_LT] = ACTIONS(718),
    [anon_sym_PLUS_TILDE] = ACTIONS(716),
    [anon_sym_STAR_TILDE] = ACTIONS(716),
    [anon_sym_SLASH_TILDE] = ACTIONS(716),
    [anon_sym_PERCENT_TILDE] = ACTIONS(716),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(716),
    [anon_sym_LT_LT_TILDE] = ACTIONS(716),
    [anon_sym_GT_GT_TILDE] = ACTIONS(716),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(716),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(716),
    [anon_sym_GT_TILDE] = ACTIONS(716),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(716),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(716),
    [anon_sym_LT_TILDE] = ACTIONS(716),
    [anon_sym_PLUS_QMARK] = ACTIONS(716),
    [anon_sym_DASH_QMARK] = ACTIONS(716),
    [anon_sym_STAR_QMARK] = ACTIONS(716),
    [anon_sym_SLASH_QMARK] = ACTIONS(716),
    [anon_sym_PERCENT_QMARK] = ACTIONS(716),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(716),
    [anon_sym_as] = ACTIONS(716),
    [anon_sym_LPAREN2] = ACTIONS(716),
    [anon_sym_DOT_GT] = ACTIONS(716),
    [anon_sym_TILDE] = ACTIONS(716),
    [anon_sym_end] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(718),
    [anon_sym_ifdef] = ACTIONS(716),
    [anon_sym_elseif] = ACTIONS(716),
    [anon_sym_iftype] = ACTIONS(716),
    [anon_sym_else] = ACTIONS(718),
    [anon_sym_for] = ACTIONS(716),
    [anon_sym_while] = ACTIONS(716),
    [anon_sym_try] = ACTIONS(716),
    [anon_sym_with] = ACTIONS(716),
    [anon_sym_repeat] = ACTIONS(716),
    [anon_sym_recover] = ACTIONS(716),
    [anon_sym_match] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(716),
    [anon_sym_continue] = ACTIONS(716),
    [anon_sym_break] = ACTIONS(716),
    [anon_sym_consume] = ACTIONS(716),
    [anon_sym_object] = ACTIONS(716),
    [sym_number] = ACTIONS(718),
    [sym_float] = ACTIONS(716),
    [anon_sym_DQUOTE] = ACTIONS(718),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(716),
    [anon_sym_SQUOTE] = ACTIONS(716),
    [anon_sym_true] = ACTIONS(716),
    [anon_sym_false] = ACTIONS(716),
    [sym_this] = ACTIONS(716),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [310] = {
    [sym_identifier] = ACTIONS(714),
    [anon_sym_EQ] = ACTIONS(714),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_LBRACK] = ACTIONS(712),
    [anon_sym_is] = ACTIONS(714),
    [anon_sym_let] = ACTIONS(712),
    [anon_sym_var] = ACTIONS(712),
    [anon_sym_iso] = ACTIONS(712),
    [anon_sym_trn] = ACTIONS(712),
    [anon_sym_ref] = ACTIONS(712),
    [anon_sym_val] = ACTIONS(712),
    [anon_sym_box] = ACTIONS(712),
    [anon_sym_tag] = ACTIONS(712),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_DOT] = ACTIONS(714),
    [anon_sym_POUNDread] = ACTIONS(712),
    [anon_sym_POUNDsend] = ACTIONS(712),
    [anon_sym_POUNDshare] = ACTIONS(712),
    [anon_sym_POUNDalias] = ACTIONS(712),
    [anon_sym_POUNDany] = ACTIONS(712),
    [anon_sym_BANG] = ACTIONS(714),
    [anon_sym_CARET] = ACTIONS(712),
    [anon_sym_PIPE] = ACTIONS(712),
    [anon_sym_AMP] = ACTIONS(712),
    [anon_sym_DASH_GT] = ACTIONS(712),
    [anon_sym_LBRACE] = ACTIONS(712),
    [anon_sym_SEMI] = ACTIONS(712),
    [sym_error] = ACTIONS(712),
    [sym_compile_intrinsic] = ACTIONS(712),
    [anon_sym_compile_error] = ACTIONS(712),
    [sym_location] = ACTIONS(712),
    [anon_sym_DASH] = ACTIONS(714),
    [anon_sym_not] = ACTIONS(712),
    [anon_sym_DASH_TILDE] = ACTIONS(712),
    [anon_sym_addressof] = ACTIONS(712),
    [anon_sym_digestof] = ACTIONS(712),
    [anon_sym_PLUS] = ACTIONS(714),
    [anon_sym_STAR] = ACTIONS(714),
    [anon_sym_SLASH] = ACTIONS(714),
    [anon_sym_PERCENT] = ACTIONS(714),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(714),
    [anon_sym_LT_LT] = ACTIONS(714),
    [anon_sym_GT_GT] = ACTIONS(714),
    [anon_sym_and] = ACTIONS(712),
    [anon_sym_or] = ACTIONS(712),
    [anon_sym_xor] = ACTIONS(712),
    [anon_sym_isnt] = ACTIONS(712),
    [anon_sym_EQ_EQ] = ACTIONS(714),
    [anon_sym_BANG_EQ] = ACTIONS(714),
    [anon_sym_GT] = ACTIONS(714),
    [anon_sym_GT_EQ] = ACTIONS(714),
    [anon_sym_LT_EQ] = ACTIONS(714),
    [anon_sym_LT] = ACTIONS(714),
    [anon_sym_PLUS_TILDE] = ACTIONS(712),
    [anon_sym_STAR_TILDE] = ACTIONS(712),
    [anon_sym_SLASH_TILDE] = ACTIONS(712),
    [anon_sym_PERCENT_TILDE] = ACTIONS(712),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(712),
    [anon_sym_LT_LT_TILDE] = ACTIONS(712),
    [anon_sym_GT_GT_TILDE] = ACTIONS(712),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(712),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(712),
    [anon_sym_GT_TILDE] = ACTIONS(712),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(712),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(712),
    [anon_sym_LT_TILDE] = ACTIONS(712),
    [anon_sym_PLUS_QMARK] = ACTIONS(712),
    [anon_sym_DASH_QMARK] = ACTIONS(712),
    [anon_sym_STAR_QMARK] = ACTIONS(712),
    [anon_sym_SLASH_QMARK] = ACTIONS(712),
    [anon_sym_PERCENT_QMARK] = ACTIONS(712),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(712),
    [anon_sym_as] = ACTIONS(712),
    [anon_sym_LPAREN2] = ACTIONS(712),
    [anon_sym_DOT_GT] = ACTIONS(712),
    [anon_sym_TILDE] = ACTIONS(712),
    [anon_sym_end] = ACTIONS(712),
    [anon_sym_if] = ACTIONS(714),
    [anon_sym_ifdef] = ACTIONS(712),
    [anon_sym_elseif] = ACTIONS(712),
    [anon_sym_iftype] = ACTIONS(712),
    [anon_sym_else] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(712),
    [anon_sym_while] = ACTIONS(712),
    [anon_sym_try] = ACTIONS(712),
    [anon_sym_with] = ACTIONS(712),
    [anon_sym_repeat] = ACTIONS(712),
    [anon_sym_recover] = ACTIONS(712),
    [anon_sym_match] = ACTIONS(712),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_continue] = ACTIONS(712),
    [anon_sym_break] = ACTIONS(712),
    [anon_sym_consume] = ACTIONS(712),
    [anon_sym_object] = ACTIONS(712),
    [sym_number] = ACTIONS(714),
    [sym_float] = ACTIONS(712),
    [anon_sym_DQUOTE] = ACTIONS(714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [anon_sym_true] = ACTIONS(712),
    [anon_sym_false] = ACTIONS(712),
    [sym_this] = ACTIONS(712),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [311] = {
    [sym_identifier] = ACTIONS(710),
    [anon_sym_EQ] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(708),
    [anon_sym_LBRACK] = ACTIONS(708),
    [anon_sym_is] = ACTIONS(710),
    [anon_sym_let] = ACTIONS(708),
    [anon_sym_var] = ACTIONS(708),
    [anon_sym_iso] = ACTIONS(708),
    [anon_sym_trn] = ACTIONS(708),
    [anon_sym_ref] = ACTIONS(708),
    [anon_sym_val] = ACTIONS(708),
    [anon_sym_box] = ACTIONS(708),
    [anon_sym_tag] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_DOT] = ACTIONS(710),
    [anon_sym_POUNDread] = ACTIONS(708),
    [anon_sym_POUNDsend] = ACTIONS(708),
    [anon_sym_POUNDshare] = ACTIONS(708),
    [anon_sym_POUNDalias] = ACTIONS(708),
    [anon_sym_POUNDany] = ACTIONS(708),
    [anon_sym_BANG] = ACTIONS(710),
    [anon_sym_CARET] = ACTIONS(708),
    [anon_sym_PIPE] = ACTIONS(708),
    [anon_sym_AMP] = ACTIONS(708),
    [anon_sym_DASH_GT] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(708),
    [anon_sym_SEMI] = ACTIONS(708),
    [sym_error] = ACTIONS(708),
    [sym_compile_intrinsic] = ACTIONS(708),
    [anon_sym_compile_error] = ACTIONS(708),
    [sym_location] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_not] = ACTIONS(708),
    [anon_sym_DASH_TILDE] = ACTIONS(708),
    [anon_sym_addressof] = ACTIONS(708),
    [anon_sym_digestof] = ACTIONS(708),
    [anon_sym_PLUS] = ACTIONS(710),
    [anon_sym_STAR] = ACTIONS(710),
    [anon_sym_SLASH] = ACTIONS(710),
    [anon_sym_PERCENT] = ACTIONS(710),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(710),
    [anon_sym_LT_LT] = ACTIONS(710),
    [anon_sym_GT_GT] = ACTIONS(710),
    [anon_sym_and] = ACTIONS(708),
    [anon_sym_or] = ACTIONS(708),
    [anon_sym_xor] = ACTIONS(708),
    [anon_sym_isnt] = ACTIONS(708),
    [anon_sym_EQ_EQ] = ACTIONS(710),
    [anon_sym_BANG_EQ] = ACTIONS(710),
    [anon_sym_GT] = ACTIONS(710),
    [anon_sym_GT_EQ] = ACTIONS(710),
    [anon_sym_LT_EQ] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(710),
    [anon_sym_PLUS_TILDE] = ACTIONS(708),
    [anon_sym_STAR_TILDE] = ACTIONS(708),
    [anon_sym_SLASH_TILDE] = ACTIONS(708),
    [anon_sym_PERCENT_TILDE] = ACTIONS(708),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(708),
    [anon_sym_LT_LT_TILDE] = ACTIONS(708),
    [anon_sym_GT_GT_TILDE] = ACTIONS(708),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(708),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(708),
    [anon_sym_GT_TILDE] = ACTIONS(708),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(708),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(708),
    [anon_sym_LT_TILDE] = ACTIONS(708),
    [anon_sym_PLUS_QMARK] = ACTIONS(708),
    [anon_sym_DASH_QMARK] = ACTIONS(708),
    [anon_sym_STAR_QMARK] = ACTIONS(708),
    [anon_sym_SLASH_QMARK] = ACTIONS(708),
    [anon_sym_PERCENT_QMARK] = ACTIONS(708),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(708),
    [anon_sym_as] = ACTIONS(708),
    [anon_sym_LPAREN2] = ACTIONS(708),
    [anon_sym_DOT_GT] = ACTIONS(708),
    [anon_sym_TILDE] = ACTIONS(708),
    [anon_sym_end] = ACTIONS(708),
    [anon_sym_if] = ACTIONS(710),
    [anon_sym_ifdef] = ACTIONS(708),
    [anon_sym_elseif] = ACTIONS(708),
    [anon_sym_iftype] = ACTIONS(708),
    [anon_sym_else] = ACTIONS(710),
    [anon_sym_for] = ACTIONS(708),
    [anon_sym_while] = ACTIONS(708),
    [anon_sym_try] = ACTIONS(708),
    [anon_sym_with] = ACTIONS(708),
    [anon_sym_repeat] = ACTIONS(708),
    [anon_sym_recover] = ACTIONS(708),
    [anon_sym_match] = ACTIONS(708),
    [anon_sym_return] = ACTIONS(708),
    [anon_sym_continue] = ACTIONS(708),
    [anon_sym_break] = ACTIONS(708),
    [anon_sym_consume] = ACTIONS(708),
    [anon_sym_object] = ACTIONS(708),
    [sym_number] = ACTIONS(710),
    [sym_float] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(708),
    [anon_sym_true] = ACTIONS(708),
    [anon_sym_false] = ACTIONS(708),
    [sym_this] = ACTIONS(708),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [312] = {
    [sym_identifier] = ACTIONS(676),
    [anon_sym_EQ] = ACTIONS(676),
    [anon_sym_AT] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(674),
    [anon_sym_is] = ACTIONS(676),
    [anon_sym_let] = ACTIONS(674),
    [anon_sym_var] = ACTIONS(674),
    [anon_sym_iso] = ACTIONS(674),
    [anon_sym_trn] = ACTIONS(674),
    [anon_sym_ref] = ACTIONS(674),
    [anon_sym_val] = ACTIONS(674),
    [anon_sym_box] = ACTIONS(674),
    [anon_sym_tag] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(676),
    [anon_sym_DOT] = ACTIONS(676),
    [anon_sym_POUNDread] = ACTIONS(674),
    [anon_sym_POUNDsend] = ACTIONS(674),
    [anon_sym_POUNDshare] = ACTIONS(674),
    [anon_sym_POUNDalias] = ACTIONS(674),
    [anon_sym_POUNDany] = ACTIONS(674),
    [anon_sym_BANG] = ACTIONS(676),
    [anon_sym_CARET] = ACTIONS(674),
    [anon_sym_PIPE] = ACTIONS(674),
    [anon_sym_AMP] = ACTIONS(674),
    [anon_sym_DASH_GT] = ACTIONS(674),
    [anon_sym_LBRACE] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(674),
    [sym_error] = ACTIONS(674),
    [sym_compile_intrinsic] = ACTIONS(674),
    [anon_sym_compile_error] = ACTIONS(674),
    [sym_location] = ACTIONS(674),
    [anon_sym_DASH] = ACTIONS(676),
    [anon_sym_not] = ACTIONS(674),
    [anon_sym_DASH_TILDE] = ACTIONS(674),
    [anon_sym_addressof] = ACTIONS(674),
    [anon_sym_digestof] = ACTIONS(674),
    [anon_sym_PLUS] = ACTIONS(676),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_SLASH] = ACTIONS(676),
    [anon_sym_PERCENT] = ACTIONS(676),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(676),
    [anon_sym_LT_LT] = ACTIONS(676),
    [anon_sym_GT_GT] = ACTIONS(676),
    [anon_sym_and] = ACTIONS(674),
    [anon_sym_or] = ACTIONS(674),
    [anon_sym_xor] = ACTIONS(674),
    [anon_sym_isnt] = ACTIONS(674),
    [anon_sym_EQ_EQ] = ACTIONS(676),
    [anon_sym_BANG_EQ] = ACTIONS(676),
    [anon_sym_GT] = ACTIONS(676),
    [anon_sym_GT_EQ] = ACTIONS(676),
    [anon_sym_LT_EQ] = ACTIONS(676),
    [anon_sym_LT] = ACTIONS(676),
    [anon_sym_PLUS_TILDE] = ACTIONS(674),
    [anon_sym_STAR_TILDE] = ACTIONS(674),
    [anon_sym_SLASH_TILDE] = ACTIONS(674),
    [anon_sym_PERCENT_TILDE] = ACTIONS(674),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(674),
    [anon_sym_LT_LT_TILDE] = ACTIONS(674),
    [anon_sym_GT_GT_TILDE] = ACTIONS(674),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(674),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(674),
    [anon_sym_GT_TILDE] = ACTIONS(674),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(674),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(674),
    [anon_sym_LT_TILDE] = ACTIONS(674),
    [anon_sym_PLUS_QMARK] = ACTIONS(674),
    [anon_sym_DASH_QMARK] = ACTIONS(674),
    [anon_sym_STAR_QMARK] = ACTIONS(674),
    [anon_sym_SLASH_QMARK] = ACTIONS(674),
    [anon_sym_PERCENT_QMARK] = ACTIONS(674),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(674),
    [anon_sym_as] = ACTIONS(674),
    [anon_sym_LPAREN2] = ACTIONS(674),
    [anon_sym_DOT_GT] = ACTIONS(674),
    [anon_sym_TILDE] = ACTIONS(674),
    [anon_sym_end] = ACTIONS(674),
    [anon_sym_if] = ACTIONS(676),
    [anon_sym_ifdef] = ACTIONS(674),
    [anon_sym_elseif] = ACTIONS(674),
    [anon_sym_iftype] = ACTIONS(674),
    [anon_sym_else] = ACTIONS(676),
    [anon_sym_for] = ACTIONS(674),
    [anon_sym_while] = ACTIONS(674),
    [anon_sym_try] = ACTIONS(674),
    [anon_sym_with] = ACTIONS(674),
    [anon_sym_repeat] = ACTIONS(674),
    [anon_sym_recover] = ACTIONS(674),
    [anon_sym_match] = ACTIONS(674),
    [anon_sym_return] = ACTIONS(674),
    [anon_sym_continue] = ACTIONS(674),
    [anon_sym_break] = ACTIONS(674),
    [anon_sym_consume] = ACTIONS(674),
    [anon_sym_object] = ACTIONS(674),
    [sym_number] = ACTIONS(676),
    [sym_float] = ACTIONS(674),
    [anon_sym_DQUOTE] = ACTIONS(676),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(674),
    [anon_sym_SQUOTE] = ACTIONS(674),
    [anon_sym_true] = ACTIONS(674),
    [anon_sym_false] = ACTIONS(674),
    [sym_this] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [313] = {
    [sym_identifier] = ACTIONS(672),
    [anon_sym_EQ] = ACTIONS(672),
    [anon_sym_AT] = ACTIONS(670),
    [anon_sym_LBRACK] = ACTIONS(670),
    [anon_sym_is] = ACTIONS(672),
    [anon_sym_let] = ACTIONS(670),
    [anon_sym_var] = ACTIONS(670),
    [anon_sym_iso] = ACTIONS(670),
    [anon_sym_trn] = ACTIONS(670),
    [anon_sym_ref] = ACTIONS(670),
    [anon_sym_val] = ACTIONS(670),
    [anon_sym_box] = ACTIONS(670),
    [anon_sym_tag] = ACTIONS(670),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_DOT] = ACTIONS(672),
    [anon_sym_POUNDread] = ACTIONS(670),
    [anon_sym_POUNDsend] = ACTIONS(670),
    [anon_sym_POUNDshare] = ACTIONS(670),
    [anon_sym_POUNDalias] = ACTIONS(670),
    [anon_sym_POUNDany] = ACTIONS(670),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_CARET] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(670),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_DASH_GT] = ACTIONS(670),
    [anon_sym_LBRACE] = ACTIONS(670),
    [anon_sym_SEMI] = ACTIONS(670),
    [sym_error] = ACTIONS(670),
    [sym_compile_intrinsic] = ACTIONS(670),
    [anon_sym_compile_error] = ACTIONS(670),
    [sym_location] = ACTIONS(670),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_not] = ACTIONS(670),
    [anon_sym_DASH_TILDE] = ACTIONS(670),
    [anon_sym_addressof] = ACTIONS(670),
    [anon_sym_digestof] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_SLASH] = ACTIONS(672),
    [anon_sym_PERCENT] = ACTIONS(672),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(672),
    [anon_sym_LT_LT] = ACTIONS(672),
    [anon_sym_GT_GT] = ACTIONS(672),
    [anon_sym_and] = ACTIONS(670),
    [anon_sym_or] = ACTIONS(670),
    [anon_sym_xor] = ACTIONS(670),
    [anon_sym_isnt] = ACTIONS(670),
    [anon_sym_EQ_EQ] = ACTIONS(672),
    [anon_sym_BANG_EQ] = ACTIONS(672),
    [anon_sym_GT] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(672),
    [anon_sym_LT_EQ] = ACTIONS(672),
    [anon_sym_LT] = ACTIONS(672),
    [anon_sym_PLUS_TILDE] = ACTIONS(670),
    [anon_sym_STAR_TILDE] = ACTIONS(670),
    [anon_sym_SLASH_TILDE] = ACTIONS(670),
    [anon_sym_PERCENT_TILDE] = ACTIONS(670),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(670),
    [anon_sym_LT_LT_TILDE] = ACTIONS(670),
    [anon_sym_GT_GT_TILDE] = ACTIONS(670),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(670),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(670),
    [anon_sym_GT_TILDE] = ACTIONS(670),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(670),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(670),
    [anon_sym_LT_TILDE] = ACTIONS(670),
    [anon_sym_PLUS_QMARK] = ACTIONS(670),
    [anon_sym_DASH_QMARK] = ACTIONS(670),
    [anon_sym_STAR_QMARK] = ACTIONS(670),
    [anon_sym_SLASH_QMARK] = ACTIONS(670),
    [anon_sym_PERCENT_QMARK] = ACTIONS(670),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(670),
    [anon_sym_as] = ACTIONS(670),
    [anon_sym_LPAREN2] = ACTIONS(670),
    [anon_sym_DOT_GT] = ACTIONS(670),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_end] = ACTIONS(670),
    [anon_sym_if] = ACTIONS(672),
    [anon_sym_ifdef] = ACTIONS(670),
    [anon_sym_elseif] = ACTIONS(670),
    [anon_sym_iftype] = ACTIONS(670),
    [anon_sym_else] = ACTIONS(672),
    [anon_sym_for] = ACTIONS(670),
    [anon_sym_while] = ACTIONS(670),
    [anon_sym_try] = ACTIONS(670),
    [anon_sym_with] = ACTIONS(670),
    [anon_sym_repeat] = ACTIONS(670),
    [anon_sym_recover] = ACTIONS(670),
    [anon_sym_match] = ACTIONS(670),
    [anon_sym_return] = ACTIONS(670),
    [anon_sym_continue] = ACTIONS(670),
    [anon_sym_break] = ACTIONS(670),
    [anon_sym_consume] = ACTIONS(670),
    [anon_sym_object] = ACTIONS(670),
    [sym_number] = ACTIONS(672),
    [sym_float] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(672),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(670),
    [anon_sym_SQUOTE] = ACTIONS(670),
    [anon_sym_true] = ACTIONS(670),
    [anon_sym_false] = ACTIONS(670),
    [sym_this] = ACTIONS(670),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [314] = {
    [ts_builtin_sym_end] = ACTIONS(1276),
    [sym_identifier] = ACTIONS(1278),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_EQ] = ACTIONS(1278),
    [anon_sym_AT] = ACTIONS(1276),
    [anon_sym_LBRACK] = ACTIONS(1276),
    [anon_sym_type] = ACTIONS(1276),
    [anon_sym_is] = ACTIONS(1278),
    [anon_sym_actor] = ACTIONS(1276),
    [anon_sym_class] = ACTIONS(1276),
    [anon_sym_primitive] = ACTIONS(1276),
    [anon_sym_interface] = ACTIONS(1276),
    [anon_sym_trait] = ACTIONS(1276),
    [anon_sym_struct] = ACTIONS(1276),
    [anon_sym_embed] = ACTIONS(1276),
    [anon_sym_let] = ACTIONS(1276),
    [anon_sym_var] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_fun] = ACTIONS(1276),
    [anon_sym_be] = ACTIONS(1276),
    [anon_sym_COMMA] = ACTIONS(1276),
    [anon_sym_LPAREN] = ACTIONS(1278),
    [anon_sym_RPAREN] = ACTIONS(1276),
    [anon_sym_DOT] = ACTIONS(1278),
    [anon_sym_LBRACE] = ACTIONS(1276),
    [anon_sym_SEMI] = ACTIONS(1276),
    [sym_error] = ACTIONS(1276),
    [sym_compile_intrinsic] = ACTIONS(1276),
    [anon_sym_compile_error] = ACTIONS(1276),
    [sym_location] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_not] = ACTIONS(1276),
    [anon_sym_DASH_TILDE] = ACTIONS(1276),
    [anon_sym_addressof] = ACTIONS(1276),
    [anon_sym_digestof] = ACTIONS(1276),
    [anon_sym_PLUS] = ACTIONS(1278),
    [anon_sym_STAR] = ACTIONS(1278),
    [anon_sym_SLASH] = ACTIONS(1278),
    [anon_sym_PERCENT] = ACTIONS(1278),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1278),
    [anon_sym_LT_LT] = ACTIONS(1278),
    [anon_sym_GT_GT] = ACTIONS(1278),
    [anon_sym_and] = ACTIONS(1276),
    [anon_sym_or] = ACTIONS(1276),
    [anon_sym_xor] = ACTIONS(1276),
    [anon_sym_isnt] = ACTIONS(1276),
    [anon_sym_EQ_EQ] = ACTIONS(1278),
    [anon_sym_BANG_EQ] = ACTIONS(1278),
    [anon_sym_GT] = ACTIONS(1278),
    [anon_sym_GT_EQ] = ACTIONS(1278),
    [anon_sym_LT_EQ] = ACTIONS(1278),
    [anon_sym_LT] = ACTIONS(1278),
    [anon_sym_PLUS_TILDE] = ACTIONS(1276),
    [anon_sym_STAR_TILDE] = ACTIONS(1276),
    [anon_sym_SLASH_TILDE] = ACTIONS(1276),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1276),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1276),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1276),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1276),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1276),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1276),
    [anon_sym_GT_TILDE] = ACTIONS(1276),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1276),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1276),
    [anon_sym_LT_TILDE] = ACTIONS(1276),
    [anon_sym_PLUS_QMARK] = ACTIONS(1276),
    [anon_sym_DASH_QMARK] = ACTIONS(1276),
    [anon_sym_STAR_QMARK] = ACTIONS(1276),
    [anon_sym_SLASH_QMARK] = ACTIONS(1276),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1276),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1276),
    [anon_sym_as] = ACTIONS(1276),
    [anon_sym_LPAREN2] = ACTIONS(1276),
    [anon_sym_DOT_GT] = ACTIONS(1276),
    [anon_sym_where] = ACTIONS(1276),
    [anon_sym_TILDE] = ACTIONS(1276),
    [anon_sym_end] = ACTIONS(1276),
    [anon_sym_if] = ACTIONS(1278),
    [anon_sym_ifdef] = ACTIONS(1276),
    [anon_sym_iftype] = ACTIONS(1276),
    [anon_sym_else] = ACTIONS(1276),
    [anon_sym_for] = ACTIONS(1276),
    [anon_sym_while] = ACTIONS(1276),
    [anon_sym_try] = ACTIONS(1276),
    [anon_sym_with] = ACTIONS(1276),
    [anon_sym_repeat] = ACTIONS(1276),
    [anon_sym_do] = ACTIONS(1276),
    [anon_sym_recover] = ACTIONS(1276),
    [anon_sym_match] = ACTIONS(1276),
    [anon_sym_return] = ACTIONS(1276),
    [anon_sym_continue] = ACTIONS(1276),
    [anon_sym_break] = ACTIONS(1276),
    [anon_sym_consume] = ACTIONS(1276),
    [anon_sym_object] = ACTIONS(1276),
    [sym_number] = ACTIONS(1278),
    [sym_float] = ACTIONS(1276),
    [anon_sym_DQUOTE] = ACTIONS(1278),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_SQUOTE] = ACTIONS(1276),
    [anon_sym_true] = ACTIONS(1276),
    [anon_sym_false] = ACTIONS(1276),
    [sym_this] = ACTIONS(1276),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [315] = {
    [ts_builtin_sym_end] = ACTIONS(1280),
    [sym_identifier] = ACTIONS(1282),
    [anon_sym_use] = ACTIONS(1280),
    [anon_sym_EQ] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(1280),
    [anon_sym_LBRACK] = ACTIONS(1280),
    [anon_sym_type] = ACTIONS(1280),
    [anon_sym_is] = ACTIONS(1282),
    [anon_sym_actor] = ACTIONS(1280),
    [anon_sym_class] = ACTIONS(1280),
    [anon_sym_primitive] = ACTIONS(1280),
    [anon_sym_interface] = ACTIONS(1280),
    [anon_sym_trait] = ACTIONS(1280),
    [anon_sym_struct] = ACTIONS(1280),
    [anon_sym_embed] = ACTIONS(1280),
    [anon_sym_let] = ACTIONS(1280),
    [anon_sym_var] = ACTIONS(1280),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_fun] = ACTIONS(1280),
    [anon_sym_be] = ACTIONS(1280),
    [anon_sym_COMMA] = ACTIONS(1280),
    [anon_sym_LPAREN] = ACTIONS(1282),
    [anon_sym_RPAREN] = ACTIONS(1280),
    [anon_sym_DOT] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(1280),
    [anon_sym_SEMI] = ACTIONS(1280),
    [sym_error] = ACTIONS(1280),
    [sym_compile_intrinsic] = ACTIONS(1280),
    [anon_sym_compile_error] = ACTIONS(1280),
    [sym_location] = ACTIONS(1280),
    [anon_sym_DASH] = ACTIONS(1282),
    [anon_sym_not] = ACTIONS(1280),
    [anon_sym_DASH_TILDE] = ACTIONS(1280),
    [anon_sym_addressof] = ACTIONS(1280),
    [anon_sym_digestof] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1282),
    [anon_sym_STAR] = ACTIONS(1282),
    [anon_sym_SLASH] = ACTIONS(1282),
    [anon_sym_PERCENT] = ACTIONS(1282),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1282),
    [anon_sym_LT_LT] = ACTIONS(1282),
    [anon_sym_GT_GT] = ACTIONS(1282),
    [anon_sym_and] = ACTIONS(1280),
    [anon_sym_or] = ACTIONS(1280),
    [anon_sym_xor] = ACTIONS(1280),
    [anon_sym_isnt] = ACTIONS(1280),
    [anon_sym_EQ_EQ] = ACTIONS(1282),
    [anon_sym_BANG_EQ] = ACTIONS(1282),
    [anon_sym_GT] = ACTIONS(1282),
    [anon_sym_GT_EQ] = ACTIONS(1282),
    [anon_sym_LT_EQ] = ACTIONS(1282),
    [anon_sym_LT] = ACTIONS(1282),
    [anon_sym_PLUS_TILDE] = ACTIONS(1280),
    [anon_sym_STAR_TILDE] = ACTIONS(1280),
    [anon_sym_SLASH_TILDE] = ACTIONS(1280),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1280),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1280),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1280),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1280),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1280),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1280),
    [anon_sym_GT_TILDE] = ACTIONS(1280),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1280),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1280),
    [anon_sym_LT_TILDE] = ACTIONS(1280),
    [anon_sym_PLUS_QMARK] = ACTIONS(1280),
    [anon_sym_DASH_QMARK] = ACTIONS(1280),
    [anon_sym_STAR_QMARK] = ACTIONS(1280),
    [anon_sym_SLASH_QMARK] = ACTIONS(1280),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1280),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1280),
    [anon_sym_as] = ACTIONS(1280),
    [anon_sym_LPAREN2] = ACTIONS(1280),
    [anon_sym_DOT_GT] = ACTIONS(1280),
    [anon_sym_where] = ACTIONS(1280),
    [anon_sym_TILDE] = ACTIONS(1280),
    [anon_sym_end] = ACTIONS(1280),
    [anon_sym_if] = ACTIONS(1282),
    [anon_sym_ifdef] = ACTIONS(1280),
    [anon_sym_iftype] = ACTIONS(1280),
    [anon_sym_else] = ACTIONS(1280),
    [anon_sym_for] = ACTIONS(1280),
    [anon_sym_while] = ACTIONS(1280),
    [anon_sym_try] = ACTIONS(1280),
    [anon_sym_with] = ACTIONS(1280),
    [anon_sym_repeat] = ACTIONS(1280),
    [anon_sym_do] = ACTIONS(1280),
    [anon_sym_recover] = ACTIONS(1280),
    [anon_sym_match] = ACTIONS(1280),
    [anon_sym_return] = ACTIONS(1280),
    [anon_sym_continue] = ACTIONS(1280),
    [anon_sym_break] = ACTIONS(1280),
    [anon_sym_consume] = ACTIONS(1280),
    [anon_sym_object] = ACTIONS(1280),
    [sym_number] = ACTIONS(1282),
    [sym_float] = ACTIONS(1280),
    [anon_sym_DQUOTE] = ACTIONS(1282),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1280),
    [anon_sym_SQUOTE] = ACTIONS(1280),
    [anon_sym_true] = ACTIONS(1280),
    [anon_sym_false] = ACTIONS(1280),
    [sym_this] = ACTIONS(1280),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [316] = {
    [ts_builtin_sym_end] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_use] = ACTIONS(1284),
    [anon_sym_EQ] = ACTIONS(1286),
    [anon_sym_AT] = ACTIONS(1284),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_type] = ACTIONS(1284),
    [anon_sym_is] = ACTIONS(1286),
    [anon_sym_actor] = ACTIONS(1284),
    [anon_sym_class] = ACTIONS(1284),
    [anon_sym_primitive] = ACTIONS(1284),
    [anon_sym_interface] = ACTIONS(1284),
    [anon_sym_trait] = ACTIONS(1284),
    [anon_sym_struct] = ACTIONS(1284),
    [anon_sym_embed] = ACTIONS(1284),
    [anon_sym_let] = ACTIONS(1284),
    [anon_sym_var] = ACTIONS(1284),
    [anon_sym_new] = ACTIONS(1284),
    [anon_sym_fun] = ACTIONS(1284),
    [anon_sym_be] = ACTIONS(1284),
    [anon_sym_COMMA] = ACTIONS(1284),
    [anon_sym_LPAREN] = ACTIONS(1286),
    [anon_sym_RPAREN] = ACTIONS(1284),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_LBRACE] = ACTIONS(1284),
    [anon_sym_SEMI] = ACTIONS(1284),
    [sym_error] = ACTIONS(1284),
    [sym_compile_intrinsic] = ACTIONS(1284),
    [anon_sym_compile_error] = ACTIONS(1284),
    [sym_location] = ACTIONS(1284),
    [anon_sym_DASH] = ACTIONS(1286),
    [anon_sym_not] = ACTIONS(1284),
    [anon_sym_DASH_TILDE] = ACTIONS(1284),
    [anon_sym_addressof] = ACTIONS(1284),
    [anon_sym_digestof] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(1286),
    [anon_sym_STAR] = ACTIONS(1286),
    [anon_sym_SLASH] = ACTIONS(1286),
    [anon_sym_PERCENT] = ACTIONS(1286),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1286),
    [anon_sym_LT_LT] = ACTIONS(1286),
    [anon_sym_GT_GT] = ACTIONS(1286),
    [anon_sym_and] = ACTIONS(1284),
    [anon_sym_or] = ACTIONS(1284),
    [anon_sym_xor] = ACTIONS(1284),
    [anon_sym_isnt] = ACTIONS(1284),
    [anon_sym_EQ_EQ] = ACTIONS(1286),
    [anon_sym_BANG_EQ] = ACTIONS(1286),
    [anon_sym_GT] = ACTIONS(1286),
    [anon_sym_GT_EQ] = ACTIONS(1286),
    [anon_sym_LT_EQ] = ACTIONS(1286),
    [anon_sym_LT] = ACTIONS(1286),
    [anon_sym_PLUS_TILDE] = ACTIONS(1284),
    [anon_sym_STAR_TILDE] = ACTIONS(1284),
    [anon_sym_SLASH_TILDE] = ACTIONS(1284),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1284),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1284),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1284),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1284),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1284),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1284),
    [anon_sym_GT_TILDE] = ACTIONS(1284),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1284),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1284),
    [anon_sym_LT_TILDE] = ACTIONS(1284),
    [anon_sym_PLUS_QMARK] = ACTIONS(1284),
    [anon_sym_DASH_QMARK] = ACTIONS(1284),
    [anon_sym_STAR_QMARK] = ACTIONS(1284),
    [anon_sym_SLASH_QMARK] = ACTIONS(1284),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1284),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1284),
    [anon_sym_as] = ACTIONS(1284),
    [anon_sym_LPAREN2] = ACTIONS(1284),
    [anon_sym_DOT_GT] = ACTIONS(1284),
    [anon_sym_where] = ACTIONS(1284),
    [anon_sym_TILDE] = ACTIONS(1284),
    [anon_sym_end] = ACTIONS(1284),
    [anon_sym_if] = ACTIONS(1286),
    [anon_sym_ifdef] = ACTIONS(1284),
    [anon_sym_iftype] = ACTIONS(1284),
    [anon_sym_else] = ACTIONS(1284),
    [anon_sym_for] = ACTIONS(1284),
    [anon_sym_while] = ACTIONS(1284),
    [anon_sym_try] = ACTIONS(1284),
    [anon_sym_with] = ACTIONS(1284),
    [anon_sym_repeat] = ACTIONS(1284),
    [anon_sym_do] = ACTIONS(1284),
    [anon_sym_recover] = ACTIONS(1284),
    [anon_sym_match] = ACTIONS(1284),
    [anon_sym_return] = ACTIONS(1284),
    [anon_sym_continue] = ACTIONS(1284),
    [anon_sym_break] = ACTIONS(1284),
    [anon_sym_consume] = ACTIONS(1284),
    [anon_sym_object] = ACTIONS(1284),
    [sym_number] = ACTIONS(1286),
    [sym_float] = ACTIONS(1284),
    [anon_sym_DQUOTE] = ACTIONS(1286),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(1284),
    [anon_sym_true] = ACTIONS(1284),
    [anon_sym_false] = ACTIONS(1284),
    [sym_this] = ACTIONS(1284),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [317] = {
    [sym_identifier] = ACTIONS(660),
    [anon_sym_EQ] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(658),
    [anon_sym_is] = ACTIONS(660),
    [anon_sym_let] = ACTIONS(658),
    [anon_sym_var] = ACTIONS(658),
    [anon_sym_iso] = ACTIONS(658),
    [anon_sym_trn] = ACTIONS(658),
    [anon_sym_ref] = ACTIONS(658),
    [anon_sym_val] = ACTIONS(658),
    [anon_sym_box] = ACTIONS(658),
    [anon_sym_tag] = ACTIONS(658),
    [anon_sym_LPAREN] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(660),
    [anon_sym_POUNDread] = ACTIONS(658),
    [anon_sym_POUNDsend] = ACTIONS(658),
    [anon_sym_POUNDshare] = ACTIONS(658),
    [anon_sym_POUNDalias] = ACTIONS(658),
    [anon_sym_POUNDany] = ACTIONS(658),
    [anon_sym_BANG] = ACTIONS(660),
    [anon_sym_CARET] = ACTIONS(658),
    [anon_sym_PIPE] = ACTIONS(658),
    [anon_sym_AMP] = ACTIONS(658),
    [anon_sym_DASH_GT] = ACTIONS(658),
    [anon_sym_LBRACE] = ACTIONS(658),
    [anon_sym_SEMI] = ACTIONS(658),
    [sym_error] = ACTIONS(658),
    [sym_compile_intrinsic] = ACTIONS(658),
    [anon_sym_compile_error] = ACTIONS(658),
    [sym_location] = ACTIONS(658),
    [anon_sym_DASH] = ACTIONS(660),
    [anon_sym_not] = ACTIONS(658),
    [anon_sym_DASH_TILDE] = ACTIONS(658),
    [anon_sym_addressof] = ACTIONS(658),
    [anon_sym_digestof] = ACTIONS(658),
    [anon_sym_PLUS] = ACTIONS(660),
    [anon_sym_STAR] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(660),
    [anon_sym_PERCENT] = ACTIONS(660),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(660),
    [anon_sym_LT_LT] = ACTIONS(660),
    [anon_sym_GT_GT] = ACTIONS(660),
    [anon_sym_and] = ACTIONS(658),
    [anon_sym_or] = ACTIONS(658),
    [anon_sym_xor] = ACTIONS(658),
    [anon_sym_isnt] = ACTIONS(658),
    [anon_sym_EQ_EQ] = ACTIONS(660),
    [anon_sym_BANG_EQ] = ACTIONS(660),
    [anon_sym_GT] = ACTIONS(660),
    [anon_sym_GT_EQ] = ACTIONS(660),
    [anon_sym_LT_EQ] = ACTIONS(660),
    [anon_sym_LT] = ACTIONS(660),
    [anon_sym_PLUS_TILDE] = ACTIONS(658),
    [anon_sym_STAR_TILDE] = ACTIONS(658),
    [anon_sym_SLASH_TILDE] = ACTIONS(658),
    [anon_sym_PERCENT_TILDE] = ACTIONS(658),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(658),
    [anon_sym_LT_LT_TILDE] = ACTIONS(658),
    [anon_sym_GT_GT_TILDE] = ACTIONS(658),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(658),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(658),
    [anon_sym_GT_TILDE] = ACTIONS(658),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(658),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(658),
    [anon_sym_LT_TILDE] = ACTIONS(658),
    [anon_sym_PLUS_QMARK] = ACTIONS(658),
    [anon_sym_DASH_QMARK] = ACTIONS(658),
    [anon_sym_STAR_QMARK] = ACTIONS(658),
    [anon_sym_SLASH_QMARK] = ACTIONS(658),
    [anon_sym_PERCENT_QMARK] = ACTIONS(658),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(658),
    [anon_sym_as] = ACTIONS(658),
    [anon_sym_LPAREN2] = ACTIONS(658),
    [anon_sym_DOT_GT] = ACTIONS(658),
    [anon_sym_TILDE] = ACTIONS(658),
    [anon_sym_end] = ACTIONS(658),
    [anon_sym_if] = ACTIONS(660),
    [anon_sym_ifdef] = ACTIONS(658),
    [anon_sym_elseif] = ACTIONS(658),
    [anon_sym_iftype] = ACTIONS(658),
    [anon_sym_else] = ACTIONS(660),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_while] = ACTIONS(658),
    [anon_sym_try] = ACTIONS(658),
    [anon_sym_with] = ACTIONS(658),
    [anon_sym_repeat] = ACTIONS(658),
    [anon_sym_recover] = ACTIONS(658),
    [anon_sym_match] = ACTIONS(658),
    [anon_sym_return] = ACTIONS(658),
    [anon_sym_continue] = ACTIONS(658),
    [anon_sym_break] = ACTIONS(658),
    [anon_sym_consume] = ACTIONS(658),
    [anon_sym_object] = ACTIONS(658),
    [sym_number] = ACTIONS(660),
    [sym_float] = ACTIONS(658),
    [anon_sym_DQUOTE] = ACTIONS(660),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(658),
    [anon_sym_SQUOTE] = ACTIONS(658),
    [anon_sym_true] = ACTIONS(658),
    [anon_sym_false] = ACTIONS(658),
    [sym_this] = ACTIONS(658),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [318] = {
    [ts_builtin_sym_end] = ACTIONS(1288),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_use] = ACTIONS(1288),
    [anon_sym_EQ] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(1288),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_type] = ACTIONS(1288),
    [anon_sym_is] = ACTIONS(1290),
    [anon_sym_actor] = ACTIONS(1288),
    [anon_sym_class] = ACTIONS(1288),
    [anon_sym_primitive] = ACTIONS(1288),
    [anon_sym_interface] = ACTIONS(1288),
    [anon_sym_trait] = ACTIONS(1288),
    [anon_sym_struct] = ACTIONS(1288),
    [anon_sym_embed] = ACTIONS(1288),
    [anon_sym_let] = ACTIONS(1288),
    [anon_sym_var] = ACTIONS(1288),
    [anon_sym_new] = ACTIONS(1288),
    [anon_sym_fun] = ACTIONS(1288),
    [anon_sym_be] = ACTIONS(1288),
    [anon_sym_COMMA] = ACTIONS(1288),
    [anon_sym_LPAREN] = ACTIONS(1290),
    [anon_sym_RPAREN] = ACTIONS(1288),
    [anon_sym_DOT] = ACTIONS(1290),
    [anon_sym_LBRACE] = ACTIONS(1288),
    [anon_sym_SEMI] = ACTIONS(1288),
    [sym_error] = ACTIONS(1288),
    [sym_compile_intrinsic] = ACTIONS(1288),
    [anon_sym_compile_error] = ACTIONS(1288),
    [sym_location] = ACTIONS(1288),
    [anon_sym_DASH] = ACTIONS(1290),
    [anon_sym_not] = ACTIONS(1288),
    [anon_sym_DASH_TILDE] = ACTIONS(1288),
    [anon_sym_addressof] = ACTIONS(1288),
    [anon_sym_digestof] = ACTIONS(1288),
    [anon_sym_PLUS] = ACTIONS(1290),
    [anon_sym_STAR] = ACTIONS(1290),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_PERCENT] = ACTIONS(1290),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1290),
    [anon_sym_LT_LT] = ACTIONS(1290),
    [anon_sym_GT_GT] = ACTIONS(1290),
    [anon_sym_and] = ACTIONS(1288),
    [anon_sym_or] = ACTIONS(1288),
    [anon_sym_xor] = ACTIONS(1288),
    [anon_sym_isnt] = ACTIONS(1288),
    [anon_sym_EQ_EQ] = ACTIONS(1290),
    [anon_sym_BANG_EQ] = ACTIONS(1290),
    [anon_sym_GT] = ACTIONS(1290),
    [anon_sym_GT_EQ] = ACTIONS(1290),
    [anon_sym_LT_EQ] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(1290),
    [anon_sym_PLUS_TILDE] = ACTIONS(1288),
    [anon_sym_STAR_TILDE] = ACTIONS(1288),
    [anon_sym_SLASH_TILDE] = ACTIONS(1288),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1288),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1288),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1288),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1288),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1288),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1288),
    [anon_sym_GT_TILDE] = ACTIONS(1288),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1288),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1288),
    [anon_sym_LT_TILDE] = ACTIONS(1288),
    [anon_sym_PLUS_QMARK] = ACTIONS(1288),
    [anon_sym_DASH_QMARK] = ACTIONS(1288),
    [anon_sym_STAR_QMARK] = ACTIONS(1288),
    [anon_sym_SLASH_QMARK] = ACTIONS(1288),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1288),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1288),
    [anon_sym_as] = ACTIONS(1288),
    [anon_sym_LPAREN2] = ACTIONS(1288),
    [anon_sym_DOT_GT] = ACTIONS(1288),
    [anon_sym_where] = ACTIONS(1288),
    [anon_sym_TILDE] = ACTIONS(1288),
    [anon_sym_end] = ACTIONS(1288),
    [anon_sym_if] = ACTIONS(1290),
    [anon_sym_ifdef] = ACTIONS(1288),
    [anon_sym_iftype] = ACTIONS(1288),
    [anon_sym_else] = ACTIONS(1288),
    [anon_sym_for] = ACTIONS(1288),
    [anon_sym_while] = ACTIONS(1288),
    [anon_sym_try] = ACTIONS(1288),
    [anon_sym_with] = ACTIONS(1288),
    [anon_sym_repeat] = ACTIONS(1288),
    [anon_sym_do] = ACTIONS(1288),
    [anon_sym_recover] = ACTIONS(1288),
    [anon_sym_match] = ACTIONS(1288),
    [anon_sym_return] = ACTIONS(1288),
    [anon_sym_continue] = ACTIONS(1288),
    [anon_sym_break] = ACTIONS(1288),
    [anon_sym_consume] = ACTIONS(1288),
    [anon_sym_object] = ACTIONS(1288),
    [sym_number] = ACTIONS(1290),
    [sym_float] = ACTIONS(1288),
    [anon_sym_DQUOTE] = ACTIONS(1290),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1288),
    [anon_sym_SQUOTE] = ACTIONS(1288),
    [anon_sym_true] = ACTIONS(1288),
    [anon_sym_false] = ACTIONS(1288),
    [sym_this] = ACTIONS(1288),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [319] = {
    [ts_builtin_sym_end] = ACTIONS(1292),
    [sym_identifier] = ACTIONS(1294),
    [anon_sym_use] = ACTIONS(1292),
    [anon_sym_EQ] = ACTIONS(1294),
    [anon_sym_AT] = ACTIONS(1292),
    [anon_sym_LBRACK] = ACTIONS(1292),
    [anon_sym_type] = ACTIONS(1292),
    [anon_sym_is] = ACTIONS(1294),
    [anon_sym_actor] = ACTIONS(1292),
    [anon_sym_class] = ACTIONS(1292),
    [anon_sym_primitive] = ACTIONS(1292),
    [anon_sym_interface] = ACTIONS(1292),
    [anon_sym_trait] = ACTIONS(1292),
    [anon_sym_struct] = ACTIONS(1292),
    [anon_sym_embed] = ACTIONS(1292),
    [anon_sym_let] = ACTIONS(1292),
    [anon_sym_var] = ACTIONS(1292),
    [anon_sym_new] = ACTIONS(1292),
    [anon_sym_fun] = ACTIONS(1292),
    [anon_sym_be] = ACTIONS(1292),
    [anon_sym_COMMA] = ACTIONS(1292),
    [anon_sym_LPAREN] = ACTIONS(1294),
    [anon_sym_RPAREN] = ACTIONS(1292),
    [anon_sym_DOT] = ACTIONS(1294),
    [anon_sym_LBRACE] = ACTIONS(1292),
    [anon_sym_SEMI] = ACTIONS(1292),
    [sym_error] = ACTIONS(1292),
    [sym_compile_intrinsic] = ACTIONS(1292),
    [anon_sym_compile_error] = ACTIONS(1292),
    [sym_location] = ACTIONS(1292),
    [anon_sym_DASH] = ACTIONS(1294),
    [anon_sym_not] = ACTIONS(1292),
    [anon_sym_DASH_TILDE] = ACTIONS(1292),
    [anon_sym_addressof] = ACTIONS(1292),
    [anon_sym_digestof] = ACTIONS(1292),
    [anon_sym_PLUS] = ACTIONS(1294),
    [anon_sym_STAR] = ACTIONS(1294),
    [anon_sym_SLASH] = ACTIONS(1294),
    [anon_sym_PERCENT] = ACTIONS(1294),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1294),
    [anon_sym_LT_LT] = ACTIONS(1294),
    [anon_sym_GT_GT] = ACTIONS(1294),
    [anon_sym_and] = ACTIONS(1292),
    [anon_sym_or] = ACTIONS(1292),
    [anon_sym_xor] = ACTIONS(1292),
    [anon_sym_isnt] = ACTIONS(1292),
    [anon_sym_EQ_EQ] = ACTIONS(1294),
    [anon_sym_BANG_EQ] = ACTIONS(1294),
    [anon_sym_GT] = ACTIONS(1294),
    [anon_sym_GT_EQ] = ACTIONS(1294),
    [anon_sym_LT_EQ] = ACTIONS(1294),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_PLUS_TILDE] = ACTIONS(1292),
    [anon_sym_STAR_TILDE] = ACTIONS(1292),
    [anon_sym_SLASH_TILDE] = ACTIONS(1292),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1292),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1292),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1292),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1292),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1292),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1292),
    [anon_sym_GT_TILDE] = ACTIONS(1292),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1292),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1292),
    [anon_sym_LT_TILDE] = ACTIONS(1292),
    [anon_sym_PLUS_QMARK] = ACTIONS(1292),
    [anon_sym_DASH_QMARK] = ACTIONS(1292),
    [anon_sym_STAR_QMARK] = ACTIONS(1292),
    [anon_sym_SLASH_QMARK] = ACTIONS(1292),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1292),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1292),
    [anon_sym_as] = ACTIONS(1292),
    [anon_sym_LPAREN2] = ACTIONS(1292),
    [anon_sym_DOT_GT] = ACTIONS(1292),
    [anon_sym_where] = ACTIONS(1292),
    [anon_sym_TILDE] = ACTIONS(1292),
    [anon_sym_end] = ACTIONS(1292),
    [anon_sym_if] = ACTIONS(1294),
    [anon_sym_ifdef] = ACTIONS(1292),
    [anon_sym_iftype] = ACTIONS(1292),
    [anon_sym_else] = ACTIONS(1292),
    [anon_sym_for] = ACTIONS(1292),
    [anon_sym_while] = ACTIONS(1292),
    [anon_sym_try] = ACTIONS(1292),
    [anon_sym_with] = ACTIONS(1292),
    [anon_sym_repeat] = ACTIONS(1292),
    [anon_sym_do] = ACTIONS(1292),
    [anon_sym_recover] = ACTIONS(1292),
    [anon_sym_match] = ACTIONS(1292),
    [anon_sym_return] = ACTIONS(1292),
    [anon_sym_continue] = ACTIONS(1292),
    [anon_sym_break] = ACTIONS(1292),
    [anon_sym_consume] = ACTIONS(1292),
    [anon_sym_object] = ACTIONS(1292),
    [sym_number] = ACTIONS(1294),
    [sym_float] = ACTIONS(1292),
    [anon_sym_DQUOTE] = ACTIONS(1294),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1292),
    [anon_sym_SQUOTE] = ACTIONS(1292),
    [anon_sym_true] = ACTIONS(1292),
    [anon_sym_false] = ACTIONS(1292),
    [sym_this] = ACTIONS(1292),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [320] = {
    [sym_identifier] = ACTIONS(734),
    [anon_sym_EQ] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_is] = ACTIONS(734),
    [anon_sym_let] = ACTIONS(732),
    [anon_sym_var] = ACTIONS(732),
    [anon_sym_iso] = ACTIONS(732),
    [anon_sym_trn] = ACTIONS(732),
    [anon_sym_ref] = ACTIONS(732),
    [anon_sym_val] = ACTIONS(732),
    [anon_sym_box] = ACTIONS(732),
    [anon_sym_tag] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(734),
    [anon_sym_DOT] = ACTIONS(734),
    [anon_sym_POUNDread] = ACTIONS(732),
    [anon_sym_POUNDsend] = ACTIONS(732),
    [anon_sym_POUNDshare] = ACTIONS(732),
    [anon_sym_POUNDalias] = ACTIONS(732),
    [anon_sym_POUNDany] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(734),
    [anon_sym_CARET] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(732),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_DASH_GT] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(732),
    [sym_error] = ACTIONS(732),
    [sym_compile_intrinsic] = ACTIONS(732),
    [anon_sym_compile_error] = ACTIONS(732),
    [sym_location] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(734),
    [anon_sym_not] = ACTIONS(732),
    [anon_sym_DASH_TILDE] = ACTIONS(732),
    [anon_sym_addressof] = ACTIONS(732),
    [anon_sym_digestof] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(734),
    [anon_sym_STAR] = ACTIONS(734),
    [anon_sym_SLASH] = ACTIONS(734),
    [anon_sym_PERCENT] = ACTIONS(734),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(734),
    [anon_sym_LT_LT] = ACTIONS(734),
    [anon_sym_GT_GT] = ACTIONS(734),
    [anon_sym_and] = ACTIONS(732),
    [anon_sym_or] = ACTIONS(732),
    [anon_sym_xor] = ACTIONS(732),
    [anon_sym_isnt] = ACTIONS(732),
    [anon_sym_EQ_EQ] = ACTIONS(734),
    [anon_sym_BANG_EQ] = ACTIONS(734),
    [anon_sym_GT] = ACTIONS(734),
    [anon_sym_GT_EQ] = ACTIONS(734),
    [anon_sym_LT_EQ] = ACTIONS(734),
    [anon_sym_LT] = ACTIONS(734),
    [anon_sym_PLUS_TILDE] = ACTIONS(732),
    [anon_sym_STAR_TILDE] = ACTIONS(732),
    [anon_sym_SLASH_TILDE] = ACTIONS(732),
    [anon_sym_PERCENT_TILDE] = ACTIONS(732),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(732),
    [anon_sym_LT_LT_TILDE] = ACTIONS(732),
    [anon_sym_GT_GT_TILDE] = ACTIONS(732),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(732),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(732),
    [anon_sym_GT_TILDE] = ACTIONS(732),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(732),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(732),
    [anon_sym_LT_TILDE] = ACTIONS(732),
    [anon_sym_PLUS_QMARK] = ACTIONS(732),
    [anon_sym_DASH_QMARK] = ACTIONS(732),
    [anon_sym_STAR_QMARK] = ACTIONS(732),
    [anon_sym_SLASH_QMARK] = ACTIONS(732),
    [anon_sym_PERCENT_QMARK] = ACTIONS(732),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(732),
    [anon_sym_as] = ACTIONS(732),
    [anon_sym_LPAREN2] = ACTIONS(732),
    [anon_sym_DOT_GT] = ACTIONS(732),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_end] = ACTIONS(732),
    [anon_sym_if] = ACTIONS(734),
    [anon_sym_ifdef] = ACTIONS(732),
    [anon_sym_elseif] = ACTIONS(732),
    [anon_sym_iftype] = ACTIONS(732),
    [anon_sym_else] = ACTIONS(734),
    [anon_sym_for] = ACTIONS(732),
    [anon_sym_while] = ACTIONS(732),
    [anon_sym_try] = ACTIONS(732),
    [anon_sym_with] = ACTIONS(732),
    [anon_sym_repeat] = ACTIONS(732),
    [anon_sym_recover] = ACTIONS(732),
    [anon_sym_match] = ACTIONS(732),
    [anon_sym_return] = ACTIONS(732),
    [anon_sym_continue] = ACTIONS(732),
    [anon_sym_break] = ACTIONS(732),
    [anon_sym_consume] = ACTIONS(732),
    [anon_sym_object] = ACTIONS(732),
    [sym_number] = ACTIONS(734),
    [sym_float] = ACTIONS(732),
    [anon_sym_DQUOTE] = ACTIONS(734),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(732),
    [anon_sym_true] = ACTIONS(732),
    [anon_sym_false] = ACTIONS(732),
    [sym_this] = ACTIONS(732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [321] = {
    [sym_string] = STATE(344),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_identifier] = ACTIONS(1296),
    [anon_sym_EQ] = ACTIONS(1296),
    [anon_sym_AT] = ACTIONS(1298),
    [anon_sym_LBRACK] = ACTIONS(1298),
    [anon_sym_RBRACK] = ACTIONS(1298),
    [anon_sym_is] = ACTIONS(1296),
    [anon_sym_embed] = ACTIONS(1298),
    [anon_sym_let] = ACTIONS(1298),
    [anon_sym_var] = ACTIONS(1298),
    [anon_sym_new] = ACTIONS(1298),
    [anon_sym_EQ_GT] = ACTIONS(1298),
    [anon_sym_fun] = ACTIONS(1298),
    [anon_sym_be] = ACTIONS(1298),
    [anon_sym_COMMA] = ACTIONS(1298),
    [anon_sym_LPAREN] = ACTIONS(1296),
    [anon_sym_RPAREN] = ACTIONS(1298),
    [anon_sym_DOT] = ACTIONS(1296),
    [anon_sym_PIPE] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1298),
    [anon_sym_RBRACE] = ACTIONS(1298),
    [anon_sym_SEMI] = ACTIONS(1298),
    [sym_error] = ACTIONS(1298),
    [sym_compile_intrinsic] = ACTIONS(1298),
    [anon_sym_compile_error] = ACTIONS(1298),
    [sym_location] = ACTIONS(1298),
    [anon_sym_DASH] = ACTIONS(1296),
    [anon_sym_not] = ACTIONS(1298),
    [anon_sym_DASH_TILDE] = ACTIONS(1298),
    [anon_sym_addressof] = ACTIONS(1298),
    [anon_sym_digestof] = ACTIONS(1298),
    [anon_sym_PLUS] = ACTIONS(1296),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_SLASH] = ACTIONS(1296),
    [anon_sym_PERCENT] = ACTIONS(1296),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1296),
    [anon_sym_LT_LT] = ACTIONS(1296),
    [anon_sym_GT_GT] = ACTIONS(1296),
    [anon_sym_and] = ACTIONS(1298),
    [anon_sym_or] = ACTIONS(1298),
    [anon_sym_xor] = ACTIONS(1298),
    [anon_sym_isnt] = ACTIONS(1298),
    [anon_sym_EQ_EQ] = ACTIONS(1296),
    [anon_sym_BANG_EQ] = ACTIONS(1296),
    [anon_sym_GT] = ACTIONS(1296),
    [anon_sym_GT_EQ] = ACTIONS(1296),
    [anon_sym_LT_EQ] = ACTIONS(1296),
    [anon_sym_LT] = ACTIONS(1296),
    [anon_sym_PLUS_TILDE] = ACTIONS(1298),
    [anon_sym_STAR_TILDE] = ACTIONS(1298),
    [anon_sym_SLASH_TILDE] = ACTIONS(1298),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1298),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1298),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1298),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1298),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1298),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1298),
    [anon_sym_GT_TILDE] = ACTIONS(1298),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1298),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1298),
    [anon_sym_LT_TILDE] = ACTIONS(1298),
    [anon_sym_PLUS_QMARK] = ACTIONS(1298),
    [anon_sym_DASH_QMARK] = ACTIONS(1298),
    [anon_sym_STAR_QMARK] = ACTIONS(1298),
    [anon_sym_SLASH_QMARK] = ACTIONS(1298),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1298),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1298),
    [anon_sym_as] = ACTIONS(1298),
    [anon_sym_LPAREN2] = ACTIONS(1298),
    [anon_sym_DOT_GT] = ACTIONS(1298),
    [anon_sym_where] = ACTIONS(1298),
    [anon_sym_TILDE] = ACTIONS(1298),
    [anon_sym_end] = ACTIONS(1298),
    [anon_sym_if] = ACTIONS(1296),
    [anon_sym_ifdef] = ACTIONS(1298),
    [anon_sym_then] = ACTIONS(1298),
    [anon_sym_iftype] = ACTIONS(1298),
    [anon_sym_else] = ACTIONS(1298),
    [anon_sym_for] = ACTIONS(1298),
    [anon_sym_while] = ACTIONS(1298),
    [anon_sym_try] = ACTIONS(1298),
    [anon_sym_with] = ACTIONS(1298),
    [anon_sym_repeat] = ACTIONS(1298),
    [anon_sym_until] = ACTIONS(1298),
    [anon_sym_do] = ACTIONS(1298),
    [anon_sym_recover] = ACTIONS(1298),
    [anon_sym_match] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1298),
    [anon_sym_continue] = ACTIONS(1298),
    [anon_sym_break] = ACTIONS(1298),
    [anon_sym_consume] = ACTIONS(1298),
    [anon_sym_object] = ACTIONS(1298),
    [sym_number] = ACTIONS(1296),
    [sym_float] = ACTIONS(1298),
    [anon_sym_DQUOTE] = ACTIONS(1296),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1298),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_true] = ACTIONS(1298),
    [anon_sym_false] = ACTIONS(1298),
    [sym_this] = ACTIONS(1298),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [322] = {
    [ts_builtin_sym_end] = ACTIONS(1300),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_use] = ACTIONS(1300),
    [anon_sym_EQ] = ACTIONS(1302),
    [anon_sym_AT] = ACTIONS(1300),
    [anon_sym_LBRACK] = ACTIONS(1300),
    [anon_sym_type] = ACTIONS(1300),
    [anon_sym_is] = ACTIONS(1302),
    [anon_sym_actor] = ACTIONS(1300),
    [anon_sym_class] = ACTIONS(1300),
    [anon_sym_primitive] = ACTIONS(1300),
    [anon_sym_interface] = ACTIONS(1300),
    [anon_sym_trait] = ACTIONS(1300),
    [anon_sym_struct] = ACTIONS(1300),
    [anon_sym_embed] = ACTIONS(1300),
    [anon_sym_let] = ACTIONS(1300),
    [anon_sym_var] = ACTIONS(1300),
    [anon_sym_new] = ACTIONS(1300),
    [anon_sym_fun] = ACTIONS(1300),
    [anon_sym_be] = ACTIONS(1300),
    [anon_sym_COMMA] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(1302),
    [anon_sym_RPAREN] = ACTIONS(1300),
    [anon_sym_DOT] = ACTIONS(1302),
    [anon_sym_LBRACE] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(1300),
    [sym_error] = ACTIONS(1300),
    [sym_compile_intrinsic] = ACTIONS(1300),
    [anon_sym_compile_error] = ACTIONS(1300),
    [sym_location] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1302),
    [anon_sym_not] = ACTIONS(1300),
    [anon_sym_DASH_TILDE] = ACTIONS(1300),
    [anon_sym_addressof] = ACTIONS(1300),
    [anon_sym_digestof] = ACTIONS(1300),
    [anon_sym_PLUS] = ACTIONS(1302),
    [anon_sym_STAR] = ACTIONS(1302),
    [anon_sym_SLASH] = ACTIONS(1302),
    [anon_sym_PERCENT] = ACTIONS(1302),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1302),
    [anon_sym_LT_LT] = ACTIONS(1302),
    [anon_sym_GT_GT] = ACTIONS(1302),
    [anon_sym_and] = ACTIONS(1300),
    [anon_sym_or] = ACTIONS(1300),
    [anon_sym_xor] = ACTIONS(1300),
    [anon_sym_isnt] = ACTIONS(1300),
    [anon_sym_EQ_EQ] = ACTIONS(1302),
    [anon_sym_BANG_EQ] = ACTIONS(1302),
    [anon_sym_GT] = ACTIONS(1302),
    [anon_sym_GT_EQ] = ACTIONS(1302),
    [anon_sym_LT_EQ] = ACTIONS(1302),
    [anon_sym_LT] = ACTIONS(1302),
    [anon_sym_PLUS_TILDE] = ACTIONS(1300),
    [anon_sym_STAR_TILDE] = ACTIONS(1300),
    [anon_sym_SLASH_TILDE] = ACTIONS(1300),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1300),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1300),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1300),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1300),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1300),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1300),
    [anon_sym_GT_TILDE] = ACTIONS(1300),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1300),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1300),
    [anon_sym_LT_TILDE] = ACTIONS(1300),
    [anon_sym_PLUS_QMARK] = ACTIONS(1300),
    [anon_sym_DASH_QMARK] = ACTIONS(1300),
    [anon_sym_STAR_QMARK] = ACTIONS(1300),
    [anon_sym_SLASH_QMARK] = ACTIONS(1300),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1300),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1300),
    [anon_sym_as] = ACTIONS(1300),
    [anon_sym_LPAREN2] = ACTIONS(1300),
    [anon_sym_DOT_GT] = ACTIONS(1300),
    [anon_sym_where] = ACTIONS(1300),
    [anon_sym_TILDE] = ACTIONS(1300),
    [anon_sym_end] = ACTIONS(1300),
    [anon_sym_if] = ACTIONS(1302),
    [anon_sym_ifdef] = ACTIONS(1300),
    [anon_sym_iftype] = ACTIONS(1300),
    [anon_sym_else] = ACTIONS(1300),
    [anon_sym_for] = ACTIONS(1300),
    [anon_sym_while] = ACTIONS(1300),
    [anon_sym_try] = ACTIONS(1300),
    [anon_sym_with] = ACTIONS(1300),
    [anon_sym_repeat] = ACTIONS(1300),
    [anon_sym_do] = ACTIONS(1300),
    [anon_sym_recover] = ACTIONS(1300),
    [anon_sym_match] = ACTIONS(1300),
    [anon_sym_return] = ACTIONS(1300),
    [anon_sym_continue] = ACTIONS(1300),
    [anon_sym_break] = ACTIONS(1300),
    [anon_sym_consume] = ACTIONS(1300),
    [anon_sym_object] = ACTIONS(1300),
    [sym_number] = ACTIONS(1302),
    [sym_float] = ACTIONS(1300),
    [anon_sym_DQUOTE] = ACTIONS(1302),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1300),
    [anon_sym_SQUOTE] = ACTIONS(1300),
    [anon_sym_true] = ACTIONS(1300),
    [anon_sym_false] = ACTIONS(1300),
    [sym_this] = ACTIONS(1300),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [323] = {
    [ts_builtin_sym_end] = ACTIONS(1304),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_use] = ACTIONS(1304),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_AT] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(1304),
    [anon_sym_type] = ACTIONS(1304),
    [anon_sym_is] = ACTIONS(1306),
    [anon_sym_actor] = ACTIONS(1304),
    [anon_sym_class] = ACTIONS(1304),
    [anon_sym_primitive] = ACTIONS(1304),
    [anon_sym_interface] = ACTIONS(1304),
    [anon_sym_trait] = ACTIONS(1304),
    [anon_sym_struct] = ACTIONS(1304),
    [anon_sym_embed] = ACTIONS(1304),
    [anon_sym_let] = ACTIONS(1304),
    [anon_sym_var] = ACTIONS(1304),
    [anon_sym_new] = ACTIONS(1304),
    [anon_sym_fun] = ACTIONS(1304),
    [anon_sym_be] = ACTIONS(1304),
    [anon_sym_COMMA] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_RPAREN] = ACTIONS(1304),
    [anon_sym_DOT] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(1304),
    [anon_sym_SEMI] = ACTIONS(1304),
    [sym_error] = ACTIONS(1304),
    [sym_compile_intrinsic] = ACTIONS(1304),
    [anon_sym_compile_error] = ACTIONS(1304),
    [sym_location] = ACTIONS(1304),
    [anon_sym_DASH] = ACTIONS(1306),
    [anon_sym_not] = ACTIONS(1304),
    [anon_sym_DASH_TILDE] = ACTIONS(1304),
    [anon_sym_addressof] = ACTIONS(1304),
    [anon_sym_digestof] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1306),
    [anon_sym_STAR] = ACTIONS(1306),
    [anon_sym_SLASH] = ACTIONS(1306),
    [anon_sym_PERCENT] = ACTIONS(1306),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1306),
    [anon_sym_LT_LT] = ACTIONS(1306),
    [anon_sym_GT_GT] = ACTIONS(1306),
    [anon_sym_and] = ACTIONS(1304),
    [anon_sym_or] = ACTIONS(1304),
    [anon_sym_xor] = ACTIONS(1304),
    [anon_sym_isnt] = ACTIONS(1304),
    [anon_sym_EQ_EQ] = ACTIONS(1306),
    [anon_sym_BANG_EQ] = ACTIONS(1306),
    [anon_sym_GT] = ACTIONS(1306),
    [anon_sym_GT_EQ] = ACTIONS(1306),
    [anon_sym_LT_EQ] = ACTIONS(1306),
    [anon_sym_LT] = ACTIONS(1306),
    [anon_sym_PLUS_TILDE] = ACTIONS(1304),
    [anon_sym_STAR_TILDE] = ACTIONS(1304),
    [anon_sym_SLASH_TILDE] = ACTIONS(1304),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1304),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1304),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1304),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1304),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1304),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1304),
    [anon_sym_GT_TILDE] = ACTIONS(1304),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1304),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1304),
    [anon_sym_LT_TILDE] = ACTIONS(1304),
    [anon_sym_PLUS_QMARK] = ACTIONS(1304),
    [anon_sym_DASH_QMARK] = ACTIONS(1304),
    [anon_sym_STAR_QMARK] = ACTIONS(1304),
    [anon_sym_SLASH_QMARK] = ACTIONS(1304),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1304),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1304),
    [anon_sym_as] = ACTIONS(1304),
    [anon_sym_LPAREN2] = ACTIONS(1304),
    [anon_sym_DOT_GT] = ACTIONS(1304),
    [anon_sym_where] = ACTIONS(1304),
    [anon_sym_TILDE] = ACTIONS(1304),
    [anon_sym_end] = ACTIONS(1304),
    [anon_sym_if] = ACTIONS(1306),
    [anon_sym_ifdef] = ACTIONS(1304),
    [anon_sym_iftype] = ACTIONS(1304),
    [anon_sym_else] = ACTIONS(1304),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_while] = ACTIONS(1304),
    [anon_sym_try] = ACTIONS(1304),
    [anon_sym_with] = ACTIONS(1304),
    [anon_sym_repeat] = ACTIONS(1304),
    [anon_sym_do] = ACTIONS(1304),
    [anon_sym_recover] = ACTIONS(1304),
    [anon_sym_match] = ACTIONS(1304),
    [anon_sym_return] = ACTIONS(1304),
    [anon_sym_continue] = ACTIONS(1304),
    [anon_sym_break] = ACTIONS(1304),
    [anon_sym_consume] = ACTIONS(1304),
    [anon_sym_object] = ACTIONS(1304),
    [sym_number] = ACTIONS(1306),
    [sym_float] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1306),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1304),
    [anon_sym_SQUOTE] = ACTIONS(1304),
    [anon_sym_true] = ACTIONS(1304),
    [anon_sym_false] = ACTIONS(1304),
    [sym_this] = ACTIONS(1304),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [324] = {
    [sym_type_args] = STATE(380),
    [sym_identifier] = ACTIONS(994),
    [anon_sym_EQ] = ACTIONS(994),
    [anon_sym_AT] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(992),
    [anon_sym_RBRACK] = ACTIONS(992),
    [anon_sym_is] = ACTIONS(994),
    [anon_sym_embed] = ACTIONS(992),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_var] = ACTIONS(992),
    [anon_sym_new] = ACTIONS(992),
    [anon_sym_EQ_GT] = ACTIONS(992),
    [anon_sym_fun] = ACTIONS(992),
    [anon_sym_be] = ACTIONS(992),
    [anon_sym_COMMA] = ACTIONS(992),
    [anon_sym_LPAREN] = ACTIONS(994),
    [anon_sym_RPAREN] = ACTIONS(992),
    [anon_sym_DOT] = ACTIONS(994),
    [anon_sym_PIPE] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(992),
    [anon_sym_RBRACE] = ACTIONS(992),
    [anon_sym_SEMI] = ACTIONS(992),
    [sym_error] = ACTIONS(992),
    [sym_compile_intrinsic] = ACTIONS(992),
    [anon_sym_compile_error] = ACTIONS(992),
    [sym_location] = ACTIONS(992),
    [anon_sym_DASH] = ACTIONS(994),
    [anon_sym_not] = ACTIONS(992),
    [anon_sym_DASH_TILDE] = ACTIONS(992),
    [anon_sym_addressof] = ACTIONS(992),
    [anon_sym_digestof] = ACTIONS(992),
    [anon_sym_PLUS] = ACTIONS(994),
    [anon_sym_STAR] = ACTIONS(994),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_PERCENT] = ACTIONS(994),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(994),
    [anon_sym_LT_LT] = ACTIONS(994),
    [anon_sym_GT_GT] = ACTIONS(994),
    [anon_sym_and] = ACTIONS(992),
    [anon_sym_or] = ACTIONS(992),
    [anon_sym_xor] = ACTIONS(992),
    [anon_sym_isnt] = ACTIONS(992),
    [anon_sym_EQ_EQ] = ACTIONS(994),
    [anon_sym_BANG_EQ] = ACTIONS(994),
    [anon_sym_GT] = ACTIONS(994),
    [anon_sym_GT_EQ] = ACTIONS(994),
    [anon_sym_LT_EQ] = ACTIONS(994),
    [anon_sym_LT] = ACTIONS(994),
    [anon_sym_PLUS_TILDE] = ACTIONS(992),
    [anon_sym_STAR_TILDE] = ACTIONS(992),
    [anon_sym_SLASH_TILDE] = ACTIONS(992),
    [anon_sym_PERCENT_TILDE] = ACTIONS(992),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(992),
    [anon_sym_LT_LT_TILDE] = ACTIONS(992),
    [anon_sym_GT_GT_TILDE] = ACTIONS(992),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(992),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(992),
    [anon_sym_GT_TILDE] = ACTIONS(992),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(992),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(992),
    [anon_sym_LT_TILDE] = ACTIONS(992),
    [anon_sym_PLUS_QMARK] = ACTIONS(992),
    [anon_sym_DASH_QMARK] = ACTIONS(992),
    [anon_sym_STAR_QMARK] = ACTIONS(992),
    [anon_sym_SLASH_QMARK] = ACTIONS(992),
    [anon_sym_PERCENT_QMARK] = ACTIONS(992),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(992),
    [anon_sym_as] = ACTIONS(992),
    [anon_sym_LPAREN2] = ACTIONS(992),
    [anon_sym_DOT_GT] = ACTIONS(992),
    [anon_sym_where] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(992),
    [anon_sym_end] = ACTIONS(992),
    [anon_sym_if] = ACTIONS(994),
    [anon_sym_ifdef] = ACTIONS(992),
    [anon_sym_then] = ACTIONS(992),
    [anon_sym_iftype] = ACTIONS(992),
    [anon_sym_else] = ACTIONS(992),
    [anon_sym_for] = ACTIONS(992),
    [anon_sym_while] = ACTIONS(992),
    [anon_sym_try] = ACTIONS(992),
    [anon_sym_with] = ACTIONS(992),
    [anon_sym_repeat] = ACTIONS(992),
    [anon_sym_until] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(992),
    [anon_sym_recover] = ACTIONS(992),
    [anon_sym_match] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(992),
    [anon_sym_continue] = ACTIONS(992),
    [anon_sym_break] = ACTIONS(992),
    [anon_sym_consume] = ACTIONS(992),
    [anon_sym_object] = ACTIONS(992),
    [sym_number] = ACTIONS(994),
    [sym_float] = ACTIONS(992),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(992),
    [anon_sym_SQUOTE] = ACTIONS(992),
    [anon_sym_true] = ACTIONS(992),
    [anon_sym_false] = ACTIONS(992),
    [sym_this] = ACTIONS(992),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(1308),
    [sym_block_comment] = ACTIONS(3),
  },
  [325] = {
    [sym_identifier] = ACTIONS(1030),
    [anon_sym_EQ] = ACTIONS(1030),
    [anon_sym_AT] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(1028),
    [anon_sym_RBRACK] = ACTIONS(1028),
    [anon_sym_is] = ACTIONS(1030),
    [anon_sym_embed] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(1028),
    [anon_sym_var] = ACTIONS(1028),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_EQ_GT] = ACTIONS(1028),
    [anon_sym_fun] = ACTIONS(1028),
    [anon_sym_be] = ACTIONS(1028),
    [anon_sym_COMMA] = ACTIONS(1028),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_RPAREN] = ACTIONS(1028),
    [anon_sym_DOT] = ACTIONS(1030),
    [anon_sym_PIPE] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_RBRACE] = ACTIONS(1028),
    [anon_sym_SEMI] = ACTIONS(1028),
    [sym_error] = ACTIONS(1028),
    [sym_compile_intrinsic] = ACTIONS(1028),
    [anon_sym_compile_error] = ACTIONS(1028),
    [sym_location] = ACTIONS(1028),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_not] = ACTIONS(1028),
    [anon_sym_DASH_TILDE] = ACTIONS(1028),
    [anon_sym_addressof] = ACTIONS(1028),
    [anon_sym_digestof] = ACTIONS(1028),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_STAR] = ACTIONS(1030),
    [anon_sym_SLASH] = ACTIONS(1030),
    [anon_sym_PERCENT] = ACTIONS(1030),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1030),
    [anon_sym_LT_LT] = ACTIONS(1030),
    [anon_sym_GT_GT] = ACTIONS(1030),
    [anon_sym_and] = ACTIONS(1028),
    [anon_sym_or] = ACTIONS(1028),
    [anon_sym_xor] = ACTIONS(1028),
    [anon_sym_isnt] = ACTIONS(1028),
    [anon_sym_EQ_EQ] = ACTIONS(1030),
    [anon_sym_BANG_EQ] = ACTIONS(1030),
    [anon_sym_GT] = ACTIONS(1030),
    [anon_sym_GT_EQ] = ACTIONS(1030),
    [anon_sym_LT_EQ] = ACTIONS(1030),
    [anon_sym_LT] = ACTIONS(1030),
    [anon_sym_PLUS_TILDE] = ACTIONS(1028),
    [anon_sym_STAR_TILDE] = ACTIONS(1028),
    [anon_sym_SLASH_TILDE] = ACTIONS(1028),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1028),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1028),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1028),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1028),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1028),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1028),
    [anon_sym_GT_TILDE] = ACTIONS(1028),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1028),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1028),
    [anon_sym_LT_TILDE] = ACTIONS(1028),
    [anon_sym_PLUS_QMARK] = ACTIONS(1028),
    [anon_sym_DASH_QMARK] = ACTIONS(1028),
    [anon_sym_STAR_QMARK] = ACTIONS(1028),
    [anon_sym_SLASH_QMARK] = ACTIONS(1028),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1028),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1028),
    [anon_sym_as] = ACTIONS(1028),
    [anon_sym_LPAREN2] = ACTIONS(1028),
    [anon_sym_DOT_GT] = ACTIONS(1028),
    [anon_sym_where] = ACTIONS(1028),
    [anon_sym_TILDE] = ACTIONS(1028),
    [anon_sym_end] = ACTIONS(1028),
    [anon_sym_if] = ACTIONS(1030),
    [anon_sym_ifdef] = ACTIONS(1028),
    [anon_sym_then] = ACTIONS(1028),
    [anon_sym_iftype] = ACTIONS(1028),
    [anon_sym_else] = ACTIONS(1028),
    [anon_sym_for] = ACTIONS(1028),
    [anon_sym_while] = ACTIONS(1028),
    [anon_sym_try] = ACTIONS(1028),
    [anon_sym_with] = ACTIONS(1028),
    [anon_sym_repeat] = ACTIONS(1028),
    [anon_sym_until] = ACTIONS(1028),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_recover] = ACTIONS(1028),
    [anon_sym_match] = ACTIONS(1028),
    [anon_sym_return] = ACTIONS(1028),
    [anon_sym_continue] = ACTIONS(1028),
    [anon_sym_break] = ACTIONS(1028),
    [anon_sym_consume] = ACTIONS(1028),
    [anon_sym_object] = ACTIONS(1028),
    [sym_number] = ACTIONS(1030),
    [sym_float] = ACTIONS(1028),
    [anon_sym_DQUOTE] = ACTIONS(1030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1028),
    [anon_sym_SQUOTE] = ACTIONS(1028),
    [anon_sym_true] = ACTIONS(1028),
    [anon_sym_false] = ACTIONS(1028),
    [sym_this] = ACTIONS(1028),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(1028),
    [sym_block_comment] = ACTIONS(3),
  },
  [326] = {
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_EQ] = ACTIONS(1018),
    [anon_sym_AT] = ACTIONS(1016),
    [anon_sym_LBRACK] = ACTIONS(1016),
    [anon_sym_RBRACK] = ACTIONS(1016),
    [anon_sym_is] = ACTIONS(1018),
    [anon_sym_embed] = ACTIONS(1016),
    [anon_sym_let] = ACTIONS(1016),
    [anon_sym_var] = ACTIONS(1016),
    [anon_sym_new] = ACTIONS(1016),
    [anon_sym_EQ_GT] = ACTIONS(1016),
    [anon_sym_fun] = ACTIONS(1016),
    [anon_sym_be] = ACTIONS(1016),
    [anon_sym_COMMA] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(1016),
    [anon_sym_DOT] = ACTIONS(1018),
    [anon_sym_PIPE] = ACTIONS(1016),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_RBRACE] = ACTIONS(1016),
    [anon_sym_SEMI] = ACTIONS(1016),
    [sym_error] = ACTIONS(1016),
    [sym_compile_intrinsic] = ACTIONS(1016),
    [anon_sym_compile_error] = ACTIONS(1016),
    [sym_location] = ACTIONS(1016),
    [anon_sym_DASH] = ACTIONS(1018),
    [anon_sym_not] = ACTIONS(1016),
    [anon_sym_DASH_TILDE] = ACTIONS(1016),
    [anon_sym_addressof] = ACTIONS(1016),
    [anon_sym_digestof] = ACTIONS(1016),
    [anon_sym_PLUS] = ACTIONS(1018),
    [anon_sym_STAR] = ACTIONS(1018),
    [anon_sym_SLASH] = ACTIONS(1018),
    [anon_sym_PERCENT] = ACTIONS(1018),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1018),
    [anon_sym_LT_LT] = ACTIONS(1018),
    [anon_sym_GT_GT] = ACTIONS(1018),
    [anon_sym_and] = ACTIONS(1016),
    [anon_sym_or] = ACTIONS(1016),
    [anon_sym_xor] = ACTIONS(1016),
    [anon_sym_isnt] = ACTIONS(1016),
    [anon_sym_EQ_EQ] = ACTIONS(1018),
    [anon_sym_BANG_EQ] = ACTIONS(1018),
    [anon_sym_GT] = ACTIONS(1018),
    [anon_sym_GT_EQ] = ACTIONS(1018),
    [anon_sym_LT_EQ] = ACTIONS(1018),
    [anon_sym_LT] = ACTIONS(1018),
    [anon_sym_PLUS_TILDE] = ACTIONS(1016),
    [anon_sym_STAR_TILDE] = ACTIONS(1016),
    [anon_sym_SLASH_TILDE] = ACTIONS(1016),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1016),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1016),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1016),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1016),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1016),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1016),
    [anon_sym_GT_TILDE] = ACTIONS(1016),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1016),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1016),
    [anon_sym_LT_TILDE] = ACTIONS(1016),
    [anon_sym_PLUS_QMARK] = ACTIONS(1016),
    [anon_sym_DASH_QMARK] = ACTIONS(1016),
    [anon_sym_STAR_QMARK] = ACTIONS(1016),
    [anon_sym_SLASH_QMARK] = ACTIONS(1016),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1016),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1016),
    [anon_sym_as] = ACTIONS(1016),
    [anon_sym_LPAREN2] = ACTIONS(1016),
    [anon_sym_DOT_GT] = ACTIONS(1016),
    [anon_sym_where] = ACTIONS(1016),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_end] = ACTIONS(1016),
    [anon_sym_if] = ACTIONS(1018),
    [anon_sym_ifdef] = ACTIONS(1016),
    [anon_sym_then] = ACTIONS(1016),
    [anon_sym_iftype] = ACTIONS(1016),
    [anon_sym_else] = ACTIONS(1016),
    [anon_sym_for] = ACTIONS(1016),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_try] = ACTIONS(1016),
    [anon_sym_with] = ACTIONS(1016),
    [anon_sym_repeat] = ACTIONS(1016),
    [anon_sym_until] = ACTIONS(1016),
    [anon_sym_do] = ACTIONS(1016),
    [anon_sym_recover] = ACTIONS(1016),
    [anon_sym_match] = ACTIONS(1016),
    [anon_sym_return] = ACTIONS(1016),
    [anon_sym_continue] = ACTIONS(1016),
    [anon_sym_break] = ACTIONS(1016),
    [anon_sym_consume] = ACTIONS(1016),
    [anon_sym_object] = ACTIONS(1016),
    [sym_number] = ACTIONS(1018),
    [sym_float] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(1018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1016),
    [anon_sym_SQUOTE] = ACTIONS(1016),
    [anon_sym_true] = ACTIONS(1016),
    [anon_sym_false] = ACTIONS(1016),
    [sym_this] = ACTIONS(1016),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(1016),
    [sym_block_comment] = ACTIONS(3),
  },
  [327] = {
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_EQ] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_RBRACK] = ACTIONS(1020),
    [anon_sym_is] = ACTIONS(1022),
    [anon_sym_embed] = ACTIONS(1020),
    [anon_sym_let] = ACTIONS(1020),
    [anon_sym_var] = ACTIONS(1020),
    [anon_sym_new] = ACTIONS(1020),
    [anon_sym_EQ_GT] = ACTIONS(1020),
    [anon_sym_fun] = ACTIONS(1020),
    [anon_sym_be] = ACTIONS(1020),
    [anon_sym_COMMA] = ACTIONS(1020),
    [anon_sym_LPAREN] = ACTIONS(1022),
    [anon_sym_RPAREN] = ACTIONS(1020),
    [anon_sym_DOT] = ACTIONS(1022),
    [anon_sym_PIPE] = ACTIONS(1020),
    [anon_sym_LBRACE] = ACTIONS(1020),
    [anon_sym_RBRACE] = ACTIONS(1020),
    [anon_sym_SEMI] = ACTIONS(1020),
    [sym_error] = ACTIONS(1020),
    [sym_compile_intrinsic] = ACTIONS(1020),
    [anon_sym_compile_error] = ACTIONS(1020),
    [sym_location] = ACTIONS(1020),
    [anon_sym_DASH] = ACTIONS(1022),
    [anon_sym_not] = ACTIONS(1020),
    [anon_sym_DASH_TILDE] = ACTIONS(1020),
    [anon_sym_addressof] = ACTIONS(1020),
    [anon_sym_digestof] = ACTIONS(1020),
    [anon_sym_PLUS] = ACTIONS(1022),
    [anon_sym_STAR] = ACTIONS(1022),
    [anon_sym_SLASH] = ACTIONS(1022),
    [anon_sym_PERCENT] = ACTIONS(1022),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1022),
    [anon_sym_LT_LT] = ACTIONS(1022),
    [anon_sym_GT_GT] = ACTIONS(1022),
    [anon_sym_and] = ACTIONS(1020),
    [anon_sym_or] = ACTIONS(1020),
    [anon_sym_xor] = ACTIONS(1020),
    [anon_sym_isnt] = ACTIONS(1020),
    [anon_sym_EQ_EQ] = ACTIONS(1022),
    [anon_sym_BANG_EQ] = ACTIONS(1022),
    [anon_sym_GT] = ACTIONS(1022),
    [anon_sym_GT_EQ] = ACTIONS(1022),
    [anon_sym_LT_EQ] = ACTIONS(1022),
    [anon_sym_LT] = ACTIONS(1022),
    [anon_sym_PLUS_TILDE] = ACTIONS(1020),
    [anon_sym_STAR_TILDE] = ACTIONS(1020),
    [anon_sym_SLASH_TILDE] = ACTIONS(1020),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1020),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1020),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1020),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1020),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1020),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1020),
    [anon_sym_GT_TILDE] = ACTIONS(1020),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1020),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1020),
    [anon_sym_LT_TILDE] = ACTIONS(1020),
    [anon_sym_PLUS_QMARK] = ACTIONS(1020),
    [anon_sym_DASH_QMARK] = ACTIONS(1020),
    [anon_sym_STAR_QMARK] = ACTIONS(1020),
    [anon_sym_SLASH_QMARK] = ACTIONS(1020),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1020),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1020),
    [anon_sym_as] = ACTIONS(1020),
    [anon_sym_LPAREN2] = ACTIONS(1020),
    [anon_sym_DOT_GT] = ACTIONS(1020),
    [anon_sym_where] = ACTIONS(1020),
    [anon_sym_TILDE] = ACTIONS(1020),
    [anon_sym_end] = ACTIONS(1020),
    [anon_sym_if] = ACTIONS(1022),
    [anon_sym_ifdef] = ACTIONS(1020),
    [anon_sym_then] = ACTIONS(1020),
    [anon_sym_iftype] = ACTIONS(1020),
    [anon_sym_else] = ACTIONS(1020),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_while] = ACTIONS(1020),
    [anon_sym_try] = ACTIONS(1020),
    [anon_sym_with] = ACTIONS(1020),
    [anon_sym_repeat] = ACTIONS(1020),
    [anon_sym_until] = ACTIONS(1020),
    [anon_sym_do] = ACTIONS(1020),
    [anon_sym_recover] = ACTIONS(1020),
    [anon_sym_match] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(1020),
    [anon_sym_continue] = ACTIONS(1020),
    [anon_sym_break] = ACTIONS(1020),
    [anon_sym_consume] = ACTIONS(1020),
    [anon_sym_object] = ACTIONS(1020),
    [sym_number] = ACTIONS(1022),
    [sym_float] = ACTIONS(1020),
    [anon_sym_DQUOTE] = ACTIONS(1022),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1020),
    [anon_sym_SQUOTE] = ACTIONS(1020),
    [anon_sym_true] = ACTIONS(1020),
    [anon_sym_false] = ACTIONS(1020),
    [sym_this] = ACTIONS(1020),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(1020),
    [sym_block_comment] = ACTIONS(3),
  },
  [328] = {
    [sym_identifier] = ACTIONS(1026),
    [anon_sym_EQ] = ACTIONS(1026),
    [anon_sym_AT] = ACTIONS(1024),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(1024),
    [anon_sym_is] = ACTIONS(1026),
    [anon_sym_embed] = ACTIONS(1024),
    [anon_sym_let] = ACTIONS(1024),
    [anon_sym_var] = ACTIONS(1024),
    [anon_sym_new] = ACTIONS(1024),
    [anon_sym_EQ_GT] = ACTIONS(1024),
    [anon_sym_fun] = ACTIONS(1024),
    [anon_sym_be] = ACTIONS(1024),
    [anon_sym_COMMA] = ACTIONS(1024),
    [anon_sym_LPAREN] = ACTIONS(1026),
    [anon_sym_RPAREN] = ACTIONS(1024),
    [anon_sym_DOT] = ACTIONS(1026),
    [anon_sym_PIPE] = ACTIONS(1024),
    [anon_sym_LBRACE] = ACTIONS(1024),
    [anon_sym_RBRACE] = ACTIONS(1024),
    [anon_sym_SEMI] = ACTIONS(1024),
    [sym_error] = ACTIONS(1024),
    [sym_compile_intrinsic] = ACTIONS(1024),
    [anon_sym_compile_error] = ACTIONS(1024),
    [sym_location] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1026),
    [anon_sym_not] = ACTIONS(1024),
    [anon_sym_DASH_TILDE] = ACTIONS(1024),
    [anon_sym_addressof] = ACTIONS(1024),
    [anon_sym_digestof] = ACTIONS(1024),
    [anon_sym_PLUS] = ACTIONS(1026),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_SLASH] = ACTIONS(1026),
    [anon_sym_PERCENT] = ACTIONS(1026),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1026),
    [anon_sym_LT_LT] = ACTIONS(1026),
    [anon_sym_GT_GT] = ACTIONS(1026),
    [anon_sym_and] = ACTIONS(1024),
    [anon_sym_or] = ACTIONS(1024),
    [anon_sym_xor] = ACTIONS(1024),
    [anon_sym_isnt] = ACTIONS(1024),
    [anon_sym_EQ_EQ] = ACTIONS(1026),
    [anon_sym_BANG_EQ] = ACTIONS(1026),
    [anon_sym_GT] = ACTIONS(1026),
    [anon_sym_GT_EQ] = ACTIONS(1026),
    [anon_sym_LT_EQ] = ACTIONS(1026),
    [anon_sym_LT] = ACTIONS(1026),
    [anon_sym_PLUS_TILDE] = ACTIONS(1024),
    [anon_sym_STAR_TILDE] = ACTIONS(1024),
    [anon_sym_SLASH_TILDE] = ACTIONS(1024),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1024),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1024),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1024),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1024),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1024),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1024),
    [anon_sym_GT_TILDE] = ACTIONS(1024),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1024),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1024),
    [anon_sym_LT_TILDE] = ACTIONS(1024),
    [anon_sym_PLUS_QMARK] = ACTIONS(1024),
    [anon_sym_DASH_QMARK] = ACTIONS(1024),
    [anon_sym_STAR_QMARK] = ACTIONS(1024),
    [anon_sym_SLASH_QMARK] = ACTIONS(1024),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1024),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1024),
    [anon_sym_as] = ACTIONS(1024),
    [anon_sym_LPAREN2] = ACTIONS(1024),
    [anon_sym_DOT_GT] = ACTIONS(1024),
    [anon_sym_where] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1024),
    [anon_sym_end] = ACTIONS(1024),
    [anon_sym_if] = ACTIONS(1026),
    [anon_sym_ifdef] = ACTIONS(1024),
    [anon_sym_then] = ACTIONS(1024),
    [anon_sym_iftype] = ACTIONS(1024),
    [anon_sym_else] = ACTIONS(1024),
    [anon_sym_for] = ACTIONS(1024),
    [anon_sym_while] = ACTIONS(1024),
    [anon_sym_try] = ACTIONS(1024),
    [anon_sym_with] = ACTIONS(1024),
    [anon_sym_repeat] = ACTIONS(1024),
    [anon_sym_until] = ACTIONS(1024),
    [anon_sym_do] = ACTIONS(1024),
    [anon_sym_recover] = ACTIONS(1024),
    [anon_sym_match] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1024),
    [anon_sym_continue] = ACTIONS(1024),
    [anon_sym_break] = ACTIONS(1024),
    [anon_sym_consume] = ACTIONS(1024),
    [anon_sym_object] = ACTIONS(1024),
    [sym_number] = ACTIONS(1026),
    [sym_float] = ACTIONS(1024),
    [anon_sym_DQUOTE] = ACTIONS(1026),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1024),
    [anon_sym_SQUOTE] = ACTIONS(1024),
    [anon_sym_true] = ACTIONS(1024),
    [anon_sym_false] = ACTIONS(1024),
    [sym_this] = ACTIONS(1024),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(1024),
    [sym_block_comment] = ACTIONS(3),
  },
  [329] = {
    [sym_identifier] = ACTIONS(1042),
    [anon_sym_EQ] = ACTIONS(1042),
    [anon_sym_AT] = ACTIONS(1040),
    [anon_sym_LBRACK] = ACTIONS(1040),
    [anon_sym_RBRACK] = ACTIONS(1040),
    [anon_sym_is] = ACTIONS(1042),
    [anon_sym_embed] = ACTIONS(1040),
    [anon_sym_let] = ACTIONS(1040),
    [anon_sym_var] = ACTIONS(1040),
    [anon_sym_new] = ACTIONS(1040),
    [anon_sym_EQ_GT] = ACTIONS(1040),
    [anon_sym_fun] = ACTIONS(1040),
    [anon_sym_be] = ACTIONS(1040),
    [anon_sym_COMMA] = ACTIONS(1040),
    [anon_sym_LPAREN] = ACTIONS(1042),
    [anon_sym_RPAREN] = ACTIONS(1040),
    [anon_sym_DOT] = ACTIONS(1042),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_RBRACE] = ACTIONS(1040),
    [anon_sym_SEMI] = ACTIONS(1040),
    [sym_error] = ACTIONS(1040),
    [sym_compile_intrinsic] = ACTIONS(1040),
    [anon_sym_compile_error] = ACTIONS(1040),
    [sym_location] = ACTIONS(1040),
    [anon_sym_DASH] = ACTIONS(1042),
    [anon_sym_not] = ACTIONS(1040),
    [anon_sym_DASH_TILDE] = ACTIONS(1040),
    [anon_sym_addressof] = ACTIONS(1040),
    [anon_sym_digestof] = ACTIONS(1040),
    [anon_sym_PLUS] = ACTIONS(1042),
    [anon_sym_STAR] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(1042),
    [anon_sym_PERCENT] = ACTIONS(1042),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1042),
    [anon_sym_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_GT] = ACTIONS(1042),
    [anon_sym_and] = ACTIONS(1040),
    [anon_sym_or] = ACTIONS(1040),
    [anon_sym_xor] = ACTIONS(1040),
    [anon_sym_isnt] = ACTIONS(1040),
    [anon_sym_EQ_EQ] = ACTIONS(1042),
    [anon_sym_BANG_EQ] = ACTIONS(1042),
    [anon_sym_GT] = ACTIONS(1042),
    [anon_sym_GT_EQ] = ACTIONS(1042),
    [anon_sym_LT_EQ] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_PLUS_TILDE] = ACTIONS(1040),
    [anon_sym_STAR_TILDE] = ACTIONS(1040),
    [anon_sym_SLASH_TILDE] = ACTIONS(1040),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1040),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1040),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1040),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1040),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1040),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1040),
    [anon_sym_GT_TILDE] = ACTIONS(1040),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1040),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1040),
    [anon_sym_LT_TILDE] = ACTIONS(1040),
    [anon_sym_PLUS_QMARK] = ACTIONS(1040),
    [anon_sym_DASH_QMARK] = ACTIONS(1040),
    [anon_sym_STAR_QMARK] = ACTIONS(1040),
    [anon_sym_SLASH_QMARK] = ACTIONS(1040),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1040),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1040),
    [anon_sym_as] = ACTIONS(1040),
    [anon_sym_LPAREN2] = ACTIONS(1040),
    [anon_sym_DOT_GT] = ACTIONS(1040),
    [anon_sym_where] = ACTIONS(1040),
    [anon_sym_TILDE] = ACTIONS(1040),
    [anon_sym_end] = ACTIONS(1040),
    [anon_sym_if] = ACTIONS(1042),
    [anon_sym_ifdef] = ACTIONS(1040),
    [anon_sym_then] = ACTIONS(1040),
    [anon_sym_iftype] = ACTIONS(1040),
    [anon_sym_else] = ACTIONS(1040),
    [anon_sym_for] = ACTIONS(1040),
    [anon_sym_while] = ACTIONS(1040),
    [anon_sym_try] = ACTIONS(1040),
    [anon_sym_with] = ACTIONS(1040),
    [anon_sym_repeat] = ACTIONS(1040),
    [anon_sym_until] = ACTIONS(1040),
    [anon_sym_do] = ACTIONS(1040),
    [anon_sym_recover] = ACTIONS(1040),
    [anon_sym_match] = ACTIONS(1040),
    [anon_sym_return] = ACTIONS(1040),
    [anon_sym_continue] = ACTIONS(1040),
    [anon_sym_break] = ACTIONS(1040),
    [anon_sym_consume] = ACTIONS(1040),
    [anon_sym_object] = ACTIONS(1040),
    [sym_number] = ACTIONS(1042),
    [sym_float] = ACTIONS(1040),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym_true] = ACTIONS(1040),
    [anon_sym_false] = ACTIONS(1040),
    [sym_this] = ACTIONS(1040),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(1040),
    [sym_block_comment] = ACTIONS(3),
  },
  [330] = {
    [sym_identifier] = ACTIONS(1008),
    [anon_sym_EQ] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1006),
    [anon_sym_RBRACK] = ACTIONS(1006),
    [anon_sym_is] = ACTIONS(1008),
    [anon_sym_embed] = ACTIONS(1006),
    [anon_sym_let] = ACTIONS(1006),
    [anon_sym_var] = ACTIONS(1006),
    [anon_sym_new] = ACTIONS(1006),
    [anon_sym_EQ_GT] = ACTIONS(1006),
    [anon_sym_fun] = ACTIONS(1006),
    [anon_sym_be] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(1008),
    [anon_sym_RPAREN] = ACTIONS(1006),
    [anon_sym_DOT] = ACTIONS(1008),
    [anon_sym_PIPE] = ACTIONS(1006),
    [anon_sym_LBRACE] = ACTIONS(1006),
    [anon_sym_RBRACE] = ACTIONS(1006),
    [anon_sym_SEMI] = ACTIONS(1006),
    [sym_error] = ACTIONS(1006),
    [sym_compile_intrinsic] = ACTIONS(1006),
    [anon_sym_compile_error] = ACTIONS(1006),
    [sym_location] = ACTIONS(1006),
    [anon_sym_DASH] = ACTIONS(1008),
    [anon_sym_not] = ACTIONS(1006),
    [anon_sym_DASH_TILDE] = ACTIONS(1006),
    [anon_sym_addressof] = ACTIONS(1006),
    [anon_sym_digestof] = ACTIONS(1006),
    [anon_sym_PLUS] = ACTIONS(1008),
    [anon_sym_STAR] = ACTIONS(1008),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_PERCENT] = ACTIONS(1008),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1008),
    [anon_sym_LT_LT] = ACTIONS(1008),
    [anon_sym_GT_GT] = ACTIONS(1008),
    [anon_sym_and] = ACTIONS(1006),
    [anon_sym_or] = ACTIONS(1006),
    [anon_sym_xor] = ACTIONS(1006),
    [anon_sym_isnt] = ACTIONS(1006),
    [anon_sym_EQ_EQ] = ACTIONS(1008),
    [anon_sym_BANG_EQ] = ACTIONS(1008),
    [anon_sym_GT] = ACTIONS(1008),
    [anon_sym_GT_EQ] = ACTIONS(1008),
    [anon_sym_LT_EQ] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(1008),
    [anon_sym_PLUS_TILDE] = ACTIONS(1006),
    [anon_sym_STAR_TILDE] = ACTIONS(1006),
    [anon_sym_SLASH_TILDE] = ACTIONS(1006),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1006),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1006),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1006),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1006),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1006),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1006),
    [anon_sym_GT_TILDE] = ACTIONS(1006),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1006),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1006),
    [anon_sym_LT_TILDE] = ACTIONS(1006),
    [anon_sym_PLUS_QMARK] = ACTIONS(1006),
    [anon_sym_DASH_QMARK] = ACTIONS(1006),
    [anon_sym_STAR_QMARK] = ACTIONS(1006),
    [anon_sym_SLASH_QMARK] = ACTIONS(1006),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1006),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1006),
    [anon_sym_as] = ACTIONS(1006),
    [anon_sym_LPAREN2] = ACTIONS(1006),
    [anon_sym_DOT_GT] = ACTIONS(1006),
    [anon_sym_where] = ACTIONS(1006),
    [anon_sym_TILDE] = ACTIONS(1006),
    [anon_sym_end] = ACTIONS(1006),
    [anon_sym_if] = ACTIONS(1008),
    [anon_sym_ifdef] = ACTIONS(1006),
    [anon_sym_then] = ACTIONS(1006),
    [anon_sym_iftype] = ACTIONS(1006),
    [anon_sym_else] = ACTIONS(1006),
    [anon_sym_for] = ACTIONS(1006),
    [anon_sym_while] = ACTIONS(1006),
    [anon_sym_try] = ACTIONS(1006),
    [anon_sym_with] = ACTIONS(1006),
    [anon_sym_repeat] = ACTIONS(1006),
    [anon_sym_until] = ACTIONS(1006),
    [anon_sym_do] = ACTIONS(1006),
    [anon_sym_recover] = ACTIONS(1006),
    [anon_sym_match] = ACTIONS(1006),
    [anon_sym_return] = ACTIONS(1006),
    [anon_sym_continue] = ACTIONS(1006),
    [anon_sym_break] = ACTIONS(1006),
    [anon_sym_consume] = ACTIONS(1006),
    [anon_sym_object] = ACTIONS(1006),
    [sym_number] = ACTIONS(1008),
    [sym_float] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(1006),
    [anon_sym_true] = ACTIONS(1006),
    [anon_sym_false] = ACTIONS(1006),
    [sym_this] = ACTIONS(1006),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(1006),
    [sym_block_comment] = ACTIONS(3),
  },
  [331] = {
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_EQ] = ACTIONS(1012),
    [anon_sym_AT] = ACTIONS(1010),
    [anon_sym_LBRACK] = ACTIONS(1010),
    [anon_sym_RBRACK] = ACTIONS(1010),
    [anon_sym_is] = ACTIONS(1012),
    [anon_sym_embed] = ACTIONS(1010),
    [anon_sym_let] = ACTIONS(1010),
    [anon_sym_var] = ACTIONS(1010),
    [anon_sym_COLON] = ACTIONS(1310),
    [anon_sym_new] = ACTIONS(1010),
    [anon_sym_EQ_GT] = ACTIONS(1010),
    [anon_sym_fun] = ACTIONS(1010),
    [anon_sym_be] = ACTIONS(1010),
    [anon_sym_COMMA] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1012),
    [anon_sym_RPAREN] = ACTIONS(1010),
    [anon_sym_DOT] = ACTIONS(1012),
    [anon_sym_PIPE] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1010),
    [anon_sym_RBRACE] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(1010),
    [sym_error] = ACTIONS(1010),
    [sym_compile_intrinsic] = ACTIONS(1010),
    [anon_sym_compile_error] = ACTIONS(1010),
    [sym_location] = ACTIONS(1010),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_not] = ACTIONS(1010),
    [anon_sym_DASH_TILDE] = ACTIONS(1010),
    [anon_sym_addressof] = ACTIONS(1010),
    [anon_sym_digestof] = ACTIONS(1010),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_STAR] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1012),
    [anon_sym_PERCENT] = ACTIONS(1012),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1012),
    [anon_sym_LT_LT] = ACTIONS(1012),
    [anon_sym_GT_GT] = ACTIONS(1012),
    [anon_sym_and] = ACTIONS(1010),
    [anon_sym_or] = ACTIONS(1010),
    [anon_sym_xor] = ACTIONS(1010),
    [anon_sym_isnt] = ACTIONS(1010),
    [anon_sym_EQ_EQ] = ACTIONS(1012),
    [anon_sym_BANG_EQ] = ACTIONS(1012),
    [anon_sym_GT] = ACTIONS(1012),
    [anon_sym_GT_EQ] = ACTIONS(1012),
    [anon_sym_LT_EQ] = ACTIONS(1012),
    [anon_sym_LT] = ACTIONS(1012),
    [anon_sym_PLUS_TILDE] = ACTIONS(1010),
    [anon_sym_STAR_TILDE] = ACTIONS(1010),
    [anon_sym_SLASH_TILDE] = ACTIONS(1010),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1010),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1010),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1010),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1010),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1010),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1010),
    [anon_sym_GT_TILDE] = ACTIONS(1010),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1010),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1010),
    [anon_sym_LT_TILDE] = ACTIONS(1010),
    [anon_sym_PLUS_QMARK] = ACTIONS(1010),
    [anon_sym_DASH_QMARK] = ACTIONS(1010),
    [anon_sym_STAR_QMARK] = ACTIONS(1010),
    [anon_sym_SLASH_QMARK] = ACTIONS(1010),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1010),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1010),
    [anon_sym_as] = ACTIONS(1010),
    [anon_sym_LPAREN2] = ACTIONS(1010),
    [anon_sym_DOT_GT] = ACTIONS(1010),
    [anon_sym_where] = ACTIONS(1010),
    [anon_sym_TILDE] = ACTIONS(1010),
    [anon_sym_end] = ACTIONS(1010),
    [anon_sym_if] = ACTIONS(1012),
    [anon_sym_ifdef] = ACTIONS(1010),
    [anon_sym_then] = ACTIONS(1010),
    [anon_sym_iftype] = ACTIONS(1010),
    [anon_sym_else] = ACTIONS(1010),
    [anon_sym_for] = ACTIONS(1010),
    [anon_sym_while] = ACTIONS(1010),
    [anon_sym_try] = ACTIONS(1010),
    [anon_sym_with] = ACTIONS(1010),
    [anon_sym_repeat] = ACTIONS(1010),
    [anon_sym_until] = ACTIONS(1010),
    [anon_sym_do] = ACTIONS(1010),
    [anon_sym_recover] = ACTIONS(1010),
    [anon_sym_match] = ACTIONS(1010),
    [anon_sym_return] = ACTIONS(1010),
    [anon_sym_continue] = ACTIONS(1010),
    [anon_sym_break] = ACTIONS(1010),
    [anon_sym_consume] = ACTIONS(1010),
    [anon_sym_object] = ACTIONS(1010),
    [sym_number] = ACTIONS(1012),
    [sym_float] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1012),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1010),
    [anon_sym_SQUOTE] = ACTIONS(1010),
    [anon_sym_true] = ACTIONS(1010),
    [anon_sym_false] = ACTIONS(1010),
    [sym_this] = ACTIONS(1010),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [332] = {
    [sym_identifier] = ACTIONS(1062),
    [anon_sym_EQ] = ACTIONS(1062),
    [anon_sym_AT] = ACTIONS(1060),
    [anon_sym_LBRACK] = ACTIONS(1060),
    [anon_sym_RBRACK] = ACTIONS(1060),
    [anon_sym_QMARK] = ACTIONS(1312),
    [anon_sym_is] = ACTIONS(1062),
    [anon_sym_embed] = ACTIONS(1060),
    [anon_sym_let] = ACTIONS(1060),
    [anon_sym_var] = ACTIONS(1060),
    [anon_sym_new] = ACTIONS(1060),
    [anon_sym_EQ_GT] = ACTIONS(1060),
    [anon_sym_fun] = ACTIONS(1060),
    [anon_sym_be] = ACTIONS(1060),
    [anon_sym_COMMA] = ACTIONS(1060),
    [anon_sym_LPAREN] = ACTIONS(1062),
    [anon_sym_RPAREN] = ACTIONS(1060),
    [anon_sym_DOT] = ACTIONS(1062),
    [anon_sym_PIPE] = ACTIONS(1060),
    [anon_sym_LBRACE] = ACTIONS(1060),
    [anon_sym_RBRACE] = ACTIONS(1060),
    [anon_sym_SEMI] = ACTIONS(1060),
    [sym_error] = ACTIONS(1060),
    [sym_compile_intrinsic] = ACTIONS(1060),
    [anon_sym_compile_error] = ACTIONS(1060),
    [sym_location] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1062),
    [anon_sym_not] = ACTIONS(1060),
    [anon_sym_DASH_TILDE] = ACTIONS(1060),
    [anon_sym_addressof] = ACTIONS(1060),
    [anon_sym_digestof] = ACTIONS(1060),
    [anon_sym_PLUS] = ACTIONS(1062),
    [anon_sym_STAR] = ACTIONS(1062),
    [anon_sym_SLASH] = ACTIONS(1062),
    [anon_sym_PERCENT] = ACTIONS(1062),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1062),
    [anon_sym_LT_LT] = ACTIONS(1062),
    [anon_sym_GT_GT] = ACTIONS(1062),
    [anon_sym_and] = ACTIONS(1060),
    [anon_sym_or] = ACTIONS(1060),
    [anon_sym_xor] = ACTIONS(1060),
    [anon_sym_isnt] = ACTIONS(1060),
    [anon_sym_EQ_EQ] = ACTIONS(1062),
    [anon_sym_BANG_EQ] = ACTIONS(1062),
    [anon_sym_GT] = ACTIONS(1062),
    [anon_sym_GT_EQ] = ACTIONS(1062),
    [anon_sym_LT_EQ] = ACTIONS(1062),
    [anon_sym_LT] = ACTIONS(1062),
    [anon_sym_PLUS_TILDE] = ACTIONS(1060),
    [anon_sym_STAR_TILDE] = ACTIONS(1060),
    [anon_sym_SLASH_TILDE] = ACTIONS(1060),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1060),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1060),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1060),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1060),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1060),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1060),
    [anon_sym_GT_TILDE] = ACTIONS(1060),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1060),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1060),
    [anon_sym_LT_TILDE] = ACTIONS(1060),
    [anon_sym_PLUS_QMARK] = ACTIONS(1060),
    [anon_sym_DASH_QMARK] = ACTIONS(1060),
    [anon_sym_STAR_QMARK] = ACTIONS(1060),
    [anon_sym_SLASH_QMARK] = ACTIONS(1060),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1060),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1060),
    [anon_sym_as] = ACTIONS(1060),
    [anon_sym_LPAREN2] = ACTIONS(1060),
    [anon_sym_DOT_GT] = ACTIONS(1060),
    [anon_sym_where] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1060),
    [anon_sym_end] = ACTIONS(1060),
    [anon_sym_if] = ACTIONS(1062),
    [anon_sym_ifdef] = ACTIONS(1060),
    [anon_sym_then] = ACTIONS(1060),
    [anon_sym_iftype] = ACTIONS(1060),
    [anon_sym_else] = ACTIONS(1060),
    [anon_sym_for] = ACTIONS(1060),
    [anon_sym_while] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1060),
    [anon_sym_with] = ACTIONS(1060),
    [anon_sym_repeat] = ACTIONS(1060),
    [anon_sym_until] = ACTIONS(1060),
    [anon_sym_do] = ACTIONS(1060),
    [anon_sym_recover] = ACTIONS(1060),
    [anon_sym_match] = ACTIONS(1060),
    [anon_sym_return] = ACTIONS(1060),
    [anon_sym_continue] = ACTIONS(1060),
    [anon_sym_break] = ACTIONS(1060),
    [anon_sym_consume] = ACTIONS(1060),
    [anon_sym_object] = ACTIONS(1060),
    [sym_number] = ACTIONS(1062),
    [sym_float] = ACTIONS(1060),
    [anon_sym_DQUOTE] = ACTIONS(1062),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1060),
    [anon_sym_SQUOTE] = ACTIONS(1060),
    [anon_sym_true] = ACTIONS(1060),
    [anon_sym_false] = ACTIONS(1060),
    [sym_this] = ACTIONS(1060),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [333] = {
    [sym_arguments] = STATE(332),
    [sym_identifier] = ACTIONS(1038),
    [anon_sym_EQ] = ACTIONS(1038),
    [anon_sym_AT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_RBRACK] = ACTIONS(1036),
    [anon_sym_is] = ACTIONS(1038),
    [anon_sym_embed] = ACTIONS(1036),
    [anon_sym_let] = ACTIONS(1036),
    [anon_sym_var] = ACTIONS(1036),
    [anon_sym_new] = ACTIONS(1036),
    [anon_sym_EQ_GT] = ACTIONS(1036),
    [anon_sym_fun] = ACTIONS(1036),
    [anon_sym_be] = ACTIONS(1036),
    [anon_sym_COMMA] = ACTIONS(1036),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [anon_sym_RPAREN] = ACTIONS(1036),
    [anon_sym_DOT] = ACTIONS(1038),
    [anon_sym_PIPE] = ACTIONS(1036),
    [anon_sym_LBRACE] = ACTIONS(1036),
    [anon_sym_RBRACE] = ACTIONS(1036),
    [anon_sym_SEMI] = ACTIONS(1036),
    [sym_error] = ACTIONS(1036),
    [sym_compile_intrinsic] = ACTIONS(1036),
    [anon_sym_compile_error] = ACTIONS(1036),
    [sym_location] = ACTIONS(1036),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_not] = ACTIONS(1036),
    [anon_sym_DASH_TILDE] = ACTIONS(1036),
    [anon_sym_addressof] = ACTIONS(1036),
    [anon_sym_digestof] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_PERCENT] = ACTIONS(1038),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1038),
    [anon_sym_LT_LT] = ACTIONS(1038),
    [anon_sym_GT_GT] = ACTIONS(1038),
    [anon_sym_and] = ACTIONS(1036),
    [anon_sym_or] = ACTIONS(1036),
    [anon_sym_xor] = ACTIONS(1036),
    [anon_sym_isnt] = ACTIONS(1036),
    [anon_sym_EQ_EQ] = ACTIONS(1038),
    [anon_sym_BANG_EQ] = ACTIONS(1038),
    [anon_sym_GT] = ACTIONS(1038),
    [anon_sym_GT_EQ] = ACTIONS(1038),
    [anon_sym_LT_EQ] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1038),
    [anon_sym_PLUS_TILDE] = ACTIONS(1036),
    [anon_sym_STAR_TILDE] = ACTIONS(1036),
    [anon_sym_SLASH_TILDE] = ACTIONS(1036),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1036),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1036),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1036),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1036),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1036),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1036),
    [anon_sym_GT_TILDE] = ACTIONS(1036),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1036),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1036),
    [anon_sym_LT_TILDE] = ACTIONS(1036),
    [anon_sym_PLUS_QMARK] = ACTIONS(1036),
    [anon_sym_DASH_QMARK] = ACTIONS(1036),
    [anon_sym_STAR_QMARK] = ACTIONS(1036),
    [anon_sym_SLASH_QMARK] = ACTIONS(1036),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1036),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1036),
    [anon_sym_as] = ACTIONS(1036),
    [anon_sym_LPAREN2] = ACTIONS(1036),
    [anon_sym_DOT_GT] = ACTIONS(1036),
    [anon_sym_where] = ACTIONS(1036),
    [anon_sym_TILDE] = ACTIONS(1036),
    [anon_sym_end] = ACTIONS(1036),
    [anon_sym_if] = ACTIONS(1038),
    [anon_sym_ifdef] = ACTIONS(1036),
    [anon_sym_then] = ACTIONS(1036),
    [anon_sym_iftype] = ACTIONS(1036),
    [anon_sym_else] = ACTIONS(1036),
    [anon_sym_for] = ACTIONS(1036),
    [anon_sym_while] = ACTIONS(1036),
    [anon_sym_try] = ACTIONS(1036),
    [anon_sym_with] = ACTIONS(1036),
    [anon_sym_repeat] = ACTIONS(1036),
    [anon_sym_until] = ACTIONS(1036),
    [anon_sym_do] = ACTIONS(1036),
    [anon_sym_recover] = ACTIONS(1036),
    [anon_sym_match] = ACTIONS(1036),
    [anon_sym_return] = ACTIONS(1036),
    [anon_sym_continue] = ACTIONS(1036),
    [anon_sym_break] = ACTIONS(1036),
    [anon_sym_consume] = ACTIONS(1036),
    [anon_sym_object] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_float] = ACTIONS(1036),
    [anon_sym_DQUOTE] = ACTIONS(1038),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1036),
    [anon_sym_SQUOTE] = ACTIONS(1036),
    [anon_sym_true] = ACTIONS(1036),
    [anon_sym_false] = ACTIONS(1036),
    [sym_this] = ACTIONS(1036),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [334] = {
    [sym_identifier] = ACTIONS(1034),
    [anon_sym_EQ] = ACTIONS(1034),
    [anon_sym_AT] = ACTIONS(1032),
    [anon_sym_LBRACK] = ACTIONS(1032),
    [anon_sym_RBRACK] = ACTIONS(1032),
    [anon_sym_QMARK] = ACTIONS(1032),
    [anon_sym_is] = ACTIONS(1034),
    [anon_sym_embed] = ACTIONS(1032),
    [anon_sym_let] = ACTIONS(1032),
    [anon_sym_var] = ACTIONS(1032),
    [anon_sym_new] = ACTIONS(1032),
    [anon_sym_EQ_GT] = ACTIONS(1032),
    [anon_sym_fun] = ACTIONS(1032),
    [anon_sym_be] = ACTIONS(1032),
    [anon_sym_COMMA] = ACTIONS(1032),
    [anon_sym_LPAREN] = ACTIONS(1034),
    [anon_sym_RPAREN] = ACTIONS(1032),
    [anon_sym_DOT] = ACTIONS(1034),
    [anon_sym_PIPE] = ACTIONS(1032),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [anon_sym_RBRACE] = ACTIONS(1032),
    [anon_sym_SEMI] = ACTIONS(1032),
    [sym_error] = ACTIONS(1032),
    [sym_compile_intrinsic] = ACTIONS(1032),
    [anon_sym_compile_error] = ACTIONS(1032),
    [sym_location] = ACTIONS(1032),
    [anon_sym_DASH] = ACTIONS(1034),
    [anon_sym_not] = ACTIONS(1032),
    [anon_sym_DASH_TILDE] = ACTIONS(1032),
    [anon_sym_addressof] = ACTIONS(1032),
    [anon_sym_digestof] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_STAR] = ACTIONS(1034),
    [anon_sym_SLASH] = ACTIONS(1034),
    [anon_sym_PERCENT] = ACTIONS(1034),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1034),
    [anon_sym_LT_LT] = ACTIONS(1034),
    [anon_sym_GT_GT] = ACTIONS(1034),
    [anon_sym_and] = ACTIONS(1032),
    [anon_sym_or] = ACTIONS(1032),
    [anon_sym_xor] = ACTIONS(1032),
    [anon_sym_isnt] = ACTIONS(1032),
    [anon_sym_EQ_EQ] = ACTIONS(1034),
    [anon_sym_BANG_EQ] = ACTIONS(1034),
    [anon_sym_GT] = ACTIONS(1034),
    [anon_sym_GT_EQ] = ACTIONS(1034),
    [anon_sym_LT_EQ] = ACTIONS(1034),
    [anon_sym_LT] = ACTIONS(1034),
    [anon_sym_PLUS_TILDE] = ACTIONS(1032),
    [anon_sym_STAR_TILDE] = ACTIONS(1032),
    [anon_sym_SLASH_TILDE] = ACTIONS(1032),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1032),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1032),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1032),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1032),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1032),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1032),
    [anon_sym_GT_TILDE] = ACTIONS(1032),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1032),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1032),
    [anon_sym_LT_TILDE] = ACTIONS(1032),
    [anon_sym_PLUS_QMARK] = ACTIONS(1032),
    [anon_sym_DASH_QMARK] = ACTIONS(1032),
    [anon_sym_STAR_QMARK] = ACTIONS(1032),
    [anon_sym_SLASH_QMARK] = ACTIONS(1032),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1032),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1032),
    [anon_sym_as] = ACTIONS(1032),
    [anon_sym_LPAREN2] = ACTIONS(1032),
    [anon_sym_DOT_GT] = ACTIONS(1032),
    [anon_sym_where] = ACTIONS(1032),
    [anon_sym_TILDE] = ACTIONS(1032),
    [anon_sym_end] = ACTIONS(1032),
    [anon_sym_if] = ACTIONS(1034),
    [anon_sym_ifdef] = ACTIONS(1032),
    [anon_sym_then] = ACTIONS(1032),
    [anon_sym_iftype] = ACTIONS(1032),
    [anon_sym_else] = ACTIONS(1032),
    [anon_sym_for] = ACTIONS(1032),
    [anon_sym_while] = ACTIONS(1032),
    [anon_sym_try] = ACTIONS(1032),
    [anon_sym_with] = ACTIONS(1032),
    [anon_sym_repeat] = ACTIONS(1032),
    [anon_sym_until] = ACTIONS(1032),
    [anon_sym_do] = ACTIONS(1032),
    [anon_sym_recover] = ACTIONS(1032),
    [anon_sym_match] = ACTIONS(1032),
    [anon_sym_return] = ACTIONS(1032),
    [anon_sym_continue] = ACTIONS(1032),
    [anon_sym_break] = ACTIONS(1032),
    [anon_sym_consume] = ACTIONS(1032),
    [anon_sym_object] = ACTIONS(1032),
    [sym_number] = ACTIONS(1034),
    [sym_float] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(1034),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1032),
    [anon_sym_true] = ACTIONS(1032),
    [anon_sym_false] = ACTIONS(1032),
    [sym_this] = ACTIONS(1032),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [335] = {
    [sym_arguments] = STATE(332),
    [sym_identifier] = ACTIONS(1000),
    [anon_sym_EQ] = ACTIONS(1000),
    [anon_sym_AT] = ACTIONS(998),
    [anon_sym_LBRACK] = ACTIONS(998),
    [anon_sym_RBRACK] = ACTIONS(998),
    [anon_sym_is] = ACTIONS(1000),
    [anon_sym_embed] = ACTIONS(998),
    [anon_sym_let] = ACTIONS(998),
    [anon_sym_var] = ACTIONS(998),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_EQ_GT] = ACTIONS(998),
    [anon_sym_fun] = ACTIONS(998),
    [anon_sym_be] = ACTIONS(998),
    [anon_sym_COMMA] = ACTIONS(998),
    [anon_sym_LPAREN] = ACTIONS(1000),
    [anon_sym_RPAREN] = ACTIONS(998),
    [anon_sym_DOT] = ACTIONS(1000),
    [anon_sym_PIPE] = ACTIONS(998),
    [anon_sym_LBRACE] = ACTIONS(998),
    [anon_sym_RBRACE] = ACTIONS(998),
    [anon_sym_SEMI] = ACTIONS(998),
    [sym_error] = ACTIONS(998),
    [sym_compile_intrinsic] = ACTIONS(998),
    [anon_sym_compile_error] = ACTIONS(998),
    [sym_location] = ACTIONS(998),
    [anon_sym_DASH] = ACTIONS(1000),
    [anon_sym_not] = ACTIONS(998),
    [anon_sym_DASH_TILDE] = ACTIONS(998),
    [anon_sym_addressof] = ACTIONS(998),
    [anon_sym_digestof] = ACTIONS(998),
    [anon_sym_PLUS] = ACTIONS(1000),
    [anon_sym_STAR] = ACTIONS(1000),
    [anon_sym_SLASH] = ACTIONS(1000),
    [anon_sym_PERCENT] = ACTIONS(1000),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1000),
    [anon_sym_LT_LT] = ACTIONS(1000),
    [anon_sym_GT_GT] = ACTIONS(1000),
    [anon_sym_and] = ACTIONS(998),
    [anon_sym_or] = ACTIONS(998),
    [anon_sym_xor] = ACTIONS(998),
    [anon_sym_isnt] = ACTIONS(998),
    [anon_sym_EQ_EQ] = ACTIONS(1000),
    [anon_sym_BANG_EQ] = ACTIONS(1000),
    [anon_sym_GT] = ACTIONS(1000),
    [anon_sym_GT_EQ] = ACTIONS(1000),
    [anon_sym_LT_EQ] = ACTIONS(1000),
    [anon_sym_LT] = ACTIONS(1000),
    [anon_sym_PLUS_TILDE] = ACTIONS(998),
    [anon_sym_STAR_TILDE] = ACTIONS(998),
    [anon_sym_SLASH_TILDE] = ACTIONS(998),
    [anon_sym_PERCENT_TILDE] = ACTIONS(998),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(998),
    [anon_sym_LT_LT_TILDE] = ACTIONS(998),
    [anon_sym_GT_GT_TILDE] = ACTIONS(998),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(998),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(998),
    [anon_sym_GT_TILDE] = ACTIONS(998),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(998),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(998),
    [anon_sym_LT_TILDE] = ACTIONS(998),
    [anon_sym_PLUS_QMARK] = ACTIONS(998),
    [anon_sym_DASH_QMARK] = ACTIONS(998),
    [anon_sym_STAR_QMARK] = ACTIONS(998),
    [anon_sym_SLASH_QMARK] = ACTIONS(998),
    [anon_sym_PERCENT_QMARK] = ACTIONS(998),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(998),
    [anon_sym_as] = ACTIONS(998),
    [anon_sym_LPAREN2] = ACTIONS(998),
    [anon_sym_DOT_GT] = ACTIONS(998),
    [anon_sym_where] = ACTIONS(998),
    [anon_sym_TILDE] = ACTIONS(998),
    [anon_sym_end] = ACTIONS(998),
    [anon_sym_if] = ACTIONS(1000),
    [anon_sym_ifdef] = ACTIONS(998),
    [anon_sym_then] = ACTIONS(998),
    [anon_sym_iftype] = ACTIONS(998),
    [anon_sym_else] = ACTIONS(998),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_while] = ACTIONS(998),
    [anon_sym_try] = ACTIONS(998),
    [anon_sym_with] = ACTIONS(998),
    [anon_sym_repeat] = ACTIONS(998),
    [anon_sym_until] = ACTIONS(998),
    [anon_sym_do] = ACTIONS(998),
    [anon_sym_recover] = ACTIONS(998),
    [anon_sym_match] = ACTIONS(998),
    [anon_sym_return] = ACTIONS(998),
    [anon_sym_continue] = ACTIONS(998),
    [anon_sym_break] = ACTIONS(998),
    [anon_sym_consume] = ACTIONS(998),
    [anon_sym_object] = ACTIONS(998),
    [sym_number] = ACTIONS(1000),
    [sym_float] = ACTIONS(998),
    [anon_sym_DQUOTE] = ACTIONS(1000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(998),
    [anon_sym_SQUOTE] = ACTIONS(998),
    [anon_sym_true] = ACTIONS(998),
    [anon_sym_false] = ACTIONS(998),
    [sym_this] = ACTIONS(998),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [336] = {
    [sym_identifier] = ACTIONS(1132),
    [anon_sym_EQ] = ACTIONS(1132),
    [anon_sym_AT] = ACTIONS(1130),
    [anon_sym_LBRACK] = ACTIONS(1130),
    [anon_sym_RBRACK] = ACTIONS(1130),
    [anon_sym_is] = ACTIONS(1132),
    [anon_sym_embed] = ACTIONS(1130),
    [anon_sym_let] = ACTIONS(1130),
    [anon_sym_var] = ACTIONS(1130),
    [anon_sym_new] = ACTIONS(1130),
    [anon_sym_EQ_GT] = ACTIONS(1130),
    [anon_sym_fun] = ACTIONS(1130),
    [anon_sym_be] = ACTIONS(1130),
    [anon_sym_COMMA] = ACTIONS(1130),
    [anon_sym_LPAREN] = ACTIONS(1132),
    [anon_sym_RPAREN] = ACTIONS(1130),
    [anon_sym_DOT] = ACTIONS(1132),
    [anon_sym_PIPE] = ACTIONS(1130),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_RBRACE] = ACTIONS(1130),
    [anon_sym_SEMI] = ACTIONS(1130),
    [sym_error] = ACTIONS(1130),
    [sym_compile_intrinsic] = ACTIONS(1130),
    [anon_sym_compile_error] = ACTIONS(1130),
    [sym_location] = ACTIONS(1130),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_not] = ACTIONS(1130),
    [anon_sym_DASH_TILDE] = ACTIONS(1130),
    [anon_sym_addressof] = ACTIONS(1130),
    [anon_sym_digestof] = ACTIONS(1130),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_STAR] = ACTIONS(1132),
    [anon_sym_SLASH] = ACTIONS(1132),
    [anon_sym_PERCENT] = ACTIONS(1132),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1132),
    [anon_sym_LT_LT] = ACTIONS(1132),
    [anon_sym_GT_GT] = ACTIONS(1132),
    [anon_sym_and] = ACTIONS(1130),
    [anon_sym_or] = ACTIONS(1130),
    [anon_sym_xor] = ACTIONS(1130),
    [anon_sym_isnt] = ACTIONS(1130),
    [anon_sym_EQ_EQ] = ACTIONS(1132),
    [anon_sym_BANG_EQ] = ACTIONS(1132),
    [anon_sym_GT] = ACTIONS(1132),
    [anon_sym_GT_EQ] = ACTIONS(1132),
    [anon_sym_LT_EQ] = ACTIONS(1132),
    [anon_sym_LT] = ACTIONS(1132),
    [anon_sym_PLUS_TILDE] = ACTIONS(1130),
    [anon_sym_STAR_TILDE] = ACTIONS(1130),
    [anon_sym_SLASH_TILDE] = ACTIONS(1130),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1130),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1130),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1130),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1130),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1130),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1130),
    [anon_sym_GT_TILDE] = ACTIONS(1130),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1130),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1130),
    [anon_sym_LT_TILDE] = ACTIONS(1130),
    [anon_sym_PLUS_QMARK] = ACTIONS(1130),
    [anon_sym_DASH_QMARK] = ACTIONS(1130),
    [anon_sym_STAR_QMARK] = ACTIONS(1130),
    [anon_sym_SLASH_QMARK] = ACTIONS(1130),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1130),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1130),
    [anon_sym_as] = ACTIONS(1130),
    [anon_sym_LPAREN2] = ACTIONS(1130),
    [anon_sym_DOT_GT] = ACTIONS(1130),
    [anon_sym_where] = ACTIONS(1130),
    [anon_sym_TILDE] = ACTIONS(1130),
    [anon_sym_end] = ACTIONS(1130),
    [anon_sym_if] = ACTIONS(1132),
    [anon_sym_ifdef] = ACTIONS(1130),
    [anon_sym_then] = ACTIONS(1130),
    [anon_sym_iftype] = ACTIONS(1130),
    [anon_sym_else] = ACTIONS(1130),
    [anon_sym_for] = ACTIONS(1130),
    [anon_sym_in] = ACTIONS(1130),
    [anon_sym_while] = ACTIONS(1130),
    [anon_sym_try] = ACTIONS(1130),
    [anon_sym_with] = ACTIONS(1130),
    [anon_sym_repeat] = ACTIONS(1130),
    [anon_sym_until] = ACTIONS(1130),
    [anon_sym_do] = ACTIONS(1130),
    [anon_sym_recover] = ACTIONS(1130),
    [anon_sym_match] = ACTIONS(1130),
    [anon_sym_return] = ACTIONS(1130),
    [anon_sym_continue] = ACTIONS(1130),
    [anon_sym_break] = ACTIONS(1130),
    [anon_sym_consume] = ACTIONS(1130),
    [anon_sym_object] = ACTIONS(1130),
    [sym_number] = ACTIONS(1132),
    [sym_float] = ACTIONS(1130),
    [anon_sym_DQUOTE] = ACTIONS(1132),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1130),
    [anon_sym_SQUOTE] = ACTIONS(1130),
    [anon_sym_true] = ACTIONS(1130),
    [anon_sym_false] = ACTIONS(1130),
    [sym_this] = ACTIONS(1130),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [337] = {
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_EQ] = ACTIONS(1054),
    [anon_sym_AT] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(1052),
    [anon_sym_RBRACK] = ACTIONS(1052),
    [anon_sym_QMARK] = ACTIONS(1052),
    [anon_sym_is] = ACTIONS(1054),
    [anon_sym_embed] = ACTIONS(1052),
    [anon_sym_let] = ACTIONS(1052),
    [anon_sym_var] = ACTIONS(1052),
    [anon_sym_new] = ACTIONS(1052),
    [anon_sym_EQ_GT] = ACTIONS(1052),
    [anon_sym_fun] = ACTIONS(1052),
    [anon_sym_be] = ACTIONS(1052),
    [anon_sym_COMMA] = ACTIONS(1052),
    [anon_sym_LPAREN] = ACTIONS(1054),
    [anon_sym_RPAREN] = ACTIONS(1052),
    [anon_sym_DOT] = ACTIONS(1054),
    [anon_sym_PIPE] = ACTIONS(1052),
    [anon_sym_LBRACE] = ACTIONS(1052),
    [anon_sym_RBRACE] = ACTIONS(1052),
    [anon_sym_SEMI] = ACTIONS(1052),
    [sym_error] = ACTIONS(1052),
    [sym_compile_intrinsic] = ACTIONS(1052),
    [anon_sym_compile_error] = ACTIONS(1052),
    [sym_location] = ACTIONS(1052),
    [anon_sym_DASH] = ACTIONS(1054),
    [anon_sym_not] = ACTIONS(1052),
    [anon_sym_DASH_TILDE] = ACTIONS(1052),
    [anon_sym_addressof] = ACTIONS(1052),
    [anon_sym_digestof] = ACTIONS(1052),
    [anon_sym_PLUS] = ACTIONS(1054),
    [anon_sym_STAR] = ACTIONS(1054),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_PERCENT] = ACTIONS(1054),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1054),
    [anon_sym_LT_LT] = ACTIONS(1054),
    [anon_sym_GT_GT] = ACTIONS(1054),
    [anon_sym_and] = ACTIONS(1052),
    [anon_sym_or] = ACTIONS(1052),
    [anon_sym_xor] = ACTIONS(1052),
    [anon_sym_isnt] = ACTIONS(1052),
    [anon_sym_EQ_EQ] = ACTIONS(1054),
    [anon_sym_BANG_EQ] = ACTIONS(1054),
    [anon_sym_GT] = ACTIONS(1054),
    [anon_sym_GT_EQ] = ACTIONS(1054),
    [anon_sym_LT_EQ] = ACTIONS(1054),
    [anon_sym_LT] = ACTIONS(1054),
    [anon_sym_PLUS_TILDE] = ACTIONS(1052),
    [anon_sym_STAR_TILDE] = ACTIONS(1052),
    [anon_sym_SLASH_TILDE] = ACTIONS(1052),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1052),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1052),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1052),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1052),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1052),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1052),
    [anon_sym_GT_TILDE] = ACTIONS(1052),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1052),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1052),
    [anon_sym_LT_TILDE] = ACTIONS(1052),
    [anon_sym_PLUS_QMARK] = ACTIONS(1052),
    [anon_sym_DASH_QMARK] = ACTIONS(1052),
    [anon_sym_STAR_QMARK] = ACTIONS(1052),
    [anon_sym_SLASH_QMARK] = ACTIONS(1052),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1052),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1052),
    [anon_sym_as] = ACTIONS(1052),
    [anon_sym_LPAREN2] = ACTIONS(1052),
    [anon_sym_DOT_GT] = ACTIONS(1052),
    [anon_sym_where] = ACTIONS(1052),
    [anon_sym_TILDE] = ACTIONS(1052),
    [anon_sym_end] = ACTIONS(1052),
    [anon_sym_if] = ACTIONS(1054),
    [anon_sym_ifdef] = ACTIONS(1052),
    [anon_sym_then] = ACTIONS(1052),
    [anon_sym_iftype] = ACTIONS(1052),
    [anon_sym_else] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1052),
    [anon_sym_while] = ACTIONS(1052),
    [anon_sym_try] = ACTIONS(1052),
    [anon_sym_with] = ACTIONS(1052),
    [anon_sym_repeat] = ACTIONS(1052),
    [anon_sym_until] = ACTIONS(1052),
    [anon_sym_do] = ACTIONS(1052),
    [anon_sym_recover] = ACTIONS(1052),
    [anon_sym_match] = ACTIONS(1052),
    [anon_sym_return] = ACTIONS(1052),
    [anon_sym_continue] = ACTIONS(1052),
    [anon_sym_break] = ACTIONS(1052),
    [anon_sym_consume] = ACTIONS(1052),
    [anon_sym_object] = ACTIONS(1052),
    [sym_number] = ACTIONS(1054),
    [sym_float] = ACTIONS(1052),
    [anon_sym_DQUOTE] = ACTIONS(1054),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1052),
    [anon_sym_SQUOTE] = ACTIONS(1052),
    [anon_sym_true] = ACTIONS(1052),
    [anon_sym_false] = ACTIONS(1052),
    [sym_this] = ACTIONS(1052),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [338] = {
    [sym_identifier] = ACTIONS(1058),
    [anon_sym_EQ] = ACTIONS(1058),
    [anon_sym_AT] = ACTIONS(1056),
    [anon_sym_LBRACK] = ACTIONS(1056),
    [anon_sym_RBRACK] = ACTIONS(1056),
    [anon_sym_QMARK] = ACTIONS(1056),
    [anon_sym_is] = ACTIONS(1058),
    [anon_sym_embed] = ACTIONS(1056),
    [anon_sym_let] = ACTIONS(1056),
    [anon_sym_var] = ACTIONS(1056),
    [anon_sym_new] = ACTIONS(1056),
    [anon_sym_EQ_GT] = ACTIONS(1056),
    [anon_sym_fun] = ACTIONS(1056),
    [anon_sym_be] = ACTIONS(1056),
    [anon_sym_COMMA] = ACTIONS(1056),
    [anon_sym_LPAREN] = ACTIONS(1058),
    [anon_sym_RPAREN] = ACTIONS(1056),
    [anon_sym_DOT] = ACTIONS(1058),
    [anon_sym_PIPE] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1056),
    [anon_sym_RBRACE] = ACTIONS(1056),
    [anon_sym_SEMI] = ACTIONS(1056),
    [sym_error] = ACTIONS(1056),
    [sym_compile_intrinsic] = ACTIONS(1056),
    [anon_sym_compile_error] = ACTIONS(1056),
    [sym_location] = ACTIONS(1056),
    [anon_sym_DASH] = ACTIONS(1058),
    [anon_sym_not] = ACTIONS(1056),
    [anon_sym_DASH_TILDE] = ACTIONS(1056),
    [anon_sym_addressof] = ACTIONS(1056),
    [anon_sym_digestof] = ACTIONS(1056),
    [anon_sym_PLUS] = ACTIONS(1058),
    [anon_sym_STAR] = ACTIONS(1058),
    [anon_sym_SLASH] = ACTIONS(1058),
    [anon_sym_PERCENT] = ACTIONS(1058),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1058),
    [anon_sym_LT_LT] = ACTIONS(1058),
    [anon_sym_GT_GT] = ACTIONS(1058),
    [anon_sym_and] = ACTIONS(1056),
    [anon_sym_or] = ACTIONS(1056),
    [anon_sym_xor] = ACTIONS(1056),
    [anon_sym_isnt] = ACTIONS(1056),
    [anon_sym_EQ_EQ] = ACTIONS(1058),
    [anon_sym_BANG_EQ] = ACTIONS(1058),
    [anon_sym_GT] = ACTIONS(1058),
    [anon_sym_GT_EQ] = ACTIONS(1058),
    [anon_sym_LT_EQ] = ACTIONS(1058),
    [anon_sym_LT] = ACTIONS(1058),
    [anon_sym_PLUS_TILDE] = ACTIONS(1056),
    [anon_sym_STAR_TILDE] = ACTIONS(1056),
    [anon_sym_SLASH_TILDE] = ACTIONS(1056),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1056),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1056),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1056),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1056),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1056),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1056),
    [anon_sym_GT_TILDE] = ACTIONS(1056),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1056),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1056),
    [anon_sym_LT_TILDE] = ACTIONS(1056),
    [anon_sym_PLUS_QMARK] = ACTIONS(1056),
    [anon_sym_DASH_QMARK] = ACTIONS(1056),
    [anon_sym_STAR_QMARK] = ACTIONS(1056),
    [anon_sym_SLASH_QMARK] = ACTIONS(1056),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1056),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1056),
    [anon_sym_as] = ACTIONS(1056),
    [anon_sym_LPAREN2] = ACTIONS(1056),
    [anon_sym_DOT_GT] = ACTIONS(1056),
    [anon_sym_where] = ACTIONS(1056),
    [anon_sym_TILDE] = ACTIONS(1056),
    [anon_sym_end] = ACTIONS(1056),
    [anon_sym_if] = ACTIONS(1058),
    [anon_sym_ifdef] = ACTIONS(1056),
    [anon_sym_then] = ACTIONS(1056),
    [anon_sym_iftype] = ACTIONS(1056),
    [anon_sym_else] = ACTIONS(1056),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1056),
    [anon_sym_try] = ACTIONS(1056),
    [anon_sym_with] = ACTIONS(1056),
    [anon_sym_repeat] = ACTIONS(1056),
    [anon_sym_until] = ACTIONS(1056),
    [anon_sym_do] = ACTIONS(1056),
    [anon_sym_recover] = ACTIONS(1056),
    [anon_sym_match] = ACTIONS(1056),
    [anon_sym_return] = ACTIONS(1056),
    [anon_sym_continue] = ACTIONS(1056),
    [anon_sym_break] = ACTIONS(1056),
    [anon_sym_consume] = ACTIONS(1056),
    [anon_sym_object] = ACTIONS(1056),
    [sym_number] = ACTIONS(1058),
    [sym_float] = ACTIONS(1056),
    [anon_sym_DQUOTE] = ACTIONS(1058),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1056),
    [anon_sym_SQUOTE] = ACTIONS(1056),
    [anon_sym_true] = ACTIONS(1056),
    [anon_sym_false] = ACTIONS(1056),
    [sym_this] = ACTIONS(1056),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [339] = {
    [sym_identifier] = ACTIONS(1004),
    [anon_sym_EQ] = ACTIONS(1004),
    [anon_sym_AT] = ACTIONS(1002),
    [anon_sym_LBRACK] = ACTIONS(1002),
    [anon_sym_RBRACK] = ACTIONS(1002),
    [anon_sym_QMARK] = ACTIONS(1002),
    [anon_sym_is] = ACTIONS(1004),
    [anon_sym_embed] = ACTIONS(1002),
    [anon_sym_let] = ACTIONS(1002),
    [anon_sym_var] = ACTIONS(1002),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_EQ_GT] = ACTIONS(1002),
    [anon_sym_fun] = ACTIONS(1002),
    [anon_sym_be] = ACTIONS(1002),
    [anon_sym_COMMA] = ACTIONS(1002),
    [anon_sym_LPAREN] = ACTIONS(1004),
    [anon_sym_RPAREN] = ACTIONS(1002),
    [anon_sym_DOT] = ACTIONS(1004),
    [anon_sym_PIPE] = ACTIONS(1002),
    [anon_sym_LBRACE] = ACTIONS(1002),
    [anon_sym_RBRACE] = ACTIONS(1002),
    [anon_sym_SEMI] = ACTIONS(1002),
    [sym_error] = ACTIONS(1002),
    [sym_compile_intrinsic] = ACTIONS(1002),
    [anon_sym_compile_error] = ACTIONS(1002),
    [sym_location] = ACTIONS(1002),
    [anon_sym_DASH] = ACTIONS(1004),
    [anon_sym_not] = ACTIONS(1002),
    [anon_sym_DASH_TILDE] = ACTIONS(1002),
    [anon_sym_addressof] = ACTIONS(1002),
    [anon_sym_digestof] = ACTIONS(1002),
    [anon_sym_PLUS] = ACTIONS(1004),
    [anon_sym_STAR] = ACTIONS(1004),
    [anon_sym_SLASH] = ACTIONS(1004),
    [anon_sym_PERCENT] = ACTIONS(1004),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1004),
    [anon_sym_LT_LT] = ACTIONS(1004),
    [anon_sym_GT_GT] = ACTIONS(1004),
    [anon_sym_and] = ACTIONS(1002),
    [anon_sym_or] = ACTIONS(1002),
    [anon_sym_xor] = ACTIONS(1002),
    [anon_sym_isnt] = ACTIONS(1002),
    [anon_sym_EQ_EQ] = ACTIONS(1004),
    [anon_sym_BANG_EQ] = ACTIONS(1004),
    [anon_sym_GT] = ACTIONS(1004),
    [anon_sym_GT_EQ] = ACTIONS(1004),
    [anon_sym_LT_EQ] = ACTIONS(1004),
    [anon_sym_LT] = ACTIONS(1004),
    [anon_sym_PLUS_TILDE] = ACTIONS(1002),
    [anon_sym_STAR_TILDE] = ACTIONS(1002),
    [anon_sym_SLASH_TILDE] = ACTIONS(1002),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1002),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1002),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1002),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1002),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1002),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1002),
    [anon_sym_GT_TILDE] = ACTIONS(1002),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1002),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1002),
    [anon_sym_LT_TILDE] = ACTIONS(1002),
    [anon_sym_PLUS_QMARK] = ACTIONS(1002),
    [anon_sym_DASH_QMARK] = ACTIONS(1002),
    [anon_sym_STAR_QMARK] = ACTIONS(1002),
    [anon_sym_SLASH_QMARK] = ACTIONS(1002),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1002),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1002),
    [anon_sym_as] = ACTIONS(1002),
    [anon_sym_LPAREN2] = ACTIONS(1002),
    [anon_sym_DOT_GT] = ACTIONS(1002),
    [anon_sym_where] = ACTIONS(1002),
    [anon_sym_TILDE] = ACTIONS(1002),
    [anon_sym_end] = ACTIONS(1002),
    [anon_sym_if] = ACTIONS(1004),
    [anon_sym_ifdef] = ACTIONS(1002),
    [anon_sym_then] = ACTIONS(1002),
    [anon_sym_iftype] = ACTIONS(1002),
    [anon_sym_else] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1002),
    [anon_sym_while] = ACTIONS(1002),
    [anon_sym_try] = ACTIONS(1002),
    [anon_sym_with] = ACTIONS(1002),
    [anon_sym_repeat] = ACTIONS(1002),
    [anon_sym_until] = ACTIONS(1002),
    [anon_sym_do] = ACTIONS(1002),
    [anon_sym_recover] = ACTIONS(1002),
    [anon_sym_match] = ACTIONS(1002),
    [anon_sym_return] = ACTIONS(1002),
    [anon_sym_continue] = ACTIONS(1002),
    [anon_sym_break] = ACTIONS(1002),
    [anon_sym_consume] = ACTIONS(1002),
    [anon_sym_object] = ACTIONS(1002),
    [sym_number] = ACTIONS(1004),
    [sym_float] = ACTIONS(1002),
    [anon_sym_DQUOTE] = ACTIONS(1004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1002),
    [anon_sym_SQUOTE] = ACTIONS(1002),
    [anon_sym_true] = ACTIONS(1002),
    [anon_sym_false] = ACTIONS(1002),
    [sym_this] = ACTIONS(1002),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [340] = {
    [sym_identifier] = ACTIONS(1238),
    [anon_sym_EQ] = ACTIONS(1238),
    [anon_sym_AT] = ACTIONS(1236),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_RBRACK] = ACTIONS(1236),
    [anon_sym_is] = ACTIONS(1238),
    [anon_sym_embed] = ACTIONS(1236),
    [anon_sym_let] = ACTIONS(1236),
    [anon_sym_var] = ACTIONS(1236),
    [anon_sym_new] = ACTIONS(1236),
    [anon_sym_EQ_GT] = ACTIONS(1236),
    [anon_sym_fun] = ACTIONS(1236),
    [anon_sym_be] = ACTIONS(1236),
    [anon_sym_COMMA] = ACTIONS(1236),
    [anon_sym_LPAREN] = ACTIONS(1238),
    [anon_sym_RPAREN] = ACTIONS(1236),
    [anon_sym_DOT] = ACTIONS(1238),
    [anon_sym_PIPE] = ACTIONS(1236),
    [anon_sym_LBRACE] = ACTIONS(1236),
    [anon_sym_RBRACE] = ACTIONS(1236),
    [anon_sym_SEMI] = ACTIONS(1236),
    [sym_error] = ACTIONS(1236),
    [sym_compile_intrinsic] = ACTIONS(1236),
    [anon_sym_compile_error] = ACTIONS(1236),
    [sym_location] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_not] = ACTIONS(1236),
    [anon_sym_DASH_TILDE] = ACTIONS(1236),
    [anon_sym_addressof] = ACTIONS(1236),
    [anon_sym_digestof] = ACTIONS(1236),
    [anon_sym_PLUS] = ACTIONS(1238),
    [anon_sym_STAR] = ACTIONS(1238),
    [anon_sym_SLASH] = ACTIONS(1238),
    [anon_sym_PERCENT] = ACTIONS(1238),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1238),
    [anon_sym_LT_LT] = ACTIONS(1238),
    [anon_sym_GT_GT] = ACTIONS(1238),
    [anon_sym_and] = ACTIONS(1236),
    [anon_sym_or] = ACTIONS(1236),
    [anon_sym_xor] = ACTIONS(1236),
    [anon_sym_isnt] = ACTIONS(1236),
    [anon_sym_EQ_EQ] = ACTIONS(1238),
    [anon_sym_BANG_EQ] = ACTIONS(1238),
    [anon_sym_GT] = ACTIONS(1238),
    [anon_sym_GT_EQ] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(1238),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_PLUS_TILDE] = ACTIONS(1236),
    [anon_sym_STAR_TILDE] = ACTIONS(1236),
    [anon_sym_SLASH_TILDE] = ACTIONS(1236),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1236),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1236),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1236),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1236),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1236),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1236),
    [anon_sym_GT_TILDE] = ACTIONS(1236),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1236),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1236),
    [anon_sym_LT_TILDE] = ACTIONS(1236),
    [anon_sym_PLUS_QMARK] = ACTIONS(1236),
    [anon_sym_DASH_QMARK] = ACTIONS(1236),
    [anon_sym_STAR_QMARK] = ACTIONS(1236),
    [anon_sym_SLASH_QMARK] = ACTIONS(1236),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1236),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1236),
    [anon_sym_as] = ACTIONS(1236),
    [anon_sym_LPAREN2] = ACTIONS(1236),
    [anon_sym_DOT_GT] = ACTIONS(1236),
    [anon_sym_where] = ACTIONS(1236),
    [anon_sym_TILDE] = ACTIONS(1236),
    [anon_sym_end] = ACTIONS(1236),
    [anon_sym_if] = ACTIONS(1238),
    [anon_sym_ifdef] = ACTIONS(1236),
    [anon_sym_then] = ACTIONS(1236),
    [anon_sym_iftype] = ACTIONS(1236),
    [anon_sym_else] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1236),
    [anon_sym_in] = ACTIONS(1236),
    [anon_sym_while] = ACTIONS(1236),
    [anon_sym_try] = ACTIONS(1236),
    [anon_sym_with] = ACTIONS(1236),
    [anon_sym_repeat] = ACTIONS(1236),
    [anon_sym_until] = ACTIONS(1236),
    [anon_sym_do] = ACTIONS(1236),
    [anon_sym_recover] = ACTIONS(1236),
    [anon_sym_match] = ACTIONS(1236),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_continue] = ACTIONS(1236),
    [anon_sym_break] = ACTIONS(1236),
    [anon_sym_consume] = ACTIONS(1236),
    [anon_sym_object] = ACTIONS(1236),
    [sym_number] = ACTIONS(1238),
    [sym_float] = ACTIONS(1236),
    [anon_sym_DQUOTE] = ACTIONS(1238),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1236),
    [anon_sym_SQUOTE] = ACTIONS(1236),
    [anon_sym_true] = ACTIONS(1236),
    [anon_sym_false] = ACTIONS(1236),
    [sym_this] = ACTIONS(1236),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [341] = {
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_EQ] = ACTIONS(1046),
    [anon_sym_AT] = ACTIONS(1044),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_RBRACK] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(1044),
    [anon_sym_is] = ACTIONS(1046),
    [anon_sym_embed] = ACTIONS(1044),
    [anon_sym_let] = ACTIONS(1044),
    [anon_sym_var] = ACTIONS(1044),
    [anon_sym_new] = ACTIONS(1044),
    [anon_sym_EQ_GT] = ACTIONS(1044),
    [anon_sym_fun] = ACTIONS(1044),
    [anon_sym_be] = ACTIONS(1044),
    [anon_sym_COMMA] = ACTIONS(1044),
    [anon_sym_LPAREN] = ACTIONS(1046),
    [anon_sym_RPAREN] = ACTIONS(1044),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_PIPE] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1044),
    [anon_sym_RBRACE] = ACTIONS(1044),
    [anon_sym_SEMI] = ACTIONS(1044),
    [sym_error] = ACTIONS(1044),
    [sym_compile_intrinsic] = ACTIONS(1044),
    [anon_sym_compile_error] = ACTIONS(1044),
    [sym_location] = ACTIONS(1044),
    [anon_sym_DASH] = ACTIONS(1046),
    [anon_sym_not] = ACTIONS(1044),
    [anon_sym_DASH_TILDE] = ACTIONS(1044),
    [anon_sym_addressof] = ACTIONS(1044),
    [anon_sym_digestof] = ACTIONS(1044),
    [anon_sym_PLUS] = ACTIONS(1046),
    [anon_sym_STAR] = ACTIONS(1046),
    [anon_sym_SLASH] = ACTIONS(1046),
    [anon_sym_PERCENT] = ACTIONS(1046),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1046),
    [anon_sym_LT_LT] = ACTIONS(1046),
    [anon_sym_GT_GT] = ACTIONS(1046),
    [anon_sym_and] = ACTIONS(1044),
    [anon_sym_or] = ACTIONS(1044),
    [anon_sym_xor] = ACTIONS(1044),
    [anon_sym_isnt] = ACTIONS(1044),
    [anon_sym_EQ_EQ] = ACTIONS(1046),
    [anon_sym_BANG_EQ] = ACTIONS(1046),
    [anon_sym_GT] = ACTIONS(1046),
    [anon_sym_GT_EQ] = ACTIONS(1046),
    [anon_sym_LT_EQ] = ACTIONS(1046),
    [anon_sym_LT] = ACTIONS(1046),
    [anon_sym_PLUS_TILDE] = ACTIONS(1044),
    [anon_sym_STAR_TILDE] = ACTIONS(1044),
    [anon_sym_SLASH_TILDE] = ACTIONS(1044),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1044),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1044),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1044),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1044),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1044),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1044),
    [anon_sym_GT_TILDE] = ACTIONS(1044),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1044),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1044),
    [anon_sym_LT_TILDE] = ACTIONS(1044),
    [anon_sym_PLUS_QMARK] = ACTIONS(1044),
    [anon_sym_DASH_QMARK] = ACTIONS(1044),
    [anon_sym_STAR_QMARK] = ACTIONS(1044),
    [anon_sym_SLASH_QMARK] = ACTIONS(1044),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1044),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1044),
    [anon_sym_as] = ACTIONS(1044),
    [anon_sym_LPAREN2] = ACTIONS(1044),
    [anon_sym_DOT_GT] = ACTIONS(1044),
    [anon_sym_where] = ACTIONS(1044),
    [anon_sym_TILDE] = ACTIONS(1044),
    [anon_sym_end] = ACTIONS(1044),
    [anon_sym_if] = ACTIONS(1046),
    [anon_sym_ifdef] = ACTIONS(1044),
    [anon_sym_then] = ACTIONS(1044),
    [anon_sym_iftype] = ACTIONS(1044),
    [anon_sym_else] = ACTIONS(1044),
    [anon_sym_for] = ACTIONS(1044),
    [anon_sym_while] = ACTIONS(1044),
    [anon_sym_try] = ACTIONS(1044),
    [anon_sym_with] = ACTIONS(1044),
    [anon_sym_repeat] = ACTIONS(1044),
    [anon_sym_until] = ACTIONS(1044),
    [anon_sym_do] = ACTIONS(1044),
    [anon_sym_recover] = ACTIONS(1044),
    [anon_sym_match] = ACTIONS(1044),
    [anon_sym_return] = ACTIONS(1044),
    [anon_sym_continue] = ACTIONS(1044),
    [anon_sym_break] = ACTIONS(1044),
    [anon_sym_consume] = ACTIONS(1044),
    [anon_sym_object] = ACTIONS(1044),
    [sym_number] = ACTIONS(1046),
    [sym_float] = ACTIONS(1044),
    [anon_sym_DQUOTE] = ACTIONS(1046),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1044),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_true] = ACTIONS(1044),
    [anon_sym_false] = ACTIONS(1044),
    [sym_this] = ACTIONS(1044),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [342] = {
    [sym_identifier] = ACTIONS(1050),
    [anon_sym_EQ] = ACTIONS(1050),
    [anon_sym_AT] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(1048),
    [anon_sym_RBRACK] = ACTIONS(1048),
    [anon_sym_QMARK] = ACTIONS(1048),
    [anon_sym_is] = ACTIONS(1050),
    [anon_sym_embed] = ACTIONS(1048),
    [anon_sym_let] = ACTIONS(1048),
    [anon_sym_var] = ACTIONS(1048),
    [anon_sym_new] = ACTIONS(1048),
    [anon_sym_EQ_GT] = ACTIONS(1048),
    [anon_sym_fun] = ACTIONS(1048),
    [anon_sym_be] = ACTIONS(1048),
    [anon_sym_COMMA] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(1050),
    [anon_sym_RPAREN] = ACTIONS(1048),
    [anon_sym_DOT] = ACTIONS(1050),
    [anon_sym_PIPE] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1048),
    [anon_sym_RBRACE] = ACTIONS(1048),
    [anon_sym_SEMI] = ACTIONS(1048),
    [sym_error] = ACTIONS(1048),
    [sym_compile_intrinsic] = ACTIONS(1048),
    [anon_sym_compile_error] = ACTIONS(1048),
    [sym_location] = ACTIONS(1048),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_not] = ACTIONS(1048),
    [anon_sym_DASH_TILDE] = ACTIONS(1048),
    [anon_sym_addressof] = ACTIONS(1048),
    [anon_sym_digestof] = ACTIONS(1048),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_STAR] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(1050),
    [anon_sym_PERCENT] = ACTIONS(1050),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1050),
    [anon_sym_LT_LT] = ACTIONS(1050),
    [anon_sym_GT_GT] = ACTIONS(1050),
    [anon_sym_and] = ACTIONS(1048),
    [anon_sym_or] = ACTIONS(1048),
    [anon_sym_xor] = ACTIONS(1048),
    [anon_sym_isnt] = ACTIONS(1048),
    [anon_sym_EQ_EQ] = ACTIONS(1050),
    [anon_sym_BANG_EQ] = ACTIONS(1050),
    [anon_sym_GT] = ACTIONS(1050),
    [anon_sym_GT_EQ] = ACTIONS(1050),
    [anon_sym_LT_EQ] = ACTIONS(1050),
    [anon_sym_LT] = ACTIONS(1050),
    [anon_sym_PLUS_TILDE] = ACTIONS(1048),
    [anon_sym_STAR_TILDE] = ACTIONS(1048),
    [anon_sym_SLASH_TILDE] = ACTIONS(1048),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1048),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1048),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1048),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1048),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1048),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1048),
    [anon_sym_GT_TILDE] = ACTIONS(1048),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1048),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1048),
    [anon_sym_LT_TILDE] = ACTIONS(1048),
    [anon_sym_PLUS_QMARK] = ACTIONS(1048),
    [anon_sym_DASH_QMARK] = ACTIONS(1048),
    [anon_sym_STAR_QMARK] = ACTIONS(1048),
    [anon_sym_SLASH_QMARK] = ACTIONS(1048),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1048),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1048),
    [anon_sym_as] = ACTIONS(1048),
    [anon_sym_LPAREN2] = ACTIONS(1048),
    [anon_sym_DOT_GT] = ACTIONS(1048),
    [anon_sym_where] = ACTIONS(1048),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_end] = ACTIONS(1048),
    [anon_sym_if] = ACTIONS(1050),
    [anon_sym_ifdef] = ACTIONS(1048),
    [anon_sym_then] = ACTIONS(1048),
    [anon_sym_iftype] = ACTIONS(1048),
    [anon_sym_else] = ACTIONS(1048),
    [anon_sym_for] = ACTIONS(1048),
    [anon_sym_while] = ACTIONS(1048),
    [anon_sym_try] = ACTIONS(1048),
    [anon_sym_with] = ACTIONS(1048),
    [anon_sym_repeat] = ACTIONS(1048),
    [anon_sym_until] = ACTIONS(1048),
    [anon_sym_do] = ACTIONS(1048),
    [anon_sym_recover] = ACTIONS(1048),
    [anon_sym_match] = ACTIONS(1048),
    [anon_sym_return] = ACTIONS(1048),
    [anon_sym_continue] = ACTIONS(1048),
    [anon_sym_break] = ACTIONS(1048),
    [anon_sym_consume] = ACTIONS(1048),
    [anon_sym_object] = ACTIONS(1048),
    [sym_number] = ACTIONS(1050),
    [sym_float] = ACTIONS(1048),
    [anon_sym_DQUOTE] = ACTIONS(1050),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1048),
    [anon_sym_SQUOTE] = ACTIONS(1048),
    [anon_sym_true] = ACTIONS(1048),
    [anon_sym_false] = ACTIONS(1048),
    [sym_this] = ACTIONS(1048),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [343] = {
    [sym_identifier] = ACTIONS(839),
    [anon_sym_EQ] = ACTIONS(839),
    [anon_sym_AT] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(837),
    [anon_sym_RBRACK] = ACTIONS(837),
    [anon_sym_is] = ACTIONS(839),
    [anon_sym_embed] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_var] = ACTIONS(837),
    [anon_sym_new] = ACTIONS(837),
    [anon_sym_EQ_GT] = ACTIONS(837),
    [anon_sym_fun] = ACTIONS(837),
    [anon_sym_be] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_SEMI] = ACTIONS(837),
    [sym_error] = ACTIONS(837),
    [sym_compile_intrinsic] = ACTIONS(837),
    [anon_sym_compile_error] = ACTIONS(837),
    [sym_location] = ACTIONS(837),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(837),
    [anon_sym_DASH_TILDE] = ACTIONS(837),
    [anon_sym_addressof] = ACTIONS(837),
    [anon_sym_digestof] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_STAR] = ACTIONS(839),
    [anon_sym_SLASH] = ACTIONS(839),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_GT_GT] = ACTIONS(839),
    [anon_sym_and] = ACTIONS(837),
    [anon_sym_or] = ACTIONS(837),
    [anon_sym_xor] = ACTIONS(837),
    [anon_sym_isnt] = ACTIONS(837),
    [anon_sym_EQ_EQ] = ACTIONS(839),
    [anon_sym_BANG_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(839),
    [anon_sym_PLUS_TILDE] = ACTIONS(837),
    [anon_sym_STAR_TILDE] = ACTIONS(837),
    [anon_sym_SLASH_TILDE] = ACTIONS(837),
    [anon_sym_PERCENT_TILDE] = ACTIONS(837),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(837),
    [anon_sym_LT_LT_TILDE] = ACTIONS(837),
    [anon_sym_GT_GT_TILDE] = ACTIONS(837),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(837),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(837),
    [anon_sym_GT_TILDE] = ACTIONS(837),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(837),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(837),
    [anon_sym_LT_TILDE] = ACTIONS(837),
    [anon_sym_PLUS_QMARK] = ACTIONS(837),
    [anon_sym_DASH_QMARK] = ACTIONS(837),
    [anon_sym_STAR_QMARK] = ACTIONS(837),
    [anon_sym_SLASH_QMARK] = ACTIONS(837),
    [anon_sym_PERCENT_QMARK] = ACTIONS(837),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(837),
    [anon_sym_as] = ACTIONS(837),
    [anon_sym_LPAREN2] = ACTIONS(837),
    [anon_sym_DOT_GT] = ACTIONS(837),
    [anon_sym_where] = ACTIONS(837),
    [anon_sym_TILDE] = ACTIONS(837),
    [anon_sym_end] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_ifdef] = ACTIONS(837),
    [anon_sym_then] = ACTIONS(837),
    [anon_sym_iftype] = ACTIONS(837),
    [anon_sym_else] = ACTIONS(837),
    [anon_sym_for] = ACTIONS(837),
    [anon_sym_while] = ACTIONS(837),
    [anon_sym_try] = ACTIONS(837),
    [anon_sym_with] = ACTIONS(837),
    [anon_sym_repeat] = ACTIONS(837),
    [anon_sym_until] = ACTIONS(837),
    [anon_sym_do] = ACTIONS(837),
    [anon_sym_recover] = ACTIONS(837),
    [anon_sym_match] = ACTIONS(837),
    [anon_sym_return] = ACTIONS(837),
    [anon_sym_continue] = ACTIONS(837),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_consume] = ACTIONS(837),
    [anon_sym_object] = ACTIONS(837),
    [sym_number] = ACTIONS(839),
    [sym_float] = ACTIONS(837),
    [anon_sym_DQUOTE] = ACTIONS(839),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(837),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_true] = ACTIONS(837),
    [anon_sym_false] = ACTIONS(837),
    [sym_this] = ACTIONS(837),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [344] = {
    [sym_identifier] = ACTIONS(1278),
    [anon_sym_EQ] = ACTIONS(1278),
    [anon_sym_AT] = ACTIONS(1276),
    [anon_sym_LBRACK] = ACTIONS(1276),
    [anon_sym_RBRACK] = ACTIONS(1276),
    [anon_sym_is] = ACTIONS(1278),
    [anon_sym_embed] = ACTIONS(1276),
    [anon_sym_let] = ACTIONS(1276),
    [anon_sym_var] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_EQ_GT] = ACTIONS(1276),
    [anon_sym_fun] = ACTIONS(1276),
    [anon_sym_be] = ACTIONS(1276),
    [anon_sym_COMMA] = ACTIONS(1276),
    [anon_sym_LPAREN] = ACTIONS(1278),
    [anon_sym_RPAREN] = ACTIONS(1276),
    [anon_sym_DOT] = ACTIONS(1278),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_LBRACE] = ACTIONS(1276),
    [anon_sym_RBRACE] = ACTIONS(1276),
    [anon_sym_SEMI] = ACTIONS(1276),
    [sym_error] = ACTIONS(1276),
    [sym_compile_intrinsic] = ACTIONS(1276),
    [anon_sym_compile_error] = ACTIONS(1276),
    [sym_location] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_not] = ACTIONS(1276),
    [anon_sym_DASH_TILDE] = ACTIONS(1276),
    [anon_sym_addressof] = ACTIONS(1276),
    [anon_sym_digestof] = ACTIONS(1276),
    [anon_sym_PLUS] = ACTIONS(1278),
    [anon_sym_STAR] = ACTIONS(1278),
    [anon_sym_SLASH] = ACTIONS(1278),
    [anon_sym_PERCENT] = ACTIONS(1278),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1278),
    [anon_sym_LT_LT] = ACTIONS(1278),
    [anon_sym_GT_GT] = ACTIONS(1278),
    [anon_sym_and] = ACTIONS(1276),
    [anon_sym_or] = ACTIONS(1276),
    [anon_sym_xor] = ACTIONS(1276),
    [anon_sym_isnt] = ACTIONS(1276),
    [anon_sym_EQ_EQ] = ACTIONS(1278),
    [anon_sym_BANG_EQ] = ACTIONS(1278),
    [anon_sym_GT] = ACTIONS(1278),
    [anon_sym_GT_EQ] = ACTIONS(1278),
    [anon_sym_LT_EQ] = ACTIONS(1278),
    [anon_sym_LT] = ACTIONS(1278),
    [anon_sym_PLUS_TILDE] = ACTIONS(1276),
    [anon_sym_STAR_TILDE] = ACTIONS(1276),
    [anon_sym_SLASH_TILDE] = ACTIONS(1276),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1276),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1276),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1276),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1276),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1276),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1276),
    [anon_sym_GT_TILDE] = ACTIONS(1276),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1276),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1276),
    [anon_sym_LT_TILDE] = ACTIONS(1276),
    [anon_sym_PLUS_QMARK] = ACTIONS(1276),
    [anon_sym_DASH_QMARK] = ACTIONS(1276),
    [anon_sym_STAR_QMARK] = ACTIONS(1276),
    [anon_sym_SLASH_QMARK] = ACTIONS(1276),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1276),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1276),
    [anon_sym_as] = ACTIONS(1276),
    [anon_sym_LPAREN2] = ACTIONS(1276),
    [anon_sym_DOT_GT] = ACTIONS(1276),
    [anon_sym_where] = ACTIONS(1276),
    [anon_sym_TILDE] = ACTIONS(1276),
    [anon_sym_end] = ACTIONS(1276),
    [anon_sym_if] = ACTIONS(1278),
    [anon_sym_ifdef] = ACTIONS(1276),
    [anon_sym_then] = ACTIONS(1276),
    [anon_sym_iftype] = ACTIONS(1276),
    [anon_sym_else] = ACTIONS(1276),
    [anon_sym_for] = ACTIONS(1276),
    [anon_sym_while] = ACTIONS(1276),
    [anon_sym_try] = ACTIONS(1276),
    [anon_sym_with] = ACTIONS(1276),
    [anon_sym_repeat] = ACTIONS(1276),
    [anon_sym_until] = ACTIONS(1276),
    [anon_sym_do] = ACTIONS(1276),
    [anon_sym_recover] = ACTIONS(1276),
    [anon_sym_match] = ACTIONS(1276),
    [anon_sym_return] = ACTIONS(1276),
    [anon_sym_continue] = ACTIONS(1276),
    [anon_sym_break] = ACTIONS(1276),
    [anon_sym_consume] = ACTIONS(1276),
    [anon_sym_object] = ACTIONS(1276),
    [sym_number] = ACTIONS(1278),
    [sym_float] = ACTIONS(1276),
    [anon_sym_DQUOTE] = ACTIONS(1278),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_SQUOTE] = ACTIONS(1276),
    [anon_sym_true] = ACTIONS(1276),
    [anon_sym_false] = ACTIONS(1276),
    [sym_this] = ACTIONS(1276),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [345] = {
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_EQ] = ACTIONS(1128),
    [anon_sym_AT] = ACTIONS(1126),
    [anon_sym_LBRACK] = ACTIONS(1126),
    [anon_sym_RBRACK] = ACTIONS(1126),
    [anon_sym_is] = ACTIONS(1128),
    [anon_sym_embed] = ACTIONS(1126),
    [anon_sym_let] = ACTIONS(1126),
    [anon_sym_var] = ACTIONS(1126),
    [anon_sym_new] = ACTIONS(1126),
    [anon_sym_EQ_GT] = ACTIONS(1126),
    [anon_sym_fun] = ACTIONS(1126),
    [anon_sym_be] = ACTIONS(1126),
    [anon_sym_COMMA] = ACTIONS(1126),
    [anon_sym_LPAREN] = ACTIONS(1128),
    [anon_sym_RPAREN] = ACTIONS(1126),
    [anon_sym_DOT] = ACTIONS(1128),
    [anon_sym_PIPE] = ACTIONS(1126),
    [anon_sym_LBRACE] = ACTIONS(1126),
    [anon_sym_RBRACE] = ACTIONS(1126),
    [anon_sym_SEMI] = ACTIONS(1126),
    [sym_error] = ACTIONS(1126),
    [sym_compile_intrinsic] = ACTIONS(1126),
    [anon_sym_compile_error] = ACTIONS(1126),
    [sym_location] = ACTIONS(1126),
    [anon_sym_DASH] = ACTIONS(1128),
    [anon_sym_not] = ACTIONS(1126),
    [anon_sym_DASH_TILDE] = ACTIONS(1126),
    [anon_sym_addressof] = ACTIONS(1126),
    [anon_sym_digestof] = ACTIONS(1126),
    [anon_sym_PLUS] = ACTIONS(1128),
    [anon_sym_STAR] = ACTIONS(1128),
    [anon_sym_SLASH] = ACTIONS(1128),
    [anon_sym_PERCENT] = ACTIONS(1128),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1128),
    [anon_sym_LT_LT] = ACTIONS(1128),
    [anon_sym_GT_GT] = ACTIONS(1128),
    [anon_sym_and] = ACTIONS(1126),
    [anon_sym_or] = ACTIONS(1126),
    [anon_sym_xor] = ACTIONS(1126),
    [anon_sym_isnt] = ACTIONS(1126),
    [anon_sym_EQ_EQ] = ACTIONS(1128),
    [anon_sym_BANG_EQ] = ACTIONS(1128),
    [anon_sym_GT] = ACTIONS(1128),
    [anon_sym_GT_EQ] = ACTIONS(1128),
    [anon_sym_LT_EQ] = ACTIONS(1128),
    [anon_sym_LT] = ACTIONS(1128),
    [anon_sym_PLUS_TILDE] = ACTIONS(1126),
    [anon_sym_STAR_TILDE] = ACTIONS(1126),
    [anon_sym_SLASH_TILDE] = ACTIONS(1126),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1126),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1126),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1126),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1126),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1126),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1126),
    [anon_sym_GT_TILDE] = ACTIONS(1126),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1126),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1126),
    [anon_sym_LT_TILDE] = ACTIONS(1126),
    [anon_sym_PLUS_QMARK] = ACTIONS(1126),
    [anon_sym_DASH_QMARK] = ACTIONS(1126),
    [anon_sym_STAR_QMARK] = ACTIONS(1126),
    [anon_sym_SLASH_QMARK] = ACTIONS(1126),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1126),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1126),
    [anon_sym_as] = ACTIONS(1126),
    [anon_sym_LPAREN2] = ACTIONS(1126),
    [anon_sym_DOT_GT] = ACTIONS(1126),
    [anon_sym_where] = ACTIONS(1126),
    [anon_sym_TILDE] = ACTIONS(1126),
    [anon_sym_end] = ACTIONS(1126),
    [anon_sym_if] = ACTIONS(1128),
    [anon_sym_ifdef] = ACTIONS(1126),
    [anon_sym_then] = ACTIONS(1126),
    [anon_sym_iftype] = ACTIONS(1126),
    [anon_sym_else] = ACTIONS(1126),
    [anon_sym_for] = ACTIONS(1126),
    [anon_sym_while] = ACTIONS(1126),
    [anon_sym_try] = ACTIONS(1126),
    [anon_sym_with] = ACTIONS(1126),
    [anon_sym_repeat] = ACTIONS(1126),
    [anon_sym_until] = ACTIONS(1126),
    [anon_sym_do] = ACTIONS(1126),
    [anon_sym_recover] = ACTIONS(1126),
    [anon_sym_match] = ACTIONS(1126),
    [anon_sym_return] = ACTIONS(1126),
    [anon_sym_continue] = ACTIONS(1126),
    [anon_sym_break] = ACTIONS(1126),
    [anon_sym_consume] = ACTIONS(1126),
    [anon_sym_object] = ACTIONS(1126),
    [sym_number] = ACTIONS(1128),
    [sym_float] = ACTIONS(1126),
    [anon_sym_DQUOTE] = ACTIONS(1128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1126),
    [anon_sym_SQUOTE] = ACTIONS(1126),
    [anon_sym_true] = ACTIONS(1126),
    [anon_sym_false] = ACTIONS(1126),
    [sym_this] = ACTIONS(1126),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [346] = {
    [sym_identifier] = ACTIONS(1124),
    [anon_sym_EQ] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1122),
    [anon_sym_RBRACK] = ACTIONS(1122),
    [anon_sym_is] = ACTIONS(1124),
    [anon_sym_embed] = ACTIONS(1122),
    [anon_sym_let] = ACTIONS(1122),
    [anon_sym_var] = ACTIONS(1122),
    [anon_sym_new] = ACTIONS(1122),
    [anon_sym_EQ_GT] = ACTIONS(1122),
    [anon_sym_fun] = ACTIONS(1122),
    [anon_sym_be] = ACTIONS(1122),
    [anon_sym_COMMA] = ACTIONS(1122),
    [anon_sym_LPAREN] = ACTIONS(1124),
    [anon_sym_RPAREN] = ACTIONS(1122),
    [anon_sym_DOT] = ACTIONS(1124),
    [anon_sym_PIPE] = ACTIONS(1122),
    [anon_sym_LBRACE] = ACTIONS(1122),
    [anon_sym_RBRACE] = ACTIONS(1122),
    [anon_sym_SEMI] = ACTIONS(1122),
    [sym_error] = ACTIONS(1122),
    [sym_compile_intrinsic] = ACTIONS(1122),
    [anon_sym_compile_error] = ACTIONS(1122),
    [sym_location] = ACTIONS(1122),
    [anon_sym_DASH] = ACTIONS(1124),
    [anon_sym_not] = ACTIONS(1122),
    [anon_sym_DASH_TILDE] = ACTIONS(1122),
    [anon_sym_addressof] = ACTIONS(1122),
    [anon_sym_digestof] = ACTIONS(1122),
    [anon_sym_PLUS] = ACTIONS(1124),
    [anon_sym_STAR] = ACTIONS(1124),
    [anon_sym_SLASH] = ACTIONS(1124),
    [anon_sym_PERCENT] = ACTIONS(1124),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1124),
    [anon_sym_LT_LT] = ACTIONS(1124),
    [anon_sym_GT_GT] = ACTIONS(1124),
    [anon_sym_and] = ACTIONS(1122),
    [anon_sym_or] = ACTIONS(1122),
    [anon_sym_xor] = ACTIONS(1122),
    [anon_sym_isnt] = ACTIONS(1122),
    [anon_sym_EQ_EQ] = ACTIONS(1124),
    [anon_sym_BANG_EQ] = ACTIONS(1124),
    [anon_sym_GT] = ACTIONS(1124),
    [anon_sym_GT_EQ] = ACTIONS(1124),
    [anon_sym_LT_EQ] = ACTIONS(1124),
    [anon_sym_LT] = ACTIONS(1124),
    [anon_sym_PLUS_TILDE] = ACTIONS(1122),
    [anon_sym_STAR_TILDE] = ACTIONS(1122),
    [anon_sym_SLASH_TILDE] = ACTIONS(1122),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1122),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1122),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1122),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1122),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1122),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1122),
    [anon_sym_GT_TILDE] = ACTIONS(1122),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1122),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1122),
    [anon_sym_LT_TILDE] = ACTIONS(1122),
    [anon_sym_PLUS_QMARK] = ACTIONS(1122),
    [anon_sym_DASH_QMARK] = ACTIONS(1122),
    [anon_sym_STAR_QMARK] = ACTIONS(1122),
    [anon_sym_SLASH_QMARK] = ACTIONS(1122),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1122),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1122),
    [anon_sym_as] = ACTIONS(1122),
    [anon_sym_LPAREN2] = ACTIONS(1122),
    [anon_sym_DOT_GT] = ACTIONS(1122),
    [anon_sym_where] = ACTIONS(1122),
    [anon_sym_TILDE] = ACTIONS(1122),
    [anon_sym_end] = ACTIONS(1122),
    [anon_sym_if] = ACTIONS(1124),
    [anon_sym_ifdef] = ACTIONS(1122),
    [anon_sym_then] = ACTIONS(1122),
    [anon_sym_iftype] = ACTIONS(1122),
    [anon_sym_else] = ACTIONS(1122),
    [anon_sym_for] = ACTIONS(1122),
    [anon_sym_while] = ACTIONS(1122),
    [anon_sym_try] = ACTIONS(1122),
    [anon_sym_with] = ACTIONS(1122),
    [anon_sym_repeat] = ACTIONS(1122),
    [anon_sym_until] = ACTIONS(1122),
    [anon_sym_do] = ACTIONS(1122),
    [anon_sym_recover] = ACTIONS(1122),
    [anon_sym_match] = ACTIONS(1122),
    [anon_sym_return] = ACTIONS(1122),
    [anon_sym_continue] = ACTIONS(1122),
    [anon_sym_break] = ACTIONS(1122),
    [anon_sym_consume] = ACTIONS(1122),
    [anon_sym_object] = ACTIONS(1122),
    [sym_number] = ACTIONS(1124),
    [sym_float] = ACTIONS(1122),
    [anon_sym_DQUOTE] = ACTIONS(1124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1122),
    [anon_sym_SQUOTE] = ACTIONS(1122),
    [anon_sym_true] = ACTIONS(1122),
    [anon_sym_false] = ACTIONS(1122),
    [sym_this] = ACTIONS(1122),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [347] = {
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_EQ] = ACTIONS(1148),
    [anon_sym_AT] = ACTIONS(1146),
    [anon_sym_LBRACK] = ACTIONS(1146),
    [anon_sym_RBRACK] = ACTIONS(1146),
    [anon_sym_is] = ACTIONS(1148),
    [anon_sym_embed] = ACTIONS(1146),
    [anon_sym_let] = ACTIONS(1146),
    [anon_sym_var] = ACTIONS(1146),
    [anon_sym_new] = ACTIONS(1146),
    [anon_sym_EQ_GT] = ACTIONS(1146),
    [anon_sym_fun] = ACTIONS(1146),
    [anon_sym_be] = ACTIONS(1146),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_LPAREN] = ACTIONS(1148),
    [anon_sym_RPAREN] = ACTIONS(1146),
    [anon_sym_DOT] = ACTIONS(1148),
    [anon_sym_PIPE] = ACTIONS(1146),
    [anon_sym_LBRACE] = ACTIONS(1146),
    [anon_sym_RBRACE] = ACTIONS(1146),
    [anon_sym_SEMI] = ACTIONS(1146),
    [sym_error] = ACTIONS(1146),
    [sym_compile_intrinsic] = ACTIONS(1146),
    [anon_sym_compile_error] = ACTIONS(1146),
    [sym_location] = ACTIONS(1146),
    [anon_sym_DASH] = ACTIONS(1148),
    [anon_sym_not] = ACTIONS(1146),
    [anon_sym_DASH_TILDE] = ACTIONS(1146),
    [anon_sym_addressof] = ACTIONS(1146),
    [anon_sym_digestof] = ACTIONS(1146),
    [anon_sym_PLUS] = ACTIONS(1148),
    [anon_sym_STAR] = ACTIONS(1148),
    [anon_sym_SLASH] = ACTIONS(1148),
    [anon_sym_PERCENT] = ACTIONS(1148),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(1148),
    [anon_sym_GT_GT] = ACTIONS(1148),
    [anon_sym_and] = ACTIONS(1146),
    [anon_sym_or] = ACTIONS(1146),
    [anon_sym_xor] = ACTIONS(1146),
    [anon_sym_isnt] = ACTIONS(1146),
    [anon_sym_EQ_EQ] = ACTIONS(1148),
    [anon_sym_BANG_EQ] = ACTIONS(1148),
    [anon_sym_GT] = ACTIONS(1148),
    [anon_sym_GT_EQ] = ACTIONS(1148),
    [anon_sym_LT_EQ] = ACTIONS(1148),
    [anon_sym_LT] = ACTIONS(1148),
    [anon_sym_PLUS_TILDE] = ACTIONS(1146),
    [anon_sym_STAR_TILDE] = ACTIONS(1146),
    [anon_sym_SLASH_TILDE] = ACTIONS(1146),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1146),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1146),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1146),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1146),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1146),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1146),
    [anon_sym_GT_TILDE] = ACTIONS(1146),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1146),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1146),
    [anon_sym_LT_TILDE] = ACTIONS(1146),
    [anon_sym_PLUS_QMARK] = ACTIONS(1146),
    [anon_sym_DASH_QMARK] = ACTIONS(1146),
    [anon_sym_STAR_QMARK] = ACTIONS(1146),
    [anon_sym_SLASH_QMARK] = ACTIONS(1146),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1146),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1146),
    [anon_sym_as] = ACTIONS(1146),
    [anon_sym_LPAREN2] = ACTIONS(1146),
    [anon_sym_DOT_GT] = ACTIONS(1146),
    [anon_sym_where] = ACTIONS(1146),
    [anon_sym_TILDE] = ACTIONS(1146),
    [anon_sym_end] = ACTIONS(1146),
    [anon_sym_if] = ACTIONS(1148),
    [anon_sym_ifdef] = ACTIONS(1146),
    [anon_sym_then] = ACTIONS(1146),
    [anon_sym_iftype] = ACTIONS(1146),
    [anon_sym_else] = ACTIONS(1146),
    [anon_sym_for] = ACTIONS(1146),
    [anon_sym_while] = ACTIONS(1146),
    [anon_sym_try] = ACTIONS(1146),
    [anon_sym_with] = ACTIONS(1146),
    [anon_sym_repeat] = ACTIONS(1146),
    [anon_sym_until] = ACTIONS(1146),
    [anon_sym_do] = ACTIONS(1146),
    [anon_sym_recover] = ACTIONS(1146),
    [anon_sym_match] = ACTIONS(1146),
    [anon_sym_return] = ACTIONS(1146),
    [anon_sym_continue] = ACTIONS(1146),
    [anon_sym_break] = ACTIONS(1146),
    [anon_sym_consume] = ACTIONS(1146),
    [anon_sym_object] = ACTIONS(1146),
    [sym_number] = ACTIONS(1148),
    [sym_float] = ACTIONS(1146),
    [anon_sym_DQUOTE] = ACTIONS(1148),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1146),
    [anon_sym_SQUOTE] = ACTIONS(1146),
    [anon_sym_true] = ACTIONS(1146),
    [anon_sym_false] = ACTIONS(1146),
    [sym_this] = ACTIONS(1146),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [348] = {
    [sym_identifier] = ACTIONS(1250),
    [anon_sym_EQ] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1248),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_RBRACK] = ACTIONS(1248),
    [anon_sym_is] = ACTIONS(1250),
    [anon_sym_embed] = ACTIONS(1248),
    [anon_sym_let] = ACTIONS(1248),
    [anon_sym_var] = ACTIONS(1248),
    [anon_sym_new] = ACTIONS(1248),
    [anon_sym_EQ_GT] = ACTIONS(1248),
    [anon_sym_fun] = ACTIONS(1248),
    [anon_sym_be] = ACTIONS(1248),
    [anon_sym_COMMA] = ACTIONS(1248),
    [anon_sym_LPAREN] = ACTIONS(1250),
    [anon_sym_RPAREN] = ACTIONS(1248),
    [anon_sym_DOT] = ACTIONS(1250),
    [anon_sym_PIPE] = ACTIONS(1248),
    [anon_sym_LBRACE] = ACTIONS(1248),
    [anon_sym_RBRACE] = ACTIONS(1248),
    [anon_sym_SEMI] = ACTIONS(1248),
    [sym_error] = ACTIONS(1248),
    [sym_compile_intrinsic] = ACTIONS(1248),
    [anon_sym_compile_error] = ACTIONS(1248),
    [sym_location] = ACTIONS(1248),
    [anon_sym_DASH] = ACTIONS(1250),
    [anon_sym_not] = ACTIONS(1248),
    [anon_sym_DASH_TILDE] = ACTIONS(1248),
    [anon_sym_addressof] = ACTIONS(1248),
    [anon_sym_digestof] = ACTIONS(1248),
    [anon_sym_PLUS] = ACTIONS(1250),
    [anon_sym_STAR] = ACTIONS(1250),
    [anon_sym_SLASH] = ACTIONS(1250),
    [anon_sym_PERCENT] = ACTIONS(1250),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1250),
    [anon_sym_LT_LT] = ACTIONS(1250),
    [anon_sym_GT_GT] = ACTIONS(1250),
    [anon_sym_and] = ACTIONS(1248),
    [anon_sym_or] = ACTIONS(1248),
    [anon_sym_xor] = ACTIONS(1248),
    [anon_sym_isnt] = ACTIONS(1248),
    [anon_sym_EQ_EQ] = ACTIONS(1250),
    [anon_sym_BANG_EQ] = ACTIONS(1250),
    [anon_sym_GT] = ACTIONS(1250),
    [anon_sym_GT_EQ] = ACTIONS(1250),
    [anon_sym_LT_EQ] = ACTIONS(1250),
    [anon_sym_LT] = ACTIONS(1250),
    [anon_sym_PLUS_TILDE] = ACTIONS(1248),
    [anon_sym_STAR_TILDE] = ACTIONS(1248),
    [anon_sym_SLASH_TILDE] = ACTIONS(1248),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1248),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1248),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1248),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1248),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1248),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1248),
    [anon_sym_GT_TILDE] = ACTIONS(1248),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1248),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1248),
    [anon_sym_LT_TILDE] = ACTIONS(1248),
    [anon_sym_PLUS_QMARK] = ACTIONS(1248),
    [anon_sym_DASH_QMARK] = ACTIONS(1248),
    [anon_sym_STAR_QMARK] = ACTIONS(1248),
    [anon_sym_SLASH_QMARK] = ACTIONS(1248),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1248),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1248),
    [anon_sym_as] = ACTIONS(1248),
    [anon_sym_LPAREN2] = ACTIONS(1248),
    [anon_sym_DOT_GT] = ACTIONS(1248),
    [anon_sym_where] = ACTIONS(1248),
    [anon_sym_TILDE] = ACTIONS(1248),
    [anon_sym_end] = ACTIONS(1248),
    [anon_sym_if] = ACTIONS(1250),
    [anon_sym_ifdef] = ACTIONS(1248),
    [anon_sym_then] = ACTIONS(1248),
    [anon_sym_iftype] = ACTIONS(1248),
    [anon_sym_else] = ACTIONS(1248),
    [anon_sym_for] = ACTIONS(1248),
    [anon_sym_while] = ACTIONS(1248),
    [anon_sym_try] = ACTIONS(1248),
    [anon_sym_with] = ACTIONS(1248),
    [anon_sym_repeat] = ACTIONS(1248),
    [anon_sym_until] = ACTIONS(1248),
    [anon_sym_do] = ACTIONS(1248),
    [anon_sym_recover] = ACTIONS(1248),
    [anon_sym_match] = ACTIONS(1248),
    [anon_sym_return] = ACTIONS(1248),
    [anon_sym_continue] = ACTIONS(1248),
    [anon_sym_break] = ACTIONS(1248),
    [anon_sym_consume] = ACTIONS(1248),
    [anon_sym_object] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_float] = ACTIONS(1248),
    [anon_sym_DQUOTE] = ACTIONS(1250),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_true] = ACTIONS(1248),
    [anon_sym_false] = ACTIONS(1248),
    [sym_this] = ACTIONS(1248),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [349] = {
    [sym_identifier] = ACTIONS(1174),
    [anon_sym_EQ] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(1172),
    [anon_sym_LBRACK] = ACTIONS(1172),
    [anon_sym_RBRACK] = ACTIONS(1172),
    [anon_sym_is] = ACTIONS(1174),
    [anon_sym_embed] = ACTIONS(1172),
    [anon_sym_let] = ACTIONS(1172),
    [anon_sym_var] = ACTIONS(1172),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_EQ_GT] = ACTIONS(1172),
    [anon_sym_fun] = ACTIONS(1172),
    [anon_sym_be] = ACTIONS(1172),
    [anon_sym_COMMA] = ACTIONS(1172),
    [anon_sym_LPAREN] = ACTIONS(1174),
    [anon_sym_RPAREN] = ACTIONS(1172),
    [anon_sym_DOT] = ACTIONS(1174),
    [anon_sym_PIPE] = ACTIONS(1172),
    [anon_sym_LBRACE] = ACTIONS(1172),
    [anon_sym_RBRACE] = ACTIONS(1172),
    [anon_sym_SEMI] = ACTIONS(1172),
    [sym_error] = ACTIONS(1172),
    [sym_compile_intrinsic] = ACTIONS(1172),
    [anon_sym_compile_error] = ACTIONS(1172),
    [sym_location] = ACTIONS(1172),
    [anon_sym_DASH] = ACTIONS(1174),
    [anon_sym_not] = ACTIONS(1172),
    [anon_sym_DASH_TILDE] = ACTIONS(1172),
    [anon_sym_addressof] = ACTIONS(1172),
    [anon_sym_digestof] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(1174),
    [anon_sym_STAR] = ACTIONS(1174),
    [anon_sym_SLASH] = ACTIONS(1174),
    [anon_sym_PERCENT] = ACTIONS(1174),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1174),
    [anon_sym_LT_LT] = ACTIONS(1174),
    [anon_sym_GT_GT] = ACTIONS(1174),
    [anon_sym_and] = ACTIONS(1172),
    [anon_sym_or] = ACTIONS(1172),
    [anon_sym_xor] = ACTIONS(1172),
    [anon_sym_isnt] = ACTIONS(1172),
    [anon_sym_EQ_EQ] = ACTIONS(1174),
    [anon_sym_BANG_EQ] = ACTIONS(1174),
    [anon_sym_GT] = ACTIONS(1174),
    [anon_sym_GT_EQ] = ACTIONS(1174),
    [anon_sym_LT_EQ] = ACTIONS(1174),
    [anon_sym_LT] = ACTIONS(1174),
    [anon_sym_PLUS_TILDE] = ACTIONS(1172),
    [anon_sym_STAR_TILDE] = ACTIONS(1172),
    [anon_sym_SLASH_TILDE] = ACTIONS(1172),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1172),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1172),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1172),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1172),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1172),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1172),
    [anon_sym_GT_TILDE] = ACTIONS(1172),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1172),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1172),
    [anon_sym_LT_TILDE] = ACTIONS(1172),
    [anon_sym_PLUS_QMARK] = ACTIONS(1172),
    [anon_sym_DASH_QMARK] = ACTIONS(1172),
    [anon_sym_STAR_QMARK] = ACTIONS(1172),
    [anon_sym_SLASH_QMARK] = ACTIONS(1172),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1172),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1172),
    [anon_sym_as] = ACTIONS(1172),
    [anon_sym_LPAREN2] = ACTIONS(1172),
    [anon_sym_DOT_GT] = ACTIONS(1172),
    [anon_sym_where] = ACTIONS(1172),
    [anon_sym_TILDE] = ACTIONS(1172),
    [anon_sym_end] = ACTIONS(1172),
    [anon_sym_if] = ACTIONS(1174),
    [anon_sym_ifdef] = ACTIONS(1172),
    [anon_sym_then] = ACTIONS(1172),
    [anon_sym_iftype] = ACTIONS(1172),
    [anon_sym_else] = ACTIONS(1172),
    [anon_sym_for] = ACTIONS(1172),
    [anon_sym_while] = ACTIONS(1172),
    [anon_sym_try] = ACTIONS(1172),
    [anon_sym_with] = ACTIONS(1172),
    [anon_sym_repeat] = ACTIONS(1172),
    [anon_sym_until] = ACTIONS(1172),
    [anon_sym_do] = ACTIONS(1172),
    [anon_sym_recover] = ACTIONS(1172),
    [anon_sym_match] = ACTIONS(1172),
    [anon_sym_return] = ACTIONS(1172),
    [anon_sym_continue] = ACTIONS(1172),
    [anon_sym_break] = ACTIONS(1172),
    [anon_sym_consume] = ACTIONS(1172),
    [anon_sym_object] = ACTIONS(1172),
    [sym_number] = ACTIONS(1174),
    [sym_float] = ACTIONS(1172),
    [anon_sym_DQUOTE] = ACTIONS(1174),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1172),
    [anon_sym_SQUOTE] = ACTIONS(1172),
    [anon_sym_true] = ACTIONS(1172),
    [anon_sym_false] = ACTIONS(1172),
    [sym_this] = ACTIONS(1172),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [350] = {
    [sym_identifier] = ACTIONS(1242),
    [anon_sym_EQ] = ACTIONS(1242),
    [anon_sym_AT] = ACTIONS(1240),
    [anon_sym_LBRACK] = ACTIONS(1240),
    [anon_sym_RBRACK] = ACTIONS(1240),
    [anon_sym_is] = ACTIONS(1242),
    [anon_sym_embed] = ACTIONS(1240),
    [anon_sym_let] = ACTIONS(1240),
    [anon_sym_var] = ACTIONS(1240),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_EQ_GT] = ACTIONS(1240),
    [anon_sym_fun] = ACTIONS(1240),
    [anon_sym_be] = ACTIONS(1240),
    [anon_sym_COMMA] = ACTIONS(1240),
    [anon_sym_LPAREN] = ACTIONS(1242),
    [anon_sym_RPAREN] = ACTIONS(1240),
    [anon_sym_DOT] = ACTIONS(1242),
    [anon_sym_PIPE] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(1240),
    [anon_sym_RBRACE] = ACTIONS(1240),
    [anon_sym_SEMI] = ACTIONS(1240),
    [sym_error] = ACTIONS(1240),
    [sym_compile_intrinsic] = ACTIONS(1240),
    [anon_sym_compile_error] = ACTIONS(1240),
    [sym_location] = ACTIONS(1240),
    [anon_sym_DASH] = ACTIONS(1242),
    [anon_sym_not] = ACTIONS(1240),
    [anon_sym_DASH_TILDE] = ACTIONS(1240),
    [anon_sym_addressof] = ACTIONS(1240),
    [anon_sym_digestof] = ACTIONS(1240),
    [anon_sym_PLUS] = ACTIONS(1242),
    [anon_sym_STAR] = ACTIONS(1242),
    [anon_sym_SLASH] = ACTIONS(1242),
    [anon_sym_PERCENT] = ACTIONS(1242),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1242),
    [anon_sym_LT_LT] = ACTIONS(1242),
    [anon_sym_GT_GT] = ACTIONS(1242),
    [anon_sym_and] = ACTIONS(1240),
    [anon_sym_or] = ACTIONS(1240),
    [anon_sym_xor] = ACTIONS(1240),
    [anon_sym_isnt] = ACTIONS(1240),
    [anon_sym_EQ_EQ] = ACTIONS(1242),
    [anon_sym_BANG_EQ] = ACTIONS(1242),
    [anon_sym_GT] = ACTIONS(1242),
    [anon_sym_GT_EQ] = ACTIONS(1242),
    [anon_sym_LT_EQ] = ACTIONS(1242),
    [anon_sym_LT] = ACTIONS(1242),
    [anon_sym_PLUS_TILDE] = ACTIONS(1240),
    [anon_sym_STAR_TILDE] = ACTIONS(1240),
    [anon_sym_SLASH_TILDE] = ACTIONS(1240),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1240),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1240),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1240),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1240),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1240),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1240),
    [anon_sym_GT_TILDE] = ACTIONS(1240),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1240),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1240),
    [anon_sym_LT_TILDE] = ACTIONS(1240),
    [anon_sym_PLUS_QMARK] = ACTIONS(1240),
    [anon_sym_DASH_QMARK] = ACTIONS(1240),
    [anon_sym_STAR_QMARK] = ACTIONS(1240),
    [anon_sym_SLASH_QMARK] = ACTIONS(1240),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1240),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1240),
    [anon_sym_as] = ACTIONS(1240),
    [anon_sym_LPAREN2] = ACTIONS(1240),
    [anon_sym_DOT_GT] = ACTIONS(1240),
    [anon_sym_where] = ACTIONS(1240),
    [anon_sym_TILDE] = ACTIONS(1240),
    [anon_sym_end] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(1242),
    [anon_sym_ifdef] = ACTIONS(1240),
    [anon_sym_then] = ACTIONS(1240),
    [anon_sym_iftype] = ACTIONS(1240),
    [anon_sym_else] = ACTIONS(1240),
    [anon_sym_for] = ACTIONS(1240),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_try] = ACTIONS(1240),
    [anon_sym_with] = ACTIONS(1240),
    [anon_sym_repeat] = ACTIONS(1240),
    [anon_sym_until] = ACTIONS(1240),
    [anon_sym_do] = ACTIONS(1240),
    [anon_sym_recover] = ACTIONS(1240),
    [anon_sym_match] = ACTIONS(1240),
    [anon_sym_return] = ACTIONS(1240),
    [anon_sym_continue] = ACTIONS(1240),
    [anon_sym_break] = ACTIONS(1240),
    [anon_sym_consume] = ACTIONS(1240),
    [anon_sym_object] = ACTIONS(1240),
    [sym_number] = ACTIONS(1242),
    [sym_float] = ACTIONS(1240),
    [anon_sym_DQUOTE] = ACTIONS(1242),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1240),
    [anon_sym_true] = ACTIONS(1240),
    [anon_sym_false] = ACTIONS(1240),
    [sym_this] = ACTIONS(1240),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [351] = {
    [sym_identifier] = ACTIONS(1206),
    [anon_sym_EQ] = ACTIONS(1206),
    [anon_sym_AT] = ACTIONS(1204),
    [anon_sym_LBRACK] = ACTIONS(1204),
    [anon_sym_RBRACK] = ACTIONS(1204),
    [anon_sym_is] = ACTIONS(1206),
    [anon_sym_embed] = ACTIONS(1204),
    [anon_sym_let] = ACTIONS(1204),
    [anon_sym_var] = ACTIONS(1204),
    [anon_sym_new] = ACTIONS(1204),
    [anon_sym_EQ_GT] = ACTIONS(1204),
    [anon_sym_fun] = ACTIONS(1204),
    [anon_sym_be] = ACTIONS(1204),
    [anon_sym_COMMA] = ACTIONS(1204),
    [anon_sym_LPAREN] = ACTIONS(1206),
    [anon_sym_RPAREN] = ACTIONS(1204),
    [anon_sym_DOT] = ACTIONS(1206),
    [anon_sym_PIPE] = ACTIONS(1204),
    [anon_sym_LBRACE] = ACTIONS(1204),
    [anon_sym_RBRACE] = ACTIONS(1204),
    [anon_sym_SEMI] = ACTIONS(1204),
    [sym_error] = ACTIONS(1204),
    [sym_compile_intrinsic] = ACTIONS(1204),
    [anon_sym_compile_error] = ACTIONS(1204),
    [sym_location] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1206),
    [anon_sym_not] = ACTIONS(1204),
    [anon_sym_DASH_TILDE] = ACTIONS(1204),
    [anon_sym_addressof] = ACTIONS(1204),
    [anon_sym_digestof] = ACTIONS(1204),
    [anon_sym_PLUS] = ACTIONS(1206),
    [anon_sym_STAR] = ACTIONS(1206),
    [anon_sym_SLASH] = ACTIONS(1206),
    [anon_sym_PERCENT] = ACTIONS(1206),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1206),
    [anon_sym_LT_LT] = ACTIONS(1206),
    [anon_sym_GT_GT] = ACTIONS(1206),
    [anon_sym_and] = ACTIONS(1204),
    [anon_sym_or] = ACTIONS(1204),
    [anon_sym_xor] = ACTIONS(1204),
    [anon_sym_isnt] = ACTIONS(1204),
    [anon_sym_EQ_EQ] = ACTIONS(1206),
    [anon_sym_BANG_EQ] = ACTIONS(1206),
    [anon_sym_GT] = ACTIONS(1206),
    [anon_sym_GT_EQ] = ACTIONS(1206),
    [anon_sym_LT_EQ] = ACTIONS(1206),
    [anon_sym_LT] = ACTIONS(1206),
    [anon_sym_PLUS_TILDE] = ACTIONS(1204),
    [anon_sym_STAR_TILDE] = ACTIONS(1204),
    [anon_sym_SLASH_TILDE] = ACTIONS(1204),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1204),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1204),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1204),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1204),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1204),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1204),
    [anon_sym_GT_TILDE] = ACTIONS(1204),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1204),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1204),
    [anon_sym_LT_TILDE] = ACTIONS(1204),
    [anon_sym_PLUS_QMARK] = ACTIONS(1204),
    [anon_sym_DASH_QMARK] = ACTIONS(1204),
    [anon_sym_STAR_QMARK] = ACTIONS(1204),
    [anon_sym_SLASH_QMARK] = ACTIONS(1204),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1204),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1204),
    [anon_sym_as] = ACTIONS(1204),
    [anon_sym_LPAREN2] = ACTIONS(1204),
    [anon_sym_DOT_GT] = ACTIONS(1204),
    [anon_sym_where] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1204),
    [anon_sym_end] = ACTIONS(1204),
    [anon_sym_if] = ACTIONS(1206),
    [anon_sym_ifdef] = ACTIONS(1204),
    [anon_sym_then] = ACTIONS(1204),
    [anon_sym_iftype] = ACTIONS(1204),
    [anon_sym_else] = ACTIONS(1204),
    [anon_sym_for] = ACTIONS(1204),
    [anon_sym_while] = ACTIONS(1204),
    [anon_sym_try] = ACTIONS(1204),
    [anon_sym_with] = ACTIONS(1204),
    [anon_sym_repeat] = ACTIONS(1204),
    [anon_sym_until] = ACTIONS(1204),
    [anon_sym_do] = ACTIONS(1204),
    [anon_sym_recover] = ACTIONS(1204),
    [anon_sym_match] = ACTIONS(1204),
    [anon_sym_return] = ACTIONS(1204),
    [anon_sym_continue] = ACTIONS(1204),
    [anon_sym_break] = ACTIONS(1204),
    [anon_sym_consume] = ACTIONS(1204),
    [anon_sym_object] = ACTIONS(1204),
    [sym_number] = ACTIONS(1206),
    [sym_float] = ACTIONS(1204),
    [anon_sym_DQUOTE] = ACTIONS(1206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1204),
    [anon_sym_SQUOTE] = ACTIONS(1204),
    [anon_sym_true] = ACTIONS(1204),
    [anon_sym_false] = ACTIONS(1204),
    [sym_this] = ACTIONS(1204),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [352] = {
    [sym_identifier] = ACTIONS(1210),
    [anon_sym_EQ] = ACTIONS(1210),
    [anon_sym_AT] = ACTIONS(1208),
    [anon_sym_LBRACK] = ACTIONS(1208),
    [anon_sym_RBRACK] = ACTIONS(1208),
    [anon_sym_is] = ACTIONS(1210),
    [anon_sym_embed] = ACTIONS(1208),
    [anon_sym_let] = ACTIONS(1208),
    [anon_sym_var] = ACTIONS(1208),
    [anon_sym_new] = ACTIONS(1208),
    [anon_sym_EQ_GT] = ACTIONS(1208),
    [anon_sym_fun] = ACTIONS(1208),
    [anon_sym_be] = ACTIONS(1208),
    [anon_sym_COMMA] = ACTIONS(1208),
    [anon_sym_LPAREN] = ACTIONS(1210),
    [anon_sym_RPAREN] = ACTIONS(1208),
    [anon_sym_DOT] = ACTIONS(1210),
    [anon_sym_PIPE] = ACTIONS(1208),
    [anon_sym_LBRACE] = ACTIONS(1208),
    [anon_sym_RBRACE] = ACTIONS(1208),
    [anon_sym_SEMI] = ACTIONS(1208),
    [sym_error] = ACTIONS(1208),
    [sym_compile_intrinsic] = ACTIONS(1208),
    [anon_sym_compile_error] = ACTIONS(1208),
    [sym_location] = ACTIONS(1208),
    [anon_sym_DASH] = ACTIONS(1210),
    [anon_sym_not] = ACTIONS(1208),
    [anon_sym_DASH_TILDE] = ACTIONS(1208),
    [anon_sym_addressof] = ACTIONS(1208),
    [anon_sym_digestof] = ACTIONS(1208),
    [anon_sym_PLUS] = ACTIONS(1210),
    [anon_sym_STAR] = ACTIONS(1210),
    [anon_sym_SLASH] = ACTIONS(1210),
    [anon_sym_PERCENT] = ACTIONS(1210),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1210),
    [anon_sym_LT_LT] = ACTIONS(1210),
    [anon_sym_GT_GT] = ACTIONS(1210),
    [anon_sym_and] = ACTIONS(1208),
    [anon_sym_or] = ACTIONS(1208),
    [anon_sym_xor] = ACTIONS(1208),
    [anon_sym_isnt] = ACTIONS(1208),
    [anon_sym_EQ_EQ] = ACTIONS(1210),
    [anon_sym_BANG_EQ] = ACTIONS(1210),
    [anon_sym_GT] = ACTIONS(1210),
    [anon_sym_GT_EQ] = ACTIONS(1210),
    [anon_sym_LT_EQ] = ACTIONS(1210),
    [anon_sym_LT] = ACTIONS(1210),
    [anon_sym_PLUS_TILDE] = ACTIONS(1208),
    [anon_sym_STAR_TILDE] = ACTIONS(1208),
    [anon_sym_SLASH_TILDE] = ACTIONS(1208),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1208),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1208),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1208),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1208),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1208),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1208),
    [anon_sym_GT_TILDE] = ACTIONS(1208),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1208),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1208),
    [anon_sym_LT_TILDE] = ACTIONS(1208),
    [anon_sym_PLUS_QMARK] = ACTIONS(1208),
    [anon_sym_DASH_QMARK] = ACTIONS(1208),
    [anon_sym_STAR_QMARK] = ACTIONS(1208),
    [anon_sym_SLASH_QMARK] = ACTIONS(1208),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1208),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1208),
    [anon_sym_as] = ACTIONS(1208),
    [anon_sym_LPAREN2] = ACTIONS(1208),
    [anon_sym_DOT_GT] = ACTIONS(1208),
    [anon_sym_where] = ACTIONS(1208),
    [anon_sym_TILDE] = ACTIONS(1208),
    [anon_sym_end] = ACTIONS(1208),
    [anon_sym_if] = ACTIONS(1210),
    [anon_sym_ifdef] = ACTIONS(1208),
    [anon_sym_then] = ACTIONS(1208),
    [anon_sym_iftype] = ACTIONS(1208),
    [anon_sym_else] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1208),
    [anon_sym_while] = ACTIONS(1208),
    [anon_sym_try] = ACTIONS(1208),
    [anon_sym_with] = ACTIONS(1208),
    [anon_sym_repeat] = ACTIONS(1208),
    [anon_sym_until] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1208),
    [anon_sym_recover] = ACTIONS(1208),
    [anon_sym_match] = ACTIONS(1208),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_continue] = ACTIONS(1208),
    [anon_sym_break] = ACTIONS(1208),
    [anon_sym_consume] = ACTIONS(1208),
    [anon_sym_object] = ACTIONS(1208),
    [sym_number] = ACTIONS(1210),
    [sym_float] = ACTIONS(1208),
    [anon_sym_DQUOTE] = ACTIONS(1210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1208),
    [anon_sym_SQUOTE] = ACTIONS(1208),
    [anon_sym_true] = ACTIONS(1208),
    [anon_sym_false] = ACTIONS(1208),
    [sym_this] = ACTIONS(1208),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [353] = {
    [sym_identifier] = ACTIONS(1112),
    [anon_sym_EQ] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1110),
    [anon_sym_LBRACK] = ACTIONS(1110),
    [anon_sym_RBRACK] = ACTIONS(1110),
    [anon_sym_is] = ACTIONS(1112),
    [anon_sym_embed] = ACTIONS(1110),
    [anon_sym_let] = ACTIONS(1110),
    [anon_sym_var] = ACTIONS(1110),
    [anon_sym_new] = ACTIONS(1110),
    [anon_sym_EQ_GT] = ACTIONS(1110),
    [anon_sym_fun] = ACTIONS(1110),
    [anon_sym_be] = ACTIONS(1110),
    [anon_sym_COMMA] = ACTIONS(1110),
    [anon_sym_LPAREN] = ACTIONS(1112),
    [anon_sym_RPAREN] = ACTIONS(1110),
    [anon_sym_DOT] = ACTIONS(1112),
    [anon_sym_PIPE] = ACTIONS(1110),
    [anon_sym_LBRACE] = ACTIONS(1110),
    [anon_sym_RBRACE] = ACTIONS(1110),
    [anon_sym_SEMI] = ACTIONS(1110),
    [sym_error] = ACTIONS(1110),
    [sym_compile_intrinsic] = ACTIONS(1110),
    [anon_sym_compile_error] = ACTIONS(1110),
    [sym_location] = ACTIONS(1110),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_not] = ACTIONS(1110),
    [anon_sym_DASH_TILDE] = ACTIONS(1110),
    [anon_sym_addressof] = ACTIONS(1110),
    [anon_sym_digestof] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1112),
    [anon_sym_PERCENT] = ACTIONS(1112),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1112),
    [anon_sym_LT_LT] = ACTIONS(1112),
    [anon_sym_GT_GT] = ACTIONS(1112),
    [anon_sym_and] = ACTIONS(1110),
    [anon_sym_or] = ACTIONS(1110),
    [anon_sym_xor] = ACTIONS(1110),
    [anon_sym_isnt] = ACTIONS(1110),
    [anon_sym_EQ_EQ] = ACTIONS(1112),
    [anon_sym_BANG_EQ] = ACTIONS(1112),
    [anon_sym_GT] = ACTIONS(1112),
    [anon_sym_GT_EQ] = ACTIONS(1112),
    [anon_sym_LT_EQ] = ACTIONS(1112),
    [anon_sym_LT] = ACTIONS(1112),
    [anon_sym_PLUS_TILDE] = ACTIONS(1110),
    [anon_sym_STAR_TILDE] = ACTIONS(1110),
    [anon_sym_SLASH_TILDE] = ACTIONS(1110),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1110),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1110),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1110),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1110),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1110),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1110),
    [anon_sym_GT_TILDE] = ACTIONS(1110),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1110),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1110),
    [anon_sym_LT_TILDE] = ACTIONS(1110),
    [anon_sym_PLUS_QMARK] = ACTIONS(1110),
    [anon_sym_DASH_QMARK] = ACTIONS(1110),
    [anon_sym_STAR_QMARK] = ACTIONS(1110),
    [anon_sym_SLASH_QMARK] = ACTIONS(1110),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1110),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1110),
    [anon_sym_as] = ACTIONS(1110),
    [anon_sym_LPAREN2] = ACTIONS(1110),
    [anon_sym_DOT_GT] = ACTIONS(1110),
    [anon_sym_where] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(1110),
    [anon_sym_end] = ACTIONS(1110),
    [anon_sym_if] = ACTIONS(1112),
    [anon_sym_ifdef] = ACTIONS(1110),
    [anon_sym_then] = ACTIONS(1110),
    [anon_sym_iftype] = ACTIONS(1110),
    [anon_sym_else] = ACTIONS(1110),
    [anon_sym_for] = ACTIONS(1110),
    [anon_sym_while] = ACTIONS(1110),
    [anon_sym_try] = ACTIONS(1110),
    [anon_sym_with] = ACTIONS(1110),
    [anon_sym_repeat] = ACTIONS(1110),
    [anon_sym_until] = ACTIONS(1110),
    [anon_sym_do] = ACTIONS(1110),
    [anon_sym_recover] = ACTIONS(1110),
    [anon_sym_match] = ACTIONS(1110),
    [anon_sym_return] = ACTIONS(1110),
    [anon_sym_continue] = ACTIONS(1110),
    [anon_sym_break] = ACTIONS(1110),
    [anon_sym_consume] = ACTIONS(1110),
    [anon_sym_object] = ACTIONS(1110),
    [sym_number] = ACTIONS(1112),
    [sym_float] = ACTIONS(1110),
    [anon_sym_DQUOTE] = ACTIONS(1112),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1110),
    [anon_sym_SQUOTE] = ACTIONS(1110),
    [anon_sym_true] = ACTIONS(1110),
    [anon_sym_false] = ACTIONS(1110),
    [sym_this] = ACTIONS(1110),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [354] = {
    [sym_identifier] = ACTIONS(1116),
    [anon_sym_EQ] = ACTIONS(1116),
    [anon_sym_AT] = ACTIONS(1114),
    [anon_sym_LBRACK] = ACTIONS(1114),
    [anon_sym_RBRACK] = ACTIONS(1114),
    [anon_sym_is] = ACTIONS(1116),
    [anon_sym_embed] = ACTIONS(1114),
    [anon_sym_let] = ACTIONS(1114),
    [anon_sym_var] = ACTIONS(1114),
    [anon_sym_new] = ACTIONS(1114),
    [anon_sym_EQ_GT] = ACTIONS(1114),
    [anon_sym_fun] = ACTIONS(1114),
    [anon_sym_be] = ACTIONS(1114),
    [anon_sym_COMMA] = ACTIONS(1114),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_RPAREN] = ACTIONS(1114),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_PIPE] = ACTIONS(1114),
    [anon_sym_LBRACE] = ACTIONS(1114),
    [anon_sym_RBRACE] = ACTIONS(1114),
    [anon_sym_SEMI] = ACTIONS(1114),
    [sym_error] = ACTIONS(1114),
    [sym_compile_intrinsic] = ACTIONS(1114),
    [anon_sym_compile_error] = ACTIONS(1114),
    [sym_location] = ACTIONS(1114),
    [anon_sym_DASH] = ACTIONS(1116),
    [anon_sym_not] = ACTIONS(1114),
    [anon_sym_DASH_TILDE] = ACTIONS(1114),
    [anon_sym_addressof] = ACTIONS(1114),
    [anon_sym_digestof] = ACTIONS(1114),
    [anon_sym_PLUS] = ACTIONS(1116),
    [anon_sym_STAR] = ACTIONS(1116),
    [anon_sym_SLASH] = ACTIONS(1116),
    [anon_sym_PERCENT] = ACTIONS(1116),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1116),
    [anon_sym_LT_LT] = ACTIONS(1116),
    [anon_sym_GT_GT] = ACTIONS(1116),
    [anon_sym_and] = ACTIONS(1114),
    [anon_sym_or] = ACTIONS(1114),
    [anon_sym_xor] = ACTIONS(1114),
    [anon_sym_isnt] = ACTIONS(1114),
    [anon_sym_EQ_EQ] = ACTIONS(1116),
    [anon_sym_BANG_EQ] = ACTIONS(1116),
    [anon_sym_GT] = ACTIONS(1116),
    [anon_sym_GT_EQ] = ACTIONS(1116),
    [anon_sym_LT_EQ] = ACTIONS(1116),
    [anon_sym_LT] = ACTIONS(1116),
    [anon_sym_PLUS_TILDE] = ACTIONS(1114),
    [anon_sym_STAR_TILDE] = ACTIONS(1114),
    [anon_sym_SLASH_TILDE] = ACTIONS(1114),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1114),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1114),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1114),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1114),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1114),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1114),
    [anon_sym_GT_TILDE] = ACTIONS(1114),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1114),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1114),
    [anon_sym_LT_TILDE] = ACTIONS(1114),
    [anon_sym_PLUS_QMARK] = ACTIONS(1114),
    [anon_sym_DASH_QMARK] = ACTIONS(1114),
    [anon_sym_STAR_QMARK] = ACTIONS(1114),
    [anon_sym_SLASH_QMARK] = ACTIONS(1114),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1114),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1114),
    [anon_sym_as] = ACTIONS(1114),
    [anon_sym_LPAREN2] = ACTIONS(1114),
    [anon_sym_DOT_GT] = ACTIONS(1114),
    [anon_sym_where] = ACTIONS(1114),
    [anon_sym_TILDE] = ACTIONS(1114),
    [anon_sym_end] = ACTIONS(1114),
    [anon_sym_if] = ACTIONS(1116),
    [anon_sym_ifdef] = ACTIONS(1114),
    [anon_sym_then] = ACTIONS(1114),
    [anon_sym_iftype] = ACTIONS(1114),
    [anon_sym_else] = ACTIONS(1114),
    [anon_sym_for] = ACTIONS(1114),
    [anon_sym_while] = ACTIONS(1114),
    [anon_sym_try] = ACTIONS(1114),
    [anon_sym_with] = ACTIONS(1114),
    [anon_sym_repeat] = ACTIONS(1114),
    [anon_sym_until] = ACTIONS(1114),
    [anon_sym_do] = ACTIONS(1114),
    [anon_sym_recover] = ACTIONS(1114),
    [anon_sym_match] = ACTIONS(1114),
    [anon_sym_return] = ACTIONS(1114),
    [anon_sym_continue] = ACTIONS(1114),
    [anon_sym_break] = ACTIONS(1114),
    [anon_sym_consume] = ACTIONS(1114),
    [anon_sym_object] = ACTIONS(1114),
    [sym_number] = ACTIONS(1116),
    [sym_float] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1114),
    [anon_sym_SQUOTE] = ACTIONS(1114),
    [anon_sym_true] = ACTIONS(1114),
    [anon_sym_false] = ACTIONS(1114),
    [sym_this] = ACTIONS(1114),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [355] = {
    [sym_identifier] = ACTIONS(851),
    [anon_sym_EQ] = ACTIONS(851),
    [anon_sym_AT] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(849),
    [anon_sym_RBRACK] = ACTIONS(849),
    [anon_sym_is] = ACTIONS(851),
    [anon_sym_embed] = ACTIONS(849),
    [anon_sym_let] = ACTIONS(849),
    [anon_sym_var] = ACTIONS(849),
    [anon_sym_new] = ACTIONS(849),
    [anon_sym_EQ_GT] = ACTIONS(849),
    [anon_sym_fun] = ACTIONS(849),
    [anon_sym_be] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_RPAREN] = ACTIONS(849),
    [anon_sym_DOT] = ACTIONS(851),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_LBRACE] = ACTIONS(849),
    [anon_sym_RBRACE] = ACTIONS(849),
    [anon_sym_SEMI] = ACTIONS(849),
    [sym_error] = ACTIONS(849),
    [sym_compile_intrinsic] = ACTIONS(849),
    [anon_sym_compile_error] = ACTIONS(849),
    [sym_location] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_not] = ACTIONS(849),
    [anon_sym_DASH_TILDE] = ACTIONS(849),
    [anon_sym_addressof] = ACTIONS(849),
    [anon_sym_digestof] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(851),
    [anon_sym_SLASH] = ACTIONS(851),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(851),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_GT_GT] = ACTIONS(851),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_isnt] = ACTIONS(849),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(851),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_LT] = ACTIONS(851),
    [anon_sym_PLUS_TILDE] = ACTIONS(849),
    [anon_sym_STAR_TILDE] = ACTIONS(849),
    [anon_sym_SLASH_TILDE] = ACTIONS(849),
    [anon_sym_PERCENT_TILDE] = ACTIONS(849),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(849),
    [anon_sym_LT_LT_TILDE] = ACTIONS(849),
    [anon_sym_GT_GT_TILDE] = ACTIONS(849),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(849),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(849),
    [anon_sym_GT_TILDE] = ACTIONS(849),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(849),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(849),
    [anon_sym_LT_TILDE] = ACTIONS(849),
    [anon_sym_PLUS_QMARK] = ACTIONS(849),
    [anon_sym_DASH_QMARK] = ACTIONS(849),
    [anon_sym_STAR_QMARK] = ACTIONS(849),
    [anon_sym_SLASH_QMARK] = ACTIONS(849),
    [anon_sym_PERCENT_QMARK] = ACTIONS(849),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(849),
    [anon_sym_as] = ACTIONS(849),
    [anon_sym_LPAREN2] = ACTIONS(849),
    [anon_sym_DOT_GT] = ACTIONS(849),
    [anon_sym_where] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(849),
    [anon_sym_end] = ACTIONS(849),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_ifdef] = ACTIONS(849),
    [anon_sym_then] = ACTIONS(849),
    [anon_sym_iftype] = ACTIONS(849),
    [anon_sym_else] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(849),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_try] = ACTIONS(849),
    [anon_sym_with] = ACTIONS(849),
    [anon_sym_repeat] = ACTIONS(849),
    [anon_sym_until] = ACTIONS(849),
    [anon_sym_do] = ACTIONS(849),
    [anon_sym_recover] = ACTIONS(849),
    [anon_sym_match] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_continue] = ACTIONS(849),
    [anon_sym_break] = ACTIONS(849),
    [anon_sym_consume] = ACTIONS(849),
    [anon_sym_object] = ACTIONS(849),
    [sym_number] = ACTIONS(851),
    [sym_float] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(851),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(849),
    [anon_sym_SQUOTE] = ACTIONS(849),
    [anon_sym_true] = ACTIONS(849),
    [anon_sym_false] = ACTIONS(849),
    [sym_this] = ACTIONS(849),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [356] = {
    [sym_identifier] = ACTIONS(1186),
    [anon_sym_EQ] = ACTIONS(1186),
    [anon_sym_AT] = ACTIONS(1184),
    [anon_sym_LBRACK] = ACTIONS(1184),
    [anon_sym_RBRACK] = ACTIONS(1184),
    [anon_sym_is] = ACTIONS(1186),
    [anon_sym_embed] = ACTIONS(1184),
    [anon_sym_let] = ACTIONS(1184),
    [anon_sym_var] = ACTIONS(1184),
    [anon_sym_new] = ACTIONS(1184),
    [anon_sym_EQ_GT] = ACTIONS(1184),
    [anon_sym_fun] = ACTIONS(1184),
    [anon_sym_be] = ACTIONS(1184),
    [anon_sym_COMMA] = ACTIONS(1184),
    [anon_sym_LPAREN] = ACTIONS(1186),
    [anon_sym_RPAREN] = ACTIONS(1184),
    [anon_sym_DOT] = ACTIONS(1186),
    [anon_sym_PIPE] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1184),
    [anon_sym_RBRACE] = ACTIONS(1184),
    [anon_sym_SEMI] = ACTIONS(1184),
    [sym_error] = ACTIONS(1184),
    [sym_compile_intrinsic] = ACTIONS(1184),
    [anon_sym_compile_error] = ACTIONS(1184),
    [sym_location] = ACTIONS(1184),
    [anon_sym_DASH] = ACTIONS(1186),
    [anon_sym_not] = ACTIONS(1184),
    [anon_sym_DASH_TILDE] = ACTIONS(1184),
    [anon_sym_addressof] = ACTIONS(1184),
    [anon_sym_digestof] = ACTIONS(1184),
    [anon_sym_PLUS] = ACTIONS(1186),
    [anon_sym_STAR] = ACTIONS(1186),
    [anon_sym_SLASH] = ACTIONS(1186),
    [anon_sym_PERCENT] = ACTIONS(1186),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1186),
    [anon_sym_LT_LT] = ACTIONS(1186),
    [anon_sym_GT_GT] = ACTIONS(1186),
    [anon_sym_and] = ACTIONS(1184),
    [anon_sym_or] = ACTIONS(1184),
    [anon_sym_xor] = ACTIONS(1184),
    [anon_sym_isnt] = ACTIONS(1184),
    [anon_sym_EQ_EQ] = ACTIONS(1186),
    [anon_sym_BANG_EQ] = ACTIONS(1186),
    [anon_sym_GT] = ACTIONS(1186),
    [anon_sym_GT_EQ] = ACTIONS(1186),
    [anon_sym_LT_EQ] = ACTIONS(1186),
    [anon_sym_LT] = ACTIONS(1186),
    [anon_sym_PLUS_TILDE] = ACTIONS(1184),
    [anon_sym_STAR_TILDE] = ACTIONS(1184),
    [anon_sym_SLASH_TILDE] = ACTIONS(1184),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1184),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1184),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1184),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1184),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1184),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1184),
    [anon_sym_GT_TILDE] = ACTIONS(1184),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1184),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1184),
    [anon_sym_LT_TILDE] = ACTIONS(1184),
    [anon_sym_PLUS_QMARK] = ACTIONS(1184),
    [anon_sym_DASH_QMARK] = ACTIONS(1184),
    [anon_sym_STAR_QMARK] = ACTIONS(1184),
    [anon_sym_SLASH_QMARK] = ACTIONS(1184),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1184),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1184),
    [anon_sym_as] = ACTIONS(1184),
    [anon_sym_LPAREN2] = ACTIONS(1184),
    [anon_sym_DOT_GT] = ACTIONS(1184),
    [anon_sym_where] = ACTIONS(1184),
    [anon_sym_TILDE] = ACTIONS(1184),
    [anon_sym_end] = ACTIONS(1184),
    [anon_sym_if] = ACTIONS(1186),
    [anon_sym_ifdef] = ACTIONS(1184),
    [anon_sym_then] = ACTIONS(1184),
    [anon_sym_iftype] = ACTIONS(1184),
    [anon_sym_else] = ACTIONS(1184),
    [anon_sym_for] = ACTIONS(1184),
    [anon_sym_while] = ACTIONS(1184),
    [anon_sym_try] = ACTIONS(1184),
    [anon_sym_with] = ACTIONS(1184),
    [anon_sym_repeat] = ACTIONS(1184),
    [anon_sym_until] = ACTIONS(1184),
    [anon_sym_do] = ACTIONS(1184),
    [anon_sym_recover] = ACTIONS(1184),
    [anon_sym_match] = ACTIONS(1184),
    [anon_sym_return] = ACTIONS(1184),
    [anon_sym_continue] = ACTIONS(1184),
    [anon_sym_break] = ACTIONS(1184),
    [anon_sym_consume] = ACTIONS(1184),
    [anon_sym_object] = ACTIONS(1184),
    [sym_number] = ACTIONS(1186),
    [sym_float] = ACTIONS(1184),
    [anon_sym_DQUOTE] = ACTIONS(1186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1184),
    [anon_sym_SQUOTE] = ACTIONS(1184),
    [anon_sym_true] = ACTIONS(1184),
    [anon_sym_false] = ACTIONS(1184),
    [sym_this] = ACTIONS(1184),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [357] = {
    [sym_identifier] = ACTIONS(1144),
    [anon_sym_EQ] = ACTIONS(1144),
    [anon_sym_AT] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_RBRACK] = ACTIONS(1142),
    [anon_sym_is] = ACTIONS(1144),
    [anon_sym_embed] = ACTIONS(1142),
    [anon_sym_let] = ACTIONS(1142),
    [anon_sym_var] = ACTIONS(1142),
    [anon_sym_new] = ACTIONS(1142),
    [anon_sym_EQ_GT] = ACTIONS(1142),
    [anon_sym_fun] = ACTIONS(1142),
    [anon_sym_be] = ACTIONS(1142),
    [anon_sym_COMMA] = ACTIONS(1142),
    [anon_sym_LPAREN] = ACTIONS(1144),
    [anon_sym_RPAREN] = ACTIONS(1142),
    [anon_sym_DOT] = ACTIONS(1144),
    [anon_sym_PIPE] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1142),
    [anon_sym_RBRACE] = ACTIONS(1142),
    [anon_sym_SEMI] = ACTIONS(1142),
    [sym_error] = ACTIONS(1142),
    [sym_compile_intrinsic] = ACTIONS(1142),
    [anon_sym_compile_error] = ACTIONS(1142),
    [sym_location] = ACTIONS(1142),
    [anon_sym_DASH] = ACTIONS(1144),
    [anon_sym_not] = ACTIONS(1142),
    [anon_sym_DASH_TILDE] = ACTIONS(1142),
    [anon_sym_addressof] = ACTIONS(1142),
    [anon_sym_digestof] = ACTIONS(1142),
    [anon_sym_PLUS] = ACTIONS(1144),
    [anon_sym_STAR] = ACTIONS(1144),
    [anon_sym_SLASH] = ACTIONS(1144),
    [anon_sym_PERCENT] = ACTIONS(1144),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1144),
    [anon_sym_LT_LT] = ACTIONS(1144),
    [anon_sym_GT_GT] = ACTIONS(1144),
    [anon_sym_and] = ACTIONS(1142),
    [anon_sym_or] = ACTIONS(1142),
    [anon_sym_xor] = ACTIONS(1142),
    [anon_sym_isnt] = ACTIONS(1142),
    [anon_sym_EQ_EQ] = ACTIONS(1144),
    [anon_sym_BANG_EQ] = ACTIONS(1144),
    [anon_sym_GT] = ACTIONS(1144),
    [anon_sym_GT_EQ] = ACTIONS(1144),
    [anon_sym_LT_EQ] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(1144),
    [anon_sym_PLUS_TILDE] = ACTIONS(1142),
    [anon_sym_STAR_TILDE] = ACTIONS(1142),
    [anon_sym_SLASH_TILDE] = ACTIONS(1142),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1142),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1142),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1142),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1142),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1142),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1142),
    [anon_sym_GT_TILDE] = ACTIONS(1142),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1142),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1142),
    [anon_sym_LT_TILDE] = ACTIONS(1142),
    [anon_sym_PLUS_QMARK] = ACTIONS(1142),
    [anon_sym_DASH_QMARK] = ACTIONS(1142),
    [anon_sym_STAR_QMARK] = ACTIONS(1142),
    [anon_sym_SLASH_QMARK] = ACTIONS(1142),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1142),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1142),
    [anon_sym_as] = ACTIONS(1142),
    [anon_sym_LPAREN2] = ACTIONS(1142),
    [anon_sym_DOT_GT] = ACTIONS(1142),
    [anon_sym_where] = ACTIONS(1142),
    [anon_sym_TILDE] = ACTIONS(1142),
    [anon_sym_end] = ACTIONS(1142),
    [anon_sym_if] = ACTIONS(1144),
    [anon_sym_ifdef] = ACTIONS(1142),
    [anon_sym_then] = ACTIONS(1142),
    [anon_sym_iftype] = ACTIONS(1142),
    [anon_sym_else] = ACTIONS(1142),
    [anon_sym_for] = ACTIONS(1142),
    [anon_sym_while] = ACTIONS(1142),
    [anon_sym_try] = ACTIONS(1142),
    [anon_sym_with] = ACTIONS(1142),
    [anon_sym_repeat] = ACTIONS(1142),
    [anon_sym_until] = ACTIONS(1142),
    [anon_sym_do] = ACTIONS(1142),
    [anon_sym_recover] = ACTIONS(1142),
    [anon_sym_match] = ACTIONS(1142),
    [anon_sym_return] = ACTIONS(1142),
    [anon_sym_continue] = ACTIONS(1142),
    [anon_sym_break] = ACTIONS(1142),
    [anon_sym_consume] = ACTIONS(1142),
    [anon_sym_object] = ACTIONS(1142),
    [sym_number] = ACTIONS(1144),
    [sym_float] = ACTIONS(1142),
    [anon_sym_DQUOTE] = ACTIONS(1144),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1142),
    [anon_sym_SQUOTE] = ACTIONS(1142),
    [anon_sym_true] = ACTIONS(1142),
    [anon_sym_false] = ACTIONS(1142),
    [sym_this] = ACTIONS(1142),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [358] = {
    [sym_identifier] = ACTIONS(1202),
    [anon_sym_EQ] = ACTIONS(1202),
    [anon_sym_AT] = ACTIONS(1200),
    [anon_sym_LBRACK] = ACTIONS(1200),
    [anon_sym_RBRACK] = ACTIONS(1200),
    [anon_sym_is] = ACTIONS(1202),
    [anon_sym_embed] = ACTIONS(1200),
    [anon_sym_let] = ACTIONS(1200),
    [anon_sym_var] = ACTIONS(1200),
    [anon_sym_new] = ACTIONS(1200),
    [anon_sym_EQ_GT] = ACTIONS(1200),
    [anon_sym_fun] = ACTIONS(1200),
    [anon_sym_be] = ACTIONS(1200),
    [anon_sym_COMMA] = ACTIONS(1200),
    [anon_sym_LPAREN] = ACTIONS(1202),
    [anon_sym_RPAREN] = ACTIONS(1200),
    [anon_sym_DOT] = ACTIONS(1202),
    [anon_sym_PIPE] = ACTIONS(1200),
    [anon_sym_LBRACE] = ACTIONS(1200),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_SEMI] = ACTIONS(1200),
    [sym_error] = ACTIONS(1200),
    [sym_compile_intrinsic] = ACTIONS(1200),
    [anon_sym_compile_error] = ACTIONS(1200),
    [sym_location] = ACTIONS(1200),
    [anon_sym_DASH] = ACTIONS(1202),
    [anon_sym_not] = ACTIONS(1200),
    [anon_sym_DASH_TILDE] = ACTIONS(1200),
    [anon_sym_addressof] = ACTIONS(1200),
    [anon_sym_digestof] = ACTIONS(1200),
    [anon_sym_PLUS] = ACTIONS(1202),
    [anon_sym_STAR] = ACTIONS(1202),
    [anon_sym_SLASH] = ACTIONS(1202),
    [anon_sym_PERCENT] = ACTIONS(1202),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1202),
    [anon_sym_LT_LT] = ACTIONS(1202),
    [anon_sym_GT_GT] = ACTIONS(1202),
    [anon_sym_and] = ACTIONS(1200),
    [anon_sym_or] = ACTIONS(1200),
    [anon_sym_xor] = ACTIONS(1200),
    [anon_sym_isnt] = ACTIONS(1200),
    [anon_sym_EQ_EQ] = ACTIONS(1202),
    [anon_sym_BANG_EQ] = ACTIONS(1202),
    [anon_sym_GT] = ACTIONS(1202),
    [anon_sym_GT_EQ] = ACTIONS(1202),
    [anon_sym_LT_EQ] = ACTIONS(1202),
    [anon_sym_LT] = ACTIONS(1202),
    [anon_sym_PLUS_TILDE] = ACTIONS(1200),
    [anon_sym_STAR_TILDE] = ACTIONS(1200),
    [anon_sym_SLASH_TILDE] = ACTIONS(1200),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1200),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1200),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1200),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1200),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1200),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1200),
    [anon_sym_GT_TILDE] = ACTIONS(1200),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1200),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1200),
    [anon_sym_LT_TILDE] = ACTIONS(1200),
    [anon_sym_PLUS_QMARK] = ACTIONS(1200),
    [anon_sym_DASH_QMARK] = ACTIONS(1200),
    [anon_sym_STAR_QMARK] = ACTIONS(1200),
    [anon_sym_SLASH_QMARK] = ACTIONS(1200),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1200),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1200),
    [anon_sym_as] = ACTIONS(1200),
    [anon_sym_LPAREN2] = ACTIONS(1200),
    [anon_sym_DOT_GT] = ACTIONS(1200),
    [anon_sym_where] = ACTIONS(1200),
    [anon_sym_TILDE] = ACTIONS(1200),
    [anon_sym_end] = ACTIONS(1200),
    [anon_sym_if] = ACTIONS(1202),
    [anon_sym_ifdef] = ACTIONS(1200),
    [anon_sym_then] = ACTIONS(1200),
    [anon_sym_iftype] = ACTIONS(1200),
    [anon_sym_else] = ACTIONS(1200),
    [anon_sym_for] = ACTIONS(1200),
    [anon_sym_while] = ACTIONS(1200),
    [anon_sym_try] = ACTIONS(1200),
    [anon_sym_with] = ACTIONS(1200),
    [anon_sym_repeat] = ACTIONS(1200),
    [anon_sym_until] = ACTIONS(1200),
    [anon_sym_do] = ACTIONS(1200),
    [anon_sym_recover] = ACTIONS(1200),
    [anon_sym_match] = ACTIONS(1200),
    [anon_sym_return] = ACTIONS(1200),
    [anon_sym_continue] = ACTIONS(1200),
    [anon_sym_break] = ACTIONS(1200),
    [anon_sym_consume] = ACTIONS(1200),
    [anon_sym_object] = ACTIONS(1200),
    [sym_number] = ACTIONS(1202),
    [sym_float] = ACTIONS(1200),
    [anon_sym_DQUOTE] = ACTIONS(1202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1200),
    [anon_sym_SQUOTE] = ACTIONS(1200),
    [anon_sym_true] = ACTIONS(1200),
    [anon_sym_false] = ACTIONS(1200),
    [sym_this] = ACTIONS(1200),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [359] = {
    [sym_identifier] = ACTIONS(1198),
    [anon_sym_EQ] = ACTIONS(1198),
    [anon_sym_AT] = ACTIONS(1196),
    [anon_sym_LBRACK] = ACTIONS(1196),
    [anon_sym_RBRACK] = ACTIONS(1196),
    [anon_sym_is] = ACTIONS(1198),
    [anon_sym_embed] = ACTIONS(1196),
    [anon_sym_let] = ACTIONS(1196),
    [anon_sym_var] = ACTIONS(1196),
    [anon_sym_new] = ACTIONS(1196),
    [anon_sym_EQ_GT] = ACTIONS(1196),
    [anon_sym_fun] = ACTIONS(1196),
    [anon_sym_be] = ACTIONS(1196),
    [anon_sym_COMMA] = ACTIONS(1196),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_RPAREN] = ACTIONS(1196),
    [anon_sym_DOT] = ACTIONS(1198),
    [anon_sym_PIPE] = ACTIONS(1196),
    [anon_sym_LBRACE] = ACTIONS(1196),
    [anon_sym_RBRACE] = ACTIONS(1196),
    [anon_sym_SEMI] = ACTIONS(1196),
    [sym_error] = ACTIONS(1196),
    [sym_compile_intrinsic] = ACTIONS(1196),
    [anon_sym_compile_error] = ACTIONS(1196),
    [sym_location] = ACTIONS(1196),
    [anon_sym_DASH] = ACTIONS(1198),
    [anon_sym_not] = ACTIONS(1196),
    [anon_sym_DASH_TILDE] = ACTIONS(1196),
    [anon_sym_addressof] = ACTIONS(1196),
    [anon_sym_digestof] = ACTIONS(1196),
    [anon_sym_PLUS] = ACTIONS(1198),
    [anon_sym_STAR] = ACTIONS(1198),
    [anon_sym_SLASH] = ACTIONS(1198),
    [anon_sym_PERCENT] = ACTIONS(1198),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1198),
    [anon_sym_LT_LT] = ACTIONS(1198),
    [anon_sym_GT_GT] = ACTIONS(1198),
    [anon_sym_and] = ACTIONS(1196),
    [anon_sym_or] = ACTIONS(1196),
    [anon_sym_xor] = ACTIONS(1196),
    [anon_sym_isnt] = ACTIONS(1196),
    [anon_sym_EQ_EQ] = ACTIONS(1198),
    [anon_sym_BANG_EQ] = ACTIONS(1198),
    [anon_sym_GT] = ACTIONS(1198),
    [anon_sym_GT_EQ] = ACTIONS(1198),
    [anon_sym_LT_EQ] = ACTIONS(1198),
    [anon_sym_LT] = ACTIONS(1198),
    [anon_sym_PLUS_TILDE] = ACTIONS(1196),
    [anon_sym_STAR_TILDE] = ACTIONS(1196),
    [anon_sym_SLASH_TILDE] = ACTIONS(1196),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1196),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1196),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1196),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1196),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1196),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1196),
    [anon_sym_GT_TILDE] = ACTIONS(1196),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1196),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1196),
    [anon_sym_LT_TILDE] = ACTIONS(1196),
    [anon_sym_PLUS_QMARK] = ACTIONS(1196),
    [anon_sym_DASH_QMARK] = ACTIONS(1196),
    [anon_sym_STAR_QMARK] = ACTIONS(1196),
    [anon_sym_SLASH_QMARK] = ACTIONS(1196),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1196),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1196),
    [anon_sym_as] = ACTIONS(1196),
    [anon_sym_LPAREN2] = ACTIONS(1196),
    [anon_sym_DOT_GT] = ACTIONS(1196),
    [anon_sym_where] = ACTIONS(1196),
    [anon_sym_TILDE] = ACTIONS(1196),
    [anon_sym_end] = ACTIONS(1196),
    [anon_sym_if] = ACTIONS(1198),
    [anon_sym_ifdef] = ACTIONS(1196),
    [anon_sym_then] = ACTIONS(1196),
    [anon_sym_iftype] = ACTIONS(1196),
    [anon_sym_else] = ACTIONS(1196),
    [anon_sym_for] = ACTIONS(1196),
    [anon_sym_while] = ACTIONS(1196),
    [anon_sym_try] = ACTIONS(1196),
    [anon_sym_with] = ACTIONS(1196),
    [anon_sym_repeat] = ACTIONS(1196),
    [anon_sym_until] = ACTIONS(1196),
    [anon_sym_do] = ACTIONS(1196),
    [anon_sym_recover] = ACTIONS(1196),
    [anon_sym_match] = ACTIONS(1196),
    [anon_sym_return] = ACTIONS(1196),
    [anon_sym_continue] = ACTIONS(1196),
    [anon_sym_break] = ACTIONS(1196),
    [anon_sym_consume] = ACTIONS(1196),
    [anon_sym_object] = ACTIONS(1196),
    [sym_number] = ACTIONS(1198),
    [sym_float] = ACTIONS(1196),
    [anon_sym_DQUOTE] = ACTIONS(1198),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_SQUOTE] = ACTIONS(1196),
    [anon_sym_true] = ACTIONS(1196),
    [anon_sym_false] = ACTIONS(1196),
    [sym_this] = ACTIONS(1196),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [360] = {
    [sym_identifier] = ACTIONS(847),
    [anon_sym_EQ] = ACTIONS(847),
    [anon_sym_AT] = ACTIONS(845),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(845),
    [anon_sym_is] = ACTIONS(847),
    [anon_sym_embed] = ACTIONS(845),
    [anon_sym_let] = ACTIONS(845),
    [anon_sym_var] = ACTIONS(845),
    [anon_sym_new] = ACTIONS(845),
    [anon_sym_EQ_GT] = ACTIONS(845),
    [anon_sym_fun] = ACTIONS(845),
    [anon_sym_be] = ACTIONS(845),
    [anon_sym_COMMA] = ACTIONS(845),
    [anon_sym_LPAREN] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(845),
    [anon_sym_DOT] = ACTIONS(847),
    [anon_sym_PIPE] = ACTIONS(845),
    [anon_sym_LBRACE] = ACTIONS(845),
    [anon_sym_RBRACE] = ACTIONS(845),
    [anon_sym_SEMI] = ACTIONS(845),
    [sym_error] = ACTIONS(845),
    [sym_compile_intrinsic] = ACTIONS(845),
    [anon_sym_compile_error] = ACTIONS(845),
    [sym_location] = ACTIONS(845),
    [anon_sym_DASH] = ACTIONS(847),
    [anon_sym_not] = ACTIONS(845),
    [anon_sym_DASH_TILDE] = ACTIONS(845),
    [anon_sym_addressof] = ACTIONS(845),
    [anon_sym_digestof] = ACTIONS(845),
    [anon_sym_PLUS] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(847),
    [anon_sym_SLASH] = ACTIONS(847),
    [anon_sym_PERCENT] = ACTIONS(847),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(847),
    [anon_sym_LT_LT] = ACTIONS(847),
    [anon_sym_GT_GT] = ACTIONS(847),
    [anon_sym_and] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(845),
    [anon_sym_xor] = ACTIONS(845),
    [anon_sym_isnt] = ACTIONS(845),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_GT_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(847),
    [anon_sym_PLUS_TILDE] = ACTIONS(845),
    [anon_sym_STAR_TILDE] = ACTIONS(845),
    [anon_sym_SLASH_TILDE] = ACTIONS(845),
    [anon_sym_PERCENT_TILDE] = ACTIONS(845),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(845),
    [anon_sym_LT_LT_TILDE] = ACTIONS(845),
    [anon_sym_GT_GT_TILDE] = ACTIONS(845),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(845),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(845),
    [anon_sym_GT_TILDE] = ACTIONS(845),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(845),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(845),
    [anon_sym_LT_TILDE] = ACTIONS(845),
    [anon_sym_PLUS_QMARK] = ACTIONS(845),
    [anon_sym_DASH_QMARK] = ACTIONS(845),
    [anon_sym_STAR_QMARK] = ACTIONS(845),
    [anon_sym_SLASH_QMARK] = ACTIONS(845),
    [anon_sym_PERCENT_QMARK] = ACTIONS(845),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(845),
    [anon_sym_as] = ACTIONS(845),
    [anon_sym_LPAREN2] = ACTIONS(845),
    [anon_sym_DOT_GT] = ACTIONS(845),
    [anon_sym_where] = ACTIONS(845),
    [anon_sym_TILDE] = ACTIONS(845),
    [anon_sym_end] = ACTIONS(845),
    [anon_sym_if] = ACTIONS(847),
    [anon_sym_ifdef] = ACTIONS(845),
    [anon_sym_then] = ACTIONS(845),
    [anon_sym_iftype] = ACTIONS(845),
    [anon_sym_else] = ACTIONS(845),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(845),
    [anon_sym_try] = ACTIONS(845),
    [anon_sym_with] = ACTIONS(845),
    [anon_sym_repeat] = ACTIONS(845),
    [anon_sym_until] = ACTIONS(845),
    [anon_sym_do] = ACTIONS(845),
    [anon_sym_recover] = ACTIONS(845),
    [anon_sym_match] = ACTIONS(845),
    [anon_sym_return] = ACTIONS(845),
    [anon_sym_continue] = ACTIONS(845),
    [anon_sym_break] = ACTIONS(845),
    [anon_sym_consume] = ACTIONS(845),
    [anon_sym_object] = ACTIONS(845),
    [sym_number] = ACTIONS(847),
    [sym_float] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(845),
    [anon_sym_SQUOTE] = ACTIONS(845),
    [anon_sym_true] = ACTIONS(845),
    [anon_sym_false] = ACTIONS(845),
    [sym_this] = ACTIONS(845),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [361] = {
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_EQ] = ACTIONS(1234),
    [anon_sym_AT] = ACTIONS(1232),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACK] = ACTIONS(1232),
    [anon_sym_is] = ACTIONS(1234),
    [anon_sym_embed] = ACTIONS(1232),
    [anon_sym_let] = ACTIONS(1232),
    [anon_sym_var] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_EQ_GT] = ACTIONS(1232),
    [anon_sym_fun] = ACTIONS(1232),
    [anon_sym_be] = ACTIONS(1232),
    [anon_sym_COMMA] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_RPAREN] = ACTIONS(1232),
    [anon_sym_DOT] = ACTIONS(1234),
    [anon_sym_PIPE] = ACTIONS(1232),
    [anon_sym_LBRACE] = ACTIONS(1232),
    [anon_sym_RBRACE] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1232),
    [sym_error] = ACTIONS(1232),
    [sym_compile_intrinsic] = ACTIONS(1232),
    [anon_sym_compile_error] = ACTIONS(1232),
    [sym_location] = ACTIONS(1232),
    [anon_sym_DASH] = ACTIONS(1234),
    [anon_sym_not] = ACTIONS(1232),
    [anon_sym_DASH_TILDE] = ACTIONS(1232),
    [anon_sym_addressof] = ACTIONS(1232),
    [anon_sym_digestof] = ACTIONS(1232),
    [anon_sym_PLUS] = ACTIONS(1234),
    [anon_sym_STAR] = ACTIONS(1234),
    [anon_sym_SLASH] = ACTIONS(1234),
    [anon_sym_PERCENT] = ACTIONS(1234),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1234),
    [anon_sym_LT_LT] = ACTIONS(1234),
    [anon_sym_GT_GT] = ACTIONS(1234),
    [anon_sym_and] = ACTIONS(1232),
    [anon_sym_or] = ACTIONS(1232),
    [anon_sym_xor] = ACTIONS(1232),
    [anon_sym_isnt] = ACTIONS(1232),
    [anon_sym_EQ_EQ] = ACTIONS(1234),
    [anon_sym_BANG_EQ] = ACTIONS(1234),
    [anon_sym_GT] = ACTIONS(1234),
    [anon_sym_GT_EQ] = ACTIONS(1234),
    [anon_sym_LT_EQ] = ACTIONS(1234),
    [anon_sym_LT] = ACTIONS(1234),
    [anon_sym_PLUS_TILDE] = ACTIONS(1232),
    [anon_sym_STAR_TILDE] = ACTIONS(1232),
    [anon_sym_SLASH_TILDE] = ACTIONS(1232),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1232),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1232),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1232),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1232),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1232),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1232),
    [anon_sym_GT_TILDE] = ACTIONS(1232),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1232),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1232),
    [anon_sym_LT_TILDE] = ACTIONS(1232),
    [anon_sym_PLUS_QMARK] = ACTIONS(1232),
    [anon_sym_DASH_QMARK] = ACTIONS(1232),
    [anon_sym_STAR_QMARK] = ACTIONS(1232),
    [anon_sym_SLASH_QMARK] = ACTIONS(1232),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1232),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1232),
    [anon_sym_as] = ACTIONS(1232),
    [anon_sym_LPAREN2] = ACTIONS(1232),
    [anon_sym_DOT_GT] = ACTIONS(1232),
    [anon_sym_where] = ACTIONS(1232),
    [anon_sym_TILDE] = ACTIONS(1232),
    [anon_sym_end] = ACTIONS(1232),
    [anon_sym_if] = ACTIONS(1234),
    [anon_sym_ifdef] = ACTIONS(1232),
    [anon_sym_then] = ACTIONS(1232),
    [anon_sym_iftype] = ACTIONS(1232),
    [anon_sym_else] = ACTIONS(1232),
    [anon_sym_for] = ACTIONS(1232),
    [anon_sym_while] = ACTIONS(1232),
    [anon_sym_try] = ACTIONS(1232),
    [anon_sym_with] = ACTIONS(1232),
    [anon_sym_repeat] = ACTIONS(1232),
    [anon_sym_until] = ACTIONS(1232),
    [anon_sym_do] = ACTIONS(1232),
    [anon_sym_recover] = ACTIONS(1232),
    [anon_sym_match] = ACTIONS(1232),
    [anon_sym_return] = ACTIONS(1232),
    [anon_sym_continue] = ACTIONS(1232),
    [anon_sym_break] = ACTIONS(1232),
    [anon_sym_consume] = ACTIONS(1232),
    [anon_sym_object] = ACTIONS(1232),
    [sym_number] = ACTIONS(1234),
    [sym_float] = ACTIONS(1232),
    [anon_sym_DQUOTE] = ACTIONS(1234),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1232),
    [anon_sym_SQUOTE] = ACTIONS(1232),
    [anon_sym_true] = ACTIONS(1232),
    [anon_sym_false] = ACTIONS(1232),
    [sym_this] = ACTIONS(1232),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [362] = {
    [sym_identifier] = ACTIONS(1190),
    [anon_sym_EQ] = ACTIONS(1190),
    [anon_sym_AT] = ACTIONS(1188),
    [anon_sym_LBRACK] = ACTIONS(1188),
    [anon_sym_RBRACK] = ACTIONS(1188),
    [anon_sym_is] = ACTIONS(1190),
    [anon_sym_embed] = ACTIONS(1188),
    [anon_sym_let] = ACTIONS(1188),
    [anon_sym_var] = ACTIONS(1188),
    [anon_sym_new] = ACTIONS(1188),
    [anon_sym_EQ_GT] = ACTIONS(1188),
    [anon_sym_fun] = ACTIONS(1188),
    [anon_sym_be] = ACTIONS(1188),
    [anon_sym_COMMA] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1190),
    [anon_sym_RPAREN] = ACTIONS(1188),
    [anon_sym_DOT] = ACTIONS(1190),
    [anon_sym_PIPE] = ACTIONS(1188),
    [anon_sym_LBRACE] = ACTIONS(1188),
    [anon_sym_RBRACE] = ACTIONS(1188),
    [anon_sym_SEMI] = ACTIONS(1188),
    [sym_error] = ACTIONS(1188),
    [sym_compile_intrinsic] = ACTIONS(1188),
    [anon_sym_compile_error] = ACTIONS(1188),
    [sym_location] = ACTIONS(1188),
    [anon_sym_DASH] = ACTIONS(1190),
    [anon_sym_not] = ACTIONS(1188),
    [anon_sym_DASH_TILDE] = ACTIONS(1188),
    [anon_sym_addressof] = ACTIONS(1188),
    [anon_sym_digestof] = ACTIONS(1188),
    [anon_sym_PLUS] = ACTIONS(1190),
    [anon_sym_STAR] = ACTIONS(1190),
    [anon_sym_SLASH] = ACTIONS(1190),
    [anon_sym_PERCENT] = ACTIONS(1190),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1190),
    [anon_sym_LT_LT] = ACTIONS(1190),
    [anon_sym_GT_GT] = ACTIONS(1190),
    [anon_sym_and] = ACTIONS(1188),
    [anon_sym_or] = ACTIONS(1188),
    [anon_sym_xor] = ACTIONS(1188),
    [anon_sym_isnt] = ACTIONS(1188),
    [anon_sym_EQ_EQ] = ACTIONS(1190),
    [anon_sym_BANG_EQ] = ACTIONS(1190),
    [anon_sym_GT] = ACTIONS(1190),
    [anon_sym_GT_EQ] = ACTIONS(1190),
    [anon_sym_LT_EQ] = ACTIONS(1190),
    [anon_sym_LT] = ACTIONS(1190),
    [anon_sym_PLUS_TILDE] = ACTIONS(1188),
    [anon_sym_STAR_TILDE] = ACTIONS(1188),
    [anon_sym_SLASH_TILDE] = ACTIONS(1188),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1188),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1188),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1188),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1188),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1188),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1188),
    [anon_sym_GT_TILDE] = ACTIONS(1188),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1188),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1188),
    [anon_sym_LT_TILDE] = ACTIONS(1188),
    [anon_sym_PLUS_QMARK] = ACTIONS(1188),
    [anon_sym_DASH_QMARK] = ACTIONS(1188),
    [anon_sym_STAR_QMARK] = ACTIONS(1188),
    [anon_sym_SLASH_QMARK] = ACTIONS(1188),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1188),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1188),
    [anon_sym_as] = ACTIONS(1188),
    [anon_sym_LPAREN2] = ACTIONS(1188),
    [anon_sym_DOT_GT] = ACTIONS(1188),
    [anon_sym_where] = ACTIONS(1188),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_end] = ACTIONS(1188),
    [anon_sym_if] = ACTIONS(1190),
    [anon_sym_ifdef] = ACTIONS(1188),
    [anon_sym_then] = ACTIONS(1188),
    [anon_sym_iftype] = ACTIONS(1188),
    [anon_sym_else] = ACTIONS(1188),
    [anon_sym_for] = ACTIONS(1188),
    [anon_sym_while] = ACTIONS(1188),
    [anon_sym_try] = ACTIONS(1188),
    [anon_sym_with] = ACTIONS(1188),
    [anon_sym_repeat] = ACTIONS(1188),
    [anon_sym_until] = ACTIONS(1188),
    [anon_sym_do] = ACTIONS(1188),
    [anon_sym_recover] = ACTIONS(1188),
    [anon_sym_match] = ACTIONS(1188),
    [anon_sym_return] = ACTIONS(1188),
    [anon_sym_continue] = ACTIONS(1188),
    [anon_sym_break] = ACTIONS(1188),
    [anon_sym_consume] = ACTIONS(1188),
    [anon_sym_object] = ACTIONS(1188),
    [sym_number] = ACTIONS(1190),
    [sym_float] = ACTIONS(1188),
    [anon_sym_DQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1188),
    [anon_sym_true] = ACTIONS(1188),
    [anon_sym_false] = ACTIONS(1188),
    [sym_this] = ACTIONS(1188),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [363] = {
    [sym_identifier] = ACTIONS(1194),
    [anon_sym_EQ] = ACTIONS(1194),
    [anon_sym_AT] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1192),
    [anon_sym_RBRACK] = ACTIONS(1192),
    [anon_sym_is] = ACTIONS(1194),
    [anon_sym_embed] = ACTIONS(1192),
    [anon_sym_let] = ACTIONS(1192),
    [anon_sym_var] = ACTIONS(1192),
    [anon_sym_new] = ACTIONS(1192),
    [anon_sym_EQ_GT] = ACTIONS(1192),
    [anon_sym_fun] = ACTIONS(1192),
    [anon_sym_be] = ACTIONS(1192),
    [anon_sym_COMMA] = ACTIONS(1192),
    [anon_sym_LPAREN] = ACTIONS(1194),
    [anon_sym_RPAREN] = ACTIONS(1192),
    [anon_sym_DOT] = ACTIONS(1194),
    [anon_sym_PIPE] = ACTIONS(1192),
    [anon_sym_LBRACE] = ACTIONS(1192),
    [anon_sym_RBRACE] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1192),
    [sym_error] = ACTIONS(1192),
    [sym_compile_intrinsic] = ACTIONS(1192),
    [anon_sym_compile_error] = ACTIONS(1192),
    [sym_location] = ACTIONS(1192),
    [anon_sym_DASH] = ACTIONS(1194),
    [anon_sym_not] = ACTIONS(1192),
    [anon_sym_DASH_TILDE] = ACTIONS(1192),
    [anon_sym_addressof] = ACTIONS(1192),
    [anon_sym_digestof] = ACTIONS(1192),
    [anon_sym_PLUS] = ACTIONS(1194),
    [anon_sym_STAR] = ACTIONS(1194),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_PERCENT] = ACTIONS(1194),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1194),
    [anon_sym_LT_LT] = ACTIONS(1194),
    [anon_sym_GT_GT] = ACTIONS(1194),
    [anon_sym_and] = ACTIONS(1192),
    [anon_sym_or] = ACTIONS(1192),
    [anon_sym_xor] = ACTIONS(1192),
    [anon_sym_isnt] = ACTIONS(1192),
    [anon_sym_EQ_EQ] = ACTIONS(1194),
    [anon_sym_BANG_EQ] = ACTIONS(1194),
    [anon_sym_GT] = ACTIONS(1194),
    [anon_sym_GT_EQ] = ACTIONS(1194),
    [anon_sym_LT_EQ] = ACTIONS(1194),
    [anon_sym_LT] = ACTIONS(1194),
    [anon_sym_PLUS_TILDE] = ACTIONS(1192),
    [anon_sym_STAR_TILDE] = ACTIONS(1192),
    [anon_sym_SLASH_TILDE] = ACTIONS(1192),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1192),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1192),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1192),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1192),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1192),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1192),
    [anon_sym_GT_TILDE] = ACTIONS(1192),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1192),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1192),
    [anon_sym_LT_TILDE] = ACTIONS(1192),
    [anon_sym_PLUS_QMARK] = ACTIONS(1192),
    [anon_sym_DASH_QMARK] = ACTIONS(1192),
    [anon_sym_STAR_QMARK] = ACTIONS(1192),
    [anon_sym_SLASH_QMARK] = ACTIONS(1192),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1192),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1192),
    [anon_sym_as] = ACTIONS(1192),
    [anon_sym_LPAREN2] = ACTIONS(1192),
    [anon_sym_DOT_GT] = ACTIONS(1192),
    [anon_sym_where] = ACTIONS(1192),
    [anon_sym_TILDE] = ACTIONS(1192),
    [anon_sym_end] = ACTIONS(1192),
    [anon_sym_if] = ACTIONS(1194),
    [anon_sym_ifdef] = ACTIONS(1192),
    [anon_sym_then] = ACTIONS(1192),
    [anon_sym_iftype] = ACTIONS(1192),
    [anon_sym_else] = ACTIONS(1192),
    [anon_sym_for] = ACTIONS(1192),
    [anon_sym_while] = ACTIONS(1192),
    [anon_sym_try] = ACTIONS(1192),
    [anon_sym_with] = ACTIONS(1192),
    [anon_sym_repeat] = ACTIONS(1192),
    [anon_sym_until] = ACTIONS(1192),
    [anon_sym_do] = ACTIONS(1192),
    [anon_sym_recover] = ACTIONS(1192),
    [anon_sym_match] = ACTIONS(1192),
    [anon_sym_return] = ACTIONS(1192),
    [anon_sym_continue] = ACTIONS(1192),
    [anon_sym_break] = ACTIONS(1192),
    [anon_sym_consume] = ACTIONS(1192),
    [anon_sym_object] = ACTIONS(1192),
    [sym_number] = ACTIONS(1194),
    [sym_float] = ACTIONS(1192),
    [anon_sym_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1192),
    [anon_sym_SQUOTE] = ACTIONS(1192),
    [anon_sym_true] = ACTIONS(1192),
    [anon_sym_false] = ACTIONS(1192),
    [sym_this] = ACTIONS(1192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [364] = {
    [sym_identifier] = ACTIONS(1246),
    [anon_sym_EQ] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(1244),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1244),
    [anon_sym_is] = ACTIONS(1246),
    [anon_sym_embed] = ACTIONS(1244),
    [anon_sym_let] = ACTIONS(1244),
    [anon_sym_var] = ACTIONS(1244),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_EQ_GT] = ACTIONS(1244),
    [anon_sym_fun] = ACTIONS(1244),
    [anon_sym_be] = ACTIONS(1244),
    [anon_sym_COMMA] = ACTIONS(1244),
    [anon_sym_LPAREN] = ACTIONS(1246),
    [anon_sym_RPAREN] = ACTIONS(1244),
    [anon_sym_DOT] = ACTIONS(1246),
    [anon_sym_PIPE] = ACTIONS(1244),
    [anon_sym_LBRACE] = ACTIONS(1244),
    [anon_sym_RBRACE] = ACTIONS(1244),
    [anon_sym_SEMI] = ACTIONS(1244),
    [sym_error] = ACTIONS(1244),
    [sym_compile_intrinsic] = ACTIONS(1244),
    [anon_sym_compile_error] = ACTIONS(1244),
    [sym_location] = ACTIONS(1244),
    [anon_sym_DASH] = ACTIONS(1246),
    [anon_sym_not] = ACTIONS(1244),
    [anon_sym_DASH_TILDE] = ACTIONS(1244),
    [anon_sym_addressof] = ACTIONS(1244),
    [anon_sym_digestof] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1246),
    [anon_sym_STAR] = ACTIONS(1246),
    [anon_sym_SLASH] = ACTIONS(1246),
    [anon_sym_PERCENT] = ACTIONS(1246),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1246),
    [anon_sym_LT_LT] = ACTIONS(1246),
    [anon_sym_GT_GT] = ACTIONS(1246),
    [anon_sym_and] = ACTIONS(1244),
    [anon_sym_or] = ACTIONS(1244),
    [anon_sym_xor] = ACTIONS(1244),
    [anon_sym_isnt] = ACTIONS(1244),
    [anon_sym_EQ_EQ] = ACTIONS(1246),
    [anon_sym_BANG_EQ] = ACTIONS(1246),
    [anon_sym_GT] = ACTIONS(1246),
    [anon_sym_GT_EQ] = ACTIONS(1246),
    [anon_sym_LT_EQ] = ACTIONS(1246),
    [anon_sym_LT] = ACTIONS(1246),
    [anon_sym_PLUS_TILDE] = ACTIONS(1244),
    [anon_sym_STAR_TILDE] = ACTIONS(1244),
    [anon_sym_SLASH_TILDE] = ACTIONS(1244),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1244),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1244),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1244),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1244),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1244),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1244),
    [anon_sym_GT_TILDE] = ACTIONS(1244),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1244),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1244),
    [anon_sym_LT_TILDE] = ACTIONS(1244),
    [anon_sym_PLUS_QMARK] = ACTIONS(1244),
    [anon_sym_DASH_QMARK] = ACTIONS(1244),
    [anon_sym_STAR_QMARK] = ACTIONS(1244),
    [anon_sym_SLASH_QMARK] = ACTIONS(1244),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1244),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1244),
    [anon_sym_as] = ACTIONS(1244),
    [anon_sym_LPAREN2] = ACTIONS(1244),
    [anon_sym_DOT_GT] = ACTIONS(1244),
    [anon_sym_where] = ACTIONS(1244),
    [anon_sym_TILDE] = ACTIONS(1244),
    [anon_sym_end] = ACTIONS(1244),
    [anon_sym_if] = ACTIONS(1246),
    [anon_sym_ifdef] = ACTIONS(1244),
    [anon_sym_then] = ACTIONS(1244),
    [anon_sym_iftype] = ACTIONS(1244),
    [anon_sym_else] = ACTIONS(1244),
    [anon_sym_for] = ACTIONS(1244),
    [anon_sym_while] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_with] = ACTIONS(1244),
    [anon_sym_repeat] = ACTIONS(1244),
    [anon_sym_until] = ACTIONS(1244),
    [anon_sym_do] = ACTIONS(1244),
    [anon_sym_recover] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1244),
    [anon_sym_return] = ACTIONS(1244),
    [anon_sym_continue] = ACTIONS(1244),
    [anon_sym_break] = ACTIONS(1244),
    [anon_sym_consume] = ACTIONS(1244),
    [anon_sym_object] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_float] = ACTIONS(1244),
    [anon_sym_DQUOTE] = ACTIONS(1246),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1244),
    [anon_sym_true] = ACTIONS(1244),
    [anon_sym_false] = ACTIONS(1244),
    [sym_this] = ACTIONS(1244),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [365] = {
    [sym_identifier] = ACTIONS(843),
    [anon_sym_EQ] = ACTIONS(843),
    [anon_sym_AT] = ACTIONS(841),
    [anon_sym_LBRACK] = ACTIONS(841),
    [anon_sym_RBRACK] = ACTIONS(841),
    [anon_sym_is] = ACTIONS(843),
    [anon_sym_embed] = ACTIONS(841),
    [anon_sym_let] = ACTIONS(841),
    [anon_sym_var] = ACTIONS(841),
    [anon_sym_new] = ACTIONS(841),
    [anon_sym_EQ_GT] = ACTIONS(841),
    [anon_sym_fun] = ACTIONS(841),
    [anon_sym_be] = ACTIONS(841),
    [anon_sym_COMMA] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_RPAREN] = ACTIONS(841),
    [anon_sym_DOT] = ACTIONS(843),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(841),
    [anon_sym_RBRACE] = ACTIONS(841),
    [anon_sym_SEMI] = ACTIONS(841),
    [sym_error] = ACTIONS(841),
    [sym_compile_intrinsic] = ACTIONS(841),
    [anon_sym_compile_error] = ACTIONS(841),
    [sym_location] = ACTIONS(841),
    [anon_sym_DASH] = ACTIONS(843),
    [anon_sym_not] = ACTIONS(841),
    [anon_sym_DASH_TILDE] = ACTIONS(841),
    [anon_sym_addressof] = ACTIONS(841),
    [anon_sym_digestof] = ACTIONS(841),
    [anon_sym_PLUS] = ACTIONS(843),
    [anon_sym_STAR] = ACTIONS(843),
    [anon_sym_SLASH] = ACTIONS(843),
    [anon_sym_PERCENT] = ACTIONS(843),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(843),
    [anon_sym_LT_LT] = ACTIONS(843),
    [anon_sym_GT_GT] = ACTIONS(843),
    [anon_sym_and] = ACTIONS(841),
    [anon_sym_or] = ACTIONS(841),
    [anon_sym_xor] = ACTIONS(841),
    [anon_sym_isnt] = ACTIONS(841),
    [anon_sym_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(843),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_PLUS_TILDE] = ACTIONS(841),
    [anon_sym_STAR_TILDE] = ACTIONS(841),
    [anon_sym_SLASH_TILDE] = ACTIONS(841),
    [anon_sym_PERCENT_TILDE] = ACTIONS(841),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(841),
    [anon_sym_LT_LT_TILDE] = ACTIONS(841),
    [anon_sym_GT_GT_TILDE] = ACTIONS(841),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(841),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(841),
    [anon_sym_GT_TILDE] = ACTIONS(841),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(841),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(841),
    [anon_sym_LT_TILDE] = ACTIONS(841),
    [anon_sym_PLUS_QMARK] = ACTIONS(841),
    [anon_sym_DASH_QMARK] = ACTIONS(841),
    [anon_sym_STAR_QMARK] = ACTIONS(841),
    [anon_sym_SLASH_QMARK] = ACTIONS(841),
    [anon_sym_PERCENT_QMARK] = ACTIONS(841),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(841),
    [anon_sym_as] = ACTIONS(841),
    [anon_sym_LPAREN2] = ACTIONS(841),
    [anon_sym_DOT_GT] = ACTIONS(841),
    [anon_sym_where] = ACTIONS(841),
    [anon_sym_TILDE] = ACTIONS(841),
    [anon_sym_end] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_ifdef] = ACTIONS(841),
    [anon_sym_then] = ACTIONS(841),
    [anon_sym_iftype] = ACTIONS(841),
    [anon_sym_else] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(841),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_with] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(841),
    [anon_sym_until] = ACTIONS(841),
    [anon_sym_do] = ACTIONS(841),
    [anon_sym_recover] = ACTIONS(841),
    [anon_sym_match] = ACTIONS(841),
    [anon_sym_return] = ACTIONS(841),
    [anon_sym_continue] = ACTIONS(841),
    [anon_sym_break] = ACTIONS(841),
    [anon_sym_consume] = ACTIONS(841),
    [anon_sym_object] = ACTIONS(841),
    [sym_number] = ACTIONS(843),
    [sym_float] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(843),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(841),
    [anon_sym_SQUOTE] = ACTIONS(841),
    [anon_sym_true] = ACTIONS(841),
    [anon_sym_false] = ACTIONS(841),
    [sym_this] = ACTIONS(841),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [366] = {
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_EQ] = ACTIONS(1136),
    [anon_sym_AT] = ACTIONS(1134),
    [anon_sym_LBRACK] = ACTIONS(1134),
    [anon_sym_RBRACK] = ACTIONS(1134),
    [anon_sym_is] = ACTIONS(1136),
    [anon_sym_embed] = ACTIONS(1134),
    [anon_sym_let] = ACTIONS(1134),
    [anon_sym_var] = ACTIONS(1134),
    [anon_sym_new] = ACTIONS(1134),
    [anon_sym_EQ_GT] = ACTIONS(1134),
    [anon_sym_fun] = ACTIONS(1134),
    [anon_sym_be] = ACTIONS(1134),
    [anon_sym_COMMA] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [anon_sym_RPAREN] = ACTIONS(1134),
    [anon_sym_DOT] = ACTIONS(1136),
    [anon_sym_PIPE] = ACTIONS(1134),
    [anon_sym_LBRACE] = ACTIONS(1134),
    [anon_sym_RBRACE] = ACTIONS(1134),
    [anon_sym_SEMI] = ACTIONS(1134),
    [sym_error] = ACTIONS(1134),
    [sym_compile_intrinsic] = ACTIONS(1134),
    [anon_sym_compile_error] = ACTIONS(1134),
    [sym_location] = ACTIONS(1134),
    [anon_sym_DASH] = ACTIONS(1136),
    [anon_sym_not] = ACTIONS(1134),
    [anon_sym_DASH_TILDE] = ACTIONS(1134),
    [anon_sym_addressof] = ACTIONS(1134),
    [anon_sym_digestof] = ACTIONS(1134),
    [anon_sym_PLUS] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_SLASH] = ACTIONS(1136),
    [anon_sym_PERCENT] = ACTIONS(1136),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1136),
    [anon_sym_LT_LT] = ACTIONS(1136),
    [anon_sym_GT_GT] = ACTIONS(1136),
    [anon_sym_and] = ACTIONS(1134),
    [anon_sym_or] = ACTIONS(1134),
    [anon_sym_xor] = ACTIONS(1134),
    [anon_sym_isnt] = ACTIONS(1134),
    [anon_sym_EQ_EQ] = ACTIONS(1136),
    [anon_sym_BANG_EQ] = ACTIONS(1136),
    [anon_sym_GT] = ACTIONS(1136),
    [anon_sym_GT_EQ] = ACTIONS(1136),
    [anon_sym_LT_EQ] = ACTIONS(1136),
    [anon_sym_LT] = ACTIONS(1136),
    [anon_sym_PLUS_TILDE] = ACTIONS(1134),
    [anon_sym_STAR_TILDE] = ACTIONS(1134),
    [anon_sym_SLASH_TILDE] = ACTIONS(1134),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1134),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1134),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1134),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1134),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1134),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1134),
    [anon_sym_GT_TILDE] = ACTIONS(1134),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1134),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1134),
    [anon_sym_LT_TILDE] = ACTIONS(1134),
    [anon_sym_PLUS_QMARK] = ACTIONS(1134),
    [anon_sym_DASH_QMARK] = ACTIONS(1134),
    [anon_sym_STAR_QMARK] = ACTIONS(1134),
    [anon_sym_SLASH_QMARK] = ACTIONS(1134),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1134),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1134),
    [anon_sym_as] = ACTIONS(1134),
    [anon_sym_LPAREN2] = ACTIONS(1134),
    [anon_sym_DOT_GT] = ACTIONS(1134),
    [anon_sym_where] = ACTIONS(1134),
    [anon_sym_TILDE] = ACTIONS(1134),
    [anon_sym_end] = ACTIONS(1134),
    [anon_sym_if] = ACTIONS(1136),
    [anon_sym_ifdef] = ACTIONS(1134),
    [anon_sym_then] = ACTIONS(1134),
    [anon_sym_iftype] = ACTIONS(1134),
    [anon_sym_else] = ACTIONS(1134),
    [anon_sym_for] = ACTIONS(1134),
    [anon_sym_while] = ACTIONS(1134),
    [anon_sym_try] = ACTIONS(1134),
    [anon_sym_with] = ACTIONS(1134),
    [anon_sym_repeat] = ACTIONS(1134),
    [anon_sym_until] = ACTIONS(1134),
    [anon_sym_do] = ACTIONS(1134),
    [anon_sym_recover] = ACTIONS(1134),
    [anon_sym_match] = ACTIONS(1134),
    [anon_sym_return] = ACTIONS(1134),
    [anon_sym_continue] = ACTIONS(1134),
    [anon_sym_break] = ACTIONS(1134),
    [anon_sym_consume] = ACTIONS(1134),
    [anon_sym_object] = ACTIONS(1134),
    [sym_number] = ACTIONS(1136),
    [sym_float] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(1136),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1134),
    [anon_sym_SQUOTE] = ACTIONS(1134),
    [anon_sym_true] = ACTIONS(1134),
    [anon_sym_false] = ACTIONS(1134),
    [sym_this] = ACTIONS(1134),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [367] = {
    [sym_identifier] = ACTIONS(833),
    [anon_sym_EQ] = ACTIONS(833),
    [anon_sym_AT] = ACTIONS(831),
    [anon_sym_LBRACK] = ACTIONS(831),
    [anon_sym_RBRACK] = ACTIONS(831),
    [anon_sym_is] = ACTIONS(833),
    [anon_sym_embed] = ACTIONS(831),
    [anon_sym_let] = ACTIONS(831),
    [anon_sym_var] = ACTIONS(831),
    [anon_sym_new] = ACTIONS(831),
    [anon_sym_EQ_GT] = ACTIONS(831),
    [anon_sym_fun] = ACTIONS(831),
    [anon_sym_be] = ACTIONS(831),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_RPAREN] = ACTIONS(831),
    [anon_sym_DOT] = ACTIONS(833),
    [anon_sym_PIPE] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(831),
    [anon_sym_RBRACE] = ACTIONS(831),
    [anon_sym_SEMI] = ACTIONS(831),
    [sym_error] = ACTIONS(831),
    [sym_compile_intrinsic] = ACTIONS(831),
    [anon_sym_compile_error] = ACTIONS(831),
    [sym_location] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_not] = ACTIONS(831),
    [anon_sym_DASH_TILDE] = ACTIONS(831),
    [anon_sym_addressof] = ACTIONS(831),
    [anon_sym_digestof] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_STAR] = ACTIONS(833),
    [anon_sym_SLASH] = ACTIONS(833),
    [anon_sym_PERCENT] = ACTIONS(833),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(833),
    [anon_sym_LT_LT] = ACTIONS(833),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_and] = ACTIONS(831),
    [anon_sym_or] = ACTIONS(831),
    [anon_sym_xor] = ACTIONS(831),
    [anon_sym_isnt] = ACTIONS(831),
    [anon_sym_EQ_EQ] = ACTIONS(833),
    [anon_sym_BANG_EQ] = ACTIONS(833),
    [anon_sym_GT] = ACTIONS(833),
    [anon_sym_GT_EQ] = ACTIONS(833),
    [anon_sym_LT_EQ] = ACTIONS(833),
    [anon_sym_LT] = ACTIONS(833),
    [anon_sym_PLUS_TILDE] = ACTIONS(831),
    [anon_sym_STAR_TILDE] = ACTIONS(831),
    [anon_sym_SLASH_TILDE] = ACTIONS(831),
    [anon_sym_PERCENT_TILDE] = ACTIONS(831),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(831),
    [anon_sym_LT_LT_TILDE] = ACTIONS(831),
    [anon_sym_GT_GT_TILDE] = ACTIONS(831),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(831),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(831),
    [anon_sym_GT_TILDE] = ACTIONS(831),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(831),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(831),
    [anon_sym_LT_TILDE] = ACTIONS(831),
    [anon_sym_PLUS_QMARK] = ACTIONS(831),
    [anon_sym_DASH_QMARK] = ACTIONS(831),
    [anon_sym_STAR_QMARK] = ACTIONS(831),
    [anon_sym_SLASH_QMARK] = ACTIONS(831),
    [anon_sym_PERCENT_QMARK] = ACTIONS(831),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(831),
    [anon_sym_as] = ACTIONS(831),
    [anon_sym_LPAREN2] = ACTIONS(831),
    [anon_sym_DOT_GT] = ACTIONS(831),
    [anon_sym_where] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(831),
    [anon_sym_end] = ACTIONS(831),
    [anon_sym_if] = ACTIONS(833),
    [anon_sym_ifdef] = ACTIONS(831),
    [anon_sym_then] = ACTIONS(831),
    [anon_sym_iftype] = ACTIONS(831),
    [anon_sym_else] = ACTIONS(831),
    [anon_sym_for] = ACTIONS(831),
    [anon_sym_while] = ACTIONS(831),
    [anon_sym_try] = ACTIONS(831),
    [anon_sym_with] = ACTIONS(831),
    [anon_sym_repeat] = ACTIONS(831),
    [anon_sym_until] = ACTIONS(831),
    [anon_sym_do] = ACTIONS(831),
    [anon_sym_recover] = ACTIONS(831),
    [anon_sym_match] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_continue] = ACTIONS(831),
    [anon_sym_break] = ACTIONS(831),
    [anon_sym_consume] = ACTIONS(831),
    [anon_sym_object] = ACTIONS(831),
    [sym_number] = ACTIONS(833),
    [sym_float] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(831),
    [anon_sym_SQUOTE] = ACTIONS(831),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_this] = ACTIONS(831),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [368] = {
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_EQ] = ACTIONS(1230),
    [anon_sym_AT] = ACTIONS(1228),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_RBRACK] = ACTIONS(1228),
    [anon_sym_is] = ACTIONS(1230),
    [anon_sym_embed] = ACTIONS(1228),
    [anon_sym_let] = ACTIONS(1228),
    [anon_sym_var] = ACTIONS(1228),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_EQ_GT] = ACTIONS(1228),
    [anon_sym_fun] = ACTIONS(1228),
    [anon_sym_be] = ACTIONS(1228),
    [anon_sym_COMMA] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_RPAREN] = ACTIONS(1228),
    [anon_sym_DOT] = ACTIONS(1230),
    [anon_sym_PIPE] = ACTIONS(1228),
    [anon_sym_LBRACE] = ACTIONS(1228),
    [anon_sym_RBRACE] = ACTIONS(1228),
    [anon_sym_SEMI] = ACTIONS(1228),
    [sym_error] = ACTIONS(1228),
    [sym_compile_intrinsic] = ACTIONS(1228),
    [anon_sym_compile_error] = ACTIONS(1228),
    [sym_location] = ACTIONS(1228),
    [anon_sym_DASH] = ACTIONS(1230),
    [anon_sym_not] = ACTIONS(1228),
    [anon_sym_DASH_TILDE] = ACTIONS(1228),
    [anon_sym_addressof] = ACTIONS(1228),
    [anon_sym_digestof] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(1230),
    [anon_sym_STAR] = ACTIONS(1230),
    [anon_sym_SLASH] = ACTIONS(1230),
    [anon_sym_PERCENT] = ACTIONS(1230),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1230),
    [anon_sym_LT_LT] = ACTIONS(1230),
    [anon_sym_GT_GT] = ACTIONS(1230),
    [anon_sym_and] = ACTIONS(1228),
    [anon_sym_or] = ACTIONS(1228),
    [anon_sym_xor] = ACTIONS(1228),
    [anon_sym_isnt] = ACTIONS(1228),
    [anon_sym_EQ_EQ] = ACTIONS(1230),
    [anon_sym_BANG_EQ] = ACTIONS(1230),
    [anon_sym_GT] = ACTIONS(1230),
    [anon_sym_GT_EQ] = ACTIONS(1230),
    [anon_sym_LT_EQ] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1230),
    [anon_sym_PLUS_TILDE] = ACTIONS(1228),
    [anon_sym_STAR_TILDE] = ACTIONS(1228),
    [anon_sym_SLASH_TILDE] = ACTIONS(1228),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1228),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1228),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1228),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1228),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1228),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1228),
    [anon_sym_GT_TILDE] = ACTIONS(1228),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1228),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1228),
    [anon_sym_LT_TILDE] = ACTIONS(1228),
    [anon_sym_PLUS_QMARK] = ACTIONS(1228),
    [anon_sym_DASH_QMARK] = ACTIONS(1228),
    [anon_sym_STAR_QMARK] = ACTIONS(1228),
    [anon_sym_SLASH_QMARK] = ACTIONS(1228),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1228),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1228),
    [anon_sym_as] = ACTIONS(1228),
    [anon_sym_LPAREN2] = ACTIONS(1228),
    [anon_sym_DOT_GT] = ACTIONS(1228),
    [anon_sym_where] = ACTIONS(1228),
    [anon_sym_TILDE] = ACTIONS(1228),
    [anon_sym_end] = ACTIONS(1228),
    [anon_sym_if] = ACTIONS(1230),
    [anon_sym_ifdef] = ACTIONS(1228),
    [anon_sym_then] = ACTIONS(1228),
    [anon_sym_iftype] = ACTIONS(1228),
    [anon_sym_else] = ACTIONS(1228),
    [anon_sym_for] = ACTIONS(1228),
    [anon_sym_while] = ACTIONS(1228),
    [anon_sym_try] = ACTIONS(1228),
    [anon_sym_with] = ACTIONS(1228),
    [anon_sym_repeat] = ACTIONS(1228),
    [anon_sym_until] = ACTIONS(1228),
    [anon_sym_do] = ACTIONS(1228),
    [anon_sym_recover] = ACTIONS(1228),
    [anon_sym_match] = ACTIONS(1228),
    [anon_sym_return] = ACTIONS(1228),
    [anon_sym_continue] = ACTIONS(1228),
    [anon_sym_break] = ACTIONS(1228),
    [anon_sym_consume] = ACTIONS(1228),
    [anon_sym_object] = ACTIONS(1228),
    [sym_number] = ACTIONS(1230),
    [sym_float] = ACTIONS(1228),
    [anon_sym_DQUOTE] = ACTIONS(1230),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1228),
    [anon_sym_SQUOTE] = ACTIONS(1228),
    [anon_sym_true] = ACTIONS(1228),
    [anon_sym_false] = ACTIONS(1228),
    [sym_this] = ACTIONS(1228),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [369] = {
    [sym_identifier] = ACTIONS(1254),
    [anon_sym_EQ] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_LBRACK] = ACTIONS(1252),
    [anon_sym_RBRACK] = ACTIONS(1252),
    [anon_sym_is] = ACTIONS(1254),
    [anon_sym_embed] = ACTIONS(1252),
    [anon_sym_let] = ACTIONS(1252),
    [anon_sym_var] = ACTIONS(1252),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_EQ_GT] = ACTIONS(1252),
    [anon_sym_fun] = ACTIONS(1252),
    [anon_sym_be] = ACTIONS(1252),
    [anon_sym_COMMA] = ACTIONS(1252),
    [anon_sym_LPAREN] = ACTIONS(1254),
    [anon_sym_RPAREN] = ACTIONS(1252),
    [anon_sym_DOT] = ACTIONS(1254),
    [anon_sym_PIPE] = ACTIONS(1252),
    [anon_sym_LBRACE] = ACTIONS(1252),
    [anon_sym_RBRACE] = ACTIONS(1252),
    [anon_sym_SEMI] = ACTIONS(1252),
    [sym_error] = ACTIONS(1252),
    [sym_compile_intrinsic] = ACTIONS(1252),
    [anon_sym_compile_error] = ACTIONS(1252),
    [sym_location] = ACTIONS(1252),
    [anon_sym_DASH] = ACTIONS(1254),
    [anon_sym_not] = ACTIONS(1252),
    [anon_sym_DASH_TILDE] = ACTIONS(1252),
    [anon_sym_addressof] = ACTIONS(1252),
    [anon_sym_digestof] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1254),
    [anon_sym_STAR] = ACTIONS(1254),
    [anon_sym_SLASH] = ACTIONS(1254),
    [anon_sym_PERCENT] = ACTIONS(1254),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1254),
    [anon_sym_LT_LT] = ACTIONS(1254),
    [anon_sym_GT_GT] = ACTIONS(1254),
    [anon_sym_and] = ACTIONS(1252),
    [anon_sym_or] = ACTIONS(1252),
    [anon_sym_xor] = ACTIONS(1252),
    [anon_sym_isnt] = ACTIONS(1252),
    [anon_sym_EQ_EQ] = ACTIONS(1254),
    [anon_sym_BANG_EQ] = ACTIONS(1254),
    [anon_sym_GT] = ACTIONS(1254),
    [anon_sym_GT_EQ] = ACTIONS(1254),
    [anon_sym_LT_EQ] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1254),
    [anon_sym_PLUS_TILDE] = ACTIONS(1252),
    [anon_sym_STAR_TILDE] = ACTIONS(1252),
    [anon_sym_SLASH_TILDE] = ACTIONS(1252),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1252),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1252),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1252),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1252),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1252),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1252),
    [anon_sym_GT_TILDE] = ACTIONS(1252),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1252),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1252),
    [anon_sym_LT_TILDE] = ACTIONS(1252),
    [anon_sym_PLUS_QMARK] = ACTIONS(1252),
    [anon_sym_DASH_QMARK] = ACTIONS(1252),
    [anon_sym_STAR_QMARK] = ACTIONS(1252),
    [anon_sym_SLASH_QMARK] = ACTIONS(1252),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1252),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1252),
    [anon_sym_as] = ACTIONS(1252),
    [anon_sym_LPAREN2] = ACTIONS(1252),
    [anon_sym_DOT_GT] = ACTIONS(1252),
    [anon_sym_where] = ACTIONS(1252),
    [anon_sym_TILDE] = ACTIONS(1252),
    [anon_sym_end] = ACTIONS(1252),
    [anon_sym_if] = ACTIONS(1254),
    [anon_sym_ifdef] = ACTIONS(1252),
    [anon_sym_then] = ACTIONS(1252),
    [anon_sym_iftype] = ACTIONS(1252),
    [anon_sym_else] = ACTIONS(1252),
    [anon_sym_for] = ACTIONS(1252),
    [anon_sym_while] = ACTIONS(1252),
    [anon_sym_try] = ACTIONS(1252),
    [anon_sym_with] = ACTIONS(1252),
    [anon_sym_repeat] = ACTIONS(1252),
    [anon_sym_until] = ACTIONS(1252),
    [anon_sym_do] = ACTIONS(1252),
    [anon_sym_recover] = ACTIONS(1252),
    [anon_sym_match] = ACTIONS(1252),
    [anon_sym_return] = ACTIONS(1252),
    [anon_sym_continue] = ACTIONS(1252),
    [anon_sym_break] = ACTIONS(1252),
    [anon_sym_consume] = ACTIONS(1252),
    [anon_sym_object] = ACTIONS(1252),
    [sym_number] = ACTIONS(1254),
    [sym_float] = ACTIONS(1252),
    [anon_sym_DQUOTE] = ACTIONS(1254),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1252),
    [anon_sym_SQUOTE] = ACTIONS(1252),
    [anon_sym_true] = ACTIONS(1252),
    [anon_sym_false] = ACTIONS(1252),
    [sym_this] = ACTIONS(1252),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [370] = {
    [sym_identifier] = ACTIONS(1042),
    [anon_sym_EQ] = ACTIONS(1042),
    [anon_sym_AT] = ACTIONS(1040),
    [anon_sym_LBRACK] = ACTIONS(1040),
    [anon_sym_RBRACK] = ACTIONS(1040),
    [anon_sym_is] = ACTIONS(1042),
    [anon_sym_embed] = ACTIONS(1040),
    [anon_sym_let] = ACTIONS(1040),
    [anon_sym_var] = ACTIONS(1040),
    [anon_sym_new] = ACTIONS(1040),
    [anon_sym_EQ_GT] = ACTIONS(1040),
    [anon_sym_fun] = ACTIONS(1040),
    [anon_sym_be] = ACTIONS(1040),
    [anon_sym_COMMA] = ACTIONS(1040),
    [anon_sym_LPAREN] = ACTIONS(1042),
    [anon_sym_RPAREN] = ACTIONS(1040),
    [anon_sym_DOT] = ACTIONS(1042),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_RBRACE] = ACTIONS(1040),
    [anon_sym_SEMI] = ACTIONS(1040),
    [sym_error] = ACTIONS(1040),
    [sym_compile_intrinsic] = ACTIONS(1040),
    [anon_sym_compile_error] = ACTIONS(1040),
    [sym_location] = ACTIONS(1040),
    [anon_sym_DASH] = ACTIONS(1042),
    [anon_sym_not] = ACTIONS(1040),
    [anon_sym_DASH_TILDE] = ACTIONS(1040),
    [anon_sym_addressof] = ACTIONS(1040),
    [anon_sym_digestof] = ACTIONS(1040),
    [anon_sym_PLUS] = ACTIONS(1042),
    [anon_sym_STAR] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(1042),
    [anon_sym_PERCENT] = ACTIONS(1042),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1042),
    [anon_sym_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_GT] = ACTIONS(1042),
    [anon_sym_and] = ACTIONS(1040),
    [anon_sym_or] = ACTIONS(1040),
    [anon_sym_xor] = ACTIONS(1040),
    [anon_sym_isnt] = ACTIONS(1040),
    [anon_sym_EQ_EQ] = ACTIONS(1042),
    [anon_sym_BANG_EQ] = ACTIONS(1042),
    [anon_sym_GT] = ACTIONS(1042),
    [anon_sym_GT_EQ] = ACTIONS(1042),
    [anon_sym_LT_EQ] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_PLUS_TILDE] = ACTIONS(1040),
    [anon_sym_STAR_TILDE] = ACTIONS(1040),
    [anon_sym_SLASH_TILDE] = ACTIONS(1040),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1040),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1040),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1040),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1040),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1040),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1040),
    [anon_sym_GT_TILDE] = ACTIONS(1040),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1040),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1040),
    [anon_sym_LT_TILDE] = ACTIONS(1040),
    [anon_sym_PLUS_QMARK] = ACTIONS(1040),
    [anon_sym_DASH_QMARK] = ACTIONS(1040),
    [anon_sym_STAR_QMARK] = ACTIONS(1040),
    [anon_sym_SLASH_QMARK] = ACTIONS(1040),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1040),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1040),
    [anon_sym_as] = ACTIONS(1040),
    [anon_sym_LPAREN2] = ACTIONS(1040),
    [anon_sym_DOT_GT] = ACTIONS(1040),
    [anon_sym_where] = ACTIONS(1040),
    [anon_sym_TILDE] = ACTIONS(1040),
    [anon_sym_end] = ACTIONS(1040),
    [anon_sym_if] = ACTIONS(1042),
    [anon_sym_ifdef] = ACTIONS(1040),
    [anon_sym_then] = ACTIONS(1040),
    [anon_sym_iftype] = ACTIONS(1040),
    [anon_sym_else] = ACTIONS(1040),
    [anon_sym_for] = ACTIONS(1040),
    [anon_sym_while] = ACTIONS(1040),
    [anon_sym_try] = ACTIONS(1040),
    [anon_sym_with] = ACTIONS(1040),
    [anon_sym_repeat] = ACTIONS(1040),
    [anon_sym_until] = ACTIONS(1040),
    [anon_sym_do] = ACTIONS(1040),
    [anon_sym_recover] = ACTIONS(1040),
    [anon_sym_match] = ACTIONS(1040),
    [anon_sym_return] = ACTIONS(1040),
    [anon_sym_continue] = ACTIONS(1040),
    [anon_sym_break] = ACTIONS(1040),
    [anon_sym_consume] = ACTIONS(1040),
    [anon_sym_object] = ACTIONS(1040),
    [sym_number] = ACTIONS(1042),
    [sym_float] = ACTIONS(1040),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym_true] = ACTIONS(1040),
    [anon_sym_false] = ACTIONS(1040),
    [sym_this] = ACTIONS(1040),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [371] = {
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_EQ] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(1288),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_RBRACK] = ACTIONS(1288),
    [anon_sym_is] = ACTIONS(1290),
    [anon_sym_embed] = ACTIONS(1288),
    [anon_sym_let] = ACTIONS(1288),
    [anon_sym_var] = ACTIONS(1288),
    [anon_sym_new] = ACTIONS(1288),
    [anon_sym_EQ_GT] = ACTIONS(1288),
    [anon_sym_fun] = ACTIONS(1288),
    [anon_sym_be] = ACTIONS(1288),
    [anon_sym_COMMA] = ACTIONS(1288),
    [anon_sym_LPAREN] = ACTIONS(1290),
    [anon_sym_RPAREN] = ACTIONS(1288),
    [anon_sym_DOT] = ACTIONS(1290),
    [anon_sym_PIPE] = ACTIONS(1288),
    [anon_sym_LBRACE] = ACTIONS(1288),
    [anon_sym_RBRACE] = ACTIONS(1288),
    [anon_sym_SEMI] = ACTIONS(1288),
    [sym_error] = ACTIONS(1288),
    [sym_compile_intrinsic] = ACTIONS(1288),
    [anon_sym_compile_error] = ACTIONS(1288),
    [sym_location] = ACTIONS(1288),
    [anon_sym_DASH] = ACTIONS(1290),
    [anon_sym_not] = ACTIONS(1288),
    [anon_sym_DASH_TILDE] = ACTIONS(1288),
    [anon_sym_addressof] = ACTIONS(1288),
    [anon_sym_digestof] = ACTIONS(1288),
    [anon_sym_PLUS] = ACTIONS(1290),
    [anon_sym_STAR] = ACTIONS(1290),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_PERCENT] = ACTIONS(1290),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1290),
    [anon_sym_LT_LT] = ACTIONS(1290),
    [anon_sym_GT_GT] = ACTIONS(1290),
    [anon_sym_and] = ACTIONS(1288),
    [anon_sym_or] = ACTIONS(1288),
    [anon_sym_xor] = ACTIONS(1288),
    [anon_sym_isnt] = ACTIONS(1288),
    [anon_sym_EQ_EQ] = ACTIONS(1290),
    [anon_sym_BANG_EQ] = ACTIONS(1290),
    [anon_sym_GT] = ACTIONS(1290),
    [anon_sym_GT_EQ] = ACTIONS(1290),
    [anon_sym_LT_EQ] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(1290),
    [anon_sym_PLUS_TILDE] = ACTIONS(1288),
    [anon_sym_STAR_TILDE] = ACTIONS(1288),
    [anon_sym_SLASH_TILDE] = ACTIONS(1288),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1288),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1288),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1288),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1288),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1288),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1288),
    [anon_sym_GT_TILDE] = ACTIONS(1288),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1288),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1288),
    [anon_sym_LT_TILDE] = ACTIONS(1288),
    [anon_sym_PLUS_QMARK] = ACTIONS(1288),
    [anon_sym_DASH_QMARK] = ACTIONS(1288),
    [anon_sym_STAR_QMARK] = ACTIONS(1288),
    [anon_sym_SLASH_QMARK] = ACTIONS(1288),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1288),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1288),
    [anon_sym_as] = ACTIONS(1288),
    [anon_sym_LPAREN2] = ACTIONS(1288),
    [anon_sym_DOT_GT] = ACTIONS(1288),
    [anon_sym_where] = ACTIONS(1288),
    [anon_sym_TILDE] = ACTIONS(1288),
    [anon_sym_end] = ACTIONS(1288),
    [anon_sym_if] = ACTIONS(1290),
    [anon_sym_ifdef] = ACTIONS(1288),
    [anon_sym_then] = ACTIONS(1288),
    [anon_sym_iftype] = ACTIONS(1288),
    [anon_sym_else] = ACTIONS(1288),
    [anon_sym_for] = ACTIONS(1288),
    [anon_sym_while] = ACTIONS(1288),
    [anon_sym_try] = ACTIONS(1288),
    [anon_sym_with] = ACTIONS(1288),
    [anon_sym_repeat] = ACTIONS(1288),
    [anon_sym_until] = ACTIONS(1288),
    [anon_sym_do] = ACTIONS(1288),
    [anon_sym_recover] = ACTIONS(1288),
    [anon_sym_match] = ACTIONS(1288),
    [anon_sym_return] = ACTIONS(1288),
    [anon_sym_continue] = ACTIONS(1288),
    [anon_sym_break] = ACTIONS(1288),
    [anon_sym_consume] = ACTIONS(1288),
    [anon_sym_object] = ACTIONS(1288),
    [sym_number] = ACTIONS(1290),
    [sym_float] = ACTIONS(1288),
    [anon_sym_DQUOTE] = ACTIONS(1290),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1288),
    [anon_sym_SQUOTE] = ACTIONS(1288),
    [anon_sym_true] = ACTIONS(1288),
    [anon_sym_false] = ACTIONS(1288),
    [sym_this] = ACTIONS(1288),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [372] = {
    [sym_identifier] = ACTIONS(1068),
    [anon_sym_EQ] = ACTIONS(1068),
    [anon_sym_AT] = ACTIONS(1066),
    [anon_sym_LBRACK] = ACTIONS(1066),
    [anon_sym_RBRACK] = ACTIONS(1066),
    [anon_sym_is] = ACTIONS(1068),
    [anon_sym_embed] = ACTIONS(1066),
    [anon_sym_let] = ACTIONS(1066),
    [anon_sym_var] = ACTIONS(1066),
    [anon_sym_new] = ACTIONS(1066),
    [anon_sym_EQ_GT] = ACTIONS(1066),
    [anon_sym_fun] = ACTIONS(1066),
    [anon_sym_be] = ACTIONS(1066),
    [anon_sym_COMMA] = ACTIONS(1066),
    [anon_sym_LPAREN] = ACTIONS(1068),
    [anon_sym_RPAREN] = ACTIONS(1066),
    [anon_sym_DOT] = ACTIONS(1068),
    [anon_sym_PIPE] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1066),
    [anon_sym_RBRACE] = ACTIONS(1066),
    [anon_sym_SEMI] = ACTIONS(1066),
    [sym_error] = ACTIONS(1066),
    [sym_compile_intrinsic] = ACTIONS(1066),
    [anon_sym_compile_error] = ACTIONS(1066),
    [sym_location] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1068),
    [anon_sym_not] = ACTIONS(1066),
    [anon_sym_DASH_TILDE] = ACTIONS(1066),
    [anon_sym_addressof] = ACTIONS(1066),
    [anon_sym_digestof] = ACTIONS(1066),
    [anon_sym_PLUS] = ACTIONS(1068),
    [anon_sym_STAR] = ACTIONS(1068),
    [anon_sym_SLASH] = ACTIONS(1068),
    [anon_sym_PERCENT] = ACTIONS(1068),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1068),
    [anon_sym_LT_LT] = ACTIONS(1068),
    [anon_sym_GT_GT] = ACTIONS(1068),
    [anon_sym_and] = ACTIONS(1066),
    [anon_sym_or] = ACTIONS(1066),
    [anon_sym_xor] = ACTIONS(1066),
    [anon_sym_isnt] = ACTIONS(1066),
    [anon_sym_EQ_EQ] = ACTIONS(1068),
    [anon_sym_BANG_EQ] = ACTIONS(1068),
    [anon_sym_GT] = ACTIONS(1068),
    [anon_sym_GT_EQ] = ACTIONS(1068),
    [anon_sym_LT_EQ] = ACTIONS(1068),
    [anon_sym_LT] = ACTIONS(1068),
    [anon_sym_PLUS_TILDE] = ACTIONS(1066),
    [anon_sym_STAR_TILDE] = ACTIONS(1066),
    [anon_sym_SLASH_TILDE] = ACTIONS(1066),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1066),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1066),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1066),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1066),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1066),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1066),
    [anon_sym_GT_TILDE] = ACTIONS(1066),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1066),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1066),
    [anon_sym_LT_TILDE] = ACTIONS(1066),
    [anon_sym_PLUS_QMARK] = ACTIONS(1066),
    [anon_sym_DASH_QMARK] = ACTIONS(1066),
    [anon_sym_STAR_QMARK] = ACTIONS(1066),
    [anon_sym_SLASH_QMARK] = ACTIONS(1066),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1066),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1066),
    [anon_sym_as] = ACTIONS(1066),
    [anon_sym_LPAREN2] = ACTIONS(1066),
    [anon_sym_DOT_GT] = ACTIONS(1066),
    [anon_sym_where] = ACTIONS(1066),
    [anon_sym_TILDE] = ACTIONS(1066),
    [anon_sym_end] = ACTIONS(1066),
    [anon_sym_if] = ACTIONS(1068),
    [anon_sym_ifdef] = ACTIONS(1066),
    [anon_sym_then] = ACTIONS(1066),
    [anon_sym_iftype] = ACTIONS(1066),
    [anon_sym_else] = ACTIONS(1066),
    [anon_sym_for] = ACTIONS(1066),
    [anon_sym_while] = ACTIONS(1066),
    [anon_sym_try] = ACTIONS(1066),
    [anon_sym_with] = ACTIONS(1066),
    [anon_sym_repeat] = ACTIONS(1066),
    [anon_sym_until] = ACTIONS(1066),
    [anon_sym_do] = ACTIONS(1066),
    [anon_sym_recover] = ACTIONS(1066),
    [anon_sym_match] = ACTIONS(1066),
    [anon_sym_return] = ACTIONS(1066),
    [anon_sym_continue] = ACTIONS(1066),
    [anon_sym_break] = ACTIONS(1066),
    [anon_sym_consume] = ACTIONS(1066),
    [anon_sym_object] = ACTIONS(1066),
    [sym_number] = ACTIONS(1068),
    [sym_float] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(1068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(1066),
    [anon_sym_true] = ACTIONS(1066),
    [anon_sym_false] = ACTIONS(1066),
    [sym_this] = ACTIONS(1066),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [373] = {
    [sym_identifier] = ACTIONS(1026),
    [anon_sym_EQ] = ACTIONS(1026),
    [anon_sym_AT] = ACTIONS(1024),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(1024),
    [anon_sym_is] = ACTIONS(1026),
    [anon_sym_embed] = ACTIONS(1024),
    [anon_sym_let] = ACTIONS(1024),
    [anon_sym_var] = ACTIONS(1024),
    [anon_sym_new] = ACTIONS(1024),
    [anon_sym_EQ_GT] = ACTIONS(1024),
    [anon_sym_fun] = ACTIONS(1024),
    [anon_sym_be] = ACTIONS(1024),
    [anon_sym_COMMA] = ACTIONS(1024),
    [anon_sym_LPAREN] = ACTIONS(1026),
    [anon_sym_RPAREN] = ACTIONS(1024),
    [anon_sym_DOT] = ACTIONS(1026),
    [anon_sym_PIPE] = ACTIONS(1024),
    [anon_sym_LBRACE] = ACTIONS(1024),
    [anon_sym_RBRACE] = ACTIONS(1024),
    [anon_sym_SEMI] = ACTIONS(1024),
    [sym_error] = ACTIONS(1024),
    [sym_compile_intrinsic] = ACTIONS(1024),
    [anon_sym_compile_error] = ACTIONS(1024),
    [sym_location] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1026),
    [anon_sym_not] = ACTIONS(1024),
    [anon_sym_DASH_TILDE] = ACTIONS(1024),
    [anon_sym_addressof] = ACTIONS(1024),
    [anon_sym_digestof] = ACTIONS(1024),
    [anon_sym_PLUS] = ACTIONS(1026),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_SLASH] = ACTIONS(1026),
    [anon_sym_PERCENT] = ACTIONS(1026),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1026),
    [anon_sym_LT_LT] = ACTIONS(1026),
    [anon_sym_GT_GT] = ACTIONS(1026),
    [anon_sym_and] = ACTIONS(1024),
    [anon_sym_or] = ACTIONS(1024),
    [anon_sym_xor] = ACTIONS(1024),
    [anon_sym_isnt] = ACTIONS(1024),
    [anon_sym_EQ_EQ] = ACTIONS(1026),
    [anon_sym_BANG_EQ] = ACTIONS(1026),
    [anon_sym_GT] = ACTIONS(1026),
    [anon_sym_GT_EQ] = ACTIONS(1026),
    [anon_sym_LT_EQ] = ACTIONS(1026),
    [anon_sym_LT] = ACTIONS(1026),
    [anon_sym_PLUS_TILDE] = ACTIONS(1024),
    [anon_sym_STAR_TILDE] = ACTIONS(1024),
    [anon_sym_SLASH_TILDE] = ACTIONS(1024),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1024),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1024),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1024),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1024),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1024),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1024),
    [anon_sym_GT_TILDE] = ACTIONS(1024),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1024),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1024),
    [anon_sym_LT_TILDE] = ACTIONS(1024),
    [anon_sym_PLUS_QMARK] = ACTIONS(1024),
    [anon_sym_DASH_QMARK] = ACTIONS(1024),
    [anon_sym_STAR_QMARK] = ACTIONS(1024),
    [anon_sym_SLASH_QMARK] = ACTIONS(1024),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1024),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1024),
    [anon_sym_as] = ACTIONS(1024),
    [anon_sym_LPAREN2] = ACTIONS(1024),
    [anon_sym_DOT_GT] = ACTIONS(1024),
    [anon_sym_where] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1024),
    [anon_sym_end] = ACTIONS(1024),
    [anon_sym_if] = ACTIONS(1026),
    [anon_sym_ifdef] = ACTIONS(1024),
    [anon_sym_then] = ACTIONS(1024),
    [anon_sym_iftype] = ACTIONS(1024),
    [anon_sym_else] = ACTIONS(1024),
    [anon_sym_for] = ACTIONS(1024),
    [anon_sym_while] = ACTIONS(1024),
    [anon_sym_try] = ACTIONS(1024),
    [anon_sym_with] = ACTIONS(1024),
    [anon_sym_repeat] = ACTIONS(1024),
    [anon_sym_until] = ACTIONS(1024),
    [anon_sym_do] = ACTIONS(1024),
    [anon_sym_recover] = ACTIONS(1024),
    [anon_sym_match] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1024),
    [anon_sym_continue] = ACTIONS(1024),
    [anon_sym_break] = ACTIONS(1024),
    [anon_sym_consume] = ACTIONS(1024),
    [anon_sym_object] = ACTIONS(1024),
    [sym_number] = ACTIONS(1026),
    [sym_float] = ACTIONS(1024),
    [anon_sym_DQUOTE] = ACTIONS(1026),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1024),
    [anon_sym_SQUOTE] = ACTIONS(1024),
    [anon_sym_true] = ACTIONS(1024),
    [anon_sym_false] = ACTIONS(1024),
    [sym_this] = ACTIONS(1024),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [374] = {
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_EQ] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_RBRACK] = ACTIONS(1020),
    [anon_sym_is] = ACTIONS(1022),
    [anon_sym_embed] = ACTIONS(1020),
    [anon_sym_let] = ACTIONS(1020),
    [anon_sym_var] = ACTIONS(1020),
    [anon_sym_new] = ACTIONS(1020),
    [anon_sym_EQ_GT] = ACTIONS(1020),
    [anon_sym_fun] = ACTIONS(1020),
    [anon_sym_be] = ACTIONS(1020),
    [anon_sym_COMMA] = ACTIONS(1020),
    [anon_sym_LPAREN] = ACTIONS(1022),
    [anon_sym_RPAREN] = ACTIONS(1020),
    [anon_sym_DOT] = ACTIONS(1022),
    [anon_sym_PIPE] = ACTIONS(1020),
    [anon_sym_LBRACE] = ACTIONS(1020),
    [anon_sym_RBRACE] = ACTIONS(1020),
    [anon_sym_SEMI] = ACTIONS(1020),
    [sym_error] = ACTIONS(1020),
    [sym_compile_intrinsic] = ACTIONS(1020),
    [anon_sym_compile_error] = ACTIONS(1020),
    [sym_location] = ACTIONS(1020),
    [anon_sym_DASH] = ACTIONS(1022),
    [anon_sym_not] = ACTIONS(1020),
    [anon_sym_DASH_TILDE] = ACTIONS(1020),
    [anon_sym_addressof] = ACTIONS(1020),
    [anon_sym_digestof] = ACTIONS(1020),
    [anon_sym_PLUS] = ACTIONS(1022),
    [anon_sym_STAR] = ACTIONS(1022),
    [anon_sym_SLASH] = ACTIONS(1022),
    [anon_sym_PERCENT] = ACTIONS(1022),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1022),
    [anon_sym_LT_LT] = ACTIONS(1022),
    [anon_sym_GT_GT] = ACTIONS(1022),
    [anon_sym_and] = ACTIONS(1020),
    [anon_sym_or] = ACTIONS(1020),
    [anon_sym_xor] = ACTIONS(1020),
    [anon_sym_isnt] = ACTIONS(1020),
    [anon_sym_EQ_EQ] = ACTIONS(1022),
    [anon_sym_BANG_EQ] = ACTIONS(1022),
    [anon_sym_GT] = ACTIONS(1022),
    [anon_sym_GT_EQ] = ACTIONS(1022),
    [anon_sym_LT_EQ] = ACTIONS(1022),
    [anon_sym_LT] = ACTIONS(1022),
    [anon_sym_PLUS_TILDE] = ACTIONS(1020),
    [anon_sym_STAR_TILDE] = ACTIONS(1020),
    [anon_sym_SLASH_TILDE] = ACTIONS(1020),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1020),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1020),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1020),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1020),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1020),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1020),
    [anon_sym_GT_TILDE] = ACTIONS(1020),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1020),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1020),
    [anon_sym_LT_TILDE] = ACTIONS(1020),
    [anon_sym_PLUS_QMARK] = ACTIONS(1020),
    [anon_sym_DASH_QMARK] = ACTIONS(1020),
    [anon_sym_STAR_QMARK] = ACTIONS(1020),
    [anon_sym_SLASH_QMARK] = ACTIONS(1020),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1020),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1020),
    [anon_sym_as] = ACTIONS(1020),
    [anon_sym_LPAREN2] = ACTIONS(1020),
    [anon_sym_DOT_GT] = ACTIONS(1020),
    [anon_sym_where] = ACTIONS(1020),
    [anon_sym_TILDE] = ACTIONS(1020),
    [anon_sym_end] = ACTIONS(1020),
    [anon_sym_if] = ACTIONS(1022),
    [anon_sym_ifdef] = ACTIONS(1020),
    [anon_sym_then] = ACTIONS(1020),
    [anon_sym_iftype] = ACTIONS(1020),
    [anon_sym_else] = ACTIONS(1020),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_while] = ACTIONS(1020),
    [anon_sym_try] = ACTIONS(1020),
    [anon_sym_with] = ACTIONS(1020),
    [anon_sym_repeat] = ACTIONS(1020),
    [anon_sym_until] = ACTIONS(1020),
    [anon_sym_do] = ACTIONS(1020),
    [anon_sym_recover] = ACTIONS(1020),
    [anon_sym_match] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(1020),
    [anon_sym_continue] = ACTIONS(1020),
    [anon_sym_break] = ACTIONS(1020),
    [anon_sym_consume] = ACTIONS(1020),
    [anon_sym_object] = ACTIONS(1020),
    [sym_number] = ACTIONS(1022),
    [sym_float] = ACTIONS(1020),
    [anon_sym_DQUOTE] = ACTIONS(1022),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1020),
    [anon_sym_SQUOTE] = ACTIONS(1020),
    [anon_sym_true] = ACTIONS(1020),
    [anon_sym_false] = ACTIONS(1020),
    [sym_this] = ACTIONS(1020),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [375] = {
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_EQ] = ACTIONS(1018),
    [anon_sym_AT] = ACTIONS(1016),
    [anon_sym_LBRACK] = ACTIONS(1016),
    [anon_sym_RBRACK] = ACTIONS(1016),
    [anon_sym_is] = ACTIONS(1018),
    [anon_sym_embed] = ACTIONS(1016),
    [anon_sym_let] = ACTIONS(1016),
    [anon_sym_var] = ACTIONS(1016),
    [anon_sym_new] = ACTIONS(1016),
    [anon_sym_EQ_GT] = ACTIONS(1016),
    [anon_sym_fun] = ACTIONS(1016),
    [anon_sym_be] = ACTIONS(1016),
    [anon_sym_COMMA] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(1016),
    [anon_sym_DOT] = ACTIONS(1018),
    [anon_sym_PIPE] = ACTIONS(1016),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_RBRACE] = ACTIONS(1016),
    [anon_sym_SEMI] = ACTIONS(1016),
    [sym_error] = ACTIONS(1016),
    [sym_compile_intrinsic] = ACTIONS(1016),
    [anon_sym_compile_error] = ACTIONS(1016),
    [sym_location] = ACTIONS(1016),
    [anon_sym_DASH] = ACTIONS(1018),
    [anon_sym_not] = ACTIONS(1016),
    [anon_sym_DASH_TILDE] = ACTIONS(1016),
    [anon_sym_addressof] = ACTIONS(1016),
    [anon_sym_digestof] = ACTIONS(1016),
    [anon_sym_PLUS] = ACTIONS(1018),
    [anon_sym_STAR] = ACTIONS(1018),
    [anon_sym_SLASH] = ACTIONS(1018),
    [anon_sym_PERCENT] = ACTIONS(1018),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1018),
    [anon_sym_LT_LT] = ACTIONS(1018),
    [anon_sym_GT_GT] = ACTIONS(1018),
    [anon_sym_and] = ACTIONS(1016),
    [anon_sym_or] = ACTIONS(1016),
    [anon_sym_xor] = ACTIONS(1016),
    [anon_sym_isnt] = ACTIONS(1016),
    [anon_sym_EQ_EQ] = ACTIONS(1018),
    [anon_sym_BANG_EQ] = ACTIONS(1018),
    [anon_sym_GT] = ACTIONS(1018),
    [anon_sym_GT_EQ] = ACTIONS(1018),
    [anon_sym_LT_EQ] = ACTIONS(1018),
    [anon_sym_LT] = ACTIONS(1018),
    [anon_sym_PLUS_TILDE] = ACTIONS(1016),
    [anon_sym_STAR_TILDE] = ACTIONS(1016),
    [anon_sym_SLASH_TILDE] = ACTIONS(1016),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1016),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1016),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1016),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1016),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1016),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1016),
    [anon_sym_GT_TILDE] = ACTIONS(1016),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1016),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1016),
    [anon_sym_LT_TILDE] = ACTIONS(1016),
    [anon_sym_PLUS_QMARK] = ACTIONS(1016),
    [anon_sym_DASH_QMARK] = ACTIONS(1016),
    [anon_sym_STAR_QMARK] = ACTIONS(1016),
    [anon_sym_SLASH_QMARK] = ACTIONS(1016),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1016),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1016),
    [anon_sym_as] = ACTIONS(1016),
    [anon_sym_LPAREN2] = ACTIONS(1016),
    [anon_sym_DOT_GT] = ACTIONS(1016),
    [anon_sym_where] = ACTIONS(1016),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_end] = ACTIONS(1016),
    [anon_sym_if] = ACTIONS(1018),
    [anon_sym_ifdef] = ACTIONS(1016),
    [anon_sym_then] = ACTIONS(1016),
    [anon_sym_iftype] = ACTIONS(1016),
    [anon_sym_else] = ACTIONS(1016),
    [anon_sym_for] = ACTIONS(1016),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_try] = ACTIONS(1016),
    [anon_sym_with] = ACTIONS(1016),
    [anon_sym_repeat] = ACTIONS(1016),
    [anon_sym_until] = ACTIONS(1016),
    [anon_sym_do] = ACTIONS(1016),
    [anon_sym_recover] = ACTIONS(1016),
    [anon_sym_match] = ACTIONS(1016),
    [anon_sym_return] = ACTIONS(1016),
    [anon_sym_continue] = ACTIONS(1016),
    [anon_sym_break] = ACTIONS(1016),
    [anon_sym_consume] = ACTIONS(1016),
    [anon_sym_object] = ACTIONS(1016),
    [sym_number] = ACTIONS(1018),
    [sym_float] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(1018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1016),
    [anon_sym_SQUOTE] = ACTIONS(1016),
    [anon_sym_true] = ACTIONS(1016),
    [anon_sym_false] = ACTIONS(1016),
    [sym_this] = ACTIONS(1016),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [376] = {
    [sym_identifier] = ACTIONS(1030),
    [anon_sym_EQ] = ACTIONS(1030),
    [anon_sym_AT] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(1028),
    [anon_sym_RBRACK] = ACTIONS(1028),
    [anon_sym_is] = ACTIONS(1030),
    [anon_sym_embed] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(1028),
    [anon_sym_var] = ACTIONS(1028),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_EQ_GT] = ACTIONS(1028),
    [anon_sym_fun] = ACTIONS(1028),
    [anon_sym_be] = ACTIONS(1028),
    [anon_sym_COMMA] = ACTIONS(1028),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_RPAREN] = ACTIONS(1028),
    [anon_sym_DOT] = ACTIONS(1030),
    [anon_sym_PIPE] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_RBRACE] = ACTIONS(1028),
    [anon_sym_SEMI] = ACTIONS(1028),
    [sym_error] = ACTIONS(1028),
    [sym_compile_intrinsic] = ACTIONS(1028),
    [anon_sym_compile_error] = ACTIONS(1028),
    [sym_location] = ACTIONS(1028),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_not] = ACTIONS(1028),
    [anon_sym_DASH_TILDE] = ACTIONS(1028),
    [anon_sym_addressof] = ACTIONS(1028),
    [anon_sym_digestof] = ACTIONS(1028),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_STAR] = ACTIONS(1030),
    [anon_sym_SLASH] = ACTIONS(1030),
    [anon_sym_PERCENT] = ACTIONS(1030),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1030),
    [anon_sym_LT_LT] = ACTIONS(1030),
    [anon_sym_GT_GT] = ACTIONS(1030),
    [anon_sym_and] = ACTIONS(1028),
    [anon_sym_or] = ACTIONS(1028),
    [anon_sym_xor] = ACTIONS(1028),
    [anon_sym_isnt] = ACTIONS(1028),
    [anon_sym_EQ_EQ] = ACTIONS(1030),
    [anon_sym_BANG_EQ] = ACTIONS(1030),
    [anon_sym_GT] = ACTIONS(1030),
    [anon_sym_GT_EQ] = ACTIONS(1030),
    [anon_sym_LT_EQ] = ACTIONS(1030),
    [anon_sym_LT] = ACTIONS(1030),
    [anon_sym_PLUS_TILDE] = ACTIONS(1028),
    [anon_sym_STAR_TILDE] = ACTIONS(1028),
    [anon_sym_SLASH_TILDE] = ACTIONS(1028),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1028),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1028),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1028),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1028),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1028),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1028),
    [anon_sym_GT_TILDE] = ACTIONS(1028),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1028),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1028),
    [anon_sym_LT_TILDE] = ACTIONS(1028),
    [anon_sym_PLUS_QMARK] = ACTIONS(1028),
    [anon_sym_DASH_QMARK] = ACTIONS(1028),
    [anon_sym_STAR_QMARK] = ACTIONS(1028),
    [anon_sym_SLASH_QMARK] = ACTIONS(1028),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1028),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1028),
    [anon_sym_as] = ACTIONS(1028),
    [anon_sym_LPAREN2] = ACTIONS(1028),
    [anon_sym_DOT_GT] = ACTIONS(1028),
    [anon_sym_where] = ACTIONS(1028),
    [anon_sym_TILDE] = ACTIONS(1028),
    [anon_sym_end] = ACTIONS(1028),
    [anon_sym_if] = ACTIONS(1030),
    [anon_sym_ifdef] = ACTIONS(1028),
    [anon_sym_then] = ACTIONS(1028),
    [anon_sym_iftype] = ACTIONS(1028),
    [anon_sym_else] = ACTIONS(1028),
    [anon_sym_for] = ACTIONS(1028),
    [anon_sym_while] = ACTIONS(1028),
    [anon_sym_try] = ACTIONS(1028),
    [anon_sym_with] = ACTIONS(1028),
    [anon_sym_repeat] = ACTIONS(1028),
    [anon_sym_until] = ACTIONS(1028),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_recover] = ACTIONS(1028),
    [anon_sym_match] = ACTIONS(1028),
    [anon_sym_return] = ACTIONS(1028),
    [anon_sym_continue] = ACTIONS(1028),
    [anon_sym_break] = ACTIONS(1028),
    [anon_sym_consume] = ACTIONS(1028),
    [anon_sym_object] = ACTIONS(1028),
    [sym_number] = ACTIONS(1030),
    [sym_float] = ACTIONS(1028),
    [anon_sym_DQUOTE] = ACTIONS(1030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1028),
    [anon_sym_SQUOTE] = ACTIONS(1028),
    [anon_sym_true] = ACTIONS(1028),
    [anon_sym_false] = ACTIONS(1028),
    [sym_this] = ACTIONS(1028),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [377] = {
    [sym_string] = STATE(314),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [ts_builtin_sym_end] = ACTIONS(1298),
    [sym_identifier] = ACTIONS(1296),
    [anon_sym_use] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(1296),
    [anon_sym_AT] = ACTIONS(1298),
    [anon_sym_LBRACK] = ACTIONS(1298),
    [anon_sym_type] = ACTIONS(1298),
    [anon_sym_is] = ACTIONS(1296),
    [anon_sym_actor] = ACTIONS(1298),
    [anon_sym_class] = ACTIONS(1298),
    [anon_sym_primitive] = ACTIONS(1298),
    [anon_sym_interface] = ACTIONS(1298),
    [anon_sym_trait] = ACTIONS(1298),
    [anon_sym_struct] = ACTIONS(1298),
    [anon_sym_embed] = ACTIONS(1298),
    [anon_sym_let] = ACTIONS(1298),
    [anon_sym_var] = ACTIONS(1298),
    [anon_sym_new] = ACTIONS(1298),
    [anon_sym_fun] = ACTIONS(1298),
    [anon_sym_be] = ACTIONS(1298),
    [anon_sym_LPAREN] = ACTIONS(1296),
    [anon_sym_DOT] = ACTIONS(1296),
    [anon_sym_LBRACE] = ACTIONS(1298),
    [anon_sym_SEMI] = ACTIONS(1298),
    [sym_error] = ACTIONS(1298),
    [sym_compile_intrinsic] = ACTIONS(1298),
    [anon_sym_compile_error] = ACTIONS(1298),
    [sym_location] = ACTIONS(1298),
    [anon_sym_DASH] = ACTIONS(1296),
    [anon_sym_not] = ACTIONS(1298),
    [anon_sym_DASH_TILDE] = ACTIONS(1298),
    [anon_sym_addressof] = ACTIONS(1298),
    [anon_sym_digestof] = ACTIONS(1298),
    [anon_sym_PLUS] = ACTIONS(1296),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_SLASH] = ACTIONS(1296),
    [anon_sym_PERCENT] = ACTIONS(1296),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1296),
    [anon_sym_LT_LT] = ACTIONS(1296),
    [anon_sym_GT_GT] = ACTIONS(1296),
    [anon_sym_and] = ACTIONS(1298),
    [anon_sym_or] = ACTIONS(1298),
    [anon_sym_xor] = ACTIONS(1298),
    [anon_sym_isnt] = ACTIONS(1298),
    [anon_sym_EQ_EQ] = ACTIONS(1296),
    [anon_sym_BANG_EQ] = ACTIONS(1296),
    [anon_sym_GT] = ACTIONS(1296),
    [anon_sym_GT_EQ] = ACTIONS(1296),
    [anon_sym_LT_EQ] = ACTIONS(1296),
    [anon_sym_LT] = ACTIONS(1296),
    [anon_sym_PLUS_TILDE] = ACTIONS(1298),
    [anon_sym_STAR_TILDE] = ACTIONS(1298),
    [anon_sym_SLASH_TILDE] = ACTIONS(1298),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1298),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1298),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1298),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1298),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1298),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1298),
    [anon_sym_GT_TILDE] = ACTIONS(1298),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1298),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1298),
    [anon_sym_LT_TILDE] = ACTIONS(1298),
    [anon_sym_PLUS_QMARK] = ACTIONS(1298),
    [anon_sym_DASH_QMARK] = ACTIONS(1298),
    [anon_sym_STAR_QMARK] = ACTIONS(1298),
    [anon_sym_SLASH_QMARK] = ACTIONS(1298),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1298),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1298),
    [anon_sym_as] = ACTIONS(1298),
    [anon_sym_LPAREN2] = ACTIONS(1298),
    [anon_sym_DOT_GT] = ACTIONS(1298),
    [anon_sym_TILDE] = ACTIONS(1298),
    [anon_sym_if] = ACTIONS(1296),
    [anon_sym_ifdef] = ACTIONS(1298),
    [anon_sym_iftype] = ACTIONS(1298),
    [anon_sym_for] = ACTIONS(1298),
    [anon_sym_while] = ACTIONS(1298),
    [anon_sym_try] = ACTIONS(1298),
    [anon_sym_with] = ACTIONS(1298),
    [anon_sym_repeat] = ACTIONS(1298),
    [anon_sym_recover] = ACTIONS(1298),
    [anon_sym_match] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1298),
    [anon_sym_continue] = ACTIONS(1298),
    [anon_sym_break] = ACTIONS(1298),
    [anon_sym_consume] = ACTIONS(1298),
    [anon_sym_object] = ACTIONS(1298),
    [sym_number] = ACTIONS(1296),
    [sym_float] = ACTIONS(1298),
    [anon_sym_DQUOTE] = ACTIONS(1296),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1298),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_true] = ACTIONS(1298),
    [anon_sym_false] = ACTIONS(1298),
    [sym_this] = ACTIONS(1298),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [378] = {
    [sym_identifier] = ACTIONS(1258),
    [anon_sym_EQ] = ACTIONS(1258),
    [anon_sym_AT] = ACTIONS(1256),
    [anon_sym_LBRACK] = ACTIONS(1256),
    [anon_sym_RBRACK] = ACTIONS(1256),
    [anon_sym_is] = ACTIONS(1258),
    [anon_sym_embed] = ACTIONS(1256),
    [anon_sym_let] = ACTIONS(1256),
    [anon_sym_var] = ACTIONS(1256),
    [anon_sym_new] = ACTIONS(1256),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_fun] = ACTIONS(1256),
    [anon_sym_be] = ACTIONS(1256),
    [anon_sym_COMMA] = ACTIONS(1256),
    [anon_sym_LPAREN] = ACTIONS(1258),
    [anon_sym_RPAREN] = ACTIONS(1256),
    [anon_sym_DOT] = ACTIONS(1258),
    [anon_sym_PIPE] = ACTIONS(1256),
    [anon_sym_LBRACE] = ACTIONS(1256),
    [anon_sym_RBRACE] = ACTIONS(1256),
    [anon_sym_SEMI] = ACTIONS(1256),
    [sym_error] = ACTIONS(1256),
    [sym_compile_intrinsic] = ACTIONS(1256),
    [anon_sym_compile_error] = ACTIONS(1256),
    [sym_location] = ACTIONS(1256),
    [anon_sym_DASH] = ACTIONS(1258),
    [anon_sym_not] = ACTIONS(1256),
    [anon_sym_DASH_TILDE] = ACTIONS(1256),
    [anon_sym_addressof] = ACTIONS(1256),
    [anon_sym_digestof] = ACTIONS(1256),
    [anon_sym_PLUS] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_SLASH] = ACTIONS(1258),
    [anon_sym_PERCENT] = ACTIONS(1258),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1258),
    [anon_sym_LT_LT] = ACTIONS(1258),
    [anon_sym_GT_GT] = ACTIONS(1258),
    [anon_sym_and] = ACTIONS(1256),
    [anon_sym_or] = ACTIONS(1256),
    [anon_sym_xor] = ACTIONS(1256),
    [anon_sym_isnt] = ACTIONS(1256),
    [anon_sym_EQ_EQ] = ACTIONS(1258),
    [anon_sym_BANG_EQ] = ACTIONS(1258),
    [anon_sym_GT] = ACTIONS(1258),
    [anon_sym_GT_EQ] = ACTIONS(1258),
    [anon_sym_LT_EQ] = ACTIONS(1258),
    [anon_sym_LT] = ACTIONS(1258),
    [anon_sym_PLUS_TILDE] = ACTIONS(1256),
    [anon_sym_STAR_TILDE] = ACTIONS(1256),
    [anon_sym_SLASH_TILDE] = ACTIONS(1256),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1256),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1256),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1256),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1256),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1256),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1256),
    [anon_sym_GT_TILDE] = ACTIONS(1256),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1256),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1256),
    [anon_sym_LT_TILDE] = ACTIONS(1256),
    [anon_sym_PLUS_QMARK] = ACTIONS(1256),
    [anon_sym_DASH_QMARK] = ACTIONS(1256),
    [anon_sym_STAR_QMARK] = ACTIONS(1256),
    [anon_sym_SLASH_QMARK] = ACTIONS(1256),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1256),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1256),
    [anon_sym_as] = ACTIONS(1256),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_DOT_GT] = ACTIONS(1256),
    [anon_sym_where] = ACTIONS(1256),
    [anon_sym_TILDE] = ACTIONS(1256),
    [anon_sym_end] = ACTIONS(1256),
    [anon_sym_if] = ACTIONS(1258),
    [anon_sym_ifdef] = ACTIONS(1256),
    [anon_sym_then] = ACTIONS(1256),
    [anon_sym_iftype] = ACTIONS(1256),
    [anon_sym_else] = ACTIONS(1256),
    [anon_sym_for] = ACTIONS(1256),
    [anon_sym_while] = ACTIONS(1256),
    [anon_sym_try] = ACTIONS(1256),
    [anon_sym_with] = ACTIONS(1256),
    [anon_sym_repeat] = ACTIONS(1256),
    [anon_sym_until] = ACTIONS(1256),
    [anon_sym_do] = ACTIONS(1256),
    [anon_sym_recover] = ACTIONS(1256),
    [anon_sym_match] = ACTIONS(1256),
    [anon_sym_return] = ACTIONS(1256),
    [anon_sym_continue] = ACTIONS(1256),
    [anon_sym_break] = ACTIONS(1256),
    [anon_sym_consume] = ACTIONS(1256),
    [anon_sym_object] = ACTIONS(1256),
    [sym_number] = ACTIONS(1258),
    [sym_float] = ACTIONS(1256),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1256),
    [anon_sym_SQUOTE] = ACTIONS(1256),
    [anon_sym_true] = ACTIONS(1256),
    [anon_sym_false] = ACTIONS(1256),
    [sym_this] = ACTIONS(1256),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [379] = {
    [sym_arguments] = STATE(332),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_EQ] = ACTIONS(29),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_LBRACK] = ACTIONS(1316),
    [anon_sym_RBRACK] = ACTIONS(1316),
    [anon_sym_is] = ACTIONS(33),
    [anon_sym_embed] = ACTIONS(1316),
    [anon_sym_let] = ACTIONS(1316),
    [anon_sym_var] = ACTIONS(1316),
    [anon_sym_new] = ACTIONS(1316),
    [anon_sym_EQ_GT] = ACTIONS(1316),
    [anon_sym_fun] = ACTIONS(1316),
    [anon_sym_be] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_RPAREN] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(35),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_RBRACE] = ACTIONS(1316),
    [anon_sym_SEMI] = ACTIONS(1316),
    [sym_error] = ACTIONS(1316),
    [sym_compile_intrinsic] = ACTIONS(1316),
    [anon_sym_compile_error] = ACTIONS(1316),
    [sym_location] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(33),
    [anon_sym_not] = ACTIONS(1316),
    [anon_sym_DASH_TILDE] = ACTIONS(41),
    [anon_sym_addressof] = ACTIONS(1316),
    [anon_sym_digestof] = ACTIONS(1316),
    [anon_sym_PLUS] = ACTIONS(33),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_SLASH] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(33),
    [anon_sym_LT_LT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(33),
    [anon_sym_and] = ACTIONS(41),
    [anon_sym_or] = ACTIONS(41),
    [anon_sym_xor] = ACTIONS(41),
    [anon_sym_isnt] = ACTIONS(41),
    [anon_sym_EQ_EQ] = ACTIONS(33),
    [anon_sym_BANG_EQ] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(33),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_PLUS_TILDE] = ACTIONS(41),
    [anon_sym_STAR_TILDE] = ACTIONS(41),
    [anon_sym_SLASH_TILDE] = ACTIONS(41),
    [anon_sym_PERCENT_TILDE] = ACTIONS(41),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(41),
    [anon_sym_LT_LT_TILDE] = ACTIONS(41),
    [anon_sym_GT_GT_TILDE] = ACTIONS(41),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(41),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(41),
    [anon_sym_GT_TILDE] = ACTIONS(41),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(41),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(41),
    [anon_sym_LT_TILDE] = ACTIONS(41),
    [anon_sym_PLUS_QMARK] = ACTIONS(41),
    [anon_sym_DASH_QMARK] = ACTIONS(41),
    [anon_sym_STAR_QMARK] = ACTIONS(41),
    [anon_sym_SLASH_QMARK] = ACTIONS(41),
    [anon_sym_PERCENT_QMARK] = ACTIONS(41),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(41),
    [anon_sym_as] = ACTIONS(43),
    [anon_sym_LPAREN2] = ACTIONS(45),
    [anon_sym_DOT_GT] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(1316),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_ifdef] = ACTIONS(1316),
    [anon_sym_then] = ACTIONS(1316),
    [anon_sym_iftype] = ACTIONS(1316),
    [anon_sym_else] = ACTIONS(1316),
    [anon_sym_for] = ACTIONS(1316),
    [anon_sym_while] = ACTIONS(1316),
    [anon_sym_try] = ACTIONS(1316),
    [anon_sym_with] = ACTIONS(1316),
    [anon_sym_repeat] = ACTIONS(1316),
    [anon_sym_until] = ACTIONS(1316),
    [anon_sym_do] = ACTIONS(1316),
    [anon_sym_recover] = ACTIONS(1316),
    [anon_sym_match] = ACTIONS(1316),
    [anon_sym_return] = ACTIONS(1316),
    [anon_sym_continue] = ACTIONS(1316),
    [anon_sym_break] = ACTIONS(1316),
    [anon_sym_consume] = ACTIONS(1316),
    [anon_sym_object] = ACTIONS(1316),
    [sym_number] = ACTIONS(1314),
    [sym_float] = ACTIONS(1316),
    [anon_sym_DQUOTE] = ACTIONS(1314),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1316),
    [anon_sym_true] = ACTIONS(1316),
    [anon_sym_false] = ACTIONS(1316),
    [sym_this] = ACTIONS(1316),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [380] = {
    [sym_identifier] = ACTIONS(1096),
    [anon_sym_EQ] = ACTIONS(1096),
    [anon_sym_AT] = ACTIONS(1094),
    [anon_sym_LBRACK] = ACTIONS(1094),
    [anon_sym_RBRACK] = ACTIONS(1094),
    [anon_sym_is] = ACTIONS(1096),
    [anon_sym_embed] = ACTIONS(1094),
    [anon_sym_let] = ACTIONS(1094),
    [anon_sym_var] = ACTIONS(1094),
    [anon_sym_new] = ACTIONS(1094),
    [anon_sym_EQ_GT] = ACTIONS(1094),
    [anon_sym_fun] = ACTIONS(1094),
    [anon_sym_be] = ACTIONS(1094),
    [anon_sym_COMMA] = ACTIONS(1094),
    [anon_sym_LPAREN] = ACTIONS(1096),
    [anon_sym_RPAREN] = ACTIONS(1094),
    [anon_sym_DOT] = ACTIONS(1096),
    [anon_sym_PIPE] = ACTIONS(1094),
    [anon_sym_LBRACE] = ACTIONS(1094),
    [anon_sym_RBRACE] = ACTIONS(1094),
    [anon_sym_SEMI] = ACTIONS(1094),
    [sym_error] = ACTIONS(1094),
    [sym_compile_intrinsic] = ACTIONS(1094),
    [anon_sym_compile_error] = ACTIONS(1094),
    [sym_location] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1096),
    [anon_sym_not] = ACTIONS(1094),
    [anon_sym_DASH_TILDE] = ACTIONS(1094),
    [anon_sym_addressof] = ACTIONS(1094),
    [anon_sym_digestof] = ACTIONS(1094),
    [anon_sym_PLUS] = ACTIONS(1096),
    [anon_sym_STAR] = ACTIONS(1096),
    [anon_sym_SLASH] = ACTIONS(1096),
    [anon_sym_PERCENT] = ACTIONS(1096),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1096),
    [anon_sym_LT_LT] = ACTIONS(1096),
    [anon_sym_GT_GT] = ACTIONS(1096),
    [anon_sym_and] = ACTIONS(1094),
    [anon_sym_or] = ACTIONS(1094),
    [anon_sym_xor] = ACTIONS(1094),
    [anon_sym_isnt] = ACTIONS(1094),
    [anon_sym_EQ_EQ] = ACTIONS(1096),
    [anon_sym_BANG_EQ] = ACTIONS(1096),
    [anon_sym_GT] = ACTIONS(1096),
    [anon_sym_GT_EQ] = ACTIONS(1096),
    [anon_sym_LT_EQ] = ACTIONS(1096),
    [anon_sym_LT] = ACTIONS(1096),
    [anon_sym_PLUS_TILDE] = ACTIONS(1094),
    [anon_sym_STAR_TILDE] = ACTIONS(1094),
    [anon_sym_SLASH_TILDE] = ACTIONS(1094),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1094),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1094),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1094),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1094),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1094),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1094),
    [anon_sym_GT_TILDE] = ACTIONS(1094),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1094),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1094),
    [anon_sym_LT_TILDE] = ACTIONS(1094),
    [anon_sym_PLUS_QMARK] = ACTIONS(1094),
    [anon_sym_DASH_QMARK] = ACTIONS(1094),
    [anon_sym_STAR_QMARK] = ACTIONS(1094),
    [anon_sym_SLASH_QMARK] = ACTIONS(1094),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1094),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1094),
    [anon_sym_as] = ACTIONS(1094),
    [anon_sym_LPAREN2] = ACTIONS(1094),
    [anon_sym_DOT_GT] = ACTIONS(1094),
    [anon_sym_where] = ACTIONS(1094),
    [anon_sym_TILDE] = ACTIONS(1094),
    [anon_sym_end] = ACTIONS(1094),
    [anon_sym_if] = ACTIONS(1096),
    [anon_sym_ifdef] = ACTIONS(1094),
    [anon_sym_then] = ACTIONS(1094),
    [anon_sym_iftype] = ACTIONS(1094),
    [anon_sym_else] = ACTIONS(1094),
    [anon_sym_for] = ACTIONS(1094),
    [anon_sym_while] = ACTIONS(1094),
    [anon_sym_try] = ACTIONS(1094),
    [anon_sym_with] = ACTIONS(1094),
    [anon_sym_repeat] = ACTIONS(1094),
    [anon_sym_until] = ACTIONS(1094),
    [anon_sym_do] = ACTIONS(1094),
    [anon_sym_recover] = ACTIONS(1094),
    [anon_sym_match] = ACTIONS(1094),
    [anon_sym_return] = ACTIONS(1094),
    [anon_sym_continue] = ACTIONS(1094),
    [anon_sym_break] = ACTIONS(1094),
    [anon_sym_consume] = ACTIONS(1094),
    [anon_sym_object] = ACTIONS(1094),
    [sym_number] = ACTIONS(1096),
    [sym_float] = ACTIONS(1094),
    [anon_sym_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_SQUOTE] = ACTIONS(1094),
    [anon_sym_true] = ACTIONS(1094),
    [anon_sym_false] = ACTIONS(1094),
    [sym_this] = ACTIONS(1094),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [381] = {
    [sym_identifier] = ACTIONS(1262),
    [anon_sym_EQ] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(1260),
    [anon_sym_LBRACK] = ACTIONS(1260),
    [anon_sym_RBRACK] = ACTIONS(1260),
    [anon_sym_is] = ACTIONS(1262),
    [anon_sym_embed] = ACTIONS(1260),
    [anon_sym_let] = ACTIONS(1260),
    [anon_sym_var] = ACTIONS(1260),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_EQ_GT] = ACTIONS(1260),
    [anon_sym_fun] = ACTIONS(1260),
    [anon_sym_be] = ACTIONS(1260),
    [anon_sym_COMMA] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1262),
    [anon_sym_RPAREN] = ACTIONS(1260),
    [anon_sym_DOT] = ACTIONS(1262),
    [anon_sym_PIPE] = ACTIONS(1260),
    [anon_sym_LBRACE] = ACTIONS(1260),
    [anon_sym_RBRACE] = ACTIONS(1260),
    [anon_sym_SEMI] = ACTIONS(1260),
    [sym_error] = ACTIONS(1260),
    [sym_compile_intrinsic] = ACTIONS(1260),
    [anon_sym_compile_error] = ACTIONS(1260),
    [sym_location] = ACTIONS(1260),
    [anon_sym_DASH] = ACTIONS(1262),
    [anon_sym_not] = ACTIONS(1260),
    [anon_sym_DASH_TILDE] = ACTIONS(1260),
    [anon_sym_addressof] = ACTIONS(1260),
    [anon_sym_digestof] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(1262),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_SLASH] = ACTIONS(1262),
    [anon_sym_PERCENT] = ACTIONS(1262),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1262),
    [anon_sym_LT_LT] = ACTIONS(1262),
    [anon_sym_GT_GT] = ACTIONS(1262),
    [anon_sym_and] = ACTIONS(1260),
    [anon_sym_or] = ACTIONS(1260),
    [anon_sym_xor] = ACTIONS(1260),
    [anon_sym_isnt] = ACTIONS(1260),
    [anon_sym_EQ_EQ] = ACTIONS(1262),
    [anon_sym_BANG_EQ] = ACTIONS(1262),
    [anon_sym_GT] = ACTIONS(1262),
    [anon_sym_GT_EQ] = ACTIONS(1262),
    [anon_sym_LT_EQ] = ACTIONS(1262),
    [anon_sym_LT] = ACTIONS(1262),
    [anon_sym_PLUS_TILDE] = ACTIONS(1260),
    [anon_sym_STAR_TILDE] = ACTIONS(1260),
    [anon_sym_SLASH_TILDE] = ACTIONS(1260),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1260),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1260),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1260),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1260),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1260),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1260),
    [anon_sym_GT_TILDE] = ACTIONS(1260),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1260),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1260),
    [anon_sym_LT_TILDE] = ACTIONS(1260),
    [anon_sym_PLUS_QMARK] = ACTIONS(1260),
    [anon_sym_DASH_QMARK] = ACTIONS(1260),
    [anon_sym_STAR_QMARK] = ACTIONS(1260),
    [anon_sym_SLASH_QMARK] = ACTIONS(1260),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1260),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(1260),
    [anon_sym_LPAREN2] = ACTIONS(1260),
    [anon_sym_DOT_GT] = ACTIONS(1260),
    [anon_sym_where] = ACTIONS(1260),
    [anon_sym_TILDE] = ACTIONS(1260),
    [anon_sym_end] = ACTIONS(1260),
    [anon_sym_if] = ACTIONS(1262),
    [anon_sym_ifdef] = ACTIONS(1260),
    [anon_sym_then] = ACTIONS(1260),
    [anon_sym_iftype] = ACTIONS(1260),
    [anon_sym_else] = ACTIONS(1260),
    [anon_sym_for] = ACTIONS(1260),
    [anon_sym_while] = ACTIONS(1260),
    [anon_sym_try] = ACTIONS(1260),
    [anon_sym_with] = ACTIONS(1260),
    [anon_sym_repeat] = ACTIONS(1260),
    [anon_sym_until] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_recover] = ACTIONS(1260),
    [anon_sym_match] = ACTIONS(1260),
    [anon_sym_return] = ACTIONS(1260),
    [anon_sym_continue] = ACTIONS(1260),
    [anon_sym_break] = ACTIONS(1260),
    [anon_sym_consume] = ACTIONS(1260),
    [anon_sym_object] = ACTIONS(1260),
    [sym_number] = ACTIONS(1262),
    [sym_float] = ACTIONS(1260),
    [anon_sym_DQUOTE] = ACTIONS(1262),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1260),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [anon_sym_true] = ACTIONS(1260),
    [anon_sym_false] = ACTIONS(1260),
    [sym_this] = ACTIONS(1260),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [382] = {
    [sym_identifier] = ACTIONS(1088),
    [anon_sym_EQ] = ACTIONS(1088),
    [anon_sym_AT] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(1086),
    [anon_sym_is] = ACTIONS(1088),
    [anon_sym_embed] = ACTIONS(1086),
    [anon_sym_let] = ACTIONS(1086),
    [anon_sym_var] = ACTIONS(1086),
    [anon_sym_new] = ACTIONS(1086),
    [anon_sym_EQ_GT] = ACTIONS(1086),
    [anon_sym_fun] = ACTIONS(1086),
    [anon_sym_be] = ACTIONS(1086),
    [anon_sym_COMMA] = ACTIONS(1086),
    [anon_sym_LPAREN] = ACTIONS(1088),
    [anon_sym_RPAREN] = ACTIONS(1086),
    [anon_sym_DOT] = ACTIONS(1088),
    [anon_sym_PIPE] = ACTIONS(1086),
    [anon_sym_LBRACE] = ACTIONS(1086),
    [anon_sym_RBRACE] = ACTIONS(1086),
    [anon_sym_SEMI] = ACTIONS(1086),
    [sym_error] = ACTIONS(1086),
    [sym_compile_intrinsic] = ACTIONS(1086),
    [anon_sym_compile_error] = ACTIONS(1086),
    [sym_location] = ACTIONS(1086),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_not] = ACTIONS(1086),
    [anon_sym_DASH_TILDE] = ACTIONS(1086),
    [anon_sym_addressof] = ACTIONS(1086),
    [anon_sym_digestof] = ACTIONS(1086),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_STAR] = ACTIONS(1088),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_PERCENT] = ACTIONS(1088),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1088),
    [anon_sym_LT_LT] = ACTIONS(1088),
    [anon_sym_GT_GT] = ACTIONS(1088),
    [anon_sym_and] = ACTIONS(1086),
    [anon_sym_or] = ACTIONS(1086),
    [anon_sym_xor] = ACTIONS(1086),
    [anon_sym_isnt] = ACTIONS(1086),
    [anon_sym_EQ_EQ] = ACTIONS(1088),
    [anon_sym_BANG_EQ] = ACTIONS(1088),
    [anon_sym_GT] = ACTIONS(1088),
    [anon_sym_GT_EQ] = ACTIONS(1088),
    [anon_sym_LT_EQ] = ACTIONS(1088),
    [anon_sym_LT] = ACTIONS(1088),
    [anon_sym_PLUS_TILDE] = ACTIONS(1086),
    [anon_sym_STAR_TILDE] = ACTIONS(1086),
    [anon_sym_SLASH_TILDE] = ACTIONS(1086),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1086),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1086),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1086),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1086),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1086),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1086),
    [anon_sym_GT_TILDE] = ACTIONS(1086),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1086),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1086),
    [anon_sym_LT_TILDE] = ACTIONS(1086),
    [anon_sym_PLUS_QMARK] = ACTIONS(1086),
    [anon_sym_DASH_QMARK] = ACTIONS(1086),
    [anon_sym_STAR_QMARK] = ACTIONS(1086),
    [anon_sym_SLASH_QMARK] = ACTIONS(1086),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1086),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1086),
    [anon_sym_as] = ACTIONS(1086),
    [anon_sym_LPAREN2] = ACTIONS(1086),
    [anon_sym_DOT_GT] = ACTIONS(1086),
    [anon_sym_where] = ACTIONS(1086),
    [anon_sym_TILDE] = ACTIONS(1086),
    [anon_sym_end] = ACTIONS(1086),
    [anon_sym_if] = ACTIONS(1088),
    [anon_sym_ifdef] = ACTIONS(1086),
    [anon_sym_then] = ACTIONS(1086),
    [anon_sym_iftype] = ACTIONS(1086),
    [anon_sym_else] = ACTIONS(1086),
    [anon_sym_for] = ACTIONS(1086),
    [anon_sym_while] = ACTIONS(1086),
    [anon_sym_try] = ACTIONS(1086),
    [anon_sym_with] = ACTIONS(1086),
    [anon_sym_repeat] = ACTIONS(1086),
    [anon_sym_until] = ACTIONS(1086),
    [anon_sym_do] = ACTIONS(1086),
    [anon_sym_recover] = ACTIONS(1086),
    [anon_sym_match] = ACTIONS(1086),
    [anon_sym_return] = ACTIONS(1086),
    [anon_sym_continue] = ACTIONS(1086),
    [anon_sym_break] = ACTIONS(1086),
    [anon_sym_consume] = ACTIONS(1086),
    [anon_sym_object] = ACTIONS(1086),
    [sym_number] = ACTIONS(1088),
    [sym_float] = ACTIONS(1086),
    [anon_sym_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1086),
    [anon_sym_true] = ACTIONS(1086),
    [anon_sym_false] = ACTIONS(1086),
    [sym_this] = ACTIONS(1086),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [383] = {
    [sym_identifier] = ACTIONS(1084),
    [anon_sym_EQ] = ACTIONS(1084),
    [anon_sym_AT] = ACTIONS(1082),
    [anon_sym_LBRACK] = ACTIONS(1082),
    [anon_sym_RBRACK] = ACTIONS(1082),
    [anon_sym_is] = ACTIONS(1084),
    [anon_sym_embed] = ACTIONS(1082),
    [anon_sym_let] = ACTIONS(1082),
    [anon_sym_var] = ACTIONS(1082),
    [anon_sym_new] = ACTIONS(1082),
    [anon_sym_EQ_GT] = ACTIONS(1082),
    [anon_sym_fun] = ACTIONS(1082),
    [anon_sym_be] = ACTIONS(1082),
    [anon_sym_COMMA] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1084),
    [anon_sym_RPAREN] = ACTIONS(1082),
    [anon_sym_DOT] = ACTIONS(1084),
    [anon_sym_PIPE] = ACTIONS(1082),
    [anon_sym_LBRACE] = ACTIONS(1082),
    [anon_sym_RBRACE] = ACTIONS(1082),
    [anon_sym_SEMI] = ACTIONS(1082),
    [sym_error] = ACTIONS(1082),
    [sym_compile_intrinsic] = ACTIONS(1082),
    [anon_sym_compile_error] = ACTIONS(1082),
    [sym_location] = ACTIONS(1082),
    [anon_sym_DASH] = ACTIONS(1084),
    [anon_sym_not] = ACTIONS(1082),
    [anon_sym_DASH_TILDE] = ACTIONS(1082),
    [anon_sym_addressof] = ACTIONS(1082),
    [anon_sym_digestof] = ACTIONS(1082),
    [anon_sym_PLUS] = ACTIONS(1084),
    [anon_sym_STAR] = ACTIONS(1084),
    [anon_sym_SLASH] = ACTIONS(1084),
    [anon_sym_PERCENT] = ACTIONS(1084),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1084),
    [anon_sym_LT_LT] = ACTIONS(1084),
    [anon_sym_GT_GT] = ACTIONS(1084),
    [anon_sym_and] = ACTIONS(1082),
    [anon_sym_or] = ACTIONS(1082),
    [anon_sym_xor] = ACTIONS(1082),
    [anon_sym_isnt] = ACTIONS(1082),
    [anon_sym_EQ_EQ] = ACTIONS(1084),
    [anon_sym_BANG_EQ] = ACTIONS(1084),
    [anon_sym_GT] = ACTIONS(1084),
    [anon_sym_GT_EQ] = ACTIONS(1084),
    [anon_sym_LT_EQ] = ACTIONS(1084),
    [anon_sym_LT] = ACTIONS(1084),
    [anon_sym_PLUS_TILDE] = ACTIONS(1082),
    [anon_sym_STAR_TILDE] = ACTIONS(1082),
    [anon_sym_SLASH_TILDE] = ACTIONS(1082),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1082),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1082),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1082),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1082),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1082),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1082),
    [anon_sym_GT_TILDE] = ACTIONS(1082),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1082),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1082),
    [anon_sym_LT_TILDE] = ACTIONS(1082),
    [anon_sym_PLUS_QMARK] = ACTIONS(1082),
    [anon_sym_DASH_QMARK] = ACTIONS(1082),
    [anon_sym_STAR_QMARK] = ACTIONS(1082),
    [anon_sym_SLASH_QMARK] = ACTIONS(1082),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1082),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1082),
    [anon_sym_as] = ACTIONS(1082),
    [anon_sym_LPAREN2] = ACTIONS(1082),
    [anon_sym_DOT_GT] = ACTIONS(1082),
    [anon_sym_where] = ACTIONS(1082),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_end] = ACTIONS(1082),
    [anon_sym_if] = ACTIONS(1084),
    [anon_sym_ifdef] = ACTIONS(1082),
    [anon_sym_then] = ACTIONS(1082),
    [anon_sym_iftype] = ACTIONS(1082),
    [anon_sym_else] = ACTIONS(1082),
    [anon_sym_for] = ACTIONS(1082),
    [anon_sym_while] = ACTIONS(1082),
    [anon_sym_try] = ACTIONS(1082),
    [anon_sym_with] = ACTIONS(1082),
    [anon_sym_repeat] = ACTIONS(1082),
    [anon_sym_until] = ACTIONS(1082),
    [anon_sym_do] = ACTIONS(1082),
    [anon_sym_recover] = ACTIONS(1082),
    [anon_sym_match] = ACTIONS(1082),
    [anon_sym_return] = ACTIONS(1082),
    [anon_sym_continue] = ACTIONS(1082),
    [anon_sym_break] = ACTIONS(1082),
    [anon_sym_consume] = ACTIONS(1082),
    [anon_sym_object] = ACTIONS(1082),
    [sym_number] = ACTIONS(1084),
    [sym_float] = ACTIONS(1082),
    [anon_sym_DQUOTE] = ACTIONS(1084),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1082),
    [anon_sym_SQUOTE] = ACTIONS(1082),
    [anon_sym_true] = ACTIONS(1082),
    [anon_sym_false] = ACTIONS(1082),
    [sym_this] = ACTIONS(1082),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [384] = {
    [sym_identifier] = ACTIONS(1080),
    [anon_sym_EQ] = ACTIONS(1080),
    [anon_sym_AT] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1078),
    [anon_sym_RBRACK] = ACTIONS(1078),
    [anon_sym_is] = ACTIONS(1080),
    [anon_sym_embed] = ACTIONS(1078),
    [anon_sym_let] = ACTIONS(1078),
    [anon_sym_var] = ACTIONS(1078),
    [anon_sym_new] = ACTIONS(1078),
    [anon_sym_EQ_GT] = ACTIONS(1078),
    [anon_sym_fun] = ACTIONS(1078),
    [anon_sym_be] = ACTIONS(1078),
    [anon_sym_COMMA] = ACTIONS(1078),
    [anon_sym_LPAREN] = ACTIONS(1080),
    [anon_sym_RPAREN] = ACTIONS(1078),
    [anon_sym_DOT] = ACTIONS(1080),
    [anon_sym_PIPE] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(1078),
    [anon_sym_RBRACE] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(1078),
    [sym_error] = ACTIONS(1078),
    [sym_compile_intrinsic] = ACTIONS(1078),
    [anon_sym_compile_error] = ACTIONS(1078),
    [sym_location] = ACTIONS(1078),
    [anon_sym_DASH] = ACTIONS(1080),
    [anon_sym_not] = ACTIONS(1078),
    [anon_sym_DASH_TILDE] = ACTIONS(1078),
    [anon_sym_addressof] = ACTIONS(1078),
    [anon_sym_digestof] = ACTIONS(1078),
    [anon_sym_PLUS] = ACTIONS(1080),
    [anon_sym_STAR] = ACTIONS(1080),
    [anon_sym_SLASH] = ACTIONS(1080),
    [anon_sym_PERCENT] = ACTIONS(1080),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1080),
    [anon_sym_LT_LT] = ACTIONS(1080),
    [anon_sym_GT_GT] = ACTIONS(1080),
    [anon_sym_and] = ACTIONS(1078),
    [anon_sym_or] = ACTIONS(1078),
    [anon_sym_xor] = ACTIONS(1078),
    [anon_sym_isnt] = ACTIONS(1078),
    [anon_sym_EQ_EQ] = ACTIONS(1080),
    [anon_sym_BANG_EQ] = ACTIONS(1080),
    [anon_sym_GT] = ACTIONS(1080),
    [anon_sym_GT_EQ] = ACTIONS(1080),
    [anon_sym_LT_EQ] = ACTIONS(1080),
    [anon_sym_LT] = ACTIONS(1080),
    [anon_sym_PLUS_TILDE] = ACTIONS(1078),
    [anon_sym_STAR_TILDE] = ACTIONS(1078),
    [anon_sym_SLASH_TILDE] = ACTIONS(1078),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1078),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1078),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1078),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1078),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1078),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1078),
    [anon_sym_GT_TILDE] = ACTIONS(1078),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1078),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1078),
    [anon_sym_LT_TILDE] = ACTIONS(1078),
    [anon_sym_PLUS_QMARK] = ACTIONS(1078),
    [anon_sym_DASH_QMARK] = ACTIONS(1078),
    [anon_sym_STAR_QMARK] = ACTIONS(1078),
    [anon_sym_SLASH_QMARK] = ACTIONS(1078),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1078),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1078),
    [anon_sym_as] = ACTIONS(1078),
    [anon_sym_LPAREN2] = ACTIONS(1078),
    [anon_sym_DOT_GT] = ACTIONS(1078),
    [anon_sym_where] = ACTIONS(1078),
    [anon_sym_TILDE] = ACTIONS(1078),
    [anon_sym_end] = ACTIONS(1078),
    [anon_sym_if] = ACTIONS(1080),
    [anon_sym_ifdef] = ACTIONS(1078),
    [anon_sym_then] = ACTIONS(1078),
    [anon_sym_iftype] = ACTIONS(1078),
    [anon_sym_else] = ACTIONS(1078),
    [anon_sym_for] = ACTIONS(1078),
    [anon_sym_while] = ACTIONS(1078),
    [anon_sym_try] = ACTIONS(1078),
    [anon_sym_with] = ACTIONS(1078),
    [anon_sym_repeat] = ACTIONS(1078),
    [anon_sym_until] = ACTIONS(1078),
    [anon_sym_do] = ACTIONS(1078),
    [anon_sym_recover] = ACTIONS(1078),
    [anon_sym_match] = ACTIONS(1078),
    [anon_sym_return] = ACTIONS(1078),
    [anon_sym_continue] = ACTIONS(1078),
    [anon_sym_break] = ACTIONS(1078),
    [anon_sym_consume] = ACTIONS(1078),
    [anon_sym_object] = ACTIONS(1078),
    [sym_number] = ACTIONS(1080),
    [sym_float] = ACTIONS(1078),
    [anon_sym_DQUOTE] = ACTIONS(1080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1078),
    [anon_sym_SQUOTE] = ACTIONS(1078),
    [anon_sym_true] = ACTIONS(1078),
    [anon_sym_false] = ACTIONS(1078),
    [sym_this] = ACTIONS(1078),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [385] = {
    [sym_identifier] = ACTIONS(1076),
    [anon_sym_EQ] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1074),
    [anon_sym_RBRACK] = ACTIONS(1074),
    [anon_sym_is] = ACTIONS(1076),
    [anon_sym_embed] = ACTIONS(1074),
    [anon_sym_let] = ACTIONS(1074),
    [anon_sym_var] = ACTIONS(1074),
    [anon_sym_new] = ACTIONS(1074),
    [anon_sym_EQ_GT] = ACTIONS(1074),
    [anon_sym_fun] = ACTIONS(1074),
    [anon_sym_be] = ACTIONS(1074),
    [anon_sym_COMMA] = ACTIONS(1074),
    [anon_sym_LPAREN] = ACTIONS(1076),
    [anon_sym_RPAREN] = ACTIONS(1074),
    [anon_sym_DOT] = ACTIONS(1076),
    [anon_sym_PIPE] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1074),
    [anon_sym_RBRACE] = ACTIONS(1074),
    [anon_sym_SEMI] = ACTIONS(1074),
    [sym_error] = ACTIONS(1074),
    [sym_compile_intrinsic] = ACTIONS(1074),
    [anon_sym_compile_error] = ACTIONS(1074),
    [sym_location] = ACTIONS(1074),
    [anon_sym_DASH] = ACTIONS(1076),
    [anon_sym_not] = ACTIONS(1074),
    [anon_sym_DASH_TILDE] = ACTIONS(1074),
    [anon_sym_addressof] = ACTIONS(1074),
    [anon_sym_digestof] = ACTIONS(1074),
    [anon_sym_PLUS] = ACTIONS(1076),
    [anon_sym_STAR] = ACTIONS(1076),
    [anon_sym_SLASH] = ACTIONS(1076),
    [anon_sym_PERCENT] = ACTIONS(1076),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1076),
    [anon_sym_LT_LT] = ACTIONS(1076),
    [anon_sym_GT_GT] = ACTIONS(1076),
    [anon_sym_and] = ACTIONS(1074),
    [anon_sym_or] = ACTIONS(1074),
    [anon_sym_xor] = ACTIONS(1074),
    [anon_sym_isnt] = ACTIONS(1074),
    [anon_sym_EQ_EQ] = ACTIONS(1076),
    [anon_sym_BANG_EQ] = ACTIONS(1076),
    [anon_sym_GT] = ACTIONS(1076),
    [anon_sym_GT_EQ] = ACTIONS(1076),
    [anon_sym_LT_EQ] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1076),
    [anon_sym_PLUS_TILDE] = ACTIONS(1074),
    [anon_sym_STAR_TILDE] = ACTIONS(1074),
    [anon_sym_SLASH_TILDE] = ACTIONS(1074),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1074),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1074),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1074),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1074),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1074),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1074),
    [anon_sym_GT_TILDE] = ACTIONS(1074),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1074),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1074),
    [anon_sym_LT_TILDE] = ACTIONS(1074),
    [anon_sym_PLUS_QMARK] = ACTIONS(1074),
    [anon_sym_DASH_QMARK] = ACTIONS(1074),
    [anon_sym_STAR_QMARK] = ACTIONS(1074),
    [anon_sym_SLASH_QMARK] = ACTIONS(1074),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1074),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1074),
    [anon_sym_as] = ACTIONS(1074),
    [anon_sym_LPAREN2] = ACTIONS(1074),
    [anon_sym_DOT_GT] = ACTIONS(1074),
    [anon_sym_where] = ACTIONS(1074),
    [anon_sym_TILDE] = ACTIONS(1074),
    [anon_sym_end] = ACTIONS(1074),
    [anon_sym_if] = ACTIONS(1076),
    [anon_sym_ifdef] = ACTIONS(1074),
    [anon_sym_then] = ACTIONS(1074),
    [anon_sym_iftype] = ACTIONS(1074),
    [anon_sym_else] = ACTIONS(1074),
    [anon_sym_for] = ACTIONS(1074),
    [anon_sym_while] = ACTIONS(1074),
    [anon_sym_try] = ACTIONS(1074),
    [anon_sym_with] = ACTIONS(1074),
    [anon_sym_repeat] = ACTIONS(1074),
    [anon_sym_until] = ACTIONS(1074),
    [anon_sym_do] = ACTIONS(1074),
    [anon_sym_recover] = ACTIONS(1074),
    [anon_sym_match] = ACTIONS(1074),
    [anon_sym_return] = ACTIONS(1074),
    [anon_sym_continue] = ACTIONS(1074),
    [anon_sym_break] = ACTIONS(1074),
    [anon_sym_consume] = ACTIONS(1074),
    [anon_sym_object] = ACTIONS(1074),
    [sym_number] = ACTIONS(1076),
    [sym_float] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1074),
    [anon_sym_SQUOTE] = ACTIONS(1074),
    [anon_sym_true] = ACTIONS(1074),
    [anon_sym_false] = ACTIONS(1074),
    [sym_this] = ACTIONS(1074),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [386] = {
    [sym_identifier] = ACTIONS(1072),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_AT] = ACTIONS(1070),
    [anon_sym_LBRACK] = ACTIONS(1070),
    [anon_sym_RBRACK] = ACTIONS(1070),
    [anon_sym_is] = ACTIONS(1072),
    [anon_sym_embed] = ACTIONS(1070),
    [anon_sym_let] = ACTIONS(1070),
    [anon_sym_var] = ACTIONS(1070),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_EQ_GT] = ACTIONS(1070),
    [anon_sym_fun] = ACTIONS(1070),
    [anon_sym_be] = ACTIONS(1070),
    [anon_sym_COMMA] = ACTIONS(1070),
    [anon_sym_LPAREN] = ACTIONS(1072),
    [anon_sym_RPAREN] = ACTIONS(1070),
    [anon_sym_DOT] = ACTIONS(1072),
    [anon_sym_PIPE] = ACTIONS(1070),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_RBRACE] = ACTIONS(1070),
    [anon_sym_SEMI] = ACTIONS(1070),
    [sym_error] = ACTIONS(1070),
    [sym_compile_intrinsic] = ACTIONS(1070),
    [anon_sym_compile_error] = ACTIONS(1070),
    [sym_location] = ACTIONS(1070),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_not] = ACTIONS(1070),
    [anon_sym_DASH_TILDE] = ACTIONS(1070),
    [anon_sym_addressof] = ACTIONS(1070),
    [anon_sym_digestof] = ACTIONS(1070),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_STAR] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1072),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_and] = ACTIONS(1070),
    [anon_sym_or] = ACTIONS(1070),
    [anon_sym_xor] = ACTIONS(1070),
    [anon_sym_isnt] = ACTIONS(1070),
    [anon_sym_EQ_EQ] = ACTIONS(1072),
    [anon_sym_BANG_EQ] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_GT_EQ] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_PLUS_TILDE] = ACTIONS(1070),
    [anon_sym_STAR_TILDE] = ACTIONS(1070),
    [anon_sym_SLASH_TILDE] = ACTIONS(1070),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1070),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1070),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1070),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1070),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1070),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1070),
    [anon_sym_GT_TILDE] = ACTIONS(1070),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1070),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1070),
    [anon_sym_LT_TILDE] = ACTIONS(1070),
    [anon_sym_PLUS_QMARK] = ACTIONS(1070),
    [anon_sym_DASH_QMARK] = ACTIONS(1070),
    [anon_sym_STAR_QMARK] = ACTIONS(1070),
    [anon_sym_SLASH_QMARK] = ACTIONS(1070),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1070),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1070),
    [anon_sym_as] = ACTIONS(1070),
    [anon_sym_LPAREN2] = ACTIONS(1070),
    [anon_sym_DOT_GT] = ACTIONS(1070),
    [anon_sym_where] = ACTIONS(1070),
    [anon_sym_TILDE] = ACTIONS(1070),
    [anon_sym_end] = ACTIONS(1070),
    [anon_sym_if] = ACTIONS(1072),
    [anon_sym_ifdef] = ACTIONS(1070),
    [anon_sym_then] = ACTIONS(1070),
    [anon_sym_iftype] = ACTIONS(1070),
    [anon_sym_else] = ACTIONS(1070),
    [anon_sym_for] = ACTIONS(1070),
    [anon_sym_while] = ACTIONS(1070),
    [anon_sym_try] = ACTIONS(1070),
    [anon_sym_with] = ACTIONS(1070),
    [anon_sym_repeat] = ACTIONS(1070),
    [anon_sym_until] = ACTIONS(1070),
    [anon_sym_do] = ACTIONS(1070),
    [anon_sym_recover] = ACTIONS(1070),
    [anon_sym_match] = ACTIONS(1070),
    [anon_sym_return] = ACTIONS(1070),
    [anon_sym_continue] = ACTIONS(1070),
    [anon_sym_break] = ACTIONS(1070),
    [anon_sym_consume] = ACTIONS(1070),
    [anon_sym_object] = ACTIONS(1070),
    [sym_number] = ACTIONS(1072),
    [sym_float] = ACTIONS(1070),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1070),
    [anon_sym_SQUOTE] = ACTIONS(1070),
    [anon_sym_true] = ACTIONS(1070),
    [anon_sym_false] = ACTIONS(1070),
    [sym_this] = ACTIONS(1070),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [387] = {
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_AT] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(1304),
    [anon_sym_RBRACK] = ACTIONS(1304),
    [anon_sym_is] = ACTIONS(1306),
    [anon_sym_embed] = ACTIONS(1304),
    [anon_sym_let] = ACTIONS(1304),
    [anon_sym_var] = ACTIONS(1304),
    [anon_sym_new] = ACTIONS(1304),
    [anon_sym_EQ_GT] = ACTIONS(1304),
    [anon_sym_fun] = ACTIONS(1304),
    [anon_sym_be] = ACTIONS(1304),
    [anon_sym_COMMA] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_RPAREN] = ACTIONS(1304),
    [anon_sym_DOT] = ACTIONS(1306),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_LBRACE] = ACTIONS(1304),
    [anon_sym_RBRACE] = ACTIONS(1304),
    [anon_sym_SEMI] = ACTIONS(1304),
    [sym_error] = ACTIONS(1304),
    [sym_compile_intrinsic] = ACTIONS(1304),
    [anon_sym_compile_error] = ACTIONS(1304),
    [sym_location] = ACTIONS(1304),
    [anon_sym_DASH] = ACTIONS(1306),
    [anon_sym_not] = ACTIONS(1304),
    [anon_sym_DASH_TILDE] = ACTIONS(1304),
    [anon_sym_addressof] = ACTIONS(1304),
    [anon_sym_digestof] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1306),
    [anon_sym_STAR] = ACTIONS(1306),
    [anon_sym_SLASH] = ACTIONS(1306),
    [anon_sym_PERCENT] = ACTIONS(1306),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1306),
    [anon_sym_LT_LT] = ACTIONS(1306),
    [anon_sym_GT_GT] = ACTIONS(1306),
    [anon_sym_and] = ACTIONS(1304),
    [anon_sym_or] = ACTIONS(1304),
    [anon_sym_xor] = ACTIONS(1304),
    [anon_sym_isnt] = ACTIONS(1304),
    [anon_sym_EQ_EQ] = ACTIONS(1306),
    [anon_sym_BANG_EQ] = ACTIONS(1306),
    [anon_sym_GT] = ACTIONS(1306),
    [anon_sym_GT_EQ] = ACTIONS(1306),
    [anon_sym_LT_EQ] = ACTIONS(1306),
    [anon_sym_LT] = ACTIONS(1306),
    [anon_sym_PLUS_TILDE] = ACTIONS(1304),
    [anon_sym_STAR_TILDE] = ACTIONS(1304),
    [anon_sym_SLASH_TILDE] = ACTIONS(1304),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1304),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1304),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1304),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1304),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1304),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1304),
    [anon_sym_GT_TILDE] = ACTIONS(1304),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1304),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1304),
    [anon_sym_LT_TILDE] = ACTIONS(1304),
    [anon_sym_PLUS_QMARK] = ACTIONS(1304),
    [anon_sym_DASH_QMARK] = ACTIONS(1304),
    [anon_sym_STAR_QMARK] = ACTIONS(1304),
    [anon_sym_SLASH_QMARK] = ACTIONS(1304),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1304),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1304),
    [anon_sym_as] = ACTIONS(1304),
    [anon_sym_LPAREN2] = ACTIONS(1304),
    [anon_sym_DOT_GT] = ACTIONS(1304),
    [anon_sym_where] = ACTIONS(1304),
    [anon_sym_TILDE] = ACTIONS(1304),
    [anon_sym_end] = ACTIONS(1304),
    [anon_sym_if] = ACTIONS(1306),
    [anon_sym_ifdef] = ACTIONS(1304),
    [anon_sym_then] = ACTIONS(1304),
    [anon_sym_iftype] = ACTIONS(1304),
    [anon_sym_else] = ACTIONS(1304),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_while] = ACTIONS(1304),
    [anon_sym_try] = ACTIONS(1304),
    [anon_sym_with] = ACTIONS(1304),
    [anon_sym_repeat] = ACTIONS(1304),
    [anon_sym_until] = ACTIONS(1304),
    [anon_sym_do] = ACTIONS(1304),
    [anon_sym_recover] = ACTIONS(1304),
    [anon_sym_match] = ACTIONS(1304),
    [anon_sym_return] = ACTIONS(1304),
    [anon_sym_continue] = ACTIONS(1304),
    [anon_sym_break] = ACTIONS(1304),
    [anon_sym_consume] = ACTIONS(1304),
    [anon_sym_object] = ACTIONS(1304),
    [sym_number] = ACTIONS(1306),
    [sym_float] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1306),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1304),
    [anon_sym_SQUOTE] = ACTIONS(1304),
    [anon_sym_true] = ACTIONS(1304),
    [anon_sym_false] = ACTIONS(1304),
    [sym_this] = ACTIONS(1304),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [388] = {
    [sym_arguments] = STATE(332),
    [sym_identifier] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(1318),
    [anon_sym_AT] = ACTIONS(1320),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_RBRACK] = ACTIONS(1320),
    [anon_sym_is] = ACTIONS(1318),
    [anon_sym_embed] = ACTIONS(1320),
    [anon_sym_let] = ACTIONS(1320),
    [anon_sym_var] = ACTIONS(1320),
    [anon_sym_new] = ACTIONS(1320),
    [anon_sym_EQ_GT] = ACTIONS(1320),
    [anon_sym_fun] = ACTIONS(1320),
    [anon_sym_be] = ACTIONS(1320),
    [anon_sym_COMMA] = ACTIONS(1320),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_RPAREN] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(35),
    [anon_sym_LBRACE] = ACTIONS(1320),
    [anon_sym_RBRACE] = ACTIONS(1320),
    [anon_sym_SEMI] = ACTIONS(1320),
    [sym_error] = ACTIONS(1320),
    [sym_compile_intrinsic] = ACTIONS(1320),
    [anon_sym_compile_error] = ACTIONS(1320),
    [sym_location] = ACTIONS(1320),
    [anon_sym_DASH] = ACTIONS(1318),
    [anon_sym_not] = ACTIONS(1320),
    [anon_sym_DASH_TILDE] = ACTIONS(1320),
    [anon_sym_addressof] = ACTIONS(1320),
    [anon_sym_digestof] = ACTIONS(1320),
    [anon_sym_PLUS] = ACTIONS(1318),
    [anon_sym_STAR] = ACTIONS(1318),
    [anon_sym_SLASH] = ACTIONS(1318),
    [anon_sym_PERCENT] = ACTIONS(1318),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1318),
    [anon_sym_LT_LT] = ACTIONS(1318),
    [anon_sym_GT_GT] = ACTIONS(1318),
    [anon_sym_and] = ACTIONS(1320),
    [anon_sym_or] = ACTIONS(1320),
    [anon_sym_xor] = ACTIONS(1320),
    [anon_sym_isnt] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1318),
    [anon_sym_BANG_EQ] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(1318),
    [anon_sym_GT_EQ] = ACTIONS(1318),
    [anon_sym_LT_EQ] = ACTIONS(1318),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_PLUS_TILDE] = ACTIONS(1320),
    [anon_sym_STAR_TILDE] = ACTIONS(1320),
    [anon_sym_SLASH_TILDE] = ACTIONS(1320),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1320),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1320),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1320),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1320),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_GT_TILDE] = ACTIONS(1320),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_LT_TILDE] = ACTIONS(1320),
    [anon_sym_PLUS_QMARK] = ACTIONS(1320),
    [anon_sym_DASH_QMARK] = ACTIONS(1320),
    [anon_sym_STAR_QMARK] = ACTIONS(1320),
    [anon_sym_SLASH_QMARK] = ACTIONS(1320),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1320),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1320),
    [anon_sym_as] = ACTIONS(1320),
    [anon_sym_LPAREN2] = ACTIONS(45),
    [anon_sym_DOT_GT] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(1320),
    [anon_sym_TILDE] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(1320),
    [anon_sym_if] = ACTIONS(1318),
    [anon_sym_ifdef] = ACTIONS(1320),
    [anon_sym_then] = ACTIONS(1320),
    [anon_sym_iftype] = ACTIONS(1320),
    [anon_sym_else] = ACTIONS(1320),
    [anon_sym_for] = ACTIONS(1320),
    [anon_sym_while] = ACTIONS(1320),
    [anon_sym_try] = ACTIONS(1320),
    [anon_sym_with] = ACTIONS(1320),
    [anon_sym_repeat] = ACTIONS(1320),
    [anon_sym_until] = ACTIONS(1320),
    [anon_sym_do] = ACTIONS(1320),
    [anon_sym_recover] = ACTIONS(1320),
    [anon_sym_match] = ACTIONS(1320),
    [anon_sym_return] = ACTIONS(1320),
    [anon_sym_continue] = ACTIONS(1320),
    [anon_sym_break] = ACTIONS(1320),
    [anon_sym_consume] = ACTIONS(1320),
    [anon_sym_object] = ACTIONS(1320),
    [sym_number] = ACTIONS(1318),
    [sym_float] = ACTIONS(1320),
    [anon_sym_DQUOTE] = ACTIONS(1318),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1320),
    [anon_sym_SQUOTE] = ACTIONS(1320),
    [anon_sym_true] = ACTIONS(1320),
    [anon_sym_false] = ACTIONS(1320),
    [sym_this] = ACTIONS(1320),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [389] = {
    [sym_identifier] = ACTIONS(1282),
    [anon_sym_EQ] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(1280),
    [anon_sym_LBRACK] = ACTIONS(1280),
    [anon_sym_RBRACK] = ACTIONS(1280),
    [anon_sym_is] = ACTIONS(1282),
    [anon_sym_embed] = ACTIONS(1280),
    [anon_sym_let] = ACTIONS(1280),
    [anon_sym_var] = ACTIONS(1280),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_EQ_GT] = ACTIONS(1280),
    [anon_sym_fun] = ACTIONS(1280),
    [anon_sym_be] = ACTIONS(1280),
    [anon_sym_COMMA] = ACTIONS(1280),
    [anon_sym_LPAREN] = ACTIONS(1282),
    [anon_sym_RPAREN] = ACTIONS(1280),
    [anon_sym_DOT] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_LBRACE] = ACTIONS(1280),
    [anon_sym_RBRACE] = ACTIONS(1280),
    [anon_sym_SEMI] = ACTIONS(1280),
    [sym_error] = ACTIONS(1280),
    [sym_compile_intrinsic] = ACTIONS(1280),
    [anon_sym_compile_error] = ACTIONS(1280),
    [sym_location] = ACTIONS(1280),
    [anon_sym_DASH] = ACTIONS(1282),
    [anon_sym_not] = ACTIONS(1280),
    [anon_sym_DASH_TILDE] = ACTIONS(1280),
    [anon_sym_addressof] = ACTIONS(1280),
    [anon_sym_digestof] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1282),
    [anon_sym_STAR] = ACTIONS(1282),
    [anon_sym_SLASH] = ACTIONS(1282),
    [anon_sym_PERCENT] = ACTIONS(1282),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1282),
    [anon_sym_LT_LT] = ACTIONS(1282),
    [anon_sym_GT_GT] = ACTIONS(1282),
    [anon_sym_and] = ACTIONS(1280),
    [anon_sym_or] = ACTIONS(1280),
    [anon_sym_xor] = ACTIONS(1280),
    [anon_sym_isnt] = ACTIONS(1280),
    [anon_sym_EQ_EQ] = ACTIONS(1282),
    [anon_sym_BANG_EQ] = ACTIONS(1282),
    [anon_sym_GT] = ACTIONS(1282),
    [anon_sym_GT_EQ] = ACTIONS(1282),
    [anon_sym_LT_EQ] = ACTIONS(1282),
    [anon_sym_LT] = ACTIONS(1282),
    [anon_sym_PLUS_TILDE] = ACTIONS(1280),
    [anon_sym_STAR_TILDE] = ACTIONS(1280),
    [anon_sym_SLASH_TILDE] = ACTIONS(1280),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1280),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1280),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1280),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1280),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1280),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1280),
    [anon_sym_GT_TILDE] = ACTIONS(1280),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1280),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1280),
    [anon_sym_LT_TILDE] = ACTIONS(1280),
    [anon_sym_PLUS_QMARK] = ACTIONS(1280),
    [anon_sym_DASH_QMARK] = ACTIONS(1280),
    [anon_sym_STAR_QMARK] = ACTIONS(1280),
    [anon_sym_SLASH_QMARK] = ACTIONS(1280),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1280),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1280),
    [anon_sym_as] = ACTIONS(1280),
    [anon_sym_LPAREN2] = ACTIONS(1280),
    [anon_sym_DOT_GT] = ACTIONS(1280),
    [anon_sym_where] = ACTIONS(1280),
    [anon_sym_TILDE] = ACTIONS(1280),
    [anon_sym_end] = ACTIONS(1280),
    [anon_sym_if] = ACTIONS(1282),
    [anon_sym_ifdef] = ACTIONS(1280),
    [anon_sym_then] = ACTIONS(1280),
    [anon_sym_iftype] = ACTIONS(1280),
    [anon_sym_else] = ACTIONS(1280),
    [anon_sym_for] = ACTIONS(1280),
    [anon_sym_while] = ACTIONS(1280),
    [anon_sym_try] = ACTIONS(1280),
    [anon_sym_with] = ACTIONS(1280),
    [anon_sym_repeat] = ACTIONS(1280),
    [anon_sym_until] = ACTIONS(1280),
    [anon_sym_do] = ACTIONS(1280),
    [anon_sym_recover] = ACTIONS(1280),
    [anon_sym_match] = ACTIONS(1280),
    [anon_sym_return] = ACTIONS(1280),
    [anon_sym_continue] = ACTIONS(1280),
    [anon_sym_break] = ACTIONS(1280),
    [anon_sym_consume] = ACTIONS(1280),
    [anon_sym_object] = ACTIONS(1280),
    [sym_number] = ACTIONS(1282),
    [sym_float] = ACTIONS(1280),
    [anon_sym_DQUOTE] = ACTIONS(1282),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1280),
    [anon_sym_SQUOTE] = ACTIONS(1280),
    [anon_sym_true] = ACTIONS(1280),
    [anon_sym_false] = ACTIONS(1280),
    [sym_this] = ACTIONS(1280),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [390] = {
    [sym_identifier] = ACTIONS(994),
    [anon_sym_EQ] = ACTIONS(994),
    [anon_sym_AT] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(992),
    [anon_sym_RBRACK] = ACTIONS(992),
    [anon_sym_is] = ACTIONS(994),
    [anon_sym_embed] = ACTIONS(992),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_var] = ACTIONS(992),
    [anon_sym_new] = ACTIONS(992),
    [anon_sym_EQ_GT] = ACTIONS(992),
    [anon_sym_fun] = ACTIONS(992),
    [anon_sym_be] = ACTIONS(992),
    [anon_sym_COMMA] = ACTIONS(992),
    [anon_sym_LPAREN] = ACTIONS(994),
    [anon_sym_RPAREN] = ACTIONS(992),
    [anon_sym_DOT] = ACTIONS(994),
    [anon_sym_PIPE] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(992),
    [anon_sym_RBRACE] = ACTIONS(992),
    [anon_sym_SEMI] = ACTIONS(992),
    [sym_error] = ACTIONS(992),
    [sym_compile_intrinsic] = ACTIONS(992),
    [anon_sym_compile_error] = ACTIONS(992),
    [sym_location] = ACTIONS(992),
    [anon_sym_DASH] = ACTIONS(994),
    [anon_sym_not] = ACTIONS(992),
    [anon_sym_DASH_TILDE] = ACTIONS(992),
    [anon_sym_addressof] = ACTIONS(992),
    [anon_sym_digestof] = ACTIONS(992),
    [anon_sym_PLUS] = ACTIONS(994),
    [anon_sym_STAR] = ACTIONS(994),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_PERCENT] = ACTIONS(994),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(994),
    [anon_sym_LT_LT] = ACTIONS(994),
    [anon_sym_GT_GT] = ACTIONS(994),
    [anon_sym_and] = ACTIONS(992),
    [anon_sym_or] = ACTIONS(992),
    [anon_sym_xor] = ACTIONS(992),
    [anon_sym_isnt] = ACTIONS(992),
    [anon_sym_EQ_EQ] = ACTIONS(994),
    [anon_sym_BANG_EQ] = ACTIONS(994),
    [anon_sym_GT] = ACTIONS(994),
    [anon_sym_GT_EQ] = ACTIONS(994),
    [anon_sym_LT_EQ] = ACTIONS(994),
    [anon_sym_LT] = ACTIONS(994),
    [anon_sym_PLUS_TILDE] = ACTIONS(992),
    [anon_sym_STAR_TILDE] = ACTIONS(992),
    [anon_sym_SLASH_TILDE] = ACTIONS(992),
    [anon_sym_PERCENT_TILDE] = ACTIONS(992),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(992),
    [anon_sym_LT_LT_TILDE] = ACTIONS(992),
    [anon_sym_GT_GT_TILDE] = ACTIONS(992),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(992),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(992),
    [anon_sym_GT_TILDE] = ACTIONS(992),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(992),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(992),
    [anon_sym_LT_TILDE] = ACTIONS(992),
    [anon_sym_PLUS_QMARK] = ACTIONS(992),
    [anon_sym_DASH_QMARK] = ACTIONS(992),
    [anon_sym_STAR_QMARK] = ACTIONS(992),
    [anon_sym_SLASH_QMARK] = ACTIONS(992),
    [anon_sym_PERCENT_QMARK] = ACTIONS(992),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(992),
    [anon_sym_as] = ACTIONS(992),
    [anon_sym_LPAREN2] = ACTIONS(992),
    [anon_sym_DOT_GT] = ACTIONS(992),
    [anon_sym_where] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(992),
    [anon_sym_end] = ACTIONS(992),
    [anon_sym_if] = ACTIONS(994),
    [anon_sym_ifdef] = ACTIONS(992),
    [anon_sym_then] = ACTIONS(992),
    [anon_sym_iftype] = ACTIONS(992),
    [anon_sym_else] = ACTIONS(992),
    [anon_sym_for] = ACTIONS(992),
    [anon_sym_while] = ACTIONS(992),
    [anon_sym_try] = ACTIONS(992),
    [anon_sym_with] = ACTIONS(992),
    [anon_sym_repeat] = ACTIONS(992),
    [anon_sym_until] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(992),
    [anon_sym_recover] = ACTIONS(992),
    [anon_sym_match] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(992),
    [anon_sym_continue] = ACTIONS(992),
    [anon_sym_break] = ACTIONS(992),
    [anon_sym_consume] = ACTIONS(992),
    [anon_sym_object] = ACTIONS(992),
    [sym_number] = ACTIONS(994),
    [sym_float] = ACTIONS(992),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(992),
    [anon_sym_SQUOTE] = ACTIONS(992),
    [anon_sym_true] = ACTIONS(992),
    [anon_sym_false] = ACTIONS(992),
    [sym_this] = ACTIONS(992),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [391] = {
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_EQ] = ACTIONS(1286),
    [anon_sym_AT] = ACTIONS(1284),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_RBRACK] = ACTIONS(1284),
    [anon_sym_is] = ACTIONS(1286),
    [anon_sym_embed] = ACTIONS(1284),
    [anon_sym_let] = ACTIONS(1284),
    [anon_sym_var] = ACTIONS(1284),
    [anon_sym_new] = ACTIONS(1284),
    [anon_sym_EQ_GT] = ACTIONS(1284),
    [anon_sym_fun] = ACTIONS(1284),
    [anon_sym_be] = ACTIONS(1284),
    [anon_sym_COMMA] = ACTIONS(1284),
    [anon_sym_LPAREN] = ACTIONS(1286),
    [anon_sym_RPAREN] = ACTIONS(1284),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_LBRACE] = ACTIONS(1284),
    [anon_sym_RBRACE] = ACTIONS(1284),
    [anon_sym_SEMI] = ACTIONS(1284),
    [sym_error] = ACTIONS(1284),
    [sym_compile_intrinsic] = ACTIONS(1284),
    [anon_sym_compile_error] = ACTIONS(1284),
    [sym_location] = ACTIONS(1284),
    [anon_sym_DASH] = ACTIONS(1286),
    [anon_sym_not] = ACTIONS(1284),
    [anon_sym_DASH_TILDE] = ACTIONS(1284),
    [anon_sym_addressof] = ACTIONS(1284),
    [anon_sym_digestof] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(1286),
    [anon_sym_STAR] = ACTIONS(1286),
    [anon_sym_SLASH] = ACTIONS(1286),
    [anon_sym_PERCENT] = ACTIONS(1286),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1286),
    [anon_sym_LT_LT] = ACTIONS(1286),
    [anon_sym_GT_GT] = ACTIONS(1286),
    [anon_sym_and] = ACTIONS(1284),
    [anon_sym_or] = ACTIONS(1284),
    [anon_sym_xor] = ACTIONS(1284),
    [anon_sym_isnt] = ACTIONS(1284),
    [anon_sym_EQ_EQ] = ACTIONS(1286),
    [anon_sym_BANG_EQ] = ACTIONS(1286),
    [anon_sym_GT] = ACTIONS(1286),
    [anon_sym_GT_EQ] = ACTIONS(1286),
    [anon_sym_LT_EQ] = ACTIONS(1286),
    [anon_sym_LT] = ACTIONS(1286),
    [anon_sym_PLUS_TILDE] = ACTIONS(1284),
    [anon_sym_STAR_TILDE] = ACTIONS(1284),
    [anon_sym_SLASH_TILDE] = ACTIONS(1284),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1284),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1284),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1284),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1284),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1284),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1284),
    [anon_sym_GT_TILDE] = ACTIONS(1284),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1284),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1284),
    [anon_sym_LT_TILDE] = ACTIONS(1284),
    [anon_sym_PLUS_QMARK] = ACTIONS(1284),
    [anon_sym_DASH_QMARK] = ACTIONS(1284),
    [anon_sym_STAR_QMARK] = ACTIONS(1284),
    [anon_sym_SLASH_QMARK] = ACTIONS(1284),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1284),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1284),
    [anon_sym_as] = ACTIONS(1284),
    [anon_sym_LPAREN2] = ACTIONS(1284),
    [anon_sym_DOT_GT] = ACTIONS(1284),
    [anon_sym_where] = ACTIONS(1284),
    [anon_sym_TILDE] = ACTIONS(1284),
    [anon_sym_end] = ACTIONS(1284),
    [anon_sym_if] = ACTIONS(1286),
    [anon_sym_ifdef] = ACTIONS(1284),
    [anon_sym_then] = ACTIONS(1284),
    [anon_sym_iftype] = ACTIONS(1284),
    [anon_sym_else] = ACTIONS(1284),
    [anon_sym_for] = ACTIONS(1284),
    [anon_sym_while] = ACTIONS(1284),
    [anon_sym_try] = ACTIONS(1284),
    [anon_sym_with] = ACTIONS(1284),
    [anon_sym_repeat] = ACTIONS(1284),
    [anon_sym_until] = ACTIONS(1284),
    [anon_sym_do] = ACTIONS(1284),
    [anon_sym_recover] = ACTIONS(1284),
    [anon_sym_match] = ACTIONS(1284),
    [anon_sym_return] = ACTIONS(1284),
    [anon_sym_continue] = ACTIONS(1284),
    [anon_sym_break] = ACTIONS(1284),
    [anon_sym_consume] = ACTIONS(1284),
    [anon_sym_object] = ACTIONS(1284),
    [sym_number] = ACTIONS(1286),
    [sym_float] = ACTIONS(1284),
    [anon_sym_DQUOTE] = ACTIONS(1286),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(1284),
    [anon_sym_true] = ACTIONS(1284),
    [anon_sym_false] = ACTIONS(1284),
    [sym_this] = ACTIONS(1284),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [392] = {
    [sym_identifier] = ACTIONS(1274),
    [anon_sym_EQ] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(1272),
    [anon_sym_LBRACK] = ACTIONS(1272),
    [anon_sym_RBRACK] = ACTIONS(1272),
    [anon_sym_is] = ACTIONS(1274),
    [anon_sym_embed] = ACTIONS(1272),
    [anon_sym_let] = ACTIONS(1272),
    [anon_sym_var] = ACTIONS(1272),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_EQ_GT] = ACTIONS(1272),
    [anon_sym_fun] = ACTIONS(1272),
    [anon_sym_be] = ACTIONS(1272),
    [anon_sym_COMMA] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(1274),
    [anon_sym_RPAREN] = ACTIONS(1272),
    [anon_sym_DOT] = ACTIONS(1274),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_LBRACE] = ACTIONS(1272),
    [anon_sym_RBRACE] = ACTIONS(1272),
    [anon_sym_SEMI] = ACTIONS(1272),
    [sym_error] = ACTIONS(1272),
    [sym_compile_intrinsic] = ACTIONS(1272),
    [anon_sym_compile_error] = ACTIONS(1272),
    [sym_location] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_not] = ACTIONS(1272),
    [anon_sym_DASH_TILDE] = ACTIONS(1272),
    [anon_sym_addressof] = ACTIONS(1272),
    [anon_sym_digestof] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1274),
    [anon_sym_STAR] = ACTIONS(1274),
    [anon_sym_SLASH] = ACTIONS(1274),
    [anon_sym_PERCENT] = ACTIONS(1274),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1274),
    [anon_sym_LT_LT] = ACTIONS(1274),
    [anon_sym_GT_GT] = ACTIONS(1274),
    [anon_sym_and] = ACTIONS(1272),
    [anon_sym_or] = ACTIONS(1272),
    [anon_sym_xor] = ACTIONS(1272),
    [anon_sym_isnt] = ACTIONS(1272),
    [anon_sym_EQ_EQ] = ACTIONS(1274),
    [anon_sym_BANG_EQ] = ACTIONS(1274),
    [anon_sym_GT] = ACTIONS(1274),
    [anon_sym_GT_EQ] = ACTIONS(1274),
    [anon_sym_LT_EQ] = ACTIONS(1274),
    [anon_sym_LT] = ACTIONS(1274),
    [anon_sym_PLUS_TILDE] = ACTIONS(1272),
    [anon_sym_STAR_TILDE] = ACTIONS(1272),
    [anon_sym_SLASH_TILDE] = ACTIONS(1272),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1272),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1272),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1272),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1272),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1272),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1272),
    [anon_sym_GT_TILDE] = ACTIONS(1272),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1272),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1272),
    [anon_sym_LT_TILDE] = ACTIONS(1272),
    [anon_sym_PLUS_QMARK] = ACTIONS(1272),
    [anon_sym_DASH_QMARK] = ACTIONS(1272),
    [anon_sym_STAR_QMARK] = ACTIONS(1272),
    [anon_sym_SLASH_QMARK] = ACTIONS(1272),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1272),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1272),
    [anon_sym_as] = ACTIONS(1272),
    [anon_sym_LPAREN2] = ACTIONS(1272),
    [anon_sym_DOT_GT] = ACTIONS(1272),
    [anon_sym_where] = ACTIONS(1272),
    [anon_sym_TILDE] = ACTIONS(1272),
    [anon_sym_end] = ACTIONS(1272),
    [anon_sym_if] = ACTIONS(1274),
    [anon_sym_ifdef] = ACTIONS(1272),
    [anon_sym_then] = ACTIONS(1272),
    [anon_sym_iftype] = ACTIONS(1272),
    [anon_sym_else] = ACTIONS(1272),
    [anon_sym_for] = ACTIONS(1272),
    [anon_sym_while] = ACTIONS(1272),
    [anon_sym_try] = ACTIONS(1272),
    [anon_sym_with] = ACTIONS(1272),
    [anon_sym_repeat] = ACTIONS(1272),
    [anon_sym_until] = ACTIONS(1272),
    [anon_sym_do] = ACTIONS(1272),
    [anon_sym_recover] = ACTIONS(1272),
    [anon_sym_match] = ACTIONS(1272),
    [anon_sym_return] = ACTIONS(1272),
    [anon_sym_continue] = ACTIONS(1272),
    [anon_sym_break] = ACTIONS(1272),
    [anon_sym_consume] = ACTIONS(1272),
    [anon_sym_object] = ACTIONS(1272),
    [sym_number] = ACTIONS(1274),
    [sym_float] = ACTIONS(1272),
    [anon_sym_DQUOTE] = ACTIONS(1274),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1272),
    [anon_sym_SQUOTE] = ACTIONS(1272),
    [anon_sym_true] = ACTIONS(1272),
    [anon_sym_false] = ACTIONS(1272),
    [sym_this] = ACTIONS(1272),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [393] = {
    [sym_identifier] = ACTIONS(867),
    [anon_sym_EQ] = ACTIONS(867),
    [anon_sym_AT] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(865),
    [anon_sym_RBRACK] = ACTIONS(865),
    [anon_sym_is] = ACTIONS(867),
    [anon_sym_embed] = ACTIONS(865),
    [anon_sym_let] = ACTIONS(865),
    [anon_sym_var] = ACTIONS(865),
    [anon_sym_new] = ACTIONS(865),
    [anon_sym_EQ_GT] = ACTIONS(865),
    [anon_sym_fun] = ACTIONS(865),
    [anon_sym_be] = ACTIONS(865),
    [anon_sym_COMMA] = ACTIONS(865),
    [anon_sym_LPAREN] = ACTIONS(867),
    [anon_sym_RPAREN] = ACTIONS(865),
    [anon_sym_DOT] = ACTIONS(867),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(865),
    [anon_sym_SEMI] = ACTIONS(865),
    [sym_error] = ACTIONS(865),
    [sym_compile_intrinsic] = ACTIONS(865),
    [anon_sym_compile_error] = ACTIONS(865),
    [sym_location] = ACTIONS(865),
    [anon_sym_DASH] = ACTIONS(867),
    [anon_sym_not] = ACTIONS(865),
    [anon_sym_DASH_TILDE] = ACTIONS(865),
    [anon_sym_addressof] = ACTIONS(865),
    [anon_sym_digestof] = ACTIONS(865),
    [anon_sym_PLUS] = ACTIONS(867),
    [anon_sym_STAR] = ACTIONS(867),
    [anon_sym_SLASH] = ACTIONS(867),
    [anon_sym_PERCENT] = ACTIONS(867),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(867),
    [anon_sym_LT_LT] = ACTIONS(867),
    [anon_sym_GT_GT] = ACTIONS(867),
    [anon_sym_and] = ACTIONS(865),
    [anon_sym_or] = ACTIONS(865),
    [anon_sym_xor] = ACTIONS(865),
    [anon_sym_isnt] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(867),
    [anon_sym_BANG_EQ] = ACTIONS(867),
    [anon_sym_GT] = ACTIONS(867),
    [anon_sym_GT_EQ] = ACTIONS(867),
    [anon_sym_LT_EQ] = ACTIONS(867),
    [anon_sym_LT] = ACTIONS(867),
    [anon_sym_PLUS_TILDE] = ACTIONS(865),
    [anon_sym_STAR_TILDE] = ACTIONS(865),
    [anon_sym_SLASH_TILDE] = ACTIONS(865),
    [anon_sym_PERCENT_TILDE] = ACTIONS(865),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(865),
    [anon_sym_LT_LT_TILDE] = ACTIONS(865),
    [anon_sym_GT_GT_TILDE] = ACTIONS(865),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(865),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(865),
    [anon_sym_GT_TILDE] = ACTIONS(865),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(865),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(865),
    [anon_sym_LT_TILDE] = ACTIONS(865),
    [anon_sym_PLUS_QMARK] = ACTIONS(865),
    [anon_sym_DASH_QMARK] = ACTIONS(865),
    [anon_sym_STAR_QMARK] = ACTIONS(865),
    [anon_sym_SLASH_QMARK] = ACTIONS(865),
    [anon_sym_PERCENT_QMARK] = ACTIONS(865),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(865),
    [anon_sym_LPAREN2] = ACTIONS(865),
    [anon_sym_DOT_GT] = ACTIONS(865),
    [anon_sym_where] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [anon_sym_end] = ACTIONS(865),
    [anon_sym_if] = ACTIONS(867),
    [anon_sym_ifdef] = ACTIONS(865),
    [anon_sym_then] = ACTIONS(865),
    [anon_sym_iftype] = ACTIONS(865),
    [anon_sym_else] = ACTIONS(865),
    [anon_sym_for] = ACTIONS(865),
    [anon_sym_while] = ACTIONS(865),
    [anon_sym_try] = ACTIONS(865),
    [anon_sym_with] = ACTIONS(865),
    [anon_sym_repeat] = ACTIONS(865),
    [anon_sym_until] = ACTIONS(865),
    [anon_sym_do] = ACTIONS(865),
    [anon_sym_recover] = ACTIONS(865),
    [anon_sym_match] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(865),
    [anon_sym_continue] = ACTIONS(865),
    [anon_sym_break] = ACTIONS(865),
    [anon_sym_consume] = ACTIONS(865),
    [anon_sym_object] = ACTIONS(865),
    [sym_number] = ACTIONS(867),
    [sym_float] = ACTIONS(865),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(865),
    [anon_sym_false] = ACTIONS(865),
    [sym_this] = ACTIONS(865),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [394] = {
    [sym_arguments] = STATE(332),
    [sym_identifier] = ACTIONS(1322),
    [anon_sym_EQ] = ACTIONS(1322),
    [anon_sym_AT] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(1324),
    [anon_sym_RBRACK] = ACTIONS(1324),
    [anon_sym_is] = ACTIONS(1322),
    [anon_sym_embed] = ACTIONS(1324),
    [anon_sym_let] = ACTIONS(1324),
    [anon_sym_var] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1324),
    [anon_sym_EQ_GT] = ACTIONS(1324),
    [anon_sym_fun] = ACTIONS(1324),
    [anon_sym_be] = ACTIONS(1324),
    [anon_sym_COMMA] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(1322),
    [anon_sym_RPAREN] = ACTIONS(1324),
    [anon_sym_DOT] = ACTIONS(35),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_RBRACE] = ACTIONS(1324),
    [anon_sym_SEMI] = ACTIONS(1324),
    [sym_error] = ACTIONS(1324),
    [sym_compile_intrinsic] = ACTIONS(1324),
    [anon_sym_compile_error] = ACTIONS(1324),
    [sym_location] = ACTIONS(1324),
    [anon_sym_DASH] = ACTIONS(1322),
    [anon_sym_not] = ACTIONS(1324),
    [anon_sym_DASH_TILDE] = ACTIONS(1324),
    [anon_sym_addressof] = ACTIONS(1324),
    [anon_sym_digestof] = ACTIONS(1324),
    [anon_sym_PLUS] = ACTIONS(1322),
    [anon_sym_STAR] = ACTIONS(1322),
    [anon_sym_SLASH] = ACTIONS(1322),
    [anon_sym_PERCENT] = ACTIONS(1322),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1322),
    [anon_sym_LT_LT] = ACTIONS(1322),
    [anon_sym_GT_GT] = ACTIONS(1322),
    [anon_sym_and] = ACTIONS(1324),
    [anon_sym_or] = ACTIONS(1324),
    [anon_sym_xor] = ACTIONS(1324),
    [anon_sym_isnt] = ACTIONS(1324),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_GT] = ACTIONS(1322),
    [anon_sym_GT_EQ] = ACTIONS(1322),
    [anon_sym_LT_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1322),
    [anon_sym_PLUS_TILDE] = ACTIONS(1324),
    [anon_sym_STAR_TILDE] = ACTIONS(1324),
    [anon_sym_SLASH_TILDE] = ACTIONS(1324),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1324),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1324),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1324),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1324),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1324),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1324),
    [anon_sym_GT_TILDE] = ACTIONS(1324),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1324),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1324),
    [anon_sym_LT_TILDE] = ACTIONS(1324),
    [anon_sym_PLUS_QMARK] = ACTIONS(1324),
    [anon_sym_DASH_QMARK] = ACTIONS(1324),
    [anon_sym_STAR_QMARK] = ACTIONS(1324),
    [anon_sym_SLASH_QMARK] = ACTIONS(1324),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1324),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1324),
    [anon_sym_as] = ACTIONS(43),
    [anon_sym_LPAREN2] = ACTIONS(45),
    [anon_sym_DOT_GT] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(1324),
    [anon_sym_TILDE] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(1324),
    [anon_sym_if] = ACTIONS(1322),
    [anon_sym_ifdef] = ACTIONS(1324),
    [anon_sym_then] = ACTIONS(1324),
    [anon_sym_iftype] = ACTIONS(1324),
    [anon_sym_else] = ACTIONS(1324),
    [anon_sym_for] = ACTIONS(1324),
    [anon_sym_while] = ACTIONS(1324),
    [anon_sym_try] = ACTIONS(1324),
    [anon_sym_with] = ACTIONS(1324),
    [anon_sym_repeat] = ACTIONS(1324),
    [anon_sym_until] = ACTIONS(1324),
    [anon_sym_do] = ACTIONS(1324),
    [anon_sym_recover] = ACTIONS(1324),
    [anon_sym_match] = ACTIONS(1324),
    [anon_sym_return] = ACTIONS(1324),
    [anon_sym_continue] = ACTIONS(1324),
    [anon_sym_break] = ACTIONS(1324),
    [anon_sym_consume] = ACTIONS(1324),
    [anon_sym_object] = ACTIONS(1324),
    [sym_number] = ACTIONS(1322),
    [sym_float] = ACTIONS(1324),
    [anon_sym_DQUOTE] = ACTIONS(1322),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1324),
    [anon_sym_SQUOTE] = ACTIONS(1324),
    [anon_sym_true] = ACTIONS(1324),
    [anon_sym_false] = ACTIONS(1324),
    [sym_this] = ACTIONS(1324),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [395] = {
    [sym_arguments] = STATE(332),
    [sym_identifier] = ACTIONS(66),
    [anon_sym_EQ] = ACTIONS(29),
    [anon_sym_AT] = ACTIONS(74),
    [anon_sym_LBRACK] = ACTIONS(74),
    [anon_sym_RBRACK] = ACTIONS(74),
    [anon_sym_is] = ACTIONS(33),
    [anon_sym_embed] = ACTIONS(74),
    [anon_sym_let] = ACTIONS(74),
    [anon_sym_var] = ACTIONS(74),
    [anon_sym_new] = ACTIONS(74),
    [anon_sym_EQ_GT] = ACTIONS(74),
    [anon_sym_fun] = ACTIONS(74),
    [anon_sym_be] = ACTIONS(74),
    [anon_sym_COMMA] = ACTIONS(74),
    [anon_sym_LPAREN] = ACTIONS(66),
    [anon_sym_RPAREN] = ACTIONS(74),
    [anon_sym_DOT] = ACTIONS(35),
    [anon_sym_LBRACE] = ACTIONS(74),
    [anon_sym_RBRACE] = ACTIONS(74),
    [anon_sym_SEMI] = ACTIONS(74),
    [sym_error] = ACTIONS(74),
    [sym_compile_intrinsic] = ACTIONS(74),
    [anon_sym_compile_error] = ACTIONS(74),
    [sym_location] = ACTIONS(74),
    [anon_sym_DASH] = ACTIONS(33),
    [anon_sym_not] = ACTIONS(74),
    [anon_sym_DASH_TILDE] = ACTIONS(41),
    [anon_sym_addressof] = ACTIONS(74),
    [anon_sym_digestof] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(33),
    [anon_sym_STAR] = ACTIONS(33),
    [anon_sym_SLASH] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(33),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(33),
    [anon_sym_LT_LT] = ACTIONS(33),
    [anon_sym_GT_GT] = ACTIONS(33),
    [anon_sym_and] = ACTIONS(41),
    [anon_sym_or] = ACTIONS(41),
    [anon_sym_xor] = ACTIONS(41),
    [anon_sym_isnt] = ACTIONS(41),
    [anon_sym_EQ_EQ] = ACTIONS(33),
    [anon_sym_BANG_EQ] = ACTIONS(33),
    [anon_sym_GT] = ACTIONS(33),
    [anon_sym_GT_EQ] = ACTIONS(33),
    [anon_sym_LT_EQ] = ACTIONS(33),
    [anon_sym_LT] = ACTIONS(33),
    [anon_sym_PLUS_TILDE] = ACTIONS(41),
    [anon_sym_STAR_TILDE] = ACTIONS(41),
    [anon_sym_SLASH_TILDE] = ACTIONS(41),
    [anon_sym_PERCENT_TILDE] = ACTIONS(41),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(41),
    [anon_sym_LT_LT_TILDE] = ACTIONS(41),
    [anon_sym_GT_GT_TILDE] = ACTIONS(41),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(41),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(41),
    [anon_sym_GT_TILDE] = ACTIONS(41),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(41),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(41),
    [anon_sym_LT_TILDE] = ACTIONS(41),
    [anon_sym_PLUS_QMARK] = ACTIONS(41),
    [anon_sym_DASH_QMARK] = ACTIONS(41),
    [anon_sym_STAR_QMARK] = ACTIONS(41),
    [anon_sym_SLASH_QMARK] = ACTIONS(41),
    [anon_sym_PERCENT_QMARK] = ACTIONS(41),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(41),
    [anon_sym_as] = ACTIONS(43),
    [anon_sym_LPAREN2] = ACTIONS(45),
    [anon_sym_DOT_GT] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(74),
    [anon_sym_TILDE] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(74),
    [anon_sym_if] = ACTIONS(66),
    [anon_sym_ifdef] = ACTIONS(74),
    [anon_sym_then] = ACTIONS(74),
    [anon_sym_iftype] = ACTIONS(74),
    [anon_sym_else] = ACTIONS(74),
    [anon_sym_for] = ACTIONS(74),
    [anon_sym_while] = ACTIONS(74),
    [anon_sym_try] = ACTIONS(74),
    [anon_sym_with] = ACTIONS(74),
    [anon_sym_repeat] = ACTIONS(74),
    [anon_sym_until] = ACTIONS(74),
    [anon_sym_do] = ACTIONS(74),
    [anon_sym_recover] = ACTIONS(74),
    [anon_sym_match] = ACTIONS(74),
    [anon_sym_return] = ACTIONS(74),
    [anon_sym_continue] = ACTIONS(74),
    [anon_sym_break] = ACTIONS(74),
    [anon_sym_consume] = ACTIONS(74),
    [anon_sym_object] = ACTIONS(74),
    [sym_number] = ACTIONS(66),
    [sym_float] = ACTIONS(74),
    [anon_sym_DQUOTE] = ACTIONS(66),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(74),
    [anon_sym_true] = ACTIONS(74),
    [anon_sym_false] = ACTIONS(74),
    [sym_this] = ACTIONS(74),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [396] = {
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_EQ] = ACTIONS(1226),
    [anon_sym_AT] = ACTIONS(1224),
    [anon_sym_LBRACK] = ACTIONS(1224),
    [anon_sym_RBRACK] = ACTIONS(1224),
    [anon_sym_is] = ACTIONS(1226),
    [anon_sym_embed] = ACTIONS(1224),
    [anon_sym_let] = ACTIONS(1224),
    [anon_sym_var] = ACTIONS(1224),
    [anon_sym_new] = ACTIONS(1224),
    [anon_sym_EQ_GT] = ACTIONS(1224),
    [anon_sym_fun] = ACTIONS(1224),
    [anon_sym_be] = ACTIONS(1224),
    [anon_sym_COMMA] = ACTIONS(1224),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_RPAREN] = ACTIONS(1224),
    [anon_sym_DOT] = ACTIONS(1226),
    [anon_sym_PIPE] = ACTIONS(1224),
    [anon_sym_LBRACE] = ACTIONS(1224),
    [anon_sym_RBRACE] = ACTIONS(1224),
    [anon_sym_SEMI] = ACTIONS(1224),
    [sym_error] = ACTIONS(1224),
    [sym_compile_intrinsic] = ACTIONS(1224),
    [anon_sym_compile_error] = ACTIONS(1224),
    [sym_location] = ACTIONS(1224),
    [anon_sym_DASH] = ACTIONS(1226),
    [anon_sym_not] = ACTIONS(1224),
    [anon_sym_DASH_TILDE] = ACTIONS(1224),
    [anon_sym_addressof] = ACTIONS(1224),
    [anon_sym_digestof] = ACTIONS(1224),
    [anon_sym_PLUS] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(1226),
    [anon_sym_SLASH] = ACTIONS(1226),
    [anon_sym_PERCENT] = ACTIONS(1226),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1226),
    [anon_sym_LT_LT] = ACTIONS(1226),
    [anon_sym_GT_GT] = ACTIONS(1226),
    [anon_sym_and] = ACTIONS(1224),
    [anon_sym_or] = ACTIONS(1224),
    [anon_sym_xor] = ACTIONS(1224),
    [anon_sym_isnt] = ACTIONS(1224),
    [anon_sym_EQ_EQ] = ACTIONS(1226),
    [anon_sym_BANG_EQ] = ACTIONS(1226),
    [anon_sym_GT] = ACTIONS(1226),
    [anon_sym_GT_EQ] = ACTIONS(1226),
    [anon_sym_LT_EQ] = ACTIONS(1226),
    [anon_sym_LT] = ACTIONS(1226),
    [anon_sym_PLUS_TILDE] = ACTIONS(1224),
    [anon_sym_STAR_TILDE] = ACTIONS(1224),
    [anon_sym_SLASH_TILDE] = ACTIONS(1224),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1224),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1224),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1224),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1224),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1224),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1224),
    [anon_sym_GT_TILDE] = ACTIONS(1224),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1224),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1224),
    [anon_sym_LT_TILDE] = ACTIONS(1224),
    [anon_sym_PLUS_QMARK] = ACTIONS(1224),
    [anon_sym_DASH_QMARK] = ACTIONS(1224),
    [anon_sym_STAR_QMARK] = ACTIONS(1224),
    [anon_sym_SLASH_QMARK] = ACTIONS(1224),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1224),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1224),
    [anon_sym_as] = ACTIONS(1224),
    [anon_sym_LPAREN2] = ACTIONS(1224),
    [anon_sym_DOT_GT] = ACTIONS(1224),
    [anon_sym_where] = ACTIONS(1224),
    [anon_sym_TILDE] = ACTIONS(1224),
    [anon_sym_end] = ACTIONS(1224),
    [anon_sym_if] = ACTIONS(1226),
    [anon_sym_ifdef] = ACTIONS(1224),
    [anon_sym_then] = ACTIONS(1224),
    [anon_sym_iftype] = ACTIONS(1224),
    [anon_sym_else] = ACTIONS(1224),
    [anon_sym_for] = ACTIONS(1224),
    [anon_sym_while] = ACTIONS(1224),
    [anon_sym_try] = ACTIONS(1224),
    [anon_sym_with] = ACTIONS(1224),
    [anon_sym_repeat] = ACTIONS(1224),
    [anon_sym_until] = ACTIONS(1224),
    [anon_sym_do] = ACTIONS(1224),
    [anon_sym_recover] = ACTIONS(1224),
    [anon_sym_match] = ACTIONS(1224),
    [anon_sym_return] = ACTIONS(1224),
    [anon_sym_continue] = ACTIONS(1224),
    [anon_sym_break] = ACTIONS(1224),
    [anon_sym_consume] = ACTIONS(1224),
    [anon_sym_object] = ACTIONS(1224),
    [sym_number] = ACTIONS(1226),
    [sym_float] = ACTIONS(1224),
    [anon_sym_DQUOTE] = ACTIONS(1226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1224),
    [anon_sym_SQUOTE] = ACTIONS(1224),
    [anon_sym_true] = ACTIONS(1224),
    [anon_sym_false] = ACTIONS(1224),
    [sym_this] = ACTIONS(1224),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [397] = {
    [sym_arguments] = STATE(332),
    [sym_identifier] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(1318),
    [anon_sym_AT] = ACTIONS(1320),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_RBRACK] = ACTIONS(1320),
    [anon_sym_is] = ACTIONS(1318),
    [anon_sym_embed] = ACTIONS(1320),
    [anon_sym_let] = ACTIONS(1320),
    [anon_sym_var] = ACTIONS(1320),
    [anon_sym_new] = ACTIONS(1320),
    [anon_sym_EQ_GT] = ACTIONS(1320),
    [anon_sym_fun] = ACTIONS(1320),
    [anon_sym_be] = ACTIONS(1320),
    [anon_sym_COMMA] = ACTIONS(1320),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_RPAREN] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(35),
    [anon_sym_LBRACE] = ACTIONS(1320),
    [anon_sym_RBRACE] = ACTIONS(1320),
    [anon_sym_SEMI] = ACTIONS(1320),
    [sym_error] = ACTIONS(1320),
    [sym_compile_intrinsic] = ACTIONS(1320),
    [anon_sym_compile_error] = ACTIONS(1320),
    [sym_location] = ACTIONS(1320),
    [anon_sym_DASH] = ACTIONS(1318),
    [anon_sym_not] = ACTIONS(1320),
    [anon_sym_DASH_TILDE] = ACTIONS(1320),
    [anon_sym_addressof] = ACTIONS(1320),
    [anon_sym_digestof] = ACTIONS(1320),
    [anon_sym_PLUS] = ACTIONS(1318),
    [anon_sym_STAR] = ACTIONS(1318),
    [anon_sym_SLASH] = ACTIONS(1318),
    [anon_sym_PERCENT] = ACTIONS(1318),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1318),
    [anon_sym_LT_LT] = ACTIONS(1318),
    [anon_sym_GT_GT] = ACTIONS(1318),
    [anon_sym_and] = ACTIONS(1320),
    [anon_sym_or] = ACTIONS(1320),
    [anon_sym_xor] = ACTIONS(1320),
    [anon_sym_isnt] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1318),
    [anon_sym_BANG_EQ] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(1318),
    [anon_sym_GT_EQ] = ACTIONS(1318),
    [anon_sym_LT_EQ] = ACTIONS(1318),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_PLUS_TILDE] = ACTIONS(1320),
    [anon_sym_STAR_TILDE] = ACTIONS(1320),
    [anon_sym_SLASH_TILDE] = ACTIONS(1320),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1320),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1320),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1320),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1320),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_GT_TILDE] = ACTIONS(1320),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_LT_TILDE] = ACTIONS(1320),
    [anon_sym_PLUS_QMARK] = ACTIONS(1320),
    [anon_sym_DASH_QMARK] = ACTIONS(1320),
    [anon_sym_STAR_QMARK] = ACTIONS(1320),
    [anon_sym_SLASH_QMARK] = ACTIONS(1320),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1320),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1320),
    [anon_sym_as] = ACTIONS(1320),
    [anon_sym_LPAREN2] = ACTIONS(45),
    [anon_sym_DOT_GT] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(1320),
    [anon_sym_TILDE] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(1320),
    [anon_sym_if] = ACTIONS(1318),
    [anon_sym_ifdef] = ACTIONS(1320),
    [anon_sym_then] = ACTIONS(1320),
    [anon_sym_iftype] = ACTIONS(1320),
    [anon_sym_else] = ACTIONS(1320),
    [anon_sym_for] = ACTIONS(1320),
    [anon_sym_while] = ACTIONS(1320),
    [anon_sym_try] = ACTIONS(1320),
    [anon_sym_with] = ACTIONS(1320),
    [anon_sym_repeat] = ACTIONS(1320),
    [anon_sym_until] = ACTIONS(1320),
    [anon_sym_do] = ACTIONS(1320),
    [anon_sym_recover] = ACTIONS(1320),
    [anon_sym_match] = ACTIONS(1320),
    [anon_sym_return] = ACTIONS(1320),
    [anon_sym_continue] = ACTIONS(1320),
    [anon_sym_break] = ACTIONS(1320),
    [anon_sym_consume] = ACTIONS(1320),
    [anon_sym_object] = ACTIONS(1320),
    [sym_number] = ACTIONS(1318),
    [sym_float] = ACTIONS(1320),
    [anon_sym_DQUOTE] = ACTIONS(1318),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1320),
    [anon_sym_SQUOTE] = ACTIONS(1320),
    [anon_sym_true] = ACTIONS(1320),
    [anon_sym_false] = ACTIONS(1320),
    [sym_this] = ACTIONS(1320),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [398] = {
    [sym_arguments] = STATE(332),
    [sym_identifier] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1326),
    [anon_sym_AT] = ACTIONS(1328),
    [anon_sym_LBRACK] = ACTIONS(1328),
    [anon_sym_RBRACK] = ACTIONS(1328),
    [anon_sym_is] = ACTIONS(1326),
    [anon_sym_embed] = ACTIONS(1328),
    [anon_sym_let] = ACTIONS(1328),
    [anon_sym_var] = ACTIONS(1328),
    [anon_sym_new] = ACTIONS(1328),
    [anon_sym_EQ_GT] = ACTIONS(1328),
    [anon_sym_fun] = ACTIONS(1328),
    [anon_sym_be] = ACTIONS(1328),
    [anon_sym_COMMA] = ACTIONS(1328),
    [anon_sym_LPAREN] = ACTIONS(1326),
    [anon_sym_RPAREN] = ACTIONS(1328),
    [anon_sym_DOT] = ACTIONS(35),
    [anon_sym_LBRACE] = ACTIONS(1328),
    [anon_sym_RBRACE] = ACTIONS(1328),
    [anon_sym_SEMI] = ACTIONS(1328),
    [sym_error] = ACTIONS(1328),
    [sym_compile_intrinsic] = ACTIONS(1328),
    [anon_sym_compile_error] = ACTIONS(1328),
    [sym_location] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_not] = ACTIONS(1328),
    [anon_sym_DASH_TILDE] = ACTIONS(1328),
    [anon_sym_addressof] = ACTIONS(1328),
    [anon_sym_digestof] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1326),
    [anon_sym_STAR] = ACTIONS(1326),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym_PERCENT] = ACTIONS(1326),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1326),
    [anon_sym_GT_GT] = ACTIONS(1326),
    [anon_sym_and] = ACTIONS(1328),
    [anon_sym_or] = ACTIONS(1328),
    [anon_sym_xor] = ACTIONS(1328),
    [anon_sym_isnt] = ACTIONS(1328),
    [anon_sym_EQ_EQ] = ACTIONS(1326),
    [anon_sym_BANG_EQ] = ACTIONS(1326),
    [anon_sym_GT] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_LT] = ACTIONS(1326),
    [anon_sym_PLUS_TILDE] = ACTIONS(1328),
    [anon_sym_STAR_TILDE] = ACTIONS(1328),
    [anon_sym_SLASH_TILDE] = ACTIONS(1328),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1328),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1328),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1328),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1328),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1328),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1328),
    [anon_sym_GT_TILDE] = ACTIONS(1328),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1328),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1328),
    [anon_sym_LT_TILDE] = ACTIONS(1328),
    [anon_sym_PLUS_QMARK] = ACTIONS(1328),
    [anon_sym_DASH_QMARK] = ACTIONS(1328),
    [anon_sym_STAR_QMARK] = ACTIONS(1328),
    [anon_sym_SLASH_QMARK] = ACTIONS(1328),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1328),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1328),
    [anon_sym_as] = ACTIONS(1328),
    [anon_sym_LPAREN2] = ACTIONS(45),
    [anon_sym_DOT_GT] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(1328),
    [anon_sym_TILDE] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(1328),
    [anon_sym_if] = ACTIONS(1326),
    [anon_sym_ifdef] = ACTIONS(1328),
    [anon_sym_then] = ACTIONS(1328),
    [anon_sym_iftype] = ACTIONS(1328),
    [anon_sym_else] = ACTIONS(1328),
    [anon_sym_for] = ACTIONS(1328),
    [anon_sym_while] = ACTIONS(1328),
    [anon_sym_try] = ACTIONS(1328),
    [anon_sym_with] = ACTIONS(1328),
    [anon_sym_repeat] = ACTIONS(1328),
    [anon_sym_until] = ACTIONS(1328),
    [anon_sym_do] = ACTIONS(1328),
    [anon_sym_recover] = ACTIONS(1328),
    [anon_sym_match] = ACTIONS(1328),
    [anon_sym_return] = ACTIONS(1328),
    [anon_sym_continue] = ACTIONS(1328),
    [anon_sym_break] = ACTIONS(1328),
    [anon_sym_consume] = ACTIONS(1328),
    [anon_sym_object] = ACTIONS(1328),
    [sym_number] = ACTIONS(1326),
    [sym_float] = ACTIONS(1328),
    [anon_sym_DQUOTE] = ACTIONS(1326),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1328),
    [anon_sym_SQUOTE] = ACTIONS(1328),
    [anon_sym_true] = ACTIONS(1328),
    [anon_sym_false] = ACTIONS(1328),
    [sym_this] = ACTIONS(1328),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [399] = {
    [sym_identifier] = ACTIONS(1294),
    [anon_sym_EQ] = ACTIONS(1294),
    [anon_sym_AT] = ACTIONS(1292),
    [anon_sym_LBRACK] = ACTIONS(1292),
    [anon_sym_RBRACK] = ACTIONS(1292),
    [anon_sym_is] = ACTIONS(1294),
    [anon_sym_embed] = ACTIONS(1292),
    [anon_sym_let] = ACTIONS(1292),
    [anon_sym_var] = ACTIONS(1292),
    [anon_sym_new] = ACTIONS(1292),
    [anon_sym_EQ_GT] = ACTIONS(1292),
    [anon_sym_fun] = ACTIONS(1292),
    [anon_sym_be] = ACTIONS(1292),
    [anon_sym_COMMA] = ACTIONS(1292),
    [anon_sym_LPAREN] = ACTIONS(1294),
    [anon_sym_RPAREN] = ACTIONS(1292),
    [anon_sym_DOT] = ACTIONS(1294),
    [anon_sym_PIPE] = ACTIONS(1292),
    [anon_sym_LBRACE] = ACTIONS(1292),
    [anon_sym_RBRACE] = ACTIONS(1292),
    [anon_sym_SEMI] = ACTIONS(1292),
    [sym_error] = ACTIONS(1292),
    [sym_compile_intrinsic] = ACTIONS(1292),
    [anon_sym_compile_error] = ACTIONS(1292),
    [sym_location] = ACTIONS(1292),
    [anon_sym_DASH] = ACTIONS(1294),
    [anon_sym_not] = ACTIONS(1292),
    [anon_sym_DASH_TILDE] = ACTIONS(1292),
    [anon_sym_addressof] = ACTIONS(1292),
    [anon_sym_digestof] = ACTIONS(1292),
    [anon_sym_PLUS] = ACTIONS(1294),
    [anon_sym_STAR] = ACTIONS(1294),
    [anon_sym_SLASH] = ACTIONS(1294),
    [anon_sym_PERCENT] = ACTIONS(1294),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1294),
    [anon_sym_LT_LT] = ACTIONS(1294),
    [anon_sym_GT_GT] = ACTIONS(1294),
    [anon_sym_and] = ACTIONS(1292),
    [anon_sym_or] = ACTIONS(1292),
    [anon_sym_xor] = ACTIONS(1292),
    [anon_sym_isnt] = ACTIONS(1292),
    [anon_sym_EQ_EQ] = ACTIONS(1294),
    [anon_sym_BANG_EQ] = ACTIONS(1294),
    [anon_sym_GT] = ACTIONS(1294),
    [anon_sym_GT_EQ] = ACTIONS(1294),
    [anon_sym_LT_EQ] = ACTIONS(1294),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_PLUS_TILDE] = ACTIONS(1292),
    [anon_sym_STAR_TILDE] = ACTIONS(1292),
    [anon_sym_SLASH_TILDE] = ACTIONS(1292),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1292),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1292),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1292),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1292),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1292),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1292),
    [anon_sym_GT_TILDE] = ACTIONS(1292),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1292),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1292),
    [anon_sym_LT_TILDE] = ACTIONS(1292),
    [anon_sym_PLUS_QMARK] = ACTIONS(1292),
    [anon_sym_DASH_QMARK] = ACTIONS(1292),
    [anon_sym_STAR_QMARK] = ACTIONS(1292),
    [anon_sym_SLASH_QMARK] = ACTIONS(1292),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1292),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1292),
    [anon_sym_as] = ACTIONS(1292),
    [anon_sym_LPAREN2] = ACTIONS(1292),
    [anon_sym_DOT_GT] = ACTIONS(1292),
    [anon_sym_where] = ACTIONS(1292),
    [anon_sym_TILDE] = ACTIONS(1292),
    [anon_sym_end] = ACTIONS(1292),
    [anon_sym_if] = ACTIONS(1294),
    [anon_sym_ifdef] = ACTIONS(1292),
    [anon_sym_then] = ACTIONS(1292),
    [anon_sym_iftype] = ACTIONS(1292),
    [anon_sym_else] = ACTIONS(1292),
    [anon_sym_for] = ACTIONS(1292),
    [anon_sym_while] = ACTIONS(1292),
    [anon_sym_try] = ACTIONS(1292),
    [anon_sym_with] = ACTIONS(1292),
    [anon_sym_repeat] = ACTIONS(1292),
    [anon_sym_until] = ACTIONS(1292),
    [anon_sym_do] = ACTIONS(1292),
    [anon_sym_recover] = ACTIONS(1292),
    [anon_sym_match] = ACTIONS(1292),
    [anon_sym_return] = ACTIONS(1292),
    [anon_sym_continue] = ACTIONS(1292),
    [anon_sym_break] = ACTIONS(1292),
    [anon_sym_consume] = ACTIONS(1292),
    [anon_sym_object] = ACTIONS(1292),
    [sym_number] = ACTIONS(1294),
    [sym_float] = ACTIONS(1292),
    [anon_sym_DQUOTE] = ACTIONS(1294),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1292),
    [anon_sym_SQUOTE] = ACTIONS(1292),
    [anon_sym_true] = ACTIONS(1292),
    [anon_sym_false] = ACTIONS(1292),
    [sym_this] = ACTIONS(1292),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [400] = {
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_EQ] = ACTIONS(1222),
    [anon_sym_AT] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1220),
    [anon_sym_RBRACK] = ACTIONS(1220),
    [anon_sym_is] = ACTIONS(1222),
    [anon_sym_embed] = ACTIONS(1220),
    [anon_sym_let] = ACTIONS(1220),
    [anon_sym_var] = ACTIONS(1220),
    [anon_sym_new] = ACTIONS(1220),
    [anon_sym_EQ_GT] = ACTIONS(1220),
    [anon_sym_fun] = ACTIONS(1220),
    [anon_sym_be] = ACTIONS(1220),
    [anon_sym_COMMA] = ACTIONS(1220),
    [anon_sym_LPAREN] = ACTIONS(1222),
    [anon_sym_RPAREN] = ACTIONS(1220),
    [anon_sym_DOT] = ACTIONS(1222),
    [anon_sym_PIPE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_RBRACE] = ACTIONS(1220),
    [anon_sym_SEMI] = ACTIONS(1220),
    [sym_error] = ACTIONS(1220),
    [sym_compile_intrinsic] = ACTIONS(1220),
    [anon_sym_compile_error] = ACTIONS(1220),
    [sym_location] = ACTIONS(1220),
    [anon_sym_DASH] = ACTIONS(1222),
    [anon_sym_not] = ACTIONS(1220),
    [anon_sym_DASH_TILDE] = ACTIONS(1220),
    [anon_sym_addressof] = ACTIONS(1220),
    [anon_sym_digestof] = ACTIONS(1220),
    [anon_sym_PLUS] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(1222),
    [anon_sym_SLASH] = ACTIONS(1222),
    [anon_sym_PERCENT] = ACTIONS(1222),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1222),
    [anon_sym_LT_LT] = ACTIONS(1222),
    [anon_sym_GT_GT] = ACTIONS(1222),
    [anon_sym_and] = ACTIONS(1220),
    [anon_sym_or] = ACTIONS(1220),
    [anon_sym_xor] = ACTIONS(1220),
    [anon_sym_isnt] = ACTIONS(1220),
    [anon_sym_EQ_EQ] = ACTIONS(1222),
    [anon_sym_BANG_EQ] = ACTIONS(1222),
    [anon_sym_GT] = ACTIONS(1222),
    [anon_sym_GT_EQ] = ACTIONS(1222),
    [anon_sym_LT_EQ] = ACTIONS(1222),
    [anon_sym_LT] = ACTIONS(1222),
    [anon_sym_PLUS_TILDE] = ACTIONS(1220),
    [anon_sym_STAR_TILDE] = ACTIONS(1220),
    [anon_sym_SLASH_TILDE] = ACTIONS(1220),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1220),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1220),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1220),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1220),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1220),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1220),
    [anon_sym_GT_TILDE] = ACTIONS(1220),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1220),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1220),
    [anon_sym_LT_TILDE] = ACTIONS(1220),
    [anon_sym_PLUS_QMARK] = ACTIONS(1220),
    [anon_sym_DASH_QMARK] = ACTIONS(1220),
    [anon_sym_STAR_QMARK] = ACTIONS(1220),
    [anon_sym_SLASH_QMARK] = ACTIONS(1220),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1220),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1220),
    [anon_sym_as] = ACTIONS(1220),
    [anon_sym_LPAREN2] = ACTIONS(1220),
    [anon_sym_DOT_GT] = ACTIONS(1220),
    [anon_sym_where] = ACTIONS(1220),
    [anon_sym_TILDE] = ACTIONS(1220),
    [anon_sym_end] = ACTIONS(1220),
    [anon_sym_if] = ACTIONS(1222),
    [anon_sym_ifdef] = ACTIONS(1220),
    [anon_sym_then] = ACTIONS(1220),
    [anon_sym_iftype] = ACTIONS(1220),
    [anon_sym_else] = ACTIONS(1220),
    [anon_sym_for] = ACTIONS(1220),
    [anon_sym_while] = ACTIONS(1220),
    [anon_sym_try] = ACTIONS(1220),
    [anon_sym_with] = ACTIONS(1220),
    [anon_sym_repeat] = ACTIONS(1220),
    [anon_sym_until] = ACTIONS(1220),
    [anon_sym_do] = ACTIONS(1220),
    [anon_sym_recover] = ACTIONS(1220),
    [anon_sym_match] = ACTIONS(1220),
    [anon_sym_return] = ACTIONS(1220),
    [anon_sym_continue] = ACTIONS(1220),
    [anon_sym_break] = ACTIONS(1220),
    [anon_sym_consume] = ACTIONS(1220),
    [anon_sym_object] = ACTIONS(1220),
    [sym_number] = ACTIONS(1222),
    [sym_float] = ACTIONS(1220),
    [anon_sym_DQUOTE] = ACTIONS(1222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1220),
    [anon_sym_SQUOTE] = ACTIONS(1220),
    [anon_sym_true] = ACTIONS(1220),
    [anon_sym_false] = ACTIONS(1220),
    [sym_this] = ACTIONS(1220),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [401] = {
    [sym_identifier] = ACTIONS(1182),
    [anon_sym_EQ] = ACTIONS(1182),
    [anon_sym_AT] = ACTIONS(1180),
    [anon_sym_LBRACK] = ACTIONS(1180),
    [anon_sym_RBRACK] = ACTIONS(1180),
    [anon_sym_is] = ACTIONS(1182),
    [anon_sym_embed] = ACTIONS(1180),
    [anon_sym_let] = ACTIONS(1180),
    [anon_sym_var] = ACTIONS(1180),
    [anon_sym_new] = ACTIONS(1180),
    [anon_sym_EQ_GT] = ACTIONS(1180),
    [anon_sym_fun] = ACTIONS(1180),
    [anon_sym_be] = ACTIONS(1180),
    [anon_sym_COMMA] = ACTIONS(1180),
    [anon_sym_LPAREN] = ACTIONS(1182),
    [anon_sym_RPAREN] = ACTIONS(1180),
    [anon_sym_DOT] = ACTIONS(1182),
    [anon_sym_PIPE] = ACTIONS(1180),
    [anon_sym_LBRACE] = ACTIONS(1180),
    [anon_sym_RBRACE] = ACTIONS(1180),
    [anon_sym_SEMI] = ACTIONS(1180),
    [sym_error] = ACTIONS(1180),
    [sym_compile_intrinsic] = ACTIONS(1180),
    [anon_sym_compile_error] = ACTIONS(1180),
    [sym_location] = ACTIONS(1180),
    [anon_sym_DASH] = ACTIONS(1182),
    [anon_sym_not] = ACTIONS(1180),
    [anon_sym_DASH_TILDE] = ACTIONS(1180),
    [anon_sym_addressof] = ACTIONS(1180),
    [anon_sym_digestof] = ACTIONS(1180),
    [anon_sym_PLUS] = ACTIONS(1182),
    [anon_sym_STAR] = ACTIONS(1182),
    [anon_sym_SLASH] = ACTIONS(1182),
    [anon_sym_PERCENT] = ACTIONS(1182),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1182),
    [anon_sym_LT_LT] = ACTIONS(1182),
    [anon_sym_GT_GT] = ACTIONS(1182),
    [anon_sym_and] = ACTIONS(1180),
    [anon_sym_or] = ACTIONS(1180),
    [anon_sym_xor] = ACTIONS(1180),
    [anon_sym_isnt] = ACTIONS(1180),
    [anon_sym_EQ_EQ] = ACTIONS(1182),
    [anon_sym_BANG_EQ] = ACTIONS(1182),
    [anon_sym_GT] = ACTIONS(1182),
    [anon_sym_GT_EQ] = ACTIONS(1182),
    [anon_sym_LT_EQ] = ACTIONS(1182),
    [anon_sym_LT] = ACTIONS(1182),
    [anon_sym_PLUS_TILDE] = ACTIONS(1180),
    [anon_sym_STAR_TILDE] = ACTIONS(1180),
    [anon_sym_SLASH_TILDE] = ACTIONS(1180),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1180),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1180),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1180),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1180),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1180),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1180),
    [anon_sym_GT_TILDE] = ACTIONS(1180),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1180),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1180),
    [anon_sym_LT_TILDE] = ACTIONS(1180),
    [anon_sym_PLUS_QMARK] = ACTIONS(1180),
    [anon_sym_DASH_QMARK] = ACTIONS(1180),
    [anon_sym_STAR_QMARK] = ACTIONS(1180),
    [anon_sym_SLASH_QMARK] = ACTIONS(1180),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1180),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1180),
    [anon_sym_as] = ACTIONS(1180),
    [anon_sym_LPAREN2] = ACTIONS(1180),
    [anon_sym_DOT_GT] = ACTIONS(1180),
    [anon_sym_where] = ACTIONS(1180),
    [anon_sym_TILDE] = ACTIONS(1180),
    [anon_sym_end] = ACTIONS(1180),
    [anon_sym_if] = ACTIONS(1182),
    [anon_sym_ifdef] = ACTIONS(1180),
    [anon_sym_then] = ACTIONS(1180),
    [anon_sym_iftype] = ACTIONS(1180),
    [anon_sym_else] = ACTIONS(1180),
    [anon_sym_for] = ACTIONS(1180),
    [anon_sym_while] = ACTIONS(1180),
    [anon_sym_try] = ACTIONS(1180),
    [anon_sym_with] = ACTIONS(1180),
    [anon_sym_repeat] = ACTIONS(1180),
    [anon_sym_until] = ACTIONS(1180),
    [anon_sym_do] = ACTIONS(1180),
    [anon_sym_recover] = ACTIONS(1180),
    [anon_sym_match] = ACTIONS(1180),
    [anon_sym_return] = ACTIONS(1180),
    [anon_sym_continue] = ACTIONS(1180),
    [anon_sym_break] = ACTIONS(1180),
    [anon_sym_consume] = ACTIONS(1180),
    [anon_sym_object] = ACTIONS(1180),
    [sym_number] = ACTIONS(1182),
    [sym_float] = ACTIONS(1180),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1180),
    [anon_sym_SQUOTE] = ACTIONS(1180),
    [anon_sym_true] = ACTIONS(1180),
    [anon_sym_false] = ACTIONS(1180),
    [sym_this] = ACTIONS(1180),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [402] = {
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_EQ] = ACTIONS(1302),
    [anon_sym_AT] = ACTIONS(1300),
    [anon_sym_LBRACK] = ACTIONS(1300),
    [anon_sym_RBRACK] = ACTIONS(1300),
    [anon_sym_is] = ACTIONS(1302),
    [anon_sym_embed] = ACTIONS(1300),
    [anon_sym_let] = ACTIONS(1300),
    [anon_sym_var] = ACTIONS(1300),
    [anon_sym_new] = ACTIONS(1300),
    [anon_sym_EQ_GT] = ACTIONS(1300),
    [anon_sym_fun] = ACTIONS(1300),
    [anon_sym_be] = ACTIONS(1300),
    [anon_sym_COMMA] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(1302),
    [anon_sym_RPAREN] = ACTIONS(1300),
    [anon_sym_DOT] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1300),
    [anon_sym_LBRACE] = ACTIONS(1300),
    [anon_sym_RBRACE] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(1300),
    [sym_error] = ACTIONS(1300),
    [sym_compile_intrinsic] = ACTIONS(1300),
    [anon_sym_compile_error] = ACTIONS(1300),
    [sym_location] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1302),
    [anon_sym_not] = ACTIONS(1300),
    [anon_sym_DASH_TILDE] = ACTIONS(1300),
    [anon_sym_addressof] = ACTIONS(1300),
    [anon_sym_digestof] = ACTIONS(1300),
    [anon_sym_PLUS] = ACTIONS(1302),
    [anon_sym_STAR] = ACTIONS(1302),
    [anon_sym_SLASH] = ACTIONS(1302),
    [anon_sym_PERCENT] = ACTIONS(1302),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1302),
    [anon_sym_LT_LT] = ACTIONS(1302),
    [anon_sym_GT_GT] = ACTIONS(1302),
    [anon_sym_and] = ACTIONS(1300),
    [anon_sym_or] = ACTIONS(1300),
    [anon_sym_xor] = ACTIONS(1300),
    [anon_sym_isnt] = ACTIONS(1300),
    [anon_sym_EQ_EQ] = ACTIONS(1302),
    [anon_sym_BANG_EQ] = ACTIONS(1302),
    [anon_sym_GT] = ACTIONS(1302),
    [anon_sym_GT_EQ] = ACTIONS(1302),
    [anon_sym_LT_EQ] = ACTIONS(1302),
    [anon_sym_LT] = ACTIONS(1302),
    [anon_sym_PLUS_TILDE] = ACTIONS(1300),
    [anon_sym_STAR_TILDE] = ACTIONS(1300),
    [anon_sym_SLASH_TILDE] = ACTIONS(1300),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1300),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1300),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1300),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1300),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1300),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1300),
    [anon_sym_GT_TILDE] = ACTIONS(1300),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1300),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1300),
    [anon_sym_LT_TILDE] = ACTIONS(1300),
    [anon_sym_PLUS_QMARK] = ACTIONS(1300),
    [anon_sym_DASH_QMARK] = ACTIONS(1300),
    [anon_sym_STAR_QMARK] = ACTIONS(1300),
    [anon_sym_SLASH_QMARK] = ACTIONS(1300),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1300),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1300),
    [anon_sym_as] = ACTIONS(1300),
    [anon_sym_LPAREN2] = ACTIONS(1300),
    [anon_sym_DOT_GT] = ACTIONS(1300),
    [anon_sym_where] = ACTIONS(1300),
    [anon_sym_TILDE] = ACTIONS(1300),
    [anon_sym_end] = ACTIONS(1300),
    [anon_sym_if] = ACTIONS(1302),
    [anon_sym_ifdef] = ACTIONS(1300),
    [anon_sym_then] = ACTIONS(1300),
    [anon_sym_iftype] = ACTIONS(1300),
    [anon_sym_else] = ACTIONS(1300),
    [anon_sym_for] = ACTIONS(1300),
    [anon_sym_while] = ACTIONS(1300),
    [anon_sym_try] = ACTIONS(1300),
    [anon_sym_with] = ACTIONS(1300),
    [anon_sym_repeat] = ACTIONS(1300),
    [anon_sym_until] = ACTIONS(1300),
    [anon_sym_do] = ACTIONS(1300),
    [anon_sym_recover] = ACTIONS(1300),
    [anon_sym_match] = ACTIONS(1300),
    [anon_sym_return] = ACTIONS(1300),
    [anon_sym_continue] = ACTIONS(1300),
    [anon_sym_break] = ACTIONS(1300),
    [anon_sym_consume] = ACTIONS(1300),
    [anon_sym_object] = ACTIONS(1300),
    [sym_number] = ACTIONS(1302),
    [sym_float] = ACTIONS(1300),
    [anon_sym_DQUOTE] = ACTIONS(1302),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1300),
    [anon_sym_SQUOTE] = ACTIONS(1300),
    [anon_sym_true] = ACTIONS(1300),
    [anon_sym_false] = ACTIONS(1300),
    [sym_this] = ACTIONS(1300),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [403] = {
    [sym_identifier] = ACTIONS(1266),
    [anon_sym_EQ] = ACTIONS(1266),
    [anon_sym_AT] = ACTIONS(1264),
    [anon_sym_LBRACK] = ACTIONS(1264),
    [anon_sym_RBRACK] = ACTIONS(1264),
    [anon_sym_is] = ACTIONS(1266),
    [anon_sym_embed] = ACTIONS(1264),
    [anon_sym_let] = ACTIONS(1264),
    [anon_sym_var] = ACTIONS(1264),
    [anon_sym_new] = ACTIONS(1264),
    [anon_sym_EQ_GT] = ACTIONS(1264),
    [anon_sym_fun] = ACTIONS(1264),
    [anon_sym_be] = ACTIONS(1264),
    [anon_sym_COMMA] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [anon_sym_RPAREN] = ACTIONS(1264),
    [anon_sym_DOT] = ACTIONS(1266),
    [anon_sym_PIPE] = ACTIONS(1264),
    [anon_sym_LBRACE] = ACTIONS(1264),
    [anon_sym_RBRACE] = ACTIONS(1264),
    [anon_sym_SEMI] = ACTIONS(1264),
    [sym_error] = ACTIONS(1264),
    [sym_compile_intrinsic] = ACTIONS(1264),
    [anon_sym_compile_error] = ACTIONS(1264),
    [sym_location] = ACTIONS(1264),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_not] = ACTIONS(1264),
    [anon_sym_DASH_TILDE] = ACTIONS(1264),
    [anon_sym_addressof] = ACTIONS(1264),
    [anon_sym_digestof] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1266),
    [anon_sym_SLASH] = ACTIONS(1266),
    [anon_sym_PERCENT] = ACTIONS(1266),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1266),
    [anon_sym_LT_LT] = ACTIONS(1266),
    [anon_sym_GT_GT] = ACTIONS(1266),
    [anon_sym_and] = ACTIONS(1264),
    [anon_sym_or] = ACTIONS(1264),
    [anon_sym_xor] = ACTIONS(1264),
    [anon_sym_isnt] = ACTIONS(1264),
    [anon_sym_EQ_EQ] = ACTIONS(1266),
    [anon_sym_BANG_EQ] = ACTIONS(1266),
    [anon_sym_GT] = ACTIONS(1266),
    [anon_sym_GT_EQ] = ACTIONS(1266),
    [anon_sym_LT_EQ] = ACTIONS(1266),
    [anon_sym_LT] = ACTIONS(1266),
    [anon_sym_PLUS_TILDE] = ACTIONS(1264),
    [anon_sym_STAR_TILDE] = ACTIONS(1264),
    [anon_sym_SLASH_TILDE] = ACTIONS(1264),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1264),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1264),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1264),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1264),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1264),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1264),
    [anon_sym_GT_TILDE] = ACTIONS(1264),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1264),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1264),
    [anon_sym_LT_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS_QMARK] = ACTIONS(1264),
    [anon_sym_DASH_QMARK] = ACTIONS(1264),
    [anon_sym_STAR_QMARK] = ACTIONS(1264),
    [anon_sym_SLASH_QMARK] = ACTIONS(1264),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1264),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1264),
    [anon_sym_as] = ACTIONS(1264),
    [anon_sym_LPAREN2] = ACTIONS(1264),
    [anon_sym_DOT_GT] = ACTIONS(1264),
    [anon_sym_where] = ACTIONS(1264),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_end] = ACTIONS(1264),
    [anon_sym_if] = ACTIONS(1266),
    [anon_sym_ifdef] = ACTIONS(1264),
    [anon_sym_then] = ACTIONS(1264),
    [anon_sym_iftype] = ACTIONS(1264),
    [anon_sym_else] = ACTIONS(1264),
    [anon_sym_for] = ACTIONS(1264),
    [anon_sym_while] = ACTIONS(1264),
    [anon_sym_try] = ACTIONS(1264),
    [anon_sym_with] = ACTIONS(1264),
    [anon_sym_repeat] = ACTIONS(1264),
    [anon_sym_until] = ACTIONS(1264),
    [anon_sym_do] = ACTIONS(1264),
    [anon_sym_recover] = ACTIONS(1264),
    [anon_sym_match] = ACTIONS(1264),
    [anon_sym_return] = ACTIONS(1264),
    [anon_sym_continue] = ACTIONS(1264),
    [anon_sym_break] = ACTIONS(1264),
    [anon_sym_consume] = ACTIONS(1264),
    [anon_sym_object] = ACTIONS(1264),
    [sym_number] = ACTIONS(1266),
    [sym_float] = ACTIONS(1264),
    [anon_sym_DQUOTE] = ACTIONS(1266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1264),
    [anon_sym_SQUOTE] = ACTIONS(1264),
    [anon_sym_true] = ACTIONS(1264),
    [anon_sym_false] = ACTIONS(1264),
    [sym_this] = ACTIONS(1264),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [404] = {
    [sym_identifier] = ACTIONS(1178),
    [anon_sym_EQ] = ACTIONS(1178),
    [anon_sym_AT] = ACTIONS(1176),
    [anon_sym_LBRACK] = ACTIONS(1176),
    [anon_sym_RBRACK] = ACTIONS(1176),
    [anon_sym_is] = ACTIONS(1178),
    [anon_sym_embed] = ACTIONS(1176),
    [anon_sym_let] = ACTIONS(1176),
    [anon_sym_var] = ACTIONS(1176),
    [anon_sym_new] = ACTIONS(1176),
    [anon_sym_EQ_GT] = ACTIONS(1176),
    [anon_sym_fun] = ACTIONS(1176),
    [anon_sym_be] = ACTIONS(1176),
    [anon_sym_COMMA] = ACTIONS(1176),
    [anon_sym_LPAREN] = ACTIONS(1178),
    [anon_sym_RPAREN] = ACTIONS(1176),
    [anon_sym_DOT] = ACTIONS(1178),
    [anon_sym_PIPE] = ACTIONS(1176),
    [anon_sym_LBRACE] = ACTIONS(1176),
    [anon_sym_RBRACE] = ACTIONS(1176),
    [anon_sym_SEMI] = ACTIONS(1176),
    [sym_error] = ACTIONS(1176),
    [sym_compile_intrinsic] = ACTIONS(1176),
    [anon_sym_compile_error] = ACTIONS(1176),
    [sym_location] = ACTIONS(1176),
    [anon_sym_DASH] = ACTIONS(1178),
    [anon_sym_not] = ACTIONS(1176),
    [anon_sym_DASH_TILDE] = ACTIONS(1176),
    [anon_sym_addressof] = ACTIONS(1176),
    [anon_sym_digestof] = ACTIONS(1176),
    [anon_sym_PLUS] = ACTIONS(1178),
    [anon_sym_STAR] = ACTIONS(1178),
    [anon_sym_SLASH] = ACTIONS(1178),
    [anon_sym_PERCENT] = ACTIONS(1178),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1178),
    [anon_sym_LT_LT] = ACTIONS(1178),
    [anon_sym_GT_GT] = ACTIONS(1178),
    [anon_sym_and] = ACTIONS(1176),
    [anon_sym_or] = ACTIONS(1176),
    [anon_sym_xor] = ACTIONS(1176),
    [anon_sym_isnt] = ACTIONS(1176),
    [anon_sym_EQ_EQ] = ACTIONS(1178),
    [anon_sym_BANG_EQ] = ACTIONS(1178),
    [anon_sym_GT] = ACTIONS(1178),
    [anon_sym_GT_EQ] = ACTIONS(1178),
    [anon_sym_LT_EQ] = ACTIONS(1178),
    [anon_sym_LT] = ACTIONS(1178),
    [anon_sym_PLUS_TILDE] = ACTIONS(1176),
    [anon_sym_STAR_TILDE] = ACTIONS(1176),
    [anon_sym_SLASH_TILDE] = ACTIONS(1176),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1176),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1176),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1176),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1176),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1176),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1176),
    [anon_sym_GT_TILDE] = ACTIONS(1176),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1176),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1176),
    [anon_sym_LT_TILDE] = ACTIONS(1176),
    [anon_sym_PLUS_QMARK] = ACTIONS(1176),
    [anon_sym_DASH_QMARK] = ACTIONS(1176),
    [anon_sym_STAR_QMARK] = ACTIONS(1176),
    [anon_sym_SLASH_QMARK] = ACTIONS(1176),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1176),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1176),
    [anon_sym_as] = ACTIONS(1176),
    [anon_sym_LPAREN2] = ACTIONS(1176),
    [anon_sym_DOT_GT] = ACTIONS(1176),
    [anon_sym_where] = ACTIONS(1176),
    [anon_sym_TILDE] = ACTIONS(1176),
    [anon_sym_end] = ACTIONS(1176),
    [anon_sym_if] = ACTIONS(1178),
    [anon_sym_ifdef] = ACTIONS(1176),
    [anon_sym_then] = ACTIONS(1176),
    [anon_sym_iftype] = ACTIONS(1176),
    [anon_sym_else] = ACTIONS(1176),
    [anon_sym_for] = ACTIONS(1176),
    [anon_sym_while] = ACTIONS(1176),
    [anon_sym_try] = ACTIONS(1176),
    [anon_sym_with] = ACTIONS(1176),
    [anon_sym_repeat] = ACTIONS(1176),
    [anon_sym_until] = ACTIONS(1176),
    [anon_sym_do] = ACTIONS(1176),
    [anon_sym_recover] = ACTIONS(1176),
    [anon_sym_match] = ACTIONS(1176),
    [anon_sym_return] = ACTIONS(1176),
    [anon_sym_continue] = ACTIONS(1176),
    [anon_sym_break] = ACTIONS(1176),
    [anon_sym_consume] = ACTIONS(1176),
    [anon_sym_object] = ACTIONS(1176),
    [sym_number] = ACTIONS(1178),
    [sym_float] = ACTIONS(1176),
    [anon_sym_DQUOTE] = ACTIONS(1178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1176),
    [anon_sym_SQUOTE] = ACTIONS(1176),
    [anon_sym_true] = ACTIONS(1176),
    [anon_sym_false] = ACTIONS(1176),
    [sym_this] = ACTIONS(1176),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [405] = {
    [sym_identifier] = ACTIONS(875),
    [anon_sym_EQ] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_RBRACK] = ACTIONS(873),
    [anon_sym_is] = ACTIONS(875),
    [anon_sym_embed] = ACTIONS(873),
    [anon_sym_let] = ACTIONS(873),
    [anon_sym_var] = ACTIONS(873),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_EQ_GT] = ACTIONS(873),
    [anon_sym_fun] = ACTIONS(873),
    [anon_sym_be] = ACTIONS(873),
    [anon_sym_COMMA] = ACTIONS(873),
    [anon_sym_LPAREN] = ACTIONS(875),
    [anon_sym_RPAREN] = ACTIONS(873),
    [anon_sym_DOT] = ACTIONS(875),
    [anon_sym_PIPE] = ACTIONS(873),
    [anon_sym_LBRACE] = ACTIONS(873),
    [anon_sym_RBRACE] = ACTIONS(873),
    [anon_sym_SEMI] = ACTIONS(873),
    [sym_error] = ACTIONS(873),
    [sym_compile_intrinsic] = ACTIONS(873),
    [anon_sym_compile_error] = ACTIONS(873),
    [sym_location] = ACTIONS(873),
    [anon_sym_DASH] = ACTIONS(875),
    [anon_sym_not] = ACTIONS(873),
    [anon_sym_DASH_TILDE] = ACTIONS(873),
    [anon_sym_addressof] = ACTIONS(873),
    [anon_sym_digestof] = ACTIONS(873),
    [anon_sym_PLUS] = ACTIONS(875),
    [anon_sym_STAR] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(875),
    [anon_sym_PERCENT] = ACTIONS(875),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(875),
    [anon_sym_LT_LT] = ACTIONS(875),
    [anon_sym_GT_GT] = ACTIONS(875),
    [anon_sym_and] = ACTIONS(873),
    [anon_sym_or] = ACTIONS(873),
    [anon_sym_xor] = ACTIONS(873),
    [anon_sym_isnt] = ACTIONS(873),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_BANG_EQ] = ACTIONS(875),
    [anon_sym_GT] = ACTIONS(875),
    [anon_sym_GT_EQ] = ACTIONS(875),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(875),
    [anon_sym_PLUS_TILDE] = ACTIONS(873),
    [anon_sym_STAR_TILDE] = ACTIONS(873),
    [anon_sym_SLASH_TILDE] = ACTIONS(873),
    [anon_sym_PERCENT_TILDE] = ACTIONS(873),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(873),
    [anon_sym_LT_LT_TILDE] = ACTIONS(873),
    [anon_sym_GT_GT_TILDE] = ACTIONS(873),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(873),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(873),
    [anon_sym_GT_TILDE] = ACTIONS(873),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(873),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(873),
    [anon_sym_LT_TILDE] = ACTIONS(873),
    [anon_sym_PLUS_QMARK] = ACTIONS(873),
    [anon_sym_DASH_QMARK] = ACTIONS(873),
    [anon_sym_STAR_QMARK] = ACTIONS(873),
    [anon_sym_SLASH_QMARK] = ACTIONS(873),
    [anon_sym_PERCENT_QMARK] = ACTIONS(873),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(873),
    [anon_sym_as] = ACTIONS(873),
    [anon_sym_LPAREN2] = ACTIONS(873),
    [anon_sym_DOT_GT] = ACTIONS(873),
    [anon_sym_where] = ACTIONS(873),
    [anon_sym_TILDE] = ACTIONS(873),
    [anon_sym_end] = ACTIONS(873),
    [anon_sym_if] = ACTIONS(875),
    [anon_sym_ifdef] = ACTIONS(873),
    [anon_sym_then] = ACTIONS(873),
    [anon_sym_iftype] = ACTIONS(873),
    [anon_sym_else] = ACTIONS(873),
    [anon_sym_for] = ACTIONS(873),
    [anon_sym_while] = ACTIONS(873),
    [anon_sym_try] = ACTIONS(873),
    [anon_sym_with] = ACTIONS(873),
    [anon_sym_repeat] = ACTIONS(873),
    [anon_sym_until] = ACTIONS(873),
    [anon_sym_do] = ACTIONS(873),
    [anon_sym_recover] = ACTIONS(873),
    [anon_sym_match] = ACTIONS(873),
    [anon_sym_return] = ACTIONS(873),
    [anon_sym_continue] = ACTIONS(873),
    [anon_sym_break] = ACTIONS(873),
    [anon_sym_consume] = ACTIONS(873),
    [anon_sym_object] = ACTIONS(873),
    [sym_number] = ACTIONS(875),
    [sym_float] = ACTIONS(873),
    [anon_sym_DQUOTE] = ACTIONS(875),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(873),
    [anon_sym_SQUOTE] = ACTIONS(873),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [sym_this] = ACTIONS(873),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [406] = {
    [sym_identifier] = ACTIONS(668),
    [anon_sym_EQ] = ACTIONS(668),
    [anon_sym_AT] = ACTIONS(666),
    [anon_sym_LBRACK] = ACTIONS(666),
    [anon_sym_RBRACK] = ACTIONS(666),
    [anon_sym_is] = ACTIONS(668),
    [anon_sym_embed] = ACTIONS(666),
    [anon_sym_let] = ACTIONS(666),
    [anon_sym_var] = ACTIONS(666),
    [anon_sym_new] = ACTIONS(666),
    [anon_sym_EQ_GT] = ACTIONS(666),
    [anon_sym_fun] = ACTIONS(666),
    [anon_sym_be] = ACTIONS(666),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(668),
    [anon_sym_RPAREN] = ACTIONS(666),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_RBRACE] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(666),
    [sym_error] = ACTIONS(666),
    [sym_compile_intrinsic] = ACTIONS(666),
    [anon_sym_compile_error] = ACTIONS(666),
    [sym_location] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(668),
    [anon_sym_not] = ACTIONS(666),
    [anon_sym_DASH_TILDE] = ACTIONS(666),
    [anon_sym_addressof] = ACTIONS(666),
    [anon_sym_digestof] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(668),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(668),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(668),
    [anon_sym_LT_LT] = ACTIONS(668),
    [anon_sym_GT_GT] = ACTIONS(668),
    [anon_sym_and] = ACTIONS(666),
    [anon_sym_or] = ACTIONS(666),
    [anon_sym_xor] = ACTIONS(666),
    [anon_sym_isnt] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(668),
    [anon_sym_BANG_EQ] = ACTIONS(668),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_GT_EQ] = ACTIONS(668),
    [anon_sym_LT_EQ] = ACTIONS(668),
    [anon_sym_LT] = ACTIONS(668),
    [anon_sym_PLUS_TILDE] = ACTIONS(666),
    [anon_sym_STAR_TILDE] = ACTIONS(666),
    [anon_sym_SLASH_TILDE] = ACTIONS(666),
    [anon_sym_PERCENT_TILDE] = ACTIONS(666),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(666),
    [anon_sym_LT_LT_TILDE] = ACTIONS(666),
    [anon_sym_GT_GT_TILDE] = ACTIONS(666),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(666),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(666),
    [anon_sym_GT_TILDE] = ACTIONS(666),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(666),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(666),
    [anon_sym_LT_TILDE] = ACTIONS(666),
    [anon_sym_PLUS_QMARK] = ACTIONS(666),
    [anon_sym_DASH_QMARK] = ACTIONS(666),
    [anon_sym_STAR_QMARK] = ACTIONS(666),
    [anon_sym_SLASH_QMARK] = ACTIONS(666),
    [anon_sym_PERCENT_QMARK] = ACTIONS(666),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(666),
    [anon_sym_LPAREN2] = ACTIONS(666),
    [anon_sym_DOT_GT] = ACTIONS(666),
    [anon_sym_where] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_end] = ACTIONS(666),
    [anon_sym_if] = ACTIONS(668),
    [anon_sym_ifdef] = ACTIONS(666),
    [anon_sym_then] = ACTIONS(666),
    [anon_sym_iftype] = ACTIONS(666),
    [anon_sym_else] = ACTIONS(666),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_while] = ACTIONS(666),
    [anon_sym_try] = ACTIONS(666),
    [anon_sym_with] = ACTIONS(666),
    [anon_sym_repeat] = ACTIONS(666),
    [anon_sym_until] = ACTIONS(666),
    [anon_sym_do] = ACTIONS(666),
    [anon_sym_recover] = ACTIONS(666),
    [anon_sym_match] = ACTIONS(666),
    [anon_sym_return] = ACTIONS(666),
    [anon_sym_continue] = ACTIONS(666),
    [anon_sym_break] = ACTIONS(666),
    [anon_sym_consume] = ACTIONS(666),
    [anon_sym_object] = ACTIONS(666),
    [sym_number] = ACTIONS(668),
    [sym_float] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(666),
    [anon_sym_SQUOTE] = ACTIONS(666),
    [anon_sym_true] = ACTIONS(666),
    [anon_sym_false] = ACTIONS(666),
    [sym_this] = ACTIONS(666),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [407] = {
    [sym_identifier] = ACTIONS(640),
    [anon_sym_EQ] = ACTIONS(640),
    [anon_sym_AT] = ACTIONS(638),
    [anon_sym_LBRACK] = ACTIONS(638),
    [anon_sym_RBRACK] = ACTIONS(638),
    [anon_sym_is] = ACTIONS(640),
    [anon_sym_embed] = ACTIONS(638),
    [anon_sym_let] = ACTIONS(638),
    [anon_sym_var] = ACTIONS(638),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_EQ_GT] = ACTIONS(638),
    [anon_sym_fun] = ACTIONS(638),
    [anon_sym_be] = ACTIONS(638),
    [anon_sym_COMMA] = ACTIONS(638),
    [anon_sym_LPAREN] = ACTIONS(640),
    [anon_sym_RPAREN] = ACTIONS(638),
    [anon_sym_DOT] = ACTIONS(640),
    [anon_sym_PIPE] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(638),
    [anon_sym_RBRACE] = ACTIONS(638),
    [anon_sym_SEMI] = ACTIONS(638),
    [sym_error] = ACTIONS(638),
    [sym_compile_intrinsic] = ACTIONS(638),
    [anon_sym_compile_error] = ACTIONS(638),
    [sym_location] = ACTIONS(638),
    [anon_sym_DASH] = ACTIONS(640),
    [anon_sym_not] = ACTIONS(638),
    [anon_sym_DASH_TILDE] = ACTIONS(638),
    [anon_sym_addressof] = ACTIONS(638),
    [anon_sym_digestof] = ACTIONS(638),
    [anon_sym_PLUS] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(640),
    [anon_sym_SLASH] = ACTIONS(640),
    [anon_sym_PERCENT] = ACTIONS(640),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(640),
    [anon_sym_LT_LT] = ACTIONS(640),
    [anon_sym_GT_GT] = ACTIONS(640),
    [anon_sym_and] = ACTIONS(638),
    [anon_sym_or] = ACTIONS(638),
    [anon_sym_xor] = ACTIONS(638),
    [anon_sym_isnt] = ACTIONS(638),
    [anon_sym_EQ_EQ] = ACTIONS(640),
    [anon_sym_BANG_EQ] = ACTIONS(640),
    [anon_sym_GT] = ACTIONS(640),
    [anon_sym_GT_EQ] = ACTIONS(640),
    [anon_sym_LT_EQ] = ACTIONS(640),
    [anon_sym_LT] = ACTIONS(640),
    [anon_sym_PLUS_TILDE] = ACTIONS(638),
    [anon_sym_STAR_TILDE] = ACTIONS(638),
    [anon_sym_SLASH_TILDE] = ACTIONS(638),
    [anon_sym_PERCENT_TILDE] = ACTIONS(638),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(638),
    [anon_sym_LT_LT_TILDE] = ACTIONS(638),
    [anon_sym_GT_GT_TILDE] = ACTIONS(638),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(638),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(638),
    [anon_sym_GT_TILDE] = ACTIONS(638),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(638),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(638),
    [anon_sym_LT_TILDE] = ACTIONS(638),
    [anon_sym_PLUS_QMARK] = ACTIONS(638),
    [anon_sym_DASH_QMARK] = ACTIONS(638),
    [anon_sym_STAR_QMARK] = ACTIONS(638),
    [anon_sym_SLASH_QMARK] = ACTIONS(638),
    [anon_sym_PERCENT_QMARK] = ACTIONS(638),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(638),
    [anon_sym_as] = ACTIONS(638),
    [anon_sym_LPAREN2] = ACTIONS(638),
    [anon_sym_DOT_GT] = ACTIONS(638),
    [anon_sym_where] = ACTIONS(638),
    [anon_sym_TILDE] = ACTIONS(638),
    [anon_sym_end] = ACTIONS(638),
    [anon_sym_if] = ACTIONS(640),
    [anon_sym_ifdef] = ACTIONS(638),
    [anon_sym_then] = ACTIONS(638),
    [anon_sym_iftype] = ACTIONS(638),
    [anon_sym_else] = ACTIONS(638),
    [anon_sym_for] = ACTIONS(638),
    [anon_sym_while] = ACTIONS(638),
    [anon_sym_try] = ACTIONS(638),
    [anon_sym_with] = ACTIONS(638),
    [anon_sym_repeat] = ACTIONS(638),
    [anon_sym_until] = ACTIONS(638),
    [anon_sym_do] = ACTIONS(638),
    [anon_sym_recover] = ACTIONS(638),
    [anon_sym_match] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(638),
    [anon_sym_continue] = ACTIONS(638),
    [anon_sym_break] = ACTIONS(638),
    [anon_sym_consume] = ACTIONS(638),
    [anon_sym_object] = ACTIONS(638),
    [sym_number] = ACTIONS(640),
    [sym_float] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(640),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(638),
    [anon_sym_SQUOTE] = ACTIONS(638),
    [anon_sym_true] = ACTIONS(638),
    [anon_sym_false] = ACTIONS(638),
    [sym_this] = ACTIONS(638),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [408] = {
    [sym_identifier] = ACTIONS(1092),
    [anon_sym_EQ] = ACTIONS(1092),
    [anon_sym_AT] = ACTIONS(1090),
    [anon_sym_LBRACK] = ACTIONS(1090),
    [anon_sym_RBRACK] = ACTIONS(1090),
    [anon_sym_is] = ACTIONS(1092),
    [anon_sym_embed] = ACTIONS(1090),
    [anon_sym_let] = ACTIONS(1090),
    [anon_sym_var] = ACTIONS(1090),
    [anon_sym_new] = ACTIONS(1090),
    [anon_sym_EQ_GT] = ACTIONS(1090),
    [anon_sym_fun] = ACTIONS(1090),
    [anon_sym_be] = ACTIONS(1090),
    [anon_sym_COMMA] = ACTIONS(1090),
    [anon_sym_LPAREN] = ACTIONS(1092),
    [anon_sym_RPAREN] = ACTIONS(1090),
    [anon_sym_DOT] = ACTIONS(1092),
    [anon_sym_PIPE] = ACTIONS(1090),
    [anon_sym_LBRACE] = ACTIONS(1090),
    [anon_sym_RBRACE] = ACTIONS(1090),
    [anon_sym_SEMI] = ACTIONS(1090),
    [sym_error] = ACTIONS(1090),
    [sym_compile_intrinsic] = ACTIONS(1090),
    [anon_sym_compile_error] = ACTIONS(1090),
    [sym_location] = ACTIONS(1090),
    [anon_sym_DASH] = ACTIONS(1092),
    [anon_sym_not] = ACTIONS(1090),
    [anon_sym_DASH_TILDE] = ACTIONS(1090),
    [anon_sym_addressof] = ACTIONS(1090),
    [anon_sym_digestof] = ACTIONS(1090),
    [anon_sym_PLUS] = ACTIONS(1092),
    [anon_sym_STAR] = ACTIONS(1092),
    [anon_sym_SLASH] = ACTIONS(1092),
    [anon_sym_PERCENT] = ACTIONS(1092),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1092),
    [anon_sym_LT_LT] = ACTIONS(1092),
    [anon_sym_GT_GT] = ACTIONS(1092),
    [anon_sym_and] = ACTIONS(1090),
    [anon_sym_or] = ACTIONS(1090),
    [anon_sym_xor] = ACTIONS(1090),
    [anon_sym_isnt] = ACTIONS(1090),
    [anon_sym_EQ_EQ] = ACTIONS(1092),
    [anon_sym_BANG_EQ] = ACTIONS(1092),
    [anon_sym_GT] = ACTIONS(1092),
    [anon_sym_GT_EQ] = ACTIONS(1092),
    [anon_sym_LT_EQ] = ACTIONS(1092),
    [anon_sym_LT] = ACTIONS(1092),
    [anon_sym_PLUS_TILDE] = ACTIONS(1090),
    [anon_sym_STAR_TILDE] = ACTIONS(1090),
    [anon_sym_SLASH_TILDE] = ACTIONS(1090),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1090),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1090),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1090),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1090),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1090),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1090),
    [anon_sym_GT_TILDE] = ACTIONS(1090),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1090),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1090),
    [anon_sym_LT_TILDE] = ACTIONS(1090),
    [anon_sym_PLUS_QMARK] = ACTIONS(1090),
    [anon_sym_DASH_QMARK] = ACTIONS(1090),
    [anon_sym_STAR_QMARK] = ACTIONS(1090),
    [anon_sym_SLASH_QMARK] = ACTIONS(1090),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1090),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1090),
    [anon_sym_as] = ACTIONS(1090),
    [anon_sym_LPAREN2] = ACTIONS(1090),
    [anon_sym_DOT_GT] = ACTIONS(1090),
    [anon_sym_where] = ACTIONS(1090),
    [anon_sym_TILDE] = ACTIONS(1090),
    [anon_sym_end] = ACTIONS(1090),
    [anon_sym_if] = ACTIONS(1092),
    [anon_sym_ifdef] = ACTIONS(1090),
    [anon_sym_then] = ACTIONS(1090),
    [anon_sym_iftype] = ACTIONS(1090),
    [anon_sym_else] = ACTIONS(1090),
    [anon_sym_for] = ACTIONS(1090),
    [anon_sym_while] = ACTIONS(1090),
    [anon_sym_try] = ACTIONS(1090),
    [anon_sym_with] = ACTIONS(1090),
    [anon_sym_repeat] = ACTIONS(1090),
    [anon_sym_until] = ACTIONS(1090),
    [anon_sym_do] = ACTIONS(1090),
    [anon_sym_recover] = ACTIONS(1090),
    [anon_sym_match] = ACTIONS(1090),
    [anon_sym_return] = ACTIONS(1090),
    [anon_sym_continue] = ACTIONS(1090),
    [anon_sym_break] = ACTIONS(1090),
    [anon_sym_consume] = ACTIONS(1090),
    [anon_sym_object] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_float] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1090),
    [anon_sym_true] = ACTIONS(1090),
    [anon_sym_false] = ACTIONS(1090),
    [sym_this] = ACTIONS(1090),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [409] = {
    [sym_identifier] = ACTIONS(1100),
    [anon_sym_EQ] = ACTIONS(1100),
    [anon_sym_AT] = ACTIONS(1098),
    [anon_sym_LBRACK] = ACTIONS(1098),
    [anon_sym_RBRACK] = ACTIONS(1098),
    [anon_sym_is] = ACTIONS(1100),
    [anon_sym_embed] = ACTIONS(1098),
    [anon_sym_let] = ACTIONS(1098),
    [anon_sym_var] = ACTIONS(1098),
    [anon_sym_new] = ACTIONS(1098),
    [anon_sym_EQ_GT] = ACTIONS(1098),
    [anon_sym_fun] = ACTIONS(1098),
    [anon_sym_be] = ACTIONS(1098),
    [anon_sym_COMMA] = ACTIONS(1098),
    [anon_sym_LPAREN] = ACTIONS(1100),
    [anon_sym_RPAREN] = ACTIONS(1098),
    [anon_sym_DOT] = ACTIONS(1100),
    [anon_sym_PIPE] = ACTIONS(1098),
    [anon_sym_LBRACE] = ACTIONS(1098),
    [anon_sym_RBRACE] = ACTIONS(1098),
    [anon_sym_SEMI] = ACTIONS(1098),
    [sym_error] = ACTIONS(1098),
    [sym_compile_intrinsic] = ACTIONS(1098),
    [anon_sym_compile_error] = ACTIONS(1098),
    [sym_location] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1100),
    [anon_sym_not] = ACTIONS(1098),
    [anon_sym_DASH_TILDE] = ACTIONS(1098),
    [anon_sym_addressof] = ACTIONS(1098),
    [anon_sym_digestof] = ACTIONS(1098),
    [anon_sym_PLUS] = ACTIONS(1100),
    [anon_sym_STAR] = ACTIONS(1100),
    [anon_sym_SLASH] = ACTIONS(1100),
    [anon_sym_PERCENT] = ACTIONS(1100),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1100),
    [anon_sym_LT_LT] = ACTIONS(1100),
    [anon_sym_GT_GT] = ACTIONS(1100),
    [anon_sym_and] = ACTIONS(1098),
    [anon_sym_or] = ACTIONS(1098),
    [anon_sym_xor] = ACTIONS(1098),
    [anon_sym_isnt] = ACTIONS(1098),
    [anon_sym_EQ_EQ] = ACTIONS(1100),
    [anon_sym_BANG_EQ] = ACTIONS(1100),
    [anon_sym_GT] = ACTIONS(1100),
    [anon_sym_GT_EQ] = ACTIONS(1100),
    [anon_sym_LT_EQ] = ACTIONS(1100),
    [anon_sym_LT] = ACTIONS(1100),
    [anon_sym_PLUS_TILDE] = ACTIONS(1098),
    [anon_sym_STAR_TILDE] = ACTIONS(1098),
    [anon_sym_SLASH_TILDE] = ACTIONS(1098),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1098),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1098),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1098),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1098),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1098),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1098),
    [anon_sym_GT_TILDE] = ACTIONS(1098),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1098),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1098),
    [anon_sym_LT_TILDE] = ACTIONS(1098),
    [anon_sym_PLUS_QMARK] = ACTIONS(1098),
    [anon_sym_DASH_QMARK] = ACTIONS(1098),
    [anon_sym_STAR_QMARK] = ACTIONS(1098),
    [anon_sym_SLASH_QMARK] = ACTIONS(1098),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1098),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1098),
    [anon_sym_as] = ACTIONS(1098),
    [anon_sym_LPAREN2] = ACTIONS(1098),
    [anon_sym_DOT_GT] = ACTIONS(1098),
    [anon_sym_where] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1098),
    [anon_sym_end] = ACTIONS(1098),
    [anon_sym_if] = ACTIONS(1100),
    [anon_sym_ifdef] = ACTIONS(1098),
    [anon_sym_then] = ACTIONS(1098),
    [anon_sym_iftype] = ACTIONS(1098),
    [anon_sym_else] = ACTIONS(1098),
    [anon_sym_for] = ACTIONS(1098),
    [anon_sym_while] = ACTIONS(1098),
    [anon_sym_try] = ACTIONS(1098),
    [anon_sym_with] = ACTIONS(1098),
    [anon_sym_repeat] = ACTIONS(1098),
    [anon_sym_until] = ACTIONS(1098),
    [anon_sym_do] = ACTIONS(1098),
    [anon_sym_recover] = ACTIONS(1098),
    [anon_sym_match] = ACTIONS(1098),
    [anon_sym_return] = ACTIONS(1098),
    [anon_sym_continue] = ACTIONS(1098),
    [anon_sym_break] = ACTIONS(1098),
    [anon_sym_consume] = ACTIONS(1098),
    [anon_sym_object] = ACTIONS(1098),
    [sym_number] = ACTIONS(1100),
    [sym_float] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(1100),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_SQUOTE] = ACTIONS(1098),
    [anon_sym_true] = ACTIONS(1098),
    [anon_sym_false] = ACTIONS(1098),
    [sym_this] = ACTIONS(1098),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [410] = {
    [sym_identifier] = ACTIONS(1218),
    [anon_sym_EQ] = ACTIONS(1218),
    [anon_sym_AT] = ACTIONS(1216),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_RBRACK] = ACTIONS(1216),
    [anon_sym_is] = ACTIONS(1218),
    [anon_sym_embed] = ACTIONS(1216),
    [anon_sym_let] = ACTIONS(1216),
    [anon_sym_var] = ACTIONS(1216),
    [anon_sym_new] = ACTIONS(1216),
    [anon_sym_EQ_GT] = ACTIONS(1216),
    [anon_sym_fun] = ACTIONS(1216),
    [anon_sym_be] = ACTIONS(1216),
    [anon_sym_COMMA] = ACTIONS(1216),
    [anon_sym_LPAREN] = ACTIONS(1218),
    [anon_sym_RPAREN] = ACTIONS(1216),
    [anon_sym_DOT] = ACTIONS(1218),
    [anon_sym_PIPE] = ACTIONS(1216),
    [anon_sym_LBRACE] = ACTIONS(1216),
    [anon_sym_RBRACE] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1216),
    [sym_error] = ACTIONS(1216),
    [sym_compile_intrinsic] = ACTIONS(1216),
    [anon_sym_compile_error] = ACTIONS(1216),
    [sym_location] = ACTIONS(1216),
    [anon_sym_DASH] = ACTIONS(1218),
    [anon_sym_not] = ACTIONS(1216),
    [anon_sym_DASH_TILDE] = ACTIONS(1216),
    [anon_sym_addressof] = ACTIONS(1216),
    [anon_sym_digestof] = ACTIONS(1216),
    [anon_sym_PLUS] = ACTIONS(1218),
    [anon_sym_STAR] = ACTIONS(1218),
    [anon_sym_SLASH] = ACTIONS(1218),
    [anon_sym_PERCENT] = ACTIONS(1218),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1218),
    [anon_sym_LT_LT] = ACTIONS(1218),
    [anon_sym_GT_GT] = ACTIONS(1218),
    [anon_sym_and] = ACTIONS(1216),
    [anon_sym_or] = ACTIONS(1216),
    [anon_sym_xor] = ACTIONS(1216),
    [anon_sym_isnt] = ACTIONS(1216),
    [anon_sym_EQ_EQ] = ACTIONS(1218),
    [anon_sym_BANG_EQ] = ACTIONS(1218),
    [anon_sym_GT] = ACTIONS(1218),
    [anon_sym_GT_EQ] = ACTIONS(1218),
    [anon_sym_LT_EQ] = ACTIONS(1218),
    [anon_sym_LT] = ACTIONS(1218),
    [anon_sym_PLUS_TILDE] = ACTIONS(1216),
    [anon_sym_STAR_TILDE] = ACTIONS(1216),
    [anon_sym_SLASH_TILDE] = ACTIONS(1216),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1216),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1216),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1216),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1216),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1216),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1216),
    [anon_sym_GT_TILDE] = ACTIONS(1216),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1216),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1216),
    [anon_sym_LT_TILDE] = ACTIONS(1216),
    [anon_sym_PLUS_QMARK] = ACTIONS(1216),
    [anon_sym_DASH_QMARK] = ACTIONS(1216),
    [anon_sym_STAR_QMARK] = ACTIONS(1216),
    [anon_sym_SLASH_QMARK] = ACTIONS(1216),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1216),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1216),
    [anon_sym_as] = ACTIONS(1216),
    [anon_sym_LPAREN2] = ACTIONS(1216),
    [anon_sym_DOT_GT] = ACTIONS(1216),
    [anon_sym_where] = ACTIONS(1216),
    [anon_sym_TILDE] = ACTIONS(1216),
    [anon_sym_end] = ACTIONS(1216),
    [anon_sym_if] = ACTIONS(1218),
    [anon_sym_ifdef] = ACTIONS(1216),
    [anon_sym_then] = ACTIONS(1216),
    [anon_sym_iftype] = ACTIONS(1216),
    [anon_sym_else] = ACTIONS(1216),
    [anon_sym_for] = ACTIONS(1216),
    [anon_sym_while] = ACTIONS(1216),
    [anon_sym_try] = ACTIONS(1216),
    [anon_sym_with] = ACTIONS(1216),
    [anon_sym_repeat] = ACTIONS(1216),
    [anon_sym_until] = ACTIONS(1216),
    [anon_sym_do] = ACTIONS(1216),
    [anon_sym_recover] = ACTIONS(1216),
    [anon_sym_match] = ACTIONS(1216),
    [anon_sym_return] = ACTIONS(1216),
    [anon_sym_continue] = ACTIONS(1216),
    [anon_sym_break] = ACTIONS(1216),
    [anon_sym_consume] = ACTIONS(1216),
    [anon_sym_object] = ACTIONS(1216),
    [sym_number] = ACTIONS(1218),
    [sym_float] = ACTIONS(1216),
    [anon_sym_DQUOTE] = ACTIONS(1218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1216),
    [anon_sym_SQUOTE] = ACTIONS(1216),
    [anon_sym_true] = ACTIONS(1216),
    [anon_sym_false] = ACTIONS(1216),
    [sym_this] = ACTIONS(1216),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [411] = {
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_EQ] = ACTIONS(1214),
    [anon_sym_AT] = ACTIONS(1212),
    [anon_sym_LBRACK] = ACTIONS(1212),
    [anon_sym_RBRACK] = ACTIONS(1212),
    [anon_sym_is] = ACTIONS(1214),
    [anon_sym_embed] = ACTIONS(1212),
    [anon_sym_let] = ACTIONS(1212),
    [anon_sym_var] = ACTIONS(1212),
    [anon_sym_new] = ACTIONS(1212),
    [anon_sym_EQ_GT] = ACTIONS(1212),
    [anon_sym_fun] = ACTIONS(1212),
    [anon_sym_be] = ACTIONS(1212),
    [anon_sym_COMMA] = ACTIONS(1212),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_RPAREN] = ACTIONS(1212),
    [anon_sym_DOT] = ACTIONS(1214),
    [anon_sym_PIPE] = ACTIONS(1212),
    [anon_sym_LBRACE] = ACTIONS(1212),
    [anon_sym_RBRACE] = ACTIONS(1212),
    [anon_sym_SEMI] = ACTIONS(1212),
    [sym_error] = ACTIONS(1212),
    [sym_compile_intrinsic] = ACTIONS(1212),
    [anon_sym_compile_error] = ACTIONS(1212),
    [sym_location] = ACTIONS(1212),
    [anon_sym_DASH] = ACTIONS(1214),
    [anon_sym_not] = ACTIONS(1212),
    [anon_sym_DASH_TILDE] = ACTIONS(1212),
    [anon_sym_addressof] = ACTIONS(1212),
    [anon_sym_digestof] = ACTIONS(1212),
    [anon_sym_PLUS] = ACTIONS(1214),
    [anon_sym_STAR] = ACTIONS(1214),
    [anon_sym_SLASH] = ACTIONS(1214),
    [anon_sym_PERCENT] = ACTIONS(1214),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1214),
    [anon_sym_LT_LT] = ACTIONS(1214),
    [anon_sym_GT_GT] = ACTIONS(1214),
    [anon_sym_and] = ACTIONS(1212),
    [anon_sym_or] = ACTIONS(1212),
    [anon_sym_xor] = ACTIONS(1212),
    [anon_sym_isnt] = ACTIONS(1212),
    [anon_sym_EQ_EQ] = ACTIONS(1214),
    [anon_sym_BANG_EQ] = ACTIONS(1214),
    [anon_sym_GT] = ACTIONS(1214),
    [anon_sym_GT_EQ] = ACTIONS(1214),
    [anon_sym_LT_EQ] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1214),
    [anon_sym_PLUS_TILDE] = ACTIONS(1212),
    [anon_sym_STAR_TILDE] = ACTIONS(1212),
    [anon_sym_SLASH_TILDE] = ACTIONS(1212),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1212),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1212),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1212),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1212),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1212),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1212),
    [anon_sym_GT_TILDE] = ACTIONS(1212),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1212),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1212),
    [anon_sym_LT_TILDE] = ACTIONS(1212),
    [anon_sym_PLUS_QMARK] = ACTIONS(1212),
    [anon_sym_DASH_QMARK] = ACTIONS(1212),
    [anon_sym_STAR_QMARK] = ACTIONS(1212),
    [anon_sym_SLASH_QMARK] = ACTIONS(1212),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1212),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1212),
    [anon_sym_as] = ACTIONS(1212),
    [anon_sym_LPAREN2] = ACTIONS(1212),
    [anon_sym_DOT_GT] = ACTIONS(1212),
    [anon_sym_where] = ACTIONS(1212),
    [anon_sym_TILDE] = ACTIONS(1212),
    [anon_sym_end] = ACTIONS(1212),
    [anon_sym_if] = ACTIONS(1214),
    [anon_sym_ifdef] = ACTIONS(1212),
    [anon_sym_then] = ACTIONS(1212),
    [anon_sym_iftype] = ACTIONS(1212),
    [anon_sym_else] = ACTIONS(1212),
    [anon_sym_for] = ACTIONS(1212),
    [anon_sym_while] = ACTIONS(1212),
    [anon_sym_try] = ACTIONS(1212),
    [anon_sym_with] = ACTIONS(1212),
    [anon_sym_repeat] = ACTIONS(1212),
    [anon_sym_until] = ACTIONS(1212),
    [anon_sym_do] = ACTIONS(1212),
    [anon_sym_recover] = ACTIONS(1212),
    [anon_sym_match] = ACTIONS(1212),
    [anon_sym_return] = ACTIONS(1212),
    [anon_sym_continue] = ACTIONS(1212),
    [anon_sym_break] = ACTIONS(1212),
    [anon_sym_consume] = ACTIONS(1212),
    [anon_sym_object] = ACTIONS(1212),
    [sym_number] = ACTIONS(1214),
    [sym_float] = ACTIONS(1212),
    [anon_sym_DQUOTE] = ACTIONS(1214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1212),
    [anon_sym_SQUOTE] = ACTIONS(1212),
    [anon_sym_true] = ACTIONS(1212),
    [anon_sym_false] = ACTIONS(1212),
    [sym_this] = ACTIONS(1212),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [412] = {
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_EQ] = ACTIONS(1108),
    [anon_sym_AT] = ACTIONS(1106),
    [anon_sym_LBRACK] = ACTIONS(1106),
    [anon_sym_RBRACK] = ACTIONS(1106),
    [anon_sym_is] = ACTIONS(1108),
    [anon_sym_embed] = ACTIONS(1106),
    [anon_sym_let] = ACTIONS(1106),
    [anon_sym_var] = ACTIONS(1106),
    [anon_sym_new] = ACTIONS(1106),
    [anon_sym_EQ_GT] = ACTIONS(1106),
    [anon_sym_fun] = ACTIONS(1106),
    [anon_sym_be] = ACTIONS(1106),
    [anon_sym_COMMA] = ACTIONS(1106),
    [anon_sym_LPAREN] = ACTIONS(1108),
    [anon_sym_RPAREN] = ACTIONS(1106),
    [anon_sym_DOT] = ACTIONS(1108),
    [anon_sym_PIPE] = ACTIONS(1106),
    [anon_sym_LBRACE] = ACTIONS(1106),
    [anon_sym_RBRACE] = ACTIONS(1106),
    [anon_sym_SEMI] = ACTIONS(1106),
    [sym_error] = ACTIONS(1106),
    [sym_compile_intrinsic] = ACTIONS(1106),
    [anon_sym_compile_error] = ACTIONS(1106),
    [sym_location] = ACTIONS(1106),
    [anon_sym_DASH] = ACTIONS(1108),
    [anon_sym_not] = ACTIONS(1106),
    [anon_sym_DASH_TILDE] = ACTIONS(1106),
    [anon_sym_addressof] = ACTIONS(1106),
    [anon_sym_digestof] = ACTIONS(1106),
    [anon_sym_PLUS] = ACTIONS(1108),
    [anon_sym_STAR] = ACTIONS(1108),
    [anon_sym_SLASH] = ACTIONS(1108),
    [anon_sym_PERCENT] = ACTIONS(1108),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1108),
    [anon_sym_LT_LT] = ACTIONS(1108),
    [anon_sym_GT_GT] = ACTIONS(1108),
    [anon_sym_and] = ACTIONS(1106),
    [anon_sym_or] = ACTIONS(1106),
    [anon_sym_xor] = ACTIONS(1106),
    [anon_sym_isnt] = ACTIONS(1106),
    [anon_sym_EQ_EQ] = ACTIONS(1108),
    [anon_sym_BANG_EQ] = ACTIONS(1108),
    [anon_sym_GT] = ACTIONS(1108),
    [anon_sym_GT_EQ] = ACTIONS(1108),
    [anon_sym_LT_EQ] = ACTIONS(1108),
    [anon_sym_LT] = ACTIONS(1108),
    [anon_sym_PLUS_TILDE] = ACTIONS(1106),
    [anon_sym_STAR_TILDE] = ACTIONS(1106),
    [anon_sym_SLASH_TILDE] = ACTIONS(1106),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1106),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1106),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1106),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1106),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1106),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1106),
    [anon_sym_GT_TILDE] = ACTIONS(1106),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1106),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1106),
    [anon_sym_LT_TILDE] = ACTIONS(1106),
    [anon_sym_PLUS_QMARK] = ACTIONS(1106),
    [anon_sym_DASH_QMARK] = ACTIONS(1106),
    [anon_sym_STAR_QMARK] = ACTIONS(1106),
    [anon_sym_SLASH_QMARK] = ACTIONS(1106),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1106),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1106),
    [anon_sym_as] = ACTIONS(1106),
    [anon_sym_LPAREN2] = ACTIONS(1106),
    [anon_sym_DOT_GT] = ACTIONS(1106),
    [anon_sym_where] = ACTIONS(1106),
    [anon_sym_TILDE] = ACTIONS(1106),
    [anon_sym_end] = ACTIONS(1106),
    [anon_sym_if] = ACTIONS(1108),
    [anon_sym_ifdef] = ACTIONS(1106),
    [anon_sym_then] = ACTIONS(1106),
    [anon_sym_iftype] = ACTIONS(1106),
    [anon_sym_else] = ACTIONS(1106),
    [anon_sym_for] = ACTIONS(1106),
    [anon_sym_while] = ACTIONS(1106),
    [anon_sym_try] = ACTIONS(1106),
    [anon_sym_with] = ACTIONS(1106),
    [anon_sym_repeat] = ACTIONS(1106),
    [anon_sym_until] = ACTIONS(1106),
    [anon_sym_do] = ACTIONS(1106),
    [anon_sym_recover] = ACTIONS(1106),
    [anon_sym_match] = ACTIONS(1106),
    [anon_sym_return] = ACTIONS(1106),
    [anon_sym_continue] = ACTIONS(1106),
    [anon_sym_break] = ACTIONS(1106),
    [anon_sym_consume] = ACTIONS(1106),
    [anon_sym_object] = ACTIONS(1106),
    [sym_number] = ACTIONS(1108),
    [sym_float] = ACTIONS(1106),
    [anon_sym_DQUOTE] = ACTIONS(1108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1106),
    [anon_sym_SQUOTE] = ACTIONS(1106),
    [anon_sym_true] = ACTIONS(1106),
    [anon_sym_false] = ACTIONS(1106),
    [sym_this] = ACTIONS(1106),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [413] = {
    [sym_identifier] = ACTIONS(1120),
    [anon_sym_EQ] = ACTIONS(1120),
    [anon_sym_AT] = ACTIONS(1118),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_RBRACK] = ACTIONS(1118),
    [anon_sym_is] = ACTIONS(1120),
    [anon_sym_embed] = ACTIONS(1118),
    [anon_sym_let] = ACTIONS(1118),
    [anon_sym_var] = ACTIONS(1118),
    [anon_sym_new] = ACTIONS(1118),
    [anon_sym_EQ_GT] = ACTIONS(1118),
    [anon_sym_fun] = ACTIONS(1118),
    [anon_sym_be] = ACTIONS(1118),
    [anon_sym_COMMA] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1120),
    [anon_sym_RPAREN] = ACTIONS(1118),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_PIPE] = ACTIONS(1118),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_RBRACE] = ACTIONS(1118),
    [anon_sym_SEMI] = ACTIONS(1118),
    [sym_error] = ACTIONS(1118),
    [sym_compile_intrinsic] = ACTIONS(1118),
    [anon_sym_compile_error] = ACTIONS(1118),
    [sym_location] = ACTIONS(1118),
    [anon_sym_DASH] = ACTIONS(1120),
    [anon_sym_not] = ACTIONS(1118),
    [anon_sym_DASH_TILDE] = ACTIONS(1118),
    [anon_sym_addressof] = ACTIONS(1118),
    [anon_sym_digestof] = ACTIONS(1118),
    [anon_sym_PLUS] = ACTIONS(1120),
    [anon_sym_STAR] = ACTIONS(1120),
    [anon_sym_SLASH] = ACTIONS(1120),
    [anon_sym_PERCENT] = ACTIONS(1120),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1120),
    [anon_sym_LT_LT] = ACTIONS(1120),
    [anon_sym_GT_GT] = ACTIONS(1120),
    [anon_sym_and] = ACTIONS(1118),
    [anon_sym_or] = ACTIONS(1118),
    [anon_sym_xor] = ACTIONS(1118),
    [anon_sym_isnt] = ACTIONS(1118),
    [anon_sym_EQ_EQ] = ACTIONS(1120),
    [anon_sym_BANG_EQ] = ACTIONS(1120),
    [anon_sym_GT] = ACTIONS(1120),
    [anon_sym_GT_EQ] = ACTIONS(1120),
    [anon_sym_LT_EQ] = ACTIONS(1120),
    [anon_sym_LT] = ACTIONS(1120),
    [anon_sym_PLUS_TILDE] = ACTIONS(1118),
    [anon_sym_STAR_TILDE] = ACTIONS(1118),
    [anon_sym_SLASH_TILDE] = ACTIONS(1118),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1118),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1118),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1118),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1118),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1118),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1118),
    [anon_sym_GT_TILDE] = ACTIONS(1118),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1118),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1118),
    [anon_sym_LT_TILDE] = ACTIONS(1118),
    [anon_sym_PLUS_QMARK] = ACTIONS(1118),
    [anon_sym_DASH_QMARK] = ACTIONS(1118),
    [anon_sym_STAR_QMARK] = ACTIONS(1118),
    [anon_sym_SLASH_QMARK] = ACTIONS(1118),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1118),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1118),
    [anon_sym_as] = ACTIONS(1118),
    [anon_sym_LPAREN2] = ACTIONS(1118),
    [anon_sym_DOT_GT] = ACTIONS(1118),
    [anon_sym_where] = ACTIONS(1118),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_end] = ACTIONS(1118),
    [anon_sym_if] = ACTIONS(1120),
    [anon_sym_ifdef] = ACTIONS(1118),
    [anon_sym_then] = ACTIONS(1118),
    [anon_sym_iftype] = ACTIONS(1118),
    [anon_sym_else] = ACTIONS(1118),
    [anon_sym_for] = ACTIONS(1118),
    [anon_sym_while] = ACTIONS(1118),
    [anon_sym_try] = ACTIONS(1118),
    [anon_sym_with] = ACTIONS(1118),
    [anon_sym_repeat] = ACTIONS(1118),
    [anon_sym_until] = ACTIONS(1118),
    [anon_sym_do] = ACTIONS(1118),
    [anon_sym_recover] = ACTIONS(1118),
    [anon_sym_match] = ACTIONS(1118),
    [anon_sym_return] = ACTIONS(1118),
    [anon_sym_continue] = ACTIONS(1118),
    [anon_sym_break] = ACTIONS(1118),
    [anon_sym_consume] = ACTIONS(1118),
    [anon_sym_object] = ACTIONS(1118),
    [sym_number] = ACTIONS(1120),
    [sym_float] = ACTIONS(1118),
    [anon_sym_DQUOTE] = ACTIONS(1120),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1118),
    [anon_sym_SQUOTE] = ACTIONS(1118),
    [anon_sym_true] = ACTIONS(1118),
    [anon_sym_false] = ACTIONS(1118),
    [sym_this] = ACTIONS(1118),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [414] = {
    [sym_identifier] = ACTIONS(855),
    [anon_sym_EQ] = ACTIONS(855),
    [anon_sym_AT] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_RBRACK] = ACTIONS(853),
    [anon_sym_is] = ACTIONS(855),
    [anon_sym_embed] = ACTIONS(853),
    [anon_sym_let] = ACTIONS(853),
    [anon_sym_var] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(853),
    [anon_sym_EQ_GT] = ACTIONS(853),
    [anon_sym_fun] = ACTIONS(853),
    [anon_sym_be] = ACTIONS(853),
    [anon_sym_COMMA] = ACTIONS(853),
    [anon_sym_LPAREN] = ACTIONS(855),
    [anon_sym_RPAREN] = ACTIONS(853),
    [anon_sym_DOT] = ACTIONS(855),
    [anon_sym_PIPE] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(853),
    [anon_sym_RBRACE] = ACTIONS(853),
    [anon_sym_SEMI] = ACTIONS(853),
    [sym_error] = ACTIONS(853),
    [sym_compile_intrinsic] = ACTIONS(853),
    [anon_sym_compile_error] = ACTIONS(853),
    [sym_location] = ACTIONS(853),
    [anon_sym_DASH] = ACTIONS(855),
    [anon_sym_not] = ACTIONS(853),
    [anon_sym_DASH_TILDE] = ACTIONS(853),
    [anon_sym_addressof] = ACTIONS(853),
    [anon_sym_digestof] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_PERCENT] = ACTIONS(855),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(855),
    [anon_sym_LT_LT] = ACTIONS(855),
    [anon_sym_GT_GT] = ACTIONS(855),
    [anon_sym_and] = ACTIONS(853),
    [anon_sym_or] = ACTIONS(853),
    [anon_sym_xor] = ACTIONS(853),
    [anon_sym_isnt] = ACTIONS(853),
    [anon_sym_EQ_EQ] = ACTIONS(855),
    [anon_sym_BANG_EQ] = ACTIONS(855),
    [anon_sym_GT] = ACTIONS(855),
    [anon_sym_GT_EQ] = ACTIONS(855),
    [anon_sym_LT_EQ] = ACTIONS(855),
    [anon_sym_LT] = ACTIONS(855),
    [anon_sym_PLUS_TILDE] = ACTIONS(853),
    [anon_sym_STAR_TILDE] = ACTIONS(853),
    [anon_sym_SLASH_TILDE] = ACTIONS(853),
    [anon_sym_PERCENT_TILDE] = ACTIONS(853),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(853),
    [anon_sym_LT_LT_TILDE] = ACTIONS(853),
    [anon_sym_GT_GT_TILDE] = ACTIONS(853),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(853),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(853),
    [anon_sym_GT_TILDE] = ACTIONS(853),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(853),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(853),
    [anon_sym_LT_TILDE] = ACTIONS(853),
    [anon_sym_PLUS_QMARK] = ACTIONS(853),
    [anon_sym_DASH_QMARK] = ACTIONS(853),
    [anon_sym_STAR_QMARK] = ACTIONS(853),
    [anon_sym_SLASH_QMARK] = ACTIONS(853),
    [anon_sym_PERCENT_QMARK] = ACTIONS(853),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(853),
    [anon_sym_as] = ACTIONS(853),
    [anon_sym_LPAREN2] = ACTIONS(853),
    [anon_sym_DOT_GT] = ACTIONS(853),
    [anon_sym_where] = ACTIONS(853),
    [anon_sym_TILDE] = ACTIONS(853),
    [anon_sym_end] = ACTIONS(853),
    [anon_sym_if] = ACTIONS(855),
    [anon_sym_ifdef] = ACTIONS(853),
    [anon_sym_then] = ACTIONS(853),
    [anon_sym_iftype] = ACTIONS(853),
    [anon_sym_else] = ACTIONS(853),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_while] = ACTIONS(853),
    [anon_sym_try] = ACTIONS(853),
    [anon_sym_with] = ACTIONS(853),
    [anon_sym_repeat] = ACTIONS(853),
    [anon_sym_until] = ACTIONS(853),
    [anon_sym_do] = ACTIONS(853),
    [anon_sym_recover] = ACTIONS(853),
    [anon_sym_match] = ACTIONS(853),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_continue] = ACTIONS(853),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_consume] = ACTIONS(853),
    [anon_sym_object] = ACTIONS(853),
    [sym_number] = ACTIONS(855),
    [sym_float] = ACTIONS(853),
    [anon_sym_DQUOTE] = ACTIONS(855),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(853),
    [anon_sym_true] = ACTIONS(853),
    [anon_sym_false] = ACTIONS(853),
    [sym_this] = ACTIONS(853),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [415] = {
    [sym_identifier] = ACTIONS(1104),
    [anon_sym_EQ] = ACTIONS(1104),
    [anon_sym_AT] = ACTIONS(1102),
    [anon_sym_LBRACK] = ACTIONS(1102),
    [anon_sym_RBRACK] = ACTIONS(1102),
    [anon_sym_is] = ACTIONS(1104),
    [anon_sym_embed] = ACTIONS(1102),
    [anon_sym_let] = ACTIONS(1102),
    [anon_sym_var] = ACTIONS(1102),
    [anon_sym_new] = ACTIONS(1102),
    [anon_sym_EQ_GT] = ACTIONS(1102),
    [anon_sym_fun] = ACTIONS(1102),
    [anon_sym_be] = ACTIONS(1102),
    [anon_sym_COMMA] = ACTIONS(1102),
    [anon_sym_LPAREN] = ACTIONS(1104),
    [anon_sym_RPAREN] = ACTIONS(1102),
    [anon_sym_DOT] = ACTIONS(1104),
    [anon_sym_PIPE] = ACTIONS(1102),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_RBRACE] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1102),
    [sym_error] = ACTIONS(1102),
    [sym_compile_intrinsic] = ACTIONS(1102),
    [anon_sym_compile_error] = ACTIONS(1102),
    [sym_location] = ACTIONS(1102),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_not] = ACTIONS(1102),
    [anon_sym_DASH_TILDE] = ACTIONS(1102),
    [anon_sym_addressof] = ACTIONS(1102),
    [anon_sym_digestof] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1104),
    [anon_sym_SLASH] = ACTIONS(1104),
    [anon_sym_PERCENT] = ACTIONS(1104),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1104),
    [anon_sym_LT_LT] = ACTIONS(1104),
    [anon_sym_GT_GT] = ACTIONS(1104),
    [anon_sym_and] = ACTIONS(1102),
    [anon_sym_or] = ACTIONS(1102),
    [anon_sym_xor] = ACTIONS(1102),
    [anon_sym_isnt] = ACTIONS(1102),
    [anon_sym_EQ_EQ] = ACTIONS(1104),
    [anon_sym_BANG_EQ] = ACTIONS(1104),
    [anon_sym_GT] = ACTIONS(1104),
    [anon_sym_GT_EQ] = ACTIONS(1104),
    [anon_sym_LT_EQ] = ACTIONS(1104),
    [anon_sym_LT] = ACTIONS(1104),
    [anon_sym_PLUS_TILDE] = ACTIONS(1102),
    [anon_sym_STAR_TILDE] = ACTIONS(1102),
    [anon_sym_SLASH_TILDE] = ACTIONS(1102),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1102),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1102),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1102),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1102),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1102),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1102),
    [anon_sym_GT_TILDE] = ACTIONS(1102),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1102),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1102),
    [anon_sym_LT_TILDE] = ACTIONS(1102),
    [anon_sym_PLUS_QMARK] = ACTIONS(1102),
    [anon_sym_DASH_QMARK] = ACTIONS(1102),
    [anon_sym_STAR_QMARK] = ACTIONS(1102),
    [anon_sym_SLASH_QMARK] = ACTIONS(1102),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1102),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1102),
    [anon_sym_as] = ACTIONS(1102),
    [anon_sym_LPAREN2] = ACTIONS(1102),
    [anon_sym_DOT_GT] = ACTIONS(1102),
    [anon_sym_where] = ACTIONS(1102),
    [anon_sym_TILDE] = ACTIONS(1102),
    [anon_sym_end] = ACTIONS(1102),
    [anon_sym_if] = ACTIONS(1104),
    [anon_sym_ifdef] = ACTIONS(1102),
    [anon_sym_then] = ACTIONS(1102),
    [anon_sym_iftype] = ACTIONS(1102),
    [anon_sym_else] = ACTIONS(1102),
    [anon_sym_for] = ACTIONS(1102),
    [anon_sym_while] = ACTIONS(1102),
    [anon_sym_try] = ACTIONS(1102),
    [anon_sym_with] = ACTIONS(1102),
    [anon_sym_repeat] = ACTIONS(1102),
    [anon_sym_until] = ACTIONS(1102),
    [anon_sym_do] = ACTIONS(1102),
    [anon_sym_recover] = ACTIONS(1102),
    [anon_sym_match] = ACTIONS(1102),
    [anon_sym_return] = ACTIONS(1102),
    [anon_sym_continue] = ACTIONS(1102),
    [anon_sym_break] = ACTIONS(1102),
    [anon_sym_consume] = ACTIONS(1102),
    [anon_sym_object] = ACTIONS(1102),
    [sym_number] = ACTIONS(1104),
    [sym_float] = ACTIONS(1102),
    [anon_sym_DQUOTE] = ACTIONS(1104),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1102),
    [anon_sym_SQUOTE] = ACTIONS(1102),
    [anon_sym_true] = ACTIONS(1102),
    [anon_sym_false] = ACTIONS(1102),
    [sym_this] = ACTIONS(1102),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [416] = {
    [sym_identifier] = ACTIONS(1270),
    [anon_sym_EQ] = ACTIONS(1270),
    [anon_sym_AT] = ACTIONS(1268),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [anon_sym_RBRACK] = ACTIONS(1268),
    [anon_sym_is] = ACTIONS(1270),
    [anon_sym_embed] = ACTIONS(1268),
    [anon_sym_let] = ACTIONS(1268),
    [anon_sym_var] = ACTIONS(1268),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_EQ_GT] = ACTIONS(1268),
    [anon_sym_fun] = ACTIONS(1268),
    [anon_sym_be] = ACTIONS(1268),
    [anon_sym_COMMA] = ACTIONS(1268),
    [anon_sym_LPAREN] = ACTIONS(1270),
    [anon_sym_RPAREN] = ACTIONS(1268),
    [anon_sym_DOT] = ACTIONS(1270),
    [anon_sym_PIPE] = ACTIONS(1268),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(1268),
    [anon_sym_SEMI] = ACTIONS(1268),
    [sym_error] = ACTIONS(1268),
    [sym_compile_intrinsic] = ACTIONS(1268),
    [anon_sym_compile_error] = ACTIONS(1268),
    [sym_location] = ACTIONS(1268),
    [anon_sym_DASH] = ACTIONS(1270),
    [anon_sym_not] = ACTIONS(1268),
    [anon_sym_DASH_TILDE] = ACTIONS(1268),
    [anon_sym_addressof] = ACTIONS(1268),
    [anon_sym_digestof] = ACTIONS(1268),
    [anon_sym_PLUS] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1270),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_PERCENT] = ACTIONS(1270),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1270),
    [anon_sym_LT_LT] = ACTIONS(1270),
    [anon_sym_GT_GT] = ACTIONS(1270),
    [anon_sym_and] = ACTIONS(1268),
    [anon_sym_or] = ACTIONS(1268),
    [anon_sym_xor] = ACTIONS(1268),
    [anon_sym_isnt] = ACTIONS(1268),
    [anon_sym_EQ_EQ] = ACTIONS(1270),
    [anon_sym_BANG_EQ] = ACTIONS(1270),
    [anon_sym_GT] = ACTIONS(1270),
    [anon_sym_GT_EQ] = ACTIONS(1270),
    [anon_sym_LT_EQ] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(1270),
    [anon_sym_PLUS_TILDE] = ACTIONS(1268),
    [anon_sym_STAR_TILDE] = ACTIONS(1268),
    [anon_sym_SLASH_TILDE] = ACTIONS(1268),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1268),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1268),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1268),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1268),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1268),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1268),
    [anon_sym_GT_TILDE] = ACTIONS(1268),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1268),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1268),
    [anon_sym_LT_TILDE] = ACTIONS(1268),
    [anon_sym_PLUS_QMARK] = ACTIONS(1268),
    [anon_sym_DASH_QMARK] = ACTIONS(1268),
    [anon_sym_STAR_QMARK] = ACTIONS(1268),
    [anon_sym_SLASH_QMARK] = ACTIONS(1268),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1268),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1268),
    [anon_sym_as] = ACTIONS(1268),
    [anon_sym_LPAREN2] = ACTIONS(1268),
    [anon_sym_DOT_GT] = ACTIONS(1268),
    [anon_sym_where] = ACTIONS(1268),
    [anon_sym_TILDE] = ACTIONS(1268),
    [anon_sym_end] = ACTIONS(1268),
    [anon_sym_if] = ACTIONS(1270),
    [anon_sym_ifdef] = ACTIONS(1268),
    [anon_sym_then] = ACTIONS(1268),
    [anon_sym_iftype] = ACTIONS(1268),
    [anon_sym_else] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(1268),
    [anon_sym_while] = ACTIONS(1268),
    [anon_sym_try] = ACTIONS(1268),
    [anon_sym_with] = ACTIONS(1268),
    [anon_sym_repeat] = ACTIONS(1268),
    [anon_sym_until] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(1268),
    [anon_sym_recover] = ACTIONS(1268),
    [anon_sym_match] = ACTIONS(1268),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_continue] = ACTIONS(1268),
    [anon_sym_break] = ACTIONS(1268),
    [anon_sym_consume] = ACTIONS(1268),
    [anon_sym_object] = ACTIONS(1268),
    [sym_number] = ACTIONS(1270),
    [sym_float] = ACTIONS(1268),
    [anon_sym_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1268),
    [anon_sym_SQUOTE] = ACTIONS(1268),
    [anon_sym_true] = ACTIONS(1268),
    [anon_sym_false] = ACTIONS(1268),
    [sym_this] = ACTIONS(1268),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [417] = {
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(1140),
    [anon_sym_AT] = ACTIONS(1138),
    [anon_sym_LBRACK] = ACTIONS(1138),
    [anon_sym_RBRACK] = ACTIONS(1138),
    [anon_sym_is] = ACTIONS(1140),
    [anon_sym_embed] = ACTIONS(1138),
    [anon_sym_let] = ACTIONS(1138),
    [anon_sym_var] = ACTIONS(1138),
    [anon_sym_new] = ACTIONS(1138),
    [anon_sym_EQ_GT] = ACTIONS(1138),
    [anon_sym_fun] = ACTIONS(1138),
    [anon_sym_be] = ACTIONS(1138),
    [anon_sym_COMMA] = ACTIONS(1138),
    [anon_sym_LPAREN] = ACTIONS(1140),
    [anon_sym_RPAREN] = ACTIONS(1138),
    [anon_sym_DOT] = ACTIONS(1140),
    [anon_sym_PIPE] = ACTIONS(1138),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_RBRACE] = ACTIONS(1138),
    [anon_sym_SEMI] = ACTIONS(1138),
    [sym_error] = ACTIONS(1138),
    [sym_compile_intrinsic] = ACTIONS(1138),
    [anon_sym_compile_error] = ACTIONS(1138),
    [sym_location] = ACTIONS(1138),
    [anon_sym_DASH] = ACTIONS(1140),
    [anon_sym_not] = ACTIONS(1138),
    [anon_sym_DASH_TILDE] = ACTIONS(1138),
    [anon_sym_addressof] = ACTIONS(1138),
    [anon_sym_digestof] = ACTIONS(1138),
    [anon_sym_PLUS] = ACTIONS(1140),
    [anon_sym_STAR] = ACTIONS(1140),
    [anon_sym_SLASH] = ACTIONS(1140),
    [anon_sym_PERCENT] = ACTIONS(1140),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1140),
    [anon_sym_LT_LT] = ACTIONS(1140),
    [anon_sym_GT_GT] = ACTIONS(1140),
    [anon_sym_and] = ACTIONS(1138),
    [anon_sym_or] = ACTIONS(1138),
    [anon_sym_xor] = ACTIONS(1138),
    [anon_sym_isnt] = ACTIONS(1138),
    [anon_sym_EQ_EQ] = ACTIONS(1140),
    [anon_sym_BANG_EQ] = ACTIONS(1140),
    [anon_sym_GT] = ACTIONS(1140),
    [anon_sym_GT_EQ] = ACTIONS(1140),
    [anon_sym_LT_EQ] = ACTIONS(1140),
    [anon_sym_LT] = ACTIONS(1140),
    [anon_sym_PLUS_TILDE] = ACTIONS(1138),
    [anon_sym_STAR_TILDE] = ACTIONS(1138),
    [anon_sym_SLASH_TILDE] = ACTIONS(1138),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1138),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1138),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1138),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1138),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1138),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1138),
    [anon_sym_GT_TILDE] = ACTIONS(1138),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1138),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1138),
    [anon_sym_LT_TILDE] = ACTIONS(1138),
    [anon_sym_PLUS_QMARK] = ACTIONS(1138),
    [anon_sym_DASH_QMARK] = ACTIONS(1138),
    [anon_sym_STAR_QMARK] = ACTIONS(1138),
    [anon_sym_SLASH_QMARK] = ACTIONS(1138),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1138),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1138),
    [anon_sym_as] = ACTIONS(1138),
    [anon_sym_LPAREN2] = ACTIONS(1138),
    [anon_sym_DOT_GT] = ACTIONS(1138),
    [anon_sym_where] = ACTIONS(1138),
    [anon_sym_TILDE] = ACTIONS(1138),
    [anon_sym_end] = ACTIONS(1138),
    [anon_sym_if] = ACTIONS(1140),
    [anon_sym_ifdef] = ACTIONS(1138),
    [anon_sym_then] = ACTIONS(1138),
    [anon_sym_iftype] = ACTIONS(1138),
    [anon_sym_else] = ACTIONS(1138),
    [anon_sym_for] = ACTIONS(1138),
    [anon_sym_while] = ACTIONS(1138),
    [anon_sym_try] = ACTIONS(1138),
    [anon_sym_with] = ACTIONS(1138),
    [anon_sym_repeat] = ACTIONS(1138),
    [anon_sym_until] = ACTIONS(1138),
    [anon_sym_do] = ACTIONS(1138),
    [anon_sym_recover] = ACTIONS(1138),
    [anon_sym_match] = ACTIONS(1138),
    [anon_sym_return] = ACTIONS(1138),
    [anon_sym_continue] = ACTIONS(1138),
    [anon_sym_break] = ACTIONS(1138),
    [anon_sym_consume] = ACTIONS(1138),
    [anon_sym_object] = ACTIONS(1138),
    [sym_number] = ACTIONS(1140),
    [sym_float] = ACTIONS(1138),
    [anon_sym_DQUOTE] = ACTIONS(1140),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1138),
    [anon_sym_SQUOTE] = ACTIONS(1138),
    [anon_sym_true] = ACTIONS(1138),
    [anon_sym_false] = ACTIONS(1138),
    [sym_this] = ACTIONS(1138),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [418] = {
    [sym_arguments] = STATE(223),
    [ts_builtin_sym_end] = ACTIONS(1316),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1316),
    [anon_sym_EQ] = ACTIONS(169),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_LBRACK] = ACTIONS(1316),
    [anon_sym_type] = ACTIONS(1316),
    [anon_sym_is] = ACTIONS(175),
    [anon_sym_actor] = ACTIONS(1316),
    [anon_sym_class] = ACTIONS(1316),
    [anon_sym_primitive] = ACTIONS(1316),
    [anon_sym_interface] = ACTIONS(1316),
    [anon_sym_trait] = ACTIONS(1316),
    [anon_sym_struct] = ACTIONS(1316),
    [anon_sym_embed] = ACTIONS(1316),
    [anon_sym_let] = ACTIONS(1316),
    [anon_sym_var] = ACTIONS(1316),
    [anon_sym_new] = ACTIONS(1316),
    [anon_sym_fun] = ACTIONS(1316),
    [anon_sym_be] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_SEMI] = ACTIONS(1316),
    [sym_error] = ACTIONS(1316),
    [sym_compile_intrinsic] = ACTIONS(1316),
    [anon_sym_compile_error] = ACTIONS(1316),
    [sym_location] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(175),
    [anon_sym_not] = ACTIONS(1316),
    [anon_sym_DASH_TILDE] = ACTIONS(195),
    [anon_sym_addressof] = ACTIONS(1316),
    [anon_sym_digestof] = ACTIONS(1316),
    [anon_sym_PLUS] = ACTIONS(175),
    [anon_sym_STAR] = ACTIONS(175),
    [anon_sym_SLASH] = ACTIONS(175),
    [anon_sym_PERCENT] = ACTIONS(175),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(175),
    [anon_sym_LT_LT] = ACTIONS(175),
    [anon_sym_GT_GT] = ACTIONS(175),
    [anon_sym_and] = ACTIONS(195),
    [anon_sym_or] = ACTIONS(195),
    [anon_sym_xor] = ACTIONS(195),
    [anon_sym_isnt] = ACTIONS(195),
    [anon_sym_EQ_EQ] = ACTIONS(175),
    [anon_sym_BANG_EQ] = ACTIONS(175),
    [anon_sym_GT] = ACTIONS(175),
    [anon_sym_GT_EQ] = ACTIONS(175),
    [anon_sym_LT_EQ] = ACTIONS(175),
    [anon_sym_LT] = ACTIONS(175),
    [anon_sym_PLUS_TILDE] = ACTIONS(195),
    [anon_sym_STAR_TILDE] = ACTIONS(195),
    [anon_sym_SLASH_TILDE] = ACTIONS(195),
    [anon_sym_PERCENT_TILDE] = ACTIONS(195),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(195),
    [anon_sym_LT_LT_TILDE] = ACTIONS(195),
    [anon_sym_GT_GT_TILDE] = ACTIONS(195),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(195),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(195),
    [anon_sym_GT_TILDE] = ACTIONS(195),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(195),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(195),
    [anon_sym_LT_TILDE] = ACTIONS(195),
    [anon_sym_PLUS_QMARK] = ACTIONS(195),
    [anon_sym_DASH_QMARK] = ACTIONS(195),
    [anon_sym_STAR_QMARK] = ACTIONS(195),
    [anon_sym_SLASH_QMARK] = ACTIONS(195),
    [anon_sym_PERCENT_QMARK] = ACTIONS(195),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(195),
    [anon_sym_as] = ACTIONS(197),
    [anon_sym_LPAREN2] = ACTIONS(199),
    [anon_sym_DOT_GT] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_ifdef] = ACTIONS(1316),
    [anon_sym_iftype] = ACTIONS(1316),
    [anon_sym_for] = ACTIONS(1316),
    [anon_sym_while] = ACTIONS(1316),
    [anon_sym_try] = ACTIONS(1316),
    [anon_sym_with] = ACTIONS(1316),
    [anon_sym_repeat] = ACTIONS(1316),
    [anon_sym_recover] = ACTIONS(1316),
    [anon_sym_match] = ACTIONS(1316),
    [anon_sym_return] = ACTIONS(1316),
    [anon_sym_continue] = ACTIONS(1316),
    [anon_sym_break] = ACTIONS(1316),
    [anon_sym_consume] = ACTIONS(1316),
    [anon_sym_object] = ACTIONS(1316),
    [sym_number] = ACTIONS(1314),
    [sym_float] = ACTIONS(1316),
    [anon_sym_DQUOTE] = ACTIONS(1314),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1316),
    [anon_sym_true] = ACTIONS(1316),
    [anon_sym_false] = ACTIONS(1316),
    [sym_this] = ACTIONS(1316),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [419] = {
    [sym_arguments] = STATE(223),
    [ts_builtin_sym_end] = ACTIONS(1324),
    [sym_identifier] = ACTIONS(1322),
    [anon_sym_use] = ACTIONS(1324),
    [anon_sym_EQ] = ACTIONS(1322),
    [anon_sym_AT] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(1324),
    [anon_sym_type] = ACTIONS(1324),
    [anon_sym_is] = ACTIONS(1322),
    [anon_sym_actor] = ACTIONS(1324),
    [anon_sym_class] = ACTIONS(1324),
    [anon_sym_primitive] = ACTIONS(1324),
    [anon_sym_interface] = ACTIONS(1324),
    [anon_sym_trait] = ACTIONS(1324),
    [anon_sym_struct] = ACTIONS(1324),
    [anon_sym_embed] = ACTIONS(1324),
    [anon_sym_let] = ACTIONS(1324),
    [anon_sym_var] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1324),
    [anon_sym_fun] = ACTIONS(1324),
    [anon_sym_be] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(1322),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_SEMI] = ACTIONS(1324),
    [sym_error] = ACTIONS(1324),
    [sym_compile_intrinsic] = ACTIONS(1324),
    [anon_sym_compile_error] = ACTIONS(1324),
    [sym_location] = ACTIONS(1324),
    [anon_sym_DASH] = ACTIONS(1322),
    [anon_sym_not] = ACTIONS(1324),
    [anon_sym_DASH_TILDE] = ACTIONS(1324),
    [anon_sym_addressof] = ACTIONS(1324),
    [anon_sym_digestof] = ACTIONS(1324),
    [anon_sym_PLUS] = ACTIONS(1322),
    [anon_sym_STAR] = ACTIONS(1322),
    [anon_sym_SLASH] = ACTIONS(1322),
    [anon_sym_PERCENT] = ACTIONS(1322),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1322),
    [anon_sym_LT_LT] = ACTIONS(1322),
    [anon_sym_GT_GT] = ACTIONS(1322),
    [anon_sym_and] = ACTIONS(1324),
    [anon_sym_or] = ACTIONS(1324),
    [anon_sym_xor] = ACTIONS(1324),
    [anon_sym_isnt] = ACTIONS(1324),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_GT] = ACTIONS(1322),
    [anon_sym_GT_EQ] = ACTIONS(1322),
    [anon_sym_LT_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1322),
    [anon_sym_PLUS_TILDE] = ACTIONS(1324),
    [anon_sym_STAR_TILDE] = ACTIONS(1324),
    [anon_sym_SLASH_TILDE] = ACTIONS(1324),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1324),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1324),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1324),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1324),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1324),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1324),
    [anon_sym_GT_TILDE] = ACTIONS(1324),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1324),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1324),
    [anon_sym_LT_TILDE] = ACTIONS(1324),
    [anon_sym_PLUS_QMARK] = ACTIONS(1324),
    [anon_sym_DASH_QMARK] = ACTIONS(1324),
    [anon_sym_STAR_QMARK] = ACTIONS(1324),
    [anon_sym_SLASH_QMARK] = ACTIONS(1324),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1324),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1324),
    [anon_sym_as] = ACTIONS(197),
    [anon_sym_LPAREN2] = ACTIONS(199),
    [anon_sym_DOT_GT] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(1322),
    [anon_sym_ifdef] = ACTIONS(1324),
    [anon_sym_iftype] = ACTIONS(1324),
    [anon_sym_for] = ACTIONS(1324),
    [anon_sym_while] = ACTIONS(1324),
    [anon_sym_try] = ACTIONS(1324),
    [anon_sym_with] = ACTIONS(1324),
    [anon_sym_repeat] = ACTIONS(1324),
    [anon_sym_recover] = ACTIONS(1324),
    [anon_sym_match] = ACTIONS(1324),
    [anon_sym_return] = ACTIONS(1324),
    [anon_sym_continue] = ACTIONS(1324),
    [anon_sym_break] = ACTIONS(1324),
    [anon_sym_consume] = ACTIONS(1324),
    [anon_sym_object] = ACTIONS(1324),
    [sym_number] = ACTIONS(1322),
    [sym_float] = ACTIONS(1324),
    [anon_sym_DQUOTE] = ACTIONS(1322),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1324),
    [anon_sym_SQUOTE] = ACTIONS(1324),
    [anon_sym_true] = ACTIONS(1324),
    [anon_sym_false] = ACTIONS(1324),
    [sym_this] = ACTIONS(1324),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [420] = {
    [sym_arguments] = STATE(223),
    [ts_builtin_sym_end] = ACTIONS(74),
    [sym_identifier] = ACTIONS(66),
    [anon_sym_use] = ACTIONS(74),
    [anon_sym_EQ] = ACTIONS(169),
    [anon_sym_AT] = ACTIONS(74),
    [anon_sym_LBRACK] = ACTIONS(74),
    [anon_sym_type] = ACTIONS(74),
    [anon_sym_is] = ACTIONS(175),
    [anon_sym_actor] = ACTIONS(74),
    [anon_sym_class] = ACTIONS(74),
    [anon_sym_primitive] = ACTIONS(74),
    [anon_sym_interface] = ACTIONS(74),
    [anon_sym_trait] = ACTIONS(74),
    [anon_sym_struct] = ACTIONS(74),
    [anon_sym_embed] = ACTIONS(74),
    [anon_sym_let] = ACTIONS(74),
    [anon_sym_var] = ACTIONS(74),
    [anon_sym_new] = ACTIONS(74),
    [anon_sym_fun] = ACTIONS(74),
    [anon_sym_be] = ACTIONS(74),
    [anon_sym_LPAREN] = ACTIONS(66),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(74),
    [anon_sym_SEMI] = ACTIONS(74),
    [sym_error] = ACTIONS(74),
    [sym_compile_intrinsic] = ACTIONS(74),
    [anon_sym_compile_error] = ACTIONS(74),
    [sym_location] = ACTIONS(74),
    [anon_sym_DASH] = ACTIONS(175),
    [anon_sym_not] = ACTIONS(74),
    [anon_sym_DASH_TILDE] = ACTIONS(195),
    [anon_sym_addressof] = ACTIONS(74),
    [anon_sym_digestof] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(175),
    [anon_sym_STAR] = ACTIONS(175),
    [anon_sym_SLASH] = ACTIONS(175),
    [anon_sym_PERCENT] = ACTIONS(175),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(175),
    [anon_sym_LT_LT] = ACTIONS(175),
    [anon_sym_GT_GT] = ACTIONS(175),
    [anon_sym_and] = ACTIONS(195),
    [anon_sym_or] = ACTIONS(195),
    [anon_sym_xor] = ACTIONS(195),
    [anon_sym_isnt] = ACTIONS(195),
    [anon_sym_EQ_EQ] = ACTIONS(175),
    [anon_sym_BANG_EQ] = ACTIONS(175),
    [anon_sym_GT] = ACTIONS(175),
    [anon_sym_GT_EQ] = ACTIONS(175),
    [anon_sym_LT_EQ] = ACTIONS(175),
    [anon_sym_LT] = ACTIONS(175),
    [anon_sym_PLUS_TILDE] = ACTIONS(195),
    [anon_sym_STAR_TILDE] = ACTIONS(195),
    [anon_sym_SLASH_TILDE] = ACTIONS(195),
    [anon_sym_PERCENT_TILDE] = ACTIONS(195),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(195),
    [anon_sym_LT_LT_TILDE] = ACTIONS(195),
    [anon_sym_GT_GT_TILDE] = ACTIONS(195),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(195),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(195),
    [anon_sym_GT_TILDE] = ACTIONS(195),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(195),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(195),
    [anon_sym_LT_TILDE] = ACTIONS(195),
    [anon_sym_PLUS_QMARK] = ACTIONS(195),
    [anon_sym_DASH_QMARK] = ACTIONS(195),
    [anon_sym_STAR_QMARK] = ACTIONS(195),
    [anon_sym_SLASH_QMARK] = ACTIONS(195),
    [anon_sym_PERCENT_QMARK] = ACTIONS(195),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(195),
    [anon_sym_as] = ACTIONS(197),
    [anon_sym_LPAREN2] = ACTIONS(199),
    [anon_sym_DOT_GT] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(66),
    [anon_sym_ifdef] = ACTIONS(74),
    [anon_sym_iftype] = ACTIONS(74),
    [anon_sym_for] = ACTIONS(74),
    [anon_sym_while] = ACTIONS(74),
    [anon_sym_try] = ACTIONS(74),
    [anon_sym_with] = ACTIONS(74),
    [anon_sym_repeat] = ACTIONS(74),
    [anon_sym_recover] = ACTIONS(74),
    [anon_sym_match] = ACTIONS(74),
    [anon_sym_return] = ACTIONS(74),
    [anon_sym_continue] = ACTIONS(74),
    [anon_sym_break] = ACTIONS(74),
    [anon_sym_consume] = ACTIONS(74),
    [anon_sym_object] = ACTIONS(74),
    [sym_number] = ACTIONS(66),
    [sym_float] = ACTIONS(74),
    [anon_sym_DQUOTE] = ACTIONS(66),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(74),
    [anon_sym_true] = ACTIONS(74),
    [anon_sym_false] = ACTIONS(74),
    [sym_this] = ACTIONS(74),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [421] = {
    [sym_arguments] = STATE(223),
    [ts_builtin_sym_end] = ACTIONS(1320),
    [sym_identifier] = ACTIONS(1318),
    [anon_sym_use] = ACTIONS(1320),
    [anon_sym_EQ] = ACTIONS(1318),
    [anon_sym_AT] = ACTIONS(1320),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_type] = ACTIONS(1320),
    [anon_sym_is] = ACTIONS(1318),
    [anon_sym_actor] = ACTIONS(1320),
    [anon_sym_class] = ACTIONS(1320),
    [anon_sym_primitive] = ACTIONS(1320),
    [anon_sym_interface] = ACTIONS(1320),
    [anon_sym_trait] = ACTIONS(1320),
    [anon_sym_struct] = ACTIONS(1320),
    [anon_sym_embed] = ACTIONS(1320),
    [anon_sym_let] = ACTIONS(1320),
    [anon_sym_var] = ACTIONS(1320),
    [anon_sym_new] = ACTIONS(1320),
    [anon_sym_fun] = ACTIONS(1320),
    [anon_sym_be] = ACTIONS(1320),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(1320),
    [anon_sym_SEMI] = ACTIONS(1320),
    [sym_error] = ACTIONS(1320),
    [sym_compile_intrinsic] = ACTIONS(1320),
    [anon_sym_compile_error] = ACTIONS(1320),
    [sym_location] = ACTIONS(1320),
    [anon_sym_DASH] = ACTIONS(1318),
    [anon_sym_not] = ACTIONS(1320),
    [anon_sym_DASH_TILDE] = ACTIONS(1320),
    [anon_sym_addressof] = ACTIONS(1320),
    [anon_sym_digestof] = ACTIONS(1320),
    [anon_sym_PLUS] = ACTIONS(1318),
    [anon_sym_STAR] = ACTIONS(1318),
    [anon_sym_SLASH] = ACTIONS(1318),
    [anon_sym_PERCENT] = ACTIONS(1318),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1318),
    [anon_sym_LT_LT] = ACTIONS(1318),
    [anon_sym_GT_GT] = ACTIONS(1318),
    [anon_sym_and] = ACTIONS(1320),
    [anon_sym_or] = ACTIONS(1320),
    [anon_sym_xor] = ACTIONS(1320),
    [anon_sym_isnt] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1318),
    [anon_sym_BANG_EQ] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(1318),
    [anon_sym_GT_EQ] = ACTIONS(1318),
    [anon_sym_LT_EQ] = ACTIONS(1318),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_PLUS_TILDE] = ACTIONS(1320),
    [anon_sym_STAR_TILDE] = ACTIONS(1320),
    [anon_sym_SLASH_TILDE] = ACTIONS(1320),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1320),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1320),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1320),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1320),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_GT_TILDE] = ACTIONS(1320),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_LT_TILDE] = ACTIONS(1320),
    [anon_sym_PLUS_QMARK] = ACTIONS(1320),
    [anon_sym_DASH_QMARK] = ACTIONS(1320),
    [anon_sym_STAR_QMARK] = ACTIONS(1320),
    [anon_sym_SLASH_QMARK] = ACTIONS(1320),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1320),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1320),
    [anon_sym_as] = ACTIONS(1320),
    [anon_sym_LPAREN2] = ACTIONS(199),
    [anon_sym_DOT_GT] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(1318),
    [anon_sym_ifdef] = ACTIONS(1320),
    [anon_sym_iftype] = ACTIONS(1320),
    [anon_sym_for] = ACTIONS(1320),
    [anon_sym_while] = ACTIONS(1320),
    [anon_sym_try] = ACTIONS(1320),
    [anon_sym_with] = ACTIONS(1320),
    [anon_sym_repeat] = ACTIONS(1320),
    [anon_sym_recover] = ACTIONS(1320),
    [anon_sym_match] = ACTIONS(1320),
    [anon_sym_return] = ACTIONS(1320),
    [anon_sym_continue] = ACTIONS(1320),
    [anon_sym_break] = ACTIONS(1320),
    [anon_sym_consume] = ACTIONS(1320),
    [anon_sym_object] = ACTIONS(1320),
    [sym_number] = ACTIONS(1318),
    [sym_float] = ACTIONS(1320),
    [anon_sym_DQUOTE] = ACTIONS(1318),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1320),
    [anon_sym_SQUOTE] = ACTIONS(1320),
    [anon_sym_true] = ACTIONS(1320),
    [anon_sym_false] = ACTIONS(1320),
    [sym_this] = ACTIONS(1320),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [422] = {
    [sym_arguments] = STATE(223),
    [ts_builtin_sym_end] = ACTIONS(1328),
    [sym_identifier] = ACTIONS(1326),
    [anon_sym_use] = ACTIONS(1328),
    [anon_sym_EQ] = ACTIONS(1326),
    [anon_sym_AT] = ACTIONS(1328),
    [anon_sym_LBRACK] = ACTIONS(1328),
    [anon_sym_type] = ACTIONS(1328),
    [anon_sym_is] = ACTIONS(1326),
    [anon_sym_actor] = ACTIONS(1328),
    [anon_sym_class] = ACTIONS(1328),
    [anon_sym_primitive] = ACTIONS(1328),
    [anon_sym_interface] = ACTIONS(1328),
    [anon_sym_trait] = ACTIONS(1328),
    [anon_sym_struct] = ACTIONS(1328),
    [anon_sym_embed] = ACTIONS(1328),
    [anon_sym_let] = ACTIONS(1328),
    [anon_sym_var] = ACTIONS(1328),
    [anon_sym_new] = ACTIONS(1328),
    [anon_sym_fun] = ACTIONS(1328),
    [anon_sym_be] = ACTIONS(1328),
    [anon_sym_LPAREN] = ACTIONS(1326),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(1328),
    [anon_sym_SEMI] = ACTIONS(1328),
    [sym_error] = ACTIONS(1328),
    [sym_compile_intrinsic] = ACTIONS(1328),
    [anon_sym_compile_error] = ACTIONS(1328),
    [sym_location] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_not] = ACTIONS(1328),
    [anon_sym_DASH_TILDE] = ACTIONS(1328),
    [anon_sym_addressof] = ACTIONS(1328),
    [anon_sym_digestof] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1326),
    [anon_sym_STAR] = ACTIONS(1326),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym_PERCENT] = ACTIONS(1326),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1326),
    [anon_sym_GT_GT] = ACTIONS(1326),
    [anon_sym_and] = ACTIONS(1328),
    [anon_sym_or] = ACTIONS(1328),
    [anon_sym_xor] = ACTIONS(1328),
    [anon_sym_isnt] = ACTIONS(1328),
    [anon_sym_EQ_EQ] = ACTIONS(1326),
    [anon_sym_BANG_EQ] = ACTIONS(1326),
    [anon_sym_GT] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_LT] = ACTIONS(1326),
    [anon_sym_PLUS_TILDE] = ACTIONS(1328),
    [anon_sym_STAR_TILDE] = ACTIONS(1328),
    [anon_sym_SLASH_TILDE] = ACTIONS(1328),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1328),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1328),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1328),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1328),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1328),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1328),
    [anon_sym_GT_TILDE] = ACTIONS(1328),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1328),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1328),
    [anon_sym_LT_TILDE] = ACTIONS(1328),
    [anon_sym_PLUS_QMARK] = ACTIONS(1328),
    [anon_sym_DASH_QMARK] = ACTIONS(1328),
    [anon_sym_STAR_QMARK] = ACTIONS(1328),
    [anon_sym_SLASH_QMARK] = ACTIONS(1328),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1328),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1328),
    [anon_sym_as] = ACTIONS(1328),
    [anon_sym_LPAREN2] = ACTIONS(199),
    [anon_sym_DOT_GT] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(1326),
    [anon_sym_ifdef] = ACTIONS(1328),
    [anon_sym_iftype] = ACTIONS(1328),
    [anon_sym_for] = ACTIONS(1328),
    [anon_sym_while] = ACTIONS(1328),
    [anon_sym_try] = ACTIONS(1328),
    [anon_sym_with] = ACTIONS(1328),
    [anon_sym_repeat] = ACTIONS(1328),
    [anon_sym_recover] = ACTIONS(1328),
    [anon_sym_match] = ACTIONS(1328),
    [anon_sym_return] = ACTIONS(1328),
    [anon_sym_continue] = ACTIONS(1328),
    [anon_sym_break] = ACTIONS(1328),
    [anon_sym_consume] = ACTIONS(1328),
    [anon_sym_object] = ACTIONS(1328),
    [sym_number] = ACTIONS(1326),
    [sym_float] = ACTIONS(1328),
    [anon_sym_DQUOTE] = ACTIONS(1326),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1328),
    [anon_sym_SQUOTE] = ACTIONS(1328),
    [anon_sym_true] = ACTIONS(1328),
    [anon_sym_false] = ACTIONS(1328),
    [sym_this] = ACTIONS(1328),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [423] = {
    [sym_arguments] = STATE(223),
    [ts_builtin_sym_end] = ACTIONS(1320),
    [sym_identifier] = ACTIONS(1318),
    [anon_sym_use] = ACTIONS(1320),
    [anon_sym_EQ] = ACTIONS(1318),
    [anon_sym_AT] = ACTIONS(1320),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_type] = ACTIONS(1320),
    [anon_sym_is] = ACTIONS(1318),
    [anon_sym_actor] = ACTIONS(1320),
    [anon_sym_class] = ACTIONS(1320),
    [anon_sym_primitive] = ACTIONS(1320),
    [anon_sym_interface] = ACTIONS(1320),
    [anon_sym_trait] = ACTIONS(1320),
    [anon_sym_struct] = ACTIONS(1320),
    [anon_sym_embed] = ACTIONS(1320),
    [anon_sym_let] = ACTIONS(1320),
    [anon_sym_var] = ACTIONS(1320),
    [anon_sym_new] = ACTIONS(1320),
    [anon_sym_fun] = ACTIONS(1320),
    [anon_sym_be] = ACTIONS(1320),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(1320),
    [anon_sym_SEMI] = ACTIONS(1320),
    [sym_error] = ACTIONS(1320),
    [sym_compile_intrinsic] = ACTIONS(1320),
    [anon_sym_compile_error] = ACTIONS(1320),
    [sym_location] = ACTIONS(1320),
    [anon_sym_DASH] = ACTIONS(1318),
    [anon_sym_not] = ACTIONS(1320),
    [anon_sym_DASH_TILDE] = ACTIONS(1320),
    [anon_sym_addressof] = ACTIONS(1320),
    [anon_sym_digestof] = ACTIONS(1320),
    [anon_sym_PLUS] = ACTIONS(1318),
    [anon_sym_STAR] = ACTIONS(1318),
    [anon_sym_SLASH] = ACTIONS(1318),
    [anon_sym_PERCENT] = ACTIONS(1318),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1318),
    [anon_sym_LT_LT] = ACTIONS(1318),
    [anon_sym_GT_GT] = ACTIONS(1318),
    [anon_sym_and] = ACTIONS(1320),
    [anon_sym_or] = ACTIONS(1320),
    [anon_sym_xor] = ACTIONS(1320),
    [anon_sym_isnt] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1318),
    [anon_sym_BANG_EQ] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(1318),
    [anon_sym_GT_EQ] = ACTIONS(1318),
    [anon_sym_LT_EQ] = ACTIONS(1318),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_PLUS_TILDE] = ACTIONS(1320),
    [anon_sym_STAR_TILDE] = ACTIONS(1320),
    [anon_sym_SLASH_TILDE] = ACTIONS(1320),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1320),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1320),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1320),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1320),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_GT_TILDE] = ACTIONS(1320),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_LT_TILDE] = ACTIONS(1320),
    [anon_sym_PLUS_QMARK] = ACTIONS(1320),
    [anon_sym_DASH_QMARK] = ACTIONS(1320),
    [anon_sym_STAR_QMARK] = ACTIONS(1320),
    [anon_sym_SLASH_QMARK] = ACTIONS(1320),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1320),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1320),
    [anon_sym_as] = ACTIONS(1320),
    [anon_sym_LPAREN2] = ACTIONS(199),
    [anon_sym_DOT_GT] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(1318),
    [anon_sym_ifdef] = ACTIONS(1320),
    [anon_sym_iftype] = ACTIONS(1320),
    [anon_sym_for] = ACTIONS(1320),
    [anon_sym_while] = ACTIONS(1320),
    [anon_sym_try] = ACTIONS(1320),
    [anon_sym_with] = ACTIONS(1320),
    [anon_sym_repeat] = ACTIONS(1320),
    [anon_sym_recover] = ACTIONS(1320),
    [anon_sym_match] = ACTIONS(1320),
    [anon_sym_return] = ACTIONS(1320),
    [anon_sym_continue] = ACTIONS(1320),
    [anon_sym_break] = ACTIONS(1320),
    [anon_sym_consume] = ACTIONS(1320),
    [anon_sym_object] = ACTIONS(1320),
    [sym_number] = ACTIONS(1318),
    [sym_float] = ACTIONS(1320),
    [anon_sym_DQUOTE] = ACTIONS(1318),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1320),
    [anon_sym_SQUOTE] = ACTIONS(1320),
    [anon_sym_true] = ACTIONS(1320),
    [anon_sym_false] = ACTIONS(1320),
    [sym_this] = ACTIONS(1320),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [424] = {
    [ts_builtin_sym_end] = ACTIONS(1040),
    [sym_identifier] = ACTIONS(1042),
    [anon_sym_use] = ACTIONS(1040),
    [anon_sym_EQ] = ACTIONS(1042),
    [anon_sym_AT] = ACTIONS(1040),
    [anon_sym_LBRACK] = ACTIONS(1040),
    [anon_sym_type] = ACTIONS(1040),
    [anon_sym_is] = ACTIONS(1042),
    [anon_sym_actor] = ACTIONS(1040),
    [anon_sym_class] = ACTIONS(1040),
    [anon_sym_primitive] = ACTIONS(1040),
    [anon_sym_interface] = ACTIONS(1040),
    [anon_sym_trait] = ACTIONS(1040),
    [anon_sym_struct] = ACTIONS(1040),
    [anon_sym_embed] = ACTIONS(1040),
    [anon_sym_let] = ACTIONS(1040),
    [anon_sym_var] = ACTIONS(1040),
    [anon_sym_new] = ACTIONS(1040),
    [anon_sym_fun] = ACTIONS(1040),
    [anon_sym_be] = ACTIONS(1040),
    [anon_sym_LPAREN] = ACTIONS(1042),
    [anon_sym_DOT] = ACTIONS(1042),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_SEMI] = ACTIONS(1040),
    [sym_error] = ACTIONS(1040),
    [sym_compile_intrinsic] = ACTIONS(1040),
    [anon_sym_compile_error] = ACTIONS(1040),
    [sym_location] = ACTIONS(1040),
    [anon_sym_DASH] = ACTIONS(1042),
    [anon_sym_not] = ACTIONS(1040),
    [anon_sym_DASH_TILDE] = ACTIONS(1040),
    [anon_sym_addressof] = ACTIONS(1040),
    [anon_sym_digestof] = ACTIONS(1040),
    [anon_sym_PLUS] = ACTIONS(1042),
    [anon_sym_STAR] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(1042),
    [anon_sym_PERCENT] = ACTIONS(1042),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1042),
    [anon_sym_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_GT] = ACTIONS(1042),
    [anon_sym_and] = ACTIONS(1040),
    [anon_sym_or] = ACTIONS(1040),
    [anon_sym_xor] = ACTIONS(1040),
    [anon_sym_isnt] = ACTIONS(1040),
    [anon_sym_EQ_EQ] = ACTIONS(1042),
    [anon_sym_BANG_EQ] = ACTIONS(1042),
    [anon_sym_GT] = ACTIONS(1042),
    [anon_sym_GT_EQ] = ACTIONS(1042),
    [anon_sym_LT_EQ] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_PLUS_TILDE] = ACTIONS(1040),
    [anon_sym_STAR_TILDE] = ACTIONS(1040),
    [anon_sym_SLASH_TILDE] = ACTIONS(1040),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1040),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1040),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1040),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1040),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1040),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1040),
    [anon_sym_GT_TILDE] = ACTIONS(1040),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1040),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1040),
    [anon_sym_LT_TILDE] = ACTIONS(1040),
    [anon_sym_PLUS_QMARK] = ACTIONS(1040),
    [anon_sym_DASH_QMARK] = ACTIONS(1040),
    [anon_sym_STAR_QMARK] = ACTIONS(1040),
    [anon_sym_SLASH_QMARK] = ACTIONS(1040),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1040),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1040),
    [anon_sym_as] = ACTIONS(1040),
    [anon_sym_LPAREN2] = ACTIONS(1040),
    [anon_sym_DOT_GT] = ACTIONS(1040),
    [anon_sym_TILDE] = ACTIONS(1040),
    [anon_sym_if] = ACTIONS(1042),
    [anon_sym_ifdef] = ACTIONS(1040),
    [anon_sym_iftype] = ACTIONS(1040),
    [anon_sym_for] = ACTIONS(1040),
    [anon_sym_while] = ACTIONS(1040),
    [anon_sym_try] = ACTIONS(1040),
    [anon_sym_with] = ACTIONS(1040),
    [anon_sym_repeat] = ACTIONS(1040),
    [anon_sym_recover] = ACTIONS(1040),
    [anon_sym_match] = ACTIONS(1040),
    [anon_sym_return] = ACTIONS(1040),
    [anon_sym_continue] = ACTIONS(1040),
    [anon_sym_break] = ACTIONS(1040),
    [anon_sym_consume] = ACTIONS(1040),
    [anon_sym_object] = ACTIONS(1040),
    [sym_number] = ACTIONS(1042),
    [sym_float] = ACTIONS(1040),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym_true] = ACTIONS(1040),
    [anon_sym_false] = ACTIONS(1040),
    [sym_this] = ACTIONS(1040),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [425] = {
    [ts_builtin_sym_end] = ACTIONS(1024),
    [sym_identifier] = ACTIONS(1026),
    [anon_sym_use] = ACTIONS(1024),
    [anon_sym_EQ] = ACTIONS(1026),
    [anon_sym_AT] = ACTIONS(1024),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_type] = ACTIONS(1024),
    [anon_sym_is] = ACTIONS(1026),
    [anon_sym_actor] = ACTIONS(1024),
    [anon_sym_class] = ACTIONS(1024),
    [anon_sym_primitive] = ACTIONS(1024),
    [anon_sym_interface] = ACTIONS(1024),
    [anon_sym_trait] = ACTIONS(1024),
    [anon_sym_struct] = ACTIONS(1024),
    [anon_sym_embed] = ACTIONS(1024),
    [anon_sym_let] = ACTIONS(1024),
    [anon_sym_var] = ACTIONS(1024),
    [anon_sym_new] = ACTIONS(1024),
    [anon_sym_fun] = ACTIONS(1024),
    [anon_sym_be] = ACTIONS(1024),
    [anon_sym_LPAREN] = ACTIONS(1026),
    [anon_sym_DOT] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1024),
    [anon_sym_SEMI] = ACTIONS(1024),
    [sym_error] = ACTIONS(1024),
    [sym_compile_intrinsic] = ACTIONS(1024),
    [anon_sym_compile_error] = ACTIONS(1024),
    [sym_location] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1026),
    [anon_sym_not] = ACTIONS(1024),
    [anon_sym_DASH_TILDE] = ACTIONS(1024),
    [anon_sym_addressof] = ACTIONS(1024),
    [anon_sym_digestof] = ACTIONS(1024),
    [anon_sym_PLUS] = ACTIONS(1026),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_SLASH] = ACTIONS(1026),
    [anon_sym_PERCENT] = ACTIONS(1026),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1026),
    [anon_sym_LT_LT] = ACTIONS(1026),
    [anon_sym_GT_GT] = ACTIONS(1026),
    [anon_sym_and] = ACTIONS(1024),
    [anon_sym_or] = ACTIONS(1024),
    [anon_sym_xor] = ACTIONS(1024),
    [anon_sym_isnt] = ACTIONS(1024),
    [anon_sym_EQ_EQ] = ACTIONS(1026),
    [anon_sym_BANG_EQ] = ACTIONS(1026),
    [anon_sym_GT] = ACTIONS(1026),
    [anon_sym_GT_EQ] = ACTIONS(1026),
    [anon_sym_LT_EQ] = ACTIONS(1026),
    [anon_sym_LT] = ACTIONS(1026),
    [anon_sym_PLUS_TILDE] = ACTIONS(1024),
    [anon_sym_STAR_TILDE] = ACTIONS(1024),
    [anon_sym_SLASH_TILDE] = ACTIONS(1024),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1024),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1024),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1024),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1024),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1024),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1024),
    [anon_sym_GT_TILDE] = ACTIONS(1024),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1024),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1024),
    [anon_sym_LT_TILDE] = ACTIONS(1024),
    [anon_sym_PLUS_QMARK] = ACTIONS(1024),
    [anon_sym_DASH_QMARK] = ACTIONS(1024),
    [anon_sym_STAR_QMARK] = ACTIONS(1024),
    [anon_sym_SLASH_QMARK] = ACTIONS(1024),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1024),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1024),
    [anon_sym_as] = ACTIONS(1024),
    [anon_sym_LPAREN2] = ACTIONS(1024),
    [anon_sym_DOT_GT] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1024),
    [anon_sym_if] = ACTIONS(1026),
    [anon_sym_ifdef] = ACTIONS(1024),
    [anon_sym_iftype] = ACTIONS(1024),
    [anon_sym_for] = ACTIONS(1024),
    [anon_sym_while] = ACTIONS(1024),
    [anon_sym_try] = ACTIONS(1024),
    [anon_sym_with] = ACTIONS(1024),
    [anon_sym_repeat] = ACTIONS(1024),
    [anon_sym_recover] = ACTIONS(1024),
    [anon_sym_match] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1024),
    [anon_sym_continue] = ACTIONS(1024),
    [anon_sym_break] = ACTIONS(1024),
    [anon_sym_consume] = ACTIONS(1024),
    [anon_sym_object] = ACTIONS(1024),
    [sym_number] = ACTIONS(1026),
    [sym_float] = ACTIONS(1024),
    [anon_sym_DQUOTE] = ACTIONS(1026),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1024),
    [anon_sym_SQUOTE] = ACTIONS(1024),
    [anon_sym_true] = ACTIONS(1024),
    [anon_sym_false] = ACTIONS(1024),
    [sym_this] = ACTIONS(1024),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [426] = {
    [ts_builtin_sym_end] = ACTIONS(1020),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_use] = ACTIONS(1020),
    [anon_sym_EQ] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_type] = ACTIONS(1020),
    [anon_sym_is] = ACTIONS(1022),
    [anon_sym_actor] = ACTIONS(1020),
    [anon_sym_class] = ACTIONS(1020),
    [anon_sym_primitive] = ACTIONS(1020),
    [anon_sym_interface] = ACTIONS(1020),
    [anon_sym_trait] = ACTIONS(1020),
    [anon_sym_struct] = ACTIONS(1020),
    [anon_sym_embed] = ACTIONS(1020),
    [anon_sym_let] = ACTIONS(1020),
    [anon_sym_var] = ACTIONS(1020),
    [anon_sym_new] = ACTIONS(1020),
    [anon_sym_fun] = ACTIONS(1020),
    [anon_sym_be] = ACTIONS(1020),
    [anon_sym_LPAREN] = ACTIONS(1022),
    [anon_sym_DOT] = ACTIONS(1022),
    [anon_sym_LBRACE] = ACTIONS(1020),
    [anon_sym_SEMI] = ACTIONS(1020),
    [sym_error] = ACTIONS(1020),
    [sym_compile_intrinsic] = ACTIONS(1020),
    [anon_sym_compile_error] = ACTIONS(1020),
    [sym_location] = ACTIONS(1020),
    [anon_sym_DASH] = ACTIONS(1022),
    [anon_sym_not] = ACTIONS(1020),
    [anon_sym_DASH_TILDE] = ACTIONS(1020),
    [anon_sym_addressof] = ACTIONS(1020),
    [anon_sym_digestof] = ACTIONS(1020),
    [anon_sym_PLUS] = ACTIONS(1022),
    [anon_sym_STAR] = ACTIONS(1022),
    [anon_sym_SLASH] = ACTIONS(1022),
    [anon_sym_PERCENT] = ACTIONS(1022),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1022),
    [anon_sym_LT_LT] = ACTIONS(1022),
    [anon_sym_GT_GT] = ACTIONS(1022),
    [anon_sym_and] = ACTIONS(1020),
    [anon_sym_or] = ACTIONS(1020),
    [anon_sym_xor] = ACTIONS(1020),
    [anon_sym_isnt] = ACTIONS(1020),
    [anon_sym_EQ_EQ] = ACTIONS(1022),
    [anon_sym_BANG_EQ] = ACTIONS(1022),
    [anon_sym_GT] = ACTIONS(1022),
    [anon_sym_GT_EQ] = ACTIONS(1022),
    [anon_sym_LT_EQ] = ACTIONS(1022),
    [anon_sym_LT] = ACTIONS(1022),
    [anon_sym_PLUS_TILDE] = ACTIONS(1020),
    [anon_sym_STAR_TILDE] = ACTIONS(1020),
    [anon_sym_SLASH_TILDE] = ACTIONS(1020),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1020),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1020),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1020),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1020),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1020),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1020),
    [anon_sym_GT_TILDE] = ACTIONS(1020),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1020),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1020),
    [anon_sym_LT_TILDE] = ACTIONS(1020),
    [anon_sym_PLUS_QMARK] = ACTIONS(1020),
    [anon_sym_DASH_QMARK] = ACTIONS(1020),
    [anon_sym_STAR_QMARK] = ACTIONS(1020),
    [anon_sym_SLASH_QMARK] = ACTIONS(1020),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1020),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1020),
    [anon_sym_as] = ACTIONS(1020),
    [anon_sym_LPAREN2] = ACTIONS(1020),
    [anon_sym_DOT_GT] = ACTIONS(1020),
    [anon_sym_TILDE] = ACTIONS(1020),
    [anon_sym_if] = ACTIONS(1022),
    [anon_sym_ifdef] = ACTIONS(1020),
    [anon_sym_iftype] = ACTIONS(1020),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_while] = ACTIONS(1020),
    [anon_sym_try] = ACTIONS(1020),
    [anon_sym_with] = ACTIONS(1020),
    [anon_sym_repeat] = ACTIONS(1020),
    [anon_sym_recover] = ACTIONS(1020),
    [anon_sym_match] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(1020),
    [anon_sym_continue] = ACTIONS(1020),
    [anon_sym_break] = ACTIONS(1020),
    [anon_sym_consume] = ACTIONS(1020),
    [anon_sym_object] = ACTIONS(1020),
    [sym_number] = ACTIONS(1022),
    [sym_float] = ACTIONS(1020),
    [anon_sym_DQUOTE] = ACTIONS(1022),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1020),
    [anon_sym_SQUOTE] = ACTIONS(1020),
    [anon_sym_true] = ACTIONS(1020),
    [anon_sym_false] = ACTIONS(1020),
    [sym_this] = ACTIONS(1020),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [427] = {
    [ts_builtin_sym_end] = ACTIONS(1016),
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_use] = ACTIONS(1016),
    [anon_sym_EQ] = ACTIONS(1018),
    [anon_sym_AT] = ACTIONS(1016),
    [anon_sym_LBRACK] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1016),
    [anon_sym_is] = ACTIONS(1018),
    [anon_sym_actor] = ACTIONS(1016),
    [anon_sym_class] = ACTIONS(1016),
    [anon_sym_primitive] = ACTIONS(1016),
    [anon_sym_interface] = ACTIONS(1016),
    [anon_sym_trait] = ACTIONS(1016),
    [anon_sym_struct] = ACTIONS(1016),
    [anon_sym_embed] = ACTIONS(1016),
    [anon_sym_let] = ACTIONS(1016),
    [anon_sym_var] = ACTIONS(1016),
    [anon_sym_new] = ACTIONS(1016),
    [anon_sym_fun] = ACTIONS(1016),
    [anon_sym_be] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_DOT] = ACTIONS(1018),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_SEMI] = ACTIONS(1016),
    [sym_error] = ACTIONS(1016),
    [sym_compile_intrinsic] = ACTIONS(1016),
    [anon_sym_compile_error] = ACTIONS(1016),
    [sym_location] = ACTIONS(1016),
    [anon_sym_DASH] = ACTIONS(1018),
    [anon_sym_not] = ACTIONS(1016),
    [anon_sym_DASH_TILDE] = ACTIONS(1016),
    [anon_sym_addressof] = ACTIONS(1016),
    [anon_sym_digestof] = ACTIONS(1016),
    [anon_sym_PLUS] = ACTIONS(1018),
    [anon_sym_STAR] = ACTIONS(1018),
    [anon_sym_SLASH] = ACTIONS(1018),
    [anon_sym_PERCENT] = ACTIONS(1018),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1018),
    [anon_sym_LT_LT] = ACTIONS(1018),
    [anon_sym_GT_GT] = ACTIONS(1018),
    [anon_sym_and] = ACTIONS(1016),
    [anon_sym_or] = ACTIONS(1016),
    [anon_sym_xor] = ACTIONS(1016),
    [anon_sym_isnt] = ACTIONS(1016),
    [anon_sym_EQ_EQ] = ACTIONS(1018),
    [anon_sym_BANG_EQ] = ACTIONS(1018),
    [anon_sym_GT] = ACTIONS(1018),
    [anon_sym_GT_EQ] = ACTIONS(1018),
    [anon_sym_LT_EQ] = ACTIONS(1018),
    [anon_sym_LT] = ACTIONS(1018),
    [anon_sym_PLUS_TILDE] = ACTIONS(1016),
    [anon_sym_STAR_TILDE] = ACTIONS(1016),
    [anon_sym_SLASH_TILDE] = ACTIONS(1016),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1016),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1016),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1016),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1016),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1016),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1016),
    [anon_sym_GT_TILDE] = ACTIONS(1016),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1016),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1016),
    [anon_sym_LT_TILDE] = ACTIONS(1016),
    [anon_sym_PLUS_QMARK] = ACTIONS(1016),
    [anon_sym_DASH_QMARK] = ACTIONS(1016),
    [anon_sym_STAR_QMARK] = ACTIONS(1016),
    [anon_sym_SLASH_QMARK] = ACTIONS(1016),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1016),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1016),
    [anon_sym_as] = ACTIONS(1016),
    [anon_sym_LPAREN2] = ACTIONS(1016),
    [anon_sym_DOT_GT] = ACTIONS(1016),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_if] = ACTIONS(1018),
    [anon_sym_ifdef] = ACTIONS(1016),
    [anon_sym_iftype] = ACTIONS(1016),
    [anon_sym_for] = ACTIONS(1016),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_try] = ACTIONS(1016),
    [anon_sym_with] = ACTIONS(1016),
    [anon_sym_repeat] = ACTIONS(1016),
    [anon_sym_recover] = ACTIONS(1016),
    [anon_sym_match] = ACTIONS(1016),
    [anon_sym_return] = ACTIONS(1016),
    [anon_sym_continue] = ACTIONS(1016),
    [anon_sym_break] = ACTIONS(1016),
    [anon_sym_consume] = ACTIONS(1016),
    [anon_sym_object] = ACTIONS(1016),
    [sym_number] = ACTIONS(1018),
    [sym_float] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(1018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1016),
    [anon_sym_SQUOTE] = ACTIONS(1016),
    [anon_sym_true] = ACTIONS(1016),
    [anon_sym_false] = ACTIONS(1016),
    [sym_this] = ACTIONS(1016),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [428] = {
    [ts_builtin_sym_end] = ACTIONS(1028),
    [sym_identifier] = ACTIONS(1030),
    [anon_sym_use] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(1030),
    [anon_sym_AT] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(1028),
    [anon_sym_type] = ACTIONS(1028),
    [anon_sym_is] = ACTIONS(1030),
    [anon_sym_actor] = ACTIONS(1028),
    [anon_sym_class] = ACTIONS(1028),
    [anon_sym_primitive] = ACTIONS(1028),
    [anon_sym_interface] = ACTIONS(1028),
    [anon_sym_trait] = ACTIONS(1028),
    [anon_sym_struct] = ACTIONS(1028),
    [anon_sym_embed] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(1028),
    [anon_sym_var] = ACTIONS(1028),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_fun] = ACTIONS(1028),
    [anon_sym_be] = ACTIONS(1028),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_DOT] = ACTIONS(1030),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_SEMI] = ACTIONS(1028),
    [sym_error] = ACTIONS(1028),
    [sym_compile_intrinsic] = ACTIONS(1028),
    [anon_sym_compile_error] = ACTIONS(1028),
    [sym_location] = ACTIONS(1028),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_not] = ACTIONS(1028),
    [anon_sym_DASH_TILDE] = ACTIONS(1028),
    [anon_sym_addressof] = ACTIONS(1028),
    [anon_sym_digestof] = ACTIONS(1028),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_STAR] = ACTIONS(1030),
    [anon_sym_SLASH] = ACTIONS(1030),
    [anon_sym_PERCENT] = ACTIONS(1030),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1030),
    [anon_sym_LT_LT] = ACTIONS(1030),
    [anon_sym_GT_GT] = ACTIONS(1030),
    [anon_sym_and] = ACTIONS(1028),
    [anon_sym_or] = ACTIONS(1028),
    [anon_sym_xor] = ACTIONS(1028),
    [anon_sym_isnt] = ACTIONS(1028),
    [anon_sym_EQ_EQ] = ACTIONS(1030),
    [anon_sym_BANG_EQ] = ACTIONS(1030),
    [anon_sym_GT] = ACTIONS(1030),
    [anon_sym_GT_EQ] = ACTIONS(1030),
    [anon_sym_LT_EQ] = ACTIONS(1030),
    [anon_sym_LT] = ACTIONS(1030),
    [anon_sym_PLUS_TILDE] = ACTIONS(1028),
    [anon_sym_STAR_TILDE] = ACTIONS(1028),
    [anon_sym_SLASH_TILDE] = ACTIONS(1028),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1028),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1028),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1028),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1028),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1028),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1028),
    [anon_sym_GT_TILDE] = ACTIONS(1028),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1028),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1028),
    [anon_sym_LT_TILDE] = ACTIONS(1028),
    [anon_sym_PLUS_QMARK] = ACTIONS(1028),
    [anon_sym_DASH_QMARK] = ACTIONS(1028),
    [anon_sym_STAR_QMARK] = ACTIONS(1028),
    [anon_sym_SLASH_QMARK] = ACTIONS(1028),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1028),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1028),
    [anon_sym_as] = ACTIONS(1028),
    [anon_sym_LPAREN2] = ACTIONS(1028),
    [anon_sym_DOT_GT] = ACTIONS(1028),
    [anon_sym_TILDE] = ACTIONS(1028),
    [anon_sym_if] = ACTIONS(1030),
    [anon_sym_ifdef] = ACTIONS(1028),
    [anon_sym_iftype] = ACTIONS(1028),
    [anon_sym_for] = ACTIONS(1028),
    [anon_sym_while] = ACTIONS(1028),
    [anon_sym_try] = ACTIONS(1028),
    [anon_sym_with] = ACTIONS(1028),
    [anon_sym_repeat] = ACTIONS(1028),
    [anon_sym_recover] = ACTIONS(1028),
    [anon_sym_match] = ACTIONS(1028),
    [anon_sym_return] = ACTIONS(1028),
    [anon_sym_continue] = ACTIONS(1028),
    [anon_sym_break] = ACTIONS(1028),
    [anon_sym_consume] = ACTIONS(1028),
    [anon_sym_object] = ACTIONS(1028),
    [sym_number] = ACTIONS(1030),
    [sym_float] = ACTIONS(1028),
    [anon_sym_DQUOTE] = ACTIONS(1030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1028),
    [anon_sym_SQUOTE] = ACTIONS(1028),
    [anon_sym_true] = ACTIONS(1028),
    [anon_sym_false] = ACTIONS(1028),
    [sym_this] = ACTIONS(1028),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [429] = {
    [sym_capability] = STATE(511),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_EQ] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_is] = ACTIONS(875),
    [anon_sym_let] = ACTIONS(873),
    [anon_sym_var] = ACTIONS(873),
    [anon_sym_iso] = ACTIONS(1330),
    [anon_sym_trn] = ACTIONS(1330),
    [anon_sym_ref] = ACTIONS(1330),
    [anon_sym_val] = ACTIONS(1330),
    [anon_sym_box] = ACTIONS(1330),
    [anon_sym_tag] = ACTIONS(1330),
    [anon_sym_LPAREN] = ACTIONS(875),
    [anon_sym_DOT] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(873),
    [anon_sym_SEMI] = ACTIONS(873),
    [sym_error] = ACTIONS(873),
    [sym_compile_intrinsic] = ACTIONS(873),
    [anon_sym_compile_error] = ACTIONS(873),
    [sym_location] = ACTIONS(873),
    [anon_sym_DASH] = ACTIONS(875),
    [anon_sym_not] = ACTIONS(873),
    [anon_sym_DASH_TILDE] = ACTIONS(873),
    [anon_sym_addressof] = ACTIONS(873),
    [anon_sym_digestof] = ACTIONS(873),
    [anon_sym_PLUS] = ACTIONS(875),
    [anon_sym_STAR] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(875),
    [anon_sym_PERCENT] = ACTIONS(875),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(875),
    [anon_sym_LT_LT] = ACTIONS(875),
    [anon_sym_GT_GT] = ACTIONS(875),
    [anon_sym_and] = ACTIONS(873),
    [anon_sym_or] = ACTIONS(873),
    [anon_sym_xor] = ACTIONS(873),
    [anon_sym_isnt] = ACTIONS(873),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_BANG_EQ] = ACTIONS(875),
    [anon_sym_GT] = ACTIONS(875),
    [anon_sym_GT_EQ] = ACTIONS(875),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(875),
    [anon_sym_PLUS_TILDE] = ACTIONS(873),
    [anon_sym_STAR_TILDE] = ACTIONS(873),
    [anon_sym_SLASH_TILDE] = ACTIONS(873),
    [anon_sym_PERCENT_TILDE] = ACTIONS(873),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(873),
    [anon_sym_LT_LT_TILDE] = ACTIONS(873),
    [anon_sym_GT_GT_TILDE] = ACTIONS(873),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(873),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(873),
    [anon_sym_GT_TILDE] = ACTIONS(873),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(873),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(873),
    [anon_sym_LT_TILDE] = ACTIONS(873),
    [anon_sym_PLUS_QMARK] = ACTIONS(873),
    [anon_sym_DASH_QMARK] = ACTIONS(873),
    [anon_sym_STAR_QMARK] = ACTIONS(873),
    [anon_sym_SLASH_QMARK] = ACTIONS(873),
    [anon_sym_PERCENT_QMARK] = ACTIONS(873),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(873),
    [anon_sym_as] = ACTIONS(873),
    [anon_sym_LPAREN2] = ACTIONS(873),
    [anon_sym_DOT_GT] = ACTIONS(873),
    [anon_sym_TILDE] = ACTIONS(873),
    [anon_sym_end] = ACTIONS(873),
    [anon_sym_if] = ACTIONS(875),
    [anon_sym_ifdef] = ACTIONS(873),
    [anon_sym_elseif] = ACTIONS(873),
    [anon_sym_iftype] = ACTIONS(873),
    [anon_sym_else] = ACTIONS(875),
    [anon_sym_for] = ACTIONS(873),
    [anon_sym_while] = ACTIONS(873),
    [anon_sym_try] = ACTIONS(873),
    [anon_sym_with] = ACTIONS(873),
    [anon_sym_repeat] = ACTIONS(873),
    [anon_sym_recover] = ACTIONS(873),
    [anon_sym_match] = ACTIONS(873),
    [anon_sym_return] = ACTIONS(873),
    [anon_sym_continue] = ACTIONS(873),
    [anon_sym_break] = ACTIONS(873),
    [anon_sym_consume] = ACTIONS(873),
    [anon_sym_object] = ACTIONS(873),
    [sym_number] = ACTIONS(875),
    [sym_float] = ACTIONS(873),
    [anon_sym_DQUOTE] = ACTIONS(875),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(873),
    [anon_sym_SQUOTE] = ACTIONS(873),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [sym_this] = ACTIONS(873),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [430] = {
    [sym_capability] = STATE(520),
    [sym_identifier] = ACTIONS(863),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(861),
    [anon_sym_is] = ACTIONS(863),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_var] = ACTIONS(861),
    [anon_sym_iso] = ACTIONS(1330),
    [anon_sym_trn] = ACTIONS(1330),
    [anon_sym_ref] = ACTIONS(1330),
    [anon_sym_val] = ACTIONS(1330),
    [anon_sym_box] = ACTIONS(1330),
    [anon_sym_tag] = ACTIONS(1330),
    [anon_sym_LPAREN] = ACTIONS(863),
    [anon_sym_DOT] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(861),
    [sym_error] = ACTIONS(861),
    [sym_compile_intrinsic] = ACTIONS(861),
    [anon_sym_compile_error] = ACTIONS(861),
    [sym_location] = ACTIONS(861),
    [anon_sym_DASH] = ACTIONS(863),
    [anon_sym_not] = ACTIONS(861),
    [anon_sym_DASH_TILDE] = ACTIONS(861),
    [anon_sym_addressof] = ACTIONS(861),
    [anon_sym_digestof] = ACTIONS(861),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_STAR] = ACTIONS(863),
    [anon_sym_SLASH] = ACTIONS(863),
    [anon_sym_PERCENT] = ACTIONS(863),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(863),
    [anon_sym_LT_LT] = ACTIONS(863),
    [anon_sym_GT_GT] = ACTIONS(863),
    [anon_sym_and] = ACTIONS(861),
    [anon_sym_or] = ACTIONS(861),
    [anon_sym_xor] = ACTIONS(861),
    [anon_sym_isnt] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(863),
    [anon_sym_BANG_EQ] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(863),
    [anon_sym_GT_EQ] = ACTIONS(863),
    [anon_sym_LT_EQ] = ACTIONS(863),
    [anon_sym_LT] = ACTIONS(863),
    [anon_sym_PLUS_TILDE] = ACTIONS(861),
    [anon_sym_STAR_TILDE] = ACTIONS(861),
    [anon_sym_SLASH_TILDE] = ACTIONS(861),
    [anon_sym_PERCENT_TILDE] = ACTIONS(861),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(861),
    [anon_sym_LT_LT_TILDE] = ACTIONS(861),
    [anon_sym_GT_GT_TILDE] = ACTIONS(861),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(861),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(861),
    [anon_sym_GT_TILDE] = ACTIONS(861),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(861),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(861),
    [anon_sym_LT_TILDE] = ACTIONS(861),
    [anon_sym_PLUS_QMARK] = ACTIONS(861),
    [anon_sym_DASH_QMARK] = ACTIONS(861),
    [anon_sym_STAR_QMARK] = ACTIONS(861),
    [anon_sym_SLASH_QMARK] = ACTIONS(861),
    [anon_sym_PERCENT_QMARK] = ACTIONS(861),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(861),
    [anon_sym_as] = ACTIONS(861),
    [anon_sym_LPAREN2] = ACTIONS(861),
    [anon_sym_DOT_GT] = ACTIONS(861),
    [anon_sym_TILDE] = ACTIONS(861),
    [anon_sym_end] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(863),
    [anon_sym_ifdef] = ACTIONS(861),
    [anon_sym_elseif] = ACTIONS(861),
    [anon_sym_iftype] = ACTIONS(861),
    [anon_sym_else] = ACTIONS(863),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_while] = ACTIONS(861),
    [anon_sym_try] = ACTIONS(861),
    [anon_sym_with] = ACTIONS(861),
    [anon_sym_repeat] = ACTIONS(861),
    [anon_sym_recover] = ACTIONS(861),
    [anon_sym_match] = ACTIONS(861),
    [anon_sym_return] = ACTIONS(861),
    [anon_sym_continue] = ACTIONS(861),
    [anon_sym_break] = ACTIONS(861),
    [anon_sym_consume] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [sym_number] = ACTIONS(863),
    [sym_float] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(863),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(861),
    [anon_sym_SQUOTE] = ACTIONS(861),
    [anon_sym_true] = ACTIONS(861),
    [anon_sym_false] = ACTIONS(861),
    [sym_this] = ACTIONS(861),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [431] = {
    [sym_capability] = STATE(509),
    [sym_identifier] = ACTIONS(851),
    [anon_sym_EQ] = ACTIONS(851),
    [anon_sym_AT] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(849),
    [anon_sym_is] = ACTIONS(851),
    [anon_sym_let] = ACTIONS(849),
    [anon_sym_var] = ACTIONS(849),
    [anon_sym_iso] = ACTIONS(1330),
    [anon_sym_trn] = ACTIONS(1330),
    [anon_sym_ref] = ACTIONS(1330),
    [anon_sym_val] = ACTIONS(1330),
    [anon_sym_box] = ACTIONS(1330),
    [anon_sym_tag] = ACTIONS(1330),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_DOT] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(849),
    [anon_sym_SEMI] = ACTIONS(849),
    [sym_error] = ACTIONS(849),
    [sym_compile_intrinsic] = ACTIONS(849),
    [anon_sym_compile_error] = ACTIONS(849),
    [sym_location] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_not] = ACTIONS(849),
    [anon_sym_DASH_TILDE] = ACTIONS(849),
    [anon_sym_addressof] = ACTIONS(849),
    [anon_sym_digestof] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(851),
    [anon_sym_SLASH] = ACTIONS(851),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(851),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_GT_GT] = ACTIONS(851),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_isnt] = ACTIONS(849),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(851),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_LT] = ACTIONS(851),
    [anon_sym_PLUS_TILDE] = ACTIONS(849),
    [anon_sym_STAR_TILDE] = ACTIONS(849),
    [anon_sym_SLASH_TILDE] = ACTIONS(849),
    [anon_sym_PERCENT_TILDE] = ACTIONS(849),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(849),
    [anon_sym_LT_LT_TILDE] = ACTIONS(849),
    [anon_sym_GT_GT_TILDE] = ACTIONS(849),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(849),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(849),
    [anon_sym_GT_TILDE] = ACTIONS(849),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(849),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(849),
    [anon_sym_LT_TILDE] = ACTIONS(849),
    [anon_sym_PLUS_QMARK] = ACTIONS(849),
    [anon_sym_DASH_QMARK] = ACTIONS(849),
    [anon_sym_STAR_QMARK] = ACTIONS(849),
    [anon_sym_SLASH_QMARK] = ACTIONS(849),
    [anon_sym_PERCENT_QMARK] = ACTIONS(849),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(849),
    [anon_sym_as] = ACTIONS(849),
    [anon_sym_LPAREN2] = ACTIONS(849),
    [anon_sym_DOT_GT] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(849),
    [anon_sym_end] = ACTIONS(849),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_ifdef] = ACTIONS(849),
    [anon_sym_elseif] = ACTIONS(849),
    [anon_sym_iftype] = ACTIONS(849),
    [anon_sym_else] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(849),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_try] = ACTIONS(849),
    [anon_sym_with] = ACTIONS(849),
    [anon_sym_repeat] = ACTIONS(849),
    [anon_sym_recover] = ACTIONS(849),
    [anon_sym_match] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_continue] = ACTIONS(849),
    [anon_sym_break] = ACTIONS(849),
    [anon_sym_consume] = ACTIONS(849),
    [anon_sym_object] = ACTIONS(849),
    [sym_number] = ACTIONS(851),
    [sym_float] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(851),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(849),
    [anon_sym_SQUOTE] = ACTIONS(849),
    [anon_sym_true] = ACTIONS(849),
    [anon_sym_false] = ACTIONS(849),
    [sym_this] = ACTIONS(849),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [432] = {
    [sym_capability] = STATE(508),
    [sym_identifier] = ACTIONS(867),
    [anon_sym_EQ] = ACTIONS(867),
    [anon_sym_AT] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(865),
    [anon_sym_is] = ACTIONS(867),
    [anon_sym_let] = ACTIONS(865),
    [anon_sym_var] = ACTIONS(865),
    [anon_sym_iso] = ACTIONS(1330),
    [anon_sym_trn] = ACTIONS(1330),
    [anon_sym_ref] = ACTIONS(1330),
    [anon_sym_val] = ACTIONS(1330),
    [anon_sym_box] = ACTIONS(1330),
    [anon_sym_tag] = ACTIONS(1330),
    [anon_sym_LPAREN] = ACTIONS(867),
    [anon_sym_DOT] = ACTIONS(867),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_SEMI] = ACTIONS(865),
    [sym_error] = ACTIONS(865),
    [sym_compile_intrinsic] = ACTIONS(865),
    [anon_sym_compile_error] = ACTIONS(865),
    [sym_location] = ACTIONS(865),
    [anon_sym_DASH] = ACTIONS(867),
    [anon_sym_not] = ACTIONS(865),
    [anon_sym_DASH_TILDE] = ACTIONS(865),
    [anon_sym_addressof] = ACTIONS(865),
    [anon_sym_digestof] = ACTIONS(865),
    [anon_sym_PLUS] = ACTIONS(867),
    [anon_sym_STAR] = ACTIONS(867),
    [anon_sym_SLASH] = ACTIONS(867),
    [anon_sym_PERCENT] = ACTIONS(867),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(867),
    [anon_sym_LT_LT] = ACTIONS(867),
    [anon_sym_GT_GT] = ACTIONS(867),
    [anon_sym_and] = ACTIONS(865),
    [anon_sym_or] = ACTIONS(865),
    [anon_sym_xor] = ACTIONS(865),
    [anon_sym_isnt] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(867),
    [anon_sym_BANG_EQ] = ACTIONS(867),
    [anon_sym_GT] = ACTIONS(867),
    [anon_sym_GT_EQ] = ACTIONS(867),
    [anon_sym_LT_EQ] = ACTIONS(867),
    [anon_sym_LT] = ACTIONS(867),
    [anon_sym_PLUS_TILDE] = ACTIONS(865),
    [anon_sym_STAR_TILDE] = ACTIONS(865),
    [anon_sym_SLASH_TILDE] = ACTIONS(865),
    [anon_sym_PERCENT_TILDE] = ACTIONS(865),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(865),
    [anon_sym_LT_LT_TILDE] = ACTIONS(865),
    [anon_sym_GT_GT_TILDE] = ACTIONS(865),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(865),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(865),
    [anon_sym_GT_TILDE] = ACTIONS(865),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(865),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(865),
    [anon_sym_LT_TILDE] = ACTIONS(865),
    [anon_sym_PLUS_QMARK] = ACTIONS(865),
    [anon_sym_DASH_QMARK] = ACTIONS(865),
    [anon_sym_STAR_QMARK] = ACTIONS(865),
    [anon_sym_SLASH_QMARK] = ACTIONS(865),
    [anon_sym_PERCENT_QMARK] = ACTIONS(865),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(865),
    [anon_sym_LPAREN2] = ACTIONS(865),
    [anon_sym_DOT_GT] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [anon_sym_end] = ACTIONS(865),
    [anon_sym_if] = ACTIONS(867),
    [anon_sym_ifdef] = ACTIONS(865),
    [anon_sym_elseif] = ACTIONS(865),
    [anon_sym_iftype] = ACTIONS(865),
    [anon_sym_else] = ACTIONS(867),
    [anon_sym_for] = ACTIONS(865),
    [anon_sym_while] = ACTIONS(865),
    [anon_sym_try] = ACTIONS(865),
    [anon_sym_with] = ACTIONS(865),
    [anon_sym_repeat] = ACTIONS(865),
    [anon_sym_recover] = ACTIONS(865),
    [anon_sym_match] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(865),
    [anon_sym_continue] = ACTIONS(865),
    [anon_sym_break] = ACTIONS(865),
    [anon_sym_consume] = ACTIONS(865),
    [anon_sym_object] = ACTIONS(865),
    [sym_number] = ACTIONS(867),
    [sym_float] = ACTIONS(865),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(865),
    [anon_sym_false] = ACTIONS(865),
    [sym_this] = ACTIONS(865),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [433] = {
    [sym_capability] = STATE(518),
    [sym_identifier] = ACTIONS(839),
    [anon_sym_EQ] = ACTIONS(839),
    [anon_sym_AT] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(837),
    [anon_sym_is] = ACTIONS(839),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_var] = ACTIONS(837),
    [anon_sym_iso] = ACTIONS(1330),
    [anon_sym_trn] = ACTIONS(1330),
    [anon_sym_ref] = ACTIONS(1330),
    [anon_sym_val] = ACTIONS(1330),
    [anon_sym_box] = ACTIONS(1330),
    [anon_sym_tag] = ACTIONS(1330),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_DOT] = ACTIONS(839),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_SEMI] = ACTIONS(837),
    [sym_error] = ACTIONS(837),
    [sym_compile_intrinsic] = ACTIONS(837),
    [anon_sym_compile_error] = ACTIONS(837),
    [sym_location] = ACTIONS(837),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(837),
    [anon_sym_DASH_TILDE] = ACTIONS(837),
    [anon_sym_addressof] = ACTIONS(837),
    [anon_sym_digestof] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_STAR] = ACTIONS(839),
    [anon_sym_SLASH] = ACTIONS(839),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_GT_GT] = ACTIONS(839),
    [anon_sym_and] = ACTIONS(837),
    [anon_sym_or] = ACTIONS(837),
    [anon_sym_xor] = ACTIONS(837),
    [anon_sym_isnt] = ACTIONS(837),
    [anon_sym_EQ_EQ] = ACTIONS(839),
    [anon_sym_BANG_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(839),
    [anon_sym_PLUS_TILDE] = ACTIONS(837),
    [anon_sym_STAR_TILDE] = ACTIONS(837),
    [anon_sym_SLASH_TILDE] = ACTIONS(837),
    [anon_sym_PERCENT_TILDE] = ACTIONS(837),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(837),
    [anon_sym_LT_LT_TILDE] = ACTIONS(837),
    [anon_sym_GT_GT_TILDE] = ACTIONS(837),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(837),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(837),
    [anon_sym_GT_TILDE] = ACTIONS(837),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(837),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(837),
    [anon_sym_LT_TILDE] = ACTIONS(837),
    [anon_sym_PLUS_QMARK] = ACTIONS(837),
    [anon_sym_DASH_QMARK] = ACTIONS(837),
    [anon_sym_STAR_QMARK] = ACTIONS(837),
    [anon_sym_SLASH_QMARK] = ACTIONS(837),
    [anon_sym_PERCENT_QMARK] = ACTIONS(837),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(837),
    [anon_sym_as] = ACTIONS(837),
    [anon_sym_LPAREN2] = ACTIONS(837),
    [anon_sym_DOT_GT] = ACTIONS(837),
    [anon_sym_TILDE] = ACTIONS(837),
    [anon_sym_end] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_ifdef] = ACTIONS(837),
    [anon_sym_elseif] = ACTIONS(837),
    [anon_sym_iftype] = ACTIONS(837),
    [anon_sym_else] = ACTIONS(839),
    [anon_sym_for] = ACTIONS(837),
    [anon_sym_while] = ACTIONS(837),
    [anon_sym_try] = ACTIONS(837),
    [anon_sym_with] = ACTIONS(837),
    [anon_sym_repeat] = ACTIONS(837),
    [anon_sym_recover] = ACTIONS(837),
    [anon_sym_match] = ACTIONS(837),
    [anon_sym_return] = ACTIONS(837),
    [anon_sym_continue] = ACTIONS(837),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_consume] = ACTIONS(837),
    [anon_sym_object] = ACTIONS(837),
    [sym_number] = ACTIONS(839),
    [sym_float] = ACTIONS(837),
    [anon_sym_DQUOTE] = ACTIONS(839),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(837),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_true] = ACTIONS(837),
    [anon_sym_false] = ACTIONS(837),
    [sym_this] = ACTIONS(837),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [434] = {
    [aux_sym_union_type_repeat1] = STATE(446),
    [aux_sym_intersection_type_repeat1] = STATE(445),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_EQ] = ACTIONS(879),
    [anon_sym_AT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(877),
    [anon_sym_is] = ACTIONS(879),
    [anon_sym_let] = ACTIONS(877),
    [anon_sym_var] = ACTIONS(877),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_DOT] = ACTIONS(879),
    [anon_sym_BANG] = ACTIONS(1332),
    [anon_sym_CARET] = ACTIONS(1334),
    [anon_sym_PIPE] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_DASH_GT] = ACTIONS(1340),
    [anon_sym_LBRACE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(877),
    [sym_error] = ACTIONS(877),
    [sym_compile_intrinsic] = ACTIONS(877),
    [anon_sym_compile_error] = ACTIONS(877),
    [sym_location] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(879),
    [anon_sym_not] = ACTIONS(877),
    [anon_sym_DASH_TILDE] = ACTIONS(877),
    [anon_sym_addressof] = ACTIONS(877),
    [anon_sym_digestof] = ACTIONS(877),
    [anon_sym_PLUS] = ACTIONS(879),
    [anon_sym_STAR] = ACTIONS(879),
    [anon_sym_SLASH] = ACTIONS(879),
    [anon_sym_PERCENT] = ACTIONS(879),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(879),
    [anon_sym_LT_LT] = ACTIONS(879),
    [anon_sym_GT_GT] = ACTIONS(879),
    [anon_sym_and] = ACTIONS(877),
    [anon_sym_or] = ACTIONS(877),
    [anon_sym_xor] = ACTIONS(877),
    [anon_sym_isnt] = ACTIONS(877),
    [anon_sym_EQ_EQ] = ACTIONS(879),
    [anon_sym_BANG_EQ] = ACTIONS(879),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_GT_EQ] = ACTIONS(879),
    [anon_sym_LT_EQ] = ACTIONS(879),
    [anon_sym_LT] = ACTIONS(879),
    [anon_sym_PLUS_TILDE] = ACTIONS(877),
    [anon_sym_STAR_TILDE] = ACTIONS(877),
    [anon_sym_SLASH_TILDE] = ACTIONS(877),
    [anon_sym_PERCENT_TILDE] = ACTIONS(877),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(877),
    [anon_sym_LT_LT_TILDE] = ACTIONS(877),
    [anon_sym_GT_GT_TILDE] = ACTIONS(877),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(877),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(877),
    [anon_sym_GT_TILDE] = ACTIONS(877),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(877),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(877),
    [anon_sym_LT_TILDE] = ACTIONS(877),
    [anon_sym_PLUS_QMARK] = ACTIONS(877),
    [anon_sym_DASH_QMARK] = ACTIONS(877),
    [anon_sym_STAR_QMARK] = ACTIONS(877),
    [anon_sym_SLASH_QMARK] = ACTIONS(877),
    [anon_sym_PERCENT_QMARK] = ACTIONS(877),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(877),
    [anon_sym_as] = ACTIONS(877),
    [anon_sym_LPAREN2] = ACTIONS(877),
    [anon_sym_DOT_GT] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(877),
    [anon_sym_end] = ACTIONS(877),
    [anon_sym_if] = ACTIONS(879),
    [anon_sym_ifdef] = ACTIONS(877),
    [anon_sym_elseif] = ACTIONS(877),
    [anon_sym_iftype] = ACTIONS(877),
    [anon_sym_else] = ACTIONS(879),
    [anon_sym_for] = ACTIONS(877),
    [anon_sym_while] = ACTIONS(877),
    [anon_sym_try] = ACTIONS(877),
    [anon_sym_with] = ACTIONS(877),
    [anon_sym_repeat] = ACTIONS(877),
    [anon_sym_recover] = ACTIONS(877),
    [anon_sym_match] = ACTIONS(877),
    [anon_sym_return] = ACTIONS(877),
    [anon_sym_continue] = ACTIONS(877),
    [anon_sym_break] = ACTIONS(877),
    [anon_sym_consume] = ACTIONS(877),
    [anon_sym_object] = ACTIONS(877),
    [sym_number] = ACTIONS(879),
    [sym_float] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(877),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(877),
    [sym_this] = ACTIONS(877),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [435] = {
    [aux_sym_union_type_repeat1] = STATE(446),
    [aux_sym_intersection_type_repeat1] = STATE(445),
    [sym_identifier] = ACTIONS(871),
    [anon_sym_EQ] = ACTIONS(871),
    [anon_sym_AT] = ACTIONS(869),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_is] = ACTIONS(871),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_var] = ACTIONS(869),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_DOT] = ACTIONS(871),
    [anon_sym_BANG] = ACTIONS(1332),
    [anon_sym_CARET] = ACTIONS(1334),
    [anon_sym_PIPE] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_DASH_GT] = ACTIONS(1340),
    [anon_sym_LBRACE] = ACTIONS(869),
    [anon_sym_SEMI] = ACTIONS(869),
    [sym_error] = ACTIONS(869),
    [sym_compile_intrinsic] = ACTIONS(869),
    [anon_sym_compile_error] = ACTIONS(869),
    [sym_location] = ACTIONS(869),
    [anon_sym_DASH] = ACTIONS(871),
    [anon_sym_not] = ACTIONS(869),
    [anon_sym_DASH_TILDE] = ACTIONS(869),
    [anon_sym_addressof] = ACTIONS(869),
    [anon_sym_digestof] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(871),
    [anon_sym_STAR] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(871),
    [anon_sym_PERCENT] = ACTIONS(871),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(871),
    [anon_sym_LT_LT] = ACTIONS(871),
    [anon_sym_GT_GT] = ACTIONS(871),
    [anon_sym_and] = ACTIONS(869),
    [anon_sym_or] = ACTIONS(869),
    [anon_sym_xor] = ACTIONS(869),
    [anon_sym_isnt] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(871),
    [anon_sym_BANG_EQ] = ACTIONS(871),
    [anon_sym_GT] = ACTIONS(871),
    [anon_sym_GT_EQ] = ACTIONS(871),
    [anon_sym_LT_EQ] = ACTIONS(871),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_PLUS_TILDE] = ACTIONS(869),
    [anon_sym_STAR_TILDE] = ACTIONS(869),
    [anon_sym_SLASH_TILDE] = ACTIONS(869),
    [anon_sym_PERCENT_TILDE] = ACTIONS(869),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(869),
    [anon_sym_LT_LT_TILDE] = ACTIONS(869),
    [anon_sym_GT_GT_TILDE] = ACTIONS(869),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(869),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(869),
    [anon_sym_GT_TILDE] = ACTIONS(869),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(869),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(869),
    [anon_sym_LT_TILDE] = ACTIONS(869),
    [anon_sym_PLUS_QMARK] = ACTIONS(869),
    [anon_sym_DASH_QMARK] = ACTIONS(869),
    [anon_sym_STAR_QMARK] = ACTIONS(869),
    [anon_sym_SLASH_QMARK] = ACTIONS(869),
    [anon_sym_PERCENT_QMARK] = ACTIONS(869),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(869),
    [anon_sym_as] = ACTIONS(869),
    [anon_sym_LPAREN2] = ACTIONS(869),
    [anon_sym_DOT_GT] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [anon_sym_end] = ACTIONS(869),
    [anon_sym_if] = ACTIONS(871),
    [anon_sym_ifdef] = ACTIONS(869),
    [anon_sym_elseif] = ACTIONS(869),
    [anon_sym_iftype] = ACTIONS(869),
    [anon_sym_else] = ACTIONS(871),
    [anon_sym_for] = ACTIONS(869),
    [anon_sym_while] = ACTIONS(869),
    [anon_sym_try] = ACTIONS(869),
    [anon_sym_with] = ACTIONS(869),
    [anon_sym_repeat] = ACTIONS(869),
    [anon_sym_recover] = ACTIONS(869),
    [anon_sym_match] = ACTIONS(869),
    [anon_sym_return] = ACTIONS(869),
    [anon_sym_continue] = ACTIONS(869),
    [anon_sym_break] = ACTIONS(869),
    [anon_sym_consume] = ACTIONS(869),
    [anon_sym_object] = ACTIONS(869),
    [sym_number] = ACTIONS(871),
    [sym_float] = ACTIONS(869),
    [anon_sym_DQUOTE] = ACTIONS(871),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(869),
    [anon_sym_SQUOTE] = ACTIONS(869),
    [anon_sym_true] = ACTIONS(869),
    [anon_sym_false] = ACTIONS(869),
    [sym_this] = ACTIONS(869),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [436] = {
    [sym_capability] = STATE(512),
    [sym_identifier] = ACTIONS(847),
    [anon_sym_EQ] = ACTIONS(847),
    [anon_sym_AT] = ACTIONS(845),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_is] = ACTIONS(847),
    [anon_sym_let] = ACTIONS(845),
    [anon_sym_var] = ACTIONS(845),
    [anon_sym_iso] = ACTIONS(1330),
    [anon_sym_trn] = ACTIONS(1330),
    [anon_sym_ref] = ACTIONS(1330),
    [anon_sym_val] = ACTIONS(1330),
    [anon_sym_box] = ACTIONS(1330),
    [anon_sym_tag] = ACTIONS(1330),
    [anon_sym_LPAREN] = ACTIONS(847),
    [anon_sym_DOT] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(845),
    [anon_sym_SEMI] = ACTIONS(845),
    [sym_error] = ACTIONS(845),
    [sym_compile_intrinsic] = ACTIONS(845),
    [anon_sym_compile_error] = ACTIONS(845),
    [sym_location] = ACTIONS(845),
    [anon_sym_DASH] = ACTIONS(847),
    [anon_sym_not] = ACTIONS(845),
    [anon_sym_DASH_TILDE] = ACTIONS(845),
    [anon_sym_addressof] = ACTIONS(845),
    [anon_sym_digestof] = ACTIONS(845),
    [anon_sym_PLUS] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(847),
    [anon_sym_SLASH] = ACTIONS(847),
    [anon_sym_PERCENT] = ACTIONS(847),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(847),
    [anon_sym_LT_LT] = ACTIONS(847),
    [anon_sym_GT_GT] = ACTIONS(847),
    [anon_sym_and] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(845),
    [anon_sym_xor] = ACTIONS(845),
    [anon_sym_isnt] = ACTIONS(845),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_GT_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(847),
    [anon_sym_PLUS_TILDE] = ACTIONS(845),
    [anon_sym_STAR_TILDE] = ACTIONS(845),
    [anon_sym_SLASH_TILDE] = ACTIONS(845),
    [anon_sym_PERCENT_TILDE] = ACTIONS(845),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(845),
    [anon_sym_LT_LT_TILDE] = ACTIONS(845),
    [anon_sym_GT_GT_TILDE] = ACTIONS(845),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(845),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(845),
    [anon_sym_GT_TILDE] = ACTIONS(845),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(845),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(845),
    [anon_sym_LT_TILDE] = ACTIONS(845),
    [anon_sym_PLUS_QMARK] = ACTIONS(845),
    [anon_sym_DASH_QMARK] = ACTIONS(845),
    [anon_sym_STAR_QMARK] = ACTIONS(845),
    [anon_sym_SLASH_QMARK] = ACTIONS(845),
    [anon_sym_PERCENT_QMARK] = ACTIONS(845),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(845),
    [anon_sym_as] = ACTIONS(845),
    [anon_sym_LPAREN2] = ACTIONS(845),
    [anon_sym_DOT_GT] = ACTIONS(845),
    [anon_sym_TILDE] = ACTIONS(845),
    [anon_sym_end] = ACTIONS(845),
    [anon_sym_if] = ACTIONS(847),
    [anon_sym_ifdef] = ACTIONS(845),
    [anon_sym_elseif] = ACTIONS(845),
    [anon_sym_iftype] = ACTIONS(845),
    [anon_sym_else] = ACTIONS(847),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(845),
    [anon_sym_try] = ACTIONS(845),
    [anon_sym_with] = ACTIONS(845),
    [anon_sym_repeat] = ACTIONS(845),
    [anon_sym_recover] = ACTIONS(845),
    [anon_sym_match] = ACTIONS(845),
    [anon_sym_return] = ACTIONS(845),
    [anon_sym_continue] = ACTIONS(845),
    [anon_sym_break] = ACTIONS(845),
    [anon_sym_consume] = ACTIONS(845),
    [anon_sym_object] = ACTIONS(845),
    [sym_number] = ACTIONS(847),
    [sym_float] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(845),
    [anon_sym_SQUOTE] = ACTIONS(845),
    [anon_sym_true] = ACTIONS(845),
    [anon_sym_false] = ACTIONS(845),
    [sym_this] = ACTIONS(845),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [437] = {
    [aux_sym_union_type_repeat1] = STATE(446),
    [aux_sym_intersection_type_repeat1] = STATE(445),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_EQ] = ACTIONS(883),
    [anon_sym_AT] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(881),
    [anon_sym_is] = ACTIONS(883),
    [anon_sym_let] = ACTIONS(881),
    [anon_sym_var] = ACTIONS(881),
    [anon_sym_LPAREN] = ACTIONS(883),
    [anon_sym_DOT] = ACTIONS(883),
    [anon_sym_BANG] = ACTIONS(1332),
    [anon_sym_CARET] = ACTIONS(1334),
    [anon_sym_PIPE] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_DASH_GT] = ACTIONS(1340),
    [anon_sym_LBRACE] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(881),
    [sym_error] = ACTIONS(881),
    [sym_compile_intrinsic] = ACTIONS(881),
    [anon_sym_compile_error] = ACTIONS(881),
    [sym_location] = ACTIONS(881),
    [anon_sym_DASH] = ACTIONS(883),
    [anon_sym_not] = ACTIONS(881),
    [anon_sym_DASH_TILDE] = ACTIONS(881),
    [anon_sym_addressof] = ACTIONS(881),
    [anon_sym_digestof] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(883),
    [anon_sym_STAR] = ACTIONS(883),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_PERCENT] = ACTIONS(883),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(881),
    [anon_sym_or] = ACTIONS(881),
    [anon_sym_xor] = ACTIONS(881),
    [anon_sym_isnt] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_PLUS_TILDE] = ACTIONS(881),
    [anon_sym_STAR_TILDE] = ACTIONS(881),
    [anon_sym_SLASH_TILDE] = ACTIONS(881),
    [anon_sym_PERCENT_TILDE] = ACTIONS(881),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(881),
    [anon_sym_LT_LT_TILDE] = ACTIONS(881),
    [anon_sym_GT_GT_TILDE] = ACTIONS(881),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(881),
    [anon_sym_GT_TILDE] = ACTIONS(881),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(881),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(881),
    [anon_sym_LT_TILDE] = ACTIONS(881),
    [anon_sym_PLUS_QMARK] = ACTIONS(881),
    [anon_sym_DASH_QMARK] = ACTIONS(881),
    [anon_sym_STAR_QMARK] = ACTIONS(881),
    [anon_sym_SLASH_QMARK] = ACTIONS(881),
    [anon_sym_PERCENT_QMARK] = ACTIONS(881),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(881),
    [anon_sym_as] = ACTIONS(881),
    [anon_sym_LPAREN2] = ACTIONS(881),
    [anon_sym_DOT_GT] = ACTIONS(881),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_end] = ACTIONS(881),
    [anon_sym_if] = ACTIONS(883),
    [anon_sym_ifdef] = ACTIONS(881),
    [anon_sym_elseif] = ACTIONS(881),
    [anon_sym_iftype] = ACTIONS(881),
    [anon_sym_else] = ACTIONS(883),
    [anon_sym_for] = ACTIONS(881),
    [anon_sym_while] = ACTIONS(881),
    [anon_sym_try] = ACTIONS(881),
    [anon_sym_with] = ACTIONS(881),
    [anon_sym_repeat] = ACTIONS(881),
    [anon_sym_recover] = ACTIONS(881),
    [anon_sym_match] = ACTIONS(881),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_continue] = ACTIONS(881),
    [anon_sym_break] = ACTIONS(881),
    [anon_sym_consume] = ACTIONS(881),
    [anon_sym_object] = ACTIONS(881),
    [sym_number] = ACTIONS(883),
    [sym_float] = ACTIONS(881),
    [anon_sym_DQUOTE] = ACTIONS(883),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(881),
    [anon_sym_SQUOTE] = ACTIONS(881),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [sym_this] = ACTIONS(881),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [438] = {
    [aux_sym_union_type_repeat1] = STATE(446),
    [aux_sym_intersection_type_repeat1] = STATE(445),
    [sym_identifier] = ACTIONS(819),
    [anon_sym_EQ] = ACTIONS(819),
    [anon_sym_AT] = ACTIONS(817),
    [anon_sym_LBRACK] = ACTIONS(817),
    [anon_sym_is] = ACTIONS(819),
    [anon_sym_let] = ACTIONS(817),
    [anon_sym_var] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_DOT] = ACTIONS(819),
    [anon_sym_BANG] = ACTIONS(1332),
    [anon_sym_CARET] = ACTIONS(1334),
    [anon_sym_PIPE] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_DASH_GT] = ACTIONS(1340),
    [anon_sym_LBRACE] = ACTIONS(817),
    [anon_sym_SEMI] = ACTIONS(817),
    [sym_error] = ACTIONS(817),
    [sym_compile_intrinsic] = ACTIONS(817),
    [anon_sym_compile_error] = ACTIONS(817),
    [sym_location] = ACTIONS(817),
    [anon_sym_DASH] = ACTIONS(819),
    [anon_sym_not] = ACTIONS(817),
    [anon_sym_DASH_TILDE] = ACTIONS(817),
    [anon_sym_addressof] = ACTIONS(817),
    [anon_sym_digestof] = ACTIONS(817),
    [anon_sym_PLUS] = ACTIONS(819),
    [anon_sym_STAR] = ACTIONS(819),
    [anon_sym_SLASH] = ACTIONS(819),
    [anon_sym_PERCENT] = ACTIONS(819),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(819),
    [anon_sym_LT_LT] = ACTIONS(819),
    [anon_sym_GT_GT] = ACTIONS(819),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_or] = ACTIONS(817),
    [anon_sym_xor] = ACTIONS(817),
    [anon_sym_isnt] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(819),
    [anon_sym_BANG_EQ] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(819),
    [anon_sym_GT_EQ] = ACTIONS(819),
    [anon_sym_LT_EQ] = ACTIONS(819),
    [anon_sym_LT] = ACTIONS(819),
    [anon_sym_PLUS_TILDE] = ACTIONS(817),
    [anon_sym_STAR_TILDE] = ACTIONS(817),
    [anon_sym_SLASH_TILDE] = ACTIONS(817),
    [anon_sym_PERCENT_TILDE] = ACTIONS(817),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(817),
    [anon_sym_LT_LT_TILDE] = ACTIONS(817),
    [anon_sym_GT_GT_TILDE] = ACTIONS(817),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(817),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(817),
    [anon_sym_GT_TILDE] = ACTIONS(817),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(817),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(817),
    [anon_sym_LT_TILDE] = ACTIONS(817),
    [anon_sym_PLUS_QMARK] = ACTIONS(817),
    [anon_sym_DASH_QMARK] = ACTIONS(817),
    [anon_sym_STAR_QMARK] = ACTIONS(817),
    [anon_sym_SLASH_QMARK] = ACTIONS(817),
    [anon_sym_PERCENT_QMARK] = ACTIONS(817),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(817),
    [anon_sym_as] = ACTIONS(817),
    [anon_sym_LPAREN2] = ACTIONS(817),
    [anon_sym_DOT_GT] = ACTIONS(817),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_end] = ACTIONS(817),
    [anon_sym_if] = ACTIONS(819),
    [anon_sym_ifdef] = ACTIONS(817),
    [anon_sym_elseif] = ACTIONS(817),
    [anon_sym_iftype] = ACTIONS(817),
    [anon_sym_else] = ACTIONS(819),
    [anon_sym_for] = ACTIONS(817),
    [anon_sym_while] = ACTIONS(817),
    [anon_sym_try] = ACTIONS(817),
    [anon_sym_with] = ACTIONS(817),
    [anon_sym_repeat] = ACTIONS(817),
    [anon_sym_recover] = ACTIONS(817),
    [anon_sym_match] = ACTIONS(817),
    [anon_sym_return] = ACTIONS(817),
    [anon_sym_continue] = ACTIONS(817),
    [anon_sym_break] = ACTIONS(817),
    [anon_sym_consume] = ACTIONS(817),
    [anon_sym_object] = ACTIONS(817),
    [sym_number] = ACTIONS(819),
    [sym_float] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(819),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(817),
    [anon_sym_SQUOTE] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(817),
    [anon_sym_false] = ACTIONS(817),
    [sym_this] = ACTIONS(817),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [439] = {
    [sym_capability] = STATE(504),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_EQ] = ACTIONS(855),
    [anon_sym_AT] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_is] = ACTIONS(855),
    [anon_sym_let] = ACTIONS(853),
    [anon_sym_var] = ACTIONS(853),
    [anon_sym_iso] = ACTIONS(1330),
    [anon_sym_trn] = ACTIONS(1330),
    [anon_sym_ref] = ACTIONS(1330),
    [anon_sym_val] = ACTIONS(1330),
    [anon_sym_box] = ACTIONS(1330),
    [anon_sym_tag] = ACTIONS(1330),
    [anon_sym_LPAREN] = ACTIONS(855),
    [anon_sym_DOT] = ACTIONS(855),
    [anon_sym_LBRACE] = ACTIONS(853),
    [anon_sym_SEMI] = ACTIONS(853),
    [sym_error] = ACTIONS(853),
    [sym_compile_intrinsic] = ACTIONS(853),
    [anon_sym_compile_error] = ACTIONS(853),
    [sym_location] = ACTIONS(853),
    [anon_sym_DASH] = ACTIONS(855),
    [anon_sym_not] = ACTIONS(853),
    [anon_sym_DASH_TILDE] = ACTIONS(853),
    [anon_sym_addressof] = ACTIONS(853),
    [anon_sym_digestof] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_PERCENT] = ACTIONS(855),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(855),
    [anon_sym_LT_LT] = ACTIONS(855),
    [anon_sym_GT_GT] = ACTIONS(855),
    [anon_sym_and] = ACTIONS(853),
    [anon_sym_or] = ACTIONS(853),
    [anon_sym_xor] = ACTIONS(853),
    [anon_sym_isnt] = ACTIONS(853),
    [anon_sym_EQ_EQ] = ACTIONS(855),
    [anon_sym_BANG_EQ] = ACTIONS(855),
    [anon_sym_GT] = ACTIONS(855),
    [anon_sym_GT_EQ] = ACTIONS(855),
    [anon_sym_LT_EQ] = ACTIONS(855),
    [anon_sym_LT] = ACTIONS(855),
    [anon_sym_PLUS_TILDE] = ACTIONS(853),
    [anon_sym_STAR_TILDE] = ACTIONS(853),
    [anon_sym_SLASH_TILDE] = ACTIONS(853),
    [anon_sym_PERCENT_TILDE] = ACTIONS(853),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(853),
    [anon_sym_LT_LT_TILDE] = ACTIONS(853),
    [anon_sym_GT_GT_TILDE] = ACTIONS(853),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(853),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(853),
    [anon_sym_GT_TILDE] = ACTIONS(853),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(853),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(853),
    [anon_sym_LT_TILDE] = ACTIONS(853),
    [anon_sym_PLUS_QMARK] = ACTIONS(853),
    [anon_sym_DASH_QMARK] = ACTIONS(853),
    [anon_sym_STAR_QMARK] = ACTIONS(853),
    [anon_sym_SLASH_QMARK] = ACTIONS(853),
    [anon_sym_PERCENT_QMARK] = ACTIONS(853),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(853),
    [anon_sym_as] = ACTIONS(853),
    [anon_sym_LPAREN2] = ACTIONS(853),
    [anon_sym_DOT_GT] = ACTIONS(853),
    [anon_sym_TILDE] = ACTIONS(853),
    [anon_sym_end] = ACTIONS(853),
    [anon_sym_if] = ACTIONS(855),
    [anon_sym_ifdef] = ACTIONS(853),
    [anon_sym_elseif] = ACTIONS(853),
    [anon_sym_iftype] = ACTIONS(853),
    [anon_sym_else] = ACTIONS(855),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_while] = ACTIONS(853),
    [anon_sym_try] = ACTIONS(853),
    [anon_sym_with] = ACTIONS(853),
    [anon_sym_repeat] = ACTIONS(853),
    [anon_sym_recover] = ACTIONS(853),
    [anon_sym_match] = ACTIONS(853),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_continue] = ACTIONS(853),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_consume] = ACTIONS(853),
    [anon_sym_object] = ACTIONS(853),
    [sym_number] = ACTIONS(855),
    [sym_float] = ACTIONS(853),
    [anon_sym_DQUOTE] = ACTIONS(855),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(853),
    [anon_sym_true] = ACTIONS(853),
    [anon_sym_false] = ACTIONS(853),
    [sym_this] = ACTIONS(853),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [440] = {
    [aux_sym_union_type_repeat1] = STATE(187),
    [aux_sym_intersection_type_repeat1] = STATE(188),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_EQ] = ACTIONS(879),
    [anon_sym_AT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(877),
    [anon_sym_is] = ACTIONS(879),
    [anon_sym_let] = ACTIONS(877),
    [anon_sym_var] = ACTIONS(877),
    [anon_sym_EQ_GT] = ACTIONS(877),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_DOT] = ACTIONS(879),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_CARET] = ACTIONS(971),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH_GT] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(877),
    [sym_error] = ACTIONS(877),
    [sym_compile_intrinsic] = ACTIONS(877),
    [anon_sym_compile_error] = ACTIONS(877),
    [sym_location] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(879),
    [anon_sym_not] = ACTIONS(877),
    [anon_sym_DASH_TILDE] = ACTIONS(877),
    [anon_sym_addressof] = ACTIONS(877),
    [anon_sym_digestof] = ACTIONS(877),
    [anon_sym_PLUS] = ACTIONS(879),
    [anon_sym_STAR] = ACTIONS(879),
    [anon_sym_SLASH] = ACTIONS(879),
    [anon_sym_PERCENT] = ACTIONS(879),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(879),
    [anon_sym_LT_LT] = ACTIONS(879),
    [anon_sym_GT_GT] = ACTIONS(879),
    [anon_sym_and] = ACTIONS(877),
    [anon_sym_or] = ACTIONS(877),
    [anon_sym_xor] = ACTIONS(877),
    [anon_sym_isnt] = ACTIONS(877),
    [anon_sym_EQ_EQ] = ACTIONS(879),
    [anon_sym_BANG_EQ] = ACTIONS(879),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_GT_EQ] = ACTIONS(879),
    [anon_sym_LT_EQ] = ACTIONS(879),
    [anon_sym_LT] = ACTIONS(879),
    [anon_sym_PLUS_TILDE] = ACTIONS(877),
    [anon_sym_STAR_TILDE] = ACTIONS(877),
    [anon_sym_SLASH_TILDE] = ACTIONS(877),
    [anon_sym_PERCENT_TILDE] = ACTIONS(877),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(877),
    [anon_sym_LT_LT_TILDE] = ACTIONS(877),
    [anon_sym_GT_GT_TILDE] = ACTIONS(877),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(877),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(877),
    [anon_sym_GT_TILDE] = ACTIONS(877),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(877),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(877),
    [anon_sym_LT_TILDE] = ACTIONS(877),
    [anon_sym_PLUS_QMARK] = ACTIONS(877),
    [anon_sym_DASH_QMARK] = ACTIONS(877),
    [anon_sym_STAR_QMARK] = ACTIONS(877),
    [anon_sym_SLASH_QMARK] = ACTIONS(877),
    [anon_sym_PERCENT_QMARK] = ACTIONS(877),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(877),
    [anon_sym_as] = ACTIONS(877),
    [anon_sym_LPAREN2] = ACTIONS(877),
    [anon_sym_DOT_GT] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(877),
    [anon_sym_end] = ACTIONS(877),
    [anon_sym_if] = ACTIONS(879),
    [anon_sym_ifdef] = ACTIONS(877),
    [anon_sym_iftype] = ACTIONS(877),
    [anon_sym_else] = ACTIONS(877),
    [anon_sym_for] = ACTIONS(877),
    [anon_sym_while] = ACTIONS(877),
    [anon_sym_try] = ACTIONS(877),
    [anon_sym_with] = ACTIONS(877),
    [anon_sym_repeat] = ACTIONS(877),
    [anon_sym_recover] = ACTIONS(877),
    [anon_sym_match] = ACTIONS(877),
    [anon_sym_return] = ACTIONS(877),
    [anon_sym_continue] = ACTIONS(877),
    [anon_sym_break] = ACTIONS(877),
    [anon_sym_consume] = ACTIONS(877),
    [anon_sym_object] = ACTIONS(877),
    [sym_number] = ACTIONS(879),
    [sym_float] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(877),
    [anon_sym_SQUOTE] = ACTIONS(877),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(877),
    [sym_this] = ACTIONS(877),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [441] = {
    [sym_capability] = STATE(523),
    [sym_identifier] = ACTIONS(833),
    [anon_sym_EQ] = ACTIONS(833),
    [anon_sym_AT] = ACTIONS(831),
    [anon_sym_LBRACK] = ACTIONS(831),
    [anon_sym_is] = ACTIONS(833),
    [anon_sym_let] = ACTIONS(831),
    [anon_sym_var] = ACTIONS(831),
    [anon_sym_iso] = ACTIONS(1330),
    [anon_sym_trn] = ACTIONS(1330),
    [anon_sym_ref] = ACTIONS(1330),
    [anon_sym_val] = ACTIONS(1330),
    [anon_sym_box] = ACTIONS(1330),
    [anon_sym_tag] = ACTIONS(1330),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_DOT] = ACTIONS(833),
    [anon_sym_LBRACE] = ACTIONS(831),
    [anon_sym_SEMI] = ACTIONS(831),
    [sym_error] = ACTIONS(831),
    [sym_compile_intrinsic] = ACTIONS(831),
    [anon_sym_compile_error] = ACTIONS(831),
    [sym_location] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_not] = ACTIONS(831),
    [anon_sym_DASH_TILDE] = ACTIONS(831),
    [anon_sym_addressof] = ACTIONS(831),
    [anon_sym_digestof] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_STAR] = ACTIONS(833),
    [anon_sym_SLASH] = ACTIONS(833),
    [anon_sym_PERCENT] = ACTIONS(833),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(833),
    [anon_sym_LT_LT] = ACTIONS(833),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_and] = ACTIONS(831),
    [anon_sym_or] = ACTIONS(831),
    [anon_sym_xor] = ACTIONS(831),
    [anon_sym_isnt] = ACTIONS(831),
    [anon_sym_EQ_EQ] = ACTIONS(833),
    [anon_sym_BANG_EQ] = ACTIONS(833),
    [anon_sym_GT] = ACTIONS(833),
    [anon_sym_GT_EQ] = ACTIONS(833),
    [anon_sym_LT_EQ] = ACTIONS(833),
    [anon_sym_LT] = ACTIONS(833),
    [anon_sym_PLUS_TILDE] = ACTIONS(831),
    [anon_sym_STAR_TILDE] = ACTIONS(831),
    [anon_sym_SLASH_TILDE] = ACTIONS(831),
    [anon_sym_PERCENT_TILDE] = ACTIONS(831),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(831),
    [anon_sym_LT_LT_TILDE] = ACTIONS(831),
    [anon_sym_GT_GT_TILDE] = ACTIONS(831),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(831),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(831),
    [anon_sym_GT_TILDE] = ACTIONS(831),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(831),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(831),
    [anon_sym_LT_TILDE] = ACTIONS(831),
    [anon_sym_PLUS_QMARK] = ACTIONS(831),
    [anon_sym_DASH_QMARK] = ACTIONS(831),
    [anon_sym_STAR_QMARK] = ACTIONS(831),
    [anon_sym_SLASH_QMARK] = ACTIONS(831),
    [anon_sym_PERCENT_QMARK] = ACTIONS(831),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(831),
    [anon_sym_as] = ACTIONS(831),
    [anon_sym_LPAREN2] = ACTIONS(831),
    [anon_sym_DOT_GT] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(831),
    [anon_sym_end] = ACTIONS(831),
    [anon_sym_if] = ACTIONS(833),
    [anon_sym_ifdef] = ACTIONS(831),
    [anon_sym_elseif] = ACTIONS(831),
    [anon_sym_iftype] = ACTIONS(831),
    [anon_sym_else] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(831),
    [anon_sym_while] = ACTIONS(831),
    [anon_sym_try] = ACTIONS(831),
    [anon_sym_with] = ACTIONS(831),
    [anon_sym_repeat] = ACTIONS(831),
    [anon_sym_recover] = ACTIONS(831),
    [anon_sym_match] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_continue] = ACTIONS(831),
    [anon_sym_break] = ACTIONS(831),
    [anon_sym_consume] = ACTIONS(831),
    [anon_sym_object] = ACTIONS(831),
    [sym_number] = ACTIONS(833),
    [sym_float] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(831),
    [anon_sym_SQUOTE] = ACTIONS(831),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_this] = ACTIONS(831),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [442] = {
    [aux_sym_union_type_repeat1] = STATE(446),
    [aux_sym_intersection_type_repeat1] = STATE(445),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_EQ] = ACTIONS(859),
    [anon_sym_AT] = ACTIONS(857),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_is] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(857),
    [anon_sym_var] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(859),
    [anon_sym_BANG] = ACTIONS(1332),
    [anon_sym_CARET] = ACTIONS(1334),
    [anon_sym_PIPE] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_DASH_GT] = ACTIONS(1340),
    [anon_sym_LBRACE] = ACTIONS(857),
    [anon_sym_SEMI] = ACTIONS(857),
    [sym_error] = ACTIONS(857),
    [sym_compile_intrinsic] = ACTIONS(857),
    [anon_sym_compile_error] = ACTIONS(857),
    [sym_location] = ACTIONS(857),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_not] = ACTIONS(857),
    [anon_sym_DASH_TILDE] = ACTIONS(857),
    [anon_sym_addressof] = ACTIONS(857),
    [anon_sym_digestof] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(859),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(859),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_and] = ACTIONS(857),
    [anon_sym_or] = ACTIONS(857),
    [anon_sym_xor] = ACTIONS(857),
    [anon_sym_isnt] = ACTIONS(857),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(859),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(859),
    [anon_sym_PLUS_TILDE] = ACTIONS(857),
    [anon_sym_STAR_TILDE] = ACTIONS(857),
    [anon_sym_SLASH_TILDE] = ACTIONS(857),
    [anon_sym_PERCENT_TILDE] = ACTIONS(857),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(857),
    [anon_sym_LT_LT_TILDE] = ACTIONS(857),
    [anon_sym_GT_GT_TILDE] = ACTIONS(857),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(857),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(857),
    [anon_sym_GT_TILDE] = ACTIONS(857),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(857),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(857),
    [anon_sym_LT_TILDE] = ACTIONS(857),
    [anon_sym_PLUS_QMARK] = ACTIONS(857),
    [anon_sym_DASH_QMARK] = ACTIONS(857),
    [anon_sym_STAR_QMARK] = ACTIONS(857),
    [anon_sym_SLASH_QMARK] = ACTIONS(857),
    [anon_sym_PERCENT_QMARK] = ACTIONS(857),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(857),
    [anon_sym_as] = ACTIONS(857),
    [anon_sym_LPAREN2] = ACTIONS(857),
    [anon_sym_DOT_GT] = ACTIONS(857),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_end] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_ifdef] = ACTIONS(857),
    [anon_sym_elseif] = ACTIONS(857),
    [anon_sym_iftype] = ACTIONS(857),
    [anon_sym_else] = ACTIONS(859),
    [anon_sym_for] = ACTIONS(857),
    [anon_sym_while] = ACTIONS(857),
    [anon_sym_try] = ACTIONS(857),
    [anon_sym_with] = ACTIONS(857),
    [anon_sym_repeat] = ACTIONS(857),
    [anon_sym_recover] = ACTIONS(857),
    [anon_sym_match] = ACTIONS(857),
    [anon_sym_return] = ACTIONS(857),
    [anon_sym_continue] = ACTIONS(857),
    [anon_sym_break] = ACTIONS(857),
    [anon_sym_consume] = ACTIONS(857),
    [anon_sym_object] = ACTIONS(857),
    [sym_number] = ACTIONS(859),
    [sym_float] = ACTIONS(857),
    [anon_sym_DQUOTE] = ACTIONS(859),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(857),
    [anon_sym_SQUOTE] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(857),
    [anon_sym_false] = ACTIONS(857),
    [sym_this] = ACTIONS(857),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [443] = {
    [sym_capability] = STATE(510),
    [sym_identifier] = ACTIONS(843),
    [anon_sym_EQ] = ACTIONS(843),
    [anon_sym_AT] = ACTIONS(841),
    [anon_sym_LBRACK] = ACTIONS(841),
    [anon_sym_is] = ACTIONS(843),
    [anon_sym_let] = ACTIONS(841),
    [anon_sym_var] = ACTIONS(841),
    [anon_sym_iso] = ACTIONS(1330),
    [anon_sym_trn] = ACTIONS(1330),
    [anon_sym_ref] = ACTIONS(1330),
    [anon_sym_val] = ACTIONS(1330),
    [anon_sym_box] = ACTIONS(1330),
    [anon_sym_tag] = ACTIONS(1330),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_DOT] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(841),
    [anon_sym_SEMI] = ACTIONS(841),
    [sym_error] = ACTIONS(841),
    [sym_compile_intrinsic] = ACTIONS(841),
    [anon_sym_compile_error] = ACTIONS(841),
    [sym_location] = ACTIONS(841),
    [anon_sym_DASH] = ACTIONS(843),
    [anon_sym_not] = ACTIONS(841),
    [anon_sym_DASH_TILDE] = ACTIONS(841),
    [anon_sym_addressof] = ACTIONS(841),
    [anon_sym_digestof] = ACTIONS(841),
    [anon_sym_PLUS] = ACTIONS(843),
    [anon_sym_STAR] = ACTIONS(843),
    [anon_sym_SLASH] = ACTIONS(843),
    [anon_sym_PERCENT] = ACTIONS(843),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(843),
    [anon_sym_LT_LT] = ACTIONS(843),
    [anon_sym_GT_GT] = ACTIONS(843),
    [anon_sym_and] = ACTIONS(841),
    [anon_sym_or] = ACTIONS(841),
    [anon_sym_xor] = ACTIONS(841),
    [anon_sym_isnt] = ACTIONS(841),
    [anon_sym_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(843),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_PLUS_TILDE] = ACTIONS(841),
    [anon_sym_STAR_TILDE] = ACTIONS(841),
    [anon_sym_SLASH_TILDE] = ACTIONS(841),
    [anon_sym_PERCENT_TILDE] = ACTIONS(841),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(841),
    [anon_sym_LT_LT_TILDE] = ACTIONS(841),
    [anon_sym_GT_GT_TILDE] = ACTIONS(841),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(841),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(841),
    [anon_sym_GT_TILDE] = ACTIONS(841),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(841),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(841),
    [anon_sym_LT_TILDE] = ACTIONS(841),
    [anon_sym_PLUS_QMARK] = ACTIONS(841),
    [anon_sym_DASH_QMARK] = ACTIONS(841),
    [anon_sym_STAR_QMARK] = ACTIONS(841),
    [anon_sym_SLASH_QMARK] = ACTIONS(841),
    [anon_sym_PERCENT_QMARK] = ACTIONS(841),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(841),
    [anon_sym_as] = ACTIONS(841),
    [anon_sym_LPAREN2] = ACTIONS(841),
    [anon_sym_DOT_GT] = ACTIONS(841),
    [anon_sym_TILDE] = ACTIONS(841),
    [anon_sym_end] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_ifdef] = ACTIONS(841),
    [anon_sym_elseif] = ACTIONS(841),
    [anon_sym_iftype] = ACTIONS(841),
    [anon_sym_else] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(841),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_with] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(841),
    [anon_sym_recover] = ACTIONS(841),
    [anon_sym_match] = ACTIONS(841),
    [anon_sym_return] = ACTIONS(841),
    [anon_sym_continue] = ACTIONS(841),
    [anon_sym_break] = ACTIONS(841),
    [anon_sym_consume] = ACTIONS(841),
    [anon_sym_object] = ACTIONS(841),
    [sym_number] = ACTIONS(843),
    [sym_float] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(843),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(841),
    [anon_sym_SQUOTE] = ACTIONS(841),
    [anon_sym_true] = ACTIONS(841),
    [anon_sym_false] = ACTIONS(841),
    [sym_this] = ACTIONS(841),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [444] = {
    [aux_sym_intersection_type_repeat1] = STATE(444),
    [sym_identifier] = ACTIONS(883),
    [anon_sym_EQ] = ACTIONS(883),
    [anon_sym_AT] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(881),
    [anon_sym_is] = ACTIONS(883),
    [anon_sym_let] = ACTIONS(881),
    [anon_sym_var] = ACTIONS(881),
    [anon_sym_LPAREN] = ACTIONS(883),
    [anon_sym_DOT] = ACTIONS(883),
    [anon_sym_BANG] = ACTIONS(883),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(881),
    [anon_sym_AMP] = ACTIONS(1342),
    [anon_sym_DASH_GT] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(881),
    [sym_error] = ACTIONS(881),
    [sym_compile_intrinsic] = ACTIONS(881),
    [anon_sym_compile_error] = ACTIONS(881),
    [sym_location] = ACTIONS(881),
    [anon_sym_DASH] = ACTIONS(883),
    [anon_sym_not] = ACTIONS(881),
    [anon_sym_DASH_TILDE] = ACTIONS(881),
    [anon_sym_addressof] = ACTIONS(881),
    [anon_sym_digestof] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(883),
    [anon_sym_STAR] = ACTIONS(883),
    [anon_sym_SLASH] = ACTIONS(883),
    [anon_sym_PERCENT] = ACTIONS(883),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(881),
    [anon_sym_or] = ACTIONS(881),
    [anon_sym_xor] = ACTIONS(881),
    [anon_sym_isnt] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_PLUS_TILDE] = ACTIONS(881),
    [anon_sym_STAR_TILDE] = ACTIONS(881),
    [anon_sym_SLASH_TILDE] = ACTIONS(881),
    [anon_sym_PERCENT_TILDE] = ACTIONS(881),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(881),
    [anon_sym_LT_LT_TILDE] = ACTIONS(881),
    [anon_sym_GT_GT_TILDE] = ACTIONS(881),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(881),
    [anon_sym_GT_TILDE] = ACTIONS(881),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(881),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(881),
    [anon_sym_LT_TILDE] = ACTIONS(881),
    [anon_sym_PLUS_QMARK] = ACTIONS(881),
    [anon_sym_DASH_QMARK] = ACTIONS(881),
    [anon_sym_STAR_QMARK] = ACTIONS(881),
    [anon_sym_SLASH_QMARK] = ACTIONS(881),
    [anon_sym_PERCENT_QMARK] = ACTIONS(881),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(881),
    [anon_sym_as] = ACTIONS(881),
    [anon_sym_LPAREN2] = ACTIONS(881),
    [anon_sym_DOT_GT] = ACTIONS(881),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_end] = ACTIONS(881),
    [anon_sym_if] = ACTIONS(883),
    [anon_sym_ifdef] = ACTIONS(881),
    [anon_sym_elseif] = ACTIONS(881),
    [anon_sym_iftype] = ACTIONS(881),
    [anon_sym_else] = ACTIONS(883),
    [anon_sym_for] = ACTIONS(881),
    [anon_sym_while] = ACTIONS(881),
    [anon_sym_try] = ACTIONS(881),
    [anon_sym_with] = ACTIONS(881),
    [anon_sym_repeat] = ACTIONS(881),
    [anon_sym_recover] = ACTIONS(881),
    [anon_sym_match] = ACTIONS(881),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_continue] = ACTIONS(881),
    [anon_sym_break] = ACTIONS(881),
    [anon_sym_consume] = ACTIONS(881),
    [anon_sym_object] = ACTIONS(881),
    [sym_number] = ACTIONS(883),
    [sym_float] = ACTIONS(881),
    [anon_sym_DQUOTE] = ACTIONS(883),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(881),
    [anon_sym_SQUOTE] = ACTIONS(881),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [sym_this] = ACTIONS(881),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [445] = {
    [aux_sym_intersection_type_repeat1] = STATE(444),
    [sym_identifier] = ACTIONS(894),
    [anon_sym_EQ] = ACTIONS(894),
    [anon_sym_AT] = ACTIONS(892),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_is] = ACTIONS(894),
    [anon_sym_let] = ACTIONS(892),
    [anon_sym_var] = ACTIONS(892),
    [anon_sym_LPAREN] = ACTIONS(894),
    [anon_sym_DOT] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(894),
    [anon_sym_CARET] = ACTIONS(892),
    [anon_sym_PIPE] = ACTIONS(892),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_DASH_GT] = ACTIONS(892),
    [anon_sym_LBRACE] = ACTIONS(892),
    [anon_sym_SEMI] = ACTIONS(892),
    [sym_error] = ACTIONS(892),
    [sym_compile_intrinsic] = ACTIONS(892),
    [anon_sym_compile_error] = ACTIONS(892),
    [sym_location] = ACTIONS(892),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_not] = ACTIONS(892),
    [anon_sym_DASH_TILDE] = ACTIONS(892),
    [anon_sym_addressof] = ACTIONS(892),
    [anon_sym_digestof] = ACTIONS(892),
    [anon_sym_PLUS] = ACTIONS(894),
    [anon_sym_STAR] = ACTIONS(894),
    [anon_sym_SLASH] = ACTIONS(894),
    [anon_sym_PERCENT] = ACTIONS(894),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(894),
    [anon_sym_LT_LT] = ACTIONS(894),
    [anon_sym_GT_GT] = ACTIONS(894),
    [anon_sym_and] = ACTIONS(892),
    [anon_sym_or] = ACTIONS(892),
    [anon_sym_xor] = ACTIONS(892),
    [anon_sym_isnt] = ACTIONS(892),
    [anon_sym_EQ_EQ] = ACTIONS(894),
    [anon_sym_BANG_EQ] = ACTIONS(894),
    [anon_sym_GT] = ACTIONS(894),
    [anon_sym_GT_EQ] = ACTIONS(894),
    [anon_sym_LT_EQ] = ACTIONS(894),
    [anon_sym_LT] = ACTIONS(894),
    [anon_sym_PLUS_TILDE] = ACTIONS(892),
    [anon_sym_STAR_TILDE] = ACTIONS(892),
    [anon_sym_SLASH_TILDE] = ACTIONS(892),
    [anon_sym_PERCENT_TILDE] = ACTIONS(892),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(892),
    [anon_sym_LT_LT_TILDE] = ACTIONS(892),
    [anon_sym_GT_GT_TILDE] = ACTIONS(892),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(892),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(892),
    [anon_sym_GT_TILDE] = ACTIONS(892),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(892),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(892),
    [anon_sym_LT_TILDE] = ACTIONS(892),
    [anon_sym_PLUS_QMARK] = ACTIONS(892),
    [anon_sym_DASH_QMARK] = ACTIONS(892),
    [anon_sym_STAR_QMARK] = ACTIONS(892),
    [anon_sym_SLASH_QMARK] = ACTIONS(892),
    [anon_sym_PERCENT_QMARK] = ACTIONS(892),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(892),
    [anon_sym_as] = ACTIONS(892),
    [anon_sym_LPAREN2] = ACTIONS(892),
    [anon_sym_DOT_GT] = ACTIONS(892),
    [anon_sym_TILDE] = ACTIONS(892),
    [anon_sym_end] = ACTIONS(892),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_ifdef] = ACTIONS(892),
    [anon_sym_elseif] = ACTIONS(892),
    [anon_sym_iftype] = ACTIONS(892),
    [anon_sym_else] = ACTIONS(894),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(892),
    [anon_sym_try] = ACTIONS(892),
    [anon_sym_with] = ACTIONS(892),
    [anon_sym_repeat] = ACTIONS(892),
    [anon_sym_recover] = ACTIONS(892),
    [anon_sym_match] = ACTIONS(892),
    [anon_sym_return] = ACTIONS(892),
    [anon_sym_continue] = ACTIONS(892),
    [anon_sym_break] = ACTIONS(892),
    [anon_sym_consume] = ACTIONS(892),
    [anon_sym_object] = ACTIONS(892),
    [sym_number] = ACTIONS(894),
    [sym_float] = ACTIONS(892),
    [anon_sym_DQUOTE] = ACTIONS(894),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(892),
    [anon_sym_SQUOTE] = ACTIONS(892),
    [anon_sym_true] = ACTIONS(892),
    [anon_sym_false] = ACTIONS(892),
    [sym_this] = ACTIONS(892),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [446] = {
    [aux_sym_union_type_repeat1] = STATE(447),
    [sym_identifier] = ACTIONS(887),
    [anon_sym_EQ] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(885),
    [anon_sym_LBRACK] = ACTIONS(885),
    [anon_sym_is] = ACTIONS(887),
    [anon_sym_let] = ACTIONS(885),
    [anon_sym_var] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(887),
    [anon_sym_DOT] = ACTIONS(887),
    [anon_sym_BANG] = ACTIONS(887),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_PIPE] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(885),
    [anon_sym_DASH_GT] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(885),
    [anon_sym_SEMI] = ACTIONS(885),
    [sym_error] = ACTIONS(885),
    [sym_compile_intrinsic] = ACTIONS(885),
    [anon_sym_compile_error] = ACTIONS(885),
    [sym_location] = ACTIONS(885),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_not] = ACTIONS(885),
    [anon_sym_DASH_TILDE] = ACTIONS(885),
    [anon_sym_addressof] = ACTIONS(885),
    [anon_sym_digestof] = ACTIONS(885),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(887),
    [anon_sym_SLASH] = ACTIONS(887),
    [anon_sym_PERCENT] = ACTIONS(887),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(887),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_and] = ACTIONS(885),
    [anon_sym_or] = ACTIONS(885),
    [anon_sym_xor] = ACTIONS(885),
    [anon_sym_isnt] = ACTIONS(885),
    [anon_sym_EQ_EQ] = ACTIONS(887),
    [anon_sym_BANG_EQ] = ACTIONS(887),
    [anon_sym_GT] = ACTIONS(887),
    [anon_sym_GT_EQ] = ACTIONS(887),
    [anon_sym_LT_EQ] = ACTIONS(887),
    [anon_sym_LT] = ACTIONS(887),
    [anon_sym_PLUS_TILDE] = ACTIONS(885),
    [anon_sym_STAR_TILDE] = ACTIONS(885),
    [anon_sym_SLASH_TILDE] = ACTIONS(885),
    [anon_sym_PERCENT_TILDE] = ACTIONS(885),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(885),
    [anon_sym_LT_LT_TILDE] = ACTIONS(885),
    [anon_sym_GT_GT_TILDE] = ACTIONS(885),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(885),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(885),
    [anon_sym_GT_TILDE] = ACTIONS(885),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(885),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(885),
    [anon_sym_LT_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_QMARK] = ACTIONS(885),
    [anon_sym_DASH_QMARK] = ACTIONS(885),
    [anon_sym_STAR_QMARK] = ACTIONS(885),
    [anon_sym_SLASH_QMARK] = ACTIONS(885),
    [anon_sym_PERCENT_QMARK] = ACTIONS(885),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(885),
    [anon_sym_as] = ACTIONS(885),
    [anon_sym_LPAREN2] = ACTIONS(885),
    [anon_sym_DOT_GT] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_end] = ACTIONS(885),
    [anon_sym_if] = ACTIONS(887),
    [anon_sym_ifdef] = ACTIONS(885),
    [anon_sym_elseif] = ACTIONS(885),
    [anon_sym_iftype] = ACTIONS(885),
    [anon_sym_else] = ACTIONS(887),
    [anon_sym_for] = ACTIONS(885),
    [anon_sym_while] = ACTIONS(885),
    [anon_sym_try] = ACTIONS(885),
    [anon_sym_with] = ACTIONS(885),
    [anon_sym_repeat] = ACTIONS(885),
    [anon_sym_recover] = ACTIONS(885),
    [anon_sym_match] = ACTIONS(885),
    [anon_sym_return] = ACTIONS(885),
    [anon_sym_continue] = ACTIONS(885),
    [anon_sym_break] = ACTIONS(885),
    [anon_sym_consume] = ACTIONS(885),
    [anon_sym_object] = ACTIONS(885),
    [sym_number] = ACTIONS(887),
    [sym_float] = ACTIONS(885),
    [anon_sym_DQUOTE] = ACTIONS(887),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(885),
    [anon_sym_SQUOTE] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(885),
    [anon_sym_false] = ACTIONS(885),
    [sym_this] = ACTIONS(885),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [447] = {
    [aux_sym_union_type_repeat1] = STATE(447),
    [sym_identifier] = ACTIONS(871),
    [anon_sym_EQ] = ACTIONS(871),
    [anon_sym_AT] = ACTIONS(869),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_is] = ACTIONS(871),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_var] = ACTIONS(869),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_DOT] = ACTIONS(871),
    [anon_sym_BANG] = ACTIONS(871),
    [anon_sym_CARET] = ACTIONS(869),
    [anon_sym_PIPE] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(869),
    [anon_sym_DASH_GT] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(869),
    [anon_sym_SEMI] = ACTIONS(869),
    [sym_error] = ACTIONS(869),
    [sym_compile_intrinsic] = ACTIONS(869),
    [anon_sym_compile_error] = ACTIONS(869),
    [sym_location] = ACTIONS(869),
    [anon_sym_DASH] = ACTIONS(871),
    [anon_sym_not] = ACTIONS(869),
    [anon_sym_DASH_TILDE] = ACTIONS(869),
    [anon_sym_addressof] = ACTIONS(869),
    [anon_sym_digestof] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(871),
    [anon_sym_STAR] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(871),
    [anon_sym_PERCENT] = ACTIONS(871),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(871),
    [anon_sym_LT_LT] = ACTIONS(871),
    [anon_sym_GT_GT] = ACTIONS(871),
    [anon_sym_and] = ACTIONS(869),
    [anon_sym_or] = ACTIONS(869),
    [anon_sym_xor] = ACTIONS(869),
    [anon_sym_isnt] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(871),
    [anon_sym_BANG_EQ] = ACTIONS(871),
    [anon_sym_GT] = ACTIONS(871),
    [anon_sym_GT_EQ] = ACTIONS(871),
    [anon_sym_LT_EQ] = ACTIONS(871),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_PLUS_TILDE] = ACTIONS(869),
    [anon_sym_STAR_TILDE] = ACTIONS(869),
    [anon_sym_SLASH_TILDE] = ACTIONS(869),
    [anon_sym_PERCENT_TILDE] = ACTIONS(869),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(869),
    [anon_sym_LT_LT_TILDE] = ACTIONS(869),
    [anon_sym_GT_GT_TILDE] = ACTIONS(869),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(869),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(869),
    [anon_sym_GT_TILDE] = ACTIONS(869),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(869),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(869),
    [anon_sym_LT_TILDE] = ACTIONS(869),
    [anon_sym_PLUS_QMARK] = ACTIONS(869),
    [anon_sym_DASH_QMARK] = ACTIONS(869),
    [anon_sym_STAR_QMARK] = ACTIONS(869),
    [anon_sym_SLASH_QMARK] = ACTIONS(869),
    [anon_sym_PERCENT_QMARK] = ACTIONS(869),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(869),
    [anon_sym_as] = ACTIONS(869),
    [anon_sym_LPAREN2] = ACTIONS(869),
    [anon_sym_DOT_GT] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [anon_sym_end] = ACTIONS(869),
    [anon_sym_if] = ACTIONS(871),
    [anon_sym_ifdef] = ACTIONS(869),
    [anon_sym_elseif] = ACTIONS(869),
    [anon_sym_iftype] = ACTIONS(869),
    [anon_sym_else] = ACTIONS(871),
    [anon_sym_for] = ACTIONS(869),
    [anon_sym_while] = ACTIONS(869),
    [anon_sym_try] = ACTIONS(869),
    [anon_sym_with] = ACTIONS(869),
    [anon_sym_repeat] = ACTIONS(869),
    [anon_sym_recover] = ACTIONS(869),
    [anon_sym_match] = ACTIONS(869),
    [anon_sym_return] = ACTIONS(869),
    [anon_sym_continue] = ACTIONS(869),
    [anon_sym_break] = ACTIONS(869),
    [anon_sym_consume] = ACTIONS(869),
    [anon_sym_object] = ACTIONS(869),
    [sym_number] = ACTIONS(871),
    [sym_float] = ACTIONS(869),
    [anon_sym_DQUOTE] = ACTIONS(871),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(869),
    [anon_sym_SQUOTE] = ACTIONS(869),
    [anon_sym_true] = ACTIONS(869),
    [anon_sym_false] = ACTIONS(869),
    [sym_this] = ACTIONS(869),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [448] = {
    [sym_identifier] = ACTIONS(909),
    [anon_sym_EQ] = ACTIONS(909),
    [anon_sym_AT] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(907),
    [anon_sym_is] = ACTIONS(909),
    [anon_sym_let] = ACTIONS(907),
    [anon_sym_var] = ACTIONS(907),
    [anon_sym_LPAREN] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(909),
    [anon_sym_BANG] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(907),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_DASH_GT] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(907),
    [sym_error] = ACTIONS(907),
    [sym_compile_intrinsic] = ACTIONS(907),
    [anon_sym_compile_error] = ACTIONS(907),
    [sym_location] = ACTIONS(907),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_not] = ACTIONS(907),
    [anon_sym_DASH_TILDE] = ACTIONS(907),
    [anon_sym_addressof] = ACTIONS(907),
    [anon_sym_digestof] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_STAR] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_and] = ACTIONS(907),
    [anon_sym_or] = ACTIONS(907),
    [anon_sym_xor] = ACTIONS(907),
    [anon_sym_isnt] = ACTIONS(907),
    [anon_sym_EQ_EQ] = ACTIONS(909),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_GT] = ACTIONS(909),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(909),
    [anon_sym_PLUS_TILDE] = ACTIONS(907),
    [anon_sym_STAR_TILDE] = ACTIONS(907),
    [anon_sym_SLASH_TILDE] = ACTIONS(907),
    [anon_sym_PERCENT_TILDE] = ACTIONS(907),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(907),
    [anon_sym_LT_LT_TILDE] = ACTIONS(907),
    [anon_sym_GT_GT_TILDE] = ACTIONS(907),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(907),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(907),
    [anon_sym_GT_TILDE] = ACTIONS(907),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(907),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(907),
    [anon_sym_LT_TILDE] = ACTIONS(907),
    [anon_sym_PLUS_QMARK] = ACTIONS(907),
    [anon_sym_DASH_QMARK] = ACTIONS(907),
    [anon_sym_STAR_QMARK] = ACTIONS(907),
    [anon_sym_SLASH_QMARK] = ACTIONS(907),
    [anon_sym_PERCENT_QMARK] = ACTIONS(907),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(907),
    [anon_sym_as] = ACTIONS(907),
    [anon_sym_LPAREN2] = ACTIONS(907),
    [anon_sym_DOT_GT] = ACTIONS(907),
    [anon_sym_TILDE] = ACTIONS(907),
    [anon_sym_end] = ACTIONS(907),
    [anon_sym_if] = ACTIONS(909),
    [anon_sym_ifdef] = ACTIONS(907),
    [anon_sym_elseif] = ACTIONS(907),
    [anon_sym_iftype] = ACTIONS(907),
    [anon_sym_else] = ACTIONS(909),
    [anon_sym_for] = ACTIONS(907),
    [anon_sym_while] = ACTIONS(907),
    [anon_sym_try] = ACTIONS(907),
    [anon_sym_with] = ACTIONS(907),
    [anon_sym_repeat] = ACTIONS(907),
    [anon_sym_recover] = ACTIONS(907),
    [anon_sym_match] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(907),
    [anon_sym_continue] = ACTIONS(907),
    [anon_sym_break] = ACTIONS(907),
    [anon_sym_consume] = ACTIONS(907),
    [anon_sym_object] = ACTIONS(907),
    [sym_number] = ACTIONS(909),
    [sym_float] = ACTIONS(907),
    [anon_sym_DQUOTE] = ACTIONS(909),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(907),
    [anon_sym_SQUOTE] = ACTIONS(907),
    [anon_sym_true] = ACTIONS(907),
    [anon_sym_false] = ACTIONS(907),
    [sym_this] = ACTIONS(907),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [449] = {
    [sym_identifier] = ACTIONS(917),
    [anon_sym_EQ] = ACTIONS(917),
    [anon_sym_AT] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(915),
    [anon_sym_is] = ACTIONS(917),
    [anon_sym_let] = ACTIONS(915),
    [anon_sym_var] = ACTIONS(915),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_DOT] = ACTIONS(917),
    [anon_sym_BANG] = ACTIONS(917),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_AMP] = ACTIONS(915),
    [anon_sym_DASH_GT] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_SEMI] = ACTIONS(915),
    [sym_error] = ACTIONS(915),
    [sym_compile_intrinsic] = ACTIONS(915),
    [anon_sym_compile_error] = ACTIONS(915),
    [sym_location] = ACTIONS(915),
    [anon_sym_DASH] = ACTIONS(917),
    [anon_sym_not] = ACTIONS(915),
    [anon_sym_DASH_TILDE] = ACTIONS(915),
    [anon_sym_addressof] = ACTIONS(915),
    [anon_sym_digestof] = ACTIONS(915),
    [anon_sym_PLUS] = ACTIONS(917),
    [anon_sym_STAR] = ACTIONS(917),
    [anon_sym_SLASH] = ACTIONS(917),
    [anon_sym_PERCENT] = ACTIONS(917),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(917),
    [anon_sym_LT_LT] = ACTIONS(917),
    [anon_sym_GT_GT] = ACTIONS(917),
    [anon_sym_and] = ACTIONS(915),
    [anon_sym_or] = ACTIONS(915),
    [anon_sym_xor] = ACTIONS(915),
    [anon_sym_isnt] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_GT] = ACTIONS(917),
    [anon_sym_GT_EQ] = ACTIONS(917),
    [anon_sym_LT_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(917),
    [anon_sym_PLUS_TILDE] = ACTIONS(915),
    [anon_sym_STAR_TILDE] = ACTIONS(915),
    [anon_sym_SLASH_TILDE] = ACTIONS(915),
    [anon_sym_PERCENT_TILDE] = ACTIONS(915),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(915),
    [anon_sym_LT_LT_TILDE] = ACTIONS(915),
    [anon_sym_GT_GT_TILDE] = ACTIONS(915),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(915),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(915),
    [anon_sym_GT_TILDE] = ACTIONS(915),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(915),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(915),
    [anon_sym_LT_TILDE] = ACTIONS(915),
    [anon_sym_PLUS_QMARK] = ACTIONS(915),
    [anon_sym_DASH_QMARK] = ACTIONS(915),
    [anon_sym_STAR_QMARK] = ACTIONS(915),
    [anon_sym_SLASH_QMARK] = ACTIONS(915),
    [anon_sym_PERCENT_QMARK] = ACTIONS(915),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(915),
    [anon_sym_as] = ACTIONS(915),
    [anon_sym_LPAREN2] = ACTIONS(915),
    [anon_sym_DOT_GT] = ACTIONS(915),
    [anon_sym_TILDE] = ACTIONS(915),
    [anon_sym_end] = ACTIONS(915),
    [anon_sym_if] = ACTIONS(917),
    [anon_sym_ifdef] = ACTIONS(915),
    [anon_sym_elseif] = ACTIONS(915),
    [anon_sym_iftype] = ACTIONS(915),
    [anon_sym_else] = ACTIONS(917),
    [anon_sym_for] = ACTIONS(915),
    [anon_sym_while] = ACTIONS(915),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_with] = ACTIONS(915),
    [anon_sym_repeat] = ACTIONS(915),
    [anon_sym_recover] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(915),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_continue] = ACTIONS(915),
    [anon_sym_break] = ACTIONS(915),
    [anon_sym_consume] = ACTIONS(915),
    [anon_sym_object] = ACTIONS(915),
    [sym_number] = ACTIONS(917),
    [sym_float] = ACTIONS(915),
    [anon_sym_DQUOTE] = ACTIONS(917),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(915),
    [anon_sym_SQUOTE] = ACTIONS(915),
    [anon_sym_true] = ACTIONS(915),
    [anon_sym_false] = ACTIONS(915),
    [sym_this] = ACTIONS(915),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [450] = {
    [sym_expression] = STATE(418),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [aux_sym_block_repeat1] = STATE(467),
    [ts_builtin_sym_end] = ACTIONS(165),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_use] = ACTIONS(165),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_type] = ACTIONS(165),
    [anon_sym_actor] = ACTIONS(165),
    [anon_sym_class] = ACTIONS(165),
    [anon_sym_primitive] = ACTIONS(165),
    [anon_sym_interface] = ACTIONS(165),
    [anon_sym_trait] = ACTIONS(165),
    [anon_sym_struct] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_new] = ACTIONS(165),
    [anon_sym_fun] = ACTIONS(165),
    [anon_sym_be] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [451] = {
    [sym_identifier] = ACTIONS(933),
    [anon_sym_EQ] = ACTIONS(933),
    [anon_sym_AT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(931),
    [anon_sym_is] = ACTIONS(933),
    [anon_sym_let] = ACTIONS(931),
    [anon_sym_var] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(933),
    [anon_sym_DOT] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_CARET] = ACTIONS(931),
    [anon_sym_PIPE] = ACTIONS(931),
    [anon_sym_AMP] = ACTIONS(931),
    [anon_sym_DASH_GT] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(931),
    [anon_sym_SEMI] = ACTIONS(931),
    [sym_error] = ACTIONS(931),
    [sym_compile_intrinsic] = ACTIONS(931),
    [anon_sym_compile_error] = ACTIONS(931),
    [sym_location] = ACTIONS(931),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_not] = ACTIONS(931),
    [anon_sym_DASH_TILDE] = ACTIONS(931),
    [anon_sym_addressof] = ACTIONS(931),
    [anon_sym_digestof] = ACTIONS(931),
    [anon_sym_PLUS] = ACTIONS(933),
    [anon_sym_STAR] = ACTIONS(933),
    [anon_sym_SLASH] = ACTIONS(933),
    [anon_sym_PERCENT] = ACTIONS(933),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(933),
    [anon_sym_LT_LT] = ACTIONS(933),
    [anon_sym_GT_GT] = ACTIONS(933),
    [anon_sym_and] = ACTIONS(931),
    [anon_sym_or] = ACTIONS(931),
    [anon_sym_xor] = ACTIONS(931),
    [anon_sym_isnt] = ACTIONS(931),
    [anon_sym_EQ_EQ] = ACTIONS(933),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_GT] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_LT] = ACTIONS(933),
    [anon_sym_PLUS_TILDE] = ACTIONS(931),
    [anon_sym_STAR_TILDE] = ACTIONS(931),
    [anon_sym_SLASH_TILDE] = ACTIONS(931),
    [anon_sym_PERCENT_TILDE] = ACTIONS(931),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(931),
    [anon_sym_LT_LT_TILDE] = ACTIONS(931),
    [anon_sym_GT_GT_TILDE] = ACTIONS(931),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(931),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(931),
    [anon_sym_GT_TILDE] = ACTIONS(931),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(931),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(931),
    [anon_sym_LT_TILDE] = ACTIONS(931),
    [anon_sym_PLUS_QMARK] = ACTIONS(931),
    [anon_sym_DASH_QMARK] = ACTIONS(931),
    [anon_sym_STAR_QMARK] = ACTIONS(931),
    [anon_sym_SLASH_QMARK] = ACTIONS(931),
    [anon_sym_PERCENT_QMARK] = ACTIONS(931),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(931),
    [anon_sym_as] = ACTIONS(931),
    [anon_sym_LPAREN2] = ACTIONS(931),
    [anon_sym_DOT_GT] = ACTIONS(931),
    [anon_sym_TILDE] = ACTIONS(931),
    [anon_sym_end] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(933),
    [anon_sym_ifdef] = ACTIONS(931),
    [anon_sym_elseif] = ACTIONS(931),
    [anon_sym_iftype] = ACTIONS(931),
    [anon_sym_else] = ACTIONS(933),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_try] = ACTIONS(931),
    [anon_sym_with] = ACTIONS(931),
    [anon_sym_repeat] = ACTIONS(931),
    [anon_sym_recover] = ACTIONS(931),
    [anon_sym_match] = ACTIONS(931),
    [anon_sym_return] = ACTIONS(931),
    [anon_sym_continue] = ACTIONS(931),
    [anon_sym_break] = ACTIONS(931),
    [anon_sym_consume] = ACTIONS(931),
    [anon_sym_object] = ACTIONS(931),
    [sym_number] = ACTIONS(933),
    [sym_float] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(933),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(931),
    [anon_sym_SQUOTE] = ACTIONS(931),
    [anon_sym_true] = ACTIONS(931),
    [anon_sym_false] = ACTIONS(931),
    [sym_this] = ACTIONS(931),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [452] = {
    [sym_identifier] = ACTIONS(965),
    [anon_sym_EQ] = ACTIONS(965),
    [anon_sym_AT] = ACTIONS(963),
    [anon_sym_LBRACK] = ACTIONS(963),
    [anon_sym_is] = ACTIONS(965),
    [anon_sym_let] = ACTIONS(963),
    [anon_sym_var] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(965),
    [anon_sym_DOT] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(965),
    [anon_sym_CARET] = ACTIONS(963),
    [anon_sym_PIPE] = ACTIONS(963),
    [anon_sym_AMP] = ACTIONS(963),
    [anon_sym_DASH_GT] = ACTIONS(963),
    [anon_sym_LBRACE] = ACTIONS(963),
    [anon_sym_SEMI] = ACTIONS(963),
    [sym_error] = ACTIONS(963),
    [sym_compile_intrinsic] = ACTIONS(963),
    [anon_sym_compile_error] = ACTIONS(963),
    [sym_location] = ACTIONS(963),
    [anon_sym_DASH] = ACTIONS(965),
    [anon_sym_not] = ACTIONS(963),
    [anon_sym_DASH_TILDE] = ACTIONS(963),
    [anon_sym_addressof] = ACTIONS(963),
    [anon_sym_digestof] = ACTIONS(963),
    [anon_sym_PLUS] = ACTIONS(965),
    [anon_sym_STAR] = ACTIONS(965),
    [anon_sym_SLASH] = ACTIONS(965),
    [anon_sym_PERCENT] = ACTIONS(965),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(965),
    [anon_sym_LT_LT] = ACTIONS(965),
    [anon_sym_GT_GT] = ACTIONS(965),
    [anon_sym_and] = ACTIONS(963),
    [anon_sym_or] = ACTIONS(963),
    [anon_sym_xor] = ACTIONS(963),
    [anon_sym_isnt] = ACTIONS(963),
    [anon_sym_EQ_EQ] = ACTIONS(965),
    [anon_sym_BANG_EQ] = ACTIONS(965),
    [anon_sym_GT] = ACTIONS(965),
    [anon_sym_GT_EQ] = ACTIONS(965),
    [anon_sym_LT_EQ] = ACTIONS(965),
    [anon_sym_LT] = ACTIONS(965),
    [anon_sym_PLUS_TILDE] = ACTIONS(963),
    [anon_sym_STAR_TILDE] = ACTIONS(963),
    [anon_sym_SLASH_TILDE] = ACTIONS(963),
    [anon_sym_PERCENT_TILDE] = ACTIONS(963),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(963),
    [anon_sym_LT_LT_TILDE] = ACTIONS(963),
    [anon_sym_GT_GT_TILDE] = ACTIONS(963),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(963),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(963),
    [anon_sym_GT_TILDE] = ACTIONS(963),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(963),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(963),
    [anon_sym_LT_TILDE] = ACTIONS(963),
    [anon_sym_PLUS_QMARK] = ACTIONS(963),
    [anon_sym_DASH_QMARK] = ACTIONS(963),
    [anon_sym_STAR_QMARK] = ACTIONS(963),
    [anon_sym_SLASH_QMARK] = ACTIONS(963),
    [anon_sym_PERCENT_QMARK] = ACTIONS(963),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(963),
    [anon_sym_as] = ACTIONS(963),
    [anon_sym_LPAREN2] = ACTIONS(963),
    [anon_sym_DOT_GT] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [anon_sym_end] = ACTIONS(963),
    [anon_sym_if] = ACTIONS(965),
    [anon_sym_ifdef] = ACTIONS(963),
    [anon_sym_elseif] = ACTIONS(963),
    [anon_sym_iftype] = ACTIONS(963),
    [anon_sym_else] = ACTIONS(965),
    [anon_sym_for] = ACTIONS(963),
    [anon_sym_while] = ACTIONS(963),
    [anon_sym_try] = ACTIONS(963),
    [anon_sym_with] = ACTIONS(963),
    [anon_sym_repeat] = ACTIONS(963),
    [anon_sym_recover] = ACTIONS(963),
    [anon_sym_match] = ACTIONS(963),
    [anon_sym_return] = ACTIONS(963),
    [anon_sym_continue] = ACTIONS(963),
    [anon_sym_break] = ACTIONS(963),
    [anon_sym_consume] = ACTIONS(963),
    [anon_sym_object] = ACTIONS(963),
    [sym_number] = ACTIONS(965),
    [sym_float] = ACTIONS(963),
    [anon_sym_DQUOTE] = ACTIONS(965),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(963),
    [anon_sym_SQUOTE] = ACTIONS(963),
    [anon_sym_true] = ACTIONS(963),
    [anon_sym_false] = ACTIONS(963),
    [sym_this] = ACTIONS(963),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [453] = {
    [sym_identifier] = ACTIONS(953),
    [anon_sym_EQ] = ACTIONS(953),
    [anon_sym_AT] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(951),
    [anon_sym_is] = ACTIONS(953),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_var] = ACTIONS(951),
    [anon_sym_LPAREN] = ACTIONS(953),
    [anon_sym_DOT] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_CARET] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(951),
    [anon_sym_AMP] = ACTIONS(951),
    [anon_sym_DASH_GT] = ACTIONS(951),
    [anon_sym_LBRACE] = ACTIONS(951),
    [anon_sym_SEMI] = ACTIONS(951),
    [sym_error] = ACTIONS(951),
    [sym_compile_intrinsic] = ACTIONS(951),
    [anon_sym_compile_error] = ACTIONS(951),
    [sym_location] = ACTIONS(951),
    [anon_sym_DASH] = ACTIONS(953),
    [anon_sym_not] = ACTIONS(951),
    [anon_sym_DASH_TILDE] = ACTIONS(951),
    [anon_sym_addressof] = ACTIONS(951),
    [anon_sym_digestof] = ACTIONS(951),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_STAR] = ACTIONS(953),
    [anon_sym_SLASH] = ACTIONS(953),
    [anon_sym_PERCENT] = ACTIONS(953),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(953),
    [anon_sym_LT_LT] = ACTIONS(953),
    [anon_sym_GT_GT] = ACTIONS(953),
    [anon_sym_and] = ACTIONS(951),
    [anon_sym_or] = ACTIONS(951),
    [anon_sym_xor] = ACTIONS(951),
    [anon_sym_isnt] = ACTIONS(951),
    [anon_sym_EQ_EQ] = ACTIONS(953),
    [anon_sym_BANG_EQ] = ACTIONS(953),
    [anon_sym_GT] = ACTIONS(953),
    [anon_sym_GT_EQ] = ACTIONS(953),
    [anon_sym_LT_EQ] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(953),
    [anon_sym_PLUS_TILDE] = ACTIONS(951),
    [anon_sym_STAR_TILDE] = ACTIONS(951),
    [anon_sym_SLASH_TILDE] = ACTIONS(951),
    [anon_sym_PERCENT_TILDE] = ACTIONS(951),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(951),
    [anon_sym_LT_LT_TILDE] = ACTIONS(951),
    [anon_sym_GT_GT_TILDE] = ACTIONS(951),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(951),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(951),
    [anon_sym_GT_TILDE] = ACTIONS(951),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(951),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(951),
    [anon_sym_LT_TILDE] = ACTIONS(951),
    [anon_sym_PLUS_QMARK] = ACTIONS(951),
    [anon_sym_DASH_QMARK] = ACTIONS(951),
    [anon_sym_STAR_QMARK] = ACTIONS(951),
    [anon_sym_SLASH_QMARK] = ACTIONS(951),
    [anon_sym_PERCENT_QMARK] = ACTIONS(951),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(951),
    [anon_sym_as] = ACTIONS(951),
    [anon_sym_LPAREN2] = ACTIONS(951),
    [anon_sym_DOT_GT] = ACTIONS(951),
    [anon_sym_TILDE] = ACTIONS(951),
    [anon_sym_end] = ACTIONS(951),
    [anon_sym_if] = ACTIONS(953),
    [anon_sym_ifdef] = ACTIONS(951),
    [anon_sym_elseif] = ACTIONS(951),
    [anon_sym_iftype] = ACTIONS(951),
    [anon_sym_else] = ACTIONS(953),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(951),
    [anon_sym_try] = ACTIONS(951),
    [anon_sym_with] = ACTIONS(951),
    [anon_sym_repeat] = ACTIONS(951),
    [anon_sym_recover] = ACTIONS(951),
    [anon_sym_match] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(951),
    [anon_sym_continue] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(951),
    [anon_sym_consume] = ACTIONS(951),
    [anon_sym_object] = ACTIONS(951),
    [sym_number] = ACTIONS(953),
    [sym_float] = ACTIONS(951),
    [anon_sym_DQUOTE] = ACTIONS(953),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [anon_sym_SQUOTE] = ACTIONS(951),
    [anon_sym_true] = ACTIONS(951),
    [anon_sym_false] = ACTIONS(951),
    [sym_this] = ACTIONS(951),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [454] = {
    [sym_identifier] = ACTIONS(945),
    [anon_sym_EQ] = ACTIONS(945),
    [anon_sym_AT] = ACTIONS(943),
    [anon_sym_LBRACK] = ACTIONS(943),
    [anon_sym_is] = ACTIONS(945),
    [anon_sym_let] = ACTIONS(943),
    [anon_sym_var] = ACTIONS(943),
    [anon_sym_LPAREN] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_BANG] = ACTIONS(945),
    [anon_sym_CARET] = ACTIONS(943),
    [anon_sym_PIPE] = ACTIONS(943),
    [anon_sym_AMP] = ACTIONS(943),
    [anon_sym_DASH_GT] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(943),
    [anon_sym_SEMI] = ACTIONS(943),
    [sym_error] = ACTIONS(943),
    [sym_compile_intrinsic] = ACTIONS(943),
    [anon_sym_compile_error] = ACTIONS(943),
    [sym_location] = ACTIONS(943),
    [anon_sym_DASH] = ACTIONS(945),
    [anon_sym_not] = ACTIONS(943),
    [anon_sym_DASH_TILDE] = ACTIONS(943),
    [anon_sym_addressof] = ACTIONS(943),
    [anon_sym_digestof] = ACTIONS(943),
    [anon_sym_PLUS] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(945),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_PERCENT] = ACTIONS(945),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(945),
    [anon_sym_LT_LT] = ACTIONS(945),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_and] = ACTIONS(943),
    [anon_sym_or] = ACTIONS(943),
    [anon_sym_xor] = ACTIONS(943),
    [anon_sym_isnt] = ACTIONS(943),
    [anon_sym_EQ_EQ] = ACTIONS(945),
    [anon_sym_BANG_EQ] = ACTIONS(945),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_GT_EQ] = ACTIONS(945),
    [anon_sym_LT_EQ] = ACTIONS(945),
    [anon_sym_LT] = ACTIONS(945),
    [anon_sym_PLUS_TILDE] = ACTIONS(943),
    [anon_sym_STAR_TILDE] = ACTIONS(943),
    [anon_sym_SLASH_TILDE] = ACTIONS(943),
    [anon_sym_PERCENT_TILDE] = ACTIONS(943),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(943),
    [anon_sym_LT_LT_TILDE] = ACTIONS(943),
    [anon_sym_GT_GT_TILDE] = ACTIONS(943),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(943),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(943),
    [anon_sym_GT_TILDE] = ACTIONS(943),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(943),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(943),
    [anon_sym_LT_TILDE] = ACTIONS(943),
    [anon_sym_PLUS_QMARK] = ACTIONS(943),
    [anon_sym_DASH_QMARK] = ACTIONS(943),
    [anon_sym_STAR_QMARK] = ACTIONS(943),
    [anon_sym_SLASH_QMARK] = ACTIONS(943),
    [anon_sym_PERCENT_QMARK] = ACTIONS(943),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(943),
    [anon_sym_as] = ACTIONS(943),
    [anon_sym_LPAREN2] = ACTIONS(943),
    [anon_sym_DOT_GT] = ACTIONS(943),
    [anon_sym_TILDE] = ACTIONS(943),
    [anon_sym_end] = ACTIONS(943),
    [anon_sym_if] = ACTIONS(945),
    [anon_sym_ifdef] = ACTIONS(943),
    [anon_sym_elseif] = ACTIONS(943),
    [anon_sym_iftype] = ACTIONS(943),
    [anon_sym_else] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(943),
    [anon_sym_while] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_with] = ACTIONS(943),
    [anon_sym_repeat] = ACTIONS(943),
    [anon_sym_recover] = ACTIONS(943),
    [anon_sym_match] = ACTIONS(943),
    [anon_sym_return] = ACTIONS(943),
    [anon_sym_continue] = ACTIONS(943),
    [anon_sym_break] = ACTIONS(943),
    [anon_sym_consume] = ACTIONS(943),
    [anon_sym_object] = ACTIONS(943),
    [sym_number] = ACTIONS(945),
    [sym_float] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_true] = ACTIONS(943),
    [anon_sym_false] = ACTIONS(943),
    [sym_this] = ACTIONS(943),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [455] = {
    [sym_identifier] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_is] = ACTIONS(925),
    [anon_sym_let] = ACTIONS(923),
    [anon_sym_var] = ACTIONS(923),
    [anon_sym_LPAREN] = ACTIONS(925),
    [anon_sym_DOT] = ACTIONS(925),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_CARET] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_AMP] = ACTIONS(923),
    [anon_sym_DASH_GT] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_SEMI] = ACTIONS(923),
    [sym_error] = ACTIONS(923),
    [sym_compile_intrinsic] = ACTIONS(923),
    [anon_sym_compile_error] = ACTIONS(923),
    [sym_location] = ACTIONS(923),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_not] = ACTIONS(923),
    [anon_sym_DASH_TILDE] = ACTIONS(923),
    [anon_sym_addressof] = ACTIONS(923),
    [anon_sym_digestof] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_STAR] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(925),
    [anon_sym_PERCENT] = ACTIONS(925),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(925),
    [anon_sym_LT_LT] = ACTIONS(925),
    [anon_sym_GT_GT] = ACTIONS(925),
    [anon_sym_and] = ACTIONS(923),
    [anon_sym_or] = ACTIONS(923),
    [anon_sym_xor] = ACTIONS(923),
    [anon_sym_isnt] = ACTIONS(923),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_BANG_EQ] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(925),
    [anon_sym_GT_EQ] = ACTIONS(925),
    [anon_sym_LT_EQ] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_PLUS_TILDE] = ACTIONS(923),
    [anon_sym_STAR_TILDE] = ACTIONS(923),
    [anon_sym_SLASH_TILDE] = ACTIONS(923),
    [anon_sym_PERCENT_TILDE] = ACTIONS(923),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(923),
    [anon_sym_LT_LT_TILDE] = ACTIONS(923),
    [anon_sym_GT_GT_TILDE] = ACTIONS(923),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(923),
    [anon_sym_GT_TILDE] = ACTIONS(923),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(923),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(923),
    [anon_sym_LT_TILDE] = ACTIONS(923),
    [anon_sym_PLUS_QMARK] = ACTIONS(923),
    [anon_sym_DASH_QMARK] = ACTIONS(923),
    [anon_sym_STAR_QMARK] = ACTIONS(923),
    [anon_sym_SLASH_QMARK] = ACTIONS(923),
    [anon_sym_PERCENT_QMARK] = ACTIONS(923),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(923),
    [anon_sym_as] = ACTIONS(923),
    [anon_sym_LPAREN2] = ACTIONS(923),
    [anon_sym_DOT_GT] = ACTIONS(923),
    [anon_sym_TILDE] = ACTIONS(923),
    [anon_sym_end] = ACTIONS(923),
    [anon_sym_if] = ACTIONS(925),
    [anon_sym_ifdef] = ACTIONS(923),
    [anon_sym_elseif] = ACTIONS(923),
    [anon_sym_iftype] = ACTIONS(923),
    [anon_sym_else] = ACTIONS(925),
    [anon_sym_for] = ACTIONS(923),
    [anon_sym_while] = ACTIONS(923),
    [anon_sym_try] = ACTIONS(923),
    [anon_sym_with] = ACTIONS(923),
    [anon_sym_repeat] = ACTIONS(923),
    [anon_sym_recover] = ACTIONS(923),
    [anon_sym_match] = ACTIONS(923),
    [anon_sym_return] = ACTIONS(923),
    [anon_sym_continue] = ACTIONS(923),
    [anon_sym_break] = ACTIONS(923),
    [anon_sym_consume] = ACTIONS(923),
    [anon_sym_object] = ACTIONS(923),
    [sym_number] = ACTIONS(925),
    [sym_float] = ACTIONS(923),
    [anon_sym_DQUOTE] = ACTIONS(925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(923),
    [anon_sym_SQUOTE] = ACTIONS(923),
    [anon_sym_true] = ACTIONS(923),
    [anon_sym_false] = ACTIONS(923),
    [sym_this] = ACTIONS(923),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [456] = {
    [sym_expression] = STATE(379),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_block_repeat1] = STATE(469),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_RBRACK] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_new] = ACTIONS(165),
    [anon_sym_EQ_GT] = ACTIONS(165),
    [anon_sym_fun] = ACTIONS(165),
    [anon_sym_be] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_RBRACE] = ACTIONS(165),
    [anon_sym_SEMI] = ACTIONS(345),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_end] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_then] = ACTIONS(165),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_else] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_until] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(165),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [457] = {
    [sym_identifier] = ACTIONS(961),
    [anon_sym_EQ] = ACTIONS(961),
    [anon_sym_AT] = ACTIONS(959),
    [anon_sym_LBRACK] = ACTIONS(959),
    [anon_sym_is] = ACTIONS(961),
    [anon_sym_let] = ACTIONS(959),
    [anon_sym_var] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_DOT] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_CARET] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_AMP] = ACTIONS(959),
    [anon_sym_DASH_GT] = ACTIONS(959),
    [anon_sym_LBRACE] = ACTIONS(959),
    [anon_sym_SEMI] = ACTIONS(959),
    [sym_error] = ACTIONS(959),
    [sym_compile_intrinsic] = ACTIONS(959),
    [anon_sym_compile_error] = ACTIONS(959),
    [sym_location] = ACTIONS(959),
    [anon_sym_DASH] = ACTIONS(961),
    [anon_sym_not] = ACTIONS(959),
    [anon_sym_DASH_TILDE] = ACTIONS(959),
    [anon_sym_addressof] = ACTIONS(959),
    [anon_sym_digestof] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_STAR] = ACTIONS(961),
    [anon_sym_SLASH] = ACTIONS(961),
    [anon_sym_PERCENT] = ACTIONS(961),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(961),
    [anon_sym_LT_LT] = ACTIONS(961),
    [anon_sym_GT_GT] = ACTIONS(961),
    [anon_sym_and] = ACTIONS(959),
    [anon_sym_or] = ACTIONS(959),
    [anon_sym_xor] = ACTIONS(959),
    [anon_sym_isnt] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(961),
    [anon_sym_BANG_EQ] = ACTIONS(961),
    [anon_sym_GT] = ACTIONS(961),
    [anon_sym_GT_EQ] = ACTIONS(961),
    [anon_sym_LT_EQ] = ACTIONS(961),
    [anon_sym_LT] = ACTIONS(961),
    [anon_sym_PLUS_TILDE] = ACTIONS(959),
    [anon_sym_STAR_TILDE] = ACTIONS(959),
    [anon_sym_SLASH_TILDE] = ACTIONS(959),
    [anon_sym_PERCENT_TILDE] = ACTIONS(959),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(959),
    [anon_sym_LT_LT_TILDE] = ACTIONS(959),
    [anon_sym_GT_GT_TILDE] = ACTIONS(959),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(959),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(959),
    [anon_sym_GT_TILDE] = ACTIONS(959),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(959),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(959),
    [anon_sym_LT_TILDE] = ACTIONS(959),
    [anon_sym_PLUS_QMARK] = ACTIONS(959),
    [anon_sym_DASH_QMARK] = ACTIONS(959),
    [anon_sym_STAR_QMARK] = ACTIONS(959),
    [anon_sym_SLASH_QMARK] = ACTIONS(959),
    [anon_sym_PERCENT_QMARK] = ACTIONS(959),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(959),
    [anon_sym_as] = ACTIONS(959),
    [anon_sym_LPAREN2] = ACTIONS(959),
    [anon_sym_DOT_GT] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_end] = ACTIONS(959),
    [anon_sym_if] = ACTIONS(961),
    [anon_sym_ifdef] = ACTIONS(959),
    [anon_sym_elseif] = ACTIONS(959),
    [anon_sym_iftype] = ACTIONS(959),
    [anon_sym_else] = ACTIONS(961),
    [anon_sym_for] = ACTIONS(959),
    [anon_sym_while] = ACTIONS(959),
    [anon_sym_try] = ACTIONS(959),
    [anon_sym_with] = ACTIONS(959),
    [anon_sym_repeat] = ACTIONS(959),
    [anon_sym_recover] = ACTIONS(959),
    [anon_sym_match] = ACTIONS(959),
    [anon_sym_return] = ACTIONS(959),
    [anon_sym_continue] = ACTIONS(959),
    [anon_sym_break] = ACTIONS(959),
    [anon_sym_consume] = ACTIONS(959),
    [anon_sym_object] = ACTIONS(959),
    [sym_number] = ACTIONS(961),
    [sym_float] = ACTIONS(959),
    [anon_sym_DQUOTE] = ACTIONS(961),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(959),
    [anon_sym_SQUOTE] = ACTIONS(959),
    [anon_sym_true] = ACTIONS(959),
    [anon_sym_false] = ACTIONS(959),
    [sym_this] = ACTIONS(959),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [458] = {
    [sym_identifier] = ACTIONS(905),
    [anon_sym_EQ] = ACTIONS(905),
    [anon_sym_AT] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(903),
    [anon_sym_is] = ACTIONS(905),
    [anon_sym_let] = ACTIONS(903),
    [anon_sym_var] = ACTIONS(903),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_DOT] = ACTIONS(905),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_CARET] = ACTIONS(903),
    [anon_sym_PIPE] = ACTIONS(903),
    [anon_sym_AMP] = ACTIONS(903),
    [anon_sym_DASH_GT] = ACTIONS(903),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_SEMI] = ACTIONS(903),
    [sym_error] = ACTIONS(903),
    [sym_compile_intrinsic] = ACTIONS(903),
    [anon_sym_compile_error] = ACTIONS(903),
    [sym_location] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_not] = ACTIONS(903),
    [anon_sym_DASH_TILDE] = ACTIONS(903),
    [anon_sym_addressof] = ACTIONS(903),
    [anon_sym_digestof] = ACTIONS(903),
    [anon_sym_PLUS] = ACTIONS(905),
    [anon_sym_STAR] = ACTIONS(905),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_PERCENT] = ACTIONS(905),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(905),
    [anon_sym_LT_LT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(905),
    [anon_sym_and] = ACTIONS(903),
    [anon_sym_or] = ACTIONS(903),
    [anon_sym_xor] = ACTIONS(903),
    [anon_sym_isnt] = ACTIONS(903),
    [anon_sym_EQ_EQ] = ACTIONS(905),
    [anon_sym_BANG_EQ] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_EQ] = ACTIONS(905),
    [anon_sym_LT_EQ] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_PLUS_TILDE] = ACTIONS(903),
    [anon_sym_STAR_TILDE] = ACTIONS(903),
    [anon_sym_SLASH_TILDE] = ACTIONS(903),
    [anon_sym_PERCENT_TILDE] = ACTIONS(903),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(903),
    [anon_sym_LT_LT_TILDE] = ACTIONS(903),
    [anon_sym_GT_GT_TILDE] = ACTIONS(903),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(903),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(903),
    [anon_sym_GT_TILDE] = ACTIONS(903),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(903),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(903),
    [anon_sym_LT_TILDE] = ACTIONS(903),
    [anon_sym_PLUS_QMARK] = ACTIONS(903),
    [anon_sym_DASH_QMARK] = ACTIONS(903),
    [anon_sym_STAR_QMARK] = ACTIONS(903),
    [anon_sym_SLASH_QMARK] = ACTIONS(903),
    [anon_sym_PERCENT_QMARK] = ACTIONS(903),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(903),
    [anon_sym_as] = ACTIONS(903),
    [anon_sym_LPAREN2] = ACTIONS(903),
    [anon_sym_DOT_GT] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(903),
    [anon_sym_end] = ACTIONS(903),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_ifdef] = ACTIONS(903),
    [anon_sym_elseif] = ACTIONS(903),
    [anon_sym_iftype] = ACTIONS(903),
    [anon_sym_else] = ACTIONS(905),
    [anon_sym_for] = ACTIONS(903),
    [anon_sym_while] = ACTIONS(903),
    [anon_sym_try] = ACTIONS(903),
    [anon_sym_with] = ACTIONS(903),
    [anon_sym_repeat] = ACTIONS(903),
    [anon_sym_recover] = ACTIONS(903),
    [anon_sym_match] = ACTIONS(903),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_continue] = ACTIONS(903),
    [anon_sym_break] = ACTIONS(903),
    [anon_sym_consume] = ACTIONS(903),
    [anon_sym_object] = ACTIONS(903),
    [sym_number] = ACTIONS(905),
    [sym_float] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(903),
    [anon_sym_SQUOTE] = ACTIONS(903),
    [anon_sym_true] = ACTIONS(903),
    [anon_sym_false] = ACTIONS(903),
    [sym_this] = ACTIONS(903),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [459] = {
    [sym_identifier] = ACTIONS(680),
    [anon_sym_EQ] = ACTIONS(680),
    [anon_sym_AT] = ACTIONS(678),
    [anon_sym_LBRACK] = ACTIONS(678),
    [anon_sym_is] = ACTIONS(680),
    [anon_sym_let] = ACTIONS(678),
    [anon_sym_var] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_DOT] = ACTIONS(680),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_CARET] = ACTIONS(678),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_AMP] = ACTIONS(678),
    [anon_sym_DASH_GT] = ACTIONS(678),
    [anon_sym_LBRACE] = ACTIONS(678),
    [anon_sym_SEMI] = ACTIONS(678),
    [sym_error] = ACTIONS(678),
    [sym_compile_intrinsic] = ACTIONS(678),
    [anon_sym_compile_error] = ACTIONS(678),
    [sym_location] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(680),
    [anon_sym_not] = ACTIONS(678),
    [anon_sym_DASH_TILDE] = ACTIONS(678),
    [anon_sym_addressof] = ACTIONS(678),
    [anon_sym_digestof] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(680),
    [anon_sym_STAR] = ACTIONS(680),
    [anon_sym_SLASH] = ACTIONS(680),
    [anon_sym_PERCENT] = ACTIONS(680),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(680),
    [anon_sym_LT_LT] = ACTIONS(680),
    [anon_sym_GT_GT] = ACTIONS(680),
    [anon_sym_and] = ACTIONS(678),
    [anon_sym_or] = ACTIONS(678),
    [anon_sym_xor] = ACTIONS(678),
    [anon_sym_isnt] = ACTIONS(678),
    [anon_sym_EQ_EQ] = ACTIONS(680),
    [anon_sym_BANG_EQ] = ACTIONS(680),
    [anon_sym_GT] = ACTIONS(680),
    [anon_sym_GT_EQ] = ACTIONS(680),
    [anon_sym_LT_EQ] = ACTIONS(680),
    [anon_sym_LT] = ACTIONS(680),
    [anon_sym_PLUS_TILDE] = ACTIONS(678),
    [anon_sym_STAR_TILDE] = ACTIONS(678),
    [anon_sym_SLASH_TILDE] = ACTIONS(678),
    [anon_sym_PERCENT_TILDE] = ACTIONS(678),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(678),
    [anon_sym_LT_LT_TILDE] = ACTIONS(678),
    [anon_sym_GT_GT_TILDE] = ACTIONS(678),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(678),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(678),
    [anon_sym_GT_TILDE] = ACTIONS(678),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(678),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(678),
    [anon_sym_LT_TILDE] = ACTIONS(678),
    [anon_sym_PLUS_QMARK] = ACTIONS(678),
    [anon_sym_DASH_QMARK] = ACTIONS(678),
    [anon_sym_STAR_QMARK] = ACTIONS(678),
    [anon_sym_SLASH_QMARK] = ACTIONS(678),
    [anon_sym_PERCENT_QMARK] = ACTIONS(678),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(678),
    [anon_sym_as] = ACTIONS(678),
    [anon_sym_LPAREN2] = ACTIONS(678),
    [anon_sym_DOT_GT] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(678),
    [anon_sym_end] = ACTIONS(678),
    [anon_sym_if] = ACTIONS(680),
    [anon_sym_ifdef] = ACTIONS(678),
    [anon_sym_elseif] = ACTIONS(678),
    [anon_sym_iftype] = ACTIONS(678),
    [anon_sym_else] = ACTIONS(680),
    [anon_sym_for] = ACTIONS(678),
    [anon_sym_while] = ACTIONS(678),
    [anon_sym_try] = ACTIONS(678),
    [anon_sym_with] = ACTIONS(678),
    [anon_sym_repeat] = ACTIONS(678),
    [anon_sym_recover] = ACTIONS(678),
    [anon_sym_match] = ACTIONS(678),
    [anon_sym_return] = ACTIONS(678),
    [anon_sym_continue] = ACTIONS(678),
    [anon_sym_break] = ACTIONS(678),
    [anon_sym_consume] = ACTIONS(678),
    [anon_sym_object] = ACTIONS(678),
    [sym_number] = ACTIONS(680),
    [sym_float] = ACTIONS(678),
    [anon_sym_DQUOTE] = ACTIONS(680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(678),
    [anon_sym_SQUOTE] = ACTIONS(678),
    [anon_sym_true] = ACTIONS(678),
    [anon_sym_false] = ACTIONS(678),
    [sym_this] = ACTIONS(678),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [460] = {
    [sym_identifier] = ACTIONS(901),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_AT] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(899),
    [anon_sym_is] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_var] = ACTIONS(899),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_CARET] = ACTIONS(899),
    [anon_sym_PIPE] = ACTIONS(899),
    [anon_sym_AMP] = ACTIONS(899),
    [anon_sym_DASH_GT] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(899),
    [anon_sym_SEMI] = ACTIONS(899),
    [sym_error] = ACTIONS(899),
    [sym_compile_intrinsic] = ACTIONS(899),
    [anon_sym_compile_error] = ACTIONS(899),
    [sym_location] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_not] = ACTIONS(899),
    [anon_sym_DASH_TILDE] = ACTIONS(899),
    [anon_sym_addressof] = ACTIONS(899),
    [anon_sym_digestof] = ACTIONS(899),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_STAR] = ACTIONS(901),
    [anon_sym_SLASH] = ACTIONS(901),
    [anon_sym_PERCENT] = ACTIONS(901),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(901),
    [anon_sym_LT_LT] = ACTIONS(901),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_and] = ACTIONS(899),
    [anon_sym_or] = ACTIONS(899),
    [anon_sym_xor] = ACTIONS(899),
    [anon_sym_isnt] = ACTIONS(899),
    [anon_sym_EQ_EQ] = ACTIONS(901),
    [anon_sym_BANG_EQ] = ACTIONS(901),
    [anon_sym_GT] = ACTIONS(901),
    [anon_sym_GT_EQ] = ACTIONS(901),
    [anon_sym_LT_EQ] = ACTIONS(901),
    [anon_sym_LT] = ACTIONS(901),
    [anon_sym_PLUS_TILDE] = ACTIONS(899),
    [anon_sym_STAR_TILDE] = ACTIONS(899),
    [anon_sym_SLASH_TILDE] = ACTIONS(899),
    [anon_sym_PERCENT_TILDE] = ACTIONS(899),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(899),
    [anon_sym_LT_LT_TILDE] = ACTIONS(899),
    [anon_sym_GT_GT_TILDE] = ACTIONS(899),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(899),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(899),
    [anon_sym_GT_TILDE] = ACTIONS(899),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(899),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(899),
    [anon_sym_LT_TILDE] = ACTIONS(899),
    [anon_sym_PLUS_QMARK] = ACTIONS(899),
    [anon_sym_DASH_QMARK] = ACTIONS(899),
    [anon_sym_STAR_QMARK] = ACTIONS(899),
    [anon_sym_SLASH_QMARK] = ACTIONS(899),
    [anon_sym_PERCENT_QMARK] = ACTIONS(899),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(899),
    [anon_sym_as] = ACTIONS(899),
    [anon_sym_LPAREN2] = ACTIONS(899),
    [anon_sym_DOT_GT] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(899),
    [anon_sym_end] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(901),
    [anon_sym_ifdef] = ACTIONS(899),
    [anon_sym_elseif] = ACTIONS(899),
    [anon_sym_iftype] = ACTIONS(899),
    [anon_sym_else] = ACTIONS(901),
    [anon_sym_for] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(899),
    [anon_sym_try] = ACTIONS(899),
    [anon_sym_with] = ACTIONS(899),
    [anon_sym_repeat] = ACTIONS(899),
    [anon_sym_recover] = ACTIONS(899),
    [anon_sym_match] = ACTIONS(899),
    [anon_sym_return] = ACTIONS(899),
    [anon_sym_continue] = ACTIONS(899),
    [anon_sym_break] = ACTIONS(899),
    [anon_sym_consume] = ACTIONS(899),
    [anon_sym_object] = ACTIONS(899),
    [sym_number] = ACTIONS(901),
    [sym_float] = ACTIONS(899),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(899),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [anon_sym_true] = ACTIONS(899),
    [anon_sym_false] = ACTIONS(899),
    [sym_this] = ACTIONS(899),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [461] = {
    [sym_identifier] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_AT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_is] = ACTIONS(937),
    [anon_sym_let] = ACTIONS(935),
    [anon_sym_var] = ACTIONS(935),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_BANG] = ACTIONS(937),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym_AMP] = ACTIONS(935),
    [anon_sym_DASH_GT] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_SEMI] = ACTIONS(935),
    [sym_error] = ACTIONS(935),
    [sym_compile_intrinsic] = ACTIONS(935),
    [anon_sym_compile_error] = ACTIONS(935),
    [sym_location] = ACTIONS(935),
    [anon_sym_DASH] = ACTIONS(937),
    [anon_sym_not] = ACTIONS(935),
    [anon_sym_DASH_TILDE] = ACTIONS(935),
    [anon_sym_addressof] = ACTIONS(935),
    [anon_sym_digestof] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_STAR] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_xor] = ACTIONS(935),
    [anon_sym_isnt] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_PLUS_TILDE] = ACTIONS(935),
    [anon_sym_STAR_TILDE] = ACTIONS(935),
    [anon_sym_SLASH_TILDE] = ACTIONS(935),
    [anon_sym_PERCENT_TILDE] = ACTIONS(935),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(935),
    [anon_sym_LT_LT_TILDE] = ACTIONS(935),
    [anon_sym_GT_GT_TILDE] = ACTIONS(935),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(935),
    [anon_sym_GT_TILDE] = ACTIONS(935),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(935),
    [anon_sym_LT_TILDE] = ACTIONS(935),
    [anon_sym_PLUS_QMARK] = ACTIONS(935),
    [anon_sym_DASH_QMARK] = ACTIONS(935),
    [anon_sym_STAR_QMARK] = ACTIONS(935),
    [anon_sym_SLASH_QMARK] = ACTIONS(935),
    [anon_sym_PERCENT_QMARK] = ACTIONS(935),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(935),
    [anon_sym_as] = ACTIONS(935),
    [anon_sym_LPAREN2] = ACTIONS(935),
    [anon_sym_DOT_GT] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(935),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(937),
    [anon_sym_ifdef] = ACTIONS(935),
    [anon_sym_elseif] = ACTIONS(935),
    [anon_sym_iftype] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(937),
    [anon_sym_for] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_try] = ACTIONS(935),
    [anon_sym_with] = ACTIONS(935),
    [anon_sym_repeat] = ACTIONS(935),
    [anon_sym_recover] = ACTIONS(935),
    [anon_sym_match] = ACTIONS(935),
    [anon_sym_return] = ACTIONS(935),
    [anon_sym_continue] = ACTIONS(935),
    [anon_sym_break] = ACTIONS(935),
    [anon_sym_consume] = ACTIONS(935),
    [anon_sym_object] = ACTIONS(935),
    [sym_number] = ACTIONS(937),
    [sym_float] = ACTIONS(935),
    [anon_sym_DQUOTE] = ACTIONS(937),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(935),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_true] = ACTIONS(935),
    [anon_sym_false] = ACTIONS(935),
    [sym_this] = ACTIONS(935),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [462] = {
    [sym_identifier] = ACTIONS(957),
    [anon_sym_EQ] = ACTIONS(957),
    [anon_sym_AT] = ACTIONS(955),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_is] = ACTIONS(957),
    [anon_sym_let] = ACTIONS(955),
    [anon_sym_var] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_DOT] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(955),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_DASH_GT] = ACTIONS(955),
    [anon_sym_LBRACE] = ACTIONS(955),
    [anon_sym_SEMI] = ACTIONS(955),
    [sym_error] = ACTIONS(955),
    [sym_compile_intrinsic] = ACTIONS(955),
    [anon_sym_compile_error] = ACTIONS(955),
    [sym_location] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_not] = ACTIONS(955),
    [anon_sym_DASH_TILDE] = ACTIONS(955),
    [anon_sym_addressof] = ACTIONS(955),
    [anon_sym_digestof] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(957),
    [anon_sym_SLASH] = ACTIONS(957),
    [anon_sym_PERCENT] = ACTIONS(957),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(957),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_and] = ACTIONS(955),
    [anon_sym_or] = ACTIONS(955),
    [anon_sym_xor] = ACTIONS(955),
    [anon_sym_isnt] = ACTIONS(955),
    [anon_sym_EQ_EQ] = ACTIONS(957),
    [anon_sym_BANG_EQ] = ACTIONS(957),
    [anon_sym_GT] = ACTIONS(957),
    [anon_sym_GT_EQ] = ACTIONS(957),
    [anon_sym_LT_EQ] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(957),
    [anon_sym_PLUS_TILDE] = ACTIONS(955),
    [anon_sym_STAR_TILDE] = ACTIONS(955),
    [anon_sym_SLASH_TILDE] = ACTIONS(955),
    [anon_sym_PERCENT_TILDE] = ACTIONS(955),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(955),
    [anon_sym_LT_LT_TILDE] = ACTIONS(955),
    [anon_sym_GT_GT_TILDE] = ACTIONS(955),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(955),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(955),
    [anon_sym_GT_TILDE] = ACTIONS(955),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(955),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(955),
    [anon_sym_LT_TILDE] = ACTIONS(955),
    [anon_sym_PLUS_QMARK] = ACTIONS(955),
    [anon_sym_DASH_QMARK] = ACTIONS(955),
    [anon_sym_STAR_QMARK] = ACTIONS(955),
    [anon_sym_SLASH_QMARK] = ACTIONS(955),
    [anon_sym_PERCENT_QMARK] = ACTIONS(955),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(955),
    [anon_sym_as] = ACTIONS(955),
    [anon_sym_LPAREN2] = ACTIONS(955),
    [anon_sym_DOT_GT] = ACTIONS(955),
    [anon_sym_TILDE] = ACTIONS(955),
    [anon_sym_end] = ACTIONS(955),
    [anon_sym_if] = ACTIONS(957),
    [anon_sym_ifdef] = ACTIONS(955),
    [anon_sym_elseif] = ACTIONS(955),
    [anon_sym_iftype] = ACTIONS(955),
    [anon_sym_else] = ACTIONS(957),
    [anon_sym_for] = ACTIONS(955),
    [anon_sym_while] = ACTIONS(955),
    [anon_sym_try] = ACTIONS(955),
    [anon_sym_with] = ACTIONS(955),
    [anon_sym_repeat] = ACTIONS(955),
    [anon_sym_recover] = ACTIONS(955),
    [anon_sym_match] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(955),
    [anon_sym_continue] = ACTIONS(955),
    [anon_sym_break] = ACTIONS(955),
    [anon_sym_consume] = ACTIONS(955),
    [anon_sym_object] = ACTIONS(955),
    [sym_number] = ACTIONS(957),
    [sym_float] = ACTIONS(955),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(955),
    [anon_sym_SQUOTE] = ACTIONS(955),
    [anon_sym_true] = ACTIONS(955),
    [anon_sym_false] = ACTIONS(955),
    [sym_this] = ACTIONS(955),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [463] = {
    [sym_identifier] = ACTIONS(949),
    [anon_sym_EQ] = ACTIONS(949),
    [anon_sym_AT] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_is] = ACTIONS(949),
    [anon_sym_let] = ACTIONS(947),
    [anon_sym_var] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(947),
    [anon_sym_DASH_GT] = ACTIONS(947),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_SEMI] = ACTIONS(947),
    [sym_error] = ACTIONS(947),
    [sym_compile_intrinsic] = ACTIONS(947),
    [anon_sym_compile_error] = ACTIONS(947),
    [sym_location] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_not] = ACTIONS(947),
    [anon_sym_DASH_TILDE] = ACTIONS(947),
    [anon_sym_addressof] = ACTIONS(947),
    [anon_sym_digestof] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_STAR] = ACTIONS(949),
    [anon_sym_SLASH] = ACTIONS(949),
    [anon_sym_PERCENT] = ACTIONS(949),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(949),
    [anon_sym_LT_LT] = ACTIONS(949),
    [anon_sym_GT_GT] = ACTIONS(949),
    [anon_sym_and] = ACTIONS(947),
    [anon_sym_or] = ACTIONS(947),
    [anon_sym_xor] = ACTIONS(947),
    [anon_sym_isnt] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_BANG_EQ] = ACTIONS(949),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(949),
    [anon_sym_LT_EQ] = ACTIONS(949),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_PLUS_TILDE] = ACTIONS(947),
    [anon_sym_STAR_TILDE] = ACTIONS(947),
    [anon_sym_SLASH_TILDE] = ACTIONS(947),
    [anon_sym_PERCENT_TILDE] = ACTIONS(947),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(947),
    [anon_sym_LT_LT_TILDE] = ACTIONS(947),
    [anon_sym_GT_GT_TILDE] = ACTIONS(947),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(947),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(947),
    [anon_sym_GT_TILDE] = ACTIONS(947),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(947),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(947),
    [anon_sym_LT_TILDE] = ACTIONS(947),
    [anon_sym_PLUS_QMARK] = ACTIONS(947),
    [anon_sym_DASH_QMARK] = ACTIONS(947),
    [anon_sym_STAR_QMARK] = ACTIONS(947),
    [anon_sym_SLASH_QMARK] = ACTIONS(947),
    [anon_sym_PERCENT_QMARK] = ACTIONS(947),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(947),
    [anon_sym_as] = ACTIONS(947),
    [anon_sym_LPAREN2] = ACTIONS(947),
    [anon_sym_DOT_GT] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(947),
    [anon_sym_end] = ACTIONS(947),
    [anon_sym_if] = ACTIONS(949),
    [anon_sym_ifdef] = ACTIONS(947),
    [anon_sym_elseif] = ACTIONS(947),
    [anon_sym_iftype] = ACTIONS(947),
    [anon_sym_else] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(947),
    [anon_sym_with] = ACTIONS(947),
    [anon_sym_repeat] = ACTIONS(947),
    [anon_sym_recover] = ACTIONS(947),
    [anon_sym_match] = ACTIONS(947),
    [anon_sym_return] = ACTIONS(947),
    [anon_sym_continue] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(947),
    [anon_sym_consume] = ACTIONS(947),
    [anon_sym_object] = ACTIONS(947),
    [sym_number] = ACTIONS(949),
    [sym_float] = ACTIONS(947),
    [anon_sym_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(947),
    [anon_sym_SQUOTE] = ACTIONS(947),
    [anon_sym_true] = ACTIONS(947),
    [anon_sym_false] = ACTIONS(947),
    [sym_this] = ACTIONS(947),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [464] = {
    [sym_identifier] = ACTIONS(913),
    [anon_sym_EQ] = ACTIONS(913),
    [anon_sym_AT] = ACTIONS(911),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_is] = ACTIONS(913),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_var] = ACTIONS(911),
    [anon_sym_LPAREN] = ACTIONS(913),
    [anon_sym_DOT] = ACTIONS(913),
    [anon_sym_BANG] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_DASH_GT] = ACTIONS(911),
    [anon_sym_LBRACE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(911),
    [sym_error] = ACTIONS(911),
    [sym_compile_intrinsic] = ACTIONS(911),
    [anon_sym_compile_error] = ACTIONS(911),
    [sym_location] = ACTIONS(911),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_DASH_TILDE] = ACTIONS(911),
    [anon_sym_addressof] = ACTIONS(911),
    [anon_sym_digestof] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(913),
    [anon_sym_SLASH] = ACTIONS(913),
    [anon_sym_PERCENT] = ACTIONS(913),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(913),
    [anon_sym_LT_LT] = ACTIONS(913),
    [anon_sym_GT_GT] = ACTIONS(913),
    [anon_sym_and] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(911),
    [anon_sym_xor] = ACTIONS(911),
    [anon_sym_isnt] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(913),
    [anon_sym_BANG_EQ] = ACTIONS(913),
    [anon_sym_GT] = ACTIONS(913),
    [anon_sym_GT_EQ] = ACTIONS(913),
    [anon_sym_LT_EQ] = ACTIONS(913),
    [anon_sym_LT] = ACTIONS(913),
    [anon_sym_PLUS_TILDE] = ACTIONS(911),
    [anon_sym_STAR_TILDE] = ACTIONS(911),
    [anon_sym_SLASH_TILDE] = ACTIONS(911),
    [anon_sym_PERCENT_TILDE] = ACTIONS(911),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(911),
    [anon_sym_LT_LT_TILDE] = ACTIONS(911),
    [anon_sym_GT_GT_TILDE] = ACTIONS(911),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(911),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(911),
    [anon_sym_GT_TILDE] = ACTIONS(911),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(911),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(911),
    [anon_sym_LT_TILDE] = ACTIONS(911),
    [anon_sym_PLUS_QMARK] = ACTIONS(911),
    [anon_sym_DASH_QMARK] = ACTIONS(911),
    [anon_sym_STAR_QMARK] = ACTIONS(911),
    [anon_sym_SLASH_QMARK] = ACTIONS(911),
    [anon_sym_PERCENT_QMARK] = ACTIONS(911),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(911),
    [anon_sym_LPAREN2] = ACTIONS(911),
    [anon_sym_DOT_GT] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(911),
    [anon_sym_end] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(913),
    [anon_sym_ifdef] = ACTIONS(911),
    [anon_sym_elseif] = ACTIONS(911),
    [anon_sym_iftype] = ACTIONS(911),
    [anon_sym_else] = ACTIONS(913),
    [anon_sym_for] = ACTIONS(911),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_try] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(911),
    [anon_sym_repeat] = ACTIONS(911),
    [anon_sym_recover] = ACTIONS(911),
    [anon_sym_match] = ACTIONS(911),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_continue] = ACTIONS(911),
    [anon_sym_break] = ACTIONS(911),
    [anon_sym_consume] = ACTIONS(911),
    [anon_sym_object] = ACTIONS(911),
    [sym_number] = ACTIONS(913),
    [sym_float] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(911),
    [anon_sym_SQUOTE] = ACTIONS(911),
    [anon_sym_true] = ACTIONS(911),
    [anon_sym_false] = ACTIONS(911),
    [sym_this] = ACTIONS(911),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [465] = {
    [sym_identifier] = ACTIONS(921),
    [anon_sym_EQ] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_is] = ACTIONS(921),
    [anon_sym_let] = ACTIONS(919),
    [anon_sym_var] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(921),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(919),
    [anon_sym_DASH_GT] = ACTIONS(919),
    [anon_sym_LBRACE] = ACTIONS(919),
    [anon_sym_SEMI] = ACTIONS(919),
    [sym_error] = ACTIONS(919),
    [sym_compile_intrinsic] = ACTIONS(919),
    [anon_sym_compile_error] = ACTIONS(919),
    [sym_location] = ACTIONS(919),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_DASH_TILDE] = ACTIONS(919),
    [anon_sym_addressof] = ACTIONS(919),
    [anon_sym_digestof] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_STAR] = ACTIONS(921),
    [anon_sym_SLASH] = ACTIONS(921),
    [anon_sym_PERCENT] = ACTIONS(921),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(921),
    [anon_sym_GT_GT] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(919),
    [anon_sym_or] = ACTIONS(919),
    [anon_sym_xor] = ACTIONS(919),
    [anon_sym_isnt] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_PLUS_TILDE] = ACTIONS(919),
    [anon_sym_STAR_TILDE] = ACTIONS(919),
    [anon_sym_SLASH_TILDE] = ACTIONS(919),
    [anon_sym_PERCENT_TILDE] = ACTIONS(919),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(919),
    [anon_sym_LT_LT_TILDE] = ACTIONS(919),
    [anon_sym_GT_GT_TILDE] = ACTIONS(919),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(919),
    [anon_sym_GT_TILDE] = ACTIONS(919),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(919),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(919),
    [anon_sym_LT_TILDE] = ACTIONS(919),
    [anon_sym_PLUS_QMARK] = ACTIONS(919),
    [anon_sym_DASH_QMARK] = ACTIONS(919),
    [anon_sym_STAR_QMARK] = ACTIONS(919),
    [anon_sym_SLASH_QMARK] = ACTIONS(919),
    [anon_sym_PERCENT_QMARK] = ACTIONS(919),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(919),
    [anon_sym_as] = ACTIONS(919),
    [anon_sym_LPAREN2] = ACTIONS(919),
    [anon_sym_DOT_GT] = ACTIONS(919),
    [anon_sym_TILDE] = ACTIONS(919),
    [anon_sym_end] = ACTIONS(919),
    [anon_sym_if] = ACTIONS(921),
    [anon_sym_ifdef] = ACTIONS(919),
    [anon_sym_elseif] = ACTIONS(919),
    [anon_sym_iftype] = ACTIONS(919),
    [anon_sym_else] = ACTIONS(921),
    [anon_sym_for] = ACTIONS(919),
    [anon_sym_while] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(919),
    [anon_sym_with] = ACTIONS(919),
    [anon_sym_repeat] = ACTIONS(919),
    [anon_sym_recover] = ACTIONS(919),
    [anon_sym_match] = ACTIONS(919),
    [anon_sym_return] = ACTIONS(919),
    [anon_sym_continue] = ACTIONS(919),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_consume] = ACTIONS(919),
    [anon_sym_object] = ACTIONS(919),
    [sym_number] = ACTIONS(921),
    [sym_float] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(921),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(919),
    [anon_sym_SQUOTE] = ACTIONS(919),
    [anon_sym_true] = ACTIONS(919),
    [anon_sym_false] = ACTIONS(919),
    [sym_this] = ACTIONS(919),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [466] = {
    [sym_identifier] = ACTIONS(929),
    [anon_sym_EQ] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(927),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_is] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(927),
    [anon_sym_var] = ACTIONS(927),
    [anon_sym_LPAREN] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_CARET] = ACTIONS(927),
    [anon_sym_PIPE] = ACTIONS(927),
    [anon_sym_AMP] = ACTIONS(927),
    [anon_sym_DASH_GT] = ACTIONS(927),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_SEMI] = ACTIONS(927),
    [sym_error] = ACTIONS(927),
    [sym_compile_intrinsic] = ACTIONS(927),
    [anon_sym_compile_error] = ACTIONS(927),
    [sym_location] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_not] = ACTIONS(927),
    [anon_sym_DASH_TILDE] = ACTIONS(927),
    [anon_sym_addressof] = ACTIONS(927),
    [anon_sym_digestof] = ACTIONS(927),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_PERCENT] = ACTIONS(929),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(929),
    [anon_sym_LT_LT] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(929),
    [anon_sym_and] = ACTIONS(927),
    [anon_sym_or] = ACTIONS(927),
    [anon_sym_xor] = ACTIONS(927),
    [anon_sym_isnt] = ACTIONS(927),
    [anon_sym_EQ_EQ] = ACTIONS(929),
    [anon_sym_BANG_EQ] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_GT_EQ] = ACTIONS(929),
    [anon_sym_LT_EQ] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_PLUS_TILDE] = ACTIONS(927),
    [anon_sym_STAR_TILDE] = ACTIONS(927),
    [anon_sym_SLASH_TILDE] = ACTIONS(927),
    [anon_sym_PERCENT_TILDE] = ACTIONS(927),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(927),
    [anon_sym_LT_LT_TILDE] = ACTIONS(927),
    [anon_sym_GT_GT_TILDE] = ACTIONS(927),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(927),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(927),
    [anon_sym_GT_TILDE] = ACTIONS(927),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(927),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(927),
    [anon_sym_LT_TILDE] = ACTIONS(927),
    [anon_sym_PLUS_QMARK] = ACTIONS(927),
    [anon_sym_DASH_QMARK] = ACTIONS(927),
    [anon_sym_STAR_QMARK] = ACTIONS(927),
    [anon_sym_SLASH_QMARK] = ACTIONS(927),
    [anon_sym_PERCENT_QMARK] = ACTIONS(927),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(927),
    [anon_sym_as] = ACTIONS(927),
    [anon_sym_LPAREN2] = ACTIONS(927),
    [anon_sym_DOT_GT] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(927),
    [anon_sym_end] = ACTIONS(927),
    [anon_sym_if] = ACTIONS(929),
    [anon_sym_ifdef] = ACTIONS(927),
    [anon_sym_elseif] = ACTIONS(927),
    [anon_sym_iftype] = ACTIONS(927),
    [anon_sym_else] = ACTIONS(929),
    [anon_sym_for] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(927),
    [anon_sym_try] = ACTIONS(927),
    [anon_sym_with] = ACTIONS(927),
    [anon_sym_repeat] = ACTIONS(927),
    [anon_sym_recover] = ACTIONS(927),
    [anon_sym_match] = ACTIONS(927),
    [anon_sym_return] = ACTIONS(927),
    [anon_sym_continue] = ACTIONS(927),
    [anon_sym_break] = ACTIONS(927),
    [anon_sym_consume] = ACTIONS(927),
    [anon_sym_object] = ACTIONS(927),
    [sym_number] = ACTIONS(929),
    [sym_float] = ACTIONS(927),
    [anon_sym_DQUOTE] = ACTIONS(929),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(927),
    [anon_sym_true] = ACTIONS(927),
    [anon_sym_false] = ACTIONS(927),
    [sym_this] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [467] = {
    [sym_expression] = STATE(418),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [aux_sym_block_repeat1] = STATE(467),
    [ts_builtin_sym_end] = ACTIONS(74),
    [sym_identifier] = ACTIONS(243),
    [anon_sym_use] = ACTIONS(74),
    [anon_sym_AT] = ACTIONS(246),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_type] = ACTIONS(74),
    [anon_sym_actor] = ACTIONS(74),
    [anon_sym_class] = ACTIONS(74),
    [anon_sym_primitive] = ACTIONS(74),
    [anon_sym_interface] = ACTIONS(74),
    [anon_sym_trait] = ACTIONS(74),
    [anon_sym_struct] = ACTIONS(74),
    [anon_sym_let] = ACTIONS(252),
    [anon_sym_var] = ACTIONS(252),
    [anon_sym_new] = ACTIONS(74),
    [anon_sym_fun] = ACTIONS(74),
    [anon_sym_be] = ACTIONS(74),
    [anon_sym_LPAREN] = ACTIONS(1356),
    [anon_sym_LBRACE] = ACTIONS(258),
    [anon_sym_SEMI] = ACTIONS(261),
    [sym_error] = ACTIONS(264),
    [sym_compile_intrinsic] = ACTIONS(264),
    [anon_sym_compile_error] = ACTIONS(267),
    [sym_location] = ACTIONS(264),
    [anon_sym_DASH] = ACTIONS(270),
    [anon_sym_not] = ACTIONS(273),
    [anon_sym_DASH_TILDE] = ACTIONS(273),
    [anon_sym_addressof] = ACTIONS(273),
    [anon_sym_digestof] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(100),
    [anon_sym_ifdef] = ACTIONS(103),
    [anon_sym_iftype] = ACTIONS(276),
    [anon_sym_for] = ACTIONS(279),
    [anon_sym_while] = ACTIONS(282),
    [anon_sym_try] = ACTIONS(285),
    [anon_sym_with] = ACTIONS(288),
    [anon_sym_repeat] = ACTIONS(291),
    [anon_sym_recover] = ACTIONS(294),
    [anon_sym_match] = ACTIONS(297),
    [anon_sym_return] = ACTIONS(300),
    [anon_sym_continue] = ACTIONS(303),
    [anon_sym_break] = ACTIONS(306),
    [anon_sym_consume] = ACTIONS(309),
    [anon_sym_object] = ACTIONS(312),
    [sym_number] = ACTIONS(315),
    [sym_float] = ACTIONS(318),
    [anon_sym_DQUOTE] = ACTIONS(321),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(324),
    [anon_sym_SQUOTE] = ACTIONS(327),
    [anon_sym_true] = ACTIONS(330),
    [anon_sym_false] = ACTIONS(330),
    [sym_this] = ACTIONS(264),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [468] = {
    [sym_identifier] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_AT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_is] = ACTIONS(941),
    [anon_sym_let] = ACTIONS(939),
    [anon_sym_var] = ACTIONS(939),
    [anon_sym_LPAREN] = ACTIONS(941),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_BANG] = ACTIONS(941),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_DASH_GT] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_error] = ACTIONS(939),
    [sym_compile_intrinsic] = ACTIONS(939),
    [anon_sym_compile_error] = ACTIONS(939),
    [sym_location] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(941),
    [anon_sym_not] = ACTIONS(939),
    [anon_sym_DASH_TILDE] = ACTIONS(939),
    [anon_sym_addressof] = ACTIONS(939),
    [anon_sym_digestof] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_xor] = ACTIONS(939),
    [anon_sym_isnt] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_PLUS_TILDE] = ACTIONS(939),
    [anon_sym_STAR_TILDE] = ACTIONS(939),
    [anon_sym_SLASH_TILDE] = ACTIONS(939),
    [anon_sym_PERCENT_TILDE] = ACTIONS(939),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(939),
    [anon_sym_LT_LT_TILDE] = ACTIONS(939),
    [anon_sym_GT_GT_TILDE] = ACTIONS(939),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(939),
    [anon_sym_GT_TILDE] = ACTIONS(939),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(939),
    [anon_sym_LT_TILDE] = ACTIONS(939),
    [anon_sym_PLUS_QMARK] = ACTIONS(939),
    [anon_sym_DASH_QMARK] = ACTIONS(939),
    [anon_sym_STAR_QMARK] = ACTIONS(939),
    [anon_sym_SLASH_QMARK] = ACTIONS(939),
    [anon_sym_PERCENT_QMARK] = ACTIONS(939),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(939),
    [anon_sym_as] = ACTIONS(939),
    [anon_sym_LPAREN2] = ACTIONS(939),
    [anon_sym_DOT_GT] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(939),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(941),
    [anon_sym_ifdef] = ACTIONS(939),
    [anon_sym_elseif] = ACTIONS(939),
    [anon_sym_iftype] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(941),
    [anon_sym_for] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_try] = ACTIONS(939),
    [anon_sym_with] = ACTIONS(939),
    [anon_sym_repeat] = ACTIONS(939),
    [anon_sym_recover] = ACTIONS(939),
    [anon_sym_match] = ACTIONS(939),
    [anon_sym_return] = ACTIONS(939),
    [anon_sym_continue] = ACTIONS(939),
    [anon_sym_break] = ACTIONS(939),
    [anon_sym_consume] = ACTIONS(939),
    [anon_sym_object] = ACTIONS(939),
    [sym_number] = ACTIONS(941),
    [sym_float] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(939),
    [anon_sym_SQUOTE] = ACTIONS(939),
    [anon_sym_true] = ACTIONS(939),
    [anon_sym_false] = ACTIONS(939),
    [sym_this] = ACTIONS(939),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [469] = {
    [sym_expression] = STATE(379),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_block_repeat1] = STATE(469),
    [sym_identifier] = ACTIONS(63),
    [anon_sym_AT] = ACTIONS(68),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_RBRACK] = ACTIONS(74),
    [anon_sym_let] = ACTIONS(76),
    [anon_sym_var] = ACTIONS(76),
    [anon_sym_new] = ACTIONS(74),
    [anon_sym_EQ_GT] = ACTIONS(74),
    [anon_sym_fun] = ACTIONS(74),
    [anon_sym_be] = ACTIONS(74),
    [anon_sym_COMMA] = ACTIONS(74),
    [anon_sym_LPAREN] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(82),
    [anon_sym_RBRACE] = ACTIONS(74),
    [anon_sym_SEMI] = ACTIONS(85),
    [sym_error] = ACTIONS(88),
    [sym_compile_intrinsic] = ACTIONS(88),
    [anon_sym_compile_error] = ACTIONS(91),
    [sym_location] = ACTIONS(88),
    [anon_sym_DASH] = ACTIONS(94),
    [anon_sym_not] = ACTIONS(97),
    [anon_sym_DASH_TILDE] = ACTIONS(97),
    [anon_sym_addressof] = ACTIONS(97),
    [anon_sym_digestof] = ACTIONS(97),
    [anon_sym_end] = ACTIONS(74),
    [anon_sym_if] = ACTIONS(100),
    [anon_sym_ifdef] = ACTIONS(103),
    [anon_sym_then] = ACTIONS(74),
    [anon_sym_iftype] = ACTIONS(106),
    [anon_sym_else] = ACTIONS(74),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_while] = ACTIONS(112),
    [anon_sym_try] = ACTIONS(115),
    [anon_sym_with] = ACTIONS(118),
    [anon_sym_repeat] = ACTIONS(121),
    [anon_sym_until] = ACTIONS(74),
    [anon_sym_do] = ACTIONS(74),
    [anon_sym_recover] = ACTIONS(124),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(130),
    [anon_sym_continue] = ACTIONS(133),
    [anon_sym_break] = ACTIONS(136),
    [anon_sym_consume] = ACTIONS(139),
    [anon_sym_object] = ACTIONS(142),
    [sym_number] = ACTIONS(145),
    [sym_float] = ACTIONS(148),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(154),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(160),
    [anon_sym_false] = ACTIONS(160),
    [sym_this] = ACTIONS(88),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [470] = {
    [sym_string] = STATE(567),
    [sym__string_literal] = STATE(533),
    [sym__multiline_string_literal] = STATE(533),
    [sym_identifier] = ACTIONS(1296),
    [anon_sym_EQ] = ACTIONS(1296),
    [anon_sym_AT] = ACTIONS(1298),
    [anon_sym_LBRACK] = ACTIONS(1298),
    [anon_sym_is] = ACTIONS(1296),
    [anon_sym_let] = ACTIONS(1298),
    [anon_sym_var] = ACTIONS(1298),
    [anon_sym_LPAREN] = ACTIONS(1296),
    [anon_sym_DOT] = ACTIONS(1296),
    [anon_sym_LBRACE] = ACTIONS(1298),
    [anon_sym_SEMI] = ACTIONS(1298),
    [sym_error] = ACTIONS(1298),
    [sym_compile_intrinsic] = ACTIONS(1298),
    [anon_sym_compile_error] = ACTIONS(1298),
    [sym_location] = ACTIONS(1298),
    [anon_sym_DASH] = ACTIONS(1296),
    [anon_sym_not] = ACTIONS(1298),
    [anon_sym_DASH_TILDE] = ACTIONS(1298),
    [anon_sym_addressof] = ACTIONS(1298),
    [anon_sym_digestof] = ACTIONS(1298),
    [anon_sym_PLUS] = ACTIONS(1296),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_SLASH] = ACTIONS(1296),
    [anon_sym_PERCENT] = ACTIONS(1296),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1296),
    [anon_sym_LT_LT] = ACTIONS(1296),
    [anon_sym_GT_GT] = ACTIONS(1296),
    [anon_sym_and] = ACTIONS(1298),
    [anon_sym_or] = ACTIONS(1298),
    [anon_sym_xor] = ACTIONS(1298),
    [anon_sym_isnt] = ACTIONS(1298),
    [anon_sym_EQ_EQ] = ACTIONS(1296),
    [anon_sym_BANG_EQ] = ACTIONS(1296),
    [anon_sym_GT] = ACTIONS(1296),
    [anon_sym_GT_EQ] = ACTIONS(1296),
    [anon_sym_LT_EQ] = ACTIONS(1296),
    [anon_sym_LT] = ACTIONS(1296),
    [anon_sym_PLUS_TILDE] = ACTIONS(1298),
    [anon_sym_STAR_TILDE] = ACTIONS(1298),
    [anon_sym_SLASH_TILDE] = ACTIONS(1298),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1298),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1298),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1298),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1298),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1298),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1298),
    [anon_sym_GT_TILDE] = ACTIONS(1298),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1298),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1298),
    [anon_sym_LT_TILDE] = ACTIONS(1298),
    [anon_sym_PLUS_QMARK] = ACTIONS(1298),
    [anon_sym_DASH_QMARK] = ACTIONS(1298),
    [anon_sym_STAR_QMARK] = ACTIONS(1298),
    [anon_sym_SLASH_QMARK] = ACTIONS(1298),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1298),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1298),
    [anon_sym_as] = ACTIONS(1298),
    [anon_sym_LPAREN2] = ACTIONS(1298),
    [anon_sym_DOT_GT] = ACTIONS(1298),
    [anon_sym_TILDE] = ACTIONS(1298),
    [anon_sym_end] = ACTIONS(1298),
    [anon_sym_if] = ACTIONS(1296),
    [anon_sym_ifdef] = ACTIONS(1298),
    [anon_sym_elseif] = ACTIONS(1298),
    [anon_sym_iftype] = ACTIONS(1298),
    [anon_sym_else] = ACTIONS(1296),
    [anon_sym_for] = ACTIONS(1298),
    [anon_sym_while] = ACTIONS(1298),
    [anon_sym_try] = ACTIONS(1298),
    [anon_sym_with] = ACTIONS(1298),
    [anon_sym_repeat] = ACTIONS(1298),
    [anon_sym_recover] = ACTIONS(1298),
    [anon_sym_match] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1298),
    [anon_sym_continue] = ACTIONS(1298),
    [anon_sym_break] = ACTIONS(1298),
    [anon_sym_consume] = ACTIONS(1298),
    [anon_sym_object] = ACTIONS(1298),
    [sym_number] = ACTIONS(1296),
    [sym_float] = ACTIONS(1298),
    [anon_sym_DQUOTE] = ACTIONS(1296),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1298),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_true] = ACTIONS(1298),
    [anon_sym_false] = ACTIONS(1298),
    [sym_this] = ACTIONS(1298),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [471] = {
    [sym_arguments] = STATE(332),
    [sym_identifier] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(1318),
    [anon_sym_AT] = ACTIONS(1320),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_is] = ACTIONS(1318),
    [anon_sym_let] = ACTIONS(1320),
    [anon_sym_var] = ACTIONS(1320),
    [anon_sym_EQ_GT] = ACTIONS(1320),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_DOT] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1320),
    [anon_sym_SEMI] = ACTIONS(1320),
    [sym_error] = ACTIONS(1320),
    [sym_compile_intrinsic] = ACTIONS(1320),
    [anon_sym_compile_error] = ACTIONS(1320),
    [sym_location] = ACTIONS(1320),
    [anon_sym_DASH] = ACTIONS(1318),
    [anon_sym_not] = ACTIONS(1320),
    [anon_sym_DASH_TILDE] = ACTIONS(1320),
    [anon_sym_addressof] = ACTIONS(1320),
    [anon_sym_digestof] = ACTIONS(1320),
    [anon_sym_PLUS] = ACTIONS(1318),
    [anon_sym_STAR] = ACTIONS(1318),
    [anon_sym_SLASH] = ACTIONS(1318),
    [anon_sym_PERCENT] = ACTIONS(1318),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1318),
    [anon_sym_LT_LT] = ACTIONS(1318),
    [anon_sym_GT_GT] = ACTIONS(1318),
    [anon_sym_and] = ACTIONS(1320),
    [anon_sym_or] = ACTIONS(1320),
    [anon_sym_xor] = ACTIONS(1320),
    [anon_sym_isnt] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1318),
    [anon_sym_BANG_EQ] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(1318),
    [anon_sym_GT_EQ] = ACTIONS(1318),
    [anon_sym_LT_EQ] = ACTIONS(1318),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_PLUS_TILDE] = ACTIONS(1320),
    [anon_sym_STAR_TILDE] = ACTIONS(1320),
    [anon_sym_SLASH_TILDE] = ACTIONS(1320),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1320),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1320),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1320),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1320),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_GT_TILDE] = ACTIONS(1320),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_LT_TILDE] = ACTIONS(1320),
    [anon_sym_PLUS_QMARK] = ACTIONS(1320),
    [anon_sym_DASH_QMARK] = ACTIONS(1320),
    [anon_sym_STAR_QMARK] = ACTIONS(1320),
    [anon_sym_SLASH_QMARK] = ACTIONS(1320),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1320),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1320),
    [anon_sym_as] = ACTIONS(1320),
    [anon_sym_LPAREN2] = ACTIONS(45),
    [anon_sym_DOT_GT] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_end] = ACTIONS(1320),
    [anon_sym_if] = ACTIONS(1318),
    [anon_sym_ifdef] = ACTIONS(1320),
    [anon_sym_iftype] = ACTIONS(1320),
    [anon_sym_else] = ACTIONS(1320),
    [anon_sym_for] = ACTIONS(1320),
    [anon_sym_while] = ACTIONS(1320),
    [anon_sym_try] = ACTIONS(1320),
    [anon_sym_with] = ACTIONS(1320),
    [anon_sym_repeat] = ACTIONS(1320),
    [anon_sym_recover] = ACTIONS(1320),
    [anon_sym_match] = ACTIONS(1320),
    [anon_sym_return] = ACTIONS(1320),
    [anon_sym_continue] = ACTIONS(1320),
    [anon_sym_break] = ACTIONS(1320),
    [anon_sym_consume] = ACTIONS(1320),
    [anon_sym_object] = ACTIONS(1320),
    [sym_number] = ACTIONS(1318),
    [sym_float] = ACTIONS(1320),
    [anon_sym_DQUOTE] = ACTIONS(1318),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1320),
    [anon_sym_SQUOTE] = ACTIONS(1320),
    [anon_sym_true] = ACTIONS(1320),
    [anon_sym_false] = ACTIONS(1320),
    [sym_this] = ACTIONS(1320),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [472] = {
    [sym_type_args] = STATE(554),
    [sym_identifier] = ACTIONS(994),
    [anon_sym_EQ] = ACTIONS(994),
    [anon_sym_AT] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(992),
    [anon_sym_is] = ACTIONS(994),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_var] = ACTIONS(992),
    [anon_sym_LPAREN] = ACTIONS(994),
    [anon_sym_DOT] = ACTIONS(994),
    [anon_sym_LBRACE] = ACTIONS(992),
    [anon_sym_SEMI] = ACTIONS(992),
    [sym_error] = ACTIONS(992),
    [sym_compile_intrinsic] = ACTIONS(992),
    [anon_sym_compile_error] = ACTIONS(992),
    [sym_location] = ACTIONS(992),
    [anon_sym_DASH] = ACTIONS(994),
    [anon_sym_not] = ACTIONS(992),
    [anon_sym_DASH_TILDE] = ACTIONS(992),
    [anon_sym_addressof] = ACTIONS(992),
    [anon_sym_digestof] = ACTIONS(992),
    [anon_sym_PLUS] = ACTIONS(994),
    [anon_sym_STAR] = ACTIONS(994),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_PERCENT] = ACTIONS(994),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(994),
    [anon_sym_LT_LT] = ACTIONS(994),
    [anon_sym_GT_GT] = ACTIONS(994),
    [anon_sym_and] = ACTIONS(992),
    [anon_sym_or] = ACTIONS(992),
    [anon_sym_xor] = ACTIONS(992),
    [anon_sym_isnt] = ACTIONS(992),
    [anon_sym_EQ_EQ] = ACTIONS(994),
    [anon_sym_BANG_EQ] = ACTIONS(994),
    [anon_sym_GT] = ACTIONS(994),
    [anon_sym_GT_EQ] = ACTIONS(994),
    [anon_sym_LT_EQ] = ACTIONS(994),
    [anon_sym_LT] = ACTIONS(994),
    [anon_sym_PLUS_TILDE] = ACTIONS(992),
    [anon_sym_STAR_TILDE] = ACTIONS(992),
    [anon_sym_SLASH_TILDE] = ACTIONS(992),
    [anon_sym_PERCENT_TILDE] = ACTIONS(992),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(992),
    [anon_sym_LT_LT_TILDE] = ACTIONS(992),
    [anon_sym_GT_GT_TILDE] = ACTIONS(992),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(992),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(992),
    [anon_sym_GT_TILDE] = ACTIONS(992),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(992),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(992),
    [anon_sym_LT_TILDE] = ACTIONS(992),
    [anon_sym_PLUS_QMARK] = ACTIONS(992),
    [anon_sym_DASH_QMARK] = ACTIONS(992),
    [anon_sym_STAR_QMARK] = ACTIONS(992),
    [anon_sym_SLASH_QMARK] = ACTIONS(992),
    [anon_sym_PERCENT_QMARK] = ACTIONS(992),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(992),
    [anon_sym_as] = ACTIONS(992),
    [anon_sym_LPAREN2] = ACTIONS(992),
    [anon_sym_DOT_GT] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(992),
    [anon_sym_end] = ACTIONS(992),
    [anon_sym_if] = ACTIONS(994),
    [anon_sym_ifdef] = ACTIONS(992),
    [anon_sym_elseif] = ACTIONS(992),
    [anon_sym_iftype] = ACTIONS(992),
    [anon_sym_else] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(992),
    [anon_sym_while] = ACTIONS(992),
    [anon_sym_try] = ACTIONS(992),
    [anon_sym_with] = ACTIONS(992),
    [anon_sym_repeat] = ACTIONS(992),
    [anon_sym_recover] = ACTIONS(992),
    [anon_sym_match] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(992),
    [anon_sym_continue] = ACTIONS(992),
    [anon_sym_break] = ACTIONS(992),
    [anon_sym_consume] = ACTIONS(992),
    [anon_sym_object] = ACTIONS(992),
    [sym_number] = ACTIONS(994),
    [sym_float] = ACTIONS(992),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(992),
    [anon_sym_SQUOTE] = ACTIONS(992),
    [anon_sym_true] = ACTIONS(992),
    [anon_sym_false] = ACTIONS(992),
    [sym_this] = ACTIONS(992),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(1362),
    [sym_block_comment] = ACTIONS(3),
  },
  [473] = {
    [sym_arguments] = STATE(332),
    [sym_identifier] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1326),
    [anon_sym_AT] = ACTIONS(1328),
    [anon_sym_LBRACK] = ACTIONS(1328),
    [anon_sym_is] = ACTIONS(1326),
    [anon_sym_let] = ACTIONS(1328),
    [anon_sym_var] = ACTIONS(1328),
    [anon_sym_EQ_GT] = ACTIONS(1328),
    [anon_sym_LPAREN] = ACTIONS(1326),
    [anon_sym_DOT] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(1328),
    [anon_sym_LBRACE] = ACTIONS(1328),
    [anon_sym_SEMI] = ACTIONS(1328),
    [sym_error] = ACTIONS(1328),
    [sym_compile_intrinsic] = ACTIONS(1328),
    [anon_sym_compile_error] = ACTIONS(1328),
    [sym_location] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_not] = ACTIONS(1328),
    [anon_sym_DASH_TILDE] = ACTIONS(1328),
    [anon_sym_addressof] = ACTIONS(1328),
    [anon_sym_digestof] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1326),
    [anon_sym_STAR] = ACTIONS(1326),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym_PERCENT] = ACTIONS(1326),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1326),
    [anon_sym_GT_GT] = ACTIONS(1326),
    [anon_sym_and] = ACTIONS(1328),
    [anon_sym_or] = ACTIONS(1328),
    [anon_sym_xor] = ACTIONS(1328),
    [anon_sym_isnt] = ACTIONS(1328),
    [anon_sym_EQ_EQ] = ACTIONS(1326),
    [anon_sym_BANG_EQ] = ACTIONS(1326),
    [anon_sym_GT] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_LT] = ACTIONS(1326),
    [anon_sym_PLUS_TILDE] = ACTIONS(1328),
    [anon_sym_STAR_TILDE] = ACTIONS(1328),
    [anon_sym_SLASH_TILDE] = ACTIONS(1328),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1328),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1328),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1328),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1328),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1328),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1328),
    [anon_sym_GT_TILDE] = ACTIONS(1328),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1328),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1328),
    [anon_sym_LT_TILDE] = ACTIONS(1328),
    [anon_sym_PLUS_QMARK] = ACTIONS(1328),
    [anon_sym_DASH_QMARK] = ACTIONS(1328),
    [anon_sym_STAR_QMARK] = ACTIONS(1328),
    [anon_sym_SLASH_QMARK] = ACTIONS(1328),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1328),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1328),
    [anon_sym_as] = ACTIONS(1328),
    [anon_sym_LPAREN2] = ACTIONS(45),
    [anon_sym_DOT_GT] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_end] = ACTIONS(1328),
    [anon_sym_if] = ACTIONS(1326),
    [anon_sym_ifdef] = ACTIONS(1328),
    [anon_sym_iftype] = ACTIONS(1328),
    [anon_sym_else] = ACTIONS(1328),
    [anon_sym_for] = ACTIONS(1328),
    [anon_sym_while] = ACTIONS(1328),
    [anon_sym_try] = ACTIONS(1328),
    [anon_sym_with] = ACTIONS(1328),
    [anon_sym_repeat] = ACTIONS(1328),
    [anon_sym_recover] = ACTIONS(1328),
    [anon_sym_match] = ACTIONS(1328),
    [anon_sym_return] = ACTIONS(1328),
    [anon_sym_continue] = ACTIONS(1328),
    [anon_sym_break] = ACTIONS(1328),
    [anon_sym_consume] = ACTIONS(1328),
    [anon_sym_object] = ACTIONS(1328),
    [sym_number] = ACTIONS(1326),
    [sym_float] = ACTIONS(1328),
    [anon_sym_DQUOTE] = ACTIONS(1326),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1328),
    [anon_sym_SQUOTE] = ACTIONS(1328),
    [anon_sym_true] = ACTIONS(1328),
    [anon_sym_false] = ACTIONS(1328),
    [sym_this] = ACTIONS(1328),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [474] = {
    [sym_arguments] = STATE(332),
    [sym_identifier] = ACTIONS(1322),
    [anon_sym_EQ] = ACTIONS(1322),
    [anon_sym_AT] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(1324),
    [anon_sym_is] = ACTIONS(1322),
    [anon_sym_let] = ACTIONS(1324),
    [anon_sym_var] = ACTIONS(1324),
    [anon_sym_EQ_GT] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(1322),
    [anon_sym_DOT] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(1324),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_SEMI] = ACTIONS(1324),
    [sym_error] = ACTIONS(1324),
    [sym_compile_intrinsic] = ACTIONS(1324),
    [anon_sym_compile_error] = ACTIONS(1324),
    [sym_location] = ACTIONS(1324),
    [anon_sym_DASH] = ACTIONS(1322),
    [anon_sym_not] = ACTIONS(1324),
    [anon_sym_DASH_TILDE] = ACTIONS(1324),
    [anon_sym_addressof] = ACTIONS(1324),
    [anon_sym_digestof] = ACTIONS(1324),
    [anon_sym_PLUS] = ACTIONS(1322),
    [anon_sym_STAR] = ACTIONS(1322),
    [anon_sym_SLASH] = ACTIONS(1322),
    [anon_sym_PERCENT] = ACTIONS(1322),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1322),
    [anon_sym_LT_LT] = ACTIONS(1322),
    [anon_sym_GT_GT] = ACTIONS(1322),
    [anon_sym_and] = ACTIONS(1324),
    [anon_sym_or] = ACTIONS(1324),
    [anon_sym_xor] = ACTIONS(1324),
    [anon_sym_isnt] = ACTIONS(1324),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_GT] = ACTIONS(1322),
    [anon_sym_GT_EQ] = ACTIONS(1322),
    [anon_sym_LT_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1322),
    [anon_sym_PLUS_TILDE] = ACTIONS(1324),
    [anon_sym_STAR_TILDE] = ACTIONS(1324),
    [anon_sym_SLASH_TILDE] = ACTIONS(1324),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1324),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1324),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1324),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1324),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1324),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1324),
    [anon_sym_GT_TILDE] = ACTIONS(1324),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1324),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1324),
    [anon_sym_LT_TILDE] = ACTIONS(1324),
    [anon_sym_PLUS_QMARK] = ACTIONS(1324),
    [anon_sym_DASH_QMARK] = ACTIONS(1324),
    [anon_sym_STAR_QMARK] = ACTIONS(1324),
    [anon_sym_SLASH_QMARK] = ACTIONS(1324),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1324),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1324),
    [anon_sym_as] = ACTIONS(409),
    [anon_sym_LPAREN2] = ACTIONS(45),
    [anon_sym_DOT_GT] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_end] = ACTIONS(1324),
    [anon_sym_if] = ACTIONS(1322),
    [anon_sym_ifdef] = ACTIONS(1324),
    [anon_sym_iftype] = ACTIONS(1324),
    [anon_sym_else] = ACTIONS(1324),
    [anon_sym_for] = ACTIONS(1324),
    [anon_sym_while] = ACTIONS(1324),
    [anon_sym_try] = ACTIONS(1324),
    [anon_sym_with] = ACTIONS(1324),
    [anon_sym_repeat] = ACTIONS(1324),
    [anon_sym_recover] = ACTIONS(1324),
    [anon_sym_match] = ACTIONS(1324),
    [anon_sym_return] = ACTIONS(1324),
    [anon_sym_continue] = ACTIONS(1324),
    [anon_sym_break] = ACTIONS(1324),
    [anon_sym_consume] = ACTIONS(1324),
    [anon_sym_object] = ACTIONS(1324),
    [sym_number] = ACTIONS(1322),
    [sym_float] = ACTIONS(1324),
    [anon_sym_DQUOTE] = ACTIONS(1322),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1324),
    [anon_sym_SQUOTE] = ACTIONS(1324),
    [anon_sym_true] = ACTIONS(1324),
    [anon_sym_false] = ACTIONS(1324),
    [sym_this] = ACTIONS(1324),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [475] = {
    [sym_arguments] = STATE(332),
    [sym_identifier] = ACTIONS(66),
    [anon_sym_EQ] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(74),
    [anon_sym_LBRACK] = ACTIONS(74),
    [anon_sym_is] = ACTIONS(399),
    [anon_sym_let] = ACTIONS(74),
    [anon_sym_var] = ACTIONS(74),
    [anon_sym_EQ_GT] = ACTIONS(74),
    [anon_sym_LPAREN] = ACTIONS(66),
    [anon_sym_DOT] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(74),
    [anon_sym_LBRACE] = ACTIONS(74),
    [anon_sym_SEMI] = ACTIONS(74),
    [sym_error] = ACTIONS(74),
    [sym_compile_intrinsic] = ACTIONS(74),
    [anon_sym_compile_error] = ACTIONS(74),
    [sym_location] = ACTIONS(74),
    [anon_sym_DASH] = ACTIONS(399),
    [anon_sym_not] = ACTIONS(74),
    [anon_sym_DASH_TILDE] = ACTIONS(407),
    [anon_sym_addressof] = ACTIONS(74),
    [anon_sym_digestof] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(399),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(399),
    [anon_sym_PERCENT] = ACTIONS(399),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(399),
    [anon_sym_LT_LT] = ACTIONS(399),
    [anon_sym_GT_GT] = ACTIONS(399),
    [anon_sym_and] = ACTIONS(407),
    [anon_sym_or] = ACTIONS(407),
    [anon_sym_xor] = ACTIONS(407),
    [anon_sym_isnt] = ACTIONS(407),
    [anon_sym_EQ_EQ] = ACTIONS(399),
    [anon_sym_BANG_EQ] = ACTIONS(399),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(399),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_PLUS_TILDE] = ACTIONS(407),
    [anon_sym_STAR_TILDE] = ACTIONS(407),
    [anon_sym_SLASH_TILDE] = ACTIONS(407),
    [anon_sym_PERCENT_TILDE] = ACTIONS(407),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(407),
    [anon_sym_LT_LT_TILDE] = ACTIONS(407),
    [anon_sym_GT_GT_TILDE] = ACTIONS(407),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(407),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(407),
    [anon_sym_GT_TILDE] = ACTIONS(407),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(407),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(407),
    [anon_sym_LT_TILDE] = ACTIONS(407),
    [anon_sym_PLUS_QMARK] = ACTIONS(407),
    [anon_sym_DASH_QMARK] = ACTIONS(407),
    [anon_sym_STAR_QMARK] = ACTIONS(407),
    [anon_sym_SLASH_QMARK] = ACTIONS(407),
    [anon_sym_PERCENT_QMARK] = ACTIONS(407),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(407),
    [anon_sym_as] = ACTIONS(409),
    [anon_sym_LPAREN2] = ACTIONS(45),
    [anon_sym_DOT_GT] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_end] = ACTIONS(74),
    [anon_sym_if] = ACTIONS(66),
    [anon_sym_ifdef] = ACTIONS(74),
    [anon_sym_iftype] = ACTIONS(74),
    [anon_sym_else] = ACTIONS(74),
    [anon_sym_for] = ACTIONS(74),
    [anon_sym_while] = ACTIONS(74),
    [anon_sym_try] = ACTIONS(74),
    [anon_sym_with] = ACTIONS(74),
    [anon_sym_repeat] = ACTIONS(74),
    [anon_sym_recover] = ACTIONS(74),
    [anon_sym_match] = ACTIONS(74),
    [anon_sym_return] = ACTIONS(74),
    [anon_sym_continue] = ACTIONS(74),
    [anon_sym_break] = ACTIONS(74),
    [anon_sym_consume] = ACTIONS(74),
    [anon_sym_object] = ACTIONS(74),
    [sym_number] = ACTIONS(66),
    [sym_float] = ACTIONS(74),
    [anon_sym_DQUOTE] = ACTIONS(66),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(74),
    [anon_sym_true] = ACTIONS(74),
    [anon_sym_false] = ACTIONS(74),
    [sym_this] = ACTIONS(74),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [476] = {
    [sym_arguments] = STATE(332),
    [sym_identifier] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(1318),
    [anon_sym_AT] = ACTIONS(1320),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_is] = ACTIONS(1318),
    [anon_sym_let] = ACTIONS(1320),
    [anon_sym_var] = ACTIONS(1320),
    [anon_sym_EQ_GT] = ACTIONS(1320),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_DOT] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1320),
    [anon_sym_SEMI] = ACTIONS(1320),
    [sym_error] = ACTIONS(1320),
    [sym_compile_intrinsic] = ACTIONS(1320),
    [anon_sym_compile_error] = ACTIONS(1320),
    [sym_location] = ACTIONS(1320),
    [anon_sym_DASH] = ACTIONS(1318),
    [anon_sym_not] = ACTIONS(1320),
    [anon_sym_DASH_TILDE] = ACTIONS(1320),
    [anon_sym_addressof] = ACTIONS(1320),
    [anon_sym_digestof] = ACTIONS(1320),
    [anon_sym_PLUS] = ACTIONS(1318),
    [anon_sym_STAR] = ACTIONS(1318),
    [anon_sym_SLASH] = ACTIONS(1318),
    [anon_sym_PERCENT] = ACTIONS(1318),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1318),
    [anon_sym_LT_LT] = ACTIONS(1318),
    [anon_sym_GT_GT] = ACTIONS(1318),
    [anon_sym_and] = ACTIONS(1320),
    [anon_sym_or] = ACTIONS(1320),
    [anon_sym_xor] = ACTIONS(1320),
    [anon_sym_isnt] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1318),
    [anon_sym_BANG_EQ] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(1318),
    [anon_sym_GT_EQ] = ACTIONS(1318),
    [anon_sym_LT_EQ] = ACTIONS(1318),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_PLUS_TILDE] = ACTIONS(1320),
    [anon_sym_STAR_TILDE] = ACTIONS(1320),
    [anon_sym_SLASH_TILDE] = ACTIONS(1320),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1320),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1320),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1320),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1320),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_GT_TILDE] = ACTIONS(1320),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_LT_TILDE] = ACTIONS(1320),
    [anon_sym_PLUS_QMARK] = ACTIONS(1320),
    [anon_sym_DASH_QMARK] = ACTIONS(1320),
    [anon_sym_STAR_QMARK] = ACTIONS(1320),
    [anon_sym_SLASH_QMARK] = ACTIONS(1320),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1320),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1320),
    [anon_sym_as] = ACTIONS(1320),
    [anon_sym_LPAREN2] = ACTIONS(45),
    [anon_sym_DOT_GT] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_end] = ACTIONS(1320),
    [anon_sym_if] = ACTIONS(1318),
    [anon_sym_ifdef] = ACTIONS(1320),
    [anon_sym_iftype] = ACTIONS(1320),
    [anon_sym_else] = ACTIONS(1320),
    [anon_sym_for] = ACTIONS(1320),
    [anon_sym_while] = ACTIONS(1320),
    [anon_sym_try] = ACTIONS(1320),
    [anon_sym_with] = ACTIONS(1320),
    [anon_sym_repeat] = ACTIONS(1320),
    [anon_sym_recover] = ACTIONS(1320),
    [anon_sym_match] = ACTIONS(1320),
    [anon_sym_return] = ACTIONS(1320),
    [anon_sym_continue] = ACTIONS(1320),
    [anon_sym_break] = ACTIONS(1320),
    [anon_sym_consume] = ACTIONS(1320),
    [anon_sym_object] = ACTIONS(1320),
    [sym_number] = ACTIONS(1318),
    [sym_float] = ACTIONS(1320),
    [anon_sym_DQUOTE] = ACTIONS(1318),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1320),
    [anon_sym_SQUOTE] = ACTIONS(1320),
    [anon_sym_true] = ACTIONS(1320),
    [anon_sym_false] = ACTIONS(1320),
    [sym_this] = ACTIONS(1320),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [477] = {
    [sym_arguments] = STATE(332),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_EQ] = ACTIONS(397),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_LBRACK] = ACTIONS(1316),
    [anon_sym_is] = ACTIONS(399),
    [anon_sym_let] = ACTIONS(1316),
    [anon_sym_var] = ACTIONS(1316),
    [anon_sym_EQ_GT] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_DOT] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_SEMI] = ACTIONS(1316),
    [sym_error] = ACTIONS(1316),
    [sym_compile_intrinsic] = ACTIONS(1316),
    [anon_sym_compile_error] = ACTIONS(1316),
    [sym_location] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(399),
    [anon_sym_not] = ACTIONS(1316),
    [anon_sym_DASH_TILDE] = ACTIONS(407),
    [anon_sym_addressof] = ACTIONS(1316),
    [anon_sym_digestof] = ACTIONS(1316),
    [anon_sym_PLUS] = ACTIONS(399),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(399),
    [anon_sym_PERCENT] = ACTIONS(399),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(399),
    [anon_sym_LT_LT] = ACTIONS(399),
    [anon_sym_GT_GT] = ACTIONS(399),
    [anon_sym_and] = ACTIONS(407),
    [anon_sym_or] = ACTIONS(407),
    [anon_sym_xor] = ACTIONS(407),
    [anon_sym_isnt] = ACTIONS(407),
    [anon_sym_EQ_EQ] = ACTIONS(399),
    [anon_sym_BANG_EQ] = ACTIONS(399),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(399),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_PLUS_TILDE] = ACTIONS(407),
    [anon_sym_STAR_TILDE] = ACTIONS(407),
    [anon_sym_SLASH_TILDE] = ACTIONS(407),
    [anon_sym_PERCENT_TILDE] = ACTIONS(407),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(407),
    [anon_sym_LT_LT_TILDE] = ACTIONS(407),
    [anon_sym_GT_GT_TILDE] = ACTIONS(407),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(407),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(407),
    [anon_sym_GT_TILDE] = ACTIONS(407),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(407),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(407),
    [anon_sym_LT_TILDE] = ACTIONS(407),
    [anon_sym_PLUS_QMARK] = ACTIONS(407),
    [anon_sym_DASH_QMARK] = ACTIONS(407),
    [anon_sym_STAR_QMARK] = ACTIONS(407),
    [anon_sym_SLASH_QMARK] = ACTIONS(407),
    [anon_sym_PERCENT_QMARK] = ACTIONS(407),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(407),
    [anon_sym_as] = ACTIONS(409),
    [anon_sym_LPAREN2] = ACTIONS(45),
    [anon_sym_DOT_GT] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_end] = ACTIONS(1316),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_ifdef] = ACTIONS(1316),
    [anon_sym_iftype] = ACTIONS(1316),
    [anon_sym_else] = ACTIONS(1316),
    [anon_sym_for] = ACTIONS(1316),
    [anon_sym_while] = ACTIONS(1316),
    [anon_sym_try] = ACTIONS(1316),
    [anon_sym_with] = ACTIONS(1316),
    [anon_sym_repeat] = ACTIONS(1316),
    [anon_sym_recover] = ACTIONS(1316),
    [anon_sym_match] = ACTIONS(1316),
    [anon_sym_return] = ACTIONS(1316),
    [anon_sym_continue] = ACTIONS(1316),
    [anon_sym_break] = ACTIONS(1316),
    [anon_sym_consume] = ACTIONS(1316),
    [anon_sym_object] = ACTIONS(1316),
    [sym_number] = ACTIONS(1314),
    [sym_float] = ACTIONS(1316),
    [anon_sym_DQUOTE] = ACTIONS(1314),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1316),
    [anon_sym_true] = ACTIONS(1316),
    [anon_sym_false] = ACTIONS(1316),
    [sym_this] = ACTIONS(1316),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [478] = {
    [sym_annotation] = STATE(574),
    [sym_capability] = STATE(771),
    [sym_block] = STATE(2214),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_iso] = ACTIONS(1366),
    [anon_sym_trn] = ACTIONS(1366),
    [anon_sym_ref] = ACTIONS(1366),
    [anon_sym_val] = ACTIONS(1366),
    [anon_sym_box] = ACTIONS(1366),
    [anon_sym_tag] = ACTIONS(1366),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [479] = {
    [sym_annotation] = STATE(576),
    [sym_capability] = STATE(759),
    [sym_block] = STATE(2275),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_iso] = ACTIONS(1366),
    [anon_sym_trn] = ACTIONS(1366),
    [anon_sym_ref] = ACTIONS(1366),
    [anon_sym_val] = ACTIONS(1366),
    [anon_sym_box] = ACTIONS(1366),
    [anon_sym_tag] = ACTIONS(1366),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [480] = {
    [sym_arguments] = STATE(494),
    [sym_identifier] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1326),
    [anon_sym_AT] = ACTIONS(1328),
    [anon_sym_LBRACK] = ACTIONS(1328),
    [anon_sym_is] = ACTIONS(1326),
    [anon_sym_let] = ACTIONS(1328),
    [anon_sym_var] = ACTIONS(1328),
    [anon_sym_LPAREN] = ACTIONS(1326),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(1328),
    [anon_sym_SEMI] = ACTIONS(1328),
    [sym_error] = ACTIONS(1328),
    [sym_compile_intrinsic] = ACTIONS(1328),
    [anon_sym_compile_error] = ACTIONS(1328),
    [sym_location] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_not] = ACTIONS(1328),
    [anon_sym_DASH_TILDE] = ACTIONS(1328),
    [anon_sym_addressof] = ACTIONS(1328),
    [anon_sym_digestof] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1326),
    [anon_sym_STAR] = ACTIONS(1326),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym_PERCENT] = ACTIONS(1326),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1326),
    [anon_sym_GT_GT] = ACTIONS(1326),
    [anon_sym_and] = ACTIONS(1328),
    [anon_sym_or] = ACTIONS(1328),
    [anon_sym_xor] = ACTIONS(1328),
    [anon_sym_isnt] = ACTIONS(1328),
    [anon_sym_EQ_EQ] = ACTIONS(1326),
    [anon_sym_BANG_EQ] = ACTIONS(1326),
    [anon_sym_GT] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_LT] = ACTIONS(1326),
    [anon_sym_PLUS_TILDE] = ACTIONS(1328),
    [anon_sym_STAR_TILDE] = ACTIONS(1328),
    [anon_sym_SLASH_TILDE] = ACTIONS(1328),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1328),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1328),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1328),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1328),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1328),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1328),
    [anon_sym_GT_TILDE] = ACTIONS(1328),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1328),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1328),
    [anon_sym_LT_TILDE] = ACTIONS(1328),
    [anon_sym_PLUS_QMARK] = ACTIONS(1328),
    [anon_sym_DASH_QMARK] = ACTIONS(1328),
    [anon_sym_STAR_QMARK] = ACTIONS(1328),
    [anon_sym_SLASH_QMARK] = ACTIONS(1328),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1328),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1328),
    [anon_sym_as] = ACTIONS(1328),
    [anon_sym_LPAREN2] = ACTIONS(449),
    [anon_sym_DOT_GT] = ACTIONS(451),
    [anon_sym_TILDE] = ACTIONS(453),
    [anon_sym_end] = ACTIONS(1328),
    [anon_sym_if] = ACTIONS(1326),
    [anon_sym_ifdef] = ACTIONS(1328),
    [anon_sym_elseif] = ACTIONS(1328),
    [anon_sym_iftype] = ACTIONS(1328),
    [anon_sym_else] = ACTIONS(1326),
    [anon_sym_for] = ACTIONS(1328),
    [anon_sym_while] = ACTIONS(1328),
    [anon_sym_try] = ACTIONS(1328),
    [anon_sym_with] = ACTIONS(1328),
    [anon_sym_repeat] = ACTIONS(1328),
    [anon_sym_recover] = ACTIONS(1328),
    [anon_sym_match] = ACTIONS(1328),
    [anon_sym_return] = ACTIONS(1328),
    [anon_sym_continue] = ACTIONS(1328),
    [anon_sym_break] = ACTIONS(1328),
    [anon_sym_consume] = ACTIONS(1328),
    [anon_sym_object] = ACTIONS(1328),
    [sym_number] = ACTIONS(1326),
    [sym_float] = ACTIONS(1328),
    [anon_sym_DQUOTE] = ACTIONS(1326),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1328),
    [anon_sym_SQUOTE] = ACTIONS(1328),
    [anon_sym_true] = ACTIONS(1328),
    [anon_sym_false] = ACTIONS(1328),
    [sym_this] = ACTIONS(1328),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [481] = {
    [sym_arguments] = STATE(494),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_LBRACK] = ACTIONS(1316),
    [anon_sym_is] = ACTIONS(423),
    [anon_sym_let] = ACTIONS(1316),
    [anon_sym_var] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_SEMI] = ACTIONS(1316),
    [sym_error] = ACTIONS(1316),
    [sym_compile_intrinsic] = ACTIONS(1316),
    [anon_sym_compile_error] = ACTIONS(1316),
    [sym_location] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(423),
    [anon_sym_not] = ACTIONS(1316),
    [anon_sym_DASH_TILDE] = ACTIONS(445),
    [anon_sym_addressof] = ACTIONS(1316),
    [anon_sym_digestof] = ACTIONS(1316),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(445),
    [anon_sym_or] = ACTIONS(445),
    [anon_sym_xor] = ACTIONS(445),
    [anon_sym_isnt] = ACTIONS(445),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_PLUS_TILDE] = ACTIONS(445),
    [anon_sym_STAR_TILDE] = ACTIONS(445),
    [anon_sym_SLASH_TILDE] = ACTIONS(445),
    [anon_sym_PERCENT_TILDE] = ACTIONS(445),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(445),
    [anon_sym_LT_LT_TILDE] = ACTIONS(445),
    [anon_sym_GT_GT_TILDE] = ACTIONS(445),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(445),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(445),
    [anon_sym_GT_TILDE] = ACTIONS(445),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(445),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(445),
    [anon_sym_LT_TILDE] = ACTIONS(445),
    [anon_sym_PLUS_QMARK] = ACTIONS(445),
    [anon_sym_DASH_QMARK] = ACTIONS(445),
    [anon_sym_STAR_QMARK] = ACTIONS(445),
    [anon_sym_SLASH_QMARK] = ACTIONS(445),
    [anon_sym_PERCENT_QMARK] = ACTIONS(445),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(445),
    [anon_sym_as] = ACTIONS(447),
    [anon_sym_LPAREN2] = ACTIONS(449),
    [anon_sym_DOT_GT] = ACTIONS(451),
    [anon_sym_TILDE] = ACTIONS(453),
    [anon_sym_end] = ACTIONS(1316),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_ifdef] = ACTIONS(1316),
    [anon_sym_elseif] = ACTIONS(1316),
    [anon_sym_iftype] = ACTIONS(1316),
    [anon_sym_else] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1316),
    [anon_sym_while] = ACTIONS(1316),
    [anon_sym_try] = ACTIONS(1316),
    [anon_sym_with] = ACTIONS(1316),
    [anon_sym_repeat] = ACTIONS(1316),
    [anon_sym_recover] = ACTIONS(1316),
    [anon_sym_match] = ACTIONS(1316),
    [anon_sym_return] = ACTIONS(1316),
    [anon_sym_continue] = ACTIONS(1316),
    [anon_sym_break] = ACTIONS(1316),
    [anon_sym_consume] = ACTIONS(1316),
    [anon_sym_object] = ACTIONS(1316),
    [sym_number] = ACTIONS(1314),
    [sym_float] = ACTIONS(1316),
    [anon_sym_DQUOTE] = ACTIONS(1314),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1316),
    [anon_sym_true] = ACTIONS(1316),
    [anon_sym_false] = ACTIONS(1316),
    [sym_this] = ACTIONS(1316),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [482] = {
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_EQ] = ACTIONS(1012),
    [anon_sym_AT] = ACTIONS(1010),
    [anon_sym_LBRACK] = ACTIONS(1010),
    [anon_sym_is] = ACTIONS(1012),
    [anon_sym_let] = ACTIONS(1010),
    [anon_sym_var] = ACTIONS(1010),
    [anon_sym_COLON] = ACTIONS(1368),
    [anon_sym_LPAREN] = ACTIONS(1012),
    [anon_sym_DOT] = ACTIONS(1012),
    [anon_sym_LBRACE] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(1010),
    [sym_error] = ACTIONS(1010),
    [sym_compile_intrinsic] = ACTIONS(1010),
    [anon_sym_compile_error] = ACTIONS(1010),
    [sym_location] = ACTIONS(1010),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_not] = ACTIONS(1010),
    [anon_sym_DASH_TILDE] = ACTIONS(1010),
    [anon_sym_addressof] = ACTIONS(1010),
    [anon_sym_digestof] = ACTIONS(1010),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_STAR] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1012),
    [anon_sym_PERCENT] = ACTIONS(1012),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1012),
    [anon_sym_LT_LT] = ACTIONS(1012),
    [anon_sym_GT_GT] = ACTIONS(1012),
    [anon_sym_and] = ACTIONS(1010),
    [anon_sym_or] = ACTIONS(1010),
    [anon_sym_xor] = ACTIONS(1010),
    [anon_sym_isnt] = ACTIONS(1010),
    [anon_sym_EQ_EQ] = ACTIONS(1012),
    [anon_sym_BANG_EQ] = ACTIONS(1012),
    [anon_sym_GT] = ACTIONS(1012),
    [anon_sym_GT_EQ] = ACTIONS(1012),
    [anon_sym_LT_EQ] = ACTIONS(1012),
    [anon_sym_LT] = ACTIONS(1012),
    [anon_sym_PLUS_TILDE] = ACTIONS(1010),
    [anon_sym_STAR_TILDE] = ACTIONS(1010),
    [anon_sym_SLASH_TILDE] = ACTIONS(1010),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1010),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1010),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1010),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1010),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1010),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1010),
    [anon_sym_GT_TILDE] = ACTIONS(1010),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1010),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1010),
    [anon_sym_LT_TILDE] = ACTIONS(1010),
    [anon_sym_PLUS_QMARK] = ACTIONS(1010),
    [anon_sym_DASH_QMARK] = ACTIONS(1010),
    [anon_sym_STAR_QMARK] = ACTIONS(1010),
    [anon_sym_SLASH_QMARK] = ACTIONS(1010),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1010),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1010),
    [anon_sym_as] = ACTIONS(1010),
    [anon_sym_LPAREN2] = ACTIONS(1010),
    [anon_sym_DOT_GT] = ACTIONS(1010),
    [anon_sym_TILDE] = ACTIONS(1010),
    [anon_sym_end] = ACTIONS(1010),
    [anon_sym_if] = ACTIONS(1012),
    [anon_sym_ifdef] = ACTIONS(1010),
    [anon_sym_elseif] = ACTIONS(1010),
    [anon_sym_iftype] = ACTIONS(1010),
    [anon_sym_else] = ACTIONS(1012),
    [anon_sym_for] = ACTIONS(1010),
    [anon_sym_while] = ACTIONS(1010),
    [anon_sym_try] = ACTIONS(1010),
    [anon_sym_with] = ACTIONS(1010),
    [anon_sym_repeat] = ACTIONS(1010),
    [anon_sym_recover] = ACTIONS(1010),
    [anon_sym_match] = ACTIONS(1010),
    [anon_sym_return] = ACTIONS(1010),
    [anon_sym_continue] = ACTIONS(1010),
    [anon_sym_break] = ACTIONS(1010),
    [anon_sym_consume] = ACTIONS(1010),
    [anon_sym_object] = ACTIONS(1010),
    [sym_number] = ACTIONS(1012),
    [sym_float] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1012),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1010),
    [anon_sym_SQUOTE] = ACTIONS(1010),
    [anon_sym_true] = ACTIONS(1010),
    [anon_sym_false] = ACTIONS(1010),
    [sym_this] = ACTIONS(1010),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [483] = {
    [sym_identifier] = ACTIONS(1008),
    [anon_sym_EQ] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1006),
    [anon_sym_is] = ACTIONS(1008),
    [anon_sym_let] = ACTIONS(1006),
    [anon_sym_var] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(1008),
    [anon_sym_DOT] = ACTIONS(1008),
    [anon_sym_LBRACE] = ACTIONS(1006),
    [anon_sym_SEMI] = ACTIONS(1006),
    [sym_error] = ACTIONS(1006),
    [sym_compile_intrinsic] = ACTIONS(1006),
    [anon_sym_compile_error] = ACTIONS(1006),
    [sym_location] = ACTIONS(1006),
    [anon_sym_DASH] = ACTIONS(1008),
    [anon_sym_not] = ACTIONS(1006),
    [anon_sym_DASH_TILDE] = ACTIONS(1006),
    [anon_sym_addressof] = ACTIONS(1006),
    [anon_sym_digestof] = ACTIONS(1006),
    [anon_sym_PLUS] = ACTIONS(1008),
    [anon_sym_STAR] = ACTIONS(1008),
    [anon_sym_SLASH] = ACTIONS(1008),
    [anon_sym_PERCENT] = ACTIONS(1008),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1008),
    [anon_sym_LT_LT] = ACTIONS(1008),
    [anon_sym_GT_GT] = ACTIONS(1008),
    [anon_sym_and] = ACTIONS(1006),
    [anon_sym_or] = ACTIONS(1006),
    [anon_sym_xor] = ACTIONS(1006),
    [anon_sym_isnt] = ACTIONS(1006),
    [anon_sym_EQ_EQ] = ACTIONS(1008),
    [anon_sym_BANG_EQ] = ACTIONS(1008),
    [anon_sym_GT] = ACTIONS(1008),
    [anon_sym_GT_EQ] = ACTIONS(1008),
    [anon_sym_LT_EQ] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(1008),
    [anon_sym_PLUS_TILDE] = ACTIONS(1006),
    [anon_sym_STAR_TILDE] = ACTIONS(1006),
    [anon_sym_SLASH_TILDE] = ACTIONS(1006),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1006),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1006),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1006),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1006),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1006),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1006),
    [anon_sym_GT_TILDE] = ACTIONS(1006),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1006),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1006),
    [anon_sym_LT_TILDE] = ACTIONS(1006),
    [anon_sym_PLUS_QMARK] = ACTIONS(1006),
    [anon_sym_DASH_QMARK] = ACTIONS(1006),
    [anon_sym_STAR_QMARK] = ACTIONS(1006),
    [anon_sym_SLASH_QMARK] = ACTIONS(1006),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1006),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1006),
    [anon_sym_as] = ACTIONS(1006),
    [anon_sym_LPAREN2] = ACTIONS(1006),
    [anon_sym_DOT_GT] = ACTIONS(1006),
    [anon_sym_TILDE] = ACTIONS(1006),
    [anon_sym_end] = ACTIONS(1006),
    [anon_sym_if] = ACTIONS(1008),
    [anon_sym_ifdef] = ACTIONS(1006),
    [anon_sym_elseif] = ACTIONS(1006),
    [anon_sym_iftype] = ACTIONS(1006),
    [anon_sym_else] = ACTIONS(1008),
    [anon_sym_for] = ACTIONS(1006),
    [anon_sym_while] = ACTIONS(1006),
    [anon_sym_try] = ACTIONS(1006),
    [anon_sym_with] = ACTIONS(1006),
    [anon_sym_repeat] = ACTIONS(1006),
    [anon_sym_recover] = ACTIONS(1006),
    [anon_sym_match] = ACTIONS(1006),
    [anon_sym_return] = ACTIONS(1006),
    [anon_sym_continue] = ACTIONS(1006),
    [anon_sym_break] = ACTIONS(1006),
    [anon_sym_consume] = ACTIONS(1006),
    [anon_sym_object] = ACTIONS(1006),
    [sym_number] = ACTIONS(1008),
    [sym_float] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(1006),
    [anon_sym_true] = ACTIONS(1006),
    [anon_sym_false] = ACTIONS(1006),
    [sym_this] = ACTIONS(1006),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(1006),
    [sym_block_comment] = ACTIONS(3),
  },
  [484] = {
    [sym_identifier] = ACTIONS(1034),
    [anon_sym_EQ] = ACTIONS(1034),
    [anon_sym_AT] = ACTIONS(1032),
    [anon_sym_LBRACK] = ACTIONS(1032),
    [anon_sym_QMARK] = ACTIONS(1032),
    [anon_sym_is] = ACTIONS(1034),
    [anon_sym_let] = ACTIONS(1032),
    [anon_sym_var] = ACTIONS(1032),
    [anon_sym_LPAREN] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [anon_sym_SEMI] = ACTIONS(1032),
    [sym_error] = ACTIONS(1032),
    [sym_compile_intrinsic] = ACTIONS(1032),
    [anon_sym_compile_error] = ACTIONS(1032),
    [sym_location] = ACTIONS(1032),
    [anon_sym_DASH] = ACTIONS(1034),
    [anon_sym_not] = ACTIONS(1032),
    [anon_sym_DASH_TILDE] = ACTIONS(1032),
    [anon_sym_addressof] = ACTIONS(1032),
    [anon_sym_digestof] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_STAR] = ACTIONS(1034),
    [anon_sym_SLASH] = ACTIONS(1034),
    [anon_sym_PERCENT] = ACTIONS(1034),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1034),
    [anon_sym_LT_LT] = ACTIONS(1034),
    [anon_sym_GT_GT] = ACTIONS(1034),
    [anon_sym_and] = ACTIONS(1032),
    [anon_sym_or] = ACTIONS(1032),
    [anon_sym_xor] = ACTIONS(1032),
    [anon_sym_isnt] = ACTIONS(1032),
    [anon_sym_EQ_EQ] = ACTIONS(1034),
    [anon_sym_BANG_EQ] = ACTIONS(1034),
    [anon_sym_GT] = ACTIONS(1034),
    [anon_sym_GT_EQ] = ACTIONS(1034),
    [anon_sym_LT_EQ] = ACTIONS(1034),
    [anon_sym_LT] = ACTIONS(1034),
    [anon_sym_PLUS_TILDE] = ACTIONS(1032),
    [anon_sym_STAR_TILDE] = ACTIONS(1032),
    [anon_sym_SLASH_TILDE] = ACTIONS(1032),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1032),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1032),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1032),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1032),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1032),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1032),
    [anon_sym_GT_TILDE] = ACTIONS(1032),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1032),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1032),
    [anon_sym_LT_TILDE] = ACTIONS(1032),
    [anon_sym_PLUS_QMARK] = ACTIONS(1032),
    [anon_sym_DASH_QMARK] = ACTIONS(1032),
    [anon_sym_STAR_QMARK] = ACTIONS(1032),
    [anon_sym_SLASH_QMARK] = ACTIONS(1032),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1032),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1032),
    [anon_sym_as] = ACTIONS(1032),
    [anon_sym_LPAREN2] = ACTIONS(1032),
    [anon_sym_DOT_GT] = ACTIONS(1032),
    [anon_sym_TILDE] = ACTIONS(1032),
    [anon_sym_end] = ACTIONS(1032),
    [anon_sym_if] = ACTIONS(1034),
    [anon_sym_ifdef] = ACTIONS(1032),
    [anon_sym_elseif] = ACTIONS(1032),
    [anon_sym_iftype] = ACTIONS(1032),
    [anon_sym_else] = ACTIONS(1034),
    [anon_sym_for] = ACTIONS(1032),
    [anon_sym_while] = ACTIONS(1032),
    [anon_sym_try] = ACTIONS(1032),
    [anon_sym_with] = ACTIONS(1032),
    [anon_sym_repeat] = ACTIONS(1032),
    [anon_sym_recover] = ACTIONS(1032),
    [anon_sym_match] = ACTIONS(1032),
    [anon_sym_return] = ACTIONS(1032),
    [anon_sym_continue] = ACTIONS(1032),
    [anon_sym_break] = ACTIONS(1032),
    [anon_sym_consume] = ACTIONS(1032),
    [anon_sym_object] = ACTIONS(1032),
    [sym_number] = ACTIONS(1034),
    [sym_float] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(1034),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1032),
    [anon_sym_SQUOTE] = ACTIONS(1032),
    [anon_sym_true] = ACTIONS(1032),
    [anon_sym_false] = ACTIONS(1032),
    [sym_this] = ACTIONS(1032),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [485] = {
    [sym_arguments] = STATE(494),
    [sym_identifier] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(1318),
    [anon_sym_AT] = ACTIONS(1320),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_is] = ACTIONS(1318),
    [anon_sym_let] = ACTIONS(1320),
    [anon_sym_var] = ACTIONS(1320),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(1320),
    [anon_sym_SEMI] = ACTIONS(1320),
    [sym_error] = ACTIONS(1320),
    [sym_compile_intrinsic] = ACTIONS(1320),
    [anon_sym_compile_error] = ACTIONS(1320),
    [sym_location] = ACTIONS(1320),
    [anon_sym_DASH] = ACTIONS(1318),
    [anon_sym_not] = ACTIONS(1320),
    [anon_sym_DASH_TILDE] = ACTIONS(1320),
    [anon_sym_addressof] = ACTIONS(1320),
    [anon_sym_digestof] = ACTIONS(1320),
    [anon_sym_PLUS] = ACTIONS(1318),
    [anon_sym_STAR] = ACTIONS(1318),
    [anon_sym_SLASH] = ACTIONS(1318),
    [anon_sym_PERCENT] = ACTIONS(1318),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1318),
    [anon_sym_LT_LT] = ACTIONS(1318),
    [anon_sym_GT_GT] = ACTIONS(1318),
    [anon_sym_and] = ACTIONS(1320),
    [anon_sym_or] = ACTIONS(1320),
    [anon_sym_xor] = ACTIONS(1320),
    [anon_sym_isnt] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1318),
    [anon_sym_BANG_EQ] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(1318),
    [anon_sym_GT_EQ] = ACTIONS(1318),
    [anon_sym_LT_EQ] = ACTIONS(1318),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_PLUS_TILDE] = ACTIONS(1320),
    [anon_sym_STAR_TILDE] = ACTIONS(1320),
    [anon_sym_SLASH_TILDE] = ACTIONS(1320),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1320),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1320),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1320),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1320),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_GT_TILDE] = ACTIONS(1320),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_LT_TILDE] = ACTIONS(1320),
    [anon_sym_PLUS_QMARK] = ACTIONS(1320),
    [anon_sym_DASH_QMARK] = ACTIONS(1320),
    [anon_sym_STAR_QMARK] = ACTIONS(1320),
    [anon_sym_SLASH_QMARK] = ACTIONS(1320),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1320),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1320),
    [anon_sym_as] = ACTIONS(1320),
    [anon_sym_LPAREN2] = ACTIONS(449),
    [anon_sym_DOT_GT] = ACTIONS(451),
    [anon_sym_TILDE] = ACTIONS(453),
    [anon_sym_end] = ACTIONS(1320),
    [anon_sym_if] = ACTIONS(1318),
    [anon_sym_ifdef] = ACTIONS(1320),
    [anon_sym_elseif] = ACTIONS(1320),
    [anon_sym_iftype] = ACTIONS(1320),
    [anon_sym_else] = ACTIONS(1318),
    [anon_sym_for] = ACTIONS(1320),
    [anon_sym_while] = ACTIONS(1320),
    [anon_sym_try] = ACTIONS(1320),
    [anon_sym_with] = ACTIONS(1320),
    [anon_sym_repeat] = ACTIONS(1320),
    [anon_sym_recover] = ACTIONS(1320),
    [anon_sym_match] = ACTIONS(1320),
    [anon_sym_return] = ACTIONS(1320),
    [anon_sym_continue] = ACTIONS(1320),
    [anon_sym_break] = ACTIONS(1320),
    [anon_sym_consume] = ACTIONS(1320),
    [anon_sym_object] = ACTIONS(1320),
    [sym_number] = ACTIONS(1318),
    [sym_float] = ACTIONS(1320),
    [anon_sym_DQUOTE] = ACTIONS(1318),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1320),
    [anon_sym_SQUOTE] = ACTIONS(1320),
    [anon_sym_true] = ACTIONS(1320),
    [anon_sym_false] = ACTIONS(1320),
    [sym_this] = ACTIONS(1320),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [486] = {
    [sym_arguments] = STATE(494),
    [sym_identifier] = ACTIONS(1038),
    [anon_sym_EQ] = ACTIONS(1038),
    [anon_sym_AT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_is] = ACTIONS(1038),
    [anon_sym_let] = ACTIONS(1036),
    [anon_sym_var] = ACTIONS(1036),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [anon_sym_DOT] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(1036),
    [anon_sym_SEMI] = ACTIONS(1036),
    [sym_error] = ACTIONS(1036),
    [sym_compile_intrinsic] = ACTIONS(1036),
    [anon_sym_compile_error] = ACTIONS(1036),
    [sym_location] = ACTIONS(1036),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_not] = ACTIONS(1036),
    [anon_sym_DASH_TILDE] = ACTIONS(1036),
    [anon_sym_addressof] = ACTIONS(1036),
    [anon_sym_digestof] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_PERCENT] = ACTIONS(1038),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1038),
    [anon_sym_LT_LT] = ACTIONS(1038),
    [anon_sym_GT_GT] = ACTIONS(1038),
    [anon_sym_and] = ACTIONS(1036),
    [anon_sym_or] = ACTIONS(1036),
    [anon_sym_xor] = ACTIONS(1036),
    [anon_sym_isnt] = ACTIONS(1036),
    [anon_sym_EQ_EQ] = ACTIONS(1038),
    [anon_sym_BANG_EQ] = ACTIONS(1038),
    [anon_sym_GT] = ACTIONS(1038),
    [anon_sym_GT_EQ] = ACTIONS(1038),
    [anon_sym_LT_EQ] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1038),
    [anon_sym_PLUS_TILDE] = ACTIONS(1036),
    [anon_sym_STAR_TILDE] = ACTIONS(1036),
    [anon_sym_SLASH_TILDE] = ACTIONS(1036),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1036),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1036),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1036),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1036),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1036),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1036),
    [anon_sym_GT_TILDE] = ACTIONS(1036),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1036),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1036),
    [anon_sym_LT_TILDE] = ACTIONS(1036),
    [anon_sym_PLUS_QMARK] = ACTIONS(1036),
    [anon_sym_DASH_QMARK] = ACTIONS(1036),
    [anon_sym_STAR_QMARK] = ACTIONS(1036),
    [anon_sym_SLASH_QMARK] = ACTIONS(1036),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1036),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1036),
    [anon_sym_as] = ACTIONS(1036),
    [anon_sym_LPAREN2] = ACTIONS(1036),
    [anon_sym_DOT_GT] = ACTIONS(1036),
    [anon_sym_TILDE] = ACTIONS(1036),
    [anon_sym_end] = ACTIONS(1036),
    [anon_sym_if] = ACTIONS(1038),
    [anon_sym_ifdef] = ACTIONS(1036),
    [anon_sym_elseif] = ACTIONS(1036),
    [anon_sym_iftype] = ACTIONS(1036),
    [anon_sym_else] = ACTIONS(1038),
    [anon_sym_for] = ACTIONS(1036),
    [anon_sym_while] = ACTIONS(1036),
    [anon_sym_try] = ACTIONS(1036),
    [anon_sym_with] = ACTIONS(1036),
    [anon_sym_repeat] = ACTIONS(1036),
    [anon_sym_recover] = ACTIONS(1036),
    [anon_sym_match] = ACTIONS(1036),
    [anon_sym_return] = ACTIONS(1036),
    [anon_sym_continue] = ACTIONS(1036),
    [anon_sym_break] = ACTIONS(1036),
    [anon_sym_consume] = ACTIONS(1036),
    [anon_sym_object] = ACTIONS(1036),
    [sym_number] = ACTIONS(1038),
    [sym_float] = ACTIONS(1036),
    [anon_sym_DQUOTE] = ACTIONS(1038),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1036),
    [anon_sym_SQUOTE] = ACTIONS(1036),
    [anon_sym_true] = ACTIONS(1036),
    [anon_sym_false] = ACTIONS(1036),
    [sym_this] = ACTIONS(1036),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [487] = {
    [sym_arguments] = STATE(494),
    [sym_identifier] = ACTIONS(1000),
    [anon_sym_EQ] = ACTIONS(1000),
    [anon_sym_AT] = ACTIONS(998),
    [anon_sym_LBRACK] = ACTIONS(998),
    [anon_sym_is] = ACTIONS(1000),
    [anon_sym_let] = ACTIONS(998),
    [anon_sym_var] = ACTIONS(998),
    [anon_sym_LPAREN] = ACTIONS(1000),
    [anon_sym_DOT] = ACTIONS(1000),
    [anon_sym_LBRACE] = ACTIONS(998),
    [anon_sym_SEMI] = ACTIONS(998),
    [sym_error] = ACTIONS(998),
    [sym_compile_intrinsic] = ACTIONS(998),
    [anon_sym_compile_error] = ACTIONS(998),
    [sym_location] = ACTIONS(998),
    [anon_sym_DASH] = ACTIONS(1000),
    [anon_sym_not] = ACTIONS(998),
    [anon_sym_DASH_TILDE] = ACTIONS(998),
    [anon_sym_addressof] = ACTIONS(998),
    [anon_sym_digestof] = ACTIONS(998),
    [anon_sym_PLUS] = ACTIONS(1000),
    [anon_sym_STAR] = ACTIONS(1000),
    [anon_sym_SLASH] = ACTIONS(1000),
    [anon_sym_PERCENT] = ACTIONS(1000),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1000),
    [anon_sym_LT_LT] = ACTIONS(1000),
    [anon_sym_GT_GT] = ACTIONS(1000),
    [anon_sym_and] = ACTIONS(998),
    [anon_sym_or] = ACTIONS(998),
    [anon_sym_xor] = ACTIONS(998),
    [anon_sym_isnt] = ACTIONS(998),
    [anon_sym_EQ_EQ] = ACTIONS(1000),
    [anon_sym_BANG_EQ] = ACTIONS(1000),
    [anon_sym_GT] = ACTIONS(1000),
    [anon_sym_GT_EQ] = ACTIONS(1000),
    [anon_sym_LT_EQ] = ACTIONS(1000),
    [anon_sym_LT] = ACTIONS(1000),
    [anon_sym_PLUS_TILDE] = ACTIONS(998),
    [anon_sym_STAR_TILDE] = ACTIONS(998),
    [anon_sym_SLASH_TILDE] = ACTIONS(998),
    [anon_sym_PERCENT_TILDE] = ACTIONS(998),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(998),
    [anon_sym_LT_LT_TILDE] = ACTIONS(998),
    [anon_sym_GT_GT_TILDE] = ACTIONS(998),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(998),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(998),
    [anon_sym_GT_TILDE] = ACTIONS(998),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(998),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(998),
    [anon_sym_LT_TILDE] = ACTIONS(998),
    [anon_sym_PLUS_QMARK] = ACTIONS(998),
    [anon_sym_DASH_QMARK] = ACTIONS(998),
    [anon_sym_STAR_QMARK] = ACTIONS(998),
    [anon_sym_SLASH_QMARK] = ACTIONS(998),
    [anon_sym_PERCENT_QMARK] = ACTIONS(998),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(998),
    [anon_sym_as] = ACTIONS(998),
    [anon_sym_LPAREN2] = ACTIONS(998),
    [anon_sym_DOT_GT] = ACTIONS(998),
    [anon_sym_TILDE] = ACTIONS(998),
    [anon_sym_end] = ACTIONS(998),
    [anon_sym_if] = ACTIONS(1000),
    [anon_sym_ifdef] = ACTIONS(998),
    [anon_sym_elseif] = ACTIONS(998),
    [anon_sym_iftype] = ACTIONS(998),
    [anon_sym_else] = ACTIONS(1000),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_while] = ACTIONS(998),
    [anon_sym_try] = ACTIONS(998),
    [anon_sym_with] = ACTIONS(998),
    [anon_sym_repeat] = ACTIONS(998),
    [anon_sym_recover] = ACTIONS(998),
    [anon_sym_match] = ACTIONS(998),
    [anon_sym_return] = ACTIONS(998),
    [anon_sym_continue] = ACTIONS(998),
    [anon_sym_break] = ACTIONS(998),
    [anon_sym_consume] = ACTIONS(998),
    [anon_sym_object] = ACTIONS(998),
    [sym_number] = ACTIONS(1000),
    [sym_float] = ACTIONS(998),
    [anon_sym_DQUOTE] = ACTIONS(1000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(998),
    [anon_sym_SQUOTE] = ACTIONS(998),
    [anon_sym_true] = ACTIONS(998),
    [anon_sym_false] = ACTIONS(998),
    [sym_this] = ACTIONS(998),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [488] = {
    [sym_identifier] = ACTIONS(1050),
    [anon_sym_EQ] = ACTIONS(1050),
    [anon_sym_AT] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(1048),
    [anon_sym_QMARK] = ACTIONS(1048),
    [anon_sym_is] = ACTIONS(1050),
    [anon_sym_let] = ACTIONS(1048),
    [anon_sym_var] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(1050),
    [anon_sym_DOT] = ACTIONS(1050),
    [anon_sym_LBRACE] = ACTIONS(1048),
    [anon_sym_SEMI] = ACTIONS(1048),
    [sym_error] = ACTIONS(1048),
    [sym_compile_intrinsic] = ACTIONS(1048),
    [anon_sym_compile_error] = ACTIONS(1048),
    [sym_location] = ACTIONS(1048),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_not] = ACTIONS(1048),
    [anon_sym_DASH_TILDE] = ACTIONS(1048),
    [anon_sym_addressof] = ACTIONS(1048),
    [anon_sym_digestof] = ACTIONS(1048),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_STAR] = ACTIONS(1050),
    [anon_sym_SLASH] = ACTIONS(1050),
    [anon_sym_PERCENT] = ACTIONS(1050),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1050),
    [anon_sym_LT_LT] = ACTIONS(1050),
    [anon_sym_GT_GT] = ACTIONS(1050),
    [anon_sym_and] = ACTIONS(1048),
    [anon_sym_or] = ACTIONS(1048),
    [anon_sym_xor] = ACTIONS(1048),
    [anon_sym_isnt] = ACTIONS(1048),
    [anon_sym_EQ_EQ] = ACTIONS(1050),
    [anon_sym_BANG_EQ] = ACTIONS(1050),
    [anon_sym_GT] = ACTIONS(1050),
    [anon_sym_GT_EQ] = ACTIONS(1050),
    [anon_sym_LT_EQ] = ACTIONS(1050),
    [anon_sym_LT] = ACTIONS(1050),
    [anon_sym_PLUS_TILDE] = ACTIONS(1048),
    [anon_sym_STAR_TILDE] = ACTIONS(1048),
    [anon_sym_SLASH_TILDE] = ACTIONS(1048),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1048),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1048),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1048),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1048),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1048),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1048),
    [anon_sym_GT_TILDE] = ACTIONS(1048),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1048),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1048),
    [anon_sym_LT_TILDE] = ACTIONS(1048),
    [anon_sym_PLUS_QMARK] = ACTIONS(1048),
    [anon_sym_DASH_QMARK] = ACTIONS(1048),
    [anon_sym_STAR_QMARK] = ACTIONS(1048),
    [anon_sym_SLASH_QMARK] = ACTIONS(1048),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1048),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1048),
    [anon_sym_as] = ACTIONS(1048),
    [anon_sym_LPAREN2] = ACTIONS(1048),
    [anon_sym_DOT_GT] = ACTIONS(1048),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_end] = ACTIONS(1048),
    [anon_sym_if] = ACTIONS(1050),
    [anon_sym_ifdef] = ACTIONS(1048),
    [anon_sym_elseif] = ACTIONS(1048),
    [anon_sym_iftype] = ACTIONS(1048),
    [anon_sym_else] = ACTIONS(1050),
    [anon_sym_for] = ACTIONS(1048),
    [anon_sym_while] = ACTIONS(1048),
    [anon_sym_try] = ACTIONS(1048),
    [anon_sym_with] = ACTIONS(1048),
    [anon_sym_repeat] = ACTIONS(1048),
    [anon_sym_recover] = ACTIONS(1048),
    [anon_sym_match] = ACTIONS(1048),
    [anon_sym_return] = ACTIONS(1048),
    [anon_sym_continue] = ACTIONS(1048),
    [anon_sym_break] = ACTIONS(1048),
    [anon_sym_consume] = ACTIONS(1048),
    [anon_sym_object] = ACTIONS(1048),
    [sym_number] = ACTIONS(1050),
    [sym_float] = ACTIONS(1048),
    [anon_sym_DQUOTE] = ACTIONS(1050),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1048),
    [anon_sym_SQUOTE] = ACTIONS(1048),
    [anon_sym_true] = ACTIONS(1048),
    [anon_sym_false] = ACTIONS(1048),
    [sym_this] = ACTIONS(1048),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [489] = {
    [sym_identifier] = ACTIONS(1004),
    [anon_sym_EQ] = ACTIONS(1004),
    [anon_sym_AT] = ACTIONS(1002),
    [anon_sym_LBRACK] = ACTIONS(1002),
    [anon_sym_QMARK] = ACTIONS(1002),
    [anon_sym_is] = ACTIONS(1004),
    [anon_sym_let] = ACTIONS(1002),
    [anon_sym_var] = ACTIONS(1002),
    [anon_sym_LPAREN] = ACTIONS(1004),
    [anon_sym_DOT] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1002),
    [anon_sym_SEMI] = ACTIONS(1002),
    [sym_error] = ACTIONS(1002),
    [sym_compile_intrinsic] = ACTIONS(1002),
    [anon_sym_compile_error] = ACTIONS(1002),
    [sym_location] = ACTIONS(1002),
    [anon_sym_DASH] = ACTIONS(1004),
    [anon_sym_not] = ACTIONS(1002),
    [anon_sym_DASH_TILDE] = ACTIONS(1002),
    [anon_sym_addressof] = ACTIONS(1002),
    [anon_sym_digestof] = ACTIONS(1002),
    [anon_sym_PLUS] = ACTIONS(1004),
    [anon_sym_STAR] = ACTIONS(1004),
    [anon_sym_SLASH] = ACTIONS(1004),
    [anon_sym_PERCENT] = ACTIONS(1004),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1004),
    [anon_sym_LT_LT] = ACTIONS(1004),
    [anon_sym_GT_GT] = ACTIONS(1004),
    [anon_sym_and] = ACTIONS(1002),
    [anon_sym_or] = ACTIONS(1002),
    [anon_sym_xor] = ACTIONS(1002),
    [anon_sym_isnt] = ACTIONS(1002),
    [anon_sym_EQ_EQ] = ACTIONS(1004),
    [anon_sym_BANG_EQ] = ACTIONS(1004),
    [anon_sym_GT] = ACTIONS(1004),
    [anon_sym_GT_EQ] = ACTIONS(1004),
    [anon_sym_LT_EQ] = ACTIONS(1004),
    [anon_sym_LT] = ACTIONS(1004),
    [anon_sym_PLUS_TILDE] = ACTIONS(1002),
    [anon_sym_STAR_TILDE] = ACTIONS(1002),
    [anon_sym_SLASH_TILDE] = ACTIONS(1002),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1002),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1002),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1002),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1002),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1002),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1002),
    [anon_sym_GT_TILDE] = ACTIONS(1002),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1002),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1002),
    [anon_sym_LT_TILDE] = ACTIONS(1002),
    [anon_sym_PLUS_QMARK] = ACTIONS(1002),
    [anon_sym_DASH_QMARK] = ACTIONS(1002),
    [anon_sym_STAR_QMARK] = ACTIONS(1002),
    [anon_sym_SLASH_QMARK] = ACTIONS(1002),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1002),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1002),
    [anon_sym_as] = ACTIONS(1002),
    [anon_sym_LPAREN2] = ACTIONS(1002),
    [anon_sym_DOT_GT] = ACTIONS(1002),
    [anon_sym_TILDE] = ACTIONS(1002),
    [anon_sym_end] = ACTIONS(1002),
    [anon_sym_if] = ACTIONS(1004),
    [anon_sym_ifdef] = ACTIONS(1002),
    [anon_sym_elseif] = ACTIONS(1002),
    [anon_sym_iftype] = ACTIONS(1002),
    [anon_sym_else] = ACTIONS(1004),
    [anon_sym_for] = ACTIONS(1002),
    [anon_sym_while] = ACTIONS(1002),
    [anon_sym_try] = ACTIONS(1002),
    [anon_sym_with] = ACTIONS(1002),
    [anon_sym_repeat] = ACTIONS(1002),
    [anon_sym_recover] = ACTIONS(1002),
    [anon_sym_match] = ACTIONS(1002),
    [anon_sym_return] = ACTIONS(1002),
    [anon_sym_continue] = ACTIONS(1002),
    [anon_sym_break] = ACTIONS(1002),
    [anon_sym_consume] = ACTIONS(1002),
    [anon_sym_object] = ACTIONS(1002),
    [sym_number] = ACTIONS(1004),
    [sym_float] = ACTIONS(1002),
    [anon_sym_DQUOTE] = ACTIONS(1004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1002),
    [anon_sym_SQUOTE] = ACTIONS(1002),
    [anon_sym_true] = ACTIONS(1002),
    [anon_sym_false] = ACTIONS(1002),
    [sym_this] = ACTIONS(1002),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [490] = {
    [sym_annotation] = STATE(577),
    [sym_capability] = STATE(676),
    [sym_block] = STATE(2482),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_iso] = ACTIONS(1366),
    [anon_sym_trn] = ACTIONS(1366),
    [anon_sym_ref] = ACTIONS(1366),
    [anon_sym_val] = ACTIONS(1366),
    [anon_sym_box] = ACTIONS(1366),
    [anon_sym_tag] = ACTIONS(1366),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [491] = {
    [sym_arguments] = STATE(494),
    [sym_identifier] = ACTIONS(1322),
    [anon_sym_EQ] = ACTIONS(1322),
    [anon_sym_AT] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(1324),
    [anon_sym_is] = ACTIONS(1322),
    [anon_sym_let] = ACTIONS(1324),
    [anon_sym_var] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(1322),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_SEMI] = ACTIONS(1324),
    [sym_error] = ACTIONS(1324),
    [sym_compile_intrinsic] = ACTIONS(1324),
    [anon_sym_compile_error] = ACTIONS(1324),
    [sym_location] = ACTIONS(1324),
    [anon_sym_DASH] = ACTIONS(1322),
    [anon_sym_not] = ACTIONS(1324),
    [anon_sym_DASH_TILDE] = ACTIONS(1324),
    [anon_sym_addressof] = ACTIONS(1324),
    [anon_sym_digestof] = ACTIONS(1324),
    [anon_sym_PLUS] = ACTIONS(1322),
    [anon_sym_STAR] = ACTIONS(1322),
    [anon_sym_SLASH] = ACTIONS(1322),
    [anon_sym_PERCENT] = ACTIONS(1322),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1322),
    [anon_sym_LT_LT] = ACTIONS(1322),
    [anon_sym_GT_GT] = ACTIONS(1322),
    [anon_sym_and] = ACTIONS(1324),
    [anon_sym_or] = ACTIONS(1324),
    [anon_sym_xor] = ACTIONS(1324),
    [anon_sym_isnt] = ACTIONS(1324),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_GT] = ACTIONS(1322),
    [anon_sym_GT_EQ] = ACTIONS(1322),
    [anon_sym_LT_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1322),
    [anon_sym_PLUS_TILDE] = ACTIONS(1324),
    [anon_sym_STAR_TILDE] = ACTIONS(1324),
    [anon_sym_SLASH_TILDE] = ACTIONS(1324),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1324),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1324),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1324),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1324),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1324),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1324),
    [anon_sym_GT_TILDE] = ACTIONS(1324),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1324),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1324),
    [anon_sym_LT_TILDE] = ACTIONS(1324),
    [anon_sym_PLUS_QMARK] = ACTIONS(1324),
    [anon_sym_DASH_QMARK] = ACTIONS(1324),
    [anon_sym_STAR_QMARK] = ACTIONS(1324),
    [anon_sym_SLASH_QMARK] = ACTIONS(1324),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1324),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1324),
    [anon_sym_as] = ACTIONS(447),
    [anon_sym_LPAREN2] = ACTIONS(449),
    [anon_sym_DOT_GT] = ACTIONS(451),
    [anon_sym_TILDE] = ACTIONS(453),
    [anon_sym_end] = ACTIONS(1324),
    [anon_sym_if] = ACTIONS(1322),
    [anon_sym_ifdef] = ACTIONS(1324),
    [anon_sym_elseif] = ACTIONS(1324),
    [anon_sym_iftype] = ACTIONS(1324),
    [anon_sym_else] = ACTIONS(1322),
    [anon_sym_for] = ACTIONS(1324),
    [anon_sym_while] = ACTIONS(1324),
    [anon_sym_try] = ACTIONS(1324),
    [anon_sym_with] = ACTIONS(1324),
    [anon_sym_repeat] = ACTIONS(1324),
    [anon_sym_recover] = ACTIONS(1324),
    [anon_sym_match] = ACTIONS(1324),
    [anon_sym_return] = ACTIONS(1324),
    [anon_sym_continue] = ACTIONS(1324),
    [anon_sym_break] = ACTIONS(1324),
    [anon_sym_consume] = ACTIONS(1324),
    [anon_sym_object] = ACTIONS(1324),
    [sym_number] = ACTIONS(1322),
    [sym_float] = ACTIONS(1324),
    [anon_sym_DQUOTE] = ACTIONS(1322),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1324),
    [anon_sym_SQUOTE] = ACTIONS(1324),
    [anon_sym_true] = ACTIONS(1324),
    [anon_sym_false] = ACTIONS(1324),
    [sym_this] = ACTIONS(1324),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [492] = {
    [sym_arguments] = STATE(494),
    [sym_identifier] = ACTIONS(66),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_AT] = ACTIONS(74),
    [anon_sym_LBRACK] = ACTIONS(74),
    [anon_sym_is] = ACTIONS(423),
    [anon_sym_let] = ACTIONS(74),
    [anon_sym_var] = ACTIONS(74),
    [anon_sym_LPAREN] = ACTIONS(66),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(74),
    [anon_sym_SEMI] = ACTIONS(74),
    [sym_error] = ACTIONS(74),
    [sym_compile_intrinsic] = ACTIONS(74),
    [anon_sym_compile_error] = ACTIONS(74),
    [sym_location] = ACTIONS(74),
    [anon_sym_DASH] = ACTIONS(423),
    [anon_sym_not] = ACTIONS(74),
    [anon_sym_DASH_TILDE] = ACTIONS(445),
    [anon_sym_addressof] = ACTIONS(74),
    [anon_sym_digestof] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(445),
    [anon_sym_or] = ACTIONS(445),
    [anon_sym_xor] = ACTIONS(445),
    [anon_sym_isnt] = ACTIONS(445),
    [anon_sym_EQ_EQ] = ACTIONS(423),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(423),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_PLUS_TILDE] = ACTIONS(445),
    [anon_sym_STAR_TILDE] = ACTIONS(445),
    [anon_sym_SLASH_TILDE] = ACTIONS(445),
    [anon_sym_PERCENT_TILDE] = ACTIONS(445),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(445),
    [anon_sym_LT_LT_TILDE] = ACTIONS(445),
    [anon_sym_GT_GT_TILDE] = ACTIONS(445),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(445),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(445),
    [anon_sym_GT_TILDE] = ACTIONS(445),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(445),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(445),
    [anon_sym_LT_TILDE] = ACTIONS(445),
    [anon_sym_PLUS_QMARK] = ACTIONS(445),
    [anon_sym_DASH_QMARK] = ACTIONS(445),
    [anon_sym_STAR_QMARK] = ACTIONS(445),
    [anon_sym_SLASH_QMARK] = ACTIONS(445),
    [anon_sym_PERCENT_QMARK] = ACTIONS(445),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(445),
    [anon_sym_as] = ACTIONS(447),
    [anon_sym_LPAREN2] = ACTIONS(449),
    [anon_sym_DOT_GT] = ACTIONS(451),
    [anon_sym_TILDE] = ACTIONS(453),
    [anon_sym_end] = ACTIONS(74),
    [anon_sym_if] = ACTIONS(66),
    [anon_sym_ifdef] = ACTIONS(74),
    [anon_sym_elseif] = ACTIONS(74),
    [anon_sym_iftype] = ACTIONS(74),
    [anon_sym_else] = ACTIONS(66),
    [anon_sym_for] = ACTIONS(74),
    [anon_sym_while] = ACTIONS(74),
    [anon_sym_try] = ACTIONS(74),
    [anon_sym_with] = ACTIONS(74),
    [anon_sym_repeat] = ACTIONS(74),
    [anon_sym_recover] = ACTIONS(74),
    [anon_sym_match] = ACTIONS(74),
    [anon_sym_return] = ACTIONS(74),
    [anon_sym_continue] = ACTIONS(74),
    [anon_sym_break] = ACTIONS(74),
    [anon_sym_consume] = ACTIONS(74),
    [anon_sym_object] = ACTIONS(74),
    [sym_number] = ACTIONS(66),
    [sym_float] = ACTIONS(74),
    [anon_sym_DQUOTE] = ACTIONS(66),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(74),
    [anon_sym_true] = ACTIONS(74),
    [anon_sym_false] = ACTIONS(74),
    [sym_this] = ACTIONS(74),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [493] = {
    [sym_arguments] = STATE(494),
    [sym_identifier] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(1318),
    [anon_sym_AT] = ACTIONS(1320),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_is] = ACTIONS(1318),
    [anon_sym_let] = ACTIONS(1320),
    [anon_sym_var] = ACTIONS(1320),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(1320),
    [anon_sym_SEMI] = ACTIONS(1320),
    [sym_error] = ACTIONS(1320),
    [sym_compile_intrinsic] = ACTIONS(1320),
    [anon_sym_compile_error] = ACTIONS(1320),
    [sym_location] = ACTIONS(1320),
    [anon_sym_DASH] = ACTIONS(1318),
    [anon_sym_not] = ACTIONS(1320),
    [anon_sym_DASH_TILDE] = ACTIONS(1320),
    [anon_sym_addressof] = ACTIONS(1320),
    [anon_sym_digestof] = ACTIONS(1320),
    [anon_sym_PLUS] = ACTIONS(1318),
    [anon_sym_STAR] = ACTIONS(1318),
    [anon_sym_SLASH] = ACTIONS(1318),
    [anon_sym_PERCENT] = ACTIONS(1318),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1318),
    [anon_sym_LT_LT] = ACTIONS(1318),
    [anon_sym_GT_GT] = ACTIONS(1318),
    [anon_sym_and] = ACTIONS(1320),
    [anon_sym_or] = ACTIONS(1320),
    [anon_sym_xor] = ACTIONS(1320),
    [anon_sym_isnt] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1318),
    [anon_sym_BANG_EQ] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(1318),
    [anon_sym_GT_EQ] = ACTIONS(1318),
    [anon_sym_LT_EQ] = ACTIONS(1318),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_PLUS_TILDE] = ACTIONS(1320),
    [anon_sym_STAR_TILDE] = ACTIONS(1320),
    [anon_sym_SLASH_TILDE] = ACTIONS(1320),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1320),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1320),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1320),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1320),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_GT_TILDE] = ACTIONS(1320),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_LT_TILDE] = ACTIONS(1320),
    [anon_sym_PLUS_QMARK] = ACTIONS(1320),
    [anon_sym_DASH_QMARK] = ACTIONS(1320),
    [anon_sym_STAR_QMARK] = ACTIONS(1320),
    [anon_sym_SLASH_QMARK] = ACTIONS(1320),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1320),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1320),
    [anon_sym_as] = ACTIONS(1320),
    [anon_sym_LPAREN2] = ACTIONS(449),
    [anon_sym_DOT_GT] = ACTIONS(451),
    [anon_sym_TILDE] = ACTIONS(453),
    [anon_sym_end] = ACTIONS(1320),
    [anon_sym_if] = ACTIONS(1318),
    [anon_sym_ifdef] = ACTIONS(1320),
    [anon_sym_elseif] = ACTIONS(1320),
    [anon_sym_iftype] = ACTIONS(1320),
    [anon_sym_else] = ACTIONS(1318),
    [anon_sym_for] = ACTIONS(1320),
    [anon_sym_while] = ACTIONS(1320),
    [anon_sym_try] = ACTIONS(1320),
    [anon_sym_with] = ACTIONS(1320),
    [anon_sym_repeat] = ACTIONS(1320),
    [anon_sym_recover] = ACTIONS(1320),
    [anon_sym_match] = ACTIONS(1320),
    [anon_sym_return] = ACTIONS(1320),
    [anon_sym_continue] = ACTIONS(1320),
    [anon_sym_break] = ACTIONS(1320),
    [anon_sym_consume] = ACTIONS(1320),
    [anon_sym_object] = ACTIONS(1320),
    [sym_number] = ACTIONS(1318),
    [sym_float] = ACTIONS(1320),
    [anon_sym_DQUOTE] = ACTIONS(1318),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1320),
    [anon_sym_SQUOTE] = ACTIONS(1320),
    [anon_sym_true] = ACTIONS(1320),
    [anon_sym_false] = ACTIONS(1320),
    [sym_this] = ACTIONS(1320),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [494] = {
    [sym_identifier] = ACTIONS(1062),
    [anon_sym_EQ] = ACTIONS(1062),
    [anon_sym_AT] = ACTIONS(1060),
    [anon_sym_LBRACK] = ACTIONS(1060),
    [anon_sym_QMARK] = ACTIONS(1370),
    [anon_sym_is] = ACTIONS(1062),
    [anon_sym_let] = ACTIONS(1060),
    [anon_sym_var] = ACTIONS(1060),
    [anon_sym_LPAREN] = ACTIONS(1062),
    [anon_sym_DOT] = ACTIONS(1062),
    [anon_sym_LBRACE] = ACTIONS(1060),
    [anon_sym_SEMI] = ACTIONS(1060),
    [sym_error] = ACTIONS(1060),
    [sym_compile_intrinsic] = ACTIONS(1060),
    [anon_sym_compile_error] = ACTIONS(1060),
    [sym_location] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1062),
    [anon_sym_not] = ACTIONS(1060),
    [anon_sym_DASH_TILDE] = ACTIONS(1060),
    [anon_sym_addressof] = ACTIONS(1060),
    [anon_sym_digestof] = ACTIONS(1060),
    [anon_sym_PLUS] = ACTIONS(1062),
    [anon_sym_STAR] = ACTIONS(1062),
    [anon_sym_SLASH] = ACTIONS(1062),
    [anon_sym_PERCENT] = ACTIONS(1062),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1062),
    [anon_sym_LT_LT] = ACTIONS(1062),
    [anon_sym_GT_GT] = ACTIONS(1062),
    [anon_sym_and] = ACTIONS(1060),
    [anon_sym_or] = ACTIONS(1060),
    [anon_sym_xor] = ACTIONS(1060),
    [anon_sym_isnt] = ACTIONS(1060),
    [anon_sym_EQ_EQ] = ACTIONS(1062),
    [anon_sym_BANG_EQ] = ACTIONS(1062),
    [anon_sym_GT] = ACTIONS(1062),
    [anon_sym_GT_EQ] = ACTIONS(1062),
    [anon_sym_LT_EQ] = ACTIONS(1062),
    [anon_sym_LT] = ACTIONS(1062),
    [anon_sym_PLUS_TILDE] = ACTIONS(1060),
    [anon_sym_STAR_TILDE] = ACTIONS(1060),
    [anon_sym_SLASH_TILDE] = ACTIONS(1060),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1060),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1060),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1060),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1060),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1060),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1060),
    [anon_sym_GT_TILDE] = ACTIONS(1060),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1060),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1060),
    [anon_sym_LT_TILDE] = ACTIONS(1060),
    [anon_sym_PLUS_QMARK] = ACTIONS(1060),
    [anon_sym_DASH_QMARK] = ACTIONS(1060),
    [anon_sym_STAR_QMARK] = ACTIONS(1060),
    [anon_sym_SLASH_QMARK] = ACTIONS(1060),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1060),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1060),
    [anon_sym_as] = ACTIONS(1060),
    [anon_sym_LPAREN2] = ACTIONS(1060),
    [anon_sym_DOT_GT] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1060),
    [anon_sym_end] = ACTIONS(1060),
    [anon_sym_if] = ACTIONS(1062),
    [anon_sym_ifdef] = ACTIONS(1060),
    [anon_sym_elseif] = ACTIONS(1060),
    [anon_sym_iftype] = ACTIONS(1060),
    [anon_sym_else] = ACTIONS(1062),
    [anon_sym_for] = ACTIONS(1060),
    [anon_sym_while] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1060),
    [anon_sym_with] = ACTIONS(1060),
    [anon_sym_repeat] = ACTIONS(1060),
    [anon_sym_recover] = ACTIONS(1060),
    [anon_sym_match] = ACTIONS(1060),
    [anon_sym_return] = ACTIONS(1060),
    [anon_sym_continue] = ACTIONS(1060),
    [anon_sym_break] = ACTIONS(1060),
    [anon_sym_consume] = ACTIONS(1060),
    [anon_sym_object] = ACTIONS(1060),
    [sym_number] = ACTIONS(1062),
    [sym_float] = ACTIONS(1060),
    [anon_sym_DQUOTE] = ACTIONS(1062),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1060),
    [anon_sym_SQUOTE] = ACTIONS(1060),
    [anon_sym_true] = ACTIONS(1060),
    [anon_sym_false] = ACTIONS(1060),
    [sym_this] = ACTIONS(1060),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [495] = {
    [sym_identifier] = ACTIONS(1030),
    [anon_sym_EQ] = ACTIONS(1030),
    [anon_sym_AT] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(1028),
    [anon_sym_is] = ACTIONS(1030),
    [anon_sym_let] = ACTIONS(1028),
    [anon_sym_var] = ACTIONS(1028),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_DOT] = ACTIONS(1030),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_SEMI] = ACTIONS(1028),
    [sym_error] = ACTIONS(1028),
    [sym_compile_intrinsic] = ACTIONS(1028),
    [anon_sym_compile_error] = ACTIONS(1028),
    [sym_location] = ACTIONS(1028),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_not] = ACTIONS(1028),
    [anon_sym_DASH_TILDE] = ACTIONS(1028),
    [anon_sym_addressof] = ACTIONS(1028),
    [anon_sym_digestof] = ACTIONS(1028),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_STAR] = ACTIONS(1030),
    [anon_sym_SLASH] = ACTIONS(1030),
    [anon_sym_PERCENT] = ACTIONS(1030),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1030),
    [anon_sym_LT_LT] = ACTIONS(1030),
    [anon_sym_GT_GT] = ACTIONS(1030),
    [anon_sym_and] = ACTIONS(1028),
    [anon_sym_or] = ACTIONS(1028),
    [anon_sym_xor] = ACTIONS(1028),
    [anon_sym_isnt] = ACTIONS(1028),
    [anon_sym_EQ_EQ] = ACTIONS(1030),
    [anon_sym_BANG_EQ] = ACTIONS(1030),
    [anon_sym_GT] = ACTIONS(1030),
    [anon_sym_GT_EQ] = ACTIONS(1030),
    [anon_sym_LT_EQ] = ACTIONS(1030),
    [anon_sym_LT] = ACTIONS(1030),
    [anon_sym_PLUS_TILDE] = ACTIONS(1028),
    [anon_sym_STAR_TILDE] = ACTIONS(1028),
    [anon_sym_SLASH_TILDE] = ACTIONS(1028),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1028),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1028),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1028),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1028),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1028),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1028),
    [anon_sym_GT_TILDE] = ACTIONS(1028),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1028),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1028),
    [anon_sym_LT_TILDE] = ACTIONS(1028),
    [anon_sym_PLUS_QMARK] = ACTIONS(1028),
    [anon_sym_DASH_QMARK] = ACTIONS(1028),
    [anon_sym_STAR_QMARK] = ACTIONS(1028),
    [anon_sym_SLASH_QMARK] = ACTIONS(1028),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1028),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1028),
    [anon_sym_as] = ACTIONS(1028),
    [anon_sym_LPAREN2] = ACTIONS(1028),
    [anon_sym_DOT_GT] = ACTIONS(1028),
    [anon_sym_TILDE] = ACTIONS(1028),
    [anon_sym_end] = ACTIONS(1028),
    [anon_sym_if] = ACTIONS(1030),
    [anon_sym_ifdef] = ACTIONS(1028),
    [anon_sym_elseif] = ACTIONS(1028),
    [anon_sym_iftype] = ACTIONS(1028),
    [anon_sym_else] = ACTIONS(1030),
    [anon_sym_for] = ACTIONS(1028),
    [anon_sym_while] = ACTIONS(1028),
    [anon_sym_try] = ACTIONS(1028),
    [anon_sym_with] = ACTIONS(1028),
    [anon_sym_repeat] = ACTIONS(1028),
    [anon_sym_recover] = ACTIONS(1028),
    [anon_sym_match] = ACTIONS(1028),
    [anon_sym_return] = ACTIONS(1028),
    [anon_sym_continue] = ACTIONS(1028),
    [anon_sym_break] = ACTIONS(1028),
    [anon_sym_consume] = ACTIONS(1028),
    [anon_sym_object] = ACTIONS(1028),
    [sym_number] = ACTIONS(1030),
    [sym_float] = ACTIONS(1028),
    [anon_sym_DQUOTE] = ACTIONS(1030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1028),
    [anon_sym_SQUOTE] = ACTIONS(1028),
    [anon_sym_true] = ACTIONS(1028),
    [anon_sym_false] = ACTIONS(1028),
    [sym_this] = ACTIONS(1028),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(1028),
    [sym_block_comment] = ACTIONS(3),
  },
  [496] = {
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_EQ] = ACTIONS(1018),
    [anon_sym_AT] = ACTIONS(1016),
    [anon_sym_LBRACK] = ACTIONS(1016),
    [anon_sym_is] = ACTIONS(1018),
    [anon_sym_let] = ACTIONS(1016),
    [anon_sym_var] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_DOT] = ACTIONS(1018),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_SEMI] = ACTIONS(1016),
    [sym_error] = ACTIONS(1016),
    [sym_compile_intrinsic] = ACTIONS(1016),
    [anon_sym_compile_error] = ACTIONS(1016),
    [sym_location] = ACTIONS(1016),
    [anon_sym_DASH] = ACTIONS(1018),
    [anon_sym_not] = ACTIONS(1016),
    [anon_sym_DASH_TILDE] = ACTIONS(1016),
    [anon_sym_addressof] = ACTIONS(1016),
    [anon_sym_digestof] = ACTIONS(1016),
    [anon_sym_PLUS] = ACTIONS(1018),
    [anon_sym_STAR] = ACTIONS(1018),
    [anon_sym_SLASH] = ACTIONS(1018),
    [anon_sym_PERCENT] = ACTIONS(1018),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1018),
    [anon_sym_LT_LT] = ACTIONS(1018),
    [anon_sym_GT_GT] = ACTIONS(1018),
    [anon_sym_and] = ACTIONS(1016),
    [anon_sym_or] = ACTIONS(1016),
    [anon_sym_xor] = ACTIONS(1016),
    [anon_sym_isnt] = ACTIONS(1016),
    [anon_sym_EQ_EQ] = ACTIONS(1018),
    [anon_sym_BANG_EQ] = ACTIONS(1018),
    [anon_sym_GT] = ACTIONS(1018),
    [anon_sym_GT_EQ] = ACTIONS(1018),
    [anon_sym_LT_EQ] = ACTIONS(1018),
    [anon_sym_LT] = ACTIONS(1018),
    [anon_sym_PLUS_TILDE] = ACTIONS(1016),
    [anon_sym_STAR_TILDE] = ACTIONS(1016),
    [anon_sym_SLASH_TILDE] = ACTIONS(1016),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1016),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1016),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1016),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1016),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1016),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1016),
    [anon_sym_GT_TILDE] = ACTIONS(1016),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1016),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1016),
    [anon_sym_LT_TILDE] = ACTIONS(1016),
    [anon_sym_PLUS_QMARK] = ACTIONS(1016),
    [anon_sym_DASH_QMARK] = ACTIONS(1016),
    [anon_sym_STAR_QMARK] = ACTIONS(1016),
    [anon_sym_SLASH_QMARK] = ACTIONS(1016),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1016),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1016),
    [anon_sym_as] = ACTIONS(1016),
    [anon_sym_LPAREN2] = ACTIONS(1016),
    [anon_sym_DOT_GT] = ACTIONS(1016),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_end] = ACTIONS(1016),
    [anon_sym_if] = ACTIONS(1018),
    [anon_sym_ifdef] = ACTIONS(1016),
    [anon_sym_elseif] = ACTIONS(1016),
    [anon_sym_iftype] = ACTIONS(1016),
    [anon_sym_else] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(1016),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_try] = ACTIONS(1016),
    [anon_sym_with] = ACTIONS(1016),
    [anon_sym_repeat] = ACTIONS(1016),
    [anon_sym_recover] = ACTIONS(1016),
    [anon_sym_match] = ACTIONS(1016),
    [anon_sym_return] = ACTIONS(1016),
    [anon_sym_continue] = ACTIONS(1016),
    [anon_sym_break] = ACTIONS(1016),
    [anon_sym_consume] = ACTIONS(1016),
    [anon_sym_object] = ACTIONS(1016),
    [sym_number] = ACTIONS(1018),
    [sym_float] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(1018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1016),
    [anon_sym_SQUOTE] = ACTIONS(1016),
    [anon_sym_true] = ACTIONS(1016),
    [anon_sym_false] = ACTIONS(1016),
    [sym_this] = ACTIONS(1016),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(1016),
    [sym_block_comment] = ACTIONS(3),
  },
  [497] = {
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_EQ] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_is] = ACTIONS(1022),
    [anon_sym_let] = ACTIONS(1020),
    [anon_sym_var] = ACTIONS(1020),
    [anon_sym_LPAREN] = ACTIONS(1022),
    [anon_sym_DOT] = ACTIONS(1022),
    [anon_sym_LBRACE] = ACTIONS(1020),
    [anon_sym_SEMI] = ACTIONS(1020),
    [sym_error] = ACTIONS(1020),
    [sym_compile_intrinsic] = ACTIONS(1020),
    [anon_sym_compile_error] = ACTIONS(1020),
    [sym_location] = ACTIONS(1020),
    [anon_sym_DASH] = ACTIONS(1022),
    [anon_sym_not] = ACTIONS(1020),
    [anon_sym_DASH_TILDE] = ACTIONS(1020),
    [anon_sym_addressof] = ACTIONS(1020),
    [anon_sym_digestof] = ACTIONS(1020),
    [anon_sym_PLUS] = ACTIONS(1022),
    [anon_sym_STAR] = ACTIONS(1022),
    [anon_sym_SLASH] = ACTIONS(1022),
    [anon_sym_PERCENT] = ACTIONS(1022),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1022),
    [anon_sym_LT_LT] = ACTIONS(1022),
    [anon_sym_GT_GT] = ACTIONS(1022),
    [anon_sym_and] = ACTIONS(1020),
    [anon_sym_or] = ACTIONS(1020),
    [anon_sym_xor] = ACTIONS(1020),
    [anon_sym_isnt] = ACTIONS(1020),
    [anon_sym_EQ_EQ] = ACTIONS(1022),
    [anon_sym_BANG_EQ] = ACTIONS(1022),
    [anon_sym_GT] = ACTIONS(1022),
    [anon_sym_GT_EQ] = ACTIONS(1022),
    [anon_sym_LT_EQ] = ACTIONS(1022),
    [anon_sym_LT] = ACTIONS(1022),
    [anon_sym_PLUS_TILDE] = ACTIONS(1020),
    [anon_sym_STAR_TILDE] = ACTIONS(1020),
    [anon_sym_SLASH_TILDE] = ACTIONS(1020),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1020),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1020),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1020),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1020),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1020),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1020),
    [anon_sym_GT_TILDE] = ACTIONS(1020),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1020),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1020),
    [anon_sym_LT_TILDE] = ACTIONS(1020),
    [anon_sym_PLUS_QMARK] = ACTIONS(1020),
    [anon_sym_DASH_QMARK] = ACTIONS(1020),
    [anon_sym_STAR_QMARK] = ACTIONS(1020),
    [anon_sym_SLASH_QMARK] = ACTIONS(1020),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1020),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1020),
    [anon_sym_as] = ACTIONS(1020),
    [anon_sym_LPAREN2] = ACTIONS(1020),
    [anon_sym_DOT_GT] = ACTIONS(1020),
    [anon_sym_TILDE] = ACTIONS(1020),
    [anon_sym_end] = ACTIONS(1020),
    [anon_sym_if] = ACTIONS(1022),
    [anon_sym_ifdef] = ACTIONS(1020),
    [anon_sym_elseif] = ACTIONS(1020),
    [anon_sym_iftype] = ACTIONS(1020),
    [anon_sym_else] = ACTIONS(1022),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_while] = ACTIONS(1020),
    [anon_sym_try] = ACTIONS(1020),
    [anon_sym_with] = ACTIONS(1020),
    [anon_sym_repeat] = ACTIONS(1020),
    [anon_sym_recover] = ACTIONS(1020),
    [anon_sym_match] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(1020),
    [anon_sym_continue] = ACTIONS(1020),
    [anon_sym_break] = ACTIONS(1020),
    [anon_sym_consume] = ACTIONS(1020),
    [anon_sym_object] = ACTIONS(1020),
    [sym_number] = ACTIONS(1022),
    [sym_float] = ACTIONS(1020),
    [anon_sym_DQUOTE] = ACTIONS(1022),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1020),
    [anon_sym_SQUOTE] = ACTIONS(1020),
    [anon_sym_true] = ACTIONS(1020),
    [anon_sym_false] = ACTIONS(1020),
    [sym_this] = ACTIONS(1020),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(1020),
    [sym_block_comment] = ACTIONS(3),
  },
  [498] = {
    [sym_identifier] = ACTIONS(1026),
    [anon_sym_EQ] = ACTIONS(1026),
    [anon_sym_AT] = ACTIONS(1024),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_is] = ACTIONS(1026),
    [anon_sym_let] = ACTIONS(1024),
    [anon_sym_var] = ACTIONS(1024),
    [anon_sym_LPAREN] = ACTIONS(1026),
    [anon_sym_DOT] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1024),
    [anon_sym_SEMI] = ACTIONS(1024),
    [sym_error] = ACTIONS(1024),
    [sym_compile_intrinsic] = ACTIONS(1024),
    [anon_sym_compile_error] = ACTIONS(1024),
    [sym_location] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1026),
    [anon_sym_not] = ACTIONS(1024),
    [anon_sym_DASH_TILDE] = ACTIONS(1024),
    [anon_sym_addressof] = ACTIONS(1024),
    [anon_sym_digestof] = ACTIONS(1024),
    [anon_sym_PLUS] = ACTIONS(1026),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_SLASH] = ACTIONS(1026),
    [anon_sym_PERCENT] = ACTIONS(1026),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1026),
    [anon_sym_LT_LT] = ACTIONS(1026),
    [anon_sym_GT_GT] = ACTIONS(1026),
    [anon_sym_and] = ACTIONS(1024),
    [anon_sym_or] = ACTIONS(1024),
    [anon_sym_xor] = ACTIONS(1024),
    [anon_sym_isnt] = ACTIONS(1024),
    [anon_sym_EQ_EQ] = ACTIONS(1026),
    [anon_sym_BANG_EQ] = ACTIONS(1026),
    [anon_sym_GT] = ACTIONS(1026),
    [anon_sym_GT_EQ] = ACTIONS(1026),
    [anon_sym_LT_EQ] = ACTIONS(1026),
    [anon_sym_LT] = ACTIONS(1026),
    [anon_sym_PLUS_TILDE] = ACTIONS(1024),
    [anon_sym_STAR_TILDE] = ACTIONS(1024),
    [anon_sym_SLASH_TILDE] = ACTIONS(1024),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1024),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1024),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1024),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1024),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1024),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1024),
    [anon_sym_GT_TILDE] = ACTIONS(1024),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1024),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1024),
    [anon_sym_LT_TILDE] = ACTIONS(1024),
    [anon_sym_PLUS_QMARK] = ACTIONS(1024),
    [anon_sym_DASH_QMARK] = ACTIONS(1024),
    [anon_sym_STAR_QMARK] = ACTIONS(1024),
    [anon_sym_SLASH_QMARK] = ACTIONS(1024),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1024),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1024),
    [anon_sym_as] = ACTIONS(1024),
    [anon_sym_LPAREN2] = ACTIONS(1024),
    [anon_sym_DOT_GT] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1024),
    [anon_sym_end] = ACTIONS(1024),
    [anon_sym_if] = ACTIONS(1026),
    [anon_sym_ifdef] = ACTIONS(1024),
    [anon_sym_elseif] = ACTIONS(1024),
    [anon_sym_iftype] = ACTIONS(1024),
    [anon_sym_else] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1024),
    [anon_sym_while] = ACTIONS(1024),
    [anon_sym_try] = ACTIONS(1024),
    [anon_sym_with] = ACTIONS(1024),
    [anon_sym_repeat] = ACTIONS(1024),
    [anon_sym_recover] = ACTIONS(1024),
    [anon_sym_match] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1024),
    [anon_sym_continue] = ACTIONS(1024),
    [anon_sym_break] = ACTIONS(1024),
    [anon_sym_consume] = ACTIONS(1024),
    [anon_sym_object] = ACTIONS(1024),
    [sym_number] = ACTIONS(1026),
    [sym_float] = ACTIONS(1024),
    [anon_sym_DQUOTE] = ACTIONS(1026),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1024),
    [anon_sym_SQUOTE] = ACTIONS(1024),
    [anon_sym_true] = ACTIONS(1024),
    [anon_sym_false] = ACTIONS(1024),
    [sym_this] = ACTIONS(1024),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(1024),
    [sym_block_comment] = ACTIONS(3),
  },
  [499] = {
    [sym_identifier] = ACTIONS(1042),
    [anon_sym_EQ] = ACTIONS(1042),
    [anon_sym_AT] = ACTIONS(1040),
    [anon_sym_LBRACK] = ACTIONS(1040),
    [anon_sym_is] = ACTIONS(1042),
    [anon_sym_let] = ACTIONS(1040),
    [anon_sym_var] = ACTIONS(1040),
    [anon_sym_LPAREN] = ACTIONS(1042),
    [anon_sym_DOT] = ACTIONS(1042),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_SEMI] = ACTIONS(1040),
    [sym_error] = ACTIONS(1040),
    [sym_compile_intrinsic] = ACTIONS(1040),
    [anon_sym_compile_error] = ACTIONS(1040),
    [sym_location] = ACTIONS(1040),
    [anon_sym_DASH] = ACTIONS(1042),
    [anon_sym_not] = ACTIONS(1040),
    [anon_sym_DASH_TILDE] = ACTIONS(1040),
    [anon_sym_addressof] = ACTIONS(1040),
    [anon_sym_digestof] = ACTIONS(1040),
    [anon_sym_PLUS] = ACTIONS(1042),
    [anon_sym_STAR] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(1042),
    [anon_sym_PERCENT] = ACTIONS(1042),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1042),
    [anon_sym_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_GT] = ACTIONS(1042),
    [anon_sym_and] = ACTIONS(1040),
    [anon_sym_or] = ACTIONS(1040),
    [anon_sym_xor] = ACTIONS(1040),
    [anon_sym_isnt] = ACTIONS(1040),
    [anon_sym_EQ_EQ] = ACTIONS(1042),
    [anon_sym_BANG_EQ] = ACTIONS(1042),
    [anon_sym_GT] = ACTIONS(1042),
    [anon_sym_GT_EQ] = ACTIONS(1042),
    [anon_sym_LT_EQ] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_PLUS_TILDE] = ACTIONS(1040),
    [anon_sym_STAR_TILDE] = ACTIONS(1040),
    [anon_sym_SLASH_TILDE] = ACTIONS(1040),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1040),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1040),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1040),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1040),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1040),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1040),
    [anon_sym_GT_TILDE] = ACTIONS(1040),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1040),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1040),
    [anon_sym_LT_TILDE] = ACTIONS(1040),
    [anon_sym_PLUS_QMARK] = ACTIONS(1040),
    [anon_sym_DASH_QMARK] = ACTIONS(1040),
    [anon_sym_STAR_QMARK] = ACTIONS(1040),
    [anon_sym_SLASH_QMARK] = ACTIONS(1040),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1040),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1040),
    [anon_sym_as] = ACTIONS(1040),
    [anon_sym_LPAREN2] = ACTIONS(1040),
    [anon_sym_DOT_GT] = ACTIONS(1040),
    [anon_sym_TILDE] = ACTIONS(1040),
    [anon_sym_end] = ACTIONS(1040),
    [anon_sym_if] = ACTIONS(1042),
    [anon_sym_ifdef] = ACTIONS(1040),
    [anon_sym_elseif] = ACTIONS(1040),
    [anon_sym_iftype] = ACTIONS(1040),
    [anon_sym_else] = ACTIONS(1042),
    [anon_sym_for] = ACTIONS(1040),
    [anon_sym_while] = ACTIONS(1040),
    [anon_sym_try] = ACTIONS(1040),
    [anon_sym_with] = ACTIONS(1040),
    [anon_sym_repeat] = ACTIONS(1040),
    [anon_sym_recover] = ACTIONS(1040),
    [anon_sym_match] = ACTIONS(1040),
    [anon_sym_return] = ACTIONS(1040),
    [anon_sym_continue] = ACTIONS(1040),
    [anon_sym_break] = ACTIONS(1040),
    [anon_sym_consume] = ACTIONS(1040),
    [anon_sym_object] = ACTIONS(1040),
    [sym_number] = ACTIONS(1042),
    [sym_float] = ACTIONS(1040),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym_true] = ACTIONS(1040),
    [anon_sym_false] = ACTIONS(1040),
    [sym_this] = ACTIONS(1040),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(1040),
    [sym_block_comment] = ACTIONS(3),
  },
  [500] = {
    [sym_annotation] = STATE(575),
    [sym_capability] = STATE(647),
    [sym_block] = STATE(2195),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_iso] = ACTIONS(1366),
    [anon_sym_trn] = ACTIONS(1366),
    [anon_sym_ref] = ACTIONS(1366),
    [anon_sym_val] = ACTIONS(1366),
    [anon_sym_box] = ACTIONS(1366),
    [anon_sym_tag] = ACTIONS(1366),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [501] = {
    [sym_identifier] = ACTIONS(1058),
    [anon_sym_EQ] = ACTIONS(1058),
    [anon_sym_AT] = ACTIONS(1056),
    [anon_sym_LBRACK] = ACTIONS(1056),
    [anon_sym_QMARK] = ACTIONS(1056),
    [anon_sym_is] = ACTIONS(1058),
    [anon_sym_let] = ACTIONS(1056),
    [anon_sym_var] = ACTIONS(1056),
    [anon_sym_LPAREN] = ACTIONS(1058),
    [anon_sym_DOT] = ACTIONS(1058),
    [anon_sym_LBRACE] = ACTIONS(1056),
    [anon_sym_SEMI] = ACTIONS(1056),
    [sym_error] = ACTIONS(1056),
    [sym_compile_intrinsic] = ACTIONS(1056),
    [anon_sym_compile_error] = ACTIONS(1056),
    [sym_location] = ACTIONS(1056),
    [anon_sym_DASH] = ACTIONS(1058),
    [anon_sym_not] = ACTIONS(1056),
    [anon_sym_DASH_TILDE] = ACTIONS(1056),
    [anon_sym_addressof] = ACTIONS(1056),
    [anon_sym_digestof] = ACTIONS(1056),
    [anon_sym_PLUS] = ACTIONS(1058),
    [anon_sym_STAR] = ACTIONS(1058),
    [anon_sym_SLASH] = ACTIONS(1058),
    [anon_sym_PERCENT] = ACTIONS(1058),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1058),
    [anon_sym_LT_LT] = ACTIONS(1058),
    [anon_sym_GT_GT] = ACTIONS(1058),
    [anon_sym_and] = ACTIONS(1056),
    [anon_sym_or] = ACTIONS(1056),
    [anon_sym_xor] = ACTIONS(1056),
    [anon_sym_isnt] = ACTIONS(1056),
    [anon_sym_EQ_EQ] = ACTIONS(1058),
    [anon_sym_BANG_EQ] = ACTIONS(1058),
    [anon_sym_GT] = ACTIONS(1058),
    [anon_sym_GT_EQ] = ACTIONS(1058),
    [anon_sym_LT_EQ] = ACTIONS(1058),
    [anon_sym_LT] = ACTIONS(1058),
    [anon_sym_PLUS_TILDE] = ACTIONS(1056),
    [anon_sym_STAR_TILDE] = ACTIONS(1056),
    [anon_sym_SLASH_TILDE] = ACTIONS(1056),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1056),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1056),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1056),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1056),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1056),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1056),
    [anon_sym_GT_TILDE] = ACTIONS(1056),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1056),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1056),
    [anon_sym_LT_TILDE] = ACTIONS(1056),
    [anon_sym_PLUS_QMARK] = ACTIONS(1056),
    [anon_sym_DASH_QMARK] = ACTIONS(1056),
    [anon_sym_STAR_QMARK] = ACTIONS(1056),
    [anon_sym_SLASH_QMARK] = ACTIONS(1056),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1056),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1056),
    [anon_sym_as] = ACTIONS(1056),
    [anon_sym_LPAREN2] = ACTIONS(1056),
    [anon_sym_DOT_GT] = ACTIONS(1056),
    [anon_sym_TILDE] = ACTIONS(1056),
    [anon_sym_end] = ACTIONS(1056),
    [anon_sym_if] = ACTIONS(1058),
    [anon_sym_ifdef] = ACTIONS(1056),
    [anon_sym_elseif] = ACTIONS(1056),
    [anon_sym_iftype] = ACTIONS(1056),
    [anon_sym_else] = ACTIONS(1058),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1056),
    [anon_sym_try] = ACTIONS(1056),
    [anon_sym_with] = ACTIONS(1056),
    [anon_sym_repeat] = ACTIONS(1056),
    [anon_sym_recover] = ACTIONS(1056),
    [anon_sym_match] = ACTIONS(1056),
    [anon_sym_return] = ACTIONS(1056),
    [anon_sym_continue] = ACTIONS(1056),
    [anon_sym_break] = ACTIONS(1056),
    [anon_sym_consume] = ACTIONS(1056),
    [anon_sym_object] = ACTIONS(1056),
    [sym_number] = ACTIONS(1058),
    [sym_float] = ACTIONS(1056),
    [anon_sym_DQUOTE] = ACTIONS(1058),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1056),
    [anon_sym_SQUOTE] = ACTIONS(1056),
    [anon_sym_true] = ACTIONS(1056),
    [anon_sym_false] = ACTIONS(1056),
    [sym_this] = ACTIONS(1056),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [502] = {
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_EQ] = ACTIONS(1054),
    [anon_sym_AT] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(1052),
    [anon_sym_QMARK] = ACTIONS(1052),
    [anon_sym_is] = ACTIONS(1054),
    [anon_sym_let] = ACTIONS(1052),
    [anon_sym_var] = ACTIONS(1052),
    [anon_sym_LPAREN] = ACTIONS(1054),
    [anon_sym_DOT] = ACTIONS(1054),
    [anon_sym_LBRACE] = ACTIONS(1052),
    [anon_sym_SEMI] = ACTIONS(1052),
    [sym_error] = ACTIONS(1052),
    [sym_compile_intrinsic] = ACTIONS(1052),
    [anon_sym_compile_error] = ACTIONS(1052),
    [sym_location] = ACTIONS(1052),
    [anon_sym_DASH] = ACTIONS(1054),
    [anon_sym_not] = ACTIONS(1052),
    [anon_sym_DASH_TILDE] = ACTIONS(1052),
    [anon_sym_addressof] = ACTIONS(1052),
    [anon_sym_digestof] = ACTIONS(1052),
    [anon_sym_PLUS] = ACTIONS(1054),
    [anon_sym_STAR] = ACTIONS(1054),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_PERCENT] = ACTIONS(1054),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1054),
    [anon_sym_LT_LT] = ACTIONS(1054),
    [anon_sym_GT_GT] = ACTIONS(1054),
    [anon_sym_and] = ACTIONS(1052),
    [anon_sym_or] = ACTIONS(1052),
    [anon_sym_xor] = ACTIONS(1052),
    [anon_sym_isnt] = ACTIONS(1052),
    [anon_sym_EQ_EQ] = ACTIONS(1054),
    [anon_sym_BANG_EQ] = ACTIONS(1054),
    [anon_sym_GT] = ACTIONS(1054),
    [anon_sym_GT_EQ] = ACTIONS(1054),
    [anon_sym_LT_EQ] = ACTIONS(1054),
    [anon_sym_LT] = ACTIONS(1054),
    [anon_sym_PLUS_TILDE] = ACTIONS(1052),
    [anon_sym_STAR_TILDE] = ACTIONS(1052),
    [anon_sym_SLASH_TILDE] = ACTIONS(1052),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1052),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1052),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1052),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1052),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1052),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1052),
    [anon_sym_GT_TILDE] = ACTIONS(1052),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1052),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1052),
    [anon_sym_LT_TILDE] = ACTIONS(1052),
    [anon_sym_PLUS_QMARK] = ACTIONS(1052),
    [anon_sym_DASH_QMARK] = ACTIONS(1052),
    [anon_sym_STAR_QMARK] = ACTIONS(1052),
    [anon_sym_SLASH_QMARK] = ACTIONS(1052),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1052),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1052),
    [anon_sym_as] = ACTIONS(1052),
    [anon_sym_LPAREN2] = ACTIONS(1052),
    [anon_sym_DOT_GT] = ACTIONS(1052),
    [anon_sym_TILDE] = ACTIONS(1052),
    [anon_sym_end] = ACTIONS(1052),
    [anon_sym_if] = ACTIONS(1054),
    [anon_sym_ifdef] = ACTIONS(1052),
    [anon_sym_elseif] = ACTIONS(1052),
    [anon_sym_iftype] = ACTIONS(1052),
    [anon_sym_else] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1052),
    [anon_sym_while] = ACTIONS(1052),
    [anon_sym_try] = ACTIONS(1052),
    [anon_sym_with] = ACTIONS(1052),
    [anon_sym_repeat] = ACTIONS(1052),
    [anon_sym_recover] = ACTIONS(1052),
    [anon_sym_match] = ACTIONS(1052),
    [anon_sym_return] = ACTIONS(1052),
    [anon_sym_continue] = ACTIONS(1052),
    [anon_sym_break] = ACTIONS(1052),
    [anon_sym_consume] = ACTIONS(1052),
    [anon_sym_object] = ACTIONS(1052),
    [sym_number] = ACTIONS(1054),
    [sym_float] = ACTIONS(1052),
    [anon_sym_DQUOTE] = ACTIONS(1054),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1052),
    [anon_sym_SQUOTE] = ACTIONS(1052),
    [anon_sym_true] = ACTIONS(1052),
    [anon_sym_false] = ACTIONS(1052),
    [sym_this] = ACTIONS(1052),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [503] = {
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_EQ] = ACTIONS(1046),
    [anon_sym_AT] = ACTIONS(1044),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_QMARK] = ACTIONS(1044),
    [anon_sym_is] = ACTIONS(1046),
    [anon_sym_let] = ACTIONS(1044),
    [anon_sym_var] = ACTIONS(1044),
    [anon_sym_LPAREN] = ACTIONS(1046),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_LBRACE] = ACTIONS(1044),
    [anon_sym_SEMI] = ACTIONS(1044),
    [sym_error] = ACTIONS(1044),
    [sym_compile_intrinsic] = ACTIONS(1044),
    [anon_sym_compile_error] = ACTIONS(1044),
    [sym_location] = ACTIONS(1044),
    [anon_sym_DASH] = ACTIONS(1046),
    [anon_sym_not] = ACTIONS(1044),
    [anon_sym_DASH_TILDE] = ACTIONS(1044),
    [anon_sym_addressof] = ACTIONS(1044),
    [anon_sym_digestof] = ACTIONS(1044),
    [anon_sym_PLUS] = ACTIONS(1046),
    [anon_sym_STAR] = ACTIONS(1046),
    [anon_sym_SLASH] = ACTIONS(1046),
    [anon_sym_PERCENT] = ACTIONS(1046),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1046),
    [anon_sym_LT_LT] = ACTIONS(1046),
    [anon_sym_GT_GT] = ACTIONS(1046),
    [anon_sym_and] = ACTIONS(1044),
    [anon_sym_or] = ACTIONS(1044),
    [anon_sym_xor] = ACTIONS(1044),
    [anon_sym_isnt] = ACTIONS(1044),
    [anon_sym_EQ_EQ] = ACTIONS(1046),
    [anon_sym_BANG_EQ] = ACTIONS(1046),
    [anon_sym_GT] = ACTIONS(1046),
    [anon_sym_GT_EQ] = ACTIONS(1046),
    [anon_sym_LT_EQ] = ACTIONS(1046),
    [anon_sym_LT] = ACTIONS(1046),
    [anon_sym_PLUS_TILDE] = ACTIONS(1044),
    [anon_sym_STAR_TILDE] = ACTIONS(1044),
    [anon_sym_SLASH_TILDE] = ACTIONS(1044),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1044),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1044),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1044),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1044),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1044),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1044),
    [anon_sym_GT_TILDE] = ACTIONS(1044),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1044),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1044),
    [anon_sym_LT_TILDE] = ACTIONS(1044),
    [anon_sym_PLUS_QMARK] = ACTIONS(1044),
    [anon_sym_DASH_QMARK] = ACTIONS(1044),
    [anon_sym_STAR_QMARK] = ACTIONS(1044),
    [anon_sym_SLASH_QMARK] = ACTIONS(1044),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1044),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1044),
    [anon_sym_as] = ACTIONS(1044),
    [anon_sym_LPAREN2] = ACTIONS(1044),
    [anon_sym_DOT_GT] = ACTIONS(1044),
    [anon_sym_TILDE] = ACTIONS(1044),
    [anon_sym_end] = ACTIONS(1044),
    [anon_sym_if] = ACTIONS(1046),
    [anon_sym_ifdef] = ACTIONS(1044),
    [anon_sym_elseif] = ACTIONS(1044),
    [anon_sym_iftype] = ACTIONS(1044),
    [anon_sym_else] = ACTIONS(1046),
    [anon_sym_for] = ACTIONS(1044),
    [anon_sym_while] = ACTIONS(1044),
    [anon_sym_try] = ACTIONS(1044),
    [anon_sym_with] = ACTIONS(1044),
    [anon_sym_repeat] = ACTIONS(1044),
    [anon_sym_recover] = ACTIONS(1044),
    [anon_sym_match] = ACTIONS(1044),
    [anon_sym_return] = ACTIONS(1044),
    [anon_sym_continue] = ACTIONS(1044),
    [anon_sym_break] = ACTIONS(1044),
    [anon_sym_consume] = ACTIONS(1044),
    [anon_sym_object] = ACTIONS(1044),
    [sym_number] = ACTIONS(1046),
    [sym_float] = ACTIONS(1044),
    [anon_sym_DQUOTE] = ACTIONS(1046),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1044),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_true] = ACTIONS(1044),
    [anon_sym_false] = ACTIONS(1044),
    [sym_this] = ACTIONS(1044),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [504] = {
    [sym_identifier] = ACTIONS(875),
    [anon_sym_EQ] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_is] = ACTIONS(875),
    [anon_sym_let] = ACTIONS(873),
    [anon_sym_var] = ACTIONS(873),
    [anon_sym_LPAREN] = ACTIONS(875),
    [anon_sym_DOT] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(873),
    [anon_sym_SEMI] = ACTIONS(873),
    [sym_error] = ACTIONS(873),
    [sym_compile_intrinsic] = ACTIONS(873),
    [anon_sym_compile_error] = ACTIONS(873),
    [sym_location] = ACTIONS(873),
    [anon_sym_DASH] = ACTIONS(875),
    [anon_sym_not] = ACTIONS(873),
    [anon_sym_DASH_TILDE] = ACTIONS(873),
    [anon_sym_addressof] = ACTIONS(873),
    [anon_sym_digestof] = ACTIONS(873),
    [anon_sym_PLUS] = ACTIONS(875),
    [anon_sym_STAR] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(875),
    [anon_sym_PERCENT] = ACTIONS(875),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(875),
    [anon_sym_LT_LT] = ACTIONS(875),
    [anon_sym_GT_GT] = ACTIONS(875),
    [anon_sym_and] = ACTIONS(873),
    [anon_sym_or] = ACTIONS(873),
    [anon_sym_xor] = ACTIONS(873),
    [anon_sym_isnt] = ACTIONS(873),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_BANG_EQ] = ACTIONS(875),
    [anon_sym_GT] = ACTIONS(875),
    [anon_sym_GT_EQ] = ACTIONS(875),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(875),
    [anon_sym_PLUS_TILDE] = ACTIONS(873),
    [anon_sym_STAR_TILDE] = ACTIONS(873),
    [anon_sym_SLASH_TILDE] = ACTIONS(873),
    [anon_sym_PERCENT_TILDE] = ACTIONS(873),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(873),
    [anon_sym_LT_LT_TILDE] = ACTIONS(873),
    [anon_sym_GT_GT_TILDE] = ACTIONS(873),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(873),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(873),
    [anon_sym_GT_TILDE] = ACTIONS(873),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(873),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(873),
    [anon_sym_LT_TILDE] = ACTIONS(873),
    [anon_sym_PLUS_QMARK] = ACTIONS(873),
    [anon_sym_DASH_QMARK] = ACTIONS(873),
    [anon_sym_STAR_QMARK] = ACTIONS(873),
    [anon_sym_SLASH_QMARK] = ACTIONS(873),
    [anon_sym_PERCENT_QMARK] = ACTIONS(873),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(873),
    [anon_sym_as] = ACTIONS(873),
    [anon_sym_LPAREN2] = ACTIONS(873),
    [anon_sym_DOT_GT] = ACTIONS(873),
    [anon_sym_TILDE] = ACTIONS(873),
    [anon_sym_end] = ACTIONS(873),
    [anon_sym_if] = ACTIONS(875),
    [anon_sym_ifdef] = ACTIONS(873),
    [anon_sym_elseif] = ACTIONS(873),
    [anon_sym_iftype] = ACTIONS(873),
    [anon_sym_else] = ACTIONS(875),
    [anon_sym_for] = ACTIONS(873),
    [anon_sym_while] = ACTIONS(873),
    [anon_sym_try] = ACTIONS(873),
    [anon_sym_with] = ACTIONS(873),
    [anon_sym_repeat] = ACTIONS(873),
    [anon_sym_recover] = ACTIONS(873),
    [anon_sym_match] = ACTIONS(873),
    [anon_sym_return] = ACTIONS(873),
    [anon_sym_continue] = ACTIONS(873),
    [anon_sym_break] = ACTIONS(873),
    [anon_sym_consume] = ACTIONS(873),
    [anon_sym_object] = ACTIONS(873),
    [sym_number] = ACTIONS(875),
    [sym_float] = ACTIONS(873),
    [anon_sym_DQUOTE] = ACTIONS(875),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(873),
    [anon_sym_SQUOTE] = ACTIONS(873),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [sym_this] = ACTIONS(873),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [505] = {
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_EQ] = ACTIONS(1136),
    [anon_sym_AT] = ACTIONS(1134),
    [anon_sym_LBRACK] = ACTIONS(1134),
    [anon_sym_is] = ACTIONS(1136),
    [anon_sym_let] = ACTIONS(1134),
    [anon_sym_var] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [anon_sym_DOT] = ACTIONS(1136),
    [anon_sym_LBRACE] = ACTIONS(1134),
    [anon_sym_SEMI] = ACTIONS(1134),
    [sym_error] = ACTIONS(1134),
    [sym_compile_intrinsic] = ACTIONS(1134),
    [anon_sym_compile_error] = ACTIONS(1134),
    [sym_location] = ACTIONS(1134),
    [anon_sym_DASH] = ACTIONS(1136),
    [anon_sym_not] = ACTIONS(1134),
    [anon_sym_DASH_TILDE] = ACTIONS(1134),
    [anon_sym_addressof] = ACTIONS(1134),
    [anon_sym_digestof] = ACTIONS(1134),
    [anon_sym_PLUS] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_SLASH] = ACTIONS(1136),
    [anon_sym_PERCENT] = ACTIONS(1136),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1136),
    [anon_sym_LT_LT] = ACTIONS(1136),
    [anon_sym_GT_GT] = ACTIONS(1136),
    [anon_sym_and] = ACTIONS(1134),
    [anon_sym_or] = ACTIONS(1134),
    [anon_sym_xor] = ACTIONS(1134),
    [anon_sym_isnt] = ACTIONS(1134),
    [anon_sym_EQ_EQ] = ACTIONS(1136),
    [anon_sym_BANG_EQ] = ACTIONS(1136),
    [anon_sym_GT] = ACTIONS(1136),
    [anon_sym_GT_EQ] = ACTIONS(1136),
    [anon_sym_LT_EQ] = ACTIONS(1136),
    [anon_sym_LT] = ACTIONS(1136),
    [anon_sym_PLUS_TILDE] = ACTIONS(1134),
    [anon_sym_STAR_TILDE] = ACTIONS(1134),
    [anon_sym_SLASH_TILDE] = ACTIONS(1134),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1134),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1134),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1134),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1134),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1134),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1134),
    [anon_sym_GT_TILDE] = ACTIONS(1134),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1134),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1134),
    [anon_sym_LT_TILDE] = ACTIONS(1134),
    [anon_sym_PLUS_QMARK] = ACTIONS(1134),
    [anon_sym_DASH_QMARK] = ACTIONS(1134),
    [anon_sym_STAR_QMARK] = ACTIONS(1134),
    [anon_sym_SLASH_QMARK] = ACTIONS(1134),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1134),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1134),
    [anon_sym_as] = ACTIONS(1134),
    [anon_sym_LPAREN2] = ACTIONS(1134),
    [anon_sym_DOT_GT] = ACTIONS(1134),
    [anon_sym_TILDE] = ACTIONS(1134),
    [anon_sym_end] = ACTIONS(1134),
    [anon_sym_if] = ACTIONS(1136),
    [anon_sym_ifdef] = ACTIONS(1134),
    [anon_sym_elseif] = ACTIONS(1134),
    [anon_sym_iftype] = ACTIONS(1134),
    [anon_sym_else] = ACTIONS(1136),
    [anon_sym_for] = ACTIONS(1134),
    [anon_sym_while] = ACTIONS(1134),
    [anon_sym_try] = ACTIONS(1134),
    [anon_sym_with] = ACTIONS(1134),
    [anon_sym_repeat] = ACTIONS(1134),
    [anon_sym_recover] = ACTIONS(1134),
    [anon_sym_match] = ACTIONS(1134),
    [anon_sym_return] = ACTIONS(1134),
    [anon_sym_continue] = ACTIONS(1134),
    [anon_sym_break] = ACTIONS(1134),
    [anon_sym_consume] = ACTIONS(1134),
    [anon_sym_object] = ACTIONS(1134),
    [sym_number] = ACTIONS(1136),
    [sym_float] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(1136),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1134),
    [anon_sym_SQUOTE] = ACTIONS(1134),
    [anon_sym_true] = ACTIONS(1134),
    [anon_sym_false] = ACTIONS(1134),
    [sym_this] = ACTIONS(1134),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [506] = {
    [sym_identifier] = ACTIONS(1242),
    [anon_sym_EQ] = ACTIONS(1242),
    [anon_sym_AT] = ACTIONS(1240),
    [anon_sym_LBRACK] = ACTIONS(1240),
    [anon_sym_is] = ACTIONS(1242),
    [anon_sym_let] = ACTIONS(1240),
    [anon_sym_var] = ACTIONS(1240),
    [anon_sym_LPAREN] = ACTIONS(1242),
    [anon_sym_DOT] = ACTIONS(1242),
    [anon_sym_LBRACE] = ACTIONS(1240),
    [anon_sym_SEMI] = ACTIONS(1240),
    [sym_error] = ACTIONS(1240),
    [sym_compile_intrinsic] = ACTIONS(1240),
    [anon_sym_compile_error] = ACTIONS(1240),
    [sym_location] = ACTIONS(1240),
    [anon_sym_DASH] = ACTIONS(1242),
    [anon_sym_not] = ACTIONS(1240),
    [anon_sym_DASH_TILDE] = ACTIONS(1240),
    [anon_sym_addressof] = ACTIONS(1240),
    [anon_sym_digestof] = ACTIONS(1240),
    [anon_sym_PLUS] = ACTIONS(1242),
    [anon_sym_STAR] = ACTIONS(1242),
    [anon_sym_SLASH] = ACTIONS(1242),
    [anon_sym_PERCENT] = ACTIONS(1242),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1242),
    [anon_sym_LT_LT] = ACTIONS(1242),
    [anon_sym_GT_GT] = ACTIONS(1242),
    [anon_sym_and] = ACTIONS(1240),
    [anon_sym_or] = ACTIONS(1240),
    [anon_sym_xor] = ACTIONS(1240),
    [anon_sym_isnt] = ACTIONS(1240),
    [anon_sym_EQ_EQ] = ACTIONS(1242),
    [anon_sym_BANG_EQ] = ACTIONS(1242),
    [anon_sym_GT] = ACTIONS(1242),
    [anon_sym_GT_EQ] = ACTIONS(1242),
    [anon_sym_LT_EQ] = ACTIONS(1242),
    [anon_sym_LT] = ACTIONS(1242),
    [anon_sym_PLUS_TILDE] = ACTIONS(1240),
    [anon_sym_STAR_TILDE] = ACTIONS(1240),
    [anon_sym_SLASH_TILDE] = ACTIONS(1240),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1240),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1240),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1240),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1240),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1240),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1240),
    [anon_sym_GT_TILDE] = ACTIONS(1240),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1240),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1240),
    [anon_sym_LT_TILDE] = ACTIONS(1240),
    [anon_sym_PLUS_QMARK] = ACTIONS(1240),
    [anon_sym_DASH_QMARK] = ACTIONS(1240),
    [anon_sym_STAR_QMARK] = ACTIONS(1240),
    [anon_sym_SLASH_QMARK] = ACTIONS(1240),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1240),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1240),
    [anon_sym_as] = ACTIONS(1240),
    [anon_sym_LPAREN2] = ACTIONS(1240),
    [anon_sym_DOT_GT] = ACTIONS(1240),
    [anon_sym_TILDE] = ACTIONS(1240),
    [anon_sym_end] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(1242),
    [anon_sym_ifdef] = ACTIONS(1240),
    [anon_sym_elseif] = ACTIONS(1240),
    [anon_sym_iftype] = ACTIONS(1240),
    [anon_sym_else] = ACTIONS(1242),
    [anon_sym_for] = ACTIONS(1240),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_try] = ACTIONS(1240),
    [anon_sym_with] = ACTIONS(1240),
    [anon_sym_repeat] = ACTIONS(1240),
    [anon_sym_recover] = ACTIONS(1240),
    [anon_sym_match] = ACTIONS(1240),
    [anon_sym_return] = ACTIONS(1240),
    [anon_sym_continue] = ACTIONS(1240),
    [anon_sym_break] = ACTIONS(1240),
    [anon_sym_consume] = ACTIONS(1240),
    [anon_sym_object] = ACTIONS(1240),
    [sym_number] = ACTIONS(1242),
    [sym_float] = ACTIONS(1240),
    [anon_sym_DQUOTE] = ACTIONS(1242),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1240),
    [anon_sym_SQUOTE] = ACTIONS(1240),
    [anon_sym_true] = ACTIONS(1240),
    [anon_sym_false] = ACTIONS(1240),
    [sym_this] = ACTIONS(1240),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [507] = {
    [sym_identifier] = ACTIONS(1266),
    [anon_sym_EQ] = ACTIONS(1266),
    [anon_sym_AT] = ACTIONS(1264),
    [anon_sym_LBRACK] = ACTIONS(1264),
    [anon_sym_is] = ACTIONS(1266),
    [anon_sym_let] = ACTIONS(1264),
    [anon_sym_var] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [anon_sym_DOT] = ACTIONS(1266),
    [anon_sym_LBRACE] = ACTIONS(1264),
    [anon_sym_SEMI] = ACTIONS(1264),
    [sym_error] = ACTIONS(1264),
    [sym_compile_intrinsic] = ACTIONS(1264),
    [anon_sym_compile_error] = ACTIONS(1264),
    [sym_location] = ACTIONS(1264),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_not] = ACTIONS(1264),
    [anon_sym_DASH_TILDE] = ACTIONS(1264),
    [anon_sym_addressof] = ACTIONS(1264),
    [anon_sym_digestof] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1266),
    [anon_sym_SLASH] = ACTIONS(1266),
    [anon_sym_PERCENT] = ACTIONS(1266),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1266),
    [anon_sym_LT_LT] = ACTIONS(1266),
    [anon_sym_GT_GT] = ACTIONS(1266),
    [anon_sym_and] = ACTIONS(1264),
    [anon_sym_or] = ACTIONS(1264),
    [anon_sym_xor] = ACTIONS(1264),
    [anon_sym_isnt] = ACTIONS(1264),
    [anon_sym_EQ_EQ] = ACTIONS(1266),
    [anon_sym_BANG_EQ] = ACTIONS(1266),
    [anon_sym_GT] = ACTIONS(1266),
    [anon_sym_GT_EQ] = ACTIONS(1266),
    [anon_sym_LT_EQ] = ACTIONS(1266),
    [anon_sym_LT] = ACTIONS(1266),
    [anon_sym_PLUS_TILDE] = ACTIONS(1264),
    [anon_sym_STAR_TILDE] = ACTIONS(1264),
    [anon_sym_SLASH_TILDE] = ACTIONS(1264),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1264),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1264),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1264),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1264),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1264),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1264),
    [anon_sym_GT_TILDE] = ACTIONS(1264),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1264),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1264),
    [anon_sym_LT_TILDE] = ACTIONS(1264),
    [anon_sym_PLUS_QMARK] = ACTIONS(1264),
    [anon_sym_DASH_QMARK] = ACTIONS(1264),
    [anon_sym_STAR_QMARK] = ACTIONS(1264),
    [anon_sym_SLASH_QMARK] = ACTIONS(1264),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1264),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1264),
    [anon_sym_as] = ACTIONS(1264),
    [anon_sym_LPAREN2] = ACTIONS(1264),
    [anon_sym_DOT_GT] = ACTIONS(1264),
    [anon_sym_TILDE] = ACTIONS(1264),
    [anon_sym_end] = ACTIONS(1264),
    [anon_sym_if] = ACTIONS(1266),
    [anon_sym_ifdef] = ACTIONS(1264),
    [anon_sym_elseif] = ACTIONS(1264),
    [anon_sym_iftype] = ACTIONS(1264),
    [anon_sym_else] = ACTIONS(1266),
    [anon_sym_for] = ACTIONS(1264),
    [anon_sym_while] = ACTIONS(1264),
    [anon_sym_try] = ACTIONS(1264),
    [anon_sym_with] = ACTIONS(1264),
    [anon_sym_repeat] = ACTIONS(1264),
    [anon_sym_recover] = ACTIONS(1264),
    [anon_sym_match] = ACTIONS(1264),
    [anon_sym_return] = ACTIONS(1264),
    [anon_sym_continue] = ACTIONS(1264),
    [anon_sym_break] = ACTIONS(1264),
    [anon_sym_consume] = ACTIONS(1264),
    [anon_sym_object] = ACTIONS(1264),
    [sym_number] = ACTIONS(1266),
    [sym_float] = ACTIONS(1264),
    [anon_sym_DQUOTE] = ACTIONS(1266),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1264),
    [anon_sym_SQUOTE] = ACTIONS(1264),
    [anon_sym_true] = ACTIONS(1264),
    [anon_sym_false] = ACTIONS(1264),
    [sym_this] = ACTIONS(1264),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [508] = {
    [sym_identifier] = ACTIONS(851),
    [anon_sym_EQ] = ACTIONS(851),
    [anon_sym_AT] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(849),
    [anon_sym_is] = ACTIONS(851),
    [anon_sym_let] = ACTIONS(849),
    [anon_sym_var] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_DOT] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(849),
    [anon_sym_SEMI] = ACTIONS(849),
    [sym_error] = ACTIONS(849),
    [sym_compile_intrinsic] = ACTIONS(849),
    [anon_sym_compile_error] = ACTIONS(849),
    [sym_location] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_not] = ACTIONS(849),
    [anon_sym_DASH_TILDE] = ACTIONS(849),
    [anon_sym_addressof] = ACTIONS(849),
    [anon_sym_digestof] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(851),
    [anon_sym_SLASH] = ACTIONS(851),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(851),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_GT_GT] = ACTIONS(851),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_isnt] = ACTIONS(849),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(851),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_LT] = ACTIONS(851),
    [anon_sym_PLUS_TILDE] = ACTIONS(849),
    [anon_sym_STAR_TILDE] = ACTIONS(849),
    [anon_sym_SLASH_TILDE] = ACTIONS(849),
    [anon_sym_PERCENT_TILDE] = ACTIONS(849),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(849),
    [anon_sym_LT_LT_TILDE] = ACTIONS(849),
    [anon_sym_GT_GT_TILDE] = ACTIONS(849),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(849),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(849),
    [anon_sym_GT_TILDE] = ACTIONS(849),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(849),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(849),
    [anon_sym_LT_TILDE] = ACTIONS(849),
    [anon_sym_PLUS_QMARK] = ACTIONS(849),
    [anon_sym_DASH_QMARK] = ACTIONS(849),
    [anon_sym_STAR_QMARK] = ACTIONS(849),
    [anon_sym_SLASH_QMARK] = ACTIONS(849),
    [anon_sym_PERCENT_QMARK] = ACTIONS(849),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(849),
    [anon_sym_as] = ACTIONS(849),
    [anon_sym_LPAREN2] = ACTIONS(849),
    [anon_sym_DOT_GT] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(849),
    [anon_sym_end] = ACTIONS(849),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_ifdef] = ACTIONS(849),
    [anon_sym_elseif] = ACTIONS(849),
    [anon_sym_iftype] = ACTIONS(849),
    [anon_sym_else] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(849),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_try] = ACTIONS(849),
    [anon_sym_with] = ACTIONS(849),
    [anon_sym_repeat] = ACTIONS(849),
    [anon_sym_recover] = ACTIONS(849),
    [anon_sym_match] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_continue] = ACTIONS(849),
    [anon_sym_break] = ACTIONS(849),
    [anon_sym_consume] = ACTIONS(849),
    [anon_sym_object] = ACTIONS(849),
    [sym_number] = ACTIONS(851),
    [sym_float] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(851),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(849),
    [anon_sym_SQUOTE] = ACTIONS(849),
    [anon_sym_true] = ACTIONS(849),
    [anon_sym_false] = ACTIONS(849),
    [sym_this] = ACTIONS(849),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [509] = {
    [sym_identifier] = ACTIONS(847),
    [anon_sym_EQ] = ACTIONS(847),
    [anon_sym_AT] = ACTIONS(845),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_is] = ACTIONS(847),
    [anon_sym_let] = ACTIONS(845),
    [anon_sym_var] = ACTIONS(845),
    [anon_sym_LPAREN] = ACTIONS(847),
    [anon_sym_DOT] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(845),
    [anon_sym_SEMI] = ACTIONS(845),
    [sym_error] = ACTIONS(845),
    [sym_compile_intrinsic] = ACTIONS(845),
    [anon_sym_compile_error] = ACTIONS(845),
    [sym_location] = ACTIONS(845),
    [anon_sym_DASH] = ACTIONS(847),
    [anon_sym_not] = ACTIONS(845),
    [anon_sym_DASH_TILDE] = ACTIONS(845),
    [anon_sym_addressof] = ACTIONS(845),
    [anon_sym_digestof] = ACTIONS(845),
    [anon_sym_PLUS] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(847),
    [anon_sym_SLASH] = ACTIONS(847),
    [anon_sym_PERCENT] = ACTIONS(847),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(847),
    [anon_sym_LT_LT] = ACTIONS(847),
    [anon_sym_GT_GT] = ACTIONS(847),
    [anon_sym_and] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(845),
    [anon_sym_xor] = ACTIONS(845),
    [anon_sym_isnt] = ACTIONS(845),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_GT_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(847),
    [anon_sym_PLUS_TILDE] = ACTIONS(845),
    [anon_sym_STAR_TILDE] = ACTIONS(845),
    [anon_sym_SLASH_TILDE] = ACTIONS(845),
    [anon_sym_PERCENT_TILDE] = ACTIONS(845),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(845),
    [anon_sym_LT_LT_TILDE] = ACTIONS(845),
    [anon_sym_GT_GT_TILDE] = ACTIONS(845),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(845),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(845),
    [anon_sym_GT_TILDE] = ACTIONS(845),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(845),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(845),
    [anon_sym_LT_TILDE] = ACTIONS(845),
    [anon_sym_PLUS_QMARK] = ACTIONS(845),
    [anon_sym_DASH_QMARK] = ACTIONS(845),
    [anon_sym_STAR_QMARK] = ACTIONS(845),
    [anon_sym_SLASH_QMARK] = ACTIONS(845),
    [anon_sym_PERCENT_QMARK] = ACTIONS(845),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(845),
    [anon_sym_as] = ACTIONS(845),
    [anon_sym_LPAREN2] = ACTIONS(845),
    [anon_sym_DOT_GT] = ACTIONS(845),
    [anon_sym_TILDE] = ACTIONS(845),
    [anon_sym_end] = ACTIONS(845),
    [anon_sym_if] = ACTIONS(847),
    [anon_sym_ifdef] = ACTIONS(845),
    [anon_sym_elseif] = ACTIONS(845),
    [anon_sym_iftype] = ACTIONS(845),
    [anon_sym_else] = ACTIONS(847),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(845),
    [anon_sym_try] = ACTIONS(845),
    [anon_sym_with] = ACTIONS(845),
    [anon_sym_repeat] = ACTIONS(845),
    [anon_sym_recover] = ACTIONS(845),
    [anon_sym_match] = ACTIONS(845),
    [anon_sym_return] = ACTIONS(845),
    [anon_sym_continue] = ACTIONS(845),
    [anon_sym_break] = ACTIONS(845),
    [anon_sym_consume] = ACTIONS(845),
    [anon_sym_object] = ACTIONS(845),
    [sym_number] = ACTIONS(847),
    [sym_float] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(845),
    [anon_sym_SQUOTE] = ACTIONS(845),
    [anon_sym_true] = ACTIONS(845),
    [anon_sym_false] = ACTIONS(845),
    [sym_this] = ACTIONS(845),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [510] = {
    [sym_identifier] = ACTIONS(839),
    [anon_sym_EQ] = ACTIONS(839),
    [anon_sym_AT] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(837),
    [anon_sym_is] = ACTIONS(839),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_var] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_DOT] = ACTIONS(839),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_SEMI] = ACTIONS(837),
    [sym_error] = ACTIONS(837),
    [sym_compile_intrinsic] = ACTIONS(837),
    [anon_sym_compile_error] = ACTIONS(837),
    [sym_location] = ACTIONS(837),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(837),
    [anon_sym_DASH_TILDE] = ACTIONS(837),
    [anon_sym_addressof] = ACTIONS(837),
    [anon_sym_digestof] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_STAR] = ACTIONS(839),
    [anon_sym_SLASH] = ACTIONS(839),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_GT_GT] = ACTIONS(839),
    [anon_sym_and] = ACTIONS(837),
    [anon_sym_or] = ACTIONS(837),
    [anon_sym_xor] = ACTIONS(837),
    [anon_sym_isnt] = ACTIONS(837),
    [anon_sym_EQ_EQ] = ACTIONS(839),
    [anon_sym_BANG_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(839),
    [anon_sym_PLUS_TILDE] = ACTIONS(837),
    [anon_sym_STAR_TILDE] = ACTIONS(837),
    [anon_sym_SLASH_TILDE] = ACTIONS(837),
    [anon_sym_PERCENT_TILDE] = ACTIONS(837),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(837),
    [anon_sym_LT_LT_TILDE] = ACTIONS(837),
    [anon_sym_GT_GT_TILDE] = ACTIONS(837),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(837),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(837),
    [anon_sym_GT_TILDE] = ACTIONS(837),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(837),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(837),
    [anon_sym_LT_TILDE] = ACTIONS(837),
    [anon_sym_PLUS_QMARK] = ACTIONS(837),
    [anon_sym_DASH_QMARK] = ACTIONS(837),
    [anon_sym_STAR_QMARK] = ACTIONS(837),
    [anon_sym_SLASH_QMARK] = ACTIONS(837),
    [anon_sym_PERCENT_QMARK] = ACTIONS(837),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(837),
    [anon_sym_as] = ACTIONS(837),
    [anon_sym_LPAREN2] = ACTIONS(837),
    [anon_sym_DOT_GT] = ACTIONS(837),
    [anon_sym_TILDE] = ACTIONS(837),
    [anon_sym_end] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_ifdef] = ACTIONS(837),
    [anon_sym_elseif] = ACTIONS(837),
    [anon_sym_iftype] = ACTIONS(837),
    [anon_sym_else] = ACTIONS(839),
    [anon_sym_for] = ACTIONS(837),
    [anon_sym_while] = ACTIONS(837),
    [anon_sym_try] = ACTIONS(837),
    [anon_sym_with] = ACTIONS(837),
    [anon_sym_repeat] = ACTIONS(837),
    [anon_sym_recover] = ACTIONS(837),
    [anon_sym_match] = ACTIONS(837),
    [anon_sym_return] = ACTIONS(837),
    [anon_sym_continue] = ACTIONS(837),
    [anon_sym_break] = ACTIONS(837),
    [anon_sym_consume] = ACTIONS(837),
    [anon_sym_object] = ACTIONS(837),
    [sym_number] = ACTIONS(839),
    [sym_float] = ACTIONS(837),
    [anon_sym_DQUOTE] = ACTIONS(839),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(837),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_true] = ACTIONS(837),
    [anon_sym_false] = ACTIONS(837),
    [sym_this] = ACTIONS(837),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [511] = {
    [sym_identifier] = ACTIONS(867),
    [anon_sym_EQ] = ACTIONS(867),
    [anon_sym_AT] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(865),
    [anon_sym_is] = ACTIONS(867),
    [anon_sym_let] = ACTIONS(865),
    [anon_sym_var] = ACTIONS(865),
    [anon_sym_LPAREN] = ACTIONS(867),
    [anon_sym_DOT] = ACTIONS(867),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_SEMI] = ACTIONS(865),
    [sym_error] = ACTIONS(865),
    [sym_compile_intrinsic] = ACTIONS(865),
    [anon_sym_compile_error] = ACTIONS(865),
    [sym_location] = ACTIONS(865),
    [anon_sym_DASH] = ACTIONS(867),
    [anon_sym_not] = ACTIONS(865),
    [anon_sym_DASH_TILDE] = ACTIONS(865),
    [anon_sym_addressof] = ACTIONS(865),
    [anon_sym_digestof] = ACTIONS(865),
    [anon_sym_PLUS] = ACTIONS(867),
    [anon_sym_STAR] = ACTIONS(867),
    [anon_sym_SLASH] = ACTIONS(867),
    [anon_sym_PERCENT] = ACTIONS(867),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(867),
    [anon_sym_LT_LT] = ACTIONS(867),
    [anon_sym_GT_GT] = ACTIONS(867),
    [anon_sym_and] = ACTIONS(865),
    [anon_sym_or] = ACTIONS(865),
    [anon_sym_xor] = ACTIONS(865),
    [anon_sym_isnt] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(867),
    [anon_sym_BANG_EQ] = ACTIONS(867),
    [anon_sym_GT] = ACTIONS(867),
    [anon_sym_GT_EQ] = ACTIONS(867),
    [anon_sym_LT_EQ] = ACTIONS(867),
    [anon_sym_LT] = ACTIONS(867),
    [anon_sym_PLUS_TILDE] = ACTIONS(865),
    [anon_sym_STAR_TILDE] = ACTIONS(865),
    [anon_sym_SLASH_TILDE] = ACTIONS(865),
    [anon_sym_PERCENT_TILDE] = ACTIONS(865),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(865),
    [anon_sym_LT_LT_TILDE] = ACTIONS(865),
    [anon_sym_GT_GT_TILDE] = ACTIONS(865),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(865),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(865),
    [anon_sym_GT_TILDE] = ACTIONS(865),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(865),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(865),
    [anon_sym_LT_TILDE] = ACTIONS(865),
    [anon_sym_PLUS_QMARK] = ACTIONS(865),
    [anon_sym_DASH_QMARK] = ACTIONS(865),
    [anon_sym_STAR_QMARK] = ACTIONS(865),
    [anon_sym_SLASH_QMARK] = ACTIONS(865),
    [anon_sym_PERCENT_QMARK] = ACTIONS(865),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(865),
    [anon_sym_LPAREN2] = ACTIONS(865),
    [anon_sym_DOT_GT] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [anon_sym_end] = ACTIONS(865),
    [anon_sym_if] = ACTIONS(867),
    [anon_sym_ifdef] = ACTIONS(865),
    [anon_sym_elseif] = ACTIONS(865),
    [anon_sym_iftype] = ACTIONS(865),
    [anon_sym_else] = ACTIONS(867),
    [anon_sym_for] = ACTIONS(865),
    [anon_sym_while] = ACTIONS(865),
    [anon_sym_try] = ACTIONS(865),
    [anon_sym_with] = ACTIONS(865),
    [anon_sym_repeat] = ACTIONS(865),
    [anon_sym_recover] = ACTIONS(865),
    [anon_sym_match] = ACTIONS(865),
    [anon_sym_return] = ACTIONS(865),
    [anon_sym_continue] = ACTIONS(865),
    [anon_sym_break] = ACTIONS(865),
    [anon_sym_consume] = ACTIONS(865),
    [anon_sym_object] = ACTIONS(865),
    [sym_number] = ACTIONS(867),
    [sym_float] = ACTIONS(865),
    [anon_sym_DQUOTE] = ACTIONS(867),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(865),
    [anon_sym_false] = ACTIONS(865),
    [sym_this] = ACTIONS(865),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [512] = {
    [sym_identifier] = ACTIONS(843),
    [anon_sym_EQ] = ACTIONS(843),
    [anon_sym_AT] = ACTIONS(841),
    [anon_sym_LBRACK] = ACTIONS(841),
    [anon_sym_is] = ACTIONS(843),
    [anon_sym_let] = ACTIONS(841),
    [anon_sym_var] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_DOT] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(841),
    [anon_sym_SEMI] = ACTIONS(841),
    [sym_error] = ACTIONS(841),
    [sym_compile_intrinsic] = ACTIONS(841),
    [anon_sym_compile_error] = ACTIONS(841),
    [sym_location] = ACTIONS(841),
    [anon_sym_DASH] = ACTIONS(843),
    [anon_sym_not] = ACTIONS(841),
    [anon_sym_DASH_TILDE] = ACTIONS(841),
    [anon_sym_addressof] = ACTIONS(841),
    [anon_sym_digestof] = ACTIONS(841),
    [anon_sym_PLUS] = ACTIONS(843),
    [anon_sym_STAR] = ACTIONS(843),
    [anon_sym_SLASH] = ACTIONS(843),
    [anon_sym_PERCENT] = ACTIONS(843),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(843),
    [anon_sym_LT_LT] = ACTIONS(843),
    [anon_sym_GT_GT] = ACTIONS(843),
    [anon_sym_and] = ACTIONS(841),
    [anon_sym_or] = ACTIONS(841),
    [anon_sym_xor] = ACTIONS(841),
    [anon_sym_isnt] = ACTIONS(841),
    [anon_sym_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(843),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_PLUS_TILDE] = ACTIONS(841),
    [anon_sym_STAR_TILDE] = ACTIONS(841),
    [anon_sym_SLASH_TILDE] = ACTIONS(841),
    [anon_sym_PERCENT_TILDE] = ACTIONS(841),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(841),
    [anon_sym_LT_LT_TILDE] = ACTIONS(841),
    [anon_sym_GT_GT_TILDE] = ACTIONS(841),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(841),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(841),
    [anon_sym_GT_TILDE] = ACTIONS(841),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(841),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(841),
    [anon_sym_LT_TILDE] = ACTIONS(841),
    [anon_sym_PLUS_QMARK] = ACTIONS(841),
    [anon_sym_DASH_QMARK] = ACTIONS(841),
    [anon_sym_STAR_QMARK] = ACTIONS(841),
    [anon_sym_SLASH_QMARK] = ACTIONS(841),
    [anon_sym_PERCENT_QMARK] = ACTIONS(841),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(841),
    [anon_sym_as] = ACTIONS(841),
    [anon_sym_LPAREN2] = ACTIONS(841),
    [anon_sym_DOT_GT] = ACTIONS(841),
    [anon_sym_TILDE] = ACTIONS(841),
    [anon_sym_end] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_ifdef] = ACTIONS(841),
    [anon_sym_elseif] = ACTIONS(841),
    [anon_sym_iftype] = ACTIONS(841),
    [anon_sym_else] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(841),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_with] = ACTIONS(841),
    [anon_sym_repeat] = ACTIONS(841),
    [anon_sym_recover] = ACTIONS(841),
    [anon_sym_match] = ACTIONS(841),
    [anon_sym_return] = ACTIONS(841),
    [anon_sym_continue] = ACTIONS(841),
    [anon_sym_break] = ACTIONS(841),
    [anon_sym_consume] = ACTIONS(841),
    [anon_sym_object] = ACTIONS(841),
    [sym_number] = ACTIONS(843),
    [sym_float] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(843),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(841),
    [anon_sym_SQUOTE] = ACTIONS(841),
    [anon_sym_true] = ACTIONS(841),
    [anon_sym_false] = ACTIONS(841),
    [sym_this] = ACTIONS(841),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [513] = {
    [sym_identifier] = ACTIONS(1178),
    [anon_sym_EQ] = ACTIONS(1178),
    [anon_sym_AT] = ACTIONS(1176),
    [anon_sym_LBRACK] = ACTIONS(1176),
    [anon_sym_is] = ACTIONS(1178),
    [anon_sym_let] = ACTIONS(1176),
    [anon_sym_var] = ACTIONS(1176),
    [anon_sym_LPAREN] = ACTIONS(1178),
    [anon_sym_DOT] = ACTIONS(1178),
    [anon_sym_LBRACE] = ACTIONS(1176),
    [anon_sym_SEMI] = ACTIONS(1176),
    [sym_error] = ACTIONS(1176),
    [sym_compile_intrinsic] = ACTIONS(1176),
    [anon_sym_compile_error] = ACTIONS(1176),
    [sym_location] = ACTIONS(1176),
    [anon_sym_DASH] = ACTIONS(1178),
    [anon_sym_not] = ACTIONS(1176),
    [anon_sym_DASH_TILDE] = ACTIONS(1176),
    [anon_sym_addressof] = ACTIONS(1176),
    [anon_sym_digestof] = ACTIONS(1176),
    [anon_sym_PLUS] = ACTIONS(1178),
    [anon_sym_STAR] = ACTIONS(1178),
    [anon_sym_SLASH] = ACTIONS(1178),
    [anon_sym_PERCENT] = ACTIONS(1178),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1178),
    [anon_sym_LT_LT] = ACTIONS(1178),
    [anon_sym_GT_GT] = ACTIONS(1178),
    [anon_sym_and] = ACTIONS(1176),
    [anon_sym_or] = ACTIONS(1176),
    [anon_sym_xor] = ACTIONS(1176),
    [anon_sym_isnt] = ACTIONS(1176),
    [anon_sym_EQ_EQ] = ACTIONS(1178),
    [anon_sym_BANG_EQ] = ACTIONS(1178),
    [anon_sym_GT] = ACTIONS(1178),
    [anon_sym_GT_EQ] = ACTIONS(1178),
    [anon_sym_LT_EQ] = ACTIONS(1178),
    [anon_sym_LT] = ACTIONS(1178),
    [anon_sym_PLUS_TILDE] = ACTIONS(1176),
    [anon_sym_STAR_TILDE] = ACTIONS(1176),
    [anon_sym_SLASH_TILDE] = ACTIONS(1176),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1176),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1176),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1176),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1176),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1176),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1176),
    [anon_sym_GT_TILDE] = ACTIONS(1176),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1176),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1176),
    [anon_sym_LT_TILDE] = ACTIONS(1176),
    [anon_sym_PLUS_QMARK] = ACTIONS(1176),
    [anon_sym_DASH_QMARK] = ACTIONS(1176),
    [anon_sym_STAR_QMARK] = ACTIONS(1176),
    [anon_sym_SLASH_QMARK] = ACTIONS(1176),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1176),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1176),
    [anon_sym_as] = ACTIONS(1176),
    [anon_sym_LPAREN2] = ACTIONS(1176),
    [anon_sym_DOT_GT] = ACTIONS(1176),
    [anon_sym_TILDE] = ACTIONS(1176),
    [anon_sym_end] = ACTIONS(1176),
    [anon_sym_if] = ACTIONS(1178),
    [anon_sym_ifdef] = ACTIONS(1176),
    [anon_sym_elseif] = ACTIONS(1176),
    [anon_sym_iftype] = ACTIONS(1176),
    [anon_sym_else] = ACTIONS(1178),
    [anon_sym_for] = ACTIONS(1176),
    [anon_sym_while] = ACTIONS(1176),
    [anon_sym_try] = ACTIONS(1176),
    [anon_sym_with] = ACTIONS(1176),
    [anon_sym_repeat] = ACTIONS(1176),
    [anon_sym_recover] = ACTIONS(1176),
    [anon_sym_match] = ACTIONS(1176),
    [anon_sym_return] = ACTIONS(1176),
    [anon_sym_continue] = ACTIONS(1176),
    [anon_sym_break] = ACTIONS(1176),
    [anon_sym_consume] = ACTIONS(1176),
    [anon_sym_object] = ACTIONS(1176),
    [sym_number] = ACTIONS(1178),
    [sym_float] = ACTIONS(1176),
    [anon_sym_DQUOTE] = ACTIONS(1178),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1176),
    [anon_sym_SQUOTE] = ACTIONS(1176),
    [anon_sym_true] = ACTIONS(1176),
    [anon_sym_false] = ACTIONS(1176),
    [sym_this] = ACTIONS(1176),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [514] = {
    [sym_identifier] = ACTIONS(1210),
    [anon_sym_EQ] = ACTIONS(1210),
    [anon_sym_AT] = ACTIONS(1208),
    [anon_sym_LBRACK] = ACTIONS(1208),
    [anon_sym_is] = ACTIONS(1210),
    [anon_sym_let] = ACTIONS(1208),
    [anon_sym_var] = ACTIONS(1208),
    [anon_sym_LPAREN] = ACTIONS(1210),
    [anon_sym_DOT] = ACTIONS(1210),
    [anon_sym_LBRACE] = ACTIONS(1208),
    [anon_sym_SEMI] = ACTIONS(1208),
    [sym_error] = ACTIONS(1208),
    [sym_compile_intrinsic] = ACTIONS(1208),
    [anon_sym_compile_error] = ACTIONS(1208),
    [sym_location] = ACTIONS(1208),
    [anon_sym_DASH] = ACTIONS(1210),
    [anon_sym_not] = ACTIONS(1208),
    [anon_sym_DASH_TILDE] = ACTIONS(1208),
    [anon_sym_addressof] = ACTIONS(1208),
    [anon_sym_digestof] = ACTIONS(1208),
    [anon_sym_PLUS] = ACTIONS(1210),
    [anon_sym_STAR] = ACTIONS(1210),
    [anon_sym_SLASH] = ACTIONS(1210),
    [anon_sym_PERCENT] = ACTIONS(1210),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1210),
    [anon_sym_LT_LT] = ACTIONS(1210),
    [anon_sym_GT_GT] = ACTIONS(1210),
    [anon_sym_and] = ACTIONS(1208),
    [anon_sym_or] = ACTIONS(1208),
    [anon_sym_xor] = ACTIONS(1208),
    [anon_sym_isnt] = ACTIONS(1208),
    [anon_sym_EQ_EQ] = ACTIONS(1210),
    [anon_sym_BANG_EQ] = ACTIONS(1210),
    [anon_sym_GT] = ACTIONS(1210),
    [anon_sym_GT_EQ] = ACTIONS(1210),
    [anon_sym_LT_EQ] = ACTIONS(1210),
    [anon_sym_LT] = ACTIONS(1210),
    [anon_sym_PLUS_TILDE] = ACTIONS(1208),
    [anon_sym_STAR_TILDE] = ACTIONS(1208),
    [anon_sym_SLASH_TILDE] = ACTIONS(1208),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1208),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1208),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1208),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1208),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1208),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1208),
    [anon_sym_GT_TILDE] = ACTIONS(1208),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1208),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1208),
    [anon_sym_LT_TILDE] = ACTIONS(1208),
    [anon_sym_PLUS_QMARK] = ACTIONS(1208),
    [anon_sym_DASH_QMARK] = ACTIONS(1208),
    [anon_sym_STAR_QMARK] = ACTIONS(1208),
    [anon_sym_SLASH_QMARK] = ACTIONS(1208),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1208),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1208),
    [anon_sym_as] = ACTIONS(1208),
    [anon_sym_LPAREN2] = ACTIONS(1208),
    [anon_sym_DOT_GT] = ACTIONS(1208),
    [anon_sym_TILDE] = ACTIONS(1208),
    [anon_sym_end] = ACTIONS(1208),
    [anon_sym_if] = ACTIONS(1210),
    [anon_sym_ifdef] = ACTIONS(1208),
    [anon_sym_elseif] = ACTIONS(1208),
    [anon_sym_iftype] = ACTIONS(1208),
    [anon_sym_else] = ACTIONS(1210),
    [anon_sym_for] = ACTIONS(1208),
    [anon_sym_while] = ACTIONS(1208),
    [anon_sym_try] = ACTIONS(1208),
    [anon_sym_with] = ACTIONS(1208),
    [anon_sym_repeat] = ACTIONS(1208),
    [anon_sym_recover] = ACTIONS(1208),
    [anon_sym_match] = ACTIONS(1208),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_continue] = ACTIONS(1208),
    [anon_sym_break] = ACTIONS(1208),
    [anon_sym_consume] = ACTIONS(1208),
    [anon_sym_object] = ACTIONS(1208),
    [sym_number] = ACTIONS(1210),
    [sym_float] = ACTIONS(1208),
    [anon_sym_DQUOTE] = ACTIONS(1210),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1208),
    [anon_sym_SQUOTE] = ACTIONS(1208),
    [anon_sym_true] = ACTIONS(1208),
    [anon_sym_false] = ACTIONS(1208),
    [sym_this] = ACTIONS(1208),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [515] = {
    [sym_identifier] = ACTIONS(1250),
    [anon_sym_EQ] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1248),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_is] = ACTIONS(1250),
    [anon_sym_let] = ACTIONS(1248),
    [anon_sym_var] = ACTIONS(1248),
    [anon_sym_LPAREN] = ACTIONS(1250),
    [anon_sym_DOT] = ACTIONS(1250),
    [anon_sym_LBRACE] = ACTIONS(1248),
    [anon_sym_SEMI] = ACTIONS(1248),
    [sym_error] = ACTIONS(1248),
    [sym_compile_intrinsic] = ACTIONS(1248),
    [anon_sym_compile_error] = ACTIONS(1248),
    [sym_location] = ACTIONS(1248),
    [anon_sym_DASH] = ACTIONS(1250),
    [anon_sym_not] = ACTIONS(1248),
    [anon_sym_DASH_TILDE] = ACTIONS(1248),
    [anon_sym_addressof] = ACTIONS(1248),
    [anon_sym_digestof] = ACTIONS(1248),
    [anon_sym_PLUS] = ACTIONS(1250),
    [anon_sym_STAR] = ACTIONS(1250),
    [anon_sym_SLASH] = ACTIONS(1250),
    [anon_sym_PERCENT] = ACTIONS(1250),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1250),
    [anon_sym_LT_LT] = ACTIONS(1250),
    [anon_sym_GT_GT] = ACTIONS(1250),
    [anon_sym_and] = ACTIONS(1248),
    [anon_sym_or] = ACTIONS(1248),
    [anon_sym_xor] = ACTIONS(1248),
    [anon_sym_isnt] = ACTIONS(1248),
    [anon_sym_EQ_EQ] = ACTIONS(1250),
    [anon_sym_BANG_EQ] = ACTIONS(1250),
    [anon_sym_GT] = ACTIONS(1250),
    [anon_sym_GT_EQ] = ACTIONS(1250),
    [anon_sym_LT_EQ] = ACTIONS(1250),
    [anon_sym_LT] = ACTIONS(1250),
    [anon_sym_PLUS_TILDE] = ACTIONS(1248),
    [anon_sym_STAR_TILDE] = ACTIONS(1248),
    [anon_sym_SLASH_TILDE] = ACTIONS(1248),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1248),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1248),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1248),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1248),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1248),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1248),
    [anon_sym_GT_TILDE] = ACTIONS(1248),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1248),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1248),
    [anon_sym_LT_TILDE] = ACTIONS(1248),
    [anon_sym_PLUS_QMARK] = ACTIONS(1248),
    [anon_sym_DASH_QMARK] = ACTIONS(1248),
    [anon_sym_STAR_QMARK] = ACTIONS(1248),
    [anon_sym_SLASH_QMARK] = ACTIONS(1248),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1248),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1248),
    [anon_sym_as] = ACTIONS(1248),
    [anon_sym_LPAREN2] = ACTIONS(1248),
    [anon_sym_DOT_GT] = ACTIONS(1248),
    [anon_sym_TILDE] = ACTIONS(1248),
    [anon_sym_end] = ACTIONS(1248),
    [anon_sym_if] = ACTIONS(1250),
    [anon_sym_ifdef] = ACTIONS(1248),
    [anon_sym_elseif] = ACTIONS(1248),
    [anon_sym_iftype] = ACTIONS(1248),
    [anon_sym_else] = ACTIONS(1250),
    [anon_sym_for] = ACTIONS(1248),
    [anon_sym_while] = ACTIONS(1248),
    [anon_sym_try] = ACTIONS(1248),
    [anon_sym_with] = ACTIONS(1248),
    [anon_sym_repeat] = ACTIONS(1248),
    [anon_sym_recover] = ACTIONS(1248),
    [anon_sym_match] = ACTIONS(1248),
    [anon_sym_return] = ACTIONS(1248),
    [anon_sym_continue] = ACTIONS(1248),
    [anon_sym_break] = ACTIONS(1248),
    [anon_sym_consume] = ACTIONS(1248),
    [anon_sym_object] = ACTIONS(1248),
    [sym_number] = ACTIONS(1250),
    [sym_float] = ACTIONS(1248),
    [anon_sym_DQUOTE] = ACTIONS(1250),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_true] = ACTIONS(1248),
    [anon_sym_false] = ACTIONS(1248),
    [sym_this] = ACTIONS(1248),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [516] = {
    [sym_identifier] = ACTIONS(1282),
    [anon_sym_EQ] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(1280),
    [anon_sym_LBRACK] = ACTIONS(1280),
    [anon_sym_is] = ACTIONS(1282),
    [anon_sym_let] = ACTIONS(1280),
    [anon_sym_var] = ACTIONS(1280),
    [anon_sym_LPAREN] = ACTIONS(1282),
    [anon_sym_DOT] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(1280),
    [anon_sym_SEMI] = ACTIONS(1280),
    [sym_error] = ACTIONS(1280),
    [sym_compile_intrinsic] = ACTIONS(1280),
    [anon_sym_compile_error] = ACTIONS(1280),
    [sym_location] = ACTIONS(1280),
    [anon_sym_DASH] = ACTIONS(1282),
    [anon_sym_not] = ACTIONS(1280),
    [anon_sym_DASH_TILDE] = ACTIONS(1280),
    [anon_sym_addressof] = ACTIONS(1280),
    [anon_sym_digestof] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1282),
    [anon_sym_STAR] = ACTIONS(1282),
    [anon_sym_SLASH] = ACTIONS(1282),
    [anon_sym_PERCENT] = ACTIONS(1282),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1282),
    [anon_sym_LT_LT] = ACTIONS(1282),
    [anon_sym_GT_GT] = ACTIONS(1282),
    [anon_sym_and] = ACTIONS(1280),
    [anon_sym_or] = ACTIONS(1280),
    [anon_sym_xor] = ACTIONS(1280),
    [anon_sym_isnt] = ACTIONS(1280),
    [anon_sym_EQ_EQ] = ACTIONS(1282),
    [anon_sym_BANG_EQ] = ACTIONS(1282),
    [anon_sym_GT] = ACTIONS(1282),
    [anon_sym_GT_EQ] = ACTIONS(1282),
    [anon_sym_LT_EQ] = ACTIONS(1282),
    [anon_sym_LT] = ACTIONS(1282),
    [anon_sym_PLUS_TILDE] = ACTIONS(1280),
    [anon_sym_STAR_TILDE] = ACTIONS(1280),
    [anon_sym_SLASH_TILDE] = ACTIONS(1280),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1280),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1280),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1280),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1280),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1280),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1280),
    [anon_sym_GT_TILDE] = ACTIONS(1280),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1280),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1280),
    [anon_sym_LT_TILDE] = ACTIONS(1280),
    [anon_sym_PLUS_QMARK] = ACTIONS(1280),
    [anon_sym_DASH_QMARK] = ACTIONS(1280),
    [anon_sym_STAR_QMARK] = ACTIONS(1280),
    [anon_sym_SLASH_QMARK] = ACTIONS(1280),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1280),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1280),
    [anon_sym_as] = ACTIONS(1280),
    [anon_sym_LPAREN2] = ACTIONS(1280),
    [anon_sym_DOT_GT] = ACTIONS(1280),
    [anon_sym_TILDE] = ACTIONS(1280),
    [anon_sym_end] = ACTIONS(1280),
    [anon_sym_if] = ACTIONS(1282),
    [anon_sym_ifdef] = ACTIONS(1280),
    [anon_sym_elseif] = ACTIONS(1280),
    [anon_sym_iftype] = ACTIONS(1280),
    [anon_sym_else] = ACTIONS(1282),
    [anon_sym_for] = ACTIONS(1280),
    [anon_sym_while] = ACTIONS(1280),
    [anon_sym_try] = ACTIONS(1280),
    [anon_sym_with] = ACTIONS(1280),
    [anon_sym_repeat] = ACTIONS(1280),
    [anon_sym_recover] = ACTIONS(1280),
    [anon_sym_match] = ACTIONS(1280),
    [anon_sym_return] = ACTIONS(1280),
    [anon_sym_continue] = ACTIONS(1280),
    [anon_sym_break] = ACTIONS(1280),
    [anon_sym_consume] = ACTIONS(1280),
    [anon_sym_object] = ACTIONS(1280),
    [sym_number] = ACTIONS(1282),
    [sym_float] = ACTIONS(1280),
    [anon_sym_DQUOTE] = ACTIONS(1282),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1280),
    [anon_sym_SQUOTE] = ACTIONS(1280),
    [anon_sym_true] = ACTIONS(1280),
    [anon_sym_false] = ACTIONS(1280),
    [sym_this] = ACTIONS(1280),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [517] = {
    [sym_identifier] = ACTIONS(1270),
    [anon_sym_EQ] = ACTIONS(1270),
    [anon_sym_AT] = ACTIONS(1268),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [anon_sym_is] = ACTIONS(1270),
    [anon_sym_let] = ACTIONS(1268),
    [anon_sym_var] = ACTIONS(1268),
    [anon_sym_LPAREN] = ACTIONS(1270),
    [anon_sym_DOT] = ACTIONS(1270),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_SEMI] = ACTIONS(1268),
    [sym_error] = ACTIONS(1268),
    [sym_compile_intrinsic] = ACTIONS(1268),
    [anon_sym_compile_error] = ACTIONS(1268),
    [sym_location] = ACTIONS(1268),
    [anon_sym_DASH] = ACTIONS(1270),
    [anon_sym_not] = ACTIONS(1268),
    [anon_sym_DASH_TILDE] = ACTIONS(1268),
    [anon_sym_addressof] = ACTIONS(1268),
    [anon_sym_digestof] = ACTIONS(1268),
    [anon_sym_PLUS] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1270),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_PERCENT] = ACTIONS(1270),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1270),
    [anon_sym_LT_LT] = ACTIONS(1270),
    [anon_sym_GT_GT] = ACTIONS(1270),
    [anon_sym_and] = ACTIONS(1268),
    [anon_sym_or] = ACTIONS(1268),
    [anon_sym_xor] = ACTIONS(1268),
    [anon_sym_isnt] = ACTIONS(1268),
    [anon_sym_EQ_EQ] = ACTIONS(1270),
    [anon_sym_BANG_EQ] = ACTIONS(1270),
    [anon_sym_GT] = ACTIONS(1270),
    [anon_sym_GT_EQ] = ACTIONS(1270),
    [anon_sym_LT_EQ] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(1270),
    [anon_sym_PLUS_TILDE] = ACTIONS(1268),
    [anon_sym_STAR_TILDE] = ACTIONS(1268),
    [anon_sym_SLASH_TILDE] = ACTIONS(1268),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1268),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1268),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1268),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1268),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1268),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1268),
    [anon_sym_GT_TILDE] = ACTIONS(1268),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1268),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1268),
    [anon_sym_LT_TILDE] = ACTIONS(1268),
    [anon_sym_PLUS_QMARK] = ACTIONS(1268),
    [anon_sym_DASH_QMARK] = ACTIONS(1268),
    [anon_sym_STAR_QMARK] = ACTIONS(1268),
    [anon_sym_SLASH_QMARK] = ACTIONS(1268),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1268),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1268),
    [anon_sym_as] = ACTIONS(1268),
    [anon_sym_LPAREN2] = ACTIONS(1268),
    [anon_sym_DOT_GT] = ACTIONS(1268),
    [anon_sym_TILDE] = ACTIONS(1268),
    [anon_sym_end] = ACTIONS(1268),
    [anon_sym_if] = ACTIONS(1270),
    [anon_sym_ifdef] = ACTIONS(1268),
    [anon_sym_elseif] = ACTIONS(1268),
    [anon_sym_iftype] = ACTIONS(1268),
    [anon_sym_else] = ACTIONS(1270),
    [anon_sym_for] = ACTIONS(1268),
    [anon_sym_while] = ACTIONS(1268),
    [anon_sym_try] = ACTIONS(1268),
    [anon_sym_with] = ACTIONS(1268),
    [anon_sym_repeat] = ACTIONS(1268),
    [anon_sym_recover] = ACTIONS(1268),
    [anon_sym_match] = ACTIONS(1268),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_continue] = ACTIONS(1268),
    [anon_sym_break] = ACTIONS(1268),
    [anon_sym_consume] = ACTIONS(1268),
    [anon_sym_object] = ACTIONS(1268),
    [sym_number] = ACTIONS(1270),
    [sym_float] = ACTIONS(1268),
    [anon_sym_DQUOTE] = ACTIONS(1270),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1268),
    [anon_sym_SQUOTE] = ACTIONS(1268),
    [anon_sym_true] = ACTIONS(1268),
    [anon_sym_false] = ACTIONS(1268),
    [sym_this] = ACTIONS(1268),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [518] = {
    [sym_identifier] = ACTIONS(833),
    [anon_sym_EQ] = ACTIONS(833),
    [anon_sym_AT] = ACTIONS(831),
    [anon_sym_LBRACK] = ACTIONS(831),
    [anon_sym_is] = ACTIONS(833),
    [anon_sym_let] = ACTIONS(831),
    [anon_sym_var] = ACTIONS(831),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_DOT] = ACTIONS(833),
    [anon_sym_LBRACE] = ACTIONS(831),
    [anon_sym_SEMI] = ACTIONS(831),
    [sym_error] = ACTIONS(831),
    [sym_compile_intrinsic] = ACTIONS(831),
    [anon_sym_compile_error] = ACTIONS(831),
    [sym_location] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_not] = ACTIONS(831),
    [anon_sym_DASH_TILDE] = ACTIONS(831),
    [anon_sym_addressof] = ACTIONS(831),
    [anon_sym_digestof] = ACTIONS(831),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_STAR] = ACTIONS(833),
    [anon_sym_SLASH] = ACTIONS(833),
    [anon_sym_PERCENT] = ACTIONS(833),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(833),
    [anon_sym_LT_LT] = ACTIONS(833),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_and] = ACTIONS(831),
    [anon_sym_or] = ACTIONS(831),
    [anon_sym_xor] = ACTIONS(831),
    [anon_sym_isnt] = ACTIONS(831),
    [anon_sym_EQ_EQ] = ACTIONS(833),
    [anon_sym_BANG_EQ] = ACTIONS(833),
    [anon_sym_GT] = ACTIONS(833),
    [anon_sym_GT_EQ] = ACTIONS(833),
    [anon_sym_LT_EQ] = ACTIONS(833),
    [anon_sym_LT] = ACTIONS(833),
    [anon_sym_PLUS_TILDE] = ACTIONS(831),
    [anon_sym_STAR_TILDE] = ACTIONS(831),
    [anon_sym_SLASH_TILDE] = ACTIONS(831),
    [anon_sym_PERCENT_TILDE] = ACTIONS(831),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(831),
    [anon_sym_LT_LT_TILDE] = ACTIONS(831),
    [anon_sym_GT_GT_TILDE] = ACTIONS(831),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(831),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(831),
    [anon_sym_GT_TILDE] = ACTIONS(831),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(831),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(831),
    [anon_sym_LT_TILDE] = ACTIONS(831),
    [anon_sym_PLUS_QMARK] = ACTIONS(831),
    [anon_sym_DASH_QMARK] = ACTIONS(831),
    [anon_sym_STAR_QMARK] = ACTIONS(831),
    [anon_sym_SLASH_QMARK] = ACTIONS(831),
    [anon_sym_PERCENT_QMARK] = ACTIONS(831),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(831),
    [anon_sym_as] = ACTIONS(831),
    [anon_sym_LPAREN2] = ACTIONS(831),
    [anon_sym_DOT_GT] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(831),
    [anon_sym_end] = ACTIONS(831),
    [anon_sym_if] = ACTIONS(833),
    [anon_sym_ifdef] = ACTIONS(831),
    [anon_sym_elseif] = ACTIONS(831),
    [anon_sym_iftype] = ACTIONS(831),
    [anon_sym_else] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(831),
    [anon_sym_while] = ACTIONS(831),
    [anon_sym_try] = ACTIONS(831),
    [anon_sym_with] = ACTIONS(831),
    [anon_sym_repeat] = ACTIONS(831),
    [anon_sym_recover] = ACTIONS(831),
    [anon_sym_match] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_continue] = ACTIONS(831),
    [anon_sym_break] = ACTIONS(831),
    [anon_sym_consume] = ACTIONS(831),
    [anon_sym_object] = ACTIONS(831),
    [sym_number] = ACTIONS(833),
    [sym_float] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(833),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(831),
    [anon_sym_SQUOTE] = ACTIONS(831),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_this] = ACTIONS(831),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [519] = {
    [sym_identifier] = ACTIONS(1104),
    [anon_sym_EQ] = ACTIONS(1104),
    [anon_sym_AT] = ACTIONS(1102),
    [anon_sym_LBRACK] = ACTIONS(1102),
    [anon_sym_is] = ACTIONS(1104),
    [anon_sym_let] = ACTIONS(1102),
    [anon_sym_var] = ACTIONS(1102),
    [anon_sym_LPAREN] = ACTIONS(1104),
    [anon_sym_DOT] = ACTIONS(1104),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1102),
    [sym_error] = ACTIONS(1102),
    [sym_compile_intrinsic] = ACTIONS(1102),
    [anon_sym_compile_error] = ACTIONS(1102),
    [sym_location] = ACTIONS(1102),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_not] = ACTIONS(1102),
    [anon_sym_DASH_TILDE] = ACTIONS(1102),
    [anon_sym_addressof] = ACTIONS(1102),
    [anon_sym_digestof] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1104),
    [anon_sym_SLASH] = ACTIONS(1104),
    [anon_sym_PERCENT] = ACTIONS(1104),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1104),
    [anon_sym_LT_LT] = ACTIONS(1104),
    [anon_sym_GT_GT] = ACTIONS(1104),
    [anon_sym_and] = ACTIONS(1102),
    [anon_sym_or] = ACTIONS(1102),
    [anon_sym_xor] = ACTIONS(1102),
    [anon_sym_isnt] = ACTIONS(1102),
    [anon_sym_EQ_EQ] = ACTIONS(1104),
    [anon_sym_BANG_EQ] = ACTIONS(1104),
    [anon_sym_GT] = ACTIONS(1104),
    [anon_sym_GT_EQ] = ACTIONS(1104),
    [anon_sym_LT_EQ] = ACTIONS(1104),
    [anon_sym_LT] = ACTIONS(1104),
    [anon_sym_PLUS_TILDE] = ACTIONS(1102),
    [anon_sym_STAR_TILDE] = ACTIONS(1102),
    [anon_sym_SLASH_TILDE] = ACTIONS(1102),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1102),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1102),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1102),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1102),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1102),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1102),
    [anon_sym_GT_TILDE] = ACTIONS(1102),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1102),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1102),
    [anon_sym_LT_TILDE] = ACTIONS(1102),
    [anon_sym_PLUS_QMARK] = ACTIONS(1102),
    [anon_sym_DASH_QMARK] = ACTIONS(1102),
    [anon_sym_STAR_QMARK] = ACTIONS(1102),
    [anon_sym_SLASH_QMARK] = ACTIONS(1102),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1102),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1102),
    [anon_sym_as] = ACTIONS(1102),
    [anon_sym_LPAREN2] = ACTIONS(1102),
    [anon_sym_DOT_GT] = ACTIONS(1102),
    [anon_sym_TILDE] = ACTIONS(1102),
    [anon_sym_end] = ACTIONS(1102),
    [anon_sym_if] = ACTIONS(1104),
    [anon_sym_ifdef] = ACTIONS(1102),
    [anon_sym_elseif] = ACTIONS(1102),
    [anon_sym_iftype] = ACTIONS(1102),
    [anon_sym_else] = ACTIONS(1104),
    [anon_sym_for] = ACTIONS(1102),
    [anon_sym_while] = ACTIONS(1102),
    [anon_sym_try] = ACTIONS(1102),
    [anon_sym_with] = ACTIONS(1102),
    [anon_sym_repeat] = ACTIONS(1102),
    [anon_sym_recover] = ACTIONS(1102),
    [anon_sym_match] = ACTIONS(1102),
    [anon_sym_return] = ACTIONS(1102),
    [anon_sym_continue] = ACTIONS(1102),
    [anon_sym_break] = ACTIONS(1102),
    [anon_sym_consume] = ACTIONS(1102),
    [anon_sym_object] = ACTIONS(1102),
    [sym_number] = ACTIONS(1104),
    [sym_float] = ACTIONS(1102),
    [anon_sym_DQUOTE] = ACTIONS(1104),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1102),
    [anon_sym_SQUOTE] = ACTIONS(1102),
    [anon_sym_true] = ACTIONS(1102),
    [anon_sym_false] = ACTIONS(1102),
    [sym_this] = ACTIONS(1102),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [520] = {
    [sym_identifier] = ACTIONS(855),
    [anon_sym_EQ] = ACTIONS(855),
    [anon_sym_AT] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_is] = ACTIONS(855),
    [anon_sym_let] = ACTIONS(853),
    [anon_sym_var] = ACTIONS(853),
    [anon_sym_LPAREN] = ACTIONS(855),
    [anon_sym_DOT] = ACTIONS(855),
    [anon_sym_LBRACE] = ACTIONS(853),
    [anon_sym_SEMI] = ACTIONS(853),
    [sym_error] = ACTIONS(853),
    [sym_compile_intrinsic] = ACTIONS(853),
    [anon_sym_compile_error] = ACTIONS(853),
    [sym_location] = ACTIONS(853),
    [anon_sym_DASH] = ACTIONS(855),
    [anon_sym_not] = ACTIONS(853),
    [anon_sym_DASH_TILDE] = ACTIONS(853),
    [anon_sym_addressof] = ACTIONS(853),
    [anon_sym_digestof] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(855),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_PERCENT] = ACTIONS(855),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(855),
    [anon_sym_LT_LT] = ACTIONS(855),
    [anon_sym_GT_GT] = ACTIONS(855),
    [anon_sym_and] = ACTIONS(853),
    [anon_sym_or] = ACTIONS(853),
    [anon_sym_xor] = ACTIONS(853),
    [anon_sym_isnt] = ACTIONS(853),
    [anon_sym_EQ_EQ] = ACTIONS(855),
    [anon_sym_BANG_EQ] = ACTIONS(855),
    [anon_sym_GT] = ACTIONS(855),
    [anon_sym_GT_EQ] = ACTIONS(855),
    [anon_sym_LT_EQ] = ACTIONS(855),
    [anon_sym_LT] = ACTIONS(855),
    [anon_sym_PLUS_TILDE] = ACTIONS(853),
    [anon_sym_STAR_TILDE] = ACTIONS(853),
    [anon_sym_SLASH_TILDE] = ACTIONS(853),
    [anon_sym_PERCENT_TILDE] = ACTIONS(853),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(853),
    [anon_sym_LT_LT_TILDE] = ACTIONS(853),
    [anon_sym_GT_GT_TILDE] = ACTIONS(853),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(853),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(853),
    [anon_sym_GT_TILDE] = ACTIONS(853),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(853),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(853),
    [anon_sym_LT_TILDE] = ACTIONS(853),
    [anon_sym_PLUS_QMARK] = ACTIONS(853),
    [anon_sym_DASH_QMARK] = ACTIONS(853),
    [anon_sym_STAR_QMARK] = ACTIONS(853),
    [anon_sym_SLASH_QMARK] = ACTIONS(853),
    [anon_sym_PERCENT_QMARK] = ACTIONS(853),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(853),
    [anon_sym_as] = ACTIONS(853),
    [anon_sym_LPAREN2] = ACTIONS(853),
    [anon_sym_DOT_GT] = ACTIONS(853),
    [anon_sym_TILDE] = ACTIONS(853),
    [anon_sym_end] = ACTIONS(853),
    [anon_sym_if] = ACTIONS(855),
    [anon_sym_ifdef] = ACTIONS(853),
    [anon_sym_elseif] = ACTIONS(853),
    [anon_sym_iftype] = ACTIONS(853),
    [anon_sym_else] = ACTIONS(855),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_while] = ACTIONS(853),
    [anon_sym_try] = ACTIONS(853),
    [anon_sym_with] = ACTIONS(853),
    [anon_sym_repeat] = ACTIONS(853),
    [anon_sym_recover] = ACTIONS(853),
    [anon_sym_match] = ACTIONS(853),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_continue] = ACTIONS(853),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_consume] = ACTIONS(853),
    [anon_sym_object] = ACTIONS(853),
    [sym_number] = ACTIONS(855),
    [sym_float] = ACTIONS(853),
    [anon_sym_DQUOTE] = ACTIONS(855),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(853),
    [anon_sym_SQUOTE] = ACTIONS(853),
    [anon_sym_true] = ACTIONS(853),
    [anon_sym_false] = ACTIONS(853),
    [sym_this] = ACTIONS(853),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [521] = {
    [sym_identifier] = ACTIONS(1262),
    [anon_sym_EQ] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(1260),
    [anon_sym_LBRACK] = ACTIONS(1260),
    [anon_sym_is] = ACTIONS(1262),
    [anon_sym_let] = ACTIONS(1260),
    [anon_sym_var] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1262),
    [anon_sym_DOT] = ACTIONS(1262),
    [anon_sym_LBRACE] = ACTIONS(1260),
    [anon_sym_SEMI] = ACTIONS(1260),
    [sym_error] = ACTIONS(1260),
    [sym_compile_intrinsic] = ACTIONS(1260),
    [anon_sym_compile_error] = ACTIONS(1260),
    [sym_location] = ACTIONS(1260),
    [anon_sym_DASH] = ACTIONS(1262),
    [anon_sym_not] = ACTIONS(1260),
    [anon_sym_DASH_TILDE] = ACTIONS(1260),
    [anon_sym_addressof] = ACTIONS(1260),
    [anon_sym_digestof] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(1262),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_SLASH] = ACTIONS(1262),
    [anon_sym_PERCENT] = ACTIONS(1262),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1262),
    [anon_sym_LT_LT] = ACTIONS(1262),
    [anon_sym_GT_GT] = ACTIONS(1262),
    [anon_sym_and] = ACTIONS(1260),
    [anon_sym_or] = ACTIONS(1260),
    [anon_sym_xor] = ACTIONS(1260),
    [anon_sym_isnt] = ACTIONS(1260),
    [anon_sym_EQ_EQ] = ACTIONS(1262),
    [anon_sym_BANG_EQ] = ACTIONS(1262),
    [anon_sym_GT] = ACTIONS(1262),
    [anon_sym_GT_EQ] = ACTIONS(1262),
    [anon_sym_LT_EQ] = ACTIONS(1262),
    [anon_sym_LT] = ACTIONS(1262),
    [anon_sym_PLUS_TILDE] = ACTIONS(1260),
    [anon_sym_STAR_TILDE] = ACTIONS(1260),
    [anon_sym_SLASH_TILDE] = ACTIONS(1260),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1260),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1260),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1260),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1260),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1260),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1260),
    [anon_sym_GT_TILDE] = ACTIONS(1260),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1260),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1260),
    [anon_sym_LT_TILDE] = ACTIONS(1260),
    [anon_sym_PLUS_QMARK] = ACTIONS(1260),
    [anon_sym_DASH_QMARK] = ACTIONS(1260),
    [anon_sym_STAR_QMARK] = ACTIONS(1260),
    [anon_sym_SLASH_QMARK] = ACTIONS(1260),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1260),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1260),
    [anon_sym_as] = ACTIONS(1260),
    [anon_sym_LPAREN2] = ACTIONS(1260),
    [anon_sym_DOT_GT] = ACTIONS(1260),
    [anon_sym_TILDE] = ACTIONS(1260),
    [anon_sym_end] = ACTIONS(1260),
    [anon_sym_if] = ACTIONS(1262),
    [anon_sym_ifdef] = ACTIONS(1260),
    [anon_sym_elseif] = ACTIONS(1260),
    [anon_sym_iftype] = ACTIONS(1260),
    [anon_sym_else] = ACTIONS(1262),
    [anon_sym_for] = ACTIONS(1260),
    [anon_sym_while] = ACTIONS(1260),
    [anon_sym_try] = ACTIONS(1260),
    [anon_sym_with] = ACTIONS(1260),
    [anon_sym_repeat] = ACTIONS(1260),
    [anon_sym_recover] = ACTIONS(1260),
    [anon_sym_match] = ACTIONS(1260),
    [anon_sym_return] = ACTIONS(1260),
    [anon_sym_continue] = ACTIONS(1260),
    [anon_sym_break] = ACTIONS(1260),
    [anon_sym_consume] = ACTIONS(1260),
    [anon_sym_object] = ACTIONS(1260),
    [sym_number] = ACTIONS(1262),
    [sym_float] = ACTIONS(1260),
    [anon_sym_DQUOTE] = ACTIONS(1262),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1260),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [anon_sym_true] = ACTIONS(1260),
    [anon_sym_false] = ACTIONS(1260),
    [sym_this] = ACTIONS(1260),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [522] = {
    [sym_identifier] = ACTIONS(640),
    [anon_sym_EQ] = ACTIONS(640),
    [anon_sym_AT] = ACTIONS(638),
    [anon_sym_LBRACK] = ACTIONS(638),
    [anon_sym_is] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(638),
    [anon_sym_var] = ACTIONS(638),
    [anon_sym_LPAREN] = ACTIONS(640),
    [anon_sym_DOT] = ACTIONS(640),
    [anon_sym_LBRACE] = ACTIONS(638),
    [anon_sym_SEMI] = ACTIONS(638),
    [sym_error] = ACTIONS(638),
    [sym_compile_intrinsic] = ACTIONS(638),
    [anon_sym_compile_error] = ACTIONS(638),
    [sym_location] = ACTIONS(638),
    [anon_sym_DASH] = ACTIONS(640),
    [anon_sym_not] = ACTIONS(638),
    [anon_sym_DASH_TILDE] = ACTIONS(638),
    [anon_sym_addressof] = ACTIONS(638),
    [anon_sym_digestof] = ACTIONS(638),
    [anon_sym_PLUS] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(640),
    [anon_sym_SLASH] = ACTIONS(640),
    [anon_sym_PERCENT] = ACTIONS(640),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(640),
    [anon_sym_LT_LT] = ACTIONS(640),
    [anon_sym_GT_GT] = ACTIONS(640),
    [anon_sym_and] = ACTIONS(638),
    [anon_sym_or] = ACTIONS(638),
    [anon_sym_xor] = ACTIONS(638),
    [anon_sym_isnt] = ACTIONS(638),
    [anon_sym_EQ_EQ] = ACTIONS(640),
    [anon_sym_BANG_EQ] = ACTIONS(640),
    [anon_sym_GT] = ACTIONS(640),
    [anon_sym_GT_EQ] = ACTIONS(640),
    [anon_sym_LT_EQ] = ACTIONS(640),
    [anon_sym_LT] = ACTIONS(640),
    [anon_sym_PLUS_TILDE] = ACTIONS(638),
    [anon_sym_STAR_TILDE] = ACTIONS(638),
    [anon_sym_SLASH_TILDE] = ACTIONS(638),
    [anon_sym_PERCENT_TILDE] = ACTIONS(638),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(638),
    [anon_sym_LT_LT_TILDE] = ACTIONS(638),
    [anon_sym_GT_GT_TILDE] = ACTIONS(638),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(638),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(638),
    [anon_sym_GT_TILDE] = ACTIONS(638),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(638),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(638),
    [anon_sym_LT_TILDE] = ACTIONS(638),
    [anon_sym_PLUS_QMARK] = ACTIONS(638),
    [anon_sym_DASH_QMARK] = ACTIONS(638),
    [anon_sym_STAR_QMARK] = ACTIONS(638),
    [anon_sym_SLASH_QMARK] = ACTIONS(638),
    [anon_sym_PERCENT_QMARK] = ACTIONS(638),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(638),
    [anon_sym_as] = ACTIONS(638),
    [anon_sym_LPAREN2] = ACTIONS(638),
    [anon_sym_DOT_GT] = ACTIONS(638),
    [anon_sym_TILDE] = ACTIONS(638),
    [anon_sym_end] = ACTIONS(638),
    [anon_sym_if] = ACTIONS(640),
    [anon_sym_ifdef] = ACTIONS(638),
    [anon_sym_elseif] = ACTIONS(638),
    [anon_sym_iftype] = ACTIONS(638),
    [anon_sym_else] = ACTIONS(640),
    [anon_sym_for] = ACTIONS(638),
    [anon_sym_while] = ACTIONS(638),
    [anon_sym_try] = ACTIONS(638),
    [anon_sym_with] = ACTIONS(638),
    [anon_sym_repeat] = ACTIONS(638),
    [anon_sym_recover] = ACTIONS(638),
    [anon_sym_match] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(638),
    [anon_sym_continue] = ACTIONS(638),
    [anon_sym_break] = ACTIONS(638),
    [anon_sym_consume] = ACTIONS(638),
    [anon_sym_object] = ACTIONS(638),
    [sym_number] = ACTIONS(640),
    [sym_float] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(640),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(638),
    [anon_sym_SQUOTE] = ACTIONS(638),
    [anon_sym_true] = ACTIONS(638),
    [anon_sym_false] = ACTIONS(638),
    [sym_this] = ACTIONS(638),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [523] = {
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_EQ] = ACTIONS(1230),
    [anon_sym_AT] = ACTIONS(1228),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_is] = ACTIONS(1230),
    [anon_sym_let] = ACTIONS(1228),
    [anon_sym_var] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_DOT] = ACTIONS(1230),
    [anon_sym_LBRACE] = ACTIONS(1228),
    [anon_sym_SEMI] = ACTIONS(1228),
    [sym_error] = ACTIONS(1228),
    [sym_compile_intrinsic] = ACTIONS(1228),
    [anon_sym_compile_error] = ACTIONS(1228),
    [sym_location] = ACTIONS(1228),
    [anon_sym_DASH] = ACTIONS(1230),
    [anon_sym_not] = ACTIONS(1228),
    [anon_sym_DASH_TILDE] = ACTIONS(1228),
    [anon_sym_addressof] = ACTIONS(1228),
    [anon_sym_digestof] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(1230),
    [anon_sym_STAR] = ACTIONS(1230),
    [anon_sym_SLASH] = ACTIONS(1230),
    [anon_sym_PERCENT] = ACTIONS(1230),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1230),
    [anon_sym_LT_LT] = ACTIONS(1230),
    [anon_sym_GT_GT] = ACTIONS(1230),
    [anon_sym_and] = ACTIONS(1228),
    [anon_sym_or] = ACTIONS(1228),
    [anon_sym_xor] = ACTIONS(1228),
    [anon_sym_isnt] = ACTIONS(1228),
    [anon_sym_EQ_EQ] = ACTIONS(1230),
    [anon_sym_BANG_EQ] = ACTIONS(1230),
    [anon_sym_GT] = ACTIONS(1230),
    [anon_sym_GT_EQ] = ACTIONS(1230),
    [anon_sym_LT_EQ] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1230),
    [anon_sym_PLUS_TILDE] = ACTIONS(1228),
    [anon_sym_STAR_TILDE] = ACTIONS(1228),
    [anon_sym_SLASH_TILDE] = ACTIONS(1228),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1228),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1228),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1228),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1228),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1228),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1228),
    [anon_sym_GT_TILDE] = ACTIONS(1228),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1228),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1228),
    [anon_sym_LT_TILDE] = ACTIONS(1228),
    [anon_sym_PLUS_QMARK] = ACTIONS(1228),
    [anon_sym_DASH_QMARK] = ACTIONS(1228),
    [anon_sym_STAR_QMARK] = ACTIONS(1228),
    [anon_sym_SLASH_QMARK] = ACTIONS(1228),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1228),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1228),
    [anon_sym_as] = ACTIONS(1228),
    [anon_sym_LPAREN2] = ACTIONS(1228),
    [anon_sym_DOT_GT] = ACTIONS(1228),
    [anon_sym_TILDE] = ACTIONS(1228),
    [anon_sym_end] = ACTIONS(1228),
    [anon_sym_if] = ACTIONS(1230),
    [anon_sym_ifdef] = ACTIONS(1228),
    [anon_sym_elseif] = ACTIONS(1228),
    [anon_sym_iftype] = ACTIONS(1228),
    [anon_sym_else] = ACTIONS(1230),
    [anon_sym_for] = ACTIONS(1228),
    [anon_sym_while] = ACTIONS(1228),
    [anon_sym_try] = ACTIONS(1228),
    [anon_sym_with] = ACTIONS(1228),
    [anon_sym_repeat] = ACTIONS(1228),
    [anon_sym_recover] = ACTIONS(1228),
    [anon_sym_match] = ACTIONS(1228),
    [anon_sym_return] = ACTIONS(1228),
    [anon_sym_continue] = ACTIONS(1228),
    [anon_sym_break] = ACTIONS(1228),
    [anon_sym_consume] = ACTIONS(1228),
    [anon_sym_object] = ACTIONS(1228),
    [sym_number] = ACTIONS(1230),
    [sym_float] = ACTIONS(1228),
    [anon_sym_DQUOTE] = ACTIONS(1230),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1228),
    [anon_sym_SQUOTE] = ACTIONS(1228),
    [anon_sym_true] = ACTIONS(1228),
    [anon_sym_false] = ACTIONS(1228),
    [sym_this] = ACTIONS(1228),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [524] = {
    [sym_identifier] = ACTIONS(668),
    [anon_sym_EQ] = ACTIONS(668),
    [anon_sym_AT] = ACTIONS(666),
    [anon_sym_LBRACK] = ACTIONS(666),
    [anon_sym_is] = ACTIONS(668),
    [anon_sym_let] = ACTIONS(666),
    [anon_sym_var] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(668),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(666),
    [sym_error] = ACTIONS(666),
    [sym_compile_intrinsic] = ACTIONS(666),
    [anon_sym_compile_error] = ACTIONS(666),
    [sym_location] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(668),
    [anon_sym_not] = ACTIONS(666),
    [anon_sym_DASH_TILDE] = ACTIONS(666),
    [anon_sym_addressof] = ACTIONS(666),
    [anon_sym_digestof] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(668),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(668),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(668),
    [anon_sym_LT_LT] = ACTIONS(668),
    [anon_sym_GT_GT] = ACTIONS(668),
    [anon_sym_and] = ACTIONS(666),
    [anon_sym_or] = ACTIONS(666),
    [anon_sym_xor] = ACTIONS(666),
    [anon_sym_isnt] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(668),
    [anon_sym_BANG_EQ] = ACTIONS(668),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_GT_EQ] = ACTIONS(668),
    [anon_sym_LT_EQ] = ACTIONS(668),
    [anon_sym_LT] = ACTIONS(668),
    [anon_sym_PLUS_TILDE] = ACTIONS(666),
    [anon_sym_STAR_TILDE] = ACTIONS(666),
    [anon_sym_SLASH_TILDE] = ACTIONS(666),
    [anon_sym_PERCENT_TILDE] = ACTIONS(666),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(666),
    [anon_sym_LT_LT_TILDE] = ACTIONS(666),
    [anon_sym_GT_GT_TILDE] = ACTIONS(666),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(666),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(666),
    [anon_sym_GT_TILDE] = ACTIONS(666),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(666),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(666),
    [anon_sym_LT_TILDE] = ACTIONS(666),
    [anon_sym_PLUS_QMARK] = ACTIONS(666),
    [anon_sym_DASH_QMARK] = ACTIONS(666),
    [anon_sym_STAR_QMARK] = ACTIONS(666),
    [anon_sym_SLASH_QMARK] = ACTIONS(666),
    [anon_sym_PERCENT_QMARK] = ACTIONS(666),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(666),
    [anon_sym_LPAREN2] = ACTIONS(666),
    [anon_sym_DOT_GT] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_end] = ACTIONS(666),
    [anon_sym_if] = ACTIONS(668),
    [anon_sym_ifdef] = ACTIONS(666),
    [anon_sym_elseif] = ACTIONS(666),
    [anon_sym_iftype] = ACTIONS(666),
    [anon_sym_else] = ACTIONS(668),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_while] = ACTIONS(666),
    [anon_sym_try] = ACTIONS(666),
    [anon_sym_with] = ACTIONS(666),
    [anon_sym_repeat] = ACTIONS(666),
    [anon_sym_recover] = ACTIONS(666),
    [anon_sym_match] = ACTIONS(666),
    [anon_sym_return] = ACTIONS(666),
    [anon_sym_continue] = ACTIONS(666),
    [anon_sym_break] = ACTIONS(666),
    [anon_sym_consume] = ACTIONS(666),
    [anon_sym_object] = ACTIONS(666),
    [sym_number] = ACTIONS(668),
    [sym_float] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(666),
    [anon_sym_SQUOTE] = ACTIONS(666),
    [anon_sym_true] = ACTIONS(666),
    [anon_sym_false] = ACTIONS(666),
    [sym_this] = ACTIONS(666),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [525] = {
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_EQ] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(1288),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_is] = ACTIONS(1290),
    [anon_sym_let] = ACTIONS(1288),
    [anon_sym_var] = ACTIONS(1288),
    [anon_sym_LPAREN] = ACTIONS(1290),
    [anon_sym_DOT] = ACTIONS(1290),
    [anon_sym_LBRACE] = ACTIONS(1288),
    [anon_sym_SEMI] = ACTIONS(1288),
    [sym_error] = ACTIONS(1288),
    [sym_compile_intrinsic] = ACTIONS(1288),
    [anon_sym_compile_error] = ACTIONS(1288),
    [sym_location] = ACTIONS(1288),
    [anon_sym_DASH] = ACTIONS(1290),
    [anon_sym_not] = ACTIONS(1288),
    [anon_sym_DASH_TILDE] = ACTIONS(1288),
    [anon_sym_addressof] = ACTIONS(1288),
    [anon_sym_digestof] = ACTIONS(1288),
    [anon_sym_PLUS] = ACTIONS(1290),
    [anon_sym_STAR] = ACTIONS(1290),
    [anon_sym_SLASH] = ACTIONS(1290),
    [anon_sym_PERCENT] = ACTIONS(1290),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1290),
    [anon_sym_LT_LT] = ACTIONS(1290),
    [anon_sym_GT_GT] = ACTIONS(1290),
    [anon_sym_and] = ACTIONS(1288),
    [anon_sym_or] = ACTIONS(1288),
    [anon_sym_xor] = ACTIONS(1288),
    [anon_sym_isnt] = ACTIONS(1288),
    [anon_sym_EQ_EQ] = ACTIONS(1290),
    [anon_sym_BANG_EQ] = ACTIONS(1290),
    [anon_sym_GT] = ACTIONS(1290),
    [anon_sym_GT_EQ] = ACTIONS(1290),
    [anon_sym_LT_EQ] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(1290),
    [anon_sym_PLUS_TILDE] = ACTIONS(1288),
    [anon_sym_STAR_TILDE] = ACTIONS(1288),
    [anon_sym_SLASH_TILDE] = ACTIONS(1288),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1288),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1288),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1288),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1288),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1288),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1288),
    [anon_sym_GT_TILDE] = ACTIONS(1288),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1288),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1288),
    [anon_sym_LT_TILDE] = ACTIONS(1288),
    [anon_sym_PLUS_QMARK] = ACTIONS(1288),
    [anon_sym_DASH_QMARK] = ACTIONS(1288),
    [anon_sym_STAR_QMARK] = ACTIONS(1288),
    [anon_sym_SLASH_QMARK] = ACTIONS(1288),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1288),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1288),
    [anon_sym_as] = ACTIONS(1288),
    [anon_sym_LPAREN2] = ACTIONS(1288),
    [anon_sym_DOT_GT] = ACTIONS(1288),
    [anon_sym_TILDE] = ACTIONS(1288),
    [anon_sym_end] = ACTIONS(1288),
    [anon_sym_if] = ACTIONS(1290),
    [anon_sym_ifdef] = ACTIONS(1288),
    [anon_sym_elseif] = ACTIONS(1288),
    [anon_sym_iftype] = ACTIONS(1288),
    [anon_sym_else] = ACTIONS(1290),
    [anon_sym_for] = ACTIONS(1288),
    [anon_sym_while] = ACTIONS(1288),
    [anon_sym_try] = ACTIONS(1288),
    [anon_sym_with] = ACTIONS(1288),
    [anon_sym_repeat] = ACTIONS(1288),
    [anon_sym_recover] = ACTIONS(1288),
    [anon_sym_match] = ACTIONS(1288),
    [anon_sym_return] = ACTIONS(1288),
    [anon_sym_continue] = ACTIONS(1288),
    [anon_sym_break] = ACTIONS(1288),
    [anon_sym_consume] = ACTIONS(1288),
    [anon_sym_object] = ACTIONS(1288),
    [sym_number] = ACTIONS(1290),
    [sym_float] = ACTIONS(1288),
    [anon_sym_DQUOTE] = ACTIONS(1290),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1288),
    [anon_sym_SQUOTE] = ACTIONS(1288),
    [anon_sym_true] = ACTIONS(1288),
    [anon_sym_false] = ACTIONS(1288),
    [sym_this] = ACTIONS(1288),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [526] = {
    [sym_identifier] = ACTIONS(1112),
    [anon_sym_EQ] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1110),
    [anon_sym_LBRACK] = ACTIONS(1110),
    [anon_sym_is] = ACTIONS(1112),
    [anon_sym_let] = ACTIONS(1110),
    [anon_sym_var] = ACTIONS(1110),
    [anon_sym_LPAREN] = ACTIONS(1112),
    [anon_sym_DOT] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1110),
    [anon_sym_SEMI] = ACTIONS(1110),
    [sym_error] = ACTIONS(1110),
    [sym_compile_intrinsic] = ACTIONS(1110),
    [anon_sym_compile_error] = ACTIONS(1110),
    [sym_location] = ACTIONS(1110),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_not] = ACTIONS(1110),
    [anon_sym_DASH_TILDE] = ACTIONS(1110),
    [anon_sym_addressof] = ACTIONS(1110),
    [anon_sym_digestof] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1112),
    [anon_sym_PERCENT] = ACTIONS(1112),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1112),
    [anon_sym_LT_LT] = ACTIONS(1112),
    [anon_sym_GT_GT] = ACTIONS(1112),
    [anon_sym_and] = ACTIONS(1110),
    [anon_sym_or] = ACTIONS(1110),
    [anon_sym_xor] = ACTIONS(1110),
    [anon_sym_isnt] = ACTIONS(1110),
    [anon_sym_EQ_EQ] = ACTIONS(1112),
    [anon_sym_BANG_EQ] = ACTIONS(1112),
    [anon_sym_GT] = ACTIONS(1112),
    [anon_sym_GT_EQ] = ACTIONS(1112),
    [anon_sym_LT_EQ] = ACTIONS(1112),
    [anon_sym_LT] = ACTIONS(1112),
    [anon_sym_PLUS_TILDE] = ACTIONS(1110),
    [anon_sym_STAR_TILDE] = ACTIONS(1110),
    [anon_sym_SLASH_TILDE] = ACTIONS(1110),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1110),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1110),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1110),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1110),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1110),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1110),
    [anon_sym_GT_TILDE] = ACTIONS(1110),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1110),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1110),
    [anon_sym_LT_TILDE] = ACTIONS(1110),
    [anon_sym_PLUS_QMARK] = ACTIONS(1110),
    [anon_sym_DASH_QMARK] = ACTIONS(1110),
    [anon_sym_STAR_QMARK] = ACTIONS(1110),
    [anon_sym_SLASH_QMARK] = ACTIONS(1110),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1110),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1110),
    [anon_sym_as] = ACTIONS(1110),
    [anon_sym_LPAREN2] = ACTIONS(1110),
    [anon_sym_DOT_GT] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(1110),
    [anon_sym_end] = ACTIONS(1110),
    [anon_sym_if] = ACTIONS(1112),
    [anon_sym_ifdef] = ACTIONS(1110),
    [anon_sym_elseif] = ACTIONS(1110),
    [anon_sym_iftype] = ACTIONS(1110),
    [anon_sym_else] = ACTIONS(1112),
    [anon_sym_for] = ACTIONS(1110),
    [anon_sym_while] = ACTIONS(1110),
    [anon_sym_try] = ACTIONS(1110),
    [anon_sym_with] = ACTIONS(1110),
    [anon_sym_repeat] = ACTIONS(1110),
    [anon_sym_recover] = ACTIONS(1110),
    [anon_sym_match] = ACTIONS(1110),
    [anon_sym_return] = ACTIONS(1110),
    [anon_sym_continue] = ACTIONS(1110),
    [anon_sym_break] = ACTIONS(1110),
    [anon_sym_consume] = ACTIONS(1110),
    [anon_sym_object] = ACTIONS(1110),
    [sym_number] = ACTIONS(1112),
    [sym_float] = ACTIONS(1110),
    [anon_sym_DQUOTE] = ACTIONS(1112),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1110),
    [anon_sym_SQUOTE] = ACTIONS(1110),
    [anon_sym_true] = ACTIONS(1110),
    [anon_sym_false] = ACTIONS(1110),
    [sym_this] = ACTIONS(1110),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [527] = {
    [sym_identifier] = ACTIONS(1030),
    [anon_sym_EQ] = ACTIONS(1030),
    [anon_sym_AT] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(1028),
    [anon_sym_is] = ACTIONS(1030),
    [anon_sym_let] = ACTIONS(1028),
    [anon_sym_var] = ACTIONS(1028),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_DOT] = ACTIONS(1030),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_SEMI] = ACTIONS(1028),
    [sym_error] = ACTIONS(1028),
    [sym_compile_intrinsic] = ACTIONS(1028),
    [anon_sym_compile_error] = ACTIONS(1028),
    [sym_location] = ACTIONS(1028),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_not] = ACTIONS(1028),
    [anon_sym_DASH_TILDE] = ACTIONS(1028),
    [anon_sym_addressof] = ACTIONS(1028),
    [anon_sym_digestof] = ACTIONS(1028),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_STAR] = ACTIONS(1030),
    [anon_sym_SLASH] = ACTIONS(1030),
    [anon_sym_PERCENT] = ACTIONS(1030),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1030),
    [anon_sym_LT_LT] = ACTIONS(1030),
    [anon_sym_GT_GT] = ACTIONS(1030),
    [anon_sym_and] = ACTIONS(1028),
    [anon_sym_or] = ACTIONS(1028),
    [anon_sym_xor] = ACTIONS(1028),
    [anon_sym_isnt] = ACTIONS(1028),
    [anon_sym_EQ_EQ] = ACTIONS(1030),
    [anon_sym_BANG_EQ] = ACTIONS(1030),
    [anon_sym_GT] = ACTIONS(1030),
    [anon_sym_GT_EQ] = ACTIONS(1030),
    [anon_sym_LT_EQ] = ACTIONS(1030),
    [anon_sym_LT] = ACTIONS(1030),
    [anon_sym_PLUS_TILDE] = ACTIONS(1028),
    [anon_sym_STAR_TILDE] = ACTIONS(1028),
    [anon_sym_SLASH_TILDE] = ACTIONS(1028),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1028),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1028),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1028),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1028),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1028),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1028),
    [anon_sym_GT_TILDE] = ACTIONS(1028),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1028),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1028),
    [anon_sym_LT_TILDE] = ACTIONS(1028),
    [anon_sym_PLUS_QMARK] = ACTIONS(1028),
    [anon_sym_DASH_QMARK] = ACTIONS(1028),
    [anon_sym_STAR_QMARK] = ACTIONS(1028),
    [anon_sym_SLASH_QMARK] = ACTIONS(1028),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1028),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1028),
    [anon_sym_as] = ACTIONS(1028),
    [anon_sym_LPAREN2] = ACTIONS(1028),
    [anon_sym_DOT_GT] = ACTIONS(1028),
    [anon_sym_TILDE] = ACTIONS(1028),
    [anon_sym_end] = ACTIONS(1028),
    [anon_sym_if] = ACTIONS(1030),
    [anon_sym_ifdef] = ACTIONS(1028),
    [anon_sym_elseif] = ACTIONS(1028),
    [anon_sym_iftype] = ACTIONS(1028),
    [anon_sym_else] = ACTIONS(1030),
    [anon_sym_for] = ACTIONS(1028),
    [anon_sym_while] = ACTIONS(1028),
    [anon_sym_try] = ACTIONS(1028),
    [anon_sym_with] = ACTIONS(1028),
    [anon_sym_repeat] = ACTIONS(1028),
    [anon_sym_recover] = ACTIONS(1028),
    [anon_sym_match] = ACTIONS(1028),
    [anon_sym_return] = ACTIONS(1028),
    [anon_sym_continue] = ACTIONS(1028),
    [anon_sym_break] = ACTIONS(1028),
    [anon_sym_consume] = ACTIONS(1028),
    [anon_sym_object] = ACTIONS(1028),
    [sym_number] = ACTIONS(1030),
    [sym_float] = ACTIONS(1028),
    [anon_sym_DQUOTE] = ACTIONS(1030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1028),
    [anon_sym_SQUOTE] = ACTIONS(1028),
    [anon_sym_true] = ACTIONS(1028),
    [anon_sym_false] = ACTIONS(1028),
    [sym_this] = ACTIONS(1028),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [528] = {
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_EQ] = ACTIONS(1018),
    [anon_sym_AT] = ACTIONS(1016),
    [anon_sym_LBRACK] = ACTIONS(1016),
    [anon_sym_is] = ACTIONS(1018),
    [anon_sym_let] = ACTIONS(1016),
    [anon_sym_var] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_DOT] = ACTIONS(1018),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_SEMI] = ACTIONS(1016),
    [sym_error] = ACTIONS(1016),
    [sym_compile_intrinsic] = ACTIONS(1016),
    [anon_sym_compile_error] = ACTIONS(1016),
    [sym_location] = ACTIONS(1016),
    [anon_sym_DASH] = ACTIONS(1018),
    [anon_sym_not] = ACTIONS(1016),
    [anon_sym_DASH_TILDE] = ACTIONS(1016),
    [anon_sym_addressof] = ACTIONS(1016),
    [anon_sym_digestof] = ACTIONS(1016),
    [anon_sym_PLUS] = ACTIONS(1018),
    [anon_sym_STAR] = ACTIONS(1018),
    [anon_sym_SLASH] = ACTIONS(1018),
    [anon_sym_PERCENT] = ACTIONS(1018),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1018),
    [anon_sym_LT_LT] = ACTIONS(1018),
    [anon_sym_GT_GT] = ACTIONS(1018),
    [anon_sym_and] = ACTIONS(1016),
    [anon_sym_or] = ACTIONS(1016),
    [anon_sym_xor] = ACTIONS(1016),
    [anon_sym_isnt] = ACTIONS(1016),
    [anon_sym_EQ_EQ] = ACTIONS(1018),
    [anon_sym_BANG_EQ] = ACTIONS(1018),
    [anon_sym_GT] = ACTIONS(1018),
    [anon_sym_GT_EQ] = ACTIONS(1018),
    [anon_sym_LT_EQ] = ACTIONS(1018),
    [anon_sym_LT] = ACTIONS(1018),
    [anon_sym_PLUS_TILDE] = ACTIONS(1016),
    [anon_sym_STAR_TILDE] = ACTIONS(1016),
    [anon_sym_SLASH_TILDE] = ACTIONS(1016),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1016),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1016),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1016),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1016),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1016),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1016),
    [anon_sym_GT_TILDE] = ACTIONS(1016),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1016),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1016),
    [anon_sym_LT_TILDE] = ACTIONS(1016),
    [anon_sym_PLUS_QMARK] = ACTIONS(1016),
    [anon_sym_DASH_QMARK] = ACTIONS(1016),
    [anon_sym_STAR_QMARK] = ACTIONS(1016),
    [anon_sym_SLASH_QMARK] = ACTIONS(1016),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1016),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1016),
    [anon_sym_as] = ACTIONS(1016),
    [anon_sym_LPAREN2] = ACTIONS(1016),
    [anon_sym_DOT_GT] = ACTIONS(1016),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_end] = ACTIONS(1016),
    [anon_sym_if] = ACTIONS(1018),
    [anon_sym_ifdef] = ACTIONS(1016),
    [anon_sym_elseif] = ACTIONS(1016),
    [anon_sym_iftype] = ACTIONS(1016),
    [anon_sym_else] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(1016),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_try] = ACTIONS(1016),
    [anon_sym_with] = ACTIONS(1016),
    [anon_sym_repeat] = ACTIONS(1016),
    [anon_sym_recover] = ACTIONS(1016),
    [anon_sym_match] = ACTIONS(1016),
    [anon_sym_return] = ACTIONS(1016),
    [anon_sym_continue] = ACTIONS(1016),
    [anon_sym_break] = ACTIONS(1016),
    [anon_sym_consume] = ACTIONS(1016),
    [anon_sym_object] = ACTIONS(1016),
    [sym_number] = ACTIONS(1018),
    [sym_float] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(1018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1016),
    [anon_sym_SQUOTE] = ACTIONS(1016),
    [anon_sym_true] = ACTIONS(1016),
    [anon_sym_false] = ACTIONS(1016),
    [sym_this] = ACTIONS(1016),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [529] = {
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_EQ] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_is] = ACTIONS(1022),
    [anon_sym_let] = ACTIONS(1020),
    [anon_sym_var] = ACTIONS(1020),
    [anon_sym_LPAREN] = ACTIONS(1022),
    [anon_sym_DOT] = ACTIONS(1022),
    [anon_sym_LBRACE] = ACTIONS(1020),
    [anon_sym_SEMI] = ACTIONS(1020),
    [sym_error] = ACTIONS(1020),
    [sym_compile_intrinsic] = ACTIONS(1020),
    [anon_sym_compile_error] = ACTIONS(1020),
    [sym_location] = ACTIONS(1020),
    [anon_sym_DASH] = ACTIONS(1022),
    [anon_sym_not] = ACTIONS(1020),
    [anon_sym_DASH_TILDE] = ACTIONS(1020),
    [anon_sym_addressof] = ACTIONS(1020),
    [anon_sym_digestof] = ACTIONS(1020),
    [anon_sym_PLUS] = ACTIONS(1022),
    [anon_sym_STAR] = ACTIONS(1022),
    [anon_sym_SLASH] = ACTIONS(1022),
    [anon_sym_PERCENT] = ACTIONS(1022),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1022),
    [anon_sym_LT_LT] = ACTIONS(1022),
    [anon_sym_GT_GT] = ACTIONS(1022),
    [anon_sym_and] = ACTIONS(1020),
    [anon_sym_or] = ACTIONS(1020),
    [anon_sym_xor] = ACTIONS(1020),
    [anon_sym_isnt] = ACTIONS(1020),
    [anon_sym_EQ_EQ] = ACTIONS(1022),
    [anon_sym_BANG_EQ] = ACTIONS(1022),
    [anon_sym_GT] = ACTIONS(1022),
    [anon_sym_GT_EQ] = ACTIONS(1022),
    [anon_sym_LT_EQ] = ACTIONS(1022),
    [anon_sym_LT] = ACTIONS(1022),
    [anon_sym_PLUS_TILDE] = ACTIONS(1020),
    [anon_sym_STAR_TILDE] = ACTIONS(1020),
    [anon_sym_SLASH_TILDE] = ACTIONS(1020),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1020),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1020),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1020),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1020),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1020),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1020),
    [anon_sym_GT_TILDE] = ACTIONS(1020),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1020),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1020),
    [anon_sym_LT_TILDE] = ACTIONS(1020),
    [anon_sym_PLUS_QMARK] = ACTIONS(1020),
    [anon_sym_DASH_QMARK] = ACTIONS(1020),
    [anon_sym_STAR_QMARK] = ACTIONS(1020),
    [anon_sym_SLASH_QMARK] = ACTIONS(1020),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1020),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1020),
    [anon_sym_as] = ACTIONS(1020),
    [anon_sym_LPAREN2] = ACTIONS(1020),
    [anon_sym_DOT_GT] = ACTIONS(1020),
    [anon_sym_TILDE] = ACTIONS(1020),
    [anon_sym_end] = ACTIONS(1020),
    [anon_sym_if] = ACTIONS(1022),
    [anon_sym_ifdef] = ACTIONS(1020),
    [anon_sym_elseif] = ACTIONS(1020),
    [anon_sym_iftype] = ACTIONS(1020),
    [anon_sym_else] = ACTIONS(1022),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_while] = ACTIONS(1020),
    [anon_sym_try] = ACTIONS(1020),
    [anon_sym_with] = ACTIONS(1020),
    [anon_sym_repeat] = ACTIONS(1020),
    [anon_sym_recover] = ACTIONS(1020),
    [anon_sym_match] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(1020),
    [anon_sym_continue] = ACTIONS(1020),
    [anon_sym_break] = ACTIONS(1020),
    [anon_sym_consume] = ACTIONS(1020),
    [anon_sym_object] = ACTIONS(1020),
    [sym_number] = ACTIONS(1022),
    [sym_float] = ACTIONS(1020),
    [anon_sym_DQUOTE] = ACTIONS(1022),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1020),
    [anon_sym_SQUOTE] = ACTIONS(1020),
    [anon_sym_true] = ACTIONS(1020),
    [anon_sym_false] = ACTIONS(1020),
    [sym_this] = ACTIONS(1020),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [530] = {
    [sym_identifier] = ACTIONS(1258),
    [anon_sym_EQ] = ACTIONS(1258),
    [anon_sym_AT] = ACTIONS(1256),
    [anon_sym_LBRACK] = ACTIONS(1256),
    [anon_sym_is] = ACTIONS(1258),
    [anon_sym_let] = ACTIONS(1256),
    [anon_sym_var] = ACTIONS(1256),
    [anon_sym_LPAREN] = ACTIONS(1258),
    [anon_sym_DOT] = ACTIONS(1258),
    [anon_sym_LBRACE] = ACTIONS(1256),
    [anon_sym_SEMI] = ACTIONS(1256),
    [sym_error] = ACTIONS(1256),
    [sym_compile_intrinsic] = ACTIONS(1256),
    [anon_sym_compile_error] = ACTIONS(1256),
    [sym_location] = ACTIONS(1256),
    [anon_sym_DASH] = ACTIONS(1258),
    [anon_sym_not] = ACTIONS(1256),
    [anon_sym_DASH_TILDE] = ACTIONS(1256),
    [anon_sym_addressof] = ACTIONS(1256),
    [anon_sym_digestof] = ACTIONS(1256),
    [anon_sym_PLUS] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_SLASH] = ACTIONS(1258),
    [anon_sym_PERCENT] = ACTIONS(1258),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1258),
    [anon_sym_LT_LT] = ACTIONS(1258),
    [anon_sym_GT_GT] = ACTIONS(1258),
    [anon_sym_and] = ACTIONS(1256),
    [anon_sym_or] = ACTIONS(1256),
    [anon_sym_xor] = ACTIONS(1256),
    [anon_sym_isnt] = ACTIONS(1256),
    [anon_sym_EQ_EQ] = ACTIONS(1258),
    [anon_sym_BANG_EQ] = ACTIONS(1258),
    [anon_sym_GT] = ACTIONS(1258),
    [anon_sym_GT_EQ] = ACTIONS(1258),
    [anon_sym_LT_EQ] = ACTIONS(1258),
    [anon_sym_LT] = ACTIONS(1258),
    [anon_sym_PLUS_TILDE] = ACTIONS(1256),
    [anon_sym_STAR_TILDE] = ACTIONS(1256),
    [anon_sym_SLASH_TILDE] = ACTIONS(1256),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1256),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1256),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1256),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1256),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1256),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1256),
    [anon_sym_GT_TILDE] = ACTIONS(1256),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1256),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1256),
    [anon_sym_LT_TILDE] = ACTIONS(1256),
    [anon_sym_PLUS_QMARK] = ACTIONS(1256),
    [anon_sym_DASH_QMARK] = ACTIONS(1256),
    [anon_sym_STAR_QMARK] = ACTIONS(1256),
    [anon_sym_SLASH_QMARK] = ACTIONS(1256),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1256),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1256),
    [anon_sym_as] = ACTIONS(1256),
    [anon_sym_LPAREN2] = ACTIONS(1256),
    [anon_sym_DOT_GT] = ACTIONS(1256),
    [anon_sym_TILDE] = ACTIONS(1256),
    [anon_sym_end] = ACTIONS(1256),
    [anon_sym_if] = ACTIONS(1258),
    [anon_sym_ifdef] = ACTIONS(1256),
    [anon_sym_elseif] = ACTIONS(1256),
    [anon_sym_iftype] = ACTIONS(1256),
    [anon_sym_else] = ACTIONS(1258),
    [anon_sym_for] = ACTIONS(1256),
    [anon_sym_while] = ACTIONS(1256),
    [anon_sym_try] = ACTIONS(1256),
    [anon_sym_with] = ACTIONS(1256),
    [anon_sym_repeat] = ACTIONS(1256),
    [anon_sym_recover] = ACTIONS(1256),
    [anon_sym_match] = ACTIONS(1256),
    [anon_sym_return] = ACTIONS(1256),
    [anon_sym_continue] = ACTIONS(1256),
    [anon_sym_break] = ACTIONS(1256),
    [anon_sym_consume] = ACTIONS(1256),
    [anon_sym_object] = ACTIONS(1256),
    [sym_number] = ACTIONS(1258),
    [sym_float] = ACTIONS(1256),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1256),
    [anon_sym_SQUOTE] = ACTIONS(1256),
    [anon_sym_true] = ACTIONS(1256),
    [anon_sym_false] = ACTIONS(1256),
    [sym_this] = ACTIONS(1256),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [531] = {
    [sym_identifier] = ACTIONS(1026),
    [anon_sym_EQ] = ACTIONS(1026),
    [anon_sym_AT] = ACTIONS(1024),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_is] = ACTIONS(1026),
    [anon_sym_let] = ACTIONS(1024),
    [anon_sym_var] = ACTIONS(1024),
    [anon_sym_LPAREN] = ACTIONS(1026),
    [anon_sym_DOT] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1024),
    [anon_sym_SEMI] = ACTIONS(1024),
    [sym_error] = ACTIONS(1024),
    [sym_compile_intrinsic] = ACTIONS(1024),
    [anon_sym_compile_error] = ACTIONS(1024),
    [sym_location] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1026),
    [anon_sym_not] = ACTIONS(1024),
    [anon_sym_DASH_TILDE] = ACTIONS(1024),
    [anon_sym_addressof] = ACTIONS(1024),
    [anon_sym_digestof] = ACTIONS(1024),
    [anon_sym_PLUS] = ACTIONS(1026),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_SLASH] = ACTIONS(1026),
    [anon_sym_PERCENT] = ACTIONS(1026),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1026),
    [anon_sym_LT_LT] = ACTIONS(1026),
    [anon_sym_GT_GT] = ACTIONS(1026),
    [anon_sym_and] = ACTIONS(1024),
    [anon_sym_or] = ACTIONS(1024),
    [anon_sym_xor] = ACTIONS(1024),
    [anon_sym_isnt] = ACTIONS(1024),
    [anon_sym_EQ_EQ] = ACTIONS(1026),
    [anon_sym_BANG_EQ] = ACTIONS(1026),
    [anon_sym_GT] = ACTIONS(1026),
    [anon_sym_GT_EQ] = ACTIONS(1026),
    [anon_sym_LT_EQ] = ACTIONS(1026),
    [anon_sym_LT] = ACTIONS(1026),
    [anon_sym_PLUS_TILDE] = ACTIONS(1024),
    [anon_sym_STAR_TILDE] = ACTIONS(1024),
    [anon_sym_SLASH_TILDE] = ACTIONS(1024),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1024),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1024),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1024),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1024),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1024),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1024),
    [anon_sym_GT_TILDE] = ACTIONS(1024),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1024),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1024),
    [anon_sym_LT_TILDE] = ACTIONS(1024),
    [anon_sym_PLUS_QMARK] = ACTIONS(1024),
    [anon_sym_DASH_QMARK] = ACTIONS(1024),
    [anon_sym_STAR_QMARK] = ACTIONS(1024),
    [anon_sym_SLASH_QMARK] = ACTIONS(1024),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1024),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1024),
    [anon_sym_as] = ACTIONS(1024),
    [anon_sym_LPAREN2] = ACTIONS(1024),
    [anon_sym_DOT_GT] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1024),
    [anon_sym_end] = ACTIONS(1024),
    [anon_sym_if] = ACTIONS(1026),
    [anon_sym_ifdef] = ACTIONS(1024),
    [anon_sym_elseif] = ACTIONS(1024),
    [anon_sym_iftype] = ACTIONS(1024),
    [anon_sym_else] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1024),
    [anon_sym_while] = ACTIONS(1024),
    [anon_sym_try] = ACTIONS(1024),
    [anon_sym_with] = ACTIONS(1024),
    [anon_sym_repeat] = ACTIONS(1024),
    [anon_sym_recover] = ACTIONS(1024),
    [anon_sym_match] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1024),
    [anon_sym_continue] = ACTIONS(1024),
    [anon_sym_break] = ACTIONS(1024),
    [anon_sym_consume] = ACTIONS(1024),
    [anon_sym_object] = ACTIONS(1024),
    [sym_number] = ACTIONS(1026),
    [sym_float] = ACTIONS(1024),
    [anon_sym_DQUOTE] = ACTIONS(1026),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1024),
    [anon_sym_SQUOTE] = ACTIONS(1024),
    [anon_sym_true] = ACTIONS(1024),
    [anon_sym_false] = ACTIONS(1024),
    [sym_this] = ACTIONS(1024),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [532] = {
    [sym_identifier] = ACTIONS(1116),
    [anon_sym_EQ] = ACTIONS(1116),
    [anon_sym_AT] = ACTIONS(1114),
    [anon_sym_LBRACK] = ACTIONS(1114),
    [anon_sym_is] = ACTIONS(1116),
    [anon_sym_let] = ACTIONS(1114),
    [anon_sym_var] = ACTIONS(1114),
    [anon_sym_LPAREN] = ACTIONS(1116),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1114),
    [anon_sym_SEMI] = ACTIONS(1114),
    [sym_error] = ACTIONS(1114),
    [sym_compile_intrinsic] = ACTIONS(1114),
    [anon_sym_compile_error] = ACTIONS(1114),
    [sym_location] = ACTIONS(1114),
    [anon_sym_DASH] = ACTIONS(1116),
    [anon_sym_not] = ACTIONS(1114),
    [anon_sym_DASH_TILDE] = ACTIONS(1114),
    [anon_sym_addressof] = ACTIONS(1114),
    [anon_sym_digestof] = ACTIONS(1114),
    [anon_sym_PLUS] = ACTIONS(1116),
    [anon_sym_STAR] = ACTIONS(1116),
    [anon_sym_SLASH] = ACTIONS(1116),
    [anon_sym_PERCENT] = ACTIONS(1116),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1116),
    [anon_sym_LT_LT] = ACTIONS(1116),
    [anon_sym_GT_GT] = ACTIONS(1116),
    [anon_sym_and] = ACTIONS(1114),
    [anon_sym_or] = ACTIONS(1114),
    [anon_sym_xor] = ACTIONS(1114),
    [anon_sym_isnt] = ACTIONS(1114),
    [anon_sym_EQ_EQ] = ACTIONS(1116),
    [anon_sym_BANG_EQ] = ACTIONS(1116),
    [anon_sym_GT] = ACTIONS(1116),
    [anon_sym_GT_EQ] = ACTIONS(1116),
    [anon_sym_LT_EQ] = ACTIONS(1116),
    [anon_sym_LT] = ACTIONS(1116),
    [anon_sym_PLUS_TILDE] = ACTIONS(1114),
    [anon_sym_STAR_TILDE] = ACTIONS(1114),
    [anon_sym_SLASH_TILDE] = ACTIONS(1114),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1114),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1114),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1114),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1114),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1114),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1114),
    [anon_sym_GT_TILDE] = ACTIONS(1114),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1114),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1114),
    [anon_sym_LT_TILDE] = ACTIONS(1114),
    [anon_sym_PLUS_QMARK] = ACTIONS(1114),
    [anon_sym_DASH_QMARK] = ACTIONS(1114),
    [anon_sym_STAR_QMARK] = ACTIONS(1114),
    [anon_sym_SLASH_QMARK] = ACTIONS(1114),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1114),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1114),
    [anon_sym_as] = ACTIONS(1114),
    [anon_sym_LPAREN2] = ACTIONS(1114),
    [anon_sym_DOT_GT] = ACTIONS(1114),
    [anon_sym_TILDE] = ACTIONS(1114),
    [anon_sym_end] = ACTIONS(1114),
    [anon_sym_if] = ACTIONS(1116),
    [anon_sym_ifdef] = ACTIONS(1114),
    [anon_sym_elseif] = ACTIONS(1114),
    [anon_sym_iftype] = ACTIONS(1114),
    [anon_sym_else] = ACTIONS(1116),
    [anon_sym_for] = ACTIONS(1114),
    [anon_sym_while] = ACTIONS(1114),
    [anon_sym_try] = ACTIONS(1114),
    [anon_sym_with] = ACTIONS(1114),
    [anon_sym_repeat] = ACTIONS(1114),
    [anon_sym_recover] = ACTIONS(1114),
    [anon_sym_match] = ACTIONS(1114),
    [anon_sym_return] = ACTIONS(1114),
    [anon_sym_continue] = ACTIONS(1114),
    [anon_sym_break] = ACTIONS(1114),
    [anon_sym_consume] = ACTIONS(1114),
    [anon_sym_object] = ACTIONS(1114),
    [sym_number] = ACTIONS(1116),
    [sym_float] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1114),
    [anon_sym_SQUOTE] = ACTIONS(1114),
    [anon_sym_true] = ACTIONS(1114),
    [anon_sym_false] = ACTIONS(1114),
    [sym_this] = ACTIONS(1114),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [533] = {
    [sym_identifier] = ACTIONS(1042),
    [anon_sym_EQ] = ACTIONS(1042),
    [anon_sym_AT] = ACTIONS(1040),
    [anon_sym_LBRACK] = ACTIONS(1040),
    [anon_sym_is] = ACTIONS(1042),
    [anon_sym_let] = ACTIONS(1040),
    [anon_sym_var] = ACTIONS(1040),
    [anon_sym_LPAREN] = ACTIONS(1042),
    [anon_sym_DOT] = ACTIONS(1042),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_SEMI] = ACTIONS(1040),
    [sym_error] = ACTIONS(1040),
    [sym_compile_intrinsic] = ACTIONS(1040),
    [anon_sym_compile_error] = ACTIONS(1040),
    [sym_location] = ACTIONS(1040),
    [anon_sym_DASH] = ACTIONS(1042),
    [anon_sym_not] = ACTIONS(1040),
    [anon_sym_DASH_TILDE] = ACTIONS(1040),
    [anon_sym_addressof] = ACTIONS(1040),
    [anon_sym_digestof] = ACTIONS(1040),
    [anon_sym_PLUS] = ACTIONS(1042),
    [anon_sym_STAR] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(1042),
    [anon_sym_PERCENT] = ACTIONS(1042),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1042),
    [anon_sym_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_GT] = ACTIONS(1042),
    [anon_sym_and] = ACTIONS(1040),
    [anon_sym_or] = ACTIONS(1040),
    [anon_sym_xor] = ACTIONS(1040),
    [anon_sym_isnt] = ACTIONS(1040),
    [anon_sym_EQ_EQ] = ACTIONS(1042),
    [anon_sym_BANG_EQ] = ACTIONS(1042),
    [anon_sym_GT] = ACTIONS(1042),
    [anon_sym_GT_EQ] = ACTIONS(1042),
    [anon_sym_LT_EQ] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_PLUS_TILDE] = ACTIONS(1040),
    [anon_sym_STAR_TILDE] = ACTIONS(1040),
    [anon_sym_SLASH_TILDE] = ACTIONS(1040),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1040),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1040),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1040),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1040),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1040),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1040),
    [anon_sym_GT_TILDE] = ACTIONS(1040),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1040),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1040),
    [anon_sym_LT_TILDE] = ACTIONS(1040),
    [anon_sym_PLUS_QMARK] = ACTIONS(1040),
    [anon_sym_DASH_QMARK] = ACTIONS(1040),
    [anon_sym_STAR_QMARK] = ACTIONS(1040),
    [anon_sym_SLASH_QMARK] = ACTIONS(1040),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1040),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1040),
    [anon_sym_as] = ACTIONS(1040),
    [anon_sym_LPAREN2] = ACTIONS(1040),
    [anon_sym_DOT_GT] = ACTIONS(1040),
    [anon_sym_TILDE] = ACTIONS(1040),
    [anon_sym_end] = ACTIONS(1040),
    [anon_sym_if] = ACTIONS(1042),
    [anon_sym_ifdef] = ACTIONS(1040),
    [anon_sym_elseif] = ACTIONS(1040),
    [anon_sym_iftype] = ACTIONS(1040),
    [anon_sym_else] = ACTIONS(1042),
    [anon_sym_for] = ACTIONS(1040),
    [anon_sym_while] = ACTIONS(1040),
    [anon_sym_try] = ACTIONS(1040),
    [anon_sym_with] = ACTIONS(1040),
    [anon_sym_repeat] = ACTIONS(1040),
    [anon_sym_recover] = ACTIONS(1040),
    [anon_sym_match] = ACTIONS(1040),
    [anon_sym_return] = ACTIONS(1040),
    [anon_sym_continue] = ACTIONS(1040),
    [anon_sym_break] = ACTIONS(1040),
    [anon_sym_consume] = ACTIONS(1040),
    [anon_sym_object] = ACTIONS(1040),
    [sym_number] = ACTIONS(1042),
    [sym_float] = ACTIONS(1040),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym_true] = ACTIONS(1040),
    [anon_sym_false] = ACTIONS(1040),
    [sym_this] = ACTIONS(1040),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [534] = {
    [sym_identifier] = ACTIONS(1186),
    [anon_sym_EQ] = ACTIONS(1186),
    [anon_sym_AT] = ACTIONS(1184),
    [anon_sym_LBRACK] = ACTIONS(1184),
    [anon_sym_is] = ACTIONS(1186),
    [anon_sym_let] = ACTIONS(1184),
    [anon_sym_var] = ACTIONS(1184),
    [anon_sym_LPAREN] = ACTIONS(1186),
    [anon_sym_DOT] = ACTIONS(1186),
    [anon_sym_LBRACE] = ACTIONS(1184),
    [anon_sym_SEMI] = ACTIONS(1184),
    [sym_error] = ACTIONS(1184),
    [sym_compile_intrinsic] = ACTIONS(1184),
    [anon_sym_compile_error] = ACTIONS(1184),
    [sym_location] = ACTIONS(1184),
    [anon_sym_DASH] = ACTIONS(1186),
    [anon_sym_not] = ACTIONS(1184),
    [anon_sym_DASH_TILDE] = ACTIONS(1184),
    [anon_sym_addressof] = ACTIONS(1184),
    [anon_sym_digestof] = ACTIONS(1184),
    [anon_sym_PLUS] = ACTIONS(1186),
    [anon_sym_STAR] = ACTIONS(1186),
    [anon_sym_SLASH] = ACTIONS(1186),
    [anon_sym_PERCENT] = ACTIONS(1186),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1186),
    [anon_sym_LT_LT] = ACTIONS(1186),
    [anon_sym_GT_GT] = ACTIONS(1186),
    [anon_sym_and] = ACTIONS(1184),
    [anon_sym_or] = ACTIONS(1184),
    [anon_sym_xor] = ACTIONS(1184),
    [anon_sym_isnt] = ACTIONS(1184),
    [anon_sym_EQ_EQ] = ACTIONS(1186),
    [anon_sym_BANG_EQ] = ACTIONS(1186),
    [anon_sym_GT] = ACTIONS(1186),
    [anon_sym_GT_EQ] = ACTIONS(1186),
    [anon_sym_LT_EQ] = ACTIONS(1186),
    [anon_sym_LT] = ACTIONS(1186),
    [anon_sym_PLUS_TILDE] = ACTIONS(1184),
    [anon_sym_STAR_TILDE] = ACTIONS(1184),
    [anon_sym_SLASH_TILDE] = ACTIONS(1184),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1184),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1184),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1184),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1184),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1184),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1184),
    [anon_sym_GT_TILDE] = ACTIONS(1184),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1184),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1184),
    [anon_sym_LT_TILDE] = ACTIONS(1184),
    [anon_sym_PLUS_QMARK] = ACTIONS(1184),
    [anon_sym_DASH_QMARK] = ACTIONS(1184),
    [anon_sym_STAR_QMARK] = ACTIONS(1184),
    [anon_sym_SLASH_QMARK] = ACTIONS(1184),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1184),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1184),
    [anon_sym_as] = ACTIONS(1184),
    [anon_sym_LPAREN2] = ACTIONS(1184),
    [anon_sym_DOT_GT] = ACTIONS(1184),
    [anon_sym_TILDE] = ACTIONS(1184),
    [anon_sym_end] = ACTIONS(1184),
    [anon_sym_if] = ACTIONS(1186),
    [anon_sym_ifdef] = ACTIONS(1184),
    [anon_sym_elseif] = ACTIONS(1184),
    [anon_sym_iftype] = ACTIONS(1184),
    [anon_sym_else] = ACTIONS(1186),
    [anon_sym_for] = ACTIONS(1184),
    [anon_sym_while] = ACTIONS(1184),
    [anon_sym_try] = ACTIONS(1184),
    [anon_sym_with] = ACTIONS(1184),
    [anon_sym_repeat] = ACTIONS(1184),
    [anon_sym_recover] = ACTIONS(1184),
    [anon_sym_match] = ACTIONS(1184),
    [anon_sym_return] = ACTIONS(1184),
    [anon_sym_continue] = ACTIONS(1184),
    [anon_sym_break] = ACTIONS(1184),
    [anon_sym_consume] = ACTIONS(1184),
    [anon_sym_object] = ACTIONS(1184),
    [sym_number] = ACTIONS(1186),
    [sym_float] = ACTIONS(1184),
    [anon_sym_DQUOTE] = ACTIONS(1186),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1184),
    [anon_sym_SQUOTE] = ACTIONS(1184),
    [anon_sym_true] = ACTIONS(1184),
    [anon_sym_false] = ACTIONS(1184),
    [sym_this] = ACTIONS(1184),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [535] = {
    [sym_identifier] = ACTIONS(1068),
    [anon_sym_EQ] = ACTIONS(1068),
    [anon_sym_AT] = ACTIONS(1066),
    [anon_sym_LBRACK] = ACTIONS(1066),
    [anon_sym_is] = ACTIONS(1068),
    [anon_sym_let] = ACTIONS(1066),
    [anon_sym_var] = ACTIONS(1066),
    [anon_sym_LPAREN] = ACTIONS(1068),
    [anon_sym_DOT] = ACTIONS(1068),
    [anon_sym_LBRACE] = ACTIONS(1066),
    [anon_sym_SEMI] = ACTIONS(1066),
    [sym_error] = ACTIONS(1066),
    [sym_compile_intrinsic] = ACTIONS(1066),
    [anon_sym_compile_error] = ACTIONS(1066),
    [sym_location] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1068),
    [anon_sym_not] = ACTIONS(1066),
    [anon_sym_DASH_TILDE] = ACTIONS(1066),
    [anon_sym_addressof] = ACTIONS(1066),
    [anon_sym_digestof] = ACTIONS(1066),
    [anon_sym_PLUS] = ACTIONS(1068),
    [anon_sym_STAR] = ACTIONS(1068),
    [anon_sym_SLASH] = ACTIONS(1068),
    [anon_sym_PERCENT] = ACTIONS(1068),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1068),
    [anon_sym_LT_LT] = ACTIONS(1068),
    [anon_sym_GT_GT] = ACTIONS(1068),
    [anon_sym_and] = ACTIONS(1066),
    [anon_sym_or] = ACTIONS(1066),
    [anon_sym_xor] = ACTIONS(1066),
    [anon_sym_isnt] = ACTIONS(1066),
    [anon_sym_EQ_EQ] = ACTIONS(1068),
    [anon_sym_BANG_EQ] = ACTIONS(1068),
    [anon_sym_GT] = ACTIONS(1068),
    [anon_sym_GT_EQ] = ACTIONS(1068),
    [anon_sym_LT_EQ] = ACTIONS(1068),
    [anon_sym_LT] = ACTIONS(1068),
    [anon_sym_PLUS_TILDE] = ACTIONS(1066),
    [anon_sym_STAR_TILDE] = ACTIONS(1066),
    [anon_sym_SLASH_TILDE] = ACTIONS(1066),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1066),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1066),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1066),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1066),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1066),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1066),
    [anon_sym_GT_TILDE] = ACTIONS(1066),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1066),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1066),
    [anon_sym_LT_TILDE] = ACTIONS(1066),
    [anon_sym_PLUS_QMARK] = ACTIONS(1066),
    [anon_sym_DASH_QMARK] = ACTIONS(1066),
    [anon_sym_STAR_QMARK] = ACTIONS(1066),
    [anon_sym_SLASH_QMARK] = ACTIONS(1066),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1066),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1066),
    [anon_sym_as] = ACTIONS(1066),
    [anon_sym_LPAREN2] = ACTIONS(1066),
    [anon_sym_DOT_GT] = ACTIONS(1066),
    [anon_sym_TILDE] = ACTIONS(1066),
    [anon_sym_end] = ACTIONS(1066),
    [anon_sym_if] = ACTIONS(1068),
    [anon_sym_ifdef] = ACTIONS(1066),
    [anon_sym_elseif] = ACTIONS(1066),
    [anon_sym_iftype] = ACTIONS(1066),
    [anon_sym_else] = ACTIONS(1068),
    [anon_sym_for] = ACTIONS(1066),
    [anon_sym_while] = ACTIONS(1066),
    [anon_sym_try] = ACTIONS(1066),
    [anon_sym_with] = ACTIONS(1066),
    [anon_sym_repeat] = ACTIONS(1066),
    [anon_sym_recover] = ACTIONS(1066),
    [anon_sym_match] = ACTIONS(1066),
    [anon_sym_return] = ACTIONS(1066),
    [anon_sym_continue] = ACTIONS(1066),
    [anon_sym_break] = ACTIONS(1066),
    [anon_sym_consume] = ACTIONS(1066),
    [anon_sym_object] = ACTIONS(1066),
    [sym_number] = ACTIONS(1068),
    [sym_float] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(1068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(1066),
    [anon_sym_true] = ACTIONS(1066),
    [anon_sym_false] = ACTIONS(1066),
    [sym_this] = ACTIONS(1066),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [536] = {
    [sym_identifier] = ACTIONS(1254),
    [anon_sym_EQ] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_LBRACK] = ACTIONS(1252),
    [anon_sym_is] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(1252),
    [anon_sym_var] = ACTIONS(1252),
    [anon_sym_LPAREN] = ACTIONS(1254),
    [anon_sym_DOT] = ACTIONS(1254),
    [anon_sym_LBRACE] = ACTIONS(1252),
    [anon_sym_SEMI] = ACTIONS(1252),
    [sym_error] = ACTIONS(1252),
    [sym_compile_intrinsic] = ACTIONS(1252),
    [anon_sym_compile_error] = ACTIONS(1252),
    [sym_location] = ACTIONS(1252),
    [anon_sym_DASH] = ACTIONS(1254),
    [anon_sym_not] = ACTIONS(1252),
    [anon_sym_DASH_TILDE] = ACTIONS(1252),
    [anon_sym_addressof] = ACTIONS(1252),
    [anon_sym_digestof] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1254),
    [anon_sym_STAR] = ACTIONS(1254),
    [anon_sym_SLASH] = ACTIONS(1254),
    [anon_sym_PERCENT] = ACTIONS(1254),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1254),
    [anon_sym_LT_LT] = ACTIONS(1254),
    [anon_sym_GT_GT] = ACTIONS(1254),
    [anon_sym_and] = ACTIONS(1252),
    [anon_sym_or] = ACTIONS(1252),
    [anon_sym_xor] = ACTIONS(1252),
    [anon_sym_isnt] = ACTIONS(1252),
    [anon_sym_EQ_EQ] = ACTIONS(1254),
    [anon_sym_BANG_EQ] = ACTIONS(1254),
    [anon_sym_GT] = ACTIONS(1254),
    [anon_sym_GT_EQ] = ACTIONS(1254),
    [anon_sym_LT_EQ] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1254),
    [anon_sym_PLUS_TILDE] = ACTIONS(1252),
    [anon_sym_STAR_TILDE] = ACTIONS(1252),
    [anon_sym_SLASH_TILDE] = ACTIONS(1252),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1252),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1252),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1252),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1252),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1252),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1252),
    [anon_sym_GT_TILDE] = ACTIONS(1252),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1252),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1252),
    [anon_sym_LT_TILDE] = ACTIONS(1252),
    [anon_sym_PLUS_QMARK] = ACTIONS(1252),
    [anon_sym_DASH_QMARK] = ACTIONS(1252),
    [anon_sym_STAR_QMARK] = ACTIONS(1252),
    [anon_sym_SLASH_QMARK] = ACTIONS(1252),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1252),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1252),
    [anon_sym_as] = ACTIONS(1252),
    [anon_sym_LPAREN2] = ACTIONS(1252),
    [anon_sym_DOT_GT] = ACTIONS(1252),
    [anon_sym_TILDE] = ACTIONS(1252),
    [anon_sym_end] = ACTIONS(1252),
    [anon_sym_if] = ACTIONS(1254),
    [anon_sym_ifdef] = ACTIONS(1252),
    [anon_sym_elseif] = ACTIONS(1252),
    [anon_sym_iftype] = ACTIONS(1252),
    [anon_sym_else] = ACTIONS(1254),
    [anon_sym_for] = ACTIONS(1252),
    [anon_sym_while] = ACTIONS(1252),
    [anon_sym_try] = ACTIONS(1252),
    [anon_sym_with] = ACTIONS(1252),
    [anon_sym_repeat] = ACTIONS(1252),
    [anon_sym_recover] = ACTIONS(1252),
    [anon_sym_match] = ACTIONS(1252),
    [anon_sym_return] = ACTIONS(1252),
    [anon_sym_continue] = ACTIONS(1252),
    [anon_sym_break] = ACTIONS(1252),
    [anon_sym_consume] = ACTIONS(1252),
    [anon_sym_object] = ACTIONS(1252),
    [sym_number] = ACTIONS(1254),
    [sym_float] = ACTIONS(1252),
    [anon_sym_DQUOTE] = ACTIONS(1254),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1252),
    [anon_sym_SQUOTE] = ACTIONS(1252),
    [anon_sym_true] = ACTIONS(1252),
    [anon_sym_false] = ACTIONS(1252),
    [sym_this] = ACTIONS(1252),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [537] = {
    [sym_identifier] = ACTIONS(1246),
    [anon_sym_EQ] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(1244),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_is] = ACTIONS(1246),
    [anon_sym_let] = ACTIONS(1244),
    [anon_sym_var] = ACTIONS(1244),
    [anon_sym_LPAREN] = ACTIONS(1246),
    [anon_sym_DOT] = ACTIONS(1246),
    [anon_sym_LBRACE] = ACTIONS(1244),
    [anon_sym_SEMI] = ACTIONS(1244),
    [sym_error] = ACTIONS(1244),
    [sym_compile_intrinsic] = ACTIONS(1244),
    [anon_sym_compile_error] = ACTIONS(1244),
    [sym_location] = ACTIONS(1244),
    [anon_sym_DASH] = ACTIONS(1246),
    [anon_sym_not] = ACTIONS(1244),
    [anon_sym_DASH_TILDE] = ACTIONS(1244),
    [anon_sym_addressof] = ACTIONS(1244),
    [anon_sym_digestof] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1246),
    [anon_sym_STAR] = ACTIONS(1246),
    [anon_sym_SLASH] = ACTIONS(1246),
    [anon_sym_PERCENT] = ACTIONS(1246),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1246),
    [anon_sym_LT_LT] = ACTIONS(1246),
    [anon_sym_GT_GT] = ACTIONS(1246),
    [anon_sym_and] = ACTIONS(1244),
    [anon_sym_or] = ACTIONS(1244),
    [anon_sym_xor] = ACTIONS(1244),
    [anon_sym_isnt] = ACTIONS(1244),
    [anon_sym_EQ_EQ] = ACTIONS(1246),
    [anon_sym_BANG_EQ] = ACTIONS(1246),
    [anon_sym_GT] = ACTIONS(1246),
    [anon_sym_GT_EQ] = ACTIONS(1246),
    [anon_sym_LT_EQ] = ACTIONS(1246),
    [anon_sym_LT] = ACTIONS(1246),
    [anon_sym_PLUS_TILDE] = ACTIONS(1244),
    [anon_sym_STAR_TILDE] = ACTIONS(1244),
    [anon_sym_SLASH_TILDE] = ACTIONS(1244),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1244),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1244),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1244),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1244),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1244),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1244),
    [anon_sym_GT_TILDE] = ACTIONS(1244),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1244),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1244),
    [anon_sym_LT_TILDE] = ACTIONS(1244),
    [anon_sym_PLUS_QMARK] = ACTIONS(1244),
    [anon_sym_DASH_QMARK] = ACTIONS(1244),
    [anon_sym_STAR_QMARK] = ACTIONS(1244),
    [anon_sym_SLASH_QMARK] = ACTIONS(1244),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1244),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1244),
    [anon_sym_as] = ACTIONS(1244),
    [anon_sym_LPAREN2] = ACTIONS(1244),
    [anon_sym_DOT_GT] = ACTIONS(1244),
    [anon_sym_TILDE] = ACTIONS(1244),
    [anon_sym_end] = ACTIONS(1244),
    [anon_sym_if] = ACTIONS(1246),
    [anon_sym_ifdef] = ACTIONS(1244),
    [anon_sym_elseif] = ACTIONS(1244),
    [anon_sym_iftype] = ACTIONS(1244),
    [anon_sym_else] = ACTIONS(1246),
    [anon_sym_for] = ACTIONS(1244),
    [anon_sym_while] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_with] = ACTIONS(1244),
    [anon_sym_repeat] = ACTIONS(1244),
    [anon_sym_recover] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1244),
    [anon_sym_return] = ACTIONS(1244),
    [anon_sym_continue] = ACTIONS(1244),
    [anon_sym_break] = ACTIONS(1244),
    [anon_sym_consume] = ACTIONS(1244),
    [anon_sym_object] = ACTIONS(1244),
    [sym_number] = ACTIONS(1246),
    [sym_float] = ACTIONS(1244),
    [anon_sym_DQUOTE] = ACTIONS(1246),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1244),
    [anon_sym_SQUOTE] = ACTIONS(1244),
    [anon_sym_true] = ACTIONS(1244),
    [anon_sym_false] = ACTIONS(1244),
    [sym_this] = ACTIONS(1244),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [538] = {
    [sym_identifier] = ACTIONS(1144),
    [anon_sym_EQ] = ACTIONS(1144),
    [anon_sym_AT] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_is] = ACTIONS(1144),
    [anon_sym_let] = ACTIONS(1142),
    [anon_sym_var] = ACTIONS(1142),
    [anon_sym_LPAREN] = ACTIONS(1144),
    [anon_sym_DOT] = ACTIONS(1144),
    [anon_sym_LBRACE] = ACTIONS(1142),
    [anon_sym_SEMI] = ACTIONS(1142),
    [sym_error] = ACTIONS(1142),
    [sym_compile_intrinsic] = ACTIONS(1142),
    [anon_sym_compile_error] = ACTIONS(1142),
    [sym_location] = ACTIONS(1142),
    [anon_sym_DASH] = ACTIONS(1144),
    [anon_sym_not] = ACTIONS(1142),
    [anon_sym_DASH_TILDE] = ACTIONS(1142),
    [anon_sym_addressof] = ACTIONS(1142),
    [anon_sym_digestof] = ACTIONS(1142),
    [anon_sym_PLUS] = ACTIONS(1144),
    [anon_sym_STAR] = ACTIONS(1144),
    [anon_sym_SLASH] = ACTIONS(1144),
    [anon_sym_PERCENT] = ACTIONS(1144),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1144),
    [anon_sym_LT_LT] = ACTIONS(1144),
    [anon_sym_GT_GT] = ACTIONS(1144),
    [anon_sym_and] = ACTIONS(1142),
    [anon_sym_or] = ACTIONS(1142),
    [anon_sym_xor] = ACTIONS(1142),
    [anon_sym_isnt] = ACTIONS(1142),
    [anon_sym_EQ_EQ] = ACTIONS(1144),
    [anon_sym_BANG_EQ] = ACTIONS(1144),
    [anon_sym_GT] = ACTIONS(1144),
    [anon_sym_GT_EQ] = ACTIONS(1144),
    [anon_sym_LT_EQ] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(1144),
    [anon_sym_PLUS_TILDE] = ACTIONS(1142),
    [anon_sym_STAR_TILDE] = ACTIONS(1142),
    [anon_sym_SLASH_TILDE] = ACTIONS(1142),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1142),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1142),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1142),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1142),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1142),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1142),
    [anon_sym_GT_TILDE] = ACTIONS(1142),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1142),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1142),
    [anon_sym_LT_TILDE] = ACTIONS(1142),
    [anon_sym_PLUS_QMARK] = ACTIONS(1142),
    [anon_sym_DASH_QMARK] = ACTIONS(1142),
    [anon_sym_STAR_QMARK] = ACTIONS(1142),
    [anon_sym_SLASH_QMARK] = ACTIONS(1142),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1142),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1142),
    [anon_sym_as] = ACTIONS(1142),
    [anon_sym_LPAREN2] = ACTIONS(1142),
    [anon_sym_DOT_GT] = ACTIONS(1142),
    [anon_sym_TILDE] = ACTIONS(1142),
    [anon_sym_end] = ACTIONS(1142),
    [anon_sym_if] = ACTIONS(1144),
    [anon_sym_ifdef] = ACTIONS(1142),
    [anon_sym_elseif] = ACTIONS(1142),
    [anon_sym_iftype] = ACTIONS(1142),
    [anon_sym_else] = ACTIONS(1144),
    [anon_sym_for] = ACTIONS(1142),
    [anon_sym_while] = ACTIONS(1142),
    [anon_sym_try] = ACTIONS(1142),
    [anon_sym_with] = ACTIONS(1142),
    [anon_sym_repeat] = ACTIONS(1142),
    [anon_sym_recover] = ACTIONS(1142),
    [anon_sym_match] = ACTIONS(1142),
    [anon_sym_return] = ACTIONS(1142),
    [anon_sym_continue] = ACTIONS(1142),
    [anon_sym_break] = ACTIONS(1142),
    [anon_sym_consume] = ACTIONS(1142),
    [anon_sym_object] = ACTIONS(1142),
    [sym_number] = ACTIONS(1144),
    [sym_float] = ACTIONS(1142),
    [anon_sym_DQUOTE] = ACTIONS(1144),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1142),
    [anon_sym_SQUOTE] = ACTIONS(1142),
    [anon_sym_true] = ACTIONS(1142),
    [anon_sym_false] = ACTIONS(1142),
    [sym_this] = ACTIONS(1142),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [539] = {
    [sym_identifier] = ACTIONS(1238),
    [anon_sym_EQ] = ACTIONS(1238),
    [anon_sym_AT] = ACTIONS(1236),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_is] = ACTIONS(1238),
    [anon_sym_let] = ACTIONS(1236),
    [anon_sym_var] = ACTIONS(1236),
    [anon_sym_LPAREN] = ACTIONS(1238),
    [anon_sym_DOT] = ACTIONS(1238),
    [anon_sym_LBRACE] = ACTIONS(1236),
    [anon_sym_SEMI] = ACTIONS(1236),
    [sym_error] = ACTIONS(1236),
    [sym_compile_intrinsic] = ACTIONS(1236),
    [anon_sym_compile_error] = ACTIONS(1236),
    [sym_location] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_not] = ACTIONS(1236),
    [anon_sym_DASH_TILDE] = ACTIONS(1236),
    [anon_sym_addressof] = ACTIONS(1236),
    [anon_sym_digestof] = ACTIONS(1236),
    [anon_sym_PLUS] = ACTIONS(1238),
    [anon_sym_STAR] = ACTIONS(1238),
    [anon_sym_SLASH] = ACTIONS(1238),
    [anon_sym_PERCENT] = ACTIONS(1238),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1238),
    [anon_sym_LT_LT] = ACTIONS(1238),
    [anon_sym_GT_GT] = ACTIONS(1238),
    [anon_sym_and] = ACTIONS(1236),
    [anon_sym_or] = ACTIONS(1236),
    [anon_sym_xor] = ACTIONS(1236),
    [anon_sym_isnt] = ACTIONS(1236),
    [anon_sym_EQ_EQ] = ACTIONS(1238),
    [anon_sym_BANG_EQ] = ACTIONS(1238),
    [anon_sym_GT] = ACTIONS(1238),
    [anon_sym_GT_EQ] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(1238),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_PLUS_TILDE] = ACTIONS(1236),
    [anon_sym_STAR_TILDE] = ACTIONS(1236),
    [anon_sym_SLASH_TILDE] = ACTIONS(1236),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1236),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1236),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1236),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1236),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1236),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1236),
    [anon_sym_GT_TILDE] = ACTIONS(1236),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1236),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1236),
    [anon_sym_LT_TILDE] = ACTIONS(1236),
    [anon_sym_PLUS_QMARK] = ACTIONS(1236),
    [anon_sym_DASH_QMARK] = ACTIONS(1236),
    [anon_sym_STAR_QMARK] = ACTIONS(1236),
    [anon_sym_SLASH_QMARK] = ACTIONS(1236),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1236),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1236),
    [anon_sym_as] = ACTIONS(1236),
    [anon_sym_LPAREN2] = ACTIONS(1236),
    [anon_sym_DOT_GT] = ACTIONS(1236),
    [anon_sym_TILDE] = ACTIONS(1236),
    [anon_sym_end] = ACTIONS(1236),
    [anon_sym_if] = ACTIONS(1238),
    [anon_sym_ifdef] = ACTIONS(1236),
    [anon_sym_elseif] = ACTIONS(1236),
    [anon_sym_iftype] = ACTIONS(1236),
    [anon_sym_else] = ACTIONS(1238),
    [anon_sym_for] = ACTIONS(1236),
    [anon_sym_while] = ACTIONS(1236),
    [anon_sym_try] = ACTIONS(1236),
    [anon_sym_with] = ACTIONS(1236),
    [anon_sym_repeat] = ACTIONS(1236),
    [anon_sym_recover] = ACTIONS(1236),
    [anon_sym_match] = ACTIONS(1236),
    [anon_sym_return] = ACTIONS(1236),
    [anon_sym_continue] = ACTIONS(1236),
    [anon_sym_break] = ACTIONS(1236),
    [anon_sym_consume] = ACTIONS(1236),
    [anon_sym_object] = ACTIONS(1236),
    [sym_number] = ACTIONS(1238),
    [sym_float] = ACTIONS(1236),
    [anon_sym_DQUOTE] = ACTIONS(1238),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1236),
    [anon_sym_SQUOTE] = ACTIONS(1236),
    [anon_sym_true] = ACTIONS(1236),
    [anon_sym_false] = ACTIONS(1236),
    [sym_this] = ACTIONS(1236),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [540] = {
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_EQ] = ACTIONS(1234),
    [anon_sym_AT] = ACTIONS(1232),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_is] = ACTIONS(1234),
    [anon_sym_let] = ACTIONS(1232),
    [anon_sym_var] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [anon_sym_DOT] = ACTIONS(1234),
    [anon_sym_LBRACE] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1232),
    [sym_error] = ACTIONS(1232),
    [sym_compile_intrinsic] = ACTIONS(1232),
    [anon_sym_compile_error] = ACTIONS(1232),
    [sym_location] = ACTIONS(1232),
    [anon_sym_DASH] = ACTIONS(1234),
    [anon_sym_not] = ACTIONS(1232),
    [anon_sym_DASH_TILDE] = ACTIONS(1232),
    [anon_sym_addressof] = ACTIONS(1232),
    [anon_sym_digestof] = ACTIONS(1232),
    [anon_sym_PLUS] = ACTIONS(1234),
    [anon_sym_STAR] = ACTIONS(1234),
    [anon_sym_SLASH] = ACTIONS(1234),
    [anon_sym_PERCENT] = ACTIONS(1234),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1234),
    [anon_sym_LT_LT] = ACTIONS(1234),
    [anon_sym_GT_GT] = ACTIONS(1234),
    [anon_sym_and] = ACTIONS(1232),
    [anon_sym_or] = ACTIONS(1232),
    [anon_sym_xor] = ACTIONS(1232),
    [anon_sym_isnt] = ACTIONS(1232),
    [anon_sym_EQ_EQ] = ACTIONS(1234),
    [anon_sym_BANG_EQ] = ACTIONS(1234),
    [anon_sym_GT] = ACTIONS(1234),
    [anon_sym_GT_EQ] = ACTIONS(1234),
    [anon_sym_LT_EQ] = ACTIONS(1234),
    [anon_sym_LT] = ACTIONS(1234),
    [anon_sym_PLUS_TILDE] = ACTIONS(1232),
    [anon_sym_STAR_TILDE] = ACTIONS(1232),
    [anon_sym_SLASH_TILDE] = ACTIONS(1232),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1232),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1232),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1232),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1232),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1232),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1232),
    [anon_sym_GT_TILDE] = ACTIONS(1232),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1232),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1232),
    [anon_sym_LT_TILDE] = ACTIONS(1232),
    [anon_sym_PLUS_QMARK] = ACTIONS(1232),
    [anon_sym_DASH_QMARK] = ACTIONS(1232),
    [anon_sym_STAR_QMARK] = ACTIONS(1232),
    [anon_sym_SLASH_QMARK] = ACTIONS(1232),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1232),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1232),
    [anon_sym_as] = ACTIONS(1232),
    [anon_sym_LPAREN2] = ACTIONS(1232),
    [anon_sym_DOT_GT] = ACTIONS(1232),
    [anon_sym_TILDE] = ACTIONS(1232),
    [anon_sym_end] = ACTIONS(1232),
    [anon_sym_if] = ACTIONS(1234),
    [anon_sym_ifdef] = ACTIONS(1232),
    [anon_sym_elseif] = ACTIONS(1232),
    [anon_sym_iftype] = ACTIONS(1232),
    [anon_sym_else] = ACTIONS(1234),
    [anon_sym_for] = ACTIONS(1232),
    [anon_sym_while] = ACTIONS(1232),
    [anon_sym_try] = ACTIONS(1232),
    [anon_sym_with] = ACTIONS(1232),
    [anon_sym_repeat] = ACTIONS(1232),
    [anon_sym_recover] = ACTIONS(1232),
    [anon_sym_match] = ACTIONS(1232),
    [anon_sym_return] = ACTIONS(1232),
    [anon_sym_continue] = ACTIONS(1232),
    [anon_sym_break] = ACTIONS(1232),
    [anon_sym_consume] = ACTIONS(1232),
    [anon_sym_object] = ACTIONS(1232),
    [sym_number] = ACTIONS(1234),
    [sym_float] = ACTIONS(1232),
    [anon_sym_DQUOTE] = ACTIONS(1234),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1232),
    [anon_sym_SQUOTE] = ACTIONS(1232),
    [anon_sym_true] = ACTIONS(1232),
    [anon_sym_false] = ACTIONS(1232),
    [sym_this] = ACTIONS(1232),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [541] = {
    [sym_identifier] = ACTIONS(1174),
    [anon_sym_EQ] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(1172),
    [anon_sym_LBRACK] = ACTIONS(1172),
    [anon_sym_is] = ACTIONS(1174),
    [anon_sym_let] = ACTIONS(1172),
    [anon_sym_var] = ACTIONS(1172),
    [anon_sym_LPAREN] = ACTIONS(1174),
    [anon_sym_DOT] = ACTIONS(1174),
    [anon_sym_LBRACE] = ACTIONS(1172),
    [anon_sym_SEMI] = ACTIONS(1172),
    [sym_error] = ACTIONS(1172),
    [sym_compile_intrinsic] = ACTIONS(1172),
    [anon_sym_compile_error] = ACTIONS(1172),
    [sym_location] = ACTIONS(1172),
    [anon_sym_DASH] = ACTIONS(1174),
    [anon_sym_not] = ACTIONS(1172),
    [anon_sym_DASH_TILDE] = ACTIONS(1172),
    [anon_sym_addressof] = ACTIONS(1172),
    [anon_sym_digestof] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(1174),
    [anon_sym_STAR] = ACTIONS(1174),
    [anon_sym_SLASH] = ACTIONS(1174),
    [anon_sym_PERCENT] = ACTIONS(1174),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1174),
    [anon_sym_LT_LT] = ACTIONS(1174),
    [anon_sym_GT_GT] = ACTIONS(1174),
    [anon_sym_and] = ACTIONS(1172),
    [anon_sym_or] = ACTIONS(1172),
    [anon_sym_xor] = ACTIONS(1172),
    [anon_sym_isnt] = ACTIONS(1172),
    [anon_sym_EQ_EQ] = ACTIONS(1174),
    [anon_sym_BANG_EQ] = ACTIONS(1174),
    [anon_sym_GT] = ACTIONS(1174),
    [anon_sym_GT_EQ] = ACTIONS(1174),
    [anon_sym_LT_EQ] = ACTIONS(1174),
    [anon_sym_LT] = ACTIONS(1174),
    [anon_sym_PLUS_TILDE] = ACTIONS(1172),
    [anon_sym_STAR_TILDE] = ACTIONS(1172),
    [anon_sym_SLASH_TILDE] = ACTIONS(1172),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1172),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1172),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1172),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1172),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1172),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1172),
    [anon_sym_GT_TILDE] = ACTIONS(1172),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1172),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1172),
    [anon_sym_LT_TILDE] = ACTIONS(1172),
    [anon_sym_PLUS_QMARK] = ACTIONS(1172),
    [anon_sym_DASH_QMARK] = ACTIONS(1172),
    [anon_sym_STAR_QMARK] = ACTIONS(1172),
    [anon_sym_SLASH_QMARK] = ACTIONS(1172),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1172),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1172),
    [anon_sym_as] = ACTIONS(1172),
    [anon_sym_LPAREN2] = ACTIONS(1172),
    [anon_sym_DOT_GT] = ACTIONS(1172),
    [anon_sym_TILDE] = ACTIONS(1172),
    [anon_sym_end] = ACTIONS(1172),
    [anon_sym_if] = ACTIONS(1174),
    [anon_sym_ifdef] = ACTIONS(1172),
    [anon_sym_elseif] = ACTIONS(1172),
    [anon_sym_iftype] = ACTIONS(1172),
    [anon_sym_else] = ACTIONS(1174),
    [anon_sym_for] = ACTIONS(1172),
    [anon_sym_while] = ACTIONS(1172),
    [anon_sym_try] = ACTIONS(1172),
    [anon_sym_with] = ACTIONS(1172),
    [anon_sym_repeat] = ACTIONS(1172),
    [anon_sym_recover] = ACTIONS(1172),
    [anon_sym_match] = ACTIONS(1172),
    [anon_sym_return] = ACTIONS(1172),
    [anon_sym_continue] = ACTIONS(1172),
    [anon_sym_break] = ACTIONS(1172),
    [anon_sym_consume] = ACTIONS(1172),
    [anon_sym_object] = ACTIONS(1172),
    [sym_number] = ACTIONS(1174),
    [sym_float] = ACTIONS(1172),
    [anon_sym_DQUOTE] = ACTIONS(1174),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1172),
    [anon_sym_SQUOTE] = ACTIONS(1172),
    [anon_sym_true] = ACTIONS(1172),
    [anon_sym_false] = ACTIONS(1172),
    [sym_this] = ACTIONS(1172),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [542] = {
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_EQ] = ACTIONS(1148),
    [anon_sym_AT] = ACTIONS(1146),
    [anon_sym_LBRACK] = ACTIONS(1146),
    [anon_sym_is] = ACTIONS(1148),
    [anon_sym_let] = ACTIONS(1146),
    [anon_sym_var] = ACTIONS(1146),
    [anon_sym_LPAREN] = ACTIONS(1148),
    [anon_sym_DOT] = ACTIONS(1148),
    [anon_sym_LBRACE] = ACTIONS(1146),
    [anon_sym_SEMI] = ACTIONS(1146),
    [sym_error] = ACTIONS(1146),
    [sym_compile_intrinsic] = ACTIONS(1146),
    [anon_sym_compile_error] = ACTIONS(1146),
    [sym_location] = ACTIONS(1146),
    [anon_sym_DASH] = ACTIONS(1148),
    [anon_sym_not] = ACTIONS(1146),
    [anon_sym_DASH_TILDE] = ACTIONS(1146),
    [anon_sym_addressof] = ACTIONS(1146),
    [anon_sym_digestof] = ACTIONS(1146),
    [anon_sym_PLUS] = ACTIONS(1148),
    [anon_sym_STAR] = ACTIONS(1148),
    [anon_sym_SLASH] = ACTIONS(1148),
    [anon_sym_PERCENT] = ACTIONS(1148),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(1148),
    [anon_sym_GT_GT] = ACTIONS(1148),
    [anon_sym_and] = ACTIONS(1146),
    [anon_sym_or] = ACTIONS(1146),
    [anon_sym_xor] = ACTIONS(1146),
    [anon_sym_isnt] = ACTIONS(1146),
    [anon_sym_EQ_EQ] = ACTIONS(1148),
    [anon_sym_BANG_EQ] = ACTIONS(1148),
    [anon_sym_GT] = ACTIONS(1148),
    [anon_sym_GT_EQ] = ACTIONS(1148),
    [anon_sym_LT_EQ] = ACTIONS(1148),
    [anon_sym_LT] = ACTIONS(1148),
    [anon_sym_PLUS_TILDE] = ACTIONS(1146),
    [anon_sym_STAR_TILDE] = ACTIONS(1146),
    [anon_sym_SLASH_TILDE] = ACTIONS(1146),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1146),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1146),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1146),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1146),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1146),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1146),
    [anon_sym_GT_TILDE] = ACTIONS(1146),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1146),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1146),
    [anon_sym_LT_TILDE] = ACTIONS(1146),
    [anon_sym_PLUS_QMARK] = ACTIONS(1146),
    [anon_sym_DASH_QMARK] = ACTIONS(1146),
    [anon_sym_STAR_QMARK] = ACTIONS(1146),
    [anon_sym_SLASH_QMARK] = ACTIONS(1146),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1146),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1146),
    [anon_sym_as] = ACTIONS(1146),
    [anon_sym_LPAREN2] = ACTIONS(1146),
    [anon_sym_DOT_GT] = ACTIONS(1146),
    [anon_sym_TILDE] = ACTIONS(1146),
    [anon_sym_end] = ACTIONS(1146),
    [anon_sym_if] = ACTIONS(1148),
    [anon_sym_ifdef] = ACTIONS(1146),
    [anon_sym_elseif] = ACTIONS(1146),
    [anon_sym_iftype] = ACTIONS(1146),
    [anon_sym_else] = ACTIONS(1148),
    [anon_sym_for] = ACTIONS(1146),
    [anon_sym_while] = ACTIONS(1146),
    [anon_sym_try] = ACTIONS(1146),
    [anon_sym_with] = ACTIONS(1146),
    [anon_sym_repeat] = ACTIONS(1146),
    [anon_sym_recover] = ACTIONS(1146),
    [anon_sym_match] = ACTIONS(1146),
    [anon_sym_return] = ACTIONS(1146),
    [anon_sym_continue] = ACTIONS(1146),
    [anon_sym_break] = ACTIONS(1146),
    [anon_sym_consume] = ACTIONS(1146),
    [anon_sym_object] = ACTIONS(1146),
    [sym_number] = ACTIONS(1148),
    [sym_float] = ACTIONS(1146),
    [anon_sym_DQUOTE] = ACTIONS(1148),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1146),
    [anon_sym_SQUOTE] = ACTIONS(1146),
    [anon_sym_true] = ACTIONS(1146),
    [anon_sym_false] = ACTIONS(1146),
    [sym_this] = ACTIONS(1146),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [543] = {
    [sym_identifier] = ACTIONS(1124),
    [anon_sym_EQ] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1122),
    [anon_sym_is] = ACTIONS(1124),
    [anon_sym_let] = ACTIONS(1122),
    [anon_sym_var] = ACTIONS(1122),
    [anon_sym_LPAREN] = ACTIONS(1124),
    [anon_sym_DOT] = ACTIONS(1124),
    [anon_sym_LBRACE] = ACTIONS(1122),
    [anon_sym_SEMI] = ACTIONS(1122),
    [sym_error] = ACTIONS(1122),
    [sym_compile_intrinsic] = ACTIONS(1122),
    [anon_sym_compile_error] = ACTIONS(1122),
    [sym_location] = ACTIONS(1122),
    [anon_sym_DASH] = ACTIONS(1124),
    [anon_sym_not] = ACTIONS(1122),
    [anon_sym_DASH_TILDE] = ACTIONS(1122),
    [anon_sym_addressof] = ACTIONS(1122),
    [anon_sym_digestof] = ACTIONS(1122),
    [anon_sym_PLUS] = ACTIONS(1124),
    [anon_sym_STAR] = ACTIONS(1124),
    [anon_sym_SLASH] = ACTIONS(1124),
    [anon_sym_PERCENT] = ACTIONS(1124),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1124),
    [anon_sym_LT_LT] = ACTIONS(1124),
    [anon_sym_GT_GT] = ACTIONS(1124),
    [anon_sym_and] = ACTIONS(1122),
    [anon_sym_or] = ACTIONS(1122),
    [anon_sym_xor] = ACTIONS(1122),
    [anon_sym_isnt] = ACTIONS(1122),
    [anon_sym_EQ_EQ] = ACTIONS(1124),
    [anon_sym_BANG_EQ] = ACTIONS(1124),
    [anon_sym_GT] = ACTIONS(1124),
    [anon_sym_GT_EQ] = ACTIONS(1124),
    [anon_sym_LT_EQ] = ACTIONS(1124),
    [anon_sym_LT] = ACTIONS(1124),
    [anon_sym_PLUS_TILDE] = ACTIONS(1122),
    [anon_sym_STAR_TILDE] = ACTIONS(1122),
    [anon_sym_SLASH_TILDE] = ACTIONS(1122),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1122),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1122),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1122),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1122),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1122),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1122),
    [anon_sym_GT_TILDE] = ACTIONS(1122),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1122),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1122),
    [anon_sym_LT_TILDE] = ACTIONS(1122),
    [anon_sym_PLUS_QMARK] = ACTIONS(1122),
    [anon_sym_DASH_QMARK] = ACTIONS(1122),
    [anon_sym_STAR_QMARK] = ACTIONS(1122),
    [anon_sym_SLASH_QMARK] = ACTIONS(1122),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1122),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1122),
    [anon_sym_as] = ACTIONS(1122),
    [anon_sym_LPAREN2] = ACTIONS(1122),
    [anon_sym_DOT_GT] = ACTIONS(1122),
    [anon_sym_TILDE] = ACTIONS(1122),
    [anon_sym_end] = ACTIONS(1122),
    [anon_sym_if] = ACTIONS(1124),
    [anon_sym_ifdef] = ACTIONS(1122),
    [anon_sym_elseif] = ACTIONS(1122),
    [anon_sym_iftype] = ACTIONS(1122),
    [anon_sym_else] = ACTIONS(1124),
    [anon_sym_for] = ACTIONS(1122),
    [anon_sym_while] = ACTIONS(1122),
    [anon_sym_try] = ACTIONS(1122),
    [anon_sym_with] = ACTIONS(1122),
    [anon_sym_repeat] = ACTIONS(1122),
    [anon_sym_recover] = ACTIONS(1122),
    [anon_sym_match] = ACTIONS(1122),
    [anon_sym_return] = ACTIONS(1122),
    [anon_sym_continue] = ACTIONS(1122),
    [anon_sym_break] = ACTIONS(1122),
    [anon_sym_consume] = ACTIONS(1122),
    [anon_sym_object] = ACTIONS(1122),
    [sym_number] = ACTIONS(1124),
    [sym_float] = ACTIONS(1122),
    [anon_sym_DQUOTE] = ACTIONS(1124),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1122),
    [anon_sym_SQUOTE] = ACTIONS(1122),
    [anon_sym_true] = ACTIONS(1122),
    [anon_sym_false] = ACTIONS(1122),
    [sym_this] = ACTIONS(1122),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [544] = {
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_EQ] = ACTIONS(1128),
    [anon_sym_AT] = ACTIONS(1126),
    [anon_sym_LBRACK] = ACTIONS(1126),
    [anon_sym_is] = ACTIONS(1128),
    [anon_sym_let] = ACTIONS(1126),
    [anon_sym_var] = ACTIONS(1126),
    [anon_sym_LPAREN] = ACTIONS(1128),
    [anon_sym_DOT] = ACTIONS(1128),
    [anon_sym_LBRACE] = ACTIONS(1126),
    [anon_sym_SEMI] = ACTIONS(1126),
    [sym_error] = ACTIONS(1126),
    [sym_compile_intrinsic] = ACTIONS(1126),
    [anon_sym_compile_error] = ACTIONS(1126),
    [sym_location] = ACTIONS(1126),
    [anon_sym_DASH] = ACTIONS(1128),
    [anon_sym_not] = ACTIONS(1126),
    [anon_sym_DASH_TILDE] = ACTIONS(1126),
    [anon_sym_addressof] = ACTIONS(1126),
    [anon_sym_digestof] = ACTIONS(1126),
    [anon_sym_PLUS] = ACTIONS(1128),
    [anon_sym_STAR] = ACTIONS(1128),
    [anon_sym_SLASH] = ACTIONS(1128),
    [anon_sym_PERCENT] = ACTIONS(1128),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1128),
    [anon_sym_LT_LT] = ACTIONS(1128),
    [anon_sym_GT_GT] = ACTIONS(1128),
    [anon_sym_and] = ACTIONS(1126),
    [anon_sym_or] = ACTIONS(1126),
    [anon_sym_xor] = ACTIONS(1126),
    [anon_sym_isnt] = ACTIONS(1126),
    [anon_sym_EQ_EQ] = ACTIONS(1128),
    [anon_sym_BANG_EQ] = ACTIONS(1128),
    [anon_sym_GT] = ACTIONS(1128),
    [anon_sym_GT_EQ] = ACTIONS(1128),
    [anon_sym_LT_EQ] = ACTIONS(1128),
    [anon_sym_LT] = ACTIONS(1128),
    [anon_sym_PLUS_TILDE] = ACTIONS(1126),
    [anon_sym_STAR_TILDE] = ACTIONS(1126),
    [anon_sym_SLASH_TILDE] = ACTIONS(1126),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1126),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1126),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1126),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1126),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1126),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1126),
    [anon_sym_GT_TILDE] = ACTIONS(1126),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1126),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1126),
    [anon_sym_LT_TILDE] = ACTIONS(1126),
    [anon_sym_PLUS_QMARK] = ACTIONS(1126),
    [anon_sym_DASH_QMARK] = ACTIONS(1126),
    [anon_sym_STAR_QMARK] = ACTIONS(1126),
    [anon_sym_SLASH_QMARK] = ACTIONS(1126),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1126),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1126),
    [anon_sym_as] = ACTIONS(1126),
    [anon_sym_LPAREN2] = ACTIONS(1126),
    [anon_sym_DOT_GT] = ACTIONS(1126),
    [anon_sym_TILDE] = ACTIONS(1126),
    [anon_sym_end] = ACTIONS(1126),
    [anon_sym_if] = ACTIONS(1128),
    [anon_sym_ifdef] = ACTIONS(1126),
    [anon_sym_elseif] = ACTIONS(1126),
    [anon_sym_iftype] = ACTIONS(1126),
    [anon_sym_else] = ACTIONS(1128),
    [anon_sym_for] = ACTIONS(1126),
    [anon_sym_while] = ACTIONS(1126),
    [anon_sym_try] = ACTIONS(1126),
    [anon_sym_with] = ACTIONS(1126),
    [anon_sym_repeat] = ACTIONS(1126),
    [anon_sym_recover] = ACTIONS(1126),
    [anon_sym_match] = ACTIONS(1126),
    [anon_sym_return] = ACTIONS(1126),
    [anon_sym_continue] = ACTIONS(1126),
    [anon_sym_break] = ACTIONS(1126),
    [anon_sym_consume] = ACTIONS(1126),
    [anon_sym_object] = ACTIONS(1126),
    [sym_number] = ACTIONS(1128),
    [sym_float] = ACTIONS(1126),
    [anon_sym_DQUOTE] = ACTIONS(1128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1126),
    [anon_sym_SQUOTE] = ACTIONS(1126),
    [anon_sym_true] = ACTIONS(1126),
    [anon_sym_false] = ACTIONS(1126),
    [sym_this] = ACTIONS(1126),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [545] = {
    [sym_identifier] = ACTIONS(1190),
    [anon_sym_EQ] = ACTIONS(1190),
    [anon_sym_AT] = ACTIONS(1188),
    [anon_sym_LBRACK] = ACTIONS(1188),
    [anon_sym_is] = ACTIONS(1190),
    [anon_sym_let] = ACTIONS(1188),
    [anon_sym_var] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1190),
    [anon_sym_DOT] = ACTIONS(1190),
    [anon_sym_LBRACE] = ACTIONS(1188),
    [anon_sym_SEMI] = ACTIONS(1188),
    [sym_error] = ACTIONS(1188),
    [sym_compile_intrinsic] = ACTIONS(1188),
    [anon_sym_compile_error] = ACTIONS(1188),
    [sym_location] = ACTIONS(1188),
    [anon_sym_DASH] = ACTIONS(1190),
    [anon_sym_not] = ACTIONS(1188),
    [anon_sym_DASH_TILDE] = ACTIONS(1188),
    [anon_sym_addressof] = ACTIONS(1188),
    [anon_sym_digestof] = ACTIONS(1188),
    [anon_sym_PLUS] = ACTIONS(1190),
    [anon_sym_STAR] = ACTIONS(1190),
    [anon_sym_SLASH] = ACTIONS(1190),
    [anon_sym_PERCENT] = ACTIONS(1190),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1190),
    [anon_sym_LT_LT] = ACTIONS(1190),
    [anon_sym_GT_GT] = ACTIONS(1190),
    [anon_sym_and] = ACTIONS(1188),
    [anon_sym_or] = ACTIONS(1188),
    [anon_sym_xor] = ACTIONS(1188),
    [anon_sym_isnt] = ACTIONS(1188),
    [anon_sym_EQ_EQ] = ACTIONS(1190),
    [anon_sym_BANG_EQ] = ACTIONS(1190),
    [anon_sym_GT] = ACTIONS(1190),
    [anon_sym_GT_EQ] = ACTIONS(1190),
    [anon_sym_LT_EQ] = ACTIONS(1190),
    [anon_sym_LT] = ACTIONS(1190),
    [anon_sym_PLUS_TILDE] = ACTIONS(1188),
    [anon_sym_STAR_TILDE] = ACTIONS(1188),
    [anon_sym_SLASH_TILDE] = ACTIONS(1188),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1188),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1188),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1188),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1188),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1188),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1188),
    [anon_sym_GT_TILDE] = ACTIONS(1188),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1188),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1188),
    [anon_sym_LT_TILDE] = ACTIONS(1188),
    [anon_sym_PLUS_QMARK] = ACTIONS(1188),
    [anon_sym_DASH_QMARK] = ACTIONS(1188),
    [anon_sym_STAR_QMARK] = ACTIONS(1188),
    [anon_sym_SLASH_QMARK] = ACTIONS(1188),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1188),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1188),
    [anon_sym_as] = ACTIONS(1188),
    [anon_sym_LPAREN2] = ACTIONS(1188),
    [anon_sym_DOT_GT] = ACTIONS(1188),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_end] = ACTIONS(1188),
    [anon_sym_if] = ACTIONS(1190),
    [anon_sym_ifdef] = ACTIONS(1188),
    [anon_sym_elseif] = ACTIONS(1188),
    [anon_sym_iftype] = ACTIONS(1188),
    [anon_sym_else] = ACTIONS(1190),
    [anon_sym_for] = ACTIONS(1188),
    [anon_sym_while] = ACTIONS(1188),
    [anon_sym_try] = ACTIONS(1188),
    [anon_sym_with] = ACTIONS(1188),
    [anon_sym_repeat] = ACTIONS(1188),
    [anon_sym_recover] = ACTIONS(1188),
    [anon_sym_match] = ACTIONS(1188),
    [anon_sym_return] = ACTIONS(1188),
    [anon_sym_continue] = ACTIONS(1188),
    [anon_sym_break] = ACTIONS(1188),
    [anon_sym_consume] = ACTIONS(1188),
    [anon_sym_object] = ACTIONS(1188),
    [sym_number] = ACTIONS(1190),
    [sym_float] = ACTIONS(1188),
    [anon_sym_DQUOTE] = ACTIONS(1190),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1188),
    [anon_sym_true] = ACTIONS(1188),
    [anon_sym_false] = ACTIONS(1188),
    [sym_this] = ACTIONS(1188),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [546] = {
    [sym_identifier] = ACTIONS(1092),
    [anon_sym_EQ] = ACTIONS(1092),
    [anon_sym_AT] = ACTIONS(1090),
    [anon_sym_LBRACK] = ACTIONS(1090),
    [anon_sym_is] = ACTIONS(1092),
    [anon_sym_let] = ACTIONS(1090),
    [anon_sym_var] = ACTIONS(1090),
    [anon_sym_LPAREN] = ACTIONS(1092),
    [anon_sym_DOT] = ACTIONS(1092),
    [anon_sym_LBRACE] = ACTIONS(1090),
    [anon_sym_SEMI] = ACTIONS(1090),
    [sym_error] = ACTIONS(1090),
    [sym_compile_intrinsic] = ACTIONS(1090),
    [anon_sym_compile_error] = ACTIONS(1090),
    [sym_location] = ACTIONS(1090),
    [anon_sym_DASH] = ACTIONS(1092),
    [anon_sym_not] = ACTIONS(1090),
    [anon_sym_DASH_TILDE] = ACTIONS(1090),
    [anon_sym_addressof] = ACTIONS(1090),
    [anon_sym_digestof] = ACTIONS(1090),
    [anon_sym_PLUS] = ACTIONS(1092),
    [anon_sym_STAR] = ACTIONS(1092),
    [anon_sym_SLASH] = ACTIONS(1092),
    [anon_sym_PERCENT] = ACTIONS(1092),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1092),
    [anon_sym_LT_LT] = ACTIONS(1092),
    [anon_sym_GT_GT] = ACTIONS(1092),
    [anon_sym_and] = ACTIONS(1090),
    [anon_sym_or] = ACTIONS(1090),
    [anon_sym_xor] = ACTIONS(1090),
    [anon_sym_isnt] = ACTIONS(1090),
    [anon_sym_EQ_EQ] = ACTIONS(1092),
    [anon_sym_BANG_EQ] = ACTIONS(1092),
    [anon_sym_GT] = ACTIONS(1092),
    [anon_sym_GT_EQ] = ACTIONS(1092),
    [anon_sym_LT_EQ] = ACTIONS(1092),
    [anon_sym_LT] = ACTIONS(1092),
    [anon_sym_PLUS_TILDE] = ACTIONS(1090),
    [anon_sym_STAR_TILDE] = ACTIONS(1090),
    [anon_sym_SLASH_TILDE] = ACTIONS(1090),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1090),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1090),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1090),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1090),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1090),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1090),
    [anon_sym_GT_TILDE] = ACTIONS(1090),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1090),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1090),
    [anon_sym_LT_TILDE] = ACTIONS(1090),
    [anon_sym_PLUS_QMARK] = ACTIONS(1090),
    [anon_sym_DASH_QMARK] = ACTIONS(1090),
    [anon_sym_STAR_QMARK] = ACTIONS(1090),
    [anon_sym_SLASH_QMARK] = ACTIONS(1090),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1090),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1090),
    [anon_sym_as] = ACTIONS(1090),
    [anon_sym_LPAREN2] = ACTIONS(1090),
    [anon_sym_DOT_GT] = ACTIONS(1090),
    [anon_sym_TILDE] = ACTIONS(1090),
    [anon_sym_end] = ACTIONS(1090),
    [anon_sym_if] = ACTIONS(1092),
    [anon_sym_ifdef] = ACTIONS(1090),
    [anon_sym_elseif] = ACTIONS(1090),
    [anon_sym_iftype] = ACTIONS(1090),
    [anon_sym_else] = ACTIONS(1092),
    [anon_sym_for] = ACTIONS(1090),
    [anon_sym_while] = ACTIONS(1090),
    [anon_sym_try] = ACTIONS(1090),
    [anon_sym_with] = ACTIONS(1090),
    [anon_sym_repeat] = ACTIONS(1090),
    [anon_sym_recover] = ACTIONS(1090),
    [anon_sym_match] = ACTIONS(1090),
    [anon_sym_return] = ACTIONS(1090),
    [anon_sym_continue] = ACTIONS(1090),
    [anon_sym_break] = ACTIONS(1090),
    [anon_sym_consume] = ACTIONS(1090),
    [anon_sym_object] = ACTIONS(1090),
    [sym_number] = ACTIONS(1092),
    [sym_float] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(1092),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1090),
    [anon_sym_true] = ACTIONS(1090),
    [anon_sym_false] = ACTIONS(1090),
    [sym_this] = ACTIONS(1090),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [547] = {
    [sym_identifier] = ACTIONS(1100),
    [anon_sym_EQ] = ACTIONS(1100),
    [anon_sym_AT] = ACTIONS(1098),
    [anon_sym_LBRACK] = ACTIONS(1098),
    [anon_sym_is] = ACTIONS(1100),
    [anon_sym_let] = ACTIONS(1098),
    [anon_sym_var] = ACTIONS(1098),
    [anon_sym_LPAREN] = ACTIONS(1100),
    [anon_sym_DOT] = ACTIONS(1100),
    [anon_sym_LBRACE] = ACTIONS(1098),
    [anon_sym_SEMI] = ACTIONS(1098),
    [sym_error] = ACTIONS(1098),
    [sym_compile_intrinsic] = ACTIONS(1098),
    [anon_sym_compile_error] = ACTIONS(1098),
    [sym_location] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1100),
    [anon_sym_not] = ACTIONS(1098),
    [anon_sym_DASH_TILDE] = ACTIONS(1098),
    [anon_sym_addressof] = ACTIONS(1098),
    [anon_sym_digestof] = ACTIONS(1098),
    [anon_sym_PLUS] = ACTIONS(1100),
    [anon_sym_STAR] = ACTIONS(1100),
    [anon_sym_SLASH] = ACTIONS(1100),
    [anon_sym_PERCENT] = ACTIONS(1100),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1100),
    [anon_sym_LT_LT] = ACTIONS(1100),
    [anon_sym_GT_GT] = ACTIONS(1100),
    [anon_sym_and] = ACTIONS(1098),
    [anon_sym_or] = ACTIONS(1098),
    [anon_sym_xor] = ACTIONS(1098),
    [anon_sym_isnt] = ACTIONS(1098),
    [anon_sym_EQ_EQ] = ACTIONS(1100),
    [anon_sym_BANG_EQ] = ACTIONS(1100),
    [anon_sym_GT] = ACTIONS(1100),
    [anon_sym_GT_EQ] = ACTIONS(1100),
    [anon_sym_LT_EQ] = ACTIONS(1100),
    [anon_sym_LT] = ACTIONS(1100),
    [anon_sym_PLUS_TILDE] = ACTIONS(1098),
    [anon_sym_STAR_TILDE] = ACTIONS(1098),
    [anon_sym_SLASH_TILDE] = ACTIONS(1098),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1098),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1098),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1098),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1098),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1098),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1098),
    [anon_sym_GT_TILDE] = ACTIONS(1098),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1098),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1098),
    [anon_sym_LT_TILDE] = ACTIONS(1098),
    [anon_sym_PLUS_QMARK] = ACTIONS(1098),
    [anon_sym_DASH_QMARK] = ACTIONS(1098),
    [anon_sym_STAR_QMARK] = ACTIONS(1098),
    [anon_sym_SLASH_QMARK] = ACTIONS(1098),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1098),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1098),
    [anon_sym_as] = ACTIONS(1098),
    [anon_sym_LPAREN2] = ACTIONS(1098),
    [anon_sym_DOT_GT] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1098),
    [anon_sym_end] = ACTIONS(1098),
    [anon_sym_if] = ACTIONS(1100),
    [anon_sym_ifdef] = ACTIONS(1098),
    [anon_sym_elseif] = ACTIONS(1098),
    [anon_sym_iftype] = ACTIONS(1098),
    [anon_sym_else] = ACTIONS(1100),
    [anon_sym_for] = ACTIONS(1098),
    [anon_sym_while] = ACTIONS(1098),
    [anon_sym_try] = ACTIONS(1098),
    [anon_sym_with] = ACTIONS(1098),
    [anon_sym_repeat] = ACTIONS(1098),
    [anon_sym_recover] = ACTIONS(1098),
    [anon_sym_match] = ACTIONS(1098),
    [anon_sym_return] = ACTIONS(1098),
    [anon_sym_continue] = ACTIONS(1098),
    [anon_sym_break] = ACTIONS(1098),
    [anon_sym_consume] = ACTIONS(1098),
    [anon_sym_object] = ACTIONS(1098),
    [sym_number] = ACTIONS(1100),
    [sym_float] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(1100),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1098),
    [anon_sym_SQUOTE] = ACTIONS(1098),
    [anon_sym_true] = ACTIONS(1098),
    [anon_sym_false] = ACTIONS(1098),
    [sym_this] = ACTIONS(1098),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [548] = {
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_EQ] = ACTIONS(1108),
    [anon_sym_AT] = ACTIONS(1106),
    [anon_sym_LBRACK] = ACTIONS(1106),
    [anon_sym_is] = ACTIONS(1108),
    [anon_sym_let] = ACTIONS(1106),
    [anon_sym_var] = ACTIONS(1106),
    [anon_sym_LPAREN] = ACTIONS(1108),
    [anon_sym_DOT] = ACTIONS(1108),
    [anon_sym_LBRACE] = ACTIONS(1106),
    [anon_sym_SEMI] = ACTIONS(1106),
    [sym_error] = ACTIONS(1106),
    [sym_compile_intrinsic] = ACTIONS(1106),
    [anon_sym_compile_error] = ACTIONS(1106),
    [sym_location] = ACTIONS(1106),
    [anon_sym_DASH] = ACTIONS(1108),
    [anon_sym_not] = ACTIONS(1106),
    [anon_sym_DASH_TILDE] = ACTIONS(1106),
    [anon_sym_addressof] = ACTIONS(1106),
    [anon_sym_digestof] = ACTIONS(1106),
    [anon_sym_PLUS] = ACTIONS(1108),
    [anon_sym_STAR] = ACTIONS(1108),
    [anon_sym_SLASH] = ACTIONS(1108),
    [anon_sym_PERCENT] = ACTIONS(1108),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1108),
    [anon_sym_LT_LT] = ACTIONS(1108),
    [anon_sym_GT_GT] = ACTIONS(1108),
    [anon_sym_and] = ACTIONS(1106),
    [anon_sym_or] = ACTIONS(1106),
    [anon_sym_xor] = ACTIONS(1106),
    [anon_sym_isnt] = ACTIONS(1106),
    [anon_sym_EQ_EQ] = ACTIONS(1108),
    [anon_sym_BANG_EQ] = ACTIONS(1108),
    [anon_sym_GT] = ACTIONS(1108),
    [anon_sym_GT_EQ] = ACTIONS(1108),
    [anon_sym_LT_EQ] = ACTIONS(1108),
    [anon_sym_LT] = ACTIONS(1108),
    [anon_sym_PLUS_TILDE] = ACTIONS(1106),
    [anon_sym_STAR_TILDE] = ACTIONS(1106),
    [anon_sym_SLASH_TILDE] = ACTIONS(1106),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1106),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1106),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1106),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1106),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1106),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1106),
    [anon_sym_GT_TILDE] = ACTIONS(1106),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1106),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1106),
    [anon_sym_LT_TILDE] = ACTIONS(1106),
    [anon_sym_PLUS_QMARK] = ACTIONS(1106),
    [anon_sym_DASH_QMARK] = ACTIONS(1106),
    [anon_sym_STAR_QMARK] = ACTIONS(1106),
    [anon_sym_SLASH_QMARK] = ACTIONS(1106),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1106),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1106),
    [anon_sym_as] = ACTIONS(1106),
    [anon_sym_LPAREN2] = ACTIONS(1106),
    [anon_sym_DOT_GT] = ACTIONS(1106),
    [anon_sym_TILDE] = ACTIONS(1106),
    [anon_sym_end] = ACTIONS(1106),
    [anon_sym_if] = ACTIONS(1108),
    [anon_sym_ifdef] = ACTIONS(1106),
    [anon_sym_elseif] = ACTIONS(1106),
    [anon_sym_iftype] = ACTIONS(1106),
    [anon_sym_else] = ACTIONS(1108),
    [anon_sym_for] = ACTIONS(1106),
    [anon_sym_while] = ACTIONS(1106),
    [anon_sym_try] = ACTIONS(1106),
    [anon_sym_with] = ACTIONS(1106),
    [anon_sym_repeat] = ACTIONS(1106),
    [anon_sym_recover] = ACTIONS(1106),
    [anon_sym_match] = ACTIONS(1106),
    [anon_sym_return] = ACTIONS(1106),
    [anon_sym_continue] = ACTIONS(1106),
    [anon_sym_break] = ACTIONS(1106),
    [anon_sym_consume] = ACTIONS(1106),
    [anon_sym_object] = ACTIONS(1106),
    [sym_number] = ACTIONS(1108),
    [sym_float] = ACTIONS(1106),
    [anon_sym_DQUOTE] = ACTIONS(1108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1106),
    [anon_sym_SQUOTE] = ACTIONS(1106),
    [anon_sym_true] = ACTIONS(1106),
    [anon_sym_false] = ACTIONS(1106),
    [sym_this] = ACTIONS(1106),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [549] = {
    [sym_identifier] = ACTIONS(1120),
    [anon_sym_EQ] = ACTIONS(1120),
    [anon_sym_AT] = ACTIONS(1118),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_is] = ACTIONS(1120),
    [anon_sym_let] = ACTIONS(1118),
    [anon_sym_var] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1120),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_SEMI] = ACTIONS(1118),
    [sym_error] = ACTIONS(1118),
    [sym_compile_intrinsic] = ACTIONS(1118),
    [anon_sym_compile_error] = ACTIONS(1118),
    [sym_location] = ACTIONS(1118),
    [anon_sym_DASH] = ACTIONS(1120),
    [anon_sym_not] = ACTIONS(1118),
    [anon_sym_DASH_TILDE] = ACTIONS(1118),
    [anon_sym_addressof] = ACTIONS(1118),
    [anon_sym_digestof] = ACTIONS(1118),
    [anon_sym_PLUS] = ACTIONS(1120),
    [anon_sym_STAR] = ACTIONS(1120),
    [anon_sym_SLASH] = ACTIONS(1120),
    [anon_sym_PERCENT] = ACTIONS(1120),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1120),
    [anon_sym_LT_LT] = ACTIONS(1120),
    [anon_sym_GT_GT] = ACTIONS(1120),
    [anon_sym_and] = ACTIONS(1118),
    [anon_sym_or] = ACTIONS(1118),
    [anon_sym_xor] = ACTIONS(1118),
    [anon_sym_isnt] = ACTIONS(1118),
    [anon_sym_EQ_EQ] = ACTIONS(1120),
    [anon_sym_BANG_EQ] = ACTIONS(1120),
    [anon_sym_GT] = ACTIONS(1120),
    [anon_sym_GT_EQ] = ACTIONS(1120),
    [anon_sym_LT_EQ] = ACTIONS(1120),
    [anon_sym_LT] = ACTIONS(1120),
    [anon_sym_PLUS_TILDE] = ACTIONS(1118),
    [anon_sym_STAR_TILDE] = ACTIONS(1118),
    [anon_sym_SLASH_TILDE] = ACTIONS(1118),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1118),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1118),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1118),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1118),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1118),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1118),
    [anon_sym_GT_TILDE] = ACTIONS(1118),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1118),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1118),
    [anon_sym_LT_TILDE] = ACTIONS(1118),
    [anon_sym_PLUS_QMARK] = ACTIONS(1118),
    [anon_sym_DASH_QMARK] = ACTIONS(1118),
    [anon_sym_STAR_QMARK] = ACTIONS(1118),
    [anon_sym_SLASH_QMARK] = ACTIONS(1118),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1118),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1118),
    [anon_sym_as] = ACTIONS(1118),
    [anon_sym_LPAREN2] = ACTIONS(1118),
    [anon_sym_DOT_GT] = ACTIONS(1118),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_end] = ACTIONS(1118),
    [anon_sym_if] = ACTIONS(1120),
    [anon_sym_ifdef] = ACTIONS(1118),
    [anon_sym_elseif] = ACTIONS(1118),
    [anon_sym_iftype] = ACTIONS(1118),
    [anon_sym_else] = ACTIONS(1120),
    [anon_sym_for] = ACTIONS(1118),
    [anon_sym_while] = ACTIONS(1118),
    [anon_sym_try] = ACTIONS(1118),
    [anon_sym_with] = ACTIONS(1118),
    [anon_sym_repeat] = ACTIONS(1118),
    [anon_sym_recover] = ACTIONS(1118),
    [anon_sym_match] = ACTIONS(1118),
    [anon_sym_return] = ACTIONS(1118),
    [anon_sym_continue] = ACTIONS(1118),
    [anon_sym_break] = ACTIONS(1118),
    [anon_sym_consume] = ACTIONS(1118),
    [anon_sym_object] = ACTIONS(1118),
    [sym_number] = ACTIONS(1120),
    [sym_float] = ACTIONS(1118),
    [anon_sym_DQUOTE] = ACTIONS(1120),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1118),
    [anon_sym_SQUOTE] = ACTIONS(1118),
    [anon_sym_true] = ACTIONS(1118),
    [anon_sym_false] = ACTIONS(1118),
    [sym_this] = ACTIONS(1118),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [550] = {
    [sym_identifier] = ACTIONS(1132),
    [anon_sym_EQ] = ACTIONS(1132),
    [anon_sym_AT] = ACTIONS(1130),
    [anon_sym_LBRACK] = ACTIONS(1130),
    [anon_sym_is] = ACTIONS(1132),
    [anon_sym_let] = ACTIONS(1130),
    [anon_sym_var] = ACTIONS(1130),
    [anon_sym_LPAREN] = ACTIONS(1132),
    [anon_sym_DOT] = ACTIONS(1132),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_SEMI] = ACTIONS(1130),
    [sym_error] = ACTIONS(1130),
    [sym_compile_intrinsic] = ACTIONS(1130),
    [anon_sym_compile_error] = ACTIONS(1130),
    [sym_location] = ACTIONS(1130),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_not] = ACTIONS(1130),
    [anon_sym_DASH_TILDE] = ACTIONS(1130),
    [anon_sym_addressof] = ACTIONS(1130),
    [anon_sym_digestof] = ACTIONS(1130),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_STAR] = ACTIONS(1132),
    [anon_sym_SLASH] = ACTIONS(1132),
    [anon_sym_PERCENT] = ACTIONS(1132),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1132),
    [anon_sym_LT_LT] = ACTIONS(1132),
    [anon_sym_GT_GT] = ACTIONS(1132),
    [anon_sym_and] = ACTIONS(1130),
    [anon_sym_or] = ACTIONS(1130),
    [anon_sym_xor] = ACTIONS(1130),
    [anon_sym_isnt] = ACTIONS(1130),
    [anon_sym_EQ_EQ] = ACTIONS(1132),
    [anon_sym_BANG_EQ] = ACTIONS(1132),
    [anon_sym_GT] = ACTIONS(1132),
    [anon_sym_GT_EQ] = ACTIONS(1132),
    [anon_sym_LT_EQ] = ACTIONS(1132),
    [anon_sym_LT] = ACTIONS(1132),
    [anon_sym_PLUS_TILDE] = ACTIONS(1130),
    [anon_sym_STAR_TILDE] = ACTIONS(1130),
    [anon_sym_SLASH_TILDE] = ACTIONS(1130),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1130),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1130),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1130),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1130),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1130),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1130),
    [anon_sym_GT_TILDE] = ACTIONS(1130),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1130),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1130),
    [anon_sym_LT_TILDE] = ACTIONS(1130),
    [anon_sym_PLUS_QMARK] = ACTIONS(1130),
    [anon_sym_DASH_QMARK] = ACTIONS(1130),
    [anon_sym_STAR_QMARK] = ACTIONS(1130),
    [anon_sym_SLASH_QMARK] = ACTIONS(1130),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1130),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1130),
    [anon_sym_as] = ACTIONS(1130),
    [anon_sym_LPAREN2] = ACTIONS(1130),
    [anon_sym_DOT_GT] = ACTIONS(1130),
    [anon_sym_TILDE] = ACTIONS(1130),
    [anon_sym_end] = ACTIONS(1130),
    [anon_sym_if] = ACTIONS(1132),
    [anon_sym_ifdef] = ACTIONS(1130),
    [anon_sym_elseif] = ACTIONS(1130),
    [anon_sym_iftype] = ACTIONS(1130),
    [anon_sym_else] = ACTIONS(1132),
    [anon_sym_for] = ACTIONS(1130),
    [anon_sym_while] = ACTIONS(1130),
    [anon_sym_try] = ACTIONS(1130),
    [anon_sym_with] = ACTIONS(1130),
    [anon_sym_repeat] = ACTIONS(1130),
    [anon_sym_recover] = ACTIONS(1130),
    [anon_sym_match] = ACTIONS(1130),
    [anon_sym_return] = ACTIONS(1130),
    [anon_sym_continue] = ACTIONS(1130),
    [anon_sym_break] = ACTIONS(1130),
    [anon_sym_consume] = ACTIONS(1130),
    [anon_sym_object] = ACTIONS(1130),
    [sym_number] = ACTIONS(1132),
    [sym_float] = ACTIONS(1130),
    [anon_sym_DQUOTE] = ACTIONS(1132),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1130),
    [anon_sym_SQUOTE] = ACTIONS(1130),
    [anon_sym_true] = ACTIONS(1130),
    [anon_sym_false] = ACTIONS(1130),
    [sym_this] = ACTIONS(1130),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [551] = {
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_EQ] = ACTIONS(1140),
    [anon_sym_AT] = ACTIONS(1138),
    [anon_sym_LBRACK] = ACTIONS(1138),
    [anon_sym_is] = ACTIONS(1140),
    [anon_sym_let] = ACTIONS(1138),
    [anon_sym_var] = ACTIONS(1138),
    [anon_sym_LPAREN] = ACTIONS(1140),
    [anon_sym_DOT] = ACTIONS(1140),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_SEMI] = ACTIONS(1138),
    [sym_error] = ACTIONS(1138),
    [sym_compile_intrinsic] = ACTIONS(1138),
    [anon_sym_compile_error] = ACTIONS(1138),
    [sym_location] = ACTIONS(1138),
    [anon_sym_DASH] = ACTIONS(1140),
    [anon_sym_not] = ACTIONS(1138),
    [anon_sym_DASH_TILDE] = ACTIONS(1138),
    [anon_sym_addressof] = ACTIONS(1138),
    [anon_sym_digestof] = ACTIONS(1138),
    [anon_sym_PLUS] = ACTIONS(1140),
    [anon_sym_STAR] = ACTIONS(1140),
    [anon_sym_SLASH] = ACTIONS(1140),
    [anon_sym_PERCENT] = ACTIONS(1140),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1140),
    [anon_sym_LT_LT] = ACTIONS(1140),
    [anon_sym_GT_GT] = ACTIONS(1140),
    [anon_sym_and] = ACTIONS(1138),
    [anon_sym_or] = ACTIONS(1138),
    [anon_sym_xor] = ACTIONS(1138),
    [anon_sym_isnt] = ACTIONS(1138),
    [anon_sym_EQ_EQ] = ACTIONS(1140),
    [anon_sym_BANG_EQ] = ACTIONS(1140),
    [anon_sym_GT] = ACTIONS(1140),
    [anon_sym_GT_EQ] = ACTIONS(1140),
    [anon_sym_LT_EQ] = ACTIONS(1140),
    [anon_sym_LT] = ACTIONS(1140),
    [anon_sym_PLUS_TILDE] = ACTIONS(1138),
    [anon_sym_STAR_TILDE] = ACTIONS(1138),
    [anon_sym_SLASH_TILDE] = ACTIONS(1138),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1138),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1138),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1138),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1138),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1138),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1138),
    [anon_sym_GT_TILDE] = ACTIONS(1138),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1138),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1138),
    [anon_sym_LT_TILDE] = ACTIONS(1138),
    [anon_sym_PLUS_QMARK] = ACTIONS(1138),
    [anon_sym_DASH_QMARK] = ACTIONS(1138),
    [anon_sym_STAR_QMARK] = ACTIONS(1138),
    [anon_sym_SLASH_QMARK] = ACTIONS(1138),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1138),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1138),
    [anon_sym_as] = ACTIONS(1138),
    [anon_sym_LPAREN2] = ACTIONS(1138),
    [anon_sym_DOT_GT] = ACTIONS(1138),
    [anon_sym_TILDE] = ACTIONS(1138),
    [anon_sym_end] = ACTIONS(1138),
    [anon_sym_if] = ACTIONS(1140),
    [anon_sym_ifdef] = ACTIONS(1138),
    [anon_sym_elseif] = ACTIONS(1138),
    [anon_sym_iftype] = ACTIONS(1138),
    [anon_sym_else] = ACTIONS(1140),
    [anon_sym_for] = ACTIONS(1138),
    [anon_sym_while] = ACTIONS(1138),
    [anon_sym_try] = ACTIONS(1138),
    [anon_sym_with] = ACTIONS(1138),
    [anon_sym_repeat] = ACTIONS(1138),
    [anon_sym_recover] = ACTIONS(1138),
    [anon_sym_match] = ACTIONS(1138),
    [anon_sym_return] = ACTIONS(1138),
    [anon_sym_continue] = ACTIONS(1138),
    [anon_sym_break] = ACTIONS(1138),
    [anon_sym_consume] = ACTIONS(1138),
    [anon_sym_object] = ACTIONS(1138),
    [sym_number] = ACTIONS(1140),
    [sym_float] = ACTIONS(1138),
    [anon_sym_DQUOTE] = ACTIONS(1140),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1138),
    [anon_sym_SQUOTE] = ACTIONS(1138),
    [anon_sym_true] = ACTIONS(1138),
    [anon_sym_false] = ACTIONS(1138),
    [sym_this] = ACTIONS(1138),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [552] = {
    [sym_identifier] = ACTIONS(1182),
    [anon_sym_EQ] = ACTIONS(1182),
    [anon_sym_AT] = ACTIONS(1180),
    [anon_sym_LBRACK] = ACTIONS(1180),
    [anon_sym_is] = ACTIONS(1182),
    [anon_sym_let] = ACTIONS(1180),
    [anon_sym_var] = ACTIONS(1180),
    [anon_sym_LPAREN] = ACTIONS(1182),
    [anon_sym_DOT] = ACTIONS(1182),
    [anon_sym_LBRACE] = ACTIONS(1180),
    [anon_sym_SEMI] = ACTIONS(1180),
    [sym_error] = ACTIONS(1180),
    [sym_compile_intrinsic] = ACTIONS(1180),
    [anon_sym_compile_error] = ACTIONS(1180),
    [sym_location] = ACTIONS(1180),
    [anon_sym_DASH] = ACTIONS(1182),
    [anon_sym_not] = ACTIONS(1180),
    [anon_sym_DASH_TILDE] = ACTIONS(1180),
    [anon_sym_addressof] = ACTIONS(1180),
    [anon_sym_digestof] = ACTIONS(1180),
    [anon_sym_PLUS] = ACTIONS(1182),
    [anon_sym_STAR] = ACTIONS(1182),
    [anon_sym_SLASH] = ACTIONS(1182),
    [anon_sym_PERCENT] = ACTIONS(1182),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1182),
    [anon_sym_LT_LT] = ACTIONS(1182),
    [anon_sym_GT_GT] = ACTIONS(1182),
    [anon_sym_and] = ACTIONS(1180),
    [anon_sym_or] = ACTIONS(1180),
    [anon_sym_xor] = ACTIONS(1180),
    [anon_sym_isnt] = ACTIONS(1180),
    [anon_sym_EQ_EQ] = ACTIONS(1182),
    [anon_sym_BANG_EQ] = ACTIONS(1182),
    [anon_sym_GT] = ACTIONS(1182),
    [anon_sym_GT_EQ] = ACTIONS(1182),
    [anon_sym_LT_EQ] = ACTIONS(1182),
    [anon_sym_LT] = ACTIONS(1182),
    [anon_sym_PLUS_TILDE] = ACTIONS(1180),
    [anon_sym_STAR_TILDE] = ACTIONS(1180),
    [anon_sym_SLASH_TILDE] = ACTIONS(1180),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1180),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1180),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1180),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1180),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1180),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1180),
    [anon_sym_GT_TILDE] = ACTIONS(1180),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1180),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1180),
    [anon_sym_LT_TILDE] = ACTIONS(1180),
    [anon_sym_PLUS_QMARK] = ACTIONS(1180),
    [anon_sym_DASH_QMARK] = ACTIONS(1180),
    [anon_sym_STAR_QMARK] = ACTIONS(1180),
    [anon_sym_SLASH_QMARK] = ACTIONS(1180),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1180),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1180),
    [anon_sym_as] = ACTIONS(1180),
    [anon_sym_LPAREN2] = ACTIONS(1180),
    [anon_sym_DOT_GT] = ACTIONS(1180),
    [anon_sym_TILDE] = ACTIONS(1180),
    [anon_sym_end] = ACTIONS(1180),
    [anon_sym_if] = ACTIONS(1182),
    [anon_sym_ifdef] = ACTIONS(1180),
    [anon_sym_elseif] = ACTIONS(1180),
    [anon_sym_iftype] = ACTIONS(1180),
    [anon_sym_else] = ACTIONS(1182),
    [anon_sym_for] = ACTIONS(1180),
    [anon_sym_while] = ACTIONS(1180),
    [anon_sym_try] = ACTIONS(1180),
    [anon_sym_with] = ACTIONS(1180),
    [anon_sym_repeat] = ACTIONS(1180),
    [anon_sym_recover] = ACTIONS(1180),
    [anon_sym_match] = ACTIONS(1180),
    [anon_sym_return] = ACTIONS(1180),
    [anon_sym_continue] = ACTIONS(1180),
    [anon_sym_break] = ACTIONS(1180),
    [anon_sym_consume] = ACTIONS(1180),
    [anon_sym_object] = ACTIONS(1180),
    [sym_number] = ACTIONS(1182),
    [sym_float] = ACTIONS(1180),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1180),
    [anon_sym_SQUOTE] = ACTIONS(1180),
    [anon_sym_true] = ACTIONS(1180),
    [anon_sym_false] = ACTIONS(1180),
    [sym_this] = ACTIONS(1180),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [553] = {
    [sym_identifier] = ACTIONS(1194),
    [anon_sym_EQ] = ACTIONS(1194),
    [anon_sym_AT] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1192),
    [anon_sym_is] = ACTIONS(1194),
    [anon_sym_let] = ACTIONS(1192),
    [anon_sym_var] = ACTIONS(1192),
    [anon_sym_LPAREN] = ACTIONS(1194),
    [anon_sym_DOT] = ACTIONS(1194),
    [anon_sym_LBRACE] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1192),
    [sym_error] = ACTIONS(1192),
    [sym_compile_intrinsic] = ACTIONS(1192),
    [anon_sym_compile_error] = ACTIONS(1192),
    [sym_location] = ACTIONS(1192),
    [anon_sym_DASH] = ACTIONS(1194),
    [anon_sym_not] = ACTIONS(1192),
    [anon_sym_DASH_TILDE] = ACTIONS(1192),
    [anon_sym_addressof] = ACTIONS(1192),
    [anon_sym_digestof] = ACTIONS(1192),
    [anon_sym_PLUS] = ACTIONS(1194),
    [anon_sym_STAR] = ACTIONS(1194),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_PERCENT] = ACTIONS(1194),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1194),
    [anon_sym_LT_LT] = ACTIONS(1194),
    [anon_sym_GT_GT] = ACTIONS(1194),
    [anon_sym_and] = ACTIONS(1192),
    [anon_sym_or] = ACTIONS(1192),
    [anon_sym_xor] = ACTIONS(1192),
    [anon_sym_isnt] = ACTIONS(1192),
    [anon_sym_EQ_EQ] = ACTIONS(1194),
    [anon_sym_BANG_EQ] = ACTIONS(1194),
    [anon_sym_GT] = ACTIONS(1194),
    [anon_sym_GT_EQ] = ACTIONS(1194),
    [anon_sym_LT_EQ] = ACTIONS(1194),
    [anon_sym_LT] = ACTIONS(1194),
    [anon_sym_PLUS_TILDE] = ACTIONS(1192),
    [anon_sym_STAR_TILDE] = ACTIONS(1192),
    [anon_sym_SLASH_TILDE] = ACTIONS(1192),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1192),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1192),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1192),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1192),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1192),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1192),
    [anon_sym_GT_TILDE] = ACTIONS(1192),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1192),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1192),
    [anon_sym_LT_TILDE] = ACTIONS(1192),
    [anon_sym_PLUS_QMARK] = ACTIONS(1192),
    [anon_sym_DASH_QMARK] = ACTIONS(1192),
    [anon_sym_STAR_QMARK] = ACTIONS(1192),
    [anon_sym_SLASH_QMARK] = ACTIONS(1192),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1192),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1192),
    [anon_sym_as] = ACTIONS(1192),
    [anon_sym_LPAREN2] = ACTIONS(1192),
    [anon_sym_DOT_GT] = ACTIONS(1192),
    [anon_sym_TILDE] = ACTIONS(1192),
    [anon_sym_end] = ACTIONS(1192),
    [anon_sym_if] = ACTIONS(1194),
    [anon_sym_ifdef] = ACTIONS(1192),
    [anon_sym_elseif] = ACTIONS(1192),
    [anon_sym_iftype] = ACTIONS(1192),
    [anon_sym_else] = ACTIONS(1194),
    [anon_sym_for] = ACTIONS(1192),
    [anon_sym_while] = ACTIONS(1192),
    [anon_sym_try] = ACTIONS(1192),
    [anon_sym_with] = ACTIONS(1192),
    [anon_sym_repeat] = ACTIONS(1192),
    [anon_sym_recover] = ACTIONS(1192),
    [anon_sym_match] = ACTIONS(1192),
    [anon_sym_return] = ACTIONS(1192),
    [anon_sym_continue] = ACTIONS(1192),
    [anon_sym_break] = ACTIONS(1192),
    [anon_sym_consume] = ACTIONS(1192),
    [anon_sym_object] = ACTIONS(1192),
    [sym_number] = ACTIONS(1194),
    [sym_float] = ACTIONS(1192),
    [anon_sym_DQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1192),
    [anon_sym_SQUOTE] = ACTIONS(1192),
    [anon_sym_true] = ACTIONS(1192),
    [anon_sym_false] = ACTIONS(1192),
    [sym_this] = ACTIONS(1192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [554] = {
    [sym_identifier] = ACTIONS(1096),
    [anon_sym_EQ] = ACTIONS(1096),
    [anon_sym_AT] = ACTIONS(1094),
    [anon_sym_LBRACK] = ACTIONS(1094),
    [anon_sym_is] = ACTIONS(1096),
    [anon_sym_let] = ACTIONS(1094),
    [anon_sym_var] = ACTIONS(1094),
    [anon_sym_LPAREN] = ACTIONS(1096),
    [anon_sym_DOT] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(1094),
    [anon_sym_SEMI] = ACTIONS(1094),
    [sym_error] = ACTIONS(1094),
    [sym_compile_intrinsic] = ACTIONS(1094),
    [anon_sym_compile_error] = ACTIONS(1094),
    [sym_location] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1096),
    [anon_sym_not] = ACTIONS(1094),
    [anon_sym_DASH_TILDE] = ACTIONS(1094),
    [anon_sym_addressof] = ACTIONS(1094),
    [anon_sym_digestof] = ACTIONS(1094),
    [anon_sym_PLUS] = ACTIONS(1096),
    [anon_sym_STAR] = ACTIONS(1096),
    [anon_sym_SLASH] = ACTIONS(1096),
    [anon_sym_PERCENT] = ACTIONS(1096),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1096),
    [anon_sym_LT_LT] = ACTIONS(1096),
    [anon_sym_GT_GT] = ACTIONS(1096),
    [anon_sym_and] = ACTIONS(1094),
    [anon_sym_or] = ACTIONS(1094),
    [anon_sym_xor] = ACTIONS(1094),
    [anon_sym_isnt] = ACTIONS(1094),
    [anon_sym_EQ_EQ] = ACTIONS(1096),
    [anon_sym_BANG_EQ] = ACTIONS(1096),
    [anon_sym_GT] = ACTIONS(1096),
    [anon_sym_GT_EQ] = ACTIONS(1096),
    [anon_sym_LT_EQ] = ACTIONS(1096),
    [anon_sym_LT] = ACTIONS(1096),
    [anon_sym_PLUS_TILDE] = ACTIONS(1094),
    [anon_sym_STAR_TILDE] = ACTIONS(1094),
    [anon_sym_SLASH_TILDE] = ACTIONS(1094),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1094),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1094),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1094),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1094),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1094),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1094),
    [anon_sym_GT_TILDE] = ACTIONS(1094),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1094),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1094),
    [anon_sym_LT_TILDE] = ACTIONS(1094),
    [anon_sym_PLUS_QMARK] = ACTIONS(1094),
    [anon_sym_DASH_QMARK] = ACTIONS(1094),
    [anon_sym_STAR_QMARK] = ACTIONS(1094),
    [anon_sym_SLASH_QMARK] = ACTIONS(1094),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1094),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1094),
    [anon_sym_as] = ACTIONS(1094),
    [anon_sym_LPAREN2] = ACTIONS(1094),
    [anon_sym_DOT_GT] = ACTIONS(1094),
    [anon_sym_TILDE] = ACTIONS(1094),
    [anon_sym_end] = ACTIONS(1094),
    [anon_sym_if] = ACTIONS(1096),
    [anon_sym_ifdef] = ACTIONS(1094),
    [anon_sym_elseif] = ACTIONS(1094),
    [anon_sym_iftype] = ACTIONS(1094),
    [anon_sym_else] = ACTIONS(1096),
    [anon_sym_for] = ACTIONS(1094),
    [anon_sym_while] = ACTIONS(1094),
    [anon_sym_try] = ACTIONS(1094),
    [anon_sym_with] = ACTIONS(1094),
    [anon_sym_repeat] = ACTIONS(1094),
    [anon_sym_recover] = ACTIONS(1094),
    [anon_sym_match] = ACTIONS(1094),
    [anon_sym_return] = ACTIONS(1094),
    [anon_sym_continue] = ACTIONS(1094),
    [anon_sym_break] = ACTIONS(1094),
    [anon_sym_consume] = ACTIONS(1094),
    [anon_sym_object] = ACTIONS(1094),
    [sym_number] = ACTIONS(1096),
    [sym_float] = ACTIONS(1094),
    [anon_sym_DQUOTE] = ACTIONS(1096),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1094),
    [anon_sym_SQUOTE] = ACTIONS(1094),
    [anon_sym_true] = ACTIONS(1094),
    [anon_sym_false] = ACTIONS(1094),
    [sym_this] = ACTIONS(1094),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [555] = {
    [sym_identifier] = ACTIONS(1198),
    [anon_sym_EQ] = ACTIONS(1198),
    [anon_sym_AT] = ACTIONS(1196),
    [anon_sym_LBRACK] = ACTIONS(1196),
    [anon_sym_is] = ACTIONS(1198),
    [anon_sym_let] = ACTIONS(1196),
    [anon_sym_var] = ACTIONS(1196),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_DOT] = ACTIONS(1198),
    [anon_sym_LBRACE] = ACTIONS(1196),
    [anon_sym_SEMI] = ACTIONS(1196),
    [sym_error] = ACTIONS(1196),
    [sym_compile_intrinsic] = ACTIONS(1196),
    [anon_sym_compile_error] = ACTIONS(1196),
    [sym_location] = ACTIONS(1196),
    [anon_sym_DASH] = ACTIONS(1198),
    [anon_sym_not] = ACTIONS(1196),
    [anon_sym_DASH_TILDE] = ACTIONS(1196),
    [anon_sym_addressof] = ACTIONS(1196),
    [anon_sym_digestof] = ACTIONS(1196),
    [anon_sym_PLUS] = ACTIONS(1198),
    [anon_sym_STAR] = ACTIONS(1198),
    [anon_sym_SLASH] = ACTIONS(1198),
    [anon_sym_PERCENT] = ACTIONS(1198),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1198),
    [anon_sym_LT_LT] = ACTIONS(1198),
    [anon_sym_GT_GT] = ACTIONS(1198),
    [anon_sym_and] = ACTIONS(1196),
    [anon_sym_or] = ACTIONS(1196),
    [anon_sym_xor] = ACTIONS(1196),
    [anon_sym_isnt] = ACTIONS(1196),
    [anon_sym_EQ_EQ] = ACTIONS(1198),
    [anon_sym_BANG_EQ] = ACTIONS(1198),
    [anon_sym_GT] = ACTIONS(1198),
    [anon_sym_GT_EQ] = ACTIONS(1198),
    [anon_sym_LT_EQ] = ACTIONS(1198),
    [anon_sym_LT] = ACTIONS(1198),
    [anon_sym_PLUS_TILDE] = ACTIONS(1196),
    [anon_sym_STAR_TILDE] = ACTIONS(1196),
    [anon_sym_SLASH_TILDE] = ACTIONS(1196),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1196),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1196),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1196),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1196),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1196),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1196),
    [anon_sym_GT_TILDE] = ACTIONS(1196),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1196),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1196),
    [anon_sym_LT_TILDE] = ACTIONS(1196),
    [anon_sym_PLUS_QMARK] = ACTIONS(1196),
    [anon_sym_DASH_QMARK] = ACTIONS(1196),
    [anon_sym_STAR_QMARK] = ACTIONS(1196),
    [anon_sym_SLASH_QMARK] = ACTIONS(1196),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1196),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1196),
    [anon_sym_as] = ACTIONS(1196),
    [anon_sym_LPAREN2] = ACTIONS(1196),
    [anon_sym_DOT_GT] = ACTIONS(1196),
    [anon_sym_TILDE] = ACTIONS(1196),
    [anon_sym_end] = ACTIONS(1196),
    [anon_sym_if] = ACTIONS(1198),
    [anon_sym_ifdef] = ACTIONS(1196),
    [anon_sym_elseif] = ACTIONS(1196),
    [anon_sym_iftype] = ACTIONS(1196),
    [anon_sym_else] = ACTIONS(1198),
    [anon_sym_for] = ACTIONS(1196),
    [anon_sym_while] = ACTIONS(1196),
    [anon_sym_try] = ACTIONS(1196),
    [anon_sym_with] = ACTIONS(1196),
    [anon_sym_repeat] = ACTIONS(1196),
    [anon_sym_recover] = ACTIONS(1196),
    [anon_sym_match] = ACTIONS(1196),
    [anon_sym_return] = ACTIONS(1196),
    [anon_sym_continue] = ACTIONS(1196),
    [anon_sym_break] = ACTIONS(1196),
    [anon_sym_consume] = ACTIONS(1196),
    [anon_sym_object] = ACTIONS(1196),
    [sym_number] = ACTIONS(1198),
    [sym_float] = ACTIONS(1196),
    [anon_sym_DQUOTE] = ACTIONS(1198),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1196),
    [anon_sym_SQUOTE] = ACTIONS(1196),
    [anon_sym_true] = ACTIONS(1196),
    [anon_sym_false] = ACTIONS(1196),
    [sym_this] = ACTIONS(1196),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [556] = {
    [sym_identifier] = ACTIONS(1202),
    [anon_sym_EQ] = ACTIONS(1202),
    [anon_sym_AT] = ACTIONS(1200),
    [anon_sym_LBRACK] = ACTIONS(1200),
    [anon_sym_is] = ACTIONS(1202),
    [anon_sym_let] = ACTIONS(1200),
    [anon_sym_var] = ACTIONS(1200),
    [anon_sym_LPAREN] = ACTIONS(1202),
    [anon_sym_DOT] = ACTIONS(1202),
    [anon_sym_LBRACE] = ACTIONS(1200),
    [anon_sym_SEMI] = ACTIONS(1200),
    [sym_error] = ACTIONS(1200),
    [sym_compile_intrinsic] = ACTIONS(1200),
    [anon_sym_compile_error] = ACTIONS(1200),
    [sym_location] = ACTIONS(1200),
    [anon_sym_DASH] = ACTIONS(1202),
    [anon_sym_not] = ACTIONS(1200),
    [anon_sym_DASH_TILDE] = ACTIONS(1200),
    [anon_sym_addressof] = ACTIONS(1200),
    [anon_sym_digestof] = ACTIONS(1200),
    [anon_sym_PLUS] = ACTIONS(1202),
    [anon_sym_STAR] = ACTIONS(1202),
    [anon_sym_SLASH] = ACTIONS(1202),
    [anon_sym_PERCENT] = ACTIONS(1202),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1202),
    [anon_sym_LT_LT] = ACTIONS(1202),
    [anon_sym_GT_GT] = ACTIONS(1202),
    [anon_sym_and] = ACTIONS(1200),
    [anon_sym_or] = ACTIONS(1200),
    [anon_sym_xor] = ACTIONS(1200),
    [anon_sym_isnt] = ACTIONS(1200),
    [anon_sym_EQ_EQ] = ACTIONS(1202),
    [anon_sym_BANG_EQ] = ACTIONS(1202),
    [anon_sym_GT] = ACTIONS(1202),
    [anon_sym_GT_EQ] = ACTIONS(1202),
    [anon_sym_LT_EQ] = ACTIONS(1202),
    [anon_sym_LT] = ACTIONS(1202),
    [anon_sym_PLUS_TILDE] = ACTIONS(1200),
    [anon_sym_STAR_TILDE] = ACTIONS(1200),
    [anon_sym_SLASH_TILDE] = ACTIONS(1200),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1200),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1200),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1200),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1200),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1200),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1200),
    [anon_sym_GT_TILDE] = ACTIONS(1200),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1200),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1200),
    [anon_sym_LT_TILDE] = ACTIONS(1200),
    [anon_sym_PLUS_QMARK] = ACTIONS(1200),
    [anon_sym_DASH_QMARK] = ACTIONS(1200),
    [anon_sym_STAR_QMARK] = ACTIONS(1200),
    [anon_sym_SLASH_QMARK] = ACTIONS(1200),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1200),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1200),
    [anon_sym_as] = ACTIONS(1200),
    [anon_sym_LPAREN2] = ACTIONS(1200),
    [anon_sym_DOT_GT] = ACTIONS(1200),
    [anon_sym_TILDE] = ACTIONS(1200),
    [anon_sym_end] = ACTIONS(1200),
    [anon_sym_if] = ACTIONS(1202),
    [anon_sym_ifdef] = ACTIONS(1200),
    [anon_sym_elseif] = ACTIONS(1200),
    [anon_sym_iftype] = ACTIONS(1200),
    [anon_sym_else] = ACTIONS(1202),
    [anon_sym_for] = ACTIONS(1200),
    [anon_sym_while] = ACTIONS(1200),
    [anon_sym_try] = ACTIONS(1200),
    [anon_sym_with] = ACTIONS(1200),
    [anon_sym_repeat] = ACTIONS(1200),
    [anon_sym_recover] = ACTIONS(1200),
    [anon_sym_match] = ACTIONS(1200),
    [anon_sym_return] = ACTIONS(1200),
    [anon_sym_continue] = ACTIONS(1200),
    [anon_sym_break] = ACTIONS(1200),
    [anon_sym_consume] = ACTIONS(1200),
    [anon_sym_object] = ACTIONS(1200),
    [sym_number] = ACTIONS(1202),
    [sym_float] = ACTIONS(1200),
    [anon_sym_DQUOTE] = ACTIONS(1202),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1200),
    [anon_sym_SQUOTE] = ACTIONS(1200),
    [anon_sym_true] = ACTIONS(1200),
    [anon_sym_false] = ACTIONS(1200),
    [sym_this] = ACTIONS(1200),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [557] = {
    [sym_identifier] = ACTIONS(1206),
    [anon_sym_EQ] = ACTIONS(1206),
    [anon_sym_AT] = ACTIONS(1204),
    [anon_sym_LBRACK] = ACTIONS(1204),
    [anon_sym_is] = ACTIONS(1206),
    [anon_sym_let] = ACTIONS(1204),
    [anon_sym_var] = ACTIONS(1204),
    [anon_sym_LPAREN] = ACTIONS(1206),
    [anon_sym_DOT] = ACTIONS(1206),
    [anon_sym_LBRACE] = ACTIONS(1204),
    [anon_sym_SEMI] = ACTIONS(1204),
    [sym_error] = ACTIONS(1204),
    [sym_compile_intrinsic] = ACTIONS(1204),
    [anon_sym_compile_error] = ACTIONS(1204),
    [sym_location] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1206),
    [anon_sym_not] = ACTIONS(1204),
    [anon_sym_DASH_TILDE] = ACTIONS(1204),
    [anon_sym_addressof] = ACTIONS(1204),
    [anon_sym_digestof] = ACTIONS(1204),
    [anon_sym_PLUS] = ACTIONS(1206),
    [anon_sym_STAR] = ACTIONS(1206),
    [anon_sym_SLASH] = ACTIONS(1206),
    [anon_sym_PERCENT] = ACTIONS(1206),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1206),
    [anon_sym_LT_LT] = ACTIONS(1206),
    [anon_sym_GT_GT] = ACTIONS(1206),
    [anon_sym_and] = ACTIONS(1204),
    [anon_sym_or] = ACTIONS(1204),
    [anon_sym_xor] = ACTIONS(1204),
    [anon_sym_isnt] = ACTIONS(1204),
    [anon_sym_EQ_EQ] = ACTIONS(1206),
    [anon_sym_BANG_EQ] = ACTIONS(1206),
    [anon_sym_GT] = ACTIONS(1206),
    [anon_sym_GT_EQ] = ACTIONS(1206),
    [anon_sym_LT_EQ] = ACTIONS(1206),
    [anon_sym_LT] = ACTIONS(1206),
    [anon_sym_PLUS_TILDE] = ACTIONS(1204),
    [anon_sym_STAR_TILDE] = ACTIONS(1204),
    [anon_sym_SLASH_TILDE] = ACTIONS(1204),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1204),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1204),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1204),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1204),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1204),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1204),
    [anon_sym_GT_TILDE] = ACTIONS(1204),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1204),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1204),
    [anon_sym_LT_TILDE] = ACTIONS(1204),
    [anon_sym_PLUS_QMARK] = ACTIONS(1204),
    [anon_sym_DASH_QMARK] = ACTIONS(1204),
    [anon_sym_STAR_QMARK] = ACTIONS(1204),
    [anon_sym_SLASH_QMARK] = ACTIONS(1204),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1204),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1204),
    [anon_sym_as] = ACTIONS(1204),
    [anon_sym_LPAREN2] = ACTIONS(1204),
    [anon_sym_DOT_GT] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1204),
    [anon_sym_end] = ACTIONS(1204),
    [anon_sym_if] = ACTIONS(1206),
    [anon_sym_ifdef] = ACTIONS(1204),
    [anon_sym_elseif] = ACTIONS(1204),
    [anon_sym_iftype] = ACTIONS(1204),
    [anon_sym_else] = ACTIONS(1206),
    [anon_sym_for] = ACTIONS(1204),
    [anon_sym_while] = ACTIONS(1204),
    [anon_sym_try] = ACTIONS(1204),
    [anon_sym_with] = ACTIONS(1204),
    [anon_sym_repeat] = ACTIONS(1204),
    [anon_sym_recover] = ACTIONS(1204),
    [anon_sym_match] = ACTIONS(1204),
    [anon_sym_return] = ACTIONS(1204),
    [anon_sym_continue] = ACTIONS(1204),
    [anon_sym_break] = ACTIONS(1204),
    [anon_sym_consume] = ACTIONS(1204),
    [anon_sym_object] = ACTIONS(1204),
    [sym_number] = ACTIONS(1206),
    [sym_float] = ACTIONS(1204),
    [anon_sym_DQUOTE] = ACTIONS(1206),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1204),
    [anon_sym_SQUOTE] = ACTIONS(1204),
    [anon_sym_true] = ACTIONS(1204),
    [anon_sym_false] = ACTIONS(1204),
    [sym_this] = ACTIONS(1204),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [558] = {
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_EQ] = ACTIONS(1214),
    [anon_sym_AT] = ACTIONS(1212),
    [anon_sym_LBRACK] = ACTIONS(1212),
    [anon_sym_is] = ACTIONS(1214),
    [anon_sym_let] = ACTIONS(1212),
    [anon_sym_var] = ACTIONS(1212),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_DOT] = ACTIONS(1214),
    [anon_sym_LBRACE] = ACTIONS(1212),
    [anon_sym_SEMI] = ACTIONS(1212),
    [sym_error] = ACTIONS(1212),
    [sym_compile_intrinsic] = ACTIONS(1212),
    [anon_sym_compile_error] = ACTIONS(1212),
    [sym_location] = ACTIONS(1212),
    [anon_sym_DASH] = ACTIONS(1214),
    [anon_sym_not] = ACTIONS(1212),
    [anon_sym_DASH_TILDE] = ACTIONS(1212),
    [anon_sym_addressof] = ACTIONS(1212),
    [anon_sym_digestof] = ACTIONS(1212),
    [anon_sym_PLUS] = ACTIONS(1214),
    [anon_sym_STAR] = ACTIONS(1214),
    [anon_sym_SLASH] = ACTIONS(1214),
    [anon_sym_PERCENT] = ACTIONS(1214),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1214),
    [anon_sym_LT_LT] = ACTIONS(1214),
    [anon_sym_GT_GT] = ACTIONS(1214),
    [anon_sym_and] = ACTIONS(1212),
    [anon_sym_or] = ACTIONS(1212),
    [anon_sym_xor] = ACTIONS(1212),
    [anon_sym_isnt] = ACTIONS(1212),
    [anon_sym_EQ_EQ] = ACTIONS(1214),
    [anon_sym_BANG_EQ] = ACTIONS(1214),
    [anon_sym_GT] = ACTIONS(1214),
    [anon_sym_GT_EQ] = ACTIONS(1214),
    [anon_sym_LT_EQ] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1214),
    [anon_sym_PLUS_TILDE] = ACTIONS(1212),
    [anon_sym_STAR_TILDE] = ACTIONS(1212),
    [anon_sym_SLASH_TILDE] = ACTIONS(1212),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1212),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1212),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1212),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1212),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1212),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1212),
    [anon_sym_GT_TILDE] = ACTIONS(1212),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1212),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1212),
    [anon_sym_LT_TILDE] = ACTIONS(1212),
    [anon_sym_PLUS_QMARK] = ACTIONS(1212),
    [anon_sym_DASH_QMARK] = ACTIONS(1212),
    [anon_sym_STAR_QMARK] = ACTIONS(1212),
    [anon_sym_SLASH_QMARK] = ACTIONS(1212),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1212),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1212),
    [anon_sym_as] = ACTIONS(1212),
    [anon_sym_LPAREN2] = ACTIONS(1212),
    [anon_sym_DOT_GT] = ACTIONS(1212),
    [anon_sym_TILDE] = ACTIONS(1212),
    [anon_sym_end] = ACTIONS(1212),
    [anon_sym_if] = ACTIONS(1214),
    [anon_sym_ifdef] = ACTIONS(1212),
    [anon_sym_elseif] = ACTIONS(1212),
    [anon_sym_iftype] = ACTIONS(1212),
    [anon_sym_else] = ACTIONS(1214),
    [anon_sym_for] = ACTIONS(1212),
    [anon_sym_while] = ACTIONS(1212),
    [anon_sym_try] = ACTIONS(1212),
    [anon_sym_with] = ACTIONS(1212),
    [anon_sym_repeat] = ACTIONS(1212),
    [anon_sym_recover] = ACTIONS(1212),
    [anon_sym_match] = ACTIONS(1212),
    [anon_sym_return] = ACTIONS(1212),
    [anon_sym_continue] = ACTIONS(1212),
    [anon_sym_break] = ACTIONS(1212),
    [anon_sym_consume] = ACTIONS(1212),
    [anon_sym_object] = ACTIONS(1212),
    [sym_number] = ACTIONS(1214),
    [sym_float] = ACTIONS(1212),
    [anon_sym_DQUOTE] = ACTIONS(1214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1212),
    [anon_sym_SQUOTE] = ACTIONS(1212),
    [anon_sym_true] = ACTIONS(1212),
    [anon_sym_false] = ACTIONS(1212),
    [sym_this] = ACTIONS(1212),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [559] = {
    [sym_identifier] = ACTIONS(1218),
    [anon_sym_EQ] = ACTIONS(1218),
    [anon_sym_AT] = ACTIONS(1216),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_is] = ACTIONS(1218),
    [anon_sym_let] = ACTIONS(1216),
    [anon_sym_var] = ACTIONS(1216),
    [anon_sym_LPAREN] = ACTIONS(1218),
    [anon_sym_DOT] = ACTIONS(1218),
    [anon_sym_LBRACE] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1216),
    [sym_error] = ACTIONS(1216),
    [sym_compile_intrinsic] = ACTIONS(1216),
    [anon_sym_compile_error] = ACTIONS(1216),
    [sym_location] = ACTIONS(1216),
    [anon_sym_DASH] = ACTIONS(1218),
    [anon_sym_not] = ACTIONS(1216),
    [anon_sym_DASH_TILDE] = ACTIONS(1216),
    [anon_sym_addressof] = ACTIONS(1216),
    [anon_sym_digestof] = ACTIONS(1216),
    [anon_sym_PLUS] = ACTIONS(1218),
    [anon_sym_STAR] = ACTIONS(1218),
    [anon_sym_SLASH] = ACTIONS(1218),
    [anon_sym_PERCENT] = ACTIONS(1218),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1218),
    [anon_sym_LT_LT] = ACTIONS(1218),
    [anon_sym_GT_GT] = ACTIONS(1218),
    [anon_sym_and] = ACTIONS(1216),
    [anon_sym_or] = ACTIONS(1216),
    [anon_sym_xor] = ACTIONS(1216),
    [anon_sym_isnt] = ACTIONS(1216),
    [anon_sym_EQ_EQ] = ACTIONS(1218),
    [anon_sym_BANG_EQ] = ACTIONS(1218),
    [anon_sym_GT] = ACTIONS(1218),
    [anon_sym_GT_EQ] = ACTIONS(1218),
    [anon_sym_LT_EQ] = ACTIONS(1218),
    [anon_sym_LT] = ACTIONS(1218),
    [anon_sym_PLUS_TILDE] = ACTIONS(1216),
    [anon_sym_STAR_TILDE] = ACTIONS(1216),
    [anon_sym_SLASH_TILDE] = ACTIONS(1216),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1216),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1216),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1216),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1216),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1216),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1216),
    [anon_sym_GT_TILDE] = ACTIONS(1216),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1216),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1216),
    [anon_sym_LT_TILDE] = ACTIONS(1216),
    [anon_sym_PLUS_QMARK] = ACTIONS(1216),
    [anon_sym_DASH_QMARK] = ACTIONS(1216),
    [anon_sym_STAR_QMARK] = ACTIONS(1216),
    [anon_sym_SLASH_QMARK] = ACTIONS(1216),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1216),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1216),
    [anon_sym_as] = ACTIONS(1216),
    [anon_sym_LPAREN2] = ACTIONS(1216),
    [anon_sym_DOT_GT] = ACTIONS(1216),
    [anon_sym_TILDE] = ACTIONS(1216),
    [anon_sym_end] = ACTIONS(1216),
    [anon_sym_if] = ACTIONS(1218),
    [anon_sym_ifdef] = ACTIONS(1216),
    [anon_sym_elseif] = ACTIONS(1216),
    [anon_sym_iftype] = ACTIONS(1216),
    [anon_sym_else] = ACTIONS(1218),
    [anon_sym_for] = ACTIONS(1216),
    [anon_sym_while] = ACTIONS(1216),
    [anon_sym_try] = ACTIONS(1216),
    [anon_sym_with] = ACTIONS(1216),
    [anon_sym_repeat] = ACTIONS(1216),
    [anon_sym_recover] = ACTIONS(1216),
    [anon_sym_match] = ACTIONS(1216),
    [anon_sym_return] = ACTIONS(1216),
    [anon_sym_continue] = ACTIONS(1216),
    [anon_sym_break] = ACTIONS(1216),
    [anon_sym_consume] = ACTIONS(1216),
    [anon_sym_object] = ACTIONS(1216),
    [sym_number] = ACTIONS(1218),
    [sym_float] = ACTIONS(1216),
    [anon_sym_DQUOTE] = ACTIONS(1218),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1216),
    [anon_sym_SQUOTE] = ACTIONS(1216),
    [anon_sym_true] = ACTIONS(1216),
    [anon_sym_false] = ACTIONS(1216),
    [sym_this] = ACTIONS(1216),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [560] = {
    [sym_identifier] = ACTIONS(994),
    [anon_sym_EQ] = ACTIONS(994),
    [anon_sym_AT] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(992),
    [anon_sym_is] = ACTIONS(994),
    [anon_sym_let] = ACTIONS(992),
    [anon_sym_var] = ACTIONS(992),
    [anon_sym_LPAREN] = ACTIONS(994),
    [anon_sym_DOT] = ACTIONS(994),
    [anon_sym_LBRACE] = ACTIONS(992),
    [anon_sym_SEMI] = ACTIONS(992),
    [sym_error] = ACTIONS(992),
    [sym_compile_intrinsic] = ACTIONS(992),
    [anon_sym_compile_error] = ACTIONS(992),
    [sym_location] = ACTIONS(992),
    [anon_sym_DASH] = ACTIONS(994),
    [anon_sym_not] = ACTIONS(992),
    [anon_sym_DASH_TILDE] = ACTIONS(992),
    [anon_sym_addressof] = ACTIONS(992),
    [anon_sym_digestof] = ACTIONS(992),
    [anon_sym_PLUS] = ACTIONS(994),
    [anon_sym_STAR] = ACTIONS(994),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_PERCENT] = ACTIONS(994),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(994),
    [anon_sym_LT_LT] = ACTIONS(994),
    [anon_sym_GT_GT] = ACTIONS(994),
    [anon_sym_and] = ACTIONS(992),
    [anon_sym_or] = ACTIONS(992),
    [anon_sym_xor] = ACTIONS(992),
    [anon_sym_isnt] = ACTIONS(992),
    [anon_sym_EQ_EQ] = ACTIONS(994),
    [anon_sym_BANG_EQ] = ACTIONS(994),
    [anon_sym_GT] = ACTIONS(994),
    [anon_sym_GT_EQ] = ACTIONS(994),
    [anon_sym_LT_EQ] = ACTIONS(994),
    [anon_sym_LT] = ACTIONS(994),
    [anon_sym_PLUS_TILDE] = ACTIONS(992),
    [anon_sym_STAR_TILDE] = ACTIONS(992),
    [anon_sym_SLASH_TILDE] = ACTIONS(992),
    [anon_sym_PERCENT_TILDE] = ACTIONS(992),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(992),
    [anon_sym_LT_LT_TILDE] = ACTIONS(992),
    [anon_sym_GT_GT_TILDE] = ACTIONS(992),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(992),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(992),
    [anon_sym_GT_TILDE] = ACTIONS(992),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(992),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(992),
    [anon_sym_LT_TILDE] = ACTIONS(992),
    [anon_sym_PLUS_QMARK] = ACTIONS(992),
    [anon_sym_DASH_QMARK] = ACTIONS(992),
    [anon_sym_STAR_QMARK] = ACTIONS(992),
    [anon_sym_SLASH_QMARK] = ACTIONS(992),
    [anon_sym_PERCENT_QMARK] = ACTIONS(992),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(992),
    [anon_sym_as] = ACTIONS(992),
    [anon_sym_LPAREN2] = ACTIONS(992),
    [anon_sym_DOT_GT] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(992),
    [anon_sym_end] = ACTIONS(992),
    [anon_sym_if] = ACTIONS(994),
    [anon_sym_ifdef] = ACTIONS(992),
    [anon_sym_elseif] = ACTIONS(992),
    [anon_sym_iftype] = ACTIONS(992),
    [anon_sym_else] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(992),
    [anon_sym_while] = ACTIONS(992),
    [anon_sym_try] = ACTIONS(992),
    [anon_sym_with] = ACTIONS(992),
    [anon_sym_repeat] = ACTIONS(992),
    [anon_sym_recover] = ACTIONS(992),
    [anon_sym_match] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(992),
    [anon_sym_continue] = ACTIONS(992),
    [anon_sym_break] = ACTIONS(992),
    [anon_sym_consume] = ACTIONS(992),
    [anon_sym_object] = ACTIONS(992),
    [sym_number] = ACTIONS(994),
    [sym_float] = ACTIONS(992),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(992),
    [anon_sym_SQUOTE] = ACTIONS(992),
    [anon_sym_true] = ACTIONS(992),
    [anon_sym_false] = ACTIONS(992),
    [sym_this] = ACTIONS(992),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [561] = {
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_EQ] = ACTIONS(1222),
    [anon_sym_AT] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1220),
    [anon_sym_is] = ACTIONS(1222),
    [anon_sym_let] = ACTIONS(1220),
    [anon_sym_var] = ACTIONS(1220),
    [anon_sym_LPAREN] = ACTIONS(1222),
    [anon_sym_DOT] = ACTIONS(1222),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_SEMI] = ACTIONS(1220),
    [sym_error] = ACTIONS(1220),
    [sym_compile_intrinsic] = ACTIONS(1220),
    [anon_sym_compile_error] = ACTIONS(1220),
    [sym_location] = ACTIONS(1220),
    [anon_sym_DASH] = ACTIONS(1222),
    [anon_sym_not] = ACTIONS(1220),
    [anon_sym_DASH_TILDE] = ACTIONS(1220),
    [anon_sym_addressof] = ACTIONS(1220),
    [anon_sym_digestof] = ACTIONS(1220),
    [anon_sym_PLUS] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(1222),
    [anon_sym_SLASH] = ACTIONS(1222),
    [anon_sym_PERCENT] = ACTIONS(1222),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1222),
    [anon_sym_LT_LT] = ACTIONS(1222),
    [anon_sym_GT_GT] = ACTIONS(1222),
    [anon_sym_and] = ACTIONS(1220),
    [anon_sym_or] = ACTIONS(1220),
    [anon_sym_xor] = ACTIONS(1220),
    [anon_sym_isnt] = ACTIONS(1220),
    [anon_sym_EQ_EQ] = ACTIONS(1222),
    [anon_sym_BANG_EQ] = ACTIONS(1222),
    [anon_sym_GT] = ACTIONS(1222),
    [anon_sym_GT_EQ] = ACTIONS(1222),
    [anon_sym_LT_EQ] = ACTIONS(1222),
    [anon_sym_LT] = ACTIONS(1222),
    [anon_sym_PLUS_TILDE] = ACTIONS(1220),
    [anon_sym_STAR_TILDE] = ACTIONS(1220),
    [anon_sym_SLASH_TILDE] = ACTIONS(1220),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1220),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1220),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1220),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1220),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1220),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1220),
    [anon_sym_GT_TILDE] = ACTIONS(1220),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1220),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1220),
    [anon_sym_LT_TILDE] = ACTIONS(1220),
    [anon_sym_PLUS_QMARK] = ACTIONS(1220),
    [anon_sym_DASH_QMARK] = ACTIONS(1220),
    [anon_sym_STAR_QMARK] = ACTIONS(1220),
    [anon_sym_SLASH_QMARK] = ACTIONS(1220),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1220),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1220),
    [anon_sym_as] = ACTIONS(1220),
    [anon_sym_LPAREN2] = ACTIONS(1220),
    [anon_sym_DOT_GT] = ACTIONS(1220),
    [anon_sym_TILDE] = ACTIONS(1220),
    [anon_sym_end] = ACTIONS(1220),
    [anon_sym_if] = ACTIONS(1222),
    [anon_sym_ifdef] = ACTIONS(1220),
    [anon_sym_elseif] = ACTIONS(1220),
    [anon_sym_iftype] = ACTIONS(1220),
    [anon_sym_else] = ACTIONS(1222),
    [anon_sym_for] = ACTIONS(1220),
    [anon_sym_while] = ACTIONS(1220),
    [anon_sym_try] = ACTIONS(1220),
    [anon_sym_with] = ACTIONS(1220),
    [anon_sym_repeat] = ACTIONS(1220),
    [anon_sym_recover] = ACTIONS(1220),
    [anon_sym_match] = ACTIONS(1220),
    [anon_sym_return] = ACTIONS(1220),
    [anon_sym_continue] = ACTIONS(1220),
    [anon_sym_break] = ACTIONS(1220),
    [anon_sym_consume] = ACTIONS(1220),
    [anon_sym_object] = ACTIONS(1220),
    [sym_number] = ACTIONS(1222),
    [sym_float] = ACTIONS(1220),
    [anon_sym_DQUOTE] = ACTIONS(1222),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1220),
    [anon_sym_SQUOTE] = ACTIONS(1220),
    [anon_sym_true] = ACTIONS(1220),
    [anon_sym_false] = ACTIONS(1220),
    [sym_this] = ACTIONS(1220),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [562] = {
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_EQ] = ACTIONS(1226),
    [anon_sym_AT] = ACTIONS(1224),
    [anon_sym_LBRACK] = ACTIONS(1224),
    [anon_sym_is] = ACTIONS(1226),
    [anon_sym_let] = ACTIONS(1224),
    [anon_sym_var] = ACTIONS(1224),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_DOT] = ACTIONS(1226),
    [anon_sym_LBRACE] = ACTIONS(1224),
    [anon_sym_SEMI] = ACTIONS(1224),
    [sym_error] = ACTIONS(1224),
    [sym_compile_intrinsic] = ACTIONS(1224),
    [anon_sym_compile_error] = ACTIONS(1224),
    [sym_location] = ACTIONS(1224),
    [anon_sym_DASH] = ACTIONS(1226),
    [anon_sym_not] = ACTIONS(1224),
    [anon_sym_DASH_TILDE] = ACTIONS(1224),
    [anon_sym_addressof] = ACTIONS(1224),
    [anon_sym_digestof] = ACTIONS(1224),
    [anon_sym_PLUS] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(1226),
    [anon_sym_SLASH] = ACTIONS(1226),
    [anon_sym_PERCENT] = ACTIONS(1226),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1226),
    [anon_sym_LT_LT] = ACTIONS(1226),
    [anon_sym_GT_GT] = ACTIONS(1226),
    [anon_sym_and] = ACTIONS(1224),
    [anon_sym_or] = ACTIONS(1224),
    [anon_sym_xor] = ACTIONS(1224),
    [anon_sym_isnt] = ACTIONS(1224),
    [anon_sym_EQ_EQ] = ACTIONS(1226),
    [anon_sym_BANG_EQ] = ACTIONS(1226),
    [anon_sym_GT] = ACTIONS(1226),
    [anon_sym_GT_EQ] = ACTIONS(1226),
    [anon_sym_LT_EQ] = ACTIONS(1226),
    [anon_sym_LT] = ACTIONS(1226),
    [anon_sym_PLUS_TILDE] = ACTIONS(1224),
    [anon_sym_STAR_TILDE] = ACTIONS(1224),
    [anon_sym_SLASH_TILDE] = ACTIONS(1224),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1224),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1224),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1224),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1224),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1224),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1224),
    [anon_sym_GT_TILDE] = ACTIONS(1224),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1224),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1224),
    [anon_sym_LT_TILDE] = ACTIONS(1224),
    [anon_sym_PLUS_QMARK] = ACTIONS(1224),
    [anon_sym_DASH_QMARK] = ACTIONS(1224),
    [anon_sym_STAR_QMARK] = ACTIONS(1224),
    [anon_sym_SLASH_QMARK] = ACTIONS(1224),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1224),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1224),
    [anon_sym_as] = ACTIONS(1224),
    [anon_sym_LPAREN2] = ACTIONS(1224),
    [anon_sym_DOT_GT] = ACTIONS(1224),
    [anon_sym_TILDE] = ACTIONS(1224),
    [anon_sym_end] = ACTIONS(1224),
    [anon_sym_if] = ACTIONS(1226),
    [anon_sym_ifdef] = ACTIONS(1224),
    [anon_sym_elseif] = ACTIONS(1224),
    [anon_sym_iftype] = ACTIONS(1224),
    [anon_sym_else] = ACTIONS(1226),
    [anon_sym_for] = ACTIONS(1224),
    [anon_sym_while] = ACTIONS(1224),
    [anon_sym_try] = ACTIONS(1224),
    [anon_sym_with] = ACTIONS(1224),
    [anon_sym_repeat] = ACTIONS(1224),
    [anon_sym_recover] = ACTIONS(1224),
    [anon_sym_match] = ACTIONS(1224),
    [anon_sym_return] = ACTIONS(1224),
    [anon_sym_continue] = ACTIONS(1224),
    [anon_sym_break] = ACTIONS(1224),
    [anon_sym_consume] = ACTIONS(1224),
    [anon_sym_object] = ACTIONS(1224),
    [sym_number] = ACTIONS(1226),
    [sym_float] = ACTIONS(1224),
    [anon_sym_DQUOTE] = ACTIONS(1226),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1224),
    [anon_sym_SQUOTE] = ACTIONS(1224),
    [anon_sym_true] = ACTIONS(1224),
    [anon_sym_false] = ACTIONS(1224),
    [sym_this] = ACTIONS(1224),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [563] = {
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_EQ] = ACTIONS(1302),
    [anon_sym_AT] = ACTIONS(1300),
    [anon_sym_LBRACK] = ACTIONS(1300),
    [anon_sym_is] = ACTIONS(1302),
    [anon_sym_let] = ACTIONS(1300),
    [anon_sym_var] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(1302),
    [anon_sym_DOT] = ACTIONS(1302),
    [anon_sym_LBRACE] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(1300),
    [sym_error] = ACTIONS(1300),
    [sym_compile_intrinsic] = ACTIONS(1300),
    [anon_sym_compile_error] = ACTIONS(1300),
    [sym_location] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1302),
    [anon_sym_not] = ACTIONS(1300),
    [anon_sym_DASH_TILDE] = ACTIONS(1300),
    [anon_sym_addressof] = ACTIONS(1300),
    [anon_sym_digestof] = ACTIONS(1300),
    [anon_sym_PLUS] = ACTIONS(1302),
    [anon_sym_STAR] = ACTIONS(1302),
    [anon_sym_SLASH] = ACTIONS(1302),
    [anon_sym_PERCENT] = ACTIONS(1302),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1302),
    [anon_sym_LT_LT] = ACTIONS(1302),
    [anon_sym_GT_GT] = ACTIONS(1302),
    [anon_sym_and] = ACTIONS(1300),
    [anon_sym_or] = ACTIONS(1300),
    [anon_sym_xor] = ACTIONS(1300),
    [anon_sym_isnt] = ACTIONS(1300),
    [anon_sym_EQ_EQ] = ACTIONS(1302),
    [anon_sym_BANG_EQ] = ACTIONS(1302),
    [anon_sym_GT] = ACTIONS(1302),
    [anon_sym_GT_EQ] = ACTIONS(1302),
    [anon_sym_LT_EQ] = ACTIONS(1302),
    [anon_sym_LT] = ACTIONS(1302),
    [anon_sym_PLUS_TILDE] = ACTIONS(1300),
    [anon_sym_STAR_TILDE] = ACTIONS(1300),
    [anon_sym_SLASH_TILDE] = ACTIONS(1300),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1300),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1300),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1300),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1300),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1300),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1300),
    [anon_sym_GT_TILDE] = ACTIONS(1300),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1300),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1300),
    [anon_sym_LT_TILDE] = ACTIONS(1300),
    [anon_sym_PLUS_QMARK] = ACTIONS(1300),
    [anon_sym_DASH_QMARK] = ACTIONS(1300),
    [anon_sym_STAR_QMARK] = ACTIONS(1300),
    [anon_sym_SLASH_QMARK] = ACTIONS(1300),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1300),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1300),
    [anon_sym_as] = ACTIONS(1300),
    [anon_sym_LPAREN2] = ACTIONS(1300),
    [anon_sym_DOT_GT] = ACTIONS(1300),
    [anon_sym_TILDE] = ACTIONS(1300),
    [anon_sym_end] = ACTIONS(1300),
    [anon_sym_if] = ACTIONS(1302),
    [anon_sym_ifdef] = ACTIONS(1300),
    [anon_sym_elseif] = ACTIONS(1300),
    [anon_sym_iftype] = ACTIONS(1300),
    [anon_sym_else] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1300),
    [anon_sym_while] = ACTIONS(1300),
    [anon_sym_try] = ACTIONS(1300),
    [anon_sym_with] = ACTIONS(1300),
    [anon_sym_repeat] = ACTIONS(1300),
    [anon_sym_recover] = ACTIONS(1300),
    [anon_sym_match] = ACTIONS(1300),
    [anon_sym_return] = ACTIONS(1300),
    [anon_sym_continue] = ACTIONS(1300),
    [anon_sym_break] = ACTIONS(1300),
    [anon_sym_consume] = ACTIONS(1300),
    [anon_sym_object] = ACTIONS(1300),
    [sym_number] = ACTIONS(1302),
    [sym_float] = ACTIONS(1300),
    [anon_sym_DQUOTE] = ACTIONS(1302),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1300),
    [anon_sym_SQUOTE] = ACTIONS(1300),
    [anon_sym_true] = ACTIONS(1300),
    [anon_sym_false] = ACTIONS(1300),
    [sym_this] = ACTIONS(1300),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [564] = {
    [sym_identifier] = ACTIONS(1088),
    [anon_sym_EQ] = ACTIONS(1088),
    [anon_sym_AT] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_is] = ACTIONS(1088),
    [anon_sym_let] = ACTIONS(1086),
    [anon_sym_var] = ACTIONS(1086),
    [anon_sym_LPAREN] = ACTIONS(1088),
    [anon_sym_DOT] = ACTIONS(1088),
    [anon_sym_LBRACE] = ACTIONS(1086),
    [anon_sym_SEMI] = ACTIONS(1086),
    [sym_error] = ACTIONS(1086),
    [sym_compile_intrinsic] = ACTIONS(1086),
    [anon_sym_compile_error] = ACTIONS(1086),
    [sym_location] = ACTIONS(1086),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_not] = ACTIONS(1086),
    [anon_sym_DASH_TILDE] = ACTIONS(1086),
    [anon_sym_addressof] = ACTIONS(1086),
    [anon_sym_digestof] = ACTIONS(1086),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_STAR] = ACTIONS(1088),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_PERCENT] = ACTIONS(1088),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1088),
    [anon_sym_LT_LT] = ACTIONS(1088),
    [anon_sym_GT_GT] = ACTIONS(1088),
    [anon_sym_and] = ACTIONS(1086),
    [anon_sym_or] = ACTIONS(1086),
    [anon_sym_xor] = ACTIONS(1086),
    [anon_sym_isnt] = ACTIONS(1086),
    [anon_sym_EQ_EQ] = ACTIONS(1088),
    [anon_sym_BANG_EQ] = ACTIONS(1088),
    [anon_sym_GT] = ACTIONS(1088),
    [anon_sym_GT_EQ] = ACTIONS(1088),
    [anon_sym_LT_EQ] = ACTIONS(1088),
    [anon_sym_LT] = ACTIONS(1088),
    [anon_sym_PLUS_TILDE] = ACTIONS(1086),
    [anon_sym_STAR_TILDE] = ACTIONS(1086),
    [anon_sym_SLASH_TILDE] = ACTIONS(1086),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1086),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1086),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1086),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1086),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1086),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1086),
    [anon_sym_GT_TILDE] = ACTIONS(1086),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1086),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1086),
    [anon_sym_LT_TILDE] = ACTIONS(1086),
    [anon_sym_PLUS_QMARK] = ACTIONS(1086),
    [anon_sym_DASH_QMARK] = ACTIONS(1086),
    [anon_sym_STAR_QMARK] = ACTIONS(1086),
    [anon_sym_SLASH_QMARK] = ACTIONS(1086),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1086),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1086),
    [anon_sym_as] = ACTIONS(1086),
    [anon_sym_LPAREN2] = ACTIONS(1086),
    [anon_sym_DOT_GT] = ACTIONS(1086),
    [anon_sym_TILDE] = ACTIONS(1086),
    [anon_sym_end] = ACTIONS(1086),
    [anon_sym_if] = ACTIONS(1088),
    [anon_sym_ifdef] = ACTIONS(1086),
    [anon_sym_elseif] = ACTIONS(1086),
    [anon_sym_iftype] = ACTIONS(1086),
    [anon_sym_else] = ACTIONS(1088),
    [anon_sym_for] = ACTIONS(1086),
    [anon_sym_while] = ACTIONS(1086),
    [anon_sym_try] = ACTIONS(1086),
    [anon_sym_with] = ACTIONS(1086),
    [anon_sym_repeat] = ACTIONS(1086),
    [anon_sym_recover] = ACTIONS(1086),
    [anon_sym_match] = ACTIONS(1086),
    [anon_sym_return] = ACTIONS(1086),
    [anon_sym_continue] = ACTIONS(1086),
    [anon_sym_break] = ACTIONS(1086),
    [anon_sym_consume] = ACTIONS(1086),
    [anon_sym_object] = ACTIONS(1086),
    [sym_number] = ACTIONS(1088),
    [sym_float] = ACTIONS(1086),
    [anon_sym_DQUOTE] = ACTIONS(1088),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1086),
    [anon_sym_true] = ACTIONS(1086),
    [anon_sym_false] = ACTIONS(1086),
    [sym_this] = ACTIONS(1086),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [565] = {
    [sym_identifier] = ACTIONS(1294),
    [anon_sym_EQ] = ACTIONS(1294),
    [anon_sym_AT] = ACTIONS(1292),
    [anon_sym_LBRACK] = ACTIONS(1292),
    [anon_sym_is] = ACTIONS(1294),
    [anon_sym_let] = ACTIONS(1292),
    [anon_sym_var] = ACTIONS(1292),
    [anon_sym_LPAREN] = ACTIONS(1294),
    [anon_sym_DOT] = ACTIONS(1294),
    [anon_sym_LBRACE] = ACTIONS(1292),
    [anon_sym_SEMI] = ACTIONS(1292),
    [sym_error] = ACTIONS(1292),
    [sym_compile_intrinsic] = ACTIONS(1292),
    [anon_sym_compile_error] = ACTIONS(1292),
    [sym_location] = ACTIONS(1292),
    [anon_sym_DASH] = ACTIONS(1294),
    [anon_sym_not] = ACTIONS(1292),
    [anon_sym_DASH_TILDE] = ACTIONS(1292),
    [anon_sym_addressof] = ACTIONS(1292),
    [anon_sym_digestof] = ACTIONS(1292),
    [anon_sym_PLUS] = ACTIONS(1294),
    [anon_sym_STAR] = ACTIONS(1294),
    [anon_sym_SLASH] = ACTIONS(1294),
    [anon_sym_PERCENT] = ACTIONS(1294),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1294),
    [anon_sym_LT_LT] = ACTIONS(1294),
    [anon_sym_GT_GT] = ACTIONS(1294),
    [anon_sym_and] = ACTIONS(1292),
    [anon_sym_or] = ACTIONS(1292),
    [anon_sym_xor] = ACTIONS(1292),
    [anon_sym_isnt] = ACTIONS(1292),
    [anon_sym_EQ_EQ] = ACTIONS(1294),
    [anon_sym_BANG_EQ] = ACTIONS(1294),
    [anon_sym_GT] = ACTIONS(1294),
    [anon_sym_GT_EQ] = ACTIONS(1294),
    [anon_sym_LT_EQ] = ACTIONS(1294),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_PLUS_TILDE] = ACTIONS(1292),
    [anon_sym_STAR_TILDE] = ACTIONS(1292),
    [anon_sym_SLASH_TILDE] = ACTIONS(1292),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1292),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1292),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1292),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1292),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1292),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1292),
    [anon_sym_GT_TILDE] = ACTIONS(1292),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1292),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1292),
    [anon_sym_LT_TILDE] = ACTIONS(1292),
    [anon_sym_PLUS_QMARK] = ACTIONS(1292),
    [anon_sym_DASH_QMARK] = ACTIONS(1292),
    [anon_sym_STAR_QMARK] = ACTIONS(1292),
    [anon_sym_SLASH_QMARK] = ACTIONS(1292),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1292),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1292),
    [anon_sym_as] = ACTIONS(1292),
    [anon_sym_LPAREN2] = ACTIONS(1292),
    [anon_sym_DOT_GT] = ACTIONS(1292),
    [anon_sym_TILDE] = ACTIONS(1292),
    [anon_sym_end] = ACTIONS(1292),
    [anon_sym_if] = ACTIONS(1294),
    [anon_sym_ifdef] = ACTIONS(1292),
    [anon_sym_elseif] = ACTIONS(1292),
    [anon_sym_iftype] = ACTIONS(1292),
    [anon_sym_else] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1292),
    [anon_sym_while] = ACTIONS(1292),
    [anon_sym_try] = ACTIONS(1292),
    [anon_sym_with] = ACTIONS(1292),
    [anon_sym_repeat] = ACTIONS(1292),
    [anon_sym_recover] = ACTIONS(1292),
    [anon_sym_match] = ACTIONS(1292),
    [anon_sym_return] = ACTIONS(1292),
    [anon_sym_continue] = ACTIONS(1292),
    [anon_sym_break] = ACTIONS(1292),
    [anon_sym_consume] = ACTIONS(1292),
    [anon_sym_object] = ACTIONS(1292),
    [sym_number] = ACTIONS(1294),
    [sym_float] = ACTIONS(1292),
    [anon_sym_DQUOTE] = ACTIONS(1294),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1292),
    [anon_sym_SQUOTE] = ACTIONS(1292),
    [anon_sym_true] = ACTIONS(1292),
    [anon_sym_false] = ACTIONS(1292),
    [sym_this] = ACTIONS(1292),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [566] = {
    [sym_identifier] = ACTIONS(1274),
    [anon_sym_EQ] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(1272),
    [anon_sym_LBRACK] = ACTIONS(1272),
    [anon_sym_is] = ACTIONS(1274),
    [anon_sym_let] = ACTIONS(1272),
    [anon_sym_var] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(1274),
    [anon_sym_DOT] = ACTIONS(1274),
    [anon_sym_LBRACE] = ACTIONS(1272),
    [anon_sym_SEMI] = ACTIONS(1272),
    [sym_error] = ACTIONS(1272),
    [sym_compile_intrinsic] = ACTIONS(1272),
    [anon_sym_compile_error] = ACTIONS(1272),
    [sym_location] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_not] = ACTIONS(1272),
    [anon_sym_DASH_TILDE] = ACTIONS(1272),
    [anon_sym_addressof] = ACTIONS(1272),
    [anon_sym_digestof] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1274),
    [anon_sym_STAR] = ACTIONS(1274),
    [anon_sym_SLASH] = ACTIONS(1274),
    [anon_sym_PERCENT] = ACTIONS(1274),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1274),
    [anon_sym_LT_LT] = ACTIONS(1274),
    [anon_sym_GT_GT] = ACTIONS(1274),
    [anon_sym_and] = ACTIONS(1272),
    [anon_sym_or] = ACTIONS(1272),
    [anon_sym_xor] = ACTIONS(1272),
    [anon_sym_isnt] = ACTIONS(1272),
    [anon_sym_EQ_EQ] = ACTIONS(1274),
    [anon_sym_BANG_EQ] = ACTIONS(1274),
    [anon_sym_GT] = ACTIONS(1274),
    [anon_sym_GT_EQ] = ACTIONS(1274),
    [anon_sym_LT_EQ] = ACTIONS(1274),
    [anon_sym_LT] = ACTIONS(1274),
    [anon_sym_PLUS_TILDE] = ACTIONS(1272),
    [anon_sym_STAR_TILDE] = ACTIONS(1272),
    [anon_sym_SLASH_TILDE] = ACTIONS(1272),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1272),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1272),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1272),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1272),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1272),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1272),
    [anon_sym_GT_TILDE] = ACTIONS(1272),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1272),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1272),
    [anon_sym_LT_TILDE] = ACTIONS(1272),
    [anon_sym_PLUS_QMARK] = ACTIONS(1272),
    [anon_sym_DASH_QMARK] = ACTIONS(1272),
    [anon_sym_STAR_QMARK] = ACTIONS(1272),
    [anon_sym_SLASH_QMARK] = ACTIONS(1272),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1272),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1272),
    [anon_sym_as] = ACTIONS(1272),
    [anon_sym_LPAREN2] = ACTIONS(1272),
    [anon_sym_DOT_GT] = ACTIONS(1272),
    [anon_sym_TILDE] = ACTIONS(1272),
    [anon_sym_end] = ACTIONS(1272),
    [anon_sym_if] = ACTIONS(1274),
    [anon_sym_ifdef] = ACTIONS(1272),
    [anon_sym_elseif] = ACTIONS(1272),
    [anon_sym_iftype] = ACTIONS(1272),
    [anon_sym_else] = ACTIONS(1274),
    [anon_sym_for] = ACTIONS(1272),
    [anon_sym_while] = ACTIONS(1272),
    [anon_sym_try] = ACTIONS(1272),
    [anon_sym_with] = ACTIONS(1272),
    [anon_sym_repeat] = ACTIONS(1272),
    [anon_sym_recover] = ACTIONS(1272),
    [anon_sym_match] = ACTIONS(1272),
    [anon_sym_return] = ACTIONS(1272),
    [anon_sym_continue] = ACTIONS(1272),
    [anon_sym_break] = ACTIONS(1272),
    [anon_sym_consume] = ACTIONS(1272),
    [anon_sym_object] = ACTIONS(1272),
    [sym_number] = ACTIONS(1274),
    [sym_float] = ACTIONS(1272),
    [anon_sym_DQUOTE] = ACTIONS(1274),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1272),
    [anon_sym_SQUOTE] = ACTIONS(1272),
    [anon_sym_true] = ACTIONS(1272),
    [anon_sym_false] = ACTIONS(1272),
    [sym_this] = ACTIONS(1272),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [567] = {
    [sym_identifier] = ACTIONS(1278),
    [anon_sym_EQ] = ACTIONS(1278),
    [anon_sym_AT] = ACTIONS(1276),
    [anon_sym_LBRACK] = ACTIONS(1276),
    [anon_sym_is] = ACTIONS(1278),
    [anon_sym_let] = ACTIONS(1276),
    [anon_sym_var] = ACTIONS(1276),
    [anon_sym_LPAREN] = ACTIONS(1278),
    [anon_sym_DOT] = ACTIONS(1278),
    [anon_sym_LBRACE] = ACTIONS(1276),
    [anon_sym_SEMI] = ACTIONS(1276),
    [sym_error] = ACTIONS(1276),
    [sym_compile_intrinsic] = ACTIONS(1276),
    [anon_sym_compile_error] = ACTIONS(1276),
    [sym_location] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_not] = ACTIONS(1276),
    [anon_sym_DASH_TILDE] = ACTIONS(1276),
    [anon_sym_addressof] = ACTIONS(1276),
    [anon_sym_digestof] = ACTIONS(1276),
    [anon_sym_PLUS] = ACTIONS(1278),
    [anon_sym_STAR] = ACTIONS(1278),
    [anon_sym_SLASH] = ACTIONS(1278),
    [anon_sym_PERCENT] = ACTIONS(1278),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1278),
    [anon_sym_LT_LT] = ACTIONS(1278),
    [anon_sym_GT_GT] = ACTIONS(1278),
    [anon_sym_and] = ACTIONS(1276),
    [anon_sym_or] = ACTIONS(1276),
    [anon_sym_xor] = ACTIONS(1276),
    [anon_sym_isnt] = ACTIONS(1276),
    [anon_sym_EQ_EQ] = ACTIONS(1278),
    [anon_sym_BANG_EQ] = ACTIONS(1278),
    [anon_sym_GT] = ACTIONS(1278),
    [anon_sym_GT_EQ] = ACTIONS(1278),
    [anon_sym_LT_EQ] = ACTIONS(1278),
    [anon_sym_LT] = ACTIONS(1278),
    [anon_sym_PLUS_TILDE] = ACTIONS(1276),
    [anon_sym_STAR_TILDE] = ACTIONS(1276),
    [anon_sym_SLASH_TILDE] = ACTIONS(1276),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1276),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1276),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1276),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1276),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1276),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1276),
    [anon_sym_GT_TILDE] = ACTIONS(1276),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1276),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1276),
    [anon_sym_LT_TILDE] = ACTIONS(1276),
    [anon_sym_PLUS_QMARK] = ACTIONS(1276),
    [anon_sym_DASH_QMARK] = ACTIONS(1276),
    [anon_sym_STAR_QMARK] = ACTIONS(1276),
    [anon_sym_SLASH_QMARK] = ACTIONS(1276),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1276),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1276),
    [anon_sym_as] = ACTIONS(1276),
    [anon_sym_LPAREN2] = ACTIONS(1276),
    [anon_sym_DOT_GT] = ACTIONS(1276),
    [anon_sym_TILDE] = ACTIONS(1276),
    [anon_sym_end] = ACTIONS(1276),
    [anon_sym_if] = ACTIONS(1278),
    [anon_sym_ifdef] = ACTIONS(1276),
    [anon_sym_elseif] = ACTIONS(1276),
    [anon_sym_iftype] = ACTIONS(1276),
    [anon_sym_else] = ACTIONS(1278),
    [anon_sym_for] = ACTIONS(1276),
    [anon_sym_while] = ACTIONS(1276),
    [anon_sym_try] = ACTIONS(1276),
    [anon_sym_with] = ACTIONS(1276),
    [anon_sym_repeat] = ACTIONS(1276),
    [anon_sym_recover] = ACTIONS(1276),
    [anon_sym_match] = ACTIONS(1276),
    [anon_sym_return] = ACTIONS(1276),
    [anon_sym_continue] = ACTIONS(1276),
    [anon_sym_break] = ACTIONS(1276),
    [anon_sym_consume] = ACTIONS(1276),
    [anon_sym_object] = ACTIONS(1276),
    [sym_number] = ACTIONS(1278),
    [sym_float] = ACTIONS(1276),
    [anon_sym_DQUOTE] = ACTIONS(1278),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1276),
    [anon_sym_SQUOTE] = ACTIONS(1276),
    [anon_sym_true] = ACTIONS(1276),
    [anon_sym_false] = ACTIONS(1276),
    [sym_this] = ACTIONS(1276),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [568] = {
    [sym_identifier] = ACTIONS(1072),
    [anon_sym_EQ] = ACTIONS(1072),
    [anon_sym_AT] = ACTIONS(1070),
    [anon_sym_LBRACK] = ACTIONS(1070),
    [anon_sym_is] = ACTIONS(1072),
    [anon_sym_let] = ACTIONS(1070),
    [anon_sym_var] = ACTIONS(1070),
    [anon_sym_LPAREN] = ACTIONS(1072),
    [anon_sym_DOT] = ACTIONS(1072),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_SEMI] = ACTIONS(1070),
    [sym_error] = ACTIONS(1070),
    [sym_compile_intrinsic] = ACTIONS(1070),
    [anon_sym_compile_error] = ACTIONS(1070),
    [sym_location] = ACTIONS(1070),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_not] = ACTIONS(1070),
    [anon_sym_DASH_TILDE] = ACTIONS(1070),
    [anon_sym_addressof] = ACTIONS(1070),
    [anon_sym_digestof] = ACTIONS(1070),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_STAR] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1072),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_and] = ACTIONS(1070),
    [anon_sym_or] = ACTIONS(1070),
    [anon_sym_xor] = ACTIONS(1070),
    [anon_sym_isnt] = ACTIONS(1070),
    [anon_sym_EQ_EQ] = ACTIONS(1072),
    [anon_sym_BANG_EQ] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_GT_EQ] = ACTIONS(1072),
    [anon_sym_LT_EQ] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_PLUS_TILDE] = ACTIONS(1070),
    [anon_sym_STAR_TILDE] = ACTIONS(1070),
    [anon_sym_SLASH_TILDE] = ACTIONS(1070),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1070),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1070),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1070),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1070),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1070),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1070),
    [anon_sym_GT_TILDE] = ACTIONS(1070),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1070),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1070),
    [anon_sym_LT_TILDE] = ACTIONS(1070),
    [anon_sym_PLUS_QMARK] = ACTIONS(1070),
    [anon_sym_DASH_QMARK] = ACTIONS(1070),
    [anon_sym_STAR_QMARK] = ACTIONS(1070),
    [anon_sym_SLASH_QMARK] = ACTIONS(1070),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1070),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1070),
    [anon_sym_as] = ACTIONS(1070),
    [anon_sym_LPAREN2] = ACTIONS(1070),
    [anon_sym_DOT_GT] = ACTIONS(1070),
    [anon_sym_TILDE] = ACTIONS(1070),
    [anon_sym_end] = ACTIONS(1070),
    [anon_sym_if] = ACTIONS(1072),
    [anon_sym_ifdef] = ACTIONS(1070),
    [anon_sym_elseif] = ACTIONS(1070),
    [anon_sym_iftype] = ACTIONS(1070),
    [anon_sym_else] = ACTIONS(1072),
    [anon_sym_for] = ACTIONS(1070),
    [anon_sym_while] = ACTIONS(1070),
    [anon_sym_try] = ACTIONS(1070),
    [anon_sym_with] = ACTIONS(1070),
    [anon_sym_repeat] = ACTIONS(1070),
    [anon_sym_recover] = ACTIONS(1070),
    [anon_sym_match] = ACTIONS(1070),
    [anon_sym_return] = ACTIONS(1070),
    [anon_sym_continue] = ACTIONS(1070),
    [anon_sym_break] = ACTIONS(1070),
    [anon_sym_consume] = ACTIONS(1070),
    [anon_sym_object] = ACTIONS(1070),
    [sym_number] = ACTIONS(1072),
    [sym_float] = ACTIONS(1070),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1070),
    [anon_sym_SQUOTE] = ACTIONS(1070),
    [anon_sym_true] = ACTIONS(1070),
    [anon_sym_false] = ACTIONS(1070),
    [sym_this] = ACTIONS(1070),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [569] = {
    [sym_identifier] = ACTIONS(1076),
    [anon_sym_EQ] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1074),
    [anon_sym_is] = ACTIONS(1076),
    [anon_sym_let] = ACTIONS(1074),
    [anon_sym_var] = ACTIONS(1074),
    [anon_sym_LPAREN] = ACTIONS(1076),
    [anon_sym_DOT] = ACTIONS(1076),
    [anon_sym_LBRACE] = ACTIONS(1074),
    [anon_sym_SEMI] = ACTIONS(1074),
    [sym_error] = ACTIONS(1074),
    [sym_compile_intrinsic] = ACTIONS(1074),
    [anon_sym_compile_error] = ACTIONS(1074),
    [sym_location] = ACTIONS(1074),
    [anon_sym_DASH] = ACTIONS(1076),
    [anon_sym_not] = ACTIONS(1074),
    [anon_sym_DASH_TILDE] = ACTIONS(1074),
    [anon_sym_addressof] = ACTIONS(1074),
    [anon_sym_digestof] = ACTIONS(1074),
    [anon_sym_PLUS] = ACTIONS(1076),
    [anon_sym_STAR] = ACTIONS(1076),
    [anon_sym_SLASH] = ACTIONS(1076),
    [anon_sym_PERCENT] = ACTIONS(1076),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1076),
    [anon_sym_LT_LT] = ACTIONS(1076),
    [anon_sym_GT_GT] = ACTIONS(1076),
    [anon_sym_and] = ACTIONS(1074),
    [anon_sym_or] = ACTIONS(1074),
    [anon_sym_xor] = ACTIONS(1074),
    [anon_sym_isnt] = ACTIONS(1074),
    [anon_sym_EQ_EQ] = ACTIONS(1076),
    [anon_sym_BANG_EQ] = ACTIONS(1076),
    [anon_sym_GT] = ACTIONS(1076),
    [anon_sym_GT_EQ] = ACTIONS(1076),
    [anon_sym_LT_EQ] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1076),
    [anon_sym_PLUS_TILDE] = ACTIONS(1074),
    [anon_sym_STAR_TILDE] = ACTIONS(1074),
    [anon_sym_SLASH_TILDE] = ACTIONS(1074),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1074),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1074),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1074),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1074),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1074),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1074),
    [anon_sym_GT_TILDE] = ACTIONS(1074),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1074),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1074),
    [anon_sym_LT_TILDE] = ACTIONS(1074),
    [anon_sym_PLUS_QMARK] = ACTIONS(1074),
    [anon_sym_DASH_QMARK] = ACTIONS(1074),
    [anon_sym_STAR_QMARK] = ACTIONS(1074),
    [anon_sym_SLASH_QMARK] = ACTIONS(1074),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1074),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1074),
    [anon_sym_as] = ACTIONS(1074),
    [anon_sym_LPAREN2] = ACTIONS(1074),
    [anon_sym_DOT_GT] = ACTIONS(1074),
    [anon_sym_TILDE] = ACTIONS(1074),
    [anon_sym_end] = ACTIONS(1074),
    [anon_sym_if] = ACTIONS(1076),
    [anon_sym_ifdef] = ACTIONS(1074),
    [anon_sym_elseif] = ACTIONS(1074),
    [anon_sym_iftype] = ACTIONS(1074),
    [anon_sym_else] = ACTIONS(1076),
    [anon_sym_for] = ACTIONS(1074),
    [anon_sym_while] = ACTIONS(1074),
    [anon_sym_try] = ACTIONS(1074),
    [anon_sym_with] = ACTIONS(1074),
    [anon_sym_repeat] = ACTIONS(1074),
    [anon_sym_recover] = ACTIONS(1074),
    [anon_sym_match] = ACTIONS(1074),
    [anon_sym_return] = ACTIONS(1074),
    [anon_sym_continue] = ACTIONS(1074),
    [anon_sym_break] = ACTIONS(1074),
    [anon_sym_consume] = ACTIONS(1074),
    [anon_sym_object] = ACTIONS(1074),
    [sym_number] = ACTIONS(1076),
    [sym_float] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1074),
    [anon_sym_SQUOTE] = ACTIONS(1074),
    [anon_sym_true] = ACTIONS(1074),
    [anon_sym_false] = ACTIONS(1074),
    [sym_this] = ACTIONS(1074),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [570] = {
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_EQ] = ACTIONS(1286),
    [anon_sym_AT] = ACTIONS(1284),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_is] = ACTIONS(1286),
    [anon_sym_let] = ACTIONS(1284),
    [anon_sym_var] = ACTIONS(1284),
    [anon_sym_LPAREN] = ACTIONS(1286),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_LBRACE] = ACTIONS(1284),
    [anon_sym_SEMI] = ACTIONS(1284),
    [sym_error] = ACTIONS(1284),
    [sym_compile_intrinsic] = ACTIONS(1284),
    [anon_sym_compile_error] = ACTIONS(1284),
    [sym_location] = ACTIONS(1284),
    [anon_sym_DASH] = ACTIONS(1286),
    [anon_sym_not] = ACTIONS(1284),
    [anon_sym_DASH_TILDE] = ACTIONS(1284),
    [anon_sym_addressof] = ACTIONS(1284),
    [anon_sym_digestof] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(1286),
    [anon_sym_STAR] = ACTIONS(1286),
    [anon_sym_SLASH] = ACTIONS(1286),
    [anon_sym_PERCENT] = ACTIONS(1286),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1286),
    [anon_sym_LT_LT] = ACTIONS(1286),
    [anon_sym_GT_GT] = ACTIONS(1286),
    [anon_sym_and] = ACTIONS(1284),
    [anon_sym_or] = ACTIONS(1284),
    [anon_sym_xor] = ACTIONS(1284),
    [anon_sym_isnt] = ACTIONS(1284),
    [anon_sym_EQ_EQ] = ACTIONS(1286),
    [anon_sym_BANG_EQ] = ACTIONS(1286),
    [anon_sym_GT] = ACTIONS(1286),
    [anon_sym_GT_EQ] = ACTIONS(1286),
    [anon_sym_LT_EQ] = ACTIONS(1286),
    [anon_sym_LT] = ACTIONS(1286),
    [anon_sym_PLUS_TILDE] = ACTIONS(1284),
    [anon_sym_STAR_TILDE] = ACTIONS(1284),
    [anon_sym_SLASH_TILDE] = ACTIONS(1284),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1284),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1284),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1284),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1284),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1284),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1284),
    [anon_sym_GT_TILDE] = ACTIONS(1284),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1284),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1284),
    [anon_sym_LT_TILDE] = ACTIONS(1284),
    [anon_sym_PLUS_QMARK] = ACTIONS(1284),
    [anon_sym_DASH_QMARK] = ACTIONS(1284),
    [anon_sym_STAR_QMARK] = ACTIONS(1284),
    [anon_sym_SLASH_QMARK] = ACTIONS(1284),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1284),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1284),
    [anon_sym_as] = ACTIONS(1284),
    [anon_sym_LPAREN2] = ACTIONS(1284),
    [anon_sym_DOT_GT] = ACTIONS(1284),
    [anon_sym_TILDE] = ACTIONS(1284),
    [anon_sym_end] = ACTIONS(1284),
    [anon_sym_if] = ACTIONS(1286),
    [anon_sym_ifdef] = ACTIONS(1284),
    [anon_sym_elseif] = ACTIONS(1284),
    [anon_sym_iftype] = ACTIONS(1284),
    [anon_sym_else] = ACTIONS(1286),
    [anon_sym_for] = ACTIONS(1284),
    [anon_sym_while] = ACTIONS(1284),
    [anon_sym_try] = ACTIONS(1284),
    [anon_sym_with] = ACTIONS(1284),
    [anon_sym_repeat] = ACTIONS(1284),
    [anon_sym_recover] = ACTIONS(1284),
    [anon_sym_match] = ACTIONS(1284),
    [anon_sym_return] = ACTIONS(1284),
    [anon_sym_continue] = ACTIONS(1284),
    [anon_sym_break] = ACTIONS(1284),
    [anon_sym_consume] = ACTIONS(1284),
    [anon_sym_object] = ACTIONS(1284),
    [sym_number] = ACTIONS(1286),
    [sym_float] = ACTIONS(1284),
    [anon_sym_DQUOTE] = ACTIONS(1286),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(1284),
    [anon_sym_true] = ACTIONS(1284),
    [anon_sym_false] = ACTIONS(1284),
    [sym_this] = ACTIONS(1284),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [571] = {
    [sym_identifier] = ACTIONS(1080),
    [anon_sym_EQ] = ACTIONS(1080),
    [anon_sym_AT] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1078),
    [anon_sym_is] = ACTIONS(1080),
    [anon_sym_let] = ACTIONS(1078),
    [anon_sym_var] = ACTIONS(1078),
    [anon_sym_LPAREN] = ACTIONS(1080),
    [anon_sym_DOT] = ACTIONS(1080),
    [anon_sym_LBRACE] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(1078),
    [sym_error] = ACTIONS(1078),
    [sym_compile_intrinsic] = ACTIONS(1078),
    [anon_sym_compile_error] = ACTIONS(1078),
    [sym_location] = ACTIONS(1078),
    [anon_sym_DASH] = ACTIONS(1080),
    [anon_sym_not] = ACTIONS(1078),
    [anon_sym_DASH_TILDE] = ACTIONS(1078),
    [anon_sym_addressof] = ACTIONS(1078),
    [anon_sym_digestof] = ACTIONS(1078),
    [anon_sym_PLUS] = ACTIONS(1080),
    [anon_sym_STAR] = ACTIONS(1080),
    [anon_sym_SLASH] = ACTIONS(1080),
    [anon_sym_PERCENT] = ACTIONS(1080),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1080),
    [anon_sym_LT_LT] = ACTIONS(1080),
    [anon_sym_GT_GT] = ACTIONS(1080),
    [anon_sym_and] = ACTIONS(1078),
    [anon_sym_or] = ACTIONS(1078),
    [anon_sym_xor] = ACTIONS(1078),
    [anon_sym_isnt] = ACTIONS(1078),
    [anon_sym_EQ_EQ] = ACTIONS(1080),
    [anon_sym_BANG_EQ] = ACTIONS(1080),
    [anon_sym_GT] = ACTIONS(1080),
    [anon_sym_GT_EQ] = ACTIONS(1080),
    [anon_sym_LT_EQ] = ACTIONS(1080),
    [anon_sym_LT] = ACTIONS(1080),
    [anon_sym_PLUS_TILDE] = ACTIONS(1078),
    [anon_sym_STAR_TILDE] = ACTIONS(1078),
    [anon_sym_SLASH_TILDE] = ACTIONS(1078),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1078),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1078),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1078),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1078),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1078),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1078),
    [anon_sym_GT_TILDE] = ACTIONS(1078),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1078),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1078),
    [anon_sym_LT_TILDE] = ACTIONS(1078),
    [anon_sym_PLUS_QMARK] = ACTIONS(1078),
    [anon_sym_DASH_QMARK] = ACTIONS(1078),
    [anon_sym_STAR_QMARK] = ACTIONS(1078),
    [anon_sym_SLASH_QMARK] = ACTIONS(1078),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1078),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1078),
    [anon_sym_as] = ACTIONS(1078),
    [anon_sym_LPAREN2] = ACTIONS(1078),
    [anon_sym_DOT_GT] = ACTIONS(1078),
    [anon_sym_TILDE] = ACTIONS(1078),
    [anon_sym_end] = ACTIONS(1078),
    [anon_sym_if] = ACTIONS(1080),
    [anon_sym_ifdef] = ACTIONS(1078),
    [anon_sym_elseif] = ACTIONS(1078),
    [anon_sym_iftype] = ACTIONS(1078),
    [anon_sym_else] = ACTIONS(1080),
    [anon_sym_for] = ACTIONS(1078),
    [anon_sym_while] = ACTIONS(1078),
    [anon_sym_try] = ACTIONS(1078),
    [anon_sym_with] = ACTIONS(1078),
    [anon_sym_repeat] = ACTIONS(1078),
    [anon_sym_recover] = ACTIONS(1078),
    [anon_sym_match] = ACTIONS(1078),
    [anon_sym_return] = ACTIONS(1078),
    [anon_sym_continue] = ACTIONS(1078),
    [anon_sym_break] = ACTIONS(1078),
    [anon_sym_consume] = ACTIONS(1078),
    [anon_sym_object] = ACTIONS(1078),
    [sym_number] = ACTIONS(1080),
    [sym_float] = ACTIONS(1078),
    [anon_sym_DQUOTE] = ACTIONS(1080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1078),
    [anon_sym_SQUOTE] = ACTIONS(1078),
    [anon_sym_true] = ACTIONS(1078),
    [anon_sym_false] = ACTIONS(1078),
    [sym_this] = ACTIONS(1078),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [572] = {
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_AT] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(1304),
    [anon_sym_is] = ACTIONS(1306),
    [anon_sym_let] = ACTIONS(1304),
    [anon_sym_var] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_DOT] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(1304),
    [anon_sym_SEMI] = ACTIONS(1304),
    [sym_error] = ACTIONS(1304),
    [sym_compile_intrinsic] = ACTIONS(1304),
    [anon_sym_compile_error] = ACTIONS(1304),
    [sym_location] = ACTIONS(1304),
    [anon_sym_DASH] = ACTIONS(1306),
    [anon_sym_not] = ACTIONS(1304),
    [anon_sym_DASH_TILDE] = ACTIONS(1304),
    [anon_sym_addressof] = ACTIONS(1304),
    [anon_sym_digestof] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1306),
    [anon_sym_STAR] = ACTIONS(1306),
    [anon_sym_SLASH] = ACTIONS(1306),
    [anon_sym_PERCENT] = ACTIONS(1306),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1306),
    [anon_sym_LT_LT] = ACTIONS(1306),
    [anon_sym_GT_GT] = ACTIONS(1306),
    [anon_sym_and] = ACTIONS(1304),
    [anon_sym_or] = ACTIONS(1304),
    [anon_sym_xor] = ACTIONS(1304),
    [anon_sym_isnt] = ACTIONS(1304),
    [anon_sym_EQ_EQ] = ACTIONS(1306),
    [anon_sym_BANG_EQ] = ACTIONS(1306),
    [anon_sym_GT] = ACTIONS(1306),
    [anon_sym_GT_EQ] = ACTIONS(1306),
    [anon_sym_LT_EQ] = ACTIONS(1306),
    [anon_sym_LT] = ACTIONS(1306),
    [anon_sym_PLUS_TILDE] = ACTIONS(1304),
    [anon_sym_STAR_TILDE] = ACTIONS(1304),
    [anon_sym_SLASH_TILDE] = ACTIONS(1304),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1304),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1304),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1304),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1304),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1304),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1304),
    [anon_sym_GT_TILDE] = ACTIONS(1304),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1304),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1304),
    [anon_sym_LT_TILDE] = ACTIONS(1304),
    [anon_sym_PLUS_QMARK] = ACTIONS(1304),
    [anon_sym_DASH_QMARK] = ACTIONS(1304),
    [anon_sym_STAR_QMARK] = ACTIONS(1304),
    [anon_sym_SLASH_QMARK] = ACTIONS(1304),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1304),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1304),
    [anon_sym_as] = ACTIONS(1304),
    [anon_sym_LPAREN2] = ACTIONS(1304),
    [anon_sym_DOT_GT] = ACTIONS(1304),
    [anon_sym_TILDE] = ACTIONS(1304),
    [anon_sym_end] = ACTIONS(1304),
    [anon_sym_if] = ACTIONS(1306),
    [anon_sym_ifdef] = ACTIONS(1304),
    [anon_sym_elseif] = ACTIONS(1304),
    [anon_sym_iftype] = ACTIONS(1304),
    [anon_sym_else] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_while] = ACTIONS(1304),
    [anon_sym_try] = ACTIONS(1304),
    [anon_sym_with] = ACTIONS(1304),
    [anon_sym_repeat] = ACTIONS(1304),
    [anon_sym_recover] = ACTIONS(1304),
    [anon_sym_match] = ACTIONS(1304),
    [anon_sym_return] = ACTIONS(1304),
    [anon_sym_continue] = ACTIONS(1304),
    [anon_sym_break] = ACTIONS(1304),
    [anon_sym_consume] = ACTIONS(1304),
    [anon_sym_object] = ACTIONS(1304),
    [sym_number] = ACTIONS(1306),
    [sym_float] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1306),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1304),
    [anon_sym_SQUOTE] = ACTIONS(1304),
    [anon_sym_true] = ACTIONS(1304),
    [anon_sym_false] = ACTIONS(1304),
    [sym_this] = ACTIONS(1304),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [573] = {
    [sym_identifier] = ACTIONS(1084),
    [anon_sym_EQ] = ACTIONS(1084),
    [anon_sym_AT] = ACTIONS(1082),
    [anon_sym_LBRACK] = ACTIONS(1082),
    [anon_sym_is] = ACTIONS(1084),
    [anon_sym_let] = ACTIONS(1082),
    [anon_sym_var] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1084),
    [anon_sym_DOT] = ACTIONS(1084),
    [anon_sym_LBRACE] = ACTIONS(1082),
    [anon_sym_SEMI] = ACTIONS(1082),
    [sym_error] = ACTIONS(1082),
    [sym_compile_intrinsic] = ACTIONS(1082),
    [anon_sym_compile_error] = ACTIONS(1082),
    [sym_location] = ACTIONS(1082),
    [anon_sym_DASH] = ACTIONS(1084),
    [anon_sym_not] = ACTIONS(1082),
    [anon_sym_DASH_TILDE] = ACTIONS(1082),
    [anon_sym_addressof] = ACTIONS(1082),
    [anon_sym_digestof] = ACTIONS(1082),
    [anon_sym_PLUS] = ACTIONS(1084),
    [anon_sym_STAR] = ACTIONS(1084),
    [anon_sym_SLASH] = ACTIONS(1084),
    [anon_sym_PERCENT] = ACTIONS(1084),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1084),
    [anon_sym_LT_LT] = ACTIONS(1084),
    [anon_sym_GT_GT] = ACTIONS(1084),
    [anon_sym_and] = ACTIONS(1082),
    [anon_sym_or] = ACTIONS(1082),
    [anon_sym_xor] = ACTIONS(1082),
    [anon_sym_isnt] = ACTIONS(1082),
    [anon_sym_EQ_EQ] = ACTIONS(1084),
    [anon_sym_BANG_EQ] = ACTIONS(1084),
    [anon_sym_GT] = ACTIONS(1084),
    [anon_sym_GT_EQ] = ACTIONS(1084),
    [anon_sym_LT_EQ] = ACTIONS(1084),
    [anon_sym_LT] = ACTIONS(1084),
    [anon_sym_PLUS_TILDE] = ACTIONS(1082),
    [anon_sym_STAR_TILDE] = ACTIONS(1082),
    [anon_sym_SLASH_TILDE] = ACTIONS(1082),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1082),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1082),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1082),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1082),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1082),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1082),
    [anon_sym_GT_TILDE] = ACTIONS(1082),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1082),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1082),
    [anon_sym_LT_TILDE] = ACTIONS(1082),
    [anon_sym_PLUS_QMARK] = ACTIONS(1082),
    [anon_sym_DASH_QMARK] = ACTIONS(1082),
    [anon_sym_STAR_QMARK] = ACTIONS(1082),
    [anon_sym_SLASH_QMARK] = ACTIONS(1082),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1082),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1082),
    [anon_sym_as] = ACTIONS(1082),
    [anon_sym_LPAREN2] = ACTIONS(1082),
    [anon_sym_DOT_GT] = ACTIONS(1082),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_end] = ACTIONS(1082),
    [anon_sym_if] = ACTIONS(1084),
    [anon_sym_ifdef] = ACTIONS(1082),
    [anon_sym_elseif] = ACTIONS(1082),
    [anon_sym_iftype] = ACTIONS(1082),
    [anon_sym_else] = ACTIONS(1084),
    [anon_sym_for] = ACTIONS(1082),
    [anon_sym_while] = ACTIONS(1082),
    [anon_sym_try] = ACTIONS(1082),
    [anon_sym_with] = ACTIONS(1082),
    [anon_sym_repeat] = ACTIONS(1082),
    [anon_sym_recover] = ACTIONS(1082),
    [anon_sym_match] = ACTIONS(1082),
    [anon_sym_return] = ACTIONS(1082),
    [anon_sym_continue] = ACTIONS(1082),
    [anon_sym_break] = ACTIONS(1082),
    [anon_sym_consume] = ACTIONS(1082),
    [anon_sym_object] = ACTIONS(1082),
    [sym_number] = ACTIONS(1084),
    [sym_float] = ACTIONS(1082),
    [anon_sym_DQUOTE] = ACTIONS(1084),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1082),
    [anon_sym_SQUOTE] = ACTIONS(1082),
    [anon_sym_true] = ACTIONS(1082),
    [anon_sym_false] = ACTIONS(1082),
    [sym_this] = ACTIONS(1082),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [574] = {
    [sym_capability] = STATE(768),
    [sym_block] = STATE(2203),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_iso] = ACTIONS(1366),
    [anon_sym_trn] = ACTIONS(1366),
    [anon_sym_ref] = ACTIONS(1366),
    [anon_sym_val] = ACTIONS(1366),
    [anon_sym_box] = ACTIONS(1366),
    [anon_sym_tag] = ACTIONS(1366),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [575] = {
    [sym_capability] = STATE(649),
    [sym_block] = STATE(2219),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_iso] = ACTIONS(1366),
    [anon_sym_trn] = ACTIONS(1366),
    [anon_sym_ref] = ACTIONS(1366),
    [anon_sym_val] = ACTIONS(1366),
    [anon_sym_box] = ACTIONS(1366),
    [anon_sym_tag] = ACTIONS(1366),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [576] = {
    [sym_capability] = STATE(733),
    [sym_block] = STATE(2405),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_iso] = ACTIONS(1366),
    [anon_sym_trn] = ACTIONS(1366),
    [anon_sym_ref] = ACTIONS(1366),
    [anon_sym_val] = ACTIONS(1366),
    [anon_sym_box] = ACTIONS(1366),
    [anon_sym_tag] = ACTIONS(1366),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [577] = {
    [sym_capability] = STATE(638),
    [sym_block] = STATE(2474),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_iso] = ACTIONS(1366),
    [anon_sym_trn] = ACTIONS(1366),
    [anon_sym_ref] = ACTIONS(1366),
    [anon_sym_val] = ACTIONS(1366),
    [anon_sym_box] = ACTIONS(1366),
    [anon_sym_tag] = ACTIONS(1366),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [578] = {
    [sym_arguments] = STATE(332),
    [sym_identifier] = ACTIONS(1372),
    [anon_sym_EQ] = ACTIONS(1374),
    [anon_sym_AT] = ACTIONS(1376),
    [anon_sym_LBRACK] = ACTIONS(1376),
    [anon_sym_is] = ACTIONS(1378),
    [anon_sym_let] = ACTIONS(1376),
    [anon_sym_var] = ACTIONS(1376),
    [anon_sym_LPAREN] = ACTIONS(1372),
    [anon_sym_DOT] = ACTIONS(1380),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [sym_error] = ACTIONS(1376),
    [sym_compile_intrinsic] = ACTIONS(1376),
    [anon_sym_compile_error] = ACTIONS(1376),
    [sym_location] = ACTIONS(1376),
    [anon_sym_DASH] = ACTIONS(1378),
    [anon_sym_not] = ACTIONS(1376),
    [anon_sym_DASH_TILDE] = ACTIONS(1382),
    [anon_sym_addressof] = ACTIONS(1376),
    [anon_sym_digestof] = ACTIONS(1376),
    [anon_sym_PLUS] = ACTIONS(1378),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_SLASH] = ACTIONS(1378),
    [anon_sym_PERCENT] = ACTIONS(1378),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1378),
    [anon_sym_LT_LT] = ACTIONS(1378),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_and] = ACTIONS(1382),
    [anon_sym_or] = ACTIONS(1382),
    [anon_sym_xor] = ACTIONS(1382),
    [anon_sym_isnt] = ACTIONS(1382),
    [anon_sym_EQ_EQ] = ACTIONS(1378),
    [anon_sym_BANG_EQ] = ACTIONS(1378),
    [anon_sym_GT] = ACTIONS(1378),
    [anon_sym_GT_EQ] = ACTIONS(1378),
    [anon_sym_LT_EQ] = ACTIONS(1378),
    [anon_sym_LT] = ACTIONS(1378),
    [anon_sym_PLUS_TILDE] = ACTIONS(1382),
    [anon_sym_STAR_TILDE] = ACTIONS(1382),
    [anon_sym_SLASH_TILDE] = ACTIONS(1382),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1382),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1382),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1382),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1382),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1382),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1382),
    [anon_sym_GT_TILDE] = ACTIONS(1382),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1382),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1382),
    [anon_sym_LT_TILDE] = ACTIONS(1382),
    [anon_sym_PLUS_QMARK] = ACTIONS(1382),
    [anon_sym_DASH_QMARK] = ACTIONS(1382),
    [anon_sym_STAR_QMARK] = ACTIONS(1382),
    [anon_sym_SLASH_QMARK] = ACTIONS(1382),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1382),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1382),
    [anon_sym_as] = ACTIONS(43),
    [anon_sym_LPAREN2] = ACTIONS(45),
    [anon_sym_DOT_GT] = ACTIONS(1384),
    [anon_sym_TILDE] = ACTIONS(1386),
    [anon_sym_if] = ACTIONS(1372),
    [anon_sym_ifdef] = ACTIONS(1376),
    [anon_sym_iftype] = ACTIONS(1376),
    [anon_sym_for] = ACTIONS(1376),
    [anon_sym_while] = ACTIONS(1376),
    [anon_sym_try] = ACTIONS(1376),
    [anon_sym_with] = ACTIONS(1376),
    [anon_sym_repeat] = ACTIONS(1376),
    [anon_sym_do] = ACTIONS(1376),
    [anon_sym_recover] = ACTIONS(1376),
    [anon_sym_match] = ACTIONS(1376),
    [anon_sym_return] = ACTIONS(1376),
    [anon_sym_continue] = ACTIONS(1376),
    [anon_sym_break] = ACTIONS(1376),
    [anon_sym_consume] = ACTIONS(1376),
    [anon_sym_object] = ACTIONS(1376),
    [sym_number] = ACTIONS(1372),
    [sym_float] = ACTIONS(1376),
    [anon_sym_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1376),
    [anon_sym_SQUOTE] = ACTIONS(1376),
    [anon_sym_true] = ACTIONS(1376),
    [anon_sym_false] = ACTIONS(1376),
    [sym_this] = ACTIONS(1376),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [579] = {
    [sym_arguments] = STATE(332),
    [sym_identifier] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1326),
    [anon_sym_AT] = ACTIONS(1328),
    [anon_sym_LBRACK] = ACTIONS(1328),
    [anon_sym_is] = ACTIONS(1326),
    [anon_sym_let] = ACTIONS(1328),
    [anon_sym_var] = ACTIONS(1328),
    [anon_sym_LPAREN] = ACTIONS(1326),
    [anon_sym_DOT] = ACTIONS(1380),
    [anon_sym_LBRACE] = ACTIONS(1328),
    [sym_error] = ACTIONS(1328),
    [sym_compile_intrinsic] = ACTIONS(1328),
    [anon_sym_compile_error] = ACTIONS(1328),
    [sym_location] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_not] = ACTIONS(1328),
    [anon_sym_DASH_TILDE] = ACTIONS(1328),
    [anon_sym_addressof] = ACTIONS(1328),
    [anon_sym_digestof] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1326),
    [anon_sym_STAR] = ACTIONS(1326),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym_PERCENT] = ACTIONS(1326),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1326),
    [anon_sym_GT_GT] = ACTIONS(1326),
    [anon_sym_and] = ACTIONS(1328),
    [anon_sym_or] = ACTIONS(1328),
    [anon_sym_xor] = ACTIONS(1328),
    [anon_sym_isnt] = ACTIONS(1328),
    [anon_sym_EQ_EQ] = ACTIONS(1326),
    [anon_sym_BANG_EQ] = ACTIONS(1326),
    [anon_sym_GT] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_LT] = ACTIONS(1326),
    [anon_sym_PLUS_TILDE] = ACTIONS(1328),
    [anon_sym_STAR_TILDE] = ACTIONS(1328),
    [anon_sym_SLASH_TILDE] = ACTIONS(1328),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1328),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1328),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1328),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1328),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1328),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1328),
    [anon_sym_GT_TILDE] = ACTIONS(1328),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1328),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1328),
    [anon_sym_LT_TILDE] = ACTIONS(1328),
    [anon_sym_PLUS_QMARK] = ACTIONS(1328),
    [anon_sym_DASH_QMARK] = ACTIONS(1328),
    [anon_sym_STAR_QMARK] = ACTIONS(1328),
    [anon_sym_SLASH_QMARK] = ACTIONS(1328),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1328),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1328),
    [anon_sym_as] = ACTIONS(1328),
    [anon_sym_LPAREN2] = ACTIONS(45),
    [anon_sym_DOT_GT] = ACTIONS(1384),
    [anon_sym_TILDE] = ACTIONS(1386),
    [anon_sym_if] = ACTIONS(1326),
    [anon_sym_ifdef] = ACTIONS(1328),
    [anon_sym_iftype] = ACTIONS(1328),
    [anon_sym_for] = ACTIONS(1328),
    [anon_sym_while] = ACTIONS(1328),
    [anon_sym_try] = ACTIONS(1328),
    [anon_sym_with] = ACTIONS(1328),
    [anon_sym_repeat] = ACTIONS(1328),
    [anon_sym_do] = ACTIONS(1328),
    [anon_sym_recover] = ACTIONS(1328),
    [anon_sym_match] = ACTIONS(1328),
    [anon_sym_return] = ACTIONS(1328),
    [anon_sym_continue] = ACTIONS(1328),
    [anon_sym_break] = ACTIONS(1328),
    [anon_sym_consume] = ACTIONS(1328),
    [anon_sym_object] = ACTIONS(1328),
    [sym_number] = ACTIONS(1326),
    [sym_float] = ACTIONS(1328),
    [anon_sym_DQUOTE] = ACTIONS(1326),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1328),
    [anon_sym_SQUOTE] = ACTIONS(1328),
    [anon_sym_true] = ACTIONS(1328),
    [anon_sym_false] = ACTIONS(1328),
    [sym_this] = ACTIONS(1328),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [580] = {
    [sym_arguments] = STATE(332),
    [sym_identifier] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(1318),
    [anon_sym_AT] = ACTIONS(1320),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_is] = ACTIONS(1318),
    [anon_sym_let] = ACTIONS(1320),
    [anon_sym_var] = ACTIONS(1320),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_DOT] = ACTIONS(1380),
    [anon_sym_LBRACE] = ACTIONS(1320),
    [sym_error] = ACTIONS(1320),
    [sym_compile_intrinsic] = ACTIONS(1320),
    [anon_sym_compile_error] = ACTIONS(1320),
    [sym_location] = ACTIONS(1320),
    [anon_sym_DASH] = ACTIONS(1318),
    [anon_sym_not] = ACTIONS(1320),
    [anon_sym_DASH_TILDE] = ACTIONS(1320),
    [anon_sym_addressof] = ACTIONS(1320),
    [anon_sym_digestof] = ACTIONS(1320),
    [anon_sym_PLUS] = ACTIONS(1318),
    [anon_sym_STAR] = ACTIONS(1318),
    [anon_sym_SLASH] = ACTIONS(1318),
    [anon_sym_PERCENT] = ACTIONS(1318),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1318),
    [anon_sym_LT_LT] = ACTIONS(1318),
    [anon_sym_GT_GT] = ACTIONS(1318),
    [anon_sym_and] = ACTIONS(1320),
    [anon_sym_or] = ACTIONS(1320),
    [anon_sym_xor] = ACTIONS(1320),
    [anon_sym_isnt] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1318),
    [anon_sym_BANG_EQ] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(1318),
    [anon_sym_GT_EQ] = ACTIONS(1318),
    [anon_sym_LT_EQ] = ACTIONS(1318),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_PLUS_TILDE] = ACTIONS(1320),
    [anon_sym_STAR_TILDE] = ACTIONS(1320),
    [anon_sym_SLASH_TILDE] = ACTIONS(1320),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1320),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1320),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1320),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1320),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_GT_TILDE] = ACTIONS(1320),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_LT_TILDE] = ACTIONS(1320),
    [anon_sym_PLUS_QMARK] = ACTIONS(1320),
    [anon_sym_DASH_QMARK] = ACTIONS(1320),
    [anon_sym_STAR_QMARK] = ACTIONS(1320),
    [anon_sym_SLASH_QMARK] = ACTIONS(1320),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1320),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1320),
    [anon_sym_as] = ACTIONS(1320),
    [anon_sym_LPAREN2] = ACTIONS(45),
    [anon_sym_DOT_GT] = ACTIONS(1384),
    [anon_sym_TILDE] = ACTIONS(1386),
    [anon_sym_if] = ACTIONS(1318),
    [anon_sym_ifdef] = ACTIONS(1320),
    [anon_sym_iftype] = ACTIONS(1320),
    [anon_sym_for] = ACTIONS(1320),
    [anon_sym_while] = ACTIONS(1320),
    [anon_sym_try] = ACTIONS(1320),
    [anon_sym_with] = ACTIONS(1320),
    [anon_sym_repeat] = ACTIONS(1320),
    [anon_sym_do] = ACTIONS(1320),
    [anon_sym_recover] = ACTIONS(1320),
    [anon_sym_match] = ACTIONS(1320),
    [anon_sym_return] = ACTIONS(1320),
    [anon_sym_continue] = ACTIONS(1320),
    [anon_sym_break] = ACTIONS(1320),
    [anon_sym_consume] = ACTIONS(1320),
    [anon_sym_object] = ACTIONS(1320),
    [sym_number] = ACTIONS(1318),
    [sym_float] = ACTIONS(1320),
    [anon_sym_DQUOTE] = ACTIONS(1318),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1320),
    [anon_sym_SQUOTE] = ACTIONS(1320),
    [anon_sym_true] = ACTIONS(1320),
    [anon_sym_false] = ACTIONS(1320),
    [sym_this] = ACTIONS(1320),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [581] = {
    [sym_arguments] = STATE(332),
    [sym_identifier] = ACTIONS(1322),
    [anon_sym_EQ] = ACTIONS(1322),
    [anon_sym_AT] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(1324),
    [anon_sym_is] = ACTIONS(1322),
    [anon_sym_let] = ACTIONS(1324),
    [anon_sym_var] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(1322),
    [anon_sym_DOT] = ACTIONS(1380),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [sym_error] = ACTIONS(1324),
    [sym_compile_intrinsic] = ACTIONS(1324),
    [anon_sym_compile_error] = ACTIONS(1324),
    [sym_location] = ACTIONS(1324),
    [anon_sym_DASH] = ACTIONS(1322),
    [anon_sym_not] = ACTIONS(1324),
    [anon_sym_DASH_TILDE] = ACTIONS(1324),
    [anon_sym_addressof] = ACTIONS(1324),
    [anon_sym_digestof] = ACTIONS(1324),
    [anon_sym_PLUS] = ACTIONS(1322),
    [anon_sym_STAR] = ACTIONS(1322),
    [anon_sym_SLASH] = ACTIONS(1322),
    [anon_sym_PERCENT] = ACTIONS(1322),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1322),
    [anon_sym_LT_LT] = ACTIONS(1322),
    [anon_sym_GT_GT] = ACTIONS(1322),
    [anon_sym_and] = ACTIONS(1324),
    [anon_sym_or] = ACTIONS(1324),
    [anon_sym_xor] = ACTIONS(1324),
    [anon_sym_isnt] = ACTIONS(1324),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_GT] = ACTIONS(1322),
    [anon_sym_GT_EQ] = ACTIONS(1322),
    [anon_sym_LT_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1322),
    [anon_sym_PLUS_TILDE] = ACTIONS(1324),
    [anon_sym_STAR_TILDE] = ACTIONS(1324),
    [anon_sym_SLASH_TILDE] = ACTIONS(1324),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1324),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1324),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1324),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1324),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1324),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1324),
    [anon_sym_GT_TILDE] = ACTIONS(1324),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1324),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1324),
    [anon_sym_LT_TILDE] = ACTIONS(1324),
    [anon_sym_PLUS_QMARK] = ACTIONS(1324),
    [anon_sym_DASH_QMARK] = ACTIONS(1324),
    [anon_sym_STAR_QMARK] = ACTIONS(1324),
    [anon_sym_SLASH_QMARK] = ACTIONS(1324),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1324),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1324),
    [anon_sym_as] = ACTIONS(43),
    [anon_sym_LPAREN2] = ACTIONS(45),
    [anon_sym_DOT_GT] = ACTIONS(1384),
    [anon_sym_TILDE] = ACTIONS(1386),
    [anon_sym_if] = ACTIONS(1322),
    [anon_sym_ifdef] = ACTIONS(1324),
    [anon_sym_iftype] = ACTIONS(1324),
    [anon_sym_for] = ACTIONS(1324),
    [anon_sym_while] = ACTIONS(1324),
    [anon_sym_try] = ACTIONS(1324),
    [anon_sym_with] = ACTIONS(1324),
    [anon_sym_repeat] = ACTIONS(1324),
    [anon_sym_do] = ACTIONS(1324),
    [anon_sym_recover] = ACTIONS(1324),
    [anon_sym_match] = ACTIONS(1324),
    [anon_sym_return] = ACTIONS(1324),
    [anon_sym_continue] = ACTIONS(1324),
    [anon_sym_break] = ACTIONS(1324),
    [anon_sym_consume] = ACTIONS(1324),
    [anon_sym_object] = ACTIONS(1324),
    [sym_number] = ACTIONS(1322),
    [sym_float] = ACTIONS(1324),
    [anon_sym_DQUOTE] = ACTIONS(1322),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1324),
    [anon_sym_SQUOTE] = ACTIONS(1324),
    [anon_sym_true] = ACTIONS(1324),
    [anon_sym_false] = ACTIONS(1324),
    [sym_this] = ACTIONS(1324),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [582] = {
    [sym_expression] = STATE(477),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_block_repeat1] = STATE(582),
    [sym_identifier] = ACTIONS(63),
    [anon_sym_AT] = ACTIONS(68),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_let] = ACTIONS(76),
    [anon_sym_var] = ACTIONS(76),
    [anon_sym_LPAREN] = ACTIONS(1359),
    [anon_sym_PIPE] = ACTIONS(74),
    [anon_sym_LBRACE] = ACTIONS(82),
    [anon_sym_SEMI] = ACTIONS(503),
    [sym_error] = ACTIONS(88),
    [sym_compile_intrinsic] = ACTIONS(88),
    [anon_sym_compile_error] = ACTIONS(91),
    [sym_location] = ACTIONS(88),
    [anon_sym_DASH] = ACTIONS(506),
    [anon_sym_not] = ACTIONS(509),
    [anon_sym_DASH_TILDE] = ACTIONS(509),
    [anon_sym_addressof] = ACTIONS(509),
    [anon_sym_digestof] = ACTIONS(509),
    [anon_sym_end] = ACTIONS(74),
    [anon_sym_if] = ACTIONS(100),
    [anon_sym_ifdef] = ACTIONS(103),
    [anon_sym_iftype] = ACTIONS(106),
    [anon_sym_else] = ACTIONS(74),
    [anon_sym_for] = ACTIONS(109),
    [anon_sym_while] = ACTIONS(112),
    [anon_sym_try] = ACTIONS(115),
    [anon_sym_with] = ACTIONS(118),
    [anon_sym_repeat] = ACTIONS(121),
    [anon_sym_recover] = ACTIONS(124),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(512),
    [anon_sym_continue] = ACTIONS(515),
    [anon_sym_break] = ACTIONS(518),
    [anon_sym_consume] = ACTIONS(139),
    [anon_sym_object] = ACTIONS(142),
    [sym_number] = ACTIONS(145),
    [sym_float] = ACTIONS(148),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(154),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(160),
    [anon_sym_false] = ACTIONS(160),
    [sym_this] = ACTIONS(88),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [583] = {
    [sym_expression] = STATE(477),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_block_repeat1] = STATE(582),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_SEMI] = ACTIONS(493),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1388),
    [anon_sym_not] = ACTIONS(495),
    [anon_sym_DASH_TILDE] = ACTIONS(495),
    [anon_sym_addressof] = ACTIONS(495),
    [anon_sym_digestof] = ACTIONS(495),
    [anon_sym_end] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_else] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [584] = {
    [sym_expression] = STATE(481),
    [sym_compile_error] = STATE(560),
    [sym_unary_expression] = STATE(560),
    [sym_binary_expression] = STATE(560),
    [sym_tuple_expression] = STATE(560),
    [sym_generic_expression] = STATE(560),
    [sym_assignment_expression] = STATE(560),
    [sym_variable_declaration] = STATE(560),
    [sym_cast_expression] = STATE(560),
    [sym_call_expression] = STATE(560),
    [sym_chain_expression] = STATE(560),
    [sym_lambda_expression] = STATE(560),
    [sym_partial_application] = STATE(560),
    [sym_member_expression] = STATE(560),
    [sym_parenthesized_expression] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_if_block] = STATE(2180),
    [sym_iftype_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_try_statement] = STATE(560),
    [sym_with_statement] = STATE(560),
    [sym_repeat_statement] = STATE(560),
    [sym_recover_statement] = STATE(560),
    [sym_match_statement] = STATE(560),
    [sym_return_statement] = STATE(560),
    [sym_continue_statement] = STATE(560),
    [sym_break_statement] = STATE(560),
    [sym_consume_statement] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_array_literal] = STATE(561),
    [sym_object_literal] = STATE(561),
    [sym_string] = STATE(561),
    [sym__string_literal] = STATE(533),
    [sym__multiline_string_literal] = STATE(533),
    [sym_character] = STATE(561),
    [sym_boolean] = STATE(561),
    [sym_ffi_identifier] = STATE(472),
    [aux_sym_block_repeat1] = STATE(584),
    [sym_identifier] = ACTIONS(521),
    [anon_sym_AT] = ACTIONS(524),
    [anon_sym_LBRACK] = ACTIONS(527),
    [anon_sym_let] = ACTIONS(530),
    [anon_sym_var] = ACTIONS(530),
    [anon_sym_LPAREN] = ACTIONS(1390),
    [anon_sym_LBRACE] = ACTIONS(536),
    [anon_sym_SEMI] = ACTIONS(539),
    [sym_error] = ACTIONS(542),
    [sym_compile_intrinsic] = ACTIONS(542),
    [anon_sym_compile_error] = ACTIONS(545),
    [sym_location] = ACTIONS(542),
    [anon_sym_DASH] = ACTIONS(548),
    [anon_sym_not] = ACTIONS(551),
    [anon_sym_DASH_TILDE] = ACTIONS(551),
    [anon_sym_addressof] = ACTIONS(551),
    [anon_sym_digestof] = ACTIONS(551),
    [anon_sym_end] = ACTIONS(74),
    [anon_sym_if] = ACTIONS(100),
    [anon_sym_ifdef] = ACTIONS(103),
    [anon_sym_elseif] = ACTIONS(74),
    [anon_sym_iftype] = ACTIONS(554),
    [anon_sym_else] = ACTIONS(66),
    [anon_sym_for] = ACTIONS(557),
    [anon_sym_while] = ACTIONS(560),
    [anon_sym_try] = ACTIONS(563),
    [anon_sym_with] = ACTIONS(566),
    [anon_sym_repeat] = ACTIONS(569),
    [anon_sym_recover] = ACTIONS(572),
    [anon_sym_match] = ACTIONS(575),
    [anon_sym_return] = ACTIONS(578),
    [anon_sym_continue] = ACTIONS(581),
    [anon_sym_break] = ACTIONS(584),
    [anon_sym_consume] = ACTIONS(587),
    [anon_sym_object] = ACTIONS(590),
    [sym_number] = ACTIONS(593),
    [sym_float] = ACTIONS(596),
    [anon_sym_DQUOTE] = ACTIONS(599),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(602),
    [anon_sym_SQUOTE] = ACTIONS(605),
    [anon_sym_true] = ACTIONS(608),
    [anon_sym_false] = ACTIONS(608),
    [sym_this] = ACTIONS(542),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [585] = {
    [sym_expression] = STATE(481),
    [sym_compile_error] = STATE(560),
    [sym_unary_expression] = STATE(560),
    [sym_binary_expression] = STATE(560),
    [sym_tuple_expression] = STATE(560),
    [sym_generic_expression] = STATE(560),
    [sym_assignment_expression] = STATE(560),
    [sym_variable_declaration] = STATE(560),
    [sym_cast_expression] = STATE(560),
    [sym_call_expression] = STATE(560),
    [sym_chain_expression] = STATE(560),
    [sym_lambda_expression] = STATE(560),
    [sym_partial_application] = STATE(560),
    [sym_member_expression] = STATE(560),
    [sym_parenthesized_expression] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_if_block] = STATE(2180),
    [sym_iftype_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_try_statement] = STATE(560),
    [sym_with_statement] = STATE(560),
    [sym_repeat_statement] = STATE(560),
    [sym_recover_statement] = STATE(560),
    [sym_match_statement] = STATE(560),
    [sym_return_statement] = STATE(560),
    [sym_continue_statement] = STATE(560),
    [sym_break_statement] = STATE(560),
    [sym_consume_statement] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_array_literal] = STATE(561),
    [sym_object_literal] = STATE(561),
    [sym_string] = STATE(561),
    [sym__string_literal] = STATE(533),
    [sym__multiline_string_literal] = STATE(533),
    [sym_character] = STATE(561),
    [sym_boolean] = STATE(561),
    [sym_ffi_identifier] = STATE(472),
    [aux_sym_block_repeat1] = STATE(584),
    [sym_identifier] = ACTIONS(415),
    [anon_sym_AT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_let] = ACTIONS(425),
    [anon_sym_var] = ACTIONS(425),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_LBRACE] = ACTIONS(431),
    [anon_sym_SEMI] = ACTIONS(433),
    [sym_error] = ACTIONS(435),
    [sym_compile_intrinsic] = ACTIONS(435),
    [anon_sym_compile_error] = ACTIONS(437),
    [sym_location] = ACTIONS(435),
    [anon_sym_DASH] = ACTIONS(1395),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_DASH_TILDE] = ACTIONS(441),
    [anon_sym_addressof] = ACTIONS(441),
    [anon_sym_digestof] = ACTIONS(441),
    [anon_sym_end] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_elseif] = ACTIONS(165),
    [anon_sym_iftype] = ACTIONS(455),
    [anon_sym_else] = ACTIONS(163),
    [anon_sym_for] = ACTIONS(457),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(461),
    [anon_sym_with] = ACTIONS(463),
    [anon_sym_repeat] = ACTIONS(465),
    [anon_sym_recover] = ACTIONS(467),
    [anon_sym_match] = ACTIONS(469),
    [anon_sym_return] = ACTIONS(471),
    [anon_sym_continue] = ACTIONS(473),
    [anon_sym_break] = ACTIONS(475),
    [anon_sym_consume] = ACTIONS(477),
    [anon_sym_object] = ACTIONS(479),
    [sym_number] = ACTIONS(481),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [anon_sym_SQUOTE] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_this] = ACTIONS(435),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [586] = {
    [sym_expression] = STATE(956),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_named_arguments] = STATE(2223),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_RPAREN] = ACTIONS(1397),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_where] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [587] = {
    [sym_expression] = STATE(578),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_do_block] = STATE(999),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_while_statement_repeat1] = STATE(630),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_not] = ACTIONS(1415),
    [anon_sym_DASH_TILDE] = ACTIONS(1415),
    [anon_sym_addressof] = ACTIONS(1415),
    [anon_sym_digestof] = ACTIONS(1415),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_do] = ACTIONS(1417),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(1419),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1423),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [588] = {
    [sym_expression] = STATE(954),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_named_arguments] = STATE(2421),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_RPAREN] = ACTIONS(1425),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_where] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [589] = {
    [sym_annotation] = STATE(724),
    [sym_block] = STATE(1919),
    [sym_expression] = STATE(30),
    [sym_compile_error] = STATE(560),
    [sym_unary_expression] = STATE(560),
    [sym_binary_expression] = STATE(560),
    [sym_tuple_expression] = STATE(560),
    [sym_generic_expression] = STATE(560),
    [sym_assignment_expression] = STATE(560),
    [sym_variable_declaration] = STATE(560),
    [sym_cast_expression] = STATE(560),
    [sym_call_expression] = STATE(560),
    [sym_chain_expression] = STATE(560),
    [sym_lambda_expression] = STATE(560),
    [sym_partial_application] = STATE(560),
    [sym_member_expression] = STATE(560),
    [sym_parenthesized_expression] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_if_block] = STATE(2180),
    [sym_iftype_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_try_statement] = STATE(560),
    [sym_with_statement] = STATE(560),
    [sym_repeat_statement] = STATE(560),
    [sym_recover_statement] = STATE(560),
    [sym_match_statement] = STATE(560),
    [sym_return_statement] = STATE(560),
    [sym_continue_statement] = STATE(560),
    [sym_break_statement] = STATE(560),
    [sym_consume_statement] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_array_literal] = STATE(561),
    [sym_object_literal] = STATE(561),
    [sym_string] = STATE(561),
    [sym__string_literal] = STATE(533),
    [sym__multiline_string_literal] = STATE(533),
    [sym_character] = STATE(561),
    [sym_boolean] = STATE(561),
    [sym_ffi_identifier] = STATE(472),
    [sym_identifier] = ACTIONS(415),
    [anon_sym_AT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_let] = ACTIONS(425),
    [anon_sym_var] = ACTIONS(425),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_LBRACE] = ACTIONS(431),
    [sym_error] = ACTIONS(435),
    [sym_compile_intrinsic] = ACTIONS(435),
    [anon_sym_compile_error] = ACTIONS(437),
    [sym_location] = ACTIONS(435),
    [anon_sym_DASH] = ACTIONS(1395),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_DASH_TILDE] = ACTIONS(441),
    [anon_sym_addressof] = ACTIONS(441),
    [anon_sym_digestof] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(455),
    [anon_sym_for] = ACTIONS(457),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(461),
    [anon_sym_with] = ACTIONS(463),
    [anon_sym_repeat] = ACTIONS(465),
    [anon_sym_recover] = ACTIONS(467),
    [anon_sym_match] = ACTIONS(469),
    [anon_sym_return] = ACTIONS(471),
    [anon_sym_continue] = ACTIONS(473),
    [anon_sym_break] = ACTIONS(475),
    [anon_sym_consume] = ACTIONS(477),
    [anon_sym_object] = ACTIONS(479),
    [sym_number] = ACTIONS(481),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [anon_sym_SQUOTE] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_this] = ACTIONS(435),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [590] = {
    [sym_annotation] = STATE(658),
    [sym_block] = STATE(2411),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [591] = {
    [sym_expression] = STATE(578),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_do_block] = STATE(987),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_while_statement_repeat1] = STATE(630),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_not] = ACTIONS(1415),
    [anon_sym_DASH_TILDE] = ACTIONS(1415),
    [anon_sym_addressof] = ACTIONS(1415),
    [anon_sym_digestof] = ACTIONS(1415),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_do] = ACTIONS(1417),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(1419),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1423),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [592] = {
    [sym_expression] = STATE(578),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_do_block] = STATE(273),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_while_statement_repeat1] = STATE(630),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_not] = ACTIONS(1415),
    [anon_sym_DASH_TILDE] = ACTIONS(1415),
    [anon_sym_addressof] = ACTIONS(1415),
    [anon_sym_digestof] = ACTIONS(1415),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_do] = ACTIONS(1427),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(1419),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1423),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [593] = {
    [sym_annotation] = STATE(762),
    [sym_block] = STATE(2379),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [594] = {
    [sym_block] = STATE(2262),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_RBRACK] = ACTIONS(1429),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_as] = ACTIONS(1431),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [595] = {
    [sym_expression] = STATE(578),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_do_block] = STATE(559),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_while_statement_repeat1] = STATE(630),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_not] = ACTIONS(1415),
    [anon_sym_DASH_TILDE] = ACTIONS(1415),
    [anon_sym_addressof] = ACTIONS(1415),
    [anon_sym_digestof] = ACTIONS(1415),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_do] = ACTIONS(1433),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(1419),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1423),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [596] = {
    [sym_annotation] = STATE(685),
    [sym_block] = STATE(2127),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [597] = {
    [sym_annotation] = STATE(675),
    [sym_block] = STATE(1850),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [598] = {
    [sym_annotation] = STATE(738),
    [sym_block] = STATE(2329),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [599] = {
    [sym_annotation] = STATE(673),
    [sym_expression] = STATE(578),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_while_statement_repeat1] = STATE(587),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_not] = ACTIONS(1415),
    [anon_sym_DASH_TILDE] = ACTIONS(1415),
    [anon_sym_addressof] = ACTIONS(1415),
    [anon_sym_digestof] = ACTIONS(1415),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(1419),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1423),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [600] = {
    [sym_annotation] = STATE(732),
    [sym_block] = STATE(2061),
    [sym_expression] = STATE(35),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1388),
    [anon_sym_not] = ACTIONS(495),
    [anon_sym_DASH_TILDE] = ACTIONS(495),
    [anon_sym_addressof] = ACTIONS(495),
    [anon_sym_digestof] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [601] = {
    [sym_expression] = STATE(578),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_do_block] = STATE(262),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_while_statement_repeat1] = STATE(630),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_not] = ACTIONS(1415),
    [anon_sym_DASH_TILDE] = ACTIONS(1415),
    [anon_sym_addressof] = ACTIONS(1415),
    [anon_sym_digestof] = ACTIONS(1415),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_do] = ACTIONS(1427),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(1419),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1423),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [602] = {
    [sym_annotation] = STATE(728),
    [sym_block] = STATE(2096),
    [sym_expression] = STATE(35),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1388),
    [anon_sym_not] = ACTIONS(495),
    [anon_sym_DASH_TILDE] = ACTIONS(495),
    [anon_sym_addressof] = ACTIONS(495),
    [anon_sym_digestof] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [603] = {
    [sym_annotation] = STATE(656),
    [sym_block] = STATE(2132),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [604] = {
    [sym_expression] = STATE(578),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_do_block] = STATE(410),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_while_statement_repeat1] = STATE(630),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_not] = ACTIONS(1415),
    [anon_sym_DASH_TILDE] = ACTIONS(1415),
    [anon_sym_addressof] = ACTIONS(1415),
    [anon_sym_digestof] = ACTIONS(1415),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_do] = ACTIONS(1435),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(1419),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1423),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [605] = {
    [sym_annotation] = STATE(721),
    [sym_block] = STATE(2098),
    [sym_expression] = STATE(35),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1388),
    [anon_sym_not] = ACTIONS(495),
    [anon_sym_DASH_TILDE] = ACTIONS(495),
    [anon_sym_addressof] = ACTIONS(495),
    [anon_sym_digestof] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [606] = {
    [sym_annotation] = STATE(707),
    [sym_block] = STATE(1536),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [607] = {
    [sym_block] = STATE(2216),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_RBRACK] = ACTIONS(1437),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_as] = ACTIONS(1439),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [608] = {
    [sym_expression] = STATE(578),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_do_block] = STATE(356),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_while_statement_repeat1] = STATE(630),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_not] = ACTIONS(1415),
    [anon_sym_DASH_TILDE] = ACTIONS(1415),
    [anon_sym_addressof] = ACTIONS(1415),
    [anon_sym_digestof] = ACTIONS(1415),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_do] = ACTIONS(1435),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(1419),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1423),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [609] = {
    [sym_expression] = STATE(955),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_named_arguments] = STATE(2201),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_RPAREN] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_where] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [610] = {
    [sym_annotation] = STATE(700),
    [sym_block] = STATE(1919),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [611] = {
    [sym_annotation] = STATE(697),
    [sym_block] = STATE(1536),
    [sym_expression] = STATE(17),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [612] = {
    [sym_expression] = STATE(578),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_do_block] = STATE(534),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_while_statement_repeat1] = STATE(630),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_not] = ACTIONS(1415),
    [anon_sym_DASH_TILDE] = ACTIONS(1415),
    [anon_sym_addressof] = ACTIONS(1415),
    [anon_sym_digestof] = ACTIONS(1415),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_do] = ACTIONS(1433),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(1419),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1423),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [613] = {
    [sym_annotation] = STATE(683),
    [sym_block] = STATE(2051),
    [sym_expression] = STATE(35),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1388),
    [anon_sym_not] = ACTIONS(495),
    [anon_sym_DASH_TILDE] = ACTIONS(495),
    [anon_sym_addressof] = ACTIONS(495),
    [anon_sym_digestof] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [614] = {
    [sym_annotation] = STATE(655),
    [sym_expression] = STATE(578),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_while_statement_repeat1] = STATE(608),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_not] = ACTIONS(1415),
    [anon_sym_DASH_TILDE] = ACTIONS(1415),
    [anon_sym_addressof] = ACTIONS(1415),
    [anon_sym_digestof] = ACTIONS(1415),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(1419),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1423),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [615] = {
    [sym_annotation] = STATE(758),
    [sym_block] = STATE(2273),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [616] = {
    [sym_annotation] = STATE(684),
    [sym_block] = STATE(1816),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [617] = {
    [sym_annotation] = STATE(725),
    [sym_expression] = STATE(578),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_while_statement_repeat1] = STATE(601),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_not] = ACTIONS(1415),
    [anon_sym_DASH_TILDE] = ACTIONS(1415),
    [anon_sym_addressof] = ACTIONS(1415),
    [anon_sym_digestof] = ACTIONS(1415),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(1419),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1423),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [618] = {
    [sym_block] = STATE(2389),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_RBRACK] = ACTIONS(1443),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_as] = ACTIONS(1445),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [619] = {
    [sym_annotation] = STATE(642),
    [sym_expression] = STATE(578),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_while_statement_repeat1] = STATE(612),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_not] = ACTIONS(1415),
    [anon_sym_DASH_TILDE] = ACTIONS(1415),
    [anon_sym_addressof] = ACTIONS(1415),
    [anon_sym_digestof] = ACTIONS(1415),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(1419),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1423),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [620] = {
    [sym_annotation] = STATE(643),
    [sym_block] = STATE(1821),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [621] = {
    [sym_annotation] = STATE(681),
    [sym_block] = STATE(1830),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [622] = {
    [sym_expression] = STATE(957),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_named_arguments] = STATE(2471),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_RPAREN] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_where] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [623] = {
    [sym_block] = STATE(2483),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_RBRACK] = ACTIONS(1449),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_as] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [624] = {
    [sym_annotation] = STATE(817),
    [sym_expression] = STATE(1012),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [625] = {
    [sym_annotation] = STATE(788),
    [sym_expression] = STATE(1010),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [626] = {
    [sym_block] = STATE(2365),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_RBRACK] = ACTIONS(1453),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [627] = {
    [sym_block] = STATE(2288),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_RBRACK] = ACTIONS(1455),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [628] = {
    [sym_annotation] = STATE(793),
    [sym_expression] = STATE(950),
    [sym_compile_error] = STATE(1044),
    [sym_unary_expression] = STATE(1044),
    [sym_binary_expression] = STATE(1044),
    [sym_tuple_expression] = STATE(1044),
    [sym_generic_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1044),
    [sym_variable_declaration] = STATE(1044),
    [sym_cast_expression] = STATE(1044),
    [sym_call_expression] = STATE(1044),
    [sym_chain_expression] = STATE(1044),
    [sym_lambda_expression] = STATE(1044),
    [sym_partial_application] = STATE(1044),
    [sym_member_expression] = STATE(1044),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_if_statement] = STATE(1044),
    [sym_if_block] = STATE(1949),
    [sym_iftype_statement] = STATE(1044),
    [sym_for_statement] = STATE(1044),
    [sym_while_statement] = STATE(1044),
    [sym_try_statement] = STATE(1044),
    [sym_with_statement] = STATE(1044),
    [sym_repeat_statement] = STATE(1044),
    [sym_recover_statement] = STATE(1044),
    [sym_match_statement] = STATE(1044),
    [sym_return_statement] = STATE(1044),
    [sym_continue_statement] = STATE(1044),
    [sym_break_statement] = STATE(1044),
    [sym_consume_statement] = STATE(1044),
    [sym_literal] = STATE(1044),
    [sym_array_literal] = STATE(1042),
    [sym_object_literal] = STATE(1042),
    [sym_string] = STATE(1042),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(1042),
    [sym_boolean] = STATE(1042),
    [sym_ffi_identifier] = STATE(958),
    [sym_identifier] = ACTIONS(1457),
    [anon_sym_AT] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(1461),
    [anon_sym_let] = ACTIONS(1463),
    [anon_sym_var] = ACTIONS(1463),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1465),
    [anon_sym_LBRACE] = ACTIONS(1467),
    [sym_error] = ACTIONS(1469),
    [sym_compile_intrinsic] = ACTIONS(1469),
    [anon_sym_compile_error] = ACTIONS(1471),
    [sym_location] = ACTIONS(1469),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_not] = ACTIONS(1475),
    [anon_sym_DASH_TILDE] = ACTIONS(1475),
    [anon_sym_addressof] = ACTIONS(1475),
    [anon_sym_digestof] = ACTIONS(1475),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(1477),
    [anon_sym_for] = ACTIONS(1479),
    [anon_sym_while] = ACTIONS(1481),
    [anon_sym_try] = ACTIONS(1483),
    [anon_sym_with] = ACTIONS(1485),
    [anon_sym_repeat] = ACTIONS(1487),
    [anon_sym_recover] = ACTIONS(1489),
    [anon_sym_match] = ACTIONS(1491),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_continue] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_consume] = ACTIONS(1499),
    [anon_sym_object] = ACTIONS(1501),
    [sym_number] = ACTIONS(1503),
    [sym_float] = ACTIONS(1505),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(1509),
    [anon_sym_false] = ACTIONS(1509),
    [sym_this] = ACTIONS(1469),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [629] = {
    [sym_annotation] = STATE(792),
    [sym_expression] = STATE(1047),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [630] = {
    [sym_expression] = STATE(578),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_while_statement_repeat1] = STATE(630),
    [sym_identifier] = ACTIONS(1511),
    [anon_sym_AT] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1517),
    [anon_sym_let] = ACTIONS(1520),
    [anon_sym_var] = ACTIONS(1520),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_LBRACE] = ACTIONS(1526),
    [sym_error] = ACTIONS(1529),
    [sym_compile_intrinsic] = ACTIONS(1529),
    [anon_sym_compile_error] = ACTIONS(1532),
    [sym_location] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1535),
    [anon_sym_not] = ACTIONS(1538),
    [anon_sym_DASH_TILDE] = ACTIONS(1538),
    [anon_sym_addressof] = ACTIONS(1538),
    [anon_sym_digestof] = ACTIONS(1538),
    [anon_sym_if] = ACTIONS(1541),
    [anon_sym_ifdef] = ACTIONS(1544),
    [anon_sym_iftype] = ACTIONS(1547),
    [anon_sym_for] = ACTIONS(1550),
    [anon_sym_while] = ACTIONS(1553),
    [anon_sym_try] = ACTIONS(1556),
    [anon_sym_with] = ACTIONS(1559),
    [anon_sym_repeat] = ACTIONS(1562),
    [anon_sym_do] = ACTIONS(1565),
    [anon_sym_recover] = ACTIONS(1567),
    [anon_sym_match] = ACTIONS(1570),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_continue] = ACTIONS(1576),
    [anon_sym_break] = ACTIONS(1579),
    [anon_sym_consume] = ACTIONS(1582),
    [anon_sym_object] = ACTIONS(1585),
    [sym_number] = ACTIONS(1588),
    [sym_float] = ACTIONS(1591),
    [anon_sym_DQUOTE] = ACTIONS(1594),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1597),
    [anon_sym_SQUOTE] = ACTIONS(1600),
    [anon_sym_true] = ACTIONS(1603),
    [anon_sym_false] = ACTIONS(1603),
    [sym_this] = ACTIONS(1529),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [631] = {
    [sym_block] = STATE(2454),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_RBRACK] = ACTIONS(1606),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [632] = {
    [sym_annotation] = STATE(806),
    [sym_expression] = STATE(1029),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [633] = {
    [sym_block] = STATE(2301),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_RBRACK] = ACTIONS(1608),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [634] = {
    [sym_annotation] = STATE(819),
    [sym_expression] = STATE(991),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [635] = {
    [sym_annotation] = STATE(805),
    [sym_expression] = STATE(1028),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [636] = {
    [sym_annotation] = STATE(821),
    [sym_expression] = STATE(1019),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [637] = {
    [sym_annotation] = STATE(789),
    [sym_expression] = STATE(1014),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [638] = {
    [sym_block] = STATE(2464),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [639] = {
    [sym_block] = STATE(2369),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [640] = {
    [sym_block] = STATE(2056),
    [sym_expression] = STATE(35),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1388),
    [anon_sym_not] = ACTIONS(495),
    [anon_sym_DASH_TILDE] = ACTIONS(495),
    [anon_sym_addressof] = ACTIONS(495),
    [anon_sym_digestof] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [641] = {
    [sym_block] = STATE(1511),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [642] = {
    [sym_expression] = STATE(578),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_while_statement_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_not] = ACTIONS(1415),
    [anon_sym_DASH_TILDE] = ACTIONS(1415),
    [anon_sym_addressof] = ACTIONS(1415),
    [anon_sym_digestof] = ACTIONS(1415),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(1419),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1423),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [643] = {
    [sym_block] = STATE(1829),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [644] = {
    [sym_block] = STATE(316),
    [sym_expression] = STATE(22),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [645] = {
    [sym_block] = STATE(1502),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [646] = {
    [sym_block] = STATE(1500),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [647] = {
    [sym_block] = STATE(2219),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [648] = {
    [sym_block] = STATE(2077),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [649] = {
    [sym_block] = STATE(2232),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [650] = {
    [sym_block] = STATE(2307),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [651] = {
    [sym_block] = STATE(2394),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [652] = {
    [sym_block] = STATE(2514),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [653] = {
    [sym_block] = STATE(2496),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [654] = {
    [sym_block] = STATE(1478),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [655] = {
    [sym_expression] = STATE(578),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_while_statement_repeat1] = STATE(604),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_not] = ACTIONS(1415),
    [anon_sym_DASH_TILDE] = ACTIONS(1415),
    [anon_sym_addressof] = ACTIONS(1415),
    [anon_sym_digestof] = ACTIONS(1415),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(1419),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1423),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [656] = {
    [sym_block] = STATE(2160),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [657] = {
    [sym_block] = STATE(992),
    [sym_expression] = STATE(43),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1388),
    [anon_sym_not] = ACTIONS(495),
    [anon_sym_DASH_TILDE] = ACTIONS(495),
    [anon_sym_addressof] = ACTIONS(495),
    [anon_sym_digestof] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [658] = {
    [sym_block] = STATE(2415),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [659] = {
    [sym_block] = STATE(1509),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [660] = {
    [sym_block] = STATE(1503),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [661] = {
    [sym_block] = STATE(1512),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [662] = {
    [sym_block] = STATE(2493),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [663] = {
    [sym_block] = STATE(391),
    [sym_expression] = STATE(47),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [664] = {
    [sym_block] = STATE(1480),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [665] = {
    [sym_block] = STATE(1482),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [666] = {
    [sym_block] = STATE(1477),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [667] = {
    [sym_block] = STATE(2490),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [668] = {
    [sym_block] = STATE(1489),
    [sym_expression] = STATE(17),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [669] = {
    [sym_block] = STATE(2489),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [670] = {
    [sym_block] = STATE(2488),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [671] = {
    [sym_block] = STATE(1507),
    [sym_expression] = STATE(17),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [672] = {
    [sym_block] = STATE(2487),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [673] = {
    [sym_expression] = STATE(578),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_while_statement_repeat1] = STATE(591),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_not] = ACTIONS(1415),
    [anon_sym_DASH_TILDE] = ACTIONS(1415),
    [anon_sym_addressof] = ACTIONS(1415),
    [anon_sym_digestof] = ACTIONS(1415),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(1419),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1423),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [674] = {
    [sym_block] = STATE(1491),
    [sym_expression] = STATE(17),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [675] = {
    [sym_block] = STATE(1808),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [676] = {
    [sym_block] = STATE(2474),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [677] = {
    [sym_block] = STATE(1957),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [678] = {
    [sym_block] = STATE(1506),
    [sym_expression] = STATE(17),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [679] = {
    [sym_block] = STATE(1501),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [680] = {
    [sym_block] = STATE(2453),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [681] = {
    [sym_block] = STATE(1842),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [682] = {
    [sym_block] = STATE(2430),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [683] = {
    [sym_block] = STATE(1996),
    [sym_expression] = STATE(35),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1388),
    [anon_sym_not] = ACTIONS(495),
    [anon_sym_DASH_TILDE] = ACTIONS(495),
    [anon_sym_addressof] = ACTIONS(495),
    [anon_sym_digestof] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [684] = {
    [sym_block] = STATE(1853),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [685] = {
    [sym_block] = STATE(2154),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [686] = {
    [sym_block] = STATE(391),
    [sym_expression] = STATE(2),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [687] = {
    [sym_block] = STATE(1505),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [688] = {
    [sym_block] = STATE(2361),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [689] = {
    [sym_block] = STATE(2191),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [690] = {
    [sym_block] = STATE(1490),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [691] = {
    [sym_block] = STATE(1510),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [692] = {
    [sym_block] = STATE(316),
    [sym_expression] = STATE(21),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [693] = {
    [sym_block] = STATE(1481),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [694] = {
    [sym_block] = STATE(2286),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [695] = {
    [sym_block] = STATE(570),
    [sym_expression] = STATE(34),
    [sym_compile_error] = STATE(560),
    [sym_unary_expression] = STATE(560),
    [sym_binary_expression] = STATE(560),
    [sym_tuple_expression] = STATE(560),
    [sym_generic_expression] = STATE(560),
    [sym_assignment_expression] = STATE(560),
    [sym_variable_declaration] = STATE(560),
    [sym_cast_expression] = STATE(560),
    [sym_call_expression] = STATE(560),
    [sym_chain_expression] = STATE(560),
    [sym_lambda_expression] = STATE(560),
    [sym_partial_application] = STATE(560),
    [sym_member_expression] = STATE(560),
    [sym_parenthesized_expression] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_if_block] = STATE(2180),
    [sym_iftype_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_try_statement] = STATE(560),
    [sym_with_statement] = STATE(560),
    [sym_repeat_statement] = STATE(560),
    [sym_recover_statement] = STATE(560),
    [sym_match_statement] = STATE(560),
    [sym_return_statement] = STATE(560),
    [sym_continue_statement] = STATE(560),
    [sym_break_statement] = STATE(560),
    [sym_consume_statement] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_array_literal] = STATE(561),
    [sym_object_literal] = STATE(561),
    [sym_string] = STATE(561),
    [sym__string_literal] = STATE(533),
    [sym__multiline_string_literal] = STATE(533),
    [sym_character] = STATE(561),
    [sym_boolean] = STATE(561),
    [sym_ffi_identifier] = STATE(472),
    [sym_identifier] = ACTIONS(415),
    [anon_sym_AT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_let] = ACTIONS(425),
    [anon_sym_var] = ACTIONS(425),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_LBRACE] = ACTIONS(431),
    [sym_error] = ACTIONS(435),
    [sym_compile_intrinsic] = ACTIONS(435),
    [anon_sym_compile_error] = ACTIONS(437),
    [sym_location] = ACTIONS(435),
    [anon_sym_DASH] = ACTIONS(1395),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_DASH_TILDE] = ACTIONS(441),
    [anon_sym_addressof] = ACTIONS(441),
    [anon_sym_digestof] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(455),
    [anon_sym_for] = ACTIONS(457),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(461),
    [anon_sym_with] = ACTIONS(463),
    [anon_sym_repeat] = ACTIONS(465),
    [anon_sym_recover] = ACTIONS(467),
    [anon_sym_match] = ACTIONS(469),
    [anon_sym_return] = ACTIONS(471),
    [anon_sym_continue] = ACTIONS(473),
    [anon_sym_break] = ACTIONS(475),
    [anon_sym_consume] = ACTIONS(477),
    [anon_sym_object] = ACTIONS(479),
    [sym_number] = ACTIONS(481),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [anon_sym_SQUOTE] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_this] = ACTIONS(435),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [696] = {
    [sym_block] = STATE(2512),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [697] = {
    [sym_block] = STATE(1529),
    [sym_expression] = STATE(17),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [698] = {
    [sym_block] = STATE(1489),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [699] = {
    [sym_block] = STATE(2409),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [700] = {
    [sym_block] = STATE(1973),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [701] = {
    [sym_block] = STATE(1507),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [702] = {
    [sym_block] = STATE(2289),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [703] = {
    [sym_block] = STATE(2373),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [704] = {
    [sym_block] = STATE(2370),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [705] = {
    [sym_block] = STATE(1498),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [706] = {
    [sym_block] = STATE(1491),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [707] = {
    [sym_block] = STATE(1529),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [708] = {
    [sym_block] = STATE(1506),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [709] = {
    [sym_block] = STATE(316),
    [sym_expression] = STATE(8),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [710] = {
    [sym_block] = STATE(2507),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [711] = {
    [sym_block] = STATE(1481),
    [sym_expression] = STATE(17),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [712] = {
    [sym_block] = STATE(1510),
    [sym_expression] = STATE(17),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [713] = {
    [sym_block] = STATE(1505),
    [sym_expression] = STATE(17),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [714] = {
    [sym_block] = STATE(2367),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [715] = {
    [sym_block] = STATE(1498),
    [sym_expression] = STATE(17),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [716] = {
    [sym_block] = STATE(2048),
    [sym_expression] = STATE(35),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1388),
    [anon_sym_not] = ACTIONS(495),
    [anon_sym_DASH_TILDE] = ACTIONS(495),
    [anon_sym_addressof] = ACTIONS(495),
    [anon_sym_digestof] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [717] = {
    [sym_block] = STATE(2366),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [718] = {
    [sym_block] = STATE(2501),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [719] = {
    [sym_block] = STATE(1511),
    [sym_expression] = STATE(17),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [720] = {
    [sym_block] = STATE(2498),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [721] = {
    [sym_block] = STATE(2117),
    [sym_expression] = STATE(35),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1388),
    [anon_sym_not] = ACTIONS(495),
    [anon_sym_DASH_TILDE] = ACTIONS(495),
    [anon_sym_addressof] = ACTIONS(495),
    [anon_sym_digestof] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [722] = {
    [sym_block] = STATE(2480),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [723] = {
    [sym_block] = STATE(391),
    [sym_expression] = STATE(27),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1388),
    [anon_sym_not] = ACTIONS(495),
    [anon_sym_DASH_TILDE] = ACTIONS(495),
    [anon_sym_addressof] = ACTIONS(495),
    [anon_sym_digestof] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [724] = {
    [sym_block] = STATE(1973),
    [sym_expression] = STATE(30),
    [sym_compile_error] = STATE(560),
    [sym_unary_expression] = STATE(560),
    [sym_binary_expression] = STATE(560),
    [sym_tuple_expression] = STATE(560),
    [sym_generic_expression] = STATE(560),
    [sym_assignment_expression] = STATE(560),
    [sym_variable_declaration] = STATE(560),
    [sym_cast_expression] = STATE(560),
    [sym_call_expression] = STATE(560),
    [sym_chain_expression] = STATE(560),
    [sym_lambda_expression] = STATE(560),
    [sym_partial_application] = STATE(560),
    [sym_member_expression] = STATE(560),
    [sym_parenthesized_expression] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_if_block] = STATE(2180),
    [sym_iftype_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_try_statement] = STATE(560),
    [sym_with_statement] = STATE(560),
    [sym_repeat_statement] = STATE(560),
    [sym_recover_statement] = STATE(560),
    [sym_match_statement] = STATE(560),
    [sym_return_statement] = STATE(560),
    [sym_continue_statement] = STATE(560),
    [sym_break_statement] = STATE(560),
    [sym_consume_statement] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_array_literal] = STATE(561),
    [sym_object_literal] = STATE(561),
    [sym_string] = STATE(561),
    [sym__string_literal] = STATE(533),
    [sym__multiline_string_literal] = STATE(533),
    [sym_character] = STATE(561),
    [sym_boolean] = STATE(561),
    [sym_ffi_identifier] = STATE(472),
    [sym_identifier] = ACTIONS(415),
    [anon_sym_AT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_let] = ACTIONS(425),
    [anon_sym_var] = ACTIONS(425),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_LBRACE] = ACTIONS(431),
    [sym_error] = ACTIONS(435),
    [sym_compile_intrinsic] = ACTIONS(435),
    [anon_sym_compile_error] = ACTIONS(437),
    [sym_location] = ACTIONS(435),
    [anon_sym_DASH] = ACTIONS(1395),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_DASH_TILDE] = ACTIONS(441),
    [anon_sym_addressof] = ACTIONS(441),
    [anon_sym_digestof] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(455),
    [anon_sym_for] = ACTIONS(457),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(461),
    [anon_sym_with] = ACTIONS(463),
    [anon_sym_repeat] = ACTIONS(465),
    [anon_sym_recover] = ACTIONS(467),
    [anon_sym_match] = ACTIONS(469),
    [anon_sym_return] = ACTIONS(471),
    [anon_sym_continue] = ACTIONS(473),
    [anon_sym_break] = ACTIONS(475),
    [anon_sym_consume] = ACTIONS(477),
    [anon_sym_object] = ACTIONS(479),
    [sym_number] = ACTIONS(481),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [anon_sym_SQUOTE] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_this] = ACTIONS(435),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [725] = {
    [sym_expression] = STATE(578),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [aux_sym_while_statement_repeat1] = STATE(592),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_not] = ACTIONS(1415),
    [anon_sym_DASH_TILDE] = ACTIONS(1415),
    [anon_sym_addressof] = ACTIONS(1415),
    [anon_sym_digestof] = ACTIONS(1415),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(1419),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1423),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [726] = {
    [sym_block] = STATE(2437),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [727] = {
    [sym_block] = STATE(2374),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [728] = {
    [sym_block] = STATE(2092),
    [sym_expression] = STATE(35),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1388),
    [anon_sym_not] = ACTIONS(495),
    [anon_sym_DASH_TILDE] = ACTIONS(495),
    [anon_sym_addressof] = ACTIONS(495),
    [anon_sym_digestof] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [729] = {
    [sym_block] = STATE(316),
    [sym_expression] = STATE(9),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [730] = {
    [sym_block] = STATE(2321),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [731] = {
    [sym_block] = STATE(1490),
    [sym_expression] = STATE(17),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [732] = {
    [sym_block] = STATE(2055),
    [sym_expression] = STATE(35),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1388),
    [anon_sym_not] = ACTIONS(495),
    [anon_sym_DASH_TILDE] = ACTIONS(495),
    [anon_sym_addressof] = ACTIONS(495),
    [anon_sym_digestof] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [733] = {
    [sym_block] = STATE(2476),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [734] = {
    [sym_block] = STATE(2247),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [735] = {
    [sym_block] = STATE(1496),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [736] = {
    [sym_block] = STATE(1488),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [737] = {
    [sym_block] = STATE(2241),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [738] = {
    [sym_block] = STATE(2338),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [739] = {
    [sym_block] = STATE(2129),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [740] = {
    [sym_block] = STATE(1477),
    [sym_expression] = STATE(17),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [741] = {
    [sym_block] = STATE(2234),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [742] = {
    [sym_block] = STATE(1499),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [743] = {
    [sym_block] = STATE(1493),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [744] = {
    [sym_block] = STATE(1482),
    [sym_expression] = STATE(17),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [745] = {
    [sym_block] = STATE(1480),
    [sym_expression] = STATE(17),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [746] = {
    [sym_block] = STATE(1496),
    [sym_expression] = STATE(17),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [747] = {
    [sym_block] = STATE(2215),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [748] = {
    [sym_block] = STATE(1485),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [749] = {
    [sym_block] = STATE(1926),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [750] = {
    [sym_block] = STATE(1488),
    [sym_expression] = STATE(17),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [751] = {
    [sym_block] = STATE(1512),
    [sym_expression] = STATE(17),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [752] = {
    [sym_block] = STATE(1499),
    [sym_expression] = STATE(17),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [753] = {
    [sym_block] = STATE(1503),
    [sym_expression] = STATE(17),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [754] = {
    [sym_block] = STATE(1493),
    [sym_expression] = STATE(17),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [755] = {
    [sym_block] = STATE(1509),
    [sym_expression] = STATE(17),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [756] = {
    [sym_block] = STATE(2116),
    [sym_expression] = STATE(35),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1388),
    [anon_sym_not] = ACTIONS(495),
    [anon_sym_DASH_TILDE] = ACTIONS(495),
    [anon_sym_addressof] = ACTIONS(495),
    [anon_sym_digestof] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [757] = {
    [sym_block] = STATE(2292),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [758] = {
    [sym_block] = STATE(2403),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [759] = {
    [sym_block] = STATE(2405),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [760] = {
    [sym_block] = STATE(1485),
    [sym_expression] = STATE(17),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [761] = {
    [sym_block] = STATE(2208),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [762] = {
    [sym_block] = STATE(2383),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [763] = {
    [sym_block] = STATE(1478),
    [sym_expression] = STATE(17),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [764] = {
    [sym_block] = STATE(1500),
    [sym_expression] = STATE(17),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [765] = {
    [sym_block] = STATE(1502),
    [sym_expression] = STATE(17),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [766] = {
    [sym_block] = STATE(1501),
    [sym_expression] = STATE(17),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [767] = {
    [sym_block] = STATE(2350),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [768] = {
    [sym_block] = STATE(2192),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [769] = {
    [sym_block] = STATE(2079),
    [sym_expression] = STATE(35),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1388),
    [anon_sym_not] = ACTIONS(495),
    [anon_sym_DASH_TILDE] = ACTIONS(495),
    [anon_sym_addressof] = ACTIONS(495),
    [anon_sym_digestof] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [770] = {
    [sym_block] = STATE(2102),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [771] = {
    [sym_block] = STATE(2203),
    [sym_expression] = STATE(15),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [772] = {
    [sym_expression] = STATE(1078),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [773] = {
    [sym_expression] = STATE(962),
    [sym_compile_error] = STATE(1044),
    [sym_unary_expression] = STATE(1044),
    [sym_binary_expression] = STATE(1044),
    [sym_tuple_expression] = STATE(1044),
    [sym_generic_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1044),
    [sym_variable_declaration] = STATE(1044),
    [sym_cast_expression] = STATE(1044),
    [sym_call_expression] = STATE(1044),
    [sym_chain_expression] = STATE(1044),
    [sym_lambda_expression] = STATE(1044),
    [sym_partial_application] = STATE(1044),
    [sym_member_expression] = STATE(1044),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_if_statement] = STATE(1044),
    [sym_if_block] = STATE(2119),
    [sym_iftype_statement] = STATE(1044),
    [sym_for_statement] = STATE(1044),
    [sym_while_statement] = STATE(1044),
    [sym_try_statement] = STATE(1044),
    [sym_with_statement] = STATE(1044),
    [sym_repeat_statement] = STATE(1044),
    [sym_recover_statement] = STATE(1044),
    [sym_match_statement] = STATE(1044),
    [sym_return_statement] = STATE(1044),
    [sym_continue_statement] = STATE(1044),
    [sym_break_statement] = STATE(1044),
    [sym_consume_statement] = STATE(1044),
    [sym_literal] = STATE(1044),
    [sym_array_literal] = STATE(1042),
    [sym_object_literal] = STATE(1042),
    [sym_string] = STATE(1042),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(1042),
    [sym_boolean] = STATE(1042),
    [sym_ffi_identifier] = STATE(958),
    [sym_identifier] = ACTIONS(1457),
    [anon_sym_AT] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(1461),
    [anon_sym_let] = ACTIONS(1463),
    [anon_sym_var] = ACTIONS(1463),
    [anon_sym_LPAREN] = ACTIONS(1465),
    [anon_sym_LBRACE] = ACTIONS(1467),
    [sym_error] = ACTIONS(1469),
    [sym_compile_intrinsic] = ACTIONS(1469),
    [anon_sym_compile_error] = ACTIONS(1471),
    [sym_location] = ACTIONS(1469),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_not] = ACTIONS(1475),
    [anon_sym_DASH_TILDE] = ACTIONS(1475),
    [anon_sym_addressof] = ACTIONS(1475),
    [anon_sym_digestof] = ACTIONS(1475),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(1477),
    [anon_sym_for] = ACTIONS(1479),
    [anon_sym_while] = ACTIONS(1481),
    [anon_sym_try] = ACTIONS(1483),
    [anon_sym_with] = ACTIONS(1485),
    [anon_sym_repeat] = ACTIONS(1487),
    [anon_sym_recover] = ACTIONS(1489),
    [anon_sym_match] = ACTIONS(1491),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_continue] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_consume] = ACTIONS(1499),
    [anon_sym_object] = ACTIONS(1501),
    [sym_number] = ACTIONS(1503),
    [sym_float] = ACTIONS(1505),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(1509),
    [anon_sym_false] = ACTIONS(1509),
    [sym_this] = ACTIONS(1469),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [774] = {
    [sym_expression] = STATE(189),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [775] = {
    [sym_expression] = STATE(476),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1388),
    [anon_sym_not] = ACTIONS(495),
    [anon_sym_DASH_TILDE] = ACTIONS(495),
    [anon_sym_addressof] = ACTIONS(495),
    [anon_sym_digestof] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [776] = {
    [sym_expression] = STATE(918),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1610),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1612),
    [anon_sym_not] = ACTIONS(1614),
    [anon_sym_DASH_TILDE] = ACTIONS(1614),
    [anon_sym_addressof] = ACTIONS(1614),
    [anon_sym_digestof] = ACTIONS(1614),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1616),
    [anon_sym_continue] = ACTIONS(1618),
    [anon_sym_break] = ACTIONS(1620),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [777] = {
    [sym_expression] = STATE(335),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1388),
    [anon_sym_not] = ACTIONS(495),
    [anon_sym_DASH_TILDE] = ACTIONS(495),
    [anon_sym_addressof] = ACTIONS(495),
    [anon_sym_digestof] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [778] = {
    [sym_expression] = STATE(473),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1388),
    [anon_sym_not] = ACTIONS(495),
    [anon_sym_DASH_TILDE] = ACTIONS(495),
    [anon_sym_addressof] = ACTIONS(495),
    [anon_sym_digestof] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [779] = {
    [sym_expression] = STATE(952),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [780] = {
    [sym_expression] = STATE(471),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1388),
    [anon_sym_not] = ACTIONS(495),
    [anon_sym_DASH_TILDE] = ACTIONS(495),
    [anon_sym_addressof] = ACTIONS(495),
    [anon_sym_digestof] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [781] = {
    [sym_expression] = STATE(475),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1388),
    [anon_sym_not] = ACTIONS(495),
    [anon_sym_DASH_TILDE] = ACTIONS(495),
    [anon_sym_addressof] = ACTIONS(495),
    [anon_sym_digestof] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [782] = {
    [sym_expression] = STATE(333),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1388),
    [anon_sym_not] = ACTIONS(495),
    [anon_sym_DASH_TILDE] = ACTIONS(495),
    [anon_sym_addressof] = ACTIONS(495),
    [anon_sym_digestof] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [783] = {
    [sym_expression] = STATE(474),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1388),
    [anon_sym_not] = ACTIONS(495),
    [anon_sym_DASH_TILDE] = ACTIONS(495),
    [anon_sym_addressof] = ACTIONS(495),
    [anon_sym_digestof] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [784] = {
    [sym_expression] = STATE(493),
    [sym_compile_error] = STATE(560),
    [sym_unary_expression] = STATE(560),
    [sym_binary_expression] = STATE(560),
    [sym_tuple_expression] = STATE(560),
    [sym_generic_expression] = STATE(560),
    [sym_assignment_expression] = STATE(560),
    [sym_variable_declaration] = STATE(560),
    [sym_cast_expression] = STATE(560),
    [sym_call_expression] = STATE(560),
    [sym_chain_expression] = STATE(560),
    [sym_lambda_expression] = STATE(560),
    [sym_partial_application] = STATE(560),
    [sym_member_expression] = STATE(560),
    [sym_parenthesized_expression] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_if_block] = STATE(2180),
    [sym_iftype_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_try_statement] = STATE(560),
    [sym_with_statement] = STATE(560),
    [sym_repeat_statement] = STATE(560),
    [sym_recover_statement] = STATE(560),
    [sym_match_statement] = STATE(560),
    [sym_return_statement] = STATE(560),
    [sym_continue_statement] = STATE(560),
    [sym_break_statement] = STATE(560),
    [sym_consume_statement] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_array_literal] = STATE(561),
    [sym_object_literal] = STATE(561),
    [sym_string] = STATE(561),
    [sym__string_literal] = STATE(533),
    [sym__multiline_string_literal] = STATE(533),
    [sym_character] = STATE(561),
    [sym_boolean] = STATE(561),
    [sym_ffi_identifier] = STATE(472),
    [sym_identifier] = ACTIONS(415),
    [anon_sym_AT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_let] = ACTIONS(425),
    [anon_sym_var] = ACTIONS(425),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_LBRACE] = ACTIONS(431),
    [sym_error] = ACTIONS(435),
    [sym_compile_intrinsic] = ACTIONS(435),
    [anon_sym_compile_error] = ACTIONS(437),
    [sym_location] = ACTIONS(435),
    [anon_sym_DASH] = ACTIONS(1395),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_DASH_TILDE] = ACTIONS(441),
    [anon_sym_addressof] = ACTIONS(441),
    [anon_sym_digestof] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(455),
    [anon_sym_for] = ACTIONS(457),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(461),
    [anon_sym_with] = ACTIONS(463),
    [anon_sym_repeat] = ACTIONS(465),
    [anon_sym_recover] = ACTIONS(467),
    [anon_sym_match] = ACTIONS(469),
    [anon_sym_return] = ACTIONS(471),
    [anon_sym_continue] = ACTIONS(473),
    [anon_sym_break] = ACTIONS(475),
    [anon_sym_consume] = ACTIONS(477),
    [anon_sym_object] = ACTIONS(479),
    [sym_number] = ACTIONS(481),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [anon_sym_SQUOTE] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_this] = ACTIONS(435),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [785] = {
    [sym_expression] = STATE(492),
    [sym_compile_error] = STATE(560),
    [sym_unary_expression] = STATE(560),
    [sym_binary_expression] = STATE(560),
    [sym_tuple_expression] = STATE(560),
    [sym_generic_expression] = STATE(560),
    [sym_assignment_expression] = STATE(560),
    [sym_variable_declaration] = STATE(560),
    [sym_cast_expression] = STATE(560),
    [sym_call_expression] = STATE(560),
    [sym_chain_expression] = STATE(560),
    [sym_lambda_expression] = STATE(560),
    [sym_partial_application] = STATE(560),
    [sym_member_expression] = STATE(560),
    [sym_parenthesized_expression] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_if_block] = STATE(2180),
    [sym_iftype_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_try_statement] = STATE(560),
    [sym_with_statement] = STATE(560),
    [sym_repeat_statement] = STATE(560),
    [sym_recover_statement] = STATE(560),
    [sym_match_statement] = STATE(560),
    [sym_return_statement] = STATE(560),
    [sym_continue_statement] = STATE(560),
    [sym_break_statement] = STATE(560),
    [sym_consume_statement] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_array_literal] = STATE(561),
    [sym_object_literal] = STATE(561),
    [sym_string] = STATE(561),
    [sym__string_literal] = STATE(533),
    [sym__multiline_string_literal] = STATE(533),
    [sym_character] = STATE(561),
    [sym_boolean] = STATE(561),
    [sym_ffi_identifier] = STATE(472),
    [sym_identifier] = ACTIONS(415),
    [anon_sym_AT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_let] = ACTIONS(425),
    [anon_sym_var] = ACTIONS(425),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_LBRACE] = ACTIONS(431),
    [sym_error] = ACTIONS(435),
    [sym_compile_intrinsic] = ACTIONS(435),
    [anon_sym_compile_error] = ACTIONS(437),
    [sym_location] = ACTIONS(435),
    [anon_sym_DASH] = ACTIONS(1395),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_DASH_TILDE] = ACTIONS(441),
    [anon_sym_addressof] = ACTIONS(441),
    [anon_sym_digestof] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(455),
    [anon_sym_for] = ACTIONS(457),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(461),
    [anon_sym_with] = ACTIONS(463),
    [anon_sym_repeat] = ACTIONS(465),
    [anon_sym_recover] = ACTIONS(467),
    [anon_sym_match] = ACTIONS(469),
    [anon_sym_return] = ACTIONS(471),
    [anon_sym_continue] = ACTIONS(473),
    [anon_sym_break] = ACTIONS(475),
    [anon_sym_consume] = ACTIONS(477),
    [anon_sym_object] = ACTIONS(479),
    [sym_number] = ACTIONS(481),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [anon_sym_SQUOTE] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_this] = ACTIONS(435),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [786] = {
    [sym_expression] = STATE(209),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [787] = {
    [sym_expression] = STATE(951),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [788] = {
    [sym_expression] = STATE(1009),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [789] = {
    [sym_expression] = STATE(1010),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [790] = {
    [sym_expression] = STATE(1076),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [791] = {
    [sym_expression] = STATE(949),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [792] = {
    [sym_expression] = STATE(1012),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [793] = {
    [sym_expression] = STATE(953),
    [sym_compile_error] = STATE(1044),
    [sym_unary_expression] = STATE(1044),
    [sym_binary_expression] = STATE(1044),
    [sym_tuple_expression] = STATE(1044),
    [sym_generic_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1044),
    [sym_variable_declaration] = STATE(1044),
    [sym_cast_expression] = STATE(1044),
    [sym_call_expression] = STATE(1044),
    [sym_chain_expression] = STATE(1044),
    [sym_lambda_expression] = STATE(1044),
    [sym_partial_application] = STATE(1044),
    [sym_member_expression] = STATE(1044),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_if_statement] = STATE(1044),
    [sym_if_block] = STATE(2033),
    [sym_iftype_statement] = STATE(1044),
    [sym_for_statement] = STATE(1044),
    [sym_while_statement] = STATE(1044),
    [sym_try_statement] = STATE(1044),
    [sym_with_statement] = STATE(1044),
    [sym_repeat_statement] = STATE(1044),
    [sym_recover_statement] = STATE(1044),
    [sym_match_statement] = STATE(1044),
    [sym_return_statement] = STATE(1044),
    [sym_continue_statement] = STATE(1044),
    [sym_break_statement] = STATE(1044),
    [sym_consume_statement] = STATE(1044),
    [sym_literal] = STATE(1044),
    [sym_array_literal] = STATE(1042),
    [sym_object_literal] = STATE(1042),
    [sym_string] = STATE(1042),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(1042),
    [sym_boolean] = STATE(1042),
    [sym_ffi_identifier] = STATE(958),
    [sym_identifier] = ACTIONS(1457),
    [anon_sym_AT] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(1461),
    [anon_sym_let] = ACTIONS(1463),
    [anon_sym_var] = ACTIONS(1463),
    [anon_sym_LPAREN] = ACTIONS(1465),
    [anon_sym_LBRACE] = ACTIONS(1467),
    [sym_error] = ACTIONS(1469),
    [sym_compile_intrinsic] = ACTIONS(1469),
    [anon_sym_compile_error] = ACTIONS(1471),
    [sym_location] = ACTIONS(1469),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_not] = ACTIONS(1475),
    [anon_sym_DASH_TILDE] = ACTIONS(1475),
    [anon_sym_addressof] = ACTIONS(1475),
    [anon_sym_digestof] = ACTIONS(1475),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(1477),
    [anon_sym_for] = ACTIONS(1479),
    [anon_sym_while] = ACTIONS(1481),
    [anon_sym_try] = ACTIONS(1483),
    [anon_sym_with] = ACTIONS(1485),
    [anon_sym_repeat] = ACTIONS(1487),
    [anon_sym_recover] = ACTIONS(1489),
    [anon_sym_match] = ACTIONS(1491),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_continue] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_consume] = ACTIONS(1499),
    [anon_sym_object] = ACTIONS(1501),
    [sym_number] = ACTIONS(1503),
    [sym_float] = ACTIONS(1505),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(1509),
    [anon_sym_false] = ACTIONS(1509),
    [sym_this] = ACTIONS(1469),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [794] = {
    [sym_expression] = STATE(1001),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [795] = {
    [sym_expression] = STATE(1067),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [796] = {
    [sym_expression] = STATE(1017),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [797] = {
    [sym_expression] = STATE(485),
    [sym_compile_error] = STATE(560),
    [sym_unary_expression] = STATE(560),
    [sym_binary_expression] = STATE(560),
    [sym_tuple_expression] = STATE(560),
    [sym_generic_expression] = STATE(560),
    [sym_assignment_expression] = STATE(560),
    [sym_variable_declaration] = STATE(560),
    [sym_cast_expression] = STATE(560),
    [sym_call_expression] = STATE(560),
    [sym_chain_expression] = STATE(560),
    [sym_lambda_expression] = STATE(560),
    [sym_partial_application] = STATE(560),
    [sym_member_expression] = STATE(560),
    [sym_parenthesized_expression] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_if_block] = STATE(2180),
    [sym_iftype_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_try_statement] = STATE(560),
    [sym_with_statement] = STATE(560),
    [sym_repeat_statement] = STATE(560),
    [sym_recover_statement] = STATE(560),
    [sym_match_statement] = STATE(560),
    [sym_return_statement] = STATE(560),
    [sym_continue_statement] = STATE(560),
    [sym_break_statement] = STATE(560),
    [sym_consume_statement] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_array_literal] = STATE(561),
    [sym_object_literal] = STATE(561),
    [sym_string] = STATE(561),
    [sym__string_literal] = STATE(533),
    [sym__multiline_string_literal] = STATE(533),
    [sym_character] = STATE(561),
    [sym_boolean] = STATE(561),
    [sym_ffi_identifier] = STATE(472),
    [sym_identifier] = ACTIONS(415),
    [anon_sym_AT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_let] = ACTIONS(425),
    [anon_sym_var] = ACTIONS(425),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_LBRACE] = ACTIONS(431),
    [sym_error] = ACTIONS(435),
    [sym_compile_intrinsic] = ACTIONS(435),
    [anon_sym_compile_error] = ACTIONS(437),
    [sym_location] = ACTIONS(435),
    [anon_sym_DASH] = ACTIONS(1395),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_DASH_TILDE] = ACTIONS(441),
    [anon_sym_addressof] = ACTIONS(441),
    [anon_sym_digestof] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(455),
    [anon_sym_for] = ACTIONS(457),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(461),
    [anon_sym_with] = ACTIONS(463),
    [anon_sym_repeat] = ACTIONS(465),
    [anon_sym_recover] = ACTIONS(467),
    [anon_sym_match] = ACTIONS(469),
    [anon_sym_return] = ACTIONS(471),
    [anon_sym_continue] = ACTIONS(473),
    [anon_sym_break] = ACTIONS(475),
    [anon_sym_consume] = ACTIONS(477),
    [anon_sym_object] = ACTIONS(479),
    [sym_number] = ACTIONS(481),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [anon_sym_SQUOTE] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_this] = ACTIONS(435),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [798] = {
    [sym_expression] = STATE(189),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1610),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1612),
    [anon_sym_not] = ACTIONS(1614),
    [anon_sym_DASH_TILDE] = ACTIONS(1614),
    [anon_sym_addressof] = ACTIONS(1614),
    [anon_sym_digestof] = ACTIONS(1614),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1616),
    [anon_sym_continue] = ACTIONS(1618),
    [anon_sym_break] = ACTIONS(1620),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [799] = {
    [sym_expression] = STATE(491),
    [sym_compile_error] = STATE(560),
    [sym_unary_expression] = STATE(560),
    [sym_binary_expression] = STATE(560),
    [sym_tuple_expression] = STATE(560),
    [sym_generic_expression] = STATE(560),
    [sym_assignment_expression] = STATE(560),
    [sym_variable_declaration] = STATE(560),
    [sym_cast_expression] = STATE(560),
    [sym_call_expression] = STATE(560),
    [sym_chain_expression] = STATE(560),
    [sym_lambda_expression] = STATE(560),
    [sym_partial_application] = STATE(560),
    [sym_member_expression] = STATE(560),
    [sym_parenthesized_expression] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_if_block] = STATE(2180),
    [sym_iftype_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_try_statement] = STATE(560),
    [sym_with_statement] = STATE(560),
    [sym_repeat_statement] = STATE(560),
    [sym_recover_statement] = STATE(560),
    [sym_match_statement] = STATE(560),
    [sym_return_statement] = STATE(560),
    [sym_continue_statement] = STATE(560),
    [sym_break_statement] = STATE(560),
    [sym_consume_statement] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_array_literal] = STATE(561),
    [sym_object_literal] = STATE(561),
    [sym_string] = STATE(561),
    [sym__string_literal] = STATE(533),
    [sym__multiline_string_literal] = STATE(533),
    [sym_character] = STATE(561),
    [sym_boolean] = STATE(561),
    [sym_ffi_identifier] = STATE(472),
    [sym_identifier] = ACTIONS(415),
    [anon_sym_AT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_let] = ACTIONS(425),
    [anon_sym_var] = ACTIONS(425),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_LBRACE] = ACTIONS(431),
    [sym_error] = ACTIONS(435),
    [sym_compile_intrinsic] = ACTIONS(435),
    [anon_sym_compile_error] = ACTIONS(437),
    [sym_location] = ACTIONS(435),
    [anon_sym_DASH] = ACTIONS(1395),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_DASH_TILDE] = ACTIONS(441),
    [anon_sym_addressof] = ACTIONS(441),
    [anon_sym_digestof] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(455),
    [anon_sym_for] = ACTIONS(457),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(461),
    [anon_sym_with] = ACTIONS(463),
    [anon_sym_repeat] = ACTIONS(465),
    [anon_sym_recover] = ACTIONS(467),
    [anon_sym_match] = ACTIONS(469),
    [anon_sym_return] = ACTIONS(471),
    [anon_sym_continue] = ACTIONS(473),
    [anon_sym_break] = ACTIONS(475),
    [anon_sym_consume] = ACTIONS(477),
    [anon_sym_object] = ACTIONS(479),
    [sym_number] = ACTIONS(481),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [anon_sym_SQUOTE] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_this] = ACTIONS(435),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [800] = {
    [sym_expression] = STATE(581),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_not] = ACTIONS(1415),
    [anon_sym_DASH_TILDE] = ACTIONS(1415),
    [anon_sym_addressof] = ACTIONS(1415),
    [anon_sym_digestof] = ACTIONS(1415),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(1419),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1423),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [801] = {
    [sym_expression] = STATE(486),
    [sym_compile_error] = STATE(560),
    [sym_unary_expression] = STATE(560),
    [sym_binary_expression] = STATE(560),
    [sym_tuple_expression] = STATE(560),
    [sym_generic_expression] = STATE(560),
    [sym_assignment_expression] = STATE(560),
    [sym_variable_declaration] = STATE(560),
    [sym_cast_expression] = STATE(560),
    [sym_call_expression] = STATE(560),
    [sym_chain_expression] = STATE(560),
    [sym_lambda_expression] = STATE(560),
    [sym_partial_application] = STATE(560),
    [sym_member_expression] = STATE(560),
    [sym_parenthesized_expression] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_if_block] = STATE(2180),
    [sym_iftype_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_try_statement] = STATE(560),
    [sym_with_statement] = STATE(560),
    [sym_repeat_statement] = STATE(560),
    [sym_recover_statement] = STATE(560),
    [sym_match_statement] = STATE(560),
    [sym_return_statement] = STATE(560),
    [sym_continue_statement] = STATE(560),
    [sym_break_statement] = STATE(560),
    [sym_consume_statement] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_array_literal] = STATE(561),
    [sym_object_literal] = STATE(561),
    [sym_string] = STATE(561),
    [sym__string_literal] = STATE(533),
    [sym__multiline_string_literal] = STATE(533),
    [sym_character] = STATE(561),
    [sym_boolean] = STATE(561),
    [sym_ffi_identifier] = STATE(472),
    [sym_identifier] = ACTIONS(415),
    [anon_sym_AT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_let] = ACTIONS(425),
    [anon_sym_var] = ACTIONS(425),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_LBRACE] = ACTIONS(431),
    [sym_error] = ACTIONS(435),
    [sym_compile_intrinsic] = ACTIONS(435),
    [anon_sym_compile_error] = ACTIONS(437),
    [sym_location] = ACTIONS(435),
    [anon_sym_DASH] = ACTIONS(1395),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_DASH_TILDE] = ACTIONS(441),
    [anon_sym_addressof] = ACTIONS(441),
    [anon_sym_digestof] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(455),
    [anon_sym_for] = ACTIONS(457),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(461),
    [anon_sym_with] = ACTIONS(463),
    [anon_sym_repeat] = ACTIONS(465),
    [anon_sym_recover] = ACTIONS(467),
    [anon_sym_match] = ACTIONS(469),
    [anon_sym_return] = ACTIONS(471),
    [anon_sym_continue] = ACTIONS(473),
    [anon_sym_break] = ACTIONS(475),
    [anon_sym_consume] = ACTIONS(477),
    [anon_sym_object] = ACTIONS(479),
    [sym_number] = ACTIONS(481),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [anon_sym_SQUOTE] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_this] = ACTIONS(435),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [802] = {
    [sym_expression] = STATE(866),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1610),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1622),
    [anon_sym_not] = ACTIONS(1624),
    [anon_sym_DASH_TILDE] = ACTIONS(1624),
    [anon_sym_addressof] = ACTIONS(1624),
    [anon_sym_digestof] = ACTIONS(1624),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1626),
    [anon_sym_continue] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(1630),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [803] = {
    [sym_expression] = STATE(480),
    [sym_compile_error] = STATE(560),
    [sym_unary_expression] = STATE(560),
    [sym_binary_expression] = STATE(560),
    [sym_tuple_expression] = STATE(560),
    [sym_generic_expression] = STATE(560),
    [sym_assignment_expression] = STATE(560),
    [sym_variable_declaration] = STATE(560),
    [sym_cast_expression] = STATE(560),
    [sym_call_expression] = STATE(560),
    [sym_chain_expression] = STATE(560),
    [sym_lambda_expression] = STATE(560),
    [sym_partial_application] = STATE(560),
    [sym_member_expression] = STATE(560),
    [sym_parenthesized_expression] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_if_block] = STATE(2180),
    [sym_iftype_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_try_statement] = STATE(560),
    [sym_with_statement] = STATE(560),
    [sym_repeat_statement] = STATE(560),
    [sym_recover_statement] = STATE(560),
    [sym_match_statement] = STATE(560),
    [sym_return_statement] = STATE(560),
    [sym_continue_statement] = STATE(560),
    [sym_break_statement] = STATE(560),
    [sym_consume_statement] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_array_literal] = STATE(561),
    [sym_object_literal] = STATE(561),
    [sym_string] = STATE(561),
    [sym__string_literal] = STATE(533),
    [sym__multiline_string_literal] = STATE(533),
    [sym_character] = STATE(561),
    [sym_boolean] = STATE(561),
    [sym_ffi_identifier] = STATE(472),
    [sym_identifier] = ACTIONS(415),
    [anon_sym_AT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_let] = ACTIONS(425),
    [anon_sym_var] = ACTIONS(425),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_LBRACE] = ACTIONS(431),
    [sym_error] = ACTIONS(435),
    [sym_compile_intrinsic] = ACTIONS(435),
    [anon_sym_compile_error] = ACTIONS(437),
    [sym_location] = ACTIONS(435),
    [anon_sym_DASH] = ACTIONS(1395),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_DASH_TILDE] = ACTIONS(441),
    [anon_sym_addressof] = ACTIONS(441),
    [anon_sym_digestof] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(455),
    [anon_sym_for] = ACTIONS(457),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(461),
    [anon_sym_with] = ACTIONS(463),
    [anon_sym_repeat] = ACTIONS(465),
    [anon_sym_recover] = ACTIONS(467),
    [anon_sym_match] = ACTIONS(469),
    [anon_sym_return] = ACTIONS(471),
    [anon_sym_continue] = ACTIONS(473),
    [anon_sym_break] = ACTIONS(475),
    [anon_sym_consume] = ACTIONS(477),
    [anon_sym_object] = ACTIONS(479),
    [sym_number] = ACTIONS(481),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [anon_sym_SQUOTE] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_this] = ACTIONS(435),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [804] = {
    [sym_expression] = STATE(1064),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [805] = {
    [sym_expression] = STATE(1027),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [806] = {
    [sym_expression] = STATE(1028),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [807] = {
    [sym_expression] = STATE(1065),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [808] = {
    [sym_expression] = STATE(1060),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [809] = {
    [sym_expression] = STATE(487),
    [sym_compile_error] = STATE(560),
    [sym_unary_expression] = STATE(560),
    [sym_binary_expression] = STATE(560),
    [sym_tuple_expression] = STATE(560),
    [sym_generic_expression] = STATE(560),
    [sym_assignment_expression] = STATE(560),
    [sym_variable_declaration] = STATE(560),
    [sym_cast_expression] = STATE(560),
    [sym_call_expression] = STATE(560),
    [sym_chain_expression] = STATE(560),
    [sym_lambda_expression] = STATE(560),
    [sym_partial_application] = STATE(560),
    [sym_member_expression] = STATE(560),
    [sym_parenthesized_expression] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_if_block] = STATE(2180),
    [sym_iftype_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_try_statement] = STATE(560),
    [sym_with_statement] = STATE(560),
    [sym_repeat_statement] = STATE(560),
    [sym_recover_statement] = STATE(560),
    [sym_match_statement] = STATE(560),
    [sym_return_statement] = STATE(560),
    [sym_continue_statement] = STATE(560),
    [sym_break_statement] = STATE(560),
    [sym_consume_statement] = STATE(560),
    [sym_literal] = STATE(560),
    [sym_array_literal] = STATE(561),
    [sym_object_literal] = STATE(561),
    [sym_string] = STATE(561),
    [sym__string_literal] = STATE(533),
    [sym__multiline_string_literal] = STATE(533),
    [sym_character] = STATE(561),
    [sym_boolean] = STATE(561),
    [sym_ffi_identifier] = STATE(472),
    [sym_identifier] = ACTIONS(415),
    [anon_sym_AT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_let] = ACTIONS(425),
    [anon_sym_var] = ACTIONS(425),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_LBRACE] = ACTIONS(431),
    [sym_error] = ACTIONS(435),
    [sym_compile_intrinsic] = ACTIONS(435),
    [anon_sym_compile_error] = ACTIONS(437),
    [sym_location] = ACTIONS(435),
    [anon_sym_DASH] = ACTIONS(1395),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_DASH_TILDE] = ACTIONS(441),
    [anon_sym_addressof] = ACTIONS(441),
    [anon_sym_digestof] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(455),
    [anon_sym_for] = ACTIONS(457),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(461),
    [anon_sym_with] = ACTIONS(463),
    [anon_sym_repeat] = ACTIONS(465),
    [anon_sym_recover] = ACTIONS(467),
    [anon_sym_match] = ACTIONS(469),
    [anon_sym_return] = ACTIONS(471),
    [anon_sym_continue] = ACTIONS(473),
    [anon_sym_break] = ACTIONS(475),
    [anon_sym_consume] = ACTIONS(477),
    [anon_sym_object] = ACTIONS(479),
    [sym_number] = ACTIONS(481),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [anon_sym_SQUOTE] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_this] = ACTIONS(435),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [810] = {
    [sym_expression] = STATE(1063),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [811] = {
    [sym_expression] = STATE(333),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_not] = ACTIONS(1415),
    [anon_sym_DASH_TILDE] = ACTIONS(1415),
    [anon_sym_addressof] = ACTIONS(1415),
    [anon_sym_digestof] = ACTIONS(1415),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(1419),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1423),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [812] = {
    [sym_expression] = STATE(1066),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [813] = {
    [sym_expression] = STATE(1025),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [814] = {
    [sym_expression] = STATE(209),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1610),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1612),
    [anon_sym_not] = ACTIONS(1614),
    [anon_sym_DASH_TILDE] = ACTIONS(1614),
    [anon_sym_addressof] = ACTIONS(1614),
    [anon_sym_digestof] = ACTIONS(1614),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1616),
    [anon_sym_continue] = ACTIONS(1618),
    [anon_sym_break] = ACTIONS(1620),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [815] = {
    [sym_expression] = STATE(580),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_not] = ACTIONS(1415),
    [anon_sym_DASH_TILDE] = ACTIONS(1415),
    [anon_sym_addressof] = ACTIONS(1415),
    [anon_sym_digestof] = ACTIONS(1415),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(1419),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1423),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [816] = {
    [sym_expression] = STATE(906),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1610),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1622),
    [anon_sym_not] = ACTIONS(1624),
    [anon_sym_DASH_TILDE] = ACTIONS(1624),
    [anon_sym_addressof] = ACTIONS(1624),
    [anon_sym_digestof] = ACTIONS(1624),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1626),
    [anon_sym_continue] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(1630),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [817] = {
    [sym_expression] = STATE(1054),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [818] = {
    [sym_expression] = STATE(960),
    [sym_compile_error] = STATE(1044),
    [sym_unary_expression] = STATE(1044),
    [sym_binary_expression] = STATE(1044),
    [sym_tuple_expression] = STATE(1044),
    [sym_generic_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1044),
    [sym_variable_declaration] = STATE(1044),
    [sym_cast_expression] = STATE(1044),
    [sym_call_expression] = STATE(1044),
    [sym_chain_expression] = STATE(1044),
    [sym_lambda_expression] = STATE(1044),
    [sym_partial_application] = STATE(1044),
    [sym_member_expression] = STATE(1044),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_if_statement] = STATE(1044),
    [sym_if_block] = STATE(2119),
    [sym_iftype_statement] = STATE(1044),
    [sym_for_statement] = STATE(1044),
    [sym_while_statement] = STATE(1044),
    [sym_try_statement] = STATE(1044),
    [sym_with_statement] = STATE(1044),
    [sym_repeat_statement] = STATE(1044),
    [sym_recover_statement] = STATE(1044),
    [sym_match_statement] = STATE(1044),
    [sym_return_statement] = STATE(1044),
    [sym_continue_statement] = STATE(1044),
    [sym_break_statement] = STATE(1044),
    [sym_consume_statement] = STATE(1044),
    [sym_literal] = STATE(1044),
    [sym_array_literal] = STATE(1042),
    [sym_object_literal] = STATE(1042),
    [sym_string] = STATE(1042),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(1042),
    [sym_boolean] = STATE(1042),
    [sym_ffi_identifier] = STATE(958),
    [sym_identifier] = ACTIONS(1457),
    [anon_sym_AT] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(1461),
    [anon_sym_let] = ACTIONS(1463),
    [anon_sym_var] = ACTIONS(1463),
    [anon_sym_LPAREN] = ACTIONS(1465),
    [anon_sym_LBRACE] = ACTIONS(1467),
    [sym_error] = ACTIONS(1469),
    [sym_compile_intrinsic] = ACTIONS(1469),
    [anon_sym_compile_error] = ACTIONS(1471),
    [sym_location] = ACTIONS(1469),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_not] = ACTIONS(1475),
    [anon_sym_DASH_TILDE] = ACTIONS(1475),
    [anon_sym_addressof] = ACTIONS(1475),
    [anon_sym_digestof] = ACTIONS(1475),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(1477),
    [anon_sym_for] = ACTIONS(1479),
    [anon_sym_while] = ACTIONS(1481),
    [anon_sym_try] = ACTIONS(1483),
    [anon_sym_with] = ACTIONS(1485),
    [anon_sym_repeat] = ACTIONS(1487),
    [anon_sym_recover] = ACTIONS(1489),
    [anon_sym_match] = ACTIONS(1491),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_continue] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_consume] = ACTIONS(1499),
    [anon_sym_object] = ACTIONS(1501),
    [sym_number] = ACTIONS(1503),
    [sym_float] = ACTIONS(1505),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(1509),
    [anon_sym_false] = ACTIONS(1509),
    [sym_this] = ACTIONS(1469),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [819] = {
    [sym_expression] = STATE(990),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [820] = {
    [sym_expression] = STATE(579),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_not] = ACTIONS(1415),
    [anon_sym_DASH_TILDE] = ACTIONS(1415),
    [anon_sym_addressof] = ACTIONS(1415),
    [anon_sym_digestof] = ACTIONS(1415),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(1419),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1423),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [821] = {
    [sym_expression] = STATE(991),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [822] = {
    [sym_expression] = STATE(920),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1610),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1612),
    [anon_sym_not] = ACTIONS(1614),
    [anon_sym_DASH_TILDE] = ACTIONS(1614),
    [anon_sym_addressof] = ACTIONS(1614),
    [anon_sym_digestof] = ACTIONS(1614),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1616),
    [anon_sym_continue] = ACTIONS(1618),
    [anon_sym_break] = ACTIONS(1620),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [823] = {
    [sym_expression] = STATE(335),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_not] = ACTIONS(1415),
    [anon_sym_DASH_TILDE] = ACTIONS(1415),
    [anon_sym_addressof] = ACTIONS(1415),
    [anon_sym_digestof] = ACTIONS(1415),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(1419),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1423),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [824] = {
    [sym_expression] = STATE(1068),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [825] = {
    [sym_expression] = STATE(1023),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [826] = {
    [sym_expression] = STATE(975),
    [sym_compile_error] = STATE(1044),
    [sym_unary_expression] = STATE(1044),
    [sym_binary_expression] = STATE(1044),
    [sym_tuple_expression] = STATE(1044),
    [sym_generic_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1044),
    [sym_variable_declaration] = STATE(1044),
    [sym_cast_expression] = STATE(1044),
    [sym_call_expression] = STATE(1044),
    [sym_chain_expression] = STATE(1044),
    [sym_lambda_expression] = STATE(1044),
    [sym_partial_application] = STATE(1044),
    [sym_member_expression] = STATE(1044),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_if_statement] = STATE(1044),
    [sym_if_block] = STATE(2119),
    [sym_iftype_statement] = STATE(1044),
    [sym_for_statement] = STATE(1044),
    [sym_while_statement] = STATE(1044),
    [sym_try_statement] = STATE(1044),
    [sym_with_statement] = STATE(1044),
    [sym_repeat_statement] = STATE(1044),
    [sym_recover_statement] = STATE(1044),
    [sym_match_statement] = STATE(1044),
    [sym_return_statement] = STATE(1044),
    [sym_continue_statement] = STATE(1044),
    [sym_break_statement] = STATE(1044),
    [sym_consume_statement] = STATE(1044),
    [sym_literal] = STATE(1044),
    [sym_array_literal] = STATE(1042),
    [sym_object_literal] = STATE(1042),
    [sym_string] = STATE(1042),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(1042),
    [sym_boolean] = STATE(1042),
    [sym_ffi_identifier] = STATE(958),
    [sym_identifier] = ACTIONS(1457),
    [anon_sym_AT] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(1461),
    [anon_sym_let] = ACTIONS(1463),
    [anon_sym_var] = ACTIONS(1463),
    [anon_sym_LPAREN] = ACTIONS(1465),
    [anon_sym_LBRACE] = ACTIONS(1467),
    [sym_error] = ACTIONS(1469),
    [sym_compile_intrinsic] = ACTIONS(1469),
    [anon_sym_compile_error] = ACTIONS(1471),
    [sym_location] = ACTIONS(1469),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_not] = ACTIONS(1475),
    [anon_sym_DASH_TILDE] = ACTIONS(1475),
    [anon_sym_addressof] = ACTIONS(1475),
    [anon_sym_digestof] = ACTIONS(1475),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(1477),
    [anon_sym_for] = ACTIONS(1479),
    [anon_sym_while] = ACTIONS(1481),
    [anon_sym_try] = ACTIONS(1483),
    [anon_sym_with] = ACTIONS(1485),
    [anon_sym_repeat] = ACTIONS(1487),
    [anon_sym_recover] = ACTIONS(1489),
    [anon_sym_match] = ACTIONS(1491),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_continue] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_consume] = ACTIONS(1499),
    [anon_sym_object] = ACTIONS(1501),
    [sym_number] = ACTIONS(1503),
    [sym_float] = ACTIONS(1505),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(1509),
    [anon_sym_false] = ACTIONS(1509),
    [sym_this] = ACTIONS(1469),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [827] = {
    [sym_expression] = STATE(973),
    [sym_compile_error] = STATE(1044),
    [sym_unary_expression] = STATE(1044),
    [sym_binary_expression] = STATE(1044),
    [sym_tuple_expression] = STATE(1044),
    [sym_generic_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1044),
    [sym_variable_declaration] = STATE(1044),
    [sym_cast_expression] = STATE(1044),
    [sym_call_expression] = STATE(1044),
    [sym_chain_expression] = STATE(1044),
    [sym_lambda_expression] = STATE(1044),
    [sym_partial_application] = STATE(1044),
    [sym_member_expression] = STATE(1044),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_if_statement] = STATE(1044),
    [sym_if_block] = STATE(2119),
    [sym_iftype_statement] = STATE(1044),
    [sym_for_statement] = STATE(1044),
    [sym_while_statement] = STATE(1044),
    [sym_try_statement] = STATE(1044),
    [sym_with_statement] = STATE(1044),
    [sym_repeat_statement] = STATE(1044),
    [sym_recover_statement] = STATE(1044),
    [sym_match_statement] = STATE(1044),
    [sym_return_statement] = STATE(1044),
    [sym_continue_statement] = STATE(1044),
    [sym_break_statement] = STATE(1044),
    [sym_consume_statement] = STATE(1044),
    [sym_literal] = STATE(1044),
    [sym_array_literal] = STATE(1042),
    [sym_object_literal] = STATE(1042),
    [sym_string] = STATE(1042),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(1042),
    [sym_boolean] = STATE(1042),
    [sym_ffi_identifier] = STATE(958),
    [sym_identifier] = ACTIONS(1457),
    [anon_sym_AT] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(1461),
    [anon_sym_let] = ACTIONS(1463),
    [anon_sym_var] = ACTIONS(1463),
    [anon_sym_LPAREN] = ACTIONS(1465),
    [anon_sym_LBRACE] = ACTIONS(1467),
    [sym_error] = ACTIONS(1469),
    [sym_compile_intrinsic] = ACTIONS(1469),
    [anon_sym_compile_error] = ACTIONS(1471),
    [sym_location] = ACTIONS(1469),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_not] = ACTIONS(1475),
    [anon_sym_DASH_TILDE] = ACTIONS(1475),
    [anon_sym_addressof] = ACTIONS(1475),
    [anon_sym_digestof] = ACTIONS(1475),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(1477),
    [anon_sym_for] = ACTIONS(1479),
    [anon_sym_while] = ACTIONS(1481),
    [anon_sym_try] = ACTIONS(1483),
    [anon_sym_with] = ACTIONS(1485),
    [anon_sym_repeat] = ACTIONS(1487),
    [anon_sym_recover] = ACTIONS(1489),
    [anon_sym_match] = ACTIONS(1491),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_continue] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_consume] = ACTIONS(1499),
    [anon_sym_object] = ACTIONS(1501),
    [sym_number] = ACTIONS(1503),
    [sym_float] = ACTIONS(1505),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(1509),
    [anon_sym_false] = ACTIONS(1509),
    [sym_this] = ACTIONS(1469),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [828] = {
    [sym_expression] = STATE(981),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [829] = {
    [sym_expression] = STATE(1073),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [830] = {
    [sym_expression] = STATE(977),
    [sym_compile_error] = STATE(1044),
    [sym_unary_expression] = STATE(1044),
    [sym_binary_expression] = STATE(1044),
    [sym_tuple_expression] = STATE(1044),
    [sym_generic_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1044),
    [sym_variable_declaration] = STATE(1044),
    [sym_cast_expression] = STATE(1044),
    [sym_call_expression] = STATE(1044),
    [sym_chain_expression] = STATE(1044),
    [sym_lambda_expression] = STATE(1044),
    [sym_partial_application] = STATE(1044),
    [sym_member_expression] = STATE(1044),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_if_statement] = STATE(1044),
    [sym_if_block] = STATE(2119),
    [sym_iftype_statement] = STATE(1044),
    [sym_for_statement] = STATE(1044),
    [sym_while_statement] = STATE(1044),
    [sym_try_statement] = STATE(1044),
    [sym_with_statement] = STATE(1044),
    [sym_repeat_statement] = STATE(1044),
    [sym_recover_statement] = STATE(1044),
    [sym_match_statement] = STATE(1044),
    [sym_return_statement] = STATE(1044),
    [sym_continue_statement] = STATE(1044),
    [sym_break_statement] = STATE(1044),
    [sym_consume_statement] = STATE(1044),
    [sym_literal] = STATE(1044),
    [sym_array_literal] = STATE(1042),
    [sym_object_literal] = STATE(1042),
    [sym_string] = STATE(1042),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(1042),
    [sym_boolean] = STATE(1042),
    [sym_ffi_identifier] = STATE(958),
    [sym_identifier] = ACTIONS(1457),
    [anon_sym_AT] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(1461),
    [anon_sym_let] = ACTIONS(1463),
    [anon_sym_var] = ACTIONS(1463),
    [anon_sym_LPAREN] = ACTIONS(1465),
    [anon_sym_LBRACE] = ACTIONS(1467),
    [sym_error] = ACTIONS(1469),
    [sym_compile_intrinsic] = ACTIONS(1469),
    [anon_sym_compile_error] = ACTIONS(1471),
    [sym_location] = ACTIONS(1469),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_not] = ACTIONS(1475),
    [anon_sym_DASH_TILDE] = ACTIONS(1475),
    [anon_sym_addressof] = ACTIONS(1475),
    [anon_sym_digestof] = ACTIONS(1475),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(1477),
    [anon_sym_for] = ACTIONS(1479),
    [anon_sym_while] = ACTIONS(1481),
    [anon_sym_try] = ACTIONS(1483),
    [anon_sym_with] = ACTIONS(1485),
    [anon_sym_repeat] = ACTIONS(1487),
    [anon_sym_recover] = ACTIONS(1489),
    [anon_sym_match] = ACTIONS(1491),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_continue] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_consume] = ACTIONS(1499),
    [anon_sym_object] = ACTIONS(1501),
    [sym_number] = ACTIONS(1503),
    [sym_float] = ACTIONS(1505),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(1509),
    [anon_sym_false] = ACTIONS(1509),
    [sym_this] = ACTIONS(1469),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [831] = {
    [sym_expression] = STATE(1069),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [832] = {
    [sym_expression] = STATE(976),
    [sym_compile_error] = STATE(1044),
    [sym_unary_expression] = STATE(1044),
    [sym_binary_expression] = STATE(1044),
    [sym_tuple_expression] = STATE(1044),
    [sym_generic_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1044),
    [sym_variable_declaration] = STATE(1044),
    [sym_cast_expression] = STATE(1044),
    [sym_call_expression] = STATE(1044),
    [sym_chain_expression] = STATE(1044),
    [sym_lambda_expression] = STATE(1044),
    [sym_partial_application] = STATE(1044),
    [sym_member_expression] = STATE(1044),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_if_statement] = STATE(1044),
    [sym_if_block] = STATE(2119),
    [sym_iftype_statement] = STATE(1044),
    [sym_for_statement] = STATE(1044),
    [sym_while_statement] = STATE(1044),
    [sym_try_statement] = STATE(1044),
    [sym_with_statement] = STATE(1044),
    [sym_repeat_statement] = STATE(1044),
    [sym_recover_statement] = STATE(1044),
    [sym_match_statement] = STATE(1044),
    [sym_return_statement] = STATE(1044),
    [sym_continue_statement] = STATE(1044),
    [sym_break_statement] = STATE(1044),
    [sym_consume_statement] = STATE(1044),
    [sym_literal] = STATE(1044),
    [sym_array_literal] = STATE(1042),
    [sym_object_literal] = STATE(1042),
    [sym_string] = STATE(1042),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(1042),
    [sym_boolean] = STATE(1042),
    [sym_ffi_identifier] = STATE(958),
    [sym_identifier] = ACTIONS(1457),
    [anon_sym_AT] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(1461),
    [anon_sym_let] = ACTIONS(1463),
    [anon_sym_var] = ACTIONS(1463),
    [anon_sym_LPAREN] = ACTIONS(1465),
    [anon_sym_LBRACE] = ACTIONS(1467),
    [sym_error] = ACTIONS(1469),
    [sym_compile_intrinsic] = ACTIONS(1469),
    [anon_sym_compile_error] = ACTIONS(1471),
    [sym_location] = ACTIONS(1469),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_not] = ACTIONS(1475),
    [anon_sym_DASH_TILDE] = ACTIONS(1475),
    [anon_sym_addressof] = ACTIONS(1475),
    [anon_sym_digestof] = ACTIONS(1475),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(1477),
    [anon_sym_for] = ACTIONS(1479),
    [anon_sym_while] = ACTIONS(1481),
    [anon_sym_try] = ACTIONS(1483),
    [anon_sym_with] = ACTIONS(1485),
    [anon_sym_repeat] = ACTIONS(1487),
    [anon_sym_recover] = ACTIONS(1489),
    [anon_sym_match] = ACTIONS(1491),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_continue] = ACTIONS(1495),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_consume] = ACTIONS(1499),
    [anon_sym_object] = ACTIONS(1501),
    [sym_number] = ACTIONS(1503),
    [sym_float] = ACTIONS(1505),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(1509),
    [anon_sym_false] = ACTIONS(1509),
    [sym_this] = ACTIONS(1469),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [833] = {
    [sym_expression] = STATE(189),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [834] = {
    [sym_expression] = STATE(422),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [835] = {
    [sym_expression] = STATE(421),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [836] = {
    [sym_expression] = STATE(335),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [837] = {
    [sym_expression] = STATE(398),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [838] = {
    [sym_expression] = STATE(397),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [839] = {
    [sym_expression] = STATE(395),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [840] = {
    [sym_expression] = STATE(1075),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [841] = {
    [sym_expression] = STATE(333),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [842] = {
    [sym_expression] = STATE(394),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [843] = {
    [sym_expression] = STATE(420),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [844] = {
    [sym_expression] = STATE(209),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [845] = {
    [sym_expression] = STATE(419),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [846] = {
    [sym_expression] = STATE(921),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1610),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1612),
    [anon_sym_not] = ACTIONS(1614),
    [anon_sym_DASH_TILDE] = ACTIONS(1614),
    [anon_sym_addressof] = ACTIONS(1614),
    [anon_sym_digestof] = ACTIONS(1614),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1616),
    [anon_sym_continue] = ACTIONS(1618),
    [anon_sym_break] = ACTIONS(1620),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [847] = {
    [sym_expression] = STATE(1039),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [848] = {
    [sym_expression] = STATE(1079),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [849] = {
    [sym_expression] = STATE(1077),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [850] = {
    [sym_expression] = STATE(388),
    [sym_compile_error] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_tuple_expression] = STATE(390),
    [sym_generic_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_variable_declaration] = STATE(390),
    [sym_cast_expression] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_chain_expression] = STATE(390),
    [sym_lambda_expression] = STATE(390),
    [sym_partial_application] = STATE(390),
    [sym_member_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_if_block] = STATE(2182),
    [sym_iftype_statement] = STATE(390),
    [sym_for_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_with_statement] = STATE(390),
    [sym_repeat_statement] = STATE(390),
    [sym_recover_statement] = STATE(390),
    [sym_match_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_consume_statement] = STATE(390),
    [sym_literal] = STATE(390),
    [sym_array_literal] = STATE(400),
    [sym_object_literal] = STATE(400),
    [sym_string] = STATE(400),
    [sym__string_literal] = STATE(370),
    [sym__multiline_string_literal] = STATE(370),
    [sym_character] = STATE(400),
    [sym_boolean] = STATE(400),
    [sym_ffi_identifier] = STATE(324),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(343),
    [sym_error] = ACTIONS(347),
    [sym_compile_intrinsic] = ACTIONS(347),
    [anon_sym_compile_error] = ACTIONS(349),
    [sym_location] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_DASH_TILDE] = ACTIONS(351),
    [anon_sym_addressof] = ACTIONS(351),
    [anon_sym_digestof] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(355),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_with] = ACTIONS(361),
    [anon_sym_repeat] = ACTIONS(363),
    [anon_sym_recover] = ACTIONS(365),
    [anon_sym_match] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_consume] = ACTIONS(375),
    [anon_sym_object] = ACTIONS(377),
    [sym_number] = ACTIONS(379),
    [sym_float] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [sym_this] = ACTIONS(347),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [851] = {
    [sym_expression] = STATE(905),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1610),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1622),
    [anon_sym_not] = ACTIONS(1624),
    [anon_sym_DASH_TILDE] = ACTIONS(1624),
    [anon_sym_addressof] = ACTIONS(1624),
    [anon_sym_digestof] = ACTIONS(1624),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1626),
    [anon_sym_continue] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(1630),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [852] = {
    [sym_expression] = STATE(209),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1610),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1622),
    [anon_sym_not] = ACTIONS(1624),
    [anon_sym_DASH_TILDE] = ACTIONS(1624),
    [anon_sym_addressof] = ACTIONS(1624),
    [anon_sym_digestof] = ACTIONS(1624),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1626),
    [anon_sym_continue] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(1630),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [853] = {
    [sym_expression] = STATE(904),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1610),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1622),
    [anon_sym_not] = ACTIONS(1624),
    [anon_sym_DASH_TILDE] = ACTIONS(1624),
    [anon_sym_addressof] = ACTIONS(1624),
    [anon_sym_digestof] = ACTIONS(1624),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1626),
    [anon_sym_continue] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(1630),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [854] = {
    [sym_expression] = STATE(189),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1610),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1622),
    [anon_sym_not] = ACTIONS(1624),
    [anon_sym_DASH_TILDE] = ACTIONS(1624),
    [anon_sym_addressof] = ACTIONS(1624),
    [anon_sym_digestof] = ACTIONS(1624),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1626),
    [anon_sym_continue] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(1630),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [855] = {
    [sym_expression] = STATE(1071),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [856] = {
    [sym_expression] = STATE(423),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(424),
    [sym__multiline_string_literal] = STATE(424),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(187),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_not] = ACTIONS(191),
    [anon_sym_DASH_TILDE] = ACTIONS(191),
    [anon_sym_addressof] = ACTIONS(191),
    [anon_sym_digestof] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(225),
    [anon_sym_continue] = ACTIONS(227),
    [anon_sym_break] = ACTIONS(229),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(395),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [857] = {
    [sym_expression] = STATE(907),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1610),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1612),
    [anon_sym_not] = ACTIONS(1614),
    [anon_sym_DASH_TILDE] = ACTIONS(1614),
    [anon_sym_addressof] = ACTIONS(1614),
    [anon_sym_digestof] = ACTIONS(1614),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1616),
    [anon_sym_continue] = ACTIONS(1618),
    [anon_sym_break] = ACTIONS(1620),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [858] = {
    [sym_expression] = STATE(1074),
    [sym_compile_error] = STATE(270),
    [sym_unary_expression] = STATE(270),
    [sym_binary_expression] = STATE(270),
    [sym_tuple_expression] = STATE(270),
    [sym_generic_expression] = STATE(270),
    [sym_assignment_expression] = STATE(270),
    [sym_variable_declaration] = STATE(270),
    [sym_cast_expression] = STATE(270),
    [sym_call_expression] = STATE(270),
    [sym_chain_expression] = STATE(270),
    [sym_lambda_expression] = STATE(270),
    [sym_partial_application] = STATE(270),
    [sym_member_expression] = STATE(270),
    [sym_parenthesized_expression] = STATE(270),
    [sym_if_statement] = STATE(270),
    [sym_if_block] = STATE(2178),
    [sym_iftype_statement] = STATE(270),
    [sym_for_statement] = STATE(270),
    [sym_while_statement] = STATE(270),
    [sym_try_statement] = STATE(270),
    [sym_with_statement] = STATE(270),
    [sym_repeat_statement] = STATE(270),
    [sym_recover_statement] = STATE(270),
    [sym_match_statement] = STATE(270),
    [sym_return_statement] = STATE(270),
    [sym_continue_statement] = STATE(270),
    [sym_break_statement] = STATE(270),
    [sym_consume_statement] = STATE(270),
    [sym_literal] = STATE(270),
    [sym_array_literal] = STATE(274),
    [sym_object_literal] = STATE(274),
    [sym_string] = STATE(274),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [sym_character] = STATE(274),
    [sym_boolean] = STATE(274),
    [sym_ffi_identifier] = STATE(186),
    [sym_identifier] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(181),
    [sym_error] = ACTIONS(185),
    [sym_compile_intrinsic] = ACTIONS(185),
    [anon_sym_compile_error] = ACTIONS(1399),
    [sym_location] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_not] = ACTIONS(1403),
    [anon_sym_DASH_TILDE] = ACTIONS(1403),
    [anon_sym_addressof] = ACTIONS(1403),
    [anon_sym_digestof] = ACTIONS(1403),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_ifdef] = ACTIONS(207),
    [anon_sym_iftype] = ACTIONS(209),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_try] = ACTIONS(215),
    [anon_sym_with] = ACTIONS(217),
    [anon_sym_repeat] = ACTIONS(219),
    [anon_sym_recover] = ACTIONS(221),
    [anon_sym_match] = ACTIONS(223),
    [anon_sym_return] = ACTIONS(1407),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1411),
    [anon_sym_consume] = ACTIONS(231),
    [anon_sym_object] = ACTIONS(233),
    [sym_number] = ACTIONS(235),
    [sym_float] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [anon_sym_true] = ACTIONS(241),
    [anon_sym_false] = ACTIONS(241),
    [sym_this] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [859] = {
    [ts_builtin_sym_end] = ACTIONS(1016),
    [anon_sym_use] = ACTIONS(1016),
    [anon_sym_EQ] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1016),
    [anon_sym_is] = ACTIONS(1018),
    [anon_sym_actor] = ACTIONS(1016),
    [anon_sym_class] = ACTIONS(1016),
    [anon_sym_primitive] = ACTIONS(1016),
    [anon_sym_interface] = ACTIONS(1016),
    [anon_sym_trait] = ACTIONS(1016),
    [anon_sym_struct] = ACTIONS(1016),
    [anon_sym_embed] = ACTIONS(1016),
    [anon_sym_let] = ACTIONS(1016),
    [anon_sym_var] = ACTIONS(1016),
    [anon_sym_new] = ACTIONS(1016),
    [anon_sym_EQ_GT] = ACTIONS(1016),
    [anon_sym_fun] = ACTIONS(1016),
    [anon_sym_be] = ACTIONS(1016),
    [anon_sym_COMMA] = ACTIONS(1016),
    [anon_sym_RPAREN] = ACTIONS(1016),
    [anon_sym_DOT] = ACTIONS(1018),
    [anon_sym_PIPE] = ACTIONS(1016),
    [anon_sym_DASH] = ACTIONS(1018),
    [anon_sym_DASH_TILDE] = ACTIONS(1016),
    [anon_sym_PLUS] = ACTIONS(1018),
    [anon_sym_STAR] = ACTIONS(1018),
    [anon_sym_SLASH] = ACTIONS(1018),
    [anon_sym_PERCENT] = ACTIONS(1018),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1018),
    [anon_sym_LT_LT] = ACTIONS(1018),
    [anon_sym_GT_GT] = ACTIONS(1018),
    [anon_sym_and] = ACTIONS(1016),
    [anon_sym_or] = ACTIONS(1016),
    [anon_sym_xor] = ACTIONS(1016),
    [anon_sym_isnt] = ACTIONS(1016),
    [anon_sym_EQ_EQ] = ACTIONS(1018),
    [anon_sym_BANG_EQ] = ACTIONS(1018),
    [anon_sym_GT] = ACTIONS(1018),
    [anon_sym_GT_EQ] = ACTIONS(1018),
    [anon_sym_LT_EQ] = ACTIONS(1018),
    [anon_sym_LT] = ACTIONS(1018),
    [anon_sym_PLUS_TILDE] = ACTIONS(1016),
    [anon_sym_STAR_TILDE] = ACTIONS(1016),
    [anon_sym_SLASH_TILDE] = ACTIONS(1016),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1016),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1016),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1016),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1016),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1016),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1016),
    [anon_sym_GT_TILDE] = ACTIONS(1016),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1016),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1016),
    [anon_sym_LT_TILDE] = ACTIONS(1016),
    [anon_sym_PLUS_QMARK] = ACTIONS(1016),
    [anon_sym_DASH_QMARK] = ACTIONS(1016),
    [anon_sym_STAR_QMARK] = ACTIONS(1016),
    [anon_sym_SLASH_QMARK] = ACTIONS(1016),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1016),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1016),
    [anon_sym_as] = ACTIONS(1016),
    [anon_sym_LPAREN2] = ACTIONS(1016),
    [anon_sym_DOT_GT] = ACTIONS(1016),
    [anon_sym_where] = ACTIONS(1016),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_end] = ACTIONS(1016),
    [anon_sym_if] = ACTIONS(1018),
    [anon_sym_ifdef] = ACTIONS(1016),
    [anon_sym_else] = ACTIONS(1016),
    [anon_sym_do] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(1018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1016),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [860] = {
    [ts_builtin_sym_end] = ACTIONS(1028),
    [anon_sym_use] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(1030),
    [anon_sym_LBRACK] = ACTIONS(1028),
    [anon_sym_type] = ACTIONS(1028),
    [anon_sym_is] = ACTIONS(1030),
    [anon_sym_actor] = ACTIONS(1028),
    [anon_sym_class] = ACTIONS(1028),
    [anon_sym_primitive] = ACTIONS(1028),
    [anon_sym_interface] = ACTIONS(1028),
    [anon_sym_trait] = ACTIONS(1028),
    [anon_sym_struct] = ACTIONS(1028),
    [anon_sym_embed] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(1028),
    [anon_sym_var] = ACTIONS(1028),
    [anon_sym_new] = ACTIONS(1028),
    [anon_sym_EQ_GT] = ACTIONS(1028),
    [anon_sym_fun] = ACTIONS(1028),
    [anon_sym_be] = ACTIONS(1028),
    [anon_sym_COMMA] = ACTIONS(1028),
    [anon_sym_RPAREN] = ACTIONS(1028),
    [anon_sym_DOT] = ACTIONS(1030),
    [anon_sym_PIPE] = ACTIONS(1028),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_DASH_TILDE] = ACTIONS(1028),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_STAR] = ACTIONS(1030),
    [anon_sym_SLASH] = ACTIONS(1030),
    [anon_sym_PERCENT] = ACTIONS(1030),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1030),
    [anon_sym_LT_LT] = ACTIONS(1030),
    [anon_sym_GT_GT] = ACTIONS(1030),
    [anon_sym_and] = ACTIONS(1028),
    [anon_sym_or] = ACTIONS(1028),
    [anon_sym_xor] = ACTIONS(1028),
    [anon_sym_isnt] = ACTIONS(1028),
    [anon_sym_EQ_EQ] = ACTIONS(1030),
    [anon_sym_BANG_EQ] = ACTIONS(1030),
    [anon_sym_GT] = ACTIONS(1030),
    [anon_sym_GT_EQ] = ACTIONS(1030),
    [anon_sym_LT_EQ] = ACTIONS(1030),
    [anon_sym_LT] = ACTIONS(1030),
    [anon_sym_PLUS_TILDE] = ACTIONS(1028),
    [anon_sym_STAR_TILDE] = ACTIONS(1028),
    [anon_sym_SLASH_TILDE] = ACTIONS(1028),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1028),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1028),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1028),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1028),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1028),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1028),
    [anon_sym_GT_TILDE] = ACTIONS(1028),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1028),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1028),
    [anon_sym_LT_TILDE] = ACTIONS(1028),
    [anon_sym_PLUS_QMARK] = ACTIONS(1028),
    [anon_sym_DASH_QMARK] = ACTIONS(1028),
    [anon_sym_STAR_QMARK] = ACTIONS(1028),
    [anon_sym_SLASH_QMARK] = ACTIONS(1028),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1028),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1028),
    [anon_sym_as] = ACTIONS(1028),
    [anon_sym_LPAREN2] = ACTIONS(1028),
    [anon_sym_DOT_GT] = ACTIONS(1028),
    [anon_sym_where] = ACTIONS(1028),
    [anon_sym_TILDE] = ACTIONS(1028),
    [anon_sym_end] = ACTIONS(1028),
    [anon_sym_if] = ACTIONS(1030),
    [anon_sym_ifdef] = ACTIONS(1028),
    [anon_sym_else] = ACTIONS(1028),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_DQUOTE] = ACTIONS(1030),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1028),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [861] = {
    [ts_builtin_sym_end] = ACTIONS(1020),
    [anon_sym_use] = ACTIONS(1020),
    [anon_sym_EQ] = ACTIONS(1022),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_type] = ACTIONS(1020),
    [anon_sym_is] = ACTIONS(1022),
    [anon_sym_actor] = ACTIONS(1020),
    [anon_sym_class] = ACTIONS(1020),
    [anon_sym_primitive] = ACTIONS(1020),
    [anon_sym_interface] = ACTIONS(1020),
    [anon_sym_trait] = ACTIONS(1020),
    [anon_sym_struct] = ACTIONS(1020),
    [anon_sym_embed] = ACTIONS(1020),
    [anon_sym_let] = ACTIONS(1020),
    [anon_sym_var] = ACTIONS(1020),
    [anon_sym_new] = ACTIONS(1020),
    [anon_sym_EQ_GT] = ACTIONS(1020),
    [anon_sym_fun] = ACTIONS(1020),
    [anon_sym_be] = ACTIONS(1020),
    [anon_sym_COMMA] = ACTIONS(1020),
    [anon_sym_RPAREN] = ACTIONS(1020),
    [anon_sym_DOT] = ACTIONS(1022),
    [anon_sym_PIPE] = ACTIONS(1020),
    [anon_sym_DASH] = ACTIONS(1022),
    [anon_sym_DASH_TILDE] = ACTIONS(1020),
    [anon_sym_PLUS] = ACTIONS(1022),
    [anon_sym_STAR] = ACTIONS(1022),
    [anon_sym_SLASH] = ACTIONS(1022),
    [anon_sym_PERCENT] = ACTIONS(1022),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1022),
    [anon_sym_LT_LT] = ACTIONS(1022),
    [anon_sym_GT_GT] = ACTIONS(1022),
    [anon_sym_and] = ACTIONS(1020),
    [anon_sym_or] = ACTIONS(1020),
    [anon_sym_xor] = ACTIONS(1020),
    [anon_sym_isnt] = ACTIONS(1020),
    [anon_sym_EQ_EQ] = ACTIONS(1022),
    [anon_sym_BANG_EQ] = ACTIONS(1022),
    [anon_sym_GT] = ACTIONS(1022),
    [anon_sym_GT_EQ] = ACTIONS(1022),
    [anon_sym_LT_EQ] = ACTIONS(1022),
    [anon_sym_LT] = ACTIONS(1022),
    [anon_sym_PLUS_TILDE] = ACTIONS(1020),
    [anon_sym_STAR_TILDE] = ACTIONS(1020),
    [anon_sym_SLASH_TILDE] = ACTIONS(1020),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1020),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1020),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1020),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1020),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1020),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1020),
    [anon_sym_GT_TILDE] = ACTIONS(1020),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1020),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1020),
    [anon_sym_LT_TILDE] = ACTIONS(1020),
    [anon_sym_PLUS_QMARK] = ACTIONS(1020),
    [anon_sym_DASH_QMARK] = ACTIONS(1020),
    [anon_sym_STAR_QMARK] = ACTIONS(1020),
    [anon_sym_SLASH_QMARK] = ACTIONS(1020),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1020),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1020),
    [anon_sym_as] = ACTIONS(1020),
    [anon_sym_LPAREN2] = ACTIONS(1020),
    [anon_sym_DOT_GT] = ACTIONS(1020),
    [anon_sym_where] = ACTIONS(1020),
    [anon_sym_TILDE] = ACTIONS(1020),
    [anon_sym_end] = ACTIONS(1020),
    [anon_sym_if] = ACTIONS(1022),
    [anon_sym_ifdef] = ACTIONS(1020),
    [anon_sym_else] = ACTIONS(1020),
    [anon_sym_do] = ACTIONS(1020),
    [anon_sym_DQUOTE] = ACTIONS(1022),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1020),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [862] = {
    [ts_builtin_sym_end] = ACTIONS(1024),
    [anon_sym_use] = ACTIONS(1024),
    [anon_sym_EQ] = ACTIONS(1026),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_type] = ACTIONS(1024),
    [anon_sym_is] = ACTIONS(1026),
    [anon_sym_actor] = ACTIONS(1024),
    [anon_sym_class] = ACTIONS(1024),
    [anon_sym_primitive] = ACTIONS(1024),
    [anon_sym_interface] = ACTIONS(1024),
    [anon_sym_trait] = ACTIONS(1024),
    [anon_sym_struct] = ACTIONS(1024),
    [anon_sym_embed] = ACTIONS(1024),
    [anon_sym_let] = ACTIONS(1024),
    [anon_sym_var] = ACTIONS(1024),
    [anon_sym_new] = ACTIONS(1024),
    [anon_sym_EQ_GT] = ACTIONS(1024),
    [anon_sym_fun] = ACTIONS(1024),
    [anon_sym_be] = ACTIONS(1024),
    [anon_sym_COMMA] = ACTIONS(1024),
    [anon_sym_RPAREN] = ACTIONS(1024),
    [anon_sym_DOT] = ACTIONS(1026),
    [anon_sym_PIPE] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1026),
    [anon_sym_DASH_TILDE] = ACTIONS(1024),
    [anon_sym_PLUS] = ACTIONS(1026),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_SLASH] = ACTIONS(1026),
    [anon_sym_PERCENT] = ACTIONS(1026),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1026),
    [anon_sym_LT_LT] = ACTIONS(1026),
    [anon_sym_GT_GT] = ACTIONS(1026),
    [anon_sym_and] = ACTIONS(1024),
    [anon_sym_or] = ACTIONS(1024),
    [anon_sym_xor] = ACTIONS(1024),
    [anon_sym_isnt] = ACTIONS(1024),
    [anon_sym_EQ_EQ] = ACTIONS(1026),
    [anon_sym_BANG_EQ] = ACTIONS(1026),
    [anon_sym_GT] = ACTIONS(1026),
    [anon_sym_GT_EQ] = ACTIONS(1026),
    [anon_sym_LT_EQ] = ACTIONS(1026),
    [anon_sym_LT] = ACTIONS(1026),
    [anon_sym_PLUS_TILDE] = ACTIONS(1024),
    [anon_sym_STAR_TILDE] = ACTIONS(1024),
    [anon_sym_SLASH_TILDE] = ACTIONS(1024),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1024),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1024),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1024),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1024),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1024),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1024),
    [anon_sym_GT_TILDE] = ACTIONS(1024),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1024),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1024),
    [anon_sym_LT_TILDE] = ACTIONS(1024),
    [anon_sym_PLUS_QMARK] = ACTIONS(1024),
    [anon_sym_DASH_QMARK] = ACTIONS(1024),
    [anon_sym_STAR_QMARK] = ACTIONS(1024),
    [anon_sym_SLASH_QMARK] = ACTIONS(1024),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1024),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1024),
    [anon_sym_as] = ACTIONS(1024),
    [anon_sym_LPAREN2] = ACTIONS(1024),
    [anon_sym_DOT_GT] = ACTIONS(1024),
    [anon_sym_where] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1024),
    [anon_sym_end] = ACTIONS(1024),
    [anon_sym_if] = ACTIONS(1026),
    [anon_sym_ifdef] = ACTIONS(1024),
    [anon_sym_else] = ACTIONS(1024),
    [anon_sym_do] = ACTIONS(1024),
    [anon_sym_DQUOTE] = ACTIONS(1026),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1024),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [863] = {
    [ts_builtin_sym_end] = ACTIONS(1040),
    [anon_sym_use] = ACTIONS(1040),
    [anon_sym_EQ] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1040),
    [anon_sym_type] = ACTIONS(1040),
    [anon_sym_is] = ACTIONS(1042),
    [anon_sym_actor] = ACTIONS(1040),
    [anon_sym_class] = ACTIONS(1040),
    [anon_sym_primitive] = ACTIONS(1040),
    [anon_sym_interface] = ACTIONS(1040),
    [anon_sym_trait] = ACTIONS(1040),
    [anon_sym_struct] = ACTIONS(1040),
    [anon_sym_embed] = ACTIONS(1040),
    [anon_sym_let] = ACTIONS(1040),
    [anon_sym_var] = ACTIONS(1040),
    [anon_sym_new] = ACTIONS(1040),
    [anon_sym_EQ_GT] = ACTIONS(1040),
    [anon_sym_fun] = ACTIONS(1040),
    [anon_sym_be] = ACTIONS(1040),
    [anon_sym_COMMA] = ACTIONS(1040),
    [anon_sym_RPAREN] = ACTIONS(1040),
    [anon_sym_DOT] = ACTIONS(1042),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_DASH] = ACTIONS(1042),
    [anon_sym_DASH_TILDE] = ACTIONS(1040),
    [anon_sym_PLUS] = ACTIONS(1042),
    [anon_sym_STAR] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(1042),
    [anon_sym_PERCENT] = ACTIONS(1042),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1042),
    [anon_sym_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_GT] = ACTIONS(1042),
    [anon_sym_and] = ACTIONS(1040),
    [anon_sym_or] = ACTIONS(1040),
    [anon_sym_xor] = ACTIONS(1040),
    [anon_sym_isnt] = ACTIONS(1040),
    [anon_sym_EQ_EQ] = ACTIONS(1042),
    [anon_sym_BANG_EQ] = ACTIONS(1042),
    [anon_sym_GT] = ACTIONS(1042),
    [anon_sym_GT_EQ] = ACTIONS(1042),
    [anon_sym_LT_EQ] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_PLUS_TILDE] = ACTIONS(1040),
    [anon_sym_STAR_TILDE] = ACTIONS(1040),
    [anon_sym_SLASH_TILDE] = ACTIONS(1040),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1040),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1040),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1040),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1040),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1040),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1040),
    [anon_sym_GT_TILDE] = ACTIONS(1040),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1040),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1040),
    [anon_sym_LT_TILDE] = ACTIONS(1040),
    [anon_sym_PLUS_QMARK] = ACTIONS(1040),
    [anon_sym_DASH_QMARK] = ACTIONS(1040),
    [anon_sym_STAR_QMARK] = ACTIONS(1040),
    [anon_sym_SLASH_QMARK] = ACTIONS(1040),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1040),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1040),
    [anon_sym_as] = ACTIONS(1040),
    [anon_sym_LPAREN2] = ACTIONS(1040),
    [anon_sym_DOT_GT] = ACTIONS(1040),
    [anon_sym_where] = ACTIONS(1040),
    [anon_sym_TILDE] = ACTIONS(1040),
    [anon_sym_end] = ACTIONS(1040),
    [anon_sym_if] = ACTIONS(1042),
    [anon_sym_ifdef] = ACTIONS(1040),
    [anon_sym_else] = ACTIONS(1040),
    [anon_sym_do] = ACTIONS(1040),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1040),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [864] = {
    [sym_type_args] = STATE(892),
    [aux_sym_base_type_repeat1] = STATE(867),
    [anon_sym_EQ] = ACTIONS(613),
    [anon_sym_is] = ACTIONS(613),
    [anon_sym_EQ_GT] = ACTIONS(611),
    [anon_sym_iso] = ACTIONS(611),
    [anon_sym_trn] = ACTIONS(611),
    [anon_sym_ref] = ACTIONS(611),
    [anon_sym_val] = ACTIONS(611),
    [anon_sym_box] = ACTIONS(611),
    [anon_sym_tag] = ACTIONS(611),
    [anon_sym_DOT] = ACTIONS(1632),
    [anon_sym_POUNDread] = ACTIONS(611),
    [anon_sym_POUNDsend] = ACTIONS(611),
    [anon_sym_POUNDshare] = ACTIONS(611),
    [anon_sym_POUNDalias] = ACTIONS(611),
    [anon_sym_POUNDany] = ACTIONS(611),
    [anon_sym_BANG] = ACTIONS(613),
    [anon_sym_CARET] = ACTIONS(611),
    [anon_sym_PIPE] = ACTIONS(611),
    [anon_sym_AMP] = ACTIONS(611),
    [anon_sym_DASH_GT] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(613),
    [anon_sym_DASH_TILDE] = ACTIONS(611),
    [anon_sym_PLUS] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(613),
    [anon_sym_SLASH] = ACTIONS(613),
    [anon_sym_PERCENT] = ACTIONS(613),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(613),
    [anon_sym_LT_LT] = ACTIONS(613),
    [anon_sym_GT_GT] = ACTIONS(613),
    [anon_sym_and] = ACTIONS(611),
    [anon_sym_or] = ACTIONS(611),
    [anon_sym_xor] = ACTIONS(611),
    [anon_sym_isnt] = ACTIONS(611),
    [anon_sym_EQ_EQ] = ACTIONS(613),
    [anon_sym_BANG_EQ] = ACTIONS(613),
    [anon_sym_GT] = ACTIONS(613),
    [anon_sym_GT_EQ] = ACTIONS(613),
    [anon_sym_LT_EQ] = ACTIONS(613),
    [anon_sym_LT] = ACTIONS(613),
    [anon_sym_PLUS_TILDE] = ACTIONS(611),
    [anon_sym_STAR_TILDE] = ACTIONS(611),
    [anon_sym_SLASH_TILDE] = ACTIONS(611),
    [anon_sym_PERCENT_TILDE] = ACTIONS(611),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(611),
    [anon_sym_LT_LT_TILDE] = ACTIONS(611),
    [anon_sym_GT_GT_TILDE] = ACTIONS(611),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(611),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(611),
    [anon_sym_GT_TILDE] = ACTIONS(611),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(611),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(611),
    [anon_sym_LT_TILDE] = ACTIONS(611),
    [anon_sym_PLUS_QMARK] = ACTIONS(611),
    [anon_sym_DASH_QMARK] = ACTIONS(611),
    [anon_sym_STAR_QMARK] = ACTIONS(611),
    [anon_sym_SLASH_QMARK] = ACTIONS(611),
    [anon_sym_PERCENT_QMARK] = ACTIONS(611),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(611),
    [anon_sym_as] = ACTIONS(611),
    [anon_sym_LPAREN2] = ACTIONS(611),
    [anon_sym_DOT_GT] = ACTIONS(611),
    [anon_sym_TILDE] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(613),
    [anon_sym_ifdef] = ACTIONS(611),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(1634),
    [sym_block_comment] = ACTIONS(3),
  },
  [865] = {
    [sym_type_args] = STATE(903),
    [aux_sym_base_type_repeat1] = STATE(864),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_is] = ACTIONS(621),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_iso] = ACTIONS(619),
    [anon_sym_trn] = ACTIONS(619),
    [anon_sym_ref] = ACTIONS(619),
    [anon_sym_val] = ACTIONS(619),
    [anon_sym_box] = ACTIONS(619),
    [anon_sym_tag] = ACTIONS(619),
    [anon_sym_DOT] = ACTIONS(1632),
    [anon_sym_POUNDread] = ACTIONS(619),
    [anon_sym_POUNDsend] = ACTIONS(619),
    [anon_sym_POUNDshare] = ACTIONS(619),
    [anon_sym_POUNDalias] = ACTIONS(619),
    [anon_sym_POUNDany] = ACTIONS(619),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_CARET] = ACTIONS(619),
    [anon_sym_PIPE] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(619),
    [anon_sym_DASH_GT] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(621),
    [anon_sym_DASH_TILDE] = ACTIONS(619),
    [anon_sym_PLUS] = ACTIONS(621),
    [anon_sym_STAR] = ACTIONS(621),
    [anon_sym_SLASH] = ACTIONS(621),
    [anon_sym_PERCENT] = ACTIONS(621),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(621),
    [anon_sym_LT_LT] = ACTIONS(621),
    [anon_sym_GT_GT] = ACTIONS(621),
    [anon_sym_and] = ACTIONS(619),
    [anon_sym_or] = ACTIONS(619),
    [anon_sym_xor] = ACTIONS(619),
    [anon_sym_isnt] = ACTIONS(619),
    [anon_sym_EQ_EQ] = ACTIONS(621),
    [anon_sym_BANG_EQ] = ACTIONS(621),
    [anon_sym_GT] = ACTIONS(621),
    [anon_sym_GT_EQ] = ACTIONS(621),
    [anon_sym_LT_EQ] = ACTIONS(621),
    [anon_sym_LT] = ACTIONS(621),
    [anon_sym_PLUS_TILDE] = ACTIONS(619),
    [anon_sym_STAR_TILDE] = ACTIONS(619),
    [anon_sym_SLASH_TILDE] = ACTIONS(619),
    [anon_sym_PERCENT_TILDE] = ACTIONS(619),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(619),
    [anon_sym_LT_LT_TILDE] = ACTIONS(619),
    [anon_sym_GT_GT_TILDE] = ACTIONS(619),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(619),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(619),
    [anon_sym_GT_TILDE] = ACTIONS(619),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(619),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(619),
    [anon_sym_LT_TILDE] = ACTIONS(619),
    [anon_sym_PLUS_QMARK] = ACTIONS(619),
    [anon_sym_DASH_QMARK] = ACTIONS(619),
    [anon_sym_STAR_QMARK] = ACTIONS(619),
    [anon_sym_SLASH_QMARK] = ACTIONS(619),
    [anon_sym_PERCENT_QMARK] = ACTIONS(619),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(619),
    [anon_sym_as] = ACTIONS(619),
    [anon_sym_LPAREN2] = ACTIONS(619),
    [anon_sym_DOT_GT] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(619),
    [anon_sym_if] = ACTIONS(621),
    [anon_sym_ifdef] = ACTIONS(619),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(1634),
    [sym_block_comment] = ACTIONS(3),
  },
  [866] = {
    [sym_arguments] = STATE(223),
    [sym_string] = STATE(1470),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [ts_builtin_sym_end] = ACTIONS(1636),
    [anon_sym_use] = ACTIONS(1636),
    [anon_sym_EQ] = ACTIONS(1638),
    [anon_sym_type] = ACTIONS(1636),
    [anon_sym_is] = ACTIONS(1640),
    [anon_sym_actor] = ACTIONS(1636),
    [anon_sym_class] = ACTIONS(1636),
    [anon_sym_primitive] = ACTIONS(1636),
    [anon_sym_interface] = ACTIONS(1636),
    [anon_sym_trait] = ACTIONS(1636),
    [anon_sym_struct] = ACTIONS(1636),
    [anon_sym_embed] = ACTIONS(1636),
    [anon_sym_let] = ACTIONS(1636),
    [anon_sym_var] = ACTIONS(1636),
    [anon_sym_new] = ACTIONS(1636),
    [anon_sym_fun] = ACTIONS(1636),
    [anon_sym_be] = ACTIONS(1636),
    [anon_sym_DOT] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1640),
    [anon_sym_DASH_TILDE] = ACTIONS(1644),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_STAR] = ACTIONS(1640),
    [anon_sym_SLASH] = ACTIONS(1640),
    [anon_sym_PERCENT] = ACTIONS(1640),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1640),
    [anon_sym_LT_LT] = ACTIONS(1640),
    [anon_sym_GT_GT] = ACTIONS(1640),
    [anon_sym_and] = ACTIONS(1644),
    [anon_sym_or] = ACTIONS(1644),
    [anon_sym_xor] = ACTIONS(1644),
    [anon_sym_isnt] = ACTIONS(1644),
    [anon_sym_EQ_EQ] = ACTIONS(1640),
    [anon_sym_BANG_EQ] = ACTIONS(1640),
    [anon_sym_GT] = ACTIONS(1640),
    [anon_sym_GT_EQ] = ACTIONS(1640),
    [anon_sym_LT_EQ] = ACTIONS(1640),
    [anon_sym_LT] = ACTIONS(1640),
    [anon_sym_PLUS_TILDE] = ACTIONS(1644),
    [anon_sym_STAR_TILDE] = ACTIONS(1644),
    [anon_sym_SLASH_TILDE] = ACTIONS(1644),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1644),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1644),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1644),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1644),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1644),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1644),
    [anon_sym_GT_TILDE] = ACTIONS(1644),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1644),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1644),
    [anon_sym_LT_TILDE] = ACTIONS(1644),
    [anon_sym_PLUS_QMARK] = ACTIONS(1644),
    [anon_sym_DASH_QMARK] = ACTIONS(1644),
    [anon_sym_STAR_QMARK] = ACTIONS(1644),
    [anon_sym_SLASH_QMARK] = ACTIONS(1644),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1644),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1644),
    [anon_sym_as] = ACTIONS(197),
    [anon_sym_LPAREN2] = ACTIONS(199),
    [anon_sym_DOT_GT] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_DQUOTE] = ACTIONS(23),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [867] = {
    [aux_sym_base_type_repeat1] = STATE(867),
    [anon_sym_EQ] = ACTIONS(625),
    [anon_sym_is] = ACTIONS(625),
    [anon_sym_EQ_GT] = ACTIONS(623),
    [anon_sym_iso] = ACTIONS(623),
    [anon_sym_trn] = ACTIONS(623),
    [anon_sym_ref] = ACTIONS(623),
    [anon_sym_val] = ACTIONS(623),
    [anon_sym_box] = ACTIONS(623),
    [anon_sym_tag] = ACTIONS(623),
    [anon_sym_DOT] = ACTIONS(1650),
    [anon_sym_POUNDread] = ACTIONS(623),
    [anon_sym_POUNDsend] = ACTIONS(623),
    [anon_sym_POUNDshare] = ACTIONS(623),
    [anon_sym_POUNDalias] = ACTIONS(623),
    [anon_sym_POUNDany] = ACTIONS(623),
    [anon_sym_BANG] = ACTIONS(625),
    [anon_sym_CARET] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(623),
    [anon_sym_AMP] = ACTIONS(623),
    [anon_sym_DASH_GT] = ACTIONS(623),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_DASH_TILDE] = ACTIONS(623),
    [anon_sym_PLUS] = ACTIONS(625),
    [anon_sym_STAR] = ACTIONS(625),
    [anon_sym_SLASH] = ACTIONS(625),
    [anon_sym_PERCENT] = ACTIONS(625),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(625),
    [anon_sym_LT_LT] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(625),
    [anon_sym_and] = ACTIONS(623),
    [anon_sym_or] = ACTIONS(623),
    [anon_sym_xor] = ACTIONS(623),
    [anon_sym_isnt] = ACTIONS(623),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(625),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_LT] = ACTIONS(625),
    [anon_sym_PLUS_TILDE] = ACTIONS(623),
    [anon_sym_STAR_TILDE] = ACTIONS(623),
    [anon_sym_SLASH_TILDE] = ACTIONS(623),
    [anon_sym_PERCENT_TILDE] = ACTIONS(623),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(623),
    [anon_sym_LT_LT_TILDE] = ACTIONS(623),
    [anon_sym_GT_GT_TILDE] = ACTIONS(623),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(623),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(623),
    [anon_sym_GT_TILDE] = ACTIONS(623),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(623),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(623),
    [anon_sym_LT_TILDE] = ACTIONS(623),
    [anon_sym_PLUS_QMARK] = ACTIONS(623),
    [anon_sym_DASH_QMARK] = ACTIONS(623),
    [anon_sym_STAR_QMARK] = ACTIONS(623),
    [anon_sym_SLASH_QMARK] = ACTIONS(623),
    [anon_sym_PERCENT_QMARK] = ACTIONS(623),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(623),
    [anon_sym_as] = ACTIONS(623),
    [anon_sym_LPAREN2] = ACTIONS(623),
    [anon_sym_DOT_GT] = ACTIONS(623),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_ifdef] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(623),
    [sym_block_comment] = ACTIONS(3),
  },
  [868] = {
    [sym_string] = STATE(314),
    [sym__string_literal] = STATE(863),
    [sym__multiline_string_literal] = STATE(863),
    [ts_builtin_sym_end] = ACTIONS(1298),
    [anon_sym_use] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(1296),
    [anon_sym_type] = ACTIONS(1298),
    [anon_sym_is] = ACTIONS(1296),
    [anon_sym_actor] = ACTIONS(1298),
    [anon_sym_class] = ACTIONS(1298),
    [anon_sym_primitive] = ACTIONS(1298),
    [anon_sym_interface] = ACTIONS(1298),
    [anon_sym_trait] = ACTIONS(1298),
    [anon_sym_struct] = ACTIONS(1298),
    [anon_sym_embed] = ACTIONS(1298),
    [anon_sym_let] = ACTIONS(1298),
    [anon_sym_var] = ACTIONS(1298),
    [anon_sym_new] = ACTIONS(1298),
    [anon_sym_fun] = ACTIONS(1298),
    [anon_sym_be] = ACTIONS(1298),
    [anon_sym_DOT] = ACTIONS(1296),
    [anon_sym_DASH] = ACTIONS(1296),
    [anon_sym_DASH_TILDE] = ACTIONS(1298),
    [anon_sym_PLUS] = ACTIONS(1296),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_SLASH] = ACTIONS(1296),
    [anon_sym_PERCENT] = ACTIONS(1296),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1296),
    [anon_sym_LT_LT] = ACTIONS(1296),
    [anon_sym_GT_GT] = ACTIONS(1296),
    [anon_sym_and] = ACTIONS(1298),
    [anon_sym_or] = ACTIONS(1298),
    [anon_sym_xor] = ACTIONS(1298),
    [anon_sym_isnt] = ACTIONS(1298),
    [anon_sym_EQ_EQ] = ACTIONS(1296),
    [anon_sym_BANG_EQ] = ACTIONS(1296),
    [anon_sym_GT] = ACTIONS(1296),
    [anon_sym_GT_EQ] = ACTIONS(1296),
    [anon_sym_LT_EQ] = ACTIONS(1296),
    [anon_sym_LT] = ACTIONS(1296),
    [anon_sym_PLUS_TILDE] = ACTIONS(1298),
    [anon_sym_STAR_TILDE] = ACTIONS(1298),
    [anon_sym_SLASH_TILDE] = ACTIONS(1298),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1298),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1298),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1298),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1298),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1298),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1298),
    [anon_sym_GT_TILDE] = ACTIONS(1298),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1298),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1298),
    [anon_sym_LT_TILDE] = ACTIONS(1298),
    [anon_sym_PLUS_QMARK] = ACTIONS(1298),
    [anon_sym_DASH_QMARK] = ACTIONS(1298),
    [anon_sym_STAR_QMARK] = ACTIONS(1298),
    [anon_sym_SLASH_QMARK] = ACTIONS(1298),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1298),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1298),
    [anon_sym_as] = ACTIONS(1298),
    [anon_sym_LPAREN2] = ACTIONS(1298),
    [anon_sym_DOT_GT] = ACTIONS(1298),
    [anon_sym_TILDE] = ACTIONS(1298),
    [anon_sym_end] = ACTIONS(1298),
    [anon_sym_DQUOTE] = ACTIONS(1296),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1298),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [869] = {
    [anon_sym_EQ] = ACTIONS(625),
    [anon_sym_is] = ACTIONS(625),
    [anon_sym_EQ_GT] = ACTIONS(623),
    [anon_sym_iso] = ACTIONS(623),
    [anon_sym_trn] = ACTIONS(623),
    [anon_sym_ref] = ACTIONS(623),
    [anon_sym_val] = ACTIONS(623),
    [anon_sym_box] = ACTIONS(623),
    [anon_sym_tag] = ACTIONS(623),
    [anon_sym_DOT] = ACTIONS(625),
    [anon_sym_POUNDread] = ACTIONS(623),
    [anon_sym_POUNDsend] = ACTIONS(623),
    [anon_sym_POUNDshare] = ACTIONS(623),
    [anon_sym_POUNDalias] = ACTIONS(623),
    [anon_sym_POUNDany] = ACTIONS(623),
    [anon_sym_BANG] = ACTIONS(625),
    [anon_sym_CARET] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(623),
    [anon_sym_AMP] = ACTIONS(623),
    [anon_sym_DASH_GT] = ACTIONS(623),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_DASH_TILDE] = ACTIONS(623),
    [anon_sym_PLUS] = ACTIONS(625),
    [anon_sym_STAR] = ACTIONS(625),
    [anon_sym_SLASH] = ACTIONS(625),
    [anon_sym_PERCENT] = ACTIONS(625),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(625),
    [anon_sym_LT_LT] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(625),
    [anon_sym_and] = ACTIONS(623),
    [anon_sym_or] = ACTIONS(623),
    [anon_sym_xor] = ACTIONS(623),
    [anon_sym_isnt] = ACTIONS(623),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(625),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_LT] = ACTIONS(625),
    [anon_sym_PLUS_TILDE] = ACTIONS(623),
    [anon_sym_STAR_TILDE] = ACTIONS(623),
    [anon_sym_SLASH_TILDE] = ACTIONS(623),
    [anon_sym_PERCENT_TILDE] = ACTIONS(623),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(623),
    [anon_sym_LT_LT_TILDE] = ACTIONS(623),
    [anon_sym_GT_GT_TILDE] = ACTIONS(623),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(623),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(623),
    [anon_sym_GT_TILDE] = ACTIONS(623),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(623),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(623),
    [anon_sym_LT_TILDE] = ACTIONS(623),
    [anon_sym_PLUS_QMARK] = ACTIONS(623),
    [anon_sym_DASH_QMARK] = ACTIONS(623),
    [anon_sym_STAR_QMARK] = ACTIONS(623),
    [anon_sym_SLASH_QMARK] = ACTIONS(623),
    [anon_sym_PERCENT_QMARK] = ACTIONS(623),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(623),
    [anon_sym_as] = ACTIONS(623),
    [anon_sym_LPAREN2] = ACTIONS(623),
    [anon_sym_DOT_GT] = ACTIONS(623),
    [anon_sym_TILDE] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_ifdef] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [sym__type_args_start] = ACTIONS(623),
    [sym_block_comment] = ACTIONS(3),
  },
  [870] = {
    [anon_sym_EQ] = ACTIONS(782),
    [anon_sym_is] = ACTIONS(782),
    [anon_sym_EQ_GT] = ACTIONS(780),
    [anon_sym_iso] = ACTIONS(780),
    [anon_sym_trn] = ACTIONS(780),
    [anon_sym_ref] = ACTIONS(780),
    [anon_sym_val] = ACTIONS(780),
    [anon_sym_box] = ACTIONS(780),
    [anon_sym_tag] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(782),
    [anon_sym_POUNDread] = ACTIONS(780),
    [anon_sym_POUNDsend] = ACTIONS(780),
    [anon_sym_POUNDshare] = ACTIONS(780),
    [anon_sym_POUNDalias] = ACTIONS(780),
    [anon_sym_POUNDany] = ACTIONS(780),
    [anon_sym_BANG] = ACTIONS(782),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(780),
    [anon_sym_DASH_GT] = ACTIONS(780),
    [anon_sym_DASH] = ACTIONS(782),
    [anon_sym_DASH_TILDE] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(782),
    [anon_sym_STAR] = ACTIONS(782),
    [anon_sym_SLASH] = ACTIONS(782),
    [anon_sym_PERCENT] = ACTIONS(782),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(782),
    [anon_sym_LT_LT] = ACTIONS(782),
    [anon_sym_GT_GT] = ACTIONS(782),
    [anon_sym_and] = ACTIONS(780),
    [anon_sym_or] = ACTIONS(780),
    [anon_sym_xor] = ACTIONS(780),
    [anon_sym_isnt] = ACTIONS(780),
    [anon_sym_EQ_EQ] = ACTIONS(782),
    [anon_sym_BANG_EQ] = ACTIONS(782),
    [anon_sym_GT] = ACTIONS(782),
    [anon_sym_GT_EQ] = ACTIONS(782),
    [anon_sym_LT_EQ] = ACTIONS(782),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_PLUS_TILDE] = ACTIONS(780),
    [anon_sym_STAR_TILDE] = ACTIONS(780),
    [anon_sym_SLASH_TILDE] = ACTIONS(780),
    [anon_sym_PERCENT_TILDE] = ACTIONS(780),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(780),
    [anon_sym_LT_LT_TILDE] = ACTIONS(780),
    [anon_sym_GT_GT_TILDE] = ACTIONS(780),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(780),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(780),
    [anon_sym_GT_TILDE] = ACTIONS(780),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(780),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(780),
    [anon_sym_LT_TILDE] = ACTIONS(780),
    [anon_sym_PLUS_QMARK] = ACTIONS(780),
    [anon_sym_DASH_QMARK] = ACTIONS(780),
    [anon_sym_STAR_QMARK] = ACTIONS(780),
    [anon_sym_SLASH_QMARK] = ACTIONS(780),
    [anon_sym_PERCENT_QMARK] = ACTIONS(780),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(780),
    [anon_sym_as] = ACTIONS(780),
    [anon_sym_LPAREN2] = ACTIONS(780),
    [anon_sym_DOT_GT] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_if] = ACTIONS(782),
    [anon_sym_ifdef] = ACTIONS(780),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [871] = {
    [anon_sym_EQ] = ACTIONS(722),
    [anon_sym_is] = ACTIONS(722),
    [anon_sym_EQ_GT] = ACTIONS(720),
    [anon_sym_iso] = ACTIONS(720),
    [anon_sym_trn] = ACTIONS(720),
    [anon_sym_ref] = ACTIONS(720),
    [anon_sym_val] = ACTIONS(720),
    [anon_sym_box] = ACTIONS(720),
    [anon_sym_tag] = ACTIONS(720),
    [anon_sym_DOT] = ACTIONS(722),
    [anon_sym_POUNDread] = ACTIONS(720),
    [anon_sym_POUNDsend] = ACTIONS(720),
    [anon_sym_POUNDshare] = ACTIONS(720),
    [anon_sym_POUNDalias] = ACTIONS(720),
    [anon_sym_POUNDany] = ACTIONS(720),
    [anon_sym_BANG] = ACTIONS(722),
    [anon_sym_CARET] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(720),
    [anon_sym_AMP] = ACTIONS(720),
    [anon_sym_DASH_GT] = ACTIONS(720),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_DASH_TILDE] = ACTIONS(720),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_STAR] = ACTIONS(722),
    [anon_sym_SLASH] = ACTIONS(722),
    [anon_sym_PERCENT] = ACTIONS(722),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(722),
    [anon_sym_LT_LT] = ACTIONS(722),
    [anon_sym_GT_GT] = ACTIONS(722),
    [anon_sym_and] = ACTIONS(720),
    [anon_sym_or] = ACTIONS(720),
    [anon_sym_xor] = ACTIONS(720),
    [anon_sym_isnt] = ACTIONS(720),
    [anon_sym_EQ_EQ] = ACTIONS(722),
    [anon_sym_BANG_EQ] = ACTIONS(722),
    [anon_sym_GT] = ACTIONS(722),
    [anon_sym_GT_EQ] = ACTIONS(722),
    [anon_sym_LT_EQ] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(722),
    [anon_sym_PLUS_TILDE] = ACTIONS(720),
    [anon_sym_STAR_TILDE] = ACTIONS(720),
    [anon_sym_SLASH_TILDE] = ACTIONS(720),
    [anon_sym_PERCENT_TILDE] = ACTIONS(720),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(720),
    [anon_sym_LT_LT_TILDE] = ACTIONS(720),
    [anon_sym_GT_GT_TILDE] = ACTIONS(720),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(720),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(720),
    [anon_sym_GT_TILDE] = ACTIONS(720),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(720),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(720),
    [anon_sym_LT_TILDE] = ACTIONS(720),
    [anon_sym_PLUS_QMARK] = ACTIONS(720),
    [anon_sym_DASH_QMARK] = ACTIONS(720),
    [anon_sym_STAR_QMARK] = ACTIONS(720),
    [anon_sym_SLASH_QMARK] = ACTIONS(720),
    [anon_sym_PERCENT_QMARK] = ACTIONS(720),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(720),
    [anon_sym_as] = ACTIONS(720),
    [anon_sym_LPAREN2] = ACTIONS(720),
    [anon_sym_DOT_GT] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(720),
    [anon_sym_if] = ACTIONS(722),
    [anon_sym_ifdef] = ACTIONS(720),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [872] = {
    [anon_sym_EQ] = ACTIONS(786),
    [anon_sym_is] = ACTIONS(786),
    [anon_sym_EQ_GT] = ACTIONS(784),
    [anon_sym_iso] = ACTIONS(784),
    [anon_sym_trn] = ACTIONS(784),
    [anon_sym_ref] = ACTIONS(784),
    [anon_sym_val] = ACTIONS(784),
    [anon_sym_box] = ACTIONS(784),
    [anon_sym_tag] = ACTIONS(784),
    [anon_sym_DOT] = ACTIONS(786),
    [anon_sym_POUNDread] = ACTIONS(784),
    [anon_sym_POUNDsend] = ACTIONS(784),
    [anon_sym_POUNDshare] = ACTIONS(784),
    [anon_sym_POUNDalias] = ACTIONS(784),
    [anon_sym_POUNDany] = ACTIONS(784),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_CARET] = ACTIONS(784),
    [anon_sym_PIPE] = ACTIONS(784),
    [anon_sym_AMP] = ACTIONS(784),
    [anon_sym_DASH_GT] = ACTIONS(784),
    [anon_sym_DASH] = ACTIONS(786),
    [anon_sym_DASH_TILDE] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(786),
    [anon_sym_STAR] = ACTIONS(786),
    [anon_sym_SLASH] = ACTIONS(786),
    [anon_sym_PERCENT] = ACTIONS(786),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(786),
    [anon_sym_LT_LT] = ACTIONS(786),
    [anon_sym_GT_GT] = ACTIONS(786),
    [anon_sym_and] = ACTIONS(784),
    [anon_sym_or] = ACTIONS(784),
    [anon_sym_xor] = ACTIONS(784),
    [anon_sym_isnt] = ACTIONS(784),
    [anon_sym_EQ_EQ] = ACTIONS(786),
    [anon_sym_BANG_EQ] = ACTIONS(786),
    [anon_sym_GT] = ACTIONS(786),
    [anon_sym_GT_EQ] = ACTIONS(786),
    [anon_sym_LT_EQ] = ACTIONS(786),
    [anon_sym_LT] = ACTIONS(786),
    [anon_sym_PLUS_TILDE] = ACTIONS(784),
    [anon_sym_STAR_TILDE] = ACTIONS(784),
    [anon_sym_SLASH_TILDE] = ACTIONS(784),
    [anon_sym_PERCENT_TILDE] = ACTIONS(784),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(784),
    [anon_sym_LT_LT_TILDE] = ACTIONS(784),
    [anon_sym_GT_GT_TILDE] = ACTIONS(784),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(784),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(784),
    [anon_sym_GT_TILDE] = ACTIONS(784),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(784),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(784),
    [anon_sym_LT_TILDE] = ACTIONS(784),
    [anon_sym_PLUS_QMARK] = ACTIONS(784),
    [anon_sym_DASH_QMARK] = ACTIONS(784),
    [anon_sym_STAR_QMARK] = ACTIONS(784),
    [anon_sym_SLASH_QMARK] = ACTIONS(784),
    [anon_sym_PERCENT_QMARK] = ACTIONS(784),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(784),
    [anon_sym_as] = ACTIONS(784),
    [anon_sym_LPAREN2] = ACTIONS(784),
    [anon_sym_DOT_GT] = ACTIONS(784),
    [anon_sym_TILDE] = ACTIONS(784),
    [anon_sym_if] = ACTIONS(786),
    [anon_sym_ifdef] = ACTIONS(784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [873] = {
    [anon_sym_EQ] = ACTIONS(762),
    [anon_sym_is] = ACTIONS(762),
    [anon_sym_EQ_GT] = ACTIONS(760),
    [anon_sym_iso] = ACTIONS(760),
    [anon_sym_trn] = ACTIONS(760),
    [anon_sym_ref] = ACTIONS(760),
    [anon_sym_val] = ACTIONS(760),
    [anon_sym_box] = ACTIONS(760),
    [anon_sym_tag] = ACTIONS(760),
    [anon_sym_DOT] = ACTIONS(762),
    [anon_sym_POUNDread] = ACTIONS(760),
    [anon_sym_POUNDsend] = ACTIONS(760),
    [anon_sym_POUNDshare] = ACTIONS(760),
    [anon_sym_POUNDalias] = ACTIONS(760),
    [anon_sym_POUNDany] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(762),
    [anon_sym_CARET] = ACTIONS(760),
    [anon_sym_PIPE] = ACTIONS(760),
    [anon_sym_AMP] = ACTIONS(760),
    [anon_sym_DASH_GT] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_DASH_TILDE] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_STAR] = ACTIONS(762),
    [anon_sym_SLASH] = ACTIONS(762),
    [anon_sym_PERCENT] = ACTIONS(762),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(762),
    [anon_sym_LT_LT] = ACTIONS(762),
    [anon_sym_GT_GT] = ACTIONS(762),
    [anon_sym_and] = ACTIONS(760),
    [anon_sym_or] = ACTIONS(760),
    [anon_sym_xor] = ACTIONS(760),
    [anon_sym_isnt] = ACTIONS(760),
    [anon_sym_EQ_EQ] = ACTIONS(762),
    [anon_sym_BANG_EQ] = ACTIONS(762),
    [anon_sym_GT] = ACTIONS(762),
    [anon_sym_GT_EQ] = ACTIONS(762),
    [anon_sym_LT_EQ] = ACTIONS(762),
    [anon_sym_LT] = ACTIONS(762),
    [anon_sym_PLUS_TILDE] = ACTIONS(760),
    [anon_sym_STAR_TILDE] = ACTIONS(760),
    [anon_sym_SLASH_TILDE] = ACTIONS(760),
    [anon_sym_PERCENT_TILDE] = ACTIONS(760),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(760),
    [anon_sym_LT_LT_TILDE] = ACTIONS(760),
    [anon_sym_GT_GT_TILDE] = ACTIONS(760),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(760),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(760),
    [anon_sym_GT_TILDE] = ACTIONS(760),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(760),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(760),
    [anon_sym_LT_TILDE] = ACTIONS(760),
    [anon_sym_PLUS_QMARK] = ACTIONS(760),
    [anon_sym_DASH_QMARK] = ACTIONS(760),
    [anon_sym_STAR_QMARK] = ACTIONS(760),
    [anon_sym_SLASH_QMARK] = ACTIONS(760),
    [anon_sym_PERCENT_QMARK] = ACTIONS(760),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(760),
    [anon_sym_as] = ACTIONS(760),
    [anon_sym_LPAREN2] = ACTIONS(760),
    [anon_sym_DOT_GT] = ACTIONS(760),
    [anon_sym_TILDE] = ACTIONS(760),
    [anon_sym_if] = ACTIONS(762),
    [anon_sym_ifdef] = ACTIONS(760),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [874] = {
    [anon_sym_EQ] = ACTIONS(766),
    [anon_sym_is] = ACTIONS(766),
    [anon_sym_EQ_GT] = ACTIONS(764),
    [anon_sym_iso] = ACTIONS(764),
    [anon_sym_trn] = ACTIONS(764),
    [anon_sym_ref] = ACTIONS(764),
    [anon_sym_val] = ACTIONS(764),
    [anon_sym_box] = ACTIONS(764),
    [anon_sym_tag] = ACTIONS(764),
    [anon_sym_DOT] = ACTIONS(766),
    [anon_sym_POUNDread] = ACTIONS(764),
    [anon_sym_POUNDsend] = ACTIONS(764),
    [anon_sym_POUNDshare] = ACTIONS(764),
    [anon_sym_POUNDalias] = ACTIONS(764),
    [anon_sym_POUNDany] = ACTIONS(764),
    [anon_sym_BANG] = ACTIONS(766),
    [anon_sym_CARET] = ACTIONS(764),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_AMP] = ACTIONS(764),
    [anon_sym_DASH_GT] = ACTIONS(764),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_DASH_TILDE] = ACTIONS(764),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(766),
    [anon_sym_SLASH] = ACTIONS(766),
    [anon_sym_PERCENT] = ACTIONS(766),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(766),
    [anon_sym_LT_LT] = ACTIONS(766),
    [anon_sym_GT_GT] = ACTIONS(766),
    [anon_sym_and] = ACTIONS(764),
    [anon_sym_or] = ACTIONS(764),
    [anon_sym_xor] = ACTIONS(764),
    [anon_sym_isnt] = ACTIONS(764),
    [anon_sym_EQ_EQ] = ACTIONS(766),
    [anon_sym_BANG_EQ] = ACTIONS(766),
    [anon_sym_GT] = ACTIONS(766),
    [anon_sym_GT_EQ] = ACTIONS(766),
    [anon_sym_LT_EQ] = ACTIONS(766),
    [anon_sym_LT] = ACTIONS(766),
    [anon_sym_PLUS_TILDE] = ACTIONS(764),
    [anon_sym_STAR_TILDE] = ACTIONS(764),
    [anon_sym_SLASH_TILDE] = ACTIONS(764),
    [anon_sym_PERCENT_TILDE] = ACTIONS(764),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(764),
    [anon_sym_LT_LT_TILDE] = ACTIONS(764),
    [anon_sym_GT_GT_TILDE] = ACTIONS(764),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(764),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(764),
    [anon_sym_GT_TILDE] = ACTIONS(764),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(764),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(764),
    [anon_sym_LT_TILDE] = ACTIONS(764),
    [anon_sym_PLUS_QMARK] = ACTIONS(764),
    [anon_sym_DASH_QMARK] = ACTIONS(764),
    [anon_sym_STAR_QMARK] = ACTIONS(764),
    [anon_sym_SLASH_QMARK] = ACTIONS(764),
    [anon_sym_PERCENT_QMARK] = ACTIONS(764),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(764),
    [anon_sym_as] = ACTIONS(764),
    [anon_sym_LPAREN2] = ACTIONS(764),
    [anon_sym_DOT_GT] = ACTIONS(764),
    [anon_sym_TILDE] = ACTIONS(764),
    [anon_sym_if] = ACTIONS(766),
    [anon_sym_ifdef] = ACTIONS(764),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [875] = {
    [anon_sym_EQ] = ACTIONS(758),
    [anon_sym_is] = ACTIONS(758),
    [anon_sym_EQ_GT] = ACTIONS(756),
    [anon_sym_iso] = ACTIONS(756),
    [anon_sym_trn] = ACTIONS(756),
    [anon_sym_ref] = ACTIONS(756),
    [anon_sym_val] = ACTIONS(756),
    [anon_sym_box] = ACTIONS(756),
    [anon_sym_tag] = ACTIONS(756),
    [anon_sym_DOT] = ACTIONS(758),
    [anon_sym_POUNDread] = ACTIONS(756),
    [anon_sym_POUNDsend] = ACTIONS(756),
    [anon_sym_POUNDshare] = ACTIONS(756),
    [anon_sym_POUNDalias] = ACTIONS(756),
    [anon_sym_POUNDany] = ACTIONS(756),
    [anon_sym_BANG] = ACTIONS(758),
    [anon_sym_CARET] = ACTIONS(756),
    [anon_sym_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(756),
    [anon_sym_DASH_GT] = ACTIONS(756),
    [anon_sym_DASH] = ACTIONS(758),
    [anon_sym_DASH_TILDE] = ACTIONS(756),
    [anon_sym_PLUS] = ACTIONS(758),
    [anon_sym_STAR] = ACTIONS(758),
    [anon_sym_SLASH] = ACTIONS(758),
    [anon_sym_PERCENT] = ACTIONS(758),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(758),
    [anon_sym_LT_LT] = ACTIONS(758),
    [anon_sym_GT_GT] = ACTIONS(758),
    [anon_sym_and] = ACTIONS(756),
    [anon_sym_or] = ACTIONS(756),
    [anon_sym_xor] = ACTIONS(756),
    [anon_sym_isnt] = ACTIONS(756),
    [anon_sym_EQ_EQ] = ACTIONS(758),
    [anon_sym_BANG_EQ] = ACTIONS(758),
    [anon_sym_GT] = ACTIONS(758),
    [anon_sym_GT_EQ] = ACTIONS(758),
    [anon_sym_LT_EQ] = ACTIONS(758),
    [anon_sym_LT] = ACTIONS(758),
    [anon_sym_PLUS_TILDE] = ACTIONS(756),
    [anon_sym_STAR_TILDE] = ACTIONS(756),
    [anon_sym_SLASH_TILDE] = ACTIONS(756),
    [anon_sym_PERCENT_TILDE] = ACTIONS(756),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(756),
    [anon_sym_LT_LT_TILDE] = ACTIONS(756),
    [anon_sym_GT_GT_TILDE] = ACTIONS(756),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(756),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(756),
    [anon_sym_GT_TILDE] = ACTIONS(756),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(756),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(756),
    [anon_sym_LT_TILDE] = ACTIONS(756),
    [anon_sym_PLUS_QMARK] = ACTIONS(756),
    [anon_sym_DASH_QMARK] = ACTIONS(756),
    [anon_sym_STAR_QMARK] = ACTIONS(756),
    [anon_sym_SLASH_QMARK] = ACTIONS(756),
    [anon_sym_PERCENT_QMARK] = ACTIONS(756),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(756),
    [anon_sym_as] = ACTIONS(756),
    [anon_sym_LPAREN2] = ACTIONS(756),
    [anon_sym_DOT_GT] = ACTIONS(756),
    [anon_sym_TILDE] = ACTIONS(756),
    [anon_sym_if] = ACTIONS(758),
    [anon_sym_ifdef] = ACTIONS(756),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [876] = {
    [anon_sym_EQ] = ACTIONS(770),
    [anon_sym_is] = ACTIONS(770),
    [anon_sym_EQ_GT] = ACTIONS(768),
    [anon_sym_iso] = ACTIONS(768),
    [anon_sym_trn] = ACTIONS(768),
    [anon_sym_ref] = ACTIONS(768),
    [anon_sym_val] = ACTIONS(768),
    [anon_sym_box] = ACTIONS(768),
    [anon_sym_tag] = ACTIONS(768),
    [anon_sym_DOT] = ACTIONS(770),
    [anon_sym_POUNDread] = ACTIONS(768),
    [anon_sym_POUNDsend] = ACTIONS(768),
    [anon_sym_POUNDshare] = ACTIONS(768),
    [anon_sym_POUNDalias] = ACTIONS(768),
    [anon_sym_POUNDany] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(770),
    [anon_sym_CARET] = ACTIONS(768),
    [anon_sym_PIPE] = ACTIONS(768),
    [anon_sym_AMP] = ACTIONS(768),
    [anon_sym_DASH_GT] = ACTIONS(768),
    [anon_sym_DASH] = ACTIONS(770),
    [anon_sym_DASH_TILDE] = ACTIONS(768),
    [anon_sym_PLUS] = ACTIONS(770),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_SLASH] = ACTIONS(770),
    [anon_sym_PERCENT] = ACTIONS(770),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(770),
    [anon_sym_LT_LT] = ACTIONS(770),
    [anon_sym_GT_GT] = ACTIONS(770),
    [anon_sym_and] = ACTIONS(768),
    [anon_sym_or] = ACTIONS(768),
    [anon_sym_xor] = ACTIONS(768),
    [anon_sym_isnt] = ACTIONS(768),
    [anon_sym_EQ_EQ] = ACTIONS(770),
    [anon_sym_BANG_EQ] = ACTIONS(770),
    [anon_sym_GT] = ACTIONS(770),
    [anon_sym_GT_EQ] = ACTIONS(770),
    [anon_sym_LT_EQ] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(770),
    [anon_sym_PLUS_TILDE] = ACTIONS(768),
    [anon_sym_STAR_TILDE] = ACTIONS(768),
    [anon_sym_SLASH_TILDE] = ACTIONS(768),
    [anon_sym_PERCENT_TILDE] = ACTIONS(768),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(768),
    [anon_sym_LT_LT_TILDE] = ACTIONS(768),
    [anon_sym_GT_GT_TILDE] = ACTIONS(768),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(768),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(768),
    [anon_sym_GT_TILDE] = ACTIONS(768),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(768),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(768),
    [anon_sym_LT_TILDE] = ACTIONS(768),
    [anon_sym_PLUS_QMARK] = ACTIONS(768),
    [anon_sym_DASH_QMARK] = ACTIONS(768),
    [anon_sym_STAR_QMARK] = ACTIONS(768),
    [anon_sym_SLASH_QMARK] = ACTIONS(768),
    [anon_sym_PERCENT_QMARK] = ACTIONS(768),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(768),
    [anon_sym_as] = ACTIONS(768),
    [anon_sym_LPAREN2] = ACTIONS(768),
    [anon_sym_DOT_GT] = ACTIONS(768),
    [anon_sym_TILDE] = ACTIONS(768),
    [anon_sym_if] = ACTIONS(770),
    [anon_sym_ifdef] = ACTIONS(768),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [877] = {
    [anon_sym_EQ] = ACTIONS(656),
    [anon_sym_is] = ACTIONS(656),
    [anon_sym_EQ_GT] = ACTIONS(654),
    [anon_sym_iso] = ACTIONS(654),
    [anon_sym_trn] = ACTIONS(654),
    [anon_sym_ref] = ACTIONS(654),
    [anon_sym_val] = ACTIONS(654),
    [anon_sym_box] = ACTIONS(654),
    [anon_sym_tag] = ACTIONS(654),
    [anon_sym_DOT] = ACTIONS(656),
    [anon_sym_POUNDread] = ACTIONS(654),
    [anon_sym_POUNDsend] = ACTIONS(654),
    [anon_sym_POUNDshare] = ACTIONS(654),
    [anon_sym_POUNDalias] = ACTIONS(654),
    [anon_sym_POUNDany] = ACTIONS(654),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(654),
    [anon_sym_PIPE] = ACTIONS(654),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_DASH_GT] = ACTIONS(654),
    [anon_sym_DASH] = ACTIONS(656),
    [anon_sym_DASH_TILDE] = ACTIONS(654),
    [anon_sym_PLUS] = ACTIONS(656),
    [anon_sym_STAR] = ACTIONS(656),
    [anon_sym_SLASH] = ACTIONS(656),
    [anon_sym_PERCENT] = ACTIONS(656),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(656),
    [anon_sym_LT_LT] = ACTIONS(656),
    [anon_sym_GT_GT] = ACTIONS(656),
    [anon_sym_and] = ACTIONS(654),
    [anon_sym_or] = ACTIONS(654),
    [anon_sym_xor] = ACTIONS(654),
    [anon_sym_isnt] = ACTIONS(654),
    [anon_sym_EQ_EQ] = ACTIONS(656),
    [anon_sym_BANG_EQ] = ACTIONS(656),
    [anon_sym_GT] = ACTIONS(656),
    [anon_sym_GT_EQ] = ACTIONS(656),
    [anon_sym_LT_EQ] = ACTIONS(656),
    [anon_sym_LT] = ACTIONS(656),
    [anon_sym_PLUS_TILDE] = ACTIONS(654),
    [anon_sym_STAR_TILDE] = ACTIONS(654),
    [anon_sym_SLASH_TILDE] = ACTIONS(654),
    [anon_sym_PERCENT_TILDE] = ACTIONS(654),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(654),
    [anon_sym_LT_LT_TILDE] = ACTIONS(654),
    [anon_sym_GT_GT_TILDE] = ACTIONS(654),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(654),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(654),
    [anon_sym_GT_TILDE] = ACTIONS(654),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(654),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(654),
    [anon_sym_LT_TILDE] = ACTIONS(654),
    [anon_sym_PLUS_QMARK] = ACTIONS(654),
    [anon_sym_DASH_QMARK] = ACTIONS(654),
    [anon_sym_STAR_QMARK] = ACTIONS(654),
    [anon_sym_SLASH_QMARK] = ACTIONS(654),
    [anon_sym_PERCENT_QMARK] = ACTIONS(654),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(654),
    [anon_sym_as] = ACTIONS(654),
    [anon_sym_LPAREN2] = ACTIONS(654),
    [anon_sym_DOT_GT] = ACTIONS(654),
    [anon_sym_TILDE] = ACTIONS(654),
    [anon_sym_if] = ACTIONS(656),
    [anon_sym_ifdef] = ACTIONS(654),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [878] = {
    [anon_sym_EQ] = ACTIONS(774),
    [anon_sym_is] = ACTIONS(774),
    [anon_sym_EQ_GT] = ACTIONS(772),
    [anon_sym_iso] = ACTIONS(772),
    [anon_sym_trn] = ACTIONS(772),
    [anon_sym_ref] = ACTIONS(772),
    [anon_sym_val] = ACTIONS(772),
    [anon_sym_box] = ACTIONS(772),
    [anon_sym_tag] = ACTIONS(772),
    [anon_sym_DOT] = ACTIONS(774),
    [anon_sym_POUNDread] = ACTIONS(772),
    [anon_sym_POUNDsend] = ACTIONS(772),
    [anon_sym_POUNDshare] = ACTIONS(772),
    [anon_sym_POUNDalias] = ACTIONS(772),
    [anon_sym_POUNDany] = ACTIONS(772),
    [anon_sym_BANG] = ACTIONS(774),
    [anon_sym_CARET] = ACTIONS(772),
    [anon_sym_PIPE] = ACTIONS(772),
    [anon_sym_AMP] = ACTIONS(772),
    [anon_sym_DASH_GT] = ACTIONS(772),
    [anon_sym_DASH] = ACTIONS(774),
    [anon_sym_DASH_TILDE] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(774),
    [anon_sym_STAR] = ACTIONS(774),
    [anon_sym_SLASH] = ACTIONS(774),
    [anon_sym_PERCENT] = ACTIONS(774),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(774),
    [anon_sym_LT_LT] = ACTIONS(774),
    [anon_sym_GT_GT] = ACTIONS(774),
    [anon_sym_and] = ACTIONS(772),
    [anon_sym_or] = ACTIONS(772),
    [anon_sym_xor] = ACTIONS(772),
    [anon_sym_isnt] = ACTIONS(772),
    [anon_sym_EQ_EQ] = ACTIONS(774),
    [anon_sym_BANG_EQ] = ACTIONS(774),
    [anon_sym_GT] = ACTIONS(774),
    [anon_sym_GT_EQ] = ACTIONS(774),
    [anon_sym_LT_EQ] = ACTIONS(774),
    [anon_sym_LT] = ACTIONS(774),
    [anon_sym_PLUS_TILDE] = ACTIONS(772),
    [anon_sym_STAR_TILDE] = ACTIONS(772),
    [anon_sym_SLASH_TILDE] = ACTIONS(772),
    [anon_sym_PERCENT_TILDE] = ACTIONS(772),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(772),
    [anon_sym_LT_LT_TILDE] = ACTIONS(772),
    [anon_sym_GT_GT_TILDE] = ACTIONS(772),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(772),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(772),
    [anon_sym_GT_TILDE] = ACTIONS(772),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(772),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(772),
    [anon_sym_LT_TILDE] = ACTIONS(772),
    [anon_sym_PLUS_QMARK] = ACTIONS(772),
    [anon_sym_DASH_QMARK] = ACTIONS(772),
    [anon_sym_STAR_QMARK] = ACTIONS(772),
    [anon_sym_SLASH_QMARK] = ACTIONS(772),
    [anon_sym_PERCENT_QMARK] = ACTIONS(772),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(772),
    [anon_sym_as] = ACTIONS(772),
    [anon_sym_LPAREN2] = ACTIONS(772),
    [anon_sym_DOT_GT] = ACTIONS(772),
    [anon_sym_TILDE] = ACTIONS(772),
    [anon_sym_if] = ACTIONS(774),
    [anon_sym_ifdef] = ACTIONS(772),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [879] = {
    [anon_sym_EQ] = ACTIONS(778),
    [anon_sym_is] = ACTIONS(778),
    [anon_sym_EQ_GT] = ACTIONS(776),
    [anon_sym_iso] = ACTIONS(776),
    [anon_sym_trn] = ACTIONS(776),
    [anon_sym_ref] = ACTIONS(776),
    [anon_sym_val] = ACTIONS(776),
    [anon_sym_box] = ACTIONS(776),
    [anon_sym_tag] = ACTIONS(776),
    [anon_sym_DOT] = ACTIONS(778),
    [anon_sym_POUNDread] = ACTIONS(776),
    [anon_sym_POUNDsend] = ACTIONS(776),
    [anon_sym_POUNDshare] = ACTIONS(776),
    [anon_sym_POUNDalias] = ACTIONS(776),
    [anon_sym_POUNDany] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_CARET] = ACTIONS(776),
    [anon_sym_PIPE] = ACTIONS(776),
    [anon_sym_AMP] = ACTIONS(776),
    [anon_sym_DASH_GT] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(778),
    [anon_sym_DASH_TILDE] = ACTIONS(776),
    [anon_sym_PLUS] = ACTIONS(778),
    [anon_sym_STAR] = ACTIONS(778),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_PERCENT] = ACTIONS(778),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(778),
    [anon_sym_LT_LT] = ACTIONS(778),
    [anon_sym_GT_GT] = ACTIONS(778),
    [anon_sym_and] = ACTIONS(776),
    [anon_sym_or] = ACTIONS(776),
    [anon_sym_xor] = ACTIONS(776),
    [anon_sym_isnt] = ACTIONS(776),
    [anon_sym_EQ_EQ] = ACTIONS(778),
    [anon_sym_BANG_EQ] = ACTIONS(778),
    [anon_sym_GT] = ACTIONS(778),
    [anon_sym_GT_EQ] = ACTIONS(778),
    [anon_sym_LT_EQ] = ACTIONS(778),
    [anon_sym_LT] = ACTIONS(778),
    [anon_sym_PLUS_TILDE] = ACTIONS(776),
    [anon_sym_STAR_TILDE] = ACTIONS(776),
    [anon_sym_SLASH_TILDE] = ACTIONS(776),
    [anon_sym_PERCENT_TILDE] = ACTIONS(776),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(776),
    [anon_sym_LT_LT_TILDE] = ACTIONS(776),
    [anon_sym_GT_GT_TILDE] = ACTIONS(776),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(776),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(776),
    [anon_sym_GT_TILDE] = ACTIONS(776),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(776),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(776),
    [anon_sym_LT_TILDE] = ACTIONS(776),
    [anon_sym_PLUS_QMARK] = ACTIONS(776),
    [anon_sym_DASH_QMARK] = ACTIONS(776),
    [anon_sym_STAR_QMARK] = ACTIONS(776),
    [anon_sym_SLASH_QMARK] = ACTIONS(776),
    [anon_sym_PERCENT_QMARK] = ACTIONS(776),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(776),
    [anon_sym_as] = ACTIONS(776),
    [anon_sym_LPAREN2] = ACTIONS(776),
    [anon_sym_DOT_GT] = ACTIONS(776),
    [anon_sym_TILDE] = ACTIONS(776),
    [anon_sym_if] = ACTIONS(778),
    [anon_sym_ifdef] = ACTIONS(776),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [880] = {
    [anon_sym_EQ] = ACTIONS(648),
    [anon_sym_is] = ACTIONS(648),
    [anon_sym_EQ_GT] = ACTIONS(646),
    [anon_sym_iso] = ACTIONS(646),
    [anon_sym_trn] = ACTIONS(646),
    [anon_sym_ref] = ACTIONS(646),
    [anon_sym_val] = ACTIONS(646),
    [anon_sym_box] = ACTIONS(646),
    [anon_sym_tag] = ACTIONS(646),
    [anon_sym_DOT] = ACTIONS(648),
    [anon_sym_POUNDread] = ACTIONS(646),
    [anon_sym_POUNDsend] = ACTIONS(646),
    [anon_sym_POUNDshare] = ACTIONS(646),
    [anon_sym_POUNDalias] = ACTIONS(646),
    [anon_sym_POUNDany] = ACTIONS(646),
    [anon_sym_BANG] = ACTIONS(648),
    [anon_sym_CARET] = ACTIONS(646),
    [anon_sym_PIPE] = ACTIONS(646),
    [anon_sym_AMP] = ACTIONS(646),
    [anon_sym_DASH_GT] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(648),
    [anon_sym_DASH_TILDE] = ACTIONS(646),
    [anon_sym_PLUS] = ACTIONS(648),
    [anon_sym_STAR] = ACTIONS(648),
    [anon_sym_SLASH] = ACTIONS(648),
    [anon_sym_PERCENT] = ACTIONS(648),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(648),
    [anon_sym_LT_LT] = ACTIONS(648),
    [anon_sym_GT_GT] = ACTIONS(648),
    [anon_sym_and] = ACTIONS(646),
    [anon_sym_or] = ACTIONS(646),
    [anon_sym_xor] = ACTIONS(646),
    [anon_sym_isnt] = ACTIONS(646),
    [anon_sym_EQ_EQ] = ACTIONS(648),
    [anon_sym_BANG_EQ] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(648),
    [anon_sym_GT_EQ] = ACTIONS(648),
    [anon_sym_LT_EQ] = ACTIONS(648),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_PLUS_TILDE] = ACTIONS(646),
    [anon_sym_STAR_TILDE] = ACTIONS(646),
    [anon_sym_SLASH_TILDE] = ACTIONS(646),
    [anon_sym_PERCENT_TILDE] = ACTIONS(646),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(646),
    [anon_sym_LT_LT_TILDE] = ACTIONS(646),
    [anon_sym_GT_GT_TILDE] = ACTIONS(646),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(646),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(646),
    [anon_sym_GT_TILDE] = ACTIONS(646),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(646),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(646),
    [anon_sym_LT_TILDE] = ACTIONS(646),
    [anon_sym_PLUS_QMARK] = ACTIONS(646),
    [anon_sym_DASH_QMARK] = ACTIONS(646),
    [anon_sym_STAR_QMARK] = ACTIONS(646),
    [anon_sym_SLASH_QMARK] = ACTIONS(646),
    [anon_sym_PERCENT_QMARK] = ACTIONS(646),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(646),
    [anon_sym_as] = ACTIONS(646),
    [anon_sym_LPAREN2] = ACTIONS(646),
    [anon_sym_DOT_GT] = ACTIONS(646),
    [anon_sym_TILDE] = ACTIONS(646),
    [anon_sym_if] = ACTIONS(648),
    [anon_sym_ifdef] = ACTIONS(646),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [881] = {
    [anon_sym_EQ] = ACTIONS(754),
    [anon_sym_is] = ACTIONS(754),
    [anon_sym_EQ_GT] = ACTIONS(752),
    [anon_sym_iso] = ACTIONS(752),
    [anon_sym_trn] = ACTIONS(752),
    [anon_sym_ref] = ACTIONS(752),
    [anon_sym_val] = ACTIONS(752),
    [anon_sym_box] = ACTIONS(752),
    [anon_sym_tag] = ACTIONS(752),
    [anon_sym_DOT] = ACTIONS(754),
    [anon_sym_POUNDread] = ACTIONS(752),
    [anon_sym_POUNDsend] = ACTIONS(752),
    [anon_sym_POUNDshare] = ACTIONS(752),
    [anon_sym_POUNDalias] = ACTIONS(752),
    [anon_sym_POUNDany] = ACTIONS(752),
    [anon_sym_BANG] = ACTIONS(754),
    [anon_sym_CARET] = ACTIONS(752),
    [anon_sym_PIPE] = ACTIONS(752),
    [anon_sym_AMP] = ACTIONS(752),
    [anon_sym_DASH_GT] = ACTIONS(752),
    [anon_sym_DASH] = ACTIONS(754),
    [anon_sym_DASH_TILDE] = ACTIONS(752),
    [anon_sym_PLUS] = ACTIONS(754),
    [anon_sym_STAR] = ACTIONS(754),
    [anon_sym_SLASH] = ACTIONS(754),
    [anon_sym_PERCENT] = ACTIONS(754),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(754),
    [anon_sym_LT_LT] = ACTIONS(754),
    [anon_sym_GT_GT] = ACTIONS(754),
    [anon_sym_and] = ACTIONS(752),
    [anon_sym_or] = ACTIONS(752),
    [anon_sym_xor] = ACTIONS(752),
    [anon_sym_isnt] = ACTIONS(752),
    [anon_sym_EQ_EQ] = ACTIONS(754),
    [anon_sym_BANG_EQ] = ACTIONS(754),
    [anon_sym_GT] = ACTIONS(754),
    [anon_sym_GT_EQ] = ACTIONS(754),
    [anon_sym_LT_EQ] = ACTIONS(754),
    [anon_sym_LT] = ACTIONS(754),
    [anon_sym_PLUS_TILDE] = ACTIONS(752),
    [anon_sym_STAR_TILDE] = ACTIONS(752),
    [anon_sym_SLASH_TILDE] = ACTIONS(752),
    [anon_sym_PERCENT_TILDE] = ACTIONS(752),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(752),
    [anon_sym_LT_LT_TILDE] = ACTIONS(752),
    [anon_sym_GT_GT_TILDE] = ACTIONS(752),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(752),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(752),
    [anon_sym_GT_TILDE] = ACTIONS(752),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(752),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(752),
    [anon_sym_LT_TILDE] = ACTIONS(752),
    [anon_sym_PLUS_QMARK] = ACTIONS(752),
    [anon_sym_DASH_QMARK] = ACTIONS(752),
    [anon_sym_STAR_QMARK] = ACTIONS(752),
    [anon_sym_SLASH_QMARK] = ACTIONS(752),
    [anon_sym_PERCENT_QMARK] = ACTIONS(752),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(752),
    [anon_sym_as] = ACTIONS(752),
    [anon_sym_LPAREN2] = ACTIONS(752),
    [anon_sym_DOT_GT] = ACTIONS(752),
    [anon_sym_TILDE] = ACTIONS(752),
    [anon_sym_if] = ACTIONS(754),
    [anon_sym_ifdef] = ACTIONS(752),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [882] = {
    [anon_sym_EQ] = ACTIONS(680),
    [anon_sym_is] = ACTIONS(680),
    [anon_sym_EQ_GT] = ACTIONS(678),
    [anon_sym_iso] = ACTIONS(1653),
    [anon_sym_trn] = ACTIONS(1655),
    [anon_sym_ref] = ACTIONS(1657),
    [anon_sym_val] = ACTIONS(1659),
    [anon_sym_box] = ACTIONS(1661),
    [anon_sym_tag] = ACTIONS(1663),
    [anon_sym_DOT] = ACTIONS(680),
    [anon_sym_POUNDread] = ACTIONS(1665),
    [anon_sym_POUNDsend] = ACTIONS(1667),
    [anon_sym_POUNDshare] = ACTIONS(1669),
    [anon_sym_POUNDalias] = ACTIONS(1671),
    [anon_sym_POUNDany] = ACTIONS(1673),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_CARET] = ACTIONS(678),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_AMP] = ACTIONS(678),
    [anon_sym_DASH_GT] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(680),
    [anon_sym_DASH_TILDE] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(680),
    [anon_sym_STAR] = ACTIONS(680),
    [anon_sym_SLASH] = ACTIONS(680),
    [anon_sym_PERCENT] = ACTIONS(680),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(680),
    [anon_sym_LT_LT] = ACTIONS(680),
    [anon_sym_GT_GT] = ACTIONS(680),
    [anon_sym_and] = ACTIONS(678),
    [anon_sym_or] = ACTIONS(678),
    [anon_sym_xor] = ACTIONS(678),
    [anon_sym_isnt] = ACTIONS(678),
    [anon_sym_EQ_EQ] = ACTIONS(680),
    [anon_sym_BANG_EQ] = ACTIONS(680),
    [anon_sym_GT] = ACTIONS(680),
    [anon_sym_GT_EQ] = ACTIONS(680),
    [anon_sym_LT_EQ] = ACTIONS(680),
    [anon_sym_LT] = ACTIONS(680),
    [anon_sym_PLUS_TILDE] = ACTIONS(678),
    [anon_sym_STAR_TILDE] = ACTIONS(678),
    [anon_sym_SLASH_TILDE] = ACTIONS(678),
    [anon_sym_PERCENT_TILDE] = ACTIONS(678),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(678),
    [anon_sym_LT_LT_TILDE] = ACTIONS(678),
    [anon_sym_GT_GT_TILDE] = ACTIONS(678),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(678),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(678),
    [anon_sym_GT_TILDE] = ACTIONS(678),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(678),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(678),
    [anon_sym_LT_TILDE] = ACTIONS(678),
    [anon_sym_PLUS_QMARK] = ACTIONS(678),
    [anon_sym_DASH_QMARK] = ACTIONS(678),
    [anon_sym_STAR_QMARK] = ACTIONS(678),
    [anon_sym_SLASH_QMARK] = ACTIONS(678),
    [anon_sym_PERCENT_QMARK] = ACTIONS(678),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(678),
    [anon_sym_as] = ACTIONS(678),
    [anon_sym_LPAREN2] = ACTIONS(678),
    [anon_sym_DOT_GT] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(678),
    [anon_sym_if] = ACTIONS(680),
    [anon_sym_ifdef] = ACTIONS(678),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [883] = {
    [anon_sym_EQ] = ACTIONS(750),
    [anon_sym_is] = ACTIONS(750),
    [anon_sym_EQ_GT] = ACTIONS(748),
    [anon_sym_iso] = ACTIONS(748),
    [anon_sym_trn] = ACTIONS(748),
    [anon_sym_ref] = ACTIONS(748),
    [anon_sym_val] = ACTIONS(748),
    [anon_sym_box] = ACTIONS(748),
    [anon_sym_tag] = ACTIONS(748),
    [anon_sym_DOT] = ACTIONS(750),
    [anon_sym_POUNDread] = ACTIONS(748),
    [anon_sym_POUNDsend] = ACTIONS(748),
    [anon_sym_POUNDshare] = ACTIONS(748),
    [anon_sym_POUNDalias] = ACTIONS(748),
    [anon_sym_POUNDany] = ACTIONS(748),
    [anon_sym_BANG] = ACTIONS(750),
    [anon_sym_CARET] = ACTIONS(748),
    [anon_sym_PIPE] = ACTIONS(748),
    [anon_sym_AMP] = ACTIONS(748),
    [anon_sym_DASH_GT] = ACTIONS(748),
    [anon_sym_DASH] = ACTIONS(750),
    [anon_sym_DASH_TILDE] = ACTIONS(748),
    [anon_sym_PLUS] = ACTIONS(750),
    [anon_sym_STAR] = ACTIONS(750),
    [anon_sym_SLASH] = ACTIONS(750),
    [anon_sym_PERCENT] = ACTIONS(750),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(750),
    [anon_sym_LT_LT] = ACTIONS(750),
    [anon_sym_GT_GT] = ACTIONS(750),
    [anon_sym_and] = ACTIONS(748),
    [anon_sym_or] = ACTIONS(748),
    [anon_sym_xor] = ACTIONS(748),
    [anon_sym_isnt] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(750),
    [anon_sym_BANG_EQ] = ACTIONS(750),
    [anon_sym_GT] = ACTIONS(750),
    [anon_sym_GT_EQ] = ACTIONS(750),
    [anon_sym_LT_EQ] = ACTIONS(750),
    [anon_sym_LT] = ACTIONS(750),
    [anon_sym_PLUS_TILDE] = ACTIONS(748),
    [anon_sym_STAR_TILDE] = ACTIONS(748),
    [anon_sym_SLASH_TILDE] = ACTIONS(748),
    [anon_sym_PERCENT_TILDE] = ACTIONS(748),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(748),
    [anon_sym_LT_LT_TILDE] = ACTIONS(748),
    [anon_sym_GT_GT_TILDE] = ACTIONS(748),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(748),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(748),
    [anon_sym_GT_TILDE] = ACTIONS(748),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(748),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(748),
    [anon_sym_LT_TILDE] = ACTIONS(748),
    [anon_sym_PLUS_QMARK] = ACTIONS(748),
    [anon_sym_DASH_QMARK] = ACTIONS(748),
    [anon_sym_STAR_QMARK] = ACTIONS(748),
    [anon_sym_SLASH_QMARK] = ACTIONS(748),
    [anon_sym_PERCENT_QMARK] = ACTIONS(748),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(748),
    [anon_sym_LPAREN2] = ACTIONS(748),
    [anon_sym_DOT_GT] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_if] = ACTIONS(750),
    [anon_sym_ifdef] = ACTIONS(748),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [884] = {
    [anon_sym_EQ] = ACTIONS(746),
    [anon_sym_is] = ACTIONS(746),
    [anon_sym_EQ_GT] = ACTIONS(744),
    [anon_sym_iso] = ACTIONS(744),
    [anon_sym_trn] = ACTIONS(744),
    [anon_sym_ref] = ACTIONS(744),
    [anon_sym_val] = ACTIONS(744),
    [anon_sym_box] = ACTIONS(744),
    [anon_sym_tag] = ACTIONS(744),
    [anon_sym_DOT] = ACTIONS(746),
    [anon_sym_POUNDread] = ACTIONS(744),
    [anon_sym_POUNDsend] = ACTIONS(744),
    [anon_sym_POUNDshare] = ACTIONS(744),
    [anon_sym_POUNDalias] = ACTIONS(744),
    [anon_sym_POUNDany] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_CARET] = ACTIONS(744),
    [anon_sym_PIPE] = ACTIONS(744),
    [anon_sym_AMP] = ACTIONS(744),
    [anon_sym_DASH_GT] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(746),
    [anon_sym_DASH_TILDE] = ACTIONS(744),
    [anon_sym_PLUS] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(746),
    [anon_sym_SLASH] = ACTIONS(746),
    [anon_sym_PERCENT] = ACTIONS(746),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(746),
    [anon_sym_LT_LT] = ACTIONS(746),
    [anon_sym_GT_GT] = ACTIONS(746),
    [anon_sym_and] = ACTIONS(744),
    [anon_sym_or] = ACTIONS(744),
    [anon_sym_xor] = ACTIONS(744),
    [anon_sym_isnt] = ACTIONS(744),
    [anon_sym_EQ_EQ] = ACTIONS(746),
    [anon_sym_BANG_EQ] = ACTIONS(746),
    [anon_sym_GT] = ACTIONS(746),
    [anon_sym_GT_EQ] = ACTIONS(746),
    [anon_sym_LT_EQ] = ACTIONS(746),
    [anon_sym_LT] = ACTIONS(746),
    [anon_sym_PLUS_TILDE] = ACTIONS(744),
    [anon_sym_STAR_TILDE] = ACTIONS(744),
    [anon_sym_SLASH_TILDE] = ACTIONS(744),
    [anon_sym_PERCENT_TILDE] = ACTIONS(744),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(744),
    [anon_sym_LT_LT_TILDE] = ACTIONS(744),
    [anon_sym_GT_GT_TILDE] = ACTIONS(744),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(744),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(744),
    [anon_sym_GT_TILDE] = ACTIONS(744),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(744),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(744),
    [anon_sym_LT_TILDE] = ACTIONS(744),
    [anon_sym_PLUS_QMARK] = ACTIONS(744),
    [anon_sym_DASH_QMARK] = ACTIONS(744),
    [anon_sym_STAR_QMARK] = ACTIONS(744),
    [anon_sym_SLASH_QMARK] = ACTIONS(744),
    [anon_sym_PERCENT_QMARK] = ACTIONS(744),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(744),
    [anon_sym_as] = ACTIONS(744),
    [anon_sym_LPAREN2] = ACTIONS(744),
    [anon_sym_DOT_GT] = ACTIONS(744),
    [anon_sym_TILDE] = ACTIONS(744),
    [anon_sym_if] = ACTIONS(746),
    [anon_sym_ifdef] = ACTIONS(744),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [885] = {
    [anon_sym_EQ] = ACTIONS(742),
    [anon_sym_is] = ACTIONS(742),
    [anon_sym_EQ_GT] = ACTIONS(740),
    [anon_sym_iso] = ACTIONS(740),
    [anon_sym_trn] = ACTIONS(740),
    [anon_sym_ref] = ACTIONS(740),
    [anon_sym_val] = ACTIONS(740),
    [anon_sym_box] = ACTIONS(740),
    [anon_sym_tag] = ACTIONS(740),
    [anon_sym_DOT] = ACTIONS(742),
    [anon_sym_POUNDread] = ACTIONS(740),
    [anon_sym_POUNDsend] = ACTIONS(740),
    [anon_sym_POUNDshare] = ACTIONS(740),
    [anon_sym_POUNDalias] = ACTIONS(740),
    [anon_sym_POUNDany] = ACTIONS(740),
    [anon_sym_BANG] = ACTIONS(742),
    [anon_sym_CARET] = ACTIONS(740),
    [anon_sym_PIPE] = ACTIONS(740),
    [anon_sym_AMP] = ACTIONS(740),
    [anon_sym_DASH_GT] = ACTIONS(740),
    [anon_sym_DASH] = ACTIONS(742),
    [anon_sym_DASH_TILDE] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(742),
    [anon_sym_STAR] = ACTIONS(742),
    [anon_sym_SLASH] = ACTIONS(742),
    [anon_sym_PERCENT] = ACTIONS(742),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(742),
    [anon_sym_LT_LT] = ACTIONS(742),
    [anon_sym_GT_GT] = ACTIONS(742),
    [anon_sym_and] = ACTIONS(740),
    [anon_sym_or] = ACTIONS(740),
    [anon_sym_xor] = ACTIONS(740),
    [anon_sym_isnt] = ACTIONS(740),
    [anon_sym_EQ_EQ] = ACTIONS(742),
    [anon_sym_BANG_EQ] = ACTIONS(742),
    [anon_sym_GT] = ACTIONS(742),
    [anon_sym_GT_EQ] = ACTIONS(742),
    [anon_sym_LT_EQ] = ACTIONS(742),
    [anon_sym_LT] = ACTIONS(742),
    [anon_sym_PLUS_TILDE] = ACTIONS(740),
    [anon_sym_STAR_TILDE] = ACTIONS(740),
    [anon_sym_SLASH_TILDE] = ACTIONS(740),
    [anon_sym_PERCENT_TILDE] = ACTIONS(740),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(740),
    [anon_sym_LT_LT_TILDE] = ACTIONS(740),
    [anon_sym_GT_GT_TILDE] = ACTIONS(740),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(740),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(740),
    [anon_sym_GT_TILDE] = ACTIONS(740),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(740),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(740),
    [anon_sym_LT_TILDE] = ACTIONS(740),
    [anon_sym_PLUS_QMARK] = ACTIONS(740),
    [anon_sym_DASH_QMARK] = ACTIONS(740),
    [anon_sym_STAR_QMARK] = ACTIONS(740),
    [anon_sym_SLASH_QMARK] = ACTIONS(740),
    [anon_sym_PERCENT_QMARK] = ACTIONS(740),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(740),
    [anon_sym_as] = ACTIONS(740),
    [anon_sym_LPAREN2] = ACTIONS(740),
    [anon_sym_DOT_GT] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_if] = ACTIONS(742),
    [anon_sym_ifdef] = ACTIONS(740),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [886] = {
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_is] = ACTIONS(738),
    [anon_sym_EQ_GT] = ACTIONS(736),
    [anon_sym_iso] = ACTIONS(736),
    [anon_sym_trn] = ACTIONS(736),
    [anon_sym_ref] = ACTIONS(736),
    [anon_sym_val] = ACTIONS(736),
    [anon_sym_box] = ACTIONS(736),
    [anon_sym_tag] = ACTIONS(736),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_POUNDread] = ACTIONS(736),
    [anon_sym_POUNDsend] = ACTIONS(736),
    [anon_sym_POUNDshare] = ACTIONS(736),
    [anon_sym_POUNDalias] = ACTIONS(736),
    [anon_sym_POUNDany] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(738),
    [anon_sym_CARET] = ACTIONS(736),
    [anon_sym_PIPE] = ACTIONS(736),
    [anon_sym_AMP] = ACTIONS(736),
    [anon_sym_DASH_GT] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DASH_TILDE] = ACTIONS(736),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(738),
    [anon_sym_LT_LT] = ACTIONS(738),
    [anon_sym_GT_GT] = ACTIONS(738),
    [anon_sym_and] = ACTIONS(736),
    [anon_sym_or] = ACTIONS(736),
    [anon_sym_xor] = ACTIONS(736),
    [anon_sym_isnt] = ACTIONS(736),
    [anon_sym_EQ_EQ] = ACTIONS(738),
    [anon_sym_BANG_EQ] = ACTIONS(738),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_EQ] = ACTIONS(738),
    [anon_sym_LT] = ACTIONS(738),
    [anon_sym_PLUS_TILDE] = ACTIONS(736),
    [anon_sym_STAR_TILDE] = ACTIONS(736),
    [anon_sym_SLASH_TILDE] = ACTIONS(736),
    [anon_sym_PERCENT_TILDE] = ACTIONS(736),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(736),
    [anon_sym_LT_LT_TILDE] = ACTIONS(736),
    [anon_sym_GT_GT_TILDE] = ACTIONS(736),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(736),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(736),
    [anon_sym_GT_TILDE] = ACTIONS(736),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(736),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(736),
    [anon_sym_LT_TILDE] = ACTIONS(736),
    [anon_sym_PLUS_QMARK] = ACTIONS(736),
    [anon_sym_DASH_QMARK] = ACTIONS(736),
    [anon_sym_STAR_QMARK] = ACTIONS(736),
    [anon_sym_SLASH_QMARK] = ACTIONS(736),
    [anon_sym_PERCENT_QMARK] = ACTIONS(736),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(736),
    [anon_sym_as] = ACTIONS(736),
    [anon_sym_LPAREN2] = ACTIONS(736),
    [anon_sym_DOT_GT] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_if] = ACTIONS(738),
    [anon_sym_ifdef] = ACTIONS(736),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [887] = {
    [anon_sym_EQ] = ACTIONS(636),
    [anon_sym_is] = ACTIONS(636),
    [anon_sym_EQ_GT] = ACTIONS(634),
    [anon_sym_iso] = ACTIONS(634),
    [anon_sym_trn] = ACTIONS(634),
    [anon_sym_ref] = ACTIONS(634),
    [anon_sym_val] = ACTIONS(634),
    [anon_sym_box] = ACTIONS(634),
    [anon_sym_tag] = ACTIONS(634),
    [anon_sym_DOT] = ACTIONS(636),
    [anon_sym_POUNDread] = ACTIONS(634),
    [anon_sym_POUNDsend] = ACTIONS(634),
    [anon_sym_POUNDshare] = ACTIONS(634),
    [anon_sym_POUNDalias] = ACTIONS(634),
    [anon_sym_POUNDany] = ACTIONS(634),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_CARET] = ACTIONS(634),
    [anon_sym_PIPE] = ACTIONS(634),
    [anon_sym_AMP] = ACTIONS(634),
    [anon_sym_DASH_GT] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(636),
    [anon_sym_DASH_TILDE] = ACTIONS(634),
    [anon_sym_PLUS] = ACTIONS(636),
    [anon_sym_STAR] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(636),
    [anon_sym_PERCENT] = ACTIONS(636),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(636),
    [anon_sym_LT_LT] = ACTIONS(636),
    [anon_sym_GT_GT] = ACTIONS(636),
    [anon_sym_and] = ACTIONS(634),
    [anon_sym_or] = ACTIONS(634),
    [anon_sym_xor] = ACTIONS(634),
    [anon_sym_isnt] = ACTIONS(634),
    [anon_sym_EQ_EQ] = ACTIONS(636),
    [anon_sym_BANG_EQ] = ACTIONS(636),
    [anon_sym_GT] = ACTIONS(636),
    [anon_sym_GT_EQ] = ACTIONS(636),
    [anon_sym_LT_EQ] = ACTIONS(636),
    [anon_sym_LT] = ACTIONS(636),
    [anon_sym_PLUS_TILDE] = ACTIONS(634),
    [anon_sym_STAR_TILDE] = ACTIONS(634),
    [anon_sym_SLASH_TILDE] = ACTIONS(634),
    [anon_sym_PERCENT_TILDE] = ACTIONS(634),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(634),
    [anon_sym_LT_LT_TILDE] = ACTIONS(634),
    [anon_sym_GT_GT_TILDE] = ACTIONS(634),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(634),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(634),
    [anon_sym_GT_TILDE] = ACTIONS(634),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(634),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(634),
    [anon_sym_LT_TILDE] = ACTIONS(634),
    [anon_sym_PLUS_QMARK] = ACTIONS(634),
    [anon_sym_DASH_QMARK] = ACTIONS(634),
    [anon_sym_STAR_QMARK] = ACTIONS(634),
    [anon_sym_SLASH_QMARK] = ACTIONS(634),
    [anon_sym_PERCENT_QMARK] = ACTIONS(634),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(634),
    [anon_sym_as] = ACTIONS(634),
    [anon_sym_LPAREN2] = ACTIONS(634),
    [anon_sym_DOT_GT] = ACTIONS(634),
    [anon_sym_TILDE] = ACTIONS(634),
    [anon_sym_if] = ACTIONS(636),
    [anon_sym_ifdef] = ACTIONS(634),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [888] = {
    [anon_sym_EQ] = ACTIONS(632),
    [anon_sym_is] = ACTIONS(632),
    [anon_sym_EQ_GT] = ACTIONS(630),
    [anon_sym_iso] = ACTIONS(630),
    [anon_sym_trn] = ACTIONS(630),
    [anon_sym_ref] = ACTIONS(630),
    [anon_sym_val] = ACTIONS(630),
    [anon_sym_box] = ACTIONS(630),
    [anon_sym_tag] = ACTIONS(630),
    [anon_sym_DOT] = ACTIONS(632),
    [anon_sym_POUNDread] = ACTIONS(630),
    [anon_sym_POUNDsend] = ACTIONS(630),
    [anon_sym_POUNDshare] = ACTIONS(630),
    [anon_sym_POUNDalias] = ACTIONS(630),
    [anon_sym_POUNDany] = ACTIONS(630),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_CARET] = ACTIONS(630),
    [anon_sym_PIPE] = ACTIONS(630),
    [anon_sym_AMP] = ACTIONS(630),
    [anon_sym_DASH_GT] = ACTIONS(630),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_DASH_TILDE] = ACTIONS(630),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_STAR] = ACTIONS(632),
    [anon_sym_SLASH] = ACTIONS(632),
    [anon_sym_PERCENT] = ACTIONS(632),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(632),
    [anon_sym_LT_LT] = ACTIONS(632),
    [anon_sym_GT_GT] = ACTIONS(632),
    [anon_sym_and] = ACTIONS(630),
    [anon_sym_or] = ACTIONS(630),
    [anon_sym_xor] = ACTIONS(630),
    [anon_sym_isnt] = ACTIONS(630),
    [anon_sym_EQ_EQ] = ACTIONS(632),
    [anon_sym_BANG_EQ] = ACTIONS(632),
    [anon_sym_GT] = ACTIONS(632),
    [anon_sym_GT_EQ] = ACTIONS(632),
    [anon_sym_LT_EQ] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(632),
    [anon_sym_PLUS_TILDE] = ACTIONS(630),
    [anon_sym_STAR_TILDE] = ACTIONS(630),
    [anon_sym_SLASH_TILDE] = ACTIONS(630),
    [anon_sym_PERCENT_TILDE] = ACTIONS(630),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(630),
    [anon_sym_LT_LT_TILDE] = ACTIONS(630),
    [anon_sym_GT_GT_TILDE] = ACTIONS(630),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(630),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(630),
    [anon_sym_GT_TILDE] = ACTIONS(630),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(630),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(630),
    [anon_sym_LT_TILDE] = ACTIONS(630),
    [anon_sym_PLUS_QMARK] = ACTIONS(630),
    [anon_sym_DASH_QMARK] = ACTIONS(630),
    [anon_sym_STAR_QMARK] = ACTIONS(630),
    [anon_sym_SLASH_QMARK] = ACTIONS(630),
    [anon_sym_PERCENT_QMARK] = ACTIONS(630),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(630),
    [anon_sym_as] = ACTIONS(630),
    [anon_sym_LPAREN2] = ACTIONS(630),
    [anon_sym_DOT_GT] = ACTIONS(630),
    [anon_sym_TILDE] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(632),
    [anon_sym_ifdef] = ACTIONS(630),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [889] = {
    [anon_sym_EQ] = ACTIONS(672),
    [anon_sym_is] = ACTIONS(672),
    [anon_sym_EQ_GT] = ACTIONS(670),
    [anon_sym_iso] = ACTIONS(670),
    [anon_sym_trn] = ACTIONS(670),
    [anon_sym_ref] = ACTIONS(670),
    [anon_sym_val] = ACTIONS(670),
    [anon_sym_box] = ACTIONS(670),
    [anon_sym_tag] = ACTIONS(670),
    [anon_sym_DOT] = ACTIONS(672),
    [anon_sym_POUNDread] = ACTIONS(670),
    [anon_sym_POUNDsend] = ACTIONS(670),
    [anon_sym_POUNDshare] = ACTIONS(670),
    [anon_sym_POUNDalias] = ACTIONS(670),
    [anon_sym_POUNDany] = ACTIONS(670),
    [anon_sym_BANG] = ACTIONS(672),
    [anon_sym_CARET] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(670),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_DASH_GT] = ACTIONS(670),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_DASH_TILDE] = ACTIONS(670),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_STAR] = ACTIONS(672),
    [anon_sym_SLASH] = ACTIONS(672),
    [anon_sym_PERCENT] = ACTIONS(672),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(672),
    [anon_sym_LT_LT] = ACTIONS(672),
    [anon_sym_GT_GT] = ACTIONS(672),
    [anon_sym_and] = ACTIONS(670),
    [anon_sym_or] = ACTIONS(670),
    [anon_sym_xor] = ACTIONS(670),
    [anon_sym_isnt] = ACTIONS(670),
    [anon_sym_EQ_EQ] = ACTIONS(672),
    [anon_sym_BANG_EQ] = ACTIONS(672),
    [anon_sym_GT] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(672),
    [anon_sym_LT_EQ] = ACTIONS(672),
    [anon_sym_LT] = ACTIONS(672),
    [anon_sym_PLUS_TILDE] = ACTIONS(670),
    [anon_sym_STAR_TILDE] = ACTIONS(670),
    [anon_sym_SLASH_TILDE] = ACTIONS(670),
    [anon_sym_PERCENT_TILDE] = ACTIONS(670),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(670),
    [anon_sym_LT_LT_TILDE] = ACTIONS(670),
    [anon_sym_GT_GT_TILDE] = ACTIONS(670),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(670),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(670),
    [anon_sym_GT_TILDE] = ACTIONS(670),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(670),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(670),
    [anon_sym_LT_TILDE] = ACTIONS(670),
    [anon_sym_PLUS_QMARK] = ACTIONS(670),
    [anon_sym_DASH_QMARK] = ACTIONS(670),
    [anon_sym_STAR_QMARK] = ACTIONS(670),
    [anon_sym_SLASH_QMARK] = ACTIONS(670),
    [anon_sym_PERCENT_QMARK] = ACTIONS(670),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(670),
    [anon_sym_as] = ACTIONS(670),
    [anon_sym_LPAREN2] = ACTIONS(670),
    [anon_sym_DOT_GT] = ACTIONS(670),
    [anon_sym_TILDE] = ACTIONS(670),
    [anon_sym_if] = ACTIONS(672),
    [anon_sym_ifdef] = ACTIONS(670),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [890] = {
    [anon_sym_EQ] = ACTIONS(718),
    [anon_sym_is] = ACTIONS(718),
    [anon_sym_EQ_GT] = ACTIONS(716),
    [anon_sym_iso] = ACTIONS(716),
    [anon_sym_trn] = ACTIONS(716),
    [anon_sym_ref] = ACTIONS(716),
    [anon_sym_val] = ACTIONS(716),
    [anon_sym_box] = ACTIONS(716),
    [anon_sym_tag] = ACTIONS(716),
    [anon_sym_DOT] = ACTIONS(718),
    [anon_sym_POUNDread] = ACTIONS(716),
    [anon_sym_POUNDsend] = ACTIONS(716),
    [anon_sym_POUNDshare] = ACTIONS(716),
    [anon_sym_POUNDalias] = ACTIONS(716),
    [anon_sym_POUNDany] = ACTIONS(716),
    [anon_sym_BANG] = ACTIONS(718),
    [anon_sym_CARET] = ACTIONS(716),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_AMP] = ACTIONS(716),
    [anon_sym_DASH_GT] = ACTIONS(716),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_DASH_TILDE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_STAR] = ACTIONS(718),
    [anon_sym_SLASH] = ACTIONS(718),
    [anon_sym_PERCENT] = ACTIONS(718),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(718),
    [anon_sym_LT_LT] = ACTIONS(718),
    [anon_sym_GT_GT] = ACTIONS(718),
    [anon_sym_and] = ACTIONS(716),
    [anon_sym_or] = ACTIONS(716),
    [anon_sym_xor] = ACTIONS(716),
    [anon_sym_isnt] = ACTIONS(716),
    [anon_sym_EQ_EQ] = ACTIONS(718),
    [anon_sym_BANG_EQ] = ACTIONS(718),
    [anon_sym_GT] = ACTIONS(718),
    [anon_sym_GT_EQ] = ACTIONS(718),
    [anon_sym_LT_EQ] = ACTIONS(718),
    [anon_sym_LT] = ACTIONS(718),
    [anon_sym_PLUS_TILDE] = ACTIONS(716),
    [anon_sym_STAR_TILDE] = ACTIONS(716),
    [anon_sym_SLASH_TILDE] = ACTIONS(716),
    [anon_sym_PERCENT_TILDE] = ACTIONS(716),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(716),
    [anon_sym_LT_LT_TILDE] = ACTIONS(716),
    [anon_sym_GT_GT_TILDE] = ACTIONS(716),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(716),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(716),
    [anon_sym_GT_TILDE] = ACTIONS(716),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(716),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(716),
    [anon_sym_LT_TILDE] = ACTIONS(716),
    [anon_sym_PLUS_QMARK] = ACTIONS(716),
    [anon_sym_DASH_QMARK] = ACTIONS(716),
    [anon_sym_STAR_QMARK] = ACTIONS(716),
    [anon_sym_SLASH_QMARK] = ACTIONS(716),
    [anon_sym_PERCENT_QMARK] = ACTIONS(716),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(716),
    [anon_sym_as] = ACTIONS(716),
    [anon_sym_LPAREN2] = ACTIONS(716),
    [anon_sym_DOT_GT] = ACTIONS(716),
    [anon_sym_TILDE] = ACTIONS(716),
    [anon_sym_if] = ACTIONS(718),
    [anon_sym_ifdef] = ACTIONS(716),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [891] = {
    [anon_sym_EQ] = ACTIONS(652),
    [anon_sym_is] = ACTIONS(652),
    [anon_sym_EQ_GT] = ACTIONS(650),
    [anon_sym_iso] = ACTIONS(650),
    [anon_sym_trn] = ACTIONS(650),
    [anon_sym_ref] = ACTIONS(650),
    [anon_sym_val] = ACTIONS(650),
    [anon_sym_box] = ACTIONS(650),
    [anon_sym_tag] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(652),
    [anon_sym_POUNDread] = ACTIONS(650),
    [anon_sym_POUNDsend] = ACTIONS(650),
    [anon_sym_POUNDshare] = ACTIONS(650),
    [anon_sym_POUNDalias] = ACTIONS(650),
    [anon_sym_POUNDany] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(650),
    [anon_sym_DASH_GT] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_DASH_TILDE] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_STAR] = ACTIONS(652),
    [anon_sym_SLASH] = ACTIONS(652),
    [anon_sym_PERCENT] = ACTIONS(652),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(652),
    [anon_sym_LT_LT] = ACTIONS(652),
    [anon_sym_GT_GT] = ACTIONS(652),
    [anon_sym_and] = ACTIONS(650),
    [anon_sym_or] = ACTIONS(650),
    [anon_sym_xor] = ACTIONS(650),
    [anon_sym_isnt] = ACTIONS(650),
    [anon_sym_EQ_EQ] = ACTIONS(652),
    [anon_sym_BANG_EQ] = ACTIONS(652),
    [anon_sym_GT] = ACTIONS(652),
    [anon_sym_GT_EQ] = ACTIONS(652),
    [anon_sym_LT_EQ] = ACTIONS(652),
    [anon_sym_LT] = ACTIONS(652),
    [anon_sym_PLUS_TILDE] = ACTIONS(650),
    [anon_sym_STAR_TILDE] = ACTIONS(650),
    [anon_sym_SLASH_TILDE] = ACTIONS(650),
    [anon_sym_PERCENT_TILDE] = ACTIONS(650),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(650),
    [anon_sym_LT_LT_TILDE] = ACTIONS(650),
    [anon_sym_GT_GT_TILDE] = ACTIONS(650),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(650),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(650),
    [anon_sym_GT_TILDE] = ACTIONS(650),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(650),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(650),
    [anon_sym_LT_TILDE] = ACTIONS(650),
    [anon_sym_PLUS_QMARK] = ACTIONS(650),
    [anon_sym_DASH_QMARK] = ACTIONS(650),
    [anon_sym_STAR_QMARK] = ACTIONS(650),
    [anon_sym_SLASH_QMARK] = ACTIONS(650),
    [anon_sym_PERCENT_QMARK] = ACTIONS(650),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(650),
    [anon_sym_as] = ACTIONS(650),
    [anon_sym_LPAREN2] = ACTIONS(650),
    [anon_sym_DOT_GT] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_if] = ACTIONS(652),
    [anon_sym_ifdef] = ACTIONS(650),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [892] = {
    [anon_sym_EQ] = ACTIONS(644),
    [anon_sym_is] = ACTIONS(644),
    [anon_sym_EQ_GT] = ACTIONS(642),
    [anon_sym_iso] = ACTIONS(642),
    [anon_sym_trn] = ACTIONS(642),
    [anon_sym_ref] = ACTIONS(642),
    [anon_sym_val] = ACTIONS(642),
    [anon_sym_box] = ACTIONS(642),
    [anon_sym_tag] = ACTIONS(642),
    [anon_sym_DOT] = ACTIONS(644),
    [anon_sym_POUNDread] = ACTIONS(642),
    [anon_sym_POUNDsend] = ACTIONS(642),
    [anon_sym_POUNDshare] = ACTIONS(642),
    [anon_sym_POUNDalias] = ACTIONS(642),
    [anon_sym_POUNDany] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(644),
    [anon_sym_CARET] = ACTIONS(642),
    [anon_sym_PIPE] = ACTIONS(642),
    [anon_sym_AMP] = ACTIONS(642),
    [anon_sym_DASH_GT] = ACTIONS(642),
    [anon_sym_DASH] = ACTIONS(644),
    [anon_sym_DASH_TILDE] = ACTIONS(642),
    [anon_sym_PLUS] = ACTIONS(644),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_SLASH] = ACTIONS(644),
    [anon_sym_PERCENT] = ACTIONS(644),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(644),
    [anon_sym_LT_LT] = ACTIONS(644),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_and] = ACTIONS(642),
    [anon_sym_or] = ACTIONS(642),
    [anon_sym_xor] = ACTIONS(642),
    [anon_sym_isnt] = ACTIONS(642),
    [anon_sym_EQ_EQ] = ACTIONS(644),
    [anon_sym_BANG_EQ] = ACTIONS(644),
    [anon_sym_GT] = ACTIONS(644),
    [anon_sym_GT_EQ] = ACTIONS(644),
    [anon_sym_LT_EQ] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(644),
    [anon_sym_PLUS_TILDE] = ACTIONS(642),
    [anon_sym_STAR_TILDE] = ACTIONS(642),
    [anon_sym_SLASH_TILDE] = ACTIONS(642),
    [anon_sym_PERCENT_TILDE] = ACTIONS(642),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(642),
    [anon_sym_LT_LT_TILDE] = ACTIONS(642),
    [anon_sym_GT_GT_TILDE] = ACTIONS(642),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(642),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(642),
    [anon_sym_GT_TILDE] = ACTIONS(642),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(642),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(642),
    [anon_sym_LT_TILDE] = ACTIONS(642),
    [anon_sym_PLUS_QMARK] = ACTIONS(642),
    [anon_sym_DASH_QMARK] = ACTIONS(642),
    [anon_sym_STAR_QMARK] = ACTIONS(642),
    [anon_sym_SLASH_QMARK] = ACTIONS(642),
    [anon_sym_PERCENT_QMARK] = ACTIONS(642),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(642),
    [anon_sym_as] = ACTIONS(642),
    [anon_sym_LPAREN2] = ACTIONS(642),
    [anon_sym_DOT_GT] = ACTIONS(642),
    [anon_sym_TILDE] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(644),
    [anon_sym_ifdef] = ACTIONS(642),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [893] = {
    [anon_sym_EQ] = ACTIONS(640),
    [anon_sym_is] = ACTIONS(640),
    [anon_sym_EQ_GT] = ACTIONS(638),
    [anon_sym_iso] = ACTIONS(638),
    [anon_sym_trn] = ACTIONS(638),
    [anon_sym_ref] = ACTIONS(638),
    [anon_sym_val] = ACTIONS(638),
    [anon_sym_box] = ACTIONS(638),
    [anon_sym_tag] = ACTIONS(638),
    [anon_sym_DOT] = ACTIONS(640),
    [anon_sym_POUNDread] = ACTIONS(638),
    [anon_sym_POUNDsend] = ACTIONS(638),
    [anon_sym_POUNDshare] = ACTIONS(638),
    [anon_sym_POUNDalias] = ACTIONS(638),
    [anon_sym_POUNDany] = ACTIONS(638),
    [anon_sym_BANG] = ACTIONS(640),
    [anon_sym_CARET] = ACTIONS(638),
    [anon_sym_PIPE] = ACTIONS(638),
    [anon_sym_AMP] = ACTIONS(638),
    [anon_sym_DASH_GT] = ACTIONS(638),
    [anon_sym_DASH] = ACTIONS(640),
    [anon_sym_DASH_TILDE] = ACTIONS(638),
    [anon_sym_PLUS] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(640),
    [anon_sym_SLASH] = ACTIONS(640),
    [anon_sym_PERCENT] = ACTIONS(640),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(640),
    [anon_sym_LT_LT] = ACTIONS(640),
    [anon_sym_GT_GT] = ACTIONS(640),
    [anon_sym_and] = ACTIONS(638),
    [anon_sym_or] = ACTIONS(638),
    [anon_sym_xor] = ACTIONS(638),
    [anon_sym_isnt] = ACTIONS(638),
    [anon_sym_EQ_EQ] = ACTIONS(640),
    [anon_sym_BANG_EQ] = ACTIONS(640),
    [anon_sym_GT] = ACTIONS(640),
    [anon_sym_GT_EQ] = ACTIONS(640),
    [anon_sym_LT_EQ] = ACTIONS(640),
    [anon_sym_LT] = ACTIONS(640),
    [anon_sym_PLUS_TILDE] = ACTIONS(638),
    [anon_sym_STAR_TILDE] = ACTIONS(638),
    [anon_sym_SLASH_TILDE] = ACTIONS(638),
    [anon_sym_PERCENT_TILDE] = ACTIONS(638),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(638),
    [anon_sym_LT_LT_TILDE] = ACTIONS(638),
    [anon_sym_GT_GT_TILDE] = ACTIONS(638),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(638),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(638),
    [anon_sym_GT_TILDE] = ACTIONS(638),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(638),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(638),
    [anon_sym_LT_TILDE] = ACTIONS(638),
    [anon_sym_PLUS_QMARK] = ACTIONS(638),
    [anon_sym_DASH_QMARK] = ACTIONS(638),
    [anon_sym_STAR_QMARK] = ACTIONS(638),
    [anon_sym_SLASH_QMARK] = ACTIONS(638),
    [anon_sym_PERCENT_QMARK] = ACTIONS(638),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(638),
    [anon_sym_as] = ACTIONS(638),
    [anon_sym_LPAREN2] = ACTIONS(638),
    [anon_sym_DOT_GT] = ACTIONS(638),
    [anon_sym_TILDE] = ACTIONS(638),
    [anon_sym_if] = ACTIONS(640),
    [anon_sym_ifdef] = ACTIONS(638),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [894] = {
    [anon_sym_EQ] = ACTIONS(668),
    [anon_sym_is] = ACTIONS(668),
    [anon_sym_EQ_GT] = ACTIONS(666),
    [anon_sym_iso] = ACTIONS(666),
    [anon_sym_trn] = ACTIONS(666),
    [anon_sym_ref] = ACTIONS(666),
    [anon_sym_val] = ACTIONS(666),
    [anon_sym_box] = ACTIONS(666),
    [anon_sym_tag] = ACTIONS(666),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_POUNDread] = ACTIONS(666),
    [anon_sym_POUNDsend] = ACTIONS(666),
    [anon_sym_POUNDshare] = ACTIONS(666),
    [anon_sym_POUNDalias] = ACTIONS(666),
    [anon_sym_POUNDany] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(666),
    [anon_sym_DASH_GT] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(668),
    [anon_sym_DASH_TILDE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(668),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(668),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(668),
    [anon_sym_LT_LT] = ACTIONS(668),
    [anon_sym_GT_GT] = ACTIONS(668),
    [anon_sym_and] = ACTIONS(666),
    [anon_sym_or] = ACTIONS(666),
    [anon_sym_xor] = ACTIONS(666),
    [anon_sym_isnt] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(668),
    [anon_sym_BANG_EQ] = ACTIONS(668),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_GT_EQ] = ACTIONS(668),
    [anon_sym_LT_EQ] = ACTIONS(668),
    [anon_sym_LT] = ACTIONS(668),
    [anon_sym_PLUS_TILDE] = ACTIONS(666),
    [anon_sym_STAR_TILDE] = ACTIONS(666),
    [anon_sym_SLASH_TILDE] = ACTIONS(666),
    [anon_sym_PERCENT_TILDE] = ACTIONS(666),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(666),
    [anon_sym_LT_LT_TILDE] = ACTIONS(666),
    [anon_sym_GT_GT_TILDE] = ACTIONS(666),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(666),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(666),
    [anon_sym_GT_TILDE] = ACTIONS(666),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(666),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(666),
    [anon_sym_LT_TILDE] = ACTIONS(666),
    [anon_sym_PLUS_QMARK] = ACTIONS(666),
    [anon_sym_DASH_QMARK] = ACTIONS(666),
    [anon_sym_STAR_QMARK] = ACTIONS(666),
    [anon_sym_SLASH_QMARK] = ACTIONS(666),
    [anon_sym_PERCENT_QMARK] = ACTIONS(666),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(666),
    [anon_sym_LPAREN2] = ACTIONS(666),
    [anon_sym_DOT_GT] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_if] = ACTIONS(668),
    [anon_sym_ifdef] = ACTIONS(666),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [895] = {
    [anon_sym_EQ] = ACTIONS(676),
    [anon_sym_is] = ACTIONS(676),
    [anon_sym_EQ_GT] = ACTIONS(674),
    [anon_sym_iso] = ACTIONS(674),
    [anon_sym_trn] = ACTIONS(674),
    [anon_sym_ref] = ACTIONS(674),
    [anon_sym_val] = ACTIONS(674),
    [anon_sym_box] = ACTIONS(674),
    [anon_sym_tag] = ACTIONS(674),
    [anon_sym_DOT] = ACTIONS(676),
    [anon_sym_POUNDread] = ACTIONS(674),
    [anon_sym_POUNDsend] = ACTIONS(674),
    [anon_sym_POUNDshare] = ACTIONS(674),
    [anon_sym_POUNDalias] = ACTIONS(674),
    [anon_sym_POUNDany] = ACTIONS(674),
    [anon_sym_BANG] = ACTIONS(676),
    [anon_sym_CARET] = ACTIONS(674),
    [anon_sym_PIPE] = ACTIONS(674),
    [anon_sym_AMP] = ACTIONS(674),
    [anon_sym_DASH_GT] = ACTIONS(674),
    [anon_sym_DASH] = ACTIONS(676),
    [anon_sym_DASH_TILDE] = ACTIONS(674),
    [anon_sym_PLUS] = ACTIONS(676),
    [anon_sym_STAR] = ACTIONS(676),
    [anon_sym_SLASH] = ACTIONS(676),
    [anon_sym_PERCENT] = ACTIONS(676),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(676),
    [anon_sym_LT_LT] = ACTIONS(676),
    [anon_sym_GT_GT] = ACTIONS(676),
    [anon_sym_and] = ACTIONS(674),
    [anon_sym_or] = ACTIONS(674),
    [anon_sym_xor] = ACTIONS(674),
    [anon_sym_isnt] = ACTIONS(674),
    [anon_sym_EQ_EQ] = ACTIONS(676),
    [anon_sym_BANG_EQ] = ACTIONS(676),
    [anon_sym_GT] = ACTIONS(676),
    [anon_sym_GT_EQ] = ACTIONS(676),
    [anon_sym_LT_EQ] = ACTIONS(676),
    [anon_sym_LT] = ACTIONS(676),
    [anon_sym_PLUS_TILDE] = ACTIONS(674),
    [anon_sym_STAR_TILDE] = ACTIONS(674),
    [anon_sym_SLASH_TILDE] = ACTIONS(674),
    [anon_sym_PERCENT_TILDE] = ACTIONS(674),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(674),
    [anon_sym_LT_LT_TILDE] = ACTIONS(674),
    [anon_sym_GT_GT_TILDE] = ACTIONS(674),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(674),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(674),
    [anon_sym_GT_TILDE] = ACTIONS(674),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(674),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(674),
    [anon_sym_LT_TILDE] = ACTIONS(674),
    [anon_sym_PLUS_QMARK] = ACTIONS(674),
    [anon_sym_DASH_QMARK] = ACTIONS(674),
    [anon_sym_STAR_QMARK] = ACTIONS(674),
    [anon_sym_SLASH_QMARK] = ACTIONS(674),
    [anon_sym_PERCENT_QMARK] = ACTIONS(674),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(674),
    [anon_sym_as] = ACTIONS(674),
    [anon_sym_LPAREN2] = ACTIONS(674),
    [anon_sym_DOT_GT] = ACTIONS(674),
    [anon_sym_TILDE] = ACTIONS(674),
    [anon_sym_if] = ACTIONS(676),
    [anon_sym_ifdef] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [896] = {
    [anon_sym_EQ] = ACTIONS(714),
    [anon_sym_is] = ACTIONS(714),
    [anon_sym_EQ_GT] = ACTIONS(712),
    [anon_sym_iso] = ACTIONS(712),
    [anon_sym_trn] = ACTIONS(712),
    [anon_sym_ref] = ACTIONS(712),
    [anon_sym_val] = ACTIONS(712),
    [anon_sym_box] = ACTIONS(712),
    [anon_sym_tag] = ACTIONS(712),
    [anon_sym_DOT] = ACTIONS(714),
    [anon_sym_POUNDread] = ACTIONS(712),
    [anon_sym_POUNDsend] = ACTIONS(712),
    [anon_sym_POUNDshare] = ACTIONS(712),
    [anon_sym_POUNDalias] = ACTIONS(712),
    [anon_sym_POUNDany] = ACTIONS(712),
    [anon_sym_BANG] = ACTIONS(714),
    [anon_sym_CARET] = ACTIONS(712),
    [anon_sym_PIPE] = ACTIONS(712),
    [anon_sym_AMP] = ACTIONS(712),
    [anon_sym_DASH_GT] = ACTIONS(712),
    [anon_sym_DASH] = ACTIONS(714),
    [anon_sym_DASH_TILDE] = ACTIONS(712),
    [anon_sym_PLUS] = ACTIONS(714),
    [anon_sym_STAR] = ACTIONS(714),
    [anon_sym_SLASH] = ACTIONS(714),
    [anon_sym_PERCENT] = ACTIONS(714),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(714),
    [anon_sym_LT_LT] = ACTIONS(714),
    [anon_sym_GT_GT] = ACTIONS(714),
    [anon_sym_and] = ACTIONS(712),
    [anon_sym_or] = ACTIONS(712),
    [anon_sym_xor] = ACTIONS(712),
    [anon_sym_isnt] = ACTIONS(712),
    [anon_sym_EQ_EQ] = ACTIONS(714),
    [anon_sym_BANG_EQ] = ACTIONS(714),
    [anon_sym_GT] = ACTIONS(714),
    [anon_sym_GT_EQ] = ACTIONS(714),
    [anon_sym_LT_EQ] = ACTIONS(714),
    [anon_sym_LT] = ACTIONS(714),
    [anon_sym_PLUS_TILDE] = ACTIONS(712),
    [anon_sym_STAR_TILDE] = ACTIONS(712),
    [anon_sym_SLASH_TILDE] = ACTIONS(712),
    [anon_sym_PERCENT_TILDE] = ACTIONS(712),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(712),
    [anon_sym_LT_LT_TILDE] = ACTIONS(712),
    [anon_sym_GT_GT_TILDE] = ACTIONS(712),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(712),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(712),
    [anon_sym_GT_TILDE] = ACTIONS(712),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(712),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(712),
    [anon_sym_LT_TILDE] = ACTIONS(712),
    [anon_sym_PLUS_QMARK] = ACTIONS(712),
    [anon_sym_DASH_QMARK] = ACTIONS(712),
    [anon_sym_STAR_QMARK] = ACTIONS(712),
    [anon_sym_SLASH_QMARK] = ACTIONS(712),
    [anon_sym_PERCENT_QMARK] = ACTIONS(712),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(712),
    [anon_sym_as] = ACTIONS(712),
    [anon_sym_LPAREN2] = ACTIONS(712),
    [anon_sym_DOT_GT] = ACTIONS(712),
    [anon_sym_TILDE] = ACTIONS(712),
    [anon_sym_if] = ACTIONS(714),
    [anon_sym_ifdef] = ACTIONS(712),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [897] = {
    [anon_sym_EQ] = ACTIONS(706),
    [anon_sym_is] = ACTIONS(706),
    [anon_sym_EQ_GT] = ACTIONS(704),
    [anon_sym_iso] = ACTIONS(704),
    [anon_sym_trn] = ACTIONS(704),
    [anon_sym_ref] = ACTIONS(704),
    [anon_sym_val] = ACTIONS(704),
    [anon_sym_box] = ACTIONS(704),
    [anon_sym_tag] = ACTIONS(704),
    [anon_sym_DOT] = ACTIONS(706),
    [anon_sym_POUNDread] = ACTIONS(704),
    [anon_sym_POUNDsend] = ACTIONS(704),
    [anon_sym_POUNDshare] = ACTIONS(704),
    [anon_sym_POUNDalias] = ACTIONS(704),
    [anon_sym_POUNDany] = ACTIONS(704),
    [anon_sym_BANG] = ACTIONS(706),
    [anon_sym_CARET] = ACTIONS(704),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_DASH_GT] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(706),
    [anon_sym_DASH_TILDE] = ACTIONS(704),
    [anon_sym_PLUS] = ACTIONS(706),
    [anon_sym_STAR] = ACTIONS(706),
    [anon_sym_SLASH] = ACTIONS(706),
    [anon_sym_PERCENT] = ACTIONS(706),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(706),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_GT_GT] = ACTIONS(706),
    [anon_sym_and] = ACTIONS(704),
    [anon_sym_or] = ACTIONS(704),
    [anon_sym_xor] = ACTIONS(704),
    [anon_sym_isnt] = ACTIONS(704),
    [anon_sym_EQ_EQ] = ACTIONS(706),
    [anon_sym_BANG_EQ] = ACTIONS(706),
    [anon_sym_GT] = ACTIONS(706),
    [anon_sym_GT_EQ] = ACTIONS(706),
    [anon_sym_LT_EQ] = ACTIONS(706),
    [anon_sym_LT] = ACTIONS(706),
    [anon_sym_PLUS_TILDE] = ACTIONS(704),
    [anon_sym_STAR_TILDE] = ACTIONS(704),
    [anon_sym_SLASH_TILDE] = ACTIONS(704),
    [anon_sym_PERCENT_TILDE] = ACTIONS(704),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(704),
    [anon_sym_LT_LT_TILDE] = ACTIONS(704),
    [anon_sym_GT_GT_TILDE] = ACTIONS(704),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(704),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(704),
    [anon_sym_GT_TILDE] = ACTIONS(704),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(704),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(704),
    [anon_sym_LT_TILDE] = ACTIONS(704),
    [anon_sym_PLUS_QMARK] = ACTIONS(704),
    [anon_sym_DASH_QMARK] = ACTIONS(704),
    [anon_sym_STAR_QMARK] = ACTIONS(704),
    [anon_sym_SLASH_QMARK] = ACTIONS(704),
    [anon_sym_PERCENT_QMARK] = ACTIONS(704),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(704),
    [anon_sym_as] = ACTIONS(704),
    [anon_sym_LPAREN2] = ACTIONS(704),
    [anon_sym_DOT_GT] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_if] = ACTIONS(706),
    [anon_sym_ifdef] = ACTIONS(704),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [898] = {
    [anon_sym_EQ] = ACTIONS(710),
    [anon_sym_is] = ACTIONS(710),
    [anon_sym_EQ_GT] = ACTIONS(708),
    [anon_sym_iso] = ACTIONS(708),
    [anon_sym_trn] = ACTIONS(708),
    [anon_sym_ref] = ACTIONS(708),
    [anon_sym_val] = ACTIONS(708),
    [anon_sym_box] = ACTIONS(708),
    [anon_sym_tag] = ACTIONS(708),
    [anon_sym_DOT] = ACTIONS(710),
    [anon_sym_POUNDread] = ACTIONS(708),
    [anon_sym_POUNDsend] = ACTIONS(708),
    [anon_sym_POUNDshare] = ACTIONS(708),
    [anon_sym_POUNDalias] = ACTIONS(708),
    [anon_sym_POUNDany] = ACTIONS(708),
    [anon_sym_BANG] = ACTIONS(710),
    [anon_sym_CARET] = ACTIONS(708),
    [anon_sym_PIPE] = ACTIONS(708),
    [anon_sym_AMP] = ACTIONS(708),
    [anon_sym_DASH_GT] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_DASH_TILDE] = ACTIONS(708),
    [anon_sym_PLUS] = ACTIONS(710),
    [anon_sym_STAR] = ACTIONS(710),
    [anon_sym_SLASH] = ACTIONS(710),
    [anon_sym_PERCENT] = ACTIONS(710),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(710),
    [anon_sym_LT_LT] = ACTIONS(710),
    [anon_sym_GT_GT] = ACTIONS(710),
    [anon_sym_and] = ACTIONS(708),
    [anon_sym_or] = ACTIONS(708),
    [anon_sym_xor] = ACTIONS(708),
    [anon_sym_isnt] = ACTIONS(708),
    [anon_sym_EQ_EQ] = ACTIONS(710),
    [anon_sym_BANG_EQ] = ACTIONS(710),
    [anon_sym_GT] = ACTIONS(710),
    [anon_sym_GT_EQ] = ACTIONS(710),
    [anon_sym_LT_EQ] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(710),
    [anon_sym_PLUS_TILDE] = ACTIONS(708),
    [anon_sym_STAR_TILDE] = ACTIONS(708),
    [anon_sym_SLASH_TILDE] = ACTIONS(708),
    [anon_sym_PERCENT_TILDE] = ACTIONS(708),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(708),
    [anon_sym_LT_LT_TILDE] = ACTIONS(708),
    [anon_sym_GT_GT_TILDE] = ACTIONS(708),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(708),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(708),
    [anon_sym_GT_TILDE] = ACTIONS(708),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(708),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(708),
    [anon_sym_LT_TILDE] = ACTIONS(708),
    [anon_sym_PLUS_QMARK] = ACTIONS(708),
    [anon_sym_DASH_QMARK] = ACTIONS(708),
    [anon_sym_STAR_QMARK] = ACTIONS(708),
    [anon_sym_SLASH_QMARK] = ACTIONS(708),
    [anon_sym_PERCENT_QMARK] = ACTIONS(708),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(708),
    [anon_sym_as] = ACTIONS(708),
    [anon_sym_LPAREN2] = ACTIONS(708),
    [anon_sym_DOT_GT] = ACTIONS(708),
    [anon_sym_TILDE] = ACTIONS(708),
    [anon_sym_if] = ACTIONS(710),
    [anon_sym_ifdef] = ACTIONS(708),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [899] = {
    [anon_sym_EQ] = ACTIONS(730),
    [anon_sym_is] = ACTIONS(730),
    [anon_sym_EQ_GT] = ACTIONS(728),
    [anon_sym_iso] = ACTIONS(728),
    [anon_sym_trn] = ACTIONS(728),
    [anon_sym_ref] = ACTIONS(728),
    [anon_sym_val] = ACTIONS(728),
    [anon_sym_box] = ACTIONS(728),
    [anon_sym_tag] = ACTIONS(728),
    [anon_sym_DOT] = ACTIONS(730),
    [anon_sym_POUNDread] = ACTIONS(728),
    [anon_sym_POUNDsend] = ACTIONS(728),
    [anon_sym_POUNDshare] = ACTIONS(728),
    [anon_sym_POUNDalias] = ACTIONS(728),
    [anon_sym_POUNDany] = ACTIONS(728),
    [anon_sym_BANG] = ACTIONS(730),
    [anon_sym_CARET] = ACTIONS(728),
    [anon_sym_PIPE] = ACTIONS(728),
    [anon_sym_AMP] = ACTIONS(728),
    [anon_sym_DASH_GT] = ACTIONS(728),
    [anon_sym_DASH] = ACTIONS(730),
    [anon_sym_DASH_TILDE] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(730),
    [anon_sym_STAR] = ACTIONS(730),
    [anon_sym_SLASH] = ACTIONS(730),
    [anon_sym_PERCENT] = ACTIONS(730),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(730),
    [anon_sym_LT_LT] = ACTIONS(730),
    [anon_sym_GT_GT] = ACTIONS(730),
    [anon_sym_and] = ACTIONS(728),
    [anon_sym_or] = ACTIONS(728),
    [anon_sym_xor] = ACTIONS(728),
    [anon_sym_isnt] = ACTIONS(728),
    [anon_sym_EQ_EQ] = ACTIONS(730),
    [anon_sym_BANG_EQ] = ACTIONS(730),
    [anon_sym_GT] = ACTIONS(730),
    [anon_sym_GT_EQ] = ACTIONS(730),
    [anon_sym_LT_EQ] = ACTIONS(730),
    [anon_sym_LT] = ACTIONS(730),
    [anon_sym_PLUS_TILDE] = ACTIONS(728),
    [anon_sym_STAR_TILDE] = ACTIONS(728),
    [anon_sym_SLASH_TILDE] = ACTIONS(728),
    [anon_sym_PERCENT_TILDE] = ACTIONS(728),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(728),
    [anon_sym_LT_LT_TILDE] = ACTIONS(728),
    [anon_sym_GT_GT_TILDE] = ACTIONS(728),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(728),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(728),
    [anon_sym_GT_TILDE] = ACTIONS(728),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(728),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(728),
    [anon_sym_LT_TILDE] = ACTIONS(728),
    [anon_sym_PLUS_QMARK] = ACTIONS(728),
    [anon_sym_DASH_QMARK] = ACTIONS(728),
    [anon_sym_STAR_QMARK] = ACTIONS(728),
    [anon_sym_SLASH_QMARK] = ACTIONS(728),
    [anon_sym_PERCENT_QMARK] = ACTIONS(728),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(728),
    [anon_sym_as] = ACTIONS(728),
    [anon_sym_LPAREN2] = ACTIONS(728),
    [anon_sym_DOT_GT] = ACTIONS(728),
    [anon_sym_TILDE] = ACTIONS(728),
    [anon_sym_if] = ACTIONS(730),
    [anon_sym_ifdef] = ACTIONS(728),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [900] = {
    [anon_sym_EQ] = ACTIONS(660),
    [anon_sym_is] = ACTIONS(660),
    [anon_sym_EQ_GT] = ACTIONS(658),
    [anon_sym_iso] = ACTIONS(658),
    [anon_sym_trn] = ACTIONS(658),
    [anon_sym_ref] = ACTIONS(658),
    [anon_sym_val] = ACTIONS(658),
    [anon_sym_box] = ACTIONS(658),
    [anon_sym_tag] = ACTIONS(658),
    [anon_sym_DOT] = ACTIONS(660),
    [anon_sym_POUNDread] = ACTIONS(658),
    [anon_sym_POUNDsend] = ACTIONS(658),
    [anon_sym_POUNDshare] = ACTIONS(658),
    [anon_sym_POUNDalias] = ACTIONS(658),
    [anon_sym_POUNDany] = ACTIONS(658),
    [anon_sym_BANG] = ACTIONS(660),
    [anon_sym_CARET] = ACTIONS(658),
    [anon_sym_PIPE] = ACTIONS(658),
    [anon_sym_AMP] = ACTIONS(658),
    [anon_sym_DASH_GT] = ACTIONS(658),
    [anon_sym_DASH] = ACTIONS(660),
    [anon_sym_DASH_TILDE] = ACTIONS(658),
    [anon_sym_PLUS] = ACTIONS(660),
    [anon_sym_STAR] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(660),
    [anon_sym_PERCENT] = ACTIONS(660),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(660),
    [anon_sym_LT_LT] = ACTIONS(660),
    [anon_sym_GT_GT] = ACTIONS(660),
    [anon_sym_and] = ACTIONS(658),
    [anon_sym_or] = ACTIONS(658),
    [anon_sym_xor] = ACTIONS(658),
    [anon_sym_isnt] = ACTIONS(658),
    [anon_sym_EQ_EQ] = ACTIONS(660),
    [anon_sym_BANG_EQ] = ACTIONS(660),
    [anon_sym_GT] = ACTIONS(660),
    [anon_sym_GT_EQ] = ACTIONS(660),
    [anon_sym_LT_EQ] = ACTIONS(660),
    [anon_sym_LT] = ACTIONS(660),
    [anon_sym_PLUS_TILDE] = ACTIONS(658),
    [anon_sym_STAR_TILDE] = ACTIONS(658),
    [anon_sym_SLASH_TILDE] = ACTIONS(658),
    [anon_sym_PERCENT_TILDE] = ACTIONS(658),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(658),
    [anon_sym_LT_LT_TILDE] = ACTIONS(658),
    [anon_sym_GT_GT_TILDE] = ACTIONS(658),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(658),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(658),
    [anon_sym_GT_TILDE] = ACTIONS(658),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(658),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(658),
    [anon_sym_LT_TILDE] = ACTIONS(658),
    [anon_sym_PLUS_QMARK] = ACTIONS(658),
    [anon_sym_DASH_QMARK] = ACTIONS(658),
    [anon_sym_STAR_QMARK] = ACTIONS(658),
    [anon_sym_SLASH_QMARK] = ACTIONS(658),
    [anon_sym_PERCENT_QMARK] = ACTIONS(658),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(658),
    [anon_sym_as] = ACTIONS(658),
    [anon_sym_LPAREN2] = ACTIONS(658),
    [anon_sym_DOT_GT] = ACTIONS(658),
    [anon_sym_TILDE] = ACTIONS(658),
    [anon_sym_if] = ACTIONS(660),
    [anon_sym_ifdef] = ACTIONS(658),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [901] = {
    [anon_sym_EQ] = ACTIONS(664),
    [anon_sym_is] = ACTIONS(664),
    [anon_sym_EQ_GT] = ACTIONS(662),
    [anon_sym_iso] = ACTIONS(662),
    [anon_sym_trn] = ACTIONS(662),
    [anon_sym_ref] = ACTIONS(662),
    [anon_sym_val] = ACTIONS(662),
    [anon_sym_box] = ACTIONS(662),
    [anon_sym_tag] = ACTIONS(662),
    [anon_sym_DOT] = ACTIONS(664),
    [anon_sym_POUNDread] = ACTIONS(662),
    [anon_sym_POUNDsend] = ACTIONS(662),
    [anon_sym_POUNDshare] = ACTIONS(662),
    [anon_sym_POUNDalias] = ACTIONS(662),
    [anon_sym_POUNDany] = ACTIONS(662),
    [anon_sym_BANG] = ACTIONS(664),
    [anon_sym_CARET] = ACTIONS(662),
    [anon_sym_PIPE] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(662),
    [anon_sym_DASH_GT] = ACTIONS(662),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_DASH_TILDE] = ACTIONS(662),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_STAR] = ACTIONS(664),
    [anon_sym_SLASH] = ACTIONS(664),
    [anon_sym_PERCENT] = ACTIONS(664),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(664),
    [anon_sym_LT_LT] = ACTIONS(664),
    [anon_sym_GT_GT] = ACTIONS(664),
    [anon_sym_and] = ACTIONS(662),
    [anon_sym_or] = ACTIONS(662),
    [anon_sym_xor] = ACTIONS(662),
    [anon_sym_isnt] = ACTIONS(662),
    [anon_sym_EQ_EQ] = ACTIONS(664),
    [anon_sym_BANG_EQ] = ACTIONS(664),
    [anon_sym_GT] = ACTIONS(664),
    [anon_sym_GT_EQ] = ACTIONS(664),
    [anon_sym_LT_EQ] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(664),
    [anon_sym_PLUS_TILDE] = ACTIONS(662),
    [anon_sym_STAR_TILDE] = ACTIONS(662),
    [anon_sym_SLASH_TILDE] = ACTIONS(662),
    [anon_sym_PERCENT_TILDE] = ACTIONS(662),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(662),
    [anon_sym_LT_LT_TILDE] = ACTIONS(662),
    [anon_sym_GT_GT_TILDE] = ACTIONS(662),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(662),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(662),
    [anon_sym_GT_TILDE] = ACTIONS(662),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(662),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(662),
    [anon_sym_LT_TILDE] = ACTIONS(662),
    [anon_sym_PLUS_QMARK] = ACTIONS(662),
    [anon_sym_DASH_QMARK] = ACTIONS(662),
    [anon_sym_STAR_QMARK] = ACTIONS(662),
    [anon_sym_SLASH_QMARK] = ACTIONS(662),
    [anon_sym_PERCENT_QMARK] = ACTIONS(662),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(662),
    [anon_sym_as] = ACTIONS(662),
    [anon_sym_LPAREN2] = ACTIONS(662),
    [anon_sym_DOT_GT] = ACTIONS(662),
    [anon_sym_TILDE] = ACTIONS(662),
    [anon_sym_if] = ACTIONS(664),
    [anon_sym_ifdef] = ACTIONS(662),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [902] = {
    [anon_sym_EQ] = ACTIONS(734),
    [anon_sym_is] = ACTIONS(734),
    [anon_sym_EQ_GT] = ACTIONS(732),
    [anon_sym_iso] = ACTIONS(732),
    [anon_sym_trn] = ACTIONS(732),
    [anon_sym_ref] = ACTIONS(732),
    [anon_sym_val] = ACTIONS(732),
    [anon_sym_box] = ACTIONS(732),
    [anon_sym_tag] = ACTIONS(732),
    [anon_sym_DOT] = ACTIONS(734),
    [anon_sym_POUNDread] = ACTIONS(732),
    [anon_sym_POUNDsend] = ACTIONS(732),
    [anon_sym_POUNDshare] = ACTIONS(732),
    [anon_sym_POUNDalias] = ACTIONS(732),
    [anon_sym_POUNDany] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(734),
    [anon_sym_CARET] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(732),
    [anon_sym_AMP] = ACTIONS(732),
    [anon_sym_DASH_GT] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(734),
    [anon_sym_DASH_TILDE] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(734),
    [anon_sym_STAR] = ACTIONS(734),
    [anon_sym_SLASH] = ACTIONS(734),
    [anon_sym_PERCENT] = ACTIONS(734),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(734),
    [anon_sym_LT_LT] = ACTIONS(734),
    [anon_sym_GT_GT] = ACTIONS(734),
    [anon_sym_and] = ACTIONS(732),
    [anon_sym_or] = ACTIONS(732),
    [anon_sym_xor] = ACTIONS(732),
    [anon_sym_isnt] = ACTIONS(732),
    [anon_sym_EQ_EQ] = ACTIONS(734),
    [anon_sym_BANG_EQ] = ACTIONS(734),
    [anon_sym_GT] = ACTIONS(734),
    [anon_sym_GT_EQ] = ACTIONS(734),
    [anon_sym_LT_EQ] = ACTIONS(734),
    [anon_sym_LT] = ACTIONS(734),
    [anon_sym_PLUS_TILDE] = ACTIONS(732),
    [anon_sym_STAR_TILDE] = ACTIONS(732),
    [anon_sym_SLASH_TILDE] = ACTIONS(732),
    [anon_sym_PERCENT_TILDE] = ACTIONS(732),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(732),
    [anon_sym_LT_LT_TILDE] = ACTIONS(732),
    [anon_sym_GT_GT_TILDE] = ACTIONS(732),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(732),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(732),
    [anon_sym_GT_TILDE] = ACTIONS(732),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(732),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(732),
    [anon_sym_LT_TILDE] = ACTIONS(732),
    [anon_sym_PLUS_QMARK] = ACTIONS(732),
    [anon_sym_DASH_QMARK] = ACTIONS(732),
    [anon_sym_STAR_QMARK] = ACTIONS(732),
    [anon_sym_SLASH_QMARK] = ACTIONS(732),
    [anon_sym_PERCENT_QMARK] = ACTIONS(732),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(732),
    [anon_sym_as] = ACTIONS(732),
    [anon_sym_LPAREN2] = ACTIONS(732),
    [anon_sym_DOT_GT] = ACTIONS(732),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_if] = ACTIONS(734),
    [anon_sym_ifdef] = ACTIONS(732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [903] = {
    [anon_sym_EQ] = ACTIONS(726),
    [anon_sym_is] = ACTIONS(726),
    [anon_sym_EQ_GT] = ACTIONS(724),
    [anon_sym_iso] = ACTIONS(724),
    [anon_sym_trn] = ACTIONS(724),
    [anon_sym_ref] = ACTIONS(724),
    [anon_sym_val] = ACTIONS(724),
    [anon_sym_box] = ACTIONS(724),
    [anon_sym_tag] = ACTIONS(724),
    [anon_sym_DOT] = ACTIONS(726),
    [anon_sym_POUNDread] = ACTIONS(724),
    [anon_sym_POUNDsend] = ACTIONS(724),
    [anon_sym_POUNDshare] = ACTIONS(724),
    [anon_sym_POUNDalias] = ACTIONS(724),
    [anon_sym_POUNDany] = ACTIONS(724),
    [anon_sym_BANG] = ACTIONS(726),
    [anon_sym_CARET] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(724),
    [anon_sym_DASH_GT] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(726),
    [anon_sym_DASH_TILDE] = ACTIONS(724),
    [anon_sym_PLUS] = ACTIONS(726),
    [anon_sym_STAR] = ACTIONS(726),
    [anon_sym_SLASH] = ACTIONS(726),
    [anon_sym_PERCENT] = ACTIONS(726),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(726),
    [anon_sym_LT_LT] = ACTIONS(726),
    [anon_sym_GT_GT] = ACTIONS(726),
    [anon_sym_and] = ACTIONS(724),
    [anon_sym_or] = ACTIONS(724),
    [anon_sym_xor] = ACTIONS(724),
    [anon_sym_isnt] = ACTIONS(724),
    [anon_sym_EQ_EQ] = ACTIONS(726),
    [anon_sym_BANG_EQ] = ACTIONS(726),
    [anon_sym_GT] = ACTIONS(726),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_LT] = ACTIONS(726),
    [anon_sym_PLUS_TILDE] = ACTIONS(724),
    [anon_sym_STAR_TILDE] = ACTIONS(724),
    [anon_sym_SLASH_TILDE] = ACTIONS(724),
    [anon_sym_PERCENT_TILDE] = ACTIONS(724),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(724),
    [anon_sym_LT_LT_TILDE] = ACTIONS(724),
    [anon_sym_GT_GT_TILDE] = ACTIONS(724),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(724),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(724),
    [anon_sym_GT_TILDE] = ACTIONS(724),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(724),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(724),
    [anon_sym_LT_TILDE] = ACTIONS(724),
    [anon_sym_PLUS_QMARK] = ACTIONS(724),
    [anon_sym_DASH_QMARK] = ACTIONS(724),
    [anon_sym_STAR_QMARK] = ACTIONS(724),
    [anon_sym_SLASH_QMARK] = ACTIONS(724),
    [anon_sym_PERCENT_QMARK] = ACTIONS(724),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(724),
    [anon_sym_as] = ACTIONS(724),
    [anon_sym_LPAREN2] = ACTIONS(724),
    [anon_sym_DOT_GT] = ACTIONS(724),
    [anon_sym_TILDE] = ACTIONS(724),
    [anon_sym_if] = ACTIONS(726),
    [anon_sym_ifdef] = ACTIONS(724),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [904] = {
    [sym_arguments] = STATE(223),
    [ts_builtin_sym_end] = ACTIONS(1328),
    [anon_sym_use] = ACTIONS(1328),
    [anon_sym_EQ] = ACTIONS(1326),
    [anon_sym_type] = ACTIONS(1328),
    [anon_sym_is] = ACTIONS(1326),
    [anon_sym_actor] = ACTIONS(1328),
    [anon_sym_class] = ACTIONS(1328),
    [anon_sym_primitive] = ACTIONS(1328),
    [anon_sym_interface] = ACTIONS(1328),
    [anon_sym_trait] = ACTIONS(1328),
    [anon_sym_struct] = ACTIONS(1328),
    [anon_sym_embed] = ACTIONS(1328),
    [anon_sym_let] = ACTIONS(1328),
    [anon_sym_var] = ACTIONS(1328),
    [anon_sym_new] = ACTIONS(1328),
    [anon_sym_fun] = ACTIONS(1328),
    [anon_sym_be] = ACTIONS(1328),
    [anon_sym_DOT] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_DASH_TILDE] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1326),
    [anon_sym_STAR] = ACTIONS(1326),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym_PERCENT] = ACTIONS(1326),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1326),
    [anon_sym_LT_LT] = ACTIONS(1326),
    [anon_sym_GT_GT] = ACTIONS(1326),
    [anon_sym_and] = ACTIONS(1328),
    [anon_sym_or] = ACTIONS(1328),
    [anon_sym_xor] = ACTIONS(1328),
    [anon_sym_isnt] = ACTIONS(1328),
    [anon_sym_EQ_EQ] = ACTIONS(1326),
    [anon_sym_BANG_EQ] = ACTIONS(1326),
    [anon_sym_GT] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_LT] = ACTIONS(1326),
    [anon_sym_PLUS_TILDE] = ACTIONS(1328),
    [anon_sym_STAR_TILDE] = ACTIONS(1328),
    [anon_sym_SLASH_TILDE] = ACTIONS(1328),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1328),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1328),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1328),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1328),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1328),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1328),
    [anon_sym_GT_TILDE] = ACTIONS(1328),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1328),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1328),
    [anon_sym_LT_TILDE] = ACTIONS(1328),
    [anon_sym_PLUS_QMARK] = ACTIONS(1328),
    [anon_sym_DASH_QMARK] = ACTIONS(1328),
    [anon_sym_STAR_QMARK] = ACTIONS(1328),
    [anon_sym_SLASH_QMARK] = ACTIONS(1328),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1328),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1328),
    [anon_sym_as] = ACTIONS(1328),
    [anon_sym_LPAREN2] = ACTIONS(199),
    [anon_sym_DOT_GT] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_DQUOTE] = ACTIONS(1326),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1328),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [905] = {
    [sym_arguments] = STATE(223),
    [ts_builtin_sym_end] = ACTIONS(1324),
    [anon_sym_use] = ACTIONS(1324),
    [anon_sym_EQ] = ACTIONS(1322),
    [anon_sym_type] = ACTIONS(1324),
    [anon_sym_is] = ACTIONS(1322),
    [anon_sym_actor] = ACTIONS(1324),
    [anon_sym_class] = ACTIONS(1324),
    [anon_sym_primitive] = ACTIONS(1324),
    [anon_sym_interface] = ACTIONS(1324),
    [anon_sym_trait] = ACTIONS(1324),
    [anon_sym_struct] = ACTIONS(1324),
    [anon_sym_embed] = ACTIONS(1324),
    [anon_sym_let] = ACTIONS(1324),
    [anon_sym_var] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1324),
    [anon_sym_fun] = ACTIONS(1324),
    [anon_sym_be] = ACTIONS(1324),
    [anon_sym_DOT] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1322),
    [anon_sym_DASH_TILDE] = ACTIONS(1324),
    [anon_sym_PLUS] = ACTIONS(1322),
    [anon_sym_STAR] = ACTIONS(1322),
    [anon_sym_SLASH] = ACTIONS(1322),
    [anon_sym_PERCENT] = ACTIONS(1322),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1322),
    [anon_sym_LT_LT] = ACTIONS(1322),
    [anon_sym_GT_GT] = ACTIONS(1322),
    [anon_sym_and] = ACTIONS(1324),
    [anon_sym_or] = ACTIONS(1324),
    [anon_sym_xor] = ACTIONS(1324),
    [anon_sym_isnt] = ACTIONS(1324),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_GT] = ACTIONS(1322),
    [anon_sym_GT_EQ] = ACTIONS(1322),
    [anon_sym_LT_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1322),
    [anon_sym_PLUS_TILDE] = ACTIONS(1324),
    [anon_sym_STAR_TILDE] = ACTIONS(1324),
    [anon_sym_SLASH_TILDE] = ACTIONS(1324),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1324),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1324),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1324),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1324),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1324),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1324),
    [anon_sym_GT_TILDE] = ACTIONS(1324),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1324),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1324),
    [anon_sym_LT_TILDE] = ACTIONS(1324),
    [anon_sym_PLUS_QMARK] = ACTIONS(1324),
    [anon_sym_DASH_QMARK] = ACTIONS(1324),
    [anon_sym_STAR_QMARK] = ACTIONS(1324),
    [anon_sym_SLASH_QMARK] = ACTIONS(1324),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1324),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1324),
    [anon_sym_as] = ACTIONS(197),
    [anon_sym_LPAREN2] = ACTIONS(199),
    [anon_sym_DOT_GT] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_DQUOTE] = ACTIONS(1322),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1324),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [906] = {
    [sym_arguments] = STATE(223),
    [ts_builtin_sym_end] = ACTIONS(1320),
    [anon_sym_use] = ACTIONS(1320),
    [anon_sym_EQ] = ACTIONS(1318),
    [anon_sym_type] = ACTIONS(1320),
    [anon_sym_is] = ACTIONS(1318),
    [anon_sym_actor] = ACTIONS(1320),
    [anon_sym_class] = ACTIONS(1320),
    [anon_sym_primitive] = ACTIONS(1320),
    [anon_sym_interface] = ACTIONS(1320),
    [anon_sym_trait] = ACTIONS(1320),
    [anon_sym_struct] = ACTIONS(1320),
    [anon_sym_embed] = ACTIONS(1320),
    [anon_sym_let] = ACTIONS(1320),
    [anon_sym_var] = ACTIONS(1320),
    [anon_sym_new] = ACTIONS(1320),
    [anon_sym_fun] = ACTIONS(1320),
    [anon_sym_be] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1318),
    [anon_sym_DASH_TILDE] = ACTIONS(1320),
    [anon_sym_PLUS] = ACTIONS(1318),
    [anon_sym_STAR] = ACTIONS(1318),
    [anon_sym_SLASH] = ACTIONS(1318),
    [anon_sym_PERCENT] = ACTIONS(1318),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1318),
    [anon_sym_LT_LT] = ACTIONS(1318),
    [anon_sym_GT_GT] = ACTIONS(1318),
    [anon_sym_and] = ACTIONS(1320),
    [anon_sym_or] = ACTIONS(1320),
    [anon_sym_xor] = ACTIONS(1320),
    [anon_sym_isnt] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1318),
    [anon_sym_BANG_EQ] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(1318),
    [anon_sym_GT_EQ] = ACTIONS(1318),
    [anon_sym_LT_EQ] = ACTIONS(1318),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_PLUS_TILDE] = ACTIONS(1320),
    [anon_sym_STAR_TILDE] = ACTIONS(1320),
    [anon_sym_SLASH_TILDE] = ACTIONS(1320),
    [anon_sym_PERCENT_TILDE] = ACTIONS(1320),
    [anon_sym_PERCENT_PERCENT_TILDE] = ACTIONS(1320),
    [anon_sym_LT_LT_TILDE] = ACTIONS(1320),
    [anon_sym_GT_GT_TILDE] = ACTIONS(1320),
    [anon_sym_EQ_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_BANG_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_GT_TILDE] = ACTIONS(1320),
    [anon_sym_GT_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_LT_EQ_TILDE] = ACTIONS(1320),
    [anon_sym_LT_TILDE] = ACTIONS(1320),
    [anon_sym_PLUS_QMARK] = ACTIONS(1320),
    [anon_sym_DASH_QMARK] = ACTIONS(1320),
    [anon_sym_STAR_QMARK] = ACTIONS(1320),
    [anon_sym_SLASH_QMARK] = ACTIONS(1320),
    [anon_sym_PERCENT_QMARK] = ACTIONS(1320),
    [anon_sym_PERCENT_PERCENT_QMARK] = ACTIONS(1320),
    [anon_sym_as] = ACTIONS(1320),
    [anon_sym_LPAREN2] = ACTIONS(199),
    [anon_sym_DOT_GT] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_DQUOTE] = ACTIONS(1318),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1320),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 15,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1675), 1,
      anon_sym_EQ,
    ACTIONS(1679), 1,
      anon_sym_DOT,
    ACTIONS(1683), 1,
      anon_sym_DOT_GT,
    ACTIONS(1685), 1,
      anon_sym_TILDE,
    STATE(223), 1,
      sym_arguments,
    STATE(1470), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(1636), 7,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
    ACTIONS(1677), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1681), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [91] = 5,
    STATE(979), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1687), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
    ACTIONS(863), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(861), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [160] = 5,
    STATE(1061), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1687), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
    ACTIONS(833), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(831), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [229] = 5,
    STATE(1059), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1687), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
    ACTIONS(839), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(837), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [298] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(314), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(1296), 17,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1298), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_where,
      anon_sym_TILDE,
      anon_sym_end,
      anon_sym_else,
      anon_sym_do,
  [371] = 5,
    STATE(1057), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1687), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
    ACTIONS(843), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(841), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [440] = 5,
    STATE(1056), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1687), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
    ACTIONS(847), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(845), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [509] = 5,
    STATE(1053), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1687), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
    ACTIONS(851), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(849), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [578] = 5,
    STATE(1052), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1687), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
    ACTIONS(867), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(865), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [647] = 5,
    STATE(1051), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1687), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
    ACTIONS(875), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(873), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [716] = 5,
    STATE(1048), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1687), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
    ACTIONS(855), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(853), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [785] = 9,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1679), 1,
      anon_sym_DOT,
    ACTIONS(1683), 1,
      anon_sym_DOT_GT,
    ACTIONS(1685), 1,
      anon_sym_TILDE,
    STATE(223), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1322), 17,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DQUOTE,
    ACTIONS(1324), 32,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_end,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [861] = 10,
    ACTIONS(1689), 1,
      anon_sym_BANG,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_PIPE,
    ACTIONS(1695), 1,
      anon_sym_AMP,
    ACTIONS(1697), 1,
      anon_sym_DASH_GT,
    STATE(928), 1,
      aux_sym_union_type_repeat1,
    STATE(929), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(859), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(857), 30,
      anon_sym_EQ_GT,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [939] = 8,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1679), 1,
      anon_sym_DOT,
    ACTIONS(1683), 1,
      anon_sym_DOT_GT,
    ACTIONS(1685), 1,
      anon_sym_TILDE,
    STATE(223), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1326), 17,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DQUOTE,
    ACTIONS(1328), 33,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_end,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [1013] = 8,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1679), 1,
      anon_sym_DOT,
    ACTIONS(1683), 1,
      anon_sym_DOT_GT,
    ACTIONS(1685), 1,
      anon_sym_TILDE,
    STATE(223), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1318), 17,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DQUOTE,
    ACTIONS(1320), 33,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_end,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [1087] = 10,
    ACTIONS(1689), 1,
      anon_sym_BANG,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_PIPE,
    ACTIONS(1695), 1,
      anon_sym_AMP,
    ACTIONS(1697), 1,
      anon_sym_DASH_GT,
    STATE(928), 1,
      aux_sym_union_type_repeat1,
    STATE(929), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(871), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(869), 30,
      anon_sym_EQ_GT,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [1165] = 10,
    ACTIONS(1689), 1,
      anon_sym_BANG,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_PIPE,
    ACTIONS(1695), 1,
      anon_sym_AMP,
    ACTIONS(1697), 1,
      anon_sym_DASH_GT,
    STATE(928), 1,
      aux_sym_union_type_repeat1,
    STATE(929), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(883), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(881), 30,
      anon_sym_EQ_GT,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [1243] = 10,
    ACTIONS(1689), 1,
      anon_sym_BANG,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1693), 1,
      anon_sym_PIPE,
    ACTIONS(1695), 1,
      anon_sym_AMP,
    ACTIONS(1697), 1,
      anon_sym_DASH_GT,
    STATE(928), 1,
      aux_sym_union_type_repeat1,
    STATE(929), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(819), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(817), 30,
      anon_sym_EQ_GT,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [1321] = 9,
    ACTIONS(1689), 1,
      anon_sym_BANG,
    ACTIONS(1691), 1,
      anon_sym_CARET,
    ACTIONS(1695), 1,
      anon_sym_AMP,
    ACTIONS(1697), 1,
      anon_sym_DASH_GT,
    STATE(928), 1,
      aux_sym_union_type_repeat1,
    STATE(929), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(879), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(877), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [1397] = 5,
    ACTIONS(1699), 1,
      anon_sym_AMP,
    STATE(926), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(883), 19,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(881), 33,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [1464] = 5,
    ACTIONS(1702), 1,
      anon_sym_PIPE,
    STATE(927), 1,
      aux_sym_union_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(871), 19,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(869), 33,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [1531] = 5,
    ACTIONS(1693), 1,
      anon_sym_PIPE,
    STATE(927), 1,
      aux_sym_union_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(887), 19,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(885), 33,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [1598] = 5,
    ACTIONS(1695), 1,
      anon_sym_AMP,
    STATE(926), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(894), 19,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(892), 33,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [1665] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(1034), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(1296), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1298), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [1736] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(953), 19,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(951), 34,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [1798] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(961), 19,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(959), 34,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [1860] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(921), 19,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(919), 34,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [1922] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(949), 19,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(947), 34,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [1984] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(941), 19,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(939), 34,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [2046] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(925), 19,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(923), 34,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [2108] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(933), 19,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(931), 34,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [2170] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(913), 19,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(911), 34,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [2232] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(965), 19,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(963), 34,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [2294] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(945), 19,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(943), 34,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [2356] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(909), 19,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(907), 34,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [2418] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(937), 19,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(935), 34,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [2480] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(901), 19,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(899), 34,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [2542] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(957), 19,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(955), 34,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [2604] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(680), 19,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(678), 34,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [2666] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(929), 19,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(927), 34,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [2728] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(917), 19,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(915), 34,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [2790] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(905), 19,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(903), 34,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [2852] = 8,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    STATE(223), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1318), 16,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1320), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_where,
      anon_sym_end,
      anon_sym_else,
      anon_sym_do,
  [2923] = 16,
    ACTIONS(205), 1,
      anon_sym_if,
    ACTIONS(207), 1,
      anon_sym_ifdef,
    ACTIONS(1711), 1,
      anon_sym_EQ,
    ACTIONS(1715), 1,
      anon_sym_EQ_GT,
    ACTIONS(1717), 1,
      anon_sym_DOT,
    ACTIONS(1719), 1,
      anon_sym_PIPE,
    ACTIONS(1723), 1,
      anon_sym_as,
    ACTIONS(1725), 1,
      anon_sym_LPAREN2,
    ACTIONS(1727), 1,
      anon_sym_DOT_GT,
    ACTIONS(1729), 1,
      anon_sym_TILDE,
    STATE(963), 1,
      sym_arguments,
    STATE(1789), 1,
      aux_sym_case_statement_repeat1,
    STATE(2315), 1,
      sym_if_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1713), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1721), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [3010] = 9,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    STATE(223), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1322), 16,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1324), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_where,
      anon_sym_end,
      anon_sym_else,
      anon_sym_do,
  [3083] = 8,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    STATE(223), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1326), 16,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1328), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_where,
      anon_sym_end,
      anon_sym_else,
      anon_sym_do,
  [3154] = 16,
    ACTIONS(205), 1,
      anon_sym_if,
    ACTIONS(207), 1,
      anon_sym_ifdef,
    ACTIONS(1711), 1,
      anon_sym_EQ,
    ACTIONS(1717), 1,
      anon_sym_DOT,
    ACTIONS(1719), 1,
      anon_sym_PIPE,
    ACTIONS(1723), 1,
      anon_sym_as,
    ACTIONS(1725), 1,
      anon_sym_LPAREN2,
    ACTIONS(1727), 1,
      anon_sym_DOT_GT,
    ACTIONS(1729), 1,
      anon_sym_TILDE,
    ACTIONS(1731), 1,
      anon_sym_EQ_GT,
    STATE(963), 1,
      sym_arguments,
    STATE(1804), 1,
      aux_sym_case_statement_repeat1,
    STATE(2254), 1,
      sym_if_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1713), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1721), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [3241] = 15,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1405), 1,
      anon_sym_where,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    ACTIONS(1737), 1,
      anon_sym_COMMA,
    ACTIONS(1739), 1,
      anon_sym_RPAREN,
    STATE(223), 1,
      sym_arguments,
    STATE(1807), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(2452), 1,
      sym_named_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [3325] = 15,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1405), 1,
      anon_sym_where,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    ACTIONS(1737), 1,
      anon_sym_COMMA,
    ACTIONS(1743), 1,
      anon_sym_RPAREN,
    STATE(223), 1,
      sym_arguments,
    STATE(1833), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(2261), 1,
      sym_named_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [3409] = 15,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1405), 1,
      anon_sym_where,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    ACTIONS(1737), 1,
      anon_sym_COMMA,
    ACTIONS(1745), 1,
      anon_sym_RPAREN,
    STATE(223), 1,
      sym_arguments,
    STATE(1831), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(2244), 1,
      sym_named_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [3493] = 15,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1405), 1,
      anon_sym_where,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    ACTIONS(1737), 1,
      anon_sym_COMMA,
    ACTIONS(1747), 1,
      anon_sym_RPAREN,
    STATE(223), 1,
      sym_arguments,
    STATE(1851), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(2460), 1,
      sym_named_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [3577] = 5,
    ACTIONS(1749), 1,
      sym__type_args_start,
    STATE(980), 1,
      sym_type_args,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(994), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(992), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [3641] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1022), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1020), 32,
      sym__type_args_start,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [3700] = 12,
    ACTIONS(1711), 1,
      anon_sym_EQ,
    ACTIONS(1717), 1,
      anon_sym_DOT,
    ACTIONS(1723), 1,
      anon_sym_as,
    ACTIONS(1725), 1,
      anon_sym_LPAREN2,
    ACTIONS(1727), 1,
      anon_sym_DOT_GT,
    ACTIONS(1729), 1,
      anon_sym_TILDE,
    ACTIONS(1753), 1,
      anon_sym_if,
    STATE(963), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1751), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_ifdef,
    ACTIONS(1713), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1721), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [3777] = 4,
    ACTIONS(1755), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1012), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1010), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [3838] = 8,
    ACTIONS(1717), 1,
      anon_sym_DOT,
    ACTIONS(1725), 1,
      anon_sym_LPAREN2,
    ACTIONS(1727), 1,
      anon_sym_DOT_GT,
    ACTIONS(1729), 1,
      anon_sym_TILDE,
    STATE(963), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1318), 17,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1320), 28,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_ifdef,
  [3907] = 4,
    ACTIONS(1757), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1062), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1060), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [3968] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1054), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1052), 32,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [4027] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1030), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1028), 32,
      sym__type_args_start,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [4086] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1018), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1016), 32,
      sym__type_args_start,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [4145] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1004), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1002), 32,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [4204] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1026), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1024), 32,
      sym__type_args_start,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [4263] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1046), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1044), 32,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [4322] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1042), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1040), 32,
      sym__type_args_start,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [4381] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1050), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1048), 32,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [4440] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1008), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1006), 32,
      sym__type_args_start,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [4499] = 4,
    STATE(963), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1038), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1036), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [4560] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1034), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1032), 32,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [4619] = 9,
    ACTIONS(1717), 1,
      anon_sym_DOT,
    ACTIONS(1723), 1,
      anon_sym_as,
    ACTIONS(1725), 1,
      anon_sym_LPAREN2,
    ACTIONS(1727), 1,
      anon_sym_DOT_GT,
    ACTIONS(1729), 1,
      anon_sym_TILDE,
    STATE(963), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1322), 17,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1324), 27,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_ifdef,
  [4690] = 4,
    STATE(963), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1000), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(998), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [4751] = 8,
    ACTIONS(1717), 1,
      anon_sym_DOT,
    ACTIONS(1725), 1,
      anon_sym_LPAREN2,
    ACTIONS(1727), 1,
      anon_sym_DOT_GT,
    ACTIONS(1729), 1,
      anon_sym_TILDE,
    STATE(963), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1326), 17,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1328), 28,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_ifdef,
  [4820] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1058), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1056), 32,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [4879] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(855), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(853), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [4937] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1096), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1094), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [4995] = 13,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    ACTIONS(1759), 1,
      anon_sym_COMMA,
    ACTIONS(1761), 1,
      anon_sym_RPAREN,
    STATE(223), 1,
      sym_arguments,
    STATE(2086), 1,
      aux_sym_lambda_captures_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [5073] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1194), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1192), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [5131] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1198), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1196), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [5189] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1202), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1200), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [5247] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1206), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1204), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [5305] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1214), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1212), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [5363] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1218), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1216), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [5421] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1302), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1300), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [5479] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1294), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1292), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [5537] = 13,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    ACTIONS(1763), 1,
      anon_sym_end,
    ACTIONS(1765), 1,
      anon_sym_else,
    STATE(223), 1,
      sym_arguments,
    STATE(2259), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [5615] = 13,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(1767), 1,
      anon_sym_end,
    STATE(223), 1,
      sym_arguments,
    STATE(2334), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [5693] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1286), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1284), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [5751] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1282), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1280), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [5809] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1250), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1248), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [5867] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1242), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1240), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [5925] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1210), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1208), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [5983] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1112), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1110), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [6041] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1116), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1114), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [6099] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1186), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1184), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [6157] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1144), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1142), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [6215] = 11,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    STATE(223), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1769), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_where,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [6289] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1190), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1188), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [6347] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1182), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1180), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [6405] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1140), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1138), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [6463] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1132), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1130), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [6521] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1120), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1118), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [6579] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1108), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1106), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [6637] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1100), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1098), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [6695] = 13,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(1771), 1,
      anon_sym_end,
    STATE(223), 1,
      sym_arguments,
    STATE(2401), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [6773] = 13,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(1773), 1,
      anon_sym_end,
    STATE(223), 1,
      sym_arguments,
    STATE(2426), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [6851] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1092), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1090), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [6909] = 13,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(1775), 1,
      anon_sym_end,
    STATE(223), 1,
      sym_arguments,
    STATE(2255), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [6987] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1136), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1134), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [7045] = 13,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(1777), 1,
      anon_sym_end,
    STATE(223), 1,
      sym_arguments,
    STATE(2449), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [7123] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1128), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1126), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [7181] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1124), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1122), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [7239] = 13,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    ACTIONS(1737), 1,
      anon_sym_COMMA,
    ACTIONS(1779), 1,
      anon_sym_RPAREN,
    STATE(223), 1,
      sym_arguments,
    STATE(1971), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [7317] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1148), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1146), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [7375] = 13,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(1781), 1,
      anon_sym_end,
    STATE(223), 1,
      sym_arguments,
    STATE(2297), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [7453] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1174), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1172), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [7511] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1234), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1232), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [7569] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1238), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1236), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [7627] = 13,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    ACTIONS(1737), 1,
      anon_sym_COMMA,
    ACTIONS(1783), 1,
      anon_sym_RPAREN,
    STATE(223), 1,
      sym_arguments,
    STATE(2108), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [7705] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1246), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1244), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [7763] = 13,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    ACTIONS(1737), 1,
      anon_sym_COMMA,
    ACTIONS(1785), 1,
      anon_sym_RPAREN,
    STATE(223), 1,
      sym_arguments,
    STATE(2014), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [7841] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1088), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1086), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [7899] = 13,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(1787), 1,
      anon_sym_end,
    STATE(223), 1,
      sym_arguments,
    STATE(2504), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [7977] = 13,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(1789), 1,
      anon_sym_end,
    STATE(223), 1,
      sym_arguments,
    STATE(2414), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [8055] = 13,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(1791), 1,
      anon_sym_end,
    STATE(223), 1,
      sym_arguments,
    STATE(2375), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [8133] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1084), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1082), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [8191] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1080), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1078), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [8249] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1076), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1074), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [8307] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1072), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1070), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [8365] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1278), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1276), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [8423] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1274), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1272), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [8481] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1254), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1252), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [8539] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1068), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1066), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [8597] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1258), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1256), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [8655] = 13,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    ACTIONS(1759), 1,
      anon_sym_COMMA,
    ACTIONS(1793), 1,
      anon_sym_RPAREN,
    STATE(223), 1,
      sym_arguments,
    STATE(2097), 1,
      aux_sym_lambda_captures_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [8733] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1262), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1260), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [8791] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1226), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1224), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [8849] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1222), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1220), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [8907] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1306), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1304), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [8965] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(994), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(992), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [9023] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1104), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1102), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [9081] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1270), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1268), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [9139] = 13,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(1795), 1,
      anon_sym_end,
    STATE(223), 1,
      sym_arguments,
    STATE(2325), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [9217] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(875), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(873), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [9275] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1178), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1176), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [9333] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1266), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1264), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [9391] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(867), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(865), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [9449] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(851), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(849), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [9507] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(847), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(845), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [9565] = 13,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(1797), 1,
      anon_sym_end,
    STATE(223), 1,
      sym_arguments,
    STATE(2283), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [9643] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(640), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(638), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [9701] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(843), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(841), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [9759] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(839), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(837), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [9817] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(668), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(666), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [9875] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(833), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(831), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [9933] = 13,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    ACTIONS(1737), 1,
      anon_sym_COMMA,
    ACTIONS(1799), 1,
      anon_sym_RPAREN,
    STATE(223), 1,
      sym_arguments,
    STATE(2043), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [10011] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1230), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1228), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [10069] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1290), 18,
      anon_sym_EQ,
      anon_sym_is,
      anon_sym_DOT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_if,
    ACTIONS(1288), 31,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
      anon_sym_as,
      anon_sym_LPAREN2,
      anon_sym_DOT_GT,
      anon_sym_TILDE,
      anon_sym_ifdef,
  [10127] = 12,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    ACTIONS(1801), 1,
      anon_sym_COMMA,
    ACTIONS(1803), 1,
      anon_sym_RPAREN,
    STATE(223), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [10202] = 12,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    ACTIONS(1805), 1,
      anon_sym_COMMA,
    ACTIONS(1807), 1,
      anon_sym_RPAREN,
    STATE(223), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [10277] = 12,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1433), 1,
      anon_sym_do,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    STATE(223), 1,
      sym_arguments,
    STATE(549), 1,
      sym_do_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [10352] = 12,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1427), 1,
      anon_sym_do,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    STATE(223), 1,
      sym_arguments,
    STATE(242), 1,
      sym_do_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [10427] = 12,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1417), 1,
      anon_sym_do,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    STATE(223), 1,
      sym_arguments,
    STATE(1006), 1,
      sym_do_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [10502] = 12,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1435), 1,
      anon_sym_do,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    STATE(223), 1,
      sym_arguments,
    STATE(413), 1,
      sym_do_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [10577] = 12,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    ACTIONS(1809), 1,
      anon_sym_COMMA,
    ACTIONS(1811), 1,
      anon_sym_RPAREN,
    STATE(223), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [10652] = 7,
    ACTIONS(1813), 1,
      anon_sym_DOT,
    ACTIONS(1815), 1,
      sym__type_args_start,
    STATE(1072), 1,
      aux_sym_base_type_repeat1,
    STATE(1104), 1,
      sym_type_args,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(621), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(619), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [10717] = 12,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    ACTIONS(1817), 1,
      anon_sym_COMMA,
    ACTIONS(1819), 1,
      anon_sym_RPAREN,
    STATE(223), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [10792] = 7,
    ACTIONS(1813), 1,
      anon_sym_DOT,
    ACTIONS(1815), 1,
      sym__type_args_start,
    STATE(1080), 1,
      aux_sym_base_type_repeat1,
    STATE(1110), 1,
      sym_type_args,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(613), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(611), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [10857] = 11,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    STATE(223), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [10930] = 11,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    STATE(223), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1823), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [11003] = 11,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    STATE(223), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1825), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [11076] = 11,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    STATE(223), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1827), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [11149] = 11,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    STATE(223), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1829), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [11222] = 11,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    STATE(223), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1831), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [11295] = 11,
    ACTIONS(197), 1,
      anon_sym_as,
    ACTIONS(199), 1,
      anon_sym_LPAREN2,
    ACTIONS(1705), 1,
      anon_sym_DOT,
    ACTIONS(1707), 1,
      anon_sym_DOT_GT,
    ACTIONS(1709), 1,
      anon_sym_TILDE,
    ACTIONS(1733), 1,
      anon_sym_EQ,
    ACTIONS(1809), 1,
      anon_sym_COMMA,
    STATE(223), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 15,
      anon_sym_is,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(1741), 24,
      anon_sym_DASH_TILDE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_isnt,
      anon_sym_PLUS_TILDE,
      anon_sym_STAR_TILDE,
      anon_sym_SLASH_TILDE,
      anon_sym_PERCENT_TILDE,
      anon_sym_PERCENT_PERCENT_TILDE,
      anon_sym_LT_LT_TILDE,
      anon_sym_GT_GT_TILDE,
      anon_sym_EQ_EQ_TILDE,
      anon_sym_BANG_EQ_TILDE,
      anon_sym_GT_TILDE,
      anon_sym_GT_EQ_TILDE,
      anon_sym_LT_EQ_TILDE,
      anon_sym_LT_TILDE,
      anon_sym_PLUS_QMARK,
      anon_sym_DASH_QMARK,
      anon_sym_STAR_QMARK,
      anon_sym_SLASH_QMARK,
      anon_sym_PERCENT_QMARK,
      anon_sym_PERCENT_PERCENT_QMARK,
  [11367] = 5,
    ACTIONS(1833), 1,
      anon_sym_DOT,
    STATE(1080), 1,
      aux_sym_base_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(625), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(623), 43,
      sym__type_args_start,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [11427] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(625), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(623), 44,
      sym__type_args_start,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [11482] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1290), 5,
      anon_sym_DASH,
      anon_sym_if,
      sym_number,
      anon_sym_DQUOTE,
      sym_identifier,
    ACTIONS(1288), 40,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_is,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      sym_error,
      sym_compile_intrinsic,
      anon_sym_compile_error,
      sym_location,
      anon_sym_not,
      anon_sym_DASH_TILDE,
      anon_sym_addressof,
      anon_sym_digestof,
      anon_sym_end,
      anon_sym_ifdef,
      anon_sym_iftype,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_repeat,
      anon_sym_recover,
      anon_sym_match,
      anon_sym_return,
      anon_sym_continue,
      anon_sym_break,
      anon_sym_consume,
      anon_sym_object,
      sym_float,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_true,
      anon_sym_false,
      sym_this,
  [11536] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1836), 5,
      anon_sym_DASH,
      anon_sym_if,
      sym_number,
      anon_sym_DQUOTE,
      sym_identifier,
    ACTIONS(1838), 40,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_let,
      anon_sym_var,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      sym_error,
      sym_compile_intrinsic,
      anon_sym_compile_error,
      sym_location,
      anon_sym_not,
      anon_sym_DASH_TILDE,
      anon_sym_addressof,
      anon_sym_digestof,
      anon_sym_ifdef,
      anon_sym_iftype,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_repeat,
      anon_sym_recover,
      anon_sym_match,
      anon_sym_return,
      anon_sym_continue,
      anon_sym_break,
      anon_sym_consume,
      anon_sym_object,
      sym_float,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_true,
      anon_sym_false,
      sym_this,
  [11590] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1840), 5,
      anon_sym_DASH,
      anon_sym_if,
      sym_number,
      anon_sym_DQUOTE,
      sym_identifier,
    ACTIONS(1842), 40,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_let,
      anon_sym_var,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      sym_error,
      sym_compile_intrinsic,
      anon_sym_compile_error,
      sym_location,
      anon_sym_not,
      anon_sym_DASH_TILDE,
      anon_sym_addressof,
      anon_sym_digestof,
      anon_sym_ifdef,
      anon_sym_iftype,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_repeat,
      anon_sym_recover,
      anon_sym_match,
      anon_sym_return,
      anon_sym_continue,
      anon_sym_break,
      anon_sym_consume,
      anon_sym_object,
      sym_float,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_true,
      anon_sym_false,
      sym_this,
  [11644] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(778), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(776), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [11697] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(706), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(704), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [11750] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(750), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(748), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [11803] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(730), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(728), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [11856] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(668), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(666), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [11909] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(770), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(768), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [11962] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(774), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(772), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [12015] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(718), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(716), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [12068] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(782), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(780), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [12121] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(676), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(674), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [12174] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(786), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(784), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [12227] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(754), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(752), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [12280] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(714), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(712), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [12333] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(758), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(756), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [12386] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(762), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(760), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [12439] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(660), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(658), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [12492] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(664), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(662), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [12545] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(652), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(650), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [12598] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(734), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(732), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [12651] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(726), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(724), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [12704] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(636), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(634), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [12757] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(640), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(638), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [12810] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(648), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(646), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [12863] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(722), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(720), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [12916] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(746), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(744), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [12969] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(644), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(642), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [13022] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(656), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(654), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [13075] = 14,
    ACTIONS(1844), 1,
      anon_sym_iso,
    ACTIONS(1846), 1,
      anon_sym_trn,
    ACTIONS(1848), 1,
      anon_sym_ref,
    ACTIONS(1850), 1,
      anon_sym_val,
    ACTIONS(1852), 1,
      anon_sym_box,
    ACTIONS(1854), 1,
      anon_sym_tag,
    ACTIONS(1856), 1,
      anon_sym_POUNDread,
    ACTIONS(1858), 1,
      anon_sym_POUNDsend,
    ACTIONS(1860), 1,
      anon_sym_POUNDshare,
    ACTIONS(1862), 1,
      anon_sym_POUNDalias,
    ACTIONS(1864), 1,
      anon_sym_POUNDany,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(680), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(678), 31,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [13150] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(742), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(740), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [13203] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(738), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(736), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [13256] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(766), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(764), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [13309] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(632), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(630), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [13362] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(710), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(708), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [13415] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(672), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(670), 42,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
      anon_sym_RPAREN,
      anon_sym_POUNDread,
      anon_sym_POUNDsend,
      anon_sym_POUNDshare,
      anon_sym_POUNDalias,
      anon_sym_POUNDany,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [13468] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(819), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(817), 26,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [13526] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(883), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(881), 26,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [13584] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(871), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(869), 26,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [13642] = 20,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1408), 1,
      sym_string,
    STATE(1587), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1876), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [13719] = 20,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1381), 1,
      sym_string,
    STATE(1674), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1886), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [13796] = 5,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    STATE(1126), 1,
      aux_sym_union_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(887), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(885), 30,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [13843] = 20,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1390), 1,
      sym_string,
    STATE(1672), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1888), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [13920] = 5,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    STATE(1126), 1,
      aux_sym_union_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(871), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(869), 30,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [13967] = 5,
    ACTIONS(1893), 1,
      anon_sym_AMP,
    STATE(1127), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(883), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(881), 30,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [14014] = 20,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1412), 1,
      sym_string,
    STATE(1689), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1896), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [14091] = 20,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1406), 1,
      sym_string,
    STATE(1633), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1898), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [14168] = 20,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1407), 1,
      sym_string,
    STATE(1589), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1900), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [14245] = 5,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    STATE(1127), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(894), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(892), 30,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [14292] = 20,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1398), 1,
      sym_string,
    STATE(1684), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1902), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [14369] = 20,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1388), 1,
      sym_string,
    STATE(1682), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1904), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [14446] = 20,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1386), 1,
      sym_string,
    STATE(1673), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1906), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [14523] = 20,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1405), 1,
      sym_string,
    STATE(1685), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1908), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [14600] = 20,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1384), 1,
      sym_string,
    STATE(1681), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1910), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [14677] = 20,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1376), 1,
      sym_string,
    STATE(1646), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1912), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [14754] = 20,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1413), 1,
      sym_string,
    STATE(1677), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1914), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [14831] = 20,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1402), 1,
      sym_string,
    STATE(1687), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1916), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [14908] = 20,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1380), 1,
      sym_string,
    STATE(1675), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1918), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [14985] = 20,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1383), 1,
      sym_string,
    STATE(1597), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1920), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [15062] = 20,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1377), 1,
      sym_string,
    STATE(1593), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1922), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [15139] = 20,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1399), 1,
      sym_string,
    STATE(1698), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1924), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [15216] = 20,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1397), 1,
      sym_string,
    STATE(1700), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1926), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [15293] = 20,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1400), 1,
      sym_string,
    STATE(1667), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1928), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [15370] = 20,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1389), 1,
      sym_string,
    STATE(1676), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1930), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [15447] = 20,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1379), 1,
      sym_string,
    STATE(1629), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1932), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [15524] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(909), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(907), 31,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [15566] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(961), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(959), 31,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [15608] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(945), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(943), 31,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [15650] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(953), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(951), 31,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [15692] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(965), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(963), 31,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [15734] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(941), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(939), 31,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [15776] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(933), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(931), 31,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [15818] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(957), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(955), 31,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [15860] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(901), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(899), 31,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [15902] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(680), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(678), 31,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [15944] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(925), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(923), 31,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [15986] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(937), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(935), 31,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [16028] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(913), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(911), 31,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [16070] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(949), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(947), 31,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [16112] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(921), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(919), 31,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [16154] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(905), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(903), 31,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [16196] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(929), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(927), 31,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [16238] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(917), 2,
      anon_sym_EQ,
      anon_sym_DQUOTE,
    ACTIONS(915), 31,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_end,
      anon_sym_then,
      anon_sym_LT_COLON,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [16280] = 16,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(1936), 1,
      anon_sym_is,
    STATE(1185), 1,
      sym_generic_parameters,
    STATE(1386), 1,
      sym_string,
    STATE(1673), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1906), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [16345] = 16,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(1938), 1,
      anon_sym_is,
    STATE(1184), 1,
      sym_generic_parameters,
    STATE(1400), 1,
      sym_string,
    STATE(1667), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1928), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [16410] = 16,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(1940), 1,
      anon_sym_is,
    STATE(1190), 1,
      sym_generic_parameters,
    STATE(1389), 1,
      sym_string,
    STATE(1676), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1930), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [16475] = 16,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(1944), 1,
      anon_sym_is,
    STATE(1191), 1,
      sym_generic_parameters,
    STATE(1409), 1,
      sym_string,
    STATE(1595), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1942), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [16540] = 16,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(1948), 1,
      anon_sym_is,
    STATE(1183), 1,
      sym_generic_parameters,
    STATE(1396), 1,
      sym_string,
    STATE(1691), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1946), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [16605] = 16,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(1952), 1,
      anon_sym_is,
    STATE(1195), 1,
      sym_generic_parameters,
    STATE(1410), 1,
      sym_string,
    STATE(1639), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1950), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [16670] = 16,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_is,
    STATE(1196), 1,
      sym_generic_parameters,
    STATE(1391), 1,
      sym_string,
    STATE(1659), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1954), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [16735] = 16,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(1960), 1,
      anon_sym_is,
    STATE(1182), 1,
      sym_generic_parameters,
    STATE(1404), 1,
      sym_string,
    STATE(1683), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1958), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [16800] = 16,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(1962), 1,
      anon_sym_is,
    STATE(1188), 1,
      sym_generic_parameters,
    STATE(1381), 1,
      sym_string,
    STATE(1674), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1886), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [16865] = 16,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(1966), 1,
      anon_sym_is,
    STATE(1189), 1,
      sym_generic_parameters,
    STATE(1378), 1,
      sym_string,
    STATE(1699), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1964), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [16930] = 16,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(1970), 1,
      anon_sym_is,
    STATE(1198), 1,
      sym_generic_parameters,
    STATE(1394), 1,
      sym_string,
    STATE(1588), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1968), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [16995] = 16,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(1974), 1,
      anon_sym_is,
    STATE(1186), 1,
      sym_generic_parameters,
    STATE(1392), 1,
      sym_string,
    STATE(1650), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1972), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [17060] = 16,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(1978), 1,
      anon_sym_is,
    STATE(1187), 1,
      sym_generic_parameters,
    STATE(1387), 1,
      sym_string,
    STATE(1664), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1976), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [17125] = 16,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(1982), 1,
      anon_sym_is,
    STATE(1193), 1,
      sym_generic_parameters,
    STATE(1411), 1,
      sym_string,
    STATE(1623), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1980), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [17190] = 16,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(1986), 1,
      anon_sym_is,
    STATE(1192), 1,
      sym_generic_parameters,
    STATE(1393), 1,
      sym_string,
    STATE(1678), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1984), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [17255] = 16,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(1990), 1,
      anon_sym_is,
    STATE(1194), 1,
      sym_generic_parameters,
    STATE(1401), 1,
      sym_string,
    STATE(1688), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1988), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [17320] = 14,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1962), 1,
      anon_sym_is,
    STATE(1381), 1,
      sym_string,
    STATE(1674), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1886), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [17379] = 14,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1956), 1,
      anon_sym_is,
    STATE(1391), 1,
      sym_string,
    STATE(1659), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1954), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [17438] = 14,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1992), 1,
      anon_sym_is,
    STATE(1379), 1,
      sym_string,
    STATE(1629), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1932), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [17497] = 14,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1994), 1,
      anon_sym_is,
    STATE(1399), 1,
      sym_string,
    STATE(1698), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1924), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [17556] = 14,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1996), 1,
      anon_sym_is,
    STATE(1390), 1,
      sym_string,
    STATE(1672), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1888), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [17615] = 14,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1944), 1,
      anon_sym_is,
    STATE(1409), 1,
      sym_string,
    STATE(1595), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1942), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [17674] = 14,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1998), 1,
      anon_sym_is,
    STATE(1402), 1,
      sym_string,
    STATE(1687), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1916), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [17733] = 14,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1940), 1,
      anon_sym_is,
    STATE(1389), 1,
      sym_string,
    STATE(1676), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1930), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [17792] = 14,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(2000), 1,
      anon_sym_is,
    STATE(1405), 1,
      sym_string,
    STATE(1685), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1908), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [17851] = 14,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(2002), 1,
      anon_sym_is,
    STATE(1406), 1,
      sym_string,
    STATE(1633), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1898), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [17910] = 14,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1970), 1,
      anon_sym_is,
    STATE(1394), 1,
      sym_string,
    STATE(1588), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1968), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [17969] = 14,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1966), 1,
      anon_sym_is,
    STATE(1378), 1,
      sym_string,
    STATE(1699), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1964), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [18028] = 14,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1974), 1,
      anon_sym_is,
    STATE(1392), 1,
      sym_string,
    STATE(1650), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1972), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [18087] = 14,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1960), 1,
      anon_sym_is,
    STATE(1404), 1,
      sym_string,
    STATE(1683), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1958), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [18146] = 14,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1936), 1,
      anon_sym_is,
    STATE(1386), 1,
      sym_string,
    STATE(1673), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1906), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [18205] = 14,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2006), 1,
      anon_sym_EQ,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1471), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2004), 15,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [18264] = 14,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(1938), 1,
      anon_sym_is,
    STATE(1400), 1,
      sym_string,
    STATE(1667), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1928), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [18323] = 11,
    ACTIONS(1364), 1,
      anon_sym_BSLASH,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1367), 1,
      sym_annotation,
    STATE(1712), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [18375] = 15,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2020), 1,
      anon_sym_QMARK,
    ACTIONS(2022), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1492), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2018), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [18434] = 15,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2026), 1,
      anon_sym_QMARK,
    ACTIONS(2028), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1483), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2024), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [18493] = 10,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    ACTIONS(2030), 1,
      anon_sym_RPAREN,
    STATE(1582), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [18542] = 15,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2034), 1,
      anon_sym_QMARK,
    ACTIONS(2036), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1487), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2032), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [18601] = 15,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2040), 1,
      anon_sym_QMARK,
    ACTIONS(2042), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1486), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2038), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [18660] = 15,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2046), 1,
      anon_sym_QMARK,
    ACTIONS(2048), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1495), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2044), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [18719] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1200), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [18765] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1658), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [18811] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1139), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [18857] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1638), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [18903] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1135), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [18949] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1142), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [18995] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1421), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [19041] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1718), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [19087] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1635), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [19133] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1720), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [19179] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1657), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [19225] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1531), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [19271] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1143), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [19317] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1734), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [19363] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1144), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [19409] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1665), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [19455] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1647), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [19501] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1641), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [19547] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1636), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [19593] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1634), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [19639] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1600), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [19685] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1590), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [19731] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1591), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [19777] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1422), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [19823] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1130), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [19869] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1653), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [19915] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1547), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [19961] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1122), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [20007] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1553), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [20053] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1419), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [20099] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1696), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [20145] = 9,
    ACTIONS(2050), 1,
      sym_identifier,
    ACTIONS(2052), 1,
      anon_sym_AT,
    ACTIONS(2054), 1,
      anon_sym_LPAREN,
    ACTIONS(2056), 1,
      anon_sym_LBRACE,
    ACTIONS(2058), 1,
      sym_this,
    STATE(178), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(97), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(219), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [20191] = 9,
    ACTIONS(2050), 1,
      sym_identifier,
    ACTIONS(2052), 1,
      anon_sym_AT,
    ACTIONS(2054), 1,
      anon_sym_LPAREN,
    ACTIONS(2056), 1,
      anon_sym_LBRACE,
    ACTIONS(2058), 1,
      sym_this,
    STATE(180), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(97), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(219), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [20237] = 9,
    ACTIONS(2050), 1,
      sym_identifier,
    ACTIONS(2052), 1,
      anon_sym_AT,
    ACTIONS(2054), 1,
      anon_sym_LPAREN,
    ACTIONS(2056), 1,
      anon_sym_LBRACE,
    ACTIONS(2058), 1,
      sym_this,
    STATE(176), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(97), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(219), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [20283] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1573), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [20329] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1741), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [20375] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1203), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [20421] = 9,
    ACTIONS(2060), 1,
      sym_identifier,
    ACTIONS(2062), 1,
      anon_sym_AT,
    ACTIONS(2064), 1,
      anon_sym_LPAREN,
    ACTIONS(2066), 1,
      anon_sym_LBRACE,
    ACTIONS(2068), 1,
      sym_this,
    STATE(919), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(882), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(945), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [20467] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1137), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [20513] = 9,
    ACTIONS(2070), 1,
      sym_identifier,
    ACTIONS(2072), 1,
      anon_sym_AT,
    ACTIONS(2074), 1,
      anon_sym_LPAREN,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    ACTIONS(2078), 1,
      sym_this,
    STATE(143), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(71), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(150), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [20559] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1561), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [20605] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1147), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [20651] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1737), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [20697] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1586), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [20743] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1670), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [20789] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1627), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [20835] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1628), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [20881] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1565), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [20927] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1563), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [20973] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1630), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [21019] = 9,
    ACTIONS(2060), 1,
      sym_identifier,
    ACTIONS(2062), 1,
      anon_sym_AT,
    ACTIONS(2064), 1,
      anon_sym_LPAREN,
    ACTIONS(2066), 1,
      anon_sym_LBRACE,
    ACTIONS(2068), 1,
      sym_this,
    STATE(925), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(882), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(945), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [21065] = 9,
    ACTIONS(2060), 1,
      sym_identifier,
    ACTIONS(2062), 1,
      anon_sym_AT,
    ACTIONS(2064), 1,
      anon_sym_LPAREN,
    ACTIONS(2066), 1,
      anon_sym_LBRACE,
    ACTIONS(2068), 1,
      sym_this,
    STATE(924), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(882), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(945), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [21111] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1632), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [21157] = 9,
    ACTIONS(2060), 1,
      sym_identifier,
    ACTIONS(2062), 1,
      anon_sym_AT,
    ACTIONS(2064), 1,
      anon_sym_LPAREN,
    ACTIONS(2066), 1,
      anon_sym_LBRACE,
    ACTIONS(2068), 1,
      sym_this,
    STATE(923), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(882), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(945), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [21203] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1637), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [21249] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1640), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [21295] = 9,
    ACTIONS(2060), 1,
      sym_identifier,
    ACTIONS(2062), 1,
      anon_sym_AT,
    ACTIONS(2064), 1,
      anon_sym_LPAREN,
    ACTIONS(2066), 1,
      anon_sym_LBRACE,
    ACTIONS(2068), 1,
      sym_this,
    STATE(922), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(882), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(945), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [21341] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1704), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [21387] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1703), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [21433] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1574), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [21479] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1702), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [21525] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1697), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [21571] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1694), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [21617] = 9,
    ACTIONS(2070), 1,
      sym_identifier,
    ACTIONS(2072), 1,
      anon_sym_AT,
    ACTIONS(2074), 1,
      anon_sym_LPAREN,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    ACTIONS(2078), 1,
      sym_this,
    STATE(141), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(71), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(150), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [21663] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1660), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [21709] = 9,
    ACTIONS(2070), 1,
      sym_identifier,
    ACTIONS(2072), 1,
      anon_sym_AT,
    ACTIONS(2074), 1,
      anon_sym_LPAREN,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    ACTIONS(2078), 1,
      sym_this,
    STATE(144), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(71), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(150), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [21755] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1568), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [21801] = 9,
    ACTIONS(2070), 1,
      sym_identifier,
    ACTIONS(2072), 1,
      anon_sym_AT,
    ACTIONS(2074), 1,
      anon_sym_LPAREN,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    ACTIONS(2078), 1,
      sym_this,
    STATE(131), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(71), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(150), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [21847] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1567), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [21893] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1141), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [21939] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1701), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [21985] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1201), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [22031] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1121), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [22077] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1671), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [22123] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1666), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [22169] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1602), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [22215] = 9,
    ACTIONS(2080), 1,
      sym_identifier,
    ACTIONS(2082), 1,
      anon_sym_AT,
    ACTIONS(2084), 1,
      anon_sym_LPAREN,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2088), 1,
      sym_this,
    STATE(442), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(256), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(459), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [22261] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1146), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [22307] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1655), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [22353] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1651), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [22399] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1645), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [22445] = 9,
    ACTIONS(2050), 1,
      sym_identifier,
    ACTIONS(2052), 1,
      anon_sym_AT,
    ACTIONS(2054), 1,
      anon_sym_LPAREN,
    ACTIONS(2056), 1,
      anon_sym_LBRACE,
    ACTIONS(2058), 1,
      sym_this,
    STATE(440), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(97), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(219), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [22491] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1120), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [22537] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1416), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [22583] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1558), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [22629] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1119), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [22675] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1619), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [22721] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1604), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [22767] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1668), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [22813] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1661), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [22859] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1724), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [22905] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1557), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [22951] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1617), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [22997] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1620), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [23043] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1631), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [23089] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1614), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [23135] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1663), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [23181] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1605), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [23227] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1606), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [23273] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1424), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [23319] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1680), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [23365] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1599), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [23411] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1608), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [23457] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1452), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [23503] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1649), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [23549] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1123), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [23595] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1693), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [23641] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1611), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [23687] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1612), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [23733] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1624), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [23779] = 9,
    ACTIONS(2080), 1,
      sym_identifier,
    ACTIONS(2082), 1,
      anon_sym_AT,
    ACTIONS(2084), 1,
      anon_sym_LPAREN,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2088), 1,
      sym_this,
    STATE(434), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(256), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(459), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [23825] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1695), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [23871] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1449), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [23917] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1705), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [23963] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1723), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [24009] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1417), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [24055] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1613), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [24101] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1662), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [24147] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1444), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [24193] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1644), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [24239] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1654), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [24285] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1618), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [24331] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1414), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [24377] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1616), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [24423] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1572), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [24469] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1575), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [24515] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1652), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [24561] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1580), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [24607] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1453), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [24653] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1642), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [24699] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1648), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [24745] = 9,
    ACTIONS(2080), 1,
      sym_identifier,
    ACTIONS(2082), 1,
      anon_sym_AT,
    ACTIONS(2084), 1,
      anon_sym_LPAREN,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2088), 1,
      sym_this,
    STATE(435), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(256), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(459), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [24791] = 9,
    ACTIONS(2080), 1,
      sym_identifier,
    ACTIONS(2082), 1,
      anon_sym_AT,
    ACTIONS(2084), 1,
      anon_sym_LPAREN,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2088), 1,
      sym_this,
    STATE(437), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(256), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(459), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [24837] = 9,
    ACTIONS(2080), 1,
      sym_identifier,
    ACTIONS(2082), 1,
      anon_sym_AT,
    ACTIONS(2084), 1,
      anon_sym_LPAREN,
    ACTIONS(2086), 1,
      anon_sym_LBRACE,
    ACTIONS(2088), 1,
      sym_this,
    STATE(438), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(256), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(459), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [24883] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1577), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [24929] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1454), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [24975] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1581), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [25021] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1626), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [25067] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1134), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [25113] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1596), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [25159] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1204), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [25205] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1420), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [25251] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1609), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [25297] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1716), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [25343] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1430), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [25389] = 9,
    ACTIONS(2050), 1,
      sym_identifier,
    ACTIONS(2052), 1,
      anon_sym_AT,
    ACTIONS(2054), 1,
      anon_sym_LPAREN,
    ACTIONS(2056), 1,
      anon_sym_LBRACE,
    ACTIONS(2058), 1,
      sym_this,
    STATE(179), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(97), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(219), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [25435] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1197), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [25481] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1621), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [25527] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1656), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [25573] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1205), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [25619] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1125), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [25665] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1601), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [25711] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1747), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [25757] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1579), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [25803] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1415), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [25849] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1129), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [25895] = 9,
    ACTIONS(2070), 1,
      sym_identifier,
    ACTIONS(2072), 1,
      anon_sym_AT,
    ACTIONS(2074), 1,
      anon_sym_LPAREN,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    ACTIONS(2078), 1,
      sym_this,
    STATE(138), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(71), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(150), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [25941] = 9,
    ACTIONS(2050), 1,
      sym_identifier,
    ACTIONS(2052), 1,
      anon_sym_AT,
    ACTIONS(2054), 1,
      anon_sym_LPAREN,
    ACTIONS(2056), 1,
      anon_sym_LBRACE,
    ACTIONS(2058), 1,
      sym_this,
    STATE(177), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(97), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(219), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [25987] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1540), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [26033] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1418), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [26079] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1128), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [26125] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1739), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [26171] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1132), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [26217] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1140), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [26263] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1571), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [26309] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1625), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [26355] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1133), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [26401] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1145), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [26447] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1136), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [26493] = 9,
    ACTIONS(2008), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_LPAREN,
    ACTIONS(2014), 1,
      anon_sym_LBRACE,
    ACTIONS(2016), 1,
      sym_this,
    STATE(1138), 1,
      sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1112), 2,
      sym_base_type,
      sym_lambda_type,
    STATE(1157), 17,
      sym_read_type,
      sym_send_type,
      sym_share_type,
      sym_alias_type,
      sym_any_type,
      sym_iso_type,
      sym_trn_type,
      sym_ref_type,
      sym_val_type,
      sym_box_type,
      sym_tag_type,
      sym_aliased_type,
      sym_ephemeral_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
      sym_viewpoint_type,
  [26539] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1679), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(2090), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [26582] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1622), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(2092), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [26625] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1676), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1930), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [26668] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1684), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1902), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [26711] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1646), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1912), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [26754] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1687), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1916), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [26797] = 12,
    ACTIONS(2094), 1,
      anon_sym_is,
    ACTIONS(2098), 1,
      anon_sym_new,
    ACTIONS(2100), 1,
      anon_sym_fun,
    ACTIONS(2102), 1,
      anon_sym_be,
    ACTIONS(2104), 1,
      anon_sym_end,
    STATE(1474), 1,
      sym_capability,
    STATE(2211), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1494), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(2096), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1742), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [26846] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1689), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1896), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [26889] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1589), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1900), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [26932] = 12,
    ACTIONS(2098), 1,
      anon_sym_new,
    ACTIONS(2100), 1,
      anon_sym_fun,
    ACTIONS(2102), 1,
      anon_sym_be,
    ACTIONS(2106), 1,
      anon_sym_is,
    ACTIONS(2108), 1,
      anon_sym_end,
    STATE(1476), 1,
      sym_capability,
    STATE(2285), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1494), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(2096), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1742), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [26981] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1698), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1924), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [27024] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1595), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1942), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [27067] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1592), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(2110), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [27110] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1685), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1908), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [27153] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1700), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1926), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [27196] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1673), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1906), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [27239] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1672), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1888), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [27282] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1588), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1968), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [27325] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1667), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1928), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [27368] = 12,
    ACTIONS(2098), 1,
      anon_sym_new,
    ACTIONS(2100), 1,
      anon_sym_fun,
    ACTIONS(2102), 1,
      anon_sym_be,
    ACTIONS(2112), 1,
      anon_sym_is,
    ACTIONS(2114), 1,
      anon_sym_end,
    STATE(1473), 1,
      sym_capability,
    STATE(2478), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1494), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(2096), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1742), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [27417] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1659), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1954), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [27460] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1682), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1904), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [27503] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1593), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1922), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [27546] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1681), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1910), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [27589] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1629), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1932), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [27632] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1650), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1972), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [27675] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1677), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1914), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [27718] = 12,
    ACTIONS(2098), 1,
      anon_sym_new,
    ACTIONS(2100), 1,
      anon_sym_fun,
    ACTIONS(2102), 1,
      anon_sym_be,
    ACTIONS(2116), 1,
      anon_sym_is,
    ACTIONS(2118), 1,
      anon_sym_end,
    STATE(1475), 1,
      sym_capability,
    STATE(2198), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1494), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(2096), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1742), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [27767] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1674), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1886), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [27810] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1675), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1918), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [27853] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1597), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1920), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [27896] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1692), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(2120), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [27939] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1690), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(2122), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [27982] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1633), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1898), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [28025] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1683), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1958), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [28068] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1699), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1964), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [28111] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1594), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(2124), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [28154] = 9,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    STATE(1587), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1423), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1472), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(1876), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [28197] = 13,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1598), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2126), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [28247] = 16,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2098), 1,
      anon_sym_new,
    ACTIONS(2100), 1,
      anon_sym_fun,
    ACTIONS(2102), 1,
      anon_sym_be,
    ACTIONS(2128), 1,
      anon_sym_end,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(2349), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1494), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(2096), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1742), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
  [28303] = 16,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2098), 1,
      anon_sym_new,
    ACTIONS(2100), 1,
      anon_sym_fun,
    ACTIONS(2102), 1,
      anon_sym_be,
    ACTIONS(2130), 1,
      anon_sym_end,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(2251), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1494), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(2096), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1742), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
  [28359] = 16,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2098), 1,
      anon_sym_new,
    ACTIONS(2100), 1,
      anon_sym_fun,
    ACTIONS(2102), 1,
      anon_sym_be,
    ACTIONS(2132), 1,
      anon_sym_end,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(2313), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1494), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(2096), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1742), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
  [28415] = 16,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2098), 1,
      anon_sym_new,
    ACTIONS(2100), 1,
      anon_sym_fun,
    ACTIONS(2102), 1,
      anon_sym_be,
    ACTIONS(2134), 1,
      anon_sym_end,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(2237), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1494), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(2096), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1742), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
  [28471] = 16,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2098), 1,
      anon_sym_new,
    ACTIONS(2100), 1,
      anon_sym_fun,
    ACTIONS(2102), 1,
      anon_sym_be,
    ACTIONS(2136), 1,
      anon_sym_end,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(2462), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1494), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(2096), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1742), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
  [28527] = 13,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1603), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2138), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [28577] = 16,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2098), 1,
      anon_sym_new,
    ACTIONS(2100), 1,
      anon_sym_fun,
    ACTIONS(2102), 1,
      anon_sym_be,
    ACTIONS(2140), 1,
      anon_sym_end,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(2447), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1494), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(2096), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1742), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
  [28633] = 16,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2098), 1,
      anon_sym_new,
    ACTIONS(2100), 1,
      anon_sym_fun,
    ACTIONS(2102), 1,
      anon_sym_be,
    ACTIONS(2142), 1,
      anon_sym_end,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(2465), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1494), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(2096), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1742), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
  [28689] = 8,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1467), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(1878), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1469), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(2144), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [28729] = 16,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2098), 1,
      anon_sym_new,
    ACTIONS(2100), 1,
      anon_sym_fun,
    ACTIONS(2102), 1,
      anon_sym_be,
    ACTIONS(2146), 1,
      anon_sym_end,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(2302), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1494), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(2096), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1742), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
  [28785] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2150), 2,
      anon_sym_if,
      anon_sym_DQUOTE,
    ACTIONS(2148), 18,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
      anon_sym_ifdef,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [28814] = 9,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(2156), 1,
      anon_sym_COLON,
    ACTIONS(2158), 1,
      anon_sym_EQ_GT,
    STATE(1479), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2152), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [28855] = 9,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2162), 1,
      anon_sym_QMARK,
    ACTIONS(2164), 1,
      anon_sym_COLON,
    ACTIONS(2166), 1,
      anon_sym_EQ_GT,
    STATE(1507), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2160), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [28896] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2170), 2,
      anon_sym_if,
      anon_sym_DQUOTE,
    ACTIONS(2168), 18,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
      anon_sym_ifdef,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [28925] = 9,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2174), 1,
      anon_sym_QMARK,
    ACTIONS(2176), 1,
      anon_sym_COLON,
    ACTIONS(2178), 1,
      anon_sym_EQ_GT,
    STATE(1498), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2172), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [28966] = 14,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2180), 1,
      anon_sym_EQ,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1471), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2004), 7,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [29017] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2184), 2,
      anon_sym_if,
      anon_sym_DQUOTE,
    ACTIONS(2182), 18,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_QMARK,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_COLON,
      anon_sym_new,
      anon_sym_EQ_GT,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
      anon_sym_ifdef,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [29046] = 9,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2188), 1,
      anon_sym_QMARK,
    ACTIONS(2190), 1,
      anon_sym_COLON,
    ACTIONS(2192), 1,
      anon_sym_EQ_GT,
    STATE(1510), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2186), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [29087] = 9,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2196), 1,
      anon_sym_QMARK,
    ACTIONS(2198), 1,
      anon_sym_COLON,
    ACTIONS(2200), 1,
      anon_sym_EQ_GT,
    STATE(1499), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2194), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [29128] = 3,
    ACTIONS(2204), 1,
      anon_sym_DQUOTE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2202), 18,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_is,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [29156] = 8,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2208), 1,
      anon_sym_QMARK,
    ACTIONS(2210), 1,
      anon_sym_EQ_GT,
    STATE(1490), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2206), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [29194] = 8,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2214), 1,
      anon_sym_QMARK,
    ACTIONS(2216), 1,
      anon_sym_EQ_GT,
    STATE(1508), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2212), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [29232] = 12,
    ACTIONS(7), 1,
      anon_sym_use,
    ACTIONS(9), 1,
      anon_sym_type,
    ACTIONS(11), 1,
      anon_sym_actor,
    ACTIONS(13), 1,
      anon_sym_class,
    ACTIONS(15), 1,
      anon_sym_primitive,
    ACTIONS(17), 1,
      anon_sym_interface,
    ACTIONS(19), 1,
      anon_sym_trait,
    ACTIONS(21), 1,
      anon_sym_struct,
    ACTIONS(2218), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1438), 2,
      sym_statement,
      aux_sym_source_file_repeat1,
    STATE(1686), 8,
      sym_use_statement,
      sym_type_alias,
      sym_actor_definition,
      sym_class_definition,
      sym_primitive_definition,
      sym_interface_definition,
      sym_trait_definition,
      sym_struct_definition,
  [29278] = 12,
    ACTIONS(2220), 1,
      ts_builtin_sym_end,
    ACTIONS(2222), 1,
      anon_sym_use,
    ACTIONS(2225), 1,
      anon_sym_type,
    ACTIONS(2228), 1,
      anon_sym_actor,
    ACTIONS(2231), 1,
      anon_sym_class,
    ACTIONS(2234), 1,
      anon_sym_primitive,
    ACTIONS(2237), 1,
      anon_sym_interface,
    ACTIONS(2240), 1,
      anon_sym_trait,
    ACTIONS(2243), 1,
      anon_sym_struct,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1438), 2,
      sym_statement,
      aux_sym_source_file_repeat1,
    STATE(1686), 8,
      sym_use_statement,
      sym_type_alias,
      sym_actor_definition,
      sym_class_definition,
      sym_primitive_definition,
      sym_interface_definition,
      sym_trait_definition,
      sym_struct_definition,
  [29324] = 12,
    ACTIONS(7), 1,
      anon_sym_use,
    ACTIONS(9), 1,
      anon_sym_type,
    ACTIONS(11), 1,
      anon_sym_actor,
    ACTIONS(13), 1,
      anon_sym_class,
    ACTIONS(15), 1,
      anon_sym_primitive,
    ACTIONS(17), 1,
      anon_sym_interface,
    ACTIONS(19), 1,
      anon_sym_trait,
    ACTIONS(21), 1,
      anon_sym_struct,
    ACTIONS(2246), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1438), 2,
      sym_statement,
      aux_sym_source_file_repeat1,
    STATE(1686), 8,
      sym_use_statement,
      sym_type_alias,
      sym_actor_definition,
      sym_class_definition,
      sym_primitive_definition,
      sym_interface_definition,
      sym_trait_definition,
      sym_struct_definition,
  [29370] = 8,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2250), 1,
      anon_sym_QMARK,
    ACTIONS(2252), 1,
      anon_sym_EQ_GT,
    STATE(1511), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2248), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [29408] = 3,
    ACTIONS(2256), 1,
      anon_sym_DQUOTE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2254), 18,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_is,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_LPAREN,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [29436] = 8,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2260), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_EQ_GT,
    STATE(1489), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2258), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [29474] = 12,
    ACTIONS(7), 1,
      anon_sym_use,
    ACTIONS(9), 1,
      anon_sym_type,
    ACTIONS(11), 1,
      anon_sym_actor,
    ACTIONS(13), 1,
      anon_sym_class,
    ACTIONS(15), 1,
      anon_sym_primitive,
    ACTIONS(17), 1,
      anon_sym_interface,
    ACTIONS(19), 1,
      anon_sym_trait,
    ACTIONS(21), 1,
      anon_sym_struct,
    ACTIONS(2246), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1437), 2,
      sym_statement,
      aux_sym_source_file_repeat1,
    STATE(1686), 8,
      sym_use_statement,
      sym_type_alias,
      sym_actor_definition,
      sym_class_definition,
      sym_primitive_definition,
      sym_interface_definition,
      sym_trait_definition,
      sym_struct_definition,
  [29520] = 15,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2264), 1,
      anon_sym_QMARK,
    ACTIONS(2266), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1483), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2024), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [29571] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2192), 1,
      anon_sym_EQ_GT,
    STATE(1510), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2186), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [29606] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2270), 1,
      anon_sym_EQ_GT,
    STATE(1497), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2268), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [29641] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2252), 1,
      anon_sym_EQ_GT,
    STATE(1511), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2248), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [29676] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2274), 1,
      anon_sym_EQ_GT,
    STATE(1482), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2272), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [29711] = 15,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2276), 1,
      anon_sym_QMARK,
    ACTIONS(2278), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1486), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2038), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [29762] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2282), 1,
      anon_sym_EQ_GT,
    STATE(1500), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2280), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [29797] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2286), 1,
      anon_sym_EQ_GT,
    STATE(1496), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2284), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [29832] = 15,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2288), 1,
      anon_sym_QMARK,
    ACTIONS(2290), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1492), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2018), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [29883] = 15,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2292), 1,
      anon_sym_QMARK,
    ACTIONS(2294), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1487), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2032), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [29934] = 15,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2296), 1,
      anon_sym_QMARK,
    ACTIONS(2298), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1495), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2044), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [29985] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2210), 1,
      anon_sym_EQ_GT,
    STATE(1490), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2206), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [30020] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2302), 1,
      anon_sym_EQ_GT,
    STATE(1503), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2300), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [30055] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2306), 1,
      anon_sym_EQ_GT,
    STATE(1478), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2304), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [30090] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2310), 1,
      anon_sym_EQ_GT,
    STATE(1506), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2308), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [30125] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2166), 1,
      anon_sym_EQ_GT,
    STATE(1507), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2160), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [30160] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2314), 1,
      anon_sym_EQ_GT,
    STATE(1488), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2312), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [30195] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2318), 1,
      anon_sym_EQ_GT,
    STATE(1481), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2316), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [30230] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2200), 1,
      anon_sym_EQ_GT,
    STATE(1499), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2194), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [30265] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2262), 1,
      anon_sym_EQ_GT,
    STATE(1489), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2258), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [30300] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2178), 1,
      anon_sym_EQ_GT,
    STATE(1498), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2172), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [30335] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2322), 1,
      anon_sym_EQ_GT,
    STATE(1491), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2320), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [30370] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2326), 1,
      anon_sym_EQ_GT,
    STATE(1505), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2324), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [30405] = 4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1467), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(2330), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    ACTIONS(2328), 12,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
  [30433] = 6,
    ACTIONS(2335), 1,
      anon_sym_new,
    ACTIONS(2338), 1,
      anon_sym_fun,
    ACTIONS(2341), 1,
      anon_sym_be,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1468), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(2333), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [30464] = 6,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1468), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(2344), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [30495] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2346), 16,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [30518] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2348), 16,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [30541] = 6,
    ACTIONS(1880), 1,
      anon_sym_new,
    ACTIONS(1882), 1,
      anon_sym_fun,
    ACTIONS(1884), 1,
      anon_sym_be,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1468), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
    ACTIONS(2144), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [30572] = 10,
    ACTIONS(2098), 1,
      anon_sym_new,
    ACTIONS(2100), 1,
      anon_sym_fun,
    ACTIONS(2102), 1,
      anon_sym_be,
    ACTIONS(2350), 1,
      anon_sym_is,
    ACTIONS(2352), 1,
      anon_sym_end,
    STATE(2473), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1494), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(2096), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1742), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
  [30610] = 10,
    ACTIONS(2098), 1,
      anon_sym_new,
    ACTIONS(2100), 1,
      anon_sym_fun,
    ACTIONS(2102), 1,
      anon_sym_be,
    ACTIONS(2354), 1,
      anon_sym_is,
    ACTIONS(2356), 1,
      anon_sym_end,
    STATE(2202), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1494), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(2096), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1742), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
  [30648] = 10,
    ACTIONS(2098), 1,
      anon_sym_new,
    ACTIONS(2100), 1,
      anon_sym_fun,
    ACTIONS(2102), 1,
      anon_sym_be,
    ACTIONS(2358), 1,
      anon_sym_is,
    ACTIONS(2360), 1,
      anon_sym_end,
    STATE(2222), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1494), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(2096), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1742), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
  [30686] = 10,
    ACTIONS(2098), 1,
      anon_sym_new,
    ACTIONS(2100), 1,
      anon_sym_fun,
    ACTIONS(2102), 1,
      anon_sym_be,
    ACTIONS(2362), 1,
      anon_sym_is,
    ACTIONS(2364), 1,
      anon_sym_end,
    STATE(2412), 1,
      sym_members,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1494), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(2096), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1742), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
  [30724] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2366), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [30744] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2368), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [30764] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2172), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [30784] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2370), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [30804] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2308), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [30824] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2372), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [30844] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2280), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [30864] = 6,
    ACTIONS(2376), 1,
      anon_sym_if,
    ACTIONS(2378), 1,
      anon_sym_ifdef,
    STATE(1610), 1,
      sym_platform_specifier,
    STATE(1615), 1,
      sym_if_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2374), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [30892] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2380), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [30912] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2312), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [30932] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2300), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [30952] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2382), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [30972] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2284), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [30992] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2258), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [31012] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2384), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [31032] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2320), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [31052] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2386), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [31072] = 8,
    ACTIONS(2098), 1,
      anon_sym_new,
    ACTIONS(2100), 1,
      anon_sym_fun,
    ACTIONS(2102), 1,
      anon_sym_be,
    ACTIONS(2144), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1643), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(2096), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    STATE(1731), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
  [31104] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2272), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [31124] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2388), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [31144] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2324), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [31164] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2186), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [31184] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2304), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [31204] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2390), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [31224] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2392), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [31244] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2394), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [31264] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2396), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [31284] = 6,
    ACTIONS(2376), 1,
      anon_sym_if,
    ACTIONS(2378), 1,
      anon_sym_ifdef,
    STATE(1615), 1,
      sym_if_block,
    STATE(1669), 1,
      sym_platform_specifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2398), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [31312] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2316), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [31332] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2400), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [31352] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2194), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [31372] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2248), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [31392] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2402), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [31412] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2160), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [31432] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2206), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [31452] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2404), 13,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [31472] = 8,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2406), 1,
      sym_identifier,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(1847), 1,
      sym_capability,
    STATE(2022), 1,
      sym_lambda_parameters,
    STATE(2167), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [31503] = 4,
    ACTIONS(2412), 1,
      anon_sym_QMARK,
    ACTIONS(2414), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2410), 10,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_ifdef,
  [31526] = 8,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    ACTIONS(2416), 1,
      sym_identifier,
    STATE(1843), 1,
      sym_capability,
    STATE(2025), 1,
      sym_lambda_parameters,
    STATE(2165), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [31557] = 8,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    ACTIONS(2418), 1,
      sym_identifier,
    STATE(1832), 1,
      sym_capability,
    STATE(1984), 1,
      sym_lambda_parameters,
    STATE(2135), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [31588] = 9,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2420), 1,
      anon_sym_QMARK,
    ACTIONS(2422), 1,
      anon_sym_COLON,
    ACTIONS(2424), 1,
      anon_sym_EQ_GT,
    STATE(1498), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2172), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [31621] = 8,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    ACTIONS(2426), 1,
      sym_identifier,
    STATE(1844), 1,
      sym_capability,
    STATE(2095), 1,
      sym_lambda_parameters,
    STATE(2128), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [31652] = 9,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2428), 1,
      anon_sym_QMARK,
    ACTIONS(2430), 1,
      anon_sym_COLON,
    ACTIONS(2432), 1,
      anon_sym_EQ_GT,
    STATE(1479), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2152), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [31685] = 8,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    ACTIONS(2434), 1,
      sym_identifier,
    STATE(1848), 1,
      sym_capability,
    STATE(2045), 1,
      sym_lambda_parameters,
    STATE(2168), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [31716] = 8,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    ACTIONS(2436), 1,
      sym_identifier,
    STATE(1809), 1,
      sym_capability,
    STATE(2085), 1,
      sym_lambda_parameters,
    STATE(2188), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [31747] = 8,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    ACTIONS(2438), 1,
      sym_identifier,
    STATE(1824), 1,
      sym_capability,
    STATE(2090), 1,
      sym_lambda_parameters,
    STATE(2181), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [31778] = 8,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    ACTIONS(2440), 1,
      sym_identifier,
    STATE(1814), 1,
      sym_capability,
    STATE(1943), 1,
      sym_lambda_parameters,
    STATE(2176), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [31809] = 8,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    ACTIONS(2442), 1,
      sym_identifier,
    STATE(1845), 1,
      sym_capability,
    STATE(2099), 1,
      sym_lambda_parameters,
    STATE(2183), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [31840] = 8,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    ACTIONS(2444), 1,
      sym_identifier,
    STATE(1849), 1,
      sym_capability,
    STATE(1952), 1,
      sym_lambda_parameters,
    STATE(2173), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [31871] = 9,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2446), 1,
      anon_sym_QMARK,
    ACTIONS(2448), 1,
      anon_sym_COLON,
    ACTIONS(2450), 1,
      anon_sym_EQ_GT,
    STATE(1510), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2186), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [31904] = 9,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2452), 1,
      anon_sym_QMARK,
    ACTIONS(2454), 1,
      anon_sym_COLON,
    ACTIONS(2456), 1,
      anon_sym_EQ_GT,
    STATE(1507), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2160), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [31937] = 9,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2458), 1,
      anon_sym_QMARK,
    ACTIONS(2460), 1,
      anon_sym_COLON,
    ACTIONS(2462), 1,
      anon_sym_EQ_GT,
    STATE(1499), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2194), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [31970] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2464), 11,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_EQ_GT,
      anon_sym_then,
  [31988] = 8,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2466), 1,
      anon_sym_QMARK,
    ACTIONS(2468), 1,
      anon_sym_EQ_GT,
    STATE(1489), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2258), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [32018] = 12,
    ACTIONS(1759), 1,
      anon_sym_COMMA,
    ACTIONS(1793), 1,
      anon_sym_RPAREN,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2470), 1,
      anon_sym_EQ,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(2097), 1,
      aux_sym_lambda_captures_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [32056] = 8,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2472), 1,
      anon_sym_QMARK,
    ACTIONS(2474), 1,
      anon_sym_EQ_GT,
    STATE(1490), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2206), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [32086] = 7,
    ACTIONS(1364), 1,
      anon_sym_BSLASH,
    ACTIONS(2476), 1,
      sym_identifier,
    ACTIONS(2478), 1,
      anon_sym_AT,
    STATE(1607), 1,
      sym_annotation,
    STATE(2184), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [32114] = 3,
    ACTIONS(2482), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2480), 10,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_ifdef,
  [32134] = 8,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2484), 1,
      anon_sym_QMARK,
    ACTIONS(2486), 1,
      anon_sym_EQ_GT,
    STATE(1508), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2212), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [32164] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2488), 11,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
      anon_sym_EQ_GT,
      anon_sym_then,
  [32182] = 7,
    ACTIONS(1364), 1,
      anon_sym_BSLASH,
    ACTIONS(2490), 1,
      sym_identifier,
    ACTIONS(2492), 1,
      anon_sym_AT,
    STATE(1585), 1,
      sym_annotation,
    STATE(2156), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [32210] = 8,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2494), 1,
      anon_sym_QMARK,
    ACTIONS(2496), 1,
      anon_sym_EQ_GT,
    STATE(1511), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2248), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [32240] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2498), 1,
      anon_sym_EQ_GT,
    STATE(1488), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2312), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [32267] = 11,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2500), 1,
      anon_sym_RBRACK,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(2065), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [32302] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2504), 1,
      anon_sym_EQ_GT,
    STATE(1506), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2308), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [32329] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2506), 1,
      anon_sym_EQ_GT,
    STATE(1491), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2320), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [32356] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2456), 1,
      anon_sym_EQ_GT,
    STATE(1507), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2160), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [32383] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2468), 1,
      anon_sym_EQ_GT,
    STATE(1489), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2258), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [32410] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2508), 1,
      anon_sym_EQ_GT,
    STATE(1481), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2316), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [32437] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2450), 1,
      anon_sym_EQ_GT,
    STATE(1510), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2186), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [32464] = 11,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(2510), 1,
      anon_sym_RBRACK,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1963), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [32499] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2474), 1,
      anon_sym_EQ_GT,
    STATE(1490), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2206), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [32526] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2512), 1,
      anon_sym_EQ_GT,
    STATE(1505), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2324), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [32553] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_EQ_GT,
    STATE(1498), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2172), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [32580] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2496), 1,
      anon_sym_EQ_GT,
    STATE(1511), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2248), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [32607] = 6,
    ACTIONS(1364), 1,
      anon_sym_BSLASH,
    ACTIONS(2514), 1,
      sym_identifier,
    STATE(1729), 1,
      sym_annotation,
    STATE(2290), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [32632] = 11,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(2516), 1,
      anon_sym_RBRACK,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1994), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [32667] = 6,
    ACTIONS(1364), 1,
      anon_sym_BSLASH,
    ACTIONS(2518), 1,
      sym_identifier,
    STATE(1733), 1,
      sym_annotation,
    STATE(2326), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [32692] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2520), 1,
      anon_sym_EQ_GT,
    STATE(1496), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2284), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [32719] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2462), 1,
      anon_sym_EQ_GT,
    STATE(1499), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2194), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [32746] = 9,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2522), 3,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [32777] = 11,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(2524), 1,
      anon_sym_RBRACK,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(2104), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [32812] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2526), 1,
      anon_sym_EQ_GT,
    STATE(1500), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2280), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [32839] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2528), 1,
      anon_sym_EQ_GT,
    STATE(1478), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2304), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [32866] = 11,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(2530), 1,
      anon_sym_RPAREN,
    STATE(1708), 1,
      aux_sym_union_type_repeat1,
    STATE(1725), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1953), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [32901] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2532), 1,
      anon_sym_EQ_GT,
    STATE(1503), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2300), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [32928] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2534), 1,
      anon_sym_EQ,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2536), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [32961] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2538), 1,
      anon_sym_EQ_GT,
    STATE(1482), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2272), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [32988] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2540), 1,
      anon_sym_EQ,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1827), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [33021] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2542), 1,
      anon_sym_EQ_GT,
    STATE(1497), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    ACTIONS(2268), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [33048] = 11,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(2544), 1,
      anon_sym_RPAREN,
    STATE(1735), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1736), 1,
      aux_sym_union_type_repeat1,
    STATE(2100), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [33083] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2546), 1,
      anon_sym_EQ,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [33116] = 6,
    ACTIONS(1364), 1,
      anon_sym_BSLASH,
    ACTIONS(2548), 1,
      sym_identifier,
    STATE(1728), 1,
      sym_annotation,
    STATE(2240), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [33141] = 6,
    ACTIONS(1364), 1,
      anon_sym_BSLASH,
    ACTIONS(2550), 1,
      sym_identifier,
    STATE(1717), 1,
      sym_annotation,
    STATE(2243), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [33166] = 11,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(2552), 1,
      anon_sym_RPAREN,
    STATE(1706), 1,
      aux_sym_union_type_repeat1,
    STATE(1740), 1,
      aux_sym_intersection_type_repeat1,
    STATE(2084), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [33201] = 11,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(2554), 1,
      anon_sym_RBRACK,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(2066), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [33236] = 11,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(2556), 1,
      anon_sym_RPAREN,
    STATE(1707), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1730), 1,
      aux_sym_union_type_repeat1,
    STATE(2026), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [33271] = 11,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(2558), 1,
      anon_sym_RBRACK,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(2031), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [33306] = 11,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(2560), 1,
      anon_sym_RBRACK,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(2072), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [33341] = 6,
    ACTIONS(1364), 1,
      anon_sym_BSLASH,
    ACTIONS(2562), 1,
      sym_identifier,
    STATE(1743), 1,
      sym_annotation,
    STATE(2319), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [33366] = 11,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(2564), 1,
      anon_sym_RBRACK,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(2078), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [33401] = 6,
    ACTIONS(1364), 1,
      anon_sym_BSLASH,
    ACTIONS(2566), 1,
      sym_identifier,
    STATE(1744), 1,
      sym_annotation,
    STATE(2324), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [33426] = 11,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(2568), 1,
      anon_sym_RPAREN,
    STATE(1732), 1,
      aux_sym_union_type_repeat1,
    STATE(1745), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1964), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [33461] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2570), 1,
      anon_sym_EQ,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2572), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [33494] = 11,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(2574), 1,
      anon_sym_RBRACK,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(2080), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [33529] = 11,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(2576), 1,
      anon_sym_RPAREN,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(2037), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [33564] = 6,
    ACTIONS(1364), 1,
      anon_sym_BSLASH,
    ACTIONS(2578), 1,
      sym_identifier,
    STATE(1726), 1,
      sym_annotation,
    STATE(2279), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [33589] = 6,
    ACTIONS(1364), 1,
      anon_sym_BSLASH,
    ACTIONS(2580), 1,
      sym_identifier,
    STATE(1715), 1,
      sym_annotation,
    STATE(2256), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [33614] = 5,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2584), 1,
      anon_sym_AT,
    STATE(2153), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [33636] = 9,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2586), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [33666] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2122), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [33682] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1928), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [33698] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2120), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [33714] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2588), 1,
      anon_sym_QMARK,
    ACTIONS(2590), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [33746] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2592), 1,
      anon_sym_QMARK,
    ACTIONS(2594), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [33778] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2596), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [33794] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2092), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [33810] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2598), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [33826] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1898), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [33842] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2600), 1,
      anon_sym_QMARK,
    ACTIONS(2602), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [33874] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1896), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [33890] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2604), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [33906] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2606), 1,
      anon_sym_QMARK,
    ACTIONS(2608), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [33938] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2610), 1,
      anon_sym_QMARK,
    ACTIONS(2612), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [33970] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2614), 1,
      anon_sym_then,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1791), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [34002] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2616), 1,
      anon_sym_QMARK,
    ACTIONS(2618), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [34034] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2620), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [34050] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2622), 1,
      anon_sym_QMARK,
    ACTIONS(2624), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [34082] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2626), 1,
      anon_sym_QMARK,
    ACTIONS(2628), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [34114] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2630), 1,
      anon_sym_QMARK,
    ACTIONS(2632), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [34146] = 5,
    ACTIONS(2634), 1,
      sym_identifier,
    ACTIONS(2636), 1,
      anon_sym_AT,
    STATE(2146), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [34168] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2638), 1,
      anon_sym_QMARK,
    ACTIONS(2640), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [34200] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2642), 1,
      anon_sym_QMARK,
    ACTIONS(2644), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [34232] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2646), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [34248] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2648), 1,
      anon_sym_QMARK,
    ACTIONS(2650), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [34280] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2652), 1,
      anon_sym_QMARK,
    ACTIONS(2654), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [34312] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2656), 1,
      anon_sym_QMARK,
    ACTIONS(2658), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [34344] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2614), 1,
      anon_sym_then,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(2063), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [34376] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2660), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [34392] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2662), 1,
      anon_sym_QMARK,
    ACTIONS(2664), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [34424] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2666), 1,
      anon_sym_QMARK,
    ACTIONS(2668), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [34456] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2670), 1,
      anon_sym_QMARK,
    ACTIONS(2672), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [34488] = 9,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2674), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [34518] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2676), 1,
      anon_sym_QMARK,
    ACTIONS(2678), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [34550] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2614), 1,
      anon_sym_then,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1766), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [34582] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2680), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [34598] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1964), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [34614] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2614), 1,
      anon_sym_then,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1785), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [34646] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2682), 1,
      anon_sym_QMARK,
    ACTIONS(2684), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [34678] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2686), 1,
      anon_sym_QMARK,
    ACTIONS(2688), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [34710] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2690), 1,
      anon_sym_QMARK,
    ACTIONS(2692), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [34742] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2694), 1,
      anon_sym_QMARK,
    ACTIONS(2696), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [34774] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1902), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [34790] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2698), 1,
      anon_sym_QMARK,
    ACTIONS(2700), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [34822] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2702), 1,
      anon_sym_QMARK,
    ACTIONS(2704), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [34854] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2706), 1,
      anon_sym_QMARK,
    ACTIONS(2708), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [34886] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1920), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [34902] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2710), 1,
      anon_sym_QMARK,
    ACTIONS(2712), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [34934] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2614), 1,
      anon_sym_then,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(2069), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [34966] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2714), 1,
      anon_sym_QMARK,
    ACTIONS(2716), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [34998] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2718), 1,
      anon_sym_QMARK,
    ACTIONS(2720), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [35030] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2722), 1,
      anon_sym_QMARK,
    ACTIONS(2724), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [35062] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1958), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [35078] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2726), 1,
      anon_sym_QMARK,
    ACTIONS(2728), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [35110] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2730), 1,
      anon_sym_QMARK,
    ACTIONS(2732), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [35142] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2734), 1,
      anon_sym_QMARK,
    ACTIONS(2736), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [35174] = 4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1643), 2,
      sym_field,
      aux_sym_members_repeat1,
    ACTIONS(2738), 3,
      anon_sym_embed,
      anon_sym_let,
      anon_sym_var,
    ACTIONS(2328), 4,
      anon_sym_new,
      anon_sym_fun,
      anon_sym_be,
      anon_sym_end,
  [35194] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2741), 1,
      anon_sym_QMARK,
    ACTIONS(2743), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [35226] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2745), 1,
      anon_sym_QMARK,
    ACTIONS(2747), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [35258] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2090), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [35274] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2749), 1,
      anon_sym_QMARK,
    ACTIONS(2751), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [35306] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2753), 1,
      anon_sym_QMARK,
    ACTIONS(2755), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [35338] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2757), 1,
      anon_sym_QMARK,
    ACTIONS(2759), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [35370] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1888), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [35386] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2761), 1,
      anon_sym_QMARK,
    ACTIONS(2763), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [35418] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2765), 1,
      anon_sym_QMARK,
    ACTIONS(2767), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [35450] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2769), 1,
      anon_sym_QMARK,
    ACTIONS(2771), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [35482] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2773), 1,
      anon_sym_QMARK,
    ACTIONS(2775), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [35514] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2777), 1,
      anon_sym_QMARK,
    ACTIONS(2779), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [35546] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2614), 1,
      anon_sym_then,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1799), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [35578] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2781), 1,
      anon_sym_QMARK,
    ACTIONS(2783), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [35610] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2785), 1,
      anon_sym_QMARK,
    ACTIONS(2787), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [35642] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1906), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [35658] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2789), 1,
      anon_sym_QMARK,
    ACTIONS(2791), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [35690] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2793), 1,
      anon_sym_QMARK,
    ACTIONS(2795), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [35722] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2797), 1,
      anon_sym_QMARK,
    ACTIONS(2799), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [35754] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2801), 1,
      anon_sym_QMARK,
    ACTIONS(2803), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [35786] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1942), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [35802] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2805), 1,
      anon_sym_QMARK,
    ACTIONS(2807), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [35834] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2809), 1,
      anon_sym_QMARK,
    ACTIONS(2811), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [35866] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1932), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [35882] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2813), 1,
      anon_sym_QMARK,
    ACTIONS(2815), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [35914] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2817), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [35930] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2819), 1,
      anon_sym_QMARK,
    ACTIONS(2821), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [35962] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2823), 1,
      anon_sym_QMARK,
    ACTIONS(2825), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [35994] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1926), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [36010] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1924), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [36026] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1916), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [36042] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1912), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [36058] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1908), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [36074] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1876), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [36090] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1968), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [36106] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2827), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [36122] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2829), 1,
      anon_sym_QMARK,
    ACTIONS(2831), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [36154] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1900), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [36170] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2110), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [36186] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1886), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [36202] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1922), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [36218] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1918), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [36234] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2833), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [36250] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1914), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [36266] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1972), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [36282] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2124), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [36298] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2835), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [36314] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1954), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [36330] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2837), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [36346] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2839), 1,
      anon_sym_QMARK,
    ACTIONS(2841), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [36378] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2843), 1,
      anon_sym_QMARK,
    ACTIONS(2845), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [36410] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2847), 1,
      anon_sym_QMARK,
    ACTIONS(2849), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [36442] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2851), 1,
      anon_sym_QMARK,
    ACTIONS(2853), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [36474] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2855), 1,
      anon_sym_QMARK,
    ACTIONS(2857), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [36506] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1910), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [36522] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1930), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [36538] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1904), 9,
      ts_builtin_sym_end,
      anon_sym_use,
      anon_sym_type,
      anon_sym_actor,
      anon_sym_class,
      anon_sym_primitive,
      anon_sym_interface,
      anon_sym_trait,
      anon_sym_struct,
  [36554] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2859), 1,
      anon_sym_QMARK,
    ACTIONS(2861), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [36586] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2863), 1,
      anon_sym_QMARK,
    ACTIONS(2865), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [36618] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2867), 1,
      anon_sym_QMARK,
    ACTIONS(2869), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [36650] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2871), 1,
      anon_sym_QMARK,
    ACTIONS(2873), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [36682] = 10,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2875), 1,
      anon_sym_QMARK,
    ACTIONS(2877), 1,
      anon_sym_RBRACE,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [36714] = 5,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(2879), 1,
      anon_sym_RPAREN,
    STATE(1126), 1,
      aux_sym_union_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(885), 5,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_DASH_GT,
  [36735] = 5,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(2881), 1,
      anon_sym_RPAREN,
    STATE(1127), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(892), 5,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
  [36756] = 5,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(2883), 1,
      anon_sym_RPAREN,
    STATE(1126), 1,
      aux_sym_union_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(885), 5,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_DASH_GT,
  [36777] = 7,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2885), 1,
      sym_identifier,
    ACTIONS(2887), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1484), 2,
      sym_ffi_method,
      sym_string,
  [36802] = 4,
    ACTIONS(2889), 1,
      anon_sym_LPAREN,
    STATE(2516), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [36821] = 4,
    ACTIONS(2891), 1,
      anon_sym_LPAREN,
    STATE(2515), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [36840] = 9,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2893), 1,
      anon_sym_LT_COLON,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [36869] = 4,
    ACTIONS(2895), 1,
      anon_sym_LPAREN,
    STATE(2511), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [36888] = 4,
    ACTIONS(2897), 1,
      sym_identifier,
    STATE(2481), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [36907] = 4,
    ACTIONS(2899), 1,
      sym_identifier,
    STATE(2398), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [36926] = 9,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2901), 1,
      anon_sym_COLON,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [36955] = 4,
    ACTIONS(2903), 1,
      sym_identifier,
    STATE(2199), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [36974] = 9,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2905), 1,
      anon_sym_COLON,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [37003] = 4,
    ACTIONS(2907), 1,
      anon_sym_LPAREN,
    STATE(2377), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [37022] = 9,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2909), 1,
      anon_sym_RBRACK,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [37051] = 4,
    ACTIONS(2911), 1,
      anon_sym_LPAREN,
    STATE(2510), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [37070] = 4,
    ACTIONS(2913), 1,
      anon_sym_LPAREN,
    STATE(2506), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [37089] = 9,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2915), 1,
      anon_sym_COLON,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [37118] = 9,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2917), 1,
      anon_sym_LT_COLON,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [37147] = 5,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(2919), 1,
      anon_sym_RPAREN,
    STATE(1127), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(892), 5,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
  [37168] = 4,
    ACTIONS(2921), 1,
      sym_identifier,
    STATE(2291), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [37187] = 4,
    ACTIONS(2923), 1,
      anon_sym_LPAREN,
    STATE(2505), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [37206] = 4,
    ACTIONS(2925), 1,
      sym_identifier,
    STATE(2248), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [37225] = 4,
    ACTIONS(2927), 1,
      sym_identifier,
    STATE(2359), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [37244] = 5,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(2929), 1,
      anon_sym_RPAREN,
    STATE(1126), 1,
      aux_sym_union_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(885), 5,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_DASH_GT,
  [37265] = 6,
    ACTIONS(2098), 1,
      anon_sym_new,
    ACTIONS(2100), 1,
      anon_sym_fun,
    ACTIONS(2102), 1,
      anon_sym_be,
    ACTIONS(2344), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1746), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
  [37288] = 5,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(2931), 1,
      anon_sym_RPAREN,
    STATE(1126), 1,
      aux_sym_union_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(885), 5,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_DASH_GT,
  [37309] = 4,
    ACTIONS(2933), 1,
      sym_identifier,
    STATE(2345), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [37328] = 9,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2935), 1,
      anon_sym_LT_COLON,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [37357] = 5,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(2937), 1,
      anon_sym_RPAREN,
    STATE(1127), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(892), 5,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
  [37378] = 5,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(2939), 1,
      anon_sym_RPAREN,
    STATE(1126), 1,
      aux_sym_union_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(885), 5,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_DASH_GT,
  [37399] = 9,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2941), 1,
      anon_sym_LT_COLON,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [37428] = 4,
    ACTIONS(2943), 1,
      sym_identifier,
    STATE(2212), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [37447] = 9,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2945), 1,
      anon_sym_LT_COLON,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [37476] = 5,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(2947), 1,
      anon_sym_RPAREN,
    STATE(1127), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(892), 5,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
  [37497] = 9,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2949), 1,
      anon_sym_LT_COLON,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [37526] = 6,
    ACTIONS(2098), 1,
      anon_sym_new,
    ACTIONS(2100), 1,
      anon_sym_fun,
    ACTIONS(2102), 1,
      anon_sym_be,
    ACTIONS(2144), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1746), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
  [37549] = 4,
    ACTIONS(2951), 1,
      sym_identifier,
    STATE(2332), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [37568] = 4,
    ACTIONS(2953), 1,
      sym_identifier,
    STATE(2335), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [37587] = 5,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(2955), 1,
      anon_sym_RPAREN,
    STATE(1127), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(892), 5,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
  [37608] = 6,
    ACTIONS(2333), 1,
      anon_sym_end,
    ACTIONS(2957), 1,
      anon_sym_new,
    ACTIONS(2960), 1,
      anon_sym_fun,
    ACTIONS(2963), 1,
      anon_sym_be,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1746), 4,
      sym_constructor,
      sym_method,
      sym_behavior,
      aux_sym_members_repeat2,
  [37631] = 9,
    ACTIONS(1866), 1,
      anon_sym_BANG,
    ACTIONS(1868), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_PIPE,
    ACTIONS(1872), 1,
      anon_sym_AMP,
    ACTIONS(1874), 1,
      anon_sym_DASH_GT,
    ACTIONS(2966), 1,
      anon_sym_COLON,
    STATE(1124), 1,
      aux_sym_union_type_repeat1,
    STATE(1131), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [37660] = 4,
    ACTIONS(2968), 1,
      sym_identifier,
    STATE(2281), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [37679] = 4,
    ACTIONS(2970), 1,
      sym_identifier,
    STATE(2197), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [37698] = 4,
    ACTIONS(2972), 1,
      anon_sym_LPAREN,
    STATE(2265), 1,
      sym_capability,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1366), 6,
      anon_sym_iso,
      anon_sym_trn,
      anon_sym_ref,
      anon_sym_val,
      anon_sym_box,
      anon_sym_tag,
  [37717] = 7,
    ACTIONS(2974), 1,
      sym_identifier,
    ACTIONS(2976), 1,
      anon_sym_LBRACE,
    ACTIONS(2978), 1,
      anon_sym_DQUOTE,
    ACTIONS(2980), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(330), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(329), 2,
      sym__string_literal,
      sym__multiline_string_literal,
  [37741] = 7,
    ACTIONS(2982), 1,
      sym_identifier,
    ACTIONS(2984), 1,
      anon_sym_LBRACE,
    ACTIONS(2986), 1,
      anon_sym_DQUOTE,
    ACTIONS(2988), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(483), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(499), 2,
      sym__string_literal,
      sym__multiline_string_literal,
  [37765] = 6,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2887), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
    STATE(1504), 2,
      sym_ffi_method,
      sym_string,
  [37787] = 7,
    ACTIONS(2990), 1,
      sym_identifier,
    ACTIONS(2992), 1,
      anon_sym_LBRACE,
    ACTIONS(2994), 1,
      anon_sym_DQUOTE,
    ACTIONS(2996), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(193), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(210), 2,
      sym__string_literal,
      sym__multiline_string_literal,
  [37811] = 7,
    ACTIONS(2998), 1,
      sym_identifier,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    ACTIONS(3002), 1,
      anon_sym_DQUOTE,
    ACTIONS(3004), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(972), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(970), 2,
      sym__string_literal,
      sym__multiline_string_literal,
  [37835] = 6,
    ACTIONS(3006), 1,
      anon_sym_end,
    ACTIONS(3008), 1,
      anon_sym_elseif,
    ACTIONS(3010), 1,
      anon_sym_else,
    STATE(2422), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1765), 2,
      sym_elseif_block,
      aux_sym_if_statement_repeat1,
  [37856] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(3012), 1,
      anon_sym_DQUOTE,
    ACTIONS(3014), 1,
      sym_string_content,
    ACTIONS(3018), 1,
      sym_line_comment,
    ACTIONS(3016), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(1803), 2,
      sym__escape_sequence,
      aux_sym__string_literal_repeat1,
  [37877] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(3018), 1,
      sym_line_comment,
    ACTIONS(3020), 1,
      anon_sym_SQUOTE,
    ACTIONS(3022), 1,
      sym_character_content,
    ACTIONS(3024), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(1769), 2,
      sym__escape_sequence,
      aux_sym_character_repeat1,
  [37898] = 6,
    ACTIONS(3010), 1,
      anon_sym_else,
    ACTIONS(3026), 1,
      anon_sym_end,
    ACTIONS(3028), 1,
      anon_sym_elseif,
    STATE(2509), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1826), 2,
      sym_elseiftype_block,
      aux_sym_iftype_statement_repeat1,
  [37919] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(3014), 1,
      sym_string_content,
    ACTIONS(3018), 1,
      sym_line_comment,
    ACTIONS(3030), 1,
      anon_sym_DQUOTE,
    ACTIONS(3016), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(1803), 2,
      sym__escape_sequence,
      aux_sym__string_literal_repeat1,
  [37940] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(3018), 1,
      sym_line_comment,
    ACTIONS(3032), 1,
      anon_sym_DQUOTE,
    ACTIONS(3034), 1,
      sym_string_content,
    ACTIONS(3036), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(1763), 2,
      sym__escape_sequence,
      aux_sym__string_literal_repeat1,
  [37961] = 6,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(3038), 1,
      anon_sym_PIPE,
    ACTIONS(3040), 1,
      anon_sym_end,
    STATE(2352), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1818), 2,
      sym_case_statement,
      aux_sym_match_statement_repeat1,
  [37982] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(3014), 1,
      sym_string_content,
    ACTIONS(3018), 1,
      sym_line_comment,
    ACTIONS(3042), 1,
      anon_sym_DQUOTE,
    ACTIONS(3016), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(1803), 2,
      sym__escape_sequence,
      aux_sym__string_literal_repeat1,
  [38003] = 6,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(3038), 1,
      anon_sym_PIPE,
    ACTIONS(3044), 1,
      anon_sym_end,
    STATE(2466), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1818), 2,
      sym_case_statement,
      aux_sym_match_statement_repeat1,
  [38024] = 6,
    ACTIONS(3008), 1,
      anon_sym_elseif,
    ACTIONS(3010), 1,
      anon_sym_else,
    ACTIONS(3046), 1,
      anon_sym_end,
    STATE(2444), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1812), 2,
      sym_elseif_block,
      aux_sym_if_statement_repeat1,
  [38045] = 6,
    ACTIONS(3010), 1,
      anon_sym_else,
    ACTIONS(3028), 1,
      anon_sym_elseif,
    ACTIONS(3048), 1,
      anon_sym_end,
    STATE(2396), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1759), 2,
      sym_elseiftype_block,
      aux_sym_iftype_statement_repeat1,
  [38066] = 6,
    ACTIONS(23), 1,
      anon_sym_DQUOTE,
    ACTIONS(25), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3050), 1,
      sym_identifier,
    STATE(2229), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(863), 2,
      sym__string_literal,
      sym__multiline_string_literal,
  [38087] = 6,
    ACTIONS(3008), 1,
      anon_sym_elseif,
    ACTIONS(3010), 1,
      anon_sym_else,
    ACTIONS(3052), 1,
      anon_sym_end,
    STATE(2457), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1812), 2,
      sym_elseif_block,
      aux_sym_if_statement_repeat1,
  [38108] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(3018), 1,
      sym_line_comment,
    ACTIONS(3054), 1,
      anon_sym_SQUOTE,
    ACTIONS(3056), 1,
      sym_character_content,
    ACTIONS(3059), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(1769), 2,
      sym__escape_sequence,
      aux_sym_character_repeat1,
  [38129] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(3018), 1,
      sym_line_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      sym_string_content,
    ACTIONS(3066), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(1771), 2,
      sym__escape_sequence,
      aux_sym__string_literal_repeat1,
  [38150] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(3014), 1,
      sym_string_content,
    ACTIONS(3018), 1,
      sym_line_comment,
    ACTIONS(3068), 1,
      anon_sym_DQUOTE,
    ACTIONS(3016), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(1803), 2,
      sym__escape_sequence,
      aux_sym__string_literal_repeat1,
  [38171] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(3018), 1,
      sym_line_comment,
    ACTIONS(3070), 1,
      anon_sym_DQUOTE,
    ACTIONS(3072), 1,
      sym_string_content,
    ACTIONS(3074), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(1773), 2,
      sym__escape_sequence,
      aux_sym__string_literal_repeat1,
  [38192] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(3014), 1,
      sym_string_content,
    ACTIONS(3018), 1,
      sym_line_comment,
    ACTIONS(3076), 1,
      anon_sym_DQUOTE,
    ACTIONS(3016), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(1803), 2,
      sym__escape_sequence,
      aux_sym__string_literal_repeat1,
  [38213] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(3018), 1,
      sym_line_comment,
    ACTIONS(3078), 1,
      anon_sym_DQUOTE,
    ACTIONS(3080), 1,
      sym_string_content,
    ACTIONS(3082), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(1760), 2,
      sym__escape_sequence,
      aux_sym__string_literal_repeat1,
  [38234] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(3018), 1,
      sym_line_comment,
    ACTIONS(3084), 1,
      anon_sym_DQUOTE,
    ACTIONS(3086), 1,
      sym_string_content,
    ACTIONS(3088), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(1777), 2,
      sym__escape_sequence,
      aux_sym__string_literal_repeat1,
  [38255] = 6,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(3038), 1,
      anon_sym_PIPE,
    ACTIONS(3090), 1,
      anon_sym_end,
    STATE(2344), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1818), 2,
      sym_case_statement,
      aux_sym_match_statement_repeat1,
  [38276] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(3014), 1,
      sym_string_content,
    ACTIONS(3018), 1,
      sym_line_comment,
    ACTIONS(3092), 1,
      anon_sym_DQUOTE,
    ACTIONS(3016), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(1803), 2,
      sym__escape_sequence,
      aux_sym__string_literal_repeat1,
  [38297] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(3018), 1,
      sym_line_comment,
    ACTIONS(3022), 1,
      sym_character_content,
    ACTIONS(3094), 1,
      anon_sym_SQUOTE,
    ACTIONS(3024), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(1769), 2,
      sym__escape_sequence,
      aux_sym_character_repeat1,
  [38318] = 6,
    ACTIONS(3010), 1,
      anon_sym_else,
    ACTIONS(3028), 1,
      anon_sym_elseif,
    ACTIONS(3096), 1,
      anon_sym_end,
    STATE(2368), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1826), 2,
      sym_elseiftype_block,
      aux_sym_iftype_statement_repeat1,
  [38339] = 6,
    ACTIONS(3008), 1,
      anon_sym_elseif,
    ACTIONS(3010), 1,
      anon_sym_else,
    ACTIONS(3098), 1,
      anon_sym_end,
    STATE(2200), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1790), 2,
      sym_elseif_block,
      aux_sym_if_statement_repeat1,
  [38360] = 6,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(3038), 1,
      anon_sym_PIPE,
    ACTIONS(3100), 1,
      anon_sym_end,
    STATE(2299), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1818), 2,
      sym_case_statement,
      aux_sym_match_statement_repeat1,
  [38381] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(3014), 1,
      sym_string_content,
    ACTIONS(3018), 1,
      sym_line_comment,
    ACTIONS(3102), 1,
      anon_sym_DQUOTE,
    ACTIONS(3016), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(1803), 2,
      sym__escape_sequence,
      aux_sym__string_literal_repeat1,
  [38402] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(3018), 1,
      sym_line_comment,
    ACTIONS(3104), 1,
      anon_sym_DQUOTE,
    ACTIONS(3106), 1,
      sym_string_content,
    ACTIONS(3108), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(1757), 2,
      sym__escape_sequence,
      aux_sym__string_literal_repeat1,
  [38423] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(3018), 1,
      sym_line_comment,
    ACTIONS(3110), 1,
      anon_sym_DQUOTE,
    ACTIONS(3112), 1,
      sym_string_content,
    ACTIONS(3114), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(1786), 2,
      sym__escape_sequence,
      aux_sym__string_literal_repeat1,
  [38444] = 6,
    ACTIONS(3010), 1,
      anon_sym_else,
    ACTIONS(3028), 1,
      anon_sym_elseif,
    ACTIONS(3116), 1,
      anon_sym_end,
    STATE(2429), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1792), 2,
      sym_elseiftype_block,
      aux_sym_iftype_statement_repeat1,
  [38465] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(3014), 1,
      sym_string_content,
    ACTIONS(3018), 1,
      sym_line_comment,
    ACTIONS(3118), 1,
      anon_sym_DQUOTE,
    ACTIONS(3016), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(1803), 2,
      sym__escape_sequence,
      aux_sym__string_literal_repeat1,
  [38486] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(3018), 1,
      sym_line_comment,
    ACTIONS(3120), 1,
      anon_sym_DQUOTE,
    ACTIONS(3122), 1,
      sym_string_content,
    ACTIONS(3124), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(1782), 2,
      sym__escape_sequence,
      aux_sym__string_literal_repeat1,
  [38507] = 6,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(3038), 1,
      anon_sym_PIPE,
    ACTIONS(3126), 1,
      anon_sym_end,
    STATE(2323), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1818), 2,
      sym_case_statement,
      aux_sym_match_statement_repeat1,
  [38528] = 7,
    ACTIONS(205), 1,
      anon_sym_if,
    ACTIONS(207), 1,
      anon_sym_ifdef,
    ACTIONS(1719), 1,
      anon_sym_PIPE,
    ACTIONS(1731), 1,
      anon_sym_EQ_GT,
    STATE(1810), 1,
      aux_sym_case_statement_repeat1,
    STATE(2254), 1,
      sym_if_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [38551] = 6,
    ACTIONS(3008), 1,
      anon_sym_elseif,
    ACTIONS(3010), 1,
      anon_sym_else,
    ACTIONS(3128), 1,
      anon_sym_end,
    STATE(2267), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1812), 2,
      sym_elseif_block,
      aux_sym_if_statement_repeat1,
  [38572] = 6,
    ACTIONS(3010), 1,
      anon_sym_else,
    ACTIONS(3028), 1,
      anon_sym_elseif,
    ACTIONS(3130), 1,
      anon_sym_end,
    STATE(2258), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1779), 2,
      sym_elseiftype_block,
      aux_sym_iftype_statement_repeat1,
  [38593] = 6,
    ACTIONS(3010), 1,
      anon_sym_else,
    ACTIONS(3028), 1,
      anon_sym_elseif,
    ACTIONS(3132), 1,
      anon_sym_end,
    STATE(2407), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1826), 2,
      sym_elseiftype_block,
      aux_sym_iftype_statement_repeat1,
  [38614] = 6,
    ACTIONS(3010), 1,
      anon_sym_else,
    ACTIONS(3028), 1,
      anon_sym_elseif,
    ACTIONS(3134), 1,
      anon_sym_end,
    STATE(2382), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1826), 2,
      sym_elseiftype_block,
      aux_sym_iftype_statement_repeat1,
  [38635] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(3018), 1,
      sym_line_comment,
    ACTIONS(3022), 1,
      sym_character_content,
    ACTIONS(3136), 1,
      anon_sym_SQUOTE,
    ACTIONS(3024), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(1769), 2,
      sym__escape_sequence,
      aux_sym_character_repeat1,
  [38656] = 6,
    ACTIONS(3008), 1,
      anon_sym_elseif,
    ACTIONS(3010), 1,
      anon_sym_else,
    ACTIONS(3138), 1,
      anon_sym_end,
    STATE(2470), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1768), 2,
      sym_elseif_block,
      aux_sym_if_statement_repeat1,
  [38677] = 6,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(3038), 1,
      anon_sym_PIPE,
    ACTIONS(3140), 1,
      anon_sym_end,
    STATE(2448), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1818), 2,
      sym_case_statement,
      aux_sym_match_statement_repeat1,
  [38698] = 6,
    ACTIONS(3008), 1,
      anon_sym_elseif,
    ACTIONS(3010), 1,
      anon_sym_else,
    ACTIONS(3142), 1,
      anon_sym_end,
    STATE(2245), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1812), 2,
      sym_elseif_block,
      aux_sym_if_statement_repeat1,
  [38719] = 6,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(3038), 1,
      anon_sym_PIPE,
    ACTIONS(3144), 1,
      anon_sym_end,
    STATE(2236), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1818), 2,
      sym_case_statement,
      aux_sym_match_statement_repeat1,
  [38740] = 6,
    ACTIONS(3010), 1,
      anon_sym_else,
    ACTIONS(3028), 1,
      anon_sym_elseif,
    ACTIONS(3146), 1,
      anon_sym_end,
    STATE(2322), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1793), 2,
      sym_elseiftype_block,
      aux_sym_iftype_statement_repeat1,
  [38761] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(3018), 1,
      sym_line_comment,
    ACTIONS(3022), 1,
      sym_character_content,
    ACTIONS(3148), 1,
      anon_sym_SQUOTE,
    ACTIONS(3024), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(1769), 2,
      sym__escape_sequence,
      aux_sym_character_repeat1,
  [38782] = 6,
    ACTIONS(3008), 1,
      anon_sym_elseif,
    ACTIONS(3010), 1,
      anon_sym_else,
    ACTIONS(3150), 1,
      anon_sym_end,
    STATE(2225), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1797), 2,
      sym_elseif_block,
      aux_sym_if_statement_repeat1,
  [38803] = 6,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(3038), 1,
      anon_sym_PIPE,
    ACTIONS(3152), 1,
      anon_sym_end,
    STATE(2463), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1818), 2,
      sym_case_statement,
      aux_sym_match_statement_repeat1,
  [38824] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(3018), 1,
      sym_line_comment,
    ACTIONS(3154), 1,
      anon_sym_DQUOTE,
    ACTIONS(3156), 1,
      sym_string_content,
    ACTIONS(3159), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(1803), 2,
      sym__escape_sequence,
      aux_sym__string_literal_repeat1,
  [38845] = 7,
    ACTIONS(205), 1,
      anon_sym_if,
    ACTIONS(207), 1,
      anon_sym_ifdef,
    ACTIONS(1719), 1,
      anon_sym_PIPE,
    ACTIONS(3162), 1,
      anon_sym_EQ_GT,
    STATE(1810), 1,
      aux_sym_case_statement_repeat1,
    STATE(2272), 1,
      sym_if_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [38868] = 6,
    ACTIONS(3164), 1,
      anon_sym_QMARK,
    ACTIONS(3166), 1,
      anon_sym_COLON,
    ACTIONS(3168), 1,
      anon_sym_EQ_GT,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    STATE(2005), 1,
      sym_lambda_captures,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [38888] = 6,
    ACTIONS(2726), 1,
      anon_sym_QMARK,
    ACTIONS(2728), 1,
      anon_sym_EQ_GT,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(3172), 1,
      anon_sym_COLON,
    STATE(1989), 1,
      sym_lambda_captures,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [38908] = 6,
    ACTIONS(1405), 1,
      anon_sym_where,
    ACTIONS(1737), 1,
      anon_sym_COMMA,
    ACTIONS(3174), 1,
      anon_sym_RPAREN,
    STATE(1868), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(2310), 1,
      sym_named_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [38928] = 6,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(3176), 1,
      anon_sym_end,
    ACTIONS(3178), 1,
      anon_sym_then,
    STATE(1959), 1,
      sym_else_block,
    STATE(2467), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [38948] = 6,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    ACTIONS(3180), 1,
      sym_identifier,
    STATE(2058), 1,
      sym_lambda_parameters,
    STATE(2187), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [38968] = 5,
    ACTIONS(1753), 1,
      anon_sym_if,
    ACTIONS(3182), 1,
      anon_sym_PIPE,
    STATE(1810), 1,
      aux_sym_case_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1751), 2,
      anon_sym_EQ_GT,
      anon_sym_ifdef,
  [38986] = 6,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(3185), 1,
      anon_sym_QMARK,
    ACTIONS(3187), 1,
      anon_sym_COLON,
    ACTIONS(3189), 1,
      anon_sym_EQ_GT,
    STATE(2004), 1,
      sym_lambda_captures,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39006] = 5,
    ACTIONS(3191), 1,
      anon_sym_end,
    ACTIONS(3193), 1,
      anon_sym_elseif,
    ACTIONS(3196), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1812), 2,
      sym_elseif_block,
      aux_sym_if_statement_repeat1,
  [39024] = 6,
    ACTIONS(2777), 1,
      anon_sym_QMARK,
    ACTIONS(2779), 1,
      anon_sym_EQ_GT,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(3198), 1,
      anon_sym_COLON,
    STATE(2015), 1,
      sym_lambda_captures,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39044] = 6,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    ACTIONS(3200), 1,
      sym_identifier,
    STATE(1952), 1,
      sym_lambda_parameters,
    STATE(2173), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39064] = 6,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(3202), 1,
      anon_sym_QMARK,
    ACTIONS(3204), 1,
      anon_sym_COLON,
    ACTIONS(3206), 1,
      anon_sym_EQ_GT,
    STATE(1990), 1,
      sym_lambda_captures,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39084] = 6,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(3178), 1,
      anon_sym_then,
    ACTIONS(3208), 1,
      anon_sym_end,
    STATE(2003), 1,
      sym_else_block,
    STATE(2384), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39104] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(3018), 1,
      sym_line_comment,
    ACTIONS(3210), 1,
      sym_character_content,
    ACTIONS(3212), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(1794), 2,
      sym__escape_sequence,
      aux_sym_character_repeat1,
  [39122] = 4,
    ACTIONS(3214), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3217), 2,
      anon_sym_end,
      anon_sym_else,
    STATE(1818), 2,
      sym_case_statement,
      aux_sym_match_statement_repeat1,
  [39138] = 6,
    ACTIONS(2855), 1,
      anon_sym_QMARK,
    ACTIONS(2857), 1,
      anon_sym_EQ_GT,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(3219), 1,
      anon_sym_COLON,
    STATE(1998), 1,
      sym_lambda_captures,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39158] = 6,
    ACTIONS(2761), 1,
      anon_sym_QMARK,
    ACTIONS(2763), 1,
      anon_sym_EQ_GT,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(3221), 1,
      anon_sym_COLON,
    STATE(2018), 1,
      sym_lambda_captures,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39178] = 6,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(3178), 1,
      anon_sym_then,
    ACTIONS(3223), 1,
      anon_sym_end,
    STATE(2091), 1,
      sym_else_block,
    STATE(2210), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39198] = 6,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(3225), 1,
      anon_sym_QMARK,
    ACTIONS(3227), 1,
      anon_sym_COLON,
    ACTIONS(3229), 1,
      anon_sym_EQ_GT,
    STATE(1923), 1,
      sym_lambda_captures,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39218] = 6,
    ACTIONS(2819), 1,
      anon_sym_QMARK,
    ACTIONS(2821), 1,
      anon_sym_EQ_GT,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(3231), 1,
      anon_sym_COLON,
    STATE(2049), 1,
      sym_lambda_captures,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39238] = 6,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    ACTIONS(3233), 1,
      sym_identifier,
    STATE(2095), 1,
      sym_lambda_parameters,
    STATE(2128), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39258] = 6,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_QMARK,
    ACTIONS(3237), 1,
      anon_sym_COLON,
    ACTIONS(3239), 1,
      anon_sym_EQ_GT,
    STATE(2024), 1,
      sym_lambda_captures,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39278] = 5,
    ACTIONS(3241), 1,
      anon_sym_end,
    ACTIONS(3243), 1,
      anon_sym_elseif,
    ACTIONS(3246), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1826), 2,
      sym_elseiftype_block,
      aux_sym_iftype_statement_repeat1,
  [39296] = 6,
    ACTIONS(2682), 1,
      anon_sym_QMARK,
    ACTIONS(2684), 1,
      anon_sym_EQ_GT,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(3248), 1,
      anon_sym_COLON,
    STATE(2011), 1,
      sym_lambda_captures,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39316] = 6,
    ACTIONS(2706), 1,
      anon_sym_QMARK,
    ACTIONS(2708), 1,
      anon_sym_EQ_GT,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(3250), 1,
      anon_sym_COLON,
    STATE(1983), 1,
      sym_lambda_captures,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39336] = 6,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(3178), 1,
      anon_sym_then,
    ACTIONS(3252), 1,
      anon_sym_end,
    STATE(2073), 1,
      sym_else_block,
    STATE(2231), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39356] = 6,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(3178), 1,
      anon_sym_then,
    ACTIONS(3254), 1,
      anon_sym_end,
    STATE(2094), 1,
      sym_else_block,
    STATE(2204), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39376] = 6,
    ACTIONS(1405), 1,
      anon_sym_where,
    ACTIONS(1737), 1,
      anon_sym_COMMA,
    ACTIONS(3256), 1,
      anon_sym_RPAREN,
    STATE(1868), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(2353), 1,
      sym_named_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39396] = 6,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    ACTIONS(3258), 1,
      sym_identifier,
    STATE(1979), 1,
      sym_lambda_parameters,
    STATE(2134), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39416] = 6,
    ACTIONS(1405), 1,
      anon_sym_where,
    ACTIONS(1737), 1,
      anon_sym_COMMA,
    ACTIONS(3260), 1,
      anon_sym_RPAREN,
    STATE(1868), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(2304), 1,
      sym_named_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39436] = 6,
    ACTIONS(2718), 1,
      anon_sym_QMARK,
    ACTIONS(2720), 1,
      anon_sym_EQ_GT,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(3262), 1,
      anon_sym_COLON,
    STATE(1985), 1,
      sym_lambda_captures,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39456] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(3018), 1,
      sym_line_comment,
    ACTIONS(3264), 1,
      sym_character_content,
    ACTIONS(3266), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(1778), 2,
      sym__escape_sequence,
      aux_sym_character_repeat1,
  [39474] = 6,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(3268), 1,
      anon_sym_QMARK,
    ACTIONS(3270), 1,
      anon_sym_COLON,
    ACTIONS(3272), 1,
      anon_sym_EQ_GT,
    STATE(2023), 1,
      sym_lambda_captures,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39494] = 6,
    ACTIONS(2843), 1,
      anon_sym_QMARK,
    ACTIONS(2845), 1,
      anon_sym_EQ_GT,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(3274), 1,
      anon_sym_COLON,
    STATE(1999), 1,
      sym_lambda_captures,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39514] = 6,
    ACTIONS(2745), 1,
      anon_sym_QMARK,
    ACTIONS(2747), 1,
      anon_sym_EQ_GT,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(3276), 1,
      anon_sym_COLON,
    STATE(2020), 1,
      sym_lambda_captures,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39534] = 6,
    ACTIONS(1759), 1,
      anon_sym_COMMA,
    ACTIONS(3278), 1,
      anon_sym_EQ,
    ACTIONS(3280), 1,
      anon_sym_COLON,
    ACTIONS(3282), 1,
      anon_sym_RPAREN,
    STATE(2081), 1,
      aux_sym_lambda_captures_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39554] = 6,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_QMARK,
    ACTIONS(3286), 1,
      anon_sym_COLON,
    ACTIONS(3288), 1,
      anon_sym_EQ_GT,
    STATE(1991), 1,
      sym_lambda_captures,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39574] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(3018), 1,
      sym_line_comment,
    ACTIONS(3290), 1,
      sym_character_content,
    ACTIONS(3292), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(1800), 2,
      sym__escape_sequence,
      aux_sym_character_repeat1,
  [39592] = 6,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(3178), 1,
      anon_sym_then,
    ACTIONS(3294), 1,
      anon_sym_end,
    STATE(2103), 1,
      sym_else_block,
    STATE(2193), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39612] = 6,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    ACTIONS(3296), 1,
      sym_identifier,
    STATE(2032), 1,
      sym_lambda_parameters,
    STATE(2164), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39632] = 6,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    ACTIONS(3298), 1,
      sym_identifier,
    STATE(2105), 1,
      sym_lambda_parameters,
    STATE(2141), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39652] = 6,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    ACTIONS(3300), 1,
      sym_identifier,
    STATE(2085), 1,
      sym_lambda_parameters,
    STATE(2188), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39672] = 6,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3304), 1,
      anon_sym_COLON,
    ACTIONS(3306), 1,
      anon_sym_EQ_GT,
    STATE(2010), 1,
      sym_lambda_captures,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39692] = 6,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    ACTIONS(3308), 1,
      sym_identifier,
    STATE(2025), 1,
      sym_lambda_parameters,
    STATE(2165), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39712] = 6,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    ACTIONS(3310), 1,
      sym_identifier,
    STATE(1984), 1,
      sym_lambda_parameters,
    STATE(2135), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39732] = 6,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    ACTIONS(3312), 1,
      sym_identifier,
    STATE(1966), 1,
      sym_lambda_parameters,
    STATE(2172), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39752] = 6,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(3178), 1,
      anon_sym_then,
    ACTIONS(3314), 1,
      anon_sym_end,
    STATE(1946), 1,
      sym_else_block,
    STATE(2475), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39772] = 6,
    ACTIONS(1405), 1,
      anon_sym_where,
    ACTIONS(1737), 1,
      anon_sym_COMMA,
    ACTIONS(3316), 1,
      anon_sym_RPAREN,
    STATE(1868), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(2446), 1,
      sym_named_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39792] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(3018), 1,
      sym_line_comment,
    ACTIONS(3318), 1,
      sym_character_content,
    ACTIONS(3320), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(1758), 2,
      sym__escape_sequence,
      aux_sym_character_repeat1,
  [39810] = 6,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(3178), 1,
      anon_sym_then,
    ACTIONS(3322), 1,
      anon_sym_end,
    STATE(1930), 1,
      sym_else_block,
    STATE(2492), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39830] = 6,
    ACTIONS(2610), 1,
      anon_sym_QMARK,
    ACTIONS(2612), 1,
      anon_sym_EQ_GT,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(3324), 1,
      anon_sym_COLON,
    STATE(2113), 1,
      sym_lambda_captures,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39850] = 6,
    ACTIONS(2789), 1,
      anon_sym_QMARK,
    ACTIONS(2791), 1,
      anon_sym_EQ_GT,
    ACTIONS(3170), 1,
      anon_sym_LPAREN,
    ACTIONS(3326), 1,
      anon_sym_COLON,
    STATE(2002), 1,
      sym_lambda_captures,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39870] = 5,
    ACTIONS(1433), 1,
      anon_sym_do,
    ACTIONS(3328), 1,
      anon_sym_COMMA,
    STATE(526), 1,
      sym_do_block,
    STATE(1883), 1,
      aux_sym_with_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39887] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1426), 1,
      sym_parameters,
    STATE(2148), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39904] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(2039), 1,
      sym_lambda_parameters,
    STATE(2162), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39921] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1446), 1,
      sym_parameters,
    STATE(2144), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39938] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1432), 1,
      sym_parameters,
    STATE(2166), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39955] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(1984), 1,
      sym_lambda_parameters,
    STATE(2135), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39972] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1436), 1,
      sym_parameters,
    STATE(2151), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [39989] = 5,
    ACTIONS(1364), 1,
      anon_sym_BSLASH,
    ACTIONS(3332), 1,
      sym_identifier,
    STATE(1911), 1,
      sym_with_elem,
    STATE(2179), 1,
      sym_annotation,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40006] = 4,
    ACTIONS(3334), 1,
      anon_sym_EQ,
    ACTIONS(3338), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3336), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [40021] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1527), 1,
      sym_parameters,
    STATE(2155), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40038] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1427), 1,
      sym_parameters,
    STATE(2174), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40055] = 5,
    ACTIONS(3340), 1,
      sym_identifier,
    ACTIONS(3342), 1,
      anon_sym_RPAREN,
    ACTIONS(3344), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1920), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40072] = 4,
    ACTIONS(3346), 1,
      anon_sym_COMMA,
    STATE(1868), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1769), 2,
      anon_sym_RPAREN,
      anon_sym_where,
  [40087] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(2025), 1,
      sym_lambda_parameters,
    STATE(2165), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40104] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1545), 1,
      sym_parameters,
    STATE(2149), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40121] = 5,
    ACTIONS(1427), 1,
      anon_sym_do,
    ACTIONS(3328), 1,
      anon_sym_COMMA,
    STATE(233), 1,
      sym_do_block,
    STATE(1940), 1,
      aux_sym_with_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40138] = 5,
    ACTIONS(1433), 1,
      anon_sym_do,
    ACTIONS(3328), 1,
      anon_sym_COMMA,
    STATE(546), 1,
      sym_do_block,
    STATE(1940), 1,
      aux_sym_with_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40155] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(2016), 1,
      sym_lambda_parameters,
    STATE(2177), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40172] = 5,
    ACTIONS(1427), 1,
      anon_sym_do,
    ACTIONS(3328), 1,
      anon_sym_COMMA,
    STATE(238), 1,
      sym_do_block,
    STATE(1896), 1,
      aux_sym_with_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40189] = 4,
    ACTIONS(3349), 1,
      anon_sym_COMMA,
    STATE(1875), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2522), 2,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [40204] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(1981), 1,
      sym_lambda_parameters,
    STATE(2170), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40221] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(1966), 1,
      sym_lambda_parameters,
    STATE(2172), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40238] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(1952), 1,
      sym_lambda_parameters,
    STATE(2173), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40255] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(2106), 1,
      sym_lambda_parameters,
    STATE(2152), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40272] = 5,
    ACTIONS(1364), 1,
      anon_sym_BSLASH,
    ACTIONS(3332), 1,
      sym_identifier,
    STATE(1893), 1,
      sym_with_elem,
    STATE(2186), 1,
      sym_annotation,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40289] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1466), 1,
      sym_parameters,
    STATE(2139), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40306] = 4,
    ACTIONS(3352), 1,
      anon_sym_EQ,
    ACTIONS(3354), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3356), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [40321] = 5,
    ACTIONS(1433), 1,
      anon_sym_do,
    ACTIONS(3328), 1,
      anon_sym_COMMA,
    STATE(557), 1,
      sym_do_block,
    STATE(1940), 1,
      aux_sym_with_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40338] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(2032), 1,
      sym_lambda_parameters,
    STATE(2164), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40355] = 5,
    ACTIONS(1433), 1,
      anon_sym_do,
    ACTIONS(3328), 1,
      anon_sym_COMMA,
    STATE(557), 1,
      sym_do_block,
    STATE(1872), 1,
      aux_sym_with_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40372] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1535), 1,
      sym_parameters,
    STATE(2158), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40389] = 5,
    ACTIONS(1364), 1,
      anon_sym_BSLASH,
    ACTIONS(3332), 1,
      sym_identifier,
    STATE(1856), 1,
      sym_with_elem,
    STATE(2185), 1,
      sym_annotation,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40406] = 5,
    ACTIONS(1417), 1,
      anon_sym_do,
    ACTIONS(3328), 1,
      anon_sym_COMMA,
    STATE(985), 1,
      sym_do_block,
    STATE(1903), 1,
      aux_sym_with_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40423] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1519), 1,
      sym_parameters,
    STATE(2122), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40440] = 5,
    ACTIONS(1417), 1,
      anon_sym_do,
    ACTIONS(3328), 1,
      anon_sym_COMMA,
    STATE(985), 1,
      sym_do_block,
    STATE(1940), 1,
      aux_sym_with_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40457] = 4,
    ACTIONS(3358), 1,
      anon_sym_EQ,
    ACTIONS(3360), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3362), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [40472] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1566), 1,
      sym_parameters,
    STATE(2123), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40489] = 5,
    ACTIONS(1435), 1,
      anon_sym_do,
    ACTIONS(3328), 1,
      anon_sym_COMMA,
    STATE(353), 1,
      sym_do_block,
    STATE(1909), 1,
      aux_sym_with_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40506] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(2058), 1,
      sym_lambda_parameters,
    STATE(2187), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40523] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(2095), 1,
      sym_lambda_parameters,
    STATE(2128), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40540] = 5,
    ACTIONS(1427), 1,
      anon_sym_do,
    ACTIONS(3328), 1,
      anon_sym_COMMA,
    STATE(269), 1,
      sym_do_block,
    STATE(1940), 1,
      aux_sym_with_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40557] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1538), 1,
      sym_parameters,
    STATE(2131), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40574] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1517), 1,
      sym_parameters,
    STATE(2133), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40591] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1549), 1,
      sym_parameters,
    STATE(2136), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40608] = 5,
    ACTIONS(1364), 1,
      anon_sym_BSLASH,
    ACTIONS(3332), 1,
      sym_identifier,
    STATE(1874), 1,
      sym_with_elem,
    STATE(2171), 1,
      sym_annotation,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40625] = 5,
    ACTIONS(1435), 1,
      anon_sym_do,
    ACTIONS(3328), 1,
      anon_sym_COMMA,
    STATE(408), 1,
      sym_do_block,
    STATE(1940), 1,
      aux_sym_with_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40642] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(1979), 1,
      sym_lambda_parameters,
    STATE(2134), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40659] = 5,
    ACTIONS(1417), 1,
      anon_sym_do,
    ACTIONS(3328), 1,
      anon_sym_COMMA,
    STATE(1011), 1,
      sym_do_block,
    STATE(1940), 1,
      aux_sym_with_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40676] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1440), 1,
      sym_parameters,
    STATE(2121), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40693] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1429), 1,
      sym_parameters,
    STATE(2120), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40710] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(2105), 1,
      sym_lambda_parameters,
    STATE(2141), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40727] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1435), 1,
      sym_parameters,
    STATE(2140), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40744] = 5,
    ACTIONS(1435), 1,
      anon_sym_do,
    ACTIONS(3328), 1,
      anon_sym_COMMA,
    STATE(351), 1,
      sym_do_block,
    STATE(1901), 1,
      aux_sym_with_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40761] = 5,
    ACTIONS(1435), 1,
      anon_sym_do,
    ACTIONS(3328), 1,
      anon_sym_COMMA,
    STATE(351), 1,
      sym_do_block,
    STATE(1940), 1,
      aux_sym_with_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40778] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1532), 1,
      sym_parameters,
    STATE(2145), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40795] = 5,
    ACTIONS(1417), 1,
      anon_sym_do,
    ACTIONS(3328), 1,
      anon_sym_COMMA,
    STATE(997), 1,
      sym_do_block,
    STATE(1890), 1,
      aux_sym_with_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40812] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(2041), 1,
      sym_lambda_parameters,
    STATE(2161), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40829] = 5,
    ACTIONS(1427), 1,
      anon_sym_do,
    ACTIONS(3328), 1,
      anon_sym_COMMA,
    STATE(269), 1,
      sym_do_block,
    STATE(1871), 1,
      aux_sym_with_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40846] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(2085), 1,
      sym_lambda_parameters,
    STATE(2188), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40863] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1461), 1,
      sym_parameters,
    STATE(2142), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40880] = 5,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1526), 1,
      sym_parameters,
    STATE(2147), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40897] = 4,
    ACTIONS(3364), 1,
      anon_sym_QMARK,
    ACTIONS(3366), 1,
      anon_sym_COLON,
    ACTIONS(3368), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40911] = 4,
    ACTIONS(3370), 1,
      anon_sym_QMARK,
    ACTIONS(3372), 1,
      anon_sym_COLON,
    ACTIONS(3374), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40925] = 3,
    ACTIONS(3378), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3376), 2,
      anon_sym_end,
      anon_sym_elseif,
  [40937] = 4,
    ACTIONS(3380), 1,
      anon_sym_COMMA,
    ACTIONS(3382), 1,
      anon_sym_RPAREN,
    STATE(2001), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40951] = 4,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(3386), 1,
      anon_sym_RPAREN,
    STATE(2012), 1,
      aux_sym_lambda_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40965] = 4,
    ACTIONS(3386), 1,
      anon_sym_RPAREN,
    ACTIONS(3388), 1,
      sym_identifier,
    STATE(2013), 1,
      sym_lambda_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40979] = 4,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3304), 1,
      anon_sym_COLON,
    ACTIONS(3306), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [40993] = 4,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(3386), 1,
      anon_sym_RPAREN,
    STATE(2028), 1,
      aux_sym_lambda_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41007] = 4,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(3390), 1,
      anon_sym_RPAREN,
    STATE(2028), 1,
      aux_sym_lambda_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41021] = 4,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(3392), 1,
      anon_sym_end,
    STATE(2331), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41035] = 4,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(3394), 1,
      anon_sym_RPAREN,
    STATE(1925), 1,
      aux_sym_lambda_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41049] = 4,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(3394), 1,
      anon_sym_RPAREN,
    STATE(2028), 1,
      aux_sym_lambda_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41063] = 4,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(3396), 1,
      anon_sym_RPAREN,
    STATE(2028), 1,
      aux_sym_lambda_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41077] = 4,
    ACTIONS(3178), 1,
      anon_sym_then,
    ACTIONS(3398), 1,
      anon_sym_end,
    STATE(2327), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41091] = 4,
    ACTIONS(3388), 1,
      sym_identifier,
    ACTIONS(3396), 1,
      anon_sym_RPAREN,
    STATE(1927), 1,
      sym_lambda_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41105] = 4,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(3396), 1,
      anon_sym_RPAREN,
    STATE(1928), 1,
      aux_sym_lambda_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41119] = 4,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(3400), 1,
      anon_sym_RPAREN,
    STATE(1929), 1,
      aux_sym_lambda_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41133] = 4,
    ACTIONS(3388), 1,
      sym_identifier,
    ACTIONS(3400), 1,
      anon_sym_RPAREN,
    STATE(1932), 1,
      sym_lambda_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41147] = 4,
    ACTIONS(3402), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3404), 1,
      sym__multiline_string_content,
    STATE(1936), 1,
      aux_sym__multiline_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41161] = 4,
    ACTIONS(3406), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3408), 1,
      sym__multiline_string_content,
    STATE(1942), 1,
      aux_sym__multiline_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41175] = 4,
    ACTIONS(3388), 1,
      sym_identifier,
    ACTIONS(3410), 1,
      anon_sym_RPAREN,
    STATE(1933), 1,
      sym_lambda_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41189] = 4,
    ACTIONS(1364), 1,
      anon_sym_BSLASH,
    ACTIONS(3412), 1,
      sym_identifier,
    STATE(2284), 1,
      sym_annotation,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41203] = 4,
    ACTIONS(3414), 1,
      sym_identifier,
    ACTIONS(3416), 1,
      anon_sym_LPAREN,
    STATE(2410), 1,
      sym_tuple_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41217] = 4,
    ACTIONS(3418), 1,
      anon_sym_COMMA,
    ACTIONS(3421), 1,
      anon_sym_do,
    STATE(1940), 1,
      aux_sym_with_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41231] = 4,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(3423), 1,
      anon_sym_RPAREN,
    STATE(2028), 1,
      aux_sym_lambda_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41245] = 4,
    ACTIONS(3425), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3427), 1,
      sym__multiline_string_content,
    STATE(1942), 1,
      aux_sym__multiline_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41259] = 4,
    ACTIONS(3430), 1,
      anon_sym_QMARK,
    ACTIONS(3432), 1,
      anon_sym_COLON,
    ACTIONS(3434), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41273] = 4,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(3436), 1,
      anon_sym_RPAREN,
    STATE(1941), 1,
      aux_sym_lambda_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41287] = 4,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(3436), 1,
      anon_sym_RPAREN,
    STATE(2028), 1,
      aux_sym_lambda_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41301] = 4,
    ACTIONS(3176), 1,
      anon_sym_end,
    ACTIONS(3178), 1,
      anon_sym_then,
    STATE(2467), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41315] = 4,
    ACTIONS(3438), 1,
      anon_sym_QMARK,
    ACTIONS(3440), 1,
      anon_sym_COLON,
    ACTIONS(3442), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41329] = 4,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(3444), 1,
      anon_sym_RPAREN,
    STATE(2028), 1,
      aux_sym_lambda_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41343] = 4,
    ACTIONS(1715), 1,
      anon_sym_EQ_GT,
    ACTIONS(2614), 1,
      anon_sym_then,
    STATE(1795), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41357] = 4,
    ACTIONS(3388), 1,
      sym_identifier,
    ACTIONS(3444), 1,
      anon_sym_RPAREN,
    STATE(1944), 1,
      sym_lambda_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41371] = 4,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(3444), 1,
      anon_sym_RPAREN,
    STATE(1945), 1,
      aux_sym_lambda_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41385] = 4,
    ACTIONS(3446), 1,
      anon_sym_QMARK,
    ACTIONS(3448), 1,
      anon_sym_COLON,
    ACTIONS(3450), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41399] = 4,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(3452), 1,
      anon_sym_RPAREN,
    STATE(1875), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41413] = 4,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(3454), 1,
      anon_sym_RPAREN,
    STATE(1948), 1,
      aux_sym_lambda_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41427] = 4,
    ACTIONS(3456), 1,
      anon_sym_QMARK,
    ACTIONS(3458), 1,
      anon_sym_COLON,
    ACTIONS(3460), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41441] = 4,
    ACTIONS(3388), 1,
      sym_identifier,
    ACTIONS(3454), 1,
      anon_sym_RPAREN,
    STATE(1951), 1,
      sym_lambda_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41455] = 4,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(3462), 1,
      anon_sym_end,
    STATE(2451), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41469] = 4,
    ACTIONS(3388), 1,
      sym_identifier,
    ACTIONS(3464), 1,
      anon_sym_RPAREN,
    STATE(1954), 1,
      sym_lambda_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41483] = 4,
    ACTIONS(3178), 1,
      anon_sym_then,
    ACTIONS(3466), 1,
      anon_sym_end,
    STATE(2450), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41497] = 4,
    ACTIONS(1364), 1,
      anon_sym_BSLASH,
    ACTIONS(3468), 1,
      sym_identifier,
    STATE(2271), 1,
      sym_annotation,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41511] = 4,
    ACTIONS(3416), 1,
      anon_sym_LPAREN,
    ACTIONS(3470), 1,
      sym_identifier,
    STATE(2378), 1,
      sym_tuple_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41525] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3472), 3,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACE,
  [41535] = 4,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(3474), 1,
      anon_sym_RBRACK,
    STATE(1875), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41549] = 4,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(3476), 1,
      anon_sym_RPAREN,
    STATE(1875), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41563] = 4,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(3478), 1,
      anon_sym_RPAREN,
    STATE(2028), 1,
      aux_sym_lambda_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41577] = 4,
    ACTIONS(3480), 1,
      anon_sym_QMARK,
    ACTIONS(3482), 1,
      anon_sym_COLON,
    ACTIONS(3484), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41591] = 4,
    ACTIONS(3486), 1,
      anon_sym_COMMA,
    ACTIONS(3488), 1,
      anon_sym_RPAREN,
    STATE(2035), 1,
      aux_sym_named_arguments_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41605] = 4,
    ACTIONS(3490), 1,
      anon_sym_QMARK,
    ACTIONS(3492), 1,
      anon_sym_COLON,
    ACTIONS(3494), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41619] = 4,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(3496), 1,
      anon_sym_RPAREN,
    STATE(1965), 1,
      aux_sym_lambda_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41633] = 4,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(3496), 1,
      anon_sym_RPAREN,
    STATE(2028), 1,
      aux_sym_lambda_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41647] = 4,
    ACTIONS(1737), 1,
      anon_sym_COMMA,
    ACTIONS(3498), 1,
      anon_sym_RPAREN,
    STATE(1868), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41661] = 4,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(3500), 1,
      anon_sym_RPAREN,
    STATE(2028), 1,
      aux_sym_lambda_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41675] = 3,
    ACTIONS(3504), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3502), 2,
      anon_sym_end,
      anon_sym_elseif,
  [41687] = 4,
    ACTIONS(3388), 1,
      sym_identifier,
    ACTIONS(3500), 1,
      anon_sym_RPAREN,
    STATE(1969), 1,
      sym_lambda_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41701] = 4,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(3500), 1,
      anon_sym_RPAREN,
    STATE(1970), 1,
      aux_sym_lambda_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41715] = 4,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(3506), 1,
      anon_sym_RPAREN,
    STATE(1972), 1,
      aux_sym_lambda_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41729] = 4,
    ACTIONS(3388), 1,
      sym_identifier,
    ACTIONS(3506), 1,
      anon_sym_RPAREN,
    STATE(1975), 1,
      sym_lambda_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41743] = 4,
    ACTIONS(3388), 1,
      sym_identifier,
    ACTIONS(3508), 1,
      anon_sym_RPAREN,
    STATE(1976), 1,
      sym_lambda_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41757] = 4,
    ACTIONS(3510), 1,
      anon_sym_QMARK,
    ACTIONS(3512), 1,
      anon_sym_COLON,
    ACTIONS(3514), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41771] = 4,
    ACTIONS(3516), 1,
      anon_sym_QMARK,
    ACTIONS(3518), 1,
      anon_sym_COLON,
    ACTIONS(3520), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41785] = 4,
    ACTIONS(3522), 1,
      anon_sym_QMARK,
    ACTIONS(3524), 1,
      anon_sym_COLON,
    ACTIONS(3526), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41799] = 4,
    ACTIONS(3416), 1,
      anon_sym_LPAREN,
    ACTIONS(3528), 1,
      sym_identifier,
    STATE(2328), 1,
      sym_tuple_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41813] = 4,
    ACTIONS(2698), 1,
      anon_sym_QMARK,
    ACTIONS(2700), 1,
      anon_sym_EQ_GT,
    ACTIONS(3530), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41827] = 4,
    ACTIONS(3532), 1,
      anon_sym_QMARK,
    ACTIONS(3534), 1,
      anon_sym_COLON,
    ACTIONS(3536), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41841] = 4,
    ACTIONS(2706), 1,
      anon_sym_QMARK,
    ACTIONS(2708), 1,
      anon_sym_EQ_GT,
    ACTIONS(3250), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41855] = 4,
    ACTIONS(3538), 1,
      anon_sym_RBRACK,
    ACTIONS(3540), 1,
      anon_sym_COMMA,
    STATE(1986), 1,
      aux_sym_generic_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41869] = 4,
    ACTIONS(3543), 1,
      anon_sym_QMARK,
    ACTIONS(3545), 1,
      anon_sym_COLON,
    ACTIONS(3547), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41883] = 4,
    ACTIONS(3549), 1,
      anon_sym_QMARK,
    ACTIONS(3551), 1,
      anon_sym_COLON,
    ACTIONS(3553), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41897] = 4,
    ACTIONS(2718), 1,
      anon_sym_QMARK,
    ACTIONS(2720), 1,
      anon_sym_EQ_GT,
    ACTIONS(3262), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41911] = 4,
    ACTIONS(2726), 1,
      anon_sym_QMARK,
    ACTIONS(2728), 1,
      anon_sym_EQ_GT,
    ACTIONS(3172), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41925] = 4,
    ACTIONS(3202), 1,
      anon_sym_QMARK,
    ACTIONS(3204), 1,
      anon_sym_COLON,
    ACTIONS(3206), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41939] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3555), 3,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACE,
  [41949] = 4,
    ACTIONS(3557), 1,
      anon_sym_QMARK,
    ACTIONS(3559), 1,
      anon_sym_COLON,
    ACTIONS(3561), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41963] = 4,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(3563), 1,
      anon_sym_RBRACK,
    STATE(1875), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41977] = 4,
    ACTIONS(3565), 1,
      sym_identifier,
    ACTIONS(3567), 1,
      anon_sym_RPAREN,
    STATE(1967), 1,
      sym_named_argument,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [41991] = 3,
    ACTIONS(3038), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1788), 2,
      sym_case_statement,
      aux_sym_match_statement_repeat1,
  [42003] = 4,
    ACTIONS(3569), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3571), 1,
      sym__multiline_string_content,
    STATE(2071), 1,
      aux_sym__multiline_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42017] = 4,
    ACTIONS(2863), 1,
      anon_sym_QMARK,
    ACTIONS(2865), 1,
      anon_sym_EQ_GT,
    ACTIONS(3573), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42031] = 4,
    ACTIONS(2855), 1,
      anon_sym_QMARK,
    ACTIONS(2857), 1,
      anon_sym_EQ_GT,
    ACTIONS(3219), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42045] = 4,
    ACTIONS(3340), 1,
      sym_identifier,
    ACTIONS(3344), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(2163), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42059] = 4,
    ACTIONS(3380), 1,
      anon_sym_COMMA,
    ACTIONS(3575), 1,
      anon_sym_RPAREN,
    STATE(2044), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42073] = 4,
    ACTIONS(2843), 1,
      anon_sym_QMARK,
    ACTIONS(2845), 1,
      anon_sym_EQ_GT,
    ACTIONS(3274), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42087] = 4,
    ACTIONS(3178), 1,
      anon_sym_then,
    ACTIONS(3322), 1,
      anon_sym_end,
    STATE(2492), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42101] = 4,
    ACTIONS(2789), 1,
      anon_sym_QMARK,
    ACTIONS(2791), 1,
      anon_sym_EQ_GT,
    ACTIONS(3326), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42115] = 4,
    ACTIONS(3185), 1,
      anon_sym_QMARK,
    ACTIONS(3187), 1,
      anon_sym_COLON,
    ACTIONS(3189), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42129] = 4,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(3577), 1,
      anon_sym_RPAREN,
    STATE(1924), 1,
      aux_sym_lambda_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42143] = 4,
    ACTIONS(3388), 1,
      sym_identifier,
    ACTIONS(3577), 1,
      anon_sym_RPAREN,
    STATE(1921), 1,
      sym_lambda_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42157] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3579), 3,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [42167] = 4,
    ACTIONS(3356), 1,
      anon_sym_RPAREN,
    ACTIONS(3581), 1,
      anon_sym_COMMA,
    STATE(2009), 1,
      aux_sym_lambda_captures_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42181] = 4,
    ACTIONS(2819), 1,
      anon_sym_QMARK,
    ACTIONS(2821), 1,
      anon_sym_EQ_GT,
    ACTIONS(3231), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42195] = 4,
    ACTIONS(2610), 1,
      anon_sym_QMARK,
    ACTIONS(2612), 1,
      anon_sym_EQ_GT,
    ACTIONS(3324), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42209] = 4,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(3584), 1,
      anon_sym_RPAREN,
    STATE(2028), 1,
      aux_sym_lambda_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42223] = 4,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(3584), 1,
      anon_sym_RPAREN,
    STATE(2050), 1,
      aux_sym_lambda_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42237] = 4,
    ACTIONS(1737), 1,
      anon_sym_COMMA,
    ACTIONS(3586), 1,
      anon_sym_RPAREN,
    STATE(1868), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42251] = 4,
    ACTIONS(2616), 1,
      anon_sym_QMARK,
    ACTIONS(2618), 1,
      anon_sym_EQ_GT,
    ACTIONS(3588), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42265] = 4,
    ACTIONS(3590), 1,
      anon_sym_QMARK,
    ACTIONS(3592), 1,
      anon_sym_COLON,
    ACTIONS(3594), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42279] = 4,
    ACTIONS(3596), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3598), 1,
      sym__multiline_string_content,
    STATE(2019), 1,
      aux_sym__multiline_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42293] = 4,
    ACTIONS(2777), 1,
      anon_sym_QMARK,
    ACTIONS(2779), 1,
      anon_sym_EQ_GT,
    ACTIONS(3198), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42307] = 4,
    ACTIONS(3408), 1,
      sym__multiline_string_content,
    ACTIONS(3600), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(1942), 1,
      aux_sym__multiline_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42321] = 4,
    ACTIONS(2761), 1,
      anon_sym_QMARK,
    ACTIONS(2763), 1,
      anon_sym_EQ_GT,
    ACTIONS(3221), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42335] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3602), 3,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [42345] = 4,
    ACTIONS(3604), 1,
      anon_sym_QMARK,
    ACTIONS(3606), 1,
      anon_sym_COLON,
    ACTIONS(3608), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42359] = 4,
    ACTIONS(2745), 1,
      anon_sym_QMARK,
    ACTIONS(2747), 1,
      anon_sym_EQ_GT,
    ACTIONS(3276), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42373] = 4,
    ACTIONS(3268), 1,
      anon_sym_QMARK,
    ACTIONS(3270), 1,
      anon_sym_COLON,
    ACTIONS(3272), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42387] = 4,
    ACTIONS(3610), 1,
      anon_sym_QMARK,
    ACTIONS(3612), 1,
      anon_sym_COLON,
    ACTIONS(3614), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42401] = 4,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(3616), 1,
      anon_sym_RPAREN,
    STATE(1875), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42415] = 4,
    ACTIONS(3618), 1,
      anon_sym_BSLASH,
    ACTIONS(3620), 1,
      anon_sym_COMMA,
    STATE(2027), 1,
      aux_sym_annotation_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42429] = 4,
    ACTIONS(3623), 1,
      anon_sym_COMMA,
    ACTIONS(3626), 1,
      anon_sym_RPAREN,
    STATE(2028), 1,
      aux_sym_lambda_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42443] = 4,
    ACTIONS(1934), 1,
      anon_sym_LBRACK,
    ACTIONS(3628), 1,
      anon_sym_is,
    STATE(2213), 1,
      sym_generic_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42457] = 4,
    ACTIONS(3630), 1,
      anon_sym_QMARK,
    ACTIONS(3632), 1,
      anon_sym_COLON,
    ACTIONS(3634), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42471] = 4,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(3636), 1,
      anon_sym_RBRACK,
    STATE(1875), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42485] = 4,
    ACTIONS(3638), 1,
      anon_sym_QMARK,
    ACTIONS(3640), 1,
      anon_sym_COLON,
    ACTIONS(3642), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42499] = 4,
    ACTIONS(1731), 1,
      anon_sym_EQ_GT,
    ACTIONS(2614), 1,
      anon_sym_then,
    STATE(1795), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42513] = 4,
    ACTIONS(3644), 1,
      anon_sym_QMARK,
    ACTIONS(3646), 1,
      anon_sym_COLON,
    ACTIONS(3648), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42527] = 4,
    ACTIONS(3486), 1,
      anon_sym_COMMA,
    ACTIONS(3650), 1,
      anon_sym_RPAREN,
    STATE(2057), 1,
      aux_sym_named_arguments_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42541] = 3,
    ACTIONS(3654), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3652), 2,
      anon_sym_end,
      anon_sym_elseif,
  [42553] = 4,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(3656), 1,
      anon_sym_RPAREN,
    STATE(1875), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42567] = 4,
    ACTIONS(3658), 1,
      anon_sym_QMARK,
    ACTIONS(3660), 1,
      anon_sym_COLON,
    ACTIONS(3662), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42581] = 4,
    ACTIONS(3664), 1,
      anon_sym_QMARK,
    ACTIONS(3666), 1,
      anon_sym_COLON,
    ACTIONS(3668), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42595] = 4,
    ACTIONS(3670), 1,
      anon_sym_QMARK,
    ACTIONS(3672), 1,
      anon_sym_COLON,
    ACTIONS(3674), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42609] = 4,
    ACTIONS(3676), 1,
      anon_sym_QMARK,
    ACTIONS(3678), 1,
      anon_sym_COLON,
    ACTIONS(3680), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42623] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3682), 3,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACE,
  [42633] = 4,
    ACTIONS(1737), 1,
      anon_sym_COMMA,
    ACTIONS(3684), 1,
      anon_sym_RPAREN,
    STATE(1868), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42647] = 4,
    ACTIONS(3686), 1,
      anon_sym_COMMA,
    ACTIONS(3689), 1,
      anon_sym_RPAREN,
    STATE(2044), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42661] = 4,
    ACTIONS(3691), 1,
      anon_sym_QMARK,
    ACTIONS(3693), 1,
      anon_sym_COLON,
    ACTIONS(3695), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42675] = 4,
    ACTIONS(3697), 1,
      anon_sym_RBRACK,
    ACTIONS(3699), 1,
      anon_sym_COMMA,
    STATE(1986), 1,
      aux_sym_generic_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42689] = 4,
    ACTIONS(3701), 1,
      anon_sym_QMARK,
    ACTIONS(3703), 1,
      anon_sym_COLON,
    ACTIONS(3705), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42703] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3707), 3,
      anon_sym_PIPE,
      anon_sym_end,
      anon_sym_else,
  [42713] = 4,
    ACTIONS(2682), 1,
      anon_sym_QMARK,
    ACTIONS(2684), 1,
      anon_sym_EQ_GT,
    ACTIONS(3248), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42727] = 4,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(3709), 1,
      anon_sym_RPAREN,
    STATE(2028), 1,
      aux_sym_lambda_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42741] = 3,
    ACTIONS(3038), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1764), 2,
      sym_case_statement,
      aux_sym_match_statement_repeat1,
  [42753] = 4,
    ACTIONS(3711), 1,
      anon_sym_QMARK,
    ACTIONS(3713), 1,
      anon_sym_COLON,
    ACTIONS(3715), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42767] = 4,
    ACTIONS(3388), 1,
      sym_identifier,
    ACTIONS(3717), 1,
      anon_sym_RPAREN,
    STATE(2006), 1,
      sym_lambda_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42781] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3719), 3,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [42791] = 3,
    ACTIONS(3038), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1796), 2,
      sym_case_statement,
      aux_sym_match_statement_repeat1,
  [42803] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3721), 3,
      anon_sym_PIPE,
      anon_sym_end,
      anon_sym_else,
  [42813] = 4,
    ACTIONS(3723), 1,
      anon_sym_COMMA,
    ACTIONS(3726), 1,
      anon_sym_RPAREN,
    STATE(2057), 1,
      aux_sym_named_arguments_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42827] = 4,
    ACTIONS(3728), 1,
      anon_sym_QMARK,
    ACTIONS(3730), 1,
      anon_sym_COLON,
    ACTIONS(3732), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42841] = 3,
    ACTIONS(3736), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3734), 2,
      anon_sym_end,
      anon_sym_elseif,
  [42853] = 4,
    ACTIONS(3738), 1,
      anon_sym_QMARK,
    ACTIONS(3740), 1,
      anon_sym_COLON,
    ACTIONS(3742), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42867] = 3,
    ACTIONS(3038), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1802), 2,
      sym_case_statement,
      aux_sym_match_statement_repeat1,
  [42879] = 4,
    ACTIONS(3744), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3746), 1,
      sym__multiline_string_content,
    STATE(2064), 1,
      aux_sym__multiline_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42893] = 3,
    ACTIONS(3750), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3748), 2,
      anon_sym_end,
      anon_sym_elseif,
  [42905] = 4,
    ACTIONS(3408), 1,
      sym__multiline_string_content,
    ACTIONS(3752), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(1942), 1,
      aux_sym__multiline_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42919] = 4,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(3754), 1,
      anon_sym_RBRACK,
    STATE(1875), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42933] = 4,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(3756), 1,
      anon_sym_RBRACK,
    STATE(1875), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42947] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3758), 3,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [42957] = 4,
    ACTIONS(3760), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3762), 1,
      sym__multiline_string_content,
    STATE(2070), 1,
      aux_sym__multiline_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42971] = 3,
    ACTIONS(3766), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3764), 2,
      anon_sym_end,
      anon_sym_elseif,
  [42983] = 4,
    ACTIONS(3408), 1,
      sym__multiline_string_content,
    ACTIONS(3768), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(1942), 1,
      aux_sym__multiline_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [42997] = 4,
    ACTIONS(3408), 1,
      sym__multiline_string_content,
    ACTIONS(3770), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(1942), 1,
      aux_sym__multiline_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43011] = 4,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(3772), 1,
      anon_sym_RBRACK,
    STATE(1875), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43025] = 4,
    ACTIONS(3178), 1,
      anon_sym_then,
    ACTIONS(3774), 1,
      anon_sym_end,
    STATE(2337), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43039] = 4,
    ACTIONS(3776), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3778), 1,
      sym__multiline_string_content,
    STATE(2076), 1,
      aux_sym__multiline_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43053] = 4,
    ACTIONS(3699), 1,
      anon_sym_COMMA,
    ACTIONS(3780), 1,
      anon_sym_RBRACK,
    STATE(2046), 1,
      aux_sym_generic_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43067] = 4,
    ACTIONS(3408), 1,
      sym__multiline_string_content,
    ACTIONS(3782), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(1942), 1,
      aux_sym__multiline_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43081] = 4,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(3784), 1,
      anon_sym_end,
    STATE(2318), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43095] = 4,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(3786), 1,
      anon_sym_RBRACK,
    STATE(1875), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43109] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3788), 3,
      anon_sym_PIPE,
      anon_sym_end,
      anon_sym_else,
  [43119] = 4,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(3790), 1,
      anon_sym_RBRACK,
    STATE(1875), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43133] = 4,
    ACTIONS(1759), 1,
      anon_sym_COMMA,
    ACTIONS(3792), 1,
      anon_sym_RPAREN,
    STATE(2009), 1,
      aux_sym_lambda_captures_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43147] = 4,
    ACTIONS(3794), 1,
      anon_sym_QMARK,
    ACTIONS(3796), 1,
      anon_sym_COLON,
    ACTIONS(3798), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43161] = 4,
    ACTIONS(3800), 1,
      anon_sym_BSLASH,
    ACTIONS(3802), 1,
      anon_sym_COMMA,
    STATE(2027), 1,
      aux_sym_annotation_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43175] = 4,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(3804), 1,
      anon_sym_RPAREN,
    STATE(1875), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43189] = 4,
    ACTIONS(3806), 1,
      anon_sym_QMARK,
    ACTIONS(3808), 1,
      anon_sym_COLON,
    ACTIONS(3810), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43203] = 4,
    ACTIONS(1759), 1,
      anon_sym_COMMA,
    ACTIONS(3812), 1,
      anon_sym_RPAREN,
    STATE(2009), 1,
      aux_sym_lambda_captures_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43217] = 4,
    ACTIONS(3814), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3816), 1,
      sym__multiline_string_content,
    STATE(2088), 1,
      aux_sym__multiline_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43231] = 4,
    ACTIONS(3408), 1,
      sym__multiline_string_content,
    ACTIONS(3818), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(1942), 1,
      aux_sym__multiline_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43245] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3820), 3,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [43255] = 4,
    ACTIONS(3822), 1,
      anon_sym_QMARK,
    ACTIONS(3824), 1,
      anon_sym_COLON,
    ACTIONS(3826), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43269] = 4,
    ACTIONS(3178), 1,
      anon_sym_then,
    ACTIONS(3252), 1,
      anon_sym_end,
    STATE(2231), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43283] = 3,
    ACTIONS(3038), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1776), 2,
      sym_case_statement,
      aux_sym_match_statement_repeat1,
  [43295] = 4,
    ACTIONS(3802), 1,
      anon_sym_COMMA,
    ACTIONS(3828), 1,
      anon_sym_BSLASH,
    STATE(2083), 1,
      aux_sym_annotation_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43309] = 4,
    ACTIONS(3178), 1,
      anon_sym_then,
    ACTIONS(3294), 1,
      anon_sym_end,
    STATE(2193), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43323] = 4,
    ACTIONS(3830), 1,
      anon_sym_QMARK,
    ACTIONS(3832), 1,
      anon_sym_COLON,
    ACTIONS(3834), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43337] = 3,
    ACTIONS(3038), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1798), 2,
      sym_case_statement,
      aux_sym_match_statement_repeat1,
  [43349] = 4,
    ACTIONS(1759), 1,
      anon_sym_COMMA,
    ACTIONS(3836), 1,
      anon_sym_RPAREN,
    STATE(2009), 1,
      aux_sym_lambda_captures_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43363] = 3,
    ACTIONS(3038), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1762), 2,
      sym_case_statement,
      aux_sym_match_statement_repeat1,
  [43375] = 4,
    ACTIONS(3838), 1,
      anon_sym_QMARK,
    ACTIONS(3840), 1,
      anon_sym_COLON,
    ACTIONS(3842), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43389] = 4,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(3844), 1,
      anon_sym_RPAREN,
    STATE(1875), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43403] = 4,
    ACTIONS(3846), 1,
      anon_sym_QMARK,
    ACTIONS(3848), 1,
      anon_sym_COLON,
    ACTIONS(3850), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43417] = 4,
    ACTIONS(1765), 1,
      anon_sym_else,
    ACTIONS(3852), 1,
      anon_sym_end,
    STATE(2294), 1,
      sym_else_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43431] = 4,
    ACTIONS(3178), 1,
      anon_sym_then,
    ACTIONS(3854), 1,
      anon_sym_end,
    STATE(2295), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43445] = 4,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(3856), 1,
      anon_sym_RBRACK,
    STATE(1875), 1,
      aux_sym_type_args_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43459] = 4,
    ACTIONS(3858), 1,
      anon_sym_QMARK,
    ACTIONS(3860), 1,
      anon_sym_COLON,
    ACTIONS(3862), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43473] = 4,
    ACTIONS(3864), 1,
      anon_sym_QMARK,
    ACTIONS(3866), 1,
      anon_sym_COLON,
    ACTIONS(3868), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43487] = 4,
    ACTIONS(3870), 1,
      anon_sym_QMARK,
    ACTIONS(3872), 1,
      anon_sym_COLON,
    ACTIONS(3874), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43501] = 4,
    ACTIONS(1737), 1,
      anon_sym_COMMA,
    ACTIONS(3876), 1,
      anon_sym_RPAREN,
    STATE(1868), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43515] = 4,
    ACTIONS(3878), 1,
      anon_sym_QMARK,
    ACTIONS(3880), 1,
      anon_sym_COLON,
    ACTIONS(3882), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43529] = 4,
    ACTIONS(3408), 1,
      sym__multiline_string_content,
    ACTIONS(3884), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(1942), 1,
      aux_sym__multiline_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43543] = 4,
    ACTIONS(3886), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3888), 1,
      sym__multiline_string_content,
    STATE(2110), 1,
      aux_sym__multiline_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43557] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3890), 3,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [43567] = 4,
    ACTIONS(2722), 1,
      anon_sym_QMARK,
    ACTIONS(2724), 1,
      anon_sym_EQ_GT,
    ACTIONS(3892), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43581] = 4,
    ACTIONS(3416), 1,
      anon_sym_LPAREN,
    ACTIONS(3894), 1,
      sym_identifier,
    STATE(2268), 1,
      sym_tuple_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43595] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3896), 3,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [43605] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3898), 3,
      anon_sym_PIPE,
      anon_sym_end,
      anon_sym_else,
  [43615] = 3,
    ACTIONS(3038), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1781), 2,
      sym_case_statement,
      aux_sym_match_statement_repeat1,
  [43627] = 3,
    ACTIONS(3900), 1,
      sym_identifier,
    STATE(2075), 1,
      sym_generic_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43638] = 3,
    ACTIONS(2614), 1,
      anon_sym_then,
    STATE(1795), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43649] = 3,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1432), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43660] = 3,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1435), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43671] = 3,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1517), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43682] = 3,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1549), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43693] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3902), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [43702] = 3,
    ACTIONS(3904), 1,
      sym_identifier,
    ACTIONS(3906), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43713] = 3,
    ACTIONS(3388), 1,
      sym_identifier,
    STATE(2150), 1,
      sym_lambda_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43724] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3908), 2,
      anon_sym_end,
      anon_sym_then,
  [43733] = 3,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(2109), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43744] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3910), 2,
      anon_sym_COMMA,
      anon_sym_do,
  [43753] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3421), 2,
      anon_sym_COMMA,
      anon_sym_do,
  [43762] = 3,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1532), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43773] = 3,
    ACTIONS(2614), 1,
      anon_sym_then,
    STATE(2036), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43784] = 3,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1526), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43795] = 3,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(2040), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43806] = 3,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(1988), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43817] = 3,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1545), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43828] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3538), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [43837] = 3,
    ACTIONS(3332), 1,
      sym_identifier,
    STATE(2130), 1,
      sym_with_elem,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43848] = 3,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1461), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43859] = 3,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1442), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43870] = 3,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(2107), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43881] = 3,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1458), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43892] = 3,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1514), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43903] = 3,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1466), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43914] = 3,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1530), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43925] = 3,
    ACTIONS(3912), 1,
      sym_identifier,
    ACTIONS(3914), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43936] = 3,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1527), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43947] = 3,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1429), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43958] = 3,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1541), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43969] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3626), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [43978] = 3,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1440), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [43989] = 3,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(1918), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44000] = 3,
    ACTIONS(3916), 1,
      sym_identifier,
    ACTIONS(3918), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44011] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3920), 2,
      anon_sym_end,
      anon_sym_then,
  [44020] = 3,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1528), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44031] = 3,
    ACTIONS(2584), 1,
      anon_sym_AT,
    ACTIONS(3922), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44042] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3618), 2,
      anon_sym_BSLASH,
      anon_sym_COMMA,
  [44051] = 3,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1538), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44062] = 3,
    ACTIONS(3565), 1,
      sym_identifier,
    STATE(2175), 1,
      sym_named_argument,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44073] = 3,
    ACTIONS(2614), 1,
      anon_sym_then,
    STATE(2059), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44084] = 3,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(2060), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44095] = 3,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(2047), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44106] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3689), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [44115] = 3,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(2038), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44126] = 3,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(2034), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44137] = 3,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1427), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44148] = 3,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(2030), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44159] = 3,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(1947), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44170] = 3,
    ACTIONS(3900), 1,
      sym_identifier,
    STATE(2137), 1,
      sym_generic_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44181] = 3,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(1993), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44192] = 3,
    ACTIONS(3332), 1,
      sym_identifier,
    STATE(1913), 1,
      sym_with_elem,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44203] = 3,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(1980), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44214] = 3,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(1968), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44225] = 3,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
    STATE(1433), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44236] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3726), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [44245] = 3,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(1955), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44256] = 3,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(1987), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44267] = 3,
    ACTIONS(2614), 1,
      anon_sym_then,
    STATE(1756), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44278] = 3,
    ACTIONS(3332), 1,
      sym_identifier,
    STATE(1888), 1,
      sym_with_elem,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44289] = 3,
    ACTIONS(2614), 1,
      anon_sym_then,
    STATE(1801), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44300] = 3,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(2101), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44311] = 3,
    ACTIONS(2614), 1,
      anon_sym_then,
    STATE(1780), 1,
      sym_then_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44322] = 3,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(2082), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44333] = 3,
    ACTIONS(2636), 1,
      anon_sym_AT,
    ACTIONS(3924), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44344] = 3,
    ACTIONS(3332), 1,
      sym_identifier,
    STATE(1885), 1,
      sym_with_elem,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44355] = 3,
    ACTIONS(3332), 1,
      sym_identifier,
    STATE(1908), 1,
      sym_with_elem,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44366] = 3,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(1917), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44377] = 3,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(2052), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44388] = 2,
    ACTIONS(3926), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44396] = 2,
    ACTIONS(3912), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44404] = 2,
    ACTIONS(3928), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44412] = 2,
    ACTIONS(3930), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44420] = 2,
    ACTIONS(3854), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44428] = 2,
    ACTIONS(2704), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44436] = 2,
    ACTIONS(3932), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44444] = 2,
    ACTIONS(3834), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44452] = 2,
    ACTIONS(3934), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44460] = 2,
    ACTIONS(2360), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44468] = 2,
    ACTIONS(3936), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44476] = 2,
    ACTIONS(3128), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44484] = 2,
    ACTIONS(3938), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44492] = 2,
    ACTIONS(2130), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44500] = 2,
    ACTIONS(3940), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44508] = 2,
    ACTIONS(3294), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44516] = 2,
    ACTIONS(3942), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44524] = 2,
    ACTIONS(3944), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44532] = 2,
    ACTIONS(3946), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44540] = 2,
    ACTIONS(3948), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44548] = 2,
    ACTIONS(3950), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44556] = 2,
    ACTIONS(3252), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44564] = 2,
    ACTIONS(2356), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44572] = 2,
    ACTIONS(3952), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44580] = 2,
    ACTIONS(3954), 1,
      anon_sym_is,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44588] = 2,
    ACTIONS(3956), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44596] = 2,
    ACTIONS(3958), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44604] = 2,
    ACTIONS(3960), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44612] = 2,
    ACTIONS(2678), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44620] = 2,
    ACTIONS(3962), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44628] = 2,
    ACTIONS(3964), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44636] = 2,
    ACTIONS(3966), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44644] = 2,
    ACTIONS(2612), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44652] = 2,
    ACTIONS(2134), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44660] = 2,
    ACTIONS(3968), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44668] = 2,
    ACTIONS(3970), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44676] = 2,
    ACTIONS(3142), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44684] = 2,
    ACTIONS(3972), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44692] = 2,
    ACTIONS(3810), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44700] = 2,
    ACTIONS(3924), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44708] = 2,
    ACTIONS(3974), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44716] = 2,
    ACTIONS(3976), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44724] = 2,
    ACTIONS(3774), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44732] = 2,
    ACTIONS(3978), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44740] = 2,
    ACTIONS(3980), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44748] = 2,
    ACTIONS(3982), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44756] = 2,
    ACTIONS(3984), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44764] = 2,
    ACTIONS(3090), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44772] = 2,
    ACTIONS(2128), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44780] = 2,
    ACTIONS(3986), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44788] = 2,
    ACTIONS(3988), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44796] = 2,
    ACTIONS(3990), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44804] = 2,
    ACTIONS(3992), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44812] = 2,
    ACTIONS(3994), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44820] = 2,
    ACTIONS(3996), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44828] = 2,
    ACTIONS(3998), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44836] = 2,
    ACTIONS(4000), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44844] = 2,
    ACTIONS(4002), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44852] = 2,
    ACTIONS(4004), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44860] = 2,
    ACTIONS(4006), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44868] = 2,
    ACTIONS(4008), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44876] = 2,
    ACTIONS(4010), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44884] = 2,
    ACTIONS(2146), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44892] = 2,
    ACTIONS(4012), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44900] = 2,
    ACTIONS(4014), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44908] = 2,
    ACTIONS(3162), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44916] = 2,
    ACTIONS(1797), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44924] = 2,
    ACTIONS(4016), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44932] = 2,
    ACTIONS(4018), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44940] = 2,
    ACTIONS(3096), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44948] = 2,
    ACTIONS(4020), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44956] = 2,
    ACTIONS(4022), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44964] = 2,
    ACTIONS(4024), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44972] = 2,
    ACTIONS(4026), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44980] = 2,
    ACTIONS(4028), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44988] = 2,
    ACTIONS(4030), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [44996] = 2,
    ACTIONS(2907), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45004] = 2,
    ACTIONS(4032), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45012] = 2,
    ACTIONS(4034), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45020] = 2,
    ACTIONS(4036), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45028] = 2,
    ACTIONS(4038), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45036] = 2,
    ACTIONS(3862), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45044] = 2,
    ACTIONS(4040), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45052] = 2,
    ACTIONS(4042), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45060] = 2,
    ACTIONS(4044), 1,
      anon_sym_until,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45068] = 2,
    ACTIONS(4046), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45076] = 2,
    ACTIONS(4048), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45084] = 2,
    ACTIONS(3732), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45092] = 2,
    ACTIONS(4050), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45100] = 2,
    ACTIONS(4052), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45108] = 2,
    ACTIONS(4054), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45116] = 2,
    ACTIONS(2684), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45124] = 2,
    ACTIONS(4056), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45132] = 2,
    ACTIONS(4058), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45140] = 2,
    ACTIONS(4060), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45148] = 2,
    ACTIONS(4062), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45156] = 2,
    ACTIONS(2364), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45164] = 2,
    ACTIONS(4064), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45172] = 2,
    ACTIONS(3680), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45180] = 2,
    ACTIONS(4066), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45188] = 2,
    ACTIONS(4068), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45196] = 2,
    ACTIONS(4070), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45204] = 2,
    ACTIONS(4072), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45212] = 2,
    ACTIONS(4074), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45220] = 2,
    ACTIONS(4076), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45228] = 2,
    ACTIONS(4078), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45236] = 2,
    ACTIONS(4080), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45244] = 2,
    ACTIONS(4082), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45252] = 2,
    ACTIONS(1767), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45260] = 2,
    ACTIONS(4084), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45268] = 2,
    ACTIONS(4086), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45276] = 2,
    ACTIONS(4088), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45284] = 2,
    ACTIONS(4090), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45292] = 2,
    ACTIONS(4092), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45300] = 2,
    ACTIONS(4094), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45308] = 2,
    ACTIONS(4096), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45316] = 2,
    ACTIONS(4098), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45324] = 2,
    ACTIONS(4100), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45332] = 2,
    ACTIONS(4102), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45340] = 2,
    ACTIONS(3668), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45348] = 2,
    ACTIONS(3868), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45356] = 2,
    ACTIONS(4104), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45364] = 2,
    ACTIONS(4106), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45372] = 2,
    ACTIONS(4108), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45380] = 2,
    ACTIONS(4110), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45388] = 2,
    ACTIONS(4112), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45396] = 2,
    ACTIONS(1731), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45404] = 2,
    ACTIONS(4114), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45412] = 2,
    ACTIONS(4116), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45420] = 2,
    ACTIONS(4118), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45428] = 2,
    ACTIONS(4120), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45436] = 2,
    ACTIONS(3922), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45444] = 2,
    ACTIONS(4122), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45452] = 2,
    ACTIONS(3134), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45460] = 2,
    ACTIONS(4124), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45468] = 2,
    ACTIONS(4126), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45476] = 2,
    ACTIONS(1775), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45484] = 2,
    ACTIONS(4128), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45492] = 2,
    ACTIONS(4130), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45500] = 2,
    ACTIONS(4132), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45508] = 2,
    ACTIONS(4134), 1,
      anon_sym_until,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45516] = 2,
    ACTIONS(3642), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45524] = 2,
    ACTIONS(4136), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45532] = 2,
    ACTIONS(4138), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45540] = 2,
    ACTIONS(3916), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45548] = 2,
    ACTIONS(1763), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45556] = 2,
    ACTIONS(4140), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45564] = 2,
    ACTIONS(3614), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45572] = 2,
    ACTIONS(4142), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45580] = 2,
    ACTIONS(4144), 1,
      anon_sym_until,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45588] = 2,
    ACTIONS(4146), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45596] = 2,
    ACTIONS(4148), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45604] = 2,
    ACTIONS(3272), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45612] = 2,
    ACTIONS(4150), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45620] = 2,
    ACTIONS(2747), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45628] = 2,
    ACTIONS(4152), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45636] = 2,
    ACTIONS(4154), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45644] = 2,
    ACTIONS(4156), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45652] = 2,
    ACTIONS(4158), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45660] = 2,
    ACTIONS(2763), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45668] = 2,
    ACTIONS(4160), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45676] = 2,
    ACTIONS(4162), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45684] = 2,
    ACTIONS(2779), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45692] = 2,
    ACTIONS(3100), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45700] = 2,
    ACTIONS(4164), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45708] = 2,
    ACTIONS(4166), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45716] = 2,
    ACTIONS(2618), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45724] = 2,
    ACTIONS(4168), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45732] = 2,
    ACTIONS(3594), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45740] = 2,
    ACTIONS(2811), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45748] = 2,
    ACTIONS(4170), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45756] = 2,
    ACTIONS(2825), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45764] = 2,
    ACTIONS(4172), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45772] = 2,
    ACTIONS(4174), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45780] = 2,
    ACTIONS(4176), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45788] = 2,
    ACTIONS(4178), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45796] = 2,
    ACTIONS(4180), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45804] = 2,
    ACTIONS(4182), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45812] = 2,
    ACTIONS(4184), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45820] = 2,
    ACTIONS(4186), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45828] = 2,
    ACTIONS(4188), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45836] = 2,
    ACTIONS(4190), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45844] = 2,
    ACTIONS(2821), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45852] = 2,
    ACTIONS(4192), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45860] = 2,
    ACTIONS(4194), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45868] = 2,
    ACTIONS(4196), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45876] = 2,
    ACTIONS(1789), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45884] = 2,
    ACTIONS(4198), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45892] = 2,
    ACTIONS(4200), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45900] = 2,
    ACTIONS(4202), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45908] = 2,
    ACTIONS(4204), 1,
      anon_sym_until,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45916] = 2,
    ACTIONS(4206), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45924] = 2,
    ACTIONS(4208), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45932] = 2,
    ACTIONS(4210), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45940] = 2,
    ACTIONS(4212), 1,
      anon_sym_until,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45948] = 2,
    ACTIONS(3322), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45956] = 2,
    ACTIONS(3189), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45964] = 2,
    ACTIONS(4214), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45972] = 2,
    ACTIONS(2791), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45980] = 2,
    ACTIONS(4216), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45988] = 2,
    ACTIONS(4218), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [45996] = 2,
    ACTIONS(2724), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46004] = 2,
    ACTIONS(4220), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46012] = 2,
    ACTIONS(2845), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46020] = 2,
    ACTIONS(4222), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46028] = 2,
    ACTIONS(4224), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46036] = 2,
    ACTIONS(2857), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46044] = 2,
    ACTIONS(3026), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46052] = 2,
    ACTIONS(4226), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46060] = 2,
    ACTIONS(4228), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46068] = 2,
    ACTIONS(2865), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46076] = 2,
    ACTIONS(4230), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46084] = 2,
    ACTIONS(4232), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46092] = 2,
    ACTIONS(2869), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46100] = 2,
    ACTIONS(4234), 1,
      anon_sym_until,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46108] = 2,
    ACTIONS(2873), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46116] = 2,
    ACTIONS(4236), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46124] = 2,
    ACTIONS(4238), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46132] = 2,
    ACTIONS(4240), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46140] = 2,
    ACTIONS(4242), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46148] = 2,
    ACTIONS(4244), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46156] = 2,
    ACTIONS(4246), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46164] = 2,
    ACTIONS(4248), 1,
      anon_sym_until,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46172] = 2,
    ACTIONS(2142), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46180] = 2,
    ACTIONS(4250), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46188] = 2,
    ACTIONS(1787), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46196] = 2,
    ACTIONS(4252), 1,
      anon_sym_until,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46204] = 2,
    ACTIONS(4254), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46212] = 2,
    ACTIONS(3206), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46220] = 2,
    ACTIONS(4256), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46228] = 2,
    ACTIONS(2728), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46236] = 2,
    ACTIONS(4258), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46244] = 2,
    ACTIONS(4260), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46252] = 2,
    ACTIONS(3046), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46260] = 2,
    ACTIONS(4262), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46268] = 2,
    ACTIONS(2720), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46276] = 2,
    ACTIONS(4264), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46284] = 2,
    ACTIONS(1771), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46292] = 2,
    ACTIONS(2708), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46300] = 2,
    ACTIONS(4266), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46308] = 2,
    ACTIONS(3132), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46316] = 2,
    ACTIONS(4268), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46324] = 2,
    ACTIONS(2700), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46332] = 2,
    ACTIONS(4270), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46340] = 2,
    ACTIONS(4272), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46348] = 2,
    ACTIONS(2696), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46356] = 2,
    ACTIONS(3514), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46364] = 2,
    ACTIONS(2692), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46372] = 2,
    ACTIONS(4274), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46380] = 2,
    ACTIONS(4276), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46388] = 2,
    ACTIONS(4278), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46396] = 2,
    ACTIONS(4280), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46404] = 2,
    ACTIONS(4282), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46412] = 2,
    ACTIONS(4284), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46420] = 2,
    ACTIONS(3526), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46428] = 2,
    ACTIONS(4286), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46436] = 2,
    ACTIONS(4288), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46444] = 2,
    ACTIONS(4290), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46452] = 2,
    ACTIONS(4292), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46460] = 2,
    ACTIONS(4294), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46468] = 2,
    ACTIONS(1773), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46476] = 2,
    ACTIONS(4296), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46484] = 2,
    ACTIONS(4298), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46492] = 2,
    ACTIONS(4300), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46500] = 2,
    ACTIONS(4302), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46508] = 2,
    ACTIONS(4304), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46516] = 2,
    ACTIONS(4306), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46524] = 2,
    ACTIONS(3484), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46532] = 2,
    ACTIONS(4308), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46540] = 2,
    ACTIONS(4310), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46548] = 2,
    ACTIONS(4312), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46556] = 2,
    ACTIONS(4314), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46564] = 2,
    ACTIONS(3536), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46572] = 2,
    ACTIONS(2140), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46580] = 2,
    ACTIONS(3140), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46588] = 2,
    ACTIONS(4316), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46596] = 2,
    ACTIONS(2132), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46604] = 2,
    ACTIONS(3126), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46612] = 2,
    ACTIONS(3466), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46620] = 2,
    ACTIONS(4318), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46628] = 2,
    ACTIONS(3450), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46636] = 2,
    ACTIONS(3052), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46644] = 2,
    ACTIONS(4320), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46652] = 2,
    ACTIONS(4322), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46660] = 2,
    ACTIONS(2136), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46668] = 2,
    ACTIONS(4324), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46676] = 2,
    ACTIONS(3176), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46684] = 2,
    ACTIONS(4326), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46692] = 2,
    ACTIONS(4328), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46700] = 2,
    ACTIONS(2352), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46708] = 2,
    ACTIONS(4330), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46716] = 2,
    ACTIONS(4332), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46724] = 2,
    ACTIONS(4334), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46732] = 2,
    ACTIONS(4336), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46740] = 2,
    ACTIONS(4338), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46748] = 2,
    ACTIONS(4340), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46756] = 2,
    ACTIONS(4342), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46764] = 2,
    ACTIONS(4344), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46772] = 2,
    ACTIONS(4346), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46780] = 2,
    ACTIONS(4348), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46788] = 2,
    ACTIONS(4350), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46796] = 2,
    ACTIONS(4352), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46804] = 2,
    ACTIONS(4354), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46812] = 2,
    ACTIONS(3398), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46820] = 2,
    ACTIONS(4356), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46828] = 2,
    ACTIONS(4358), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46836] = 2,
    ACTIONS(4360), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46844] = 2,
    ACTIONS(4362), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46852] = 2,
    ACTIONS(4364), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46860] = 2,
    ACTIONS(4366), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46868] = 2,
    ACTIONS(4368), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46876] = 2,
    ACTIONS(4370), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46884] = 2,
    ACTIONS(4372), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46892] = 2,
    ACTIONS(3306), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46900] = 2,
    ACTIONS(4374), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46908] = 2,
    ACTIONS(4376), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46916] = 2,
    ACTIONS(2913), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46924] = 2,
    ACTIONS(4378), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46932] = 2,
    ACTIONS(4380), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46940] = 2,
    ACTIONS(4382), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46948] = 2,
    ACTIONS(4384), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46956] = 2,
    ACTIONS(2895), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46964] = 2,
    ACTIONS(4386), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46972] = 2,
    ACTIONS(4388), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46980] = 2,
    ACTIONS(4390), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46988] = 2,
    ACTIONS(4392), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [46996] = 2,
    ACTIONS(2889), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [47004] = 2,
    ACTIONS(4394), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(907)] = 0,
  [SMALL_STATE(908)] = 91,
  [SMALL_STATE(909)] = 160,
  [SMALL_STATE(910)] = 229,
  [SMALL_STATE(911)] = 298,
  [SMALL_STATE(912)] = 371,
  [SMALL_STATE(913)] = 440,
  [SMALL_STATE(914)] = 509,
  [SMALL_STATE(915)] = 578,
  [SMALL_STATE(916)] = 647,
  [SMALL_STATE(917)] = 716,
  [SMALL_STATE(918)] = 785,
  [SMALL_STATE(919)] = 861,
  [SMALL_STATE(920)] = 939,
  [SMALL_STATE(921)] = 1013,
  [SMALL_STATE(922)] = 1087,
  [SMALL_STATE(923)] = 1165,
  [SMALL_STATE(924)] = 1243,
  [SMALL_STATE(925)] = 1321,
  [SMALL_STATE(926)] = 1397,
  [SMALL_STATE(927)] = 1464,
  [SMALL_STATE(928)] = 1531,
  [SMALL_STATE(929)] = 1598,
  [SMALL_STATE(930)] = 1665,
  [SMALL_STATE(931)] = 1736,
  [SMALL_STATE(932)] = 1798,
  [SMALL_STATE(933)] = 1860,
  [SMALL_STATE(934)] = 1922,
  [SMALL_STATE(935)] = 1984,
  [SMALL_STATE(936)] = 2046,
  [SMALL_STATE(937)] = 2108,
  [SMALL_STATE(938)] = 2170,
  [SMALL_STATE(939)] = 2232,
  [SMALL_STATE(940)] = 2294,
  [SMALL_STATE(941)] = 2356,
  [SMALL_STATE(942)] = 2418,
  [SMALL_STATE(943)] = 2480,
  [SMALL_STATE(944)] = 2542,
  [SMALL_STATE(945)] = 2604,
  [SMALL_STATE(946)] = 2666,
  [SMALL_STATE(947)] = 2728,
  [SMALL_STATE(948)] = 2790,
  [SMALL_STATE(949)] = 2852,
  [SMALL_STATE(950)] = 2923,
  [SMALL_STATE(951)] = 3010,
  [SMALL_STATE(952)] = 3083,
  [SMALL_STATE(953)] = 3154,
  [SMALL_STATE(954)] = 3241,
  [SMALL_STATE(955)] = 3325,
  [SMALL_STATE(956)] = 3409,
  [SMALL_STATE(957)] = 3493,
  [SMALL_STATE(958)] = 3577,
  [SMALL_STATE(959)] = 3641,
  [SMALL_STATE(960)] = 3700,
  [SMALL_STATE(961)] = 3777,
  [SMALL_STATE(962)] = 3838,
  [SMALL_STATE(963)] = 3907,
  [SMALL_STATE(964)] = 3968,
  [SMALL_STATE(965)] = 4027,
  [SMALL_STATE(966)] = 4086,
  [SMALL_STATE(967)] = 4145,
  [SMALL_STATE(968)] = 4204,
  [SMALL_STATE(969)] = 4263,
  [SMALL_STATE(970)] = 4322,
  [SMALL_STATE(971)] = 4381,
  [SMALL_STATE(972)] = 4440,
  [SMALL_STATE(973)] = 4499,
  [SMALL_STATE(974)] = 4560,
  [SMALL_STATE(975)] = 4619,
  [SMALL_STATE(976)] = 4690,
  [SMALL_STATE(977)] = 4751,
  [SMALL_STATE(978)] = 4820,
  [SMALL_STATE(979)] = 4879,
  [SMALL_STATE(980)] = 4937,
  [SMALL_STATE(981)] = 4995,
  [SMALL_STATE(982)] = 5073,
  [SMALL_STATE(983)] = 5131,
  [SMALL_STATE(984)] = 5189,
  [SMALL_STATE(985)] = 5247,
  [SMALL_STATE(986)] = 5305,
  [SMALL_STATE(987)] = 5363,
  [SMALL_STATE(988)] = 5421,
  [SMALL_STATE(989)] = 5479,
  [SMALL_STATE(990)] = 5537,
  [SMALL_STATE(991)] = 5615,
  [SMALL_STATE(992)] = 5693,
  [SMALL_STATE(993)] = 5751,
  [SMALL_STATE(994)] = 5809,
  [SMALL_STATE(995)] = 5867,
  [SMALL_STATE(996)] = 5925,
  [SMALL_STATE(997)] = 5983,
  [SMALL_STATE(998)] = 6041,
  [SMALL_STATE(999)] = 6099,
  [SMALL_STATE(1000)] = 6157,
  [SMALL_STATE(1001)] = 6215,
  [SMALL_STATE(1002)] = 6289,
  [SMALL_STATE(1003)] = 6347,
  [SMALL_STATE(1004)] = 6405,
  [SMALL_STATE(1005)] = 6463,
  [SMALL_STATE(1006)] = 6521,
  [SMALL_STATE(1007)] = 6579,
  [SMALL_STATE(1008)] = 6637,
  [SMALL_STATE(1009)] = 6695,
  [SMALL_STATE(1010)] = 6773,
  [SMALL_STATE(1011)] = 6851,
  [SMALL_STATE(1012)] = 6909,
  [SMALL_STATE(1013)] = 6987,
  [SMALL_STATE(1014)] = 7045,
  [SMALL_STATE(1015)] = 7123,
  [SMALL_STATE(1016)] = 7181,
  [SMALL_STATE(1017)] = 7239,
  [SMALL_STATE(1018)] = 7317,
  [SMALL_STATE(1019)] = 7375,
  [SMALL_STATE(1020)] = 7453,
  [SMALL_STATE(1021)] = 7511,
  [SMALL_STATE(1022)] = 7569,
  [SMALL_STATE(1023)] = 7627,
  [SMALL_STATE(1024)] = 7705,
  [SMALL_STATE(1025)] = 7763,
  [SMALL_STATE(1026)] = 7841,
  [SMALL_STATE(1027)] = 7899,
  [SMALL_STATE(1028)] = 7977,
  [SMALL_STATE(1029)] = 8055,
  [SMALL_STATE(1030)] = 8133,
  [SMALL_STATE(1031)] = 8191,
  [SMALL_STATE(1032)] = 8249,
  [SMALL_STATE(1033)] = 8307,
  [SMALL_STATE(1034)] = 8365,
  [SMALL_STATE(1035)] = 8423,
  [SMALL_STATE(1036)] = 8481,
  [SMALL_STATE(1037)] = 8539,
  [SMALL_STATE(1038)] = 8597,
  [SMALL_STATE(1039)] = 8655,
  [SMALL_STATE(1040)] = 8733,
  [SMALL_STATE(1041)] = 8791,
  [SMALL_STATE(1042)] = 8849,
  [SMALL_STATE(1043)] = 8907,
  [SMALL_STATE(1044)] = 8965,
  [SMALL_STATE(1045)] = 9023,
  [SMALL_STATE(1046)] = 9081,
  [SMALL_STATE(1047)] = 9139,
  [SMALL_STATE(1048)] = 9217,
  [SMALL_STATE(1049)] = 9275,
  [SMALL_STATE(1050)] = 9333,
  [SMALL_STATE(1051)] = 9391,
  [SMALL_STATE(1052)] = 9449,
  [SMALL_STATE(1053)] = 9507,
  [SMALL_STATE(1054)] = 9565,
  [SMALL_STATE(1055)] = 9643,
  [SMALL_STATE(1056)] = 9701,
  [SMALL_STATE(1057)] = 9759,
  [SMALL_STATE(1058)] = 9817,
  [SMALL_STATE(1059)] = 9875,
  [SMALL_STATE(1060)] = 9933,
  [SMALL_STATE(1061)] = 10011,
  [SMALL_STATE(1062)] = 10069,
  [SMALL_STATE(1063)] = 10127,
  [SMALL_STATE(1064)] = 10202,
  [SMALL_STATE(1065)] = 10277,
  [SMALL_STATE(1066)] = 10352,
  [SMALL_STATE(1067)] = 10427,
  [SMALL_STATE(1068)] = 10502,
  [SMALL_STATE(1069)] = 10577,
  [SMALL_STATE(1070)] = 10652,
  [SMALL_STATE(1071)] = 10717,
  [SMALL_STATE(1072)] = 10792,
  [SMALL_STATE(1073)] = 10857,
  [SMALL_STATE(1074)] = 10930,
  [SMALL_STATE(1075)] = 11003,
  [SMALL_STATE(1076)] = 11076,
  [SMALL_STATE(1077)] = 11149,
  [SMALL_STATE(1078)] = 11222,
  [SMALL_STATE(1079)] = 11295,
  [SMALL_STATE(1080)] = 11367,
  [SMALL_STATE(1081)] = 11427,
  [SMALL_STATE(1082)] = 11482,
  [SMALL_STATE(1083)] = 11536,
  [SMALL_STATE(1084)] = 11590,
  [SMALL_STATE(1085)] = 11644,
  [SMALL_STATE(1086)] = 11697,
  [SMALL_STATE(1087)] = 11750,
  [SMALL_STATE(1088)] = 11803,
  [SMALL_STATE(1089)] = 11856,
  [SMALL_STATE(1090)] = 11909,
  [SMALL_STATE(1091)] = 11962,
  [SMALL_STATE(1092)] = 12015,
  [SMALL_STATE(1093)] = 12068,
  [SMALL_STATE(1094)] = 12121,
  [SMALL_STATE(1095)] = 12174,
  [SMALL_STATE(1096)] = 12227,
  [SMALL_STATE(1097)] = 12280,
  [SMALL_STATE(1098)] = 12333,
  [SMALL_STATE(1099)] = 12386,
  [SMALL_STATE(1100)] = 12439,
  [SMALL_STATE(1101)] = 12492,
  [SMALL_STATE(1102)] = 12545,
  [SMALL_STATE(1103)] = 12598,
  [SMALL_STATE(1104)] = 12651,
  [SMALL_STATE(1105)] = 12704,
  [SMALL_STATE(1106)] = 12757,
  [SMALL_STATE(1107)] = 12810,
  [SMALL_STATE(1108)] = 12863,
  [SMALL_STATE(1109)] = 12916,
  [SMALL_STATE(1110)] = 12969,
  [SMALL_STATE(1111)] = 13022,
  [SMALL_STATE(1112)] = 13075,
  [SMALL_STATE(1113)] = 13150,
  [SMALL_STATE(1114)] = 13203,
  [SMALL_STATE(1115)] = 13256,
  [SMALL_STATE(1116)] = 13309,
  [SMALL_STATE(1117)] = 13362,
  [SMALL_STATE(1118)] = 13415,
  [SMALL_STATE(1119)] = 13468,
  [SMALL_STATE(1120)] = 13526,
  [SMALL_STATE(1121)] = 13584,
  [SMALL_STATE(1122)] = 13642,
  [SMALL_STATE(1123)] = 13719,
  [SMALL_STATE(1124)] = 13796,
  [SMALL_STATE(1125)] = 13843,
  [SMALL_STATE(1126)] = 13920,
  [SMALL_STATE(1127)] = 13967,
  [SMALL_STATE(1128)] = 14014,
  [SMALL_STATE(1129)] = 14091,
  [SMALL_STATE(1130)] = 14168,
  [SMALL_STATE(1131)] = 14245,
  [SMALL_STATE(1132)] = 14292,
  [SMALL_STATE(1133)] = 14369,
  [SMALL_STATE(1134)] = 14446,
  [SMALL_STATE(1135)] = 14523,
  [SMALL_STATE(1136)] = 14600,
  [SMALL_STATE(1137)] = 14677,
  [SMALL_STATE(1138)] = 14754,
  [SMALL_STATE(1139)] = 14831,
  [SMALL_STATE(1140)] = 14908,
  [SMALL_STATE(1141)] = 14985,
  [SMALL_STATE(1142)] = 15062,
  [SMALL_STATE(1143)] = 15139,
  [SMALL_STATE(1144)] = 15216,
  [SMALL_STATE(1145)] = 15293,
  [SMALL_STATE(1146)] = 15370,
  [SMALL_STATE(1147)] = 15447,
  [SMALL_STATE(1148)] = 15524,
  [SMALL_STATE(1149)] = 15566,
  [SMALL_STATE(1150)] = 15608,
  [SMALL_STATE(1151)] = 15650,
  [SMALL_STATE(1152)] = 15692,
  [SMALL_STATE(1153)] = 15734,
  [SMALL_STATE(1154)] = 15776,
  [SMALL_STATE(1155)] = 15818,
  [SMALL_STATE(1156)] = 15860,
  [SMALL_STATE(1157)] = 15902,
  [SMALL_STATE(1158)] = 15944,
  [SMALL_STATE(1159)] = 15986,
  [SMALL_STATE(1160)] = 16028,
  [SMALL_STATE(1161)] = 16070,
  [SMALL_STATE(1162)] = 16112,
  [SMALL_STATE(1163)] = 16154,
  [SMALL_STATE(1164)] = 16196,
  [SMALL_STATE(1165)] = 16238,
  [SMALL_STATE(1166)] = 16280,
  [SMALL_STATE(1167)] = 16345,
  [SMALL_STATE(1168)] = 16410,
  [SMALL_STATE(1169)] = 16475,
  [SMALL_STATE(1170)] = 16540,
  [SMALL_STATE(1171)] = 16605,
  [SMALL_STATE(1172)] = 16670,
  [SMALL_STATE(1173)] = 16735,
  [SMALL_STATE(1174)] = 16800,
  [SMALL_STATE(1175)] = 16865,
  [SMALL_STATE(1176)] = 16930,
  [SMALL_STATE(1177)] = 16995,
  [SMALL_STATE(1178)] = 17060,
  [SMALL_STATE(1179)] = 17125,
  [SMALL_STATE(1180)] = 17190,
  [SMALL_STATE(1181)] = 17255,
  [SMALL_STATE(1182)] = 17320,
  [SMALL_STATE(1183)] = 17379,
  [SMALL_STATE(1184)] = 17438,
  [SMALL_STATE(1185)] = 17497,
  [SMALL_STATE(1186)] = 17556,
  [SMALL_STATE(1187)] = 17615,
  [SMALL_STATE(1188)] = 17674,
  [SMALL_STATE(1189)] = 17733,
  [SMALL_STATE(1190)] = 17792,
  [SMALL_STATE(1191)] = 17851,
  [SMALL_STATE(1192)] = 17910,
  [SMALL_STATE(1193)] = 17969,
  [SMALL_STATE(1194)] = 18028,
  [SMALL_STATE(1195)] = 18087,
  [SMALL_STATE(1196)] = 18146,
  [SMALL_STATE(1197)] = 18205,
  [SMALL_STATE(1198)] = 18264,
  [SMALL_STATE(1199)] = 18323,
  [SMALL_STATE(1200)] = 18375,
  [SMALL_STATE(1201)] = 18434,
  [SMALL_STATE(1202)] = 18493,
  [SMALL_STATE(1203)] = 18542,
  [SMALL_STATE(1204)] = 18601,
  [SMALL_STATE(1205)] = 18660,
  [SMALL_STATE(1206)] = 18719,
  [SMALL_STATE(1207)] = 18765,
  [SMALL_STATE(1208)] = 18811,
  [SMALL_STATE(1209)] = 18857,
  [SMALL_STATE(1210)] = 18903,
  [SMALL_STATE(1211)] = 18949,
  [SMALL_STATE(1212)] = 18995,
  [SMALL_STATE(1213)] = 19041,
  [SMALL_STATE(1214)] = 19087,
  [SMALL_STATE(1215)] = 19133,
  [SMALL_STATE(1216)] = 19179,
  [SMALL_STATE(1217)] = 19225,
  [SMALL_STATE(1218)] = 19271,
  [SMALL_STATE(1219)] = 19317,
  [SMALL_STATE(1220)] = 19363,
  [SMALL_STATE(1221)] = 19409,
  [SMALL_STATE(1222)] = 19455,
  [SMALL_STATE(1223)] = 19501,
  [SMALL_STATE(1224)] = 19547,
  [SMALL_STATE(1225)] = 19593,
  [SMALL_STATE(1226)] = 19639,
  [SMALL_STATE(1227)] = 19685,
  [SMALL_STATE(1228)] = 19731,
  [SMALL_STATE(1229)] = 19777,
  [SMALL_STATE(1230)] = 19823,
  [SMALL_STATE(1231)] = 19869,
  [SMALL_STATE(1232)] = 19915,
  [SMALL_STATE(1233)] = 19961,
  [SMALL_STATE(1234)] = 20007,
  [SMALL_STATE(1235)] = 20053,
  [SMALL_STATE(1236)] = 20099,
  [SMALL_STATE(1237)] = 20145,
  [SMALL_STATE(1238)] = 20191,
  [SMALL_STATE(1239)] = 20237,
  [SMALL_STATE(1240)] = 20283,
  [SMALL_STATE(1241)] = 20329,
  [SMALL_STATE(1242)] = 20375,
  [SMALL_STATE(1243)] = 20421,
  [SMALL_STATE(1244)] = 20467,
  [SMALL_STATE(1245)] = 20513,
  [SMALL_STATE(1246)] = 20559,
  [SMALL_STATE(1247)] = 20605,
  [SMALL_STATE(1248)] = 20651,
  [SMALL_STATE(1249)] = 20697,
  [SMALL_STATE(1250)] = 20743,
  [SMALL_STATE(1251)] = 20789,
  [SMALL_STATE(1252)] = 20835,
  [SMALL_STATE(1253)] = 20881,
  [SMALL_STATE(1254)] = 20927,
  [SMALL_STATE(1255)] = 20973,
  [SMALL_STATE(1256)] = 21019,
  [SMALL_STATE(1257)] = 21065,
  [SMALL_STATE(1258)] = 21111,
  [SMALL_STATE(1259)] = 21157,
  [SMALL_STATE(1260)] = 21203,
  [SMALL_STATE(1261)] = 21249,
  [SMALL_STATE(1262)] = 21295,
  [SMALL_STATE(1263)] = 21341,
  [SMALL_STATE(1264)] = 21387,
  [SMALL_STATE(1265)] = 21433,
  [SMALL_STATE(1266)] = 21479,
  [SMALL_STATE(1267)] = 21525,
  [SMALL_STATE(1268)] = 21571,
  [SMALL_STATE(1269)] = 21617,
  [SMALL_STATE(1270)] = 21663,
  [SMALL_STATE(1271)] = 21709,
  [SMALL_STATE(1272)] = 21755,
  [SMALL_STATE(1273)] = 21801,
  [SMALL_STATE(1274)] = 21847,
  [SMALL_STATE(1275)] = 21893,
  [SMALL_STATE(1276)] = 21939,
  [SMALL_STATE(1277)] = 21985,
  [SMALL_STATE(1278)] = 22031,
  [SMALL_STATE(1279)] = 22077,
  [SMALL_STATE(1280)] = 22123,
  [SMALL_STATE(1281)] = 22169,
  [SMALL_STATE(1282)] = 22215,
  [SMALL_STATE(1283)] = 22261,
  [SMALL_STATE(1284)] = 22307,
  [SMALL_STATE(1285)] = 22353,
  [SMALL_STATE(1286)] = 22399,
  [SMALL_STATE(1287)] = 22445,
  [SMALL_STATE(1288)] = 22491,
  [SMALL_STATE(1289)] = 22537,
  [SMALL_STATE(1290)] = 22583,
  [SMALL_STATE(1291)] = 22629,
  [SMALL_STATE(1292)] = 22675,
  [SMALL_STATE(1293)] = 22721,
  [SMALL_STATE(1294)] = 22767,
  [SMALL_STATE(1295)] = 22813,
  [SMALL_STATE(1296)] = 22859,
  [SMALL_STATE(1297)] = 22905,
  [SMALL_STATE(1298)] = 22951,
  [SMALL_STATE(1299)] = 22997,
  [SMALL_STATE(1300)] = 23043,
  [SMALL_STATE(1301)] = 23089,
  [SMALL_STATE(1302)] = 23135,
  [SMALL_STATE(1303)] = 23181,
  [SMALL_STATE(1304)] = 23227,
  [SMALL_STATE(1305)] = 23273,
  [SMALL_STATE(1306)] = 23319,
  [SMALL_STATE(1307)] = 23365,
  [SMALL_STATE(1308)] = 23411,
  [SMALL_STATE(1309)] = 23457,
  [SMALL_STATE(1310)] = 23503,
  [SMALL_STATE(1311)] = 23549,
  [SMALL_STATE(1312)] = 23595,
  [SMALL_STATE(1313)] = 23641,
  [SMALL_STATE(1314)] = 23687,
  [SMALL_STATE(1315)] = 23733,
  [SMALL_STATE(1316)] = 23779,
  [SMALL_STATE(1317)] = 23825,
  [SMALL_STATE(1318)] = 23871,
  [SMALL_STATE(1319)] = 23917,
  [SMALL_STATE(1320)] = 23963,
  [SMALL_STATE(1321)] = 24009,
  [SMALL_STATE(1322)] = 24055,
  [SMALL_STATE(1323)] = 24101,
  [SMALL_STATE(1324)] = 24147,
  [SMALL_STATE(1325)] = 24193,
  [SMALL_STATE(1326)] = 24239,
  [SMALL_STATE(1327)] = 24285,
  [SMALL_STATE(1328)] = 24331,
  [SMALL_STATE(1329)] = 24377,
  [SMALL_STATE(1330)] = 24423,
  [SMALL_STATE(1331)] = 24469,
  [SMALL_STATE(1332)] = 24515,
  [SMALL_STATE(1333)] = 24561,
  [SMALL_STATE(1334)] = 24607,
  [SMALL_STATE(1335)] = 24653,
  [SMALL_STATE(1336)] = 24699,
  [SMALL_STATE(1337)] = 24745,
  [SMALL_STATE(1338)] = 24791,
  [SMALL_STATE(1339)] = 24837,
  [SMALL_STATE(1340)] = 24883,
  [SMALL_STATE(1341)] = 24929,
  [SMALL_STATE(1342)] = 24975,
  [SMALL_STATE(1343)] = 25021,
  [SMALL_STATE(1344)] = 25067,
  [SMALL_STATE(1345)] = 25113,
  [SMALL_STATE(1346)] = 25159,
  [SMALL_STATE(1347)] = 25205,
  [SMALL_STATE(1348)] = 25251,
  [SMALL_STATE(1349)] = 25297,
  [SMALL_STATE(1350)] = 25343,
  [SMALL_STATE(1351)] = 25389,
  [SMALL_STATE(1352)] = 25435,
  [SMALL_STATE(1353)] = 25481,
  [SMALL_STATE(1354)] = 25527,
  [SMALL_STATE(1355)] = 25573,
  [SMALL_STATE(1356)] = 25619,
  [SMALL_STATE(1357)] = 25665,
  [SMALL_STATE(1358)] = 25711,
  [SMALL_STATE(1359)] = 25757,
  [SMALL_STATE(1360)] = 25803,
  [SMALL_STATE(1361)] = 25849,
  [SMALL_STATE(1362)] = 25895,
  [SMALL_STATE(1363)] = 25941,
  [SMALL_STATE(1364)] = 25987,
  [SMALL_STATE(1365)] = 26033,
  [SMALL_STATE(1366)] = 26079,
  [SMALL_STATE(1367)] = 26125,
  [SMALL_STATE(1368)] = 26171,
  [SMALL_STATE(1369)] = 26217,
  [SMALL_STATE(1370)] = 26263,
  [SMALL_STATE(1371)] = 26309,
  [SMALL_STATE(1372)] = 26355,
  [SMALL_STATE(1373)] = 26401,
  [SMALL_STATE(1374)] = 26447,
  [SMALL_STATE(1375)] = 26493,
  [SMALL_STATE(1376)] = 26539,
  [SMALL_STATE(1377)] = 26582,
  [SMALL_STATE(1378)] = 26625,
  [SMALL_STATE(1379)] = 26668,
  [SMALL_STATE(1380)] = 26711,
  [SMALL_STATE(1381)] = 26754,
  [SMALL_STATE(1382)] = 26797,
  [SMALL_STATE(1383)] = 26846,
  [SMALL_STATE(1384)] = 26889,
  [SMALL_STATE(1385)] = 26932,
  [SMALL_STATE(1386)] = 26981,
  [SMALL_STATE(1387)] = 27024,
  [SMALL_STATE(1388)] = 27067,
  [SMALL_STATE(1389)] = 27110,
  [SMALL_STATE(1390)] = 27153,
  [SMALL_STATE(1391)] = 27196,
  [SMALL_STATE(1392)] = 27239,
  [SMALL_STATE(1393)] = 27282,
  [SMALL_STATE(1394)] = 27325,
  [SMALL_STATE(1395)] = 27368,
  [SMALL_STATE(1396)] = 27417,
  [SMALL_STATE(1397)] = 27460,
  [SMALL_STATE(1398)] = 27503,
  [SMALL_STATE(1399)] = 27546,
  [SMALL_STATE(1400)] = 27589,
  [SMALL_STATE(1401)] = 27632,
  [SMALL_STATE(1402)] = 27675,
  [SMALL_STATE(1403)] = 27718,
  [SMALL_STATE(1404)] = 27767,
  [SMALL_STATE(1405)] = 27810,
  [SMALL_STATE(1406)] = 27853,
  [SMALL_STATE(1407)] = 27896,
  [SMALL_STATE(1408)] = 27939,
  [SMALL_STATE(1409)] = 27982,
  [SMALL_STATE(1410)] = 28025,
  [SMALL_STATE(1411)] = 28068,
  [SMALL_STATE(1412)] = 28111,
  [SMALL_STATE(1413)] = 28154,
  [SMALL_STATE(1414)] = 28197,
  [SMALL_STATE(1415)] = 28247,
  [SMALL_STATE(1416)] = 28303,
  [SMALL_STATE(1417)] = 28359,
  [SMALL_STATE(1418)] = 28415,
  [SMALL_STATE(1419)] = 28471,
  [SMALL_STATE(1420)] = 28527,
  [SMALL_STATE(1421)] = 28577,
  [SMALL_STATE(1422)] = 28633,
  [SMALL_STATE(1423)] = 28689,
  [SMALL_STATE(1424)] = 28729,
  [SMALL_STATE(1425)] = 28785,
  [SMALL_STATE(1426)] = 28814,
  [SMALL_STATE(1427)] = 28855,
  [SMALL_STATE(1428)] = 28896,
  [SMALL_STATE(1429)] = 28925,
  [SMALL_STATE(1430)] = 28966,
  [SMALL_STATE(1431)] = 29017,
  [SMALL_STATE(1432)] = 29046,
  [SMALL_STATE(1433)] = 29087,
  [SMALL_STATE(1434)] = 29128,
  [SMALL_STATE(1435)] = 29156,
  [SMALL_STATE(1436)] = 29194,
  [SMALL_STATE(1437)] = 29232,
  [SMALL_STATE(1438)] = 29278,
  [SMALL_STATE(1439)] = 29324,
  [SMALL_STATE(1440)] = 29370,
  [SMALL_STATE(1441)] = 29408,
  [SMALL_STATE(1442)] = 29436,
  [SMALL_STATE(1443)] = 29474,
  [SMALL_STATE(1444)] = 29520,
  [SMALL_STATE(1445)] = 29571,
  [SMALL_STATE(1446)] = 29606,
  [SMALL_STATE(1447)] = 29641,
  [SMALL_STATE(1448)] = 29676,
  [SMALL_STATE(1449)] = 29711,
  [SMALL_STATE(1450)] = 29762,
  [SMALL_STATE(1451)] = 29797,
  [SMALL_STATE(1452)] = 29832,
  [SMALL_STATE(1453)] = 29883,
  [SMALL_STATE(1454)] = 29934,
  [SMALL_STATE(1455)] = 29985,
  [SMALL_STATE(1456)] = 30020,
  [SMALL_STATE(1457)] = 30055,
  [SMALL_STATE(1458)] = 30090,
  [SMALL_STATE(1459)] = 30125,
  [SMALL_STATE(1460)] = 30160,
  [SMALL_STATE(1461)] = 30195,
  [SMALL_STATE(1462)] = 30230,
  [SMALL_STATE(1463)] = 30265,
  [SMALL_STATE(1464)] = 30300,
  [SMALL_STATE(1465)] = 30335,
  [SMALL_STATE(1466)] = 30370,
  [SMALL_STATE(1467)] = 30405,
  [SMALL_STATE(1468)] = 30433,
  [SMALL_STATE(1469)] = 30464,
  [SMALL_STATE(1470)] = 30495,
  [SMALL_STATE(1471)] = 30518,
  [SMALL_STATE(1472)] = 30541,
  [SMALL_STATE(1473)] = 30572,
  [SMALL_STATE(1474)] = 30610,
  [SMALL_STATE(1475)] = 30648,
  [SMALL_STATE(1476)] = 30686,
  [SMALL_STATE(1477)] = 30724,
  [SMALL_STATE(1478)] = 30744,
  [SMALL_STATE(1479)] = 30764,
  [SMALL_STATE(1480)] = 30784,
  [SMALL_STATE(1481)] = 30804,
  [SMALL_STATE(1482)] = 30824,
  [SMALL_STATE(1483)] = 30844,
  [SMALL_STATE(1484)] = 30864,
  [SMALL_STATE(1485)] = 30892,
  [SMALL_STATE(1486)] = 30912,
  [SMALL_STATE(1487)] = 30932,
  [SMALL_STATE(1488)] = 30952,
  [SMALL_STATE(1489)] = 30972,
  [SMALL_STATE(1490)] = 30992,
  [SMALL_STATE(1491)] = 31012,
  [SMALL_STATE(1492)] = 31032,
  [SMALL_STATE(1493)] = 31052,
  [SMALL_STATE(1494)] = 31072,
  [SMALL_STATE(1495)] = 31104,
  [SMALL_STATE(1496)] = 31124,
  [SMALL_STATE(1497)] = 31144,
  [SMALL_STATE(1498)] = 31164,
  [SMALL_STATE(1499)] = 31184,
  [SMALL_STATE(1500)] = 31204,
  [SMALL_STATE(1501)] = 31224,
  [SMALL_STATE(1502)] = 31244,
  [SMALL_STATE(1503)] = 31264,
  [SMALL_STATE(1504)] = 31284,
  [SMALL_STATE(1505)] = 31312,
  [SMALL_STATE(1506)] = 31332,
  [SMALL_STATE(1507)] = 31352,
  [SMALL_STATE(1508)] = 31372,
  [SMALL_STATE(1509)] = 31392,
  [SMALL_STATE(1510)] = 31412,
  [SMALL_STATE(1511)] = 31432,
  [SMALL_STATE(1512)] = 31452,
  [SMALL_STATE(1513)] = 31472,
  [SMALL_STATE(1514)] = 31503,
  [SMALL_STATE(1515)] = 31526,
  [SMALL_STATE(1516)] = 31557,
  [SMALL_STATE(1517)] = 31588,
  [SMALL_STATE(1518)] = 31621,
  [SMALL_STATE(1519)] = 31652,
  [SMALL_STATE(1520)] = 31685,
  [SMALL_STATE(1521)] = 31716,
  [SMALL_STATE(1522)] = 31747,
  [SMALL_STATE(1523)] = 31778,
  [SMALL_STATE(1524)] = 31809,
  [SMALL_STATE(1525)] = 31840,
  [SMALL_STATE(1526)] = 31871,
  [SMALL_STATE(1527)] = 31904,
  [SMALL_STATE(1528)] = 31937,
  [SMALL_STATE(1529)] = 31970,
  [SMALL_STATE(1530)] = 31988,
  [SMALL_STATE(1531)] = 32018,
  [SMALL_STATE(1532)] = 32056,
  [SMALL_STATE(1533)] = 32086,
  [SMALL_STATE(1534)] = 32114,
  [SMALL_STATE(1535)] = 32134,
  [SMALL_STATE(1536)] = 32164,
  [SMALL_STATE(1537)] = 32182,
  [SMALL_STATE(1538)] = 32210,
  [SMALL_STATE(1539)] = 32240,
  [SMALL_STATE(1540)] = 32267,
  [SMALL_STATE(1541)] = 32302,
  [SMALL_STATE(1542)] = 32329,
  [SMALL_STATE(1543)] = 32356,
  [SMALL_STATE(1544)] = 32383,
  [SMALL_STATE(1545)] = 32410,
  [SMALL_STATE(1546)] = 32437,
  [SMALL_STATE(1547)] = 32464,
  [SMALL_STATE(1548)] = 32499,
  [SMALL_STATE(1549)] = 32526,
  [SMALL_STATE(1550)] = 32553,
  [SMALL_STATE(1551)] = 32580,
  [SMALL_STATE(1552)] = 32607,
  [SMALL_STATE(1553)] = 32632,
  [SMALL_STATE(1554)] = 32667,
  [SMALL_STATE(1555)] = 32692,
  [SMALL_STATE(1556)] = 32719,
  [SMALL_STATE(1557)] = 32746,
  [SMALL_STATE(1558)] = 32777,
  [SMALL_STATE(1559)] = 32812,
  [SMALL_STATE(1560)] = 32839,
  [SMALL_STATE(1561)] = 32866,
  [SMALL_STATE(1562)] = 32901,
  [SMALL_STATE(1563)] = 32928,
  [SMALL_STATE(1564)] = 32961,
  [SMALL_STATE(1565)] = 32988,
  [SMALL_STATE(1566)] = 33021,
  [SMALL_STATE(1567)] = 33048,
  [SMALL_STATE(1568)] = 33083,
  [SMALL_STATE(1569)] = 33116,
  [SMALL_STATE(1570)] = 33141,
  [SMALL_STATE(1571)] = 33166,
  [SMALL_STATE(1572)] = 33201,
  [SMALL_STATE(1573)] = 33236,
  [SMALL_STATE(1574)] = 33271,
  [SMALL_STATE(1575)] = 33306,
  [SMALL_STATE(1576)] = 33341,
  [SMALL_STATE(1577)] = 33366,
  [SMALL_STATE(1578)] = 33401,
  [SMALL_STATE(1579)] = 33426,
  [SMALL_STATE(1580)] = 33461,
  [SMALL_STATE(1581)] = 33494,
  [SMALL_STATE(1582)] = 33529,
  [SMALL_STATE(1583)] = 33564,
  [SMALL_STATE(1584)] = 33589,
  [SMALL_STATE(1585)] = 33614,
  [SMALL_STATE(1586)] = 33636,
  [SMALL_STATE(1587)] = 33666,
  [SMALL_STATE(1588)] = 33682,
  [SMALL_STATE(1589)] = 33698,
  [SMALL_STATE(1590)] = 33714,
  [SMALL_STATE(1591)] = 33746,
  [SMALL_STATE(1592)] = 33778,
  [SMALL_STATE(1593)] = 33794,
  [SMALL_STATE(1594)] = 33810,
  [SMALL_STATE(1595)] = 33826,
  [SMALL_STATE(1596)] = 33842,
  [SMALL_STATE(1597)] = 33874,
  [SMALL_STATE(1598)] = 33890,
  [SMALL_STATE(1599)] = 33906,
  [SMALL_STATE(1600)] = 33938,
  [SMALL_STATE(1601)] = 33970,
  [SMALL_STATE(1602)] = 34002,
  [SMALL_STATE(1603)] = 34034,
  [SMALL_STATE(1604)] = 34050,
  [SMALL_STATE(1605)] = 34082,
  [SMALL_STATE(1606)] = 34114,
  [SMALL_STATE(1607)] = 34146,
  [SMALL_STATE(1608)] = 34168,
  [SMALL_STATE(1609)] = 34200,
  [SMALL_STATE(1610)] = 34232,
  [SMALL_STATE(1611)] = 34248,
  [SMALL_STATE(1612)] = 34280,
  [SMALL_STATE(1613)] = 34312,
  [SMALL_STATE(1614)] = 34344,
  [SMALL_STATE(1615)] = 34376,
  [SMALL_STATE(1616)] = 34392,
  [SMALL_STATE(1617)] = 34424,
  [SMALL_STATE(1618)] = 34456,
  [SMALL_STATE(1619)] = 34488,
  [SMALL_STATE(1620)] = 34518,
  [SMALL_STATE(1621)] = 34550,
  [SMALL_STATE(1622)] = 34582,
  [SMALL_STATE(1623)] = 34598,
  [SMALL_STATE(1624)] = 34614,
  [SMALL_STATE(1625)] = 34646,
  [SMALL_STATE(1626)] = 34678,
  [SMALL_STATE(1627)] = 34710,
  [SMALL_STATE(1628)] = 34742,
  [SMALL_STATE(1629)] = 34774,
  [SMALL_STATE(1630)] = 34790,
  [SMALL_STATE(1631)] = 34822,
  [SMALL_STATE(1632)] = 34854,
  [SMALL_STATE(1633)] = 34886,
  [SMALL_STATE(1634)] = 34902,
  [SMALL_STATE(1635)] = 34934,
  [SMALL_STATE(1636)] = 34966,
  [SMALL_STATE(1637)] = 34998,
  [SMALL_STATE(1638)] = 35030,
  [SMALL_STATE(1639)] = 35062,
  [SMALL_STATE(1640)] = 35078,
  [SMALL_STATE(1641)] = 35110,
  [SMALL_STATE(1642)] = 35142,
  [SMALL_STATE(1643)] = 35174,
  [SMALL_STATE(1644)] = 35194,
  [SMALL_STATE(1645)] = 35226,
  [SMALL_STATE(1646)] = 35258,
  [SMALL_STATE(1647)] = 35274,
  [SMALL_STATE(1648)] = 35306,
  [SMALL_STATE(1649)] = 35338,
  [SMALL_STATE(1650)] = 35370,
  [SMALL_STATE(1651)] = 35386,
  [SMALL_STATE(1652)] = 35418,
  [SMALL_STATE(1653)] = 35450,
  [SMALL_STATE(1654)] = 35482,
  [SMALL_STATE(1655)] = 35514,
  [SMALL_STATE(1656)] = 35546,
  [SMALL_STATE(1657)] = 35578,
  [SMALL_STATE(1658)] = 35610,
  [SMALL_STATE(1659)] = 35642,
  [SMALL_STATE(1660)] = 35658,
  [SMALL_STATE(1661)] = 35690,
  [SMALL_STATE(1662)] = 35722,
  [SMALL_STATE(1663)] = 35754,
  [SMALL_STATE(1664)] = 35786,
  [SMALL_STATE(1665)] = 35802,
  [SMALL_STATE(1666)] = 35834,
  [SMALL_STATE(1667)] = 35866,
  [SMALL_STATE(1668)] = 35882,
  [SMALL_STATE(1669)] = 35914,
  [SMALL_STATE(1670)] = 35930,
  [SMALL_STATE(1671)] = 35962,
  [SMALL_STATE(1672)] = 35994,
  [SMALL_STATE(1673)] = 36010,
  [SMALL_STATE(1674)] = 36026,
  [SMALL_STATE(1675)] = 36042,
  [SMALL_STATE(1676)] = 36058,
  [SMALL_STATE(1677)] = 36074,
  [SMALL_STATE(1678)] = 36090,
  [SMALL_STATE(1679)] = 36106,
  [SMALL_STATE(1680)] = 36122,
  [SMALL_STATE(1681)] = 36154,
  [SMALL_STATE(1682)] = 36170,
  [SMALL_STATE(1683)] = 36186,
  [SMALL_STATE(1684)] = 36202,
  [SMALL_STATE(1685)] = 36218,
  [SMALL_STATE(1686)] = 36234,
  [SMALL_STATE(1687)] = 36250,
  [SMALL_STATE(1688)] = 36266,
  [SMALL_STATE(1689)] = 36282,
  [SMALL_STATE(1690)] = 36298,
  [SMALL_STATE(1691)] = 36314,
  [SMALL_STATE(1692)] = 36330,
  [SMALL_STATE(1693)] = 36346,
  [SMALL_STATE(1694)] = 36378,
  [SMALL_STATE(1695)] = 36410,
  [SMALL_STATE(1696)] = 36442,
  [SMALL_STATE(1697)] = 36474,
  [SMALL_STATE(1698)] = 36506,
  [SMALL_STATE(1699)] = 36522,
  [SMALL_STATE(1700)] = 36538,
  [SMALL_STATE(1701)] = 36554,
  [SMALL_STATE(1702)] = 36586,
  [SMALL_STATE(1703)] = 36618,
  [SMALL_STATE(1704)] = 36650,
  [SMALL_STATE(1705)] = 36682,
  [SMALL_STATE(1706)] = 36714,
  [SMALL_STATE(1707)] = 36735,
  [SMALL_STATE(1708)] = 36756,
  [SMALL_STATE(1709)] = 36777,
  [SMALL_STATE(1710)] = 36802,
  [SMALL_STATE(1711)] = 36821,
  [SMALL_STATE(1712)] = 36840,
  [SMALL_STATE(1713)] = 36869,
  [SMALL_STATE(1714)] = 36888,
  [SMALL_STATE(1715)] = 36907,
  [SMALL_STATE(1716)] = 36926,
  [SMALL_STATE(1717)] = 36955,
  [SMALL_STATE(1718)] = 36974,
  [SMALL_STATE(1719)] = 37003,
  [SMALL_STATE(1720)] = 37022,
  [SMALL_STATE(1721)] = 37051,
  [SMALL_STATE(1722)] = 37070,
  [SMALL_STATE(1723)] = 37089,
  [SMALL_STATE(1724)] = 37118,
  [SMALL_STATE(1725)] = 37147,
  [SMALL_STATE(1726)] = 37168,
  [SMALL_STATE(1727)] = 37187,
  [SMALL_STATE(1728)] = 37206,
  [SMALL_STATE(1729)] = 37225,
  [SMALL_STATE(1730)] = 37244,
  [SMALL_STATE(1731)] = 37265,
  [SMALL_STATE(1732)] = 37288,
  [SMALL_STATE(1733)] = 37309,
  [SMALL_STATE(1734)] = 37328,
  [SMALL_STATE(1735)] = 37357,
  [SMALL_STATE(1736)] = 37378,
  [SMALL_STATE(1737)] = 37399,
  [SMALL_STATE(1738)] = 37428,
  [SMALL_STATE(1739)] = 37447,
  [SMALL_STATE(1740)] = 37476,
  [SMALL_STATE(1741)] = 37497,
  [SMALL_STATE(1742)] = 37526,
  [SMALL_STATE(1743)] = 37549,
  [SMALL_STATE(1744)] = 37568,
  [SMALL_STATE(1745)] = 37587,
  [SMALL_STATE(1746)] = 37608,
  [SMALL_STATE(1747)] = 37631,
  [SMALL_STATE(1748)] = 37660,
  [SMALL_STATE(1749)] = 37679,
  [SMALL_STATE(1750)] = 37698,
  [SMALL_STATE(1751)] = 37717,
  [SMALL_STATE(1752)] = 37741,
  [SMALL_STATE(1753)] = 37765,
  [SMALL_STATE(1754)] = 37787,
  [SMALL_STATE(1755)] = 37811,
  [SMALL_STATE(1756)] = 37835,
  [SMALL_STATE(1757)] = 37856,
  [SMALL_STATE(1758)] = 37877,
  [SMALL_STATE(1759)] = 37898,
  [SMALL_STATE(1760)] = 37919,
  [SMALL_STATE(1761)] = 37940,
  [SMALL_STATE(1762)] = 37961,
  [SMALL_STATE(1763)] = 37982,
  [SMALL_STATE(1764)] = 38003,
  [SMALL_STATE(1765)] = 38024,
  [SMALL_STATE(1766)] = 38045,
  [SMALL_STATE(1767)] = 38066,
  [SMALL_STATE(1768)] = 38087,
  [SMALL_STATE(1769)] = 38108,
  [SMALL_STATE(1770)] = 38129,
  [SMALL_STATE(1771)] = 38150,
  [SMALL_STATE(1772)] = 38171,
  [SMALL_STATE(1773)] = 38192,
  [SMALL_STATE(1774)] = 38213,
  [SMALL_STATE(1775)] = 38234,
  [SMALL_STATE(1776)] = 38255,
  [SMALL_STATE(1777)] = 38276,
  [SMALL_STATE(1778)] = 38297,
  [SMALL_STATE(1779)] = 38318,
  [SMALL_STATE(1780)] = 38339,
  [SMALL_STATE(1781)] = 38360,
  [SMALL_STATE(1782)] = 38381,
  [SMALL_STATE(1783)] = 38402,
  [SMALL_STATE(1784)] = 38423,
  [SMALL_STATE(1785)] = 38444,
  [SMALL_STATE(1786)] = 38465,
  [SMALL_STATE(1787)] = 38486,
  [SMALL_STATE(1788)] = 38507,
  [SMALL_STATE(1789)] = 38528,
  [SMALL_STATE(1790)] = 38551,
  [SMALL_STATE(1791)] = 38572,
  [SMALL_STATE(1792)] = 38593,
  [SMALL_STATE(1793)] = 38614,
  [SMALL_STATE(1794)] = 38635,
  [SMALL_STATE(1795)] = 38656,
  [SMALL_STATE(1796)] = 38677,
  [SMALL_STATE(1797)] = 38698,
  [SMALL_STATE(1798)] = 38719,
  [SMALL_STATE(1799)] = 38740,
  [SMALL_STATE(1800)] = 38761,
  [SMALL_STATE(1801)] = 38782,
  [SMALL_STATE(1802)] = 38803,
  [SMALL_STATE(1803)] = 38824,
  [SMALL_STATE(1804)] = 38845,
  [SMALL_STATE(1805)] = 38868,
  [SMALL_STATE(1806)] = 38888,
  [SMALL_STATE(1807)] = 38908,
  [SMALL_STATE(1808)] = 38928,
  [SMALL_STATE(1809)] = 38948,
  [SMALL_STATE(1810)] = 38968,
  [SMALL_STATE(1811)] = 38986,
  [SMALL_STATE(1812)] = 39006,
  [SMALL_STATE(1813)] = 39024,
  [SMALL_STATE(1814)] = 39044,
  [SMALL_STATE(1815)] = 39064,
  [SMALL_STATE(1816)] = 39084,
  [SMALL_STATE(1817)] = 39104,
  [SMALL_STATE(1818)] = 39122,
  [SMALL_STATE(1819)] = 39138,
  [SMALL_STATE(1820)] = 39158,
  [SMALL_STATE(1821)] = 39178,
  [SMALL_STATE(1822)] = 39198,
  [SMALL_STATE(1823)] = 39218,
  [SMALL_STATE(1824)] = 39238,
  [SMALL_STATE(1825)] = 39258,
  [SMALL_STATE(1826)] = 39278,
  [SMALL_STATE(1827)] = 39296,
  [SMALL_STATE(1828)] = 39316,
  [SMALL_STATE(1829)] = 39336,
  [SMALL_STATE(1830)] = 39356,
  [SMALL_STATE(1831)] = 39376,
  [SMALL_STATE(1832)] = 39396,
  [SMALL_STATE(1833)] = 39416,
  [SMALL_STATE(1834)] = 39436,
  [SMALL_STATE(1835)] = 39456,
  [SMALL_STATE(1836)] = 39474,
  [SMALL_STATE(1837)] = 39494,
  [SMALL_STATE(1838)] = 39514,
  [SMALL_STATE(1839)] = 39534,
  [SMALL_STATE(1840)] = 39554,
  [SMALL_STATE(1841)] = 39574,
  [SMALL_STATE(1842)] = 39592,
  [SMALL_STATE(1843)] = 39612,
  [SMALL_STATE(1844)] = 39632,
  [SMALL_STATE(1845)] = 39652,
  [SMALL_STATE(1846)] = 39672,
  [SMALL_STATE(1847)] = 39692,
  [SMALL_STATE(1848)] = 39712,
  [SMALL_STATE(1849)] = 39732,
  [SMALL_STATE(1850)] = 39752,
  [SMALL_STATE(1851)] = 39772,
  [SMALL_STATE(1852)] = 39792,
  [SMALL_STATE(1853)] = 39810,
  [SMALL_STATE(1854)] = 39830,
  [SMALL_STATE(1855)] = 39850,
  [SMALL_STATE(1856)] = 39870,
  [SMALL_STATE(1857)] = 39887,
  [SMALL_STATE(1858)] = 39904,
  [SMALL_STATE(1859)] = 39921,
  [SMALL_STATE(1860)] = 39938,
  [SMALL_STATE(1861)] = 39955,
  [SMALL_STATE(1862)] = 39972,
  [SMALL_STATE(1863)] = 39989,
  [SMALL_STATE(1864)] = 40006,
  [SMALL_STATE(1865)] = 40021,
  [SMALL_STATE(1866)] = 40038,
  [SMALL_STATE(1867)] = 40055,
  [SMALL_STATE(1868)] = 40072,
  [SMALL_STATE(1869)] = 40087,
  [SMALL_STATE(1870)] = 40104,
  [SMALL_STATE(1871)] = 40121,
  [SMALL_STATE(1872)] = 40138,
  [SMALL_STATE(1873)] = 40155,
  [SMALL_STATE(1874)] = 40172,
  [SMALL_STATE(1875)] = 40189,
  [SMALL_STATE(1876)] = 40204,
  [SMALL_STATE(1877)] = 40221,
  [SMALL_STATE(1878)] = 40238,
  [SMALL_STATE(1879)] = 40255,
  [SMALL_STATE(1880)] = 40272,
  [SMALL_STATE(1881)] = 40289,
  [SMALL_STATE(1882)] = 40306,
  [SMALL_STATE(1883)] = 40321,
  [SMALL_STATE(1884)] = 40338,
  [SMALL_STATE(1885)] = 40355,
  [SMALL_STATE(1886)] = 40372,
  [SMALL_STATE(1887)] = 40389,
  [SMALL_STATE(1888)] = 40406,
  [SMALL_STATE(1889)] = 40423,
  [SMALL_STATE(1890)] = 40440,
  [SMALL_STATE(1891)] = 40457,
  [SMALL_STATE(1892)] = 40472,
  [SMALL_STATE(1893)] = 40489,
  [SMALL_STATE(1894)] = 40506,
  [SMALL_STATE(1895)] = 40523,
  [SMALL_STATE(1896)] = 40540,
  [SMALL_STATE(1897)] = 40557,
  [SMALL_STATE(1898)] = 40574,
  [SMALL_STATE(1899)] = 40591,
  [SMALL_STATE(1900)] = 40608,
  [SMALL_STATE(1901)] = 40625,
  [SMALL_STATE(1902)] = 40642,
  [SMALL_STATE(1903)] = 40659,
  [SMALL_STATE(1904)] = 40676,
  [SMALL_STATE(1905)] = 40693,
  [SMALL_STATE(1906)] = 40710,
  [SMALL_STATE(1907)] = 40727,
  [SMALL_STATE(1908)] = 40744,
  [SMALL_STATE(1909)] = 40761,
  [SMALL_STATE(1910)] = 40778,
  [SMALL_STATE(1911)] = 40795,
  [SMALL_STATE(1912)] = 40812,
  [SMALL_STATE(1913)] = 40829,
  [SMALL_STATE(1914)] = 40846,
  [SMALL_STATE(1915)] = 40863,
  [SMALL_STATE(1916)] = 40880,
  [SMALL_STATE(1917)] = 40897,
  [SMALL_STATE(1918)] = 40911,
  [SMALL_STATE(1919)] = 40925,
  [SMALL_STATE(1920)] = 40937,
  [SMALL_STATE(1921)] = 40951,
  [SMALL_STATE(1922)] = 40965,
  [SMALL_STATE(1923)] = 40979,
  [SMALL_STATE(1924)] = 40993,
  [SMALL_STATE(1925)] = 41007,
  [SMALL_STATE(1926)] = 41021,
  [SMALL_STATE(1927)] = 41035,
  [SMALL_STATE(1928)] = 41049,
  [SMALL_STATE(1929)] = 41063,
  [SMALL_STATE(1930)] = 41077,
  [SMALL_STATE(1931)] = 41091,
  [SMALL_STATE(1932)] = 41105,
  [SMALL_STATE(1933)] = 41119,
  [SMALL_STATE(1934)] = 41133,
  [SMALL_STATE(1935)] = 41147,
  [SMALL_STATE(1936)] = 41161,
  [SMALL_STATE(1937)] = 41175,
  [SMALL_STATE(1938)] = 41189,
  [SMALL_STATE(1939)] = 41203,
  [SMALL_STATE(1940)] = 41217,
  [SMALL_STATE(1941)] = 41231,
  [SMALL_STATE(1942)] = 41245,
  [SMALL_STATE(1943)] = 41259,
  [SMALL_STATE(1944)] = 41273,
  [SMALL_STATE(1945)] = 41287,
  [SMALL_STATE(1946)] = 41301,
  [SMALL_STATE(1947)] = 41315,
  [SMALL_STATE(1948)] = 41329,
  [SMALL_STATE(1949)] = 41343,
  [SMALL_STATE(1950)] = 41357,
  [SMALL_STATE(1951)] = 41371,
  [SMALL_STATE(1952)] = 41385,
  [SMALL_STATE(1953)] = 41399,
  [SMALL_STATE(1954)] = 41413,
  [SMALL_STATE(1955)] = 41427,
  [SMALL_STATE(1956)] = 41441,
  [SMALL_STATE(1957)] = 41455,
  [SMALL_STATE(1958)] = 41469,
  [SMALL_STATE(1959)] = 41483,
  [SMALL_STATE(1960)] = 41497,
  [SMALL_STATE(1961)] = 41511,
  [SMALL_STATE(1962)] = 41525,
  [SMALL_STATE(1963)] = 41535,
  [SMALL_STATE(1964)] = 41549,
  [SMALL_STATE(1965)] = 41563,
  [SMALL_STATE(1966)] = 41577,
  [SMALL_STATE(1967)] = 41591,
  [SMALL_STATE(1968)] = 41605,
  [SMALL_STATE(1969)] = 41619,
  [SMALL_STATE(1970)] = 41633,
  [SMALL_STATE(1971)] = 41647,
  [SMALL_STATE(1972)] = 41661,
  [SMALL_STATE(1973)] = 41675,
  [SMALL_STATE(1974)] = 41687,
  [SMALL_STATE(1975)] = 41701,
  [SMALL_STATE(1976)] = 41715,
  [SMALL_STATE(1977)] = 41729,
  [SMALL_STATE(1978)] = 41743,
  [SMALL_STATE(1979)] = 41757,
  [SMALL_STATE(1980)] = 41771,
  [SMALL_STATE(1981)] = 41785,
  [SMALL_STATE(1982)] = 41799,
  [SMALL_STATE(1983)] = 41813,
  [SMALL_STATE(1984)] = 41827,
  [SMALL_STATE(1985)] = 41841,
  [SMALL_STATE(1986)] = 41855,
  [SMALL_STATE(1987)] = 41869,
  [SMALL_STATE(1988)] = 41883,
  [SMALL_STATE(1989)] = 41897,
  [SMALL_STATE(1990)] = 41911,
  [SMALL_STATE(1991)] = 41925,
  [SMALL_STATE(1992)] = 41939,
  [SMALL_STATE(1993)] = 41949,
  [SMALL_STATE(1994)] = 41963,
  [SMALL_STATE(1995)] = 41977,
  [SMALL_STATE(1996)] = 41991,
  [SMALL_STATE(1997)] = 42003,
  [SMALL_STATE(1998)] = 42017,
  [SMALL_STATE(1999)] = 42031,
  [SMALL_STATE(2000)] = 42045,
  [SMALL_STATE(2001)] = 42059,
  [SMALL_STATE(2002)] = 42073,
  [SMALL_STATE(2003)] = 42087,
  [SMALL_STATE(2004)] = 42101,
  [SMALL_STATE(2005)] = 42115,
  [SMALL_STATE(2006)] = 42129,
  [SMALL_STATE(2007)] = 42143,
  [SMALL_STATE(2008)] = 42157,
  [SMALL_STATE(2009)] = 42167,
  [SMALL_STATE(2010)] = 42181,
  [SMALL_STATE(2011)] = 42195,
  [SMALL_STATE(2012)] = 42209,
  [SMALL_STATE(2013)] = 42223,
  [SMALL_STATE(2014)] = 42237,
  [SMALL_STATE(2015)] = 42251,
  [SMALL_STATE(2016)] = 42265,
  [SMALL_STATE(2017)] = 42279,
  [SMALL_STATE(2018)] = 42293,
  [SMALL_STATE(2019)] = 42307,
  [SMALL_STATE(2020)] = 42321,
  [SMALL_STATE(2021)] = 42335,
  [SMALL_STATE(2022)] = 42345,
  [SMALL_STATE(2023)] = 42359,
  [SMALL_STATE(2024)] = 42373,
  [SMALL_STATE(2025)] = 42387,
  [SMALL_STATE(2026)] = 42401,
  [SMALL_STATE(2027)] = 42415,
  [SMALL_STATE(2028)] = 42429,
  [SMALL_STATE(2029)] = 42443,
  [SMALL_STATE(2030)] = 42457,
  [SMALL_STATE(2031)] = 42471,
  [SMALL_STATE(2032)] = 42485,
  [SMALL_STATE(2033)] = 42499,
  [SMALL_STATE(2034)] = 42513,
  [SMALL_STATE(2035)] = 42527,
  [SMALL_STATE(2036)] = 42541,
  [SMALL_STATE(2037)] = 42553,
  [SMALL_STATE(2038)] = 42567,
  [SMALL_STATE(2039)] = 42581,
  [SMALL_STATE(2040)] = 42595,
  [SMALL_STATE(2041)] = 42609,
  [SMALL_STATE(2042)] = 42623,
  [SMALL_STATE(2043)] = 42633,
  [SMALL_STATE(2044)] = 42647,
  [SMALL_STATE(2045)] = 42661,
  [SMALL_STATE(2046)] = 42675,
  [SMALL_STATE(2047)] = 42689,
  [SMALL_STATE(2048)] = 42703,
  [SMALL_STATE(2049)] = 42713,
  [SMALL_STATE(2050)] = 42727,
  [SMALL_STATE(2051)] = 42741,
  [SMALL_STATE(2052)] = 42753,
  [SMALL_STATE(2053)] = 42767,
  [SMALL_STATE(2054)] = 42781,
  [SMALL_STATE(2055)] = 42791,
  [SMALL_STATE(2056)] = 42803,
  [SMALL_STATE(2057)] = 42813,
  [SMALL_STATE(2058)] = 42827,
  [SMALL_STATE(2059)] = 42841,
  [SMALL_STATE(2060)] = 42853,
  [SMALL_STATE(2061)] = 42867,
  [SMALL_STATE(2062)] = 42879,
  [SMALL_STATE(2063)] = 42893,
  [SMALL_STATE(2064)] = 42905,
  [SMALL_STATE(2065)] = 42919,
  [SMALL_STATE(2066)] = 42933,
  [SMALL_STATE(2067)] = 42947,
  [SMALL_STATE(2068)] = 42957,
  [SMALL_STATE(2069)] = 42971,
  [SMALL_STATE(2070)] = 42983,
  [SMALL_STATE(2071)] = 42997,
  [SMALL_STATE(2072)] = 43011,
  [SMALL_STATE(2073)] = 43025,
  [SMALL_STATE(2074)] = 43039,
  [SMALL_STATE(2075)] = 43053,
  [SMALL_STATE(2076)] = 43067,
  [SMALL_STATE(2077)] = 43081,
  [SMALL_STATE(2078)] = 43095,
  [SMALL_STATE(2079)] = 43109,
  [SMALL_STATE(2080)] = 43119,
  [SMALL_STATE(2081)] = 43133,
  [SMALL_STATE(2082)] = 43147,
  [SMALL_STATE(2083)] = 43161,
  [SMALL_STATE(2084)] = 43175,
  [SMALL_STATE(2085)] = 43189,
  [SMALL_STATE(2086)] = 43203,
  [SMALL_STATE(2087)] = 43217,
  [SMALL_STATE(2088)] = 43231,
  [SMALL_STATE(2089)] = 43245,
  [SMALL_STATE(2090)] = 43255,
  [SMALL_STATE(2091)] = 43269,
  [SMALL_STATE(2092)] = 43283,
  [SMALL_STATE(2093)] = 43295,
  [SMALL_STATE(2094)] = 43309,
  [SMALL_STATE(2095)] = 43323,
  [SMALL_STATE(2096)] = 43337,
  [SMALL_STATE(2097)] = 43349,
  [SMALL_STATE(2098)] = 43363,
  [SMALL_STATE(2099)] = 43375,
  [SMALL_STATE(2100)] = 43389,
  [SMALL_STATE(2101)] = 43403,
  [SMALL_STATE(2102)] = 43417,
  [SMALL_STATE(2103)] = 43431,
  [SMALL_STATE(2104)] = 43445,
  [SMALL_STATE(2105)] = 43459,
  [SMALL_STATE(2106)] = 43473,
  [SMALL_STATE(2107)] = 43487,
  [SMALL_STATE(2108)] = 43501,
  [SMALL_STATE(2109)] = 43515,
  [SMALL_STATE(2110)] = 43529,
  [SMALL_STATE(2111)] = 43543,
  [SMALL_STATE(2112)] = 43557,
  [SMALL_STATE(2113)] = 43567,
  [SMALL_STATE(2114)] = 43581,
  [SMALL_STATE(2115)] = 43595,
  [SMALL_STATE(2116)] = 43605,
  [SMALL_STATE(2117)] = 43615,
  [SMALL_STATE(2118)] = 43627,
  [SMALL_STATE(2119)] = 43638,
  [SMALL_STATE(2120)] = 43649,
  [SMALL_STATE(2121)] = 43660,
  [SMALL_STATE(2122)] = 43671,
  [SMALL_STATE(2123)] = 43682,
  [SMALL_STATE(2124)] = 43693,
  [SMALL_STATE(2125)] = 43702,
  [SMALL_STATE(2126)] = 43713,
  [SMALL_STATE(2127)] = 43724,
  [SMALL_STATE(2128)] = 43733,
  [SMALL_STATE(2129)] = 43744,
  [SMALL_STATE(2130)] = 43753,
  [SMALL_STATE(2131)] = 43762,
  [SMALL_STATE(2132)] = 43773,
  [SMALL_STATE(2133)] = 43784,
  [SMALL_STATE(2134)] = 43795,
  [SMALL_STATE(2135)] = 43806,
  [SMALL_STATE(2136)] = 43817,
  [SMALL_STATE(2137)] = 43828,
  [SMALL_STATE(2138)] = 43837,
  [SMALL_STATE(2139)] = 43848,
  [SMALL_STATE(2140)] = 43859,
  [SMALL_STATE(2141)] = 43870,
  [SMALL_STATE(2142)] = 43881,
  [SMALL_STATE(2143)] = 43892,
  [SMALL_STATE(2144)] = 43903,
  [SMALL_STATE(2145)] = 43914,
  [SMALL_STATE(2146)] = 43925,
  [SMALL_STATE(2147)] = 43936,
  [SMALL_STATE(2148)] = 43947,
  [SMALL_STATE(2149)] = 43958,
  [SMALL_STATE(2150)] = 43969,
  [SMALL_STATE(2151)] = 43978,
  [SMALL_STATE(2152)] = 43989,
  [SMALL_STATE(2153)] = 44000,
  [SMALL_STATE(2154)] = 44011,
  [SMALL_STATE(2155)] = 44020,
  [SMALL_STATE(2156)] = 44031,
  [SMALL_STATE(2157)] = 44042,
  [SMALL_STATE(2158)] = 44051,
  [SMALL_STATE(2159)] = 44062,
  [SMALL_STATE(2160)] = 44073,
  [SMALL_STATE(2161)] = 44084,
  [SMALL_STATE(2162)] = 44095,
  [SMALL_STATE(2163)] = 44106,
  [SMALL_STATE(2164)] = 44115,
  [SMALL_STATE(2165)] = 44126,
  [SMALL_STATE(2166)] = 44137,
  [SMALL_STATE(2167)] = 44148,
  [SMALL_STATE(2168)] = 44159,
  [SMALL_STATE(2169)] = 44170,
  [SMALL_STATE(2170)] = 44181,
  [SMALL_STATE(2171)] = 44192,
  [SMALL_STATE(2172)] = 44203,
  [SMALL_STATE(2173)] = 44214,
  [SMALL_STATE(2174)] = 44225,
  [SMALL_STATE(2175)] = 44236,
  [SMALL_STATE(2176)] = 44245,
  [SMALL_STATE(2177)] = 44256,
  [SMALL_STATE(2178)] = 44267,
  [SMALL_STATE(2179)] = 44278,
  [SMALL_STATE(2180)] = 44289,
  [SMALL_STATE(2181)] = 44300,
  [SMALL_STATE(2182)] = 44311,
  [SMALL_STATE(2183)] = 44322,
  [SMALL_STATE(2184)] = 44333,
  [SMALL_STATE(2185)] = 44344,
  [SMALL_STATE(2186)] = 44355,
  [SMALL_STATE(2187)] = 44366,
  [SMALL_STATE(2188)] = 44377,
  [SMALL_STATE(2189)] = 44388,
  [SMALL_STATE(2190)] = 44396,
  [SMALL_STATE(2191)] = 44404,
  [SMALL_STATE(2192)] = 44412,
  [SMALL_STATE(2193)] = 44420,
  [SMALL_STATE(2194)] = 44428,
  [SMALL_STATE(2195)] = 44436,
  [SMALL_STATE(2196)] = 44444,
  [SMALL_STATE(2197)] = 44452,
  [SMALL_STATE(2198)] = 44460,
  [SMALL_STATE(2199)] = 44468,
  [SMALL_STATE(2200)] = 44476,
  [SMALL_STATE(2201)] = 44484,
  [SMALL_STATE(2202)] = 44492,
  [SMALL_STATE(2203)] = 44500,
  [SMALL_STATE(2204)] = 44508,
  [SMALL_STATE(2205)] = 44516,
  [SMALL_STATE(2206)] = 44524,
  [SMALL_STATE(2207)] = 44532,
  [SMALL_STATE(2208)] = 44540,
  [SMALL_STATE(2209)] = 44548,
  [SMALL_STATE(2210)] = 44556,
  [SMALL_STATE(2211)] = 44564,
  [SMALL_STATE(2212)] = 44572,
  [SMALL_STATE(2213)] = 44580,
  [SMALL_STATE(2214)] = 44588,
  [SMALL_STATE(2215)] = 44596,
  [SMALL_STATE(2216)] = 44604,
  [SMALL_STATE(2217)] = 44612,
  [SMALL_STATE(2218)] = 44620,
  [SMALL_STATE(2219)] = 44628,
  [SMALL_STATE(2220)] = 44636,
  [SMALL_STATE(2221)] = 44644,
  [SMALL_STATE(2222)] = 44652,
  [SMALL_STATE(2223)] = 44660,
  [SMALL_STATE(2224)] = 44668,
  [SMALL_STATE(2225)] = 44676,
  [SMALL_STATE(2226)] = 44684,
  [SMALL_STATE(2227)] = 44692,
  [SMALL_STATE(2228)] = 44700,
  [SMALL_STATE(2229)] = 44708,
  [SMALL_STATE(2230)] = 44716,
  [SMALL_STATE(2231)] = 44724,
  [SMALL_STATE(2232)] = 44732,
  [SMALL_STATE(2233)] = 44740,
  [SMALL_STATE(2234)] = 44748,
  [SMALL_STATE(2235)] = 44756,
  [SMALL_STATE(2236)] = 44764,
  [SMALL_STATE(2237)] = 44772,
  [SMALL_STATE(2238)] = 44780,
  [SMALL_STATE(2239)] = 44788,
  [SMALL_STATE(2240)] = 44796,
  [SMALL_STATE(2241)] = 44804,
  [SMALL_STATE(2242)] = 44812,
  [SMALL_STATE(2243)] = 44820,
  [SMALL_STATE(2244)] = 44828,
  [SMALL_STATE(2245)] = 44836,
  [SMALL_STATE(2246)] = 44844,
  [SMALL_STATE(2247)] = 44852,
  [SMALL_STATE(2248)] = 44860,
  [SMALL_STATE(2249)] = 44868,
  [SMALL_STATE(2250)] = 44876,
  [SMALL_STATE(2251)] = 44884,
  [SMALL_STATE(2252)] = 44892,
  [SMALL_STATE(2253)] = 44900,
  [SMALL_STATE(2254)] = 44908,
  [SMALL_STATE(2255)] = 44916,
  [SMALL_STATE(2256)] = 44924,
  [SMALL_STATE(2257)] = 44932,
  [SMALL_STATE(2258)] = 44940,
  [SMALL_STATE(2259)] = 44948,
  [SMALL_STATE(2260)] = 44956,
  [SMALL_STATE(2261)] = 44964,
  [SMALL_STATE(2262)] = 44972,
  [SMALL_STATE(2263)] = 44980,
  [SMALL_STATE(2264)] = 44988,
  [SMALL_STATE(2265)] = 44996,
  [SMALL_STATE(2266)] = 45004,
  [SMALL_STATE(2267)] = 45012,
  [SMALL_STATE(2268)] = 45020,
  [SMALL_STATE(2269)] = 45028,
  [SMALL_STATE(2270)] = 45036,
  [SMALL_STATE(2271)] = 45044,
  [SMALL_STATE(2272)] = 45052,
  [SMALL_STATE(2273)] = 45060,
  [SMALL_STATE(2274)] = 45068,
  [SMALL_STATE(2275)] = 45076,
  [SMALL_STATE(2276)] = 45084,
  [SMALL_STATE(2277)] = 45092,
  [SMALL_STATE(2278)] = 45100,
  [SMALL_STATE(2279)] = 45108,
  [SMALL_STATE(2280)] = 45116,
  [SMALL_STATE(2281)] = 45124,
  [SMALL_STATE(2282)] = 45132,
  [SMALL_STATE(2283)] = 45140,
  [SMALL_STATE(2284)] = 45148,
  [SMALL_STATE(2285)] = 45156,
  [SMALL_STATE(2286)] = 45164,
  [SMALL_STATE(2287)] = 45172,
  [SMALL_STATE(2288)] = 45180,
  [SMALL_STATE(2289)] = 45188,
  [SMALL_STATE(2290)] = 45196,
  [SMALL_STATE(2291)] = 45204,
  [SMALL_STATE(2292)] = 45212,
  [SMALL_STATE(2293)] = 45220,
  [SMALL_STATE(2294)] = 45228,
  [SMALL_STATE(2295)] = 45236,
  [SMALL_STATE(2296)] = 45244,
  [SMALL_STATE(2297)] = 45252,
  [SMALL_STATE(2298)] = 45260,
  [SMALL_STATE(2299)] = 45268,
  [SMALL_STATE(2300)] = 45276,
  [SMALL_STATE(2301)] = 45284,
  [SMALL_STATE(2302)] = 45292,
  [SMALL_STATE(2303)] = 45300,
  [SMALL_STATE(2304)] = 45308,
  [SMALL_STATE(2305)] = 45316,
  [SMALL_STATE(2306)] = 45324,
  [SMALL_STATE(2307)] = 45332,
  [SMALL_STATE(2308)] = 45340,
  [SMALL_STATE(2309)] = 45348,
  [SMALL_STATE(2310)] = 45356,
  [SMALL_STATE(2311)] = 45364,
  [SMALL_STATE(2312)] = 45372,
  [SMALL_STATE(2313)] = 45380,
  [SMALL_STATE(2314)] = 45388,
  [SMALL_STATE(2315)] = 45396,
  [SMALL_STATE(2316)] = 45404,
  [SMALL_STATE(2317)] = 45412,
  [SMALL_STATE(2318)] = 45420,
  [SMALL_STATE(2319)] = 45428,
  [SMALL_STATE(2320)] = 45436,
  [SMALL_STATE(2321)] = 45444,
  [SMALL_STATE(2322)] = 45452,
  [SMALL_STATE(2323)] = 45460,
  [SMALL_STATE(2324)] = 45468,
  [SMALL_STATE(2325)] = 45476,
  [SMALL_STATE(2326)] = 45484,
  [SMALL_STATE(2327)] = 45492,
  [SMALL_STATE(2328)] = 45500,
  [SMALL_STATE(2329)] = 45508,
  [SMALL_STATE(2330)] = 45516,
  [SMALL_STATE(2331)] = 45524,
  [SMALL_STATE(2332)] = 45532,
  [SMALL_STATE(2333)] = 45540,
  [SMALL_STATE(2334)] = 45548,
  [SMALL_STATE(2335)] = 45556,
  [SMALL_STATE(2336)] = 45564,
  [SMALL_STATE(2337)] = 45572,
  [SMALL_STATE(2338)] = 45580,
  [SMALL_STATE(2339)] = 45588,
  [SMALL_STATE(2340)] = 45596,
  [SMALL_STATE(2341)] = 45604,
  [SMALL_STATE(2342)] = 45612,
  [SMALL_STATE(2343)] = 45620,
  [SMALL_STATE(2344)] = 45628,
  [SMALL_STATE(2345)] = 45636,
  [SMALL_STATE(2346)] = 45644,
  [SMALL_STATE(2347)] = 45652,
  [SMALL_STATE(2348)] = 45660,
  [SMALL_STATE(2349)] = 45668,
  [SMALL_STATE(2350)] = 45676,
  [SMALL_STATE(2351)] = 45684,
  [SMALL_STATE(2352)] = 45692,
  [SMALL_STATE(2353)] = 45700,
  [SMALL_STATE(2354)] = 45708,
  [SMALL_STATE(2355)] = 45716,
  [SMALL_STATE(2356)] = 45724,
  [SMALL_STATE(2357)] = 45732,
  [SMALL_STATE(2358)] = 45740,
  [SMALL_STATE(2359)] = 45748,
  [SMALL_STATE(2360)] = 45756,
  [SMALL_STATE(2361)] = 45764,
  [SMALL_STATE(2362)] = 45772,
  [SMALL_STATE(2363)] = 45780,
  [SMALL_STATE(2364)] = 45788,
  [SMALL_STATE(2365)] = 45796,
  [SMALL_STATE(2366)] = 45804,
  [SMALL_STATE(2367)] = 45812,
  [SMALL_STATE(2368)] = 45820,
  [SMALL_STATE(2369)] = 45828,
  [SMALL_STATE(2370)] = 45836,
  [SMALL_STATE(2371)] = 45844,
  [SMALL_STATE(2372)] = 45852,
  [SMALL_STATE(2373)] = 45860,
  [SMALL_STATE(2374)] = 45868,
  [SMALL_STATE(2375)] = 45876,
  [SMALL_STATE(2376)] = 45884,
  [SMALL_STATE(2377)] = 45892,
  [SMALL_STATE(2378)] = 45900,
  [SMALL_STATE(2379)] = 45908,
  [SMALL_STATE(2380)] = 45916,
  [SMALL_STATE(2381)] = 45924,
  [SMALL_STATE(2382)] = 45932,
  [SMALL_STATE(2383)] = 45940,
  [SMALL_STATE(2384)] = 45948,
  [SMALL_STATE(2385)] = 45956,
  [SMALL_STATE(2386)] = 45964,
  [SMALL_STATE(2387)] = 45972,
  [SMALL_STATE(2388)] = 45980,
  [SMALL_STATE(2389)] = 45988,
  [SMALL_STATE(2390)] = 45996,
  [SMALL_STATE(2391)] = 46004,
  [SMALL_STATE(2392)] = 46012,
  [SMALL_STATE(2393)] = 46020,
  [SMALL_STATE(2394)] = 46028,
  [SMALL_STATE(2395)] = 46036,
  [SMALL_STATE(2396)] = 46044,
  [SMALL_STATE(2397)] = 46052,
  [SMALL_STATE(2398)] = 46060,
  [SMALL_STATE(2399)] = 46068,
  [SMALL_STATE(2400)] = 46076,
  [SMALL_STATE(2401)] = 46084,
  [SMALL_STATE(2402)] = 46092,
  [SMALL_STATE(2403)] = 46100,
  [SMALL_STATE(2404)] = 46108,
  [SMALL_STATE(2405)] = 46116,
  [SMALL_STATE(2406)] = 46124,
  [SMALL_STATE(2407)] = 46132,
  [SMALL_STATE(2408)] = 46140,
  [SMALL_STATE(2409)] = 46148,
  [SMALL_STATE(2410)] = 46156,
  [SMALL_STATE(2411)] = 46164,
  [SMALL_STATE(2412)] = 46172,
  [SMALL_STATE(2413)] = 46180,
  [SMALL_STATE(2414)] = 46188,
  [SMALL_STATE(2415)] = 46196,
  [SMALL_STATE(2416)] = 46204,
  [SMALL_STATE(2417)] = 46212,
  [SMALL_STATE(2418)] = 46220,
  [SMALL_STATE(2419)] = 46228,
  [SMALL_STATE(2420)] = 46236,
  [SMALL_STATE(2421)] = 46244,
  [SMALL_STATE(2422)] = 46252,
  [SMALL_STATE(2423)] = 46260,
  [SMALL_STATE(2424)] = 46268,
  [SMALL_STATE(2425)] = 46276,
  [SMALL_STATE(2426)] = 46284,
  [SMALL_STATE(2427)] = 46292,
  [SMALL_STATE(2428)] = 46300,
  [SMALL_STATE(2429)] = 46308,
  [SMALL_STATE(2430)] = 46316,
  [SMALL_STATE(2431)] = 46324,
  [SMALL_STATE(2432)] = 46332,
  [SMALL_STATE(2433)] = 46340,
  [SMALL_STATE(2434)] = 46348,
  [SMALL_STATE(2435)] = 46356,
  [SMALL_STATE(2436)] = 46364,
  [SMALL_STATE(2437)] = 46372,
  [SMALL_STATE(2438)] = 46380,
  [SMALL_STATE(2439)] = 46388,
  [SMALL_STATE(2440)] = 46396,
  [SMALL_STATE(2441)] = 46404,
  [SMALL_STATE(2442)] = 46412,
  [SMALL_STATE(2443)] = 46420,
  [SMALL_STATE(2444)] = 46428,
  [SMALL_STATE(2445)] = 46436,
  [SMALL_STATE(2446)] = 46444,
  [SMALL_STATE(2447)] = 46452,
  [SMALL_STATE(2448)] = 46460,
  [SMALL_STATE(2449)] = 46468,
  [SMALL_STATE(2450)] = 46476,
  [SMALL_STATE(2451)] = 46484,
  [SMALL_STATE(2452)] = 46492,
  [SMALL_STATE(2453)] = 46500,
  [SMALL_STATE(2454)] = 46508,
  [SMALL_STATE(2455)] = 46516,
  [SMALL_STATE(2456)] = 46524,
  [SMALL_STATE(2457)] = 46532,
  [SMALL_STATE(2458)] = 46540,
  [SMALL_STATE(2459)] = 46548,
  [SMALL_STATE(2460)] = 46556,
  [SMALL_STATE(2461)] = 46564,
  [SMALL_STATE(2462)] = 46572,
  [SMALL_STATE(2463)] = 46580,
  [SMALL_STATE(2464)] = 46588,
  [SMALL_STATE(2465)] = 46596,
  [SMALL_STATE(2466)] = 46604,
  [SMALL_STATE(2467)] = 46612,
  [SMALL_STATE(2468)] = 46620,
  [SMALL_STATE(2469)] = 46628,
  [SMALL_STATE(2470)] = 46636,
  [SMALL_STATE(2471)] = 46644,
  [SMALL_STATE(2472)] = 46652,
  [SMALL_STATE(2473)] = 46660,
  [SMALL_STATE(2474)] = 46668,
  [SMALL_STATE(2475)] = 46676,
  [SMALL_STATE(2476)] = 46684,
  [SMALL_STATE(2477)] = 46692,
  [SMALL_STATE(2478)] = 46700,
  [SMALL_STATE(2479)] = 46708,
  [SMALL_STATE(2480)] = 46716,
  [SMALL_STATE(2481)] = 46724,
  [SMALL_STATE(2482)] = 46732,
  [SMALL_STATE(2483)] = 46740,
  [SMALL_STATE(2484)] = 46748,
  [SMALL_STATE(2485)] = 46756,
  [SMALL_STATE(2486)] = 46764,
  [SMALL_STATE(2487)] = 46772,
  [SMALL_STATE(2488)] = 46780,
  [SMALL_STATE(2489)] = 46788,
  [SMALL_STATE(2490)] = 46796,
  [SMALL_STATE(2491)] = 46804,
  [SMALL_STATE(2492)] = 46812,
  [SMALL_STATE(2493)] = 46820,
  [SMALL_STATE(2494)] = 46828,
  [SMALL_STATE(2495)] = 46836,
  [SMALL_STATE(2496)] = 46844,
  [SMALL_STATE(2497)] = 46852,
  [SMALL_STATE(2498)] = 46860,
  [SMALL_STATE(2499)] = 46868,
  [SMALL_STATE(2500)] = 46876,
  [SMALL_STATE(2501)] = 46884,
  [SMALL_STATE(2502)] = 46892,
  [SMALL_STATE(2503)] = 46900,
  [SMALL_STATE(2504)] = 46908,
  [SMALL_STATE(2505)] = 46916,
  [SMALL_STATE(2506)] = 46924,
  [SMALL_STATE(2507)] = 46932,
  [SMALL_STATE(2508)] = 46940,
  [SMALL_STATE(2509)] = 46948,
  [SMALL_STATE(2510)] = 46956,
  [SMALL_STATE(2511)] = 46964,
  [SMALL_STATE(2512)] = 46972,
  [SMALL_STATE(2513)] = 46980,
  [SMALL_STATE(2514)] = 46988,
  [SMALL_STATE(2515)] = 46996,
  [SMALL_STATE(2516)] = 47004,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1774),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [27] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 1, 0, 0),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(686),
  [31] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 1, 0, 0),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(842),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(841),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [51] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 1, 0, 0),
  [53] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 1, 0, 0),
  [55] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 1, 0, 0),
  [57] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 1, 0, 0),
  [59] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 1, 0, 0),
  [61] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 1, 0, 0),
  [63] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(324),
  [66] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0),
  [68] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1751),
  [71] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(607),
  [74] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0),
  [76] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2218),
  [79] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(831),
  [82] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1727),
  [85] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(839),
  [88] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(390),
  [91] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(321),
  [94] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(850),
  [97] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(850),
  [100] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(606),
  [103] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(606),
  [106] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1248),
  [109] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1982),
  [112] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(614),
  [115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(621),
  [118] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1880),
  [121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(598),
  [124] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(478),
  [127] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(605),
  [130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(5),
  [133] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4),
  [136] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3),
  [139] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1738),
  [142] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1382),
  [145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(400),
  [148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(400),
  [151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1787),
  [154] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1935),
  [157] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1817),
  [160] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(396),
  [163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2, 0, 0),
  [165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2, 0, 0),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(845),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(835),
  [191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(274),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(186),
  [246] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1754),
  [249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(594),
  [252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2230),
  [255] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(855),
  [258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1750),
  [261] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(843),
  [264] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(270),
  [267] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(377),
  [270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(856),
  [273] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(856),
  [276] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1296),
  [279] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2114),
  [282] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(617),
  [285] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(616),
  [288] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1900),
  [291] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(615),
  [294] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(479),
  [297] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(613),
  [300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(13),
  [303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(11),
  [306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(12),
  [309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1748),
  [312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1385),
  [315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(274),
  [318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(274),
  [321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1770),
  [324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2087),
  [327] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1835),
  [330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(275),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(831),
  [343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1787),
  [385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1770),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(723),
  [399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(783),
  [401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(799),
  [425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(784),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1772),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(781),
  [506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(775),
  [509] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(775),
  [512] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(38),
  [515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(33),
  [518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(32),
  [521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(472),
  [524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1752),
  [527] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(618),
  [530] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2513),
  [533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(810),
  [536] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1721),
  [539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(785),
  [542] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(560),
  [545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(470),
  [548] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(797),
  [551] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(797),
  [554] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1241),
  [557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1961),
  [560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(619),
  [563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(620),
  [566] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1887),
  [569] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(593),
  [572] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(500),
  [575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(602),
  [578] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(41),
  [581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(45),
  [584] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(44),
  [587] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1749),
  [590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1403),
  [593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(561),
  [596] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(561),
  [599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1772),
  [602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2062),
  [605] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1841),
  [608] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(562),
  [611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_type, 2, 0, 4),
  [613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_base_type, 2, 0, 4),
  [615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2209),
  [617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_type, 1, 0, 1),
  [621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_base_type, 1, 0, 1),
  [623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_type_repeat1, 2, 0, 0),
  [625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_base_type_repeat1, 2, 0, 0),
  [627] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_base_type_repeat1, 2, 0, 0), SHIFT_REPEAT(2209),
  [630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_type, 6, 0, 16),
  [632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_type, 6, 0, 16),
  [634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_type, 6, 0, 19),
  [636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_type, 6, 0, 19),
  [638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_args, 4, 0, 0),
  [640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_args, 4, 0, 0),
  [642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_type, 3, 0, 4),
  [644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_base_type, 3, 0, 4),
  [646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_type, 9, 0, 20),
  [648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_type, 9, 0, 20),
  [650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_type, 3, 0, 0),
  [652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_type, 3, 0, 0),
  [654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_type, 9, 0, 24),
  [656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_type, 9, 0, 24),
  [658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_type, 4, 0, 11),
  [660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_type, 4, 0, 11),
  [662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_type, 5, 0, 0),
  [664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_type, 5, 0, 0),
  [666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_args, 3, 0, 0),
  [668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_args, 3, 0, 0),
  [670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_type, 5, 0, 16),
  [672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_type, 5, 0, 16),
  [674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_type, 5, 0, 11),
  [676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_type, 5, 0, 11),
  [678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, 0, 0),
  [680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 1, 0, 0),
  [682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_type, 9, 0, 26),
  [706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_type, 9, 0, 26),
  [708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_type, 6, 0, 0),
  [710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_type, 6, 0, 0),
  [712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_type, 6, 0, 18),
  [714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_type, 6, 0, 18),
  [716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_type, 6, 0, 12),
  [718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_type, 6, 0, 12),
  [720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_type, 6, 0, 5),
  [722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_type, 6, 0, 5),
  [724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_type, 2, 0, 1),
  [726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_base_type, 2, 0, 1),
  [728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_type, 4, 0, 0),
  [730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_type, 4, 0, 0),
  [732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_type, 5, 0, 5),
  [734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_type, 5, 0, 5),
  [736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_type, 7, 0, 17),
  [738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_type, 7, 0, 17),
  [740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_type, 7, 0, 18),
  [742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_type, 7, 0, 18),
  [744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_type, 7, 0, 0),
  [746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_type, 7, 0, 0),
  [748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_type, 7, 0, 21),
  [750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_type, 7, 0, 21),
  [752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_type, 7, 0, 12),
  [754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_type, 7, 0, 12),
  [756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_type, 7, 0, 22),
  [758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_type, 7, 0, 22),
  [760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_type, 7, 0, 19),
  [762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_type, 7, 0, 19),
  [764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_type, 10, 0, 26),
  [766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_type, 10, 0, 26),
  [768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_type, 8, 0, 17),
  [770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_type, 8, 0, 17),
  [772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_type, 8, 0, 24),
  [774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_type, 8, 0, 24),
  [776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_type, 8, 0, 20),
  [778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_type, 8, 0, 20),
  [780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_type, 8, 0, 21),
  [782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_type, 8, 0, 21),
  [784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_type, 8, 0, 22),
  [786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_type, 8, 0, 22),
  [788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2207),
  [790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [792] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_base_type_repeat1, 2, 0, 0), SHIFT_REPEAT(2207),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_viewpoint_type, 3, 0, 0),
  [819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_viewpoint_type, 3, 0, 0),
  [821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 14, 0, 0),
  [833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 14, 0, 0),
  [835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 13, 0, 0),
  [839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 13, 0, 0),
  [841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 12, 0, 0),
  [843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 12, 0, 0),
  [845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 11, 0, 0),
  [847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 11, 0, 0),
  [849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 10, 0, 0),
  [851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 10, 0, 0),
  [853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 7, 0, 0),
  [855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 7, 0, 0),
  [857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4, 0, 0),
  [859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4, 0, 0),
  [861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 6, 0, 0),
  [863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 6, 0, 0),
  [865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 9, 0, 0),
  [867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 9, 0, 0),
  [869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_union_type_repeat1, 2, 0, 0),
  [871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_union_type_repeat1, 2, 0, 0),
  [873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 8, 0, 0),
  [875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 8, 0, 0),
  [877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 3, 0, 0),
  [879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 3, 0, 0),
  [881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_intersection_type_repeat1, 2, 0, 0),
  [883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_intersection_type_repeat1, 2, 0, 0),
  [885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 2, 0, 0),
  [887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 2, 0, 0),
  [889] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_intersection_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1271),
  [892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 2, 0, 0),
  [894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 2, 0, 0),
  [896] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1269),
  [899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iso_type, 2, 0, 0),
  [901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iso_type, 2, 0, 0),
  [903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_box_type, 2, 0, 0),
  [905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_box_type, 2, 0, 0),
  [907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_val_type, 2, 0, 0),
  [909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_val_type, 2, 0, 0),
  [911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tag_type, 2, 0, 0),
  [913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tag_type, 2, 0, 0),
  [915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_type, 2, 0, 0),
  [917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ref_type, 2, 0, 0),
  [919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trn_type, 2, 0, 0),
  [921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trn_type, 2, 0, 0),
  [923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 3, 0, 0),
  [925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 3, 0, 0),
  [927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_read_type, 2, 0, 0),
  [929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_read_type, 2, 0, 0),
  [931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 4, 0, 0),
  [933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 4, 0, 0),
  [935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_any_type, 2, 0, 0),
  [937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_any_type, 2, 0, 0),
  [939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 4, 0, 0),
  [941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 4, 0, 0),
  [943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_send_type, 2, 0, 0),
  [945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_send_type, 2, 0, 0),
  [947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4, 0, 0),
  [949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 4, 0, 0),
  [951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_share_type, 2, 0, 0),
  [953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_share_type, 2, 0, 0),
  [955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ephemeral_type, 2, 0, 0),
  [957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ephemeral_type, 2, 0, 0),
  [959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_aliased_type, 2, 0, 0),
  [961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_aliased_type, 2, 0, 0),
  [963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_type, 2, 0, 0),
  [965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_type, 2, 0, 0),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2477),
  [981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [983] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1239),
  [986] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_intersection_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1238),
  [989] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_base_type_repeat1, 2, 0, 0), SHIFT_REPEAT(2477),
  [992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [994] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_partial_application, 3, 0, 0),
  [1000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_partial_application, 3, 0, 0),
  [1002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 5, 0, 14),
  [1004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 5, 0, 14),
  [1006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ffi_identifier, 2, 0, 0),
  [1008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ffi_identifier, 2, 0, 0),
  [1010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 2, 0, 0),
  [1012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 2, 0, 0),
  [1014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [1016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_literal, 3, 0, 0),
  [1018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_literal, 3, 0, 0),
  [1020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__multiline_string_literal, 2, 0, 0),
  [1022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__multiline_string_literal, 2, 0, 0),
  [1024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_literal, 2, 0, 0),
  [1026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_literal, 2, 0, 0),
  [1028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__multiline_string_literal, 3, 0, 0),
  [1030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__multiline_string_literal, 3, 0, 0),
  [1032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2, 0, 0),
  [1034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2, 0, 0),
  [1036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, 0, 0),
  [1038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, 0, 0),
  [1040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 1, 0, 0),
  [1042] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 1, 0, 0),
  [1044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4, 0, 14),
  [1046] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4, 0, 14),
  [1048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4, 0, 10),
  [1050] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4, 0, 10),
  [1052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3, 0, 0),
  [1054] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3, 0, 0),
  [1056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3, 0, 10),
  [1058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3, 0, 10),
  [1060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, 0, 3),
  [1062] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, 0, 3),
  [1064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [1066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 6, 0, 0),
  [1068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 6, 0, 0),
  [1070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [1072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2, 0, 0),
  [1074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [1076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [1078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2, 0, 0),
  [1080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2, 0, 0),
  [1082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_consume_statement, 2, 0, 0),
  [1084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_consume_statement, 2, 0, 0),
  [1086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_literal, 2, 0, 0),
  [1088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_literal, 2, 0, 0),
  [1090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 5, 0, 0),
  [1092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 5, 0, 0),
  [1094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_expression, 2, 0, 0),
  [1096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_expression, 2, 0, 0),
  [1098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 5, 0, 0),
  [1100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 5, 0, 0),
  [1102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iftype_statement, 7, 0, 0),
  [1104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iftype_statement, 7, 0, 0),
  [1106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 3, 0, 0),
  [1108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 3, 0, 0),
  [1110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 3, 0, 0),
  [1112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 3, 0, 0),
  [1114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, 0, 0),
  [1116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, 0, 0),
  [1118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, 0, 13),
  [1120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 5, 0, 13),
  [1122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_statement, 5, 0, 0),
  [1124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_statement, 5, 0, 0),
  [1126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recover_statement, 5, 0, 0),
  [1128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recover_statement, 5, 0, 0),
  [1130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 5, 0, 0),
  [1132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 5, 0, 0),
  [1134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_statement, 5, 0, 0),
  [1136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_statement, 5, 0, 0),
  [1138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_literal, 5, 0, 0),
  [1140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_literal, 5, 0, 0),
  [1142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [1144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [1146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_literal, 5, 0, 0),
  [1148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_literal, 5, 0, 0),
  [1150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [1152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [1154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [1156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [1158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [1160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [1162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [1164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [1166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [1168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [1170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [1172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 0),
  [1174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 0),
  [1176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iftype_statement, 8, 0, 0),
  [1178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iftype_statement, 8, 0, 0),
  [1180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 0),
  [1182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 0),
  [1184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, 0, 0),
  [1186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, 0, 0),
  [1188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_literal, 3, 0, 0),
  [1190] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_literal, 3, 0, 0),
  [1192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_literal, 4, 0, 0),
  [1194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_literal, 4, 0, 0),
  [1196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_statement, 4, 0, 0),
  [1198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_statement, 4, 0, 0),
  [1200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recover_statement, 4, 0, 0),
  [1202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recover_statement, 4, 0, 0),
  [1204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 4, 0, 0),
  [1206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 4, 0, 0),
  [1208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recover_statement, 3, 0, 0),
  [1210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recover_statement, 3, 0, 0),
  [1212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, 0, 0),
  [1214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, 0, 0),
  [1216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 4, 0, 0),
  [1218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 4, 0, 0),
  [1220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal, 1, 0, 0),
  [1222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal, 1, 0, 0),
  [1224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean, 1, 0, 0),
  [1226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean, 1, 0, 0),
  [1228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 15, 0, 0),
  [1230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 15, 0, 0),
  [1232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_literal, 6, 0, 0),
  [1234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_literal, 6, 0, 0),
  [1236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 6, 0, 0),
  [1238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 6, 0, 0),
  [1240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_consume_statement, 3, 0, 0),
  [1242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_consume_statement, 3, 0, 0),
  [1244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iftype_statement, 6, 0, 0),
  [1246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iftype_statement, 6, 0, 0),
  [1248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_literal, 3, 0, 0),
  [1250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_literal, 3, 0, 0),
  [1252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 4, 0, 0),
  [1254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 4, 0, 0),
  [1256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_statement, 6, 0, 0),
  [1258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_statement, 6, 0, 0),
  [1260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_statement, 6, 0, 0),
  [1262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_statement, 6, 0, 0),
  [1264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_statement, 8, 0, 0),
  [1266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_statement, 8, 0, 0),
  [1268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_statement, 7, 0, 0),
  [1270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_statement, 7, 0, 0),
  [1272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_literal, 2, 0, 0),
  [1274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_literal, 2, 0, 0),
  [1276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compile_error, 2, 0, 0),
  [1278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compile_error, 2, 0, 0),
  [1280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character, 3, 0, 0),
  [1282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character, 3, 0, 0),
  [1284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, 0, 0),
  [1286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, 0, 0),
  [1288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_capability, 1, 0, 0),
  [1290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_capability, 1, 0, 0),
  [1292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, 0, 3),
  [1294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, 0, 3),
  [1296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compile_error, 1, 0, 0),
  [1298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compile_error, 1, 0, 0),
  [1300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, 0, 0),
  [1302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, 0, 0),
  [1304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_literal, 6, 0, 0),
  [1306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_literal, 6, 0, 0),
  [1308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [1310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [1312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [1314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 1, 0, 0),
  [1316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 1, 0, 0),
  [1318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 2),
  [1320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 2),
  [1322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 6),
  [1324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 6),
  [1326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_chain_expression, 3, 0, 0),
  [1328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chain_expression, 3, 0, 0),
  [1330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [1332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [1334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [1336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [1338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [1340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [1342] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_intersection_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1338),
  [1345] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1337),
  [1348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [1350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [1352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [1354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(850),
  [1356] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(855),
  [1359] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(831),
  [1362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [1364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [1366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [1368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [1370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [1372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_while_statement_repeat1, 1, 0, 0),
  [1374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(663),
  [1376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_while_statement_repeat1, 1, 0, 0),
  [1378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [1380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [1382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [1384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [1386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [1388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(775),
  [1390] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(810),
  [1393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [1395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [1401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [1413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [1417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [1421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [1457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(958),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [1469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [1473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [1481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [1491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [1497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [1499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [1503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1042),
  [1505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [1509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [1511] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(324),
  [1514] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1751),
  [1517] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(607),
  [1520] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2218),
  [1523] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(831),
  [1526] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1727),
  [1529] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(390),
  [1532] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(321),
  [1535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(815),
  [1538] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(815),
  [1541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(606),
  [1544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(606),
  [1547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1248),
  [1550] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1982),
  [1553] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(614),
  [1556] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(621),
  [1559] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1880),
  [1562] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(598),
  [1565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0),
  [1567] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(478),
  [1570] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(605),
  [1573] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(52),
  [1576] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(53),
  [1579] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(54),
  [1582] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1738),
  [1585] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1382),
  [1588] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(400),
  [1591] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(400),
  [1594] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1787),
  [1597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1935),
  [1600] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1817),
  [1603] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(396),
  [1606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [1608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [1610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [1612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(846),
  [1614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [1616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [1618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [1620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [1622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [1624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [1626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [1628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [1630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [1632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2347),
  [1634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [1636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 6, 0, 8),
  [1638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(709),
  [1640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(851),
  [1642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(852),
  [1644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [1646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [1648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [1650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_base_type_repeat1, 2, 0, 0), SHIFT_REPEAT(2347),
  [1653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [1655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [1657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [1659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [1661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [1663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [1665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [1667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [1669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [1671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [1673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [1675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(644),
  [1677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(776),
  [1679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(814),
  [1681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [1683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [1685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [1687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [1689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(932),
  [1691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [1693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [1695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [1697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [1699] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_intersection_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1259),
  [1702] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1262),
  [1705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(786),
  [1707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [1709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [1711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(657),
  [1713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [1715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [1717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [1719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [1721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [1723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [1725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [1727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [1729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [1731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [1733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [1735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(787),
  [1737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [1739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [1741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [1743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [1745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [1747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [1749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [1751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0),
  [1753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0),
  [1755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [1757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [1759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [1761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [1763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [1765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [1767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [1769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0),
  [1771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [1773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [1775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [1777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [1779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [1781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [1783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [1785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [1787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [1789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [1791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [1793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [1795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [1797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [1799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [1801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [1803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [1805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [1807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [1809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [1811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [1813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2293),
  [1815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [1817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [1819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [1821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_lambda_captures_repeat1, 4, 0, 0),
  [1823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 5, 0, 1),
  [1825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_lambda_captures_repeat1, 6, 0, 0),
  [1827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_parameter, 3, 0, 1),
  [1829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_parameter, 5, 0, 1),
  [1831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_argument, 3, 0, 0),
  [1833] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_base_type_repeat1, 2, 0, 0), SHIFT_REPEAT(2293),
  [1836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 4, 0, 0),
  [1838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 4, 0, 0),
  [1840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 3, 0, 0),
  [1842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 3, 0, 0),
  [1844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [1846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [1848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [1850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [1852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [1854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [1856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [1858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [1860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [1862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [1864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [1866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [1868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [1870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [1872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [1874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [1876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_definition, 7, 0, 0),
  [1878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [1880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [1882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [1884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [1886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_definition, 4, 0, 0),
  [1888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_definition, 4, 0, 0),
  [1890] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1278),
  [1893] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_intersection_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1288),
  [1896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_actor_definition, 6, 0, 0),
  [1898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_actor_definition, 4, 0, 0),
  [1900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_definition, 7, 0, 0),
  [1902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 6, 0, 0),
  [1904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_definition, 6, 0, 0),
  [1906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_definition, 4, 0, 0),
  [1908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 5, 0, 0),
  [1910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_definition, 6, 0, 0),
  [1912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 7, 0, 0),
  [1914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_definition, 6, 0, 0),
  [1916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_definition, 5, 0, 0),
  [1918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 6, 0, 0),
  [1920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_actor_definition, 5, 0, 0),
  [1922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 7, 0, 0),
  [1924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_definition, 5, 0, 0),
  [1926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_definition, 5, 0, 0),
  [1928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 4, 0, 0),
  [1930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 4, 0, 0),
  [1932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 5, 0, 0),
  [1934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [1936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [1938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [1940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [1942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_actor_definition, 3, 0, 0),
  [1944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [1946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_definition, 2, 0, 0),
  [1948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [1950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_definition, 2, 0, 0),
  [1952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [1954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_definition, 3, 0, 0),
  [1956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [1958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_definition, 3, 0, 0),
  [1960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [1962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [1964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 3, 0, 0),
  [1966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [1968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 3, 0, 0),
  [1970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [1972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_definition, 3, 0, 0),
  [1974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [1976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_actor_definition, 2, 0, 0),
  [1978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [1980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 2, 0, 0),
  [1982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [1984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 2, 0, 0),
  [1986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [1988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_definition, 2, 0, 0),
  [1990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [1992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [1994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [1996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [1998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [2000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [2002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [2004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 4, 0, 8),
  [2006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [2008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [2010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [2012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [2014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [2016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [2018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 5, 0, 12),
  [2020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [2022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [2024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 7, 0, 20),
  [2026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [2028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [2030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1962),
  [2032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 8, 0, 23),
  [2034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [2036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [2038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 6, 0, 17),
  [2040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [2042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [2044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 9, 0, 25),
  [2046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [2048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [2050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [2052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [2054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [2056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [2058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [2060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [2062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2439),
  [2064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [2066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [2068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [2070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [2072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [2074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [2076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [2078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [2080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [2082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [2084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [2086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [2088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [2090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 8, 0, 0),
  [2092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 8, 0, 0),
  [2094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1289),
  [2096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2500),
  [2098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [2100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [2102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [2104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [2106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1229),
  [2108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [2110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_definition, 7, 0, 0),
  [2112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [2114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [2116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1365),
  [2118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [2120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_definition, 8, 0, 0),
  [2122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_definition, 8, 0, 0),
  [2124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_actor_definition, 7, 0, 0),
  [2126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias, 5, 0, 5),
  [2128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [2130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [2132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [2134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [2136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [2138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias, 4, 0, 0),
  [2140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [2142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [2144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_members, 1, 0, 0),
  [2146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [2148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2, 0, 0),
  [2150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 2, 0, 0),
  [2152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 3, 0, 0),
  [2154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [2156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [2158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [2160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 6, 0, 0),
  [2162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [2164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [2166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [2168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 4, 0, 0),
  [2170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 4, 0, 0),
  [2172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 4, 0, 0),
  [2174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [2176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [2178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [2180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [2182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3, 0, 0),
  [2184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 3, 0, 0),
  [2186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 5, 0, 0),
  [2188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [2190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [2192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [2194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 7, 0, 0),
  [2196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [2198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [2200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [2202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_parameters, 3, 0, 0),
  [2204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_parameters, 3, 0, 0),
  [2206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor, 5, 0, 0),
  [2208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [2210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [2212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor, 3, 0, 0),
  [2214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [2216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [2218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 2, 0, 0),
  [2220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0),
  [2222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1709),
  [2225] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2485),
  [2228] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1938),
  [2231] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1583),
  [2234] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1960),
  [2237] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1584),
  [2240] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1570),
  [2243] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1569),
  [2246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1, 0, 0),
  [2248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor, 4, 0, 0),
  [2250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [2252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [2254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_parameters, 4, 0, 0),
  [2256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_parameters, 4, 0, 0),
  [2258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor, 6, 0, 0),
  [2260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [2262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [2264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [2266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [2268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_behavior, 3, 0, 0),
  [2270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [2272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 10, 0, 25),
  [2274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [2276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [2280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 8, 0, 20),
  [2282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [2284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor, 7, 0, 0),
  [2286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [2288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [2290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [2292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [2294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [2296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [2298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [2300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 9, 0, 23),
  [2302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [2304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 8, 0, 0),
  [2306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [2308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_behavior, 6, 0, 0),
  [2310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [2312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 7, 0, 17),
  [2314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [2316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_behavior, 5, 0, 0),
  [2318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [2320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 6, 0, 12),
  [2322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [2324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_behavior, 4, 0, 0),
  [2326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [2328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_members_repeat1, 2, 0, 0),
  [2330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_members_repeat1, 2, 0, 0), SHIFT_REPEAT(2205),
  [2333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_members_repeat2, 2, 0, 0),
  [2335] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_members_repeat2, 2, 0, 0), SHIFT_REPEAT(1554),
  [2338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_members_repeat2, 2, 0, 0), SHIFT_REPEAT(1533),
  [2341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_members_repeat2, 2, 0, 0), SHIFT_REPEAT(1552),
  [2344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_members, 2, 0, 0),
  [2346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 7, 0, 8),
  [2348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 5, 0, 8),
  [2350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [2352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [2354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [2356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [2358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [2360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [2362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [2364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [2366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 12, 0, 25),
  [2368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 9, 0, 0),
  [2370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 11, 0, 23),
  [2372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 11, 0, 25),
  [2374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_statement, 2, 0, 0),
  [2376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(611),
  [2378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [2380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_behavior, 8, 0, 0),
  [2382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 8, 0, 17),
  [2384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 7, 0, 12),
  [2386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 8, 0, 12),
  [2388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor, 8, 0, 0),
  [2390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 9, 0, 20),
  [2392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor, 9, 0, 0),
  [2394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 9, 0, 17),
  [2396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 10, 0, 23),
  [2398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_statement, 4, 0, 0),
  [2400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_behavior, 7, 0, 0),
  [2402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 10, 0, 20),
  [2404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 10, 0, 0),
  [2406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1869),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [2410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ffi_method, 6, 0, 9),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [2414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ffi_method, 6, 0, 9),
  [2416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1884),
  [2418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1902),
  [2420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [2422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [2426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1906),
  [2428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [2434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1861),
  [2436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1894),
  [2438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1895),
  [2440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1878),
  [2442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1914),
  [2444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1877),
  [2446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [2458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [2460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [2462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [2464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_block, 3, 0, 0),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [2476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1857),
  [2478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [2480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ffi_method, 7, 0, 9),
  [2482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ffi_method, 7, 0, 9),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [2486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [2488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_block, 2, 0, 0),
  [2490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1889),
  [2492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [2494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [2496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [2502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [2504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [2506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [2508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [2510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [2512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [2514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1859),
  [2516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [2518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1862),
  [2520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [2522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_args_repeat1, 2, 0, 0),
  [2524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [2526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [2528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [2532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [2534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [2536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_parameter, 3, 0, 0),
  [2538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [2540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [2544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [2546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [2548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1179),
  [2550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1171),
  [2552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [2554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [2556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [2558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [2560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [2562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1886),
  [2564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [2566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1892),
  [2568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [2570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [2572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, 0, 1),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [2576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1992),
  [2578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [2580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1170),
  [2582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1898),
  [2584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [2586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_parameter, 3, 0, 7),
  [2588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [2590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [2592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [2594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [2596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_definition, 8, 0, 0),
  [2598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_actor_definition, 8, 0, 0),
  [2600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [2602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [2604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias, 6, 0, 5),
  [2606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [2608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [2610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [2612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [2614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [2616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [2618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [2620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias, 5, 0, 0),
  [2622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [2624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [2626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [2628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [2630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [2632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [2634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1905),
  [2636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [2638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [2640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [2642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2433),
  [2644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [2646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_statement, 3, 0, 0),
  [2648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [2650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [2652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [2654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [2656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [2658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [2660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_platform_specifier, 1, 0, 0),
  [2662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2233),
  [2664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [2666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [2668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [2670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [2672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [2674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_parameter, 5, 0, 15),
  [2676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [2678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [2680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 9, 0, 0),
  [2682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [2684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [2686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [2688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [2690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [2692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [2694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2436),
  [2696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [2698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [2700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [2702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [2704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [2706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [2708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [2710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2386),
  [2712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [2714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [2716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [2718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [2720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [2722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [2724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [2726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [2728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [2730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2397),
  [2732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [2734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2503),
  [2736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [2738] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_members_repeat1, 2, 0, 0), SHIFT_REPEAT(2500),
  [2741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2266),
  [2743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [2745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [2747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [2749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [2751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [2753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2484),
  [2755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [2757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [2759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [2761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [2763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [2765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [2767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [2769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2468),
  [2771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [2773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2445),
  [2775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [2777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [2779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [2781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [2783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [2785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2495),
  [2787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [2789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [2791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [2793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [2795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [2797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [2799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [2801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [2803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [2805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2416),
  [2807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [2809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [2811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [2813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [2815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [2817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_statement, 5, 0, 0),
  [2819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [2821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [2823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [2825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [2827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 9, 0, 0),
  [2829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [2831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [2833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0),
  [2835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_definition, 9, 0, 0),
  [2837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_definition, 9, 0, 0),
  [2839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2354),
  [2841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [2843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2395),
  [2845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [2847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [2849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [2851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [2853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [2855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2399),
  [2857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [2859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [2861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [2863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [2865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [2867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [2869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [2871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2406),
  [2873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [2875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [2877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [2879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [2881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [2883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [2885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [2887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [2889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [2891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [2893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [2895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [2897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [2899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1172),
  [2901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [2903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1173),
  [2905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [2907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [2909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [2911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [2913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [2915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [2917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [2919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [2921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1176),
  [2923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [2925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1175),
  [2927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1881),
  [2929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [2931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [2933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1904),
  [2935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [2937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [2939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [2941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [2943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [2945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [2947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [2949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [2951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1897),
  [2953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1899),
  [2955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [2957] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_members_repeat2, 2, 0, 0), SHIFT_REPEAT(1576),
  [2960] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_members_repeat2, 2, 0, 0), SHIFT_REPEAT(1537),
  [2963] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_members_repeat2, 2, 0, 0), SHIFT_REPEAT(1578),
  [2966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [2968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [2970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(573),
  [2972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [2974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [2976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [2978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1761),
  [2980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [2982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [2984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [2986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1775),
  [2988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [2990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [2992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [2994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1784),
  [2996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [2998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [3000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [3002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1783),
  [3004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [3006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [3008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [3010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(596),
  [3012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(966),
  [3014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [3016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1803),
  [3018] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [3020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(993),
  [3022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [3024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1769),
  [3026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [3028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [3030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(859),
  [3032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(328),
  [3034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [3036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1763),
  [3038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [3040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [3042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [3044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [3046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [3048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [3050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [3052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [3054] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_character_repeat1, 2, 0, 0),
  [3056] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_character_repeat1, 2, 0, 0), SHIFT_REPEAT(1769),
  [3059] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_character_repeat1, 2, 0, 0), SHIFT_REPEAT(1769),
  [3062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [3064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [3066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1771),
  [3068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [3070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [3072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [3074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1773),
  [3076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [3078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [3080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [3082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1760),
  [3084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(498),
  [3086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [3088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1777),
  [3090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [3092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [3094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [3096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [3098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [3100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [3102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(375),
  [3104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(968),
  [3106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [3108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1757),
  [3110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [3112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [3114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1786),
  [3116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [3118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [3120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [3122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [3124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1782),
  [3126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [3128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [3130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [3132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [3134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [3136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(389),
  [3138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [3140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [3142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [3144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [3146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [3148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(516),
  [3150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [3152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [3154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__string_literal_repeat1, 2, 0, 0),
  [3156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(1803),
  [3159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(1803),
  [3162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [3164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2385),
  [3166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [3168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [3170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [3172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [3174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [3176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [3178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [3180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [3182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(818),
  [3185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [3187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [3189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [3191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 0),
  [3193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(603),
  [3196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 0),
  [3198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [3200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [3202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2419),
  [3204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [3206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [3208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [3210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [3212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1794),
  [3214] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(628),
  [3217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_statement_repeat1, 2, 0, 0),
  [3219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [3221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [3223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [3225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2502),
  [3227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [3229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [3231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [3233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [3235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [3237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [3239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [3241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_iftype_statement_repeat1, 2, 0, 0),
  [3243] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_iftype_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1199),
  [3246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_iftype_statement_repeat1, 2, 0, 0),
  [3248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [3250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [3252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [3254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [3256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [3258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [3260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [3262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [3264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [3266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1778),
  [3268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2343),
  [3270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [3272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [3274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [3276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [3278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [3280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [3282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [3284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2417),
  [3286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [3288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [3290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [3292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1800),
  [3294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [3296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [3298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [3300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [3302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2371),
  [3304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [3306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [3308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [3310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [3312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [3314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [3316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [3318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [3320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [3322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [3324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [3326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [3328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [3330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [3332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [3334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [3336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_parameter, 1, 0, 0),
  [3338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [3340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2508),
  [3342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [3344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [3346] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(794),
  [3349] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_args_repeat1, 2, 0, 0), SHIFT_REPEAT(1297),
  [3352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [3354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [3356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_lambda_captures_repeat1, 2, 0, 0),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [3360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [3362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_parameter, 1, 0, 1),
  [3364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [3366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [3368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [3370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2342),
  [3372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [3374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [3376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_then_block, 2, 0, 0),
  [3378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_then_block, 2, 0, 0),
  [3380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [3382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [3384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [3386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [3388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [3390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [3392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [3394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [3396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [3398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [3400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [3402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [3404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [3406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [3408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [3410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [3412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [3414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [3416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [3418] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_with_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2138),
  [3421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_with_statement_repeat1, 2, 0, 0),
  [3423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [3425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__multiline_string_literal_repeat1, 2, 0, 0),
  [3427] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__multiline_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(1942),
  [3430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2469),
  [3432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [3434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [3436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [3438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2400),
  [3440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [3442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [3444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [3446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2456),
  [3448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [3450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [3452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [3454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [3456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [3458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [3460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [3462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [3464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [3466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [3468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [3470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2378),
  [3472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_parameters, 2, 0, 0),
  [3474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [3476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [3478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [3480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2443),
  [3482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [3484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [3486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [3488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_arguments, 2, 0, 0),
  [3490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2441),
  [3492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [3494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [3496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [3498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [3500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [3502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_then_block, 3, 0, 0),
  [3504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_then_block, 3, 0, 0),
  [3506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [3508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [3510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [3512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [3514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [3516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [3518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [3520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [3522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [3524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [3526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [3528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [3530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [3532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2435),
  [3534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [3536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [3538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_parameters_repeat1, 2, 0, 0),
  [3540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(2169),
  [3543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2499),
  [3545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [3547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [3549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [3551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [3553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [3555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_parameters, 3, 0, 0),
  [3557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2393),
  [3559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [3561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [3563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [3565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2458),
  [3567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_arguments, 1, 0, 0),
  [3569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [3571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [3573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [3575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [3577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [3579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_captures, 4, 0, 0),
  [3581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_lambda_captures_repeat1, 2, 0, 0), SHIFT_REPEAT(2263),
  [3584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [3586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [3588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [3590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2428),
  [3592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [3594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [3596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [3598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [3600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [3602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_captures, 2, 0, 0),
  [3604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2336),
  [3606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [3608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [3610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [3612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [3614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [3616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [3618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_repeat1, 2, 0, 0),
  [3620] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_annotation_repeat1, 2, 0, 0), SHIFT_REPEAT(2224),
  [3623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_lambda_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2126),
  [3626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_lambda_expression_repeat1, 2, 0, 0),
  [3628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [3630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [3632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [3634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [3636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [3638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [3640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [3642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [3644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [3646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [3648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [3650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_arguments, 3, 0, 0),
  [3652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elseif_block, 3, 0, 0),
  [3654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_block, 3, 0, 0),
  [3656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [3658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [3660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [3662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [3664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2296),
  [3666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [3668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [3670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [3672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [3674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [3676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2246),
  [3678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [3680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [3682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_parameters, 4, 0, 0),
  [3684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [3686] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(2000),
  [3689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0),
  [3691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [3693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [3695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [3697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [3699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [3701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [3703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [3705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [3707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 5, 0, 0),
  [3709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [3711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [3713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [3715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [3717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [3719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_captures, 3, 0, 0),
  [3721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 4, 0, 0),
  [3723] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_arguments_repeat1, 2, 0, 0), SHIFT_REPEAT(2159),
  [3726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_arguments_repeat1, 2, 0, 0),
  [3728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [3730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [3732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [3734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elseif_block, 4, 0, 0),
  [3736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_block, 4, 0, 0),
  [3738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [3740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [3742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [3744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [3746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [3748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elseiftype_block, 6, 0, 0),
  [3750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseiftype_block, 6, 0, 0),
  [3752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [3754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [3756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [3758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_captures, 8, 0, 0),
  [3760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [3762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [3764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elseiftype_block, 5, 0, 0),
  [3766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseiftype_block, 5, 0, 0),
  [3768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [3770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [3772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [3774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [3776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [3778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [3780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [3782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [3784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [3786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [3788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 6, 0, 0),
  [3790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [3792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [3794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [3796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [3798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [3800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [3802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [3804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [3806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [3808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [3810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [3812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [3814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [3816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [3818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [3820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_captures, 7, 0, 0),
  [3822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2196),
  [3824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [3826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [3828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [3830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [3832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [3834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [3836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [3838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [3840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [3842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [3844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [3846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [3848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [3850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [3852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [3854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [3856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [3858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2309),
  [3860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [3862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [3864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2346),
  [3866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [3868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [3870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [3872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [3874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [3876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [3878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [3880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [3882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [3884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [3886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [3888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [3890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_captures, 5, 0, 0),
  [3892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [3894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [3896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_captures, 6, 0, 0),
  [3898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 7, 0, 0),
  [3900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [3902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 0),
  [3904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [3906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [3908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_block, 2, 0, 0),
  [3910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_elem, 3, 0, 0),
  [3912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [3914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2459),
  [3916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [3918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [3920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_block, 3, 0, 0),
  [3922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [3924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [3926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [3928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [3930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [3932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [3934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [3936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [3938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [3940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [3942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [3944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [3946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [3948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [3950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [3952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [3954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [3956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [3958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [3960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [3962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [3964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [3966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [3968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [3970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [3972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [3974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [3976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [3978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [3980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [3982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [3984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [3986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [3988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [3990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [3992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [3994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [3996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [3998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [4000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [4002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [4004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [4006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [4008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [4010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [4012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [4014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [4016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [4018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [4020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [4022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [4024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [4026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [4028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [4030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [4032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [4034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [4036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [4038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [4040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [4042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [4044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [4046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [4048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [4050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [4052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [4054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [4056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [4058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [4060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [4062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [4064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [4066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [4068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [4070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [4072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [4074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [4076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [4078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [4080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [4082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [4084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [4086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [4088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [4090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [4092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [4094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [4096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [4098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [4100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [4102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [4104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [4106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [4108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [4110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [4112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [4114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [4116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [4118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [4120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [4122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [4124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [4126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [4128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [4130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [4132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [4134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [4136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [4138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [4140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [4142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [4144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [4146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [4148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [4150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [4152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [4154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [4156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [4158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [4160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [4162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [4164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [4166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [4168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [4170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [4172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [4174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [4176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [4178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [4180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [4182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [4184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [4186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [4188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [4190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [4192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [4194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [4196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [4198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [4200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [4202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [4204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [4206] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [4208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [4210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [4212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [4214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [4216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [4218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [4220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [4222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [4224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [4226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [4228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [4230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [4232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [4234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [4236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [4238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [4240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [4242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [4244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [4246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [4248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [4250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [4252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [4254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [4256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [4258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [4260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [4262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [4264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [4266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [4268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [4270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [4272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [4274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [4276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [4278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [4280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [4282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [4284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [4286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [4288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [4290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [4292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [4294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [4296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [4298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [4300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [4302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [4304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [4306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [4308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [4310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [4312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [4314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [4316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [4318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [4320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [4322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [4324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [4326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [4328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [4330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [4332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [4334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [4336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [4338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [4340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [4342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [4344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [4346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [4348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [4350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [4352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [4354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [4356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [4358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [4360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [4362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [4364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [4366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [4368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [4370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2442),
  [4372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [4374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [4376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [4378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [4380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [4382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [4384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [4386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [4388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [4390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [4392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [4394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__type_args_start = 0,
  ts_external_token_block_comment = 1,
  ts_external_token__multiline_string_content = 2,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__type_args_start] = sym__type_args_start,
  [ts_external_token_block_comment] = sym_block_comment,
  [ts_external_token__multiline_string_content] = sym__multiline_string_content,
};

static const bool ts_external_scanner_states[5][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__type_args_start] = true,
    [ts_external_token_block_comment] = true,
    [ts_external_token__multiline_string_content] = true,
  },
  [2] = {
    [ts_external_token_block_comment] = true,
  },
  [3] = {
    [ts_external_token__type_args_start] = true,
    [ts_external_token_block_comment] = true,
  },
  [4] = {
    [ts_external_token_block_comment] = true,
    [ts_external_token__multiline_string_content] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_pony_external_scanner_create(void);
void tree_sitter_pony_external_scanner_destroy(void *);
bool tree_sitter_pony_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_pony_external_scanner_serialize(void *, char *);
void tree_sitter_pony_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_pony(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_pony_external_scanner_create,
      tree_sitter_pony_external_scanner_destroy,
      tree_sitter_pony_external_scanner_scan,
      tree_sitter_pony_external_scanner_serialize,
      tree_sitter_pony_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
