#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 2119
#define LARGE_STATE_COUNT 373
#define SYMBOL_COUNT 393
#define ALIAS_COUNT 0
#define TOKEN_COUNT 214
#define EXTERNAL_TOKEN_COUNT 1
#define FIELD_COUNT 14
#define MAX_ALIAS_SEQUENCE_LENGTH 12
#define PRODUCTION_ID_COUNT 27

enum ts_symbol_identifiers {
  sym_comment = 1,
  sym_decimal_integer_literal = 2,
  sym_hexadecimal_integer_literal = 3,
  sym_real_literal = 4,
  aux_sym_expandable_string_literal_token1 = 5,
  aux_sym_expandable_string_literal_token2 = 6,
  aux_sym_expandable_string_literal_token3 = 7,
  aux_sym_expandable_string_literal_token4 = 8,
  anon_sym_DQUOTE_DQUOTE = 9,
  anon_sym_DOLLAR = 10,
  aux_sym_expandable_string_literal_token5 = 11,
  aux_sym_expandable_here_string_literal_token1 = 12,
  aux_sym_expandable_here_string_literal_token2 = 13,
  aux_sym_expandable_here_string_literal_token3 = 14,
  aux_sym_expandable_here_string_literal_token4 = 15,
  aux_sym_expandable_here_string_literal_token5 = 16,
  sym_verbatim_string_characters = 17,
  sym_verbatim_here_string_characters = 18,
  sym_simple_name = 19,
  sym_type_identifier = 20,
  anon_sym_DOT = 21,
  anon_sym_LBRACK = 22,
  anon_sym_EQ = 23,
  anon_sym_BANG_EQ = 24,
  anon_sym_PLUS_EQ = 25,
  anon_sym_STAR_EQ = 26,
  anon_sym_SLASH_EQ = 27,
  anon_sym_PERCENT_EQ = 28,
  anon_sym_GT = 29,
  anon_sym_GT_GT = 30,
  anon_sym_2_GT = 31,
  anon_sym_2_GT_GT = 32,
  anon_sym_3_GT = 33,
  anon_sym_3_GT_GT = 34,
  anon_sym_4_GT = 35,
  anon_sym_4_GT_GT = 36,
  anon_sym_5_GT = 37,
  anon_sym_5_GT_GT = 38,
  anon_sym_6_GT = 39,
  anon_sym_6_GT_GT = 40,
  anon_sym_STAR_GT = 41,
  anon_sym_STAR_GT_GT = 42,
  anon_sym_LT = 43,
  anon_sym_STAR_GT_AMP1 = 44,
  anon_sym_2_GT_AMP1 = 45,
  anon_sym_3_GT_AMP1 = 46,
  anon_sym_4_GT_AMP1 = 47,
  anon_sym_5_GT_AMP1 = 48,
  anon_sym_6_GT_AMP1 = 49,
  anon_sym_STAR_GT_AMP2 = 50,
  anon_sym_1_GT_AMP2 = 51,
  anon_sym_3_GT_AMP2 = 52,
  anon_sym_4_GT_AMP2 = 53,
  anon_sym_5_GT_AMP2 = 54,
  anon_sym_6_GT_AMP2 = 55,
  anon_sym_DASHas = 56,
  anon_sym_DASHccontains = 57,
  anon_sym_DASHceq = 58,
  anon_sym_DASHcge = 59,
  anon_sym_DASHcgt = 60,
  anon_sym_DASHcle = 61,
  anon_sym_DASHclike = 62,
  anon_sym_DASHclt = 63,
  anon_sym_DASHcmatch = 64,
  anon_sym_DASHcne = 65,
  anon_sym_DASHcnotcontains = 66,
  anon_sym_DASHcnotlike = 67,
  anon_sym_DASHcnotmatch = 68,
  anon_sym_DASHcontains = 69,
  anon_sym_DASHcreplace = 70,
  anon_sym_DASHcsplit = 71,
  anon_sym_DASHeq = 72,
  anon_sym_DASHge = 73,
  anon_sym_DASHgt = 74,
  anon_sym_DASHicontains = 75,
  anon_sym_DASHieq = 76,
  anon_sym_DASHige = 77,
  anon_sym_DASHigt = 78,
  anon_sym_DASHile = 79,
  anon_sym_DASHilike = 80,
  anon_sym_DASHilt = 81,
  anon_sym_DASHimatch = 82,
  anon_sym_DASHin = 83,
  anon_sym_DASHine = 84,
  anon_sym_DASHinotcontains = 85,
  anon_sym_DASHinotlike = 86,
  anon_sym_DASHinotmatch = 87,
  anon_sym_DASHireplace = 88,
  anon_sym_DASHis = 89,
  anon_sym_DASHisnot = 90,
  anon_sym_DASHisplit = 91,
  anon_sym_DASHjoin = 92,
  anon_sym_DASHle = 93,
  anon_sym_DASHlike = 94,
  anon_sym_DASHlt = 95,
  anon_sym_DASHmatch = 96,
  anon_sym_DASHne = 97,
  anon_sym_DASHnotcontains = 98,
  anon_sym_DASHnotin = 99,
  anon_sym_DASHnotlike = 100,
  anon_sym_DASHnotmatch = 101,
  anon_sym_DASHreplace = 102,
  anon_sym_DASHshl = 103,
  anon_sym_DASHshr = 104,
  anon_sym_DASHsplit = 105,
  sym_format_operator = 106,
  anon_sym_DOLLAR_DOLLAR = 107,
  anon_sym_DOLLAR_CARET = 108,
  anon_sym_DOLLAR_QMARK = 109,
  anon_sym_DOLLAR_ = 110,
  aux_sym_variable_token1 = 111,
  aux_sym_variable_token2 = 112,
  sym_braced_variable = 113,
  sym_generic_token = 114,
  sym__command_token = 115,
  sym_command_parameter = 116,
  aux_sym__verbatim_command_argument_chars_token1 = 117,
  aux_sym__verbatim_command_argument_chars_token2 = 118,
  aux_sym__verbatim_command_argument_chars_token3 = 119,
  anon_sym_SEMI = 120,
  anon_sym_param = 121,
  anon_sym_LPAREN = 122,
  anon_sym_RPAREN = 123,
  anon_sym_COMMA = 124,
  anon_sym_dynamicparam = 125,
  anon_sym_begin = 126,
  anon_sym_process = 127,
  anon_sym_end = 128,
  anon_sym_LBRACE = 129,
  anon_sym_RBRACE = 130,
  anon_sym_if = 131,
  anon_sym_elseif = 132,
  anon_sym_else = 133,
  anon_sym_switch = 134,
  anon_sym_DASHregex = 135,
  anon_sym_DASHwildcard = 136,
  anon_sym_DASHexact = 137,
  anon_sym_DASHcasesensitive = 138,
  anon_sym_DASHparallel = 139,
  anon_sym_DASHfile = 140,
  anon_sym_foreach = 141,
  anon_sym_in = 142,
  anon_sym_for = 143,
  anon_sym_LF = 144,
  anon_sym_while = 145,
  anon_sym_do = 146,
  anon_sym_until = 147,
  anon_sym_function = 148,
  anon_sym_filter = 149,
  anon_sym_workflow = 150,
  anon_sym_break = 151,
  anon_sym_continue = 152,
  anon_sym_throw = 153,
  anon_sym_return = 154,
  anon_sym_exit = 155,
  sym_label = 156,
  anon_sym_trap = 157,
  anon_sym_try = 158,
  anon_sym_catch = 159,
  anon_sym_finally = 160,
  anon_sym_data = 161,
  anon_sym_DASHsupportedcommand = 162,
  anon_sym_inlinescript = 163,
  anon_sym_parallel = 164,
  anon_sym_sequence = 165,
  anon_sym_PIPE = 166,
  anon_sym_AMP = 167,
  aux_sym__expandable_string_literal_immediate_token1 = 168,
  aux_sym__expandable_string_literal_immediate_token2 = 169,
  aux_sym__expandable_string_literal_immediate_token3 = 170,
  anon_sym_DQUOTE_DQUOTE2 = 171,
  anon_sym_DOLLAR2 = 172,
  anon_sym_DQUOTE = 173,
  aux_sym_command_name_token1 = 174,
  aux_sym_command_name_token2 = 175,
  anon_sym_DQUOTE2 = 176,
  anon_sym_SQUOTE_SQUOTE = 177,
  sym_path_command_name_token = 178,
  sym_stop_parsing = 179,
  anon_sym_SPACE = 180,
  anon_sym_COLON = 181,
  anon_sym_PERCENT = 182,
  anon_sym_foreach_DASHobject = 183,
  anon_sym_DASH_DASH_PERCENT = 184,
  anon_sym_hidden = 185,
  anon_sym_static = 186,
  anon_sym_class = 187,
  anon_sym_enum = 188,
  anon_sym_DASHand = 189,
  anon_sym_DASHor = 190,
  anon_sym_DASHxor = 191,
  anon_sym_DASHband = 192,
  anon_sym_DASHbor = 193,
  anon_sym_DASHbxor = 194,
  anon_sym_PLUS = 195,
  anon_sym_DASH = 196,
  anon_sym_SLASH = 197,
  anon_sym_BSLASH = 198,
  anon_sym_STAR = 199,
  anon_sym_DOT_DOT = 200,
  anon_sym_DASHnot = 201,
  anon_sym_BANG = 202,
  anon_sym_DASHbnot = 203,
  anon_sym_PLUS_PLUS = 204,
  anon_sym_DASH_DASH = 205,
  anon_sym_DOLLAR_LPAREN = 206,
  anon_sym_AT_LPAREN = 207,
  anon_sym_AT_LBRACE = 208,
  anon_sym_DOT2 = 209,
  anon_sym_COLON_COLON = 210,
  anon_sym_RBRACK = 211,
  anon_sym_DOTforeach = 212,
  sym__statement_terminator = 213,
  sym_program = 214,
  sym__literal = 215,
  sym_integer_literal = 216,
  sym_string_literal = 217,
  sym_expandable_string_literal = 218,
  sym_expandable_here_string_literal = 219,
  sym_type_name = 220,
  sym_array_type_name = 221,
  sym_generic_type_name = 222,
  sym_assignement_operator = 223,
  sym_file_redirection_operator = 224,
  sym_merging_redirection_operator = 225,
  sym_comparison_operator = 226,
  sym_variable = 227,
  aux_sym__verbatim_command_argument_chars = 228,
  sym_script_block = 229,
  sym_param_block = 230,
  sym_parameter_list = 231,
  sym_script_parameter = 232,
  sym_script_parameter_default = 233,
  sym_script_block_body = 234,
  sym_named_block_list = 235,
  sym_named_block = 236,
  sym_block_name = 237,
  sym_statement_block = 238,
  sym_statement_list = 239,
  sym__statement = 240,
  sym_empty_statement = 241,
  sym_if_statement = 242,
  sym_elseif_clauses = 243,
  sym_elseif_clause = 244,
  sym_else_clause = 245,
  sym__labeled_statement = 246,
  sym_switch_statement = 247,
  sym_switch_parameters = 248,
  sym_switch_parameter = 249,
  sym_switch_condition = 250,
  sym_switch_filename = 251,
  sym_switch_body = 252,
  sym_switch_clauses = 253,
  sym_switch_clause = 254,
  sym_switch_clause_condition = 255,
  sym_foreach_statement = 256,
  sym_foreach_parameter = 257,
  sym_for_statement = 258,
  sym_for_initializer = 259,
  sym_for_condition = 260,
  sym_for_iterator = 261,
  sym_while_statement = 262,
  sym_while_condition = 263,
  sym_do_statement = 264,
  sym_function_statement = 265,
  sym_function_name = 266,
  sym_function_parameter_declaration = 267,
  sym_flow_control_statement = 268,
  sym_label_expression = 269,
  sym_trap_statement = 270,
  sym_try_statement = 271,
  sym_catch_clauses = 272,
  sym_catch_clause = 273,
  sym_catch_type_list = 274,
  sym_finally_clause = 275,
  sym_data_statement = 276,
  sym_data_name = 277,
  sym_data_commands_allowed = 278,
  sym_data_commands_list = 279,
  sym_data_command = 280,
  sym_inlinescript_statement = 281,
  sym_parallel_statement = 282,
  sym_sequence_statement = 283,
  sym_pipeline = 284,
  sym_left_assignment_expression = 285,
  sym_assignment_expression = 286,
  aux_sym__pipeline_tail = 287,
  sym_command = 288,
  sym_command_invokation_operator = 289,
  sym__expandable_string_literal_immediate = 290,
  sym_command_name = 291,
  sym_path_command_name = 292,
  sym_command_name_expr = 293,
  sym_command_elements = 294,
  sym__command_element = 295,
  sym_command_argument_sep = 296,
  sym__command_argument = 297,
  sym_foreach_command = 298,
  sym_verbatim_command_argument = 299,
  sym_redirections = 300,
  sym_redirection = 301,
  sym_redirected_file_name = 302,
  sym_class_attribute = 303,
  sym_class_property_definition = 304,
  sym_class_method_parameter = 305,
  sym_class_method_parameter_list = 306,
  sym_class_method_definition = 307,
  sym_class_statement = 308,
  sym_enum_statement = 309,
  sym_enum_member = 310,
  sym__expression = 311,
  sym_logical_expression = 312,
  sym_bitwise_expression = 313,
  sym_comparison_expression = 314,
  sym_additive_expression = 315,
  sym_multiplicative_expression = 316,
  sym_format_expression = 317,
  sym_range_expression = 318,
  sym_array_literal_expression = 319,
  sym_unary_expression = 320,
  sym_expression_with_unary_operator = 321,
  sym_pre_increment_expression = 322,
  sym_pre_decrement_expression = 323,
  sym_cast_expression = 324,
  sym__primary_expression = 325,
  sym__value = 326,
  sym_parenthesized_expression = 327,
  sym_sub_expression = 328,
  sym_array_expression = 329,
  sym_script_block_expression = 330,
  sym_hash_literal_expression = 331,
  sym_hash_literal_body = 332,
  sym_hash_entry = 333,
  sym_key_expression = 334,
  sym_post_increment_expression = 335,
  sym_post_decrement_expression = 336,
  sym_member_access = 337,
  sym_member_name = 338,
  sym_element_access = 339,
  sym_invokation_expression = 340,
  sym_invokation_foreach_expression = 341,
  sym_argument_list = 342,
  sym_argument_expression_list = 343,
  sym_argument_expression = 344,
  sym_logical_argument_expression = 345,
  sym_bitwise_argument_expression = 346,
  sym_comparison_argument_expression = 347,
  sym_additive_argument_expression = 348,
  sym_multiplicative_argument_expression = 349,
  sym_format_argument_expression = 350,
  sym_range_argument_expression = 351,
  sym_type_literal = 352,
  sym_type_spec = 353,
  sym_dimension = 354,
  sym_generic_type_arguments = 355,
  sym_attribute_list = 356,
  sym_attribute = 357,
  sym_attribute_name = 358,
  sym_attribute_arguments = 359,
  sym_attribute_argument = 360,
  aux_sym_expandable_string_literal_repeat1 = 361,
  aux_sym_expandable_string_literal_repeat2 = 362,
  aux_sym_expandable_here_string_literal_repeat1 = 363,
  aux_sym_script_block_repeat1 = 364,
  aux_sym_parameter_list_repeat1 = 365,
  aux_sym_named_block_list_repeat1 = 366,
  aux_sym_statement_list_repeat1 = 367,
  aux_sym_elseif_clauses_repeat1 = 368,
  aux_sym_switch_parameters_repeat1 = 369,
  aux_sym_switch_clauses_repeat1 = 370,
  aux_sym_catch_clauses_repeat1 = 371,
  aux_sym_catch_type_list_repeat1 = 372,
  aux_sym_data_commands_list_repeat1 = 373,
  aux_sym__expandable_string_literal_immediate_repeat1 = 374,
  aux_sym__expandable_string_literal_immediate_repeat2 = 375,
  aux_sym_command_name_repeat1 = 376,
  aux_sym_path_command_name_repeat1 = 377,
  aux_sym_command_elements_repeat1 = 378,
  aux_sym_command_argument_sep_repeat1 = 379,
  aux_sym_foreach_command_repeat1 = 380,
  aux_sym_redirections_repeat1 = 381,
  aux_sym_class_property_definition_repeat1 = 382,
  aux_sym_class_method_parameter_list_repeat1 = 383,
  aux_sym_class_statement_repeat1 = 384,
  aux_sym_class_statement_repeat2 = 385,
  aux_sym_enum_statement_repeat1 = 386,
  aux_sym_hash_literal_body_repeat1 = 387,
  aux_sym_argument_expression_list_repeat1 = 388,
  aux_sym_dimension_repeat1 = 389,
  aux_sym_generic_type_arguments_repeat1 = 390,
  aux_sym_attribute_list_repeat1 = 391,
  aux_sym_attribute_arguments_repeat1 = 392,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_comment] = "comment",
  [sym_decimal_integer_literal] = "decimal_integer_literal",
  [sym_hexadecimal_integer_literal] = "hexadecimal_integer_literal",
  [sym_real_literal] = "real_literal",
  [aux_sym_expandable_string_literal_token1] = "expandable_string_literal_token1",
  [aux_sym_expandable_string_literal_token2] = "expandable_string_literal_token2",
  [aux_sym_expandable_string_literal_token3] = "expandable_string_literal_token3",
  [aux_sym_expandable_string_literal_token4] = "expandable_string_literal_token4",
  [anon_sym_DQUOTE_DQUOTE] = "\"\"",
  [anon_sym_DOLLAR] = "$",
  [aux_sym_expandable_string_literal_token5] = "expandable_string_literal_token5",
  [aux_sym_expandable_here_string_literal_token1] = "expandable_here_string_literal_token1",
  [aux_sym_expandable_here_string_literal_token2] = "expandable_here_string_literal_token2",
  [aux_sym_expandable_here_string_literal_token3] = "expandable_here_string_literal_token3",
  [aux_sym_expandable_here_string_literal_token4] = "expandable_here_string_literal_token4",
  [aux_sym_expandable_here_string_literal_token5] = "expandable_here_string_literal_token5",
  [sym_verbatim_string_characters] = "verbatim_string_characters",
  [sym_verbatim_here_string_characters] = "verbatim_here_string_characters",
  [sym_simple_name] = "simple_name",
  [sym_type_identifier] = "type_identifier",
  [anon_sym_DOT] = ".",
  [anon_sym_LBRACK] = "[",
  [anon_sym_EQ] = "=",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_2_GT] = "2>",
  [anon_sym_2_GT_GT] = "2>>",
  [anon_sym_3_GT] = "3>",
  [anon_sym_3_GT_GT] = "3>>",
  [anon_sym_4_GT] = "4>",
  [anon_sym_4_GT_GT] = "4>>",
  [anon_sym_5_GT] = "5>",
  [anon_sym_5_GT_GT] = "5>>",
  [anon_sym_6_GT] = "6>",
  [anon_sym_6_GT_GT] = "6>>",
  [anon_sym_STAR_GT] = "*>",
  [anon_sym_STAR_GT_GT] = "*>>",
  [anon_sym_LT] = "<",
  [anon_sym_STAR_GT_AMP1] = "*>&1",
  [anon_sym_2_GT_AMP1] = "2>&1",
  [anon_sym_3_GT_AMP1] = "3>&1",
  [anon_sym_4_GT_AMP1] = "4>&1",
  [anon_sym_5_GT_AMP1] = "5>&1",
  [anon_sym_6_GT_AMP1] = "6>&1",
  [anon_sym_STAR_GT_AMP2] = "*>&2",
  [anon_sym_1_GT_AMP2] = "1>&2",
  [anon_sym_3_GT_AMP2] = "3>&2",
  [anon_sym_4_GT_AMP2] = "4>&2",
  [anon_sym_5_GT_AMP2] = "5>&2",
  [anon_sym_6_GT_AMP2] = "6>&2",
  [anon_sym_DASHas] = "-as",
  [anon_sym_DASHccontains] = "-ccontains",
  [anon_sym_DASHceq] = "-ceq",
  [anon_sym_DASHcge] = "-cge",
  [anon_sym_DASHcgt] = "-cgt",
  [anon_sym_DASHcle] = "-cle",
  [anon_sym_DASHclike] = "-clike",
  [anon_sym_DASHclt] = "-clt",
  [anon_sym_DASHcmatch] = "-cmatch",
  [anon_sym_DASHcne] = "-cne",
  [anon_sym_DASHcnotcontains] = "-cnotcontains",
  [anon_sym_DASHcnotlike] = "-cnotlike",
  [anon_sym_DASHcnotmatch] = "-cnotmatch",
  [anon_sym_DASHcontains] = "-contains",
  [anon_sym_DASHcreplace] = "-creplace",
  [anon_sym_DASHcsplit] = "-csplit",
  [anon_sym_DASHeq] = "-eq",
  [anon_sym_DASHge] = "-ge",
  [anon_sym_DASHgt] = "-gt",
  [anon_sym_DASHicontains] = "-icontains",
  [anon_sym_DASHieq] = "-ieq",
  [anon_sym_DASHige] = "-ige",
  [anon_sym_DASHigt] = "-igt",
  [anon_sym_DASHile] = "-ile",
  [anon_sym_DASHilike] = "-ilike",
  [anon_sym_DASHilt] = "-ilt",
  [anon_sym_DASHimatch] = "-imatch",
  [anon_sym_DASHin] = "-in",
  [anon_sym_DASHine] = "-ine",
  [anon_sym_DASHinotcontains] = "-inotcontains",
  [anon_sym_DASHinotlike] = "-inotlike",
  [anon_sym_DASHinotmatch] = "-inotmatch",
  [anon_sym_DASHireplace] = "-ireplace",
  [anon_sym_DASHis] = "-is",
  [anon_sym_DASHisnot] = "-isnot",
  [anon_sym_DASHisplit] = "-isplit",
  [anon_sym_DASHjoin] = "-join",
  [anon_sym_DASHle] = "-le",
  [anon_sym_DASHlike] = "-like",
  [anon_sym_DASHlt] = "-lt",
  [anon_sym_DASHmatch] = "-match",
  [anon_sym_DASHne] = "-ne",
  [anon_sym_DASHnotcontains] = "-notcontains",
  [anon_sym_DASHnotin] = "-notin",
  [anon_sym_DASHnotlike] = "-notlike",
  [anon_sym_DASHnotmatch] = "-notmatch",
  [anon_sym_DASHreplace] = "-replace",
  [anon_sym_DASHshl] = "-shl",
  [anon_sym_DASHshr] = "-shr",
  [anon_sym_DASHsplit] = "-split",
  [sym_format_operator] = "format_operator",
  [anon_sym_DOLLAR_DOLLAR] = "$$",
  [anon_sym_DOLLAR_CARET] = "$^",
  [anon_sym_DOLLAR_QMARK] = "$\?",
  [anon_sym_DOLLAR_] = "$_",
  [aux_sym_variable_token1] = "variable_token1",
  [aux_sym_variable_token2] = "variable_token2",
  [sym_braced_variable] = "braced_variable",
  [sym_generic_token] = "generic_token",
  [sym__command_token] = "_command_token",
  [sym_command_parameter] = "command_parameter",
  [aux_sym__verbatim_command_argument_chars_token1] = "_verbatim_command_argument_chars_token1",
  [aux_sym__verbatim_command_argument_chars_token2] = "_verbatim_command_argument_chars_token2",
  [aux_sym__verbatim_command_argument_chars_token3] = "_verbatim_command_argument_chars_token3",
  [anon_sym_SEMI] = ";",
  [anon_sym_param] = "param",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COMMA] = ",",
  [anon_sym_dynamicparam] = "dynamicparam",
  [anon_sym_begin] = "begin",
  [anon_sym_process] = "process",
  [anon_sym_end] = "end",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_if] = "if",
  [anon_sym_elseif] = "elseif",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_DASHregex] = "-regex",
  [anon_sym_DASHwildcard] = "-wildcard",
  [anon_sym_DASHexact] = "-exact",
  [anon_sym_DASHcasesensitive] = "-casesensitive",
  [anon_sym_DASHparallel] = "-parallel",
  [anon_sym_DASHfile] = "-file",
  [anon_sym_foreach] = "foreach",
  [anon_sym_in] = "in",
  [anon_sym_for] = "for",
  [anon_sym_LF] = "\n",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_until] = "until",
  [anon_sym_function] = "function",
  [anon_sym_filter] = "filter",
  [anon_sym_workflow] = "workflow",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_throw] = "throw",
  [anon_sym_return] = "return",
  [anon_sym_exit] = "exit",
  [sym_label] = "label",
  [anon_sym_trap] = "trap",
  [anon_sym_try] = "try",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_data] = "data",
  [anon_sym_DASHsupportedcommand] = "-supportedcommand",
  [anon_sym_inlinescript] = "inlinescript",
  [anon_sym_parallel] = "parallel",
  [anon_sym_sequence] = "sequence",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP] = "&",
  [aux_sym__expandable_string_literal_immediate_token1] = "_expandable_string_literal_immediate_token1",
  [aux_sym__expandable_string_literal_immediate_token2] = "_expandable_string_literal_immediate_token2",
  [aux_sym__expandable_string_literal_immediate_token3] = "_expandable_string_literal_immediate_token3",
  [anon_sym_DQUOTE_DQUOTE2] = "\"\"",
  [anon_sym_DOLLAR2] = "$",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_command_name_token1] = "command_name_token1",
  [aux_sym_command_name_token2] = "command_name_token2",
  [anon_sym_DQUOTE2] = "\"",
  [anon_sym_SQUOTE_SQUOTE] = "''",
  [sym_path_command_name_token] = "path_command_name_token",
  [sym_stop_parsing] = "stop_parsing",
  [anon_sym_SPACE] = " ",
  [anon_sym_COLON] = ":",
  [anon_sym_PERCENT] = "%",
  [anon_sym_foreach_DASHobject] = "foreach-object",
  [anon_sym_DASH_DASH_PERCENT] = "--%",
  [anon_sym_hidden] = "hidden",
  [anon_sym_static] = "static",
  [anon_sym_class] = "class",
  [anon_sym_enum] = "enum",
  [anon_sym_DASHand] = "-and",
  [anon_sym_DASHor] = "-or",
  [anon_sym_DASHxor] = "-xor",
  [anon_sym_DASHband] = "-band",
  [anon_sym_DASHbor] = "-bor",
  [anon_sym_DASHbxor] = "-bxor",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_SLASH] = "/",
  [anon_sym_BSLASH] = "\\",
  [anon_sym_STAR] = "*",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_DASHnot] = "-not",
  [anon_sym_BANG] = "!",
  [anon_sym_DASHbnot] = "-bnot",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DOLLAR_LPAREN] = "$(",
  [anon_sym_AT_LPAREN] = "@(",
  [anon_sym_AT_LBRACE] = "@{",
  [anon_sym_DOT2] = ".",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_RBRACK] = "]",
  [anon_sym_DOTforeach] = ".foreach",
  [sym__statement_terminator] = "_statement_terminator",
  [sym_program] = "program",
  [sym__literal] = "_literal",
  [sym_integer_literal] = "integer_literal",
  [sym_string_literal] = "string_literal",
  [sym_expandable_string_literal] = "expandable_string_literal",
  [sym_expandable_here_string_literal] = "expandable_here_string_literal",
  [sym_type_name] = "type_name",
  [sym_array_type_name] = "array_type_name",
  [sym_generic_type_name] = "generic_type_name",
  [sym_assignement_operator] = "assignement_operator",
  [sym_file_redirection_operator] = "file_redirection_operator",
  [sym_merging_redirection_operator] = "merging_redirection_operator",
  [sym_comparison_operator] = "comparison_operator",
  [sym_variable] = "variable",
  [aux_sym__verbatim_command_argument_chars] = "_verbatim_command_argument_chars",
  [sym_script_block] = "script_block",
  [sym_param_block] = "param_block",
  [sym_parameter_list] = "parameter_list",
  [sym_script_parameter] = "script_parameter",
  [sym_script_parameter_default] = "script_parameter_default",
  [sym_script_block_body] = "script_block_body",
  [sym_named_block_list] = "named_block_list",
  [sym_named_block] = "named_block",
  [sym_block_name] = "block_name",
  [sym_statement_block] = "statement_block",
  [sym_statement_list] = "statement_list",
  [sym__statement] = "_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_if_statement] = "if_statement",
  [sym_elseif_clauses] = "elseif_clauses",
  [sym_elseif_clause] = "elseif_clause",
  [sym_else_clause] = "else_clause",
  [sym__labeled_statement] = "_labeled_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_switch_parameters] = "switch_parameters",
  [sym_switch_parameter] = "switch_parameter",
  [sym_switch_condition] = "switch_condition",
  [sym_switch_filename] = "switch_filename",
  [sym_switch_body] = "switch_body",
  [sym_switch_clauses] = "switch_clauses",
  [sym_switch_clause] = "switch_clause",
  [sym_switch_clause_condition] = "switch_clause_condition",
  [sym_foreach_statement] = "foreach_statement",
  [sym_foreach_parameter] = "foreach_parameter",
  [sym_for_statement] = "for_statement",
  [sym_for_initializer] = "for_initializer",
  [sym_for_condition] = "for_condition",
  [sym_for_iterator] = "for_iterator",
  [sym_while_statement] = "while_statement",
  [sym_while_condition] = "while_condition",
  [sym_do_statement] = "do_statement",
  [sym_function_statement] = "function_statement",
  [sym_function_name] = "function_name",
  [sym_function_parameter_declaration] = "function_parameter_declaration",
  [sym_flow_control_statement] = "flow_control_statement",
  [sym_label_expression] = "label_expression",
  [sym_trap_statement] = "trap_statement",
  [sym_try_statement] = "try_statement",
  [sym_catch_clauses] = "catch_clauses",
  [sym_catch_clause] = "catch_clause",
  [sym_catch_type_list] = "catch_type_list",
  [sym_finally_clause] = "finally_clause",
  [sym_data_statement] = "data_statement",
  [sym_data_name] = "data_name",
  [sym_data_commands_allowed] = "data_commands_allowed",
  [sym_data_commands_list] = "data_commands_list",
  [sym_data_command] = "data_command",
  [sym_inlinescript_statement] = "inlinescript_statement",
  [sym_parallel_statement] = "parallel_statement",
  [sym_sequence_statement] = "sequence_statement",
  [sym_pipeline] = "pipeline",
  [sym_left_assignment_expression] = "left_assignment_expression",
  [sym_assignment_expression] = "assignment_expression",
  [aux_sym__pipeline_tail] = "_pipeline_tail",
  [sym_command] = "command",
  [sym_command_invokation_operator] = "command_invokation_operator",
  [sym__expandable_string_literal_immediate] = "_expandable_string_literal_immediate",
  [sym_command_name] = "command_name",
  [sym_path_command_name] = "path_command_name",
  [sym_command_name_expr] = "command_name_expr",
  [sym_command_elements] = "command_elements",
  [sym__command_element] = "_command_element",
  [sym_command_argument_sep] = "command_argument_sep",
  [sym__command_argument] = "_command_argument",
  [sym_foreach_command] = "foreach_command",
  [sym_verbatim_command_argument] = "verbatim_command_argument",
  [sym_redirections] = "redirections",
  [sym_redirection] = "redirection",
  [sym_redirected_file_name] = "redirected_file_name",
  [sym_class_attribute] = "class_attribute",
  [sym_class_property_definition] = "class_property_definition",
  [sym_class_method_parameter] = "class_method_parameter",
  [sym_class_method_parameter_list] = "class_method_parameter_list",
  [sym_class_method_definition] = "class_method_definition",
  [sym_class_statement] = "class_statement",
  [sym_enum_statement] = "enum_statement",
  [sym_enum_member] = "enum_member",
  [sym__expression] = "_expression",
  [sym_logical_expression] = "logical_expression",
  [sym_bitwise_expression] = "bitwise_expression",
  [sym_comparison_expression] = "comparison_expression",
  [sym_additive_expression] = "additive_expression",
  [sym_multiplicative_expression] = "multiplicative_expression",
  [sym_format_expression] = "format_expression",
  [sym_range_expression] = "range_expression",
  [sym_array_literal_expression] = "array_literal_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_expression_with_unary_operator] = "expression_with_unary_operator",
  [sym_pre_increment_expression] = "pre_increment_expression",
  [sym_pre_decrement_expression] = "pre_decrement_expression",
  [sym_cast_expression] = "cast_expression",
  [sym__primary_expression] = "_primary_expression",
  [sym__value] = "_value",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_sub_expression] = "sub_expression",
  [sym_array_expression] = "array_expression",
  [sym_script_block_expression] = "script_block_expression",
  [sym_hash_literal_expression] = "hash_literal_expression",
  [sym_hash_literal_body] = "hash_literal_body",
  [sym_hash_entry] = "hash_entry",
  [sym_key_expression] = "key_expression",
  [sym_post_increment_expression] = "post_increment_expression",
  [sym_post_decrement_expression] = "post_decrement_expression",
  [sym_member_access] = "member_access",
  [sym_member_name] = "member_name",
  [sym_element_access] = "element_access",
  [sym_invokation_expression] = "invokation_expression",
  [sym_invokation_foreach_expression] = "invokation_foreach_expression",
  [sym_argument_list] = "argument_list",
  [sym_argument_expression_list] = "argument_expression_list",
  [sym_argument_expression] = "argument_expression",
  [sym_logical_argument_expression] = "logical_argument_expression",
  [sym_bitwise_argument_expression] = "bitwise_argument_expression",
  [sym_comparison_argument_expression] = "comparison_argument_expression",
  [sym_additive_argument_expression] = "additive_argument_expression",
  [sym_multiplicative_argument_expression] = "multiplicative_argument_expression",
  [sym_format_argument_expression] = "format_argument_expression",
  [sym_range_argument_expression] = "range_argument_expression",
  [sym_type_literal] = "type_literal",
  [sym_type_spec] = "type_spec",
  [sym_dimension] = "dimension",
  [sym_generic_type_arguments] = "generic_type_arguments",
  [sym_attribute_list] = "attribute_list",
  [sym_attribute] = "attribute",
  [sym_attribute_name] = "attribute_name",
  [sym_attribute_arguments] = "attribute_arguments",
  [sym_attribute_argument] = "attribute_argument",
  [aux_sym_expandable_string_literal_repeat1] = "expandable_string_literal_repeat1",
  [aux_sym_expandable_string_literal_repeat2] = "expandable_string_literal_repeat2",
  [aux_sym_expandable_here_string_literal_repeat1] = "expandable_here_string_literal_repeat1",
  [aux_sym_script_block_repeat1] = "script_block_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym_named_block_list_repeat1] = "named_block_list_repeat1",
  [aux_sym_statement_list_repeat1] = "statement_list_repeat1",
  [aux_sym_elseif_clauses_repeat1] = "elseif_clauses_repeat1",
  [aux_sym_switch_parameters_repeat1] = "switch_parameters_repeat1",
  [aux_sym_switch_clauses_repeat1] = "switch_clauses_repeat1",
  [aux_sym_catch_clauses_repeat1] = "catch_clauses_repeat1",
  [aux_sym_catch_type_list_repeat1] = "catch_type_list_repeat1",
  [aux_sym_data_commands_list_repeat1] = "data_commands_list_repeat1",
  [aux_sym__expandable_string_literal_immediate_repeat1] = "_expandable_string_literal_immediate_repeat1",
  [aux_sym__expandable_string_literal_immediate_repeat2] = "_expandable_string_literal_immediate_repeat2",
  [aux_sym_command_name_repeat1] = "command_name_repeat1",
  [aux_sym_path_command_name_repeat1] = "path_command_name_repeat1",
  [aux_sym_command_elements_repeat1] = "command_elements_repeat1",
  [aux_sym_command_argument_sep_repeat1] = "command_argument_sep_repeat1",
  [aux_sym_foreach_command_repeat1] = "foreach_command_repeat1",
  [aux_sym_redirections_repeat1] = "redirections_repeat1",
  [aux_sym_class_property_definition_repeat1] = "class_property_definition_repeat1",
  [aux_sym_class_method_parameter_list_repeat1] = "class_method_parameter_list_repeat1",
  [aux_sym_class_statement_repeat1] = "class_statement_repeat1",
  [aux_sym_class_statement_repeat2] = "class_statement_repeat2",
  [aux_sym_enum_statement_repeat1] = "enum_statement_repeat1",
  [aux_sym_hash_literal_body_repeat1] = "hash_literal_body_repeat1",
  [aux_sym_argument_expression_list_repeat1] = "argument_expression_list_repeat1",
  [aux_sym_dimension_repeat1] = "dimension_repeat1",
  [aux_sym_generic_type_arguments_repeat1] = "generic_type_arguments_repeat1",
  [aux_sym_attribute_list_repeat1] = "attribute_list_repeat1",
  [aux_sym_attribute_arguments_repeat1] = "attribute_arguments_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_comment] = sym_comment,
  [sym_decimal_integer_literal] = sym_decimal_integer_literal,
  [sym_hexadecimal_integer_literal] = sym_hexadecimal_integer_literal,
  [sym_real_literal] = sym_real_literal,
  [aux_sym_expandable_string_literal_token1] = aux_sym_expandable_string_literal_token1,
  [aux_sym_expandable_string_literal_token2] = aux_sym_expandable_string_literal_token2,
  [aux_sym_expandable_string_literal_token3] = aux_sym_expandable_string_literal_token3,
  [aux_sym_expandable_string_literal_token4] = aux_sym_expandable_string_literal_token4,
  [anon_sym_DQUOTE_DQUOTE] = anon_sym_DQUOTE_DQUOTE,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [aux_sym_expandable_string_literal_token5] = aux_sym_expandable_string_literal_token5,
  [aux_sym_expandable_here_string_literal_token1] = aux_sym_expandable_here_string_literal_token1,
  [aux_sym_expandable_here_string_literal_token2] = aux_sym_expandable_here_string_literal_token2,
  [aux_sym_expandable_here_string_literal_token3] = aux_sym_expandable_here_string_literal_token3,
  [aux_sym_expandable_here_string_literal_token4] = aux_sym_expandable_here_string_literal_token4,
  [aux_sym_expandable_here_string_literal_token5] = aux_sym_expandable_here_string_literal_token5,
  [sym_verbatim_string_characters] = sym_verbatim_string_characters,
  [sym_verbatim_here_string_characters] = sym_verbatim_here_string_characters,
  [sym_simple_name] = sym_simple_name,
  [sym_type_identifier] = sym_type_identifier,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_2_GT] = anon_sym_2_GT,
  [anon_sym_2_GT_GT] = anon_sym_2_GT_GT,
  [anon_sym_3_GT] = anon_sym_3_GT,
  [anon_sym_3_GT_GT] = anon_sym_3_GT_GT,
  [anon_sym_4_GT] = anon_sym_4_GT,
  [anon_sym_4_GT_GT] = anon_sym_4_GT_GT,
  [anon_sym_5_GT] = anon_sym_5_GT,
  [anon_sym_5_GT_GT] = anon_sym_5_GT_GT,
  [anon_sym_6_GT] = anon_sym_6_GT,
  [anon_sym_6_GT_GT] = anon_sym_6_GT_GT,
  [anon_sym_STAR_GT] = anon_sym_STAR_GT,
  [anon_sym_STAR_GT_GT] = anon_sym_STAR_GT_GT,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_STAR_GT_AMP1] = anon_sym_STAR_GT_AMP1,
  [anon_sym_2_GT_AMP1] = anon_sym_2_GT_AMP1,
  [anon_sym_3_GT_AMP1] = anon_sym_3_GT_AMP1,
  [anon_sym_4_GT_AMP1] = anon_sym_4_GT_AMP1,
  [anon_sym_5_GT_AMP1] = anon_sym_5_GT_AMP1,
  [anon_sym_6_GT_AMP1] = anon_sym_6_GT_AMP1,
  [anon_sym_STAR_GT_AMP2] = anon_sym_STAR_GT_AMP2,
  [anon_sym_1_GT_AMP2] = anon_sym_1_GT_AMP2,
  [anon_sym_3_GT_AMP2] = anon_sym_3_GT_AMP2,
  [anon_sym_4_GT_AMP2] = anon_sym_4_GT_AMP2,
  [anon_sym_5_GT_AMP2] = anon_sym_5_GT_AMP2,
  [anon_sym_6_GT_AMP2] = anon_sym_6_GT_AMP2,
  [anon_sym_DASHas] = anon_sym_DASHas,
  [anon_sym_DASHccontains] = anon_sym_DASHccontains,
  [anon_sym_DASHceq] = anon_sym_DASHceq,
  [anon_sym_DASHcge] = anon_sym_DASHcge,
  [anon_sym_DASHcgt] = anon_sym_DASHcgt,
  [anon_sym_DASHcle] = anon_sym_DASHcle,
  [anon_sym_DASHclike] = anon_sym_DASHclike,
  [anon_sym_DASHclt] = anon_sym_DASHclt,
  [anon_sym_DASHcmatch] = anon_sym_DASHcmatch,
  [anon_sym_DASHcne] = anon_sym_DASHcne,
  [anon_sym_DASHcnotcontains] = anon_sym_DASHcnotcontains,
  [anon_sym_DASHcnotlike] = anon_sym_DASHcnotlike,
  [anon_sym_DASHcnotmatch] = anon_sym_DASHcnotmatch,
  [anon_sym_DASHcontains] = anon_sym_DASHcontains,
  [anon_sym_DASHcreplace] = anon_sym_DASHcreplace,
  [anon_sym_DASHcsplit] = anon_sym_DASHcsplit,
  [anon_sym_DASHeq] = anon_sym_DASHeq,
  [anon_sym_DASHge] = anon_sym_DASHge,
  [anon_sym_DASHgt] = anon_sym_DASHgt,
  [anon_sym_DASHicontains] = anon_sym_DASHicontains,
  [anon_sym_DASHieq] = anon_sym_DASHieq,
  [anon_sym_DASHige] = anon_sym_DASHige,
  [anon_sym_DASHigt] = anon_sym_DASHigt,
  [anon_sym_DASHile] = anon_sym_DASHile,
  [anon_sym_DASHilike] = anon_sym_DASHilike,
  [anon_sym_DASHilt] = anon_sym_DASHilt,
  [anon_sym_DASHimatch] = anon_sym_DASHimatch,
  [anon_sym_DASHin] = anon_sym_DASHin,
  [anon_sym_DASHine] = anon_sym_DASHine,
  [anon_sym_DASHinotcontains] = anon_sym_DASHinotcontains,
  [anon_sym_DASHinotlike] = anon_sym_DASHinotlike,
  [anon_sym_DASHinotmatch] = anon_sym_DASHinotmatch,
  [anon_sym_DASHireplace] = anon_sym_DASHireplace,
  [anon_sym_DASHis] = anon_sym_DASHis,
  [anon_sym_DASHisnot] = anon_sym_DASHisnot,
  [anon_sym_DASHisplit] = anon_sym_DASHisplit,
  [anon_sym_DASHjoin] = anon_sym_DASHjoin,
  [anon_sym_DASHle] = anon_sym_DASHle,
  [anon_sym_DASHlike] = anon_sym_DASHlike,
  [anon_sym_DASHlt] = anon_sym_DASHlt,
  [anon_sym_DASHmatch] = anon_sym_DASHmatch,
  [anon_sym_DASHne] = anon_sym_DASHne,
  [anon_sym_DASHnotcontains] = anon_sym_DASHnotcontains,
  [anon_sym_DASHnotin] = anon_sym_DASHnotin,
  [anon_sym_DASHnotlike] = anon_sym_DASHnotlike,
  [anon_sym_DASHnotmatch] = anon_sym_DASHnotmatch,
  [anon_sym_DASHreplace] = anon_sym_DASHreplace,
  [anon_sym_DASHshl] = anon_sym_DASHshl,
  [anon_sym_DASHshr] = anon_sym_DASHshr,
  [anon_sym_DASHsplit] = anon_sym_DASHsplit,
  [sym_format_operator] = sym_format_operator,
  [anon_sym_DOLLAR_DOLLAR] = anon_sym_DOLLAR_DOLLAR,
  [anon_sym_DOLLAR_CARET] = anon_sym_DOLLAR_CARET,
  [anon_sym_DOLLAR_QMARK] = anon_sym_DOLLAR_QMARK,
  [anon_sym_DOLLAR_] = anon_sym_DOLLAR_,
  [aux_sym_variable_token1] = aux_sym_variable_token1,
  [aux_sym_variable_token2] = aux_sym_variable_token2,
  [sym_braced_variable] = sym_braced_variable,
  [sym_generic_token] = sym_generic_token,
  [sym__command_token] = sym__command_token,
  [sym_command_parameter] = sym_command_parameter,
  [aux_sym__verbatim_command_argument_chars_token1] = aux_sym__verbatim_command_argument_chars_token1,
  [aux_sym__verbatim_command_argument_chars_token2] = aux_sym__verbatim_command_argument_chars_token2,
  [aux_sym__verbatim_command_argument_chars_token3] = aux_sym__verbatim_command_argument_chars_token3,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_param] = anon_sym_param,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_dynamicparam] = anon_sym_dynamicparam,
  [anon_sym_begin] = anon_sym_begin,
  [anon_sym_process] = anon_sym_process,
  [anon_sym_end] = anon_sym_end,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_elseif] = anon_sym_elseif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_DASHregex] = anon_sym_DASHregex,
  [anon_sym_DASHwildcard] = anon_sym_DASHwildcard,
  [anon_sym_DASHexact] = anon_sym_DASHexact,
  [anon_sym_DASHcasesensitive] = anon_sym_DASHcasesensitive,
  [anon_sym_DASHparallel] = anon_sym_DASHparallel,
  [anon_sym_DASHfile] = anon_sym_DASHfile,
  [anon_sym_foreach] = anon_sym_foreach,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_LF] = anon_sym_LF,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_until] = anon_sym_until,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_filter] = anon_sym_filter,
  [anon_sym_workflow] = anon_sym_workflow,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_exit] = anon_sym_exit,
  [sym_label] = sym_label,
  [anon_sym_trap] = anon_sym_trap,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_data] = anon_sym_data,
  [anon_sym_DASHsupportedcommand] = anon_sym_DASHsupportedcommand,
  [anon_sym_inlinescript] = anon_sym_inlinescript,
  [anon_sym_parallel] = anon_sym_parallel,
  [anon_sym_sequence] = anon_sym_sequence,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_AMP] = anon_sym_AMP,
  [aux_sym__expandable_string_literal_immediate_token1] = aux_sym__expandable_string_literal_immediate_token1,
  [aux_sym__expandable_string_literal_immediate_token2] = aux_sym__expandable_string_literal_immediate_token2,
  [aux_sym__expandable_string_literal_immediate_token3] = aux_sym__expandable_string_literal_immediate_token3,
  [anon_sym_DQUOTE_DQUOTE2] = anon_sym_DQUOTE_DQUOTE,
  [anon_sym_DOLLAR2] = anon_sym_DOLLAR,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_command_name_token1] = aux_sym_command_name_token1,
  [aux_sym_command_name_token2] = aux_sym_command_name_token2,
  [anon_sym_DQUOTE2] = anon_sym_DQUOTE,
  [anon_sym_SQUOTE_SQUOTE] = anon_sym_SQUOTE_SQUOTE,
  [sym_path_command_name_token] = sym_path_command_name_token,
  [sym_stop_parsing] = sym_stop_parsing,
  [anon_sym_SPACE] = anon_sym_SPACE,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_foreach_DASHobject] = anon_sym_foreach_DASHobject,
  [anon_sym_DASH_DASH_PERCENT] = anon_sym_DASH_DASH_PERCENT,
  [anon_sym_hidden] = anon_sym_hidden,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_DASHand] = anon_sym_DASHand,
  [anon_sym_DASHor] = anon_sym_DASHor,
  [anon_sym_DASHxor] = anon_sym_DASHxor,
  [anon_sym_DASHband] = anon_sym_DASHband,
  [anon_sym_DASHbor] = anon_sym_DASHbor,
  [anon_sym_DASHbxor] = anon_sym_DASHbxor,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_BSLASH] = anon_sym_BSLASH,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_DASHnot] = anon_sym_DASHnot,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_DASHbnot] = anon_sym_DASHbnot,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_DOLLAR_LPAREN] = anon_sym_DOLLAR_LPAREN,
  [anon_sym_AT_LPAREN] = anon_sym_AT_LPAREN,
  [anon_sym_AT_LBRACE] = anon_sym_AT_LBRACE,
  [anon_sym_DOT2] = anon_sym_DOT,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_DOTforeach] = anon_sym_DOTforeach,
  [sym__statement_terminator] = sym__statement_terminator,
  [sym_program] = sym_program,
  [sym__literal] = sym__literal,
  [sym_integer_literal] = sym_integer_literal,
  [sym_string_literal] = sym_string_literal,
  [sym_expandable_string_literal] = sym_expandable_string_literal,
  [sym_expandable_here_string_literal] = sym_expandable_here_string_literal,
  [sym_type_name] = sym_type_name,
  [sym_array_type_name] = sym_array_type_name,
  [sym_generic_type_name] = sym_generic_type_name,
  [sym_assignement_operator] = sym_assignement_operator,
  [sym_file_redirection_operator] = sym_file_redirection_operator,
  [sym_merging_redirection_operator] = sym_merging_redirection_operator,
  [sym_comparison_operator] = sym_comparison_operator,
  [sym_variable] = sym_variable,
  [aux_sym__verbatim_command_argument_chars] = aux_sym__verbatim_command_argument_chars,
  [sym_script_block] = sym_script_block,
  [sym_param_block] = sym_param_block,
  [sym_parameter_list] = sym_parameter_list,
  [sym_script_parameter] = sym_script_parameter,
  [sym_script_parameter_default] = sym_script_parameter_default,
  [sym_script_block_body] = sym_script_block_body,
  [sym_named_block_list] = sym_named_block_list,
  [sym_named_block] = sym_named_block,
  [sym_block_name] = sym_block_name,
  [sym_statement_block] = sym_statement_block,
  [sym_statement_list] = sym_statement_list,
  [sym__statement] = sym__statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_elseif_clauses] = sym_elseif_clauses,
  [sym_elseif_clause] = sym_elseif_clause,
  [sym_else_clause] = sym_else_clause,
  [sym__labeled_statement] = sym__labeled_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_switch_parameters] = sym_switch_parameters,
  [sym_switch_parameter] = sym_switch_parameter,
  [sym_switch_condition] = sym_switch_condition,
  [sym_switch_filename] = sym_switch_filename,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_clauses] = sym_switch_clauses,
  [sym_switch_clause] = sym_switch_clause,
  [sym_switch_clause_condition] = sym_switch_clause_condition,
  [sym_foreach_statement] = sym_foreach_statement,
  [sym_foreach_parameter] = sym_foreach_parameter,
  [sym_for_statement] = sym_for_statement,
  [sym_for_initializer] = sym_for_initializer,
  [sym_for_condition] = sym_for_condition,
  [sym_for_iterator] = sym_for_iterator,
  [sym_while_statement] = sym_while_statement,
  [sym_while_condition] = sym_while_condition,
  [sym_do_statement] = sym_do_statement,
  [sym_function_statement] = sym_function_statement,
  [sym_function_name] = sym_function_name,
  [sym_function_parameter_declaration] = sym_function_parameter_declaration,
  [sym_flow_control_statement] = sym_flow_control_statement,
  [sym_label_expression] = sym_label_expression,
  [sym_trap_statement] = sym_trap_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_clauses] = sym_catch_clauses,
  [sym_catch_clause] = sym_catch_clause,
  [sym_catch_type_list] = sym_catch_type_list,
  [sym_finally_clause] = sym_finally_clause,
  [sym_data_statement] = sym_data_statement,
  [sym_data_name] = sym_data_name,
  [sym_data_commands_allowed] = sym_data_commands_allowed,
  [sym_data_commands_list] = sym_data_commands_list,
  [sym_data_command] = sym_data_command,
  [sym_inlinescript_statement] = sym_inlinescript_statement,
  [sym_parallel_statement] = sym_parallel_statement,
  [sym_sequence_statement] = sym_sequence_statement,
  [sym_pipeline] = sym_pipeline,
  [sym_left_assignment_expression] = sym_left_assignment_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [aux_sym__pipeline_tail] = aux_sym__pipeline_tail,
  [sym_command] = sym_command,
  [sym_command_invokation_operator] = sym_command_invokation_operator,
  [sym__expandable_string_literal_immediate] = sym__expandable_string_literal_immediate,
  [sym_command_name] = sym_command_name,
  [sym_path_command_name] = sym_path_command_name,
  [sym_command_name_expr] = sym_command_name_expr,
  [sym_command_elements] = sym_command_elements,
  [sym__command_element] = sym__command_element,
  [sym_command_argument_sep] = sym_command_argument_sep,
  [sym__command_argument] = sym__command_argument,
  [sym_foreach_command] = sym_foreach_command,
  [sym_verbatim_command_argument] = sym_verbatim_command_argument,
  [sym_redirections] = sym_redirections,
  [sym_redirection] = sym_redirection,
  [sym_redirected_file_name] = sym_redirected_file_name,
  [sym_class_attribute] = sym_class_attribute,
  [sym_class_property_definition] = sym_class_property_definition,
  [sym_class_method_parameter] = sym_class_method_parameter,
  [sym_class_method_parameter_list] = sym_class_method_parameter_list,
  [sym_class_method_definition] = sym_class_method_definition,
  [sym_class_statement] = sym_class_statement,
  [sym_enum_statement] = sym_enum_statement,
  [sym_enum_member] = sym_enum_member,
  [sym__expression] = sym__expression,
  [sym_logical_expression] = sym_logical_expression,
  [sym_bitwise_expression] = sym_bitwise_expression,
  [sym_comparison_expression] = sym_comparison_expression,
  [sym_additive_expression] = sym_additive_expression,
  [sym_multiplicative_expression] = sym_multiplicative_expression,
  [sym_format_expression] = sym_format_expression,
  [sym_range_expression] = sym_range_expression,
  [sym_array_literal_expression] = sym_array_literal_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_expression_with_unary_operator] = sym_expression_with_unary_operator,
  [sym_pre_increment_expression] = sym_pre_increment_expression,
  [sym_pre_decrement_expression] = sym_pre_decrement_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym__primary_expression] = sym__primary_expression,
  [sym__value] = sym__value,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_sub_expression] = sym_sub_expression,
  [sym_array_expression] = sym_array_expression,
  [sym_script_block_expression] = sym_script_block_expression,
  [sym_hash_literal_expression] = sym_hash_literal_expression,
  [sym_hash_literal_body] = sym_hash_literal_body,
  [sym_hash_entry] = sym_hash_entry,
  [sym_key_expression] = sym_key_expression,
  [sym_post_increment_expression] = sym_post_increment_expression,
  [sym_post_decrement_expression] = sym_post_decrement_expression,
  [sym_member_access] = sym_member_access,
  [sym_member_name] = sym_member_name,
  [sym_element_access] = sym_element_access,
  [sym_invokation_expression] = sym_invokation_expression,
  [sym_invokation_foreach_expression] = sym_invokation_foreach_expression,
  [sym_argument_list] = sym_argument_list,
  [sym_argument_expression_list] = sym_argument_expression_list,
  [sym_argument_expression] = sym_argument_expression,
  [sym_logical_argument_expression] = sym_logical_argument_expression,
  [sym_bitwise_argument_expression] = sym_bitwise_argument_expression,
  [sym_comparison_argument_expression] = sym_comparison_argument_expression,
  [sym_additive_argument_expression] = sym_additive_argument_expression,
  [sym_multiplicative_argument_expression] = sym_multiplicative_argument_expression,
  [sym_format_argument_expression] = sym_format_argument_expression,
  [sym_range_argument_expression] = sym_range_argument_expression,
  [sym_type_literal] = sym_type_literal,
  [sym_type_spec] = sym_type_spec,
  [sym_dimension] = sym_dimension,
  [sym_generic_type_arguments] = sym_generic_type_arguments,
  [sym_attribute_list] = sym_attribute_list,
  [sym_attribute] = sym_attribute,
  [sym_attribute_name] = sym_attribute_name,
  [sym_attribute_arguments] = sym_attribute_arguments,
  [sym_attribute_argument] = sym_attribute_argument,
  [aux_sym_expandable_string_literal_repeat1] = aux_sym_expandable_string_literal_repeat1,
  [aux_sym_expandable_string_literal_repeat2] = aux_sym_expandable_string_literal_repeat2,
  [aux_sym_expandable_here_string_literal_repeat1] = aux_sym_expandable_here_string_literal_repeat1,
  [aux_sym_script_block_repeat1] = aux_sym_script_block_repeat1,
  [aux_sym_parameter_list_repeat1] = aux_sym_parameter_list_repeat1,
  [aux_sym_named_block_list_repeat1] = aux_sym_named_block_list_repeat1,
  [aux_sym_statement_list_repeat1] = aux_sym_statement_list_repeat1,
  [aux_sym_elseif_clauses_repeat1] = aux_sym_elseif_clauses_repeat1,
  [aux_sym_switch_parameters_repeat1] = aux_sym_switch_parameters_repeat1,
  [aux_sym_switch_clauses_repeat1] = aux_sym_switch_clauses_repeat1,
  [aux_sym_catch_clauses_repeat1] = aux_sym_catch_clauses_repeat1,
  [aux_sym_catch_type_list_repeat1] = aux_sym_catch_type_list_repeat1,
  [aux_sym_data_commands_list_repeat1] = aux_sym_data_commands_list_repeat1,
  [aux_sym__expandable_string_literal_immediate_repeat1] = aux_sym__expandable_string_literal_immediate_repeat1,
  [aux_sym__expandable_string_literal_immediate_repeat2] = aux_sym__expandable_string_literal_immediate_repeat2,
  [aux_sym_command_name_repeat1] = aux_sym_command_name_repeat1,
  [aux_sym_path_command_name_repeat1] = aux_sym_path_command_name_repeat1,
  [aux_sym_command_elements_repeat1] = aux_sym_command_elements_repeat1,
  [aux_sym_command_argument_sep_repeat1] = aux_sym_command_argument_sep_repeat1,
  [aux_sym_foreach_command_repeat1] = aux_sym_foreach_command_repeat1,
  [aux_sym_redirections_repeat1] = aux_sym_redirections_repeat1,
  [aux_sym_class_property_definition_repeat1] = aux_sym_class_property_definition_repeat1,
  [aux_sym_class_method_parameter_list_repeat1] = aux_sym_class_method_parameter_list_repeat1,
  [aux_sym_class_statement_repeat1] = aux_sym_class_statement_repeat1,
  [aux_sym_class_statement_repeat2] = aux_sym_class_statement_repeat2,
  [aux_sym_enum_statement_repeat1] = aux_sym_enum_statement_repeat1,
  [aux_sym_hash_literal_body_repeat1] = aux_sym_hash_literal_body_repeat1,
  [aux_sym_argument_expression_list_repeat1] = aux_sym_argument_expression_list_repeat1,
  [aux_sym_dimension_repeat1] = aux_sym_dimension_repeat1,
  [aux_sym_generic_type_arguments_repeat1] = aux_sym_generic_type_arguments_repeat1,
  [aux_sym_attribute_list_repeat1] = aux_sym_attribute_list_repeat1,
  [aux_sym_attribute_arguments_repeat1] = aux_sym_attribute_arguments_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_decimal_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_hexadecimal_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_real_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_expandable_string_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expandable_string_literal_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expandable_string_literal_token3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expandable_string_literal_token4] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_expandable_string_literal_token5] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expandable_here_string_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expandable_here_string_literal_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expandable_here_string_literal_token3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expandable_here_string_literal_token4] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expandable_here_string_literal_token5] = {
    .visible = false,
    .named = false,
  },
  [sym_verbatim_string_characters] = {
    .visible = true,
    .named = true,
  },
  [sym_verbatim_here_string_characters] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_name] = {
    .visible = true,
    .named = true,
  },
  [sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_2_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_2_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_3_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_3_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_4_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_4_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_5_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_5_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_6_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_6_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_GT_AMP1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_2_GT_AMP1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_3_GT_AMP1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_4_GT_AMP1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_5_GT_AMP1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_6_GT_AMP1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_GT_AMP2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_1_GT_AMP2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_3_GT_AMP2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_4_GT_AMP2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_5_GT_AMP2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_6_GT_AMP2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHas] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHccontains] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHceq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHcge] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHcgt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHcle] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHclike] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHclt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHcmatch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHcne] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHcnotcontains] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHcnotlike] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHcnotmatch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHcontains] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHcreplace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHcsplit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHeq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHge] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHgt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHicontains] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHieq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHige] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHigt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHilike] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHilt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHimatch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHine] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHinotcontains] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHinotlike] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHinotmatch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHireplace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHis] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHisnot] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHisplit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHjoin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHle] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHlike] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHlt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHmatch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHne] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHnotcontains] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHnotin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHnotlike] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHnotmatch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHreplace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHshl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHshr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHsplit] = {
    .visible = true,
    .named = false,
  },
  [sym_format_operator] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOLLAR_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_variable_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_braced_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_token] = {
    .visible = true,
    .named = true,
  },
  [sym__command_token] = {
    .visible = false,
    .named = true,
  },
  [sym_command_parameter] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__verbatim_command_argument_chars_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__verbatim_command_argument_chars_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__verbatim_command_argument_chars_token3] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_param] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dynamicparam] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_begin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_process] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elseif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHregex] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHwildcard] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHexact] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHcasesensitive] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHparallel] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHfile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_foreach] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_until] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_filter] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_workflow] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exit] = {
    .visible = true,
    .named = false,
  },
  [sym_label] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_trap] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_data] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHsupportedcommand] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inlinescript] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_parallel] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sequence] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__expandable_string_literal_immediate_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__expandable_string_literal_immediate_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__expandable_string_literal_immediate_token3] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DQUOTE_DQUOTE2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_command_name_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_name_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DQUOTE2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_path_command_name_token] = {
    .visible = true,
    .named = true,
  },
  [sym_stop_parsing] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SPACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_foreach_DASHobject] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_hidden] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHand] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHxor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHband] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHbor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHbxor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHnot] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASHbnot] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOTforeach] = {
    .visible = true,
    .named = false,
  },
  [sym__statement_terminator] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
  },
  [sym_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_expandable_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_expandable_here_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_type_name] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type_name] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type_name] = {
    .visible = true,
    .named = true,
  },
  [sym_assignement_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_file_redirection_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_merging_redirection_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_comparison_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_variable] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__verbatim_command_argument_chars] = {
    .visible = false,
    .named = false,
  },
  [sym_script_block] = {
    .visible = true,
    .named = true,
  },
  [sym_param_block] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_script_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_script_parameter_default] = {
    .visible = true,
    .named = true,
  },
  [sym_script_block_body] = {
    .visible = true,
    .named = true,
  },
  [sym_named_block_list] = {
    .visible = true,
    .named = true,
  },
  [sym_named_block] = {
    .visible = true,
    .named = true,
  },
  [sym_block_name] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_list] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elseif_clauses] = {
    .visible = true,
    .named = true,
  },
  [sym_elseif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__labeled_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_condition] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_filename] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_clauses] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_clause_condition] = {
    .visible = true,
    .named = true,
  },
  [sym_foreach_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_foreach_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_for_condition] = {
    .visible = true,
    .named = true,
  },
  [sym_for_iterator] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_condition] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_function_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_function_name] = {
    .visible = true,
    .named = true,
  },
  [sym_function_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_flow_control_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_label_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_trap_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clauses] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_type_list] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_data_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_data_name] = {
    .visible = true,
    .named = true,
  },
  [sym_data_commands_allowed] = {
    .visible = true,
    .named = true,
  },
  [sym_data_commands_list] = {
    .visible = true,
    .named = true,
  },
  [sym_data_command] = {
    .visible = true,
    .named = true,
  },
  [sym_inlinescript_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_parallel_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_pipeline] = {
    .visible = true,
    .named = true,
  },
  [sym_left_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__pipeline_tail] = {
    .visible = false,
    .named = false,
  },
  [sym_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command_invokation_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__expandable_string_literal_immediate] = {
    .visible = false,
    .named = true,
  },
  [sym_command_name] = {
    .visible = true,
    .named = true,
  },
  [sym_path_command_name] = {
    .visible = true,
    .named = true,
  },
  [sym_command_name_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_command_elements] = {
    .visible = true,
    .named = true,
  },
  [sym__command_element] = {
    .visible = false,
    .named = true,
  },
  [sym_command_argument_sep] = {
    .visible = true,
    .named = true,
  },
  [sym__command_argument] = {
    .visible = false,
    .named = true,
  },
  [sym_foreach_command] = {
    .visible = true,
    .named = true,
  },
  [sym_verbatim_command_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_redirections] = {
    .visible = true,
    .named = true,
  },
  [sym_redirection] = {
    .visible = true,
    .named = true,
  },
  [sym_redirected_file_name] = {
    .visible = true,
    .named = true,
  },
  [sym_class_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_class_property_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_class_method_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_class_method_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_class_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_class_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_member] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_logical_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_bitwise_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_comparison_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_additive_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_multiplicative_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_format_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_range_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_array_literal_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_with_unary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_pre_increment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_pre_decrement_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__value] = {
    .visible = false,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sub_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_array_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_script_block_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_literal_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_literal_body] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_entry] = {
    .visible = true,
    .named = true,
  },
  [sym_key_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_post_increment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_post_decrement_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_access] = {
    .visible = true,
    .named = true,
  },
  [sym_member_name] = {
    .visible = true,
    .named = true,
  },
  [sym_element_access] = {
    .visible = true,
    .named = true,
  },
  [sym_invokation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_invokation_foreach_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_argument_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_bitwise_argument_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_comparison_argument_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_additive_argument_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_multiplicative_argument_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_format_argument_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_range_argument_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_type_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_dimension] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_list] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_name] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_argument] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_expandable_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expandable_string_literal_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expandable_here_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_script_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_block_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_statement_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_elseif_clauses_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_clauses_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_catch_clauses_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_catch_type_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_data_commands_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__expandable_string_literal_immediate_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__expandable_string_literal_immediate_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_name_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_path_command_name_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_elements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_argument_sep_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_foreach_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_redirections_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_property_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_method_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_statement_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_hash_literal_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_expression_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dimension_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_generic_type_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_argument_expression_list = 1,
  field_command_elements = 2,
  field_command_name = 3,
  field_condition = 4,
  field_else_clause = 5,
  field_elseif_clauses = 6,
  field_for_condition = 7,
  field_for_initializer = 8,
  field_for_iterator = 9,
  field_named_block_list = 10,
  field_script_block_body = 11,
  field_statement_list = 12,
  field_statements = 13,
  field_value = 14,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_argument_expression_list] = "argument_expression_list",
  [field_command_elements] = "command_elements",
  [field_command_name] = "command_name",
  [field_condition] = "condition",
  [field_else_clause] = "else_clause",
  [field_elseif_clauses] = "elseif_clauses",
  [field_for_condition] = "for_condition",
  [field_for_initializer] = "for_initializer",
  [field_for_iterator] = "for_iterator",
  [field_named_block_list] = "named_block_list",
  [field_script_block_body] = "script_block_body",
  [field_statement_list] = "statement_list",
  [field_statements] = "statements",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 2, .length = 1},
  [4] = {.index = 3, .length = 1},
  [5] = {.index = 4, .length = 1},
  [6] = {.index = 5, .length = 1},
  [7] = {.index = 6, .length = 2},
  [8] = {.index = 8, .length = 1},
  [9] = {.index = 9, .length = 1},
  [10] = {.index = 10, .length = 2},
  [11] = {.index = 12, .length = 1},
  [12] = {.index = 13, .length = 1},
  [13] = {.index = 14, .length = 1},
  [14] = {.index = 15, .length = 1},
  [15] = {.index = 16, .length = 1},
  [16] = {.index = 17, .length = 2},
  [17] = {.index = 19, .length = 2},
  [18] = {.index = 21, .length = 1},
  [19] = {.index = 22, .length = 1},
  [20] = {.index = 23, .length = 3},
  [21] = {.index = 26, .length = 1},
  [22] = {.index = 27, .length = 1},
  [23] = {.index = 28, .length = 2},
  [24] = {.index = 30, .length = 2},
  [25] = {.index = 32, .length = 2},
  [26] = {.index = 34, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_command_name, 0},
  [1] =
    {field_script_block_body, 0},
  [2] =
    {field_named_block_list, 0},
  [3] =
    {field_statement_list, 0},
  [4] =
    {field_command_elements, 1},
  [5] =
    {field_command_name, 1},
  [6] =
    {field_command_elements, 1},
    {field_command_name, 0},
  [8] =
    {field_statements, 1},
  [9] =
    {field_value, 2},
  [10] =
    {field_command_elements, 2},
    {field_command_name, 1},
  [12] =
    {field_script_block_body, 2},
  [13] =
    {field_statement_list, 1},
  [14] =
    {field_script_block_body, 3},
  [15] =
    {field_condition, 2},
  [16] =
    {field_argument_expression_list, 1},
  [17] =
    {field_condition, 2},
    {field_elseif_clauses, 5},
  [19] =
    {field_condition, 2},
    {field_else_clause, 5},
  [21] =
    {field_for_initializer, 2},
  [22] =
    {field_condition, 4},
  [23] =
    {field_condition, 2},
    {field_else_clause, 6},
    {field_elseif_clauses, 5},
  [26] =
    {field_for_condition, 3},
  [27] =
    {field_for_iterator, 4},
  [28] =
    {field_for_condition, 5},
    {field_for_initializer, 2},
  [30] =
    {field_for_condition, 3},
    {field_for_iterator, 6},
  [32] =
    {field_for_initializer, 2},
    {field_for_iterator, 6},
  [34] =
    {field_for_condition, 5},
    {field_for_initializer, 2},
    {field_for_iterator, 8},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 3,
  [5] = 3,
  [6] = 3,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 7,
  [11] = 11,
  [12] = 7,
  [13] = 7,
  [14] = 14,
  [15] = 11,
  [16] = 14,
  [17] = 7,
  [18] = 7,
  [19] = 19,
  [20] = 20,
  [21] = 14,
  [22] = 7,
  [23] = 23,
  [24] = 7,
  [25] = 7,
  [26] = 11,
  [27] = 7,
  [28] = 11,
  [29] = 14,
  [30] = 30,
  [31] = 30,
  [32] = 30,
  [33] = 30,
  [34] = 30,
  [35] = 30,
  [36] = 30,
  [37] = 30,
  [38] = 30,
  [39] = 30,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 42,
  [44] = 44,
  [45] = 45,
  [46] = 44,
  [47] = 45,
  [48] = 44,
  [49] = 49,
  [50] = 50,
  [51] = 49,
  [52] = 45,
  [53] = 44,
  [54] = 49,
  [55] = 49,
  [56] = 44,
  [57] = 45,
  [58] = 58,
  [59] = 45,
  [60] = 49,
  [61] = 45,
  [62] = 45,
  [63] = 45,
  [64] = 44,
  [65] = 45,
  [66] = 44,
  [67] = 49,
  [68] = 49,
  [69] = 45,
  [70] = 44,
  [71] = 49,
  [72] = 45,
  [73] = 58,
  [74] = 50,
  [75] = 75,
  [76] = 3,
  [77] = 3,
  [78] = 3,
  [79] = 79,
  [80] = 80,
  [81] = 3,
  [82] = 79,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 83,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 86,
  [95] = 95,
  [96] = 83,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 83,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 106,
  [107] = 84,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 97,
  [123] = 105,
  [124] = 110,
  [125] = 85,
  [126] = 109,
  [127] = 111,
  [128] = 120,
  [129] = 98,
  [130] = 92,
  [131] = 99,
  [132] = 114,
  [133] = 102,
  [134] = 89,
  [135] = 135,
  [136] = 93,
  [137] = 117,
  [138] = 118,
  [139] = 119,
  [140] = 121,
  [141] = 90,
  [142] = 104,
  [143] = 88,
  [144] = 95,
  [145] = 135,
  [146] = 101,
  [147] = 112,
  [148] = 106,
  [149] = 91,
  [150] = 115,
  [151] = 108,
  [152] = 103,
  [153] = 113,
  [154] = 116,
  [155] = 135,
  [156] = 135,
  [157] = 119,
  [158] = 90,
  [159] = 121,
  [160] = 118,
  [161] = 117,
  [162] = 162,
  [163] = 112,
  [164] = 164,
  [165] = 112,
  [166] = 166,
  [167] = 90,
  [168] = 168,
  [169] = 164,
  [170] = 168,
  [171] = 118,
  [172] = 117,
  [173] = 162,
  [174] = 121,
  [175] = 166,
  [176] = 119,
  [177] = 177,
  [178] = 178,
  [179] = 177,
  [180] = 178,
  [181] = 181,
  [182] = 182,
  [183] = 181,
  [184] = 182,
  [185] = 185,
  [186] = 186,
  [187] = 185,
  [188] = 186,
  [189] = 42,
  [190] = 42,
  [191] = 191,
  [192] = 191,
  [193] = 193,
  [194] = 193,
  [195] = 3,
  [196] = 196,
  [197] = 3,
  [198] = 3,
  [199] = 3,
  [200] = 200,
  [201] = 3,
  [202] = 3,
  [203] = 196,
  [204] = 200,
  [205] = 205,
  [206] = 3,
  [207] = 3,
  [208] = 3,
  [209] = 3,
  [210] = 205,
  [211] = 205,
  [212] = 3,
  [213] = 205,
  [214] = 3,
  [215] = 205,
  [216] = 205,
  [217] = 205,
  [218] = 205,
  [219] = 3,
  [220] = 3,
  [221] = 3,
  [222] = 3,
  [223] = 205,
  [224] = 205,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 226,
  [229] = 227,
  [230] = 226,
  [231] = 227,
  [232] = 227,
  [233] = 225,
  [234] = 225,
  [235] = 226,
  [236] = 225,
  [237] = 237,
  [238] = 238,
  [239] = 238,
  [240] = 237,
  [241] = 241,
  [242] = 242,
  [243] = 238,
  [244] = 237,
  [245] = 241,
  [246] = 241,
  [247] = 242,
  [248] = 238,
  [249] = 241,
  [250] = 242,
  [251] = 237,
  [252] = 242,
  [253] = 253,
  [254] = 254,
  [255] = 253,
  [256] = 256,
  [257] = 256,
  [258] = 256,
  [259] = 253,
  [260] = 253,
  [261] = 256,
  [262] = 262,
  [263] = 263,
  [264] = 262,
  [265] = 265,
  [266] = 263,
  [267] = 267,
  [268] = 268,
  [269] = 263,
  [270] = 265,
  [271] = 263,
  [272] = 267,
  [273] = 263,
  [274] = 262,
  [275] = 267,
  [276] = 268,
  [277] = 265,
  [278] = 268,
  [279] = 263,
  [280] = 263,
  [281] = 265,
  [282] = 262,
  [283] = 268,
  [284] = 284,
  [285] = 263,
  [286] = 267,
  [287] = 135,
  [288] = 135,
  [289] = 135,
  [290] = 135,
  [291] = 291,
  [292] = 291,
  [293] = 293,
  [294] = 42,
  [295] = 295,
  [296] = 42,
  [297] = 297,
  [298] = 298,
  [299] = 166,
  [300] = 42,
  [301] = 178,
  [302] = 177,
  [303] = 168,
  [304] = 166,
  [305] = 298,
  [306] = 306,
  [307] = 42,
  [308] = 166,
  [309] = 306,
  [310] = 293,
  [311] = 168,
  [312] = 168,
  [313] = 295,
  [314] = 314,
  [315] = 314,
  [316] = 181,
  [317] = 314,
  [318] = 318,
  [319] = 182,
  [320] = 306,
  [321] = 321,
  [322] = 298,
  [323] = 177,
  [324] = 324,
  [325] = 325,
  [326] = 326,
  [327] = 327,
  [328] = 314,
  [329] = 314,
  [330] = 177,
  [331] = 331,
  [332] = 332,
  [333] = 298,
  [334] = 178,
  [335] = 321,
  [336] = 306,
  [337] = 314,
  [338] = 314,
  [339] = 314,
  [340] = 340,
  [341] = 314,
  [342] = 314,
  [343] = 314,
  [344] = 314,
  [345] = 178,
  [346] = 181,
  [347] = 185,
  [348] = 348,
  [349] = 349,
  [350] = 332,
  [351] = 351,
  [352] = 349,
  [353] = 353,
  [354] = 349,
  [355] = 182,
  [356] = 349,
  [357] = 349,
  [358] = 324,
  [359] = 321,
  [360] = 360,
  [361] = 349,
  [362] = 349,
  [363] = 349,
  [364] = 182,
  [365] = 186,
  [366] = 366,
  [367] = 327,
  [368] = 368,
  [369] = 321,
  [370] = 181,
  [371] = 318,
  [372] = 372,
  [373] = 373,
  [374] = 374,
  [375] = 375,
  [376] = 376,
  [377] = 377,
  [378] = 374,
  [379] = 373,
  [380] = 380,
  [381] = 381,
  [382] = 185,
  [383] = 383,
  [384] = 384,
  [385] = 385,
  [386] = 386,
  [387] = 186,
  [388] = 185,
  [389] = 186,
  [390] = 390,
  [391] = 391,
  [392] = 381,
  [393] = 373,
  [394] = 374,
  [395] = 374,
  [396] = 306,
  [397] = 383,
  [398] = 398,
  [399] = 298,
  [400] = 373,
  [401] = 376,
  [402] = 402,
  [403] = 298,
  [404] = 306,
  [405] = 385,
  [406] = 42,
  [407] = 398,
  [408] = 42,
  [409] = 398,
  [410] = 384,
  [411] = 398,
  [412] = 398,
  [413] = 413,
  [414] = 414,
  [415] = 415,
  [416] = 415,
  [417] = 415,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 414,
  [422] = 415,
  [423] = 423,
  [424] = 424,
  [425] = 425,
  [426] = 414,
  [427] = 427,
  [428] = 428,
  [429] = 429,
  [430] = 430,
  [431] = 373,
  [432] = 432,
  [433] = 433,
  [434] = 434,
  [435] = 435,
  [436] = 436,
  [437] = 437,
  [438] = 438,
  [439] = 439,
  [440] = 440,
  [441] = 441,
  [442] = 442,
  [443] = 443,
  [444] = 414,
  [445] = 445,
  [446] = 446,
  [447] = 447,
  [448] = 448,
  [449] = 415,
  [450] = 450,
  [451] = 451,
  [452] = 374,
  [453] = 453,
  [454] = 415,
  [455] = 455,
  [456] = 456,
  [457] = 457,
  [458] = 458,
  [459] = 459,
  [460] = 414,
  [461] = 461,
  [462] = 462,
  [463] = 463,
  [464] = 464,
  [465] = 415,
  [466] = 466,
  [467] = 467,
  [468] = 468,
  [469] = 469,
  [470] = 470,
  [471] = 471,
  [472] = 472,
  [473] = 415,
  [474] = 474,
  [475] = 475,
  [476] = 476,
  [477] = 477,
  [478] = 420,
  [479] = 467,
  [480] = 468,
  [481] = 466,
  [482] = 463,
  [483] = 483,
  [484] = 433,
  [485] = 461,
  [486] = 469,
  [487] = 321,
  [488] = 445,
  [489] = 462,
  [490] = 193,
  [491] = 443,
  [492] = 442,
  [493] = 453,
  [494] = 440,
  [495] = 450,
  [496] = 436,
  [497] = 437,
  [498] = 476,
  [499] = 439,
  [500] = 374,
  [501] = 438,
  [502] = 483,
  [503] = 503,
  [504] = 441,
  [505] = 483,
  [506] = 471,
  [507] = 446,
  [508] = 435,
  [509] = 434,
  [510] = 432,
  [511] = 429,
  [512] = 447,
  [513] = 427,
  [514] = 451,
  [515] = 477,
  [516] = 321,
  [517] = 455,
  [518] = 470,
  [519] = 459,
  [520] = 483,
  [521] = 425,
  [522] = 522,
  [523] = 456,
  [524] = 472,
  [525] = 483,
  [526] = 448,
  [527] = 424,
  [528] = 458,
  [529] = 457,
  [530] = 464,
  [531] = 373,
  [532] = 423,
  [533] = 419,
  [534] = 418,
  [535] = 191,
  [536] = 413,
  [537] = 475,
  [538] = 538,
  [539] = 325,
  [540] = 196,
  [541] = 3,
  [542] = 193,
  [543] = 3,
  [544] = 544,
  [545] = 544,
  [546] = 191,
  [547] = 331,
  [548] = 544,
  [549] = 3,
  [550] = 340,
  [551] = 544,
  [552] = 552,
  [553] = 193,
  [554] = 191,
  [555] = 200,
  [556] = 3,
  [557] = 544,
  [558] = 558,
  [559] = 196,
  [560] = 558,
  [561] = 558,
  [562] = 562,
  [563] = 200,
  [564] = 196,
  [565] = 200,
  [566] = 566,
  [567] = 558,
  [568] = 558,
  [569] = 569,
  [570] = 569,
  [571] = 569,
  [572] = 569,
  [573] = 573,
  [574] = 569,
  [575] = 575,
  [576] = 576,
  [577] = 577,
  [578] = 577,
  [579] = 577,
  [580] = 577,
  [581] = 577,
  [582] = 582,
  [583] = 583,
  [584] = 584,
  [585] = 585,
  [586] = 586,
  [587] = 587,
  [588] = 588,
  [589] = 587,
  [590] = 588,
  [591] = 585,
  [592] = 587,
  [593] = 588,
  [594] = 585,
  [595] = 585,
  [596] = 587,
  [597] = 588,
  [598] = 587,
  [599] = 585,
  [600] = 588,
  [601] = 585,
  [602] = 588,
  [603] = 587,
  [604] = 586,
  [605] = 588,
  [606] = 585,
  [607] = 587,
  [608] = 586,
  [609] = 588,
  [610] = 587,
  [611] = 585,
  [612] = 588,
  [613] = 586,
  [614] = 586,
  [615] = 585,
  [616] = 587,
  [617] = 588,
  [618] = 618,
  [619] = 588,
  [620] = 587,
  [621] = 587,
  [622] = 586,
  [623] = 587,
  [624] = 587,
  [625] = 585,
  [626] = 588,
  [627] = 587,
  [628] = 585,
  [629] = 585,
  [630] = 586,
  [631] = 586,
  [632] = 585,
  [633] = 588,
  [634] = 585,
  [635] = 588,
  [636] = 586,
  [637] = 587,
  [638] = 588,
  [639] = 586,
  [640] = 588,
  [641] = 587,
  [642] = 588,
  [643] = 586,
  [644] = 588,
  [645] = 587,
  [646] = 587,
  [647] = 585,
  [648] = 585,
  [649] = 586,
  [650] = 585,
  [651] = 588,
  [652] = 587,
  [653] = 585,
  [654] = 588,
  [655] = 587,
  [656] = 587,
  [657] = 585,
  [658] = 588,
  [659] = 588,
  [660] = 587,
  [661] = 585,
  [662] = 588,
  [663] = 585,
  [664] = 587,
  [665] = 587,
  [666] = 588,
  [667] = 585,
  [668] = 588,
  [669] = 587,
  [670] = 585,
  [671] = 588,
  [672] = 587,
  [673] = 586,
  [674] = 585,
  [675] = 585,
  [676] = 587,
  [677] = 585,
  [678] = 585,
  [679] = 586,
  [680] = 588,
  [681] = 587,
  [682] = 585,
  [683] = 588,
  [684] = 684,
  [685] = 684,
  [686] = 684,
  [687] = 684,
  [688] = 684,
  [689] = 684,
  [690] = 684,
  [691] = 684,
  [692] = 684,
  [693] = 684,
  [694] = 684,
  [695] = 684,
  [696] = 684,
  [697] = 684,
  [698] = 684,
  [699] = 684,
  [700] = 684,
  [701] = 684,
  [702] = 684,
  [703] = 684,
  [704] = 684,
  [705] = 684,
  [706] = 684,
  [707] = 684,
  [708] = 85,
  [709] = 709,
  [710] = 85,
  [711] = 709,
  [712] = 712,
  [713] = 709,
  [714] = 714,
  [715] = 85,
  [716] = 709,
  [717] = 85,
  [718] = 718,
  [719] = 718,
  [720] = 718,
  [721] = 721,
  [722] = 718,
  [723] = 723,
  [724] = 723,
  [725] = 721,
  [726] = 723,
  [727] = 721,
  [728] = 723,
  [729] = 721,
  [730] = 721,
  [731] = 721,
  [732] = 732,
  [733] = 733,
  [734] = 42,
  [735] = 735,
  [736] = 736,
  [737] = 736,
  [738] = 735,
  [739] = 739,
  [740] = 740,
  [741] = 736,
  [742] = 735,
  [743] = 740,
  [744] = 736,
  [745] = 83,
  [746] = 83,
  [747] = 83,
  [748] = 83,
  [749] = 735,
  [750] = 739,
  [751] = 97,
  [752] = 104,
  [753] = 101,
  [754] = 95,
  [755] = 98,
  [756] = 114,
  [757] = 105,
  [758] = 109,
  [759] = 103,
  [760] = 113,
  [761] = 740,
  [762] = 104,
  [763] = 99,
  [764] = 120,
  [765] = 91,
  [766] = 92,
  [767] = 88,
  [768] = 135,
  [769] = 84,
  [770] = 93,
  [771] = 110,
  [772] = 111,
  [773] = 109,
  [774] = 86,
  [775] = 102,
  [776] = 108,
  [777] = 777,
  [778] = 89,
  [779] = 115,
  [780] = 118,
  [781] = 119,
  [782] = 121,
  [783] = 90,
  [784] = 739,
  [785] = 112,
  [786] = 116,
  [787] = 83,
  [788] = 85,
  [789] = 117,
  [790] = 118,
  [791] = 119,
  [792] = 121,
  [793] = 90,
  [794] = 112,
  [795] = 111,
  [796] = 110,
  [797] = 102,
  [798] = 89,
  [799] = 85,
  [800] = 135,
  [801] = 88,
  [802] = 92,
  [803] = 116,
  [804] = 115,
  [805] = 91,
  [806] = 777,
  [807] = 739,
  [808] = 83,
  [809] = 86,
  [810] = 108,
  [811] = 106,
  [812] = 106,
  [813] = 101,
  [814] = 85,
  [815] = 117,
  [816] = 95,
  [817] = 740,
  [818] = 85,
  [819] = 819,
  [820] = 105,
  [821] = 97,
  [822] = 83,
  [823] = 98,
  [824] = 114,
  [825] = 825,
  [826] = 103,
  [827] = 825,
  [828] = 84,
  [829] = 99,
  [830] = 113,
  [831] = 93,
  [832] = 83,
  [833] = 120,
  [834] = 89,
  [835] = 114,
  [836] = 109,
  [837] = 84,
  [838] = 93,
  [839] = 825,
  [840] = 88,
  [841] = 103,
  [842] = 92,
  [843] = 86,
  [844] = 91,
  [845] = 825,
  [846] = 110,
  [847] = 111,
  [848] = 848,
  [849] = 777,
  [850] = 110,
  [851] = 113,
  [852] = 86,
  [853] = 114,
  [854] = 120,
  [855] = 99,
  [856] = 97,
  [857] = 98,
  [858] = 135,
  [859] = 105,
  [860] = 95,
  [861] = 88,
  [862] = 104,
  [863] = 85,
  [864] = 116,
  [865] = 865,
  [866] = 84,
  [867] = 92,
  [868] = 868,
  [869] = 85,
  [870] = 85,
  [871] = 85,
  [872] = 115,
  [873] = 91,
  [874] = 112,
  [875] = 90,
  [876] = 121,
  [877] = 119,
  [878] = 118,
  [879] = 113,
  [880] = 104,
  [881] = 117,
  [882] = 103,
  [883] = 777,
  [884] = 105,
  [885] = 112,
  [886] = 90,
  [887] = 121,
  [888] = 119,
  [889] = 118,
  [890] = 117,
  [891] = 109,
  [892] = 135,
  [893] = 101,
  [894] = 106,
  [895] = 97,
  [896] = 865,
  [897] = 89,
  [898] = 102,
  [899] = 116,
  [900] = 99,
  [901] = 868,
  [902] = 120,
  [903] = 111,
  [904] = 98,
  [905] = 108,
  [906] = 135,
  [907] = 93,
  [908] = 95,
  [909] = 101,
  [910] = 106,
  [911] = 108,
  [912] = 115,
  [913] = 135,
  [914] = 102,
  [915] = 848,
  [916] = 916,
  [917] = 917,
  [918] = 83,
  [919] = 42,
  [920] = 42,
  [921] = 917,
  [922] = 135,
  [923] = 916,
  [924] = 135,
  [925] = 83,
  [926] = 926,
  [927] = 115,
  [928] = 916,
  [929] = 42,
  [930] = 110,
  [931] = 89,
  [932] = 111,
  [933] = 118,
  [934] = 109,
  [935] = 935,
  [936] = 97,
  [937] = 104,
  [938] = 42,
  [939] = 113,
  [940] = 103,
  [941] = 916,
  [942] = 86,
  [943] = 105,
  [944] = 112,
  [945] = 945,
  [946] = 91,
  [947] = 935,
  [948] = 116,
  [949] = 102,
  [950] = 88,
  [951] = 99,
  [952] = 117,
  [953] = 84,
  [954] = 926,
  [955] = 114,
  [956] = 98,
  [957] = 90,
  [958] = 120,
  [959] = 85,
  [960] = 121,
  [961] = 119,
  [962] = 917,
  [963] = 95,
  [964] = 101,
  [965] = 945,
  [966] = 106,
  [967] = 108,
  [968] = 93,
  [969] = 92,
  [970] = 917,
  [971] = 926,
  [972] = 972,
  [973] = 973,
  [974] = 973,
  [975] = 83,
  [976] = 926,
  [977] = 977,
  [978] = 978,
  [979] = 83,
  [980] = 978,
  [981] = 935,
  [982] = 935,
  [983] = 977,
  [984] = 945,
  [985] = 945,
  [986] = 972,
  [987] = 135,
  [988] = 98,
  [989] = 89,
  [990] = 973,
  [991] = 977,
  [992] = 95,
  [993] = 101,
  [994] = 97,
  [995] = 106,
  [996] = 108,
  [997] = 111,
  [998] = 42,
  [999] = 119,
  [1000] = 121,
  [1001] = 972,
  [1002] = 99,
  [1003] = 120,
  [1004] = 103,
  [1005] = 110,
  [1006] = 93,
  [1007] = 102,
  [1008] = 86,
  [1009] = 973,
  [1010] = 105,
  [1011] = 84,
  [1012] = 112,
  [1013] = 115,
  [1014] = 116,
  [1015] = 972,
  [1016] = 135,
  [1017] = 117,
  [1018] = 977,
  [1019] = 109,
  [1020] = 113,
  [1021] = 114,
  [1022] = 88,
  [1023] = 92,
  [1024] = 91,
  [1025] = 118,
  [1026] = 90,
  [1027] = 104,
  [1028] = 85,
  [1029] = 135,
  [1030] = 162,
  [1031] = 112,
  [1032] = 164,
  [1033] = 1033,
  [1034] = 1034,
  [1035] = 118,
  [1036] = 119,
  [1037] = 1034,
  [1038] = 164,
  [1039] = 162,
  [1040] = 119,
  [1041] = 117,
  [1042] = 112,
  [1043] = 121,
  [1044] = 90,
  [1045] = 121,
  [1046] = 90,
  [1047] = 118,
  [1048] = 135,
  [1049] = 117,
  [1050] = 1033,
  [1051] = 164,
  [1052] = 119,
  [1053] = 1033,
  [1054] = 112,
  [1055] = 917,
  [1056] = 112,
  [1057] = 917,
  [1058] = 1058,
  [1059] = 118,
  [1060] = 1058,
  [1061] = 1034,
  [1062] = 1034,
  [1063] = 1033,
  [1064] = 162,
  [1065] = 121,
  [1066] = 1034,
  [1067] = 90,
  [1068] = 117,
  [1069] = 121,
  [1070] = 42,
  [1071] = 119,
  [1072] = 1034,
  [1073] = 118,
  [1074] = 164,
  [1075] = 162,
  [1076] = 117,
  [1077] = 90,
  [1078] = 1078,
  [1079] = 89,
  [1080] = 102,
  [1081] = 1078,
  [1082] = 1082,
  [1083] = 1058,
  [1084] = 1058,
  [1085] = 1085,
  [1086] = 1086,
  [1087] = 1087,
  [1088] = 1086,
  [1089] = 1089,
  [1090] = 1085,
  [1091] = 1091,
  [1092] = 1034,
  [1093] = 1089,
  [1094] = 42,
  [1095] = 1034,
  [1096] = 1082,
  [1097] = 326,
  [1098] = 89,
  [1099] = 1099,
  [1100] = 102,
  [1101] = 1091,
  [1102] = 89,
  [1103] = 1089,
  [1104] = 1104,
  [1105] = 1082,
  [1106] = 1106,
  [1107] = 102,
  [1108] = 1091,
  [1109] = 1091,
  [1110] = 1086,
  [1111] = 1106,
  [1112] = 1078,
  [1113] = 1082,
  [1114] = 1089,
  [1115] = 1078,
  [1116] = 1086,
  [1117] = 89,
  [1118] = 1085,
  [1119] = 1104,
  [1120] = 102,
  [1121] = 1085,
  [1122] = 1034,
  [1123] = 1123,
  [1124] = 1034,
  [1125] = 1089,
  [1126] = 1058,
  [1127] = 1082,
  [1128] = 1078,
  [1129] = 1058,
  [1130] = 1082,
  [1131] = 1078,
  [1132] = 1089,
  [1133] = 1086,
  [1134] = 1086,
  [1135] = 1135,
  [1136] = 326,
  [1137] = 1137,
  [1138] = 1138,
  [1139] = 1139,
  [1140] = 1140,
  [1141] = 1141,
  [1142] = 1141,
  [1143] = 1140,
  [1144] = 1144,
  [1145] = 1145,
  [1146] = 1144,
  [1147] = 1147,
  [1148] = 1147,
  [1149] = 1145,
  [1150] = 1150,
  [1151] = 1147,
  [1152] = 1150,
  [1153] = 1150,
  [1154] = 1140,
  [1155] = 1144,
  [1156] = 1156,
  [1157] = 1150,
  [1158] = 1147,
  [1159] = 1145,
  [1160] = 1144,
  [1161] = 1141,
  [1162] = 1145,
  [1163] = 1140,
  [1164] = 1141,
  [1165] = 1165,
  [1166] = 1165,
  [1167] = 1165,
  [1168] = 1165,
  [1169] = 1165,
  [1170] = 1170,
  [1171] = 1171,
  [1172] = 1172,
  [1173] = 1172,
  [1174] = 1172,
  [1175] = 1171,
  [1176] = 1170,
  [1177] = 1172,
  [1178] = 1170,
  [1179] = 1171,
  [1180] = 1172,
  [1181] = 1170,
  [1182] = 1171,
  [1183] = 1170,
  [1184] = 1170,
  [1185] = 1170,
  [1186] = 1172,
  [1187] = 1171,
  [1188] = 1172,
  [1189] = 1172,
  [1190] = 1170,
  [1191] = 1191,
  [1192] = 1192,
  [1193] = 1193,
  [1194] = 1193,
  [1195] = 1191,
  [1196] = 1193,
  [1197] = 1191,
  [1198] = 1191,
  [1199] = 1191,
  [1200] = 1191,
  [1201] = 1191,
  [1202] = 1191,
  [1203] = 1203,
  [1204] = 1204,
  [1205] = 1193,
  [1206] = 1193,
  [1207] = 1193,
  [1208] = 1193,
  [1209] = 1193,
  [1210] = 1210,
  [1211] = 1211,
  [1212] = 1211,
  [1213] = 1213,
  [1214] = 1211,
  [1215] = 85,
  [1216] = 709,
  [1217] = 1210,
  [1218] = 1210,
  [1219] = 1219,
  [1220] = 1220,
  [1221] = 1221,
  [1222] = 1222,
  [1223] = 109,
  [1224] = 85,
  [1225] = 1225,
  [1226] = 85,
  [1227] = 93,
  [1228] = 1228,
  [1229] = 109,
  [1230] = 326,
  [1231] = 1231,
  [1232] = 109,
  [1233] = 93,
  [1234] = 93,
  [1235] = 85,
  [1236] = 1236,
  [1237] = 1237,
  [1238] = 1238,
  [1239] = 1239,
  [1240] = 1240,
  [1241] = 1241,
  [1242] = 374,
  [1243] = 1243,
  [1244] = 1244,
  [1245] = 1245,
  [1246] = 736,
  [1247] = 1247,
  [1248] = 735,
  [1249] = 1249,
  [1250] = 1250,
  [1251] = 373,
  [1252] = 1252,
  [1253] = 1253,
  [1254] = 1254,
  [1255] = 1254,
  [1256] = 1256,
  [1257] = 1256,
  [1258] = 1258,
  [1259] = 1254,
  [1260] = 1256,
  [1261] = 1261,
  [1262] = 1254,
  [1263] = 1256,
  [1264] = 1264,
  [1265] = 1265,
  [1266] = 85,
  [1267] = 135,
  [1268] = 1261,
  [1269] = 1258,
  [1270] = 1270,
  [1271] = 1271,
  [1272] = 1271,
  [1273] = 1273,
  [1274] = 1274,
  [1275] = 1275,
  [1276] = 1276,
  [1277] = 1277,
  [1278] = 1278,
  [1279] = 916,
  [1280] = 1278,
  [1281] = 135,
  [1282] = 1277,
  [1283] = 1278,
  [1284] = 1278,
  [1285] = 1277,
  [1286] = 868,
  [1287] = 1287,
  [1288] = 848,
  [1289] = 1289,
  [1290] = 1277,
  [1291] = 1291,
  [1292] = 1292,
  [1293] = 848,
  [1294] = 926,
  [1295] = 135,
  [1296] = 135,
  [1297] = 935,
  [1298] = 945,
  [1299] = 868,
  [1300] = 868,
  [1301] = 1301,
  [1302] = 295,
  [1303] = 293,
  [1304] = 848,
  [1305] = 1305,
  [1306] = 1306,
  [1307] = 1307,
  [1308] = 293,
  [1309] = 295,
  [1310] = 1301,
  [1311] = 1311,
  [1312] = 972,
  [1313] = 1311,
  [1314] = 1314,
  [1315] = 1315,
  [1316] = 1316,
  [1317] = 1317,
  [1318] = 1317,
  [1319] = 1315,
  [1320] = 1314,
  [1321] = 1317,
  [1322] = 1322,
  [1323] = 977,
  [1324] = 973,
  [1325] = 1322,
  [1326] = 1326,
  [1327] = 1326,
  [1328] = 1326,
  [1329] = 1329,
  [1330] = 1330,
  [1331] = 1331,
  [1332] = 1332,
  [1333] = 1326,
  [1334] = 1311,
  [1335] = 1326,
  [1336] = 1336,
  [1337] = 327,
  [1338] = 1326,
  [1339] = 1326,
  [1340] = 1314,
  [1341] = 1329,
  [1342] = 373,
  [1343] = 1336,
  [1344] = 1344,
  [1345] = 1329,
  [1346] = 1326,
  [1347] = 1326,
  [1348] = 1326,
  [1349] = 1349,
  [1350] = 1350,
  [1351] = 318,
  [1352] = 1326,
  [1353] = 327,
  [1354] = 1354,
  [1355] = 1329,
  [1356] = 1326,
  [1357] = 1357,
  [1358] = 1326,
  [1359] = 324,
  [1360] = 978,
  [1361] = 1326,
  [1362] = 324,
  [1363] = 1326,
  [1364] = 332,
  [1365] = 1326,
  [1366] = 318,
  [1367] = 332,
  [1368] = 1326,
  [1369] = 1326,
  [1370] = 374,
  [1371] = 1314,
  [1372] = 1311,
  [1373] = 1373,
  [1374] = 1374,
  [1375] = 1375,
  [1376] = 1376,
  [1377] = 1377,
  [1378] = 1376,
  [1379] = 86,
  [1380] = 84,
  [1381] = 1381,
  [1382] = 1382,
  [1383] = 1374,
  [1384] = 1384,
  [1385] = 86,
  [1386] = 1373,
  [1387] = 1374,
  [1388] = 1388,
  [1389] = 1377,
  [1390] = 1390,
  [1391] = 1391,
  [1392] = 1374,
  [1393] = 1377,
  [1394] = 1373,
  [1395] = 1377,
  [1396] = 978,
  [1397] = 1384,
  [1398] = 978,
  [1399] = 84,
  [1400] = 1376,
  [1401] = 1373,
  [1402] = 1376,
  [1403] = 1403,
  [1404] = 1404,
  [1405] = 1405,
  [1406] = 1406,
  [1407] = 1407,
  [1408] = 1408,
  [1409] = 1409,
  [1410] = 1410,
  [1411] = 1411,
  [1412] = 1412,
  [1413] = 385,
  [1414] = 1414,
  [1415] = 1404,
  [1416] = 1412,
  [1417] = 1417,
  [1418] = 1418,
  [1419] = 1419,
  [1420] = 376,
  [1421] = 1421,
  [1422] = 1403,
  [1423] = 1421,
  [1424] = 1407,
  [1425] = 384,
  [1426] = 1410,
  [1427] = 1419,
  [1428] = 384,
  [1429] = 381,
  [1430] = 1405,
  [1431] = 1431,
  [1432] = 1432,
  [1433] = 1433,
  [1434] = 376,
  [1435] = 383,
  [1436] = 1432,
  [1437] = 1431,
  [1438] = 1403,
  [1439] = 1431,
  [1440] = 1440,
  [1441] = 1412,
  [1442] = 1442,
  [1443] = 1443,
  [1444] = 1405,
  [1445] = 1445,
  [1446] = 1417,
  [1447] = 1405,
  [1448] = 1421,
  [1449] = 385,
  [1450] = 1450,
  [1451] = 1451,
  [1452] = 1452,
  [1453] = 1453,
  [1454] = 1451,
  [1455] = 1455,
  [1456] = 1411,
  [1457] = 1455,
  [1458] = 1458,
  [1459] = 1459,
  [1460] = 1409,
  [1461] = 1461,
  [1462] = 1405,
  [1463] = 1463,
  [1464] = 1464,
  [1465] = 1465,
  [1466] = 1466,
  [1467] = 1451,
  [1468] = 1411,
  [1469] = 1459,
  [1470] = 1409,
  [1471] = 1455,
  [1472] = 381,
  [1473] = 1473,
  [1474] = 1406,
  [1475] = 1475,
  [1476] = 1476,
  [1477] = 1405,
  [1478] = 1411,
  [1479] = 1479,
  [1480] = 1431,
  [1481] = 1418,
  [1482] = 1482,
  [1483] = 1421,
  [1484] = 1484,
  [1485] = 1485,
  [1486] = 1486,
  [1487] = 1451,
  [1488] = 383,
  [1489] = 1404,
  [1490] = 1490,
  [1491] = 1491,
  [1492] = 1418,
  [1493] = 1455,
  [1494] = 1494,
  [1495] = 1445,
  [1496] = 1410,
  [1497] = 1404,
  [1498] = 1459,
  [1499] = 1418,
  [1500] = 1403,
  [1501] = 1501,
  [1502] = 1502,
  [1503] = 1431,
  [1504] = 1405,
  [1505] = 1431,
  [1506] = 1431,
  [1507] = 1459,
  [1508] = 1508,
  [1509] = 1405,
  [1510] = 1409,
  [1511] = 1421,
  [1512] = 1412,
  [1513] = 1513,
  [1514] = 1410,
  [1515] = 1515,
  [1516] = 1410,
  [1517] = 1431,
  [1518] = 1408,
  [1519] = 1519,
  [1520] = 1520,
  [1521] = 1521,
  [1522] = 1522,
  [1523] = 1523,
  [1524] = 1091,
  [1525] = 1525,
  [1526] = 1526,
  [1527] = 1523,
  [1528] = 1523,
  [1529] = 1529,
  [1530] = 1529,
  [1531] = 1529,
  [1532] = 1532,
  [1533] = 1521,
  [1534] = 1534,
  [1535] = 1523,
  [1536] = 1534,
  [1537] = 1537,
  [1538] = 1538,
  [1539] = 1539,
  [1540] = 1534,
  [1541] = 1541,
  [1542] = 1542,
  [1543] = 1543,
  [1544] = 1544,
  [1545] = 1545,
  [1546] = 1546,
  [1547] = 1545,
  [1548] = 1548,
  [1549] = 1549,
  [1550] = 1542,
  [1551] = 1541,
  [1552] = 1552,
  [1553] = 1538,
  [1554] = 1554,
  [1555] = 1555,
  [1556] = 1534,
  [1557] = 1522,
  [1558] = 1558,
  [1559] = 1559,
  [1560] = 1560,
  [1561] = 1561,
  [1562] = 1525,
  [1563] = 1563,
  [1564] = 1564,
  [1565] = 1565,
  [1566] = 1566,
  [1567] = 1529,
  [1568] = 1568,
  [1569] = 1569,
  [1570] = 1570,
  [1571] = 1571,
  [1572] = 1572,
  [1573] = 1573,
  [1574] = 1574,
  [1575] = 1520,
  [1576] = 1576,
  [1577] = 1577,
  [1578] = 1578,
  [1579] = 1548,
  [1580] = 1580,
  [1581] = 1581,
  [1582] = 1582,
  [1583] = 1583,
  [1584] = 1584,
  [1585] = 1585,
  [1586] = 1526,
  [1587] = 1564,
  [1588] = 1558,
  [1589] = 1589,
  [1590] = 1566,
  [1591] = 1566,
  [1592] = 1548,
  [1593] = 1555,
  [1594] = 1521,
  [1595] = 1595,
  [1596] = 1585,
  [1597] = 1554,
  [1598] = 1565,
  [1599] = 1566,
  [1600] = 1584,
  [1601] = 1601,
  [1602] = 1583,
  [1603] = 1582,
  [1604] = 1581,
  [1605] = 1552,
  [1606] = 1548,
  [1607] = 1570,
  [1608] = 1580,
  [1609] = 1609,
  [1610] = 1610,
  [1611] = 1611,
  [1612] = 1578,
  [1613] = 1613,
  [1614] = 1537,
  [1615] = 1615,
  [1616] = 1577,
  [1617] = 1585,
  [1618] = 1545,
  [1619] = 1542,
  [1620] = 1541,
  [1621] = 1538,
  [1622] = 1576,
  [1623] = 1584,
  [1624] = 1583,
  [1625] = 1582,
  [1626] = 1581,
  [1627] = 1521,
  [1628] = 1580,
  [1629] = 1578,
  [1630] = 1577,
  [1631] = 1576,
  [1632] = 1539,
  [1633] = 1520,
  [1634] = 1525,
  [1635] = 1572,
  [1636] = 1526,
  [1637] = 1571,
  [1638] = 1570,
  [1639] = 1639,
  [1640] = 1640,
  [1641] = 1521,
  [1642] = 1569,
  [1643] = 1521,
  [1644] = 1644,
  [1645] = 1545,
  [1646] = 1537,
  [1647] = 1542,
  [1648] = 1539,
  [1649] = 1541,
  [1650] = 1521,
  [1651] = 1565,
  [1652] = 1543,
  [1653] = 1544,
  [1654] = 1564,
  [1655] = 1538,
  [1656] = 1656,
  [1657] = 1543,
  [1658] = 1558,
  [1659] = 1544,
  [1660] = 1552,
  [1661] = 1522,
  [1662] = 1554,
  [1663] = 1555,
  [1664] = 1525,
  [1665] = 1665,
  [1666] = 1558,
  [1667] = 1526,
  [1668] = 1555,
  [1669] = 1554,
  [1670] = 1571,
  [1671] = 1564,
  [1672] = 1565,
  [1673] = 1539,
  [1674] = 1572,
  [1675] = 1563,
  [1676] = 1569,
  [1677] = 1570,
  [1678] = 1571,
  [1679] = 1572,
  [1680] = 1552,
  [1681] = 1681,
  [1682] = 1520,
  [1683] = 1576,
  [1684] = 1577,
  [1685] = 1578,
  [1686] = 1537,
  [1687] = 1580,
  [1688] = 1581,
  [1689] = 1582,
  [1690] = 1583,
  [1691] = 1584,
  [1692] = 1585,
  [1693] = 1693,
  [1694] = 1694,
  [1695] = 1569,
  [1696] = 1696,
  [1697] = 1544,
  [1698] = 1521,
  [1699] = 1543,
  [1700] = 1700,
  [1701] = 477,
  [1702] = 1702,
  [1703] = 1703,
  [1704] = 1704,
  [1705] = 1705,
  [1706] = 1706,
  [1707] = 1707,
  [1708] = 1708,
  [1709] = 1709,
  [1710] = 1710,
  [1711] = 1711,
  [1712] = 1712,
  [1713] = 1713,
  [1714] = 1714,
  [1715] = 1715,
  [1716] = 1716,
  [1717] = 1717,
  [1718] = 1718,
  [1719] = 1708,
  [1720] = 1720,
  [1721] = 1721,
  [1722] = 1722,
  [1723] = 1723,
  [1724] = 1723,
  [1725] = 1714,
  [1726] = 1711,
  [1727] = 1722,
  [1728] = 1721,
  [1729] = 1729,
  [1730] = 1706,
  [1731] = 1731,
  [1732] = 1732,
  [1733] = 1733,
  [1734] = 1734,
  [1735] = 1718,
  [1736] = 1733,
  [1737] = 1704,
  [1738] = 1706,
  [1739] = 1739,
  [1740] = 1740,
  [1741] = 1741,
  [1742] = 1732,
  [1743] = 1718,
  [1744] = 1708,
  [1745] = 1745,
  [1746] = 1721,
  [1747] = 1722,
  [1748] = 1723,
  [1749] = 1749,
  [1750] = 1706,
  [1751] = 1714,
  [1752] = 1711,
  [1753] = 1753,
  [1754] = 1706,
  [1755] = 1732,
  [1756] = 1711,
  [1757] = 1702,
  [1758] = 1734,
  [1759] = 1759,
  [1760] = 1711,
  [1761] = 1714,
  [1762] = 1734,
  [1763] = 1734,
  [1764] = 1734,
  [1765] = 1718,
  [1766] = 1708,
  [1767] = 1767,
  [1768] = 1721,
  [1769] = 1722,
  [1770] = 1723,
  [1771] = 1703,
  [1772] = 1734,
  [1773] = 1714,
  [1774] = 1711,
  [1775] = 1775,
  [1776] = 1706,
  [1777] = 1732,
  [1778] = 1734,
  [1779] = 1723,
  [1780] = 1780,
  [1781] = 1781,
  [1782] = 1782,
  [1783] = 1734,
  [1784] = 1722,
  [1785] = 1721,
  [1786] = 1734,
  [1787] = 1718,
  [1788] = 1708,
  [1789] = 1708,
  [1790] = 1721,
  [1791] = 1722,
  [1792] = 1723,
  [1793] = 1718,
  [1794] = 1739,
  [1795] = 1714,
  [1796] = 1711,
  [1797] = 1705,
  [1798] = 1706,
  [1799] = 1732,
  [1800] = 1800,
  [1801] = 1734,
  [1802] = 1708,
  [1803] = 1721,
  [1804] = 1714,
  [1805] = 1805,
  [1806] = 1732,
  [1807] = 1807,
  [1808] = 1808,
  [1809] = 1708,
  [1810] = 1721,
  [1811] = 1714,
  [1812] = 1812,
  [1813] = 1732,
  [1814] = 1814,
  [1815] = 1734,
  [1816] = 1721,
  [1817] = 1817,
  [1818] = 1732,
  [1819] = 1739,
  [1820] = 1820,
  [1821] = 1732,
  [1822] = 1822,
  [1823] = 1823,
  [1824] = 1824,
  [1825] = 1825,
  [1826] = 1734,
  [1827] = 1827,
  [1828] = 1828,
  [1829] = 1829,
  [1830] = 1723,
  [1831] = 1831,
  [1832] = 1832,
  [1833] = 1703,
  [1834] = 1834,
  [1835] = 1835,
  [1836] = 1836,
  [1837] = 1734,
  [1838] = 1838,
  [1839] = 1839,
  [1840] = 1714,
  [1841] = 1841,
  [1842] = 1842,
  [1843] = 1715,
  [1844] = 1844,
  [1845] = 1734,
  [1846] = 1846,
  [1847] = 1704,
  [1848] = 1848,
  [1849] = 1849,
  [1850] = 1702,
  [1851] = 1851,
  [1852] = 1852,
  [1853] = 1853,
  [1854] = 1854,
  [1855] = 1709,
  [1856] = 1856,
  [1857] = 1780,
  [1858] = 1753,
  [1859] = 1859,
  [1860] = 1822,
  [1861] = 1861,
  [1862] = 434,
  [1863] = 1863,
  [1864] = 1864,
  [1865] = 1807,
  [1866] = 1732,
  [1867] = 1734,
  [1868] = 1868,
  [1869] = 1710,
  [1870] = 1712,
  [1871] = 1871,
  [1872] = 1872,
  [1873] = 448,
  [1874] = 1827,
  [1875] = 1828,
  [1876] = 1831,
  [1877] = 418,
  [1878] = 1861,
  [1879] = 419,
  [1880] = 423,
  [1881] = 424,
  [1882] = 425,
  [1883] = 1853,
  [1884] = 1884,
  [1885] = 427,
  [1886] = 429,
  [1887] = 432,
  [1888] = 423,
  [1889] = 435,
  [1890] = 438,
  [1891] = 439,
  [1892] = 440,
  [1893] = 442,
  [1894] = 443,
  [1895] = 445,
  [1896] = 446,
  [1897] = 447,
  [1898] = 451,
  [1899] = 455,
  [1900] = 456,
  [1901] = 458,
  [1902] = 1829,
  [1903] = 459,
  [1904] = 462,
  [1905] = 469,
  [1906] = 1906,
  [1907] = 413,
  [1908] = 472,
  [1909] = 1732,
  [1910] = 1910,
  [1911] = 476,
  [1912] = 1912,
  [1913] = 1851,
  [1914] = 1914,
  [1915] = 1853,
  [1916] = 1709,
  [1917] = 1917,
  [1918] = 1780,
  [1919] = 1753,
  [1920] = 1920,
  [1921] = 475,
  [1922] = 1722,
  [1923] = 468,
  [1924] = 1807,
  [1925] = 466,
  [1926] = 1721,
  [1927] = 463,
  [1928] = 1710,
  [1929] = 1712,
  [1930] = 1851,
  [1931] = 1931,
  [1932] = 461,
  [1933] = 1827,
  [1934] = 1828,
  [1935] = 1831,
  [1936] = 453,
  [1937] = 1861,
  [1938] = 450,
  [1939] = 441,
  [1940] = 437,
  [1941] = 436,
  [1942] = 433,
  [1943] = 1943,
  [1944] = 1733,
  [1945] = 1945,
  [1946] = 1734,
  [1947] = 1947,
  [1948] = 1948,
  [1949] = 457,
  [1950] = 464,
  [1951] = 1951,
  [1952] = 1952,
  [1953] = 1953,
  [1954] = 467,
  [1955] = 470,
  [1956] = 471,
  [1957] = 1703,
  [1958] = 1851,
  [1959] = 1959,
  [1960] = 1709,
  [1961] = 1713,
  [1962] = 1780,
  [1963] = 1753,
  [1964] = 1702,
  [1965] = 420,
  [1966] = 1745,
  [1967] = 448,
  [1968] = 1807,
  [1969] = 418,
  [1970] = 419,
  [1971] = 435,
  [1972] = 1710,
  [1973] = 1712,
  [1974] = 424,
  [1975] = 425,
  [1976] = 427,
  [1977] = 1827,
  [1978] = 1828,
  [1979] = 1831,
  [1980] = 429,
  [1981] = 1861,
  [1982] = 1982,
  [1983] = 432,
  [1984] = 434,
  [1985] = 1718,
  [1986] = 1986,
  [1987] = 1987,
  [1988] = 1708,
  [1989] = 1989,
  [1990] = 1718,
  [1991] = 420,
  [1992] = 438,
  [1993] = 1993,
  [1994] = 1729,
  [1995] = 439,
  [1996] = 440,
  [1997] = 442,
  [1998] = 443,
  [1999] = 445,
  [2000] = 446,
  [2001] = 447,
  [2002] = 451,
  [2003] = 455,
  [2004] = 2004,
  [2005] = 2005,
  [2006] = 1745,
  [2007] = 2007,
  [2008] = 2008,
  [2009] = 2004,
  [2010] = 1993,
  [2011] = 456,
  [2012] = 325,
  [2013] = 458,
  [2014] = 1782,
  [2015] = 1759,
  [2016] = 1716,
  [2017] = 459,
  [2018] = 1868,
  [2019] = 462,
  [2020] = 1912,
  [2021] = 1717,
  [2022] = 1872,
  [2023] = 1805,
  [2024] = 1812,
  [2025] = 1848,
  [2026] = 469,
  [2027] = 413,
  [2028] = 472,
  [2029] = 477,
  [2030] = 1739,
  [2031] = 2031,
  [2032] = 2032,
  [2033] = 2008,
  [2034] = 2007,
  [2035] = 476,
  [2036] = 475,
  [2037] = 468,
  [2038] = 1733,
  [2039] = 1704,
  [2040] = 466,
  [2041] = 1732,
  [2042] = 1706,
  [2043] = 2043,
  [2044] = 463,
  [2045] = 461,
  [2046] = 2046,
  [2047] = 453,
  [2048] = 2005,
  [2049] = 1711,
  [2050] = 2007,
  [2051] = 2008,
  [2052] = 2004,
  [2053] = 1714,
  [2054] = 2054,
  [2055] = 1782,
  [2056] = 1759,
  [2057] = 1716,
  [2058] = 2005,
  [2059] = 1868,
  [2060] = 450,
  [2061] = 1912,
  [2062] = 1717,
  [2063] = 340,
  [2064] = 1805,
  [2065] = 1812,
  [2066] = 1848,
  [2067] = 2005,
  [2068] = 1715,
  [2069] = 2007,
  [2070] = 2008,
  [2071] = 2071,
  [2072] = 1829,
  [2073] = 1782,
  [2074] = 1759,
  [2075] = 1716,
  [2076] = 441,
  [2077] = 1868,
  [2078] = 437,
  [2079] = 1912,
  [2080] = 1717,
  [2081] = 436,
  [2082] = 1805,
  [2083] = 1812,
  [2084] = 1848,
  [2085] = 2071,
  [2086] = 2054,
  [2087] = 2087,
  [2088] = 1800,
  [2089] = 1734,
  [2090] = 1749,
  [2091] = 1707,
  [2092] = 2071,
  [2093] = 2054,
  [2094] = 1723,
  [2095] = 1800,
  [2096] = 1749,
  [2097] = 1707,
  [2098] = 2071,
  [2099] = 2054,
  [2100] = 1722,
  [2101] = 1800,
  [2102] = 1749,
  [2103] = 1707,
  [2104] = 1721,
  [2105] = 433,
  [2106] = 331,
  [2107] = 2107,
  [2108] = 1734,
  [2109] = 2109,
  [2110] = 1708,
  [2111] = 457,
  [2112] = 464,
  [2113] = 467,
  [2114] = 1917,
  [2115] = 470,
  [2116] = 1917,
  [2117] = 471,
  [2118] = 1917,
};

static TSCharacterRange sym_generic_token_character_set_1[] = {
  {0, 0x08}, {0x0e, 0x1f}, {'!', '!'}, {'#', '#'}, {'%', '&'}, {'*', ','}, {'.', '?'}, {'A', 'Z'},
  {'\\', '_'}, {'a', 'z'}, {'~', 0x10ffff},
};

static TSCharacterRange aux_sym_command_name_token1_character_set_1[] = {
  {0, 0x08}, {0x0e, 0x1f}, {'#', '#'}, {'.', '.'}, {'0', ':'}, {'=', '?'}, {'A', 'Z'}, {'\\', '\\'},
  {'^', '_'}, {'a', 'z'}, {'~', 0x10ffff},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(545);
      ADVANCE_MAP(
        '!', 1620,
        '"', 1539,
        '#', 547,
        '$', 676,
        '%', 1574,
        '&', 1330,
        '\'', 123,
        '(', 1250,
        ')', 1251,
        '*', 1612,
        '+', 1595,
        ',', 1253,
        '-', 1598,
        '.', 1647,
        '/', 1609,
        '0', 569,
        '1', 563,
        '2', 564,
        '3', 565,
        '4', 566,
        '5', 567,
        '6', 568,
        ':', 1570,
        ';', 1247,
        '<', 801,
        '=', 753,
        '>', 759,
        '@', 96,
        '[', 750,
        '\\', 1610,
        ']', 1649,
      );
      if (lookahead == '`') SKIP(530);
      if (lookahead == 'b') ADVANCE(245);
      if (lookahead == 'c') ADVANCE(160);
      if (lookahead == 'd') ADVANCE(163);
      if (lookahead == 'e') ADVANCE(350);
      if (lookahead == 'f') ADVANCE(312);
      if (lookahead == 'h') ADVANCE(313);
      if (lookahead == 'i') ADVANCE(290);
      if (lookahead == 'p') ADVANCE(166);
      if (lookahead == 'r') ADVANCE(274);
      if (lookahead == 's') ADVANCE(246);
      if (lookahead == 't') ADVANCE(309);
      if (lookahead == 'u') ADVANCE(389);
      if (lookahead == 'w') ADVANCE(311);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '|') ADVANCE(1329);
      if (lookahead == '}') ADVANCE(1265);
      if (('7' <= lookahead && lookahead <= '9')) ADVANCE(570);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(537);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(80);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(81);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(680);
      if (lookahead == ' ') ADVANCE(2);
      END_STATE();
    case 3:
      if (lookahead == '\n') ADVANCE(5);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(3);
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(4);
      if (lookahead == '\'') ADVANCE(40);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(5);
      if (lookahead != 0) ADVANCE(7);
      END_STATE();
    case 5:
      if (lookahead == '\n') ADVANCE(4);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(5);
      if (lookahead != 0) ADVANCE(7);
      END_STATE();
    case 6:
      if (lookahead == '\n') ADVANCE(46);
      if (lookahead == '\'') ADVANCE(40);
      if (lookahead != 0) ADVANCE(7);
      END_STATE();
    case 7:
      if (lookahead == '\n') ADVANCE(46);
      if (lookahead != 0) ADVANCE(7);
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(89);
      END_STATE();
    case 9:
      if (lookahead == '\n') SKIP(90);
      END_STATE();
    case 10:
      if (lookahead == '\n') SKIP(94);
      END_STATE();
    case 11:
      if (lookahead == '\n') SKIP(77);
      END_STATE();
    case 12:
      if (lookahead == '\n') SKIP(95);
      END_STATE();
    case 13:
      if (lookahead == '\n') SKIP(14);
      END_STATE();
    case 14:
      ADVANCE_MAP(
        '\n', 1288,
        '!', 1619,
        '"', 624,
        '#', 552,
        '$', 120,
        '%', 1573,
        '&', 1330,
        '\'', 124,
        '(', 1250,
        ')', 1251,
        '+', 1594,
        ',', 1253,
        '-', 1601,
        '.', 748,
        '0', 571,
        ';', 1247,
        '<', 115,
        '@', 96,
        '[', 750,
      );
      if (lookahead == '`') SKIP(13);
      if (lookahead == 'f') ADVANCE(1471);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1349);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(14);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(572);
      if (lookahead != 0 &&
          (lookahead < ' ' || '9' < lookahead) &&
          lookahead != ']' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 15:
      if (lookahead == '\n') SKIP(88);
      END_STATE();
    case 16:
      if (lookahead == '\n') SKIP(78);
      END_STATE();
    case 17:
      if (lookahead == '\n') SKIP(64);
      END_STATE();
    case 18:
      if (lookahead == '\n') SKIP(100);
      END_STATE();
    case 19:
      if (lookahead == '\n') SKIP(60);
      END_STATE();
    case 20:
      if (lookahead == '\n') SKIP(107);
      END_STATE();
    case 21:
      if (lookahead == '\n') SKIP(67);
      END_STATE();
    case 22:
      if (lookahead == '\n') SKIP(73);
      END_STATE();
    case 23:
      if (lookahead == '\n') SKIP(70);
      END_STATE();
    case 24:
      if (lookahead == '\n') SKIP(75);
      END_STATE();
    case 25:
      if (lookahead == '\n') ADVANCE(1342);
      if (lookahead != 0) ADVANCE(1341);
      END_STATE();
    case 26:
      if (lookahead == '\n') ADVANCE(672);
      if (lookahead != 0) ADVANCE(672);
      END_STATE();
    case 27:
      if (lookahead == '\n') ADVANCE(27);
      if (lookahead == '"') ADVANCE(157);
      if (lookahead == '#') ADVANCE(726);
      if (lookahead == '$') ADVANCE(724);
      if (lookahead == '<') ADVANCE(723);
      if (lookahead == '@') ADVANCE(725);
      if (lookahead == '`') ADVANCE(722);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(722);
      if (lookahead != 0) ADVANCE(722);
      END_STATE();
    case 28:
      if (lookahead == '\n') ADVANCE(27);
      if (lookahead == '#') ADVANCE(719);
      if (lookahead == '$') ADVANCE(676);
      if (lookahead == '<') ADVANCE(682);
      if (lookahead == '@') ADVANCE(717);
      if (lookahead == '`') ADVANCE(26);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(681);
      if (lookahead != 0) ADVANCE(721);
      END_STATE();
    case 29:
      if (lookahead == '\n') SKIP(110);
      END_STATE();
    case 30:
      if (lookahead == '\n') SKIP(108);
      END_STATE();
    case 31:
      if (lookahead == '\n') SKIP(118);
      END_STATE();
    case 32:
      if (lookahead == '\n') SKIP(112);
      END_STATE();
    case 33:
      if (lookahead == '\n') SKIP(33);
      if (lookahead == '"') ADVANCE(1241);
      if (lookahead == '#') ADVANCE(549);
      if (lookahead == '&') ADVANCE(1237);
      if (lookahead == '<') ADVANCE(1242);
      if (lookahead == '`') ADVANCE(1246);
      if (lookahead == '|') ADVANCE(1329);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1240);
      if (lookahead != 0) ADVANCE(1246);
      END_STATE();
    case 34:
      if (lookahead == '\n') SKIP(111);
      END_STATE();
    case 35:
      if (lookahead == '\n') SKIP(35);
      if (lookahead == '"') ADVANCE(1241);
      if (lookahead == '#') ADVANCE(549);
      if (lookahead == '&') ADVANCE(1237);
      if (lookahead == ')') ADVANCE(1252);
      if (lookahead == '<') ADVANCE(1242);
      if (lookahead == '`') ADVANCE(1246);
      if (lookahead == '|') ADVANCE(1329);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1239);
      if (lookahead != 0) ADVANCE(1246);
      END_STATE();
    case 36:
      if (lookahead == '\n') SKIP(37);
      END_STATE();
    case 37:
      if (lookahead == '\n') ADVANCE(1289);
      if (lookahead == '#') ADVANCE(557);
      if (lookahead == ')') ADVANCE(1251);
      if (lookahead == ';') ADVANCE(1247);
      if (lookahead == '<') ADVANCE(115);
      if (lookahead == '`') SKIP(36);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(37);
      END_STATE();
    case 38:
      if (lookahead == '\n') SKIP(114);
      END_STATE();
    case 39:
      if (lookahead == '\n') SKIP(113);
      END_STATE();
    case 40:
      if (lookahead == '\n') ADVANCE(6);
      if (lookahead == '@') ADVANCE(733);
      if (lookahead != 0) ADVANCE(7);
      END_STATE();
    case 41:
      if (lookahead == '\n') SKIP(83);
      END_STATE();
    case 42:
      if (lookahead == '\n') SKIP(93);
      END_STATE();
    case 43:
      if (lookahead == '\n') SKIP(56);
      END_STATE();
    case 44:
      if (lookahead == '\n') SKIP(84);
      END_STATE();
    case 45:
      if (lookahead == '\n') SKIP(86);
      END_STATE();
    case 46:
      if (lookahead == '\n') ADVANCE(47);
      if (lookahead == '\'') ADVANCE(156);
      if (lookahead != 0) ADVANCE(7);
      END_STATE();
    case 47:
      if (lookahead == '\n') ADVANCE(47);
      if (lookahead == '\'') ADVANCE(155);
      if (lookahead != 0) ADVANCE(7);
      END_STATE();
    case 48:
      if (lookahead == '\n') SKIP(79);
      END_STATE();
    case 49:
      if (lookahead == '\n') SKIP(66);
      END_STATE();
    case 50:
      if (lookahead == '\n') SKIP(68);
      END_STATE();
    case 51:
      if (lookahead == '\n') SKIP(72);
      END_STATE();
    case 52:
      if (lookahead == '\n') SKIP(76);
      END_STATE();
    case 53:
      if (lookahead == '\n') SKIP(58);
      END_STATE();
    case 54:
      if (lookahead == '\n') SKIP(74);
      END_STATE();
    case 55:
      if (lookahead == '\n') SKIP(91);
      END_STATE();
    case 56:
      ADVANCE_MAP(
        ' ', 1565,
        '!', 1619,
        '"', 624,
        '#', 557,
        '$', 120,
        '\'', 124,
        '(', 1250,
        ')', 1251,
        '*', 145,
        '+', 1594,
        ',', 1253,
        '-', 1602,
        '.', 524,
        '0', 569,
        '1', 563,
        '2', 564,
        '3', 565,
        '4', 566,
        '5', 567,
        '6', 568,
        ':', 1570,
        '<', 801,
        '>', 759,
        '@', 96,
        '[', 750,
      );
      if (lookahead == '`') SKIP(43);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '|') ADVANCE(1329);
      if (('7' <= lookahead && lookahead <= '9')) ADVANCE(570);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(56);
      END_STATE();
    case 57:
      ADVANCE_MAP(
        ' ', 1565,
        '!', 1619,
        '"', 624,
        '#', 557,
        '$', 120,
        '\'', 124,
        '(', 1250,
        ')', 1251,
        '*', 145,
        '+', 1594,
        ',', 1253,
        '-', 1602,
        '.', 1646,
        '0', 569,
        '1', 563,
        '2', 564,
        '3', 565,
        '4', 566,
        '5', 567,
        '6', 568,
        ':', 1570,
        '<', 801,
        '>', 759,
        '@', 96,
        '[', 750,
      );
      if (lookahead == '`') SKIP(43);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '|') ADVANCE(1329);
      if (('7' <= lookahead && lookahead <= '9')) ADVANCE(570);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(56);
      END_STATE();
    case 58:
      ADVANCE_MAP(
        ' ', 1565,
        '!', 1619,
        '"', 624,
        '#', 557,
        '$', 120,
        '\'', 124,
        '(', 1250,
        ')', 1251,
        '*', 145,
        '+', 1594,
        ',', 1253,
        '-', 1605,
        '.', 524,
        '0', 569,
        '1', 563,
        '2', 564,
        '3', 565,
        '4', 566,
        '5', 567,
        '6', 568,
        ':', 1570,
        '<', 801,
        '>', 759,
        '@', 96,
        '[', 750,
      );
      if (lookahead == '`') SKIP(53);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '|') ADVANCE(1329);
      if (('7' <= lookahead && lookahead <= '9')) ADVANCE(570);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(58);
      END_STATE();
    case 59:
      ADVANCE_MAP(
        ' ', 1565,
        '!', 1619,
        '"', 624,
        '#', 557,
        '$', 120,
        '\'', 124,
        '(', 1250,
        ')', 1251,
        '*', 145,
        '+', 1594,
        ',', 1253,
        '-', 1605,
        '.', 1646,
        '0', 569,
        '1', 563,
        '2', 564,
        '3', 565,
        '4', 566,
        '5', 567,
        '6', 568,
        ':', 1570,
        '<', 801,
        '>', 759,
        '@', 96,
        '[', 750,
      );
      if (lookahead == '`') SKIP(53);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '|') ADVANCE(1329);
      if (('7' <= lookahead && lookahead <= '9')) ADVANCE(570);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(58);
      END_STATE();
    case 60:
      ADVANCE_MAP(
        ' ', 1565,
        '"', 624,
        '#', 557,
        '$', 120,
        '\'', 124,
        '(', 1250,
        '.', 524,
        '0', 569,
        ':', 1569,
        '<', 115,
        '@', 96,
        '[', 750,
      );
      if (lookahead == '`') SKIP(19);
      if (lookahead == '{') ADVANCE(1263);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(60);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(570);
      END_STATE();
    case 61:
      ADVANCE_MAP(
        ' ', 1565,
        '"', 1540,
        '#', 1534,
        '\'', 123,
        ')', 1251,
        '*', 1527,
        '-', 1524,
        '1', 1528,
        '2', 1529,
        '3', 1530,
        '4', 1531,
        '5', 1532,
        '6', 1533,
        ':', 1571,
        '<', 803,
        '>', 761,
        '`', 1538,
        '|', 1329,
        0xa0, 1515,
        0x200b, 1515,
        0x2060, 1515,
        0xfeff, 1515,
      );
      if (('\t' <= lookahead && lookahead <= '\r')) SKIP(75);
      if (lookahead != 0 &&
          (lookahead < '&' || '*' < lookahead) &&
          lookahead != ',' &&
          lookahead != '-' &&
          (lookahead < ':' || '<' < lookahead) &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1538);
      END_STATE();
    case 62:
      ADVANCE_MAP(
        ' ', 1565,
        '"', 1540,
        '#', 1534,
        '\'', 123,
        ')', 1251,
        '*', 1527,
        '-', 1526,
        '1', 1528,
        '2', 1529,
        '3', 1530,
        '4', 1531,
        '5', 1532,
        '6', 1533,
        ':', 1571,
        '<', 803,
        '>', 761,
        '`', 1538,
        '|', 1329,
        0xa0, 1516,
        0x200b, 1516,
        0x2060, 1516,
        0xfeff, 1516,
      );
      if (('\t' <= lookahead && lookahead <= '\r')) SKIP(76);
      if (lookahead != 0 &&
          (lookahead < '&' || '*' < lookahead) &&
          lookahead != ',' &&
          lookahead != '-' &&
          (lookahead < ':' || '<' < lookahead) &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1538);
      END_STATE();
    case 63:
      ADVANCE_MAP(
        ' ', 1565,
        '#', 557,
        '$', 121,
        ')', 1251,
        '*', 145,
        '+', 125,
        '-', 1543,
        '.', 1644,
        '1', 1549,
        '2', 1550,
        '3', 1551,
        '4', 1552,
        '5', 1553,
        '6', 1554,
        ':', 1570,
        '<', 801,
        '>', 759,
        '@', 152,
        '[', 750,
      );
      if (lookahead == '`') SKIP(17);
      if (lookahead == '|') ADVANCE(1329);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(64);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('?' <= lookahead && lookahead <= '\\') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 64:
      ADVANCE_MAP(
        ' ', 1565,
        '#', 557,
        '$', 121,
        ')', 1251,
        '*', 145,
        '+', 125,
        '-', 1543,
        '1', 1549,
        '2', 1550,
        '3', 1551,
        '4', 1552,
        '5', 1553,
        '6', 1554,
        ':', 1570,
        '<', 801,
        '>', 759,
        '@', 152,
        '[', 750,
      );
      if (lookahead == '`') SKIP(17);
      if (lookahead == '|') ADVANCE(1329);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(64);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('?' <= lookahead && lookahead <= '\\') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 65:
      ADVANCE_MAP(
        ' ', 1565,
        '#', 557,
        '$', 121,
        ')', 1251,
        '*', 145,
        '+', 125,
        '-', 1547,
        '.', 1644,
        '1', 1549,
        '2', 1550,
        '3', 1551,
        '4', 1552,
        '5', 1553,
        '6', 1554,
        ':', 1570,
        '<', 801,
        '>', 759,
        '@', 152,
        '[', 750,
      );
      if (lookahead == '`') SKIP(49);
      if (lookahead == '|') ADVANCE(1329);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(66);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('?' <= lookahead && lookahead <= '\\') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 66:
      ADVANCE_MAP(
        ' ', 1565,
        '#', 557,
        '$', 121,
        ')', 1251,
        '*', 145,
        '+', 125,
        '-', 1547,
        '1', 1549,
        '2', 1550,
        '3', 1551,
        '4', 1552,
        '5', 1553,
        '6', 1554,
        ':', 1570,
        '<', 801,
        '>', 759,
        '@', 152,
        '[', 750,
      );
      if (lookahead == '`') SKIP(49);
      if (lookahead == '|') ADVANCE(1329);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(66);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('?' <= lookahead && lookahead <= '\\') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 67:
      ADVANCE_MAP(
        ' ', 1565,
        '#', 557,
        '$', 121,
        ')', 1251,
        '*', 145,
        '-', 1544,
        '1', 1549,
        '2', 1550,
        '3', 1551,
        '4', 1552,
        '5', 1553,
        '6', 1554,
        ':', 1569,
        '<', 801,
        '>', 759,
        '@', 152,
      );
      if (lookahead == '`') SKIP(21);
      if (lookahead == '|') ADVANCE(1329);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(67);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('?' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 68:
      ADVANCE_MAP(
        ' ', 1565,
        '#', 557,
        '$', 121,
        ')', 1251,
        '*', 145,
        '-', 1548,
        '1', 1549,
        '2', 1550,
        '3', 1551,
        '4', 1552,
        '5', 1553,
        '6', 1554,
        ':', 1569,
        '<', 801,
        '>', 759,
        '@', 152,
      );
      if (lookahead == '`') SKIP(50);
      if (lookahead == '|') ADVANCE(1329);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(68);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('?' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 69:
      ADVANCE_MAP(
        ' ', 1565,
        '#', 557,
        '(', 1250,
        ')', 1251,
        '*', 145,
        '+', 125,
        ',', 1253,
        '-', 127,
        '.', 1645,
        '1', 146,
        '2', 147,
        '3', 148,
        '4', 149,
        '5', 150,
        '6', 151,
        ':', 1570,
        '<', 801,
        '>', 759,
        '[', 750,
      );
      if (lookahead == '`') SKIP(23);
      if (lookahead == '|') ADVANCE(1329);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(70);
      END_STATE();
    case 70:
      ADVANCE_MAP(
        ' ', 1565,
        '#', 557,
        '(', 1250,
        ')', 1251,
        '*', 145,
        '+', 125,
        ',', 1253,
        '-', 127,
        '1', 146,
        '2', 147,
        '3', 148,
        '4', 149,
        '5', 150,
        '6', 151,
        ':', 1570,
        '<', 801,
        '>', 759,
        '[', 750,
      );
      if (lookahead == '`') SKIP(23);
      if (lookahead == '|') ADVANCE(1329);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(70);
      END_STATE();
    case 71:
      ADVANCE_MAP(
        ' ', 1565,
        '#', 557,
        '(', 1250,
        ')', 1251,
        '*', 145,
        '+', 125,
        ',', 1253,
        '-', 129,
        '.', 1645,
        '1', 146,
        '2', 147,
        '3', 148,
        '4', 149,
        '5', 150,
        '6', 151,
        ':', 1570,
        '<', 801,
        '>', 759,
        '[', 750,
      );
      if (lookahead == '`') SKIP(51);
      if (lookahead == '|') ADVANCE(1329);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(72);
      END_STATE();
    case 72:
      ADVANCE_MAP(
        ' ', 1565,
        '#', 557,
        '(', 1250,
        ')', 1251,
        '*', 145,
        '+', 125,
        ',', 1253,
        '-', 129,
        '1', 146,
        '2', 147,
        '3', 148,
        '4', 149,
        '5', 150,
        '6', 151,
        ':', 1570,
        '<', 801,
        '>', 759,
        '[', 750,
      );
      if (lookahead == '`') SKIP(51);
      if (lookahead == '|') ADVANCE(1329);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(72);
      END_STATE();
    case 73:
      ADVANCE_MAP(
        ' ', 1565,
        '#', 557,
        '(', 1250,
        ')', 1251,
        '*', 145,
        ',', 1253,
        '-', 128,
        '1', 146,
        '2', 147,
        '3', 148,
        '4', 149,
        '5', 150,
        '6', 151,
        ':', 1569,
        '<', 801,
        '>', 759,
      );
      if (lookahead == '`') SKIP(22);
      if (lookahead == '|') ADVANCE(1329);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(73);
      END_STATE();
    case 74:
      ADVANCE_MAP(
        ' ', 1565,
        '#', 557,
        '(', 1250,
        ')', 1251,
        '*', 145,
        ',', 1253,
        '-', 130,
        '1', 146,
        '2', 147,
        '3', 148,
        '4', 149,
        '5', 150,
        '6', 151,
        ':', 1569,
        '<', 801,
        '>', 759,
      );
      if (lookahead == '`') SKIP(54);
      if (lookahead == '|') ADVANCE(1329);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(74);
      END_STATE();
    case 75:
      ADVANCE_MAP(
        ' ', 1565,
        '#', 557,
        ')', 1251,
        '*', 145,
        '-', 128,
        '1', 146,
        '2', 147,
        '3', 148,
        '4', 149,
        '5', 150,
        '6', 151,
        ':', 1569,
        '<', 801,
        '>', 759,
      );
      if (lookahead == '`') SKIP(24);
      if (lookahead == '|') ADVANCE(1329);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(75);
      END_STATE();
    case 76:
      ADVANCE_MAP(
        ' ', 1565,
        '#', 557,
        ')', 1251,
        '*', 145,
        '-', 130,
        '1', 146,
        '2', 147,
        '3', 148,
        '4', 149,
        '5', 150,
        '6', 151,
        ':', 1569,
        '<', 801,
        '>', 759,
      );
      if (lookahead == '`') SKIP(52);
      if (lookahead == '|') ADVANCE(1329);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(76);
      END_STATE();
    case 77:
      ADVANCE_MAP(
        ' ', 1566,
        '!', 1621,
        '"', 624,
        '#', 551,
        '$', 120,
        '\'', 124,
        '(', 1250,
        ')', 1251,
        '*', 1152,
        '+', 1596,
        ',', 1254,
        '-', 1602,
        '.', 1184,
        '0', 579,
        '1', 573,
        '2', 574,
        '3', 575,
        '4', 576,
        '5', 577,
        '6', 578,
        ':', 1572,
        '<', 802,
        '>', 760,
        '@', 96,
        '[', 750,
      );
      if (lookahead == '`') SKIP(11);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '|') ADVANCE(1329);
      if (('7' <= lookahead && lookahead <= '9')) ADVANCE(580);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1132);
      if (('\t' <= lookahead && lookahead <= '\r')) SKIP(77);
      if (lookahead != 0 &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1191);
      END_STATE();
    case 78:
      ADVANCE_MAP(
        ' ', 1567,
        '!', 1621,
        '"', 624,
        '#', 551,
        '$', 120,
        '\'', 124,
        '(', 1250,
        ')', 1251,
        '*', 1152,
        '+', 1596,
        ',', 1254,
        '-', 1601,
        '.', 1184,
        '0', 579,
        '1', 573,
        '2', 574,
        '3', 575,
        '4', 576,
        '5', 577,
        '6', 578,
        '<', 802,
        '>', 760,
        '@', 96,
        '[', 750,
      );
      if (lookahead == '`') SKIP(16);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '|') ADVANCE(1329);
      if (('7' <= lookahead && lookahead <= '9')) ADVANCE(580);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1133);
      if (('\t' <= lookahead && lookahead <= '\r')) SKIP(78);
      if (lookahead != 0 &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1191);
      END_STATE();
    case 79:
      ADVANCE_MAP(
        ' ', 1568,
        '!', 1621,
        '"', 624,
        '#', 551,
        '$', 120,
        '\'', 124,
        '(', 1250,
        ')', 1251,
        '*', 1152,
        '+', 1596,
        ',', 1254,
        '-', 1605,
        '.', 1184,
        '0', 579,
        '1', 573,
        '2', 574,
        '3', 575,
        '4', 576,
        '5', 577,
        '6', 578,
        ':', 1572,
        '<', 802,
        '>', 760,
        '@', 96,
        '[', 750,
      );
      if (lookahead == '`') SKIP(48);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '|') ADVANCE(1329);
      if (('7' <= lookahead && lookahead <= '9')) ADVANCE(580);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1134);
      if (('\t' <= lookahead && lookahead <= '\r')) SKIP(79);
      if (lookahead != 0 &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1191);
      END_STATE();
    case 80:
      ADVANCE_MAP(
        '!', 1620,
        '"', 1347,
        '#', 547,
        '$', 1346,
        '%', 1574,
        '&', 1330,
        '(', 1250,
        ')', 1251,
        '*', 1612,
        '+', 1595,
        ',', 1253,
        '-', 1598,
        '.', 747,
        '/', 1609,
        '0', 569,
        '1', 563,
        '2', 564,
        '3', 565,
        '4', 566,
        '5', 567,
        '6', 568,
        ':', 1570,
        ';', 1247,
        '<', 801,
        '=', 753,
        '>', 759,
        '@', 96,
        '[', 750,
        '\\', 1610,
        ']', 1649,
      );
      if (lookahead == '`') SKIP(1);
      if (lookahead == 'b') ADVANCE(245);
      if (lookahead == 'c') ADVANCE(160);
      if (lookahead == 'd') ADVANCE(163);
      if (lookahead == 'e') ADVANCE(350);
      if (lookahead == 'f') ADVANCE(312);
      if (lookahead == 'h') ADVANCE(313);
      if (lookahead == 'i') ADVANCE(290);
      if (lookahead == 'p') ADVANCE(166);
      if (lookahead == 'r') ADVANCE(274);
      if (lookahead == 's') ADVANCE(246);
      if (lookahead == 't') ADVANCE(309);
      if (lookahead == 'u') ADVANCE(389);
      if (lookahead == 'w') ADVANCE(311);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '|') ADVANCE(1329);
      if (lookahead == '}') ADVANCE(1265);
      if (('7' <= lookahead && lookahead <= '9')) ADVANCE(570);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(81);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(80);
      END_STATE();
    case 81:
      ADVANCE_MAP(
        '!', 1620,
        '"', 1347,
        '#', 557,
        '$', 1346,
        '%', 1574,
        '&', 1330,
        '(', 1250,
        ')', 1251,
        '*', 1612,
        '+', 1595,
        ',', 1253,
        '-', 1598,
        '.', 747,
        '/', 1609,
        '0', 569,
        '1', 563,
        '2', 564,
        '3', 565,
        '4', 566,
        '5', 567,
        '6', 568,
        ':', 1570,
        ';', 1247,
        '<', 801,
        '=', 753,
        '>', 759,
        '@', 96,
        '[', 750,
        '\\', 1610,
        ']', 1649,
      );
      if (lookahead == '`') SKIP(1);
      if (lookahead == 'b') ADVANCE(245);
      if (lookahead == 'c') ADVANCE(160);
      if (lookahead == 'd') ADVANCE(163);
      if (lookahead == 'e') ADVANCE(350);
      if (lookahead == 'f') ADVANCE(312);
      if (lookahead == 'h') ADVANCE(313);
      if (lookahead == 'i') ADVANCE(290);
      if (lookahead == 'p') ADVANCE(166);
      if (lookahead == 'r') ADVANCE(274);
      if (lookahead == 's') ADVANCE(246);
      if (lookahead == 't') ADVANCE(309);
      if (lookahead == 'u') ADVANCE(389);
      if (lookahead == 'w') ADVANCE(311);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '|') ADVANCE(1329);
      if (lookahead == '}') ADVANCE(1265);
      if (('7' <= lookahead && lookahead <= '9')) ADVANCE(570);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(81);
      END_STATE();
    case 82:
      ADVANCE_MAP(
        '!', 1619,
        '"', 624,
        '#', 557,
        '$', 120,
        '%', 1573,
        '\'', 124,
        '(', 1250,
        ')', 1251,
        '*', 1611,
        '+', 1594,
        ',', 1253,
        '-', 1599,
        '.', 1643,
        '/', 1608,
        '0', 569,
        ':', 141,
        ';', 1247,
        '<', 115,
        '@', 96,
        '[', 750,
        '\\', 1610,
        ']', 1649,
      );
      if (lookahead == '`') SKIP(41);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '}') ADVANCE(1265);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(570);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(83);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(744);
      END_STATE();
    case 83:
      ADVANCE_MAP(
        '!', 1619,
        '"', 624,
        '#', 557,
        '$', 120,
        '%', 1573,
        '\'', 124,
        '(', 1250,
        ')', 1251,
        '*', 1611,
        '+', 1594,
        ',', 1253,
        '-', 1599,
        '.', 132,
        '/', 1608,
        '0', 569,
        ':', 141,
        ';', 1247,
        '<', 115,
        '@', 96,
        '[', 750,
        '\\', 1610,
        ']', 1649,
      );
      if (lookahead == '`') SKIP(41);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '}') ADVANCE(1265);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(570);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(83);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(744);
      END_STATE();
    case 84:
      ADVANCE_MAP(
        '!', 1619,
        '"', 624,
        '#', 557,
        '$', 120,
        '\'', 124,
        '(', 1250,
        ')', 1251,
        '*', 145,
        '+', 1594,
        ',', 1253,
        '-', 1601,
        '.', 524,
        '0', 569,
        '1', 563,
        '2', 564,
        '3', 565,
        '4', 566,
        '5', 567,
        '6', 568,
        ':', 140,
        '<', 801,
        '>', 759,
        '@', 96,
        '[', 750,
      );
      if (lookahead == '`') SKIP(44);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '|') ADVANCE(1329);
      if (('7' <= lookahead && lookahead <= '9')) ADVANCE(570);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(84);
      END_STATE();
    case 85:
      ADVANCE_MAP(
        '!', 1619,
        '"', 624,
        '#', 557,
        '$', 120,
        '\'', 124,
        '(', 1250,
        ')', 1251,
        '*', 145,
        '+', 1594,
        ',', 1253,
        '-', 1601,
        '.', 1646,
        '0', 569,
        '1', 563,
        '2', 564,
        '3', 565,
        '4', 566,
        '5', 567,
        '6', 568,
        ':', 140,
        '<', 801,
        '>', 759,
        '@', 96,
        '[', 750,
      );
      if (lookahead == '`') SKIP(44);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '|') ADVANCE(1329);
      if (('7' <= lookahead && lookahead <= '9')) ADVANCE(570);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(84);
      END_STATE();
    case 86:
      ADVANCE_MAP(
        '!', 1619,
        '"', 624,
        '#', 557,
        '$', 120,
        '\'', 124,
        '(', 1250,
        '+', 1594,
        ',', 1253,
        '-', 1601,
        '.', 524,
        '0', 569,
        ':', 140,
        '<', 115,
        '=', 753,
        '@', 96,
        '[', 750,
      );
      if (lookahead == '`') SKIP(45);
      if (lookahead == 'h') ADVANCE(739);
      if (lookahead == 's') ADVANCE(742);
      if (lookahead == '{') ADVANCE(1263);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(570);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(86);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(744);
      END_STATE();
    case 87:
      ADVANCE_MAP(
        '!', 1619,
        '"', 624,
        '#', 557,
        '$', 120,
        '\'', 124,
        '(', 1250,
        '+', 1594,
        ',', 1253,
        '-', 1601,
        '.', 1646,
        '0', 569,
        ':', 140,
        '<', 115,
        '=', 753,
        '@', 96,
        '[', 750,
      );
      if (lookahead == '`') SKIP(45);
      if (lookahead == 'h') ADVANCE(739);
      if (lookahead == 's') ADVANCE(742);
      if (lookahead == '{') ADVANCE(1263);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(570);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(86);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(744);
      END_STATE();
    case 88:
      ADVANCE_MAP(
        '!', 1619,
        '"', 624,
        '#', 552,
        '$', 120,
        '%', 1573,
        '&', 1330,
        '\'', 124,
        '(', 1250,
        ')', 1251,
        '+', 1594,
        ',', 1253,
        '-', 1601,
        '.', 748,
        '0', 571,
        '<', 115,
        '@', 96,
        '[', 750,
      );
      if (lookahead == '`') SKIP(15);
      if (lookahead == 'f') ADVANCE(1471);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1358);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(88);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(572);
      if (lookahead != 0 &&
          (lookahead < ' ' || '9' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != ']' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 89:
      ADVANCE_MAP(
        '!', 1619,
        '"', 624,
        '#', 552,
        '$', 120,
        '%', 1573,
        '&', 1330,
        '\'', 124,
        '(', 1250,
        '+', 1594,
        ',', 1253,
        '-', 1601,
        '.', 748,
        '0', 571,
        ':', 1513,
        ';', 1247,
        '<', 115,
        '@', 96,
        '[', 750,
      );
      if (lookahead == '`') SKIP(8);
      if (lookahead == 'b') ADVANCE(1480);
      if (lookahead == 'c') ADVANCE(1441);
      if (lookahead == 'd') ADVANCE(1370);
      if (lookahead == 'e') ADVANCE(1456);
      if (lookahead == 'f') ADVANCE(1426);
      if (lookahead == 'i') ADVANCE(1416);
      if (lookahead == 'p') ADVANCE(1378);
      if (lookahead == 'r') ADVANCE(1408);
      if (lookahead == 's') ADVANCE(1401);
      if (lookahead == 't') ADVANCE(1425);
      if (lookahead == 'w') ADVANCE(1424);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1350);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(89);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(572);
      if (lookahead != 0 &&
          (lookahead < ' ' || '<' < lookahead) &&
          lookahead != ']' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 90:
      ADVANCE_MAP(
        '!', 1619,
        '"', 624,
        '#', 552,
        '$', 120,
        '%', 1573,
        '&', 1330,
        '\'', 124,
        '(', 1250,
        '+', 1594,
        ',', 1253,
        '-', 1601,
        '.', 748,
        '0', 571,
        ':', 1513,
        ';', 1247,
        '<', 115,
        '@', 96,
        '[', 750,
      );
      if (lookahead == '`') SKIP(9);
      if (lookahead == 'b') ADVANCE(1405);
      if (lookahead == 'c') ADVANCE(1441);
      if (lookahead == 'd') ADVANCE(1369);
      if (lookahead == 'e') ADVANCE(1460);
      if (lookahead == 'f') ADVANCE(1426);
      if (lookahead == 'i') ADVANCE(1416);
      if (lookahead == 'p') ADVANCE(1377);
      if (lookahead == 'r') ADVANCE(1408);
      if (lookahead == 's') ADVANCE(1401);
      if (lookahead == 't') ADVANCE(1425);
      if (lookahead == 'w') ADVANCE(1424);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '}') ADVANCE(1265);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1356);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(90);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(572);
      if (lookahead != 0 &&
          (lookahead < ' ' || '<' < lookahead) &&
          lookahead != ']' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 91:
      ADVANCE_MAP(
        '!', 1619,
        '"', 624,
        '#', 552,
        '$', 120,
        '%', 1573,
        '&', 1330,
        '\'', 124,
        '(', 1250,
        '+', 1594,
        ',', 1253,
        '-', 1601,
        '.', 748,
        '0', 571,
        ':', 1513,
        ';', 1247,
        '<', 115,
        '@', 96,
        '[', 750,
      );
      if (lookahead == '`') SKIP(55);
      if (lookahead == 'b') ADVANCE(1405);
      if (lookahead == 'c') ADVANCE(1441);
      if (lookahead == 'd') ADVANCE(1369);
      if (lookahead == 'e') ADVANCE(1460);
      if (lookahead == 'f') ADVANCE(1426);
      if (lookahead == 'i') ADVANCE(1416);
      if (lookahead == 'p') ADVANCE(1386);
      if (lookahead == 'r') ADVANCE(1408);
      if (lookahead == 's') ADVANCE(1401);
      if (lookahead == 't') ADVANCE(1425);
      if (lookahead == 'w') ADVANCE(1424);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '}') ADVANCE(1265);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1357);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(91);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(572);
      if (lookahead != 0 &&
          (lookahead < ' ' || '<' < lookahead) &&
          lookahead != ']' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 92:
      ADVANCE_MAP(
        '!', 144,
        '"', 1347,
        '#', 557,
        '$', 1344,
        '%', 1574,
        '(', 1250,
        ')', 1251,
        '*', 1612,
        '+', 1595,
        ',', 1253,
        '-', 1600,
        '.', 1642,
        '/', 1609,
        '1', 146,
        '2', 147,
        '3', 148,
        '4', 149,
        '5', 150,
        '6', 151,
        ':', 140,
        '<', 801,
        '=', 753,
        '>', 759,
        '[', 750,
        '\\', 1610,
        ']', 1649,
      );
      if (lookahead == '`') SKIP(42);
      if (lookahead == 'i') ADVANCE(379);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '|') ADVANCE(1329);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(93);
      END_STATE();
    case 93:
      ADVANCE_MAP(
        '!', 144,
        '"', 1347,
        '#', 557,
        '$', 1344,
        '%', 1574,
        '(', 1250,
        ')', 1251,
        '*', 1612,
        '+', 1595,
        ',', 1253,
        '-', 1600,
        '.', 131,
        '/', 1609,
        '1', 146,
        '2', 147,
        '3', 148,
        '4', 149,
        '5', 150,
        '6', 151,
        ':', 140,
        '<', 801,
        '=', 753,
        '>', 759,
        '[', 750,
        '\\', 1610,
        ']', 1649,
      );
      if (lookahead == '`') SKIP(42);
      if (lookahead == 'i') ADVANCE(379);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '|') ADVANCE(1329);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(93);
      END_STATE();
    case 94:
      ADVANCE_MAP(
        '!', 144,
        '#', 557,
        '$', 121,
        '%', 1574,
        ')', 1251,
        '*', 1612,
        '+', 1597,
        ',', 1253,
        '-', 1607,
        '.', 131,
        '/', 1609,
        '1', 146,
        '2', 147,
        '3', 148,
        '4', 149,
        '5', 150,
        '6', 151,
        ':', 1569,
        ';', 1247,
        '<', 801,
        '=', 753,
        '>', 759,
        '@', 152,
        '[', 750,
        '\\', 1610,
        ']', 1649,
      );
      if (lookahead == '`') SKIP(10);
      if (lookahead == 'h') ADVANCE(739);
      if (lookahead == 's') ADVANCE(742);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '|') ADVANCE(1329);
      if (lookahead == '}') ADVANCE(1265);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(94);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(744);
      END_STATE();
    case 95:
      ADVANCE_MAP(
        '!', 1621,
        '"', 624,
        '#', 551,
        '$', 120,
        '\'', 124,
        '(', 1250,
        ')', 1251,
        '*', 1152,
        '+', 1596,
        ',', 1254,
        '-', 1601,
        '.', 1184,
        '0', 579,
        '1', 573,
        '2', 574,
        '3', 575,
        '4', 576,
        '5', 577,
        '6', 578,
        '<', 802,
        '>', 760,
        '@', 96,
        '[', 750,
      );
      if (lookahead == '`') SKIP(12);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '|') ADVANCE(1329);
      if (('7' <= lookahead && lookahead <= '9')) ADVANCE(580);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1135);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(95);
      if (lookahead != 0 &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1191);
      END_STATE();
    case 96:
      ADVANCE_MAP(
        '"', 2,
        '\'', 3,
        '(', 1639,
        '?', 997,
        'g', 1042,
        'l', 1048,
        'p', 1050,
        's', 1033,
        'u', 1053,
        'w', 1047,
        '{', 1640,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 97:
      if (lookahead == '"') ADVANCE(677);
      if (lookahead == '#') ADVANCE(547);
      if (lookahead == '$') ADVANCE(674);
      if (lookahead == '<') ADVANCE(115);
      if (lookahead == '`') SKIP(38);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(114);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(98);
      END_STATE();
    case 98:
      if (lookahead == '"') ADVANCE(677);
      if (lookahead == '#') ADVANCE(547);
      if (lookahead == '<') ADVANCE(115);
      if (lookahead == '`') SKIP(38);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(114);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(98);
      END_STATE();
    case 99:
      if (lookahead == '"') ADVANCE(677);
      if (lookahead == '#') ADVANCE(99);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(99);
      END_STATE();
    case 100:
      ADVANCE_MAP(
        '"', 624,
        '#', 552,
        '$', 120,
        '\'', 124,
        '(', 1250,
        '-', 1563,
        '.', 1365,
        '0', 559,
        '<', 115,
        '@', 96,
        '[', 750,
      );
      if (lookahead == '`') SKIP(18);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1359);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(100);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(560);
      if (('?' <= lookahead && lookahead <= '\\') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1367);
      if (lookahead != 0 &&
          (lookahead < ' ' || '9' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '?' || ']' < lookahead) &&
          (lookahead < '_' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 101:
      ADVANCE_MAP(
        '"', 626,
        '#', 550,
        '$', 1200,
        '\'', 1201,
        '(', 1250,
        '.', 1210,
        '0', 581,
        ';', 1247,
        '<', 1197,
        '@', 1195,
        '[', 752,
        '`', 1214,
        '{', 1263,
        '}', 1265,
        0xa0, 1194,
        0x200b, 1194,
        0x2060, 1194,
        0xfeff, 1194,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(101);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(582);
      if (lookahead != 0 &&
          (lookahead < '\'' || ')' < lookahead)) ADVANCE(1214);
      END_STATE();
    case 102:
      ADVANCE_MAP(
        '"', 1540,
        '#', 1534,
        '\'', 123,
        ',', 1253,
        '<', 1518,
        '`', 1538,
        '{', 1263,
        0xa0, 1517,
        0x200b, 1517,
        0x2060, 1517,
        0xfeff, 1517,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(112);
      if (lookahead != 0 &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1538);
      END_STATE();
    case 103:
      if (lookahead == '"') ADVANCE(1348);
      if (lookahead == '#') ADVANCE(548);
      if (lookahead == '$') ADVANCE(1345);
      if (lookahead == '<') ADVANCE(1332);
      if (lookahead == '@') ADVANCE(1336);
      if (lookahead == '`') ADVANCE(25);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1331);
      if (lookahead != 0) ADVANCE(1338);
      END_STATE();
    case 104:
      ADVANCE_MAP(
        '"', 678,
        '#', 628,
        '$', 675,
        '<', 632,
        '@', 667,
        '`', 26,
        0xa0, 631,
        0x200b, 631,
        0x2060, 631,
        0xfeff, 631,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(630);
      if (lookahead != 0) ADVANCE(670);
      END_STATE();
    case 105:
      if (lookahead == '"') ADVANCE(1235);
      if (lookahead != 0) ADVANCE(105);
      END_STATE();
    case 106:
      ADVANCE_MAP(
        '#', 557,
        '$', 121,
        '(', 1250,
        ')', 1251,
        '*', 145,
        '+', 125,
        ',', 1253,
        '-', 126,
        '.', 1645,
        '1', 146,
        '2', 147,
        '3', 148,
        '4', 149,
        '5', 150,
        '6', 151,
        ':', 140,
        '<', 801,
        '=', 753,
        '>', 759,
        '@', 152,
        '[', 750,
      );
      if (lookahead == '`') SKIP(20);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '|') ADVANCE(1329);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(107);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(744);
      END_STATE();
    case 107:
      ADVANCE_MAP(
        '#', 557,
        '$', 121,
        '(', 1250,
        ')', 1251,
        '*', 145,
        '+', 125,
        ',', 1253,
        '-', 126,
        '1', 146,
        '2', 147,
        '3', 148,
        '4', 149,
        '5', 150,
        '6', 151,
        ':', 140,
        '<', 801,
        '=', 753,
        '>', 759,
        '@', 152,
        '[', 750,
      );
      if (lookahead == '`') SKIP(20);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '|') ADVANCE(1329);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(107);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(744);
      END_STATE();
    case 108:
      if (lookahead == '#') ADVANCE(557);
      if (lookahead == '$') ADVANCE(121);
      if (lookahead == ')') ADVANCE(1251);
      if (lookahead == ',') ADVANCE(1253);
      if (lookahead == '-') ADVANCE(1546);
      if (lookahead == '<') ADVANCE(115);
      if (lookahead == '@') ADVANCE(152);
      if (lookahead == '`') SKIP(30);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '|') ADVANCE(1329);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(108);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('?' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 109:
      ADVANCE_MAP(
        '#', 557,
        '$', 121,
        '+', 125,
        ',', 1253,
        '-', 1545,
        '.', 1644,
        ':', 140,
        '<', 115,
        '@', 152,
        '[', 750,
      );
      if (lookahead == '`') SKIP(29);
      if (lookahead == '{') ADVANCE(1263);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(110);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('?' <= lookahead && lookahead <= '\\') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 110:
      ADVANCE_MAP(
        '#', 557,
        '$', 121,
        '+', 125,
        ',', 1253,
        '-', 1545,
        ':', 140,
        '<', 115,
        '@', 152,
        '[', 750,
      );
      if (lookahead == '`') SKIP(29);
      if (lookahead == '{') ADVANCE(1263);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(110);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('?' <= lookahead && lookahead <= '\\') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 111:
      if (lookahead == '#') ADVANCE(557);
      if (lookahead == '(') ADVANCE(1250);
      if (lookahead == ',') ADVANCE(1253);
      if (lookahead == '.') ADVANCE(746);
      if (lookahead == '<') ADVANCE(115);
      if (lookahead == '[') ADVANCE(750);
      if (lookahead == ']') ADVANCE(1649);
      if (lookahead == '`') SKIP(34);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(111);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(745);
      END_STATE();
    case 112:
      if (lookahead == '#') ADVANCE(557);
      if (lookahead == ',') ADVANCE(1253);
      if (lookahead == '<') ADVANCE(115);
      if (lookahead == '`') SKIP(32);
      if (lookahead == '{') ADVANCE(1263);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(112);
      END_STATE();
    case 113:
      if (lookahead == '#') ADVANCE(557);
      if (lookahead == '0') ADVANCE(584);
      if (lookahead == '<') ADVANCE(115);
      if (lookahead == '`') SKIP(39);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(585);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(113);
      END_STATE();
    case 114:
      if (lookahead == '#') ADVANCE(557);
      if (lookahead == '<') ADVANCE(115);
      if (lookahead == '`') SKIP(38);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(114);
      END_STATE();
    case 115:
      if (lookahead == '#') ADVANCE(117);
      END_STATE();
    case 116:
      if (lookahead == '#') ADVANCE(116);
      if (lookahead == '>') ADVANCE(546);
      if (lookahead != 0) ADVANCE(117);
      END_STATE();
    case 117:
      if (lookahead == '#') ADVANCE(116);
      if (lookahead == '`') ADVANCE(528);
      if (lookahead != 0) ADVANCE(117);
      END_STATE();
    case 118:
      if (lookahead == '#') ADVANCE(552);
      if (lookahead == '%') ADVANCE(1573);
      if (lookahead == '&') ADVANCE(1330);
      if (lookahead == '.') ADVANCE(749);
      if (lookahead == '<') ADVANCE(115);
      if (lookahead == '`') SKIP(31);
      if (lookahead == 'f') ADVANCE(1471);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1360);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(118);
      if (lookahead != 0 &&
          (lookahead < ' ' || '/' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '@' &&
          lookahead != '[' &&
          lookahead != ']' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 119:
      if (lookahead == '#') ADVANCE(550);
      if (lookahead == '<') ADVANCE(1197);
      if (lookahead == '`') ADVANCE(1214);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1196);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(119);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 120:
      ADVANCE_MAP(
        '$', 886,
        '(', 1638,
        '?', 892,
        '^', 889,
        '_', 895,
        'g', 912,
        'l', 918,
        'p', 920,
        's', 903,
        'u', 923,
        'w', 917,
        '{', 527,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 121:
      ADVANCE_MAP(
        '$', 886,
        '?', 892,
        '^', 889,
        '_', 895,
        'g', 912,
        'l', 918,
        'p', 920,
        's', 903,
        'u', 923,
        'w', 917,
        '{', 527,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 122:
      if (lookahead == '&') ADVANCE(139);
      END_STATE();
    case 123:
      if (lookahead == '\'') ADVANCE(1541);
      END_STATE();
    case 124:
      if (lookahead == '\'') ADVANCE(729);
      if (lookahead != 0) ADVANCE(124);
      END_STATE();
    case 125:
      if (lookahead == '+') ADVANCE(1626);
      END_STATE();
    case 126:
      ADVANCE_MAP(
        '-', 1628,
        'c', 176,
        'e', 520,
        'f', 314,
        'p', 179,
        'r', 273,
        's', 511,
        'w', 316,
      );
      END_STATE();
    case 127:
      if (lookahead == '-') ADVANCE(1630);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1234);
      END_STATE();
    case 128:
      if (lookahead == '-') ADVANCE(1215);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1234);
      END_STATE();
    case 129:
      if (lookahead == '-') ADVANCE(1632);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1234);
      END_STATE();
    case 130:
      if (lookahead == '-') ADVANCE(1217);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1234);
      END_STATE();
    case 131:
      if (lookahead == '.') ADVANCE(1613);
      END_STATE();
    case 132:
      if (lookahead == '.') ADVANCE(1613);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(611);
      END_STATE();
    case 133:
      if (lookahead == '1') ADVANCE(804);
      if (lookahead == '2') ADVANCE(816);
      END_STATE();
    case 134:
      if (lookahead == '1') ADVANCE(806);
      END_STATE();
    case 135:
      if (lookahead == '1') ADVANCE(808);
      if (lookahead == '2') ADVANCE(820);
      END_STATE();
    case 136:
      if (lookahead == '1') ADVANCE(810);
      if (lookahead == '2') ADVANCE(822);
      END_STATE();
    case 137:
      if (lookahead == '1') ADVANCE(812);
      if (lookahead == '2') ADVANCE(824);
      END_STATE();
    case 138:
      if (lookahead == '1') ADVANCE(814);
      if (lookahead == '2') ADVANCE(826);
      END_STATE();
    case 139:
      if (lookahead == '2') ADVANCE(818);
      END_STATE();
    case 140:
      if (lookahead == ':') ADVANCE(1648);
      END_STATE();
    case 141:
      if (lookahead == ':') ADVANCE(1648);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1312);
      END_STATE();
    case 142:
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == '?') ADVANCE(898);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(992);
      END_STATE();
    case 143:
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == '?') ADVANCE(997);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1122);
      END_STATE();
    case 144:
      if (lookahead == '=') ADVANCE(754);
      END_STATE();
    case 145:
      if (lookahead == '>') ADVANCE(795);
      END_STATE();
    case 146:
      if (lookahead == '>') ADVANCE(122);
      END_STATE();
    case 147:
      if (lookahead == '>') ADVANCE(765);
      END_STATE();
    case 148:
      if (lookahead == '>') ADVANCE(771);
      END_STATE();
    case 149:
      if (lookahead == '>') ADVANCE(777);
      END_STATE();
    case 150:
      if (lookahead == '>') ADVANCE(783);
      END_STATE();
    case 151:
      if (lookahead == '>') ADVANCE(789);
      END_STATE();
    case 152:
      if (lookahead == '?') ADVANCE(997);
      if (lookahead == 'g') ADVANCE(1042);
      if (lookahead == 'l') ADVANCE(1048);
      if (lookahead == 'p') ADVANCE(1050);
      if (lookahead == 's') ADVANCE(1033);
      if (lookahead == 'u') ADVANCE(1053);
      if (lookahead == 'w') ADVANCE(1047);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 153:
      if (lookahead == '?') ADVANCE(997);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1122);
      END_STATE();
    case 154:
      if (lookahead == '?') ADVANCE(898);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(992);
      END_STATE();
    case 155:
      if (lookahead == '@') ADVANCE(732);
      END_STATE();
    case 156:
      if (lookahead == '@') ADVANCE(732);
      if (lookahead != 0) ADVANCE(7);
      END_STATE();
    case 157:
      if (lookahead == '@') ADVANCE(728);
      if (lookahead != 0) ADVANCE(727);
      END_STATE();
    case 158:
      if (lookahead == '`') ADVANCE(1340);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(1339);
      END_STATE();
    case 159:
      if (lookahead == 'a') ADVANCE(475);
      END_STATE();
    case 160:
      if (lookahead == 'a') ADVANCE(475);
      if (lookahead == 'l') ADVANCE(164);
      if (lookahead == 'o') ADVANCE(392);
      END_STATE();
    case 161:
      if (lookahead == 'a') ADVANCE(1321);
      END_STATE();
    case 162:
      if (lookahead == 'a') ADVANCE(367);
      END_STATE();
    case 163:
      if (lookahead == 'a') ADVANCE(489);
      if (lookahead == 'o') ADVANCE(1292);
      if (lookahead == 'y') ADVANCE(394);
      END_STATE();
    case 164:
      if (lookahead == 'a') ADVANCE(469);
      END_STATE();
    case 165:
      if (lookahead == 'a') ADVANCE(377);
      END_STATE();
    case 166:
      if (lookahead == 'a') ADVANCE(453);
      if (lookahead == 'r') ADVANCE(413);
      END_STATE();
    case 167:
      if (lookahead == 'a') ADVANCE(430);
      if (lookahead == 'y') ADVANCE(1315);
      END_STATE();
    case 168:
      if (lookahead == 'a') ADVANCE(343);
      END_STATE();
    case 169:
      if (lookahead == 'a') ADVANCE(375);
      END_STATE();
    case 170:
      if (lookahead == 'a') ADVANCE(390);
      if (lookahead == 'n') ADVANCE(419);
      if (lookahead == 'o') ADVANCE(446);
      if (lookahead == 'x') ADVANCE(418);
      END_STATE();
    case 171:
      if (lookahead == 'a') ADVANCE(390);
      if (lookahead == 'o') ADVANCE(446);
      if (lookahead == 'x') ADVANCE(418);
      END_STATE();
    case 172:
      if (lookahead == 'a') ADVANCE(361);
      END_STATE();
    case 173:
      if (lookahead == 'a') ADVANCE(374);
      END_STATE();
    case 174:
      if (lookahead == 'a') ADVANCE(369);
      END_STATE();
    case 175:
      if (lookahead == 'a') ADVANCE(452);
      END_STATE();
    case 176:
      if (lookahead == 'a') ADVANCE(472);
      END_STATE();
    case 177:
      ADVANCE_MAP(
        'a', 472,
        'c', 425,
        'e', 441,
        'g', 252,
        'l', 253,
        'm', 197,
        'n', 254,
        'o', 402,
        'r', 283,
        's', 436,
      );
      END_STATE();
    case 178:
      if (lookahead == 'a') ADVANCE(219);
      END_STATE();
    case 179:
      if (lookahead == 'a') ADVANCE(455);
      END_STATE();
    case 180:
      if (lookahead == 'a') ADVANCE(224);
      END_STATE();
    case 181:
      if (lookahead == 'a') ADVANCE(398);
      END_STATE();
    case 182:
      if (lookahead == 'a') ADVANCE(491);
      END_STATE();
    case 183:
      if (lookahead == 'a') ADVANCE(325);
      END_STATE();
    case 184:
      if (lookahead == 'a') ADVANCE(456);
      END_STATE();
    case 185:
      if (lookahead == 'a') ADVANCE(328);
      END_STATE();
    case 186:
      if (lookahead == 'a') ADVANCE(457);
      if (lookahead == 'r') ADVANCE(413);
      END_STATE();
    case 187:
      if (lookahead == 'a') ADVANCE(226);
      END_STATE();
    case 188:
      if (lookahead == 'a') ADVANCE(330);
      END_STATE();
    case 189:
      if (lookahead == 'a') ADVANCE(227);
      END_STATE();
    case 190:
      if (lookahead == 'a') ADVANCE(331);
      END_STATE();
    case 191:
      if (lookahead == 'a') ADVANCE(214);
      END_STATE();
    case 192:
      if (lookahead == 'a') ADVANCE(332);
      END_STATE();
    case 193:
      if (lookahead == 'a') ADVANCE(333);
      END_STATE();
    case 194:
      if (lookahead == 'a') ADVANCE(220);
      END_STATE();
    case 195:
      if (lookahead == 'a') ADVANCE(222);
      END_STATE();
    case 196:
      if (lookahead == 'a') ADVANCE(497);
      END_STATE();
    case 197:
      if (lookahead == 'a') ADVANCE(500);
      END_STATE();
    case 198:
      if (lookahead == 'a') ADVANCE(501);
      END_STATE();
    case 199:
      if (lookahead == 'a') ADVANCE(502);
      END_STATE();
    case 200:
      if (lookahead == 'a') ADVANCE(503);
      END_STATE();
    case 201:
      if (lookahead == 'a') ADVANCE(504);
      END_STATE();
    case 202:
      if (lookahead == 'b') ADVANCE(558);
      END_STATE();
    case 203:
      if (lookahead == 'b') ADVANCE(607);
      END_STATE();
    case 204:
      if (lookahead == 'b') ADVANCE(592);
      END_STATE();
    case 205:
      if (lookahead == 'b') ADVANCE(341);
      END_STATE();
    case 206:
      if (lookahead == 'c') ADVANCE(298);
      END_STATE();
    case 207:
      if (lookahead == 'c') ADVANCE(1582);
      END_STATE();
    case 208:
      if (lookahead == 'c') ADVANCE(299);
      END_STATE();
    case 209:
      if (lookahead == 'c') ADVANCE(300);
      END_STATE();
    case 210:
      if (lookahead == 'c') ADVANCE(301);
      END_STATE();
    case 211:
      ADVANCE_MAP(
        'c', 425,
        'e', 441,
        'g', 252,
        'l', 253,
        'm', 197,
        'n', 254,
        'o', 402,
        'r', 283,
        's', 436,
      );
      END_STATE();
    case 212:
      if (lookahead == 'c') ADVANCE(435);
      END_STATE();
    case 213:
      if (lookahead == 'c') ADVANCE(302);
      END_STATE();
    case 214:
      if (lookahead == 'c') ADVANCE(303);
      END_STATE();
    case 215:
      if (lookahead == 'c') ADVANCE(304);
      END_STATE();
    case 216:
      if (lookahead == 'c') ADVANCE(305);
      END_STATE();
    case 217:
      if (lookahead == 'c') ADVANCE(306);
      END_STATE();
    case 218:
      if (lookahead == 'c') ADVANCE(415);
      END_STATE();
    case 219:
      if (lookahead == 'c') ADVANCE(481);
      END_STATE();
    case 220:
      if (lookahead == 'c') ADVANCE(307);
      END_STATE();
    case 221:
      if (lookahead == 'c') ADVANCE(284);
      END_STATE();
    case 222:
      if (lookahead == 'c') ADVANCE(308);
      END_STATE();
    case 223:
      if (lookahead == 'c') ADVANCE(486);
      END_STATE();
    case 224:
      if (lookahead == 'c') ADVANCE(265);
      END_STATE();
    case 225:
      if (lookahead == 'c') ADVANCE(267);
      END_STATE();
    case 226:
      if (lookahead == 'c') ADVANCE(269);
      END_STATE();
    case 227:
      if (lookahead == 'c') ADVANCE(271);
      END_STATE();
    case 228:
      if (lookahead == 'c') ADVANCE(175);
      END_STATE();
    case 229:
      if (lookahead == 'c') ADVANCE(493);
      END_STATE();
    case 230:
      ADVANCE_MAP(
        'c', 426,
        'e', 442,
        'g', 255,
        'l', 256,
        'm', 198,
        'n', 855,
        'r', 289,
        's', 861,
      );
      END_STATE();
    case 231:
      if (lookahead == 'c') ADVANCE(427);
      if (lookahead == 'i') ADVANCE(382);
      if (lookahead == 'l') ADVANCE(336);
      if (lookahead == 'm') ADVANCE(199);
      END_STATE();
    case 232:
      if (lookahead == 'c') ADVANCE(428);
      if (lookahead == 'l') ADVANCE(338);
      if (lookahead == 'm') ADVANCE(200);
      END_STATE();
    case 233:
      if (lookahead == 'c') ADVANCE(429);
      if (lookahead == 'l') ADVANCE(339);
      if (lookahead == 'm') ADVANCE(201);
      END_STATE();
    case 234:
      if (lookahead == 'd') ADVANCE(1261);
      END_STATE();
    case 235:
      if (lookahead == 'd') ADVANCE(1261);
      if (lookahead == 'u') ADVANCE(373);
      END_STATE();
    case 236:
      if (lookahead == 'd') ADVANCE(1588);
      END_STATE();
    case 237:
      if (lookahead == 'd') ADVANCE(1591);
      END_STATE();
    case 238:
      if (lookahead == 'd') ADVANCE(1276);
      END_STATE();
    case 239:
      if (lookahead == 'd') ADVANCE(1323);
      END_STATE();
    case 240:
      if (lookahead == 'd') ADVANCE(243);
      END_STATE();
    case 241:
      if (lookahead == 'd') ADVANCE(228);
      END_STATE();
    case 242:
      if (lookahead == 'd') ADVANCE(218);
      END_STATE();
    case 243:
      if (lookahead == 'd') ADVANCE(277);
      END_STATE();
    case 244:
      if (lookahead == 'e') ADVANCE(293);
      END_STATE();
    case 245:
      if (lookahead == 'e') ADVANCE(293);
      if (lookahead == 'r') ADVANCE(275);
      END_STATE();
    case 246:
      if (lookahead == 'e') ADVANCE(443);
      if (lookahead == 't') ADVANCE(182);
      if (lookahead == 'w') ADVANCE(340);
      END_STATE();
    case 247:
      if (lookahead == 'e') ADVANCE(845);
      if (lookahead == 't') ADVANCE(846);
      END_STATE();
    case 248:
      if (lookahead == 'e') ADVANCE(868);
      if (lookahead == 'i') ADVANCE(344);
      if (lookahead == 't') ADVANCE(870);
      END_STATE();
    case 249:
      if (lookahead == 'e') ADVANCE(872);
      if (lookahead == 'o') ADVANCE(477);
      END_STATE();
    case 250:
      if (lookahead == 'e') ADVANCE(872);
      if (lookahead == 'o') ADVANCE(488);
      END_STATE();
    case 251:
      if (lookahead == 'e') ADVANCE(295);
      END_STATE();
    case 252:
      if (lookahead == 'e') ADVANCE(831);
      if (lookahead == 't') ADVANCE(832);
      END_STATE();
    case 253:
      if (lookahead == 'e') ADVANCE(833);
      if (lookahead == 'i') ADVANCE(345);
      if (lookahead == 't') ADVANCE(835);
      END_STATE();
    case 254:
      if (lookahead == 'e') ADVANCE(837);
      if (lookahead == 'o') ADVANCE(480);
      END_STATE();
    case 255:
      if (lookahead == 'e') ADVANCE(849);
      if (lookahead == 't') ADVANCE(850);
      END_STATE();
    case 256:
      if (lookahead == 'e') ADVANCE(851);
      if (lookahead == 'i') ADVANCE(346);
      if (lookahead == 't') ADVANCE(853);
      END_STATE();
    case 257:
      if (lookahead == 'e') ADVANCE(1270);
      END_STATE();
    case 258:
      if (lookahead == 'e') ADVANCE(1280);
      END_STATE();
    case 259:
      if (lookahead == 'e') ADVANCE(869);
      END_STATE();
    case 260:
      if (lookahead == 'e') ADVANCE(519);
      END_STATE();
    case 261:
      if (lookahead == 'e') ADVANCE(1290);
      END_STATE();
    case 262:
      if (lookahead == 'e') ADVANCE(834);
      END_STATE();
    case 263:
      if (lookahead == 'e') ADVANCE(852);
      END_STATE();
    case 264:
      if (lookahead == 'e') ADVANCE(875);
      END_STATE();
    case 265:
      if (lookahead == 'e') ADVANCE(877);
      END_STATE();
    case 266:
      if (lookahead == 'e') ADVANCE(1303);
      END_STATE();
    case 267:
      if (lookahead == 'e') ADVANCE(1327);
      END_STATE();
    case 268:
      if (lookahead == 'e') ADVANCE(839);
      END_STATE();
    case 269:
      if (lookahead == 'e') ADVANCE(842);
      END_STATE();
    case 270:
      if (lookahead == 'e') ADVANCE(858);
      END_STATE();
    case 271:
      if (lookahead == 'e') ADVANCE(860);
      END_STATE();
    case 272:
      if (lookahead == 'e') ADVANCE(1278);
      END_STATE();
    case 273:
      if (lookahead == 'e') ADVANCE(294);
      END_STATE();
    case 274:
      if (lookahead == 'e') ADVANCE(476);
      END_STATE();
    case 275:
      if (lookahead == 'e') ADVANCE(168);
      END_STATE();
    case 276:
      if (lookahead == 'e') ADVANCE(242);
      END_STATE();
    case 277:
      if (lookahead == 'e') ADVANCE(383);
      END_STATE();
    case 278:
      if (lookahead == 'e') ADVANCE(449);
      END_STATE();
    case 279:
      if (lookahead == 'e') ADVANCE(355);
      END_STATE();
    case 280:
      if (lookahead == 'e') ADVANCE(404);
      END_STATE();
    case 281:
      if (lookahead == 'e') ADVANCE(356);
      END_STATE();
    case 282:
      if (lookahead == 'e') ADVANCE(391);
      END_STATE();
    case 283:
      if (lookahead == 'e') ADVANCE(437);
      END_STATE();
    case 284:
      if (lookahead == 'e') ADVANCE(470);
      END_STATE();
    case 285:
      if (lookahead == 'e') ADVANCE(473);
      END_STATE();
    case 286:
      if (lookahead == 'e') ADVANCE(223);
      END_STATE();
    case 287:
      if (lookahead == 'e') ADVANCE(195);
      END_STATE();
    case 288:
      if (lookahead == 'e') ADVANCE(433);
      END_STATE();
    case 289:
      if (lookahead == 'e') ADVANCE(438);
      END_STATE();
    case 290:
      if (lookahead == 'f') ADVANCE(1266);
      if (lookahead == 'n') ADVANCE(1284);
      END_STATE();
    case 291:
      if (lookahead == 'f') ADVANCE(1268);
      END_STATE();
    case 292:
      if (lookahead == 'f') ADVANCE(359);
      END_STATE();
    case 293:
      if (lookahead == 'g') ADVANCE(319);
      END_STATE();
    case 294:
      if (lookahead == 'g') ADVANCE(260);
      END_STATE();
    case 295:
      if (lookahead == 'g') ADVANCE(260);
      if (lookahead == 'p') ADVANCE(362);
      END_STATE();
    case 296:
      if (lookahead == 'h') ADVANCE(352);
      if (lookahead == 'p') ADVANCE(366);
      END_STATE();
    case 297:
      if (lookahead == 'h') ADVANCE(352);
      if (lookahead == 'p') ADVANCE(366);
      if (lookahead == 'u') ADVANCE(432);
      END_STATE();
    case 298:
      if (lookahead == 'h') ADVANCE(1317);
      END_STATE();
    case 299:
      if (lookahead == 'h') ADVANCE(871);
      END_STATE();
    case 300:
      if (lookahead == 'h') ADVANCE(1273);
      END_STATE();
    case 301:
      if (lookahead == 'h') ADVANCE(836);
      END_STATE();
    case 302:
      if (lookahead == 'h') ADVANCE(854);
      END_STATE();
    case 303:
      if (lookahead == 'h') ADVANCE(1282);
      END_STATE();
    case 304:
      if (lookahead == 'h') ADVANCE(876);
      END_STATE();
    case 305:
      if (lookahead == 'h') ADVANCE(840);
      END_STATE();
    case 306:
      if (lookahead == 'h') ADVANCE(859);
      END_STATE();
    case 307:
      if (lookahead == 'h') ADVANCE(1281);
      END_STATE();
    case 308:
      if (lookahead == 'h') ADVANCE(1650);
      END_STATE();
    case 309:
      if (lookahead == 'h') ADVANCE(451);
      if (lookahead == 'r') ADVANCE(167);
      END_STATE();
    case 310:
      if (lookahead == 'h') ADVANCE(334);
      END_STATE();
    case 311:
      if (lookahead == 'h') ADVANCE(334);
      if (lookahead == 'o') ADVANCE(450);
      END_STATE();
    case 312:
      if (lookahead == 'i') ADVANCE(360);
      if (lookahead == 'o') ADVANCE(445);
      if (lookahead == 'u') ADVANCE(387);
      END_STATE();
    case 313:
      if (lookahead == 'i') ADVANCE(240);
      END_STATE();
    case 314:
      if (lookahead == 'i') ADVANCE(358);
      END_STATE();
    case 315:
      if (lookahead == 'i') ADVANCE(515);
      END_STATE();
    case 316:
      if (lookahead == 'i') ADVANCE(357);
      END_STATE();
    case 317:
      if (lookahead == 'i') ADVANCE(380);
      END_STATE();
    case 318:
      if (lookahead == 'i') ADVANCE(207);
      END_STATE();
    case 319:
      if (lookahead == 'i') ADVANCE(381);
      END_STATE();
    case 320:
      if (lookahead == 'i') ADVANCE(353);
      END_STATE();
    case 321:
      if (lookahead == 'i') ADVANCE(212);
      END_STATE();
    case 322:
      if (lookahead == 'i') ADVANCE(423);
      END_STATE();
    case 323:
      if (lookahead == 'i') ADVANCE(478);
      END_STATE();
    case 324:
      if (lookahead == 'i') ADVANCE(403);
      END_STATE();
    case 325:
      if (lookahead == 'i') ADVANCE(393);
      END_STATE();
    case 326:
      if (lookahead == 'i') ADVANCE(483);
      END_STATE();
    case 327:
      if (lookahead == 'i') ADVANCE(484);
      END_STATE();
    case 328:
      if (lookahead == 'i') ADVANCE(395);
      END_STATE();
    case 329:
      if (lookahead == 'i') ADVANCE(485);
      END_STATE();
    case 330:
      if (lookahead == 'i') ADVANCE(397);
      END_STATE();
    case 331:
      if (lookahead == 'i') ADVANCE(399);
      END_STATE();
    case 332:
      if (lookahead == 'i') ADVANCE(400);
      END_STATE();
    case 333:
      if (lookahead == 'i') ADVANCE(401);
      END_STATE();
    case 334:
      if (lookahead == 'i') ADVANCE(363);
      END_STATE();
    case 335:
      if (lookahead == 'i') ADVANCE(396);
      if (lookahead == 'o') ADVANCE(460);
      END_STATE();
    case 336:
      if (lookahead == 'i') ADVANCE(347);
      END_STATE();
    case 337:
      if (lookahead == 'i') ADVANCE(495);
      END_STATE();
    case 338:
      if (lookahead == 'i') ADVANCE(348);
      END_STATE();
    case 339:
      if (lookahead == 'i') ADVANCE(349);
      END_STATE();
    case 340:
      if (lookahead == 'i') ADVANCE(499);
      END_STATE();
    case 341:
      if (lookahead == 'j') ADVANCE(286);
      END_STATE();
    case 342:
      if (lookahead == 'k') ADVANCE(292);
      END_STATE();
    case 343:
      if (lookahead == 'k') ADVANCE(1301);
      END_STATE();
    case 344:
      if (lookahead == 'k') ADVANCE(259);
      END_STATE();
    case 345:
      if (lookahead == 'k') ADVANCE(262);
      END_STATE();
    case 346:
      if (lookahead == 'k') ADVANCE(263);
      END_STATE();
    case 347:
      if (lookahead == 'k') ADVANCE(264);
      END_STATE();
    case 348:
      if (lookahead == 'k') ADVANCE(268);
      END_STATE();
    case 349:
      if (lookahead == 'k') ADVANCE(270);
      END_STATE();
    case 350:
      if (lookahead == 'l') ADVANCE(471);
      if (lookahead == 'n') ADVANCE(235);
      if (lookahead == 'x') ADVANCE(323);
      END_STATE();
    case 351:
      if (lookahead == 'l') ADVANCE(471);
      if (lookahead == 'n') ADVANCE(234);
      END_STATE();
    case 352:
      if (lookahead == 'l') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(879);
      END_STATE();
    case 353:
      if (lookahead == 'l') ADVANCE(1294);
      END_STATE();
    case 354:
      if (lookahead == 'l') ADVANCE(521);
      END_STATE();
    case 355:
      if (lookahead == 'l') ADVANCE(1325);
      END_STATE();
    case 356:
      if (lookahead == 'l') ADVANCE(1279);
      END_STATE();
    case 357:
      if (lookahead == 'l') ADVANCE(241);
      END_STATE();
    case 358:
      if (lookahead == 'l') ADVANCE(258);
      END_STATE();
    case 359:
      if (lookahead == 'l') ADVANCE(412);
      END_STATE();
    case 360:
      if (lookahead == 'l') ADVANCE(492);
      if (lookahead == 'n') ADVANCE(172);
      END_STATE();
    case 361:
      if (lookahead == 'l') ADVANCE(354);
      END_STATE();
    case 362:
      if (lookahead == 'l') ADVANCE(180);
      END_STATE();
    case 363:
      if (lookahead == 'l') ADVANCE(261);
      END_STATE();
    case 364:
      if (lookahead == 'l') ADVANCE(279);
      END_STATE();
    case 365:
      if (lookahead == 'l') ADVANCE(281);
      END_STATE();
    case 366:
      if (lookahead == 'l') ADVANCE(326);
      END_STATE();
    case 367:
      if (lookahead == 'l') ADVANCE(364);
      if (lookahead == 'm') ADVANCE(1248);
      END_STATE();
    case 368:
      if (lookahead == 'l') ADVANCE(327);
      END_STATE();
    case 369:
      if (lookahead == 'l') ADVANCE(365);
      END_STATE();
    case 370:
      if (lookahead == 'l') ADVANCE(329);
      END_STATE();
    case 371:
      if (lookahead == 'l') ADVANCE(187);
      END_STATE();
    case 372:
      if (lookahead == 'l') ADVANCE(189);
      END_STATE();
    case 373:
      if (lookahead == 'm') ADVANCE(1586);
      END_STATE();
    case 374:
      if (lookahead == 'm') ADVANCE(1248);
      END_STATE();
    case 375:
      if (lookahead == 'm') ADVANCE(1255);
      END_STATE();
    case 376:
      if (lookahead == 'm') ADVANCE(378);
      END_STATE();
    case 377:
      if (lookahead == 'm') ADVANCE(321);
      END_STATE();
    case 378:
      if (lookahead == 'm') ADVANCE(181);
      END_STATE();
    case 379:
      if (lookahead == 'n') ADVANCE(1284);
      END_STATE();
    case 380:
      if (lookahead == 'n') ADVANCE(864);
      END_STATE();
    case 381:
      if (lookahead == 'n') ADVANCE(1257);
      END_STATE();
    case 382:
      if (lookahead == 'n') ADVANCE(874);
      END_STATE();
    case 383:
      if (lookahead == 'n') ADVANCE(1580);
      END_STATE();
    case 384:
      if (lookahead == 'n') ADVANCE(1307);
      END_STATE();
    case 385:
      if (lookahead == 'n') ADVANCE(1295);
      END_STATE();
    case 386:
      if (lookahead == 'n') ADVANCE(236);
      if (lookahead == 's') ADVANCE(828);
      END_STATE();
    case 387:
      if (lookahead == 'n') ADVANCE(229);
      END_STATE();
    case 388:
      if (lookahead == 'n') ADVANCE(419);
      END_STATE();
    case 389:
      if (lookahead == 'n') ADVANCE(498);
      END_STATE();
    case 390:
      if (lookahead == 'n') ADVANCE(237);
      END_STATE();
    case 391:
      if (lookahead == 'n') ADVANCE(474);
      END_STATE();
    case 392:
      if (lookahead == 'n') ADVANCE(490);
      END_STATE();
    case 393:
      if (lookahead == 'n') ADVANCE(463);
      END_STATE();
    case 394:
      if (lookahead == 'n') ADVANCE(165);
      END_STATE();
    case 395:
      if (lookahead == 'n') ADVANCE(464);
      END_STATE();
    case 396:
      if (lookahead == 'n') ADVANCE(172);
      END_STATE();
    case 397:
      if (lookahead == 'n') ADVANCE(465);
      END_STATE();
    case 398:
      if (lookahead == 'n') ADVANCE(239);
      END_STATE();
    case 399:
      if (lookahead == 'n') ADVANCE(466);
      END_STATE();
    case 400:
      if (lookahead == 'n') ADVANCE(467);
      END_STATE();
    case 401:
      if (lookahead == 'n') ADVANCE(468);
      END_STATE();
    case 402:
      if (lookahead == 'n') ADVANCE(494);
      END_STATE();
    case 403:
      if (lookahead == 'n') ADVANCE(514);
      END_STATE();
    case 404:
      if (lookahead == 'n') ADVANCE(225);
      END_STATE();
    case 405:
      if (lookahead == 'n') ADVANCE(505);
      END_STATE();
    case 406:
      if (lookahead == 'n') ADVANCE(506);
      END_STATE();
    case 407:
      if (lookahead == 'n') ADVANCE(507);
      END_STATE();
    case 408:
      if (lookahead == 'n') ADVANCE(508);
      END_STATE();
    case 409:
      if (lookahead == 'n') ADVANCE(509);
      END_STATE();
    case 410:
      if (lookahead == 'o') ADVANCE(1292);
      if (lookahead == 'y') ADVANCE(394);
      END_STATE();
    case 411:
      if (lookahead == 'o') ADVANCE(516);
      END_STATE();
    case 412:
      if (lookahead == 'o') ADVANCE(517);
      END_STATE();
    case 413:
      if (lookahead == 'o') ADVANCE(221);
      END_STATE();
    case 414:
      if (lookahead == 'o') ADVANCE(205);
      END_STATE();
    case 415:
      if (lookahead == 'o') ADVANCE(376);
      END_STATE();
    case 416:
      if (lookahead == 'o') ADVANCE(317);
      END_STATE();
    case 417:
      if (lookahead == 'o') ADVANCE(447);
      END_STATE();
    case 418:
      if (lookahead == 'o') ADVANCE(448);
      END_STATE();
    case 419:
      if (lookahead == 'o') ADVANCE(479);
      END_STATE();
    case 420:
      if (lookahead == 'o') ADVANCE(459);
      END_STATE();
    case 421:
      if (lookahead == 'o') ADVANCE(482);
      END_STATE();
    case 422:
      if (lookahead == 'o') ADVANCE(458);
      END_STATE();
    case 423:
      if (lookahead == 'o') ADVANCE(385);
      END_STATE();
    case 424:
      if (lookahead == 'o') ADVANCE(487);
      END_STATE();
    case 425:
      if (lookahead == 'o') ADVANCE(405);
      END_STATE();
    case 426:
      if (lookahead == 'o') ADVANCE(406);
      END_STATE();
    case 427:
      if (lookahead == 'o') ADVANCE(407);
      END_STATE();
    case 428:
      if (lookahead == 'o') ADVANCE(408);
      END_STATE();
    case 429:
      if (lookahead == 'o') ADVANCE(409);
      END_STATE();
    case 430:
      if (lookahead == 'p') ADVANCE(1313);
      END_STATE();
    case 431:
      if (lookahead == 'p') ADVANCE(366);
      END_STATE();
    case 432:
      if (lookahead == 'p') ADVANCE(434);
      END_STATE();
    case 433:
      if (lookahead == 'p') ADVANCE(362);
      END_STATE();
    case 434:
      if (lookahead == 'p') ADVANCE(420);
      END_STATE();
    case 435:
      if (lookahead == 'p') ADVANCE(184);
      END_STATE();
    case 436:
      if (lookahead == 'p') ADVANCE(368);
      END_STATE();
    case 437:
      if (lookahead == 'p') ADVANCE(371);
      END_STATE();
    case 438:
      if (lookahead == 'p') ADVANCE(372);
      END_STATE();
    case 439:
      if (lookahead == 'q') ADVANCE(844);
      END_STATE();
    case 440:
      if (lookahead == 'q') ADVANCE(844);
      if (lookahead == 'x') ADVANCE(178);
      END_STATE();
    case 441:
      if (lookahead == 'q') ADVANCE(830);
      END_STATE();
    case 442:
      if (lookahead == 'q') ADVANCE(848);
      END_STATE();
    case 443:
      if (lookahead == 'q') ADVANCE(513);
      END_STATE();
    case 444:
      if (lookahead == 'r') ADVANCE(1589);
      END_STATE();
    case 445:
      if (lookahead == 'r') ADVANCE(1286);
      END_STATE();
    case 446:
      if (lookahead == 'r') ADVANCE(1592);
      END_STATE();
    case 447:
      if (lookahead == 'r') ADVANCE(1590);
      END_STATE();
    case 448:
      if (lookahead == 'r') ADVANCE(1593);
      END_STATE();
    case 449:
      if (lookahead == 'r') ADVANCE(1297);
      END_STATE();
    case 450:
      if (lookahead == 'r') ADVANCE(342);
      END_STATE();
    case 451:
      if (lookahead == 'r') ADVANCE(411);
      END_STATE();
    case 452:
      if (lookahead == 'r') ADVANCE(238);
      END_STATE();
    case 453:
      if (lookahead == 'r') ADVANCE(162);
      END_STATE();
    case 454:
      if (lookahead == 'r') ADVANCE(384);
      END_STATE();
    case 455:
      if (lookahead == 'r') ADVANCE(174);
      END_STATE();
    case 456:
      if (lookahead == 'r') ADVANCE(169);
      END_STATE();
    case 457:
      if (lookahead == 'r') ADVANCE(173);
      END_STATE();
    case 458:
      if (lookahead == 'r') ADVANCE(287);
      END_STATE();
    case 459:
      if (lookahead == 'r') ADVANCE(496);
      END_STATE();
    case 460:
      if (lookahead == 'r') ADVANCE(1287);
      END_STATE();
    case 461:
      if (lookahead == 's') ADVANCE(1584);
      END_STATE();
    case 462:
      if (lookahead == 's') ADVANCE(1259);
      END_STATE();
    case 463:
      if (lookahead == 's') ADVANCE(841);
      END_STATE();
    case 464:
      if (lookahead == 's') ADVANCE(829);
      END_STATE();
    case 465:
      if (lookahead == 's') ADVANCE(847);
      END_STATE();
    case 466:
      if (lookahead == 's') ADVANCE(873);
      END_STATE();
    case 467:
      if (lookahead == 's') ADVANCE(838);
      END_STATE();
    case 468:
      if (lookahead == 's') ADVANCE(857);
      END_STATE();
    case 469:
      if (lookahead == 's') ADVANCE(461);
      END_STATE();
    case 470:
      if (lookahead == 's') ADVANCE(462);
      END_STATE();
    case 471:
      if (lookahead == 's') ADVANCE(257);
      END_STATE();
    case 472:
      if (lookahead == 's') ADVANCE(285);
      END_STATE();
    case 473:
      if (lookahead == 's') ADVANCE(282);
      END_STATE();
    case 474:
      if (lookahead == 's') ADVANCE(337);
      END_STATE();
    case 475:
      if (lookahead == 't') ADVANCE(206);
      END_STATE();
    case 476:
      if (lookahead == 't') ADVANCE(512);
      END_STATE();
    case 477:
      if (lookahead == 't') ADVANCE(1615);
      END_STATE();
    case 478:
      if (lookahead == 't') ADVANCE(1309);
      END_STATE();
    case 479:
      if (lookahead == 't') ADVANCE(1622);
      END_STATE();
    case 480:
      if (lookahead == 't') ADVANCE(232);
      END_STATE();
    case 481:
      if (lookahead == 't') ADVANCE(1277);
      END_STATE();
    case 482:
      if (lookahead == 't') ADVANCE(862);
      END_STATE();
    case 483:
      if (lookahead == 't') ADVANCE(880);
      END_STATE();
    case 484:
      if (lookahead == 't') ADVANCE(843);
      END_STATE();
    case 485:
      if (lookahead == 't') ADVANCE(863);
      END_STATE();
    case 486:
      if (lookahead == 't') ADVANCE(1575);
      END_STATE();
    case 487:
      if (lookahead == 't') ADVANCE(1614);
      END_STATE();
    case 488:
      if (lookahead == 't') ADVANCE(231);
      END_STATE();
    case 489:
      if (lookahead == 't') ADVANCE(161);
      END_STATE();
    case 490:
      if (lookahead == 't') ADVANCE(324);
      END_STATE();
    case 491:
      if (lookahead == 't') ADVANCE(318);
      END_STATE();
    case 492:
      if (lookahead == 't') ADVANCE(278);
      END_STATE();
    case 493:
      if (lookahead == 't') ADVANCE(322);
      END_STATE();
    case 494:
      if (lookahead == 't') ADVANCE(183);
      END_STATE();
    case 495:
      if (lookahead == 't') ADVANCE(315);
      END_STATE();
    case 496:
      if (lookahead == 't') ADVANCE(276);
      END_STATE();
    case 497:
      if (lookahead == 't') ADVANCE(208);
      END_STATE();
    case 498:
      if (lookahead == 't') ADVANCE(320);
      END_STATE();
    case 499:
      if (lookahead == 't') ADVANCE(209);
      END_STATE();
    case 500:
      if (lookahead == 't') ADVANCE(210);
      END_STATE();
    case 501:
      if (lookahead == 't') ADVANCE(213);
      END_STATE();
    case 502:
      if (lookahead == 't') ADVANCE(215);
      END_STATE();
    case 503:
      if (lookahead == 't') ADVANCE(216);
      END_STATE();
    case 504:
      if (lookahead == 't') ADVANCE(217);
      END_STATE();
    case 505:
      if (lookahead == 't') ADVANCE(185);
      END_STATE();
    case 506:
      if (lookahead == 't') ADVANCE(188);
      END_STATE();
    case 507:
      if (lookahead == 't') ADVANCE(190);
      END_STATE();
    case 508:
      if (lookahead == 't') ADVANCE(192);
      END_STATE();
    case 509:
      if (lookahead == 't') ADVANCE(193);
      END_STATE();
    case 510:
      if (lookahead == 't') ADVANCE(233);
      END_STATE();
    case 511:
      if (lookahead == 'u') ADVANCE(432);
      END_STATE();
    case 512:
      if (lookahead == 'u') ADVANCE(454);
      END_STATE();
    case 513:
      if (lookahead == 'u') ADVANCE(280);
      END_STATE();
    case 514:
      if (lookahead == 'u') ADVANCE(266);
      END_STATE();
    case 515:
      if (lookahead == 'v') ADVANCE(272);
      END_STATE();
    case 516:
      if (lookahead == 'w') ADVANCE(1305);
      END_STATE();
    case 517:
      if (lookahead == 'w') ADVANCE(1299);
      END_STATE();
    case 518:
      if (lookahead == 'w') ADVANCE(340);
      END_STATE();
    case 519:
      if (lookahead == 'x') ADVANCE(1275);
      END_STATE();
    case 520:
      if (lookahead == 'x') ADVANCE(178);
      END_STATE();
    case 521:
      if (lookahead == 'y') ADVANCE(1319);
      END_STATE();
    case 522:
      if (lookahead == '}') ADVANCE(1129);
      if (lookahead != 0) ADVANCE(522);
      END_STATE();
    case 523:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(525);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(616);
      END_STATE();
    case 524:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(611);
      END_STATE();
    case 525:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(616);
      END_STATE();
    case 526:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(596);
      END_STATE();
    case 527:
      if (lookahead != 0 &&
          lookahead != '}') ADVANCE(522);
      END_STATE();
    case 528:
      if (lookahead != 0) ADVANCE(117);
      END_STATE();
    case 529:
      if (lookahead != 0) ADVANCE(671);
      END_STATE();
    case 530:
      if (eof) ADVANCE(545);
      if (lookahead == '\n') SKIP(537);
      END_STATE();
    case 531:
      if (eof) ADVANCE(545);
      if (lookahead == '\n') SKIP(540);
      END_STATE();
    case 532:
      if (eof) ADVANCE(545);
      if (lookahead == '\n') SKIP(539);
      END_STATE();
    case 533:
      if (eof) ADVANCE(545);
      if (lookahead == '\n') SKIP(541);
      END_STATE();
    case 534:
      if (eof) ADVANCE(545);
      if (lookahead == '\n') SKIP(542);
      END_STATE();
    case 535:
      if (eof) ADVANCE(545);
      if (lookahead == '\n') SKIP(543);
      END_STATE();
    case 536:
      if (eof) ADVANCE(545);
      if (lookahead == '\n') SKIP(544);
      END_STATE();
    case 537:
      if (eof) ADVANCE(545);
      ADVANCE_MAP(
        '!', 1620,
        '"', 1347,
        '#', 557,
        '$', 1346,
        '%', 1574,
        '&', 1330,
        '(', 1250,
        ')', 1251,
        '*', 1612,
        '+', 1595,
        ',', 1253,
        '-', 1598,
        '.', 747,
        '/', 1609,
        '0', 569,
        '1', 563,
        '2', 564,
        '3', 565,
        '4', 566,
        '5', 567,
        '6', 568,
        ':', 1570,
        ';', 1247,
        '<', 801,
        '=', 753,
        '>', 759,
        '@', 96,
        '[', 750,
        '\\', 1610,
        ']', 1649,
      );
      if (lookahead == '`') SKIP(530);
      if (lookahead == 'b') ADVANCE(245);
      if (lookahead == 'c') ADVANCE(160);
      if (lookahead == 'd') ADVANCE(163);
      if (lookahead == 'e') ADVANCE(350);
      if (lookahead == 'f') ADVANCE(312);
      if (lookahead == 'h') ADVANCE(313);
      if (lookahead == 'i') ADVANCE(290);
      if (lookahead == 'p') ADVANCE(166);
      if (lookahead == 'r') ADVANCE(274);
      if (lookahead == 's') ADVANCE(246);
      if (lookahead == 't') ADVANCE(309);
      if (lookahead == 'u') ADVANCE(389);
      if (lookahead == 'w') ADVANCE(311);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '|') ADVANCE(1329);
      if (lookahead == '}') ADVANCE(1265);
      if (('7' <= lookahead && lookahead <= '9')) ADVANCE(570);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(537);
      END_STATE();
    case 538:
      if (eof) ADVANCE(545);
      ADVANCE_MAP(
        '!', 1620,
        '"', 624,
        '#', 557,
        '$', 120,
        '%', 1574,
        '\'', 124,
        '(', 1250,
        ')', 1251,
        '*', 1612,
        '+', 1595,
        ',', 1253,
        '-', 1599,
        '.', 1643,
        '/', 1609,
        '0', 569,
        '1', 563,
        '2', 564,
        '3', 565,
        '4', 566,
        '5', 567,
        '6', 568,
        ':', 140,
        '<', 801,
        '=', 753,
        '>', 759,
        '@', 96,
        '[', 750,
        '\\', 1610,
        ']', 1649,
      );
      if (lookahead == '`') SKIP(532);
      if (lookahead == 'b') ADVANCE(244);
      if (lookahead == 'c') ADVANCE(159);
      if (lookahead == 'd') ADVANCE(410);
      if (lookahead == 'e') ADVANCE(351);
      if (lookahead == 'f') ADVANCE(335);
      if (lookahead == 'i') ADVANCE(379);
      if (lookahead == 'p') ADVANCE(186);
      if (lookahead == 's') ADVANCE(518);
      if (lookahead == 'u') ADVANCE(389);
      if (lookahead == 'w') ADVANCE(310);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '|') ADVANCE(1329);
      if (lookahead == '}') ADVANCE(1265);
      if (('7' <= lookahead && lookahead <= '9')) ADVANCE(570);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(539);
      END_STATE();
    case 539:
      if (eof) ADVANCE(545);
      ADVANCE_MAP(
        '!', 1620,
        '"', 624,
        '#', 557,
        '$', 120,
        '%', 1574,
        '\'', 124,
        '(', 1250,
        ')', 1251,
        '*', 1612,
        '+', 1595,
        ',', 1253,
        '-', 1599,
        '.', 132,
        '/', 1609,
        '0', 569,
        '1', 563,
        '2', 564,
        '3', 565,
        '4', 566,
        '5', 567,
        '6', 568,
        ':', 140,
        '<', 801,
        '=', 753,
        '>', 759,
        '@', 96,
        '[', 750,
        '\\', 1610,
        ']', 1649,
      );
      if (lookahead == '`') SKIP(532);
      if (lookahead == 'b') ADVANCE(244);
      if (lookahead == 'c') ADVANCE(159);
      if (lookahead == 'd') ADVANCE(410);
      if (lookahead == 'e') ADVANCE(351);
      if (lookahead == 'f') ADVANCE(335);
      if (lookahead == 'i') ADVANCE(379);
      if (lookahead == 'p') ADVANCE(186);
      if (lookahead == 's') ADVANCE(518);
      if (lookahead == 'u') ADVANCE(389);
      if (lookahead == 'w') ADVANCE(310);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '|') ADVANCE(1329);
      if (lookahead == '}') ADVANCE(1265);
      if (('7' <= lookahead && lookahead <= '9')) ADVANCE(570);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(539);
      END_STATE();
    case 540:
      if (eof) ADVANCE(545);
      ADVANCE_MAP(
        '!', 1619,
        '"', 624,
        '#', 552,
        '$', 120,
        '%', 1573,
        '&', 1330,
        '\'', 124,
        '(', 1250,
        ')', 1251,
        '+', 1594,
        ',', 1253,
        '-', 1601,
        '.', 748,
        '0', 571,
        ':', 1513,
        ';', 1247,
        '<', 115,
        '@', 96,
        '[', 750,
      );
      if (lookahead == '`') SKIP(531);
      if (lookahead == 'b') ADVANCE(1480);
      if (lookahead == 'c') ADVANCE(1441);
      if (lookahead == 'd') ADVANCE(1370);
      if (lookahead == 'e') ADVANCE(1456);
      if (lookahead == 'f') ADVANCE(1426);
      if (lookahead == 'i') ADVANCE(1416);
      if (lookahead == 'p') ADVANCE(1387);
      if (lookahead == 'r') ADVANCE(1408);
      if (lookahead == 's') ADVANCE(1401);
      if (lookahead == 't') ADVANCE(1425);
      if (lookahead == 'w') ADVANCE(1424);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '}') ADVANCE(1265);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(540);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(572);
      if (lookahead != 0 &&
          (lookahead < ' ' || '<' < lookahead) &&
          lookahead != ']' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 541:
      if (eof) ADVANCE(545);
      ADVANCE_MAP(
        '!', 1619,
        '"', 624,
        '#', 552,
        '$', 120,
        '%', 1573,
        '&', 1330,
        '\'', 124,
        '(', 1250,
        ')', 1251,
        '+', 1594,
        ',', 1253,
        '-', 1601,
        '.', 748,
        '0', 571,
        ':', 1513,
        ';', 1247,
        '<', 115,
        '@', 96,
        '[', 750,
      );
      if (lookahead == '`') SKIP(533);
      if (lookahead == 'b') ADVANCE(1480);
      if (lookahead == 'c') ADVANCE(1384);
      if (lookahead == 'd') ADVANCE(1370);
      if (lookahead == 'e') ADVANCE(1456);
      if (lookahead == 'f') ADVANCE(1427);
      if (lookahead == 'i') ADVANCE(1416);
      if (lookahead == 'p') ADVANCE(1387);
      if (lookahead == 'r') ADVANCE(1408);
      if (lookahead == 's') ADVANCE(1401);
      if (lookahead == 't') ADVANCE(1425);
      if (lookahead == 'w') ADVANCE(1424);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '}') ADVANCE(1265);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1355);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(541);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(572);
      if (lookahead != 0 &&
          (lookahead < ' ' || '<' < lookahead) &&
          lookahead != ']' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 542:
      if (eof) ADVANCE(545);
      ADVANCE_MAP(
        '!', 1619,
        '"', 624,
        '#', 552,
        '$', 120,
        '%', 1573,
        '&', 1330,
        '\'', 124,
        '(', 1250,
        ')', 1251,
        '+', 1594,
        ',', 1253,
        '-', 1601,
        '.', 748,
        '0', 571,
        ':', 1513,
        ';', 1247,
        '<', 115,
        '@', 96,
        '[', 750,
      );
      if (lookahead == '`') SKIP(534);
      if (lookahead == 'b') ADVANCE(1480);
      if (lookahead == 'c') ADVANCE(1441);
      if (lookahead == 'd') ADVANCE(1370);
      if (lookahead == 'e') ADVANCE(1446);
      if (lookahead == 'f') ADVANCE(1426);
      if (lookahead == 'i') ADVANCE(1416);
      if (lookahead == 'p') ADVANCE(1387);
      if (lookahead == 'r') ADVANCE(1408);
      if (lookahead == 's') ADVANCE(1401);
      if (lookahead == 't') ADVANCE(1425);
      if (lookahead == 'w') ADVANCE(1424);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '}') ADVANCE(1265);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1353);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(542);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(572);
      if (lookahead != 0 &&
          (lookahead < ' ' || '<' < lookahead) &&
          lookahead != ']' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 543:
      if (eof) ADVANCE(545);
      ADVANCE_MAP(
        '!', 1619,
        '"', 624,
        '#', 552,
        '$', 120,
        '%', 1573,
        '&', 1330,
        '\'', 124,
        '(', 1250,
        ')', 1251,
        '+', 1594,
        ',', 1253,
        '-', 1601,
        '.', 748,
        '0', 571,
        ':', 1513,
        ';', 1247,
        '<', 115,
        '@', 96,
        '[', 750,
      );
      if (lookahead == '`') SKIP(535);
      if (lookahead == 'b') ADVANCE(1480);
      if (lookahead == 'c') ADVANCE(1441);
      if (lookahead == 'd') ADVANCE(1370);
      if (lookahead == 'e') ADVANCE(1456);
      if (lookahead == 'f') ADVANCE(1427);
      if (lookahead == 'i') ADVANCE(1416);
      if (lookahead == 'p') ADVANCE(1387);
      if (lookahead == 'r') ADVANCE(1408);
      if (lookahead == 's') ADVANCE(1401);
      if (lookahead == 't') ADVANCE(1425);
      if (lookahead == 'w') ADVANCE(1424);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '}') ADVANCE(1265);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1352);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(543);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(572);
      if (lookahead != 0 &&
          (lookahead < ' ' || '<' < lookahead) &&
          lookahead != ']' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 544:
      if (eof) ADVANCE(545);
      ADVANCE_MAP(
        '!', 1619,
        '"', 624,
        '#', 552,
        '$', 120,
        '%', 1573,
        '&', 1330,
        '\'', 124,
        '(', 1250,
        ')', 1251,
        '+', 1594,
        ',', 1253,
        '-', 1601,
        '.', 748,
        '0', 571,
        ':', 1513,
        ';', 1247,
        '<', 115,
        '@', 96,
        '[', 750,
      );
      if (lookahead == '`') SKIP(536);
      if (lookahead == 'b') ADVANCE(1480);
      if (lookahead == 'c') ADVANCE(1441);
      if (lookahead == 'd') ADVANCE(1370);
      if (lookahead == 'e') ADVANCE(1452);
      if (lookahead == 'f') ADVANCE(1426);
      if (lookahead == 'i') ADVANCE(1416);
      if (lookahead == 'p') ADVANCE(1387);
      if (lookahead == 'r') ADVANCE(1408);
      if (lookahead == 's') ADVANCE(1401);
      if (lookahead == 't') ADVANCE(1425);
      if (lookahead == 'w') ADVANCE(1424);
      if (lookahead == '{') ADVANCE(1263);
      if (lookahead == '}') ADVANCE(1265);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1354);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(544);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(572);
      if (lookahead != 0 &&
          (lookahead < ' ' || '<' < lookahead) &&
          lookahead != ']' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 547:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n') ADVANCE(99);
      if (lookahead == '"') ADVANCE(679);
      if (lookahead == '#') ADVANCE(547);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(547);
      if (lookahead != 0) ADVANCE(557);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n') ADVANCE(1338);
      if (lookahead == '"' ||
          lookahead == '$' ||
          lookahead == '`') ADVANCE(557);
      if (lookahead != 0) ADVANCE(548);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '|') ADVANCE(557);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(549);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(557);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(550);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ',' ||
          lookahead == ';' ||
          lookahead == '|' ||
          lookahead == '}') ADVANCE(557);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(551);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          (' ' <= lookahead && lookahead <= '"') ||
          ('$' <= lookahead && lookahead <= '-') ||
          lookahead == '/' ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '@' ||
          lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '}')) ADVANCE(557);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(552);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 555:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '`') ADVANCE(1338);
      END_STATE();
    case 556:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '|') ADVANCE(1246);
      END_STATE();
    case 557:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(557);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      ADVANCE_MAP(
        '-', 1563,
        '.', 1365,
        'e', 1361,
        'g', 1362,
        'k', 1362,
        'm', 1362,
        'p', 1362,
        't', 1362,
        'x', 1366,
        'd', 561,
        'l', 561,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(560);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1367);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < '$' || '9' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '?' || ']' < lookahead) &&
          (lookahead < '_' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 560:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      ADVANCE_MAP(
        '-', 1563,
        '.', 1365,
        'e', 1361,
        'g', 1362,
        'k', 1362,
        'm', 1362,
        'p', 1362,
        't', 1362,
        'd', 561,
        'l', 561,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(560);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1367);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < '$' || '9' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '?' || ']' < lookahead) &&
          (lookahead < '_' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      if (lookahead == '-') ADVANCE(1563);
      if (lookahead == 'g') ADVANCE(1362);
      if (lookahead == 'k') ADVANCE(1362);
      if (lookahead == 'm') ADVANCE(1362);
      if (lookahead == 'p') ADVANCE(1362);
      if (lookahead == 't') ADVANCE(1362);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1367);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < '$' || '9' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '?' || ']' < lookahead) &&
          (lookahead < '_' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 562:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      if (lookahead == '-') ADVANCE(1563);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1367);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < '$' || '9' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '?' || ']' < lookahead) &&
          (lookahead < '_' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      ADVANCE_MAP(
        '.', 524,
        '>', 122,
        'e', 523,
        'g', 202,
        'k', 202,
        'm', 202,
        'p', 202,
        't', 202,
        'd', 583,
        'l', 583,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(570);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      ADVANCE_MAP(
        '.', 524,
        '>', 765,
        'e', 523,
        'g', 202,
        'k', 202,
        'm', 202,
        'p', 202,
        't', 202,
        'd', 583,
        'l', 583,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(570);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      ADVANCE_MAP(
        '.', 524,
        '>', 771,
        'e', 523,
        'g', 202,
        'k', 202,
        'm', 202,
        'p', 202,
        't', 202,
        'd', 583,
        'l', 583,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(570);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      ADVANCE_MAP(
        '.', 524,
        '>', 777,
        'e', 523,
        'g', 202,
        'k', 202,
        'm', 202,
        'p', 202,
        't', 202,
        'd', 583,
        'l', 583,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(570);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      ADVANCE_MAP(
        '.', 524,
        '>', 783,
        'e', 523,
        'g', 202,
        'k', 202,
        'm', 202,
        'p', 202,
        't', 202,
        'd', 583,
        'l', 583,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(570);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      ADVANCE_MAP(
        '.', 524,
        '>', 789,
        'e', 523,
        'g', 202,
        'k', 202,
        'm', 202,
        'p', 202,
        't', 202,
        'd', 583,
        'l', 583,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(570);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      ADVANCE_MAP(
        '.', 524,
        'e', 523,
        'g', 202,
        'k', 202,
        'm', 202,
        'p', 202,
        't', 202,
        'x', 526,
        'd', 583,
        'l', 583,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(570);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      ADVANCE_MAP(
        '.', 524,
        'e', 523,
        'g', 202,
        'k', 202,
        'm', 202,
        'p', 202,
        't', 202,
        'd', 583,
        'l', 583,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(570);
      END_STATE();
    case 571:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      ADVANCE_MAP(
        '.', 1511,
        'e', 1510,
        'g', 1388,
        'k', 1388,
        'm', 1388,
        'p', 1388,
        't', 1388,
        'x', 1512,
        'd', 586,
        'l', 586,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(572);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      ADVANCE_MAP(
        '.', 1511,
        'e', 1510,
        'g', 1388,
        'k', 1388,
        'm', 1388,
        'p', 1388,
        't', 1388,
        'd', 586,
        'l', 586,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(572);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 573:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      ADVANCE_MAP(
        '.', 1184,
        '>', 1140,
        'e', 1183,
        'g', 1155,
        'k', 1155,
        'm', 1155,
        'p', 1155,
        't', 1155,
        'd', 587,
        'l', 587,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(580);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 574:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      ADVANCE_MAP(
        '.', 1184,
        '>', 767,
        'e', 1183,
        'g', 1155,
        'k', 1155,
        'm', 1155,
        'p', 1155,
        't', 1155,
        'd', 587,
        'l', 587,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(580);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 575:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      ADVANCE_MAP(
        '.', 1184,
        '>', 773,
        'e', 1183,
        'g', 1155,
        'k', 1155,
        'm', 1155,
        'p', 1155,
        't', 1155,
        'd', 587,
        'l', 587,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(580);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      ADVANCE_MAP(
        '.', 1184,
        '>', 779,
        'e', 1183,
        'g', 1155,
        'k', 1155,
        'm', 1155,
        'p', 1155,
        't', 1155,
        'd', 587,
        'l', 587,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(580);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 577:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      ADVANCE_MAP(
        '.', 1184,
        '>', 785,
        'e', 1183,
        'g', 1155,
        'k', 1155,
        'm', 1155,
        'p', 1155,
        't', 1155,
        'd', 587,
        'l', 587,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(580);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      ADVANCE_MAP(
        '.', 1184,
        '>', 791,
        'e', 1183,
        'g', 1155,
        'k', 1155,
        'm', 1155,
        'p', 1155,
        't', 1155,
        'd', 587,
        'l', 587,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(580);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 579:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      ADVANCE_MAP(
        '.', 1184,
        'e', 1183,
        'g', 1155,
        'k', 1155,
        'm', 1155,
        'p', 1155,
        't', 1155,
        'x', 1189,
        'd', 587,
        'l', 587,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(580);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      ADVANCE_MAP(
        '.', 1184,
        'e', 1183,
        'g', 1155,
        'k', 1155,
        'm', 1155,
        'p', 1155,
        't', 1155,
        'd', 587,
        'l', 587,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(580);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 581:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      ADVANCE_MAP(
        '.', 1210,
        'e', 1209,
        'g', 1206,
        'k', 1206,
        'm', 1206,
        'p', 1206,
        't', 1206,
        'x', 1213,
        'd', 588,
        'l', 588,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(582);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 582:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      ADVANCE_MAP(
        '.', 1210,
        'e', 1209,
        'g', 1206,
        'k', 1206,
        'm', 1206,
        'p', 1206,
        't', 1206,
        'd', 588,
        'l', 588,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(582);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      if (lookahead == 'g') ADVANCE(202);
      if (lookahead == 'k') ADVANCE(202);
      if (lookahead == 'm') ADVANCE(202);
      if (lookahead == 'p') ADVANCE(202);
      if (lookahead == 't') ADVANCE(202);
      END_STATE();
    case 584:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      ADVANCE_MAP(
        'g', 202,
        'k', 202,
        'm', 202,
        'p', 202,
        't', 202,
        'x', 526,
        'd', 583,
        'l', 583,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(585);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      if (lookahead == 'g') ADVANCE(202);
      if (lookahead == 'k') ADVANCE(202);
      if (lookahead == 'm') ADVANCE(202);
      if (lookahead == 'p') ADVANCE(202);
      if (lookahead == 't') ADVANCE(202);
      if (lookahead == 'd' ||
          lookahead == 'l') ADVANCE(583);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(585);
      END_STATE();
    case 586:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      if (lookahead == 'g') ADVANCE(1388);
      if (lookahead == 'k') ADVANCE(1388);
      if (lookahead == 'm') ADVANCE(1388);
      if (lookahead == 'p') ADVANCE(1388);
      if (lookahead == 't') ADVANCE(1388);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 587:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      if (lookahead == 'g') ADVANCE(1155);
      if (lookahead == 'k') ADVANCE(1155);
      if (lookahead == 'm') ADVANCE(1155);
      if (lookahead == 'p') ADVANCE(1155);
      if (lookahead == 't') ADVANCE(1155);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      if (lookahead == 'g') ADVANCE(1206);
      if (lookahead == 'k') ADVANCE(1206);
      if (lookahead == 'm') ADVANCE(1206);
      if (lookahead == 'p') ADVANCE(1206);
      if (lookahead == 't') ADVANCE(1206);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(sym_hexadecimal_integer_literal);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(sym_hexadecimal_integer_literal);
      if (lookahead == '-') ADVANCE(1563);
      if (lookahead == 'g') ADVANCE(1364);
      if (lookahead == 'k') ADVANCE(1364);
      if (lookahead == 'l') ADVANCE(594);
      if (lookahead == 'm') ADVANCE(1364);
      if (lookahead == 'p') ADVANCE(1364);
      if (lookahead == 't') ADVANCE(1364);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(593);
      if (lookahead == '.' ||
          lookahead == '?' ||
          ('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(1367);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < '$' || '9' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '?' || ']' < lookahead) &&
          (lookahead < '_' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(sym_hexadecimal_integer_literal);
      if (lookahead == '-') ADVANCE(1563);
      if (lookahead == 'g') ADVANCE(1364);
      if (lookahead == 'k') ADVANCE(1364);
      if (lookahead == 'm') ADVANCE(1364);
      if (lookahead == 'p') ADVANCE(1364);
      if (lookahead == 't') ADVANCE(1364);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1367);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < '$' || '9' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '?' || ']' < lookahead) &&
          (lookahead < '_' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(sym_hexadecimal_integer_literal);
      if (lookahead == '-') ADVANCE(1563);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1367);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < '$' || '9' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '?' || ']' < lookahead) &&
          (lookahead < '_' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(sym_hexadecimal_integer_literal);
      if (lookahead == 'g') ADVANCE(204);
      if (lookahead == 'k') ADVANCE(204);
      if (lookahead == 'l') ADVANCE(597);
      if (lookahead == 'm') ADVANCE(204);
      if (lookahead == 'p') ADVANCE(204);
      if (lookahead == 't') ADVANCE(204);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(596);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(sym_hexadecimal_integer_literal);
      if (lookahead == 'g') ADVANCE(204);
      if (lookahead == 'k') ADVANCE(204);
      if (lookahead == 'm') ADVANCE(204);
      if (lookahead == 'p') ADVANCE(204);
      if (lookahead == 't') ADVANCE(204);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(sym_hexadecimal_integer_literal);
      if (lookahead == 'g') ADVANCE(1390);
      if (lookahead == 'k') ADVANCE(1390);
      if (lookahead == 'l') ADVANCE(599);
      if (lookahead == 'm') ADVANCE(1390);
      if (lookahead == 'p') ADVANCE(1390);
      if (lookahead == 't') ADVANCE(1390);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(598);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(sym_hexadecimal_integer_literal);
      if (lookahead == 'g') ADVANCE(1390);
      if (lookahead == 'k') ADVANCE(1390);
      if (lookahead == 'm') ADVANCE(1390);
      if (lookahead == 'p') ADVANCE(1390);
      if (lookahead == 't') ADVANCE(1390);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 600:
      ACCEPT_TOKEN(sym_hexadecimal_integer_literal);
      if (lookahead == 'g') ADVANCE(1157);
      if (lookahead == 'k') ADVANCE(1157);
      if (lookahead == 'l') ADVANCE(601);
      if (lookahead == 'm') ADVANCE(1157);
      if (lookahead == 'p') ADVANCE(1157);
      if (lookahead == 't') ADVANCE(1157);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(600);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 601:
      ACCEPT_TOKEN(sym_hexadecimal_integer_literal);
      if (lookahead == 'g') ADVANCE(1157);
      if (lookahead == 'k') ADVANCE(1157);
      if (lookahead == 'm') ADVANCE(1157);
      if (lookahead == 'p') ADVANCE(1157);
      if (lookahead == 't') ADVANCE(1157);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 602:
      ACCEPT_TOKEN(sym_hexadecimal_integer_literal);
      if (lookahead == 'g') ADVANCE(1208);
      if (lookahead == 'k') ADVANCE(1208);
      if (lookahead == 'l') ADVANCE(603);
      if (lookahead == 'm') ADVANCE(1208);
      if (lookahead == 'p') ADVANCE(1208);
      if (lookahead == 't') ADVANCE(1208);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(602);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(sym_hexadecimal_integer_literal);
      if (lookahead == 'g') ADVANCE(1208);
      if (lookahead == 'k') ADVANCE(1208);
      if (lookahead == 'm') ADVANCE(1208);
      if (lookahead == 'p') ADVANCE(1208);
      if (lookahead == 't') ADVANCE(1208);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 604:
      ACCEPT_TOKEN(sym_hexadecimal_integer_literal);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 605:
      ACCEPT_TOKEN(sym_hexadecimal_integer_literal);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 606:
      ACCEPT_TOKEN(sym_hexadecimal_integer_literal);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 607:
      ACCEPT_TOKEN(sym_real_literal);
      END_STATE();
    case 608:
      ACCEPT_TOKEN(sym_real_literal);
      if (lookahead == '-') ADVANCE(1563);
      if (lookahead == 'e') ADVANCE(1361);
      if (lookahead == 'g') ADVANCE(1363);
      if (lookahead == 'k') ADVANCE(1363);
      if (lookahead == 'm') ADVANCE(1363);
      if (lookahead == 'p') ADVANCE(1363);
      if (lookahead == 't') ADVANCE(1363);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(608);
      if (lookahead == '.' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1367);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < '$' || '9' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '?' || ']' < lookahead) &&
          (lookahead < '_' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 609:
      ACCEPT_TOKEN(sym_real_literal);
      if (lookahead == '-') ADVANCE(1563);
      if (lookahead == 'g') ADVANCE(1363);
      if (lookahead == 'k') ADVANCE(1363);
      if (lookahead == 'm') ADVANCE(1363);
      if (lookahead == 'p') ADVANCE(1363);
      if (lookahead == 't') ADVANCE(1363);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(609);
      if (lookahead == '.' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1367);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < '$' || '9' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '?' || ']' < lookahead) &&
          (lookahead < '_' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 610:
      ACCEPT_TOKEN(sym_real_literal);
      if (lookahead == '-') ADVANCE(1563);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1367);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < '$' || '9' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '?' || ']' < lookahead) &&
          (lookahead < '_' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 611:
      ACCEPT_TOKEN(sym_real_literal);
      if (lookahead == 'e') ADVANCE(523);
      if (lookahead == 'g') ADVANCE(203);
      if (lookahead == 'k') ADVANCE(203);
      if (lookahead == 'm') ADVANCE(203);
      if (lookahead == 'p') ADVANCE(203);
      if (lookahead == 't') ADVANCE(203);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(611);
      END_STATE();
    case 612:
      ACCEPT_TOKEN(sym_real_literal);
      if (lookahead == 'e') ADVANCE(1510);
      if (lookahead == 'g') ADVANCE(1389);
      if (lookahead == 'k') ADVANCE(1389);
      if (lookahead == 'm') ADVANCE(1389);
      if (lookahead == 'p') ADVANCE(1389);
      if (lookahead == 't') ADVANCE(1389);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(612);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 613:
      ACCEPT_TOKEN(sym_real_literal);
      if (lookahead == 'e') ADVANCE(1183);
      if (lookahead == 'g') ADVANCE(1156);
      if (lookahead == 'k') ADVANCE(1156);
      if (lookahead == 'm') ADVANCE(1156);
      if (lookahead == 'p') ADVANCE(1156);
      if (lookahead == 't') ADVANCE(1156);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(613);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 614:
      ACCEPT_TOKEN(sym_real_literal);
      if (lookahead == 'e') ADVANCE(1209);
      if (lookahead == 'g') ADVANCE(1207);
      if (lookahead == 'k') ADVANCE(1207);
      if (lookahead == 'm') ADVANCE(1207);
      if (lookahead == 'p') ADVANCE(1207);
      if (lookahead == 't') ADVANCE(1207);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(614);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 615:
      ACCEPT_TOKEN(sym_real_literal);
      if (lookahead == 'g') ADVANCE(1556);
      if (lookahead == 'k') ADVANCE(1556);
      if (lookahead == 'm') ADVANCE(1556);
      if (lookahead == 'p') ADVANCE(1556);
      if (lookahead == 't') ADVANCE(1556);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(615);
      if (lookahead == '-' ||
          lookahead == '.' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 616:
      ACCEPT_TOKEN(sym_real_literal);
      if (lookahead == 'g') ADVANCE(203);
      if (lookahead == 'k') ADVANCE(203);
      if (lookahead == 'm') ADVANCE(203);
      if (lookahead == 'p') ADVANCE(203);
      if (lookahead == 't') ADVANCE(203);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(616);
      END_STATE();
    case 617:
      ACCEPT_TOKEN(sym_real_literal);
      if (lookahead == 'g') ADVANCE(1389);
      if (lookahead == 'k') ADVANCE(1389);
      if (lookahead == 'm') ADVANCE(1389);
      if (lookahead == 'p') ADVANCE(1389);
      if (lookahead == 't') ADVANCE(1389);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(617);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 618:
      ACCEPT_TOKEN(sym_real_literal);
      if (lookahead == 'g') ADVANCE(1156);
      if (lookahead == 'k') ADVANCE(1156);
      if (lookahead == 'm') ADVANCE(1156);
      if (lookahead == 'p') ADVANCE(1156);
      if (lookahead == 't') ADVANCE(1156);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(618);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 619:
      ACCEPT_TOKEN(sym_real_literal);
      if (lookahead == 'g') ADVANCE(1207);
      if (lookahead == 'k') ADVANCE(1207);
      if (lookahead == 'm') ADVANCE(1207);
      if (lookahead == 'p') ADVANCE(1207);
      if (lookahead == 't') ADVANCE(1207);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(619);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 620:
      ACCEPT_TOKEN(sym_real_literal);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 621:
      ACCEPT_TOKEN(sym_real_literal);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 622:
      ACCEPT_TOKEN(sym_real_literal);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 623:
      ACCEPT_TOKEN(sym_real_literal);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 624:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token1);
      if (lookahead == '#') ADVANCE(624);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(624);
      END_STATE();
    case 625:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token1);
      if (lookahead == '#') ADVANCE(625);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(624);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 626:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token1);
      if (lookahead == '#') ADVANCE(626);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(624);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 627:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == '\n') ADVANCE(670);
      if (lookahead == '"' ||
          lookahead == '$' ||
          lookahead == '`') ADVANCE(557);
      if (lookahead != 0) ADVANCE(627);
      END_STATE();
    case 628:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == '\n') ADVANCE(629);
      if (lookahead == '"') ADVANCE(679);
      if (lookahead == '#') ADVANCE(628);
      if (lookahead == '$' ||
          lookahead == '`') ADVANCE(557);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(628);
      if (lookahead != 0) ADVANCE(627);
      END_STATE();
    case 629:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == '"') ADVANCE(677);
      if (lookahead == '#') ADVANCE(629);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(629);
      if (lookahead != 0 &&
          (lookahead < '"' || '$' < lookahead) &&
          lookahead != '`') ADVANCE(670);
      END_STATE();
    case 630:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == '#') ADVANCE(628);
      if (lookahead == '<') ADVANCE(632);
      if (lookahead == '@') ADVANCE(667);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(631);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(630);
      if (lookahead != 0 &&
          (lookahead < '"' || '$' < lookahead) &&
          lookahead != '`') ADVANCE(670);
      END_STATE();
    case 631:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == '#') ADVANCE(627);
      if (lookahead == '<') ADVANCE(632);
      if (lookahead == '@') ADVANCE(667);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(631);
      if (lookahead != 0 &&
          (lookahead < '"' || '$' < lookahead) &&
          lookahead != '`') ADVANCE(670);
      END_STATE();
    case 632:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == '#') ADVANCE(634);
      if (lookahead != 0 &&
          (lookahead < '"' || '$' < lookahead) &&
          lookahead != '`') ADVANCE(670);
      END_STATE();
    case 633:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == '#') ADVANCE(633);
      if (lookahead == '>') ADVANCE(670);
      if (('"' <= lookahead && lookahead <= '$') ||
          lookahead == '`') ADVANCE(117);
      if (lookahead != 0) ADVANCE(634);
      END_STATE();
    case 634:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == '#') ADVANCE(633);
      if (lookahead == '`') ADVANCE(528);
      if (('"' <= lookahead && lookahead <= '$')) ADVANCE(117);
      if (lookahead != 0) ADVANCE(634);
      END_STATE();
    case 635:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == '?') ADVANCE(670);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(669);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 636:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == 'a') ADVANCE(661);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 637:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == 'a') ADVANCE(648);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 638:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == 'b') ADVANCE(637);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 639:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == 'c') ADVANCE(637);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 640:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == 'c') ADVANCE(659);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 641:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == 'e') ADVANCE(666);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 642:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == 'f') ADVANCE(650);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 643:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == 'g') ADVANCE(666);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 644:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == 'i') ADVANCE(663);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 645:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == 'i') ADVANCE(651);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 646:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == 'i') ADVANCE(656);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 647:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == 'k') ADVANCE(642);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 648:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == 'l') ADVANCE(666);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 649:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == 'l') ADVANCE(652);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 650:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == 'l') ADVANCE(653);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 651:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == 'n') ADVANCE(643);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 652:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == 'o') ADVANCE(638);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 653:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == 'o') ADVANCE(664);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 654:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == 'o') ADVANCE(658);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 655:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == 'o') ADVANCE(639);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 656:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == 'p') ADVANCE(662);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 657:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == 'r') ADVANCE(644);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 658:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == 'r') ADVANCE(647);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 659:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == 'r') ADVANCE(646);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 660:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == 's') ADVANCE(645);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 661:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == 't') ADVANCE(641);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 662:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == 't') ADVANCE(666);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 663:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == 'v') ADVANCE(636);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 664:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (lookahead == 'w') ADVANCE(666);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 665:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(668);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 666:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == ':') ADVANCE(635);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 667:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == '?') ADVANCE(670);
      if (lookahead == 'g') ADVANCE(649);
      if (lookahead == 'l') ADVANCE(655);
      if (lookahead == 'p') ADVANCE(657);
      if (lookahead == 's') ADVANCE(640);
      if (lookahead == 'u') ADVANCE(660);
      if (lookahead == 'w') ADVANCE(654);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 668:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead == '?') ADVANCE(670);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(669);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 669:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(669);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(670);
      END_STATE();
    case 670:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token2);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '`') ADVANCE(670);
      END_STATE();
    case 671:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token3);
      END_STATE();
    case 672:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token4);
      END_STATE();
    case 673:
      ACCEPT_TOKEN(anon_sym_DQUOTE_DQUOTE);
      END_STATE();
    case 674:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 675:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      ADVANCE_MAP(
        '$', 886,
        '(', 1638,
        '?', 892,
        '^', 889,
        '_', 895,
        '`', 529,
        'g', 912,
        'l', 918,
        'p', 920,
        's', 903,
        'u', 923,
        'w', 917,
        '{', 527,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == '\\') ADVANCE(671);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 676:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      ADVANCE_MAP(
        '$', 886,
        '(', 1638,
        '?', 892,
        '^', 889,
        '_', 895,
        'g', 912,
        'l', 918,
        'p', 920,
        's', 903,
        'u', 923,
        'w', 917,
        '{', 527,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 677:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token5);
      END_STATE();
    case 678:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token5);
      if (lookahead == '"') ADVANCE(673);
      END_STATE();
    case 679:
      ACCEPT_TOKEN(aux_sym_expandable_string_literal_token5);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(557);
      END_STATE();
    case 680:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token1);
      END_STATE();
    case 681:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == '#') ADVANCE(719);
      if (lookahead == '<') ADVANCE(682);
      if (lookahead == '@') ADVANCE(717);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(681);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '#' &&
          lookahead != '$' &&
          lookahead != '`') ADVANCE(721);
      END_STATE();
    case 682:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == '#') ADVANCE(684);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '#' &&
          lookahead != '$' &&
          lookahead != '`') ADVANCE(721);
      END_STATE();
    case 683:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == '#') ADVANCE(683);
      if (lookahead == '>') ADVANCE(721);
      if (lookahead == '\n' ||
          lookahead == '$' ||
          lookahead == '`') ADVANCE(117);
      if (lookahead != 0) ADVANCE(684);
      END_STATE();
    case 684:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == '#') ADVANCE(683);
      if (lookahead == '`') ADVANCE(528);
      if (lookahead == '\n' ||
          lookahead == '$') ADVANCE(117);
      if (lookahead != 0) ADVANCE(684);
      END_STATE();
    case 685:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == '?') ADVANCE(721);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(720);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 686:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == 'a') ADVANCE(711);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 687:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == 'a') ADVANCE(698);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 688:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == 'b') ADVANCE(687);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 689:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == 'c') ADVANCE(687);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 690:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == 'c') ADVANCE(709);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 691:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == 'e') ADVANCE(716);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 692:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == 'f') ADVANCE(700);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 693:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == 'g') ADVANCE(716);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 694:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == 'i') ADVANCE(713);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 695:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == 'i') ADVANCE(701);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 696:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == 'i') ADVANCE(706);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 697:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == 'k') ADVANCE(692);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 698:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == 'l') ADVANCE(716);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 699:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == 'l') ADVANCE(702);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 700:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == 'l') ADVANCE(703);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 701:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == 'n') ADVANCE(693);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 702:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == 'o') ADVANCE(688);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 703:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == 'o') ADVANCE(714);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 704:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == 'o') ADVANCE(708);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 705:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == 'o') ADVANCE(689);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 706:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == 'p') ADVANCE(712);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 707:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == 'r') ADVANCE(694);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 708:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == 'r') ADVANCE(697);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 709:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == 'r') ADVANCE(696);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 710:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == 's') ADVANCE(695);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 711:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == 't') ADVANCE(691);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 712:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == 't') ADVANCE(716);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 713:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == 'v') ADVANCE(686);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 714:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (lookahead == 'w') ADVANCE(716);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 715:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(718);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 716:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == ':') ADVANCE(685);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 717:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == '?') ADVANCE(721);
      if (lookahead == 'g') ADVANCE(699);
      if (lookahead == 'l') ADVANCE(705);
      if (lookahead == 'p') ADVANCE(707);
      if (lookahead == 's') ADVANCE(690);
      if (lookahead == 'u') ADVANCE(710);
      if (lookahead == 'w') ADVANCE(704);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 718:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == '?') ADVANCE(721);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(720);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 719:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead == '$' ||
          lookahead == '`') ADVANCE(557);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(719);
      END_STATE();
    case 720:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(720);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(721);
      END_STATE();
    case 721:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token2);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$' &&
          lookahead != '`') ADVANCE(721);
      END_STATE();
    case 722:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token3);
      END_STATE();
    case 723:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token3);
      if (lookahead == '#') ADVANCE(117);
      END_STATE();
    case 724:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token3);
      ADVANCE_MAP(
        '$', 886,
        '(', 1638,
        '?', 892,
        '^', 889,
        '_', 895,
        'g', 912,
        'l', 918,
        'p', 920,
        's', 903,
        'u', 923,
        'w', 917,
        '{', 527,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 725:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token3);
      if (lookahead == '?') ADVANCE(997);
      if (lookahead == 'g') ADVANCE(1042);
      if (lookahead == 'l') ADVANCE(1048);
      if (lookahead == 'p') ADVANCE(1050);
      if (lookahead == 's') ADVANCE(1033);
      if (lookahead == 'u') ADVANCE(1053);
      if (lookahead == 'w') ADVANCE(1047);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 726:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token3);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(557);
      END_STATE();
    case 727:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token4);
      END_STATE();
    case 728:
      ACCEPT_TOKEN(aux_sym_expandable_here_string_literal_token5);
      END_STATE();
    case 729:
      ACCEPT_TOKEN(sym_verbatim_string_characters);
      if (lookahead == '\'') ADVANCE(124);
      END_STATE();
    case 730:
      ACCEPT_TOKEN(sym_verbatim_string_characters);
      if (lookahead == '\'') ADVANCE(1141);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 731:
      ACCEPT_TOKEN(sym_verbatim_string_characters);
      if (lookahead == '\'') ADVANCE(1201);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 732:
      ACCEPT_TOKEN(sym_verbatim_here_string_characters);
      END_STATE();
    case 733:
      ACCEPT_TOKEN(sym_verbatim_here_string_characters);
      if (lookahead == '\n') ADVANCE(46);
      if (lookahead != 0) ADVANCE(7);
      END_STATE();
    case 734:
      ACCEPT_TOKEN(sym_simple_name);
      if (lookahead == 'a') ADVANCE(743);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(744);
      END_STATE();
    case 735:
      ACCEPT_TOKEN(sym_simple_name);
      if (lookahead == 'c') ADVANCE(1583);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(744);
      END_STATE();
    case 736:
      ACCEPT_TOKEN(sym_simple_name);
      if (lookahead == 'd') ADVANCE(738);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(744);
      END_STATE();
    case 737:
      ACCEPT_TOKEN(sym_simple_name);
      if (lookahead == 'd') ADVANCE(736);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(744);
      END_STATE();
    case 738:
      ACCEPT_TOKEN(sym_simple_name);
      if (lookahead == 'e') ADVANCE(741);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(744);
      END_STATE();
    case 739:
      ACCEPT_TOKEN(sym_simple_name);
      if (lookahead == 'i') ADVANCE(737);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(744);
      END_STATE();
    case 740:
      ACCEPT_TOKEN(sym_simple_name);
      if (lookahead == 'i') ADVANCE(735);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(744);
      END_STATE();
    case 741:
      ACCEPT_TOKEN(sym_simple_name);
      if (lookahead == 'n') ADVANCE(1581);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(744);
      END_STATE();
    case 742:
      ACCEPT_TOKEN(sym_simple_name);
      if (lookahead == 't') ADVANCE(734);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(744);
      END_STATE();
    case 743:
      ACCEPT_TOKEN(sym_simple_name);
      if (lookahead == 't') ADVANCE(740);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(744);
      END_STATE();
    case 744:
      ACCEPT_TOKEN(sym_simple_name);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(744);
      END_STATE();
    case 745:
      ACCEPT_TOKEN(sym_type_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(745);
      END_STATE();
    case 746:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 747:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(611);
      END_STATE();
    case 748:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(612);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 749:
      ACCEPT_TOKEN(anon_sym_DOT);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 750:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 751:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 752:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 753:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 754:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 755:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 756:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 757:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 758:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 759:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '>') ADVANCE(762);
      END_STATE();
    case 760:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '>') ADVANCE(764);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 761:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '>') ADVANCE(763);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1538);
      END_STATE();
    case 762:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 763:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1538);
      END_STATE();
    case 764:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 765:
      ACCEPT_TOKEN(anon_sym_2_GT);
      if (lookahead == '&') ADVANCE(134);
      if (lookahead == '>') ADVANCE(768);
      END_STATE();
    case 766:
      ACCEPT_TOKEN(anon_sym_2_GT);
      if (lookahead == '&') ADVANCE(134);
      if (lookahead == '>') ADVANCE(769);
      if (((!eof && set_contains(sym_generic_token_character_set_1, 11, lookahead)) ||
          lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '@' ||
          lookahead == '[' ||
          lookahead == '`') &&
          lookahead != ',' &&
          lookahead != ';') ADVANCE(1538);
      END_STATE();
    case 767:
      ACCEPT_TOKEN(anon_sym_2_GT);
      if (lookahead == '&') ADVANCE(1144);
      if (lookahead == '>') ADVANCE(770);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 768:
      ACCEPT_TOKEN(anon_sym_2_GT_GT);
      END_STATE();
    case 769:
      ACCEPT_TOKEN(anon_sym_2_GT_GT);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1538);
      END_STATE();
    case 770:
      ACCEPT_TOKEN(anon_sym_2_GT_GT);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 771:
      ACCEPT_TOKEN(anon_sym_3_GT);
      if (lookahead == '&') ADVANCE(135);
      if (lookahead == '>') ADVANCE(774);
      END_STATE();
    case 772:
      ACCEPT_TOKEN(anon_sym_3_GT);
      if (lookahead == '&') ADVANCE(135);
      if (lookahead == '>') ADVANCE(775);
      if (((!eof && set_contains(sym_generic_token_character_set_1, 11, lookahead)) ||
          lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '@' ||
          lookahead == '[' ||
          lookahead == '`') &&
          lookahead != ',' &&
          lookahead != ';') ADVANCE(1538);
      END_STATE();
    case 773:
      ACCEPT_TOKEN(anon_sym_3_GT);
      if (lookahead == '&') ADVANCE(1145);
      if (lookahead == '>') ADVANCE(776);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 774:
      ACCEPT_TOKEN(anon_sym_3_GT_GT);
      END_STATE();
    case 775:
      ACCEPT_TOKEN(anon_sym_3_GT_GT);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1538);
      END_STATE();
    case 776:
      ACCEPT_TOKEN(anon_sym_3_GT_GT);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 777:
      ACCEPT_TOKEN(anon_sym_4_GT);
      if (lookahead == '&') ADVANCE(136);
      if (lookahead == '>') ADVANCE(780);
      END_STATE();
    case 778:
      ACCEPT_TOKEN(anon_sym_4_GT);
      if (lookahead == '&') ADVANCE(136);
      if (lookahead == '>') ADVANCE(781);
      if (((!eof && set_contains(sym_generic_token_character_set_1, 11, lookahead)) ||
          lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '@' ||
          lookahead == '[' ||
          lookahead == '`') &&
          lookahead != ',' &&
          lookahead != ';') ADVANCE(1538);
      END_STATE();
    case 779:
      ACCEPT_TOKEN(anon_sym_4_GT);
      if (lookahead == '&') ADVANCE(1146);
      if (lookahead == '>') ADVANCE(782);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 780:
      ACCEPT_TOKEN(anon_sym_4_GT_GT);
      END_STATE();
    case 781:
      ACCEPT_TOKEN(anon_sym_4_GT_GT);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1538);
      END_STATE();
    case 782:
      ACCEPT_TOKEN(anon_sym_4_GT_GT);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 783:
      ACCEPT_TOKEN(anon_sym_5_GT);
      if (lookahead == '&') ADVANCE(137);
      if (lookahead == '>') ADVANCE(786);
      END_STATE();
    case 784:
      ACCEPT_TOKEN(anon_sym_5_GT);
      if (lookahead == '&') ADVANCE(137);
      if (lookahead == '>') ADVANCE(787);
      if (((!eof && set_contains(sym_generic_token_character_set_1, 11, lookahead)) ||
          lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '@' ||
          lookahead == '[' ||
          lookahead == '`') &&
          lookahead != ',' &&
          lookahead != ';') ADVANCE(1538);
      END_STATE();
    case 785:
      ACCEPT_TOKEN(anon_sym_5_GT);
      if (lookahead == '&') ADVANCE(1147);
      if (lookahead == '>') ADVANCE(788);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 786:
      ACCEPT_TOKEN(anon_sym_5_GT_GT);
      END_STATE();
    case 787:
      ACCEPT_TOKEN(anon_sym_5_GT_GT);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1538);
      END_STATE();
    case 788:
      ACCEPT_TOKEN(anon_sym_5_GT_GT);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 789:
      ACCEPT_TOKEN(anon_sym_6_GT);
      if (lookahead == '&') ADVANCE(138);
      if (lookahead == '>') ADVANCE(792);
      END_STATE();
    case 790:
      ACCEPT_TOKEN(anon_sym_6_GT);
      if (lookahead == '&') ADVANCE(138);
      if (lookahead == '>') ADVANCE(793);
      if (((!eof && set_contains(sym_generic_token_character_set_1, 11, lookahead)) ||
          lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '@' ||
          lookahead == '[' ||
          lookahead == '`') &&
          lookahead != ',' &&
          lookahead != ';') ADVANCE(1538);
      END_STATE();
    case 791:
      ACCEPT_TOKEN(anon_sym_6_GT);
      if (lookahead == '&') ADVANCE(1148);
      if (lookahead == '>') ADVANCE(794);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 792:
      ACCEPT_TOKEN(anon_sym_6_GT_GT);
      END_STATE();
    case 793:
      ACCEPT_TOKEN(anon_sym_6_GT_GT);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1538);
      END_STATE();
    case 794:
      ACCEPT_TOKEN(anon_sym_6_GT_GT);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 795:
      ACCEPT_TOKEN(anon_sym_STAR_GT);
      if (lookahead == '&') ADVANCE(133);
      if (lookahead == '>') ADVANCE(798);
      END_STATE();
    case 796:
      ACCEPT_TOKEN(anon_sym_STAR_GT);
      if (lookahead == '&') ADVANCE(133);
      if (lookahead == '>') ADVANCE(799);
      if (((!eof && set_contains(sym_generic_token_character_set_1, 11, lookahead)) ||
          lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '@' ||
          lookahead == '[' ||
          lookahead == '`') &&
          lookahead != ',' &&
          lookahead != ';') ADVANCE(1538);
      END_STATE();
    case 797:
      ACCEPT_TOKEN(anon_sym_STAR_GT);
      if (lookahead == '&') ADVANCE(1143);
      if (lookahead == '>') ADVANCE(800);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 798:
      ACCEPT_TOKEN(anon_sym_STAR_GT_GT);
      END_STATE();
    case 799:
      ACCEPT_TOKEN(anon_sym_STAR_GT_GT);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1538);
      END_STATE();
    case 800:
      ACCEPT_TOKEN(anon_sym_STAR_GT_GT);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 801:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '#') ADVANCE(117);
      END_STATE();
    case 802:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '#') ADVANCE(1138);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 803:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '#') ADVANCE(1520);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1538);
      END_STATE();
    case 804:
      ACCEPT_TOKEN(anon_sym_STAR_GT_AMP1);
      END_STATE();
    case 805:
      ACCEPT_TOKEN(anon_sym_STAR_GT_AMP1);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 806:
      ACCEPT_TOKEN(anon_sym_2_GT_AMP1);
      END_STATE();
    case 807:
      ACCEPT_TOKEN(anon_sym_2_GT_AMP1);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 808:
      ACCEPT_TOKEN(anon_sym_3_GT_AMP1);
      END_STATE();
    case 809:
      ACCEPT_TOKEN(anon_sym_3_GT_AMP1);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 810:
      ACCEPT_TOKEN(anon_sym_4_GT_AMP1);
      END_STATE();
    case 811:
      ACCEPT_TOKEN(anon_sym_4_GT_AMP1);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 812:
      ACCEPT_TOKEN(anon_sym_5_GT_AMP1);
      END_STATE();
    case 813:
      ACCEPT_TOKEN(anon_sym_5_GT_AMP1);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 814:
      ACCEPT_TOKEN(anon_sym_6_GT_AMP1);
      END_STATE();
    case 815:
      ACCEPT_TOKEN(anon_sym_6_GT_AMP1);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 816:
      ACCEPT_TOKEN(anon_sym_STAR_GT_AMP2);
      END_STATE();
    case 817:
      ACCEPT_TOKEN(anon_sym_STAR_GT_AMP2);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 818:
      ACCEPT_TOKEN(anon_sym_1_GT_AMP2);
      END_STATE();
    case 819:
      ACCEPT_TOKEN(anon_sym_1_GT_AMP2);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 820:
      ACCEPT_TOKEN(anon_sym_3_GT_AMP2);
      END_STATE();
    case 821:
      ACCEPT_TOKEN(anon_sym_3_GT_AMP2);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 822:
      ACCEPT_TOKEN(anon_sym_4_GT_AMP2);
      END_STATE();
    case 823:
      ACCEPT_TOKEN(anon_sym_4_GT_AMP2);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 824:
      ACCEPT_TOKEN(anon_sym_5_GT_AMP2);
      END_STATE();
    case 825:
      ACCEPT_TOKEN(anon_sym_5_GT_AMP2);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 826:
      ACCEPT_TOKEN(anon_sym_6_GT_AMP2);
      END_STATE();
    case 827:
      ACCEPT_TOKEN(anon_sym_6_GT_AMP2);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 828:
      ACCEPT_TOKEN(anon_sym_DASHas);
      END_STATE();
    case 829:
      ACCEPT_TOKEN(anon_sym_DASHccontains);
      END_STATE();
    case 830:
      ACCEPT_TOKEN(anon_sym_DASHceq);
      END_STATE();
    case 831:
      ACCEPT_TOKEN(anon_sym_DASHcge);
      END_STATE();
    case 832:
      ACCEPT_TOKEN(anon_sym_DASHcgt);
      END_STATE();
    case 833:
      ACCEPT_TOKEN(anon_sym_DASHcle);
      END_STATE();
    case 834:
      ACCEPT_TOKEN(anon_sym_DASHclike);
      END_STATE();
    case 835:
      ACCEPT_TOKEN(anon_sym_DASHclt);
      END_STATE();
    case 836:
      ACCEPT_TOKEN(anon_sym_DASHcmatch);
      END_STATE();
    case 837:
      ACCEPT_TOKEN(anon_sym_DASHcne);
      END_STATE();
    case 838:
      ACCEPT_TOKEN(anon_sym_DASHcnotcontains);
      END_STATE();
    case 839:
      ACCEPT_TOKEN(anon_sym_DASHcnotlike);
      END_STATE();
    case 840:
      ACCEPT_TOKEN(anon_sym_DASHcnotmatch);
      END_STATE();
    case 841:
      ACCEPT_TOKEN(anon_sym_DASHcontains);
      END_STATE();
    case 842:
      ACCEPT_TOKEN(anon_sym_DASHcreplace);
      END_STATE();
    case 843:
      ACCEPT_TOKEN(anon_sym_DASHcsplit);
      END_STATE();
    case 844:
      ACCEPT_TOKEN(anon_sym_DASHeq);
      END_STATE();
    case 845:
      ACCEPT_TOKEN(anon_sym_DASHge);
      END_STATE();
    case 846:
      ACCEPT_TOKEN(anon_sym_DASHgt);
      END_STATE();
    case 847:
      ACCEPT_TOKEN(anon_sym_DASHicontains);
      END_STATE();
    case 848:
      ACCEPT_TOKEN(anon_sym_DASHieq);
      END_STATE();
    case 849:
      ACCEPT_TOKEN(anon_sym_DASHige);
      END_STATE();
    case 850:
      ACCEPT_TOKEN(anon_sym_DASHigt);
      END_STATE();
    case 851:
      ACCEPT_TOKEN(anon_sym_DASHile);
      END_STATE();
    case 852:
      ACCEPT_TOKEN(anon_sym_DASHilike);
      END_STATE();
    case 853:
      ACCEPT_TOKEN(anon_sym_DASHilt);
      END_STATE();
    case 854:
      ACCEPT_TOKEN(anon_sym_DASHimatch);
      END_STATE();
    case 855:
      ACCEPT_TOKEN(anon_sym_DASHin);
      if (lookahead == 'e') ADVANCE(856);
      if (lookahead == 'o') ADVANCE(510);
      END_STATE();
    case 856:
      ACCEPT_TOKEN(anon_sym_DASHine);
      END_STATE();
    case 857:
      ACCEPT_TOKEN(anon_sym_DASHinotcontains);
      END_STATE();
    case 858:
      ACCEPT_TOKEN(anon_sym_DASHinotlike);
      END_STATE();
    case 859:
      ACCEPT_TOKEN(anon_sym_DASHinotmatch);
      END_STATE();
    case 860:
      ACCEPT_TOKEN(anon_sym_DASHireplace);
      END_STATE();
    case 861:
      ACCEPT_TOKEN(anon_sym_DASHis);
      if (lookahead == 'n') ADVANCE(421);
      if (lookahead == 'p') ADVANCE(370);
      END_STATE();
    case 862:
      ACCEPT_TOKEN(anon_sym_DASHisnot);
      END_STATE();
    case 863:
      ACCEPT_TOKEN(anon_sym_DASHisplit);
      END_STATE();
    case 864:
      ACCEPT_TOKEN(anon_sym_DASHjoin);
      END_STATE();
    case 865:
      ACCEPT_TOKEN(anon_sym_DASHjoin);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1234);
      END_STATE();
    case 866:
      ACCEPT_TOKEN(anon_sym_DASHjoin);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1190);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '-' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 867:
      ACCEPT_TOKEN(anon_sym_DASHjoin);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 868:
      ACCEPT_TOKEN(anon_sym_DASHle);
      END_STATE();
    case 869:
      ACCEPT_TOKEN(anon_sym_DASHlike);
      END_STATE();
    case 870:
      ACCEPT_TOKEN(anon_sym_DASHlt);
      END_STATE();
    case 871:
      ACCEPT_TOKEN(anon_sym_DASHmatch);
      END_STATE();
    case 872:
      ACCEPT_TOKEN(anon_sym_DASHne);
      END_STATE();
    case 873:
      ACCEPT_TOKEN(anon_sym_DASHnotcontains);
      END_STATE();
    case 874:
      ACCEPT_TOKEN(anon_sym_DASHnotin);
      END_STATE();
    case 875:
      ACCEPT_TOKEN(anon_sym_DASHnotlike);
      END_STATE();
    case 876:
      ACCEPT_TOKEN(anon_sym_DASHnotmatch);
      END_STATE();
    case 877:
      ACCEPT_TOKEN(anon_sym_DASHreplace);
      END_STATE();
    case 878:
      ACCEPT_TOKEN(anon_sym_DASHshl);
      END_STATE();
    case 879:
      ACCEPT_TOKEN(anon_sym_DASHshr);
      END_STATE();
    case 880:
      ACCEPT_TOKEN(anon_sym_DASHsplit);
      END_STATE();
    case 881:
      ACCEPT_TOKEN(anon_sym_DASHsplit);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1234);
      END_STATE();
    case 882:
      ACCEPT_TOKEN(anon_sym_DASHsplit);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1190);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '-' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 883:
      ACCEPT_TOKEN(anon_sym_DASHsplit);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 884:
      ACCEPT_TOKEN(sym_format_operator);
      END_STATE();
    case 885:
      ACCEPT_TOKEN(sym_format_operator);
      if (lookahead == 'i') ADVANCE(358);
      END_STATE();
    case 886:
      ACCEPT_TOKEN(anon_sym_DOLLAR_DOLLAR);
      END_STATE();
    case 887:
      ACCEPT_TOKEN(anon_sym_DOLLAR_DOLLAR);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 888:
      ACCEPT_TOKEN(anon_sym_DOLLAR_DOLLAR);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 889:
      ACCEPT_TOKEN(anon_sym_DOLLAR_CARET);
      END_STATE();
    case 890:
      ACCEPT_TOKEN(anon_sym_DOLLAR_CARET);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 891:
      ACCEPT_TOKEN(anon_sym_DOLLAR_CARET);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 892:
      ACCEPT_TOKEN(anon_sym_DOLLAR_QMARK);
      END_STATE();
    case 893:
      ACCEPT_TOKEN(anon_sym_DOLLAR_QMARK);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 894:
      ACCEPT_TOKEN(anon_sym_DOLLAR_QMARK);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 895:
      ACCEPT_TOKEN(anon_sym_DOLLAR_);
      if (lookahead == ':') ADVANCE(154);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 896:
      ACCEPT_TOKEN(anon_sym_DOLLAR_);
      if (lookahead == ':') ADVANCE(1154);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 897:
      ACCEPT_TOKEN(anon_sym_DOLLAR_);
      if (lookahead == ':') ADVANCE(1205);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 898:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      END_STATE();
    case 899:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == 'a') ADVANCE(924);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 900:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == 'a') ADVANCE(911);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 901:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == 'b') ADVANCE(900);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 902:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == 'c') ADVANCE(900);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 903:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == 'c') ADVANCE(922);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 904:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == 'e') ADVANCE(929);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 905:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == 'f') ADVANCE(913);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 906:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == 'g') ADVANCE(929);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 907:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == 'i') ADVANCE(926);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 908:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == 'i') ADVANCE(914);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 909:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == 'i') ADVANCE(919);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 910:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == 'k') ADVANCE(905);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 911:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == 'l') ADVANCE(929);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 912:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == 'l') ADVANCE(915);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 913:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == 'l') ADVANCE(916);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 914:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == 'n') ADVANCE(906);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 915:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == 'o') ADVANCE(901);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 916:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == 'o') ADVANCE(927);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 917:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == 'o') ADVANCE(921);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 918:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == 'o') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 919:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == 'p') ADVANCE(925);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 920:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == 'r') ADVANCE(907);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 921:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == 'r') ADVANCE(910);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 922:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == 'r') ADVANCE(909);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 923:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == 's') ADVANCE(908);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 924:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == 't') ADVANCE(904);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 925:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == 't') ADVANCE(929);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 926:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == 'v') ADVANCE(899);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 927:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (lookahead == 'w') ADVANCE(929);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 928:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(154);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 929:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(142);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 930:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == 'a') ADVANCE(955);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 931:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == 'a') ADVANCE(942);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 932:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == 'b') ADVANCE(931);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 933:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == 'c') ADVANCE(931);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 934:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == 'c') ADVANCE(953);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 935:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == 'e') ADVANCE(960);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 936:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == 'f') ADVANCE(944);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 937:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == 'g') ADVANCE(960);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 938:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == 'i') ADVANCE(957);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 939:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == 'i') ADVANCE(945);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 940:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == 'i') ADVANCE(950);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 941:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == 'k') ADVANCE(936);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 942:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == 'l') ADVANCE(960);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 943:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == 'l') ADVANCE(946);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 944:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == 'l') ADVANCE(947);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 945:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == 'n') ADVANCE(937);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 946:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == 'o') ADVANCE(932);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 947:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == 'o') ADVANCE(958);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 948:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == 'o') ADVANCE(952);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 949:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == 'o') ADVANCE(933);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 950:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == 'p') ADVANCE(956);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 951:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == 'r') ADVANCE(938);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 952:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == 'r') ADVANCE(941);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 953:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == 'r') ADVANCE(940);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 954:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == 's') ADVANCE(939);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 955:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == 't') ADVANCE(935);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 956:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == 't') ADVANCE(960);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 957:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == 'v') ADVANCE(930);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 958:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == 'w') ADVANCE(960);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 959:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1154);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 960:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1150);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 961:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == 'a') ADVANCE(986);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 962:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == 'a') ADVANCE(973);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 963:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == 'b') ADVANCE(962);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 964:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == 'c') ADVANCE(962);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 965:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == 'c') ADVANCE(984);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 966:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == 'e') ADVANCE(991);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 967:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == 'f') ADVANCE(975);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 968:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == 'g') ADVANCE(991);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 969:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == 'i') ADVANCE(988);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 970:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == 'i') ADVANCE(976);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 971:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == 'i') ADVANCE(981);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 972:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == 'k') ADVANCE(967);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 973:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == 'l') ADVANCE(991);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 974:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == 'l') ADVANCE(977);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 975:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == 'l') ADVANCE(978);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 976:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == 'n') ADVANCE(968);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 977:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == 'o') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 978:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == 'o') ADVANCE(989);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 979:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == 'o') ADVANCE(983);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 980:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == 'o') ADVANCE(964);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 981:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == 'p') ADVANCE(987);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 982:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == 'r') ADVANCE(969);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 983:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == 'r') ADVANCE(972);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 984:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == 'r') ADVANCE(971);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 985:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == 's') ADVANCE(970);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 986:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == 't') ADVANCE(966);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 987:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == 't') ADVANCE(991);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 988:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == 'v') ADVANCE(961);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 989:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == 'w') ADVANCE(991);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 990:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1205);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 991:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead == ':') ADVANCE(1202);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 992:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(992);
      END_STATE();
    case 993:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(993);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 994:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(994);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 995:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 996:
      ACCEPT_TOKEN(aux_sym_variable_token1);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 997:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      END_STATE();
    case 998:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == 'a') ADVANCE(1023);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 999:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == 'a') ADVANCE(1010);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1000:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == 'b') ADVANCE(999);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1001:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == 'c') ADVANCE(999);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1002:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == 'c') ADVANCE(1021);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1003:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == 'e') ADVANCE(1028);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1004:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == 'f') ADVANCE(1012);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1005:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == 'g') ADVANCE(1028);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1006:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == 'i') ADVANCE(1025);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1007:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == 'i') ADVANCE(1013);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1008:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == 'i') ADVANCE(1018);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1009:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == 'k') ADVANCE(1004);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1010:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == 'l') ADVANCE(1028);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1011:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == 'l') ADVANCE(1014);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1012:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == 'l') ADVANCE(1015);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1013:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == 'n') ADVANCE(1005);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1014:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == 'o') ADVANCE(1000);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1015:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == 'o') ADVANCE(1026);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1016:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == 'o') ADVANCE(1020);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1017:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == 'o') ADVANCE(1001);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1018:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == 'p') ADVANCE(1024);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1019:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == 'r') ADVANCE(1006);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1020:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == 'r') ADVANCE(1009);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1021:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == 'r') ADVANCE(1008);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1022:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == 's') ADVANCE(1007);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1023:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == 't') ADVANCE(1003);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1024:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == 't') ADVANCE(1028);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1025:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == 'v') ADVANCE(998);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1026:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == 'w') ADVANCE(1028);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1027:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1337);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1028:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1335);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1029:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == 'a') ADVANCE(1054);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1030:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == 'a') ADVANCE(1041);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1031:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == 'b') ADVANCE(1030);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1032:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == 'c') ADVANCE(1030);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1033:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == 'c') ADVANCE(1052);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1034:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == 'e') ADVANCE(1059);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1035:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == 'f') ADVANCE(1043);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1036:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == 'g') ADVANCE(1059);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1037:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == 'i') ADVANCE(1056);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1038:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == 'i') ADVANCE(1044);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1039:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == 'i') ADVANCE(1049);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1040:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == 'k') ADVANCE(1035);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1041:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == 'l') ADVANCE(1059);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1042:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == 'l') ADVANCE(1045);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1043:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == 'l') ADVANCE(1046);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1044:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == 'n') ADVANCE(1036);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1045:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == 'o') ADVANCE(1031);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1046:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == 'o') ADVANCE(1057);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1047:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == 'o') ADVANCE(1051);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1048:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == 'o') ADVANCE(1032);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1049:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == 'p') ADVANCE(1055);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1050:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == 'r') ADVANCE(1037);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1051:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == 'r') ADVANCE(1040);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1052:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == 'r') ADVANCE(1039);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1053:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == 's') ADVANCE(1038);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1054:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == 't') ADVANCE(1034);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1055:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == 't') ADVANCE(1059);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1056:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == 'v') ADVANCE(1029);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1057:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (lookahead == 'w') ADVANCE(1059);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1058:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(153);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1059:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(143);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1058);
      END_STATE();
    case 1060:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == 'a') ADVANCE(1085);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1061:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == 'a') ADVANCE(1072);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1062:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == 'b') ADVANCE(1061);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1063:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == 'c') ADVANCE(1061);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1064:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == 'c') ADVANCE(1083);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1065:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == 'e') ADVANCE(1090);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1066:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == 'f') ADVANCE(1074);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1067:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == 'g') ADVANCE(1090);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1068:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == 'i') ADVANCE(1087);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1069:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == 'i') ADVANCE(1075);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1070:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == 'i') ADVANCE(1080);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1071:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == 'k') ADVANCE(1066);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1072:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == 'l') ADVANCE(1090);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1073:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == 'l') ADVANCE(1076);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1074:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == 'l') ADVANCE(1077);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1075:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == 'n') ADVANCE(1067);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1076:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == 'o') ADVANCE(1062);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1077:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == 'o') ADVANCE(1088);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1078:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == 'o') ADVANCE(1082);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1079:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == 'o') ADVANCE(1063);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1080:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == 'p') ADVANCE(1086);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1081:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == 'r') ADVANCE(1068);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1082:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == 'r') ADVANCE(1071);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1083:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == 'r') ADVANCE(1070);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1084:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == 's') ADVANCE(1069);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1085:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == 't') ADVANCE(1065);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1086:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == 't') ADVANCE(1090);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1087:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == 'v') ADVANCE(1060);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1088:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == 'w') ADVANCE(1090);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1089:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1153);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1090:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1151);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1091:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == 'a') ADVANCE(1116);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1092:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == 'a') ADVANCE(1103);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1093:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == 'b') ADVANCE(1092);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1094:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == 'c') ADVANCE(1092);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1095:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == 'c') ADVANCE(1114);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1096:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == 'e') ADVANCE(1121);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1097:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == 'f') ADVANCE(1105);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1098:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == 'g') ADVANCE(1121);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1099:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == 'i') ADVANCE(1118);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1100:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == 'i') ADVANCE(1106);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1101:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == 'i') ADVANCE(1111);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1102:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == 'k') ADVANCE(1097);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1103:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == 'l') ADVANCE(1121);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1104:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == 'l') ADVANCE(1107);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1105:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == 'l') ADVANCE(1108);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1106:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == 'n') ADVANCE(1098);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1107:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == 'o') ADVANCE(1093);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1108:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == 'o') ADVANCE(1119);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1109:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == 'o') ADVANCE(1113);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1110:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == 'o') ADVANCE(1094);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1111:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == 'p') ADVANCE(1117);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1112:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == 'r') ADVANCE(1099);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1113:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == 'r') ADVANCE(1102);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1114:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == 'r') ADVANCE(1101);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1115:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == 's') ADVANCE(1100);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1116:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == 't') ADVANCE(1096);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1117:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == 't') ADVANCE(1121);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1118:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == 'v') ADVANCE(1091);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1119:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == 'w') ADVANCE(1121);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1120:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1204);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1121:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead == ':') ADVANCE(1203);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1122:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1122);
      END_STATE();
    case 1123:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1123);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1124:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1124);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1125:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1125);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1126:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1127:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1128:
      ACCEPT_TOKEN(aux_sym_variable_token2);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '`') ADVANCE(1338);
      END_STATE();
    case 1129:
      ACCEPT_TOKEN(sym_braced_variable);
      END_STATE();
    case 1130:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == '\n') ADVANCE(680);
      if (lookahead == ' ') ADVANCE(2);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1131:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == '\n') ADVANCE(5);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(3);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1132:
      ACCEPT_TOKEN(sym_generic_token);
      ADVANCE_MAP(
        ' ', 1566,
        '!', 1621,
        '"', 625,
        '#', 551,
        '$', 1139,
        '\'', 1141,
        '*', 1152,
        '+', 1596,
        ',', 1254,
        '-', 1603,
        '.', 1184,
        '0', 579,
        '1', 573,
        '2', 574,
        '3', 575,
        '4', 576,
        '5', 577,
        '6', 578,
        ':', 1572,
        ';', 1191,
        '<', 802,
        '>', 760,
        '@', 1136,
        '[', 751,
        '`', 1191,
        '{', 1264,
      );
      if (('7' <= lookahead && lookahead <= '9')) ADVANCE(580);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1132);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < '\'' || '.' < lookahead) &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1191);
      END_STATE();
    case 1133:
      ACCEPT_TOKEN(sym_generic_token);
      ADVANCE_MAP(
        ' ', 1567,
        '!', 1621,
        '"', 625,
        '#', 551,
        '$', 1139,
        '\'', 1141,
        '*', 1152,
        '+', 1596,
        ',', 1254,
        '-', 1604,
        '.', 1184,
        '0', 579,
        '1', 573,
        '2', 574,
        '3', 575,
        '4', 576,
        '5', 577,
        '6', 578,
        ';', 1191,
        '<', 802,
        '>', 760,
        '@', 1136,
        '[', 751,
        '`', 1191,
        '{', 1264,
      );
      if (('7' <= lookahead && lookahead <= '9')) ADVANCE(580);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1133);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < '\'' || '.' < lookahead) &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1191);
      END_STATE();
    case 1134:
      ACCEPT_TOKEN(sym_generic_token);
      ADVANCE_MAP(
        ' ', 1568,
        '!', 1621,
        '"', 625,
        '#', 551,
        '$', 1139,
        '\'', 1141,
        '*', 1152,
        '+', 1596,
        ',', 1254,
        '-', 1606,
        '.', 1184,
        '0', 579,
        '1', 573,
        '2', 574,
        '3', 575,
        '4', 576,
        '5', 577,
        '6', 578,
        ':', 1572,
        ';', 1191,
        '<', 802,
        '>', 760,
        '@', 1136,
        '[', 751,
        '`', 1191,
        '{', 1264,
      );
      if (('7' <= lookahead && lookahead <= '9')) ADVANCE(580);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1134);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < '\'' || '.' < lookahead) &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1191);
      END_STATE();
    case 1135:
      ACCEPT_TOKEN(sym_generic_token);
      ADVANCE_MAP(
        '!', 1621,
        '"', 625,
        '#', 551,
        '$', 1139,
        '\'', 1141,
        '*', 1152,
        '+', 1596,
        ',', 1254,
        '-', 1604,
        '.', 1184,
        '0', 579,
        '1', 573,
        '2', 574,
        '3', 575,
        '4', 576,
        '5', 577,
        '6', 578,
        ';', 1191,
        '<', 802,
        '>', 760,
        '@', 1136,
        '[', 751,
        '`', 1191,
        '{', 1264,
      );
      if (('7' <= lookahead && lookahead <= '9')) ADVANCE(580);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1135);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '$' < lookahead) &&
          (lookahead < '\'' || '.' < lookahead) &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1191);
      END_STATE();
    case 1136:
      ACCEPT_TOKEN(sym_generic_token);
      ADVANCE_MAP(
        '"', 1130,
        '\'', 1131,
        '(', 1639,
        '?', 1126,
        'g', 1073,
        'l', 1079,
        'p', 1081,
        's', 1064,
        'u', 1084,
        'w', 1078,
        '{', 1641,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1089);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          (lookahead < 'a' || '}' < lookahead)) ADVANCE(1191);
      END_STATE();
    case 1137:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == '#') ADVANCE(1137);
      if (lookahead == '>') ADVANCE(553);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ',' ||
          lookahead == ';' ||
          lookahead == '|' ||
          lookahead == '}') ADVANCE(117);
      if (lookahead != 0) ADVANCE(1138);
      END_STATE();
    case 1138:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == '#') ADVANCE(1137);
      if (lookahead == '`') ADVANCE(1188);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ',' ||
          lookahead == ';' ||
          lookahead == '|' ||
          lookahead == '}') ADVANCE(117);
      if (lookahead != 0) ADVANCE(1138);
      END_STATE();
    case 1139:
      ACCEPT_TOKEN(sym_generic_token);
      ADVANCE_MAP(
        '$', 887,
        '(', 1638,
        '?', 893,
        '^', 890,
        '_', 896,
        'g', 943,
        'l', 949,
        'p', 951,
        's', 934,
        'u', 954,
        'w', 948,
        '{', 1187,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(959);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          (lookahead < 'a' || '}' < lookahead)) ADVANCE(1191);
      END_STATE();
    case 1140:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == '&') ADVANCE(1149);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1141:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == '\'') ADVANCE(730);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ',' ||
          lookahead == ';' ||
          lookahead == '|' ||
          lookahead == '}') ADVANCE(124);
      if (lookahead != 0) ADVANCE(1141);
      END_STATE();
    case 1142:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == '-') ADVANCE(1142);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1190);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '-' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1143:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == '1') ADVANCE(805);
      if (lookahead == '2') ADVANCE(817);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1144:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == '1') ADVANCE(807);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1145:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == '1') ADVANCE(809);
      if (lookahead == '2') ADVANCE(821);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1146:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == '1') ADVANCE(811);
      if (lookahead == '2') ADVANCE(823);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1147:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == '1') ADVANCE(813);
      if (lookahead == '2') ADVANCE(825);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1148:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == '1') ADVANCE(815);
      if (lookahead == '2') ADVANCE(827);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1149:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == '2') ADVANCE(819);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1150:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == ':') ADVANCE(1154);
      if (lookahead == '?') ADVANCE(995);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(993);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1151:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == ':') ADVANCE(1153);
      if (lookahead == '?') ADVANCE(1126);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1123);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          (lookahead < '0' || ';' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1152:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == '>') ADVANCE(797);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1153:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == '?') ADVANCE(1126);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1123);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1154:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == '?') ADVANCE(995);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(993);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1155:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == 'b') ADVANCE(590);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1156:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == 'b') ADVANCE(622);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1157:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == 'b') ADVANCE(605);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1158:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == 'i') ADVANCE(1164);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1190);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '-' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1159:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == 'i') ADVANCE(1165);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1160:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == 'i') ADVANCE(1178);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1190);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '-' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1161:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == 'i') ADVANCE(1181);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1162:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == 'l') ADVANCE(1160);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1190);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '-' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1163:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == 'l') ADVANCE(1161);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1164:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == 'n') ADVANCE(866);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1190);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '-' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1165:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == 'n') ADVANCE(867);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1166:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == 'n') ADVANCE(1172);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1190);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '-' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1167:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == 'n') ADVANCE(1173);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1168:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == 'o') ADVANCE(1158);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1190);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '-' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1169:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == 'o') ADVANCE(1176);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1190);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '-' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1170:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == 'o') ADVANCE(1159);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1171:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == 'o') ADVANCE(1179);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1172:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == 'o') ADVANCE(1177);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1190);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '-' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1173:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == 'o') ADVANCE(1180);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1174:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == 'p') ADVANCE(1162);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1190);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '-' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1175:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == 'p') ADVANCE(1163);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1176:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == 't') ADVANCE(1617);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1190);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '-' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1177:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == 't') ADVANCE(1624);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1190);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '-' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1178:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == 't') ADVANCE(882);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1190);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '-' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1179:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == 't') ADVANCE(1618);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1180:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == 't') ADVANCE(1625);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1181:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == 't') ADVANCE(883);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1182:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == '}') ADVANCE(1129);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ',' ||
          lookahead == ';' ||
          lookahead == '|') ADVANCE(522);
      if (lookahead != 0) ADVANCE(1182);
      END_STATE();
    case 1183:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(1185);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(618);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '+' || '-' < lookahead) &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1184:
      ACCEPT_TOKEN(sym_generic_token);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(613);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1185:
      ACCEPT_TOKEN(sym_generic_token);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(618);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1186:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ',' ||
          lookahead == ';' ||
          lookahead == '|' ||
          lookahead == '}') ADVANCE(1564);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(1186);
      END_STATE();
    case 1187:
      ACCEPT_TOKEN(sym_generic_token);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ',' ||
          lookahead == ';' ||
          lookahead == '|') ADVANCE(522);
      if (lookahead != 0 &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1182);
      END_STATE();
    case 1188:
      ACCEPT_TOKEN(sym_generic_token);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ',' ||
          lookahead == ';' ||
          lookahead == '|' ||
          lookahead == '}') ADVANCE(117);
      if (lookahead != 0) ADVANCE(1138);
      END_STATE();
    case 1189:
      ACCEPT_TOKEN(sym_generic_token);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(600);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1190:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1190);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '-' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1191:
      ACCEPT_TOKEN(sym_generic_token);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1192:
      ACCEPT_TOKEN(sym__command_token);
      if (lookahead == '\n') ADVANCE(680);
      if (lookahead == ' ') ADVANCE(2);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1193:
      ACCEPT_TOKEN(sym__command_token);
      if (lookahead == '\n') ADVANCE(5);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(3);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1194:
      ACCEPT_TOKEN(sym__command_token);
      ADVANCE_MAP(
        '"', 626,
        '#', 550,
        '$', 1200,
        '\'', 1201,
        '.', 1210,
        '0', 581,
        '<', 1197,
        '@', 1195,
        '[', 752,
        '`', 1214,
        0xa0, 1194,
        0x200b, 1194,
        0x2060, 1194,
        0xfeff, 1194,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(582);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1195:
      ACCEPT_TOKEN(sym__command_token);
      ADVANCE_MAP(
        '"', 1192,
        '\'', 1193,
        '(', 1639,
        '?', 1127,
        'g', 1104,
        'l', 1110,
        'p', 1112,
        's', 1095,
        'u', 1115,
        'w', 1109,
        '{', 1640,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1120);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1196:
      ACCEPT_TOKEN(sym__command_token);
      if (lookahead == '#') ADVANCE(550);
      if (lookahead == '<') ADVANCE(1197);
      if (lookahead == '`') ADVANCE(1214);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1196);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1197:
      ACCEPT_TOKEN(sym__command_token);
      if (lookahead == '#') ADVANCE(1199);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1198:
      ACCEPT_TOKEN(sym__command_token);
      if (lookahead == '#') ADVANCE(1198);
      if (lookahead == '>') ADVANCE(554);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(117);
      if (lookahead != 0) ADVANCE(1199);
      END_STATE();
    case 1199:
      ACCEPT_TOKEN(sym__command_token);
      if (lookahead == '#') ADVANCE(1198);
      if (lookahead == '`') ADVANCE(1212);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(117);
      if (lookahead != 0) ADVANCE(1199);
      END_STATE();
    case 1200:
      ACCEPT_TOKEN(sym__command_token);
      ADVANCE_MAP(
        '$', 888,
        '(', 1638,
        '?', 894,
        '^', 891,
        '_', 897,
        'g', 974,
        'l', 980,
        'p', 982,
        's', 965,
        'u', 985,
        'w', 979,
        '{', 527,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(990);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1201:
      ACCEPT_TOKEN(sym__command_token);
      if (lookahead == '\'') ADVANCE(731);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(124);
      if (lookahead != 0) ADVANCE(1201);
      END_STATE();
    case 1202:
      ACCEPT_TOKEN(sym__command_token);
      if (lookahead == ':') ADVANCE(1205);
      if (lookahead == '?') ADVANCE(996);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(994);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1203:
      ACCEPT_TOKEN(sym__command_token);
      if (lookahead == ':') ADVANCE(1204);
      if (lookahead == '?') ADVANCE(1127);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1124);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          (lookahead < '0' || ';' < lookahead) &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1204:
      ACCEPT_TOKEN(sym__command_token);
      if (lookahead == '?') ADVANCE(1127);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1124);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1205:
      ACCEPT_TOKEN(sym__command_token);
      if (lookahead == '?') ADVANCE(996);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(994);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          (lookahead < 'a' || '{' < lookahead) &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1206:
      ACCEPT_TOKEN(sym__command_token);
      if (lookahead == 'b') ADVANCE(591);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1207:
      ACCEPT_TOKEN(sym__command_token);
      if (lookahead == 'b') ADVANCE(623);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1208:
      ACCEPT_TOKEN(sym__command_token);
      if (lookahead == 'b') ADVANCE(606);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1209:
      ACCEPT_TOKEN(sym__command_token);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(1211);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(619);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1210:
      ACCEPT_TOKEN(sym__command_token);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(614);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1211:
      ACCEPT_TOKEN(sym__command_token);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(619);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1212:
      ACCEPT_TOKEN(sym__command_token);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(117);
      if (lookahead != 0) ADVANCE(1199);
      END_STATE();
    case 1213:
      ACCEPT_TOKEN(sym__command_token);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(602);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1214:
      ACCEPT_TOKEN(sym__command_token);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(1214);
      END_STATE();
    case 1215:
      ACCEPT_TOKEN(sym_command_parameter);
      if (lookahead == '%') ADVANCE(1579);
      if (lookahead == '-') ADVANCE(1219);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1234);
      END_STATE();
    case 1216:
      ACCEPT_TOKEN(sym_command_parameter);
      if (lookahead == '%') ADVANCE(1579);
      if (lookahead == '-') ADVANCE(1220);
      if (lookahead == '`') ADVANCE(1234);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '\\') ADVANCE(1563);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1221);
      END_STATE();
    case 1217:
      ACCEPT_TOKEN(sym_command_parameter);
      if (lookahead == '%') ADVANCE(1564);
      if (lookahead == '-') ADVANCE(1219);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1234);
      END_STATE();
    case 1218:
      ACCEPT_TOKEN(sym_command_parameter);
      if (lookahead == '%') ADVANCE(1564);
      if (lookahead == '-') ADVANCE(1220);
      if (lookahead == '`') ADVANCE(1234);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '\\') ADVANCE(1563);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1221);
      END_STATE();
    case 1219:
      ACCEPT_TOKEN(sym_command_parameter);
      if (lookahead == '-') ADVANCE(1219);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1234);
      END_STATE();
    case 1220:
      ACCEPT_TOKEN(sym_command_parameter);
      if (lookahead == '-') ADVANCE(1220);
      if (lookahead == '`') ADVANCE(1234);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '\\') ADVANCE(1563);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1221);
      END_STATE();
    case 1221:
      ACCEPT_TOKEN(sym_command_parameter);
      if (lookahead == '`') ADVANCE(1234);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '\\') ADVANCE(1563);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1221);
      END_STATE();
    case 1222:
      ACCEPT_TOKEN(sym_command_parameter);
      if (lookahead == 'i') ADVANCE(1225);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1234);
      END_STATE();
    case 1223:
      ACCEPT_TOKEN(sym_command_parameter);
      if (lookahead == 'i') ADVANCE(1233);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1234);
      END_STATE();
    case 1224:
      ACCEPT_TOKEN(sym_command_parameter);
      if (lookahead == 'l') ADVANCE(1223);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1234);
      END_STATE();
    case 1225:
      ACCEPT_TOKEN(sym_command_parameter);
      if (lookahead == 'n') ADVANCE(865);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1234);
      END_STATE();
    case 1226:
      ACCEPT_TOKEN(sym_command_parameter);
      if (lookahead == 'n') ADVANCE(1229);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1234);
      END_STATE();
    case 1227:
      ACCEPT_TOKEN(sym_command_parameter);
      if (lookahead == 'o') ADVANCE(1222);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1234);
      END_STATE();
    case 1228:
      ACCEPT_TOKEN(sym_command_parameter);
      if (lookahead == 'o') ADVANCE(1231);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1234);
      END_STATE();
    case 1229:
      ACCEPT_TOKEN(sym_command_parameter);
      if (lookahead == 'o') ADVANCE(1232);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1234);
      END_STATE();
    case 1230:
      ACCEPT_TOKEN(sym_command_parameter);
      if (lookahead == 'p') ADVANCE(1224);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1234);
      END_STATE();
    case 1231:
      ACCEPT_TOKEN(sym_command_parameter);
      if (lookahead == 't') ADVANCE(1616);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1234);
      END_STATE();
    case 1232:
      ACCEPT_TOKEN(sym_command_parameter);
      if (lookahead == 't') ADVANCE(1623);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1234);
      END_STATE();
    case 1233:
      ACCEPT_TOKEN(sym_command_parameter);
      if (lookahead == 't') ADVANCE(881);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1234);
      END_STATE();
    case 1234:
      ACCEPT_TOKEN(sym_command_parameter);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1234);
      END_STATE();
    case 1235:
      ACCEPT_TOKEN(aux_sym__verbatim_command_argument_chars_token1);
      END_STATE();
    case 1236:
      ACCEPT_TOKEN(aux_sym__verbatim_command_argument_chars_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '|') ADVANCE(1246);
      END_STATE();
    case 1237:
      ACCEPT_TOKEN(aux_sym__verbatim_command_argument_chars_token2);
      if (lookahead == '&') ADVANCE(1246);
      if (lookahead == '\n' ||
          lookahead == '|') ADVANCE(1238);
      if (lookahead != 0) ADVANCE(1237);
      END_STATE();
    case 1238:
      ACCEPT_TOKEN(aux_sym__verbatim_command_argument_chars_token2);
      if (lookahead != 0 &&
          lookahead != '&') ADVANCE(1238);
      END_STATE();
    case 1239:
      ACCEPT_TOKEN(aux_sym__verbatim_command_argument_chars_token3);
      if (lookahead == '"') ADVANCE(1241);
      if (lookahead == '#') ADVANCE(549);
      if (lookahead == '&') ADVANCE(1237);
      if (lookahead == ')') ADVANCE(1252);
      if (lookahead == '<') ADVANCE(1242);
      if (lookahead == '`') ADVANCE(1246);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1239);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '|') ADVANCE(1246);
      END_STATE();
    case 1240:
      ACCEPT_TOKEN(aux_sym__verbatim_command_argument_chars_token3);
      if (lookahead == '"') ADVANCE(1241);
      if (lookahead == '#') ADVANCE(549);
      if (lookahead == '&') ADVANCE(1237);
      if (lookahead == '<') ADVANCE(1242);
      if (lookahead == '`') ADVANCE(1246);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1240);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '|') ADVANCE(1246);
      END_STATE();
    case 1241:
      ACCEPT_TOKEN(aux_sym__verbatim_command_argument_chars_token3);
      if (lookahead == '"') ADVANCE(1236);
      if (lookahead == '\n' ||
          lookahead == '|') ADVANCE(105);
      if (lookahead != 0) ADVANCE(1241);
      END_STATE();
    case 1242:
      ACCEPT_TOKEN(aux_sym__verbatim_command_argument_chars_token3);
      if (lookahead == '#') ADVANCE(1244);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '|') ADVANCE(1246);
      END_STATE();
    case 1243:
      ACCEPT_TOKEN(aux_sym__verbatim_command_argument_chars_token3);
      if (lookahead == '#') ADVANCE(1243);
      if (lookahead == '>') ADVANCE(556);
      if (lookahead == '\n' ||
          lookahead == '|') ADVANCE(117);
      if (lookahead != 0) ADVANCE(1244);
      END_STATE();
    case 1244:
      ACCEPT_TOKEN(aux_sym__verbatim_command_argument_chars_token3);
      if (lookahead == '#') ADVANCE(1243);
      if (lookahead == '`') ADVANCE(1245);
      if (lookahead == '\n' ||
          lookahead == '|') ADVANCE(117);
      if (lookahead != 0) ADVANCE(1244);
      END_STATE();
    case 1245:
      ACCEPT_TOKEN(aux_sym__verbatim_command_argument_chars_token3);
      if (lookahead == '\n' ||
          lookahead == '|') ADVANCE(117);
      if (lookahead != 0) ADVANCE(1244);
      END_STATE();
    case 1246:
      ACCEPT_TOKEN(aux_sym__verbatim_command_argument_chars_token3);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '|') ADVANCE(1246);
      END_STATE();
    case 1247:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 1248:
      ACCEPT_TOKEN(anon_sym_param);
      END_STATE();
    case 1249:
      ACCEPT_TOKEN(anon_sym_param);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1250:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 1251:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 1252:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '|') ADVANCE(1246);
      END_STATE();
    case 1253:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 1254:
      ACCEPT_TOKEN(anon_sym_COMMA);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1255:
      ACCEPT_TOKEN(anon_sym_dynamicparam);
      END_STATE();
    case 1256:
      ACCEPT_TOKEN(anon_sym_dynamicparam);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1257:
      ACCEPT_TOKEN(anon_sym_begin);
      END_STATE();
    case 1258:
      ACCEPT_TOKEN(anon_sym_begin);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1259:
      ACCEPT_TOKEN(anon_sym_process);
      END_STATE();
    case 1260:
      ACCEPT_TOKEN(anon_sym_process);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1261:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 1262:
      ACCEPT_TOKEN(anon_sym_end);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1263:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 1264:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1265:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 1266:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 1267:
      ACCEPT_TOKEN(anon_sym_if);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1268:
      ACCEPT_TOKEN(anon_sym_elseif);
      END_STATE();
    case 1269:
      ACCEPT_TOKEN(anon_sym_elseif);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1270:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == 'i') ADVANCE(291);
      END_STATE();
    case 1271:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == 'i') ADVANCE(1417);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1272:
      ACCEPT_TOKEN(anon_sym_else);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1273:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 1274:
      ACCEPT_TOKEN(anon_sym_switch);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1275:
      ACCEPT_TOKEN(anon_sym_DASHregex);
      END_STATE();
    case 1276:
      ACCEPT_TOKEN(anon_sym_DASHwildcard);
      END_STATE();
    case 1277:
      ACCEPT_TOKEN(anon_sym_DASHexact);
      END_STATE();
    case 1278:
      ACCEPT_TOKEN(anon_sym_DASHcasesensitive);
      END_STATE();
    case 1279:
      ACCEPT_TOKEN(anon_sym_DASHparallel);
      END_STATE();
    case 1280:
      ACCEPT_TOKEN(anon_sym_DASHfile);
      END_STATE();
    case 1281:
      ACCEPT_TOKEN(anon_sym_foreach);
      END_STATE();
    case 1282:
      ACCEPT_TOKEN(anon_sym_foreach);
      if (lookahead == '-') ADVANCE(414);
      END_STATE();
    case 1283:
      ACCEPT_TOKEN(anon_sym_foreach);
      if (lookahead == '-') ADVANCE(414);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1284:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 1285:
      ACCEPT_TOKEN(anon_sym_for);
      if (lookahead == 'e') ADVANCE(1380);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1286:
      ACCEPT_TOKEN(anon_sym_for);
      if (lookahead == 'e') ADVANCE(191);
      END_STATE();
    case 1287:
      ACCEPT_TOKEN(anon_sym_for);
      if (lookahead == 'e') ADVANCE(194);
      END_STATE();
    case 1288:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(1288);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1349);
      END_STATE();
    case 1289:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(1289);
      END_STATE();
    case 1290:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 1291:
      ACCEPT_TOKEN(anon_sym_while);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1292:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 1293:
      ACCEPT_TOKEN(anon_sym_do);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1294:
      ACCEPT_TOKEN(anon_sym_until);
      END_STATE();
    case 1295:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 1296:
      ACCEPT_TOKEN(anon_sym_function);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1297:
      ACCEPT_TOKEN(anon_sym_filter);
      END_STATE();
    case 1298:
      ACCEPT_TOKEN(anon_sym_filter);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1299:
      ACCEPT_TOKEN(anon_sym_workflow);
      END_STATE();
    case 1300:
      ACCEPT_TOKEN(anon_sym_workflow);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1301:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 1302:
      ACCEPT_TOKEN(anon_sym_break);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1303:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 1304:
      ACCEPT_TOKEN(anon_sym_continue);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1305:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 1306:
      ACCEPT_TOKEN(anon_sym_throw);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1307:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 1308:
      ACCEPT_TOKEN(anon_sym_return);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1309:
      ACCEPT_TOKEN(anon_sym_exit);
      END_STATE();
    case 1310:
      ACCEPT_TOKEN(anon_sym_exit);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1311:
      ACCEPT_TOKEN(sym_label);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1311);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1312:
      ACCEPT_TOKEN(sym_label);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1312);
      END_STATE();
    case 1313:
      ACCEPT_TOKEN(anon_sym_trap);
      END_STATE();
    case 1314:
      ACCEPT_TOKEN(anon_sym_trap);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1315:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 1316:
      ACCEPT_TOKEN(anon_sym_try);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1317:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 1318:
      ACCEPT_TOKEN(anon_sym_catch);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1319:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 1320:
      ACCEPT_TOKEN(anon_sym_finally);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1321:
      ACCEPT_TOKEN(anon_sym_data);
      END_STATE();
    case 1322:
      ACCEPT_TOKEN(anon_sym_data);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1323:
      ACCEPT_TOKEN(anon_sym_DASHsupportedcommand);
      END_STATE();
    case 1324:
      ACCEPT_TOKEN(anon_sym_inlinescript);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1325:
      ACCEPT_TOKEN(anon_sym_parallel);
      END_STATE();
    case 1326:
      ACCEPT_TOKEN(anon_sym_parallel);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1327:
      ACCEPT_TOKEN(anon_sym_sequence);
      END_STATE();
    case 1328:
      ACCEPT_TOKEN(anon_sym_sequence);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1329:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 1330:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 1331:
      ACCEPT_TOKEN(aux_sym__expandable_string_literal_immediate_token1);
      if (lookahead == '#') ADVANCE(548);
      if (lookahead == '<') ADVANCE(1332);
      if (lookahead == '@') ADVANCE(1336);
      if (lookahead == '`') ADVANCE(25);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1331);
      if (lookahead != 0 &&
          (lookahead < '"' || '$' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1332:
      ACCEPT_TOKEN(aux_sym__expandable_string_literal_immediate_token1);
      if (lookahead == '#') ADVANCE(1334);
      if (lookahead != 0 &&
          (lookahead < '"' || '$' < lookahead) &&
          lookahead != '`') ADVANCE(1338);
      END_STATE();
    case 1333:
      ACCEPT_TOKEN(aux_sym__expandable_string_literal_immediate_token1);
      if (lookahead == '#') ADVANCE(1333);
      if (lookahead == '>') ADVANCE(555);
      if (('"' <= lookahead && lookahead <= '$') ||
          lookahead == '`') ADVANCE(117);
      if (lookahead != 0) ADVANCE(1334);
      END_STATE();
    case 1334:
      ACCEPT_TOKEN(aux_sym__expandable_string_literal_immediate_token1);
      if (lookahead == '#') ADVANCE(1333);
      if (lookahead == '`') ADVANCE(528);
      if (('"' <= lookahead && lookahead <= '$')) ADVANCE(117);
      if (lookahead != 0) ADVANCE(1334);
      END_STATE();
    case 1335:
      ACCEPT_TOKEN(aux_sym__expandable_string_literal_immediate_token1);
      if (lookahead == ':') ADVANCE(1337);
      if (lookahead == '?') ADVANCE(1128);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1125);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1336:
      ACCEPT_TOKEN(aux_sym__expandable_string_literal_immediate_token1);
      if (lookahead == '?') ADVANCE(1128);
      if (lookahead == 'g') ADVANCE(1011);
      if (lookahead == 'l') ADVANCE(1017);
      if (lookahead == 'p') ADVANCE(1019);
      if (lookahead == 's') ADVANCE(1002);
      if (lookahead == 'u') ADVANCE(1022);
      if (lookahead == 'w') ADVANCE(1016);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1027);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1337:
      ACCEPT_TOKEN(aux_sym__expandable_string_literal_immediate_token1);
      if (lookahead == '?') ADVANCE(1128);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1125);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          (lookahead < '_' || 'z' < lookahead)) ADVANCE(1338);
      END_STATE();
    case 1338:
      ACCEPT_TOKEN(aux_sym__expandable_string_literal_immediate_token1);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '`') ADVANCE(1338);
      END_STATE();
    case 1339:
      ACCEPT_TOKEN(aux_sym__expandable_string_literal_immediate_token2);
      END_STATE();
    case 1340:
      ACCEPT_TOKEN(aux_sym__expandable_string_literal_immediate_token2);
      if (lookahead == '\n') ADVANCE(1339);
      END_STATE();
    case 1341:
      ACCEPT_TOKEN(aux_sym__expandable_string_literal_immediate_token3);
      END_STATE();
    case 1342:
      ACCEPT_TOKEN(aux_sym__expandable_string_literal_immediate_token3);
      if (lookahead == '`') ADVANCE(25);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1331);
      END_STATE();
    case 1343:
      ACCEPT_TOKEN(anon_sym_DQUOTE_DQUOTE2);
      END_STATE();
    case 1344:
      ACCEPT_TOKEN(anon_sym_DOLLAR2);
      END_STATE();
    case 1345:
      ACCEPT_TOKEN(anon_sym_DOLLAR2);
      ADVANCE_MAP(
        '$', 886,
        '(', 1638,
        '?', 892,
        '^', 889,
        '_', 895,
        '`', 158,
        'g', 912,
        'l', 918,
        'p', 920,
        's', 903,
        'u', 923,
        'w', 917,
        '{', 527,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 1346:
      ACCEPT_TOKEN(anon_sym_DOLLAR2);
      ADVANCE_MAP(
        '$', 886,
        '(', 1638,
        '?', 892,
        '^', 889,
        '_', 895,
        'g', 912,
        'l', 918,
        'p', 920,
        's', 903,
        'u', 923,
        'w', 917,
        '{', 527,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(928);
      END_STATE();
    case 1347:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 1348:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      if (lookahead == '"') ADVANCE(1343);
      END_STATE();
    case 1349:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      ADVANCE_MAP(
        '\n', 1288,
        '#', 552,
        '.', 748,
        '0', 571,
        'f', 1471,
        0xa0, 1349,
        0x200b, 1349,
        0x2060, 1349,
        0xfeff, 1349,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(572);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1350:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      ADVANCE_MAP(
        '#', 552,
        '.', 748,
        '0', 571,
        ':', 1513,
        'b', 1480,
        'c', 1441,
        'd', 1370,
        'e', 1456,
        'f', 1426,
        'i', 1416,
        'p', 1378,
        'r', 1408,
        's', 1401,
        't', 1425,
        'w', 1424,
        0xa0, 1350,
        0x200b, 1350,
        0x2060, 1350,
        0xfeff, 1350,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(572);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1351:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      ADVANCE_MAP(
        '#', 552,
        '.', 748,
        '0', 571,
        ':', 1513,
        'b', 1480,
        'c', 1441,
        'd', 1370,
        'e', 1456,
        'f', 1426,
        'i', 1416,
        'p', 1387,
        'r', 1408,
        's', 1401,
        't', 1425,
        'w', 1424,
        0xa0, 1351,
        0x200b, 1351,
        0x2060, 1351,
        0xfeff, 1351,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(572);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1352:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      ADVANCE_MAP(
        '#', 552,
        '.', 748,
        '0', 571,
        ':', 1513,
        'b', 1480,
        'c', 1441,
        'd', 1370,
        'e', 1456,
        'f', 1427,
        'i', 1416,
        'p', 1387,
        'r', 1408,
        's', 1401,
        't', 1425,
        'w', 1424,
        0xa0, 1352,
        0x200b, 1352,
        0x2060, 1352,
        0xfeff, 1352,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(572);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1353:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      ADVANCE_MAP(
        '#', 552,
        '.', 748,
        '0', 571,
        ':', 1513,
        'b', 1480,
        'c', 1441,
        'd', 1370,
        'e', 1446,
        'f', 1426,
        'i', 1416,
        'p', 1387,
        'r', 1408,
        's', 1401,
        't', 1425,
        'w', 1424,
        0xa0, 1353,
        0x200b, 1353,
        0x2060, 1353,
        0xfeff, 1353,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(572);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1354:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      ADVANCE_MAP(
        '#', 552,
        '.', 748,
        '0', 571,
        ':', 1513,
        'b', 1480,
        'c', 1441,
        'd', 1370,
        'e', 1452,
        'f', 1426,
        'i', 1416,
        'p', 1387,
        'r', 1408,
        's', 1401,
        't', 1425,
        'w', 1424,
        0xa0, 1354,
        0x200b, 1354,
        0x2060, 1354,
        0xfeff, 1354,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(572);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1355:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      ADVANCE_MAP(
        '#', 552,
        '.', 748,
        '0', 571,
        ':', 1513,
        'b', 1480,
        'c', 1384,
        'd', 1370,
        'e', 1456,
        'f', 1427,
        'i', 1416,
        'p', 1387,
        'r', 1408,
        's', 1401,
        't', 1425,
        'w', 1424,
        0xa0, 1355,
        0x200b, 1355,
        0x2060, 1355,
        0xfeff, 1355,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(572);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1356:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      ADVANCE_MAP(
        '#', 552,
        '.', 748,
        '0', 571,
        ':', 1513,
        'b', 1405,
        'c', 1441,
        'd', 1369,
        'e', 1460,
        'f', 1426,
        'i', 1416,
        'p', 1377,
        'r', 1408,
        's', 1401,
        't', 1425,
        'w', 1424,
        0xa0, 1356,
        0x200b, 1356,
        0x2060, 1356,
        0xfeff, 1356,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(572);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1357:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      ADVANCE_MAP(
        '#', 552,
        '.', 748,
        '0', 571,
        ':', 1513,
        'b', 1405,
        'c', 1441,
        'd', 1369,
        'e', 1460,
        'f', 1426,
        'i', 1416,
        'p', 1386,
        'r', 1408,
        's', 1401,
        't', 1425,
        'w', 1424,
        0xa0, 1357,
        0x200b, 1357,
        0x2060, 1357,
        0xfeff, 1357,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(572);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1358:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      ADVANCE_MAP(
        '#', 552,
        '.', 748,
        '0', 571,
        'f', 1471,
        0xa0, 1358,
        0x200b, 1358,
        0x2060, 1358,
        0xfeff, 1358,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(572);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1359:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == '#') ADVANCE(552);
      if (lookahead == '.') ADVANCE(1365);
      if (lookahead == '0') ADVANCE(559);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1359);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(560);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1367);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '9' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '?' || ']' < lookahead) &&
          (lookahead < '_' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 1360:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == '#') ADVANCE(552);
      if (lookahead == '.') ADVANCE(749);
      if (lookahead == 'f') ADVANCE(1471);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1360);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1361:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == '+') ADVANCE(525);
      if (lookahead == '-') ADVANCE(1562);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(609);
      if (lookahead == '.' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1367);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < '$' || '9' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '?' || ']' < lookahead) &&
          (lookahead < '_' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 1362:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == '-') ADVANCE(1563);
      if (lookahead == 'b') ADVANCE(562);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1367);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < '$' || '9' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '?' || ']' < lookahead) &&
          (lookahead < '_' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 1363:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == '-') ADVANCE(1563);
      if (lookahead == 'b') ADVANCE(610);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1367);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < '$' || '9' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '?' || ']' < lookahead) &&
          (lookahead < '_' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 1364:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == '-') ADVANCE(1563);
      if (lookahead == 'b') ADVANCE(595);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1367);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < '$' || '9' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '?' || ']' < lookahead) &&
          (lookahead < '_' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 1365:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == '-') ADVANCE(1563);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(608);
      if (lookahead == '.' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1367);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < '$' || '9' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '?' || ']' < lookahead) &&
          (lookahead < '_' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 1366:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == '-') ADVANCE(1563);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(593);
      if (lookahead == '.' ||
          lookahead == '?' ||
          ('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(1367);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < '$' || '9' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '?' || ']' < lookahead) &&
          (lookahead < '_' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 1367:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == '-') ADVANCE(1563);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1367);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < '$' || '9' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '?' || ']' < lookahead) &&
          (lookahead < '_' || '}' < lookahead)) ADVANCE(1514);
      END_STATE();
    case 1368:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == '-') ADVANCE(414);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1369:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'a') ADVANCE(1499);
      if (lookahead == 'o') ADVANCE(1293);
      if (lookahead == 'y') ADVANCE(1465);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1370:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'a') ADVANCE(1499);
      if (lookahead == 'o') ADVANCE(1293);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1371:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'a') ADVANCE(1489);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1372:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'a') ADVANCE(1472);
      if (lookahead == 'y') ADVANCE(1316);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1373:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'a') ADVANCE(1322);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1374:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'a') ADVANCE(1450);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1375:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'a') ADVANCE(1455);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1376:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'a') ADVANCE(1438);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1377:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'a') ADVANCE(1481);
      if (lookahead == 'r') ADVANCE(1470);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1378:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'a') ADVANCE(1481);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1379:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'a') ADVANCE(1454);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1380:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'a') ADVANCE(1392);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1381:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'a') ADVANCE(1451);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1382:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'a') ADVANCE(1448);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1383:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'a') ADVANCE(1394);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1384:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'a') ADVANCE(1502);
      if (lookahead == 'l') ADVANCE(1371);
      if (lookahead == 'o') ADVANCE(1462);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1385:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'a') ADVANCE(1484);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1386:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'a') ADVANCE(1485);
      if (lookahead == 'r') ADVANCE(1470);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1387:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'a') ADVANCE(1485);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1388:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'b') ADVANCE(589);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1389:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'b') ADVANCE(621);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1390:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'b') ADVANCE(604);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1391:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'c') ADVANCE(1420);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1392:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'c') ADVANCE(1421);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1393:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'c') ADVANCE(1474);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1394:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'c') ADVANCE(1422);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1395:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'c') ADVANCE(1423);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1396:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'c') ADVANCE(1483);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1397:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'c') ADVANCE(1404);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1398:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'c') ADVANCE(1415);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1399:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'c') ADVANCE(1501);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1400:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'd') ADVANCE(1262);
      if (lookahead == 'u') ADVANCE(1453);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1401:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'e') ADVANCE(1475);
      if (lookahead == 'w') ADVANCE(1434);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1402:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'e') ADVANCE(1291);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1403:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'e') ADVANCE(1304);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1404:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'e') ADVANCE(1328);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1405:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'e') ADVANCE(1419);
      if (lookahead == 'r') ADVANCE(1409);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1406:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'e') ADVANCE(1271);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1407:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'e') ADVANCE(1272);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1408:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'e') ADVANCE(1496);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1409:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'e') ADVANCE(1376);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1410:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'e') ADVANCE(1491);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1411:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'e') ADVANCE(1439);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1412:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'e') ADVANCE(1463);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1413:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'e') ADVANCE(1479);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1414:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'e') ADVANCE(1383);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1415:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'e') ADVANCE(1490);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1416:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'f') ADVANCE(1267);
      if (lookahead == 'n') ADVANCE(1442);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1417:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'f') ADVANCE(1269);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1418:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'f') ADVANCE(1449);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1419:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'g') ADVANCE(1436);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1420:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'h') ADVANCE(1274);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1421:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'h') ADVANCE(1283);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1422:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'h') ADVANCE(1368);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1423:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'h') ADVANCE(1318);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1424:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'h') ADVANCE(1431);
      if (lookahead == 'o') ADVANCE(1478);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1425:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'h') ADVANCE(1477);
      if (lookahead == 'r') ADVANCE(1372);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1426:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'i') ADVANCE(1445);
      if (lookahead == 'o') ADVANCE(1476);
      if (lookahead == 'u') ADVANCE(1457);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1427:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'i') ADVANCE(1444);
      if (lookahead == 'o') ADVANCE(1476);
      if (lookahead == 'u') ADVANCE(1457);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1428:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'i') ADVANCE(1469);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1429:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'i') ADVANCE(1473);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1430:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'i') ADVANCE(1464);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1431:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'i') ADVANCE(1443);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1432:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'i') ADVANCE(1466);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1433:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'i') ADVANCE(1494);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1434:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'i') ADVANCE(1497);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1435:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'i') ADVANCE(1393);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1436:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'i') ADVANCE(1461);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1437:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'k') ADVANCE(1418);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1438:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'k') ADVANCE(1302);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1439:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'l') ADVANCE(1326);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1440:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'l') ADVANCE(1509);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1441:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'l') ADVANCE(1371);
      if (lookahead == 'o') ADVANCE(1462);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1442:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'l') ADVANCE(1430);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1443:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'l') ADVANCE(1402);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1444:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'l') ADVANCE(1498);
      if (lookahead == 'n') ADVANCE(1382);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1445:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'l') ADVANCE(1498);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1446:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'l') ADVANCE(1492);
      if (lookahead == 'n') ADVANCE(1503);
      if (lookahead == 'x') ADVANCE(1433);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1447:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'l') ADVANCE(1411);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1448:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'l') ADVANCE(1440);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1449:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'l') ADVANCE(1468);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1450:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'l') ADVANCE(1447);
      if (lookahead == 'm') ADVANCE(1249);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1451:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'l') ADVANCE(1447);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1452:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'l') ADVANCE(1493);
      if (lookahead == 'n') ADVANCE(1503);
      if (lookahead == 'x') ADVANCE(1433);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1453:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'm') ADVANCE(1587);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1454:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'm') ADVANCE(1256);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1455:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'm') ADVANCE(1435);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1456:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'n') ADVANCE(1503);
      if (lookahead == 'x') ADVANCE(1433);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1457:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'n') ADVANCE(1399);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1458:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'n') ADVANCE(1308);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1459:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'n') ADVANCE(1296);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1460:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'n') ADVANCE(1400);
      if (lookahead == 'x') ADVANCE(1433);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1461:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'n') ADVANCE(1258);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1462:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'n') ADVANCE(1500);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1463:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'n') ADVANCE(1397);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1464:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'n') ADVANCE(1410);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1465:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'n') ADVANCE(1375);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1466:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'n') ADVANCE(1506);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1467:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'o') ADVANCE(1507);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1468:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'o') ADVANCE(1508);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1469:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'o') ADVANCE(1459);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1470:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'o') ADVANCE(1398);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1471:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'o') ADVANCE(1486);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1472:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'p') ADVANCE(1314);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1473:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'p') ADVANCE(1495);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1474:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'p') ADVANCE(1385);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1475:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'q') ADVANCE(1504);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1476:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'r') ADVANCE(1285);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1477:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'r') ADVANCE(1467);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1478:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'r') ADVANCE(1437);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1479:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'r') ADVANCE(1298);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1480:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'r') ADVANCE(1409);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1481:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'r') ADVANCE(1374);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1482:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'r') ADVANCE(1458);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1483:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'r') ADVANCE(1429);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1484:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'r') ADVANCE(1379);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1485:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'r') ADVANCE(1381);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1486:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'r') ADVANCE(1414);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1487:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 's') ADVANCE(1585);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1488:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 's') ADVANCE(1260);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1489:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 's') ADVANCE(1487);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1490:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 's') ADVANCE(1488);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1491:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 's') ADVANCE(1396);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1492:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 's') ADVANCE(1406);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1493:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 's') ADVANCE(1407);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1494:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 't') ADVANCE(1310);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1495:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 't') ADVANCE(1324);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1496:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 't') ADVANCE(1505);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1497:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 't') ADVANCE(1391);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1498:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 't') ADVANCE(1413);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1499:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 't') ADVANCE(1373);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1500:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 't') ADVANCE(1432);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1501:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 't') ADVANCE(1428);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1502:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 't') ADVANCE(1395);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1503:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'u') ADVANCE(1453);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1504:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'u') ADVANCE(1412);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1505:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'u') ADVANCE(1482);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1506:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'u') ADVANCE(1403);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1507:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'w') ADVANCE(1306);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1508:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'w') ADVANCE(1300);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1509:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == 'y') ADVANCE(1320);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1510:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(525);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(617);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1511:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(612);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1512:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(598);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1513:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1311);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1514:
      ACCEPT_TOKEN(aux_sym_command_name_token1);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1515:
      ACCEPT_TOKEN(aux_sym_command_name_token2);
      ADVANCE_MAP(
        '#', 1534,
        '*', 1527,
        '-', 1524,
        '1', 1528,
        '2', 1529,
        '3', 1530,
        '4', 1531,
        '5', 1532,
        '6', 1533,
        ':', 1571,
        '<', 803,
        '>', 761,
        '`', 1538,
        0xa0, 1515,
        0x200b, 1515,
        0x2060, 1515,
        0xfeff, 1515,
      );
      if (((!eof && set_contains(sym_generic_token_character_set_1, 11, lookahead)) ||
          lookahead == '$' ||
          lookahead == '@' ||
          lookahead == '[') &&
          lookahead != '&' &&
          lookahead != ',' &&
          (lookahead < ':' || '<' < lookahead)) ADVANCE(1538);
      END_STATE();
    case 1516:
      ACCEPT_TOKEN(aux_sym_command_name_token2);
      ADVANCE_MAP(
        '#', 1534,
        '*', 1527,
        '-', 1526,
        '1', 1528,
        '2', 1529,
        '3', 1530,
        '4', 1531,
        '5', 1532,
        '6', 1533,
        ':', 1571,
        '<', 803,
        '>', 761,
        '`', 1538,
        0xa0, 1516,
        0x200b, 1516,
        0x2060, 1516,
        0xfeff, 1516,
      );
      if (((!eof && set_contains(sym_generic_token_character_set_1, 11, lookahead)) ||
          lookahead == '$' ||
          lookahead == '@' ||
          lookahead == '[') &&
          lookahead != '&' &&
          lookahead != ',' &&
          (lookahead < ':' || '<' < lookahead)) ADVANCE(1538);
      END_STATE();
    case 1517:
      ACCEPT_TOKEN(aux_sym_command_name_token2);
      if (lookahead == '#') ADVANCE(1534);
      if (lookahead == '<') ADVANCE(1518);
      if (lookahead == '`') ADVANCE(1538);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1517);
      if (((!eof && set_contains(sym_generic_token_character_set_1, 11, lookahead)) ||
          lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '@' ||
          lookahead == '[') &&
          lookahead != '&' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '<') ADVANCE(1538);
      END_STATE();
    case 1518:
      ACCEPT_TOKEN(aux_sym_command_name_token2);
      if (lookahead == '#') ADVANCE(1520);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1538);
      END_STATE();
    case 1519:
      ACCEPT_TOKEN(aux_sym_command_name_token2);
      if (lookahead == '#') ADVANCE(1519);
      if (lookahead == '>') ADVANCE(1538);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == '"' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ',' ||
          lookahead == ';' ||
          ('{' <= lookahead && lookahead <= '}')) ADVANCE(117);
      if (lookahead != 0) ADVANCE(1520);
      END_STATE();
    case 1520:
      ACCEPT_TOKEN(aux_sym_command_name_token2);
      if (lookahead == '#') ADVANCE(1519);
      if (lookahead == '`') ADVANCE(1536);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == '"' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ',' ||
          lookahead == ';' ||
          ('{' <= lookahead && lookahead <= '}')) ADVANCE(117);
      if (lookahead != 0) ADVANCE(1520);
      END_STATE();
    case 1521:
      ACCEPT_TOKEN(aux_sym_command_name_token2);
      if (lookahead == '%') ADVANCE(1578);
      if (lookahead == '-') ADVANCE(1525);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1537);
      if (((!eof && set_contains(sym_generic_token_character_set_1, 11, lookahead)) ||
          lookahead == '$' ||
          ('@' <= lookahead && lookahead <= '[')) &&
          lookahead != '%' &&
          lookahead != '&' &&
          lookahead != ',' &&
          lookahead != ';') ADVANCE(1538);
      END_STATE();
    case 1522:
      ACCEPT_TOKEN(aux_sym_command_name_token2);
      if (lookahead == '%') ADVANCE(1535);
      if (lookahead == '-') ADVANCE(1525);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1537);
      if (((!eof && set_contains(sym_generic_token_character_set_1, 11, lookahead)) ||
          lookahead == '$' ||
          ('@' <= lookahead && lookahead <= '[')) &&
          lookahead != '%' &&
          lookahead != '&' &&
          lookahead != ',' &&
          lookahead != ';') ADVANCE(1538);
      END_STATE();
    case 1523:
      ACCEPT_TOKEN(aux_sym_command_name_token2);
      if (lookahead == '&') ADVANCE(139);
      if (((!eof && set_contains(sym_generic_token_character_set_1, 11, lookahead)) ||
          lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '@' ||
          lookahead == '[' ||
          lookahead == '`') &&
          lookahead != ',' &&
          lookahead != ';') ADVANCE(1538);
      END_STATE();
    case 1524:
      ACCEPT_TOKEN(aux_sym_command_name_token2);
      if (lookahead == '-') ADVANCE(1521);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1537);
      if (((!eof && set_contains(sym_generic_token_character_set_1, 11, lookahead)) ||
          lookahead == '$' ||
          ('@' <= lookahead && lookahead <= '[')) &&
          lookahead != '&' &&
          lookahead != ',' &&
          lookahead != ';') ADVANCE(1538);
      END_STATE();
    case 1525:
      ACCEPT_TOKEN(aux_sym_command_name_token2);
      if (lookahead == '-') ADVANCE(1525);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1537);
      if (((!eof && set_contains(sym_generic_token_character_set_1, 11, lookahead)) ||
          lookahead == '$' ||
          ('@' <= lookahead && lookahead <= '[')) &&
          lookahead != '&' &&
          lookahead != ',' &&
          lookahead != ';') ADVANCE(1538);
      END_STATE();
    case 1526:
      ACCEPT_TOKEN(aux_sym_command_name_token2);
      if (lookahead == '-') ADVANCE(1522);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1537);
      if (((!eof && set_contains(sym_generic_token_character_set_1, 11, lookahead)) ||
          lookahead == '$' ||
          ('@' <= lookahead && lookahead <= '[')) &&
          lookahead != '&' &&
          lookahead != ',' &&
          lookahead != ';') ADVANCE(1538);
      END_STATE();
    case 1527:
      ACCEPT_TOKEN(aux_sym_command_name_token2);
      if (lookahead == '>') ADVANCE(796);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1538);
      END_STATE();
    case 1528:
      ACCEPT_TOKEN(aux_sym_command_name_token2);
      if (lookahead == '>') ADVANCE(1523);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1538);
      END_STATE();
    case 1529:
      ACCEPT_TOKEN(aux_sym_command_name_token2);
      if (lookahead == '>') ADVANCE(766);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1538);
      END_STATE();
    case 1530:
      ACCEPT_TOKEN(aux_sym_command_name_token2);
      if (lookahead == '>') ADVANCE(772);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1538);
      END_STATE();
    case 1531:
      ACCEPT_TOKEN(aux_sym_command_name_token2);
      if (lookahead == '>') ADVANCE(778);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1538);
      END_STATE();
    case 1532:
      ACCEPT_TOKEN(aux_sym_command_name_token2);
      if (lookahead == '>') ADVANCE(784);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1538);
      END_STATE();
    case 1533:
      ACCEPT_TOKEN(aux_sym_command_name_token2);
      if (lookahead == '>') ADVANCE(790);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1538);
      END_STATE();
    case 1534:
      ACCEPT_TOKEN(aux_sym_command_name_token2);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == '"' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ',' ||
          lookahead == ';' ||
          ('{' <= lookahead && lookahead <= '}')) ADVANCE(557);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(1534);
      END_STATE();
    case 1535:
      ACCEPT_TOKEN(aux_sym_command_name_token2);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == '"' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ',' ||
          lookahead == ';' ||
          ('{' <= lookahead && lookahead <= '}')) ADVANCE(1564);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(1535);
      END_STATE();
    case 1536:
      ACCEPT_TOKEN(aux_sym_command_name_token2);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == '"' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ',' ||
          lookahead == ';' ||
          ('{' <= lookahead && lookahead <= '}')) ADVANCE(117);
      if (lookahead != 0) ADVANCE(1520);
      END_STATE();
    case 1537:
      ACCEPT_TOKEN(aux_sym_command_name_token2);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1537);
      if (((!eof && set_contains(sym_generic_token_character_set_1, 11, lookahead)) ||
          lookahead == '$' ||
          ('@' <= lookahead && lookahead <= '[')) &&
          lookahead != '&' &&
          lookahead != ',' &&
          lookahead != ';') ADVANCE(1538);
      END_STATE();
    case 1538:
      ACCEPT_TOKEN(aux_sym_command_name_token2);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1538);
      END_STATE();
    case 1539:
      ACCEPT_TOKEN(anon_sym_DQUOTE2);
      END_STATE();
    case 1540:
      ACCEPT_TOKEN(anon_sym_DQUOTE2);
      if (lookahead == '"') ADVANCE(673);
      END_STATE();
    case 1541:
      ACCEPT_TOKEN(anon_sym_SQUOTE_SQUOTE);
      END_STATE();
    case 1542:
      ACCEPT_TOKEN(sym_path_command_name_token);
      if (lookahead == '%') ADVANCE(1576);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 1543:
      ACCEPT_TOKEN(sym_path_command_name_token);
      if (lookahead == '-') ADVANCE(1631);
      if (lookahead == '`') ADVANCE(1234);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '\\') ADVANCE(1563);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1221);
      END_STATE();
    case 1544:
      ACCEPT_TOKEN(sym_path_command_name_token);
      if (lookahead == '-') ADVANCE(1216);
      if (lookahead == '`') ADVANCE(1234);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '\\') ADVANCE(1563);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1221);
      END_STATE();
    case 1545:
      ACCEPT_TOKEN(sym_path_command_name_token);
      if (lookahead == '-') ADVANCE(1636);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 1546:
      ACCEPT_TOKEN(sym_path_command_name_token);
      if (lookahead == '-') ADVANCE(1542);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 1547:
      ACCEPT_TOKEN(sym_path_command_name_token);
      if (lookahead == '-') ADVANCE(1633);
      if (lookahead == '`') ADVANCE(1234);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '\\') ADVANCE(1563);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1221);
      END_STATE();
    case 1548:
      ACCEPT_TOKEN(sym_path_command_name_token);
      if (lookahead == '-') ADVANCE(1218);
      if (lookahead == '`') ADVANCE(1234);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '\\') ADVANCE(1563);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1221);
      END_STATE();
    case 1549:
      ACCEPT_TOKEN(sym_path_command_name_token);
      if (lookahead == '>') ADVANCE(122);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 1550:
      ACCEPT_TOKEN(sym_path_command_name_token);
      if (lookahead == '>') ADVANCE(765);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 1551:
      ACCEPT_TOKEN(sym_path_command_name_token);
      if (lookahead == '>') ADVANCE(771);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 1552:
      ACCEPT_TOKEN(sym_path_command_name_token);
      if (lookahead == '>') ADVANCE(777);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 1553:
      ACCEPT_TOKEN(sym_path_command_name_token);
      if (lookahead == '>') ADVANCE(783);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 1554:
      ACCEPT_TOKEN(sym_path_command_name_token);
      if (lookahead == '>') ADVANCE(789);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 1555:
      ACCEPT_TOKEN(sym_path_command_name_token);
      if (lookahead == 'a') ADVANCE(1557);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 1556:
      ACCEPT_TOKEN(sym_path_command_name_token);
      if (lookahead == 'b') ADVANCE(620);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 1557:
      ACCEPT_TOKEN(sym_path_command_name_token);
      if (lookahead == 'c') ADVANCE(1559);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 1558:
      ACCEPT_TOKEN(sym_path_command_name_token);
      if (lookahead == 'e') ADVANCE(1555);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 1559:
      ACCEPT_TOKEN(sym_path_command_name_token);
      if (lookahead == 'h') ADVANCE(1651);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 1560:
      ACCEPT_TOKEN(sym_path_command_name_token);
      if (lookahead == 'o') ADVANCE(1561);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 1561:
      ACCEPT_TOKEN(sym_path_command_name_token);
      if (lookahead == 'r') ADVANCE(1558);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 1562:
      ACCEPT_TOKEN(sym_path_command_name_token);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(615);
      if (lookahead == '-' ||
          lookahead == '.' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 1563:
      ACCEPT_TOKEN(sym_path_command_name_token);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 1564:
      ACCEPT_TOKEN(sym_stop_parsing);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(1564);
      END_STATE();
    case 1565:
      ACCEPT_TOKEN(anon_sym_SPACE);
      if (lookahead == ' ') ADVANCE(1565);
      END_STATE();
    case 1566:
      ACCEPT_TOKEN(anon_sym_SPACE);
      if (lookahead == ' ') ADVANCE(1566);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1132);
      END_STATE();
    case 1567:
      ACCEPT_TOKEN(anon_sym_SPACE);
      if (lookahead == ' ') ADVANCE(1567);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1133);
      END_STATE();
    case 1568:
      ACCEPT_TOKEN(anon_sym_SPACE);
      if (lookahead == ' ') ADVANCE(1568);
      if (lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(1134);
      END_STATE();
    case 1569:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 1570:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(1648);
      END_STATE();
    case 1571:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(1538);
      END_STATE();
    case 1572:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1573:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 1574:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(758);
      END_STATE();
    case 1575:
      ACCEPT_TOKEN(anon_sym_foreach_DASHobject);
      END_STATE();
    case 1576:
      ACCEPT_TOKEN(anon_sym_DASH_DASH_PERCENT);
      END_STATE();
    case 1577:
      ACCEPT_TOKEN(anon_sym_DASH_DASH_PERCENT);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ',' ||
          lookahead == ';' ||
          lookahead == '|' ||
          lookahead == '}') ADVANCE(1564);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(1186);
      END_STATE();
    case 1578:
      ACCEPT_TOKEN(anon_sym_DASH_DASH_PERCENT);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == '"' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ',' ||
          lookahead == ';' ||
          ('{' <= lookahead && lookahead <= '}')) ADVANCE(1564);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(1535);
      END_STATE();
    case 1579:
      ACCEPT_TOKEN(anon_sym_DASH_DASH_PERCENT);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(1564);
      END_STATE();
    case 1580:
      ACCEPT_TOKEN(anon_sym_hidden);
      END_STATE();
    case 1581:
      ACCEPT_TOKEN(anon_sym_hidden);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(744);
      END_STATE();
    case 1582:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 1583:
      ACCEPT_TOKEN(anon_sym_static);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(744);
      END_STATE();
    case 1584:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 1585:
      ACCEPT_TOKEN(anon_sym_class);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1586:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 1587:
      ACCEPT_TOKEN(anon_sym_enum);
      if ((!eof && set_contains(aux_sym_command_name_token1_character_set_1, 11, lookahead))) ADVANCE(1514);
      END_STATE();
    case 1588:
      ACCEPT_TOKEN(anon_sym_DASHand);
      END_STATE();
    case 1589:
      ACCEPT_TOKEN(anon_sym_DASHor);
      END_STATE();
    case 1590:
      ACCEPT_TOKEN(anon_sym_DASHxor);
      END_STATE();
    case 1591:
      ACCEPT_TOKEN(anon_sym_DASHband);
      END_STATE();
    case 1592:
      ACCEPT_TOKEN(anon_sym_DASHbor);
      END_STATE();
    case 1593:
      ACCEPT_TOKEN(anon_sym_DASHbxor);
      END_STATE();
    case 1594:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(1626);
      END_STATE();
    case 1595:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(1626);
      if (lookahead == '=') ADVANCE(755);
      END_STATE();
    case 1596:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(1627);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != '+' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1597:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(755);
      END_STATE();
    case 1598:
      ACCEPT_TOKEN(anon_sym_DASH);
      ADVANCE_MAP(
        '-', 1629,
        'a', 386,
        'b', 170,
        'c', 177,
        'e', 440,
        'f', 885,
        'g', 247,
        'i', 230,
        'j', 416,
        'l', 248,
        'm', 196,
        'n', 249,
        'o', 444,
        'p', 179,
        'r', 251,
        's', 297,
        'w', 316,
        'x', 417,
      );
      END_STATE();
    case 1599:
      ACCEPT_TOKEN(anon_sym_DASH);
      ADVANCE_MAP(
        '-', 1628,
        'a', 386,
        'b', 170,
        'c', 211,
        'e', 439,
        'f', 884,
        'g', 247,
        'i', 230,
        'j', 416,
        'l', 248,
        'm', 196,
        'n', 249,
        'o', 444,
        'r', 288,
        's', 296,
        'x', 417,
      );
      END_STATE();
    case 1600:
      ACCEPT_TOKEN(anon_sym_DASH);
      ADVANCE_MAP(
        '-', 1628,
        'a', 386,
        'b', 171,
        'c', 211,
        'e', 439,
        'f', 884,
        'g', 247,
        'i', 230,
        'j', 416,
        'l', 248,
        'm', 196,
        'n', 250,
        'o', 444,
        'r', 288,
        's', 296,
        'x', 417,
      );
      END_STATE();
    case 1601:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(1628);
      if (lookahead == 'b') ADVANCE(388);
      if (lookahead == 'j') ADVANCE(416);
      if (lookahead == 'n') ADVANCE(424);
      if (lookahead == 's') ADVANCE(431);
      END_STATE();
    case 1602:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(1630);
      if (lookahead == 'b') ADVANCE(1226);
      if (lookahead == 'j') ADVANCE(1227);
      if (lookahead == 'n') ADVANCE(1228);
      if (lookahead == 's') ADVANCE(1230);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1234);
      END_STATE();
    case 1603:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(1634);
      if (lookahead == 'b') ADVANCE(1166);
      if (lookahead == 'j') ADVANCE(1168);
      if (lookahead == 'n') ADVANCE(1169);
      if (lookahead == 's') ADVANCE(1174);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1190);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '-' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1604:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(1637);
      if (lookahead == 'b') ADVANCE(1167);
      if (lookahead == 'j') ADVANCE(1170);
      if (lookahead == 'n') ADVANCE(1171);
      if (lookahead == 's') ADVANCE(1175);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '-' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1605:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(1632);
      if (lookahead == 'b') ADVANCE(1226);
      if (lookahead == 'j') ADVANCE(1227);
      if (lookahead == 'n') ADVANCE(1228);
      if (lookahead == 's') ADVANCE(1230);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1234);
      END_STATE();
    case 1606:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(1635);
      if (lookahead == 'b') ADVANCE(1166);
      if (lookahead == 'j') ADVANCE(1168);
      if (lookahead == 'n') ADVANCE(1169);
      if (lookahead == 's') ADVANCE(1174);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1190);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '-' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1607:
      ACCEPT_TOKEN(anon_sym_DASH);
      ADVANCE_MAP(
        'a', 386,
        'b', 171,
        'c', 211,
        'e', 439,
        'f', 884,
        'g', 247,
        'i', 230,
        'j', 416,
        'l', 248,
        'm', 196,
        'n', 250,
        'o', 444,
        'r', 288,
        's', 296,
        'x', 417,
      );
      END_STATE();
    case 1608:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 1609:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '=') ADVANCE(757);
      END_STATE();
    case 1610:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      END_STATE();
    case 1611:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 1612:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(756);
      if (lookahead == '>') ADVANCE(795);
      END_STATE();
    case 1613:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 1614:
      ACCEPT_TOKEN(anon_sym_DASHnot);
      END_STATE();
    case 1615:
      ACCEPT_TOKEN(anon_sym_DASHnot);
      if (lookahead == 'c') ADVANCE(427);
      if (lookahead == 'i') ADVANCE(382);
      if (lookahead == 'l') ADVANCE(336);
      if (lookahead == 'm') ADVANCE(199);
      END_STATE();
    case 1616:
      ACCEPT_TOKEN(anon_sym_DASHnot);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1234);
      END_STATE();
    case 1617:
      ACCEPT_TOKEN(anon_sym_DASHnot);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1190);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '-' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1618:
      ACCEPT_TOKEN(anon_sym_DASHnot);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1619:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 1620:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(754);
      END_STATE();
    case 1621:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1622:
      ACCEPT_TOKEN(anon_sym_DASHbnot);
      END_STATE();
    case 1623:
      ACCEPT_TOKEN(anon_sym_DASHbnot);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1234);
      END_STATE();
    case 1624:
      ACCEPT_TOKEN(anon_sym_DASHbnot);
      if (lookahead == '-' ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1190);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '-' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1625:
      ACCEPT_TOKEN(anon_sym_DASHbnot);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1626:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 1627:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1628:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 1629:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      if (lookahead == '%') ADVANCE(1579);
      END_STATE();
    case 1630:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      if (lookahead == '%') ADVANCE(1579);
      if (lookahead == '-') ADVANCE(1219);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1234);
      END_STATE();
    case 1631:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      if (lookahead == '%') ADVANCE(1579);
      if (lookahead == '-') ADVANCE(1220);
      if (lookahead == '`') ADVANCE(1234);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '\\') ADVANCE(1563);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1221);
      END_STATE();
    case 1632:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      if (lookahead == '%') ADVANCE(1564);
      if (lookahead == '-') ADVANCE(1219);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1234);
      END_STATE();
    case 1633:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      if (lookahead == '%') ADVANCE(1564);
      if (lookahead == '-') ADVANCE(1220);
      if (lookahead == '`') ADVANCE(1234);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '\\') ADVANCE(1563);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1221);
      END_STATE();
    case 1634:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      if (lookahead == '%') ADVANCE(1577);
      if (lookahead == '-') ADVANCE(1142);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1190);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '-' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1635:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      if (lookahead == '%') ADVANCE(1186);
      if (lookahead == '-') ADVANCE(1142);
      if (lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(1190);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '-' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1636:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 1637:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1638:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      END_STATE();
    case 1639:
      ACCEPT_TOKEN(anon_sym_AT_LPAREN);
      END_STATE();
    case 1640:
      ACCEPT_TOKEN(anon_sym_AT_LBRACE);
      END_STATE();
    case 1641:
      ACCEPT_TOKEN(anon_sym_AT_LBRACE);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(1191);
      END_STATE();
    case 1642:
      ACCEPT_TOKEN(anon_sym_DOT2);
      if (lookahead == '.') ADVANCE(1613);
      if (lookahead == 'f') ADVANCE(422);
      END_STATE();
    case 1643:
      ACCEPT_TOKEN(anon_sym_DOT2);
      if (lookahead == '.') ADVANCE(1613);
      if (lookahead == 'f') ADVANCE(422);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(611);
      END_STATE();
    case 1644:
      ACCEPT_TOKEN(anon_sym_DOT2);
      if (lookahead == 'f') ADVANCE(1560);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    case 1645:
      ACCEPT_TOKEN(anon_sym_DOT2);
      if (lookahead == 'f') ADVANCE(422);
      END_STATE();
    case 1646:
      ACCEPT_TOKEN(anon_sym_DOT2);
      if (lookahead == 'f') ADVANCE(422);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(611);
      END_STATE();
    case 1647:
      ACCEPT_TOKEN(anon_sym_DOT2);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(611);
      END_STATE();
    case 1648:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 1649:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 1650:
      ACCEPT_TOKEN(anon_sym_DOTforeach);
      END_STATE();
    case 1651:
      ACCEPT_TOKEN(anon_sym_DOTforeach);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1563);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 89},
  [2] = {.lex_state = 538, .external_lex_state = 1},
  [3] = {.lex_state = 538},
  [4] = {.lex_state = 538},
  [5] = {.lex_state = 538, .external_lex_state = 1},
  [6] = {.lex_state = 538, .external_lex_state = 1},
  [7] = {.lex_state = 90, .external_lex_state = 1},
  [8] = {.lex_state = 90},
  [9] = {.lex_state = 90},
  [10] = {.lex_state = 90, .external_lex_state = 1},
  [11] = {.lex_state = 90},
  [12] = {.lex_state = 90, .external_lex_state = 1},
  [13] = {.lex_state = 90, .external_lex_state = 1},
  [14] = {.lex_state = 90},
  [15] = {.lex_state = 90},
  [16] = {.lex_state = 90},
  [17] = {.lex_state = 90, .external_lex_state = 1},
  [18] = {.lex_state = 90, .external_lex_state = 1},
  [19] = {.lex_state = 90},
  [20] = {.lex_state = 90},
  [21] = {.lex_state = 90},
  [22] = {.lex_state = 90, .external_lex_state = 1},
  [23] = {.lex_state = 90},
  [24] = {.lex_state = 90, .external_lex_state = 1},
  [25] = {.lex_state = 90, .external_lex_state = 1},
  [26] = {.lex_state = 90},
  [27] = {.lex_state = 90, .external_lex_state = 1},
  [28] = {.lex_state = 90},
  [29] = {.lex_state = 90},
  [30] = {.lex_state = 90},
  [31] = {.lex_state = 90},
  [32] = {.lex_state = 90},
  [33] = {.lex_state = 90},
  [34] = {.lex_state = 90},
  [35] = {.lex_state = 90},
  [36] = {.lex_state = 90},
  [37] = {.lex_state = 90},
  [38] = {.lex_state = 90},
  [39] = {.lex_state = 90},
  [40] = {.lex_state = 91},
  [41] = {.lex_state = 91},
  [42] = {.lex_state = 538},
  [43] = {.lex_state = 538, .external_lex_state = 1},
  [44] = {.lex_state = 540},
  [45] = {.lex_state = 540},
  [46] = {.lex_state = 540},
  [47] = {.lex_state = 540},
  [48] = {.lex_state = 540},
  [49] = {.lex_state = 540},
  [50] = {.lex_state = 540},
  [51] = {.lex_state = 540},
  [52] = {.lex_state = 540},
  [53] = {.lex_state = 540},
  [54] = {.lex_state = 540},
  [55] = {.lex_state = 540},
  [56] = {.lex_state = 540},
  [57] = {.lex_state = 540},
  [58] = {.lex_state = 540},
  [59] = {.lex_state = 540},
  [60] = {.lex_state = 540},
  [61] = {.lex_state = 540},
  [62] = {.lex_state = 540},
  [63] = {.lex_state = 540},
  [64] = {.lex_state = 540},
  [65] = {.lex_state = 540},
  [66] = {.lex_state = 540},
  [67] = {.lex_state = 540},
  [68] = {.lex_state = 540},
  [69] = {.lex_state = 540},
  [70] = {.lex_state = 540},
  [71] = {.lex_state = 540},
  [72] = {.lex_state = 540},
  [73] = {.lex_state = 540},
  [74] = {.lex_state = 540},
  [75] = {.lex_state = 540},
  [76] = {.lex_state = 82},
  [77] = {.lex_state = 82},
  [78] = {.lex_state = 82, .external_lex_state = 1},
  [79] = {.lex_state = 540},
  [80] = {.lex_state = 540},
  [81] = {.lex_state = 82, .external_lex_state = 1},
  [82] = {.lex_state = 540},
  [83] = {.lex_state = 92},
  [84] = {.lex_state = 92},
  [85] = {.lex_state = 92},
  [86] = {.lex_state = 92},
  [87] = {.lex_state = 92},
  [88] = {.lex_state = 92},
  [89] = {.lex_state = 92},
  [90] = {.lex_state = 92},
  [91] = {.lex_state = 92},
  [92] = {.lex_state = 92},
  [93] = {.lex_state = 92},
  [94] = {.lex_state = 92, .external_lex_state = 1},
  [95] = {.lex_state = 92},
  [96] = {.lex_state = 92, .external_lex_state = 1},
  [97] = {.lex_state = 92},
  [98] = {.lex_state = 92},
  [99] = {.lex_state = 92},
  [100] = {.lex_state = 92, .external_lex_state = 1},
  [101] = {.lex_state = 92},
  [102] = {.lex_state = 92},
  [103] = {.lex_state = 92},
  [104] = {.lex_state = 92},
  [105] = {.lex_state = 92},
  [106] = {.lex_state = 92},
  [107] = {.lex_state = 92, .external_lex_state = 1},
  [108] = {.lex_state = 92},
  [109] = {.lex_state = 92},
  [110] = {.lex_state = 92},
  [111] = {.lex_state = 92},
  [112] = {.lex_state = 92},
  [113] = {.lex_state = 92},
  [114] = {.lex_state = 92},
  [115] = {.lex_state = 92},
  [116] = {.lex_state = 92},
  [117] = {.lex_state = 92},
  [118] = {.lex_state = 92},
  [119] = {.lex_state = 92},
  [120] = {.lex_state = 92},
  [121] = {.lex_state = 92},
  [122] = {.lex_state = 92, .external_lex_state = 1},
  [123] = {.lex_state = 92, .external_lex_state = 1},
  [124] = {.lex_state = 92, .external_lex_state = 1},
  [125] = {.lex_state = 92, .external_lex_state = 1},
  [126] = {.lex_state = 92, .external_lex_state = 1},
  [127] = {.lex_state = 92, .external_lex_state = 1},
  [128] = {.lex_state = 92, .external_lex_state = 1},
  [129] = {.lex_state = 92, .external_lex_state = 1},
  [130] = {.lex_state = 92, .external_lex_state = 1},
  [131] = {.lex_state = 92, .external_lex_state = 1},
  [132] = {.lex_state = 92, .external_lex_state = 1},
  [133] = {.lex_state = 92, .external_lex_state = 1},
  [134] = {.lex_state = 92, .external_lex_state = 1},
  [135] = {.lex_state = 92},
  [136] = {.lex_state = 92, .external_lex_state = 1},
  [137] = {.lex_state = 92, .external_lex_state = 1},
  [138] = {.lex_state = 92, .external_lex_state = 1},
  [139] = {.lex_state = 92, .external_lex_state = 1},
  [140] = {.lex_state = 92, .external_lex_state = 1},
  [141] = {.lex_state = 92, .external_lex_state = 1},
  [142] = {.lex_state = 92, .external_lex_state = 1},
  [143] = {.lex_state = 92, .external_lex_state = 1},
  [144] = {.lex_state = 92, .external_lex_state = 1},
  [145] = {.lex_state = 92, .external_lex_state = 1},
  [146] = {.lex_state = 92, .external_lex_state = 1},
  [147] = {.lex_state = 92, .external_lex_state = 1},
  [148] = {.lex_state = 92, .external_lex_state = 1},
  [149] = {.lex_state = 92, .external_lex_state = 1},
  [150] = {.lex_state = 92, .external_lex_state = 1},
  [151] = {.lex_state = 92, .external_lex_state = 1},
  [152] = {.lex_state = 92, .external_lex_state = 1},
  [153] = {.lex_state = 92, .external_lex_state = 1},
  [154] = {.lex_state = 92, .external_lex_state = 1},
  [155] = {.lex_state = 92},
  [156] = {.lex_state = 92, .external_lex_state = 1},
  [157] = {.lex_state = 94},
  [158] = {.lex_state = 94},
  [159] = {.lex_state = 94},
  [160] = {.lex_state = 94},
  [161] = {.lex_state = 94},
  [162] = {.lex_state = 94},
  [163] = {.lex_state = 94},
  [164] = {.lex_state = 94},
  [165] = {.lex_state = 94, .external_lex_state = 1},
  [166] = {.lex_state = 94},
  [167] = {.lex_state = 94, .external_lex_state = 1},
  [168] = {.lex_state = 94},
  [169] = {.lex_state = 94, .external_lex_state = 1},
  [170] = {.lex_state = 94, .external_lex_state = 1},
  [171] = {.lex_state = 94, .external_lex_state = 1},
  [172] = {.lex_state = 94, .external_lex_state = 1},
  [173] = {.lex_state = 94, .external_lex_state = 1},
  [174] = {.lex_state = 94, .external_lex_state = 1},
  [175] = {.lex_state = 94, .external_lex_state = 1},
  [176] = {.lex_state = 94, .external_lex_state = 1},
  [177] = {.lex_state = 94},
  [178] = {.lex_state = 94},
  [179] = {.lex_state = 94, .external_lex_state = 1},
  [180] = {.lex_state = 94, .external_lex_state = 1},
  [181] = {.lex_state = 94, .external_lex_state = 1},
  [182] = {.lex_state = 94},
  [183] = {.lex_state = 94},
  [184] = {.lex_state = 94, .external_lex_state = 1},
  [185] = {.lex_state = 94},
  [186] = {.lex_state = 94, .external_lex_state = 1},
  [187] = {.lex_state = 94, .external_lex_state = 1},
  [188] = {.lex_state = 94},
  [189] = {.lex_state = 82},
  [190] = {.lex_state = 82, .external_lex_state = 1},
  [191] = {.lex_state = 94, .external_lex_state = 1},
  [192] = {.lex_state = 94},
  [193] = {.lex_state = 94},
  [194] = {.lex_state = 94, .external_lex_state = 1},
  [195] = {.lex_state = 57, .external_lex_state = 1},
  [196] = {.lex_state = 538, .external_lex_state = 1},
  [197] = {.lex_state = 57, .external_lex_state = 1},
  [198] = {.lex_state = 57},
  [199] = {.lex_state = 57, .external_lex_state = 1},
  [200] = {.lex_state = 538},
  [201] = {.lex_state = 57},
  [202] = {.lex_state = 57},
  [203] = {.lex_state = 538},
  [204] = {.lex_state = 538, .external_lex_state = 1},
  [205] = {.lex_state = 77},
  [206] = {.lex_state = 59},
  [207] = {.lex_state = 59, .external_lex_state = 1},
  [208] = {.lex_state = 59, .external_lex_state = 1},
  [209] = {.lex_state = 59},
  [210] = {.lex_state = 77, .external_lex_state = 1},
  [211] = {.lex_state = 77},
  [212] = {.lex_state = 59, .external_lex_state = 1},
  [213] = {.lex_state = 77, .external_lex_state = 1},
  [214] = {.lex_state = 59},
  [215] = {.lex_state = 79},
  [216] = {.lex_state = 79, .external_lex_state = 1},
  [217] = {.lex_state = 79},
  [218] = {.lex_state = 79, .external_lex_state = 1},
  [219] = {.lex_state = 85},
  [220] = {.lex_state = 85},
  [221] = {.lex_state = 85, .external_lex_state = 1},
  [222] = {.lex_state = 85, .external_lex_state = 1},
  [223] = {.lex_state = 95},
  [224] = {.lex_state = 95, .external_lex_state = 1},
  [225] = {.lex_state = 14},
  [226] = {.lex_state = 14},
  [227] = {.lex_state = 14},
  [228] = {.lex_state = 14},
  [229] = {.lex_state = 14},
  [230] = {.lex_state = 14},
  [231] = {.lex_state = 14},
  [232] = {.lex_state = 14},
  [233] = {.lex_state = 14},
  [234] = {.lex_state = 14},
  [235] = {.lex_state = 14},
  [236] = {.lex_state = 14},
  [237] = {.lex_state = 88},
  [238] = {.lex_state = 88},
  [239] = {.lex_state = 88},
  [240] = {.lex_state = 88},
  [241] = {.lex_state = 88},
  [242] = {.lex_state = 88},
  [243] = {.lex_state = 88},
  [244] = {.lex_state = 88},
  [245] = {.lex_state = 88},
  [246] = {.lex_state = 88},
  [247] = {.lex_state = 88},
  [248] = {.lex_state = 88},
  [249] = {.lex_state = 88},
  [250] = {.lex_state = 88},
  [251] = {.lex_state = 88},
  [252] = {.lex_state = 88},
  [253] = {.lex_state = 88},
  [254] = {.lex_state = 88, .external_lex_state = 1},
  [255] = {.lex_state = 88},
  [256] = {.lex_state = 88},
  [257] = {.lex_state = 88},
  [258] = {.lex_state = 88},
  [259] = {.lex_state = 88},
  [260] = {.lex_state = 88},
  [261] = {.lex_state = 88},
  [262] = {.lex_state = 88},
  [263] = {.lex_state = 88},
  [264] = {.lex_state = 88},
  [265] = {.lex_state = 88},
  [266] = {.lex_state = 88},
  [267] = {.lex_state = 88},
  [268] = {.lex_state = 88},
  [269] = {.lex_state = 88},
  [270] = {.lex_state = 88},
  [271] = {.lex_state = 88},
  [272] = {.lex_state = 88},
  [273] = {.lex_state = 88},
  [274] = {.lex_state = 88},
  [275] = {.lex_state = 88},
  [276] = {.lex_state = 88},
  [277] = {.lex_state = 88},
  [278] = {.lex_state = 88},
  [279] = {.lex_state = 88},
  [280] = {.lex_state = 88},
  [281] = {.lex_state = 88},
  [282] = {.lex_state = 88},
  [283] = {.lex_state = 88},
  [284] = {.lex_state = 88},
  [285] = {.lex_state = 88},
  [286] = {.lex_state = 88},
  [287] = {.lex_state = 92},
  [288] = {.lex_state = 92, .external_lex_state = 1},
  [289] = {.lex_state = 92},
  [290] = {.lex_state = 92, .external_lex_state = 1},
  [291] = {.lex_state = 82},
  [292] = {.lex_state = 82},
  [293] = {.lex_state = 541},
  [294] = {.lex_state = 57, .external_lex_state = 1},
  [295] = {.lex_state = 542},
  [296] = {.lex_state = 57},
  [297] = {.lex_state = 82},
  [298] = {.lex_state = 77},
  [299] = {.lex_state = 94},
  [300] = {.lex_state = 59, .external_lex_state = 1},
  [301] = {.lex_state = 94},
  [302] = {.lex_state = 94},
  [303] = {.lex_state = 94, .external_lex_state = 1},
  [304] = {.lex_state = 94},
  [305] = {.lex_state = 77, .external_lex_state = 1},
  [306] = {.lex_state = 77, .external_lex_state = 1},
  [307] = {.lex_state = 59},
  [308] = {.lex_state = 94, .external_lex_state = 1},
  [309] = {.lex_state = 77},
  [310] = {.lex_state = 541},
  [311] = {.lex_state = 94},
  [312] = {.lex_state = 94},
  [313] = {.lex_state = 542},
  [314] = {.lex_state = 82},
  [315] = {.lex_state = 82},
  [316] = {.lex_state = 94},
  [317] = {.lex_state = 82},
  [318] = {.lex_state = 542},
  [319] = {.lex_state = 94},
  [320] = {.lex_state = 79, .external_lex_state = 1},
  [321] = {.lex_state = 77},
  [322] = {.lex_state = 79, .external_lex_state = 1},
  [323] = {.lex_state = 94},
  [324] = {.lex_state = 541},
  [325] = {.lex_state = 90, .external_lex_state = 1},
  [326] = {.lex_state = 91},
  [327] = {.lex_state = 542},
  [328] = {.lex_state = 82},
  [329] = {.lex_state = 82},
  [330] = {.lex_state = 94, .external_lex_state = 1},
  [331] = {.lex_state = 90, .external_lex_state = 1},
  [332] = {.lex_state = 541},
  [333] = {.lex_state = 79},
  [334] = {.lex_state = 94, .external_lex_state = 1},
  [335] = {.lex_state = 77, .external_lex_state = 1},
  [336] = {.lex_state = 79},
  [337] = {.lex_state = 82},
  [338] = {.lex_state = 82},
  [339] = {.lex_state = 82},
  [340] = {.lex_state = 90, .external_lex_state = 1},
  [341] = {.lex_state = 82},
  [342] = {.lex_state = 82},
  [343] = {.lex_state = 82},
  [344] = {.lex_state = 82},
  [345] = {.lex_state = 94},
  [346] = {.lex_state = 94, .external_lex_state = 1},
  [347] = {.lex_state = 94},
  [348] = {.lex_state = 82},
  [349] = {.lex_state = 82},
  [350] = {.lex_state = 541},
  [351] = {.lex_state = 82},
  [352] = {.lex_state = 82},
  [353] = {.lex_state = 82},
  [354] = {.lex_state = 82},
  [355] = {.lex_state = 94},
  [356] = {.lex_state = 82},
  [357] = {.lex_state = 82},
  [358] = {.lex_state = 541},
  [359] = {.lex_state = 79, .external_lex_state = 1},
  [360] = {.lex_state = 82},
  [361] = {.lex_state = 82},
  [362] = {.lex_state = 82},
  [363] = {.lex_state = 82},
  [364] = {.lex_state = 94, .external_lex_state = 1},
  [365] = {.lex_state = 94},
  [366] = {.lex_state = 82},
  [367] = {.lex_state = 542},
  [368] = {.lex_state = 91},
  [369] = {.lex_state = 79},
  [370] = {.lex_state = 94},
  [371] = {.lex_state = 542},
  [372] = {.lex_state = 82},
  [373] = {.lex_state = 541},
  [374] = {.lex_state = 541},
  [375] = {.lex_state = 94},
  [376] = {.lex_state = 541},
  [377] = {.lex_state = 94},
  [378] = {.lex_state = 542},
  [379] = {.lex_state = 542},
  [380] = {.lex_state = 94},
  [381] = {.lex_state = 544},
  [382] = {.lex_state = 94, .external_lex_state = 1},
  [383] = {.lex_state = 542},
  [384] = {.lex_state = 543},
  [385] = {.lex_state = 541},
  [386] = {.lex_state = 94},
  [387] = {.lex_state = 94},
  [388] = {.lex_state = 94},
  [389] = {.lex_state = 94, .external_lex_state = 1},
  [390] = {.lex_state = 82},
  [391] = {.lex_state = 94},
  [392] = {.lex_state = 544},
  [393] = {.lex_state = 542},
  [394] = {.lex_state = 542},
  [395] = {.lex_state = 541},
  [396] = {.lex_state = 78},
  [397] = {.lex_state = 542},
  [398] = {.lex_state = 82},
  [399] = {.lex_state = 78, .external_lex_state = 1},
  [400] = {.lex_state = 541},
  [401] = {.lex_state = 541},
  [402] = {.lex_state = 94},
  [403] = {.lex_state = 78},
  [404] = {.lex_state = 78, .external_lex_state = 1},
  [405] = {.lex_state = 541},
  [406] = {.lex_state = 85},
  [407] = {.lex_state = 82},
  [408] = {.lex_state = 85, .external_lex_state = 1},
  [409] = {.lex_state = 82},
  [410] = {.lex_state = 543},
  [411] = {.lex_state = 82},
  [412] = {.lex_state = 82},
  [413] = {.lex_state = 540},
  [414] = {.lex_state = 82},
  [415] = {.lex_state = 82},
  [416] = {.lex_state = 82},
  [417] = {.lex_state = 82},
  [418] = {.lex_state = 540},
  [419] = {.lex_state = 540},
  [420] = {.lex_state = 540},
  [421] = {.lex_state = 82},
  [422] = {.lex_state = 82},
  [423] = {.lex_state = 540},
  [424] = {.lex_state = 540},
  [425] = {.lex_state = 540},
  [426] = {.lex_state = 82},
  [427] = {.lex_state = 540},
  [428] = {.lex_state = 82},
  [429] = {.lex_state = 540},
  [430] = {.lex_state = 94},
  [431] = {.lex_state = 540},
  [432] = {.lex_state = 540},
  [433] = {.lex_state = 540},
  [434] = {.lex_state = 540},
  [435] = {.lex_state = 540},
  [436] = {.lex_state = 540},
  [437] = {.lex_state = 540},
  [438] = {.lex_state = 540},
  [439] = {.lex_state = 540},
  [440] = {.lex_state = 540},
  [441] = {.lex_state = 540},
  [442] = {.lex_state = 540},
  [443] = {.lex_state = 540},
  [444] = {.lex_state = 82},
  [445] = {.lex_state = 540},
  [446] = {.lex_state = 540},
  [447] = {.lex_state = 540},
  [448] = {.lex_state = 540},
  [449] = {.lex_state = 82},
  [450] = {.lex_state = 540},
  [451] = {.lex_state = 540},
  [452] = {.lex_state = 540},
  [453] = {.lex_state = 540},
  [454] = {.lex_state = 82},
  [455] = {.lex_state = 540},
  [456] = {.lex_state = 540},
  [457] = {.lex_state = 540},
  [458] = {.lex_state = 540},
  [459] = {.lex_state = 540},
  [460] = {.lex_state = 82},
  [461] = {.lex_state = 540},
  [462] = {.lex_state = 540},
  [463] = {.lex_state = 540},
  [464] = {.lex_state = 540},
  [465] = {.lex_state = 82},
  [466] = {.lex_state = 540},
  [467] = {.lex_state = 540},
  [468] = {.lex_state = 540},
  [469] = {.lex_state = 540},
  [470] = {.lex_state = 540},
  [471] = {.lex_state = 540},
  [472] = {.lex_state = 540},
  [473] = {.lex_state = 82},
  [474] = {.lex_state = 94},
  [475] = {.lex_state = 540},
  [476] = {.lex_state = 540},
  [477] = {.lex_state = 540},
  [478] = {.lex_state = 540},
  [479] = {.lex_state = 540},
  [480] = {.lex_state = 540},
  [481] = {.lex_state = 540},
  [482] = {.lex_state = 540},
  [483] = {.lex_state = 82},
  [484] = {.lex_state = 540},
  [485] = {.lex_state = 540},
  [486] = {.lex_state = 540},
  [487] = {.lex_state = 95, .external_lex_state = 1},
  [488] = {.lex_state = 540},
  [489] = {.lex_state = 540},
  [490] = {.lex_state = 94},
  [491] = {.lex_state = 540},
  [492] = {.lex_state = 540},
  [493] = {.lex_state = 540},
  [494] = {.lex_state = 540},
  [495] = {.lex_state = 540},
  [496] = {.lex_state = 540},
  [497] = {.lex_state = 540},
  [498] = {.lex_state = 540},
  [499] = {.lex_state = 540},
  [500] = {.lex_state = 540},
  [501] = {.lex_state = 540},
  [502] = {.lex_state = 82},
  [503] = {.lex_state = 82},
  [504] = {.lex_state = 540},
  [505] = {.lex_state = 82},
  [506] = {.lex_state = 540},
  [507] = {.lex_state = 540},
  [508] = {.lex_state = 540},
  [509] = {.lex_state = 540},
  [510] = {.lex_state = 540},
  [511] = {.lex_state = 540},
  [512] = {.lex_state = 540},
  [513] = {.lex_state = 540},
  [514] = {.lex_state = 540},
  [515] = {.lex_state = 540},
  [516] = {.lex_state = 95},
  [517] = {.lex_state = 540},
  [518] = {.lex_state = 540},
  [519] = {.lex_state = 540},
  [520] = {.lex_state = 82},
  [521] = {.lex_state = 540},
  [522] = {.lex_state = 82},
  [523] = {.lex_state = 540},
  [524] = {.lex_state = 540},
  [525] = {.lex_state = 82},
  [526] = {.lex_state = 540},
  [527] = {.lex_state = 540},
  [528] = {.lex_state = 540},
  [529] = {.lex_state = 540},
  [530] = {.lex_state = 540},
  [531] = {.lex_state = 540},
  [532] = {.lex_state = 540},
  [533] = {.lex_state = 540},
  [534] = {.lex_state = 540},
  [535] = {.lex_state = 94},
  [536] = {.lex_state = 540},
  [537] = {.lex_state = 540},
  [538] = {.lex_state = 82},
  [539] = {.lex_state = 540},
  [540] = {.lex_state = 538},
  [541] = {.lex_state = 87},
  [542] = {.lex_state = 94, .external_lex_state = 1},
  [543] = {.lex_state = 87},
  [544] = {.lex_state = 82},
  [545] = {.lex_state = 82},
  [546] = {.lex_state = 94, .external_lex_state = 1},
  [547] = {.lex_state = 540},
  [548] = {.lex_state = 82},
  [549] = {.lex_state = 87, .external_lex_state = 1},
  [550] = {.lex_state = 540},
  [551] = {.lex_state = 82},
  [552] = {.lex_state = 540},
  [553] = {.lex_state = 94},
  [554] = {.lex_state = 94},
  [555] = {.lex_state = 538},
  [556] = {.lex_state = 87, .external_lex_state = 1},
  [557] = {.lex_state = 82},
  [558] = {.lex_state = 82},
  [559] = {.lex_state = 538},
  [560] = {.lex_state = 82},
  [561] = {.lex_state = 82},
  [562] = {.lex_state = 82, .external_lex_state = 1},
  [563] = {.lex_state = 538, .external_lex_state = 1},
  [564] = {.lex_state = 538, .external_lex_state = 1},
  [565] = {.lex_state = 538},
  [566] = {.lex_state = 82},
  [567] = {.lex_state = 82},
  [568] = {.lex_state = 82},
  [569] = {.lex_state = 82},
  [570] = {.lex_state = 82},
  [571] = {.lex_state = 82},
  [572] = {.lex_state = 82},
  [573] = {.lex_state = 94},
  [574] = {.lex_state = 82},
  [575] = {.lex_state = 82},
  [576] = {.lex_state = 94},
  [577] = {.lex_state = 82},
  [578] = {.lex_state = 82},
  [579] = {.lex_state = 82},
  [580] = {.lex_state = 82},
  [581] = {.lex_state = 82},
  [582] = {.lex_state = 82},
  [583] = {.lex_state = 538},
  [584] = {.lex_state = 538},
  [585] = {.lex_state = 82},
  [586] = {.lex_state = 82},
  [587] = {.lex_state = 82},
  [588] = {.lex_state = 82},
  [589] = {.lex_state = 82},
  [590] = {.lex_state = 82},
  [591] = {.lex_state = 82},
  [592] = {.lex_state = 82},
  [593] = {.lex_state = 82},
  [594] = {.lex_state = 82},
  [595] = {.lex_state = 82},
  [596] = {.lex_state = 82},
  [597] = {.lex_state = 82},
  [598] = {.lex_state = 82},
  [599] = {.lex_state = 82},
  [600] = {.lex_state = 82},
  [601] = {.lex_state = 82},
  [602] = {.lex_state = 82},
  [603] = {.lex_state = 82},
  [604] = {.lex_state = 82},
  [605] = {.lex_state = 82},
  [606] = {.lex_state = 82},
  [607] = {.lex_state = 82},
  [608] = {.lex_state = 82},
  [609] = {.lex_state = 82},
  [610] = {.lex_state = 82},
  [611] = {.lex_state = 82},
  [612] = {.lex_state = 82},
  [613] = {.lex_state = 82},
  [614] = {.lex_state = 82},
  [615] = {.lex_state = 82},
  [616] = {.lex_state = 82},
  [617] = {.lex_state = 82},
  [618] = {.lex_state = 82},
  [619] = {.lex_state = 82},
  [620] = {.lex_state = 82},
  [621] = {.lex_state = 82},
  [622] = {.lex_state = 82},
  [623] = {.lex_state = 82},
  [624] = {.lex_state = 82},
  [625] = {.lex_state = 82},
  [626] = {.lex_state = 82},
  [627] = {.lex_state = 82},
  [628] = {.lex_state = 82},
  [629] = {.lex_state = 82},
  [630] = {.lex_state = 82},
  [631] = {.lex_state = 82},
  [632] = {.lex_state = 82},
  [633] = {.lex_state = 82},
  [634] = {.lex_state = 82},
  [635] = {.lex_state = 82},
  [636] = {.lex_state = 82},
  [637] = {.lex_state = 82},
  [638] = {.lex_state = 82},
  [639] = {.lex_state = 82},
  [640] = {.lex_state = 82},
  [641] = {.lex_state = 82},
  [642] = {.lex_state = 82},
  [643] = {.lex_state = 82},
  [644] = {.lex_state = 82},
  [645] = {.lex_state = 82},
  [646] = {.lex_state = 82},
  [647] = {.lex_state = 82},
  [648] = {.lex_state = 82},
  [649] = {.lex_state = 82},
  [650] = {.lex_state = 82},
  [651] = {.lex_state = 82},
  [652] = {.lex_state = 82},
  [653] = {.lex_state = 82},
  [654] = {.lex_state = 82},
  [655] = {.lex_state = 82},
  [656] = {.lex_state = 82},
  [657] = {.lex_state = 82},
  [658] = {.lex_state = 82},
  [659] = {.lex_state = 82},
  [660] = {.lex_state = 82},
  [661] = {.lex_state = 82},
  [662] = {.lex_state = 82},
  [663] = {.lex_state = 82},
  [664] = {.lex_state = 82},
  [665] = {.lex_state = 82},
  [666] = {.lex_state = 82},
  [667] = {.lex_state = 82},
  [668] = {.lex_state = 82},
  [669] = {.lex_state = 82},
  [670] = {.lex_state = 82},
  [671] = {.lex_state = 82},
  [672] = {.lex_state = 82},
  [673] = {.lex_state = 82},
  [674] = {.lex_state = 82},
  [675] = {.lex_state = 82},
  [676] = {.lex_state = 82},
  [677] = {.lex_state = 82},
  [678] = {.lex_state = 82},
  [679] = {.lex_state = 82},
  [680] = {.lex_state = 82},
  [681] = {.lex_state = 82},
  [682] = {.lex_state = 82},
  [683] = {.lex_state = 82},
  [684] = {.lex_state = 82},
  [685] = {.lex_state = 82},
  [686] = {.lex_state = 82},
  [687] = {.lex_state = 82},
  [688] = {.lex_state = 82},
  [689] = {.lex_state = 82},
  [690] = {.lex_state = 82},
  [691] = {.lex_state = 82},
  [692] = {.lex_state = 82},
  [693] = {.lex_state = 82},
  [694] = {.lex_state = 82},
  [695] = {.lex_state = 82},
  [696] = {.lex_state = 82},
  [697] = {.lex_state = 82},
  [698] = {.lex_state = 82},
  [699] = {.lex_state = 82},
  [700] = {.lex_state = 82},
  [701] = {.lex_state = 82},
  [702] = {.lex_state = 82},
  [703] = {.lex_state = 82},
  [704] = {.lex_state = 82},
  [705] = {.lex_state = 82},
  [706] = {.lex_state = 82},
  [707] = {.lex_state = 82},
  [708] = {.lex_state = 63},
  [709] = {.lex_state = 63, .external_lex_state = 1},
  [710] = {.lex_state = 63, .external_lex_state = 1},
  [711] = {.lex_state = 63},
  [712] = {.lex_state = 100},
  [713] = {.lex_state = 65},
  [714] = {.lex_state = 100},
  [715] = {.lex_state = 65, .external_lex_state = 1},
  [716] = {.lex_state = 65, .external_lex_state = 1},
  [717] = {.lex_state = 65},
  [718] = {.lex_state = 100},
  [719] = {.lex_state = 100},
  [720] = {.lex_state = 100},
  [721] = {.lex_state = 60},
  [722] = {.lex_state = 100},
  [723] = {.lex_state = 101},
  [724] = {.lex_state = 101},
  [725] = {.lex_state = 60},
  [726] = {.lex_state = 101},
  [727] = {.lex_state = 60},
  [728] = {.lex_state = 101},
  [729] = {.lex_state = 60},
  [730] = {.lex_state = 60},
  [731] = {.lex_state = 60},
  [732] = {.lex_state = 101},
  [733] = {.lex_state = 101},
  [734] = {.lex_state = 106},
  [735] = {.lex_state = 67},
  [736] = {.lex_state = 67, .external_lex_state = 1},
  [737] = {.lex_state = 67},
  [738] = {.lex_state = 67, .external_lex_state = 1},
  [739] = {.lex_state = 73, .external_lex_state = 1},
  [740] = {.lex_state = 73},
  [741] = {.lex_state = 68, .external_lex_state = 1},
  [742] = {.lex_state = 68, .external_lex_state = 1},
  [743] = {.lex_state = 73, .external_lex_state = 1},
  [744] = {.lex_state = 68},
  [745] = {.lex_state = 69},
  [746] = {.lex_state = 69, .external_lex_state = 1},
  [747] = {.lex_state = 69},
  [748] = {.lex_state = 69, .external_lex_state = 1},
  [749] = {.lex_state = 68},
  [750] = {.lex_state = 73},
  [751] = {.lex_state = 69, .external_lex_state = 1},
  [752] = {.lex_state = 69},
  [753] = {.lex_state = 69, .external_lex_state = 1},
  [754] = {.lex_state = 69, .external_lex_state = 1},
  [755] = {.lex_state = 69, .external_lex_state = 1},
  [756] = {.lex_state = 69, .external_lex_state = 1},
  [757] = {.lex_state = 69, .external_lex_state = 1},
  [758] = {.lex_state = 69},
  [759] = {.lex_state = 69, .external_lex_state = 1},
  [760] = {.lex_state = 69, .external_lex_state = 1},
  [761] = {.lex_state = 74, .external_lex_state = 1},
  [762] = {.lex_state = 69, .external_lex_state = 1},
  [763] = {.lex_state = 69, .external_lex_state = 1},
  [764] = {.lex_state = 69, .external_lex_state = 1},
  [765] = {.lex_state = 69, .external_lex_state = 1},
  [766] = {.lex_state = 69, .external_lex_state = 1},
  [767] = {.lex_state = 69, .external_lex_state = 1},
  [768] = {.lex_state = 69, .external_lex_state = 1},
  [769] = {.lex_state = 69},
  [770] = {.lex_state = 69},
  [771] = {.lex_state = 69, .external_lex_state = 1},
  [772] = {.lex_state = 69, .external_lex_state = 1},
  [773] = {.lex_state = 69, .external_lex_state = 1},
  [774] = {.lex_state = 69},
  [775] = {.lex_state = 69, .external_lex_state = 1},
  [776] = {.lex_state = 69, .external_lex_state = 1},
  [777] = {.lex_state = 73, .external_lex_state = 1},
  [778] = {.lex_state = 69, .external_lex_state = 1},
  [779] = {.lex_state = 69, .external_lex_state = 1},
  [780] = {.lex_state = 69, .external_lex_state = 1},
  [781] = {.lex_state = 69, .external_lex_state = 1},
  [782] = {.lex_state = 69, .external_lex_state = 1},
  [783] = {.lex_state = 69, .external_lex_state = 1},
  [784] = {.lex_state = 74, .external_lex_state = 1},
  [785] = {.lex_state = 69, .external_lex_state = 1},
  [786] = {.lex_state = 69, .external_lex_state = 1},
  [787] = {.lex_state = 71, .external_lex_state = 1},
  [788] = {.lex_state = 67, .external_lex_state = 1},
  [789] = {.lex_state = 69, .external_lex_state = 1},
  [790] = {.lex_state = 69},
  [791] = {.lex_state = 69},
  [792] = {.lex_state = 69},
  [793] = {.lex_state = 69},
  [794] = {.lex_state = 69},
  [795] = {.lex_state = 69},
  [796] = {.lex_state = 69},
  [797] = {.lex_state = 69},
  [798] = {.lex_state = 69},
  [799] = {.lex_state = 69, .external_lex_state = 1},
  [800] = {.lex_state = 69},
  [801] = {.lex_state = 69},
  [802] = {.lex_state = 69},
  [803] = {.lex_state = 69},
  [804] = {.lex_state = 69},
  [805] = {.lex_state = 69},
  [806] = {.lex_state = 73},
  [807] = {.lex_state = 74},
  [808] = {.lex_state = 71},
  [809] = {.lex_state = 69, .external_lex_state = 1},
  [810] = {.lex_state = 69},
  [811] = {.lex_state = 69, .external_lex_state = 1},
  [812] = {.lex_state = 69},
  [813] = {.lex_state = 69},
  [814] = {.lex_state = 67},
  [815] = {.lex_state = 69},
  [816] = {.lex_state = 69},
  [817] = {.lex_state = 74},
  [818] = {.lex_state = 69},
  [819] = {.lex_state = 101},
  [820] = {.lex_state = 69},
  [821] = {.lex_state = 69},
  [822] = {.lex_state = 71, .external_lex_state = 1},
  [823] = {.lex_state = 69},
  [824] = {.lex_state = 69},
  [825] = {.lex_state = 73, .external_lex_state = 1},
  [826] = {.lex_state = 69},
  [827] = {.lex_state = 73},
  [828] = {.lex_state = 69, .external_lex_state = 1},
  [829] = {.lex_state = 69},
  [830] = {.lex_state = 69},
  [831] = {.lex_state = 69, .external_lex_state = 1},
  [832] = {.lex_state = 71},
  [833] = {.lex_state = 69},
  [834] = {.lex_state = 71, .external_lex_state = 1},
  [835] = {.lex_state = 71},
  [836] = {.lex_state = 71, .external_lex_state = 1},
  [837] = {.lex_state = 71},
  [838] = {.lex_state = 71, .external_lex_state = 1},
  [839] = {.lex_state = 74, .external_lex_state = 1},
  [840] = {.lex_state = 71},
  [841] = {.lex_state = 71, .external_lex_state = 1},
  [842] = {.lex_state = 71},
  [843] = {.lex_state = 71},
  [844] = {.lex_state = 71},
  [845] = {.lex_state = 74},
  [846] = {.lex_state = 71},
  [847] = {.lex_state = 71},
  [848] = {.lex_state = 538},
  [849] = {.lex_state = 74, .external_lex_state = 1},
  [850] = {.lex_state = 71, .external_lex_state = 1},
  [851] = {.lex_state = 71, .external_lex_state = 1},
  [852] = {.lex_state = 71, .external_lex_state = 1},
  [853] = {.lex_state = 71, .external_lex_state = 1},
  [854] = {.lex_state = 71},
  [855] = {.lex_state = 71},
  [856] = {.lex_state = 71},
  [857] = {.lex_state = 71, .external_lex_state = 1},
  [858] = {.lex_state = 71, .external_lex_state = 1},
  [859] = {.lex_state = 71, .external_lex_state = 1},
  [860] = {.lex_state = 71, .external_lex_state = 1},
  [861] = {.lex_state = 71, .external_lex_state = 1},
  [862] = {.lex_state = 71},
  [863] = {.lex_state = 71},
  [864] = {.lex_state = 71, .external_lex_state = 1},
  [865] = {.lex_state = 538, .external_lex_state = 1},
  [866] = {.lex_state = 71, .external_lex_state = 1},
  [867] = {.lex_state = 71, .external_lex_state = 1},
  [868] = {.lex_state = 538, .external_lex_state = 1},
  [869] = {.lex_state = 68},
  [870] = {.lex_state = 71, .external_lex_state = 1},
  [871] = {.lex_state = 68, .external_lex_state = 1},
  [872] = {.lex_state = 71, .external_lex_state = 1},
  [873] = {.lex_state = 71, .external_lex_state = 1},
  [874] = {.lex_state = 71},
  [875] = {.lex_state = 71},
  [876] = {.lex_state = 71},
  [877] = {.lex_state = 71},
  [878] = {.lex_state = 71},
  [879] = {.lex_state = 71},
  [880] = {.lex_state = 71, .external_lex_state = 1},
  [881] = {.lex_state = 71},
  [882] = {.lex_state = 71},
  [883] = {.lex_state = 74},
  [884] = {.lex_state = 71},
  [885] = {.lex_state = 71, .external_lex_state = 1},
  [886] = {.lex_state = 71, .external_lex_state = 1},
  [887] = {.lex_state = 71, .external_lex_state = 1},
  [888] = {.lex_state = 71, .external_lex_state = 1},
  [889] = {.lex_state = 71, .external_lex_state = 1},
  [890] = {.lex_state = 71, .external_lex_state = 1},
  [891] = {.lex_state = 71},
  [892] = {.lex_state = 71},
  [893] = {.lex_state = 71, .external_lex_state = 1},
  [894] = {.lex_state = 71, .external_lex_state = 1},
  [895] = {.lex_state = 71, .external_lex_state = 1},
  [896] = {.lex_state = 538},
  [897] = {.lex_state = 71},
  [898] = {.lex_state = 71},
  [899] = {.lex_state = 71},
  [900] = {.lex_state = 71, .external_lex_state = 1},
  [901] = {.lex_state = 538},
  [902] = {.lex_state = 71, .external_lex_state = 1},
  [903] = {.lex_state = 71, .external_lex_state = 1},
  [904] = {.lex_state = 71},
  [905] = {.lex_state = 71, .external_lex_state = 1},
  [906] = {.lex_state = 69},
  [907] = {.lex_state = 71},
  [908] = {.lex_state = 71},
  [909] = {.lex_state = 71},
  [910] = {.lex_state = 71},
  [911] = {.lex_state = 71},
  [912] = {.lex_state = 71},
  [913] = {.lex_state = 69, .external_lex_state = 1},
  [914] = {.lex_state = 71, .external_lex_state = 1},
  [915] = {.lex_state = 538, .external_lex_state = 1},
  [916] = {.lex_state = 69, .external_lex_state = 1},
  [917] = {.lex_state = 69},
  [918] = {.lex_state = 106},
  [919] = {.lex_state = 69},
  [920] = {.lex_state = 69, .external_lex_state = 1},
  [921] = {.lex_state = 69, .external_lex_state = 1},
  [922] = {.lex_state = 71, .external_lex_state = 1},
  [923] = {.lex_state = 69},
  [924] = {.lex_state = 71},
  [925] = {.lex_state = 106},
  [926] = {.lex_state = 61},
  [927] = {.lex_state = 106},
  [928] = {.lex_state = 71, .external_lex_state = 1},
  [929] = {.lex_state = 71, .external_lex_state = 1},
  [930] = {.lex_state = 106},
  [931] = {.lex_state = 106},
  [932] = {.lex_state = 106},
  [933] = {.lex_state = 106},
  [934] = {.lex_state = 106},
  [935] = {.lex_state = 61},
  [936] = {.lex_state = 106},
  [937] = {.lex_state = 106},
  [938] = {.lex_state = 71},
  [939] = {.lex_state = 106},
  [940] = {.lex_state = 106},
  [941] = {.lex_state = 71},
  [942] = {.lex_state = 106},
  [943] = {.lex_state = 106},
  [944] = {.lex_state = 106},
  [945] = {.lex_state = 61, .external_lex_state = 1},
  [946] = {.lex_state = 106},
  [947] = {.lex_state = 61, .external_lex_state = 1},
  [948] = {.lex_state = 106},
  [949] = {.lex_state = 106},
  [950] = {.lex_state = 106},
  [951] = {.lex_state = 106},
  [952] = {.lex_state = 106},
  [953] = {.lex_state = 106},
  [954] = {.lex_state = 61, .external_lex_state = 1},
  [955] = {.lex_state = 106},
  [956] = {.lex_state = 106},
  [957] = {.lex_state = 106},
  [958] = {.lex_state = 106},
  [959] = {.lex_state = 106},
  [960] = {.lex_state = 106},
  [961] = {.lex_state = 106},
  [962] = {.lex_state = 71, .external_lex_state = 1},
  [963] = {.lex_state = 106},
  [964] = {.lex_state = 106},
  [965] = {.lex_state = 61},
  [966] = {.lex_state = 106},
  [967] = {.lex_state = 106},
  [968] = {.lex_state = 106},
  [969] = {.lex_state = 106},
  [970] = {.lex_state = 71},
  [971] = {.lex_state = 62},
  [972] = {.lex_state = 61},
  [973] = {.lex_state = 61, .external_lex_state = 1},
  [974] = {.lex_state = 61},
  [975] = {.lex_state = 106, .external_lex_state = 1},
  [976] = {.lex_state = 62, .external_lex_state = 1},
  [977] = {.lex_state = 61, .external_lex_state = 1},
  [978] = {.lex_state = 538, .external_lex_state = 1},
  [979] = {.lex_state = 106, .external_lex_state = 1},
  [980] = {.lex_state = 538},
  [981] = {.lex_state = 62, .external_lex_state = 1},
  [982] = {.lex_state = 62},
  [983] = {.lex_state = 61},
  [984] = {.lex_state = 62},
  [985] = {.lex_state = 62, .external_lex_state = 1},
  [986] = {.lex_state = 61, .external_lex_state = 1},
  [987] = {.lex_state = 106},
  [988] = {.lex_state = 106, .external_lex_state = 1},
  [989] = {.lex_state = 106, .external_lex_state = 1},
  [990] = {.lex_state = 62},
  [991] = {.lex_state = 62},
  [992] = {.lex_state = 106, .external_lex_state = 1},
  [993] = {.lex_state = 106, .external_lex_state = 1},
  [994] = {.lex_state = 106, .external_lex_state = 1},
  [995] = {.lex_state = 106, .external_lex_state = 1},
  [996] = {.lex_state = 106, .external_lex_state = 1},
  [997] = {.lex_state = 106, .external_lex_state = 1},
  [998] = {.lex_state = 87},
  [999] = {.lex_state = 106, .external_lex_state = 1},
  [1000] = {.lex_state = 106, .external_lex_state = 1},
  [1001] = {.lex_state = 62},
  [1002] = {.lex_state = 106, .external_lex_state = 1},
  [1003] = {.lex_state = 106, .external_lex_state = 1},
  [1004] = {.lex_state = 106, .external_lex_state = 1},
  [1005] = {.lex_state = 106, .external_lex_state = 1},
  [1006] = {.lex_state = 106, .external_lex_state = 1},
  [1007] = {.lex_state = 106, .external_lex_state = 1},
  [1008] = {.lex_state = 106, .external_lex_state = 1},
  [1009] = {.lex_state = 62, .external_lex_state = 1},
  [1010] = {.lex_state = 106, .external_lex_state = 1},
  [1011] = {.lex_state = 106, .external_lex_state = 1},
  [1012] = {.lex_state = 106, .external_lex_state = 1},
  [1013] = {.lex_state = 106, .external_lex_state = 1},
  [1014] = {.lex_state = 106, .external_lex_state = 1},
  [1015] = {.lex_state = 62, .external_lex_state = 1},
  [1016] = {.lex_state = 106, .external_lex_state = 1},
  [1017] = {.lex_state = 106, .external_lex_state = 1},
  [1018] = {.lex_state = 62, .external_lex_state = 1},
  [1019] = {.lex_state = 106, .external_lex_state = 1},
  [1020] = {.lex_state = 106, .external_lex_state = 1},
  [1021] = {.lex_state = 106, .external_lex_state = 1},
  [1022] = {.lex_state = 106, .external_lex_state = 1},
  [1023] = {.lex_state = 106, .external_lex_state = 1},
  [1024] = {.lex_state = 106, .external_lex_state = 1},
  [1025] = {.lex_state = 106, .external_lex_state = 1},
  [1026] = {.lex_state = 106, .external_lex_state = 1},
  [1027] = {.lex_state = 106, .external_lex_state = 1},
  [1028] = {.lex_state = 106, .external_lex_state = 1},
  [1029] = {.lex_state = 106},
  [1030] = {.lex_state = 73},
  [1031] = {.lex_state = 73, .external_lex_state = 1},
  [1032] = {.lex_state = 73},
  [1033] = {.lex_state = 73},
  [1034] = {.lex_state = 73},
  [1035] = {.lex_state = 73},
  [1036] = {.lex_state = 73, .external_lex_state = 1},
  [1037] = {.lex_state = 73, .external_lex_state = 1},
  [1038] = {.lex_state = 73, .external_lex_state = 1},
  [1039] = {.lex_state = 73, .external_lex_state = 1},
  [1040] = {.lex_state = 73},
  [1041] = {.lex_state = 73},
  [1042] = {.lex_state = 73},
  [1043] = {.lex_state = 73},
  [1044] = {.lex_state = 73},
  [1045] = {.lex_state = 73, .external_lex_state = 1},
  [1046] = {.lex_state = 73, .external_lex_state = 1},
  [1047] = {.lex_state = 73, .external_lex_state = 1},
  [1048] = {.lex_state = 106, .external_lex_state = 1},
  [1049] = {.lex_state = 73, .external_lex_state = 1},
  [1050] = {.lex_state = 73, .external_lex_state = 1},
  [1051] = {.lex_state = 74},
  [1052] = {.lex_state = 74},
  [1053] = {.lex_state = 74, .external_lex_state = 1},
  [1054] = {.lex_state = 74},
  [1055] = {.lex_state = 106, .external_lex_state = 1},
  [1056] = {.lex_state = 74, .external_lex_state = 1},
  [1057] = {.lex_state = 106},
  [1058] = {.lex_state = 73, .external_lex_state = 1},
  [1059] = {.lex_state = 74},
  [1060] = {.lex_state = 73},
  [1061] = {.lex_state = 73, .external_lex_state = 1},
  [1062] = {.lex_state = 73},
  [1063] = {.lex_state = 74},
  [1064] = {.lex_state = 74},
  [1065] = {.lex_state = 74},
  [1066] = {.lex_state = 74},
  [1067] = {.lex_state = 74, .external_lex_state = 1},
  [1068] = {.lex_state = 74, .external_lex_state = 1},
  [1069] = {.lex_state = 74, .external_lex_state = 1},
  [1070] = {.lex_state = 106, .external_lex_state = 1},
  [1071] = {.lex_state = 74, .external_lex_state = 1},
  [1072] = {.lex_state = 74, .external_lex_state = 1},
  [1073] = {.lex_state = 74, .external_lex_state = 1},
  [1074] = {.lex_state = 74, .external_lex_state = 1},
  [1075] = {.lex_state = 74, .external_lex_state = 1},
  [1076] = {.lex_state = 74},
  [1077] = {.lex_state = 74},
  [1078] = {.lex_state = 73, .external_lex_state = 1},
  [1079] = {.lex_state = 73},
  [1080] = {.lex_state = 73},
  [1081] = {.lex_state = 73},
  [1082] = {.lex_state = 73},
  [1083] = {.lex_state = 74, .external_lex_state = 1},
  [1084] = {.lex_state = 74},
  [1085] = {.lex_state = 73},
  [1086] = {.lex_state = 73},
  [1087] = {.lex_state = 82},
  [1088] = {.lex_state = 73, .external_lex_state = 1},
  [1089] = {.lex_state = 73, .external_lex_state = 1},
  [1090] = {.lex_state = 73, .external_lex_state = 1},
  [1091] = {.lex_state = 73, .external_lex_state = 1},
  [1092] = {.lex_state = 74},
  [1093] = {.lex_state = 73},
  [1094] = {.lex_state = 87, .external_lex_state = 1},
  [1095] = {.lex_state = 74, .external_lex_state = 1},
  [1096] = {.lex_state = 73, .external_lex_state = 1},
  [1097] = {.lex_state = 82},
  [1098] = {.lex_state = 73, .external_lex_state = 1},
  [1099] = {.lex_state = 82},
  [1100] = {.lex_state = 73, .external_lex_state = 1},
  [1101] = {.lex_state = 73},
  [1102] = {.lex_state = 74},
  [1103] = {.lex_state = 74, .external_lex_state = 1},
  [1104] = {.lex_state = 538, .external_lex_state = 1},
  [1105] = {.lex_state = 74, .external_lex_state = 1},
  [1106] = {.lex_state = 538},
  [1107] = {.lex_state = 74, .external_lex_state = 1},
  [1108] = {.lex_state = 74},
  [1109] = {.lex_state = 74, .external_lex_state = 1},
  [1110] = {.lex_state = 74, .external_lex_state = 1},
  [1111] = {.lex_state = 538, .external_lex_state = 1},
  [1112] = {.lex_state = 74, .external_lex_state = 1},
  [1113] = {.lex_state = 74},
  [1114] = {.lex_state = 74},
  [1115] = {.lex_state = 74},
  [1116] = {.lex_state = 74},
  [1117] = {.lex_state = 74, .external_lex_state = 1},
  [1118] = {.lex_state = 74, .external_lex_state = 1},
  [1119] = {.lex_state = 538},
  [1120] = {.lex_state = 74},
  [1121] = {.lex_state = 74},
  [1122] = {.lex_state = 538},
  [1123] = {.lex_state = 82},
  [1124] = {.lex_state = 538, .external_lex_state = 1},
  [1125] = {.lex_state = 538, .external_lex_state = 1},
  [1126] = {.lex_state = 538},
  [1127] = {.lex_state = 538},
  [1128] = {.lex_state = 538},
  [1129] = {.lex_state = 538, .external_lex_state = 1},
  [1130] = {.lex_state = 538, .external_lex_state = 1},
  [1131] = {.lex_state = 538, .external_lex_state = 1},
  [1132] = {.lex_state = 538},
  [1133] = {.lex_state = 538},
  [1134] = {.lex_state = 538, .external_lex_state = 1},
  [1135] = {.lex_state = 101},
  [1136] = {.lex_state = 101},
  [1137] = {.lex_state = 101},
  [1138] = {.lex_state = 60},
  [1139] = {.lex_state = 100},
  [1140] = {.lex_state = 94},
  [1141] = {.lex_state = 94},
  [1142] = {.lex_state = 94},
  [1143] = {.lex_state = 94},
  [1144] = {.lex_state = 94},
  [1145] = {.lex_state = 94},
  [1146] = {.lex_state = 94},
  [1147] = {.lex_state = 94},
  [1148] = {.lex_state = 94},
  [1149] = {.lex_state = 94},
  [1150] = {.lex_state = 94},
  [1151] = {.lex_state = 94},
  [1152] = {.lex_state = 94},
  [1153] = {.lex_state = 94},
  [1154] = {.lex_state = 94},
  [1155] = {.lex_state = 94},
  [1156] = {.lex_state = 94},
  [1157] = {.lex_state = 94},
  [1158] = {.lex_state = 94},
  [1159] = {.lex_state = 94},
  [1160] = {.lex_state = 94},
  [1161] = {.lex_state = 94},
  [1162] = {.lex_state = 94},
  [1163] = {.lex_state = 94},
  [1164] = {.lex_state = 94},
  [1165] = {.lex_state = 103},
  [1166] = {.lex_state = 103},
  [1167] = {.lex_state = 103},
  [1168] = {.lex_state = 103},
  [1169] = {.lex_state = 103},
  [1170] = {.lex_state = 104},
  [1171] = {.lex_state = 103},
  [1172] = {.lex_state = 104},
  [1173] = {.lex_state = 104},
  [1174] = {.lex_state = 104},
  [1175] = {.lex_state = 103},
  [1176] = {.lex_state = 104},
  [1177] = {.lex_state = 104},
  [1178] = {.lex_state = 104},
  [1179] = {.lex_state = 103},
  [1180] = {.lex_state = 104},
  [1181] = {.lex_state = 104},
  [1182] = {.lex_state = 103},
  [1183] = {.lex_state = 104},
  [1184] = {.lex_state = 104},
  [1185] = {.lex_state = 104},
  [1186] = {.lex_state = 104},
  [1187] = {.lex_state = 103},
  [1188] = {.lex_state = 104},
  [1189] = {.lex_state = 104},
  [1190] = {.lex_state = 104},
  [1191] = {.lex_state = 28},
  [1192] = {.lex_state = 28},
  [1193] = {.lex_state = 28},
  [1194] = {.lex_state = 28},
  [1195] = {.lex_state = 28},
  [1196] = {.lex_state = 28},
  [1197] = {.lex_state = 28},
  [1198] = {.lex_state = 28},
  [1199] = {.lex_state = 28},
  [1200] = {.lex_state = 28},
  [1201] = {.lex_state = 28},
  [1202] = {.lex_state = 28},
  [1203] = {.lex_state = 104},
  [1204] = {.lex_state = 103},
  [1205] = {.lex_state = 28},
  [1206] = {.lex_state = 28},
  [1207] = {.lex_state = 28},
  [1208] = {.lex_state = 28},
  [1209] = {.lex_state = 28},
  [1210] = {.lex_state = 538},
  [1211] = {.lex_state = 538},
  [1212] = {.lex_state = 538},
  [1213] = {.lex_state = 538},
  [1214] = {.lex_state = 538},
  [1215] = {.lex_state = 109},
  [1216] = {.lex_state = 109},
  [1217] = {.lex_state = 538},
  [1218] = {.lex_state = 538},
  [1219] = {.lex_state = 94},
  [1220] = {.lex_state = 94},
  [1221] = {.lex_state = 94},
  [1222] = {.lex_state = 94},
  [1223] = {.lex_state = 103},
  [1224] = {.lex_state = 104},
  [1225] = {.lex_state = 104},
  [1226] = {.lex_state = 28},
  [1227] = {.lex_state = 104},
  [1228] = {.lex_state = 94},
  [1229] = {.lex_state = 28},
  [1230] = {.lex_state = 94},
  [1231] = {.lex_state = 538},
  [1232] = {.lex_state = 104},
  [1233] = {.lex_state = 28},
  [1234] = {.lex_state = 103},
  [1235] = {.lex_state = 103},
  [1236] = {.lex_state = 538},
  [1237] = {.lex_state = 538},
  [1238] = {.lex_state = 538},
  [1239] = {.lex_state = 538},
  [1240] = {.lex_state = 94},
  [1241] = {.lex_state = 94},
  [1242] = {.lex_state = 538},
  [1243] = {.lex_state = 538},
  [1244] = {.lex_state = 94},
  [1245] = {.lex_state = 94},
  [1246] = {.lex_state = 108},
  [1247] = {.lex_state = 94},
  [1248] = {.lex_state = 108},
  [1249] = {.lex_state = 94},
  [1250] = {.lex_state = 538},
  [1251] = {.lex_state = 538},
  [1252] = {.lex_state = 94},
  [1253] = {.lex_state = 94},
  [1254] = {.lex_state = 538},
  [1255] = {.lex_state = 538},
  [1256] = {.lex_state = 106},
  [1257] = {.lex_state = 106},
  [1258] = {.lex_state = 94},
  [1259] = {.lex_state = 538},
  [1260] = {.lex_state = 106},
  [1261] = {.lex_state = 94},
  [1262] = {.lex_state = 538},
  [1263] = {.lex_state = 106},
  [1264] = {.lex_state = 538},
  [1265] = {.lex_state = 94},
  [1266] = {.lex_state = 108},
  [1267] = {.lex_state = 106},
  [1268] = {.lex_state = 538},
  [1269] = {.lex_state = 538},
  [1270] = {.lex_state = 82},
  [1271] = {.lex_state = 118},
  [1272] = {.lex_state = 118},
  [1273] = {.lex_state = 82},
  [1274] = {.lex_state = 106},
  [1275] = {.lex_state = 106},
  [1276] = {.lex_state = 538},
  [1277] = {.lex_state = 538},
  [1278] = {.lex_state = 538},
  [1279] = {.lex_state = 106},
  [1280] = {.lex_state = 538},
  [1281] = {.lex_state = 106, .external_lex_state = 1},
  [1282] = {.lex_state = 538},
  [1283] = {.lex_state = 538},
  [1284] = {.lex_state = 538},
  [1285] = {.lex_state = 538},
  [1286] = {.lex_state = 538},
  [1287] = {.lex_state = 538},
  [1288] = {.lex_state = 538},
  [1289] = {.lex_state = 538},
  [1290] = {.lex_state = 538},
  [1291] = {.lex_state = 538},
  [1292] = {.lex_state = 538},
  [1293] = {.lex_state = 538},
  [1294] = {.lex_state = 102},
  [1295] = {.lex_state = 106},
  [1296] = {.lex_state = 106, .external_lex_state = 1},
  [1297] = {.lex_state = 102},
  [1298] = {.lex_state = 102},
  [1299] = {.lex_state = 538, .external_lex_state = 1},
  [1300] = {.lex_state = 538},
  [1301] = {.lex_state = 538},
  [1302] = {.lex_state = 538, .external_lex_state = 1},
  [1303] = {.lex_state = 538, .external_lex_state = 1},
  [1304] = {.lex_state = 538, .external_lex_state = 1},
  [1305] = {.lex_state = 106},
  [1306] = {.lex_state = 106},
  [1307] = {.lex_state = 106},
  [1308] = {.lex_state = 538},
  [1309] = {.lex_state = 538},
  [1310] = {.lex_state = 538},
  [1311] = {.lex_state = 108},
  [1312] = {.lex_state = 102},
  [1313] = {.lex_state = 108, .external_lex_state = 1},
  [1314] = {.lex_state = 108, .external_lex_state = 1},
  [1315] = {.lex_state = 33, .external_lex_state = 1},
  [1316] = {.lex_state = 111},
  [1317] = {.lex_state = 111},
  [1318] = {.lex_state = 111},
  [1319] = {.lex_state = 35},
  [1320] = {.lex_state = 108},
  [1321] = {.lex_state = 111},
  [1322] = {.lex_state = 35},
  [1323] = {.lex_state = 102},
  [1324] = {.lex_state = 102},
  [1325] = {.lex_state = 33, .external_lex_state = 1},
  [1326] = {.lex_state = 111},
  [1327] = {.lex_state = 111},
  [1328] = {.lex_state = 111},
  [1329] = {.lex_state = 538},
  [1330] = {.lex_state = 538},
  [1331] = {.lex_state = 538},
  [1332] = {.lex_state = 538},
  [1333] = {.lex_state = 111},
  [1334] = {.lex_state = 538, .external_lex_state = 1},
  [1335] = {.lex_state = 111},
  [1336] = {.lex_state = 108, .external_lex_state = 1},
  [1337] = {.lex_state = 538, .external_lex_state = 1},
  [1338] = {.lex_state = 111},
  [1339] = {.lex_state = 111},
  [1340] = {.lex_state = 538, .external_lex_state = 1},
  [1341] = {.lex_state = 538},
  [1342] = {.lex_state = 538, .external_lex_state = 1},
  [1343] = {.lex_state = 108},
  [1344] = {.lex_state = 111},
  [1345] = {.lex_state = 538},
  [1346] = {.lex_state = 111},
  [1347] = {.lex_state = 111},
  [1348] = {.lex_state = 111},
  [1349] = {.lex_state = 111},
  [1350] = {.lex_state = 538},
  [1351] = {.lex_state = 538},
  [1352] = {.lex_state = 111},
  [1353] = {.lex_state = 538},
  [1354] = {.lex_state = 111},
  [1355] = {.lex_state = 538},
  [1356] = {.lex_state = 111},
  [1357] = {.lex_state = 111},
  [1358] = {.lex_state = 111},
  [1359] = {.lex_state = 538},
  [1360] = {.lex_state = 538},
  [1361] = {.lex_state = 111},
  [1362] = {.lex_state = 538, .external_lex_state = 1},
  [1363] = {.lex_state = 111},
  [1364] = {.lex_state = 538, .external_lex_state = 1},
  [1365] = {.lex_state = 111},
  [1366] = {.lex_state = 538, .external_lex_state = 1},
  [1367] = {.lex_state = 538},
  [1368] = {.lex_state = 111},
  [1369] = {.lex_state = 111},
  [1370] = {.lex_state = 538, .external_lex_state = 1},
  [1371] = {.lex_state = 538},
  [1372] = {.lex_state = 538},
  [1373] = {.lex_state = 82},
  [1374] = {.lex_state = 82},
  [1375] = {.lex_state = 538},
  [1376] = {.lex_state = 106},
  [1377] = {.lex_state = 538},
  [1378] = {.lex_state = 106},
  [1379] = {.lex_state = 108, .external_lex_state = 1},
  [1380] = {.lex_state = 108},
  [1381] = {.lex_state = 82},
  [1382] = {.lex_state = 538},
  [1383] = {.lex_state = 82},
  [1384] = {.lex_state = 33},
  [1385] = {.lex_state = 108},
  [1386] = {.lex_state = 82},
  [1387] = {.lex_state = 82},
  [1388] = {.lex_state = 538},
  [1389] = {.lex_state = 538},
  [1390] = {.lex_state = 82},
  [1391] = {.lex_state = 82},
  [1392] = {.lex_state = 82},
  [1393] = {.lex_state = 538},
  [1394] = {.lex_state = 82},
  [1395] = {.lex_state = 538},
  [1396] = {.lex_state = 538},
  [1397] = {.lex_state = 33},
  [1398] = {.lex_state = 538, .external_lex_state = 1},
  [1399] = {.lex_state = 108, .external_lex_state = 1},
  [1400] = {.lex_state = 106},
  [1401] = {.lex_state = 82},
  [1402] = {.lex_state = 106},
  [1403] = {.lex_state = 37},
  [1404] = {.lex_state = 106},
  [1405] = {.lex_state = 97},
  [1406] = {.lex_state = 538, .external_lex_state = 1},
  [1407] = {.lex_state = 538, .external_lex_state = 1},
  [1408] = {.lex_state = 108, .external_lex_state = 1},
  [1409] = {.lex_state = 37},
  [1410] = {.lex_state = 92},
  [1411] = {.lex_state = 538},
  [1412] = {.lex_state = 538},
  [1413] = {.lex_state = 538, .external_lex_state = 1},
  [1414] = {.lex_state = 538},
  [1415] = {.lex_state = 106},
  [1416] = {.lex_state = 538},
  [1417] = {.lex_state = 538, .external_lex_state = 1},
  [1418] = {.lex_state = 106},
  [1419] = {.lex_state = 538, .external_lex_state = 1},
  [1420] = {.lex_state = 538},
  [1421] = {.lex_state = 92},
  [1422] = {.lex_state = 37},
  [1423] = {.lex_state = 92},
  [1424] = {.lex_state = 538},
  [1425] = {.lex_state = 538, .external_lex_state = 1},
  [1426] = {.lex_state = 92},
  [1427] = {.lex_state = 538},
  [1428] = {.lex_state = 538},
  [1429] = {.lex_state = 538},
  [1430] = {.lex_state = 97},
  [1431] = {.lex_state = 97},
  [1432] = {.lex_state = 108, .external_lex_state = 1},
  [1433] = {.lex_state = 538},
  [1434] = {.lex_state = 538, .external_lex_state = 1},
  [1435] = {.lex_state = 538},
  [1436] = {.lex_state = 108},
  [1437] = {.lex_state = 97},
  [1438] = {.lex_state = 37},
  [1439] = {.lex_state = 97},
  [1440] = {.lex_state = 538},
  [1441] = {.lex_state = 538},
  [1442] = {.lex_state = 538},
  [1443] = {.lex_state = 538},
  [1444] = {.lex_state = 97},
  [1445] = {.lex_state = 108},
  [1446] = {.lex_state = 538},
  [1447] = {.lex_state = 97},
  [1448] = {.lex_state = 92},
  [1449] = {.lex_state = 538},
  [1450] = {.lex_state = 113},
  [1451] = {.lex_state = 538},
  [1452] = {.lex_state = 97},
  [1453] = {.lex_state = 538},
  [1454] = {.lex_state = 538},
  [1455] = {.lex_state = 37},
  [1456] = {.lex_state = 538},
  [1457] = {.lex_state = 37},
  [1458] = {.lex_state = 538},
  [1459] = {.lex_state = 538},
  [1460] = {.lex_state = 37},
  [1461] = {.lex_state = 111},
  [1462] = {.lex_state = 97},
  [1463] = {.lex_state = 538},
  [1464] = {.lex_state = 538},
  [1465] = {.lex_state = 538},
  [1466] = {.lex_state = 538},
  [1467] = {.lex_state = 538},
  [1468] = {.lex_state = 538},
  [1469] = {.lex_state = 538},
  [1470] = {.lex_state = 37},
  [1471] = {.lex_state = 37},
  [1472] = {.lex_state = 538, .external_lex_state = 1},
  [1473] = {.lex_state = 538},
  [1474] = {.lex_state = 538},
  [1475] = {.lex_state = 538},
  [1476] = {.lex_state = 538},
  [1477] = {.lex_state = 97},
  [1478] = {.lex_state = 538},
  [1479] = {.lex_state = 538},
  [1480] = {.lex_state = 97},
  [1481] = {.lex_state = 106},
  [1482] = {.lex_state = 538},
  [1483] = {.lex_state = 92},
  [1484] = {.lex_state = 538},
  [1485] = {.lex_state = 538},
  [1486] = {.lex_state = 538},
  [1487] = {.lex_state = 538},
  [1488] = {.lex_state = 538, .external_lex_state = 1},
  [1489] = {.lex_state = 106},
  [1490] = {.lex_state = 538},
  [1491] = {.lex_state = 538},
  [1492] = {.lex_state = 106},
  [1493] = {.lex_state = 37},
  [1494] = {.lex_state = 538},
  [1495] = {.lex_state = 108, .external_lex_state = 1},
  [1496] = {.lex_state = 92},
  [1497] = {.lex_state = 106},
  [1498] = {.lex_state = 538},
  [1499] = {.lex_state = 106},
  [1500] = {.lex_state = 37},
  [1501] = {.lex_state = 538},
  [1502] = {.lex_state = 538},
  [1503] = {.lex_state = 97},
  [1504] = {.lex_state = 97},
  [1505] = {.lex_state = 97},
  [1506] = {.lex_state = 97},
  [1507] = {.lex_state = 538},
  [1508] = {.lex_state = 538},
  [1509] = {.lex_state = 97},
  [1510] = {.lex_state = 37},
  [1511] = {.lex_state = 92},
  [1512] = {.lex_state = 538},
  [1513] = {.lex_state = 538},
  [1514] = {.lex_state = 92},
  [1515] = {.lex_state = 538},
  [1516] = {.lex_state = 92},
  [1517] = {.lex_state = 97},
  [1518] = {.lex_state = 108},
  [1519] = {.lex_state = 92},
  [1520] = {.lex_state = 538},
  [1521] = {.lex_state = 538},
  [1522] = {.lex_state = 538},
  [1523] = {.lex_state = 538},
  [1524] = {.lex_state = 538},
  [1525] = {.lex_state = 538},
  [1526] = {.lex_state = 538},
  [1527] = {.lex_state = 538},
  [1528] = {.lex_state = 538},
  [1529] = {.lex_state = 538},
  [1530] = {.lex_state = 538},
  [1531] = {.lex_state = 538},
  [1532] = {.lex_state = 538, .external_lex_state = 1},
  [1533] = {.lex_state = 538},
  [1534] = {.lex_state = 119},
  [1535] = {.lex_state = 538},
  [1536] = {.lex_state = 119},
  [1537] = {.lex_state = 538},
  [1538] = {.lex_state = 538},
  [1539] = {.lex_state = 538},
  [1540] = {.lex_state = 119},
  [1541] = {.lex_state = 538},
  [1542] = {.lex_state = 538},
  [1543] = {.lex_state = 538},
  [1544] = {.lex_state = 538},
  [1545] = {.lex_state = 538},
  [1546] = {.lex_state = 538, .external_lex_state = 1},
  [1547] = {.lex_state = 538},
  [1548] = {.lex_state = 82},
  [1549] = {.lex_state = 538},
  [1550] = {.lex_state = 538},
  [1551] = {.lex_state = 538},
  [1552] = {.lex_state = 538},
  [1553] = {.lex_state = 538},
  [1554] = {.lex_state = 538},
  [1555] = {.lex_state = 538},
  [1556] = {.lex_state = 119},
  [1557] = {.lex_state = 538},
  [1558] = {.lex_state = 538},
  [1559] = {.lex_state = 538},
  [1560] = {.lex_state = 538},
  [1561] = {.lex_state = 538},
  [1562] = {.lex_state = 538},
  [1563] = {.lex_state = 538},
  [1564] = {.lex_state = 538},
  [1565] = {.lex_state = 538},
  [1566] = {.lex_state = 94},
  [1567] = {.lex_state = 538},
  [1568] = {.lex_state = 538},
  [1569] = {.lex_state = 538},
  [1570] = {.lex_state = 538},
  [1571] = {.lex_state = 538},
  [1572] = {.lex_state = 538},
  [1573] = {.lex_state = 538},
  [1574] = {.lex_state = 538},
  [1575] = {.lex_state = 538},
  [1576] = {.lex_state = 538},
  [1577] = {.lex_state = 538},
  [1578] = {.lex_state = 538},
  [1579] = {.lex_state = 82},
  [1580] = {.lex_state = 538},
  [1581] = {.lex_state = 538},
  [1582] = {.lex_state = 538},
  [1583] = {.lex_state = 538},
  [1584] = {.lex_state = 538},
  [1585] = {.lex_state = 538},
  [1586] = {.lex_state = 538},
  [1587] = {.lex_state = 538},
  [1588] = {.lex_state = 538},
  [1589] = {.lex_state = 106},
  [1590] = {.lex_state = 94},
  [1591] = {.lex_state = 94},
  [1592] = {.lex_state = 82},
  [1593] = {.lex_state = 538},
  [1594] = {.lex_state = 538},
  [1595] = {.lex_state = 538, .external_lex_state = 1},
  [1596] = {.lex_state = 538},
  [1597] = {.lex_state = 538},
  [1598] = {.lex_state = 538},
  [1599] = {.lex_state = 94},
  [1600] = {.lex_state = 538},
  [1601] = {.lex_state = 538},
  [1602] = {.lex_state = 538},
  [1603] = {.lex_state = 538},
  [1604] = {.lex_state = 538},
  [1605] = {.lex_state = 538},
  [1606] = {.lex_state = 82},
  [1607] = {.lex_state = 538},
  [1608] = {.lex_state = 538},
  [1609] = {.lex_state = 538},
  [1610] = {.lex_state = 538},
  [1611] = {.lex_state = 538},
  [1612] = {.lex_state = 538},
  [1613] = {.lex_state = 538, .external_lex_state = 1},
  [1614] = {.lex_state = 538},
  [1615] = {.lex_state = 538},
  [1616] = {.lex_state = 538},
  [1617] = {.lex_state = 538},
  [1618] = {.lex_state = 538},
  [1619] = {.lex_state = 538},
  [1620] = {.lex_state = 538},
  [1621] = {.lex_state = 538},
  [1622] = {.lex_state = 538},
  [1623] = {.lex_state = 538},
  [1624] = {.lex_state = 538},
  [1625] = {.lex_state = 538},
  [1626] = {.lex_state = 538},
  [1627] = {.lex_state = 538},
  [1628] = {.lex_state = 538},
  [1629] = {.lex_state = 538},
  [1630] = {.lex_state = 538},
  [1631] = {.lex_state = 538},
  [1632] = {.lex_state = 538},
  [1633] = {.lex_state = 538},
  [1634] = {.lex_state = 538},
  [1635] = {.lex_state = 538},
  [1636] = {.lex_state = 538},
  [1637] = {.lex_state = 538},
  [1638] = {.lex_state = 538},
  [1639] = {.lex_state = 538},
  [1640] = {.lex_state = 538},
  [1641] = {.lex_state = 538},
  [1642] = {.lex_state = 538},
  [1643] = {.lex_state = 538},
  [1644] = {.lex_state = 538},
  [1645] = {.lex_state = 538},
  [1646] = {.lex_state = 538},
  [1647] = {.lex_state = 538},
  [1648] = {.lex_state = 538},
  [1649] = {.lex_state = 538},
  [1650] = {.lex_state = 538},
  [1651] = {.lex_state = 538},
  [1652] = {.lex_state = 538},
  [1653] = {.lex_state = 538},
  [1654] = {.lex_state = 538},
  [1655] = {.lex_state = 538},
  [1656] = {.lex_state = 538, .external_lex_state = 1},
  [1657] = {.lex_state = 538},
  [1658] = {.lex_state = 538},
  [1659] = {.lex_state = 538},
  [1660] = {.lex_state = 538},
  [1661] = {.lex_state = 538},
  [1662] = {.lex_state = 538},
  [1663] = {.lex_state = 538},
  [1664] = {.lex_state = 538},
  [1665] = {.lex_state = 538},
  [1666] = {.lex_state = 538},
  [1667] = {.lex_state = 538},
  [1668] = {.lex_state = 538},
  [1669] = {.lex_state = 538},
  [1670] = {.lex_state = 538},
  [1671] = {.lex_state = 538},
  [1672] = {.lex_state = 538},
  [1673] = {.lex_state = 538},
  [1674] = {.lex_state = 538},
  [1675] = {.lex_state = 538, .external_lex_state = 1},
  [1676] = {.lex_state = 538},
  [1677] = {.lex_state = 538},
  [1678] = {.lex_state = 538},
  [1679] = {.lex_state = 538},
  [1680] = {.lex_state = 538},
  [1681] = {.lex_state = 538},
  [1682] = {.lex_state = 538},
  [1683] = {.lex_state = 538},
  [1684] = {.lex_state = 538},
  [1685] = {.lex_state = 538},
  [1686] = {.lex_state = 538},
  [1687] = {.lex_state = 538},
  [1688] = {.lex_state = 538},
  [1689] = {.lex_state = 538},
  [1690] = {.lex_state = 538},
  [1691] = {.lex_state = 538},
  [1692] = {.lex_state = 538},
  [1693] = {.lex_state = 538},
  [1694] = {.lex_state = 538},
  [1695] = {.lex_state = 538},
  [1696] = {.lex_state = 538},
  [1697] = {.lex_state = 538},
  [1698] = {.lex_state = 538},
  [1699] = {.lex_state = 538},
  [1700] = {.lex_state = 538},
  [1701] = {.lex_state = 538},
  [1702] = {.lex_state = 538},
  [1703] = {.lex_state = 538},
  [1704] = {.lex_state = 538},
  [1705] = {.lex_state = 538},
  [1706] = {.lex_state = 538},
  [1707] = {.lex_state = 538},
  [1708] = {.lex_state = 538},
  [1709] = {.lex_state = 538},
  [1710] = {.lex_state = 538},
  [1711] = {.lex_state = 538},
  [1712] = {.lex_state = 538},
  [1713] = {.lex_state = 538, .external_lex_state = 1},
  [1714] = {.lex_state = 538},
  [1715] = {.lex_state = 538},
  [1716] = {.lex_state = 82},
  [1717] = {.lex_state = 538, .external_lex_state = 1},
  [1718] = {.lex_state = 538},
  [1719] = {.lex_state = 538},
  [1720] = {.lex_state = 538},
  [1721] = {.lex_state = 538},
  [1722] = {.lex_state = 538},
  [1723] = {.lex_state = 538},
  [1724] = {.lex_state = 538},
  [1725] = {.lex_state = 538},
  [1726] = {.lex_state = 538},
  [1727] = {.lex_state = 538},
  [1728] = {.lex_state = 538},
  [1729] = {.lex_state = 538},
  [1730] = {.lex_state = 538},
  [1731] = {.lex_state = 538},
  [1732] = {.lex_state = 538},
  [1733] = {.lex_state = 538},
  [1734] = {.lex_state = 538},
  [1735] = {.lex_state = 538},
  [1736] = {.lex_state = 538},
  [1737] = {.lex_state = 538},
  [1738] = {.lex_state = 538},
  [1739] = {.lex_state = 538, .external_lex_state = 1},
  [1740] = {.lex_state = 538, .external_lex_state = 1},
  [1741] = {.lex_state = 538},
  [1742] = {.lex_state = 538},
  [1743] = {.lex_state = 538},
  [1744] = {.lex_state = 538},
  [1745] = {.lex_state = 538},
  [1746] = {.lex_state = 538},
  [1747] = {.lex_state = 538},
  [1748] = {.lex_state = 538},
  [1749] = {.lex_state = 538},
  [1750] = {.lex_state = 538},
  [1751] = {.lex_state = 538},
  [1752] = {.lex_state = 538},
  [1753] = {.lex_state = 538},
  [1754] = {.lex_state = 538},
  [1755] = {.lex_state = 538},
  [1756] = {.lex_state = 538},
  [1757] = {.lex_state = 538},
  [1758] = {.lex_state = 538},
  [1759] = {.lex_state = 538},
  [1760] = {.lex_state = 538},
  [1761] = {.lex_state = 538},
  [1762] = {.lex_state = 538},
  [1763] = {.lex_state = 538},
  [1764] = {.lex_state = 538},
  [1765] = {.lex_state = 538},
  [1766] = {.lex_state = 538},
  [1767] = {.lex_state = 538, .external_lex_state = 1},
  [1768] = {.lex_state = 538},
  [1769] = {.lex_state = 538},
  [1770] = {.lex_state = 538},
  [1771] = {.lex_state = 538},
  [1772] = {.lex_state = 538},
  [1773] = {.lex_state = 538},
  [1774] = {.lex_state = 538},
  [1775] = {.lex_state = 538},
  [1776] = {.lex_state = 538},
  [1777] = {.lex_state = 538},
  [1778] = {.lex_state = 538},
  [1779] = {.lex_state = 538},
  [1780] = {.lex_state = 538},
  [1781] = {.lex_state = 538, .external_lex_state = 1},
  [1782] = {.lex_state = 538, .external_lex_state = 1},
  [1783] = {.lex_state = 538},
  [1784] = {.lex_state = 538},
  [1785] = {.lex_state = 538},
  [1786] = {.lex_state = 538},
  [1787] = {.lex_state = 538},
  [1788] = {.lex_state = 538},
  [1789] = {.lex_state = 538},
  [1790] = {.lex_state = 538},
  [1791] = {.lex_state = 538},
  [1792] = {.lex_state = 538},
  [1793] = {.lex_state = 538},
  [1794] = {.lex_state = 538, .external_lex_state = 1},
  [1795] = {.lex_state = 538},
  [1796] = {.lex_state = 538},
  [1797] = {.lex_state = 538},
  [1798] = {.lex_state = 538},
  [1799] = {.lex_state = 538},
  [1800] = {.lex_state = 538},
  [1801] = {.lex_state = 538},
  [1802] = {.lex_state = 538},
  [1803] = {.lex_state = 538},
  [1804] = {.lex_state = 538},
  [1805] = {.lex_state = 538, .external_lex_state = 1},
  [1806] = {.lex_state = 538},
  [1807] = {.lex_state = 538},
  [1808] = {.lex_state = 82},
  [1809] = {.lex_state = 538},
  [1810] = {.lex_state = 538},
  [1811] = {.lex_state = 538},
  [1812] = {.lex_state = 538, .external_lex_state = 1},
  [1813] = {.lex_state = 538},
  [1814] = {.lex_state = 538},
  [1815] = {.lex_state = 538},
  [1816] = {.lex_state = 538},
  [1817] = {.lex_state = 538},
  [1818] = {.lex_state = 538},
  [1819] = {.lex_state = 538, .external_lex_state = 1},
  [1820] = {.lex_state = 538},
  [1821] = {.lex_state = 538},
  [1822] = {.lex_state = 538},
  [1823] = {.lex_state = 538},
  [1824] = {.lex_state = 538, .external_lex_state = 1},
  [1825] = {.lex_state = 538},
  [1826] = {.lex_state = 538},
  [1827] = {.lex_state = 538},
  [1828] = {.lex_state = 538},
  [1829] = {.lex_state = 538},
  [1830] = {.lex_state = 538},
  [1831] = {.lex_state = 538},
  [1832] = {.lex_state = 538},
  [1833] = {.lex_state = 538},
  [1834] = {.lex_state = 538},
  [1835] = {.lex_state = 538},
  [1836] = {.lex_state = 538},
  [1837] = {.lex_state = 538},
  [1838] = {.lex_state = 538},
  [1839] = {.lex_state = 538, .external_lex_state = 1},
  [1840] = {.lex_state = 538},
  [1841] = {.lex_state = 538, .external_lex_state = 1},
  [1842] = {.lex_state = 538},
  [1843] = {.lex_state = 538},
  [1844] = {.lex_state = 538},
  [1845] = {.lex_state = 538},
  [1846] = {.lex_state = 538},
  [1847] = {.lex_state = 538},
  [1848] = {.lex_state = 538, .external_lex_state = 1},
  [1849] = {.lex_state = 538},
  [1850] = {.lex_state = 538},
  [1851] = {.lex_state = 538},
  [1852] = {.lex_state = 538},
  [1853] = {.lex_state = 538},
  [1854] = {.lex_state = 538},
  [1855] = {.lex_state = 538},
  [1856] = {.lex_state = 538},
  [1857] = {.lex_state = 538},
  [1858] = {.lex_state = 538},
  [1859] = {.lex_state = 538, .external_lex_state = 1},
  [1860] = {.lex_state = 538},
  [1861] = {.lex_state = 538},
  [1862] = {.lex_state = 538},
  [1863] = {.lex_state = 111},
  [1864] = {.lex_state = 538},
  [1865] = {.lex_state = 538},
  [1866] = {.lex_state = 538},
  [1867] = {.lex_state = 538},
  [1868] = {.lex_state = 538, .external_lex_state = 1},
  [1869] = {.lex_state = 538},
  [1870] = {.lex_state = 538},
  [1871] = {.lex_state = 538},
  [1872] = {.lex_state = 538},
  [1873] = {.lex_state = 538},
  [1874] = {.lex_state = 538},
  [1875] = {.lex_state = 538},
  [1876] = {.lex_state = 538},
  [1877] = {.lex_state = 538},
  [1878] = {.lex_state = 538},
  [1879] = {.lex_state = 538},
  [1880] = {.lex_state = 538},
  [1881] = {.lex_state = 538},
  [1882] = {.lex_state = 538},
  [1883] = {.lex_state = 538},
  [1884] = {.lex_state = 538, .external_lex_state = 1},
  [1885] = {.lex_state = 538},
  [1886] = {.lex_state = 538},
  [1887] = {.lex_state = 538},
  [1888] = {.lex_state = 538, .external_lex_state = 1},
  [1889] = {.lex_state = 538},
  [1890] = {.lex_state = 538},
  [1891] = {.lex_state = 538},
  [1892] = {.lex_state = 538},
  [1893] = {.lex_state = 538},
  [1894] = {.lex_state = 538},
  [1895] = {.lex_state = 538},
  [1896] = {.lex_state = 538},
  [1897] = {.lex_state = 538},
  [1898] = {.lex_state = 538},
  [1899] = {.lex_state = 538},
  [1900] = {.lex_state = 538},
  [1901] = {.lex_state = 538},
  [1902] = {.lex_state = 538},
  [1903] = {.lex_state = 538},
  [1904] = {.lex_state = 538},
  [1905] = {.lex_state = 538},
  [1906] = {.lex_state = 538, .external_lex_state = 1},
  [1907] = {.lex_state = 538},
  [1908] = {.lex_state = 538},
  [1909] = {.lex_state = 538},
  [1910] = {.lex_state = 538},
  [1911] = {.lex_state = 538},
  [1912] = {.lex_state = 538, .external_lex_state = 1},
  [1913] = {.lex_state = 538},
  [1914] = {.lex_state = 538},
  [1915] = {.lex_state = 538},
  [1916] = {.lex_state = 538},
  [1917] = {.lex_state = 538},
  [1918] = {.lex_state = 538},
  [1919] = {.lex_state = 538},
  [1920] = {.lex_state = 538},
  [1921] = {.lex_state = 538},
  [1922] = {.lex_state = 538},
  [1923] = {.lex_state = 538},
  [1924] = {.lex_state = 538},
  [1925] = {.lex_state = 538},
  [1926] = {.lex_state = 538},
  [1927] = {.lex_state = 538},
  [1928] = {.lex_state = 538},
  [1929] = {.lex_state = 538},
  [1930] = {.lex_state = 538},
  [1931] = {.lex_state = 538},
  [1932] = {.lex_state = 538},
  [1933] = {.lex_state = 538},
  [1934] = {.lex_state = 538},
  [1935] = {.lex_state = 538},
  [1936] = {.lex_state = 538},
  [1937] = {.lex_state = 538},
  [1938] = {.lex_state = 538},
  [1939] = {.lex_state = 538},
  [1940] = {.lex_state = 538},
  [1941] = {.lex_state = 538},
  [1942] = {.lex_state = 538},
  [1943] = {.lex_state = 538},
  [1944] = {.lex_state = 538},
  [1945] = {.lex_state = 538, .external_lex_state = 1},
  [1946] = {.lex_state = 538},
  [1947] = {.lex_state = 538},
  [1948] = {.lex_state = 538, .external_lex_state = 1},
  [1949] = {.lex_state = 538},
  [1950] = {.lex_state = 538},
  [1951] = {.lex_state = 538},
  [1952] = {.lex_state = 538, .external_lex_state = 1},
  [1953] = {.lex_state = 538},
  [1954] = {.lex_state = 538},
  [1955] = {.lex_state = 538},
  [1956] = {.lex_state = 538},
  [1957] = {.lex_state = 538},
  [1958] = {.lex_state = 538},
  [1959] = {.lex_state = 538},
  [1960] = {.lex_state = 538},
  [1961] = {.lex_state = 538},
  [1962] = {.lex_state = 538},
  [1963] = {.lex_state = 538},
  [1964] = {.lex_state = 538},
  [1965] = {.lex_state = 538},
  [1966] = {.lex_state = 538},
  [1967] = {.lex_state = 538, .external_lex_state = 1},
  [1968] = {.lex_state = 538},
  [1969] = {.lex_state = 538, .external_lex_state = 1},
  [1970] = {.lex_state = 538, .external_lex_state = 1},
  [1971] = {.lex_state = 538, .external_lex_state = 1},
  [1972] = {.lex_state = 538},
  [1973] = {.lex_state = 538},
  [1974] = {.lex_state = 538, .external_lex_state = 1},
  [1975] = {.lex_state = 538, .external_lex_state = 1},
  [1976] = {.lex_state = 538, .external_lex_state = 1},
  [1977] = {.lex_state = 538},
  [1978] = {.lex_state = 538},
  [1979] = {.lex_state = 538},
  [1980] = {.lex_state = 538, .external_lex_state = 1},
  [1981] = {.lex_state = 538},
  [1982] = {.lex_state = 538},
  [1983] = {.lex_state = 538, .external_lex_state = 1},
  [1984] = {.lex_state = 538, .external_lex_state = 1},
  [1985] = {.lex_state = 538},
  [1986] = {.lex_state = 538},
  [1987] = {.lex_state = 538},
  [1988] = {.lex_state = 538},
  [1989] = {.lex_state = 538},
  [1990] = {.lex_state = 538},
  [1991] = {.lex_state = 538, .external_lex_state = 1},
  [1992] = {.lex_state = 538, .external_lex_state = 1},
  [1993] = {.lex_state = 538},
  [1994] = {.lex_state = 538},
  [1995] = {.lex_state = 538, .external_lex_state = 1},
  [1996] = {.lex_state = 538, .external_lex_state = 1},
  [1997] = {.lex_state = 538, .external_lex_state = 1},
  [1998] = {.lex_state = 538, .external_lex_state = 1},
  [1999] = {.lex_state = 538, .external_lex_state = 1},
  [2000] = {.lex_state = 538, .external_lex_state = 1},
  [2001] = {.lex_state = 538, .external_lex_state = 1},
  [2002] = {.lex_state = 538, .external_lex_state = 1},
  [2003] = {.lex_state = 538, .external_lex_state = 1},
  [2004] = {.lex_state = 538},
  [2005] = {.lex_state = 538},
  [2006] = {.lex_state = 538},
  [2007] = {.lex_state = 82},
  [2008] = {.lex_state = 82},
  [2009] = {.lex_state = 538},
  [2010] = {.lex_state = 538},
  [2011] = {.lex_state = 538, .external_lex_state = 1},
  [2012] = {.lex_state = 538, .external_lex_state = 1},
  [2013] = {.lex_state = 538, .external_lex_state = 1},
  [2014] = {.lex_state = 538, .external_lex_state = 1},
  [2015] = {.lex_state = 538},
  [2016] = {.lex_state = 82},
  [2017] = {.lex_state = 538, .external_lex_state = 1},
  [2018] = {.lex_state = 538, .external_lex_state = 1},
  [2019] = {.lex_state = 538, .external_lex_state = 1},
  [2020] = {.lex_state = 538, .external_lex_state = 1},
  [2021] = {.lex_state = 538, .external_lex_state = 1},
  [2022] = {.lex_state = 538, .external_lex_state = 1},
  [2023] = {.lex_state = 538, .external_lex_state = 1},
  [2024] = {.lex_state = 538, .external_lex_state = 1},
  [2025] = {.lex_state = 538, .external_lex_state = 1},
  [2026] = {.lex_state = 538, .external_lex_state = 1},
  [2027] = {.lex_state = 538, .external_lex_state = 1},
  [2028] = {.lex_state = 538, .external_lex_state = 1},
  [2029] = {.lex_state = 538, .external_lex_state = 1},
  [2030] = {.lex_state = 538, .external_lex_state = 1},
  [2031] = {.lex_state = 538},
  [2032] = {.lex_state = 538},
  [2033] = {.lex_state = 82},
  [2034] = {.lex_state = 82},
  [2035] = {.lex_state = 538, .external_lex_state = 1},
  [2036] = {.lex_state = 538, .external_lex_state = 1},
  [2037] = {.lex_state = 538, .external_lex_state = 1},
  [2038] = {.lex_state = 538},
  [2039] = {.lex_state = 538},
  [2040] = {.lex_state = 538, .external_lex_state = 1},
  [2041] = {.lex_state = 538},
  [2042] = {.lex_state = 538},
  [2043] = {.lex_state = 538, .external_lex_state = 1},
  [2044] = {.lex_state = 538, .external_lex_state = 1},
  [2045] = {.lex_state = 538, .external_lex_state = 1},
  [2046] = {.lex_state = 538, .external_lex_state = 1},
  [2047] = {.lex_state = 538, .external_lex_state = 1},
  [2048] = {.lex_state = 538},
  [2049] = {.lex_state = 538},
  [2050] = {.lex_state = 82},
  [2051] = {.lex_state = 82},
  [2052] = {.lex_state = 538},
  [2053] = {.lex_state = 538},
  [2054] = {.lex_state = 538},
  [2055] = {.lex_state = 538, .external_lex_state = 1},
  [2056] = {.lex_state = 538},
  [2057] = {.lex_state = 82},
  [2058] = {.lex_state = 538},
  [2059] = {.lex_state = 538, .external_lex_state = 1},
  [2060] = {.lex_state = 538, .external_lex_state = 1},
  [2061] = {.lex_state = 538, .external_lex_state = 1},
  [2062] = {.lex_state = 538, .external_lex_state = 1},
  [2063] = {.lex_state = 538, .external_lex_state = 1},
  [2064] = {.lex_state = 538, .external_lex_state = 1},
  [2065] = {.lex_state = 538, .external_lex_state = 1},
  [2066] = {.lex_state = 538, .external_lex_state = 1},
  [2067] = {.lex_state = 538},
  [2068] = {.lex_state = 538},
  [2069] = {.lex_state = 82},
  [2070] = {.lex_state = 82},
  [2071] = {.lex_state = 538},
  [2072] = {.lex_state = 538},
  [2073] = {.lex_state = 538, .external_lex_state = 1},
  [2074] = {.lex_state = 538},
  [2075] = {.lex_state = 82},
  [2076] = {.lex_state = 538, .external_lex_state = 1},
  [2077] = {.lex_state = 538, .external_lex_state = 1},
  [2078] = {.lex_state = 538, .external_lex_state = 1},
  [2079] = {.lex_state = 538, .external_lex_state = 1},
  [2080] = {.lex_state = 538, .external_lex_state = 1},
  [2081] = {.lex_state = 538, .external_lex_state = 1},
  [2082] = {.lex_state = 538, .external_lex_state = 1},
  [2083] = {.lex_state = 538, .external_lex_state = 1},
  [2084] = {.lex_state = 538, .external_lex_state = 1},
  [2085] = {.lex_state = 538},
  [2086] = {.lex_state = 538},
  [2087] = {.lex_state = 538, .external_lex_state = 1},
  [2088] = {.lex_state = 538},
  [2089] = {.lex_state = 538},
  [2090] = {.lex_state = 538},
  [2091] = {.lex_state = 538},
  [2092] = {.lex_state = 538},
  [2093] = {.lex_state = 538},
  [2094] = {.lex_state = 538},
  [2095] = {.lex_state = 538},
  [2096] = {.lex_state = 538},
  [2097] = {.lex_state = 538},
  [2098] = {.lex_state = 538},
  [2099] = {.lex_state = 538},
  [2100] = {.lex_state = 538},
  [2101] = {.lex_state = 538},
  [2102] = {.lex_state = 538},
  [2103] = {.lex_state = 538},
  [2104] = {.lex_state = 538},
  [2105] = {.lex_state = 538, .external_lex_state = 1},
  [2106] = {.lex_state = 538, .external_lex_state = 1},
  [2107] = {.lex_state = 538},
  [2108] = {.lex_state = 538},
  [2109] = {.lex_state = 538},
  [2110] = {.lex_state = 538},
  [2111] = {.lex_state = 538, .external_lex_state = 1},
  [2112] = {.lex_state = 538, .external_lex_state = 1},
  [2113] = {.lex_state = 538, .external_lex_state = 1},
  [2114] = {.lex_state = 538},
  [2115] = {.lex_state = 538, .external_lex_state = 1},
  [2116] = {.lex_state = 538},
  [2117] = {.lex_state = 538, .external_lex_state = 1},
  [2118] = {.lex_state = 538},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1),
    [sym_hexadecimal_integer_literal] = ACTIONS(1),
    [sym_real_literal] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [aux_sym_expandable_string_literal_token5] = ACTIONS(1),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1),
    [sym_verbatim_here_string_characters] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_2_GT] = ACTIONS(1),
    [anon_sym_2_GT_GT] = ACTIONS(1),
    [anon_sym_3_GT] = ACTIONS(1),
    [anon_sym_3_GT_GT] = ACTIONS(1),
    [anon_sym_4_GT] = ACTIONS(1),
    [anon_sym_4_GT_GT] = ACTIONS(1),
    [anon_sym_5_GT] = ACTIONS(1),
    [anon_sym_5_GT_GT] = ACTIONS(1),
    [anon_sym_6_GT] = ACTIONS(1),
    [anon_sym_6_GT_GT] = ACTIONS(1),
    [anon_sym_STAR_GT] = ACTIONS(1),
    [anon_sym_STAR_GT_GT] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(1),
    [anon_sym_2_GT_AMP1] = ACTIONS(1),
    [anon_sym_3_GT_AMP1] = ACTIONS(1),
    [anon_sym_4_GT_AMP1] = ACTIONS(1),
    [anon_sym_5_GT_AMP1] = ACTIONS(1),
    [anon_sym_6_GT_AMP1] = ACTIONS(1),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(1),
    [anon_sym_1_GT_AMP2] = ACTIONS(1),
    [anon_sym_3_GT_AMP2] = ACTIONS(1),
    [anon_sym_4_GT_AMP2] = ACTIONS(1),
    [anon_sym_5_GT_AMP2] = ACTIONS(1),
    [anon_sym_6_GT_AMP2] = ACTIONS(1),
    [anon_sym_DASHas] = ACTIONS(1),
    [anon_sym_DASHccontains] = ACTIONS(1),
    [anon_sym_DASHceq] = ACTIONS(1),
    [anon_sym_DASHcge] = ACTIONS(1),
    [anon_sym_DASHcgt] = ACTIONS(1),
    [anon_sym_DASHcle] = ACTIONS(1),
    [anon_sym_DASHclike] = ACTIONS(1),
    [anon_sym_DASHclt] = ACTIONS(1),
    [anon_sym_DASHcmatch] = ACTIONS(1),
    [anon_sym_DASHcne] = ACTIONS(1),
    [anon_sym_DASHcnotcontains] = ACTIONS(1),
    [anon_sym_DASHcnotlike] = ACTIONS(1),
    [anon_sym_DASHcnotmatch] = ACTIONS(1),
    [anon_sym_DASHcontains] = ACTIONS(1),
    [anon_sym_DASHcreplace] = ACTIONS(1),
    [anon_sym_DASHcsplit] = ACTIONS(1),
    [anon_sym_DASHeq] = ACTIONS(1),
    [anon_sym_DASHge] = ACTIONS(1),
    [anon_sym_DASHgt] = ACTIONS(1),
    [anon_sym_DASHicontains] = ACTIONS(1),
    [anon_sym_DASHieq] = ACTIONS(1),
    [anon_sym_DASHige] = ACTIONS(1),
    [anon_sym_DASHigt] = ACTIONS(1),
    [anon_sym_DASHile] = ACTIONS(1),
    [anon_sym_DASHilike] = ACTIONS(1),
    [anon_sym_DASHilt] = ACTIONS(1),
    [anon_sym_DASHimatch] = ACTIONS(1),
    [anon_sym_DASHin] = ACTIONS(1),
    [anon_sym_DASHine] = ACTIONS(1),
    [anon_sym_DASHinotcontains] = ACTIONS(1),
    [anon_sym_DASHinotlike] = ACTIONS(1),
    [anon_sym_DASHinotmatch] = ACTIONS(1),
    [anon_sym_DASHireplace] = ACTIONS(1),
    [anon_sym_DASHis] = ACTIONS(1),
    [anon_sym_DASHisnot] = ACTIONS(1),
    [anon_sym_DASHisplit] = ACTIONS(1),
    [anon_sym_DASHjoin] = ACTIONS(1),
    [anon_sym_DASHle] = ACTIONS(1),
    [anon_sym_DASHlike] = ACTIONS(1),
    [anon_sym_DASHlt] = ACTIONS(1),
    [anon_sym_DASHmatch] = ACTIONS(1),
    [anon_sym_DASHne] = ACTIONS(1),
    [anon_sym_DASHnotcontains] = ACTIONS(1),
    [anon_sym_DASHnotin] = ACTIONS(1),
    [anon_sym_DASHnotlike] = ACTIONS(1),
    [anon_sym_DASHnotmatch] = ACTIONS(1),
    [anon_sym_DASHreplace] = ACTIONS(1),
    [anon_sym_DASHshl] = ACTIONS(1),
    [anon_sym_DASHshr] = ACTIONS(1),
    [anon_sym_DASHsplit] = ACTIONS(1),
    [sym_format_operator] = ACTIONS(1),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1),
    [anon_sym_DOLLAR_] = ACTIONS(1),
    [aux_sym_variable_token1] = ACTIONS(1),
    [aux_sym_variable_token2] = ACTIONS(1),
    [sym_braced_variable] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_param] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_dynamicparam] = ACTIONS(1),
    [anon_sym_begin] = ACTIONS(1),
    [anon_sym_process] = ACTIONS(1),
    [anon_sym_end] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_elseif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_DASHregex] = ACTIONS(1),
    [anon_sym_DASHwildcard] = ACTIONS(1),
    [anon_sym_DASHexact] = ACTIONS(1),
    [anon_sym_DASHcasesensitive] = ACTIONS(1),
    [anon_sym_DASHparallel] = ACTIONS(1),
    [anon_sym_DASHfile] = ACTIONS(1),
    [anon_sym_foreach] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_until] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_filter] = ACTIONS(1),
    [anon_sym_workflow] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_exit] = ACTIONS(1),
    [anon_sym_trap] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_data] = ACTIONS(1),
    [anon_sym_DASHsupportedcommand] = ACTIONS(1),
    [anon_sym_parallel] = ACTIONS(1),
    [anon_sym_sequence] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_DOLLAR2] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE2] = ACTIONS(1),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1),
    [sym_stop_parsing] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_foreach_DASHobject] = ACTIONS(1),
    [anon_sym_DASH_DASH_PERCENT] = ACTIONS(1),
    [anon_sym_hidden] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_DASHand] = ACTIONS(1),
    [anon_sym_DASHor] = ACTIONS(1),
    [anon_sym_DASHxor] = ACTIONS(1),
    [anon_sym_DASHband] = ACTIONS(1),
    [anon_sym_DASHbor] = ACTIONS(1),
    [anon_sym_DASHbxor] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_BSLASH] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_DASHnot] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_DASHbnot] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1),
    [anon_sym_AT_LPAREN] = ACTIONS(1),
    [anon_sym_AT_LBRACE] = ACTIONS(1),
    [anon_sym_DOT2] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [sym__statement_terminator] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(2032),
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_param_block] = STATE(75),
    [sym_statement_list] = STATE(2031),
    [sym__statement] = STATE(73),
    [sym_empty_statement] = STATE(73),
    [sym_if_statement] = STATE(73),
    [sym__labeled_statement] = STATE(73),
    [sym_switch_statement] = STATE(73),
    [sym_foreach_statement] = STATE(73),
    [sym_for_statement] = STATE(73),
    [sym_while_statement] = STATE(73),
    [sym_do_statement] = STATE(73),
    [sym_function_statement] = STATE(73),
    [sym_flow_control_statement] = STATE(2030),
    [sym_trap_statement] = STATE(73),
    [sym_try_statement] = STATE(73),
    [sym_data_statement] = STATE(73),
    [sym_inlinescript_statement] = STATE(73),
    [sym_parallel_statement] = STATE(73),
    [sym_sequence_statement] = STATE(73),
    [sym_pipeline] = STATE(2030),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(73),
    [sym_enum_statement] = STATE(73),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2004),
    [sym_attribute] = STATE(1250),
    [aux_sym_statement_list_repeat1] = STATE(73),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_param] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_foreach] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_function] = ACTIONS(43),
    [anon_sym_filter] = ACTIONS(43),
    [anon_sym_workflow] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(49),
    [anon_sym_trap] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_data] = ACTIONS(55),
    [anon_sym_inlinescript] = ACTIONS(57),
    [anon_sym_parallel] = ACTIONS(59),
    [anon_sym_sequence] = ACTIONS(61),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [2] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_unary_expression] = STATE(165),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(83),
    [sym_real_literal] = ACTIONS(85),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(87),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(89),
    [sym_verbatim_string_characters] = ACTIONS(91),
    [sym_verbatim_here_string_characters] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(93),
    [anon_sym_EQ] = ACTIONS(95),
    [anon_sym_BANG_EQ] = ACTIONS(95),
    [anon_sym_PLUS_EQ] = ACTIONS(95),
    [anon_sym_STAR_EQ] = ACTIONS(95),
    [anon_sym_SLASH_EQ] = ACTIONS(95),
    [anon_sym_PERCENT_EQ] = ACTIONS(95),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_GT] = ACTIONS(95),
    [anon_sym_2_GT] = ACTIONS(97),
    [anon_sym_2_GT_GT] = ACTIONS(95),
    [anon_sym_3_GT] = ACTIONS(97),
    [anon_sym_3_GT_GT] = ACTIONS(95),
    [anon_sym_4_GT] = ACTIONS(97),
    [anon_sym_4_GT_GT] = ACTIONS(95),
    [anon_sym_5_GT] = ACTIONS(97),
    [anon_sym_5_GT_GT] = ACTIONS(95),
    [anon_sym_6_GT] = ACTIONS(97),
    [anon_sym_6_GT_GT] = ACTIONS(95),
    [anon_sym_STAR_GT] = ACTIONS(97),
    [anon_sym_STAR_GT_GT] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(95),
    [anon_sym_2_GT_AMP1] = ACTIONS(95),
    [anon_sym_3_GT_AMP1] = ACTIONS(95),
    [anon_sym_4_GT_AMP1] = ACTIONS(95),
    [anon_sym_5_GT_AMP1] = ACTIONS(95),
    [anon_sym_6_GT_AMP1] = ACTIONS(95),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(95),
    [anon_sym_1_GT_AMP2] = ACTIONS(95),
    [anon_sym_3_GT_AMP2] = ACTIONS(95),
    [anon_sym_4_GT_AMP2] = ACTIONS(95),
    [anon_sym_5_GT_AMP2] = ACTIONS(95),
    [anon_sym_6_GT_AMP2] = ACTIONS(95),
    [anon_sym_DASHas] = ACTIONS(95),
    [anon_sym_DASHccontains] = ACTIONS(95),
    [anon_sym_DASHceq] = ACTIONS(95),
    [anon_sym_DASHcge] = ACTIONS(95),
    [anon_sym_DASHcgt] = ACTIONS(95),
    [anon_sym_DASHcle] = ACTIONS(95),
    [anon_sym_DASHclike] = ACTIONS(95),
    [anon_sym_DASHclt] = ACTIONS(95),
    [anon_sym_DASHcmatch] = ACTIONS(95),
    [anon_sym_DASHcne] = ACTIONS(95),
    [anon_sym_DASHcnotcontains] = ACTIONS(95),
    [anon_sym_DASHcnotlike] = ACTIONS(95),
    [anon_sym_DASHcnotmatch] = ACTIONS(95),
    [anon_sym_DASHcontains] = ACTIONS(95),
    [anon_sym_DASHcreplace] = ACTIONS(95),
    [anon_sym_DASHcsplit] = ACTIONS(95),
    [anon_sym_DASHeq] = ACTIONS(95),
    [anon_sym_DASHge] = ACTIONS(95),
    [anon_sym_DASHgt] = ACTIONS(95),
    [anon_sym_DASHicontains] = ACTIONS(95),
    [anon_sym_DASHieq] = ACTIONS(95),
    [anon_sym_DASHige] = ACTIONS(95),
    [anon_sym_DASHigt] = ACTIONS(95),
    [anon_sym_DASHile] = ACTIONS(95),
    [anon_sym_DASHilike] = ACTIONS(95),
    [anon_sym_DASHilt] = ACTIONS(95),
    [anon_sym_DASHimatch] = ACTIONS(95),
    [anon_sym_DASHin] = ACTIONS(97),
    [anon_sym_DASHine] = ACTIONS(95),
    [anon_sym_DASHinotcontains] = ACTIONS(95),
    [anon_sym_DASHinotlike] = ACTIONS(95),
    [anon_sym_DASHinotmatch] = ACTIONS(95),
    [anon_sym_DASHireplace] = ACTIONS(95),
    [anon_sym_DASHis] = ACTIONS(97),
    [anon_sym_DASHisnot] = ACTIONS(95),
    [anon_sym_DASHisplit] = ACTIONS(95),
    [anon_sym_DASHjoin] = ACTIONS(99),
    [anon_sym_DASHle] = ACTIONS(95),
    [anon_sym_DASHlike] = ACTIONS(95),
    [anon_sym_DASHlt] = ACTIONS(95),
    [anon_sym_DASHmatch] = ACTIONS(95),
    [anon_sym_DASHne] = ACTIONS(95),
    [anon_sym_DASHnotcontains] = ACTIONS(95),
    [anon_sym_DASHnotin] = ACTIONS(95),
    [anon_sym_DASHnotlike] = ACTIONS(95),
    [anon_sym_DASHnotmatch] = ACTIONS(95),
    [anon_sym_DASHreplace] = ACTIONS(95),
    [anon_sym_DASHshl] = ACTIONS(95),
    [anon_sym_DASHshr] = ACTIONS(95),
    [anon_sym_DASHsplit] = ACTIONS(99),
    [sym_format_operator] = ACTIONS(95),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(101),
    [anon_sym_DOLLAR_CARET] = ACTIONS(101),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(101),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(101),
    [sym_braced_variable] = ACTIONS(101),
    [anon_sym_param] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_COMMA] = ACTIONS(99),
    [anon_sym_LBRACE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_PERCENT] = ACTIONS(97),
    [anon_sym_DASHand] = ACTIONS(95),
    [anon_sym_DASHor] = ACTIONS(95),
    [anon_sym_DASHxor] = ACTIONS(95),
    [anon_sym_DASHband] = ACTIONS(95),
    [anon_sym_DASHbor] = ACTIONS(95),
    [anon_sym_DASHbxor] = ACTIONS(95),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(97),
    [anon_sym_BSLASH] = ACTIONS(95),
    [anon_sym_STAR] = ACTIONS(97),
    [anon_sym_DOT_DOT] = ACTIONS(95),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(113),
    [anon_sym_AT_LPAREN] = ACTIONS(115),
    [anon_sym_AT_LBRACE] = ACTIONS(117),
    [anon_sym_DOT2] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(95),
    [anon_sym_DOTforeach] = ACTIONS(95),
    [sym__statement_terminator] = ACTIONS(95),
  },
  [3] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_unary_expression] = STATE(163),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(121),
    [sym_real_literal] = ACTIONS(123),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(125),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(127),
    [sym_verbatim_string_characters] = ACTIONS(129),
    [sym_verbatim_here_string_characters] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(95),
    [anon_sym_BANG_EQ] = ACTIONS(95),
    [anon_sym_PLUS_EQ] = ACTIONS(95),
    [anon_sym_STAR_EQ] = ACTIONS(95),
    [anon_sym_SLASH_EQ] = ACTIONS(95),
    [anon_sym_PERCENT_EQ] = ACTIONS(95),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_GT] = ACTIONS(95),
    [anon_sym_2_GT] = ACTIONS(97),
    [anon_sym_2_GT_GT] = ACTIONS(95),
    [anon_sym_3_GT] = ACTIONS(97),
    [anon_sym_3_GT_GT] = ACTIONS(95),
    [anon_sym_4_GT] = ACTIONS(97),
    [anon_sym_4_GT_GT] = ACTIONS(95),
    [anon_sym_5_GT] = ACTIONS(97),
    [anon_sym_5_GT_GT] = ACTIONS(95),
    [anon_sym_6_GT] = ACTIONS(97),
    [anon_sym_6_GT_GT] = ACTIONS(95),
    [anon_sym_STAR_GT] = ACTIONS(97),
    [anon_sym_STAR_GT_GT] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(95),
    [anon_sym_2_GT_AMP1] = ACTIONS(95),
    [anon_sym_3_GT_AMP1] = ACTIONS(95),
    [anon_sym_4_GT_AMP1] = ACTIONS(95),
    [anon_sym_5_GT_AMP1] = ACTIONS(95),
    [anon_sym_6_GT_AMP1] = ACTIONS(95),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(95),
    [anon_sym_1_GT_AMP2] = ACTIONS(95),
    [anon_sym_3_GT_AMP2] = ACTIONS(95),
    [anon_sym_4_GT_AMP2] = ACTIONS(95),
    [anon_sym_5_GT_AMP2] = ACTIONS(95),
    [anon_sym_6_GT_AMP2] = ACTIONS(95),
    [anon_sym_DASHas] = ACTIONS(95),
    [anon_sym_DASHccontains] = ACTIONS(95),
    [anon_sym_DASHceq] = ACTIONS(95),
    [anon_sym_DASHcge] = ACTIONS(95),
    [anon_sym_DASHcgt] = ACTIONS(95),
    [anon_sym_DASHcle] = ACTIONS(95),
    [anon_sym_DASHclike] = ACTIONS(95),
    [anon_sym_DASHclt] = ACTIONS(95),
    [anon_sym_DASHcmatch] = ACTIONS(95),
    [anon_sym_DASHcne] = ACTIONS(95),
    [anon_sym_DASHcnotcontains] = ACTIONS(95),
    [anon_sym_DASHcnotlike] = ACTIONS(95),
    [anon_sym_DASHcnotmatch] = ACTIONS(95),
    [anon_sym_DASHcontains] = ACTIONS(95),
    [anon_sym_DASHcreplace] = ACTIONS(95),
    [anon_sym_DASHcsplit] = ACTIONS(95),
    [anon_sym_DASHeq] = ACTIONS(95),
    [anon_sym_DASHge] = ACTIONS(95),
    [anon_sym_DASHgt] = ACTIONS(95),
    [anon_sym_DASHicontains] = ACTIONS(95),
    [anon_sym_DASHieq] = ACTIONS(95),
    [anon_sym_DASHige] = ACTIONS(95),
    [anon_sym_DASHigt] = ACTIONS(95),
    [anon_sym_DASHile] = ACTIONS(95),
    [anon_sym_DASHilike] = ACTIONS(95),
    [anon_sym_DASHilt] = ACTIONS(95),
    [anon_sym_DASHimatch] = ACTIONS(95),
    [anon_sym_DASHin] = ACTIONS(97),
    [anon_sym_DASHine] = ACTIONS(95),
    [anon_sym_DASHinotcontains] = ACTIONS(95),
    [anon_sym_DASHinotlike] = ACTIONS(95),
    [anon_sym_DASHinotmatch] = ACTIONS(95),
    [anon_sym_DASHireplace] = ACTIONS(95),
    [anon_sym_DASHis] = ACTIONS(97),
    [anon_sym_DASHisnot] = ACTIONS(95),
    [anon_sym_DASHisplit] = ACTIONS(95),
    [anon_sym_DASHjoin] = ACTIONS(133),
    [anon_sym_DASHle] = ACTIONS(95),
    [anon_sym_DASHlike] = ACTIONS(95),
    [anon_sym_DASHlt] = ACTIONS(95),
    [anon_sym_DASHmatch] = ACTIONS(95),
    [anon_sym_DASHne] = ACTIONS(95),
    [anon_sym_DASHnotcontains] = ACTIONS(95),
    [anon_sym_DASHnotin] = ACTIONS(95),
    [anon_sym_DASHnotlike] = ACTIONS(95),
    [anon_sym_DASHnotmatch] = ACTIONS(95),
    [anon_sym_DASHreplace] = ACTIONS(95),
    [anon_sym_DASHshl] = ACTIONS(95),
    [anon_sym_DASHshr] = ACTIONS(95),
    [anon_sym_DASHsplit] = ACTIONS(133),
    [sym_format_operator] = ACTIONS(95),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(135),
    [anon_sym_DOLLAR_CARET] = ACTIONS(135),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(135),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(135),
    [sym_braced_variable] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(95),
    [anon_sym_COMMA] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_PERCENT] = ACTIONS(97),
    [anon_sym_DASHand] = ACTIONS(95),
    [anon_sym_DASHor] = ACTIONS(95),
    [anon_sym_DASHxor] = ACTIONS(95),
    [anon_sym_DASHband] = ACTIONS(95),
    [anon_sym_DASHbor] = ACTIONS(95),
    [anon_sym_DASHbxor] = ACTIONS(95),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_SLASH] = ACTIONS(97),
    [anon_sym_BSLASH] = ACTIONS(95),
    [anon_sym_STAR] = ACTIONS(97),
    [anon_sym_DOT_DOT] = ACTIONS(95),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(145),
    [anon_sym_DASH_DASH] = ACTIONS(147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_AT_LBRACE] = ACTIONS(153),
    [anon_sym_DOT2] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(95),
    [anon_sym_DOTforeach] = ACTIONS(95),
  },
  [4] = {
    [sym__literal] = STATE(135),
    [sym_integer_literal] = STATE(135),
    [sym_string_literal] = STATE(135),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(135),
    [sym_unary_expression] = STATE(112),
    [sym_expression_with_unary_operator] = STATE(117),
    [sym_pre_increment_expression] = STATE(118),
    [sym_pre_decrement_expression] = STATE(118),
    [sym_cast_expression] = STATE(118),
    [sym__primary_expression] = STATE(135),
    [sym__value] = STATE(135),
    [sym_parenthesized_expression] = STATE(135),
    [sym_sub_expression] = STATE(135),
    [sym_array_expression] = STATE(135),
    [sym_script_block_expression] = STATE(135),
    [sym_hash_literal_expression] = STATE(135),
    [sym_post_increment_expression] = STATE(135),
    [sym_post_decrement_expression] = STATE(135),
    [sym_member_access] = STATE(135),
    [sym_element_access] = STATE(135),
    [sym_invokation_expression] = STATE(135),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(4),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(121),
    [sym_real_literal] = ACTIONS(155),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(125),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(127),
    [sym_verbatim_string_characters] = ACTIONS(129),
    [sym_verbatim_here_string_characters] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(95),
    [anon_sym_BANG_EQ] = ACTIONS(95),
    [anon_sym_PLUS_EQ] = ACTIONS(95),
    [anon_sym_STAR_EQ] = ACTIONS(95),
    [anon_sym_SLASH_EQ] = ACTIONS(95),
    [anon_sym_PERCENT_EQ] = ACTIONS(95),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_GT] = ACTIONS(95),
    [anon_sym_2_GT] = ACTIONS(97),
    [anon_sym_2_GT_GT] = ACTIONS(95),
    [anon_sym_3_GT] = ACTIONS(97),
    [anon_sym_3_GT_GT] = ACTIONS(95),
    [anon_sym_4_GT] = ACTIONS(97),
    [anon_sym_4_GT_GT] = ACTIONS(95),
    [anon_sym_5_GT] = ACTIONS(97),
    [anon_sym_5_GT_GT] = ACTIONS(95),
    [anon_sym_6_GT] = ACTIONS(97),
    [anon_sym_6_GT_GT] = ACTIONS(95),
    [anon_sym_STAR_GT] = ACTIONS(97),
    [anon_sym_STAR_GT_GT] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(95),
    [anon_sym_2_GT_AMP1] = ACTIONS(95),
    [anon_sym_3_GT_AMP1] = ACTIONS(95),
    [anon_sym_4_GT_AMP1] = ACTIONS(95),
    [anon_sym_5_GT_AMP1] = ACTIONS(95),
    [anon_sym_6_GT_AMP1] = ACTIONS(95),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(95),
    [anon_sym_1_GT_AMP2] = ACTIONS(95),
    [anon_sym_3_GT_AMP2] = ACTIONS(95),
    [anon_sym_4_GT_AMP2] = ACTIONS(95),
    [anon_sym_5_GT_AMP2] = ACTIONS(95),
    [anon_sym_6_GT_AMP2] = ACTIONS(95),
    [anon_sym_DASHas] = ACTIONS(95),
    [anon_sym_DASHccontains] = ACTIONS(95),
    [anon_sym_DASHceq] = ACTIONS(95),
    [anon_sym_DASHcge] = ACTIONS(95),
    [anon_sym_DASHcgt] = ACTIONS(95),
    [anon_sym_DASHcle] = ACTIONS(95),
    [anon_sym_DASHclike] = ACTIONS(95),
    [anon_sym_DASHclt] = ACTIONS(95),
    [anon_sym_DASHcmatch] = ACTIONS(95),
    [anon_sym_DASHcne] = ACTIONS(95),
    [anon_sym_DASHcnotcontains] = ACTIONS(95),
    [anon_sym_DASHcnotlike] = ACTIONS(95),
    [anon_sym_DASHcnotmatch] = ACTIONS(95),
    [anon_sym_DASHcontains] = ACTIONS(95),
    [anon_sym_DASHcreplace] = ACTIONS(95),
    [anon_sym_DASHcsplit] = ACTIONS(95),
    [anon_sym_DASHeq] = ACTIONS(95),
    [anon_sym_DASHge] = ACTIONS(95),
    [anon_sym_DASHgt] = ACTIONS(95),
    [anon_sym_DASHicontains] = ACTIONS(95),
    [anon_sym_DASHieq] = ACTIONS(95),
    [anon_sym_DASHige] = ACTIONS(95),
    [anon_sym_DASHigt] = ACTIONS(95),
    [anon_sym_DASHile] = ACTIONS(95),
    [anon_sym_DASHilike] = ACTIONS(95),
    [anon_sym_DASHilt] = ACTIONS(95),
    [anon_sym_DASHimatch] = ACTIONS(95),
    [anon_sym_DASHin] = ACTIONS(97),
    [anon_sym_DASHine] = ACTIONS(95),
    [anon_sym_DASHinotcontains] = ACTIONS(95),
    [anon_sym_DASHinotlike] = ACTIONS(95),
    [anon_sym_DASHinotmatch] = ACTIONS(95),
    [anon_sym_DASHireplace] = ACTIONS(95),
    [anon_sym_DASHis] = ACTIONS(97),
    [anon_sym_DASHisnot] = ACTIONS(95),
    [anon_sym_DASHisplit] = ACTIONS(95),
    [anon_sym_DASHjoin] = ACTIONS(157),
    [anon_sym_DASHle] = ACTIONS(95),
    [anon_sym_DASHlike] = ACTIONS(95),
    [anon_sym_DASHlt] = ACTIONS(95),
    [anon_sym_DASHmatch] = ACTIONS(95),
    [anon_sym_DASHne] = ACTIONS(95),
    [anon_sym_DASHnotcontains] = ACTIONS(95),
    [anon_sym_DASHnotin] = ACTIONS(95),
    [anon_sym_DASHnotlike] = ACTIONS(95),
    [anon_sym_DASHnotmatch] = ACTIONS(95),
    [anon_sym_DASHreplace] = ACTIONS(95),
    [anon_sym_DASHshl] = ACTIONS(95),
    [anon_sym_DASHshr] = ACTIONS(95),
    [anon_sym_DASHsplit] = ACTIONS(157),
    [sym_format_operator] = ACTIONS(95),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(135),
    [anon_sym_DOLLAR_CARET] = ACTIONS(135),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(135),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(135),
    [sym_braced_variable] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(95),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_PERCENT] = ACTIONS(97),
    [anon_sym_DASHand] = ACTIONS(95),
    [anon_sym_DASHor] = ACTIONS(95),
    [anon_sym_DASHxor] = ACTIONS(95),
    [anon_sym_DASHband] = ACTIONS(95),
    [anon_sym_DASHbor] = ACTIONS(95),
    [anon_sym_DASHbxor] = ACTIONS(95),
    [anon_sym_PLUS] = ACTIONS(159),
    [anon_sym_DASH] = ACTIONS(159),
    [anon_sym_SLASH] = ACTIONS(97),
    [anon_sym_BSLASH] = ACTIONS(95),
    [anon_sym_STAR] = ACTIONS(97),
    [anon_sym_DOT_DOT] = ACTIONS(95),
    [anon_sym_DASHnot] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(159),
    [anon_sym_DASHbnot] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(161),
    [anon_sym_DASH_DASH] = ACTIONS(163),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_AT_LBRACE] = ACTIONS(153),
    [anon_sym_DOT2] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(95),
    [anon_sym_DOTforeach] = ACTIONS(95),
  },
  [5] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_unary_expression] = STATE(165),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(83),
    [sym_real_literal] = ACTIONS(85),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(87),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(89),
    [sym_verbatim_string_characters] = ACTIONS(91),
    [sym_verbatim_here_string_characters] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(93),
    [anon_sym_EQ] = ACTIONS(95),
    [anon_sym_BANG_EQ] = ACTIONS(95),
    [anon_sym_PLUS_EQ] = ACTIONS(95),
    [anon_sym_STAR_EQ] = ACTIONS(95),
    [anon_sym_SLASH_EQ] = ACTIONS(95),
    [anon_sym_PERCENT_EQ] = ACTIONS(95),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_GT] = ACTIONS(95),
    [anon_sym_2_GT] = ACTIONS(97),
    [anon_sym_2_GT_GT] = ACTIONS(95),
    [anon_sym_3_GT] = ACTIONS(97),
    [anon_sym_3_GT_GT] = ACTIONS(95),
    [anon_sym_4_GT] = ACTIONS(97),
    [anon_sym_4_GT_GT] = ACTIONS(95),
    [anon_sym_5_GT] = ACTIONS(97),
    [anon_sym_5_GT_GT] = ACTIONS(95),
    [anon_sym_6_GT] = ACTIONS(97),
    [anon_sym_6_GT_GT] = ACTIONS(95),
    [anon_sym_STAR_GT] = ACTIONS(97),
    [anon_sym_STAR_GT_GT] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(95),
    [anon_sym_2_GT_AMP1] = ACTIONS(95),
    [anon_sym_3_GT_AMP1] = ACTIONS(95),
    [anon_sym_4_GT_AMP1] = ACTIONS(95),
    [anon_sym_5_GT_AMP1] = ACTIONS(95),
    [anon_sym_6_GT_AMP1] = ACTIONS(95),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(95),
    [anon_sym_1_GT_AMP2] = ACTIONS(95),
    [anon_sym_3_GT_AMP2] = ACTIONS(95),
    [anon_sym_4_GT_AMP2] = ACTIONS(95),
    [anon_sym_5_GT_AMP2] = ACTIONS(95),
    [anon_sym_6_GT_AMP2] = ACTIONS(95),
    [anon_sym_DASHas] = ACTIONS(95),
    [anon_sym_DASHccontains] = ACTIONS(95),
    [anon_sym_DASHceq] = ACTIONS(95),
    [anon_sym_DASHcge] = ACTIONS(95),
    [anon_sym_DASHcgt] = ACTIONS(95),
    [anon_sym_DASHcle] = ACTIONS(95),
    [anon_sym_DASHclike] = ACTIONS(95),
    [anon_sym_DASHclt] = ACTIONS(95),
    [anon_sym_DASHcmatch] = ACTIONS(95),
    [anon_sym_DASHcne] = ACTIONS(95),
    [anon_sym_DASHcnotcontains] = ACTIONS(95),
    [anon_sym_DASHcnotlike] = ACTIONS(95),
    [anon_sym_DASHcnotmatch] = ACTIONS(95),
    [anon_sym_DASHcontains] = ACTIONS(95),
    [anon_sym_DASHcreplace] = ACTIONS(95),
    [anon_sym_DASHcsplit] = ACTIONS(95),
    [anon_sym_DASHeq] = ACTIONS(95),
    [anon_sym_DASHge] = ACTIONS(95),
    [anon_sym_DASHgt] = ACTIONS(95),
    [anon_sym_DASHicontains] = ACTIONS(95),
    [anon_sym_DASHieq] = ACTIONS(95),
    [anon_sym_DASHige] = ACTIONS(95),
    [anon_sym_DASHigt] = ACTIONS(95),
    [anon_sym_DASHile] = ACTIONS(95),
    [anon_sym_DASHilike] = ACTIONS(95),
    [anon_sym_DASHilt] = ACTIONS(95),
    [anon_sym_DASHimatch] = ACTIONS(95),
    [anon_sym_DASHin] = ACTIONS(97),
    [anon_sym_DASHine] = ACTIONS(95),
    [anon_sym_DASHinotcontains] = ACTIONS(95),
    [anon_sym_DASHinotlike] = ACTIONS(95),
    [anon_sym_DASHinotmatch] = ACTIONS(95),
    [anon_sym_DASHireplace] = ACTIONS(95),
    [anon_sym_DASHis] = ACTIONS(97),
    [anon_sym_DASHisnot] = ACTIONS(95),
    [anon_sym_DASHisplit] = ACTIONS(95),
    [anon_sym_DASHjoin] = ACTIONS(99),
    [anon_sym_DASHle] = ACTIONS(95),
    [anon_sym_DASHlike] = ACTIONS(95),
    [anon_sym_DASHlt] = ACTIONS(95),
    [anon_sym_DASHmatch] = ACTIONS(95),
    [anon_sym_DASHne] = ACTIONS(95),
    [anon_sym_DASHnotcontains] = ACTIONS(95),
    [anon_sym_DASHnotin] = ACTIONS(95),
    [anon_sym_DASHnotlike] = ACTIONS(95),
    [anon_sym_DASHnotmatch] = ACTIONS(95),
    [anon_sym_DASHreplace] = ACTIONS(95),
    [anon_sym_DASHshl] = ACTIONS(95),
    [anon_sym_DASHshr] = ACTIONS(95),
    [anon_sym_DASHsplit] = ACTIONS(99),
    [sym_format_operator] = ACTIONS(95),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(101),
    [anon_sym_DOLLAR_CARET] = ACTIONS(101),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(101),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(101),
    [sym_braced_variable] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_COMMA] = ACTIONS(99),
    [anon_sym_LBRACE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_PERCENT] = ACTIONS(97),
    [anon_sym_DASHand] = ACTIONS(95),
    [anon_sym_DASHor] = ACTIONS(95),
    [anon_sym_DASHxor] = ACTIONS(95),
    [anon_sym_DASHband] = ACTIONS(95),
    [anon_sym_DASHbor] = ACTIONS(95),
    [anon_sym_DASHbxor] = ACTIONS(95),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_SLASH] = ACTIONS(97),
    [anon_sym_BSLASH] = ACTIONS(95),
    [anon_sym_STAR] = ACTIONS(97),
    [anon_sym_DOT_DOT] = ACTIONS(95),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(113),
    [anon_sym_AT_LPAREN] = ACTIONS(115),
    [anon_sym_AT_LBRACE] = ACTIONS(117),
    [anon_sym_DOT2] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(95),
    [anon_sym_DOTforeach] = ACTIONS(95),
    [sym__statement_terminator] = ACTIONS(95),
  },
  [6] = {
    [sym__literal] = STATE(145),
    [sym_integer_literal] = STATE(145),
    [sym_string_literal] = STATE(145),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(145),
    [sym_unary_expression] = STATE(147),
    [sym_expression_with_unary_operator] = STATE(137),
    [sym_pre_increment_expression] = STATE(138),
    [sym_pre_decrement_expression] = STATE(138),
    [sym_cast_expression] = STATE(138),
    [sym__primary_expression] = STATE(145),
    [sym__value] = STATE(145),
    [sym_parenthesized_expression] = STATE(145),
    [sym_sub_expression] = STATE(145),
    [sym_array_expression] = STATE(145),
    [sym_script_block_expression] = STATE(145),
    [sym_hash_literal_expression] = STATE(145),
    [sym_post_increment_expression] = STATE(145),
    [sym_post_decrement_expression] = STATE(145),
    [sym_member_access] = STATE(145),
    [sym_element_access] = STATE(145),
    [sym_invokation_expression] = STATE(145),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(6),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(83),
    [sym_real_literal] = ACTIONS(165),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(87),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(89),
    [sym_verbatim_string_characters] = ACTIONS(91),
    [sym_verbatim_here_string_characters] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(93),
    [anon_sym_EQ] = ACTIONS(95),
    [anon_sym_BANG_EQ] = ACTIONS(95),
    [anon_sym_PLUS_EQ] = ACTIONS(95),
    [anon_sym_STAR_EQ] = ACTIONS(95),
    [anon_sym_SLASH_EQ] = ACTIONS(95),
    [anon_sym_PERCENT_EQ] = ACTIONS(95),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_GT] = ACTIONS(95),
    [anon_sym_2_GT] = ACTIONS(97),
    [anon_sym_2_GT_GT] = ACTIONS(95),
    [anon_sym_3_GT] = ACTIONS(97),
    [anon_sym_3_GT_GT] = ACTIONS(95),
    [anon_sym_4_GT] = ACTIONS(97),
    [anon_sym_4_GT_GT] = ACTIONS(95),
    [anon_sym_5_GT] = ACTIONS(97),
    [anon_sym_5_GT_GT] = ACTIONS(95),
    [anon_sym_6_GT] = ACTIONS(97),
    [anon_sym_6_GT_GT] = ACTIONS(95),
    [anon_sym_STAR_GT] = ACTIONS(97),
    [anon_sym_STAR_GT_GT] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(95),
    [anon_sym_2_GT_AMP1] = ACTIONS(95),
    [anon_sym_3_GT_AMP1] = ACTIONS(95),
    [anon_sym_4_GT_AMP1] = ACTIONS(95),
    [anon_sym_5_GT_AMP1] = ACTIONS(95),
    [anon_sym_6_GT_AMP1] = ACTIONS(95),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(95),
    [anon_sym_1_GT_AMP2] = ACTIONS(95),
    [anon_sym_3_GT_AMP2] = ACTIONS(95),
    [anon_sym_4_GT_AMP2] = ACTIONS(95),
    [anon_sym_5_GT_AMP2] = ACTIONS(95),
    [anon_sym_6_GT_AMP2] = ACTIONS(95),
    [anon_sym_DASHas] = ACTIONS(95),
    [anon_sym_DASHccontains] = ACTIONS(95),
    [anon_sym_DASHceq] = ACTIONS(95),
    [anon_sym_DASHcge] = ACTIONS(95),
    [anon_sym_DASHcgt] = ACTIONS(95),
    [anon_sym_DASHcle] = ACTIONS(95),
    [anon_sym_DASHclike] = ACTIONS(95),
    [anon_sym_DASHclt] = ACTIONS(95),
    [anon_sym_DASHcmatch] = ACTIONS(95),
    [anon_sym_DASHcne] = ACTIONS(95),
    [anon_sym_DASHcnotcontains] = ACTIONS(95),
    [anon_sym_DASHcnotlike] = ACTIONS(95),
    [anon_sym_DASHcnotmatch] = ACTIONS(95),
    [anon_sym_DASHcontains] = ACTIONS(95),
    [anon_sym_DASHcreplace] = ACTIONS(95),
    [anon_sym_DASHcsplit] = ACTIONS(95),
    [anon_sym_DASHeq] = ACTIONS(95),
    [anon_sym_DASHge] = ACTIONS(95),
    [anon_sym_DASHgt] = ACTIONS(95),
    [anon_sym_DASHicontains] = ACTIONS(95),
    [anon_sym_DASHieq] = ACTIONS(95),
    [anon_sym_DASHige] = ACTIONS(95),
    [anon_sym_DASHigt] = ACTIONS(95),
    [anon_sym_DASHile] = ACTIONS(95),
    [anon_sym_DASHilike] = ACTIONS(95),
    [anon_sym_DASHilt] = ACTIONS(95),
    [anon_sym_DASHimatch] = ACTIONS(95),
    [anon_sym_DASHin] = ACTIONS(97),
    [anon_sym_DASHine] = ACTIONS(95),
    [anon_sym_DASHinotcontains] = ACTIONS(95),
    [anon_sym_DASHinotlike] = ACTIONS(95),
    [anon_sym_DASHinotmatch] = ACTIONS(95),
    [anon_sym_DASHireplace] = ACTIONS(95),
    [anon_sym_DASHis] = ACTIONS(97),
    [anon_sym_DASHisnot] = ACTIONS(95),
    [anon_sym_DASHisplit] = ACTIONS(95),
    [anon_sym_DASHjoin] = ACTIONS(167),
    [anon_sym_DASHle] = ACTIONS(95),
    [anon_sym_DASHlike] = ACTIONS(95),
    [anon_sym_DASHlt] = ACTIONS(95),
    [anon_sym_DASHmatch] = ACTIONS(95),
    [anon_sym_DASHne] = ACTIONS(95),
    [anon_sym_DASHnotcontains] = ACTIONS(95),
    [anon_sym_DASHnotin] = ACTIONS(95),
    [anon_sym_DASHnotlike] = ACTIONS(95),
    [anon_sym_DASHnotmatch] = ACTIONS(95),
    [anon_sym_DASHreplace] = ACTIONS(95),
    [anon_sym_DASHshl] = ACTIONS(95),
    [anon_sym_DASHshr] = ACTIONS(95),
    [anon_sym_DASHsplit] = ACTIONS(167),
    [sym_format_operator] = ACTIONS(95),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(101),
    [anon_sym_DOLLAR_CARET] = ACTIONS(101),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(101),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(101),
    [sym_braced_variable] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_COMMA] = ACTIONS(167),
    [anon_sym_LBRACE] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_PERCENT] = ACTIONS(97),
    [anon_sym_DASHand] = ACTIONS(95),
    [anon_sym_DASHor] = ACTIONS(95),
    [anon_sym_DASHxor] = ACTIONS(95),
    [anon_sym_DASHband] = ACTIONS(95),
    [anon_sym_DASHbor] = ACTIONS(95),
    [anon_sym_DASHbxor] = ACTIONS(95),
    [anon_sym_PLUS] = ACTIONS(169),
    [anon_sym_DASH] = ACTIONS(169),
    [anon_sym_SLASH] = ACTIONS(97),
    [anon_sym_BSLASH] = ACTIONS(95),
    [anon_sym_STAR] = ACTIONS(97),
    [anon_sym_DOT_DOT] = ACTIONS(95),
    [anon_sym_DASHnot] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(169),
    [anon_sym_DASHbnot] = ACTIONS(167),
    [anon_sym_PLUS_PLUS] = ACTIONS(171),
    [anon_sym_DASH_DASH] = ACTIONS(173),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(113),
    [anon_sym_AT_LPAREN] = ACTIONS(115),
    [anon_sym_AT_LBRACE] = ACTIONS(117),
    [anon_sym_DOT2] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(95),
    [anon_sym_DOTforeach] = ACTIONS(95),
    [sym__statement_terminator] = ACTIONS(95),
  },
  [7] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1751),
    [sym_param_block] = STATE(1839),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2052),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
    [sym__statement_terminator] = ACTIONS(213),
  },
  [8] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1947),
    [sym_param_block] = STATE(1839),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2052),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(215),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [9] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1834),
    [sym_param_block] = STATE(1839),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2052),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [10] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(2053),
    [sym_param_block] = STATE(1839),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2052),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
    [sym__statement_terminator] = ACTIONS(213),
  },
  [11] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(2038),
    [sym_param_block] = STATE(1839),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2052),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(219),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [12] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1714),
    [sym_param_block] = STATE(1839),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2052),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
    [sym__statement_terminator] = ACTIONS(213),
  },
  [13] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1761),
    [sym_param_block] = STATE(1839),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2052),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
    [sym__statement_terminator] = ACTIONS(213),
  },
  [14] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1957),
    [sym_param_block] = STATE(1839),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2052),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(221),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [15] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1733),
    [sym_param_block] = STATE(1839),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2052),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [16] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1833),
    [sym_param_block] = STATE(1839),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2052),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [17] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1840),
    [sym_param_block] = STATE(1839),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2052),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
    [sym__statement_terminator] = ACTIONS(213),
  },
  [18] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1725),
    [sym_param_block] = STATE(1839),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2052),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
    [sym__statement_terminator] = ACTIONS(213),
  },
  [19] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1849),
    [sym_param_block] = STATE(1839),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2052),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(227),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [20] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1835),
    [sym_param_block] = STATE(1839),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2052),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [21] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1771),
    [sym_param_block] = STATE(1839),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2052),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [22] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1811),
    [sym_param_block] = STATE(1839),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2052),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
    [sym__statement_terminator] = ACTIONS(213),
  },
  [23] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1871),
    [sym_param_block] = STATE(1839),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2052),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(233),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [24] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1804),
    [sym_param_block] = STATE(1839),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2052),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
    [sym__statement_terminator] = ACTIONS(213),
  },
  [25] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1773),
    [sym_param_block] = STATE(1839),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2052),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
    [sym__statement_terminator] = ACTIONS(213),
  },
  [26] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1736),
    [sym_param_block] = STATE(1839),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2052),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [27] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1795),
    [sym_param_block] = STATE(1839),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2052),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
    [sym__statement_terminator] = ACTIONS(213),
  },
  [28] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1944),
    [sym_param_block] = STATE(1839),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2052),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(237),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [29] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1703),
    [sym_param_block] = STATE(1839),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2052),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(239),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [30] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1802),
    [sym_param_block] = STATE(24),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2009),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [31] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1788),
    [sym_param_block] = STATE(27),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2009),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [32] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1708),
    [sym_param_block] = STATE(12),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2009),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [33] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1766),
    [sym_param_block] = STATE(25),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2009),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [34] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1809),
    [sym_param_block] = STATE(22),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2009),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [35] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1744),
    [sym_param_block] = STATE(7),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2009),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [36] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1719),
    [sym_param_block] = STATE(18),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2009),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [37] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1988),
    [sym_param_block] = STATE(17),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2009),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [38] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(2110),
    [sym_param_block] = STATE(10),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2009),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [39] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block] = STATE(1789),
    [sym_param_block] = STATE(13),
    [sym_script_block_body] = STATE(1987),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(2),
    [sym_attribute_list] = STATE(2009),
    [sym_attribute] = STATE(1250),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1250),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_param] = ACTIONS(241),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [40] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block_body] = STATE(1953),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_script_block_repeat1] = STATE(326),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [41] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_script_block_body] = STATE(1842),
    [sym_named_block_list] = STATE(1986),
    [sym_named_block] = STATE(1291),
    [sym_block_name] = STATE(1560),
    [sym_statement_list] = STATE(1982),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_script_block_repeat1] = STATE(40),
    [aux_sym_named_block_list_repeat1] = STATE(1291),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_dynamicparam] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(179),
    [anon_sym_process] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(249),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [42] = {
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(251),
    [sym_hexadecimal_integer_literal] = ACTIONS(253),
    [sym_real_literal] = ACTIONS(253),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(253),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(253),
    [sym_verbatim_string_characters] = ACTIONS(253),
    [sym_verbatim_here_string_characters] = ACTIONS(253),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_EQ] = ACTIONS(253),
    [anon_sym_BANG_EQ] = ACTIONS(253),
    [anon_sym_PLUS_EQ] = ACTIONS(253),
    [anon_sym_STAR_EQ] = ACTIONS(253),
    [anon_sym_SLASH_EQ] = ACTIONS(253),
    [anon_sym_PERCENT_EQ] = ACTIONS(253),
    [anon_sym_GT] = ACTIONS(251),
    [anon_sym_GT_GT] = ACTIONS(253),
    [anon_sym_2_GT] = ACTIONS(251),
    [anon_sym_2_GT_GT] = ACTIONS(253),
    [anon_sym_3_GT] = ACTIONS(251),
    [anon_sym_3_GT_GT] = ACTIONS(253),
    [anon_sym_4_GT] = ACTIONS(251),
    [anon_sym_4_GT_GT] = ACTIONS(253),
    [anon_sym_5_GT] = ACTIONS(251),
    [anon_sym_5_GT_GT] = ACTIONS(253),
    [anon_sym_6_GT] = ACTIONS(251),
    [anon_sym_6_GT_GT] = ACTIONS(253),
    [anon_sym_STAR_GT] = ACTIONS(251),
    [anon_sym_STAR_GT_GT] = ACTIONS(253),
    [anon_sym_LT] = ACTIONS(251),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(253),
    [anon_sym_2_GT_AMP1] = ACTIONS(253),
    [anon_sym_3_GT_AMP1] = ACTIONS(253),
    [anon_sym_4_GT_AMP1] = ACTIONS(253),
    [anon_sym_5_GT_AMP1] = ACTIONS(253),
    [anon_sym_6_GT_AMP1] = ACTIONS(253),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(253),
    [anon_sym_1_GT_AMP2] = ACTIONS(253),
    [anon_sym_3_GT_AMP2] = ACTIONS(253),
    [anon_sym_4_GT_AMP2] = ACTIONS(253),
    [anon_sym_5_GT_AMP2] = ACTIONS(253),
    [anon_sym_6_GT_AMP2] = ACTIONS(253),
    [anon_sym_DASHas] = ACTIONS(253),
    [anon_sym_DASHccontains] = ACTIONS(253),
    [anon_sym_DASHceq] = ACTIONS(253),
    [anon_sym_DASHcge] = ACTIONS(253),
    [anon_sym_DASHcgt] = ACTIONS(253),
    [anon_sym_DASHcle] = ACTIONS(253),
    [anon_sym_DASHclike] = ACTIONS(253),
    [anon_sym_DASHclt] = ACTIONS(253),
    [anon_sym_DASHcmatch] = ACTIONS(253),
    [anon_sym_DASHcne] = ACTIONS(253),
    [anon_sym_DASHcnotcontains] = ACTIONS(253),
    [anon_sym_DASHcnotlike] = ACTIONS(253),
    [anon_sym_DASHcnotmatch] = ACTIONS(253),
    [anon_sym_DASHcontains] = ACTIONS(253),
    [anon_sym_DASHcreplace] = ACTIONS(253),
    [anon_sym_DASHcsplit] = ACTIONS(253),
    [anon_sym_DASHeq] = ACTIONS(253),
    [anon_sym_DASHge] = ACTIONS(253),
    [anon_sym_DASHgt] = ACTIONS(253),
    [anon_sym_DASHicontains] = ACTIONS(253),
    [anon_sym_DASHieq] = ACTIONS(253),
    [anon_sym_DASHige] = ACTIONS(253),
    [anon_sym_DASHigt] = ACTIONS(253),
    [anon_sym_DASHile] = ACTIONS(253),
    [anon_sym_DASHilike] = ACTIONS(253),
    [anon_sym_DASHilt] = ACTIONS(253),
    [anon_sym_DASHimatch] = ACTIONS(253),
    [anon_sym_DASHin] = ACTIONS(251),
    [anon_sym_DASHine] = ACTIONS(253),
    [anon_sym_DASHinotcontains] = ACTIONS(253),
    [anon_sym_DASHinotlike] = ACTIONS(253),
    [anon_sym_DASHinotmatch] = ACTIONS(253),
    [anon_sym_DASHireplace] = ACTIONS(253),
    [anon_sym_DASHis] = ACTIONS(251),
    [anon_sym_DASHisnot] = ACTIONS(253),
    [anon_sym_DASHisplit] = ACTIONS(253),
    [anon_sym_DASHjoin] = ACTIONS(253),
    [anon_sym_DASHle] = ACTIONS(253),
    [anon_sym_DASHlike] = ACTIONS(253),
    [anon_sym_DASHlt] = ACTIONS(253),
    [anon_sym_DASHmatch] = ACTIONS(253),
    [anon_sym_DASHne] = ACTIONS(253),
    [anon_sym_DASHnotcontains] = ACTIONS(253),
    [anon_sym_DASHnotin] = ACTIONS(253),
    [anon_sym_DASHnotlike] = ACTIONS(253),
    [anon_sym_DASHnotmatch] = ACTIONS(253),
    [anon_sym_DASHreplace] = ACTIONS(253),
    [anon_sym_DASHshl] = ACTIONS(253),
    [anon_sym_DASHshr] = ACTIONS(253),
    [anon_sym_DASHsplit] = ACTIONS(253),
    [sym_format_operator] = ACTIONS(253),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(253),
    [anon_sym_DOLLAR_CARET] = ACTIONS(253),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(253),
    [anon_sym_DOLLAR_] = ACTIONS(251),
    [aux_sym_variable_token1] = ACTIONS(251),
    [aux_sym_variable_token2] = ACTIONS(253),
    [sym_braced_variable] = ACTIONS(253),
    [anon_sym_param] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(253),
    [anon_sym_COMMA] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(253),
    [anon_sym_PIPE] = ACTIONS(253),
    [anon_sym_PERCENT] = ACTIONS(251),
    [anon_sym_DASHand] = ACTIONS(253),
    [anon_sym_DASHor] = ACTIONS(253),
    [anon_sym_DASHxor] = ACTIONS(253),
    [anon_sym_DASHband] = ACTIONS(253),
    [anon_sym_DASHbor] = ACTIONS(253),
    [anon_sym_DASHbxor] = ACTIONS(253),
    [anon_sym_PLUS] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(251),
    [anon_sym_BSLASH] = ACTIONS(253),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_DOT_DOT] = ACTIONS(253),
    [anon_sym_DASHnot] = ACTIONS(251),
    [anon_sym_BANG] = ACTIONS(251),
    [anon_sym_DASHbnot] = ACTIONS(253),
    [anon_sym_PLUS_PLUS] = ACTIONS(253),
    [anon_sym_DASH_DASH] = ACTIONS(253),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_AT_LPAREN] = ACTIONS(253),
    [anon_sym_AT_LBRACE] = ACTIONS(253),
    [anon_sym_DOT2] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(253),
    [anon_sym_DOTforeach] = ACTIONS(253),
  },
  [43] = {
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(251),
    [sym_hexadecimal_integer_literal] = ACTIONS(253),
    [sym_real_literal] = ACTIONS(253),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(253),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(253),
    [sym_verbatim_string_characters] = ACTIONS(253),
    [sym_verbatim_here_string_characters] = ACTIONS(253),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_EQ] = ACTIONS(253),
    [anon_sym_BANG_EQ] = ACTIONS(253),
    [anon_sym_PLUS_EQ] = ACTIONS(253),
    [anon_sym_STAR_EQ] = ACTIONS(253),
    [anon_sym_SLASH_EQ] = ACTIONS(253),
    [anon_sym_PERCENT_EQ] = ACTIONS(253),
    [anon_sym_GT] = ACTIONS(251),
    [anon_sym_GT_GT] = ACTIONS(253),
    [anon_sym_2_GT] = ACTIONS(251),
    [anon_sym_2_GT_GT] = ACTIONS(253),
    [anon_sym_3_GT] = ACTIONS(251),
    [anon_sym_3_GT_GT] = ACTIONS(253),
    [anon_sym_4_GT] = ACTIONS(251),
    [anon_sym_4_GT_GT] = ACTIONS(253),
    [anon_sym_5_GT] = ACTIONS(251),
    [anon_sym_5_GT_GT] = ACTIONS(253),
    [anon_sym_6_GT] = ACTIONS(251),
    [anon_sym_6_GT_GT] = ACTIONS(253),
    [anon_sym_STAR_GT] = ACTIONS(251),
    [anon_sym_STAR_GT_GT] = ACTIONS(253),
    [anon_sym_LT] = ACTIONS(251),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(253),
    [anon_sym_2_GT_AMP1] = ACTIONS(253),
    [anon_sym_3_GT_AMP1] = ACTIONS(253),
    [anon_sym_4_GT_AMP1] = ACTIONS(253),
    [anon_sym_5_GT_AMP1] = ACTIONS(253),
    [anon_sym_6_GT_AMP1] = ACTIONS(253),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(253),
    [anon_sym_1_GT_AMP2] = ACTIONS(253),
    [anon_sym_3_GT_AMP2] = ACTIONS(253),
    [anon_sym_4_GT_AMP2] = ACTIONS(253),
    [anon_sym_5_GT_AMP2] = ACTIONS(253),
    [anon_sym_6_GT_AMP2] = ACTIONS(253),
    [anon_sym_DASHas] = ACTIONS(253),
    [anon_sym_DASHccontains] = ACTIONS(253),
    [anon_sym_DASHceq] = ACTIONS(253),
    [anon_sym_DASHcge] = ACTIONS(253),
    [anon_sym_DASHcgt] = ACTIONS(253),
    [anon_sym_DASHcle] = ACTIONS(253),
    [anon_sym_DASHclike] = ACTIONS(253),
    [anon_sym_DASHclt] = ACTIONS(253),
    [anon_sym_DASHcmatch] = ACTIONS(253),
    [anon_sym_DASHcne] = ACTIONS(253),
    [anon_sym_DASHcnotcontains] = ACTIONS(253),
    [anon_sym_DASHcnotlike] = ACTIONS(253),
    [anon_sym_DASHcnotmatch] = ACTIONS(253),
    [anon_sym_DASHcontains] = ACTIONS(253),
    [anon_sym_DASHcreplace] = ACTIONS(253),
    [anon_sym_DASHcsplit] = ACTIONS(253),
    [anon_sym_DASHeq] = ACTIONS(253),
    [anon_sym_DASHge] = ACTIONS(253),
    [anon_sym_DASHgt] = ACTIONS(253),
    [anon_sym_DASHicontains] = ACTIONS(253),
    [anon_sym_DASHieq] = ACTIONS(253),
    [anon_sym_DASHige] = ACTIONS(253),
    [anon_sym_DASHigt] = ACTIONS(253),
    [anon_sym_DASHile] = ACTIONS(253),
    [anon_sym_DASHilike] = ACTIONS(253),
    [anon_sym_DASHilt] = ACTIONS(253),
    [anon_sym_DASHimatch] = ACTIONS(253),
    [anon_sym_DASHin] = ACTIONS(251),
    [anon_sym_DASHine] = ACTIONS(253),
    [anon_sym_DASHinotcontains] = ACTIONS(253),
    [anon_sym_DASHinotlike] = ACTIONS(253),
    [anon_sym_DASHinotmatch] = ACTIONS(253),
    [anon_sym_DASHireplace] = ACTIONS(253),
    [anon_sym_DASHis] = ACTIONS(251),
    [anon_sym_DASHisnot] = ACTIONS(253),
    [anon_sym_DASHisplit] = ACTIONS(253),
    [anon_sym_DASHjoin] = ACTIONS(253),
    [anon_sym_DASHle] = ACTIONS(253),
    [anon_sym_DASHlike] = ACTIONS(253),
    [anon_sym_DASHlt] = ACTIONS(253),
    [anon_sym_DASHmatch] = ACTIONS(253),
    [anon_sym_DASHne] = ACTIONS(253),
    [anon_sym_DASHnotcontains] = ACTIONS(253),
    [anon_sym_DASHnotin] = ACTIONS(253),
    [anon_sym_DASHnotlike] = ACTIONS(253),
    [anon_sym_DASHnotmatch] = ACTIONS(253),
    [anon_sym_DASHreplace] = ACTIONS(253),
    [anon_sym_DASHshl] = ACTIONS(253),
    [anon_sym_DASHshr] = ACTIONS(253),
    [anon_sym_DASHsplit] = ACTIONS(253),
    [sym_format_operator] = ACTIONS(253),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(253),
    [anon_sym_DOLLAR_CARET] = ACTIONS(253),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(253),
    [anon_sym_DOLLAR_] = ACTIONS(251),
    [aux_sym_variable_token1] = ACTIONS(251),
    [aux_sym_variable_token2] = ACTIONS(253),
    [sym_braced_variable] = ACTIONS(253),
    [anon_sym_param] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_COMMA] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(253),
    [anon_sym_PIPE] = ACTIONS(253),
    [anon_sym_PERCENT] = ACTIONS(251),
    [anon_sym_DASHand] = ACTIONS(253),
    [anon_sym_DASHor] = ACTIONS(253),
    [anon_sym_DASHxor] = ACTIONS(253),
    [anon_sym_DASHband] = ACTIONS(253),
    [anon_sym_DASHbor] = ACTIONS(253),
    [anon_sym_DASHbxor] = ACTIONS(253),
    [anon_sym_PLUS] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(251),
    [anon_sym_BSLASH] = ACTIONS(253),
    [anon_sym_STAR] = ACTIONS(251),
    [anon_sym_DOT_DOT] = ACTIONS(253),
    [anon_sym_DASHnot] = ACTIONS(251),
    [anon_sym_BANG] = ACTIONS(251),
    [anon_sym_DASHbnot] = ACTIONS(253),
    [anon_sym_PLUS_PLUS] = ACTIONS(253),
    [anon_sym_DASH_DASH] = ACTIONS(253),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_AT_LPAREN] = ACTIONS(253),
    [anon_sym_AT_LBRACE] = ACTIONS(253),
    [anon_sym_DOT2] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(253),
    [anon_sym_DOTforeach] = ACTIONS(253),
    [sym__statement_terminator] = ACTIONS(253),
  },
  [44] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_statement_list] = STATE(2100),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [45] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_statement_list] = STATE(1810),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(257),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [46] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_statement_list] = STATE(1922),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(259),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [47] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_statement_list] = STATE(1768),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(261),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [48] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_statement_list] = STATE(1769),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(263),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [49] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_statement_list] = STATE(1774),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [50] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym__statement] = STATE(50),
    [sym_empty_statement] = STATE(50),
    [sym_if_statement] = STATE(50),
    [sym__labeled_statement] = STATE(50),
    [sym_switch_statement] = STATE(50),
    [sym_foreach_statement] = STATE(50),
    [sym_for_statement] = STATE(50),
    [sym_while_statement] = STATE(50),
    [sym_do_statement] = STATE(50),
    [sym_function_statement] = STATE(50),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(50),
    [sym_try_statement] = STATE(50),
    [sym_data_statement] = STATE(50),
    [sym_inlinescript_statement] = STATE(50),
    [sym_parallel_statement] = STATE(50),
    [sym_sequence_statement] = STATE(50),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(50),
    [sym_enum_statement] = STATE(50),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(50),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(267),
    [sym_hexadecimal_integer_literal] = ACTIONS(267),
    [sym_real_literal] = ACTIONS(270),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(273),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(276),
    [sym_verbatim_string_characters] = ACTIONS(279),
    [sym_verbatim_here_string_characters] = ACTIONS(279),
    [anon_sym_DOT] = ACTIONS(282),
    [anon_sym_LBRACK] = ACTIONS(285),
    [anon_sym_DASHjoin] = ACTIONS(288),
    [anon_sym_DASHsplit] = ACTIONS(288),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(291),
    [anon_sym_DOLLAR_CARET] = ACTIONS(291),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(291),
    [anon_sym_DOLLAR_] = ACTIONS(291),
    [aux_sym_variable_token1] = ACTIONS(291),
    [aux_sym_variable_token2] = ACTIONS(291),
    [sym_braced_variable] = ACTIONS(291),
    [anon_sym_SEMI] = ACTIONS(294),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_RPAREN] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(288),
    [anon_sym_LBRACE] = ACTIONS(302),
    [anon_sym_RBRACE] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(308),
    [anon_sym_foreach] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(314),
    [anon_sym_while] = ACTIONS(317),
    [anon_sym_do] = ACTIONS(320),
    [anon_sym_function] = ACTIONS(323),
    [anon_sym_filter] = ACTIONS(323),
    [anon_sym_workflow] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(326),
    [anon_sym_continue] = ACTIONS(326),
    [anon_sym_throw] = ACTIONS(329),
    [anon_sym_return] = ACTIONS(329),
    [anon_sym_exit] = ACTIONS(329),
    [sym_label] = ACTIONS(332),
    [anon_sym_trap] = ACTIONS(335),
    [anon_sym_try] = ACTIONS(338),
    [anon_sym_data] = ACTIONS(341),
    [anon_sym_inlinescript] = ACTIONS(344),
    [anon_sym_parallel] = ACTIONS(347),
    [anon_sym_sequence] = ACTIONS(350),
    [anon_sym_AMP] = ACTIONS(282),
    [aux_sym_command_name_token1] = ACTIONS(353),
    [anon_sym_PERCENT] = ACTIONS(356),
    [anon_sym_foreach_DASHobject] = ACTIONS(356),
    [anon_sym_class] = ACTIONS(359),
    [anon_sym_enum] = ACTIONS(362),
    [anon_sym_PLUS] = ACTIONS(288),
    [anon_sym_DASH] = ACTIONS(288),
    [anon_sym_DASHnot] = ACTIONS(288),
    [anon_sym_BANG] = ACTIONS(288),
    [anon_sym_DASHbnot] = ACTIONS(288),
    [anon_sym_PLUS_PLUS] = ACTIONS(365),
    [anon_sym_DASH_DASH] = ACTIONS(368),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_AT_LPAREN] = ACTIONS(374),
    [anon_sym_AT_LBRACE] = ACTIONS(377),
  },
  [51] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_statement_list] = STATE(1760),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(380),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [52] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_statement_list] = STATE(1728),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(382),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [53] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_statement_list] = STATE(1727),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(384),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [54] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_statement_list] = STATE(1711),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(386),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [55] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_statement_list] = STATE(1756),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(388),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [56] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_statement_list] = STATE(1784),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(390),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [57] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_statement_list] = STATE(1785),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(392),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [58] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym__statement] = STATE(50),
    [sym_empty_statement] = STATE(50),
    [sym_if_statement] = STATE(50),
    [sym__labeled_statement] = STATE(50),
    [sym_switch_statement] = STATE(50),
    [sym_foreach_statement] = STATE(50),
    [sym_for_statement] = STATE(50),
    [sym_while_statement] = STATE(50),
    [sym_do_statement] = STATE(50),
    [sym_function_statement] = STATE(50),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(50),
    [sym_try_statement] = STATE(50),
    [sym_data_statement] = STATE(50),
    [sym_inlinescript_statement] = STATE(50),
    [sym_parallel_statement] = STATE(50),
    [sym_sequence_statement] = STATE(50),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(50),
    [sym_enum_statement] = STATE(50),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(50),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(394),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(394),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [59] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_statement_list] = STATE(1721),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(396),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [60] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_statement_list] = STATE(2049),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(398),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [61] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_statement_list] = STATE(1790),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(400),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [62] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_statement_list] = STATE(2104),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(402),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [63] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_statement_list] = STATE(1746),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(404),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [64] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_statement_list] = STATE(1791),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(406),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [65] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_statement_list] = STATE(1926),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(408),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [66] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_statement_list] = STATE(1722),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(410),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [67] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_statement_list] = STATE(1796),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [68] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_statement_list] = STATE(1726),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(414),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [69] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_statement_list] = STATE(1803),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(416),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [70] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_statement_list] = STATE(1747),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(418),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [71] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_statement_list] = STATE(1752),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [72] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_statement_list] = STATE(1816),
    [sym__statement] = STATE(58),
    [sym_empty_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym__labeled_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_function_statement] = STATE(58),
    [sym_flow_control_statement] = STATE(1739),
    [sym_trap_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_data_statement] = STATE(58),
    [sym_inlinescript_statement] = STATE(58),
    [sym_parallel_statement] = STATE(58),
    [sym_sequence_statement] = STATE(58),
    [sym_pipeline] = STATE(1739),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(58),
    [sym_enum_statement] = STATE(58),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(58),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(422),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_switch] = ACTIONS(183),
    [anon_sym_foreach] = ACTIONS(185),
    [anon_sym_for] = ACTIONS(187),
    [anon_sym_while] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(191),
    [anon_sym_function] = ACTIONS(193),
    [anon_sym_filter] = ACTIONS(193),
    [anon_sym_workflow] = ACTIONS(193),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(195),
    [anon_sym_trap] = ACTIONS(197),
    [anon_sym_try] = ACTIONS(199),
    [anon_sym_data] = ACTIONS(201),
    [anon_sym_inlinescript] = ACTIONS(203),
    [anon_sym_parallel] = ACTIONS(205),
    [anon_sym_sequence] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_enum] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [73] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym__statement] = STATE(74),
    [sym_empty_statement] = STATE(74),
    [sym_if_statement] = STATE(74),
    [sym__labeled_statement] = STATE(74),
    [sym_switch_statement] = STATE(74),
    [sym_foreach_statement] = STATE(74),
    [sym_for_statement] = STATE(74),
    [sym_while_statement] = STATE(74),
    [sym_do_statement] = STATE(74),
    [sym_function_statement] = STATE(74),
    [sym_flow_control_statement] = STATE(2030),
    [sym_trap_statement] = STATE(74),
    [sym_try_statement] = STATE(74),
    [sym_data_statement] = STATE(74),
    [sym_inlinescript_statement] = STATE(74),
    [sym_parallel_statement] = STATE(74),
    [sym_sequence_statement] = STATE(74),
    [sym_pipeline] = STATE(2030),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(74),
    [sym_enum_statement] = STATE(74),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(74),
    [ts_builtin_sym_end] = ACTIONS(424),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_foreach] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_function] = ACTIONS(43),
    [anon_sym_filter] = ACTIONS(43),
    [anon_sym_workflow] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(49),
    [anon_sym_trap] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_data] = ACTIONS(55),
    [anon_sym_inlinescript] = ACTIONS(57),
    [anon_sym_parallel] = ACTIONS(59),
    [anon_sym_sequence] = ACTIONS(61),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [74] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym__statement] = STATE(74),
    [sym_empty_statement] = STATE(74),
    [sym_if_statement] = STATE(74),
    [sym__labeled_statement] = STATE(74),
    [sym_switch_statement] = STATE(74),
    [sym_foreach_statement] = STATE(74),
    [sym_for_statement] = STATE(74),
    [sym_while_statement] = STATE(74),
    [sym_do_statement] = STATE(74),
    [sym_function_statement] = STATE(74),
    [sym_flow_control_statement] = STATE(2030),
    [sym_trap_statement] = STATE(74),
    [sym_try_statement] = STATE(74),
    [sym_data_statement] = STATE(74),
    [sym_inlinescript_statement] = STATE(74),
    [sym_parallel_statement] = STATE(74),
    [sym_sequence_statement] = STATE(74),
    [sym_pipeline] = STATE(2030),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(74),
    [sym_enum_statement] = STATE(74),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(74),
    [ts_builtin_sym_end] = ACTIONS(426),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(267),
    [sym_hexadecimal_integer_literal] = ACTIONS(267),
    [sym_real_literal] = ACTIONS(270),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(273),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(276),
    [sym_verbatim_string_characters] = ACTIONS(279),
    [sym_verbatim_here_string_characters] = ACTIONS(279),
    [anon_sym_DOT] = ACTIONS(282),
    [anon_sym_LBRACK] = ACTIONS(285),
    [anon_sym_DASHjoin] = ACTIONS(288),
    [anon_sym_DASHsplit] = ACTIONS(288),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(291),
    [anon_sym_DOLLAR_CARET] = ACTIONS(291),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(291),
    [anon_sym_DOLLAR_] = ACTIONS(291),
    [aux_sym_variable_token1] = ACTIONS(291),
    [aux_sym_variable_token2] = ACTIONS(291),
    [sym_braced_variable] = ACTIONS(291),
    [anon_sym_SEMI] = ACTIONS(428),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COMMA] = ACTIONS(288),
    [anon_sym_LBRACE] = ACTIONS(302),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_switch] = ACTIONS(434),
    [anon_sym_foreach] = ACTIONS(437),
    [anon_sym_for] = ACTIONS(440),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_do] = ACTIONS(446),
    [anon_sym_function] = ACTIONS(449),
    [anon_sym_filter] = ACTIONS(449),
    [anon_sym_workflow] = ACTIONS(449),
    [anon_sym_break] = ACTIONS(326),
    [anon_sym_continue] = ACTIONS(326),
    [anon_sym_throw] = ACTIONS(329),
    [anon_sym_return] = ACTIONS(329),
    [anon_sym_exit] = ACTIONS(329),
    [sym_label] = ACTIONS(452),
    [anon_sym_trap] = ACTIONS(455),
    [anon_sym_try] = ACTIONS(458),
    [anon_sym_data] = ACTIONS(461),
    [anon_sym_inlinescript] = ACTIONS(464),
    [anon_sym_parallel] = ACTIONS(467),
    [anon_sym_sequence] = ACTIONS(470),
    [anon_sym_AMP] = ACTIONS(282),
    [aux_sym_command_name_token1] = ACTIONS(353),
    [anon_sym_PERCENT] = ACTIONS(356),
    [anon_sym_foreach_DASHobject] = ACTIONS(356),
    [anon_sym_class] = ACTIONS(473),
    [anon_sym_enum] = ACTIONS(476),
    [anon_sym_PLUS] = ACTIONS(288),
    [anon_sym_DASH] = ACTIONS(288),
    [anon_sym_DASHnot] = ACTIONS(288),
    [anon_sym_BANG] = ACTIONS(288),
    [anon_sym_DASHbnot] = ACTIONS(288),
    [anon_sym_PLUS_PLUS] = ACTIONS(365),
    [anon_sym_DASH_DASH] = ACTIONS(368),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_AT_LPAREN] = ACTIONS(374),
    [anon_sym_AT_LBRACE] = ACTIONS(377),
  },
  [75] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_statement_list] = STATE(1910),
    [sym__statement] = STATE(73),
    [sym_empty_statement] = STATE(73),
    [sym_if_statement] = STATE(73),
    [sym__labeled_statement] = STATE(73),
    [sym_switch_statement] = STATE(73),
    [sym_foreach_statement] = STATE(73),
    [sym_for_statement] = STATE(73),
    [sym_while_statement] = STATE(73),
    [sym_do_statement] = STATE(73),
    [sym_function_statement] = STATE(73),
    [sym_flow_control_statement] = STATE(2030),
    [sym_trap_statement] = STATE(73),
    [sym_try_statement] = STATE(73),
    [sym_data_statement] = STATE(73),
    [sym_inlinescript_statement] = STATE(73),
    [sym_parallel_statement] = STATE(73),
    [sym_sequence_statement] = STATE(73),
    [sym_pipeline] = STATE(2030),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(73),
    [sym_enum_statement] = STATE(73),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [aux_sym_statement_list_repeat1] = STATE(73),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_foreach] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_function] = ACTIONS(43),
    [anon_sym_filter] = ACTIONS(43),
    [anon_sym_workflow] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(49),
    [anon_sym_trap] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_data] = ACTIONS(55),
    [anon_sym_inlinescript] = ACTIONS(57),
    [anon_sym_parallel] = ACTIONS(59),
    [anon_sym_sequence] = ACTIONS(61),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [76] = {
    [sym__literal] = STATE(289),
    [sym_integer_literal] = STATE(289),
    [sym_string_literal] = STATE(289),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(289),
    [sym_unary_expression] = STATE(163),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(289),
    [sym__value] = STATE(289),
    [sym_parenthesized_expression] = STATE(289),
    [sym_sub_expression] = STATE(289),
    [sym_array_expression] = STATE(289),
    [sym_script_block_expression] = STATE(289),
    [sym_hash_literal_expression] = STATE(289),
    [sym_post_increment_expression] = STATE(289),
    [sym_post_decrement_expression] = STATE(289),
    [sym_member_access] = STATE(289),
    [sym_element_access] = STATE(289),
    [sym_invokation_expression] = STATE(289),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(76),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(121),
    [sym_real_literal] = ACTIONS(479),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(125),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(127),
    [sym_verbatim_string_characters] = ACTIONS(129),
    [sym_verbatim_here_string_characters] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_DASHas] = ACTIONS(95),
    [anon_sym_DASHccontains] = ACTIONS(95),
    [anon_sym_DASHceq] = ACTIONS(95),
    [anon_sym_DASHcge] = ACTIONS(95),
    [anon_sym_DASHcgt] = ACTIONS(95),
    [anon_sym_DASHcle] = ACTIONS(95),
    [anon_sym_DASHclike] = ACTIONS(95),
    [anon_sym_DASHclt] = ACTIONS(95),
    [anon_sym_DASHcmatch] = ACTIONS(95),
    [anon_sym_DASHcne] = ACTIONS(95),
    [anon_sym_DASHcnotcontains] = ACTIONS(95),
    [anon_sym_DASHcnotlike] = ACTIONS(95),
    [anon_sym_DASHcnotmatch] = ACTIONS(95),
    [anon_sym_DASHcontains] = ACTIONS(95),
    [anon_sym_DASHcreplace] = ACTIONS(95),
    [anon_sym_DASHcsplit] = ACTIONS(95),
    [anon_sym_DASHeq] = ACTIONS(95),
    [anon_sym_DASHge] = ACTIONS(95),
    [anon_sym_DASHgt] = ACTIONS(95),
    [anon_sym_DASHicontains] = ACTIONS(95),
    [anon_sym_DASHieq] = ACTIONS(95),
    [anon_sym_DASHige] = ACTIONS(95),
    [anon_sym_DASHigt] = ACTIONS(95),
    [anon_sym_DASHile] = ACTIONS(95),
    [anon_sym_DASHilike] = ACTIONS(95),
    [anon_sym_DASHilt] = ACTIONS(95),
    [anon_sym_DASHimatch] = ACTIONS(95),
    [anon_sym_DASHin] = ACTIONS(97),
    [anon_sym_DASHine] = ACTIONS(95),
    [anon_sym_DASHinotcontains] = ACTIONS(95),
    [anon_sym_DASHinotlike] = ACTIONS(95),
    [anon_sym_DASHinotmatch] = ACTIONS(95),
    [anon_sym_DASHireplace] = ACTIONS(95),
    [anon_sym_DASHis] = ACTIONS(97),
    [anon_sym_DASHisnot] = ACTIONS(95),
    [anon_sym_DASHisplit] = ACTIONS(95),
    [anon_sym_DASHjoin] = ACTIONS(483),
    [anon_sym_DASHle] = ACTIONS(95),
    [anon_sym_DASHlike] = ACTIONS(95),
    [anon_sym_DASHlt] = ACTIONS(95),
    [anon_sym_DASHmatch] = ACTIONS(95),
    [anon_sym_DASHne] = ACTIONS(95),
    [anon_sym_DASHnotcontains] = ACTIONS(95),
    [anon_sym_DASHnotin] = ACTIONS(95),
    [anon_sym_DASHnotlike] = ACTIONS(95),
    [anon_sym_DASHnotmatch] = ACTIONS(95),
    [anon_sym_DASHreplace] = ACTIONS(95),
    [anon_sym_DASHshl] = ACTIONS(95),
    [anon_sym_DASHshr] = ACTIONS(95),
    [anon_sym_DASHsplit] = ACTIONS(483),
    [sym_format_operator] = ACTIONS(95),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(135),
    [anon_sym_DOLLAR_CARET] = ACTIONS(135),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(135),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(135),
    [sym_braced_variable] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(95),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_PERCENT] = ACTIONS(95),
    [anon_sym_DASHand] = ACTIONS(95),
    [anon_sym_DASHor] = ACTIONS(95),
    [anon_sym_DASHxor] = ACTIONS(95),
    [anon_sym_DASHband] = ACTIONS(95),
    [anon_sym_DASHbor] = ACTIONS(95),
    [anon_sym_DASHbxor] = ACTIONS(95),
    [anon_sym_PLUS] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(485),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(95),
    [anon_sym_STAR] = ACTIONS(95),
    [anon_sym_DOT_DOT] = ACTIONS(95),
    [anon_sym_DASHnot] = ACTIONS(485),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_DASHbnot] = ACTIONS(483),
    [anon_sym_PLUS_PLUS] = ACTIONS(487),
    [anon_sym_DASH_DASH] = ACTIONS(489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_AT_LBRACE] = ACTIONS(153),
    [anon_sym_DOT2] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(95),
    [anon_sym_RBRACK] = ACTIONS(95),
    [anon_sym_DOTforeach] = ACTIONS(95),
  },
  [77] = {
    [sym__literal] = STATE(287),
    [sym_integer_literal] = STATE(287),
    [sym_string_literal] = STATE(287),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(287),
    [sym_unary_expression] = STATE(112),
    [sym_expression_with_unary_operator] = STATE(117),
    [sym_pre_increment_expression] = STATE(118),
    [sym_pre_decrement_expression] = STATE(118),
    [sym_cast_expression] = STATE(118),
    [sym__primary_expression] = STATE(287),
    [sym__value] = STATE(287),
    [sym_parenthesized_expression] = STATE(287),
    [sym_sub_expression] = STATE(287),
    [sym_array_expression] = STATE(287),
    [sym_script_block_expression] = STATE(287),
    [sym_hash_literal_expression] = STATE(287),
    [sym_post_increment_expression] = STATE(287),
    [sym_post_decrement_expression] = STATE(287),
    [sym_member_access] = STATE(287),
    [sym_element_access] = STATE(287),
    [sym_invokation_expression] = STATE(287),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(77),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(121),
    [sym_real_literal] = ACTIONS(491),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(125),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(127),
    [sym_verbatim_string_characters] = ACTIONS(129),
    [sym_verbatim_here_string_characters] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_DASHas] = ACTIONS(95),
    [anon_sym_DASHccontains] = ACTIONS(95),
    [anon_sym_DASHceq] = ACTIONS(95),
    [anon_sym_DASHcge] = ACTIONS(95),
    [anon_sym_DASHcgt] = ACTIONS(95),
    [anon_sym_DASHcle] = ACTIONS(95),
    [anon_sym_DASHclike] = ACTIONS(95),
    [anon_sym_DASHclt] = ACTIONS(95),
    [anon_sym_DASHcmatch] = ACTIONS(95),
    [anon_sym_DASHcne] = ACTIONS(95),
    [anon_sym_DASHcnotcontains] = ACTIONS(95),
    [anon_sym_DASHcnotlike] = ACTIONS(95),
    [anon_sym_DASHcnotmatch] = ACTIONS(95),
    [anon_sym_DASHcontains] = ACTIONS(95),
    [anon_sym_DASHcreplace] = ACTIONS(95),
    [anon_sym_DASHcsplit] = ACTIONS(95),
    [anon_sym_DASHeq] = ACTIONS(95),
    [anon_sym_DASHge] = ACTIONS(95),
    [anon_sym_DASHgt] = ACTIONS(95),
    [anon_sym_DASHicontains] = ACTIONS(95),
    [anon_sym_DASHieq] = ACTIONS(95),
    [anon_sym_DASHige] = ACTIONS(95),
    [anon_sym_DASHigt] = ACTIONS(95),
    [anon_sym_DASHile] = ACTIONS(95),
    [anon_sym_DASHilike] = ACTIONS(95),
    [anon_sym_DASHilt] = ACTIONS(95),
    [anon_sym_DASHimatch] = ACTIONS(95),
    [anon_sym_DASHin] = ACTIONS(97),
    [anon_sym_DASHine] = ACTIONS(95),
    [anon_sym_DASHinotcontains] = ACTIONS(95),
    [anon_sym_DASHinotlike] = ACTIONS(95),
    [anon_sym_DASHinotmatch] = ACTIONS(95),
    [anon_sym_DASHireplace] = ACTIONS(95),
    [anon_sym_DASHis] = ACTIONS(97),
    [anon_sym_DASHisnot] = ACTIONS(95),
    [anon_sym_DASHisplit] = ACTIONS(95),
    [anon_sym_DASHjoin] = ACTIONS(493),
    [anon_sym_DASHle] = ACTIONS(95),
    [anon_sym_DASHlike] = ACTIONS(95),
    [anon_sym_DASHlt] = ACTIONS(95),
    [anon_sym_DASHmatch] = ACTIONS(95),
    [anon_sym_DASHne] = ACTIONS(95),
    [anon_sym_DASHnotcontains] = ACTIONS(95),
    [anon_sym_DASHnotin] = ACTIONS(95),
    [anon_sym_DASHnotlike] = ACTIONS(95),
    [anon_sym_DASHnotmatch] = ACTIONS(95),
    [anon_sym_DASHreplace] = ACTIONS(95),
    [anon_sym_DASHshl] = ACTIONS(95),
    [anon_sym_DASHshr] = ACTIONS(95),
    [anon_sym_DASHsplit] = ACTIONS(493),
    [sym_format_operator] = ACTIONS(95),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(135),
    [anon_sym_DOLLAR_CARET] = ACTIONS(135),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(135),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(135),
    [sym_braced_variable] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(95),
    [anon_sym_COMMA] = ACTIONS(493),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_PERCENT] = ACTIONS(95),
    [anon_sym_DASHand] = ACTIONS(95),
    [anon_sym_DASHor] = ACTIONS(95),
    [anon_sym_DASHxor] = ACTIONS(95),
    [anon_sym_DASHband] = ACTIONS(95),
    [anon_sym_DASHbor] = ACTIONS(95),
    [anon_sym_DASHbxor] = ACTIONS(95),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_DASH] = ACTIONS(495),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(95),
    [anon_sym_STAR] = ACTIONS(95),
    [anon_sym_DOT_DOT] = ACTIONS(95),
    [anon_sym_DASHnot] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_DASHbnot] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(497),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_AT_LBRACE] = ACTIONS(153),
    [anon_sym_DOT2] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(95),
    [anon_sym_RBRACK] = ACTIONS(95),
    [anon_sym_DOTforeach] = ACTIONS(95),
  },
  [78] = {
    [sym__literal] = STATE(288),
    [sym_integer_literal] = STATE(288),
    [sym_string_literal] = STATE(288),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(288),
    [sym_unary_expression] = STATE(147),
    [sym_expression_with_unary_operator] = STATE(137),
    [sym_pre_increment_expression] = STATE(138),
    [sym_pre_decrement_expression] = STATE(138),
    [sym_cast_expression] = STATE(138),
    [sym__primary_expression] = STATE(288),
    [sym__value] = STATE(288),
    [sym_parenthesized_expression] = STATE(288),
    [sym_sub_expression] = STATE(288),
    [sym_array_expression] = STATE(288),
    [sym_script_block_expression] = STATE(288),
    [sym_hash_literal_expression] = STATE(288),
    [sym_post_increment_expression] = STATE(288),
    [sym_post_decrement_expression] = STATE(288),
    [sym_member_access] = STATE(288),
    [sym_element_access] = STATE(288),
    [sym_invokation_expression] = STATE(288),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(78),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(83),
    [sym_real_literal] = ACTIONS(501),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(87),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(89),
    [sym_verbatim_string_characters] = ACTIONS(91),
    [sym_verbatim_here_string_characters] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_DASHas] = ACTIONS(95),
    [anon_sym_DASHccontains] = ACTIONS(95),
    [anon_sym_DASHceq] = ACTIONS(95),
    [anon_sym_DASHcge] = ACTIONS(95),
    [anon_sym_DASHcgt] = ACTIONS(95),
    [anon_sym_DASHcle] = ACTIONS(95),
    [anon_sym_DASHclike] = ACTIONS(95),
    [anon_sym_DASHclt] = ACTIONS(95),
    [anon_sym_DASHcmatch] = ACTIONS(95),
    [anon_sym_DASHcne] = ACTIONS(95),
    [anon_sym_DASHcnotcontains] = ACTIONS(95),
    [anon_sym_DASHcnotlike] = ACTIONS(95),
    [anon_sym_DASHcnotmatch] = ACTIONS(95),
    [anon_sym_DASHcontains] = ACTIONS(95),
    [anon_sym_DASHcreplace] = ACTIONS(95),
    [anon_sym_DASHcsplit] = ACTIONS(95),
    [anon_sym_DASHeq] = ACTIONS(95),
    [anon_sym_DASHge] = ACTIONS(95),
    [anon_sym_DASHgt] = ACTIONS(95),
    [anon_sym_DASHicontains] = ACTIONS(95),
    [anon_sym_DASHieq] = ACTIONS(95),
    [anon_sym_DASHige] = ACTIONS(95),
    [anon_sym_DASHigt] = ACTIONS(95),
    [anon_sym_DASHile] = ACTIONS(95),
    [anon_sym_DASHilike] = ACTIONS(95),
    [anon_sym_DASHilt] = ACTIONS(95),
    [anon_sym_DASHimatch] = ACTIONS(95),
    [anon_sym_DASHin] = ACTIONS(97),
    [anon_sym_DASHine] = ACTIONS(95),
    [anon_sym_DASHinotcontains] = ACTIONS(95),
    [anon_sym_DASHinotlike] = ACTIONS(95),
    [anon_sym_DASHinotmatch] = ACTIONS(95),
    [anon_sym_DASHireplace] = ACTIONS(95),
    [anon_sym_DASHis] = ACTIONS(97),
    [anon_sym_DASHisnot] = ACTIONS(95),
    [anon_sym_DASHisplit] = ACTIONS(95),
    [anon_sym_DASHjoin] = ACTIONS(505),
    [anon_sym_DASHle] = ACTIONS(95),
    [anon_sym_DASHlike] = ACTIONS(95),
    [anon_sym_DASHlt] = ACTIONS(95),
    [anon_sym_DASHmatch] = ACTIONS(95),
    [anon_sym_DASHne] = ACTIONS(95),
    [anon_sym_DASHnotcontains] = ACTIONS(95),
    [anon_sym_DASHnotin] = ACTIONS(95),
    [anon_sym_DASHnotlike] = ACTIONS(95),
    [anon_sym_DASHnotmatch] = ACTIONS(95),
    [anon_sym_DASHreplace] = ACTIONS(95),
    [anon_sym_DASHshl] = ACTIONS(95),
    [anon_sym_DASHshr] = ACTIONS(95),
    [anon_sym_DASHsplit] = ACTIONS(505),
    [sym_format_operator] = ACTIONS(95),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(101),
    [anon_sym_DOLLAR_CARET] = ACTIONS(101),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(101),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(101),
    [sym_braced_variable] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_COMMA] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(107),
    [anon_sym_PERCENT] = ACTIONS(95),
    [anon_sym_DASHand] = ACTIONS(95),
    [anon_sym_DASHor] = ACTIONS(95),
    [anon_sym_DASHxor] = ACTIONS(95),
    [anon_sym_DASHband] = ACTIONS(95),
    [anon_sym_DASHbor] = ACTIONS(95),
    [anon_sym_DASHbxor] = ACTIONS(95),
    [anon_sym_PLUS] = ACTIONS(507),
    [anon_sym_DASH] = ACTIONS(507),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(95),
    [anon_sym_STAR] = ACTIONS(95),
    [anon_sym_DOT_DOT] = ACTIONS(95),
    [anon_sym_DASHnot] = ACTIONS(507),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_DASHbnot] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DASH_DASH] = ACTIONS(511),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(113),
    [anon_sym_AT_LPAREN] = ACTIONS(115),
    [anon_sym_AT_LBRACE] = ACTIONS(117),
    [anon_sym_DOT2] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(95),
    [anon_sym_DOTforeach] = ACTIONS(95),
    [sym__statement_terminator] = ACTIONS(95),
  },
  [79] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym__statement] = STATE(1713),
    [sym_empty_statement] = STATE(1713),
    [sym_if_statement] = STATE(1713),
    [sym__labeled_statement] = STATE(1713),
    [sym_switch_statement] = STATE(1713),
    [sym_foreach_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_do_statement] = STATE(1713),
    [sym_function_statement] = STATE(1713),
    [sym_flow_control_statement] = STATE(1819),
    [sym_trap_statement] = STATE(1713),
    [sym_try_statement] = STATE(1713),
    [sym_data_statement] = STATE(1713),
    [sym_inlinescript_statement] = STATE(1713),
    [sym_parallel_statement] = STATE(1713),
    [sym_sequence_statement] = STATE(1713),
    [sym_pipeline] = STATE(1819),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(1713),
    [sym_enum_statement] = STATE(1713),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(515),
    [anon_sym_switch] = ACTIONS(517),
    [anon_sym_foreach] = ACTIONS(519),
    [anon_sym_for] = ACTIONS(521),
    [anon_sym_while] = ACTIONS(523),
    [anon_sym_do] = ACTIONS(525),
    [anon_sym_function] = ACTIONS(527),
    [anon_sym_filter] = ACTIONS(527),
    [anon_sym_workflow] = ACTIONS(527),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(529),
    [anon_sym_trap] = ACTIONS(531),
    [anon_sym_try] = ACTIONS(533),
    [anon_sym_data] = ACTIONS(535),
    [anon_sym_inlinescript] = ACTIONS(537),
    [anon_sym_parallel] = ACTIONS(539),
    [anon_sym_sequence] = ACTIONS(541),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(543),
    [anon_sym_enum] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [80] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym__statement] = STATE(2043),
    [sym_empty_statement] = STATE(2043),
    [sym_if_statement] = STATE(2043),
    [sym__labeled_statement] = STATE(2043),
    [sym_switch_statement] = STATE(2043),
    [sym_foreach_statement] = STATE(2043),
    [sym_for_statement] = STATE(2043),
    [sym_while_statement] = STATE(2043),
    [sym_do_statement] = STATE(2043),
    [sym_function_statement] = STATE(2043),
    [sym_flow_control_statement] = STATE(1819),
    [sym_trap_statement] = STATE(2043),
    [sym_try_statement] = STATE(2043),
    [sym_data_statement] = STATE(2043),
    [sym_inlinescript_statement] = STATE(2043),
    [sym_parallel_statement] = STATE(2043),
    [sym_sequence_statement] = STATE(2043),
    [sym_pipeline] = STATE(1819),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(2043),
    [sym_enum_statement] = STATE(2043),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(515),
    [anon_sym_switch] = ACTIONS(517),
    [anon_sym_foreach] = ACTIONS(519),
    [anon_sym_for] = ACTIONS(521),
    [anon_sym_while] = ACTIONS(523),
    [anon_sym_do] = ACTIONS(525),
    [anon_sym_function] = ACTIONS(527),
    [anon_sym_filter] = ACTIONS(527),
    [anon_sym_workflow] = ACTIONS(527),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(529),
    [anon_sym_trap] = ACTIONS(531),
    [anon_sym_try] = ACTIONS(533),
    [anon_sym_data] = ACTIONS(535),
    [anon_sym_inlinescript] = ACTIONS(537),
    [anon_sym_parallel] = ACTIONS(539),
    [anon_sym_sequence] = ACTIONS(541),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(543),
    [anon_sym_enum] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [81] = {
    [sym__literal] = STATE(290),
    [sym_integer_literal] = STATE(290),
    [sym_string_literal] = STATE(290),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(290),
    [sym_unary_expression] = STATE(165),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(290),
    [sym__value] = STATE(290),
    [sym_parenthesized_expression] = STATE(290),
    [sym_sub_expression] = STATE(290),
    [sym_array_expression] = STATE(290),
    [sym_script_block_expression] = STATE(290),
    [sym_hash_literal_expression] = STATE(290),
    [sym_post_increment_expression] = STATE(290),
    [sym_post_decrement_expression] = STATE(290),
    [sym_member_access] = STATE(290),
    [sym_element_access] = STATE(290),
    [sym_invokation_expression] = STATE(290),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(81),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(83),
    [sym_real_literal] = ACTIONS(547),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(87),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(89),
    [sym_verbatim_string_characters] = ACTIONS(91),
    [sym_verbatim_here_string_characters] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_DASHas] = ACTIONS(95),
    [anon_sym_DASHccontains] = ACTIONS(95),
    [anon_sym_DASHceq] = ACTIONS(95),
    [anon_sym_DASHcge] = ACTIONS(95),
    [anon_sym_DASHcgt] = ACTIONS(95),
    [anon_sym_DASHcle] = ACTIONS(95),
    [anon_sym_DASHclike] = ACTIONS(95),
    [anon_sym_DASHclt] = ACTIONS(95),
    [anon_sym_DASHcmatch] = ACTIONS(95),
    [anon_sym_DASHcne] = ACTIONS(95),
    [anon_sym_DASHcnotcontains] = ACTIONS(95),
    [anon_sym_DASHcnotlike] = ACTIONS(95),
    [anon_sym_DASHcnotmatch] = ACTIONS(95),
    [anon_sym_DASHcontains] = ACTIONS(95),
    [anon_sym_DASHcreplace] = ACTIONS(95),
    [anon_sym_DASHcsplit] = ACTIONS(95),
    [anon_sym_DASHeq] = ACTIONS(95),
    [anon_sym_DASHge] = ACTIONS(95),
    [anon_sym_DASHgt] = ACTIONS(95),
    [anon_sym_DASHicontains] = ACTIONS(95),
    [anon_sym_DASHieq] = ACTIONS(95),
    [anon_sym_DASHige] = ACTIONS(95),
    [anon_sym_DASHigt] = ACTIONS(95),
    [anon_sym_DASHile] = ACTIONS(95),
    [anon_sym_DASHilike] = ACTIONS(95),
    [anon_sym_DASHilt] = ACTIONS(95),
    [anon_sym_DASHimatch] = ACTIONS(95),
    [anon_sym_DASHin] = ACTIONS(97),
    [anon_sym_DASHine] = ACTIONS(95),
    [anon_sym_DASHinotcontains] = ACTIONS(95),
    [anon_sym_DASHinotlike] = ACTIONS(95),
    [anon_sym_DASHinotmatch] = ACTIONS(95),
    [anon_sym_DASHireplace] = ACTIONS(95),
    [anon_sym_DASHis] = ACTIONS(97),
    [anon_sym_DASHisnot] = ACTIONS(95),
    [anon_sym_DASHisplit] = ACTIONS(95),
    [anon_sym_DASHjoin] = ACTIONS(549),
    [anon_sym_DASHle] = ACTIONS(95),
    [anon_sym_DASHlike] = ACTIONS(95),
    [anon_sym_DASHlt] = ACTIONS(95),
    [anon_sym_DASHmatch] = ACTIONS(95),
    [anon_sym_DASHne] = ACTIONS(95),
    [anon_sym_DASHnotcontains] = ACTIONS(95),
    [anon_sym_DASHnotin] = ACTIONS(95),
    [anon_sym_DASHnotlike] = ACTIONS(95),
    [anon_sym_DASHnotmatch] = ACTIONS(95),
    [anon_sym_DASHreplace] = ACTIONS(95),
    [anon_sym_DASHshl] = ACTIONS(95),
    [anon_sym_DASHshr] = ACTIONS(95),
    [anon_sym_DASHsplit] = ACTIONS(549),
    [sym_format_operator] = ACTIONS(95),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(101),
    [anon_sym_DOLLAR_CARET] = ACTIONS(101),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(101),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(101),
    [sym_braced_variable] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_LBRACE] = ACTIONS(107),
    [anon_sym_PERCENT] = ACTIONS(95),
    [anon_sym_DASHand] = ACTIONS(95),
    [anon_sym_DASHor] = ACTIONS(95),
    [anon_sym_DASHxor] = ACTIONS(95),
    [anon_sym_DASHband] = ACTIONS(95),
    [anon_sym_DASHbor] = ACTIONS(95),
    [anon_sym_DASHbxor] = ACTIONS(95),
    [anon_sym_PLUS] = ACTIONS(551),
    [anon_sym_DASH] = ACTIONS(551),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_BSLASH] = ACTIONS(95),
    [anon_sym_STAR] = ACTIONS(95),
    [anon_sym_DOT_DOT] = ACTIONS(95),
    [anon_sym_DASHnot] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_DASHbnot] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(553),
    [anon_sym_DASH_DASH] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(113),
    [anon_sym_AT_LPAREN] = ACTIONS(115),
    [anon_sym_AT_LBRACE] = ACTIONS(117),
    [anon_sym_DOT2] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(95),
    [anon_sym_DOTforeach] = ACTIONS(95),
    [sym__statement_terminator] = ACTIONS(95),
  },
  [82] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym__statement] = STATE(1961),
    [sym_empty_statement] = STATE(1961),
    [sym_if_statement] = STATE(1961),
    [sym__labeled_statement] = STATE(1961),
    [sym_switch_statement] = STATE(1961),
    [sym_foreach_statement] = STATE(1961),
    [sym_for_statement] = STATE(1961),
    [sym_while_statement] = STATE(1961),
    [sym_do_statement] = STATE(1961),
    [sym_function_statement] = STATE(1961),
    [sym_flow_control_statement] = STATE(1794),
    [sym_trap_statement] = STATE(1961),
    [sym_try_statement] = STATE(1961),
    [sym_data_statement] = STATE(1961),
    [sym_inlinescript_statement] = STATE(1961),
    [sym_parallel_statement] = STATE(1961),
    [sym_sequence_statement] = STATE(1961),
    [sym_pipeline] = STATE(1794),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym_class_statement] = STATE(1961),
    [sym_enum_statement] = STATE(1961),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(557),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_switch] = ACTIONS(561),
    [anon_sym_foreach] = ACTIONS(563),
    [anon_sym_for] = ACTIONS(565),
    [anon_sym_while] = ACTIONS(567),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_function] = ACTIONS(571),
    [anon_sym_filter] = ACTIONS(571),
    [anon_sym_workflow] = ACTIONS(571),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_exit] = ACTIONS(47),
    [sym_label] = ACTIONS(573),
    [anon_sym_trap] = ACTIONS(575),
    [anon_sym_try] = ACTIONS(577),
    [anon_sym_data] = ACTIONS(579),
    [anon_sym_inlinescript] = ACTIONS(581),
    [anon_sym_parallel] = ACTIONS(583),
    [anon_sym_sequence] = ACTIONS(585),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(587),
    [anon_sym_enum] = ACTIONS(589),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [83] = {
    [sym_argument_list] = STATE(116),
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(591),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_BANG_EQ] = ACTIONS(591),
    [anon_sym_PLUS_EQ] = ACTIONS(591),
    [anon_sym_STAR_EQ] = ACTIONS(591),
    [anon_sym_SLASH_EQ] = ACTIONS(591),
    [anon_sym_PERCENT_EQ] = ACTIONS(591),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_GT_GT] = ACTIONS(591),
    [anon_sym_2_GT] = ACTIONS(593),
    [anon_sym_2_GT_GT] = ACTIONS(591),
    [anon_sym_3_GT] = ACTIONS(593),
    [anon_sym_3_GT_GT] = ACTIONS(591),
    [anon_sym_4_GT] = ACTIONS(593),
    [anon_sym_4_GT_GT] = ACTIONS(591),
    [anon_sym_5_GT] = ACTIONS(593),
    [anon_sym_5_GT_GT] = ACTIONS(591),
    [anon_sym_6_GT] = ACTIONS(593),
    [anon_sym_6_GT_GT] = ACTIONS(591),
    [anon_sym_STAR_GT] = ACTIONS(593),
    [anon_sym_STAR_GT_GT] = ACTIONS(591),
    [anon_sym_LT] = ACTIONS(593),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(591),
    [anon_sym_2_GT_AMP1] = ACTIONS(591),
    [anon_sym_3_GT_AMP1] = ACTIONS(591),
    [anon_sym_4_GT_AMP1] = ACTIONS(591),
    [anon_sym_5_GT_AMP1] = ACTIONS(591),
    [anon_sym_6_GT_AMP1] = ACTIONS(591),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(591),
    [anon_sym_1_GT_AMP2] = ACTIONS(591),
    [anon_sym_3_GT_AMP2] = ACTIONS(591),
    [anon_sym_4_GT_AMP2] = ACTIONS(591),
    [anon_sym_5_GT_AMP2] = ACTIONS(591),
    [anon_sym_6_GT_AMP2] = ACTIONS(591),
    [anon_sym_DASHas] = ACTIONS(591),
    [anon_sym_DASHccontains] = ACTIONS(591),
    [anon_sym_DASHceq] = ACTIONS(591),
    [anon_sym_DASHcge] = ACTIONS(591),
    [anon_sym_DASHcgt] = ACTIONS(591),
    [anon_sym_DASHcle] = ACTIONS(591),
    [anon_sym_DASHclike] = ACTIONS(591),
    [anon_sym_DASHclt] = ACTIONS(591),
    [anon_sym_DASHcmatch] = ACTIONS(591),
    [anon_sym_DASHcne] = ACTIONS(591),
    [anon_sym_DASHcnotcontains] = ACTIONS(591),
    [anon_sym_DASHcnotlike] = ACTIONS(591),
    [anon_sym_DASHcnotmatch] = ACTIONS(591),
    [anon_sym_DASHcontains] = ACTIONS(591),
    [anon_sym_DASHcreplace] = ACTIONS(591),
    [anon_sym_DASHcsplit] = ACTIONS(591),
    [anon_sym_DASHeq] = ACTIONS(591),
    [anon_sym_DASHge] = ACTIONS(591),
    [anon_sym_DASHgt] = ACTIONS(591),
    [anon_sym_DASHicontains] = ACTIONS(591),
    [anon_sym_DASHieq] = ACTIONS(591),
    [anon_sym_DASHige] = ACTIONS(591),
    [anon_sym_DASHigt] = ACTIONS(591),
    [anon_sym_DASHile] = ACTIONS(591),
    [anon_sym_DASHilike] = ACTIONS(591),
    [anon_sym_DASHilt] = ACTIONS(591),
    [anon_sym_DASHimatch] = ACTIONS(591),
    [anon_sym_DASHin] = ACTIONS(593),
    [anon_sym_DASHine] = ACTIONS(591),
    [anon_sym_DASHinotcontains] = ACTIONS(591),
    [anon_sym_DASHinotlike] = ACTIONS(591),
    [anon_sym_DASHinotmatch] = ACTIONS(591),
    [anon_sym_DASHireplace] = ACTIONS(591),
    [anon_sym_DASHis] = ACTIONS(593),
    [anon_sym_DASHisnot] = ACTIONS(591),
    [anon_sym_DASHisplit] = ACTIONS(591),
    [anon_sym_DASHjoin] = ACTIONS(591),
    [anon_sym_DASHle] = ACTIONS(591),
    [anon_sym_DASHlike] = ACTIONS(591),
    [anon_sym_DASHlt] = ACTIONS(591),
    [anon_sym_DASHmatch] = ACTIONS(591),
    [anon_sym_DASHne] = ACTIONS(591),
    [anon_sym_DASHnotcontains] = ACTIONS(591),
    [anon_sym_DASHnotin] = ACTIONS(591),
    [anon_sym_DASHnotlike] = ACTIONS(591),
    [anon_sym_DASHnotmatch] = ACTIONS(591),
    [anon_sym_DASHreplace] = ACTIONS(591),
    [anon_sym_DASHshl] = ACTIONS(591),
    [anon_sym_DASHshr] = ACTIONS(591),
    [anon_sym_DASHsplit] = ACTIONS(591),
    [sym_format_operator] = ACTIONS(591),
    [anon_sym_LPAREN] = ACTIONS(591),
    [anon_sym_RPAREN] = ACTIONS(591),
    [anon_sym_COMMA] = ACTIONS(591),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PERCENT] = ACTIONS(593),
    [anon_sym_DASHand] = ACTIONS(591),
    [anon_sym_DASHor] = ACTIONS(591),
    [anon_sym_DASHxor] = ACTIONS(591),
    [anon_sym_DASHband] = ACTIONS(591),
    [anon_sym_DASHbor] = ACTIONS(591),
    [anon_sym_DASHbxor] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(593),
    [anon_sym_DASH] = ACTIONS(593),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_BSLASH] = ACTIONS(591),
    [anon_sym_STAR] = ACTIONS(593),
    [anon_sym_DOT_DOT] = ACTIONS(591),
    [anon_sym_PLUS_PLUS] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(591),
    [anon_sym_DOT2] = ACTIONS(593),
    [anon_sym_COLON_COLON] = ACTIONS(591),
    [anon_sym_RBRACK] = ACTIONS(591),
    [anon_sym_DOTforeach] = ACTIONS(591),
  },
  [84] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_EQ] = ACTIONS(595),
    [anon_sym_BANG_EQ] = ACTIONS(595),
    [anon_sym_PLUS_EQ] = ACTIONS(595),
    [anon_sym_STAR_EQ] = ACTIONS(595),
    [anon_sym_SLASH_EQ] = ACTIONS(595),
    [anon_sym_PERCENT_EQ] = ACTIONS(595),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(595),
    [anon_sym_2_GT] = ACTIONS(597),
    [anon_sym_2_GT_GT] = ACTIONS(595),
    [anon_sym_3_GT] = ACTIONS(597),
    [anon_sym_3_GT_GT] = ACTIONS(595),
    [anon_sym_4_GT] = ACTIONS(597),
    [anon_sym_4_GT_GT] = ACTIONS(595),
    [anon_sym_5_GT] = ACTIONS(597),
    [anon_sym_5_GT_GT] = ACTIONS(595),
    [anon_sym_6_GT] = ACTIONS(597),
    [anon_sym_6_GT_GT] = ACTIONS(595),
    [anon_sym_STAR_GT] = ACTIONS(597),
    [anon_sym_STAR_GT_GT] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(595),
    [anon_sym_2_GT_AMP1] = ACTIONS(595),
    [anon_sym_3_GT_AMP1] = ACTIONS(595),
    [anon_sym_4_GT_AMP1] = ACTIONS(595),
    [anon_sym_5_GT_AMP1] = ACTIONS(595),
    [anon_sym_6_GT_AMP1] = ACTIONS(595),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(595),
    [anon_sym_1_GT_AMP2] = ACTIONS(595),
    [anon_sym_3_GT_AMP2] = ACTIONS(595),
    [anon_sym_4_GT_AMP2] = ACTIONS(595),
    [anon_sym_5_GT_AMP2] = ACTIONS(595),
    [anon_sym_6_GT_AMP2] = ACTIONS(595),
    [anon_sym_DASHas] = ACTIONS(595),
    [anon_sym_DASHccontains] = ACTIONS(595),
    [anon_sym_DASHceq] = ACTIONS(595),
    [anon_sym_DASHcge] = ACTIONS(595),
    [anon_sym_DASHcgt] = ACTIONS(595),
    [anon_sym_DASHcle] = ACTIONS(595),
    [anon_sym_DASHclike] = ACTIONS(595),
    [anon_sym_DASHclt] = ACTIONS(595),
    [anon_sym_DASHcmatch] = ACTIONS(595),
    [anon_sym_DASHcne] = ACTIONS(595),
    [anon_sym_DASHcnotcontains] = ACTIONS(595),
    [anon_sym_DASHcnotlike] = ACTIONS(595),
    [anon_sym_DASHcnotmatch] = ACTIONS(595),
    [anon_sym_DASHcontains] = ACTIONS(595),
    [anon_sym_DASHcreplace] = ACTIONS(595),
    [anon_sym_DASHcsplit] = ACTIONS(595),
    [anon_sym_DASHeq] = ACTIONS(595),
    [anon_sym_DASHge] = ACTIONS(595),
    [anon_sym_DASHgt] = ACTIONS(595),
    [anon_sym_DASHicontains] = ACTIONS(595),
    [anon_sym_DASHieq] = ACTIONS(595),
    [anon_sym_DASHige] = ACTIONS(595),
    [anon_sym_DASHigt] = ACTIONS(595),
    [anon_sym_DASHile] = ACTIONS(595),
    [anon_sym_DASHilike] = ACTIONS(595),
    [anon_sym_DASHilt] = ACTIONS(595),
    [anon_sym_DASHimatch] = ACTIONS(595),
    [anon_sym_DASHin] = ACTIONS(597),
    [anon_sym_DASHine] = ACTIONS(595),
    [anon_sym_DASHinotcontains] = ACTIONS(595),
    [anon_sym_DASHinotlike] = ACTIONS(595),
    [anon_sym_DASHinotmatch] = ACTIONS(595),
    [anon_sym_DASHireplace] = ACTIONS(595),
    [anon_sym_DASHis] = ACTIONS(597),
    [anon_sym_DASHisnot] = ACTIONS(595),
    [anon_sym_DASHisplit] = ACTIONS(595),
    [anon_sym_DASHjoin] = ACTIONS(595),
    [anon_sym_DASHle] = ACTIONS(595),
    [anon_sym_DASHlike] = ACTIONS(595),
    [anon_sym_DASHlt] = ACTIONS(595),
    [anon_sym_DASHmatch] = ACTIONS(595),
    [anon_sym_DASHne] = ACTIONS(595),
    [anon_sym_DASHnotcontains] = ACTIONS(595),
    [anon_sym_DASHnotin] = ACTIONS(595),
    [anon_sym_DASHnotlike] = ACTIONS(595),
    [anon_sym_DASHnotmatch] = ACTIONS(595),
    [anon_sym_DASHreplace] = ACTIONS(595),
    [anon_sym_DASHshl] = ACTIONS(595),
    [anon_sym_DASHshr] = ACTIONS(595),
    [anon_sym_DASHsplit] = ACTIONS(595),
    [sym_format_operator] = ACTIONS(595),
    [anon_sym_LPAREN] = ACTIONS(595),
    [anon_sym_RPAREN] = ACTIONS(595),
    [anon_sym_COMMA] = ACTIONS(595),
    [anon_sym_LBRACE] = ACTIONS(595),
    [anon_sym_PIPE] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(597),
    [anon_sym_DASHand] = ACTIONS(595),
    [anon_sym_DASHor] = ACTIONS(595),
    [anon_sym_DASHxor] = ACTIONS(595),
    [anon_sym_DASHband] = ACTIONS(595),
    [anon_sym_DASHbor] = ACTIONS(595),
    [anon_sym_DASHbxor] = ACTIONS(595),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_SLASH] = ACTIONS(597),
    [anon_sym_BSLASH] = ACTIONS(595),
    [anon_sym_STAR] = ACTIONS(597),
    [anon_sym_DOT_DOT] = ACTIONS(595),
    [anon_sym_PLUS_PLUS] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(595),
    [anon_sym_DOT2] = ACTIONS(597),
    [anon_sym_COLON_COLON] = ACTIONS(595),
    [anon_sym_RBRACK] = ACTIONS(595),
    [anon_sym_DOTforeach] = ACTIONS(595),
  },
  [85] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_EQ] = ACTIONS(599),
    [anon_sym_BANG_EQ] = ACTIONS(599),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_GT] = ACTIONS(601),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_2_GT] = ACTIONS(601),
    [anon_sym_2_GT_GT] = ACTIONS(599),
    [anon_sym_3_GT] = ACTIONS(601),
    [anon_sym_3_GT_GT] = ACTIONS(599),
    [anon_sym_4_GT] = ACTIONS(601),
    [anon_sym_4_GT_GT] = ACTIONS(599),
    [anon_sym_5_GT] = ACTIONS(601),
    [anon_sym_5_GT_GT] = ACTIONS(599),
    [anon_sym_6_GT] = ACTIONS(601),
    [anon_sym_6_GT_GT] = ACTIONS(599),
    [anon_sym_STAR_GT] = ACTIONS(601),
    [anon_sym_STAR_GT_GT] = ACTIONS(599),
    [anon_sym_LT] = ACTIONS(601),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(599),
    [anon_sym_2_GT_AMP1] = ACTIONS(599),
    [anon_sym_3_GT_AMP1] = ACTIONS(599),
    [anon_sym_4_GT_AMP1] = ACTIONS(599),
    [anon_sym_5_GT_AMP1] = ACTIONS(599),
    [anon_sym_6_GT_AMP1] = ACTIONS(599),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(599),
    [anon_sym_1_GT_AMP2] = ACTIONS(599),
    [anon_sym_3_GT_AMP2] = ACTIONS(599),
    [anon_sym_4_GT_AMP2] = ACTIONS(599),
    [anon_sym_5_GT_AMP2] = ACTIONS(599),
    [anon_sym_6_GT_AMP2] = ACTIONS(599),
    [anon_sym_DASHas] = ACTIONS(599),
    [anon_sym_DASHccontains] = ACTIONS(599),
    [anon_sym_DASHceq] = ACTIONS(599),
    [anon_sym_DASHcge] = ACTIONS(599),
    [anon_sym_DASHcgt] = ACTIONS(599),
    [anon_sym_DASHcle] = ACTIONS(599),
    [anon_sym_DASHclike] = ACTIONS(599),
    [anon_sym_DASHclt] = ACTIONS(599),
    [anon_sym_DASHcmatch] = ACTIONS(599),
    [anon_sym_DASHcne] = ACTIONS(599),
    [anon_sym_DASHcnotcontains] = ACTIONS(599),
    [anon_sym_DASHcnotlike] = ACTIONS(599),
    [anon_sym_DASHcnotmatch] = ACTIONS(599),
    [anon_sym_DASHcontains] = ACTIONS(599),
    [anon_sym_DASHcreplace] = ACTIONS(599),
    [anon_sym_DASHcsplit] = ACTIONS(599),
    [anon_sym_DASHeq] = ACTIONS(599),
    [anon_sym_DASHge] = ACTIONS(599),
    [anon_sym_DASHgt] = ACTIONS(599),
    [anon_sym_DASHicontains] = ACTIONS(599),
    [anon_sym_DASHieq] = ACTIONS(599),
    [anon_sym_DASHige] = ACTIONS(599),
    [anon_sym_DASHigt] = ACTIONS(599),
    [anon_sym_DASHile] = ACTIONS(599),
    [anon_sym_DASHilike] = ACTIONS(599),
    [anon_sym_DASHilt] = ACTIONS(599),
    [anon_sym_DASHimatch] = ACTIONS(599),
    [anon_sym_DASHin] = ACTIONS(601),
    [anon_sym_DASHine] = ACTIONS(599),
    [anon_sym_DASHinotcontains] = ACTIONS(599),
    [anon_sym_DASHinotlike] = ACTIONS(599),
    [anon_sym_DASHinotmatch] = ACTIONS(599),
    [anon_sym_DASHireplace] = ACTIONS(599),
    [anon_sym_DASHis] = ACTIONS(601),
    [anon_sym_DASHisnot] = ACTIONS(599),
    [anon_sym_DASHisplit] = ACTIONS(599),
    [anon_sym_DASHjoin] = ACTIONS(599),
    [anon_sym_DASHle] = ACTIONS(599),
    [anon_sym_DASHlike] = ACTIONS(599),
    [anon_sym_DASHlt] = ACTIONS(599),
    [anon_sym_DASHmatch] = ACTIONS(599),
    [anon_sym_DASHne] = ACTIONS(599),
    [anon_sym_DASHnotcontains] = ACTIONS(599),
    [anon_sym_DASHnotin] = ACTIONS(599),
    [anon_sym_DASHnotlike] = ACTIONS(599),
    [anon_sym_DASHnotmatch] = ACTIONS(599),
    [anon_sym_DASHreplace] = ACTIONS(599),
    [anon_sym_DASHshl] = ACTIONS(599),
    [anon_sym_DASHshr] = ACTIONS(599),
    [anon_sym_DASHsplit] = ACTIONS(599),
    [sym_format_operator] = ACTIONS(599),
    [anon_sym_LPAREN] = ACTIONS(599),
    [anon_sym_RPAREN] = ACTIONS(599),
    [anon_sym_COMMA] = ACTIONS(599),
    [anon_sym_in] = ACTIONS(599),
    [anon_sym_PIPE] = ACTIONS(599),
    [anon_sym_PERCENT] = ACTIONS(601),
    [anon_sym_DASHand] = ACTIONS(599),
    [anon_sym_DASHor] = ACTIONS(599),
    [anon_sym_DASHxor] = ACTIONS(599),
    [anon_sym_DASHband] = ACTIONS(599),
    [anon_sym_DASHbor] = ACTIONS(599),
    [anon_sym_DASHbxor] = ACTIONS(599),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_SLASH] = ACTIONS(601),
    [anon_sym_BSLASH] = ACTIONS(599),
    [anon_sym_STAR] = ACTIONS(601),
    [anon_sym_DOT_DOT] = ACTIONS(599),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DOT2] = ACTIONS(601),
    [anon_sym_COLON_COLON] = ACTIONS(599),
    [anon_sym_RBRACK] = ACTIONS(599),
    [anon_sym_DOTforeach] = ACTIONS(599),
  },
  [86] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(603),
    [anon_sym_EQ] = ACTIONS(603),
    [anon_sym_BANG_EQ] = ACTIONS(603),
    [anon_sym_PLUS_EQ] = ACTIONS(603),
    [anon_sym_STAR_EQ] = ACTIONS(603),
    [anon_sym_SLASH_EQ] = ACTIONS(603),
    [anon_sym_PERCENT_EQ] = ACTIONS(603),
    [anon_sym_GT] = ACTIONS(605),
    [anon_sym_GT_GT] = ACTIONS(603),
    [anon_sym_2_GT] = ACTIONS(605),
    [anon_sym_2_GT_GT] = ACTIONS(603),
    [anon_sym_3_GT] = ACTIONS(605),
    [anon_sym_3_GT_GT] = ACTIONS(603),
    [anon_sym_4_GT] = ACTIONS(605),
    [anon_sym_4_GT_GT] = ACTIONS(603),
    [anon_sym_5_GT] = ACTIONS(605),
    [anon_sym_5_GT_GT] = ACTIONS(603),
    [anon_sym_6_GT] = ACTIONS(605),
    [anon_sym_6_GT_GT] = ACTIONS(603),
    [anon_sym_STAR_GT] = ACTIONS(605),
    [anon_sym_STAR_GT_GT] = ACTIONS(603),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(603),
    [anon_sym_2_GT_AMP1] = ACTIONS(603),
    [anon_sym_3_GT_AMP1] = ACTIONS(603),
    [anon_sym_4_GT_AMP1] = ACTIONS(603),
    [anon_sym_5_GT_AMP1] = ACTIONS(603),
    [anon_sym_6_GT_AMP1] = ACTIONS(603),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(603),
    [anon_sym_1_GT_AMP2] = ACTIONS(603),
    [anon_sym_3_GT_AMP2] = ACTIONS(603),
    [anon_sym_4_GT_AMP2] = ACTIONS(603),
    [anon_sym_5_GT_AMP2] = ACTIONS(603),
    [anon_sym_6_GT_AMP2] = ACTIONS(603),
    [anon_sym_DASHas] = ACTIONS(603),
    [anon_sym_DASHccontains] = ACTIONS(603),
    [anon_sym_DASHceq] = ACTIONS(603),
    [anon_sym_DASHcge] = ACTIONS(603),
    [anon_sym_DASHcgt] = ACTIONS(603),
    [anon_sym_DASHcle] = ACTIONS(603),
    [anon_sym_DASHclike] = ACTIONS(603),
    [anon_sym_DASHclt] = ACTIONS(603),
    [anon_sym_DASHcmatch] = ACTIONS(603),
    [anon_sym_DASHcne] = ACTIONS(603),
    [anon_sym_DASHcnotcontains] = ACTIONS(603),
    [anon_sym_DASHcnotlike] = ACTIONS(603),
    [anon_sym_DASHcnotmatch] = ACTIONS(603),
    [anon_sym_DASHcontains] = ACTIONS(603),
    [anon_sym_DASHcreplace] = ACTIONS(603),
    [anon_sym_DASHcsplit] = ACTIONS(603),
    [anon_sym_DASHeq] = ACTIONS(603),
    [anon_sym_DASHge] = ACTIONS(603),
    [anon_sym_DASHgt] = ACTIONS(603),
    [anon_sym_DASHicontains] = ACTIONS(603),
    [anon_sym_DASHieq] = ACTIONS(603),
    [anon_sym_DASHige] = ACTIONS(603),
    [anon_sym_DASHigt] = ACTIONS(603),
    [anon_sym_DASHile] = ACTIONS(603),
    [anon_sym_DASHilike] = ACTIONS(603),
    [anon_sym_DASHilt] = ACTIONS(603),
    [anon_sym_DASHimatch] = ACTIONS(603),
    [anon_sym_DASHin] = ACTIONS(605),
    [anon_sym_DASHine] = ACTIONS(603),
    [anon_sym_DASHinotcontains] = ACTIONS(603),
    [anon_sym_DASHinotlike] = ACTIONS(603),
    [anon_sym_DASHinotmatch] = ACTIONS(603),
    [anon_sym_DASHireplace] = ACTIONS(603),
    [anon_sym_DASHis] = ACTIONS(605),
    [anon_sym_DASHisnot] = ACTIONS(603),
    [anon_sym_DASHisplit] = ACTIONS(603),
    [anon_sym_DASHjoin] = ACTIONS(603),
    [anon_sym_DASHle] = ACTIONS(603),
    [anon_sym_DASHlike] = ACTIONS(603),
    [anon_sym_DASHlt] = ACTIONS(603),
    [anon_sym_DASHmatch] = ACTIONS(603),
    [anon_sym_DASHne] = ACTIONS(603),
    [anon_sym_DASHnotcontains] = ACTIONS(603),
    [anon_sym_DASHnotin] = ACTIONS(603),
    [anon_sym_DASHnotlike] = ACTIONS(603),
    [anon_sym_DASHnotmatch] = ACTIONS(603),
    [anon_sym_DASHreplace] = ACTIONS(603),
    [anon_sym_DASHshl] = ACTIONS(603),
    [anon_sym_DASHshr] = ACTIONS(603),
    [anon_sym_DASHsplit] = ACTIONS(603),
    [sym_format_operator] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(603),
    [anon_sym_RPAREN] = ACTIONS(603),
    [anon_sym_COMMA] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(603),
    [anon_sym_PIPE] = ACTIONS(603),
    [anon_sym_PERCENT] = ACTIONS(605),
    [anon_sym_DASHand] = ACTIONS(603),
    [anon_sym_DASHor] = ACTIONS(603),
    [anon_sym_DASHxor] = ACTIONS(603),
    [anon_sym_DASHband] = ACTIONS(603),
    [anon_sym_DASHbor] = ACTIONS(603),
    [anon_sym_DASHbxor] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(605),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(605),
    [anon_sym_BSLASH] = ACTIONS(603),
    [anon_sym_STAR] = ACTIONS(605),
    [anon_sym_DOT_DOT] = ACTIONS(603),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DOT2] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(603),
    [anon_sym_RBRACK] = ACTIONS(603),
    [anon_sym_DOTforeach] = ACTIONS(603),
  },
  [87] = {
    [sym_argument_list] = STATE(116),
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(591),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_BANG_EQ] = ACTIONS(591),
    [anon_sym_PLUS_EQ] = ACTIONS(591),
    [anon_sym_STAR_EQ] = ACTIONS(591),
    [anon_sym_SLASH_EQ] = ACTIONS(591),
    [anon_sym_PERCENT_EQ] = ACTIONS(591),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_GT_GT] = ACTIONS(591),
    [anon_sym_2_GT] = ACTIONS(593),
    [anon_sym_2_GT_GT] = ACTIONS(591),
    [anon_sym_3_GT] = ACTIONS(593),
    [anon_sym_3_GT_GT] = ACTIONS(591),
    [anon_sym_4_GT] = ACTIONS(593),
    [anon_sym_4_GT_GT] = ACTIONS(591),
    [anon_sym_5_GT] = ACTIONS(593),
    [anon_sym_5_GT_GT] = ACTIONS(591),
    [anon_sym_6_GT] = ACTIONS(593),
    [anon_sym_6_GT_GT] = ACTIONS(591),
    [anon_sym_STAR_GT] = ACTIONS(593),
    [anon_sym_STAR_GT_GT] = ACTIONS(591),
    [anon_sym_LT] = ACTIONS(593),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(591),
    [anon_sym_2_GT_AMP1] = ACTIONS(591),
    [anon_sym_3_GT_AMP1] = ACTIONS(591),
    [anon_sym_4_GT_AMP1] = ACTIONS(591),
    [anon_sym_5_GT_AMP1] = ACTIONS(591),
    [anon_sym_6_GT_AMP1] = ACTIONS(591),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(591),
    [anon_sym_1_GT_AMP2] = ACTIONS(591),
    [anon_sym_3_GT_AMP2] = ACTIONS(591),
    [anon_sym_4_GT_AMP2] = ACTIONS(591),
    [anon_sym_5_GT_AMP2] = ACTIONS(591),
    [anon_sym_6_GT_AMP2] = ACTIONS(591),
    [anon_sym_DASHas] = ACTIONS(591),
    [anon_sym_DASHccontains] = ACTIONS(591),
    [anon_sym_DASHceq] = ACTIONS(591),
    [anon_sym_DASHcge] = ACTIONS(591),
    [anon_sym_DASHcgt] = ACTIONS(591),
    [anon_sym_DASHcle] = ACTIONS(591),
    [anon_sym_DASHclike] = ACTIONS(591),
    [anon_sym_DASHclt] = ACTIONS(591),
    [anon_sym_DASHcmatch] = ACTIONS(591),
    [anon_sym_DASHcne] = ACTIONS(591),
    [anon_sym_DASHcnotcontains] = ACTIONS(591),
    [anon_sym_DASHcnotlike] = ACTIONS(591),
    [anon_sym_DASHcnotmatch] = ACTIONS(591),
    [anon_sym_DASHcontains] = ACTIONS(591),
    [anon_sym_DASHcreplace] = ACTIONS(591),
    [anon_sym_DASHcsplit] = ACTIONS(591),
    [anon_sym_DASHeq] = ACTIONS(591),
    [anon_sym_DASHge] = ACTIONS(591),
    [anon_sym_DASHgt] = ACTIONS(591),
    [anon_sym_DASHicontains] = ACTIONS(591),
    [anon_sym_DASHieq] = ACTIONS(591),
    [anon_sym_DASHige] = ACTIONS(591),
    [anon_sym_DASHigt] = ACTIONS(591),
    [anon_sym_DASHile] = ACTIONS(591),
    [anon_sym_DASHilike] = ACTIONS(591),
    [anon_sym_DASHilt] = ACTIONS(591),
    [anon_sym_DASHimatch] = ACTIONS(591),
    [anon_sym_DASHin] = ACTIONS(593),
    [anon_sym_DASHine] = ACTIONS(591),
    [anon_sym_DASHinotcontains] = ACTIONS(591),
    [anon_sym_DASHinotlike] = ACTIONS(591),
    [anon_sym_DASHinotmatch] = ACTIONS(591),
    [anon_sym_DASHireplace] = ACTIONS(591),
    [anon_sym_DASHis] = ACTIONS(593),
    [anon_sym_DASHisnot] = ACTIONS(591),
    [anon_sym_DASHisplit] = ACTIONS(591),
    [anon_sym_DASHjoin] = ACTIONS(591),
    [anon_sym_DASHle] = ACTIONS(591),
    [anon_sym_DASHlike] = ACTIONS(591),
    [anon_sym_DASHlt] = ACTIONS(591),
    [anon_sym_DASHmatch] = ACTIONS(591),
    [anon_sym_DASHne] = ACTIONS(591),
    [anon_sym_DASHnotcontains] = ACTIONS(591),
    [anon_sym_DASHnotin] = ACTIONS(591),
    [anon_sym_DASHnotlike] = ACTIONS(591),
    [anon_sym_DASHnotmatch] = ACTIONS(591),
    [anon_sym_DASHreplace] = ACTIONS(591),
    [anon_sym_DASHshl] = ACTIONS(591),
    [anon_sym_DASHshr] = ACTIONS(591),
    [anon_sym_DASHsplit] = ACTIONS(591),
    [sym_format_operator] = ACTIONS(591),
    [anon_sym_LPAREN] = ACTIONS(607),
    [anon_sym_RPAREN] = ACTIONS(591),
    [anon_sym_COMMA] = ACTIONS(591),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PERCENT] = ACTIONS(593),
    [anon_sym_DASHand] = ACTIONS(591),
    [anon_sym_DASHor] = ACTIONS(591),
    [anon_sym_DASHxor] = ACTIONS(591),
    [anon_sym_DASHband] = ACTIONS(591),
    [anon_sym_DASHbor] = ACTIONS(591),
    [anon_sym_DASHbxor] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(593),
    [anon_sym_DASH] = ACTIONS(593),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_BSLASH] = ACTIONS(591),
    [anon_sym_STAR] = ACTIONS(593),
    [anon_sym_DOT_DOT] = ACTIONS(591),
    [anon_sym_PLUS_PLUS] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(591),
    [anon_sym_DOT2] = ACTIONS(593),
    [anon_sym_COLON_COLON] = ACTIONS(591),
    [anon_sym_RBRACK] = ACTIONS(591),
    [anon_sym_DOTforeach] = ACTIONS(591),
  },
  [88] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(609),
    [anon_sym_EQ] = ACTIONS(609),
    [anon_sym_BANG_EQ] = ACTIONS(609),
    [anon_sym_PLUS_EQ] = ACTIONS(609),
    [anon_sym_STAR_EQ] = ACTIONS(609),
    [anon_sym_SLASH_EQ] = ACTIONS(609),
    [anon_sym_PERCENT_EQ] = ACTIONS(609),
    [anon_sym_GT] = ACTIONS(611),
    [anon_sym_GT_GT] = ACTIONS(609),
    [anon_sym_2_GT] = ACTIONS(611),
    [anon_sym_2_GT_GT] = ACTIONS(609),
    [anon_sym_3_GT] = ACTIONS(611),
    [anon_sym_3_GT_GT] = ACTIONS(609),
    [anon_sym_4_GT] = ACTIONS(611),
    [anon_sym_4_GT_GT] = ACTIONS(609),
    [anon_sym_5_GT] = ACTIONS(611),
    [anon_sym_5_GT_GT] = ACTIONS(609),
    [anon_sym_6_GT] = ACTIONS(611),
    [anon_sym_6_GT_GT] = ACTIONS(609),
    [anon_sym_STAR_GT] = ACTIONS(611),
    [anon_sym_STAR_GT_GT] = ACTIONS(609),
    [anon_sym_LT] = ACTIONS(611),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(609),
    [anon_sym_2_GT_AMP1] = ACTIONS(609),
    [anon_sym_3_GT_AMP1] = ACTIONS(609),
    [anon_sym_4_GT_AMP1] = ACTIONS(609),
    [anon_sym_5_GT_AMP1] = ACTIONS(609),
    [anon_sym_6_GT_AMP1] = ACTIONS(609),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(609),
    [anon_sym_1_GT_AMP2] = ACTIONS(609),
    [anon_sym_3_GT_AMP2] = ACTIONS(609),
    [anon_sym_4_GT_AMP2] = ACTIONS(609),
    [anon_sym_5_GT_AMP2] = ACTIONS(609),
    [anon_sym_6_GT_AMP2] = ACTIONS(609),
    [anon_sym_DASHas] = ACTIONS(609),
    [anon_sym_DASHccontains] = ACTIONS(609),
    [anon_sym_DASHceq] = ACTIONS(609),
    [anon_sym_DASHcge] = ACTIONS(609),
    [anon_sym_DASHcgt] = ACTIONS(609),
    [anon_sym_DASHcle] = ACTIONS(609),
    [anon_sym_DASHclike] = ACTIONS(609),
    [anon_sym_DASHclt] = ACTIONS(609),
    [anon_sym_DASHcmatch] = ACTIONS(609),
    [anon_sym_DASHcne] = ACTIONS(609),
    [anon_sym_DASHcnotcontains] = ACTIONS(609),
    [anon_sym_DASHcnotlike] = ACTIONS(609),
    [anon_sym_DASHcnotmatch] = ACTIONS(609),
    [anon_sym_DASHcontains] = ACTIONS(609),
    [anon_sym_DASHcreplace] = ACTIONS(609),
    [anon_sym_DASHcsplit] = ACTIONS(609),
    [anon_sym_DASHeq] = ACTIONS(609),
    [anon_sym_DASHge] = ACTIONS(609),
    [anon_sym_DASHgt] = ACTIONS(609),
    [anon_sym_DASHicontains] = ACTIONS(609),
    [anon_sym_DASHieq] = ACTIONS(609),
    [anon_sym_DASHige] = ACTIONS(609),
    [anon_sym_DASHigt] = ACTIONS(609),
    [anon_sym_DASHile] = ACTIONS(609),
    [anon_sym_DASHilike] = ACTIONS(609),
    [anon_sym_DASHilt] = ACTIONS(609),
    [anon_sym_DASHimatch] = ACTIONS(609),
    [anon_sym_DASHin] = ACTIONS(611),
    [anon_sym_DASHine] = ACTIONS(609),
    [anon_sym_DASHinotcontains] = ACTIONS(609),
    [anon_sym_DASHinotlike] = ACTIONS(609),
    [anon_sym_DASHinotmatch] = ACTIONS(609),
    [anon_sym_DASHireplace] = ACTIONS(609),
    [anon_sym_DASHis] = ACTIONS(611),
    [anon_sym_DASHisnot] = ACTIONS(609),
    [anon_sym_DASHisplit] = ACTIONS(609),
    [anon_sym_DASHjoin] = ACTIONS(609),
    [anon_sym_DASHle] = ACTIONS(609),
    [anon_sym_DASHlike] = ACTIONS(609),
    [anon_sym_DASHlt] = ACTIONS(609),
    [anon_sym_DASHmatch] = ACTIONS(609),
    [anon_sym_DASHne] = ACTIONS(609),
    [anon_sym_DASHnotcontains] = ACTIONS(609),
    [anon_sym_DASHnotin] = ACTIONS(609),
    [anon_sym_DASHnotlike] = ACTIONS(609),
    [anon_sym_DASHnotmatch] = ACTIONS(609),
    [anon_sym_DASHreplace] = ACTIONS(609),
    [anon_sym_DASHshl] = ACTIONS(609),
    [anon_sym_DASHshr] = ACTIONS(609),
    [anon_sym_DASHsplit] = ACTIONS(609),
    [sym_format_operator] = ACTIONS(609),
    [anon_sym_LPAREN] = ACTIONS(609),
    [anon_sym_RPAREN] = ACTIONS(609),
    [anon_sym_COMMA] = ACTIONS(609),
    [anon_sym_PIPE] = ACTIONS(609),
    [anon_sym_PERCENT] = ACTIONS(611),
    [anon_sym_DASHand] = ACTIONS(609),
    [anon_sym_DASHor] = ACTIONS(609),
    [anon_sym_DASHxor] = ACTIONS(609),
    [anon_sym_DASHband] = ACTIONS(609),
    [anon_sym_DASHbor] = ACTIONS(609),
    [anon_sym_DASHbxor] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_SLASH] = ACTIONS(611),
    [anon_sym_BSLASH] = ACTIONS(609),
    [anon_sym_STAR] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(609),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DOT2] = ACTIONS(611),
    [anon_sym_COLON_COLON] = ACTIONS(609),
    [anon_sym_RBRACK] = ACTIONS(609),
    [anon_sym_DOTforeach] = ACTIONS(609),
  },
  [89] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(613),
    [anon_sym_EQ] = ACTIONS(613),
    [anon_sym_BANG_EQ] = ACTIONS(613),
    [anon_sym_PLUS_EQ] = ACTIONS(613),
    [anon_sym_STAR_EQ] = ACTIONS(613),
    [anon_sym_SLASH_EQ] = ACTIONS(613),
    [anon_sym_PERCENT_EQ] = ACTIONS(613),
    [anon_sym_GT] = ACTIONS(615),
    [anon_sym_GT_GT] = ACTIONS(613),
    [anon_sym_2_GT] = ACTIONS(615),
    [anon_sym_2_GT_GT] = ACTIONS(613),
    [anon_sym_3_GT] = ACTIONS(615),
    [anon_sym_3_GT_GT] = ACTIONS(613),
    [anon_sym_4_GT] = ACTIONS(615),
    [anon_sym_4_GT_GT] = ACTIONS(613),
    [anon_sym_5_GT] = ACTIONS(615),
    [anon_sym_5_GT_GT] = ACTIONS(613),
    [anon_sym_6_GT] = ACTIONS(615),
    [anon_sym_6_GT_GT] = ACTIONS(613),
    [anon_sym_STAR_GT] = ACTIONS(615),
    [anon_sym_STAR_GT_GT] = ACTIONS(613),
    [anon_sym_LT] = ACTIONS(615),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(613),
    [anon_sym_2_GT_AMP1] = ACTIONS(613),
    [anon_sym_3_GT_AMP1] = ACTIONS(613),
    [anon_sym_4_GT_AMP1] = ACTIONS(613),
    [anon_sym_5_GT_AMP1] = ACTIONS(613),
    [anon_sym_6_GT_AMP1] = ACTIONS(613),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(613),
    [anon_sym_1_GT_AMP2] = ACTIONS(613),
    [anon_sym_3_GT_AMP2] = ACTIONS(613),
    [anon_sym_4_GT_AMP2] = ACTIONS(613),
    [anon_sym_5_GT_AMP2] = ACTIONS(613),
    [anon_sym_6_GT_AMP2] = ACTIONS(613),
    [anon_sym_DASHas] = ACTIONS(613),
    [anon_sym_DASHccontains] = ACTIONS(613),
    [anon_sym_DASHceq] = ACTIONS(613),
    [anon_sym_DASHcge] = ACTIONS(613),
    [anon_sym_DASHcgt] = ACTIONS(613),
    [anon_sym_DASHcle] = ACTIONS(613),
    [anon_sym_DASHclike] = ACTIONS(613),
    [anon_sym_DASHclt] = ACTIONS(613),
    [anon_sym_DASHcmatch] = ACTIONS(613),
    [anon_sym_DASHcne] = ACTIONS(613),
    [anon_sym_DASHcnotcontains] = ACTIONS(613),
    [anon_sym_DASHcnotlike] = ACTIONS(613),
    [anon_sym_DASHcnotmatch] = ACTIONS(613),
    [anon_sym_DASHcontains] = ACTIONS(613),
    [anon_sym_DASHcreplace] = ACTIONS(613),
    [anon_sym_DASHcsplit] = ACTIONS(613),
    [anon_sym_DASHeq] = ACTIONS(613),
    [anon_sym_DASHge] = ACTIONS(613),
    [anon_sym_DASHgt] = ACTIONS(613),
    [anon_sym_DASHicontains] = ACTIONS(613),
    [anon_sym_DASHieq] = ACTIONS(613),
    [anon_sym_DASHige] = ACTIONS(613),
    [anon_sym_DASHigt] = ACTIONS(613),
    [anon_sym_DASHile] = ACTIONS(613),
    [anon_sym_DASHilike] = ACTIONS(613),
    [anon_sym_DASHilt] = ACTIONS(613),
    [anon_sym_DASHimatch] = ACTIONS(613),
    [anon_sym_DASHin] = ACTIONS(615),
    [anon_sym_DASHine] = ACTIONS(613),
    [anon_sym_DASHinotcontains] = ACTIONS(613),
    [anon_sym_DASHinotlike] = ACTIONS(613),
    [anon_sym_DASHinotmatch] = ACTIONS(613),
    [anon_sym_DASHireplace] = ACTIONS(613),
    [anon_sym_DASHis] = ACTIONS(615),
    [anon_sym_DASHisnot] = ACTIONS(613),
    [anon_sym_DASHisplit] = ACTIONS(613),
    [anon_sym_DASHjoin] = ACTIONS(613),
    [anon_sym_DASHle] = ACTIONS(613),
    [anon_sym_DASHlike] = ACTIONS(613),
    [anon_sym_DASHlt] = ACTIONS(613),
    [anon_sym_DASHmatch] = ACTIONS(613),
    [anon_sym_DASHne] = ACTIONS(613),
    [anon_sym_DASHnotcontains] = ACTIONS(613),
    [anon_sym_DASHnotin] = ACTIONS(613),
    [anon_sym_DASHnotlike] = ACTIONS(613),
    [anon_sym_DASHnotmatch] = ACTIONS(613),
    [anon_sym_DASHreplace] = ACTIONS(613),
    [anon_sym_DASHshl] = ACTIONS(613),
    [anon_sym_DASHshr] = ACTIONS(613),
    [anon_sym_DASHsplit] = ACTIONS(613),
    [sym_format_operator] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(613),
    [anon_sym_RPAREN] = ACTIONS(613),
    [anon_sym_COMMA] = ACTIONS(613),
    [anon_sym_PIPE] = ACTIONS(613),
    [anon_sym_PERCENT] = ACTIONS(615),
    [anon_sym_DASHand] = ACTIONS(613),
    [anon_sym_DASHor] = ACTIONS(613),
    [anon_sym_DASHxor] = ACTIONS(613),
    [anon_sym_DASHband] = ACTIONS(613),
    [anon_sym_DASHbor] = ACTIONS(613),
    [anon_sym_DASHbxor] = ACTIONS(613),
    [anon_sym_PLUS] = ACTIONS(615),
    [anon_sym_DASH] = ACTIONS(615),
    [anon_sym_SLASH] = ACTIONS(615),
    [anon_sym_BSLASH] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(615),
    [anon_sym_DOT_DOT] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_DOT2] = ACTIONS(615),
    [anon_sym_COLON_COLON] = ACTIONS(613),
    [anon_sym_RBRACK] = ACTIONS(613),
    [anon_sym_DOTforeach] = ACTIONS(613),
  },
  [90] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(617),
    [anon_sym_EQ] = ACTIONS(617),
    [anon_sym_BANG_EQ] = ACTIONS(617),
    [anon_sym_PLUS_EQ] = ACTIONS(617),
    [anon_sym_STAR_EQ] = ACTIONS(617),
    [anon_sym_SLASH_EQ] = ACTIONS(617),
    [anon_sym_PERCENT_EQ] = ACTIONS(617),
    [anon_sym_GT] = ACTIONS(619),
    [anon_sym_GT_GT] = ACTIONS(617),
    [anon_sym_2_GT] = ACTIONS(619),
    [anon_sym_2_GT_GT] = ACTIONS(617),
    [anon_sym_3_GT] = ACTIONS(619),
    [anon_sym_3_GT_GT] = ACTIONS(617),
    [anon_sym_4_GT] = ACTIONS(619),
    [anon_sym_4_GT_GT] = ACTIONS(617),
    [anon_sym_5_GT] = ACTIONS(619),
    [anon_sym_5_GT_GT] = ACTIONS(617),
    [anon_sym_6_GT] = ACTIONS(619),
    [anon_sym_6_GT_GT] = ACTIONS(617),
    [anon_sym_STAR_GT] = ACTIONS(619),
    [anon_sym_STAR_GT_GT] = ACTIONS(617),
    [anon_sym_LT] = ACTIONS(619),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(617),
    [anon_sym_2_GT_AMP1] = ACTIONS(617),
    [anon_sym_3_GT_AMP1] = ACTIONS(617),
    [anon_sym_4_GT_AMP1] = ACTIONS(617),
    [anon_sym_5_GT_AMP1] = ACTIONS(617),
    [anon_sym_6_GT_AMP1] = ACTIONS(617),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(617),
    [anon_sym_1_GT_AMP2] = ACTIONS(617),
    [anon_sym_3_GT_AMP2] = ACTIONS(617),
    [anon_sym_4_GT_AMP2] = ACTIONS(617),
    [anon_sym_5_GT_AMP2] = ACTIONS(617),
    [anon_sym_6_GT_AMP2] = ACTIONS(617),
    [anon_sym_DASHas] = ACTIONS(617),
    [anon_sym_DASHccontains] = ACTIONS(617),
    [anon_sym_DASHceq] = ACTIONS(617),
    [anon_sym_DASHcge] = ACTIONS(617),
    [anon_sym_DASHcgt] = ACTIONS(617),
    [anon_sym_DASHcle] = ACTIONS(617),
    [anon_sym_DASHclike] = ACTIONS(617),
    [anon_sym_DASHclt] = ACTIONS(617),
    [anon_sym_DASHcmatch] = ACTIONS(617),
    [anon_sym_DASHcne] = ACTIONS(617),
    [anon_sym_DASHcnotcontains] = ACTIONS(617),
    [anon_sym_DASHcnotlike] = ACTIONS(617),
    [anon_sym_DASHcnotmatch] = ACTIONS(617),
    [anon_sym_DASHcontains] = ACTIONS(617),
    [anon_sym_DASHcreplace] = ACTIONS(617),
    [anon_sym_DASHcsplit] = ACTIONS(617),
    [anon_sym_DASHeq] = ACTIONS(617),
    [anon_sym_DASHge] = ACTIONS(617),
    [anon_sym_DASHgt] = ACTIONS(617),
    [anon_sym_DASHicontains] = ACTIONS(617),
    [anon_sym_DASHieq] = ACTIONS(617),
    [anon_sym_DASHige] = ACTIONS(617),
    [anon_sym_DASHigt] = ACTIONS(617),
    [anon_sym_DASHile] = ACTIONS(617),
    [anon_sym_DASHilike] = ACTIONS(617),
    [anon_sym_DASHilt] = ACTIONS(617),
    [anon_sym_DASHimatch] = ACTIONS(617),
    [anon_sym_DASHin] = ACTIONS(619),
    [anon_sym_DASHine] = ACTIONS(617),
    [anon_sym_DASHinotcontains] = ACTIONS(617),
    [anon_sym_DASHinotlike] = ACTIONS(617),
    [anon_sym_DASHinotmatch] = ACTIONS(617),
    [anon_sym_DASHireplace] = ACTIONS(617),
    [anon_sym_DASHis] = ACTIONS(619),
    [anon_sym_DASHisnot] = ACTIONS(617),
    [anon_sym_DASHisplit] = ACTIONS(617),
    [anon_sym_DASHjoin] = ACTIONS(617),
    [anon_sym_DASHle] = ACTIONS(617),
    [anon_sym_DASHlike] = ACTIONS(617),
    [anon_sym_DASHlt] = ACTIONS(617),
    [anon_sym_DASHmatch] = ACTIONS(617),
    [anon_sym_DASHne] = ACTIONS(617),
    [anon_sym_DASHnotcontains] = ACTIONS(617),
    [anon_sym_DASHnotin] = ACTIONS(617),
    [anon_sym_DASHnotlike] = ACTIONS(617),
    [anon_sym_DASHnotmatch] = ACTIONS(617),
    [anon_sym_DASHreplace] = ACTIONS(617),
    [anon_sym_DASHshl] = ACTIONS(617),
    [anon_sym_DASHshr] = ACTIONS(617),
    [anon_sym_DASHsplit] = ACTIONS(617),
    [sym_format_operator] = ACTIONS(617),
    [anon_sym_LPAREN] = ACTIONS(617),
    [anon_sym_RPAREN] = ACTIONS(617),
    [anon_sym_COMMA] = ACTIONS(617),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_DASHand] = ACTIONS(617),
    [anon_sym_DASHor] = ACTIONS(617),
    [anon_sym_DASHxor] = ACTIONS(617),
    [anon_sym_DASHband] = ACTIONS(617),
    [anon_sym_DASHbor] = ACTIONS(617),
    [anon_sym_DASHbxor] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_BSLASH] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_DOT_DOT] = ACTIONS(617),
    [anon_sym_PLUS_PLUS] = ACTIONS(617),
    [anon_sym_DASH_DASH] = ACTIONS(617),
    [anon_sym_DOT2] = ACTIONS(619),
    [anon_sym_COLON_COLON] = ACTIONS(617),
    [anon_sym_RBRACK] = ACTIONS(617),
    [anon_sym_DOTforeach] = ACTIONS(617),
  },
  [91] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(621),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_BANG_EQ] = ACTIONS(621),
    [anon_sym_PLUS_EQ] = ACTIONS(621),
    [anon_sym_STAR_EQ] = ACTIONS(621),
    [anon_sym_SLASH_EQ] = ACTIONS(621),
    [anon_sym_PERCENT_EQ] = ACTIONS(621),
    [anon_sym_GT] = ACTIONS(623),
    [anon_sym_GT_GT] = ACTIONS(621),
    [anon_sym_2_GT] = ACTIONS(623),
    [anon_sym_2_GT_GT] = ACTIONS(621),
    [anon_sym_3_GT] = ACTIONS(623),
    [anon_sym_3_GT_GT] = ACTIONS(621),
    [anon_sym_4_GT] = ACTIONS(623),
    [anon_sym_4_GT_GT] = ACTIONS(621),
    [anon_sym_5_GT] = ACTIONS(623),
    [anon_sym_5_GT_GT] = ACTIONS(621),
    [anon_sym_6_GT] = ACTIONS(623),
    [anon_sym_6_GT_GT] = ACTIONS(621),
    [anon_sym_STAR_GT] = ACTIONS(623),
    [anon_sym_STAR_GT_GT] = ACTIONS(621),
    [anon_sym_LT] = ACTIONS(623),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(621),
    [anon_sym_2_GT_AMP1] = ACTIONS(621),
    [anon_sym_3_GT_AMP1] = ACTIONS(621),
    [anon_sym_4_GT_AMP1] = ACTIONS(621),
    [anon_sym_5_GT_AMP1] = ACTIONS(621),
    [anon_sym_6_GT_AMP1] = ACTIONS(621),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(621),
    [anon_sym_1_GT_AMP2] = ACTIONS(621),
    [anon_sym_3_GT_AMP2] = ACTIONS(621),
    [anon_sym_4_GT_AMP2] = ACTIONS(621),
    [anon_sym_5_GT_AMP2] = ACTIONS(621),
    [anon_sym_6_GT_AMP2] = ACTIONS(621),
    [anon_sym_DASHas] = ACTIONS(621),
    [anon_sym_DASHccontains] = ACTIONS(621),
    [anon_sym_DASHceq] = ACTIONS(621),
    [anon_sym_DASHcge] = ACTIONS(621),
    [anon_sym_DASHcgt] = ACTIONS(621),
    [anon_sym_DASHcle] = ACTIONS(621),
    [anon_sym_DASHclike] = ACTIONS(621),
    [anon_sym_DASHclt] = ACTIONS(621),
    [anon_sym_DASHcmatch] = ACTIONS(621),
    [anon_sym_DASHcne] = ACTIONS(621),
    [anon_sym_DASHcnotcontains] = ACTIONS(621),
    [anon_sym_DASHcnotlike] = ACTIONS(621),
    [anon_sym_DASHcnotmatch] = ACTIONS(621),
    [anon_sym_DASHcontains] = ACTIONS(621),
    [anon_sym_DASHcreplace] = ACTIONS(621),
    [anon_sym_DASHcsplit] = ACTIONS(621),
    [anon_sym_DASHeq] = ACTIONS(621),
    [anon_sym_DASHge] = ACTIONS(621),
    [anon_sym_DASHgt] = ACTIONS(621),
    [anon_sym_DASHicontains] = ACTIONS(621),
    [anon_sym_DASHieq] = ACTIONS(621),
    [anon_sym_DASHige] = ACTIONS(621),
    [anon_sym_DASHigt] = ACTIONS(621),
    [anon_sym_DASHile] = ACTIONS(621),
    [anon_sym_DASHilike] = ACTIONS(621),
    [anon_sym_DASHilt] = ACTIONS(621),
    [anon_sym_DASHimatch] = ACTIONS(621),
    [anon_sym_DASHin] = ACTIONS(623),
    [anon_sym_DASHine] = ACTIONS(621),
    [anon_sym_DASHinotcontains] = ACTIONS(621),
    [anon_sym_DASHinotlike] = ACTIONS(621),
    [anon_sym_DASHinotmatch] = ACTIONS(621),
    [anon_sym_DASHireplace] = ACTIONS(621),
    [anon_sym_DASHis] = ACTIONS(623),
    [anon_sym_DASHisnot] = ACTIONS(621),
    [anon_sym_DASHisplit] = ACTIONS(621),
    [anon_sym_DASHjoin] = ACTIONS(621),
    [anon_sym_DASHle] = ACTIONS(621),
    [anon_sym_DASHlike] = ACTIONS(621),
    [anon_sym_DASHlt] = ACTIONS(621),
    [anon_sym_DASHmatch] = ACTIONS(621),
    [anon_sym_DASHne] = ACTIONS(621),
    [anon_sym_DASHnotcontains] = ACTIONS(621),
    [anon_sym_DASHnotin] = ACTIONS(621),
    [anon_sym_DASHnotlike] = ACTIONS(621),
    [anon_sym_DASHnotmatch] = ACTIONS(621),
    [anon_sym_DASHreplace] = ACTIONS(621),
    [anon_sym_DASHshl] = ACTIONS(621),
    [anon_sym_DASHshr] = ACTIONS(621),
    [anon_sym_DASHsplit] = ACTIONS(621),
    [sym_format_operator] = ACTIONS(621),
    [anon_sym_LPAREN] = ACTIONS(621),
    [anon_sym_RPAREN] = ACTIONS(621),
    [anon_sym_COMMA] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(621),
    [anon_sym_PERCENT] = ACTIONS(623),
    [anon_sym_DASHand] = ACTIONS(621),
    [anon_sym_DASHor] = ACTIONS(621),
    [anon_sym_DASHxor] = ACTIONS(621),
    [anon_sym_DASHband] = ACTIONS(621),
    [anon_sym_DASHbor] = ACTIONS(621),
    [anon_sym_DASHbxor] = ACTIONS(621),
    [anon_sym_PLUS] = ACTIONS(623),
    [anon_sym_DASH] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(623),
    [anon_sym_BSLASH] = ACTIONS(621),
    [anon_sym_STAR] = ACTIONS(623),
    [anon_sym_DOT_DOT] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_DOT2] = ACTIONS(623),
    [anon_sym_COLON_COLON] = ACTIONS(621),
    [anon_sym_RBRACK] = ACTIONS(621),
    [anon_sym_DOTforeach] = ACTIONS(621),
  },
  [92] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(625),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_PLUS_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(625),
    [anon_sym_SLASH_EQ] = ACTIONS(625),
    [anon_sym_PERCENT_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(625),
    [anon_sym_2_GT] = ACTIONS(627),
    [anon_sym_2_GT_GT] = ACTIONS(625),
    [anon_sym_3_GT] = ACTIONS(627),
    [anon_sym_3_GT_GT] = ACTIONS(625),
    [anon_sym_4_GT] = ACTIONS(627),
    [anon_sym_4_GT_GT] = ACTIONS(625),
    [anon_sym_5_GT] = ACTIONS(627),
    [anon_sym_5_GT_GT] = ACTIONS(625),
    [anon_sym_6_GT] = ACTIONS(627),
    [anon_sym_6_GT_GT] = ACTIONS(625),
    [anon_sym_STAR_GT] = ACTIONS(627),
    [anon_sym_STAR_GT_GT] = ACTIONS(625),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(625),
    [anon_sym_2_GT_AMP1] = ACTIONS(625),
    [anon_sym_3_GT_AMP1] = ACTIONS(625),
    [anon_sym_4_GT_AMP1] = ACTIONS(625),
    [anon_sym_5_GT_AMP1] = ACTIONS(625),
    [anon_sym_6_GT_AMP1] = ACTIONS(625),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(625),
    [anon_sym_1_GT_AMP2] = ACTIONS(625),
    [anon_sym_3_GT_AMP2] = ACTIONS(625),
    [anon_sym_4_GT_AMP2] = ACTIONS(625),
    [anon_sym_5_GT_AMP2] = ACTIONS(625),
    [anon_sym_6_GT_AMP2] = ACTIONS(625),
    [anon_sym_DASHas] = ACTIONS(625),
    [anon_sym_DASHccontains] = ACTIONS(625),
    [anon_sym_DASHceq] = ACTIONS(625),
    [anon_sym_DASHcge] = ACTIONS(625),
    [anon_sym_DASHcgt] = ACTIONS(625),
    [anon_sym_DASHcle] = ACTIONS(625),
    [anon_sym_DASHclike] = ACTIONS(625),
    [anon_sym_DASHclt] = ACTIONS(625),
    [anon_sym_DASHcmatch] = ACTIONS(625),
    [anon_sym_DASHcne] = ACTIONS(625),
    [anon_sym_DASHcnotcontains] = ACTIONS(625),
    [anon_sym_DASHcnotlike] = ACTIONS(625),
    [anon_sym_DASHcnotmatch] = ACTIONS(625),
    [anon_sym_DASHcontains] = ACTIONS(625),
    [anon_sym_DASHcreplace] = ACTIONS(625),
    [anon_sym_DASHcsplit] = ACTIONS(625),
    [anon_sym_DASHeq] = ACTIONS(625),
    [anon_sym_DASHge] = ACTIONS(625),
    [anon_sym_DASHgt] = ACTIONS(625),
    [anon_sym_DASHicontains] = ACTIONS(625),
    [anon_sym_DASHieq] = ACTIONS(625),
    [anon_sym_DASHige] = ACTIONS(625),
    [anon_sym_DASHigt] = ACTIONS(625),
    [anon_sym_DASHile] = ACTIONS(625),
    [anon_sym_DASHilike] = ACTIONS(625),
    [anon_sym_DASHilt] = ACTIONS(625),
    [anon_sym_DASHimatch] = ACTIONS(625),
    [anon_sym_DASHin] = ACTIONS(627),
    [anon_sym_DASHine] = ACTIONS(625),
    [anon_sym_DASHinotcontains] = ACTIONS(625),
    [anon_sym_DASHinotlike] = ACTIONS(625),
    [anon_sym_DASHinotmatch] = ACTIONS(625),
    [anon_sym_DASHireplace] = ACTIONS(625),
    [anon_sym_DASHis] = ACTIONS(627),
    [anon_sym_DASHisnot] = ACTIONS(625),
    [anon_sym_DASHisplit] = ACTIONS(625),
    [anon_sym_DASHjoin] = ACTIONS(625),
    [anon_sym_DASHle] = ACTIONS(625),
    [anon_sym_DASHlike] = ACTIONS(625),
    [anon_sym_DASHlt] = ACTIONS(625),
    [anon_sym_DASHmatch] = ACTIONS(625),
    [anon_sym_DASHne] = ACTIONS(625),
    [anon_sym_DASHnotcontains] = ACTIONS(625),
    [anon_sym_DASHnotin] = ACTIONS(625),
    [anon_sym_DASHnotlike] = ACTIONS(625),
    [anon_sym_DASHnotmatch] = ACTIONS(625),
    [anon_sym_DASHreplace] = ACTIONS(625),
    [anon_sym_DASHshl] = ACTIONS(625),
    [anon_sym_DASHshr] = ACTIONS(625),
    [anon_sym_DASHsplit] = ACTIONS(625),
    [sym_format_operator] = ACTIONS(625),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(625),
    [anon_sym_PERCENT] = ACTIONS(627),
    [anon_sym_DASHand] = ACTIONS(625),
    [anon_sym_DASHor] = ACTIONS(625),
    [anon_sym_DASHxor] = ACTIONS(625),
    [anon_sym_DASHband] = ACTIONS(625),
    [anon_sym_DASHbor] = ACTIONS(625),
    [anon_sym_DASHbxor] = ACTIONS(625),
    [anon_sym_PLUS] = ACTIONS(627),
    [anon_sym_DASH] = ACTIONS(627),
    [anon_sym_SLASH] = ACTIONS(627),
    [anon_sym_BSLASH] = ACTIONS(625),
    [anon_sym_STAR] = ACTIONS(627),
    [anon_sym_DOT_DOT] = ACTIONS(625),
    [anon_sym_PLUS_PLUS] = ACTIONS(625),
    [anon_sym_DASH_DASH] = ACTIONS(625),
    [anon_sym_DOT2] = ACTIONS(627),
    [anon_sym_COLON_COLON] = ACTIONS(625),
    [anon_sym_RBRACK] = ACTIONS(625),
    [anon_sym_DOTforeach] = ACTIONS(625),
  },
  [93] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(629),
    [anon_sym_EQ] = ACTIONS(629),
    [anon_sym_BANG_EQ] = ACTIONS(629),
    [anon_sym_PLUS_EQ] = ACTIONS(629),
    [anon_sym_STAR_EQ] = ACTIONS(629),
    [anon_sym_SLASH_EQ] = ACTIONS(629),
    [anon_sym_PERCENT_EQ] = ACTIONS(629),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_GT] = ACTIONS(629),
    [anon_sym_2_GT] = ACTIONS(631),
    [anon_sym_2_GT_GT] = ACTIONS(629),
    [anon_sym_3_GT] = ACTIONS(631),
    [anon_sym_3_GT_GT] = ACTIONS(629),
    [anon_sym_4_GT] = ACTIONS(631),
    [anon_sym_4_GT_GT] = ACTIONS(629),
    [anon_sym_5_GT] = ACTIONS(631),
    [anon_sym_5_GT_GT] = ACTIONS(629),
    [anon_sym_6_GT] = ACTIONS(631),
    [anon_sym_6_GT_GT] = ACTIONS(629),
    [anon_sym_STAR_GT] = ACTIONS(631),
    [anon_sym_STAR_GT_GT] = ACTIONS(629),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(629),
    [anon_sym_2_GT_AMP1] = ACTIONS(629),
    [anon_sym_3_GT_AMP1] = ACTIONS(629),
    [anon_sym_4_GT_AMP1] = ACTIONS(629),
    [anon_sym_5_GT_AMP1] = ACTIONS(629),
    [anon_sym_6_GT_AMP1] = ACTIONS(629),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(629),
    [anon_sym_1_GT_AMP2] = ACTIONS(629),
    [anon_sym_3_GT_AMP2] = ACTIONS(629),
    [anon_sym_4_GT_AMP2] = ACTIONS(629),
    [anon_sym_5_GT_AMP2] = ACTIONS(629),
    [anon_sym_6_GT_AMP2] = ACTIONS(629),
    [anon_sym_DASHas] = ACTIONS(629),
    [anon_sym_DASHccontains] = ACTIONS(629),
    [anon_sym_DASHceq] = ACTIONS(629),
    [anon_sym_DASHcge] = ACTIONS(629),
    [anon_sym_DASHcgt] = ACTIONS(629),
    [anon_sym_DASHcle] = ACTIONS(629),
    [anon_sym_DASHclike] = ACTIONS(629),
    [anon_sym_DASHclt] = ACTIONS(629),
    [anon_sym_DASHcmatch] = ACTIONS(629),
    [anon_sym_DASHcne] = ACTIONS(629),
    [anon_sym_DASHcnotcontains] = ACTIONS(629),
    [anon_sym_DASHcnotlike] = ACTIONS(629),
    [anon_sym_DASHcnotmatch] = ACTIONS(629),
    [anon_sym_DASHcontains] = ACTIONS(629),
    [anon_sym_DASHcreplace] = ACTIONS(629),
    [anon_sym_DASHcsplit] = ACTIONS(629),
    [anon_sym_DASHeq] = ACTIONS(629),
    [anon_sym_DASHge] = ACTIONS(629),
    [anon_sym_DASHgt] = ACTIONS(629),
    [anon_sym_DASHicontains] = ACTIONS(629),
    [anon_sym_DASHieq] = ACTIONS(629),
    [anon_sym_DASHige] = ACTIONS(629),
    [anon_sym_DASHigt] = ACTIONS(629),
    [anon_sym_DASHile] = ACTIONS(629),
    [anon_sym_DASHilike] = ACTIONS(629),
    [anon_sym_DASHilt] = ACTIONS(629),
    [anon_sym_DASHimatch] = ACTIONS(629),
    [anon_sym_DASHin] = ACTIONS(631),
    [anon_sym_DASHine] = ACTIONS(629),
    [anon_sym_DASHinotcontains] = ACTIONS(629),
    [anon_sym_DASHinotlike] = ACTIONS(629),
    [anon_sym_DASHinotmatch] = ACTIONS(629),
    [anon_sym_DASHireplace] = ACTIONS(629),
    [anon_sym_DASHis] = ACTIONS(631),
    [anon_sym_DASHisnot] = ACTIONS(629),
    [anon_sym_DASHisplit] = ACTIONS(629),
    [anon_sym_DASHjoin] = ACTIONS(629),
    [anon_sym_DASHle] = ACTIONS(629),
    [anon_sym_DASHlike] = ACTIONS(629),
    [anon_sym_DASHlt] = ACTIONS(629),
    [anon_sym_DASHmatch] = ACTIONS(629),
    [anon_sym_DASHne] = ACTIONS(629),
    [anon_sym_DASHnotcontains] = ACTIONS(629),
    [anon_sym_DASHnotin] = ACTIONS(629),
    [anon_sym_DASHnotlike] = ACTIONS(629),
    [anon_sym_DASHnotmatch] = ACTIONS(629),
    [anon_sym_DASHreplace] = ACTIONS(629),
    [anon_sym_DASHshl] = ACTIONS(629),
    [anon_sym_DASHshr] = ACTIONS(629),
    [anon_sym_DASHsplit] = ACTIONS(629),
    [sym_format_operator] = ACTIONS(629),
    [anon_sym_LPAREN] = ACTIONS(629),
    [anon_sym_RPAREN] = ACTIONS(629),
    [anon_sym_COMMA] = ACTIONS(629),
    [anon_sym_PIPE] = ACTIONS(629),
    [anon_sym_PERCENT] = ACTIONS(631),
    [anon_sym_DASHand] = ACTIONS(629),
    [anon_sym_DASHor] = ACTIONS(629),
    [anon_sym_DASHxor] = ACTIONS(629),
    [anon_sym_DASHband] = ACTIONS(629),
    [anon_sym_DASHbor] = ACTIONS(629),
    [anon_sym_DASHbxor] = ACTIONS(629),
    [anon_sym_PLUS] = ACTIONS(631),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_SLASH] = ACTIONS(631),
    [anon_sym_BSLASH] = ACTIONS(629),
    [anon_sym_STAR] = ACTIONS(631),
    [anon_sym_DOT_DOT] = ACTIONS(629),
    [anon_sym_PLUS_PLUS] = ACTIONS(629),
    [anon_sym_DASH_DASH] = ACTIONS(629),
    [anon_sym_DOT2] = ACTIONS(631),
    [anon_sym_COLON_COLON] = ACTIONS(629),
    [anon_sym_RBRACK] = ACTIONS(629),
    [anon_sym_DOTforeach] = ACTIONS(629),
  },
  [94] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(603),
    [anon_sym_EQ] = ACTIONS(603),
    [anon_sym_BANG_EQ] = ACTIONS(603),
    [anon_sym_PLUS_EQ] = ACTIONS(603),
    [anon_sym_STAR_EQ] = ACTIONS(603),
    [anon_sym_SLASH_EQ] = ACTIONS(603),
    [anon_sym_PERCENT_EQ] = ACTIONS(603),
    [anon_sym_GT] = ACTIONS(605),
    [anon_sym_GT_GT] = ACTIONS(603),
    [anon_sym_2_GT] = ACTIONS(605),
    [anon_sym_2_GT_GT] = ACTIONS(603),
    [anon_sym_3_GT] = ACTIONS(605),
    [anon_sym_3_GT_GT] = ACTIONS(603),
    [anon_sym_4_GT] = ACTIONS(605),
    [anon_sym_4_GT_GT] = ACTIONS(603),
    [anon_sym_5_GT] = ACTIONS(605),
    [anon_sym_5_GT_GT] = ACTIONS(603),
    [anon_sym_6_GT] = ACTIONS(605),
    [anon_sym_6_GT_GT] = ACTIONS(603),
    [anon_sym_STAR_GT] = ACTIONS(605),
    [anon_sym_STAR_GT_GT] = ACTIONS(603),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(603),
    [anon_sym_2_GT_AMP1] = ACTIONS(603),
    [anon_sym_3_GT_AMP1] = ACTIONS(603),
    [anon_sym_4_GT_AMP1] = ACTIONS(603),
    [anon_sym_5_GT_AMP1] = ACTIONS(603),
    [anon_sym_6_GT_AMP1] = ACTIONS(603),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(603),
    [anon_sym_1_GT_AMP2] = ACTIONS(603),
    [anon_sym_3_GT_AMP2] = ACTIONS(603),
    [anon_sym_4_GT_AMP2] = ACTIONS(603),
    [anon_sym_5_GT_AMP2] = ACTIONS(603),
    [anon_sym_6_GT_AMP2] = ACTIONS(603),
    [anon_sym_DASHas] = ACTIONS(603),
    [anon_sym_DASHccontains] = ACTIONS(603),
    [anon_sym_DASHceq] = ACTIONS(603),
    [anon_sym_DASHcge] = ACTIONS(603),
    [anon_sym_DASHcgt] = ACTIONS(603),
    [anon_sym_DASHcle] = ACTIONS(603),
    [anon_sym_DASHclike] = ACTIONS(603),
    [anon_sym_DASHclt] = ACTIONS(603),
    [anon_sym_DASHcmatch] = ACTIONS(603),
    [anon_sym_DASHcne] = ACTIONS(603),
    [anon_sym_DASHcnotcontains] = ACTIONS(603),
    [anon_sym_DASHcnotlike] = ACTIONS(603),
    [anon_sym_DASHcnotmatch] = ACTIONS(603),
    [anon_sym_DASHcontains] = ACTIONS(603),
    [anon_sym_DASHcreplace] = ACTIONS(603),
    [anon_sym_DASHcsplit] = ACTIONS(603),
    [anon_sym_DASHeq] = ACTIONS(603),
    [anon_sym_DASHge] = ACTIONS(603),
    [anon_sym_DASHgt] = ACTIONS(603),
    [anon_sym_DASHicontains] = ACTIONS(603),
    [anon_sym_DASHieq] = ACTIONS(603),
    [anon_sym_DASHige] = ACTIONS(603),
    [anon_sym_DASHigt] = ACTIONS(603),
    [anon_sym_DASHile] = ACTIONS(603),
    [anon_sym_DASHilike] = ACTIONS(603),
    [anon_sym_DASHilt] = ACTIONS(603),
    [anon_sym_DASHimatch] = ACTIONS(603),
    [anon_sym_DASHin] = ACTIONS(605),
    [anon_sym_DASHine] = ACTIONS(603),
    [anon_sym_DASHinotcontains] = ACTIONS(603),
    [anon_sym_DASHinotlike] = ACTIONS(603),
    [anon_sym_DASHinotmatch] = ACTIONS(603),
    [anon_sym_DASHireplace] = ACTIONS(603),
    [anon_sym_DASHis] = ACTIONS(605),
    [anon_sym_DASHisnot] = ACTIONS(603),
    [anon_sym_DASHisplit] = ACTIONS(603),
    [anon_sym_DASHjoin] = ACTIONS(603),
    [anon_sym_DASHle] = ACTIONS(603),
    [anon_sym_DASHlike] = ACTIONS(603),
    [anon_sym_DASHlt] = ACTIONS(603),
    [anon_sym_DASHmatch] = ACTIONS(603),
    [anon_sym_DASHne] = ACTIONS(603),
    [anon_sym_DASHnotcontains] = ACTIONS(603),
    [anon_sym_DASHnotin] = ACTIONS(603),
    [anon_sym_DASHnotlike] = ACTIONS(603),
    [anon_sym_DASHnotmatch] = ACTIONS(603),
    [anon_sym_DASHreplace] = ACTIONS(603),
    [anon_sym_DASHshl] = ACTIONS(603),
    [anon_sym_DASHshr] = ACTIONS(603),
    [anon_sym_DASHsplit] = ACTIONS(603),
    [sym_format_operator] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(603),
    [anon_sym_COMMA] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(603),
    [anon_sym_PIPE] = ACTIONS(603),
    [anon_sym_PERCENT] = ACTIONS(605),
    [anon_sym_DASHand] = ACTIONS(603),
    [anon_sym_DASHor] = ACTIONS(603),
    [anon_sym_DASHxor] = ACTIONS(603),
    [anon_sym_DASHband] = ACTIONS(603),
    [anon_sym_DASHbor] = ACTIONS(603),
    [anon_sym_DASHbxor] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(605),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(605),
    [anon_sym_BSLASH] = ACTIONS(603),
    [anon_sym_STAR] = ACTIONS(605),
    [anon_sym_DOT_DOT] = ACTIONS(603),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_DOT2] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(603),
    [anon_sym_DOTforeach] = ACTIONS(603),
    [sym__statement_terminator] = ACTIONS(603),
  },
  [95] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(633),
    [anon_sym_EQ] = ACTIONS(633),
    [anon_sym_BANG_EQ] = ACTIONS(633),
    [anon_sym_PLUS_EQ] = ACTIONS(633),
    [anon_sym_STAR_EQ] = ACTIONS(633),
    [anon_sym_SLASH_EQ] = ACTIONS(633),
    [anon_sym_PERCENT_EQ] = ACTIONS(633),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_2_GT] = ACTIONS(635),
    [anon_sym_2_GT_GT] = ACTIONS(633),
    [anon_sym_3_GT] = ACTIONS(635),
    [anon_sym_3_GT_GT] = ACTIONS(633),
    [anon_sym_4_GT] = ACTIONS(635),
    [anon_sym_4_GT_GT] = ACTIONS(633),
    [anon_sym_5_GT] = ACTIONS(635),
    [anon_sym_5_GT_GT] = ACTIONS(633),
    [anon_sym_6_GT] = ACTIONS(635),
    [anon_sym_6_GT_GT] = ACTIONS(633),
    [anon_sym_STAR_GT] = ACTIONS(635),
    [anon_sym_STAR_GT_GT] = ACTIONS(633),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(633),
    [anon_sym_2_GT_AMP1] = ACTIONS(633),
    [anon_sym_3_GT_AMP1] = ACTIONS(633),
    [anon_sym_4_GT_AMP1] = ACTIONS(633),
    [anon_sym_5_GT_AMP1] = ACTIONS(633),
    [anon_sym_6_GT_AMP1] = ACTIONS(633),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(633),
    [anon_sym_1_GT_AMP2] = ACTIONS(633),
    [anon_sym_3_GT_AMP2] = ACTIONS(633),
    [anon_sym_4_GT_AMP2] = ACTIONS(633),
    [anon_sym_5_GT_AMP2] = ACTIONS(633),
    [anon_sym_6_GT_AMP2] = ACTIONS(633),
    [anon_sym_DASHas] = ACTIONS(633),
    [anon_sym_DASHccontains] = ACTIONS(633),
    [anon_sym_DASHceq] = ACTIONS(633),
    [anon_sym_DASHcge] = ACTIONS(633),
    [anon_sym_DASHcgt] = ACTIONS(633),
    [anon_sym_DASHcle] = ACTIONS(633),
    [anon_sym_DASHclike] = ACTIONS(633),
    [anon_sym_DASHclt] = ACTIONS(633),
    [anon_sym_DASHcmatch] = ACTIONS(633),
    [anon_sym_DASHcne] = ACTIONS(633),
    [anon_sym_DASHcnotcontains] = ACTIONS(633),
    [anon_sym_DASHcnotlike] = ACTIONS(633),
    [anon_sym_DASHcnotmatch] = ACTIONS(633),
    [anon_sym_DASHcontains] = ACTIONS(633),
    [anon_sym_DASHcreplace] = ACTIONS(633),
    [anon_sym_DASHcsplit] = ACTIONS(633),
    [anon_sym_DASHeq] = ACTIONS(633),
    [anon_sym_DASHge] = ACTIONS(633),
    [anon_sym_DASHgt] = ACTIONS(633),
    [anon_sym_DASHicontains] = ACTIONS(633),
    [anon_sym_DASHieq] = ACTIONS(633),
    [anon_sym_DASHige] = ACTIONS(633),
    [anon_sym_DASHigt] = ACTIONS(633),
    [anon_sym_DASHile] = ACTIONS(633),
    [anon_sym_DASHilike] = ACTIONS(633),
    [anon_sym_DASHilt] = ACTIONS(633),
    [anon_sym_DASHimatch] = ACTIONS(633),
    [anon_sym_DASHin] = ACTIONS(635),
    [anon_sym_DASHine] = ACTIONS(633),
    [anon_sym_DASHinotcontains] = ACTIONS(633),
    [anon_sym_DASHinotlike] = ACTIONS(633),
    [anon_sym_DASHinotmatch] = ACTIONS(633),
    [anon_sym_DASHireplace] = ACTIONS(633),
    [anon_sym_DASHis] = ACTIONS(635),
    [anon_sym_DASHisnot] = ACTIONS(633),
    [anon_sym_DASHisplit] = ACTIONS(633),
    [anon_sym_DASHjoin] = ACTIONS(633),
    [anon_sym_DASHle] = ACTIONS(633),
    [anon_sym_DASHlike] = ACTIONS(633),
    [anon_sym_DASHlt] = ACTIONS(633),
    [anon_sym_DASHmatch] = ACTIONS(633),
    [anon_sym_DASHne] = ACTIONS(633),
    [anon_sym_DASHnotcontains] = ACTIONS(633),
    [anon_sym_DASHnotin] = ACTIONS(633),
    [anon_sym_DASHnotlike] = ACTIONS(633),
    [anon_sym_DASHnotmatch] = ACTIONS(633),
    [anon_sym_DASHreplace] = ACTIONS(633),
    [anon_sym_DASHshl] = ACTIONS(633),
    [anon_sym_DASHshr] = ACTIONS(633),
    [anon_sym_DASHsplit] = ACTIONS(633),
    [sym_format_operator] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_RPAREN] = ACTIONS(633),
    [anon_sym_COMMA] = ACTIONS(633),
    [anon_sym_PIPE] = ACTIONS(633),
    [anon_sym_PERCENT] = ACTIONS(635),
    [anon_sym_DASHand] = ACTIONS(633),
    [anon_sym_DASHor] = ACTIONS(633),
    [anon_sym_DASHxor] = ACTIONS(633),
    [anon_sym_DASHband] = ACTIONS(633),
    [anon_sym_DASHbor] = ACTIONS(633),
    [anon_sym_DASHbxor] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(635),
    [anon_sym_DASH] = ACTIONS(635),
    [anon_sym_SLASH] = ACTIONS(635),
    [anon_sym_BSLASH] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_DOT_DOT] = ACTIONS(633),
    [anon_sym_PLUS_PLUS] = ACTIONS(633),
    [anon_sym_DASH_DASH] = ACTIONS(633),
    [anon_sym_DOT2] = ACTIONS(635),
    [anon_sym_COLON_COLON] = ACTIONS(633),
    [anon_sym_RBRACK] = ACTIONS(633),
    [anon_sym_DOTforeach] = ACTIONS(633),
  },
  [96] = {
    [sym_argument_list] = STATE(154),
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(591),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_BANG_EQ] = ACTIONS(591),
    [anon_sym_PLUS_EQ] = ACTIONS(591),
    [anon_sym_STAR_EQ] = ACTIONS(591),
    [anon_sym_SLASH_EQ] = ACTIONS(591),
    [anon_sym_PERCENT_EQ] = ACTIONS(591),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_GT_GT] = ACTIONS(591),
    [anon_sym_2_GT] = ACTIONS(593),
    [anon_sym_2_GT_GT] = ACTIONS(591),
    [anon_sym_3_GT] = ACTIONS(593),
    [anon_sym_3_GT_GT] = ACTIONS(591),
    [anon_sym_4_GT] = ACTIONS(593),
    [anon_sym_4_GT_GT] = ACTIONS(591),
    [anon_sym_5_GT] = ACTIONS(593),
    [anon_sym_5_GT_GT] = ACTIONS(591),
    [anon_sym_6_GT] = ACTIONS(593),
    [anon_sym_6_GT_GT] = ACTIONS(591),
    [anon_sym_STAR_GT] = ACTIONS(593),
    [anon_sym_STAR_GT_GT] = ACTIONS(591),
    [anon_sym_LT] = ACTIONS(593),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(591),
    [anon_sym_2_GT_AMP1] = ACTIONS(591),
    [anon_sym_3_GT_AMP1] = ACTIONS(591),
    [anon_sym_4_GT_AMP1] = ACTIONS(591),
    [anon_sym_5_GT_AMP1] = ACTIONS(591),
    [anon_sym_6_GT_AMP1] = ACTIONS(591),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(591),
    [anon_sym_1_GT_AMP2] = ACTIONS(591),
    [anon_sym_3_GT_AMP2] = ACTIONS(591),
    [anon_sym_4_GT_AMP2] = ACTIONS(591),
    [anon_sym_5_GT_AMP2] = ACTIONS(591),
    [anon_sym_6_GT_AMP2] = ACTIONS(591),
    [anon_sym_DASHas] = ACTIONS(591),
    [anon_sym_DASHccontains] = ACTIONS(591),
    [anon_sym_DASHceq] = ACTIONS(591),
    [anon_sym_DASHcge] = ACTIONS(591),
    [anon_sym_DASHcgt] = ACTIONS(591),
    [anon_sym_DASHcle] = ACTIONS(591),
    [anon_sym_DASHclike] = ACTIONS(591),
    [anon_sym_DASHclt] = ACTIONS(591),
    [anon_sym_DASHcmatch] = ACTIONS(591),
    [anon_sym_DASHcne] = ACTIONS(591),
    [anon_sym_DASHcnotcontains] = ACTIONS(591),
    [anon_sym_DASHcnotlike] = ACTIONS(591),
    [anon_sym_DASHcnotmatch] = ACTIONS(591),
    [anon_sym_DASHcontains] = ACTIONS(591),
    [anon_sym_DASHcreplace] = ACTIONS(591),
    [anon_sym_DASHcsplit] = ACTIONS(591),
    [anon_sym_DASHeq] = ACTIONS(591),
    [anon_sym_DASHge] = ACTIONS(591),
    [anon_sym_DASHgt] = ACTIONS(591),
    [anon_sym_DASHicontains] = ACTIONS(591),
    [anon_sym_DASHieq] = ACTIONS(591),
    [anon_sym_DASHige] = ACTIONS(591),
    [anon_sym_DASHigt] = ACTIONS(591),
    [anon_sym_DASHile] = ACTIONS(591),
    [anon_sym_DASHilike] = ACTIONS(591),
    [anon_sym_DASHilt] = ACTIONS(591),
    [anon_sym_DASHimatch] = ACTIONS(591),
    [anon_sym_DASHin] = ACTIONS(593),
    [anon_sym_DASHine] = ACTIONS(591),
    [anon_sym_DASHinotcontains] = ACTIONS(591),
    [anon_sym_DASHinotlike] = ACTIONS(591),
    [anon_sym_DASHinotmatch] = ACTIONS(591),
    [anon_sym_DASHireplace] = ACTIONS(591),
    [anon_sym_DASHis] = ACTIONS(593),
    [anon_sym_DASHisnot] = ACTIONS(591),
    [anon_sym_DASHisplit] = ACTIONS(591),
    [anon_sym_DASHjoin] = ACTIONS(591),
    [anon_sym_DASHle] = ACTIONS(591),
    [anon_sym_DASHlike] = ACTIONS(591),
    [anon_sym_DASHlt] = ACTIONS(591),
    [anon_sym_DASHmatch] = ACTIONS(591),
    [anon_sym_DASHne] = ACTIONS(591),
    [anon_sym_DASHnotcontains] = ACTIONS(591),
    [anon_sym_DASHnotin] = ACTIONS(591),
    [anon_sym_DASHnotlike] = ACTIONS(591),
    [anon_sym_DASHnotmatch] = ACTIONS(591),
    [anon_sym_DASHreplace] = ACTIONS(591),
    [anon_sym_DASHshl] = ACTIONS(591),
    [anon_sym_DASHshr] = ACTIONS(591),
    [anon_sym_DASHsplit] = ACTIONS(591),
    [sym_format_operator] = ACTIONS(591),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_COMMA] = ACTIONS(591),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PERCENT] = ACTIONS(593),
    [anon_sym_DASHand] = ACTIONS(591),
    [anon_sym_DASHor] = ACTIONS(591),
    [anon_sym_DASHxor] = ACTIONS(591),
    [anon_sym_DASHband] = ACTIONS(591),
    [anon_sym_DASHbor] = ACTIONS(591),
    [anon_sym_DASHbxor] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(593),
    [anon_sym_DASH] = ACTIONS(593),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_BSLASH] = ACTIONS(591),
    [anon_sym_STAR] = ACTIONS(593),
    [anon_sym_DOT_DOT] = ACTIONS(591),
    [anon_sym_PLUS_PLUS] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(591),
    [anon_sym_DOT2] = ACTIONS(593),
    [anon_sym_COLON_COLON] = ACTIONS(591),
    [anon_sym_DOTforeach] = ACTIONS(591),
    [sym__statement_terminator] = ACTIONS(591),
  },
  [97] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_EQ] = ACTIONS(639),
    [anon_sym_BANG_EQ] = ACTIONS(639),
    [anon_sym_PLUS_EQ] = ACTIONS(639),
    [anon_sym_STAR_EQ] = ACTIONS(639),
    [anon_sym_SLASH_EQ] = ACTIONS(639),
    [anon_sym_PERCENT_EQ] = ACTIONS(639),
    [anon_sym_GT] = ACTIONS(641),
    [anon_sym_GT_GT] = ACTIONS(639),
    [anon_sym_2_GT] = ACTIONS(641),
    [anon_sym_2_GT_GT] = ACTIONS(639),
    [anon_sym_3_GT] = ACTIONS(641),
    [anon_sym_3_GT_GT] = ACTIONS(639),
    [anon_sym_4_GT] = ACTIONS(641),
    [anon_sym_4_GT_GT] = ACTIONS(639),
    [anon_sym_5_GT] = ACTIONS(641),
    [anon_sym_5_GT_GT] = ACTIONS(639),
    [anon_sym_6_GT] = ACTIONS(641),
    [anon_sym_6_GT_GT] = ACTIONS(639),
    [anon_sym_STAR_GT] = ACTIONS(641),
    [anon_sym_STAR_GT_GT] = ACTIONS(639),
    [anon_sym_LT] = ACTIONS(641),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(639),
    [anon_sym_2_GT_AMP1] = ACTIONS(639),
    [anon_sym_3_GT_AMP1] = ACTIONS(639),
    [anon_sym_4_GT_AMP1] = ACTIONS(639),
    [anon_sym_5_GT_AMP1] = ACTIONS(639),
    [anon_sym_6_GT_AMP1] = ACTIONS(639),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(639),
    [anon_sym_1_GT_AMP2] = ACTIONS(639),
    [anon_sym_3_GT_AMP2] = ACTIONS(639),
    [anon_sym_4_GT_AMP2] = ACTIONS(639),
    [anon_sym_5_GT_AMP2] = ACTIONS(639),
    [anon_sym_6_GT_AMP2] = ACTIONS(639),
    [anon_sym_DASHas] = ACTIONS(639),
    [anon_sym_DASHccontains] = ACTIONS(639),
    [anon_sym_DASHceq] = ACTIONS(639),
    [anon_sym_DASHcge] = ACTIONS(639),
    [anon_sym_DASHcgt] = ACTIONS(639),
    [anon_sym_DASHcle] = ACTIONS(639),
    [anon_sym_DASHclike] = ACTIONS(639),
    [anon_sym_DASHclt] = ACTIONS(639),
    [anon_sym_DASHcmatch] = ACTIONS(639),
    [anon_sym_DASHcne] = ACTIONS(639),
    [anon_sym_DASHcnotcontains] = ACTIONS(639),
    [anon_sym_DASHcnotlike] = ACTIONS(639),
    [anon_sym_DASHcnotmatch] = ACTIONS(639),
    [anon_sym_DASHcontains] = ACTIONS(639),
    [anon_sym_DASHcreplace] = ACTIONS(639),
    [anon_sym_DASHcsplit] = ACTIONS(639),
    [anon_sym_DASHeq] = ACTIONS(639),
    [anon_sym_DASHge] = ACTIONS(639),
    [anon_sym_DASHgt] = ACTIONS(639),
    [anon_sym_DASHicontains] = ACTIONS(639),
    [anon_sym_DASHieq] = ACTIONS(639),
    [anon_sym_DASHige] = ACTIONS(639),
    [anon_sym_DASHigt] = ACTIONS(639),
    [anon_sym_DASHile] = ACTIONS(639),
    [anon_sym_DASHilike] = ACTIONS(639),
    [anon_sym_DASHilt] = ACTIONS(639),
    [anon_sym_DASHimatch] = ACTIONS(639),
    [anon_sym_DASHin] = ACTIONS(641),
    [anon_sym_DASHine] = ACTIONS(639),
    [anon_sym_DASHinotcontains] = ACTIONS(639),
    [anon_sym_DASHinotlike] = ACTIONS(639),
    [anon_sym_DASHinotmatch] = ACTIONS(639),
    [anon_sym_DASHireplace] = ACTIONS(639),
    [anon_sym_DASHis] = ACTIONS(641),
    [anon_sym_DASHisnot] = ACTIONS(639),
    [anon_sym_DASHisplit] = ACTIONS(639),
    [anon_sym_DASHjoin] = ACTIONS(639),
    [anon_sym_DASHle] = ACTIONS(639),
    [anon_sym_DASHlike] = ACTIONS(639),
    [anon_sym_DASHlt] = ACTIONS(639),
    [anon_sym_DASHmatch] = ACTIONS(639),
    [anon_sym_DASHne] = ACTIONS(639),
    [anon_sym_DASHnotcontains] = ACTIONS(639),
    [anon_sym_DASHnotin] = ACTIONS(639),
    [anon_sym_DASHnotlike] = ACTIONS(639),
    [anon_sym_DASHnotmatch] = ACTIONS(639),
    [anon_sym_DASHreplace] = ACTIONS(639),
    [anon_sym_DASHshl] = ACTIONS(639),
    [anon_sym_DASHshr] = ACTIONS(639),
    [anon_sym_DASHsplit] = ACTIONS(639),
    [sym_format_operator] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_RPAREN] = ACTIONS(639),
    [anon_sym_COMMA] = ACTIONS(639),
    [anon_sym_PIPE] = ACTIONS(639),
    [anon_sym_PERCENT] = ACTIONS(641),
    [anon_sym_DASHand] = ACTIONS(639),
    [anon_sym_DASHor] = ACTIONS(639),
    [anon_sym_DASHxor] = ACTIONS(639),
    [anon_sym_DASHband] = ACTIONS(639),
    [anon_sym_DASHbor] = ACTIONS(639),
    [anon_sym_DASHbxor] = ACTIONS(639),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_DASH] = ACTIONS(641),
    [anon_sym_SLASH] = ACTIONS(641),
    [anon_sym_BSLASH] = ACTIONS(639),
    [anon_sym_STAR] = ACTIONS(641),
    [anon_sym_DOT_DOT] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(639),
    [anon_sym_DASH_DASH] = ACTIONS(639),
    [anon_sym_DOT2] = ACTIONS(641),
    [anon_sym_COLON_COLON] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(639),
    [anon_sym_DOTforeach] = ACTIONS(639),
  },
  [98] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_EQ] = ACTIONS(643),
    [anon_sym_BANG_EQ] = ACTIONS(643),
    [anon_sym_PLUS_EQ] = ACTIONS(643),
    [anon_sym_STAR_EQ] = ACTIONS(643),
    [anon_sym_SLASH_EQ] = ACTIONS(643),
    [anon_sym_PERCENT_EQ] = ACTIONS(643),
    [anon_sym_GT] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(643),
    [anon_sym_2_GT] = ACTIONS(645),
    [anon_sym_2_GT_GT] = ACTIONS(643),
    [anon_sym_3_GT] = ACTIONS(645),
    [anon_sym_3_GT_GT] = ACTIONS(643),
    [anon_sym_4_GT] = ACTIONS(645),
    [anon_sym_4_GT_GT] = ACTIONS(643),
    [anon_sym_5_GT] = ACTIONS(645),
    [anon_sym_5_GT_GT] = ACTIONS(643),
    [anon_sym_6_GT] = ACTIONS(645),
    [anon_sym_6_GT_GT] = ACTIONS(643),
    [anon_sym_STAR_GT] = ACTIONS(645),
    [anon_sym_STAR_GT_GT] = ACTIONS(643),
    [anon_sym_LT] = ACTIONS(645),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(643),
    [anon_sym_2_GT_AMP1] = ACTIONS(643),
    [anon_sym_3_GT_AMP1] = ACTIONS(643),
    [anon_sym_4_GT_AMP1] = ACTIONS(643),
    [anon_sym_5_GT_AMP1] = ACTIONS(643),
    [anon_sym_6_GT_AMP1] = ACTIONS(643),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(643),
    [anon_sym_1_GT_AMP2] = ACTIONS(643),
    [anon_sym_3_GT_AMP2] = ACTIONS(643),
    [anon_sym_4_GT_AMP2] = ACTIONS(643),
    [anon_sym_5_GT_AMP2] = ACTIONS(643),
    [anon_sym_6_GT_AMP2] = ACTIONS(643),
    [anon_sym_DASHas] = ACTIONS(643),
    [anon_sym_DASHccontains] = ACTIONS(643),
    [anon_sym_DASHceq] = ACTIONS(643),
    [anon_sym_DASHcge] = ACTIONS(643),
    [anon_sym_DASHcgt] = ACTIONS(643),
    [anon_sym_DASHcle] = ACTIONS(643),
    [anon_sym_DASHclike] = ACTIONS(643),
    [anon_sym_DASHclt] = ACTIONS(643),
    [anon_sym_DASHcmatch] = ACTIONS(643),
    [anon_sym_DASHcne] = ACTIONS(643),
    [anon_sym_DASHcnotcontains] = ACTIONS(643),
    [anon_sym_DASHcnotlike] = ACTIONS(643),
    [anon_sym_DASHcnotmatch] = ACTIONS(643),
    [anon_sym_DASHcontains] = ACTIONS(643),
    [anon_sym_DASHcreplace] = ACTIONS(643),
    [anon_sym_DASHcsplit] = ACTIONS(643),
    [anon_sym_DASHeq] = ACTIONS(643),
    [anon_sym_DASHge] = ACTIONS(643),
    [anon_sym_DASHgt] = ACTIONS(643),
    [anon_sym_DASHicontains] = ACTIONS(643),
    [anon_sym_DASHieq] = ACTIONS(643),
    [anon_sym_DASHige] = ACTIONS(643),
    [anon_sym_DASHigt] = ACTIONS(643),
    [anon_sym_DASHile] = ACTIONS(643),
    [anon_sym_DASHilike] = ACTIONS(643),
    [anon_sym_DASHilt] = ACTIONS(643),
    [anon_sym_DASHimatch] = ACTIONS(643),
    [anon_sym_DASHin] = ACTIONS(645),
    [anon_sym_DASHine] = ACTIONS(643),
    [anon_sym_DASHinotcontains] = ACTIONS(643),
    [anon_sym_DASHinotlike] = ACTIONS(643),
    [anon_sym_DASHinotmatch] = ACTIONS(643),
    [anon_sym_DASHireplace] = ACTIONS(643),
    [anon_sym_DASHis] = ACTIONS(645),
    [anon_sym_DASHisnot] = ACTIONS(643),
    [anon_sym_DASHisplit] = ACTIONS(643),
    [anon_sym_DASHjoin] = ACTIONS(643),
    [anon_sym_DASHle] = ACTIONS(643),
    [anon_sym_DASHlike] = ACTIONS(643),
    [anon_sym_DASHlt] = ACTIONS(643),
    [anon_sym_DASHmatch] = ACTIONS(643),
    [anon_sym_DASHne] = ACTIONS(643),
    [anon_sym_DASHnotcontains] = ACTIONS(643),
    [anon_sym_DASHnotin] = ACTIONS(643),
    [anon_sym_DASHnotlike] = ACTIONS(643),
    [anon_sym_DASHnotmatch] = ACTIONS(643),
    [anon_sym_DASHreplace] = ACTIONS(643),
    [anon_sym_DASHshl] = ACTIONS(643),
    [anon_sym_DASHshr] = ACTIONS(643),
    [anon_sym_DASHsplit] = ACTIONS(643),
    [sym_format_operator] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(643),
    [anon_sym_RPAREN] = ACTIONS(643),
    [anon_sym_COMMA] = ACTIONS(643),
    [anon_sym_PIPE] = ACTIONS(643),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_DASHand] = ACTIONS(643),
    [anon_sym_DASHor] = ACTIONS(643),
    [anon_sym_DASHxor] = ACTIONS(643),
    [anon_sym_DASHband] = ACTIONS(643),
    [anon_sym_DASHbor] = ACTIONS(643),
    [anon_sym_DASHbxor] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(645),
    [anon_sym_SLASH] = ACTIONS(645),
    [anon_sym_BSLASH] = ACTIONS(643),
    [anon_sym_STAR] = ACTIONS(645),
    [anon_sym_DOT_DOT] = ACTIONS(643),
    [anon_sym_PLUS_PLUS] = ACTIONS(643),
    [anon_sym_DASH_DASH] = ACTIONS(643),
    [anon_sym_DOT2] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(643),
    [anon_sym_RBRACK] = ACTIONS(643),
    [anon_sym_DOTforeach] = ACTIONS(643),
  },
  [99] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(647),
    [anon_sym_EQ] = ACTIONS(647),
    [anon_sym_BANG_EQ] = ACTIONS(647),
    [anon_sym_PLUS_EQ] = ACTIONS(647),
    [anon_sym_STAR_EQ] = ACTIONS(647),
    [anon_sym_SLASH_EQ] = ACTIONS(647),
    [anon_sym_PERCENT_EQ] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(649),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_2_GT] = ACTIONS(649),
    [anon_sym_2_GT_GT] = ACTIONS(647),
    [anon_sym_3_GT] = ACTIONS(649),
    [anon_sym_3_GT_GT] = ACTIONS(647),
    [anon_sym_4_GT] = ACTIONS(649),
    [anon_sym_4_GT_GT] = ACTIONS(647),
    [anon_sym_5_GT] = ACTIONS(649),
    [anon_sym_5_GT_GT] = ACTIONS(647),
    [anon_sym_6_GT] = ACTIONS(649),
    [anon_sym_6_GT_GT] = ACTIONS(647),
    [anon_sym_STAR_GT] = ACTIONS(649),
    [anon_sym_STAR_GT_GT] = ACTIONS(647),
    [anon_sym_LT] = ACTIONS(649),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(647),
    [anon_sym_2_GT_AMP1] = ACTIONS(647),
    [anon_sym_3_GT_AMP1] = ACTIONS(647),
    [anon_sym_4_GT_AMP1] = ACTIONS(647),
    [anon_sym_5_GT_AMP1] = ACTIONS(647),
    [anon_sym_6_GT_AMP1] = ACTIONS(647),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(647),
    [anon_sym_1_GT_AMP2] = ACTIONS(647),
    [anon_sym_3_GT_AMP2] = ACTIONS(647),
    [anon_sym_4_GT_AMP2] = ACTIONS(647),
    [anon_sym_5_GT_AMP2] = ACTIONS(647),
    [anon_sym_6_GT_AMP2] = ACTIONS(647),
    [anon_sym_DASHas] = ACTIONS(647),
    [anon_sym_DASHccontains] = ACTIONS(647),
    [anon_sym_DASHceq] = ACTIONS(647),
    [anon_sym_DASHcge] = ACTIONS(647),
    [anon_sym_DASHcgt] = ACTIONS(647),
    [anon_sym_DASHcle] = ACTIONS(647),
    [anon_sym_DASHclike] = ACTIONS(647),
    [anon_sym_DASHclt] = ACTIONS(647),
    [anon_sym_DASHcmatch] = ACTIONS(647),
    [anon_sym_DASHcne] = ACTIONS(647),
    [anon_sym_DASHcnotcontains] = ACTIONS(647),
    [anon_sym_DASHcnotlike] = ACTIONS(647),
    [anon_sym_DASHcnotmatch] = ACTIONS(647),
    [anon_sym_DASHcontains] = ACTIONS(647),
    [anon_sym_DASHcreplace] = ACTIONS(647),
    [anon_sym_DASHcsplit] = ACTIONS(647),
    [anon_sym_DASHeq] = ACTIONS(647),
    [anon_sym_DASHge] = ACTIONS(647),
    [anon_sym_DASHgt] = ACTIONS(647),
    [anon_sym_DASHicontains] = ACTIONS(647),
    [anon_sym_DASHieq] = ACTIONS(647),
    [anon_sym_DASHige] = ACTIONS(647),
    [anon_sym_DASHigt] = ACTIONS(647),
    [anon_sym_DASHile] = ACTIONS(647),
    [anon_sym_DASHilike] = ACTIONS(647),
    [anon_sym_DASHilt] = ACTIONS(647),
    [anon_sym_DASHimatch] = ACTIONS(647),
    [anon_sym_DASHin] = ACTIONS(649),
    [anon_sym_DASHine] = ACTIONS(647),
    [anon_sym_DASHinotcontains] = ACTIONS(647),
    [anon_sym_DASHinotlike] = ACTIONS(647),
    [anon_sym_DASHinotmatch] = ACTIONS(647),
    [anon_sym_DASHireplace] = ACTIONS(647),
    [anon_sym_DASHis] = ACTIONS(649),
    [anon_sym_DASHisnot] = ACTIONS(647),
    [anon_sym_DASHisplit] = ACTIONS(647),
    [anon_sym_DASHjoin] = ACTIONS(647),
    [anon_sym_DASHle] = ACTIONS(647),
    [anon_sym_DASHlike] = ACTIONS(647),
    [anon_sym_DASHlt] = ACTIONS(647),
    [anon_sym_DASHmatch] = ACTIONS(647),
    [anon_sym_DASHne] = ACTIONS(647),
    [anon_sym_DASHnotcontains] = ACTIONS(647),
    [anon_sym_DASHnotin] = ACTIONS(647),
    [anon_sym_DASHnotlike] = ACTIONS(647),
    [anon_sym_DASHnotmatch] = ACTIONS(647),
    [anon_sym_DASHreplace] = ACTIONS(647),
    [anon_sym_DASHshl] = ACTIONS(647),
    [anon_sym_DASHshr] = ACTIONS(647),
    [anon_sym_DASHsplit] = ACTIONS(647),
    [sym_format_operator] = ACTIONS(647),
    [anon_sym_LPAREN] = ACTIONS(647),
    [anon_sym_RPAREN] = ACTIONS(647),
    [anon_sym_COMMA] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(649),
    [anon_sym_DASHand] = ACTIONS(647),
    [anon_sym_DASHor] = ACTIONS(647),
    [anon_sym_DASHxor] = ACTIONS(647),
    [anon_sym_DASHband] = ACTIONS(647),
    [anon_sym_DASHbor] = ACTIONS(647),
    [anon_sym_DASHbxor] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(649),
    [anon_sym_DASH] = ACTIONS(649),
    [anon_sym_SLASH] = ACTIONS(649),
    [anon_sym_BSLASH] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(649),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [anon_sym_PLUS_PLUS] = ACTIONS(647),
    [anon_sym_DASH_DASH] = ACTIONS(647),
    [anon_sym_DOT2] = ACTIONS(649),
    [anon_sym_COLON_COLON] = ACTIONS(647),
    [anon_sym_RBRACK] = ACTIONS(647),
    [anon_sym_DOTforeach] = ACTIONS(647),
  },
  [100] = {
    [sym_argument_list] = STATE(154),
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(591),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_BANG_EQ] = ACTIONS(591),
    [anon_sym_PLUS_EQ] = ACTIONS(591),
    [anon_sym_STAR_EQ] = ACTIONS(591),
    [anon_sym_SLASH_EQ] = ACTIONS(591),
    [anon_sym_PERCENT_EQ] = ACTIONS(591),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_GT_GT] = ACTIONS(591),
    [anon_sym_2_GT] = ACTIONS(593),
    [anon_sym_2_GT_GT] = ACTIONS(591),
    [anon_sym_3_GT] = ACTIONS(593),
    [anon_sym_3_GT_GT] = ACTIONS(591),
    [anon_sym_4_GT] = ACTIONS(593),
    [anon_sym_4_GT_GT] = ACTIONS(591),
    [anon_sym_5_GT] = ACTIONS(593),
    [anon_sym_5_GT_GT] = ACTIONS(591),
    [anon_sym_6_GT] = ACTIONS(593),
    [anon_sym_6_GT_GT] = ACTIONS(591),
    [anon_sym_STAR_GT] = ACTIONS(593),
    [anon_sym_STAR_GT_GT] = ACTIONS(591),
    [anon_sym_LT] = ACTIONS(593),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(591),
    [anon_sym_2_GT_AMP1] = ACTIONS(591),
    [anon_sym_3_GT_AMP1] = ACTIONS(591),
    [anon_sym_4_GT_AMP1] = ACTIONS(591),
    [anon_sym_5_GT_AMP1] = ACTIONS(591),
    [anon_sym_6_GT_AMP1] = ACTIONS(591),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(591),
    [anon_sym_1_GT_AMP2] = ACTIONS(591),
    [anon_sym_3_GT_AMP2] = ACTIONS(591),
    [anon_sym_4_GT_AMP2] = ACTIONS(591),
    [anon_sym_5_GT_AMP2] = ACTIONS(591),
    [anon_sym_6_GT_AMP2] = ACTIONS(591),
    [anon_sym_DASHas] = ACTIONS(591),
    [anon_sym_DASHccontains] = ACTIONS(591),
    [anon_sym_DASHceq] = ACTIONS(591),
    [anon_sym_DASHcge] = ACTIONS(591),
    [anon_sym_DASHcgt] = ACTIONS(591),
    [anon_sym_DASHcle] = ACTIONS(591),
    [anon_sym_DASHclike] = ACTIONS(591),
    [anon_sym_DASHclt] = ACTIONS(591),
    [anon_sym_DASHcmatch] = ACTIONS(591),
    [anon_sym_DASHcne] = ACTIONS(591),
    [anon_sym_DASHcnotcontains] = ACTIONS(591),
    [anon_sym_DASHcnotlike] = ACTIONS(591),
    [anon_sym_DASHcnotmatch] = ACTIONS(591),
    [anon_sym_DASHcontains] = ACTIONS(591),
    [anon_sym_DASHcreplace] = ACTIONS(591),
    [anon_sym_DASHcsplit] = ACTIONS(591),
    [anon_sym_DASHeq] = ACTIONS(591),
    [anon_sym_DASHge] = ACTIONS(591),
    [anon_sym_DASHgt] = ACTIONS(591),
    [anon_sym_DASHicontains] = ACTIONS(591),
    [anon_sym_DASHieq] = ACTIONS(591),
    [anon_sym_DASHige] = ACTIONS(591),
    [anon_sym_DASHigt] = ACTIONS(591),
    [anon_sym_DASHile] = ACTIONS(591),
    [anon_sym_DASHilike] = ACTIONS(591),
    [anon_sym_DASHilt] = ACTIONS(591),
    [anon_sym_DASHimatch] = ACTIONS(591),
    [anon_sym_DASHin] = ACTIONS(593),
    [anon_sym_DASHine] = ACTIONS(591),
    [anon_sym_DASHinotcontains] = ACTIONS(591),
    [anon_sym_DASHinotlike] = ACTIONS(591),
    [anon_sym_DASHinotmatch] = ACTIONS(591),
    [anon_sym_DASHireplace] = ACTIONS(591),
    [anon_sym_DASHis] = ACTIONS(593),
    [anon_sym_DASHisnot] = ACTIONS(591),
    [anon_sym_DASHisplit] = ACTIONS(591),
    [anon_sym_DASHjoin] = ACTIONS(591),
    [anon_sym_DASHle] = ACTIONS(591),
    [anon_sym_DASHlike] = ACTIONS(591),
    [anon_sym_DASHlt] = ACTIONS(591),
    [anon_sym_DASHmatch] = ACTIONS(591),
    [anon_sym_DASHne] = ACTIONS(591),
    [anon_sym_DASHnotcontains] = ACTIONS(591),
    [anon_sym_DASHnotin] = ACTIONS(591),
    [anon_sym_DASHnotlike] = ACTIONS(591),
    [anon_sym_DASHnotmatch] = ACTIONS(591),
    [anon_sym_DASHreplace] = ACTIONS(591),
    [anon_sym_DASHshl] = ACTIONS(591),
    [anon_sym_DASHshr] = ACTIONS(591),
    [anon_sym_DASHsplit] = ACTIONS(591),
    [sym_format_operator] = ACTIONS(591),
    [anon_sym_LPAREN] = ACTIONS(591),
    [anon_sym_COMMA] = ACTIONS(591),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PERCENT] = ACTIONS(593),
    [anon_sym_DASHand] = ACTIONS(591),
    [anon_sym_DASHor] = ACTIONS(591),
    [anon_sym_DASHxor] = ACTIONS(591),
    [anon_sym_DASHband] = ACTIONS(591),
    [anon_sym_DASHbor] = ACTIONS(591),
    [anon_sym_DASHbxor] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(593),
    [anon_sym_DASH] = ACTIONS(593),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_BSLASH] = ACTIONS(591),
    [anon_sym_STAR] = ACTIONS(593),
    [anon_sym_DOT_DOT] = ACTIONS(591),
    [anon_sym_PLUS_PLUS] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(591),
    [anon_sym_DOT2] = ACTIONS(593),
    [anon_sym_COLON_COLON] = ACTIONS(591),
    [anon_sym_DOTforeach] = ACTIONS(591),
    [sym__statement_terminator] = ACTIONS(591),
  },
  [101] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_EQ] = ACTIONS(651),
    [anon_sym_BANG_EQ] = ACTIONS(651),
    [anon_sym_PLUS_EQ] = ACTIONS(651),
    [anon_sym_STAR_EQ] = ACTIONS(651),
    [anon_sym_SLASH_EQ] = ACTIONS(651),
    [anon_sym_PERCENT_EQ] = ACTIONS(651),
    [anon_sym_GT] = ACTIONS(654),
    [anon_sym_GT_GT] = ACTIONS(651),
    [anon_sym_2_GT] = ACTIONS(654),
    [anon_sym_2_GT_GT] = ACTIONS(651),
    [anon_sym_3_GT] = ACTIONS(654),
    [anon_sym_3_GT_GT] = ACTIONS(651),
    [anon_sym_4_GT] = ACTIONS(654),
    [anon_sym_4_GT_GT] = ACTIONS(651),
    [anon_sym_5_GT] = ACTIONS(654),
    [anon_sym_5_GT_GT] = ACTIONS(651),
    [anon_sym_6_GT] = ACTIONS(654),
    [anon_sym_6_GT_GT] = ACTIONS(651),
    [anon_sym_STAR_GT] = ACTIONS(654),
    [anon_sym_STAR_GT_GT] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(654),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(651),
    [anon_sym_2_GT_AMP1] = ACTIONS(651),
    [anon_sym_3_GT_AMP1] = ACTIONS(651),
    [anon_sym_4_GT_AMP1] = ACTIONS(651),
    [anon_sym_5_GT_AMP1] = ACTIONS(651),
    [anon_sym_6_GT_AMP1] = ACTIONS(651),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(651),
    [anon_sym_1_GT_AMP2] = ACTIONS(651),
    [anon_sym_3_GT_AMP2] = ACTIONS(651),
    [anon_sym_4_GT_AMP2] = ACTIONS(651),
    [anon_sym_5_GT_AMP2] = ACTIONS(651),
    [anon_sym_6_GT_AMP2] = ACTIONS(651),
    [anon_sym_DASHas] = ACTIONS(651),
    [anon_sym_DASHccontains] = ACTIONS(651),
    [anon_sym_DASHceq] = ACTIONS(651),
    [anon_sym_DASHcge] = ACTIONS(651),
    [anon_sym_DASHcgt] = ACTIONS(651),
    [anon_sym_DASHcle] = ACTIONS(651),
    [anon_sym_DASHclike] = ACTIONS(651),
    [anon_sym_DASHclt] = ACTIONS(651),
    [anon_sym_DASHcmatch] = ACTIONS(651),
    [anon_sym_DASHcne] = ACTIONS(651),
    [anon_sym_DASHcnotcontains] = ACTIONS(651),
    [anon_sym_DASHcnotlike] = ACTIONS(651),
    [anon_sym_DASHcnotmatch] = ACTIONS(651),
    [anon_sym_DASHcontains] = ACTIONS(651),
    [anon_sym_DASHcreplace] = ACTIONS(651),
    [anon_sym_DASHcsplit] = ACTIONS(651),
    [anon_sym_DASHeq] = ACTIONS(651),
    [anon_sym_DASHge] = ACTIONS(651),
    [anon_sym_DASHgt] = ACTIONS(651),
    [anon_sym_DASHicontains] = ACTIONS(651),
    [anon_sym_DASHieq] = ACTIONS(651),
    [anon_sym_DASHige] = ACTIONS(651),
    [anon_sym_DASHigt] = ACTIONS(651),
    [anon_sym_DASHile] = ACTIONS(651),
    [anon_sym_DASHilike] = ACTIONS(651),
    [anon_sym_DASHilt] = ACTIONS(651),
    [anon_sym_DASHimatch] = ACTIONS(651),
    [anon_sym_DASHin] = ACTIONS(654),
    [anon_sym_DASHine] = ACTIONS(651),
    [anon_sym_DASHinotcontains] = ACTIONS(651),
    [anon_sym_DASHinotlike] = ACTIONS(651),
    [anon_sym_DASHinotmatch] = ACTIONS(651),
    [anon_sym_DASHireplace] = ACTIONS(651),
    [anon_sym_DASHis] = ACTIONS(654),
    [anon_sym_DASHisnot] = ACTIONS(651),
    [anon_sym_DASHisplit] = ACTIONS(651),
    [anon_sym_DASHjoin] = ACTIONS(651),
    [anon_sym_DASHle] = ACTIONS(651),
    [anon_sym_DASHlike] = ACTIONS(651),
    [anon_sym_DASHlt] = ACTIONS(651),
    [anon_sym_DASHmatch] = ACTIONS(651),
    [anon_sym_DASHne] = ACTIONS(651),
    [anon_sym_DASHnotcontains] = ACTIONS(651),
    [anon_sym_DASHnotin] = ACTIONS(651),
    [anon_sym_DASHnotlike] = ACTIONS(651),
    [anon_sym_DASHnotmatch] = ACTIONS(651),
    [anon_sym_DASHreplace] = ACTIONS(651),
    [anon_sym_DASHshl] = ACTIONS(651),
    [anon_sym_DASHshr] = ACTIONS(651),
    [anon_sym_DASHsplit] = ACTIONS(651),
    [sym_format_operator] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(651),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_PIPE] = ACTIONS(651),
    [anon_sym_PERCENT] = ACTIONS(654),
    [anon_sym_DASHand] = ACTIONS(651),
    [anon_sym_DASHor] = ACTIONS(651),
    [anon_sym_DASHxor] = ACTIONS(651),
    [anon_sym_DASHband] = ACTIONS(651),
    [anon_sym_DASHbor] = ACTIONS(651),
    [anon_sym_DASHbxor] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(654),
    [anon_sym_DASH] = ACTIONS(654),
    [anon_sym_SLASH] = ACTIONS(654),
    [anon_sym_BSLASH] = ACTIONS(651),
    [anon_sym_STAR] = ACTIONS(654),
    [anon_sym_DOT_DOT] = ACTIONS(651),
    [anon_sym_PLUS_PLUS] = ACTIONS(651),
    [anon_sym_DASH_DASH] = ACTIONS(651),
    [anon_sym_DOT2] = ACTIONS(654),
    [anon_sym_COLON_COLON] = ACTIONS(651),
    [anon_sym_RBRACK] = ACTIONS(651),
    [anon_sym_DOTforeach] = ACTIONS(651),
  },
  [102] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_EQ] = ACTIONS(657),
    [anon_sym_BANG_EQ] = ACTIONS(657),
    [anon_sym_PLUS_EQ] = ACTIONS(657),
    [anon_sym_STAR_EQ] = ACTIONS(657),
    [anon_sym_SLASH_EQ] = ACTIONS(657),
    [anon_sym_PERCENT_EQ] = ACTIONS(657),
    [anon_sym_GT] = ACTIONS(659),
    [anon_sym_GT_GT] = ACTIONS(657),
    [anon_sym_2_GT] = ACTIONS(659),
    [anon_sym_2_GT_GT] = ACTIONS(657),
    [anon_sym_3_GT] = ACTIONS(659),
    [anon_sym_3_GT_GT] = ACTIONS(657),
    [anon_sym_4_GT] = ACTIONS(659),
    [anon_sym_4_GT_GT] = ACTIONS(657),
    [anon_sym_5_GT] = ACTIONS(659),
    [anon_sym_5_GT_GT] = ACTIONS(657),
    [anon_sym_6_GT] = ACTIONS(659),
    [anon_sym_6_GT_GT] = ACTIONS(657),
    [anon_sym_STAR_GT] = ACTIONS(659),
    [anon_sym_STAR_GT_GT] = ACTIONS(657),
    [anon_sym_LT] = ACTIONS(659),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(657),
    [anon_sym_2_GT_AMP1] = ACTIONS(657),
    [anon_sym_3_GT_AMP1] = ACTIONS(657),
    [anon_sym_4_GT_AMP1] = ACTIONS(657),
    [anon_sym_5_GT_AMP1] = ACTIONS(657),
    [anon_sym_6_GT_AMP1] = ACTIONS(657),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(657),
    [anon_sym_1_GT_AMP2] = ACTIONS(657),
    [anon_sym_3_GT_AMP2] = ACTIONS(657),
    [anon_sym_4_GT_AMP2] = ACTIONS(657),
    [anon_sym_5_GT_AMP2] = ACTIONS(657),
    [anon_sym_6_GT_AMP2] = ACTIONS(657),
    [anon_sym_DASHas] = ACTIONS(657),
    [anon_sym_DASHccontains] = ACTIONS(657),
    [anon_sym_DASHceq] = ACTIONS(657),
    [anon_sym_DASHcge] = ACTIONS(657),
    [anon_sym_DASHcgt] = ACTIONS(657),
    [anon_sym_DASHcle] = ACTIONS(657),
    [anon_sym_DASHclike] = ACTIONS(657),
    [anon_sym_DASHclt] = ACTIONS(657),
    [anon_sym_DASHcmatch] = ACTIONS(657),
    [anon_sym_DASHcne] = ACTIONS(657),
    [anon_sym_DASHcnotcontains] = ACTIONS(657),
    [anon_sym_DASHcnotlike] = ACTIONS(657),
    [anon_sym_DASHcnotmatch] = ACTIONS(657),
    [anon_sym_DASHcontains] = ACTIONS(657),
    [anon_sym_DASHcreplace] = ACTIONS(657),
    [anon_sym_DASHcsplit] = ACTIONS(657),
    [anon_sym_DASHeq] = ACTIONS(657),
    [anon_sym_DASHge] = ACTIONS(657),
    [anon_sym_DASHgt] = ACTIONS(657),
    [anon_sym_DASHicontains] = ACTIONS(657),
    [anon_sym_DASHieq] = ACTIONS(657),
    [anon_sym_DASHige] = ACTIONS(657),
    [anon_sym_DASHigt] = ACTIONS(657),
    [anon_sym_DASHile] = ACTIONS(657),
    [anon_sym_DASHilike] = ACTIONS(657),
    [anon_sym_DASHilt] = ACTIONS(657),
    [anon_sym_DASHimatch] = ACTIONS(657),
    [anon_sym_DASHin] = ACTIONS(659),
    [anon_sym_DASHine] = ACTIONS(657),
    [anon_sym_DASHinotcontains] = ACTIONS(657),
    [anon_sym_DASHinotlike] = ACTIONS(657),
    [anon_sym_DASHinotmatch] = ACTIONS(657),
    [anon_sym_DASHireplace] = ACTIONS(657),
    [anon_sym_DASHis] = ACTIONS(659),
    [anon_sym_DASHisnot] = ACTIONS(657),
    [anon_sym_DASHisplit] = ACTIONS(657),
    [anon_sym_DASHjoin] = ACTIONS(657),
    [anon_sym_DASHle] = ACTIONS(657),
    [anon_sym_DASHlike] = ACTIONS(657),
    [anon_sym_DASHlt] = ACTIONS(657),
    [anon_sym_DASHmatch] = ACTIONS(657),
    [anon_sym_DASHne] = ACTIONS(657),
    [anon_sym_DASHnotcontains] = ACTIONS(657),
    [anon_sym_DASHnotin] = ACTIONS(657),
    [anon_sym_DASHnotlike] = ACTIONS(657),
    [anon_sym_DASHnotmatch] = ACTIONS(657),
    [anon_sym_DASHreplace] = ACTIONS(657),
    [anon_sym_DASHshl] = ACTIONS(657),
    [anon_sym_DASHshr] = ACTIONS(657),
    [anon_sym_DASHsplit] = ACTIONS(657),
    [sym_format_operator] = ACTIONS(657),
    [anon_sym_LPAREN] = ACTIONS(657),
    [anon_sym_RPAREN] = ACTIONS(657),
    [anon_sym_COMMA] = ACTIONS(657),
    [anon_sym_PIPE] = ACTIONS(657),
    [anon_sym_PERCENT] = ACTIONS(659),
    [anon_sym_DASHand] = ACTIONS(657),
    [anon_sym_DASHor] = ACTIONS(657),
    [anon_sym_DASHxor] = ACTIONS(657),
    [anon_sym_DASHband] = ACTIONS(657),
    [anon_sym_DASHbor] = ACTIONS(657),
    [anon_sym_DASHbxor] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_SLASH] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(657),
    [anon_sym_STAR] = ACTIONS(659),
    [anon_sym_DOT_DOT] = ACTIONS(657),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DOT2] = ACTIONS(659),
    [anon_sym_COLON_COLON] = ACTIONS(657),
    [anon_sym_RBRACK] = ACTIONS(657),
    [anon_sym_DOTforeach] = ACTIONS(657),
  },
  [103] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(661),
    [anon_sym_EQ] = ACTIONS(661),
    [anon_sym_BANG_EQ] = ACTIONS(661),
    [anon_sym_PLUS_EQ] = ACTIONS(661),
    [anon_sym_STAR_EQ] = ACTIONS(661),
    [anon_sym_SLASH_EQ] = ACTIONS(661),
    [anon_sym_PERCENT_EQ] = ACTIONS(661),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_GT] = ACTIONS(661),
    [anon_sym_2_GT] = ACTIONS(663),
    [anon_sym_2_GT_GT] = ACTIONS(661),
    [anon_sym_3_GT] = ACTIONS(663),
    [anon_sym_3_GT_GT] = ACTIONS(661),
    [anon_sym_4_GT] = ACTIONS(663),
    [anon_sym_4_GT_GT] = ACTIONS(661),
    [anon_sym_5_GT] = ACTIONS(663),
    [anon_sym_5_GT_GT] = ACTIONS(661),
    [anon_sym_6_GT] = ACTIONS(663),
    [anon_sym_6_GT_GT] = ACTIONS(661),
    [anon_sym_STAR_GT] = ACTIONS(663),
    [anon_sym_STAR_GT_GT] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(661),
    [anon_sym_2_GT_AMP1] = ACTIONS(661),
    [anon_sym_3_GT_AMP1] = ACTIONS(661),
    [anon_sym_4_GT_AMP1] = ACTIONS(661),
    [anon_sym_5_GT_AMP1] = ACTIONS(661),
    [anon_sym_6_GT_AMP1] = ACTIONS(661),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(661),
    [anon_sym_1_GT_AMP2] = ACTIONS(661),
    [anon_sym_3_GT_AMP2] = ACTIONS(661),
    [anon_sym_4_GT_AMP2] = ACTIONS(661),
    [anon_sym_5_GT_AMP2] = ACTIONS(661),
    [anon_sym_6_GT_AMP2] = ACTIONS(661),
    [anon_sym_DASHas] = ACTIONS(661),
    [anon_sym_DASHccontains] = ACTIONS(661),
    [anon_sym_DASHceq] = ACTIONS(661),
    [anon_sym_DASHcge] = ACTIONS(661),
    [anon_sym_DASHcgt] = ACTIONS(661),
    [anon_sym_DASHcle] = ACTIONS(661),
    [anon_sym_DASHclike] = ACTIONS(661),
    [anon_sym_DASHclt] = ACTIONS(661),
    [anon_sym_DASHcmatch] = ACTIONS(661),
    [anon_sym_DASHcne] = ACTIONS(661),
    [anon_sym_DASHcnotcontains] = ACTIONS(661),
    [anon_sym_DASHcnotlike] = ACTIONS(661),
    [anon_sym_DASHcnotmatch] = ACTIONS(661),
    [anon_sym_DASHcontains] = ACTIONS(661),
    [anon_sym_DASHcreplace] = ACTIONS(661),
    [anon_sym_DASHcsplit] = ACTIONS(661),
    [anon_sym_DASHeq] = ACTIONS(661),
    [anon_sym_DASHge] = ACTIONS(661),
    [anon_sym_DASHgt] = ACTIONS(661),
    [anon_sym_DASHicontains] = ACTIONS(661),
    [anon_sym_DASHieq] = ACTIONS(661),
    [anon_sym_DASHige] = ACTIONS(661),
    [anon_sym_DASHigt] = ACTIONS(661),
    [anon_sym_DASHile] = ACTIONS(661),
    [anon_sym_DASHilike] = ACTIONS(661),
    [anon_sym_DASHilt] = ACTIONS(661),
    [anon_sym_DASHimatch] = ACTIONS(661),
    [anon_sym_DASHin] = ACTIONS(663),
    [anon_sym_DASHine] = ACTIONS(661),
    [anon_sym_DASHinotcontains] = ACTIONS(661),
    [anon_sym_DASHinotlike] = ACTIONS(661),
    [anon_sym_DASHinotmatch] = ACTIONS(661),
    [anon_sym_DASHireplace] = ACTIONS(661),
    [anon_sym_DASHis] = ACTIONS(663),
    [anon_sym_DASHisnot] = ACTIONS(661),
    [anon_sym_DASHisplit] = ACTIONS(661),
    [anon_sym_DASHjoin] = ACTIONS(661),
    [anon_sym_DASHle] = ACTIONS(661),
    [anon_sym_DASHlike] = ACTIONS(661),
    [anon_sym_DASHlt] = ACTIONS(661),
    [anon_sym_DASHmatch] = ACTIONS(661),
    [anon_sym_DASHne] = ACTIONS(661),
    [anon_sym_DASHnotcontains] = ACTIONS(661),
    [anon_sym_DASHnotin] = ACTIONS(661),
    [anon_sym_DASHnotlike] = ACTIONS(661),
    [anon_sym_DASHnotmatch] = ACTIONS(661),
    [anon_sym_DASHreplace] = ACTIONS(661),
    [anon_sym_DASHshl] = ACTIONS(661),
    [anon_sym_DASHshr] = ACTIONS(661),
    [anon_sym_DASHsplit] = ACTIONS(661),
    [sym_format_operator] = ACTIONS(661),
    [anon_sym_LPAREN] = ACTIONS(661),
    [anon_sym_RPAREN] = ACTIONS(661),
    [anon_sym_COMMA] = ACTIONS(661),
    [anon_sym_PIPE] = ACTIONS(661),
    [anon_sym_PERCENT] = ACTIONS(663),
    [anon_sym_DASHand] = ACTIONS(661),
    [anon_sym_DASHor] = ACTIONS(661),
    [anon_sym_DASHxor] = ACTIONS(661),
    [anon_sym_DASHband] = ACTIONS(661),
    [anon_sym_DASHbor] = ACTIONS(661),
    [anon_sym_DASHbxor] = ACTIONS(661),
    [anon_sym_PLUS] = ACTIONS(663),
    [anon_sym_DASH] = ACTIONS(663),
    [anon_sym_SLASH] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(661),
    [anon_sym_STAR] = ACTIONS(663),
    [anon_sym_DOT_DOT] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_DOT2] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(661),
    [anon_sym_RBRACK] = ACTIONS(661),
    [anon_sym_DOTforeach] = ACTIONS(661),
  },
  [104] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(665),
    [anon_sym_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_PLUS_EQ] = ACTIONS(665),
    [anon_sym_STAR_EQ] = ACTIONS(665),
    [anon_sym_SLASH_EQ] = ACTIONS(665),
    [anon_sym_PERCENT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(667),
    [anon_sym_GT_GT] = ACTIONS(665),
    [anon_sym_2_GT] = ACTIONS(667),
    [anon_sym_2_GT_GT] = ACTIONS(665),
    [anon_sym_3_GT] = ACTIONS(667),
    [anon_sym_3_GT_GT] = ACTIONS(665),
    [anon_sym_4_GT] = ACTIONS(667),
    [anon_sym_4_GT_GT] = ACTIONS(665),
    [anon_sym_5_GT] = ACTIONS(667),
    [anon_sym_5_GT_GT] = ACTIONS(665),
    [anon_sym_6_GT] = ACTIONS(667),
    [anon_sym_6_GT_GT] = ACTIONS(665),
    [anon_sym_STAR_GT] = ACTIONS(667),
    [anon_sym_STAR_GT_GT] = ACTIONS(665),
    [anon_sym_LT] = ACTIONS(667),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(665),
    [anon_sym_2_GT_AMP1] = ACTIONS(665),
    [anon_sym_3_GT_AMP1] = ACTIONS(665),
    [anon_sym_4_GT_AMP1] = ACTIONS(665),
    [anon_sym_5_GT_AMP1] = ACTIONS(665),
    [anon_sym_6_GT_AMP1] = ACTIONS(665),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(665),
    [anon_sym_1_GT_AMP2] = ACTIONS(665),
    [anon_sym_3_GT_AMP2] = ACTIONS(665),
    [anon_sym_4_GT_AMP2] = ACTIONS(665),
    [anon_sym_5_GT_AMP2] = ACTIONS(665),
    [anon_sym_6_GT_AMP2] = ACTIONS(665),
    [anon_sym_DASHas] = ACTIONS(665),
    [anon_sym_DASHccontains] = ACTIONS(665),
    [anon_sym_DASHceq] = ACTIONS(665),
    [anon_sym_DASHcge] = ACTIONS(665),
    [anon_sym_DASHcgt] = ACTIONS(665),
    [anon_sym_DASHcle] = ACTIONS(665),
    [anon_sym_DASHclike] = ACTIONS(665),
    [anon_sym_DASHclt] = ACTIONS(665),
    [anon_sym_DASHcmatch] = ACTIONS(665),
    [anon_sym_DASHcne] = ACTIONS(665),
    [anon_sym_DASHcnotcontains] = ACTIONS(665),
    [anon_sym_DASHcnotlike] = ACTIONS(665),
    [anon_sym_DASHcnotmatch] = ACTIONS(665),
    [anon_sym_DASHcontains] = ACTIONS(665),
    [anon_sym_DASHcreplace] = ACTIONS(665),
    [anon_sym_DASHcsplit] = ACTIONS(665),
    [anon_sym_DASHeq] = ACTIONS(665),
    [anon_sym_DASHge] = ACTIONS(665),
    [anon_sym_DASHgt] = ACTIONS(665),
    [anon_sym_DASHicontains] = ACTIONS(665),
    [anon_sym_DASHieq] = ACTIONS(665),
    [anon_sym_DASHige] = ACTIONS(665),
    [anon_sym_DASHigt] = ACTIONS(665),
    [anon_sym_DASHile] = ACTIONS(665),
    [anon_sym_DASHilike] = ACTIONS(665),
    [anon_sym_DASHilt] = ACTIONS(665),
    [anon_sym_DASHimatch] = ACTIONS(665),
    [anon_sym_DASHin] = ACTIONS(667),
    [anon_sym_DASHine] = ACTIONS(665),
    [anon_sym_DASHinotcontains] = ACTIONS(665),
    [anon_sym_DASHinotlike] = ACTIONS(665),
    [anon_sym_DASHinotmatch] = ACTIONS(665),
    [anon_sym_DASHireplace] = ACTIONS(665),
    [anon_sym_DASHis] = ACTIONS(667),
    [anon_sym_DASHisnot] = ACTIONS(665),
    [anon_sym_DASHisplit] = ACTIONS(665),
    [anon_sym_DASHjoin] = ACTIONS(665),
    [anon_sym_DASHle] = ACTIONS(665),
    [anon_sym_DASHlike] = ACTIONS(665),
    [anon_sym_DASHlt] = ACTIONS(665),
    [anon_sym_DASHmatch] = ACTIONS(665),
    [anon_sym_DASHne] = ACTIONS(665),
    [anon_sym_DASHnotcontains] = ACTIONS(665),
    [anon_sym_DASHnotin] = ACTIONS(665),
    [anon_sym_DASHnotlike] = ACTIONS(665),
    [anon_sym_DASHnotmatch] = ACTIONS(665),
    [anon_sym_DASHreplace] = ACTIONS(665),
    [anon_sym_DASHshl] = ACTIONS(665),
    [anon_sym_DASHshr] = ACTIONS(665),
    [anon_sym_DASHsplit] = ACTIONS(665),
    [sym_format_operator] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(665),
    [anon_sym_COMMA] = ACTIONS(665),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_PERCENT] = ACTIONS(667),
    [anon_sym_DASHand] = ACTIONS(665),
    [anon_sym_DASHor] = ACTIONS(665),
    [anon_sym_DASHxor] = ACTIONS(665),
    [anon_sym_DASHband] = ACTIONS(665),
    [anon_sym_DASHbor] = ACTIONS(665),
    [anon_sym_DASHbxor] = ACTIONS(665),
    [anon_sym_PLUS] = ACTIONS(667),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(667),
    [anon_sym_BSLASH] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_DOT_DOT] = ACTIONS(665),
    [anon_sym_PLUS_PLUS] = ACTIONS(665),
    [anon_sym_DASH_DASH] = ACTIONS(665),
    [anon_sym_DOT2] = ACTIONS(667),
    [anon_sym_COLON_COLON] = ACTIONS(665),
    [anon_sym_RBRACK] = ACTIONS(665),
    [anon_sym_DOTforeach] = ACTIONS(665),
  },
  [105] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_EQ] = ACTIONS(669),
    [anon_sym_BANG_EQ] = ACTIONS(669),
    [anon_sym_PLUS_EQ] = ACTIONS(669),
    [anon_sym_STAR_EQ] = ACTIONS(669),
    [anon_sym_SLASH_EQ] = ACTIONS(669),
    [anon_sym_PERCENT_EQ] = ACTIONS(669),
    [anon_sym_GT] = ACTIONS(671),
    [anon_sym_GT_GT] = ACTIONS(669),
    [anon_sym_2_GT] = ACTIONS(671),
    [anon_sym_2_GT_GT] = ACTIONS(669),
    [anon_sym_3_GT] = ACTIONS(671),
    [anon_sym_3_GT_GT] = ACTIONS(669),
    [anon_sym_4_GT] = ACTIONS(671),
    [anon_sym_4_GT_GT] = ACTIONS(669),
    [anon_sym_5_GT] = ACTIONS(671),
    [anon_sym_5_GT_GT] = ACTIONS(669),
    [anon_sym_6_GT] = ACTIONS(671),
    [anon_sym_6_GT_GT] = ACTIONS(669),
    [anon_sym_STAR_GT] = ACTIONS(671),
    [anon_sym_STAR_GT_GT] = ACTIONS(669),
    [anon_sym_LT] = ACTIONS(671),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(669),
    [anon_sym_2_GT_AMP1] = ACTIONS(669),
    [anon_sym_3_GT_AMP1] = ACTIONS(669),
    [anon_sym_4_GT_AMP1] = ACTIONS(669),
    [anon_sym_5_GT_AMP1] = ACTIONS(669),
    [anon_sym_6_GT_AMP1] = ACTIONS(669),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(669),
    [anon_sym_1_GT_AMP2] = ACTIONS(669),
    [anon_sym_3_GT_AMP2] = ACTIONS(669),
    [anon_sym_4_GT_AMP2] = ACTIONS(669),
    [anon_sym_5_GT_AMP2] = ACTIONS(669),
    [anon_sym_6_GT_AMP2] = ACTIONS(669),
    [anon_sym_DASHas] = ACTIONS(669),
    [anon_sym_DASHccontains] = ACTIONS(669),
    [anon_sym_DASHceq] = ACTIONS(669),
    [anon_sym_DASHcge] = ACTIONS(669),
    [anon_sym_DASHcgt] = ACTIONS(669),
    [anon_sym_DASHcle] = ACTIONS(669),
    [anon_sym_DASHclike] = ACTIONS(669),
    [anon_sym_DASHclt] = ACTIONS(669),
    [anon_sym_DASHcmatch] = ACTIONS(669),
    [anon_sym_DASHcne] = ACTIONS(669),
    [anon_sym_DASHcnotcontains] = ACTIONS(669),
    [anon_sym_DASHcnotlike] = ACTIONS(669),
    [anon_sym_DASHcnotmatch] = ACTIONS(669),
    [anon_sym_DASHcontains] = ACTIONS(669),
    [anon_sym_DASHcreplace] = ACTIONS(669),
    [anon_sym_DASHcsplit] = ACTIONS(669),
    [anon_sym_DASHeq] = ACTIONS(669),
    [anon_sym_DASHge] = ACTIONS(669),
    [anon_sym_DASHgt] = ACTIONS(669),
    [anon_sym_DASHicontains] = ACTIONS(669),
    [anon_sym_DASHieq] = ACTIONS(669),
    [anon_sym_DASHige] = ACTIONS(669),
    [anon_sym_DASHigt] = ACTIONS(669),
    [anon_sym_DASHile] = ACTIONS(669),
    [anon_sym_DASHilike] = ACTIONS(669),
    [anon_sym_DASHilt] = ACTIONS(669),
    [anon_sym_DASHimatch] = ACTIONS(669),
    [anon_sym_DASHin] = ACTIONS(671),
    [anon_sym_DASHine] = ACTIONS(669),
    [anon_sym_DASHinotcontains] = ACTIONS(669),
    [anon_sym_DASHinotlike] = ACTIONS(669),
    [anon_sym_DASHinotmatch] = ACTIONS(669),
    [anon_sym_DASHireplace] = ACTIONS(669),
    [anon_sym_DASHis] = ACTIONS(671),
    [anon_sym_DASHisnot] = ACTIONS(669),
    [anon_sym_DASHisplit] = ACTIONS(669),
    [anon_sym_DASHjoin] = ACTIONS(669),
    [anon_sym_DASHle] = ACTIONS(669),
    [anon_sym_DASHlike] = ACTIONS(669),
    [anon_sym_DASHlt] = ACTIONS(669),
    [anon_sym_DASHmatch] = ACTIONS(669),
    [anon_sym_DASHne] = ACTIONS(669),
    [anon_sym_DASHnotcontains] = ACTIONS(669),
    [anon_sym_DASHnotin] = ACTIONS(669),
    [anon_sym_DASHnotlike] = ACTIONS(669),
    [anon_sym_DASHnotmatch] = ACTIONS(669),
    [anon_sym_DASHreplace] = ACTIONS(669),
    [anon_sym_DASHshl] = ACTIONS(669),
    [anon_sym_DASHshr] = ACTIONS(669),
    [anon_sym_DASHsplit] = ACTIONS(669),
    [sym_format_operator] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(669),
    [anon_sym_COMMA] = ACTIONS(669),
    [anon_sym_PIPE] = ACTIONS(669),
    [anon_sym_PERCENT] = ACTIONS(671),
    [anon_sym_DASHand] = ACTIONS(669),
    [anon_sym_DASHor] = ACTIONS(669),
    [anon_sym_DASHxor] = ACTIONS(669),
    [anon_sym_DASHband] = ACTIONS(669),
    [anon_sym_DASHbor] = ACTIONS(669),
    [anon_sym_DASHbxor] = ACTIONS(669),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_SLASH] = ACTIONS(671),
    [anon_sym_BSLASH] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_DOT_DOT] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_DOT2] = ACTIONS(671),
    [anon_sym_COLON_COLON] = ACTIONS(669),
    [anon_sym_RBRACK] = ACTIONS(669),
    [anon_sym_DOTforeach] = ACTIONS(669),
  },
  [106] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(673),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_BANG_EQ] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(673),
    [anon_sym_STAR_EQ] = ACTIONS(673),
    [anon_sym_SLASH_EQ] = ACTIONS(673),
    [anon_sym_PERCENT_EQ] = ACTIONS(673),
    [anon_sym_GT] = ACTIONS(675),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_2_GT] = ACTIONS(675),
    [anon_sym_2_GT_GT] = ACTIONS(673),
    [anon_sym_3_GT] = ACTIONS(675),
    [anon_sym_3_GT_GT] = ACTIONS(673),
    [anon_sym_4_GT] = ACTIONS(675),
    [anon_sym_4_GT_GT] = ACTIONS(673),
    [anon_sym_5_GT] = ACTIONS(675),
    [anon_sym_5_GT_GT] = ACTIONS(673),
    [anon_sym_6_GT] = ACTIONS(675),
    [anon_sym_6_GT_GT] = ACTIONS(673),
    [anon_sym_STAR_GT] = ACTIONS(675),
    [anon_sym_STAR_GT_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(675),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(673),
    [anon_sym_2_GT_AMP1] = ACTIONS(673),
    [anon_sym_3_GT_AMP1] = ACTIONS(673),
    [anon_sym_4_GT_AMP1] = ACTIONS(673),
    [anon_sym_5_GT_AMP1] = ACTIONS(673),
    [anon_sym_6_GT_AMP1] = ACTIONS(673),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(673),
    [anon_sym_1_GT_AMP2] = ACTIONS(673),
    [anon_sym_3_GT_AMP2] = ACTIONS(673),
    [anon_sym_4_GT_AMP2] = ACTIONS(673),
    [anon_sym_5_GT_AMP2] = ACTIONS(673),
    [anon_sym_6_GT_AMP2] = ACTIONS(673),
    [anon_sym_DASHas] = ACTIONS(673),
    [anon_sym_DASHccontains] = ACTIONS(673),
    [anon_sym_DASHceq] = ACTIONS(673),
    [anon_sym_DASHcge] = ACTIONS(673),
    [anon_sym_DASHcgt] = ACTIONS(673),
    [anon_sym_DASHcle] = ACTIONS(673),
    [anon_sym_DASHclike] = ACTIONS(673),
    [anon_sym_DASHclt] = ACTIONS(673),
    [anon_sym_DASHcmatch] = ACTIONS(673),
    [anon_sym_DASHcne] = ACTIONS(673),
    [anon_sym_DASHcnotcontains] = ACTIONS(673),
    [anon_sym_DASHcnotlike] = ACTIONS(673),
    [anon_sym_DASHcnotmatch] = ACTIONS(673),
    [anon_sym_DASHcontains] = ACTIONS(673),
    [anon_sym_DASHcreplace] = ACTIONS(673),
    [anon_sym_DASHcsplit] = ACTIONS(673),
    [anon_sym_DASHeq] = ACTIONS(673),
    [anon_sym_DASHge] = ACTIONS(673),
    [anon_sym_DASHgt] = ACTIONS(673),
    [anon_sym_DASHicontains] = ACTIONS(673),
    [anon_sym_DASHieq] = ACTIONS(673),
    [anon_sym_DASHige] = ACTIONS(673),
    [anon_sym_DASHigt] = ACTIONS(673),
    [anon_sym_DASHile] = ACTIONS(673),
    [anon_sym_DASHilike] = ACTIONS(673),
    [anon_sym_DASHilt] = ACTIONS(673),
    [anon_sym_DASHimatch] = ACTIONS(673),
    [anon_sym_DASHin] = ACTIONS(675),
    [anon_sym_DASHine] = ACTIONS(673),
    [anon_sym_DASHinotcontains] = ACTIONS(673),
    [anon_sym_DASHinotlike] = ACTIONS(673),
    [anon_sym_DASHinotmatch] = ACTIONS(673),
    [anon_sym_DASHireplace] = ACTIONS(673),
    [anon_sym_DASHis] = ACTIONS(675),
    [anon_sym_DASHisnot] = ACTIONS(673),
    [anon_sym_DASHisplit] = ACTIONS(673),
    [anon_sym_DASHjoin] = ACTIONS(673),
    [anon_sym_DASHle] = ACTIONS(673),
    [anon_sym_DASHlike] = ACTIONS(673),
    [anon_sym_DASHlt] = ACTIONS(673),
    [anon_sym_DASHmatch] = ACTIONS(673),
    [anon_sym_DASHne] = ACTIONS(673),
    [anon_sym_DASHnotcontains] = ACTIONS(673),
    [anon_sym_DASHnotin] = ACTIONS(673),
    [anon_sym_DASHnotlike] = ACTIONS(673),
    [anon_sym_DASHnotmatch] = ACTIONS(673),
    [anon_sym_DASHreplace] = ACTIONS(673),
    [anon_sym_DASHshl] = ACTIONS(673),
    [anon_sym_DASHshr] = ACTIONS(673),
    [anon_sym_DASHsplit] = ACTIONS(673),
    [sym_format_operator] = ACTIONS(673),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(673),
    [anon_sym_COMMA] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(675),
    [anon_sym_DASHand] = ACTIONS(673),
    [anon_sym_DASHor] = ACTIONS(673),
    [anon_sym_DASHxor] = ACTIONS(673),
    [anon_sym_DASHband] = ACTIONS(673),
    [anon_sym_DASHbor] = ACTIONS(673),
    [anon_sym_DASHbxor] = ACTIONS(673),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_BSLASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(675),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DOT2] = ACTIONS(675),
    [anon_sym_COLON_COLON] = ACTIONS(673),
    [anon_sym_RBRACK] = ACTIONS(673),
    [anon_sym_DOTforeach] = ACTIONS(673),
  },
  [107] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_EQ] = ACTIONS(595),
    [anon_sym_BANG_EQ] = ACTIONS(595),
    [anon_sym_PLUS_EQ] = ACTIONS(595),
    [anon_sym_STAR_EQ] = ACTIONS(595),
    [anon_sym_SLASH_EQ] = ACTIONS(595),
    [anon_sym_PERCENT_EQ] = ACTIONS(595),
    [anon_sym_GT] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(595),
    [anon_sym_2_GT] = ACTIONS(597),
    [anon_sym_2_GT_GT] = ACTIONS(595),
    [anon_sym_3_GT] = ACTIONS(597),
    [anon_sym_3_GT_GT] = ACTIONS(595),
    [anon_sym_4_GT] = ACTIONS(597),
    [anon_sym_4_GT_GT] = ACTIONS(595),
    [anon_sym_5_GT] = ACTIONS(597),
    [anon_sym_5_GT_GT] = ACTIONS(595),
    [anon_sym_6_GT] = ACTIONS(597),
    [anon_sym_6_GT_GT] = ACTIONS(595),
    [anon_sym_STAR_GT] = ACTIONS(597),
    [anon_sym_STAR_GT_GT] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(595),
    [anon_sym_2_GT_AMP1] = ACTIONS(595),
    [anon_sym_3_GT_AMP1] = ACTIONS(595),
    [anon_sym_4_GT_AMP1] = ACTIONS(595),
    [anon_sym_5_GT_AMP1] = ACTIONS(595),
    [anon_sym_6_GT_AMP1] = ACTIONS(595),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(595),
    [anon_sym_1_GT_AMP2] = ACTIONS(595),
    [anon_sym_3_GT_AMP2] = ACTIONS(595),
    [anon_sym_4_GT_AMP2] = ACTIONS(595),
    [anon_sym_5_GT_AMP2] = ACTIONS(595),
    [anon_sym_6_GT_AMP2] = ACTIONS(595),
    [anon_sym_DASHas] = ACTIONS(595),
    [anon_sym_DASHccontains] = ACTIONS(595),
    [anon_sym_DASHceq] = ACTIONS(595),
    [anon_sym_DASHcge] = ACTIONS(595),
    [anon_sym_DASHcgt] = ACTIONS(595),
    [anon_sym_DASHcle] = ACTIONS(595),
    [anon_sym_DASHclike] = ACTIONS(595),
    [anon_sym_DASHclt] = ACTIONS(595),
    [anon_sym_DASHcmatch] = ACTIONS(595),
    [anon_sym_DASHcne] = ACTIONS(595),
    [anon_sym_DASHcnotcontains] = ACTIONS(595),
    [anon_sym_DASHcnotlike] = ACTIONS(595),
    [anon_sym_DASHcnotmatch] = ACTIONS(595),
    [anon_sym_DASHcontains] = ACTIONS(595),
    [anon_sym_DASHcreplace] = ACTIONS(595),
    [anon_sym_DASHcsplit] = ACTIONS(595),
    [anon_sym_DASHeq] = ACTIONS(595),
    [anon_sym_DASHge] = ACTIONS(595),
    [anon_sym_DASHgt] = ACTIONS(595),
    [anon_sym_DASHicontains] = ACTIONS(595),
    [anon_sym_DASHieq] = ACTIONS(595),
    [anon_sym_DASHige] = ACTIONS(595),
    [anon_sym_DASHigt] = ACTIONS(595),
    [anon_sym_DASHile] = ACTIONS(595),
    [anon_sym_DASHilike] = ACTIONS(595),
    [anon_sym_DASHilt] = ACTIONS(595),
    [anon_sym_DASHimatch] = ACTIONS(595),
    [anon_sym_DASHin] = ACTIONS(597),
    [anon_sym_DASHine] = ACTIONS(595),
    [anon_sym_DASHinotcontains] = ACTIONS(595),
    [anon_sym_DASHinotlike] = ACTIONS(595),
    [anon_sym_DASHinotmatch] = ACTIONS(595),
    [anon_sym_DASHireplace] = ACTIONS(595),
    [anon_sym_DASHis] = ACTIONS(597),
    [anon_sym_DASHisnot] = ACTIONS(595),
    [anon_sym_DASHisplit] = ACTIONS(595),
    [anon_sym_DASHjoin] = ACTIONS(595),
    [anon_sym_DASHle] = ACTIONS(595),
    [anon_sym_DASHlike] = ACTIONS(595),
    [anon_sym_DASHlt] = ACTIONS(595),
    [anon_sym_DASHmatch] = ACTIONS(595),
    [anon_sym_DASHne] = ACTIONS(595),
    [anon_sym_DASHnotcontains] = ACTIONS(595),
    [anon_sym_DASHnotin] = ACTIONS(595),
    [anon_sym_DASHnotlike] = ACTIONS(595),
    [anon_sym_DASHnotmatch] = ACTIONS(595),
    [anon_sym_DASHreplace] = ACTIONS(595),
    [anon_sym_DASHshl] = ACTIONS(595),
    [anon_sym_DASHshr] = ACTIONS(595),
    [anon_sym_DASHsplit] = ACTIONS(595),
    [sym_format_operator] = ACTIONS(595),
    [anon_sym_LPAREN] = ACTIONS(595),
    [anon_sym_COMMA] = ACTIONS(595),
    [anon_sym_LBRACE] = ACTIONS(595),
    [anon_sym_PIPE] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(597),
    [anon_sym_DASHand] = ACTIONS(595),
    [anon_sym_DASHor] = ACTIONS(595),
    [anon_sym_DASHxor] = ACTIONS(595),
    [anon_sym_DASHband] = ACTIONS(595),
    [anon_sym_DASHbor] = ACTIONS(595),
    [anon_sym_DASHbxor] = ACTIONS(595),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_SLASH] = ACTIONS(597),
    [anon_sym_BSLASH] = ACTIONS(595),
    [anon_sym_STAR] = ACTIONS(597),
    [anon_sym_DOT_DOT] = ACTIONS(595),
    [anon_sym_PLUS_PLUS] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(595),
    [anon_sym_DOT2] = ACTIONS(597),
    [anon_sym_COLON_COLON] = ACTIONS(595),
    [anon_sym_DOTforeach] = ACTIONS(595),
    [sym__statement_terminator] = ACTIONS(595),
  },
  [108] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_2_GT] = ACTIONS(679),
    [anon_sym_2_GT_GT] = ACTIONS(677),
    [anon_sym_3_GT] = ACTIONS(679),
    [anon_sym_3_GT_GT] = ACTIONS(677),
    [anon_sym_4_GT] = ACTIONS(679),
    [anon_sym_4_GT_GT] = ACTIONS(677),
    [anon_sym_5_GT] = ACTIONS(679),
    [anon_sym_5_GT_GT] = ACTIONS(677),
    [anon_sym_6_GT] = ACTIONS(679),
    [anon_sym_6_GT_GT] = ACTIONS(677),
    [anon_sym_STAR_GT] = ACTIONS(679),
    [anon_sym_STAR_GT_GT] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(677),
    [anon_sym_2_GT_AMP1] = ACTIONS(677),
    [anon_sym_3_GT_AMP1] = ACTIONS(677),
    [anon_sym_4_GT_AMP1] = ACTIONS(677),
    [anon_sym_5_GT_AMP1] = ACTIONS(677),
    [anon_sym_6_GT_AMP1] = ACTIONS(677),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(677),
    [anon_sym_1_GT_AMP2] = ACTIONS(677),
    [anon_sym_3_GT_AMP2] = ACTIONS(677),
    [anon_sym_4_GT_AMP2] = ACTIONS(677),
    [anon_sym_5_GT_AMP2] = ACTIONS(677),
    [anon_sym_6_GT_AMP2] = ACTIONS(677),
    [anon_sym_DASHas] = ACTIONS(677),
    [anon_sym_DASHccontains] = ACTIONS(677),
    [anon_sym_DASHceq] = ACTIONS(677),
    [anon_sym_DASHcge] = ACTIONS(677),
    [anon_sym_DASHcgt] = ACTIONS(677),
    [anon_sym_DASHcle] = ACTIONS(677),
    [anon_sym_DASHclike] = ACTIONS(677),
    [anon_sym_DASHclt] = ACTIONS(677),
    [anon_sym_DASHcmatch] = ACTIONS(677),
    [anon_sym_DASHcne] = ACTIONS(677),
    [anon_sym_DASHcnotcontains] = ACTIONS(677),
    [anon_sym_DASHcnotlike] = ACTIONS(677),
    [anon_sym_DASHcnotmatch] = ACTIONS(677),
    [anon_sym_DASHcontains] = ACTIONS(677),
    [anon_sym_DASHcreplace] = ACTIONS(677),
    [anon_sym_DASHcsplit] = ACTIONS(677),
    [anon_sym_DASHeq] = ACTIONS(677),
    [anon_sym_DASHge] = ACTIONS(677),
    [anon_sym_DASHgt] = ACTIONS(677),
    [anon_sym_DASHicontains] = ACTIONS(677),
    [anon_sym_DASHieq] = ACTIONS(677),
    [anon_sym_DASHige] = ACTIONS(677),
    [anon_sym_DASHigt] = ACTIONS(677),
    [anon_sym_DASHile] = ACTIONS(677),
    [anon_sym_DASHilike] = ACTIONS(677),
    [anon_sym_DASHilt] = ACTIONS(677),
    [anon_sym_DASHimatch] = ACTIONS(677),
    [anon_sym_DASHin] = ACTIONS(679),
    [anon_sym_DASHine] = ACTIONS(677),
    [anon_sym_DASHinotcontains] = ACTIONS(677),
    [anon_sym_DASHinotlike] = ACTIONS(677),
    [anon_sym_DASHinotmatch] = ACTIONS(677),
    [anon_sym_DASHireplace] = ACTIONS(677),
    [anon_sym_DASHis] = ACTIONS(679),
    [anon_sym_DASHisnot] = ACTIONS(677),
    [anon_sym_DASHisplit] = ACTIONS(677),
    [anon_sym_DASHjoin] = ACTIONS(677),
    [anon_sym_DASHle] = ACTIONS(677),
    [anon_sym_DASHlike] = ACTIONS(677),
    [anon_sym_DASHlt] = ACTIONS(677),
    [anon_sym_DASHmatch] = ACTIONS(677),
    [anon_sym_DASHne] = ACTIONS(677),
    [anon_sym_DASHnotcontains] = ACTIONS(677),
    [anon_sym_DASHnotin] = ACTIONS(677),
    [anon_sym_DASHnotlike] = ACTIONS(677),
    [anon_sym_DASHnotmatch] = ACTIONS(677),
    [anon_sym_DASHreplace] = ACTIONS(677),
    [anon_sym_DASHshl] = ACTIONS(677),
    [anon_sym_DASHshr] = ACTIONS(677),
    [anon_sym_DASHsplit] = ACTIONS(677),
    [sym_format_operator] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(677),
    [anon_sym_RPAREN] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_PIPE] = ACTIONS(677),
    [anon_sym_PERCENT] = ACTIONS(679),
    [anon_sym_DASHand] = ACTIONS(677),
    [anon_sym_DASHor] = ACTIONS(677),
    [anon_sym_DASHxor] = ACTIONS(677),
    [anon_sym_DASHband] = ACTIONS(677),
    [anon_sym_DASHbor] = ACTIONS(677),
    [anon_sym_DASHbxor] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(679),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_SLASH] = ACTIONS(679),
    [anon_sym_BSLASH] = ACTIONS(677),
    [anon_sym_STAR] = ACTIONS(679),
    [anon_sym_DOT_DOT] = ACTIONS(677),
    [anon_sym_PLUS_PLUS] = ACTIONS(677),
    [anon_sym_DASH_DASH] = ACTIONS(677),
    [anon_sym_DOT2] = ACTIONS(679),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_RBRACK] = ACTIONS(677),
    [anon_sym_DOTforeach] = ACTIONS(677),
  },
  [109] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_EQ] = ACTIONS(681),
    [anon_sym_BANG_EQ] = ACTIONS(681),
    [anon_sym_PLUS_EQ] = ACTIONS(681),
    [anon_sym_STAR_EQ] = ACTIONS(681),
    [anon_sym_SLASH_EQ] = ACTIONS(681),
    [anon_sym_PERCENT_EQ] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_2_GT] = ACTIONS(683),
    [anon_sym_2_GT_GT] = ACTIONS(681),
    [anon_sym_3_GT] = ACTIONS(683),
    [anon_sym_3_GT_GT] = ACTIONS(681),
    [anon_sym_4_GT] = ACTIONS(683),
    [anon_sym_4_GT_GT] = ACTIONS(681),
    [anon_sym_5_GT] = ACTIONS(683),
    [anon_sym_5_GT_GT] = ACTIONS(681),
    [anon_sym_6_GT] = ACTIONS(683),
    [anon_sym_6_GT_GT] = ACTIONS(681),
    [anon_sym_STAR_GT] = ACTIONS(683),
    [anon_sym_STAR_GT_GT] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(683),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(681),
    [anon_sym_2_GT_AMP1] = ACTIONS(681),
    [anon_sym_3_GT_AMP1] = ACTIONS(681),
    [anon_sym_4_GT_AMP1] = ACTIONS(681),
    [anon_sym_5_GT_AMP1] = ACTIONS(681),
    [anon_sym_6_GT_AMP1] = ACTIONS(681),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(681),
    [anon_sym_1_GT_AMP2] = ACTIONS(681),
    [anon_sym_3_GT_AMP2] = ACTIONS(681),
    [anon_sym_4_GT_AMP2] = ACTIONS(681),
    [anon_sym_5_GT_AMP2] = ACTIONS(681),
    [anon_sym_6_GT_AMP2] = ACTIONS(681),
    [anon_sym_DASHas] = ACTIONS(681),
    [anon_sym_DASHccontains] = ACTIONS(681),
    [anon_sym_DASHceq] = ACTIONS(681),
    [anon_sym_DASHcge] = ACTIONS(681),
    [anon_sym_DASHcgt] = ACTIONS(681),
    [anon_sym_DASHcle] = ACTIONS(681),
    [anon_sym_DASHclike] = ACTIONS(681),
    [anon_sym_DASHclt] = ACTIONS(681),
    [anon_sym_DASHcmatch] = ACTIONS(681),
    [anon_sym_DASHcne] = ACTIONS(681),
    [anon_sym_DASHcnotcontains] = ACTIONS(681),
    [anon_sym_DASHcnotlike] = ACTIONS(681),
    [anon_sym_DASHcnotmatch] = ACTIONS(681),
    [anon_sym_DASHcontains] = ACTIONS(681),
    [anon_sym_DASHcreplace] = ACTIONS(681),
    [anon_sym_DASHcsplit] = ACTIONS(681),
    [anon_sym_DASHeq] = ACTIONS(681),
    [anon_sym_DASHge] = ACTIONS(681),
    [anon_sym_DASHgt] = ACTIONS(681),
    [anon_sym_DASHicontains] = ACTIONS(681),
    [anon_sym_DASHieq] = ACTIONS(681),
    [anon_sym_DASHige] = ACTIONS(681),
    [anon_sym_DASHigt] = ACTIONS(681),
    [anon_sym_DASHile] = ACTIONS(681),
    [anon_sym_DASHilike] = ACTIONS(681),
    [anon_sym_DASHilt] = ACTIONS(681),
    [anon_sym_DASHimatch] = ACTIONS(681),
    [anon_sym_DASHin] = ACTIONS(683),
    [anon_sym_DASHine] = ACTIONS(681),
    [anon_sym_DASHinotcontains] = ACTIONS(681),
    [anon_sym_DASHinotlike] = ACTIONS(681),
    [anon_sym_DASHinotmatch] = ACTIONS(681),
    [anon_sym_DASHireplace] = ACTIONS(681),
    [anon_sym_DASHis] = ACTIONS(683),
    [anon_sym_DASHisnot] = ACTIONS(681),
    [anon_sym_DASHisplit] = ACTIONS(681),
    [anon_sym_DASHjoin] = ACTIONS(681),
    [anon_sym_DASHle] = ACTIONS(681),
    [anon_sym_DASHlike] = ACTIONS(681),
    [anon_sym_DASHlt] = ACTIONS(681),
    [anon_sym_DASHmatch] = ACTIONS(681),
    [anon_sym_DASHne] = ACTIONS(681),
    [anon_sym_DASHnotcontains] = ACTIONS(681),
    [anon_sym_DASHnotin] = ACTIONS(681),
    [anon_sym_DASHnotlike] = ACTIONS(681),
    [anon_sym_DASHnotmatch] = ACTIONS(681),
    [anon_sym_DASHreplace] = ACTIONS(681),
    [anon_sym_DASHshl] = ACTIONS(681),
    [anon_sym_DASHshr] = ACTIONS(681),
    [anon_sym_DASHsplit] = ACTIONS(681),
    [sym_format_operator] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(681),
    [anon_sym_RPAREN] = ACTIONS(681),
    [anon_sym_COMMA] = ACTIONS(681),
    [anon_sym_PIPE] = ACTIONS(681),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_DASHand] = ACTIONS(681),
    [anon_sym_DASHor] = ACTIONS(681),
    [anon_sym_DASHxor] = ACTIONS(681),
    [anon_sym_DASHband] = ACTIONS(681),
    [anon_sym_DASHbor] = ACTIONS(681),
    [anon_sym_DASHbxor] = ACTIONS(681),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_DOT_DOT] = ACTIONS(681),
    [anon_sym_PLUS_PLUS] = ACTIONS(681),
    [anon_sym_DASH_DASH] = ACTIONS(681),
    [anon_sym_DOT2] = ACTIONS(683),
    [anon_sym_COLON_COLON] = ACTIONS(681),
    [anon_sym_RBRACK] = ACTIONS(681),
    [anon_sym_DOTforeach] = ACTIONS(681),
  },
  [110] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_EQ] = ACTIONS(685),
    [anon_sym_BANG_EQ] = ACTIONS(685),
    [anon_sym_PLUS_EQ] = ACTIONS(685),
    [anon_sym_STAR_EQ] = ACTIONS(685),
    [anon_sym_SLASH_EQ] = ACTIONS(685),
    [anon_sym_PERCENT_EQ] = ACTIONS(685),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(685),
    [anon_sym_2_GT] = ACTIONS(687),
    [anon_sym_2_GT_GT] = ACTIONS(685),
    [anon_sym_3_GT] = ACTIONS(687),
    [anon_sym_3_GT_GT] = ACTIONS(685),
    [anon_sym_4_GT] = ACTIONS(687),
    [anon_sym_4_GT_GT] = ACTIONS(685),
    [anon_sym_5_GT] = ACTIONS(687),
    [anon_sym_5_GT_GT] = ACTIONS(685),
    [anon_sym_6_GT] = ACTIONS(687),
    [anon_sym_6_GT_GT] = ACTIONS(685),
    [anon_sym_STAR_GT] = ACTIONS(687),
    [anon_sym_STAR_GT_GT] = ACTIONS(685),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(685),
    [anon_sym_2_GT_AMP1] = ACTIONS(685),
    [anon_sym_3_GT_AMP1] = ACTIONS(685),
    [anon_sym_4_GT_AMP1] = ACTIONS(685),
    [anon_sym_5_GT_AMP1] = ACTIONS(685),
    [anon_sym_6_GT_AMP1] = ACTIONS(685),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(685),
    [anon_sym_1_GT_AMP2] = ACTIONS(685),
    [anon_sym_3_GT_AMP2] = ACTIONS(685),
    [anon_sym_4_GT_AMP2] = ACTIONS(685),
    [anon_sym_5_GT_AMP2] = ACTIONS(685),
    [anon_sym_6_GT_AMP2] = ACTIONS(685),
    [anon_sym_DASHas] = ACTIONS(685),
    [anon_sym_DASHccontains] = ACTIONS(685),
    [anon_sym_DASHceq] = ACTIONS(685),
    [anon_sym_DASHcge] = ACTIONS(685),
    [anon_sym_DASHcgt] = ACTIONS(685),
    [anon_sym_DASHcle] = ACTIONS(685),
    [anon_sym_DASHclike] = ACTIONS(685),
    [anon_sym_DASHclt] = ACTIONS(685),
    [anon_sym_DASHcmatch] = ACTIONS(685),
    [anon_sym_DASHcne] = ACTIONS(685),
    [anon_sym_DASHcnotcontains] = ACTIONS(685),
    [anon_sym_DASHcnotlike] = ACTIONS(685),
    [anon_sym_DASHcnotmatch] = ACTIONS(685),
    [anon_sym_DASHcontains] = ACTIONS(685),
    [anon_sym_DASHcreplace] = ACTIONS(685),
    [anon_sym_DASHcsplit] = ACTIONS(685),
    [anon_sym_DASHeq] = ACTIONS(685),
    [anon_sym_DASHge] = ACTIONS(685),
    [anon_sym_DASHgt] = ACTIONS(685),
    [anon_sym_DASHicontains] = ACTIONS(685),
    [anon_sym_DASHieq] = ACTIONS(685),
    [anon_sym_DASHige] = ACTIONS(685),
    [anon_sym_DASHigt] = ACTIONS(685),
    [anon_sym_DASHile] = ACTIONS(685),
    [anon_sym_DASHilike] = ACTIONS(685),
    [anon_sym_DASHilt] = ACTIONS(685),
    [anon_sym_DASHimatch] = ACTIONS(685),
    [anon_sym_DASHin] = ACTIONS(687),
    [anon_sym_DASHine] = ACTIONS(685),
    [anon_sym_DASHinotcontains] = ACTIONS(685),
    [anon_sym_DASHinotlike] = ACTIONS(685),
    [anon_sym_DASHinotmatch] = ACTIONS(685),
    [anon_sym_DASHireplace] = ACTIONS(685),
    [anon_sym_DASHis] = ACTIONS(687),
    [anon_sym_DASHisnot] = ACTIONS(685),
    [anon_sym_DASHisplit] = ACTIONS(685),
    [anon_sym_DASHjoin] = ACTIONS(685),
    [anon_sym_DASHle] = ACTIONS(685),
    [anon_sym_DASHlike] = ACTIONS(685),
    [anon_sym_DASHlt] = ACTIONS(685),
    [anon_sym_DASHmatch] = ACTIONS(685),
    [anon_sym_DASHne] = ACTIONS(685),
    [anon_sym_DASHnotcontains] = ACTIONS(685),
    [anon_sym_DASHnotin] = ACTIONS(685),
    [anon_sym_DASHnotlike] = ACTIONS(685),
    [anon_sym_DASHnotmatch] = ACTIONS(685),
    [anon_sym_DASHreplace] = ACTIONS(685),
    [anon_sym_DASHshl] = ACTIONS(685),
    [anon_sym_DASHshr] = ACTIONS(685),
    [anon_sym_DASHsplit] = ACTIONS(685),
    [sym_format_operator] = ACTIONS(685),
    [anon_sym_LPAREN] = ACTIONS(685),
    [anon_sym_RPAREN] = ACTIONS(685),
    [anon_sym_COMMA] = ACTIONS(685),
    [anon_sym_PIPE] = ACTIONS(685),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_DASHand] = ACTIONS(685),
    [anon_sym_DASHor] = ACTIONS(685),
    [anon_sym_DASHxor] = ACTIONS(685),
    [anon_sym_DASHband] = ACTIONS(685),
    [anon_sym_DASHbor] = ACTIONS(685),
    [anon_sym_DASHbxor] = ACTIONS(685),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_BSLASH] = ACTIONS(685),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(685),
    [anon_sym_PLUS_PLUS] = ACTIONS(685),
    [anon_sym_DASH_DASH] = ACTIONS(685),
    [anon_sym_DOT2] = ACTIONS(687),
    [anon_sym_COLON_COLON] = ACTIONS(685),
    [anon_sym_RBRACK] = ACTIONS(685),
    [anon_sym_DOTforeach] = ACTIONS(685),
  },
  [111] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_BANG_EQ] = ACTIONS(689),
    [anon_sym_PLUS_EQ] = ACTIONS(689),
    [anon_sym_STAR_EQ] = ACTIONS(689),
    [anon_sym_SLASH_EQ] = ACTIONS(689),
    [anon_sym_PERCENT_EQ] = ACTIONS(689),
    [anon_sym_GT] = ACTIONS(691),
    [anon_sym_GT_GT] = ACTIONS(689),
    [anon_sym_2_GT] = ACTIONS(691),
    [anon_sym_2_GT_GT] = ACTIONS(689),
    [anon_sym_3_GT] = ACTIONS(691),
    [anon_sym_3_GT_GT] = ACTIONS(689),
    [anon_sym_4_GT] = ACTIONS(691),
    [anon_sym_4_GT_GT] = ACTIONS(689),
    [anon_sym_5_GT] = ACTIONS(691),
    [anon_sym_5_GT_GT] = ACTIONS(689),
    [anon_sym_6_GT] = ACTIONS(691),
    [anon_sym_6_GT_GT] = ACTIONS(689),
    [anon_sym_STAR_GT] = ACTIONS(691),
    [anon_sym_STAR_GT_GT] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(691),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(689),
    [anon_sym_2_GT_AMP1] = ACTIONS(689),
    [anon_sym_3_GT_AMP1] = ACTIONS(689),
    [anon_sym_4_GT_AMP1] = ACTIONS(689),
    [anon_sym_5_GT_AMP1] = ACTIONS(689),
    [anon_sym_6_GT_AMP1] = ACTIONS(689),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(689),
    [anon_sym_1_GT_AMP2] = ACTIONS(689),
    [anon_sym_3_GT_AMP2] = ACTIONS(689),
    [anon_sym_4_GT_AMP2] = ACTIONS(689),
    [anon_sym_5_GT_AMP2] = ACTIONS(689),
    [anon_sym_6_GT_AMP2] = ACTIONS(689),
    [anon_sym_DASHas] = ACTIONS(689),
    [anon_sym_DASHccontains] = ACTIONS(689),
    [anon_sym_DASHceq] = ACTIONS(689),
    [anon_sym_DASHcge] = ACTIONS(689),
    [anon_sym_DASHcgt] = ACTIONS(689),
    [anon_sym_DASHcle] = ACTIONS(689),
    [anon_sym_DASHclike] = ACTIONS(689),
    [anon_sym_DASHclt] = ACTIONS(689),
    [anon_sym_DASHcmatch] = ACTIONS(689),
    [anon_sym_DASHcne] = ACTIONS(689),
    [anon_sym_DASHcnotcontains] = ACTIONS(689),
    [anon_sym_DASHcnotlike] = ACTIONS(689),
    [anon_sym_DASHcnotmatch] = ACTIONS(689),
    [anon_sym_DASHcontains] = ACTIONS(689),
    [anon_sym_DASHcreplace] = ACTIONS(689),
    [anon_sym_DASHcsplit] = ACTIONS(689),
    [anon_sym_DASHeq] = ACTIONS(689),
    [anon_sym_DASHge] = ACTIONS(689),
    [anon_sym_DASHgt] = ACTIONS(689),
    [anon_sym_DASHicontains] = ACTIONS(689),
    [anon_sym_DASHieq] = ACTIONS(689),
    [anon_sym_DASHige] = ACTIONS(689),
    [anon_sym_DASHigt] = ACTIONS(689),
    [anon_sym_DASHile] = ACTIONS(689),
    [anon_sym_DASHilike] = ACTIONS(689),
    [anon_sym_DASHilt] = ACTIONS(689),
    [anon_sym_DASHimatch] = ACTIONS(689),
    [anon_sym_DASHin] = ACTIONS(691),
    [anon_sym_DASHine] = ACTIONS(689),
    [anon_sym_DASHinotcontains] = ACTIONS(689),
    [anon_sym_DASHinotlike] = ACTIONS(689),
    [anon_sym_DASHinotmatch] = ACTIONS(689),
    [anon_sym_DASHireplace] = ACTIONS(689),
    [anon_sym_DASHis] = ACTIONS(691),
    [anon_sym_DASHisnot] = ACTIONS(689),
    [anon_sym_DASHisplit] = ACTIONS(689),
    [anon_sym_DASHjoin] = ACTIONS(689),
    [anon_sym_DASHle] = ACTIONS(689),
    [anon_sym_DASHlike] = ACTIONS(689),
    [anon_sym_DASHlt] = ACTIONS(689),
    [anon_sym_DASHmatch] = ACTIONS(689),
    [anon_sym_DASHne] = ACTIONS(689),
    [anon_sym_DASHnotcontains] = ACTIONS(689),
    [anon_sym_DASHnotin] = ACTIONS(689),
    [anon_sym_DASHnotlike] = ACTIONS(689),
    [anon_sym_DASHnotmatch] = ACTIONS(689),
    [anon_sym_DASHreplace] = ACTIONS(689),
    [anon_sym_DASHshl] = ACTIONS(689),
    [anon_sym_DASHshr] = ACTIONS(689),
    [anon_sym_DASHsplit] = ACTIONS(689),
    [sym_format_operator] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(689),
    [anon_sym_RPAREN] = ACTIONS(689),
    [anon_sym_COMMA] = ACTIONS(689),
    [anon_sym_PIPE] = ACTIONS(689),
    [anon_sym_PERCENT] = ACTIONS(691),
    [anon_sym_DASHand] = ACTIONS(689),
    [anon_sym_DASHor] = ACTIONS(689),
    [anon_sym_DASHxor] = ACTIONS(689),
    [anon_sym_DASHband] = ACTIONS(689),
    [anon_sym_DASHbor] = ACTIONS(689),
    [anon_sym_DASHbxor] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(691),
    [anon_sym_DASH] = ACTIONS(691),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_STAR] = ACTIONS(691),
    [anon_sym_DOT_DOT] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DOT2] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(689),
    [anon_sym_RBRACK] = ACTIONS(689),
    [anon_sym_DOTforeach] = ACTIONS(689),
  },
  [112] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(693),
    [anon_sym_EQ] = ACTIONS(693),
    [anon_sym_BANG_EQ] = ACTIONS(693),
    [anon_sym_PLUS_EQ] = ACTIONS(693),
    [anon_sym_STAR_EQ] = ACTIONS(693),
    [anon_sym_SLASH_EQ] = ACTIONS(693),
    [anon_sym_PERCENT_EQ] = ACTIONS(693),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(693),
    [anon_sym_2_GT] = ACTIONS(695),
    [anon_sym_2_GT_GT] = ACTIONS(693),
    [anon_sym_3_GT] = ACTIONS(695),
    [anon_sym_3_GT_GT] = ACTIONS(693),
    [anon_sym_4_GT] = ACTIONS(695),
    [anon_sym_4_GT_GT] = ACTIONS(693),
    [anon_sym_5_GT] = ACTIONS(695),
    [anon_sym_5_GT_GT] = ACTIONS(693),
    [anon_sym_6_GT] = ACTIONS(695),
    [anon_sym_6_GT_GT] = ACTIONS(693),
    [anon_sym_STAR_GT] = ACTIONS(695),
    [anon_sym_STAR_GT_GT] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(693),
    [anon_sym_2_GT_AMP1] = ACTIONS(693),
    [anon_sym_3_GT_AMP1] = ACTIONS(693),
    [anon_sym_4_GT_AMP1] = ACTIONS(693),
    [anon_sym_5_GT_AMP1] = ACTIONS(693),
    [anon_sym_6_GT_AMP1] = ACTIONS(693),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(693),
    [anon_sym_1_GT_AMP2] = ACTIONS(693),
    [anon_sym_3_GT_AMP2] = ACTIONS(693),
    [anon_sym_4_GT_AMP2] = ACTIONS(693),
    [anon_sym_5_GT_AMP2] = ACTIONS(693),
    [anon_sym_6_GT_AMP2] = ACTIONS(693),
    [anon_sym_DASHas] = ACTIONS(693),
    [anon_sym_DASHccontains] = ACTIONS(693),
    [anon_sym_DASHceq] = ACTIONS(693),
    [anon_sym_DASHcge] = ACTIONS(693),
    [anon_sym_DASHcgt] = ACTIONS(693),
    [anon_sym_DASHcle] = ACTIONS(693),
    [anon_sym_DASHclike] = ACTIONS(693),
    [anon_sym_DASHclt] = ACTIONS(693),
    [anon_sym_DASHcmatch] = ACTIONS(693),
    [anon_sym_DASHcne] = ACTIONS(693),
    [anon_sym_DASHcnotcontains] = ACTIONS(693),
    [anon_sym_DASHcnotlike] = ACTIONS(693),
    [anon_sym_DASHcnotmatch] = ACTIONS(693),
    [anon_sym_DASHcontains] = ACTIONS(693),
    [anon_sym_DASHcreplace] = ACTIONS(693),
    [anon_sym_DASHcsplit] = ACTIONS(693),
    [anon_sym_DASHeq] = ACTIONS(693),
    [anon_sym_DASHge] = ACTIONS(693),
    [anon_sym_DASHgt] = ACTIONS(693),
    [anon_sym_DASHicontains] = ACTIONS(693),
    [anon_sym_DASHieq] = ACTIONS(693),
    [anon_sym_DASHige] = ACTIONS(693),
    [anon_sym_DASHigt] = ACTIONS(693),
    [anon_sym_DASHile] = ACTIONS(693),
    [anon_sym_DASHilike] = ACTIONS(693),
    [anon_sym_DASHilt] = ACTIONS(693),
    [anon_sym_DASHimatch] = ACTIONS(693),
    [anon_sym_DASHin] = ACTIONS(695),
    [anon_sym_DASHine] = ACTIONS(693),
    [anon_sym_DASHinotcontains] = ACTIONS(693),
    [anon_sym_DASHinotlike] = ACTIONS(693),
    [anon_sym_DASHinotmatch] = ACTIONS(693),
    [anon_sym_DASHireplace] = ACTIONS(693),
    [anon_sym_DASHis] = ACTIONS(695),
    [anon_sym_DASHisnot] = ACTIONS(693),
    [anon_sym_DASHisplit] = ACTIONS(693),
    [anon_sym_DASHjoin] = ACTIONS(693),
    [anon_sym_DASHle] = ACTIONS(693),
    [anon_sym_DASHlike] = ACTIONS(693),
    [anon_sym_DASHlt] = ACTIONS(693),
    [anon_sym_DASHmatch] = ACTIONS(693),
    [anon_sym_DASHne] = ACTIONS(693),
    [anon_sym_DASHnotcontains] = ACTIONS(693),
    [anon_sym_DASHnotin] = ACTIONS(693),
    [anon_sym_DASHnotlike] = ACTIONS(693),
    [anon_sym_DASHnotmatch] = ACTIONS(693),
    [anon_sym_DASHreplace] = ACTIONS(693),
    [anon_sym_DASHshl] = ACTIONS(693),
    [anon_sym_DASHshr] = ACTIONS(693),
    [anon_sym_DASHsplit] = ACTIONS(693),
    [sym_format_operator] = ACTIONS(693),
    [anon_sym_LPAREN] = ACTIONS(693),
    [anon_sym_RPAREN] = ACTIONS(693),
    [anon_sym_COMMA] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(693),
    [anon_sym_PERCENT] = ACTIONS(695),
    [anon_sym_DASHand] = ACTIONS(693),
    [anon_sym_DASHor] = ACTIONS(693),
    [anon_sym_DASHxor] = ACTIONS(693),
    [anon_sym_DASHband] = ACTIONS(693),
    [anon_sym_DASHbor] = ACTIONS(693),
    [anon_sym_DASHbxor] = ACTIONS(693),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_SLASH] = ACTIONS(695),
    [anon_sym_BSLASH] = ACTIONS(693),
    [anon_sym_STAR] = ACTIONS(695),
    [anon_sym_DOT_DOT] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_DOT2] = ACTIONS(695),
    [anon_sym_COLON_COLON] = ACTIONS(693),
    [anon_sym_RBRACK] = ACTIONS(693),
    [anon_sym_DOTforeach] = ACTIONS(693),
  },
  [113] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(697),
    [anon_sym_EQ] = ACTIONS(697),
    [anon_sym_BANG_EQ] = ACTIONS(697),
    [anon_sym_PLUS_EQ] = ACTIONS(697),
    [anon_sym_STAR_EQ] = ACTIONS(697),
    [anon_sym_SLASH_EQ] = ACTIONS(697),
    [anon_sym_PERCENT_EQ] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_GT_GT] = ACTIONS(697),
    [anon_sym_2_GT] = ACTIONS(699),
    [anon_sym_2_GT_GT] = ACTIONS(697),
    [anon_sym_3_GT] = ACTIONS(699),
    [anon_sym_3_GT_GT] = ACTIONS(697),
    [anon_sym_4_GT] = ACTIONS(699),
    [anon_sym_4_GT_GT] = ACTIONS(697),
    [anon_sym_5_GT] = ACTIONS(699),
    [anon_sym_5_GT_GT] = ACTIONS(697),
    [anon_sym_6_GT] = ACTIONS(699),
    [anon_sym_6_GT_GT] = ACTIONS(697),
    [anon_sym_STAR_GT] = ACTIONS(699),
    [anon_sym_STAR_GT_GT] = ACTIONS(697),
    [anon_sym_LT] = ACTIONS(699),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(697),
    [anon_sym_2_GT_AMP1] = ACTIONS(697),
    [anon_sym_3_GT_AMP1] = ACTIONS(697),
    [anon_sym_4_GT_AMP1] = ACTIONS(697),
    [anon_sym_5_GT_AMP1] = ACTIONS(697),
    [anon_sym_6_GT_AMP1] = ACTIONS(697),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(697),
    [anon_sym_1_GT_AMP2] = ACTIONS(697),
    [anon_sym_3_GT_AMP2] = ACTIONS(697),
    [anon_sym_4_GT_AMP2] = ACTIONS(697),
    [anon_sym_5_GT_AMP2] = ACTIONS(697),
    [anon_sym_6_GT_AMP2] = ACTIONS(697),
    [anon_sym_DASHas] = ACTIONS(697),
    [anon_sym_DASHccontains] = ACTIONS(697),
    [anon_sym_DASHceq] = ACTIONS(697),
    [anon_sym_DASHcge] = ACTIONS(697),
    [anon_sym_DASHcgt] = ACTIONS(697),
    [anon_sym_DASHcle] = ACTIONS(697),
    [anon_sym_DASHclike] = ACTIONS(697),
    [anon_sym_DASHclt] = ACTIONS(697),
    [anon_sym_DASHcmatch] = ACTIONS(697),
    [anon_sym_DASHcne] = ACTIONS(697),
    [anon_sym_DASHcnotcontains] = ACTIONS(697),
    [anon_sym_DASHcnotlike] = ACTIONS(697),
    [anon_sym_DASHcnotmatch] = ACTIONS(697),
    [anon_sym_DASHcontains] = ACTIONS(697),
    [anon_sym_DASHcreplace] = ACTIONS(697),
    [anon_sym_DASHcsplit] = ACTIONS(697),
    [anon_sym_DASHeq] = ACTIONS(697),
    [anon_sym_DASHge] = ACTIONS(697),
    [anon_sym_DASHgt] = ACTIONS(697),
    [anon_sym_DASHicontains] = ACTIONS(697),
    [anon_sym_DASHieq] = ACTIONS(697),
    [anon_sym_DASHige] = ACTIONS(697),
    [anon_sym_DASHigt] = ACTIONS(697),
    [anon_sym_DASHile] = ACTIONS(697),
    [anon_sym_DASHilike] = ACTIONS(697),
    [anon_sym_DASHilt] = ACTIONS(697),
    [anon_sym_DASHimatch] = ACTIONS(697),
    [anon_sym_DASHin] = ACTIONS(699),
    [anon_sym_DASHine] = ACTIONS(697),
    [anon_sym_DASHinotcontains] = ACTIONS(697),
    [anon_sym_DASHinotlike] = ACTIONS(697),
    [anon_sym_DASHinotmatch] = ACTIONS(697),
    [anon_sym_DASHireplace] = ACTIONS(697),
    [anon_sym_DASHis] = ACTIONS(699),
    [anon_sym_DASHisnot] = ACTIONS(697),
    [anon_sym_DASHisplit] = ACTIONS(697),
    [anon_sym_DASHjoin] = ACTIONS(697),
    [anon_sym_DASHle] = ACTIONS(697),
    [anon_sym_DASHlike] = ACTIONS(697),
    [anon_sym_DASHlt] = ACTIONS(697),
    [anon_sym_DASHmatch] = ACTIONS(697),
    [anon_sym_DASHne] = ACTIONS(697),
    [anon_sym_DASHnotcontains] = ACTIONS(697),
    [anon_sym_DASHnotin] = ACTIONS(697),
    [anon_sym_DASHnotlike] = ACTIONS(697),
    [anon_sym_DASHnotmatch] = ACTIONS(697),
    [anon_sym_DASHreplace] = ACTIONS(697),
    [anon_sym_DASHshl] = ACTIONS(697),
    [anon_sym_DASHshr] = ACTIONS(697),
    [anon_sym_DASHsplit] = ACTIONS(697),
    [sym_format_operator] = ACTIONS(697),
    [anon_sym_LPAREN] = ACTIONS(697),
    [anon_sym_RPAREN] = ACTIONS(697),
    [anon_sym_COMMA] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_PERCENT] = ACTIONS(699),
    [anon_sym_DASHand] = ACTIONS(697),
    [anon_sym_DASHor] = ACTIONS(697),
    [anon_sym_DASHxor] = ACTIONS(697),
    [anon_sym_DASHband] = ACTIONS(697),
    [anon_sym_DASHbor] = ACTIONS(697),
    [anon_sym_DASHbxor] = ACTIONS(697),
    [anon_sym_PLUS] = ACTIONS(699),
    [anon_sym_DASH] = ACTIONS(699),
    [anon_sym_SLASH] = ACTIONS(699),
    [anon_sym_BSLASH] = ACTIONS(697),
    [anon_sym_STAR] = ACTIONS(699),
    [anon_sym_DOT_DOT] = ACTIONS(697),
    [anon_sym_PLUS_PLUS] = ACTIONS(697),
    [anon_sym_DASH_DASH] = ACTIONS(697),
    [anon_sym_DOT2] = ACTIONS(699),
    [anon_sym_COLON_COLON] = ACTIONS(697),
    [anon_sym_RBRACK] = ACTIONS(697),
    [anon_sym_DOTforeach] = ACTIONS(697),
  },
  [114] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_EQ] = ACTIONS(701),
    [anon_sym_BANG_EQ] = ACTIONS(701),
    [anon_sym_PLUS_EQ] = ACTIONS(701),
    [anon_sym_STAR_EQ] = ACTIONS(701),
    [anon_sym_SLASH_EQ] = ACTIONS(701),
    [anon_sym_PERCENT_EQ] = ACTIONS(701),
    [anon_sym_GT] = ACTIONS(703),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_2_GT] = ACTIONS(703),
    [anon_sym_2_GT_GT] = ACTIONS(701),
    [anon_sym_3_GT] = ACTIONS(703),
    [anon_sym_3_GT_GT] = ACTIONS(701),
    [anon_sym_4_GT] = ACTIONS(703),
    [anon_sym_4_GT_GT] = ACTIONS(701),
    [anon_sym_5_GT] = ACTIONS(703),
    [anon_sym_5_GT_GT] = ACTIONS(701),
    [anon_sym_6_GT] = ACTIONS(703),
    [anon_sym_6_GT_GT] = ACTIONS(701),
    [anon_sym_STAR_GT] = ACTIONS(703),
    [anon_sym_STAR_GT_GT] = ACTIONS(701),
    [anon_sym_LT] = ACTIONS(703),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(701),
    [anon_sym_2_GT_AMP1] = ACTIONS(701),
    [anon_sym_3_GT_AMP1] = ACTIONS(701),
    [anon_sym_4_GT_AMP1] = ACTIONS(701),
    [anon_sym_5_GT_AMP1] = ACTIONS(701),
    [anon_sym_6_GT_AMP1] = ACTIONS(701),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(701),
    [anon_sym_1_GT_AMP2] = ACTIONS(701),
    [anon_sym_3_GT_AMP2] = ACTIONS(701),
    [anon_sym_4_GT_AMP2] = ACTIONS(701),
    [anon_sym_5_GT_AMP2] = ACTIONS(701),
    [anon_sym_6_GT_AMP2] = ACTIONS(701),
    [anon_sym_DASHas] = ACTIONS(701),
    [anon_sym_DASHccontains] = ACTIONS(701),
    [anon_sym_DASHceq] = ACTIONS(701),
    [anon_sym_DASHcge] = ACTIONS(701),
    [anon_sym_DASHcgt] = ACTIONS(701),
    [anon_sym_DASHcle] = ACTIONS(701),
    [anon_sym_DASHclike] = ACTIONS(701),
    [anon_sym_DASHclt] = ACTIONS(701),
    [anon_sym_DASHcmatch] = ACTIONS(701),
    [anon_sym_DASHcne] = ACTIONS(701),
    [anon_sym_DASHcnotcontains] = ACTIONS(701),
    [anon_sym_DASHcnotlike] = ACTIONS(701),
    [anon_sym_DASHcnotmatch] = ACTIONS(701),
    [anon_sym_DASHcontains] = ACTIONS(701),
    [anon_sym_DASHcreplace] = ACTIONS(701),
    [anon_sym_DASHcsplit] = ACTIONS(701),
    [anon_sym_DASHeq] = ACTIONS(701),
    [anon_sym_DASHge] = ACTIONS(701),
    [anon_sym_DASHgt] = ACTIONS(701),
    [anon_sym_DASHicontains] = ACTIONS(701),
    [anon_sym_DASHieq] = ACTIONS(701),
    [anon_sym_DASHige] = ACTIONS(701),
    [anon_sym_DASHigt] = ACTIONS(701),
    [anon_sym_DASHile] = ACTIONS(701),
    [anon_sym_DASHilike] = ACTIONS(701),
    [anon_sym_DASHilt] = ACTIONS(701),
    [anon_sym_DASHimatch] = ACTIONS(701),
    [anon_sym_DASHin] = ACTIONS(703),
    [anon_sym_DASHine] = ACTIONS(701),
    [anon_sym_DASHinotcontains] = ACTIONS(701),
    [anon_sym_DASHinotlike] = ACTIONS(701),
    [anon_sym_DASHinotmatch] = ACTIONS(701),
    [anon_sym_DASHireplace] = ACTIONS(701),
    [anon_sym_DASHis] = ACTIONS(703),
    [anon_sym_DASHisnot] = ACTIONS(701),
    [anon_sym_DASHisplit] = ACTIONS(701),
    [anon_sym_DASHjoin] = ACTIONS(701),
    [anon_sym_DASHle] = ACTIONS(701),
    [anon_sym_DASHlike] = ACTIONS(701),
    [anon_sym_DASHlt] = ACTIONS(701),
    [anon_sym_DASHmatch] = ACTIONS(701),
    [anon_sym_DASHne] = ACTIONS(701),
    [anon_sym_DASHnotcontains] = ACTIONS(701),
    [anon_sym_DASHnotin] = ACTIONS(701),
    [anon_sym_DASHnotlike] = ACTIONS(701),
    [anon_sym_DASHnotmatch] = ACTIONS(701),
    [anon_sym_DASHreplace] = ACTIONS(701),
    [anon_sym_DASHshl] = ACTIONS(701),
    [anon_sym_DASHshr] = ACTIONS(701),
    [anon_sym_DASHsplit] = ACTIONS(701),
    [sym_format_operator] = ACTIONS(701),
    [anon_sym_LPAREN] = ACTIONS(701),
    [anon_sym_RPAREN] = ACTIONS(701),
    [anon_sym_COMMA] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_PERCENT] = ACTIONS(703),
    [anon_sym_DASHand] = ACTIONS(701),
    [anon_sym_DASHor] = ACTIONS(701),
    [anon_sym_DASHxor] = ACTIONS(701),
    [anon_sym_DASHband] = ACTIONS(701),
    [anon_sym_DASHbor] = ACTIONS(701),
    [anon_sym_DASHbxor] = ACTIONS(701),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_SLASH] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(701),
    [anon_sym_STAR] = ACTIONS(703),
    [anon_sym_DOT_DOT] = ACTIONS(701),
    [anon_sym_PLUS_PLUS] = ACTIONS(701),
    [anon_sym_DASH_DASH] = ACTIONS(701),
    [anon_sym_DOT2] = ACTIONS(703),
    [anon_sym_COLON_COLON] = ACTIONS(701),
    [anon_sym_RBRACK] = ACTIONS(701),
    [anon_sym_DOTforeach] = ACTIONS(701),
  },
  [115] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(705),
    [anon_sym_EQ] = ACTIONS(705),
    [anon_sym_BANG_EQ] = ACTIONS(705),
    [anon_sym_PLUS_EQ] = ACTIONS(705),
    [anon_sym_STAR_EQ] = ACTIONS(705),
    [anon_sym_SLASH_EQ] = ACTIONS(705),
    [anon_sym_PERCENT_EQ] = ACTIONS(705),
    [anon_sym_GT] = ACTIONS(707),
    [anon_sym_GT_GT] = ACTIONS(705),
    [anon_sym_2_GT] = ACTIONS(707),
    [anon_sym_2_GT_GT] = ACTIONS(705),
    [anon_sym_3_GT] = ACTIONS(707),
    [anon_sym_3_GT_GT] = ACTIONS(705),
    [anon_sym_4_GT] = ACTIONS(707),
    [anon_sym_4_GT_GT] = ACTIONS(705),
    [anon_sym_5_GT] = ACTIONS(707),
    [anon_sym_5_GT_GT] = ACTIONS(705),
    [anon_sym_6_GT] = ACTIONS(707),
    [anon_sym_6_GT_GT] = ACTIONS(705),
    [anon_sym_STAR_GT] = ACTIONS(707),
    [anon_sym_STAR_GT_GT] = ACTIONS(705),
    [anon_sym_LT] = ACTIONS(707),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(705),
    [anon_sym_2_GT_AMP1] = ACTIONS(705),
    [anon_sym_3_GT_AMP1] = ACTIONS(705),
    [anon_sym_4_GT_AMP1] = ACTIONS(705),
    [anon_sym_5_GT_AMP1] = ACTIONS(705),
    [anon_sym_6_GT_AMP1] = ACTIONS(705),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(705),
    [anon_sym_1_GT_AMP2] = ACTIONS(705),
    [anon_sym_3_GT_AMP2] = ACTIONS(705),
    [anon_sym_4_GT_AMP2] = ACTIONS(705),
    [anon_sym_5_GT_AMP2] = ACTIONS(705),
    [anon_sym_6_GT_AMP2] = ACTIONS(705),
    [anon_sym_DASHas] = ACTIONS(705),
    [anon_sym_DASHccontains] = ACTIONS(705),
    [anon_sym_DASHceq] = ACTIONS(705),
    [anon_sym_DASHcge] = ACTIONS(705),
    [anon_sym_DASHcgt] = ACTIONS(705),
    [anon_sym_DASHcle] = ACTIONS(705),
    [anon_sym_DASHclike] = ACTIONS(705),
    [anon_sym_DASHclt] = ACTIONS(705),
    [anon_sym_DASHcmatch] = ACTIONS(705),
    [anon_sym_DASHcne] = ACTIONS(705),
    [anon_sym_DASHcnotcontains] = ACTIONS(705),
    [anon_sym_DASHcnotlike] = ACTIONS(705),
    [anon_sym_DASHcnotmatch] = ACTIONS(705),
    [anon_sym_DASHcontains] = ACTIONS(705),
    [anon_sym_DASHcreplace] = ACTIONS(705),
    [anon_sym_DASHcsplit] = ACTIONS(705),
    [anon_sym_DASHeq] = ACTIONS(705),
    [anon_sym_DASHge] = ACTIONS(705),
    [anon_sym_DASHgt] = ACTIONS(705),
    [anon_sym_DASHicontains] = ACTIONS(705),
    [anon_sym_DASHieq] = ACTIONS(705),
    [anon_sym_DASHige] = ACTIONS(705),
    [anon_sym_DASHigt] = ACTIONS(705),
    [anon_sym_DASHile] = ACTIONS(705),
    [anon_sym_DASHilike] = ACTIONS(705),
    [anon_sym_DASHilt] = ACTIONS(705),
    [anon_sym_DASHimatch] = ACTIONS(705),
    [anon_sym_DASHin] = ACTIONS(707),
    [anon_sym_DASHine] = ACTIONS(705),
    [anon_sym_DASHinotcontains] = ACTIONS(705),
    [anon_sym_DASHinotlike] = ACTIONS(705),
    [anon_sym_DASHinotmatch] = ACTIONS(705),
    [anon_sym_DASHireplace] = ACTIONS(705),
    [anon_sym_DASHis] = ACTIONS(707),
    [anon_sym_DASHisnot] = ACTIONS(705),
    [anon_sym_DASHisplit] = ACTIONS(705),
    [anon_sym_DASHjoin] = ACTIONS(705),
    [anon_sym_DASHle] = ACTIONS(705),
    [anon_sym_DASHlike] = ACTIONS(705),
    [anon_sym_DASHlt] = ACTIONS(705),
    [anon_sym_DASHmatch] = ACTIONS(705),
    [anon_sym_DASHne] = ACTIONS(705),
    [anon_sym_DASHnotcontains] = ACTIONS(705),
    [anon_sym_DASHnotin] = ACTIONS(705),
    [anon_sym_DASHnotlike] = ACTIONS(705),
    [anon_sym_DASHnotmatch] = ACTIONS(705),
    [anon_sym_DASHreplace] = ACTIONS(705),
    [anon_sym_DASHshl] = ACTIONS(705),
    [anon_sym_DASHshr] = ACTIONS(705),
    [anon_sym_DASHsplit] = ACTIONS(705),
    [sym_format_operator] = ACTIONS(705),
    [anon_sym_LPAREN] = ACTIONS(705),
    [anon_sym_RPAREN] = ACTIONS(705),
    [anon_sym_COMMA] = ACTIONS(705),
    [anon_sym_PIPE] = ACTIONS(705),
    [anon_sym_PERCENT] = ACTIONS(707),
    [anon_sym_DASHand] = ACTIONS(705),
    [anon_sym_DASHor] = ACTIONS(705),
    [anon_sym_DASHxor] = ACTIONS(705),
    [anon_sym_DASHband] = ACTIONS(705),
    [anon_sym_DASHbor] = ACTIONS(705),
    [anon_sym_DASHbxor] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(707),
    [anon_sym_SLASH] = ACTIONS(707),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_STAR] = ACTIONS(707),
    [anon_sym_DOT_DOT] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(705),
    [anon_sym_DASH_DASH] = ACTIONS(705),
    [anon_sym_DOT2] = ACTIONS(707),
    [anon_sym_COLON_COLON] = ACTIONS(705),
    [anon_sym_RBRACK] = ACTIONS(705),
    [anon_sym_DOTforeach] = ACTIONS(705),
  },
  [116] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(709),
    [anon_sym_EQ] = ACTIONS(709),
    [anon_sym_BANG_EQ] = ACTIONS(709),
    [anon_sym_PLUS_EQ] = ACTIONS(709),
    [anon_sym_STAR_EQ] = ACTIONS(709),
    [anon_sym_SLASH_EQ] = ACTIONS(709),
    [anon_sym_PERCENT_EQ] = ACTIONS(709),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_GT] = ACTIONS(709),
    [anon_sym_2_GT] = ACTIONS(711),
    [anon_sym_2_GT_GT] = ACTIONS(709),
    [anon_sym_3_GT] = ACTIONS(711),
    [anon_sym_3_GT_GT] = ACTIONS(709),
    [anon_sym_4_GT] = ACTIONS(711),
    [anon_sym_4_GT_GT] = ACTIONS(709),
    [anon_sym_5_GT] = ACTIONS(711),
    [anon_sym_5_GT_GT] = ACTIONS(709),
    [anon_sym_6_GT] = ACTIONS(711),
    [anon_sym_6_GT_GT] = ACTIONS(709),
    [anon_sym_STAR_GT] = ACTIONS(711),
    [anon_sym_STAR_GT_GT] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(709),
    [anon_sym_2_GT_AMP1] = ACTIONS(709),
    [anon_sym_3_GT_AMP1] = ACTIONS(709),
    [anon_sym_4_GT_AMP1] = ACTIONS(709),
    [anon_sym_5_GT_AMP1] = ACTIONS(709),
    [anon_sym_6_GT_AMP1] = ACTIONS(709),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(709),
    [anon_sym_1_GT_AMP2] = ACTIONS(709),
    [anon_sym_3_GT_AMP2] = ACTIONS(709),
    [anon_sym_4_GT_AMP2] = ACTIONS(709),
    [anon_sym_5_GT_AMP2] = ACTIONS(709),
    [anon_sym_6_GT_AMP2] = ACTIONS(709),
    [anon_sym_DASHas] = ACTIONS(709),
    [anon_sym_DASHccontains] = ACTIONS(709),
    [anon_sym_DASHceq] = ACTIONS(709),
    [anon_sym_DASHcge] = ACTIONS(709),
    [anon_sym_DASHcgt] = ACTIONS(709),
    [anon_sym_DASHcle] = ACTIONS(709),
    [anon_sym_DASHclike] = ACTIONS(709),
    [anon_sym_DASHclt] = ACTIONS(709),
    [anon_sym_DASHcmatch] = ACTIONS(709),
    [anon_sym_DASHcne] = ACTIONS(709),
    [anon_sym_DASHcnotcontains] = ACTIONS(709),
    [anon_sym_DASHcnotlike] = ACTIONS(709),
    [anon_sym_DASHcnotmatch] = ACTIONS(709),
    [anon_sym_DASHcontains] = ACTIONS(709),
    [anon_sym_DASHcreplace] = ACTIONS(709),
    [anon_sym_DASHcsplit] = ACTIONS(709),
    [anon_sym_DASHeq] = ACTIONS(709),
    [anon_sym_DASHge] = ACTIONS(709),
    [anon_sym_DASHgt] = ACTIONS(709),
    [anon_sym_DASHicontains] = ACTIONS(709),
    [anon_sym_DASHieq] = ACTIONS(709),
    [anon_sym_DASHige] = ACTIONS(709),
    [anon_sym_DASHigt] = ACTIONS(709),
    [anon_sym_DASHile] = ACTIONS(709),
    [anon_sym_DASHilike] = ACTIONS(709),
    [anon_sym_DASHilt] = ACTIONS(709),
    [anon_sym_DASHimatch] = ACTIONS(709),
    [anon_sym_DASHin] = ACTIONS(711),
    [anon_sym_DASHine] = ACTIONS(709),
    [anon_sym_DASHinotcontains] = ACTIONS(709),
    [anon_sym_DASHinotlike] = ACTIONS(709),
    [anon_sym_DASHinotmatch] = ACTIONS(709),
    [anon_sym_DASHireplace] = ACTIONS(709),
    [anon_sym_DASHis] = ACTIONS(711),
    [anon_sym_DASHisnot] = ACTIONS(709),
    [anon_sym_DASHisplit] = ACTIONS(709),
    [anon_sym_DASHjoin] = ACTIONS(709),
    [anon_sym_DASHle] = ACTIONS(709),
    [anon_sym_DASHlike] = ACTIONS(709),
    [anon_sym_DASHlt] = ACTIONS(709),
    [anon_sym_DASHmatch] = ACTIONS(709),
    [anon_sym_DASHne] = ACTIONS(709),
    [anon_sym_DASHnotcontains] = ACTIONS(709),
    [anon_sym_DASHnotin] = ACTIONS(709),
    [anon_sym_DASHnotlike] = ACTIONS(709),
    [anon_sym_DASHnotmatch] = ACTIONS(709),
    [anon_sym_DASHreplace] = ACTIONS(709),
    [anon_sym_DASHshl] = ACTIONS(709),
    [anon_sym_DASHshr] = ACTIONS(709),
    [anon_sym_DASHsplit] = ACTIONS(709),
    [sym_format_operator] = ACTIONS(709),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_RPAREN] = ACTIONS(709),
    [anon_sym_COMMA] = ACTIONS(709),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_PERCENT] = ACTIONS(711),
    [anon_sym_DASHand] = ACTIONS(709),
    [anon_sym_DASHor] = ACTIONS(709),
    [anon_sym_DASHxor] = ACTIONS(709),
    [anon_sym_DASHband] = ACTIONS(709),
    [anon_sym_DASHbor] = ACTIONS(709),
    [anon_sym_DASHbxor] = ACTIONS(709),
    [anon_sym_PLUS] = ACTIONS(711),
    [anon_sym_DASH] = ACTIONS(711),
    [anon_sym_SLASH] = ACTIONS(711),
    [anon_sym_BSLASH] = ACTIONS(709),
    [anon_sym_STAR] = ACTIONS(711),
    [anon_sym_DOT_DOT] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(709),
    [anon_sym_DASH_DASH] = ACTIONS(709),
    [anon_sym_DOT2] = ACTIONS(711),
    [anon_sym_COLON_COLON] = ACTIONS(709),
    [anon_sym_RBRACK] = ACTIONS(709),
    [anon_sym_DOTforeach] = ACTIONS(709),
  },
  [117] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(713),
    [anon_sym_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_PLUS_EQ] = ACTIONS(713),
    [anon_sym_STAR_EQ] = ACTIONS(713),
    [anon_sym_SLASH_EQ] = ACTIONS(713),
    [anon_sym_PERCENT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(713),
    [anon_sym_2_GT] = ACTIONS(715),
    [anon_sym_2_GT_GT] = ACTIONS(713),
    [anon_sym_3_GT] = ACTIONS(715),
    [anon_sym_3_GT_GT] = ACTIONS(713),
    [anon_sym_4_GT] = ACTIONS(715),
    [anon_sym_4_GT_GT] = ACTIONS(713),
    [anon_sym_5_GT] = ACTIONS(715),
    [anon_sym_5_GT_GT] = ACTIONS(713),
    [anon_sym_6_GT] = ACTIONS(715),
    [anon_sym_6_GT_GT] = ACTIONS(713),
    [anon_sym_STAR_GT] = ACTIONS(715),
    [anon_sym_STAR_GT_GT] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(713),
    [anon_sym_2_GT_AMP1] = ACTIONS(713),
    [anon_sym_3_GT_AMP1] = ACTIONS(713),
    [anon_sym_4_GT_AMP1] = ACTIONS(713),
    [anon_sym_5_GT_AMP1] = ACTIONS(713),
    [anon_sym_6_GT_AMP1] = ACTIONS(713),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(713),
    [anon_sym_1_GT_AMP2] = ACTIONS(713),
    [anon_sym_3_GT_AMP2] = ACTIONS(713),
    [anon_sym_4_GT_AMP2] = ACTIONS(713),
    [anon_sym_5_GT_AMP2] = ACTIONS(713),
    [anon_sym_6_GT_AMP2] = ACTIONS(713),
    [anon_sym_DASHas] = ACTIONS(713),
    [anon_sym_DASHccontains] = ACTIONS(713),
    [anon_sym_DASHceq] = ACTIONS(713),
    [anon_sym_DASHcge] = ACTIONS(713),
    [anon_sym_DASHcgt] = ACTIONS(713),
    [anon_sym_DASHcle] = ACTIONS(713),
    [anon_sym_DASHclike] = ACTIONS(713),
    [anon_sym_DASHclt] = ACTIONS(713),
    [anon_sym_DASHcmatch] = ACTIONS(713),
    [anon_sym_DASHcne] = ACTIONS(713),
    [anon_sym_DASHcnotcontains] = ACTIONS(713),
    [anon_sym_DASHcnotlike] = ACTIONS(713),
    [anon_sym_DASHcnotmatch] = ACTIONS(713),
    [anon_sym_DASHcontains] = ACTIONS(713),
    [anon_sym_DASHcreplace] = ACTIONS(713),
    [anon_sym_DASHcsplit] = ACTIONS(713),
    [anon_sym_DASHeq] = ACTIONS(713),
    [anon_sym_DASHge] = ACTIONS(713),
    [anon_sym_DASHgt] = ACTIONS(713),
    [anon_sym_DASHicontains] = ACTIONS(713),
    [anon_sym_DASHieq] = ACTIONS(713),
    [anon_sym_DASHige] = ACTIONS(713),
    [anon_sym_DASHigt] = ACTIONS(713),
    [anon_sym_DASHile] = ACTIONS(713),
    [anon_sym_DASHilike] = ACTIONS(713),
    [anon_sym_DASHilt] = ACTIONS(713),
    [anon_sym_DASHimatch] = ACTIONS(713),
    [anon_sym_DASHin] = ACTIONS(715),
    [anon_sym_DASHine] = ACTIONS(713),
    [anon_sym_DASHinotcontains] = ACTIONS(713),
    [anon_sym_DASHinotlike] = ACTIONS(713),
    [anon_sym_DASHinotmatch] = ACTIONS(713),
    [anon_sym_DASHireplace] = ACTIONS(713),
    [anon_sym_DASHis] = ACTIONS(715),
    [anon_sym_DASHisnot] = ACTIONS(713),
    [anon_sym_DASHisplit] = ACTIONS(713),
    [anon_sym_DASHjoin] = ACTIONS(713),
    [anon_sym_DASHle] = ACTIONS(713),
    [anon_sym_DASHlike] = ACTIONS(713),
    [anon_sym_DASHlt] = ACTIONS(713),
    [anon_sym_DASHmatch] = ACTIONS(713),
    [anon_sym_DASHne] = ACTIONS(713),
    [anon_sym_DASHnotcontains] = ACTIONS(713),
    [anon_sym_DASHnotin] = ACTIONS(713),
    [anon_sym_DASHnotlike] = ACTIONS(713),
    [anon_sym_DASHnotmatch] = ACTIONS(713),
    [anon_sym_DASHreplace] = ACTIONS(713),
    [anon_sym_DASHshl] = ACTIONS(713),
    [anon_sym_DASHshr] = ACTIONS(713),
    [anon_sym_DASHsplit] = ACTIONS(713),
    [sym_format_operator] = ACTIONS(713),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(713),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_DASHand] = ACTIONS(713),
    [anon_sym_DASHor] = ACTIONS(713),
    [anon_sym_DASHxor] = ACTIONS(713),
    [anon_sym_DASHband] = ACTIONS(713),
    [anon_sym_DASHbor] = ACTIONS(713),
    [anon_sym_DASHbxor] = ACTIONS(713),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_BSLASH] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_DOT_DOT] = ACTIONS(713),
    [anon_sym_PLUS_PLUS] = ACTIONS(713),
    [anon_sym_DASH_DASH] = ACTIONS(713),
    [anon_sym_DOT2] = ACTIONS(715),
    [anon_sym_COLON_COLON] = ACTIONS(713),
    [anon_sym_RBRACK] = ACTIONS(713),
    [anon_sym_DOTforeach] = ACTIONS(713),
  },
  [118] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(717),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_BANG_EQ] = ACTIONS(717),
    [anon_sym_PLUS_EQ] = ACTIONS(717),
    [anon_sym_STAR_EQ] = ACTIONS(717),
    [anon_sym_SLASH_EQ] = ACTIONS(717),
    [anon_sym_PERCENT_EQ] = ACTIONS(717),
    [anon_sym_GT] = ACTIONS(719),
    [anon_sym_GT_GT] = ACTIONS(717),
    [anon_sym_2_GT] = ACTIONS(719),
    [anon_sym_2_GT_GT] = ACTIONS(717),
    [anon_sym_3_GT] = ACTIONS(719),
    [anon_sym_3_GT_GT] = ACTIONS(717),
    [anon_sym_4_GT] = ACTIONS(719),
    [anon_sym_4_GT_GT] = ACTIONS(717),
    [anon_sym_5_GT] = ACTIONS(719),
    [anon_sym_5_GT_GT] = ACTIONS(717),
    [anon_sym_6_GT] = ACTIONS(719),
    [anon_sym_6_GT_GT] = ACTIONS(717),
    [anon_sym_STAR_GT] = ACTIONS(719),
    [anon_sym_STAR_GT_GT] = ACTIONS(717),
    [anon_sym_LT] = ACTIONS(719),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(717),
    [anon_sym_2_GT_AMP1] = ACTIONS(717),
    [anon_sym_3_GT_AMP1] = ACTIONS(717),
    [anon_sym_4_GT_AMP1] = ACTIONS(717),
    [anon_sym_5_GT_AMP1] = ACTIONS(717),
    [anon_sym_6_GT_AMP1] = ACTIONS(717),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(717),
    [anon_sym_1_GT_AMP2] = ACTIONS(717),
    [anon_sym_3_GT_AMP2] = ACTIONS(717),
    [anon_sym_4_GT_AMP2] = ACTIONS(717),
    [anon_sym_5_GT_AMP2] = ACTIONS(717),
    [anon_sym_6_GT_AMP2] = ACTIONS(717),
    [anon_sym_DASHas] = ACTIONS(717),
    [anon_sym_DASHccontains] = ACTIONS(717),
    [anon_sym_DASHceq] = ACTIONS(717),
    [anon_sym_DASHcge] = ACTIONS(717),
    [anon_sym_DASHcgt] = ACTIONS(717),
    [anon_sym_DASHcle] = ACTIONS(717),
    [anon_sym_DASHclike] = ACTIONS(717),
    [anon_sym_DASHclt] = ACTIONS(717),
    [anon_sym_DASHcmatch] = ACTIONS(717),
    [anon_sym_DASHcne] = ACTIONS(717),
    [anon_sym_DASHcnotcontains] = ACTIONS(717),
    [anon_sym_DASHcnotlike] = ACTIONS(717),
    [anon_sym_DASHcnotmatch] = ACTIONS(717),
    [anon_sym_DASHcontains] = ACTIONS(717),
    [anon_sym_DASHcreplace] = ACTIONS(717),
    [anon_sym_DASHcsplit] = ACTIONS(717),
    [anon_sym_DASHeq] = ACTIONS(717),
    [anon_sym_DASHge] = ACTIONS(717),
    [anon_sym_DASHgt] = ACTIONS(717),
    [anon_sym_DASHicontains] = ACTIONS(717),
    [anon_sym_DASHieq] = ACTIONS(717),
    [anon_sym_DASHige] = ACTIONS(717),
    [anon_sym_DASHigt] = ACTIONS(717),
    [anon_sym_DASHile] = ACTIONS(717),
    [anon_sym_DASHilike] = ACTIONS(717),
    [anon_sym_DASHilt] = ACTIONS(717),
    [anon_sym_DASHimatch] = ACTIONS(717),
    [anon_sym_DASHin] = ACTIONS(719),
    [anon_sym_DASHine] = ACTIONS(717),
    [anon_sym_DASHinotcontains] = ACTIONS(717),
    [anon_sym_DASHinotlike] = ACTIONS(717),
    [anon_sym_DASHinotmatch] = ACTIONS(717),
    [anon_sym_DASHireplace] = ACTIONS(717),
    [anon_sym_DASHis] = ACTIONS(719),
    [anon_sym_DASHisnot] = ACTIONS(717),
    [anon_sym_DASHisplit] = ACTIONS(717),
    [anon_sym_DASHjoin] = ACTIONS(717),
    [anon_sym_DASHle] = ACTIONS(717),
    [anon_sym_DASHlike] = ACTIONS(717),
    [anon_sym_DASHlt] = ACTIONS(717),
    [anon_sym_DASHmatch] = ACTIONS(717),
    [anon_sym_DASHne] = ACTIONS(717),
    [anon_sym_DASHnotcontains] = ACTIONS(717),
    [anon_sym_DASHnotin] = ACTIONS(717),
    [anon_sym_DASHnotlike] = ACTIONS(717),
    [anon_sym_DASHnotmatch] = ACTIONS(717),
    [anon_sym_DASHreplace] = ACTIONS(717),
    [anon_sym_DASHshl] = ACTIONS(717),
    [anon_sym_DASHshr] = ACTIONS(717),
    [anon_sym_DASHsplit] = ACTIONS(717),
    [sym_format_operator] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(717),
    [anon_sym_RPAREN] = ACTIONS(717),
    [anon_sym_COMMA] = ACTIONS(717),
    [anon_sym_PIPE] = ACTIONS(717),
    [anon_sym_PERCENT] = ACTIONS(719),
    [anon_sym_DASHand] = ACTIONS(717),
    [anon_sym_DASHor] = ACTIONS(717),
    [anon_sym_DASHxor] = ACTIONS(717),
    [anon_sym_DASHband] = ACTIONS(717),
    [anon_sym_DASHbor] = ACTIONS(717),
    [anon_sym_DASHbxor] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_SLASH] = ACTIONS(719),
    [anon_sym_BSLASH] = ACTIONS(717),
    [anon_sym_STAR] = ACTIONS(719),
    [anon_sym_DOT_DOT] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_DOT2] = ACTIONS(719),
    [anon_sym_COLON_COLON] = ACTIONS(717),
    [anon_sym_RBRACK] = ACTIONS(717),
    [anon_sym_DOTforeach] = ACTIONS(717),
  },
  [119] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(721),
    [anon_sym_EQ] = ACTIONS(721),
    [anon_sym_BANG_EQ] = ACTIONS(721),
    [anon_sym_PLUS_EQ] = ACTIONS(721),
    [anon_sym_STAR_EQ] = ACTIONS(721),
    [anon_sym_SLASH_EQ] = ACTIONS(721),
    [anon_sym_PERCENT_EQ] = ACTIONS(721),
    [anon_sym_GT] = ACTIONS(723),
    [anon_sym_GT_GT] = ACTIONS(721),
    [anon_sym_2_GT] = ACTIONS(723),
    [anon_sym_2_GT_GT] = ACTIONS(721),
    [anon_sym_3_GT] = ACTIONS(723),
    [anon_sym_3_GT_GT] = ACTIONS(721),
    [anon_sym_4_GT] = ACTIONS(723),
    [anon_sym_4_GT_GT] = ACTIONS(721),
    [anon_sym_5_GT] = ACTIONS(723),
    [anon_sym_5_GT_GT] = ACTIONS(721),
    [anon_sym_6_GT] = ACTIONS(723),
    [anon_sym_6_GT_GT] = ACTIONS(721),
    [anon_sym_STAR_GT] = ACTIONS(723),
    [anon_sym_STAR_GT_GT] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(721),
    [anon_sym_2_GT_AMP1] = ACTIONS(721),
    [anon_sym_3_GT_AMP1] = ACTIONS(721),
    [anon_sym_4_GT_AMP1] = ACTIONS(721),
    [anon_sym_5_GT_AMP1] = ACTIONS(721),
    [anon_sym_6_GT_AMP1] = ACTIONS(721),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(721),
    [anon_sym_1_GT_AMP2] = ACTIONS(721),
    [anon_sym_3_GT_AMP2] = ACTIONS(721),
    [anon_sym_4_GT_AMP2] = ACTIONS(721),
    [anon_sym_5_GT_AMP2] = ACTIONS(721),
    [anon_sym_6_GT_AMP2] = ACTIONS(721),
    [anon_sym_DASHas] = ACTIONS(721),
    [anon_sym_DASHccontains] = ACTIONS(721),
    [anon_sym_DASHceq] = ACTIONS(721),
    [anon_sym_DASHcge] = ACTIONS(721),
    [anon_sym_DASHcgt] = ACTIONS(721),
    [anon_sym_DASHcle] = ACTIONS(721),
    [anon_sym_DASHclike] = ACTIONS(721),
    [anon_sym_DASHclt] = ACTIONS(721),
    [anon_sym_DASHcmatch] = ACTIONS(721),
    [anon_sym_DASHcne] = ACTIONS(721),
    [anon_sym_DASHcnotcontains] = ACTIONS(721),
    [anon_sym_DASHcnotlike] = ACTIONS(721),
    [anon_sym_DASHcnotmatch] = ACTIONS(721),
    [anon_sym_DASHcontains] = ACTIONS(721),
    [anon_sym_DASHcreplace] = ACTIONS(721),
    [anon_sym_DASHcsplit] = ACTIONS(721),
    [anon_sym_DASHeq] = ACTIONS(721),
    [anon_sym_DASHge] = ACTIONS(721),
    [anon_sym_DASHgt] = ACTIONS(721),
    [anon_sym_DASHicontains] = ACTIONS(721),
    [anon_sym_DASHieq] = ACTIONS(721),
    [anon_sym_DASHige] = ACTIONS(721),
    [anon_sym_DASHigt] = ACTIONS(721),
    [anon_sym_DASHile] = ACTIONS(721),
    [anon_sym_DASHilike] = ACTIONS(721),
    [anon_sym_DASHilt] = ACTIONS(721),
    [anon_sym_DASHimatch] = ACTIONS(721),
    [anon_sym_DASHin] = ACTIONS(723),
    [anon_sym_DASHine] = ACTIONS(721),
    [anon_sym_DASHinotcontains] = ACTIONS(721),
    [anon_sym_DASHinotlike] = ACTIONS(721),
    [anon_sym_DASHinotmatch] = ACTIONS(721),
    [anon_sym_DASHireplace] = ACTIONS(721),
    [anon_sym_DASHis] = ACTIONS(723),
    [anon_sym_DASHisnot] = ACTIONS(721),
    [anon_sym_DASHisplit] = ACTIONS(721),
    [anon_sym_DASHjoin] = ACTIONS(721),
    [anon_sym_DASHle] = ACTIONS(721),
    [anon_sym_DASHlike] = ACTIONS(721),
    [anon_sym_DASHlt] = ACTIONS(721),
    [anon_sym_DASHmatch] = ACTIONS(721),
    [anon_sym_DASHne] = ACTIONS(721),
    [anon_sym_DASHnotcontains] = ACTIONS(721),
    [anon_sym_DASHnotin] = ACTIONS(721),
    [anon_sym_DASHnotlike] = ACTIONS(721),
    [anon_sym_DASHnotmatch] = ACTIONS(721),
    [anon_sym_DASHreplace] = ACTIONS(721),
    [anon_sym_DASHshl] = ACTIONS(721),
    [anon_sym_DASHshr] = ACTIONS(721),
    [anon_sym_DASHsplit] = ACTIONS(721),
    [sym_format_operator] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(721),
    [anon_sym_RPAREN] = ACTIONS(721),
    [anon_sym_COMMA] = ACTIONS(721),
    [anon_sym_PIPE] = ACTIONS(721),
    [anon_sym_PERCENT] = ACTIONS(723),
    [anon_sym_DASHand] = ACTIONS(721),
    [anon_sym_DASHor] = ACTIONS(721),
    [anon_sym_DASHxor] = ACTIONS(721),
    [anon_sym_DASHband] = ACTIONS(721),
    [anon_sym_DASHbor] = ACTIONS(721),
    [anon_sym_DASHbxor] = ACTIONS(721),
    [anon_sym_PLUS] = ACTIONS(723),
    [anon_sym_DASH] = ACTIONS(723),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_BSLASH] = ACTIONS(721),
    [anon_sym_STAR] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(721),
    [anon_sym_PLUS_PLUS] = ACTIONS(721),
    [anon_sym_DASH_DASH] = ACTIONS(721),
    [anon_sym_DOT2] = ACTIONS(723),
    [anon_sym_COLON_COLON] = ACTIONS(721),
    [anon_sym_RBRACK] = ACTIONS(721),
    [anon_sym_DOTforeach] = ACTIONS(721),
  },
  [120] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_GT] = ACTIONS(727),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_2_GT] = ACTIONS(727),
    [anon_sym_2_GT_GT] = ACTIONS(725),
    [anon_sym_3_GT] = ACTIONS(727),
    [anon_sym_3_GT_GT] = ACTIONS(725),
    [anon_sym_4_GT] = ACTIONS(727),
    [anon_sym_4_GT_GT] = ACTIONS(725),
    [anon_sym_5_GT] = ACTIONS(727),
    [anon_sym_5_GT_GT] = ACTIONS(725),
    [anon_sym_6_GT] = ACTIONS(727),
    [anon_sym_6_GT_GT] = ACTIONS(725),
    [anon_sym_STAR_GT] = ACTIONS(727),
    [anon_sym_STAR_GT_GT] = ACTIONS(725),
    [anon_sym_LT] = ACTIONS(727),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(725),
    [anon_sym_2_GT_AMP1] = ACTIONS(725),
    [anon_sym_3_GT_AMP1] = ACTIONS(725),
    [anon_sym_4_GT_AMP1] = ACTIONS(725),
    [anon_sym_5_GT_AMP1] = ACTIONS(725),
    [anon_sym_6_GT_AMP1] = ACTIONS(725),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(725),
    [anon_sym_1_GT_AMP2] = ACTIONS(725),
    [anon_sym_3_GT_AMP2] = ACTIONS(725),
    [anon_sym_4_GT_AMP2] = ACTIONS(725),
    [anon_sym_5_GT_AMP2] = ACTIONS(725),
    [anon_sym_6_GT_AMP2] = ACTIONS(725),
    [anon_sym_DASHas] = ACTIONS(725),
    [anon_sym_DASHccontains] = ACTIONS(725),
    [anon_sym_DASHceq] = ACTIONS(725),
    [anon_sym_DASHcge] = ACTIONS(725),
    [anon_sym_DASHcgt] = ACTIONS(725),
    [anon_sym_DASHcle] = ACTIONS(725),
    [anon_sym_DASHclike] = ACTIONS(725),
    [anon_sym_DASHclt] = ACTIONS(725),
    [anon_sym_DASHcmatch] = ACTIONS(725),
    [anon_sym_DASHcne] = ACTIONS(725),
    [anon_sym_DASHcnotcontains] = ACTIONS(725),
    [anon_sym_DASHcnotlike] = ACTIONS(725),
    [anon_sym_DASHcnotmatch] = ACTIONS(725),
    [anon_sym_DASHcontains] = ACTIONS(725),
    [anon_sym_DASHcreplace] = ACTIONS(725),
    [anon_sym_DASHcsplit] = ACTIONS(725),
    [anon_sym_DASHeq] = ACTIONS(725),
    [anon_sym_DASHge] = ACTIONS(725),
    [anon_sym_DASHgt] = ACTIONS(725),
    [anon_sym_DASHicontains] = ACTIONS(725),
    [anon_sym_DASHieq] = ACTIONS(725),
    [anon_sym_DASHige] = ACTIONS(725),
    [anon_sym_DASHigt] = ACTIONS(725),
    [anon_sym_DASHile] = ACTIONS(725),
    [anon_sym_DASHilike] = ACTIONS(725),
    [anon_sym_DASHilt] = ACTIONS(725),
    [anon_sym_DASHimatch] = ACTIONS(725),
    [anon_sym_DASHin] = ACTIONS(727),
    [anon_sym_DASHine] = ACTIONS(725),
    [anon_sym_DASHinotcontains] = ACTIONS(725),
    [anon_sym_DASHinotlike] = ACTIONS(725),
    [anon_sym_DASHinotmatch] = ACTIONS(725),
    [anon_sym_DASHireplace] = ACTIONS(725),
    [anon_sym_DASHis] = ACTIONS(727),
    [anon_sym_DASHisnot] = ACTIONS(725),
    [anon_sym_DASHisplit] = ACTIONS(725),
    [anon_sym_DASHjoin] = ACTIONS(725),
    [anon_sym_DASHle] = ACTIONS(725),
    [anon_sym_DASHlike] = ACTIONS(725),
    [anon_sym_DASHlt] = ACTIONS(725),
    [anon_sym_DASHmatch] = ACTIONS(725),
    [anon_sym_DASHne] = ACTIONS(725),
    [anon_sym_DASHnotcontains] = ACTIONS(725),
    [anon_sym_DASHnotin] = ACTIONS(725),
    [anon_sym_DASHnotlike] = ACTIONS(725),
    [anon_sym_DASHnotmatch] = ACTIONS(725),
    [anon_sym_DASHreplace] = ACTIONS(725),
    [anon_sym_DASHshl] = ACTIONS(725),
    [anon_sym_DASHshr] = ACTIONS(725),
    [anon_sym_DASHsplit] = ACTIONS(725),
    [sym_format_operator] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(727),
    [anon_sym_DASHand] = ACTIONS(725),
    [anon_sym_DASHor] = ACTIONS(725),
    [anon_sym_DASHxor] = ACTIONS(725),
    [anon_sym_DASHband] = ACTIONS(725),
    [anon_sym_DASHbor] = ACTIONS(725),
    [anon_sym_DASHbxor] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(727),
    [anon_sym_DASH] = ACTIONS(727),
    [anon_sym_SLASH] = ACTIONS(727),
    [anon_sym_BSLASH] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(727),
    [anon_sym_DOT_DOT] = ACTIONS(725),
    [anon_sym_PLUS_PLUS] = ACTIONS(725),
    [anon_sym_DASH_DASH] = ACTIONS(725),
    [anon_sym_DOT2] = ACTIONS(727),
    [anon_sym_COLON_COLON] = ACTIONS(725),
    [anon_sym_RBRACK] = ACTIONS(725),
    [anon_sym_DOTforeach] = ACTIONS(725),
  },
  [121] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_EQ] = ACTIONS(729),
    [anon_sym_BANG_EQ] = ACTIONS(729),
    [anon_sym_PLUS_EQ] = ACTIONS(729),
    [anon_sym_STAR_EQ] = ACTIONS(729),
    [anon_sym_SLASH_EQ] = ACTIONS(729),
    [anon_sym_PERCENT_EQ] = ACTIONS(729),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(729),
    [anon_sym_2_GT] = ACTIONS(731),
    [anon_sym_2_GT_GT] = ACTIONS(729),
    [anon_sym_3_GT] = ACTIONS(731),
    [anon_sym_3_GT_GT] = ACTIONS(729),
    [anon_sym_4_GT] = ACTIONS(731),
    [anon_sym_4_GT_GT] = ACTIONS(729),
    [anon_sym_5_GT] = ACTIONS(731),
    [anon_sym_5_GT_GT] = ACTIONS(729),
    [anon_sym_6_GT] = ACTIONS(731),
    [anon_sym_6_GT_GT] = ACTIONS(729),
    [anon_sym_STAR_GT] = ACTIONS(731),
    [anon_sym_STAR_GT_GT] = ACTIONS(729),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(729),
    [anon_sym_2_GT_AMP1] = ACTIONS(729),
    [anon_sym_3_GT_AMP1] = ACTIONS(729),
    [anon_sym_4_GT_AMP1] = ACTIONS(729),
    [anon_sym_5_GT_AMP1] = ACTIONS(729),
    [anon_sym_6_GT_AMP1] = ACTIONS(729),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(729),
    [anon_sym_1_GT_AMP2] = ACTIONS(729),
    [anon_sym_3_GT_AMP2] = ACTIONS(729),
    [anon_sym_4_GT_AMP2] = ACTIONS(729),
    [anon_sym_5_GT_AMP2] = ACTIONS(729),
    [anon_sym_6_GT_AMP2] = ACTIONS(729),
    [anon_sym_DASHas] = ACTIONS(729),
    [anon_sym_DASHccontains] = ACTIONS(729),
    [anon_sym_DASHceq] = ACTIONS(729),
    [anon_sym_DASHcge] = ACTIONS(729),
    [anon_sym_DASHcgt] = ACTIONS(729),
    [anon_sym_DASHcle] = ACTIONS(729),
    [anon_sym_DASHclike] = ACTIONS(729),
    [anon_sym_DASHclt] = ACTIONS(729),
    [anon_sym_DASHcmatch] = ACTIONS(729),
    [anon_sym_DASHcne] = ACTIONS(729),
    [anon_sym_DASHcnotcontains] = ACTIONS(729),
    [anon_sym_DASHcnotlike] = ACTIONS(729),
    [anon_sym_DASHcnotmatch] = ACTIONS(729),
    [anon_sym_DASHcontains] = ACTIONS(729),
    [anon_sym_DASHcreplace] = ACTIONS(729),
    [anon_sym_DASHcsplit] = ACTIONS(729),
    [anon_sym_DASHeq] = ACTIONS(729),
    [anon_sym_DASHge] = ACTIONS(729),
    [anon_sym_DASHgt] = ACTIONS(729),
    [anon_sym_DASHicontains] = ACTIONS(729),
    [anon_sym_DASHieq] = ACTIONS(729),
    [anon_sym_DASHige] = ACTIONS(729),
    [anon_sym_DASHigt] = ACTIONS(729),
    [anon_sym_DASHile] = ACTIONS(729),
    [anon_sym_DASHilike] = ACTIONS(729),
    [anon_sym_DASHilt] = ACTIONS(729),
    [anon_sym_DASHimatch] = ACTIONS(729),
    [anon_sym_DASHin] = ACTIONS(731),
    [anon_sym_DASHine] = ACTIONS(729),
    [anon_sym_DASHinotcontains] = ACTIONS(729),
    [anon_sym_DASHinotlike] = ACTIONS(729),
    [anon_sym_DASHinotmatch] = ACTIONS(729),
    [anon_sym_DASHireplace] = ACTIONS(729),
    [anon_sym_DASHis] = ACTIONS(731),
    [anon_sym_DASHisnot] = ACTIONS(729),
    [anon_sym_DASHisplit] = ACTIONS(729),
    [anon_sym_DASHjoin] = ACTIONS(729),
    [anon_sym_DASHle] = ACTIONS(729),
    [anon_sym_DASHlike] = ACTIONS(729),
    [anon_sym_DASHlt] = ACTIONS(729),
    [anon_sym_DASHmatch] = ACTIONS(729),
    [anon_sym_DASHne] = ACTIONS(729),
    [anon_sym_DASHnotcontains] = ACTIONS(729),
    [anon_sym_DASHnotin] = ACTIONS(729),
    [anon_sym_DASHnotlike] = ACTIONS(729),
    [anon_sym_DASHnotmatch] = ACTIONS(729),
    [anon_sym_DASHreplace] = ACTIONS(729),
    [anon_sym_DASHshl] = ACTIONS(729),
    [anon_sym_DASHshr] = ACTIONS(729),
    [anon_sym_DASHsplit] = ACTIONS(729),
    [sym_format_operator] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(729),
    [anon_sym_RPAREN] = ACTIONS(729),
    [anon_sym_COMMA] = ACTIONS(729),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_DASHand] = ACTIONS(729),
    [anon_sym_DASHor] = ACTIONS(729),
    [anon_sym_DASHxor] = ACTIONS(729),
    [anon_sym_DASHband] = ACTIONS(729),
    [anon_sym_DASHbor] = ACTIONS(729),
    [anon_sym_DASHbxor] = ACTIONS(729),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(731),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_BSLASH] = ACTIONS(729),
    [anon_sym_STAR] = ACTIONS(731),
    [anon_sym_DOT_DOT] = ACTIONS(729),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DOT2] = ACTIONS(731),
    [anon_sym_COLON_COLON] = ACTIONS(729),
    [anon_sym_RBRACK] = ACTIONS(729),
    [anon_sym_DOTforeach] = ACTIONS(729),
  },
  [122] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_EQ] = ACTIONS(639),
    [anon_sym_BANG_EQ] = ACTIONS(639),
    [anon_sym_PLUS_EQ] = ACTIONS(639),
    [anon_sym_STAR_EQ] = ACTIONS(639),
    [anon_sym_SLASH_EQ] = ACTIONS(639),
    [anon_sym_PERCENT_EQ] = ACTIONS(639),
    [anon_sym_GT] = ACTIONS(641),
    [anon_sym_GT_GT] = ACTIONS(639),
    [anon_sym_2_GT] = ACTIONS(641),
    [anon_sym_2_GT_GT] = ACTIONS(639),
    [anon_sym_3_GT] = ACTIONS(641),
    [anon_sym_3_GT_GT] = ACTIONS(639),
    [anon_sym_4_GT] = ACTIONS(641),
    [anon_sym_4_GT_GT] = ACTIONS(639),
    [anon_sym_5_GT] = ACTIONS(641),
    [anon_sym_5_GT_GT] = ACTIONS(639),
    [anon_sym_6_GT] = ACTIONS(641),
    [anon_sym_6_GT_GT] = ACTIONS(639),
    [anon_sym_STAR_GT] = ACTIONS(641),
    [anon_sym_STAR_GT_GT] = ACTIONS(639),
    [anon_sym_LT] = ACTIONS(641),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(639),
    [anon_sym_2_GT_AMP1] = ACTIONS(639),
    [anon_sym_3_GT_AMP1] = ACTIONS(639),
    [anon_sym_4_GT_AMP1] = ACTIONS(639),
    [anon_sym_5_GT_AMP1] = ACTIONS(639),
    [anon_sym_6_GT_AMP1] = ACTIONS(639),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(639),
    [anon_sym_1_GT_AMP2] = ACTIONS(639),
    [anon_sym_3_GT_AMP2] = ACTIONS(639),
    [anon_sym_4_GT_AMP2] = ACTIONS(639),
    [anon_sym_5_GT_AMP2] = ACTIONS(639),
    [anon_sym_6_GT_AMP2] = ACTIONS(639),
    [anon_sym_DASHas] = ACTIONS(639),
    [anon_sym_DASHccontains] = ACTIONS(639),
    [anon_sym_DASHceq] = ACTIONS(639),
    [anon_sym_DASHcge] = ACTIONS(639),
    [anon_sym_DASHcgt] = ACTIONS(639),
    [anon_sym_DASHcle] = ACTIONS(639),
    [anon_sym_DASHclike] = ACTIONS(639),
    [anon_sym_DASHclt] = ACTIONS(639),
    [anon_sym_DASHcmatch] = ACTIONS(639),
    [anon_sym_DASHcne] = ACTIONS(639),
    [anon_sym_DASHcnotcontains] = ACTIONS(639),
    [anon_sym_DASHcnotlike] = ACTIONS(639),
    [anon_sym_DASHcnotmatch] = ACTIONS(639),
    [anon_sym_DASHcontains] = ACTIONS(639),
    [anon_sym_DASHcreplace] = ACTIONS(639),
    [anon_sym_DASHcsplit] = ACTIONS(639),
    [anon_sym_DASHeq] = ACTIONS(639),
    [anon_sym_DASHge] = ACTIONS(639),
    [anon_sym_DASHgt] = ACTIONS(639),
    [anon_sym_DASHicontains] = ACTIONS(639),
    [anon_sym_DASHieq] = ACTIONS(639),
    [anon_sym_DASHige] = ACTIONS(639),
    [anon_sym_DASHigt] = ACTIONS(639),
    [anon_sym_DASHile] = ACTIONS(639),
    [anon_sym_DASHilike] = ACTIONS(639),
    [anon_sym_DASHilt] = ACTIONS(639),
    [anon_sym_DASHimatch] = ACTIONS(639),
    [anon_sym_DASHin] = ACTIONS(641),
    [anon_sym_DASHine] = ACTIONS(639),
    [anon_sym_DASHinotcontains] = ACTIONS(639),
    [anon_sym_DASHinotlike] = ACTIONS(639),
    [anon_sym_DASHinotmatch] = ACTIONS(639),
    [anon_sym_DASHireplace] = ACTIONS(639),
    [anon_sym_DASHis] = ACTIONS(641),
    [anon_sym_DASHisnot] = ACTIONS(639),
    [anon_sym_DASHisplit] = ACTIONS(639),
    [anon_sym_DASHjoin] = ACTIONS(639),
    [anon_sym_DASHle] = ACTIONS(639),
    [anon_sym_DASHlike] = ACTIONS(639),
    [anon_sym_DASHlt] = ACTIONS(639),
    [anon_sym_DASHmatch] = ACTIONS(639),
    [anon_sym_DASHne] = ACTIONS(639),
    [anon_sym_DASHnotcontains] = ACTIONS(639),
    [anon_sym_DASHnotin] = ACTIONS(639),
    [anon_sym_DASHnotlike] = ACTIONS(639),
    [anon_sym_DASHnotmatch] = ACTIONS(639),
    [anon_sym_DASHreplace] = ACTIONS(639),
    [anon_sym_DASHshl] = ACTIONS(639),
    [anon_sym_DASHshr] = ACTIONS(639),
    [anon_sym_DASHsplit] = ACTIONS(639),
    [sym_format_operator] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_COMMA] = ACTIONS(639),
    [anon_sym_PIPE] = ACTIONS(639),
    [anon_sym_PERCENT] = ACTIONS(641),
    [anon_sym_DASHand] = ACTIONS(639),
    [anon_sym_DASHor] = ACTIONS(639),
    [anon_sym_DASHxor] = ACTIONS(639),
    [anon_sym_DASHband] = ACTIONS(639),
    [anon_sym_DASHbor] = ACTIONS(639),
    [anon_sym_DASHbxor] = ACTIONS(639),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_DASH] = ACTIONS(641),
    [anon_sym_SLASH] = ACTIONS(641),
    [anon_sym_BSLASH] = ACTIONS(639),
    [anon_sym_STAR] = ACTIONS(641),
    [anon_sym_DOT_DOT] = ACTIONS(639),
    [anon_sym_PLUS_PLUS] = ACTIONS(639),
    [anon_sym_DASH_DASH] = ACTIONS(639),
    [anon_sym_DOT2] = ACTIONS(641),
    [anon_sym_COLON_COLON] = ACTIONS(639),
    [anon_sym_DOTforeach] = ACTIONS(639),
    [sym__statement_terminator] = ACTIONS(639),
  },
  [123] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_EQ] = ACTIONS(669),
    [anon_sym_BANG_EQ] = ACTIONS(669),
    [anon_sym_PLUS_EQ] = ACTIONS(669),
    [anon_sym_STAR_EQ] = ACTIONS(669),
    [anon_sym_SLASH_EQ] = ACTIONS(669),
    [anon_sym_PERCENT_EQ] = ACTIONS(669),
    [anon_sym_GT] = ACTIONS(671),
    [anon_sym_GT_GT] = ACTIONS(669),
    [anon_sym_2_GT] = ACTIONS(671),
    [anon_sym_2_GT_GT] = ACTIONS(669),
    [anon_sym_3_GT] = ACTIONS(671),
    [anon_sym_3_GT_GT] = ACTIONS(669),
    [anon_sym_4_GT] = ACTIONS(671),
    [anon_sym_4_GT_GT] = ACTIONS(669),
    [anon_sym_5_GT] = ACTIONS(671),
    [anon_sym_5_GT_GT] = ACTIONS(669),
    [anon_sym_6_GT] = ACTIONS(671),
    [anon_sym_6_GT_GT] = ACTIONS(669),
    [anon_sym_STAR_GT] = ACTIONS(671),
    [anon_sym_STAR_GT_GT] = ACTIONS(669),
    [anon_sym_LT] = ACTIONS(671),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(669),
    [anon_sym_2_GT_AMP1] = ACTIONS(669),
    [anon_sym_3_GT_AMP1] = ACTIONS(669),
    [anon_sym_4_GT_AMP1] = ACTIONS(669),
    [anon_sym_5_GT_AMP1] = ACTIONS(669),
    [anon_sym_6_GT_AMP1] = ACTIONS(669),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(669),
    [anon_sym_1_GT_AMP2] = ACTIONS(669),
    [anon_sym_3_GT_AMP2] = ACTIONS(669),
    [anon_sym_4_GT_AMP2] = ACTIONS(669),
    [anon_sym_5_GT_AMP2] = ACTIONS(669),
    [anon_sym_6_GT_AMP2] = ACTIONS(669),
    [anon_sym_DASHas] = ACTIONS(669),
    [anon_sym_DASHccontains] = ACTIONS(669),
    [anon_sym_DASHceq] = ACTIONS(669),
    [anon_sym_DASHcge] = ACTIONS(669),
    [anon_sym_DASHcgt] = ACTIONS(669),
    [anon_sym_DASHcle] = ACTIONS(669),
    [anon_sym_DASHclike] = ACTIONS(669),
    [anon_sym_DASHclt] = ACTIONS(669),
    [anon_sym_DASHcmatch] = ACTIONS(669),
    [anon_sym_DASHcne] = ACTIONS(669),
    [anon_sym_DASHcnotcontains] = ACTIONS(669),
    [anon_sym_DASHcnotlike] = ACTIONS(669),
    [anon_sym_DASHcnotmatch] = ACTIONS(669),
    [anon_sym_DASHcontains] = ACTIONS(669),
    [anon_sym_DASHcreplace] = ACTIONS(669),
    [anon_sym_DASHcsplit] = ACTIONS(669),
    [anon_sym_DASHeq] = ACTIONS(669),
    [anon_sym_DASHge] = ACTIONS(669),
    [anon_sym_DASHgt] = ACTIONS(669),
    [anon_sym_DASHicontains] = ACTIONS(669),
    [anon_sym_DASHieq] = ACTIONS(669),
    [anon_sym_DASHige] = ACTIONS(669),
    [anon_sym_DASHigt] = ACTIONS(669),
    [anon_sym_DASHile] = ACTIONS(669),
    [anon_sym_DASHilike] = ACTIONS(669),
    [anon_sym_DASHilt] = ACTIONS(669),
    [anon_sym_DASHimatch] = ACTIONS(669),
    [anon_sym_DASHin] = ACTIONS(671),
    [anon_sym_DASHine] = ACTIONS(669),
    [anon_sym_DASHinotcontains] = ACTIONS(669),
    [anon_sym_DASHinotlike] = ACTIONS(669),
    [anon_sym_DASHinotmatch] = ACTIONS(669),
    [anon_sym_DASHireplace] = ACTIONS(669),
    [anon_sym_DASHis] = ACTIONS(671),
    [anon_sym_DASHisnot] = ACTIONS(669),
    [anon_sym_DASHisplit] = ACTIONS(669),
    [anon_sym_DASHjoin] = ACTIONS(669),
    [anon_sym_DASHle] = ACTIONS(669),
    [anon_sym_DASHlike] = ACTIONS(669),
    [anon_sym_DASHlt] = ACTIONS(669),
    [anon_sym_DASHmatch] = ACTIONS(669),
    [anon_sym_DASHne] = ACTIONS(669),
    [anon_sym_DASHnotcontains] = ACTIONS(669),
    [anon_sym_DASHnotin] = ACTIONS(669),
    [anon_sym_DASHnotlike] = ACTIONS(669),
    [anon_sym_DASHnotmatch] = ACTIONS(669),
    [anon_sym_DASHreplace] = ACTIONS(669),
    [anon_sym_DASHshl] = ACTIONS(669),
    [anon_sym_DASHshr] = ACTIONS(669),
    [anon_sym_DASHsplit] = ACTIONS(669),
    [sym_format_operator] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_COMMA] = ACTIONS(669),
    [anon_sym_PIPE] = ACTIONS(669),
    [anon_sym_PERCENT] = ACTIONS(671),
    [anon_sym_DASHand] = ACTIONS(669),
    [anon_sym_DASHor] = ACTIONS(669),
    [anon_sym_DASHxor] = ACTIONS(669),
    [anon_sym_DASHband] = ACTIONS(669),
    [anon_sym_DASHbor] = ACTIONS(669),
    [anon_sym_DASHbxor] = ACTIONS(669),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_SLASH] = ACTIONS(671),
    [anon_sym_BSLASH] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_DOT_DOT] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_DOT2] = ACTIONS(671),
    [anon_sym_COLON_COLON] = ACTIONS(669),
    [anon_sym_DOTforeach] = ACTIONS(669),
    [sym__statement_terminator] = ACTIONS(669),
  },
  [124] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_EQ] = ACTIONS(685),
    [anon_sym_BANG_EQ] = ACTIONS(685),
    [anon_sym_PLUS_EQ] = ACTIONS(685),
    [anon_sym_STAR_EQ] = ACTIONS(685),
    [anon_sym_SLASH_EQ] = ACTIONS(685),
    [anon_sym_PERCENT_EQ] = ACTIONS(685),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(685),
    [anon_sym_2_GT] = ACTIONS(687),
    [anon_sym_2_GT_GT] = ACTIONS(685),
    [anon_sym_3_GT] = ACTIONS(687),
    [anon_sym_3_GT_GT] = ACTIONS(685),
    [anon_sym_4_GT] = ACTIONS(687),
    [anon_sym_4_GT_GT] = ACTIONS(685),
    [anon_sym_5_GT] = ACTIONS(687),
    [anon_sym_5_GT_GT] = ACTIONS(685),
    [anon_sym_6_GT] = ACTIONS(687),
    [anon_sym_6_GT_GT] = ACTIONS(685),
    [anon_sym_STAR_GT] = ACTIONS(687),
    [anon_sym_STAR_GT_GT] = ACTIONS(685),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(685),
    [anon_sym_2_GT_AMP1] = ACTIONS(685),
    [anon_sym_3_GT_AMP1] = ACTIONS(685),
    [anon_sym_4_GT_AMP1] = ACTIONS(685),
    [anon_sym_5_GT_AMP1] = ACTIONS(685),
    [anon_sym_6_GT_AMP1] = ACTIONS(685),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(685),
    [anon_sym_1_GT_AMP2] = ACTIONS(685),
    [anon_sym_3_GT_AMP2] = ACTIONS(685),
    [anon_sym_4_GT_AMP2] = ACTIONS(685),
    [anon_sym_5_GT_AMP2] = ACTIONS(685),
    [anon_sym_6_GT_AMP2] = ACTIONS(685),
    [anon_sym_DASHas] = ACTIONS(685),
    [anon_sym_DASHccontains] = ACTIONS(685),
    [anon_sym_DASHceq] = ACTIONS(685),
    [anon_sym_DASHcge] = ACTIONS(685),
    [anon_sym_DASHcgt] = ACTIONS(685),
    [anon_sym_DASHcle] = ACTIONS(685),
    [anon_sym_DASHclike] = ACTIONS(685),
    [anon_sym_DASHclt] = ACTIONS(685),
    [anon_sym_DASHcmatch] = ACTIONS(685),
    [anon_sym_DASHcne] = ACTIONS(685),
    [anon_sym_DASHcnotcontains] = ACTIONS(685),
    [anon_sym_DASHcnotlike] = ACTIONS(685),
    [anon_sym_DASHcnotmatch] = ACTIONS(685),
    [anon_sym_DASHcontains] = ACTIONS(685),
    [anon_sym_DASHcreplace] = ACTIONS(685),
    [anon_sym_DASHcsplit] = ACTIONS(685),
    [anon_sym_DASHeq] = ACTIONS(685),
    [anon_sym_DASHge] = ACTIONS(685),
    [anon_sym_DASHgt] = ACTIONS(685),
    [anon_sym_DASHicontains] = ACTIONS(685),
    [anon_sym_DASHieq] = ACTIONS(685),
    [anon_sym_DASHige] = ACTIONS(685),
    [anon_sym_DASHigt] = ACTIONS(685),
    [anon_sym_DASHile] = ACTIONS(685),
    [anon_sym_DASHilike] = ACTIONS(685),
    [anon_sym_DASHilt] = ACTIONS(685),
    [anon_sym_DASHimatch] = ACTIONS(685),
    [anon_sym_DASHin] = ACTIONS(687),
    [anon_sym_DASHine] = ACTIONS(685),
    [anon_sym_DASHinotcontains] = ACTIONS(685),
    [anon_sym_DASHinotlike] = ACTIONS(685),
    [anon_sym_DASHinotmatch] = ACTIONS(685),
    [anon_sym_DASHireplace] = ACTIONS(685),
    [anon_sym_DASHis] = ACTIONS(687),
    [anon_sym_DASHisnot] = ACTIONS(685),
    [anon_sym_DASHisplit] = ACTIONS(685),
    [anon_sym_DASHjoin] = ACTIONS(685),
    [anon_sym_DASHle] = ACTIONS(685),
    [anon_sym_DASHlike] = ACTIONS(685),
    [anon_sym_DASHlt] = ACTIONS(685),
    [anon_sym_DASHmatch] = ACTIONS(685),
    [anon_sym_DASHne] = ACTIONS(685),
    [anon_sym_DASHnotcontains] = ACTIONS(685),
    [anon_sym_DASHnotin] = ACTIONS(685),
    [anon_sym_DASHnotlike] = ACTIONS(685),
    [anon_sym_DASHnotmatch] = ACTIONS(685),
    [anon_sym_DASHreplace] = ACTIONS(685),
    [anon_sym_DASHshl] = ACTIONS(685),
    [anon_sym_DASHshr] = ACTIONS(685),
    [anon_sym_DASHsplit] = ACTIONS(685),
    [sym_format_operator] = ACTIONS(685),
    [anon_sym_LPAREN] = ACTIONS(685),
    [anon_sym_COMMA] = ACTIONS(685),
    [anon_sym_PIPE] = ACTIONS(685),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_DASHand] = ACTIONS(685),
    [anon_sym_DASHor] = ACTIONS(685),
    [anon_sym_DASHxor] = ACTIONS(685),
    [anon_sym_DASHband] = ACTIONS(685),
    [anon_sym_DASHbor] = ACTIONS(685),
    [anon_sym_DASHbxor] = ACTIONS(685),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(687),
    [anon_sym_BSLASH] = ACTIONS(685),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_DOT_DOT] = ACTIONS(685),
    [anon_sym_PLUS_PLUS] = ACTIONS(685),
    [anon_sym_DASH_DASH] = ACTIONS(685),
    [anon_sym_DOT2] = ACTIONS(687),
    [anon_sym_COLON_COLON] = ACTIONS(685),
    [anon_sym_DOTforeach] = ACTIONS(685),
    [sym__statement_terminator] = ACTIONS(685),
  },
  [125] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_EQ] = ACTIONS(599),
    [anon_sym_BANG_EQ] = ACTIONS(599),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_GT] = ACTIONS(601),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_2_GT] = ACTIONS(601),
    [anon_sym_2_GT_GT] = ACTIONS(599),
    [anon_sym_3_GT] = ACTIONS(601),
    [anon_sym_3_GT_GT] = ACTIONS(599),
    [anon_sym_4_GT] = ACTIONS(601),
    [anon_sym_4_GT_GT] = ACTIONS(599),
    [anon_sym_5_GT] = ACTIONS(601),
    [anon_sym_5_GT_GT] = ACTIONS(599),
    [anon_sym_6_GT] = ACTIONS(601),
    [anon_sym_6_GT_GT] = ACTIONS(599),
    [anon_sym_STAR_GT] = ACTIONS(601),
    [anon_sym_STAR_GT_GT] = ACTIONS(599),
    [anon_sym_LT] = ACTIONS(601),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(599),
    [anon_sym_2_GT_AMP1] = ACTIONS(599),
    [anon_sym_3_GT_AMP1] = ACTIONS(599),
    [anon_sym_4_GT_AMP1] = ACTIONS(599),
    [anon_sym_5_GT_AMP1] = ACTIONS(599),
    [anon_sym_6_GT_AMP1] = ACTIONS(599),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(599),
    [anon_sym_1_GT_AMP2] = ACTIONS(599),
    [anon_sym_3_GT_AMP2] = ACTIONS(599),
    [anon_sym_4_GT_AMP2] = ACTIONS(599),
    [anon_sym_5_GT_AMP2] = ACTIONS(599),
    [anon_sym_6_GT_AMP2] = ACTIONS(599),
    [anon_sym_DASHas] = ACTIONS(599),
    [anon_sym_DASHccontains] = ACTIONS(599),
    [anon_sym_DASHceq] = ACTIONS(599),
    [anon_sym_DASHcge] = ACTIONS(599),
    [anon_sym_DASHcgt] = ACTIONS(599),
    [anon_sym_DASHcle] = ACTIONS(599),
    [anon_sym_DASHclike] = ACTIONS(599),
    [anon_sym_DASHclt] = ACTIONS(599),
    [anon_sym_DASHcmatch] = ACTIONS(599),
    [anon_sym_DASHcne] = ACTIONS(599),
    [anon_sym_DASHcnotcontains] = ACTIONS(599),
    [anon_sym_DASHcnotlike] = ACTIONS(599),
    [anon_sym_DASHcnotmatch] = ACTIONS(599),
    [anon_sym_DASHcontains] = ACTIONS(599),
    [anon_sym_DASHcreplace] = ACTIONS(599),
    [anon_sym_DASHcsplit] = ACTIONS(599),
    [anon_sym_DASHeq] = ACTIONS(599),
    [anon_sym_DASHge] = ACTIONS(599),
    [anon_sym_DASHgt] = ACTIONS(599),
    [anon_sym_DASHicontains] = ACTIONS(599),
    [anon_sym_DASHieq] = ACTIONS(599),
    [anon_sym_DASHige] = ACTIONS(599),
    [anon_sym_DASHigt] = ACTIONS(599),
    [anon_sym_DASHile] = ACTIONS(599),
    [anon_sym_DASHilike] = ACTIONS(599),
    [anon_sym_DASHilt] = ACTIONS(599),
    [anon_sym_DASHimatch] = ACTIONS(599),
    [anon_sym_DASHin] = ACTIONS(601),
    [anon_sym_DASHine] = ACTIONS(599),
    [anon_sym_DASHinotcontains] = ACTIONS(599),
    [anon_sym_DASHinotlike] = ACTIONS(599),
    [anon_sym_DASHinotmatch] = ACTIONS(599),
    [anon_sym_DASHireplace] = ACTIONS(599),
    [anon_sym_DASHis] = ACTIONS(601),
    [anon_sym_DASHisnot] = ACTIONS(599),
    [anon_sym_DASHisplit] = ACTIONS(599),
    [anon_sym_DASHjoin] = ACTIONS(599),
    [anon_sym_DASHle] = ACTIONS(599),
    [anon_sym_DASHlike] = ACTIONS(599),
    [anon_sym_DASHlt] = ACTIONS(599),
    [anon_sym_DASHmatch] = ACTIONS(599),
    [anon_sym_DASHne] = ACTIONS(599),
    [anon_sym_DASHnotcontains] = ACTIONS(599),
    [anon_sym_DASHnotin] = ACTIONS(599),
    [anon_sym_DASHnotlike] = ACTIONS(599),
    [anon_sym_DASHnotmatch] = ACTIONS(599),
    [anon_sym_DASHreplace] = ACTIONS(599),
    [anon_sym_DASHshl] = ACTIONS(599),
    [anon_sym_DASHshr] = ACTIONS(599),
    [anon_sym_DASHsplit] = ACTIONS(599),
    [sym_format_operator] = ACTIONS(599),
    [anon_sym_LPAREN] = ACTIONS(599),
    [anon_sym_COMMA] = ACTIONS(599),
    [anon_sym_PIPE] = ACTIONS(599),
    [anon_sym_PERCENT] = ACTIONS(601),
    [anon_sym_DASHand] = ACTIONS(599),
    [anon_sym_DASHor] = ACTIONS(599),
    [anon_sym_DASHxor] = ACTIONS(599),
    [anon_sym_DASHband] = ACTIONS(599),
    [anon_sym_DASHbor] = ACTIONS(599),
    [anon_sym_DASHbxor] = ACTIONS(599),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_SLASH] = ACTIONS(601),
    [anon_sym_BSLASH] = ACTIONS(599),
    [anon_sym_STAR] = ACTIONS(601),
    [anon_sym_DOT_DOT] = ACTIONS(599),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DOT2] = ACTIONS(601),
    [anon_sym_COLON_COLON] = ACTIONS(599),
    [anon_sym_DOTforeach] = ACTIONS(599),
    [sym__statement_terminator] = ACTIONS(599),
  },
  [126] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_EQ] = ACTIONS(681),
    [anon_sym_BANG_EQ] = ACTIONS(681),
    [anon_sym_PLUS_EQ] = ACTIONS(681),
    [anon_sym_STAR_EQ] = ACTIONS(681),
    [anon_sym_SLASH_EQ] = ACTIONS(681),
    [anon_sym_PERCENT_EQ] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_2_GT] = ACTIONS(683),
    [anon_sym_2_GT_GT] = ACTIONS(681),
    [anon_sym_3_GT] = ACTIONS(683),
    [anon_sym_3_GT_GT] = ACTIONS(681),
    [anon_sym_4_GT] = ACTIONS(683),
    [anon_sym_4_GT_GT] = ACTIONS(681),
    [anon_sym_5_GT] = ACTIONS(683),
    [anon_sym_5_GT_GT] = ACTIONS(681),
    [anon_sym_6_GT] = ACTIONS(683),
    [anon_sym_6_GT_GT] = ACTIONS(681),
    [anon_sym_STAR_GT] = ACTIONS(683),
    [anon_sym_STAR_GT_GT] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(683),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(681),
    [anon_sym_2_GT_AMP1] = ACTIONS(681),
    [anon_sym_3_GT_AMP1] = ACTIONS(681),
    [anon_sym_4_GT_AMP1] = ACTIONS(681),
    [anon_sym_5_GT_AMP1] = ACTIONS(681),
    [anon_sym_6_GT_AMP1] = ACTIONS(681),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(681),
    [anon_sym_1_GT_AMP2] = ACTIONS(681),
    [anon_sym_3_GT_AMP2] = ACTIONS(681),
    [anon_sym_4_GT_AMP2] = ACTIONS(681),
    [anon_sym_5_GT_AMP2] = ACTIONS(681),
    [anon_sym_6_GT_AMP2] = ACTIONS(681),
    [anon_sym_DASHas] = ACTIONS(681),
    [anon_sym_DASHccontains] = ACTIONS(681),
    [anon_sym_DASHceq] = ACTIONS(681),
    [anon_sym_DASHcge] = ACTIONS(681),
    [anon_sym_DASHcgt] = ACTIONS(681),
    [anon_sym_DASHcle] = ACTIONS(681),
    [anon_sym_DASHclike] = ACTIONS(681),
    [anon_sym_DASHclt] = ACTIONS(681),
    [anon_sym_DASHcmatch] = ACTIONS(681),
    [anon_sym_DASHcne] = ACTIONS(681),
    [anon_sym_DASHcnotcontains] = ACTIONS(681),
    [anon_sym_DASHcnotlike] = ACTIONS(681),
    [anon_sym_DASHcnotmatch] = ACTIONS(681),
    [anon_sym_DASHcontains] = ACTIONS(681),
    [anon_sym_DASHcreplace] = ACTIONS(681),
    [anon_sym_DASHcsplit] = ACTIONS(681),
    [anon_sym_DASHeq] = ACTIONS(681),
    [anon_sym_DASHge] = ACTIONS(681),
    [anon_sym_DASHgt] = ACTIONS(681),
    [anon_sym_DASHicontains] = ACTIONS(681),
    [anon_sym_DASHieq] = ACTIONS(681),
    [anon_sym_DASHige] = ACTIONS(681),
    [anon_sym_DASHigt] = ACTIONS(681),
    [anon_sym_DASHile] = ACTIONS(681),
    [anon_sym_DASHilike] = ACTIONS(681),
    [anon_sym_DASHilt] = ACTIONS(681),
    [anon_sym_DASHimatch] = ACTIONS(681),
    [anon_sym_DASHin] = ACTIONS(683),
    [anon_sym_DASHine] = ACTIONS(681),
    [anon_sym_DASHinotcontains] = ACTIONS(681),
    [anon_sym_DASHinotlike] = ACTIONS(681),
    [anon_sym_DASHinotmatch] = ACTIONS(681),
    [anon_sym_DASHireplace] = ACTIONS(681),
    [anon_sym_DASHis] = ACTIONS(683),
    [anon_sym_DASHisnot] = ACTIONS(681),
    [anon_sym_DASHisplit] = ACTIONS(681),
    [anon_sym_DASHjoin] = ACTIONS(681),
    [anon_sym_DASHle] = ACTIONS(681),
    [anon_sym_DASHlike] = ACTIONS(681),
    [anon_sym_DASHlt] = ACTIONS(681),
    [anon_sym_DASHmatch] = ACTIONS(681),
    [anon_sym_DASHne] = ACTIONS(681),
    [anon_sym_DASHnotcontains] = ACTIONS(681),
    [anon_sym_DASHnotin] = ACTIONS(681),
    [anon_sym_DASHnotlike] = ACTIONS(681),
    [anon_sym_DASHnotmatch] = ACTIONS(681),
    [anon_sym_DASHreplace] = ACTIONS(681),
    [anon_sym_DASHshl] = ACTIONS(681),
    [anon_sym_DASHshr] = ACTIONS(681),
    [anon_sym_DASHsplit] = ACTIONS(681),
    [sym_format_operator] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(681),
    [anon_sym_COMMA] = ACTIONS(681),
    [anon_sym_PIPE] = ACTIONS(681),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_DASHand] = ACTIONS(681),
    [anon_sym_DASHor] = ACTIONS(681),
    [anon_sym_DASHxor] = ACTIONS(681),
    [anon_sym_DASHband] = ACTIONS(681),
    [anon_sym_DASHbor] = ACTIONS(681),
    [anon_sym_DASHbxor] = ACTIONS(681),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(681),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_DOT_DOT] = ACTIONS(681),
    [anon_sym_PLUS_PLUS] = ACTIONS(681),
    [anon_sym_DASH_DASH] = ACTIONS(681),
    [anon_sym_DOT2] = ACTIONS(683),
    [anon_sym_COLON_COLON] = ACTIONS(681),
    [anon_sym_DOTforeach] = ACTIONS(681),
    [sym__statement_terminator] = ACTIONS(681),
  },
  [127] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_BANG_EQ] = ACTIONS(689),
    [anon_sym_PLUS_EQ] = ACTIONS(689),
    [anon_sym_STAR_EQ] = ACTIONS(689),
    [anon_sym_SLASH_EQ] = ACTIONS(689),
    [anon_sym_PERCENT_EQ] = ACTIONS(689),
    [anon_sym_GT] = ACTIONS(691),
    [anon_sym_GT_GT] = ACTIONS(689),
    [anon_sym_2_GT] = ACTIONS(691),
    [anon_sym_2_GT_GT] = ACTIONS(689),
    [anon_sym_3_GT] = ACTIONS(691),
    [anon_sym_3_GT_GT] = ACTIONS(689),
    [anon_sym_4_GT] = ACTIONS(691),
    [anon_sym_4_GT_GT] = ACTIONS(689),
    [anon_sym_5_GT] = ACTIONS(691),
    [anon_sym_5_GT_GT] = ACTIONS(689),
    [anon_sym_6_GT] = ACTIONS(691),
    [anon_sym_6_GT_GT] = ACTIONS(689),
    [anon_sym_STAR_GT] = ACTIONS(691),
    [anon_sym_STAR_GT_GT] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(691),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(689),
    [anon_sym_2_GT_AMP1] = ACTIONS(689),
    [anon_sym_3_GT_AMP1] = ACTIONS(689),
    [anon_sym_4_GT_AMP1] = ACTIONS(689),
    [anon_sym_5_GT_AMP1] = ACTIONS(689),
    [anon_sym_6_GT_AMP1] = ACTIONS(689),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(689),
    [anon_sym_1_GT_AMP2] = ACTIONS(689),
    [anon_sym_3_GT_AMP2] = ACTIONS(689),
    [anon_sym_4_GT_AMP2] = ACTIONS(689),
    [anon_sym_5_GT_AMP2] = ACTIONS(689),
    [anon_sym_6_GT_AMP2] = ACTIONS(689),
    [anon_sym_DASHas] = ACTIONS(689),
    [anon_sym_DASHccontains] = ACTIONS(689),
    [anon_sym_DASHceq] = ACTIONS(689),
    [anon_sym_DASHcge] = ACTIONS(689),
    [anon_sym_DASHcgt] = ACTIONS(689),
    [anon_sym_DASHcle] = ACTIONS(689),
    [anon_sym_DASHclike] = ACTIONS(689),
    [anon_sym_DASHclt] = ACTIONS(689),
    [anon_sym_DASHcmatch] = ACTIONS(689),
    [anon_sym_DASHcne] = ACTIONS(689),
    [anon_sym_DASHcnotcontains] = ACTIONS(689),
    [anon_sym_DASHcnotlike] = ACTIONS(689),
    [anon_sym_DASHcnotmatch] = ACTIONS(689),
    [anon_sym_DASHcontains] = ACTIONS(689),
    [anon_sym_DASHcreplace] = ACTIONS(689),
    [anon_sym_DASHcsplit] = ACTIONS(689),
    [anon_sym_DASHeq] = ACTIONS(689),
    [anon_sym_DASHge] = ACTIONS(689),
    [anon_sym_DASHgt] = ACTIONS(689),
    [anon_sym_DASHicontains] = ACTIONS(689),
    [anon_sym_DASHieq] = ACTIONS(689),
    [anon_sym_DASHige] = ACTIONS(689),
    [anon_sym_DASHigt] = ACTIONS(689),
    [anon_sym_DASHile] = ACTIONS(689),
    [anon_sym_DASHilike] = ACTIONS(689),
    [anon_sym_DASHilt] = ACTIONS(689),
    [anon_sym_DASHimatch] = ACTIONS(689),
    [anon_sym_DASHin] = ACTIONS(691),
    [anon_sym_DASHine] = ACTIONS(689),
    [anon_sym_DASHinotcontains] = ACTIONS(689),
    [anon_sym_DASHinotlike] = ACTIONS(689),
    [anon_sym_DASHinotmatch] = ACTIONS(689),
    [anon_sym_DASHireplace] = ACTIONS(689),
    [anon_sym_DASHis] = ACTIONS(691),
    [anon_sym_DASHisnot] = ACTIONS(689),
    [anon_sym_DASHisplit] = ACTIONS(689),
    [anon_sym_DASHjoin] = ACTIONS(689),
    [anon_sym_DASHle] = ACTIONS(689),
    [anon_sym_DASHlike] = ACTIONS(689),
    [anon_sym_DASHlt] = ACTIONS(689),
    [anon_sym_DASHmatch] = ACTIONS(689),
    [anon_sym_DASHne] = ACTIONS(689),
    [anon_sym_DASHnotcontains] = ACTIONS(689),
    [anon_sym_DASHnotin] = ACTIONS(689),
    [anon_sym_DASHnotlike] = ACTIONS(689),
    [anon_sym_DASHnotmatch] = ACTIONS(689),
    [anon_sym_DASHreplace] = ACTIONS(689),
    [anon_sym_DASHshl] = ACTIONS(689),
    [anon_sym_DASHshr] = ACTIONS(689),
    [anon_sym_DASHsplit] = ACTIONS(689),
    [sym_format_operator] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(689),
    [anon_sym_COMMA] = ACTIONS(689),
    [anon_sym_PIPE] = ACTIONS(689),
    [anon_sym_PERCENT] = ACTIONS(691),
    [anon_sym_DASHand] = ACTIONS(689),
    [anon_sym_DASHor] = ACTIONS(689),
    [anon_sym_DASHxor] = ACTIONS(689),
    [anon_sym_DASHband] = ACTIONS(689),
    [anon_sym_DASHbor] = ACTIONS(689),
    [anon_sym_DASHbxor] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(691),
    [anon_sym_DASH] = ACTIONS(691),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_STAR] = ACTIONS(691),
    [anon_sym_DOT_DOT] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_DOT2] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(689),
    [anon_sym_DOTforeach] = ACTIONS(689),
    [sym__statement_terminator] = ACTIONS(689),
  },
  [128] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_GT] = ACTIONS(727),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_2_GT] = ACTIONS(727),
    [anon_sym_2_GT_GT] = ACTIONS(725),
    [anon_sym_3_GT] = ACTIONS(727),
    [anon_sym_3_GT_GT] = ACTIONS(725),
    [anon_sym_4_GT] = ACTIONS(727),
    [anon_sym_4_GT_GT] = ACTIONS(725),
    [anon_sym_5_GT] = ACTIONS(727),
    [anon_sym_5_GT_GT] = ACTIONS(725),
    [anon_sym_6_GT] = ACTIONS(727),
    [anon_sym_6_GT_GT] = ACTIONS(725),
    [anon_sym_STAR_GT] = ACTIONS(727),
    [anon_sym_STAR_GT_GT] = ACTIONS(725),
    [anon_sym_LT] = ACTIONS(727),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(725),
    [anon_sym_2_GT_AMP1] = ACTIONS(725),
    [anon_sym_3_GT_AMP1] = ACTIONS(725),
    [anon_sym_4_GT_AMP1] = ACTIONS(725),
    [anon_sym_5_GT_AMP1] = ACTIONS(725),
    [anon_sym_6_GT_AMP1] = ACTIONS(725),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(725),
    [anon_sym_1_GT_AMP2] = ACTIONS(725),
    [anon_sym_3_GT_AMP2] = ACTIONS(725),
    [anon_sym_4_GT_AMP2] = ACTIONS(725),
    [anon_sym_5_GT_AMP2] = ACTIONS(725),
    [anon_sym_6_GT_AMP2] = ACTIONS(725),
    [anon_sym_DASHas] = ACTIONS(725),
    [anon_sym_DASHccontains] = ACTIONS(725),
    [anon_sym_DASHceq] = ACTIONS(725),
    [anon_sym_DASHcge] = ACTIONS(725),
    [anon_sym_DASHcgt] = ACTIONS(725),
    [anon_sym_DASHcle] = ACTIONS(725),
    [anon_sym_DASHclike] = ACTIONS(725),
    [anon_sym_DASHclt] = ACTIONS(725),
    [anon_sym_DASHcmatch] = ACTIONS(725),
    [anon_sym_DASHcne] = ACTIONS(725),
    [anon_sym_DASHcnotcontains] = ACTIONS(725),
    [anon_sym_DASHcnotlike] = ACTIONS(725),
    [anon_sym_DASHcnotmatch] = ACTIONS(725),
    [anon_sym_DASHcontains] = ACTIONS(725),
    [anon_sym_DASHcreplace] = ACTIONS(725),
    [anon_sym_DASHcsplit] = ACTIONS(725),
    [anon_sym_DASHeq] = ACTIONS(725),
    [anon_sym_DASHge] = ACTIONS(725),
    [anon_sym_DASHgt] = ACTIONS(725),
    [anon_sym_DASHicontains] = ACTIONS(725),
    [anon_sym_DASHieq] = ACTIONS(725),
    [anon_sym_DASHige] = ACTIONS(725),
    [anon_sym_DASHigt] = ACTIONS(725),
    [anon_sym_DASHile] = ACTIONS(725),
    [anon_sym_DASHilike] = ACTIONS(725),
    [anon_sym_DASHilt] = ACTIONS(725),
    [anon_sym_DASHimatch] = ACTIONS(725),
    [anon_sym_DASHin] = ACTIONS(727),
    [anon_sym_DASHine] = ACTIONS(725),
    [anon_sym_DASHinotcontains] = ACTIONS(725),
    [anon_sym_DASHinotlike] = ACTIONS(725),
    [anon_sym_DASHinotmatch] = ACTIONS(725),
    [anon_sym_DASHireplace] = ACTIONS(725),
    [anon_sym_DASHis] = ACTIONS(727),
    [anon_sym_DASHisnot] = ACTIONS(725),
    [anon_sym_DASHisplit] = ACTIONS(725),
    [anon_sym_DASHjoin] = ACTIONS(725),
    [anon_sym_DASHle] = ACTIONS(725),
    [anon_sym_DASHlike] = ACTIONS(725),
    [anon_sym_DASHlt] = ACTIONS(725),
    [anon_sym_DASHmatch] = ACTIONS(725),
    [anon_sym_DASHne] = ACTIONS(725),
    [anon_sym_DASHnotcontains] = ACTIONS(725),
    [anon_sym_DASHnotin] = ACTIONS(725),
    [anon_sym_DASHnotlike] = ACTIONS(725),
    [anon_sym_DASHnotmatch] = ACTIONS(725),
    [anon_sym_DASHreplace] = ACTIONS(725),
    [anon_sym_DASHshl] = ACTIONS(725),
    [anon_sym_DASHshr] = ACTIONS(725),
    [anon_sym_DASHsplit] = ACTIONS(725),
    [sym_format_operator] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(727),
    [anon_sym_DASHand] = ACTIONS(725),
    [anon_sym_DASHor] = ACTIONS(725),
    [anon_sym_DASHxor] = ACTIONS(725),
    [anon_sym_DASHband] = ACTIONS(725),
    [anon_sym_DASHbor] = ACTIONS(725),
    [anon_sym_DASHbxor] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(727),
    [anon_sym_DASH] = ACTIONS(727),
    [anon_sym_SLASH] = ACTIONS(727),
    [anon_sym_BSLASH] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(727),
    [anon_sym_DOT_DOT] = ACTIONS(725),
    [anon_sym_PLUS_PLUS] = ACTIONS(725),
    [anon_sym_DASH_DASH] = ACTIONS(725),
    [anon_sym_DOT2] = ACTIONS(727),
    [anon_sym_COLON_COLON] = ACTIONS(725),
    [anon_sym_DOTforeach] = ACTIONS(725),
    [sym__statement_terminator] = ACTIONS(725),
  },
  [129] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_EQ] = ACTIONS(643),
    [anon_sym_BANG_EQ] = ACTIONS(643),
    [anon_sym_PLUS_EQ] = ACTIONS(643),
    [anon_sym_STAR_EQ] = ACTIONS(643),
    [anon_sym_SLASH_EQ] = ACTIONS(643),
    [anon_sym_PERCENT_EQ] = ACTIONS(643),
    [anon_sym_GT] = ACTIONS(645),
    [anon_sym_GT_GT] = ACTIONS(643),
    [anon_sym_2_GT] = ACTIONS(645),
    [anon_sym_2_GT_GT] = ACTIONS(643),
    [anon_sym_3_GT] = ACTIONS(645),
    [anon_sym_3_GT_GT] = ACTIONS(643),
    [anon_sym_4_GT] = ACTIONS(645),
    [anon_sym_4_GT_GT] = ACTIONS(643),
    [anon_sym_5_GT] = ACTIONS(645),
    [anon_sym_5_GT_GT] = ACTIONS(643),
    [anon_sym_6_GT] = ACTIONS(645),
    [anon_sym_6_GT_GT] = ACTIONS(643),
    [anon_sym_STAR_GT] = ACTIONS(645),
    [anon_sym_STAR_GT_GT] = ACTIONS(643),
    [anon_sym_LT] = ACTIONS(645),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(643),
    [anon_sym_2_GT_AMP1] = ACTIONS(643),
    [anon_sym_3_GT_AMP1] = ACTIONS(643),
    [anon_sym_4_GT_AMP1] = ACTIONS(643),
    [anon_sym_5_GT_AMP1] = ACTIONS(643),
    [anon_sym_6_GT_AMP1] = ACTIONS(643),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(643),
    [anon_sym_1_GT_AMP2] = ACTIONS(643),
    [anon_sym_3_GT_AMP2] = ACTIONS(643),
    [anon_sym_4_GT_AMP2] = ACTIONS(643),
    [anon_sym_5_GT_AMP2] = ACTIONS(643),
    [anon_sym_6_GT_AMP2] = ACTIONS(643),
    [anon_sym_DASHas] = ACTIONS(643),
    [anon_sym_DASHccontains] = ACTIONS(643),
    [anon_sym_DASHceq] = ACTIONS(643),
    [anon_sym_DASHcge] = ACTIONS(643),
    [anon_sym_DASHcgt] = ACTIONS(643),
    [anon_sym_DASHcle] = ACTIONS(643),
    [anon_sym_DASHclike] = ACTIONS(643),
    [anon_sym_DASHclt] = ACTIONS(643),
    [anon_sym_DASHcmatch] = ACTIONS(643),
    [anon_sym_DASHcne] = ACTIONS(643),
    [anon_sym_DASHcnotcontains] = ACTIONS(643),
    [anon_sym_DASHcnotlike] = ACTIONS(643),
    [anon_sym_DASHcnotmatch] = ACTIONS(643),
    [anon_sym_DASHcontains] = ACTIONS(643),
    [anon_sym_DASHcreplace] = ACTIONS(643),
    [anon_sym_DASHcsplit] = ACTIONS(643),
    [anon_sym_DASHeq] = ACTIONS(643),
    [anon_sym_DASHge] = ACTIONS(643),
    [anon_sym_DASHgt] = ACTIONS(643),
    [anon_sym_DASHicontains] = ACTIONS(643),
    [anon_sym_DASHieq] = ACTIONS(643),
    [anon_sym_DASHige] = ACTIONS(643),
    [anon_sym_DASHigt] = ACTIONS(643),
    [anon_sym_DASHile] = ACTIONS(643),
    [anon_sym_DASHilike] = ACTIONS(643),
    [anon_sym_DASHilt] = ACTIONS(643),
    [anon_sym_DASHimatch] = ACTIONS(643),
    [anon_sym_DASHin] = ACTIONS(645),
    [anon_sym_DASHine] = ACTIONS(643),
    [anon_sym_DASHinotcontains] = ACTIONS(643),
    [anon_sym_DASHinotlike] = ACTIONS(643),
    [anon_sym_DASHinotmatch] = ACTIONS(643),
    [anon_sym_DASHireplace] = ACTIONS(643),
    [anon_sym_DASHis] = ACTIONS(645),
    [anon_sym_DASHisnot] = ACTIONS(643),
    [anon_sym_DASHisplit] = ACTIONS(643),
    [anon_sym_DASHjoin] = ACTIONS(643),
    [anon_sym_DASHle] = ACTIONS(643),
    [anon_sym_DASHlike] = ACTIONS(643),
    [anon_sym_DASHlt] = ACTIONS(643),
    [anon_sym_DASHmatch] = ACTIONS(643),
    [anon_sym_DASHne] = ACTIONS(643),
    [anon_sym_DASHnotcontains] = ACTIONS(643),
    [anon_sym_DASHnotin] = ACTIONS(643),
    [anon_sym_DASHnotlike] = ACTIONS(643),
    [anon_sym_DASHnotmatch] = ACTIONS(643),
    [anon_sym_DASHreplace] = ACTIONS(643),
    [anon_sym_DASHshl] = ACTIONS(643),
    [anon_sym_DASHshr] = ACTIONS(643),
    [anon_sym_DASHsplit] = ACTIONS(643),
    [sym_format_operator] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(643),
    [anon_sym_COMMA] = ACTIONS(643),
    [anon_sym_PIPE] = ACTIONS(643),
    [anon_sym_PERCENT] = ACTIONS(645),
    [anon_sym_DASHand] = ACTIONS(643),
    [anon_sym_DASHor] = ACTIONS(643),
    [anon_sym_DASHxor] = ACTIONS(643),
    [anon_sym_DASHband] = ACTIONS(643),
    [anon_sym_DASHbor] = ACTIONS(643),
    [anon_sym_DASHbxor] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(645),
    [anon_sym_SLASH] = ACTIONS(645),
    [anon_sym_BSLASH] = ACTIONS(643),
    [anon_sym_STAR] = ACTIONS(645),
    [anon_sym_DOT_DOT] = ACTIONS(643),
    [anon_sym_PLUS_PLUS] = ACTIONS(643),
    [anon_sym_DASH_DASH] = ACTIONS(643),
    [anon_sym_DOT2] = ACTIONS(645),
    [anon_sym_COLON_COLON] = ACTIONS(643),
    [anon_sym_DOTforeach] = ACTIONS(643),
    [sym__statement_terminator] = ACTIONS(643),
  },
  [130] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(625),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_PLUS_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(625),
    [anon_sym_SLASH_EQ] = ACTIONS(625),
    [anon_sym_PERCENT_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(625),
    [anon_sym_2_GT] = ACTIONS(627),
    [anon_sym_2_GT_GT] = ACTIONS(625),
    [anon_sym_3_GT] = ACTIONS(627),
    [anon_sym_3_GT_GT] = ACTIONS(625),
    [anon_sym_4_GT] = ACTIONS(627),
    [anon_sym_4_GT_GT] = ACTIONS(625),
    [anon_sym_5_GT] = ACTIONS(627),
    [anon_sym_5_GT_GT] = ACTIONS(625),
    [anon_sym_6_GT] = ACTIONS(627),
    [anon_sym_6_GT_GT] = ACTIONS(625),
    [anon_sym_STAR_GT] = ACTIONS(627),
    [anon_sym_STAR_GT_GT] = ACTIONS(625),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(625),
    [anon_sym_2_GT_AMP1] = ACTIONS(625),
    [anon_sym_3_GT_AMP1] = ACTIONS(625),
    [anon_sym_4_GT_AMP1] = ACTIONS(625),
    [anon_sym_5_GT_AMP1] = ACTIONS(625),
    [anon_sym_6_GT_AMP1] = ACTIONS(625),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(625),
    [anon_sym_1_GT_AMP2] = ACTIONS(625),
    [anon_sym_3_GT_AMP2] = ACTIONS(625),
    [anon_sym_4_GT_AMP2] = ACTIONS(625),
    [anon_sym_5_GT_AMP2] = ACTIONS(625),
    [anon_sym_6_GT_AMP2] = ACTIONS(625),
    [anon_sym_DASHas] = ACTIONS(625),
    [anon_sym_DASHccontains] = ACTIONS(625),
    [anon_sym_DASHceq] = ACTIONS(625),
    [anon_sym_DASHcge] = ACTIONS(625),
    [anon_sym_DASHcgt] = ACTIONS(625),
    [anon_sym_DASHcle] = ACTIONS(625),
    [anon_sym_DASHclike] = ACTIONS(625),
    [anon_sym_DASHclt] = ACTIONS(625),
    [anon_sym_DASHcmatch] = ACTIONS(625),
    [anon_sym_DASHcne] = ACTIONS(625),
    [anon_sym_DASHcnotcontains] = ACTIONS(625),
    [anon_sym_DASHcnotlike] = ACTIONS(625),
    [anon_sym_DASHcnotmatch] = ACTIONS(625),
    [anon_sym_DASHcontains] = ACTIONS(625),
    [anon_sym_DASHcreplace] = ACTIONS(625),
    [anon_sym_DASHcsplit] = ACTIONS(625),
    [anon_sym_DASHeq] = ACTIONS(625),
    [anon_sym_DASHge] = ACTIONS(625),
    [anon_sym_DASHgt] = ACTIONS(625),
    [anon_sym_DASHicontains] = ACTIONS(625),
    [anon_sym_DASHieq] = ACTIONS(625),
    [anon_sym_DASHige] = ACTIONS(625),
    [anon_sym_DASHigt] = ACTIONS(625),
    [anon_sym_DASHile] = ACTIONS(625),
    [anon_sym_DASHilike] = ACTIONS(625),
    [anon_sym_DASHilt] = ACTIONS(625),
    [anon_sym_DASHimatch] = ACTIONS(625),
    [anon_sym_DASHin] = ACTIONS(627),
    [anon_sym_DASHine] = ACTIONS(625),
    [anon_sym_DASHinotcontains] = ACTIONS(625),
    [anon_sym_DASHinotlike] = ACTIONS(625),
    [anon_sym_DASHinotmatch] = ACTIONS(625),
    [anon_sym_DASHireplace] = ACTIONS(625),
    [anon_sym_DASHis] = ACTIONS(627),
    [anon_sym_DASHisnot] = ACTIONS(625),
    [anon_sym_DASHisplit] = ACTIONS(625),
    [anon_sym_DASHjoin] = ACTIONS(625),
    [anon_sym_DASHle] = ACTIONS(625),
    [anon_sym_DASHlike] = ACTIONS(625),
    [anon_sym_DASHlt] = ACTIONS(625),
    [anon_sym_DASHmatch] = ACTIONS(625),
    [anon_sym_DASHne] = ACTIONS(625),
    [anon_sym_DASHnotcontains] = ACTIONS(625),
    [anon_sym_DASHnotin] = ACTIONS(625),
    [anon_sym_DASHnotlike] = ACTIONS(625),
    [anon_sym_DASHnotmatch] = ACTIONS(625),
    [anon_sym_DASHreplace] = ACTIONS(625),
    [anon_sym_DASHshl] = ACTIONS(625),
    [anon_sym_DASHshr] = ACTIONS(625),
    [anon_sym_DASHsplit] = ACTIONS(625),
    [sym_format_operator] = ACTIONS(625),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(625),
    [anon_sym_PERCENT] = ACTIONS(627),
    [anon_sym_DASHand] = ACTIONS(625),
    [anon_sym_DASHor] = ACTIONS(625),
    [anon_sym_DASHxor] = ACTIONS(625),
    [anon_sym_DASHband] = ACTIONS(625),
    [anon_sym_DASHbor] = ACTIONS(625),
    [anon_sym_DASHbxor] = ACTIONS(625),
    [anon_sym_PLUS] = ACTIONS(627),
    [anon_sym_DASH] = ACTIONS(627),
    [anon_sym_SLASH] = ACTIONS(627),
    [anon_sym_BSLASH] = ACTIONS(625),
    [anon_sym_STAR] = ACTIONS(627),
    [anon_sym_DOT_DOT] = ACTIONS(625),
    [anon_sym_PLUS_PLUS] = ACTIONS(625),
    [anon_sym_DASH_DASH] = ACTIONS(625),
    [anon_sym_DOT2] = ACTIONS(627),
    [anon_sym_COLON_COLON] = ACTIONS(625),
    [anon_sym_DOTforeach] = ACTIONS(625),
    [sym__statement_terminator] = ACTIONS(625),
  },
  [131] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(647),
    [anon_sym_EQ] = ACTIONS(647),
    [anon_sym_BANG_EQ] = ACTIONS(647),
    [anon_sym_PLUS_EQ] = ACTIONS(647),
    [anon_sym_STAR_EQ] = ACTIONS(647),
    [anon_sym_SLASH_EQ] = ACTIONS(647),
    [anon_sym_PERCENT_EQ] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(649),
    [anon_sym_GT_GT] = ACTIONS(647),
    [anon_sym_2_GT] = ACTIONS(649),
    [anon_sym_2_GT_GT] = ACTIONS(647),
    [anon_sym_3_GT] = ACTIONS(649),
    [anon_sym_3_GT_GT] = ACTIONS(647),
    [anon_sym_4_GT] = ACTIONS(649),
    [anon_sym_4_GT_GT] = ACTIONS(647),
    [anon_sym_5_GT] = ACTIONS(649),
    [anon_sym_5_GT_GT] = ACTIONS(647),
    [anon_sym_6_GT] = ACTIONS(649),
    [anon_sym_6_GT_GT] = ACTIONS(647),
    [anon_sym_STAR_GT] = ACTIONS(649),
    [anon_sym_STAR_GT_GT] = ACTIONS(647),
    [anon_sym_LT] = ACTIONS(649),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(647),
    [anon_sym_2_GT_AMP1] = ACTIONS(647),
    [anon_sym_3_GT_AMP1] = ACTIONS(647),
    [anon_sym_4_GT_AMP1] = ACTIONS(647),
    [anon_sym_5_GT_AMP1] = ACTIONS(647),
    [anon_sym_6_GT_AMP1] = ACTIONS(647),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(647),
    [anon_sym_1_GT_AMP2] = ACTIONS(647),
    [anon_sym_3_GT_AMP2] = ACTIONS(647),
    [anon_sym_4_GT_AMP2] = ACTIONS(647),
    [anon_sym_5_GT_AMP2] = ACTIONS(647),
    [anon_sym_6_GT_AMP2] = ACTIONS(647),
    [anon_sym_DASHas] = ACTIONS(647),
    [anon_sym_DASHccontains] = ACTIONS(647),
    [anon_sym_DASHceq] = ACTIONS(647),
    [anon_sym_DASHcge] = ACTIONS(647),
    [anon_sym_DASHcgt] = ACTIONS(647),
    [anon_sym_DASHcle] = ACTIONS(647),
    [anon_sym_DASHclike] = ACTIONS(647),
    [anon_sym_DASHclt] = ACTIONS(647),
    [anon_sym_DASHcmatch] = ACTIONS(647),
    [anon_sym_DASHcne] = ACTIONS(647),
    [anon_sym_DASHcnotcontains] = ACTIONS(647),
    [anon_sym_DASHcnotlike] = ACTIONS(647),
    [anon_sym_DASHcnotmatch] = ACTIONS(647),
    [anon_sym_DASHcontains] = ACTIONS(647),
    [anon_sym_DASHcreplace] = ACTIONS(647),
    [anon_sym_DASHcsplit] = ACTIONS(647),
    [anon_sym_DASHeq] = ACTIONS(647),
    [anon_sym_DASHge] = ACTIONS(647),
    [anon_sym_DASHgt] = ACTIONS(647),
    [anon_sym_DASHicontains] = ACTIONS(647),
    [anon_sym_DASHieq] = ACTIONS(647),
    [anon_sym_DASHige] = ACTIONS(647),
    [anon_sym_DASHigt] = ACTIONS(647),
    [anon_sym_DASHile] = ACTIONS(647),
    [anon_sym_DASHilike] = ACTIONS(647),
    [anon_sym_DASHilt] = ACTIONS(647),
    [anon_sym_DASHimatch] = ACTIONS(647),
    [anon_sym_DASHin] = ACTIONS(649),
    [anon_sym_DASHine] = ACTIONS(647),
    [anon_sym_DASHinotcontains] = ACTIONS(647),
    [anon_sym_DASHinotlike] = ACTIONS(647),
    [anon_sym_DASHinotmatch] = ACTIONS(647),
    [anon_sym_DASHireplace] = ACTIONS(647),
    [anon_sym_DASHis] = ACTIONS(649),
    [anon_sym_DASHisnot] = ACTIONS(647),
    [anon_sym_DASHisplit] = ACTIONS(647),
    [anon_sym_DASHjoin] = ACTIONS(647),
    [anon_sym_DASHle] = ACTIONS(647),
    [anon_sym_DASHlike] = ACTIONS(647),
    [anon_sym_DASHlt] = ACTIONS(647),
    [anon_sym_DASHmatch] = ACTIONS(647),
    [anon_sym_DASHne] = ACTIONS(647),
    [anon_sym_DASHnotcontains] = ACTIONS(647),
    [anon_sym_DASHnotin] = ACTIONS(647),
    [anon_sym_DASHnotlike] = ACTIONS(647),
    [anon_sym_DASHnotmatch] = ACTIONS(647),
    [anon_sym_DASHreplace] = ACTIONS(647),
    [anon_sym_DASHshl] = ACTIONS(647),
    [anon_sym_DASHshr] = ACTIONS(647),
    [anon_sym_DASHsplit] = ACTIONS(647),
    [sym_format_operator] = ACTIONS(647),
    [anon_sym_LPAREN] = ACTIONS(647),
    [anon_sym_COMMA] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(647),
    [anon_sym_PERCENT] = ACTIONS(649),
    [anon_sym_DASHand] = ACTIONS(647),
    [anon_sym_DASHor] = ACTIONS(647),
    [anon_sym_DASHxor] = ACTIONS(647),
    [anon_sym_DASHband] = ACTIONS(647),
    [anon_sym_DASHbor] = ACTIONS(647),
    [anon_sym_DASHbxor] = ACTIONS(647),
    [anon_sym_PLUS] = ACTIONS(649),
    [anon_sym_DASH] = ACTIONS(649),
    [anon_sym_SLASH] = ACTIONS(649),
    [anon_sym_BSLASH] = ACTIONS(647),
    [anon_sym_STAR] = ACTIONS(649),
    [anon_sym_DOT_DOT] = ACTIONS(647),
    [anon_sym_PLUS_PLUS] = ACTIONS(647),
    [anon_sym_DASH_DASH] = ACTIONS(647),
    [anon_sym_DOT2] = ACTIONS(649),
    [anon_sym_COLON_COLON] = ACTIONS(647),
    [anon_sym_DOTforeach] = ACTIONS(647),
    [sym__statement_terminator] = ACTIONS(647),
  },
  [132] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_EQ] = ACTIONS(701),
    [anon_sym_BANG_EQ] = ACTIONS(701),
    [anon_sym_PLUS_EQ] = ACTIONS(701),
    [anon_sym_STAR_EQ] = ACTIONS(701),
    [anon_sym_SLASH_EQ] = ACTIONS(701),
    [anon_sym_PERCENT_EQ] = ACTIONS(701),
    [anon_sym_GT] = ACTIONS(703),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_2_GT] = ACTIONS(703),
    [anon_sym_2_GT_GT] = ACTIONS(701),
    [anon_sym_3_GT] = ACTIONS(703),
    [anon_sym_3_GT_GT] = ACTIONS(701),
    [anon_sym_4_GT] = ACTIONS(703),
    [anon_sym_4_GT_GT] = ACTIONS(701),
    [anon_sym_5_GT] = ACTIONS(703),
    [anon_sym_5_GT_GT] = ACTIONS(701),
    [anon_sym_6_GT] = ACTIONS(703),
    [anon_sym_6_GT_GT] = ACTIONS(701),
    [anon_sym_STAR_GT] = ACTIONS(703),
    [anon_sym_STAR_GT_GT] = ACTIONS(701),
    [anon_sym_LT] = ACTIONS(703),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(701),
    [anon_sym_2_GT_AMP1] = ACTIONS(701),
    [anon_sym_3_GT_AMP1] = ACTIONS(701),
    [anon_sym_4_GT_AMP1] = ACTIONS(701),
    [anon_sym_5_GT_AMP1] = ACTIONS(701),
    [anon_sym_6_GT_AMP1] = ACTIONS(701),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(701),
    [anon_sym_1_GT_AMP2] = ACTIONS(701),
    [anon_sym_3_GT_AMP2] = ACTIONS(701),
    [anon_sym_4_GT_AMP2] = ACTIONS(701),
    [anon_sym_5_GT_AMP2] = ACTIONS(701),
    [anon_sym_6_GT_AMP2] = ACTIONS(701),
    [anon_sym_DASHas] = ACTIONS(701),
    [anon_sym_DASHccontains] = ACTIONS(701),
    [anon_sym_DASHceq] = ACTIONS(701),
    [anon_sym_DASHcge] = ACTIONS(701),
    [anon_sym_DASHcgt] = ACTIONS(701),
    [anon_sym_DASHcle] = ACTIONS(701),
    [anon_sym_DASHclike] = ACTIONS(701),
    [anon_sym_DASHclt] = ACTIONS(701),
    [anon_sym_DASHcmatch] = ACTIONS(701),
    [anon_sym_DASHcne] = ACTIONS(701),
    [anon_sym_DASHcnotcontains] = ACTIONS(701),
    [anon_sym_DASHcnotlike] = ACTIONS(701),
    [anon_sym_DASHcnotmatch] = ACTIONS(701),
    [anon_sym_DASHcontains] = ACTIONS(701),
    [anon_sym_DASHcreplace] = ACTIONS(701),
    [anon_sym_DASHcsplit] = ACTIONS(701),
    [anon_sym_DASHeq] = ACTIONS(701),
    [anon_sym_DASHge] = ACTIONS(701),
    [anon_sym_DASHgt] = ACTIONS(701),
    [anon_sym_DASHicontains] = ACTIONS(701),
    [anon_sym_DASHieq] = ACTIONS(701),
    [anon_sym_DASHige] = ACTIONS(701),
    [anon_sym_DASHigt] = ACTIONS(701),
    [anon_sym_DASHile] = ACTIONS(701),
    [anon_sym_DASHilike] = ACTIONS(701),
    [anon_sym_DASHilt] = ACTIONS(701),
    [anon_sym_DASHimatch] = ACTIONS(701),
    [anon_sym_DASHin] = ACTIONS(703),
    [anon_sym_DASHine] = ACTIONS(701),
    [anon_sym_DASHinotcontains] = ACTIONS(701),
    [anon_sym_DASHinotlike] = ACTIONS(701),
    [anon_sym_DASHinotmatch] = ACTIONS(701),
    [anon_sym_DASHireplace] = ACTIONS(701),
    [anon_sym_DASHis] = ACTIONS(703),
    [anon_sym_DASHisnot] = ACTIONS(701),
    [anon_sym_DASHisplit] = ACTIONS(701),
    [anon_sym_DASHjoin] = ACTIONS(701),
    [anon_sym_DASHle] = ACTIONS(701),
    [anon_sym_DASHlike] = ACTIONS(701),
    [anon_sym_DASHlt] = ACTIONS(701),
    [anon_sym_DASHmatch] = ACTIONS(701),
    [anon_sym_DASHne] = ACTIONS(701),
    [anon_sym_DASHnotcontains] = ACTIONS(701),
    [anon_sym_DASHnotin] = ACTIONS(701),
    [anon_sym_DASHnotlike] = ACTIONS(701),
    [anon_sym_DASHnotmatch] = ACTIONS(701),
    [anon_sym_DASHreplace] = ACTIONS(701),
    [anon_sym_DASHshl] = ACTIONS(701),
    [anon_sym_DASHshr] = ACTIONS(701),
    [anon_sym_DASHsplit] = ACTIONS(701),
    [sym_format_operator] = ACTIONS(701),
    [anon_sym_LPAREN] = ACTIONS(701),
    [anon_sym_COMMA] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_PERCENT] = ACTIONS(703),
    [anon_sym_DASHand] = ACTIONS(701),
    [anon_sym_DASHor] = ACTIONS(701),
    [anon_sym_DASHxor] = ACTIONS(701),
    [anon_sym_DASHband] = ACTIONS(701),
    [anon_sym_DASHbor] = ACTIONS(701),
    [anon_sym_DASHbxor] = ACTIONS(701),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_SLASH] = ACTIONS(703),
    [anon_sym_BSLASH] = ACTIONS(701),
    [anon_sym_STAR] = ACTIONS(703),
    [anon_sym_DOT_DOT] = ACTIONS(701),
    [anon_sym_PLUS_PLUS] = ACTIONS(701),
    [anon_sym_DASH_DASH] = ACTIONS(701),
    [anon_sym_DOT2] = ACTIONS(703),
    [anon_sym_COLON_COLON] = ACTIONS(701),
    [anon_sym_DOTforeach] = ACTIONS(701),
    [sym__statement_terminator] = ACTIONS(701),
  },
  [133] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_EQ] = ACTIONS(657),
    [anon_sym_BANG_EQ] = ACTIONS(657),
    [anon_sym_PLUS_EQ] = ACTIONS(657),
    [anon_sym_STAR_EQ] = ACTIONS(657),
    [anon_sym_SLASH_EQ] = ACTIONS(657),
    [anon_sym_PERCENT_EQ] = ACTIONS(657),
    [anon_sym_GT] = ACTIONS(659),
    [anon_sym_GT_GT] = ACTIONS(657),
    [anon_sym_2_GT] = ACTIONS(659),
    [anon_sym_2_GT_GT] = ACTIONS(657),
    [anon_sym_3_GT] = ACTIONS(659),
    [anon_sym_3_GT_GT] = ACTIONS(657),
    [anon_sym_4_GT] = ACTIONS(659),
    [anon_sym_4_GT_GT] = ACTIONS(657),
    [anon_sym_5_GT] = ACTIONS(659),
    [anon_sym_5_GT_GT] = ACTIONS(657),
    [anon_sym_6_GT] = ACTIONS(659),
    [anon_sym_6_GT_GT] = ACTIONS(657),
    [anon_sym_STAR_GT] = ACTIONS(659),
    [anon_sym_STAR_GT_GT] = ACTIONS(657),
    [anon_sym_LT] = ACTIONS(659),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(657),
    [anon_sym_2_GT_AMP1] = ACTIONS(657),
    [anon_sym_3_GT_AMP1] = ACTIONS(657),
    [anon_sym_4_GT_AMP1] = ACTIONS(657),
    [anon_sym_5_GT_AMP1] = ACTIONS(657),
    [anon_sym_6_GT_AMP1] = ACTIONS(657),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(657),
    [anon_sym_1_GT_AMP2] = ACTIONS(657),
    [anon_sym_3_GT_AMP2] = ACTIONS(657),
    [anon_sym_4_GT_AMP2] = ACTIONS(657),
    [anon_sym_5_GT_AMP2] = ACTIONS(657),
    [anon_sym_6_GT_AMP2] = ACTIONS(657),
    [anon_sym_DASHas] = ACTIONS(657),
    [anon_sym_DASHccontains] = ACTIONS(657),
    [anon_sym_DASHceq] = ACTIONS(657),
    [anon_sym_DASHcge] = ACTIONS(657),
    [anon_sym_DASHcgt] = ACTIONS(657),
    [anon_sym_DASHcle] = ACTIONS(657),
    [anon_sym_DASHclike] = ACTIONS(657),
    [anon_sym_DASHclt] = ACTIONS(657),
    [anon_sym_DASHcmatch] = ACTIONS(657),
    [anon_sym_DASHcne] = ACTIONS(657),
    [anon_sym_DASHcnotcontains] = ACTIONS(657),
    [anon_sym_DASHcnotlike] = ACTIONS(657),
    [anon_sym_DASHcnotmatch] = ACTIONS(657),
    [anon_sym_DASHcontains] = ACTIONS(657),
    [anon_sym_DASHcreplace] = ACTIONS(657),
    [anon_sym_DASHcsplit] = ACTIONS(657),
    [anon_sym_DASHeq] = ACTIONS(657),
    [anon_sym_DASHge] = ACTIONS(657),
    [anon_sym_DASHgt] = ACTIONS(657),
    [anon_sym_DASHicontains] = ACTIONS(657),
    [anon_sym_DASHieq] = ACTIONS(657),
    [anon_sym_DASHige] = ACTIONS(657),
    [anon_sym_DASHigt] = ACTIONS(657),
    [anon_sym_DASHile] = ACTIONS(657),
    [anon_sym_DASHilike] = ACTIONS(657),
    [anon_sym_DASHilt] = ACTIONS(657),
    [anon_sym_DASHimatch] = ACTIONS(657),
    [anon_sym_DASHin] = ACTIONS(659),
    [anon_sym_DASHine] = ACTIONS(657),
    [anon_sym_DASHinotcontains] = ACTIONS(657),
    [anon_sym_DASHinotlike] = ACTIONS(657),
    [anon_sym_DASHinotmatch] = ACTIONS(657),
    [anon_sym_DASHireplace] = ACTIONS(657),
    [anon_sym_DASHis] = ACTIONS(659),
    [anon_sym_DASHisnot] = ACTIONS(657),
    [anon_sym_DASHisplit] = ACTIONS(657),
    [anon_sym_DASHjoin] = ACTIONS(657),
    [anon_sym_DASHle] = ACTIONS(657),
    [anon_sym_DASHlike] = ACTIONS(657),
    [anon_sym_DASHlt] = ACTIONS(657),
    [anon_sym_DASHmatch] = ACTIONS(657),
    [anon_sym_DASHne] = ACTIONS(657),
    [anon_sym_DASHnotcontains] = ACTIONS(657),
    [anon_sym_DASHnotin] = ACTIONS(657),
    [anon_sym_DASHnotlike] = ACTIONS(657),
    [anon_sym_DASHnotmatch] = ACTIONS(657),
    [anon_sym_DASHreplace] = ACTIONS(657),
    [anon_sym_DASHshl] = ACTIONS(657),
    [anon_sym_DASHshr] = ACTIONS(657),
    [anon_sym_DASHsplit] = ACTIONS(657),
    [sym_format_operator] = ACTIONS(657),
    [anon_sym_LPAREN] = ACTIONS(657),
    [anon_sym_COMMA] = ACTIONS(657),
    [anon_sym_PIPE] = ACTIONS(657),
    [anon_sym_PERCENT] = ACTIONS(659),
    [anon_sym_DASHand] = ACTIONS(657),
    [anon_sym_DASHor] = ACTIONS(657),
    [anon_sym_DASHxor] = ACTIONS(657),
    [anon_sym_DASHband] = ACTIONS(657),
    [anon_sym_DASHbor] = ACTIONS(657),
    [anon_sym_DASHbxor] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_SLASH] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(657),
    [anon_sym_STAR] = ACTIONS(659),
    [anon_sym_DOT_DOT] = ACTIONS(657),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DOT2] = ACTIONS(659),
    [anon_sym_COLON_COLON] = ACTIONS(657),
    [anon_sym_DOTforeach] = ACTIONS(657),
    [sym__statement_terminator] = ACTIONS(657),
  },
  [134] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(613),
    [anon_sym_EQ] = ACTIONS(613),
    [anon_sym_BANG_EQ] = ACTIONS(613),
    [anon_sym_PLUS_EQ] = ACTIONS(613),
    [anon_sym_STAR_EQ] = ACTIONS(613),
    [anon_sym_SLASH_EQ] = ACTIONS(613),
    [anon_sym_PERCENT_EQ] = ACTIONS(613),
    [anon_sym_GT] = ACTIONS(615),
    [anon_sym_GT_GT] = ACTIONS(613),
    [anon_sym_2_GT] = ACTIONS(615),
    [anon_sym_2_GT_GT] = ACTIONS(613),
    [anon_sym_3_GT] = ACTIONS(615),
    [anon_sym_3_GT_GT] = ACTIONS(613),
    [anon_sym_4_GT] = ACTIONS(615),
    [anon_sym_4_GT_GT] = ACTIONS(613),
    [anon_sym_5_GT] = ACTIONS(615),
    [anon_sym_5_GT_GT] = ACTIONS(613),
    [anon_sym_6_GT] = ACTIONS(615),
    [anon_sym_6_GT_GT] = ACTIONS(613),
    [anon_sym_STAR_GT] = ACTIONS(615),
    [anon_sym_STAR_GT_GT] = ACTIONS(613),
    [anon_sym_LT] = ACTIONS(615),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(613),
    [anon_sym_2_GT_AMP1] = ACTIONS(613),
    [anon_sym_3_GT_AMP1] = ACTIONS(613),
    [anon_sym_4_GT_AMP1] = ACTIONS(613),
    [anon_sym_5_GT_AMP1] = ACTIONS(613),
    [anon_sym_6_GT_AMP1] = ACTIONS(613),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(613),
    [anon_sym_1_GT_AMP2] = ACTIONS(613),
    [anon_sym_3_GT_AMP2] = ACTIONS(613),
    [anon_sym_4_GT_AMP2] = ACTIONS(613),
    [anon_sym_5_GT_AMP2] = ACTIONS(613),
    [anon_sym_6_GT_AMP2] = ACTIONS(613),
    [anon_sym_DASHas] = ACTIONS(613),
    [anon_sym_DASHccontains] = ACTIONS(613),
    [anon_sym_DASHceq] = ACTIONS(613),
    [anon_sym_DASHcge] = ACTIONS(613),
    [anon_sym_DASHcgt] = ACTIONS(613),
    [anon_sym_DASHcle] = ACTIONS(613),
    [anon_sym_DASHclike] = ACTIONS(613),
    [anon_sym_DASHclt] = ACTIONS(613),
    [anon_sym_DASHcmatch] = ACTIONS(613),
    [anon_sym_DASHcne] = ACTIONS(613),
    [anon_sym_DASHcnotcontains] = ACTIONS(613),
    [anon_sym_DASHcnotlike] = ACTIONS(613),
    [anon_sym_DASHcnotmatch] = ACTIONS(613),
    [anon_sym_DASHcontains] = ACTIONS(613),
    [anon_sym_DASHcreplace] = ACTIONS(613),
    [anon_sym_DASHcsplit] = ACTIONS(613),
    [anon_sym_DASHeq] = ACTIONS(613),
    [anon_sym_DASHge] = ACTIONS(613),
    [anon_sym_DASHgt] = ACTIONS(613),
    [anon_sym_DASHicontains] = ACTIONS(613),
    [anon_sym_DASHieq] = ACTIONS(613),
    [anon_sym_DASHige] = ACTIONS(613),
    [anon_sym_DASHigt] = ACTIONS(613),
    [anon_sym_DASHile] = ACTIONS(613),
    [anon_sym_DASHilike] = ACTIONS(613),
    [anon_sym_DASHilt] = ACTIONS(613),
    [anon_sym_DASHimatch] = ACTIONS(613),
    [anon_sym_DASHin] = ACTIONS(615),
    [anon_sym_DASHine] = ACTIONS(613),
    [anon_sym_DASHinotcontains] = ACTIONS(613),
    [anon_sym_DASHinotlike] = ACTIONS(613),
    [anon_sym_DASHinotmatch] = ACTIONS(613),
    [anon_sym_DASHireplace] = ACTIONS(613),
    [anon_sym_DASHis] = ACTIONS(615),
    [anon_sym_DASHisnot] = ACTIONS(613),
    [anon_sym_DASHisplit] = ACTIONS(613),
    [anon_sym_DASHjoin] = ACTIONS(613),
    [anon_sym_DASHle] = ACTIONS(613),
    [anon_sym_DASHlike] = ACTIONS(613),
    [anon_sym_DASHlt] = ACTIONS(613),
    [anon_sym_DASHmatch] = ACTIONS(613),
    [anon_sym_DASHne] = ACTIONS(613),
    [anon_sym_DASHnotcontains] = ACTIONS(613),
    [anon_sym_DASHnotin] = ACTIONS(613),
    [anon_sym_DASHnotlike] = ACTIONS(613),
    [anon_sym_DASHnotmatch] = ACTIONS(613),
    [anon_sym_DASHreplace] = ACTIONS(613),
    [anon_sym_DASHshl] = ACTIONS(613),
    [anon_sym_DASHshr] = ACTIONS(613),
    [anon_sym_DASHsplit] = ACTIONS(613),
    [sym_format_operator] = ACTIONS(613),
    [anon_sym_LPAREN] = ACTIONS(613),
    [anon_sym_COMMA] = ACTIONS(613),
    [anon_sym_PIPE] = ACTIONS(613),
    [anon_sym_PERCENT] = ACTIONS(615),
    [anon_sym_DASHand] = ACTIONS(613),
    [anon_sym_DASHor] = ACTIONS(613),
    [anon_sym_DASHxor] = ACTIONS(613),
    [anon_sym_DASHband] = ACTIONS(613),
    [anon_sym_DASHbor] = ACTIONS(613),
    [anon_sym_DASHbxor] = ACTIONS(613),
    [anon_sym_PLUS] = ACTIONS(615),
    [anon_sym_DASH] = ACTIONS(615),
    [anon_sym_SLASH] = ACTIONS(615),
    [anon_sym_BSLASH] = ACTIONS(613),
    [anon_sym_STAR] = ACTIONS(615),
    [anon_sym_DOT_DOT] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_DOT2] = ACTIONS(615),
    [anon_sym_COLON_COLON] = ACTIONS(613),
    [anon_sym_DOTforeach] = ACTIONS(613),
    [sym__statement_terminator] = ACTIONS(613),
  },
  [135] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_PLUS_EQ] = ACTIONS(713),
    [anon_sym_STAR_EQ] = ACTIONS(713),
    [anon_sym_SLASH_EQ] = ACTIONS(713),
    [anon_sym_PERCENT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(713),
    [anon_sym_2_GT] = ACTIONS(715),
    [anon_sym_2_GT_GT] = ACTIONS(713),
    [anon_sym_3_GT] = ACTIONS(715),
    [anon_sym_3_GT_GT] = ACTIONS(713),
    [anon_sym_4_GT] = ACTIONS(715),
    [anon_sym_4_GT_GT] = ACTIONS(713),
    [anon_sym_5_GT] = ACTIONS(715),
    [anon_sym_5_GT_GT] = ACTIONS(713),
    [anon_sym_6_GT] = ACTIONS(715),
    [anon_sym_6_GT_GT] = ACTIONS(713),
    [anon_sym_STAR_GT] = ACTIONS(715),
    [anon_sym_STAR_GT_GT] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(713),
    [anon_sym_2_GT_AMP1] = ACTIONS(713),
    [anon_sym_3_GT_AMP1] = ACTIONS(713),
    [anon_sym_4_GT_AMP1] = ACTIONS(713),
    [anon_sym_5_GT_AMP1] = ACTIONS(713),
    [anon_sym_6_GT_AMP1] = ACTIONS(713),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(713),
    [anon_sym_1_GT_AMP2] = ACTIONS(713),
    [anon_sym_3_GT_AMP2] = ACTIONS(713),
    [anon_sym_4_GT_AMP2] = ACTIONS(713),
    [anon_sym_5_GT_AMP2] = ACTIONS(713),
    [anon_sym_6_GT_AMP2] = ACTIONS(713),
    [anon_sym_DASHas] = ACTIONS(713),
    [anon_sym_DASHccontains] = ACTIONS(713),
    [anon_sym_DASHceq] = ACTIONS(713),
    [anon_sym_DASHcge] = ACTIONS(713),
    [anon_sym_DASHcgt] = ACTIONS(713),
    [anon_sym_DASHcle] = ACTIONS(713),
    [anon_sym_DASHclike] = ACTIONS(713),
    [anon_sym_DASHclt] = ACTIONS(713),
    [anon_sym_DASHcmatch] = ACTIONS(713),
    [anon_sym_DASHcne] = ACTIONS(713),
    [anon_sym_DASHcnotcontains] = ACTIONS(713),
    [anon_sym_DASHcnotlike] = ACTIONS(713),
    [anon_sym_DASHcnotmatch] = ACTIONS(713),
    [anon_sym_DASHcontains] = ACTIONS(713),
    [anon_sym_DASHcreplace] = ACTIONS(713),
    [anon_sym_DASHcsplit] = ACTIONS(713),
    [anon_sym_DASHeq] = ACTIONS(713),
    [anon_sym_DASHge] = ACTIONS(713),
    [anon_sym_DASHgt] = ACTIONS(713),
    [anon_sym_DASHicontains] = ACTIONS(713),
    [anon_sym_DASHieq] = ACTIONS(713),
    [anon_sym_DASHige] = ACTIONS(713),
    [anon_sym_DASHigt] = ACTIONS(713),
    [anon_sym_DASHile] = ACTIONS(713),
    [anon_sym_DASHilike] = ACTIONS(713),
    [anon_sym_DASHilt] = ACTIONS(713),
    [anon_sym_DASHimatch] = ACTIONS(713),
    [anon_sym_DASHin] = ACTIONS(715),
    [anon_sym_DASHine] = ACTIONS(713),
    [anon_sym_DASHinotcontains] = ACTIONS(713),
    [anon_sym_DASHinotlike] = ACTIONS(713),
    [anon_sym_DASHinotmatch] = ACTIONS(713),
    [anon_sym_DASHireplace] = ACTIONS(713),
    [anon_sym_DASHis] = ACTIONS(715),
    [anon_sym_DASHisnot] = ACTIONS(713),
    [anon_sym_DASHisplit] = ACTIONS(713),
    [anon_sym_DASHjoin] = ACTIONS(713),
    [anon_sym_DASHle] = ACTIONS(713),
    [anon_sym_DASHlike] = ACTIONS(713),
    [anon_sym_DASHlt] = ACTIONS(713),
    [anon_sym_DASHmatch] = ACTIONS(713),
    [anon_sym_DASHne] = ACTIONS(713),
    [anon_sym_DASHnotcontains] = ACTIONS(713),
    [anon_sym_DASHnotin] = ACTIONS(713),
    [anon_sym_DASHnotlike] = ACTIONS(713),
    [anon_sym_DASHnotmatch] = ACTIONS(713),
    [anon_sym_DASHreplace] = ACTIONS(713),
    [anon_sym_DASHshl] = ACTIONS(713),
    [anon_sym_DASHshr] = ACTIONS(713),
    [anon_sym_DASHsplit] = ACTIONS(713),
    [sym_format_operator] = ACTIONS(713),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(713),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_DASHand] = ACTIONS(713),
    [anon_sym_DASHor] = ACTIONS(713),
    [anon_sym_DASHxor] = ACTIONS(713),
    [anon_sym_DASHband] = ACTIONS(713),
    [anon_sym_DASHbor] = ACTIONS(713),
    [anon_sym_DASHbxor] = ACTIONS(713),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_BSLASH] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_DOT_DOT] = ACTIONS(713),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DOT2] = ACTIONS(739),
    [anon_sym_COLON_COLON] = ACTIONS(741),
    [anon_sym_DOTforeach] = ACTIONS(743),
  },
  [136] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(629),
    [anon_sym_EQ] = ACTIONS(629),
    [anon_sym_BANG_EQ] = ACTIONS(629),
    [anon_sym_PLUS_EQ] = ACTIONS(629),
    [anon_sym_STAR_EQ] = ACTIONS(629),
    [anon_sym_SLASH_EQ] = ACTIONS(629),
    [anon_sym_PERCENT_EQ] = ACTIONS(629),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_GT] = ACTIONS(629),
    [anon_sym_2_GT] = ACTIONS(631),
    [anon_sym_2_GT_GT] = ACTIONS(629),
    [anon_sym_3_GT] = ACTIONS(631),
    [anon_sym_3_GT_GT] = ACTIONS(629),
    [anon_sym_4_GT] = ACTIONS(631),
    [anon_sym_4_GT_GT] = ACTIONS(629),
    [anon_sym_5_GT] = ACTIONS(631),
    [anon_sym_5_GT_GT] = ACTIONS(629),
    [anon_sym_6_GT] = ACTIONS(631),
    [anon_sym_6_GT_GT] = ACTIONS(629),
    [anon_sym_STAR_GT] = ACTIONS(631),
    [anon_sym_STAR_GT_GT] = ACTIONS(629),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(629),
    [anon_sym_2_GT_AMP1] = ACTIONS(629),
    [anon_sym_3_GT_AMP1] = ACTIONS(629),
    [anon_sym_4_GT_AMP1] = ACTIONS(629),
    [anon_sym_5_GT_AMP1] = ACTIONS(629),
    [anon_sym_6_GT_AMP1] = ACTIONS(629),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(629),
    [anon_sym_1_GT_AMP2] = ACTIONS(629),
    [anon_sym_3_GT_AMP2] = ACTIONS(629),
    [anon_sym_4_GT_AMP2] = ACTIONS(629),
    [anon_sym_5_GT_AMP2] = ACTIONS(629),
    [anon_sym_6_GT_AMP2] = ACTIONS(629),
    [anon_sym_DASHas] = ACTIONS(629),
    [anon_sym_DASHccontains] = ACTIONS(629),
    [anon_sym_DASHceq] = ACTIONS(629),
    [anon_sym_DASHcge] = ACTIONS(629),
    [anon_sym_DASHcgt] = ACTIONS(629),
    [anon_sym_DASHcle] = ACTIONS(629),
    [anon_sym_DASHclike] = ACTIONS(629),
    [anon_sym_DASHclt] = ACTIONS(629),
    [anon_sym_DASHcmatch] = ACTIONS(629),
    [anon_sym_DASHcne] = ACTIONS(629),
    [anon_sym_DASHcnotcontains] = ACTIONS(629),
    [anon_sym_DASHcnotlike] = ACTIONS(629),
    [anon_sym_DASHcnotmatch] = ACTIONS(629),
    [anon_sym_DASHcontains] = ACTIONS(629),
    [anon_sym_DASHcreplace] = ACTIONS(629),
    [anon_sym_DASHcsplit] = ACTIONS(629),
    [anon_sym_DASHeq] = ACTIONS(629),
    [anon_sym_DASHge] = ACTIONS(629),
    [anon_sym_DASHgt] = ACTIONS(629),
    [anon_sym_DASHicontains] = ACTIONS(629),
    [anon_sym_DASHieq] = ACTIONS(629),
    [anon_sym_DASHige] = ACTIONS(629),
    [anon_sym_DASHigt] = ACTIONS(629),
    [anon_sym_DASHile] = ACTIONS(629),
    [anon_sym_DASHilike] = ACTIONS(629),
    [anon_sym_DASHilt] = ACTIONS(629),
    [anon_sym_DASHimatch] = ACTIONS(629),
    [anon_sym_DASHin] = ACTIONS(631),
    [anon_sym_DASHine] = ACTIONS(629),
    [anon_sym_DASHinotcontains] = ACTIONS(629),
    [anon_sym_DASHinotlike] = ACTIONS(629),
    [anon_sym_DASHinotmatch] = ACTIONS(629),
    [anon_sym_DASHireplace] = ACTIONS(629),
    [anon_sym_DASHis] = ACTIONS(631),
    [anon_sym_DASHisnot] = ACTIONS(629),
    [anon_sym_DASHisplit] = ACTIONS(629),
    [anon_sym_DASHjoin] = ACTIONS(629),
    [anon_sym_DASHle] = ACTIONS(629),
    [anon_sym_DASHlike] = ACTIONS(629),
    [anon_sym_DASHlt] = ACTIONS(629),
    [anon_sym_DASHmatch] = ACTIONS(629),
    [anon_sym_DASHne] = ACTIONS(629),
    [anon_sym_DASHnotcontains] = ACTIONS(629),
    [anon_sym_DASHnotin] = ACTIONS(629),
    [anon_sym_DASHnotlike] = ACTIONS(629),
    [anon_sym_DASHnotmatch] = ACTIONS(629),
    [anon_sym_DASHreplace] = ACTIONS(629),
    [anon_sym_DASHshl] = ACTIONS(629),
    [anon_sym_DASHshr] = ACTIONS(629),
    [anon_sym_DASHsplit] = ACTIONS(629),
    [sym_format_operator] = ACTIONS(629),
    [anon_sym_LPAREN] = ACTIONS(629),
    [anon_sym_COMMA] = ACTIONS(629),
    [anon_sym_PIPE] = ACTIONS(629),
    [anon_sym_PERCENT] = ACTIONS(631),
    [anon_sym_DASHand] = ACTIONS(629),
    [anon_sym_DASHor] = ACTIONS(629),
    [anon_sym_DASHxor] = ACTIONS(629),
    [anon_sym_DASHband] = ACTIONS(629),
    [anon_sym_DASHbor] = ACTIONS(629),
    [anon_sym_DASHbxor] = ACTIONS(629),
    [anon_sym_PLUS] = ACTIONS(631),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_SLASH] = ACTIONS(631),
    [anon_sym_BSLASH] = ACTIONS(629),
    [anon_sym_STAR] = ACTIONS(631),
    [anon_sym_DOT_DOT] = ACTIONS(629),
    [anon_sym_PLUS_PLUS] = ACTIONS(629),
    [anon_sym_DASH_DASH] = ACTIONS(629),
    [anon_sym_DOT2] = ACTIONS(631),
    [anon_sym_COLON_COLON] = ACTIONS(629),
    [anon_sym_DOTforeach] = ACTIONS(629),
    [sym__statement_terminator] = ACTIONS(629),
  },
  [137] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(713),
    [anon_sym_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_PLUS_EQ] = ACTIONS(713),
    [anon_sym_STAR_EQ] = ACTIONS(713),
    [anon_sym_SLASH_EQ] = ACTIONS(713),
    [anon_sym_PERCENT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(713),
    [anon_sym_2_GT] = ACTIONS(715),
    [anon_sym_2_GT_GT] = ACTIONS(713),
    [anon_sym_3_GT] = ACTIONS(715),
    [anon_sym_3_GT_GT] = ACTIONS(713),
    [anon_sym_4_GT] = ACTIONS(715),
    [anon_sym_4_GT_GT] = ACTIONS(713),
    [anon_sym_5_GT] = ACTIONS(715),
    [anon_sym_5_GT_GT] = ACTIONS(713),
    [anon_sym_6_GT] = ACTIONS(715),
    [anon_sym_6_GT_GT] = ACTIONS(713),
    [anon_sym_STAR_GT] = ACTIONS(715),
    [anon_sym_STAR_GT_GT] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(713),
    [anon_sym_2_GT_AMP1] = ACTIONS(713),
    [anon_sym_3_GT_AMP1] = ACTIONS(713),
    [anon_sym_4_GT_AMP1] = ACTIONS(713),
    [anon_sym_5_GT_AMP1] = ACTIONS(713),
    [anon_sym_6_GT_AMP1] = ACTIONS(713),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(713),
    [anon_sym_1_GT_AMP2] = ACTIONS(713),
    [anon_sym_3_GT_AMP2] = ACTIONS(713),
    [anon_sym_4_GT_AMP2] = ACTIONS(713),
    [anon_sym_5_GT_AMP2] = ACTIONS(713),
    [anon_sym_6_GT_AMP2] = ACTIONS(713),
    [anon_sym_DASHas] = ACTIONS(713),
    [anon_sym_DASHccontains] = ACTIONS(713),
    [anon_sym_DASHceq] = ACTIONS(713),
    [anon_sym_DASHcge] = ACTIONS(713),
    [anon_sym_DASHcgt] = ACTIONS(713),
    [anon_sym_DASHcle] = ACTIONS(713),
    [anon_sym_DASHclike] = ACTIONS(713),
    [anon_sym_DASHclt] = ACTIONS(713),
    [anon_sym_DASHcmatch] = ACTIONS(713),
    [anon_sym_DASHcne] = ACTIONS(713),
    [anon_sym_DASHcnotcontains] = ACTIONS(713),
    [anon_sym_DASHcnotlike] = ACTIONS(713),
    [anon_sym_DASHcnotmatch] = ACTIONS(713),
    [anon_sym_DASHcontains] = ACTIONS(713),
    [anon_sym_DASHcreplace] = ACTIONS(713),
    [anon_sym_DASHcsplit] = ACTIONS(713),
    [anon_sym_DASHeq] = ACTIONS(713),
    [anon_sym_DASHge] = ACTIONS(713),
    [anon_sym_DASHgt] = ACTIONS(713),
    [anon_sym_DASHicontains] = ACTIONS(713),
    [anon_sym_DASHieq] = ACTIONS(713),
    [anon_sym_DASHige] = ACTIONS(713),
    [anon_sym_DASHigt] = ACTIONS(713),
    [anon_sym_DASHile] = ACTIONS(713),
    [anon_sym_DASHilike] = ACTIONS(713),
    [anon_sym_DASHilt] = ACTIONS(713),
    [anon_sym_DASHimatch] = ACTIONS(713),
    [anon_sym_DASHin] = ACTIONS(715),
    [anon_sym_DASHine] = ACTIONS(713),
    [anon_sym_DASHinotcontains] = ACTIONS(713),
    [anon_sym_DASHinotlike] = ACTIONS(713),
    [anon_sym_DASHinotmatch] = ACTIONS(713),
    [anon_sym_DASHireplace] = ACTIONS(713),
    [anon_sym_DASHis] = ACTIONS(715),
    [anon_sym_DASHisnot] = ACTIONS(713),
    [anon_sym_DASHisplit] = ACTIONS(713),
    [anon_sym_DASHjoin] = ACTIONS(713),
    [anon_sym_DASHle] = ACTIONS(713),
    [anon_sym_DASHlike] = ACTIONS(713),
    [anon_sym_DASHlt] = ACTIONS(713),
    [anon_sym_DASHmatch] = ACTIONS(713),
    [anon_sym_DASHne] = ACTIONS(713),
    [anon_sym_DASHnotcontains] = ACTIONS(713),
    [anon_sym_DASHnotin] = ACTIONS(713),
    [anon_sym_DASHnotlike] = ACTIONS(713),
    [anon_sym_DASHnotmatch] = ACTIONS(713),
    [anon_sym_DASHreplace] = ACTIONS(713),
    [anon_sym_DASHshl] = ACTIONS(713),
    [anon_sym_DASHshr] = ACTIONS(713),
    [anon_sym_DASHsplit] = ACTIONS(713),
    [sym_format_operator] = ACTIONS(713),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(713),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_DASHand] = ACTIONS(713),
    [anon_sym_DASHor] = ACTIONS(713),
    [anon_sym_DASHxor] = ACTIONS(713),
    [anon_sym_DASHband] = ACTIONS(713),
    [anon_sym_DASHbor] = ACTIONS(713),
    [anon_sym_DASHbxor] = ACTIONS(713),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_BSLASH] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_DOT_DOT] = ACTIONS(713),
    [anon_sym_PLUS_PLUS] = ACTIONS(713),
    [anon_sym_DASH_DASH] = ACTIONS(713),
    [anon_sym_DOT2] = ACTIONS(715),
    [anon_sym_COLON_COLON] = ACTIONS(713),
    [anon_sym_DOTforeach] = ACTIONS(713),
    [sym__statement_terminator] = ACTIONS(713),
  },
  [138] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(717),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_BANG_EQ] = ACTIONS(717),
    [anon_sym_PLUS_EQ] = ACTIONS(717),
    [anon_sym_STAR_EQ] = ACTIONS(717),
    [anon_sym_SLASH_EQ] = ACTIONS(717),
    [anon_sym_PERCENT_EQ] = ACTIONS(717),
    [anon_sym_GT] = ACTIONS(719),
    [anon_sym_GT_GT] = ACTIONS(717),
    [anon_sym_2_GT] = ACTIONS(719),
    [anon_sym_2_GT_GT] = ACTIONS(717),
    [anon_sym_3_GT] = ACTIONS(719),
    [anon_sym_3_GT_GT] = ACTIONS(717),
    [anon_sym_4_GT] = ACTIONS(719),
    [anon_sym_4_GT_GT] = ACTIONS(717),
    [anon_sym_5_GT] = ACTIONS(719),
    [anon_sym_5_GT_GT] = ACTIONS(717),
    [anon_sym_6_GT] = ACTIONS(719),
    [anon_sym_6_GT_GT] = ACTIONS(717),
    [anon_sym_STAR_GT] = ACTIONS(719),
    [anon_sym_STAR_GT_GT] = ACTIONS(717),
    [anon_sym_LT] = ACTIONS(719),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(717),
    [anon_sym_2_GT_AMP1] = ACTIONS(717),
    [anon_sym_3_GT_AMP1] = ACTIONS(717),
    [anon_sym_4_GT_AMP1] = ACTIONS(717),
    [anon_sym_5_GT_AMP1] = ACTIONS(717),
    [anon_sym_6_GT_AMP1] = ACTIONS(717),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(717),
    [anon_sym_1_GT_AMP2] = ACTIONS(717),
    [anon_sym_3_GT_AMP2] = ACTIONS(717),
    [anon_sym_4_GT_AMP2] = ACTIONS(717),
    [anon_sym_5_GT_AMP2] = ACTIONS(717),
    [anon_sym_6_GT_AMP2] = ACTIONS(717),
    [anon_sym_DASHas] = ACTIONS(717),
    [anon_sym_DASHccontains] = ACTIONS(717),
    [anon_sym_DASHceq] = ACTIONS(717),
    [anon_sym_DASHcge] = ACTIONS(717),
    [anon_sym_DASHcgt] = ACTIONS(717),
    [anon_sym_DASHcle] = ACTIONS(717),
    [anon_sym_DASHclike] = ACTIONS(717),
    [anon_sym_DASHclt] = ACTIONS(717),
    [anon_sym_DASHcmatch] = ACTIONS(717),
    [anon_sym_DASHcne] = ACTIONS(717),
    [anon_sym_DASHcnotcontains] = ACTIONS(717),
    [anon_sym_DASHcnotlike] = ACTIONS(717),
    [anon_sym_DASHcnotmatch] = ACTIONS(717),
    [anon_sym_DASHcontains] = ACTIONS(717),
    [anon_sym_DASHcreplace] = ACTIONS(717),
    [anon_sym_DASHcsplit] = ACTIONS(717),
    [anon_sym_DASHeq] = ACTIONS(717),
    [anon_sym_DASHge] = ACTIONS(717),
    [anon_sym_DASHgt] = ACTIONS(717),
    [anon_sym_DASHicontains] = ACTIONS(717),
    [anon_sym_DASHieq] = ACTIONS(717),
    [anon_sym_DASHige] = ACTIONS(717),
    [anon_sym_DASHigt] = ACTIONS(717),
    [anon_sym_DASHile] = ACTIONS(717),
    [anon_sym_DASHilike] = ACTIONS(717),
    [anon_sym_DASHilt] = ACTIONS(717),
    [anon_sym_DASHimatch] = ACTIONS(717),
    [anon_sym_DASHin] = ACTIONS(719),
    [anon_sym_DASHine] = ACTIONS(717),
    [anon_sym_DASHinotcontains] = ACTIONS(717),
    [anon_sym_DASHinotlike] = ACTIONS(717),
    [anon_sym_DASHinotmatch] = ACTIONS(717),
    [anon_sym_DASHireplace] = ACTIONS(717),
    [anon_sym_DASHis] = ACTIONS(719),
    [anon_sym_DASHisnot] = ACTIONS(717),
    [anon_sym_DASHisplit] = ACTIONS(717),
    [anon_sym_DASHjoin] = ACTIONS(717),
    [anon_sym_DASHle] = ACTIONS(717),
    [anon_sym_DASHlike] = ACTIONS(717),
    [anon_sym_DASHlt] = ACTIONS(717),
    [anon_sym_DASHmatch] = ACTIONS(717),
    [anon_sym_DASHne] = ACTIONS(717),
    [anon_sym_DASHnotcontains] = ACTIONS(717),
    [anon_sym_DASHnotin] = ACTIONS(717),
    [anon_sym_DASHnotlike] = ACTIONS(717),
    [anon_sym_DASHnotmatch] = ACTIONS(717),
    [anon_sym_DASHreplace] = ACTIONS(717),
    [anon_sym_DASHshl] = ACTIONS(717),
    [anon_sym_DASHshr] = ACTIONS(717),
    [anon_sym_DASHsplit] = ACTIONS(717),
    [sym_format_operator] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(717),
    [anon_sym_COMMA] = ACTIONS(717),
    [anon_sym_PIPE] = ACTIONS(717),
    [anon_sym_PERCENT] = ACTIONS(719),
    [anon_sym_DASHand] = ACTIONS(717),
    [anon_sym_DASHor] = ACTIONS(717),
    [anon_sym_DASHxor] = ACTIONS(717),
    [anon_sym_DASHband] = ACTIONS(717),
    [anon_sym_DASHbor] = ACTIONS(717),
    [anon_sym_DASHbxor] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_SLASH] = ACTIONS(719),
    [anon_sym_BSLASH] = ACTIONS(717),
    [anon_sym_STAR] = ACTIONS(719),
    [anon_sym_DOT_DOT] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(717),
    [anon_sym_DASH_DASH] = ACTIONS(717),
    [anon_sym_DOT2] = ACTIONS(719),
    [anon_sym_COLON_COLON] = ACTIONS(717),
    [anon_sym_DOTforeach] = ACTIONS(717),
    [sym__statement_terminator] = ACTIONS(717),
  },
  [139] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(721),
    [anon_sym_EQ] = ACTIONS(721),
    [anon_sym_BANG_EQ] = ACTIONS(721),
    [anon_sym_PLUS_EQ] = ACTIONS(721),
    [anon_sym_STAR_EQ] = ACTIONS(721),
    [anon_sym_SLASH_EQ] = ACTIONS(721),
    [anon_sym_PERCENT_EQ] = ACTIONS(721),
    [anon_sym_GT] = ACTIONS(723),
    [anon_sym_GT_GT] = ACTIONS(721),
    [anon_sym_2_GT] = ACTIONS(723),
    [anon_sym_2_GT_GT] = ACTIONS(721),
    [anon_sym_3_GT] = ACTIONS(723),
    [anon_sym_3_GT_GT] = ACTIONS(721),
    [anon_sym_4_GT] = ACTIONS(723),
    [anon_sym_4_GT_GT] = ACTIONS(721),
    [anon_sym_5_GT] = ACTIONS(723),
    [anon_sym_5_GT_GT] = ACTIONS(721),
    [anon_sym_6_GT] = ACTIONS(723),
    [anon_sym_6_GT_GT] = ACTIONS(721),
    [anon_sym_STAR_GT] = ACTIONS(723),
    [anon_sym_STAR_GT_GT] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(721),
    [anon_sym_2_GT_AMP1] = ACTIONS(721),
    [anon_sym_3_GT_AMP1] = ACTIONS(721),
    [anon_sym_4_GT_AMP1] = ACTIONS(721),
    [anon_sym_5_GT_AMP1] = ACTIONS(721),
    [anon_sym_6_GT_AMP1] = ACTIONS(721),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(721),
    [anon_sym_1_GT_AMP2] = ACTIONS(721),
    [anon_sym_3_GT_AMP2] = ACTIONS(721),
    [anon_sym_4_GT_AMP2] = ACTIONS(721),
    [anon_sym_5_GT_AMP2] = ACTIONS(721),
    [anon_sym_6_GT_AMP2] = ACTIONS(721),
    [anon_sym_DASHas] = ACTIONS(721),
    [anon_sym_DASHccontains] = ACTIONS(721),
    [anon_sym_DASHceq] = ACTIONS(721),
    [anon_sym_DASHcge] = ACTIONS(721),
    [anon_sym_DASHcgt] = ACTIONS(721),
    [anon_sym_DASHcle] = ACTIONS(721),
    [anon_sym_DASHclike] = ACTIONS(721),
    [anon_sym_DASHclt] = ACTIONS(721),
    [anon_sym_DASHcmatch] = ACTIONS(721),
    [anon_sym_DASHcne] = ACTIONS(721),
    [anon_sym_DASHcnotcontains] = ACTIONS(721),
    [anon_sym_DASHcnotlike] = ACTIONS(721),
    [anon_sym_DASHcnotmatch] = ACTIONS(721),
    [anon_sym_DASHcontains] = ACTIONS(721),
    [anon_sym_DASHcreplace] = ACTIONS(721),
    [anon_sym_DASHcsplit] = ACTIONS(721),
    [anon_sym_DASHeq] = ACTIONS(721),
    [anon_sym_DASHge] = ACTIONS(721),
    [anon_sym_DASHgt] = ACTIONS(721),
    [anon_sym_DASHicontains] = ACTIONS(721),
    [anon_sym_DASHieq] = ACTIONS(721),
    [anon_sym_DASHige] = ACTIONS(721),
    [anon_sym_DASHigt] = ACTIONS(721),
    [anon_sym_DASHile] = ACTIONS(721),
    [anon_sym_DASHilike] = ACTIONS(721),
    [anon_sym_DASHilt] = ACTIONS(721),
    [anon_sym_DASHimatch] = ACTIONS(721),
    [anon_sym_DASHin] = ACTIONS(723),
    [anon_sym_DASHine] = ACTIONS(721),
    [anon_sym_DASHinotcontains] = ACTIONS(721),
    [anon_sym_DASHinotlike] = ACTIONS(721),
    [anon_sym_DASHinotmatch] = ACTIONS(721),
    [anon_sym_DASHireplace] = ACTIONS(721),
    [anon_sym_DASHis] = ACTIONS(723),
    [anon_sym_DASHisnot] = ACTIONS(721),
    [anon_sym_DASHisplit] = ACTIONS(721),
    [anon_sym_DASHjoin] = ACTIONS(721),
    [anon_sym_DASHle] = ACTIONS(721),
    [anon_sym_DASHlike] = ACTIONS(721),
    [anon_sym_DASHlt] = ACTIONS(721),
    [anon_sym_DASHmatch] = ACTIONS(721),
    [anon_sym_DASHne] = ACTIONS(721),
    [anon_sym_DASHnotcontains] = ACTIONS(721),
    [anon_sym_DASHnotin] = ACTIONS(721),
    [anon_sym_DASHnotlike] = ACTIONS(721),
    [anon_sym_DASHnotmatch] = ACTIONS(721),
    [anon_sym_DASHreplace] = ACTIONS(721),
    [anon_sym_DASHshl] = ACTIONS(721),
    [anon_sym_DASHshr] = ACTIONS(721),
    [anon_sym_DASHsplit] = ACTIONS(721),
    [sym_format_operator] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(721),
    [anon_sym_COMMA] = ACTIONS(721),
    [anon_sym_PIPE] = ACTIONS(721),
    [anon_sym_PERCENT] = ACTIONS(723),
    [anon_sym_DASHand] = ACTIONS(721),
    [anon_sym_DASHor] = ACTIONS(721),
    [anon_sym_DASHxor] = ACTIONS(721),
    [anon_sym_DASHband] = ACTIONS(721),
    [anon_sym_DASHbor] = ACTIONS(721),
    [anon_sym_DASHbxor] = ACTIONS(721),
    [anon_sym_PLUS] = ACTIONS(723),
    [anon_sym_DASH] = ACTIONS(723),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_BSLASH] = ACTIONS(721),
    [anon_sym_STAR] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(721),
    [anon_sym_PLUS_PLUS] = ACTIONS(721),
    [anon_sym_DASH_DASH] = ACTIONS(721),
    [anon_sym_DOT2] = ACTIONS(723),
    [anon_sym_COLON_COLON] = ACTIONS(721),
    [anon_sym_DOTforeach] = ACTIONS(721),
    [sym__statement_terminator] = ACTIONS(721),
  },
  [140] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_EQ] = ACTIONS(729),
    [anon_sym_BANG_EQ] = ACTIONS(729),
    [anon_sym_PLUS_EQ] = ACTIONS(729),
    [anon_sym_STAR_EQ] = ACTIONS(729),
    [anon_sym_SLASH_EQ] = ACTIONS(729),
    [anon_sym_PERCENT_EQ] = ACTIONS(729),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(729),
    [anon_sym_2_GT] = ACTIONS(731),
    [anon_sym_2_GT_GT] = ACTIONS(729),
    [anon_sym_3_GT] = ACTIONS(731),
    [anon_sym_3_GT_GT] = ACTIONS(729),
    [anon_sym_4_GT] = ACTIONS(731),
    [anon_sym_4_GT_GT] = ACTIONS(729),
    [anon_sym_5_GT] = ACTIONS(731),
    [anon_sym_5_GT_GT] = ACTIONS(729),
    [anon_sym_6_GT] = ACTIONS(731),
    [anon_sym_6_GT_GT] = ACTIONS(729),
    [anon_sym_STAR_GT] = ACTIONS(731),
    [anon_sym_STAR_GT_GT] = ACTIONS(729),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(729),
    [anon_sym_2_GT_AMP1] = ACTIONS(729),
    [anon_sym_3_GT_AMP1] = ACTIONS(729),
    [anon_sym_4_GT_AMP1] = ACTIONS(729),
    [anon_sym_5_GT_AMP1] = ACTIONS(729),
    [anon_sym_6_GT_AMP1] = ACTIONS(729),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(729),
    [anon_sym_1_GT_AMP2] = ACTIONS(729),
    [anon_sym_3_GT_AMP2] = ACTIONS(729),
    [anon_sym_4_GT_AMP2] = ACTIONS(729),
    [anon_sym_5_GT_AMP2] = ACTIONS(729),
    [anon_sym_6_GT_AMP2] = ACTIONS(729),
    [anon_sym_DASHas] = ACTIONS(729),
    [anon_sym_DASHccontains] = ACTIONS(729),
    [anon_sym_DASHceq] = ACTIONS(729),
    [anon_sym_DASHcge] = ACTIONS(729),
    [anon_sym_DASHcgt] = ACTIONS(729),
    [anon_sym_DASHcle] = ACTIONS(729),
    [anon_sym_DASHclike] = ACTIONS(729),
    [anon_sym_DASHclt] = ACTIONS(729),
    [anon_sym_DASHcmatch] = ACTIONS(729),
    [anon_sym_DASHcne] = ACTIONS(729),
    [anon_sym_DASHcnotcontains] = ACTIONS(729),
    [anon_sym_DASHcnotlike] = ACTIONS(729),
    [anon_sym_DASHcnotmatch] = ACTIONS(729),
    [anon_sym_DASHcontains] = ACTIONS(729),
    [anon_sym_DASHcreplace] = ACTIONS(729),
    [anon_sym_DASHcsplit] = ACTIONS(729),
    [anon_sym_DASHeq] = ACTIONS(729),
    [anon_sym_DASHge] = ACTIONS(729),
    [anon_sym_DASHgt] = ACTIONS(729),
    [anon_sym_DASHicontains] = ACTIONS(729),
    [anon_sym_DASHieq] = ACTIONS(729),
    [anon_sym_DASHige] = ACTIONS(729),
    [anon_sym_DASHigt] = ACTIONS(729),
    [anon_sym_DASHile] = ACTIONS(729),
    [anon_sym_DASHilike] = ACTIONS(729),
    [anon_sym_DASHilt] = ACTIONS(729),
    [anon_sym_DASHimatch] = ACTIONS(729),
    [anon_sym_DASHin] = ACTIONS(731),
    [anon_sym_DASHine] = ACTIONS(729),
    [anon_sym_DASHinotcontains] = ACTIONS(729),
    [anon_sym_DASHinotlike] = ACTIONS(729),
    [anon_sym_DASHinotmatch] = ACTIONS(729),
    [anon_sym_DASHireplace] = ACTIONS(729),
    [anon_sym_DASHis] = ACTIONS(731),
    [anon_sym_DASHisnot] = ACTIONS(729),
    [anon_sym_DASHisplit] = ACTIONS(729),
    [anon_sym_DASHjoin] = ACTIONS(729),
    [anon_sym_DASHle] = ACTIONS(729),
    [anon_sym_DASHlike] = ACTIONS(729),
    [anon_sym_DASHlt] = ACTIONS(729),
    [anon_sym_DASHmatch] = ACTIONS(729),
    [anon_sym_DASHne] = ACTIONS(729),
    [anon_sym_DASHnotcontains] = ACTIONS(729),
    [anon_sym_DASHnotin] = ACTIONS(729),
    [anon_sym_DASHnotlike] = ACTIONS(729),
    [anon_sym_DASHnotmatch] = ACTIONS(729),
    [anon_sym_DASHreplace] = ACTIONS(729),
    [anon_sym_DASHshl] = ACTIONS(729),
    [anon_sym_DASHshr] = ACTIONS(729),
    [anon_sym_DASHsplit] = ACTIONS(729),
    [sym_format_operator] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(729),
    [anon_sym_COMMA] = ACTIONS(729),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_DASHand] = ACTIONS(729),
    [anon_sym_DASHor] = ACTIONS(729),
    [anon_sym_DASHxor] = ACTIONS(729),
    [anon_sym_DASHband] = ACTIONS(729),
    [anon_sym_DASHbor] = ACTIONS(729),
    [anon_sym_DASHbxor] = ACTIONS(729),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(731),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_BSLASH] = ACTIONS(729),
    [anon_sym_STAR] = ACTIONS(731),
    [anon_sym_DOT_DOT] = ACTIONS(729),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_DOT2] = ACTIONS(731),
    [anon_sym_COLON_COLON] = ACTIONS(729),
    [anon_sym_DOTforeach] = ACTIONS(729),
    [sym__statement_terminator] = ACTIONS(729),
  },
  [141] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(617),
    [anon_sym_EQ] = ACTIONS(617),
    [anon_sym_BANG_EQ] = ACTIONS(617),
    [anon_sym_PLUS_EQ] = ACTIONS(617),
    [anon_sym_STAR_EQ] = ACTIONS(617),
    [anon_sym_SLASH_EQ] = ACTIONS(617),
    [anon_sym_PERCENT_EQ] = ACTIONS(617),
    [anon_sym_GT] = ACTIONS(619),
    [anon_sym_GT_GT] = ACTIONS(617),
    [anon_sym_2_GT] = ACTIONS(619),
    [anon_sym_2_GT_GT] = ACTIONS(617),
    [anon_sym_3_GT] = ACTIONS(619),
    [anon_sym_3_GT_GT] = ACTIONS(617),
    [anon_sym_4_GT] = ACTIONS(619),
    [anon_sym_4_GT_GT] = ACTIONS(617),
    [anon_sym_5_GT] = ACTIONS(619),
    [anon_sym_5_GT_GT] = ACTIONS(617),
    [anon_sym_6_GT] = ACTIONS(619),
    [anon_sym_6_GT_GT] = ACTIONS(617),
    [anon_sym_STAR_GT] = ACTIONS(619),
    [anon_sym_STAR_GT_GT] = ACTIONS(617),
    [anon_sym_LT] = ACTIONS(619),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(617),
    [anon_sym_2_GT_AMP1] = ACTIONS(617),
    [anon_sym_3_GT_AMP1] = ACTIONS(617),
    [anon_sym_4_GT_AMP1] = ACTIONS(617),
    [anon_sym_5_GT_AMP1] = ACTIONS(617),
    [anon_sym_6_GT_AMP1] = ACTIONS(617),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(617),
    [anon_sym_1_GT_AMP2] = ACTIONS(617),
    [anon_sym_3_GT_AMP2] = ACTIONS(617),
    [anon_sym_4_GT_AMP2] = ACTIONS(617),
    [anon_sym_5_GT_AMP2] = ACTIONS(617),
    [anon_sym_6_GT_AMP2] = ACTIONS(617),
    [anon_sym_DASHas] = ACTIONS(617),
    [anon_sym_DASHccontains] = ACTIONS(617),
    [anon_sym_DASHceq] = ACTIONS(617),
    [anon_sym_DASHcge] = ACTIONS(617),
    [anon_sym_DASHcgt] = ACTIONS(617),
    [anon_sym_DASHcle] = ACTIONS(617),
    [anon_sym_DASHclike] = ACTIONS(617),
    [anon_sym_DASHclt] = ACTIONS(617),
    [anon_sym_DASHcmatch] = ACTIONS(617),
    [anon_sym_DASHcne] = ACTIONS(617),
    [anon_sym_DASHcnotcontains] = ACTIONS(617),
    [anon_sym_DASHcnotlike] = ACTIONS(617),
    [anon_sym_DASHcnotmatch] = ACTIONS(617),
    [anon_sym_DASHcontains] = ACTIONS(617),
    [anon_sym_DASHcreplace] = ACTIONS(617),
    [anon_sym_DASHcsplit] = ACTIONS(617),
    [anon_sym_DASHeq] = ACTIONS(617),
    [anon_sym_DASHge] = ACTIONS(617),
    [anon_sym_DASHgt] = ACTIONS(617),
    [anon_sym_DASHicontains] = ACTIONS(617),
    [anon_sym_DASHieq] = ACTIONS(617),
    [anon_sym_DASHige] = ACTIONS(617),
    [anon_sym_DASHigt] = ACTIONS(617),
    [anon_sym_DASHile] = ACTIONS(617),
    [anon_sym_DASHilike] = ACTIONS(617),
    [anon_sym_DASHilt] = ACTIONS(617),
    [anon_sym_DASHimatch] = ACTIONS(617),
    [anon_sym_DASHin] = ACTIONS(619),
    [anon_sym_DASHine] = ACTIONS(617),
    [anon_sym_DASHinotcontains] = ACTIONS(617),
    [anon_sym_DASHinotlike] = ACTIONS(617),
    [anon_sym_DASHinotmatch] = ACTIONS(617),
    [anon_sym_DASHireplace] = ACTIONS(617),
    [anon_sym_DASHis] = ACTIONS(619),
    [anon_sym_DASHisnot] = ACTIONS(617),
    [anon_sym_DASHisplit] = ACTIONS(617),
    [anon_sym_DASHjoin] = ACTIONS(617),
    [anon_sym_DASHle] = ACTIONS(617),
    [anon_sym_DASHlike] = ACTIONS(617),
    [anon_sym_DASHlt] = ACTIONS(617),
    [anon_sym_DASHmatch] = ACTIONS(617),
    [anon_sym_DASHne] = ACTIONS(617),
    [anon_sym_DASHnotcontains] = ACTIONS(617),
    [anon_sym_DASHnotin] = ACTIONS(617),
    [anon_sym_DASHnotlike] = ACTIONS(617),
    [anon_sym_DASHnotmatch] = ACTIONS(617),
    [anon_sym_DASHreplace] = ACTIONS(617),
    [anon_sym_DASHshl] = ACTIONS(617),
    [anon_sym_DASHshr] = ACTIONS(617),
    [anon_sym_DASHsplit] = ACTIONS(617),
    [sym_format_operator] = ACTIONS(617),
    [anon_sym_LPAREN] = ACTIONS(617),
    [anon_sym_COMMA] = ACTIONS(617),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_DASHand] = ACTIONS(617),
    [anon_sym_DASHor] = ACTIONS(617),
    [anon_sym_DASHxor] = ACTIONS(617),
    [anon_sym_DASHband] = ACTIONS(617),
    [anon_sym_DASHbor] = ACTIONS(617),
    [anon_sym_DASHbxor] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_BSLASH] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_DOT_DOT] = ACTIONS(617),
    [anon_sym_PLUS_PLUS] = ACTIONS(617),
    [anon_sym_DASH_DASH] = ACTIONS(617),
    [anon_sym_DOT2] = ACTIONS(619),
    [anon_sym_COLON_COLON] = ACTIONS(617),
    [anon_sym_DOTforeach] = ACTIONS(617),
    [sym__statement_terminator] = ACTIONS(617),
  },
  [142] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(665),
    [anon_sym_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_PLUS_EQ] = ACTIONS(665),
    [anon_sym_STAR_EQ] = ACTIONS(665),
    [anon_sym_SLASH_EQ] = ACTIONS(665),
    [anon_sym_PERCENT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(667),
    [anon_sym_GT_GT] = ACTIONS(665),
    [anon_sym_2_GT] = ACTIONS(667),
    [anon_sym_2_GT_GT] = ACTIONS(665),
    [anon_sym_3_GT] = ACTIONS(667),
    [anon_sym_3_GT_GT] = ACTIONS(665),
    [anon_sym_4_GT] = ACTIONS(667),
    [anon_sym_4_GT_GT] = ACTIONS(665),
    [anon_sym_5_GT] = ACTIONS(667),
    [anon_sym_5_GT_GT] = ACTIONS(665),
    [anon_sym_6_GT] = ACTIONS(667),
    [anon_sym_6_GT_GT] = ACTIONS(665),
    [anon_sym_STAR_GT] = ACTIONS(667),
    [anon_sym_STAR_GT_GT] = ACTIONS(665),
    [anon_sym_LT] = ACTIONS(667),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(665),
    [anon_sym_2_GT_AMP1] = ACTIONS(665),
    [anon_sym_3_GT_AMP1] = ACTIONS(665),
    [anon_sym_4_GT_AMP1] = ACTIONS(665),
    [anon_sym_5_GT_AMP1] = ACTIONS(665),
    [anon_sym_6_GT_AMP1] = ACTIONS(665),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(665),
    [anon_sym_1_GT_AMP2] = ACTIONS(665),
    [anon_sym_3_GT_AMP2] = ACTIONS(665),
    [anon_sym_4_GT_AMP2] = ACTIONS(665),
    [anon_sym_5_GT_AMP2] = ACTIONS(665),
    [anon_sym_6_GT_AMP2] = ACTIONS(665),
    [anon_sym_DASHas] = ACTIONS(665),
    [anon_sym_DASHccontains] = ACTIONS(665),
    [anon_sym_DASHceq] = ACTIONS(665),
    [anon_sym_DASHcge] = ACTIONS(665),
    [anon_sym_DASHcgt] = ACTIONS(665),
    [anon_sym_DASHcle] = ACTIONS(665),
    [anon_sym_DASHclike] = ACTIONS(665),
    [anon_sym_DASHclt] = ACTIONS(665),
    [anon_sym_DASHcmatch] = ACTIONS(665),
    [anon_sym_DASHcne] = ACTIONS(665),
    [anon_sym_DASHcnotcontains] = ACTIONS(665),
    [anon_sym_DASHcnotlike] = ACTIONS(665),
    [anon_sym_DASHcnotmatch] = ACTIONS(665),
    [anon_sym_DASHcontains] = ACTIONS(665),
    [anon_sym_DASHcreplace] = ACTIONS(665),
    [anon_sym_DASHcsplit] = ACTIONS(665),
    [anon_sym_DASHeq] = ACTIONS(665),
    [anon_sym_DASHge] = ACTIONS(665),
    [anon_sym_DASHgt] = ACTIONS(665),
    [anon_sym_DASHicontains] = ACTIONS(665),
    [anon_sym_DASHieq] = ACTIONS(665),
    [anon_sym_DASHige] = ACTIONS(665),
    [anon_sym_DASHigt] = ACTIONS(665),
    [anon_sym_DASHile] = ACTIONS(665),
    [anon_sym_DASHilike] = ACTIONS(665),
    [anon_sym_DASHilt] = ACTIONS(665),
    [anon_sym_DASHimatch] = ACTIONS(665),
    [anon_sym_DASHin] = ACTIONS(667),
    [anon_sym_DASHine] = ACTIONS(665),
    [anon_sym_DASHinotcontains] = ACTIONS(665),
    [anon_sym_DASHinotlike] = ACTIONS(665),
    [anon_sym_DASHinotmatch] = ACTIONS(665),
    [anon_sym_DASHireplace] = ACTIONS(665),
    [anon_sym_DASHis] = ACTIONS(667),
    [anon_sym_DASHisnot] = ACTIONS(665),
    [anon_sym_DASHisplit] = ACTIONS(665),
    [anon_sym_DASHjoin] = ACTIONS(665),
    [anon_sym_DASHle] = ACTIONS(665),
    [anon_sym_DASHlike] = ACTIONS(665),
    [anon_sym_DASHlt] = ACTIONS(665),
    [anon_sym_DASHmatch] = ACTIONS(665),
    [anon_sym_DASHne] = ACTIONS(665),
    [anon_sym_DASHnotcontains] = ACTIONS(665),
    [anon_sym_DASHnotin] = ACTIONS(665),
    [anon_sym_DASHnotlike] = ACTIONS(665),
    [anon_sym_DASHnotmatch] = ACTIONS(665),
    [anon_sym_DASHreplace] = ACTIONS(665),
    [anon_sym_DASHshl] = ACTIONS(665),
    [anon_sym_DASHshr] = ACTIONS(665),
    [anon_sym_DASHsplit] = ACTIONS(665),
    [sym_format_operator] = ACTIONS(665),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_COMMA] = ACTIONS(665),
    [anon_sym_PIPE] = ACTIONS(665),
    [anon_sym_PERCENT] = ACTIONS(667),
    [anon_sym_DASHand] = ACTIONS(665),
    [anon_sym_DASHor] = ACTIONS(665),
    [anon_sym_DASHxor] = ACTIONS(665),
    [anon_sym_DASHband] = ACTIONS(665),
    [anon_sym_DASHbor] = ACTIONS(665),
    [anon_sym_DASHbxor] = ACTIONS(665),
    [anon_sym_PLUS] = ACTIONS(667),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(667),
    [anon_sym_BSLASH] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_DOT_DOT] = ACTIONS(665),
    [anon_sym_PLUS_PLUS] = ACTIONS(665),
    [anon_sym_DASH_DASH] = ACTIONS(665),
    [anon_sym_DOT2] = ACTIONS(667),
    [anon_sym_COLON_COLON] = ACTIONS(665),
    [anon_sym_DOTforeach] = ACTIONS(665),
    [sym__statement_terminator] = ACTIONS(665),
  },
  [143] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(609),
    [anon_sym_EQ] = ACTIONS(609),
    [anon_sym_BANG_EQ] = ACTIONS(609),
    [anon_sym_PLUS_EQ] = ACTIONS(609),
    [anon_sym_STAR_EQ] = ACTIONS(609),
    [anon_sym_SLASH_EQ] = ACTIONS(609),
    [anon_sym_PERCENT_EQ] = ACTIONS(609),
    [anon_sym_GT] = ACTIONS(611),
    [anon_sym_GT_GT] = ACTIONS(609),
    [anon_sym_2_GT] = ACTIONS(611),
    [anon_sym_2_GT_GT] = ACTIONS(609),
    [anon_sym_3_GT] = ACTIONS(611),
    [anon_sym_3_GT_GT] = ACTIONS(609),
    [anon_sym_4_GT] = ACTIONS(611),
    [anon_sym_4_GT_GT] = ACTIONS(609),
    [anon_sym_5_GT] = ACTIONS(611),
    [anon_sym_5_GT_GT] = ACTIONS(609),
    [anon_sym_6_GT] = ACTIONS(611),
    [anon_sym_6_GT_GT] = ACTIONS(609),
    [anon_sym_STAR_GT] = ACTIONS(611),
    [anon_sym_STAR_GT_GT] = ACTIONS(609),
    [anon_sym_LT] = ACTIONS(611),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(609),
    [anon_sym_2_GT_AMP1] = ACTIONS(609),
    [anon_sym_3_GT_AMP1] = ACTIONS(609),
    [anon_sym_4_GT_AMP1] = ACTIONS(609),
    [anon_sym_5_GT_AMP1] = ACTIONS(609),
    [anon_sym_6_GT_AMP1] = ACTIONS(609),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(609),
    [anon_sym_1_GT_AMP2] = ACTIONS(609),
    [anon_sym_3_GT_AMP2] = ACTIONS(609),
    [anon_sym_4_GT_AMP2] = ACTIONS(609),
    [anon_sym_5_GT_AMP2] = ACTIONS(609),
    [anon_sym_6_GT_AMP2] = ACTIONS(609),
    [anon_sym_DASHas] = ACTIONS(609),
    [anon_sym_DASHccontains] = ACTIONS(609),
    [anon_sym_DASHceq] = ACTIONS(609),
    [anon_sym_DASHcge] = ACTIONS(609),
    [anon_sym_DASHcgt] = ACTIONS(609),
    [anon_sym_DASHcle] = ACTIONS(609),
    [anon_sym_DASHclike] = ACTIONS(609),
    [anon_sym_DASHclt] = ACTIONS(609),
    [anon_sym_DASHcmatch] = ACTIONS(609),
    [anon_sym_DASHcne] = ACTIONS(609),
    [anon_sym_DASHcnotcontains] = ACTIONS(609),
    [anon_sym_DASHcnotlike] = ACTIONS(609),
    [anon_sym_DASHcnotmatch] = ACTIONS(609),
    [anon_sym_DASHcontains] = ACTIONS(609),
    [anon_sym_DASHcreplace] = ACTIONS(609),
    [anon_sym_DASHcsplit] = ACTIONS(609),
    [anon_sym_DASHeq] = ACTIONS(609),
    [anon_sym_DASHge] = ACTIONS(609),
    [anon_sym_DASHgt] = ACTIONS(609),
    [anon_sym_DASHicontains] = ACTIONS(609),
    [anon_sym_DASHieq] = ACTIONS(609),
    [anon_sym_DASHige] = ACTIONS(609),
    [anon_sym_DASHigt] = ACTIONS(609),
    [anon_sym_DASHile] = ACTIONS(609),
    [anon_sym_DASHilike] = ACTIONS(609),
    [anon_sym_DASHilt] = ACTIONS(609),
    [anon_sym_DASHimatch] = ACTIONS(609),
    [anon_sym_DASHin] = ACTIONS(611),
    [anon_sym_DASHine] = ACTIONS(609),
    [anon_sym_DASHinotcontains] = ACTIONS(609),
    [anon_sym_DASHinotlike] = ACTIONS(609),
    [anon_sym_DASHinotmatch] = ACTIONS(609),
    [anon_sym_DASHireplace] = ACTIONS(609),
    [anon_sym_DASHis] = ACTIONS(611),
    [anon_sym_DASHisnot] = ACTIONS(609),
    [anon_sym_DASHisplit] = ACTIONS(609),
    [anon_sym_DASHjoin] = ACTIONS(609),
    [anon_sym_DASHle] = ACTIONS(609),
    [anon_sym_DASHlike] = ACTIONS(609),
    [anon_sym_DASHlt] = ACTIONS(609),
    [anon_sym_DASHmatch] = ACTIONS(609),
    [anon_sym_DASHne] = ACTIONS(609),
    [anon_sym_DASHnotcontains] = ACTIONS(609),
    [anon_sym_DASHnotin] = ACTIONS(609),
    [anon_sym_DASHnotlike] = ACTIONS(609),
    [anon_sym_DASHnotmatch] = ACTIONS(609),
    [anon_sym_DASHreplace] = ACTIONS(609),
    [anon_sym_DASHshl] = ACTIONS(609),
    [anon_sym_DASHshr] = ACTIONS(609),
    [anon_sym_DASHsplit] = ACTIONS(609),
    [sym_format_operator] = ACTIONS(609),
    [anon_sym_LPAREN] = ACTIONS(609),
    [anon_sym_COMMA] = ACTIONS(609),
    [anon_sym_PIPE] = ACTIONS(609),
    [anon_sym_PERCENT] = ACTIONS(611),
    [anon_sym_DASHand] = ACTIONS(609),
    [anon_sym_DASHor] = ACTIONS(609),
    [anon_sym_DASHxor] = ACTIONS(609),
    [anon_sym_DASHband] = ACTIONS(609),
    [anon_sym_DASHbor] = ACTIONS(609),
    [anon_sym_DASHbxor] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_SLASH] = ACTIONS(611),
    [anon_sym_BSLASH] = ACTIONS(609),
    [anon_sym_STAR] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(609),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DOT2] = ACTIONS(611),
    [anon_sym_COLON_COLON] = ACTIONS(609),
    [anon_sym_DOTforeach] = ACTIONS(609),
    [sym__statement_terminator] = ACTIONS(609),
  },
  [144] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(633),
    [anon_sym_EQ] = ACTIONS(633),
    [anon_sym_BANG_EQ] = ACTIONS(633),
    [anon_sym_PLUS_EQ] = ACTIONS(633),
    [anon_sym_STAR_EQ] = ACTIONS(633),
    [anon_sym_SLASH_EQ] = ACTIONS(633),
    [anon_sym_PERCENT_EQ] = ACTIONS(633),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_2_GT] = ACTIONS(635),
    [anon_sym_2_GT_GT] = ACTIONS(633),
    [anon_sym_3_GT] = ACTIONS(635),
    [anon_sym_3_GT_GT] = ACTIONS(633),
    [anon_sym_4_GT] = ACTIONS(635),
    [anon_sym_4_GT_GT] = ACTIONS(633),
    [anon_sym_5_GT] = ACTIONS(635),
    [anon_sym_5_GT_GT] = ACTIONS(633),
    [anon_sym_6_GT] = ACTIONS(635),
    [anon_sym_6_GT_GT] = ACTIONS(633),
    [anon_sym_STAR_GT] = ACTIONS(635),
    [anon_sym_STAR_GT_GT] = ACTIONS(633),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(633),
    [anon_sym_2_GT_AMP1] = ACTIONS(633),
    [anon_sym_3_GT_AMP1] = ACTIONS(633),
    [anon_sym_4_GT_AMP1] = ACTIONS(633),
    [anon_sym_5_GT_AMP1] = ACTIONS(633),
    [anon_sym_6_GT_AMP1] = ACTIONS(633),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(633),
    [anon_sym_1_GT_AMP2] = ACTIONS(633),
    [anon_sym_3_GT_AMP2] = ACTIONS(633),
    [anon_sym_4_GT_AMP2] = ACTIONS(633),
    [anon_sym_5_GT_AMP2] = ACTIONS(633),
    [anon_sym_6_GT_AMP2] = ACTIONS(633),
    [anon_sym_DASHas] = ACTIONS(633),
    [anon_sym_DASHccontains] = ACTIONS(633),
    [anon_sym_DASHceq] = ACTIONS(633),
    [anon_sym_DASHcge] = ACTIONS(633),
    [anon_sym_DASHcgt] = ACTIONS(633),
    [anon_sym_DASHcle] = ACTIONS(633),
    [anon_sym_DASHclike] = ACTIONS(633),
    [anon_sym_DASHclt] = ACTIONS(633),
    [anon_sym_DASHcmatch] = ACTIONS(633),
    [anon_sym_DASHcne] = ACTIONS(633),
    [anon_sym_DASHcnotcontains] = ACTIONS(633),
    [anon_sym_DASHcnotlike] = ACTIONS(633),
    [anon_sym_DASHcnotmatch] = ACTIONS(633),
    [anon_sym_DASHcontains] = ACTIONS(633),
    [anon_sym_DASHcreplace] = ACTIONS(633),
    [anon_sym_DASHcsplit] = ACTIONS(633),
    [anon_sym_DASHeq] = ACTIONS(633),
    [anon_sym_DASHge] = ACTIONS(633),
    [anon_sym_DASHgt] = ACTIONS(633),
    [anon_sym_DASHicontains] = ACTIONS(633),
    [anon_sym_DASHieq] = ACTIONS(633),
    [anon_sym_DASHige] = ACTIONS(633),
    [anon_sym_DASHigt] = ACTIONS(633),
    [anon_sym_DASHile] = ACTIONS(633),
    [anon_sym_DASHilike] = ACTIONS(633),
    [anon_sym_DASHilt] = ACTIONS(633),
    [anon_sym_DASHimatch] = ACTIONS(633),
    [anon_sym_DASHin] = ACTIONS(635),
    [anon_sym_DASHine] = ACTIONS(633),
    [anon_sym_DASHinotcontains] = ACTIONS(633),
    [anon_sym_DASHinotlike] = ACTIONS(633),
    [anon_sym_DASHinotmatch] = ACTIONS(633),
    [anon_sym_DASHireplace] = ACTIONS(633),
    [anon_sym_DASHis] = ACTIONS(635),
    [anon_sym_DASHisnot] = ACTIONS(633),
    [anon_sym_DASHisplit] = ACTIONS(633),
    [anon_sym_DASHjoin] = ACTIONS(633),
    [anon_sym_DASHle] = ACTIONS(633),
    [anon_sym_DASHlike] = ACTIONS(633),
    [anon_sym_DASHlt] = ACTIONS(633),
    [anon_sym_DASHmatch] = ACTIONS(633),
    [anon_sym_DASHne] = ACTIONS(633),
    [anon_sym_DASHnotcontains] = ACTIONS(633),
    [anon_sym_DASHnotin] = ACTIONS(633),
    [anon_sym_DASHnotlike] = ACTIONS(633),
    [anon_sym_DASHnotmatch] = ACTIONS(633),
    [anon_sym_DASHreplace] = ACTIONS(633),
    [anon_sym_DASHshl] = ACTIONS(633),
    [anon_sym_DASHshr] = ACTIONS(633),
    [anon_sym_DASHsplit] = ACTIONS(633),
    [sym_format_operator] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_COMMA] = ACTIONS(633),
    [anon_sym_PIPE] = ACTIONS(633),
    [anon_sym_PERCENT] = ACTIONS(635),
    [anon_sym_DASHand] = ACTIONS(633),
    [anon_sym_DASHor] = ACTIONS(633),
    [anon_sym_DASHxor] = ACTIONS(633),
    [anon_sym_DASHband] = ACTIONS(633),
    [anon_sym_DASHbor] = ACTIONS(633),
    [anon_sym_DASHbxor] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(635),
    [anon_sym_DASH] = ACTIONS(635),
    [anon_sym_SLASH] = ACTIONS(635),
    [anon_sym_BSLASH] = ACTIONS(633),
    [anon_sym_STAR] = ACTIONS(635),
    [anon_sym_DOT_DOT] = ACTIONS(633),
    [anon_sym_PLUS_PLUS] = ACTIONS(633),
    [anon_sym_DASH_DASH] = ACTIONS(633),
    [anon_sym_DOT2] = ACTIONS(635),
    [anon_sym_COLON_COLON] = ACTIONS(633),
    [anon_sym_DOTforeach] = ACTIONS(633),
    [sym__statement_terminator] = ACTIONS(633),
  },
  [145] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_PLUS_EQ] = ACTIONS(713),
    [anon_sym_STAR_EQ] = ACTIONS(713),
    [anon_sym_SLASH_EQ] = ACTIONS(713),
    [anon_sym_PERCENT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(713),
    [anon_sym_2_GT] = ACTIONS(715),
    [anon_sym_2_GT_GT] = ACTIONS(713),
    [anon_sym_3_GT] = ACTIONS(715),
    [anon_sym_3_GT_GT] = ACTIONS(713),
    [anon_sym_4_GT] = ACTIONS(715),
    [anon_sym_4_GT_GT] = ACTIONS(713),
    [anon_sym_5_GT] = ACTIONS(715),
    [anon_sym_5_GT_GT] = ACTIONS(713),
    [anon_sym_6_GT] = ACTIONS(715),
    [anon_sym_6_GT_GT] = ACTIONS(713),
    [anon_sym_STAR_GT] = ACTIONS(715),
    [anon_sym_STAR_GT_GT] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(713),
    [anon_sym_2_GT_AMP1] = ACTIONS(713),
    [anon_sym_3_GT_AMP1] = ACTIONS(713),
    [anon_sym_4_GT_AMP1] = ACTIONS(713),
    [anon_sym_5_GT_AMP1] = ACTIONS(713),
    [anon_sym_6_GT_AMP1] = ACTIONS(713),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(713),
    [anon_sym_1_GT_AMP2] = ACTIONS(713),
    [anon_sym_3_GT_AMP2] = ACTIONS(713),
    [anon_sym_4_GT_AMP2] = ACTIONS(713),
    [anon_sym_5_GT_AMP2] = ACTIONS(713),
    [anon_sym_6_GT_AMP2] = ACTIONS(713),
    [anon_sym_DASHas] = ACTIONS(713),
    [anon_sym_DASHccontains] = ACTIONS(713),
    [anon_sym_DASHceq] = ACTIONS(713),
    [anon_sym_DASHcge] = ACTIONS(713),
    [anon_sym_DASHcgt] = ACTIONS(713),
    [anon_sym_DASHcle] = ACTIONS(713),
    [anon_sym_DASHclike] = ACTIONS(713),
    [anon_sym_DASHclt] = ACTIONS(713),
    [anon_sym_DASHcmatch] = ACTIONS(713),
    [anon_sym_DASHcne] = ACTIONS(713),
    [anon_sym_DASHcnotcontains] = ACTIONS(713),
    [anon_sym_DASHcnotlike] = ACTIONS(713),
    [anon_sym_DASHcnotmatch] = ACTIONS(713),
    [anon_sym_DASHcontains] = ACTIONS(713),
    [anon_sym_DASHcreplace] = ACTIONS(713),
    [anon_sym_DASHcsplit] = ACTIONS(713),
    [anon_sym_DASHeq] = ACTIONS(713),
    [anon_sym_DASHge] = ACTIONS(713),
    [anon_sym_DASHgt] = ACTIONS(713),
    [anon_sym_DASHicontains] = ACTIONS(713),
    [anon_sym_DASHieq] = ACTIONS(713),
    [anon_sym_DASHige] = ACTIONS(713),
    [anon_sym_DASHigt] = ACTIONS(713),
    [anon_sym_DASHile] = ACTIONS(713),
    [anon_sym_DASHilike] = ACTIONS(713),
    [anon_sym_DASHilt] = ACTIONS(713),
    [anon_sym_DASHimatch] = ACTIONS(713),
    [anon_sym_DASHin] = ACTIONS(715),
    [anon_sym_DASHine] = ACTIONS(713),
    [anon_sym_DASHinotcontains] = ACTIONS(713),
    [anon_sym_DASHinotlike] = ACTIONS(713),
    [anon_sym_DASHinotmatch] = ACTIONS(713),
    [anon_sym_DASHireplace] = ACTIONS(713),
    [anon_sym_DASHis] = ACTIONS(715),
    [anon_sym_DASHisnot] = ACTIONS(713),
    [anon_sym_DASHisplit] = ACTIONS(713),
    [anon_sym_DASHjoin] = ACTIONS(713),
    [anon_sym_DASHle] = ACTIONS(713),
    [anon_sym_DASHlike] = ACTIONS(713),
    [anon_sym_DASHlt] = ACTIONS(713),
    [anon_sym_DASHmatch] = ACTIONS(713),
    [anon_sym_DASHne] = ACTIONS(713),
    [anon_sym_DASHnotcontains] = ACTIONS(713),
    [anon_sym_DASHnotin] = ACTIONS(713),
    [anon_sym_DASHnotlike] = ACTIONS(713),
    [anon_sym_DASHnotmatch] = ACTIONS(713),
    [anon_sym_DASHreplace] = ACTIONS(713),
    [anon_sym_DASHshl] = ACTIONS(713),
    [anon_sym_DASHshr] = ACTIONS(713),
    [anon_sym_DASHsplit] = ACTIONS(713),
    [sym_format_operator] = ACTIONS(713),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(713),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_DASHand] = ACTIONS(713),
    [anon_sym_DASHor] = ACTIONS(713),
    [anon_sym_DASHxor] = ACTIONS(713),
    [anon_sym_DASHband] = ACTIONS(713),
    [anon_sym_DASHbor] = ACTIONS(713),
    [anon_sym_DASHbxor] = ACTIONS(713),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_BSLASH] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_DOT_DOT] = ACTIONS(713),
    [anon_sym_PLUS_PLUS] = ACTIONS(747),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_DOT2] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(753),
    [anon_sym_DOTforeach] = ACTIONS(755),
    [sym__statement_terminator] = ACTIONS(713),
  },
  [146] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_EQ] = ACTIONS(651),
    [anon_sym_BANG_EQ] = ACTIONS(651),
    [anon_sym_PLUS_EQ] = ACTIONS(651),
    [anon_sym_STAR_EQ] = ACTIONS(651),
    [anon_sym_SLASH_EQ] = ACTIONS(651),
    [anon_sym_PERCENT_EQ] = ACTIONS(651),
    [anon_sym_GT] = ACTIONS(654),
    [anon_sym_GT_GT] = ACTIONS(651),
    [anon_sym_2_GT] = ACTIONS(654),
    [anon_sym_2_GT_GT] = ACTIONS(651),
    [anon_sym_3_GT] = ACTIONS(654),
    [anon_sym_3_GT_GT] = ACTIONS(651),
    [anon_sym_4_GT] = ACTIONS(654),
    [anon_sym_4_GT_GT] = ACTIONS(651),
    [anon_sym_5_GT] = ACTIONS(654),
    [anon_sym_5_GT_GT] = ACTIONS(651),
    [anon_sym_6_GT] = ACTIONS(654),
    [anon_sym_6_GT_GT] = ACTIONS(651),
    [anon_sym_STAR_GT] = ACTIONS(654),
    [anon_sym_STAR_GT_GT] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(654),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(651),
    [anon_sym_2_GT_AMP1] = ACTIONS(651),
    [anon_sym_3_GT_AMP1] = ACTIONS(651),
    [anon_sym_4_GT_AMP1] = ACTIONS(651),
    [anon_sym_5_GT_AMP1] = ACTIONS(651),
    [anon_sym_6_GT_AMP1] = ACTIONS(651),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(651),
    [anon_sym_1_GT_AMP2] = ACTIONS(651),
    [anon_sym_3_GT_AMP2] = ACTIONS(651),
    [anon_sym_4_GT_AMP2] = ACTIONS(651),
    [anon_sym_5_GT_AMP2] = ACTIONS(651),
    [anon_sym_6_GT_AMP2] = ACTIONS(651),
    [anon_sym_DASHas] = ACTIONS(651),
    [anon_sym_DASHccontains] = ACTIONS(651),
    [anon_sym_DASHceq] = ACTIONS(651),
    [anon_sym_DASHcge] = ACTIONS(651),
    [anon_sym_DASHcgt] = ACTIONS(651),
    [anon_sym_DASHcle] = ACTIONS(651),
    [anon_sym_DASHclike] = ACTIONS(651),
    [anon_sym_DASHclt] = ACTIONS(651),
    [anon_sym_DASHcmatch] = ACTIONS(651),
    [anon_sym_DASHcne] = ACTIONS(651),
    [anon_sym_DASHcnotcontains] = ACTIONS(651),
    [anon_sym_DASHcnotlike] = ACTIONS(651),
    [anon_sym_DASHcnotmatch] = ACTIONS(651),
    [anon_sym_DASHcontains] = ACTIONS(651),
    [anon_sym_DASHcreplace] = ACTIONS(651),
    [anon_sym_DASHcsplit] = ACTIONS(651),
    [anon_sym_DASHeq] = ACTIONS(651),
    [anon_sym_DASHge] = ACTIONS(651),
    [anon_sym_DASHgt] = ACTIONS(651),
    [anon_sym_DASHicontains] = ACTIONS(651),
    [anon_sym_DASHieq] = ACTIONS(651),
    [anon_sym_DASHige] = ACTIONS(651),
    [anon_sym_DASHigt] = ACTIONS(651),
    [anon_sym_DASHile] = ACTIONS(651),
    [anon_sym_DASHilike] = ACTIONS(651),
    [anon_sym_DASHilt] = ACTIONS(651),
    [anon_sym_DASHimatch] = ACTIONS(651),
    [anon_sym_DASHin] = ACTIONS(654),
    [anon_sym_DASHine] = ACTIONS(651),
    [anon_sym_DASHinotcontains] = ACTIONS(651),
    [anon_sym_DASHinotlike] = ACTIONS(651),
    [anon_sym_DASHinotmatch] = ACTIONS(651),
    [anon_sym_DASHireplace] = ACTIONS(651),
    [anon_sym_DASHis] = ACTIONS(654),
    [anon_sym_DASHisnot] = ACTIONS(651),
    [anon_sym_DASHisplit] = ACTIONS(651),
    [anon_sym_DASHjoin] = ACTIONS(651),
    [anon_sym_DASHle] = ACTIONS(651),
    [anon_sym_DASHlike] = ACTIONS(651),
    [anon_sym_DASHlt] = ACTIONS(651),
    [anon_sym_DASHmatch] = ACTIONS(651),
    [anon_sym_DASHne] = ACTIONS(651),
    [anon_sym_DASHnotcontains] = ACTIONS(651),
    [anon_sym_DASHnotin] = ACTIONS(651),
    [anon_sym_DASHnotlike] = ACTIONS(651),
    [anon_sym_DASHnotmatch] = ACTIONS(651),
    [anon_sym_DASHreplace] = ACTIONS(651),
    [anon_sym_DASHshl] = ACTIONS(651),
    [anon_sym_DASHshr] = ACTIONS(651),
    [anon_sym_DASHsplit] = ACTIONS(651),
    [sym_format_operator] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(651),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_PIPE] = ACTIONS(651),
    [anon_sym_PERCENT] = ACTIONS(654),
    [anon_sym_DASHand] = ACTIONS(651),
    [anon_sym_DASHor] = ACTIONS(651),
    [anon_sym_DASHxor] = ACTIONS(651),
    [anon_sym_DASHband] = ACTIONS(651),
    [anon_sym_DASHbor] = ACTIONS(651),
    [anon_sym_DASHbxor] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(654),
    [anon_sym_DASH] = ACTIONS(654),
    [anon_sym_SLASH] = ACTIONS(654),
    [anon_sym_BSLASH] = ACTIONS(651),
    [anon_sym_STAR] = ACTIONS(654),
    [anon_sym_DOT_DOT] = ACTIONS(651),
    [anon_sym_PLUS_PLUS] = ACTIONS(651),
    [anon_sym_DASH_DASH] = ACTIONS(651),
    [anon_sym_DOT2] = ACTIONS(654),
    [anon_sym_COLON_COLON] = ACTIONS(651),
    [anon_sym_DOTforeach] = ACTIONS(651),
    [sym__statement_terminator] = ACTIONS(651),
  },
  [147] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(693),
    [anon_sym_EQ] = ACTIONS(693),
    [anon_sym_BANG_EQ] = ACTIONS(693),
    [anon_sym_PLUS_EQ] = ACTIONS(693),
    [anon_sym_STAR_EQ] = ACTIONS(693),
    [anon_sym_SLASH_EQ] = ACTIONS(693),
    [anon_sym_PERCENT_EQ] = ACTIONS(693),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(693),
    [anon_sym_2_GT] = ACTIONS(695),
    [anon_sym_2_GT_GT] = ACTIONS(693),
    [anon_sym_3_GT] = ACTIONS(695),
    [anon_sym_3_GT_GT] = ACTIONS(693),
    [anon_sym_4_GT] = ACTIONS(695),
    [anon_sym_4_GT_GT] = ACTIONS(693),
    [anon_sym_5_GT] = ACTIONS(695),
    [anon_sym_5_GT_GT] = ACTIONS(693),
    [anon_sym_6_GT] = ACTIONS(695),
    [anon_sym_6_GT_GT] = ACTIONS(693),
    [anon_sym_STAR_GT] = ACTIONS(695),
    [anon_sym_STAR_GT_GT] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(693),
    [anon_sym_2_GT_AMP1] = ACTIONS(693),
    [anon_sym_3_GT_AMP1] = ACTIONS(693),
    [anon_sym_4_GT_AMP1] = ACTIONS(693),
    [anon_sym_5_GT_AMP1] = ACTIONS(693),
    [anon_sym_6_GT_AMP1] = ACTIONS(693),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(693),
    [anon_sym_1_GT_AMP2] = ACTIONS(693),
    [anon_sym_3_GT_AMP2] = ACTIONS(693),
    [anon_sym_4_GT_AMP2] = ACTIONS(693),
    [anon_sym_5_GT_AMP2] = ACTIONS(693),
    [anon_sym_6_GT_AMP2] = ACTIONS(693),
    [anon_sym_DASHas] = ACTIONS(693),
    [anon_sym_DASHccontains] = ACTIONS(693),
    [anon_sym_DASHceq] = ACTIONS(693),
    [anon_sym_DASHcge] = ACTIONS(693),
    [anon_sym_DASHcgt] = ACTIONS(693),
    [anon_sym_DASHcle] = ACTIONS(693),
    [anon_sym_DASHclike] = ACTIONS(693),
    [anon_sym_DASHclt] = ACTIONS(693),
    [anon_sym_DASHcmatch] = ACTIONS(693),
    [anon_sym_DASHcne] = ACTIONS(693),
    [anon_sym_DASHcnotcontains] = ACTIONS(693),
    [anon_sym_DASHcnotlike] = ACTIONS(693),
    [anon_sym_DASHcnotmatch] = ACTIONS(693),
    [anon_sym_DASHcontains] = ACTIONS(693),
    [anon_sym_DASHcreplace] = ACTIONS(693),
    [anon_sym_DASHcsplit] = ACTIONS(693),
    [anon_sym_DASHeq] = ACTIONS(693),
    [anon_sym_DASHge] = ACTIONS(693),
    [anon_sym_DASHgt] = ACTIONS(693),
    [anon_sym_DASHicontains] = ACTIONS(693),
    [anon_sym_DASHieq] = ACTIONS(693),
    [anon_sym_DASHige] = ACTIONS(693),
    [anon_sym_DASHigt] = ACTIONS(693),
    [anon_sym_DASHile] = ACTIONS(693),
    [anon_sym_DASHilike] = ACTIONS(693),
    [anon_sym_DASHilt] = ACTIONS(693),
    [anon_sym_DASHimatch] = ACTIONS(693),
    [anon_sym_DASHin] = ACTIONS(695),
    [anon_sym_DASHine] = ACTIONS(693),
    [anon_sym_DASHinotcontains] = ACTIONS(693),
    [anon_sym_DASHinotlike] = ACTIONS(693),
    [anon_sym_DASHinotmatch] = ACTIONS(693),
    [anon_sym_DASHireplace] = ACTIONS(693),
    [anon_sym_DASHis] = ACTIONS(695),
    [anon_sym_DASHisnot] = ACTIONS(693),
    [anon_sym_DASHisplit] = ACTIONS(693),
    [anon_sym_DASHjoin] = ACTIONS(693),
    [anon_sym_DASHle] = ACTIONS(693),
    [anon_sym_DASHlike] = ACTIONS(693),
    [anon_sym_DASHlt] = ACTIONS(693),
    [anon_sym_DASHmatch] = ACTIONS(693),
    [anon_sym_DASHne] = ACTIONS(693),
    [anon_sym_DASHnotcontains] = ACTIONS(693),
    [anon_sym_DASHnotin] = ACTIONS(693),
    [anon_sym_DASHnotlike] = ACTIONS(693),
    [anon_sym_DASHnotmatch] = ACTIONS(693),
    [anon_sym_DASHreplace] = ACTIONS(693),
    [anon_sym_DASHshl] = ACTIONS(693),
    [anon_sym_DASHshr] = ACTIONS(693),
    [anon_sym_DASHsplit] = ACTIONS(693),
    [sym_format_operator] = ACTIONS(693),
    [anon_sym_LPAREN] = ACTIONS(693),
    [anon_sym_COMMA] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(693),
    [anon_sym_PERCENT] = ACTIONS(695),
    [anon_sym_DASHand] = ACTIONS(693),
    [anon_sym_DASHor] = ACTIONS(693),
    [anon_sym_DASHxor] = ACTIONS(693),
    [anon_sym_DASHband] = ACTIONS(693),
    [anon_sym_DASHbor] = ACTIONS(693),
    [anon_sym_DASHbxor] = ACTIONS(693),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_SLASH] = ACTIONS(695),
    [anon_sym_BSLASH] = ACTIONS(693),
    [anon_sym_STAR] = ACTIONS(695),
    [anon_sym_DOT_DOT] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_DOT2] = ACTIONS(695),
    [anon_sym_COLON_COLON] = ACTIONS(693),
    [anon_sym_DOTforeach] = ACTIONS(693),
    [sym__statement_terminator] = ACTIONS(693),
  },
  [148] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(673),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_BANG_EQ] = ACTIONS(673),
    [anon_sym_PLUS_EQ] = ACTIONS(673),
    [anon_sym_STAR_EQ] = ACTIONS(673),
    [anon_sym_SLASH_EQ] = ACTIONS(673),
    [anon_sym_PERCENT_EQ] = ACTIONS(673),
    [anon_sym_GT] = ACTIONS(675),
    [anon_sym_GT_GT] = ACTIONS(673),
    [anon_sym_2_GT] = ACTIONS(675),
    [anon_sym_2_GT_GT] = ACTIONS(673),
    [anon_sym_3_GT] = ACTIONS(675),
    [anon_sym_3_GT_GT] = ACTIONS(673),
    [anon_sym_4_GT] = ACTIONS(675),
    [anon_sym_4_GT_GT] = ACTIONS(673),
    [anon_sym_5_GT] = ACTIONS(675),
    [anon_sym_5_GT_GT] = ACTIONS(673),
    [anon_sym_6_GT] = ACTIONS(675),
    [anon_sym_6_GT_GT] = ACTIONS(673),
    [anon_sym_STAR_GT] = ACTIONS(675),
    [anon_sym_STAR_GT_GT] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(675),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(673),
    [anon_sym_2_GT_AMP1] = ACTIONS(673),
    [anon_sym_3_GT_AMP1] = ACTIONS(673),
    [anon_sym_4_GT_AMP1] = ACTIONS(673),
    [anon_sym_5_GT_AMP1] = ACTIONS(673),
    [anon_sym_6_GT_AMP1] = ACTIONS(673),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(673),
    [anon_sym_1_GT_AMP2] = ACTIONS(673),
    [anon_sym_3_GT_AMP2] = ACTIONS(673),
    [anon_sym_4_GT_AMP2] = ACTIONS(673),
    [anon_sym_5_GT_AMP2] = ACTIONS(673),
    [anon_sym_6_GT_AMP2] = ACTIONS(673),
    [anon_sym_DASHas] = ACTIONS(673),
    [anon_sym_DASHccontains] = ACTIONS(673),
    [anon_sym_DASHceq] = ACTIONS(673),
    [anon_sym_DASHcge] = ACTIONS(673),
    [anon_sym_DASHcgt] = ACTIONS(673),
    [anon_sym_DASHcle] = ACTIONS(673),
    [anon_sym_DASHclike] = ACTIONS(673),
    [anon_sym_DASHclt] = ACTIONS(673),
    [anon_sym_DASHcmatch] = ACTIONS(673),
    [anon_sym_DASHcne] = ACTIONS(673),
    [anon_sym_DASHcnotcontains] = ACTIONS(673),
    [anon_sym_DASHcnotlike] = ACTIONS(673),
    [anon_sym_DASHcnotmatch] = ACTIONS(673),
    [anon_sym_DASHcontains] = ACTIONS(673),
    [anon_sym_DASHcreplace] = ACTIONS(673),
    [anon_sym_DASHcsplit] = ACTIONS(673),
    [anon_sym_DASHeq] = ACTIONS(673),
    [anon_sym_DASHge] = ACTIONS(673),
    [anon_sym_DASHgt] = ACTIONS(673),
    [anon_sym_DASHicontains] = ACTIONS(673),
    [anon_sym_DASHieq] = ACTIONS(673),
    [anon_sym_DASHige] = ACTIONS(673),
    [anon_sym_DASHigt] = ACTIONS(673),
    [anon_sym_DASHile] = ACTIONS(673),
    [anon_sym_DASHilike] = ACTIONS(673),
    [anon_sym_DASHilt] = ACTIONS(673),
    [anon_sym_DASHimatch] = ACTIONS(673),
    [anon_sym_DASHin] = ACTIONS(675),
    [anon_sym_DASHine] = ACTIONS(673),
    [anon_sym_DASHinotcontains] = ACTIONS(673),
    [anon_sym_DASHinotlike] = ACTIONS(673),
    [anon_sym_DASHinotmatch] = ACTIONS(673),
    [anon_sym_DASHireplace] = ACTIONS(673),
    [anon_sym_DASHis] = ACTIONS(675),
    [anon_sym_DASHisnot] = ACTIONS(673),
    [anon_sym_DASHisplit] = ACTIONS(673),
    [anon_sym_DASHjoin] = ACTIONS(673),
    [anon_sym_DASHle] = ACTIONS(673),
    [anon_sym_DASHlike] = ACTIONS(673),
    [anon_sym_DASHlt] = ACTIONS(673),
    [anon_sym_DASHmatch] = ACTIONS(673),
    [anon_sym_DASHne] = ACTIONS(673),
    [anon_sym_DASHnotcontains] = ACTIONS(673),
    [anon_sym_DASHnotin] = ACTIONS(673),
    [anon_sym_DASHnotlike] = ACTIONS(673),
    [anon_sym_DASHnotmatch] = ACTIONS(673),
    [anon_sym_DASHreplace] = ACTIONS(673),
    [anon_sym_DASHshl] = ACTIONS(673),
    [anon_sym_DASHshr] = ACTIONS(673),
    [anon_sym_DASHsplit] = ACTIONS(673),
    [sym_format_operator] = ACTIONS(673),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_COMMA] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(675),
    [anon_sym_DASHand] = ACTIONS(673),
    [anon_sym_DASHor] = ACTIONS(673),
    [anon_sym_DASHxor] = ACTIONS(673),
    [anon_sym_DASHband] = ACTIONS(673),
    [anon_sym_DASHbor] = ACTIONS(673),
    [anon_sym_DASHbxor] = ACTIONS(673),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_BSLASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(675),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DOT2] = ACTIONS(675),
    [anon_sym_COLON_COLON] = ACTIONS(673),
    [anon_sym_DOTforeach] = ACTIONS(673),
    [sym__statement_terminator] = ACTIONS(673),
  },
  [149] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(621),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_BANG_EQ] = ACTIONS(621),
    [anon_sym_PLUS_EQ] = ACTIONS(621),
    [anon_sym_STAR_EQ] = ACTIONS(621),
    [anon_sym_SLASH_EQ] = ACTIONS(621),
    [anon_sym_PERCENT_EQ] = ACTIONS(621),
    [anon_sym_GT] = ACTIONS(623),
    [anon_sym_GT_GT] = ACTIONS(621),
    [anon_sym_2_GT] = ACTIONS(623),
    [anon_sym_2_GT_GT] = ACTIONS(621),
    [anon_sym_3_GT] = ACTIONS(623),
    [anon_sym_3_GT_GT] = ACTIONS(621),
    [anon_sym_4_GT] = ACTIONS(623),
    [anon_sym_4_GT_GT] = ACTIONS(621),
    [anon_sym_5_GT] = ACTIONS(623),
    [anon_sym_5_GT_GT] = ACTIONS(621),
    [anon_sym_6_GT] = ACTIONS(623),
    [anon_sym_6_GT_GT] = ACTIONS(621),
    [anon_sym_STAR_GT] = ACTIONS(623),
    [anon_sym_STAR_GT_GT] = ACTIONS(621),
    [anon_sym_LT] = ACTIONS(623),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(621),
    [anon_sym_2_GT_AMP1] = ACTIONS(621),
    [anon_sym_3_GT_AMP1] = ACTIONS(621),
    [anon_sym_4_GT_AMP1] = ACTIONS(621),
    [anon_sym_5_GT_AMP1] = ACTIONS(621),
    [anon_sym_6_GT_AMP1] = ACTIONS(621),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(621),
    [anon_sym_1_GT_AMP2] = ACTIONS(621),
    [anon_sym_3_GT_AMP2] = ACTIONS(621),
    [anon_sym_4_GT_AMP2] = ACTIONS(621),
    [anon_sym_5_GT_AMP2] = ACTIONS(621),
    [anon_sym_6_GT_AMP2] = ACTIONS(621),
    [anon_sym_DASHas] = ACTIONS(621),
    [anon_sym_DASHccontains] = ACTIONS(621),
    [anon_sym_DASHceq] = ACTIONS(621),
    [anon_sym_DASHcge] = ACTIONS(621),
    [anon_sym_DASHcgt] = ACTIONS(621),
    [anon_sym_DASHcle] = ACTIONS(621),
    [anon_sym_DASHclike] = ACTIONS(621),
    [anon_sym_DASHclt] = ACTIONS(621),
    [anon_sym_DASHcmatch] = ACTIONS(621),
    [anon_sym_DASHcne] = ACTIONS(621),
    [anon_sym_DASHcnotcontains] = ACTIONS(621),
    [anon_sym_DASHcnotlike] = ACTIONS(621),
    [anon_sym_DASHcnotmatch] = ACTIONS(621),
    [anon_sym_DASHcontains] = ACTIONS(621),
    [anon_sym_DASHcreplace] = ACTIONS(621),
    [anon_sym_DASHcsplit] = ACTIONS(621),
    [anon_sym_DASHeq] = ACTIONS(621),
    [anon_sym_DASHge] = ACTIONS(621),
    [anon_sym_DASHgt] = ACTIONS(621),
    [anon_sym_DASHicontains] = ACTIONS(621),
    [anon_sym_DASHieq] = ACTIONS(621),
    [anon_sym_DASHige] = ACTIONS(621),
    [anon_sym_DASHigt] = ACTIONS(621),
    [anon_sym_DASHile] = ACTIONS(621),
    [anon_sym_DASHilike] = ACTIONS(621),
    [anon_sym_DASHilt] = ACTIONS(621),
    [anon_sym_DASHimatch] = ACTIONS(621),
    [anon_sym_DASHin] = ACTIONS(623),
    [anon_sym_DASHine] = ACTIONS(621),
    [anon_sym_DASHinotcontains] = ACTIONS(621),
    [anon_sym_DASHinotlike] = ACTIONS(621),
    [anon_sym_DASHinotmatch] = ACTIONS(621),
    [anon_sym_DASHireplace] = ACTIONS(621),
    [anon_sym_DASHis] = ACTIONS(623),
    [anon_sym_DASHisnot] = ACTIONS(621),
    [anon_sym_DASHisplit] = ACTIONS(621),
    [anon_sym_DASHjoin] = ACTIONS(621),
    [anon_sym_DASHle] = ACTIONS(621),
    [anon_sym_DASHlike] = ACTIONS(621),
    [anon_sym_DASHlt] = ACTIONS(621),
    [anon_sym_DASHmatch] = ACTIONS(621),
    [anon_sym_DASHne] = ACTIONS(621),
    [anon_sym_DASHnotcontains] = ACTIONS(621),
    [anon_sym_DASHnotin] = ACTIONS(621),
    [anon_sym_DASHnotlike] = ACTIONS(621),
    [anon_sym_DASHnotmatch] = ACTIONS(621),
    [anon_sym_DASHreplace] = ACTIONS(621),
    [anon_sym_DASHshl] = ACTIONS(621),
    [anon_sym_DASHshr] = ACTIONS(621),
    [anon_sym_DASHsplit] = ACTIONS(621),
    [sym_format_operator] = ACTIONS(621),
    [anon_sym_LPAREN] = ACTIONS(621),
    [anon_sym_COMMA] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(621),
    [anon_sym_PERCENT] = ACTIONS(623),
    [anon_sym_DASHand] = ACTIONS(621),
    [anon_sym_DASHor] = ACTIONS(621),
    [anon_sym_DASHxor] = ACTIONS(621),
    [anon_sym_DASHband] = ACTIONS(621),
    [anon_sym_DASHbor] = ACTIONS(621),
    [anon_sym_DASHbxor] = ACTIONS(621),
    [anon_sym_PLUS] = ACTIONS(623),
    [anon_sym_DASH] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(623),
    [anon_sym_BSLASH] = ACTIONS(621),
    [anon_sym_STAR] = ACTIONS(623),
    [anon_sym_DOT_DOT] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_DOT2] = ACTIONS(623),
    [anon_sym_COLON_COLON] = ACTIONS(621),
    [anon_sym_DOTforeach] = ACTIONS(621),
    [sym__statement_terminator] = ACTIONS(621),
  },
  [150] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(705),
    [anon_sym_EQ] = ACTIONS(705),
    [anon_sym_BANG_EQ] = ACTIONS(705),
    [anon_sym_PLUS_EQ] = ACTIONS(705),
    [anon_sym_STAR_EQ] = ACTIONS(705),
    [anon_sym_SLASH_EQ] = ACTIONS(705),
    [anon_sym_PERCENT_EQ] = ACTIONS(705),
    [anon_sym_GT] = ACTIONS(707),
    [anon_sym_GT_GT] = ACTIONS(705),
    [anon_sym_2_GT] = ACTIONS(707),
    [anon_sym_2_GT_GT] = ACTIONS(705),
    [anon_sym_3_GT] = ACTIONS(707),
    [anon_sym_3_GT_GT] = ACTIONS(705),
    [anon_sym_4_GT] = ACTIONS(707),
    [anon_sym_4_GT_GT] = ACTIONS(705),
    [anon_sym_5_GT] = ACTIONS(707),
    [anon_sym_5_GT_GT] = ACTIONS(705),
    [anon_sym_6_GT] = ACTIONS(707),
    [anon_sym_6_GT_GT] = ACTIONS(705),
    [anon_sym_STAR_GT] = ACTIONS(707),
    [anon_sym_STAR_GT_GT] = ACTIONS(705),
    [anon_sym_LT] = ACTIONS(707),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(705),
    [anon_sym_2_GT_AMP1] = ACTIONS(705),
    [anon_sym_3_GT_AMP1] = ACTIONS(705),
    [anon_sym_4_GT_AMP1] = ACTIONS(705),
    [anon_sym_5_GT_AMP1] = ACTIONS(705),
    [anon_sym_6_GT_AMP1] = ACTIONS(705),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(705),
    [anon_sym_1_GT_AMP2] = ACTIONS(705),
    [anon_sym_3_GT_AMP2] = ACTIONS(705),
    [anon_sym_4_GT_AMP2] = ACTIONS(705),
    [anon_sym_5_GT_AMP2] = ACTIONS(705),
    [anon_sym_6_GT_AMP2] = ACTIONS(705),
    [anon_sym_DASHas] = ACTIONS(705),
    [anon_sym_DASHccontains] = ACTIONS(705),
    [anon_sym_DASHceq] = ACTIONS(705),
    [anon_sym_DASHcge] = ACTIONS(705),
    [anon_sym_DASHcgt] = ACTIONS(705),
    [anon_sym_DASHcle] = ACTIONS(705),
    [anon_sym_DASHclike] = ACTIONS(705),
    [anon_sym_DASHclt] = ACTIONS(705),
    [anon_sym_DASHcmatch] = ACTIONS(705),
    [anon_sym_DASHcne] = ACTIONS(705),
    [anon_sym_DASHcnotcontains] = ACTIONS(705),
    [anon_sym_DASHcnotlike] = ACTIONS(705),
    [anon_sym_DASHcnotmatch] = ACTIONS(705),
    [anon_sym_DASHcontains] = ACTIONS(705),
    [anon_sym_DASHcreplace] = ACTIONS(705),
    [anon_sym_DASHcsplit] = ACTIONS(705),
    [anon_sym_DASHeq] = ACTIONS(705),
    [anon_sym_DASHge] = ACTIONS(705),
    [anon_sym_DASHgt] = ACTIONS(705),
    [anon_sym_DASHicontains] = ACTIONS(705),
    [anon_sym_DASHieq] = ACTIONS(705),
    [anon_sym_DASHige] = ACTIONS(705),
    [anon_sym_DASHigt] = ACTIONS(705),
    [anon_sym_DASHile] = ACTIONS(705),
    [anon_sym_DASHilike] = ACTIONS(705),
    [anon_sym_DASHilt] = ACTIONS(705),
    [anon_sym_DASHimatch] = ACTIONS(705),
    [anon_sym_DASHin] = ACTIONS(707),
    [anon_sym_DASHine] = ACTIONS(705),
    [anon_sym_DASHinotcontains] = ACTIONS(705),
    [anon_sym_DASHinotlike] = ACTIONS(705),
    [anon_sym_DASHinotmatch] = ACTIONS(705),
    [anon_sym_DASHireplace] = ACTIONS(705),
    [anon_sym_DASHis] = ACTIONS(707),
    [anon_sym_DASHisnot] = ACTIONS(705),
    [anon_sym_DASHisplit] = ACTIONS(705),
    [anon_sym_DASHjoin] = ACTIONS(705),
    [anon_sym_DASHle] = ACTIONS(705),
    [anon_sym_DASHlike] = ACTIONS(705),
    [anon_sym_DASHlt] = ACTIONS(705),
    [anon_sym_DASHmatch] = ACTIONS(705),
    [anon_sym_DASHne] = ACTIONS(705),
    [anon_sym_DASHnotcontains] = ACTIONS(705),
    [anon_sym_DASHnotin] = ACTIONS(705),
    [anon_sym_DASHnotlike] = ACTIONS(705),
    [anon_sym_DASHnotmatch] = ACTIONS(705),
    [anon_sym_DASHreplace] = ACTIONS(705),
    [anon_sym_DASHshl] = ACTIONS(705),
    [anon_sym_DASHshr] = ACTIONS(705),
    [anon_sym_DASHsplit] = ACTIONS(705),
    [sym_format_operator] = ACTIONS(705),
    [anon_sym_LPAREN] = ACTIONS(705),
    [anon_sym_COMMA] = ACTIONS(705),
    [anon_sym_PIPE] = ACTIONS(705),
    [anon_sym_PERCENT] = ACTIONS(707),
    [anon_sym_DASHand] = ACTIONS(705),
    [anon_sym_DASHor] = ACTIONS(705),
    [anon_sym_DASHxor] = ACTIONS(705),
    [anon_sym_DASHband] = ACTIONS(705),
    [anon_sym_DASHbor] = ACTIONS(705),
    [anon_sym_DASHbxor] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(707),
    [anon_sym_SLASH] = ACTIONS(707),
    [anon_sym_BSLASH] = ACTIONS(705),
    [anon_sym_STAR] = ACTIONS(707),
    [anon_sym_DOT_DOT] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(705),
    [anon_sym_DASH_DASH] = ACTIONS(705),
    [anon_sym_DOT2] = ACTIONS(707),
    [anon_sym_COLON_COLON] = ACTIONS(705),
    [anon_sym_DOTforeach] = ACTIONS(705),
    [sym__statement_terminator] = ACTIONS(705),
  },
  [151] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(677),
    [anon_sym_EQ] = ACTIONS(677),
    [anon_sym_BANG_EQ] = ACTIONS(677),
    [anon_sym_PLUS_EQ] = ACTIONS(677),
    [anon_sym_STAR_EQ] = ACTIONS(677),
    [anon_sym_SLASH_EQ] = ACTIONS(677),
    [anon_sym_PERCENT_EQ] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_2_GT] = ACTIONS(679),
    [anon_sym_2_GT_GT] = ACTIONS(677),
    [anon_sym_3_GT] = ACTIONS(679),
    [anon_sym_3_GT_GT] = ACTIONS(677),
    [anon_sym_4_GT] = ACTIONS(679),
    [anon_sym_4_GT_GT] = ACTIONS(677),
    [anon_sym_5_GT] = ACTIONS(679),
    [anon_sym_5_GT_GT] = ACTIONS(677),
    [anon_sym_6_GT] = ACTIONS(679),
    [anon_sym_6_GT_GT] = ACTIONS(677),
    [anon_sym_STAR_GT] = ACTIONS(679),
    [anon_sym_STAR_GT_GT] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(677),
    [anon_sym_2_GT_AMP1] = ACTIONS(677),
    [anon_sym_3_GT_AMP1] = ACTIONS(677),
    [anon_sym_4_GT_AMP1] = ACTIONS(677),
    [anon_sym_5_GT_AMP1] = ACTIONS(677),
    [anon_sym_6_GT_AMP1] = ACTIONS(677),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(677),
    [anon_sym_1_GT_AMP2] = ACTIONS(677),
    [anon_sym_3_GT_AMP2] = ACTIONS(677),
    [anon_sym_4_GT_AMP2] = ACTIONS(677),
    [anon_sym_5_GT_AMP2] = ACTIONS(677),
    [anon_sym_6_GT_AMP2] = ACTIONS(677),
    [anon_sym_DASHas] = ACTIONS(677),
    [anon_sym_DASHccontains] = ACTIONS(677),
    [anon_sym_DASHceq] = ACTIONS(677),
    [anon_sym_DASHcge] = ACTIONS(677),
    [anon_sym_DASHcgt] = ACTIONS(677),
    [anon_sym_DASHcle] = ACTIONS(677),
    [anon_sym_DASHclike] = ACTIONS(677),
    [anon_sym_DASHclt] = ACTIONS(677),
    [anon_sym_DASHcmatch] = ACTIONS(677),
    [anon_sym_DASHcne] = ACTIONS(677),
    [anon_sym_DASHcnotcontains] = ACTIONS(677),
    [anon_sym_DASHcnotlike] = ACTIONS(677),
    [anon_sym_DASHcnotmatch] = ACTIONS(677),
    [anon_sym_DASHcontains] = ACTIONS(677),
    [anon_sym_DASHcreplace] = ACTIONS(677),
    [anon_sym_DASHcsplit] = ACTIONS(677),
    [anon_sym_DASHeq] = ACTIONS(677),
    [anon_sym_DASHge] = ACTIONS(677),
    [anon_sym_DASHgt] = ACTIONS(677),
    [anon_sym_DASHicontains] = ACTIONS(677),
    [anon_sym_DASHieq] = ACTIONS(677),
    [anon_sym_DASHige] = ACTIONS(677),
    [anon_sym_DASHigt] = ACTIONS(677),
    [anon_sym_DASHile] = ACTIONS(677),
    [anon_sym_DASHilike] = ACTIONS(677),
    [anon_sym_DASHilt] = ACTIONS(677),
    [anon_sym_DASHimatch] = ACTIONS(677),
    [anon_sym_DASHin] = ACTIONS(679),
    [anon_sym_DASHine] = ACTIONS(677),
    [anon_sym_DASHinotcontains] = ACTIONS(677),
    [anon_sym_DASHinotlike] = ACTIONS(677),
    [anon_sym_DASHinotmatch] = ACTIONS(677),
    [anon_sym_DASHireplace] = ACTIONS(677),
    [anon_sym_DASHis] = ACTIONS(679),
    [anon_sym_DASHisnot] = ACTIONS(677),
    [anon_sym_DASHisplit] = ACTIONS(677),
    [anon_sym_DASHjoin] = ACTIONS(677),
    [anon_sym_DASHle] = ACTIONS(677),
    [anon_sym_DASHlike] = ACTIONS(677),
    [anon_sym_DASHlt] = ACTIONS(677),
    [anon_sym_DASHmatch] = ACTIONS(677),
    [anon_sym_DASHne] = ACTIONS(677),
    [anon_sym_DASHnotcontains] = ACTIONS(677),
    [anon_sym_DASHnotin] = ACTIONS(677),
    [anon_sym_DASHnotlike] = ACTIONS(677),
    [anon_sym_DASHnotmatch] = ACTIONS(677),
    [anon_sym_DASHreplace] = ACTIONS(677),
    [anon_sym_DASHshl] = ACTIONS(677),
    [anon_sym_DASHshr] = ACTIONS(677),
    [anon_sym_DASHsplit] = ACTIONS(677),
    [sym_format_operator] = ACTIONS(677),
    [anon_sym_LPAREN] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(677),
    [anon_sym_PIPE] = ACTIONS(677),
    [anon_sym_PERCENT] = ACTIONS(679),
    [anon_sym_DASHand] = ACTIONS(677),
    [anon_sym_DASHor] = ACTIONS(677),
    [anon_sym_DASHxor] = ACTIONS(677),
    [anon_sym_DASHband] = ACTIONS(677),
    [anon_sym_DASHbor] = ACTIONS(677),
    [anon_sym_DASHbxor] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(679),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_SLASH] = ACTIONS(679),
    [anon_sym_BSLASH] = ACTIONS(677),
    [anon_sym_STAR] = ACTIONS(679),
    [anon_sym_DOT_DOT] = ACTIONS(677),
    [anon_sym_PLUS_PLUS] = ACTIONS(677),
    [anon_sym_DASH_DASH] = ACTIONS(677),
    [anon_sym_DOT2] = ACTIONS(679),
    [anon_sym_COLON_COLON] = ACTIONS(677),
    [anon_sym_DOTforeach] = ACTIONS(677),
    [sym__statement_terminator] = ACTIONS(677),
  },
  [152] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(661),
    [anon_sym_EQ] = ACTIONS(661),
    [anon_sym_BANG_EQ] = ACTIONS(661),
    [anon_sym_PLUS_EQ] = ACTIONS(661),
    [anon_sym_STAR_EQ] = ACTIONS(661),
    [anon_sym_SLASH_EQ] = ACTIONS(661),
    [anon_sym_PERCENT_EQ] = ACTIONS(661),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_GT] = ACTIONS(661),
    [anon_sym_2_GT] = ACTIONS(663),
    [anon_sym_2_GT_GT] = ACTIONS(661),
    [anon_sym_3_GT] = ACTIONS(663),
    [anon_sym_3_GT_GT] = ACTIONS(661),
    [anon_sym_4_GT] = ACTIONS(663),
    [anon_sym_4_GT_GT] = ACTIONS(661),
    [anon_sym_5_GT] = ACTIONS(663),
    [anon_sym_5_GT_GT] = ACTIONS(661),
    [anon_sym_6_GT] = ACTIONS(663),
    [anon_sym_6_GT_GT] = ACTIONS(661),
    [anon_sym_STAR_GT] = ACTIONS(663),
    [anon_sym_STAR_GT_GT] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(661),
    [anon_sym_2_GT_AMP1] = ACTIONS(661),
    [anon_sym_3_GT_AMP1] = ACTIONS(661),
    [anon_sym_4_GT_AMP1] = ACTIONS(661),
    [anon_sym_5_GT_AMP1] = ACTIONS(661),
    [anon_sym_6_GT_AMP1] = ACTIONS(661),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(661),
    [anon_sym_1_GT_AMP2] = ACTIONS(661),
    [anon_sym_3_GT_AMP2] = ACTIONS(661),
    [anon_sym_4_GT_AMP2] = ACTIONS(661),
    [anon_sym_5_GT_AMP2] = ACTIONS(661),
    [anon_sym_6_GT_AMP2] = ACTIONS(661),
    [anon_sym_DASHas] = ACTIONS(661),
    [anon_sym_DASHccontains] = ACTIONS(661),
    [anon_sym_DASHceq] = ACTIONS(661),
    [anon_sym_DASHcge] = ACTIONS(661),
    [anon_sym_DASHcgt] = ACTIONS(661),
    [anon_sym_DASHcle] = ACTIONS(661),
    [anon_sym_DASHclike] = ACTIONS(661),
    [anon_sym_DASHclt] = ACTIONS(661),
    [anon_sym_DASHcmatch] = ACTIONS(661),
    [anon_sym_DASHcne] = ACTIONS(661),
    [anon_sym_DASHcnotcontains] = ACTIONS(661),
    [anon_sym_DASHcnotlike] = ACTIONS(661),
    [anon_sym_DASHcnotmatch] = ACTIONS(661),
    [anon_sym_DASHcontains] = ACTIONS(661),
    [anon_sym_DASHcreplace] = ACTIONS(661),
    [anon_sym_DASHcsplit] = ACTIONS(661),
    [anon_sym_DASHeq] = ACTIONS(661),
    [anon_sym_DASHge] = ACTIONS(661),
    [anon_sym_DASHgt] = ACTIONS(661),
    [anon_sym_DASHicontains] = ACTIONS(661),
    [anon_sym_DASHieq] = ACTIONS(661),
    [anon_sym_DASHige] = ACTIONS(661),
    [anon_sym_DASHigt] = ACTIONS(661),
    [anon_sym_DASHile] = ACTIONS(661),
    [anon_sym_DASHilike] = ACTIONS(661),
    [anon_sym_DASHilt] = ACTIONS(661),
    [anon_sym_DASHimatch] = ACTIONS(661),
    [anon_sym_DASHin] = ACTIONS(663),
    [anon_sym_DASHine] = ACTIONS(661),
    [anon_sym_DASHinotcontains] = ACTIONS(661),
    [anon_sym_DASHinotlike] = ACTIONS(661),
    [anon_sym_DASHinotmatch] = ACTIONS(661),
    [anon_sym_DASHireplace] = ACTIONS(661),
    [anon_sym_DASHis] = ACTIONS(663),
    [anon_sym_DASHisnot] = ACTIONS(661),
    [anon_sym_DASHisplit] = ACTIONS(661),
    [anon_sym_DASHjoin] = ACTIONS(661),
    [anon_sym_DASHle] = ACTIONS(661),
    [anon_sym_DASHlike] = ACTIONS(661),
    [anon_sym_DASHlt] = ACTIONS(661),
    [anon_sym_DASHmatch] = ACTIONS(661),
    [anon_sym_DASHne] = ACTIONS(661),
    [anon_sym_DASHnotcontains] = ACTIONS(661),
    [anon_sym_DASHnotin] = ACTIONS(661),
    [anon_sym_DASHnotlike] = ACTIONS(661),
    [anon_sym_DASHnotmatch] = ACTIONS(661),
    [anon_sym_DASHreplace] = ACTIONS(661),
    [anon_sym_DASHshl] = ACTIONS(661),
    [anon_sym_DASHshr] = ACTIONS(661),
    [anon_sym_DASHsplit] = ACTIONS(661),
    [sym_format_operator] = ACTIONS(661),
    [anon_sym_LPAREN] = ACTIONS(661),
    [anon_sym_COMMA] = ACTIONS(661),
    [anon_sym_PIPE] = ACTIONS(661),
    [anon_sym_PERCENT] = ACTIONS(663),
    [anon_sym_DASHand] = ACTIONS(661),
    [anon_sym_DASHor] = ACTIONS(661),
    [anon_sym_DASHxor] = ACTIONS(661),
    [anon_sym_DASHband] = ACTIONS(661),
    [anon_sym_DASHbor] = ACTIONS(661),
    [anon_sym_DASHbxor] = ACTIONS(661),
    [anon_sym_PLUS] = ACTIONS(663),
    [anon_sym_DASH] = ACTIONS(663),
    [anon_sym_SLASH] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(661),
    [anon_sym_STAR] = ACTIONS(663),
    [anon_sym_DOT_DOT] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_DOT2] = ACTIONS(663),
    [anon_sym_COLON_COLON] = ACTIONS(661),
    [anon_sym_DOTforeach] = ACTIONS(661),
    [sym__statement_terminator] = ACTIONS(661),
  },
  [153] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(697),
    [anon_sym_EQ] = ACTIONS(697),
    [anon_sym_BANG_EQ] = ACTIONS(697),
    [anon_sym_PLUS_EQ] = ACTIONS(697),
    [anon_sym_STAR_EQ] = ACTIONS(697),
    [anon_sym_SLASH_EQ] = ACTIONS(697),
    [anon_sym_PERCENT_EQ] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(699),
    [anon_sym_GT_GT] = ACTIONS(697),
    [anon_sym_2_GT] = ACTIONS(699),
    [anon_sym_2_GT_GT] = ACTIONS(697),
    [anon_sym_3_GT] = ACTIONS(699),
    [anon_sym_3_GT_GT] = ACTIONS(697),
    [anon_sym_4_GT] = ACTIONS(699),
    [anon_sym_4_GT_GT] = ACTIONS(697),
    [anon_sym_5_GT] = ACTIONS(699),
    [anon_sym_5_GT_GT] = ACTIONS(697),
    [anon_sym_6_GT] = ACTIONS(699),
    [anon_sym_6_GT_GT] = ACTIONS(697),
    [anon_sym_STAR_GT] = ACTIONS(699),
    [anon_sym_STAR_GT_GT] = ACTIONS(697),
    [anon_sym_LT] = ACTIONS(699),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(697),
    [anon_sym_2_GT_AMP1] = ACTIONS(697),
    [anon_sym_3_GT_AMP1] = ACTIONS(697),
    [anon_sym_4_GT_AMP1] = ACTIONS(697),
    [anon_sym_5_GT_AMP1] = ACTIONS(697),
    [anon_sym_6_GT_AMP1] = ACTIONS(697),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(697),
    [anon_sym_1_GT_AMP2] = ACTIONS(697),
    [anon_sym_3_GT_AMP2] = ACTIONS(697),
    [anon_sym_4_GT_AMP2] = ACTIONS(697),
    [anon_sym_5_GT_AMP2] = ACTIONS(697),
    [anon_sym_6_GT_AMP2] = ACTIONS(697),
    [anon_sym_DASHas] = ACTIONS(697),
    [anon_sym_DASHccontains] = ACTIONS(697),
    [anon_sym_DASHceq] = ACTIONS(697),
    [anon_sym_DASHcge] = ACTIONS(697),
    [anon_sym_DASHcgt] = ACTIONS(697),
    [anon_sym_DASHcle] = ACTIONS(697),
    [anon_sym_DASHclike] = ACTIONS(697),
    [anon_sym_DASHclt] = ACTIONS(697),
    [anon_sym_DASHcmatch] = ACTIONS(697),
    [anon_sym_DASHcne] = ACTIONS(697),
    [anon_sym_DASHcnotcontains] = ACTIONS(697),
    [anon_sym_DASHcnotlike] = ACTIONS(697),
    [anon_sym_DASHcnotmatch] = ACTIONS(697),
    [anon_sym_DASHcontains] = ACTIONS(697),
    [anon_sym_DASHcreplace] = ACTIONS(697),
    [anon_sym_DASHcsplit] = ACTIONS(697),
    [anon_sym_DASHeq] = ACTIONS(697),
    [anon_sym_DASHge] = ACTIONS(697),
    [anon_sym_DASHgt] = ACTIONS(697),
    [anon_sym_DASHicontains] = ACTIONS(697),
    [anon_sym_DASHieq] = ACTIONS(697),
    [anon_sym_DASHige] = ACTIONS(697),
    [anon_sym_DASHigt] = ACTIONS(697),
    [anon_sym_DASHile] = ACTIONS(697),
    [anon_sym_DASHilike] = ACTIONS(697),
    [anon_sym_DASHilt] = ACTIONS(697),
    [anon_sym_DASHimatch] = ACTIONS(697),
    [anon_sym_DASHin] = ACTIONS(699),
    [anon_sym_DASHine] = ACTIONS(697),
    [anon_sym_DASHinotcontains] = ACTIONS(697),
    [anon_sym_DASHinotlike] = ACTIONS(697),
    [anon_sym_DASHinotmatch] = ACTIONS(697),
    [anon_sym_DASHireplace] = ACTIONS(697),
    [anon_sym_DASHis] = ACTIONS(699),
    [anon_sym_DASHisnot] = ACTIONS(697),
    [anon_sym_DASHisplit] = ACTIONS(697),
    [anon_sym_DASHjoin] = ACTIONS(697),
    [anon_sym_DASHle] = ACTIONS(697),
    [anon_sym_DASHlike] = ACTIONS(697),
    [anon_sym_DASHlt] = ACTIONS(697),
    [anon_sym_DASHmatch] = ACTIONS(697),
    [anon_sym_DASHne] = ACTIONS(697),
    [anon_sym_DASHnotcontains] = ACTIONS(697),
    [anon_sym_DASHnotin] = ACTIONS(697),
    [anon_sym_DASHnotlike] = ACTIONS(697),
    [anon_sym_DASHnotmatch] = ACTIONS(697),
    [anon_sym_DASHreplace] = ACTIONS(697),
    [anon_sym_DASHshl] = ACTIONS(697),
    [anon_sym_DASHshr] = ACTIONS(697),
    [anon_sym_DASHsplit] = ACTIONS(697),
    [sym_format_operator] = ACTIONS(697),
    [anon_sym_LPAREN] = ACTIONS(697),
    [anon_sym_COMMA] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(697),
    [anon_sym_PERCENT] = ACTIONS(699),
    [anon_sym_DASHand] = ACTIONS(697),
    [anon_sym_DASHor] = ACTIONS(697),
    [anon_sym_DASHxor] = ACTIONS(697),
    [anon_sym_DASHband] = ACTIONS(697),
    [anon_sym_DASHbor] = ACTIONS(697),
    [anon_sym_DASHbxor] = ACTIONS(697),
    [anon_sym_PLUS] = ACTIONS(699),
    [anon_sym_DASH] = ACTIONS(699),
    [anon_sym_SLASH] = ACTIONS(699),
    [anon_sym_BSLASH] = ACTIONS(697),
    [anon_sym_STAR] = ACTIONS(699),
    [anon_sym_DOT_DOT] = ACTIONS(697),
    [anon_sym_PLUS_PLUS] = ACTIONS(697),
    [anon_sym_DASH_DASH] = ACTIONS(697),
    [anon_sym_DOT2] = ACTIONS(699),
    [anon_sym_COLON_COLON] = ACTIONS(697),
    [anon_sym_DOTforeach] = ACTIONS(697),
    [sym__statement_terminator] = ACTIONS(697),
  },
  [154] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(709),
    [anon_sym_EQ] = ACTIONS(709),
    [anon_sym_BANG_EQ] = ACTIONS(709),
    [anon_sym_PLUS_EQ] = ACTIONS(709),
    [anon_sym_STAR_EQ] = ACTIONS(709),
    [anon_sym_SLASH_EQ] = ACTIONS(709),
    [anon_sym_PERCENT_EQ] = ACTIONS(709),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_GT] = ACTIONS(709),
    [anon_sym_2_GT] = ACTIONS(711),
    [anon_sym_2_GT_GT] = ACTIONS(709),
    [anon_sym_3_GT] = ACTIONS(711),
    [anon_sym_3_GT_GT] = ACTIONS(709),
    [anon_sym_4_GT] = ACTIONS(711),
    [anon_sym_4_GT_GT] = ACTIONS(709),
    [anon_sym_5_GT] = ACTIONS(711),
    [anon_sym_5_GT_GT] = ACTIONS(709),
    [anon_sym_6_GT] = ACTIONS(711),
    [anon_sym_6_GT_GT] = ACTIONS(709),
    [anon_sym_STAR_GT] = ACTIONS(711),
    [anon_sym_STAR_GT_GT] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(709),
    [anon_sym_2_GT_AMP1] = ACTIONS(709),
    [anon_sym_3_GT_AMP1] = ACTIONS(709),
    [anon_sym_4_GT_AMP1] = ACTIONS(709),
    [anon_sym_5_GT_AMP1] = ACTIONS(709),
    [anon_sym_6_GT_AMP1] = ACTIONS(709),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(709),
    [anon_sym_1_GT_AMP2] = ACTIONS(709),
    [anon_sym_3_GT_AMP2] = ACTIONS(709),
    [anon_sym_4_GT_AMP2] = ACTIONS(709),
    [anon_sym_5_GT_AMP2] = ACTIONS(709),
    [anon_sym_6_GT_AMP2] = ACTIONS(709),
    [anon_sym_DASHas] = ACTIONS(709),
    [anon_sym_DASHccontains] = ACTIONS(709),
    [anon_sym_DASHceq] = ACTIONS(709),
    [anon_sym_DASHcge] = ACTIONS(709),
    [anon_sym_DASHcgt] = ACTIONS(709),
    [anon_sym_DASHcle] = ACTIONS(709),
    [anon_sym_DASHclike] = ACTIONS(709),
    [anon_sym_DASHclt] = ACTIONS(709),
    [anon_sym_DASHcmatch] = ACTIONS(709),
    [anon_sym_DASHcne] = ACTIONS(709),
    [anon_sym_DASHcnotcontains] = ACTIONS(709),
    [anon_sym_DASHcnotlike] = ACTIONS(709),
    [anon_sym_DASHcnotmatch] = ACTIONS(709),
    [anon_sym_DASHcontains] = ACTIONS(709),
    [anon_sym_DASHcreplace] = ACTIONS(709),
    [anon_sym_DASHcsplit] = ACTIONS(709),
    [anon_sym_DASHeq] = ACTIONS(709),
    [anon_sym_DASHge] = ACTIONS(709),
    [anon_sym_DASHgt] = ACTIONS(709),
    [anon_sym_DASHicontains] = ACTIONS(709),
    [anon_sym_DASHieq] = ACTIONS(709),
    [anon_sym_DASHige] = ACTIONS(709),
    [anon_sym_DASHigt] = ACTIONS(709),
    [anon_sym_DASHile] = ACTIONS(709),
    [anon_sym_DASHilike] = ACTIONS(709),
    [anon_sym_DASHilt] = ACTIONS(709),
    [anon_sym_DASHimatch] = ACTIONS(709),
    [anon_sym_DASHin] = ACTIONS(711),
    [anon_sym_DASHine] = ACTIONS(709),
    [anon_sym_DASHinotcontains] = ACTIONS(709),
    [anon_sym_DASHinotlike] = ACTIONS(709),
    [anon_sym_DASHinotmatch] = ACTIONS(709),
    [anon_sym_DASHireplace] = ACTIONS(709),
    [anon_sym_DASHis] = ACTIONS(711),
    [anon_sym_DASHisnot] = ACTIONS(709),
    [anon_sym_DASHisplit] = ACTIONS(709),
    [anon_sym_DASHjoin] = ACTIONS(709),
    [anon_sym_DASHle] = ACTIONS(709),
    [anon_sym_DASHlike] = ACTIONS(709),
    [anon_sym_DASHlt] = ACTIONS(709),
    [anon_sym_DASHmatch] = ACTIONS(709),
    [anon_sym_DASHne] = ACTIONS(709),
    [anon_sym_DASHnotcontains] = ACTIONS(709),
    [anon_sym_DASHnotin] = ACTIONS(709),
    [anon_sym_DASHnotlike] = ACTIONS(709),
    [anon_sym_DASHnotmatch] = ACTIONS(709),
    [anon_sym_DASHreplace] = ACTIONS(709),
    [anon_sym_DASHshl] = ACTIONS(709),
    [anon_sym_DASHshr] = ACTIONS(709),
    [anon_sym_DASHsplit] = ACTIONS(709),
    [sym_format_operator] = ACTIONS(709),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_COMMA] = ACTIONS(709),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_PERCENT] = ACTIONS(711),
    [anon_sym_DASHand] = ACTIONS(709),
    [anon_sym_DASHor] = ACTIONS(709),
    [anon_sym_DASHxor] = ACTIONS(709),
    [anon_sym_DASHband] = ACTIONS(709),
    [anon_sym_DASHbor] = ACTIONS(709),
    [anon_sym_DASHbxor] = ACTIONS(709),
    [anon_sym_PLUS] = ACTIONS(711),
    [anon_sym_DASH] = ACTIONS(711),
    [anon_sym_SLASH] = ACTIONS(711),
    [anon_sym_BSLASH] = ACTIONS(709),
    [anon_sym_STAR] = ACTIONS(711),
    [anon_sym_DOT_DOT] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(709),
    [anon_sym_DASH_DASH] = ACTIONS(709),
    [anon_sym_DOT2] = ACTIONS(711),
    [anon_sym_COLON_COLON] = ACTIONS(709),
    [anon_sym_DOTforeach] = ACTIONS(709),
    [sym__statement_terminator] = ACTIONS(709),
  },
  [155] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_PLUS_EQ] = ACTIONS(713),
    [anon_sym_STAR_EQ] = ACTIONS(713),
    [anon_sym_SLASH_EQ] = ACTIONS(713),
    [anon_sym_PERCENT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(713),
    [anon_sym_2_GT] = ACTIONS(715),
    [anon_sym_2_GT_GT] = ACTIONS(713),
    [anon_sym_3_GT] = ACTIONS(715),
    [anon_sym_3_GT_GT] = ACTIONS(713),
    [anon_sym_4_GT] = ACTIONS(715),
    [anon_sym_4_GT_GT] = ACTIONS(713),
    [anon_sym_5_GT] = ACTIONS(715),
    [anon_sym_5_GT_GT] = ACTIONS(713),
    [anon_sym_6_GT] = ACTIONS(715),
    [anon_sym_6_GT_GT] = ACTIONS(713),
    [anon_sym_STAR_GT] = ACTIONS(715),
    [anon_sym_STAR_GT_GT] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(713),
    [anon_sym_2_GT_AMP1] = ACTIONS(713),
    [anon_sym_3_GT_AMP1] = ACTIONS(713),
    [anon_sym_4_GT_AMP1] = ACTIONS(713),
    [anon_sym_5_GT_AMP1] = ACTIONS(713),
    [anon_sym_6_GT_AMP1] = ACTIONS(713),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(713),
    [anon_sym_1_GT_AMP2] = ACTIONS(713),
    [anon_sym_3_GT_AMP2] = ACTIONS(713),
    [anon_sym_4_GT_AMP2] = ACTIONS(713),
    [anon_sym_5_GT_AMP2] = ACTIONS(713),
    [anon_sym_6_GT_AMP2] = ACTIONS(713),
    [anon_sym_DASHas] = ACTIONS(713),
    [anon_sym_DASHccontains] = ACTIONS(713),
    [anon_sym_DASHceq] = ACTIONS(713),
    [anon_sym_DASHcge] = ACTIONS(713),
    [anon_sym_DASHcgt] = ACTIONS(713),
    [anon_sym_DASHcle] = ACTIONS(713),
    [anon_sym_DASHclike] = ACTIONS(713),
    [anon_sym_DASHclt] = ACTIONS(713),
    [anon_sym_DASHcmatch] = ACTIONS(713),
    [anon_sym_DASHcne] = ACTIONS(713),
    [anon_sym_DASHcnotcontains] = ACTIONS(713),
    [anon_sym_DASHcnotlike] = ACTIONS(713),
    [anon_sym_DASHcnotmatch] = ACTIONS(713),
    [anon_sym_DASHcontains] = ACTIONS(713),
    [anon_sym_DASHcreplace] = ACTIONS(713),
    [anon_sym_DASHcsplit] = ACTIONS(713),
    [anon_sym_DASHeq] = ACTIONS(713),
    [anon_sym_DASHge] = ACTIONS(713),
    [anon_sym_DASHgt] = ACTIONS(713),
    [anon_sym_DASHicontains] = ACTIONS(713),
    [anon_sym_DASHieq] = ACTIONS(713),
    [anon_sym_DASHige] = ACTIONS(713),
    [anon_sym_DASHigt] = ACTIONS(713),
    [anon_sym_DASHile] = ACTIONS(713),
    [anon_sym_DASHilike] = ACTIONS(713),
    [anon_sym_DASHilt] = ACTIONS(713),
    [anon_sym_DASHimatch] = ACTIONS(713),
    [anon_sym_DASHin] = ACTIONS(715),
    [anon_sym_DASHine] = ACTIONS(713),
    [anon_sym_DASHinotcontains] = ACTIONS(713),
    [anon_sym_DASHinotlike] = ACTIONS(713),
    [anon_sym_DASHinotmatch] = ACTIONS(713),
    [anon_sym_DASHireplace] = ACTIONS(713),
    [anon_sym_DASHis] = ACTIONS(715),
    [anon_sym_DASHisnot] = ACTIONS(713),
    [anon_sym_DASHisplit] = ACTIONS(713),
    [anon_sym_DASHjoin] = ACTIONS(713),
    [anon_sym_DASHle] = ACTIONS(713),
    [anon_sym_DASHlike] = ACTIONS(713),
    [anon_sym_DASHlt] = ACTIONS(713),
    [anon_sym_DASHmatch] = ACTIONS(713),
    [anon_sym_DASHne] = ACTIONS(713),
    [anon_sym_DASHnotcontains] = ACTIONS(713),
    [anon_sym_DASHnotin] = ACTIONS(713),
    [anon_sym_DASHnotlike] = ACTIONS(713),
    [anon_sym_DASHnotmatch] = ACTIONS(713),
    [anon_sym_DASHreplace] = ACTIONS(713),
    [anon_sym_DASHshl] = ACTIONS(713),
    [anon_sym_DASHshr] = ACTIONS(713),
    [anon_sym_DASHsplit] = ACTIONS(713),
    [sym_format_operator] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(713),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_DASHand] = ACTIONS(713),
    [anon_sym_DASHor] = ACTIONS(713),
    [anon_sym_DASHxor] = ACTIONS(713),
    [anon_sym_DASHband] = ACTIONS(713),
    [anon_sym_DASHbor] = ACTIONS(713),
    [anon_sym_DASHbxor] = ACTIONS(713),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_BSLASH] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_DOT_DOT] = ACTIONS(713),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DOT2] = ACTIONS(757),
    [anon_sym_COLON_COLON] = ACTIONS(759),
    [anon_sym_DOTforeach] = ACTIONS(743),
  },
  [156] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_PLUS_EQ] = ACTIONS(713),
    [anon_sym_STAR_EQ] = ACTIONS(713),
    [anon_sym_SLASH_EQ] = ACTIONS(713),
    [anon_sym_PERCENT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(713),
    [anon_sym_2_GT] = ACTIONS(715),
    [anon_sym_2_GT_GT] = ACTIONS(713),
    [anon_sym_3_GT] = ACTIONS(715),
    [anon_sym_3_GT_GT] = ACTIONS(713),
    [anon_sym_4_GT] = ACTIONS(715),
    [anon_sym_4_GT_GT] = ACTIONS(713),
    [anon_sym_5_GT] = ACTIONS(715),
    [anon_sym_5_GT_GT] = ACTIONS(713),
    [anon_sym_6_GT] = ACTIONS(715),
    [anon_sym_6_GT_GT] = ACTIONS(713),
    [anon_sym_STAR_GT] = ACTIONS(715),
    [anon_sym_STAR_GT_GT] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(713),
    [anon_sym_2_GT_AMP1] = ACTIONS(713),
    [anon_sym_3_GT_AMP1] = ACTIONS(713),
    [anon_sym_4_GT_AMP1] = ACTIONS(713),
    [anon_sym_5_GT_AMP1] = ACTIONS(713),
    [anon_sym_6_GT_AMP1] = ACTIONS(713),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(713),
    [anon_sym_1_GT_AMP2] = ACTIONS(713),
    [anon_sym_3_GT_AMP2] = ACTIONS(713),
    [anon_sym_4_GT_AMP2] = ACTIONS(713),
    [anon_sym_5_GT_AMP2] = ACTIONS(713),
    [anon_sym_6_GT_AMP2] = ACTIONS(713),
    [anon_sym_DASHas] = ACTIONS(713),
    [anon_sym_DASHccontains] = ACTIONS(713),
    [anon_sym_DASHceq] = ACTIONS(713),
    [anon_sym_DASHcge] = ACTIONS(713),
    [anon_sym_DASHcgt] = ACTIONS(713),
    [anon_sym_DASHcle] = ACTIONS(713),
    [anon_sym_DASHclike] = ACTIONS(713),
    [anon_sym_DASHclt] = ACTIONS(713),
    [anon_sym_DASHcmatch] = ACTIONS(713),
    [anon_sym_DASHcne] = ACTIONS(713),
    [anon_sym_DASHcnotcontains] = ACTIONS(713),
    [anon_sym_DASHcnotlike] = ACTIONS(713),
    [anon_sym_DASHcnotmatch] = ACTIONS(713),
    [anon_sym_DASHcontains] = ACTIONS(713),
    [anon_sym_DASHcreplace] = ACTIONS(713),
    [anon_sym_DASHcsplit] = ACTIONS(713),
    [anon_sym_DASHeq] = ACTIONS(713),
    [anon_sym_DASHge] = ACTIONS(713),
    [anon_sym_DASHgt] = ACTIONS(713),
    [anon_sym_DASHicontains] = ACTIONS(713),
    [anon_sym_DASHieq] = ACTIONS(713),
    [anon_sym_DASHige] = ACTIONS(713),
    [anon_sym_DASHigt] = ACTIONS(713),
    [anon_sym_DASHile] = ACTIONS(713),
    [anon_sym_DASHilike] = ACTIONS(713),
    [anon_sym_DASHilt] = ACTIONS(713),
    [anon_sym_DASHimatch] = ACTIONS(713),
    [anon_sym_DASHin] = ACTIONS(715),
    [anon_sym_DASHine] = ACTIONS(713),
    [anon_sym_DASHinotcontains] = ACTIONS(713),
    [anon_sym_DASHinotlike] = ACTIONS(713),
    [anon_sym_DASHinotmatch] = ACTIONS(713),
    [anon_sym_DASHireplace] = ACTIONS(713),
    [anon_sym_DASHis] = ACTIONS(715),
    [anon_sym_DASHisnot] = ACTIONS(713),
    [anon_sym_DASHisplit] = ACTIONS(713),
    [anon_sym_DASHjoin] = ACTIONS(713),
    [anon_sym_DASHle] = ACTIONS(713),
    [anon_sym_DASHlike] = ACTIONS(713),
    [anon_sym_DASHlt] = ACTIONS(713),
    [anon_sym_DASHmatch] = ACTIONS(713),
    [anon_sym_DASHne] = ACTIONS(713),
    [anon_sym_DASHnotcontains] = ACTIONS(713),
    [anon_sym_DASHnotin] = ACTIONS(713),
    [anon_sym_DASHnotlike] = ACTIONS(713),
    [anon_sym_DASHnotmatch] = ACTIONS(713),
    [anon_sym_DASHreplace] = ACTIONS(713),
    [anon_sym_DASHshl] = ACTIONS(713),
    [anon_sym_DASHshr] = ACTIONS(713),
    [anon_sym_DASHsplit] = ACTIONS(713),
    [sym_format_operator] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(713),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_DASHand] = ACTIONS(713),
    [anon_sym_DASHor] = ACTIONS(713),
    [anon_sym_DASHxor] = ACTIONS(713),
    [anon_sym_DASHband] = ACTIONS(713),
    [anon_sym_DASHbor] = ACTIONS(713),
    [anon_sym_DASHbxor] = ACTIONS(713),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_BSLASH] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_DOT_DOT] = ACTIONS(713),
    [anon_sym_PLUS_PLUS] = ACTIONS(747),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_DOT2] = ACTIONS(761),
    [anon_sym_COLON_COLON] = ACTIONS(763),
    [anon_sym_DOTforeach] = ACTIONS(755),
    [sym__statement_terminator] = ACTIONS(713),
  },
  [157] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(721),
    [anon_sym_BANG_EQ] = ACTIONS(721),
    [anon_sym_PLUS_EQ] = ACTIONS(721),
    [anon_sym_STAR_EQ] = ACTIONS(721),
    [anon_sym_SLASH_EQ] = ACTIONS(721),
    [anon_sym_PERCENT_EQ] = ACTIONS(721),
    [anon_sym_GT] = ACTIONS(723),
    [anon_sym_GT_GT] = ACTIONS(721),
    [anon_sym_2_GT] = ACTIONS(723),
    [anon_sym_2_GT_GT] = ACTIONS(721),
    [anon_sym_3_GT] = ACTIONS(723),
    [anon_sym_3_GT_GT] = ACTIONS(721),
    [anon_sym_4_GT] = ACTIONS(723),
    [anon_sym_4_GT_GT] = ACTIONS(721),
    [anon_sym_5_GT] = ACTIONS(723),
    [anon_sym_5_GT_GT] = ACTIONS(721),
    [anon_sym_6_GT] = ACTIONS(723),
    [anon_sym_6_GT_GT] = ACTIONS(721),
    [anon_sym_STAR_GT] = ACTIONS(723),
    [anon_sym_STAR_GT_GT] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(721),
    [anon_sym_2_GT_AMP1] = ACTIONS(721),
    [anon_sym_3_GT_AMP1] = ACTIONS(721),
    [anon_sym_4_GT_AMP1] = ACTIONS(721),
    [anon_sym_5_GT_AMP1] = ACTIONS(721),
    [anon_sym_6_GT_AMP1] = ACTIONS(721),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(721),
    [anon_sym_1_GT_AMP2] = ACTIONS(721),
    [anon_sym_3_GT_AMP2] = ACTIONS(721),
    [anon_sym_4_GT_AMP2] = ACTIONS(721),
    [anon_sym_5_GT_AMP2] = ACTIONS(721),
    [anon_sym_6_GT_AMP2] = ACTIONS(721),
    [anon_sym_DASHas] = ACTIONS(721),
    [anon_sym_DASHccontains] = ACTIONS(721),
    [anon_sym_DASHceq] = ACTIONS(721),
    [anon_sym_DASHcge] = ACTIONS(721),
    [anon_sym_DASHcgt] = ACTIONS(721),
    [anon_sym_DASHcle] = ACTIONS(721),
    [anon_sym_DASHclike] = ACTIONS(721),
    [anon_sym_DASHclt] = ACTIONS(721),
    [anon_sym_DASHcmatch] = ACTIONS(721),
    [anon_sym_DASHcne] = ACTIONS(721),
    [anon_sym_DASHcnotcontains] = ACTIONS(721),
    [anon_sym_DASHcnotlike] = ACTIONS(721),
    [anon_sym_DASHcnotmatch] = ACTIONS(721),
    [anon_sym_DASHcontains] = ACTIONS(721),
    [anon_sym_DASHcreplace] = ACTIONS(721),
    [anon_sym_DASHcsplit] = ACTIONS(721),
    [anon_sym_DASHeq] = ACTIONS(721),
    [anon_sym_DASHge] = ACTIONS(721),
    [anon_sym_DASHgt] = ACTIONS(721),
    [anon_sym_DASHicontains] = ACTIONS(721),
    [anon_sym_DASHieq] = ACTIONS(721),
    [anon_sym_DASHige] = ACTIONS(721),
    [anon_sym_DASHigt] = ACTIONS(721),
    [anon_sym_DASHile] = ACTIONS(721),
    [anon_sym_DASHilike] = ACTIONS(721),
    [anon_sym_DASHilt] = ACTIONS(721),
    [anon_sym_DASHimatch] = ACTIONS(721),
    [anon_sym_DASHin] = ACTIONS(723),
    [anon_sym_DASHine] = ACTIONS(721),
    [anon_sym_DASHinotcontains] = ACTIONS(721),
    [anon_sym_DASHinotlike] = ACTIONS(721),
    [anon_sym_DASHinotmatch] = ACTIONS(721),
    [anon_sym_DASHireplace] = ACTIONS(721),
    [anon_sym_DASHis] = ACTIONS(723),
    [anon_sym_DASHisnot] = ACTIONS(721),
    [anon_sym_DASHisplit] = ACTIONS(721),
    [anon_sym_DASHjoin] = ACTIONS(721),
    [anon_sym_DASHle] = ACTIONS(721),
    [anon_sym_DASHlike] = ACTIONS(721),
    [anon_sym_DASHlt] = ACTIONS(721),
    [anon_sym_DASHmatch] = ACTIONS(721),
    [anon_sym_DASHne] = ACTIONS(721),
    [anon_sym_DASHnotcontains] = ACTIONS(721),
    [anon_sym_DASHnotin] = ACTIONS(721),
    [anon_sym_DASHnotlike] = ACTIONS(721),
    [anon_sym_DASHnotmatch] = ACTIONS(721),
    [anon_sym_DASHreplace] = ACTIONS(721),
    [anon_sym_DASHshl] = ACTIONS(721),
    [anon_sym_DASHshr] = ACTIONS(721),
    [anon_sym_DASHsplit] = ACTIONS(721),
    [sym_format_operator] = ACTIONS(721),
    [anon_sym_RPAREN] = ACTIONS(721),
    [anon_sym_COMMA] = ACTIONS(721),
    [anon_sym_PIPE] = ACTIONS(721),
    [anon_sym_PERCENT] = ACTIONS(723),
    [anon_sym_DASHand] = ACTIONS(721),
    [anon_sym_DASHor] = ACTIONS(721),
    [anon_sym_DASHxor] = ACTIONS(721),
    [anon_sym_DASHband] = ACTIONS(721),
    [anon_sym_DASHbor] = ACTIONS(721),
    [anon_sym_DASHbxor] = ACTIONS(721),
    [anon_sym_PLUS] = ACTIONS(723),
    [anon_sym_DASH] = ACTIONS(723),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_BSLASH] = ACTIONS(721),
    [anon_sym_STAR] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(721),
    [anon_sym_RBRACK] = ACTIONS(721),
  },
  [158] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(617),
    [anon_sym_BANG_EQ] = ACTIONS(617),
    [anon_sym_PLUS_EQ] = ACTIONS(617),
    [anon_sym_STAR_EQ] = ACTIONS(617),
    [anon_sym_SLASH_EQ] = ACTIONS(617),
    [anon_sym_PERCENT_EQ] = ACTIONS(617),
    [anon_sym_GT] = ACTIONS(619),
    [anon_sym_GT_GT] = ACTIONS(617),
    [anon_sym_2_GT] = ACTIONS(619),
    [anon_sym_2_GT_GT] = ACTIONS(617),
    [anon_sym_3_GT] = ACTIONS(619),
    [anon_sym_3_GT_GT] = ACTIONS(617),
    [anon_sym_4_GT] = ACTIONS(619),
    [anon_sym_4_GT_GT] = ACTIONS(617),
    [anon_sym_5_GT] = ACTIONS(619),
    [anon_sym_5_GT_GT] = ACTIONS(617),
    [anon_sym_6_GT] = ACTIONS(619),
    [anon_sym_6_GT_GT] = ACTIONS(617),
    [anon_sym_STAR_GT] = ACTIONS(619),
    [anon_sym_STAR_GT_GT] = ACTIONS(617),
    [anon_sym_LT] = ACTIONS(619),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(617),
    [anon_sym_2_GT_AMP1] = ACTIONS(617),
    [anon_sym_3_GT_AMP1] = ACTIONS(617),
    [anon_sym_4_GT_AMP1] = ACTIONS(617),
    [anon_sym_5_GT_AMP1] = ACTIONS(617),
    [anon_sym_6_GT_AMP1] = ACTIONS(617),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(617),
    [anon_sym_1_GT_AMP2] = ACTIONS(617),
    [anon_sym_3_GT_AMP2] = ACTIONS(617),
    [anon_sym_4_GT_AMP2] = ACTIONS(617),
    [anon_sym_5_GT_AMP2] = ACTIONS(617),
    [anon_sym_6_GT_AMP2] = ACTIONS(617),
    [anon_sym_DASHas] = ACTIONS(617),
    [anon_sym_DASHccontains] = ACTIONS(617),
    [anon_sym_DASHceq] = ACTIONS(617),
    [anon_sym_DASHcge] = ACTIONS(617),
    [anon_sym_DASHcgt] = ACTIONS(617),
    [anon_sym_DASHcle] = ACTIONS(617),
    [anon_sym_DASHclike] = ACTIONS(617),
    [anon_sym_DASHclt] = ACTIONS(617),
    [anon_sym_DASHcmatch] = ACTIONS(617),
    [anon_sym_DASHcne] = ACTIONS(617),
    [anon_sym_DASHcnotcontains] = ACTIONS(617),
    [anon_sym_DASHcnotlike] = ACTIONS(617),
    [anon_sym_DASHcnotmatch] = ACTIONS(617),
    [anon_sym_DASHcontains] = ACTIONS(617),
    [anon_sym_DASHcreplace] = ACTIONS(617),
    [anon_sym_DASHcsplit] = ACTIONS(617),
    [anon_sym_DASHeq] = ACTIONS(617),
    [anon_sym_DASHge] = ACTIONS(617),
    [anon_sym_DASHgt] = ACTIONS(617),
    [anon_sym_DASHicontains] = ACTIONS(617),
    [anon_sym_DASHieq] = ACTIONS(617),
    [anon_sym_DASHige] = ACTIONS(617),
    [anon_sym_DASHigt] = ACTIONS(617),
    [anon_sym_DASHile] = ACTIONS(617),
    [anon_sym_DASHilike] = ACTIONS(617),
    [anon_sym_DASHilt] = ACTIONS(617),
    [anon_sym_DASHimatch] = ACTIONS(617),
    [anon_sym_DASHin] = ACTIONS(619),
    [anon_sym_DASHine] = ACTIONS(617),
    [anon_sym_DASHinotcontains] = ACTIONS(617),
    [anon_sym_DASHinotlike] = ACTIONS(617),
    [anon_sym_DASHinotmatch] = ACTIONS(617),
    [anon_sym_DASHireplace] = ACTIONS(617),
    [anon_sym_DASHis] = ACTIONS(619),
    [anon_sym_DASHisnot] = ACTIONS(617),
    [anon_sym_DASHisplit] = ACTIONS(617),
    [anon_sym_DASHjoin] = ACTIONS(617),
    [anon_sym_DASHle] = ACTIONS(617),
    [anon_sym_DASHlike] = ACTIONS(617),
    [anon_sym_DASHlt] = ACTIONS(617),
    [anon_sym_DASHmatch] = ACTIONS(617),
    [anon_sym_DASHne] = ACTIONS(617),
    [anon_sym_DASHnotcontains] = ACTIONS(617),
    [anon_sym_DASHnotin] = ACTIONS(617),
    [anon_sym_DASHnotlike] = ACTIONS(617),
    [anon_sym_DASHnotmatch] = ACTIONS(617),
    [anon_sym_DASHreplace] = ACTIONS(617),
    [anon_sym_DASHshl] = ACTIONS(617),
    [anon_sym_DASHshr] = ACTIONS(617),
    [anon_sym_DASHsplit] = ACTIONS(617),
    [sym_format_operator] = ACTIONS(617),
    [anon_sym_RPAREN] = ACTIONS(617),
    [anon_sym_COMMA] = ACTIONS(617),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_DASHand] = ACTIONS(617),
    [anon_sym_DASHor] = ACTIONS(617),
    [anon_sym_DASHxor] = ACTIONS(617),
    [anon_sym_DASHband] = ACTIONS(617),
    [anon_sym_DASHbor] = ACTIONS(617),
    [anon_sym_DASHbxor] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_BSLASH] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_DOT_DOT] = ACTIONS(617),
    [anon_sym_RBRACK] = ACTIONS(617),
  },
  [159] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(729),
    [anon_sym_BANG_EQ] = ACTIONS(729),
    [anon_sym_PLUS_EQ] = ACTIONS(729),
    [anon_sym_STAR_EQ] = ACTIONS(729),
    [anon_sym_SLASH_EQ] = ACTIONS(729),
    [anon_sym_PERCENT_EQ] = ACTIONS(729),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(729),
    [anon_sym_2_GT] = ACTIONS(731),
    [anon_sym_2_GT_GT] = ACTIONS(729),
    [anon_sym_3_GT] = ACTIONS(731),
    [anon_sym_3_GT_GT] = ACTIONS(729),
    [anon_sym_4_GT] = ACTIONS(731),
    [anon_sym_4_GT_GT] = ACTIONS(729),
    [anon_sym_5_GT] = ACTIONS(731),
    [anon_sym_5_GT_GT] = ACTIONS(729),
    [anon_sym_6_GT] = ACTIONS(731),
    [anon_sym_6_GT_GT] = ACTIONS(729),
    [anon_sym_STAR_GT] = ACTIONS(731),
    [anon_sym_STAR_GT_GT] = ACTIONS(729),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(729),
    [anon_sym_2_GT_AMP1] = ACTIONS(729),
    [anon_sym_3_GT_AMP1] = ACTIONS(729),
    [anon_sym_4_GT_AMP1] = ACTIONS(729),
    [anon_sym_5_GT_AMP1] = ACTIONS(729),
    [anon_sym_6_GT_AMP1] = ACTIONS(729),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(729),
    [anon_sym_1_GT_AMP2] = ACTIONS(729),
    [anon_sym_3_GT_AMP2] = ACTIONS(729),
    [anon_sym_4_GT_AMP2] = ACTIONS(729),
    [anon_sym_5_GT_AMP2] = ACTIONS(729),
    [anon_sym_6_GT_AMP2] = ACTIONS(729),
    [anon_sym_DASHas] = ACTIONS(729),
    [anon_sym_DASHccontains] = ACTIONS(729),
    [anon_sym_DASHceq] = ACTIONS(729),
    [anon_sym_DASHcge] = ACTIONS(729),
    [anon_sym_DASHcgt] = ACTIONS(729),
    [anon_sym_DASHcle] = ACTIONS(729),
    [anon_sym_DASHclike] = ACTIONS(729),
    [anon_sym_DASHclt] = ACTIONS(729),
    [anon_sym_DASHcmatch] = ACTIONS(729),
    [anon_sym_DASHcne] = ACTIONS(729),
    [anon_sym_DASHcnotcontains] = ACTIONS(729),
    [anon_sym_DASHcnotlike] = ACTIONS(729),
    [anon_sym_DASHcnotmatch] = ACTIONS(729),
    [anon_sym_DASHcontains] = ACTIONS(729),
    [anon_sym_DASHcreplace] = ACTIONS(729),
    [anon_sym_DASHcsplit] = ACTIONS(729),
    [anon_sym_DASHeq] = ACTIONS(729),
    [anon_sym_DASHge] = ACTIONS(729),
    [anon_sym_DASHgt] = ACTIONS(729),
    [anon_sym_DASHicontains] = ACTIONS(729),
    [anon_sym_DASHieq] = ACTIONS(729),
    [anon_sym_DASHige] = ACTIONS(729),
    [anon_sym_DASHigt] = ACTIONS(729),
    [anon_sym_DASHile] = ACTIONS(729),
    [anon_sym_DASHilike] = ACTIONS(729),
    [anon_sym_DASHilt] = ACTIONS(729),
    [anon_sym_DASHimatch] = ACTIONS(729),
    [anon_sym_DASHin] = ACTIONS(731),
    [anon_sym_DASHine] = ACTIONS(729),
    [anon_sym_DASHinotcontains] = ACTIONS(729),
    [anon_sym_DASHinotlike] = ACTIONS(729),
    [anon_sym_DASHinotmatch] = ACTIONS(729),
    [anon_sym_DASHireplace] = ACTIONS(729),
    [anon_sym_DASHis] = ACTIONS(731),
    [anon_sym_DASHisnot] = ACTIONS(729),
    [anon_sym_DASHisplit] = ACTIONS(729),
    [anon_sym_DASHjoin] = ACTIONS(729),
    [anon_sym_DASHle] = ACTIONS(729),
    [anon_sym_DASHlike] = ACTIONS(729),
    [anon_sym_DASHlt] = ACTIONS(729),
    [anon_sym_DASHmatch] = ACTIONS(729),
    [anon_sym_DASHne] = ACTIONS(729),
    [anon_sym_DASHnotcontains] = ACTIONS(729),
    [anon_sym_DASHnotin] = ACTIONS(729),
    [anon_sym_DASHnotlike] = ACTIONS(729),
    [anon_sym_DASHnotmatch] = ACTIONS(729),
    [anon_sym_DASHreplace] = ACTIONS(729),
    [anon_sym_DASHshl] = ACTIONS(729),
    [anon_sym_DASHshr] = ACTIONS(729),
    [anon_sym_DASHsplit] = ACTIONS(729),
    [sym_format_operator] = ACTIONS(729),
    [anon_sym_RPAREN] = ACTIONS(729),
    [anon_sym_COMMA] = ACTIONS(729),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_DASHand] = ACTIONS(729),
    [anon_sym_DASHor] = ACTIONS(729),
    [anon_sym_DASHxor] = ACTIONS(729),
    [anon_sym_DASHband] = ACTIONS(729),
    [anon_sym_DASHbor] = ACTIONS(729),
    [anon_sym_DASHbxor] = ACTIONS(729),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(731),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_BSLASH] = ACTIONS(729),
    [anon_sym_STAR] = ACTIONS(731),
    [anon_sym_DOT_DOT] = ACTIONS(729),
    [anon_sym_RBRACK] = ACTIONS(729),
  },
  [160] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_BANG_EQ] = ACTIONS(717),
    [anon_sym_PLUS_EQ] = ACTIONS(717),
    [anon_sym_STAR_EQ] = ACTIONS(717),
    [anon_sym_SLASH_EQ] = ACTIONS(717),
    [anon_sym_PERCENT_EQ] = ACTIONS(717),
    [anon_sym_GT] = ACTIONS(719),
    [anon_sym_GT_GT] = ACTIONS(717),
    [anon_sym_2_GT] = ACTIONS(719),
    [anon_sym_2_GT_GT] = ACTIONS(717),
    [anon_sym_3_GT] = ACTIONS(719),
    [anon_sym_3_GT_GT] = ACTIONS(717),
    [anon_sym_4_GT] = ACTIONS(719),
    [anon_sym_4_GT_GT] = ACTIONS(717),
    [anon_sym_5_GT] = ACTIONS(719),
    [anon_sym_5_GT_GT] = ACTIONS(717),
    [anon_sym_6_GT] = ACTIONS(719),
    [anon_sym_6_GT_GT] = ACTIONS(717),
    [anon_sym_STAR_GT] = ACTIONS(719),
    [anon_sym_STAR_GT_GT] = ACTIONS(717),
    [anon_sym_LT] = ACTIONS(719),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(717),
    [anon_sym_2_GT_AMP1] = ACTIONS(717),
    [anon_sym_3_GT_AMP1] = ACTIONS(717),
    [anon_sym_4_GT_AMP1] = ACTIONS(717),
    [anon_sym_5_GT_AMP1] = ACTIONS(717),
    [anon_sym_6_GT_AMP1] = ACTIONS(717),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(717),
    [anon_sym_1_GT_AMP2] = ACTIONS(717),
    [anon_sym_3_GT_AMP2] = ACTIONS(717),
    [anon_sym_4_GT_AMP2] = ACTIONS(717),
    [anon_sym_5_GT_AMP2] = ACTIONS(717),
    [anon_sym_6_GT_AMP2] = ACTIONS(717),
    [anon_sym_DASHas] = ACTIONS(717),
    [anon_sym_DASHccontains] = ACTIONS(717),
    [anon_sym_DASHceq] = ACTIONS(717),
    [anon_sym_DASHcge] = ACTIONS(717),
    [anon_sym_DASHcgt] = ACTIONS(717),
    [anon_sym_DASHcle] = ACTIONS(717),
    [anon_sym_DASHclike] = ACTIONS(717),
    [anon_sym_DASHclt] = ACTIONS(717),
    [anon_sym_DASHcmatch] = ACTIONS(717),
    [anon_sym_DASHcne] = ACTIONS(717),
    [anon_sym_DASHcnotcontains] = ACTIONS(717),
    [anon_sym_DASHcnotlike] = ACTIONS(717),
    [anon_sym_DASHcnotmatch] = ACTIONS(717),
    [anon_sym_DASHcontains] = ACTIONS(717),
    [anon_sym_DASHcreplace] = ACTIONS(717),
    [anon_sym_DASHcsplit] = ACTIONS(717),
    [anon_sym_DASHeq] = ACTIONS(717),
    [anon_sym_DASHge] = ACTIONS(717),
    [anon_sym_DASHgt] = ACTIONS(717),
    [anon_sym_DASHicontains] = ACTIONS(717),
    [anon_sym_DASHieq] = ACTIONS(717),
    [anon_sym_DASHige] = ACTIONS(717),
    [anon_sym_DASHigt] = ACTIONS(717),
    [anon_sym_DASHile] = ACTIONS(717),
    [anon_sym_DASHilike] = ACTIONS(717),
    [anon_sym_DASHilt] = ACTIONS(717),
    [anon_sym_DASHimatch] = ACTIONS(717),
    [anon_sym_DASHin] = ACTIONS(719),
    [anon_sym_DASHine] = ACTIONS(717),
    [anon_sym_DASHinotcontains] = ACTIONS(717),
    [anon_sym_DASHinotlike] = ACTIONS(717),
    [anon_sym_DASHinotmatch] = ACTIONS(717),
    [anon_sym_DASHireplace] = ACTIONS(717),
    [anon_sym_DASHis] = ACTIONS(719),
    [anon_sym_DASHisnot] = ACTIONS(717),
    [anon_sym_DASHisplit] = ACTIONS(717),
    [anon_sym_DASHjoin] = ACTIONS(717),
    [anon_sym_DASHle] = ACTIONS(717),
    [anon_sym_DASHlike] = ACTIONS(717),
    [anon_sym_DASHlt] = ACTIONS(717),
    [anon_sym_DASHmatch] = ACTIONS(717),
    [anon_sym_DASHne] = ACTIONS(717),
    [anon_sym_DASHnotcontains] = ACTIONS(717),
    [anon_sym_DASHnotin] = ACTIONS(717),
    [anon_sym_DASHnotlike] = ACTIONS(717),
    [anon_sym_DASHnotmatch] = ACTIONS(717),
    [anon_sym_DASHreplace] = ACTIONS(717),
    [anon_sym_DASHshl] = ACTIONS(717),
    [anon_sym_DASHshr] = ACTIONS(717),
    [anon_sym_DASHsplit] = ACTIONS(717),
    [sym_format_operator] = ACTIONS(717),
    [anon_sym_RPAREN] = ACTIONS(717),
    [anon_sym_COMMA] = ACTIONS(717),
    [anon_sym_PIPE] = ACTIONS(717),
    [anon_sym_PERCENT] = ACTIONS(719),
    [anon_sym_DASHand] = ACTIONS(717),
    [anon_sym_DASHor] = ACTIONS(717),
    [anon_sym_DASHxor] = ACTIONS(717),
    [anon_sym_DASHband] = ACTIONS(717),
    [anon_sym_DASHbor] = ACTIONS(717),
    [anon_sym_DASHbxor] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_SLASH] = ACTIONS(719),
    [anon_sym_BSLASH] = ACTIONS(717),
    [anon_sym_STAR] = ACTIONS(719),
    [anon_sym_DOT_DOT] = ACTIONS(717),
    [anon_sym_RBRACK] = ACTIONS(717),
  },
  [161] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_PLUS_EQ] = ACTIONS(713),
    [anon_sym_STAR_EQ] = ACTIONS(713),
    [anon_sym_SLASH_EQ] = ACTIONS(713),
    [anon_sym_PERCENT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(713),
    [anon_sym_2_GT] = ACTIONS(715),
    [anon_sym_2_GT_GT] = ACTIONS(713),
    [anon_sym_3_GT] = ACTIONS(715),
    [anon_sym_3_GT_GT] = ACTIONS(713),
    [anon_sym_4_GT] = ACTIONS(715),
    [anon_sym_4_GT_GT] = ACTIONS(713),
    [anon_sym_5_GT] = ACTIONS(715),
    [anon_sym_5_GT_GT] = ACTIONS(713),
    [anon_sym_6_GT] = ACTIONS(715),
    [anon_sym_6_GT_GT] = ACTIONS(713),
    [anon_sym_STAR_GT] = ACTIONS(715),
    [anon_sym_STAR_GT_GT] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(713),
    [anon_sym_2_GT_AMP1] = ACTIONS(713),
    [anon_sym_3_GT_AMP1] = ACTIONS(713),
    [anon_sym_4_GT_AMP1] = ACTIONS(713),
    [anon_sym_5_GT_AMP1] = ACTIONS(713),
    [anon_sym_6_GT_AMP1] = ACTIONS(713),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(713),
    [anon_sym_1_GT_AMP2] = ACTIONS(713),
    [anon_sym_3_GT_AMP2] = ACTIONS(713),
    [anon_sym_4_GT_AMP2] = ACTIONS(713),
    [anon_sym_5_GT_AMP2] = ACTIONS(713),
    [anon_sym_6_GT_AMP2] = ACTIONS(713),
    [anon_sym_DASHas] = ACTIONS(713),
    [anon_sym_DASHccontains] = ACTIONS(713),
    [anon_sym_DASHceq] = ACTIONS(713),
    [anon_sym_DASHcge] = ACTIONS(713),
    [anon_sym_DASHcgt] = ACTIONS(713),
    [anon_sym_DASHcle] = ACTIONS(713),
    [anon_sym_DASHclike] = ACTIONS(713),
    [anon_sym_DASHclt] = ACTIONS(713),
    [anon_sym_DASHcmatch] = ACTIONS(713),
    [anon_sym_DASHcne] = ACTIONS(713),
    [anon_sym_DASHcnotcontains] = ACTIONS(713),
    [anon_sym_DASHcnotlike] = ACTIONS(713),
    [anon_sym_DASHcnotmatch] = ACTIONS(713),
    [anon_sym_DASHcontains] = ACTIONS(713),
    [anon_sym_DASHcreplace] = ACTIONS(713),
    [anon_sym_DASHcsplit] = ACTIONS(713),
    [anon_sym_DASHeq] = ACTIONS(713),
    [anon_sym_DASHge] = ACTIONS(713),
    [anon_sym_DASHgt] = ACTIONS(713),
    [anon_sym_DASHicontains] = ACTIONS(713),
    [anon_sym_DASHieq] = ACTIONS(713),
    [anon_sym_DASHige] = ACTIONS(713),
    [anon_sym_DASHigt] = ACTIONS(713),
    [anon_sym_DASHile] = ACTIONS(713),
    [anon_sym_DASHilike] = ACTIONS(713),
    [anon_sym_DASHilt] = ACTIONS(713),
    [anon_sym_DASHimatch] = ACTIONS(713),
    [anon_sym_DASHin] = ACTIONS(715),
    [anon_sym_DASHine] = ACTIONS(713),
    [anon_sym_DASHinotcontains] = ACTIONS(713),
    [anon_sym_DASHinotlike] = ACTIONS(713),
    [anon_sym_DASHinotmatch] = ACTIONS(713),
    [anon_sym_DASHireplace] = ACTIONS(713),
    [anon_sym_DASHis] = ACTIONS(715),
    [anon_sym_DASHisnot] = ACTIONS(713),
    [anon_sym_DASHisplit] = ACTIONS(713),
    [anon_sym_DASHjoin] = ACTIONS(713),
    [anon_sym_DASHle] = ACTIONS(713),
    [anon_sym_DASHlike] = ACTIONS(713),
    [anon_sym_DASHlt] = ACTIONS(713),
    [anon_sym_DASHmatch] = ACTIONS(713),
    [anon_sym_DASHne] = ACTIONS(713),
    [anon_sym_DASHnotcontains] = ACTIONS(713),
    [anon_sym_DASHnotin] = ACTIONS(713),
    [anon_sym_DASHnotlike] = ACTIONS(713),
    [anon_sym_DASHnotmatch] = ACTIONS(713),
    [anon_sym_DASHreplace] = ACTIONS(713),
    [anon_sym_DASHshl] = ACTIONS(713),
    [anon_sym_DASHshr] = ACTIONS(713),
    [anon_sym_DASHsplit] = ACTIONS(713),
    [sym_format_operator] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(713),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_DASHand] = ACTIONS(713),
    [anon_sym_DASHor] = ACTIONS(713),
    [anon_sym_DASHxor] = ACTIONS(713),
    [anon_sym_DASHband] = ACTIONS(713),
    [anon_sym_DASHbor] = ACTIONS(713),
    [anon_sym_DASHbxor] = ACTIONS(713),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_BSLASH] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_DOT_DOT] = ACTIONS(713),
    [anon_sym_RBRACK] = ACTIONS(713),
  },
  [162] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_PLUS_EQ] = ACTIONS(765),
    [anon_sym_STAR_EQ] = ACTIONS(765),
    [anon_sym_SLASH_EQ] = ACTIONS(765),
    [anon_sym_PERCENT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(765),
    [anon_sym_2_GT] = ACTIONS(767),
    [anon_sym_2_GT_GT] = ACTIONS(765),
    [anon_sym_3_GT] = ACTIONS(767),
    [anon_sym_3_GT_GT] = ACTIONS(765),
    [anon_sym_4_GT] = ACTIONS(767),
    [anon_sym_4_GT_GT] = ACTIONS(765),
    [anon_sym_5_GT] = ACTIONS(767),
    [anon_sym_5_GT_GT] = ACTIONS(765),
    [anon_sym_6_GT] = ACTIONS(767),
    [anon_sym_6_GT_GT] = ACTIONS(765),
    [anon_sym_STAR_GT] = ACTIONS(767),
    [anon_sym_STAR_GT_GT] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(765),
    [anon_sym_2_GT_AMP1] = ACTIONS(765),
    [anon_sym_3_GT_AMP1] = ACTIONS(765),
    [anon_sym_4_GT_AMP1] = ACTIONS(765),
    [anon_sym_5_GT_AMP1] = ACTIONS(765),
    [anon_sym_6_GT_AMP1] = ACTIONS(765),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(765),
    [anon_sym_1_GT_AMP2] = ACTIONS(765),
    [anon_sym_3_GT_AMP2] = ACTIONS(765),
    [anon_sym_4_GT_AMP2] = ACTIONS(765),
    [anon_sym_5_GT_AMP2] = ACTIONS(765),
    [anon_sym_6_GT_AMP2] = ACTIONS(765),
    [anon_sym_DASHas] = ACTIONS(765),
    [anon_sym_DASHccontains] = ACTIONS(765),
    [anon_sym_DASHceq] = ACTIONS(765),
    [anon_sym_DASHcge] = ACTIONS(765),
    [anon_sym_DASHcgt] = ACTIONS(765),
    [anon_sym_DASHcle] = ACTIONS(765),
    [anon_sym_DASHclike] = ACTIONS(765),
    [anon_sym_DASHclt] = ACTIONS(765),
    [anon_sym_DASHcmatch] = ACTIONS(765),
    [anon_sym_DASHcne] = ACTIONS(765),
    [anon_sym_DASHcnotcontains] = ACTIONS(765),
    [anon_sym_DASHcnotlike] = ACTIONS(765),
    [anon_sym_DASHcnotmatch] = ACTIONS(765),
    [anon_sym_DASHcontains] = ACTIONS(765),
    [anon_sym_DASHcreplace] = ACTIONS(765),
    [anon_sym_DASHcsplit] = ACTIONS(765),
    [anon_sym_DASHeq] = ACTIONS(765),
    [anon_sym_DASHge] = ACTIONS(765),
    [anon_sym_DASHgt] = ACTIONS(765),
    [anon_sym_DASHicontains] = ACTIONS(765),
    [anon_sym_DASHieq] = ACTIONS(765),
    [anon_sym_DASHige] = ACTIONS(765),
    [anon_sym_DASHigt] = ACTIONS(765),
    [anon_sym_DASHile] = ACTIONS(765),
    [anon_sym_DASHilike] = ACTIONS(765),
    [anon_sym_DASHilt] = ACTIONS(765),
    [anon_sym_DASHimatch] = ACTIONS(765),
    [anon_sym_DASHin] = ACTIONS(767),
    [anon_sym_DASHine] = ACTIONS(765),
    [anon_sym_DASHinotcontains] = ACTIONS(765),
    [anon_sym_DASHinotlike] = ACTIONS(765),
    [anon_sym_DASHinotmatch] = ACTIONS(765),
    [anon_sym_DASHireplace] = ACTIONS(765),
    [anon_sym_DASHis] = ACTIONS(767),
    [anon_sym_DASHisnot] = ACTIONS(765),
    [anon_sym_DASHisplit] = ACTIONS(765),
    [anon_sym_DASHjoin] = ACTIONS(765),
    [anon_sym_DASHle] = ACTIONS(765),
    [anon_sym_DASHlike] = ACTIONS(765),
    [anon_sym_DASHlt] = ACTIONS(765),
    [anon_sym_DASHmatch] = ACTIONS(765),
    [anon_sym_DASHne] = ACTIONS(765),
    [anon_sym_DASHnotcontains] = ACTIONS(765),
    [anon_sym_DASHnotin] = ACTIONS(765),
    [anon_sym_DASHnotlike] = ACTIONS(765),
    [anon_sym_DASHnotmatch] = ACTIONS(765),
    [anon_sym_DASHreplace] = ACTIONS(765),
    [anon_sym_DASHshl] = ACTIONS(765),
    [anon_sym_DASHshr] = ACTIONS(765),
    [anon_sym_DASHsplit] = ACTIONS(765),
    [sym_format_operator] = ACTIONS(765),
    [anon_sym_RPAREN] = ACTIONS(765),
    [anon_sym_COMMA] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(765),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_DASHand] = ACTIONS(765),
    [anon_sym_DASHor] = ACTIONS(765),
    [anon_sym_DASHxor] = ACTIONS(765),
    [anon_sym_DASHband] = ACTIONS(765),
    [anon_sym_DASHbor] = ACTIONS(765),
    [anon_sym_DASHbxor] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_DOT_DOT] = ACTIONS(765),
    [anon_sym_RBRACK] = ACTIONS(765),
  },
  [163] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(693),
    [anon_sym_BANG_EQ] = ACTIONS(693),
    [anon_sym_PLUS_EQ] = ACTIONS(693),
    [anon_sym_STAR_EQ] = ACTIONS(693),
    [anon_sym_SLASH_EQ] = ACTIONS(693),
    [anon_sym_PERCENT_EQ] = ACTIONS(693),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(693),
    [anon_sym_2_GT] = ACTIONS(695),
    [anon_sym_2_GT_GT] = ACTIONS(693),
    [anon_sym_3_GT] = ACTIONS(695),
    [anon_sym_3_GT_GT] = ACTIONS(693),
    [anon_sym_4_GT] = ACTIONS(695),
    [anon_sym_4_GT_GT] = ACTIONS(693),
    [anon_sym_5_GT] = ACTIONS(695),
    [anon_sym_5_GT_GT] = ACTIONS(693),
    [anon_sym_6_GT] = ACTIONS(695),
    [anon_sym_6_GT_GT] = ACTIONS(693),
    [anon_sym_STAR_GT] = ACTIONS(695),
    [anon_sym_STAR_GT_GT] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(693),
    [anon_sym_2_GT_AMP1] = ACTIONS(693),
    [anon_sym_3_GT_AMP1] = ACTIONS(693),
    [anon_sym_4_GT_AMP1] = ACTIONS(693),
    [anon_sym_5_GT_AMP1] = ACTIONS(693),
    [anon_sym_6_GT_AMP1] = ACTIONS(693),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(693),
    [anon_sym_1_GT_AMP2] = ACTIONS(693),
    [anon_sym_3_GT_AMP2] = ACTIONS(693),
    [anon_sym_4_GT_AMP2] = ACTIONS(693),
    [anon_sym_5_GT_AMP2] = ACTIONS(693),
    [anon_sym_6_GT_AMP2] = ACTIONS(693),
    [anon_sym_DASHas] = ACTIONS(693),
    [anon_sym_DASHccontains] = ACTIONS(693),
    [anon_sym_DASHceq] = ACTIONS(693),
    [anon_sym_DASHcge] = ACTIONS(693),
    [anon_sym_DASHcgt] = ACTIONS(693),
    [anon_sym_DASHcle] = ACTIONS(693),
    [anon_sym_DASHclike] = ACTIONS(693),
    [anon_sym_DASHclt] = ACTIONS(693),
    [anon_sym_DASHcmatch] = ACTIONS(693),
    [anon_sym_DASHcne] = ACTIONS(693),
    [anon_sym_DASHcnotcontains] = ACTIONS(693),
    [anon_sym_DASHcnotlike] = ACTIONS(693),
    [anon_sym_DASHcnotmatch] = ACTIONS(693),
    [anon_sym_DASHcontains] = ACTIONS(693),
    [anon_sym_DASHcreplace] = ACTIONS(693),
    [anon_sym_DASHcsplit] = ACTIONS(693),
    [anon_sym_DASHeq] = ACTIONS(693),
    [anon_sym_DASHge] = ACTIONS(693),
    [anon_sym_DASHgt] = ACTIONS(693),
    [anon_sym_DASHicontains] = ACTIONS(693),
    [anon_sym_DASHieq] = ACTIONS(693),
    [anon_sym_DASHige] = ACTIONS(693),
    [anon_sym_DASHigt] = ACTIONS(693),
    [anon_sym_DASHile] = ACTIONS(693),
    [anon_sym_DASHilike] = ACTIONS(693),
    [anon_sym_DASHilt] = ACTIONS(693),
    [anon_sym_DASHimatch] = ACTIONS(693),
    [anon_sym_DASHin] = ACTIONS(695),
    [anon_sym_DASHine] = ACTIONS(693),
    [anon_sym_DASHinotcontains] = ACTIONS(693),
    [anon_sym_DASHinotlike] = ACTIONS(693),
    [anon_sym_DASHinotmatch] = ACTIONS(693),
    [anon_sym_DASHireplace] = ACTIONS(693),
    [anon_sym_DASHis] = ACTIONS(695),
    [anon_sym_DASHisnot] = ACTIONS(693),
    [anon_sym_DASHisplit] = ACTIONS(693),
    [anon_sym_DASHjoin] = ACTIONS(693),
    [anon_sym_DASHle] = ACTIONS(693),
    [anon_sym_DASHlike] = ACTIONS(693),
    [anon_sym_DASHlt] = ACTIONS(693),
    [anon_sym_DASHmatch] = ACTIONS(693),
    [anon_sym_DASHne] = ACTIONS(693),
    [anon_sym_DASHnotcontains] = ACTIONS(693),
    [anon_sym_DASHnotin] = ACTIONS(693),
    [anon_sym_DASHnotlike] = ACTIONS(693),
    [anon_sym_DASHnotmatch] = ACTIONS(693),
    [anon_sym_DASHreplace] = ACTIONS(693),
    [anon_sym_DASHshl] = ACTIONS(693),
    [anon_sym_DASHshr] = ACTIONS(693),
    [anon_sym_DASHsplit] = ACTIONS(693),
    [sym_format_operator] = ACTIONS(693),
    [anon_sym_RPAREN] = ACTIONS(693),
    [anon_sym_COMMA] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(693),
    [anon_sym_PERCENT] = ACTIONS(695),
    [anon_sym_DASHand] = ACTIONS(693),
    [anon_sym_DASHor] = ACTIONS(693),
    [anon_sym_DASHxor] = ACTIONS(693),
    [anon_sym_DASHband] = ACTIONS(693),
    [anon_sym_DASHbor] = ACTIONS(693),
    [anon_sym_DASHbxor] = ACTIONS(693),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_SLASH] = ACTIONS(695),
    [anon_sym_BSLASH] = ACTIONS(693),
    [anon_sym_STAR] = ACTIONS(695),
    [anon_sym_DOT_DOT] = ACTIONS(693),
    [anon_sym_RBRACK] = ACTIONS(693),
  },
  [164] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(769),
    [anon_sym_PLUS_EQ] = ACTIONS(769),
    [anon_sym_STAR_EQ] = ACTIONS(769),
    [anon_sym_SLASH_EQ] = ACTIONS(769),
    [anon_sym_PERCENT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_2_GT] = ACTIONS(771),
    [anon_sym_2_GT_GT] = ACTIONS(769),
    [anon_sym_3_GT] = ACTIONS(771),
    [anon_sym_3_GT_GT] = ACTIONS(769),
    [anon_sym_4_GT] = ACTIONS(771),
    [anon_sym_4_GT_GT] = ACTIONS(769),
    [anon_sym_5_GT] = ACTIONS(771),
    [anon_sym_5_GT_GT] = ACTIONS(769),
    [anon_sym_6_GT] = ACTIONS(771),
    [anon_sym_6_GT_GT] = ACTIONS(769),
    [anon_sym_STAR_GT] = ACTIONS(771),
    [anon_sym_STAR_GT_GT] = ACTIONS(769),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(769),
    [anon_sym_2_GT_AMP1] = ACTIONS(769),
    [anon_sym_3_GT_AMP1] = ACTIONS(769),
    [anon_sym_4_GT_AMP1] = ACTIONS(769),
    [anon_sym_5_GT_AMP1] = ACTIONS(769),
    [anon_sym_6_GT_AMP1] = ACTIONS(769),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(769),
    [anon_sym_1_GT_AMP2] = ACTIONS(769),
    [anon_sym_3_GT_AMP2] = ACTIONS(769),
    [anon_sym_4_GT_AMP2] = ACTIONS(769),
    [anon_sym_5_GT_AMP2] = ACTIONS(769),
    [anon_sym_6_GT_AMP2] = ACTIONS(769),
    [anon_sym_DASHas] = ACTIONS(769),
    [anon_sym_DASHccontains] = ACTIONS(769),
    [anon_sym_DASHceq] = ACTIONS(769),
    [anon_sym_DASHcge] = ACTIONS(769),
    [anon_sym_DASHcgt] = ACTIONS(769),
    [anon_sym_DASHcle] = ACTIONS(769),
    [anon_sym_DASHclike] = ACTIONS(769),
    [anon_sym_DASHclt] = ACTIONS(769),
    [anon_sym_DASHcmatch] = ACTIONS(769),
    [anon_sym_DASHcne] = ACTIONS(769),
    [anon_sym_DASHcnotcontains] = ACTIONS(769),
    [anon_sym_DASHcnotlike] = ACTIONS(769),
    [anon_sym_DASHcnotmatch] = ACTIONS(769),
    [anon_sym_DASHcontains] = ACTIONS(769),
    [anon_sym_DASHcreplace] = ACTIONS(769),
    [anon_sym_DASHcsplit] = ACTIONS(769),
    [anon_sym_DASHeq] = ACTIONS(769),
    [anon_sym_DASHge] = ACTIONS(769),
    [anon_sym_DASHgt] = ACTIONS(769),
    [anon_sym_DASHicontains] = ACTIONS(769),
    [anon_sym_DASHieq] = ACTIONS(769),
    [anon_sym_DASHige] = ACTIONS(769),
    [anon_sym_DASHigt] = ACTIONS(769),
    [anon_sym_DASHile] = ACTIONS(769),
    [anon_sym_DASHilike] = ACTIONS(769),
    [anon_sym_DASHilt] = ACTIONS(769),
    [anon_sym_DASHimatch] = ACTIONS(769),
    [anon_sym_DASHin] = ACTIONS(771),
    [anon_sym_DASHine] = ACTIONS(769),
    [anon_sym_DASHinotcontains] = ACTIONS(769),
    [anon_sym_DASHinotlike] = ACTIONS(769),
    [anon_sym_DASHinotmatch] = ACTIONS(769),
    [anon_sym_DASHireplace] = ACTIONS(769),
    [anon_sym_DASHis] = ACTIONS(771),
    [anon_sym_DASHisnot] = ACTIONS(769),
    [anon_sym_DASHisplit] = ACTIONS(769),
    [anon_sym_DASHjoin] = ACTIONS(769),
    [anon_sym_DASHle] = ACTIONS(769),
    [anon_sym_DASHlike] = ACTIONS(769),
    [anon_sym_DASHlt] = ACTIONS(769),
    [anon_sym_DASHmatch] = ACTIONS(769),
    [anon_sym_DASHne] = ACTIONS(769),
    [anon_sym_DASHnotcontains] = ACTIONS(769),
    [anon_sym_DASHnotin] = ACTIONS(769),
    [anon_sym_DASHnotlike] = ACTIONS(769),
    [anon_sym_DASHnotmatch] = ACTIONS(769),
    [anon_sym_DASHreplace] = ACTIONS(769),
    [anon_sym_DASHshl] = ACTIONS(769),
    [anon_sym_DASHshr] = ACTIONS(769),
    [anon_sym_DASHsplit] = ACTIONS(769),
    [sym_format_operator] = ACTIONS(769),
    [anon_sym_RPAREN] = ACTIONS(769),
    [anon_sym_COMMA] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_DASHand] = ACTIONS(769),
    [anon_sym_DASHor] = ACTIONS(769),
    [anon_sym_DASHxor] = ACTIONS(769),
    [anon_sym_DASHband] = ACTIONS(769),
    [anon_sym_DASHbor] = ACTIONS(769),
    [anon_sym_DASHbxor] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_DASH] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_BSLASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_RBRACK] = ACTIONS(769),
  },
  [165] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(693),
    [anon_sym_BANG_EQ] = ACTIONS(693),
    [anon_sym_PLUS_EQ] = ACTIONS(693),
    [anon_sym_STAR_EQ] = ACTIONS(693),
    [anon_sym_SLASH_EQ] = ACTIONS(693),
    [anon_sym_PERCENT_EQ] = ACTIONS(693),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_GT_GT] = ACTIONS(693),
    [anon_sym_2_GT] = ACTIONS(695),
    [anon_sym_2_GT_GT] = ACTIONS(693),
    [anon_sym_3_GT] = ACTIONS(695),
    [anon_sym_3_GT_GT] = ACTIONS(693),
    [anon_sym_4_GT] = ACTIONS(695),
    [anon_sym_4_GT_GT] = ACTIONS(693),
    [anon_sym_5_GT] = ACTIONS(695),
    [anon_sym_5_GT_GT] = ACTIONS(693),
    [anon_sym_6_GT] = ACTIONS(695),
    [anon_sym_6_GT_GT] = ACTIONS(693),
    [anon_sym_STAR_GT] = ACTIONS(695),
    [anon_sym_STAR_GT_GT] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(693),
    [anon_sym_2_GT_AMP1] = ACTIONS(693),
    [anon_sym_3_GT_AMP1] = ACTIONS(693),
    [anon_sym_4_GT_AMP1] = ACTIONS(693),
    [anon_sym_5_GT_AMP1] = ACTIONS(693),
    [anon_sym_6_GT_AMP1] = ACTIONS(693),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(693),
    [anon_sym_1_GT_AMP2] = ACTIONS(693),
    [anon_sym_3_GT_AMP2] = ACTIONS(693),
    [anon_sym_4_GT_AMP2] = ACTIONS(693),
    [anon_sym_5_GT_AMP2] = ACTIONS(693),
    [anon_sym_6_GT_AMP2] = ACTIONS(693),
    [anon_sym_DASHas] = ACTIONS(693),
    [anon_sym_DASHccontains] = ACTIONS(693),
    [anon_sym_DASHceq] = ACTIONS(693),
    [anon_sym_DASHcge] = ACTIONS(693),
    [anon_sym_DASHcgt] = ACTIONS(693),
    [anon_sym_DASHcle] = ACTIONS(693),
    [anon_sym_DASHclike] = ACTIONS(693),
    [anon_sym_DASHclt] = ACTIONS(693),
    [anon_sym_DASHcmatch] = ACTIONS(693),
    [anon_sym_DASHcne] = ACTIONS(693),
    [anon_sym_DASHcnotcontains] = ACTIONS(693),
    [anon_sym_DASHcnotlike] = ACTIONS(693),
    [anon_sym_DASHcnotmatch] = ACTIONS(693),
    [anon_sym_DASHcontains] = ACTIONS(693),
    [anon_sym_DASHcreplace] = ACTIONS(693),
    [anon_sym_DASHcsplit] = ACTIONS(693),
    [anon_sym_DASHeq] = ACTIONS(693),
    [anon_sym_DASHge] = ACTIONS(693),
    [anon_sym_DASHgt] = ACTIONS(693),
    [anon_sym_DASHicontains] = ACTIONS(693),
    [anon_sym_DASHieq] = ACTIONS(693),
    [anon_sym_DASHige] = ACTIONS(693),
    [anon_sym_DASHigt] = ACTIONS(693),
    [anon_sym_DASHile] = ACTIONS(693),
    [anon_sym_DASHilike] = ACTIONS(693),
    [anon_sym_DASHilt] = ACTIONS(693),
    [anon_sym_DASHimatch] = ACTIONS(693),
    [anon_sym_DASHin] = ACTIONS(695),
    [anon_sym_DASHine] = ACTIONS(693),
    [anon_sym_DASHinotcontains] = ACTIONS(693),
    [anon_sym_DASHinotlike] = ACTIONS(693),
    [anon_sym_DASHinotmatch] = ACTIONS(693),
    [anon_sym_DASHireplace] = ACTIONS(693),
    [anon_sym_DASHis] = ACTIONS(695),
    [anon_sym_DASHisnot] = ACTIONS(693),
    [anon_sym_DASHisplit] = ACTIONS(693),
    [anon_sym_DASHjoin] = ACTIONS(693),
    [anon_sym_DASHle] = ACTIONS(693),
    [anon_sym_DASHlike] = ACTIONS(693),
    [anon_sym_DASHlt] = ACTIONS(693),
    [anon_sym_DASHmatch] = ACTIONS(693),
    [anon_sym_DASHne] = ACTIONS(693),
    [anon_sym_DASHnotcontains] = ACTIONS(693),
    [anon_sym_DASHnotin] = ACTIONS(693),
    [anon_sym_DASHnotlike] = ACTIONS(693),
    [anon_sym_DASHnotmatch] = ACTIONS(693),
    [anon_sym_DASHreplace] = ACTIONS(693),
    [anon_sym_DASHshl] = ACTIONS(693),
    [anon_sym_DASHshr] = ACTIONS(693),
    [anon_sym_DASHsplit] = ACTIONS(693),
    [sym_format_operator] = ACTIONS(693),
    [anon_sym_COMMA] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(693),
    [anon_sym_PERCENT] = ACTIONS(695),
    [anon_sym_DASHand] = ACTIONS(693),
    [anon_sym_DASHor] = ACTIONS(693),
    [anon_sym_DASHxor] = ACTIONS(693),
    [anon_sym_DASHband] = ACTIONS(693),
    [anon_sym_DASHbor] = ACTIONS(693),
    [anon_sym_DASHbxor] = ACTIONS(693),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_SLASH] = ACTIONS(695),
    [anon_sym_BSLASH] = ACTIONS(693),
    [anon_sym_STAR] = ACTIONS(695),
    [anon_sym_DOT_DOT] = ACTIONS(693),
    [sym__statement_terminator] = ACTIONS(693),
  },
  [166] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(773),
    [anon_sym_BANG_EQ] = ACTIONS(773),
    [anon_sym_PLUS_EQ] = ACTIONS(773),
    [anon_sym_STAR_EQ] = ACTIONS(773),
    [anon_sym_SLASH_EQ] = ACTIONS(773),
    [anon_sym_PERCENT_EQ] = ACTIONS(773),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(773),
    [anon_sym_2_GT] = ACTIONS(775),
    [anon_sym_2_GT_GT] = ACTIONS(773),
    [anon_sym_3_GT] = ACTIONS(775),
    [anon_sym_3_GT_GT] = ACTIONS(773),
    [anon_sym_4_GT] = ACTIONS(775),
    [anon_sym_4_GT_GT] = ACTIONS(773),
    [anon_sym_5_GT] = ACTIONS(775),
    [anon_sym_5_GT_GT] = ACTIONS(773),
    [anon_sym_6_GT] = ACTIONS(775),
    [anon_sym_6_GT_GT] = ACTIONS(773),
    [anon_sym_STAR_GT] = ACTIONS(775),
    [anon_sym_STAR_GT_GT] = ACTIONS(773),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(773),
    [anon_sym_2_GT_AMP1] = ACTIONS(773),
    [anon_sym_3_GT_AMP1] = ACTIONS(773),
    [anon_sym_4_GT_AMP1] = ACTIONS(773),
    [anon_sym_5_GT_AMP1] = ACTIONS(773),
    [anon_sym_6_GT_AMP1] = ACTIONS(773),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(773),
    [anon_sym_1_GT_AMP2] = ACTIONS(773),
    [anon_sym_3_GT_AMP2] = ACTIONS(773),
    [anon_sym_4_GT_AMP2] = ACTIONS(773),
    [anon_sym_5_GT_AMP2] = ACTIONS(773),
    [anon_sym_6_GT_AMP2] = ACTIONS(773),
    [anon_sym_DASHas] = ACTIONS(773),
    [anon_sym_DASHccontains] = ACTIONS(773),
    [anon_sym_DASHceq] = ACTIONS(773),
    [anon_sym_DASHcge] = ACTIONS(773),
    [anon_sym_DASHcgt] = ACTIONS(773),
    [anon_sym_DASHcle] = ACTIONS(773),
    [anon_sym_DASHclike] = ACTIONS(773),
    [anon_sym_DASHclt] = ACTIONS(773),
    [anon_sym_DASHcmatch] = ACTIONS(773),
    [anon_sym_DASHcne] = ACTIONS(773),
    [anon_sym_DASHcnotcontains] = ACTIONS(773),
    [anon_sym_DASHcnotlike] = ACTIONS(773),
    [anon_sym_DASHcnotmatch] = ACTIONS(773),
    [anon_sym_DASHcontains] = ACTIONS(773),
    [anon_sym_DASHcreplace] = ACTIONS(773),
    [anon_sym_DASHcsplit] = ACTIONS(773),
    [anon_sym_DASHeq] = ACTIONS(773),
    [anon_sym_DASHge] = ACTIONS(773),
    [anon_sym_DASHgt] = ACTIONS(773),
    [anon_sym_DASHicontains] = ACTIONS(773),
    [anon_sym_DASHieq] = ACTIONS(773),
    [anon_sym_DASHige] = ACTIONS(773),
    [anon_sym_DASHigt] = ACTIONS(773),
    [anon_sym_DASHile] = ACTIONS(773),
    [anon_sym_DASHilike] = ACTIONS(773),
    [anon_sym_DASHilt] = ACTIONS(773),
    [anon_sym_DASHimatch] = ACTIONS(773),
    [anon_sym_DASHin] = ACTIONS(775),
    [anon_sym_DASHine] = ACTIONS(773),
    [anon_sym_DASHinotcontains] = ACTIONS(773),
    [anon_sym_DASHinotlike] = ACTIONS(773),
    [anon_sym_DASHinotmatch] = ACTIONS(773),
    [anon_sym_DASHireplace] = ACTIONS(773),
    [anon_sym_DASHis] = ACTIONS(775),
    [anon_sym_DASHisnot] = ACTIONS(773),
    [anon_sym_DASHisplit] = ACTIONS(773),
    [anon_sym_DASHjoin] = ACTIONS(773),
    [anon_sym_DASHle] = ACTIONS(773),
    [anon_sym_DASHlike] = ACTIONS(773),
    [anon_sym_DASHlt] = ACTIONS(773),
    [anon_sym_DASHmatch] = ACTIONS(773),
    [anon_sym_DASHne] = ACTIONS(773),
    [anon_sym_DASHnotcontains] = ACTIONS(773),
    [anon_sym_DASHnotin] = ACTIONS(773),
    [anon_sym_DASHnotlike] = ACTIONS(773),
    [anon_sym_DASHnotmatch] = ACTIONS(773),
    [anon_sym_DASHreplace] = ACTIONS(773),
    [anon_sym_DASHshl] = ACTIONS(773),
    [anon_sym_DASHshr] = ACTIONS(773),
    [anon_sym_DASHsplit] = ACTIONS(773),
    [sym_format_operator] = ACTIONS(773),
    [anon_sym_RPAREN] = ACTIONS(773),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_DASHand] = ACTIONS(773),
    [anon_sym_DASHor] = ACTIONS(773),
    [anon_sym_DASHxor] = ACTIONS(773),
    [anon_sym_DASHband] = ACTIONS(773),
    [anon_sym_DASHbor] = ACTIONS(773),
    [anon_sym_DASHbxor] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_STAR] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(773),
  },
  [167] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(617),
    [anon_sym_BANG_EQ] = ACTIONS(617),
    [anon_sym_PLUS_EQ] = ACTIONS(617),
    [anon_sym_STAR_EQ] = ACTIONS(617),
    [anon_sym_SLASH_EQ] = ACTIONS(617),
    [anon_sym_PERCENT_EQ] = ACTIONS(617),
    [anon_sym_GT] = ACTIONS(619),
    [anon_sym_GT_GT] = ACTIONS(617),
    [anon_sym_2_GT] = ACTIONS(619),
    [anon_sym_2_GT_GT] = ACTIONS(617),
    [anon_sym_3_GT] = ACTIONS(619),
    [anon_sym_3_GT_GT] = ACTIONS(617),
    [anon_sym_4_GT] = ACTIONS(619),
    [anon_sym_4_GT_GT] = ACTIONS(617),
    [anon_sym_5_GT] = ACTIONS(619),
    [anon_sym_5_GT_GT] = ACTIONS(617),
    [anon_sym_6_GT] = ACTIONS(619),
    [anon_sym_6_GT_GT] = ACTIONS(617),
    [anon_sym_STAR_GT] = ACTIONS(619),
    [anon_sym_STAR_GT_GT] = ACTIONS(617),
    [anon_sym_LT] = ACTIONS(619),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(617),
    [anon_sym_2_GT_AMP1] = ACTIONS(617),
    [anon_sym_3_GT_AMP1] = ACTIONS(617),
    [anon_sym_4_GT_AMP1] = ACTIONS(617),
    [anon_sym_5_GT_AMP1] = ACTIONS(617),
    [anon_sym_6_GT_AMP1] = ACTIONS(617),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(617),
    [anon_sym_1_GT_AMP2] = ACTIONS(617),
    [anon_sym_3_GT_AMP2] = ACTIONS(617),
    [anon_sym_4_GT_AMP2] = ACTIONS(617),
    [anon_sym_5_GT_AMP2] = ACTIONS(617),
    [anon_sym_6_GT_AMP2] = ACTIONS(617),
    [anon_sym_DASHas] = ACTIONS(617),
    [anon_sym_DASHccontains] = ACTIONS(617),
    [anon_sym_DASHceq] = ACTIONS(617),
    [anon_sym_DASHcge] = ACTIONS(617),
    [anon_sym_DASHcgt] = ACTIONS(617),
    [anon_sym_DASHcle] = ACTIONS(617),
    [anon_sym_DASHclike] = ACTIONS(617),
    [anon_sym_DASHclt] = ACTIONS(617),
    [anon_sym_DASHcmatch] = ACTIONS(617),
    [anon_sym_DASHcne] = ACTIONS(617),
    [anon_sym_DASHcnotcontains] = ACTIONS(617),
    [anon_sym_DASHcnotlike] = ACTIONS(617),
    [anon_sym_DASHcnotmatch] = ACTIONS(617),
    [anon_sym_DASHcontains] = ACTIONS(617),
    [anon_sym_DASHcreplace] = ACTIONS(617),
    [anon_sym_DASHcsplit] = ACTIONS(617),
    [anon_sym_DASHeq] = ACTIONS(617),
    [anon_sym_DASHge] = ACTIONS(617),
    [anon_sym_DASHgt] = ACTIONS(617),
    [anon_sym_DASHicontains] = ACTIONS(617),
    [anon_sym_DASHieq] = ACTIONS(617),
    [anon_sym_DASHige] = ACTIONS(617),
    [anon_sym_DASHigt] = ACTIONS(617),
    [anon_sym_DASHile] = ACTIONS(617),
    [anon_sym_DASHilike] = ACTIONS(617),
    [anon_sym_DASHilt] = ACTIONS(617),
    [anon_sym_DASHimatch] = ACTIONS(617),
    [anon_sym_DASHin] = ACTIONS(619),
    [anon_sym_DASHine] = ACTIONS(617),
    [anon_sym_DASHinotcontains] = ACTIONS(617),
    [anon_sym_DASHinotlike] = ACTIONS(617),
    [anon_sym_DASHinotmatch] = ACTIONS(617),
    [anon_sym_DASHireplace] = ACTIONS(617),
    [anon_sym_DASHis] = ACTIONS(619),
    [anon_sym_DASHisnot] = ACTIONS(617),
    [anon_sym_DASHisplit] = ACTIONS(617),
    [anon_sym_DASHjoin] = ACTIONS(617),
    [anon_sym_DASHle] = ACTIONS(617),
    [anon_sym_DASHlike] = ACTIONS(617),
    [anon_sym_DASHlt] = ACTIONS(617),
    [anon_sym_DASHmatch] = ACTIONS(617),
    [anon_sym_DASHne] = ACTIONS(617),
    [anon_sym_DASHnotcontains] = ACTIONS(617),
    [anon_sym_DASHnotin] = ACTIONS(617),
    [anon_sym_DASHnotlike] = ACTIONS(617),
    [anon_sym_DASHnotmatch] = ACTIONS(617),
    [anon_sym_DASHreplace] = ACTIONS(617),
    [anon_sym_DASHshl] = ACTIONS(617),
    [anon_sym_DASHshr] = ACTIONS(617),
    [anon_sym_DASHsplit] = ACTIONS(617),
    [sym_format_operator] = ACTIONS(617),
    [anon_sym_COMMA] = ACTIONS(617),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_DASHand] = ACTIONS(617),
    [anon_sym_DASHor] = ACTIONS(617),
    [anon_sym_DASHxor] = ACTIONS(617),
    [anon_sym_DASHband] = ACTIONS(617),
    [anon_sym_DASHbor] = ACTIONS(617),
    [anon_sym_DASHbxor] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_BSLASH] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_DOT_DOT] = ACTIONS(617),
    [sym__statement_terminator] = ACTIONS(617),
  },
  [168] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(779),
    [anon_sym_BANG_EQ] = ACTIONS(779),
    [anon_sym_PLUS_EQ] = ACTIONS(779),
    [anon_sym_STAR_EQ] = ACTIONS(779),
    [anon_sym_SLASH_EQ] = ACTIONS(779),
    [anon_sym_PERCENT_EQ] = ACTIONS(779),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_GT_GT] = ACTIONS(779),
    [anon_sym_2_GT] = ACTIONS(781),
    [anon_sym_2_GT_GT] = ACTIONS(779),
    [anon_sym_3_GT] = ACTIONS(781),
    [anon_sym_3_GT_GT] = ACTIONS(779),
    [anon_sym_4_GT] = ACTIONS(781),
    [anon_sym_4_GT_GT] = ACTIONS(779),
    [anon_sym_5_GT] = ACTIONS(781),
    [anon_sym_5_GT_GT] = ACTIONS(779),
    [anon_sym_6_GT] = ACTIONS(781),
    [anon_sym_6_GT_GT] = ACTIONS(779),
    [anon_sym_STAR_GT] = ACTIONS(781),
    [anon_sym_STAR_GT_GT] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(779),
    [anon_sym_2_GT_AMP1] = ACTIONS(779),
    [anon_sym_3_GT_AMP1] = ACTIONS(779),
    [anon_sym_4_GT_AMP1] = ACTIONS(779),
    [anon_sym_5_GT_AMP1] = ACTIONS(779),
    [anon_sym_6_GT_AMP1] = ACTIONS(779),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(779),
    [anon_sym_1_GT_AMP2] = ACTIONS(779),
    [anon_sym_3_GT_AMP2] = ACTIONS(779),
    [anon_sym_4_GT_AMP2] = ACTIONS(779),
    [anon_sym_5_GT_AMP2] = ACTIONS(779),
    [anon_sym_6_GT_AMP2] = ACTIONS(779),
    [anon_sym_DASHas] = ACTIONS(779),
    [anon_sym_DASHccontains] = ACTIONS(779),
    [anon_sym_DASHceq] = ACTIONS(779),
    [anon_sym_DASHcge] = ACTIONS(779),
    [anon_sym_DASHcgt] = ACTIONS(779),
    [anon_sym_DASHcle] = ACTIONS(779),
    [anon_sym_DASHclike] = ACTIONS(779),
    [anon_sym_DASHclt] = ACTIONS(779),
    [anon_sym_DASHcmatch] = ACTIONS(779),
    [anon_sym_DASHcne] = ACTIONS(779),
    [anon_sym_DASHcnotcontains] = ACTIONS(779),
    [anon_sym_DASHcnotlike] = ACTIONS(779),
    [anon_sym_DASHcnotmatch] = ACTIONS(779),
    [anon_sym_DASHcontains] = ACTIONS(779),
    [anon_sym_DASHcreplace] = ACTIONS(779),
    [anon_sym_DASHcsplit] = ACTIONS(779),
    [anon_sym_DASHeq] = ACTIONS(779),
    [anon_sym_DASHge] = ACTIONS(779),
    [anon_sym_DASHgt] = ACTIONS(779),
    [anon_sym_DASHicontains] = ACTIONS(779),
    [anon_sym_DASHieq] = ACTIONS(779),
    [anon_sym_DASHige] = ACTIONS(779),
    [anon_sym_DASHigt] = ACTIONS(779),
    [anon_sym_DASHile] = ACTIONS(779),
    [anon_sym_DASHilike] = ACTIONS(779),
    [anon_sym_DASHilt] = ACTIONS(779),
    [anon_sym_DASHimatch] = ACTIONS(779),
    [anon_sym_DASHin] = ACTIONS(781),
    [anon_sym_DASHine] = ACTIONS(779),
    [anon_sym_DASHinotcontains] = ACTIONS(779),
    [anon_sym_DASHinotlike] = ACTIONS(779),
    [anon_sym_DASHinotmatch] = ACTIONS(779),
    [anon_sym_DASHireplace] = ACTIONS(779),
    [anon_sym_DASHis] = ACTIONS(781),
    [anon_sym_DASHisnot] = ACTIONS(779),
    [anon_sym_DASHisplit] = ACTIONS(779),
    [anon_sym_DASHjoin] = ACTIONS(779),
    [anon_sym_DASHle] = ACTIONS(779),
    [anon_sym_DASHlike] = ACTIONS(779),
    [anon_sym_DASHlt] = ACTIONS(779),
    [anon_sym_DASHmatch] = ACTIONS(779),
    [anon_sym_DASHne] = ACTIONS(779),
    [anon_sym_DASHnotcontains] = ACTIONS(779),
    [anon_sym_DASHnotin] = ACTIONS(779),
    [anon_sym_DASHnotlike] = ACTIONS(779),
    [anon_sym_DASHnotmatch] = ACTIONS(779),
    [anon_sym_DASHreplace] = ACTIONS(779),
    [anon_sym_DASHshl] = ACTIONS(779),
    [anon_sym_DASHshr] = ACTIONS(779),
    [anon_sym_DASHsplit] = ACTIONS(779),
    [sym_format_operator] = ACTIONS(779),
    [anon_sym_RPAREN] = ACTIONS(779),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(779),
    [anon_sym_PERCENT] = ACTIONS(781),
    [anon_sym_DASHand] = ACTIONS(779),
    [anon_sym_DASHor] = ACTIONS(779),
    [anon_sym_DASHxor] = ACTIONS(779),
    [anon_sym_DASHband] = ACTIONS(779),
    [anon_sym_DASHbor] = ACTIONS(779),
    [anon_sym_DASHbxor] = ACTIONS(779),
    [anon_sym_PLUS] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_SLASH] = ACTIONS(781),
    [anon_sym_BSLASH] = ACTIONS(779),
    [anon_sym_STAR] = ACTIONS(781),
    [anon_sym_DOT_DOT] = ACTIONS(779),
  },
  [169] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(769),
    [anon_sym_PLUS_EQ] = ACTIONS(769),
    [anon_sym_STAR_EQ] = ACTIONS(769),
    [anon_sym_SLASH_EQ] = ACTIONS(769),
    [anon_sym_PERCENT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_2_GT] = ACTIONS(771),
    [anon_sym_2_GT_GT] = ACTIONS(769),
    [anon_sym_3_GT] = ACTIONS(771),
    [anon_sym_3_GT_GT] = ACTIONS(769),
    [anon_sym_4_GT] = ACTIONS(771),
    [anon_sym_4_GT_GT] = ACTIONS(769),
    [anon_sym_5_GT] = ACTIONS(771),
    [anon_sym_5_GT_GT] = ACTIONS(769),
    [anon_sym_6_GT] = ACTIONS(771),
    [anon_sym_6_GT_GT] = ACTIONS(769),
    [anon_sym_STAR_GT] = ACTIONS(771),
    [anon_sym_STAR_GT_GT] = ACTIONS(769),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(769),
    [anon_sym_2_GT_AMP1] = ACTIONS(769),
    [anon_sym_3_GT_AMP1] = ACTIONS(769),
    [anon_sym_4_GT_AMP1] = ACTIONS(769),
    [anon_sym_5_GT_AMP1] = ACTIONS(769),
    [anon_sym_6_GT_AMP1] = ACTIONS(769),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(769),
    [anon_sym_1_GT_AMP2] = ACTIONS(769),
    [anon_sym_3_GT_AMP2] = ACTIONS(769),
    [anon_sym_4_GT_AMP2] = ACTIONS(769),
    [anon_sym_5_GT_AMP2] = ACTIONS(769),
    [anon_sym_6_GT_AMP2] = ACTIONS(769),
    [anon_sym_DASHas] = ACTIONS(769),
    [anon_sym_DASHccontains] = ACTIONS(769),
    [anon_sym_DASHceq] = ACTIONS(769),
    [anon_sym_DASHcge] = ACTIONS(769),
    [anon_sym_DASHcgt] = ACTIONS(769),
    [anon_sym_DASHcle] = ACTIONS(769),
    [anon_sym_DASHclike] = ACTIONS(769),
    [anon_sym_DASHclt] = ACTIONS(769),
    [anon_sym_DASHcmatch] = ACTIONS(769),
    [anon_sym_DASHcne] = ACTIONS(769),
    [anon_sym_DASHcnotcontains] = ACTIONS(769),
    [anon_sym_DASHcnotlike] = ACTIONS(769),
    [anon_sym_DASHcnotmatch] = ACTIONS(769),
    [anon_sym_DASHcontains] = ACTIONS(769),
    [anon_sym_DASHcreplace] = ACTIONS(769),
    [anon_sym_DASHcsplit] = ACTIONS(769),
    [anon_sym_DASHeq] = ACTIONS(769),
    [anon_sym_DASHge] = ACTIONS(769),
    [anon_sym_DASHgt] = ACTIONS(769),
    [anon_sym_DASHicontains] = ACTIONS(769),
    [anon_sym_DASHieq] = ACTIONS(769),
    [anon_sym_DASHige] = ACTIONS(769),
    [anon_sym_DASHigt] = ACTIONS(769),
    [anon_sym_DASHile] = ACTIONS(769),
    [anon_sym_DASHilike] = ACTIONS(769),
    [anon_sym_DASHilt] = ACTIONS(769),
    [anon_sym_DASHimatch] = ACTIONS(769),
    [anon_sym_DASHin] = ACTIONS(771),
    [anon_sym_DASHine] = ACTIONS(769),
    [anon_sym_DASHinotcontains] = ACTIONS(769),
    [anon_sym_DASHinotlike] = ACTIONS(769),
    [anon_sym_DASHinotmatch] = ACTIONS(769),
    [anon_sym_DASHireplace] = ACTIONS(769),
    [anon_sym_DASHis] = ACTIONS(771),
    [anon_sym_DASHisnot] = ACTIONS(769),
    [anon_sym_DASHisplit] = ACTIONS(769),
    [anon_sym_DASHjoin] = ACTIONS(769),
    [anon_sym_DASHle] = ACTIONS(769),
    [anon_sym_DASHlike] = ACTIONS(769),
    [anon_sym_DASHlt] = ACTIONS(769),
    [anon_sym_DASHmatch] = ACTIONS(769),
    [anon_sym_DASHne] = ACTIONS(769),
    [anon_sym_DASHnotcontains] = ACTIONS(769),
    [anon_sym_DASHnotin] = ACTIONS(769),
    [anon_sym_DASHnotlike] = ACTIONS(769),
    [anon_sym_DASHnotmatch] = ACTIONS(769),
    [anon_sym_DASHreplace] = ACTIONS(769),
    [anon_sym_DASHshl] = ACTIONS(769),
    [anon_sym_DASHshr] = ACTIONS(769),
    [anon_sym_DASHsplit] = ACTIONS(769),
    [sym_format_operator] = ACTIONS(769),
    [anon_sym_COMMA] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_DASHand] = ACTIONS(769),
    [anon_sym_DASHor] = ACTIONS(769),
    [anon_sym_DASHxor] = ACTIONS(769),
    [anon_sym_DASHband] = ACTIONS(769),
    [anon_sym_DASHbor] = ACTIONS(769),
    [anon_sym_DASHbxor] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_DASH] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_BSLASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [sym__statement_terminator] = ACTIONS(769),
  },
  [170] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(779),
    [anon_sym_BANG_EQ] = ACTIONS(779),
    [anon_sym_PLUS_EQ] = ACTIONS(779),
    [anon_sym_STAR_EQ] = ACTIONS(779),
    [anon_sym_SLASH_EQ] = ACTIONS(779),
    [anon_sym_PERCENT_EQ] = ACTIONS(779),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_GT_GT] = ACTIONS(779),
    [anon_sym_2_GT] = ACTIONS(781),
    [anon_sym_2_GT_GT] = ACTIONS(779),
    [anon_sym_3_GT] = ACTIONS(781),
    [anon_sym_3_GT_GT] = ACTIONS(779),
    [anon_sym_4_GT] = ACTIONS(781),
    [anon_sym_4_GT_GT] = ACTIONS(779),
    [anon_sym_5_GT] = ACTIONS(781),
    [anon_sym_5_GT_GT] = ACTIONS(779),
    [anon_sym_6_GT] = ACTIONS(781),
    [anon_sym_6_GT_GT] = ACTIONS(779),
    [anon_sym_STAR_GT] = ACTIONS(781),
    [anon_sym_STAR_GT_GT] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(779),
    [anon_sym_2_GT_AMP1] = ACTIONS(779),
    [anon_sym_3_GT_AMP1] = ACTIONS(779),
    [anon_sym_4_GT_AMP1] = ACTIONS(779),
    [anon_sym_5_GT_AMP1] = ACTIONS(779),
    [anon_sym_6_GT_AMP1] = ACTIONS(779),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(779),
    [anon_sym_1_GT_AMP2] = ACTIONS(779),
    [anon_sym_3_GT_AMP2] = ACTIONS(779),
    [anon_sym_4_GT_AMP2] = ACTIONS(779),
    [anon_sym_5_GT_AMP2] = ACTIONS(779),
    [anon_sym_6_GT_AMP2] = ACTIONS(779),
    [anon_sym_DASHas] = ACTIONS(779),
    [anon_sym_DASHccontains] = ACTIONS(779),
    [anon_sym_DASHceq] = ACTIONS(779),
    [anon_sym_DASHcge] = ACTIONS(779),
    [anon_sym_DASHcgt] = ACTIONS(779),
    [anon_sym_DASHcle] = ACTIONS(779),
    [anon_sym_DASHclike] = ACTIONS(779),
    [anon_sym_DASHclt] = ACTIONS(779),
    [anon_sym_DASHcmatch] = ACTIONS(779),
    [anon_sym_DASHcne] = ACTIONS(779),
    [anon_sym_DASHcnotcontains] = ACTIONS(779),
    [anon_sym_DASHcnotlike] = ACTIONS(779),
    [anon_sym_DASHcnotmatch] = ACTIONS(779),
    [anon_sym_DASHcontains] = ACTIONS(779),
    [anon_sym_DASHcreplace] = ACTIONS(779),
    [anon_sym_DASHcsplit] = ACTIONS(779),
    [anon_sym_DASHeq] = ACTIONS(779),
    [anon_sym_DASHge] = ACTIONS(779),
    [anon_sym_DASHgt] = ACTIONS(779),
    [anon_sym_DASHicontains] = ACTIONS(779),
    [anon_sym_DASHieq] = ACTIONS(779),
    [anon_sym_DASHige] = ACTIONS(779),
    [anon_sym_DASHigt] = ACTIONS(779),
    [anon_sym_DASHile] = ACTIONS(779),
    [anon_sym_DASHilike] = ACTIONS(779),
    [anon_sym_DASHilt] = ACTIONS(779),
    [anon_sym_DASHimatch] = ACTIONS(779),
    [anon_sym_DASHin] = ACTIONS(781),
    [anon_sym_DASHine] = ACTIONS(779),
    [anon_sym_DASHinotcontains] = ACTIONS(779),
    [anon_sym_DASHinotlike] = ACTIONS(779),
    [anon_sym_DASHinotmatch] = ACTIONS(779),
    [anon_sym_DASHireplace] = ACTIONS(779),
    [anon_sym_DASHis] = ACTIONS(781),
    [anon_sym_DASHisnot] = ACTIONS(779),
    [anon_sym_DASHisplit] = ACTIONS(779),
    [anon_sym_DASHjoin] = ACTIONS(779),
    [anon_sym_DASHle] = ACTIONS(779),
    [anon_sym_DASHlike] = ACTIONS(779),
    [anon_sym_DASHlt] = ACTIONS(779),
    [anon_sym_DASHmatch] = ACTIONS(779),
    [anon_sym_DASHne] = ACTIONS(779),
    [anon_sym_DASHnotcontains] = ACTIONS(779),
    [anon_sym_DASHnotin] = ACTIONS(779),
    [anon_sym_DASHnotlike] = ACTIONS(779),
    [anon_sym_DASHnotmatch] = ACTIONS(779),
    [anon_sym_DASHreplace] = ACTIONS(779),
    [anon_sym_DASHshl] = ACTIONS(779),
    [anon_sym_DASHshr] = ACTIONS(779),
    [anon_sym_DASHsplit] = ACTIONS(779),
    [sym_format_operator] = ACTIONS(779),
    [anon_sym_COMMA] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(779),
    [anon_sym_PERCENT] = ACTIONS(781),
    [anon_sym_DASHand] = ACTIONS(779),
    [anon_sym_DASHor] = ACTIONS(779),
    [anon_sym_DASHxor] = ACTIONS(779),
    [anon_sym_DASHband] = ACTIONS(779),
    [anon_sym_DASHbor] = ACTIONS(779),
    [anon_sym_DASHbxor] = ACTIONS(779),
    [anon_sym_PLUS] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_SLASH] = ACTIONS(781),
    [anon_sym_BSLASH] = ACTIONS(779),
    [anon_sym_STAR] = ACTIONS(781),
    [anon_sym_DOT_DOT] = ACTIONS(779),
    [sym__statement_terminator] = ACTIONS(779),
  },
  [171] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_BANG_EQ] = ACTIONS(717),
    [anon_sym_PLUS_EQ] = ACTIONS(717),
    [anon_sym_STAR_EQ] = ACTIONS(717),
    [anon_sym_SLASH_EQ] = ACTIONS(717),
    [anon_sym_PERCENT_EQ] = ACTIONS(717),
    [anon_sym_GT] = ACTIONS(719),
    [anon_sym_GT_GT] = ACTIONS(717),
    [anon_sym_2_GT] = ACTIONS(719),
    [anon_sym_2_GT_GT] = ACTIONS(717),
    [anon_sym_3_GT] = ACTIONS(719),
    [anon_sym_3_GT_GT] = ACTIONS(717),
    [anon_sym_4_GT] = ACTIONS(719),
    [anon_sym_4_GT_GT] = ACTIONS(717),
    [anon_sym_5_GT] = ACTIONS(719),
    [anon_sym_5_GT_GT] = ACTIONS(717),
    [anon_sym_6_GT] = ACTIONS(719),
    [anon_sym_6_GT_GT] = ACTIONS(717),
    [anon_sym_STAR_GT] = ACTIONS(719),
    [anon_sym_STAR_GT_GT] = ACTIONS(717),
    [anon_sym_LT] = ACTIONS(719),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(717),
    [anon_sym_2_GT_AMP1] = ACTIONS(717),
    [anon_sym_3_GT_AMP1] = ACTIONS(717),
    [anon_sym_4_GT_AMP1] = ACTIONS(717),
    [anon_sym_5_GT_AMP1] = ACTIONS(717),
    [anon_sym_6_GT_AMP1] = ACTIONS(717),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(717),
    [anon_sym_1_GT_AMP2] = ACTIONS(717),
    [anon_sym_3_GT_AMP2] = ACTIONS(717),
    [anon_sym_4_GT_AMP2] = ACTIONS(717),
    [anon_sym_5_GT_AMP2] = ACTIONS(717),
    [anon_sym_6_GT_AMP2] = ACTIONS(717),
    [anon_sym_DASHas] = ACTIONS(717),
    [anon_sym_DASHccontains] = ACTIONS(717),
    [anon_sym_DASHceq] = ACTIONS(717),
    [anon_sym_DASHcge] = ACTIONS(717),
    [anon_sym_DASHcgt] = ACTIONS(717),
    [anon_sym_DASHcle] = ACTIONS(717),
    [anon_sym_DASHclike] = ACTIONS(717),
    [anon_sym_DASHclt] = ACTIONS(717),
    [anon_sym_DASHcmatch] = ACTIONS(717),
    [anon_sym_DASHcne] = ACTIONS(717),
    [anon_sym_DASHcnotcontains] = ACTIONS(717),
    [anon_sym_DASHcnotlike] = ACTIONS(717),
    [anon_sym_DASHcnotmatch] = ACTIONS(717),
    [anon_sym_DASHcontains] = ACTIONS(717),
    [anon_sym_DASHcreplace] = ACTIONS(717),
    [anon_sym_DASHcsplit] = ACTIONS(717),
    [anon_sym_DASHeq] = ACTIONS(717),
    [anon_sym_DASHge] = ACTIONS(717),
    [anon_sym_DASHgt] = ACTIONS(717),
    [anon_sym_DASHicontains] = ACTIONS(717),
    [anon_sym_DASHieq] = ACTIONS(717),
    [anon_sym_DASHige] = ACTIONS(717),
    [anon_sym_DASHigt] = ACTIONS(717),
    [anon_sym_DASHile] = ACTIONS(717),
    [anon_sym_DASHilike] = ACTIONS(717),
    [anon_sym_DASHilt] = ACTIONS(717),
    [anon_sym_DASHimatch] = ACTIONS(717),
    [anon_sym_DASHin] = ACTIONS(719),
    [anon_sym_DASHine] = ACTIONS(717),
    [anon_sym_DASHinotcontains] = ACTIONS(717),
    [anon_sym_DASHinotlike] = ACTIONS(717),
    [anon_sym_DASHinotmatch] = ACTIONS(717),
    [anon_sym_DASHireplace] = ACTIONS(717),
    [anon_sym_DASHis] = ACTIONS(719),
    [anon_sym_DASHisnot] = ACTIONS(717),
    [anon_sym_DASHisplit] = ACTIONS(717),
    [anon_sym_DASHjoin] = ACTIONS(717),
    [anon_sym_DASHle] = ACTIONS(717),
    [anon_sym_DASHlike] = ACTIONS(717),
    [anon_sym_DASHlt] = ACTIONS(717),
    [anon_sym_DASHmatch] = ACTIONS(717),
    [anon_sym_DASHne] = ACTIONS(717),
    [anon_sym_DASHnotcontains] = ACTIONS(717),
    [anon_sym_DASHnotin] = ACTIONS(717),
    [anon_sym_DASHnotlike] = ACTIONS(717),
    [anon_sym_DASHnotmatch] = ACTIONS(717),
    [anon_sym_DASHreplace] = ACTIONS(717),
    [anon_sym_DASHshl] = ACTIONS(717),
    [anon_sym_DASHshr] = ACTIONS(717),
    [anon_sym_DASHsplit] = ACTIONS(717),
    [sym_format_operator] = ACTIONS(717),
    [anon_sym_COMMA] = ACTIONS(717),
    [anon_sym_PIPE] = ACTIONS(717),
    [anon_sym_PERCENT] = ACTIONS(719),
    [anon_sym_DASHand] = ACTIONS(717),
    [anon_sym_DASHor] = ACTIONS(717),
    [anon_sym_DASHxor] = ACTIONS(717),
    [anon_sym_DASHband] = ACTIONS(717),
    [anon_sym_DASHbor] = ACTIONS(717),
    [anon_sym_DASHbxor] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_SLASH] = ACTIONS(719),
    [anon_sym_BSLASH] = ACTIONS(717),
    [anon_sym_STAR] = ACTIONS(719),
    [anon_sym_DOT_DOT] = ACTIONS(717),
    [sym__statement_terminator] = ACTIONS(717),
  },
  [172] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_PLUS_EQ] = ACTIONS(713),
    [anon_sym_STAR_EQ] = ACTIONS(713),
    [anon_sym_SLASH_EQ] = ACTIONS(713),
    [anon_sym_PERCENT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(713),
    [anon_sym_2_GT] = ACTIONS(715),
    [anon_sym_2_GT_GT] = ACTIONS(713),
    [anon_sym_3_GT] = ACTIONS(715),
    [anon_sym_3_GT_GT] = ACTIONS(713),
    [anon_sym_4_GT] = ACTIONS(715),
    [anon_sym_4_GT_GT] = ACTIONS(713),
    [anon_sym_5_GT] = ACTIONS(715),
    [anon_sym_5_GT_GT] = ACTIONS(713),
    [anon_sym_6_GT] = ACTIONS(715),
    [anon_sym_6_GT_GT] = ACTIONS(713),
    [anon_sym_STAR_GT] = ACTIONS(715),
    [anon_sym_STAR_GT_GT] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(713),
    [anon_sym_2_GT_AMP1] = ACTIONS(713),
    [anon_sym_3_GT_AMP1] = ACTIONS(713),
    [anon_sym_4_GT_AMP1] = ACTIONS(713),
    [anon_sym_5_GT_AMP1] = ACTIONS(713),
    [anon_sym_6_GT_AMP1] = ACTIONS(713),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(713),
    [anon_sym_1_GT_AMP2] = ACTIONS(713),
    [anon_sym_3_GT_AMP2] = ACTIONS(713),
    [anon_sym_4_GT_AMP2] = ACTIONS(713),
    [anon_sym_5_GT_AMP2] = ACTIONS(713),
    [anon_sym_6_GT_AMP2] = ACTIONS(713),
    [anon_sym_DASHas] = ACTIONS(713),
    [anon_sym_DASHccontains] = ACTIONS(713),
    [anon_sym_DASHceq] = ACTIONS(713),
    [anon_sym_DASHcge] = ACTIONS(713),
    [anon_sym_DASHcgt] = ACTIONS(713),
    [anon_sym_DASHcle] = ACTIONS(713),
    [anon_sym_DASHclike] = ACTIONS(713),
    [anon_sym_DASHclt] = ACTIONS(713),
    [anon_sym_DASHcmatch] = ACTIONS(713),
    [anon_sym_DASHcne] = ACTIONS(713),
    [anon_sym_DASHcnotcontains] = ACTIONS(713),
    [anon_sym_DASHcnotlike] = ACTIONS(713),
    [anon_sym_DASHcnotmatch] = ACTIONS(713),
    [anon_sym_DASHcontains] = ACTIONS(713),
    [anon_sym_DASHcreplace] = ACTIONS(713),
    [anon_sym_DASHcsplit] = ACTIONS(713),
    [anon_sym_DASHeq] = ACTIONS(713),
    [anon_sym_DASHge] = ACTIONS(713),
    [anon_sym_DASHgt] = ACTIONS(713),
    [anon_sym_DASHicontains] = ACTIONS(713),
    [anon_sym_DASHieq] = ACTIONS(713),
    [anon_sym_DASHige] = ACTIONS(713),
    [anon_sym_DASHigt] = ACTIONS(713),
    [anon_sym_DASHile] = ACTIONS(713),
    [anon_sym_DASHilike] = ACTIONS(713),
    [anon_sym_DASHilt] = ACTIONS(713),
    [anon_sym_DASHimatch] = ACTIONS(713),
    [anon_sym_DASHin] = ACTIONS(715),
    [anon_sym_DASHine] = ACTIONS(713),
    [anon_sym_DASHinotcontains] = ACTIONS(713),
    [anon_sym_DASHinotlike] = ACTIONS(713),
    [anon_sym_DASHinotmatch] = ACTIONS(713),
    [anon_sym_DASHireplace] = ACTIONS(713),
    [anon_sym_DASHis] = ACTIONS(715),
    [anon_sym_DASHisnot] = ACTIONS(713),
    [anon_sym_DASHisplit] = ACTIONS(713),
    [anon_sym_DASHjoin] = ACTIONS(713),
    [anon_sym_DASHle] = ACTIONS(713),
    [anon_sym_DASHlike] = ACTIONS(713),
    [anon_sym_DASHlt] = ACTIONS(713),
    [anon_sym_DASHmatch] = ACTIONS(713),
    [anon_sym_DASHne] = ACTIONS(713),
    [anon_sym_DASHnotcontains] = ACTIONS(713),
    [anon_sym_DASHnotin] = ACTIONS(713),
    [anon_sym_DASHnotlike] = ACTIONS(713),
    [anon_sym_DASHnotmatch] = ACTIONS(713),
    [anon_sym_DASHreplace] = ACTIONS(713),
    [anon_sym_DASHshl] = ACTIONS(713),
    [anon_sym_DASHshr] = ACTIONS(713),
    [anon_sym_DASHsplit] = ACTIONS(713),
    [sym_format_operator] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(713),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_DASHand] = ACTIONS(713),
    [anon_sym_DASHor] = ACTIONS(713),
    [anon_sym_DASHxor] = ACTIONS(713),
    [anon_sym_DASHband] = ACTIONS(713),
    [anon_sym_DASHbor] = ACTIONS(713),
    [anon_sym_DASHbxor] = ACTIONS(713),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_BSLASH] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_DOT_DOT] = ACTIONS(713),
    [sym__statement_terminator] = ACTIONS(713),
  },
  [173] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(765),
    [anon_sym_BANG_EQ] = ACTIONS(765),
    [anon_sym_PLUS_EQ] = ACTIONS(765),
    [anon_sym_STAR_EQ] = ACTIONS(765),
    [anon_sym_SLASH_EQ] = ACTIONS(765),
    [anon_sym_PERCENT_EQ] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(765),
    [anon_sym_2_GT] = ACTIONS(767),
    [anon_sym_2_GT_GT] = ACTIONS(765),
    [anon_sym_3_GT] = ACTIONS(767),
    [anon_sym_3_GT_GT] = ACTIONS(765),
    [anon_sym_4_GT] = ACTIONS(767),
    [anon_sym_4_GT_GT] = ACTIONS(765),
    [anon_sym_5_GT] = ACTIONS(767),
    [anon_sym_5_GT_GT] = ACTIONS(765),
    [anon_sym_6_GT] = ACTIONS(767),
    [anon_sym_6_GT_GT] = ACTIONS(765),
    [anon_sym_STAR_GT] = ACTIONS(767),
    [anon_sym_STAR_GT_GT] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(765),
    [anon_sym_2_GT_AMP1] = ACTIONS(765),
    [anon_sym_3_GT_AMP1] = ACTIONS(765),
    [anon_sym_4_GT_AMP1] = ACTIONS(765),
    [anon_sym_5_GT_AMP1] = ACTIONS(765),
    [anon_sym_6_GT_AMP1] = ACTIONS(765),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(765),
    [anon_sym_1_GT_AMP2] = ACTIONS(765),
    [anon_sym_3_GT_AMP2] = ACTIONS(765),
    [anon_sym_4_GT_AMP2] = ACTIONS(765),
    [anon_sym_5_GT_AMP2] = ACTIONS(765),
    [anon_sym_6_GT_AMP2] = ACTIONS(765),
    [anon_sym_DASHas] = ACTIONS(765),
    [anon_sym_DASHccontains] = ACTIONS(765),
    [anon_sym_DASHceq] = ACTIONS(765),
    [anon_sym_DASHcge] = ACTIONS(765),
    [anon_sym_DASHcgt] = ACTIONS(765),
    [anon_sym_DASHcle] = ACTIONS(765),
    [anon_sym_DASHclike] = ACTIONS(765),
    [anon_sym_DASHclt] = ACTIONS(765),
    [anon_sym_DASHcmatch] = ACTIONS(765),
    [anon_sym_DASHcne] = ACTIONS(765),
    [anon_sym_DASHcnotcontains] = ACTIONS(765),
    [anon_sym_DASHcnotlike] = ACTIONS(765),
    [anon_sym_DASHcnotmatch] = ACTIONS(765),
    [anon_sym_DASHcontains] = ACTIONS(765),
    [anon_sym_DASHcreplace] = ACTIONS(765),
    [anon_sym_DASHcsplit] = ACTIONS(765),
    [anon_sym_DASHeq] = ACTIONS(765),
    [anon_sym_DASHge] = ACTIONS(765),
    [anon_sym_DASHgt] = ACTIONS(765),
    [anon_sym_DASHicontains] = ACTIONS(765),
    [anon_sym_DASHieq] = ACTIONS(765),
    [anon_sym_DASHige] = ACTIONS(765),
    [anon_sym_DASHigt] = ACTIONS(765),
    [anon_sym_DASHile] = ACTIONS(765),
    [anon_sym_DASHilike] = ACTIONS(765),
    [anon_sym_DASHilt] = ACTIONS(765),
    [anon_sym_DASHimatch] = ACTIONS(765),
    [anon_sym_DASHin] = ACTIONS(767),
    [anon_sym_DASHine] = ACTIONS(765),
    [anon_sym_DASHinotcontains] = ACTIONS(765),
    [anon_sym_DASHinotlike] = ACTIONS(765),
    [anon_sym_DASHinotmatch] = ACTIONS(765),
    [anon_sym_DASHireplace] = ACTIONS(765),
    [anon_sym_DASHis] = ACTIONS(767),
    [anon_sym_DASHisnot] = ACTIONS(765),
    [anon_sym_DASHisplit] = ACTIONS(765),
    [anon_sym_DASHjoin] = ACTIONS(765),
    [anon_sym_DASHle] = ACTIONS(765),
    [anon_sym_DASHlike] = ACTIONS(765),
    [anon_sym_DASHlt] = ACTIONS(765),
    [anon_sym_DASHmatch] = ACTIONS(765),
    [anon_sym_DASHne] = ACTIONS(765),
    [anon_sym_DASHnotcontains] = ACTIONS(765),
    [anon_sym_DASHnotin] = ACTIONS(765),
    [anon_sym_DASHnotlike] = ACTIONS(765),
    [anon_sym_DASHnotmatch] = ACTIONS(765),
    [anon_sym_DASHreplace] = ACTIONS(765),
    [anon_sym_DASHshl] = ACTIONS(765),
    [anon_sym_DASHshr] = ACTIONS(765),
    [anon_sym_DASHsplit] = ACTIONS(765),
    [sym_format_operator] = ACTIONS(765),
    [anon_sym_COMMA] = ACTIONS(765),
    [anon_sym_PIPE] = ACTIONS(765),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_DASHand] = ACTIONS(765),
    [anon_sym_DASHor] = ACTIONS(765),
    [anon_sym_DASHxor] = ACTIONS(765),
    [anon_sym_DASHband] = ACTIONS(765),
    [anon_sym_DASHbor] = ACTIONS(765),
    [anon_sym_DASHbxor] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_DOT_DOT] = ACTIONS(765),
    [sym__statement_terminator] = ACTIONS(765),
  },
  [174] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(729),
    [anon_sym_BANG_EQ] = ACTIONS(729),
    [anon_sym_PLUS_EQ] = ACTIONS(729),
    [anon_sym_STAR_EQ] = ACTIONS(729),
    [anon_sym_SLASH_EQ] = ACTIONS(729),
    [anon_sym_PERCENT_EQ] = ACTIONS(729),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(729),
    [anon_sym_2_GT] = ACTIONS(731),
    [anon_sym_2_GT_GT] = ACTIONS(729),
    [anon_sym_3_GT] = ACTIONS(731),
    [anon_sym_3_GT_GT] = ACTIONS(729),
    [anon_sym_4_GT] = ACTIONS(731),
    [anon_sym_4_GT_GT] = ACTIONS(729),
    [anon_sym_5_GT] = ACTIONS(731),
    [anon_sym_5_GT_GT] = ACTIONS(729),
    [anon_sym_6_GT] = ACTIONS(731),
    [anon_sym_6_GT_GT] = ACTIONS(729),
    [anon_sym_STAR_GT] = ACTIONS(731),
    [anon_sym_STAR_GT_GT] = ACTIONS(729),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(729),
    [anon_sym_2_GT_AMP1] = ACTIONS(729),
    [anon_sym_3_GT_AMP1] = ACTIONS(729),
    [anon_sym_4_GT_AMP1] = ACTIONS(729),
    [anon_sym_5_GT_AMP1] = ACTIONS(729),
    [anon_sym_6_GT_AMP1] = ACTIONS(729),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(729),
    [anon_sym_1_GT_AMP2] = ACTIONS(729),
    [anon_sym_3_GT_AMP2] = ACTIONS(729),
    [anon_sym_4_GT_AMP2] = ACTIONS(729),
    [anon_sym_5_GT_AMP2] = ACTIONS(729),
    [anon_sym_6_GT_AMP2] = ACTIONS(729),
    [anon_sym_DASHas] = ACTIONS(729),
    [anon_sym_DASHccontains] = ACTIONS(729),
    [anon_sym_DASHceq] = ACTIONS(729),
    [anon_sym_DASHcge] = ACTIONS(729),
    [anon_sym_DASHcgt] = ACTIONS(729),
    [anon_sym_DASHcle] = ACTIONS(729),
    [anon_sym_DASHclike] = ACTIONS(729),
    [anon_sym_DASHclt] = ACTIONS(729),
    [anon_sym_DASHcmatch] = ACTIONS(729),
    [anon_sym_DASHcne] = ACTIONS(729),
    [anon_sym_DASHcnotcontains] = ACTIONS(729),
    [anon_sym_DASHcnotlike] = ACTIONS(729),
    [anon_sym_DASHcnotmatch] = ACTIONS(729),
    [anon_sym_DASHcontains] = ACTIONS(729),
    [anon_sym_DASHcreplace] = ACTIONS(729),
    [anon_sym_DASHcsplit] = ACTIONS(729),
    [anon_sym_DASHeq] = ACTIONS(729),
    [anon_sym_DASHge] = ACTIONS(729),
    [anon_sym_DASHgt] = ACTIONS(729),
    [anon_sym_DASHicontains] = ACTIONS(729),
    [anon_sym_DASHieq] = ACTIONS(729),
    [anon_sym_DASHige] = ACTIONS(729),
    [anon_sym_DASHigt] = ACTIONS(729),
    [anon_sym_DASHile] = ACTIONS(729),
    [anon_sym_DASHilike] = ACTIONS(729),
    [anon_sym_DASHilt] = ACTIONS(729),
    [anon_sym_DASHimatch] = ACTIONS(729),
    [anon_sym_DASHin] = ACTIONS(731),
    [anon_sym_DASHine] = ACTIONS(729),
    [anon_sym_DASHinotcontains] = ACTIONS(729),
    [anon_sym_DASHinotlike] = ACTIONS(729),
    [anon_sym_DASHinotmatch] = ACTIONS(729),
    [anon_sym_DASHireplace] = ACTIONS(729),
    [anon_sym_DASHis] = ACTIONS(731),
    [anon_sym_DASHisnot] = ACTIONS(729),
    [anon_sym_DASHisplit] = ACTIONS(729),
    [anon_sym_DASHjoin] = ACTIONS(729),
    [anon_sym_DASHle] = ACTIONS(729),
    [anon_sym_DASHlike] = ACTIONS(729),
    [anon_sym_DASHlt] = ACTIONS(729),
    [anon_sym_DASHmatch] = ACTIONS(729),
    [anon_sym_DASHne] = ACTIONS(729),
    [anon_sym_DASHnotcontains] = ACTIONS(729),
    [anon_sym_DASHnotin] = ACTIONS(729),
    [anon_sym_DASHnotlike] = ACTIONS(729),
    [anon_sym_DASHnotmatch] = ACTIONS(729),
    [anon_sym_DASHreplace] = ACTIONS(729),
    [anon_sym_DASHshl] = ACTIONS(729),
    [anon_sym_DASHshr] = ACTIONS(729),
    [anon_sym_DASHsplit] = ACTIONS(729),
    [sym_format_operator] = ACTIONS(729),
    [anon_sym_COMMA] = ACTIONS(729),
    [anon_sym_PIPE] = ACTIONS(729),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_DASHand] = ACTIONS(729),
    [anon_sym_DASHor] = ACTIONS(729),
    [anon_sym_DASHxor] = ACTIONS(729),
    [anon_sym_DASHband] = ACTIONS(729),
    [anon_sym_DASHbor] = ACTIONS(729),
    [anon_sym_DASHbxor] = ACTIONS(729),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(731),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_BSLASH] = ACTIONS(729),
    [anon_sym_STAR] = ACTIONS(731),
    [anon_sym_DOT_DOT] = ACTIONS(729),
    [sym__statement_terminator] = ACTIONS(729),
  },
  [175] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(773),
    [anon_sym_BANG_EQ] = ACTIONS(773),
    [anon_sym_PLUS_EQ] = ACTIONS(773),
    [anon_sym_STAR_EQ] = ACTIONS(773),
    [anon_sym_SLASH_EQ] = ACTIONS(773),
    [anon_sym_PERCENT_EQ] = ACTIONS(773),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(773),
    [anon_sym_2_GT] = ACTIONS(775),
    [anon_sym_2_GT_GT] = ACTIONS(773),
    [anon_sym_3_GT] = ACTIONS(775),
    [anon_sym_3_GT_GT] = ACTIONS(773),
    [anon_sym_4_GT] = ACTIONS(775),
    [anon_sym_4_GT_GT] = ACTIONS(773),
    [anon_sym_5_GT] = ACTIONS(775),
    [anon_sym_5_GT_GT] = ACTIONS(773),
    [anon_sym_6_GT] = ACTIONS(775),
    [anon_sym_6_GT_GT] = ACTIONS(773),
    [anon_sym_STAR_GT] = ACTIONS(775),
    [anon_sym_STAR_GT_GT] = ACTIONS(773),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(773),
    [anon_sym_2_GT_AMP1] = ACTIONS(773),
    [anon_sym_3_GT_AMP1] = ACTIONS(773),
    [anon_sym_4_GT_AMP1] = ACTIONS(773),
    [anon_sym_5_GT_AMP1] = ACTIONS(773),
    [anon_sym_6_GT_AMP1] = ACTIONS(773),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(773),
    [anon_sym_1_GT_AMP2] = ACTIONS(773),
    [anon_sym_3_GT_AMP2] = ACTIONS(773),
    [anon_sym_4_GT_AMP2] = ACTIONS(773),
    [anon_sym_5_GT_AMP2] = ACTIONS(773),
    [anon_sym_6_GT_AMP2] = ACTIONS(773),
    [anon_sym_DASHas] = ACTIONS(773),
    [anon_sym_DASHccontains] = ACTIONS(773),
    [anon_sym_DASHceq] = ACTIONS(773),
    [anon_sym_DASHcge] = ACTIONS(773),
    [anon_sym_DASHcgt] = ACTIONS(773),
    [anon_sym_DASHcle] = ACTIONS(773),
    [anon_sym_DASHclike] = ACTIONS(773),
    [anon_sym_DASHclt] = ACTIONS(773),
    [anon_sym_DASHcmatch] = ACTIONS(773),
    [anon_sym_DASHcne] = ACTIONS(773),
    [anon_sym_DASHcnotcontains] = ACTIONS(773),
    [anon_sym_DASHcnotlike] = ACTIONS(773),
    [anon_sym_DASHcnotmatch] = ACTIONS(773),
    [anon_sym_DASHcontains] = ACTIONS(773),
    [anon_sym_DASHcreplace] = ACTIONS(773),
    [anon_sym_DASHcsplit] = ACTIONS(773),
    [anon_sym_DASHeq] = ACTIONS(773),
    [anon_sym_DASHge] = ACTIONS(773),
    [anon_sym_DASHgt] = ACTIONS(773),
    [anon_sym_DASHicontains] = ACTIONS(773),
    [anon_sym_DASHieq] = ACTIONS(773),
    [anon_sym_DASHige] = ACTIONS(773),
    [anon_sym_DASHigt] = ACTIONS(773),
    [anon_sym_DASHile] = ACTIONS(773),
    [anon_sym_DASHilike] = ACTIONS(773),
    [anon_sym_DASHilt] = ACTIONS(773),
    [anon_sym_DASHimatch] = ACTIONS(773),
    [anon_sym_DASHin] = ACTIONS(775),
    [anon_sym_DASHine] = ACTIONS(773),
    [anon_sym_DASHinotcontains] = ACTIONS(773),
    [anon_sym_DASHinotlike] = ACTIONS(773),
    [anon_sym_DASHinotmatch] = ACTIONS(773),
    [anon_sym_DASHireplace] = ACTIONS(773),
    [anon_sym_DASHis] = ACTIONS(775),
    [anon_sym_DASHisnot] = ACTIONS(773),
    [anon_sym_DASHisplit] = ACTIONS(773),
    [anon_sym_DASHjoin] = ACTIONS(773),
    [anon_sym_DASHle] = ACTIONS(773),
    [anon_sym_DASHlike] = ACTIONS(773),
    [anon_sym_DASHlt] = ACTIONS(773),
    [anon_sym_DASHmatch] = ACTIONS(773),
    [anon_sym_DASHne] = ACTIONS(773),
    [anon_sym_DASHnotcontains] = ACTIONS(773),
    [anon_sym_DASHnotin] = ACTIONS(773),
    [anon_sym_DASHnotlike] = ACTIONS(773),
    [anon_sym_DASHnotmatch] = ACTIONS(773),
    [anon_sym_DASHreplace] = ACTIONS(773),
    [anon_sym_DASHshl] = ACTIONS(773),
    [anon_sym_DASHshr] = ACTIONS(773),
    [anon_sym_DASHsplit] = ACTIONS(773),
    [sym_format_operator] = ACTIONS(773),
    [anon_sym_COMMA] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_DASHand] = ACTIONS(773),
    [anon_sym_DASHor] = ACTIONS(773),
    [anon_sym_DASHxor] = ACTIONS(773),
    [anon_sym_DASHband] = ACTIONS(773),
    [anon_sym_DASHbor] = ACTIONS(773),
    [anon_sym_DASHbxor] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_STAR] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(773),
    [sym__statement_terminator] = ACTIONS(773),
  },
  [176] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(721),
    [anon_sym_BANG_EQ] = ACTIONS(721),
    [anon_sym_PLUS_EQ] = ACTIONS(721),
    [anon_sym_STAR_EQ] = ACTIONS(721),
    [anon_sym_SLASH_EQ] = ACTIONS(721),
    [anon_sym_PERCENT_EQ] = ACTIONS(721),
    [anon_sym_GT] = ACTIONS(723),
    [anon_sym_GT_GT] = ACTIONS(721),
    [anon_sym_2_GT] = ACTIONS(723),
    [anon_sym_2_GT_GT] = ACTIONS(721),
    [anon_sym_3_GT] = ACTIONS(723),
    [anon_sym_3_GT_GT] = ACTIONS(721),
    [anon_sym_4_GT] = ACTIONS(723),
    [anon_sym_4_GT_GT] = ACTIONS(721),
    [anon_sym_5_GT] = ACTIONS(723),
    [anon_sym_5_GT_GT] = ACTIONS(721),
    [anon_sym_6_GT] = ACTIONS(723),
    [anon_sym_6_GT_GT] = ACTIONS(721),
    [anon_sym_STAR_GT] = ACTIONS(723),
    [anon_sym_STAR_GT_GT] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(721),
    [anon_sym_2_GT_AMP1] = ACTIONS(721),
    [anon_sym_3_GT_AMP1] = ACTIONS(721),
    [anon_sym_4_GT_AMP1] = ACTIONS(721),
    [anon_sym_5_GT_AMP1] = ACTIONS(721),
    [anon_sym_6_GT_AMP1] = ACTIONS(721),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(721),
    [anon_sym_1_GT_AMP2] = ACTIONS(721),
    [anon_sym_3_GT_AMP2] = ACTIONS(721),
    [anon_sym_4_GT_AMP2] = ACTIONS(721),
    [anon_sym_5_GT_AMP2] = ACTIONS(721),
    [anon_sym_6_GT_AMP2] = ACTIONS(721),
    [anon_sym_DASHas] = ACTIONS(721),
    [anon_sym_DASHccontains] = ACTIONS(721),
    [anon_sym_DASHceq] = ACTIONS(721),
    [anon_sym_DASHcge] = ACTIONS(721),
    [anon_sym_DASHcgt] = ACTIONS(721),
    [anon_sym_DASHcle] = ACTIONS(721),
    [anon_sym_DASHclike] = ACTIONS(721),
    [anon_sym_DASHclt] = ACTIONS(721),
    [anon_sym_DASHcmatch] = ACTIONS(721),
    [anon_sym_DASHcne] = ACTIONS(721),
    [anon_sym_DASHcnotcontains] = ACTIONS(721),
    [anon_sym_DASHcnotlike] = ACTIONS(721),
    [anon_sym_DASHcnotmatch] = ACTIONS(721),
    [anon_sym_DASHcontains] = ACTIONS(721),
    [anon_sym_DASHcreplace] = ACTIONS(721),
    [anon_sym_DASHcsplit] = ACTIONS(721),
    [anon_sym_DASHeq] = ACTIONS(721),
    [anon_sym_DASHge] = ACTIONS(721),
    [anon_sym_DASHgt] = ACTIONS(721),
    [anon_sym_DASHicontains] = ACTIONS(721),
    [anon_sym_DASHieq] = ACTIONS(721),
    [anon_sym_DASHige] = ACTIONS(721),
    [anon_sym_DASHigt] = ACTIONS(721),
    [anon_sym_DASHile] = ACTIONS(721),
    [anon_sym_DASHilike] = ACTIONS(721),
    [anon_sym_DASHilt] = ACTIONS(721),
    [anon_sym_DASHimatch] = ACTIONS(721),
    [anon_sym_DASHin] = ACTIONS(723),
    [anon_sym_DASHine] = ACTIONS(721),
    [anon_sym_DASHinotcontains] = ACTIONS(721),
    [anon_sym_DASHinotlike] = ACTIONS(721),
    [anon_sym_DASHinotmatch] = ACTIONS(721),
    [anon_sym_DASHireplace] = ACTIONS(721),
    [anon_sym_DASHis] = ACTIONS(723),
    [anon_sym_DASHisnot] = ACTIONS(721),
    [anon_sym_DASHisplit] = ACTIONS(721),
    [anon_sym_DASHjoin] = ACTIONS(721),
    [anon_sym_DASHle] = ACTIONS(721),
    [anon_sym_DASHlike] = ACTIONS(721),
    [anon_sym_DASHlt] = ACTIONS(721),
    [anon_sym_DASHmatch] = ACTIONS(721),
    [anon_sym_DASHne] = ACTIONS(721),
    [anon_sym_DASHnotcontains] = ACTIONS(721),
    [anon_sym_DASHnotin] = ACTIONS(721),
    [anon_sym_DASHnotlike] = ACTIONS(721),
    [anon_sym_DASHnotmatch] = ACTIONS(721),
    [anon_sym_DASHreplace] = ACTIONS(721),
    [anon_sym_DASHshl] = ACTIONS(721),
    [anon_sym_DASHshr] = ACTIONS(721),
    [anon_sym_DASHsplit] = ACTIONS(721),
    [sym_format_operator] = ACTIONS(721),
    [anon_sym_COMMA] = ACTIONS(721),
    [anon_sym_PIPE] = ACTIONS(721),
    [anon_sym_PERCENT] = ACTIONS(723),
    [anon_sym_DASHand] = ACTIONS(721),
    [anon_sym_DASHor] = ACTIONS(721),
    [anon_sym_DASHxor] = ACTIONS(721),
    [anon_sym_DASHband] = ACTIONS(721),
    [anon_sym_DASHbor] = ACTIONS(721),
    [anon_sym_DASHbxor] = ACTIONS(721),
    [anon_sym_PLUS] = ACTIONS(723),
    [anon_sym_DASH] = ACTIONS(723),
    [anon_sym_SLASH] = ACTIONS(723),
    [anon_sym_BSLASH] = ACTIONS(721),
    [anon_sym_STAR] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(721),
    [sym__statement_terminator] = ACTIONS(721),
  },
  [177] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(785),
    [anon_sym_BANG_EQ] = ACTIONS(785),
    [anon_sym_PLUS_EQ] = ACTIONS(785),
    [anon_sym_STAR_EQ] = ACTIONS(785),
    [anon_sym_SLASH_EQ] = ACTIONS(785),
    [anon_sym_PERCENT_EQ] = ACTIONS(785),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_GT_GT] = ACTIONS(785),
    [anon_sym_2_GT] = ACTIONS(787),
    [anon_sym_2_GT_GT] = ACTIONS(785),
    [anon_sym_3_GT] = ACTIONS(787),
    [anon_sym_3_GT_GT] = ACTIONS(785),
    [anon_sym_4_GT] = ACTIONS(787),
    [anon_sym_4_GT_GT] = ACTIONS(785),
    [anon_sym_5_GT] = ACTIONS(787),
    [anon_sym_5_GT_GT] = ACTIONS(785),
    [anon_sym_6_GT] = ACTIONS(787),
    [anon_sym_6_GT_GT] = ACTIONS(785),
    [anon_sym_STAR_GT] = ACTIONS(787),
    [anon_sym_STAR_GT_GT] = ACTIONS(785),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(785),
    [anon_sym_2_GT_AMP1] = ACTIONS(785),
    [anon_sym_3_GT_AMP1] = ACTIONS(785),
    [anon_sym_4_GT_AMP1] = ACTIONS(785),
    [anon_sym_5_GT_AMP1] = ACTIONS(785),
    [anon_sym_6_GT_AMP1] = ACTIONS(785),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(785),
    [anon_sym_1_GT_AMP2] = ACTIONS(785),
    [anon_sym_3_GT_AMP2] = ACTIONS(785),
    [anon_sym_4_GT_AMP2] = ACTIONS(785),
    [anon_sym_5_GT_AMP2] = ACTIONS(785),
    [anon_sym_6_GT_AMP2] = ACTIONS(785),
    [anon_sym_DASHas] = ACTIONS(785),
    [anon_sym_DASHccontains] = ACTIONS(785),
    [anon_sym_DASHceq] = ACTIONS(785),
    [anon_sym_DASHcge] = ACTIONS(785),
    [anon_sym_DASHcgt] = ACTIONS(785),
    [anon_sym_DASHcle] = ACTIONS(785),
    [anon_sym_DASHclike] = ACTIONS(785),
    [anon_sym_DASHclt] = ACTIONS(785),
    [anon_sym_DASHcmatch] = ACTIONS(785),
    [anon_sym_DASHcne] = ACTIONS(785),
    [anon_sym_DASHcnotcontains] = ACTIONS(785),
    [anon_sym_DASHcnotlike] = ACTIONS(785),
    [anon_sym_DASHcnotmatch] = ACTIONS(785),
    [anon_sym_DASHcontains] = ACTIONS(785),
    [anon_sym_DASHcreplace] = ACTIONS(785),
    [anon_sym_DASHcsplit] = ACTIONS(785),
    [anon_sym_DASHeq] = ACTIONS(785),
    [anon_sym_DASHge] = ACTIONS(785),
    [anon_sym_DASHgt] = ACTIONS(785),
    [anon_sym_DASHicontains] = ACTIONS(785),
    [anon_sym_DASHieq] = ACTIONS(785),
    [anon_sym_DASHige] = ACTIONS(785),
    [anon_sym_DASHigt] = ACTIONS(785),
    [anon_sym_DASHile] = ACTIONS(785),
    [anon_sym_DASHilike] = ACTIONS(785),
    [anon_sym_DASHilt] = ACTIONS(785),
    [anon_sym_DASHimatch] = ACTIONS(785),
    [anon_sym_DASHin] = ACTIONS(787),
    [anon_sym_DASHine] = ACTIONS(785),
    [anon_sym_DASHinotcontains] = ACTIONS(785),
    [anon_sym_DASHinotlike] = ACTIONS(785),
    [anon_sym_DASHinotmatch] = ACTIONS(785),
    [anon_sym_DASHireplace] = ACTIONS(785),
    [anon_sym_DASHis] = ACTIONS(787),
    [anon_sym_DASHisnot] = ACTIONS(785),
    [anon_sym_DASHisplit] = ACTIONS(785),
    [anon_sym_DASHjoin] = ACTIONS(785),
    [anon_sym_DASHle] = ACTIONS(785),
    [anon_sym_DASHlike] = ACTIONS(785),
    [anon_sym_DASHlt] = ACTIONS(785),
    [anon_sym_DASHmatch] = ACTIONS(785),
    [anon_sym_DASHne] = ACTIONS(785),
    [anon_sym_DASHnotcontains] = ACTIONS(785),
    [anon_sym_DASHnotin] = ACTIONS(785),
    [anon_sym_DASHnotlike] = ACTIONS(785),
    [anon_sym_DASHnotmatch] = ACTIONS(785),
    [anon_sym_DASHreplace] = ACTIONS(785),
    [anon_sym_DASHshl] = ACTIONS(785),
    [anon_sym_DASHshr] = ACTIONS(785),
    [anon_sym_DASHsplit] = ACTIONS(785),
    [sym_format_operator] = ACTIONS(785),
    [anon_sym_RPAREN] = ACTIONS(785),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PERCENT] = ACTIONS(787),
    [anon_sym_DASHand] = ACTIONS(785),
    [anon_sym_DASHor] = ACTIONS(785),
    [anon_sym_DASHxor] = ACTIONS(785),
    [anon_sym_DASHband] = ACTIONS(785),
    [anon_sym_DASHbor] = ACTIONS(785),
    [anon_sym_DASHbxor] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(787),
    [anon_sym_BSLASH] = ACTIONS(785),
    [anon_sym_STAR] = ACTIONS(787),
    [anon_sym_DOT_DOT] = ACTIONS(789),
  },
  [178] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(791),
    [anon_sym_BANG_EQ] = ACTIONS(791),
    [anon_sym_PLUS_EQ] = ACTIONS(791),
    [anon_sym_STAR_EQ] = ACTIONS(791),
    [anon_sym_SLASH_EQ] = ACTIONS(791),
    [anon_sym_PERCENT_EQ] = ACTIONS(791),
    [anon_sym_GT] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_2_GT] = ACTIONS(793),
    [anon_sym_2_GT_GT] = ACTIONS(791),
    [anon_sym_3_GT] = ACTIONS(793),
    [anon_sym_3_GT_GT] = ACTIONS(791),
    [anon_sym_4_GT] = ACTIONS(793),
    [anon_sym_4_GT_GT] = ACTIONS(791),
    [anon_sym_5_GT] = ACTIONS(793),
    [anon_sym_5_GT_GT] = ACTIONS(791),
    [anon_sym_6_GT] = ACTIONS(793),
    [anon_sym_6_GT_GT] = ACTIONS(791),
    [anon_sym_STAR_GT] = ACTIONS(793),
    [anon_sym_STAR_GT_GT] = ACTIONS(791),
    [anon_sym_LT] = ACTIONS(793),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(791),
    [anon_sym_2_GT_AMP1] = ACTIONS(791),
    [anon_sym_3_GT_AMP1] = ACTIONS(791),
    [anon_sym_4_GT_AMP1] = ACTIONS(791),
    [anon_sym_5_GT_AMP1] = ACTIONS(791),
    [anon_sym_6_GT_AMP1] = ACTIONS(791),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(791),
    [anon_sym_1_GT_AMP2] = ACTIONS(791),
    [anon_sym_3_GT_AMP2] = ACTIONS(791),
    [anon_sym_4_GT_AMP2] = ACTIONS(791),
    [anon_sym_5_GT_AMP2] = ACTIONS(791),
    [anon_sym_6_GT_AMP2] = ACTIONS(791),
    [anon_sym_DASHas] = ACTIONS(791),
    [anon_sym_DASHccontains] = ACTIONS(791),
    [anon_sym_DASHceq] = ACTIONS(791),
    [anon_sym_DASHcge] = ACTIONS(791),
    [anon_sym_DASHcgt] = ACTIONS(791),
    [anon_sym_DASHcle] = ACTIONS(791),
    [anon_sym_DASHclike] = ACTIONS(791),
    [anon_sym_DASHclt] = ACTIONS(791),
    [anon_sym_DASHcmatch] = ACTIONS(791),
    [anon_sym_DASHcne] = ACTIONS(791),
    [anon_sym_DASHcnotcontains] = ACTIONS(791),
    [anon_sym_DASHcnotlike] = ACTIONS(791),
    [anon_sym_DASHcnotmatch] = ACTIONS(791),
    [anon_sym_DASHcontains] = ACTIONS(791),
    [anon_sym_DASHcreplace] = ACTIONS(791),
    [anon_sym_DASHcsplit] = ACTIONS(791),
    [anon_sym_DASHeq] = ACTIONS(791),
    [anon_sym_DASHge] = ACTIONS(791),
    [anon_sym_DASHgt] = ACTIONS(791),
    [anon_sym_DASHicontains] = ACTIONS(791),
    [anon_sym_DASHieq] = ACTIONS(791),
    [anon_sym_DASHige] = ACTIONS(791),
    [anon_sym_DASHigt] = ACTIONS(791),
    [anon_sym_DASHile] = ACTIONS(791),
    [anon_sym_DASHilike] = ACTIONS(791),
    [anon_sym_DASHilt] = ACTIONS(791),
    [anon_sym_DASHimatch] = ACTIONS(791),
    [anon_sym_DASHin] = ACTIONS(793),
    [anon_sym_DASHine] = ACTIONS(791),
    [anon_sym_DASHinotcontains] = ACTIONS(791),
    [anon_sym_DASHinotlike] = ACTIONS(791),
    [anon_sym_DASHinotmatch] = ACTIONS(791),
    [anon_sym_DASHireplace] = ACTIONS(791),
    [anon_sym_DASHis] = ACTIONS(793),
    [anon_sym_DASHisnot] = ACTIONS(791),
    [anon_sym_DASHisplit] = ACTIONS(791),
    [anon_sym_DASHjoin] = ACTIONS(791),
    [anon_sym_DASHle] = ACTIONS(791),
    [anon_sym_DASHlike] = ACTIONS(791),
    [anon_sym_DASHlt] = ACTIONS(791),
    [anon_sym_DASHmatch] = ACTIONS(791),
    [anon_sym_DASHne] = ACTIONS(791),
    [anon_sym_DASHnotcontains] = ACTIONS(791),
    [anon_sym_DASHnotin] = ACTIONS(791),
    [anon_sym_DASHnotlike] = ACTIONS(791),
    [anon_sym_DASHnotmatch] = ACTIONS(791),
    [anon_sym_DASHreplace] = ACTIONS(791),
    [anon_sym_DASHshl] = ACTIONS(791),
    [anon_sym_DASHshr] = ACTIONS(791),
    [anon_sym_DASHsplit] = ACTIONS(791),
    [sym_format_operator] = ACTIONS(791),
    [anon_sym_RPAREN] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(793),
    [anon_sym_DASHand] = ACTIONS(791),
    [anon_sym_DASHor] = ACTIONS(791),
    [anon_sym_DASHxor] = ACTIONS(791),
    [anon_sym_DASHband] = ACTIONS(791),
    [anon_sym_DASHbor] = ACTIONS(791),
    [anon_sym_DASHbxor] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(793),
    [anon_sym_DASH] = ACTIONS(793),
    [anon_sym_SLASH] = ACTIONS(793),
    [anon_sym_BSLASH] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(793),
    [anon_sym_DOT_DOT] = ACTIONS(789),
  },
  [179] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(785),
    [anon_sym_BANG_EQ] = ACTIONS(785),
    [anon_sym_PLUS_EQ] = ACTIONS(785),
    [anon_sym_STAR_EQ] = ACTIONS(785),
    [anon_sym_SLASH_EQ] = ACTIONS(785),
    [anon_sym_PERCENT_EQ] = ACTIONS(785),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_GT_GT] = ACTIONS(785),
    [anon_sym_2_GT] = ACTIONS(787),
    [anon_sym_2_GT_GT] = ACTIONS(785),
    [anon_sym_3_GT] = ACTIONS(787),
    [anon_sym_3_GT_GT] = ACTIONS(785),
    [anon_sym_4_GT] = ACTIONS(787),
    [anon_sym_4_GT_GT] = ACTIONS(785),
    [anon_sym_5_GT] = ACTIONS(787),
    [anon_sym_5_GT_GT] = ACTIONS(785),
    [anon_sym_6_GT] = ACTIONS(787),
    [anon_sym_6_GT_GT] = ACTIONS(785),
    [anon_sym_STAR_GT] = ACTIONS(787),
    [anon_sym_STAR_GT_GT] = ACTIONS(785),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(785),
    [anon_sym_2_GT_AMP1] = ACTIONS(785),
    [anon_sym_3_GT_AMP1] = ACTIONS(785),
    [anon_sym_4_GT_AMP1] = ACTIONS(785),
    [anon_sym_5_GT_AMP1] = ACTIONS(785),
    [anon_sym_6_GT_AMP1] = ACTIONS(785),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(785),
    [anon_sym_1_GT_AMP2] = ACTIONS(785),
    [anon_sym_3_GT_AMP2] = ACTIONS(785),
    [anon_sym_4_GT_AMP2] = ACTIONS(785),
    [anon_sym_5_GT_AMP2] = ACTIONS(785),
    [anon_sym_6_GT_AMP2] = ACTIONS(785),
    [anon_sym_DASHas] = ACTIONS(785),
    [anon_sym_DASHccontains] = ACTIONS(785),
    [anon_sym_DASHceq] = ACTIONS(785),
    [anon_sym_DASHcge] = ACTIONS(785),
    [anon_sym_DASHcgt] = ACTIONS(785),
    [anon_sym_DASHcle] = ACTIONS(785),
    [anon_sym_DASHclike] = ACTIONS(785),
    [anon_sym_DASHclt] = ACTIONS(785),
    [anon_sym_DASHcmatch] = ACTIONS(785),
    [anon_sym_DASHcne] = ACTIONS(785),
    [anon_sym_DASHcnotcontains] = ACTIONS(785),
    [anon_sym_DASHcnotlike] = ACTIONS(785),
    [anon_sym_DASHcnotmatch] = ACTIONS(785),
    [anon_sym_DASHcontains] = ACTIONS(785),
    [anon_sym_DASHcreplace] = ACTIONS(785),
    [anon_sym_DASHcsplit] = ACTIONS(785),
    [anon_sym_DASHeq] = ACTIONS(785),
    [anon_sym_DASHge] = ACTIONS(785),
    [anon_sym_DASHgt] = ACTIONS(785),
    [anon_sym_DASHicontains] = ACTIONS(785),
    [anon_sym_DASHieq] = ACTIONS(785),
    [anon_sym_DASHige] = ACTIONS(785),
    [anon_sym_DASHigt] = ACTIONS(785),
    [anon_sym_DASHile] = ACTIONS(785),
    [anon_sym_DASHilike] = ACTIONS(785),
    [anon_sym_DASHilt] = ACTIONS(785),
    [anon_sym_DASHimatch] = ACTIONS(785),
    [anon_sym_DASHin] = ACTIONS(787),
    [anon_sym_DASHine] = ACTIONS(785),
    [anon_sym_DASHinotcontains] = ACTIONS(785),
    [anon_sym_DASHinotlike] = ACTIONS(785),
    [anon_sym_DASHinotmatch] = ACTIONS(785),
    [anon_sym_DASHireplace] = ACTIONS(785),
    [anon_sym_DASHis] = ACTIONS(787),
    [anon_sym_DASHisnot] = ACTIONS(785),
    [anon_sym_DASHisplit] = ACTIONS(785),
    [anon_sym_DASHjoin] = ACTIONS(785),
    [anon_sym_DASHle] = ACTIONS(785),
    [anon_sym_DASHlike] = ACTIONS(785),
    [anon_sym_DASHlt] = ACTIONS(785),
    [anon_sym_DASHmatch] = ACTIONS(785),
    [anon_sym_DASHne] = ACTIONS(785),
    [anon_sym_DASHnotcontains] = ACTIONS(785),
    [anon_sym_DASHnotin] = ACTIONS(785),
    [anon_sym_DASHnotlike] = ACTIONS(785),
    [anon_sym_DASHnotmatch] = ACTIONS(785),
    [anon_sym_DASHreplace] = ACTIONS(785),
    [anon_sym_DASHshl] = ACTIONS(785),
    [anon_sym_DASHshr] = ACTIONS(785),
    [anon_sym_DASHsplit] = ACTIONS(785),
    [sym_format_operator] = ACTIONS(785),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PERCENT] = ACTIONS(787),
    [anon_sym_DASHand] = ACTIONS(785),
    [anon_sym_DASHor] = ACTIONS(785),
    [anon_sym_DASHxor] = ACTIONS(785),
    [anon_sym_DASHband] = ACTIONS(785),
    [anon_sym_DASHbor] = ACTIONS(785),
    [anon_sym_DASHbxor] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(787),
    [anon_sym_BSLASH] = ACTIONS(785),
    [anon_sym_STAR] = ACTIONS(787),
    [anon_sym_DOT_DOT] = ACTIONS(795),
    [sym__statement_terminator] = ACTIONS(785),
  },
  [180] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(791),
    [anon_sym_BANG_EQ] = ACTIONS(791),
    [anon_sym_PLUS_EQ] = ACTIONS(791),
    [anon_sym_STAR_EQ] = ACTIONS(791),
    [anon_sym_SLASH_EQ] = ACTIONS(791),
    [anon_sym_PERCENT_EQ] = ACTIONS(791),
    [anon_sym_GT] = ACTIONS(793),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_2_GT] = ACTIONS(793),
    [anon_sym_2_GT_GT] = ACTIONS(791),
    [anon_sym_3_GT] = ACTIONS(793),
    [anon_sym_3_GT_GT] = ACTIONS(791),
    [anon_sym_4_GT] = ACTIONS(793),
    [anon_sym_4_GT_GT] = ACTIONS(791),
    [anon_sym_5_GT] = ACTIONS(793),
    [anon_sym_5_GT_GT] = ACTIONS(791),
    [anon_sym_6_GT] = ACTIONS(793),
    [anon_sym_6_GT_GT] = ACTIONS(791),
    [anon_sym_STAR_GT] = ACTIONS(793),
    [anon_sym_STAR_GT_GT] = ACTIONS(791),
    [anon_sym_LT] = ACTIONS(793),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(791),
    [anon_sym_2_GT_AMP1] = ACTIONS(791),
    [anon_sym_3_GT_AMP1] = ACTIONS(791),
    [anon_sym_4_GT_AMP1] = ACTIONS(791),
    [anon_sym_5_GT_AMP1] = ACTIONS(791),
    [anon_sym_6_GT_AMP1] = ACTIONS(791),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(791),
    [anon_sym_1_GT_AMP2] = ACTIONS(791),
    [anon_sym_3_GT_AMP2] = ACTIONS(791),
    [anon_sym_4_GT_AMP2] = ACTIONS(791),
    [anon_sym_5_GT_AMP2] = ACTIONS(791),
    [anon_sym_6_GT_AMP2] = ACTIONS(791),
    [anon_sym_DASHas] = ACTIONS(791),
    [anon_sym_DASHccontains] = ACTIONS(791),
    [anon_sym_DASHceq] = ACTIONS(791),
    [anon_sym_DASHcge] = ACTIONS(791),
    [anon_sym_DASHcgt] = ACTIONS(791),
    [anon_sym_DASHcle] = ACTIONS(791),
    [anon_sym_DASHclike] = ACTIONS(791),
    [anon_sym_DASHclt] = ACTIONS(791),
    [anon_sym_DASHcmatch] = ACTIONS(791),
    [anon_sym_DASHcne] = ACTIONS(791),
    [anon_sym_DASHcnotcontains] = ACTIONS(791),
    [anon_sym_DASHcnotlike] = ACTIONS(791),
    [anon_sym_DASHcnotmatch] = ACTIONS(791),
    [anon_sym_DASHcontains] = ACTIONS(791),
    [anon_sym_DASHcreplace] = ACTIONS(791),
    [anon_sym_DASHcsplit] = ACTIONS(791),
    [anon_sym_DASHeq] = ACTIONS(791),
    [anon_sym_DASHge] = ACTIONS(791),
    [anon_sym_DASHgt] = ACTIONS(791),
    [anon_sym_DASHicontains] = ACTIONS(791),
    [anon_sym_DASHieq] = ACTIONS(791),
    [anon_sym_DASHige] = ACTIONS(791),
    [anon_sym_DASHigt] = ACTIONS(791),
    [anon_sym_DASHile] = ACTIONS(791),
    [anon_sym_DASHilike] = ACTIONS(791),
    [anon_sym_DASHilt] = ACTIONS(791),
    [anon_sym_DASHimatch] = ACTIONS(791),
    [anon_sym_DASHin] = ACTIONS(793),
    [anon_sym_DASHine] = ACTIONS(791),
    [anon_sym_DASHinotcontains] = ACTIONS(791),
    [anon_sym_DASHinotlike] = ACTIONS(791),
    [anon_sym_DASHinotmatch] = ACTIONS(791),
    [anon_sym_DASHireplace] = ACTIONS(791),
    [anon_sym_DASHis] = ACTIONS(793),
    [anon_sym_DASHisnot] = ACTIONS(791),
    [anon_sym_DASHisplit] = ACTIONS(791),
    [anon_sym_DASHjoin] = ACTIONS(791),
    [anon_sym_DASHle] = ACTIONS(791),
    [anon_sym_DASHlike] = ACTIONS(791),
    [anon_sym_DASHlt] = ACTIONS(791),
    [anon_sym_DASHmatch] = ACTIONS(791),
    [anon_sym_DASHne] = ACTIONS(791),
    [anon_sym_DASHnotcontains] = ACTIONS(791),
    [anon_sym_DASHnotin] = ACTIONS(791),
    [anon_sym_DASHnotlike] = ACTIONS(791),
    [anon_sym_DASHnotmatch] = ACTIONS(791),
    [anon_sym_DASHreplace] = ACTIONS(791),
    [anon_sym_DASHshl] = ACTIONS(791),
    [anon_sym_DASHshr] = ACTIONS(791),
    [anon_sym_DASHsplit] = ACTIONS(791),
    [sym_format_operator] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(793),
    [anon_sym_DASHand] = ACTIONS(791),
    [anon_sym_DASHor] = ACTIONS(791),
    [anon_sym_DASHxor] = ACTIONS(791),
    [anon_sym_DASHband] = ACTIONS(791),
    [anon_sym_DASHbor] = ACTIONS(791),
    [anon_sym_DASHbxor] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(793),
    [anon_sym_DASH] = ACTIONS(793),
    [anon_sym_SLASH] = ACTIONS(793),
    [anon_sym_BSLASH] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(793),
    [anon_sym_DOT_DOT] = ACTIONS(795),
    [sym__statement_terminator] = ACTIONS(791),
  },
  [181] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_BANG_EQ] = ACTIONS(797),
    [anon_sym_PLUS_EQ] = ACTIONS(797),
    [anon_sym_STAR_EQ] = ACTIONS(797),
    [anon_sym_SLASH_EQ] = ACTIONS(797),
    [anon_sym_PERCENT_EQ] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(799),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_2_GT] = ACTIONS(799),
    [anon_sym_2_GT_GT] = ACTIONS(797),
    [anon_sym_3_GT] = ACTIONS(799),
    [anon_sym_3_GT_GT] = ACTIONS(797),
    [anon_sym_4_GT] = ACTIONS(799),
    [anon_sym_4_GT_GT] = ACTIONS(797),
    [anon_sym_5_GT] = ACTIONS(799),
    [anon_sym_5_GT_GT] = ACTIONS(797),
    [anon_sym_6_GT] = ACTIONS(799),
    [anon_sym_6_GT_GT] = ACTIONS(797),
    [anon_sym_STAR_GT] = ACTIONS(799),
    [anon_sym_STAR_GT_GT] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(797),
    [anon_sym_2_GT_AMP1] = ACTIONS(797),
    [anon_sym_3_GT_AMP1] = ACTIONS(797),
    [anon_sym_4_GT_AMP1] = ACTIONS(797),
    [anon_sym_5_GT_AMP1] = ACTIONS(797),
    [anon_sym_6_GT_AMP1] = ACTIONS(797),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(797),
    [anon_sym_1_GT_AMP2] = ACTIONS(797),
    [anon_sym_3_GT_AMP2] = ACTIONS(797),
    [anon_sym_4_GT_AMP2] = ACTIONS(797),
    [anon_sym_5_GT_AMP2] = ACTIONS(797),
    [anon_sym_6_GT_AMP2] = ACTIONS(797),
    [anon_sym_DASHas] = ACTIONS(797),
    [anon_sym_DASHccontains] = ACTIONS(797),
    [anon_sym_DASHceq] = ACTIONS(797),
    [anon_sym_DASHcge] = ACTIONS(797),
    [anon_sym_DASHcgt] = ACTIONS(797),
    [anon_sym_DASHcle] = ACTIONS(797),
    [anon_sym_DASHclike] = ACTIONS(797),
    [anon_sym_DASHclt] = ACTIONS(797),
    [anon_sym_DASHcmatch] = ACTIONS(797),
    [anon_sym_DASHcne] = ACTIONS(797),
    [anon_sym_DASHcnotcontains] = ACTIONS(797),
    [anon_sym_DASHcnotlike] = ACTIONS(797),
    [anon_sym_DASHcnotmatch] = ACTIONS(797),
    [anon_sym_DASHcontains] = ACTIONS(797),
    [anon_sym_DASHcreplace] = ACTIONS(797),
    [anon_sym_DASHcsplit] = ACTIONS(797),
    [anon_sym_DASHeq] = ACTIONS(797),
    [anon_sym_DASHge] = ACTIONS(797),
    [anon_sym_DASHgt] = ACTIONS(797),
    [anon_sym_DASHicontains] = ACTIONS(797),
    [anon_sym_DASHieq] = ACTIONS(797),
    [anon_sym_DASHige] = ACTIONS(797),
    [anon_sym_DASHigt] = ACTIONS(797),
    [anon_sym_DASHile] = ACTIONS(797),
    [anon_sym_DASHilike] = ACTIONS(797),
    [anon_sym_DASHilt] = ACTIONS(797),
    [anon_sym_DASHimatch] = ACTIONS(797),
    [anon_sym_DASHin] = ACTIONS(799),
    [anon_sym_DASHine] = ACTIONS(797),
    [anon_sym_DASHinotcontains] = ACTIONS(797),
    [anon_sym_DASHinotlike] = ACTIONS(797),
    [anon_sym_DASHinotmatch] = ACTIONS(797),
    [anon_sym_DASHireplace] = ACTIONS(797),
    [anon_sym_DASHis] = ACTIONS(799),
    [anon_sym_DASHisnot] = ACTIONS(797),
    [anon_sym_DASHisplit] = ACTIONS(797),
    [anon_sym_DASHjoin] = ACTIONS(797),
    [anon_sym_DASHle] = ACTIONS(797),
    [anon_sym_DASHlike] = ACTIONS(797),
    [anon_sym_DASHlt] = ACTIONS(797),
    [anon_sym_DASHmatch] = ACTIONS(797),
    [anon_sym_DASHne] = ACTIONS(797),
    [anon_sym_DASHnotcontains] = ACTIONS(797),
    [anon_sym_DASHnotin] = ACTIONS(797),
    [anon_sym_DASHnotlike] = ACTIONS(797),
    [anon_sym_DASHnotmatch] = ACTIONS(797),
    [anon_sym_DASHreplace] = ACTIONS(797),
    [anon_sym_DASHshl] = ACTIONS(797),
    [anon_sym_DASHshr] = ACTIONS(797),
    [anon_sym_DASHsplit] = ACTIONS(797),
    [sym_format_operator] = ACTIONS(801),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(799),
    [anon_sym_DASHand] = ACTIONS(797),
    [anon_sym_DASHor] = ACTIONS(797),
    [anon_sym_DASHxor] = ACTIONS(797),
    [anon_sym_DASHband] = ACTIONS(797),
    [anon_sym_DASHbor] = ACTIONS(797),
    [anon_sym_DASHbxor] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_SLASH] = ACTIONS(799),
    [anon_sym_BSLASH] = ACTIONS(797),
    [anon_sym_STAR] = ACTIONS(799),
    [sym__statement_terminator] = ACTIONS(797),
  },
  [182] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(803),
    [anon_sym_BANG_EQ] = ACTIONS(803),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_GT] = ACTIONS(805),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_2_GT] = ACTIONS(805),
    [anon_sym_2_GT_GT] = ACTIONS(803),
    [anon_sym_3_GT] = ACTIONS(805),
    [anon_sym_3_GT_GT] = ACTIONS(803),
    [anon_sym_4_GT] = ACTIONS(805),
    [anon_sym_4_GT_GT] = ACTIONS(803),
    [anon_sym_5_GT] = ACTIONS(805),
    [anon_sym_5_GT_GT] = ACTIONS(803),
    [anon_sym_6_GT] = ACTIONS(805),
    [anon_sym_6_GT_GT] = ACTIONS(803),
    [anon_sym_STAR_GT] = ACTIONS(805),
    [anon_sym_STAR_GT_GT] = ACTIONS(803),
    [anon_sym_LT] = ACTIONS(805),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(803),
    [anon_sym_2_GT_AMP1] = ACTIONS(803),
    [anon_sym_3_GT_AMP1] = ACTIONS(803),
    [anon_sym_4_GT_AMP1] = ACTIONS(803),
    [anon_sym_5_GT_AMP1] = ACTIONS(803),
    [anon_sym_6_GT_AMP1] = ACTIONS(803),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(803),
    [anon_sym_1_GT_AMP2] = ACTIONS(803),
    [anon_sym_3_GT_AMP2] = ACTIONS(803),
    [anon_sym_4_GT_AMP2] = ACTIONS(803),
    [anon_sym_5_GT_AMP2] = ACTIONS(803),
    [anon_sym_6_GT_AMP2] = ACTIONS(803),
    [anon_sym_DASHas] = ACTIONS(803),
    [anon_sym_DASHccontains] = ACTIONS(803),
    [anon_sym_DASHceq] = ACTIONS(803),
    [anon_sym_DASHcge] = ACTIONS(803),
    [anon_sym_DASHcgt] = ACTIONS(803),
    [anon_sym_DASHcle] = ACTIONS(803),
    [anon_sym_DASHclike] = ACTIONS(803),
    [anon_sym_DASHclt] = ACTIONS(803),
    [anon_sym_DASHcmatch] = ACTIONS(803),
    [anon_sym_DASHcne] = ACTIONS(803),
    [anon_sym_DASHcnotcontains] = ACTIONS(803),
    [anon_sym_DASHcnotlike] = ACTIONS(803),
    [anon_sym_DASHcnotmatch] = ACTIONS(803),
    [anon_sym_DASHcontains] = ACTIONS(803),
    [anon_sym_DASHcreplace] = ACTIONS(803),
    [anon_sym_DASHcsplit] = ACTIONS(803),
    [anon_sym_DASHeq] = ACTIONS(803),
    [anon_sym_DASHge] = ACTIONS(803),
    [anon_sym_DASHgt] = ACTIONS(803),
    [anon_sym_DASHicontains] = ACTIONS(803),
    [anon_sym_DASHieq] = ACTIONS(803),
    [anon_sym_DASHige] = ACTIONS(803),
    [anon_sym_DASHigt] = ACTIONS(803),
    [anon_sym_DASHile] = ACTIONS(803),
    [anon_sym_DASHilike] = ACTIONS(803),
    [anon_sym_DASHilt] = ACTIONS(803),
    [anon_sym_DASHimatch] = ACTIONS(803),
    [anon_sym_DASHin] = ACTIONS(805),
    [anon_sym_DASHine] = ACTIONS(803),
    [anon_sym_DASHinotcontains] = ACTIONS(803),
    [anon_sym_DASHinotlike] = ACTIONS(803),
    [anon_sym_DASHinotmatch] = ACTIONS(803),
    [anon_sym_DASHireplace] = ACTIONS(803),
    [anon_sym_DASHis] = ACTIONS(805),
    [anon_sym_DASHisnot] = ACTIONS(803),
    [anon_sym_DASHisplit] = ACTIONS(803),
    [anon_sym_DASHjoin] = ACTIONS(803),
    [anon_sym_DASHle] = ACTIONS(803),
    [anon_sym_DASHlike] = ACTIONS(803),
    [anon_sym_DASHlt] = ACTIONS(803),
    [anon_sym_DASHmatch] = ACTIONS(803),
    [anon_sym_DASHne] = ACTIONS(803),
    [anon_sym_DASHnotcontains] = ACTIONS(803),
    [anon_sym_DASHnotin] = ACTIONS(803),
    [anon_sym_DASHnotlike] = ACTIONS(803),
    [anon_sym_DASHnotmatch] = ACTIONS(803),
    [anon_sym_DASHreplace] = ACTIONS(803),
    [anon_sym_DASHshl] = ACTIONS(803),
    [anon_sym_DASHshr] = ACTIONS(803),
    [anon_sym_DASHsplit] = ACTIONS(803),
    [sym_format_operator] = ACTIONS(807),
    [anon_sym_RPAREN] = ACTIONS(803),
    [anon_sym_PIPE] = ACTIONS(803),
    [anon_sym_PERCENT] = ACTIONS(805),
    [anon_sym_DASHand] = ACTIONS(803),
    [anon_sym_DASHor] = ACTIONS(803),
    [anon_sym_DASHxor] = ACTIONS(803),
    [anon_sym_DASHband] = ACTIONS(803),
    [anon_sym_DASHbor] = ACTIONS(803),
    [anon_sym_DASHbxor] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [anon_sym_SLASH] = ACTIONS(805),
    [anon_sym_BSLASH] = ACTIONS(803),
    [anon_sym_STAR] = ACTIONS(805),
  },
  [183] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_BANG_EQ] = ACTIONS(797),
    [anon_sym_PLUS_EQ] = ACTIONS(797),
    [anon_sym_STAR_EQ] = ACTIONS(797),
    [anon_sym_SLASH_EQ] = ACTIONS(797),
    [anon_sym_PERCENT_EQ] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(799),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_2_GT] = ACTIONS(799),
    [anon_sym_2_GT_GT] = ACTIONS(797),
    [anon_sym_3_GT] = ACTIONS(799),
    [anon_sym_3_GT_GT] = ACTIONS(797),
    [anon_sym_4_GT] = ACTIONS(799),
    [anon_sym_4_GT_GT] = ACTIONS(797),
    [anon_sym_5_GT] = ACTIONS(799),
    [anon_sym_5_GT_GT] = ACTIONS(797),
    [anon_sym_6_GT] = ACTIONS(799),
    [anon_sym_6_GT_GT] = ACTIONS(797),
    [anon_sym_STAR_GT] = ACTIONS(799),
    [anon_sym_STAR_GT_GT] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(797),
    [anon_sym_2_GT_AMP1] = ACTIONS(797),
    [anon_sym_3_GT_AMP1] = ACTIONS(797),
    [anon_sym_4_GT_AMP1] = ACTIONS(797),
    [anon_sym_5_GT_AMP1] = ACTIONS(797),
    [anon_sym_6_GT_AMP1] = ACTIONS(797),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(797),
    [anon_sym_1_GT_AMP2] = ACTIONS(797),
    [anon_sym_3_GT_AMP2] = ACTIONS(797),
    [anon_sym_4_GT_AMP2] = ACTIONS(797),
    [anon_sym_5_GT_AMP2] = ACTIONS(797),
    [anon_sym_6_GT_AMP2] = ACTIONS(797),
    [anon_sym_DASHas] = ACTIONS(797),
    [anon_sym_DASHccontains] = ACTIONS(797),
    [anon_sym_DASHceq] = ACTIONS(797),
    [anon_sym_DASHcge] = ACTIONS(797),
    [anon_sym_DASHcgt] = ACTIONS(797),
    [anon_sym_DASHcle] = ACTIONS(797),
    [anon_sym_DASHclike] = ACTIONS(797),
    [anon_sym_DASHclt] = ACTIONS(797),
    [anon_sym_DASHcmatch] = ACTIONS(797),
    [anon_sym_DASHcne] = ACTIONS(797),
    [anon_sym_DASHcnotcontains] = ACTIONS(797),
    [anon_sym_DASHcnotlike] = ACTIONS(797),
    [anon_sym_DASHcnotmatch] = ACTIONS(797),
    [anon_sym_DASHcontains] = ACTIONS(797),
    [anon_sym_DASHcreplace] = ACTIONS(797),
    [anon_sym_DASHcsplit] = ACTIONS(797),
    [anon_sym_DASHeq] = ACTIONS(797),
    [anon_sym_DASHge] = ACTIONS(797),
    [anon_sym_DASHgt] = ACTIONS(797),
    [anon_sym_DASHicontains] = ACTIONS(797),
    [anon_sym_DASHieq] = ACTIONS(797),
    [anon_sym_DASHige] = ACTIONS(797),
    [anon_sym_DASHigt] = ACTIONS(797),
    [anon_sym_DASHile] = ACTIONS(797),
    [anon_sym_DASHilike] = ACTIONS(797),
    [anon_sym_DASHilt] = ACTIONS(797),
    [anon_sym_DASHimatch] = ACTIONS(797),
    [anon_sym_DASHin] = ACTIONS(799),
    [anon_sym_DASHine] = ACTIONS(797),
    [anon_sym_DASHinotcontains] = ACTIONS(797),
    [anon_sym_DASHinotlike] = ACTIONS(797),
    [anon_sym_DASHinotmatch] = ACTIONS(797),
    [anon_sym_DASHireplace] = ACTIONS(797),
    [anon_sym_DASHis] = ACTIONS(799),
    [anon_sym_DASHisnot] = ACTIONS(797),
    [anon_sym_DASHisplit] = ACTIONS(797),
    [anon_sym_DASHjoin] = ACTIONS(797),
    [anon_sym_DASHle] = ACTIONS(797),
    [anon_sym_DASHlike] = ACTIONS(797),
    [anon_sym_DASHlt] = ACTIONS(797),
    [anon_sym_DASHmatch] = ACTIONS(797),
    [anon_sym_DASHne] = ACTIONS(797),
    [anon_sym_DASHnotcontains] = ACTIONS(797),
    [anon_sym_DASHnotin] = ACTIONS(797),
    [anon_sym_DASHnotlike] = ACTIONS(797),
    [anon_sym_DASHnotmatch] = ACTIONS(797),
    [anon_sym_DASHreplace] = ACTIONS(797),
    [anon_sym_DASHshl] = ACTIONS(797),
    [anon_sym_DASHshr] = ACTIONS(797),
    [anon_sym_DASHsplit] = ACTIONS(797),
    [sym_format_operator] = ACTIONS(807),
    [anon_sym_RPAREN] = ACTIONS(797),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(799),
    [anon_sym_DASHand] = ACTIONS(797),
    [anon_sym_DASHor] = ACTIONS(797),
    [anon_sym_DASHxor] = ACTIONS(797),
    [anon_sym_DASHband] = ACTIONS(797),
    [anon_sym_DASHbor] = ACTIONS(797),
    [anon_sym_DASHbxor] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_SLASH] = ACTIONS(799),
    [anon_sym_BSLASH] = ACTIONS(797),
    [anon_sym_STAR] = ACTIONS(799),
  },
  [184] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(803),
    [anon_sym_BANG_EQ] = ACTIONS(803),
    [anon_sym_PLUS_EQ] = ACTIONS(803),
    [anon_sym_STAR_EQ] = ACTIONS(803),
    [anon_sym_SLASH_EQ] = ACTIONS(803),
    [anon_sym_PERCENT_EQ] = ACTIONS(803),
    [anon_sym_GT] = ACTIONS(805),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_2_GT] = ACTIONS(805),
    [anon_sym_2_GT_GT] = ACTIONS(803),
    [anon_sym_3_GT] = ACTIONS(805),
    [anon_sym_3_GT_GT] = ACTIONS(803),
    [anon_sym_4_GT] = ACTIONS(805),
    [anon_sym_4_GT_GT] = ACTIONS(803),
    [anon_sym_5_GT] = ACTIONS(805),
    [anon_sym_5_GT_GT] = ACTIONS(803),
    [anon_sym_6_GT] = ACTIONS(805),
    [anon_sym_6_GT_GT] = ACTIONS(803),
    [anon_sym_STAR_GT] = ACTIONS(805),
    [anon_sym_STAR_GT_GT] = ACTIONS(803),
    [anon_sym_LT] = ACTIONS(805),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(803),
    [anon_sym_2_GT_AMP1] = ACTIONS(803),
    [anon_sym_3_GT_AMP1] = ACTIONS(803),
    [anon_sym_4_GT_AMP1] = ACTIONS(803),
    [anon_sym_5_GT_AMP1] = ACTIONS(803),
    [anon_sym_6_GT_AMP1] = ACTIONS(803),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(803),
    [anon_sym_1_GT_AMP2] = ACTIONS(803),
    [anon_sym_3_GT_AMP2] = ACTIONS(803),
    [anon_sym_4_GT_AMP2] = ACTIONS(803),
    [anon_sym_5_GT_AMP2] = ACTIONS(803),
    [anon_sym_6_GT_AMP2] = ACTIONS(803),
    [anon_sym_DASHas] = ACTIONS(803),
    [anon_sym_DASHccontains] = ACTIONS(803),
    [anon_sym_DASHceq] = ACTIONS(803),
    [anon_sym_DASHcge] = ACTIONS(803),
    [anon_sym_DASHcgt] = ACTIONS(803),
    [anon_sym_DASHcle] = ACTIONS(803),
    [anon_sym_DASHclike] = ACTIONS(803),
    [anon_sym_DASHclt] = ACTIONS(803),
    [anon_sym_DASHcmatch] = ACTIONS(803),
    [anon_sym_DASHcne] = ACTIONS(803),
    [anon_sym_DASHcnotcontains] = ACTIONS(803),
    [anon_sym_DASHcnotlike] = ACTIONS(803),
    [anon_sym_DASHcnotmatch] = ACTIONS(803),
    [anon_sym_DASHcontains] = ACTIONS(803),
    [anon_sym_DASHcreplace] = ACTIONS(803),
    [anon_sym_DASHcsplit] = ACTIONS(803),
    [anon_sym_DASHeq] = ACTIONS(803),
    [anon_sym_DASHge] = ACTIONS(803),
    [anon_sym_DASHgt] = ACTIONS(803),
    [anon_sym_DASHicontains] = ACTIONS(803),
    [anon_sym_DASHieq] = ACTIONS(803),
    [anon_sym_DASHige] = ACTIONS(803),
    [anon_sym_DASHigt] = ACTIONS(803),
    [anon_sym_DASHile] = ACTIONS(803),
    [anon_sym_DASHilike] = ACTIONS(803),
    [anon_sym_DASHilt] = ACTIONS(803),
    [anon_sym_DASHimatch] = ACTIONS(803),
    [anon_sym_DASHin] = ACTIONS(805),
    [anon_sym_DASHine] = ACTIONS(803),
    [anon_sym_DASHinotcontains] = ACTIONS(803),
    [anon_sym_DASHinotlike] = ACTIONS(803),
    [anon_sym_DASHinotmatch] = ACTIONS(803),
    [anon_sym_DASHireplace] = ACTIONS(803),
    [anon_sym_DASHis] = ACTIONS(805),
    [anon_sym_DASHisnot] = ACTIONS(803),
    [anon_sym_DASHisplit] = ACTIONS(803),
    [anon_sym_DASHjoin] = ACTIONS(803),
    [anon_sym_DASHle] = ACTIONS(803),
    [anon_sym_DASHlike] = ACTIONS(803),
    [anon_sym_DASHlt] = ACTIONS(803),
    [anon_sym_DASHmatch] = ACTIONS(803),
    [anon_sym_DASHne] = ACTIONS(803),
    [anon_sym_DASHnotcontains] = ACTIONS(803),
    [anon_sym_DASHnotin] = ACTIONS(803),
    [anon_sym_DASHnotlike] = ACTIONS(803),
    [anon_sym_DASHnotmatch] = ACTIONS(803),
    [anon_sym_DASHreplace] = ACTIONS(803),
    [anon_sym_DASHshl] = ACTIONS(803),
    [anon_sym_DASHshr] = ACTIONS(803),
    [anon_sym_DASHsplit] = ACTIONS(803),
    [sym_format_operator] = ACTIONS(801),
    [anon_sym_PIPE] = ACTIONS(803),
    [anon_sym_PERCENT] = ACTIONS(805),
    [anon_sym_DASHand] = ACTIONS(803),
    [anon_sym_DASHor] = ACTIONS(803),
    [anon_sym_DASHxor] = ACTIONS(803),
    [anon_sym_DASHband] = ACTIONS(803),
    [anon_sym_DASHbor] = ACTIONS(803),
    [anon_sym_DASHbxor] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [anon_sym_SLASH] = ACTIONS(805),
    [anon_sym_BSLASH] = ACTIONS(803),
    [anon_sym_STAR] = ACTIONS(805),
    [sym__statement_terminator] = ACTIONS(803),
  },
  [185] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(809),
    [anon_sym_BANG_EQ] = ACTIONS(809),
    [anon_sym_PLUS_EQ] = ACTIONS(809),
    [anon_sym_STAR_EQ] = ACTIONS(809),
    [anon_sym_SLASH_EQ] = ACTIONS(809),
    [anon_sym_PERCENT_EQ] = ACTIONS(809),
    [anon_sym_GT] = ACTIONS(811),
    [anon_sym_GT_GT] = ACTIONS(809),
    [anon_sym_2_GT] = ACTIONS(811),
    [anon_sym_2_GT_GT] = ACTIONS(809),
    [anon_sym_3_GT] = ACTIONS(811),
    [anon_sym_3_GT_GT] = ACTIONS(809),
    [anon_sym_4_GT] = ACTIONS(811),
    [anon_sym_4_GT_GT] = ACTIONS(809),
    [anon_sym_5_GT] = ACTIONS(811),
    [anon_sym_5_GT_GT] = ACTIONS(809),
    [anon_sym_6_GT] = ACTIONS(811),
    [anon_sym_6_GT_GT] = ACTIONS(809),
    [anon_sym_STAR_GT] = ACTIONS(811),
    [anon_sym_STAR_GT_GT] = ACTIONS(809),
    [anon_sym_LT] = ACTIONS(811),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(809),
    [anon_sym_2_GT_AMP1] = ACTIONS(809),
    [anon_sym_3_GT_AMP1] = ACTIONS(809),
    [anon_sym_4_GT_AMP1] = ACTIONS(809),
    [anon_sym_5_GT_AMP1] = ACTIONS(809),
    [anon_sym_6_GT_AMP1] = ACTIONS(809),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(809),
    [anon_sym_1_GT_AMP2] = ACTIONS(809),
    [anon_sym_3_GT_AMP2] = ACTIONS(809),
    [anon_sym_4_GT_AMP2] = ACTIONS(809),
    [anon_sym_5_GT_AMP2] = ACTIONS(809),
    [anon_sym_6_GT_AMP2] = ACTIONS(809),
    [anon_sym_DASHas] = ACTIONS(809),
    [anon_sym_DASHccontains] = ACTIONS(809),
    [anon_sym_DASHceq] = ACTIONS(809),
    [anon_sym_DASHcge] = ACTIONS(809),
    [anon_sym_DASHcgt] = ACTIONS(809),
    [anon_sym_DASHcle] = ACTIONS(809),
    [anon_sym_DASHclike] = ACTIONS(809),
    [anon_sym_DASHclt] = ACTIONS(809),
    [anon_sym_DASHcmatch] = ACTIONS(809),
    [anon_sym_DASHcne] = ACTIONS(809),
    [anon_sym_DASHcnotcontains] = ACTIONS(809),
    [anon_sym_DASHcnotlike] = ACTIONS(809),
    [anon_sym_DASHcnotmatch] = ACTIONS(809),
    [anon_sym_DASHcontains] = ACTIONS(809),
    [anon_sym_DASHcreplace] = ACTIONS(809),
    [anon_sym_DASHcsplit] = ACTIONS(809),
    [anon_sym_DASHeq] = ACTIONS(809),
    [anon_sym_DASHge] = ACTIONS(809),
    [anon_sym_DASHgt] = ACTIONS(809),
    [anon_sym_DASHicontains] = ACTIONS(809),
    [anon_sym_DASHieq] = ACTIONS(809),
    [anon_sym_DASHige] = ACTIONS(809),
    [anon_sym_DASHigt] = ACTIONS(809),
    [anon_sym_DASHile] = ACTIONS(809),
    [anon_sym_DASHilike] = ACTIONS(809),
    [anon_sym_DASHilt] = ACTIONS(809),
    [anon_sym_DASHimatch] = ACTIONS(809),
    [anon_sym_DASHin] = ACTIONS(811),
    [anon_sym_DASHine] = ACTIONS(809),
    [anon_sym_DASHinotcontains] = ACTIONS(809),
    [anon_sym_DASHinotlike] = ACTIONS(809),
    [anon_sym_DASHinotmatch] = ACTIONS(809),
    [anon_sym_DASHireplace] = ACTIONS(809),
    [anon_sym_DASHis] = ACTIONS(811),
    [anon_sym_DASHisnot] = ACTIONS(809),
    [anon_sym_DASHisplit] = ACTIONS(809),
    [anon_sym_DASHjoin] = ACTIONS(809),
    [anon_sym_DASHle] = ACTIONS(809),
    [anon_sym_DASHlike] = ACTIONS(809),
    [anon_sym_DASHlt] = ACTIONS(809),
    [anon_sym_DASHmatch] = ACTIONS(809),
    [anon_sym_DASHne] = ACTIONS(809),
    [anon_sym_DASHnotcontains] = ACTIONS(809),
    [anon_sym_DASHnotin] = ACTIONS(809),
    [anon_sym_DASHnotlike] = ACTIONS(809),
    [anon_sym_DASHnotmatch] = ACTIONS(809),
    [anon_sym_DASHreplace] = ACTIONS(809),
    [anon_sym_DASHshl] = ACTIONS(809),
    [anon_sym_DASHshr] = ACTIONS(809),
    [anon_sym_DASHsplit] = ACTIONS(809),
    [anon_sym_RPAREN] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_DASHand] = ACTIONS(809),
    [anon_sym_DASHor] = ACTIONS(809),
    [anon_sym_DASHxor] = ACTIONS(809),
    [anon_sym_DASHband] = ACTIONS(809),
    [anon_sym_DASHbor] = ACTIONS(809),
    [anon_sym_DASHbxor] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(811),
    [anon_sym_DASH] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_BSLASH] = ACTIONS(815),
    [anon_sym_STAR] = ACTIONS(813),
  },
  [186] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(817),
    [anon_sym_PLUS_EQ] = ACTIONS(817),
    [anon_sym_STAR_EQ] = ACTIONS(817),
    [anon_sym_SLASH_EQ] = ACTIONS(817),
    [anon_sym_PERCENT_EQ] = ACTIONS(817),
    [anon_sym_GT] = ACTIONS(819),
    [anon_sym_GT_GT] = ACTIONS(817),
    [anon_sym_2_GT] = ACTIONS(819),
    [anon_sym_2_GT_GT] = ACTIONS(817),
    [anon_sym_3_GT] = ACTIONS(819),
    [anon_sym_3_GT_GT] = ACTIONS(817),
    [anon_sym_4_GT] = ACTIONS(819),
    [anon_sym_4_GT_GT] = ACTIONS(817),
    [anon_sym_5_GT] = ACTIONS(819),
    [anon_sym_5_GT_GT] = ACTIONS(817),
    [anon_sym_6_GT] = ACTIONS(819),
    [anon_sym_6_GT_GT] = ACTIONS(817),
    [anon_sym_STAR_GT] = ACTIONS(819),
    [anon_sym_STAR_GT_GT] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(819),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(817),
    [anon_sym_2_GT_AMP1] = ACTIONS(817),
    [anon_sym_3_GT_AMP1] = ACTIONS(817),
    [anon_sym_4_GT_AMP1] = ACTIONS(817),
    [anon_sym_5_GT_AMP1] = ACTIONS(817),
    [anon_sym_6_GT_AMP1] = ACTIONS(817),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(817),
    [anon_sym_1_GT_AMP2] = ACTIONS(817),
    [anon_sym_3_GT_AMP2] = ACTIONS(817),
    [anon_sym_4_GT_AMP2] = ACTIONS(817),
    [anon_sym_5_GT_AMP2] = ACTIONS(817),
    [anon_sym_6_GT_AMP2] = ACTIONS(817),
    [anon_sym_DASHas] = ACTIONS(817),
    [anon_sym_DASHccontains] = ACTIONS(817),
    [anon_sym_DASHceq] = ACTIONS(817),
    [anon_sym_DASHcge] = ACTIONS(817),
    [anon_sym_DASHcgt] = ACTIONS(817),
    [anon_sym_DASHcle] = ACTIONS(817),
    [anon_sym_DASHclike] = ACTIONS(817),
    [anon_sym_DASHclt] = ACTIONS(817),
    [anon_sym_DASHcmatch] = ACTIONS(817),
    [anon_sym_DASHcne] = ACTIONS(817),
    [anon_sym_DASHcnotcontains] = ACTIONS(817),
    [anon_sym_DASHcnotlike] = ACTIONS(817),
    [anon_sym_DASHcnotmatch] = ACTIONS(817),
    [anon_sym_DASHcontains] = ACTIONS(817),
    [anon_sym_DASHcreplace] = ACTIONS(817),
    [anon_sym_DASHcsplit] = ACTIONS(817),
    [anon_sym_DASHeq] = ACTIONS(817),
    [anon_sym_DASHge] = ACTIONS(817),
    [anon_sym_DASHgt] = ACTIONS(817),
    [anon_sym_DASHicontains] = ACTIONS(817),
    [anon_sym_DASHieq] = ACTIONS(817),
    [anon_sym_DASHige] = ACTIONS(817),
    [anon_sym_DASHigt] = ACTIONS(817),
    [anon_sym_DASHile] = ACTIONS(817),
    [anon_sym_DASHilike] = ACTIONS(817),
    [anon_sym_DASHilt] = ACTIONS(817),
    [anon_sym_DASHimatch] = ACTIONS(817),
    [anon_sym_DASHin] = ACTIONS(819),
    [anon_sym_DASHine] = ACTIONS(817),
    [anon_sym_DASHinotcontains] = ACTIONS(817),
    [anon_sym_DASHinotlike] = ACTIONS(817),
    [anon_sym_DASHinotmatch] = ACTIONS(817),
    [anon_sym_DASHireplace] = ACTIONS(817),
    [anon_sym_DASHis] = ACTIONS(819),
    [anon_sym_DASHisnot] = ACTIONS(817),
    [anon_sym_DASHisplit] = ACTIONS(817),
    [anon_sym_DASHjoin] = ACTIONS(817),
    [anon_sym_DASHle] = ACTIONS(817),
    [anon_sym_DASHlike] = ACTIONS(817),
    [anon_sym_DASHlt] = ACTIONS(817),
    [anon_sym_DASHmatch] = ACTIONS(817),
    [anon_sym_DASHne] = ACTIONS(817),
    [anon_sym_DASHnotcontains] = ACTIONS(817),
    [anon_sym_DASHnotin] = ACTIONS(817),
    [anon_sym_DASHnotlike] = ACTIONS(817),
    [anon_sym_DASHnotmatch] = ACTIONS(817),
    [anon_sym_DASHreplace] = ACTIONS(817),
    [anon_sym_DASHshl] = ACTIONS(817),
    [anon_sym_DASHshr] = ACTIONS(817),
    [anon_sym_DASHsplit] = ACTIONS(817),
    [anon_sym_PIPE] = ACTIONS(817),
    [anon_sym_PERCENT] = ACTIONS(821),
    [anon_sym_DASHand] = ACTIONS(817),
    [anon_sym_DASHor] = ACTIONS(817),
    [anon_sym_DASHxor] = ACTIONS(817),
    [anon_sym_DASHband] = ACTIONS(817),
    [anon_sym_DASHbor] = ACTIONS(817),
    [anon_sym_DASHbxor] = ACTIONS(817),
    [anon_sym_PLUS] = ACTIONS(819),
    [anon_sym_DASH] = ACTIONS(819),
    [anon_sym_SLASH] = ACTIONS(821),
    [anon_sym_BSLASH] = ACTIONS(823),
    [anon_sym_STAR] = ACTIONS(821),
    [sym__statement_terminator] = ACTIONS(817),
  },
  [187] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(809),
    [anon_sym_BANG_EQ] = ACTIONS(809),
    [anon_sym_PLUS_EQ] = ACTIONS(809),
    [anon_sym_STAR_EQ] = ACTIONS(809),
    [anon_sym_SLASH_EQ] = ACTIONS(809),
    [anon_sym_PERCENT_EQ] = ACTIONS(809),
    [anon_sym_GT] = ACTIONS(811),
    [anon_sym_GT_GT] = ACTIONS(809),
    [anon_sym_2_GT] = ACTIONS(811),
    [anon_sym_2_GT_GT] = ACTIONS(809),
    [anon_sym_3_GT] = ACTIONS(811),
    [anon_sym_3_GT_GT] = ACTIONS(809),
    [anon_sym_4_GT] = ACTIONS(811),
    [anon_sym_4_GT_GT] = ACTIONS(809),
    [anon_sym_5_GT] = ACTIONS(811),
    [anon_sym_5_GT_GT] = ACTIONS(809),
    [anon_sym_6_GT] = ACTIONS(811),
    [anon_sym_6_GT_GT] = ACTIONS(809),
    [anon_sym_STAR_GT] = ACTIONS(811),
    [anon_sym_STAR_GT_GT] = ACTIONS(809),
    [anon_sym_LT] = ACTIONS(811),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(809),
    [anon_sym_2_GT_AMP1] = ACTIONS(809),
    [anon_sym_3_GT_AMP1] = ACTIONS(809),
    [anon_sym_4_GT_AMP1] = ACTIONS(809),
    [anon_sym_5_GT_AMP1] = ACTIONS(809),
    [anon_sym_6_GT_AMP1] = ACTIONS(809),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(809),
    [anon_sym_1_GT_AMP2] = ACTIONS(809),
    [anon_sym_3_GT_AMP2] = ACTIONS(809),
    [anon_sym_4_GT_AMP2] = ACTIONS(809),
    [anon_sym_5_GT_AMP2] = ACTIONS(809),
    [anon_sym_6_GT_AMP2] = ACTIONS(809),
    [anon_sym_DASHas] = ACTIONS(809),
    [anon_sym_DASHccontains] = ACTIONS(809),
    [anon_sym_DASHceq] = ACTIONS(809),
    [anon_sym_DASHcge] = ACTIONS(809),
    [anon_sym_DASHcgt] = ACTIONS(809),
    [anon_sym_DASHcle] = ACTIONS(809),
    [anon_sym_DASHclike] = ACTIONS(809),
    [anon_sym_DASHclt] = ACTIONS(809),
    [anon_sym_DASHcmatch] = ACTIONS(809),
    [anon_sym_DASHcne] = ACTIONS(809),
    [anon_sym_DASHcnotcontains] = ACTIONS(809),
    [anon_sym_DASHcnotlike] = ACTIONS(809),
    [anon_sym_DASHcnotmatch] = ACTIONS(809),
    [anon_sym_DASHcontains] = ACTIONS(809),
    [anon_sym_DASHcreplace] = ACTIONS(809),
    [anon_sym_DASHcsplit] = ACTIONS(809),
    [anon_sym_DASHeq] = ACTIONS(809),
    [anon_sym_DASHge] = ACTIONS(809),
    [anon_sym_DASHgt] = ACTIONS(809),
    [anon_sym_DASHicontains] = ACTIONS(809),
    [anon_sym_DASHieq] = ACTIONS(809),
    [anon_sym_DASHige] = ACTIONS(809),
    [anon_sym_DASHigt] = ACTIONS(809),
    [anon_sym_DASHile] = ACTIONS(809),
    [anon_sym_DASHilike] = ACTIONS(809),
    [anon_sym_DASHilt] = ACTIONS(809),
    [anon_sym_DASHimatch] = ACTIONS(809),
    [anon_sym_DASHin] = ACTIONS(811),
    [anon_sym_DASHine] = ACTIONS(809),
    [anon_sym_DASHinotcontains] = ACTIONS(809),
    [anon_sym_DASHinotlike] = ACTIONS(809),
    [anon_sym_DASHinotmatch] = ACTIONS(809),
    [anon_sym_DASHireplace] = ACTIONS(809),
    [anon_sym_DASHis] = ACTIONS(811),
    [anon_sym_DASHisnot] = ACTIONS(809),
    [anon_sym_DASHisplit] = ACTIONS(809),
    [anon_sym_DASHjoin] = ACTIONS(809),
    [anon_sym_DASHle] = ACTIONS(809),
    [anon_sym_DASHlike] = ACTIONS(809),
    [anon_sym_DASHlt] = ACTIONS(809),
    [anon_sym_DASHmatch] = ACTIONS(809),
    [anon_sym_DASHne] = ACTIONS(809),
    [anon_sym_DASHnotcontains] = ACTIONS(809),
    [anon_sym_DASHnotin] = ACTIONS(809),
    [anon_sym_DASHnotlike] = ACTIONS(809),
    [anon_sym_DASHnotmatch] = ACTIONS(809),
    [anon_sym_DASHreplace] = ACTIONS(809),
    [anon_sym_DASHshl] = ACTIONS(809),
    [anon_sym_DASHshr] = ACTIONS(809),
    [anon_sym_DASHsplit] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_PERCENT] = ACTIONS(821),
    [anon_sym_DASHand] = ACTIONS(809),
    [anon_sym_DASHor] = ACTIONS(809),
    [anon_sym_DASHxor] = ACTIONS(809),
    [anon_sym_DASHband] = ACTIONS(809),
    [anon_sym_DASHbor] = ACTIONS(809),
    [anon_sym_DASHbxor] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(811),
    [anon_sym_DASH] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(821),
    [anon_sym_BSLASH] = ACTIONS(823),
    [anon_sym_STAR] = ACTIONS(821),
    [sym__statement_terminator] = ACTIONS(809),
  },
  [188] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(817),
    [anon_sym_PLUS_EQ] = ACTIONS(817),
    [anon_sym_STAR_EQ] = ACTIONS(817),
    [anon_sym_SLASH_EQ] = ACTIONS(817),
    [anon_sym_PERCENT_EQ] = ACTIONS(817),
    [anon_sym_GT] = ACTIONS(819),
    [anon_sym_GT_GT] = ACTIONS(817),
    [anon_sym_2_GT] = ACTIONS(819),
    [anon_sym_2_GT_GT] = ACTIONS(817),
    [anon_sym_3_GT] = ACTIONS(819),
    [anon_sym_3_GT_GT] = ACTIONS(817),
    [anon_sym_4_GT] = ACTIONS(819),
    [anon_sym_4_GT_GT] = ACTIONS(817),
    [anon_sym_5_GT] = ACTIONS(819),
    [anon_sym_5_GT_GT] = ACTIONS(817),
    [anon_sym_6_GT] = ACTIONS(819),
    [anon_sym_6_GT_GT] = ACTIONS(817),
    [anon_sym_STAR_GT] = ACTIONS(819),
    [anon_sym_STAR_GT_GT] = ACTIONS(817),
    [anon_sym_LT] = ACTIONS(819),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(817),
    [anon_sym_2_GT_AMP1] = ACTIONS(817),
    [anon_sym_3_GT_AMP1] = ACTIONS(817),
    [anon_sym_4_GT_AMP1] = ACTIONS(817),
    [anon_sym_5_GT_AMP1] = ACTIONS(817),
    [anon_sym_6_GT_AMP1] = ACTIONS(817),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(817),
    [anon_sym_1_GT_AMP2] = ACTIONS(817),
    [anon_sym_3_GT_AMP2] = ACTIONS(817),
    [anon_sym_4_GT_AMP2] = ACTIONS(817),
    [anon_sym_5_GT_AMP2] = ACTIONS(817),
    [anon_sym_6_GT_AMP2] = ACTIONS(817),
    [anon_sym_DASHas] = ACTIONS(817),
    [anon_sym_DASHccontains] = ACTIONS(817),
    [anon_sym_DASHceq] = ACTIONS(817),
    [anon_sym_DASHcge] = ACTIONS(817),
    [anon_sym_DASHcgt] = ACTIONS(817),
    [anon_sym_DASHcle] = ACTIONS(817),
    [anon_sym_DASHclike] = ACTIONS(817),
    [anon_sym_DASHclt] = ACTIONS(817),
    [anon_sym_DASHcmatch] = ACTIONS(817),
    [anon_sym_DASHcne] = ACTIONS(817),
    [anon_sym_DASHcnotcontains] = ACTIONS(817),
    [anon_sym_DASHcnotlike] = ACTIONS(817),
    [anon_sym_DASHcnotmatch] = ACTIONS(817),
    [anon_sym_DASHcontains] = ACTIONS(817),
    [anon_sym_DASHcreplace] = ACTIONS(817),
    [anon_sym_DASHcsplit] = ACTIONS(817),
    [anon_sym_DASHeq] = ACTIONS(817),
    [anon_sym_DASHge] = ACTIONS(817),
    [anon_sym_DASHgt] = ACTIONS(817),
    [anon_sym_DASHicontains] = ACTIONS(817),
    [anon_sym_DASHieq] = ACTIONS(817),
    [anon_sym_DASHige] = ACTIONS(817),
    [anon_sym_DASHigt] = ACTIONS(817),
    [anon_sym_DASHile] = ACTIONS(817),
    [anon_sym_DASHilike] = ACTIONS(817),
    [anon_sym_DASHilt] = ACTIONS(817),
    [anon_sym_DASHimatch] = ACTIONS(817),
    [anon_sym_DASHin] = ACTIONS(819),
    [anon_sym_DASHine] = ACTIONS(817),
    [anon_sym_DASHinotcontains] = ACTIONS(817),
    [anon_sym_DASHinotlike] = ACTIONS(817),
    [anon_sym_DASHinotmatch] = ACTIONS(817),
    [anon_sym_DASHireplace] = ACTIONS(817),
    [anon_sym_DASHis] = ACTIONS(819),
    [anon_sym_DASHisnot] = ACTIONS(817),
    [anon_sym_DASHisplit] = ACTIONS(817),
    [anon_sym_DASHjoin] = ACTIONS(817),
    [anon_sym_DASHle] = ACTIONS(817),
    [anon_sym_DASHlike] = ACTIONS(817),
    [anon_sym_DASHlt] = ACTIONS(817),
    [anon_sym_DASHmatch] = ACTIONS(817),
    [anon_sym_DASHne] = ACTIONS(817),
    [anon_sym_DASHnotcontains] = ACTIONS(817),
    [anon_sym_DASHnotin] = ACTIONS(817),
    [anon_sym_DASHnotlike] = ACTIONS(817),
    [anon_sym_DASHnotmatch] = ACTIONS(817),
    [anon_sym_DASHreplace] = ACTIONS(817),
    [anon_sym_DASHshl] = ACTIONS(817),
    [anon_sym_DASHshr] = ACTIONS(817),
    [anon_sym_DASHsplit] = ACTIONS(817),
    [anon_sym_RPAREN] = ACTIONS(817),
    [anon_sym_PIPE] = ACTIONS(817),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_DASHand] = ACTIONS(817),
    [anon_sym_DASHor] = ACTIONS(817),
    [anon_sym_DASHxor] = ACTIONS(817),
    [anon_sym_DASHband] = ACTIONS(817),
    [anon_sym_DASHbor] = ACTIONS(817),
    [anon_sym_DASHbxor] = ACTIONS(817),
    [anon_sym_PLUS] = ACTIONS(819),
    [anon_sym_DASH] = ACTIONS(819),
    [anon_sym_SLASH] = ACTIONS(813),
    [anon_sym_BSLASH] = ACTIONS(815),
    [anon_sym_STAR] = ACTIONS(813),
  },
  [189] = {
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(251),
    [sym_hexadecimal_integer_literal] = ACTIONS(253),
    [sym_real_literal] = ACTIONS(253),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(253),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(253),
    [sym_verbatim_string_characters] = ACTIONS(253),
    [sym_verbatim_here_string_characters] = ACTIONS(253),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_DASHas] = ACTIONS(253),
    [anon_sym_DASHccontains] = ACTIONS(253),
    [anon_sym_DASHceq] = ACTIONS(253),
    [anon_sym_DASHcge] = ACTIONS(253),
    [anon_sym_DASHcgt] = ACTIONS(253),
    [anon_sym_DASHcle] = ACTIONS(253),
    [anon_sym_DASHclike] = ACTIONS(253),
    [anon_sym_DASHclt] = ACTIONS(253),
    [anon_sym_DASHcmatch] = ACTIONS(253),
    [anon_sym_DASHcne] = ACTIONS(253),
    [anon_sym_DASHcnotcontains] = ACTIONS(253),
    [anon_sym_DASHcnotlike] = ACTIONS(253),
    [anon_sym_DASHcnotmatch] = ACTIONS(253),
    [anon_sym_DASHcontains] = ACTIONS(253),
    [anon_sym_DASHcreplace] = ACTIONS(253),
    [anon_sym_DASHcsplit] = ACTIONS(253),
    [anon_sym_DASHeq] = ACTIONS(253),
    [anon_sym_DASHge] = ACTIONS(253),
    [anon_sym_DASHgt] = ACTIONS(253),
    [anon_sym_DASHicontains] = ACTIONS(253),
    [anon_sym_DASHieq] = ACTIONS(253),
    [anon_sym_DASHige] = ACTIONS(253),
    [anon_sym_DASHigt] = ACTIONS(253),
    [anon_sym_DASHile] = ACTIONS(253),
    [anon_sym_DASHilike] = ACTIONS(253),
    [anon_sym_DASHilt] = ACTIONS(253),
    [anon_sym_DASHimatch] = ACTIONS(253),
    [anon_sym_DASHin] = ACTIONS(251),
    [anon_sym_DASHine] = ACTIONS(253),
    [anon_sym_DASHinotcontains] = ACTIONS(253),
    [anon_sym_DASHinotlike] = ACTIONS(253),
    [anon_sym_DASHinotmatch] = ACTIONS(253),
    [anon_sym_DASHireplace] = ACTIONS(253),
    [anon_sym_DASHis] = ACTIONS(251),
    [anon_sym_DASHisnot] = ACTIONS(253),
    [anon_sym_DASHisplit] = ACTIONS(253),
    [anon_sym_DASHjoin] = ACTIONS(253),
    [anon_sym_DASHle] = ACTIONS(253),
    [anon_sym_DASHlike] = ACTIONS(253),
    [anon_sym_DASHlt] = ACTIONS(253),
    [anon_sym_DASHmatch] = ACTIONS(253),
    [anon_sym_DASHne] = ACTIONS(253),
    [anon_sym_DASHnotcontains] = ACTIONS(253),
    [anon_sym_DASHnotin] = ACTIONS(253),
    [anon_sym_DASHnotlike] = ACTIONS(253),
    [anon_sym_DASHnotmatch] = ACTIONS(253),
    [anon_sym_DASHreplace] = ACTIONS(253),
    [anon_sym_DASHshl] = ACTIONS(253),
    [anon_sym_DASHshr] = ACTIONS(253),
    [anon_sym_DASHsplit] = ACTIONS(253),
    [sym_format_operator] = ACTIONS(253),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(253),
    [anon_sym_DOLLAR_CARET] = ACTIONS(253),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(253),
    [anon_sym_DOLLAR_] = ACTIONS(251),
    [aux_sym_variable_token1] = ACTIONS(251),
    [aux_sym_variable_token2] = ACTIONS(253),
    [sym_braced_variable] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(253),
    [anon_sym_COMMA] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(253),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DASHand] = ACTIONS(253),
    [anon_sym_DASHor] = ACTIONS(253),
    [anon_sym_DASHxor] = ACTIONS(253),
    [anon_sym_DASHband] = ACTIONS(253),
    [anon_sym_DASHbor] = ACTIONS(253),
    [anon_sym_DASHbxor] = ACTIONS(253),
    [anon_sym_PLUS] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_BSLASH] = ACTIONS(253),
    [anon_sym_STAR] = ACTIONS(253),
    [anon_sym_DOT_DOT] = ACTIONS(253),
    [anon_sym_DASHnot] = ACTIONS(251),
    [anon_sym_BANG] = ACTIONS(253),
    [anon_sym_DASHbnot] = ACTIONS(253),
    [anon_sym_PLUS_PLUS] = ACTIONS(253),
    [anon_sym_DASH_DASH] = ACTIONS(253),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_AT_LPAREN] = ACTIONS(253),
    [anon_sym_AT_LBRACE] = ACTIONS(253),
    [anon_sym_DOT2] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(253),
    [anon_sym_RBRACK] = ACTIONS(253),
    [anon_sym_DOTforeach] = ACTIONS(253),
  },
  [190] = {
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(251),
    [sym_hexadecimal_integer_literal] = ACTIONS(253),
    [sym_real_literal] = ACTIONS(253),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(253),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(253),
    [sym_verbatim_string_characters] = ACTIONS(253),
    [sym_verbatim_here_string_characters] = ACTIONS(253),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_DASHas] = ACTIONS(253),
    [anon_sym_DASHccontains] = ACTIONS(253),
    [anon_sym_DASHceq] = ACTIONS(253),
    [anon_sym_DASHcge] = ACTIONS(253),
    [anon_sym_DASHcgt] = ACTIONS(253),
    [anon_sym_DASHcle] = ACTIONS(253),
    [anon_sym_DASHclike] = ACTIONS(253),
    [anon_sym_DASHclt] = ACTIONS(253),
    [anon_sym_DASHcmatch] = ACTIONS(253),
    [anon_sym_DASHcne] = ACTIONS(253),
    [anon_sym_DASHcnotcontains] = ACTIONS(253),
    [anon_sym_DASHcnotlike] = ACTIONS(253),
    [anon_sym_DASHcnotmatch] = ACTIONS(253),
    [anon_sym_DASHcontains] = ACTIONS(253),
    [anon_sym_DASHcreplace] = ACTIONS(253),
    [anon_sym_DASHcsplit] = ACTIONS(253),
    [anon_sym_DASHeq] = ACTIONS(253),
    [anon_sym_DASHge] = ACTIONS(253),
    [anon_sym_DASHgt] = ACTIONS(253),
    [anon_sym_DASHicontains] = ACTIONS(253),
    [anon_sym_DASHieq] = ACTIONS(253),
    [anon_sym_DASHige] = ACTIONS(253),
    [anon_sym_DASHigt] = ACTIONS(253),
    [anon_sym_DASHile] = ACTIONS(253),
    [anon_sym_DASHilike] = ACTIONS(253),
    [anon_sym_DASHilt] = ACTIONS(253),
    [anon_sym_DASHimatch] = ACTIONS(253),
    [anon_sym_DASHin] = ACTIONS(251),
    [anon_sym_DASHine] = ACTIONS(253),
    [anon_sym_DASHinotcontains] = ACTIONS(253),
    [anon_sym_DASHinotlike] = ACTIONS(253),
    [anon_sym_DASHinotmatch] = ACTIONS(253),
    [anon_sym_DASHireplace] = ACTIONS(253),
    [anon_sym_DASHis] = ACTIONS(251),
    [anon_sym_DASHisnot] = ACTIONS(253),
    [anon_sym_DASHisplit] = ACTIONS(253),
    [anon_sym_DASHjoin] = ACTIONS(253),
    [anon_sym_DASHle] = ACTIONS(253),
    [anon_sym_DASHlike] = ACTIONS(253),
    [anon_sym_DASHlt] = ACTIONS(253),
    [anon_sym_DASHmatch] = ACTIONS(253),
    [anon_sym_DASHne] = ACTIONS(253),
    [anon_sym_DASHnotcontains] = ACTIONS(253),
    [anon_sym_DASHnotin] = ACTIONS(253),
    [anon_sym_DASHnotlike] = ACTIONS(253),
    [anon_sym_DASHnotmatch] = ACTIONS(253),
    [anon_sym_DASHreplace] = ACTIONS(253),
    [anon_sym_DASHshl] = ACTIONS(253),
    [anon_sym_DASHshr] = ACTIONS(253),
    [anon_sym_DASHsplit] = ACTIONS(253),
    [sym_format_operator] = ACTIONS(253),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(253),
    [anon_sym_DOLLAR_CARET] = ACTIONS(253),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(253),
    [anon_sym_DOLLAR_] = ACTIONS(251),
    [aux_sym_variable_token1] = ACTIONS(251),
    [aux_sym_variable_token2] = ACTIONS(253),
    [sym_braced_variable] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_COMMA] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(253),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DASHand] = ACTIONS(253),
    [anon_sym_DASHor] = ACTIONS(253),
    [anon_sym_DASHxor] = ACTIONS(253),
    [anon_sym_DASHband] = ACTIONS(253),
    [anon_sym_DASHbor] = ACTIONS(253),
    [anon_sym_DASHbxor] = ACTIONS(253),
    [anon_sym_PLUS] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_SLASH] = ACTIONS(253),
    [anon_sym_BSLASH] = ACTIONS(253),
    [anon_sym_STAR] = ACTIONS(253),
    [anon_sym_DOT_DOT] = ACTIONS(253),
    [anon_sym_DASHnot] = ACTIONS(251),
    [anon_sym_BANG] = ACTIONS(253),
    [anon_sym_DASHbnot] = ACTIONS(253),
    [anon_sym_PLUS_PLUS] = ACTIONS(253),
    [anon_sym_DASH_DASH] = ACTIONS(253),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_AT_LPAREN] = ACTIONS(253),
    [anon_sym_AT_LBRACE] = ACTIONS(253),
    [anon_sym_DOT2] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(253),
    [anon_sym_DOTforeach] = ACTIONS(253),
    [sym__statement_terminator] = ACTIONS(253),
  },
  [191] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_BANG_EQ] = ACTIONS(825),
    [anon_sym_PLUS_EQ] = ACTIONS(825),
    [anon_sym_STAR_EQ] = ACTIONS(825),
    [anon_sym_SLASH_EQ] = ACTIONS(825),
    [anon_sym_PERCENT_EQ] = ACTIONS(825),
    [anon_sym_GT] = ACTIONS(827),
    [anon_sym_GT_GT] = ACTIONS(825),
    [anon_sym_2_GT] = ACTIONS(827),
    [anon_sym_2_GT_GT] = ACTIONS(825),
    [anon_sym_3_GT] = ACTIONS(827),
    [anon_sym_3_GT_GT] = ACTIONS(825),
    [anon_sym_4_GT] = ACTIONS(827),
    [anon_sym_4_GT_GT] = ACTIONS(825),
    [anon_sym_5_GT] = ACTIONS(827),
    [anon_sym_5_GT_GT] = ACTIONS(825),
    [anon_sym_6_GT] = ACTIONS(827),
    [anon_sym_6_GT_GT] = ACTIONS(825),
    [anon_sym_STAR_GT] = ACTIONS(827),
    [anon_sym_STAR_GT_GT] = ACTIONS(825),
    [anon_sym_LT] = ACTIONS(827),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(825),
    [anon_sym_2_GT_AMP1] = ACTIONS(825),
    [anon_sym_3_GT_AMP1] = ACTIONS(825),
    [anon_sym_4_GT_AMP1] = ACTIONS(825),
    [anon_sym_5_GT_AMP1] = ACTIONS(825),
    [anon_sym_6_GT_AMP1] = ACTIONS(825),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(825),
    [anon_sym_1_GT_AMP2] = ACTIONS(825),
    [anon_sym_3_GT_AMP2] = ACTIONS(825),
    [anon_sym_4_GT_AMP2] = ACTIONS(825),
    [anon_sym_5_GT_AMP2] = ACTIONS(825),
    [anon_sym_6_GT_AMP2] = ACTIONS(825),
    [anon_sym_DASHas] = ACTIONS(825),
    [anon_sym_DASHccontains] = ACTIONS(825),
    [anon_sym_DASHceq] = ACTIONS(825),
    [anon_sym_DASHcge] = ACTIONS(825),
    [anon_sym_DASHcgt] = ACTIONS(825),
    [anon_sym_DASHcle] = ACTIONS(825),
    [anon_sym_DASHclike] = ACTIONS(825),
    [anon_sym_DASHclt] = ACTIONS(825),
    [anon_sym_DASHcmatch] = ACTIONS(825),
    [anon_sym_DASHcne] = ACTIONS(825),
    [anon_sym_DASHcnotcontains] = ACTIONS(825),
    [anon_sym_DASHcnotlike] = ACTIONS(825),
    [anon_sym_DASHcnotmatch] = ACTIONS(825),
    [anon_sym_DASHcontains] = ACTIONS(825),
    [anon_sym_DASHcreplace] = ACTIONS(825),
    [anon_sym_DASHcsplit] = ACTIONS(825),
    [anon_sym_DASHeq] = ACTIONS(825),
    [anon_sym_DASHge] = ACTIONS(825),
    [anon_sym_DASHgt] = ACTIONS(825),
    [anon_sym_DASHicontains] = ACTIONS(825),
    [anon_sym_DASHieq] = ACTIONS(825),
    [anon_sym_DASHige] = ACTIONS(825),
    [anon_sym_DASHigt] = ACTIONS(825),
    [anon_sym_DASHile] = ACTIONS(825),
    [anon_sym_DASHilike] = ACTIONS(825),
    [anon_sym_DASHilt] = ACTIONS(825),
    [anon_sym_DASHimatch] = ACTIONS(825),
    [anon_sym_DASHin] = ACTIONS(827),
    [anon_sym_DASHine] = ACTIONS(825),
    [anon_sym_DASHinotcontains] = ACTIONS(825),
    [anon_sym_DASHinotlike] = ACTIONS(825),
    [anon_sym_DASHinotmatch] = ACTIONS(825),
    [anon_sym_DASHireplace] = ACTIONS(825),
    [anon_sym_DASHis] = ACTIONS(827),
    [anon_sym_DASHisnot] = ACTIONS(825),
    [anon_sym_DASHisplit] = ACTIONS(825),
    [anon_sym_DASHjoin] = ACTIONS(825),
    [anon_sym_DASHle] = ACTIONS(825),
    [anon_sym_DASHlike] = ACTIONS(825),
    [anon_sym_DASHlt] = ACTIONS(825),
    [anon_sym_DASHmatch] = ACTIONS(825),
    [anon_sym_DASHne] = ACTIONS(825),
    [anon_sym_DASHnotcontains] = ACTIONS(825),
    [anon_sym_DASHnotin] = ACTIONS(825),
    [anon_sym_DASHnotlike] = ACTIONS(825),
    [anon_sym_DASHnotmatch] = ACTIONS(825),
    [anon_sym_DASHreplace] = ACTIONS(825),
    [anon_sym_DASHshl] = ACTIONS(825),
    [anon_sym_DASHshr] = ACTIONS(825),
    [anon_sym_DASHsplit] = ACTIONS(825),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_DASHand] = ACTIONS(825),
    [anon_sym_DASHor] = ACTIONS(825),
    [anon_sym_DASHxor] = ACTIONS(825),
    [anon_sym_DASHband] = ACTIONS(825),
    [anon_sym_DASHbor] = ACTIONS(825),
    [anon_sym_DASHbxor] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(829),
    [anon_sym_DASH] = ACTIONS(829),
    [sym__statement_terminator] = ACTIONS(825),
  },
  [192] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_BANG_EQ] = ACTIONS(825),
    [anon_sym_PLUS_EQ] = ACTIONS(825),
    [anon_sym_STAR_EQ] = ACTIONS(825),
    [anon_sym_SLASH_EQ] = ACTIONS(825),
    [anon_sym_PERCENT_EQ] = ACTIONS(825),
    [anon_sym_GT] = ACTIONS(827),
    [anon_sym_GT_GT] = ACTIONS(825),
    [anon_sym_2_GT] = ACTIONS(827),
    [anon_sym_2_GT_GT] = ACTIONS(825),
    [anon_sym_3_GT] = ACTIONS(827),
    [anon_sym_3_GT_GT] = ACTIONS(825),
    [anon_sym_4_GT] = ACTIONS(827),
    [anon_sym_4_GT_GT] = ACTIONS(825),
    [anon_sym_5_GT] = ACTIONS(827),
    [anon_sym_5_GT_GT] = ACTIONS(825),
    [anon_sym_6_GT] = ACTIONS(827),
    [anon_sym_6_GT_GT] = ACTIONS(825),
    [anon_sym_STAR_GT] = ACTIONS(827),
    [anon_sym_STAR_GT_GT] = ACTIONS(825),
    [anon_sym_LT] = ACTIONS(827),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(825),
    [anon_sym_2_GT_AMP1] = ACTIONS(825),
    [anon_sym_3_GT_AMP1] = ACTIONS(825),
    [anon_sym_4_GT_AMP1] = ACTIONS(825),
    [anon_sym_5_GT_AMP1] = ACTIONS(825),
    [anon_sym_6_GT_AMP1] = ACTIONS(825),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(825),
    [anon_sym_1_GT_AMP2] = ACTIONS(825),
    [anon_sym_3_GT_AMP2] = ACTIONS(825),
    [anon_sym_4_GT_AMP2] = ACTIONS(825),
    [anon_sym_5_GT_AMP2] = ACTIONS(825),
    [anon_sym_6_GT_AMP2] = ACTIONS(825),
    [anon_sym_DASHas] = ACTIONS(825),
    [anon_sym_DASHccontains] = ACTIONS(825),
    [anon_sym_DASHceq] = ACTIONS(825),
    [anon_sym_DASHcge] = ACTIONS(825),
    [anon_sym_DASHcgt] = ACTIONS(825),
    [anon_sym_DASHcle] = ACTIONS(825),
    [anon_sym_DASHclike] = ACTIONS(825),
    [anon_sym_DASHclt] = ACTIONS(825),
    [anon_sym_DASHcmatch] = ACTIONS(825),
    [anon_sym_DASHcne] = ACTIONS(825),
    [anon_sym_DASHcnotcontains] = ACTIONS(825),
    [anon_sym_DASHcnotlike] = ACTIONS(825),
    [anon_sym_DASHcnotmatch] = ACTIONS(825),
    [anon_sym_DASHcontains] = ACTIONS(825),
    [anon_sym_DASHcreplace] = ACTIONS(825),
    [anon_sym_DASHcsplit] = ACTIONS(825),
    [anon_sym_DASHeq] = ACTIONS(825),
    [anon_sym_DASHge] = ACTIONS(825),
    [anon_sym_DASHgt] = ACTIONS(825),
    [anon_sym_DASHicontains] = ACTIONS(825),
    [anon_sym_DASHieq] = ACTIONS(825),
    [anon_sym_DASHige] = ACTIONS(825),
    [anon_sym_DASHigt] = ACTIONS(825),
    [anon_sym_DASHile] = ACTIONS(825),
    [anon_sym_DASHilike] = ACTIONS(825),
    [anon_sym_DASHilt] = ACTIONS(825),
    [anon_sym_DASHimatch] = ACTIONS(825),
    [anon_sym_DASHin] = ACTIONS(827),
    [anon_sym_DASHine] = ACTIONS(825),
    [anon_sym_DASHinotcontains] = ACTIONS(825),
    [anon_sym_DASHinotlike] = ACTIONS(825),
    [anon_sym_DASHinotmatch] = ACTIONS(825),
    [anon_sym_DASHireplace] = ACTIONS(825),
    [anon_sym_DASHis] = ACTIONS(827),
    [anon_sym_DASHisnot] = ACTIONS(825),
    [anon_sym_DASHisplit] = ACTIONS(825),
    [anon_sym_DASHjoin] = ACTIONS(825),
    [anon_sym_DASHle] = ACTIONS(825),
    [anon_sym_DASHlike] = ACTIONS(825),
    [anon_sym_DASHlt] = ACTIONS(825),
    [anon_sym_DASHmatch] = ACTIONS(825),
    [anon_sym_DASHne] = ACTIONS(825),
    [anon_sym_DASHnotcontains] = ACTIONS(825),
    [anon_sym_DASHnotin] = ACTIONS(825),
    [anon_sym_DASHnotlike] = ACTIONS(825),
    [anon_sym_DASHnotmatch] = ACTIONS(825),
    [anon_sym_DASHreplace] = ACTIONS(825),
    [anon_sym_DASHshl] = ACTIONS(825),
    [anon_sym_DASHshr] = ACTIONS(825),
    [anon_sym_DASHsplit] = ACTIONS(825),
    [anon_sym_RPAREN] = ACTIONS(825),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_DASHand] = ACTIONS(825),
    [anon_sym_DASHor] = ACTIONS(825),
    [anon_sym_DASHxor] = ACTIONS(825),
    [anon_sym_DASHband] = ACTIONS(825),
    [anon_sym_DASHbor] = ACTIONS(825),
    [anon_sym_DASHbxor] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
  },
  [193] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(833),
    [anon_sym_BANG_EQ] = ACTIONS(833),
    [anon_sym_PLUS_EQ] = ACTIONS(833),
    [anon_sym_STAR_EQ] = ACTIONS(833),
    [anon_sym_SLASH_EQ] = ACTIONS(833),
    [anon_sym_PERCENT_EQ] = ACTIONS(833),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_2_GT] = ACTIONS(835),
    [anon_sym_2_GT_GT] = ACTIONS(833),
    [anon_sym_3_GT] = ACTIONS(835),
    [anon_sym_3_GT_GT] = ACTIONS(833),
    [anon_sym_4_GT] = ACTIONS(835),
    [anon_sym_4_GT_GT] = ACTIONS(833),
    [anon_sym_5_GT] = ACTIONS(835),
    [anon_sym_5_GT_GT] = ACTIONS(833),
    [anon_sym_6_GT] = ACTIONS(835),
    [anon_sym_6_GT_GT] = ACTIONS(833),
    [anon_sym_STAR_GT] = ACTIONS(835),
    [anon_sym_STAR_GT_GT] = ACTIONS(833),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(833),
    [anon_sym_2_GT_AMP1] = ACTIONS(833),
    [anon_sym_3_GT_AMP1] = ACTIONS(833),
    [anon_sym_4_GT_AMP1] = ACTIONS(833),
    [anon_sym_5_GT_AMP1] = ACTIONS(833),
    [anon_sym_6_GT_AMP1] = ACTIONS(833),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(833),
    [anon_sym_1_GT_AMP2] = ACTIONS(833),
    [anon_sym_3_GT_AMP2] = ACTIONS(833),
    [anon_sym_4_GT_AMP2] = ACTIONS(833),
    [anon_sym_5_GT_AMP2] = ACTIONS(833),
    [anon_sym_6_GT_AMP2] = ACTIONS(833),
    [anon_sym_DASHas] = ACTIONS(833),
    [anon_sym_DASHccontains] = ACTIONS(833),
    [anon_sym_DASHceq] = ACTIONS(833),
    [anon_sym_DASHcge] = ACTIONS(833),
    [anon_sym_DASHcgt] = ACTIONS(833),
    [anon_sym_DASHcle] = ACTIONS(833),
    [anon_sym_DASHclike] = ACTIONS(833),
    [anon_sym_DASHclt] = ACTIONS(833),
    [anon_sym_DASHcmatch] = ACTIONS(833),
    [anon_sym_DASHcne] = ACTIONS(833),
    [anon_sym_DASHcnotcontains] = ACTIONS(833),
    [anon_sym_DASHcnotlike] = ACTIONS(833),
    [anon_sym_DASHcnotmatch] = ACTIONS(833),
    [anon_sym_DASHcontains] = ACTIONS(833),
    [anon_sym_DASHcreplace] = ACTIONS(833),
    [anon_sym_DASHcsplit] = ACTIONS(833),
    [anon_sym_DASHeq] = ACTIONS(833),
    [anon_sym_DASHge] = ACTIONS(833),
    [anon_sym_DASHgt] = ACTIONS(833),
    [anon_sym_DASHicontains] = ACTIONS(833),
    [anon_sym_DASHieq] = ACTIONS(833),
    [anon_sym_DASHige] = ACTIONS(833),
    [anon_sym_DASHigt] = ACTIONS(833),
    [anon_sym_DASHile] = ACTIONS(833),
    [anon_sym_DASHilike] = ACTIONS(833),
    [anon_sym_DASHilt] = ACTIONS(833),
    [anon_sym_DASHimatch] = ACTIONS(833),
    [anon_sym_DASHin] = ACTIONS(835),
    [anon_sym_DASHine] = ACTIONS(833),
    [anon_sym_DASHinotcontains] = ACTIONS(833),
    [anon_sym_DASHinotlike] = ACTIONS(833),
    [anon_sym_DASHinotmatch] = ACTIONS(833),
    [anon_sym_DASHireplace] = ACTIONS(833),
    [anon_sym_DASHis] = ACTIONS(835),
    [anon_sym_DASHisnot] = ACTIONS(833),
    [anon_sym_DASHisplit] = ACTIONS(833),
    [anon_sym_DASHjoin] = ACTIONS(833),
    [anon_sym_DASHle] = ACTIONS(833),
    [anon_sym_DASHlike] = ACTIONS(833),
    [anon_sym_DASHlt] = ACTIONS(833),
    [anon_sym_DASHmatch] = ACTIONS(833),
    [anon_sym_DASHne] = ACTIONS(833),
    [anon_sym_DASHnotcontains] = ACTIONS(833),
    [anon_sym_DASHnotin] = ACTIONS(833),
    [anon_sym_DASHnotlike] = ACTIONS(833),
    [anon_sym_DASHnotmatch] = ACTIONS(833),
    [anon_sym_DASHreplace] = ACTIONS(833),
    [anon_sym_DASHshl] = ACTIONS(833),
    [anon_sym_DASHshr] = ACTIONS(833),
    [anon_sym_DASHsplit] = ACTIONS(833),
    [anon_sym_RPAREN] = ACTIONS(833),
    [anon_sym_PIPE] = ACTIONS(833),
    [anon_sym_DASHand] = ACTIONS(833),
    [anon_sym_DASHor] = ACTIONS(833),
    [anon_sym_DASHxor] = ACTIONS(833),
    [anon_sym_DASHband] = ACTIONS(833),
    [anon_sym_DASHbor] = ACTIONS(833),
    [anon_sym_DASHbxor] = ACTIONS(833),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
  },
  [194] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(833),
    [anon_sym_BANG_EQ] = ACTIONS(833),
    [anon_sym_PLUS_EQ] = ACTIONS(833),
    [anon_sym_STAR_EQ] = ACTIONS(833),
    [anon_sym_SLASH_EQ] = ACTIONS(833),
    [anon_sym_PERCENT_EQ] = ACTIONS(833),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_GT] = ACTIONS(833),
    [anon_sym_2_GT] = ACTIONS(835),
    [anon_sym_2_GT_GT] = ACTIONS(833),
    [anon_sym_3_GT] = ACTIONS(835),
    [anon_sym_3_GT_GT] = ACTIONS(833),
    [anon_sym_4_GT] = ACTIONS(835),
    [anon_sym_4_GT_GT] = ACTIONS(833),
    [anon_sym_5_GT] = ACTIONS(835),
    [anon_sym_5_GT_GT] = ACTIONS(833),
    [anon_sym_6_GT] = ACTIONS(835),
    [anon_sym_6_GT_GT] = ACTIONS(833),
    [anon_sym_STAR_GT] = ACTIONS(835),
    [anon_sym_STAR_GT_GT] = ACTIONS(833),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(833),
    [anon_sym_2_GT_AMP1] = ACTIONS(833),
    [anon_sym_3_GT_AMP1] = ACTIONS(833),
    [anon_sym_4_GT_AMP1] = ACTIONS(833),
    [anon_sym_5_GT_AMP1] = ACTIONS(833),
    [anon_sym_6_GT_AMP1] = ACTIONS(833),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(833),
    [anon_sym_1_GT_AMP2] = ACTIONS(833),
    [anon_sym_3_GT_AMP2] = ACTIONS(833),
    [anon_sym_4_GT_AMP2] = ACTIONS(833),
    [anon_sym_5_GT_AMP2] = ACTIONS(833),
    [anon_sym_6_GT_AMP2] = ACTIONS(833),
    [anon_sym_DASHas] = ACTIONS(833),
    [anon_sym_DASHccontains] = ACTIONS(833),
    [anon_sym_DASHceq] = ACTIONS(833),
    [anon_sym_DASHcge] = ACTIONS(833),
    [anon_sym_DASHcgt] = ACTIONS(833),
    [anon_sym_DASHcle] = ACTIONS(833),
    [anon_sym_DASHclike] = ACTIONS(833),
    [anon_sym_DASHclt] = ACTIONS(833),
    [anon_sym_DASHcmatch] = ACTIONS(833),
    [anon_sym_DASHcne] = ACTIONS(833),
    [anon_sym_DASHcnotcontains] = ACTIONS(833),
    [anon_sym_DASHcnotlike] = ACTIONS(833),
    [anon_sym_DASHcnotmatch] = ACTIONS(833),
    [anon_sym_DASHcontains] = ACTIONS(833),
    [anon_sym_DASHcreplace] = ACTIONS(833),
    [anon_sym_DASHcsplit] = ACTIONS(833),
    [anon_sym_DASHeq] = ACTIONS(833),
    [anon_sym_DASHge] = ACTIONS(833),
    [anon_sym_DASHgt] = ACTIONS(833),
    [anon_sym_DASHicontains] = ACTIONS(833),
    [anon_sym_DASHieq] = ACTIONS(833),
    [anon_sym_DASHige] = ACTIONS(833),
    [anon_sym_DASHigt] = ACTIONS(833),
    [anon_sym_DASHile] = ACTIONS(833),
    [anon_sym_DASHilike] = ACTIONS(833),
    [anon_sym_DASHilt] = ACTIONS(833),
    [anon_sym_DASHimatch] = ACTIONS(833),
    [anon_sym_DASHin] = ACTIONS(835),
    [anon_sym_DASHine] = ACTIONS(833),
    [anon_sym_DASHinotcontains] = ACTIONS(833),
    [anon_sym_DASHinotlike] = ACTIONS(833),
    [anon_sym_DASHinotmatch] = ACTIONS(833),
    [anon_sym_DASHireplace] = ACTIONS(833),
    [anon_sym_DASHis] = ACTIONS(835),
    [anon_sym_DASHisnot] = ACTIONS(833),
    [anon_sym_DASHisplit] = ACTIONS(833),
    [anon_sym_DASHjoin] = ACTIONS(833),
    [anon_sym_DASHle] = ACTIONS(833),
    [anon_sym_DASHlike] = ACTIONS(833),
    [anon_sym_DASHlt] = ACTIONS(833),
    [anon_sym_DASHmatch] = ACTIONS(833),
    [anon_sym_DASHne] = ACTIONS(833),
    [anon_sym_DASHnotcontains] = ACTIONS(833),
    [anon_sym_DASHnotin] = ACTIONS(833),
    [anon_sym_DASHnotlike] = ACTIONS(833),
    [anon_sym_DASHnotmatch] = ACTIONS(833),
    [anon_sym_DASHreplace] = ACTIONS(833),
    [anon_sym_DASHshl] = ACTIONS(833),
    [anon_sym_DASHshr] = ACTIONS(833),
    [anon_sym_DASHsplit] = ACTIONS(833),
    [anon_sym_PIPE] = ACTIONS(833),
    [anon_sym_DASHand] = ACTIONS(833),
    [anon_sym_DASHor] = ACTIONS(833),
    [anon_sym_DASHxor] = ACTIONS(833),
    [anon_sym_DASHband] = ACTIONS(833),
    [anon_sym_DASHbor] = ACTIONS(833),
    [anon_sym_DASHbxor] = ACTIONS(833),
    [anon_sym_PLUS] = ACTIONS(829),
    [anon_sym_DASH] = ACTIONS(829),
    [sym__statement_terminator] = ACTIONS(833),
  },
  [195] = {
    [sym__literal] = STATE(768),
    [sym_integer_literal] = STATE(768),
    [sym_string_literal] = STATE(768),
    [sym_expandable_string_literal] = STATE(771),
    [sym_expandable_here_string_literal] = STATE(771),
    [sym_variable] = STATE(768),
    [sym_unary_expression] = STATE(785),
    [sym_expression_with_unary_operator] = STATE(789),
    [sym_pre_increment_expression] = STATE(780),
    [sym_pre_decrement_expression] = STATE(780),
    [sym_cast_expression] = STATE(780),
    [sym__primary_expression] = STATE(768),
    [sym__value] = STATE(768),
    [sym_parenthesized_expression] = STATE(768),
    [sym_sub_expression] = STATE(768),
    [sym_array_expression] = STATE(768),
    [sym_script_block_expression] = STATE(768),
    [sym_hash_literal_expression] = STATE(768),
    [sym_post_increment_expression] = STATE(768),
    [sym_post_decrement_expression] = STATE(768),
    [sym_member_access] = STATE(768),
    [sym_element_access] = STATE(768),
    [sym_invokation_expression] = STATE(768),
    [sym_invokation_foreach_expression] = STATE(767),
    [sym_type_literal] = STATE(195),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(837),
    [sym_hexadecimal_integer_literal] = ACTIONS(837),
    [sym_real_literal] = ACTIONS(839),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(841),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(843),
    [sym_verbatim_string_characters] = ACTIONS(845),
    [sym_verbatim_here_string_characters] = ACTIONS(845),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_GT] = ACTIONS(97),
    [anon_sym_2_GT] = ACTIONS(97),
    [anon_sym_2_GT_GT] = ACTIONS(97),
    [anon_sym_3_GT] = ACTIONS(97),
    [anon_sym_3_GT_GT] = ACTIONS(97),
    [anon_sym_4_GT] = ACTIONS(97),
    [anon_sym_4_GT_GT] = ACTIONS(97),
    [anon_sym_5_GT] = ACTIONS(97),
    [anon_sym_5_GT_GT] = ACTIONS(97),
    [anon_sym_6_GT] = ACTIONS(97),
    [anon_sym_6_GT_GT] = ACTIONS(97),
    [anon_sym_STAR_GT] = ACTIONS(97),
    [anon_sym_STAR_GT_GT] = ACTIONS(97),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(97),
    [anon_sym_2_GT_AMP1] = ACTIONS(97),
    [anon_sym_3_GT_AMP1] = ACTIONS(97),
    [anon_sym_4_GT_AMP1] = ACTIONS(97),
    [anon_sym_5_GT_AMP1] = ACTIONS(97),
    [anon_sym_6_GT_AMP1] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(97),
    [anon_sym_1_GT_AMP2] = ACTIONS(97),
    [anon_sym_3_GT_AMP2] = ACTIONS(97),
    [anon_sym_4_GT_AMP2] = ACTIONS(97),
    [anon_sym_5_GT_AMP2] = ACTIONS(97),
    [anon_sym_6_GT_AMP2] = ACTIONS(97),
    [anon_sym_DASHjoin] = ACTIONS(849),
    [anon_sym_DASHsplit] = ACTIONS(849),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(851),
    [anon_sym_DOLLAR_CARET] = ACTIONS(851),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(851),
    [anon_sym_DOLLAR_] = ACTIONS(851),
    [aux_sym_variable_token1] = ACTIONS(851),
    [aux_sym_variable_token2] = ACTIONS(851),
    [sym_braced_variable] = ACTIONS(851),
    [sym_command_parameter] = ACTIONS(97),
    [anon_sym_LPAREN] = ACTIONS(853),
    [anon_sym_COMMA] = ACTIONS(849),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_PIPE] = ACTIONS(97),
    [sym_stop_parsing] = ACTIONS(97),
    [anon_sym_SPACE] = ACTIONS(95),
    [anon_sym_COLON] = ACTIONS(97),
    [anon_sym_DASH_DASH_PERCENT] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_DASHnot] = ACTIONS(849),
    [anon_sym_BANG] = ACTIONS(849),
    [anon_sym_DASHbnot] = ACTIONS(849),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(859),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [anon_sym_AT_LPAREN] = ACTIONS(863),
    [anon_sym_AT_LBRACE] = ACTIONS(865),
    [anon_sym_DOT2] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(97),
    [anon_sym_DOTforeach] = ACTIONS(95),
    [sym__statement_terminator] = ACTIONS(95),
  },
  [196] = {
    [sym_comparison_operator] = STATE(520),
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(867),
    [anon_sym_BANG_EQ] = ACTIONS(867),
    [anon_sym_PLUS_EQ] = ACTIONS(867),
    [anon_sym_STAR_EQ] = ACTIONS(867),
    [anon_sym_SLASH_EQ] = ACTIONS(867),
    [anon_sym_PERCENT_EQ] = ACTIONS(867),
    [anon_sym_GT] = ACTIONS(869),
    [anon_sym_GT_GT] = ACTIONS(867),
    [anon_sym_2_GT] = ACTIONS(869),
    [anon_sym_2_GT_GT] = ACTIONS(867),
    [anon_sym_3_GT] = ACTIONS(869),
    [anon_sym_3_GT_GT] = ACTIONS(867),
    [anon_sym_4_GT] = ACTIONS(869),
    [anon_sym_4_GT_GT] = ACTIONS(867),
    [anon_sym_5_GT] = ACTIONS(869),
    [anon_sym_5_GT_GT] = ACTIONS(867),
    [anon_sym_6_GT] = ACTIONS(869),
    [anon_sym_6_GT_GT] = ACTIONS(867),
    [anon_sym_STAR_GT] = ACTIONS(869),
    [anon_sym_STAR_GT_GT] = ACTIONS(867),
    [anon_sym_LT] = ACTIONS(869),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(867),
    [anon_sym_2_GT_AMP1] = ACTIONS(867),
    [anon_sym_3_GT_AMP1] = ACTIONS(867),
    [anon_sym_4_GT_AMP1] = ACTIONS(867),
    [anon_sym_5_GT_AMP1] = ACTIONS(867),
    [anon_sym_6_GT_AMP1] = ACTIONS(867),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(867),
    [anon_sym_1_GT_AMP2] = ACTIONS(867),
    [anon_sym_3_GT_AMP2] = ACTIONS(867),
    [anon_sym_4_GT_AMP2] = ACTIONS(867),
    [anon_sym_5_GT_AMP2] = ACTIONS(867),
    [anon_sym_6_GT_AMP2] = ACTIONS(867),
    [anon_sym_DASHas] = ACTIONS(871),
    [anon_sym_DASHccontains] = ACTIONS(871),
    [anon_sym_DASHceq] = ACTIONS(871),
    [anon_sym_DASHcge] = ACTIONS(871),
    [anon_sym_DASHcgt] = ACTIONS(871),
    [anon_sym_DASHcle] = ACTIONS(871),
    [anon_sym_DASHclike] = ACTIONS(871),
    [anon_sym_DASHclt] = ACTIONS(871),
    [anon_sym_DASHcmatch] = ACTIONS(871),
    [anon_sym_DASHcne] = ACTIONS(871),
    [anon_sym_DASHcnotcontains] = ACTIONS(871),
    [anon_sym_DASHcnotlike] = ACTIONS(871),
    [anon_sym_DASHcnotmatch] = ACTIONS(871),
    [anon_sym_DASHcontains] = ACTIONS(871),
    [anon_sym_DASHcreplace] = ACTIONS(871),
    [anon_sym_DASHcsplit] = ACTIONS(871),
    [anon_sym_DASHeq] = ACTIONS(871),
    [anon_sym_DASHge] = ACTIONS(871),
    [anon_sym_DASHgt] = ACTIONS(871),
    [anon_sym_DASHicontains] = ACTIONS(871),
    [anon_sym_DASHieq] = ACTIONS(871),
    [anon_sym_DASHige] = ACTIONS(871),
    [anon_sym_DASHigt] = ACTIONS(871),
    [anon_sym_DASHile] = ACTIONS(871),
    [anon_sym_DASHilike] = ACTIONS(871),
    [anon_sym_DASHilt] = ACTIONS(871),
    [anon_sym_DASHimatch] = ACTIONS(871),
    [anon_sym_DASHin] = ACTIONS(873),
    [anon_sym_DASHine] = ACTIONS(871),
    [anon_sym_DASHinotcontains] = ACTIONS(871),
    [anon_sym_DASHinotlike] = ACTIONS(871),
    [anon_sym_DASHinotmatch] = ACTIONS(871),
    [anon_sym_DASHireplace] = ACTIONS(871),
    [anon_sym_DASHis] = ACTIONS(873),
    [anon_sym_DASHisnot] = ACTIONS(871),
    [anon_sym_DASHisplit] = ACTIONS(871),
    [anon_sym_DASHjoin] = ACTIONS(871),
    [anon_sym_DASHle] = ACTIONS(871),
    [anon_sym_DASHlike] = ACTIONS(871),
    [anon_sym_DASHlt] = ACTIONS(871),
    [anon_sym_DASHmatch] = ACTIONS(871),
    [anon_sym_DASHne] = ACTIONS(871),
    [anon_sym_DASHnotcontains] = ACTIONS(871),
    [anon_sym_DASHnotin] = ACTIONS(871),
    [anon_sym_DASHnotlike] = ACTIONS(871),
    [anon_sym_DASHnotmatch] = ACTIONS(871),
    [anon_sym_DASHreplace] = ACTIONS(871),
    [anon_sym_DASHshl] = ACTIONS(871),
    [anon_sym_DASHshr] = ACTIONS(871),
    [anon_sym_DASHsplit] = ACTIONS(871),
    [anon_sym_PIPE] = ACTIONS(867),
    [anon_sym_DASHand] = ACTIONS(867),
    [anon_sym_DASHor] = ACTIONS(867),
    [anon_sym_DASHxor] = ACTIONS(867),
    [anon_sym_DASHband] = ACTIONS(867),
    [anon_sym_DASHbor] = ACTIONS(867),
    [anon_sym_DASHbxor] = ACTIONS(867),
    [sym__statement_terminator] = ACTIONS(867),
  },
  [197] = {
    [sym__literal] = STATE(913),
    [sym_integer_literal] = STATE(913),
    [sym_string_literal] = STATE(913),
    [sym_expandable_string_literal] = STATE(771),
    [sym_expandable_here_string_literal] = STATE(771),
    [sym_variable] = STATE(913),
    [sym_unary_expression] = STATE(1031),
    [sym_expression_with_unary_operator] = STATE(1049),
    [sym_pre_increment_expression] = STATE(1047),
    [sym_pre_decrement_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1047),
    [sym__primary_expression] = STATE(913),
    [sym__value] = STATE(913),
    [sym_parenthesized_expression] = STATE(913),
    [sym_sub_expression] = STATE(913),
    [sym_array_expression] = STATE(913),
    [sym_script_block_expression] = STATE(913),
    [sym_hash_literal_expression] = STATE(913),
    [sym_post_increment_expression] = STATE(913),
    [sym_post_decrement_expression] = STATE(913),
    [sym_member_access] = STATE(913),
    [sym_element_access] = STATE(913),
    [sym_invokation_expression] = STATE(913),
    [sym_invokation_foreach_expression] = STATE(767),
    [sym_type_literal] = STATE(197),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(837),
    [sym_hexadecimal_integer_literal] = ACTIONS(837),
    [sym_real_literal] = ACTIONS(875),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(841),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(843),
    [sym_verbatim_string_characters] = ACTIONS(845),
    [sym_verbatim_here_string_characters] = ACTIONS(845),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_GT] = ACTIONS(97),
    [anon_sym_2_GT] = ACTIONS(97),
    [anon_sym_2_GT_GT] = ACTIONS(97),
    [anon_sym_3_GT] = ACTIONS(97),
    [anon_sym_3_GT_GT] = ACTIONS(97),
    [anon_sym_4_GT] = ACTIONS(97),
    [anon_sym_4_GT_GT] = ACTIONS(97),
    [anon_sym_5_GT] = ACTIONS(97),
    [anon_sym_5_GT_GT] = ACTIONS(97),
    [anon_sym_6_GT] = ACTIONS(97),
    [anon_sym_6_GT_GT] = ACTIONS(97),
    [anon_sym_STAR_GT] = ACTIONS(97),
    [anon_sym_STAR_GT_GT] = ACTIONS(97),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(97),
    [anon_sym_2_GT_AMP1] = ACTIONS(97),
    [anon_sym_3_GT_AMP1] = ACTIONS(97),
    [anon_sym_4_GT_AMP1] = ACTIONS(97),
    [anon_sym_5_GT_AMP1] = ACTIONS(97),
    [anon_sym_6_GT_AMP1] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(97),
    [anon_sym_1_GT_AMP2] = ACTIONS(97),
    [anon_sym_3_GT_AMP2] = ACTIONS(97),
    [anon_sym_4_GT_AMP2] = ACTIONS(97),
    [anon_sym_5_GT_AMP2] = ACTIONS(97),
    [anon_sym_6_GT_AMP2] = ACTIONS(97),
    [anon_sym_DASHjoin] = ACTIONS(877),
    [anon_sym_DASHsplit] = ACTIONS(877),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(851),
    [anon_sym_DOLLAR_CARET] = ACTIONS(851),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(851),
    [anon_sym_DOLLAR_] = ACTIONS(851),
    [aux_sym_variable_token1] = ACTIONS(851),
    [aux_sym_variable_token2] = ACTIONS(851),
    [sym_braced_variable] = ACTIONS(851),
    [sym_command_parameter] = ACTIONS(97),
    [anon_sym_LPAREN] = ACTIONS(853),
    [anon_sym_COMMA] = ACTIONS(877),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_PIPE] = ACTIONS(97),
    [sym_stop_parsing] = ACTIONS(97),
    [anon_sym_SPACE] = ACTIONS(95),
    [anon_sym_COLON] = ACTIONS(97),
    [anon_sym_DASH_DASH_PERCENT] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_DASHnot] = ACTIONS(877),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_DASHbnot] = ACTIONS(877),
    [anon_sym_PLUS_PLUS] = ACTIONS(879),
    [anon_sym_DASH_DASH] = ACTIONS(881),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [anon_sym_AT_LPAREN] = ACTIONS(863),
    [anon_sym_AT_LBRACE] = ACTIONS(865),
    [anon_sym_DOT2] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(97),
    [anon_sym_DOTforeach] = ACTIONS(95),
    [sym__statement_terminator] = ACTIONS(95),
  },
  [198] = {
    [sym__literal] = STATE(906),
    [sym_integer_literal] = STATE(906),
    [sym_string_literal] = STATE(906),
    [sym_expandable_string_literal] = STATE(796),
    [sym_expandable_here_string_literal] = STATE(796),
    [sym_variable] = STATE(906),
    [sym_unary_expression] = STATE(1042),
    [sym_expression_with_unary_operator] = STATE(1041),
    [sym_pre_increment_expression] = STATE(1035),
    [sym_pre_decrement_expression] = STATE(1035),
    [sym_cast_expression] = STATE(1035),
    [sym__primary_expression] = STATE(906),
    [sym__value] = STATE(906),
    [sym_parenthesized_expression] = STATE(906),
    [sym_sub_expression] = STATE(906),
    [sym_array_expression] = STATE(906),
    [sym_script_block_expression] = STATE(906),
    [sym_hash_literal_expression] = STATE(906),
    [sym_post_increment_expression] = STATE(906),
    [sym_post_decrement_expression] = STATE(906),
    [sym_member_access] = STATE(906),
    [sym_element_access] = STATE(906),
    [sym_invokation_expression] = STATE(906),
    [sym_invokation_foreach_expression] = STATE(801),
    [sym_type_literal] = STATE(198),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(883),
    [sym_hexadecimal_integer_literal] = ACTIONS(883),
    [sym_real_literal] = ACTIONS(885),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(887),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(889),
    [sym_verbatim_string_characters] = ACTIONS(891),
    [sym_verbatim_here_string_characters] = ACTIONS(891),
    [anon_sym_LBRACK] = ACTIONS(893),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_GT] = ACTIONS(97),
    [anon_sym_2_GT] = ACTIONS(97),
    [anon_sym_2_GT_GT] = ACTIONS(97),
    [anon_sym_3_GT] = ACTIONS(97),
    [anon_sym_3_GT_GT] = ACTIONS(97),
    [anon_sym_4_GT] = ACTIONS(97),
    [anon_sym_4_GT_GT] = ACTIONS(97),
    [anon_sym_5_GT] = ACTIONS(97),
    [anon_sym_5_GT_GT] = ACTIONS(97),
    [anon_sym_6_GT] = ACTIONS(97),
    [anon_sym_6_GT_GT] = ACTIONS(97),
    [anon_sym_STAR_GT] = ACTIONS(97),
    [anon_sym_STAR_GT_GT] = ACTIONS(97),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(97),
    [anon_sym_2_GT_AMP1] = ACTIONS(97),
    [anon_sym_3_GT_AMP1] = ACTIONS(97),
    [anon_sym_4_GT_AMP1] = ACTIONS(97),
    [anon_sym_5_GT_AMP1] = ACTIONS(97),
    [anon_sym_6_GT_AMP1] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(97),
    [anon_sym_1_GT_AMP2] = ACTIONS(97),
    [anon_sym_3_GT_AMP2] = ACTIONS(97),
    [anon_sym_4_GT_AMP2] = ACTIONS(97),
    [anon_sym_5_GT_AMP2] = ACTIONS(97),
    [anon_sym_6_GT_AMP2] = ACTIONS(97),
    [anon_sym_DASHjoin] = ACTIONS(895),
    [anon_sym_DASHsplit] = ACTIONS(895),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(897),
    [anon_sym_DOLLAR_CARET] = ACTIONS(897),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(897),
    [anon_sym_DOLLAR_] = ACTIONS(897),
    [aux_sym_variable_token1] = ACTIONS(897),
    [aux_sym_variable_token2] = ACTIONS(897),
    [sym_braced_variable] = ACTIONS(897),
    [sym_command_parameter] = ACTIONS(97),
    [anon_sym_LPAREN] = ACTIONS(899),
    [anon_sym_RPAREN] = ACTIONS(97),
    [anon_sym_COMMA] = ACTIONS(895),
    [anon_sym_LBRACE] = ACTIONS(901),
    [anon_sym_PIPE] = ACTIONS(97),
    [sym_stop_parsing] = ACTIONS(97),
    [anon_sym_SPACE] = ACTIONS(95),
    [anon_sym_COLON] = ACTIONS(97),
    [anon_sym_DASH_DASH_PERCENT] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(895),
    [anon_sym_DASHnot] = ACTIONS(895),
    [anon_sym_BANG] = ACTIONS(895),
    [anon_sym_DASHbnot] = ACTIONS(895),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(907),
    [anon_sym_AT_LPAREN] = ACTIONS(909),
    [anon_sym_AT_LBRACE] = ACTIONS(911),
    [anon_sym_DOT2] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(97),
    [anon_sym_DOTforeach] = ACTIONS(95),
  },
  [199] = {
    [sym__literal] = STATE(768),
    [sym_integer_literal] = STATE(768),
    [sym_string_literal] = STATE(768),
    [sym_expandable_string_literal] = STATE(771),
    [sym_expandable_here_string_literal] = STATE(771),
    [sym_variable] = STATE(768),
    [sym_unary_expression] = STATE(1031),
    [sym_expression_with_unary_operator] = STATE(1049),
    [sym_pre_increment_expression] = STATE(1047),
    [sym_pre_decrement_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1047),
    [sym__primary_expression] = STATE(768),
    [sym__value] = STATE(768),
    [sym_parenthesized_expression] = STATE(768),
    [sym_sub_expression] = STATE(768),
    [sym_array_expression] = STATE(768),
    [sym_script_block_expression] = STATE(768),
    [sym_hash_literal_expression] = STATE(768),
    [sym_post_increment_expression] = STATE(768),
    [sym_post_decrement_expression] = STATE(768),
    [sym_member_access] = STATE(768),
    [sym_element_access] = STATE(768),
    [sym_invokation_expression] = STATE(768),
    [sym_invokation_foreach_expression] = STATE(767),
    [sym_type_literal] = STATE(199),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(837),
    [sym_hexadecimal_integer_literal] = ACTIONS(837),
    [sym_real_literal] = ACTIONS(839),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(841),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(843),
    [sym_verbatim_string_characters] = ACTIONS(845),
    [sym_verbatim_here_string_characters] = ACTIONS(845),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_GT] = ACTIONS(97),
    [anon_sym_2_GT] = ACTIONS(97),
    [anon_sym_2_GT_GT] = ACTIONS(97),
    [anon_sym_3_GT] = ACTIONS(97),
    [anon_sym_3_GT_GT] = ACTIONS(97),
    [anon_sym_4_GT] = ACTIONS(97),
    [anon_sym_4_GT_GT] = ACTIONS(97),
    [anon_sym_5_GT] = ACTIONS(97),
    [anon_sym_5_GT_GT] = ACTIONS(97),
    [anon_sym_6_GT] = ACTIONS(97),
    [anon_sym_6_GT_GT] = ACTIONS(97),
    [anon_sym_STAR_GT] = ACTIONS(97),
    [anon_sym_STAR_GT_GT] = ACTIONS(97),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(97),
    [anon_sym_2_GT_AMP1] = ACTIONS(97),
    [anon_sym_3_GT_AMP1] = ACTIONS(97),
    [anon_sym_4_GT_AMP1] = ACTIONS(97),
    [anon_sym_5_GT_AMP1] = ACTIONS(97),
    [anon_sym_6_GT_AMP1] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(97),
    [anon_sym_1_GT_AMP2] = ACTIONS(97),
    [anon_sym_3_GT_AMP2] = ACTIONS(97),
    [anon_sym_4_GT_AMP2] = ACTIONS(97),
    [anon_sym_5_GT_AMP2] = ACTIONS(97),
    [anon_sym_6_GT_AMP2] = ACTIONS(97),
    [anon_sym_DASHjoin] = ACTIONS(913),
    [anon_sym_DASHsplit] = ACTIONS(913),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(851),
    [anon_sym_DOLLAR_CARET] = ACTIONS(851),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(851),
    [anon_sym_DOLLAR_] = ACTIONS(851),
    [aux_sym_variable_token1] = ACTIONS(851),
    [aux_sym_variable_token2] = ACTIONS(851),
    [sym_braced_variable] = ACTIONS(851),
    [sym_command_parameter] = ACTIONS(97),
    [anon_sym_LPAREN] = ACTIONS(853),
    [anon_sym_COMMA] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_PIPE] = ACTIONS(97),
    [sym_stop_parsing] = ACTIONS(97),
    [anon_sym_SPACE] = ACTIONS(95),
    [anon_sym_COLON] = ACTIONS(97),
    [anon_sym_DASH_DASH_PERCENT] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_DASHnot] = ACTIONS(913),
    [anon_sym_BANG] = ACTIONS(913),
    [anon_sym_DASHbnot] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(917),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [anon_sym_AT_LPAREN] = ACTIONS(863),
    [anon_sym_AT_LBRACE] = ACTIONS(865),
    [anon_sym_DOT2] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(97),
    [anon_sym_DOTforeach] = ACTIONS(95),
    [sym__statement_terminator] = ACTIONS(95),
  },
  [200] = {
    [sym_comparison_operator] = STATE(505),
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(919),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_PLUS_EQ] = ACTIONS(919),
    [anon_sym_STAR_EQ] = ACTIONS(919),
    [anon_sym_SLASH_EQ] = ACTIONS(919),
    [anon_sym_PERCENT_EQ] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_2_GT] = ACTIONS(921),
    [anon_sym_2_GT_GT] = ACTIONS(919),
    [anon_sym_3_GT] = ACTIONS(921),
    [anon_sym_3_GT_GT] = ACTIONS(919),
    [anon_sym_4_GT] = ACTIONS(921),
    [anon_sym_4_GT_GT] = ACTIONS(919),
    [anon_sym_5_GT] = ACTIONS(921),
    [anon_sym_5_GT_GT] = ACTIONS(919),
    [anon_sym_6_GT] = ACTIONS(921),
    [anon_sym_6_GT_GT] = ACTIONS(919),
    [anon_sym_STAR_GT] = ACTIONS(921),
    [anon_sym_STAR_GT_GT] = ACTIONS(919),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(919),
    [anon_sym_2_GT_AMP1] = ACTIONS(919),
    [anon_sym_3_GT_AMP1] = ACTIONS(919),
    [anon_sym_4_GT_AMP1] = ACTIONS(919),
    [anon_sym_5_GT_AMP1] = ACTIONS(919),
    [anon_sym_6_GT_AMP1] = ACTIONS(919),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(919),
    [anon_sym_1_GT_AMP2] = ACTIONS(919),
    [anon_sym_3_GT_AMP2] = ACTIONS(919),
    [anon_sym_4_GT_AMP2] = ACTIONS(919),
    [anon_sym_5_GT_AMP2] = ACTIONS(919),
    [anon_sym_6_GT_AMP2] = ACTIONS(919),
    [anon_sym_DASHas] = ACTIONS(871),
    [anon_sym_DASHccontains] = ACTIONS(871),
    [anon_sym_DASHceq] = ACTIONS(871),
    [anon_sym_DASHcge] = ACTIONS(871),
    [anon_sym_DASHcgt] = ACTIONS(871),
    [anon_sym_DASHcle] = ACTIONS(871),
    [anon_sym_DASHclike] = ACTIONS(871),
    [anon_sym_DASHclt] = ACTIONS(871),
    [anon_sym_DASHcmatch] = ACTIONS(871),
    [anon_sym_DASHcne] = ACTIONS(871),
    [anon_sym_DASHcnotcontains] = ACTIONS(871),
    [anon_sym_DASHcnotlike] = ACTIONS(871),
    [anon_sym_DASHcnotmatch] = ACTIONS(871),
    [anon_sym_DASHcontains] = ACTIONS(871),
    [anon_sym_DASHcreplace] = ACTIONS(871),
    [anon_sym_DASHcsplit] = ACTIONS(871),
    [anon_sym_DASHeq] = ACTIONS(871),
    [anon_sym_DASHge] = ACTIONS(871),
    [anon_sym_DASHgt] = ACTIONS(871),
    [anon_sym_DASHicontains] = ACTIONS(871),
    [anon_sym_DASHieq] = ACTIONS(871),
    [anon_sym_DASHige] = ACTIONS(871),
    [anon_sym_DASHigt] = ACTIONS(871),
    [anon_sym_DASHile] = ACTIONS(871),
    [anon_sym_DASHilike] = ACTIONS(871),
    [anon_sym_DASHilt] = ACTIONS(871),
    [anon_sym_DASHimatch] = ACTIONS(871),
    [anon_sym_DASHin] = ACTIONS(873),
    [anon_sym_DASHine] = ACTIONS(871),
    [anon_sym_DASHinotcontains] = ACTIONS(871),
    [anon_sym_DASHinotlike] = ACTIONS(871),
    [anon_sym_DASHinotmatch] = ACTIONS(871),
    [anon_sym_DASHireplace] = ACTIONS(871),
    [anon_sym_DASHis] = ACTIONS(873),
    [anon_sym_DASHisnot] = ACTIONS(871),
    [anon_sym_DASHisplit] = ACTIONS(871),
    [anon_sym_DASHjoin] = ACTIONS(871),
    [anon_sym_DASHle] = ACTIONS(871),
    [anon_sym_DASHlike] = ACTIONS(871),
    [anon_sym_DASHlt] = ACTIONS(871),
    [anon_sym_DASHmatch] = ACTIONS(871),
    [anon_sym_DASHne] = ACTIONS(871),
    [anon_sym_DASHnotcontains] = ACTIONS(871),
    [anon_sym_DASHnotin] = ACTIONS(871),
    [anon_sym_DASHnotlike] = ACTIONS(871),
    [anon_sym_DASHnotmatch] = ACTIONS(871),
    [anon_sym_DASHreplace] = ACTIONS(871),
    [anon_sym_DASHshl] = ACTIONS(871),
    [anon_sym_DASHshr] = ACTIONS(871),
    [anon_sym_DASHsplit] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(919),
    [anon_sym_DASHand] = ACTIONS(919),
    [anon_sym_DASHor] = ACTIONS(919),
    [anon_sym_DASHxor] = ACTIONS(919),
    [anon_sym_DASHband] = ACTIONS(919),
    [anon_sym_DASHbor] = ACTIONS(919),
    [anon_sym_DASHbxor] = ACTIONS(919),
  },
  [201] = {
    [sym__literal] = STATE(800),
    [sym_integer_literal] = STATE(800),
    [sym_string_literal] = STATE(800),
    [sym_expandable_string_literal] = STATE(796),
    [sym_expandable_here_string_literal] = STATE(796),
    [sym_variable] = STATE(800),
    [sym_unary_expression] = STATE(794),
    [sym_expression_with_unary_operator] = STATE(815),
    [sym_pre_increment_expression] = STATE(790),
    [sym_pre_decrement_expression] = STATE(790),
    [sym_cast_expression] = STATE(790),
    [sym__primary_expression] = STATE(800),
    [sym__value] = STATE(800),
    [sym_parenthesized_expression] = STATE(800),
    [sym_sub_expression] = STATE(800),
    [sym_array_expression] = STATE(800),
    [sym_script_block_expression] = STATE(800),
    [sym_hash_literal_expression] = STATE(800),
    [sym_post_increment_expression] = STATE(800),
    [sym_post_decrement_expression] = STATE(800),
    [sym_member_access] = STATE(800),
    [sym_element_access] = STATE(800),
    [sym_invokation_expression] = STATE(800),
    [sym_invokation_foreach_expression] = STATE(801),
    [sym_type_literal] = STATE(201),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(883),
    [sym_hexadecimal_integer_literal] = ACTIONS(883),
    [sym_real_literal] = ACTIONS(923),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(887),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(889),
    [sym_verbatim_string_characters] = ACTIONS(891),
    [sym_verbatim_here_string_characters] = ACTIONS(891),
    [anon_sym_LBRACK] = ACTIONS(893),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_GT] = ACTIONS(97),
    [anon_sym_2_GT] = ACTIONS(97),
    [anon_sym_2_GT_GT] = ACTIONS(97),
    [anon_sym_3_GT] = ACTIONS(97),
    [anon_sym_3_GT_GT] = ACTIONS(97),
    [anon_sym_4_GT] = ACTIONS(97),
    [anon_sym_4_GT_GT] = ACTIONS(97),
    [anon_sym_5_GT] = ACTIONS(97),
    [anon_sym_5_GT_GT] = ACTIONS(97),
    [anon_sym_6_GT] = ACTIONS(97),
    [anon_sym_6_GT_GT] = ACTIONS(97),
    [anon_sym_STAR_GT] = ACTIONS(97),
    [anon_sym_STAR_GT_GT] = ACTIONS(97),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(97),
    [anon_sym_2_GT_AMP1] = ACTIONS(97),
    [anon_sym_3_GT_AMP1] = ACTIONS(97),
    [anon_sym_4_GT_AMP1] = ACTIONS(97),
    [anon_sym_5_GT_AMP1] = ACTIONS(97),
    [anon_sym_6_GT_AMP1] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(97),
    [anon_sym_1_GT_AMP2] = ACTIONS(97),
    [anon_sym_3_GT_AMP2] = ACTIONS(97),
    [anon_sym_4_GT_AMP2] = ACTIONS(97),
    [anon_sym_5_GT_AMP2] = ACTIONS(97),
    [anon_sym_6_GT_AMP2] = ACTIONS(97),
    [anon_sym_DASHjoin] = ACTIONS(925),
    [anon_sym_DASHsplit] = ACTIONS(925),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(897),
    [anon_sym_DOLLAR_CARET] = ACTIONS(897),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(897),
    [anon_sym_DOLLAR_] = ACTIONS(897),
    [aux_sym_variable_token1] = ACTIONS(897),
    [aux_sym_variable_token2] = ACTIONS(897),
    [sym_braced_variable] = ACTIONS(897),
    [sym_command_parameter] = ACTIONS(97),
    [anon_sym_LPAREN] = ACTIONS(899),
    [anon_sym_RPAREN] = ACTIONS(97),
    [anon_sym_COMMA] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(901),
    [anon_sym_PIPE] = ACTIONS(97),
    [sym_stop_parsing] = ACTIONS(97),
    [anon_sym_SPACE] = ACTIONS(95),
    [anon_sym_COLON] = ACTIONS(97),
    [anon_sym_DASH_DASH_PERCENT] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_DASH] = ACTIONS(925),
    [anon_sym_DASHnot] = ACTIONS(925),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_DASHbnot] = ACTIONS(925),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_DASH_DASH] = ACTIONS(929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(907),
    [anon_sym_AT_LPAREN] = ACTIONS(909),
    [anon_sym_AT_LBRACE] = ACTIONS(911),
    [anon_sym_DOT2] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(97),
    [anon_sym_DOTforeach] = ACTIONS(95),
  },
  [202] = {
    [sym__literal] = STATE(800),
    [sym_integer_literal] = STATE(800),
    [sym_string_literal] = STATE(800),
    [sym_expandable_string_literal] = STATE(796),
    [sym_expandable_here_string_literal] = STATE(796),
    [sym_variable] = STATE(800),
    [sym_unary_expression] = STATE(1042),
    [sym_expression_with_unary_operator] = STATE(1041),
    [sym_pre_increment_expression] = STATE(1035),
    [sym_pre_decrement_expression] = STATE(1035),
    [sym_cast_expression] = STATE(1035),
    [sym__primary_expression] = STATE(800),
    [sym__value] = STATE(800),
    [sym_parenthesized_expression] = STATE(800),
    [sym_sub_expression] = STATE(800),
    [sym_array_expression] = STATE(800),
    [sym_script_block_expression] = STATE(800),
    [sym_hash_literal_expression] = STATE(800),
    [sym_post_increment_expression] = STATE(800),
    [sym_post_decrement_expression] = STATE(800),
    [sym_member_access] = STATE(800),
    [sym_element_access] = STATE(800),
    [sym_invokation_expression] = STATE(800),
    [sym_invokation_foreach_expression] = STATE(801),
    [sym_type_literal] = STATE(202),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(883),
    [sym_hexadecimal_integer_literal] = ACTIONS(883),
    [sym_real_literal] = ACTIONS(923),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(887),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(889),
    [sym_verbatim_string_characters] = ACTIONS(891),
    [sym_verbatim_here_string_characters] = ACTIONS(891),
    [anon_sym_LBRACK] = ACTIONS(893),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_GT] = ACTIONS(97),
    [anon_sym_2_GT] = ACTIONS(97),
    [anon_sym_2_GT_GT] = ACTIONS(97),
    [anon_sym_3_GT] = ACTIONS(97),
    [anon_sym_3_GT_GT] = ACTIONS(97),
    [anon_sym_4_GT] = ACTIONS(97),
    [anon_sym_4_GT_GT] = ACTIONS(97),
    [anon_sym_5_GT] = ACTIONS(97),
    [anon_sym_5_GT_GT] = ACTIONS(97),
    [anon_sym_6_GT] = ACTIONS(97),
    [anon_sym_6_GT_GT] = ACTIONS(97),
    [anon_sym_STAR_GT] = ACTIONS(97),
    [anon_sym_STAR_GT_GT] = ACTIONS(97),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(97),
    [anon_sym_2_GT_AMP1] = ACTIONS(97),
    [anon_sym_3_GT_AMP1] = ACTIONS(97),
    [anon_sym_4_GT_AMP1] = ACTIONS(97),
    [anon_sym_5_GT_AMP1] = ACTIONS(97),
    [anon_sym_6_GT_AMP1] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(97),
    [anon_sym_1_GT_AMP2] = ACTIONS(97),
    [anon_sym_3_GT_AMP2] = ACTIONS(97),
    [anon_sym_4_GT_AMP2] = ACTIONS(97),
    [anon_sym_5_GT_AMP2] = ACTIONS(97),
    [anon_sym_6_GT_AMP2] = ACTIONS(97),
    [anon_sym_DASHjoin] = ACTIONS(931),
    [anon_sym_DASHsplit] = ACTIONS(931),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(897),
    [anon_sym_DOLLAR_CARET] = ACTIONS(897),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(897),
    [anon_sym_DOLLAR_] = ACTIONS(897),
    [aux_sym_variable_token1] = ACTIONS(897),
    [aux_sym_variable_token2] = ACTIONS(897),
    [sym_braced_variable] = ACTIONS(897),
    [sym_command_parameter] = ACTIONS(97),
    [anon_sym_LPAREN] = ACTIONS(899),
    [anon_sym_RPAREN] = ACTIONS(97),
    [anon_sym_COMMA] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(901),
    [anon_sym_PIPE] = ACTIONS(97),
    [sym_stop_parsing] = ACTIONS(97),
    [anon_sym_SPACE] = ACTIONS(95),
    [anon_sym_COLON] = ACTIONS(97),
    [anon_sym_DASH_DASH_PERCENT] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(931),
    [anon_sym_DASH] = ACTIONS(931),
    [anon_sym_DASHnot] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_DASHbnot] = ACTIONS(931),
    [anon_sym_PLUS_PLUS] = ACTIONS(933),
    [anon_sym_DASH_DASH] = ACTIONS(935),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(907),
    [anon_sym_AT_LPAREN] = ACTIONS(909),
    [anon_sym_AT_LBRACE] = ACTIONS(911),
    [anon_sym_DOT2] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(97),
    [anon_sym_DOTforeach] = ACTIONS(95),
  },
  [203] = {
    [sym_comparison_operator] = STATE(505),
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(867),
    [anon_sym_BANG_EQ] = ACTIONS(867),
    [anon_sym_PLUS_EQ] = ACTIONS(867),
    [anon_sym_STAR_EQ] = ACTIONS(867),
    [anon_sym_SLASH_EQ] = ACTIONS(867),
    [anon_sym_PERCENT_EQ] = ACTIONS(867),
    [anon_sym_GT] = ACTIONS(869),
    [anon_sym_GT_GT] = ACTIONS(867),
    [anon_sym_2_GT] = ACTIONS(869),
    [anon_sym_2_GT_GT] = ACTIONS(867),
    [anon_sym_3_GT] = ACTIONS(869),
    [anon_sym_3_GT_GT] = ACTIONS(867),
    [anon_sym_4_GT] = ACTIONS(869),
    [anon_sym_4_GT_GT] = ACTIONS(867),
    [anon_sym_5_GT] = ACTIONS(869),
    [anon_sym_5_GT_GT] = ACTIONS(867),
    [anon_sym_6_GT] = ACTIONS(869),
    [anon_sym_6_GT_GT] = ACTIONS(867),
    [anon_sym_STAR_GT] = ACTIONS(869),
    [anon_sym_STAR_GT_GT] = ACTIONS(867),
    [anon_sym_LT] = ACTIONS(869),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(867),
    [anon_sym_2_GT_AMP1] = ACTIONS(867),
    [anon_sym_3_GT_AMP1] = ACTIONS(867),
    [anon_sym_4_GT_AMP1] = ACTIONS(867),
    [anon_sym_5_GT_AMP1] = ACTIONS(867),
    [anon_sym_6_GT_AMP1] = ACTIONS(867),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(867),
    [anon_sym_1_GT_AMP2] = ACTIONS(867),
    [anon_sym_3_GT_AMP2] = ACTIONS(867),
    [anon_sym_4_GT_AMP2] = ACTIONS(867),
    [anon_sym_5_GT_AMP2] = ACTIONS(867),
    [anon_sym_6_GT_AMP2] = ACTIONS(867),
    [anon_sym_DASHas] = ACTIONS(871),
    [anon_sym_DASHccontains] = ACTIONS(871),
    [anon_sym_DASHceq] = ACTIONS(871),
    [anon_sym_DASHcge] = ACTIONS(871),
    [anon_sym_DASHcgt] = ACTIONS(871),
    [anon_sym_DASHcle] = ACTIONS(871),
    [anon_sym_DASHclike] = ACTIONS(871),
    [anon_sym_DASHclt] = ACTIONS(871),
    [anon_sym_DASHcmatch] = ACTIONS(871),
    [anon_sym_DASHcne] = ACTIONS(871),
    [anon_sym_DASHcnotcontains] = ACTIONS(871),
    [anon_sym_DASHcnotlike] = ACTIONS(871),
    [anon_sym_DASHcnotmatch] = ACTIONS(871),
    [anon_sym_DASHcontains] = ACTIONS(871),
    [anon_sym_DASHcreplace] = ACTIONS(871),
    [anon_sym_DASHcsplit] = ACTIONS(871),
    [anon_sym_DASHeq] = ACTIONS(871),
    [anon_sym_DASHge] = ACTIONS(871),
    [anon_sym_DASHgt] = ACTIONS(871),
    [anon_sym_DASHicontains] = ACTIONS(871),
    [anon_sym_DASHieq] = ACTIONS(871),
    [anon_sym_DASHige] = ACTIONS(871),
    [anon_sym_DASHigt] = ACTIONS(871),
    [anon_sym_DASHile] = ACTIONS(871),
    [anon_sym_DASHilike] = ACTIONS(871),
    [anon_sym_DASHilt] = ACTIONS(871),
    [anon_sym_DASHimatch] = ACTIONS(871),
    [anon_sym_DASHin] = ACTIONS(873),
    [anon_sym_DASHine] = ACTIONS(871),
    [anon_sym_DASHinotcontains] = ACTIONS(871),
    [anon_sym_DASHinotlike] = ACTIONS(871),
    [anon_sym_DASHinotmatch] = ACTIONS(871),
    [anon_sym_DASHireplace] = ACTIONS(871),
    [anon_sym_DASHis] = ACTIONS(873),
    [anon_sym_DASHisnot] = ACTIONS(871),
    [anon_sym_DASHisplit] = ACTIONS(871),
    [anon_sym_DASHjoin] = ACTIONS(871),
    [anon_sym_DASHle] = ACTIONS(871),
    [anon_sym_DASHlike] = ACTIONS(871),
    [anon_sym_DASHlt] = ACTIONS(871),
    [anon_sym_DASHmatch] = ACTIONS(871),
    [anon_sym_DASHne] = ACTIONS(871),
    [anon_sym_DASHnotcontains] = ACTIONS(871),
    [anon_sym_DASHnotin] = ACTIONS(871),
    [anon_sym_DASHnotlike] = ACTIONS(871),
    [anon_sym_DASHnotmatch] = ACTIONS(871),
    [anon_sym_DASHreplace] = ACTIONS(871),
    [anon_sym_DASHshl] = ACTIONS(871),
    [anon_sym_DASHshr] = ACTIONS(871),
    [anon_sym_DASHsplit] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(867),
    [anon_sym_PIPE] = ACTIONS(867),
    [anon_sym_DASHand] = ACTIONS(867),
    [anon_sym_DASHor] = ACTIONS(867),
    [anon_sym_DASHxor] = ACTIONS(867),
    [anon_sym_DASHband] = ACTIONS(867),
    [anon_sym_DASHbor] = ACTIONS(867),
    [anon_sym_DASHbxor] = ACTIONS(867),
  },
  [204] = {
    [sym_comparison_operator] = STATE(520),
    [sym_comment] = ACTIONS(81),
    [anon_sym_EQ] = ACTIONS(919),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_PLUS_EQ] = ACTIONS(919),
    [anon_sym_STAR_EQ] = ACTIONS(919),
    [anon_sym_SLASH_EQ] = ACTIONS(919),
    [anon_sym_PERCENT_EQ] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_2_GT] = ACTIONS(921),
    [anon_sym_2_GT_GT] = ACTIONS(919),
    [anon_sym_3_GT] = ACTIONS(921),
    [anon_sym_3_GT_GT] = ACTIONS(919),
    [anon_sym_4_GT] = ACTIONS(921),
    [anon_sym_4_GT_GT] = ACTIONS(919),
    [anon_sym_5_GT] = ACTIONS(921),
    [anon_sym_5_GT_GT] = ACTIONS(919),
    [anon_sym_6_GT] = ACTIONS(921),
    [anon_sym_6_GT_GT] = ACTIONS(919),
    [anon_sym_STAR_GT] = ACTIONS(921),
    [anon_sym_STAR_GT_GT] = ACTIONS(919),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(919),
    [anon_sym_2_GT_AMP1] = ACTIONS(919),
    [anon_sym_3_GT_AMP1] = ACTIONS(919),
    [anon_sym_4_GT_AMP1] = ACTIONS(919),
    [anon_sym_5_GT_AMP1] = ACTIONS(919),
    [anon_sym_6_GT_AMP1] = ACTIONS(919),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(919),
    [anon_sym_1_GT_AMP2] = ACTIONS(919),
    [anon_sym_3_GT_AMP2] = ACTIONS(919),
    [anon_sym_4_GT_AMP2] = ACTIONS(919),
    [anon_sym_5_GT_AMP2] = ACTIONS(919),
    [anon_sym_6_GT_AMP2] = ACTIONS(919),
    [anon_sym_DASHas] = ACTIONS(871),
    [anon_sym_DASHccontains] = ACTIONS(871),
    [anon_sym_DASHceq] = ACTIONS(871),
    [anon_sym_DASHcge] = ACTIONS(871),
    [anon_sym_DASHcgt] = ACTIONS(871),
    [anon_sym_DASHcle] = ACTIONS(871),
    [anon_sym_DASHclike] = ACTIONS(871),
    [anon_sym_DASHclt] = ACTIONS(871),
    [anon_sym_DASHcmatch] = ACTIONS(871),
    [anon_sym_DASHcne] = ACTIONS(871),
    [anon_sym_DASHcnotcontains] = ACTIONS(871),
    [anon_sym_DASHcnotlike] = ACTIONS(871),
    [anon_sym_DASHcnotmatch] = ACTIONS(871),
    [anon_sym_DASHcontains] = ACTIONS(871),
    [anon_sym_DASHcreplace] = ACTIONS(871),
    [anon_sym_DASHcsplit] = ACTIONS(871),
    [anon_sym_DASHeq] = ACTIONS(871),
    [anon_sym_DASHge] = ACTIONS(871),
    [anon_sym_DASHgt] = ACTIONS(871),
    [anon_sym_DASHicontains] = ACTIONS(871),
    [anon_sym_DASHieq] = ACTIONS(871),
    [anon_sym_DASHige] = ACTIONS(871),
    [anon_sym_DASHigt] = ACTIONS(871),
    [anon_sym_DASHile] = ACTIONS(871),
    [anon_sym_DASHilike] = ACTIONS(871),
    [anon_sym_DASHilt] = ACTIONS(871),
    [anon_sym_DASHimatch] = ACTIONS(871),
    [anon_sym_DASHin] = ACTIONS(873),
    [anon_sym_DASHine] = ACTIONS(871),
    [anon_sym_DASHinotcontains] = ACTIONS(871),
    [anon_sym_DASHinotlike] = ACTIONS(871),
    [anon_sym_DASHinotmatch] = ACTIONS(871),
    [anon_sym_DASHireplace] = ACTIONS(871),
    [anon_sym_DASHis] = ACTIONS(873),
    [anon_sym_DASHisnot] = ACTIONS(871),
    [anon_sym_DASHisplit] = ACTIONS(871),
    [anon_sym_DASHjoin] = ACTIONS(871),
    [anon_sym_DASHle] = ACTIONS(871),
    [anon_sym_DASHlike] = ACTIONS(871),
    [anon_sym_DASHlt] = ACTIONS(871),
    [anon_sym_DASHmatch] = ACTIONS(871),
    [anon_sym_DASHne] = ACTIONS(871),
    [anon_sym_DASHnotcontains] = ACTIONS(871),
    [anon_sym_DASHnotin] = ACTIONS(871),
    [anon_sym_DASHnotlike] = ACTIONS(871),
    [anon_sym_DASHnotmatch] = ACTIONS(871),
    [anon_sym_DASHreplace] = ACTIONS(871),
    [anon_sym_DASHshl] = ACTIONS(871),
    [anon_sym_DASHshr] = ACTIONS(871),
    [anon_sym_DASHsplit] = ACTIONS(871),
    [anon_sym_PIPE] = ACTIONS(919),
    [anon_sym_DASHand] = ACTIONS(919),
    [anon_sym_DASHor] = ACTIONS(919),
    [anon_sym_DASHxor] = ACTIONS(919),
    [anon_sym_DASHband] = ACTIONS(919),
    [anon_sym_DASHbor] = ACTIONS(919),
    [anon_sym_DASHbxor] = ACTIONS(919),
    [sym__statement_terminator] = ACTIONS(919),
  },
  [205] = {
    [sym__literal] = STATE(906),
    [sym_integer_literal] = STATE(906),
    [sym_string_literal] = STATE(906),
    [sym_expandable_string_literal] = STATE(796),
    [sym_expandable_here_string_literal] = STATE(796),
    [sym_variable] = STATE(906),
    [sym_array_literal_expression] = STATE(1062),
    [sym_unary_expression] = STATE(1030),
    [sym_expression_with_unary_operator] = STATE(1041),
    [sym_pre_increment_expression] = STATE(1035),
    [sym_pre_decrement_expression] = STATE(1035),
    [sym_cast_expression] = STATE(1035),
    [sym__primary_expression] = STATE(906),
    [sym__value] = STATE(906),
    [sym_parenthesized_expression] = STATE(906),
    [sym_sub_expression] = STATE(906),
    [sym_array_expression] = STATE(906),
    [sym_script_block_expression] = STATE(906),
    [sym_hash_literal_expression] = STATE(906),
    [sym_post_increment_expression] = STATE(906),
    [sym_post_decrement_expression] = STATE(906),
    [sym_member_access] = STATE(906),
    [sym_element_access] = STATE(906),
    [sym_invokation_expression] = STATE(906),
    [sym_invokation_foreach_expression] = STATE(801),
    [sym_type_literal] = STATE(198),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(883),
    [sym_hexadecimal_integer_literal] = ACTIONS(883),
    [sym_real_literal] = ACTIONS(885),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(887),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(889),
    [sym_verbatim_string_characters] = ACTIONS(891),
    [sym_verbatim_here_string_characters] = ACTIONS(891),
    [anon_sym_LBRACK] = ACTIONS(893),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_2_GT] = ACTIONS(937),
    [anon_sym_2_GT_GT] = ACTIONS(937),
    [anon_sym_3_GT] = ACTIONS(937),
    [anon_sym_3_GT_GT] = ACTIONS(937),
    [anon_sym_4_GT] = ACTIONS(937),
    [anon_sym_4_GT_GT] = ACTIONS(937),
    [anon_sym_5_GT] = ACTIONS(937),
    [anon_sym_5_GT_GT] = ACTIONS(937),
    [anon_sym_6_GT] = ACTIONS(937),
    [anon_sym_6_GT_GT] = ACTIONS(937),
    [anon_sym_STAR_GT] = ACTIONS(937),
    [anon_sym_STAR_GT_GT] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(937),
    [anon_sym_2_GT_AMP1] = ACTIONS(937),
    [anon_sym_3_GT_AMP1] = ACTIONS(937),
    [anon_sym_4_GT_AMP1] = ACTIONS(937),
    [anon_sym_5_GT_AMP1] = ACTIONS(937),
    [anon_sym_6_GT_AMP1] = ACTIONS(937),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(937),
    [anon_sym_1_GT_AMP2] = ACTIONS(937),
    [anon_sym_3_GT_AMP2] = ACTIONS(937),
    [anon_sym_4_GT_AMP2] = ACTIONS(937),
    [anon_sym_5_GT_AMP2] = ACTIONS(937),
    [anon_sym_6_GT_AMP2] = ACTIONS(937),
    [anon_sym_DASHjoin] = ACTIONS(895),
    [anon_sym_DASHsplit] = ACTIONS(895),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(897),
    [anon_sym_DOLLAR_CARET] = ACTIONS(897),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(897),
    [anon_sym_DOLLAR_] = ACTIONS(897),
    [aux_sym_variable_token1] = ACTIONS(897),
    [aux_sym_variable_token2] = ACTIONS(897),
    [sym_braced_variable] = ACTIONS(897),
    [sym_generic_token] = ACTIONS(939),
    [sym_command_parameter] = ACTIONS(937),
    [anon_sym_LPAREN] = ACTIONS(899),
    [anon_sym_RPAREN] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(895),
    [anon_sym_LBRACE] = ACTIONS(901),
    [anon_sym_PIPE] = ACTIONS(937),
    [sym_stop_parsing] = ACTIONS(937),
    [anon_sym_SPACE] = ACTIONS(937),
    [anon_sym_COLON] = ACTIONS(937),
    [anon_sym_DASH_DASH_PERCENT] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(895),
    [anon_sym_DASHnot] = ACTIONS(895),
    [anon_sym_BANG] = ACTIONS(895),
    [anon_sym_DASHbnot] = ACTIONS(895),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(907),
    [anon_sym_AT_LPAREN] = ACTIONS(909),
    [anon_sym_AT_LBRACE] = ACTIONS(911),
  },
  [206] = {
    [sym__literal] = STATE(892),
    [sym_integer_literal] = STATE(892),
    [sym_string_literal] = STATE(892),
    [sym_expandable_string_literal] = STATE(846),
    [sym_expandable_here_string_literal] = STATE(846),
    [sym_variable] = STATE(892),
    [sym_unary_expression] = STATE(1054),
    [sym_expression_with_unary_operator] = STATE(1076),
    [sym_pre_increment_expression] = STATE(1059),
    [sym_pre_decrement_expression] = STATE(1059),
    [sym_cast_expression] = STATE(1059),
    [sym__primary_expression] = STATE(892),
    [sym__value] = STATE(892),
    [sym_parenthesized_expression] = STATE(892),
    [sym_sub_expression] = STATE(892),
    [sym_array_expression] = STATE(892),
    [sym_script_block_expression] = STATE(892),
    [sym_hash_literal_expression] = STATE(892),
    [sym_post_increment_expression] = STATE(892),
    [sym_post_decrement_expression] = STATE(892),
    [sym_member_access] = STATE(892),
    [sym_element_access] = STATE(892),
    [sym_invokation_expression] = STATE(892),
    [sym_invokation_foreach_expression] = STATE(840),
    [sym_type_literal] = STATE(206),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(941),
    [sym_hexadecimal_integer_literal] = ACTIONS(941),
    [sym_real_literal] = ACTIONS(943),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(945),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(947),
    [sym_verbatim_string_characters] = ACTIONS(949),
    [sym_verbatim_here_string_characters] = ACTIONS(949),
    [anon_sym_LBRACK] = ACTIONS(951),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_GT] = ACTIONS(97),
    [anon_sym_2_GT] = ACTIONS(97),
    [anon_sym_2_GT_GT] = ACTIONS(97),
    [anon_sym_3_GT] = ACTIONS(97),
    [anon_sym_3_GT_GT] = ACTIONS(97),
    [anon_sym_4_GT] = ACTIONS(97),
    [anon_sym_4_GT_GT] = ACTIONS(97),
    [anon_sym_5_GT] = ACTIONS(97),
    [anon_sym_5_GT_GT] = ACTIONS(97),
    [anon_sym_6_GT] = ACTIONS(97),
    [anon_sym_6_GT_GT] = ACTIONS(97),
    [anon_sym_STAR_GT] = ACTIONS(97),
    [anon_sym_STAR_GT_GT] = ACTIONS(97),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(97),
    [anon_sym_2_GT_AMP1] = ACTIONS(97),
    [anon_sym_3_GT_AMP1] = ACTIONS(97),
    [anon_sym_4_GT_AMP1] = ACTIONS(97),
    [anon_sym_5_GT_AMP1] = ACTIONS(97),
    [anon_sym_6_GT_AMP1] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(97),
    [anon_sym_1_GT_AMP2] = ACTIONS(97),
    [anon_sym_3_GT_AMP2] = ACTIONS(97),
    [anon_sym_4_GT_AMP2] = ACTIONS(97),
    [anon_sym_5_GT_AMP2] = ACTIONS(97),
    [anon_sym_6_GT_AMP2] = ACTIONS(97),
    [anon_sym_DASHjoin] = ACTIONS(953),
    [anon_sym_DASHsplit] = ACTIONS(953),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(955),
    [anon_sym_DOLLAR_CARET] = ACTIONS(955),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(955),
    [anon_sym_DOLLAR_] = ACTIONS(955),
    [aux_sym_variable_token1] = ACTIONS(955),
    [aux_sym_variable_token2] = ACTIONS(955),
    [sym_braced_variable] = ACTIONS(955),
    [sym_command_parameter] = ACTIONS(97),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_RPAREN] = ACTIONS(97),
    [anon_sym_COMMA] = ACTIONS(953),
    [anon_sym_LBRACE] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(97),
    [sym_stop_parsing] = ACTIONS(97),
    [anon_sym_SPACE] = ACTIONS(95),
    [anon_sym_COLON] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_DASH] = ACTIONS(953),
    [anon_sym_DASHnot] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_DASHbnot] = ACTIONS(953),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(963),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(965),
    [anon_sym_AT_LPAREN] = ACTIONS(967),
    [anon_sym_AT_LBRACE] = ACTIONS(969),
    [anon_sym_DOT2] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(97),
    [anon_sym_DOTforeach] = ACTIONS(95),
  },
  [207] = {
    [sym__literal] = STATE(858),
    [sym_integer_literal] = STATE(858),
    [sym_string_literal] = STATE(858),
    [sym_expandable_string_literal] = STATE(850),
    [sym_expandable_here_string_literal] = STATE(850),
    [sym_variable] = STATE(858),
    [sym_unary_expression] = STATE(885),
    [sym_expression_with_unary_operator] = STATE(890),
    [sym_pre_increment_expression] = STATE(889),
    [sym_pre_decrement_expression] = STATE(889),
    [sym_cast_expression] = STATE(889),
    [sym__primary_expression] = STATE(858),
    [sym__value] = STATE(858),
    [sym_parenthesized_expression] = STATE(858),
    [sym_sub_expression] = STATE(858),
    [sym_array_expression] = STATE(858),
    [sym_script_block_expression] = STATE(858),
    [sym_hash_literal_expression] = STATE(858),
    [sym_post_increment_expression] = STATE(858),
    [sym_post_decrement_expression] = STATE(858),
    [sym_member_access] = STATE(858),
    [sym_element_access] = STATE(858),
    [sym_invokation_expression] = STATE(858),
    [sym_invokation_foreach_expression] = STATE(861),
    [sym_type_literal] = STATE(207),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(971),
    [sym_hexadecimal_integer_literal] = ACTIONS(971),
    [sym_real_literal] = ACTIONS(973),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(975),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(977),
    [sym_verbatim_string_characters] = ACTIONS(979),
    [sym_verbatim_here_string_characters] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_GT] = ACTIONS(97),
    [anon_sym_2_GT] = ACTIONS(97),
    [anon_sym_2_GT_GT] = ACTIONS(97),
    [anon_sym_3_GT] = ACTIONS(97),
    [anon_sym_3_GT_GT] = ACTIONS(97),
    [anon_sym_4_GT] = ACTIONS(97),
    [anon_sym_4_GT_GT] = ACTIONS(97),
    [anon_sym_5_GT] = ACTIONS(97),
    [anon_sym_5_GT_GT] = ACTIONS(97),
    [anon_sym_6_GT] = ACTIONS(97),
    [anon_sym_6_GT_GT] = ACTIONS(97),
    [anon_sym_STAR_GT] = ACTIONS(97),
    [anon_sym_STAR_GT_GT] = ACTIONS(97),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(97),
    [anon_sym_2_GT_AMP1] = ACTIONS(97),
    [anon_sym_3_GT_AMP1] = ACTIONS(97),
    [anon_sym_4_GT_AMP1] = ACTIONS(97),
    [anon_sym_5_GT_AMP1] = ACTIONS(97),
    [anon_sym_6_GT_AMP1] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(97),
    [anon_sym_1_GT_AMP2] = ACTIONS(97),
    [anon_sym_3_GT_AMP2] = ACTIONS(97),
    [anon_sym_4_GT_AMP2] = ACTIONS(97),
    [anon_sym_5_GT_AMP2] = ACTIONS(97),
    [anon_sym_6_GT_AMP2] = ACTIONS(97),
    [anon_sym_DASHjoin] = ACTIONS(983),
    [anon_sym_DASHsplit] = ACTIONS(983),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(985),
    [anon_sym_DOLLAR_CARET] = ACTIONS(985),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(985),
    [anon_sym_DOLLAR_] = ACTIONS(985),
    [aux_sym_variable_token1] = ACTIONS(985),
    [aux_sym_variable_token2] = ACTIONS(985),
    [sym_braced_variable] = ACTIONS(985),
    [sym_command_parameter] = ACTIONS(97),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_COMMA] = ACTIONS(983),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_PIPE] = ACTIONS(97),
    [sym_stop_parsing] = ACTIONS(97),
    [anon_sym_SPACE] = ACTIONS(95),
    [anon_sym_COLON] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(983),
    [anon_sym_DASHnot] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(983),
    [anon_sym_DASHbnot] = ACTIONS(983),
    [anon_sym_PLUS_PLUS] = ACTIONS(991),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(995),
    [anon_sym_AT_LPAREN] = ACTIONS(997),
    [anon_sym_AT_LBRACE] = ACTIONS(999),
    [anon_sym_DOT2] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(97),
    [anon_sym_DOTforeach] = ACTIONS(95),
    [sym__statement_terminator] = ACTIONS(95),
  },
  [208] = {
    [sym__literal] = STATE(858),
    [sym_integer_literal] = STATE(858),
    [sym_string_literal] = STATE(858),
    [sym_expandable_string_literal] = STATE(850),
    [sym_expandable_here_string_literal] = STATE(850),
    [sym_variable] = STATE(858),
    [sym_unary_expression] = STATE(1056),
    [sym_expression_with_unary_operator] = STATE(1068),
    [sym_pre_increment_expression] = STATE(1073),
    [sym_pre_decrement_expression] = STATE(1073),
    [sym_cast_expression] = STATE(1073),
    [sym__primary_expression] = STATE(858),
    [sym__value] = STATE(858),
    [sym_parenthesized_expression] = STATE(858),
    [sym_sub_expression] = STATE(858),
    [sym_array_expression] = STATE(858),
    [sym_script_block_expression] = STATE(858),
    [sym_hash_literal_expression] = STATE(858),
    [sym_post_increment_expression] = STATE(858),
    [sym_post_decrement_expression] = STATE(858),
    [sym_member_access] = STATE(858),
    [sym_element_access] = STATE(858),
    [sym_invokation_expression] = STATE(858),
    [sym_invokation_foreach_expression] = STATE(861),
    [sym_type_literal] = STATE(208),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(971),
    [sym_hexadecimal_integer_literal] = ACTIONS(971),
    [sym_real_literal] = ACTIONS(973),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(975),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(977),
    [sym_verbatim_string_characters] = ACTIONS(979),
    [sym_verbatim_here_string_characters] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_GT] = ACTIONS(97),
    [anon_sym_2_GT] = ACTIONS(97),
    [anon_sym_2_GT_GT] = ACTIONS(97),
    [anon_sym_3_GT] = ACTIONS(97),
    [anon_sym_3_GT_GT] = ACTIONS(97),
    [anon_sym_4_GT] = ACTIONS(97),
    [anon_sym_4_GT_GT] = ACTIONS(97),
    [anon_sym_5_GT] = ACTIONS(97),
    [anon_sym_5_GT_GT] = ACTIONS(97),
    [anon_sym_6_GT] = ACTIONS(97),
    [anon_sym_6_GT_GT] = ACTIONS(97),
    [anon_sym_STAR_GT] = ACTIONS(97),
    [anon_sym_STAR_GT_GT] = ACTIONS(97),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(97),
    [anon_sym_2_GT_AMP1] = ACTIONS(97),
    [anon_sym_3_GT_AMP1] = ACTIONS(97),
    [anon_sym_4_GT_AMP1] = ACTIONS(97),
    [anon_sym_5_GT_AMP1] = ACTIONS(97),
    [anon_sym_6_GT_AMP1] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(97),
    [anon_sym_1_GT_AMP2] = ACTIONS(97),
    [anon_sym_3_GT_AMP2] = ACTIONS(97),
    [anon_sym_4_GT_AMP2] = ACTIONS(97),
    [anon_sym_5_GT_AMP2] = ACTIONS(97),
    [anon_sym_6_GT_AMP2] = ACTIONS(97),
    [anon_sym_DASHjoin] = ACTIONS(1001),
    [anon_sym_DASHsplit] = ACTIONS(1001),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(985),
    [anon_sym_DOLLAR_CARET] = ACTIONS(985),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(985),
    [anon_sym_DOLLAR_] = ACTIONS(985),
    [aux_sym_variable_token1] = ACTIONS(985),
    [aux_sym_variable_token2] = ACTIONS(985),
    [sym_braced_variable] = ACTIONS(985),
    [sym_command_parameter] = ACTIONS(97),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_COMMA] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_PIPE] = ACTIONS(97),
    [sym_stop_parsing] = ACTIONS(97),
    [anon_sym_SPACE] = ACTIONS(95),
    [anon_sym_COLON] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_DASHnot] = ACTIONS(1001),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_DASHbnot] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1003),
    [anon_sym_DASH_DASH] = ACTIONS(1005),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(995),
    [anon_sym_AT_LPAREN] = ACTIONS(997),
    [anon_sym_AT_LBRACE] = ACTIONS(999),
    [anon_sym_DOT2] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(97),
    [anon_sym_DOTforeach] = ACTIONS(95),
    [sym__statement_terminator] = ACTIONS(95),
  },
  [209] = {
    [sym__literal] = STATE(924),
    [sym_integer_literal] = STATE(924),
    [sym_string_literal] = STATE(924),
    [sym_expandable_string_literal] = STATE(846),
    [sym_expandable_here_string_literal] = STATE(846),
    [sym_variable] = STATE(924),
    [sym_unary_expression] = STATE(1054),
    [sym_expression_with_unary_operator] = STATE(1076),
    [sym_pre_increment_expression] = STATE(1059),
    [sym_pre_decrement_expression] = STATE(1059),
    [sym_cast_expression] = STATE(1059),
    [sym__primary_expression] = STATE(924),
    [sym__value] = STATE(924),
    [sym_parenthesized_expression] = STATE(924),
    [sym_sub_expression] = STATE(924),
    [sym_array_expression] = STATE(924),
    [sym_script_block_expression] = STATE(924),
    [sym_hash_literal_expression] = STATE(924),
    [sym_post_increment_expression] = STATE(924),
    [sym_post_decrement_expression] = STATE(924),
    [sym_member_access] = STATE(924),
    [sym_element_access] = STATE(924),
    [sym_invokation_expression] = STATE(924),
    [sym_invokation_foreach_expression] = STATE(840),
    [sym_type_literal] = STATE(209),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(941),
    [sym_hexadecimal_integer_literal] = ACTIONS(941),
    [sym_real_literal] = ACTIONS(1007),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(945),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(947),
    [sym_verbatim_string_characters] = ACTIONS(949),
    [sym_verbatim_here_string_characters] = ACTIONS(949),
    [anon_sym_LBRACK] = ACTIONS(951),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_GT] = ACTIONS(97),
    [anon_sym_2_GT] = ACTIONS(97),
    [anon_sym_2_GT_GT] = ACTIONS(97),
    [anon_sym_3_GT] = ACTIONS(97),
    [anon_sym_3_GT_GT] = ACTIONS(97),
    [anon_sym_4_GT] = ACTIONS(97),
    [anon_sym_4_GT_GT] = ACTIONS(97),
    [anon_sym_5_GT] = ACTIONS(97),
    [anon_sym_5_GT_GT] = ACTIONS(97),
    [anon_sym_6_GT] = ACTIONS(97),
    [anon_sym_6_GT_GT] = ACTIONS(97),
    [anon_sym_STAR_GT] = ACTIONS(97),
    [anon_sym_STAR_GT_GT] = ACTIONS(97),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(97),
    [anon_sym_2_GT_AMP1] = ACTIONS(97),
    [anon_sym_3_GT_AMP1] = ACTIONS(97),
    [anon_sym_4_GT_AMP1] = ACTIONS(97),
    [anon_sym_5_GT_AMP1] = ACTIONS(97),
    [anon_sym_6_GT_AMP1] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(97),
    [anon_sym_1_GT_AMP2] = ACTIONS(97),
    [anon_sym_3_GT_AMP2] = ACTIONS(97),
    [anon_sym_4_GT_AMP2] = ACTIONS(97),
    [anon_sym_5_GT_AMP2] = ACTIONS(97),
    [anon_sym_6_GT_AMP2] = ACTIONS(97),
    [anon_sym_DASHjoin] = ACTIONS(1009),
    [anon_sym_DASHsplit] = ACTIONS(1009),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(955),
    [anon_sym_DOLLAR_CARET] = ACTIONS(955),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(955),
    [anon_sym_DOLLAR_] = ACTIONS(955),
    [aux_sym_variable_token1] = ACTIONS(955),
    [aux_sym_variable_token2] = ACTIONS(955),
    [sym_braced_variable] = ACTIONS(955),
    [sym_command_parameter] = ACTIONS(97),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_RPAREN] = ACTIONS(97),
    [anon_sym_COMMA] = ACTIONS(1009),
    [anon_sym_LBRACE] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(97),
    [sym_stop_parsing] = ACTIONS(97),
    [anon_sym_SPACE] = ACTIONS(95),
    [anon_sym_COLON] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_DASHnot] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_DASHbnot] = ACTIONS(1009),
    [anon_sym_PLUS_PLUS] = ACTIONS(1011),
    [anon_sym_DASH_DASH] = ACTIONS(1013),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(965),
    [anon_sym_AT_LPAREN] = ACTIONS(967),
    [anon_sym_AT_LBRACE] = ACTIONS(969),
    [anon_sym_DOT2] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(97),
    [anon_sym_DOTforeach] = ACTIONS(95),
  },
  [210] = {
    [sym__literal] = STATE(913),
    [sym_integer_literal] = STATE(913),
    [sym_string_literal] = STATE(913),
    [sym_expandable_string_literal] = STATE(771),
    [sym_expandable_here_string_literal] = STATE(771),
    [sym_variable] = STATE(913),
    [sym_array_literal_expression] = STATE(1061),
    [sym_unary_expression] = STATE(1039),
    [sym_expression_with_unary_operator] = STATE(1049),
    [sym_pre_increment_expression] = STATE(1047),
    [sym_pre_decrement_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1047),
    [sym__primary_expression] = STATE(913),
    [sym__value] = STATE(913),
    [sym_parenthesized_expression] = STATE(913),
    [sym_sub_expression] = STATE(913),
    [sym_array_expression] = STATE(913),
    [sym_script_block_expression] = STATE(913),
    [sym_hash_literal_expression] = STATE(913),
    [sym_post_increment_expression] = STATE(913),
    [sym_post_decrement_expression] = STATE(913),
    [sym_member_access] = STATE(913),
    [sym_element_access] = STATE(913),
    [sym_invokation_expression] = STATE(913),
    [sym_invokation_foreach_expression] = STATE(767),
    [sym_type_literal] = STATE(197),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(837),
    [sym_hexadecimal_integer_literal] = ACTIONS(837),
    [sym_real_literal] = ACTIONS(875),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(841),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(843),
    [sym_verbatim_string_characters] = ACTIONS(845),
    [sym_verbatim_here_string_characters] = ACTIONS(845),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_2_GT] = ACTIONS(937),
    [anon_sym_2_GT_GT] = ACTIONS(937),
    [anon_sym_3_GT] = ACTIONS(937),
    [anon_sym_3_GT_GT] = ACTIONS(937),
    [anon_sym_4_GT] = ACTIONS(937),
    [anon_sym_4_GT_GT] = ACTIONS(937),
    [anon_sym_5_GT] = ACTIONS(937),
    [anon_sym_5_GT_GT] = ACTIONS(937),
    [anon_sym_6_GT] = ACTIONS(937),
    [anon_sym_6_GT_GT] = ACTIONS(937),
    [anon_sym_STAR_GT] = ACTIONS(937),
    [anon_sym_STAR_GT_GT] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(937),
    [anon_sym_2_GT_AMP1] = ACTIONS(937),
    [anon_sym_3_GT_AMP1] = ACTIONS(937),
    [anon_sym_4_GT_AMP1] = ACTIONS(937),
    [anon_sym_5_GT_AMP1] = ACTIONS(937),
    [anon_sym_6_GT_AMP1] = ACTIONS(937),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(937),
    [anon_sym_1_GT_AMP2] = ACTIONS(937),
    [anon_sym_3_GT_AMP2] = ACTIONS(937),
    [anon_sym_4_GT_AMP2] = ACTIONS(937),
    [anon_sym_5_GT_AMP2] = ACTIONS(937),
    [anon_sym_6_GT_AMP2] = ACTIONS(937),
    [anon_sym_DASHjoin] = ACTIONS(877),
    [anon_sym_DASHsplit] = ACTIONS(877),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(851),
    [anon_sym_DOLLAR_CARET] = ACTIONS(851),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(851),
    [anon_sym_DOLLAR_] = ACTIONS(851),
    [aux_sym_variable_token1] = ACTIONS(851),
    [aux_sym_variable_token2] = ACTIONS(851),
    [sym_braced_variable] = ACTIONS(851),
    [sym_generic_token] = ACTIONS(1015),
    [sym_command_parameter] = ACTIONS(937),
    [anon_sym_LPAREN] = ACTIONS(853),
    [anon_sym_COMMA] = ACTIONS(877),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_PIPE] = ACTIONS(937),
    [sym_stop_parsing] = ACTIONS(937),
    [anon_sym_SPACE] = ACTIONS(937),
    [anon_sym_COLON] = ACTIONS(937),
    [anon_sym_DASH_DASH_PERCENT] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_DASHnot] = ACTIONS(877),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_DASHbnot] = ACTIONS(877),
    [anon_sym_PLUS_PLUS] = ACTIONS(879),
    [anon_sym_DASH_DASH] = ACTIONS(881),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [anon_sym_AT_LPAREN] = ACTIONS(863),
    [anon_sym_AT_LBRACE] = ACTIONS(865),
    [sym__statement_terminator] = ACTIONS(1017),
  },
  [211] = {
    [sym__literal] = STATE(800),
    [sym_integer_literal] = STATE(800),
    [sym_string_literal] = STATE(800),
    [sym_expandable_string_literal] = STATE(796),
    [sym_expandable_here_string_literal] = STATE(796),
    [sym_variable] = STATE(800),
    [sym_array_literal_expression] = STATE(1034),
    [sym_unary_expression] = STATE(1030),
    [sym_expression_with_unary_operator] = STATE(1041),
    [sym_pre_increment_expression] = STATE(1035),
    [sym_pre_decrement_expression] = STATE(1035),
    [sym_cast_expression] = STATE(1035),
    [sym__primary_expression] = STATE(800),
    [sym__value] = STATE(800),
    [sym_parenthesized_expression] = STATE(800),
    [sym_sub_expression] = STATE(800),
    [sym_array_expression] = STATE(800),
    [sym_script_block_expression] = STATE(800),
    [sym_hash_literal_expression] = STATE(800),
    [sym_post_increment_expression] = STATE(800),
    [sym_post_decrement_expression] = STATE(800),
    [sym_member_access] = STATE(800),
    [sym_element_access] = STATE(800),
    [sym_invokation_expression] = STATE(800),
    [sym_invokation_foreach_expression] = STATE(801),
    [sym_type_literal] = STATE(202),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(883),
    [sym_hexadecimal_integer_literal] = ACTIONS(883),
    [sym_real_literal] = ACTIONS(923),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(887),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(889),
    [sym_verbatim_string_characters] = ACTIONS(891),
    [sym_verbatim_here_string_characters] = ACTIONS(891),
    [anon_sym_LBRACK] = ACTIONS(893),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_2_GT] = ACTIONS(937),
    [anon_sym_2_GT_GT] = ACTIONS(937),
    [anon_sym_3_GT] = ACTIONS(937),
    [anon_sym_3_GT_GT] = ACTIONS(937),
    [anon_sym_4_GT] = ACTIONS(937),
    [anon_sym_4_GT_GT] = ACTIONS(937),
    [anon_sym_5_GT] = ACTIONS(937),
    [anon_sym_5_GT_GT] = ACTIONS(937),
    [anon_sym_6_GT] = ACTIONS(937),
    [anon_sym_6_GT_GT] = ACTIONS(937),
    [anon_sym_STAR_GT] = ACTIONS(937),
    [anon_sym_STAR_GT_GT] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(937),
    [anon_sym_2_GT_AMP1] = ACTIONS(937),
    [anon_sym_3_GT_AMP1] = ACTIONS(937),
    [anon_sym_4_GT_AMP1] = ACTIONS(937),
    [anon_sym_5_GT_AMP1] = ACTIONS(937),
    [anon_sym_6_GT_AMP1] = ACTIONS(937),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(937),
    [anon_sym_1_GT_AMP2] = ACTIONS(937),
    [anon_sym_3_GT_AMP2] = ACTIONS(937),
    [anon_sym_4_GT_AMP2] = ACTIONS(937),
    [anon_sym_5_GT_AMP2] = ACTIONS(937),
    [anon_sym_6_GT_AMP2] = ACTIONS(937),
    [anon_sym_DASHjoin] = ACTIONS(931),
    [anon_sym_DASHsplit] = ACTIONS(931),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(897),
    [anon_sym_DOLLAR_CARET] = ACTIONS(897),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(897),
    [anon_sym_DOLLAR_] = ACTIONS(897),
    [aux_sym_variable_token1] = ACTIONS(897),
    [aux_sym_variable_token2] = ACTIONS(897),
    [sym_braced_variable] = ACTIONS(897),
    [sym_generic_token] = ACTIONS(939),
    [sym_command_parameter] = ACTIONS(937),
    [anon_sym_LPAREN] = ACTIONS(899),
    [anon_sym_RPAREN] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(901),
    [anon_sym_PIPE] = ACTIONS(937),
    [sym_stop_parsing] = ACTIONS(937),
    [anon_sym_SPACE] = ACTIONS(937),
    [anon_sym_COLON] = ACTIONS(937),
    [anon_sym_DASH_DASH_PERCENT] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(931),
    [anon_sym_DASH] = ACTIONS(931),
    [anon_sym_DASHnot] = ACTIONS(931),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_DASHbnot] = ACTIONS(931),
    [anon_sym_PLUS_PLUS] = ACTIONS(933),
    [anon_sym_DASH_DASH] = ACTIONS(935),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(907),
    [anon_sym_AT_LPAREN] = ACTIONS(909),
    [anon_sym_AT_LBRACE] = ACTIONS(911),
  },
  [212] = {
    [sym__literal] = STATE(922),
    [sym_integer_literal] = STATE(922),
    [sym_string_literal] = STATE(922),
    [sym_expandable_string_literal] = STATE(850),
    [sym_expandable_here_string_literal] = STATE(850),
    [sym_variable] = STATE(922),
    [sym_unary_expression] = STATE(1056),
    [sym_expression_with_unary_operator] = STATE(1068),
    [sym_pre_increment_expression] = STATE(1073),
    [sym_pre_decrement_expression] = STATE(1073),
    [sym_cast_expression] = STATE(1073),
    [sym__primary_expression] = STATE(922),
    [sym__value] = STATE(922),
    [sym_parenthesized_expression] = STATE(922),
    [sym_sub_expression] = STATE(922),
    [sym_array_expression] = STATE(922),
    [sym_script_block_expression] = STATE(922),
    [sym_hash_literal_expression] = STATE(922),
    [sym_post_increment_expression] = STATE(922),
    [sym_post_decrement_expression] = STATE(922),
    [sym_member_access] = STATE(922),
    [sym_element_access] = STATE(922),
    [sym_invokation_expression] = STATE(922),
    [sym_invokation_foreach_expression] = STATE(861),
    [sym_type_literal] = STATE(212),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(971),
    [sym_hexadecimal_integer_literal] = ACTIONS(971),
    [sym_real_literal] = ACTIONS(1019),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(975),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(977),
    [sym_verbatim_string_characters] = ACTIONS(979),
    [sym_verbatim_here_string_characters] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_GT] = ACTIONS(97),
    [anon_sym_2_GT] = ACTIONS(97),
    [anon_sym_2_GT_GT] = ACTIONS(97),
    [anon_sym_3_GT] = ACTIONS(97),
    [anon_sym_3_GT_GT] = ACTIONS(97),
    [anon_sym_4_GT] = ACTIONS(97),
    [anon_sym_4_GT_GT] = ACTIONS(97),
    [anon_sym_5_GT] = ACTIONS(97),
    [anon_sym_5_GT_GT] = ACTIONS(97),
    [anon_sym_6_GT] = ACTIONS(97),
    [anon_sym_6_GT_GT] = ACTIONS(97),
    [anon_sym_STAR_GT] = ACTIONS(97),
    [anon_sym_STAR_GT_GT] = ACTIONS(97),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(97),
    [anon_sym_2_GT_AMP1] = ACTIONS(97),
    [anon_sym_3_GT_AMP1] = ACTIONS(97),
    [anon_sym_4_GT_AMP1] = ACTIONS(97),
    [anon_sym_5_GT_AMP1] = ACTIONS(97),
    [anon_sym_6_GT_AMP1] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(97),
    [anon_sym_1_GT_AMP2] = ACTIONS(97),
    [anon_sym_3_GT_AMP2] = ACTIONS(97),
    [anon_sym_4_GT_AMP2] = ACTIONS(97),
    [anon_sym_5_GT_AMP2] = ACTIONS(97),
    [anon_sym_6_GT_AMP2] = ACTIONS(97),
    [anon_sym_DASHjoin] = ACTIONS(1021),
    [anon_sym_DASHsplit] = ACTIONS(1021),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(985),
    [anon_sym_DOLLAR_CARET] = ACTIONS(985),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(985),
    [anon_sym_DOLLAR_] = ACTIONS(985),
    [aux_sym_variable_token1] = ACTIONS(985),
    [aux_sym_variable_token2] = ACTIONS(985),
    [sym_braced_variable] = ACTIONS(985),
    [sym_command_parameter] = ACTIONS(97),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_COMMA] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_PIPE] = ACTIONS(97),
    [sym_stop_parsing] = ACTIONS(97),
    [anon_sym_SPACE] = ACTIONS(95),
    [anon_sym_COLON] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_DASH] = ACTIONS(1021),
    [anon_sym_DASHnot] = ACTIONS(1021),
    [anon_sym_BANG] = ACTIONS(1021),
    [anon_sym_DASHbnot] = ACTIONS(1021),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(995),
    [anon_sym_AT_LPAREN] = ACTIONS(997),
    [anon_sym_AT_LBRACE] = ACTIONS(999),
    [anon_sym_DOT2] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(97),
    [anon_sym_DOTforeach] = ACTIONS(95),
    [sym__statement_terminator] = ACTIONS(95),
  },
  [213] = {
    [sym__literal] = STATE(768),
    [sym_integer_literal] = STATE(768),
    [sym_string_literal] = STATE(768),
    [sym_expandable_string_literal] = STATE(771),
    [sym_expandable_here_string_literal] = STATE(771),
    [sym_variable] = STATE(768),
    [sym_array_literal_expression] = STATE(1037),
    [sym_unary_expression] = STATE(1039),
    [sym_expression_with_unary_operator] = STATE(1049),
    [sym_pre_increment_expression] = STATE(1047),
    [sym_pre_decrement_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1047),
    [sym__primary_expression] = STATE(768),
    [sym__value] = STATE(768),
    [sym_parenthesized_expression] = STATE(768),
    [sym_sub_expression] = STATE(768),
    [sym_array_expression] = STATE(768),
    [sym_script_block_expression] = STATE(768),
    [sym_hash_literal_expression] = STATE(768),
    [sym_post_increment_expression] = STATE(768),
    [sym_post_decrement_expression] = STATE(768),
    [sym_member_access] = STATE(768),
    [sym_element_access] = STATE(768),
    [sym_invokation_expression] = STATE(768),
    [sym_invokation_foreach_expression] = STATE(767),
    [sym_type_literal] = STATE(199),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(837),
    [sym_hexadecimal_integer_literal] = ACTIONS(837),
    [sym_real_literal] = ACTIONS(839),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(841),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(843),
    [sym_verbatim_string_characters] = ACTIONS(845),
    [sym_verbatim_here_string_characters] = ACTIONS(845),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_2_GT] = ACTIONS(937),
    [anon_sym_2_GT_GT] = ACTIONS(937),
    [anon_sym_3_GT] = ACTIONS(937),
    [anon_sym_3_GT_GT] = ACTIONS(937),
    [anon_sym_4_GT] = ACTIONS(937),
    [anon_sym_4_GT_GT] = ACTIONS(937),
    [anon_sym_5_GT] = ACTIONS(937),
    [anon_sym_5_GT_GT] = ACTIONS(937),
    [anon_sym_6_GT] = ACTIONS(937),
    [anon_sym_6_GT_GT] = ACTIONS(937),
    [anon_sym_STAR_GT] = ACTIONS(937),
    [anon_sym_STAR_GT_GT] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(937),
    [anon_sym_2_GT_AMP1] = ACTIONS(937),
    [anon_sym_3_GT_AMP1] = ACTIONS(937),
    [anon_sym_4_GT_AMP1] = ACTIONS(937),
    [anon_sym_5_GT_AMP1] = ACTIONS(937),
    [anon_sym_6_GT_AMP1] = ACTIONS(937),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(937),
    [anon_sym_1_GT_AMP2] = ACTIONS(937),
    [anon_sym_3_GT_AMP2] = ACTIONS(937),
    [anon_sym_4_GT_AMP2] = ACTIONS(937),
    [anon_sym_5_GT_AMP2] = ACTIONS(937),
    [anon_sym_6_GT_AMP2] = ACTIONS(937),
    [anon_sym_DASHjoin] = ACTIONS(913),
    [anon_sym_DASHsplit] = ACTIONS(913),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(851),
    [anon_sym_DOLLAR_CARET] = ACTIONS(851),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(851),
    [anon_sym_DOLLAR_] = ACTIONS(851),
    [aux_sym_variable_token1] = ACTIONS(851),
    [aux_sym_variable_token2] = ACTIONS(851),
    [sym_braced_variable] = ACTIONS(851),
    [sym_generic_token] = ACTIONS(1015),
    [sym_command_parameter] = ACTIONS(937),
    [anon_sym_LPAREN] = ACTIONS(853),
    [anon_sym_COMMA] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_PIPE] = ACTIONS(937),
    [sym_stop_parsing] = ACTIONS(937),
    [anon_sym_SPACE] = ACTIONS(937),
    [anon_sym_COLON] = ACTIONS(937),
    [anon_sym_DASH_DASH_PERCENT] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_DASHnot] = ACTIONS(913),
    [anon_sym_BANG] = ACTIONS(913),
    [anon_sym_DASHbnot] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(915),
    [anon_sym_DASH_DASH] = ACTIONS(917),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [anon_sym_AT_LPAREN] = ACTIONS(863),
    [anon_sym_AT_LBRACE] = ACTIONS(865),
    [sym__statement_terminator] = ACTIONS(1017),
  },
  [214] = {
    [sym__literal] = STATE(892),
    [sym_integer_literal] = STATE(892),
    [sym_string_literal] = STATE(892),
    [sym_expandable_string_literal] = STATE(846),
    [sym_expandable_here_string_literal] = STATE(846),
    [sym_variable] = STATE(892),
    [sym_unary_expression] = STATE(874),
    [sym_expression_with_unary_operator] = STATE(881),
    [sym_pre_increment_expression] = STATE(878),
    [sym_pre_decrement_expression] = STATE(878),
    [sym_cast_expression] = STATE(878),
    [sym__primary_expression] = STATE(892),
    [sym__value] = STATE(892),
    [sym_parenthesized_expression] = STATE(892),
    [sym_sub_expression] = STATE(892),
    [sym_array_expression] = STATE(892),
    [sym_script_block_expression] = STATE(892),
    [sym_hash_literal_expression] = STATE(892),
    [sym_post_increment_expression] = STATE(892),
    [sym_post_decrement_expression] = STATE(892),
    [sym_member_access] = STATE(892),
    [sym_element_access] = STATE(892),
    [sym_invokation_expression] = STATE(892),
    [sym_invokation_foreach_expression] = STATE(840),
    [sym_type_literal] = STATE(214),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(941),
    [sym_hexadecimal_integer_literal] = ACTIONS(941),
    [sym_real_literal] = ACTIONS(943),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(945),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(947),
    [sym_verbatim_string_characters] = ACTIONS(949),
    [sym_verbatim_here_string_characters] = ACTIONS(949),
    [anon_sym_LBRACK] = ACTIONS(951),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_GT] = ACTIONS(97),
    [anon_sym_2_GT] = ACTIONS(97),
    [anon_sym_2_GT_GT] = ACTIONS(97),
    [anon_sym_3_GT] = ACTIONS(97),
    [anon_sym_3_GT_GT] = ACTIONS(97),
    [anon_sym_4_GT] = ACTIONS(97),
    [anon_sym_4_GT_GT] = ACTIONS(97),
    [anon_sym_5_GT] = ACTIONS(97),
    [anon_sym_5_GT_GT] = ACTIONS(97),
    [anon_sym_6_GT] = ACTIONS(97),
    [anon_sym_6_GT_GT] = ACTIONS(97),
    [anon_sym_STAR_GT] = ACTIONS(97),
    [anon_sym_STAR_GT_GT] = ACTIONS(97),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(97),
    [anon_sym_2_GT_AMP1] = ACTIONS(97),
    [anon_sym_3_GT_AMP1] = ACTIONS(97),
    [anon_sym_4_GT_AMP1] = ACTIONS(97),
    [anon_sym_5_GT_AMP1] = ACTIONS(97),
    [anon_sym_6_GT_AMP1] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(97),
    [anon_sym_1_GT_AMP2] = ACTIONS(97),
    [anon_sym_3_GT_AMP2] = ACTIONS(97),
    [anon_sym_4_GT_AMP2] = ACTIONS(97),
    [anon_sym_5_GT_AMP2] = ACTIONS(97),
    [anon_sym_6_GT_AMP2] = ACTIONS(97),
    [anon_sym_DASHjoin] = ACTIONS(1027),
    [anon_sym_DASHsplit] = ACTIONS(1027),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(955),
    [anon_sym_DOLLAR_CARET] = ACTIONS(955),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(955),
    [anon_sym_DOLLAR_] = ACTIONS(955),
    [aux_sym_variable_token1] = ACTIONS(955),
    [aux_sym_variable_token2] = ACTIONS(955),
    [sym_braced_variable] = ACTIONS(955),
    [sym_command_parameter] = ACTIONS(97),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_RPAREN] = ACTIONS(97),
    [anon_sym_COMMA] = ACTIONS(1027),
    [anon_sym_LBRACE] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(97),
    [sym_stop_parsing] = ACTIONS(97),
    [anon_sym_SPACE] = ACTIONS(95),
    [anon_sym_COLON] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_DASHnot] = ACTIONS(1027),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_DASHbnot] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1031),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(965),
    [anon_sym_AT_LPAREN] = ACTIONS(967),
    [anon_sym_AT_LBRACE] = ACTIONS(969),
    [anon_sym_DOT2] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(97),
    [anon_sym_DOTforeach] = ACTIONS(95),
  },
  [215] = {
    [sym__literal] = STATE(924),
    [sym_integer_literal] = STATE(924),
    [sym_string_literal] = STATE(924),
    [sym_expandable_string_literal] = STATE(846),
    [sym_expandable_here_string_literal] = STATE(846),
    [sym_variable] = STATE(924),
    [sym_array_literal_expression] = STATE(1092),
    [sym_unary_expression] = STATE(1064),
    [sym_expression_with_unary_operator] = STATE(1076),
    [sym_pre_increment_expression] = STATE(1059),
    [sym_pre_decrement_expression] = STATE(1059),
    [sym_cast_expression] = STATE(1059),
    [sym__primary_expression] = STATE(924),
    [sym__value] = STATE(924),
    [sym_parenthesized_expression] = STATE(924),
    [sym_sub_expression] = STATE(924),
    [sym_array_expression] = STATE(924),
    [sym_script_block_expression] = STATE(924),
    [sym_hash_literal_expression] = STATE(924),
    [sym_post_increment_expression] = STATE(924),
    [sym_post_decrement_expression] = STATE(924),
    [sym_member_access] = STATE(924),
    [sym_element_access] = STATE(924),
    [sym_invokation_expression] = STATE(924),
    [sym_invokation_foreach_expression] = STATE(840),
    [sym_type_literal] = STATE(209),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(941),
    [sym_hexadecimal_integer_literal] = ACTIONS(941),
    [sym_real_literal] = ACTIONS(1007),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(945),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(947),
    [sym_verbatim_string_characters] = ACTIONS(949),
    [sym_verbatim_here_string_characters] = ACTIONS(949),
    [anon_sym_LBRACK] = ACTIONS(951),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_2_GT] = ACTIONS(937),
    [anon_sym_2_GT_GT] = ACTIONS(937),
    [anon_sym_3_GT] = ACTIONS(937),
    [anon_sym_3_GT_GT] = ACTIONS(937),
    [anon_sym_4_GT] = ACTIONS(937),
    [anon_sym_4_GT_GT] = ACTIONS(937),
    [anon_sym_5_GT] = ACTIONS(937),
    [anon_sym_5_GT_GT] = ACTIONS(937),
    [anon_sym_6_GT] = ACTIONS(937),
    [anon_sym_6_GT_GT] = ACTIONS(937),
    [anon_sym_STAR_GT] = ACTIONS(937),
    [anon_sym_STAR_GT_GT] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(937),
    [anon_sym_2_GT_AMP1] = ACTIONS(937),
    [anon_sym_3_GT_AMP1] = ACTIONS(937),
    [anon_sym_4_GT_AMP1] = ACTIONS(937),
    [anon_sym_5_GT_AMP1] = ACTIONS(937),
    [anon_sym_6_GT_AMP1] = ACTIONS(937),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(937),
    [anon_sym_1_GT_AMP2] = ACTIONS(937),
    [anon_sym_3_GT_AMP2] = ACTIONS(937),
    [anon_sym_4_GT_AMP2] = ACTIONS(937),
    [anon_sym_5_GT_AMP2] = ACTIONS(937),
    [anon_sym_6_GT_AMP2] = ACTIONS(937),
    [anon_sym_DASHjoin] = ACTIONS(1009),
    [anon_sym_DASHsplit] = ACTIONS(1009),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(955),
    [anon_sym_DOLLAR_CARET] = ACTIONS(955),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(955),
    [anon_sym_DOLLAR_] = ACTIONS(955),
    [aux_sym_variable_token1] = ACTIONS(955),
    [aux_sym_variable_token2] = ACTIONS(955),
    [sym_braced_variable] = ACTIONS(955),
    [sym_generic_token] = ACTIONS(1033),
    [sym_command_parameter] = ACTIONS(937),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_RPAREN] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(1009),
    [anon_sym_LBRACE] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(937),
    [sym_stop_parsing] = ACTIONS(937),
    [anon_sym_SPACE] = ACTIONS(937),
    [anon_sym_COLON] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_DASHnot] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_DASHbnot] = ACTIONS(1009),
    [anon_sym_PLUS_PLUS] = ACTIONS(1011),
    [anon_sym_DASH_DASH] = ACTIONS(1013),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(965),
    [anon_sym_AT_LPAREN] = ACTIONS(967),
    [anon_sym_AT_LBRACE] = ACTIONS(969),
  },
  [216] = {
    [sym__literal] = STATE(922),
    [sym_integer_literal] = STATE(922),
    [sym_string_literal] = STATE(922),
    [sym_expandable_string_literal] = STATE(850),
    [sym_expandable_here_string_literal] = STATE(850),
    [sym_variable] = STATE(922),
    [sym_array_literal_expression] = STATE(1095),
    [sym_unary_expression] = STATE(1075),
    [sym_expression_with_unary_operator] = STATE(1068),
    [sym_pre_increment_expression] = STATE(1073),
    [sym_pre_decrement_expression] = STATE(1073),
    [sym_cast_expression] = STATE(1073),
    [sym__primary_expression] = STATE(922),
    [sym__value] = STATE(922),
    [sym_parenthesized_expression] = STATE(922),
    [sym_sub_expression] = STATE(922),
    [sym_array_expression] = STATE(922),
    [sym_script_block_expression] = STATE(922),
    [sym_hash_literal_expression] = STATE(922),
    [sym_post_increment_expression] = STATE(922),
    [sym_post_decrement_expression] = STATE(922),
    [sym_member_access] = STATE(922),
    [sym_element_access] = STATE(922),
    [sym_invokation_expression] = STATE(922),
    [sym_invokation_foreach_expression] = STATE(861),
    [sym_type_literal] = STATE(212),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(971),
    [sym_hexadecimal_integer_literal] = ACTIONS(971),
    [sym_real_literal] = ACTIONS(1019),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(975),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(977),
    [sym_verbatim_string_characters] = ACTIONS(979),
    [sym_verbatim_here_string_characters] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_2_GT] = ACTIONS(937),
    [anon_sym_2_GT_GT] = ACTIONS(937),
    [anon_sym_3_GT] = ACTIONS(937),
    [anon_sym_3_GT_GT] = ACTIONS(937),
    [anon_sym_4_GT] = ACTIONS(937),
    [anon_sym_4_GT_GT] = ACTIONS(937),
    [anon_sym_5_GT] = ACTIONS(937),
    [anon_sym_5_GT_GT] = ACTIONS(937),
    [anon_sym_6_GT] = ACTIONS(937),
    [anon_sym_6_GT_GT] = ACTIONS(937),
    [anon_sym_STAR_GT] = ACTIONS(937),
    [anon_sym_STAR_GT_GT] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(937),
    [anon_sym_2_GT_AMP1] = ACTIONS(937),
    [anon_sym_3_GT_AMP1] = ACTIONS(937),
    [anon_sym_4_GT_AMP1] = ACTIONS(937),
    [anon_sym_5_GT_AMP1] = ACTIONS(937),
    [anon_sym_6_GT_AMP1] = ACTIONS(937),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(937),
    [anon_sym_1_GT_AMP2] = ACTIONS(937),
    [anon_sym_3_GT_AMP2] = ACTIONS(937),
    [anon_sym_4_GT_AMP2] = ACTIONS(937),
    [anon_sym_5_GT_AMP2] = ACTIONS(937),
    [anon_sym_6_GT_AMP2] = ACTIONS(937),
    [anon_sym_DASHjoin] = ACTIONS(1021),
    [anon_sym_DASHsplit] = ACTIONS(1021),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(985),
    [anon_sym_DOLLAR_CARET] = ACTIONS(985),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(985),
    [anon_sym_DOLLAR_] = ACTIONS(985),
    [aux_sym_variable_token1] = ACTIONS(985),
    [aux_sym_variable_token2] = ACTIONS(985),
    [sym_braced_variable] = ACTIONS(985),
    [sym_generic_token] = ACTIONS(1035),
    [sym_command_parameter] = ACTIONS(937),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_COMMA] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_PIPE] = ACTIONS(937),
    [sym_stop_parsing] = ACTIONS(937),
    [anon_sym_SPACE] = ACTIONS(937),
    [anon_sym_COLON] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_DASH] = ACTIONS(1021),
    [anon_sym_DASHnot] = ACTIONS(1021),
    [anon_sym_BANG] = ACTIONS(1021),
    [anon_sym_DASHbnot] = ACTIONS(1021),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(995),
    [anon_sym_AT_LPAREN] = ACTIONS(997),
    [anon_sym_AT_LBRACE] = ACTIONS(999),
    [sym__statement_terminator] = ACTIONS(1017),
  },
  [217] = {
    [sym__literal] = STATE(892),
    [sym_integer_literal] = STATE(892),
    [sym_string_literal] = STATE(892),
    [sym_expandable_string_literal] = STATE(846),
    [sym_expandable_here_string_literal] = STATE(846),
    [sym_variable] = STATE(892),
    [sym_array_literal_expression] = STATE(1066),
    [sym_unary_expression] = STATE(1064),
    [sym_expression_with_unary_operator] = STATE(1076),
    [sym_pre_increment_expression] = STATE(1059),
    [sym_pre_decrement_expression] = STATE(1059),
    [sym_cast_expression] = STATE(1059),
    [sym__primary_expression] = STATE(892),
    [sym__value] = STATE(892),
    [sym_parenthesized_expression] = STATE(892),
    [sym_sub_expression] = STATE(892),
    [sym_array_expression] = STATE(892),
    [sym_script_block_expression] = STATE(892),
    [sym_hash_literal_expression] = STATE(892),
    [sym_post_increment_expression] = STATE(892),
    [sym_post_decrement_expression] = STATE(892),
    [sym_member_access] = STATE(892),
    [sym_element_access] = STATE(892),
    [sym_invokation_expression] = STATE(892),
    [sym_invokation_foreach_expression] = STATE(840),
    [sym_type_literal] = STATE(206),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(941),
    [sym_hexadecimal_integer_literal] = ACTIONS(941),
    [sym_real_literal] = ACTIONS(943),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(945),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(947),
    [sym_verbatim_string_characters] = ACTIONS(949),
    [sym_verbatim_here_string_characters] = ACTIONS(949),
    [anon_sym_LBRACK] = ACTIONS(951),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_2_GT] = ACTIONS(937),
    [anon_sym_2_GT_GT] = ACTIONS(937),
    [anon_sym_3_GT] = ACTIONS(937),
    [anon_sym_3_GT_GT] = ACTIONS(937),
    [anon_sym_4_GT] = ACTIONS(937),
    [anon_sym_4_GT_GT] = ACTIONS(937),
    [anon_sym_5_GT] = ACTIONS(937),
    [anon_sym_5_GT_GT] = ACTIONS(937),
    [anon_sym_6_GT] = ACTIONS(937),
    [anon_sym_6_GT_GT] = ACTIONS(937),
    [anon_sym_STAR_GT] = ACTIONS(937),
    [anon_sym_STAR_GT_GT] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(937),
    [anon_sym_2_GT_AMP1] = ACTIONS(937),
    [anon_sym_3_GT_AMP1] = ACTIONS(937),
    [anon_sym_4_GT_AMP1] = ACTIONS(937),
    [anon_sym_5_GT_AMP1] = ACTIONS(937),
    [anon_sym_6_GT_AMP1] = ACTIONS(937),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(937),
    [anon_sym_1_GT_AMP2] = ACTIONS(937),
    [anon_sym_3_GT_AMP2] = ACTIONS(937),
    [anon_sym_4_GT_AMP2] = ACTIONS(937),
    [anon_sym_5_GT_AMP2] = ACTIONS(937),
    [anon_sym_6_GT_AMP2] = ACTIONS(937),
    [anon_sym_DASHjoin] = ACTIONS(953),
    [anon_sym_DASHsplit] = ACTIONS(953),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(955),
    [anon_sym_DOLLAR_CARET] = ACTIONS(955),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(955),
    [anon_sym_DOLLAR_] = ACTIONS(955),
    [aux_sym_variable_token1] = ACTIONS(955),
    [aux_sym_variable_token2] = ACTIONS(955),
    [sym_braced_variable] = ACTIONS(955),
    [sym_generic_token] = ACTIONS(1033),
    [sym_command_parameter] = ACTIONS(937),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_RPAREN] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(953),
    [anon_sym_LBRACE] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(937),
    [sym_stop_parsing] = ACTIONS(937),
    [anon_sym_SPACE] = ACTIONS(937),
    [anon_sym_COLON] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_DASH] = ACTIONS(953),
    [anon_sym_DASHnot] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_DASHbnot] = ACTIONS(953),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(963),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(965),
    [anon_sym_AT_LPAREN] = ACTIONS(967),
    [anon_sym_AT_LBRACE] = ACTIONS(969),
  },
  [218] = {
    [sym__literal] = STATE(858),
    [sym_integer_literal] = STATE(858),
    [sym_string_literal] = STATE(858),
    [sym_expandable_string_literal] = STATE(850),
    [sym_expandable_here_string_literal] = STATE(850),
    [sym_variable] = STATE(858),
    [sym_array_literal_expression] = STATE(1072),
    [sym_unary_expression] = STATE(1075),
    [sym_expression_with_unary_operator] = STATE(1068),
    [sym_pre_increment_expression] = STATE(1073),
    [sym_pre_decrement_expression] = STATE(1073),
    [sym_cast_expression] = STATE(1073),
    [sym__primary_expression] = STATE(858),
    [sym__value] = STATE(858),
    [sym_parenthesized_expression] = STATE(858),
    [sym_sub_expression] = STATE(858),
    [sym_array_expression] = STATE(858),
    [sym_script_block_expression] = STATE(858),
    [sym_hash_literal_expression] = STATE(858),
    [sym_post_increment_expression] = STATE(858),
    [sym_post_decrement_expression] = STATE(858),
    [sym_member_access] = STATE(858),
    [sym_element_access] = STATE(858),
    [sym_invokation_expression] = STATE(858),
    [sym_invokation_foreach_expression] = STATE(861),
    [sym_type_literal] = STATE(208),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(971),
    [sym_hexadecimal_integer_literal] = ACTIONS(971),
    [sym_real_literal] = ACTIONS(973),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(975),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(977),
    [sym_verbatim_string_characters] = ACTIONS(979),
    [sym_verbatim_here_string_characters] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(981),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_2_GT] = ACTIONS(937),
    [anon_sym_2_GT_GT] = ACTIONS(937),
    [anon_sym_3_GT] = ACTIONS(937),
    [anon_sym_3_GT_GT] = ACTIONS(937),
    [anon_sym_4_GT] = ACTIONS(937),
    [anon_sym_4_GT_GT] = ACTIONS(937),
    [anon_sym_5_GT] = ACTIONS(937),
    [anon_sym_5_GT_GT] = ACTIONS(937),
    [anon_sym_6_GT] = ACTIONS(937),
    [anon_sym_6_GT_GT] = ACTIONS(937),
    [anon_sym_STAR_GT] = ACTIONS(937),
    [anon_sym_STAR_GT_GT] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(937),
    [anon_sym_2_GT_AMP1] = ACTIONS(937),
    [anon_sym_3_GT_AMP1] = ACTIONS(937),
    [anon_sym_4_GT_AMP1] = ACTIONS(937),
    [anon_sym_5_GT_AMP1] = ACTIONS(937),
    [anon_sym_6_GT_AMP1] = ACTIONS(937),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(937),
    [anon_sym_1_GT_AMP2] = ACTIONS(937),
    [anon_sym_3_GT_AMP2] = ACTIONS(937),
    [anon_sym_4_GT_AMP2] = ACTIONS(937),
    [anon_sym_5_GT_AMP2] = ACTIONS(937),
    [anon_sym_6_GT_AMP2] = ACTIONS(937),
    [anon_sym_DASHjoin] = ACTIONS(1001),
    [anon_sym_DASHsplit] = ACTIONS(1001),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(985),
    [anon_sym_DOLLAR_CARET] = ACTIONS(985),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(985),
    [anon_sym_DOLLAR_] = ACTIONS(985),
    [aux_sym_variable_token1] = ACTIONS(985),
    [aux_sym_variable_token2] = ACTIONS(985),
    [sym_braced_variable] = ACTIONS(985),
    [sym_generic_token] = ACTIONS(1035),
    [sym_command_parameter] = ACTIONS(937),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_COMMA] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_PIPE] = ACTIONS(937),
    [sym_stop_parsing] = ACTIONS(937),
    [anon_sym_SPACE] = ACTIONS(937),
    [anon_sym_COLON] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_DASHnot] = ACTIONS(1001),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_DASHbnot] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1003),
    [anon_sym_DASH_DASH] = ACTIONS(1005),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(995),
    [anon_sym_AT_LPAREN] = ACTIONS(997),
    [anon_sym_AT_LBRACE] = ACTIONS(999),
    [sym__statement_terminator] = ACTIONS(1017),
  },
  [219] = {
    [sym__literal] = STATE(987),
    [sym_integer_literal] = STATE(987),
    [sym_string_literal] = STATE(987),
    [sym_expandable_string_literal] = STATE(930),
    [sym_expandable_here_string_literal] = STATE(930),
    [sym_variable] = STATE(987),
    [sym_unary_expression] = STATE(944),
    [sym_expression_with_unary_operator] = STATE(952),
    [sym_pre_increment_expression] = STATE(933),
    [sym_pre_decrement_expression] = STATE(933),
    [sym_cast_expression] = STATE(933),
    [sym__primary_expression] = STATE(987),
    [sym__value] = STATE(987),
    [sym_parenthesized_expression] = STATE(987),
    [sym_sub_expression] = STATE(987),
    [sym_array_expression] = STATE(987),
    [sym_script_block_expression] = STATE(987),
    [sym_hash_literal_expression] = STATE(987),
    [sym_post_increment_expression] = STATE(987),
    [sym_post_decrement_expression] = STATE(987),
    [sym_member_access] = STATE(987),
    [sym_element_access] = STATE(987),
    [sym_invokation_expression] = STATE(987),
    [sym_invokation_foreach_expression] = STATE(950),
    [sym_type_literal] = STATE(219),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(1037),
    [sym_hexadecimal_integer_literal] = ACTIONS(1039),
    [sym_real_literal] = ACTIONS(1041),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1043),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1045),
    [sym_verbatim_string_characters] = ACTIONS(1047),
    [sym_verbatim_here_string_characters] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_GT] = ACTIONS(95),
    [anon_sym_2_GT] = ACTIONS(97),
    [anon_sym_2_GT_GT] = ACTIONS(95),
    [anon_sym_3_GT] = ACTIONS(97),
    [anon_sym_3_GT_GT] = ACTIONS(95),
    [anon_sym_4_GT] = ACTIONS(97),
    [anon_sym_4_GT_GT] = ACTIONS(95),
    [anon_sym_5_GT] = ACTIONS(97),
    [anon_sym_5_GT_GT] = ACTIONS(95),
    [anon_sym_6_GT] = ACTIONS(97),
    [anon_sym_6_GT_GT] = ACTIONS(95),
    [anon_sym_STAR_GT] = ACTIONS(97),
    [anon_sym_STAR_GT_GT] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(95),
    [anon_sym_2_GT_AMP1] = ACTIONS(95),
    [anon_sym_3_GT_AMP1] = ACTIONS(95),
    [anon_sym_4_GT_AMP1] = ACTIONS(95),
    [anon_sym_5_GT_AMP1] = ACTIONS(95),
    [anon_sym_6_GT_AMP1] = ACTIONS(95),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(95),
    [anon_sym_1_GT_AMP2] = ACTIONS(95),
    [anon_sym_3_GT_AMP2] = ACTIONS(95),
    [anon_sym_4_GT_AMP2] = ACTIONS(95),
    [anon_sym_5_GT_AMP2] = ACTIONS(95),
    [anon_sym_6_GT_AMP2] = ACTIONS(95),
    [anon_sym_DASHjoin] = ACTIONS(1051),
    [anon_sym_DASHsplit] = ACTIONS(1051),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1053),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1053),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1053),
    [anon_sym_DOLLAR_] = ACTIONS(1055),
    [aux_sym_variable_token1] = ACTIONS(1055),
    [aux_sym_variable_token2] = ACTIONS(1053),
    [sym_braced_variable] = ACTIONS(1053),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(95),
    [anon_sym_COMMA] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_DASHnot] = ACTIONS(1051),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_DASHbnot] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1067),
    [anon_sym_AT_LPAREN] = ACTIONS(1069),
    [anon_sym_AT_LBRACE] = ACTIONS(1071),
    [anon_sym_DOT2] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(95),
    [anon_sym_DOTforeach] = ACTIONS(95),
  },
  [220] = {
    [sym__literal] = STATE(1029),
    [sym_integer_literal] = STATE(1029),
    [sym_string_literal] = STATE(1029),
    [sym_expandable_string_literal] = STATE(930),
    [sym_expandable_here_string_literal] = STATE(930),
    [sym_variable] = STATE(1029),
    [sym_unary_expression] = STATE(163),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(1029),
    [sym__value] = STATE(1029),
    [sym_parenthesized_expression] = STATE(1029),
    [sym_sub_expression] = STATE(1029),
    [sym_array_expression] = STATE(1029),
    [sym_script_block_expression] = STATE(1029),
    [sym_hash_literal_expression] = STATE(1029),
    [sym_post_increment_expression] = STATE(1029),
    [sym_post_decrement_expression] = STATE(1029),
    [sym_member_access] = STATE(1029),
    [sym_element_access] = STATE(1029),
    [sym_invokation_expression] = STATE(1029),
    [sym_invokation_foreach_expression] = STATE(950),
    [sym_type_literal] = STATE(220),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(1037),
    [sym_hexadecimal_integer_literal] = ACTIONS(1039),
    [sym_real_literal] = ACTIONS(1073),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1043),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1045),
    [sym_verbatim_string_characters] = ACTIONS(1047),
    [sym_verbatim_here_string_characters] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_GT] = ACTIONS(95),
    [anon_sym_2_GT] = ACTIONS(97),
    [anon_sym_2_GT_GT] = ACTIONS(95),
    [anon_sym_3_GT] = ACTIONS(97),
    [anon_sym_3_GT_GT] = ACTIONS(95),
    [anon_sym_4_GT] = ACTIONS(97),
    [anon_sym_4_GT_GT] = ACTIONS(95),
    [anon_sym_5_GT] = ACTIONS(97),
    [anon_sym_5_GT_GT] = ACTIONS(95),
    [anon_sym_6_GT] = ACTIONS(97),
    [anon_sym_6_GT_GT] = ACTIONS(95),
    [anon_sym_STAR_GT] = ACTIONS(97),
    [anon_sym_STAR_GT_GT] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(95),
    [anon_sym_2_GT_AMP1] = ACTIONS(95),
    [anon_sym_3_GT_AMP1] = ACTIONS(95),
    [anon_sym_4_GT_AMP1] = ACTIONS(95),
    [anon_sym_5_GT_AMP1] = ACTIONS(95),
    [anon_sym_6_GT_AMP1] = ACTIONS(95),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(95),
    [anon_sym_1_GT_AMP2] = ACTIONS(95),
    [anon_sym_3_GT_AMP2] = ACTIONS(95),
    [anon_sym_4_GT_AMP2] = ACTIONS(95),
    [anon_sym_5_GT_AMP2] = ACTIONS(95),
    [anon_sym_6_GT_AMP2] = ACTIONS(95),
    [anon_sym_DASHjoin] = ACTIONS(1075),
    [anon_sym_DASHsplit] = ACTIONS(1075),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1053),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1053),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1053),
    [anon_sym_DOLLAR_] = ACTIONS(1055),
    [aux_sym_variable_token1] = ACTIONS(1055),
    [aux_sym_variable_token2] = ACTIONS(1053),
    [sym_braced_variable] = ACTIONS(1053),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(95),
    [anon_sym_COMMA] = ACTIONS(1075),
    [anon_sym_LBRACE] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_PLUS] = ACTIONS(1077),
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DASHnot] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1075),
    [anon_sym_DASHbnot] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1067),
    [anon_sym_AT_LPAREN] = ACTIONS(1069),
    [anon_sym_AT_LBRACE] = ACTIONS(1071),
    [anon_sym_DOT2] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(95),
    [anon_sym_DOTforeach] = ACTIONS(95),
  },
  [221] = {
    [sym__literal] = STATE(1016),
    [sym_integer_literal] = STATE(1016),
    [sym_string_literal] = STATE(1016),
    [sym_expandable_string_literal] = STATE(1005),
    [sym_expandable_here_string_literal] = STATE(1005),
    [sym_variable] = STATE(1016),
    [sym_unary_expression] = STATE(1012),
    [sym_expression_with_unary_operator] = STATE(1017),
    [sym_pre_increment_expression] = STATE(1025),
    [sym_pre_decrement_expression] = STATE(1025),
    [sym_cast_expression] = STATE(1025),
    [sym__primary_expression] = STATE(1016),
    [sym__value] = STATE(1016),
    [sym_parenthesized_expression] = STATE(1016),
    [sym_sub_expression] = STATE(1016),
    [sym_array_expression] = STATE(1016),
    [sym_script_block_expression] = STATE(1016),
    [sym_hash_literal_expression] = STATE(1016),
    [sym_post_increment_expression] = STATE(1016),
    [sym_post_decrement_expression] = STATE(1016),
    [sym_member_access] = STATE(1016),
    [sym_element_access] = STATE(1016),
    [sym_invokation_expression] = STATE(1016),
    [sym_invokation_foreach_expression] = STATE(1022),
    [sym_type_literal] = STATE(221),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(1083),
    [sym_hexadecimal_integer_literal] = ACTIONS(1085),
    [sym_real_literal] = ACTIONS(1087),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1089),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1091),
    [sym_verbatim_string_characters] = ACTIONS(1093),
    [sym_verbatim_here_string_characters] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_GT] = ACTIONS(95),
    [anon_sym_2_GT] = ACTIONS(97),
    [anon_sym_2_GT_GT] = ACTIONS(95),
    [anon_sym_3_GT] = ACTIONS(97),
    [anon_sym_3_GT_GT] = ACTIONS(95),
    [anon_sym_4_GT] = ACTIONS(97),
    [anon_sym_4_GT_GT] = ACTIONS(95),
    [anon_sym_5_GT] = ACTIONS(97),
    [anon_sym_5_GT_GT] = ACTIONS(95),
    [anon_sym_6_GT] = ACTIONS(97),
    [anon_sym_6_GT_GT] = ACTIONS(95),
    [anon_sym_STAR_GT] = ACTIONS(97),
    [anon_sym_STAR_GT_GT] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(95),
    [anon_sym_2_GT_AMP1] = ACTIONS(95),
    [anon_sym_3_GT_AMP1] = ACTIONS(95),
    [anon_sym_4_GT_AMP1] = ACTIONS(95),
    [anon_sym_5_GT_AMP1] = ACTIONS(95),
    [anon_sym_6_GT_AMP1] = ACTIONS(95),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(95),
    [anon_sym_1_GT_AMP2] = ACTIONS(95),
    [anon_sym_3_GT_AMP2] = ACTIONS(95),
    [anon_sym_4_GT_AMP2] = ACTIONS(95),
    [anon_sym_5_GT_AMP2] = ACTIONS(95),
    [anon_sym_6_GT_AMP2] = ACTIONS(95),
    [anon_sym_DASHjoin] = ACTIONS(1097),
    [anon_sym_DASHsplit] = ACTIONS(1097),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1099),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1099),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1099),
    [anon_sym_DOLLAR_] = ACTIONS(1101),
    [aux_sym_variable_token1] = ACTIONS(1101),
    [aux_sym_variable_token2] = ACTIONS(1099),
    [sym_braced_variable] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_PLUS] = ACTIONS(1107),
    [anon_sym_DASH] = ACTIONS(1107),
    [anon_sym_DASHnot] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_DASHbnot] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1109),
    [anon_sym_DASH_DASH] = ACTIONS(1111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1113),
    [anon_sym_AT_LPAREN] = ACTIONS(1115),
    [anon_sym_AT_LBRACE] = ACTIONS(1117),
    [anon_sym_DOT2] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(95),
    [anon_sym_DOTforeach] = ACTIONS(95),
    [sym__statement_terminator] = ACTIONS(95),
  },
  [222] = {
    [sym__literal] = STATE(1048),
    [sym_integer_literal] = STATE(1048),
    [sym_string_literal] = STATE(1048),
    [sym_expandable_string_literal] = STATE(1005),
    [sym_expandable_here_string_literal] = STATE(1005),
    [sym_variable] = STATE(1048),
    [sym_unary_expression] = STATE(165),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(1048),
    [sym__value] = STATE(1048),
    [sym_parenthesized_expression] = STATE(1048),
    [sym_sub_expression] = STATE(1048),
    [sym_array_expression] = STATE(1048),
    [sym_script_block_expression] = STATE(1048),
    [sym_hash_literal_expression] = STATE(1048),
    [sym_post_increment_expression] = STATE(1048),
    [sym_post_decrement_expression] = STATE(1048),
    [sym_member_access] = STATE(1048),
    [sym_element_access] = STATE(1048),
    [sym_invokation_expression] = STATE(1048),
    [sym_invokation_foreach_expression] = STATE(1022),
    [sym_type_literal] = STATE(222),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(1083),
    [sym_hexadecimal_integer_literal] = ACTIONS(1085),
    [sym_real_literal] = ACTIONS(1119),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1089),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1091),
    [sym_verbatim_string_characters] = ACTIONS(1093),
    [sym_verbatim_here_string_characters] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_GT_GT] = ACTIONS(95),
    [anon_sym_2_GT] = ACTIONS(97),
    [anon_sym_2_GT_GT] = ACTIONS(95),
    [anon_sym_3_GT] = ACTIONS(97),
    [anon_sym_3_GT_GT] = ACTIONS(95),
    [anon_sym_4_GT] = ACTIONS(97),
    [anon_sym_4_GT_GT] = ACTIONS(95),
    [anon_sym_5_GT] = ACTIONS(97),
    [anon_sym_5_GT_GT] = ACTIONS(95),
    [anon_sym_6_GT] = ACTIONS(97),
    [anon_sym_6_GT_GT] = ACTIONS(95),
    [anon_sym_STAR_GT] = ACTIONS(97),
    [anon_sym_STAR_GT_GT] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(97),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(95),
    [anon_sym_2_GT_AMP1] = ACTIONS(95),
    [anon_sym_3_GT_AMP1] = ACTIONS(95),
    [anon_sym_4_GT_AMP1] = ACTIONS(95),
    [anon_sym_5_GT_AMP1] = ACTIONS(95),
    [anon_sym_6_GT_AMP1] = ACTIONS(95),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(95),
    [anon_sym_1_GT_AMP2] = ACTIONS(95),
    [anon_sym_3_GT_AMP2] = ACTIONS(95),
    [anon_sym_4_GT_AMP2] = ACTIONS(95),
    [anon_sym_5_GT_AMP2] = ACTIONS(95),
    [anon_sym_6_GT_AMP2] = ACTIONS(95),
    [anon_sym_DASHjoin] = ACTIONS(1121),
    [anon_sym_DASHsplit] = ACTIONS(1121),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1099),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1099),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1099),
    [anon_sym_DOLLAR_] = ACTIONS(1101),
    [aux_sym_variable_token1] = ACTIONS(1101),
    [aux_sym_variable_token2] = ACTIONS(1099),
    [sym_braced_variable] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_DASHnot] = ACTIONS(1121),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_DASHbnot] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1125),
    [anon_sym_DASH_DASH] = ACTIONS(1127),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1113),
    [anon_sym_AT_LPAREN] = ACTIONS(1115),
    [anon_sym_AT_LBRACE] = ACTIONS(1117),
    [anon_sym_DOT2] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(95),
    [anon_sym_DOTforeach] = ACTIONS(95),
    [sym__statement_terminator] = ACTIONS(95),
  },
  [223] = {
    [sym__literal] = STATE(1029),
    [sym_integer_literal] = STATE(1029),
    [sym_string_literal] = STATE(1029),
    [sym_expandable_string_literal] = STATE(930),
    [sym_expandable_here_string_literal] = STATE(930),
    [sym_variable] = STATE(1029),
    [sym_array_literal_expression] = STATE(1122),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(1029),
    [sym__value] = STATE(1029),
    [sym_parenthesized_expression] = STATE(1029),
    [sym_sub_expression] = STATE(1029),
    [sym_array_expression] = STATE(1029),
    [sym_script_block_expression] = STATE(1029),
    [sym_hash_literal_expression] = STATE(1029),
    [sym_post_increment_expression] = STATE(1029),
    [sym_post_decrement_expression] = STATE(1029),
    [sym_member_access] = STATE(1029),
    [sym_element_access] = STATE(1029),
    [sym_invokation_expression] = STATE(1029),
    [sym_invokation_foreach_expression] = STATE(950),
    [sym_type_literal] = STATE(220),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1037),
    [sym_hexadecimal_integer_literal] = ACTIONS(1037),
    [sym_real_literal] = ACTIONS(1129),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1131),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1133),
    [sym_verbatim_string_characters] = ACTIONS(1135),
    [sym_verbatim_here_string_characters] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_2_GT] = ACTIONS(937),
    [anon_sym_2_GT_GT] = ACTIONS(937),
    [anon_sym_3_GT] = ACTIONS(937),
    [anon_sym_3_GT_GT] = ACTIONS(937),
    [anon_sym_4_GT] = ACTIONS(937),
    [anon_sym_4_GT_GT] = ACTIONS(937),
    [anon_sym_5_GT] = ACTIONS(937),
    [anon_sym_5_GT_GT] = ACTIONS(937),
    [anon_sym_6_GT] = ACTIONS(937),
    [anon_sym_6_GT_GT] = ACTIONS(937),
    [anon_sym_STAR_GT] = ACTIONS(937),
    [anon_sym_STAR_GT_GT] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(937),
    [anon_sym_2_GT_AMP1] = ACTIONS(937),
    [anon_sym_3_GT_AMP1] = ACTIONS(937),
    [anon_sym_4_GT_AMP1] = ACTIONS(937),
    [anon_sym_5_GT_AMP1] = ACTIONS(937),
    [anon_sym_6_GT_AMP1] = ACTIONS(937),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(937),
    [anon_sym_1_GT_AMP2] = ACTIONS(937),
    [anon_sym_3_GT_AMP2] = ACTIONS(937),
    [anon_sym_4_GT_AMP2] = ACTIONS(937),
    [anon_sym_5_GT_AMP2] = ACTIONS(937),
    [anon_sym_6_GT_AMP2] = ACTIONS(937),
    [anon_sym_DASHjoin] = ACTIONS(1077),
    [anon_sym_DASHsplit] = ACTIONS(1077),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1055),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1055),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1055),
    [anon_sym_DOLLAR_] = ACTIONS(1055),
    [aux_sym_variable_token1] = ACTIONS(1055),
    [aux_sym_variable_token2] = ACTIONS(1055),
    [sym_braced_variable] = ACTIONS(1055),
    [sym_generic_token] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(1141),
    [anon_sym_RPAREN] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(1077),
    [anon_sym_LBRACE] = ACTIONS(1143),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(1077),
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DASHnot] = ACTIONS(1077),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_DASHbnot] = ACTIONS(1077),
    [anon_sym_PLUS_PLUS] = ACTIONS(1145),
    [anon_sym_DASH_DASH] = ACTIONS(1147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1149),
    [anon_sym_AT_LPAREN] = ACTIONS(1151),
    [anon_sym_AT_LBRACE] = ACTIONS(1153),
  },
  [224] = {
    [sym__literal] = STATE(1048),
    [sym_integer_literal] = STATE(1048),
    [sym_string_literal] = STATE(1048),
    [sym_expandable_string_literal] = STATE(1005),
    [sym_expandable_here_string_literal] = STATE(1005),
    [sym_variable] = STATE(1048),
    [sym_array_literal_expression] = STATE(1124),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(1048),
    [sym__value] = STATE(1048),
    [sym_parenthesized_expression] = STATE(1048),
    [sym_sub_expression] = STATE(1048),
    [sym_array_expression] = STATE(1048),
    [sym_script_block_expression] = STATE(1048),
    [sym_hash_literal_expression] = STATE(1048),
    [sym_post_increment_expression] = STATE(1048),
    [sym_post_decrement_expression] = STATE(1048),
    [sym_member_access] = STATE(1048),
    [sym_element_access] = STATE(1048),
    [sym_invokation_expression] = STATE(1048),
    [sym_invokation_foreach_expression] = STATE(1022),
    [sym_type_literal] = STATE(222),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1083),
    [sym_hexadecimal_integer_literal] = ACTIONS(1083),
    [sym_real_literal] = ACTIONS(1155),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1157),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1159),
    [sym_verbatim_string_characters] = ACTIONS(1161),
    [sym_verbatim_here_string_characters] = ACTIONS(1161),
    [anon_sym_LBRACK] = ACTIONS(1163),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_2_GT] = ACTIONS(937),
    [anon_sym_2_GT_GT] = ACTIONS(937),
    [anon_sym_3_GT] = ACTIONS(937),
    [anon_sym_3_GT_GT] = ACTIONS(937),
    [anon_sym_4_GT] = ACTIONS(937),
    [anon_sym_4_GT_GT] = ACTIONS(937),
    [anon_sym_5_GT] = ACTIONS(937),
    [anon_sym_5_GT_GT] = ACTIONS(937),
    [anon_sym_6_GT] = ACTIONS(937),
    [anon_sym_6_GT_GT] = ACTIONS(937),
    [anon_sym_STAR_GT] = ACTIONS(937),
    [anon_sym_STAR_GT_GT] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(937),
    [anon_sym_2_GT_AMP1] = ACTIONS(937),
    [anon_sym_3_GT_AMP1] = ACTIONS(937),
    [anon_sym_4_GT_AMP1] = ACTIONS(937),
    [anon_sym_5_GT_AMP1] = ACTIONS(937),
    [anon_sym_6_GT_AMP1] = ACTIONS(937),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(937),
    [anon_sym_1_GT_AMP2] = ACTIONS(937),
    [anon_sym_3_GT_AMP2] = ACTIONS(937),
    [anon_sym_4_GT_AMP2] = ACTIONS(937),
    [anon_sym_5_GT_AMP2] = ACTIONS(937),
    [anon_sym_6_GT_AMP2] = ACTIONS(937),
    [anon_sym_DASHjoin] = ACTIONS(1123),
    [anon_sym_DASHsplit] = ACTIONS(1123),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1101),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1101),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1101),
    [anon_sym_DOLLAR_] = ACTIONS(1101),
    [aux_sym_variable_token1] = ACTIONS(1101),
    [aux_sym_variable_token2] = ACTIONS(1101),
    [sym_braced_variable] = ACTIONS(1101),
    [sym_generic_token] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1169),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_DASHnot] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1123),
    [anon_sym_DASHbnot] = ACTIONS(1123),
    [anon_sym_PLUS_PLUS] = ACTIONS(1171),
    [anon_sym_DASH_DASH] = ACTIONS(1173),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1175),
    [anon_sym_AT_LPAREN] = ACTIONS(1177),
    [anon_sym_AT_LBRACE] = ACTIONS(1179),
    [sym__statement_terminator] = ACTIONS(1017),
  },
  [225] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_for_initializer] = STATE(2014),
    [sym_pipeline] = STATE(1781),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_LF] = ACTIONS(1181),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [226] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_for_condition] = STATE(2080),
    [sym_pipeline] = STATE(1884),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(1185),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_LF] = ACTIONS(1185),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [227] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_for_condition] = STATE(2059),
    [sym_pipeline] = STATE(1884),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1191),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_LF] = ACTIONS(1189),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [228] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_for_condition] = STATE(1717),
    [sym_pipeline] = STATE(1884),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(1193),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1195),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_LF] = ACTIONS(1193),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [229] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_for_condition] = STATE(2077),
    [sym_pipeline] = STATE(1884),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(1197),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1199),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_LF] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [230] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_for_condition] = STATE(2062),
    [sym_pipeline] = STATE(1884),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1203),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_LF] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [231] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_for_condition] = STATE(1868),
    [sym_pipeline] = STATE(1884),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(1205),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1207),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_LF] = ACTIONS(1205),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [232] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_for_condition] = STATE(2018),
    [sym_pipeline] = STATE(1884),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1211),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_LF] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [233] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_for_initializer] = STATE(2055),
    [sym_pipeline] = STATE(1781),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(1213),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1215),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_LF] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [234] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_for_initializer] = STATE(2073),
    [sym_pipeline] = STATE(1781),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(1217),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1219),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_LF] = ACTIONS(1217),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [235] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_for_condition] = STATE(2021),
    [sym_pipeline] = STATE(1884),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(1221),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_LF] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [236] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_for_initializer] = STATE(1782),
    [sym_pipeline] = STATE(1781),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1227),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_LF] = ACTIONS(1225),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [237] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_for_iterator] = STATE(1912),
    [sym_pipeline] = STATE(1906),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1229),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [238] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_for_iterator] = STATE(2064),
    [sym_pipeline] = STATE(1906),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [239] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_for_iterator] = STATE(2023),
    [sym_pipeline] = STATE(1906),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1233),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [240] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_for_iterator] = STATE(2079),
    [sym_pipeline] = STATE(1906),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1235),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [241] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_for_iterator] = STATE(2083),
    [sym_pipeline] = STATE(1906),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1237),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [242] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_for_iterator] = STATE(1848),
    [sym_pipeline] = STATE(1906),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1239),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [243] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_for_iterator] = STATE(2082),
    [sym_pipeline] = STATE(1906),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1241),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [244] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_for_iterator] = STATE(2061),
    [sym_pipeline] = STATE(1906),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1243),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [245] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_for_iterator] = STATE(1812),
    [sym_pipeline] = STATE(1906),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1245),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [246] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_for_iterator] = STATE(2065),
    [sym_pipeline] = STATE(1906),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1247),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [247] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_for_iterator] = STATE(2066),
    [sym_pipeline] = STATE(1906),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1249),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [248] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_for_iterator] = STATE(1805),
    [sym_pipeline] = STATE(1906),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1251),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [249] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_for_iterator] = STATE(2024),
    [sym_pipeline] = STATE(1906),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1253),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [250] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_for_iterator] = STATE(2084),
    [sym_pipeline] = STATE(1906),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1255),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [251] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_for_iterator] = STATE(2020),
    [sym_pipeline] = STATE(1906),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1257),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [252] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_for_iterator] = STATE(2025),
    [sym_pipeline] = STATE(1906),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1259),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
  },
  [253] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_while_condition] = STATE(1757),
    [sym_pipeline] = STATE(1775),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [254] = {
    [sym__literal] = STATE(156),
    [sym_integer_literal] = STATE(156),
    [sym_string_literal] = STATE(156),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(156),
    [sym_pipeline] = STATE(1945),
    [sym_left_assignment_expression] = STATE(1301),
    [sym_assignment_expression] = STATE(2022),
    [sym_command] = STATE(1336),
    [sym_command_invokation_operator] = STATE(718),
    [sym_command_name] = STATE(743),
    [sym_foreach_command] = STATE(1495),
    [sym__expression] = STATE(865),
    [sym_logical_expression] = STATE(978),
    [sym_bitwise_expression] = STATE(868),
    [sym_comparison_expression] = STATE(196),
    [sym_additive_expression] = STATE(191),
    [sym_multiplicative_expression] = STATE(186),
    [sym_format_expression] = STATE(181),
    [sym_range_expression] = STATE(180),
    [sym_array_literal_expression] = STATE(175),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(156),
    [sym__value] = STATE(156),
    [sym_parenthesized_expression] = STATE(156),
    [sym_sub_expression] = STATE(156),
    [sym_array_expression] = STATE(156),
    [sym_script_block_expression] = STATE(156),
    [sym_hash_literal_expression] = STATE(156),
    [sym_post_increment_expression] = STATE(156),
    [sym_post_decrement_expression] = STATE(156),
    [sym_member_access] = STATE(156),
    [sym_element_access] = STATE(156),
    [sym_invokation_expression] = STATE(156),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(5),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(5),
    [sym_real_literal] = ACTIONS(7),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(9),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(11),
    [sym_verbatim_string_characters] = ACTIONS(13),
    [sym_verbatim_here_string_characters] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(243),
    [anon_sym_DASHjoin] = ACTIONS(19),
    [anon_sym_DASHsplit] = ACTIONS(19),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(21),
    [anon_sym_DOLLAR_CARET] = ACTIONS(21),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(21),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(21),
    [sym_braced_variable] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(19),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(63),
    [anon_sym_PERCENT] = ACTIONS(65),
    [anon_sym_foreach_DASHobject] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_DASHnot] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASHbnot] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(71),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(75),
    [anon_sym_AT_LPAREN] = ACTIONS(77),
    [anon_sym_AT_LBRACE] = ACTIONS(79),
    [sym__statement_terminator] = ACTIONS(1289),
  },
  [255] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_while_condition] = STATE(1702),
    [sym_pipeline] = STATE(1775),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [256] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_while_condition] = STATE(1780),
    [sym_pipeline] = STATE(1775),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [257] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_while_condition] = STATE(1857),
    [sym_pipeline] = STATE(1775),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [258] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_while_condition] = STATE(1918),
    [sym_pipeline] = STATE(1775),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [259] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_while_condition] = STATE(1964),
    [sym_pipeline] = STATE(1775),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [260] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_while_condition] = STATE(1850),
    [sym_pipeline] = STATE(1775),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [261] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_while_condition] = STATE(1962),
    [sym_pipeline] = STATE(1775),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [262] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_pipeline] = STATE(1972),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [263] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_pipeline] = STATE(1718),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [264] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_pipeline] = STATE(1928),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [265] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_pipeline] = STATE(1933),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [266] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_pipeline] = STATE(1990),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [267] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_pipeline] = STATE(1924),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [268] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_pipeline] = STATE(1960),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [269] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_pipeline] = STATE(1743),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [270] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_pipeline] = STATE(1977),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [271] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_pipeline] = STATE(1735),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [272] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_pipeline] = STATE(1807),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [273] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_pipeline] = STATE(1787),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [274] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_pipeline] = STATE(1869),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [275] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_pipeline] = STATE(1865),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [276] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_pipeline] = STATE(1916),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [277] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_pipeline] = STATE(1827),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [278] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_pipeline] = STATE(1709),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [279] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_pipeline] = STATE(1793),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [280] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_pipeline] = STATE(1985),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [281] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_pipeline] = STATE(1874),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [282] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_pipeline] = STATE(1710),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [283] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_pipeline] = STATE(1855),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [284] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_pipeline] = STATE(1820),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [285] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_pipeline] = STATE(1765),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [286] = {
    [sym__literal] = STATE(155),
    [sym_integer_literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(155),
    [sym_pipeline] = STATE(1968),
    [sym_left_assignment_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1872),
    [sym_command] = STATE(1343),
    [sym_command_invokation_operator] = STATE(719),
    [sym_command_name] = STATE(740),
    [sym_foreach_command] = STATE(1445),
    [sym__expression] = STATE(896),
    [sym_logical_expression] = STATE(980),
    [sym_bitwise_expression] = STATE(901),
    [sym_comparison_expression] = STATE(203),
    [sym_additive_expression] = STATE(192),
    [sym_multiplicative_expression] = STATE(188),
    [sym_format_expression] = STATE(183),
    [sym_range_expression] = STATE(178),
    [sym_array_literal_expression] = STATE(166),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(155),
    [sym__value] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_sub_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_script_block_expression] = STATE(155),
    [sym_hash_literal_expression] = STATE(155),
    [sym_post_increment_expression] = STATE(155),
    [sym_post_decrement_expression] = STATE(155),
    [sym_member_access] = STATE(155),
    [sym_element_access] = STATE(155),
    [sym_invokation_expression] = STATE(155),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(3),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(119),
    [sym_real_literal] = ACTIONS(1261),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1263),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1265),
    [sym_verbatim_string_characters] = ACTIONS(1267),
    [sym_verbatim_here_string_characters] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_DASHjoin] = ACTIONS(143),
    [anon_sym_DASHsplit] = ACTIONS(143),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(137),
    [anon_sym_DOLLAR_CARET] = ACTIONS(137),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(137),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(137),
    [sym_braced_variable] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(15),
    [aux_sym_command_name_token1] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_foreach_DASHobject] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_DASHnot] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_DASHbnot] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1283),
    [anon_sym_AT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT_LBRACE] = ACTIONS(1287),
  },
  [287] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_DASHas] = ACTIONS(713),
    [anon_sym_DASHccontains] = ACTIONS(713),
    [anon_sym_DASHceq] = ACTIONS(713),
    [anon_sym_DASHcge] = ACTIONS(713),
    [anon_sym_DASHcgt] = ACTIONS(713),
    [anon_sym_DASHcle] = ACTIONS(713),
    [anon_sym_DASHclike] = ACTIONS(713),
    [anon_sym_DASHclt] = ACTIONS(713),
    [anon_sym_DASHcmatch] = ACTIONS(713),
    [anon_sym_DASHcne] = ACTIONS(713),
    [anon_sym_DASHcnotcontains] = ACTIONS(713),
    [anon_sym_DASHcnotlike] = ACTIONS(713),
    [anon_sym_DASHcnotmatch] = ACTIONS(713),
    [anon_sym_DASHcontains] = ACTIONS(713),
    [anon_sym_DASHcreplace] = ACTIONS(713),
    [anon_sym_DASHcsplit] = ACTIONS(713),
    [anon_sym_DASHeq] = ACTIONS(713),
    [anon_sym_DASHge] = ACTIONS(713),
    [anon_sym_DASHgt] = ACTIONS(713),
    [anon_sym_DASHicontains] = ACTIONS(713),
    [anon_sym_DASHieq] = ACTIONS(713),
    [anon_sym_DASHige] = ACTIONS(713),
    [anon_sym_DASHigt] = ACTIONS(713),
    [anon_sym_DASHile] = ACTIONS(713),
    [anon_sym_DASHilike] = ACTIONS(713),
    [anon_sym_DASHilt] = ACTIONS(713),
    [anon_sym_DASHimatch] = ACTIONS(713),
    [anon_sym_DASHin] = ACTIONS(715),
    [anon_sym_DASHine] = ACTIONS(713),
    [anon_sym_DASHinotcontains] = ACTIONS(713),
    [anon_sym_DASHinotlike] = ACTIONS(713),
    [anon_sym_DASHinotmatch] = ACTIONS(713),
    [anon_sym_DASHireplace] = ACTIONS(713),
    [anon_sym_DASHis] = ACTIONS(715),
    [anon_sym_DASHisnot] = ACTIONS(713),
    [anon_sym_DASHisplit] = ACTIONS(713),
    [anon_sym_DASHjoin] = ACTIONS(713),
    [anon_sym_DASHle] = ACTIONS(713),
    [anon_sym_DASHlike] = ACTIONS(713),
    [anon_sym_DASHlt] = ACTIONS(713),
    [anon_sym_DASHmatch] = ACTIONS(713),
    [anon_sym_DASHne] = ACTIONS(713),
    [anon_sym_DASHnotcontains] = ACTIONS(713),
    [anon_sym_DASHnotin] = ACTIONS(713),
    [anon_sym_DASHnotlike] = ACTIONS(713),
    [anon_sym_DASHnotmatch] = ACTIONS(713),
    [anon_sym_DASHreplace] = ACTIONS(713),
    [anon_sym_DASHshl] = ACTIONS(713),
    [anon_sym_DASHshr] = ACTIONS(713),
    [anon_sym_DASHsplit] = ACTIONS(713),
    [sym_format_operator] = ACTIONS(713),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(713),
    [anon_sym_PERCENT] = ACTIONS(713),
    [anon_sym_DASHand] = ACTIONS(713),
    [anon_sym_DASHor] = ACTIONS(713),
    [anon_sym_DASHxor] = ACTIONS(713),
    [anon_sym_DASHband] = ACTIONS(713),
    [anon_sym_DASHbor] = ACTIONS(713),
    [anon_sym_DASHbxor] = ACTIONS(713),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(713),
    [anon_sym_BSLASH] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_DOT_DOT] = ACTIONS(713),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DOT2] = ACTIONS(1291),
    [anon_sym_COLON_COLON] = ACTIONS(1293),
    [anon_sym_RBRACK] = ACTIONS(713),
    [anon_sym_DOTforeach] = ACTIONS(743),
  },
  [288] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_DASHas] = ACTIONS(713),
    [anon_sym_DASHccontains] = ACTIONS(713),
    [anon_sym_DASHceq] = ACTIONS(713),
    [anon_sym_DASHcge] = ACTIONS(713),
    [anon_sym_DASHcgt] = ACTIONS(713),
    [anon_sym_DASHcle] = ACTIONS(713),
    [anon_sym_DASHclike] = ACTIONS(713),
    [anon_sym_DASHclt] = ACTIONS(713),
    [anon_sym_DASHcmatch] = ACTIONS(713),
    [anon_sym_DASHcne] = ACTIONS(713),
    [anon_sym_DASHcnotcontains] = ACTIONS(713),
    [anon_sym_DASHcnotlike] = ACTIONS(713),
    [anon_sym_DASHcnotmatch] = ACTIONS(713),
    [anon_sym_DASHcontains] = ACTIONS(713),
    [anon_sym_DASHcreplace] = ACTIONS(713),
    [anon_sym_DASHcsplit] = ACTIONS(713),
    [anon_sym_DASHeq] = ACTIONS(713),
    [anon_sym_DASHge] = ACTIONS(713),
    [anon_sym_DASHgt] = ACTIONS(713),
    [anon_sym_DASHicontains] = ACTIONS(713),
    [anon_sym_DASHieq] = ACTIONS(713),
    [anon_sym_DASHige] = ACTIONS(713),
    [anon_sym_DASHigt] = ACTIONS(713),
    [anon_sym_DASHile] = ACTIONS(713),
    [anon_sym_DASHilike] = ACTIONS(713),
    [anon_sym_DASHilt] = ACTIONS(713),
    [anon_sym_DASHimatch] = ACTIONS(713),
    [anon_sym_DASHin] = ACTIONS(715),
    [anon_sym_DASHine] = ACTIONS(713),
    [anon_sym_DASHinotcontains] = ACTIONS(713),
    [anon_sym_DASHinotlike] = ACTIONS(713),
    [anon_sym_DASHinotmatch] = ACTIONS(713),
    [anon_sym_DASHireplace] = ACTIONS(713),
    [anon_sym_DASHis] = ACTIONS(715),
    [anon_sym_DASHisnot] = ACTIONS(713),
    [anon_sym_DASHisplit] = ACTIONS(713),
    [anon_sym_DASHjoin] = ACTIONS(713),
    [anon_sym_DASHle] = ACTIONS(713),
    [anon_sym_DASHlike] = ACTIONS(713),
    [anon_sym_DASHlt] = ACTIONS(713),
    [anon_sym_DASHmatch] = ACTIONS(713),
    [anon_sym_DASHne] = ACTIONS(713),
    [anon_sym_DASHnotcontains] = ACTIONS(713),
    [anon_sym_DASHnotin] = ACTIONS(713),
    [anon_sym_DASHnotlike] = ACTIONS(713),
    [anon_sym_DASHnotmatch] = ACTIONS(713),
    [anon_sym_DASHreplace] = ACTIONS(713),
    [anon_sym_DASHshl] = ACTIONS(713),
    [anon_sym_DASHshr] = ACTIONS(713),
    [anon_sym_DASHsplit] = ACTIONS(713),
    [sym_format_operator] = ACTIONS(713),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(713),
    [anon_sym_PERCENT] = ACTIONS(713),
    [anon_sym_DASHand] = ACTIONS(713),
    [anon_sym_DASHor] = ACTIONS(713),
    [anon_sym_DASHxor] = ACTIONS(713),
    [anon_sym_DASHband] = ACTIONS(713),
    [anon_sym_DASHbor] = ACTIONS(713),
    [anon_sym_DASHbxor] = ACTIONS(713),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(713),
    [anon_sym_BSLASH] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_DOT_DOT] = ACTIONS(713),
    [anon_sym_PLUS_PLUS] = ACTIONS(747),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_DOT2] = ACTIONS(1295),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_DOTforeach] = ACTIONS(755),
    [sym__statement_terminator] = ACTIONS(713),
  },
  [289] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_DASHas] = ACTIONS(713),
    [anon_sym_DASHccontains] = ACTIONS(713),
    [anon_sym_DASHceq] = ACTIONS(713),
    [anon_sym_DASHcge] = ACTIONS(713),
    [anon_sym_DASHcgt] = ACTIONS(713),
    [anon_sym_DASHcle] = ACTIONS(713),
    [anon_sym_DASHclike] = ACTIONS(713),
    [anon_sym_DASHclt] = ACTIONS(713),
    [anon_sym_DASHcmatch] = ACTIONS(713),
    [anon_sym_DASHcne] = ACTIONS(713),
    [anon_sym_DASHcnotcontains] = ACTIONS(713),
    [anon_sym_DASHcnotlike] = ACTIONS(713),
    [anon_sym_DASHcnotmatch] = ACTIONS(713),
    [anon_sym_DASHcontains] = ACTIONS(713),
    [anon_sym_DASHcreplace] = ACTIONS(713),
    [anon_sym_DASHcsplit] = ACTIONS(713),
    [anon_sym_DASHeq] = ACTIONS(713),
    [anon_sym_DASHge] = ACTIONS(713),
    [anon_sym_DASHgt] = ACTIONS(713),
    [anon_sym_DASHicontains] = ACTIONS(713),
    [anon_sym_DASHieq] = ACTIONS(713),
    [anon_sym_DASHige] = ACTIONS(713),
    [anon_sym_DASHigt] = ACTIONS(713),
    [anon_sym_DASHile] = ACTIONS(713),
    [anon_sym_DASHilike] = ACTIONS(713),
    [anon_sym_DASHilt] = ACTIONS(713),
    [anon_sym_DASHimatch] = ACTIONS(713),
    [anon_sym_DASHin] = ACTIONS(715),
    [anon_sym_DASHine] = ACTIONS(713),
    [anon_sym_DASHinotcontains] = ACTIONS(713),
    [anon_sym_DASHinotlike] = ACTIONS(713),
    [anon_sym_DASHinotmatch] = ACTIONS(713),
    [anon_sym_DASHireplace] = ACTIONS(713),
    [anon_sym_DASHis] = ACTIONS(715),
    [anon_sym_DASHisnot] = ACTIONS(713),
    [anon_sym_DASHisplit] = ACTIONS(713),
    [anon_sym_DASHjoin] = ACTIONS(713),
    [anon_sym_DASHle] = ACTIONS(713),
    [anon_sym_DASHlike] = ACTIONS(713),
    [anon_sym_DASHlt] = ACTIONS(713),
    [anon_sym_DASHmatch] = ACTIONS(713),
    [anon_sym_DASHne] = ACTIONS(713),
    [anon_sym_DASHnotcontains] = ACTIONS(713),
    [anon_sym_DASHnotin] = ACTIONS(713),
    [anon_sym_DASHnotlike] = ACTIONS(713),
    [anon_sym_DASHnotmatch] = ACTIONS(713),
    [anon_sym_DASHreplace] = ACTIONS(713),
    [anon_sym_DASHshl] = ACTIONS(713),
    [anon_sym_DASHshr] = ACTIONS(713),
    [anon_sym_DASHsplit] = ACTIONS(713),
    [sym_format_operator] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(713),
    [anon_sym_PERCENT] = ACTIONS(713),
    [anon_sym_DASHand] = ACTIONS(713),
    [anon_sym_DASHor] = ACTIONS(713),
    [anon_sym_DASHxor] = ACTIONS(713),
    [anon_sym_DASHband] = ACTIONS(713),
    [anon_sym_DASHbor] = ACTIONS(713),
    [anon_sym_DASHbxor] = ACTIONS(713),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(713),
    [anon_sym_BSLASH] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_DOT_DOT] = ACTIONS(713),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(737),
    [anon_sym_DOT2] = ACTIONS(1299),
    [anon_sym_COLON_COLON] = ACTIONS(1301),
    [anon_sym_RBRACK] = ACTIONS(713),
    [anon_sym_DOTforeach] = ACTIONS(743),
  },
  [290] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_DASHas] = ACTIONS(713),
    [anon_sym_DASHccontains] = ACTIONS(713),
    [anon_sym_DASHceq] = ACTIONS(713),
    [anon_sym_DASHcge] = ACTIONS(713),
    [anon_sym_DASHcgt] = ACTIONS(713),
    [anon_sym_DASHcle] = ACTIONS(713),
    [anon_sym_DASHclike] = ACTIONS(713),
    [anon_sym_DASHclt] = ACTIONS(713),
    [anon_sym_DASHcmatch] = ACTIONS(713),
    [anon_sym_DASHcne] = ACTIONS(713),
    [anon_sym_DASHcnotcontains] = ACTIONS(713),
    [anon_sym_DASHcnotlike] = ACTIONS(713),
    [anon_sym_DASHcnotmatch] = ACTIONS(713),
    [anon_sym_DASHcontains] = ACTIONS(713),
    [anon_sym_DASHcreplace] = ACTIONS(713),
    [anon_sym_DASHcsplit] = ACTIONS(713),
    [anon_sym_DASHeq] = ACTIONS(713),
    [anon_sym_DASHge] = ACTIONS(713),
    [anon_sym_DASHgt] = ACTIONS(713),
    [anon_sym_DASHicontains] = ACTIONS(713),
    [anon_sym_DASHieq] = ACTIONS(713),
    [anon_sym_DASHige] = ACTIONS(713),
    [anon_sym_DASHigt] = ACTIONS(713),
    [anon_sym_DASHile] = ACTIONS(713),
    [anon_sym_DASHilike] = ACTIONS(713),
    [anon_sym_DASHilt] = ACTIONS(713),
    [anon_sym_DASHimatch] = ACTIONS(713),
    [anon_sym_DASHin] = ACTIONS(715),
    [anon_sym_DASHine] = ACTIONS(713),
    [anon_sym_DASHinotcontains] = ACTIONS(713),
    [anon_sym_DASHinotlike] = ACTIONS(713),
    [anon_sym_DASHinotmatch] = ACTIONS(713),
    [anon_sym_DASHireplace] = ACTIONS(713),
    [anon_sym_DASHis] = ACTIONS(715),
    [anon_sym_DASHisnot] = ACTIONS(713),
    [anon_sym_DASHisplit] = ACTIONS(713),
    [anon_sym_DASHjoin] = ACTIONS(713),
    [anon_sym_DASHle] = ACTIONS(713),
    [anon_sym_DASHlike] = ACTIONS(713),
    [anon_sym_DASHlt] = ACTIONS(713),
    [anon_sym_DASHmatch] = ACTIONS(713),
    [anon_sym_DASHne] = ACTIONS(713),
    [anon_sym_DASHnotcontains] = ACTIONS(713),
    [anon_sym_DASHnotin] = ACTIONS(713),
    [anon_sym_DASHnotlike] = ACTIONS(713),
    [anon_sym_DASHnotmatch] = ACTIONS(713),
    [anon_sym_DASHreplace] = ACTIONS(713),
    [anon_sym_DASHshl] = ACTIONS(713),
    [anon_sym_DASHshr] = ACTIONS(713),
    [anon_sym_DASHsplit] = ACTIONS(713),
    [sym_format_operator] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(713),
    [anon_sym_PERCENT] = ACTIONS(713),
    [anon_sym_DASHand] = ACTIONS(713),
    [anon_sym_DASHor] = ACTIONS(713),
    [anon_sym_DASHxor] = ACTIONS(713),
    [anon_sym_DASHband] = ACTIONS(713),
    [anon_sym_DASHbor] = ACTIONS(713),
    [anon_sym_DASHbxor] = ACTIONS(713),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(713),
    [anon_sym_BSLASH] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_DOT_DOT] = ACTIONS(713),
    [anon_sym_PLUS_PLUS] = ACTIONS(747),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_DOT2] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1305),
    [anon_sym_DOTforeach] = ACTIONS(755),
    [sym__statement_terminator] = ACTIONS(713),
  },
  [291] = {
    [sym__literal] = STATE(289),
    [sym_integer_literal] = STATE(289),
    [sym_string_literal] = STATE(289),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(289),
    [sym__expression] = STATE(1615),
    [sym_logical_expression] = STATE(1360),
    [sym_bitwise_expression] = STATE(1286),
    [sym_comparison_expression] = STATE(540),
    [sym_additive_expression] = STATE(535),
    [sym_multiplicative_expression] = STATE(365),
    [sym_format_expression] = STATE(316),
    [sym_range_expression] = STATE(301),
    [sym_array_literal_expression] = STATE(304),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(289),
    [sym__value] = STATE(289),
    [sym_parenthesized_expression] = STATE(289),
    [sym_sub_expression] = STATE(289),
    [sym_array_expression] = STATE(289),
    [sym_script_block_expression] = STATE(289),
    [sym_hash_literal_expression] = STATE(289),
    [sym_post_increment_expression] = STATE(289),
    [sym_post_decrement_expression] = STATE(289),
    [sym_member_access] = STATE(289),
    [sym_element_access] = STATE(289),
    [sym_invokation_expression] = STATE(289),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(76),
    [sym_attribute_arguments] = STATE(1860),
    [sym_attribute_argument] = STATE(1458),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(121),
    [sym_real_literal] = ACTIONS(479),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(125),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(127),
    [sym_verbatim_string_characters] = ACTIONS(129),
    [sym_verbatim_here_string_characters] = ACTIONS(129),
    [sym_simple_name] = ACTIONS(1307),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_DASHjoin] = ACTIONS(483),
    [anon_sym_DASHsplit] = ACTIONS(483),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(135),
    [anon_sym_DOLLAR_CARET] = ACTIONS(135),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(135),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(135),
    [sym_braced_variable] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(1309),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(485),
    [anon_sym_DASHnot] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_DASHbnot] = ACTIONS(483),
    [anon_sym_PLUS_PLUS] = ACTIONS(487),
    [anon_sym_DASH_DASH] = ACTIONS(489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_AT_LBRACE] = ACTIONS(153),
  },
  [292] = {
    [sym__literal] = STATE(289),
    [sym_integer_literal] = STATE(289),
    [sym_string_literal] = STATE(289),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(289),
    [sym__expression] = STATE(1615),
    [sym_logical_expression] = STATE(1360),
    [sym_bitwise_expression] = STATE(1286),
    [sym_comparison_expression] = STATE(540),
    [sym_additive_expression] = STATE(535),
    [sym_multiplicative_expression] = STATE(365),
    [sym_format_expression] = STATE(316),
    [sym_range_expression] = STATE(301),
    [sym_array_literal_expression] = STATE(304),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(289),
    [sym__value] = STATE(289),
    [sym_parenthesized_expression] = STATE(289),
    [sym_sub_expression] = STATE(289),
    [sym_array_expression] = STATE(289),
    [sym_script_block_expression] = STATE(289),
    [sym_hash_literal_expression] = STATE(289),
    [sym_post_increment_expression] = STATE(289),
    [sym_post_decrement_expression] = STATE(289),
    [sym_member_access] = STATE(289),
    [sym_element_access] = STATE(289),
    [sym_invokation_expression] = STATE(289),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(76),
    [sym_attribute_arguments] = STATE(1822),
    [sym_attribute_argument] = STATE(1458),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(121),
    [sym_real_literal] = ACTIONS(479),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(125),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(127),
    [sym_verbatim_string_characters] = ACTIONS(129),
    [sym_verbatim_here_string_characters] = ACTIONS(129),
    [sym_simple_name] = ACTIONS(1307),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_DASHjoin] = ACTIONS(483),
    [anon_sym_DASHsplit] = ACTIONS(483),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(135),
    [anon_sym_DOLLAR_CARET] = ACTIONS(135),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(135),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(135),
    [sym_braced_variable] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(1311),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(485),
    [anon_sym_DASHnot] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_DASHbnot] = ACTIONS(483),
    [anon_sym_PLUS_PLUS] = ACTIONS(487),
    [anon_sym_DASH_DASH] = ACTIONS(489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_AT_LBRACE] = ACTIONS(153),
  },
  [293] = {
    [sym_catch_clauses] = STATE(384),
    [sym_catch_clause] = STATE(324),
    [sym_finally_clause] = STATE(437),
    [aux_sym_catch_clauses_repeat1] = STATE(324),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1313),
    [sym_hexadecimal_integer_literal] = ACTIONS(1313),
    [sym_real_literal] = ACTIONS(1313),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1313),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1313),
    [sym_verbatim_string_characters] = ACTIONS(1313),
    [sym_verbatim_here_string_characters] = ACTIONS(1313),
    [anon_sym_DOT] = ACTIONS(1313),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_DASHjoin] = ACTIONS(1313),
    [anon_sym_DASHsplit] = ACTIONS(1313),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1313),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1313),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1313),
    [anon_sym_DOLLAR_] = ACTIONS(1313),
    [aux_sym_variable_token1] = ACTIONS(1313),
    [aux_sym_variable_token2] = ACTIONS(1313),
    [sym_braced_variable] = ACTIONS(1313),
    [anon_sym_SEMI] = ACTIONS(1313),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_RPAREN] = ACTIONS(1313),
    [anon_sym_COMMA] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(1313),
    [anon_sym_RBRACE] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_switch] = ACTIONS(1313),
    [anon_sym_foreach] = ACTIONS(1313),
    [anon_sym_for] = ACTIONS(1313),
    [anon_sym_while] = ACTIONS(1313),
    [anon_sym_do] = ACTIONS(1313),
    [anon_sym_function] = ACTIONS(1313),
    [anon_sym_filter] = ACTIONS(1313),
    [anon_sym_workflow] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1313),
    [anon_sym_continue] = ACTIONS(1313),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_return] = ACTIONS(1313),
    [anon_sym_exit] = ACTIONS(1313),
    [sym_label] = ACTIONS(1313),
    [anon_sym_trap] = ACTIONS(1313),
    [anon_sym_try] = ACTIONS(1313),
    [anon_sym_catch] = ACTIONS(1315),
    [anon_sym_finally] = ACTIONS(1317),
    [anon_sym_data] = ACTIONS(1313),
    [anon_sym_inlinescript] = ACTIONS(1313),
    [anon_sym_parallel] = ACTIONS(1313),
    [anon_sym_sequence] = ACTIONS(1313),
    [anon_sym_AMP] = ACTIONS(1313),
    [aux_sym_command_name_token1] = ACTIONS(1313),
    [anon_sym_PERCENT] = ACTIONS(1313),
    [anon_sym_foreach_DASHobject] = ACTIONS(1313),
    [anon_sym_class] = ACTIONS(1313),
    [anon_sym_enum] = ACTIONS(1313),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_DASH] = ACTIONS(1313),
    [anon_sym_DASHnot] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(1313),
    [anon_sym_DASHbnot] = ACTIONS(1313),
    [anon_sym_PLUS_PLUS] = ACTIONS(1313),
    [anon_sym_DASH_DASH] = ACTIONS(1313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1313),
    [anon_sym_AT_LPAREN] = ACTIONS(1313),
    [anon_sym_AT_LBRACE] = ACTIONS(1313),
  },
  [294] = {
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(251),
    [sym_hexadecimal_integer_literal] = ACTIONS(251),
    [sym_real_literal] = ACTIONS(251),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(251),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(251),
    [sym_verbatim_string_characters] = ACTIONS(251),
    [sym_verbatim_here_string_characters] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(251),
    [anon_sym_GT] = ACTIONS(251),
    [anon_sym_GT_GT] = ACTIONS(251),
    [anon_sym_2_GT] = ACTIONS(251),
    [anon_sym_2_GT_GT] = ACTIONS(251),
    [anon_sym_3_GT] = ACTIONS(251),
    [anon_sym_3_GT_GT] = ACTIONS(251),
    [anon_sym_4_GT] = ACTIONS(251),
    [anon_sym_4_GT_GT] = ACTIONS(251),
    [anon_sym_5_GT] = ACTIONS(251),
    [anon_sym_5_GT_GT] = ACTIONS(251),
    [anon_sym_6_GT] = ACTIONS(251),
    [anon_sym_6_GT_GT] = ACTIONS(251),
    [anon_sym_STAR_GT] = ACTIONS(251),
    [anon_sym_STAR_GT_GT] = ACTIONS(251),
    [anon_sym_LT] = ACTIONS(251),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(251),
    [anon_sym_2_GT_AMP1] = ACTIONS(251),
    [anon_sym_3_GT_AMP1] = ACTIONS(251),
    [anon_sym_4_GT_AMP1] = ACTIONS(251),
    [anon_sym_5_GT_AMP1] = ACTIONS(251),
    [anon_sym_6_GT_AMP1] = ACTIONS(251),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(251),
    [anon_sym_1_GT_AMP2] = ACTIONS(251),
    [anon_sym_3_GT_AMP2] = ACTIONS(251),
    [anon_sym_4_GT_AMP2] = ACTIONS(251),
    [anon_sym_5_GT_AMP2] = ACTIONS(251),
    [anon_sym_6_GT_AMP2] = ACTIONS(251),
    [anon_sym_DASHjoin] = ACTIONS(251),
    [anon_sym_DASHsplit] = ACTIONS(251),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(251),
    [anon_sym_DOLLAR_CARET] = ACTIONS(251),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(251),
    [anon_sym_DOLLAR_] = ACTIONS(251),
    [aux_sym_variable_token1] = ACTIONS(251),
    [aux_sym_variable_token2] = ACTIONS(251),
    [sym_braced_variable] = ACTIONS(251),
    [sym_command_parameter] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(251),
    [anon_sym_COMMA] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(251),
    [anon_sym_PIPE] = ACTIONS(251),
    [sym_stop_parsing] = ACTIONS(251),
    [anon_sym_SPACE] = ACTIONS(253),
    [anon_sym_COLON] = ACTIONS(251),
    [anon_sym_DASH_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_DASHnot] = ACTIONS(251),
    [anon_sym_BANG] = ACTIONS(251),
    [anon_sym_DASHbnot] = ACTIONS(251),
    [anon_sym_PLUS_PLUS] = ACTIONS(251),
    [anon_sym_DASH_DASH] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(251),
    [anon_sym_AT_LPAREN] = ACTIONS(251),
    [anon_sym_AT_LBRACE] = ACTIONS(251),
    [anon_sym_DOT2] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(251),
    [anon_sym_DOTforeach] = ACTIONS(253),
    [sym__statement_terminator] = ACTIONS(253),
  },
  [295] = {
    [sym_elseif_clauses] = STATE(381),
    [sym_elseif_clause] = STATE(327),
    [sym_else_clause] = STATE(456),
    [aux_sym_elseif_clauses_repeat1] = STATE(327),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1319),
    [sym_hexadecimal_integer_literal] = ACTIONS(1319),
    [sym_real_literal] = ACTIONS(1319),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1319),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1319),
    [sym_verbatim_string_characters] = ACTIONS(1319),
    [sym_verbatim_here_string_characters] = ACTIONS(1319),
    [anon_sym_DOT] = ACTIONS(1319),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_DASHjoin] = ACTIONS(1319),
    [anon_sym_DASHsplit] = ACTIONS(1319),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1319),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1319),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1319),
    [anon_sym_DOLLAR_] = ACTIONS(1319),
    [aux_sym_variable_token1] = ACTIONS(1319),
    [aux_sym_variable_token2] = ACTIONS(1319),
    [sym_braced_variable] = ACTIONS(1319),
    [anon_sym_SEMI] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1319),
    [anon_sym_RPAREN] = ACTIONS(1319),
    [anon_sym_COMMA] = ACTIONS(1319),
    [anon_sym_LBRACE] = ACTIONS(1319),
    [anon_sym_RBRACE] = ACTIONS(1319),
    [anon_sym_if] = ACTIONS(1319),
    [anon_sym_elseif] = ACTIONS(1321),
    [anon_sym_else] = ACTIONS(1323),
    [anon_sym_switch] = ACTIONS(1319),
    [anon_sym_foreach] = ACTIONS(1319),
    [anon_sym_for] = ACTIONS(1319),
    [anon_sym_while] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(1319),
    [anon_sym_filter] = ACTIONS(1319),
    [anon_sym_workflow] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1319),
    [anon_sym_continue] = ACTIONS(1319),
    [anon_sym_throw] = ACTIONS(1319),
    [anon_sym_return] = ACTIONS(1319),
    [anon_sym_exit] = ACTIONS(1319),
    [sym_label] = ACTIONS(1319),
    [anon_sym_trap] = ACTIONS(1319),
    [anon_sym_try] = ACTIONS(1319),
    [anon_sym_data] = ACTIONS(1319),
    [anon_sym_inlinescript] = ACTIONS(1319),
    [anon_sym_parallel] = ACTIONS(1319),
    [anon_sym_sequence] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [aux_sym_command_name_token1] = ACTIONS(1319),
    [anon_sym_PERCENT] = ACTIONS(1319),
    [anon_sym_foreach_DASHobject] = ACTIONS(1319),
    [anon_sym_class] = ACTIONS(1319),
    [anon_sym_enum] = ACTIONS(1319),
    [anon_sym_PLUS] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_DASHnot] = ACTIONS(1319),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_DASHbnot] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1319),
    [anon_sym_AT_LPAREN] = ACTIONS(1319),
    [anon_sym_AT_LBRACE] = ACTIONS(1319),
  },
  [296] = {
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(251),
    [sym_hexadecimal_integer_literal] = ACTIONS(251),
    [sym_real_literal] = ACTIONS(251),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(251),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(251),
    [sym_verbatim_string_characters] = ACTIONS(251),
    [sym_verbatim_here_string_characters] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(251),
    [anon_sym_GT] = ACTIONS(251),
    [anon_sym_GT_GT] = ACTIONS(251),
    [anon_sym_2_GT] = ACTIONS(251),
    [anon_sym_2_GT_GT] = ACTIONS(251),
    [anon_sym_3_GT] = ACTIONS(251),
    [anon_sym_3_GT_GT] = ACTIONS(251),
    [anon_sym_4_GT] = ACTIONS(251),
    [anon_sym_4_GT_GT] = ACTIONS(251),
    [anon_sym_5_GT] = ACTIONS(251),
    [anon_sym_5_GT_GT] = ACTIONS(251),
    [anon_sym_6_GT] = ACTIONS(251),
    [anon_sym_6_GT_GT] = ACTIONS(251),
    [anon_sym_STAR_GT] = ACTIONS(251),
    [anon_sym_STAR_GT_GT] = ACTIONS(251),
    [anon_sym_LT] = ACTIONS(251),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(251),
    [anon_sym_2_GT_AMP1] = ACTIONS(251),
    [anon_sym_3_GT_AMP1] = ACTIONS(251),
    [anon_sym_4_GT_AMP1] = ACTIONS(251),
    [anon_sym_5_GT_AMP1] = ACTIONS(251),
    [anon_sym_6_GT_AMP1] = ACTIONS(251),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(251),
    [anon_sym_1_GT_AMP2] = ACTIONS(251),
    [anon_sym_3_GT_AMP2] = ACTIONS(251),
    [anon_sym_4_GT_AMP2] = ACTIONS(251),
    [anon_sym_5_GT_AMP2] = ACTIONS(251),
    [anon_sym_6_GT_AMP2] = ACTIONS(251),
    [anon_sym_DASHjoin] = ACTIONS(251),
    [anon_sym_DASHsplit] = ACTIONS(251),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(251),
    [anon_sym_DOLLAR_CARET] = ACTIONS(251),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(251),
    [anon_sym_DOLLAR_] = ACTIONS(251),
    [aux_sym_variable_token1] = ACTIONS(251),
    [aux_sym_variable_token2] = ACTIONS(251),
    [sym_braced_variable] = ACTIONS(251),
    [sym_command_parameter] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(251),
    [anon_sym_RPAREN] = ACTIONS(251),
    [anon_sym_COMMA] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(251),
    [anon_sym_PIPE] = ACTIONS(251),
    [sym_stop_parsing] = ACTIONS(251),
    [anon_sym_SPACE] = ACTIONS(253),
    [anon_sym_COLON] = ACTIONS(251),
    [anon_sym_DASH_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_DASHnot] = ACTIONS(251),
    [anon_sym_BANG] = ACTIONS(251),
    [anon_sym_DASHbnot] = ACTIONS(251),
    [anon_sym_PLUS_PLUS] = ACTIONS(251),
    [anon_sym_DASH_DASH] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(251),
    [anon_sym_AT_LPAREN] = ACTIONS(251),
    [anon_sym_AT_LBRACE] = ACTIONS(251),
    [anon_sym_DOT2] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(251),
    [anon_sym_DOTforeach] = ACTIONS(253),
  },
  [297] = {
    [sym__literal] = STATE(289),
    [sym_integer_literal] = STATE(289),
    [sym_string_literal] = STATE(289),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(289),
    [sym__expression] = STATE(1615),
    [sym_logical_expression] = STATE(1360),
    [sym_bitwise_expression] = STATE(1286),
    [sym_comparison_expression] = STATE(540),
    [sym_additive_expression] = STATE(535),
    [sym_multiplicative_expression] = STATE(365),
    [sym_format_expression] = STATE(316),
    [sym_range_expression] = STATE(301),
    [sym_array_literal_expression] = STATE(304),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(289),
    [sym__value] = STATE(289),
    [sym_parenthesized_expression] = STATE(289),
    [sym_sub_expression] = STATE(289),
    [sym_array_expression] = STATE(289),
    [sym_script_block_expression] = STATE(289),
    [sym_hash_literal_expression] = STATE(289),
    [sym_post_increment_expression] = STATE(289),
    [sym_post_decrement_expression] = STATE(289),
    [sym_member_access] = STATE(289),
    [sym_element_access] = STATE(289),
    [sym_invokation_expression] = STATE(289),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(76),
    [sym_attribute_argument] = STATE(1693),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(121),
    [sym_real_literal] = ACTIONS(479),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(125),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(127),
    [sym_verbatim_string_characters] = ACTIONS(129),
    [sym_verbatim_here_string_characters] = ACTIONS(129),
    [sym_simple_name] = ACTIONS(1307),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_DASHjoin] = ACTIONS(483),
    [anon_sym_DASHsplit] = ACTIONS(483),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(135),
    [anon_sym_DOLLAR_CARET] = ACTIONS(135),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(135),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(135),
    [sym_braced_variable] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(485),
    [anon_sym_DASHnot] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_DASHbnot] = ACTIONS(483),
    [anon_sym_PLUS_PLUS] = ACTIONS(487),
    [anon_sym_DASH_DASH] = ACTIONS(489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_AT_LBRACE] = ACTIONS(153),
  },
  [298] = {
    [aux_sym_command_argument_sep_repeat1] = STATE(298),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1325),
    [sym_hexadecimal_integer_literal] = ACTIONS(1325),
    [sym_real_literal] = ACTIONS(1325),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1325),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1325),
    [sym_verbatim_string_characters] = ACTIONS(1325),
    [sym_verbatim_here_string_characters] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(1325),
    [anon_sym_GT] = ACTIONS(1325),
    [anon_sym_GT_GT] = ACTIONS(1325),
    [anon_sym_2_GT] = ACTIONS(1325),
    [anon_sym_2_GT_GT] = ACTIONS(1325),
    [anon_sym_3_GT] = ACTIONS(1325),
    [anon_sym_3_GT_GT] = ACTIONS(1325),
    [anon_sym_4_GT] = ACTIONS(1325),
    [anon_sym_4_GT_GT] = ACTIONS(1325),
    [anon_sym_5_GT] = ACTIONS(1325),
    [anon_sym_5_GT_GT] = ACTIONS(1325),
    [anon_sym_6_GT] = ACTIONS(1325),
    [anon_sym_6_GT_GT] = ACTIONS(1325),
    [anon_sym_STAR_GT] = ACTIONS(1325),
    [anon_sym_STAR_GT_GT] = ACTIONS(1325),
    [anon_sym_LT] = ACTIONS(1325),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(1325),
    [anon_sym_2_GT_AMP1] = ACTIONS(1325),
    [anon_sym_3_GT_AMP1] = ACTIONS(1325),
    [anon_sym_4_GT_AMP1] = ACTIONS(1325),
    [anon_sym_5_GT_AMP1] = ACTIONS(1325),
    [anon_sym_6_GT_AMP1] = ACTIONS(1325),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(1325),
    [anon_sym_1_GT_AMP2] = ACTIONS(1325),
    [anon_sym_3_GT_AMP2] = ACTIONS(1325),
    [anon_sym_4_GT_AMP2] = ACTIONS(1325),
    [anon_sym_5_GT_AMP2] = ACTIONS(1325),
    [anon_sym_6_GT_AMP2] = ACTIONS(1325),
    [anon_sym_DASHjoin] = ACTIONS(1325),
    [anon_sym_DASHsplit] = ACTIONS(1325),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1325),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1325),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1325),
    [anon_sym_DOLLAR_] = ACTIONS(1325),
    [aux_sym_variable_token1] = ACTIONS(1325),
    [aux_sym_variable_token2] = ACTIONS(1325),
    [sym_braced_variable] = ACTIONS(1325),
    [sym_generic_token] = ACTIONS(1325),
    [sym_command_parameter] = ACTIONS(1325),
    [anon_sym_LPAREN] = ACTIONS(1325),
    [anon_sym_RPAREN] = ACTIONS(1325),
    [anon_sym_COMMA] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_PIPE] = ACTIONS(1325),
    [sym_stop_parsing] = ACTIONS(1325),
    [anon_sym_SPACE] = ACTIONS(1327),
    [anon_sym_COLON] = ACTIONS(1325),
    [anon_sym_DASH_DASH_PERCENT] = ACTIONS(1325),
    [anon_sym_PLUS] = ACTIONS(1325),
    [anon_sym_DASH] = ACTIONS(1325),
    [anon_sym_DASHnot] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1325),
    [anon_sym_DASHbnot] = ACTIONS(1325),
    [anon_sym_PLUS_PLUS] = ACTIONS(1325),
    [anon_sym_DASH_DASH] = ACTIONS(1325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1325),
    [anon_sym_AT_LPAREN] = ACTIONS(1325),
    [anon_sym_AT_LBRACE] = ACTIONS(1325),
  },
  [299] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_DASHas] = ACTIONS(773),
    [anon_sym_DASHccontains] = ACTIONS(773),
    [anon_sym_DASHceq] = ACTIONS(773),
    [anon_sym_DASHcge] = ACTIONS(773),
    [anon_sym_DASHcgt] = ACTIONS(773),
    [anon_sym_DASHcle] = ACTIONS(773),
    [anon_sym_DASHclike] = ACTIONS(773),
    [anon_sym_DASHclt] = ACTIONS(773),
    [anon_sym_DASHcmatch] = ACTIONS(773),
    [anon_sym_DASHcne] = ACTIONS(773),
    [anon_sym_DASHcnotcontains] = ACTIONS(773),
    [anon_sym_DASHcnotlike] = ACTIONS(773),
    [anon_sym_DASHcnotmatch] = ACTIONS(773),
    [anon_sym_DASHcontains] = ACTIONS(773),
    [anon_sym_DASHcreplace] = ACTIONS(773),
    [anon_sym_DASHcsplit] = ACTIONS(773),
    [anon_sym_DASHeq] = ACTIONS(773),
    [anon_sym_DASHge] = ACTIONS(773),
    [anon_sym_DASHgt] = ACTIONS(773),
    [anon_sym_DASHicontains] = ACTIONS(773),
    [anon_sym_DASHieq] = ACTIONS(773),
    [anon_sym_DASHige] = ACTIONS(773),
    [anon_sym_DASHigt] = ACTIONS(773),
    [anon_sym_DASHile] = ACTIONS(773),
    [anon_sym_DASHilike] = ACTIONS(773),
    [anon_sym_DASHilt] = ACTIONS(773),
    [anon_sym_DASHimatch] = ACTIONS(773),
    [anon_sym_DASHin] = ACTIONS(775),
    [anon_sym_DASHine] = ACTIONS(773),
    [anon_sym_DASHinotcontains] = ACTIONS(773),
    [anon_sym_DASHinotlike] = ACTIONS(773),
    [anon_sym_DASHinotmatch] = ACTIONS(773),
    [anon_sym_DASHireplace] = ACTIONS(773),
    [anon_sym_DASHis] = ACTIONS(775),
    [anon_sym_DASHisnot] = ACTIONS(773),
    [anon_sym_DASHisplit] = ACTIONS(773),
    [anon_sym_DASHjoin] = ACTIONS(773),
    [anon_sym_DASHle] = ACTIONS(773),
    [anon_sym_DASHlike] = ACTIONS(773),
    [anon_sym_DASHlt] = ACTIONS(773),
    [anon_sym_DASHmatch] = ACTIONS(773),
    [anon_sym_DASHne] = ACTIONS(773),
    [anon_sym_DASHnotcontains] = ACTIONS(773),
    [anon_sym_DASHnotin] = ACTIONS(773),
    [anon_sym_DASHnotlike] = ACTIONS(773),
    [anon_sym_DASHnotmatch] = ACTIONS(773),
    [anon_sym_DASHreplace] = ACTIONS(773),
    [anon_sym_DASHshl] = ACTIONS(773),
    [anon_sym_DASHshr] = ACTIONS(773),
    [anon_sym_DASHsplit] = ACTIONS(773),
    [sym_format_operator] = ACTIONS(773),
    [anon_sym_COMMA] = ACTIONS(1330),
    [anon_sym_PERCENT] = ACTIONS(773),
    [anon_sym_DASHand] = ACTIONS(773),
    [anon_sym_DASHor] = ACTIONS(773),
    [anon_sym_DASHxor] = ACTIONS(773),
    [anon_sym_DASHband] = ACTIONS(773),
    [anon_sym_DASHbor] = ACTIONS(773),
    [anon_sym_DASHbxor] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(773),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_STAR] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(773),
    [anon_sym_RBRACK] = ACTIONS(773),
  },
  [300] = {
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(251),
    [sym_hexadecimal_integer_literal] = ACTIONS(251),
    [sym_real_literal] = ACTIONS(251),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(251),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(251),
    [sym_verbatim_string_characters] = ACTIONS(251),
    [sym_verbatim_here_string_characters] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(251),
    [anon_sym_GT] = ACTIONS(251),
    [anon_sym_GT_GT] = ACTIONS(251),
    [anon_sym_2_GT] = ACTIONS(251),
    [anon_sym_2_GT_GT] = ACTIONS(251),
    [anon_sym_3_GT] = ACTIONS(251),
    [anon_sym_3_GT_GT] = ACTIONS(251),
    [anon_sym_4_GT] = ACTIONS(251),
    [anon_sym_4_GT_GT] = ACTIONS(251),
    [anon_sym_5_GT] = ACTIONS(251),
    [anon_sym_5_GT_GT] = ACTIONS(251),
    [anon_sym_6_GT] = ACTIONS(251),
    [anon_sym_6_GT_GT] = ACTIONS(251),
    [anon_sym_STAR_GT] = ACTIONS(251),
    [anon_sym_STAR_GT_GT] = ACTIONS(251),
    [anon_sym_LT] = ACTIONS(251),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(251),
    [anon_sym_2_GT_AMP1] = ACTIONS(251),
    [anon_sym_3_GT_AMP1] = ACTIONS(251),
    [anon_sym_4_GT_AMP1] = ACTIONS(251),
    [anon_sym_5_GT_AMP1] = ACTIONS(251),
    [anon_sym_6_GT_AMP1] = ACTIONS(251),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(251),
    [anon_sym_1_GT_AMP2] = ACTIONS(251),
    [anon_sym_3_GT_AMP2] = ACTIONS(251),
    [anon_sym_4_GT_AMP2] = ACTIONS(251),
    [anon_sym_5_GT_AMP2] = ACTIONS(251),
    [anon_sym_6_GT_AMP2] = ACTIONS(251),
    [anon_sym_DASHjoin] = ACTIONS(251),
    [anon_sym_DASHsplit] = ACTIONS(251),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(251),
    [anon_sym_DOLLAR_CARET] = ACTIONS(251),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(251),
    [anon_sym_DOLLAR_] = ACTIONS(251),
    [aux_sym_variable_token1] = ACTIONS(251),
    [aux_sym_variable_token2] = ACTIONS(251),
    [sym_braced_variable] = ACTIONS(251),
    [sym_command_parameter] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(251),
    [anon_sym_COMMA] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(251),
    [anon_sym_PIPE] = ACTIONS(251),
    [sym_stop_parsing] = ACTIONS(251),
    [anon_sym_SPACE] = ACTIONS(253),
    [anon_sym_COLON] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_DASHnot] = ACTIONS(251),
    [anon_sym_BANG] = ACTIONS(251),
    [anon_sym_DASHbnot] = ACTIONS(251),
    [anon_sym_PLUS_PLUS] = ACTIONS(251),
    [anon_sym_DASH_DASH] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(251),
    [anon_sym_AT_LPAREN] = ACTIONS(251),
    [anon_sym_AT_LBRACE] = ACTIONS(251),
    [anon_sym_DOT2] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(251),
    [anon_sym_DOTforeach] = ACTIONS(253),
    [sym__statement_terminator] = ACTIONS(253),
  },
  [301] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_DASHas] = ACTIONS(791),
    [anon_sym_DASHccontains] = ACTIONS(791),
    [anon_sym_DASHceq] = ACTIONS(791),
    [anon_sym_DASHcge] = ACTIONS(791),
    [anon_sym_DASHcgt] = ACTIONS(791),
    [anon_sym_DASHcle] = ACTIONS(791),
    [anon_sym_DASHclike] = ACTIONS(791),
    [anon_sym_DASHclt] = ACTIONS(791),
    [anon_sym_DASHcmatch] = ACTIONS(791),
    [anon_sym_DASHcne] = ACTIONS(791),
    [anon_sym_DASHcnotcontains] = ACTIONS(791),
    [anon_sym_DASHcnotlike] = ACTIONS(791),
    [anon_sym_DASHcnotmatch] = ACTIONS(791),
    [anon_sym_DASHcontains] = ACTIONS(791),
    [anon_sym_DASHcreplace] = ACTIONS(791),
    [anon_sym_DASHcsplit] = ACTIONS(791),
    [anon_sym_DASHeq] = ACTIONS(791),
    [anon_sym_DASHge] = ACTIONS(791),
    [anon_sym_DASHgt] = ACTIONS(791),
    [anon_sym_DASHicontains] = ACTIONS(791),
    [anon_sym_DASHieq] = ACTIONS(791),
    [anon_sym_DASHige] = ACTIONS(791),
    [anon_sym_DASHigt] = ACTIONS(791),
    [anon_sym_DASHile] = ACTIONS(791),
    [anon_sym_DASHilike] = ACTIONS(791),
    [anon_sym_DASHilt] = ACTIONS(791),
    [anon_sym_DASHimatch] = ACTIONS(791),
    [anon_sym_DASHin] = ACTIONS(793),
    [anon_sym_DASHine] = ACTIONS(791),
    [anon_sym_DASHinotcontains] = ACTIONS(791),
    [anon_sym_DASHinotlike] = ACTIONS(791),
    [anon_sym_DASHinotmatch] = ACTIONS(791),
    [anon_sym_DASHireplace] = ACTIONS(791),
    [anon_sym_DASHis] = ACTIONS(793),
    [anon_sym_DASHisnot] = ACTIONS(791),
    [anon_sym_DASHisplit] = ACTIONS(791),
    [anon_sym_DASHjoin] = ACTIONS(791),
    [anon_sym_DASHle] = ACTIONS(791),
    [anon_sym_DASHlike] = ACTIONS(791),
    [anon_sym_DASHlt] = ACTIONS(791),
    [anon_sym_DASHmatch] = ACTIONS(791),
    [anon_sym_DASHne] = ACTIONS(791),
    [anon_sym_DASHnotcontains] = ACTIONS(791),
    [anon_sym_DASHnotin] = ACTIONS(791),
    [anon_sym_DASHnotlike] = ACTIONS(791),
    [anon_sym_DASHnotmatch] = ACTIONS(791),
    [anon_sym_DASHreplace] = ACTIONS(791),
    [anon_sym_DASHshl] = ACTIONS(791),
    [anon_sym_DASHshr] = ACTIONS(791),
    [anon_sym_DASHsplit] = ACTIONS(791),
    [sym_format_operator] = ACTIONS(791),
    [anon_sym_RPAREN] = ACTIONS(791),
    [anon_sym_COMMA] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_DASHand] = ACTIONS(791),
    [anon_sym_DASHor] = ACTIONS(791),
    [anon_sym_DASHxor] = ACTIONS(791),
    [anon_sym_DASHband] = ACTIONS(791),
    [anon_sym_DASHbor] = ACTIONS(791),
    [anon_sym_DASHbxor] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_DASH] = ACTIONS(793),
    [anon_sym_SLASH] = ACTIONS(791),
    [anon_sym_BSLASH] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(1332),
  },
  [302] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_DASHas] = ACTIONS(785),
    [anon_sym_DASHccontains] = ACTIONS(785),
    [anon_sym_DASHceq] = ACTIONS(785),
    [anon_sym_DASHcge] = ACTIONS(785),
    [anon_sym_DASHcgt] = ACTIONS(785),
    [anon_sym_DASHcle] = ACTIONS(785),
    [anon_sym_DASHclike] = ACTIONS(785),
    [anon_sym_DASHclt] = ACTIONS(785),
    [anon_sym_DASHcmatch] = ACTIONS(785),
    [anon_sym_DASHcne] = ACTIONS(785),
    [anon_sym_DASHcnotcontains] = ACTIONS(785),
    [anon_sym_DASHcnotlike] = ACTIONS(785),
    [anon_sym_DASHcnotmatch] = ACTIONS(785),
    [anon_sym_DASHcontains] = ACTIONS(785),
    [anon_sym_DASHcreplace] = ACTIONS(785),
    [anon_sym_DASHcsplit] = ACTIONS(785),
    [anon_sym_DASHeq] = ACTIONS(785),
    [anon_sym_DASHge] = ACTIONS(785),
    [anon_sym_DASHgt] = ACTIONS(785),
    [anon_sym_DASHicontains] = ACTIONS(785),
    [anon_sym_DASHieq] = ACTIONS(785),
    [anon_sym_DASHige] = ACTIONS(785),
    [anon_sym_DASHigt] = ACTIONS(785),
    [anon_sym_DASHile] = ACTIONS(785),
    [anon_sym_DASHilike] = ACTIONS(785),
    [anon_sym_DASHilt] = ACTIONS(785),
    [anon_sym_DASHimatch] = ACTIONS(785),
    [anon_sym_DASHin] = ACTIONS(787),
    [anon_sym_DASHine] = ACTIONS(785),
    [anon_sym_DASHinotcontains] = ACTIONS(785),
    [anon_sym_DASHinotlike] = ACTIONS(785),
    [anon_sym_DASHinotmatch] = ACTIONS(785),
    [anon_sym_DASHireplace] = ACTIONS(785),
    [anon_sym_DASHis] = ACTIONS(787),
    [anon_sym_DASHisnot] = ACTIONS(785),
    [anon_sym_DASHisplit] = ACTIONS(785),
    [anon_sym_DASHjoin] = ACTIONS(785),
    [anon_sym_DASHle] = ACTIONS(785),
    [anon_sym_DASHlike] = ACTIONS(785),
    [anon_sym_DASHlt] = ACTIONS(785),
    [anon_sym_DASHmatch] = ACTIONS(785),
    [anon_sym_DASHne] = ACTIONS(785),
    [anon_sym_DASHnotcontains] = ACTIONS(785),
    [anon_sym_DASHnotin] = ACTIONS(785),
    [anon_sym_DASHnotlike] = ACTIONS(785),
    [anon_sym_DASHnotmatch] = ACTIONS(785),
    [anon_sym_DASHreplace] = ACTIONS(785),
    [anon_sym_DASHshl] = ACTIONS(785),
    [anon_sym_DASHshr] = ACTIONS(785),
    [anon_sym_DASHsplit] = ACTIONS(785),
    [sym_format_operator] = ACTIONS(785),
    [anon_sym_RPAREN] = ACTIONS(785),
    [anon_sym_COMMA] = ACTIONS(785),
    [anon_sym_PERCENT] = ACTIONS(785),
    [anon_sym_DASHand] = ACTIONS(785),
    [anon_sym_DASHor] = ACTIONS(785),
    [anon_sym_DASHxor] = ACTIONS(785),
    [anon_sym_DASHband] = ACTIONS(785),
    [anon_sym_DASHbor] = ACTIONS(785),
    [anon_sym_DASHbxor] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(785),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(785),
    [anon_sym_BSLASH] = ACTIONS(785),
    [anon_sym_STAR] = ACTIONS(785),
    [anon_sym_DOT_DOT] = ACTIONS(1332),
  },
  [303] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_DASHas] = ACTIONS(779),
    [anon_sym_DASHccontains] = ACTIONS(779),
    [anon_sym_DASHceq] = ACTIONS(779),
    [anon_sym_DASHcge] = ACTIONS(779),
    [anon_sym_DASHcgt] = ACTIONS(779),
    [anon_sym_DASHcle] = ACTIONS(779),
    [anon_sym_DASHclike] = ACTIONS(779),
    [anon_sym_DASHclt] = ACTIONS(779),
    [anon_sym_DASHcmatch] = ACTIONS(779),
    [anon_sym_DASHcne] = ACTIONS(779),
    [anon_sym_DASHcnotcontains] = ACTIONS(779),
    [anon_sym_DASHcnotlike] = ACTIONS(779),
    [anon_sym_DASHcnotmatch] = ACTIONS(779),
    [anon_sym_DASHcontains] = ACTIONS(779),
    [anon_sym_DASHcreplace] = ACTIONS(779),
    [anon_sym_DASHcsplit] = ACTIONS(779),
    [anon_sym_DASHeq] = ACTIONS(779),
    [anon_sym_DASHge] = ACTIONS(779),
    [anon_sym_DASHgt] = ACTIONS(779),
    [anon_sym_DASHicontains] = ACTIONS(779),
    [anon_sym_DASHieq] = ACTIONS(779),
    [anon_sym_DASHige] = ACTIONS(779),
    [anon_sym_DASHigt] = ACTIONS(779),
    [anon_sym_DASHile] = ACTIONS(779),
    [anon_sym_DASHilike] = ACTIONS(779),
    [anon_sym_DASHilt] = ACTIONS(779),
    [anon_sym_DASHimatch] = ACTIONS(779),
    [anon_sym_DASHin] = ACTIONS(781),
    [anon_sym_DASHine] = ACTIONS(779),
    [anon_sym_DASHinotcontains] = ACTIONS(779),
    [anon_sym_DASHinotlike] = ACTIONS(779),
    [anon_sym_DASHinotmatch] = ACTIONS(779),
    [anon_sym_DASHireplace] = ACTIONS(779),
    [anon_sym_DASHis] = ACTIONS(781),
    [anon_sym_DASHisnot] = ACTIONS(779),
    [anon_sym_DASHisplit] = ACTIONS(779),
    [anon_sym_DASHjoin] = ACTIONS(779),
    [anon_sym_DASHle] = ACTIONS(779),
    [anon_sym_DASHlike] = ACTIONS(779),
    [anon_sym_DASHlt] = ACTIONS(779),
    [anon_sym_DASHmatch] = ACTIONS(779),
    [anon_sym_DASHne] = ACTIONS(779),
    [anon_sym_DASHnotcontains] = ACTIONS(779),
    [anon_sym_DASHnotin] = ACTIONS(779),
    [anon_sym_DASHnotlike] = ACTIONS(779),
    [anon_sym_DASHnotmatch] = ACTIONS(779),
    [anon_sym_DASHreplace] = ACTIONS(779),
    [anon_sym_DASHshl] = ACTIONS(779),
    [anon_sym_DASHshr] = ACTIONS(779),
    [anon_sym_DASHsplit] = ACTIONS(779),
    [sym_format_operator] = ACTIONS(779),
    [anon_sym_COMMA] = ACTIONS(1334),
    [anon_sym_PERCENT] = ACTIONS(779),
    [anon_sym_DASHand] = ACTIONS(779),
    [anon_sym_DASHor] = ACTIONS(779),
    [anon_sym_DASHxor] = ACTIONS(779),
    [anon_sym_DASHband] = ACTIONS(779),
    [anon_sym_DASHbor] = ACTIONS(779),
    [anon_sym_DASHbxor] = ACTIONS(779),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_SLASH] = ACTIONS(779),
    [anon_sym_BSLASH] = ACTIONS(779),
    [anon_sym_STAR] = ACTIONS(779),
    [anon_sym_DOT_DOT] = ACTIONS(779),
    [sym__statement_terminator] = ACTIONS(779),
  },
  [304] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_DASHas] = ACTIONS(773),
    [anon_sym_DASHccontains] = ACTIONS(773),
    [anon_sym_DASHceq] = ACTIONS(773),
    [anon_sym_DASHcge] = ACTIONS(773),
    [anon_sym_DASHcgt] = ACTIONS(773),
    [anon_sym_DASHcle] = ACTIONS(773),
    [anon_sym_DASHclike] = ACTIONS(773),
    [anon_sym_DASHclt] = ACTIONS(773),
    [anon_sym_DASHcmatch] = ACTIONS(773),
    [anon_sym_DASHcne] = ACTIONS(773),
    [anon_sym_DASHcnotcontains] = ACTIONS(773),
    [anon_sym_DASHcnotlike] = ACTIONS(773),
    [anon_sym_DASHcnotmatch] = ACTIONS(773),
    [anon_sym_DASHcontains] = ACTIONS(773),
    [anon_sym_DASHcreplace] = ACTIONS(773),
    [anon_sym_DASHcsplit] = ACTIONS(773),
    [anon_sym_DASHeq] = ACTIONS(773),
    [anon_sym_DASHge] = ACTIONS(773),
    [anon_sym_DASHgt] = ACTIONS(773),
    [anon_sym_DASHicontains] = ACTIONS(773),
    [anon_sym_DASHieq] = ACTIONS(773),
    [anon_sym_DASHige] = ACTIONS(773),
    [anon_sym_DASHigt] = ACTIONS(773),
    [anon_sym_DASHile] = ACTIONS(773),
    [anon_sym_DASHilike] = ACTIONS(773),
    [anon_sym_DASHilt] = ACTIONS(773),
    [anon_sym_DASHimatch] = ACTIONS(773),
    [anon_sym_DASHin] = ACTIONS(775),
    [anon_sym_DASHine] = ACTIONS(773),
    [anon_sym_DASHinotcontains] = ACTIONS(773),
    [anon_sym_DASHinotlike] = ACTIONS(773),
    [anon_sym_DASHinotmatch] = ACTIONS(773),
    [anon_sym_DASHireplace] = ACTIONS(773),
    [anon_sym_DASHis] = ACTIONS(775),
    [anon_sym_DASHisnot] = ACTIONS(773),
    [anon_sym_DASHisplit] = ACTIONS(773),
    [anon_sym_DASHjoin] = ACTIONS(773),
    [anon_sym_DASHle] = ACTIONS(773),
    [anon_sym_DASHlike] = ACTIONS(773),
    [anon_sym_DASHlt] = ACTIONS(773),
    [anon_sym_DASHmatch] = ACTIONS(773),
    [anon_sym_DASHne] = ACTIONS(773),
    [anon_sym_DASHnotcontains] = ACTIONS(773),
    [anon_sym_DASHnotin] = ACTIONS(773),
    [anon_sym_DASHnotlike] = ACTIONS(773),
    [anon_sym_DASHnotmatch] = ACTIONS(773),
    [anon_sym_DASHreplace] = ACTIONS(773),
    [anon_sym_DASHshl] = ACTIONS(773),
    [anon_sym_DASHshr] = ACTIONS(773),
    [anon_sym_DASHsplit] = ACTIONS(773),
    [sym_format_operator] = ACTIONS(773),
    [anon_sym_RPAREN] = ACTIONS(773),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(773),
    [anon_sym_DASHand] = ACTIONS(773),
    [anon_sym_DASHor] = ACTIONS(773),
    [anon_sym_DASHxor] = ACTIONS(773),
    [anon_sym_DASHband] = ACTIONS(773),
    [anon_sym_DASHbor] = ACTIONS(773),
    [anon_sym_DASHbxor] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(773),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_STAR] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(773),
  },
  [305] = {
    [aux_sym_command_argument_sep_repeat1] = STATE(305),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1325),
    [sym_hexadecimal_integer_literal] = ACTIONS(1325),
    [sym_real_literal] = ACTIONS(1325),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1325),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1325),
    [sym_verbatim_string_characters] = ACTIONS(1325),
    [sym_verbatim_here_string_characters] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(1325),
    [anon_sym_GT] = ACTIONS(1325),
    [anon_sym_GT_GT] = ACTIONS(1325),
    [anon_sym_2_GT] = ACTIONS(1325),
    [anon_sym_2_GT_GT] = ACTIONS(1325),
    [anon_sym_3_GT] = ACTIONS(1325),
    [anon_sym_3_GT_GT] = ACTIONS(1325),
    [anon_sym_4_GT] = ACTIONS(1325),
    [anon_sym_4_GT_GT] = ACTIONS(1325),
    [anon_sym_5_GT] = ACTIONS(1325),
    [anon_sym_5_GT_GT] = ACTIONS(1325),
    [anon_sym_6_GT] = ACTIONS(1325),
    [anon_sym_6_GT_GT] = ACTIONS(1325),
    [anon_sym_STAR_GT] = ACTIONS(1325),
    [anon_sym_STAR_GT_GT] = ACTIONS(1325),
    [anon_sym_LT] = ACTIONS(1325),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(1325),
    [anon_sym_2_GT_AMP1] = ACTIONS(1325),
    [anon_sym_3_GT_AMP1] = ACTIONS(1325),
    [anon_sym_4_GT_AMP1] = ACTIONS(1325),
    [anon_sym_5_GT_AMP1] = ACTIONS(1325),
    [anon_sym_6_GT_AMP1] = ACTIONS(1325),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(1325),
    [anon_sym_1_GT_AMP2] = ACTIONS(1325),
    [anon_sym_3_GT_AMP2] = ACTIONS(1325),
    [anon_sym_4_GT_AMP2] = ACTIONS(1325),
    [anon_sym_5_GT_AMP2] = ACTIONS(1325),
    [anon_sym_6_GT_AMP2] = ACTIONS(1325),
    [anon_sym_DASHjoin] = ACTIONS(1325),
    [anon_sym_DASHsplit] = ACTIONS(1325),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1325),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1325),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1325),
    [anon_sym_DOLLAR_] = ACTIONS(1325),
    [aux_sym_variable_token1] = ACTIONS(1325),
    [aux_sym_variable_token2] = ACTIONS(1325),
    [sym_braced_variable] = ACTIONS(1325),
    [sym_generic_token] = ACTIONS(1325),
    [sym_command_parameter] = ACTIONS(1325),
    [anon_sym_LPAREN] = ACTIONS(1325),
    [anon_sym_COMMA] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_PIPE] = ACTIONS(1325),
    [sym_stop_parsing] = ACTIONS(1325),
    [anon_sym_SPACE] = ACTIONS(1336),
    [anon_sym_COLON] = ACTIONS(1325),
    [anon_sym_DASH_DASH_PERCENT] = ACTIONS(1325),
    [anon_sym_PLUS] = ACTIONS(1325),
    [anon_sym_DASH] = ACTIONS(1325),
    [anon_sym_DASHnot] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1325),
    [anon_sym_DASHbnot] = ACTIONS(1325),
    [anon_sym_PLUS_PLUS] = ACTIONS(1325),
    [anon_sym_DASH_DASH] = ACTIONS(1325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1325),
    [anon_sym_AT_LPAREN] = ACTIONS(1325),
    [anon_sym_AT_LBRACE] = ACTIONS(1325),
    [sym__statement_terminator] = ACTIONS(1339),
  },
  [306] = {
    [aux_sym_command_argument_sep_repeat1] = STATE(305),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1341),
    [sym_hexadecimal_integer_literal] = ACTIONS(1341),
    [sym_real_literal] = ACTIONS(1341),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1341),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1341),
    [sym_verbatim_string_characters] = ACTIONS(1341),
    [sym_verbatim_here_string_characters] = ACTIONS(1341),
    [anon_sym_LBRACK] = ACTIONS(1341),
    [anon_sym_GT] = ACTIONS(1341),
    [anon_sym_GT_GT] = ACTIONS(1341),
    [anon_sym_2_GT] = ACTIONS(1341),
    [anon_sym_2_GT_GT] = ACTIONS(1341),
    [anon_sym_3_GT] = ACTIONS(1341),
    [anon_sym_3_GT_GT] = ACTIONS(1341),
    [anon_sym_4_GT] = ACTIONS(1341),
    [anon_sym_4_GT_GT] = ACTIONS(1341),
    [anon_sym_5_GT] = ACTIONS(1341),
    [anon_sym_5_GT_GT] = ACTIONS(1341),
    [anon_sym_6_GT] = ACTIONS(1341),
    [anon_sym_6_GT_GT] = ACTIONS(1341),
    [anon_sym_STAR_GT] = ACTIONS(1341),
    [anon_sym_STAR_GT_GT] = ACTIONS(1341),
    [anon_sym_LT] = ACTIONS(1341),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(1341),
    [anon_sym_2_GT_AMP1] = ACTIONS(1341),
    [anon_sym_3_GT_AMP1] = ACTIONS(1341),
    [anon_sym_4_GT_AMP1] = ACTIONS(1341),
    [anon_sym_5_GT_AMP1] = ACTIONS(1341),
    [anon_sym_6_GT_AMP1] = ACTIONS(1341),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(1341),
    [anon_sym_1_GT_AMP2] = ACTIONS(1341),
    [anon_sym_3_GT_AMP2] = ACTIONS(1341),
    [anon_sym_4_GT_AMP2] = ACTIONS(1341),
    [anon_sym_5_GT_AMP2] = ACTIONS(1341),
    [anon_sym_6_GT_AMP2] = ACTIONS(1341),
    [anon_sym_DASHjoin] = ACTIONS(1341),
    [anon_sym_DASHsplit] = ACTIONS(1341),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1341),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1341),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1341),
    [anon_sym_DOLLAR_] = ACTIONS(1341),
    [aux_sym_variable_token1] = ACTIONS(1341),
    [aux_sym_variable_token2] = ACTIONS(1341),
    [sym_braced_variable] = ACTIONS(1341),
    [sym_generic_token] = ACTIONS(1341),
    [sym_command_parameter] = ACTIONS(1341),
    [anon_sym_LPAREN] = ACTIONS(1341),
    [anon_sym_COMMA] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1341),
    [anon_sym_PIPE] = ACTIONS(1341),
    [sym_stop_parsing] = ACTIONS(1341),
    [anon_sym_SPACE] = ACTIONS(1343),
    [anon_sym_COLON] = ACTIONS(1341),
    [anon_sym_DASH_DASH_PERCENT] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_DASHnot] = ACTIONS(1341),
    [anon_sym_BANG] = ACTIONS(1341),
    [anon_sym_DASHbnot] = ACTIONS(1341),
    [anon_sym_PLUS_PLUS] = ACTIONS(1341),
    [anon_sym_DASH_DASH] = ACTIONS(1341),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1341),
    [anon_sym_AT_LPAREN] = ACTIONS(1341),
    [anon_sym_AT_LBRACE] = ACTIONS(1341),
    [sym__statement_terminator] = ACTIONS(1345),
  },
  [307] = {
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(251),
    [sym_hexadecimal_integer_literal] = ACTIONS(251),
    [sym_real_literal] = ACTIONS(251),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(251),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(251),
    [sym_verbatim_string_characters] = ACTIONS(251),
    [sym_verbatim_here_string_characters] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(251),
    [anon_sym_GT] = ACTIONS(251),
    [anon_sym_GT_GT] = ACTIONS(251),
    [anon_sym_2_GT] = ACTIONS(251),
    [anon_sym_2_GT_GT] = ACTIONS(251),
    [anon_sym_3_GT] = ACTIONS(251),
    [anon_sym_3_GT_GT] = ACTIONS(251),
    [anon_sym_4_GT] = ACTIONS(251),
    [anon_sym_4_GT_GT] = ACTIONS(251),
    [anon_sym_5_GT] = ACTIONS(251),
    [anon_sym_5_GT_GT] = ACTIONS(251),
    [anon_sym_6_GT] = ACTIONS(251),
    [anon_sym_6_GT_GT] = ACTIONS(251),
    [anon_sym_STAR_GT] = ACTIONS(251),
    [anon_sym_STAR_GT_GT] = ACTIONS(251),
    [anon_sym_LT] = ACTIONS(251),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(251),
    [anon_sym_2_GT_AMP1] = ACTIONS(251),
    [anon_sym_3_GT_AMP1] = ACTIONS(251),
    [anon_sym_4_GT_AMP1] = ACTIONS(251),
    [anon_sym_5_GT_AMP1] = ACTIONS(251),
    [anon_sym_6_GT_AMP1] = ACTIONS(251),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(251),
    [anon_sym_1_GT_AMP2] = ACTIONS(251),
    [anon_sym_3_GT_AMP2] = ACTIONS(251),
    [anon_sym_4_GT_AMP2] = ACTIONS(251),
    [anon_sym_5_GT_AMP2] = ACTIONS(251),
    [anon_sym_6_GT_AMP2] = ACTIONS(251),
    [anon_sym_DASHjoin] = ACTIONS(251),
    [anon_sym_DASHsplit] = ACTIONS(251),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(251),
    [anon_sym_DOLLAR_CARET] = ACTIONS(251),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(251),
    [anon_sym_DOLLAR_] = ACTIONS(251),
    [aux_sym_variable_token1] = ACTIONS(251),
    [aux_sym_variable_token2] = ACTIONS(251),
    [sym_braced_variable] = ACTIONS(251),
    [sym_command_parameter] = ACTIONS(251),
    [anon_sym_LPAREN] = ACTIONS(251),
    [anon_sym_RPAREN] = ACTIONS(251),
    [anon_sym_COMMA] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(251),
    [anon_sym_PIPE] = ACTIONS(251),
    [sym_stop_parsing] = ACTIONS(251),
    [anon_sym_SPACE] = ACTIONS(253),
    [anon_sym_COLON] = ACTIONS(251),
    [anon_sym_PLUS] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_DASHnot] = ACTIONS(251),
    [anon_sym_BANG] = ACTIONS(251),
    [anon_sym_DASHbnot] = ACTIONS(251),
    [anon_sym_PLUS_PLUS] = ACTIONS(251),
    [anon_sym_DASH_DASH] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(251),
    [anon_sym_AT_LPAREN] = ACTIONS(251),
    [anon_sym_AT_LBRACE] = ACTIONS(251),
    [anon_sym_DOT2] = ACTIONS(251),
    [anon_sym_COLON_COLON] = ACTIONS(251),
    [anon_sym_DOTforeach] = ACTIONS(253),
  },
  [308] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_DASHas] = ACTIONS(773),
    [anon_sym_DASHccontains] = ACTIONS(773),
    [anon_sym_DASHceq] = ACTIONS(773),
    [anon_sym_DASHcge] = ACTIONS(773),
    [anon_sym_DASHcgt] = ACTIONS(773),
    [anon_sym_DASHcle] = ACTIONS(773),
    [anon_sym_DASHclike] = ACTIONS(773),
    [anon_sym_DASHclt] = ACTIONS(773),
    [anon_sym_DASHcmatch] = ACTIONS(773),
    [anon_sym_DASHcne] = ACTIONS(773),
    [anon_sym_DASHcnotcontains] = ACTIONS(773),
    [anon_sym_DASHcnotlike] = ACTIONS(773),
    [anon_sym_DASHcnotmatch] = ACTIONS(773),
    [anon_sym_DASHcontains] = ACTIONS(773),
    [anon_sym_DASHcreplace] = ACTIONS(773),
    [anon_sym_DASHcsplit] = ACTIONS(773),
    [anon_sym_DASHeq] = ACTIONS(773),
    [anon_sym_DASHge] = ACTIONS(773),
    [anon_sym_DASHgt] = ACTIONS(773),
    [anon_sym_DASHicontains] = ACTIONS(773),
    [anon_sym_DASHieq] = ACTIONS(773),
    [anon_sym_DASHige] = ACTIONS(773),
    [anon_sym_DASHigt] = ACTIONS(773),
    [anon_sym_DASHile] = ACTIONS(773),
    [anon_sym_DASHilike] = ACTIONS(773),
    [anon_sym_DASHilt] = ACTIONS(773),
    [anon_sym_DASHimatch] = ACTIONS(773),
    [anon_sym_DASHin] = ACTIONS(775),
    [anon_sym_DASHine] = ACTIONS(773),
    [anon_sym_DASHinotcontains] = ACTIONS(773),
    [anon_sym_DASHinotlike] = ACTIONS(773),
    [anon_sym_DASHinotmatch] = ACTIONS(773),
    [anon_sym_DASHireplace] = ACTIONS(773),
    [anon_sym_DASHis] = ACTIONS(775),
    [anon_sym_DASHisnot] = ACTIONS(773),
    [anon_sym_DASHisplit] = ACTIONS(773),
    [anon_sym_DASHjoin] = ACTIONS(773),
    [anon_sym_DASHle] = ACTIONS(773),
    [anon_sym_DASHlike] = ACTIONS(773),
    [anon_sym_DASHlt] = ACTIONS(773),
    [anon_sym_DASHmatch] = ACTIONS(773),
    [anon_sym_DASHne] = ACTIONS(773),
    [anon_sym_DASHnotcontains] = ACTIONS(773),
    [anon_sym_DASHnotin] = ACTIONS(773),
    [anon_sym_DASHnotlike] = ACTIONS(773),
    [anon_sym_DASHnotmatch] = ACTIONS(773),
    [anon_sym_DASHreplace] = ACTIONS(773),
    [anon_sym_DASHshl] = ACTIONS(773),
    [anon_sym_DASHshr] = ACTIONS(773),
    [anon_sym_DASHsplit] = ACTIONS(773),
    [sym_format_operator] = ACTIONS(773),
    [anon_sym_COMMA] = ACTIONS(1334),
    [anon_sym_PERCENT] = ACTIONS(773),
    [anon_sym_DASHand] = ACTIONS(773),
    [anon_sym_DASHor] = ACTIONS(773),
    [anon_sym_DASHxor] = ACTIONS(773),
    [anon_sym_DASHband] = ACTIONS(773),
    [anon_sym_DASHbor] = ACTIONS(773),
    [anon_sym_DASHbxor] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(773),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_STAR] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(773),
    [sym__statement_terminator] = ACTIONS(773),
  },
  [309] = {
    [aux_sym_command_argument_sep_repeat1] = STATE(298),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1341),
    [sym_hexadecimal_integer_literal] = ACTIONS(1341),
    [sym_real_literal] = ACTIONS(1341),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1341),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1341),
    [sym_verbatim_string_characters] = ACTIONS(1341),
    [sym_verbatim_here_string_characters] = ACTIONS(1341),
    [anon_sym_LBRACK] = ACTIONS(1341),
    [anon_sym_GT] = ACTIONS(1341),
    [anon_sym_GT_GT] = ACTIONS(1341),
    [anon_sym_2_GT] = ACTIONS(1341),
    [anon_sym_2_GT_GT] = ACTIONS(1341),
    [anon_sym_3_GT] = ACTIONS(1341),
    [anon_sym_3_GT_GT] = ACTIONS(1341),
    [anon_sym_4_GT] = ACTIONS(1341),
    [anon_sym_4_GT_GT] = ACTIONS(1341),
    [anon_sym_5_GT] = ACTIONS(1341),
    [anon_sym_5_GT_GT] = ACTIONS(1341),
    [anon_sym_6_GT] = ACTIONS(1341),
    [anon_sym_6_GT_GT] = ACTIONS(1341),
    [anon_sym_STAR_GT] = ACTIONS(1341),
    [anon_sym_STAR_GT_GT] = ACTIONS(1341),
    [anon_sym_LT] = ACTIONS(1341),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(1341),
    [anon_sym_2_GT_AMP1] = ACTIONS(1341),
    [anon_sym_3_GT_AMP1] = ACTIONS(1341),
    [anon_sym_4_GT_AMP1] = ACTIONS(1341),
    [anon_sym_5_GT_AMP1] = ACTIONS(1341),
    [anon_sym_6_GT_AMP1] = ACTIONS(1341),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(1341),
    [anon_sym_1_GT_AMP2] = ACTIONS(1341),
    [anon_sym_3_GT_AMP2] = ACTIONS(1341),
    [anon_sym_4_GT_AMP2] = ACTIONS(1341),
    [anon_sym_5_GT_AMP2] = ACTIONS(1341),
    [anon_sym_6_GT_AMP2] = ACTIONS(1341),
    [anon_sym_DASHjoin] = ACTIONS(1341),
    [anon_sym_DASHsplit] = ACTIONS(1341),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1341),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1341),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1341),
    [anon_sym_DOLLAR_] = ACTIONS(1341),
    [aux_sym_variable_token1] = ACTIONS(1341),
    [aux_sym_variable_token2] = ACTIONS(1341),
    [sym_braced_variable] = ACTIONS(1341),
    [sym_generic_token] = ACTIONS(1341),
    [sym_command_parameter] = ACTIONS(1341),
    [anon_sym_LPAREN] = ACTIONS(1341),
    [anon_sym_RPAREN] = ACTIONS(1341),
    [anon_sym_COMMA] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1341),
    [anon_sym_PIPE] = ACTIONS(1341),
    [sym_stop_parsing] = ACTIONS(1341),
    [anon_sym_SPACE] = ACTIONS(1347),
    [anon_sym_COLON] = ACTIONS(1341),
    [anon_sym_DASH_DASH_PERCENT] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_DASHnot] = ACTIONS(1341),
    [anon_sym_BANG] = ACTIONS(1341),
    [anon_sym_DASHbnot] = ACTIONS(1341),
    [anon_sym_PLUS_PLUS] = ACTIONS(1341),
    [anon_sym_DASH_DASH] = ACTIONS(1341),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1341),
    [anon_sym_AT_LPAREN] = ACTIONS(1341),
    [anon_sym_AT_LBRACE] = ACTIONS(1341),
  },
  [310] = {
    [sym_catch_clauses] = STATE(410),
    [sym_catch_clause] = STATE(358),
    [sym_finally_clause] = STATE(497),
    [aux_sym_catch_clauses_repeat1] = STATE(358),
    [ts_builtin_sym_end] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1313),
    [sym_hexadecimal_integer_literal] = ACTIONS(1313),
    [sym_real_literal] = ACTIONS(1313),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1313),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1313),
    [sym_verbatim_string_characters] = ACTIONS(1313),
    [sym_verbatim_here_string_characters] = ACTIONS(1313),
    [anon_sym_DOT] = ACTIONS(1313),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_DASHjoin] = ACTIONS(1313),
    [anon_sym_DASHsplit] = ACTIONS(1313),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1313),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1313),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1313),
    [anon_sym_DOLLAR_] = ACTIONS(1313),
    [aux_sym_variable_token1] = ACTIONS(1313),
    [aux_sym_variable_token2] = ACTIONS(1313),
    [sym_braced_variable] = ACTIONS(1313),
    [anon_sym_SEMI] = ACTIONS(1313),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_COMMA] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_switch] = ACTIONS(1313),
    [anon_sym_foreach] = ACTIONS(1313),
    [anon_sym_for] = ACTIONS(1313),
    [anon_sym_while] = ACTIONS(1313),
    [anon_sym_do] = ACTIONS(1313),
    [anon_sym_function] = ACTIONS(1313),
    [anon_sym_filter] = ACTIONS(1313),
    [anon_sym_workflow] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1313),
    [anon_sym_continue] = ACTIONS(1313),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_return] = ACTIONS(1313),
    [anon_sym_exit] = ACTIONS(1313),
    [sym_label] = ACTIONS(1313),
    [anon_sym_trap] = ACTIONS(1313),
    [anon_sym_try] = ACTIONS(1313),
    [anon_sym_catch] = ACTIONS(1351),
    [anon_sym_finally] = ACTIONS(1353),
    [anon_sym_data] = ACTIONS(1313),
    [anon_sym_inlinescript] = ACTIONS(1313),
    [anon_sym_parallel] = ACTIONS(1313),
    [anon_sym_sequence] = ACTIONS(1313),
    [anon_sym_AMP] = ACTIONS(1313),
    [aux_sym_command_name_token1] = ACTIONS(1313),
    [anon_sym_PERCENT] = ACTIONS(1313),
    [anon_sym_foreach_DASHobject] = ACTIONS(1313),
    [anon_sym_class] = ACTIONS(1313),
    [anon_sym_enum] = ACTIONS(1313),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_DASH] = ACTIONS(1313),
    [anon_sym_DASHnot] = ACTIONS(1313),
    [anon_sym_BANG] = ACTIONS(1313),
    [anon_sym_DASHbnot] = ACTIONS(1313),
    [anon_sym_PLUS_PLUS] = ACTIONS(1313),
    [anon_sym_DASH_DASH] = ACTIONS(1313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1313),
    [anon_sym_AT_LPAREN] = ACTIONS(1313),
    [anon_sym_AT_LBRACE] = ACTIONS(1313),
  },
  [311] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_DASHas] = ACTIONS(779),
    [anon_sym_DASHccontains] = ACTIONS(779),
    [anon_sym_DASHceq] = ACTIONS(779),
    [anon_sym_DASHcge] = ACTIONS(779),
    [anon_sym_DASHcgt] = ACTIONS(779),
    [anon_sym_DASHcle] = ACTIONS(779),
    [anon_sym_DASHclike] = ACTIONS(779),
    [anon_sym_DASHclt] = ACTIONS(779),
    [anon_sym_DASHcmatch] = ACTIONS(779),
    [anon_sym_DASHcne] = ACTIONS(779),
    [anon_sym_DASHcnotcontains] = ACTIONS(779),
    [anon_sym_DASHcnotlike] = ACTIONS(779),
    [anon_sym_DASHcnotmatch] = ACTIONS(779),
    [anon_sym_DASHcontains] = ACTIONS(779),
    [anon_sym_DASHcreplace] = ACTIONS(779),
    [anon_sym_DASHcsplit] = ACTIONS(779),
    [anon_sym_DASHeq] = ACTIONS(779),
    [anon_sym_DASHge] = ACTIONS(779),
    [anon_sym_DASHgt] = ACTIONS(779),
    [anon_sym_DASHicontains] = ACTIONS(779),
    [anon_sym_DASHieq] = ACTIONS(779),
    [anon_sym_DASHige] = ACTIONS(779),
    [anon_sym_DASHigt] = ACTIONS(779),
    [anon_sym_DASHile] = ACTIONS(779),
    [anon_sym_DASHilike] = ACTIONS(779),
    [anon_sym_DASHilt] = ACTIONS(779),
    [anon_sym_DASHimatch] = ACTIONS(779),
    [anon_sym_DASHin] = ACTIONS(781),
    [anon_sym_DASHine] = ACTIONS(779),
    [anon_sym_DASHinotcontains] = ACTIONS(779),
    [anon_sym_DASHinotlike] = ACTIONS(779),
    [anon_sym_DASHinotmatch] = ACTIONS(779),
    [anon_sym_DASHireplace] = ACTIONS(779),
    [anon_sym_DASHis] = ACTIONS(781),
    [anon_sym_DASHisnot] = ACTIONS(779),
    [anon_sym_DASHisplit] = ACTIONS(779),
    [anon_sym_DASHjoin] = ACTIONS(779),
    [anon_sym_DASHle] = ACTIONS(779),
    [anon_sym_DASHlike] = ACTIONS(779),
    [anon_sym_DASHlt] = ACTIONS(779),
    [anon_sym_DASHmatch] = ACTIONS(779),
    [anon_sym_DASHne] = ACTIONS(779),
    [anon_sym_DASHnotcontains] = ACTIONS(779),
    [anon_sym_DASHnotin] = ACTIONS(779),
    [anon_sym_DASHnotlike] = ACTIONS(779),
    [anon_sym_DASHnotmatch] = ACTIONS(779),
    [anon_sym_DASHreplace] = ACTIONS(779),
    [anon_sym_DASHshl] = ACTIONS(779),
    [anon_sym_DASHshr] = ACTIONS(779),
    [anon_sym_DASHsplit] = ACTIONS(779),
    [sym_format_operator] = ACTIONS(779),
    [anon_sym_COMMA] = ACTIONS(1330),
    [anon_sym_PERCENT] = ACTIONS(779),
    [anon_sym_DASHand] = ACTIONS(779),
    [anon_sym_DASHor] = ACTIONS(779),
    [anon_sym_DASHxor] = ACTIONS(779),
    [anon_sym_DASHband] = ACTIONS(779),
    [anon_sym_DASHbor] = ACTIONS(779),
    [anon_sym_DASHbxor] = ACTIONS(779),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_SLASH] = ACTIONS(779),
    [anon_sym_BSLASH] = ACTIONS(779),
    [anon_sym_STAR] = ACTIONS(779),
    [anon_sym_DOT_DOT] = ACTIONS(779),
    [anon_sym_RBRACK] = ACTIONS(779),
  },
  [312] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_DASHas] = ACTIONS(779),
    [anon_sym_DASHccontains] = ACTIONS(779),
    [anon_sym_DASHceq] = ACTIONS(779),
    [anon_sym_DASHcge] = ACTIONS(779),
    [anon_sym_DASHcgt] = ACTIONS(779),
    [anon_sym_DASHcle] = ACTIONS(779),
    [anon_sym_DASHclike] = ACTIONS(779),
    [anon_sym_DASHclt] = ACTIONS(779),
    [anon_sym_DASHcmatch] = ACTIONS(779),
    [anon_sym_DASHcne] = ACTIONS(779),
    [anon_sym_DASHcnotcontains] = ACTIONS(779),
    [anon_sym_DASHcnotlike] = ACTIONS(779),
    [anon_sym_DASHcnotmatch] = ACTIONS(779),
    [anon_sym_DASHcontains] = ACTIONS(779),
    [anon_sym_DASHcreplace] = ACTIONS(779),
    [anon_sym_DASHcsplit] = ACTIONS(779),
    [anon_sym_DASHeq] = ACTIONS(779),
    [anon_sym_DASHge] = ACTIONS(779),
    [anon_sym_DASHgt] = ACTIONS(779),
    [anon_sym_DASHicontains] = ACTIONS(779),
    [anon_sym_DASHieq] = ACTIONS(779),
    [anon_sym_DASHige] = ACTIONS(779),
    [anon_sym_DASHigt] = ACTIONS(779),
    [anon_sym_DASHile] = ACTIONS(779),
    [anon_sym_DASHilike] = ACTIONS(779),
    [anon_sym_DASHilt] = ACTIONS(779),
    [anon_sym_DASHimatch] = ACTIONS(779),
    [anon_sym_DASHin] = ACTIONS(781),
    [anon_sym_DASHine] = ACTIONS(779),
    [anon_sym_DASHinotcontains] = ACTIONS(779),
    [anon_sym_DASHinotlike] = ACTIONS(779),
    [anon_sym_DASHinotmatch] = ACTIONS(779),
    [anon_sym_DASHireplace] = ACTIONS(779),
    [anon_sym_DASHis] = ACTIONS(781),
    [anon_sym_DASHisnot] = ACTIONS(779),
    [anon_sym_DASHisplit] = ACTIONS(779),
    [anon_sym_DASHjoin] = ACTIONS(779),
    [anon_sym_DASHle] = ACTIONS(779),
    [anon_sym_DASHlike] = ACTIONS(779),
    [anon_sym_DASHlt] = ACTIONS(779),
    [anon_sym_DASHmatch] = ACTIONS(779),
    [anon_sym_DASHne] = ACTIONS(779),
    [anon_sym_DASHnotcontains] = ACTIONS(779),
    [anon_sym_DASHnotin] = ACTIONS(779),
    [anon_sym_DASHnotlike] = ACTIONS(779),
    [anon_sym_DASHnotmatch] = ACTIONS(779),
    [anon_sym_DASHreplace] = ACTIONS(779),
    [anon_sym_DASHshl] = ACTIONS(779),
    [anon_sym_DASHshr] = ACTIONS(779),
    [anon_sym_DASHsplit] = ACTIONS(779),
    [sym_format_operator] = ACTIONS(779),
    [anon_sym_RPAREN] = ACTIONS(779),
    [anon_sym_COMMA] = ACTIONS(779),
    [anon_sym_PERCENT] = ACTIONS(779),
    [anon_sym_DASHand] = ACTIONS(779),
    [anon_sym_DASHor] = ACTIONS(779),
    [anon_sym_DASHxor] = ACTIONS(779),
    [anon_sym_DASHband] = ACTIONS(779),
    [anon_sym_DASHbor] = ACTIONS(779),
    [anon_sym_DASHbxor] = ACTIONS(779),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_SLASH] = ACTIONS(779),
    [anon_sym_BSLASH] = ACTIONS(779),
    [anon_sym_STAR] = ACTIONS(779),
    [anon_sym_DOT_DOT] = ACTIONS(779),
  },
  [313] = {
    [sym_elseif_clauses] = STATE(392),
    [sym_elseif_clause] = STATE(367),
    [sym_else_clause] = STATE(523),
    [aux_sym_elseif_clauses_repeat1] = STATE(367),
    [ts_builtin_sym_end] = ACTIONS(1355),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1319),
    [sym_hexadecimal_integer_literal] = ACTIONS(1319),
    [sym_real_literal] = ACTIONS(1319),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1319),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1319),
    [sym_verbatim_string_characters] = ACTIONS(1319),
    [sym_verbatim_here_string_characters] = ACTIONS(1319),
    [anon_sym_DOT] = ACTIONS(1319),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_DASHjoin] = ACTIONS(1319),
    [anon_sym_DASHsplit] = ACTIONS(1319),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1319),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1319),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1319),
    [anon_sym_DOLLAR_] = ACTIONS(1319),
    [aux_sym_variable_token1] = ACTIONS(1319),
    [aux_sym_variable_token2] = ACTIONS(1319),
    [sym_braced_variable] = ACTIONS(1319),
    [anon_sym_SEMI] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1319),
    [anon_sym_COMMA] = ACTIONS(1319),
    [anon_sym_LBRACE] = ACTIONS(1319),
    [anon_sym_if] = ACTIONS(1319),
    [anon_sym_elseif] = ACTIONS(1357),
    [anon_sym_else] = ACTIONS(1359),
    [anon_sym_switch] = ACTIONS(1319),
    [anon_sym_foreach] = ACTIONS(1319),
    [anon_sym_for] = ACTIONS(1319),
    [anon_sym_while] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1319),
    [anon_sym_function] = ACTIONS(1319),
    [anon_sym_filter] = ACTIONS(1319),
    [anon_sym_workflow] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1319),
    [anon_sym_continue] = ACTIONS(1319),
    [anon_sym_throw] = ACTIONS(1319),
    [anon_sym_return] = ACTIONS(1319),
    [anon_sym_exit] = ACTIONS(1319),
    [sym_label] = ACTIONS(1319),
    [anon_sym_trap] = ACTIONS(1319),
    [anon_sym_try] = ACTIONS(1319),
    [anon_sym_data] = ACTIONS(1319),
    [anon_sym_inlinescript] = ACTIONS(1319),
    [anon_sym_parallel] = ACTIONS(1319),
    [anon_sym_sequence] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [aux_sym_command_name_token1] = ACTIONS(1319),
    [anon_sym_PERCENT] = ACTIONS(1319),
    [anon_sym_foreach_DASHobject] = ACTIONS(1319),
    [anon_sym_class] = ACTIONS(1319),
    [anon_sym_enum] = ACTIONS(1319),
    [anon_sym_PLUS] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_DASHnot] = ACTIONS(1319),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_DASHbnot] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1319),
    [anon_sym_AT_LPAREN] = ACTIONS(1319),
    [anon_sym_AT_LBRACE] = ACTIONS(1319),
  },
  [314] = {
    [sym__literal] = STATE(289),
    [sym_integer_literal] = STATE(289),
    [sym_string_literal] = STATE(289),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(289),
    [sym_unary_expression] = STATE(386),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(289),
    [sym__value] = STATE(289),
    [sym_parenthesized_expression] = STATE(289),
    [sym_sub_expression] = STATE(289),
    [sym_array_expression] = STATE(289),
    [sym_script_block_expression] = STATE(289),
    [sym_hash_literal_expression] = STATE(289),
    [sym_post_increment_expression] = STATE(289),
    [sym_post_decrement_expression] = STATE(289),
    [sym_member_access] = STATE(289),
    [sym_element_access] = STATE(289),
    [sym_invokation_expression] = STATE(289),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_argument_expression_list] = STATE(1806),
    [sym_argument_expression] = STATE(1490),
    [sym_logical_argument_expression] = STATE(1331),
    [sym_bitwise_argument_expression] = STATE(1332),
    [sym_comparison_argument_expression] = STATE(584),
    [sym_additive_argument_expression] = STATE(576),
    [sym_multiplicative_argument_expression] = STATE(430),
    [sym_format_argument_expression] = STATE(402),
    [sym_range_argument_expression] = STATE(380),
    [sym_type_literal] = STATE(76),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(121),
    [sym_real_literal] = ACTIONS(479),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(125),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(127),
    [sym_verbatim_string_characters] = ACTIONS(129),
    [sym_verbatim_here_string_characters] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_DASHjoin] = ACTIONS(483),
    [anon_sym_DASHsplit] = ACTIONS(483),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(135),
    [anon_sym_DOLLAR_CARET] = ACTIONS(135),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(135),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(135),
    [sym_braced_variable] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(1361),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(485),
    [anon_sym_DASHnot] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_DASHbnot] = ACTIONS(483),
    [anon_sym_PLUS_PLUS] = ACTIONS(487),
    [anon_sym_DASH_DASH] = ACTIONS(489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_AT_LBRACE] = ACTIONS(153),
  },
  [315] = {
    [sym__literal] = STATE(289),
    [sym_integer_literal] = STATE(289),
    [sym_string_literal] = STATE(289),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(289),
    [sym_unary_expression] = STATE(386),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(289),
    [sym__value] = STATE(289),
    [sym_parenthesized_expression] = STATE(289),
    [sym_sub_expression] = STATE(289),
    [sym_array_expression] = STATE(289),
    [sym_script_block_expression] = STATE(289),
    [sym_hash_literal_expression] = STATE(289),
    [sym_post_increment_expression] = STATE(289),
    [sym_post_decrement_expression] = STATE(289),
    [sym_member_access] = STATE(289),
    [sym_element_access] = STATE(289),
    [sym_invokation_expression] = STATE(289),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_argument_expression_list] = STATE(1742),
    [sym_argument_expression] = STATE(1490),
    [sym_logical_argument_expression] = STATE(1331),
    [sym_bitwise_argument_expression] = STATE(1332),
    [sym_comparison_argument_expression] = STATE(584),
    [sym_additive_argument_expression] = STATE(576),
    [sym_multiplicative_argument_expression] = STATE(430),
    [sym_format_argument_expression] = STATE(402),
    [sym_range_argument_expression] = STATE(380),
    [sym_type_literal] = STATE(76),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(121),
    [sym_real_literal] = ACTIONS(479),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(125),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(127),
    [sym_verbatim_string_characters] = ACTIONS(129),
    [sym_verbatim_here_string_characters] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_DASHjoin] = ACTIONS(483),
    [anon_sym_DASHsplit] = ACTIONS(483),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(135),
    [anon_sym_DOLLAR_CARET] = ACTIONS(135),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(135),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(135),
    [sym_braced_variable] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(485),
    [anon_sym_DASHnot] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_DASHbnot] = ACTIONS(483),
    [anon_sym_PLUS_PLUS] = ACTIONS(487),
    [anon_sym_DASH_DASH] = ACTIONS(489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_AT_LBRACE] = ACTIONS(153),
  },
  [316] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_DASHas] = ACTIONS(797),
    [anon_sym_DASHccontains] = ACTIONS(797),
    [anon_sym_DASHceq] = ACTIONS(797),
    [anon_sym_DASHcge] = ACTIONS(797),
    [anon_sym_DASHcgt] = ACTIONS(797),
    [anon_sym_DASHcle] = ACTIONS(797),
    [anon_sym_DASHclike] = ACTIONS(797),
    [anon_sym_DASHclt] = ACTIONS(797),
    [anon_sym_DASHcmatch] = ACTIONS(797),
    [anon_sym_DASHcne] = ACTIONS(797),
    [anon_sym_DASHcnotcontains] = ACTIONS(797),
    [anon_sym_DASHcnotlike] = ACTIONS(797),
    [anon_sym_DASHcnotmatch] = ACTIONS(797),
    [anon_sym_DASHcontains] = ACTIONS(797),
    [anon_sym_DASHcreplace] = ACTIONS(797),
    [anon_sym_DASHcsplit] = ACTIONS(797),
    [anon_sym_DASHeq] = ACTIONS(797),
    [anon_sym_DASHge] = ACTIONS(797),
    [anon_sym_DASHgt] = ACTIONS(797),
    [anon_sym_DASHicontains] = ACTIONS(797),
    [anon_sym_DASHieq] = ACTIONS(797),
    [anon_sym_DASHige] = ACTIONS(797),
    [anon_sym_DASHigt] = ACTIONS(797),
    [anon_sym_DASHile] = ACTIONS(797),
    [anon_sym_DASHilike] = ACTIONS(797),
    [anon_sym_DASHilt] = ACTIONS(797),
    [anon_sym_DASHimatch] = ACTIONS(797),
    [anon_sym_DASHin] = ACTIONS(799),
    [anon_sym_DASHine] = ACTIONS(797),
    [anon_sym_DASHinotcontains] = ACTIONS(797),
    [anon_sym_DASHinotlike] = ACTIONS(797),
    [anon_sym_DASHinotmatch] = ACTIONS(797),
    [anon_sym_DASHireplace] = ACTIONS(797),
    [anon_sym_DASHis] = ACTIONS(799),
    [anon_sym_DASHisnot] = ACTIONS(797),
    [anon_sym_DASHisplit] = ACTIONS(797),
    [anon_sym_DASHjoin] = ACTIONS(797),
    [anon_sym_DASHle] = ACTIONS(797),
    [anon_sym_DASHlike] = ACTIONS(797),
    [anon_sym_DASHlt] = ACTIONS(797),
    [anon_sym_DASHmatch] = ACTIONS(797),
    [anon_sym_DASHne] = ACTIONS(797),
    [anon_sym_DASHnotcontains] = ACTIONS(797),
    [anon_sym_DASHnotin] = ACTIONS(797),
    [anon_sym_DASHnotlike] = ACTIONS(797),
    [anon_sym_DASHnotmatch] = ACTIONS(797),
    [anon_sym_DASHreplace] = ACTIONS(797),
    [anon_sym_DASHshl] = ACTIONS(797),
    [anon_sym_DASHshr] = ACTIONS(797),
    [anon_sym_DASHsplit] = ACTIONS(797),
    [sym_format_operator] = ACTIONS(1365),
    [anon_sym_RPAREN] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_DASHand] = ACTIONS(797),
    [anon_sym_DASHor] = ACTIONS(797),
    [anon_sym_DASHxor] = ACTIONS(797),
    [anon_sym_DASHband] = ACTIONS(797),
    [anon_sym_DASHbor] = ACTIONS(797),
    [anon_sym_DASHbxor] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(797),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_BSLASH] = ACTIONS(797),
    [anon_sym_STAR] = ACTIONS(797),
  },
  [317] = {
    [sym__literal] = STATE(289),
    [sym_integer_literal] = STATE(289),
    [sym_string_literal] = STATE(289),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(289),
    [sym_unary_expression] = STATE(386),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(289),
    [sym__value] = STATE(289),
    [sym_parenthesized_expression] = STATE(289),
    [sym_sub_expression] = STATE(289),
    [sym_array_expression] = STATE(289),
    [sym_script_block_expression] = STATE(289),
    [sym_hash_literal_expression] = STATE(289),
    [sym_post_increment_expression] = STATE(289),
    [sym_post_decrement_expression] = STATE(289),
    [sym_member_access] = STATE(289),
    [sym_element_access] = STATE(289),
    [sym_invokation_expression] = STATE(289),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_argument_expression_list] = STATE(1732),
    [sym_argument_expression] = STATE(1490),
    [sym_logical_argument_expression] = STATE(1331),
    [sym_bitwise_argument_expression] = STATE(1332),
    [sym_comparison_argument_expression] = STATE(584),
    [sym_additive_argument_expression] = STATE(576),
    [sym_multiplicative_argument_expression] = STATE(430),
    [sym_format_argument_expression] = STATE(402),
    [sym_range_argument_expression] = STATE(380),
    [sym_type_literal] = STATE(76),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(121),
    [sym_real_literal] = ACTIONS(479),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(125),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(127),
    [sym_verbatim_string_characters] = ACTIONS(129),
    [sym_verbatim_here_string_characters] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_DASHjoin] = ACTIONS(483),
    [anon_sym_DASHsplit] = ACTIONS(483),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(135),
    [anon_sym_DOLLAR_CARET] = ACTIONS(135),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(135),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(135),
    [sym_braced_variable] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(1367),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(485),
    [anon_sym_DASHnot] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_DASHbnot] = ACTIONS(483),
    [anon_sym_PLUS_PLUS] = ACTIONS(487),
    [anon_sym_DASH_DASH] = ACTIONS(489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_AT_LBRACE] = ACTIONS(153),
  },
  [318] = {
    [sym_elseif_clause] = STATE(318),
    [aux_sym_elseif_clauses_repeat1] = STATE(318),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1369),
    [sym_hexadecimal_integer_literal] = ACTIONS(1369),
    [sym_real_literal] = ACTIONS(1369),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1369),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1369),
    [sym_verbatim_string_characters] = ACTIONS(1369),
    [sym_verbatim_here_string_characters] = ACTIONS(1369),
    [anon_sym_DOT] = ACTIONS(1369),
    [anon_sym_LBRACK] = ACTIONS(1369),
    [anon_sym_DASHjoin] = ACTIONS(1369),
    [anon_sym_DASHsplit] = ACTIONS(1369),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1369),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1369),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1369),
    [anon_sym_DOLLAR_] = ACTIONS(1369),
    [aux_sym_variable_token1] = ACTIONS(1369),
    [aux_sym_variable_token2] = ACTIONS(1369),
    [sym_braced_variable] = ACTIONS(1369),
    [anon_sym_SEMI] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(1369),
    [anon_sym_RPAREN] = ACTIONS(1369),
    [anon_sym_COMMA] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1369),
    [anon_sym_RBRACE] = ACTIONS(1369),
    [anon_sym_if] = ACTIONS(1369),
    [anon_sym_elseif] = ACTIONS(1371),
    [anon_sym_else] = ACTIONS(1369),
    [anon_sym_switch] = ACTIONS(1369),
    [anon_sym_foreach] = ACTIONS(1369),
    [anon_sym_for] = ACTIONS(1369),
    [anon_sym_while] = ACTIONS(1369),
    [anon_sym_do] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(1369),
    [anon_sym_filter] = ACTIONS(1369),
    [anon_sym_workflow] = ACTIONS(1369),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_continue] = ACTIONS(1369),
    [anon_sym_throw] = ACTIONS(1369),
    [anon_sym_return] = ACTIONS(1369),
    [anon_sym_exit] = ACTIONS(1369),
    [sym_label] = ACTIONS(1369),
    [anon_sym_trap] = ACTIONS(1369),
    [anon_sym_try] = ACTIONS(1369),
    [anon_sym_data] = ACTIONS(1369),
    [anon_sym_inlinescript] = ACTIONS(1369),
    [anon_sym_parallel] = ACTIONS(1369),
    [anon_sym_sequence] = ACTIONS(1369),
    [anon_sym_AMP] = ACTIONS(1369),
    [aux_sym_command_name_token1] = ACTIONS(1369),
    [anon_sym_PERCENT] = ACTIONS(1369),
    [anon_sym_foreach_DASHobject] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(1369),
    [anon_sym_enum] = ACTIONS(1369),
    [anon_sym_PLUS] = ACTIONS(1369),
    [anon_sym_DASH] = ACTIONS(1369),
    [anon_sym_DASHnot] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_DASHbnot] = ACTIONS(1369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1369),
    [anon_sym_DASH_DASH] = ACTIONS(1369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1369),
    [anon_sym_AT_LPAREN] = ACTIONS(1369),
    [anon_sym_AT_LBRACE] = ACTIONS(1369),
  },
  [319] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_DASHas] = ACTIONS(803),
    [anon_sym_DASHccontains] = ACTIONS(803),
    [anon_sym_DASHceq] = ACTIONS(803),
    [anon_sym_DASHcge] = ACTIONS(803),
    [anon_sym_DASHcgt] = ACTIONS(803),
    [anon_sym_DASHcle] = ACTIONS(803),
    [anon_sym_DASHclike] = ACTIONS(803),
    [anon_sym_DASHclt] = ACTIONS(803),
    [anon_sym_DASHcmatch] = ACTIONS(803),
    [anon_sym_DASHcne] = ACTIONS(803),
    [anon_sym_DASHcnotcontains] = ACTIONS(803),
    [anon_sym_DASHcnotlike] = ACTIONS(803),
    [anon_sym_DASHcnotmatch] = ACTIONS(803),
    [anon_sym_DASHcontains] = ACTIONS(803),
    [anon_sym_DASHcreplace] = ACTIONS(803),
    [anon_sym_DASHcsplit] = ACTIONS(803),
    [anon_sym_DASHeq] = ACTIONS(803),
    [anon_sym_DASHge] = ACTIONS(803),
    [anon_sym_DASHgt] = ACTIONS(803),
    [anon_sym_DASHicontains] = ACTIONS(803),
    [anon_sym_DASHieq] = ACTIONS(803),
    [anon_sym_DASHige] = ACTIONS(803),
    [anon_sym_DASHigt] = ACTIONS(803),
    [anon_sym_DASHile] = ACTIONS(803),
    [anon_sym_DASHilike] = ACTIONS(803),
    [anon_sym_DASHilt] = ACTIONS(803),
    [anon_sym_DASHimatch] = ACTIONS(803),
    [anon_sym_DASHin] = ACTIONS(805),
    [anon_sym_DASHine] = ACTIONS(803),
    [anon_sym_DASHinotcontains] = ACTIONS(803),
    [anon_sym_DASHinotlike] = ACTIONS(803),
    [anon_sym_DASHinotmatch] = ACTIONS(803),
    [anon_sym_DASHireplace] = ACTIONS(803),
    [anon_sym_DASHis] = ACTIONS(805),
    [anon_sym_DASHisnot] = ACTIONS(803),
    [anon_sym_DASHisplit] = ACTIONS(803),
    [anon_sym_DASHjoin] = ACTIONS(803),
    [anon_sym_DASHle] = ACTIONS(803),
    [anon_sym_DASHlike] = ACTIONS(803),
    [anon_sym_DASHlt] = ACTIONS(803),
    [anon_sym_DASHmatch] = ACTIONS(803),
    [anon_sym_DASHne] = ACTIONS(803),
    [anon_sym_DASHnotcontains] = ACTIONS(803),
    [anon_sym_DASHnotin] = ACTIONS(803),
    [anon_sym_DASHnotlike] = ACTIONS(803),
    [anon_sym_DASHnotmatch] = ACTIONS(803),
    [anon_sym_DASHreplace] = ACTIONS(803),
    [anon_sym_DASHshl] = ACTIONS(803),
    [anon_sym_DASHshr] = ACTIONS(803),
    [anon_sym_DASHsplit] = ACTIONS(803),
    [sym_format_operator] = ACTIONS(1365),
    [anon_sym_RPAREN] = ACTIONS(803),
    [anon_sym_COMMA] = ACTIONS(803),
    [anon_sym_PERCENT] = ACTIONS(803),
    [anon_sym_DASHand] = ACTIONS(803),
    [anon_sym_DASHor] = ACTIONS(803),
    [anon_sym_DASHxor] = ACTIONS(803),
    [anon_sym_DASHband] = ACTIONS(803),
    [anon_sym_DASHbor] = ACTIONS(803),
    [anon_sym_DASHbxor] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_DASH] = ACTIONS(805),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_BSLASH] = ACTIONS(803),
    [anon_sym_STAR] = ACTIONS(803),
  },
  [320] = {
    [aux_sym_command_argument_sep_repeat1] = STATE(322),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1341),
    [sym_hexadecimal_integer_literal] = ACTIONS(1341),
    [sym_real_literal] = ACTIONS(1341),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1341),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1341),
    [sym_verbatim_string_characters] = ACTIONS(1341),
    [sym_verbatim_here_string_characters] = ACTIONS(1341),
    [anon_sym_LBRACK] = ACTIONS(1341),
    [anon_sym_GT] = ACTIONS(1341),
    [anon_sym_GT_GT] = ACTIONS(1341),
    [anon_sym_2_GT] = ACTIONS(1341),
    [anon_sym_2_GT_GT] = ACTIONS(1341),
    [anon_sym_3_GT] = ACTIONS(1341),
    [anon_sym_3_GT_GT] = ACTIONS(1341),
    [anon_sym_4_GT] = ACTIONS(1341),
    [anon_sym_4_GT_GT] = ACTIONS(1341),
    [anon_sym_5_GT] = ACTIONS(1341),
    [anon_sym_5_GT_GT] = ACTIONS(1341),
    [anon_sym_6_GT] = ACTIONS(1341),
    [anon_sym_6_GT_GT] = ACTIONS(1341),
    [anon_sym_STAR_GT] = ACTIONS(1341),
    [anon_sym_STAR_GT_GT] = ACTIONS(1341),
    [anon_sym_LT] = ACTIONS(1341),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(1341),
    [anon_sym_2_GT_AMP1] = ACTIONS(1341),
    [anon_sym_3_GT_AMP1] = ACTIONS(1341),
    [anon_sym_4_GT_AMP1] = ACTIONS(1341),
    [anon_sym_5_GT_AMP1] = ACTIONS(1341),
    [anon_sym_6_GT_AMP1] = ACTIONS(1341),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(1341),
    [anon_sym_1_GT_AMP2] = ACTIONS(1341),
    [anon_sym_3_GT_AMP2] = ACTIONS(1341),
    [anon_sym_4_GT_AMP2] = ACTIONS(1341),
    [anon_sym_5_GT_AMP2] = ACTIONS(1341),
    [anon_sym_6_GT_AMP2] = ACTIONS(1341),
    [anon_sym_DASHjoin] = ACTIONS(1341),
    [anon_sym_DASHsplit] = ACTIONS(1341),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1341),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1341),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1341),
    [anon_sym_DOLLAR_] = ACTIONS(1341),
    [aux_sym_variable_token1] = ACTIONS(1341),
    [aux_sym_variable_token2] = ACTIONS(1341),
    [sym_braced_variable] = ACTIONS(1341),
    [sym_generic_token] = ACTIONS(1341),
    [sym_command_parameter] = ACTIONS(1341),
    [anon_sym_LPAREN] = ACTIONS(1341),
    [anon_sym_COMMA] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1341),
    [anon_sym_PIPE] = ACTIONS(1341),
    [sym_stop_parsing] = ACTIONS(1341),
    [anon_sym_SPACE] = ACTIONS(1374),
    [anon_sym_COLON] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_DASHnot] = ACTIONS(1341),
    [anon_sym_BANG] = ACTIONS(1341),
    [anon_sym_DASHbnot] = ACTIONS(1341),
    [anon_sym_PLUS_PLUS] = ACTIONS(1341),
    [anon_sym_DASH_DASH] = ACTIONS(1341),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1341),
    [anon_sym_AT_LPAREN] = ACTIONS(1341),
    [anon_sym_AT_LBRACE] = ACTIONS(1341),
    [sym__statement_terminator] = ACTIONS(1345),
  },
  [321] = {
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1341),
    [sym_hexadecimal_integer_literal] = ACTIONS(1341),
    [sym_real_literal] = ACTIONS(1341),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1341),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1341),
    [sym_verbatim_string_characters] = ACTIONS(1341),
    [sym_verbatim_here_string_characters] = ACTIONS(1341),
    [anon_sym_LBRACK] = ACTIONS(1341),
    [anon_sym_GT] = ACTIONS(1341),
    [anon_sym_GT_GT] = ACTIONS(1341),
    [anon_sym_2_GT] = ACTIONS(1341),
    [anon_sym_2_GT_GT] = ACTIONS(1341),
    [anon_sym_3_GT] = ACTIONS(1341),
    [anon_sym_3_GT_GT] = ACTIONS(1341),
    [anon_sym_4_GT] = ACTIONS(1341),
    [anon_sym_4_GT_GT] = ACTIONS(1341),
    [anon_sym_5_GT] = ACTIONS(1341),
    [anon_sym_5_GT_GT] = ACTIONS(1341),
    [anon_sym_6_GT] = ACTIONS(1341),
    [anon_sym_6_GT_GT] = ACTIONS(1341),
    [anon_sym_STAR_GT] = ACTIONS(1341),
    [anon_sym_STAR_GT_GT] = ACTIONS(1341),
    [anon_sym_LT] = ACTIONS(1341),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(1341),
    [anon_sym_2_GT_AMP1] = ACTIONS(1341),
    [anon_sym_3_GT_AMP1] = ACTIONS(1341),
    [anon_sym_4_GT_AMP1] = ACTIONS(1341),
    [anon_sym_5_GT_AMP1] = ACTIONS(1341),
    [anon_sym_6_GT_AMP1] = ACTIONS(1341),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(1341),
    [anon_sym_1_GT_AMP2] = ACTIONS(1341),
    [anon_sym_3_GT_AMP2] = ACTIONS(1341),
    [anon_sym_4_GT_AMP2] = ACTIONS(1341),
    [anon_sym_5_GT_AMP2] = ACTIONS(1341),
    [anon_sym_6_GT_AMP2] = ACTIONS(1341),
    [anon_sym_DASHjoin] = ACTIONS(1341),
    [anon_sym_DASHsplit] = ACTIONS(1341),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1341),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1341),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1341),
    [anon_sym_DOLLAR_] = ACTIONS(1341),
    [aux_sym_variable_token1] = ACTIONS(1341),
    [aux_sym_variable_token2] = ACTIONS(1341),
    [sym_braced_variable] = ACTIONS(1341),
    [sym_generic_token] = ACTIONS(1341),
    [sym_command_parameter] = ACTIONS(1341),
    [anon_sym_LPAREN] = ACTIONS(1341),
    [anon_sym_RPAREN] = ACTIONS(1341),
    [anon_sym_COMMA] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1341),
    [anon_sym_PIPE] = ACTIONS(1341),
    [sym_stop_parsing] = ACTIONS(1341),
    [anon_sym_SPACE] = ACTIONS(1341),
    [anon_sym_COLON] = ACTIONS(1341),
    [anon_sym_DASH_DASH_PERCENT] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_DASHnot] = ACTIONS(1341),
    [anon_sym_BANG] = ACTIONS(1341),
    [anon_sym_DASHbnot] = ACTIONS(1341),
    [anon_sym_PLUS_PLUS] = ACTIONS(1341),
    [anon_sym_DASH_DASH] = ACTIONS(1341),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1341),
    [anon_sym_AT_LPAREN] = ACTIONS(1341),
    [anon_sym_AT_LBRACE] = ACTIONS(1341),
  },
  [322] = {
    [aux_sym_command_argument_sep_repeat1] = STATE(322),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1325),
    [sym_hexadecimal_integer_literal] = ACTIONS(1325),
    [sym_real_literal] = ACTIONS(1325),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1325),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1325),
    [sym_verbatim_string_characters] = ACTIONS(1325),
    [sym_verbatim_here_string_characters] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(1325),
    [anon_sym_GT] = ACTIONS(1325),
    [anon_sym_GT_GT] = ACTIONS(1325),
    [anon_sym_2_GT] = ACTIONS(1325),
    [anon_sym_2_GT_GT] = ACTIONS(1325),
    [anon_sym_3_GT] = ACTIONS(1325),
    [anon_sym_3_GT_GT] = ACTIONS(1325),
    [anon_sym_4_GT] = ACTIONS(1325),
    [anon_sym_4_GT_GT] = ACTIONS(1325),
    [anon_sym_5_GT] = ACTIONS(1325),
    [anon_sym_5_GT_GT] = ACTIONS(1325),
    [anon_sym_6_GT] = ACTIONS(1325),
    [anon_sym_6_GT_GT] = ACTIONS(1325),
    [anon_sym_STAR_GT] = ACTIONS(1325),
    [anon_sym_STAR_GT_GT] = ACTIONS(1325),
    [anon_sym_LT] = ACTIONS(1325),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(1325),
    [anon_sym_2_GT_AMP1] = ACTIONS(1325),
    [anon_sym_3_GT_AMP1] = ACTIONS(1325),
    [anon_sym_4_GT_AMP1] = ACTIONS(1325),
    [anon_sym_5_GT_AMP1] = ACTIONS(1325),
    [anon_sym_6_GT_AMP1] = ACTIONS(1325),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(1325),
    [anon_sym_1_GT_AMP2] = ACTIONS(1325),
    [anon_sym_3_GT_AMP2] = ACTIONS(1325),
    [anon_sym_4_GT_AMP2] = ACTIONS(1325),
    [anon_sym_5_GT_AMP2] = ACTIONS(1325),
    [anon_sym_6_GT_AMP2] = ACTIONS(1325),
    [anon_sym_DASHjoin] = ACTIONS(1325),
    [anon_sym_DASHsplit] = ACTIONS(1325),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1325),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1325),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1325),
    [anon_sym_DOLLAR_] = ACTIONS(1325),
    [aux_sym_variable_token1] = ACTIONS(1325),
    [aux_sym_variable_token2] = ACTIONS(1325),
    [sym_braced_variable] = ACTIONS(1325),
    [sym_generic_token] = ACTIONS(1325),
    [sym_command_parameter] = ACTIONS(1325),
    [anon_sym_LPAREN] = ACTIONS(1325),
    [anon_sym_COMMA] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_PIPE] = ACTIONS(1325),
    [sym_stop_parsing] = ACTIONS(1325),
    [anon_sym_SPACE] = ACTIONS(1376),
    [anon_sym_COLON] = ACTIONS(1325),
    [anon_sym_PLUS] = ACTIONS(1325),
    [anon_sym_DASH] = ACTIONS(1325),
    [anon_sym_DASHnot] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1325),
    [anon_sym_DASHbnot] = ACTIONS(1325),
    [anon_sym_PLUS_PLUS] = ACTIONS(1325),
    [anon_sym_DASH_DASH] = ACTIONS(1325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1325),
    [anon_sym_AT_LPAREN] = ACTIONS(1325),
    [anon_sym_AT_LBRACE] = ACTIONS(1325),
    [sym__statement_terminator] = ACTIONS(1339),
  },
  [323] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_DASHas] = ACTIONS(785),
    [anon_sym_DASHccontains] = ACTIONS(785),
    [anon_sym_DASHceq] = ACTIONS(785),
    [anon_sym_DASHcge] = ACTIONS(785),
    [anon_sym_DASHcgt] = ACTIONS(785),
    [anon_sym_DASHcle] = ACTIONS(785),
    [anon_sym_DASHclike] = ACTIONS(785),
    [anon_sym_DASHclt] = ACTIONS(785),
    [anon_sym_DASHcmatch] = ACTIONS(785),
    [anon_sym_DASHcne] = ACTIONS(785),
    [anon_sym_DASHcnotcontains] = ACTIONS(785),
    [anon_sym_DASHcnotlike] = ACTIONS(785),
    [anon_sym_DASHcnotmatch] = ACTIONS(785),
    [anon_sym_DASHcontains] = ACTIONS(785),
    [anon_sym_DASHcreplace] = ACTIONS(785),
    [anon_sym_DASHcsplit] = ACTIONS(785),
    [anon_sym_DASHeq] = ACTIONS(785),
    [anon_sym_DASHge] = ACTIONS(785),
    [anon_sym_DASHgt] = ACTIONS(785),
    [anon_sym_DASHicontains] = ACTIONS(785),
    [anon_sym_DASHieq] = ACTIONS(785),
    [anon_sym_DASHige] = ACTIONS(785),
    [anon_sym_DASHigt] = ACTIONS(785),
    [anon_sym_DASHile] = ACTIONS(785),
    [anon_sym_DASHilike] = ACTIONS(785),
    [anon_sym_DASHilt] = ACTIONS(785),
    [anon_sym_DASHimatch] = ACTIONS(785),
    [anon_sym_DASHin] = ACTIONS(787),
    [anon_sym_DASHine] = ACTIONS(785),
    [anon_sym_DASHinotcontains] = ACTIONS(785),
    [anon_sym_DASHinotlike] = ACTIONS(785),
    [anon_sym_DASHinotmatch] = ACTIONS(785),
    [anon_sym_DASHireplace] = ACTIONS(785),
    [anon_sym_DASHis] = ACTIONS(787),
    [anon_sym_DASHisnot] = ACTIONS(785),
    [anon_sym_DASHisplit] = ACTIONS(785),
    [anon_sym_DASHjoin] = ACTIONS(785),
    [anon_sym_DASHle] = ACTIONS(785),
    [anon_sym_DASHlike] = ACTIONS(785),
    [anon_sym_DASHlt] = ACTIONS(785),
    [anon_sym_DASHmatch] = ACTIONS(785),
    [anon_sym_DASHne] = ACTIONS(785),
    [anon_sym_DASHnotcontains] = ACTIONS(785),
    [anon_sym_DASHnotin] = ACTIONS(785),
    [anon_sym_DASHnotlike] = ACTIONS(785),
    [anon_sym_DASHnotmatch] = ACTIONS(785),
    [anon_sym_DASHreplace] = ACTIONS(785),
    [anon_sym_DASHshl] = ACTIONS(785),
    [anon_sym_DASHshr] = ACTIONS(785),
    [anon_sym_DASHsplit] = ACTIONS(785),
    [sym_format_operator] = ACTIONS(785),
    [anon_sym_PERCENT] = ACTIONS(785),
    [anon_sym_DASHand] = ACTIONS(785),
    [anon_sym_DASHor] = ACTIONS(785),
    [anon_sym_DASHxor] = ACTIONS(785),
    [anon_sym_DASHband] = ACTIONS(785),
    [anon_sym_DASHbor] = ACTIONS(785),
    [anon_sym_DASHbxor] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(785),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(785),
    [anon_sym_BSLASH] = ACTIONS(785),
    [anon_sym_STAR] = ACTIONS(785),
    [anon_sym_DOT_DOT] = ACTIONS(1379),
    [anon_sym_RBRACK] = ACTIONS(785),
  },
  [324] = {
    [sym_catch_clause] = STATE(332),
    [aux_sym_catch_clauses_repeat1] = STATE(332),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1381),
    [sym_hexadecimal_integer_literal] = ACTIONS(1381),
    [sym_real_literal] = ACTIONS(1381),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1381),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1381),
    [sym_verbatim_string_characters] = ACTIONS(1381),
    [sym_verbatim_here_string_characters] = ACTIONS(1381),
    [anon_sym_DOT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1381),
    [anon_sym_DASHjoin] = ACTIONS(1381),
    [anon_sym_DASHsplit] = ACTIONS(1381),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1381),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1381),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1381),
    [anon_sym_DOLLAR_] = ACTIONS(1381),
    [aux_sym_variable_token1] = ACTIONS(1381),
    [aux_sym_variable_token2] = ACTIONS(1381),
    [sym_braced_variable] = ACTIONS(1381),
    [anon_sym_SEMI] = ACTIONS(1381),
    [anon_sym_LPAREN] = ACTIONS(1381),
    [anon_sym_RPAREN] = ACTIONS(1381),
    [anon_sym_COMMA] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(1381),
    [anon_sym_RBRACE] = ACTIONS(1381),
    [anon_sym_if] = ACTIONS(1381),
    [anon_sym_switch] = ACTIONS(1381),
    [anon_sym_foreach] = ACTIONS(1381),
    [anon_sym_for] = ACTIONS(1381),
    [anon_sym_while] = ACTIONS(1381),
    [anon_sym_do] = ACTIONS(1381),
    [anon_sym_function] = ACTIONS(1381),
    [anon_sym_filter] = ACTIONS(1381),
    [anon_sym_workflow] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1381),
    [anon_sym_continue] = ACTIONS(1381),
    [anon_sym_throw] = ACTIONS(1381),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_exit] = ACTIONS(1381),
    [sym_label] = ACTIONS(1381),
    [anon_sym_trap] = ACTIONS(1381),
    [anon_sym_try] = ACTIONS(1381),
    [anon_sym_catch] = ACTIONS(1315),
    [anon_sym_finally] = ACTIONS(1381),
    [anon_sym_data] = ACTIONS(1381),
    [anon_sym_inlinescript] = ACTIONS(1381),
    [anon_sym_parallel] = ACTIONS(1381),
    [anon_sym_sequence] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [aux_sym_command_name_token1] = ACTIONS(1381),
    [anon_sym_PERCENT] = ACTIONS(1381),
    [anon_sym_foreach_DASHobject] = ACTIONS(1381),
    [anon_sym_class] = ACTIONS(1381),
    [anon_sym_enum] = ACTIONS(1381),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASHnot] = ACTIONS(1381),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_DASHbnot] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1381),
    [anon_sym_AT_LPAREN] = ACTIONS(1381),
    [anon_sym_AT_LBRACE] = ACTIONS(1381),
  },
  [325] = {
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1383),
    [sym_hexadecimal_integer_literal] = ACTIONS(1383),
    [sym_real_literal] = ACTIONS(1383),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1383),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1383),
    [sym_verbatim_string_characters] = ACTIONS(1383),
    [sym_verbatim_here_string_characters] = ACTIONS(1383),
    [anon_sym_DOT] = ACTIONS(1383),
    [anon_sym_LBRACK] = ACTIONS(1383),
    [anon_sym_DASHjoin] = ACTIONS(1383),
    [anon_sym_DASHsplit] = ACTIONS(1383),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1383),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1383),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1383),
    [anon_sym_DOLLAR_] = ACTIONS(1383),
    [aux_sym_variable_token1] = ACTIONS(1383),
    [aux_sym_variable_token2] = ACTIONS(1383),
    [sym_braced_variable] = ACTIONS(1383),
    [anon_sym_SEMI] = ACTIONS(1383),
    [anon_sym_param] = ACTIONS(1383),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_COMMA] = ACTIONS(1383),
    [anon_sym_dynamicparam] = ACTIONS(1383),
    [anon_sym_begin] = ACTIONS(1383),
    [anon_sym_process] = ACTIONS(1383),
    [anon_sym_end] = ACTIONS(1383),
    [anon_sym_LBRACE] = ACTIONS(1383),
    [anon_sym_if] = ACTIONS(1383),
    [anon_sym_switch] = ACTIONS(1383),
    [anon_sym_foreach] = ACTIONS(1383),
    [anon_sym_for] = ACTIONS(1383),
    [anon_sym_while] = ACTIONS(1383),
    [anon_sym_do] = ACTIONS(1383),
    [anon_sym_function] = ACTIONS(1383),
    [anon_sym_filter] = ACTIONS(1383),
    [anon_sym_workflow] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1383),
    [anon_sym_continue] = ACTIONS(1383),
    [anon_sym_throw] = ACTIONS(1383),
    [anon_sym_return] = ACTIONS(1383),
    [anon_sym_exit] = ACTIONS(1383),
    [sym_label] = ACTIONS(1383),
    [anon_sym_trap] = ACTIONS(1383),
    [anon_sym_try] = ACTIONS(1383),
    [anon_sym_data] = ACTIONS(1383),
    [anon_sym_inlinescript] = ACTIONS(1383),
    [anon_sym_parallel] = ACTIONS(1383),
    [anon_sym_sequence] = ACTIONS(1383),
    [anon_sym_AMP] = ACTIONS(1383),
    [aux_sym_command_name_token1] = ACTIONS(1383),
    [anon_sym_PERCENT] = ACTIONS(1383),
    [anon_sym_foreach_DASHobject] = ACTIONS(1383),
    [anon_sym_class] = ACTIONS(1383),
    [anon_sym_enum] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1383),
    [anon_sym_DASH] = ACTIONS(1383),
    [anon_sym_DASHnot] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_DASHbnot] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1383),
    [anon_sym_AT_LPAREN] = ACTIONS(1383),
    [anon_sym_AT_LBRACE] = ACTIONS(1383),
    [sym__statement_terminator] = ACTIONS(1385),
  },
  [326] = {
    [aux_sym_script_block_repeat1] = STATE(326),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1387),
    [sym_hexadecimal_integer_literal] = ACTIONS(1387),
    [sym_real_literal] = ACTIONS(1387),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1387),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1387),
    [sym_verbatim_string_characters] = ACTIONS(1387),
    [sym_verbatim_here_string_characters] = ACTIONS(1387),
    [anon_sym_DOT] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1387),
    [anon_sym_DASHjoin] = ACTIONS(1387),
    [anon_sym_DASHsplit] = ACTIONS(1387),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1387),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1387),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1387),
    [anon_sym_DOLLAR_] = ACTIONS(1387),
    [aux_sym_variable_token1] = ACTIONS(1387),
    [aux_sym_variable_token2] = ACTIONS(1387),
    [sym_braced_variable] = ACTIONS(1387),
    [anon_sym_SEMI] = ACTIONS(1389),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_COMMA] = ACTIONS(1387),
    [anon_sym_dynamicparam] = ACTIONS(1387),
    [anon_sym_begin] = ACTIONS(1387),
    [anon_sym_process] = ACTIONS(1387),
    [anon_sym_end] = ACTIONS(1387),
    [anon_sym_LBRACE] = ACTIONS(1387),
    [anon_sym_RBRACE] = ACTIONS(1387),
    [anon_sym_if] = ACTIONS(1387),
    [anon_sym_switch] = ACTIONS(1387),
    [anon_sym_foreach] = ACTIONS(1387),
    [anon_sym_for] = ACTIONS(1387),
    [anon_sym_while] = ACTIONS(1387),
    [anon_sym_do] = ACTIONS(1387),
    [anon_sym_function] = ACTIONS(1387),
    [anon_sym_filter] = ACTIONS(1387),
    [anon_sym_workflow] = ACTIONS(1387),
    [anon_sym_break] = ACTIONS(1387),
    [anon_sym_continue] = ACTIONS(1387),
    [anon_sym_throw] = ACTIONS(1387),
    [anon_sym_return] = ACTIONS(1387),
    [anon_sym_exit] = ACTIONS(1387),
    [sym_label] = ACTIONS(1387),
    [anon_sym_trap] = ACTIONS(1387),
    [anon_sym_try] = ACTIONS(1387),
    [anon_sym_data] = ACTIONS(1387),
    [anon_sym_inlinescript] = ACTIONS(1387),
    [anon_sym_parallel] = ACTIONS(1387),
    [anon_sym_sequence] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [aux_sym_command_name_token1] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_foreach_DASHobject] = ACTIONS(1387),
    [anon_sym_class] = ACTIONS(1387),
    [anon_sym_enum] = ACTIONS(1387),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_DASHnot] = ACTIONS(1387),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_DASHbnot] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1387),
    [anon_sym_AT_LPAREN] = ACTIONS(1387),
    [anon_sym_AT_LBRACE] = ACTIONS(1387),
  },
  [327] = {
    [sym_elseif_clause] = STATE(318),
    [aux_sym_elseif_clauses_repeat1] = STATE(318),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1392),
    [sym_hexadecimal_integer_literal] = ACTIONS(1392),
    [sym_real_literal] = ACTIONS(1392),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1392),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1392),
    [sym_verbatim_string_characters] = ACTIONS(1392),
    [sym_verbatim_here_string_characters] = ACTIONS(1392),
    [anon_sym_DOT] = ACTIONS(1392),
    [anon_sym_LBRACK] = ACTIONS(1392),
    [anon_sym_DASHjoin] = ACTIONS(1392),
    [anon_sym_DASHsplit] = ACTIONS(1392),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1392),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1392),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1392),
    [anon_sym_DOLLAR_] = ACTIONS(1392),
    [aux_sym_variable_token1] = ACTIONS(1392),
    [aux_sym_variable_token2] = ACTIONS(1392),
    [sym_braced_variable] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(1392),
    [anon_sym_RPAREN] = ACTIONS(1392),
    [anon_sym_COMMA] = ACTIONS(1392),
    [anon_sym_LBRACE] = ACTIONS(1392),
    [anon_sym_RBRACE] = ACTIONS(1392),
    [anon_sym_if] = ACTIONS(1392),
    [anon_sym_elseif] = ACTIONS(1321),
    [anon_sym_else] = ACTIONS(1392),
    [anon_sym_switch] = ACTIONS(1392),
    [anon_sym_foreach] = ACTIONS(1392),
    [anon_sym_for] = ACTIONS(1392),
    [anon_sym_while] = ACTIONS(1392),
    [anon_sym_do] = ACTIONS(1392),
    [anon_sym_function] = ACTIONS(1392),
    [anon_sym_filter] = ACTIONS(1392),
    [anon_sym_workflow] = ACTIONS(1392),
    [anon_sym_break] = ACTIONS(1392),
    [anon_sym_continue] = ACTIONS(1392),
    [anon_sym_throw] = ACTIONS(1392),
    [anon_sym_return] = ACTIONS(1392),
    [anon_sym_exit] = ACTIONS(1392),
    [sym_label] = ACTIONS(1392),
    [anon_sym_trap] = ACTIONS(1392),
    [anon_sym_try] = ACTIONS(1392),
    [anon_sym_data] = ACTIONS(1392),
    [anon_sym_inlinescript] = ACTIONS(1392),
    [anon_sym_parallel] = ACTIONS(1392),
    [anon_sym_sequence] = ACTIONS(1392),
    [anon_sym_AMP] = ACTIONS(1392),
    [aux_sym_command_name_token1] = ACTIONS(1392),
    [anon_sym_PERCENT] = ACTIONS(1392),
    [anon_sym_foreach_DASHobject] = ACTIONS(1392),
    [anon_sym_class] = ACTIONS(1392),
    [anon_sym_enum] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASHnot] = ACTIONS(1392),
    [anon_sym_BANG] = ACTIONS(1392),
    [anon_sym_DASHbnot] = ACTIONS(1392),
    [anon_sym_PLUS_PLUS] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1392),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1392),
    [anon_sym_AT_LPAREN] = ACTIONS(1392),
    [anon_sym_AT_LBRACE] = ACTIONS(1392),
  },
  [328] = {
    [sym__literal] = STATE(289),
    [sym_integer_literal] = STATE(289),
    [sym_string_literal] = STATE(289),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(289),
    [sym_unary_expression] = STATE(386),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(289),
    [sym__value] = STATE(289),
    [sym_parenthesized_expression] = STATE(289),
    [sym_sub_expression] = STATE(289),
    [sym_array_expression] = STATE(289),
    [sym_script_block_expression] = STATE(289),
    [sym_hash_literal_expression] = STATE(289),
    [sym_post_increment_expression] = STATE(289),
    [sym_post_decrement_expression] = STATE(289),
    [sym_member_access] = STATE(289),
    [sym_element_access] = STATE(289),
    [sym_invokation_expression] = STATE(289),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_argument_expression_list] = STATE(1866),
    [sym_argument_expression] = STATE(1490),
    [sym_logical_argument_expression] = STATE(1331),
    [sym_bitwise_argument_expression] = STATE(1332),
    [sym_comparison_argument_expression] = STATE(584),
    [sym_additive_argument_expression] = STATE(576),
    [sym_multiplicative_argument_expression] = STATE(430),
    [sym_format_argument_expression] = STATE(402),
    [sym_range_argument_expression] = STATE(380),
    [sym_type_literal] = STATE(76),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(121),
    [sym_real_literal] = ACTIONS(479),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(125),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(127),
    [sym_verbatim_string_characters] = ACTIONS(129),
    [sym_verbatim_here_string_characters] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_DASHjoin] = ACTIONS(483),
    [anon_sym_DASHsplit] = ACTIONS(483),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(135),
    [anon_sym_DOLLAR_CARET] = ACTIONS(135),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(135),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(135),
    [sym_braced_variable] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(1394),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(485),
    [anon_sym_DASHnot] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_DASHbnot] = ACTIONS(483),
    [anon_sym_PLUS_PLUS] = ACTIONS(487),
    [anon_sym_DASH_DASH] = ACTIONS(489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_AT_LBRACE] = ACTIONS(153),
  },
  [329] = {
    [sym__literal] = STATE(289),
    [sym_integer_literal] = STATE(289),
    [sym_string_literal] = STATE(289),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(289),
    [sym_unary_expression] = STATE(386),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(289),
    [sym__value] = STATE(289),
    [sym_parenthesized_expression] = STATE(289),
    [sym_sub_expression] = STATE(289),
    [sym_array_expression] = STATE(289),
    [sym_script_block_expression] = STATE(289),
    [sym_hash_literal_expression] = STATE(289),
    [sym_post_increment_expression] = STATE(289),
    [sym_post_decrement_expression] = STATE(289),
    [sym_member_access] = STATE(289),
    [sym_element_access] = STATE(289),
    [sym_invokation_expression] = STATE(289),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_argument_expression_list] = STATE(1755),
    [sym_argument_expression] = STATE(1490),
    [sym_logical_argument_expression] = STATE(1331),
    [sym_bitwise_argument_expression] = STATE(1332),
    [sym_comparison_argument_expression] = STATE(584),
    [sym_additive_argument_expression] = STATE(576),
    [sym_multiplicative_argument_expression] = STATE(430),
    [sym_format_argument_expression] = STATE(402),
    [sym_range_argument_expression] = STATE(380),
    [sym_type_literal] = STATE(76),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(121),
    [sym_real_literal] = ACTIONS(479),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(125),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(127),
    [sym_verbatim_string_characters] = ACTIONS(129),
    [sym_verbatim_here_string_characters] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_DASHjoin] = ACTIONS(483),
    [anon_sym_DASHsplit] = ACTIONS(483),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(135),
    [anon_sym_DOLLAR_CARET] = ACTIONS(135),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(135),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(135),
    [sym_braced_variable] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(1396),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(485),
    [anon_sym_DASHnot] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_DASHbnot] = ACTIONS(483),
    [anon_sym_PLUS_PLUS] = ACTIONS(487),
    [anon_sym_DASH_DASH] = ACTIONS(489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_AT_LBRACE] = ACTIONS(153),
  },
  [330] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_DASHas] = ACTIONS(785),
    [anon_sym_DASHccontains] = ACTIONS(785),
    [anon_sym_DASHceq] = ACTIONS(785),
    [anon_sym_DASHcge] = ACTIONS(785),
    [anon_sym_DASHcgt] = ACTIONS(785),
    [anon_sym_DASHcle] = ACTIONS(785),
    [anon_sym_DASHclike] = ACTIONS(785),
    [anon_sym_DASHclt] = ACTIONS(785),
    [anon_sym_DASHcmatch] = ACTIONS(785),
    [anon_sym_DASHcne] = ACTIONS(785),
    [anon_sym_DASHcnotcontains] = ACTIONS(785),
    [anon_sym_DASHcnotlike] = ACTIONS(785),
    [anon_sym_DASHcnotmatch] = ACTIONS(785),
    [anon_sym_DASHcontains] = ACTIONS(785),
    [anon_sym_DASHcreplace] = ACTIONS(785),
    [anon_sym_DASHcsplit] = ACTIONS(785),
    [anon_sym_DASHeq] = ACTIONS(785),
    [anon_sym_DASHge] = ACTIONS(785),
    [anon_sym_DASHgt] = ACTIONS(785),
    [anon_sym_DASHicontains] = ACTIONS(785),
    [anon_sym_DASHieq] = ACTIONS(785),
    [anon_sym_DASHige] = ACTIONS(785),
    [anon_sym_DASHigt] = ACTIONS(785),
    [anon_sym_DASHile] = ACTIONS(785),
    [anon_sym_DASHilike] = ACTIONS(785),
    [anon_sym_DASHilt] = ACTIONS(785),
    [anon_sym_DASHimatch] = ACTIONS(785),
    [anon_sym_DASHin] = ACTIONS(787),
    [anon_sym_DASHine] = ACTIONS(785),
    [anon_sym_DASHinotcontains] = ACTIONS(785),
    [anon_sym_DASHinotlike] = ACTIONS(785),
    [anon_sym_DASHinotmatch] = ACTIONS(785),
    [anon_sym_DASHireplace] = ACTIONS(785),
    [anon_sym_DASHis] = ACTIONS(787),
    [anon_sym_DASHisnot] = ACTIONS(785),
    [anon_sym_DASHisplit] = ACTIONS(785),
    [anon_sym_DASHjoin] = ACTIONS(785),
    [anon_sym_DASHle] = ACTIONS(785),
    [anon_sym_DASHlike] = ACTIONS(785),
    [anon_sym_DASHlt] = ACTIONS(785),
    [anon_sym_DASHmatch] = ACTIONS(785),
    [anon_sym_DASHne] = ACTIONS(785),
    [anon_sym_DASHnotcontains] = ACTIONS(785),
    [anon_sym_DASHnotin] = ACTIONS(785),
    [anon_sym_DASHnotlike] = ACTIONS(785),
    [anon_sym_DASHnotmatch] = ACTIONS(785),
    [anon_sym_DASHreplace] = ACTIONS(785),
    [anon_sym_DASHshl] = ACTIONS(785),
    [anon_sym_DASHshr] = ACTIONS(785),
    [anon_sym_DASHsplit] = ACTIONS(785),
    [sym_format_operator] = ACTIONS(785),
    [anon_sym_PERCENT] = ACTIONS(785),
    [anon_sym_DASHand] = ACTIONS(785),
    [anon_sym_DASHor] = ACTIONS(785),
    [anon_sym_DASHxor] = ACTIONS(785),
    [anon_sym_DASHband] = ACTIONS(785),
    [anon_sym_DASHbor] = ACTIONS(785),
    [anon_sym_DASHbxor] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(785),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(785),
    [anon_sym_BSLASH] = ACTIONS(785),
    [anon_sym_STAR] = ACTIONS(785),
    [anon_sym_DOT_DOT] = ACTIONS(1398),
    [sym__statement_terminator] = ACTIONS(785),
  },
  [331] = {
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1400),
    [sym_hexadecimal_integer_literal] = ACTIONS(1400),
    [sym_real_literal] = ACTIONS(1400),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1400),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1400),
    [sym_verbatim_string_characters] = ACTIONS(1400),
    [sym_verbatim_here_string_characters] = ACTIONS(1400),
    [anon_sym_DOT] = ACTIONS(1400),
    [anon_sym_LBRACK] = ACTIONS(1400),
    [anon_sym_DASHjoin] = ACTIONS(1400),
    [anon_sym_DASHsplit] = ACTIONS(1400),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1400),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1400),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1400),
    [anon_sym_DOLLAR_] = ACTIONS(1400),
    [aux_sym_variable_token1] = ACTIONS(1400),
    [aux_sym_variable_token2] = ACTIONS(1400),
    [sym_braced_variable] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_param] = ACTIONS(1400),
    [anon_sym_LPAREN] = ACTIONS(1400),
    [anon_sym_COMMA] = ACTIONS(1400),
    [anon_sym_dynamicparam] = ACTIONS(1400),
    [anon_sym_begin] = ACTIONS(1400),
    [anon_sym_process] = ACTIONS(1400),
    [anon_sym_end] = ACTIONS(1400),
    [anon_sym_LBRACE] = ACTIONS(1400),
    [anon_sym_if] = ACTIONS(1400),
    [anon_sym_switch] = ACTIONS(1400),
    [anon_sym_foreach] = ACTIONS(1400),
    [anon_sym_for] = ACTIONS(1400),
    [anon_sym_while] = ACTIONS(1400),
    [anon_sym_do] = ACTIONS(1400),
    [anon_sym_function] = ACTIONS(1400),
    [anon_sym_filter] = ACTIONS(1400),
    [anon_sym_workflow] = ACTIONS(1400),
    [anon_sym_break] = ACTIONS(1400),
    [anon_sym_continue] = ACTIONS(1400),
    [anon_sym_throw] = ACTIONS(1400),
    [anon_sym_return] = ACTIONS(1400),
    [anon_sym_exit] = ACTIONS(1400),
    [sym_label] = ACTIONS(1400),
    [anon_sym_trap] = ACTIONS(1400),
    [anon_sym_try] = ACTIONS(1400),
    [anon_sym_data] = ACTIONS(1400),
    [anon_sym_inlinescript] = ACTIONS(1400),
    [anon_sym_parallel] = ACTIONS(1400),
    [anon_sym_sequence] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1400),
    [aux_sym_command_name_token1] = ACTIONS(1400),
    [anon_sym_PERCENT] = ACTIONS(1400),
    [anon_sym_foreach_DASHobject] = ACTIONS(1400),
    [anon_sym_class] = ACTIONS(1400),
    [anon_sym_enum] = ACTIONS(1400),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_DASHnot] = ACTIONS(1400),
    [anon_sym_BANG] = ACTIONS(1400),
    [anon_sym_DASHbnot] = ACTIONS(1400),
    [anon_sym_PLUS_PLUS] = ACTIONS(1400),
    [anon_sym_DASH_DASH] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_AT_LPAREN] = ACTIONS(1400),
    [anon_sym_AT_LBRACE] = ACTIONS(1400),
    [sym__statement_terminator] = ACTIONS(1402),
  },
  [332] = {
    [sym_catch_clause] = STATE(332),
    [aux_sym_catch_clauses_repeat1] = STATE(332),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1404),
    [sym_hexadecimal_integer_literal] = ACTIONS(1404),
    [sym_real_literal] = ACTIONS(1404),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1404),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1404),
    [sym_verbatim_string_characters] = ACTIONS(1404),
    [sym_verbatim_here_string_characters] = ACTIONS(1404),
    [anon_sym_DOT] = ACTIONS(1404),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_DASHjoin] = ACTIONS(1404),
    [anon_sym_DASHsplit] = ACTIONS(1404),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1404),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1404),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1404),
    [anon_sym_DOLLAR_] = ACTIONS(1404),
    [aux_sym_variable_token1] = ACTIONS(1404),
    [aux_sym_variable_token2] = ACTIONS(1404),
    [sym_braced_variable] = ACTIONS(1404),
    [anon_sym_SEMI] = ACTIONS(1404),
    [anon_sym_LPAREN] = ACTIONS(1404),
    [anon_sym_RPAREN] = ACTIONS(1404),
    [anon_sym_COMMA] = ACTIONS(1404),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_RBRACE] = ACTIONS(1404),
    [anon_sym_if] = ACTIONS(1404),
    [anon_sym_switch] = ACTIONS(1404),
    [anon_sym_foreach] = ACTIONS(1404),
    [anon_sym_for] = ACTIONS(1404),
    [anon_sym_while] = ACTIONS(1404),
    [anon_sym_do] = ACTIONS(1404),
    [anon_sym_function] = ACTIONS(1404),
    [anon_sym_filter] = ACTIONS(1404),
    [anon_sym_workflow] = ACTIONS(1404),
    [anon_sym_break] = ACTIONS(1404),
    [anon_sym_continue] = ACTIONS(1404),
    [anon_sym_throw] = ACTIONS(1404),
    [anon_sym_return] = ACTIONS(1404),
    [anon_sym_exit] = ACTIONS(1404),
    [sym_label] = ACTIONS(1404),
    [anon_sym_trap] = ACTIONS(1404),
    [anon_sym_try] = ACTIONS(1404),
    [anon_sym_catch] = ACTIONS(1406),
    [anon_sym_finally] = ACTIONS(1404),
    [anon_sym_data] = ACTIONS(1404),
    [anon_sym_inlinescript] = ACTIONS(1404),
    [anon_sym_parallel] = ACTIONS(1404),
    [anon_sym_sequence] = ACTIONS(1404),
    [anon_sym_AMP] = ACTIONS(1404),
    [aux_sym_command_name_token1] = ACTIONS(1404),
    [anon_sym_PERCENT] = ACTIONS(1404),
    [anon_sym_foreach_DASHobject] = ACTIONS(1404),
    [anon_sym_class] = ACTIONS(1404),
    [anon_sym_enum] = ACTIONS(1404),
    [anon_sym_PLUS] = ACTIONS(1404),
    [anon_sym_DASH] = ACTIONS(1404),
    [anon_sym_DASHnot] = ACTIONS(1404),
    [anon_sym_BANG] = ACTIONS(1404),
    [anon_sym_DASHbnot] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1404),
    [anon_sym_DASH_DASH] = ACTIONS(1404),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1404),
    [anon_sym_AT_LPAREN] = ACTIONS(1404),
    [anon_sym_AT_LBRACE] = ACTIONS(1404),
  },
  [333] = {
    [aux_sym_command_argument_sep_repeat1] = STATE(333),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1325),
    [sym_hexadecimal_integer_literal] = ACTIONS(1325),
    [sym_real_literal] = ACTIONS(1325),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1325),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1325),
    [sym_verbatim_string_characters] = ACTIONS(1325),
    [sym_verbatim_here_string_characters] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(1325),
    [anon_sym_GT] = ACTIONS(1325),
    [anon_sym_GT_GT] = ACTIONS(1325),
    [anon_sym_2_GT] = ACTIONS(1325),
    [anon_sym_2_GT_GT] = ACTIONS(1325),
    [anon_sym_3_GT] = ACTIONS(1325),
    [anon_sym_3_GT_GT] = ACTIONS(1325),
    [anon_sym_4_GT] = ACTIONS(1325),
    [anon_sym_4_GT_GT] = ACTIONS(1325),
    [anon_sym_5_GT] = ACTIONS(1325),
    [anon_sym_5_GT_GT] = ACTIONS(1325),
    [anon_sym_6_GT] = ACTIONS(1325),
    [anon_sym_6_GT_GT] = ACTIONS(1325),
    [anon_sym_STAR_GT] = ACTIONS(1325),
    [anon_sym_STAR_GT_GT] = ACTIONS(1325),
    [anon_sym_LT] = ACTIONS(1325),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(1325),
    [anon_sym_2_GT_AMP1] = ACTIONS(1325),
    [anon_sym_3_GT_AMP1] = ACTIONS(1325),
    [anon_sym_4_GT_AMP1] = ACTIONS(1325),
    [anon_sym_5_GT_AMP1] = ACTIONS(1325),
    [anon_sym_6_GT_AMP1] = ACTIONS(1325),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(1325),
    [anon_sym_1_GT_AMP2] = ACTIONS(1325),
    [anon_sym_3_GT_AMP2] = ACTIONS(1325),
    [anon_sym_4_GT_AMP2] = ACTIONS(1325),
    [anon_sym_5_GT_AMP2] = ACTIONS(1325),
    [anon_sym_6_GT_AMP2] = ACTIONS(1325),
    [anon_sym_DASHjoin] = ACTIONS(1325),
    [anon_sym_DASHsplit] = ACTIONS(1325),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1325),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1325),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1325),
    [anon_sym_DOLLAR_] = ACTIONS(1325),
    [aux_sym_variable_token1] = ACTIONS(1325),
    [aux_sym_variable_token2] = ACTIONS(1325),
    [sym_braced_variable] = ACTIONS(1325),
    [sym_generic_token] = ACTIONS(1325),
    [sym_command_parameter] = ACTIONS(1325),
    [anon_sym_LPAREN] = ACTIONS(1325),
    [anon_sym_RPAREN] = ACTIONS(1325),
    [anon_sym_COMMA] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_PIPE] = ACTIONS(1325),
    [sym_stop_parsing] = ACTIONS(1325),
    [anon_sym_SPACE] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(1325),
    [anon_sym_PLUS] = ACTIONS(1325),
    [anon_sym_DASH] = ACTIONS(1325),
    [anon_sym_DASHnot] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1325),
    [anon_sym_DASHbnot] = ACTIONS(1325),
    [anon_sym_PLUS_PLUS] = ACTIONS(1325),
    [anon_sym_DASH_DASH] = ACTIONS(1325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1325),
    [anon_sym_AT_LPAREN] = ACTIONS(1325),
    [anon_sym_AT_LBRACE] = ACTIONS(1325),
  },
  [334] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_DASHas] = ACTIONS(791),
    [anon_sym_DASHccontains] = ACTIONS(791),
    [anon_sym_DASHceq] = ACTIONS(791),
    [anon_sym_DASHcge] = ACTIONS(791),
    [anon_sym_DASHcgt] = ACTIONS(791),
    [anon_sym_DASHcle] = ACTIONS(791),
    [anon_sym_DASHclike] = ACTIONS(791),
    [anon_sym_DASHclt] = ACTIONS(791),
    [anon_sym_DASHcmatch] = ACTIONS(791),
    [anon_sym_DASHcne] = ACTIONS(791),
    [anon_sym_DASHcnotcontains] = ACTIONS(791),
    [anon_sym_DASHcnotlike] = ACTIONS(791),
    [anon_sym_DASHcnotmatch] = ACTIONS(791),
    [anon_sym_DASHcontains] = ACTIONS(791),
    [anon_sym_DASHcreplace] = ACTIONS(791),
    [anon_sym_DASHcsplit] = ACTIONS(791),
    [anon_sym_DASHeq] = ACTIONS(791),
    [anon_sym_DASHge] = ACTIONS(791),
    [anon_sym_DASHgt] = ACTIONS(791),
    [anon_sym_DASHicontains] = ACTIONS(791),
    [anon_sym_DASHieq] = ACTIONS(791),
    [anon_sym_DASHige] = ACTIONS(791),
    [anon_sym_DASHigt] = ACTIONS(791),
    [anon_sym_DASHile] = ACTIONS(791),
    [anon_sym_DASHilike] = ACTIONS(791),
    [anon_sym_DASHilt] = ACTIONS(791),
    [anon_sym_DASHimatch] = ACTIONS(791),
    [anon_sym_DASHin] = ACTIONS(793),
    [anon_sym_DASHine] = ACTIONS(791),
    [anon_sym_DASHinotcontains] = ACTIONS(791),
    [anon_sym_DASHinotlike] = ACTIONS(791),
    [anon_sym_DASHinotmatch] = ACTIONS(791),
    [anon_sym_DASHireplace] = ACTIONS(791),
    [anon_sym_DASHis] = ACTIONS(793),
    [anon_sym_DASHisnot] = ACTIONS(791),
    [anon_sym_DASHisplit] = ACTIONS(791),
    [anon_sym_DASHjoin] = ACTIONS(791),
    [anon_sym_DASHle] = ACTIONS(791),
    [anon_sym_DASHlike] = ACTIONS(791),
    [anon_sym_DASHlt] = ACTIONS(791),
    [anon_sym_DASHmatch] = ACTIONS(791),
    [anon_sym_DASHne] = ACTIONS(791),
    [anon_sym_DASHnotcontains] = ACTIONS(791),
    [anon_sym_DASHnotin] = ACTIONS(791),
    [anon_sym_DASHnotlike] = ACTIONS(791),
    [anon_sym_DASHnotmatch] = ACTIONS(791),
    [anon_sym_DASHreplace] = ACTIONS(791),
    [anon_sym_DASHshl] = ACTIONS(791),
    [anon_sym_DASHshr] = ACTIONS(791),
    [anon_sym_DASHsplit] = ACTIONS(791),
    [sym_format_operator] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_DASHand] = ACTIONS(791),
    [anon_sym_DASHor] = ACTIONS(791),
    [anon_sym_DASHxor] = ACTIONS(791),
    [anon_sym_DASHband] = ACTIONS(791),
    [anon_sym_DASHbor] = ACTIONS(791),
    [anon_sym_DASHbxor] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_DASH] = ACTIONS(793),
    [anon_sym_SLASH] = ACTIONS(791),
    [anon_sym_BSLASH] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(1398),
    [sym__statement_terminator] = ACTIONS(791),
  },
  [335] = {
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1341),
    [sym_hexadecimal_integer_literal] = ACTIONS(1341),
    [sym_real_literal] = ACTIONS(1341),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1341),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1341),
    [sym_verbatim_string_characters] = ACTIONS(1341),
    [sym_verbatim_here_string_characters] = ACTIONS(1341),
    [anon_sym_LBRACK] = ACTIONS(1341),
    [anon_sym_GT] = ACTIONS(1341),
    [anon_sym_GT_GT] = ACTIONS(1341),
    [anon_sym_2_GT] = ACTIONS(1341),
    [anon_sym_2_GT_GT] = ACTIONS(1341),
    [anon_sym_3_GT] = ACTIONS(1341),
    [anon_sym_3_GT_GT] = ACTIONS(1341),
    [anon_sym_4_GT] = ACTIONS(1341),
    [anon_sym_4_GT_GT] = ACTIONS(1341),
    [anon_sym_5_GT] = ACTIONS(1341),
    [anon_sym_5_GT_GT] = ACTIONS(1341),
    [anon_sym_6_GT] = ACTIONS(1341),
    [anon_sym_6_GT_GT] = ACTIONS(1341),
    [anon_sym_STAR_GT] = ACTIONS(1341),
    [anon_sym_STAR_GT_GT] = ACTIONS(1341),
    [anon_sym_LT] = ACTIONS(1341),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(1341),
    [anon_sym_2_GT_AMP1] = ACTIONS(1341),
    [anon_sym_3_GT_AMP1] = ACTIONS(1341),
    [anon_sym_4_GT_AMP1] = ACTIONS(1341),
    [anon_sym_5_GT_AMP1] = ACTIONS(1341),
    [anon_sym_6_GT_AMP1] = ACTIONS(1341),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(1341),
    [anon_sym_1_GT_AMP2] = ACTIONS(1341),
    [anon_sym_3_GT_AMP2] = ACTIONS(1341),
    [anon_sym_4_GT_AMP2] = ACTIONS(1341),
    [anon_sym_5_GT_AMP2] = ACTIONS(1341),
    [anon_sym_6_GT_AMP2] = ACTIONS(1341),
    [anon_sym_DASHjoin] = ACTIONS(1341),
    [anon_sym_DASHsplit] = ACTIONS(1341),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1341),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1341),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1341),
    [anon_sym_DOLLAR_] = ACTIONS(1341),
    [aux_sym_variable_token1] = ACTIONS(1341),
    [aux_sym_variable_token2] = ACTIONS(1341),
    [sym_braced_variable] = ACTIONS(1341),
    [sym_generic_token] = ACTIONS(1341),
    [sym_command_parameter] = ACTIONS(1341),
    [anon_sym_LPAREN] = ACTIONS(1341),
    [anon_sym_COMMA] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1341),
    [anon_sym_PIPE] = ACTIONS(1341),
    [sym_stop_parsing] = ACTIONS(1341),
    [anon_sym_SPACE] = ACTIONS(1341),
    [anon_sym_COLON] = ACTIONS(1341),
    [anon_sym_DASH_DASH_PERCENT] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_DASHnot] = ACTIONS(1341),
    [anon_sym_BANG] = ACTIONS(1341),
    [anon_sym_DASHbnot] = ACTIONS(1341),
    [anon_sym_PLUS_PLUS] = ACTIONS(1341),
    [anon_sym_DASH_DASH] = ACTIONS(1341),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1341),
    [anon_sym_AT_LPAREN] = ACTIONS(1341),
    [anon_sym_AT_LBRACE] = ACTIONS(1341),
    [sym__statement_terminator] = ACTIONS(1345),
  },
  [336] = {
    [aux_sym_command_argument_sep_repeat1] = STATE(333),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1341),
    [sym_hexadecimal_integer_literal] = ACTIONS(1341),
    [sym_real_literal] = ACTIONS(1341),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1341),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1341),
    [sym_verbatim_string_characters] = ACTIONS(1341),
    [sym_verbatim_here_string_characters] = ACTIONS(1341),
    [anon_sym_LBRACK] = ACTIONS(1341),
    [anon_sym_GT] = ACTIONS(1341),
    [anon_sym_GT_GT] = ACTIONS(1341),
    [anon_sym_2_GT] = ACTIONS(1341),
    [anon_sym_2_GT_GT] = ACTIONS(1341),
    [anon_sym_3_GT] = ACTIONS(1341),
    [anon_sym_3_GT_GT] = ACTIONS(1341),
    [anon_sym_4_GT] = ACTIONS(1341),
    [anon_sym_4_GT_GT] = ACTIONS(1341),
    [anon_sym_5_GT] = ACTIONS(1341),
    [anon_sym_5_GT_GT] = ACTIONS(1341),
    [anon_sym_6_GT] = ACTIONS(1341),
    [anon_sym_6_GT_GT] = ACTIONS(1341),
    [anon_sym_STAR_GT] = ACTIONS(1341),
    [anon_sym_STAR_GT_GT] = ACTIONS(1341),
    [anon_sym_LT] = ACTIONS(1341),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(1341),
    [anon_sym_2_GT_AMP1] = ACTIONS(1341),
    [anon_sym_3_GT_AMP1] = ACTIONS(1341),
    [anon_sym_4_GT_AMP1] = ACTIONS(1341),
    [anon_sym_5_GT_AMP1] = ACTIONS(1341),
    [anon_sym_6_GT_AMP1] = ACTIONS(1341),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(1341),
    [anon_sym_1_GT_AMP2] = ACTIONS(1341),
    [anon_sym_3_GT_AMP2] = ACTIONS(1341),
    [anon_sym_4_GT_AMP2] = ACTIONS(1341),
    [anon_sym_5_GT_AMP2] = ACTIONS(1341),
    [anon_sym_6_GT_AMP2] = ACTIONS(1341),
    [anon_sym_DASHjoin] = ACTIONS(1341),
    [anon_sym_DASHsplit] = ACTIONS(1341),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1341),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1341),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1341),
    [anon_sym_DOLLAR_] = ACTIONS(1341),
    [aux_sym_variable_token1] = ACTIONS(1341),
    [aux_sym_variable_token2] = ACTIONS(1341),
    [sym_braced_variable] = ACTIONS(1341),
    [sym_generic_token] = ACTIONS(1341),
    [sym_command_parameter] = ACTIONS(1341),
    [anon_sym_LPAREN] = ACTIONS(1341),
    [anon_sym_RPAREN] = ACTIONS(1341),
    [anon_sym_COMMA] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1341),
    [anon_sym_PIPE] = ACTIONS(1341),
    [sym_stop_parsing] = ACTIONS(1341),
    [anon_sym_SPACE] = ACTIONS(1412),
    [anon_sym_COLON] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_DASHnot] = ACTIONS(1341),
    [anon_sym_BANG] = ACTIONS(1341),
    [anon_sym_DASHbnot] = ACTIONS(1341),
    [anon_sym_PLUS_PLUS] = ACTIONS(1341),
    [anon_sym_DASH_DASH] = ACTIONS(1341),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1341),
    [anon_sym_AT_LPAREN] = ACTIONS(1341),
    [anon_sym_AT_LBRACE] = ACTIONS(1341),
  },
  [337] = {
    [sym__literal] = STATE(289),
    [sym_integer_literal] = STATE(289),
    [sym_string_literal] = STATE(289),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(289),
    [sym_unary_expression] = STATE(386),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(289),
    [sym__value] = STATE(289),
    [sym_parenthesized_expression] = STATE(289),
    [sym_sub_expression] = STATE(289),
    [sym_array_expression] = STATE(289),
    [sym_script_block_expression] = STATE(289),
    [sym_hash_literal_expression] = STATE(289),
    [sym_post_increment_expression] = STATE(289),
    [sym_post_decrement_expression] = STATE(289),
    [sym_member_access] = STATE(289),
    [sym_element_access] = STATE(289),
    [sym_invokation_expression] = STATE(289),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_argument_expression_list] = STATE(1777),
    [sym_argument_expression] = STATE(1490),
    [sym_logical_argument_expression] = STATE(1331),
    [sym_bitwise_argument_expression] = STATE(1332),
    [sym_comparison_argument_expression] = STATE(584),
    [sym_additive_argument_expression] = STATE(576),
    [sym_multiplicative_argument_expression] = STATE(430),
    [sym_format_argument_expression] = STATE(402),
    [sym_range_argument_expression] = STATE(380),
    [sym_type_literal] = STATE(76),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(121),
    [sym_real_literal] = ACTIONS(479),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(125),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(127),
    [sym_verbatim_string_characters] = ACTIONS(129),
    [sym_verbatim_here_string_characters] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_DASHjoin] = ACTIONS(483),
    [anon_sym_DASHsplit] = ACTIONS(483),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(135),
    [anon_sym_DOLLAR_CARET] = ACTIONS(135),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(135),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(135),
    [sym_braced_variable] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(1414),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(485),
    [anon_sym_DASHnot] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_DASHbnot] = ACTIONS(483),
    [anon_sym_PLUS_PLUS] = ACTIONS(487),
    [anon_sym_DASH_DASH] = ACTIONS(489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_AT_LBRACE] = ACTIONS(153),
  },
  [338] = {
    [sym__literal] = STATE(289),
    [sym_integer_literal] = STATE(289),
    [sym_string_literal] = STATE(289),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(289),
    [sym_unary_expression] = STATE(386),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(289),
    [sym__value] = STATE(289),
    [sym_parenthesized_expression] = STATE(289),
    [sym_sub_expression] = STATE(289),
    [sym_array_expression] = STATE(289),
    [sym_script_block_expression] = STATE(289),
    [sym_hash_literal_expression] = STATE(289),
    [sym_post_increment_expression] = STATE(289),
    [sym_post_decrement_expression] = STATE(289),
    [sym_member_access] = STATE(289),
    [sym_element_access] = STATE(289),
    [sym_invokation_expression] = STATE(289),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_argument_expression_list] = STATE(1821),
    [sym_argument_expression] = STATE(1490),
    [sym_logical_argument_expression] = STATE(1331),
    [sym_bitwise_argument_expression] = STATE(1332),
    [sym_comparison_argument_expression] = STATE(584),
    [sym_additive_argument_expression] = STATE(576),
    [sym_multiplicative_argument_expression] = STATE(430),
    [sym_format_argument_expression] = STATE(402),
    [sym_range_argument_expression] = STATE(380),
    [sym_type_literal] = STATE(76),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(121),
    [sym_real_literal] = ACTIONS(479),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(125),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(127),
    [sym_verbatim_string_characters] = ACTIONS(129),
    [sym_verbatim_here_string_characters] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_DASHjoin] = ACTIONS(483),
    [anon_sym_DASHsplit] = ACTIONS(483),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(135),
    [anon_sym_DOLLAR_CARET] = ACTIONS(135),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(135),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(135),
    [sym_braced_variable] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(1416),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(485),
    [anon_sym_DASHnot] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_DASHbnot] = ACTIONS(483),
    [anon_sym_PLUS_PLUS] = ACTIONS(487),
    [anon_sym_DASH_DASH] = ACTIONS(489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_AT_LBRACE] = ACTIONS(153),
  },
  [339] = {
    [sym__literal] = STATE(289),
    [sym_integer_literal] = STATE(289),
    [sym_string_literal] = STATE(289),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(289),
    [sym_unary_expression] = STATE(386),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(289),
    [sym__value] = STATE(289),
    [sym_parenthesized_expression] = STATE(289),
    [sym_sub_expression] = STATE(289),
    [sym_array_expression] = STATE(289),
    [sym_script_block_expression] = STATE(289),
    [sym_hash_literal_expression] = STATE(289),
    [sym_post_increment_expression] = STATE(289),
    [sym_post_decrement_expression] = STATE(289),
    [sym_member_access] = STATE(289),
    [sym_element_access] = STATE(289),
    [sym_invokation_expression] = STATE(289),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_argument_expression_list] = STATE(1799),
    [sym_argument_expression] = STATE(1490),
    [sym_logical_argument_expression] = STATE(1331),
    [sym_bitwise_argument_expression] = STATE(1332),
    [sym_comparison_argument_expression] = STATE(584),
    [sym_additive_argument_expression] = STATE(576),
    [sym_multiplicative_argument_expression] = STATE(430),
    [sym_format_argument_expression] = STATE(402),
    [sym_range_argument_expression] = STATE(380),
    [sym_type_literal] = STATE(76),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(121),
    [sym_real_literal] = ACTIONS(479),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(125),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(127),
    [sym_verbatim_string_characters] = ACTIONS(129),
    [sym_verbatim_here_string_characters] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_DASHjoin] = ACTIONS(483),
    [anon_sym_DASHsplit] = ACTIONS(483),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(135),
    [anon_sym_DOLLAR_CARET] = ACTIONS(135),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(135),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(135),
    [sym_braced_variable] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(1418),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(485),
    [anon_sym_DASHnot] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_DASHbnot] = ACTIONS(483),
    [anon_sym_PLUS_PLUS] = ACTIONS(487),
    [anon_sym_DASH_DASH] = ACTIONS(489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_AT_LBRACE] = ACTIONS(153),
  },
  [340] = {
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1420),
    [sym_hexadecimal_integer_literal] = ACTIONS(1420),
    [sym_real_literal] = ACTIONS(1420),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1420),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1420),
    [sym_verbatim_string_characters] = ACTIONS(1420),
    [sym_verbatim_here_string_characters] = ACTIONS(1420),
    [anon_sym_DOT] = ACTIONS(1420),
    [anon_sym_LBRACK] = ACTIONS(1420),
    [anon_sym_DASHjoin] = ACTIONS(1420),
    [anon_sym_DASHsplit] = ACTIONS(1420),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1420),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1420),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1420),
    [anon_sym_DOLLAR_] = ACTIONS(1420),
    [aux_sym_variable_token1] = ACTIONS(1420),
    [aux_sym_variable_token2] = ACTIONS(1420),
    [sym_braced_variable] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(1420),
    [anon_sym_param] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1420),
    [anon_sym_COMMA] = ACTIONS(1420),
    [anon_sym_dynamicparam] = ACTIONS(1420),
    [anon_sym_begin] = ACTIONS(1420),
    [anon_sym_process] = ACTIONS(1420),
    [anon_sym_end] = ACTIONS(1420),
    [anon_sym_LBRACE] = ACTIONS(1420),
    [anon_sym_if] = ACTIONS(1420),
    [anon_sym_switch] = ACTIONS(1420),
    [anon_sym_foreach] = ACTIONS(1420),
    [anon_sym_for] = ACTIONS(1420),
    [anon_sym_while] = ACTIONS(1420),
    [anon_sym_do] = ACTIONS(1420),
    [anon_sym_function] = ACTIONS(1420),
    [anon_sym_filter] = ACTIONS(1420),
    [anon_sym_workflow] = ACTIONS(1420),
    [anon_sym_break] = ACTIONS(1420),
    [anon_sym_continue] = ACTIONS(1420),
    [anon_sym_throw] = ACTIONS(1420),
    [anon_sym_return] = ACTIONS(1420),
    [anon_sym_exit] = ACTIONS(1420),
    [sym_label] = ACTIONS(1420),
    [anon_sym_trap] = ACTIONS(1420),
    [anon_sym_try] = ACTIONS(1420),
    [anon_sym_data] = ACTIONS(1420),
    [anon_sym_inlinescript] = ACTIONS(1420),
    [anon_sym_parallel] = ACTIONS(1420),
    [anon_sym_sequence] = ACTIONS(1420),
    [anon_sym_AMP] = ACTIONS(1420),
    [aux_sym_command_name_token1] = ACTIONS(1420),
    [anon_sym_PERCENT] = ACTIONS(1420),
    [anon_sym_foreach_DASHobject] = ACTIONS(1420),
    [anon_sym_class] = ACTIONS(1420),
    [anon_sym_enum] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1420),
    [anon_sym_DASH] = ACTIONS(1420),
    [anon_sym_DASHnot] = ACTIONS(1420),
    [anon_sym_BANG] = ACTIONS(1420),
    [anon_sym_DASHbnot] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1420),
    [anon_sym_DASH_DASH] = ACTIONS(1420),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1420),
    [anon_sym_AT_LPAREN] = ACTIONS(1420),
    [anon_sym_AT_LBRACE] = ACTIONS(1420),
    [sym__statement_terminator] = ACTIONS(1422),
  },
  [341] = {
    [sym__literal] = STATE(289),
    [sym_integer_literal] = STATE(289),
    [sym_string_literal] = STATE(289),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(289),
    [sym_unary_expression] = STATE(386),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(289),
    [sym__value] = STATE(289),
    [sym_parenthesized_expression] = STATE(289),
    [sym_sub_expression] = STATE(289),
    [sym_array_expression] = STATE(289),
    [sym_script_block_expression] = STATE(289),
    [sym_hash_literal_expression] = STATE(289),
    [sym_post_increment_expression] = STATE(289),
    [sym_post_decrement_expression] = STATE(289),
    [sym_member_access] = STATE(289),
    [sym_element_access] = STATE(289),
    [sym_invokation_expression] = STATE(289),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_argument_expression_list] = STATE(1818),
    [sym_argument_expression] = STATE(1490),
    [sym_logical_argument_expression] = STATE(1331),
    [sym_bitwise_argument_expression] = STATE(1332),
    [sym_comparison_argument_expression] = STATE(584),
    [sym_additive_argument_expression] = STATE(576),
    [sym_multiplicative_argument_expression] = STATE(430),
    [sym_format_argument_expression] = STATE(402),
    [sym_range_argument_expression] = STATE(380),
    [sym_type_literal] = STATE(76),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(121),
    [sym_real_literal] = ACTIONS(479),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(125),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(127),
    [sym_verbatim_string_characters] = ACTIONS(129),
    [sym_verbatim_here_string_characters] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_DASHjoin] = ACTIONS(483),
    [anon_sym_DASHsplit] = ACTIONS(483),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(135),
    [anon_sym_DOLLAR_CARET] = ACTIONS(135),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(135),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(135),
    [sym_braced_variable] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(1424),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(485),
    [anon_sym_DASHnot] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_DASHbnot] = ACTIONS(483),
    [anon_sym_PLUS_PLUS] = ACTIONS(487),
    [anon_sym_DASH_DASH] = ACTIONS(489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_AT_LBRACE] = ACTIONS(153),
  },
  [342] = {
    [sym__literal] = STATE(289),
    [sym_integer_literal] = STATE(289),
    [sym_string_literal] = STATE(289),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(289),
    [sym_unary_expression] = STATE(386),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(289),
    [sym__value] = STATE(289),
    [sym_parenthesized_expression] = STATE(289),
    [sym_sub_expression] = STATE(289),
    [sym_array_expression] = STATE(289),
    [sym_script_block_expression] = STATE(289),
    [sym_hash_literal_expression] = STATE(289),
    [sym_post_increment_expression] = STATE(289),
    [sym_post_decrement_expression] = STATE(289),
    [sym_member_access] = STATE(289),
    [sym_element_access] = STATE(289),
    [sym_invokation_expression] = STATE(289),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_argument_expression_list] = STATE(1909),
    [sym_argument_expression] = STATE(1490),
    [sym_logical_argument_expression] = STATE(1331),
    [sym_bitwise_argument_expression] = STATE(1332),
    [sym_comparison_argument_expression] = STATE(584),
    [sym_additive_argument_expression] = STATE(576),
    [sym_multiplicative_argument_expression] = STATE(430),
    [sym_format_argument_expression] = STATE(402),
    [sym_range_argument_expression] = STATE(380),
    [sym_type_literal] = STATE(76),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(121),
    [sym_real_literal] = ACTIONS(479),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(125),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(127),
    [sym_verbatim_string_characters] = ACTIONS(129),
    [sym_verbatim_here_string_characters] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_DASHjoin] = ACTIONS(483),
    [anon_sym_DASHsplit] = ACTIONS(483),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(135),
    [anon_sym_DOLLAR_CARET] = ACTIONS(135),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(135),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(135),
    [sym_braced_variable] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(1426),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(485),
    [anon_sym_DASHnot] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_DASHbnot] = ACTIONS(483),
    [anon_sym_PLUS_PLUS] = ACTIONS(487),
    [anon_sym_DASH_DASH] = ACTIONS(489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_AT_LBRACE] = ACTIONS(153),
  },
  [343] = {
    [sym__literal] = STATE(289),
    [sym_integer_literal] = STATE(289),
    [sym_string_literal] = STATE(289),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(289),
    [sym_unary_expression] = STATE(386),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(289),
    [sym__value] = STATE(289),
    [sym_parenthesized_expression] = STATE(289),
    [sym_sub_expression] = STATE(289),
    [sym_array_expression] = STATE(289),
    [sym_script_block_expression] = STATE(289),
    [sym_hash_literal_expression] = STATE(289),
    [sym_post_increment_expression] = STATE(289),
    [sym_post_decrement_expression] = STATE(289),
    [sym_member_access] = STATE(289),
    [sym_element_access] = STATE(289),
    [sym_invokation_expression] = STATE(289),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_argument_expression_list] = STATE(1813),
    [sym_argument_expression] = STATE(1490),
    [sym_logical_argument_expression] = STATE(1331),
    [sym_bitwise_argument_expression] = STATE(1332),
    [sym_comparison_argument_expression] = STATE(584),
    [sym_additive_argument_expression] = STATE(576),
    [sym_multiplicative_argument_expression] = STATE(430),
    [sym_format_argument_expression] = STATE(402),
    [sym_range_argument_expression] = STATE(380),
    [sym_type_literal] = STATE(76),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(121),
    [sym_real_literal] = ACTIONS(479),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(125),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(127),
    [sym_verbatim_string_characters] = ACTIONS(129),
    [sym_verbatim_here_string_characters] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_DASHjoin] = ACTIONS(483),
    [anon_sym_DASHsplit] = ACTIONS(483),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(135),
    [anon_sym_DOLLAR_CARET] = ACTIONS(135),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(135),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(135),
    [sym_braced_variable] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(1428),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(485),
    [anon_sym_DASHnot] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_DASHbnot] = ACTIONS(483),
    [anon_sym_PLUS_PLUS] = ACTIONS(487),
    [anon_sym_DASH_DASH] = ACTIONS(489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_AT_LBRACE] = ACTIONS(153),
  },
  [344] = {
    [sym__literal] = STATE(289),
    [sym_integer_literal] = STATE(289),
    [sym_string_literal] = STATE(289),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(289),
    [sym_unary_expression] = STATE(386),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(289),
    [sym__value] = STATE(289),
    [sym_parenthesized_expression] = STATE(289),
    [sym_sub_expression] = STATE(289),
    [sym_array_expression] = STATE(289),
    [sym_script_block_expression] = STATE(289),
    [sym_hash_literal_expression] = STATE(289),
    [sym_post_increment_expression] = STATE(289),
    [sym_post_decrement_expression] = STATE(289),
    [sym_member_access] = STATE(289),
    [sym_element_access] = STATE(289),
    [sym_invokation_expression] = STATE(289),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_argument_expression_list] = STATE(2041),
    [sym_argument_expression] = STATE(1490),
    [sym_logical_argument_expression] = STATE(1331),
    [sym_bitwise_argument_expression] = STATE(1332),
    [sym_comparison_argument_expression] = STATE(584),
    [sym_additive_argument_expression] = STATE(576),
    [sym_multiplicative_argument_expression] = STATE(430),
    [sym_format_argument_expression] = STATE(402),
    [sym_range_argument_expression] = STATE(380),
    [sym_type_literal] = STATE(76),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(121),
    [sym_real_literal] = ACTIONS(479),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(125),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(127),
    [sym_verbatim_string_characters] = ACTIONS(129),
    [sym_verbatim_here_string_characters] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_DASHjoin] = ACTIONS(483),
    [anon_sym_DASHsplit] = ACTIONS(483),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(135),
    [anon_sym_DOLLAR_CARET] = ACTIONS(135),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(135),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(135),
    [sym_braced_variable] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(1430),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(485),
    [anon_sym_DASHnot] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_DASHbnot] = ACTIONS(483),
    [anon_sym_PLUS_PLUS] = ACTIONS(487),
    [anon_sym_DASH_DASH] = ACTIONS(489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_AT_LBRACE] = ACTIONS(153),
  },
  [345] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_DASHas] = ACTIONS(791),
    [anon_sym_DASHccontains] = ACTIONS(791),
    [anon_sym_DASHceq] = ACTIONS(791),
    [anon_sym_DASHcge] = ACTIONS(791),
    [anon_sym_DASHcgt] = ACTIONS(791),
    [anon_sym_DASHcle] = ACTIONS(791),
    [anon_sym_DASHclike] = ACTIONS(791),
    [anon_sym_DASHclt] = ACTIONS(791),
    [anon_sym_DASHcmatch] = ACTIONS(791),
    [anon_sym_DASHcne] = ACTIONS(791),
    [anon_sym_DASHcnotcontains] = ACTIONS(791),
    [anon_sym_DASHcnotlike] = ACTIONS(791),
    [anon_sym_DASHcnotmatch] = ACTIONS(791),
    [anon_sym_DASHcontains] = ACTIONS(791),
    [anon_sym_DASHcreplace] = ACTIONS(791),
    [anon_sym_DASHcsplit] = ACTIONS(791),
    [anon_sym_DASHeq] = ACTIONS(791),
    [anon_sym_DASHge] = ACTIONS(791),
    [anon_sym_DASHgt] = ACTIONS(791),
    [anon_sym_DASHicontains] = ACTIONS(791),
    [anon_sym_DASHieq] = ACTIONS(791),
    [anon_sym_DASHige] = ACTIONS(791),
    [anon_sym_DASHigt] = ACTIONS(791),
    [anon_sym_DASHile] = ACTIONS(791),
    [anon_sym_DASHilike] = ACTIONS(791),
    [anon_sym_DASHilt] = ACTIONS(791),
    [anon_sym_DASHimatch] = ACTIONS(791),
    [anon_sym_DASHin] = ACTIONS(793),
    [anon_sym_DASHine] = ACTIONS(791),
    [anon_sym_DASHinotcontains] = ACTIONS(791),
    [anon_sym_DASHinotlike] = ACTIONS(791),
    [anon_sym_DASHinotmatch] = ACTIONS(791),
    [anon_sym_DASHireplace] = ACTIONS(791),
    [anon_sym_DASHis] = ACTIONS(793),
    [anon_sym_DASHisnot] = ACTIONS(791),
    [anon_sym_DASHisplit] = ACTIONS(791),
    [anon_sym_DASHjoin] = ACTIONS(791),
    [anon_sym_DASHle] = ACTIONS(791),
    [anon_sym_DASHlike] = ACTIONS(791),
    [anon_sym_DASHlt] = ACTIONS(791),
    [anon_sym_DASHmatch] = ACTIONS(791),
    [anon_sym_DASHne] = ACTIONS(791),
    [anon_sym_DASHnotcontains] = ACTIONS(791),
    [anon_sym_DASHnotin] = ACTIONS(791),
    [anon_sym_DASHnotlike] = ACTIONS(791),
    [anon_sym_DASHnotmatch] = ACTIONS(791),
    [anon_sym_DASHreplace] = ACTIONS(791),
    [anon_sym_DASHshl] = ACTIONS(791),
    [anon_sym_DASHshr] = ACTIONS(791),
    [anon_sym_DASHsplit] = ACTIONS(791),
    [sym_format_operator] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_DASHand] = ACTIONS(791),
    [anon_sym_DASHor] = ACTIONS(791),
    [anon_sym_DASHxor] = ACTIONS(791),
    [anon_sym_DASHband] = ACTIONS(791),
    [anon_sym_DASHbor] = ACTIONS(791),
    [anon_sym_DASHbxor] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_DASH] = ACTIONS(793),
    [anon_sym_SLASH] = ACTIONS(791),
    [anon_sym_BSLASH] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(1379),
    [anon_sym_RBRACK] = ACTIONS(791),
  },
  [346] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_DASHas] = ACTIONS(797),
    [anon_sym_DASHccontains] = ACTIONS(797),
    [anon_sym_DASHceq] = ACTIONS(797),
    [anon_sym_DASHcge] = ACTIONS(797),
    [anon_sym_DASHcgt] = ACTIONS(797),
    [anon_sym_DASHcle] = ACTIONS(797),
    [anon_sym_DASHclike] = ACTIONS(797),
    [anon_sym_DASHclt] = ACTIONS(797),
    [anon_sym_DASHcmatch] = ACTIONS(797),
    [anon_sym_DASHcne] = ACTIONS(797),
    [anon_sym_DASHcnotcontains] = ACTIONS(797),
    [anon_sym_DASHcnotlike] = ACTIONS(797),
    [anon_sym_DASHcnotmatch] = ACTIONS(797),
    [anon_sym_DASHcontains] = ACTIONS(797),
    [anon_sym_DASHcreplace] = ACTIONS(797),
    [anon_sym_DASHcsplit] = ACTIONS(797),
    [anon_sym_DASHeq] = ACTIONS(797),
    [anon_sym_DASHge] = ACTIONS(797),
    [anon_sym_DASHgt] = ACTIONS(797),
    [anon_sym_DASHicontains] = ACTIONS(797),
    [anon_sym_DASHieq] = ACTIONS(797),
    [anon_sym_DASHige] = ACTIONS(797),
    [anon_sym_DASHigt] = ACTIONS(797),
    [anon_sym_DASHile] = ACTIONS(797),
    [anon_sym_DASHilike] = ACTIONS(797),
    [anon_sym_DASHilt] = ACTIONS(797),
    [anon_sym_DASHimatch] = ACTIONS(797),
    [anon_sym_DASHin] = ACTIONS(799),
    [anon_sym_DASHine] = ACTIONS(797),
    [anon_sym_DASHinotcontains] = ACTIONS(797),
    [anon_sym_DASHinotlike] = ACTIONS(797),
    [anon_sym_DASHinotmatch] = ACTIONS(797),
    [anon_sym_DASHireplace] = ACTIONS(797),
    [anon_sym_DASHis] = ACTIONS(799),
    [anon_sym_DASHisnot] = ACTIONS(797),
    [anon_sym_DASHisplit] = ACTIONS(797),
    [anon_sym_DASHjoin] = ACTIONS(797),
    [anon_sym_DASHle] = ACTIONS(797),
    [anon_sym_DASHlike] = ACTIONS(797),
    [anon_sym_DASHlt] = ACTIONS(797),
    [anon_sym_DASHmatch] = ACTIONS(797),
    [anon_sym_DASHne] = ACTIONS(797),
    [anon_sym_DASHnotcontains] = ACTIONS(797),
    [anon_sym_DASHnotin] = ACTIONS(797),
    [anon_sym_DASHnotlike] = ACTIONS(797),
    [anon_sym_DASHnotmatch] = ACTIONS(797),
    [anon_sym_DASHreplace] = ACTIONS(797),
    [anon_sym_DASHshl] = ACTIONS(797),
    [anon_sym_DASHshr] = ACTIONS(797),
    [anon_sym_DASHsplit] = ACTIONS(797),
    [sym_format_operator] = ACTIONS(1432),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_DASHand] = ACTIONS(797),
    [anon_sym_DASHor] = ACTIONS(797),
    [anon_sym_DASHxor] = ACTIONS(797),
    [anon_sym_DASHband] = ACTIONS(797),
    [anon_sym_DASHbor] = ACTIONS(797),
    [anon_sym_DASHbxor] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(797),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_BSLASH] = ACTIONS(797),
    [anon_sym_STAR] = ACTIONS(797),
    [sym__statement_terminator] = ACTIONS(797),
  },
  [347] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_DASHas] = ACTIONS(809),
    [anon_sym_DASHccontains] = ACTIONS(809),
    [anon_sym_DASHceq] = ACTIONS(809),
    [anon_sym_DASHcge] = ACTIONS(809),
    [anon_sym_DASHcgt] = ACTIONS(809),
    [anon_sym_DASHcle] = ACTIONS(809),
    [anon_sym_DASHclike] = ACTIONS(809),
    [anon_sym_DASHclt] = ACTIONS(809),
    [anon_sym_DASHcmatch] = ACTIONS(809),
    [anon_sym_DASHcne] = ACTIONS(809),
    [anon_sym_DASHcnotcontains] = ACTIONS(809),
    [anon_sym_DASHcnotlike] = ACTIONS(809),
    [anon_sym_DASHcnotmatch] = ACTIONS(809),
    [anon_sym_DASHcontains] = ACTIONS(809),
    [anon_sym_DASHcreplace] = ACTIONS(809),
    [anon_sym_DASHcsplit] = ACTIONS(809),
    [anon_sym_DASHeq] = ACTIONS(809),
    [anon_sym_DASHge] = ACTIONS(809),
    [anon_sym_DASHgt] = ACTIONS(809),
    [anon_sym_DASHicontains] = ACTIONS(809),
    [anon_sym_DASHieq] = ACTIONS(809),
    [anon_sym_DASHige] = ACTIONS(809),
    [anon_sym_DASHigt] = ACTIONS(809),
    [anon_sym_DASHile] = ACTIONS(809),
    [anon_sym_DASHilike] = ACTIONS(809),
    [anon_sym_DASHilt] = ACTIONS(809),
    [anon_sym_DASHimatch] = ACTIONS(809),
    [anon_sym_DASHin] = ACTIONS(811),
    [anon_sym_DASHine] = ACTIONS(809),
    [anon_sym_DASHinotcontains] = ACTIONS(809),
    [anon_sym_DASHinotlike] = ACTIONS(809),
    [anon_sym_DASHinotmatch] = ACTIONS(809),
    [anon_sym_DASHireplace] = ACTIONS(809),
    [anon_sym_DASHis] = ACTIONS(811),
    [anon_sym_DASHisnot] = ACTIONS(809),
    [anon_sym_DASHisplit] = ACTIONS(809),
    [anon_sym_DASHjoin] = ACTIONS(809),
    [anon_sym_DASHle] = ACTIONS(809),
    [anon_sym_DASHlike] = ACTIONS(809),
    [anon_sym_DASHlt] = ACTIONS(809),
    [anon_sym_DASHmatch] = ACTIONS(809),
    [anon_sym_DASHne] = ACTIONS(809),
    [anon_sym_DASHnotcontains] = ACTIONS(809),
    [anon_sym_DASHnotin] = ACTIONS(809),
    [anon_sym_DASHnotlike] = ACTIONS(809),
    [anon_sym_DASHnotmatch] = ACTIONS(809),
    [anon_sym_DASHreplace] = ACTIONS(809),
    [anon_sym_DASHshl] = ACTIONS(809),
    [anon_sym_DASHshr] = ACTIONS(809),
    [anon_sym_DASHsplit] = ACTIONS(809),
    [anon_sym_RPAREN] = ACTIONS(809),
    [anon_sym_COMMA] = ACTIONS(809),
    [anon_sym_PERCENT] = ACTIONS(1434),
    [anon_sym_DASHand] = ACTIONS(809),
    [anon_sym_DASHor] = ACTIONS(809),
    [anon_sym_DASHxor] = ACTIONS(809),
    [anon_sym_DASHband] = ACTIONS(809),
    [anon_sym_DASHbor] = ACTIONS(809),
    [anon_sym_DASHbxor] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(1434),
    [anon_sym_BSLASH] = ACTIONS(1434),
    [anon_sym_STAR] = ACTIONS(1434),
  },
  [348] = {
    [sym__literal] = STATE(290),
    [sym_integer_literal] = STATE(290),
    [sym_string_literal] = STATE(290),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(290),
    [sym__expression] = STATE(1740),
    [sym_logical_expression] = STATE(1398),
    [sym_bitwise_expression] = STATE(1299),
    [sym_comparison_expression] = STATE(564),
    [sym_additive_expression] = STATE(546),
    [sym_multiplicative_expression] = STATE(389),
    [sym_format_expression] = STATE(346),
    [sym_range_expression] = STATE(334),
    [sym_array_literal_expression] = STATE(308),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(290),
    [sym__value] = STATE(290),
    [sym_parenthesized_expression] = STATE(290),
    [sym_sub_expression] = STATE(290),
    [sym_array_expression] = STATE(290),
    [sym_script_block_expression] = STATE(290),
    [sym_hash_literal_expression] = STATE(290),
    [sym_post_increment_expression] = STATE(290),
    [sym_post_decrement_expression] = STATE(290),
    [sym_member_access] = STATE(290),
    [sym_element_access] = STATE(290),
    [sym_invokation_expression] = STATE(290),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(81),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(83),
    [sym_real_literal] = ACTIONS(547),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(87),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(89),
    [sym_verbatim_string_characters] = ACTIONS(91),
    [sym_verbatim_here_string_characters] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_DASHjoin] = ACTIONS(549),
    [anon_sym_DASHsplit] = ACTIONS(549),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(101),
    [anon_sym_DOLLAR_CARET] = ACTIONS(101),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(101),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(101),
    [sym_braced_variable] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_LBRACE] = ACTIONS(107),
    [anon_sym_PLUS] = ACTIONS(551),
    [anon_sym_DASH] = ACTIONS(551),
    [anon_sym_DASHnot] = ACTIONS(549),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_DASHbnot] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(553),
    [anon_sym_DASH_DASH] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(113),
    [anon_sym_AT_LPAREN] = ACTIONS(115),
    [anon_sym_AT_LBRACE] = ACTIONS(117),
  },
  [349] = {
    [sym__literal] = STATE(289),
    [sym_integer_literal] = STATE(289),
    [sym_string_literal] = STATE(289),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(289),
    [sym__expression] = STATE(1730),
    [sym_logical_expression] = STATE(1396),
    [sym_bitwise_expression] = STATE(1300),
    [sym_comparison_expression] = STATE(559),
    [sym_additive_expression] = STATE(554),
    [sym_multiplicative_expression] = STATE(387),
    [sym_format_expression] = STATE(370),
    [sym_range_expression] = STATE(345),
    [sym_array_literal_expression] = STATE(299),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(289),
    [sym__value] = STATE(289),
    [sym_parenthesized_expression] = STATE(289),
    [sym_sub_expression] = STATE(289),
    [sym_array_expression] = STATE(289),
    [sym_script_block_expression] = STATE(289),
    [sym_hash_literal_expression] = STATE(289),
    [sym_post_increment_expression] = STATE(289),
    [sym_post_decrement_expression] = STATE(289),
    [sym_member_access] = STATE(289),
    [sym_element_access] = STATE(289),
    [sym_invokation_expression] = STATE(289),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(76),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(121),
    [sym_real_literal] = ACTIONS(479),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(125),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(127),
    [sym_verbatim_string_characters] = ACTIONS(129),
    [sym_verbatim_here_string_characters] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_DASHjoin] = ACTIONS(483),
    [anon_sym_DASHsplit] = ACTIONS(483),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(135),
    [anon_sym_DOLLAR_CARET] = ACTIONS(135),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(135),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(135),
    [sym_braced_variable] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(485),
    [anon_sym_DASHnot] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_DASHbnot] = ACTIONS(483),
    [anon_sym_PLUS_PLUS] = ACTIONS(487),
    [anon_sym_DASH_DASH] = ACTIONS(489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_AT_LBRACE] = ACTIONS(153),
  },
  [350] = {
    [sym_catch_clause] = STATE(350),
    [aux_sym_catch_clauses_repeat1] = STATE(350),
    [ts_builtin_sym_end] = ACTIONS(1436),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1404),
    [sym_hexadecimal_integer_literal] = ACTIONS(1404),
    [sym_real_literal] = ACTIONS(1404),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1404),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1404),
    [sym_verbatim_string_characters] = ACTIONS(1404),
    [sym_verbatim_here_string_characters] = ACTIONS(1404),
    [anon_sym_DOT] = ACTIONS(1404),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_DASHjoin] = ACTIONS(1404),
    [anon_sym_DASHsplit] = ACTIONS(1404),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1404),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1404),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1404),
    [anon_sym_DOLLAR_] = ACTIONS(1404),
    [aux_sym_variable_token1] = ACTIONS(1404),
    [aux_sym_variable_token2] = ACTIONS(1404),
    [sym_braced_variable] = ACTIONS(1404),
    [anon_sym_SEMI] = ACTIONS(1404),
    [anon_sym_LPAREN] = ACTIONS(1404),
    [anon_sym_COMMA] = ACTIONS(1404),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_if] = ACTIONS(1404),
    [anon_sym_switch] = ACTIONS(1404),
    [anon_sym_foreach] = ACTIONS(1404),
    [anon_sym_for] = ACTIONS(1404),
    [anon_sym_while] = ACTIONS(1404),
    [anon_sym_do] = ACTIONS(1404),
    [anon_sym_function] = ACTIONS(1404),
    [anon_sym_filter] = ACTIONS(1404),
    [anon_sym_workflow] = ACTIONS(1404),
    [anon_sym_break] = ACTIONS(1404),
    [anon_sym_continue] = ACTIONS(1404),
    [anon_sym_throw] = ACTIONS(1404),
    [anon_sym_return] = ACTIONS(1404),
    [anon_sym_exit] = ACTIONS(1404),
    [sym_label] = ACTIONS(1404),
    [anon_sym_trap] = ACTIONS(1404),
    [anon_sym_try] = ACTIONS(1404),
    [anon_sym_catch] = ACTIONS(1438),
    [anon_sym_finally] = ACTIONS(1404),
    [anon_sym_data] = ACTIONS(1404),
    [anon_sym_inlinescript] = ACTIONS(1404),
    [anon_sym_parallel] = ACTIONS(1404),
    [anon_sym_sequence] = ACTIONS(1404),
    [anon_sym_AMP] = ACTIONS(1404),
    [aux_sym_command_name_token1] = ACTIONS(1404),
    [anon_sym_PERCENT] = ACTIONS(1404),
    [anon_sym_foreach_DASHobject] = ACTIONS(1404),
    [anon_sym_class] = ACTIONS(1404),
    [anon_sym_enum] = ACTIONS(1404),
    [anon_sym_PLUS] = ACTIONS(1404),
    [anon_sym_DASH] = ACTIONS(1404),
    [anon_sym_DASHnot] = ACTIONS(1404),
    [anon_sym_BANG] = ACTIONS(1404),
    [anon_sym_DASHbnot] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1404),
    [anon_sym_DASH_DASH] = ACTIONS(1404),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1404),
    [anon_sym_AT_LPAREN] = ACTIONS(1404),
    [anon_sym_AT_LBRACE] = ACTIONS(1404),
  },
  [351] = {
    [sym__literal] = STATE(290),
    [sym_integer_literal] = STATE(290),
    [sym_string_literal] = STATE(290),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(290),
    [sym__expression] = STATE(1859),
    [sym_logical_expression] = STATE(1398),
    [sym_bitwise_expression] = STATE(1299),
    [sym_comparison_expression] = STATE(564),
    [sym_additive_expression] = STATE(546),
    [sym_multiplicative_expression] = STATE(389),
    [sym_format_expression] = STATE(346),
    [sym_range_expression] = STATE(334),
    [sym_array_literal_expression] = STATE(308),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(290),
    [sym__value] = STATE(290),
    [sym_parenthesized_expression] = STATE(290),
    [sym_sub_expression] = STATE(290),
    [sym_array_expression] = STATE(290),
    [sym_script_block_expression] = STATE(290),
    [sym_hash_literal_expression] = STATE(290),
    [sym_post_increment_expression] = STATE(290),
    [sym_post_decrement_expression] = STATE(290),
    [sym_member_access] = STATE(290),
    [sym_element_access] = STATE(290),
    [sym_invokation_expression] = STATE(290),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(81),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(83),
    [sym_real_literal] = ACTIONS(547),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(87),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(89),
    [sym_verbatim_string_characters] = ACTIONS(91),
    [sym_verbatim_here_string_characters] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_DASHjoin] = ACTIONS(549),
    [anon_sym_DASHsplit] = ACTIONS(549),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(101),
    [anon_sym_DOLLAR_CARET] = ACTIONS(101),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(101),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(101),
    [sym_braced_variable] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_LBRACE] = ACTIONS(107),
    [anon_sym_PLUS] = ACTIONS(551),
    [anon_sym_DASH] = ACTIONS(551),
    [anon_sym_DASHnot] = ACTIONS(549),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_DASHbnot] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(553),
    [anon_sym_DASH_DASH] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(113),
    [anon_sym_AT_LPAREN] = ACTIONS(115),
    [anon_sym_AT_LBRACE] = ACTIONS(117),
  },
  [352] = {
    [sym__literal] = STATE(289),
    [sym_integer_literal] = STATE(289),
    [sym_string_literal] = STATE(289),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(289),
    [sym__expression] = STATE(1798),
    [sym_logical_expression] = STATE(1396),
    [sym_bitwise_expression] = STATE(1300),
    [sym_comparison_expression] = STATE(559),
    [sym_additive_expression] = STATE(554),
    [sym_multiplicative_expression] = STATE(387),
    [sym_format_expression] = STATE(370),
    [sym_range_expression] = STATE(345),
    [sym_array_literal_expression] = STATE(299),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(289),
    [sym__value] = STATE(289),
    [sym_parenthesized_expression] = STATE(289),
    [sym_sub_expression] = STATE(289),
    [sym_array_expression] = STATE(289),
    [sym_script_block_expression] = STATE(289),
    [sym_hash_literal_expression] = STATE(289),
    [sym_post_increment_expression] = STATE(289),
    [sym_post_decrement_expression] = STATE(289),
    [sym_member_access] = STATE(289),
    [sym_element_access] = STATE(289),
    [sym_invokation_expression] = STATE(289),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(76),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(121),
    [sym_real_literal] = ACTIONS(479),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(125),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(127),
    [sym_verbatim_string_characters] = ACTIONS(129),
    [sym_verbatim_here_string_characters] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_DASHjoin] = ACTIONS(483),
    [anon_sym_DASHsplit] = ACTIONS(483),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(135),
    [anon_sym_DOLLAR_CARET] = ACTIONS(135),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(135),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(135),
    [sym_braced_variable] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(485),
    [anon_sym_DASHnot] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_DASHbnot] = ACTIONS(483),
    [anon_sym_PLUS_PLUS] = ACTIONS(487),
    [anon_sym_DASH_DASH] = ACTIONS(489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_AT_LBRACE] = ACTIONS(153),
  },
  [353] = {
    [sym__literal] = STATE(290),
    [sym_integer_literal] = STATE(290),
    [sym_string_literal] = STATE(290),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(290),
    [sym__expression] = STATE(1824),
    [sym_logical_expression] = STATE(1398),
    [sym_bitwise_expression] = STATE(1299),
    [sym_comparison_expression] = STATE(564),
    [sym_additive_expression] = STATE(546),
    [sym_multiplicative_expression] = STATE(389),
    [sym_format_expression] = STATE(346),
    [sym_range_expression] = STATE(334),
    [sym_array_literal_expression] = STATE(308),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(290),
    [sym__value] = STATE(290),
    [sym_parenthesized_expression] = STATE(290),
    [sym_sub_expression] = STATE(290),
    [sym_array_expression] = STATE(290),
    [sym_script_block_expression] = STATE(290),
    [sym_hash_literal_expression] = STATE(290),
    [sym_post_increment_expression] = STATE(290),
    [sym_post_decrement_expression] = STATE(290),
    [sym_member_access] = STATE(290),
    [sym_element_access] = STATE(290),
    [sym_invokation_expression] = STATE(290),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(81),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(83),
    [sym_real_literal] = ACTIONS(547),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(87),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(89),
    [sym_verbatim_string_characters] = ACTIONS(91),
    [sym_verbatim_here_string_characters] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_DASHjoin] = ACTIONS(549),
    [anon_sym_DASHsplit] = ACTIONS(549),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(101),
    [anon_sym_DOLLAR_CARET] = ACTIONS(101),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(101),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(101),
    [sym_braced_variable] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_LBRACE] = ACTIONS(107),
    [anon_sym_PLUS] = ACTIONS(551),
    [anon_sym_DASH] = ACTIONS(551),
    [anon_sym_DASHnot] = ACTIONS(549),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_DASHbnot] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(553),
    [anon_sym_DASH_DASH] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(113),
    [anon_sym_AT_LPAREN] = ACTIONS(115),
    [anon_sym_AT_LBRACE] = ACTIONS(117),
  },
  [354] = {
    [sym__literal] = STATE(289),
    [sym_integer_literal] = STATE(289),
    [sym_string_literal] = STATE(289),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(289),
    [sym__expression] = STATE(1754),
    [sym_logical_expression] = STATE(1396),
    [sym_bitwise_expression] = STATE(1300),
    [sym_comparison_expression] = STATE(559),
    [sym_additive_expression] = STATE(554),
    [sym_multiplicative_expression] = STATE(387),
    [sym_format_expression] = STATE(370),
    [sym_range_expression] = STATE(345),
    [sym_array_literal_expression] = STATE(299),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(289),
    [sym__value] = STATE(289),
    [sym_parenthesized_expression] = STATE(289),
    [sym_sub_expression] = STATE(289),
    [sym_array_expression] = STATE(289),
    [sym_script_block_expression] = STATE(289),
    [sym_hash_literal_expression] = STATE(289),
    [sym_post_increment_expression] = STATE(289),
    [sym_post_decrement_expression] = STATE(289),
    [sym_member_access] = STATE(289),
    [sym_element_access] = STATE(289),
    [sym_invokation_expression] = STATE(289),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(76),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(121),
    [sym_real_literal] = ACTIONS(479),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(125),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(127),
    [sym_verbatim_string_characters] = ACTIONS(129),
    [sym_verbatim_here_string_characters] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_DASHjoin] = ACTIONS(483),
    [anon_sym_DASHsplit] = ACTIONS(483),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(135),
    [anon_sym_DOLLAR_CARET] = ACTIONS(135),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(135),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(135),
    [sym_braced_variable] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(485),
    [anon_sym_DASHnot] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_DASHbnot] = ACTIONS(483),
    [anon_sym_PLUS_PLUS] = ACTIONS(487),
    [anon_sym_DASH_DASH] = ACTIONS(489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_AT_LBRACE] = ACTIONS(153),
  },
  [355] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_DASHas] = ACTIONS(803),
    [anon_sym_DASHccontains] = ACTIONS(803),
    [anon_sym_DASHceq] = ACTIONS(803),
    [anon_sym_DASHcge] = ACTIONS(803),
    [anon_sym_DASHcgt] = ACTIONS(803),
    [anon_sym_DASHcle] = ACTIONS(803),
    [anon_sym_DASHclike] = ACTIONS(803),
    [anon_sym_DASHclt] = ACTIONS(803),
    [anon_sym_DASHcmatch] = ACTIONS(803),
    [anon_sym_DASHcne] = ACTIONS(803),
    [anon_sym_DASHcnotcontains] = ACTIONS(803),
    [anon_sym_DASHcnotlike] = ACTIONS(803),
    [anon_sym_DASHcnotmatch] = ACTIONS(803),
    [anon_sym_DASHcontains] = ACTIONS(803),
    [anon_sym_DASHcreplace] = ACTIONS(803),
    [anon_sym_DASHcsplit] = ACTIONS(803),
    [anon_sym_DASHeq] = ACTIONS(803),
    [anon_sym_DASHge] = ACTIONS(803),
    [anon_sym_DASHgt] = ACTIONS(803),
    [anon_sym_DASHicontains] = ACTIONS(803),
    [anon_sym_DASHieq] = ACTIONS(803),
    [anon_sym_DASHige] = ACTIONS(803),
    [anon_sym_DASHigt] = ACTIONS(803),
    [anon_sym_DASHile] = ACTIONS(803),
    [anon_sym_DASHilike] = ACTIONS(803),
    [anon_sym_DASHilt] = ACTIONS(803),
    [anon_sym_DASHimatch] = ACTIONS(803),
    [anon_sym_DASHin] = ACTIONS(805),
    [anon_sym_DASHine] = ACTIONS(803),
    [anon_sym_DASHinotcontains] = ACTIONS(803),
    [anon_sym_DASHinotlike] = ACTIONS(803),
    [anon_sym_DASHinotmatch] = ACTIONS(803),
    [anon_sym_DASHireplace] = ACTIONS(803),
    [anon_sym_DASHis] = ACTIONS(805),
    [anon_sym_DASHisnot] = ACTIONS(803),
    [anon_sym_DASHisplit] = ACTIONS(803),
    [anon_sym_DASHjoin] = ACTIONS(803),
    [anon_sym_DASHle] = ACTIONS(803),
    [anon_sym_DASHlike] = ACTIONS(803),
    [anon_sym_DASHlt] = ACTIONS(803),
    [anon_sym_DASHmatch] = ACTIONS(803),
    [anon_sym_DASHne] = ACTIONS(803),
    [anon_sym_DASHnotcontains] = ACTIONS(803),
    [anon_sym_DASHnotin] = ACTIONS(803),
    [anon_sym_DASHnotlike] = ACTIONS(803),
    [anon_sym_DASHnotmatch] = ACTIONS(803),
    [anon_sym_DASHreplace] = ACTIONS(803),
    [anon_sym_DASHshl] = ACTIONS(803),
    [anon_sym_DASHshr] = ACTIONS(803),
    [anon_sym_DASHsplit] = ACTIONS(803),
    [sym_format_operator] = ACTIONS(1441),
    [anon_sym_PERCENT] = ACTIONS(803),
    [anon_sym_DASHand] = ACTIONS(803),
    [anon_sym_DASHor] = ACTIONS(803),
    [anon_sym_DASHxor] = ACTIONS(803),
    [anon_sym_DASHband] = ACTIONS(803),
    [anon_sym_DASHbor] = ACTIONS(803),
    [anon_sym_DASHbxor] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_DASH] = ACTIONS(805),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_BSLASH] = ACTIONS(803),
    [anon_sym_STAR] = ACTIONS(803),
    [anon_sym_RBRACK] = ACTIONS(803),
  },
  [356] = {
    [sym__literal] = STATE(289),
    [sym_integer_literal] = STATE(289),
    [sym_string_literal] = STATE(289),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(289),
    [sym__expression] = STATE(1706),
    [sym_logical_expression] = STATE(1396),
    [sym_bitwise_expression] = STATE(1300),
    [sym_comparison_expression] = STATE(559),
    [sym_additive_expression] = STATE(554),
    [sym_multiplicative_expression] = STATE(387),
    [sym_format_expression] = STATE(370),
    [sym_range_expression] = STATE(345),
    [sym_array_literal_expression] = STATE(299),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(289),
    [sym__value] = STATE(289),
    [sym_parenthesized_expression] = STATE(289),
    [sym_sub_expression] = STATE(289),
    [sym_array_expression] = STATE(289),
    [sym_script_block_expression] = STATE(289),
    [sym_hash_literal_expression] = STATE(289),
    [sym_post_increment_expression] = STATE(289),
    [sym_post_decrement_expression] = STATE(289),
    [sym_member_access] = STATE(289),
    [sym_element_access] = STATE(289),
    [sym_invokation_expression] = STATE(289),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(76),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(121),
    [sym_real_literal] = ACTIONS(479),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(125),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(127),
    [sym_verbatim_string_characters] = ACTIONS(129),
    [sym_verbatim_here_string_characters] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_DASHjoin] = ACTIONS(483),
    [anon_sym_DASHsplit] = ACTIONS(483),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(135),
    [anon_sym_DOLLAR_CARET] = ACTIONS(135),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(135),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(135),
    [sym_braced_variable] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(485),
    [anon_sym_DASHnot] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_DASHbnot] = ACTIONS(483),
    [anon_sym_PLUS_PLUS] = ACTIONS(487),
    [anon_sym_DASH_DASH] = ACTIONS(489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_AT_LBRACE] = ACTIONS(153),
  },
  [357] = {
    [sym__literal] = STATE(289),
    [sym_integer_literal] = STATE(289),
    [sym_string_literal] = STATE(289),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(289),
    [sym__expression] = STATE(1776),
    [sym_logical_expression] = STATE(1396),
    [sym_bitwise_expression] = STATE(1300),
    [sym_comparison_expression] = STATE(559),
    [sym_additive_expression] = STATE(554),
    [sym_multiplicative_expression] = STATE(387),
    [sym_format_expression] = STATE(370),
    [sym_range_expression] = STATE(345),
    [sym_array_literal_expression] = STATE(299),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(289),
    [sym__value] = STATE(289),
    [sym_parenthesized_expression] = STATE(289),
    [sym_sub_expression] = STATE(289),
    [sym_array_expression] = STATE(289),
    [sym_script_block_expression] = STATE(289),
    [sym_hash_literal_expression] = STATE(289),
    [sym_post_increment_expression] = STATE(289),
    [sym_post_decrement_expression] = STATE(289),
    [sym_member_access] = STATE(289),
    [sym_element_access] = STATE(289),
    [sym_invokation_expression] = STATE(289),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(76),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(121),
    [sym_real_literal] = ACTIONS(479),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(125),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(127),
    [sym_verbatim_string_characters] = ACTIONS(129),
    [sym_verbatim_here_string_characters] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_DASHjoin] = ACTIONS(483),
    [anon_sym_DASHsplit] = ACTIONS(483),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(135),
    [anon_sym_DOLLAR_CARET] = ACTIONS(135),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(135),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(135),
    [sym_braced_variable] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(485),
    [anon_sym_DASHnot] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_DASHbnot] = ACTIONS(483),
    [anon_sym_PLUS_PLUS] = ACTIONS(487),
    [anon_sym_DASH_DASH] = ACTIONS(489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_AT_LBRACE] = ACTIONS(153),
  },
  [358] = {
    [sym_catch_clause] = STATE(350),
    [aux_sym_catch_clauses_repeat1] = STATE(350),
    [ts_builtin_sym_end] = ACTIONS(1443),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1381),
    [sym_hexadecimal_integer_literal] = ACTIONS(1381),
    [sym_real_literal] = ACTIONS(1381),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1381),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1381),
    [sym_verbatim_string_characters] = ACTIONS(1381),
    [sym_verbatim_here_string_characters] = ACTIONS(1381),
    [anon_sym_DOT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1381),
    [anon_sym_DASHjoin] = ACTIONS(1381),
    [anon_sym_DASHsplit] = ACTIONS(1381),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1381),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1381),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1381),
    [anon_sym_DOLLAR_] = ACTIONS(1381),
    [aux_sym_variable_token1] = ACTIONS(1381),
    [aux_sym_variable_token2] = ACTIONS(1381),
    [sym_braced_variable] = ACTIONS(1381),
    [anon_sym_SEMI] = ACTIONS(1381),
    [anon_sym_LPAREN] = ACTIONS(1381),
    [anon_sym_COMMA] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(1381),
    [anon_sym_if] = ACTIONS(1381),
    [anon_sym_switch] = ACTIONS(1381),
    [anon_sym_foreach] = ACTIONS(1381),
    [anon_sym_for] = ACTIONS(1381),
    [anon_sym_while] = ACTIONS(1381),
    [anon_sym_do] = ACTIONS(1381),
    [anon_sym_function] = ACTIONS(1381),
    [anon_sym_filter] = ACTIONS(1381),
    [anon_sym_workflow] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1381),
    [anon_sym_continue] = ACTIONS(1381),
    [anon_sym_throw] = ACTIONS(1381),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_exit] = ACTIONS(1381),
    [sym_label] = ACTIONS(1381),
    [anon_sym_trap] = ACTIONS(1381),
    [anon_sym_try] = ACTIONS(1381),
    [anon_sym_catch] = ACTIONS(1351),
    [anon_sym_finally] = ACTIONS(1381),
    [anon_sym_data] = ACTIONS(1381),
    [anon_sym_inlinescript] = ACTIONS(1381),
    [anon_sym_parallel] = ACTIONS(1381),
    [anon_sym_sequence] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [aux_sym_command_name_token1] = ACTIONS(1381),
    [anon_sym_PERCENT] = ACTIONS(1381),
    [anon_sym_foreach_DASHobject] = ACTIONS(1381),
    [anon_sym_class] = ACTIONS(1381),
    [anon_sym_enum] = ACTIONS(1381),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_DASHnot] = ACTIONS(1381),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_DASHbnot] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1381),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1381),
    [anon_sym_AT_LPAREN] = ACTIONS(1381),
    [anon_sym_AT_LBRACE] = ACTIONS(1381),
  },
  [359] = {
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1341),
    [sym_hexadecimal_integer_literal] = ACTIONS(1341),
    [sym_real_literal] = ACTIONS(1341),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1341),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1341),
    [sym_verbatim_string_characters] = ACTIONS(1341),
    [sym_verbatim_here_string_characters] = ACTIONS(1341),
    [anon_sym_LBRACK] = ACTIONS(1341),
    [anon_sym_GT] = ACTIONS(1341),
    [anon_sym_GT_GT] = ACTIONS(1341),
    [anon_sym_2_GT] = ACTIONS(1341),
    [anon_sym_2_GT_GT] = ACTIONS(1341),
    [anon_sym_3_GT] = ACTIONS(1341),
    [anon_sym_3_GT_GT] = ACTIONS(1341),
    [anon_sym_4_GT] = ACTIONS(1341),
    [anon_sym_4_GT_GT] = ACTIONS(1341),
    [anon_sym_5_GT] = ACTIONS(1341),
    [anon_sym_5_GT_GT] = ACTIONS(1341),
    [anon_sym_6_GT] = ACTIONS(1341),
    [anon_sym_6_GT_GT] = ACTIONS(1341),
    [anon_sym_STAR_GT] = ACTIONS(1341),
    [anon_sym_STAR_GT_GT] = ACTIONS(1341),
    [anon_sym_LT] = ACTIONS(1341),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(1341),
    [anon_sym_2_GT_AMP1] = ACTIONS(1341),
    [anon_sym_3_GT_AMP1] = ACTIONS(1341),
    [anon_sym_4_GT_AMP1] = ACTIONS(1341),
    [anon_sym_5_GT_AMP1] = ACTIONS(1341),
    [anon_sym_6_GT_AMP1] = ACTIONS(1341),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(1341),
    [anon_sym_1_GT_AMP2] = ACTIONS(1341),
    [anon_sym_3_GT_AMP2] = ACTIONS(1341),
    [anon_sym_4_GT_AMP2] = ACTIONS(1341),
    [anon_sym_5_GT_AMP2] = ACTIONS(1341),
    [anon_sym_6_GT_AMP2] = ACTIONS(1341),
    [anon_sym_DASHjoin] = ACTIONS(1341),
    [anon_sym_DASHsplit] = ACTIONS(1341),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1341),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1341),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1341),
    [anon_sym_DOLLAR_] = ACTIONS(1341),
    [aux_sym_variable_token1] = ACTIONS(1341),
    [aux_sym_variable_token2] = ACTIONS(1341),
    [sym_braced_variable] = ACTIONS(1341),
    [sym_generic_token] = ACTIONS(1341),
    [sym_command_parameter] = ACTIONS(1341),
    [anon_sym_LPAREN] = ACTIONS(1341),
    [anon_sym_COMMA] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1341),
    [anon_sym_PIPE] = ACTIONS(1341),
    [sym_stop_parsing] = ACTIONS(1341),
    [anon_sym_SPACE] = ACTIONS(1341),
    [anon_sym_COLON] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_DASHnot] = ACTIONS(1341),
    [anon_sym_BANG] = ACTIONS(1341),
    [anon_sym_DASHbnot] = ACTIONS(1341),
    [anon_sym_PLUS_PLUS] = ACTIONS(1341),
    [anon_sym_DASH_DASH] = ACTIONS(1341),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1341),
    [anon_sym_AT_LPAREN] = ACTIONS(1341),
    [anon_sym_AT_LBRACE] = ACTIONS(1341),
    [sym__statement_terminator] = ACTIONS(1345),
  },
  [360] = {
    [sym__literal] = STATE(290),
    [sym_integer_literal] = STATE(290),
    [sym_string_literal] = STATE(290),
    [sym_expandable_string_literal] = STATE(124),
    [sym_expandable_here_string_literal] = STATE(124),
    [sym_variable] = STATE(290),
    [sym__expression] = STATE(1841),
    [sym_logical_expression] = STATE(1398),
    [sym_bitwise_expression] = STATE(1299),
    [sym_comparison_expression] = STATE(564),
    [sym_additive_expression] = STATE(546),
    [sym_multiplicative_expression] = STATE(389),
    [sym_format_expression] = STATE(346),
    [sym_range_expression] = STATE(334),
    [sym_array_literal_expression] = STATE(308),
    [sym_unary_expression] = STATE(173),
    [sym_expression_with_unary_operator] = STATE(172),
    [sym_pre_increment_expression] = STATE(171),
    [sym_pre_decrement_expression] = STATE(171),
    [sym_cast_expression] = STATE(171),
    [sym__primary_expression] = STATE(290),
    [sym__value] = STATE(290),
    [sym_parenthesized_expression] = STATE(290),
    [sym_sub_expression] = STATE(290),
    [sym_array_expression] = STATE(290),
    [sym_script_block_expression] = STATE(290),
    [sym_hash_literal_expression] = STATE(290),
    [sym_post_increment_expression] = STATE(290),
    [sym_post_decrement_expression] = STATE(290),
    [sym_member_access] = STATE(290),
    [sym_element_access] = STATE(290),
    [sym_invokation_expression] = STATE(290),
    [sym_invokation_foreach_expression] = STATE(143),
    [sym_type_literal] = STATE(81),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(5),
    [sym_hexadecimal_integer_literal] = ACTIONS(83),
    [sym_real_literal] = ACTIONS(547),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(87),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(89),
    [sym_verbatim_string_characters] = ACTIONS(91),
    [sym_verbatim_here_string_characters] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_DASHjoin] = ACTIONS(549),
    [anon_sym_DASHsplit] = ACTIONS(549),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(101),
    [anon_sym_DOLLAR_CARET] = ACTIONS(101),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(101),
    [anon_sym_DOLLAR_] = ACTIONS(21),
    [aux_sym_variable_token1] = ACTIONS(21),
    [aux_sym_variable_token2] = ACTIONS(101),
    [sym_braced_variable] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_LBRACE] = ACTIONS(107),
    [anon_sym_PLUS] = ACTIONS(551),
    [anon_sym_DASH] = ACTIONS(551),
    [anon_sym_DASHnot] = ACTIONS(549),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_DASHbnot] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(553),
    [anon_sym_DASH_DASH] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(113),
    [anon_sym_AT_LPAREN] = ACTIONS(115),
    [anon_sym_AT_LBRACE] = ACTIONS(117),
  },
  [361] = {
    [sym__literal] = STATE(289),
    [sym_integer_literal] = STATE(289),
    [sym_string_literal] = STATE(289),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(289),
    [sym__expression] = STATE(2042),
    [sym_logical_expression] = STATE(1396),
    [sym_bitwise_expression] = STATE(1300),
    [sym_comparison_expression] = STATE(559),
    [sym_additive_expression] = STATE(554),
    [sym_multiplicative_expression] = STATE(387),
    [sym_format_expression] = STATE(370),
    [sym_range_expression] = STATE(345),
    [sym_array_literal_expression] = STATE(299),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(289),
    [sym__value] = STATE(289),
    [sym_parenthesized_expression] = STATE(289),
    [sym_sub_expression] = STATE(289),
    [sym_array_expression] = STATE(289),
    [sym_script_block_expression] = STATE(289),
    [sym_hash_literal_expression] = STATE(289),
    [sym_post_increment_expression] = STATE(289),
    [sym_post_decrement_expression] = STATE(289),
    [sym_member_access] = STATE(289),
    [sym_element_access] = STATE(289),
    [sym_invokation_expression] = STATE(289),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(76),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(121),
    [sym_real_literal] = ACTIONS(479),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(125),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(127),
    [sym_verbatim_string_characters] = ACTIONS(129),
    [sym_verbatim_here_string_characters] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_DASHjoin] = ACTIONS(483),
    [anon_sym_DASHsplit] = ACTIONS(483),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(135),
    [anon_sym_DOLLAR_CARET] = ACTIONS(135),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(135),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(135),
    [sym_braced_variable] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(485),
    [anon_sym_DASHnot] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_DASHbnot] = ACTIONS(483),
    [anon_sym_PLUS_PLUS] = ACTIONS(487),
    [anon_sym_DASH_DASH] = ACTIONS(489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_AT_LBRACE] = ACTIONS(153),
  },
  [362] = {
    [sym__literal] = STATE(289),
    [sym_integer_literal] = STATE(289),
    [sym_string_literal] = STATE(289),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(289),
    [sym__expression] = STATE(1738),
    [sym_logical_expression] = STATE(1396),
    [sym_bitwise_expression] = STATE(1300),
    [sym_comparison_expression] = STATE(559),
    [sym_additive_expression] = STATE(554),
    [sym_multiplicative_expression] = STATE(387),
    [sym_format_expression] = STATE(370),
    [sym_range_expression] = STATE(345),
    [sym_array_literal_expression] = STATE(299),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(289),
    [sym__value] = STATE(289),
    [sym_parenthesized_expression] = STATE(289),
    [sym_sub_expression] = STATE(289),
    [sym_array_expression] = STATE(289),
    [sym_script_block_expression] = STATE(289),
    [sym_hash_literal_expression] = STATE(289),
    [sym_post_increment_expression] = STATE(289),
    [sym_post_decrement_expression] = STATE(289),
    [sym_member_access] = STATE(289),
    [sym_element_access] = STATE(289),
    [sym_invokation_expression] = STATE(289),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(76),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(121),
    [sym_real_literal] = ACTIONS(479),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(125),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(127),
    [sym_verbatim_string_characters] = ACTIONS(129),
    [sym_verbatim_here_string_characters] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_DASHjoin] = ACTIONS(483),
    [anon_sym_DASHsplit] = ACTIONS(483),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(135),
    [anon_sym_DOLLAR_CARET] = ACTIONS(135),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(135),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(135),
    [sym_braced_variable] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(485),
    [anon_sym_DASHnot] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_DASHbnot] = ACTIONS(483),
    [anon_sym_PLUS_PLUS] = ACTIONS(487),
    [anon_sym_DASH_DASH] = ACTIONS(489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_AT_LBRACE] = ACTIONS(153),
  },
  [363] = {
    [sym__literal] = STATE(289),
    [sym_integer_literal] = STATE(289),
    [sym_string_literal] = STATE(289),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(289),
    [sym__expression] = STATE(1750),
    [sym_logical_expression] = STATE(1396),
    [sym_bitwise_expression] = STATE(1300),
    [sym_comparison_expression] = STATE(559),
    [sym_additive_expression] = STATE(554),
    [sym_multiplicative_expression] = STATE(387),
    [sym_format_expression] = STATE(370),
    [sym_range_expression] = STATE(345),
    [sym_array_literal_expression] = STATE(299),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(289),
    [sym__value] = STATE(289),
    [sym_parenthesized_expression] = STATE(289),
    [sym_sub_expression] = STATE(289),
    [sym_array_expression] = STATE(289),
    [sym_script_block_expression] = STATE(289),
    [sym_hash_literal_expression] = STATE(289),
    [sym_post_increment_expression] = STATE(289),
    [sym_post_decrement_expression] = STATE(289),
    [sym_member_access] = STATE(289),
    [sym_element_access] = STATE(289),
    [sym_invokation_expression] = STATE(289),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(76),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(121),
    [sym_real_literal] = ACTIONS(479),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(125),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(127),
    [sym_verbatim_string_characters] = ACTIONS(129),
    [sym_verbatim_here_string_characters] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_DASHjoin] = ACTIONS(483),
    [anon_sym_DASHsplit] = ACTIONS(483),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(135),
    [anon_sym_DOLLAR_CARET] = ACTIONS(135),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(135),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(135),
    [sym_braced_variable] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(485),
    [anon_sym_DASHnot] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_DASHbnot] = ACTIONS(483),
    [anon_sym_PLUS_PLUS] = ACTIONS(487),
    [anon_sym_DASH_DASH] = ACTIONS(489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_AT_LBRACE] = ACTIONS(153),
  },
  [364] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_DASHas] = ACTIONS(803),
    [anon_sym_DASHccontains] = ACTIONS(803),
    [anon_sym_DASHceq] = ACTIONS(803),
    [anon_sym_DASHcge] = ACTIONS(803),
    [anon_sym_DASHcgt] = ACTIONS(803),
    [anon_sym_DASHcle] = ACTIONS(803),
    [anon_sym_DASHclike] = ACTIONS(803),
    [anon_sym_DASHclt] = ACTIONS(803),
    [anon_sym_DASHcmatch] = ACTIONS(803),
    [anon_sym_DASHcne] = ACTIONS(803),
    [anon_sym_DASHcnotcontains] = ACTIONS(803),
    [anon_sym_DASHcnotlike] = ACTIONS(803),
    [anon_sym_DASHcnotmatch] = ACTIONS(803),
    [anon_sym_DASHcontains] = ACTIONS(803),
    [anon_sym_DASHcreplace] = ACTIONS(803),
    [anon_sym_DASHcsplit] = ACTIONS(803),
    [anon_sym_DASHeq] = ACTIONS(803),
    [anon_sym_DASHge] = ACTIONS(803),
    [anon_sym_DASHgt] = ACTIONS(803),
    [anon_sym_DASHicontains] = ACTIONS(803),
    [anon_sym_DASHieq] = ACTIONS(803),
    [anon_sym_DASHige] = ACTIONS(803),
    [anon_sym_DASHigt] = ACTIONS(803),
    [anon_sym_DASHile] = ACTIONS(803),
    [anon_sym_DASHilike] = ACTIONS(803),
    [anon_sym_DASHilt] = ACTIONS(803),
    [anon_sym_DASHimatch] = ACTIONS(803),
    [anon_sym_DASHin] = ACTIONS(805),
    [anon_sym_DASHine] = ACTIONS(803),
    [anon_sym_DASHinotcontains] = ACTIONS(803),
    [anon_sym_DASHinotlike] = ACTIONS(803),
    [anon_sym_DASHinotmatch] = ACTIONS(803),
    [anon_sym_DASHireplace] = ACTIONS(803),
    [anon_sym_DASHis] = ACTIONS(805),
    [anon_sym_DASHisnot] = ACTIONS(803),
    [anon_sym_DASHisplit] = ACTIONS(803),
    [anon_sym_DASHjoin] = ACTIONS(803),
    [anon_sym_DASHle] = ACTIONS(803),
    [anon_sym_DASHlike] = ACTIONS(803),
    [anon_sym_DASHlt] = ACTIONS(803),
    [anon_sym_DASHmatch] = ACTIONS(803),
    [anon_sym_DASHne] = ACTIONS(803),
    [anon_sym_DASHnotcontains] = ACTIONS(803),
    [anon_sym_DASHnotin] = ACTIONS(803),
    [anon_sym_DASHnotlike] = ACTIONS(803),
    [anon_sym_DASHnotmatch] = ACTIONS(803),
    [anon_sym_DASHreplace] = ACTIONS(803),
    [anon_sym_DASHshl] = ACTIONS(803),
    [anon_sym_DASHshr] = ACTIONS(803),
    [anon_sym_DASHsplit] = ACTIONS(803),
    [sym_format_operator] = ACTIONS(1432),
    [anon_sym_PERCENT] = ACTIONS(803),
    [anon_sym_DASHand] = ACTIONS(803),
    [anon_sym_DASHor] = ACTIONS(803),
    [anon_sym_DASHxor] = ACTIONS(803),
    [anon_sym_DASHband] = ACTIONS(803),
    [anon_sym_DASHbor] = ACTIONS(803),
    [anon_sym_DASHbxor] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_DASH] = ACTIONS(805),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_BSLASH] = ACTIONS(803),
    [anon_sym_STAR] = ACTIONS(803),
    [sym__statement_terminator] = ACTIONS(803),
  },
  [365] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_DASHas] = ACTIONS(817),
    [anon_sym_DASHccontains] = ACTIONS(817),
    [anon_sym_DASHceq] = ACTIONS(817),
    [anon_sym_DASHcge] = ACTIONS(817),
    [anon_sym_DASHcgt] = ACTIONS(817),
    [anon_sym_DASHcle] = ACTIONS(817),
    [anon_sym_DASHclike] = ACTIONS(817),
    [anon_sym_DASHclt] = ACTIONS(817),
    [anon_sym_DASHcmatch] = ACTIONS(817),
    [anon_sym_DASHcne] = ACTIONS(817),
    [anon_sym_DASHcnotcontains] = ACTIONS(817),
    [anon_sym_DASHcnotlike] = ACTIONS(817),
    [anon_sym_DASHcnotmatch] = ACTIONS(817),
    [anon_sym_DASHcontains] = ACTIONS(817),
    [anon_sym_DASHcreplace] = ACTIONS(817),
    [anon_sym_DASHcsplit] = ACTIONS(817),
    [anon_sym_DASHeq] = ACTIONS(817),
    [anon_sym_DASHge] = ACTIONS(817),
    [anon_sym_DASHgt] = ACTIONS(817),
    [anon_sym_DASHicontains] = ACTIONS(817),
    [anon_sym_DASHieq] = ACTIONS(817),
    [anon_sym_DASHige] = ACTIONS(817),
    [anon_sym_DASHigt] = ACTIONS(817),
    [anon_sym_DASHile] = ACTIONS(817),
    [anon_sym_DASHilike] = ACTIONS(817),
    [anon_sym_DASHilt] = ACTIONS(817),
    [anon_sym_DASHimatch] = ACTIONS(817),
    [anon_sym_DASHin] = ACTIONS(819),
    [anon_sym_DASHine] = ACTIONS(817),
    [anon_sym_DASHinotcontains] = ACTIONS(817),
    [anon_sym_DASHinotlike] = ACTIONS(817),
    [anon_sym_DASHinotmatch] = ACTIONS(817),
    [anon_sym_DASHireplace] = ACTIONS(817),
    [anon_sym_DASHis] = ACTIONS(819),
    [anon_sym_DASHisnot] = ACTIONS(817),
    [anon_sym_DASHisplit] = ACTIONS(817),
    [anon_sym_DASHjoin] = ACTIONS(817),
    [anon_sym_DASHle] = ACTIONS(817),
    [anon_sym_DASHlike] = ACTIONS(817),
    [anon_sym_DASHlt] = ACTIONS(817),
    [anon_sym_DASHmatch] = ACTIONS(817),
    [anon_sym_DASHne] = ACTIONS(817),
    [anon_sym_DASHnotcontains] = ACTIONS(817),
    [anon_sym_DASHnotin] = ACTIONS(817),
    [anon_sym_DASHnotlike] = ACTIONS(817),
    [anon_sym_DASHnotmatch] = ACTIONS(817),
    [anon_sym_DASHreplace] = ACTIONS(817),
    [anon_sym_DASHshl] = ACTIONS(817),
    [anon_sym_DASHshr] = ACTIONS(817),
    [anon_sym_DASHsplit] = ACTIONS(817),
    [anon_sym_RPAREN] = ACTIONS(817),
    [anon_sym_COMMA] = ACTIONS(817),
    [anon_sym_PERCENT] = ACTIONS(1434),
    [anon_sym_DASHand] = ACTIONS(817),
    [anon_sym_DASHor] = ACTIONS(817),
    [anon_sym_DASHxor] = ACTIONS(817),
    [anon_sym_DASHband] = ACTIONS(817),
    [anon_sym_DASHbor] = ACTIONS(817),
    [anon_sym_DASHbxor] = ACTIONS(817),
    [anon_sym_PLUS] = ACTIONS(817),
    [anon_sym_DASH] = ACTIONS(819),
    [anon_sym_SLASH] = ACTIONS(1434),
    [anon_sym_BSLASH] = ACTIONS(1434),
    [anon_sym_STAR] = ACTIONS(1434),
  },
  [366] = {
    [sym__literal] = STATE(289),
    [sym_integer_literal] = STATE(289),
    [sym_string_literal] = STATE(289),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(289),
    [sym__expression] = STATE(1561),
    [sym_logical_expression] = STATE(1360),
    [sym_bitwise_expression] = STATE(1286),
    [sym_comparison_expression] = STATE(540),
    [sym_additive_expression] = STATE(535),
    [sym_multiplicative_expression] = STATE(365),
    [sym_format_expression] = STATE(316),
    [sym_range_expression] = STATE(301),
    [sym_array_literal_expression] = STATE(304),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(289),
    [sym__value] = STATE(289),
    [sym_parenthesized_expression] = STATE(289),
    [sym_sub_expression] = STATE(289),
    [sym_array_expression] = STATE(289),
    [sym_script_block_expression] = STATE(289),
    [sym_hash_literal_expression] = STATE(289),
    [sym_post_increment_expression] = STATE(289),
    [sym_post_decrement_expression] = STATE(289),
    [sym_member_access] = STATE(289),
    [sym_element_access] = STATE(289),
    [sym_invokation_expression] = STATE(289),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(76),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(121),
    [sym_real_literal] = ACTIONS(479),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(125),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(127),
    [sym_verbatim_string_characters] = ACTIONS(129),
    [sym_verbatim_here_string_characters] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_DASHjoin] = ACTIONS(483),
    [anon_sym_DASHsplit] = ACTIONS(483),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(135),
    [anon_sym_DOLLAR_CARET] = ACTIONS(135),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(135),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(135),
    [sym_braced_variable] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(485),
    [anon_sym_DASHnot] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_DASHbnot] = ACTIONS(483),
    [anon_sym_PLUS_PLUS] = ACTIONS(487),
    [anon_sym_DASH_DASH] = ACTIONS(489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_AT_LBRACE] = ACTIONS(153),
  },
  [367] = {
    [sym_elseif_clause] = STATE(371),
    [aux_sym_elseif_clauses_repeat1] = STATE(371),
    [ts_builtin_sym_end] = ACTIONS(1445),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1392),
    [sym_hexadecimal_integer_literal] = ACTIONS(1392),
    [sym_real_literal] = ACTIONS(1392),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1392),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1392),
    [sym_verbatim_string_characters] = ACTIONS(1392),
    [sym_verbatim_here_string_characters] = ACTIONS(1392),
    [anon_sym_DOT] = ACTIONS(1392),
    [anon_sym_LBRACK] = ACTIONS(1392),
    [anon_sym_DASHjoin] = ACTIONS(1392),
    [anon_sym_DASHsplit] = ACTIONS(1392),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1392),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1392),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1392),
    [anon_sym_DOLLAR_] = ACTIONS(1392),
    [aux_sym_variable_token1] = ACTIONS(1392),
    [aux_sym_variable_token2] = ACTIONS(1392),
    [sym_braced_variable] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(1392),
    [anon_sym_COMMA] = ACTIONS(1392),
    [anon_sym_LBRACE] = ACTIONS(1392),
    [anon_sym_if] = ACTIONS(1392),
    [anon_sym_elseif] = ACTIONS(1357),
    [anon_sym_else] = ACTIONS(1392),
    [anon_sym_switch] = ACTIONS(1392),
    [anon_sym_foreach] = ACTIONS(1392),
    [anon_sym_for] = ACTIONS(1392),
    [anon_sym_while] = ACTIONS(1392),
    [anon_sym_do] = ACTIONS(1392),
    [anon_sym_function] = ACTIONS(1392),
    [anon_sym_filter] = ACTIONS(1392),
    [anon_sym_workflow] = ACTIONS(1392),
    [anon_sym_break] = ACTIONS(1392),
    [anon_sym_continue] = ACTIONS(1392),
    [anon_sym_throw] = ACTIONS(1392),
    [anon_sym_return] = ACTIONS(1392),
    [anon_sym_exit] = ACTIONS(1392),
    [sym_label] = ACTIONS(1392),
    [anon_sym_trap] = ACTIONS(1392),
    [anon_sym_try] = ACTIONS(1392),
    [anon_sym_data] = ACTIONS(1392),
    [anon_sym_inlinescript] = ACTIONS(1392),
    [anon_sym_parallel] = ACTIONS(1392),
    [anon_sym_sequence] = ACTIONS(1392),
    [anon_sym_AMP] = ACTIONS(1392),
    [aux_sym_command_name_token1] = ACTIONS(1392),
    [anon_sym_PERCENT] = ACTIONS(1392),
    [anon_sym_foreach_DASHobject] = ACTIONS(1392),
    [anon_sym_class] = ACTIONS(1392),
    [anon_sym_enum] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DASHnot] = ACTIONS(1392),
    [anon_sym_BANG] = ACTIONS(1392),
    [anon_sym_DASHbnot] = ACTIONS(1392),
    [anon_sym_PLUS_PLUS] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1392),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1392),
    [anon_sym_AT_LPAREN] = ACTIONS(1392),
    [anon_sym_AT_LBRACE] = ACTIONS(1392),
  },
  [368] = {
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1447),
    [sym_hexadecimal_integer_literal] = ACTIONS(1447),
    [sym_real_literal] = ACTIONS(1447),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1447),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1447),
    [sym_verbatim_string_characters] = ACTIONS(1447),
    [sym_verbatim_here_string_characters] = ACTIONS(1447),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(1447),
    [anon_sym_DASHjoin] = ACTIONS(1447),
    [anon_sym_DASHsplit] = ACTIONS(1447),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1447),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1447),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1447),
    [anon_sym_DOLLAR_] = ACTIONS(1447),
    [aux_sym_variable_token1] = ACTIONS(1447),
    [aux_sym_variable_token2] = ACTIONS(1447),
    [sym_braced_variable] = ACTIONS(1447),
    [anon_sym_SEMI] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1447),
    [anon_sym_COMMA] = ACTIONS(1447),
    [anon_sym_dynamicparam] = ACTIONS(1449),
    [anon_sym_begin] = ACTIONS(1449),
    [anon_sym_process] = ACTIONS(1449),
    [anon_sym_end] = ACTIONS(1449),
    [anon_sym_LBRACE] = ACTIONS(1447),
    [anon_sym_RBRACE] = ACTIONS(1447),
    [anon_sym_if] = ACTIONS(1447),
    [anon_sym_switch] = ACTIONS(1447),
    [anon_sym_foreach] = ACTIONS(1447),
    [anon_sym_for] = ACTIONS(1447),
    [anon_sym_while] = ACTIONS(1447),
    [anon_sym_do] = ACTIONS(1447),
    [anon_sym_function] = ACTIONS(1447),
    [anon_sym_filter] = ACTIONS(1447),
    [anon_sym_workflow] = ACTIONS(1447),
    [anon_sym_break] = ACTIONS(1447),
    [anon_sym_continue] = ACTIONS(1447),
    [anon_sym_throw] = ACTIONS(1447),
    [anon_sym_return] = ACTIONS(1447),
    [anon_sym_exit] = ACTIONS(1447),
    [sym_label] = ACTIONS(1447),
    [anon_sym_trap] = ACTIONS(1447),
    [anon_sym_try] = ACTIONS(1447),
    [anon_sym_data] = ACTIONS(1447),
    [anon_sym_inlinescript] = ACTIONS(1447),
    [anon_sym_parallel] = ACTIONS(1447),
    [anon_sym_sequence] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [aux_sym_command_name_token1] = ACTIONS(1447),
    [anon_sym_PERCENT] = ACTIONS(1447),
    [anon_sym_foreach_DASHobject] = ACTIONS(1447),
    [anon_sym_class] = ACTIONS(1447),
    [anon_sym_enum] = ACTIONS(1447),
    [anon_sym_PLUS] = ACTIONS(1447),
    [anon_sym_DASH] = ACTIONS(1447),
    [anon_sym_DASHnot] = ACTIONS(1447),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_DASHbnot] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1447),
    [anon_sym_AT_LPAREN] = ACTIONS(1447),
    [anon_sym_AT_LBRACE] = ACTIONS(1447),
  },
  [369] = {
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1341),
    [sym_hexadecimal_integer_literal] = ACTIONS(1341),
    [sym_real_literal] = ACTIONS(1341),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1341),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1341),
    [sym_verbatim_string_characters] = ACTIONS(1341),
    [sym_verbatim_here_string_characters] = ACTIONS(1341),
    [anon_sym_LBRACK] = ACTIONS(1341),
    [anon_sym_GT] = ACTIONS(1341),
    [anon_sym_GT_GT] = ACTIONS(1341),
    [anon_sym_2_GT] = ACTIONS(1341),
    [anon_sym_2_GT_GT] = ACTIONS(1341),
    [anon_sym_3_GT] = ACTIONS(1341),
    [anon_sym_3_GT_GT] = ACTIONS(1341),
    [anon_sym_4_GT] = ACTIONS(1341),
    [anon_sym_4_GT_GT] = ACTIONS(1341),
    [anon_sym_5_GT] = ACTIONS(1341),
    [anon_sym_5_GT_GT] = ACTIONS(1341),
    [anon_sym_6_GT] = ACTIONS(1341),
    [anon_sym_6_GT_GT] = ACTIONS(1341),
    [anon_sym_STAR_GT] = ACTIONS(1341),
    [anon_sym_STAR_GT_GT] = ACTIONS(1341),
    [anon_sym_LT] = ACTIONS(1341),
    [anon_sym_STAR_GT_AMP1] = ACTIONS(1341),
    [anon_sym_2_GT_AMP1] = ACTIONS(1341),
    [anon_sym_3_GT_AMP1] = ACTIONS(1341),
    [anon_sym_4_GT_AMP1] = ACTIONS(1341),
    [anon_sym_5_GT_AMP1] = ACTIONS(1341),
    [anon_sym_6_GT_AMP1] = ACTIONS(1341),
    [anon_sym_STAR_GT_AMP2] = ACTIONS(1341),
    [anon_sym_1_GT_AMP2] = ACTIONS(1341),
    [anon_sym_3_GT_AMP2] = ACTIONS(1341),
    [anon_sym_4_GT_AMP2] = ACTIONS(1341),
    [anon_sym_5_GT_AMP2] = ACTIONS(1341),
    [anon_sym_6_GT_AMP2] = ACTIONS(1341),
    [anon_sym_DASHjoin] = ACTIONS(1341),
    [anon_sym_DASHsplit] = ACTIONS(1341),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1341),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1341),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1341),
    [anon_sym_DOLLAR_] = ACTIONS(1341),
    [aux_sym_variable_token1] = ACTIONS(1341),
    [aux_sym_variable_token2] = ACTIONS(1341),
    [sym_braced_variable] = ACTIONS(1341),
    [sym_generic_token] = ACTIONS(1341),
    [sym_command_parameter] = ACTIONS(1341),
    [anon_sym_LPAREN] = ACTIONS(1341),
    [anon_sym_RPAREN] = ACTIONS(1341),
    [anon_sym_COMMA] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1341),
    [anon_sym_PIPE] = ACTIONS(1341),
    [sym_stop_parsing] = ACTIONS(1341),
    [anon_sym_SPACE] = ACTIONS(1341),
    [anon_sym_COLON] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_DASHnot] = ACTIONS(1341),
    [anon_sym_BANG] = ACTIONS(1341),
    [anon_sym_DASHbnot] = ACTIONS(1341),
    [anon_sym_PLUS_PLUS] = ACTIONS(1341),
    [anon_sym_DASH_DASH] = ACTIONS(1341),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1341),
    [anon_sym_AT_LPAREN] = ACTIONS(1341),
    [anon_sym_AT_LBRACE] = ACTIONS(1341),
  },
  [370] = {
    [sym_comment] = ACTIONS(81),
    [anon_sym_DASHas] = ACTIONS(797),
    [anon_sym_DASHccontains] = ACTIONS(797),
    [anon_sym_DASHceq] = ACTIONS(797),
    [anon_sym_DASHcge] = ACTIONS(797),
    [anon_sym_DASHcgt] = ACTIONS(797),
    [anon_sym_DASHcle] = ACTIONS(797),
    [anon_sym_DASHclike] = ACTIONS(797),
    [anon_sym_DASHclt] = ACTIONS(797),
    [anon_sym_DASHcmatch] = ACTIONS(797),
    [anon_sym_DASHcne] = ACTIONS(797),
    [anon_sym_DASHcnotcontains] = ACTIONS(797),
    [anon_sym_DASHcnotlike] = ACTIONS(797),
    [anon_sym_DASHcnotmatch] = ACTIONS(797),
    [anon_sym_DASHcontains] = ACTIONS(797),
    [anon_sym_DASHcreplace] = ACTIONS(797),
    [anon_sym_DASHcsplit] = ACTIONS(797),
    [anon_sym_DASHeq] = ACTIONS(797),
    [anon_sym_DASHge] = ACTIONS(797),
    [anon_sym_DASHgt] = ACTIONS(797),
    [anon_sym_DASHicontains] = ACTIONS(797),
    [anon_sym_DASHieq] = ACTIONS(797),
    [anon_sym_DASHige] = ACTIONS(797),
    [anon_sym_DASHigt] = ACTIONS(797),
    [anon_sym_DASHile] = ACTIONS(797),
    [anon_sym_DASHilike] = ACTIONS(797),
    [anon_sym_DASHilt] = ACTIONS(797),
    [anon_sym_DASHimatch] = ACTIONS(797),
    [anon_sym_DASHin] = ACTIONS(799),
    [anon_sym_DASHine] = ACTIONS(797),
    [anon_sym_DASHinotcontains] = ACTIONS(797),
    [anon_sym_DASHinotlike] = ACTIONS(797),
    [anon_sym_DASHinotmatch] = ACTIONS(797),
    [anon_sym_DASHireplace] = ACTIONS(797),
    [anon_sym_DASHis] = ACTIONS(799),
    [anon_sym_DASHisnot] = ACTIONS(797),
    [anon_sym_DASHisplit] = ACTIONS(797),
    [anon_sym_DASHjoin] = ACTIONS(797),
    [anon_sym_DASHle] = ACTIONS(797),
    [anon_sym_DASHlike] = ACTIONS(797),
    [anon_sym_DASHlt] = ACTIONS(797),
    [anon_sym_DASHmatch] = ACTIONS(797),
    [anon_sym_DASHne] = ACTIONS(797),
    [anon_sym_DASHnotcontains] = ACTIONS(797),
    [anon_sym_DASHnotin] = ACTIONS(797),
    [anon_sym_DASHnotlike] = ACTIONS(797),
    [anon_sym_DASHnotmatch] = ACTIONS(797),
    [anon_sym_DASHreplace] = ACTIONS(797),
    [anon_sym_DASHshl] = ACTIONS(797),
    [anon_sym_DASHshr] = ACTIONS(797),
    [anon_sym_DASHsplit] = ACTIONS(797),
    [sym_format_operator] = ACTIONS(1441),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_DASHand] = ACTIONS(797),
    [anon_sym_DASHor] = ACTIONS(797),
    [anon_sym_DASHxor] = ACTIONS(797),
    [anon_sym_DASHband] = ACTIONS(797),
    [anon_sym_DASHbor] = ACTIONS(797),
    [anon_sym_DASHbxor] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(797),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_BSLASH] = ACTIONS(797),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_RBRACK] = ACTIONS(797),
  },
  [371] = {
    [sym_elseif_clause] = STATE(371),
    [aux_sym_elseif_clauses_repeat1] = STATE(371),
    [ts_builtin_sym_end] = ACTIONS(1451),
    [sym_comment] = ACTIONS(3),
    [sym_decimal_integer_literal] = ACTIONS(1369),
    [sym_hexadecimal_integer_literal] = ACTIONS(1369),
    [sym_real_literal] = ACTIONS(1369),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(1369),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(1369),
    [sym_verbatim_string_characters] = ACTIONS(1369),
    [sym_verbatim_here_string_characters] = ACTIONS(1369),
    [anon_sym_DOT] = ACTIONS(1369),
    [anon_sym_LBRACK] = ACTIONS(1369),
    [anon_sym_DASHjoin] = ACTIONS(1369),
    [anon_sym_DASHsplit] = ACTIONS(1369),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1369),
    [anon_sym_DOLLAR_CARET] = ACTIONS(1369),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(1369),
    [anon_sym_DOLLAR_] = ACTIONS(1369),
    [aux_sym_variable_token1] = ACTIONS(1369),
    [aux_sym_variable_token2] = ACTIONS(1369),
    [sym_braced_variable] = ACTIONS(1369),
    [anon_sym_SEMI] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(1369),
    [anon_sym_COMMA] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1369),
    [anon_sym_if] = ACTIONS(1369),
    [anon_sym_elseif] = ACTIONS(1453),
    [anon_sym_else] = ACTIONS(1369),
    [anon_sym_switch] = ACTIONS(1369),
    [anon_sym_foreach] = ACTIONS(1369),
    [anon_sym_for] = ACTIONS(1369),
    [anon_sym_while] = ACTIONS(1369),
    [anon_sym_do] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(1369),
    [anon_sym_filter] = ACTIONS(1369),
    [anon_sym_workflow] = ACTIONS(1369),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_continue] = ACTIONS(1369),
    [anon_sym_throw] = ACTIONS(1369),
    [anon_sym_return] = ACTIONS(1369),
    [anon_sym_exit] = ACTIONS(1369),
    [sym_label] = ACTIONS(1369),
    [anon_sym_trap] = ACTIONS(1369),
    [anon_sym_try] = ACTIONS(1369),
    [anon_sym_data] = ACTIONS(1369),
    [anon_sym_inlinescript] = ACTIONS(1369),
    [anon_sym_parallel] = ACTIONS(1369),
    [anon_sym_sequence] = ACTIONS(1369),
    [anon_sym_AMP] = ACTIONS(1369),
    [aux_sym_command_name_token1] = ACTIONS(1369),
    [anon_sym_PERCENT] = ACTIONS(1369),
    [anon_sym_foreach_DASHobject] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(1369),
    [anon_sym_enum] = ACTIONS(1369),
    [anon_sym_PLUS] = ACTIONS(1369),
    [anon_sym_DASH] = ACTIONS(1369),
    [anon_sym_DASHnot] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_DASHbnot] = ACTIONS(1369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1369),
    [anon_sym_DASH_DASH] = ACTIONS(1369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1369),
    [anon_sym_AT_LPAREN] = ACTIONS(1369),
    [anon_sym_AT_LBRACE] = ACTIONS(1369),
  },
  [372] = {
    [sym__literal] = STATE(289),
    [sym_integer_literal] = STATE(289),
    [sym_string_literal] = STATE(289),
    [sym_expandable_string_literal] = STATE(110),
    [sym_expandable_here_string_literal] = STATE(110),
    [sym_variable] = STATE(289),
    [sym__expression] = STATE(1665),
    [sym_logical_expression] = STATE(1360),
    [sym_bitwise_expression] = STATE(1286),
    [sym_comparison_expression] = STATE(540),
    [sym_additive_expression] = STATE(535),
    [sym_multiplicative_expression] = STATE(365),
    [sym_format_expression] = STATE(316),
    [sym_range_expression] = STATE(301),
    [sym_array_literal_expression] = STATE(304),
    [sym_unary_expression] = STATE(162),
    [sym_expression_with_unary_operator] = STATE(161),
    [sym_pre_increment_expression] = STATE(160),
    [sym_pre_decrement_expression] = STATE(160),
    [sym_cast_expression] = STATE(160),
    [sym__primary_expression] = STATE(289),
    [sym__value] = STATE(289),
    [sym_parenthesized_expression] = STATE(289),
    [sym_sub_expression] = STATE(289),
    [sym_array_expression] = STATE(289),
    [sym_script_block_expression] = STATE(289),
    [sym_hash_literal_expression] = STATE(289),
    [sym_post_increment_expression] = STATE(289),
    [sym_post_decrement_expression] = STATE(289),
    [sym_member_access] = STATE(289),
    [sym_element_access] = STATE(289),
    [sym_invokation_expression] = STATE(289),
    [sym_invokation_foreach_expression] = STATE(88),
    [sym_type_literal] = STATE(76),
    [sym_comment] = ACTIONS(81),
    [sym_decimal_integer_literal] = ACTIONS(119),
    [sym_hexadecimal_integer_literal] = ACTIONS(121),
    [sym_real_literal] = ACTIONS(479),
    [aux_sym_expandable_string_literal_token1] = ACTIONS(125),
    [aux_sym_expandable_here_string_literal_token1] = ACTIONS(127),
    [sym_verbatim_string_characters] = ACTIONS(129),
    [sym_verbatim_here_string_characters] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_DASHjoin] = ACTIONS(483),
    [anon_sym_DASHsplit] = ACTIONS(483),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(135),
    [anon_sym_DOLLAR_CARET] = ACTIONS(135),
    [anon_sym_DOLLAR_QMARK] = ACTIONS(135),
    [anon_sym_DOLLAR_] = ACTIONS(137),
    [aux_sym_variable_token1] = ACTIONS(137),
    [aux_sym_variable_token2] = ACTIONS(135),
    [sym_braced_variable] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(485),
    [anon_sym_DASHnot] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_DASHbnot] = ACTIONS(483),
    [anon_sym_PLUS_PLUS] = ACTIONS(487),
    [anon_sym_DASH_DASH] = ACTIONS(489),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(149),
    [anon_sym_AT_LPAREN] = ACTIONS(151),
    [anon_sym_AT_LBRACE] = ACTIONS(153),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1456), 63,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [69] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1458), 63,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [138] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1462), 3,
      anon_sym_DASHin,
      anon_sym_DASHis,
      anon_sym_DASH,
    ACTIONS(1460), 60,
      anon_sym_DASHas,
      anon_sym_DASHccontains,
      anon_sym_DASHceq,
      anon_sym_DASHcge,
      anon_sym_DASHcgt,
      anon_sym_DASHcle,
      anon_sym_DASHclike,
      anon_sym_DASHclt,
      anon_sym_DASHcmatch,
      anon_sym_DASHcne,
      anon_sym_DASHcnotcontains,
      anon_sym_DASHcnotlike,
      anon_sym_DASHcnotmatch,
      anon_sym_DASHcontains,
      anon_sym_DASHcreplace,
      anon_sym_DASHcsplit,
      anon_sym_DASHeq,
      anon_sym_DASHge,
      anon_sym_DASHgt,
      anon_sym_DASHicontains,
      anon_sym_DASHieq,
      anon_sym_DASHige,
      anon_sym_DASHigt,
      anon_sym_DASHile,
      anon_sym_DASHilike,
      anon_sym_DASHilt,
      anon_sym_DASHimatch,
      anon_sym_DASHine,
      anon_sym_DASHinotcontains,
      anon_sym_DASHinotlike,
      anon_sym_DASHinotmatch,
      anon_sym_DASHireplace,
      anon_sym_DASHisnot,
      anon_sym_DASHisplit,
      anon_sym_DASHjoin,
      anon_sym_DASHle,
      anon_sym_DASHlike,
      anon_sym_DASHlt,
      anon_sym_DASHmatch,
      anon_sym_DASHne,
      anon_sym_DASHnotcontains,
      anon_sym_DASHnotin,
      anon_sym_DASHnotlike,
      anon_sym_DASHnotmatch,
      anon_sym_DASHreplace,
      anon_sym_DASHshl,
      anon_sym_DASHshr,
      anon_sym_DASHsplit,
      sym_format_operator,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PERCENT,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_BSLASH,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
  [209] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1464), 63,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [278] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1470), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1468), 3,
      anon_sym_DASHin,
      anon_sym_DASHis,
      anon_sym_DASH,
    ACTIONS(1466), 59,
      anon_sym_DASHas,
      anon_sym_DASHccontains,
      anon_sym_DASHceq,
      anon_sym_DASHcge,
      anon_sym_DASHcgt,
      anon_sym_DASHcle,
      anon_sym_DASHclike,
      anon_sym_DASHclt,
      anon_sym_DASHcmatch,
      anon_sym_DASHcne,
      anon_sym_DASHcnotcontains,
      anon_sym_DASHcnotlike,
      anon_sym_DASHcnotmatch,
      anon_sym_DASHcontains,
      anon_sym_DASHcreplace,
      anon_sym_DASHcsplit,
      anon_sym_DASHeq,
      anon_sym_DASHge,
      anon_sym_DASHgt,
      anon_sym_DASHicontains,
      anon_sym_DASHieq,
      anon_sym_DASHige,
      anon_sym_DASHigt,
      anon_sym_DASHile,
      anon_sym_DASHilike,
      anon_sym_DASHilt,
      anon_sym_DASHimatch,
      anon_sym_DASHine,
      anon_sym_DASHinotcontains,
      anon_sym_DASHinotlike,
      anon_sym_DASHinotmatch,
      anon_sym_DASHireplace,
      anon_sym_DASHisnot,
      anon_sym_DASHisplit,
      anon_sym_DASHjoin,
      anon_sym_DASHle,
      anon_sym_DASHlike,
      anon_sym_DASHlt,
      anon_sym_DASHmatch,
      anon_sym_DASHne,
      anon_sym_DASHnotcontains,
      anon_sym_DASHnotin,
      anon_sym_DASHnotlike,
      anon_sym_DASHnotmatch,
      anon_sym_DASHreplace,
      anon_sym_DASHshl,
      anon_sym_DASHshr,
      anon_sym_DASHsplit,
      sym_format_operator,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PERCENT,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_BSLASH,
      anon_sym_STAR,
  [351] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1458), 63,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [420] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1456), 63,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [489] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1470), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1474), 3,
      anon_sym_DASHin,
      anon_sym_DASHis,
      anon_sym_DASH,
    ACTIONS(1472), 59,
      anon_sym_DASHas,
      anon_sym_DASHccontains,
      anon_sym_DASHceq,
      anon_sym_DASHcge,
      anon_sym_DASHcgt,
      anon_sym_DASHcle,
      anon_sym_DASHclike,
      anon_sym_DASHclt,
      anon_sym_DASHcmatch,
      anon_sym_DASHcne,
      anon_sym_DASHcnotcontains,
      anon_sym_DASHcnotlike,
      anon_sym_DASHcnotmatch,
      anon_sym_DASHcontains,
      anon_sym_DASHcreplace,
      anon_sym_DASHcsplit,
      anon_sym_DASHeq,
      anon_sym_DASHge,
      anon_sym_DASHgt,
      anon_sym_DASHicontains,
      anon_sym_DASHieq,
      anon_sym_DASHige,
      anon_sym_DASHigt,
      anon_sym_DASHile,
      anon_sym_DASHilike,
      anon_sym_DASHilt,
      anon_sym_DASHimatch,
      anon_sym_DASHine,
      anon_sym_DASHinotcontains,
      anon_sym_DASHinotlike,
      anon_sym_DASHinotmatch,
      anon_sym_DASHireplace,
      anon_sym_DASHisnot,
      anon_sym_DASHisplit,
      anon_sym_DASHjoin,
      anon_sym_DASHle,
      anon_sym_DASHlike,
      anon_sym_DASHlt,
      anon_sym_DASHmatch,
      anon_sym_DASHne,
      anon_sym_DASHnotcontains,
      anon_sym_DASHnotin,
      anon_sym_DASHnotlike,
      anon_sym_DASHnotmatch,
      anon_sym_DASHreplace,
      anon_sym_DASHshl,
      anon_sym_DASHshr,
      anon_sym_DASHsplit,
      sym_format_operator,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PERCENT,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_BSLASH,
      anon_sym_STAR,
  [562] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1323), 1,
      anon_sym_else,
    STATE(442), 1,
      sym_else_clause,
    ACTIONS(1476), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [635] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(811), 3,
      anon_sym_DASHin,
      anon_sym_DASHis,
      anon_sym_DASH,
    ACTIONS(1478), 4,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      anon_sym_BSLASH,
      anon_sym_STAR,
    ACTIONS(809), 56,
      sym__statement_terminator,
      anon_sym_DASHas,
      anon_sym_DASHccontains,
      anon_sym_DASHceq,
      anon_sym_DASHcge,
      anon_sym_DASHcgt,
      anon_sym_DASHcle,
      anon_sym_DASHclike,
      anon_sym_DASHclt,
      anon_sym_DASHcmatch,
      anon_sym_DASHcne,
      anon_sym_DASHcnotcontains,
      anon_sym_DASHcnotlike,
      anon_sym_DASHcnotmatch,
      anon_sym_DASHcontains,
      anon_sym_DASHcreplace,
      anon_sym_DASHcsplit,
      anon_sym_DASHeq,
      anon_sym_DASHge,
      anon_sym_DASHgt,
      anon_sym_DASHicontains,
      anon_sym_DASHieq,
      anon_sym_DASHige,
      anon_sym_DASHigt,
      anon_sym_DASHile,
      anon_sym_DASHilike,
      anon_sym_DASHilt,
      anon_sym_DASHimatch,
      anon_sym_DASHine,
      anon_sym_DASHinotcontains,
      anon_sym_DASHinotlike,
      anon_sym_DASHinotmatch,
      anon_sym_DASHireplace,
      anon_sym_DASHisnot,
      anon_sym_DASHisplit,
      anon_sym_DASHjoin,
      anon_sym_DASHle,
      anon_sym_DASHlike,
      anon_sym_DASHlt,
      anon_sym_DASHmatch,
      anon_sym_DASHne,
      anon_sym_DASHnotcontains,
      anon_sym_DASHnotin,
      anon_sym_DASHnotlike,
      anon_sym_DASHnotmatch,
      anon_sym_DASHreplace,
      anon_sym_DASHshl,
      anon_sym_DASHshr,
      anon_sym_DASHsplit,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
      anon_sym_DASHband,
      anon_sym_DASHbor,
      anon_sym_DASHbxor,
      anon_sym_PLUS,
  [708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1480), 63,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [777] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1317), 1,
      anon_sym_finally,
    STATE(468), 1,
      sym_finally_clause,
    ACTIONS(1482), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1484), 63,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [919] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1488), 3,
      anon_sym_DASHin,
      anon_sym_DASHis,
      anon_sym_DASH,
    ACTIONS(1486), 60,
      anon_sym_DASHas,
      anon_sym_DASHccontains,
      anon_sym_DASHceq,
      anon_sym_DASHcge,
      anon_sym_DASHcgt,
      anon_sym_DASHcle,
      anon_sym_DASHclike,
      anon_sym_DASHclt,
      anon_sym_DASHcmatch,
      anon_sym_DASHcne,
      anon_sym_DASHcnotcontains,
      anon_sym_DASHcnotlike,
      anon_sym_DASHcnotmatch,
      anon_sym_DASHcontains,
      anon_sym_DASHcreplace,
      anon_sym_DASHcsplit,
      anon_sym_DASHeq,
      anon_sym_DASHge,
      anon_sym_DASHgt,
      anon_sym_DASHicontains,
      anon_sym_DASHieq,
      anon_sym_DASHige,
      anon_sym_DASHigt,
      anon_sym_DASHile,
      anon_sym_DASHilike,
      anon_sym_DASHilt,
      anon_sym_DASHimatch,
      anon_sym_DASHine,
      anon_sym_DASHinotcontains,
      anon_sym_DASHinotlike,
      anon_sym_DASHinotmatch,
      anon_sym_DASHireplace,
      anon_sym_DASHisnot,
      anon_sym_DASHisplit,
      anon_sym_DASHjoin,
      anon_sym_DASHle,
      anon_sym_DASHlike,
      anon_sym_DASHlt,
      anon_sym_DASHmatch,
      anon_sym_DASHne,
      anon_sym_DASHnotcontains,
      anon_sym_DASHnotin,
      anon_sym_DASHnotlike,
      anon_sym_DASHnotmatch,
      anon_sym_DASHreplace,
      anon_sym_DASHshl,
      anon_sym_DASHshr,
      anon_sym_DASHsplit,
      sym_format_operator,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PERCENT,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_BSLASH,
      anon_sym_STAR,
      anon_sym_DOT_DOT,
  [990] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(819), 3,
      anon_sym_DASHin,
      anon_sym_DASHis,
      anon_sym_DASH,
    ACTIONS(1490), 4,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      anon_sym_BSLASH,
      anon_sym_STAR,
    ACTIONS(817), 56,
      anon_sym_DASHas,
      anon_sym_DASHccontains,
      anon_sym_DASHceq,
      anon_sym_DASHcge,
      anon_sym_DASHcgt,
      anon_sym_DASHcle,
      anon_sym_DASHclike,
      anon_sym_DASHclt,
      anon_sym_DASHcmatch,
      anon_sym_DASHcne,
      anon_sym_DASHcnotcontains,
      anon_sym_DASHcnotlike,
      anon_sym_DASHcnotmatch,
      anon_sym_DASHcontains,
      anon_sym_DASHcreplace,
      anon_sym_DASHcsplit,
      anon_sym_DASHeq,
      anon_sym_DASHge,
      anon_sym_DASHgt,
      anon_sym_DASHicontains,
      anon_sym_DASHieq,
      anon_sym_DASHige,
      anon_sym_DASHigt,
      anon_sym_DASHile,
      anon_sym_DASHilike,
      anon_sym_DASHilt,
      anon_sym_DASHimatch,
      anon_sym_DASHine,
      anon_sym_DASHinotcontains,
      anon_sym_DASHinotlike,
      anon_sym_DASHinotmatch,
      anon_sym_DASHireplace,
      anon_sym_DASHisnot,
      anon_sym_DASHisplit,
      anon_sym_DASHjoin,
      anon_sym_DASHle,
      anon_sym_DASHlike,
      anon_sym_DASHlt,
      anon_sym_DASHmatch,
      anon_sym_DASHne,
      anon_sym_DASHnotcontains,
      anon_sym_DASHnotin,
      anon_sym_DASHnotlike,
      anon_sym_DASHnotmatch,
      anon_sym_DASHreplace,
      anon_sym_DASHshl,
      anon_sym_DASHshr,
      anon_sym_DASHsplit,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
      anon_sym_DASHband,
      anon_sym_DASHbor,
      anon_sym_DASHbxor,
      anon_sym_PLUS,
      anon_sym_RBRACK,
  [1063] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(811), 3,
      anon_sym_DASHin,
      anon_sym_DASHis,
      anon_sym_DASH,
    ACTIONS(1490), 4,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      anon_sym_BSLASH,
      anon_sym_STAR,
    ACTIONS(809), 56,
      anon_sym_DASHas,
      anon_sym_DASHccontains,
      anon_sym_DASHceq,
      anon_sym_DASHcge,
      anon_sym_DASHcgt,
      anon_sym_DASHcle,
      anon_sym_DASHclike,
      anon_sym_DASHclt,
      anon_sym_DASHcmatch,
      anon_sym_DASHcne,
      anon_sym_DASHcnotcontains,
      anon_sym_DASHcnotlike,
      anon_sym_DASHcnotmatch,
      anon_sym_DASHcontains,
      anon_sym_DASHcreplace,
      anon_sym_DASHcsplit,
      anon_sym_DASHeq,
      anon_sym_DASHge,
      anon_sym_DASHgt,
      anon_sym_DASHicontains,
      anon_sym_DASHieq,
      anon_sym_DASHige,
      anon_sym_DASHigt,
      anon_sym_DASHile,
      anon_sym_DASHilike,
      anon_sym_DASHilt,
      anon_sym_DASHimatch,
      anon_sym_DASHine,
      anon_sym_DASHinotcontains,
      anon_sym_DASHinotlike,
      anon_sym_DASHinotmatch,
      anon_sym_DASHireplace,
      anon_sym_DASHisnot,
      anon_sym_DASHisplit,
      anon_sym_DASHjoin,
      anon_sym_DASHle,
      anon_sym_DASHlike,
      anon_sym_DASHlt,
      anon_sym_DASHmatch,
      anon_sym_DASHne,
      anon_sym_DASHnotcontains,
      anon_sym_DASHnotin,
      anon_sym_DASHnotlike,
      anon_sym_DASHnotmatch,
      anon_sym_DASHreplace,
      anon_sym_DASHshl,
      anon_sym_DASHshr,
      anon_sym_DASHsplit,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
      anon_sym_DASHband,
      anon_sym_DASHbor,
      anon_sym_DASHbxor,
      anon_sym_PLUS,
      anon_sym_RBRACK,
  [1136] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(819), 3,
      anon_sym_DASHin,
      anon_sym_DASHis,
      anon_sym_DASH,
    ACTIONS(1478), 4,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      anon_sym_BSLASH,
      anon_sym_STAR,
    ACTIONS(817), 56,
      sym__statement_terminator,
      anon_sym_DASHas,
      anon_sym_DASHccontains,
      anon_sym_DASHceq,
      anon_sym_DASHcge,
      anon_sym_DASHcgt,
      anon_sym_DASHcle,
      anon_sym_DASHclike,
      anon_sym_DASHclt,
      anon_sym_DASHcmatch,
      anon_sym_DASHcne,
      anon_sym_DASHcnotcontains,
      anon_sym_DASHcnotlike,
      anon_sym_DASHcnotmatch,
      anon_sym_DASHcontains,
      anon_sym_DASHcreplace,
      anon_sym_DASHcsplit,
      anon_sym_DASHeq,
      anon_sym_DASHge,
      anon_sym_DASHgt,
      anon_sym_DASHicontains,
      anon_sym_DASHieq,
      anon_sym_DASHige,
      anon_sym_DASHigt,
      anon_sym_DASHile,
      anon_sym_DASHilike,
      anon_sym_DASHilt,
      anon_sym_DASHimatch,
      anon_sym_DASHine,
      anon_sym_DASHinotcontains,
      anon_sym_DASHinotlike,
      anon_sym_DASHinotmatch,
      anon_sym_DASHireplace,
      anon_sym_DASHisnot,
      anon_sym_DASHisplit,
      anon_sym_DASHjoin,
      anon_sym_DASHle,
      anon_sym_DASHlike,
      anon_sym_DASHlt,
      anon_sym_DASHmatch,
      anon_sym_DASHne,
      anon_sym_DASHnotcontains,
      anon_sym_DASHnotin,
      anon_sym_DASHnotlike,
      anon_sym_DASHnotmatch,
      anon_sym_DASHreplace,
      anon_sym_DASHshl,
      anon_sym_DASHshr,
      anon_sym_DASHsplit,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
      anon_sym_DASHband,
      anon_sym_DASHbor,
      anon_sym_DASHbxor,
      anon_sym_PLUS,
  [1209] = 34,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(479), 1,
      sym_real_literal,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(487), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(489), 1,
      anon_sym_DASH_DASH,
    STATE(76), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(380), 1,
      sym_range_argument_expression,
    STATE(386), 1,
      sym_unary_expression,
    STATE(402), 1,
      sym_format_argument_expression,
    STATE(430), 1,
      sym_multiplicative_argument_expression,
    STATE(576), 1,
      sym_additive_argument_expression,
    STATE(584), 1,
      sym_comparison_argument_expression,
    STATE(1331), 1,
      sym_logical_argument_expression,
    STATE(1332), 1,
      sym_bitwise_argument_expression,
    STATE(1640), 1,
      sym_argument_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(483), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(289), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [1342] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1496), 1,
      sym_format_operator,
    ACTIONS(1494), 3,
      anon_sym_DASHin,
      anon_sym_DASHis,
      anon_sym_DASH,
    ACTIONS(1492), 58,
      anon_sym_DASHas,
      anon_sym_DASHccontains,
      anon_sym_DASHceq,
      anon_sym_DASHcge,
      anon_sym_DASHcgt,
      anon_sym_DASHcle,
      anon_sym_DASHclike,
      anon_sym_DASHclt,
      anon_sym_DASHcmatch,
      anon_sym_DASHcne,
      anon_sym_DASHcnotcontains,
      anon_sym_DASHcnotlike,
      anon_sym_DASHcnotmatch,
      anon_sym_DASHcontains,
      anon_sym_DASHcreplace,
      anon_sym_DASHcsplit,
      anon_sym_DASHeq,
      anon_sym_DASHge,
      anon_sym_DASHgt,
      anon_sym_DASHicontains,
      anon_sym_DASHieq,
      anon_sym_DASHige,
      anon_sym_DASHigt,
      anon_sym_DASHile,
      anon_sym_DASHilike,
      anon_sym_DASHilt,
      anon_sym_DASHimatch,
      anon_sym_DASHine,
      anon_sym_DASHinotcontains,
      anon_sym_DASHinotlike,
      anon_sym_DASHinotmatch,
      anon_sym_DASHireplace,
      anon_sym_DASHisnot,
      anon_sym_DASHisplit,
      anon_sym_DASHjoin,
      anon_sym_DASHle,
      anon_sym_DASHlike,
      anon_sym_DASHlt,
      anon_sym_DASHmatch,
      anon_sym_DASHne,
      anon_sym_DASHnotcontains,
      anon_sym_DASHnotin,
      anon_sym_DASHnotlike,
      anon_sym_DASHnotmatch,
      anon_sym_DASHreplace,
      anon_sym_DASHshl,
      anon_sym_DASHshr,
      anon_sym_DASHsplit,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PERCENT,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_BSLASH,
      anon_sym_STAR,
  [1414] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1359), 1,
      anon_sym_else,
    ACTIONS(1498), 1,
      ts_builtin_sym_end,
    STATE(492), 1,
      sym_else_clause,
    ACTIONS(1476), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [1488] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1500), 1,
      ts_builtin_sym_end,
    ACTIONS(1456), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [1558] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1502), 1,
      ts_builtin_sym_end,
    ACTIONS(1458), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [1628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1502), 1,
      ts_builtin_sym_end,
    ACTIONS(1458), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [1698] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1504), 1,
      anon_sym_SPACE,
    STATE(403), 1,
      aux_sym_command_argument_sep_repeat1,
    ACTIONS(1341), 60,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      sym_generic_token,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [1770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1506), 1,
      ts_builtin_sym_end,
    ACTIONS(1480), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [1840] = 33,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(503), 1,
      anon_sym_LBRACK,
    ACTIONS(547), 1,
      sym_real_literal,
    ACTIONS(553), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(555), 1,
      anon_sym_DASH_DASH,
    STATE(81), 1,
      sym_type_literal,
    STATE(143), 1,
      sym_invokation_foreach_expression,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    STATE(173), 1,
      sym_unary_expression,
    STATE(308), 1,
      sym_array_literal_expression,
    STATE(334), 1,
      sym_range_expression,
    STATE(346), 1,
      sym_format_expression,
    STATE(389), 1,
      sym_multiplicative_expression,
    STATE(546), 1,
      sym_additive_expression,
    STATE(564), 1,
      sym_comparison_expression,
    STATE(1304), 1,
      sym_bitwise_expression,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(549), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(290), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [1970] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1339), 1,
      sym__statement_terminator,
    ACTIONS(1508), 1,
      anon_sym_SPACE,
    STATE(399), 1,
      aux_sym_command_argument_sep_repeat1,
    ACTIONS(1325), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      sym_generic_token,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [2044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1500), 1,
      ts_builtin_sym_end,
    ACTIONS(1456), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [2114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 1,
      ts_builtin_sym_end,
    ACTIONS(1464), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [2184] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1496), 1,
      sym_format_operator,
    ACTIONS(1515), 3,
      anon_sym_DASHin,
      anon_sym_DASHis,
      anon_sym_DASH,
    ACTIONS(1513), 58,
      anon_sym_DASHas,
      anon_sym_DASHccontains,
      anon_sym_DASHceq,
      anon_sym_DASHcge,
      anon_sym_DASHcgt,
      anon_sym_DASHcle,
      anon_sym_DASHclike,
      anon_sym_DASHclt,
      anon_sym_DASHcmatch,
      anon_sym_DASHcne,
      anon_sym_DASHcnotcontains,
      anon_sym_DASHcnotlike,
      anon_sym_DASHcnotmatch,
      anon_sym_DASHcontains,
      anon_sym_DASHcreplace,
      anon_sym_DASHcsplit,
      anon_sym_DASHeq,
      anon_sym_DASHge,
      anon_sym_DASHgt,
      anon_sym_DASHicontains,
      anon_sym_DASHieq,
      anon_sym_DASHige,
      anon_sym_DASHigt,
      anon_sym_DASHile,
      anon_sym_DASHilike,
      anon_sym_DASHilt,
      anon_sym_DASHimatch,
      anon_sym_DASHine,
      anon_sym_DASHinotcontains,
      anon_sym_DASHinotlike,
      anon_sym_DASHinotmatch,
      anon_sym_DASHireplace,
      anon_sym_DASHisnot,
      anon_sym_DASHisplit,
      anon_sym_DASHjoin,
      anon_sym_DASHle,
      anon_sym_DASHlike,
      anon_sym_DASHlt,
      anon_sym_DASHmatch,
      anon_sym_DASHne,
      anon_sym_DASHnotcontains,
      anon_sym_DASHnotin,
      anon_sym_DASHnotlike,
      anon_sym_DASHnotmatch,
      anon_sym_DASHreplace,
      anon_sym_DASHshl,
      anon_sym_DASHshr,
      anon_sym_DASHsplit,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PERCENT,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_BSLASH,
      anon_sym_STAR,
  [2256] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1517), 1,
      anon_sym_SPACE,
    STATE(403), 1,
      aux_sym_command_argument_sep_repeat1,
    ACTIONS(1325), 60,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      sym_generic_token,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [2328] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1345), 1,
      sym__statement_terminator,
    ACTIONS(1520), 1,
      anon_sym_SPACE,
    STATE(399), 1,
      aux_sym_command_argument_sep_repeat1,
    ACTIONS(1341), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      sym_generic_token,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [2402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1522), 1,
      ts_builtin_sym_end,
    ACTIONS(1484), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [2472] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(251), 14,
      sym_decimal_integer_literal,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT2,
    ACTIONS(253), 48,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [2542] = 33,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(479), 1,
      sym_real_literal,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(487), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(489), 1,
      anon_sym_DASH_DASH,
    STATE(76), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(162), 1,
      sym_unary_expression,
    STATE(301), 1,
      sym_range_expression,
    STATE(304), 1,
      sym_array_literal_expression,
    STATE(316), 1,
      sym_format_expression,
    STATE(365), 1,
      sym_multiplicative_expression,
    STATE(535), 1,
      sym_additive_expression,
    STATE(540), 1,
      sym_comparison_expression,
    STATE(1288), 1,
      sym_bitwise_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(483), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(289), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [2672] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(251), 14,
      sym_decimal_integer_literal,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT2,
    ACTIONS(253), 48,
      sym__statement_terminator,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [2742] = 33,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(479), 1,
      sym_real_literal,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(487), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(489), 1,
      anon_sym_DASH_DASH,
    STATE(76), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(162), 1,
      sym_unary_expression,
    STATE(299), 1,
      sym_array_literal_expression,
    STATE(345), 1,
      sym_range_expression,
    STATE(370), 1,
      sym_format_expression,
    STATE(387), 1,
      sym_multiplicative_expression,
    STATE(554), 1,
      sym_additive_expression,
    STATE(559), 1,
      sym_comparison_expression,
    STATE(1293), 1,
      sym_bitwise_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(483), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(289), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [2872] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1353), 1,
      anon_sym_finally,
    ACTIONS(1524), 1,
      ts_builtin_sym_end,
    STATE(480), 1,
      sym_finally_clause,
    ACTIONS(1482), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [2946] = 33,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(85), 1,
      sym_real_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(93), 1,
      anon_sym_LBRACK,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(109), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(111), 1,
      anon_sym_DASH_DASH,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    STATE(5), 1,
      sym_type_literal,
    STATE(143), 1,
      sym_invokation_foreach_expression,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    STATE(173), 1,
      sym_unary_expression,
    STATE(175), 1,
      sym_array_literal_expression,
    STATE(180), 1,
      sym_range_expression,
    STATE(181), 1,
      sym_format_expression,
    STATE(186), 1,
      sym_multiplicative_expression,
    STATE(191), 1,
      sym_additive_expression,
    STATE(196), 1,
      sym_comparison_expression,
    STATE(915), 1,
      sym_bitwise_expression,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(99), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(156), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [3076] = 33,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(123), 1,
      sym_real_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(147), 1,
      anon_sym_DASH_DASH,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    STATE(3), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(162), 1,
      sym_unary_expression,
    STATE(166), 1,
      sym_array_literal_expression,
    STATE(178), 1,
      sym_range_expression,
    STATE(183), 1,
      sym_format_expression,
    STATE(188), 1,
      sym_multiplicative_expression,
    STATE(192), 1,
      sym_additive_expression,
    STATE(203), 1,
      sym_comparison_expression,
    STATE(848), 1,
      sym_bitwise_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(143), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(133), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(155), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [3206] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1526), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [3273] = 32,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(479), 1,
      sym_real_literal,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(487), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(489), 1,
      anon_sym_DASH_DASH,
    STATE(76), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(162), 1,
      sym_unary_expression,
    STATE(301), 1,
      sym_range_expression,
    STATE(304), 1,
      sym_array_literal_expression,
    STATE(316), 1,
      sym_format_expression,
    STATE(365), 1,
      sym_multiplicative_expression,
    STATE(535), 1,
      sym_additive_expression,
    STATE(555), 1,
      sym_comparison_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(483), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(289), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [3400] = 31,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym_decimal_integer_literal,
    ACTIONS(1039), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1043), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1045), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1528), 1,
      sym_real_literal,
    ACTIONS(1530), 1,
      sym_simple_name,
    ACTIONS(1532), 1,
      anon_sym_LBRACK,
    ACTIONS(1536), 1,
      anon_sym_RBRACE,
    ACTIONS(1540), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1542), 1,
      anon_sym_DASH_DASH,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(543), 1,
      sym_type_literal,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    STATE(1792), 1,
      sym_hash_literal_body,
    STATE(1914), 1,
      sym_key_expression,
    STATE(1920), 1,
      sym_unary_expression,
    ACTIONS(1047), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1055), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1538), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(503), 2,
      sym_hash_entry,
      aux_sym_hash_literal_body_repeat1,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1053), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1534), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1295), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [3525] = 31,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym_decimal_integer_literal,
    ACTIONS(1039), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1043), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1045), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1528), 1,
      sym_real_literal,
    ACTIONS(1530), 1,
      sym_simple_name,
    ACTIONS(1532), 1,
      anon_sym_LBRACK,
    ACTIONS(1540), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1542), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1544), 1,
      anon_sym_RBRACE,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(543), 1,
      sym_type_literal,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    STATE(1770), 1,
      sym_hash_literal_body,
    STATE(1914), 1,
      sym_key_expression,
    STATE(1920), 1,
      sym_unary_expression,
    ACTIONS(1047), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1055), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1538), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(503), 2,
      sym_hash_entry,
      aux_sym_hash_literal_body_repeat1,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1053), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1534), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1295), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [3650] = 31,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym_decimal_integer_literal,
    ACTIONS(1039), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1043), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1045), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1528), 1,
      sym_real_literal,
    ACTIONS(1530), 1,
      sym_simple_name,
    ACTIONS(1532), 1,
      anon_sym_LBRACK,
    ACTIONS(1540), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1542), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1546), 1,
      anon_sym_RBRACE,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(543), 1,
      sym_type_literal,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    STATE(1748), 1,
      sym_hash_literal_body,
    STATE(1914), 1,
      sym_key_expression,
    STATE(1920), 1,
      sym_unary_expression,
    ACTIONS(1047), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1055), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1538), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(503), 2,
      sym_hash_entry,
      aux_sym_hash_literal_body_repeat1,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1053), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1534), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1295), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [3775] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1548), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [3842] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1550), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [3909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1447), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [3976] = 32,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(123), 1,
      sym_real_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(147), 1,
      anon_sym_DASH_DASH,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    STATE(3), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(162), 1,
      sym_unary_expression,
    STATE(166), 1,
      sym_array_literal_expression,
    STATE(178), 1,
      sym_range_expression,
    STATE(183), 1,
      sym_format_expression,
    STATE(188), 1,
      sym_multiplicative_expression,
    STATE(192), 1,
      sym_additive_expression,
    STATE(200), 1,
      sym_comparison_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(143), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(133), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(155), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [4103] = 31,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym_decimal_integer_literal,
    ACTIONS(1039), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1043), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1045), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1528), 1,
      sym_real_literal,
    ACTIONS(1530), 1,
      sym_simple_name,
    ACTIONS(1532), 1,
      anon_sym_LBRACK,
    ACTIONS(1540), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1542), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1552), 1,
      anon_sym_RBRACE,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(543), 1,
      sym_type_literal,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    STATE(1723), 1,
      sym_hash_literal_body,
    STATE(1914), 1,
      sym_key_expression,
    STATE(1920), 1,
      sym_unary_expression,
    ACTIONS(1047), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1055), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1538), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(503), 2,
      sym_hash_entry,
      aux_sym_hash_literal_body_repeat1,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1053), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1534), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1295), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [4228] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1554), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [4295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1556), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [4362] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1558), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [4429] = 32,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(479), 1,
      sym_real_literal,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(487), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(489), 1,
      anon_sym_DASH_DASH,
    STATE(76), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(162), 1,
      sym_unary_expression,
    STATE(299), 1,
      sym_array_literal_expression,
    STATE(345), 1,
      sym_range_expression,
    STATE(370), 1,
      sym_format_expression,
    STATE(387), 1,
      sym_multiplicative_expression,
    STATE(554), 1,
      sym_additive_expression,
    STATE(565), 1,
      sym_comparison_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(483), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(289), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [4556] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1560), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [4623] = 32,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(479), 1,
      sym_real_literal,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(487), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(489), 1,
      anon_sym_DASH_DASH,
    STATE(76), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(380), 1,
      sym_range_argument_expression,
    STATE(386), 1,
      sym_unary_expression,
    STATE(402), 1,
      sym_format_argument_expression,
    STATE(430), 1,
      sym_multiplicative_argument_expression,
    STATE(576), 1,
      sym_additive_argument_expression,
    STATE(584), 1,
      sym_comparison_argument_expression,
    STATE(1350), 1,
      sym_bitwise_argument_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(483), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(289), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [4750] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1562), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [4817] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1566), 3,
      anon_sym_DASHin,
      anon_sym_DASHis,
      anon_sym_DASH,
    ACTIONS(1568), 4,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      anon_sym_BSLASH,
      anon_sym_STAR,
    ACTIONS(1564), 54,
      anon_sym_DASHas,
      anon_sym_DASHccontains,
      anon_sym_DASHceq,
      anon_sym_DASHcge,
      anon_sym_DASHcgt,
      anon_sym_DASHcle,
      anon_sym_DASHclike,
      anon_sym_DASHclt,
      anon_sym_DASHcmatch,
      anon_sym_DASHcne,
      anon_sym_DASHcnotcontains,
      anon_sym_DASHcnotlike,
      anon_sym_DASHcnotmatch,
      anon_sym_DASHcontains,
      anon_sym_DASHcreplace,
      anon_sym_DASHcsplit,
      anon_sym_DASHeq,
      anon_sym_DASHge,
      anon_sym_DASHgt,
      anon_sym_DASHicontains,
      anon_sym_DASHieq,
      anon_sym_DASHige,
      anon_sym_DASHigt,
      anon_sym_DASHile,
      anon_sym_DASHilike,
      anon_sym_DASHilt,
      anon_sym_DASHimatch,
      anon_sym_DASHine,
      anon_sym_DASHinotcontains,
      anon_sym_DASHinotlike,
      anon_sym_DASHinotmatch,
      anon_sym_DASHireplace,
      anon_sym_DASHisnot,
      anon_sym_DASHisplit,
      anon_sym_DASHjoin,
      anon_sym_DASHle,
      anon_sym_DASHlike,
      anon_sym_DASHlt,
      anon_sym_DASHmatch,
      anon_sym_DASHne,
      anon_sym_DASHnotcontains,
      anon_sym_DASHnotin,
      anon_sym_DASHnotlike,
      anon_sym_DASHnotmatch,
      anon_sym_DASHreplace,
      anon_sym_DASHshl,
      anon_sym_DASHshr,
      anon_sym_DASHsplit,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
      anon_sym_PLUS,
  [4888] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1456), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [4955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [5022] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1572), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [5089] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [5156] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1576), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [5223] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [5290] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1482), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [5357] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1580), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [5424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1582), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [5491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1584), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [5558] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1586), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [5625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1588), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [5692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1590), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [5759] = 32,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(85), 1,
      sym_real_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(93), 1,
      anon_sym_LBRACK,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(109), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(111), 1,
      anon_sym_DASH_DASH,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    STATE(5), 1,
      sym_type_literal,
    STATE(143), 1,
      sym_invokation_foreach_expression,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    STATE(173), 1,
      sym_unary_expression,
    STATE(175), 1,
      sym_array_literal_expression,
    STATE(180), 1,
      sym_range_expression,
    STATE(181), 1,
      sym_format_expression,
    STATE(186), 1,
      sym_multiplicative_expression,
    STATE(191), 1,
      sym_additive_expression,
    STATE(204), 1,
      sym_comparison_expression,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(99), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(156), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [5886] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1592), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [5953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1594), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [6020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1596), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [6087] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1598), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [6154] = 31,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym_decimal_integer_literal,
    ACTIONS(1039), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1043), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1045), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1528), 1,
      sym_real_literal,
    ACTIONS(1530), 1,
      sym_simple_name,
    ACTIONS(1532), 1,
      anon_sym_LBRACK,
    ACTIONS(1540), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1542), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1600), 1,
      anon_sym_RBRACE,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(543), 1,
      sym_type_literal,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    STATE(1830), 1,
      sym_hash_literal_body,
    STATE(1914), 1,
      sym_key_expression,
    STATE(1920), 1,
      sym_unary_expression,
    ACTIONS(1047), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1055), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1538), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(503), 2,
      sym_hash_entry,
      aux_sym_hash_literal_body_repeat1,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1053), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1534), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1295), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [6279] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1602), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [6346] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1604), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [6413] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1458), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [6480] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1606), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [6547] = 31,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym_decimal_integer_literal,
    ACTIONS(1039), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1043), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1045), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1528), 1,
      sym_real_literal,
    ACTIONS(1530), 1,
      sym_simple_name,
    ACTIONS(1532), 1,
      anon_sym_LBRACK,
    ACTIONS(1540), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1542), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1608), 1,
      anon_sym_RBRACE,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(543), 1,
      sym_type_literal,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    STATE(1779), 1,
      sym_hash_literal_body,
    STATE(1914), 1,
      sym_key_expression,
    STATE(1920), 1,
      sym_unary_expression,
    ACTIONS(1047), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1055), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1538), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(503), 2,
      sym_hash_entry,
      aux_sym_hash_literal_body_repeat1,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1053), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1534), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1295), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [6672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [6739] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [6806] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1614), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [6873] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1616), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [6940] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1618), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [7007] = 32,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(503), 1,
      anon_sym_LBRACK,
    ACTIONS(547), 1,
      sym_real_literal,
    ACTIONS(553), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(555), 1,
      anon_sym_DASH_DASH,
    STATE(81), 1,
      sym_type_literal,
    STATE(143), 1,
      sym_invokation_foreach_expression,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    STATE(173), 1,
      sym_unary_expression,
    STATE(308), 1,
      sym_array_literal_expression,
    STATE(334), 1,
      sym_range_expression,
    STATE(346), 1,
      sym_format_expression,
    STATE(389), 1,
      sym_multiplicative_expression,
    STATE(546), 1,
      sym_additive_expression,
    STATE(563), 1,
      sym_comparison_expression,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(549), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(290), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [7134] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1620), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [7201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [7268] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [7335] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1626), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [7402] = 31,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym_decimal_integer_literal,
    ACTIONS(1039), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1043), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1045), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1528), 1,
      sym_real_literal,
    ACTIONS(1530), 1,
      sym_simple_name,
    ACTIONS(1532), 1,
      anon_sym_LBRACK,
    ACTIONS(1540), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1542), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1628), 1,
      anon_sym_RBRACE,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(543), 1,
      sym_type_literal,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    STATE(1724), 1,
      sym_hash_literal_body,
    STATE(1914), 1,
      sym_key_expression,
    STATE(1920), 1,
      sym_unary_expression,
    ACTIONS(1047), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1055), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1538), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(503), 2,
      sym_hash_entry,
      aux_sym_hash_literal_body_repeat1,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1053), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1534), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1295), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [7527] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1630), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [7594] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1632), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [7661] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1634), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [7728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1636), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [7795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1638), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [7862] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [7929] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [7996] = 31,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym_decimal_integer_literal,
    ACTIONS(1039), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1043), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1045), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1528), 1,
      sym_real_literal,
    ACTIONS(1530), 1,
      sym_simple_name,
    ACTIONS(1532), 1,
      anon_sym_LBRACK,
    ACTIONS(1540), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1542), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1644), 1,
      anon_sym_RBRACE,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(543), 1,
      sym_type_literal,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    STATE(1914), 1,
      sym_key_expression,
    STATE(1920), 1,
      sym_unary_expression,
    STATE(2094), 1,
      sym_hash_literal_body,
    ACTIONS(1047), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1055), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1538), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(503), 2,
      sym_hash_entry,
      aux_sym_hash_literal_body_repeat1,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1053), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1534), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1295), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [8121] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1648), 3,
      anon_sym_DASHin,
      anon_sym_DASHis,
      anon_sym_DASH,
    ACTIONS(1568), 4,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      anon_sym_BSLASH,
      anon_sym_STAR,
    ACTIONS(1646), 54,
      anon_sym_DASHas,
      anon_sym_DASHccontains,
      anon_sym_DASHceq,
      anon_sym_DASHcge,
      anon_sym_DASHcgt,
      anon_sym_DASHcle,
      anon_sym_DASHclike,
      anon_sym_DASHclt,
      anon_sym_DASHcmatch,
      anon_sym_DASHcne,
      anon_sym_DASHcnotcontains,
      anon_sym_DASHcnotlike,
      anon_sym_DASHcnotmatch,
      anon_sym_DASHcontains,
      anon_sym_DASHcreplace,
      anon_sym_DASHcsplit,
      anon_sym_DASHeq,
      anon_sym_DASHge,
      anon_sym_DASHgt,
      anon_sym_DASHicontains,
      anon_sym_DASHieq,
      anon_sym_DASHige,
      anon_sym_DASHigt,
      anon_sym_DASHile,
      anon_sym_DASHilike,
      anon_sym_DASHilt,
      anon_sym_DASHimatch,
      anon_sym_DASHine,
      anon_sym_DASHinotcontains,
      anon_sym_DASHinotlike,
      anon_sym_DASHinotmatch,
      anon_sym_DASHireplace,
      anon_sym_DASHisnot,
      anon_sym_DASHisplit,
      anon_sym_DASHjoin,
      anon_sym_DASHle,
      anon_sym_DASHlike,
      anon_sym_DASHlt,
      anon_sym_DASHmatch,
      anon_sym_DASHne,
      anon_sym_DASHnotcontains,
      anon_sym_DASHnotin,
      anon_sym_DASHnotlike,
      anon_sym_DASHnotmatch,
      anon_sym_DASHreplace,
      anon_sym_DASHshl,
      anon_sym_DASHshr,
      anon_sym_DASHsplit,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
      anon_sym_PLUS,
  [8192] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1650), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [8259] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1652), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [8326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1654), 61,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [8393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1656), 1,
      ts_builtin_sym_end,
    ACTIONS(1447), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [8461] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1658), 1,
      ts_builtin_sym_end,
    ACTIONS(1632), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [8529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1660), 1,
      ts_builtin_sym_end,
    ACTIONS(1634), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [8597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1662), 1,
      ts_builtin_sym_end,
    ACTIONS(1630), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [8665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1664), 1,
      ts_builtin_sym_end,
    ACTIONS(1624), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [8733] = 31,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(479), 1,
      sym_real_literal,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(487), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(489), 1,
      anon_sym_DASH_DASH,
    STATE(76), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(162), 1,
      sym_unary_expression,
    STATE(301), 1,
      sym_range_expression,
    STATE(304), 1,
      sym_array_literal_expression,
    STATE(316), 1,
      sym_format_expression,
    STATE(365), 1,
      sym_multiplicative_expression,
    STATE(490), 1,
      sym_additive_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(483), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(289), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [8857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1666), 1,
      ts_builtin_sym_end,
    ACTIONS(1572), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [8925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 1,
      ts_builtin_sym_end,
    ACTIONS(1620), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [8993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1670), 1,
      ts_builtin_sym_end,
    ACTIONS(1636), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [9061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1345), 1,
      sym__statement_terminator,
    ACTIONS(1341), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      sym_generic_token,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [9129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1672), 1,
      ts_builtin_sym_end,
    ACTIONS(1592), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [9197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1674), 1,
      ts_builtin_sym_end,
    ACTIONS(1622), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [9265] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_PLUS,
    ACTIONS(1678), 1,
      anon_sym_DASH,
    ACTIONS(835), 2,
      anon_sym_DASHin,
      anon_sym_DASHis,
    ACTIONS(833), 56,
      anon_sym_DASHas,
      anon_sym_DASHccontains,
      anon_sym_DASHceq,
      anon_sym_DASHcge,
      anon_sym_DASHcgt,
      anon_sym_DASHcle,
      anon_sym_DASHclike,
      anon_sym_DASHclt,
      anon_sym_DASHcmatch,
      anon_sym_DASHcne,
      anon_sym_DASHcnotcontains,
      anon_sym_DASHcnotlike,
      anon_sym_DASHcnotmatch,
      anon_sym_DASHcontains,
      anon_sym_DASHcreplace,
      anon_sym_DASHcsplit,
      anon_sym_DASHeq,
      anon_sym_DASHge,
      anon_sym_DASHgt,
      anon_sym_DASHicontains,
      anon_sym_DASHieq,
      anon_sym_DASHige,
      anon_sym_DASHigt,
      anon_sym_DASHile,
      anon_sym_DASHilike,
      anon_sym_DASHilt,
      anon_sym_DASHimatch,
      anon_sym_DASHine,
      anon_sym_DASHinotcontains,
      anon_sym_DASHinotlike,
      anon_sym_DASHinotmatch,
      anon_sym_DASHireplace,
      anon_sym_DASHisnot,
      anon_sym_DASHisplit,
      anon_sym_DASHjoin,
      anon_sym_DASHle,
      anon_sym_DASHlike,
      anon_sym_DASHlt,
      anon_sym_DASHmatch,
      anon_sym_DASHne,
      anon_sym_DASHnotcontains,
      anon_sym_DASHnotin,
      anon_sym_DASHnotlike,
      anon_sym_DASHnotmatch,
      anon_sym_DASHreplace,
      anon_sym_DASHshl,
      anon_sym_DASHshr,
      anon_sym_DASHsplit,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
      anon_sym_DASHband,
      anon_sym_DASHbor,
      anon_sym_DASHbxor,
  [9337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1680), 1,
      ts_builtin_sym_end,
    ACTIONS(1590), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [9405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1682), 1,
      ts_builtin_sym_end,
    ACTIONS(1588), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [9473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1684), 1,
      ts_builtin_sym_end,
    ACTIONS(1606), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [9541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1686), 1,
      ts_builtin_sym_end,
    ACTIONS(1584), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [9609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1688), 1,
      ts_builtin_sym_end,
    ACTIONS(1602), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [9677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1690), 1,
      ts_builtin_sym_end,
    ACTIONS(1578), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [9745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1524), 1,
      ts_builtin_sym_end,
    ACTIONS(1482), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [9813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1692), 1,
      ts_builtin_sym_end,
    ACTIONS(1652), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [9881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1694), 1,
      ts_builtin_sym_end,
    ACTIONS(1582), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [9949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1502), 1,
      ts_builtin_sym_end,
    ACTIONS(1458), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [10017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1696), 1,
      ts_builtin_sym_end,
    ACTIONS(1580), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [10085] = 31,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(503), 1,
      anon_sym_LBRACK,
    ACTIONS(547), 1,
      sym_real_literal,
    ACTIONS(553), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(555), 1,
      anon_sym_DASH_DASH,
    STATE(81), 1,
      sym_type_literal,
    STATE(143), 1,
      sym_invokation_foreach_expression,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    STATE(173), 1,
      sym_unary_expression,
    STATE(308), 1,
      sym_array_literal_expression,
    STATE(334), 1,
      sym_range_expression,
    STATE(346), 1,
      sym_format_expression,
    STATE(389), 1,
      sym_multiplicative_expression,
    STATE(542), 1,
      sym_additive_expression,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(549), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(290), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [10209] = 30,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym_decimal_integer_literal,
    ACTIONS(1039), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1043), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1045), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1528), 1,
      sym_real_literal,
    ACTIONS(1530), 1,
      sym_simple_name,
    ACTIONS(1532), 1,
      anon_sym_LBRACK,
    ACTIONS(1540), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1542), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1698), 1,
      anon_sym_RBRACE,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(543), 1,
      sym_type_literal,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    STATE(1914), 1,
      sym_key_expression,
    STATE(1920), 1,
      sym_unary_expression,
    ACTIONS(1047), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1055), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1538), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(522), 2,
      sym_hash_entry,
      aux_sym_hash_literal_body_repeat1,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1053), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1534), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1295), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [10331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1700), 1,
      ts_builtin_sym_end,
    ACTIONS(1586), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [10399] = 31,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(123), 1,
      sym_real_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(147), 1,
      anon_sym_DASH_DASH,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    STATE(3), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(162), 1,
      sym_unary_expression,
    STATE(166), 1,
      sym_array_literal_expression,
    STATE(178), 1,
      sym_range_expression,
    STATE(183), 1,
      sym_format_expression,
    STATE(188), 1,
      sym_multiplicative_expression,
    STATE(193), 1,
      sym_additive_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(143), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(133), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(155), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [10523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1702), 1,
      ts_builtin_sym_end,
    ACTIONS(1640), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [10591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1704), 1,
      ts_builtin_sym_end,
    ACTIONS(1594), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [10659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1706), 1,
      ts_builtin_sym_end,
    ACTIONS(1576), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [10727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1708), 1,
      ts_builtin_sym_end,
    ACTIONS(1574), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [10795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1710), 1,
      ts_builtin_sym_end,
    ACTIONS(1570), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [10863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1712), 1,
      ts_builtin_sym_end,
    ACTIONS(1562), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [10931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1714), 1,
      ts_builtin_sym_end,
    ACTIONS(1596), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [10999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1716), 1,
      ts_builtin_sym_end,
    ACTIONS(1560), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [11067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1718), 1,
      ts_builtin_sym_end,
    ACTIONS(1604), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [11135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1720), 1,
      ts_builtin_sym_end,
    ACTIONS(1654), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [11203] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1341), 60,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      sym_generic_token,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [11269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1722), 1,
      ts_builtin_sym_end,
    ACTIONS(1610), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [11337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1724), 1,
      ts_builtin_sym_end,
    ACTIONS(1638), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [11405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1726), 1,
      ts_builtin_sym_end,
    ACTIONS(1618), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [11473] = 31,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(85), 1,
      sym_real_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(93), 1,
      anon_sym_LBRACK,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(109), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(111), 1,
      anon_sym_DASH_DASH,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    STATE(5), 1,
      sym_type_literal,
    STATE(143), 1,
      sym_invokation_foreach_expression,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    STATE(173), 1,
      sym_unary_expression,
    STATE(175), 1,
      sym_array_literal_expression,
    STATE(180), 1,
      sym_range_expression,
    STATE(181), 1,
      sym_format_expression,
    STATE(186), 1,
      sym_multiplicative_expression,
    STATE(194), 1,
      sym_additive_expression,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(99), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(156), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [11597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1728), 1,
      ts_builtin_sym_end,
    ACTIONS(1558), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [11665] = 30,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1730), 1,
      sym_decimal_integer_literal,
    ACTIONS(1733), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1736), 1,
      sym_real_literal,
    ACTIONS(1739), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1742), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1748), 1,
      sym_simple_name,
    ACTIONS(1751), 1,
      anon_sym_LBRACK,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    ACTIONS(1766), 1,
      anon_sym_LBRACE,
    ACTIONS(1769), 1,
      anon_sym_RBRACE,
    ACTIONS(1774), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1777), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1780), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1783), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1786), 1,
      anon_sym_AT_LBRACE,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(543), 1,
      sym_type_literal,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    STATE(1914), 1,
      sym_key_expression,
    STATE(1920), 1,
      sym_unary_expression,
    ACTIONS(1745), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1760), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1771), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(522), 2,
      sym_hash_entry,
      aux_sym_hash_literal_body_repeat1,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1757), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1754), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1295), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [11787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1789), 1,
      ts_builtin_sym_end,
    ACTIONS(1612), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [11855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1791), 1,
      ts_builtin_sym_end,
    ACTIONS(1642), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [11923] = 31,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(479), 1,
      sym_real_literal,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(487), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(489), 1,
      anon_sym_DASH_DASH,
    STATE(76), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(162), 1,
      sym_unary_expression,
    STATE(299), 1,
      sym_array_literal_expression,
    STATE(345), 1,
      sym_range_expression,
    STATE(370), 1,
      sym_format_expression,
    STATE(387), 1,
      sym_multiplicative_expression,
    STATE(553), 1,
      sym_additive_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(483), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(289), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [12047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1793), 1,
      ts_builtin_sym_end,
    ACTIONS(1598), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [12115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1795), 1,
      ts_builtin_sym_end,
    ACTIONS(1556), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [12183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1797), 1,
      ts_builtin_sym_end,
    ACTIONS(1616), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [12251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1799), 1,
      ts_builtin_sym_end,
    ACTIONS(1614), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [12319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1801), 1,
      ts_builtin_sym_end,
    ACTIONS(1626), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [12387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1500), 1,
      ts_builtin_sym_end,
    ACTIONS(1456), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [12455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1803), 1,
      ts_builtin_sym_end,
    ACTIONS(1554), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [12523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1805), 1,
      ts_builtin_sym_end,
    ACTIONS(1550), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [12591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1807), 1,
      ts_builtin_sym_end,
    ACTIONS(1548), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [12659] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_PLUS,
    ACTIONS(1678), 1,
      anon_sym_DASH,
    ACTIONS(827), 2,
      anon_sym_DASHin,
      anon_sym_DASHis,
    ACTIONS(825), 56,
      anon_sym_DASHas,
      anon_sym_DASHccontains,
      anon_sym_DASHceq,
      anon_sym_DASHcge,
      anon_sym_DASHcgt,
      anon_sym_DASHcle,
      anon_sym_DASHclike,
      anon_sym_DASHclt,
      anon_sym_DASHcmatch,
      anon_sym_DASHcne,
      anon_sym_DASHcnotcontains,
      anon_sym_DASHcnotlike,
      anon_sym_DASHcnotmatch,
      anon_sym_DASHcontains,
      anon_sym_DASHcreplace,
      anon_sym_DASHcsplit,
      anon_sym_DASHeq,
      anon_sym_DASHge,
      anon_sym_DASHgt,
      anon_sym_DASHicontains,
      anon_sym_DASHieq,
      anon_sym_DASHige,
      anon_sym_DASHigt,
      anon_sym_DASHile,
      anon_sym_DASHilike,
      anon_sym_DASHilt,
      anon_sym_DASHimatch,
      anon_sym_DASHine,
      anon_sym_DASHinotcontains,
      anon_sym_DASHinotlike,
      anon_sym_DASHinotmatch,
      anon_sym_DASHireplace,
      anon_sym_DASHisnot,
      anon_sym_DASHisplit,
      anon_sym_DASHjoin,
      anon_sym_DASHle,
      anon_sym_DASHlike,
      anon_sym_DASHlt,
      anon_sym_DASHmatch,
      anon_sym_DASHne,
      anon_sym_DASHnotcontains,
      anon_sym_DASHnotin,
      anon_sym_DASHnotlike,
      anon_sym_DASHnotmatch,
      anon_sym_DASHreplace,
      anon_sym_DASHshl,
      anon_sym_DASHshr,
      anon_sym_DASHsplit,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
      anon_sym_DASHband,
      anon_sym_DASHbor,
      anon_sym_DASHbxor,
  [12731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1809), 1,
      ts_builtin_sym_end,
    ACTIONS(1526), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [12799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1811), 1,
      ts_builtin_sym_end,
    ACTIONS(1650), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [12867] = 30,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(479), 1,
      sym_real_literal,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(487), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(489), 1,
      anon_sym_DASH_DASH,
    STATE(76), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(380), 1,
      sym_range_argument_expression,
    STATE(386), 1,
      sym_unary_expression,
    STATE(402), 1,
      sym_format_argument_expression,
    STATE(430), 1,
      sym_multiplicative_argument_expression,
    STATE(573), 1,
      sym_additive_argument_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(483), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(289), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [12988] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1383), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [13053] = 5,
    ACTIONS(81), 1,
      sym_comment,
    STATE(483), 1,
      sym_comparison_operator,
    ACTIONS(873), 2,
      anon_sym_DASHin,
      anon_sym_DASHis,
    ACTIONS(867), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
      anon_sym_DASHband,
      anon_sym_DASHbor,
      anon_sym_DASHbxor,
    ACTIONS(871), 48,
      anon_sym_DASHas,
      anon_sym_DASHccontains,
      anon_sym_DASHceq,
      anon_sym_DASHcge,
      anon_sym_DASHcgt,
      anon_sym_DASHcle,
      anon_sym_DASHclike,
      anon_sym_DASHclt,
      anon_sym_DASHcmatch,
      anon_sym_DASHcne,
      anon_sym_DASHcnotcontains,
      anon_sym_DASHcnotlike,
      anon_sym_DASHcnotmatch,
      anon_sym_DASHcontains,
      anon_sym_DASHcreplace,
      anon_sym_DASHcsplit,
      anon_sym_DASHeq,
      anon_sym_DASHge,
      anon_sym_DASHgt,
      anon_sym_DASHicontains,
      anon_sym_DASHieq,
      anon_sym_DASHige,
      anon_sym_DASHigt,
      anon_sym_DASHile,
      anon_sym_DASHilike,
      anon_sym_DASHilt,
      anon_sym_DASHimatch,
      anon_sym_DASHine,
      anon_sym_DASHinotcontains,
      anon_sym_DASHinotlike,
      anon_sym_DASHinotmatch,
      anon_sym_DASHireplace,
      anon_sym_DASHisnot,
      anon_sym_DASHisplit,
      anon_sym_DASHjoin,
      anon_sym_DASHle,
      anon_sym_DASHlike,
      anon_sym_DASHlt,
      anon_sym_DASHmatch,
      anon_sym_DASHne,
      anon_sym_DASHnotcontains,
      anon_sym_DASHnotin,
      anon_sym_DASHnotlike,
      anon_sym_DASHnotmatch,
      anon_sym_DASHreplace,
      anon_sym_DASHshl,
      anon_sym_DASHshr,
      anon_sym_DASHsplit,
  [13124] = 28,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(97), 1,
      anon_sym_DOT2,
    ACTIONS(1037), 1,
      sym_decimal_integer_literal,
    ACTIONS(1039), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1043), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1045), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1532), 1,
      anon_sym_LBRACK,
    ACTIONS(1813), 1,
      sym_real_literal,
    ACTIONS(1819), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1821), 1,
      anon_sym_DASH_DASH,
    STATE(541), 1,
      sym_type_literal,
    STATE(944), 1,
      sym_unary_expression,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    STATE(952), 1,
      sym_expression_with_unary_operator,
    ACTIONS(1047), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1055), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    ACTIONS(95), 3,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
    STATE(933), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1053), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1815), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1267), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [13241] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_PLUS,
    ACTIONS(1825), 1,
      anon_sym_DASH,
    ACTIONS(835), 2,
      anon_sym_DASHin,
      anon_sym_DASHis,
    ACTIONS(833), 55,
      sym__statement_terminator,
      anon_sym_DASHas,
      anon_sym_DASHccontains,
      anon_sym_DASHceq,
      anon_sym_DASHcge,
      anon_sym_DASHcgt,
      anon_sym_DASHcle,
      anon_sym_DASHclike,
      anon_sym_DASHclt,
      anon_sym_DASHcmatch,
      anon_sym_DASHcne,
      anon_sym_DASHcnotcontains,
      anon_sym_DASHcnotlike,
      anon_sym_DASHcnotmatch,
      anon_sym_DASHcontains,
      anon_sym_DASHcreplace,
      anon_sym_DASHcsplit,
      anon_sym_DASHeq,
      anon_sym_DASHge,
      anon_sym_DASHgt,
      anon_sym_DASHicontains,
      anon_sym_DASHieq,
      anon_sym_DASHige,
      anon_sym_DASHigt,
      anon_sym_DASHile,
      anon_sym_DASHilike,
      anon_sym_DASHilt,
      anon_sym_DASHimatch,
      anon_sym_DASHine,
      anon_sym_DASHinotcontains,
      anon_sym_DASHinotlike,
      anon_sym_DASHinotmatch,
      anon_sym_DASHireplace,
      anon_sym_DASHisnot,
      anon_sym_DASHisplit,
      anon_sym_DASHjoin,
      anon_sym_DASHle,
      anon_sym_DASHlike,
      anon_sym_DASHlt,
      anon_sym_DASHmatch,
      anon_sym_DASHne,
      anon_sym_DASHnotcontains,
      anon_sym_DASHnotin,
      anon_sym_DASHnotlike,
      anon_sym_DASHnotmatch,
      anon_sym_DASHreplace,
      anon_sym_DASHshl,
      anon_sym_DASHshr,
      anon_sym_DASHsplit,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
      anon_sym_DASHband,
      anon_sym_DASHbor,
      anon_sym_DASHbxor,
  [13312] = 28,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(97), 1,
      anon_sym_DOT2,
    ACTIONS(1037), 1,
      sym_decimal_integer_literal,
    ACTIONS(1039), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1043), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1045), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1528), 1,
      sym_real_literal,
    ACTIONS(1532), 1,
      anon_sym_LBRACK,
    ACTIONS(1540), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1542), 1,
      anon_sym_DASH_DASH,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(163), 1,
      sym_unary_expression,
    STATE(543), 1,
      sym_type_literal,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    ACTIONS(1047), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1055), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1538), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    ACTIONS(95), 3,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1053), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1534), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1295), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [13429] = 30,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(479), 1,
      sym_real_literal,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(487), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(489), 1,
      anon_sym_DASH_DASH,
    STATE(76), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(162), 1,
      sym_unary_expression,
    STATE(299), 1,
      sym_array_literal_expression,
    STATE(345), 1,
      sym_range_expression,
    STATE(370), 1,
      sym_format_expression,
    STATE(388), 1,
      sym_multiplicative_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(483), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(289), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [13550] = 30,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(85), 1,
      sym_real_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(93), 1,
      anon_sym_LBRACK,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(109), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(111), 1,
      anon_sym_DASH_DASH,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    STATE(5), 1,
      sym_type_literal,
    STATE(143), 1,
      sym_invokation_foreach_expression,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    STATE(173), 1,
      sym_unary_expression,
    STATE(175), 1,
      sym_array_literal_expression,
    STATE(180), 1,
      sym_range_expression,
    STATE(181), 1,
      sym_format_expression,
    STATE(187), 1,
      sym_multiplicative_expression,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(99), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(156), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [13671] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_PLUS,
    ACTIONS(1825), 1,
      anon_sym_DASH,
    ACTIONS(827), 2,
      anon_sym_DASHin,
      anon_sym_DASHis,
    ACTIONS(825), 55,
      sym__statement_terminator,
      anon_sym_DASHas,
      anon_sym_DASHccontains,
      anon_sym_DASHceq,
      anon_sym_DASHcge,
      anon_sym_DASHcgt,
      anon_sym_DASHcle,
      anon_sym_DASHclike,
      anon_sym_DASHclt,
      anon_sym_DASHcmatch,
      anon_sym_DASHcne,
      anon_sym_DASHcnotcontains,
      anon_sym_DASHcnotlike,
      anon_sym_DASHcnotmatch,
      anon_sym_DASHcontains,
      anon_sym_DASHcreplace,
      anon_sym_DASHcsplit,
      anon_sym_DASHeq,
      anon_sym_DASHge,
      anon_sym_DASHgt,
      anon_sym_DASHicontains,
      anon_sym_DASHieq,
      anon_sym_DASHige,
      anon_sym_DASHigt,
      anon_sym_DASHile,
      anon_sym_DASHilike,
      anon_sym_DASHilt,
      anon_sym_DASHimatch,
      anon_sym_DASHine,
      anon_sym_DASHinotcontains,
      anon_sym_DASHinotlike,
      anon_sym_DASHinotmatch,
      anon_sym_DASHireplace,
      anon_sym_DASHisnot,
      anon_sym_DASHisplit,
      anon_sym_DASHjoin,
      anon_sym_DASHle,
      anon_sym_DASHlike,
      anon_sym_DASHlt,
      anon_sym_DASHmatch,
      anon_sym_DASHne,
      anon_sym_DASHnotcontains,
      anon_sym_DASHnotin,
      anon_sym_DASHnotlike,
      anon_sym_DASHnotmatch,
      anon_sym_DASHreplace,
      anon_sym_DASHshl,
      anon_sym_DASHshr,
      anon_sym_DASHsplit,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
      anon_sym_DASHband,
      anon_sym_DASHbor,
      anon_sym_DASHbxor,
  [13742] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1400), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [13807] = 30,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(503), 1,
      anon_sym_LBRACK,
    ACTIONS(547), 1,
      sym_real_literal,
    ACTIONS(553), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(555), 1,
      anon_sym_DASH_DASH,
    STATE(81), 1,
      sym_type_literal,
    STATE(143), 1,
      sym_invokation_foreach_expression,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    STATE(173), 1,
      sym_unary_expression,
    STATE(308), 1,
      sym_array_literal_expression,
    STATE(334), 1,
      sym_range_expression,
    STATE(346), 1,
      sym_format_expression,
    STATE(382), 1,
      sym_multiplicative_expression,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(549), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(290), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [13928] = 28,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(97), 1,
      anon_sym_DOT2,
    ACTIONS(1083), 1,
      sym_decimal_integer_literal,
    ACTIONS(1085), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1089), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1091), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1103), 1,
      anon_sym_LPAREN,
    ACTIONS(1105), 1,
      anon_sym_LBRACE,
    ACTIONS(1113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1827), 1,
      sym_real_literal,
    ACTIONS(1829), 1,
      anon_sym_LBRACK,
    ACTIONS(1835), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1837), 1,
      anon_sym_DASH_DASH,
    STATE(165), 1,
      sym_unary_expression,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    STATE(549), 1,
      sym_type_literal,
    STATE(1022), 1,
      sym_invokation_foreach_expression,
    ACTIONS(1093), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1101), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1005), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    ACTIONS(95), 3,
      sym__statement_terminator,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1099), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1831), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1296), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [14045] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1420), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [14110] = 30,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(123), 1,
      sym_real_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(147), 1,
      anon_sym_DASH_DASH,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    STATE(3), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(162), 1,
      sym_unary_expression,
    STATE(166), 1,
      sym_array_literal_expression,
    STATE(178), 1,
      sym_range_expression,
    STATE(183), 1,
      sym_format_expression,
    STATE(185), 1,
      sym_multiplicative_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(143), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(133), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(155), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [14231] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1839), 59,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_foreach,
      anon_sym_for,
      anon_sym_while,
      anon_sym_do,
      anon_sym_function,
      anon_sym_filter,
      anon_sym_workflow,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_throw,
      anon_sym_return,
      anon_sym_exit,
      sym_label,
      anon_sym_trap,
      anon_sym_try,
      anon_sym_data,
      anon_sym_inlinescript,
      anon_sym_parallel,
      anon_sym_sequence,
      anon_sym_AMP,
      aux_sym_command_name_token1,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [14296] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1841), 1,
      anon_sym_PLUS,
    ACTIONS(1843), 1,
      anon_sym_DASH,
    ACTIONS(835), 2,
      anon_sym_DASHin,
      anon_sym_DASHis,
    ACTIONS(833), 55,
      anon_sym_DASHas,
      anon_sym_DASHccontains,
      anon_sym_DASHceq,
      anon_sym_DASHcge,
      anon_sym_DASHcgt,
      anon_sym_DASHcle,
      anon_sym_DASHclike,
      anon_sym_DASHclt,
      anon_sym_DASHcmatch,
      anon_sym_DASHcne,
      anon_sym_DASHcnotcontains,
      anon_sym_DASHcnotlike,
      anon_sym_DASHcnotmatch,
      anon_sym_DASHcontains,
      anon_sym_DASHcreplace,
      anon_sym_DASHcsplit,
      anon_sym_DASHeq,
      anon_sym_DASHge,
      anon_sym_DASHgt,
      anon_sym_DASHicontains,
      anon_sym_DASHieq,
      anon_sym_DASHige,
      anon_sym_DASHigt,
      anon_sym_DASHile,
      anon_sym_DASHilike,
      anon_sym_DASHilt,
      anon_sym_DASHimatch,
      anon_sym_DASHine,
      anon_sym_DASHinotcontains,
      anon_sym_DASHinotlike,
      anon_sym_DASHinotmatch,
      anon_sym_DASHireplace,
      anon_sym_DASHisnot,
      anon_sym_DASHisplit,
      anon_sym_DASHjoin,
      anon_sym_DASHle,
      anon_sym_DASHlike,
      anon_sym_DASHlt,
      anon_sym_DASHmatch,
      anon_sym_DASHne,
      anon_sym_DASHnotcontains,
      anon_sym_DASHnotin,
      anon_sym_DASHnotlike,
      anon_sym_DASHnotmatch,
      anon_sym_DASHreplace,
      anon_sym_DASHshl,
      anon_sym_DASHshr,
      anon_sym_DASHsplit,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
      anon_sym_DASHband,
      anon_sym_DASHbor,
      anon_sym_DASHbxor,
      anon_sym_RBRACK,
  [14367] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1841), 1,
      anon_sym_PLUS,
    ACTIONS(1843), 1,
      anon_sym_DASH,
    ACTIONS(827), 2,
      anon_sym_DASHin,
      anon_sym_DASHis,
    ACTIONS(825), 55,
      anon_sym_DASHas,
      anon_sym_DASHccontains,
      anon_sym_DASHceq,
      anon_sym_DASHcge,
      anon_sym_DASHcgt,
      anon_sym_DASHcle,
      anon_sym_DASHclike,
      anon_sym_DASHclt,
      anon_sym_DASHcmatch,
      anon_sym_DASHcne,
      anon_sym_DASHcnotcontains,
      anon_sym_DASHcnotlike,
      anon_sym_DASHcnotmatch,
      anon_sym_DASHcontains,
      anon_sym_DASHcreplace,
      anon_sym_DASHcsplit,
      anon_sym_DASHeq,
      anon_sym_DASHge,
      anon_sym_DASHgt,
      anon_sym_DASHicontains,
      anon_sym_DASHieq,
      anon_sym_DASHige,
      anon_sym_DASHigt,
      anon_sym_DASHile,
      anon_sym_DASHilike,
      anon_sym_DASHilt,
      anon_sym_DASHimatch,
      anon_sym_DASHine,
      anon_sym_DASHinotcontains,
      anon_sym_DASHinotlike,
      anon_sym_DASHinotmatch,
      anon_sym_DASHireplace,
      anon_sym_DASHisnot,
      anon_sym_DASHisplit,
      anon_sym_DASHjoin,
      anon_sym_DASHle,
      anon_sym_DASHlike,
      anon_sym_DASHlt,
      anon_sym_DASHmatch,
      anon_sym_DASHne,
      anon_sym_DASHnotcontains,
      anon_sym_DASHnotin,
      anon_sym_DASHnotlike,
      anon_sym_DASHnotmatch,
      anon_sym_DASHreplace,
      anon_sym_DASHshl,
      anon_sym_DASHshr,
      anon_sym_DASHsplit,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
      anon_sym_DASHband,
      anon_sym_DASHbor,
      anon_sym_DASHbxor,
      anon_sym_RBRACK,
  [14438] = 5,
    ACTIONS(81), 1,
      sym_comment,
    STATE(483), 1,
      sym_comparison_operator,
    ACTIONS(873), 2,
      anon_sym_DASHin,
      anon_sym_DASHis,
    ACTIONS(919), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
      anon_sym_DASHband,
      anon_sym_DASHbor,
      anon_sym_DASHbxor,
    ACTIONS(871), 48,
      anon_sym_DASHas,
      anon_sym_DASHccontains,
      anon_sym_DASHceq,
      anon_sym_DASHcge,
      anon_sym_DASHcgt,
      anon_sym_DASHcle,
      anon_sym_DASHclike,
      anon_sym_DASHclt,
      anon_sym_DASHcmatch,
      anon_sym_DASHcne,
      anon_sym_DASHcnotcontains,
      anon_sym_DASHcnotlike,
      anon_sym_DASHcnotmatch,
      anon_sym_DASHcontains,
      anon_sym_DASHcreplace,
      anon_sym_DASHcsplit,
      anon_sym_DASHeq,
      anon_sym_DASHge,
      anon_sym_DASHgt,
      anon_sym_DASHicontains,
      anon_sym_DASHieq,
      anon_sym_DASHige,
      anon_sym_DASHigt,
      anon_sym_DASHile,
      anon_sym_DASHilike,
      anon_sym_DASHilt,
      anon_sym_DASHimatch,
      anon_sym_DASHine,
      anon_sym_DASHinotcontains,
      anon_sym_DASHinotlike,
      anon_sym_DASHinotmatch,
      anon_sym_DASHireplace,
      anon_sym_DASHisnot,
      anon_sym_DASHisplit,
      anon_sym_DASHjoin,
      anon_sym_DASHle,
      anon_sym_DASHlike,
      anon_sym_DASHlt,
      anon_sym_DASHmatch,
      anon_sym_DASHne,
      anon_sym_DASHnotcontains,
      anon_sym_DASHnotin,
      anon_sym_DASHnotlike,
      anon_sym_DASHnotmatch,
      anon_sym_DASHreplace,
      anon_sym_DASHshl,
      anon_sym_DASHshr,
      anon_sym_DASHsplit,
  [14509] = 28,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(97), 1,
      anon_sym_DOT2,
    ACTIONS(1083), 1,
      sym_decimal_integer_literal,
    ACTIONS(1085), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1089), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1091), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1103), 1,
      anon_sym_LPAREN,
    ACTIONS(1105), 1,
      anon_sym_LBRACE,
    ACTIONS(1113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1829), 1,
      anon_sym_LBRACK,
    ACTIONS(1845), 1,
      sym_real_literal,
    ACTIONS(1851), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1853), 1,
      anon_sym_DASH_DASH,
    STATE(556), 1,
      sym_type_literal,
    STATE(1012), 1,
      sym_unary_expression,
    STATE(1017), 1,
      sym_expression_with_unary_operator,
    STATE(1022), 1,
      sym_invokation_foreach_expression,
    ACTIONS(1093), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1101), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1005), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    ACTIONS(95), 3,
      sym__statement_terminator,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
    STATE(1025), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1099), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1847), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1281), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [14626] = 30,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(479), 1,
      sym_real_literal,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(487), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(489), 1,
      anon_sym_DASH_DASH,
    STATE(76), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(162), 1,
      sym_unary_expression,
    STATE(301), 1,
      sym_range_expression,
    STATE(304), 1,
      sym_array_literal_expression,
    STATE(316), 1,
      sym_format_expression,
    STATE(347), 1,
      sym_multiplicative_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(483), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(289), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [14747] = 29,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(85), 1,
      sym_real_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(93), 1,
      anon_sym_LBRACK,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(109), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(111), 1,
      anon_sym_DASH_DASH,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    STATE(5), 1,
      sym_type_literal,
    STATE(143), 1,
      sym_invokation_foreach_expression,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    STATE(173), 1,
      sym_unary_expression,
    STATE(175), 1,
      sym_array_literal_expression,
    STATE(180), 1,
      sym_range_expression,
    STATE(184), 1,
      sym_format_expression,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(99), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(156), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [14865] = 5,
    ACTIONS(81), 1,
      sym_comment,
    STATE(525), 1,
      sym_comparison_operator,
    ACTIONS(873), 2,
      anon_sym_DASHin,
      anon_sym_DASHis,
    ACTIONS(867), 7,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
      anon_sym_DASHband,
      anon_sym_DASHbor,
      anon_sym_DASHbxor,
      anon_sym_RBRACK,
    ACTIONS(871), 48,
      anon_sym_DASHas,
      anon_sym_DASHccontains,
      anon_sym_DASHceq,
      anon_sym_DASHcge,
      anon_sym_DASHcgt,
      anon_sym_DASHcle,
      anon_sym_DASHclike,
      anon_sym_DASHclt,
      anon_sym_DASHcmatch,
      anon_sym_DASHcne,
      anon_sym_DASHcnotcontains,
      anon_sym_DASHcnotlike,
      anon_sym_DASHcnotmatch,
      anon_sym_DASHcontains,
      anon_sym_DASHcreplace,
      anon_sym_DASHcsplit,
      anon_sym_DASHeq,
      anon_sym_DASHge,
      anon_sym_DASHgt,
      anon_sym_DASHicontains,
      anon_sym_DASHieq,
      anon_sym_DASHige,
      anon_sym_DASHigt,
      anon_sym_DASHile,
      anon_sym_DASHilike,
      anon_sym_DASHilt,
      anon_sym_DASHimatch,
      anon_sym_DASHine,
      anon_sym_DASHinotcontains,
      anon_sym_DASHinotlike,
      anon_sym_DASHinotmatch,
      anon_sym_DASHireplace,
      anon_sym_DASHisnot,
      anon_sym_DASHisplit,
      anon_sym_DASHjoin,
      anon_sym_DASHle,
      anon_sym_DASHlike,
      anon_sym_DASHlt,
      anon_sym_DASHmatch,
      anon_sym_DASHne,
      anon_sym_DASHnotcontains,
      anon_sym_DASHnotin,
      anon_sym_DASHnotlike,
      anon_sym_DASHnotmatch,
      anon_sym_DASHreplace,
      anon_sym_DASHshl,
      anon_sym_DASHshr,
      anon_sym_DASHsplit,
  [14935] = 29,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(503), 1,
      anon_sym_LBRACK,
    ACTIONS(547), 1,
      sym_real_literal,
    ACTIONS(553), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(555), 1,
      anon_sym_DASH_DASH,
    STATE(81), 1,
      sym_type_literal,
    STATE(143), 1,
      sym_invokation_foreach_expression,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    STATE(173), 1,
      sym_unary_expression,
    STATE(308), 1,
      sym_array_literal_expression,
    STATE(334), 1,
      sym_range_expression,
    STATE(364), 1,
      sym_format_expression,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(549), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(290), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [15053] = 29,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(479), 1,
      sym_real_literal,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(487), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(489), 1,
      anon_sym_DASH_DASH,
    STATE(76), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(162), 1,
      sym_unary_expression,
    STATE(301), 1,
      sym_range_expression,
    STATE(304), 1,
      sym_array_literal_expression,
    STATE(319), 1,
      sym_format_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(483), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(289), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [15171] = 29,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1083), 1,
      sym_decimal_integer_literal,
    ACTIONS(1085), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1089), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1091), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1103), 1,
      anon_sym_LPAREN,
    ACTIONS(1105), 1,
      anon_sym_LBRACE,
    ACTIONS(1113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1289), 1,
      sym__statement_terminator,
    ACTIONS(1827), 1,
      sym_real_literal,
    ACTIONS(1829), 1,
      anon_sym_LBRACK,
    ACTIONS(1835), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1837), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1855), 1,
      sym_label,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    STATE(549), 1,
      sym_type_literal,
    STATE(1022), 1,
      sym_invokation_foreach_expression,
    STATE(1945), 1,
      sym_label_expression,
    STATE(1948), 1,
      sym_unary_expression,
    ACTIONS(1093), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1101), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1005), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1099), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1831), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1296), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [15289] = 5,
    ACTIONS(81), 1,
      sym_comment,
    STATE(502), 1,
      sym_comparison_operator,
    ACTIONS(873), 2,
      anon_sym_DASHin,
      anon_sym_DASHis,
    ACTIONS(919), 7,
      sym__statement_terminator,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
      anon_sym_DASHband,
      anon_sym_DASHbor,
      anon_sym_DASHbxor,
    ACTIONS(871), 48,
      anon_sym_DASHas,
      anon_sym_DASHccontains,
      anon_sym_DASHceq,
      anon_sym_DASHcge,
      anon_sym_DASHcgt,
      anon_sym_DASHcle,
      anon_sym_DASHclike,
      anon_sym_DASHclt,
      anon_sym_DASHcmatch,
      anon_sym_DASHcne,
      anon_sym_DASHcnotcontains,
      anon_sym_DASHcnotlike,
      anon_sym_DASHcnotmatch,
      anon_sym_DASHcontains,
      anon_sym_DASHcreplace,
      anon_sym_DASHcsplit,
      anon_sym_DASHeq,
      anon_sym_DASHge,
      anon_sym_DASHgt,
      anon_sym_DASHicontains,
      anon_sym_DASHieq,
      anon_sym_DASHige,
      anon_sym_DASHigt,
      anon_sym_DASHile,
      anon_sym_DASHilike,
      anon_sym_DASHilt,
      anon_sym_DASHimatch,
      anon_sym_DASHine,
      anon_sym_DASHinotcontains,
      anon_sym_DASHinotlike,
      anon_sym_DASHinotmatch,
      anon_sym_DASHireplace,
      anon_sym_DASHisnot,
      anon_sym_DASHisplit,
      anon_sym_DASHjoin,
      anon_sym_DASHle,
      anon_sym_DASHlike,
      anon_sym_DASHlt,
      anon_sym_DASHmatch,
      anon_sym_DASHne,
      anon_sym_DASHnotcontains,
      anon_sym_DASHnotin,
      anon_sym_DASHnotlike,
      anon_sym_DASHnotmatch,
      anon_sym_DASHreplace,
      anon_sym_DASHshl,
      anon_sym_DASHshr,
      anon_sym_DASHsplit,
  [15359] = 5,
    ACTIONS(81), 1,
      sym_comment,
    STATE(502), 1,
      sym_comparison_operator,
    ACTIONS(873), 2,
      anon_sym_DASHin,
      anon_sym_DASHis,
    ACTIONS(867), 7,
      sym__statement_terminator,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
      anon_sym_DASHband,
      anon_sym_DASHbor,
      anon_sym_DASHbxor,
    ACTIONS(871), 48,
      anon_sym_DASHas,
      anon_sym_DASHccontains,
      anon_sym_DASHceq,
      anon_sym_DASHcge,
      anon_sym_DASHcgt,
      anon_sym_DASHcle,
      anon_sym_DASHclike,
      anon_sym_DASHclt,
      anon_sym_DASHcmatch,
      anon_sym_DASHcne,
      anon_sym_DASHcnotcontains,
      anon_sym_DASHcnotlike,
      anon_sym_DASHcnotmatch,
      anon_sym_DASHcontains,
      anon_sym_DASHcreplace,
      anon_sym_DASHcsplit,
      anon_sym_DASHeq,
      anon_sym_DASHge,
      anon_sym_DASHgt,
      anon_sym_DASHicontains,
      anon_sym_DASHieq,
      anon_sym_DASHige,
      anon_sym_DASHigt,
      anon_sym_DASHile,
      anon_sym_DASHilike,
      anon_sym_DASHilt,
      anon_sym_DASHimatch,
      anon_sym_DASHine,
      anon_sym_DASHinotcontains,
      anon_sym_DASHinotlike,
      anon_sym_DASHinotmatch,
      anon_sym_DASHireplace,
      anon_sym_DASHisnot,
      anon_sym_DASHisplit,
      anon_sym_DASHjoin,
      anon_sym_DASHle,
      anon_sym_DASHlike,
      anon_sym_DASHlt,
      anon_sym_DASHmatch,
      anon_sym_DASHne,
      anon_sym_DASHnotcontains,
      anon_sym_DASHnotin,
      anon_sym_DASHnotlike,
      anon_sym_DASHnotmatch,
      anon_sym_DASHreplace,
      anon_sym_DASHshl,
      anon_sym_DASHshr,
      anon_sym_DASHsplit,
  [15429] = 5,
    ACTIONS(81), 1,
      sym_comment,
    STATE(525), 1,
      sym_comparison_operator,
    ACTIONS(873), 2,
      anon_sym_DASHin,
      anon_sym_DASHis,
    ACTIONS(919), 7,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
      anon_sym_DASHband,
      anon_sym_DASHbor,
      anon_sym_DASHbxor,
      anon_sym_RBRACK,
    ACTIONS(871), 48,
      anon_sym_DASHas,
      anon_sym_DASHccontains,
      anon_sym_DASHceq,
      anon_sym_DASHcge,
      anon_sym_DASHcgt,
      anon_sym_DASHcle,
      anon_sym_DASHclike,
      anon_sym_DASHclt,
      anon_sym_DASHcmatch,
      anon_sym_DASHcne,
      anon_sym_DASHcnotcontains,
      anon_sym_DASHcnotlike,
      anon_sym_DASHcnotmatch,
      anon_sym_DASHcontains,
      anon_sym_DASHcreplace,
      anon_sym_DASHcsplit,
      anon_sym_DASHeq,
      anon_sym_DASHge,
      anon_sym_DASHgt,
      anon_sym_DASHicontains,
      anon_sym_DASHieq,
      anon_sym_DASHige,
      anon_sym_DASHigt,
      anon_sym_DASHile,
      anon_sym_DASHilike,
      anon_sym_DASHilt,
      anon_sym_DASHimatch,
      anon_sym_DASHine,
      anon_sym_DASHinotcontains,
      anon_sym_DASHinotlike,
      anon_sym_DASHinotmatch,
      anon_sym_DASHireplace,
      anon_sym_DASHisnot,
      anon_sym_DASHisplit,
      anon_sym_DASHjoin,
      anon_sym_DASHle,
      anon_sym_DASHlike,
      anon_sym_DASHlt,
      anon_sym_DASHmatch,
      anon_sym_DASHne,
      anon_sym_DASHnotcontains,
      anon_sym_DASHnotin,
      anon_sym_DASHnotlike,
      anon_sym_DASHnotmatch,
      anon_sym_DASHreplace,
      anon_sym_DASHshl,
      anon_sym_DASHshr,
      anon_sym_DASHsplit,
  [15499] = 29,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(479), 1,
      sym_real_literal,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(487), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(489), 1,
      anon_sym_DASH_DASH,
    STATE(76), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(380), 1,
      sym_range_argument_expression,
    STATE(386), 1,
      sym_unary_expression,
    STATE(402), 1,
      sym_format_argument_expression,
    STATE(474), 1,
      sym_multiplicative_argument_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(483), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(289), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [15617] = 29,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(479), 1,
      sym_real_literal,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(487), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(489), 1,
      anon_sym_DASH_DASH,
    STATE(76), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(162), 1,
      sym_unary_expression,
    STATE(299), 1,
      sym_array_literal_expression,
    STATE(345), 1,
      sym_range_expression,
    STATE(355), 1,
      sym_format_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(483), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(289), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [15735] = 29,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(123), 1,
      sym_real_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(147), 1,
      anon_sym_DASH_DASH,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    STATE(3), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(162), 1,
      sym_unary_expression,
    STATE(166), 1,
      sym_array_literal_expression,
    STATE(178), 1,
      sym_range_expression,
    STATE(182), 1,
      sym_format_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(143), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(133), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(155), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [15853] = 28,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(479), 1,
      sym_real_literal,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(487), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(489), 1,
      anon_sym_DASH_DASH,
    STATE(76), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(162), 1,
      sym_unary_expression,
    STATE(299), 1,
      sym_array_literal_expression,
    STATE(323), 1,
      sym_range_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(483), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(289), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [15968] = 28,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(503), 1,
      anon_sym_LBRACK,
    ACTIONS(547), 1,
      sym_real_literal,
    ACTIONS(553), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(555), 1,
      anon_sym_DASH_DASH,
    STATE(81), 1,
      sym_type_literal,
    STATE(143), 1,
      sym_invokation_foreach_expression,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    STATE(173), 1,
      sym_unary_expression,
    STATE(308), 1,
      sym_array_literal_expression,
    STATE(330), 1,
      sym_range_expression,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(549), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(290), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [16083] = 28,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(123), 1,
      sym_real_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(147), 1,
      anon_sym_DASH_DASH,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    STATE(3), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(162), 1,
      sym_unary_expression,
    STATE(166), 1,
      sym_array_literal_expression,
    STATE(177), 1,
      sym_range_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(143), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(133), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(155), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [16198] = 28,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(479), 1,
      sym_real_literal,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(487), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(489), 1,
      anon_sym_DASH_DASH,
    STATE(76), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(162), 1,
      sym_unary_expression,
    STATE(302), 1,
      sym_range_expression,
    STATE(304), 1,
      sym_array_literal_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(483), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(289), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [16313] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1861), 1,
      anon_sym_PLUS,
    ACTIONS(1863), 1,
      anon_sym_DASH,
    ACTIONS(1859), 2,
      anon_sym_DASHin,
      anon_sym_DASHis,
    ACTIONS(1857), 53,
      anon_sym_DASHas,
      anon_sym_DASHccontains,
      anon_sym_DASHceq,
      anon_sym_DASHcge,
      anon_sym_DASHcgt,
      anon_sym_DASHcle,
      anon_sym_DASHclike,
      anon_sym_DASHclt,
      anon_sym_DASHcmatch,
      anon_sym_DASHcne,
      anon_sym_DASHcnotcontains,
      anon_sym_DASHcnotlike,
      anon_sym_DASHcnotmatch,
      anon_sym_DASHcontains,
      anon_sym_DASHcreplace,
      anon_sym_DASHcsplit,
      anon_sym_DASHeq,
      anon_sym_DASHge,
      anon_sym_DASHgt,
      anon_sym_DASHicontains,
      anon_sym_DASHieq,
      anon_sym_DASHige,
      anon_sym_DASHigt,
      anon_sym_DASHile,
      anon_sym_DASHilike,
      anon_sym_DASHilt,
      anon_sym_DASHimatch,
      anon_sym_DASHine,
      anon_sym_DASHinotcontains,
      anon_sym_DASHinotlike,
      anon_sym_DASHinotmatch,
      anon_sym_DASHireplace,
      anon_sym_DASHisnot,
      anon_sym_DASHisplit,
      anon_sym_DASHjoin,
      anon_sym_DASHle,
      anon_sym_DASHlike,
      anon_sym_DASHlt,
      anon_sym_DASHmatch,
      anon_sym_DASHne,
      anon_sym_DASHnotcontains,
      anon_sym_DASHnotin,
      anon_sym_DASHnotlike,
      anon_sym_DASHnotmatch,
      anon_sym_DASHreplace,
      anon_sym_DASHshl,
      anon_sym_DASHshr,
      anon_sym_DASHsplit,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
  [16382] = 28,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(85), 1,
      sym_real_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(93), 1,
      anon_sym_LBRACK,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(109), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(111), 1,
      anon_sym_DASH_DASH,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    STATE(5), 1,
      sym_type_literal,
    STATE(143), 1,
      sym_invokation_foreach_expression,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    STATE(173), 1,
      sym_unary_expression,
    STATE(175), 1,
      sym_array_literal_expression,
    STATE(179), 1,
      sym_range_expression,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(99), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(156), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [16497] = 28,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(479), 1,
      sym_real_literal,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(487), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(489), 1,
      anon_sym_DASH_DASH,
    STATE(76), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(380), 1,
      sym_range_argument_expression,
    STATE(386), 1,
      sym_unary_expression,
    STATE(391), 1,
      sym_format_argument_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(483), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(289), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [16612] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1861), 1,
      anon_sym_PLUS,
    ACTIONS(1863), 1,
      anon_sym_DASH,
    ACTIONS(1867), 2,
      anon_sym_DASHin,
      anon_sym_DASHis,
    ACTIONS(1865), 53,
      anon_sym_DASHas,
      anon_sym_DASHccontains,
      anon_sym_DASHceq,
      anon_sym_DASHcge,
      anon_sym_DASHcgt,
      anon_sym_DASHcle,
      anon_sym_DASHclike,
      anon_sym_DASHclt,
      anon_sym_DASHcmatch,
      anon_sym_DASHcne,
      anon_sym_DASHcnotcontains,
      anon_sym_DASHcnotlike,
      anon_sym_DASHcnotmatch,
      anon_sym_DASHcontains,
      anon_sym_DASHcreplace,
      anon_sym_DASHcsplit,
      anon_sym_DASHeq,
      anon_sym_DASHge,
      anon_sym_DASHgt,
      anon_sym_DASHicontains,
      anon_sym_DASHieq,
      anon_sym_DASHige,
      anon_sym_DASHigt,
      anon_sym_DASHile,
      anon_sym_DASHilike,
      anon_sym_DASHilt,
      anon_sym_DASHimatch,
      anon_sym_DASHine,
      anon_sym_DASHinotcontains,
      anon_sym_DASHinotlike,
      anon_sym_DASHinotmatch,
      anon_sym_DASHireplace,
      anon_sym_DASHisnot,
      anon_sym_DASHisplit,
      anon_sym_DASHjoin,
      anon_sym_DASHle,
      anon_sym_DASHlike,
      anon_sym_DASHlt,
      anon_sym_DASHmatch,
      anon_sym_DASHne,
      anon_sym_DASHnotcontains,
      anon_sym_DASHnotin,
      anon_sym_DASHnotlike,
      anon_sym_DASHnotmatch,
      anon_sym_DASHreplace,
      anon_sym_DASHshl,
      anon_sym_DASHshr,
      anon_sym_DASHsplit,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
  [16681] = 27,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(479), 1,
      sym_real_literal,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(487), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(489), 1,
      anon_sym_DASH_DASH,
    STATE(76), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(162), 1,
      sym_unary_expression,
    STATE(311), 1,
      sym_array_literal_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(483), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(289), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [16793] = 27,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(123), 1,
      sym_real_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(147), 1,
      anon_sym_DASH_DASH,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    STATE(3), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(162), 1,
      sym_unary_expression,
    STATE(168), 1,
      sym_array_literal_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(143), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(133), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(155), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [16905] = 27,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(503), 1,
      anon_sym_LBRACK,
    ACTIONS(547), 1,
      sym_real_literal,
    ACTIONS(553), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(555), 1,
      anon_sym_DASH_DASH,
    STATE(81), 1,
      sym_type_literal,
    STATE(143), 1,
      sym_invokation_foreach_expression,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    STATE(173), 1,
      sym_unary_expression,
    STATE(303), 1,
      sym_array_literal_expression,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(549), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(290), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [17017] = 27,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(85), 1,
      sym_real_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(93), 1,
      anon_sym_LBRACK,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(109), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(111), 1,
      anon_sym_DASH_DASH,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    STATE(5), 1,
      sym_type_literal,
    STATE(143), 1,
      sym_invokation_foreach_expression,
    STATE(170), 1,
      sym_array_literal_expression,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    STATE(173), 1,
      sym_unary_expression,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(99), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(156), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [17129] = 27,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(479), 1,
      sym_real_literal,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(487), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(489), 1,
      anon_sym_DASH_DASH,
    STATE(76), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(162), 1,
      sym_unary_expression,
    STATE(312), 1,
      sym_array_literal_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(483), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(289), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [17241] = 27,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(479), 1,
      sym_real_literal,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(487), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(489), 1,
      anon_sym_DASH_DASH,
    STATE(76), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(377), 1,
      sym_range_argument_expression,
    STATE(386), 1,
      sym_unary_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(483), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(289), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [17353] = 5,
    ACTIONS(81), 1,
      sym_comment,
    STATE(538), 1,
      sym_comparison_operator,
    ACTIONS(873), 2,
      anon_sym_DASHin,
      anon_sym_DASHis,
    ACTIONS(1869), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
    ACTIONS(871), 48,
      anon_sym_DASHas,
      anon_sym_DASHccontains,
      anon_sym_DASHceq,
      anon_sym_DASHcge,
      anon_sym_DASHcgt,
      anon_sym_DASHcle,
      anon_sym_DASHclike,
      anon_sym_DASHclt,
      anon_sym_DASHcmatch,
      anon_sym_DASHcne,
      anon_sym_DASHcnotcontains,
      anon_sym_DASHcnotlike,
      anon_sym_DASHcnotmatch,
      anon_sym_DASHcontains,
      anon_sym_DASHcreplace,
      anon_sym_DASHcsplit,
      anon_sym_DASHeq,
      anon_sym_DASHge,
      anon_sym_DASHgt,
      anon_sym_DASHicontains,
      anon_sym_DASHieq,
      anon_sym_DASHige,
      anon_sym_DASHigt,
      anon_sym_DASHile,
      anon_sym_DASHilike,
      anon_sym_DASHilt,
      anon_sym_DASHimatch,
      anon_sym_DASHine,
      anon_sym_DASHinotcontains,
      anon_sym_DASHinotlike,
      anon_sym_DASHinotmatch,
      anon_sym_DASHireplace,
      anon_sym_DASHisnot,
      anon_sym_DASHisplit,
      anon_sym_DASHjoin,
      anon_sym_DASHle,
      anon_sym_DASHlike,
      anon_sym_DASHlt,
      anon_sym_DASHmatch,
      anon_sym_DASHne,
      anon_sym_DASHnotcontains,
      anon_sym_DASHnotin,
      anon_sym_DASHnotlike,
      anon_sym_DASHnotmatch,
      anon_sym_DASHreplace,
      anon_sym_DASHshl,
      anon_sym_DASHshr,
      anon_sym_DASHsplit,
  [17421] = 5,
    ACTIONS(81), 1,
      sym_comment,
    STATE(538), 1,
      sym_comparison_operator,
    ACTIONS(873), 2,
      anon_sym_DASHin,
      anon_sym_DASHis,
    ACTIONS(1871), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
    ACTIONS(871), 48,
      anon_sym_DASHas,
      anon_sym_DASHccontains,
      anon_sym_DASHceq,
      anon_sym_DASHcge,
      anon_sym_DASHcgt,
      anon_sym_DASHcle,
      anon_sym_DASHclike,
      anon_sym_DASHclt,
      anon_sym_DASHcmatch,
      anon_sym_DASHcne,
      anon_sym_DASHcnotcontains,
      anon_sym_DASHcnotlike,
      anon_sym_DASHcnotmatch,
      anon_sym_DASHcontains,
      anon_sym_DASHcreplace,
      anon_sym_DASHcsplit,
      anon_sym_DASHeq,
      anon_sym_DASHge,
      anon_sym_DASHgt,
      anon_sym_DASHicontains,
      anon_sym_DASHieq,
      anon_sym_DASHige,
      anon_sym_DASHigt,
      anon_sym_DASHile,
      anon_sym_DASHilike,
      anon_sym_DASHilt,
      anon_sym_DASHimatch,
      anon_sym_DASHine,
      anon_sym_DASHinotcontains,
      anon_sym_DASHinotlike,
      anon_sym_DASHinotmatch,
      anon_sym_DASHireplace,
      anon_sym_DASHisnot,
      anon_sym_DASHisplit,
      anon_sym_DASHjoin,
      anon_sym_DASHle,
      anon_sym_DASHlike,
      anon_sym_DASHlt,
      anon_sym_DASHmatch,
      anon_sym_DASHne,
      anon_sym_DASHnotcontains,
      anon_sym_DASHnotin,
      anon_sym_DASHnotlike,
      anon_sym_DASHnotmatch,
      anon_sym_DASHreplace,
      anon_sym_DASHshl,
      anon_sym_DASHshr,
      anon_sym_DASHsplit,
  [17489] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(155), 1,
      sym_real_literal,
    ACTIONS(161), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(163), 1,
      anon_sym_DASH_DASH,
    STATE(4), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(90), 1,
      sym_unary_expression,
    STATE(117), 1,
      sym_expression_with_unary_operator,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(118), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(157), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(135), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [17598] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(941), 1,
      sym_decimal_integer_literal,
    ACTIONS(1873), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1875), 1,
      sym_real_literal,
    ACTIONS(1877), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1879), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1883), 1,
      anon_sym_LBRACK,
    ACTIONS(1889), 1,
      anon_sym_LPAREN,
    ACTIONS(1891), 1,
      anon_sym_LBRACE,
    ACTIONS(1893), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1895), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1897), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1899), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1901), 1,
      anon_sym_AT_LBRACE,
    STATE(209), 1,
      sym_type_literal,
    STATE(840), 1,
      sym_invokation_foreach_expression,
    STATE(1051), 1,
      sym_unary_expression,
    STATE(1076), 1,
      sym_expression_with_unary_operator,
    ACTIONS(955), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1881), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(846), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1059), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1887), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1885), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(924), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [17707] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(883), 1,
      sym_decimal_integer_literal,
    ACTIONS(1903), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1905), 1,
      sym_real_literal,
    ACTIONS(1907), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1909), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1913), 1,
      anon_sym_LBRACK,
    ACTIONS(1919), 1,
      anon_sym_LPAREN,
    ACTIONS(1921), 1,
      anon_sym_LBRACE,
    ACTIONS(1923), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1925), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1927), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1929), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1931), 1,
      anon_sym_AT_LBRACE,
    STATE(202), 1,
      sym_type_literal,
    STATE(801), 1,
      sym_invokation_foreach_expression,
    STATE(1041), 1,
      sym_expression_with_unary_operator,
    STATE(1043), 1,
      sym_unary_expression,
    ACTIONS(897), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(931), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1911), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(796), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1035), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1917), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1915), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(800), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [17816] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(883), 1,
      sym_decimal_integer_literal,
    ACTIONS(1903), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1905), 1,
      sym_real_literal,
    ACTIONS(1907), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1909), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1913), 1,
      anon_sym_LBRACK,
    ACTIONS(1919), 1,
      anon_sym_LPAREN,
    ACTIONS(1921), 1,
      anon_sym_LBRACE,
    ACTIONS(1923), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1925), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1927), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1929), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1931), 1,
      anon_sym_AT_LBRACE,
    STATE(202), 1,
      sym_type_literal,
    STATE(801), 1,
      sym_invokation_foreach_expression,
    STATE(1040), 1,
      sym_unary_expression,
    STATE(1041), 1,
      sym_expression_with_unary_operator,
    ACTIONS(897), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(931), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1911), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(796), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1035), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1917), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1915), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(800), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [17925] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1083), 1,
      sym_decimal_integer_literal,
    ACTIONS(1085), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1087), 1,
      sym_real_literal,
    ACTIONS(1089), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1091), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1103), 1,
      anon_sym_LPAREN,
    ACTIONS(1105), 1,
      anon_sym_LBRACE,
    ACTIONS(1109), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1111), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1117), 1,
      anon_sym_AT_LBRACE,
    STATE(221), 1,
      sym_type_literal,
    STATE(1000), 1,
      sym_unary_expression,
    STATE(1017), 1,
      sym_expression_with_unary_operator,
    STATE(1022), 1,
      sym_invokation_foreach_expression,
    ACTIONS(1093), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1101), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1005), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1025), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1099), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1097), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1016), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [18034] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1083), 1,
      sym_decimal_integer_literal,
    ACTIONS(1085), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1087), 1,
      sym_real_literal,
    ACTIONS(1089), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1091), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1103), 1,
      anon_sym_LPAREN,
    ACTIONS(1105), 1,
      anon_sym_LBRACE,
    ACTIONS(1109), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1111), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1117), 1,
      anon_sym_AT_LBRACE,
    STATE(221), 1,
      sym_type_literal,
    STATE(999), 1,
      sym_unary_expression,
    STATE(1017), 1,
      sym_expression_with_unary_operator,
    STATE(1022), 1,
      sym_invokation_foreach_expression,
    ACTIONS(1093), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1101), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1005), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1025), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1099), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1097), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1016), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [18143] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(837), 1,
      sym_decimal_integer_literal,
    ACTIONS(1933), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1935), 1,
      sym_real_literal,
    ACTIONS(1937), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1939), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1943), 1,
      anon_sym_LBRACK,
    ACTIONS(1949), 1,
      anon_sym_LPAREN,
    ACTIONS(1951), 1,
      anon_sym_LBRACE,
    ACTIONS(1953), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1955), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1957), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1959), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1961), 1,
      anon_sym_AT_LBRACE,
    STATE(199), 1,
      sym_type_literal,
    STATE(767), 1,
      sym_invokation_foreach_expression,
    STATE(1046), 1,
      sym_unary_expression,
    STATE(1049), 1,
      sym_expression_with_unary_operator,
    ACTIONS(851), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(913), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1941), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(771), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1047), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1947), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1945), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(768), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [18252] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(837), 1,
      sym_decimal_integer_literal,
    ACTIONS(1933), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1935), 1,
      sym_real_literal,
    ACTIONS(1937), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1939), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1943), 1,
      anon_sym_LBRACK,
    ACTIONS(1949), 1,
      anon_sym_LPAREN,
    ACTIONS(1951), 1,
      anon_sym_LBRACE,
    ACTIONS(1953), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1955), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1957), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1959), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1961), 1,
      anon_sym_AT_LBRACE,
    STATE(199), 1,
      sym_type_literal,
    STATE(767), 1,
      sym_invokation_foreach_expression,
    STATE(1045), 1,
      sym_unary_expression,
    STATE(1049), 1,
      sym_expression_with_unary_operator,
    ACTIONS(851), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(913), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1941), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(771), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1047), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1947), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1945), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(768), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [18361] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(837), 1,
      sym_decimal_integer_literal,
    ACTIONS(1933), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1935), 1,
      sym_real_literal,
    ACTIONS(1937), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1939), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1943), 1,
      anon_sym_LBRACK,
    ACTIONS(1949), 1,
      anon_sym_LPAREN,
    ACTIONS(1951), 1,
      anon_sym_LBRACE,
    ACTIONS(1953), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1955), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1957), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1959), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1961), 1,
      anon_sym_AT_LBRACE,
    STATE(199), 1,
      sym_type_literal,
    STATE(767), 1,
      sym_invokation_foreach_expression,
    STATE(1036), 1,
      sym_unary_expression,
    STATE(1049), 1,
      sym_expression_with_unary_operator,
    ACTIONS(851), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(913), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1941), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(771), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1047), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1947), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1945), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(768), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [18470] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(941), 1,
      sym_decimal_integer_literal,
    ACTIONS(1873), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1877), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1879), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1883), 1,
      anon_sym_LBRACK,
    ACTIONS(1889), 1,
      anon_sym_LPAREN,
    ACTIONS(1891), 1,
      anon_sym_LBRACE,
    ACTIONS(1897), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1899), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1901), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1963), 1,
      sym_real_literal,
    ACTIONS(1967), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1969), 1,
      anon_sym_DASH_DASH,
    STATE(206), 1,
      sym_type_literal,
    STATE(840), 1,
      sym_invokation_foreach_expression,
    STATE(1076), 1,
      sym_expression_with_unary_operator,
    STATE(1077), 1,
      sym_unary_expression,
    ACTIONS(953), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(955), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1881), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(846), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1059), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1887), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1965), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(892), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [18579] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(491), 1,
      sym_real_literal,
    ACTIONS(497), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(499), 1,
      anon_sym_DASH_DASH,
    STATE(77), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(90), 1,
      sym_unary_expression,
    STATE(117), 1,
      sym_expression_with_unary_operator,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(495), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(118), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(493), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(287), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [18688] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(491), 1,
      sym_real_literal,
    ACTIONS(497), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(499), 1,
      anon_sym_DASH_DASH,
    STATE(77), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(117), 1,
      sym_expression_with_unary_operator,
    STATE(121), 1,
      sym_unary_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(495), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(118), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(493), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(287), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [18797] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(491), 1,
      sym_real_literal,
    ACTIONS(497), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(499), 1,
      anon_sym_DASH_DASH,
    STATE(77), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(117), 1,
      sym_expression_with_unary_operator,
    STATE(119), 1,
      sym_unary_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(495), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(118), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(493), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(287), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [18906] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(941), 1,
      sym_decimal_integer_literal,
    ACTIONS(1873), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1877), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1879), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1883), 1,
      anon_sym_LBRACK,
    ACTIONS(1889), 1,
      anon_sym_LPAREN,
    ACTIONS(1891), 1,
      anon_sym_LBRACE,
    ACTIONS(1897), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1899), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1901), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1963), 1,
      sym_real_literal,
    ACTIONS(1967), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1969), 1,
      anon_sym_DASH_DASH,
    STATE(206), 1,
      sym_type_literal,
    STATE(840), 1,
      sym_invokation_foreach_expression,
    STATE(1065), 1,
      sym_unary_expression,
    STATE(1076), 1,
      sym_expression_with_unary_operator,
    ACTIONS(953), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(955), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1881), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(846), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1059), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1887), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1965), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(892), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [19015] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1083), 1,
      sym_decimal_integer_literal,
    ACTIONS(1085), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1089), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1091), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1103), 1,
      anon_sym_LPAREN,
    ACTIONS(1105), 1,
      anon_sym_LBRACE,
    ACTIONS(1113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1827), 1,
      sym_real_literal,
    ACTIONS(1829), 1,
      anon_sym_LBRACK,
    ACTIONS(1835), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1837), 1,
      anon_sym_DASH_DASH,
    STATE(167), 1,
      sym_unary_expression,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    STATE(549), 1,
      sym_type_literal,
    STATE(1022), 1,
      sym_invokation_foreach_expression,
    ACTIONS(1093), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1101), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1005), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1099), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1831), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1296), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [19124] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(941), 1,
      sym_decimal_integer_literal,
    ACTIONS(1873), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1877), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1879), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1883), 1,
      anon_sym_LBRACK,
    ACTIONS(1889), 1,
      anon_sym_LPAREN,
    ACTIONS(1891), 1,
      anon_sym_LBRACE,
    ACTIONS(1897), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1899), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1901), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1963), 1,
      sym_real_literal,
    ACTIONS(1967), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1969), 1,
      anon_sym_DASH_DASH,
    STATE(206), 1,
      sym_type_literal,
    STATE(840), 1,
      sym_invokation_foreach_expression,
    STATE(1052), 1,
      sym_unary_expression,
    STATE(1076), 1,
      sym_expression_with_unary_operator,
    ACTIONS(953), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(955), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1881), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(846), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1059), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1887), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1965), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(892), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [19233] = 26,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(501), 1,
      sym_real_literal,
    ACTIONS(503), 1,
      anon_sym_LBRACK,
    ACTIONS(509), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(511), 1,
      anon_sym_DASH_DASH,
    STATE(78), 1,
      sym_type_literal,
    STATE(137), 1,
      sym_expression_with_unary_operator,
    STATE(141), 1,
      sym_unary_expression,
    STATE(143), 1,
      sym_invokation_foreach_expression,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(507), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(138), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(505), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(288), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [19342] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(479), 1,
      sym_real_literal,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(487), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(489), 1,
      anon_sym_DASH_DASH,
    STATE(76), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(157), 1,
      sym_unary_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(483), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(289), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [19451] = 26,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(501), 1,
      sym_real_literal,
    ACTIONS(503), 1,
      anon_sym_LBRACK,
    ACTIONS(509), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(511), 1,
      anon_sym_DASH_DASH,
    STATE(78), 1,
      sym_type_literal,
    STATE(137), 1,
      sym_expression_with_unary_operator,
    STATE(140), 1,
      sym_unary_expression,
    STATE(143), 1,
      sym_invokation_foreach_expression,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(507), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(138), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(505), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(288), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [19560] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_decimal_integer_literal,
    ACTIONS(1971), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1973), 1,
      sym_real_literal,
    ACTIONS(1975), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1977), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1981), 1,
      anon_sym_LBRACK,
    ACTIONS(1987), 1,
      anon_sym_LPAREN,
    ACTIONS(1989), 1,
      anon_sym_LBRACE,
    ACTIONS(1991), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1993), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1995), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1997), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1999), 1,
      anon_sym_AT_LBRACE,
    STATE(212), 1,
      sym_type_literal,
    STATE(861), 1,
      sym_invokation_foreach_expression,
    STATE(1068), 1,
      sym_expression_with_unary_operator,
    STATE(1074), 1,
      sym_unary_expression,
    ACTIONS(985), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1021), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1979), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(850), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1073), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1985), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1983), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(922), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [19669] = 26,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(501), 1,
      sym_real_literal,
    ACTIONS(503), 1,
      anon_sym_LBRACK,
    ACTIONS(509), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(511), 1,
      anon_sym_DASH_DASH,
    STATE(78), 1,
      sym_type_literal,
    STATE(137), 1,
      sym_expression_with_unary_operator,
    STATE(139), 1,
      sym_unary_expression,
    STATE(143), 1,
      sym_invokation_foreach_expression,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(507), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(138), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(505), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(288), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [19778] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym_decimal_integer_literal,
    ACTIONS(1039), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1043), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1045), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1049), 1,
      anon_sym_LBRACK,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1073), 1,
      sym_real_literal,
    ACTIONS(1079), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1081), 1,
      anon_sym_DASH_DASH,
    STATE(158), 1,
      sym_unary_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(220), 1,
      sym_type_literal,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    ACTIONS(1047), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1055), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1077), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1053), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1075), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1029), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [19887] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym_decimal_integer_literal,
    ACTIONS(1039), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1043), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1045), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1049), 1,
      anon_sym_LBRACK,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1073), 1,
      sym_real_literal,
    ACTIONS(1079), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1081), 1,
      anon_sym_DASH_DASH,
    STATE(159), 1,
      sym_unary_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(220), 1,
      sym_type_literal,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    ACTIONS(1047), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1055), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1077), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1053), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1075), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1029), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [19996] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(883), 1,
      sym_decimal_integer_literal,
    ACTIONS(1903), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1907), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1909), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1913), 1,
      anon_sym_LBRACK,
    ACTIONS(1919), 1,
      anon_sym_LPAREN,
    ACTIONS(1921), 1,
      anon_sym_LBRACE,
    ACTIONS(1927), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1929), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1931), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2001), 1,
      sym_real_literal,
    ACTIONS(2005), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2007), 1,
      anon_sym_DASH_DASH,
    STATE(198), 1,
      sym_type_literal,
    STATE(801), 1,
      sym_invokation_foreach_expression,
    STATE(1032), 1,
      sym_unary_expression,
    STATE(1041), 1,
      sym_expression_with_unary_operator,
    ACTIONS(895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(897), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1911), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(796), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1035), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1917), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2003), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(906), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [20105] = 26,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(93), 1,
      anon_sym_LBRACK,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(165), 1,
      sym_real_literal,
    ACTIONS(171), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(173), 1,
      anon_sym_DASH_DASH,
    STATE(6), 1,
      sym_type_literal,
    STATE(137), 1,
      sym_expression_with_unary_operator,
    STATE(139), 1,
      sym_unary_expression,
    STATE(143), 1,
      sym_invokation_foreach_expression,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(169), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(138), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(167), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(145), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [20214] = 26,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(93), 1,
      anon_sym_LBRACK,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(165), 1,
      sym_real_literal,
    ACTIONS(171), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(173), 1,
      anon_sym_DASH_DASH,
    STATE(6), 1,
      sym_type_literal,
    STATE(137), 1,
      sym_expression_with_unary_operator,
    STATE(140), 1,
      sym_unary_expression,
    STATE(143), 1,
      sym_invokation_foreach_expression,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(169), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(138), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(167), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(145), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [20323] = 26,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(93), 1,
      anon_sym_LBRACK,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(165), 1,
      sym_real_literal,
    ACTIONS(171), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(173), 1,
      anon_sym_DASH_DASH,
    STATE(6), 1,
      sym_type_literal,
    STATE(137), 1,
      sym_expression_with_unary_operator,
    STATE(141), 1,
      sym_unary_expression,
    STATE(143), 1,
      sym_invokation_foreach_expression,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(169), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(138), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(167), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(145), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [20432] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym_decimal_integer_literal,
    ACTIONS(1039), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1043), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1045), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1049), 1,
      anon_sym_LBRACK,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1073), 1,
      sym_real_literal,
    ACTIONS(1079), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1081), 1,
      anon_sym_DASH_DASH,
    STATE(157), 1,
      sym_unary_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(220), 1,
      sym_type_literal,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    ACTIONS(1047), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1055), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1077), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1053), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1075), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1029), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [20541] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym_decimal_integer_literal,
    ACTIONS(1039), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1043), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1045), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1049), 1,
      anon_sym_LBRACK,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1073), 1,
      sym_real_literal,
    ACTIONS(1079), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1081), 1,
      anon_sym_DASH_DASH,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(164), 1,
      sym_unary_expression,
    STATE(220), 1,
      sym_type_literal,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    ACTIONS(1047), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1055), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1077), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1053), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1075), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1029), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [20650] = 26,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(503), 1,
      anon_sym_LBRACK,
    ACTIONS(547), 1,
      sym_real_literal,
    ACTIONS(553), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(555), 1,
      anon_sym_DASH_DASH,
    STATE(81), 1,
      sym_type_literal,
    STATE(143), 1,
      sym_invokation_foreach_expression,
    STATE(169), 1,
      sym_unary_expression,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(549), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(290), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [20759] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1083), 1,
      sym_decimal_integer_literal,
    ACTIONS(1085), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1089), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1091), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1103), 1,
      anon_sym_LPAREN,
    ACTIONS(1105), 1,
      anon_sym_LBRACE,
    ACTIONS(1113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1119), 1,
      sym_real_literal,
    ACTIONS(1125), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1127), 1,
      anon_sym_DASH_DASH,
    STATE(167), 1,
      sym_unary_expression,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    STATE(222), 1,
      sym_type_literal,
    STATE(1022), 1,
      sym_invokation_foreach_expression,
    ACTIONS(1093), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1101), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1123), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1005), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1099), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1121), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1048), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [20868] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1083), 1,
      sym_decimal_integer_literal,
    ACTIONS(1085), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1089), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1091), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1103), 1,
      anon_sym_LPAREN,
    ACTIONS(1105), 1,
      anon_sym_LBRACE,
    ACTIONS(1113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1119), 1,
      sym_real_literal,
    ACTIONS(1125), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1127), 1,
      anon_sym_DASH_DASH,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    STATE(174), 1,
      sym_unary_expression,
    STATE(222), 1,
      sym_type_literal,
    STATE(1022), 1,
      sym_invokation_foreach_expression,
    ACTIONS(1093), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1101), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1123), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1005), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1099), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1121), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1048), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [20977] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1083), 1,
      sym_decimal_integer_literal,
    ACTIONS(1085), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1089), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1091), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1103), 1,
      anon_sym_LPAREN,
    ACTIONS(1105), 1,
      anon_sym_LBRACE,
    ACTIONS(1113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1119), 1,
      sym_real_literal,
    ACTIONS(1125), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1127), 1,
      anon_sym_DASH_DASH,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    STATE(176), 1,
      sym_unary_expression,
    STATE(222), 1,
      sym_type_literal,
    STATE(1022), 1,
      sym_invokation_foreach_expression,
    ACTIONS(1093), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1101), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1123), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1005), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1099), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1121), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1048), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [21086] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(479), 1,
      sym_real_literal,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(487), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(489), 1,
      anon_sym_DASH_DASH,
    STATE(76), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(375), 1,
      sym_unary_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(483), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(289), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [21195] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1083), 1,
      sym_decimal_integer_literal,
    ACTIONS(1085), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1089), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1091), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1103), 1,
      anon_sym_LPAREN,
    ACTIONS(1105), 1,
      anon_sym_LBRACE,
    ACTIONS(1113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1827), 1,
      sym_real_literal,
    ACTIONS(1829), 1,
      anon_sym_LBRACK,
    ACTIONS(1835), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1837), 1,
      anon_sym_DASH_DASH,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    STATE(176), 1,
      sym_unary_expression,
    STATE(549), 1,
      sym_type_literal,
    STATE(1022), 1,
      sym_invokation_foreach_expression,
    ACTIONS(1093), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1101), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1005), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1099), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1831), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1296), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [21304] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1083), 1,
      sym_decimal_integer_literal,
    ACTIONS(1085), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1089), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1091), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1103), 1,
      anon_sym_LPAREN,
    ACTIONS(1105), 1,
      anon_sym_LBRACE,
    ACTIONS(1113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1827), 1,
      sym_real_literal,
    ACTIONS(1829), 1,
      anon_sym_LBRACK,
    ACTIONS(1835), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1837), 1,
      anon_sym_DASH_DASH,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    STATE(174), 1,
      sym_unary_expression,
    STATE(549), 1,
      sym_type_literal,
    STATE(1022), 1,
      sym_invokation_foreach_expression,
    ACTIONS(1093), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1101), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1005), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1099), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1831), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1296), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [21413] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(941), 1,
      sym_decimal_integer_literal,
    ACTIONS(1873), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1877), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1879), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1883), 1,
      anon_sym_LBRACK,
    ACTIONS(1889), 1,
      anon_sym_LPAREN,
    ACTIONS(1891), 1,
      anon_sym_LBRACE,
    ACTIONS(1897), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1899), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1901), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1963), 1,
      sym_real_literal,
    ACTIONS(2011), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2013), 1,
      anon_sym_DASH_DASH,
    STATE(214), 1,
      sym_type_literal,
    STATE(840), 1,
      sym_invokation_foreach_expression,
    STATE(876), 1,
      sym_unary_expression,
    STATE(881), 1,
      sym_expression_with_unary_operator,
    ACTIONS(955), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1027), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1881), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(846), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(878), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1887), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2009), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(892), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [21522] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1083), 1,
      sym_decimal_integer_literal,
    ACTIONS(1085), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1089), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1091), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1103), 1,
      anon_sym_LPAREN,
    ACTIONS(1105), 1,
      anon_sym_LBRACE,
    ACTIONS(1113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1119), 1,
      sym_real_literal,
    ACTIONS(1125), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1127), 1,
      anon_sym_DASH_DASH,
    STATE(169), 1,
      sym_unary_expression,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    STATE(222), 1,
      sym_type_literal,
    STATE(1022), 1,
      sym_invokation_foreach_expression,
    ACTIONS(1093), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1101), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1123), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1005), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1099), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1121), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1048), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [21631] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(155), 1,
      sym_real_literal,
    ACTIONS(161), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(163), 1,
      anon_sym_DASH_DASH,
    STATE(4), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(117), 1,
      sym_expression_with_unary_operator,
    STATE(121), 1,
      sym_unary_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(118), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(157), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(135), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [21740] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(479), 1,
      sym_real_literal,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(487), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(489), 1,
      anon_sym_DASH_DASH,
    STATE(76), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(159), 1,
      sym_unary_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(483), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(289), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [21849] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(479), 1,
      sym_real_literal,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(487), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(489), 1,
      anon_sym_DASH_DASH,
    STATE(76), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(158), 1,
      sym_unary_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(483), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(289), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [21958] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(155), 1,
      sym_real_literal,
    ACTIONS(161), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(163), 1,
      anon_sym_DASH_DASH,
    STATE(4), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(117), 1,
      sym_expression_with_unary_operator,
    STATE(119), 1,
      sym_unary_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(118), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(157), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(135), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [22067] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(123), 1,
      sym_real_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(147), 1,
      anon_sym_DASH_DASH,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    STATE(3), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(159), 1,
      sym_unary_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(143), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(133), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(155), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [22176] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1083), 1,
      sym_decimal_integer_literal,
    ACTIONS(1085), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1087), 1,
      sym_real_literal,
    ACTIONS(1089), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1091), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1103), 1,
      anon_sym_LPAREN,
    ACTIONS(1105), 1,
      anon_sym_LBRACE,
    ACTIONS(1109), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1111), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1117), 1,
      anon_sym_AT_LBRACE,
    STATE(221), 1,
      sym_type_literal,
    STATE(1017), 1,
      sym_expression_with_unary_operator,
    STATE(1022), 1,
      sym_invokation_foreach_expression,
    STATE(1026), 1,
      sym_unary_expression,
    ACTIONS(1093), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1101), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1005), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1025), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1099), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1097), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1016), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [22285] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(883), 1,
      sym_decimal_integer_literal,
    ACTIONS(1903), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1905), 1,
      sym_real_literal,
    ACTIONS(1907), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1909), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1913), 1,
      anon_sym_LBRACK,
    ACTIONS(1919), 1,
      anon_sym_LPAREN,
    ACTIONS(1921), 1,
      anon_sym_LBRACE,
    ACTIONS(1923), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1925), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1927), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1929), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1931), 1,
      anon_sym_AT_LBRACE,
    STATE(202), 1,
      sym_type_literal,
    STATE(801), 1,
      sym_invokation_foreach_expression,
    STATE(1041), 1,
      sym_expression_with_unary_operator,
    STATE(1044), 1,
      sym_unary_expression,
    ACTIONS(897), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(931), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1911), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(796), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1035), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1917), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1915), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(800), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [22394] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_decimal_integer_literal,
    ACTIONS(1971), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1975), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1977), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1981), 1,
      anon_sym_LBRACK,
    ACTIONS(1987), 1,
      anon_sym_LPAREN,
    ACTIONS(1989), 1,
      anon_sym_LBRACE,
    ACTIONS(1995), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1997), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1999), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2015), 1,
      sym_real_literal,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2021), 1,
      anon_sym_DASH_DASH,
    STATE(208), 1,
      sym_type_literal,
    STATE(861), 1,
      sym_invokation_foreach_expression,
    STATE(1068), 1,
      sym_expression_with_unary_operator,
    STATE(1074), 1,
      sym_unary_expression,
    ACTIONS(985), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1001), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1979), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(850), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1073), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1985), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2017), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(858), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [22503] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(479), 1,
      sym_real_literal,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(487), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(489), 1,
      anon_sym_DASH_DASH,
    STATE(76), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(164), 1,
      sym_unary_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(483), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(289), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [22612] = 26,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(503), 1,
      anon_sym_LBRACK,
    ACTIONS(547), 1,
      sym_real_literal,
    ACTIONS(553), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(555), 1,
      anon_sym_DASH_DASH,
    STATE(81), 1,
      sym_type_literal,
    STATE(143), 1,
      sym_invokation_foreach_expression,
    STATE(167), 1,
      sym_unary_expression,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(549), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(290), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [22721] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(123), 1,
      sym_real_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(147), 1,
      anon_sym_DASH_DASH,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    STATE(3), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(157), 1,
      sym_unary_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(143), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(133), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(155), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [22830] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(123), 1,
      sym_real_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(147), 1,
      anon_sym_DASH_DASH,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    STATE(3), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(158), 1,
      sym_unary_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(143), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(133), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(155), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [22939] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym_decimal_integer_literal,
    ACTIONS(1039), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1041), 1,
      sym_real_literal,
    ACTIONS(1043), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1045), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1049), 1,
      anon_sym_LBRACK,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    ACTIONS(1063), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1065), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_AT_LBRACE,
    STATE(219), 1,
      sym_type_literal,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    STATE(952), 1,
      sym_expression_with_unary_operator,
    STATE(961), 1,
      sym_unary_expression,
    ACTIONS(1047), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1055), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1061), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(933), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1053), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1051), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(987), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [23048] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(123), 1,
      sym_real_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(147), 1,
      anon_sym_DASH_DASH,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    STATE(3), 1,
      sym_type_literal,
    STATE(88), 1,
      sym_invokation_foreach_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(164), 1,
      sym_unary_expression,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(143), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(133), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(155), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [23157] = 26,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(503), 1,
      anon_sym_LBRACK,
    ACTIONS(547), 1,
      sym_real_literal,
    ACTIONS(553), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(555), 1,
      anon_sym_DASH_DASH,
    STATE(81), 1,
      sym_type_literal,
    STATE(143), 1,
      sym_invokation_foreach_expression,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    STATE(174), 1,
      sym_unary_expression,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(549), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(290), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [23266] = 26,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(503), 1,
      anon_sym_LBRACK,
    ACTIONS(547), 1,
      sym_real_literal,
    ACTIONS(553), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(555), 1,
      anon_sym_DASH_DASH,
    STATE(81), 1,
      sym_type_literal,
    STATE(143), 1,
      sym_invokation_foreach_expression,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    STATE(176), 1,
      sym_unary_expression,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(549), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(290), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [23375] = 26,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(85), 1,
      sym_real_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(93), 1,
      anon_sym_LBRACK,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(109), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(111), 1,
      anon_sym_DASH_DASH,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    STATE(5), 1,
      sym_type_literal,
    STATE(143), 1,
      sym_invokation_foreach_expression,
    STATE(169), 1,
      sym_unary_expression,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(99), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(156), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [23484] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_decimal_integer_literal,
    ACTIONS(1971), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1975), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1977), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1981), 1,
      anon_sym_LBRACK,
    ACTIONS(1987), 1,
      anon_sym_LPAREN,
    ACTIONS(1989), 1,
      anon_sym_LBRACE,
    ACTIONS(1995), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1997), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1999), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2015), 1,
      sym_real_literal,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2021), 1,
      anon_sym_DASH_DASH,
    STATE(208), 1,
      sym_type_literal,
    STATE(861), 1,
      sym_invokation_foreach_expression,
    STATE(1068), 1,
      sym_expression_with_unary_operator,
    STATE(1071), 1,
      sym_unary_expression,
    ACTIONS(985), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1001), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1979), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(850), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1073), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1985), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2017), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(858), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [23593] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym_decimal_integer_literal,
    ACTIONS(1039), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1041), 1,
      sym_real_literal,
    ACTIONS(1043), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1045), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1049), 1,
      anon_sym_LBRACK,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    ACTIONS(1063), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1065), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_AT_LBRACE,
    STATE(219), 1,
      sym_type_literal,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    STATE(952), 1,
      sym_expression_with_unary_operator,
    STATE(960), 1,
      sym_unary_expression,
    ACTIONS(1047), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1055), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1061), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(933), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1053), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1051), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(987), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [23702] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1083), 1,
      sym_decimal_integer_literal,
    ACTIONS(1085), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1089), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1091), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1103), 1,
      anon_sym_LPAREN,
    ACTIONS(1105), 1,
      anon_sym_LBRACE,
    ACTIONS(1113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1829), 1,
      anon_sym_LBRACK,
    ACTIONS(1845), 1,
      sym_real_literal,
    ACTIONS(1851), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1853), 1,
      anon_sym_DASH_DASH,
    STATE(556), 1,
      sym_type_literal,
    STATE(999), 1,
      sym_unary_expression,
    STATE(1017), 1,
      sym_expression_with_unary_operator,
    STATE(1022), 1,
      sym_invokation_foreach_expression,
    ACTIONS(1093), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1101), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1005), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1025), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1099), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1847), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1281), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [23811] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(837), 1,
      sym_decimal_integer_literal,
    ACTIONS(1933), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1937), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1939), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1943), 1,
      anon_sym_LBRACK,
    ACTIONS(1949), 1,
      anon_sym_LPAREN,
    ACTIONS(1951), 1,
      anon_sym_LBRACE,
    ACTIONS(1957), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1959), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1961), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2023), 1,
      sym_real_literal,
    ACTIONS(2027), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2029), 1,
      anon_sym_DASH_DASH,
    STATE(197), 1,
      sym_type_literal,
    STATE(767), 1,
      sym_invokation_foreach_expression,
    STATE(1038), 1,
      sym_unary_expression,
    STATE(1049), 1,
      sym_expression_with_unary_operator,
    ACTIONS(851), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1941), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(771), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1047), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1947), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2025), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(913), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [23920] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(837), 1,
      sym_decimal_integer_literal,
    ACTIONS(1933), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1937), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1939), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1943), 1,
      anon_sym_LBRACK,
    ACTIONS(1949), 1,
      anon_sym_LPAREN,
    ACTIONS(1951), 1,
      anon_sym_LBRACE,
    ACTIONS(1957), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1959), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1961), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2023), 1,
      sym_real_literal,
    ACTIONS(2027), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2029), 1,
      anon_sym_DASH_DASH,
    STATE(197), 1,
      sym_type_literal,
    STATE(767), 1,
      sym_invokation_foreach_expression,
    STATE(1036), 1,
      sym_unary_expression,
    STATE(1049), 1,
      sym_expression_with_unary_operator,
    ACTIONS(851), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1941), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(771), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1047), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1947), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2025), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(913), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [24029] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_decimal_integer_literal,
    ACTIONS(1971), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1975), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1977), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1981), 1,
      anon_sym_LBRACK,
    ACTIONS(1987), 1,
      anon_sym_LPAREN,
    ACTIONS(1989), 1,
      anon_sym_LBRACE,
    ACTIONS(1995), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1997), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1999), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2015), 1,
      sym_real_literal,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2021), 1,
      anon_sym_DASH_DASH,
    STATE(208), 1,
      sym_type_literal,
    STATE(861), 1,
      sym_invokation_foreach_expression,
    STATE(1068), 1,
      sym_expression_with_unary_operator,
    STATE(1069), 1,
      sym_unary_expression,
    ACTIONS(985), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1001), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1979), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(850), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1073), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1985), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2017), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(858), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [24138] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1083), 1,
      sym_decimal_integer_literal,
    ACTIONS(1085), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1089), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1091), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1103), 1,
      anon_sym_LPAREN,
    ACTIONS(1105), 1,
      anon_sym_LBRACE,
    ACTIONS(1113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1829), 1,
      anon_sym_LBRACK,
    ACTIONS(1845), 1,
      sym_real_literal,
    ACTIONS(1851), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1853), 1,
      anon_sym_DASH_DASH,
    STATE(556), 1,
      sym_type_literal,
    STATE(1000), 1,
      sym_unary_expression,
    STATE(1017), 1,
      sym_expression_with_unary_operator,
    STATE(1022), 1,
      sym_invokation_foreach_expression,
    ACTIONS(1093), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1101), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1005), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1025), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1099), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1847), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1281), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [24247] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1083), 1,
      sym_decimal_integer_literal,
    ACTIONS(1085), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1089), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1091), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1103), 1,
      anon_sym_LPAREN,
    ACTIONS(1105), 1,
      anon_sym_LBRACE,
    ACTIONS(1113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1829), 1,
      anon_sym_LBRACK,
    ACTIONS(1845), 1,
      sym_real_literal,
    ACTIONS(1851), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1853), 1,
      anon_sym_DASH_DASH,
    STATE(556), 1,
      sym_type_literal,
    STATE(1017), 1,
      sym_expression_with_unary_operator,
    STATE(1022), 1,
      sym_invokation_foreach_expression,
    STATE(1026), 1,
      sym_unary_expression,
    ACTIONS(1093), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1101), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1005), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1025), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1099), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1847), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1281), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [24356] = 26,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(85), 1,
      sym_real_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(93), 1,
      anon_sym_LBRACK,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(109), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(111), 1,
      anon_sym_DASH_DASH,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    STATE(5), 1,
      sym_type_literal,
    STATE(143), 1,
      sym_invokation_foreach_expression,
    STATE(167), 1,
      sym_unary_expression,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(99), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(156), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [24465] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(883), 1,
      sym_decimal_integer_literal,
    ACTIONS(1903), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1905), 1,
      sym_real_literal,
    ACTIONS(1907), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1909), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1913), 1,
      anon_sym_LBRACK,
    ACTIONS(1919), 1,
      anon_sym_LPAREN,
    ACTIONS(1921), 1,
      anon_sym_LBRACE,
    ACTIONS(1923), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1925), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1927), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1929), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1931), 1,
      anon_sym_AT_LBRACE,
    STATE(202), 1,
      sym_type_literal,
    STATE(801), 1,
      sym_invokation_foreach_expression,
    STATE(1032), 1,
      sym_unary_expression,
    STATE(1041), 1,
      sym_expression_with_unary_operator,
    ACTIONS(897), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(931), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1911), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(796), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1035), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1917), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1915), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(800), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [24574] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(941), 1,
      sym_decimal_integer_literal,
    ACTIONS(1873), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1877), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1879), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1883), 1,
      anon_sym_LBRACK,
    ACTIONS(1889), 1,
      anon_sym_LPAREN,
    ACTIONS(1891), 1,
      anon_sym_LBRACE,
    ACTIONS(1897), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1899), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1901), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1963), 1,
      sym_real_literal,
    ACTIONS(2011), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2013), 1,
      anon_sym_DASH_DASH,
    STATE(214), 1,
      sym_type_literal,
    STATE(840), 1,
      sym_invokation_foreach_expression,
    STATE(875), 1,
      sym_unary_expression,
    STATE(881), 1,
      sym_expression_with_unary_operator,
    ACTIONS(955), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1027), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1881), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(846), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(878), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1887), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2009), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(892), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [24683] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym_decimal_integer_literal,
    ACTIONS(1039), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1043), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1045), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1532), 1,
      anon_sym_LBRACK,
    ACTIONS(1813), 1,
      sym_real_literal,
    ACTIONS(1819), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1821), 1,
      anon_sym_DASH_DASH,
    STATE(541), 1,
      sym_type_literal,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    STATE(952), 1,
      sym_expression_with_unary_operator,
    STATE(961), 1,
      sym_unary_expression,
    ACTIONS(1047), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1055), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(933), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1053), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1815), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1267), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [24792] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym_decimal_integer_literal,
    ACTIONS(1039), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1043), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1045), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1532), 1,
      anon_sym_LBRACK,
    ACTIONS(1813), 1,
      sym_real_literal,
    ACTIONS(1819), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1821), 1,
      anon_sym_DASH_DASH,
    STATE(541), 1,
      sym_type_literal,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    STATE(952), 1,
      sym_expression_with_unary_operator,
    STATE(960), 1,
      sym_unary_expression,
    ACTIONS(1047), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1055), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(933), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1053), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1815), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1267), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [24901] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym_decimal_integer_literal,
    ACTIONS(1039), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1043), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1045), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1532), 1,
      anon_sym_LBRACK,
    ACTIONS(1813), 1,
      sym_real_literal,
    ACTIONS(1819), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1821), 1,
      anon_sym_DASH_DASH,
    STATE(541), 1,
      sym_type_literal,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    STATE(952), 1,
      sym_expression_with_unary_operator,
    STATE(957), 1,
      sym_unary_expression,
    ACTIONS(1047), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1055), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(933), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1053), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1815), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1267), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [25010] = 26,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(85), 1,
      sym_real_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(93), 1,
      anon_sym_LBRACK,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(109), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(111), 1,
      anon_sym_DASH_DASH,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    STATE(5), 1,
      sym_type_literal,
    STATE(143), 1,
      sym_invokation_foreach_expression,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    STATE(176), 1,
      sym_unary_expression,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(99), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(156), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [25119] = 26,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(85), 1,
      sym_real_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(93), 1,
      anon_sym_LBRACK,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(109), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(111), 1,
      anon_sym_DASH_DASH,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    STATE(5), 1,
      sym_type_literal,
    STATE(143), 1,
      sym_invokation_foreach_expression,
    STATE(172), 1,
      sym_expression_with_unary_operator,
    STATE(174), 1,
      sym_unary_expression,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(171), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(99), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(156), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [25228] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(837), 1,
      sym_decimal_integer_literal,
    ACTIONS(1933), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1937), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1939), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1943), 1,
      anon_sym_LBRACK,
    ACTIONS(1949), 1,
      anon_sym_LPAREN,
    ACTIONS(1951), 1,
      anon_sym_LBRACE,
    ACTIONS(1957), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1959), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1961), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2023), 1,
      sym_real_literal,
    ACTIONS(2027), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2029), 1,
      anon_sym_DASH_DASH,
    STATE(197), 1,
      sym_type_literal,
    STATE(767), 1,
      sym_invokation_foreach_expression,
    STATE(1045), 1,
      sym_unary_expression,
    STATE(1049), 1,
      sym_expression_with_unary_operator,
    ACTIONS(851), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1941), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(771), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1047), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1947), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2025), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(913), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [25337] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(837), 1,
      sym_decimal_integer_literal,
    ACTIONS(1933), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1937), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1939), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1943), 1,
      anon_sym_LBRACK,
    ACTIONS(1949), 1,
      anon_sym_LPAREN,
    ACTIONS(1951), 1,
      anon_sym_LBRACE,
    ACTIONS(1957), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1959), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1961), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2023), 1,
      sym_real_literal,
    ACTIONS(2027), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2029), 1,
      anon_sym_DASH_DASH,
    STATE(197), 1,
      sym_type_literal,
    STATE(767), 1,
      sym_invokation_foreach_expression,
    STATE(1046), 1,
      sym_unary_expression,
    STATE(1049), 1,
      sym_expression_with_unary_operator,
    ACTIONS(851), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1941), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(771), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1047), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1947), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2025), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(913), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [25446] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(837), 1,
      sym_decimal_integer_literal,
    ACTIONS(1933), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1935), 1,
      sym_real_literal,
    ACTIONS(1937), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1939), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1943), 1,
      anon_sym_LBRACK,
    ACTIONS(1949), 1,
      anon_sym_LPAREN,
    ACTIONS(1951), 1,
      anon_sym_LBRACE,
    ACTIONS(1957), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1959), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1961), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2035), 1,
      anon_sym_DASH_DASH,
    STATE(195), 1,
      sym_type_literal,
    STATE(767), 1,
      sym_invokation_foreach_expression,
    STATE(781), 1,
      sym_unary_expression,
    STATE(789), 1,
      sym_expression_with_unary_operator,
    ACTIONS(849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(851), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1941), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(771), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(780), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1947), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2031), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(768), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [25555] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(883), 1,
      sym_decimal_integer_literal,
    ACTIONS(1903), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1907), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1909), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1913), 1,
      anon_sym_LBRACK,
    ACTIONS(1919), 1,
      anon_sym_LPAREN,
    ACTIONS(1921), 1,
      anon_sym_LBRACE,
    ACTIONS(1927), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1929), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1931), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2001), 1,
      sym_real_literal,
    ACTIONS(2005), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2007), 1,
      anon_sym_DASH_DASH,
    STATE(198), 1,
      sym_type_literal,
    STATE(801), 1,
      sym_invokation_foreach_expression,
    STATE(1040), 1,
      sym_unary_expression,
    STATE(1041), 1,
      sym_expression_with_unary_operator,
    ACTIONS(895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(897), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1911), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(796), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1035), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1917), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2003), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(906), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [25664] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(883), 1,
      sym_decimal_integer_literal,
    ACTIONS(1903), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1907), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1909), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1913), 1,
      anon_sym_LBRACK,
    ACTIONS(1919), 1,
      anon_sym_LPAREN,
    ACTIONS(1921), 1,
      anon_sym_LBRACE,
    ACTIONS(1927), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1929), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1931), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2001), 1,
      sym_real_literal,
    ACTIONS(2005), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2007), 1,
      anon_sym_DASH_DASH,
    STATE(198), 1,
      sym_type_literal,
    STATE(801), 1,
      sym_invokation_foreach_expression,
    STATE(1041), 1,
      sym_expression_with_unary_operator,
    STATE(1043), 1,
      sym_unary_expression,
    ACTIONS(895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(897), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1911), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(796), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1035), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1917), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2003), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(906), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [25773] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(883), 1,
      sym_decimal_integer_literal,
    ACTIONS(1903), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1907), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1909), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1913), 1,
      anon_sym_LBRACK,
    ACTIONS(1919), 1,
      anon_sym_LPAREN,
    ACTIONS(1921), 1,
      anon_sym_LBRACE,
    ACTIONS(1927), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1929), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1931), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2001), 1,
      sym_real_literal,
    ACTIONS(2005), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2007), 1,
      anon_sym_DASH_DASH,
    STATE(198), 1,
      sym_type_literal,
    STATE(801), 1,
      sym_invokation_foreach_expression,
    STATE(1041), 1,
      sym_expression_with_unary_operator,
    STATE(1044), 1,
      sym_unary_expression,
    ACTIONS(895), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(897), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1911), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(796), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1035), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1917), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2003), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(906), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [25882] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_decimal_integer_literal,
    ACTIONS(1971), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1973), 1,
      sym_real_literal,
    ACTIONS(1975), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1977), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1981), 1,
      anon_sym_LBRACK,
    ACTIONS(1987), 1,
      anon_sym_LPAREN,
    ACTIONS(1989), 1,
      anon_sym_LBRACE,
    ACTIONS(1991), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1993), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1995), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1997), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1999), 1,
      anon_sym_AT_LBRACE,
    STATE(212), 1,
      sym_type_literal,
    STATE(861), 1,
      sym_invokation_foreach_expression,
    STATE(1068), 1,
      sym_expression_with_unary_operator,
    STATE(1071), 1,
      sym_unary_expression,
    ACTIONS(985), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1021), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1979), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(850), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1073), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1985), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1983), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(922), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [25991] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym_decimal_integer_literal,
    ACTIONS(1039), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1043), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1045), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1528), 1,
      sym_real_literal,
    ACTIONS(1532), 1,
      anon_sym_LBRACK,
    ACTIONS(1540), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1542), 1,
      anon_sym_DASH_DASH,
    STATE(158), 1,
      sym_unary_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(543), 1,
      sym_type_literal,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    ACTIONS(1047), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1055), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1538), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1053), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1534), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1295), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [26100] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym_decimal_integer_literal,
    ACTIONS(1039), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1043), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1045), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1528), 1,
      sym_real_literal,
    ACTIONS(1532), 1,
      anon_sym_LBRACK,
    ACTIONS(1540), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1542), 1,
      anon_sym_DASH_DASH,
    STATE(159), 1,
      sym_unary_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(543), 1,
      sym_type_literal,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    ACTIONS(1047), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1055), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1538), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1053), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1534), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1295), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [26209] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_decimal_integer_literal,
    ACTIONS(1971), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1973), 1,
      sym_real_literal,
    ACTIONS(1975), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1977), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1981), 1,
      anon_sym_LBRACK,
    ACTIONS(1987), 1,
      anon_sym_LPAREN,
    ACTIONS(1989), 1,
      anon_sym_LBRACE,
    ACTIONS(1991), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1993), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1995), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1997), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1999), 1,
      anon_sym_AT_LBRACE,
    STATE(212), 1,
      sym_type_literal,
    STATE(861), 1,
      sym_invokation_foreach_expression,
    STATE(1068), 1,
      sym_expression_with_unary_operator,
    STATE(1069), 1,
      sym_unary_expression,
    ACTIONS(985), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1021), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1979), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(850), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1073), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1985), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1983), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(922), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [26318] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym_decimal_integer_literal,
    ACTIONS(1039), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1043), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1045), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1528), 1,
      sym_real_literal,
    ACTIONS(1532), 1,
      anon_sym_LBRACK,
    ACTIONS(1540), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1542), 1,
      anon_sym_DASH_DASH,
    STATE(157), 1,
      sym_unary_expression,
    STATE(161), 1,
      sym_expression_with_unary_operator,
    STATE(543), 1,
      sym_type_literal,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    ACTIONS(1047), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1055), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1538), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(160), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1053), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1534), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(1295), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [26427] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_decimal_integer_literal,
    ACTIONS(1971), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1973), 1,
      sym_real_literal,
    ACTIONS(1975), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1977), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1981), 1,
      anon_sym_LBRACK,
    ACTIONS(1987), 1,
      anon_sym_LPAREN,
    ACTIONS(1989), 1,
      anon_sym_LBRACE,
    ACTIONS(1991), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1993), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1995), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1997), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1999), 1,
      anon_sym_AT_LBRACE,
    STATE(212), 1,
      sym_type_literal,
    STATE(861), 1,
      sym_invokation_foreach_expression,
    STATE(1067), 1,
      sym_unary_expression,
    STATE(1068), 1,
      sym_expression_with_unary_operator,
    ACTIONS(985), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1021), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1979), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(850), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1073), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1985), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1983), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(922), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [26536] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(941), 1,
      sym_decimal_integer_literal,
    ACTIONS(1873), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1875), 1,
      sym_real_literal,
    ACTIONS(1877), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1879), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1883), 1,
      anon_sym_LBRACK,
    ACTIONS(1889), 1,
      anon_sym_LPAREN,
    ACTIONS(1891), 1,
      anon_sym_LBRACE,
    ACTIONS(1893), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1895), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1897), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1899), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1901), 1,
      anon_sym_AT_LBRACE,
    STATE(209), 1,
      sym_type_literal,
    STATE(840), 1,
      sym_invokation_foreach_expression,
    STATE(1052), 1,
      sym_unary_expression,
    STATE(1076), 1,
      sym_expression_with_unary_operator,
    ACTIONS(955), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1881), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(846), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1059), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1887), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1885), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(924), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [26645] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(837), 1,
      sym_decimal_integer_literal,
    ACTIONS(1933), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1935), 1,
      sym_real_literal,
    ACTIONS(1937), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1939), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1943), 1,
      anon_sym_LBRACK,
    ACTIONS(1949), 1,
      anon_sym_LPAREN,
    ACTIONS(1951), 1,
      anon_sym_LBRACE,
    ACTIONS(1957), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1959), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1961), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2035), 1,
      anon_sym_DASH_DASH,
    STATE(195), 1,
      sym_type_literal,
    STATE(767), 1,
      sym_invokation_foreach_expression,
    STATE(782), 1,
      sym_unary_expression,
    STATE(789), 1,
      sym_expression_with_unary_operator,
    ACTIONS(849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(851), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1941), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(771), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(780), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1947), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2031), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(768), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [26754] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(837), 1,
      sym_decimal_integer_literal,
    ACTIONS(1933), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1935), 1,
      sym_real_literal,
    ACTIONS(1937), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1939), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1943), 1,
      anon_sym_LBRACK,
    ACTIONS(1949), 1,
      anon_sym_LPAREN,
    ACTIONS(1951), 1,
      anon_sym_LBRACE,
    ACTIONS(1957), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1959), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1961), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2035), 1,
      anon_sym_DASH_DASH,
    STATE(195), 1,
      sym_type_literal,
    STATE(767), 1,
      sym_invokation_foreach_expression,
    STATE(783), 1,
      sym_unary_expression,
    STATE(789), 1,
      sym_expression_with_unary_operator,
    ACTIONS(849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(851), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1941), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(771), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(780), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1947), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2031), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(768), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [26863] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(883), 1,
      sym_decimal_integer_literal,
    ACTIONS(1903), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1905), 1,
      sym_real_literal,
    ACTIONS(1907), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1909), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1913), 1,
      anon_sym_LBRACK,
    ACTIONS(1919), 1,
      anon_sym_LPAREN,
    ACTIONS(1921), 1,
      anon_sym_LBRACE,
    ACTIONS(1927), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1929), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1931), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2039), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2041), 1,
      anon_sym_DASH_DASH,
    STATE(201), 1,
      sym_type_literal,
    STATE(791), 1,
      sym_unary_expression,
    STATE(801), 1,
      sym_invokation_foreach_expression,
    STATE(815), 1,
      sym_expression_with_unary_operator,
    ACTIONS(897), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1911), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(796), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(790), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1917), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2037), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(800), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [26972] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(883), 1,
      sym_decimal_integer_literal,
    ACTIONS(1903), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1905), 1,
      sym_real_literal,
    ACTIONS(1907), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1909), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1913), 1,
      anon_sym_LBRACK,
    ACTIONS(1919), 1,
      anon_sym_LPAREN,
    ACTIONS(1921), 1,
      anon_sym_LBRACE,
    ACTIONS(1927), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1929), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1931), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2039), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2041), 1,
      anon_sym_DASH_DASH,
    STATE(201), 1,
      sym_type_literal,
    STATE(792), 1,
      sym_unary_expression,
    STATE(801), 1,
      sym_invokation_foreach_expression,
    STATE(815), 1,
      sym_expression_with_unary_operator,
    ACTIONS(897), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1911), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(796), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(790), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1917), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2037), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(800), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [27081] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(837), 1,
      sym_decimal_integer_literal,
    ACTIONS(1933), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1935), 1,
      sym_real_literal,
    ACTIONS(1937), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1939), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1943), 1,
      anon_sym_LBRACK,
    ACTIONS(1949), 1,
      anon_sym_LPAREN,
    ACTIONS(1951), 1,
      anon_sym_LBRACE,
    ACTIONS(1953), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1955), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1957), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1959), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1961), 1,
      anon_sym_AT_LBRACE,
    STATE(199), 1,
      sym_type_literal,
    STATE(767), 1,
      sym_invokation_foreach_expression,
    STATE(1038), 1,
      sym_unary_expression,
    STATE(1049), 1,
      sym_expression_with_unary_operator,
    ACTIONS(851), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(913), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1941), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(771), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1047), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1947), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1945), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(768), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [27190] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(883), 1,
      sym_decimal_integer_literal,
    ACTIONS(1903), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1905), 1,
      sym_real_literal,
    ACTIONS(1907), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1909), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1913), 1,
      anon_sym_LBRACK,
    ACTIONS(1919), 1,
      anon_sym_LPAREN,
    ACTIONS(1921), 1,
      anon_sym_LBRACE,
    ACTIONS(1927), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1929), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1931), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2039), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2041), 1,
      anon_sym_DASH_DASH,
    STATE(201), 1,
      sym_type_literal,
    STATE(793), 1,
      sym_unary_expression,
    STATE(801), 1,
      sym_invokation_foreach_expression,
    STATE(815), 1,
      sym_expression_with_unary_operator,
    ACTIONS(897), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1911), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(796), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(790), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1917), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2037), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(800), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [27299] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym_decimal_integer_literal,
    ACTIONS(1039), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1041), 1,
      sym_real_literal,
    ACTIONS(1043), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1045), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1049), 1,
      anon_sym_LBRACK,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    ACTIONS(1063), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1065), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_AT_LBRACE,
    STATE(219), 1,
      sym_type_literal,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    STATE(952), 1,
      sym_expression_with_unary_operator,
    STATE(957), 1,
      sym_unary_expression,
    ACTIONS(1047), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1055), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1061), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(933), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1053), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1051), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(987), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [27408] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(941), 1,
      sym_decimal_integer_literal,
    ACTIONS(1873), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1875), 1,
      sym_real_literal,
    ACTIONS(1877), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1879), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1883), 1,
      anon_sym_LBRACK,
    ACTIONS(1889), 1,
      anon_sym_LPAREN,
    ACTIONS(1891), 1,
      anon_sym_LBRACE,
    ACTIONS(1893), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1895), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1897), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1899), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1901), 1,
      anon_sym_AT_LBRACE,
    STATE(209), 1,
      sym_type_literal,
    STATE(840), 1,
      sym_invokation_foreach_expression,
    STATE(1065), 1,
      sym_unary_expression,
    STATE(1076), 1,
      sym_expression_with_unary_operator,
    ACTIONS(955), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1881), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(846), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1059), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1887), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1885), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(924), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [27517] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(941), 1,
      sym_decimal_integer_literal,
    ACTIONS(1873), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1875), 1,
      sym_real_literal,
    ACTIONS(1877), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1879), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1883), 1,
      anon_sym_LBRACK,
    ACTIONS(1889), 1,
      anon_sym_LPAREN,
    ACTIONS(1891), 1,
      anon_sym_LBRACE,
    ACTIONS(1893), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1895), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1897), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1899), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1901), 1,
      anon_sym_AT_LBRACE,
    STATE(209), 1,
      sym_type_literal,
    STATE(840), 1,
      sym_invokation_foreach_expression,
    STATE(1076), 1,
      sym_expression_with_unary_operator,
    STATE(1077), 1,
      sym_unary_expression,
    ACTIONS(955), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1881), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(846), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1059), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1887), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1885), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(924), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [27626] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_decimal_integer_literal,
    ACTIONS(1971), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1975), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1977), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1981), 1,
      anon_sym_LBRACK,
    ACTIONS(1987), 1,
      anon_sym_LPAREN,
    ACTIONS(1989), 1,
      anon_sym_LBRACE,
    ACTIONS(1995), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1997), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1999), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2015), 1,
      sym_real_literal,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2021), 1,
      anon_sym_DASH_DASH,
    STATE(208), 1,
      sym_type_literal,
    STATE(861), 1,
      sym_invokation_foreach_expression,
    STATE(1067), 1,
      sym_unary_expression,
    STATE(1068), 1,
      sym_expression_with_unary_operator,
    ACTIONS(985), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1001), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1979), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(850), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1073), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1985), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2017), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(858), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [27735] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(941), 1,
      sym_decimal_integer_literal,
    ACTIONS(1873), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1877), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1879), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1883), 1,
      anon_sym_LBRACK,
    ACTIONS(1889), 1,
      anon_sym_LPAREN,
    ACTIONS(1891), 1,
      anon_sym_LBRACE,
    ACTIONS(1897), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1899), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1901), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1963), 1,
      sym_real_literal,
    ACTIONS(1967), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1969), 1,
      anon_sym_DASH_DASH,
    STATE(206), 1,
      sym_type_literal,
    STATE(840), 1,
      sym_invokation_foreach_expression,
    STATE(1051), 1,
      sym_unary_expression,
    STATE(1076), 1,
      sym_expression_with_unary_operator,
    ACTIONS(953), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(955), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1881), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(846), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1059), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1887), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1965), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(892), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [27844] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_decimal_integer_literal,
    ACTIONS(1971), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1975), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1977), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1981), 1,
      anon_sym_LBRACK,
    ACTIONS(1987), 1,
      anon_sym_LPAREN,
    ACTIONS(1989), 1,
      anon_sym_LBRACE,
    ACTIONS(1995), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1997), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1999), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2015), 1,
      sym_real_literal,
    ACTIONS(2045), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2047), 1,
      anon_sym_DASH_DASH,
    STATE(207), 1,
      sym_type_literal,
    STATE(861), 1,
      sym_invokation_foreach_expression,
    STATE(888), 1,
      sym_unary_expression,
    STATE(890), 1,
      sym_expression_with_unary_operator,
    ACTIONS(983), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(985), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1979), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(850), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(889), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1985), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2043), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(858), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [27953] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_decimal_integer_literal,
    ACTIONS(1971), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1975), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1977), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1981), 1,
      anon_sym_LBRACK,
    ACTIONS(1987), 1,
      anon_sym_LPAREN,
    ACTIONS(1989), 1,
      anon_sym_LBRACE,
    ACTIONS(1995), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1997), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1999), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2015), 1,
      sym_real_literal,
    ACTIONS(2045), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2047), 1,
      anon_sym_DASH_DASH,
    STATE(207), 1,
      sym_type_literal,
    STATE(861), 1,
      sym_invokation_foreach_expression,
    STATE(887), 1,
      sym_unary_expression,
    STATE(890), 1,
      sym_expression_with_unary_operator,
    ACTIONS(983), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(985), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1979), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(850), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(889), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1985), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2043), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(858), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [28062] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_decimal_integer_literal,
    ACTIONS(1971), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1975), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1977), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1981), 1,
      anon_sym_LBRACK,
    ACTIONS(1987), 1,
      anon_sym_LPAREN,
    ACTIONS(1989), 1,
      anon_sym_LBRACE,
    ACTIONS(1995), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1997), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1999), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2015), 1,
      sym_real_literal,
    ACTIONS(2045), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2047), 1,
      anon_sym_DASH_DASH,
    STATE(207), 1,
      sym_type_literal,
    STATE(861), 1,
      sym_invokation_foreach_expression,
    STATE(886), 1,
      sym_unary_expression,
    STATE(890), 1,
      sym_expression_with_unary_operator,
    ACTIONS(983), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(985), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1979), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(850), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(889), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1985), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2043), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(858), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [28171] = 26,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(941), 1,
      sym_decimal_integer_literal,
    ACTIONS(1873), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1877), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1879), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1883), 1,
      anon_sym_LBRACK,
    ACTIONS(1889), 1,
      anon_sym_LPAREN,
    ACTIONS(1891), 1,
      anon_sym_LBRACE,
    ACTIONS(1897), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1899), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1901), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1963), 1,
      sym_real_literal,
    ACTIONS(2011), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2013), 1,
      anon_sym_DASH_DASH,
    STATE(214), 1,
      sym_type_literal,
    STATE(840), 1,
      sym_invokation_foreach_expression,
    STATE(877), 1,
      sym_unary_expression,
    STATE(881), 1,
      sym_expression_with_unary_operator,
    ACTIONS(955), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1027), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1881), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(846), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(878), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1887), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2009), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(892), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
  [28280] = 25,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym_decimal_integer_literal,
    ACTIONS(1039), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1043), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1045), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1049), 1,
      anon_sym_LBRACK,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    ACTIONS(1063), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1065), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_AT_LBRACE,
    STATE(219), 1,
      sym_type_literal,
    STATE(918), 1,
      sym_member_name,
    STATE(964), 1,
      sym_string_literal,
    ACTIONS(1047), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1055), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1061), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2049), 2,
      sym_real_literal,
      sym_simple_name,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(933), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1053), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1051), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(963), 10,
      sym__literal,
      sym_integer_literal,
      sym_variable,
      sym_expression_with_unary_operator,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
  [28381] = 25,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(503), 1,
      anon_sym_LBRACK,
    ACTIONS(509), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(511), 1,
      anon_sym_DASH_DASH,
    STATE(78), 1,
      sym_type_literal,
    STATE(100), 1,
      sym_member_name,
    STATE(146), 1,
      sym_string_literal,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(507), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2051), 2,
      sym_real_literal,
      sym_simple_name,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(138), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(505), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(144), 10,
      sym__literal,
      sym_integer_literal,
      sym_variable,
      sym_expression_with_unary_operator,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
  [28482] = 25,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(941), 1,
      sym_decimal_integer_literal,
    ACTIONS(1873), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1877), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1879), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1883), 1,
      anon_sym_LBRACK,
    ACTIONS(1889), 1,
      anon_sym_LPAREN,
    ACTIONS(1891), 1,
      anon_sym_LBRACE,
    ACTIONS(1897), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1899), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1901), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2011), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2013), 1,
      anon_sym_DASH_DASH,
    STATE(214), 1,
      sym_type_literal,
    STATE(808), 1,
      sym_member_name,
    STATE(909), 1,
      sym_string_literal,
    ACTIONS(955), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1027), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1881), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(2053), 2,
      sym_real_literal,
      sym_simple_name,
    STATE(846), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(878), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1887), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2009), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(908), 10,
      sym__literal,
      sym_integer_literal,
      sym_variable,
      sym_expression_with_unary_operator,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
  [28583] = 25,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1083), 1,
      sym_decimal_integer_literal,
    ACTIONS(1085), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1089), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1091), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1103), 1,
      anon_sym_LPAREN,
    ACTIONS(1105), 1,
      anon_sym_LBRACE,
    ACTIONS(1113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1829), 1,
      anon_sym_LBRACK,
    ACTIONS(1851), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1853), 1,
      anon_sym_DASH_DASH,
    STATE(556), 1,
      sym_type_literal,
    STATE(979), 1,
      sym_member_name,
    STATE(993), 1,
      sym_string_literal,
    ACTIONS(1093), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1101), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2055), 2,
      sym_real_literal,
      sym_simple_name,
    STATE(1005), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1025), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1099), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1847), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(992), 10,
      sym__literal,
      sym_integer_literal,
      sym_variable,
      sym_expression_with_unary_operator,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
  [28684] = 25,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1083), 1,
      sym_decimal_integer_literal,
    ACTIONS(1085), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1089), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1091), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1103), 1,
      anon_sym_LPAREN,
    ACTIONS(1105), 1,
      anon_sym_LBRACE,
    ACTIONS(1113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1829), 1,
      anon_sym_LBRACK,
    ACTIONS(1851), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1853), 1,
      anon_sym_DASH_DASH,
    STATE(556), 1,
      sym_type_literal,
    STATE(975), 1,
      sym_member_name,
    STATE(993), 1,
      sym_string_literal,
    ACTIONS(1093), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1101), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2055), 2,
      sym_real_literal,
      sym_simple_name,
    STATE(1005), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1025), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1099), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1847), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(992), 10,
      sym__literal,
      sym_integer_literal,
      sym_variable,
      sym_expression_with_unary_operator,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
  [28785] = 25,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym_decimal_integer_literal,
    ACTIONS(1039), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1043), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1045), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1049), 1,
      anon_sym_LBRACK,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    ACTIONS(1063), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1065), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_AT_LBRACE,
    STATE(219), 1,
      sym_type_literal,
    STATE(925), 1,
      sym_member_name,
    STATE(964), 1,
      sym_string_literal,
    ACTIONS(1047), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1055), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1061), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2049), 2,
      sym_real_literal,
      sym_simple_name,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(933), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1053), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1051), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(963), 10,
      sym__literal,
      sym_integer_literal,
      sym_variable,
      sym_expression_with_unary_operator,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
  [28886] = 25,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(883), 1,
      sym_decimal_integer_literal,
    ACTIONS(1903), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1907), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1909), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1913), 1,
      anon_sym_LBRACK,
    ACTIONS(1919), 1,
      anon_sym_LPAREN,
    ACTIONS(1921), 1,
      anon_sym_LBRACE,
    ACTIONS(1927), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1929), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1931), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2039), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2041), 1,
      anon_sym_DASH_DASH,
    STATE(201), 1,
      sym_type_literal,
    STATE(747), 1,
      sym_member_name,
    STATE(813), 1,
      sym_string_literal,
    ACTIONS(897), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1911), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(2057), 2,
      sym_real_literal,
      sym_simple_name,
    STATE(796), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(790), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1917), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2037), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(816), 10,
      sym__literal,
      sym_integer_literal,
      sym_variable,
      sym_expression_with_unary_operator,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
  [28987] = 25,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(161), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(163), 1,
      anon_sym_DASH_DASH,
    STATE(4), 1,
      sym_type_literal,
    STATE(83), 1,
      sym_member_name,
    STATE(101), 1,
      sym_string_literal,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2059), 2,
      sym_real_literal,
      sym_simple_name,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(118), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(157), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(95), 10,
      sym__literal,
      sym_integer_literal,
      sym_variable,
      sym_expression_with_unary_operator,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
  [29088] = 25,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(837), 1,
      sym_decimal_integer_literal,
    ACTIONS(1933), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1937), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1939), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1943), 1,
      anon_sym_LBRACK,
    ACTIONS(1949), 1,
      anon_sym_LPAREN,
    ACTIONS(1951), 1,
      anon_sym_LBRACE,
    ACTIONS(1957), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1959), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1961), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2035), 1,
      anon_sym_DASH_DASH,
    STATE(195), 1,
      sym_type_literal,
    STATE(746), 1,
      sym_member_name,
    STATE(753), 1,
      sym_string_literal,
    ACTIONS(849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(851), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1941), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(2061), 2,
      sym_real_literal,
      sym_simple_name,
    STATE(771), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(780), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1947), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2031), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(754), 10,
      sym__literal,
      sym_integer_literal,
      sym_variable,
      sym_expression_with_unary_operator,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
  [29189] = 25,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1083), 1,
      sym_decimal_integer_literal,
    ACTIONS(1085), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1089), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1091), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1103), 1,
      anon_sym_LPAREN,
    ACTIONS(1105), 1,
      anon_sym_LBRACE,
    ACTIONS(1109), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1111), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1117), 1,
      anon_sym_AT_LBRACE,
    STATE(221), 1,
      sym_type_literal,
    STATE(979), 1,
      sym_member_name,
    STATE(993), 1,
      sym_string_literal,
    ACTIONS(1093), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1101), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2055), 2,
      sym_real_literal,
      sym_simple_name,
    STATE(1005), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1025), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1099), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1097), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(992), 10,
      sym__literal,
      sym_integer_literal,
      sym_variable,
      sym_expression_with_unary_operator,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
  [29290] = 25,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1083), 1,
      sym_decimal_integer_literal,
    ACTIONS(1085), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1089), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1091), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1095), 1,
      anon_sym_LBRACK,
    ACTIONS(1103), 1,
      anon_sym_LPAREN,
    ACTIONS(1105), 1,
      anon_sym_LBRACE,
    ACTIONS(1109), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1111), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1117), 1,
      anon_sym_AT_LBRACE,
    STATE(221), 1,
      sym_type_literal,
    STATE(975), 1,
      sym_member_name,
    STATE(993), 1,
      sym_string_literal,
    ACTIONS(1093), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1101), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2055), 2,
      sym_real_literal,
      sym_simple_name,
    STATE(1005), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1025), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1099), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1097), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(992), 10,
      sym__literal,
      sym_integer_literal,
      sym_variable,
      sym_expression_with_unary_operator,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
  [29391] = 25,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(941), 1,
      sym_decimal_integer_literal,
    ACTIONS(1873), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1877), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1879), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1883), 1,
      anon_sym_LBRACK,
    ACTIONS(1889), 1,
      anon_sym_LPAREN,
    ACTIONS(1891), 1,
      anon_sym_LBRACE,
    ACTIONS(1897), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1899), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1901), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2011), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2013), 1,
      anon_sym_DASH_DASH,
    STATE(214), 1,
      sym_type_literal,
    STATE(832), 1,
      sym_member_name,
    STATE(909), 1,
      sym_string_literal,
    ACTIONS(955), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1027), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1881), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(2053), 2,
      sym_real_literal,
      sym_simple_name,
    STATE(846), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(878), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1887), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2009), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(908), 10,
      sym__literal,
      sym_integer_literal,
      sym_variable,
      sym_expression_with_unary_operator,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
  [29492] = 25,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym_decimal_integer_literal,
    ACTIONS(1039), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1043), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1045), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1532), 1,
      anon_sym_LBRACK,
    ACTIONS(1819), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1821), 1,
      anon_sym_DASH_DASH,
    STATE(541), 1,
      sym_type_literal,
    STATE(925), 1,
      sym_member_name,
    STATE(964), 1,
      sym_string_literal,
    ACTIONS(1047), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1055), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2049), 2,
      sym_real_literal,
      sym_simple_name,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(933), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1053), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1815), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(963), 10,
      sym__literal,
      sym_integer_literal,
      sym_variable,
      sym_expression_with_unary_operator,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
  [29593] = 25,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym_decimal_integer_literal,
    ACTIONS(1039), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1043), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1045), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    ACTIONS(1067), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1532), 1,
      anon_sym_LBRACK,
    ACTIONS(1819), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1821), 1,
      anon_sym_DASH_DASH,
    STATE(541), 1,
      sym_type_literal,
    STATE(918), 1,
      sym_member_name,
    STATE(964), 1,
      sym_string_literal,
    ACTIONS(1047), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(1055), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1817), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2049), 2,
      sym_real_literal,
      sym_simple_name,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(933), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1053), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(1815), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(963), 10,
      sym__literal,
      sym_integer_literal,
      sym_variable,
      sym_expression_with_unary_operator,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
  [29694] = 25,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(93), 1,
      anon_sym_LBRACK,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(171), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(173), 1,
      anon_sym_DASH_DASH,
    STATE(6), 1,
      sym_type_literal,
    STATE(96), 1,
      sym_member_name,
    STATE(146), 1,
      sym_string_literal,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(169), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2051), 2,
      sym_real_literal,
      sym_simple_name,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(138), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(167), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(144), 10,
      sym__literal,
      sym_integer_literal,
      sym_variable,
      sym_expression_with_unary_operator,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
  [29795] = 25,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(161), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(163), 1,
      anon_sym_DASH_DASH,
    STATE(4), 1,
      sym_type_literal,
    STATE(87), 1,
      sym_member_name,
    STATE(101), 1,
      sym_string_literal,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(159), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2059), 2,
      sym_real_literal,
      sym_simple_name,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(118), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(157), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(95), 10,
      sym__literal,
      sym_integer_literal,
      sym_variable,
      sym_expression_with_unary_operator,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
  [29896] = 25,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(837), 1,
      sym_decimal_integer_literal,
    ACTIONS(1933), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1937), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1939), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1943), 1,
      anon_sym_LBRACK,
    ACTIONS(1949), 1,
      anon_sym_LPAREN,
    ACTIONS(1951), 1,
      anon_sym_LBRACE,
    ACTIONS(1957), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1959), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1961), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2035), 1,
      anon_sym_DASH_DASH,
    STATE(195), 1,
      sym_type_literal,
    STATE(748), 1,
      sym_member_name,
    STATE(753), 1,
      sym_string_literal,
    ACTIONS(849), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(851), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1941), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(2061), 2,
      sym_real_literal,
      sym_simple_name,
    STATE(771), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(780), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1947), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2031), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(754), 10,
      sym__literal,
      sym_integer_literal,
      sym_variable,
      sym_expression_with_unary_operator,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
  [29997] = 25,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(93), 1,
      anon_sym_LBRACK,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(171), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(173), 1,
      anon_sym_DASH_DASH,
    STATE(6), 1,
      sym_type_literal,
    STATE(100), 1,
      sym_member_name,
    STATE(146), 1,
      sym_string_literal,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(169), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2051), 2,
      sym_real_literal,
      sym_simple_name,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(138), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(167), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(144), 10,
      sym__literal,
      sym_integer_literal,
      sym_variable,
      sym_expression_with_unary_operator,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
  [30098] = 25,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(497), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(499), 1,
      anon_sym_DASH_DASH,
    STATE(77), 1,
      sym_type_literal,
    STATE(87), 1,
      sym_member_name,
    STATE(101), 1,
      sym_string_literal,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(495), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2059), 2,
      sym_real_literal,
      sym_simple_name,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(118), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(493), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(95), 10,
      sym__literal,
      sym_integer_literal,
      sym_variable,
      sym_expression_with_unary_operator,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
  [30199] = 25,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(87), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(89), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(105), 1,
      anon_sym_LPAREN,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(113), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(115), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(117), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(503), 1,
      anon_sym_LBRACK,
    ACTIONS(509), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(511), 1,
      anon_sym_DASH_DASH,
    STATE(78), 1,
      sym_type_literal,
    STATE(96), 1,
      sym_member_name,
    STATE(146), 1,
      sym_string_literal,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(91), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(507), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2051), 2,
      sym_real_literal,
      sym_simple_name,
    STATE(124), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(138), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(505), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(144), 10,
      sym__literal,
      sym_integer_literal,
      sym_variable,
      sym_expression_with_unary_operator,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
  [30300] = 25,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_decimal_integer_literal,
    ACTIONS(121), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(125), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(127), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(481), 1,
      anon_sym_LBRACK,
    ACTIONS(497), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(499), 1,
      anon_sym_DASH_DASH,
    STATE(77), 1,
      sym_type_literal,
    STATE(83), 1,
      sym_member_name,
    STATE(101), 1,
      sym_string_literal,
    ACTIONS(129), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(495), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2059), 2,
      sym_real_literal,
      sym_simple_name,
    STATE(110), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(118), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(493), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(95), 10,
      sym__literal,
      sym_integer_literal,
      sym_variable,
      sym_expression_with_unary_operator,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
  [30401] = 25,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(883), 1,
      sym_decimal_integer_literal,
    ACTIONS(1903), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1907), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1909), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1913), 1,
      anon_sym_LBRACK,
    ACTIONS(1919), 1,
      anon_sym_LPAREN,
    ACTIONS(1921), 1,
      anon_sym_LBRACE,
    ACTIONS(1927), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1929), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1931), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2039), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2041), 1,
      anon_sym_DASH_DASH,
    STATE(201), 1,
      sym_type_literal,
    STATE(745), 1,
      sym_member_name,
    STATE(813), 1,
      sym_string_literal,
    ACTIONS(897), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1911), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(2057), 2,
      sym_real_literal,
      sym_simple_name,
    STATE(796), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(790), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1917), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2037), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(816), 10,
      sym__literal,
      sym_integer_literal,
      sym_variable,
      sym_expression_with_unary_operator,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
  [30502] = 25,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_decimal_integer_literal,
    ACTIONS(1971), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1975), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1977), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1981), 1,
      anon_sym_LBRACK,
    ACTIONS(1987), 1,
      anon_sym_LPAREN,
    ACTIONS(1989), 1,
      anon_sym_LBRACE,
    ACTIONS(1995), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1997), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1999), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2045), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2047), 1,
      anon_sym_DASH_DASH,
    STATE(207), 1,
      sym_type_literal,
    STATE(787), 1,
      sym_member_name,
    STATE(893), 1,
      sym_string_literal,
    ACTIONS(983), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(985), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1979), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(2063), 2,
      sym_real_literal,
      sym_simple_name,
    STATE(850), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(889), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1985), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2043), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(860), 10,
      sym__literal,
      sym_integer_literal,
      sym_variable,
      sym_expression_with_unary_operator,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
  [30603] = 25,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_decimal_integer_literal,
    ACTIONS(1971), 1,
      sym_hexadecimal_integer_literal,
    ACTIONS(1975), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1977), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1981), 1,
      anon_sym_LBRACK,
    ACTIONS(1987), 1,
      anon_sym_LPAREN,
    ACTIONS(1989), 1,
      anon_sym_LBRACE,
    ACTIONS(1995), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1997), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1999), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2045), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2047), 1,
      anon_sym_DASH_DASH,
    STATE(207), 1,
      sym_type_literal,
    STATE(822), 1,
      sym_member_name,
    STATE(893), 1,
      sym_string_literal,
    ACTIONS(983), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(985), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(1979), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    ACTIONS(2063), 2,
      sym_real_literal,
      sym_simple_name,
    STATE(850), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(889), 3,
      sym_pre_increment_expression,
      sym_pre_decrement_expression,
      sym_cast_expression,
    ACTIONS(1985), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2043), 6,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_COMMA,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
    STATE(860), 10,
      sym__literal,
      sym_integer_literal,
      sym_variable,
      sym_expression_with_unary_operator,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
  [30704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(599), 1,
      anon_sym_SPACE,
    ACTIONS(601), 47,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_path_command_name_token,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [30760] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2070), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(97), 6,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
    ACTIONS(2068), 8,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      sym_path_command_name_token,
    ACTIONS(2065), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [30820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(599), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(601), 46,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_path_command_name_token,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [30876] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2070), 1,
      anon_sym_SPACE,
    ACTIONS(97), 6,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
    ACTIONS(2068), 8,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      sym_path_command_name_token,
    ACTIONS(2065), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [30936] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1131), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1133), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1141), 1,
      anon_sym_LPAREN,
    ACTIONS(1143), 1,
      anon_sym_LBRACE,
    ACTIONS(1149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2073), 1,
      sym_real_literal,
    ACTIONS(2075), 1,
      anon_sym_LBRACK,
    ACTIONS(2079), 1,
      aux_sym_command_name_token1,
    ACTIONS(2081), 1,
      sym_path_command_name_token,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    STATE(1216), 1,
      sym_variable,
    STATE(1246), 1,
      aux_sym_path_command_name_repeat1,
    STATE(1486), 1,
      sym_data_command,
    STATE(1549), 1,
      sym_command_name_expr,
    STATE(1951), 1,
      sym_data_commands_list,
    ACTIONS(1037), 2,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
    ACTIONS(1135), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1524), 2,
      sym_command_name,
      sym_path_command_name,
    ACTIONS(2077), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
    STATE(1279), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
      sym_type_literal,
  [31034] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2070), 1,
      anon_sym_SPACE,
    ACTIONS(97), 6,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
    ACTIONS(2068), 8,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      sym_path_command_name_token,
    ACTIONS(2065), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [31093] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1131), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1133), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1141), 1,
      anon_sym_LPAREN,
    ACTIONS(1143), 1,
      anon_sym_LBRACE,
    ACTIONS(1149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2073), 1,
      sym_real_literal,
    ACTIONS(2075), 1,
      anon_sym_LBRACK,
    ACTIONS(2079), 1,
      aux_sym_command_name_token1,
    ACTIONS(2081), 1,
      sym_path_command_name_token,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    STATE(1216), 1,
      sym_variable,
    STATE(1246), 1,
      aux_sym_path_command_name_repeat1,
    STATE(1549), 1,
      sym_command_name_expr,
    STATE(1696), 1,
      sym_data_command,
    ACTIONS(1037), 2,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
    ACTIONS(1135), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1524), 2,
      sym_command_name,
      sym_path_command_name,
    ACTIONS(2077), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
    STATE(1279), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
      sym_type_literal,
  [31188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(599), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(601), 45,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_path_command_name_token,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [31243] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2070), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(97), 6,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
    ACTIONS(2068), 8,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      sym_path_command_name_token,
    ACTIONS(2065), 31,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [31302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(599), 1,
      anon_sym_SPACE,
    ACTIONS(601), 46,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_path_command_name_token,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [31357] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      aux_sym_command_name_token1,
    ACTIONS(841), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(843), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(853), 1,
      anon_sym_LPAREN,
    ACTIONS(855), 1,
      anon_sym_LBRACE,
    ACTIONS(861), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(863), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(865), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2083), 1,
      sym_real_literal,
    ACTIONS(2085), 1,
      anon_sym_LBRACK,
    ACTIONS(2089), 1,
      sym_path_command_name_token,
    STATE(709), 1,
      sym_variable,
    STATE(736), 1,
      aux_sym_path_command_name_repeat1,
    STATE(739), 1,
      sym_command_name_expr,
    STATE(767), 1,
      sym_invokation_foreach_expression,
    ACTIONS(837), 2,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
    ACTIONS(845), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(771), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1091), 2,
      sym_command_name,
      sym_path_command_name,
    ACTIONS(2087), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
    STATE(916), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
      sym_type_literal,
  [31449] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(887), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(889), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(899), 1,
      anon_sym_LPAREN,
    ACTIONS(901), 1,
      anon_sym_LBRACE,
    ACTIONS(907), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(909), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(911), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(1275), 1,
      aux_sym_command_name_token1,
    ACTIONS(2091), 1,
      sym_real_literal,
    ACTIONS(2093), 1,
      anon_sym_LBRACK,
    ACTIONS(2097), 1,
      sym_path_command_name_token,
    STATE(711), 1,
      sym_variable,
    STATE(737), 1,
      aux_sym_path_command_name_repeat1,
    STATE(750), 1,
      sym_command_name_expr,
    STATE(801), 1,
      sym_invokation_foreach_expression,
    ACTIONS(883), 2,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
    ACTIONS(891), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(796), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1101), 2,
      sym_command_name,
      sym_path_command_name,
    ACTIONS(2095), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
    STATE(923), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
      sym_type_literal,
  [31541] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(975), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(977), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(987), 1,
      anon_sym_LPAREN,
    ACTIONS(989), 1,
      anon_sym_LBRACE,
    ACTIONS(995), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(997), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(999), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2099), 1,
      sym_real_literal,
    ACTIONS(2101), 1,
      anon_sym_LBRACK,
    ACTIONS(2105), 1,
      aux_sym_command_name_token1,
    ACTIONS(2107), 1,
      sym_path_command_name_token,
    STATE(716), 1,
      sym_variable,
    STATE(741), 1,
      aux_sym_path_command_name_repeat1,
    STATE(784), 1,
      sym_command_name_expr,
    STATE(861), 1,
      sym_invokation_foreach_expression,
    ACTIONS(971), 2,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
    ACTIONS(979), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(850), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1109), 2,
      sym_command_name,
      sym_path_command_name,
    ACTIONS(2103), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
    STATE(928), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
      sym_type_literal,
  [31633] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(841), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(843), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(853), 1,
      anon_sym_LPAREN,
    ACTIONS(855), 1,
      anon_sym_LBRACE,
    ACTIONS(861), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(863), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(865), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2085), 1,
      anon_sym_LBRACK,
    ACTIONS(2109), 1,
      sym_real_literal,
    ACTIONS(2111), 1,
      anon_sym_SPACE,
    ACTIONS(2113), 1,
      anon_sym_COLON,
    STATE(210), 1,
      sym_command_argument_sep,
    STATE(306), 1,
      aux_sym_command_argument_sep_repeat1,
    STATE(767), 1,
      sym_invokation_foreach_expression,
    STATE(1078), 1,
      sym__command_argument,
    STATE(1096), 1,
      sym_redirected_file_name,
    ACTIONS(837), 2,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
    ACTIONS(845), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(771), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    ACTIONS(851), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
    STATE(921), 17,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
      sym_type_literal,
  [31725] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(947), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(957), 1,
      anon_sym_LPAREN,
    ACTIONS(959), 1,
      anon_sym_LBRACE,
    ACTIONS(965), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(967), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(969), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2115), 1,
      sym_real_literal,
    ACTIONS(2117), 1,
      anon_sym_LBRACK,
    ACTIONS(2121), 1,
      aux_sym_command_name_token1,
    ACTIONS(2123), 1,
      sym_path_command_name_token,
    STATE(713), 1,
      sym_variable,
    STATE(744), 1,
      aux_sym_path_command_name_repeat1,
    STATE(807), 1,
      sym_command_name_expr,
    STATE(840), 1,
      sym_invokation_foreach_expression,
    ACTIONS(941), 2,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
    ACTIONS(949), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(846), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    STATE(1108), 2,
      sym_command_name,
      sym_path_command_name,
    ACTIONS(2119), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
    STATE(941), 16,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
      sym_type_literal,
  [31817] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1131), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1133), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1141), 1,
      anon_sym_LPAREN,
    ACTIONS(1143), 1,
      anon_sym_LBRACE,
    ACTIONS(1149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2075), 1,
      anon_sym_LBRACK,
    ACTIONS(2125), 1,
      sym_real_literal,
    ACTIONS(2127), 1,
      sym__command_token,
    ACTIONS(2129), 1,
      anon_sym_RBRACE,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    STATE(1601), 1,
      sym_switch_clause_condition,
    STATE(1847), 1,
      sym_switch_clauses,
    ACTIONS(1037), 2,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
    ACTIONS(1135), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(732), 2,
      sym_switch_clause,
      aux_sym_switch_clauses_repeat1,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    ACTIONS(1055), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
    STATE(1305), 17,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
      sym_type_literal,
  [31907] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1131), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1133), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1141), 1,
      anon_sym_LPAREN,
    ACTIONS(1143), 1,
      anon_sym_LBRACE,
    ACTIONS(1149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2075), 1,
      anon_sym_LBRACK,
    ACTIONS(2125), 1,
      sym_real_literal,
    ACTIONS(2127), 1,
      sym__command_token,
    ACTIONS(2131), 1,
      anon_sym_RBRACE,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    STATE(1601), 1,
      sym_switch_clause_condition,
    STATE(1704), 1,
      sym_switch_clauses,
    ACTIONS(1037), 2,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
    ACTIONS(1135), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(732), 2,
      sym_switch_clause,
      aux_sym_switch_clauses_repeat1,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    ACTIONS(1055), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
    STATE(1305), 17,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
      sym_type_literal,
  [31997] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1157), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1159), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1167), 1,
      anon_sym_LPAREN,
    ACTIONS(1169), 1,
      anon_sym_LBRACE,
    ACTIONS(1175), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1177), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1179), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2133), 1,
      sym_real_literal,
    ACTIONS(2135), 1,
      anon_sym_LBRACK,
    ACTIONS(2137), 1,
      anon_sym_SPACE,
    ACTIONS(2139), 1,
      anon_sym_COLON,
    STATE(224), 1,
      sym_command_argument_sep,
    STATE(404), 1,
      aux_sym_command_argument_sep_repeat1,
    STATE(1022), 1,
      sym_invokation_foreach_expression,
    STATE(1130), 1,
      sym_redirected_file_name,
    STATE(1131), 1,
      sym__command_argument,
    ACTIONS(1083), 2,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
    ACTIONS(1161), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(1005), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    ACTIONS(1101), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
    STATE(1055), 17,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
      sym_type_literal,
  [32089] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1131), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1133), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1141), 1,
      anon_sym_LPAREN,
    ACTIONS(1143), 1,
      anon_sym_LBRACE,
    ACTIONS(1149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2075), 1,
      anon_sym_LBRACK,
    ACTIONS(2125), 1,
      sym_real_literal,
    ACTIONS(2127), 1,
      sym__command_token,
    ACTIONS(2141), 1,
      anon_sym_RBRACE,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    STATE(1601), 1,
      sym_switch_clause_condition,
    STATE(1737), 1,
      sym_switch_clauses,
    ACTIONS(1037), 2,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
    ACTIONS(1135), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(732), 2,
      sym_switch_clause,
      aux_sym_switch_clauses_repeat1,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    ACTIONS(1055), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
    STATE(1305), 17,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
      sym_type_literal,
  [32179] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(975), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(977), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(987), 1,
      anon_sym_LPAREN,
    ACTIONS(989), 1,
      anon_sym_LBRACE,
    ACTIONS(995), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(997), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(999), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2101), 1,
      anon_sym_LBRACK,
    ACTIONS(2143), 1,
      sym_real_literal,
    ACTIONS(2145), 1,
      anon_sym_SPACE,
    ACTIONS(2147), 1,
      anon_sym_COLON,
    STATE(216), 1,
      sym_command_argument_sep,
    STATE(320), 1,
      aux_sym_command_argument_sep_repeat1,
    STATE(861), 1,
      sym_invokation_foreach_expression,
    STATE(1105), 1,
      sym_redirected_file_name,
    STATE(1112), 1,
      sym__command_argument,
    ACTIONS(971), 2,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
    ACTIONS(979), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(850), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    ACTIONS(985), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
    STATE(962), 17,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
      sym_type_literal,
  [32271] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1131), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1133), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1141), 1,
      anon_sym_LPAREN,
    ACTIONS(1143), 1,
      anon_sym_LBRACE,
    ACTIONS(1149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2075), 1,
      anon_sym_LBRACK,
    ACTIONS(2125), 1,
      sym_real_literal,
    ACTIONS(2127), 1,
      sym__command_token,
    ACTIONS(2149), 1,
      anon_sym_RBRACE,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    STATE(1601), 1,
      sym_switch_clause_condition,
    STATE(2039), 1,
      sym_switch_clauses,
    ACTIONS(1037), 2,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
    ACTIONS(1135), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(732), 2,
      sym_switch_clause,
      aux_sym_switch_clauses_repeat1,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    ACTIONS(1055), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
    STATE(1305), 17,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
      sym_type_literal,
  [32361] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(887), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(889), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(899), 1,
      anon_sym_LPAREN,
    ACTIONS(901), 1,
      anon_sym_LBRACE,
    ACTIONS(907), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(909), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(911), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2093), 1,
      anon_sym_LBRACK,
    ACTIONS(2151), 1,
      sym_real_literal,
    ACTIONS(2153), 1,
      anon_sym_SPACE,
    ACTIONS(2155), 1,
      anon_sym_COLON,
    STATE(205), 1,
      sym_command_argument_sep,
    STATE(309), 1,
      aux_sym_command_argument_sep_repeat1,
    STATE(801), 1,
      sym_invokation_foreach_expression,
    STATE(1081), 1,
      sym__command_argument,
    STATE(1082), 1,
      sym_redirected_file_name,
    ACTIONS(883), 2,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
    ACTIONS(891), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(796), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    ACTIONS(897), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
    STATE(917), 17,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
      sym_type_literal,
  [32453] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1131), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1133), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1141), 1,
      anon_sym_LPAREN,
    ACTIONS(1143), 1,
      anon_sym_LBRACE,
    ACTIONS(1149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2075), 1,
      anon_sym_LBRACK,
    ACTIONS(2157), 1,
      sym_real_literal,
    ACTIONS(2159), 1,
      anon_sym_SPACE,
    ACTIONS(2161), 1,
      anon_sym_COLON,
    STATE(223), 1,
      sym_command_argument_sep,
    STATE(396), 1,
      aux_sym_command_argument_sep_repeat1,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    STATE(1127), 1,
      sym_redirected_file_name,
    STATE(1128), 1,
      sym__command_argument,
    ACTIONS(1037), 2,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
    ACTIONS(1135), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    ACTIONS(1055), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
    STATE(1057), 17,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
      sym_type_literal,
  [32545] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(945), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(947), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(957), 1,
      anon_sym_LPAREN,
    ACTIONS(959), 1,
      anon_sym_LBRACE,
    ACTIONS(965), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(967), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(969), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2117), 1,
      anon_sym_LBRACK,
    ACTIONS(2163), 1,
      sym_real_literal,
    ACTIONS(2165), 1,
      anon_sym_SPACE,
    ACTIONS(2167), 1,
      anon_sym_COLON,
    STATE(215), 1,
      sym_command_argument_sep,
    STATE(336), 1,
      aux_sym_command_argument_sep_repeat1,
    STATE(840), 1,
      sym_invokation_foreach_expression,
    STATE(1113), 1,
      sym_redirected_file_name,
    STATE(1115), 1,
      sym__command_argument,
    ACTIONS(941), 2,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
    ACTIONS(949), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(846), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    ACTIONS(955), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
    STATE(970), 17,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
      sym_type_literal,
  [32637] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1131), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1133), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1141), 1,
      anon_sym_LPAREN,
    ACTIONS(1143), 1,
      anon_sym_LBRACE,
    ACTIONS(1149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2075), 1,
      anon_sym_LBRACK,
    ACTIONS(2125), 1,
      sym_real_literal,
    ACTIONS(2127), 1,
      sym__command_token,
    ACTIONS(2169), 1,
      anon_sym_RBRACE,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    STATE(1601), 1,
      sym_switch_clause_condition,
    ACTIONS(1037), 2,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
    ACTIONS(1135), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(733), 2,
      sym_switch_clause,
      aux_sym_switch_clauses_repeat1,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    ACTIONS(1055), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
    STATE(1305), 17,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
      sym_type_literal,
  [32724] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2174), 1,
      sym_real_literal,
    ACTIONS(2177), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(2180), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(2186), 1,
      anon_sym_LBRACK,
    ACTIONS(2192), 1,
      sym__command_token,
    ACTIONS(2195), 1,
      anon_sym_LPAREN,
    ACTIONS(2198), 1,
      anon_sym_LBRACE,
    ACTIONS(2201), 1,
      anon_sym_RBRACE,
    ACTIONS(2203), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2206), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(2209), 1,
      anon_sym_AT_LBRACE,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    STATE(1601), 1,
      sym_switch_clause_condition,
    ACTIONS(2171), 2,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
    ACTIONS(2183), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(733), 2,
      sym_switch_clause,
      aux_sym_switch_clauses_repeat1,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    ACTIONS(2189), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
    STATE(1305), 17,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
      sym_type_literal,
  [32811] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(251), 11,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      anon_sym_DOT2,
    ACTIONS(253), 34,
      sym_simple_name,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [32864] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2217), 1,
      sym_path_command_name_token,
    ACTIONS(2220), 1,
      anon_sym_SPACE,
    STATE(735), 2,
      sym_variable,
      aux_sym_path_command_name_repeat1,
    ACTIONS(2214), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2212), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [32922] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 1,
      sym_path_command_name_token,
    ACTIONS(2228), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    STATE(738), 2,
      sym_variable,
      aux_sym_path_command_name_repeat1,
    ACTIONS(2224), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2222), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [32980] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2228), 1,
      anon_sym_SPACE,
    ACTIONS(2232), 1,
      sym_path_command_name_token,
    STATE(735), 2,
      sym_variable,
      aux_sym_path_command_name_repeat1,
    ACTIONS(2230), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2222), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [33038] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2237), 1,
      sym_path_command_name_token,
    ACTIONS(2220), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    STATE(738), 2,
      sym_variable,
      aux_sym_path_command_name_repeat1,
    ACTIONS(2234), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2212), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [33096] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2111), 1,
      anon_sym_SPACE,
    ACTIONS(2113), 1,
      anon_sym_COLON,
    ACTIONS(2248), 1,
      sym__statement_terminator,
    STATE(213), 1,
      sym_command_argument_sep,
    STATE(306), 1,
      aux_sym_command_argument_sep_repeat1,
    STATE(721), 1,
      sym_file_redirection_operator,
    STATE(1050), 1,
      sym__command_argument,
    STATE(1088), 1,
      sym_merging_redirection_operator,
    STATE(1408), 1,
      sym_command_elements,
    ACTIONS(2244), 2,
      sym_command_parameter,
      sym_stop_parsing,
    ACTIONS(2246), 2,
      anon_sym_PIPE,
      anon_sym_DASH_DASH_PERCENT,
    STATE(777), 3,
      sym__command_element,
      sym_redirection,
      aux_sym_command_elements_repeat1,
    ACTIONS(2242), 12,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
    ACTIONS(2240), 15,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
  [33171] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2153), 1,
      anon_sym_SPACE,
    ACTIONS(2155), 1,
      anon_sym_COLON,
    STATE(211), 1,
      sym_command_argument_sep,
    STATE(309), 1,
      aux_sym_command_argument_sep_repeat1,
    STATE(729), 1,
      sym_file_redirection_operator,
    STATE(1033), 1,
      sym__command_argument,
    STATE(1086), 1,
      sym_merging_redirection_operator,
    STATE(1436), 1,
      sym_command_elements,
    ACTIONS(2252), 2,
      sym_command_parameter,
      sym_stop_parsing,
    ACTIONS(2254), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_DASH_DASH_PERCENT,
    STATE(806), 3,
      sym__command_element,
      sym_redirection,
      aux_sym_command_elements_repeat1,
    ACTIONS(2250), 12,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
    ACTIONS(2240), 15,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
  [33244] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2258), 1,
      sym_path_command_name_token,
    ACTIONS(2228), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    STATE(742), 2,
      sym_variable,
      aux_sym_path_command_name_repeat1,
    ACTIONS(2256), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2222), 31,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [33301] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2263), 1,
      sym_path_command_name_token,
    ACTIONS(2220), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    STATE(742), 2,
      sym_variable,
      aux_sym_path_command_name_repeat1,
    ACTIONS(2260), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2212), 31,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [33358] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2111), 1,
      anon_sym_SPACE,
    ACTIONS(2113), 1,
      anon_sym_COLON,
    ACTIONS(2266), 1,
      sym__statement_terminator,
    STATE(213), 1,
      sym_command_argument_sep,
    STATE(306), 1,
      aux_sym_command_argument_sep_repeat1,
    STATE(721), 1,
      sym_file_redirection_operator,
    STATE(1050), 1,
      sym__command_argument,
    STATE(1088), 1,
      sym_merging_redirection_operator,
    STATE(1432), 1,
      sym_command_elements,
    ACTIONS(2244), 2,
      sym_command_parameter,
      sym_stop_parsing,
    ACTIONS(2254), 2,
      anon_sym_PIPE,
      anon_sym_DASH_DASH_PERCENT,
    STATE(777), 3,
      sym__command_element,
      sym_redirection,
      aux_sym_command_elements_repeat1,
    ACTIONS(2242), 12,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
    ACTIONS(2240), 15,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
  [33433] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2228), 1,
      anon_sym_SPACE,
    ACTIONS(2270), 1,
      sym_path_command_name_token,
    STATE(749), 2,
      sym_variable,
      aux_sym_path_command_name_repeat1,
    ACTIONS(2268), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2222), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [33490] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2272), 1,
      anon_sym_LPAREN,
    STATE(803), 1,
      sym_argument_list,
    ACTIONS(591), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(593), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [33545] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2274), 1,
      anon_sym_LPAREN,
    STATE(786), 1,
      sym_argument_list,
    ACTIONS(591), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(593), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [33600] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(803), 1,
      sym_argument_list,
    ACTIONS(591), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(593), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [33653] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(786), 1,
      sym_argument_list,
    ACTIONS(591), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(593), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [33706] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2220), 1,
      anon_sym_SPACE,
    ACTIONS(2279), 1,
      sym_path_command_name_token,
    STATE(749), 2,
      sym_variable,
      aux_sym_path_command_name_repeat1,
    ACTIONS(2276), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
    ACTIONS(2212), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [33763] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2153), 1,
      anon_sym_SPACE,
    ACTIONS(2155), 1,
      anon_sym_COLON,
    STATE(211), 1,
      sym_command_argument_sep,
    STATE(309), 1,
      aux_sym_command_argument_sep_repeat1,
    STATE(729), 1,
      sym_file_redirection_operator,
    STATE(1033), 1,
      sym__command_argument,
    STATE(1086), 1,
      sym_merging_redirection_operator,
    STATE(1518), 1,
      sym_command_elements,
    ACTIONS(2252), 2,
      sym_command_parameter,
      sym_stop_parsing,
    ACTIONS(2246), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_DASH_DASH_PERCENT,
    STATE(806), 3,
      sym__command_element,
      sym_redirection,
      aux_sym_command_elements_repeat1,
    ACTIONS(2250), 12,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
    ACTIONS(2240), 15,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
  [33836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(641), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [33886] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(665), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(667), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [33936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(654), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [33986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(633), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(635), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [34036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(645), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [34086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(701), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(703), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [34136] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(669), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(671), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [34186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(681), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(683), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [34236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(661), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(663), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [34286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(699), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [34336] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2145), 1,
      anon_sym_SPACE,
    ACTIONS(2147), 1,
      anon_sym_COLON,
    ACTIONS(2254), 1,
      anon_sym_PIPE,
    ACTIONS(2266), 1,
      sym__statement_terminator,
    STATE(218), 1,
      sym_command_argument_sep,
    STATE(320), 1,
      aux_sym_command_argument_sep_repeat1,
    STATE(727), 1,
      sym_file_redirection_operator,
    STATE(1053), 1,
      sym__command_argument,
    STATE(1110), 1,
      sym_merging_redirection_operator,
    STATE(1432), 1,
      sym_command_elements,
    ACTIONS(2284), 2,
      sym_command_parameter,
      sym_stop_parsing,
    STATE(849), 3,
      sym__command_element,
      sym_redirection,
      aux_sym_command_elements_repeat1,
    ACTIONS(2282), 12,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
    ACTIONS(2240), 15,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
  [34410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(665), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(667), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [34460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(647), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(649), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [34510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(725), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(727), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [34560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(621), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(623), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [34610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(627), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [34660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(609), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(611), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [34710] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2286), 1,
      anon_sym_LBRACK,
    ACTIONS(2288), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2290), 1,
      anon_sym_DASH_DASH,
    ACTIONS(2294), 1,
      anon_sym_DOTforeach,
    ACTIONS(713), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(2292), 2,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
    ACTIONS(715), 34,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [34770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(595), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(597), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [34820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(629), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(631), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [34870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(687), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [34920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(689), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(691), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [34970] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(681), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(683), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [35020] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(603), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(605), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [35070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(659), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [35120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(677), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(679), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [35170] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2111), 1,
      anon_sym_SPACE,
    ACTIONS(2113), 1,
      anon_sym_COLON,
    ACTIONS(2300), 1,
      sym__statement_terminator,
    STATE(213), 1,
      sym_command_argument_sep,
    STATE(306), 1,
      aux_sym_command_argument_sep_repeat1,
    STATE(721), 1,
      sym_file_redirection_operator,
    STATE(1050), 1,
      sym__command_argument,
    STATE(1088), 1,
      sym_merging_redirection_operator,
    ACTIONS(2296), 2,
      sym_command_parameter,
      sym_stop_parsing,
    ACTIONS(2298), 2,
      anon_sym_PIPE,
      anon_sym_DASH_DASH_PERCENT,
    STATE(825), 3,
      sym__command_element,
      sym_redirection,
      aux_sym_command_elements_repeat1,
    ACTIONS(2242), 12,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
    ACTIONS(2240), 15,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
  [35242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(613), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(615), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [35292] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(705), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(707), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [35342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(719), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [35392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(721), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(723), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [35442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(729), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(731), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [35492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(617), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(619), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [35542] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2145), 1,
      anon_sym_SPACE,
    ACTIONS(2147), 1,
      anon_sym_COLON,
    ACTIONS(2246), 1,
      anon_sym_PIPE,
    ACTIONS(2248), 1,
      sym__statement_terminator,
    STATE(218), 1,
      sym_command_argument_sep,
    STATE(320), 1,
      aux_sym_command_argument_sep_repeat1,
    STATE(727), 1,
      sym_file_redirection_operator,
    STATE(1053), 1,
      sym__command_argument,
    STATE(1110), 1,
      sym_merging_redirection_operator,
    STATE(1408), 1,
      sym_command_elements,
    ACTIONS(2284), 2,
      sym_command_parameter,
      sym_stop_parsing,
    STATE(849), 3,
      sym__command_element,
      sym_redirection,
      aux_sym_command_elements_repeat1,
    ACTIONS(2282), 12,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
    ACTIONS(2240), 15,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
  [35616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(695), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [35666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(709), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(711), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [35716] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2302), 1,
      anon_sym_LPAREN,
    STATE(864), 1,
      sym_argument_list,
    ACTIONS(591), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(593), 37,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [35770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(599), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(601), 40,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_path_command_name_token,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [35820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(715), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [35870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(719), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [35920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(721), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(723), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [35970] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(729), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(731), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [36020] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(617), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(619), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [36070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(695), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [36120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(689), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(691), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [36170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(687), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [36220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(659), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [36270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(613), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(615), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [36320] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(599), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(601), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [36370] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 1,
      anon_sym_SPACE,
    ACTIONS(2304), 1,
      anon_sym_LBRACK,
    ACTIONS(2306), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2308), 1,
      anon_sym_DASH_DASH,
    ACTIONS(2312), 1,
      anon_sym_DOTforeach,
    ACTIONS(2310), 2,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
    ACTIONS(715), 35,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [36430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(609), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(611), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [36480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(627), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [36530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(709), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(711), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [36580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(705), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(707), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [36630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(621), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(623), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [36680] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2153), 1,
      anon_sym_SPACE,
    ACTIONS(2155), 1,
      anon_sym_COLON,
    STATE(211), 1,
      sym_command_argument_sep,
    STATE(309), 1,
      aux_sym_command_argument_sep_repeat1,
    STATE(729), 1,
      sym_file_redirection_operator,
    STATE(1033), 1,
      sym__command_argument,
    STATE(1086), 1,
      sym_merging_redirection_operator,
    ACTIONS(2314), 2,
      sym_command_parameter,
      sym_stop_parsing,
    ACTIONS(2298), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_DASH_DASH_PERCENT,
    STATE(827), 3,
      sym__command_element,
      sym_redirection,
      aux_sym_command_elements_repeat1,
    ACTIONS(2250), 12,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
    ACTIONS(2240), 15,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
  [36750] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2165), 1,
      anon_sym_SPACE,
    ACTIONS(2167), 1,
      anon_sym_COLON,
    STATE(217), 1,
      sym_command_argument_sep,
    STATE(336), 1,
      aux_sym_command_argument_sep_repeat1,
    STATE(731), 1,
      sym_file_redirection_operator,
    STATE(1063), 1,
      sym__command_argument,
    STATE(1116), 1,
      sym_merging_redirection_operator,
    STATE(1518), 1,
      sym_command_elements,
    ACTIONS(2246), 2,
      anon_sym_RPAREN,
      anon_sym_PIPE,
    ACTIONS(2318), 2,
      sym_command_parameter,
      sym_stop_parsing,
    STATE(883), 3,
      sym__command_element,
      sym_redirection,
      aux_sym_command_elements_repeat1,
    ACTIONS(2316), 12,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
    ACTIONS(2240), 15,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
  [36822] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2320), 1,
      anon_sym_LPAREN,
    STATE(899), 1,
      sym_argument_list,
    ACTIONS(591), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(593), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [36876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(603), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(605), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [36926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(677), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(679), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [36976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(673), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(675), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [37026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(673), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(675), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [37076] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(654), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [37126] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(599), 1,
      anon_sym_SPACE,
    ACTIONS(601), 41,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_path_command_name_token,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [37176] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(715), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [37226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(633), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(635), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [37276] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2165), 1,
      anon_sym_SPACE,
    ACTIONS(2167), 1,
      anon_sym_COLON,
    STATE(217), 1,
      sym_command_argument_sep,
    STATE(336), 1,
      aux_sym_command_argument_sep_repeat1,
    STATE(731), 1,
      sym_file_redirection_operator,
    STATE(1063), 1,
      sym__command_argument,
    STATE(1116), 1,
      sym_merging_redirection_operator,
    STATE(1436), 1,
      sym_command_elements,
    ACTIONS(2254), 2,
      anon_sym_RPAREN,
      anon_sym_PIPE,
    ACTIONS(2318), 2,
      sym_command_parameter,
      sym_stop_parsing,
    STATE(883), 3,
      sym__command_element,
      sym_redirection,
      aux_sym_command_elements_repeat1,
    ACTIONS(2316), 12,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
    ACTIONS(2240), 15,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
  [37348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(599), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(601), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [37398] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1131), 1,
      aux_sym_expandable_string_literal_token1,
    ACTIONS(1133), 1,
      aux_sym_expandable_here_string_literal_token1,
    ACTIONS(1141), 1,
      anon_sym_LPAREN,
    ACTIONS(1143), 1,
      anon_sym_LBRACE,
    ACTIONS(1149), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1151), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(1153), 1,
      anon_sym_AT_LBRACE,
    ACTIONS(2075), 1,
      anon_sym_LBRACK,
    ACTIONS(2322), 1,
      sym_real_literal,
    ACTIONS(2324), 1,
      sym__command_token,
    STATE(950), 1,
      sym_invokation_foreach_expression,
    STATE(1814), 1,
      sym_switch_filename,
    ACTIONS(1037), 2,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
    ACTIONS(1135), 2,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
    STATE(930), 2,
      sym_expandable_string_literal,
      sym_expandable_here_string_literal,
    ACTIONS(1055), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
    STATE(1306), 17,
      sym__literal,
      sym_integer_literal,
      sym_string_literal,
      sym_variable,
      sym__primary_expression,
      sym__value,
      sym_parenthesized_expression,
      sym_sub_expression,
      sym_array_expression,
      sym_script_block_expression,
      sym_hash_literal_expression,
      sym_post_increment_expression,
      sym_post_decrement_expression,
      sym_member_access,
      sym_element_access,
      sym_invokation_expression,
      sym_type_literal,
  [37478] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(669), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(671), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [37528] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(641), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [37578] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(864), 1,
      sym_argument_list,
    ACTIONS(591), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(593), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [37630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(645), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [37680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(701), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(703), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [37730] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2337), 1,
      anon_sym_SPACE,
    ACTIONS(2340), 1,
      anon_sym_COLON,
    ACTIONS(2343), 1,
      sym__statement_terminator,
    STATE(213), 1,
      sym_command_argument_sep,
    STATE(306), 1,
      aux_sym_command_argument_sep_repeat1,
    STATE(721), 1,
      sym_file_redirection_operator,
    STATE(1050), 1,
      sym__command_argument,
    STATE(1088), 1,
      sym_merging_redirection_operator,
    ACTIONS(2332), 2,
      sym_command_parameter,
      sym_stop_parsing,
    ACTIONS(2335), 2,
      anon_sym_PIPE,
      anon_sym_DASH_DASH_PERCENT,
    STATE(825), 3,
      sym__command_element,
      sym_redirection,
      aux_sym_command_elements_repeat1,
    ACTIONS(2329), 12,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
    ACTIONS(2326), 15,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
  [37802] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(661), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(663), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [37852] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2351), 1,
      anon_sym_SPACE,
    ACTIONS(2354), 1,
      anon_sym_COLON,
    STATE(211), 1,
      sym_command_argument_sep,
    STATE(309), 1,
      aux_sym_command_argument_sep_repeat1,
    STATE(729), 1,
      sym_file_redirection_operator,
    STATE(1033), 1,
      sym__command_argument,
    STATE(1086), 1,
      sym_merging_redirection_operator,
    ACTIONS(2348), 2,
      sym_command_parameter,
      sym_stop_parsing,
    ACTIONS(2335), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_DASH_DASH_PERCENT,
    STATE(827), 3,
      sym__command_element,
      sym_redirection,
      aux_sym_command_elements_repeat1,
    ACTIONS(2345), 12,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
    ACTIONS(2326), 15,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
  [37922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(595), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(597), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [37972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(647), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(649), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [38022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(699), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [38072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(629), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(631), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [38122] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(899), 1,
      sym_argument_list,
    ACTIONS(591), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(593), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [38174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(725), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(727), 40,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [38224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(613), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(615), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [38273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(701), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(703), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [38322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(681), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(683), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [38371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(595), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(597), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [38420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(629), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(631), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [38469] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_PIPE,
    ACTIONS(2343), 1,
      sym__statement_terminator,
    ACTIONS(2363), 1,
      anon_sym_SPACE,
    ACTIONS(2366), 1,
      anon_sym_COLON,
    STATE(218), 1,
      sym_command_argument_sep,
    STATE(320), 1,
      aux_sym_command_argument_sep_repeat1,
    STATE(727), 1,
      sym_file_redirection_operator,
    STATE(1053), 1,
      sym__command_argument,
    STATE(1110), 1,
      sym_merging_redirection_operator,
    ACTIONS(2360), 2,
      sym_command_parameter,
      sym_stop_parsing,
    STATE(839), 3,
      sym__command_element,
      sym_redirection,
      aux_sym_command_elements_repeat1,
    ACTIONS(2357), 12,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
    ACTIONS(2326), 15,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
  [38540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(609), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(611), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [38589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(661), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(663), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [38638] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(627), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [38687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(603), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(605), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [38736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(621), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(623), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [38785] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2375), 1,
      anon_sym_SPACE,
    ACTIONS(2378), 1,
      anon_sym_COLON,
    STATE(217), 1,
      sym_command_argument_sep,
    STATE(336), 1,
      aux_sym_command_argument_sep_repeat1,
    STATE(731), 1,
      sym_file_redirection_operator,
    STATE(1063), 1,
      sym__command_argument,
    STATE(1116), 1,
      sym_merging_redirection_operator,
    ACTIONS(2335), 2,
      anon_sym_RPAREN,
      anon_sym_PIPE,
    ACTIONS(2372), 2,
      sym_command_parameter,
      sym_stop_parsing,
    STATE(845), 3,
      sym__command_element,
      sym_redirection,
      aux_sym_command_elements_repeat1,
    ACTIONS(2369), 12,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
    ACTIONS(2326), 15,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
  [38854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(687), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [38903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(689), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(691), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [38952] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2385), 3,
      anon_sym_DASHband,
      anon_sym_DASHbor,
      anon_sym_DASHbxor,
    ACTIONS(2383), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(2381), 30,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
  [39003] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2145), 1,
      anon_sym_SPACE,
    ACTIONS(2147), 1,
      anon_sym_COLON,
    ACTIONS(2298), 1,
      anon_sym_PIPE,
    ACTIONS(2300), 1,
      sym__statement_terminator,
    STATE(218), 1,
      sym_command_argument_sep,
    STATE(320), 1,
      aux_sym_command_argument_sep_repeat1,
    STATE(727), 1,
      sym_file_redirection_operator,
    STATE(1053), 1,
      sym__command_argument,
    STATE(1110), 1,
      sym_merging_redirection_operator,
    ACTIONS(2387), 2,
      sym_command_parameter,
      sym_stop_parsing,
    STATE(839), 3,
      sym__command_element,
      sym_redirection,
      aux_sym_command_elements_repeat1,
    ACTIONS(2282), 12,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
    ACTIONS(2240), 15,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
  [39074] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(687), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [39123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(699), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [39172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(603), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(605), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [39221] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(701), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(703), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [39270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(725), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(727), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [39319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(647), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(649), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [39368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(641), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [39417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(645), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [39466] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2389), 1,
      anon_sym_LBRACK,
    ACTIONS(2391), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2393), 1,
      anon_sym_DASH_DASH,
    ACTIONS(2397), 1,
      anon_sym_DOTforeach,
    ACTIONS(713), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(2395), 2,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
    ACTIONS(715), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [39525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(669), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(671), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [39574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(633), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(635), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [39623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(609), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(611), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [39672] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(665), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(667), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [39721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(599), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(601), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [39770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(709), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(711), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [39819] = 12,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2405), 1,
      anon_sym_PIPE,
    ACTIONS(2407), 1,
      sym__statement_terminator,
    STATE(725), 1,
      sym_file_redirection_operator,
    STATE(1134), 1,
      sym_merging_redirection_operator,
    STATE(1417), 1,
      aux_sym__pipeline_tail,
    STATE(1419), 1,
      sym_redirections,
    STATE(1111), 2,
      sym_redirection,
      aux_sym_redirections_repeat1,
    ACTIONS(2399), 6,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
    ACTIONS(2401), 7,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
    ACTIONS(2240), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(2403), 12,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
  [39886] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(595), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(597), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [39935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(627), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [39984] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2413), 3,
      anon_sym_DASHband,
      anon_sym_DASHbor,
      anon_sym_DASHbxor,
    ACTIONS(2411), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(2409), 30,
      sym__statement_terminator,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_PIPE,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
  [40035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(599), 1,
      anon_sym_SPACE,
    ACTIONS(601), 40,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_path_command_name_token,
      sym_stop_parsing,
      anon_sym_COLON,
  [40084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(599), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(601), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [40133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(599), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(601), 39,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_path_command_name_token,
      sym_stop_parsing,
      anon_sym_COLON,
  [40182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(705), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(707), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [40231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(621), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(623), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [40280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(695), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [40329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(617), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(619), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [40378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(729), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(731), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [40427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(721), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(723), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [40476] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(719), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [40525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(699), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [40574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(665), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(667), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [40623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(715), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [40672] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(661), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(663), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [40721] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2165), 1,
      anon_sym_SPACE,
    ACTIONS(2167), 1,
      anon_sym_COLON,
    STATE(217), 1,
      sym_command_argument_sep,
    STATE(336), 1,
      aux_sym_command_argument_sep_repeat1,
    STATE(731), 1,
      sym_file_redirection_operator,
    STATE(1063), 1,
      sym__command_argument,
    STATE(1116), 1,
      sym_merging_redirection_operator,
    ACTIONS(2298), 2,
      anon_sym_RPAREN,
      anon_sym_PIPE,
    ACTIONS(2415), 2,
      sym_command_parameter,
      sym_stop_parsing,
    STATE(845), 3,
      sym__command_element,
      sym_redirection,
      aux_sym_command_elements_repeat1,
    ACTIONS(2316), 12,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
    ACTIONS(2240), 15,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
  [40790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(669), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(671), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [40839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(695), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [40888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(617), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(619), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [40937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(729), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(731), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [40986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(721), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(723), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [41035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(719), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [41084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(715), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [41133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(681), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(683), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [41182] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 1,
      anon_sym_SPACE,
    ACTIONS(2417), 1,
      anon_sym_LBRACK,
    ACTIONS(2419), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2421), 1,
      anon_sym_DASH_DASH,
    ACTIONS(2425), 1,
      anon_sym_DOTforeach,
    ACTIONS(2423), 2,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
    ACTIONS(715), 34,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [41241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(654), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [41290] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(673), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(675), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [41339] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(641), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [41388] = 12,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_RPAREN,
    ACTIONS(2429), 1,
      anon_sym_PIPE,
    STATE(730), 1,
      sym_file_redirection_operator,
    STATE(1133), 1,
      sym_merging_redirection_operator,
    STATE(1427), 1,
      sym_redirections,
    STATE(1446), 1,
      aux_sym__pipeline_tail,
    STATE(1106), 2,
      sym_redirection,
      aux_sym_redirections_repeat1,
    ACTIONS(2399), 6,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
    ACTIONS(2401), 7,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
    ACTIONS(2240), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(2427), 12,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
  [41455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(613), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(615), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [41504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(659), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [41553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(709), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(711), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [41602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(647), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(649), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [41651] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2385), 3,
      anon_sym_DASHband,
      anon_sym_DASHbor,
      anon_sym_DASHbxor,
    ACTIONS(2411), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(2409), 30,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
  [41702] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(725), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(727), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [41751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(689), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(691), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [41800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(645), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [41849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(677), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(679), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [41898] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 1,
      anon_sym_SPACE,
    ACTIONS(2304), 1,
      anon_sym_LBRACK,
    ACTIONS(2306), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2308), 1,
      anon_sym_DASH_DASH,
    ACTIONS(2312), 1,
      anon_sym_DOTforeach,
    ACTIONS(2431), 2,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
    ACTIONS(715), 34,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [41957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(629), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(631), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [42006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(633), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(635), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [42055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(654), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [42104] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(673), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(675), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [42153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(677), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(679), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [42202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(705), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(707), 39,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [42251] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2286), 1,
      anon_sym_LBRACK,
    ACTIONS(2288), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2290), 1,
      anon_sym_DASH_DASH,
    ACTIONS(2294), 1,
      anon_sym_DOTforeach,
    ACTIONS(713), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(2433), 2,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
    ACTIONS(715), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [42310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(659), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [42359] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2413), 3,
      anon_sym_DASHband,
      anon_sym_DASHbor,
      anon_sym_DASHbxor,
    ACTIONS(2383), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(2381), 30,
      sym__statement_terminator,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_PIPE,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
  [42410] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2286), 1,
      anon_sym_LBRACK,
    ACTIONS(2288), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2290), 1,
      anon_sym_DASH_DASH,
    ACTIONS(2294), 1,
      anon_sym_DOTforeach,
    ACTIONS(2433), 2,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
    ACTIONS(2437), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(2435), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [42468] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2304), 1,
      anon_sym_LBRACK,
    ACTIONS(2306), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2308), 1,
      anon_sym_DASH_DASH,
    ACTIONS(2312), 1,
      anon_sym_DOTforeach,
    ACTIONS(2441), 1,
      anon_sym_SPACE,
    ACTIONS(2431), 2,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
    ACTIONS(2439), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [42526] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2443), 1,
      anon_sym_LPAREN,
    STATE(948), 1,
      sym_argument_list,
    ACTIONS(593), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(591), 29,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [42578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(253), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(251), 38,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [42626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(253), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(251), 37,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [42674] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2286), 1,
      anon_sym_LBRACK,
    ACTIONS(2288), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2290), 1,
      anon_sym_DASH_DASH,
    ACTIONS(2294), 1,
      anon_sym_DOTforeach,
    ACTIONS(2433), 2,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
    ACTIONS(2441), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(2439), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [42732] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2389), 1,
      anon_sym_LBRACK,
    ACTIONS(2391), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2393), 1,
      anon_sym_DASH_DASH,
    ACTIONS(2397), 1,
      anon_sym_DOTforeach,
    ACTIONS(713), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(2445), 2,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
    ACTIONS(715), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [42790] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2304), 1,
      anon_sym_LBRACK,
    ACTIONS(2306), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2308), 1,
      anon_sym_DASH_DASH,
    ACTIONS(2312), 1,
      anon_sym_DOTforeach,
    ACTIONS(2437), 1,
      anon_sym_SPACE,
    ACTIONS(2431), 2,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
    ACTIONS(2435), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [42848] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 1,
      anon_sym_SPACE,
    ACTIONS(2417), 1,
      anon_sym_LBRACK,
    ACTIONS(2419), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2421), 1,
      anon_sym_DASH_DASH,
    ACTIONS(2425), 1,
      anon_sym_DOTforeach,
    ACTIONS(2447), 2,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
    ACTIONS(715), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [42906] = 4,
    ACTIONS(81), 1,
      sym_comment,
    STATE(948), 1,
      sym_argument_list,
    ACTIONS(593), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(591), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [42956] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2453), 1,
      aux_sym_command_name_token2,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE2,
    STATE(935), 1,
      aux_sym_command_name_repeat1,
    ACTIONS(2449), 2,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
    ACTIONS(2451), 34,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_SPACE,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [43009] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(707), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(705), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [43056] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2389), 1,
      anon_sym_LBRACK,
    ACTIONS(2391), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2393), 1,
      anon_sym_DASH_DASH,
    ACTIONS(2397), 1,
      anon_sym_DOTforeach,
    ACTIONS(2437), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(2445), 2,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
    ACTIONS(2435), 31,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [43113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(253), 3,
      sym__statement_terminator,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(251), 36,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [43160] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(687), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(685), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [43207] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(615), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(613), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [43254] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(691), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(689), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [43301] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(719), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(717), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [43348] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(683), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(681), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [43395] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2455), 1,
      anon_sym_DQUOTE2,
    ACTIONS(2461), 1,
      aux_sym_command_name_token2,
    STATE(965), 1,
      aux_sym_command_name_repeat1,
    ACTIONS(2457), 2,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
    ACTIONS(2459), 34,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_SPACE,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [43448] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(641), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(639), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [43495] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(667), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(665), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [43542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(253), 2,
      anon_sym_SPACE,
      anon_sym_DOTforeach,
    ACTIONS(251), 37,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
  [43589] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(699), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(697), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [43636] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(663), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(661), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [43683] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2417), 1,
      anon_sym_LBRACK,
    ACTIONS(2419), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2421), 1,
      anon_sym_DASH_DASH,
    ACTIONS(2425), 1,
      anon_sym_DOTforeach,
    ACTIONS(2437), 1,
      anon_sym_SPACE,
    ACTIONS(2447), 2,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
    ACTIONS(2435), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [43740] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(605), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(603), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [43787] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(671), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(669), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [43834] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(695), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(693), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [43881] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2468), 1,
      aux_sym_command_name_token2,
    ACTIONS(2471), 1,
      anon_sym_DQUOTE2,
    ACTIONS(2474), 1,
      sym__statement_terminator,
    STATE(945), 1,
      aux_sym_command_name_repeat1,
    ACTIONS(2463), 2,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
    ACTIONS(2466), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_SPACE,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [43936] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(623), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(621), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [43983] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2478), 1,
      aux_sym_command_name_token2,
    ACTIONS(2480), 1,
      anon_sym_DQUOTE2,
    ACTIONS(2482), 1,
      sym__statement_terminator,
    STATE(945), 1,
      aux_sym_command_name_repeat1,
    ACTIONS(2476), 2,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
    ACTIONS(2459), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_SPACE,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [44038] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(711), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(709), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [44085] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(659), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(657), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [44132] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(611), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(609), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [44179] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(649), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(647), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [44226] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(715), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(713), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [44273] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(597), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(595), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [44320] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2480), 1,
      anon_sym_DQUOTE2,
    ACTIONS(2486), 1,
      aux_sym_command_name_token2,
    ACTIONS(2488), 1,
      sym__statement_terminator,
    STATE(947), 1,
      aux_sym_command_name_repeat1,
    ACTIONS(2484), 2,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
    ACTIONS(2451), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_SPACE,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [44375] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(703), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(701), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [44422] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(645), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(643), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [44469] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(619), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(617), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [44516] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(727), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(725), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [44563] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(601), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(599), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [44610] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(731), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(729), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [44657] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(723), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(721), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [44704] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2389), 1,
      anon_sym_LBRACK,
    ACTIONS(2391), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2393), 1,
      anon_sym_DASH_DASH,
    ACTIONS(2397), 1,
      anon_sym_DOTforeach,
    ACTIONS(2441), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(2445), 2,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
    ACTIONS(2439), 31,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [44761] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(635), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(633), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [44808] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(654), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(651), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [44855] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2493), 1,
      aux_sym_command_name_token2,
    ACTIONS(2496), 1,
      anon_sym_DQUOTE2,
    STATE(965), 1,
      aux_sym_command_name_repeat1,
    ACTIONS(2490), 2,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
    ACTIONS(2466), 34,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_SPACE,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [44908] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(675), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(673), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [44955] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(679), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(677), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [45002] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(631), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(629), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [45049] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(627), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(625), 30,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [45096] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2417), 1,
      anon_sym_LBRACK,
    ACTIONS(2419), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2421), 1,
      anon_sym_DASH_DASH,
    ACTIONS(2425), 1,
      anon_sym_DOTforeach,
    ACTIONS(2441), 1,
      anon_sym_SPACE,
    ACTIONS(2447), 2,
      anon_sym_DOT2,
      anon_sym_COLON_COLON,
    ACTIONS(2439), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [45153] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2501), 1,
      aux_sym_command_name_token2,
    ACTIONS(2503), 1,
      anon_sym_DQUOTE2,
    STATE(982), 1,
      aux_sym_command_name_repeat1,
    ACTIONS(2499), 2,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
    ACTIONS(2451), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_SPACE,
      anon_sym_COLON,
  [45205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2505), 2,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
    ACTIONS(2507), 36,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      aux_sym_command_name_token2,
      anon_sym_DQUOTE2,
      sym_stop_parsing,
      anon_sym_SPACE,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [45251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2509), 3,
      sym__statement_terminator,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
    ACTIONS(2511), 35,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      aux_sym_command_name_token2,
      anon_sym_DQUOTE2,
      sym_stop_parsing,
      anon_sym_SPACE,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [45297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2509), 2,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
    ACTIONS(2511), 36,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      aux_sym_command_name_token2,
      anon_sym_DQUOTE2,
      sym_stop_parsing,
      anon_sym_SPACE,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [45343] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2513), 1,
      anon_sym_LPAREN,
    STATE(1014), 1,
      sym_argument_list,
    ACTIONS(593), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(591), 27,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [45393] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2488), 1,
      sym__statement_terminator,
    ACTIONS(2517), 1,
      aux_sym_command_name_token2,
    ACTIONS(2519), 1,
      anon_sym_DQUOTE2,
    STATE(981), 1,
      aux_sym_command_name_repeat1,
    ACTIONS(2515), 2,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
    ACTIONS(2451), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_SPACE,
      anon_sym_COLON,
  [45447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2474), 3,
      sym__statement_terminator,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
    ACTIONS(2466), 35,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      aux_sym_command_name_token2,
      anon_sym_DQUOTE2,
      sym_stop_parsing,
      anon_sym_SPACE,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [45493] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2525), 3,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
    ACTIONS(2523), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(2521), 27,
      sym__statement_terminator,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_PIPE,
  [45541] = 4,
    ACTIONS(81), 1,
      sym_comment,
    STATE(1014), 1,
      sym_argument_list,
    ACTIONS(593), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(591), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [45589] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2527), 3,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
    ACTIONS(2523), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(2521), 27,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_RPAREN,
      anon_sym_PIPE,
  [45637] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2482), 1,
      sym__statement_terminator,
    ACTIONS(2519), 1,
      anon_sym_DQUOTE2,
    ACTIONS(2531), 1,
      aux_sym_command_name_token2,
    STATE(985), 1,
      aux_sym_command_name_repeat1,
    ACTIONS(2529), 2,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
    ACTIONS(2459), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_SPACE,
      anon_sym_COLON,
  [45691] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2503), 1,
      anon_sym_DQUOTE2,
    ACTIONS(2535), 1,
      aux_sym_command_name_token2,
    STATE(984), 1,
      aux_sym_command_name_repeat1,
    ACTIONS(2533), 2,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
    ACTIONS(2459), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_SPACE,
      anon_sym_COLON,
  [45743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2474), 2,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
    ACTIONS(2466), 36,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      aux_sym_command_name_token2,
      anon_sym_DQUOTE2,
      sym_stop_parsing,
      anon_sym_SPACE,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [45789] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2540), 1,
      aux_sym_command_name_token2,
    ACTIONS(2543), 1,
      anon_sym_DQUOTE2,
    STATE(984), 1,
      aux_sym_command_name_repeat1,
    ACTIONS(2537), 2,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
    ACTIONS(2466), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_SPACE,
      anon_sym_COLON,
  [45841] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2474), 1,
      sym__statement_terminator,
    ACTIONS(2549), 1,
      aux_sym_command_name_token2,
    ACTIONS(2552), 1,
      anon_sym_DQUOTE2,
    STATE(985), 1,
      aux_sym_command_name_repeat1,
    ACTIONS(2546), 2,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
    ACTIONS(2466), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_SPACE,
      anon_sym_COLON,
  [45895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2505), 3,
      sym__statement_terminator,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
    ACTIONS(2507), 35,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      aux_sym_command_name_token2,
      anon_sym_DQUOTE2,
      sym_stop_parsing,
      anon_sym_SPACE,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [45941] = 9,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2555), 1,
      anon_sym_LBRACK,
    ACTIONS(2557), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2559), 1,
      anon_sym_DASH_DASH,
    ACTIONS(2561), 1,
      anon_sym_DOT2,
    ACTIONS(2563), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2565), 1,
      anon_sym_DOTforeach,
    ACTIONS(715), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(713), 23,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [45998] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(645), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(643), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [46043] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(615), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(613), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [46088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2509), 2,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
    ACTIONS(2511), 35,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      aux_sym_command_name_token2,
      anon_sym_DQUOTE2,
      sym_stop_parsing,
      anon_sym_SPACE,
      anon_sym_COLON,
  [46133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2474), 2,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
    ACTIONS(2466), 35,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      aux_sym_command_name_token2,
      anon_sym_DQUOTE2,
      sym_stop_parsing,
      anon_sym_SPACE,
      anon_sym_COLON,
  [46178] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(635), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(633), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [46223] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(654), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(651), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [46268] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(641), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(639), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [46313] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(675), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(673), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [46358] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(679), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(677), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [46403] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(691), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(689), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [46448] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(251), 9,
      sym_decimal_integer_literal,
      sym_simple_name,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      anon_sym_hidden,
      anon_sym_static,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT2,
    ACTIONS(253), 28,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [46493] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(723), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(721), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [46538] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(731), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(729), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [46583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2505), 2,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
    ACTIONS(2507), 35,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      aux_sym_command_name_token2,
      anon_sym_DQUOTE2,
      sym_stop_parsing,
      anon_sym_SPACE,
      anon_sym_COLON,
  [46628] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(649), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(647), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [46673] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(727), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(725), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [46718] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(663), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(661), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [46763] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(687), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(685), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [46808] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(631), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(629), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [46853] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(659), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(657), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [46898] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(605), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(603), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [46943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2509), 3,
      sym__statement_terminator,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
    ACTIONS(2511), 34,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      aux_sym_command_name_token2,
      anon_sym_DQUOTE2,
      sym_stop_parsing,
      anon_sym_SPACE,
      anon_sym_COLON,
  [46988] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(671), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(669), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [47033] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(597), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(595), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [47078] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(695), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(693), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [47123] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(707), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(705), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [47168] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(711), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(709), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [47213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2505), 3,
      sym__statement_terminator,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
    ACTIONS(2507), 34,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      aux_sym_command_name_token2,
      anon_sym_DQUOTE2,
      sym_stop_parsing,
      anon_sym_SPACE,
      anon_sym_COLON,
  [47258] = 9,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2567), 1,
      anon_sym_LBRACK,
    ACTIONS(2569), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2571), 1,
      anon_sym_DASH_DASH,
    ACTIONS(2573), 1,
      anon_sym_DOT2,
    ACTIONS(2575), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2577), 1,
      anon_sym_DOTforeach,
    ACTIONS(715), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(713), 23,
      sym__statement_terminator,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [47315] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(715), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(713), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [47360] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2474), 3,
      sym__statement_terminator,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
    ACTIONS(2466), 34,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      aux_sym_command_name_token2,
      anon_sym_DQUOTE2,
      sym_stop_parsing,
      anon_sym_SPACE,
      anon_sym_COLON,
  [47405] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(683), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(681), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [47450] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(699), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(697), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [47495] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(703), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(701), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [47540] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(611), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(609), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [47585] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(627), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(625), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [47630] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(623), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(621), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [47675] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(719), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(717), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [47720] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(619), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(617), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [47765] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(667), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(665), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [47810] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(601), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(599), 28,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [47855] = 9,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2555), 1,
      anon_sym_LBRACK,
    ACTIONS(2557), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2559), 1,
      anon_sym_DASH_DASH,
    ACTIONS(2565), 1,
      anon_sym_DOTforeach,
    ACTIONS(2579), 1,
      anon_sym_DOT2,
    ACTIONS(2581), 1,
      anon_sym_COLON_COLON,
    ACTIONS(715), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(713), 22,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [47911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(765), 1,
      anon_sym_SPACE,
    ACTIONS(767), 35,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [47955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(695), 34,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [47999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      anon_sym_SPACE,
    ACTIONS(771), 35,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [48043] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LPAREN,
    ACTIONS(2587), 1,
      anon_sym_SPACE,
    STATE(1085), 1,
      sym_argument_list,
    ACTIONS(2583), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [48091] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2591), 1,
      anon_sym_COMMA,
    ACTIONS(2593), 1,
      anon_sym_SPACE,
    ACTIONS(2589), 34,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [48137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_SPACE,
    ACTIONS(719), 35,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [48181] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(721), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(723), 34,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [48225] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2595), 1,
      anon_sym_COMMA,
    ACTIONS(2593), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(2589), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [48271] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(771), 34,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [48315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(765), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(767), 34,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [48359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(721), 1,
      anon_sym_SPACE,
    ACTIONS(723), 35,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [48403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 1,
      anon_sym_SPACE,
    ACTIONS(715), 35,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [48447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 1,
      anon_sym_SPACE,
    ACTIONS(695), 35,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [48491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(729), 1,
      anon_sym_SPACE,
    ACTIONS(731), 35,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [48535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(617), 1,
      anon_sym_SPACE,
    ACTIONS(619), 35,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [48579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(729), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(731), 34,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [48623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(617), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(619), 34,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [48667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(719), 34,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [48711] = 9,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2567), 1,
      anon_sym_LBRACK,
    ACTIONS(2569), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2571), 1,
      anon_sym_DASH_DASH,
    ACTIONS(2577), 1,
      anon_sym_DOTforeach,
    ACTIONS(2597), 1,
      anon_sym_DOT2,
    ACTIONS(2599), 1,
      anon_sym_COLON_COLON,
    ACTIONS(715), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(713), 22,
      sym__statement_terminator,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [48767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(715), 34,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [48811] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2601), 1,
      anon_sym_LPAREN,
    STATE(1090), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(2583), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [48859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 1,
      anon_sym_SPACE,
    ACTIONS(771), 34,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [48902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(721), 1,
      anon_sym_SPACE,
    ACTIONS(723), 34,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [48945] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2603), 1,
      anon_sym_LPAREN,
    STATE(1118), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(2583), 31,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [48992] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 1,
      anon_sym_SPACE,
    ACTIONS(695), 34,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [49035] = 9,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2567), 1,
      anon_sym_LBRACK,
    ACTIONS(2569), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2571), 1,
      anon_sym_DASH_DASH,
    ACTIONS(2577), 1,
      anon_sym_DOTforeach,
    ACTIONS(2597), 1,
      anon_sym_DOT2,
    ACTIONS(2599), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2439), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(2441), 21,
      sym__statement_terminator,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_PIPE,
  [49090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(695), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [49133] = 9,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2555), 1,
      anon_sym_LBRACK,
    ACTIONS(2557), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2559), 1,
      anon_sym_DASH_DASH,
    ACTIONS(2565), 1,
      anon_sym_DOTforeach,
    ACTIONS(2579), 1,
      anon_sym_DOT2,
    ACTIONS(2581), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2439), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(2441), 21,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_RPAREN,
      anon_sym_PIPE,
  [49188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2593), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(2589), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [49231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_SPACE,
    ACTIONS(719), 34,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [49274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2593), 1,
      anon_sym_SPACE,
    ACTIONS(2589), 34,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [49317] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2605), 1,
      anon_sym_COMMA,
    ACTIONS(2593), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(2589), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [49362] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2593), 1,
      anon_sym_SPACE,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    ACTIONS(2589), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [49407] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2587), 1,
      anon_sym_SPACE,
    ACTIONS(2609), 1,
      anon_sym_LPAREN,
    STATE(1121), 1,
      sym_argument_list,
    ACTIONS(2583), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [49454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(765), 1,
      anon_sym_SPACE,
    ACTIONS(767), 34,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [49497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(729), 1,
      anon_sym_SPACE,
    ACTIONS(731), 34,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [49540] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2593), 1,
      anon_sym_SPACE,
    ACTIONS(2611), 1,
      anon_sym_COMMA,
    ACTIONS(2589), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [49585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(617), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(619), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [49628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(715), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [49671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(729), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(731), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [49714] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(251), 9,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
      anon_sym_DOT2,
    ACTIONS(253), 26,
      sym__statement_terminator,
      anon_sym_LBRACK,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [49757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(721), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(723), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [49800] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2613), 1,
      anon_sym_COMMA,
    ACTIONS(2593), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(2589), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [49845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(719), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [49888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(769), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(771), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [49931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(765), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(767), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [49974] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 1,
      anon_sym_SPACE,
    ACTIONS(715), 34,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [50017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(617), 1,
      anon_sym_SPACE,
    ACTIONS(619), 34,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [50060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(2439), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [50102] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(613), 1,
      anon_sym_SPACE,
    ACTIONS(615), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [50144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_SPACE,
    ACTIONS(659), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [50186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_SPACE,
    ACTIONS(2439), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [50228] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2617), 1,
      anon_sym_SPACE,
    ACTIONS(2615), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [50270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2593), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(2589), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [50312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2593), 1,
      anon_sym_SPACE,
    ACTIONS(2589), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [50354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2621), 1,
      anon_sym_SPACE,
    ACTIONS(2619), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [50396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2625), 1,
      anon_sym_SPACE,
    ACTIONS(2623), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [50438] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2631), 1,
      anon_sym_SEMI,
    STATE(1097), 1,
      aux_sym_script_block_repeat1,
    ACTIONS(2627), 5,
      sym_decimal_integer_literal,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2629), 27,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      sym_simple_name,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [50484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2625), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(2623), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [50526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2635), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(2633), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [50568] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2621), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(2619), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [50610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2437), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(2435), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [50652] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2593), 1,
      anon_sym_SPACE,
    ACTIONS(2637), 1,
      anon_sym_COMMA,
    ACTIONS(2589), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [50696] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2635), 1,
      anon_sym_SPACE,
    ACTIONS(2633), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [50738] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(251), 6,
      sym_decimal_integer_literal,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT2,
    ACTIONS(253), 28,
      sym__statement_terminator,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DOTforeach,
  [50780] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2639), 1,
      anon_sym_COMMA,
    ACTIONS(2593), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(2589), 31,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [50824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2617), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(2615), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [50866] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2643), 1,
      anon_sym_SEMI,
    STATE(1097), 1,
      aux_sym_script_block_repeat1,
    ACTIONS(1387), 5,
      sym_decimal_integer_literal,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2641), 27,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      sym_simple_name,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [50912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(613), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(615), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [50954] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2650), 1,
      anon_sym_SEMI,
    STATE(1087), 1,
      aux_sym_script_block_repeat1,
    ACTIONS(2646), 5,
      sym_decimal_integer_literal,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2648), 27,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      sym_simple_name,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [51000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(659), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [51042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2437), 1,
      anon_sym_SPACE,
    ACTIONS(2435), 33,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
      anon_sym_DASH_DASH_PERCENT,
  [51084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(613), 1,
      anon_sym_SPACE,
    ACTIONS(615), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [51125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2635), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(2633), 31,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [51166] = 8,
    ACTIONS(81), 1,
      sym_comment,
    STATE(725), 1,
      sym_file_redirection_operator,
    STATE(1134), 1,
      sym_merging_redirection_operator,
    ACTIONS(2661), 2,
      sym__statement_terminator,
      anon_sym_PIPE,
    STATE(1104), 2,
      sym_redirection,
      aux_sym_redirections_repeat1,
    ACTIONS(2655), 7,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
    ACTIONS(2652), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(2658), 12,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
  [51217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2617), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(2615), 31,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [51258] = 8,
    ACTIONS(81), 1,
      sym_comment,
    STATE(730), 1,
      sym_file_redirection_operator,
    STATE(1133), 1,
      sym_merging_redirection_operator,
    ACTIONS(2663), 2,
      anon_sym_RPAREN,
      anon_sym_PIPE,
    STATE(1119), 2,
      sym_redirection,
      aux_sym_redirections_repeat1,
    ACTIONS(2401), 7,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
    ACTIONS(2240), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(2427), 12,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
  [51309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(659), 31,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [51350] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2437), 1,
      anon_sym_SPACE,
    ACTIONS(2435), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [51391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2437), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(2435), 31,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [51432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2625), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(2623), 31,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [51473] = 8,
    ACTIONS(81), 1,
      sym_comment,
    STATE(725), 1,
      sym_file_redirection_operator,
    STATE(1134), 1,
      sym_merging_redirection_operator,
    ACTIONS(2663), 2,
      sym__statement_terminator,
      anon_sym_PIPE,
    STATE(1104), 2,
      sym_redirection,
      aux_sym_redirections_repeat1,
    ACTIONS(2401), 7,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
    ACTIONS(2240), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(2403), 12,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
  [51524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(2439), 31,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [51565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2617), 1,
      anon_sym_SPACE,
    ACTIONS(2615), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [51606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2635), 1,
      anon_sym_SPACE,
    ACTIONS(2633), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [51647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_SPACE,
    ACTIONS(2439), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [51688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2625), 1,
      anon_sym_SPACE,
    ACTIONS(2623), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [51729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(613), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(615), 31,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [51770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2621), 2,
      sym__statement_terminator,
      anon_sym_SPACE,
    ACTIONS(2619), 31,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [51811] = 8,
    ACTIONS(81), 1,
      sym_comment,
    STATE(730), 1,
      sym_file_redirection_operator,
    STATE(1133), 1,
      sym_merging_redirection_operator,
    ACTIONS(2661), 2,
      anon_sym_RPAREN,
      anon_sym_PIPE,
    STATE(1119), 2,
      sym_redirection,
      aux_sym_redirections_repeat1,
    ACTIONS(2655), 7,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
    ACTIONS(2652), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(2665), 12,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
  [51862] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_SPACE,
    ACTIONS(659), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [51903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2621), 1,
      anon_sym_SPACE,
    ACTIONS(2619), 32,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_2_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_LT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      sym_command_parameter,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      sym_stop_parsing,
      anon_sym_COLON,
  [51944] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_COMMA,
    ACTIONS(2589), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(2593), 21,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_RPAREN,
      anon_sym_PIPE,
  [51984] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2670), 5,
      sym_decimal_integer_literal,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2672), 25,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_LBRACK,
      anon_sym_DASHjoin,
      anon_sym_DASHsplit,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_DASHnot,
      anon_sym_BANG,
      anon_sym_DASHbnot,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [52022] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_COMMA,
    ACTIONS(2589), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(2593), 21,
      sym__statement_terminator,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_PIPE,
  [52062] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2633), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(2635), 21,
      sym__statement_terminator,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_PIPE,
  [52099] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2589), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(2593), 21,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_RPAREN,
      anon_sym_PIPE,
  [52136] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2615), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(2617), 21,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_RPAREN,
      anon_sym_PIPE,
  [52173] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2439), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(2441), 21,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_RPAREN,
      anon_sym_PIPE,
  [52210] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2589), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(2593), 21,
      sym__statement_terminator,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_PIPE,
  [52247] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2615), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(2617), 21,
      sym__statement_terminator,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_PIPE,
  [52284] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2439), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(2441), 21,
      sym__statement_terminator,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_PIPE,
  [52321] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2633), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(2635), 21,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_RPAREN,
      anon_sym_PIPE,
  [52358] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2623), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(2625), 21,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_RPAREN,
      anon_sym_PIPE,
  [52395] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2623), 8,
      anon_sym_GT,
      anon_sym_2_GT,
      anon_sym_3_GT,
      anon_sym_4_GT,
      anon_sym_5_GT,
      anon_sym_6_GT,
      anon_sym_STAR_GT,
      anon_sym_LT,
    ACTIONS(2625), 21,
      sym__statement_terminator,
      anon_sym_GT_GT,
      anon_sym_2_GT_GT,
      anon_sym_3_GT_GT,
      anon_sym_4_GT_GT,
      anon_sym_5_GT_GT,
      anon_sym_6_GT_GT,
      anon_sym_STAR_GT_GT,
      anon_sym_STAR_GT_AMP1,
      anon_sym_2_GT_AMP1,
      anon_sym_3_GT_AMP1,
      anon_sym_4_GT_AMP1,
      anon_sym_5_GT_AMP1,
      anon_sym_6_GT_AMP1,
      anon_sym_STAR_GT_AMP2,
      anon_sym_1_GT_AMP2,
      anon_sym_3_GT_AMP2,
      anon_sym_4_GT_AMP2,
      anon_sym_5_GT_AMP2,
      anon_sym_6_GT_AMP2,
      anon_sym_PIPE,
  [52432] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_SEMI,
    STATE(1137), 1,
      aux_sym_script_block_repeat1,
    ACTIONS(2676), 22,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      sym__command_token,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [52466] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2680), 1,
      anon_sym_SEMI,
    STATE(1136), 1,
      aux_sym_script_block_repeat1,
    ACTIONS(1387), 22,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      sym__command_token,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [52500] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2685), 1,
      anon_sym_SEMI,
    STATE(1136), 1,
      aux_sym_script_block_repeat1,
    ACTIONS(2683), 22,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      sym__command_token,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [52534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_SPACE,
    ACTIONS(2687), 21,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [52564] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 22,
      sym_decimal_integer_literal,
      sym_hexadecimal_integer_literal,
      sym_real_literal,
      aux_sym_expandable_string_literal_token1,
      aux_sym_expandable_here_string_literal_token1,
      sym_verbatim_string_characters,
      sym_verbatim_here_string_characters,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      aux_sym_command_name_token1,
      sym_path_command_name_token,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACE,
  [52592] = 13,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2693), 1,
      sym_simple_name,
    ACTIONS(2695), 1,
      anon_sym_LBRACK,
    ACTIONS(2697), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_attribute,
    STATE(1245), 1,
      sym_type_literal,
    STATE(1532), 1,
      sym_variable,
    STATE(2087), 1,
      sym_class_property_definition,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(2699), 2,
      anon_sym_hidden,
      anon_sym_static,
    STATE(1141), 2,
      sym_class_method_definition,
      aux_sym_class_statement_repeat2,
    STATE(1221), 2,
      sym_class_attribute,
      aux_sym_class_property_definition_repeat1,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [52640] = 13,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2693), 1,
      sym_simple_name,
    ACTIONS(2695), 1,
      anon_sym_LBRACK,
    ACTIONS(2701), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_attribute,
    STATE(1245), 1,
      sym_type_literal,
    STATE(1532), 1,
      sym_variable,
    STATE(2087), 1,
      sym_class_property_definition,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(2699), 2,
      anon_sym_hidden,
      anon_sym_static,
    STATE(1156), 2,
      sym_class_method_definition,
      aux_sym_class_statement_repeat2,
    STATE(1221), 2,
      sym_class_attribute,
      aux_sym_class_property_definition_repeat1,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [52688] = 13,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2693), 1,
      sym_simple_name,
    ACTIONS(2695), 1,
      anon_sym_LBRACK,
    ACTIONS(2703), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_attribute,
    STATE(1245), 1,
      sym_type_literal,
    STATE(1532), 1,
      sym_variable,
    STATE(2087), 1,
      sym_class_property_definition,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(2699), 2,
      anon_sym_hidden,
      anon_sym_static,
    STATE(1156), 2,
      sym_class_method_definition,
      aux_sym_class_statement_repeat2,
    STATE(1221), 2,
      sym_class_attribute,
      aux_sym_class_property_definition_repeat1,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [52736] = 13,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2693), 1,
      sym_simple_name,
    ACTIONS(2695), 1,
      anon_sym_LBRACK,
    ACTIONS(2705), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_attribute,
    STATE(1245), 1,
      sym_type_literal,
    STATE(1532), 1,
      sym_variable,
    STATE(2087), 1,
      sym_class_property_definition,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(2699), 2,
      anon_sym_hidden,
      anon_sym_static,
    STATE(1142), 2,
      sym_class_method_definition,
      aux_sym_class_statement_repeat2,
    STATE(1221), 2,
      sym_class_attribute,
      aux_sym_class_property_definition_repeat1,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [52784] = 13,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2693), 1,
      sym_simple_name,
    ACTIONS(2695), 1,
      anon_sym_LBRACK,
    ACTIONS(2707), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_attribute,
    STATE(1245), 1,
      sym_type_literal,
    STATE(1532), 1,
      sym_variable,
    STATE(2087), 1,
      sym_class_property_definition,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(2699), 2,
      anon_sym_hidden,
      anon_sym_static,
    STATE(1145), 2,
      sym_class_method_definition,
      aux_sym_class_statement_repeat2,
    STATE(1221), 2,
      sym_class_attribute,
      aux_sym_class_property_definition_repeat1,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [52832] = 13,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2693), 1,
      sym_simple_name,
    ACTIONS(2695), 1,
      anon_sym_LBRACK,
    ACTIONS(2709), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_attribute,
    STATE(1245), 1,
      sym_type_literal,
    STATE(1532), 1,
      sym_variable,
    STATE(2087), 1,
      sym_class_property_definition,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(2699), 2,
      anon_sym_hidden,
      anon_sym_static,
    STATE(1156), 2,
      sym_class_method_definition,
      aux_sym_class_statement_repeat2,
    STATE(1221), 2,
      sym_class_attribute,
      aux_sym_class_property_definition_repeat1,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [52880] = 13,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2693), 1,
      sym_simple_name,
    ACTIONS(2695), 1,
      anon_sym_LBRACK,
    ACTIONS(2711), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_attribute,
    STATE(1245), 1,
      sym_type_literal,
    STATE(1532), 1,
      sym_variable,
    STATE(2087), 1,
      sym_class_property_definition,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(2699), 2,
      anon_sym_hidden,
      anon_sym_static,
    STATE(1149), 2,
      sym_class_method_definition,
      aux_sym_class_statement_repeat2,
    STATE(1221), 2,
      sym_class_attribute,
      aux_sym_class_property_definition_repeat1,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [52928] = 13,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2693), 1,
      sym_simple_name,
    ACTIONS(2695), 1,
      anon_sym_LBRACK,
    ACTIONS(2709), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_attribute,
    STATE(1245), 1,
      sym_type_literal,
    STATE(1532), 1,
      sym_variable,
    STATE(2087), 1,
      sym_class_property_definition,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(2699), 2,
      anon_sym_hidden,
      anon_sym_static,
    STATE(1150), 2,
      sym_class_method_definition,
      aux_sym_class_statement_repeat2,
    STATE(1221), 2,
      sym_class_attribute,
      aux_sym_class_property_definition_repeat1,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [52976] = 13,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2693), 1,
      sym_simple_name,
    ACTIONS(2695), 1,
      anon_sym_LBRACK,
    ACTIONS(2713), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_attribute,
    STATE(1245), 1,
      sym_type_literal,
    STATE(1532), 1,
      sym_variable,
    STATE(2087), 1,
      sym_class_property_definition,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(2699), 2,
      anon_sym_hidden,
      anon_sym_static,
    STATE(1153), 2,
      sym_class_method_definition,
      aux_sym_class_statement_repeat2,
    STATE(1221), 2,
      sym_class_attribute,
      aux_sym_class_property_definition_repeat1,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [53024] = 13,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2693), 1,
      sym_simple_name,
    ACTIONS(2695), 1,
      anon_sym_LBRACK,
    ACTIONS(2715), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_attribute,
    STATE(1245), 1,
      sym_type_literal,
    STATE(1532), 1,
      sym_variable,
    STATE(2087), 1,
      sym_class_property_definition,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(2699), 2,
      anon_sym_hidden,
      anon_sym_static,
    STATE(1156), 2,
      sym_class_method_definition,
      aux_sym_class_statement_repeat2,
    STATE(1221), 2,
      sym_class_attribute,
      aux_sym_class_property_definition_repeat1,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [53072] = 13,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2693), 1,
      sym_simple_name,
    ACTIONS(2695), 1,
      anon_sym_LBRACK,
    ACTIONS(2717), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_attribute,
    STATE(1245), 1,
      sym_type_literal,
    STATE(1532), 1,
      sym_variable,
    STATE(2087), 1,
      sym_class_property_definition,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(2699), 2,
      anon_sym_hidden,
      anon_sym_static,
    STATE(1156), 2,
      sym_class_method_definition,
      aux_sym_class_statement_repeat2,
    STATE(1221), 2,
      sym_class_attribute,
      aux_sym_class_property_definition_repeat1,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [53120] = 13,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2693), 1,
      sym_simple_name,
    ACTIONS(2695), 1,
      anon_sym_LBRACK,
    ACTIONS(2715), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_attribute,
    STATE(1245), 1,
      sym_type_literal,
    STATE(1532), 1,
      sym_variable,
    STATE(2087), 1,
      sym_class_property_definition,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(2699), 2,
      anon_sym_hidden,
      anon_sym_static,
    STATE(1152), 2,
      sym_class_method_definition,
      aux_sym_class_statement_repeat2,
    STATE(1221), 2,
      sym_class_attribute,
      aux_sym_class_property_definition_repeat1,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [53168] = 13,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2693), 1,
      sym_simple_name,
    ACTIONS(2695), 1,
      anon_sym_LBRACK,
    ACTIONS(2719), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_attribute,
    STATE(1245), 1,
      sym_type_literal,
    STATE(1532), 1,
      sym_variable,
    STATE(2087), 1,
      sym_class_property_definition,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(2699), 2,
      anon_sym_hidden,
      anon_sym_static,
    STATE(1156), 2,
      sym_class_method_definition,
      aux_sym_class_statement_repeat2,
    STATE(1221), 2,
      sym_class_attribute,
      aux_sym_class_property_definition_repeat1,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [53216] = 13,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2693), 1,
      sym_simple_name,
    ACTIONS(2695), 1,
      anon_sym_LBRACK,
    ACTIONS(2721), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_attribute,
    STATE(1245), 1,
      sym_type_literal,
    STATE(1532), 1,
      sym_variable,
    STATE(2087), 1,
      sym_class_property_definition,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(2699), 2,
      anon_sym_hidden,
      anon_sym_static,
    STATE(1156), 2,
      sym_class_method_definition,
      aux_sym_class_statement_repeat2,
    STATE(1221), 2,
      sym_class_attribute,
      aux_sym_class_property_definition_repeat1,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [53264] = 13,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2693), 1,
      sym_simple_name,
    ACTIONS(2695), 1,
      anon_sym_LBRACK,
    ACTIONS(2723), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_attribute,
    STATE(1245), 1,
      sym_type_literal,
    STATE(1532), 1,
      sym_variable,
    STATE(2087), 1,
      sym_class_property_definition,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(2699), 2,
      anon_sym_hidden,
      anon_sym_static,
    STATE(1164), 2,
      sym_class_method_definition,
      aux_sym_class_statement_repeat2,
    STATE(1221), 2,
      sym_class_attribute,
      aux_sym_class_property_definition_repeat1,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [53312] = 13,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2693), 1,
      sym_simple_name,
    ACTIONS(2695), 1,
      anon_sym_LBRACK,
    ACTIONS(2725), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_attribute,
    STATE(1245), 1,
      sym_type_literal,
    STATE(1532), 1,
      sym_variable,
    STATE(2087), 1,
      sym_class_property_definition,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(2699), 2,
      anon_sym_hidden,
      anon_sym_static,
    STATE(1162), 2,
      sym_class_method_definition,
      aux_sym_class_statement_repeat2,
    STATE(1221), 2,
      sym_class_attribute,
      aux_sym_class_property_definition_repeat1,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [53360] = 13,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2727), 1,
      sym_simple_name,
    ACTIONS(2730), 1,
      anon_sym_LBRACK,
    ACTIONS(2739), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_attribute,
    STATE(1245), 1,
      sym_type_literal,
    STATE(1532), 1,
      sym_variable,
    STATE(2087), 1,
      sym_class_property_definition,
    ACTIONS(2736), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(2741), 2,
      anon_sym_hidden,
      anon_sym_static,
    STATE(1156), 2,
      sym_class_method_definition,
      aux_sym_class_statement_repeat2,
    STATE(1221), 2,
      sym_class_attribute,
      aux_sym_class_property_definition_repeat1,
    ACTIONS(2733), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [53408] = 13,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2693), 1,
      sym_simple_name,
    ACTIONS(2695), 1,
      anon_sym_LBRACK,
    ACTIONS(2744), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_attribute,
    STATE(1245), 1,
      sym_type_literal,
    STATE(1532), 1,
      sym_variable,
    STATE(2087), 1,
      sym_class_property_definition,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(2699), 2,
      anon_sym_hidden,
      anon_sym_static,
    STATE(1156), 2,
      sym_class_method_definition,
      aux_sym_class_statement_repeat2,
    STATE(1221), 2,
      sym_class_attribute,
      aux_sym_class_property_definition_repeat1,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [53456] = 13,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2693), 1,
      sym_simple_name,
    ACTIONS(2695), 1,
      anon_sym_LBRACK,
    ACTIONS(2746), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_attribute,
    STATE(1245), 1,
      sym_type_literal,
    STATE(1532), 1,
      sym_variable,
    STATE(2087), 1,
      sym_class_property_definition,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(2699), 2,
      anon_sym_hidden,
      anon_sym_static,
    STATE(1157), 2,
      sym_class_method_definition,
      aux_sym_class_statement_repeat2,
    STATE(1221), 2,
      sym_class_attribute,
      aux_sym_class_property_definition_repeat1,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [53504] = 13,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2693), 1,
      sym_simple_name,
    ACTIONS(2695), 1,
      anon_sym_LBRACK,
    ACTIONS(2746), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_attribute,
    STATE(1245), 1,
      sym_type_literal,
    STATE(1532), 1,
      sym_variable,
    STATE(2087), 1,
      sym_class_property_definition,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(2699), 2,
      anon_sym_hidden,
      anon_sym_static,
    STATE(1156), 2,
      sym_class_method_definition,
      aux_sym_class_statement_repeat2,
    STATE(1221), 2,
      sym_class_attribute,
      aux_sym_class_property_definition_repeat1,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [53552] = 13,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2693), 1,
      sym_simple_name,
    ACTIONS(2695), 1,
      anon_sym_LBRACK,
    ACTIONS(2748), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_attribute,
    STATE(1245), 1,
      sym_type_literal,
    STATE(1532), 1,
      sym_variable,
    STATE(2087), 1,
      sym_class_property_definition,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(2699), 2,
      anon_sym_hidden,
      anon_sym_static,
    STATE(1159), 2,
      sym_class_method_definition,
      aux_sym_class_statement_repeat2,
    STATE(1221), 2,
      sym_class_attribute,
      aux_sym_class_property_definition_repeat1,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [53600] = 13,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2693), 1,
      sym_simple_name,
    ACTIONS(2695), 1,
      anon_sym_LBRACK,
    ACTIONS(2750), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_attribute,
    STATE(1245), 1,
      sym_type_literal,
    STATE(1532), 1,
      sym_variable,
    STATE(2087), 1,
      sym_class_property_definition,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(2699), 2,
      anon_sym_hidden,
      anon_sym_static,
    STATE(1156), 2,
      sym_class_method_definition,
      aux_sym_class_statement_repeat2,
    STATE(1221), 2,
      sym_class_attribute,
      aux_sym_class_property_definition_repeat1,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [53648] = 13,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2693), 1,
      sym_simple_name,
    ACTIONS(2695), 1,
      anon_sym_LBRACK,
    ACTIONS(2713), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_attribute,
    STATE(1245), 1,
      sym_type_literal,
    STATE(1532), 1,
      sym_variable,
    STATE(2087), 1,
      sym_class_property_definition,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(2699), 2,
      anon_sym_hidden,
      anon_sym_static,
    STATE(1156), 2,
      sym_class_method_definition,
      aux_sym_class_statement_repeat2,
    STATE(1221), 2,
      sym_class_attribute,
      aux_sym_class_property_definition_repeat1,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [53696] = 13,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2693), 1,
      sym_simple_name,
    ACTIONS(2695), 1,
      anon_sym_LBRACK,
    ACTIONS(2752), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_attribute,
    STATE(1245), 1,
      sym_type_literal,
    STATE(1532), 1,
      sym_variable,
    STATE(2087), 1,
      sym_class_property_definition,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(2699), 2,
      anon_sym_hidden,
      anon_sym_static,
    STATE(1161), 2,
      sym_class_method_definition,
      aux_sym_class_statement_repeat2,
    STATE(1221), 2,
      sym_class_attribute,
      aux_sym_class_property_definition_repeat1,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [53744] = 13,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2693), 1,
      sym_simple_name,
    ACTIONS(2695), 1,
      anon_sym_LBRACK,
    ACTIONS(2754), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_attribute,
    STATE(1245), 1,
      sym_type_literal,
    STATE(1532), 1,
      sym_variable,
    STATE(2087), 1,
      sym_class_property_definition,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(2699), 2,
      anon_sym_hidden,
      anon_sym_static,
    STATE(1156), 2,
      sym_class_method_definition,
      aux_sym_class_statement_repeat2,
    STATE(1221), 2,
      sym_class_attribute,
      aux_sym_class_property_definition_repeat1,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [53792] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DOLLAR2,
    ACTIONS(2762), 1,
      anon_sym_DQUOTE,
    ACTIONS(2764), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(977), 1,
      sym__expandable_string_literal_immediate,
    STATE(1516), 1,
      aux_sym__expandable_string_literal_immediate_repeat2,
    STATE(1182), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym__expandable_string_literal_immediate_repeat1,
    ACTIONS(2758), 4,
      aux_sym__expandable_string_literal_immediate_token1,
      aux_sym__expandable_string_literal_immediate_token2,
      aux_sym__expandable_string_literal_immediate_token3,
      anon_sym_DQUOTE_DQUOTE2,
    ACTIONS(2756), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [53831] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2764), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2768), 1,
      anon_sym_DOLLAR2,
    ACTIONS(2770), 1,
      anon_sym_DQUOTE,
    STATE(1323), 1,
      sym__expandable_string_literal_immediate,
    STATE(1514), 1,
      aux_sym__expandable_string_literal_immediate_repeat2,
    STATE(1179), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym__expandable_string_literal_immediate_repeat1,
    ACTIONS(2766), 4,
      aux_sym__expandable_string_literal_immediate_token1,
      aux_sym__expandable_string_literal_immediate_token2,
      aux_sym__expandable_string_literal_immediate_token3,
      anon_sym_DQUOTE_DQUOTE2,
    ACTIONS(2756), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [53870] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2764), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2774), 1,
      anon_sym_DOLLAR2,
    ACTIONS(2776), 1,
      anon_sym_DQUOTE,
    STATE(983), 1,
      sym__expandable_string_literal_immediate,
    STATE(1410), 1,
      aux_sym__expandable_string_literal_immediate_repeat2,
    STATE(1175), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym__expandable_string_literal_immediate_repeat1,
    ACTIONS(2772), 4,
      aux_sym__expandable_string_literal_immediate_token1,
      aux_sym__expandable_string_literal_immediate_token2,
      aux_sym__expandable_string_literal_immediate_token3,
      anon_sym_DQUOTE_DQUOTE2,
    ACTIONS(2756), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [53909] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2764), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2780), 1,
      anon_sym_DOLLAR2,
    ACTIONS(2782), 1,
      anon_sym_DQUOTE,
    STATE(1018), 1,
      sym__expandable_string_literal_immediate,
    STATE(1496), 1,
      aux_sym__expandable_string_literal_immediate_repeat2,
    STATE(1187), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym__expandable_string_literal_immediate_repeat1,
    ACTIONS(2778), 4,
      aux_sym__expandable_string_literal_immediate_token1,
      aux_sym__expandable_string_literal_immediate_token2,
      aux_sym__expandable_string_literal_immediate_token3,
      anon_sym_DQUOTE_DQUOTE2,
    ACTIONS(2756), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [53948] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2764), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2786), 1,
      anon_sym_DOLLAR2,
    ACTIONS(2788), 1,
      anon_sym_DQUOTE,
    STATE(991), 1,
      sym__expandable_string_literal_immediate,
    STATE(1426), 1,
      aux_sym__expandable_string_literal_immediate_repeat2,
    STATE(1171), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym__expandable_string_literal_immediate_repeat1,
    ACTIONS(2784), 4,
      aux_sym__expandable_string_literal_immediate_token1,
      aux_sym__expandable_string_literal_immediate_token2,
      aux_sym__expandable_string_literal_immediate_token3,
      anon_sym_DQUOTE_DQUOTE2,
    ACTIONS(2756), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [53987] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2790), 1,
      aux_sym_expandable_string_literal_token2,
    ACTIONS(2794), 1,
      anon_sym_DOLLAR,
    ACTIONS(2796), 1,
      aux_sym_expandable_string_literal_token5,
    ACTIONS(2800), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(1437), 1,
      aux_sym_expandable_string_literal_repeat2,
    ACTIONS(2792), 3,
      aux_sym_expandable_string_literal_token3,
      aux_sym_expandable_string_literal_token4,
      anon_sym_DQUOTE_DQUOTE,
    STATE(1180), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_string_literal_repeat1,
    ACTIONS(2798), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [54025] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2764), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_DOLLAR2,
    ACTIONS(2806), 1,
      anon_sym_DQUOTE,
    STATE(1421), 1,
      aux_sym__expandable_string_literal_immediate_repeat2,
    STATE(1204), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym__expandable_string_literal_immediate_repeat1,
    ACTIONS(2802), 4,
      aux_sym__expandable_string_literal_immediate_token1,
      aux_sym__expandable_string_literal_immediate_token2,
      aux_sym__expandable_string_literal_immediate_token3,
      anon_sym_DQUOTE_DQUOTE2,
    ACTIONS(2756), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [54061] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_DOLLAR,
    ACTIONS(2800), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2808), 1,
      aux_sym_expandable_string_literal_token2,
    ACTIONS(2812), 1,
      aux_sym_expandable_string_literal_token5,
    STATE(1509), 1,
      aux_sym_expandable_string_literal_repeat2,
    ACTIONS(2810), 3,
      aux_sym_expandable_string_literal_token3,
      aux_sym_expandable_string_literal_token4,
      anon_sym_DQUOTE_DQUOTE,
    STATE(1203), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_string_literal_repeat1,
    ACTIONS(2798), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [54099] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_DOLLAR,
    ACTIONS(2800), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2808), 1,
      aux_sym_expandable_string_literal_token2,
    ACTIONS(2814), 1,
      aux_sym_expandable_string_literal_token5,
    STATE(1477), 1,
      aux_sym_expandable_string_literal_repeat2,
    ACTIONS(2810), 3,
      aux_sym_expandable_string_literal_token3,
      aux_sym_expandable_string_literal_token4,
      anon_sym_DQUOTE_DQUOTE,
    STATE(1203), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_string_literal_repeat1,
    ACTIONS(2798), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [54137] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_DOLLAR,
    ACTIONS(2800), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2808), 1,
      aux_sym_expandable_string_literal_token2,
    ACTIONS(2816), 1,
      aux_sym_expandable_string_literal_token5,
    STATE(1444), 1,
      aux_sym_expandable_string_literal_repeat2,
    ACTIONS(2810), 3,
      aux_sym_expandable_string_literal_token3,
      aux_sym_expandable_string_literal_token4,
      anon_sym_DQUOTE_DQUOTE,
    STATE(1203), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_string_literal_repeat1,
    ACTIONS(2798), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [54175] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2764), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2818), 1,
      anon_sym_DOLLAR2,
    ACTIONS(2820), 1,
      anon_sym_DQUOTE,
    STATE(1423), 1,
      aux_sym__expandable_string_literal_immediate_repeat2,
    STATE(1204), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym__expandable_string_literal_immediate_repeat1,
    ACTIONS(2802), 4,
      aux_sym__expandable_string_literal_immediate_token1,
      aux_sym__expandable_string_literal_immediate_token2,
      aux_sym__expandable_string_literal_immediate_token3,
      anon_sym_DQUOTE_DQUOTE2,
    ACTIONS(2756), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [54211] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_DOLLAR,
    ACTIONS(2800), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2822), 1,
      aux_sym_expandable_string_literal_token2,
    ACTIONS(2826), 1,
      aux_sym_expandable_string_literal_token5,
    STATE(1480), 1,
      aux_sym_expandable_string_literal_repeat2,
    ACTIONS(2824), 3,
      aux_sym_expandable_string_literal_token3,
      aux_sym_expandable_string_literal_token4,
      anon_sym_DQUOTE_DQUOTE,
    STATE(1177), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_string_literal_repeat1,
    ACTIONS(2798), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [54249] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_DOLLAR,
    ACTIONS(2800), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2808), 1,
      aux_sym_expandable_string_literal_token2,
    ACTIONS(2828), 1,
      aux_sym_expandable_string_literal_token5,
    STATE(1504), 1,
      aux_sym_expandable_string_literal_repeat2,
    ACTIONS(2810), 3,
      aux_sym_expandable_string_literal_token3,
      aux_sym_expandable_string_literal_token4,
      anon_sym_DQUOTE_DQUOTE,
    STATE(1203), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_string_literal_repeat1,
    ACTIONS(2798), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [54287] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_DOLLAR,
    ACTIONS(2800), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2830), 1,
      aux_sym_expandable_string_literal_token2,
    ACTIONS(2834), 1,
      aux_sym_expandable_string_literal_token5,
    STATE(1506), 1,
      aux_sym_expandable_string_literal_repeat2,
    ACTIONS(2832), 3,
      aux_sym_expandable_string_literal_token3,
      aux_sym_expandable_string_literal_token4,
      anon_sym_DQUOTE_DQUOTE,
    STATE(1173), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_string_literal_repeat1,
    ACTIONS(2798), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [54325] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2764), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2836), 1,
      anon_sym_DOLLAR2,
    ACTIONS(2838), 1,
      anon_sym_DQUOTE,
    STATE(1448), 1,
      aux_sym__expandable_string_literal_immediate_repeat2,
    STATE(1204), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym__expandable_string_literal_immediate_repeat1,
    ACTIONS(2802), 4,
      aux_sym__expandable_string_literal_immediate_token1,
      aux_sym__expandable_string_literal_immediate_token2,
      aux_sym__expandable_string_literal_immediate_token3,
      anon_sym_DQUOTE_DQUOTE2,
    ACTIONS(2756), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [54361] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_DOLLAR,
    ACTIONS(2800), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2808), 1,
      aux_sym_expandable_string_literal_token2,
    ACTIONS(2840), 1,
      aux_sym_expandable_string_literal_token5,
    STATE(1430), 1,
      aux_sym_expandable_string_literal_repeat2,
    ACTIONS(2810), 3,
      aux_sym_expandable_string_literal_token3,
      aux_sym_expandable_string_literal_token4,
      anon_sym_DQUOTE_DQUOTE,
    STATE(1203), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_string_literal_repeat1,
    ACTIONS(2798), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [54399] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_DOLLAR,
    ACTIONS(2800), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2842), 1,
      aux_sym_expandable_string_literal_token2,
    ACTIONS(2846), 1,
      aux_sym_expandable_string_literal_token5,
    STATE(1505), 1,
      aux_sym_expandable_string_literal_repeat2,
    ACTIONS(2844), 3,
      aux_sym_expandable_string_literal_token3,
      aux_sym_expandable_string_literal_token4,
      anon_sym_DQUOTE_DQUOTE,
    STATE(1189), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_string_literal_repeat1,
    ACTIONS(2798), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [54437] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2764), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2848), 1,
      anon_sym_DOLLAR2,
    ACTIONS(2850), 1,
      anon_sym_DQUOTE,
    STATE(1511), 1,
      aux_sym__expandable_string_literal_immediate_repeat2,
    STATE(1204), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym__expandable_string_literal_immediate_repeat1,
    ACTIONS(2802), 4,
      aux_sym__expandable_string_literal_immediate_token1,
      aux_sym__expandable_string_literal_immediate_token2,
      aux_sym__expandable_string_literal_immediate_token3,
      anon_sym_DQUOTE_DQUOTE2,
    ACTIONS(2756), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [54473] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_DOLLAR,
    ACTIONS(2800), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2852), 1,
      aux_sym_expandable_string_literal_token2,
    ACTIONS(2856), 1,
      aux_sym_expandable_string_literal_token5,
    STATE(1439), 1,
      aux_sym_expandable_string_literal_repeat2,
    ACTIONS(2854), 3,
      aux_sym_expandable_string_literal_token3,
      aux_sym_expandable_string_literal_token4,
      anon_sym_DQUOTE_DQUOTE,
    STATE(1188), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_string_literal_repeat1,
    ACTIONS(2798), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [54511] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_DOLLAR,
    ACTIONS(2800), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2858), 1,
      aux_sym_expandable_string_literal_token2,
    ACTIONS(2862), 1,
      aux_sym_expandable_string_literal_token5,
    STATE(1431), 1,
      aux_sym_expandable_string_literal_repeat2,
    ACTIONS(2860), 3,
      aux_sym_expandable_string_literal_token3,
      aux_sym_expandable_string_literal_token4,
      anon_sym_DQUOTE_DQUOTE,
    STATE(1186), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_string_literal_repeat1,
    ACTIONS(2798), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [54549] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_DOLLAR,
    ACTIONS(2800), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2864), 1,
      aux_sym_expandable_string_literal_token2,
    ACTIONS(2868), 1,
      aux_sym_expandable_string_literal_token5,
    STATE(1517), 1,
      aux_sym_expandable_string_literal_repeat2,
    ACTIONS(2866), 3,
      aux_sym_expandable_string_literal_token3,
      aux_sym_expandable_string_literal_token4,
      anon_sym_DQUOTE_DQUOTE,
    STATE(1172), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_string_literal_repeat1,
    ACTIONS(2798), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [54587] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_DOLLAR,
    ACTIONS(2800), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2808), 1,
      aux_sym_expandable_string_literal_token2,
    ACTIONS(2870), 1,
      aux_sym_expandable_string_literal_token5,
    STATE(1462), 1,
      aux_sym_expandable_string_literal_repeat2,
    ACTIONS(2810), 3,
      aux_sym_expandable_string_literal_token3,
      aux_sym_expandable_string_literal_token4,
      anon_sym_DQUOTE_DQUOTE,
    STATE(1203), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_string_literal_repeat1,
    ACTIONS(2798), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [54625] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2764), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2872), 1,
      anon_sym_DOLLAR2,
    ACTIONS(2874), 1,
      anon_sym_DQUOTE,
    STATE(1483), 1,
      aux_sym__expandable_string_literal_immediate_repeat2,
    STATE(1204), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym__expandable_string_literal_immediate_repeat1,
    ACTIONS(2802), 4,
      aux_sym__expandable_string_literal_immediate_token1,
      aux_sym__expandable_string_literal_immediate_token2,
      aux_sym__expandable_string_literal_immediate_token3,
      anon_sym_DQUOTE_DQUOTE2,
    ACTIONS(2756), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [54661] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_DOLLAR,
    ACTIONS(2800), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2808), 1,
      aux_sym_expandable_string_literal_token2,
    ACTIONS(2876), 1,
      aux_sym_expandable_string_literal_token5,
    STATE(1447), 1,
      aux_sym_expandable_string_literal_repeat2,
    ACTIONS(2810), 3,
      aux_sym_expandable_string_literal_token3,
      aux_sym_expandable_string_literal_token4,
      anon_sym_DQUOTE_DQUOTE,
    STATE(1203), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_string_literal_repeat1,
    ACTIONS(2798), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [54699] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_DOLLAR,
    ACTIONS(2800), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2808), 1,
      aux_sym_expandable_string_literal_token2,
    ACTIONS(2878), 1,
      aux_sym_expandable_string_literal_token5,
    STATE(1405), 1,
      aux_sym_expandable_string_literal_repeat2,
    ACTIONS(2810), 3,
      aux_sym_expandable_string_literal_token3,
      aux_sym_expandable_string_literal_token4,
      anon_sym_DQUOTE_DQUOTE,
    STATE(1203), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_string_literal_repeat1,
    ACTIONS(2798), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [54737] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_DOLLAR,
    ACTIONS(2800), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2880), 1,
      aux_sym_expandable_string_literal_token2,
    ACTIONS(2884), 1,
      aux_sym_expandable_string_literal_token5,
    STATE(1503), 1,
      aux_sym_expandable_string_literal_repeat2,
    ACTIONS(2882), 3,
      aux_sym_expandable_string_literal_token3,
      aux_sym_expandable_string_literal_token4,
      anon_sym_DQUOTE_DQUOTE,
    STATE(1174), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_string_literal_repeat1,
    ACTIONS(2798), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [54775] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2890), 1,
      aux_sym_expandable_here_string_literal_token5,
    ACTIONS(2894), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2886), 2,
      aux_sym_expandable_string_literal_token4,
      aux_sym_expandable_here_string_literal_token4,
    ACTIONS(2888), 3,
      anon_sym_DOLLAR,
      aux_sym_expandable_here_string_literal_token2,
      aux_sym_expandable_here_string_literal_token3,
    STATE(1206), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_here_string_literal_repeat1,
    ACTIONS(2892), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [54808] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2902), 1,
      aux_sym_expandable_here_string_literal_token5,
    ACTIONS(2907), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2896), 2,
      aux_sym_expandable_string_literal_token4,
      aux_sym_expandable_here_string_literal_token4,
    ACTIONS(2899), 3,
      anon_sym_DOLLAR,
      aux_sym_expandable_here_string_literal_token2,
      aux_sym_expandable_here_string_literal_token3,
    STATE(1192), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_here_string_literal_repeat1,
    ACTIONS(2904), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [54841] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2894), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2914), 1,
      aux_sym_expandable_here_string_literal_token5,
    ACTIONS(2910), 2,
      aux_sym_expandable_string_literal_token4,
      aux_sym_expandable_here_string_literal_token4,
    ACTIONS(2912), 3,
      anon_sym_DOLLAR,
      aux_sym_expandable_here_string_literal_token2,
      aux_sym_expandable_here_string_literal_token3,
    STATE(1192), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_here_string_literal_repeat1,
    ACTIONS(2892), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [54874] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2894), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2916), 1,
      aux_sym_expandable_here_string_literal_token5,
    ACTIONS(2910), 2,
      aux_sym_expandable_string_literal_token4,
      aux_sym_expandable_here_string_literal_token4,
    ACTIONS(2912), 3,
      anon_sym_DOLLAR,
      aux_sym_expandable_here_string_literal_token2,
      aux_sym_expandable_here_string_literal_token3,
    STATE(1192), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_here_string_literal_repeat1,
    ACTIONS(2892), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [54907] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2894), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2922), 1,
      aux_sym_expandable_here_string_literal_token5,
    ACTIONS(2918), 2,
      aux_sym_expandable_string_literal_token4,
      aux_sym_expandable_here_string_literal_token4,
    ACTIONS(2920), 3,
      anon_sym_DOLLAR,
      aux_sym_expandable_here_string_literal_token2,
      aux_sym_expandable_here_string_literal_token3,
    STATE(1196), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_here_string_literal_repeat1,
    ACTIONS(2892), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [54940] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2894), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2924), 1,
      aux_sym_expandable_here_string_literal_token5,
    ACTIONS(2910), 2,
      aux_sym_expandable_string_literal_token4,
      aux_sym_expandable_here_string_literal_token4,
    ACTIONS(2912), 3,
      anon_sym_DOLLAR,
      aux_sym_expandable_here_string_literal_token2,
      aux_sym_expandable_here_string_literal_token3,
    STATE(1192), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_here_string_literal_repeat1,
    ACTIONS(2892), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [54973] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2894), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2930), 1,
      aux_sym_expandable_here_string_literal_token5,
    ACTIONS(2926), 2,
      aux_sym_expandable_string_literal_token4,
      aux_sym_expandable_here_string_literal_token4,
    ACTIONS(2928), 3,
      anon_sym_DOLLAR,
      aux_sym_expandable_here_string_literal_token2,
      aux_sym_expandable_here_string_literal_token3,
    STATE(1193), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_here_string_literal_repeat1,
    ACTIONS(2892), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [55006] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2894), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2936), 1,
      aux_sym_expandable_here_string_literal_token5,
    ACTIONS(2932), 2,
      aux_sym_expandable_string_literal_token4,
      aux_sym_expandable_here_string_literal_token4,
    ACTIONS(2934), 3,
      anon_sym_DOLLAR,
      aux_sym_expandable_here_string_literal_token2,
      aux_sym_expandable_here_string_literal_token3,
    STATE(1208), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_here_string_literal_repeat1,
    ACTIONS(2892), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [55039] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2894), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2942), 1,
      aux_sym_expandable_here_string_literal_token5,
    ACTIONS(2938), 2,
      aux_sym_expandable_string_literal_token4,
      aux_sym_expandable_here_string_literal_token4,
    ACTIONS(2940), 3,
      anon_sym_DOLLAR,
      aux_sym_expandable_here_string_literal_token2,
      aux_sym_expandable_here_string_literal_token3,
    STATE(1207), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_here_string_literal_repeat1,
    ACTIONS(2892), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [55072] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2894), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2948), 1,
      aux_sym_expandable_here_string_literal_token5,
    ACTIONS(2944), 2,
      aux_sym_expandable_string_literal_token4,
      aux_sym_expandable_here_string_literal_token4,
    ACTIONS(2946), 3,
      anon_sym_DOLLAR,
      aux_sym_expandable_here_string_literal_token2,
      aux_sym_expandable_here_string_literal_token3,
    STATE(1205), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_here_string_literal_repeat1,
    ACTIONS(2892), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [55105] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2894), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2954), 1,
      aux_sym_expandable_here_string_literal_token5,
    ACTIONS(2950), 2,
      aux_sym_expandable_string_literal_token4,
      aux_sym_expandable_here_string_literal_token4,
    ACTIONS(2952), 3,
      anon_sym_DOLLAR,
      aux_sym_expandable_here_string_literal_token2,
      aux_sym_expandable_here_string_literal_token3,
    STATE(1209), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_here_string_literal_repeat1,
    ACTIONS(2892), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [55138] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2894), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2960), 1,
      aux_sym_expandable_here_string_literal_token5,
    ACTIONS(2956), 2,
      aux_sym_expandable_string_literal_token4,
      aux_sym_expandable_here_string_literal_token4,
    ACTIONS(2958), 3,
      anon_sym_DOLLAR,
      aux_sym_expandable_here_string_literal_token2,
      aux_sym_expandable_here_string_literal_token3,
    STATE(1194), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_here_string_literal_repeat1,
    ACTIONS(2892), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [55171] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2968), 1,
      aux_sym_expandable_string_literal_token5,
    ACTIONS(2973), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2962), 2,
      aux_sym_expandable_string_literal_token2,
      anon_sym_DOLLAR,
    ACTIONS(2965), 3,
      aux_sym_expandable_string_literal_token3,
      aux_sym_expandable_string_literal_token4,
      anon_sym_DQUOTE_DQUOTE,
    STATE(1203), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_string_literal_repeat1,
    ACTIONS(2970), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [55204] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2984), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2982), 2,
      anon_sym_DOLLAR2,
      anon_sym_DQUOTE,
    STATE(1204), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym__expandable_string_literal_immediate_repeat1,
    ACTIONS(2979), 4,
      aux_sym__expandable_string_literal_immediate_token1,
      aux_sym__expandable_string_literal_immediate_token2,
      aux_sym__expandable_string_literal_immediate_token3,
      anon_sym_DQUOTE_DQUOTE2,
    ACTIONS(2976), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [55235] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2894), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2987), 1,
      aux_sym_expandable_here_string_literal_token5,
    ACTIONS(2910), 2,
      aux_sym_expandable_string_literal_token4,
      aux_sym_expandable_here_string_literal_token4,
    ACTIONS(2912), 3,
      anon_sym_DOLLAR,
      aux_sym_expandable_here_string_literal_token2,
      aux_sym_expandable_here_string_literal_token3,
    STATE(1192), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_here_string_literal_repeat1,
    ACTIONS(2892), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [55268] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2894), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2989), 1,
      aux_sym_expandable_here_string_literal_token5,
    ACTIONS(2910), 2,
      aux_sym_expandable_string_literal_token4,
      aux_sym_expandable_here_string_literal_token4,
    ACTIONS(2912), 3,
      anon_sym_DOLLAR,
      aux_sym_expandable_here_string_literal_token2,
      aux_sym_expandable_here_string_literal_token3,
    STATE(1192), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_here_string_literal_repeat1,
    ACTIONS(2892), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [55301] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2894), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2991), 1,
      aux_sym_expandable_here_string_literal_token5,
    ACTIONS(2910), 2,
      aux_sym_expandable_string_literal_token4,
      aux_sym_expandable_here_string_literal_token4,
    ACTIONS(2912), 3,
      anon_sym_DOLLAR,
      aux_sym_expandable_here_string_literal_token2,
      aux_sym_expandable_here_string_literal_token3,
    STATE(1192), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_here_string_literal_repeat1,
    ACTIONS(2892), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [55334] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2894), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2993), 1,
      aux_sym_expandable_here_string_literal_token5,
    ACTIONS(2910), 2,
      aux_sym_expandable_string_literal_token4,
      aux_sym_expandable_here_string_literal_token4,
    ACTIONS(2912), 3,
      anon_sym_DOLLAR,
      aux_sym_expandable_here_string_literal_token2,
      aux_sym_expandable_here_string_literal_token3,
    STATE(1192), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_here_string_literal_repeat1,
    ACTIONS(2892), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [55367] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2894), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(2995), 1,
      aux_sym_expandable_here_string_literal_token5,
    ACTIONS(2910), 2,
      aux_sym_expandable_string_literal_token4,
      aux_sym_expandable_here_string_literal_token4,
    ACTIONS(2912), 3,
      anon_sym_DOLLAR,
      aux_sym_expandable_here_string_literal_token2,
      aux_sym_expandable_here_string_literal_token3,
    STATE(1192), 3,
      sym_variable,
      sym_sub_expression,
      aux_sym_expandable_here_string_literal_repeat1,
    ACTIONS(2892), 7,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
  [55400] = 11,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_LBRACK,
    ACTIONS(2999), 1,
      anon_sym_RPAREN,
    STATE(1276), 1,
      sym_type_literal,
    STATE(1292), 1,
      sym_attribute_list,
    STATE(1382), 1,
      sym_variable,
    STATE(1502), 1,
      sym_script_parameter,
    STATE(1843), 1,
      sym_parameter_list,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    STATE(1250), 2,
      sym_attribute,
      aux_sym_attribute_list_repeat1,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [55440] = 11,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_LBRACK,
    ACTIONS(3001), 1,
      anon_sym_RPAREN,
    STATE(1276), 1,
      sym_type_literal,
    STATE(1292), 1,
      sym_attribute_list,
    STATE(1382), 1,
      sym_variable,
    STATE(1502), 1,
      sym_script_parameter,
    STATE(1745), 1,
      sym_parameter_list,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    STATE(1250), 2,
      sym_attribute,
      aux_sym_attribute_list_repeat1,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [55480] = 11,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_LBRACK,
    ACTIONS(3003), 1,
      anon_sym_RPAREN,
    STATE(1276), 1,
      sym_type_literal,
    STATE(1292), 1,
      sym_attribute_list,
    STATE(1382), 1,
      sym_variable,
    STATE(1502), 1,
      sym_script_parameter,
    STATE(1966), 1,
      sym_parameter_list,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    STATE(1250), 2,
      sym_attribute,
      aux_sym_attribute_list_repeat1,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [55520] = 11,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_LBRACK,
    ACTIONS(3005), 1,
      anon_sym_RPAREN,
    STATE(1276), 1,
      sym_type_literal,
    STATE(1292), 1,
      sym_attribute_list,
    STATE(1382), 1,
      sym_variable,
    STATE(1502), 1,
      sym_script_parameter,
    STATE(1943), 1,
      sym_parameter_list,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    STATE(1250), 2,
      sym_attribute,
      aux_sym_attribute_list_repeat1,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [55560] = 11,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_LBRACK,
    ACTIONS(3007), 1,
      anon_sym_RPAREN,
    STATE(1276), 1,
      sym_type_literal,
    STATE(1292), 1,
      sym_attribute_list,
    STATE(1382), 1,
      sym_variable,
    STATE(1502), 1,
      sym_script_parameter,
    STATE(2006), 1,
      sym_parameter_list,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    STATE(1250), 2,
      sym_attribute,
      aux_sym_attribute_list_repeat1,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [55600] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(601), 6,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      sym_path_command_name_token,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_DOTforeach,
    ACTIONS(599), 10,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_COLON_COLON,
  [55624] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2070), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
    ACTIONS(95), 3,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_COLON_COLON,
    ACTIONS(97), 3,
      anon_sym_DASH_DASH,
      anon_sym_DOT2,
      anon_sym_DOTforeach,
    ACTIONS(2068), 3,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      sym_path_command_name_token,
    ACTIONS(3009), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [55654] = 11,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_LBRACK,
    ACTIONS(3011), 1,
      anon_sym_RPAREN,
    STATE(1276), 1,
      sym_type_literal,
    STATE(1292), 1,
      sym_attribute_list,
    STATE(1382), 1,
      sym_variable,
    STATE(1502), 1,
      sym_script_parameter,
    STATE(2068), 1,
      sym_parameter_list,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    STATE(1250), 2,
      sym_attribute,
      aux_sym_attribute_list_repeat1,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [55694] = 11,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_LBRACK,
    ACTIONS(3013), 1,
      anon_sym_RPAREN,
    STATE(1276), 1,
      sym_type_literal,
    STATE(1292), 1,
      sym_attribute_list,
    STATE(1382), 1,
      sym_variable,
    STATE(1502), 1,
      sym_script_parameter,
    STATE(1715), 1,
      sym_parameter_list,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    STATE(1250), 2,
      sym_attribute,
      aux_sym_attribute_list_repeat1,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [55734] = 9,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3015), 1,
      sym_simple_name,
    ACTIONS(3017), 1,
      anon_sym_LBRACK,
    STATE(1270), 1,
      sym_type_literal,
    STATE(1656), 1,
      sym_variable,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(2699), 2,
      anon_sym_hidden,
      anon_sym_static,
    STATE(1240), 2,
      sym_class_attribute,
      aux_sym_class_property_definition_repeat1,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [55769] = 9,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3017), 1,
      anon_sym_LBRACK,
    ACTIONS(3019), 1,
      sym_simple_name,
    STATE(1273), 1,
      sym_type_literal,
    STATE(1613), 1,
      sym_variable,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(2699), 2,
      anon_sym_hidden,
      anon_sym_static,
    STATE(1219), 2,
      sym_class_attribute,
      aux_sym_class_property_definition_repeat1,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [55804] = 9,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3017), 1,
      anon_sym_LBRACK,
    ACTIONS(3019), 1,
      sym_simple_name,
    STATE(1273), 1,
      sym_type_literal,
    STATE(1613), 1,
      sym_variable,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(2699), 2,
      anon_sym_hidden,
      anon_sym_static,
    STATE(1240), 2,
      sym_class_attribute,
      aux_sym_class_property_definition_repeat1,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [55839] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3023), 1,
      anon_sym_SEMI,
    STATE(1228), 1,
      aux_sym_script_block_repeat1,
    ACTIONS(3021), 5,
      sym_simple_name,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      anon_sym_hidden,
      anon_sym_static,
    ACTIONS(2739), 7,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_RBRACE,
  [55865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(683), 14,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      aux_sym__expandable_string_literal_immediate_token1,
      aux_sym__expandable_string_literal_immediate_token2,
      aux_sym__expandable_string_literal_immediate_token3,
      anon_sym_DQUOTE_DQUOTE2,
      anon_sym_DOLLAR2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_LPAREN,
  [55885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(599), 3,
      aux_sym_expandable_string_literal_token3,
      aux_sym_expandable_string_literal_token4,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(601), 11,
      aux_sym_expandable_string_literal_token2,
      anon_sym_DOLLAR,
      aux_sym_expandable_string_literal_token5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_DOLLAR_LPAREN,
  [55907] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3029), 2,
      anon_sym_DOLLAR,
      aux_sym_expandable_string_literal_token5,
    ACTIONS(3027), 3,
      aux_sym_expandable_string_literal_token3,
      aux_sym_expandable_string_literal_token4,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(3025), 9,
      aux_sym_expandable_string_literal_token2,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_DOLLAR_LPAREN,
  [55931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(599), 3,
      aux_sym_expandable_string_literal_token4,
      aux_sym_expandable_here_string_literal_token4,
      aux_sym_expandable_here_string_literal_token5,
    ACTIONS(601), 11,
      anon_sym_DOLLAR,
      aux_sym_expandable_here_string_literal_token2,
      aux_sym_expandable_here_string_literal_token3,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_DOLLAR_LPAREN,
  [55953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(629), 3,
      aux_sym_expandable_string_literal_token3,
      aux_sym_expandable_string_literal_token4,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(631), 11,
      aux_sym_expandable_string_literal_token2,
      anon_sym_DOLLAR,
      aux_sym_expandable_string_literal_token5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_DOLLAR_LPAREN,
  [55975] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3036), 1,
      anon_sym_SEMI,
    STATE(1230), 1,
      aux_sym_script_block_repeat1,
    ACTIONS(3032), 5,
      sym_simple_name,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      anon_sym_hidden,
      anon_sym_static,
    ACTIONS(3034), 7,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_RBRACE,
  [56001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(681), 3,
      aux_sym_expandable_string_literal_token4,
      aux_sym_expandable_here_string_literal_token4,
      aux_sym_expandable_here_string_literal_token5,
    ACTIONS(683), 11,
      anon_sym_DOLLAR,
      aux_sym_expandable_here_string_literal_token2,
      aux_sym_expandable_here_string_literal_token3,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_DOLLAR_LPAREN,
  [56023] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3038), 1,
      anon_sym_SEMI,
    STATE(1230), 1,
      aux_sym_script_block_repeat1,
    ACTIONS(1387), 5,
      sym_simple_name,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      anon_sym_hidden,
      anon_sym_static,
    ACTIONS(2641), 7,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_RBRACE,
  [56049] = 9,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_LBRACK,
    STATE(1276), 1,
      sym_type_literal,
    STATE(1292), 1,
      sym_attribute_list,
    STATE(1382), 1,
      sym_variable,
    STATE(1568), 1,
      sym_script_parameter,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    STATE(1250), 2,
      sym_attribute,
      aux_sym_attribute_list_repeat1,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [56083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(681), 3,
      aux_sym_expandable_string_literal_token3,
      aux_sym_expandable_string_literal_token4,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(683), 11,
      aux_sym_expandable_string_literal_token2,
      anon_sym_DOLLAR,
      aux_sym_expandable_string_literal_token5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_DOLLAR_LPAREN,
  [56105] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(629), 3,
      aux_sym_expandable_string_literal_token4,
      aux_sym_expandable_here_string_literal_token4,
      aux_sym_expandable_here_string_literal_token5,
    ACTIONS(631), 11,
      anon_sym_DOLLAR,
      aux_sym_expandable_here_string_literal_token2,
      aux_sym_expandable_here_string_literal_token3,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_DOLLAR_LPAREN,
  [56127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(631), 14,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      aux_sym__expandable_string_literal_immediate_token1,
      aux_sym__expandable_string_literal_immediate_token2,
      aux_sym__expandable_string_literal_immediate_token3,
      anon_sym_DQUOTE_DQUOTE2,
      anon_sym_DOLLAR2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_LPAREN,
  [56147] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 14,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      aux_sym_variable_token2,
      sym_braced_variable,
      aux_sym__expandable_string_literal_immediate_token1,
      aux_sym__expandable_string_literal_immediate_token2,
      aux_sym__expandable_string_literal_immediate_token3,
      anon_sym_DQUOTE_DQUOTE2,
      anon_sym_DOLLAR2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_LPAREN,
  [56167] = 9,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    ACTIONS(3041), 1,
      anon_sym_RPAREN,
    STATE(1287), 1,
      sym_type_literal,
    STATE(1501), 1,
      sym_class_method_parameter,
    STATE(1681), 1,
      sym_variable,
    STATE(1856), 1,
      sym_class_method_parameter_list,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [56200] = 9,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    ACTIONS(3043), 1,
      anon_sym_RPAREN,
    STATE(1287), 1,
      sym_type_literal,
    STATE(1501), 1,
      sym_class_method_parameter,
    STATE(1681), 1,
      sym_variable,
    STATE(1823), 1,
      sym_class_method_parameter_list,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [56233] = 9,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    ACTIONS(3045), 1,
      anon_sym_RPAREN,
    STATE(1287), 1,
      sym_type_literal,
    STATE(1501), 1,
      sym_class_method_parameter,
    STATE(1681), 1,
      sym_variable,
    STATE(1838), 1,
      sym_class_method_parameter_list,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [56266] = 9,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    ACTIONS(3047), 1,
      anon_sym_RPAREN,
    STATE(1287), 1,
      sym_type_literal,
    STATE(1501), 1,
      sym_class_method_parameter,
    STATE(1681), 1,
      sym_variable,
    STATE(1731), 1,
      sym_class_method_parameter_list,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [56299] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3053), 2,
      anon_sym_hidden,
      anon_sym_static,
    STATE(1240), 2,
      sym_class_attribute,
      aux_sym_class_property_definition_repeat1,
    ACTIONS(3049), 3,
      sym_simple_name,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(3051), 6,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [56324] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3056), 5,
      sym_simple_name,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      anon_sym_hidden,
      anon_sym_static,
    ACTIONS(3058), 7,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_RBRACE,
  [56344] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1458), 1,
      anon_sym_else,
    ACTIONS(1502), 11,
      anon_sym_RPAREN,
      anon_sym_dynamicparam,
      anon_sym_begin,
      anon_sym_process,
      anon_sym_end,
      anon_sym_RBRACE,
      anon_sym_elseif,
      anon_sym_while,
      anon_sym_until,
      anon_sym_catch,
      anon_sym_finally,
  [56364] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3060), 1,
      anon_sym_LBRACK,
    STATE(1276), 1,
      sym_type_literal,
    ACTIONS(3065), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    STATE(1243), 2,
      sym_attribute,
      aux_sym_attribute_list_repeat1,
    ACTIONS(3063), 6,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_param,
  [56390] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3067), 5,
      sym_simple_name,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      anon_sym_hidden,
      anon_sym_static,
    ACTIONS(3069), 7,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_RBRACE,
  [56410] = 7,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_LBRACK,
    ACTIONS(3071), 1,
      sym_simple_name,
    STATE(1613), 1,
      sym_variable,
    ACTIONS(3077), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(3080), 2,
      anon_sym_hidden,
      anon_sym_static,
    ACTIONS(3074), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [56438] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3086), 1,
      sym_path_command_name_token,
    ACTIONS(2228), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
    ACTIONS(3084), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    STATE(1248), 2,
      sym_variable,
      aux_sym_path_command_name_repeat1,
    ACTIONS(3082), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [56464] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3088), 5,
      sym_simple_name,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      anon_sym_hidden,
      anon_sym_static,
    ACTIONS(3090), 7,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_RBRACE,
  [56484] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3098), 1,
      sym_path_command_name_token,
    ACTIONS(2220), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
    ACTIONS(3095), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    STATE(1248), 2,
      sym_variable,
      aux_sym_path_command_name_repeat1,
    ACTIONS(3092), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [56510] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3101), 5,
      sym_simple_name,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      anon_sym_hidden,
      anon_sym_static,
    ACTIONS(3103), 7,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_RBRACE,
  [56530] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_LBRACK,
    STATE(1276), 1,
      sym_type_literal,
    ACTIONS(3107), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    STATE(1243), 2,
      sym_attribute,
      aux_sym_attribute_list_repeat1,
    ACTIONS(3105), 6,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_param,
  [56556] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1456), 1,
      anon_sym_else,
    ACTIONS(1500), 11,
      anon_sym_RPAREN,
      anon_sym_dynamicparam,
      anon_sym_begin,
      anon_sym_process,
      anon_sym_end,
      anon_sym_RBRACE,
      anon_sym_elseif,
      anon_sym_while,
      anon_sym_until,
      anon_sym_catch,
      anon_sym_finally,
  [56576] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3109), 5,
      sym_simple_name,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      anon_sym_hidden,
      anon_sym_static,
    ACTIONS(3111), 7,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_RBRACE,
  [56596] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3113), 5,
      sym_simple_name,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      anon_sym_hidden,
      anon_sym_static,
    ACTIONS(3115), 7,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_RBRACE,
  [56616] = 7,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_for,
    ACTIONS(3117), 1,
      anon_sym_switch,
    ACTIONS(3119), 1,
      anon_sym_foreach,
    ACTIONS(3121), 1,
      anon_sym_while,
    ACTIONS(3123), 1,
      anon_sym_do,
    STATE(2117), 6,
      sym__labeled_statement,
      sym_switch_statement,
      sym_foreach_statement,
      sym_for_statement,
      sym_while_statement,
      sym_do_statement,
  [56643] = 7,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3125), 1,
      anon_sym_switch,
    ACTIONS(3127), 1,
      anon_sym_foreach,
    ACTIONS(3129), 1,
      anon_sym_while,
    ACTIONS(3131), 1,
      anon_sym_do,
    STATE(506), 6,
      sym__labeled_statement,
      sym_switch_statement,
      sym_foreach_statement,
      sym_for_statement,
      sym_while_statement,
      sym_do_statement,
  [56670] = 7,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3133), 1,
      anon_sym_LPAREN,
    ACTIONS(3137), 1,
      anon_sym_DASHfile,
    STATE(1497), 1,
      sym_switch_parameters,
    STATE(1664), 1,
      sym_switch_condition,
    STATE(1275), 2,
      sym_switch_parameter,
      aux_sym_switch_parameters_repeat1,
    ACTIONS(3135), 5,
      anon_sym_DASHregex,
      anon_sym_DASHwildcard,
      anon_sym_DASHexact,
      anon_sym_DASHcasesensitive,
      anon_sym_DASHparallel,
  [56697] = 7,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3133), 1,
      anon_sym_LPAREN,
    ACTIONS(3137), 1,
      anon_sym_DASHfile,
    STATE(1415), 1,
      sym_switch_parameters,
    STATE(1525), 1,
      sym_switch_condition,
    STATE(1275), 2,
      sym_switch_parameter,
      aux_sym_switch_parameters_repeat1,
    ACTIONS(3135), 5,
      anon_sym_DASHregex,
      anon_sym_DASHwildcard,
      anon_sym_DASHexact,
      anon_sym_DASHcasesensitive,
      anon_sym_DASHparallel,
  [56724] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3139), 5,
      sym_simple_name,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      anon_sym_hidden,
      anon_sym_static,
    ACTIONS(3141), 6,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [56743] = 7,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(565), 1,
      anon_sym_for,
    ACTIONS(3143), 1,
      anon_sym_switch,
    ACTIONS(3145), 1,
      anon_sym_foreach,
    ACTIONS(3147), 1,
      anon_sym_while,
    ACTIONS(3149), 1,
      anon_sym_do,
    STATE(1956), 6,
      sym__labeled_statement,
      sym_switch_statement,
      sym_foreach_statement,
      sym_for_statement,
      sym_while_statement,
      sym_do_statement,
  [56770] = 7,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3133), 1,
      anon_sym_LPAREN,
    ACTIONS(3137), 1,
      anon_sym_DASHfile,
    STATE(1489), 1,
      sym_switch_parameters,
    STATE(1562), 1,
      sym_switch_condition,
    STATE(1275), 2,
      sym_switch_parameter,
      aux_sym_switch_parameters_repeat1,
    ACTIONS(3135), 5,
      anon_sym_DASHregex,
      anon_sym_DASHwildcard,
      anon_sym_DASHexact,
      anon_sym_DASHcasesensitive,
      anon_sym_DASHparallel,
  [56797] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3151), 5,
      sym_simple_name,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      anon_sym_hidden,
      anon_sym_static,
    ACTIONS(3153), 6,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [56816] = 7,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(187), 1,
      anon_sym_for,
    ACTIONS(3155), 1,
      anon_sym_switch,
    ACTIONS(3157), 1,
      anon_sym_foreach,
    ACTIONS(3159), 1,
      anon_sym_while,
    ACTIONS(3161), 1,
      anon_sym_do,
    STATE(471), 6,
      sym__labeled_statement,
      sym_switch_statement,
      sym_foreach_statement,
      sym_for_statement,
      sym_while_statement,
      sym_do_statement,
  [56843] = 7,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3133), 1,
      anon_sym_LPAREN,
    ACTIONS(3137), 1,
      anon_sym_DASHfile,
    STATE(1404), 1,
      sym_switch_parameters,
    STATE(1634), 1,
      sym_switch_condition,
    STATE(1275), 2,
      sym_switch_parameter,
      aux_sym_switch_parameters_repeat1,
    ACTIONS(3135), 5,
      anon_sym_DASHregex,
      anon_sym_DASHwildcard,
      anon_sym_DASHexact,
      anon_sym_DASHcasesensitive,
      anon_sym_DASHparallel,
  [56870] = 7,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    STATE(1287), 1,
      sym_type_literal,
    STATE(1639), 1,
      sym_class_method_parameter,
    STATE(1681), 1,
      sym_variable,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [56897] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3163), 5,
      sym_simple_name,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
      anon_sym_hidden,
      anon_sym_static,
    ACTIONS(3165), 6,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [56916] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(601), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(599), 8,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_path_command_name_token,
  [56934] = 8,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2555), 1,
      anon_sym_LBRACK,
    ACTIONS(2557), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2559), 1,
      anon_sym_DASH_DASH,
    ACTIONS(2565), 1,
      anon_sym_DOTforeach,
    ACTIONS(3167), 1,
      anon_sym_DOT2,
    ACTIONS(3169), 1,
      anon_sym_COLON_COLON,
    ACTIONS(713), 4,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [56962] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3151), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(3153), 7,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_param,
  [56979] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3139), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(3141), 7,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_param,
  [56996] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3171), 1,
      sym_simple_name,
    STATE(1595), 1,
      sym_variable,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [57017] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2105), 1,
      aux_sym_command_name_token1,
    STATE(720), 1,
      sym_command_invokation_operator,
    STATE(761), 1,
      sym_command_name,
    STATE(1495), 1,
      sym_foreach_command,
    STATE(1675), 1,
      sym_command,
    ACTIONS(15), 2,
      anon_sym_DOT,
      anon_sym_AMP,
    ACTIONS(3173), 2,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
  [57044] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2121), 1,
      aux_sym_command_name_token1,
    STATE(722), 1,
      sym_command_invokation_operator,
    STATE(817), 1,
      sym_command_name,
    STATE(1445), 1,
      sym_foreach_command,
    STATE(1563), 1,
      sym_command,
    ACTIONS(15), 2,
      anon_sym_DOT,
      anon_sym_AMP,
    ACTIONS(3175), 2,
      anon_sym_PERCENT,
      anon_sym_foreach_DASHobject,
  [57071] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3177), 1,
      sym_simple_name,
    STATE(1656), 1,
      sym_variable,
    ACTIONS(21), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(101), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [57092] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3179), 2,
      anon_sym_LPAREN,
      anon_sym_DASHfile,
    STATE(1274), 2,
      sym_switch_parameter,
      aux_sym_switch_parameters_repeat1,
    ACTIONS(3181), 5,
      anon_sym_DASHregex,
      anon_sym_DASHwildcard,
      anon_sym_DASHexact,
      anon_sym_DASHcasesensitive,
      anon_sym_DASHparallel,
  [57111] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3184), 2,
      anon_sym_LPAREN,
      anon_sym_DASHfile,
    STATE(1274), 2,
      sym_switch_parameter,
      aux_sym_switch_parameters_repeat1,
    ACTIONS(3135), 5,
      anon_sym_DASHregex,
      anon_sym_DASHwildcard,
      anon_sym_DASHexact,
      anon_sym_DASHcasesensitive,
      anon_sym_DASHparallel,
  [57130] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3080), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(103), 7,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
      anon_sym_param,
  [57147] = 4,
    ACTIONS(81), 1,
      sym_comment,
    STATE(1800), 1,
      sym_variable,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [57165] = 4,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2096), 1,
      sym_variable,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [57183] = 8,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2555), 1,
      anon_sym_LBRACK,
    ACTIONS(2557), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2559), 1,
      anon_sym_DASH_DASH,
    ACTIONS(2565), 1,
      anon_sym_DOTforeach,
    ACTIONS(3186), 1,
      anon_sym_DOT2,
    ACTIONS(3188), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2437), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [57209] = 4,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2090), 1,
      sym_variable,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [57227] = 8,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2567), 1,
      anon_sym_LBRACK,
    ACTIONS(2569), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2571), 1,
      anon_sym_DASH_DASH,
    ACTIONS(2577), 1,
      anon_sym_DOTforeach,
    ACTIONS(3190), 1,
      anon_sym_DOT2,
    ACTIONS(3192), 1,
      anon_sym_COLON_COLON,
    ACTIONS(713), 2,
      sym__statement_terminator,
      anon_sym_LPAREN,
  [57253] = 4,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2101), 1,
      sym_variable,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [57271] = 4,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2102), 1,
      sym_variable,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [57289] = 4,
    ACTIONS(81), 1,
      sym_comment,
    STATE(1749), 1,
      sym_variable,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [57307] = 4,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2088), 1,
      sym_variable,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [57325] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3194), 3,
      anon_sym_DASHband,
      anon_sym_DASHbor,
      anon_sym_DASHbxor,
    ACTIONS(2409), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
  [57341] = 4,
    ACTIONS(81), 1,
      sym_comment,
    STATE(1611), 1,
      sym_variable,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [57359] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3194), 3,
      anon_sym_DASHband,
      anon_sym_DASHbor,
      anon_sym_DASHbxor,
    ACTIONS(2381), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
  [57375] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3199), 1,
      anon_sym_RBRACE,
    STATE(1560), 1,
      sym_block_name,
    STATE(1289), 2,
      sym_named_block,
      aux_sym_named_block_list_repeat1,
    ACTIONS(3196), 4,
      anon_sym_dynamicparam,
      anon_sym_begin,
      anon_sym_process,
      anon_sym_end,
  [57395] = 4,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2095), 1,
      sym_variable,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [57413] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3203), 1,
      anon_sym_RBRACE,
    STATE(1560), 1,
      sym_block_name,
    STATE(1289), 2,
      sym_named_block,
      aux_sym_named_block_list_repeat1,
    ACTIONS(3201), 4,
      anon_sym_dynamicparam,
      anon_sym_begin,
      anon_sym_process,
      anon_sym_end,
  [57433] = 4,
    ACTIONS(81), 1,
      sym_comment,
    STATE(1388), 1,
      sym_variable,
    ACTIONS(137), 2,
      anon_sym_DOLLAR_,
      aux_sym_variable_token1,
    ACTIONS(135), 5,
      anon_sym_DOLLAR_DOLLAR,
      anon_sym_DOLLAR_CARET,
      anon_sym_DOLLAR_QMARK,
      aux_sym_variable_token2,
      sym_braced_variable,
  [57451] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3205), 3,
      anon_sym_DASHband,
      anon_sym_DASHbor,
      anon_sym_DASHbxor,
    ACTIONS(2381), 4,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
      anon_sym_RBRACK,
  [57466] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3209), 1,
      aux_sym_command_name_token2,
    ACTIONS(3211), 1,
      anon_sym_DQUOTE2,
    STATE(1297), 1,
      aux_sym_command_name_repeat1,
    ACTIONS(2451), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
    ACTIONS(3207), 2,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
  [57487] = 8,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(713), 1,
      anon_sym_EQ,
    ACTIONS(2555), 1,
      anon_sym_LBRACK,
    ACTIONS(2557), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2559), 1,
      anon_sym_DASH_DASH,
    ACTIONS(2565), 1,
      anon_sym_DOTforeach,
    ACTIONS(3186), 1,
      anon_sym_DOT2,
    ACTIONS(3188), 1,
      anon_sym_COLON_COLON,
  [57512] = 8,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(713), 1,
      sym__statement_terminator,
    ACTIONS(2567), 1,
      anon_sym_LBRACK,
    ACTIONS(2569), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2571), 1,
      anon_sym_DASH_DASH,
    ACTIONS(2577), 1,
      anon_sym_DOTforeach,
    ACTIONS(3213), 1,
      anon_sym_DOT2,
    ACTIONS(3215), 1,
      anon_sym_COLON_COLON,
  [57537] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3211), 1,
      anon_sym_DQUOTE2,
    ACTIONS(3219), 1,
      aux_sym_command_name_token2,
    STATE(1298), 1,
      aux_sym_command_name_repeat1,
    ACTIONS(2459), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
    ACTIONS(3217), 2,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
  [57558] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3224), 1,
      aux_sym_command_name_token2,
    ACTIONS(3227), 1,
      anon_sym_DQUOTE2,
    STATE(1298), 1,
      aux_sym_command_name_repeat1,
    ACTIONS(2466), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
    ACTIONS(3221), 2,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
  [57579] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3230), 3,
      anon_sym_DASHband,
      anon_sym_DASHbor,
      anon_sym_DASHbxor,
    ACTIONS(2409), 4,
      sym__statement_terminator,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
  [57594] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3205), 3,
      anon_sym_DASHband,
      anon_sym_DASHbor,
      anon_sym_DASHbxor,
    ACTIONS(2409), 4,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
      anon_sym_RBRACK,
  [57609] = 3,
    ACTIONS(81), 1,
      sym_comment,
    STATE(79), 1,
      sym_assignement_operator,
    ACTIONS(3232), 6,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
  [57624] = 7,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1355), 1,
      sym__statement_terminator,
    ACTIONS(3234), 1,
      anon_sym_elseif,
    ACTIONS(3236), 1,
      anon_sym_else,
    STATE(1472), 1,
      sym_elseif_clauses,
    STATE(2011), 1,
      sym_else_clause,
    STATE(1337), 2,
      sym_elseif_clause,
      aux_sym_elseif_clauses_repeat1,
  [57647] = 7,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1349), 1,
      sym__statement_terminator,
    ACTIONS(3238), 1,
      anon_sym_catch,
    ACTIONS(3240), 1,
      anon_sym_finally,
    STATE(1425), 1,
      sym_catch_clauses,
    STATE(2078), 1,
      sym_finally_clause,
    STATE(1362), 2,
      sym_catch_clause,
      aux_sym_catch_clauses_repeat1,
  [57670] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3230), 3,
      anon_sym_DASHband,
      anon_sym_DASHbor,
      anon_sym_DASHbxor,
    ACTIONS(2381), 4,
      sym__statement_terminator,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
  [57685] = 8,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2555), 1,
      anon_sym_LBRACK,
    ACTIONS(2557), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2559), 1,
      anon_sym_DASH_DASH,
    ACTIONS(2565), 1,
      anon_sym_DOTforeach,
    ACTIONS(3186), 1,
      anon_sym_DOT2,
    ACTIONS(3188), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3242), 1,
      anon_sym_LBRACE,
  [57710] = 8,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2555), 1,
      anon_sym_LBRACK,
    ACTIONS(2557), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2559), 1,
      anon_sym_DASH_DASH,
    ACTIONS(2565), 1,
      anon_sym_DOTforeach,
    ACTIONS(3186), 1,
      anon_sym_DOT2,
    ACTIONS(3188), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3244), 1,
      anon_sym_LBRACE,
  [57735] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3246), 7,
      anon_sym_LPAREN,
      anon_sym_DASHregex,
      anon_sym_DASHwildcard,
      anon_sym_DASHexact,
      anon_sym_DASHcasesensitive,
      anon_sym_DASHparallel,
      anon_sym_DASHfile,
  [57748] = 7,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1349), 1,
      anon_sym_RPAREN,
    ACTIONS(3248), 1,
      anon_sym_catch,
    ACTIONS(3250), 1,
      anon_sym_finally,
    STATE(1428), 1,
      sym_catch_clauses,
    STATE(1940), 1,
      sym_finally_clause,
    STATE(1359), 2,
      sym_catch_clause,
      aux_sym_catch_clauses_repeat1,
  [57771] = 7,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1355), 1,
      anon_sym_RPAREN,
    ACTIONS(3252), 1,
      anon_sym_elseif,
    ACTIONS(3254), 1,
      anon_sym_else,
    STATE(1429), 1,
      sym_elseif_clauses,
    STATE(1900), 1,
      sym_else_clause,
    STATE(1353), 2,
      sym_elseif_clause,
      aux_sym_elseif_clauses_repeat1,
  [57794] = 3,
    ACTIONS(81), 1,
      sym_comment,
    STATE(82), 1,
      sym_assignement_operator,
    ACTIONS(3232), 6,
      anon_sym_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
  [57809] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_LBRACE,
    STATE(1320), 2,
      sym_script_block_expression,
      aux_sym_foreach_command_repeat1,
    ACTIONS(3256), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_DASH_DASH_PERCENT,
  [57825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2505), 2,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
    ACTIONS(2507), 4,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      aux_sym_command_name_token2,
      anon_sym_DQUOTE2,
  [57839] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3260), 1,
      anon_sym_LBRACE,
    STATE(1314), 2,
      sym_script_block_expression,
      aux_sym_foreach_command_repeat1,
    ACTIONS(3256), 3,
      sym__statement_terminator,
      anon_sym_PIPE,
      anon_sym_DASH_DASH_PERCENT,
  [57855] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3262), 1,
      anon_sym_LBRACE,
    STATE(1314), 2,
      sym_script_block_expression,
      aux_sym_foreach_command_repeat1,
    ACTIONS(3265), 3,
      sym__statement_terminator,
      anon_sym_PIPE,
      anon_sym_DASH_DASH_PERCENT,
  [57871] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3269), 1,
      anon_sym_PIPE,
    ACTIONS(3271), 1,
      sym__statement_terminator,
    STATE(1325), 1,
      aux_sym__verbatim_command_argument_chars,
    ACTIONS(3267), 3,
      aux_sym__verbatim_command_argument_chars_token1,
      aux_sym__verbatim_command_argument_chars_token2,
      aux_sym__verbatim_command_argument_chars_token3,
  [57889] = 7,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3273), 1,
      sym_type_identifier,
    STATE(1316), 1,
      sym_generic_type_name,
    STATE(1357), 1,
      sym_type_name,
    STATE(1375), 1,
      sym_array_type_name,
    STATE(1484), 1,
      sym_type_spec,
    STATE(1854), 1,
      sym_generic_type_arguments,
  [57911] = 7,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3273), 1,
      sym_type_identifier,
    STATE(1316), 1,
      sym_generic_type_name,
    STATE(1357), 1,
      sym_type_name,
    STATE(1375), 1,
      sym_array_type_name,
    STATE(1557), 1,
      sym_type_spec,
    STATE(1993), 1,
      sym_attribute_name,
  [57933] = 7,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3273), 1,
      sym_type_identifier,
    STATE(1316), 1,
      sym_generic_type_name,
    STATE(1357), 1,
      sym_type_name,
    STATE(1375), 1,
      sym_array_type_name,
    STATE(1522), 1,
      sym_type_spec,
    STATE(2010), 1,
      sym_attribute_name,
  [57955] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1322), 1,
      aux_sym__verbatim_command_argument_chars,
    ACTIONS(3269), 2,
      anon_sym_RPAREN,
      anon_sym_PIPE,
    ACTIONS(3275), 3,
      aux_sym__verbatim_command_argument_chars_token1,
      aux_sym__verbatim_command_argument_chars_token2,
      aux_sym__verbatim_command_argument_chars_token3,
  [57971] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3277), 1,
      anon_sym_LBRACE,
    STATE(1320), 2,
      sym_script_block_expression,
      aux_sym_foreach_command_repeat1,
    ACTIONS(3265), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_DASH_DASH_PERCENT,
  [57987] = 7,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3273), 1,
      sym_type_identifier,
    STATE(1316), 1,
      sym_generic_type_name,
    STATE(1357), 1,
      sym_type_name,
    STATE(1375), 1,
      sym_array_type_name,
    STATE(1661), 1,
      sym_type_spec,
    STATE(1993), 1,
      sym_attribute_name,
  [58009] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1322), 1,
      aux_sym__verbatim_command_argument_chars,
    ACTIONS(3283), 2,
      anon_sym_RPAREN,
      anon_sym_PIPE,
    ACTIONS(3280), 3,
      aux_sym__verbatim_command_argument_chars_token1,
      aux_sym__verbatim_command_argument_chars_token2,
      aux_sym__verbatim_command_argument_chars_token3,
  [58025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2474), 2,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
    ACTIONS(2466), 4,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      aux_sym_command_name_token2,
      anon_sym_DQUOTE2,
  [58039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2509), 2,
      anon_sym_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE,
    ACTIONS(2511), 4,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      aux_sym_command_name_token2,
      anon_sym_DQUOTE2,
  [58053] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3283), 1,
      anon_sym_PIPE,
    ACTIONS(3288), 1,
      sym__statement_terminator,
    STATE(1325), 1,
      aux_sym__verbatim_command_argument_chars,
    ACTIONS(3285), 3,
      aux_sym__verbatim_command_argument_chars_token1,
      aux_sym__verbatim_command_argument_chars_token2,
      aux_sym__verbatim_command_argument_chars_token3,
  [58071] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3273), 1,
      sym_type_identifier,
    STATE(1316), 1,
      sym_generic_type_name,
    STATE(1357), 1,
      sym_type_name,
    STATE(1375), 1,
      sym_array_type_name,
    STATE(1734), 1,
      sym_type_spec,
  [58090] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3273), 1,
      sym_type_identifier,
    STATE(1316), 1,
      sym_generic_type_name,
    STATE(1357), 1,
      sym_type_name,
    STATE(1375), 1,
      sym_array_type_name,
    STATE(1786), 1,
      sym_type_spec,
  [58109] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3273), 1,
      sym_type_identifier,
    STATE(1316), 1,
      sym_generic_type_name,
    STATE(1357), 1,
      sym_type_name,
    STATE(1375), 1,
      sym_array_type_name,
    STATE(1763), 1,
      sym_type_spec,
  [58128] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(1413), 1,
      sym_statement_block,
    STATE(1473), 1,
      sym_type_literal,
    STATE(1558), 1,
      sym_catch_type_list,
  [58147] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3292), 5,
      anon_sym_dynamicparam,
      anon_sym_begin,
      anon_sym_process,
      anon_sym_end,
      anon_sym_RBRACE,
  [58158] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3294), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3296), 3,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
  [58171] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3298), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
  [58182] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3273), 1,
      sym_type_identifier,
    STATE(1316), 1,
      sym_generic_type_name,
    STATE(1357), 1,
      sym_type_name,
    STATE(1375), 1,
      sym_array_type_name,
    STATE(1764), 1,
      sym_type_spec,
  [58201] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    ACTIONS(3256), 2,
      sym__statement_terminator,
      anon_sym_PIPE,
    STATE(1340), 2,
      sym_script_block_expression,
      aux_sym_foreach_command_repeat1,
  [58216] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3273), 1,
      sym_type_identifier,
    STATE(1316), 1,
      sym_generic_type_name,
    STATE(1357), 1,
      sym_type_name,
    STATE(1375), 1,
      sym_array_type_name,
    STATE(1772), 1,
      sym_type_spec,
  [58235] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2405), 1,
      anon_sym_PIPE,
    ACTIONS(2407), 1,
      sym__statement_terminator,
    ACTIONS(3300), 1,
      anon_sym_DASH_DASH_PERCENT,
    STATE(1417), 1,
      aux_sym__pipeline_tail,
    STATE(1419), 1,
      sym_verbatim_command_argument,
  [58254] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1392), 1,
      anon_sym_else,
    ACTIONS(1445), 1,
      sym__statement_terminator,
    ACTIONS(3234), 1,
      anon_sym_elseif,
    STATE(1366), 2,
      sym_elseif_clause,
      aux_sym_elseif_clauses_repeat1,
  [58271] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3273), 1,
      sym_type_identifier,
    STATE(1316), 1,
      sym_generic_type_name,
    STATE(1357), 1,
      sym_type_name,
    STATE(1375), 1,
      sym_array_type_name,
    STATE(1778), 1,
      sym_type_spec,
  [58290] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3273), 1,
      sym_type_identifier,
    STATE(1316), 1,
      sym_generic_type_name,
    STATE(1357), 1,
      sym_type_name,
    STATE(1375), 1,
      sym_array_type_name,
    STATE(1783), 1,
      sym_type_spec,
  [58309] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3302), 1,
      anon_sym_LBRACE,
    ACTIONS(3265), 2,
      sym__statement_terminator,
      anon_sym_PIPE,
    STATE(1340), 2,
      sym_script_block_expression,
      aux_sym_foreach_command_repeat1,
  [58324] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    ACTIONS(3305), 1,
      anon_sym_LBRACE,
    STATE(385), 1,
      sym_statement_block,
    STATE(1473), 1,
      sym_type_literal,
    STATE(1658), 1,
      sym_catch_type_list,
  [58343] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1456), 1,
      anon_sym_else,
    ACTIONS(1500), 4,
      sym__statement_terminator,
      anon_sym_elseif,
      anon_sym_catch,
      anon_sym_finally,
  [58356] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_RPAREN,
    ACTIONS(2429), 1,
      anon_sym_PIPE,
    ACTIONS(3307), 1,
      anon_sym_DASH_DASH_PERCENT,
    STATE(1427), 1,
      sym_verbatim_command_argument,
    STATE(1446), 1,
      aux_sym__pipeline_tail,
  [58375] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3273), 1,
      sym_type_identifier,
    STATE(1316), 1,
      sym_generic_type_name,
    STATE(1357), 1,
      sym_type_name,
    STATE(1375), 1,
      sym_array_type_name,
    STATE(1559), 1,
      sym_type_spec,
  [58394] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    ACTIONS(3309), 1,
      anon_sym_LBRACE,
    STATE(405), 1,
      sym_statement_block,
    STATE(1473), 1,
      sym_type_literal,
    STATE(1588), 1,
      sym_catch_type_list,
  [58413] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3273), 1,
      sym_type_identifier,
    STATE(1316), 1,
      sym_generic_type_name,
    STATE(1357), 1,
      sym_type_name,
    STATE(1375), 1,
      sym_array_type_name,
    STATE(1837), 1,
      sym_type_spec,
  [58432] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3273), 1,
      sym_type_identifier,
    STATE(1316), 1,
      sym_generic_type_name,
    STATE(1357), 1,
      sym_type_name,
    STATE(1375), 1,
      sym_array_type_name,
    STATE(1762), 1,
      sym_type_spec,
  [58451] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3273), 1,
      sym_type_identifier,
    STATE(1316), 1,
      sym_generic_type_name,
    STATE(1357), 1,
      sym_type_name,
    STATE(1375), 1,
      sym_array_type_name,
    STATE(1826), 1,
      sym_type_spec,
  [58470] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3311), 5,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [58481] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3313), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
  [58492] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1369), 1,
      anon_sym_else,
    ACTIONS(1451), 1,
      anon_sym_RPAREN,
    ACTIONS(3315), 1,
      anon_sym_elseif,
    STATE(1351), 2,
      sym_elseif_clause,
      aux_sym_elseif_clauses_repeat1,
  [58509] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3273), 1,
      sym_type_identifier,
    STATE(1316), 1,
      sym_generic_type_name,
    STATE(1357), 1,
      sym_type_name,
    STATE(1375), 1,
      sym_array_type_name,
    STATE(1946), 1,
      sym_type_spec,
  [58528] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1392), 1,
      anon_sym_else,
    ACTIONS(1445), 1,
      anon_sym_RPAREN,
    ACTIONS(3252), 1,
      anon_sym_elseif,
    STATE(1351), 2,
      sym_elseif_clause,
      aux_sym_elseif_clauses_repeat1,
  [58545] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3318), 5,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [58556] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1449), 1,
      sym_statement_block,
    STATE(1473), 1,
      sym_type_literal,
    STATE(1666), 1,
      sym_catch_type_list,
  [58575] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3273), 1,
      sym_type_identifier,
    STATE(1316), 1,
      sym_generic_type_name,
    STATE(1357), 1,
      sym_type_name,
    STATE(1375), 1,
      sym_array_type_name,
    STATE(2108), 1,
      sym_type_spec,
  [58594] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3322), 1,
      anon_sym_DOT,
    ACTIONS(3324), 1,
      anon_sym_LBRACK,
    ACTIONS(3326), 3,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [58609] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3273), 1,
      sym_type_identifier,
    STATE(1316), 1,
      sym_generic_type_name,
    STATE(1357), 1,
      sym_type_name,
    STATE(1375), 1,
      sym_array_type_name,
    STATE(2089), 1,
      sym_type_spec,
  [58628] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3248), 1,
      anon_sym_catch,
    ACTIONS(1443), 2,
      anon_sym_RPAREN,
      anon_sym_finally,
    STATE(1367), 2,
      sym_catch_clause,
      aux_sym_catch_clauses_repeat1,
  [58643] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2521), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3328), 3,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
  [58656] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3273), 1,
      sym_type_identifier,
    STATE(1316), 1,
      sym_generic_type_name,
    STATE(1357), 1,
      sym_type_name,
    STATE(1375), 1,
      sym_array_type_name,
    STATE(1758), 1,
      sym_type_spec,
  [58675] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3238), 1,
      anon_sym_catch,
    ACTIONS(1443), 2,
      sym__statement_terminator,
      anon_sym_finally,
    STATE(1364), 2,
      sym_catch_clause,
      aux_sym_catch_clauses_repeat1,
  [58690] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3273), 1,
      sym_type_identifier,
    STATE(1316), 1,
      sym_generic_type_name,
    STATE(1357), 1,
      sym_type_name,
    STATE(1375), 1,
      sym_array_type_name,
    STATE(1867), 1,
      sym_type_spec,
  [58709] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3330), 1,
      anon_sym_catch,
    ACTIONS(1436), 2,
      sym__statement_terminator,
      anon_sym_finally,
    STATE(1364), 2,
      sym_catch_clause,
      aux_sym_catch_clauses_repeat1,
  [58724] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3273), 1,
      sym_type_identifier,
    STATE(1316), 1,
      sym_generic_type_name,
    STATE(1357), 1,
      sym_type_name,
    STATE(1375), 1,
      sym_array_type_name,
    STATE(1815), 1,
      sym_type_spec,
  [58743] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1369), 1,
      anon_sym_else,
    ACTIONS(1451), 1,
      sym__statement_terminator,
    ACTIONS(3333), 1,
      anon_sym_elseif,
    STATE(1366), 2,
      sym_elseif_clause,
      aux_sym_elseif_clauses_repeat1,
  [58760] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3336), 1,
      anon_sym_catch,
    ACTIONS(1436), 2,
      anon_sym_RPAREN,
      anon_sym_finally,
    STATE(1367), 2,
      sym_catch_clause,
      aux_sym_catch_clauses_repeat1,
  [58775] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3273), 1,
      sym_type_identifier,
    STATE(1316), 1,
      sym_generic_type_name,
    STATE(1357), 1,
      sym_type_name,
    STATE(1375), 1,
      sym_array_type_name,
    STATE(1801), 1,
      sym_type_spec,
  [58794] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3273), 1,
      sym_type_identifier,
    STATE(1316), 1,
      sym_generic_type_name,
    STATE(1357), 1,
      sym_type_name,
    STATE(1375), 1,
      sym_array_type_name,
    STATE(1845), 1,
      sym_type_spec,
  [58813] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1458), 1,
      anon_sym_else,
    ACTIONS(1502), 4,
      sym__statement_terminator,
      anon_sym_elseif,
      anon_sym_catch,
      anon_sym_finally,
  [58826] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3339), 1,
      anon_sym_LBRACE,
    ACTIONS(3265), 2,
      anon_sym_RPAREN,
      anon_sym_PIPE,
    STATE(1371), 2,
      sym_script_block_expression,
      aux_sym_foreach_command_repeat1,
  [58841] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    ACTIONS(3256), 2,
      anon_sym_RPAREN,
      anon_sym_PIPE,
    STATE(1371), 2,
      sym_script_block_expression,
      aux_sym_foreach_command_repeat1,
  [58856] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3342), 1,
      sym_simple_name,
    ACTIONS(3344), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      aux_sym_enum_statement_repeat1,
    STATE(2046), 1,
      sym_enum_member,
  [58872] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3342), 1,
      sym_simple_name,
    ACTIONS(3346), 1,
      anon_sym_RBRACE,
    STATE(1391), 1,
      aux_sym_enum_statement_repeat1,
    STATE(2046), 1,
      sym_enum_member,
  [58888] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3348), 1,
      anon_sym_COMMA,
    ACTIONS(3350), 1,
      anon_sym_RBRACK,
    STATE(1476), 1,
      aux_sym_dimension_repeat1,
    STATE(1854), 1,
      sym_dimension,
  [58904] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    ACTIONS(3352), 1,
      anon_sym_DASHsupportedcommand,
    STATE(1544), 1,
      sym_data_commands_allowed,
    STATE(2076), 1,
      sym_statement_block,
  [58920] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(1526), 1,
      sym_type_literal,
    STATE(2115), 1,
      sym_statement_block,
  [58936] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3352), 1,
      anon_sym_DASHsupportedcommand,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(441), 1,
      sym_statement_block,
    STATE(1697), 1,
      sym_data_commands_allowed,
  [58952] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(603), 4,
      sym__statement_terminator,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_DASH_DASH_PERCENT,
  [58962] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(595), 4,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_DASH_DASH_PERCENT,
  [58972] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2631), 1,
      anon_sym_SEMI,
    STATE(1097), 1,
      aux_sym_script_block_repeat1,
    ACTIONS(3356), 2,
      sym_simple_name,
      anon_sym_RBRACE,
  [58986] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3358), 1,
      anon_sym_EQ,
    STATE(1610), 1,
      sym_script_parameter_default,
    ACTIONS(3360), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [59000] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3342), 1,
      sym_simple_name,
    ACTIONS(3362), 1,
      anon_sym_RBRACE,
    STATE(1391), 1,
      aux_sym_enum_statement_repeat1,
    STATE(2046), 1,
      sym_enum_member,
  [59016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1319), 1,
      aux_sym__verbatim_command_argument_chars,
    ACTIONS(3364), 3,
      aux_sym__verbatim_command_argument_chars_token1,
      aux_sym__verbatim_command_argument_chars_token2,
      aux_sym__verbatim_command_argument_chars_token3,
  [59028] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(603), 4,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_DASH_DASH_PERCENT,
  [59038] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3342), 1,
      sym_simple_name,
    ACTIONS(3366), 1,
      anon_sym_RBRACE,
    STATE(1387), 1,
      aux_sym_enum_statement_repeat1,
    STATE(2046), 1,
      sym_enum_member,
  [59054] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3342), 1,
      sym_simple_name,
    ACTIONS(3368), 1,
      anon_sym_RBRACE,
    STATE(1391), 1,
      aux_sym_enum_statement_repeat1,
    STATE(2046), 1,
      sym_enum_member,
  [59070] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3358), 1,
      anon_sym_EQ,
    STATE(1573), 1,
      sym_script_parameter_default,
    ACTIONS(3370), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [59084] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(470), 1,
      sym_statement_block,
    STATE(1667), 1,
      sym_type_literal,
  [59100] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3374), 1,
      anon_sym_SEMI,
    STATE(1381), 1,
      aux_sym_script_block_repeat1,
    ACTIONS(3372), 2,
      sym_simple_name,
      anon_sym_RBRACE,
  [59114] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3372), 1,
      anon_sym_RBRACE,
    ACTIONS(3376), 1,
      sym_simple_name,
    STATE(1391), 1,
      aux_sym_enum_statement_repeat1,
    STATE(2046), 1,
      sym_enum_member,
  [59130] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3342), 1,
      sym_simple_name,
    ACTIONS(3379), 1,
      anon_sym_RBRACE,
    STATE(1391), 1,
      aux_sym_enum_statement_repeat1,
    STATE(2046), 1,
      sym_enum_member,
  [59146] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    ACTIONS(3381), 1,
      anon_sym_LBRACE,
    STATE(518), 1,
      sym_statement_block,
    STATE(1586), 1,
      sym_type_literal,
  [59162] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3342), 1,
      sym_simple_name,
    ACTIONS(3383), 1,
      anon_sym_RBRACE,
    STATE(1383), 1,
      aux_sym_enum_statement_repeat1,
    STATE(2046), 1,
      sym_enum_member,
  [59178] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1636), 1,
      sym_type_literal,
    STATE(1955), 1,
      sym_statement_block,
  [59194] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2521), 1,
      anon_sym_RBRACK,
    ACTIONS(3385), 3,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
  [59206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1315), 1,
      aux_sym__verbatim_command_argument_chars,
    ACTIONS(3387), 3,
      aux_sym__verbatim_command_argument_chars_token1,
      aux_sym__verbatim_command_argument_chars_token2,
      aux_sym__verbatim_command_argument_chars_token3,
  [59218] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2521), 1,
      sym__statement_terminator,
    ACTIONS(3389), 3,
      anon_sym_DASHand,
      anon_sym_DASHor,
      anon_sym_DASHxor,
  [59230] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(595), 4,
      sym__statement_terminator,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_DASH_DASH_PERCENT,
  [59240] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3352), 1,
      anon_sym_DASHsupportedcommand,
    ACTIONS(3381), 1,
      anon_sym_LBRACE,
    STATE(504), 1,
      sym_statement_block,
    STATE(1659), 1,
      sym_data_commands_allowed,
  [59256] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3342), 1,
      sym_simple_name,
    ACTIONS(3391), 1,
      anon_sym_RBRACE,
    STATE(1374), 1,
      aux_sym_enum_statement_repeat1,
    STATE(2046), 1,
      sym_enum_member,
  [59272] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    ACTIONS(3352), 1,
      anon_sym_DASHsupportedcommand,
    STATE(1653), 1,
      sym_data_commands_allowed,
    STATE(1939), 1,
      sym_statement_block,
  [59288] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3393), 1,
      anon_sym_SEMI,
    ACTIONS(3395), 1,
      anon_sym_RPAREN,
    ACTIONS(3397), 1,
      anon_sym_LF,
  [59301] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3133), 1,
      anon_sym_LPAREN,
    ACTIONS(3137), 1,
      anon_sym_DASHfile,
    STATE(1646), 1,
      sym_switch_condition,
  [59314] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3399), 1,
      anon_sym_DOLLAR,
    ACTIONS(3401), 1,
      aux_sym_expandable_string_literal_token5,
    STATE(1452), 1,
      aux_sym_expandable_string_literal_repeat2,
  [59327] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3403), 1,
      anon_sym_PIPE,
    ACTIONS(3406), 1,
      sym__statement_terminator,
    STATE(1406), 1,
      aux_sym__pipeline_tail,
  [59340] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2405), 1,
      anon_sym_PIPE,
    ACTIONS(3408), 1,
      sym__statement_terminator,
    STATE(1406), 1,
      aux_sym__pipeline_tail,
  [59353] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3410), 3,
      sym__statement_terminator,
      anon_sym_PIPE,
      anon_sym_DASH_DASH_PERCENT,
  [59362] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3412), 1,
      anon_sym_SEMI,
    ACTIONS(3414), 1,
      anon_sym_RPAREN,
    ACTIONS(3416), 1,
      anon_sym_LF,
  [59375] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3418), 1,
      anon_sym_DOLLAR2,
    ACTIONS(3420), 1,
      anon_sym_DQUOTE,
    STATE(1519), 1,
      aux_sym__expandable_string_literal_immediate_repeat2,
  [59388] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3422), 1,
      anon_sym_LPAREN,
    ACTIONS(3424), 1,
      anon_sym_LBRACE,
    STATE(1919), 1,
      sym_function_parameter_declaration,
  [59401] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3260), 1,
      anon_sym_LBRACE,
    STATE(1313), 2,
      sym_script_block_expression,
      aux_sym_foreach_command_repeat1,
  [59412] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1522), 3,
      sym__statement_terminator,
      anon_sym_catch,
      anon_sym_finally,
  [59421] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3426), 1,
      anon_sym_RPAREN,
    ACTIONS(3428), 1,
      anon_sym_COMMA,
    STATE(1414), 1,
      aux_sym_attribute_arguments_repeat1,
  [59434] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3133), 1,
      anon_sym_LPAREN,
    ACTIONS(3137), 1,
      anon_sym_DASHfile,
    STATE(1537), 1,
      sym_switch_condition,
  [59447] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    STATE(1372), 2,
      sym_script_block_expression,
      aux_sym_foreach_command_repeat1,
  [59458] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2405), 1,
      anon_sym_PIPE,
    ACTIONS(3431), 1,
      sym__statement_terminator,
    STATE(1406), 1,
      aux_sym__pipeline_tail,
  [59471] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3433), 1,
      anon_sym_LPAREN,
    ACTIONS(3435), 1,
      anon_sym_DASHparallel,
    STATE(1917), 1,
      sym_foreach_parameter,
  [59484] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2405), 1,
      anon_sym_PIPE,
    ACTIONS(3431), 1,
      sym__statement_terminator,
    STATE(1407), 1,
      aux_sym__pipeline_tail,
  [59497] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1511), 3,
      anon_sym_RPAREN,
      anon_sym_catch,
      anon_sym_finally,
  [59506] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3418), 1,
      anon_sym_DOLLAR2,
    ACTIONS(3437), 1,
      anon_sym_DQUOTE,
    STATE(1519), 1,
      aux_sym__expandable_string_literal_immediate_repeat2,
  [59519] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3439), 1,
      anon_sym_SEMI,
    ACTIONS(3441), 1,
      anon_sym_RPAREN,
    ACTIONS(3443), 1,
      anon_sym_LF,
  [59532] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3418), 1,
      anon_sym_DOLLAR2,
    ACTIONS(3445), 1,
      anon_sym_DQUOTE,
    STATE(1519), 1,
      aux_sym__expandable_string_literal_immediate_repeat2,
  [59545] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2429), 1,
      anon_sym_PIPE,
    ACTIONS(3408), 1,
      anon_sym_RPAREN,
    STATE(1474), 1,
      aux_sym__pipeline_tail,
  [59558] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1524), 1,
      sym__statement_terminator,
    ACTIONS(3240), 1,
      anon_sym_finally,
    STATE(2037), 1,
      sym_finally_clause,
  [59571] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3418), 1,
      anon_sym_DOLLAR2,
    ACTIONS(3447), 1,
      anon_sym_DQUOTE,
    STATE(1519), 1,
      aux_sym__expandable_string_literal_immediate_repeat2,
  [59584] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2429), 1,
      anon_sym_PIPE,
    ACTIONS(3431), 1,
      anon_sym_RPAREN,
    STATE(1424), 1,
      aux_sym__pipeline_tail,
  [59597] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1524), 1,
      anon_sym_RPAREN,
    ACTIONS(3250), 1,
      anon_sym_finally,
    STATE(1923), 1,
      sym_finally_clause,
  [59610] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1498), 1,
      anon_sym_RPAREN,
    ACTIONS(3449), 1,
      anon_sym_else,
    STATE(1893), 1,
      sym_else_clause,
  [59623] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3399), 1,
      anon_sym_DOLLAR,
    ACTIONS(3451), 1,
      aux_sym_expandable_string_literal_token5,
    STATE(1452), 1,
      aux_sym_expandable_string_literal_repeat2,
  [59636] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2870), 1,
      aux_sym_expandable_string_literal_token5,
    ACTIONS(3399), 1,
      anon_sym_DOLLAR,
    STATE(1452), 1,
      aux_sym_expandable_string_literal_repeat2,
  [59649] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3453), 3,
      sym__statement_terminator,
      anon_sym_PIPE,
      anon_sym_DASH_DASH_PERCENT,
  [59658] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3455), 3,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [59667] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1511), 3,
      sym__statement_terminator,
      anon_sym_catch,
      anon_sym_finally,
  [59676] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1480), 1,
      anon_sym_else,
    ACTIONS(1506), 2,
      anon_sym_RPAREN,
      anon_sym_elseif,
  [59687] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3453), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_DASH_DASH_PERCENT,
  [59696] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 1,
      aux_sym_expandable_string_literal_token5,
    ACTIONS(3399), 1,
      anon_sym_DOLLAR,
    STATE(1452), 1,
      aux_sym_expandable_string_literal_repeat2,
  [59709] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3457), 1,
      anon_sym_SEMI,
    ACTIONS(3459), 1,
      anon_sym_RPAREN,
    ACTIONS(3461), 1,
      anon_sym_LF,
  [59722] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2876), 1,
      aux_sym_expandable_string_literal_token5,
    ACTIONS(3399), 1,
      anon_sym_DOLLAR,
    STATE(1452), 1,
      aux_sym_expandable_string_literal_repeat2,
  [59735] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3463), 1,
      anon_sym_COMMA,
    ACTIONS(3466), 1,
      anon_sym_RBRACK,
    STATE(1440), 1,
      aux_sym_dimension_repeat1,
  [59748] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3258), 1,
      anon_sym_LBRACE,
    STATE(1311), 2,
      sym_script_block_expression,
      aux_sym_foreach_command_repeat1,
  [59759] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_COMMA,
    ACTIONS(3470), 1,
      anon_sym_RBRACK,
    STATE(1485), 1,
      aux_sym_generic_type_arguments_repeat1,
  [59772] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3472), 1,
      anon_sym_EQ,
    ACTIONS(3474), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [59783] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3399), 1,
      anon_sym_DOLLAR,
    ACTIONS(3476), 1,
      aux_sym_expandable_string_literal_token5,
    STATE(1452), 1,
      aux_sym_expandable_string_literal_repeat2,
  [59796] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3478), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_DASH_DASH_PERCENT,
  [59805] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2429), 1,
      anon_sym_PIPE,
    ACTIONS(3431), 1,
      anon_sym_RPAREN,
    STATE(1474), 1,
      aux_sym__pipeline_tail,
  [59818] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3399), 1,
      anon_sym_DOLLAR,
    ACTIONS(3480), 1,
      aux_sym_expandable_string_literal_token5,
    STATE(1452), 1,
      aux_sym_expandable_string_literal_repeat2,
  [59831] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3418), 1,
      anon_sym_DOLLAR2,
    ACTIONS(3482), 1,
      anon_sym_DQUOTE,
    STATE(1519), 1,
      aux_sym__expandable_string_literal_immediate_repeat2,
  [59844] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1522), 3,
      anon_sym_RPAREN,
      anon_sym_catch,
      anon_sym_finally,
  [59853] = 4,
    ACTIONS(5), 1,
      sym_decimal_integer_literal,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_hexadecimal_integer_literal,
    STATE(1767), 1,
      sym_integer_literal,
  [59866] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3484), 1,
      anon_sym_COMMA,
    ACTIONS(3486), 1,
      anon_sym_LBRACE,
    STATE(1508), 1,
      aux_sym_class_statement_repeat1,
  [59879] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3488), 1,
      anon_sym_DOLLAR,
    ACTIONS(3491), 1,
      aux_sym_expandable_string_literal_token5,
    STATE(1452), 1,
      aux_sym_expandable_string_literal_repeat2,
  [59892] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_RPAREN,
    ACTIONS(3495), 1,
      anon_sym_COMMA,
    STATE(1515), 1,
      aux_sym_class_method_parameter_list_repeat1,
  [59905] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3484), 1,
      anon_sym_COMMA,
    ACTIONS(3497), 1,
      anon_sym_LBRACE,
    STATE(1508), 1,
      aux_sym_class_statement_repeat1,
  [59918] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 1,
      anon_sym_SEMI,
    ACTIONS(3501), 1,
      anon_sym_RPAREN,
    ACTIONS(3503), 1,
      anon_sym_LF,
  [59931] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3422), 1,
      anon_sym_LPAREN,
    ACTIONS(3505), 1,
      anon_sym_LBRACE,
    STATE(1753), 1,
      sym_function_parameter_declaration,
  [59944] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3507), 1,
      anon_sym_SEMI,
    ACTIONS(3509), 1,
      anon_sym_RPAREN,
    ACTIONS(3511), 1,
      anon_sym_LF,
  [59957] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3513), 1,
      anon_sym_RPAREN,
    ACTIONS(3515), 1,
      anon_sym_COMMA,
    STATE(1482), 1,
      aux_sym_attribute_arguments_repeat1,
  [59970] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3484), 1,
      anon_sym_COMMA,
    ACTIONS(3517), 1,
      anon_sym_LBRACE,
    STATE(1454), 1,
      aux_sym_class_statement_repeat1,
  [59983] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3519), 1,
      anon_sym_SEMI,
    ACTIONS(3521), 1,
      anon_sym_RPAREN,
    ACTIONS(3523), 1,
      anon_sym_LF,
  [59996] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3525), 1,
      sym_type_identifier,
    ACTIONS(3527), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [60007] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3399), 1,
      anon_sym_DOLLAR,
    ACTIONS(3529), 1,
      aux_sym_expandable_string_literal_token5,
    STATE(1452), 1,
      aux_sym_expandable_string_literal_repeat2,
  [60020] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3531), 1,
      anon_sym_RPAREN,
    ACTIONS(3533), 1,
      anon_sym_COMMA,
    STATE(1463), 1,
      aux_sym_argument_expression_list_repeat1,
  [60033] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3536), 1,
      anon_sym_COMMA,
    ACTIONS(3538), 1,
      anon_sym_LBRACE,
    STATE(1494), 1,
      aux_sym_data_commands_list_repeat1,
  [60046] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3540), 1,
      anon_sym_COMMA,
    ACTIONS(3542), 1,
      anon_sym_LBRACE,
    STATE(1491), 1,
      aux_sym_catch_type_list_repeat1,
  [60059] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3544), 1,
      anon_sym_RPAREN,
    ACTIONS(3546), 1,
      anon_sym_COMMA,
    STATE(1479), 1,
      aux_sym_parameter_list_repeat1,
  [60072] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3484), 1,
      anon_sym_COMMA,
    ACTIONS(3548), 1,
      anon_sym_LBRACE,
    STATE(1508), 1,
      aux_sym_class_statement_repeat1,
  [60085] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3422), 1,
      anon_sym_LPAREN,
    ACTIONS(3550), 1,
      anon_sym_LBRACE,
    STATE(1963), 1,
      sym_function_parameter_declaration,
  [60098] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3484), 1,
      anon_sym_COMMA,
    ACTIONS(3552), 1,
      anon_sym_LBRACE,
    STATE(1467), 1,
      aux_sym_class_statement_repeat1,
  [60111] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3554), 1,
      anon_sym_SEMI,
    ACTIONS(3556), 1,
      anon_sym_RPAREN,
    ACTIONS(3558), 1,
      anon_sym_LF,
  [60124] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3560), 1,
      anon_sym_SEMI,
    ACTIONS(3562), 1,
      anon_sym_RPAREN,
    ACTIONS(3564), 1,
      anon_sym_LF,
  [60137] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1498), 1,
      sym__statement_terminator,
    ACTIONS(3566), 1,
      anon_sym_else,
    STATE(1997), 1,
      sym_else_clause,
  [60150] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3540), 1,
      anon_sym_COMMA,
    ACTIONS(3568), 1,
      anon_sym_LBRACE,
    STATE(1465), 1,
      aux_sym_catch_type_list_repeat1,
  [60163] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3406), 1,
      anon_sym_RPAREN,
    ACTIONS(3570), 1,
      anon_sym_PIPE,
    STATE(1474), 1,
      aux_sym__pipeline_tail,
  [60176] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3573), 3,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [60185] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_COMMA,
    ACTIONS(3577), 1,
      anon_sym_RBRACK,
    STATE(1440), 1,
      aux_sym_dimension_repeat1,
  [60198] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3399), 1,
      anon_sym_DOLLAR,
    ACTIONS(3579), 1,
      aux_sym_expandable_string_literal_token5,
    STATE(1452), 1,
      aux_sym_expandable_string_literal_repeat2,
  [60211] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3422), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_LBRACE,
    STATE(1858), 1,
      sym_function_parameter_declaration,
  [60224] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3583), 1,
      anon_sym_RPAREN,
    ACTIONS(3585), 1,
      anon_sym_COMMA,
    STATE(1479), 1,
      aux_sym_parameter_list_repeat1,
  [60237] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2828), 1,
      aux_sym_expandable_string_literal_token5,
    ACTIONS(3399), 1,
      anon_sym_DOLLAR,
    STATE(1452), 1,
      aux_sym_expandable_string_literal_repeat2,
  [60250] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_DASHparallel,
    ACTIONS(3588), 1,
      anon_sym_LPAREN,
    STATE(2114), 1,
      sym_foreach_parameter,
  [60263] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3515), 1,
      anon_sym_COMMA,
    ACTIONS(3590), 1,
      anon_sym_RPAREN,
    STATE(1414), 1,
      aux_sym_attribute_arguments_repeat1,
  [60276] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3418), 1,
      anon_sym_DOLLAR2,
    ACTIONS(3592), 1,
      anon_sym_DQUOTE,
    STATE(1519), 1,
      aux_sym__expandable_string_literal_immediate_repeat2,
  [60289] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_COMMA,
    ACTIONS(3594), 1,
      anon_sym_RBRACK,
    STATE(1442), 1,
      aux_sym_generic_type_arguments_repeat1,
  [60302] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3596), 1,
      anon_sym_COMMA,
    ACTIONS(3599), 1,
      anon_sym_RBRACK,
    STATE(1485), 1,
      aux_sym_generic_type_arguments_repeat1,
  [60315] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3536), 1,
      anon_sym_COMMA,
    ACTIONS(3601), 1,
      anon_sym_LBRACE,
    STATE(1464), 1,
      aux_sym_data_commands_list_repeat1,
  [60328] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3484), 1,
      anon_sym_COMMA,
    ACTIONS(3603), 1,
      anon_sym_LBRACE,
    STATE(1508), 1,
      aux_sym_class_statement_repeat1,
  [60341] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1480), 1,
      anon_sym_else,
    ACTIONS(1506), 2,
      sym__statement_terminator,
      anon_sym_elseif,
  [60352] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3133), 1,
      anon_sym_LPAREN,
    ACTIONS(3137), 1,
      anon_sym_DASHfile,
    STATE(1614), 1,
      sym_switch_condition,
  [60365] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3605), 1,
      anon_sym_RPAREN,
    ACTIONS(3607), 1,
      anon_sym_COMMA,
    STATE(1513), 1,
      aux_sym_argument_expression_list_repeat1,
  [60378] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3609), 1,
      anon_sym_COMMA,
    ACTIONS(3612), 1,
      anon_sym_LBRACE,
    STATE(1491), 1,
      aux_sym_catch_type_list_repeat1,
  [60391] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_DASHparallel,
    ACTIONS(3614), 1,
      anon_sym_LPAREN,
    STATE(2116), 1,
      sym_foreach_parameter,
  [60404] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3616), 1,
      anon_sym_SEMI,
    ACTIONS(3618), 1,
      anon_sym_RPAREN,
    ACTIONS(3620), 1,
      anon_sym_LF,
  [60417] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
    ACTIONS(3625), 1,
      anon_sym_LBRACE,
    STATE(1494), 1,
      aux_sym_data_commands_list_repeat1,
  [60430] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3478), 3,
      sym__statement_terminator,
      anon_sym_PIPE,
      anon_sym_DASH_DASH_PERCENT,
  [60439] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3418), 1,
      anon_sym_DOLLAR2,
    ACTIONS(3627), 1,
      anon_sym_DQUOTE,
    STATE(1519), 1,
      aux_sym__expandable_string_literal_immediate_repeat2,
  [60452] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3133), 1,
      anon_sym_LPAREN,
    ACTIONS(3137), 1,
      anon_sym_DASHfile,
    STATE(1686), 1,
      sym_switch_condition,
  [60465] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3484), 1,
      anon_sym_COMMA,
    ACTIONS(3629), 1,
      anon_sym_LBRACE,
    STATE(1451), 1,
      aux_sym_class_statement_repeat1,
  [60478] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_DASHparallel,
    ACTIONS(3631), 1,
      anon_sym_LPAREN,
    STATE(2118), 1,
      sym_foreach_parameter,
  [60491] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3633), 1,
      anon_sym_SEMI,
    ACTIONS(3635), 1,
      anon_sym_RPAREN,
    ACTIONS(3637), 1,
      anon_sym_LF,
  [60504] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3495), 1,
      anon_sym_COMMA,
    ACTIONS(3639), 1,
      anon_sym_RPAREN,
    STATE(1453), 1,
      aux_sym_class_method_parameter_list_repeat1,
  [60517] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3546), 1,
      anon_sym_COMMA,
    ACTIONS(3641), 1,
      anon_sym_RPAREN,
    STATE(1466), 1,
      aux_sym_parameter_list_repeat1,
  [60530] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2816), 1,
      aux_sym_expandable_string_literal_token5,
    ACTIONS(3399), 1,
      anon_sym_DOLLAR,
    STATE(1452), 1,
      aux_sym_expandable_string_literal_repeat2,
  [60543] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3399), 1,
      anon_sym_DOLLAR,
    ACTIONS(3643), 1,
      aux_sym_expandable_string_literal_token5,
    STATE(1452), 1,
      aux_sym_expandable_string_literal_repeat2,
  [60556] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2878), 1,
      aux_sym_expandable_string_literal_token5,
    ACTIONS(3399), 1,
      anon_sym_DOLLAR,
    STATE(1452), 1,
      aux_sym_expandable_string_literal_repeat2,
  [60569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2814), 1,
      aux_sym_expandable_string_literal_token5,
    ACTIONS(3399), 1,
      anon_sym_DOLLAR,
    STATE(1452), 1,
      aux_sym_expandable_string_literal_repeat2,
  [60582] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3484), 1,
      anon_sym_COMMA,
    ACTIONS(3645), 1,
      anon_sym_LBRACE,
    STATE(1487), 1,
      aux_sym_class_statement_repeat1,
  [60595] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3647), 1,
      anon_sym_COMMA,
    ACTIONS(3650), 1,
      anon_sym_LBRACE,
    STATE(1508), 1,
      aux_sym_class_statement_repeat1,
  [60608] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3399), 1,
      anon_sym_DOLLAR,
    ACTIONS(3652), 1,
      aux_sym_expandable_string_literal_token5,
    STATE(1452), 1,
      aux_sym_expandable_string_literal_repeat2,
  [60621] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3654), 1,
      anon_sym_SEMI,
    ACTIONS(3656), 1,
      anon_sym_RPAREN,
    ACTIONS(3658), 1,
      anon_sym_LF,
  [60634] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3418), 1,
      anon_sym_DOLLAR2,
    ACTIONS(3660), 1,
      anon_sym_DQUOTE,
    STATE(1519), 1,
      aux_sym__expandable_string_literal_immediate_repeat2,
  [60647] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    STATE(1334), 2,
      sym_script_block_expression,
      aux_sym_foreach_command_repeat1,
  [60658] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3607), 1,
      anon_sym_COMMA,
    ACTIONS(3662), 1,
      anon_sym_RPAREN,
    STATE(1463), 1,
      aux_sym_argument_expression_list_repeat1,
  [60671] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3418), 1,
      anon_sym_DOLLAR2,
    ACTIONS(3664), 1,
      anon_sym_DQUOTE,
    STATE(1519), 1,
      aux_sym__expandable_string_literal_immediate_repeat2,
  [60684] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3666), 1,
      anon_sym_RPAREN,
    ACTIONS(3668), 1,
      anon_sym_COMMA,
    STATE(1515), 1,
      aux_sym_class_method_parameter_list_repeat1,
  [60697] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3418), 1,
      anon_sym_DOLLAR2,
    ACTIONS(3671), 1,
      anon_sym_DQUOTE,
    STATE(1519), 1,
      aux_sym__expandable_string_literal_immediate_repeat2,
  [60710] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2812), 1,
      aux_sym_expandable_string_literal_token5,
    ACTIONS(3399), 1,
      anon_sym_DOLLAR,
    STATE(1452), 1,
      aux_sym_expandable_string_literal_repeat2,
  [60723] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3410), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_DASH_DASH_PERCENT,
  [60732] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3673), 1,
      anon_sym_DOLLAR2,
    ACTIONS(3676), 1,
      anon_sym_DQUOTE,
    STATE(1519), 1,
      aux_sym__expandable_string_literal_immediate_repeat2,
  [60745] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(434), 1,
      sym_statement_block,
  [60755] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_LBRACE,
    STATE(106), 1,
      sym_script_block_expression,
  [60765] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3678), 1,
      anon_sym_LPAREN,
    ACTIONS(3680), 1,
      anon_sym_RBRACK,
  [60775] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1529), 1,
      sym_statement_block,
  [60785] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2437), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [60793] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3682), 1,
      anon_sym_LBRACE,
    STATE(2105), 1,
      sym_switch_body,
  [60803] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(2081), 1,
      sym_statement_block,
  [60813] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1530), 1,
      sym_statement_block,
  [60823] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1531), 1,
      sym_statement_block,
  [60833] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3684), 2,
      anon_sym_while,
      anon_sym_until,
  [60841] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3686), 2,
      anon_sym_while,
      anon_sym_until,
  [60849] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3688), 2,
      anon_sym_while,
      anon_sym_until,
  [60857] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3690), 1,
      anon_sym_EQ,
    ACTIONS(3692), 1,
      sym__statement_terminator,
  [60867] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1105), 1,
      anon_sym_LBRACE,
    STATE(995), 1,
      sym_script_block_expression,
  [60877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3694), 1,
      sym__command_token,
    STATE(1468), 1,
      sym_function_name,
  [60887] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1567), 1,
      sym_statement_block,
  [60897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3694), 1,
      sym__command_token,
    STATE(1411), 1,
      sym_function_name,
  [60907] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3682), 1,
      anon_sym_LBRACE,
    STATE(2060), 1,
      sym_switch_body,
  [60917] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(2111), 1,
      sym_statement_block,
  [60927] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(2045), 1,
      sym_statement_block,
  [60937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3694), 1,
      sym__command_token,
    STATE(1456), 1,
      sym_function_name,
  [60947] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(2112), 1,
      sym_statement_block,
  [60957] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(2113), 1,
      sym_statement_block,
  [60967] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(2040), 1,
      sym_statement_block,
  [60977] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(2036), 1,
      sym_statement_block,
  [60987] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(1303), 1,
      sym_statement_block,
  [60997] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3696), 1,
      anon_sym_EQ,
    ACTIONS(3698), 1,
      sym__statement_terminator,
  [61007] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3309), 1,
      anon_sym_LBRACE,
    STATE(310), 1,
      sym_statement_block,
  [61017] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3700), 1,
      sym_simple_name,
    STATE(1400), 1,
      sym_data_name,
  [61027] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3702), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [61035] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_LBRACE,
    STATE(479), 1,
      sym_statement_block,
  [61045] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_LBRACE,
    STATE(530), 1,
      sym_statement_block,
  [61055] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(1302), 1,
      sym_statement_block,
  [61065] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_LBRACE,
    STATE(529), 1,
      sym_statement_block,
  [61075] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(2027), 1,
      sym_statement_block,
  [61085] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(2026), 1,
      sym_statement_block,
  [61095] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3694), 1,
      sym__command_token,
    STATE(1478), 1,
      sym_function_name,
  [61105] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3678), 1,
      anon_sym_LPAREN,
    ACTIONS(3704), 1,
      anon_sym_RBRACK,
  [61115] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(1434), 1,
      sym_statement_block,
  [61125] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3599), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [61133] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1330), 1,
      sym_statement_block,
  [61143] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3706), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [61151] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3708), 1,
      anon_sym_LBRACE,
    STATE(484), 1,
      sym_switch_body,
  [61161] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3406), 2,
      anon_sym_RPAREN,
      anon_sym_PIPE,
  [61169] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(2003), 1,
      sym_statement_block,
  [61179] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(2002), 1,
      sym_statement_block,
  [61189] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3710), 1,
      anon_sym_LBRACE,
    ACTIONS(3712), 1,
      anon_sym_COLON,
  [61199] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3714), 2,
      anon_sym_while,
      anon_sym_until,
  [61207] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3583), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [61215] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(1998), 1,
      sym_statement_block,
  [61225] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(1996), 1,
      sym_statement_block,
  [61235] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(1995), 1,
      sym_statement_block,
  [61245] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(1992), 1,
      sym_statement_block,
  [61255] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3716), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [61263] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3718), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [61271] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(1984), 1,
      sym_statement_block,
  [61281] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(1983), 1,
      sym_statement_block,
  [61291] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(1980), 1,
      sym_statement_block,
  [61301] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(1976), 1,
      sym_statement_block,
  [61311] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3700), 1,
      sym_simple_name,
    STATE(1402), 1,
      sym_data_name,
  [61321] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(1974), 1,
      sym_statement_block,
  [61331] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(1488), 1,
      sym_statement_block,
  [61341] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(1888), 1,
      sym_statement_block,
  [61351] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(1970), 1,
      sym_statement_block,
  [61361] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(1969), 1,
      sym_statement_block,
  [61371] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(1967), 1,
      sym_statement_block,
  [61381] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_LBRACE,
    STATE(496), 1,
      sym_statement_block,
  [61391] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_LBRACE,
    STATE(517), 1,
      sym_statement_block,
  [61401] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3309), 1,
      anon_sym_LBRACE,
    STATE(401), 1,
      sym_statement_block,
  [61411] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3720), 2,
      anon_sym_LBRACE,
      anon_sym_DASHsupportedcommand,
  [61419] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3722), 1,
      anon_sym_LBRACE,
    ACTIONS(3724), 1,
      anon_sym_COLON,
  [61429] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3726), 1,
      anon_sym_LBRACE,
    ACTIONS(3728), 1,
      anon_sym_COLON,
  [61439] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3700), 1,
      sym_simple_name,
    STATE(1376), 1,
      sym_data_name,
  [61449] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_LBRACE,
    STATE(486), 1,
      sym_statement_block,
  [61459] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(107), 1,
      anon_sym_LBRACE,
    STATE(148), 1,
      sym_script_block_expression,
  [61469] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3730), 1,
      anon_sym_EQ,
    ACTIONS(3732), 1,
      sym__statement_terminator,
  [61479] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_LBRACE,
    STATE(526), 1,
      sym_statement_block,
  [61489] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_LBRACE,
    STATE(536), 1,
      sym_statement_block,
  [61499] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_LBRACE,
    STATE(514), 1,
      sym_statement_block,
  [61509] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3734), 1,
      anon_sym_LBRACE,
    ACTIONS(3736), 1,
      anon_sym_COLON,
  [61519] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_LBRACE,
    STATE(534), 1,
      sym_statement_block,
  [61529] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACE,
    STATE(1952), 1,
      sym_statement_block,
  [61539] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_LBRACE,
    STATE(533), 1,
      sym_statement_block,
  [61549] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_LBRACE,
    STATE(532), 1,
      sym_statement_block,
  [61559] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3738), 1,
      anon_sym_LBRACE,
    STATE(397), 1,
      sym_statement_block,
  [61569] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3738), 1,
      anon_sym_LBRACE,
    STATE(313), 1,
      sym_statement_block,
  [61579] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3700), 1,
      sym_simple_name,
    STATE(1378), 1,
      sym_data_name,
  [61589] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_LBRACE,
    STATE(494), 1,
      sym_statement_block,
  [61599] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_LBRACE,
    STATE(527), 1,
      sym_statement_block,
  [61609] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(131), 1,
      anon_sym_LBRACK,
    STATE(1694), 1,
      sym_type_literal,
  [61619] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3370), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [61627] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3740), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [61635] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_LBRACE,
    STATE(513), 1,
      sym_statement_block,
  [61645] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3742), 1,
      anon_sym_EQ,
    ACTIONS(3744), 1,
      sym__statement_terminator,
  [61655] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3708), 1,
      anon_sym_LBRACE,
    STATE(495), 1,
      sym_switch_body,
  [61665] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3474), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [61673] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_LBRACE,
    STATE(511), 1,
      sym_statement_block,
  [61683] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(448), 1,
      sym_statement_block,
  [61693] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1308), 1,
      sym_statement_block,
  [61703] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1954), 1,
      sym_statement_block,
  [61713] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1950), 1,
      sym_statement_block,
  [61723] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1949), 1,
      sym_statement_block,
  [61733] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_LBRACE,
    STATE(510), 1,
      sym_statement_block,
  [61743] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(418), 1,
      sym_statement_block,
  [61753] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(419), 1,
      sym_statement_block,
  [61763] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(423), 1,
      sym_statement_block,
  [61773] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    STATE(383), 1,
      sym_statement_block,
  [61783] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1891), 1,
      anon_sym_LBRACE,
    STATE(910), 1,
      sym_script_block_expression,
  [61793] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(424), 1,
      sym_statement_block,
  [61803] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(427), 1,
      sym_statement_block,
  [61813] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(429), 1,
      sym_statement_block,
  [61823] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(432), 1,
      sym_statement_block,
  [61833] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_LBRACE,
    STATE(485), 1,
      sym_statement_block,
  [61843] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_LBRACE,
    STATE(509), 1,
      sym_statement_block,
  [61853] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3748), 1,
      anon_sym_LBRACE,
    STATE(1942), 1,
      sym_switch_body,
  [61863] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(438), 1,
      sym_statement_block,
  [61873] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1941), 1,
      sym_statement_block,
  [61883] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(439), 1,
      sym_statement_block,
  [61893] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(440), 1,
      sym_statement_block,
  [61903] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3666), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [61911] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3531), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [61919] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1989), 1,
      anon_sym_LBRACE,
    STATE(894), 1,
      sym_script_block_expression,
  [61929] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(443), 1,
      sym_statement_block,
  [61939] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1059), 1,
      anon_sym_LBRACE,
    STATE(966), 1,
      sym_script_block_expression,
  [61949] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3650), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [61957] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3305), 1,
      anon_sym_LBRACE,
    STATE(293), 1,
      sym_statement_block,
  [61967] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3748), 1,
      anon_sym_LBRACE,
    STATE(1938), 1,
      sym_switch_body,
  [61977] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(467), 1,
      sym_statement_block,
  [61987] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1932), 1,
      sym_statement_block,
  [61997] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(464), 1,
      sym_statement_block,
  [62007] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1921), 1,
      anon_sym_LBRACE,
    STATE(812), 1,
      sym_script_block_expression,
  [62017] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(451), 1,
      sym_statement_block,
  [62027] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1925), 1,
      sym_statement_block,
  [62037] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1921), 1,
      sym_statement_block,
  [62047] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(455), 1,
      sym_statement_block,
  [62057] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(457), 1,
      sym_statement_block,
  [62067] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3750), 1,
      anon_sym_EQ,
    ACTIONS(3752), 1,
      sym__statement_terminator,
  [62077] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_LBRACE,
    STATE(481), 1,
      sym_statement_block,
  [62087] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3305), 1,
      anon_sym_LBRACE,
    STATE(376), 1,
      sym_statement_block,
  [62097] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_LBRACE,
    STATE(537), 1,
      sym_statement_block,
  [62107] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1309), 1,
      sym_statement_block,
  [62117] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3678), 1,
      anon_sym_LPAREN,
    ACTIONS(3754), 1,
      anon_sym_RBRACK,
  [62127] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1907), 1,
      sym_statement_block,
  [62137] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1905), 1,
      sym_statement_block,
  [62147] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3756), 1,
      anon_sym_LBRACE,
    STATE(433), 1,
      sym_switch_body,
  [62157] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3758), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [62165] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1420), 1,
      sym_statement_block,
  [62175] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(436), 1,
      sym_statement_block,
  [62185] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(469), 1,
      sym_statement_block,
  [62195] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(413), 1,
      sym_statement_block,
  [62205] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_LBRACE,
    STATE(499), 1,
      sym_statement_block,
  [62215] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1899), 1,
      sym_statement_block,
  [62225] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1898), 1,
      sym_statement_block,
  [62235] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(461), 1,
      sym_statement_block,
  [62245] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_LBRACE,
    STATE(501), 1,
      sym_statement_block,
  [62255] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3406), 2,
      sym__statement_terminator,
      anon_sym_PIPE,
  [62263] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1894), 1,
      sym_statement_block,
  [62273] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1892), 1,
      sym_statement_block,
  [62283] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1891), 1,
      sym_statement_block,
  [62293] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1890), 1,
      sym_statement_block,
  [62303] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    STATE(295), 1,
      sym_statement_block,
  [62313] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3760), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [62321] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1862), 1,
      sym_statement_block,
  [62331] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1887), 1,
      sym_statement_block,
  [62341] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1886), 1,
      sym_statement_block,
  [62351] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1885), 1,
      sym_statement_block,
  [62361] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3756), 1,
      anon_sym_LBRACE,
    STATE(450), 1,
      sym_switch_body,
  [62371] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1881), 1,
      sym_statement_block,
  [62381] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1435), 1,
      sym_statement_block,
  [62391] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1880), 1,
      sym_statement_block,
  [62401] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1879), 1,
      sym_statement_block,
  [62411] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1877), 1,
      sym_statement_block,
  [62421] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3320), 1,
      anon_sym_LBRACE,
    STATE(1873), 1,
      sym_statement_block,
  [62431] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3426), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [62439] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3612), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [62447] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_LBRACE,
    STATE(491), 1,
      sym_statement_block,
  [62457] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3625), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [62465] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(475), 1,
      sym_statement_block,
  [62475] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_LBRACE,
    STATE(811), 1,
      sym_script_block_expression,
  [62485] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(466), 1,
      sym_statement_block,
  [62495] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3762), 1,
      anon_sym_LBRACE,
  [62502] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_RPAREN,
  [62509] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3764), 1,
      anon_sym_RPAREN,
  [62516] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3766), 1,
      anon_sym_RBRACE,
  [62523] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3768), 1,
      anon_sym_RBRACE,
  [62530] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3770), 1,
      anon_sym_RBRACK,
  [62537] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3772), 1,
      anon_sym_RBRACK,
  [62544] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3774), 1,
      anon_sym_LPAREN,
  [62551] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3776), 1,
      anon_sym_RBRACE,
  [62558] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3778), 1,
      anon_sym_RPAREN,
  [62565] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_RPAREN,
  [62572] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3782), 1,
      anon_sym_RBRACE,
  [62579] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3784), 1,
      anon_sym_RPAREN,
  [62586] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3786), 1,
      sym__statement_terminator,
  [62593] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3788), 1,
      anon_sym_RBRACE,
  [62600] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3001), 1,
      anon_sym_RPAREN,
  [62607] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3790), 1,
      sym_simple_name,
  [62614] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3792), 1,
      sym__statement_terminator,
  [62621] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3794), 1,
      anon_sym_RPAREN,
  [62628] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3796), 1,
      anon_sym_RBRACE,
  [62635] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3798), 1,
      anon_sym_LBRACE,
  [62642] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3800), 1,
      anon_sym_RPAREN,
  [62649] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3802), 1,
      anon_sym_RPAREN,
  [62656] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3804), 1,
      anon_sym_RBRACE,
  [62663] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3806), 1,
      anon_sym_RBRACE,
  [62670] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3808), 1,
      anon_sym_RBRACE,
  [62677] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3810), 1,
      anon_sym_RBRACE,
  [62684] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3812), 1,
      anon_sym_RPAREN,
  [62691] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3814), 1,
      anon_sym_RPAREN,
  [62698] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3816), 1,
      anon_sym_RBRACK,
  [62705] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3818), 1,
      anon_sym_RBRACK,
  [62712] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3043), 1,
      anon_sym_RPAREN,
  [62719] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3820), 1,
      anon_sym_RPAREN,
  [62726] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3822), 1,
      anon_sym_RBRACE,
  [62733] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3824), 1,
      anon_sym_RBRACK,
  [62740] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3826), 1,
      anon_sym_RPAREN,
  [62747] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3828), 1,
      anon_sym_RBRACE,
  [62754] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3830), 1,
      anon_sym_RBRACE,
  [62761] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3832), 1,
      anon_sym_RBRACK,
  [62768] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3834), 1,
      sym__statement_terminator,
  [62775] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3752), 1,
      sym__statement_terminator,
  [62782] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3836), 1,
      anon_sym_LPAREN,
  [62789] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3838), 1,
      anon_sym_RPAREN,
  [62796] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3840), 1,
      anon_sym_RPAREN,
  [62803] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3842), 1,
      anon_sym_RBRACE,
  [62810] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3844), 1,
      anon_sym_RPAREN,
  [62817] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3846), 1,
      anon_sym_RPAREN,
  [62824] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3848), 1,
      anon_sym_RPAREN,
  [62831] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3850), 1,
      anon_sym_RBRACE,
  [62838] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3852), 1,
      anon_sym_in,
  [62845] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3854), 1,
      anon_sym_RBRACK,
  [62852] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3856), 1,
      anon_sym_RBRACE,
  [62859] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3858), 1,
      anon_sym_RBRACE,
  [62866] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3860), 1,
      anon_sym_LBRACE,
  [62873] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3862), 1,
      anon_sym_RBRACK,
  [62880] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3864), 1,
      anon_sym_RPAREN,
  [62887] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3866), 1,
      anon_sym_RBRACE,
  [62894] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3868), 1,
      anon_sym_RPAREN,
  [62901] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3870), 1,
      anon_sym_RBRACK,
  [62908] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3872), 1,
      anon_sym_LPAREN,
  [62915] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3874), 1,
      anon_sym_RBRACE,
  [62922] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3876), 1,
      anon_sym_RBRACE,
  [62929] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3878), 1,
      anon_sym_RBRACK,
  [62936] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym_RBRACK,
  [62943] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3882), 1,
      anon_sym_RBRACK,
  [62950] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3884), 1,
      anon_sym_RPAREN,
  [62957] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3886), 1,
      anon_sym_RBRACE,
  [62964] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3888), 1,
      sym__statement_terminator,
  [62971] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3890), 1,
      anon_sym_RPAREN,
  [62978] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3892), 1,
      anon_sym_RPAREN,
  [62985] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3894), 1,
      anon_sym_RBRACE,
  [62992] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3896), 1,
      anon_sym_RBRACE,
  [62999] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3898), 1,
      anon_sym_RBRACK,
  [63006] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3900), 1,
      anon_sym_RBRACE,
  [63013] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3902), 1,
      anon_sym_RBRACE,
  [63020] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3904), 1,
      anon_sym_RPAREN,
  [63027] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3906), 1,
      anon_sym_RBRACK,
  [63034] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3908), 1,
      anon_sym_RPAREN,
  [63041] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3910), 1,
      anon_sym_RBRACK,
  [63048] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3912), 1,
      anon_sym_RBRACE,
  [63055] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3914), 1,
      anon_sym_RPAREN,
  [63062] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3916), 1,
      sym__statement_terminator,
  [63069] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3918), 1,
      sym__statement_terminator,
  [63076] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3920), 1,
      anon_sym_RBRACK,
  [63083] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3922), 1,
      anon_sym_RPAREN,
  [63090] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3924), 1,
      anon_sym_RPAREN,
  [63097] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3926), 1,
      anon_sym_RBRACK,
  [63104] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3928), 1,
      anon_sym_RPAREN,
  [63111] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3930), 1,
      anon_sym_RBRACE,
  [63118] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3932), 1,
      anon_sym_RBRACE,
  [63125] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3934), 1,
      anon_sym_RPAREN,
  [63132] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3936), 1,
      anon_sym_RPAREN,
  [63139] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3938), 1,
      anon_sym_RBRACE,
  [63146] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_RPAREN,
  [63153] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3942), 1,
      sym__statement_terminator,
  [63160] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3944), 1,
      anon_sym_RBRACE,
  [63167] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3946), 1,
      anon_sym_RBRACE,
  [63174] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3948), 1,
      anon_sym_RBRACK,
  [63181] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3950), 1,
      anon_sym_RBRACK,
  [63188] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3952), 1,
      anon_sym_RPAREN,
  [63195] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3954), 1,
      anon_sym_in,
  [63202] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3956), 1,
      anon_sym_RBRACK,
  [63209] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3958), 1,
      anon_sym_RBRACE,
  [63216] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3960), 1,
      anon_sym_RPAREN,
  [63223] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3962), 1,
      anon_sym_RBRACE,
  [63230] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3964), 1,
      sym__statement_terminator,
  [63237] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3966), 1,
      anon_sym_RPAREN,
  [63244] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3968), 1,
      anon_sym_RPAREN,
  [63251] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3970), 1,
      sym_simple_name,
  [63258] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3972), 1,
      anon_sym_RBRACE,
  [63265] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3974), 1,
      anon_sym_RPAREN,
  [63272] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3976), 1,
      anon_sym_RBRACE,
  [63279] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3978), 1,
      sym__statement_terminator,
  [63286] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3980), 1,
      anon_sym_RPAREN,
  [63293] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3982), 1,
      anon_sym_LBRACE,
  [63300] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_RBRACK,
  [63307] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3986), 1,
      anon_sym_RPAREN,
  [63314] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3244), 1,
      anon_sym_LBRACE,
  [63321] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3988), 1,
      anon_sym_RPAREN,
  [63328] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3990), 1,
      sym__statement_terminator,
  [63335] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3992), 1,
      anon_sym_RPAREN,
  [63342] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3994), 1,
      anon_sym_RPAREN,
  [63349] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3996), 1,
      anon_sym_RPAREN,
  [63356] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3045), 1,
      anon_sym_RPAREN,
  [63363] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3732), 1,
      sym__statement_terminator,
  [63370] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_LPAREN,
  [63377] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4000), 1,
      anon_sym_RBRACK,
  [63384] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4002), 1,
      anon_sym_RPAREN,
  [63391] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4004), 1,
      anon_sym_RPAREN,
  [63398] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4006), 1,
      anon_sym_LPAREN,
  [63405] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4008), 1,
      anon_sym_RBRACE,
  [63412] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4010), 1,
      anon_sym_RPAREN,
  [63419] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4012), 1,
      anon_sym_LPAREN,
  [63426] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4014), 1,
      anon_sym_RBRACE,
  [63433] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4016), 1,
      anon_sym_RBRACE,
  [63440] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4018), 1,
      anon_sym_RBRACE,
  [63447] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4020), 1,
      anon_sym_LBRACE,
  [63454] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4022), 1,
      anon_sym_RBRACK,
  [63461] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3041), 1,
      anon_sym_RPAREN,
  [63468] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(213), 1,
      sym__statement_terminator,
  [63475] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_RBRACE,
  [63482] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4026), 1,
      sym__statement_terminator,
  [63489] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4028), 1,
      anon_sym_RBRACE,
  [63496] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3007), 1,
      anon_sym_RPAREN,
  [63503] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
  [63510] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3704), 1,
      anon_sym_RBRACK,
  [63517] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3242), 1,
      anon_sym_LBRACE,
  [63524] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4032), 1,
      anon_sym_RBRACE,
  [63531] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4034), 1,
      sym__statement_terminator,
  [63538] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4036), 1,
      anon_sym_RBRACE,
  [63545] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4038), 1,
      anon_sym_RPAREN,
  [63552] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4040), 1,
      anon_sym_LBRACE,
  [63559] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4042), 1,
      anon_sym_LBRACE,
  [63566] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4044), 1,
      anon_sym_LPAREN,
  [63573] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4046), 1,
      anon_sym_RBRACK,
  [63580] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4048), 1,
      anon_sym_RPAREN,
  [63587] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4050), 1,
      anon_sym_RPAREN,
  [63594] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4052), 1,
      anon_sym_RPAREN,
  [63601] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_LBRACE,
  [63608] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4056), 1,
      sym__statement_terminator,
  [63615] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4058), 1,
      anon_sym_RPAREN,
  [63622] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4060), 1,
      anon_sym_RPAREN,
  [63629] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1708), 1,
      anon_sym_RPAREN,
  [63636] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4062), 1,
      sym_type_identifier,
  [63643] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4064), 1,
      anon_sym_LBRACE,
  [63650] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4066), 1,
      anon_sym_RPAREN,
  [63657] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4068), 1,
      anon_sym_RPAREN,
  [63664] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4070), 1,
      anon_sym_RBRACK,
  [63671] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4072), 1,
      sym__statement_terminator,
  [63678] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4074), 1,
      anon_sym_RPAREN,
  [63685] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4076), 1,
      anon_sym_RPAREN,
  [63692] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4078), 1,
      anon_sym_RBRACE,
  [63699] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_RPAREN,
  [63706] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1793), 1,
      anon_sym_RPAREN,
  [63713] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4080), 1,
      anon_sym_RPAREN,
  [63720] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4082), 1,
      anon_sym_RPAREN,
  [63727] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_RPAREN,
  [63734] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1807), 1,
      anon_sym_RPAREN,
  [63741] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4086), 1,
      anon_sym_RPAREN,
  [63748] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1805), 1,
      anon_sym_RPAREN,
  [63755] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1803), 1,
      anon_sym_RPAREN,
  [63762] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1795), 1,
      anon_sym_RPAREN,
  [63769] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1728), 1,
      anon_sym_RPAREN,
  [63776] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4088), 1,
      anon_sym_LPAREN,
  [63783] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4090), 1,
      sym__statement_terminator,
  [63790] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1716), 1,
      anon_sym_RPAREN,
  [63797] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1712), 1,
      anon_sym_RPAREN,
  [63804] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1710), 1,
      anon_sym_RPAREN,
  [63811] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1803), 1,
      sym__statement_terminator,
  [63818] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1706), 1,
      anon_sym_RPAREN,
  [63825] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1696), 1,
      anon_sym_RPAREN,
  [63832] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1694), 1,
      anon_sym_RPAREN,
  [63839] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1686), 1,
      anon_sym_RPAREN,
  [63846] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1682), 1,
      anon_sym_RPAREN,
  [63853] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1680), 1,
      anon_sym_RPAREN,
  [63860] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1672), 1,
      anon_sym_RPAREN,
  [63867] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1704), 1,
      anon_sym_RPAREN,
  [63874] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1714), 1,
      anon_sym_RPAREN,
  [63881] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_RPAREN,
  [63888] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1722), 1,
      anon_sym_RPAREN,
  [63895] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1789), 1,
      anon_sym_RPAREN,
  [63902] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1797), 1,
      anon_sym_RPAREN,
  [63909] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4092), 1,
      anon_sym_LPAREN,
  [63916] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_RPAREN,
  [63923] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1674), 1,
      anon_sym_RPAREN,
  [63930] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1670), 1,
      anon_sym_RPAREN,
  [63937] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4094), 1,
      sym__statement_terminator,
  [63944] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1809), 1,
      anon_sym_RPAREN,
  [63951] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1791), 1,
      anon_sym_RPAREN,
  [63958] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_RPAREN,
  [63965] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4098), 1,
      ts_builtin_sym_end,
  [63972] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1692), 1,
      anon_sym_RPAREN,
  [63979] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4100), 1,
      sym__statement_terminator,
  [63986] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4102), 1,
      anon_sym_LBRACE,
  [63993] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4104), 1,
      anon_sym_EQ,
  [64000] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4106), 1,
      anon_sym_LPAREN,
  [64007] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4108), 1,
      anon_sym_RPAREN,
  [64014] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4110), 1,
      anon_sym_LPAREN,
  [64021] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4112), 1,
      anon_sym_RPAREN,
  [64028] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4114), 1,
      anon_sym_LBRACE,
  [64035] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4116), 1,
      anon_sym_EQ,
  [64042] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1811), 1,
      anon_sym_RPAREN,
  [64049] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4118), 1,
      anon_sym_RPAREN,
  [64056] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1660), 1,
      anon_sym_RPAREN,
  [64063] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4120), 1,
      anon_sym_RPAREN,
  [64070] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1662), 1,
      anon_sym_RPAREN,
  [64077] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4122), 1,
      anon_sym_RPAREN,
  [64084] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1664), 1,
      anon_sym_RPAREN,
  [64091] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4124), 1,
      anon_sym_RPAREN,
  [64098] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4126), 1,
      anon_sym_RPAREN,
  [64105] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4128), 1,
      anon_sym_LBRACE,
  [64112] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4130), 1,
      anon_sym_LBRACE,
  [64119] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_RPAREN,
  [64126] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4132), 1,
      anon_sym_RPAREN,
  [64133] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4134), 1,
      anon_sym_RPAREN,
  [64140] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4136), 1,
      anon_sym_RPAREN,
  [64147] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1684), 1,
      anon_sym_RPAREN,
  [64154] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4138), 1,
      anon_sym_RPAREN,
  [64161] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1688), 1,
      anon_sym_RPAREN,
  [64168] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1700), 1,
      anon_sym_RPAREN,
  [64175] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1524), 1,
      anon_sym_RPAREN,
  [64182] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1690), 1,
      anon_sym_RPAREN,
  [64189] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1666), 1,
      anon_sym_RPAREN,
  [64196] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4140), 1,
      anon_sym_RPAREN,
  [64203] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4142), 1,
      anon_sym_RBRACE,
  [64210] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4144), 1,
      sym__statement_terminator,
  [64217] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3680), 1,
      anon_sym_RBRACK,
  [64224] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4146), 1,
      anon_sym_RBRACE,
  [64231] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4148), 1,
      sym__statement_terminator,
  [64238] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1799), 1,
      anon_sym_RPAREN,
  [64245] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1801), 1,
      anon_sym_RPAREN,
  [64252] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4150), 1,
      anon_sym_LBRACE,
  [64259] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4152), 1,
      sym__statement_terminator,
  [64266] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4154), 1,
      anon_sym_RBRACE,
  [64273] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1658), 1,
      anon_sym_RPAREN,
  [64280] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1724), 1,
      anon_sym_RPAREN,
  [64287] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1702), 1,
      anon_sym_RPAREN,
  [64294] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4156), 1,
      anon_sym_RBRACE,
  [64301] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_LBRACE,
  [64308] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4160), 1,
      anon_sym_LPAREN,
  [64315] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4162), 1,
      anon_sym_RPAREN,
  [64322] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3786), 1,
      anon_sym_RPAREN,
  [64329] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4164), 1,
      anon_sym_RPAREN,
  [64336] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4166), 1,
      anon_sym_LBRACE,
  [64343] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4168), 1,
      anon_sym_RPAREN,
  [64350] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1656), 1,
      anon_sym_RPAREN,
  [64357] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4170), 1,
      anon_sym_RPAREN,
  [64364] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1793), 1,
      sym__statement_terminator,
  [64371] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4172), 1,
      anon_sym_RPAREN,
  [64378] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1807), 1,
      sym__statement_terminator,
  [64385] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1805), 1,
      sym__statement_terminator,
  [64392] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1706), 1,
      sym__statement_terminator,
  [64399] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4174), 1,
      anon_sym_RPAREN,
  [64406] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4176), 1,
      anon_sym_RPAREN,
  [64413] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1795), 1,
      sym__statement_terminator,
  [64420] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1728), 1,
      sym__statement_terminator,
  [64427] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1716), 1,
      sym__statement_terminator,
  [64434] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4178), 1,
      anon_sym_RPAREN,
  [64441] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4180), 1,
      anon_sym_RPAREN,
  [64448] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4182), 1,
      anon_sym_RPAREN,
  [64455] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1712), 1,
      sym__statement_terminator,
  [64462] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4184), 1,
      anon_sym_RPAREN,
  [64469] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4186), 1,
      anon_sym_RBRACE,
  [64476] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1710), 1,
      sym__statement_terminator,
  [64483] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1708), 1,
      sym__statement_terminator,
  [64490] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4188), 1,
      anon_sym_RPAREN,
  [64497] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4190), 1,
      anon_sym_RBRACE,
  [64504] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4192), 1,
      anon_sym_RBRACE,
  [64511] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4194), 1,
      anon_sym_RBRACE,
  [64518] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4196), 1,
      anon_sym_LBRACE,
  [64525] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4198), 1,
      anon_sym_RPAREN,
  [64532] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1656), 1,
      sym__statement_terminator,
  [64539] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1696), 1,
      sym__statement_terminator,
  [64546] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4200), 1,
      anon_sym_LPAREN,
  [64553] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4202), 1,
      anon_sym_RBRACK,
  [64560] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1694), 1,
      sym__statement_terminator,
  [64567] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1686), 1,
      sym__statement_terminator,
  [64574] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1682), 1,
      sym__statement_terminator,
  [64581] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1680), 1,
      sym__statement_terminator,
  [64588] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1672), 1,
      sym__statement_terminator,
  [64595] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1704), 1,
      sym__statement_terminator,
  [64602] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1714), 1,
      sym__statement_terminator,
  [64609] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1718), 1,
      sym__statement_terminator,
  [64616] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1722), 1,
      sym__statement_terminator,
  [64623] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4204), 1,
      anon_sym_param,
  [64630] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4206), 1,
      anon_sym_LPAREN,
  [64637] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4208), 1,
      anon_sym_RPAREN,
  [64644] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4210), 1,
      sym_simple_name,
  [64651] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4212), 1,
      sym_simple_name,
  [64658] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4214), 1,
      anon_sym_param,
  [64665] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_LPAREN,
  [64672] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1789), 1,
      sym__statement_terminator,
  [64679] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym__statement_terminator,
  [64686] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1797), 1,
      sym__statement_terminator,
  [64693] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4218), 1,
      sym__statement_terminator,
  [64700] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4220), 1,
      anon_sym_LPAREN,
  [64707] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4222), 1,
      sym_simple_name,
  [64714] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1726), 1,
      sym__statement_terminator,
  [64721] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4224), 1,
      sym__statement_terminator,
  [64728] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1674), 1,
      sym__statement_terminator,
  [64735] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4226), 1,
      sym__statement_terminator,
  [64742] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4228), 1,
      sym__statement_terminator,
  [64749] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2407), 1,
      sym__statement_terminator,
  [64756] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4230), 1,
      sym__statement_terminator,
  [64763] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4232), 1,
      sym__statement_terminator,
  [64770] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4234), 1,
      sym__statement_terminator,
  [64777] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1670), 1,
      sym__statement_terminator,
  [64784] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1809), 1,
      sym__statement_terminator,
  [64791] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1791), 1,
      sym__statement_terminator,
  [64798] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1720), 1,
      sym__statement_terminator,
  [64805] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4236), 1,
      sym__statement_terminator,
  [64812] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4238), 1,
      ts_builtin_sym_end,
  [64819] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4240), 1,
      ts_builtin_sym_end,
  [64826] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4242), 1,
      sym_simple_name,
  [64833] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4244), 1,
      sym_simple_name,
  [64840] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1692), 1,
      sym__statement_terminator,
  [64847] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1811), 1,
      sym__statement_terminator,
  [64854] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1660), 1,
      sym__statement_terminator,
  [64861] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_RBRACE,
  [64868] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4248), 1,
      anon_sym_RBRACE,
  [64875] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1662), 1,
      sym__statement_terminator,
  [64882] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4250), 1,
      anon_sym_RPAREN,
  [64889] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4252), 1,
      anon_sym_RBRACK,
  [64896] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4254), 1,
      sym__statement_terminator,
  [64903] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1664), 1,
      sym__statement_terminator,
  [64910] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1668), 1,
      sym__statement_terminator,
  [64917] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4256), 1,
      sym__statement_terminator,
  [64924] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1684), 1,
      sym__statement_terminator,
  [64931] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4258), 1,
      anon_sym_LPAREN,
  [64938] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4260), 1,
      anon_sym_RBRACE,
  [64945] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4262), 1,
      sym_simple_name,
  [64952] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4264), 1,
      sym_simple_name,
  [64959] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4266), 1,
      anon_sym_param,
  [64966] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4268), 1,
      anon_sym_RBRACE,
  [64973] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4270), 1,
      anon_sym_LPAREN,
  [64980] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4272), 1,
      sym__statement_terminator,
  [64987] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4274), 1,
      anon_sym_LPAREN,
  [64994] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4276), 1,
      sym_simple_name,
  [65001] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
  [65008] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4280), 1,
      sym__statement_terminator,
  [65015] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1688), 1,
      sym__statement_terminator,
  [65022] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4282), 1,
      sym__statement_terminator,
  [65029] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4284), 1,
      sym__statement_terminator,
  [65036] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1422), 1,
      sym__statement_terminator,
  [65043] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4286), 1,
      sym__statement_terminator,
  [65050] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4288), 1,
      sym__statement_terminator,
  [65057] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4290), 1,
      sym__statement_terminator,
  [65064] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4292), 1,
      anon_sym_LPAREN,
  [65071] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3003), 1,
      anon_sym_RPAREN,
  [65078] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4294), 1,
      sym_simple_name,
  [65085] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4296), 1,
      sym_simple_name,
  [65092] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4298), 1,
      anon_sym_LPAREN,
  [65099] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4300), 1,
      anon_sym_LPAREN,
  [65106] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4302), 1,
      sym__statement_terminator,
  [65113] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4304), 1,
      anon_sym_LPAREN,
  [65120] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4306), 1,
      sym_simple_name,
  [65127] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1700), 1,
      sym__statement_terminator,
  [65134] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4308), 1,
      sym__statement_terminator,
  [65141] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1524), 1,
      sym__statement_terminator,
  [65148] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4310), 1,
      sym__statement_terminator,
  [65155] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4312), 1,
      sym__statement_terminator,
  [65162] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1690), 1,
      sym__statement_terminator,
  [65169] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4314), 1,
      sym__statement_terminator,
  [65176] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4316), 1,
      sym__statement_terminator,
  [65183] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4318), 1,
      sym__statement_terminator,
  [65190] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4320), 1,
      anon_sym_LPAREN,
  [65197] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4322), 1,
      anon_sym_LPAREN,
  [65204] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4324), 1,
      sym__statement_terminator,
  [65211] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4326), 1,
      anon_sym_in,
  [65218] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3754), 1,
      anon_sym_RBRACK,
  [65225] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4328), 1,
      anon_sym_in,
  [65232] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4330), 1,
      anon_sym_LPAREN,
  [65239] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4332), 1,
      anon_sym_LPAREN,
  [65246] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4334), 1,
      anon_sym_LPAREN,
  [65253] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4336), 1,
      anon_sym_RBRACE,
  [65260] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4338), 1,
      anon_sym_in,
  [65267] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4340), 1,
      anon_sym_in,
  [65274] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4342), 1,
      anon_sym_LPAREN,
  [65281] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4344), 1,
      anon_sym_LPAREN,
  [65288] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4346), 1,
      anon_sym_LPAREN,
  [65295] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4348), 1,
      anon_sym_RPAREN,
  [65302] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4350), 1,
      anon_sym_in,
  [65309] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4352), 1,
      anon_sym_in,
  [65316] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4354), 1,
      anon_sym_LPAREN,
  [65323] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4356), 1,
      anon_sym_RPAREN,
  [65330] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1666), 1,
      sym__statement_terminator,
  [65337] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1402), 1,
      sym__statement_terminator,
  [65344] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4358), 1,
      anon_sym_LPAREN,
  [65351] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4360), 1,
      anon_sym_RBRACK,
  [65358] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4362), 1,
      anon_sym_LBRACE,
  [65365] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4364), 1,
      anon_sym_RBRACE,
  [65372] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1799), 1,
      sym__statement_terminator,
  [65379] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1801), 1,
      sym__statement_terminator,
  [65386] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1658), 1,
      sym__statement_terminator,
  [65393] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4366), 1,
      anon_sym_LPAREN,
  [65400] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1724), 1,
      sym__statement_terminator,
  [65407] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4368), 1,
      anon_sym_LPAREN,
  [65414] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1702), 1,
      sym__statement_terminator,
  [65421] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4370), 1,
      anon_sym_LPAREN,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(373)] = 0,
  [SMALL_STATE(374)] = 69,
  [SMALL_STATE(375)] = 138,
  [SMALL_STATE(376)] = 209,
  [SMALL_STATE(377)] = 278,
  [SMALL_STATE(378)] = 351,
  [SMALL_STATE(379)] = 420,
  [SMALL_STATE(380)] = 489,
  [SMALL_STATE(381)] = 562,
  [SMALL_STATE(382)] = 635,
  [SMALL_STATE(383)] = 708,
  [SMALL_STATE(384)] = 777,
  [SMALL_STATE(385)] = 850,
  [SMALL_STATE(386)] = 919,
  [SMALL_STATE(387)] = 990,
  [SMALL_STATE(388)] = 1063,
  [SMALL_STATE(389)] = 1136,
  [SMALL_STATE(390)] = 1209,
  [SMALL_STATE(391)] = 1342,
  [SMALL_STATE(392)] = 1414,
  [SMALL_STATE(393)] = 1488,
  [SMALL_STATE(394)] = 1558,
  [SMALL_STATE(395)] = 1628,
  [SMALL_STATE(396)] = 1698,
  [SMALL_STATE(397)] = 1770,
  [SMALL_STATE(398)] = 1840,
  [SMALL_STATE(399)] = 1970,
  [SMALL_STATE(400)] = 2044,
  [SMALL_STATE(401)] = 2114,
  [SMALL_STATE(402)] = 2184,
  [SMALL_STATE(403)] = 2256,
  [SMALL_STATE(404)] = 2328,
  [SMALL_STATE(405)] = 2402,
  [SMALL_STATE(406)] = 2472,
  [SMALL_STATE(407)] = 2542,
  [SMALL_STATE(408)] = 2672,
  [SMALL_STATE(409)] = 2742,
  [SMALL_STATE(410)] = 2872,
  [SMALL_STATE(411)] = 2946,
  [SMALL_STATE(412)] = 3076,
  [SMALL_STATE(413)] = 3206,
  [SMALL_STATE(414)] = 3273,
  [SMALL_STATE(415)] = 3400,
  [SMALL_STATE(416)] = 3525,
  [SMALL_STATE(417)] = 3650,
  [SMALL_STATE(418)] = 3775,
  [SMALL_STATE(419)] = 3842,
  [SMALL_STATE(420)] = 3909,
  [SMALL_STATE(421)] = 3976,
  [SMALL_STATE(422)] = 4103,
  [SMALL_STATE(423)] = 4228,
  [SMALL_STATE(424)] = 4295,
  [SMALL_STATE(425)] = 4362,
  [SMALL_STATE(426)] = 4429,
  [SMALL_STATE(427)] = 4556,
  [SMALL_STATE(428)] = 4623,
  [SMALL_STATE(429)] = 4750,
  [SMALL_STATE(430)] = 4817,
  [SMALL_STATE(431)] = 4888,
  [SMALL_STATE(432)] = 4955,
  [SMALL_STATE(433)] = 5022,
  [SMALL_STATE(434)] = 5089,
  [SMALL_STATE(435)] = 5156,
  [SMALL_STATE(436)] = 5223,
  [SMALL_STATE(437)] = 5290,
  [SMALL_STATE(438)] = 5357,
  [SMALL_STATE(439)] = 5424,
  [SMALL_STATE(440)] = 5491,
  [SMALL_STATE(441)] = 5558,
  [SMALL_STATE(442)] = 5625,
  [SMALL_STATE(443)] = 5692,
  [SMALL_STATE(444)] = 5759,
  [SMALL_STATE(445)] = 5886,
  [SMALL_STATE(446)] = 5953,
  [SMALL_STATE(447)] = 6020,
  [SMALL_STATE(448)] = 6087,
  [SMALL_STATE(449)] = 6154,
  [SMALL_STATE(450)] = 6279,
  [SMALL_STATE(451)] = 6346,
  [SMALL_STATE(452)] = 6413,
  [SMALL_STATE(453)] = 6480,
  [SMALL_STATE(454)] = 6547,
  [SMALL_STATE(455)] = 6672,
  [SMALL_STATE(456)] = 6739,
  [SMALL_STATE(457)] = 6806,
  [SMALL_STATE(458)] = 6873,
  [SMALL_STATE(459)] = 6940,
  [SMALL_STATE(460)] = 7007,
  [SMALL_STATE(461)] = 7134,
  [SMALL_STATE(462)] = 7201,
  [SMALL_STATE(463)] = 7268,
  [SMALL_STATE(464)] = 7335,
  [SMALL_STATE(465)] = 7402,
  [SMALL_STATE(466)] = 7527,
  [SMALL_STATE(467)] = 7594,
  [SMALL_STATE(468)] = 7661,
  [SMALL_STATE(469)] = 7728,
  [SMALL_STATE(470)] = 7795,
  [SMALL_STATE(471)] = 7862,
  [SMALL_STATE(472)] = 7929,
  [SMALL_STATE(473)] = 7996,
  [SMALL_STATE(474)] = 8121,
  [SMALL_STATE(475)] = 8192,
  [SMALL_STATE(476)] = 8259,
  [SMALL_STATE(477)] = 8326,
  [SMALL_STATE(478)] = 8393,
  [SMALL_STATE(479)] = 8461,
  [SMALL_STATE(480)] = 8529,
  [SMALL_STATE(481)] = 8597,
  [SMALL_STATE(482)] = 8665,
  [SMALL_STATE(483)] = 8733,
  [SMALL_STATE(484)] = 8857,
  [SMALL_STATE(485)] = 8925,
  [SMALL_STATE(486)] = 8993,
  [SMALL_STATE(487)] = 9061,
  [SMALL_STATE(488)] = 9129,
  [SMALL_STATE(489)] = 9197,
  [SMALL_STATE(490)] = 9265,
  [SMALL_STATE(491)] = 9337,
  [SMALL_STATE(492)] = 9405,
  [SMALL_STATE(493)] = 9473,
  [SMALL_STATE(494)] = 9541,
  [SMALL_STATE(495)] = 9609,
  [SMALL_STATE(496)] = 9677,
  [SMALL_STATE(497)] = 9745,
  [SMALL_STATE(498)] = 9813,
  [SMALL_STATE(499)] = 9881,
  [SMALL_STATE(500)] = 9949,
  [SMALL_STATE(501)] = 10017,
  [SMALL_STATE(502)] = 10085,
  [SMALL_STATE(503)] = 10209,
  [SMALL_STATE(504)] = 10331,
  [SMALL_STATE(505)] = 10399,
  [SMALL_STATE(506)] = 10523,
  [SMALL_STATE(507)] = 10591,
  [SMALL_STATE(508)] = 10659,
  [SMALL_STATE(509)] = 10727,
  [SMALL_STATE(510)] = 10795,
  [SMALL_STATE(511)] = 10863,
  [SMALL_STATE(512)] = 10931,
  [SMALL_STATE(513)] = 10999,
  [SMALL_STATE(514)] = 11067,
  [SMALL_STATE(515)] = 11135,
  [SMALL_STATE(516)] = 11203,
  [SMALL_STATE(517)] = 11269,
  [SMALL_STATE(518)] = 11337,
  [SMALL_STATE(519)] = 11405,
  [SMALL_STATE(520)] = 11473,
  [SMALL_STATE(521)] = 11597,
  [SMALL_STATE(522)] = 11665,
  [SMALL_STATE(523)] = 11787,
  [SMALL_STATE(524)] = 11855,
  [SMALL_STATE(525)] = 11923,
  [SMALL_STATE(526)] = 12047,
  [SMALL_STATE(527)] = 12115,
  [SMALL_STATE(528)] = 12183,
  [SMALL_STATE(529)] = 12251,
  [SMALL_STATE(530)] = 12319,
  [SMALL_STATE(531)] = 12387,
  [SMALL_STATE(532)] = 12455,
  [SMALL_STATE(533)] = 12523,
  [SMALL_STATE(534)] = 12591,
  [SMALL_STATE(535)] = 12659,
  [SMALL_STATE(536)] = 12731,
  [SMALL_STATE(537)] = 12799,
  [SMALL_STATE(538)] = 12867,
  [SMALL_STATE(539)] = 12988,
  [SMALL_STATE(540)] = 13053,
  [SMALL_STATE(541)] = 13124,
  [SMALL_STATE(542)] = 13241,
  [SMALL_STATE(543)] = 13312,
  [SMALL_STATE(544)] = 13429,
  [SMALL_STATE(545)] = 13550,
  [SMALL_STATE(546)] = 13671,
  [SMALL_STATE(547)] = 13742,
  [SMALL_STATE(548)] = 13807,
  [SMALL_STATE(549)] = 13928,
  [SMALL_STATE(550)] = 14045,
  [SMALL_STATE(551)] = 14110,
  [SMALL_STATE(552)] = 14231,
  [SMALL_STATE(553)] = 14296,
  [SMALL_STATE(554)] = 14367,
  [SMALL_STATE(555)] = 14438,
  [SMALL_STATE(556)] = 14509,
  [SMALL_STATE(557)] = 14626,
  [SMALL_STATE(558)] = 14747,
  [SMALL_STATE(559)] = 14865,
  [SMALL_STATE(560)] = 14935,
  [SMALL_STATE(561)] = 15053,
  [SMALL_STATE(562)] = 15171,
  [SMALL_STATE(563)] = 15289,
  [SMALL_STATE(564)] = 15359,
  [SMALL_STATE(565)] = 15429,
  [SMALL_STATE(566)] = 15499,
  [SMALL_STATE(567)] = 15617,
  [SMALL_STATE(568)] = 15735,
  [SMALL_STATE(569)] = 15853,
  [SMALL_STATE(570)] = 15968,
  [SMALL_STATE(571)] = 16083,
  [SMALL_STATE(572)] = 16198,
  [SMALL_STATE(573)] = 16313,
  [SMALL_STATE(574)] = 16382,
  [SMALL_STATE(575)] = 16497,
  [SMALL_STATE(576)] = 16612,
  [SMALL_STATE(577)] = 16681,
  [SMALL_STATE(578)] = 16793,
  [SMALL_STATE(579)] = 16905,
  [SMALL_STATE(580)] = 17017,
  [SMALL_STATE(581)] = 17129,
  [SMALL_STATE(582)] = 17241,
  [SMALL_STATE(583)] = 17353,
  [SMALL_STATE(584)] = 17421,
  [SMALL_STATE(585)] = 17489,
  [SMALL_STATE(586)] = 17598,
  [SMALL_STATE(587)] = 17707,
  [SMALL_STATE(588)] = 17816,
  [SMALL_STATE(589)] = 17925,
  [SMALL_STATE(590)] = 18034,
  [SMALL_STATE(591)] = 18143,
  [SMALL_STATE(592)] = 18252,
  [SMALL_STATE(593)] = 18361,
  [SMALL_STATE(594)] = 18470,
  [SMALL_STATE(595)] = 18579,
  [SMALL_STATE(596)] = 18688,
  [SMALL_STATE(597)] = 18797,
  [SMALL_STATE(598)] = 18906,
  [SMALL_STATE(599)] = 19015,
  [SMALL_STATE(600)] = 19124,
  [SMALL_STATE(601)] = 19233,
  [SMALL_STATE(602)] = 19342,
  [SMALL_STATE(603)] = 19451,
  [SMALL_STATE(604)] = 19560,
  [SMALL_STATE(605)] = 19669,
  [SMALL_STATE(606)] = 19778,
  [SMALL_STATE(607)] = 19887,
  [SMALL_STATE(608)] = 19996,
  [SMALL_STATE(609)] = 20105,
  [SMALL_STATE(610)] = 20214,
  [SMALL_STATE(611)] = 20323,
  [SMALL_STATE(612)] = 20432,
  [SMALL_STATE(613)] = 20541,
  [SMALL_STATE(614)] = 20650,
  [SMALL_STATE(615)] = 20759,
  [SMALL_STATE(616)] = 20868,
  [SMALL_STATE(617)] = 20977,
  [SMALL_STATE(618)] = 21086,
  [SMALL_STATE(619)] = 21195,
  [SMALL_STATE(620)] = 21304,
  [SMALL_STATE(621)] = 21413,
  [SMALL_STATE(622)] = 21522,
  [SMALL_STATE(623)] = 21631,
  [SMALL_STATE(624)] = 21740,
  [SMALL_STATE(625)] = 21849,
  [SMALL_STATE(626)] = 21958,
  [SMALL_STATE(627)] = 22067,
  [SMALL_STATE(628)] = 22176,
  [SMALL_STATE(629)] = 22285,
  [SMALL_STATE(630)] = 22394,
  [SMALL_STATE(631)] = 22503,
  [SMALL_STATE(632)] = 22612,
  [SMALL_STATE(633)] = 22721,
  [SMALL_STATE(634)] = 22830,
  [SMALL_STATE(635)] = 22939,
  [SMALL_STATE(636)] = 23048,
  [SMALL_STATE(637)] = 23157,
  [SMALL_STATE(638)] = 23266,
  [SMALL_STATE(639)] = 23375,
  [SMALL_STATE(640)] = 23484,
  [SMALL_STATE(641)] = 23593,
  [SMALL_STATE(642)] = 23702,
  [SMALL_STATE(643)] = 23811,
  [SMALL_STATE(644)] = 23920,
  [SMALL_STATE(645)] = 24029,
  [SMALL_STATE(646)] = 24138,
  [SMALL_STATE(647)] = 24247,
  [SMALL_STATE(648)] = 24356,
  [SMALL_STATE(649)] = 24465,
  [SMALL_STATE(650)] = 24574,
  [SMALL_STATE(651)] = 24683,
  [SMALL_STATE(652)] = 24792,
  [SMALL_STATE(653)] = 24901,
  [SMALL_STATE(654)] = 25010,
  [SMALL_STATE(655)] = 25119,
  [SMALL_STATE(656)] = 25228,
  [SMALL_STATE(657)] = 25337,
  [SMALL_STATE(658)] = 25446,
  [SMALL_STATE(659)] = 25555,
  [SMALL_STATE(660)] = 25664,
  [SMALL_STATE(661)] = 25773,
  [SMALL_STATE(662)] = 25882,
  [SMALL_STATE(663)] = 25991,
  [SMALL_STATE(664)] = 26100,
  [SMALL_STATE(665)] = 26209,
  [SMALL_STATE(666)] = 26318,
  [SMALL_STATE(667)] = 26427,
  [SMALL_STATE(668)] = 26536,
  [SMALL_STATE(669)] = 26645,
  [SMALL_STATE(670)] = 26754,
  [SMALL_STATE(671)] = 26863,
  [SMALL_STATE(672)] = 26972,
  [SMALL_STATE(673)] = 27081,
  [SMALL_STATE(674)] = 27190,
  [SMALL_STATE(675)] = 27299,
  [SMALL_STATE(676)] = 27408,
  [SMALL_STATE(677)] = 27517,
  [SMALL_STATE(678)] = 27626,
  [SMALL_STATE(679)] = 27735,
  [SMALL_STATE(680)] = 27844,
  [SMALL_STATE(681)] = 27953,
  [SMALL_STATE(682)] = 28062,
  [SMALL_STATE(683)] = 28171,
  [SMALL_STATE(684)] = 28280,
  [SMALL_STATE(685)] = 28381,
  [SMALL_STATE(686)] = 28482,
  [SMALL_STATE(687)] = 28583,
  [SMALL_STATE(688)] = 28684,
  [SMALL_STATE(689)] = 28785,
  [SMALL_STATE(690)] = 28886,
  [SMALL_STATE(691)] = 28987,
  [SMALL_STATE(692)] = 29088,
  [SMALL_STATE(693)] = 29189,
  [SMALL_STATE(694)] = 29290,
  [SMALL_STATE(695)] = 29391,
  [SMALL_STATE(696)] = 29492,
  [SMALL_STATE(697)] = 29593,
  [SMALL_STATE(698)] = 29694,
  [SMALL_STATE(699)] = 29795,
  [SMALL_STATE(700)] = 29896,
  [SMALL_STATE(701)] = 29997,
  [SMALL_STATE(702)] = 30098,
  [SMALL_STATE(703)] = 30199,
  [SMALL_STATE(704)] = 30300,
  [SMALL_STATE(705)] = 30401,
  [SMALL_STATE(706)] = 30502,
  [SMALL_STATE(707)] = 30603,
  [SMALL_STATE(708)] = 30704,
  [SMALL_STATE(709)] = 30760,
  [SMALL_STATE(710)] = 30820,
  [SMALL_STATE(711)] = 30876,
  [SMALL_STATE(712)] = 30936,
  [SMALL_STATE(713)] = 31034,
  [SMALL_STATE(714)] = 31093,
  [SMALL_STATE(715)] = 31188,
  [SMALL_STATE(716)] = 31243,
  [SMALL_STATE(717)] = 31302,
  [SMALL_STATE(718)] = 31357,
  [SMALL_STATE(719)] = 31449,
  [SMALL_STATE(720)] = 31541,
  [SMALL_STATE(721)] = 31633,
  [SMALL_STATE(722)] = 31725,
  [SMALL_STATE(723)] = 31817,
  [SMALL_STATE(724)] = 31907,
  [SMALL_STATE(725)] = 31997,
  [SMALL_STATE(726)] = 32089,
  [SMALL_STATE(727)] = 32179,
  [SMALL_STATE(728)] = 32271,
  [SMALL_STATE(729)] = 32361,
  [SMALL_STATE(730)] = 32453,
  [SMALL_STATE(731)] = 32545,
  [SMALL_STATE(732)] = 32637,
  [SMALL_STATE(733)] = 32724,
  [SMALL_STATE(734)] = 32811,
  [SMALL_STATE(735)] = 32864,
  [SMALL_STATE(736)] = 32922,
  [SMALL_STATE(737)] = 32980,
  [SMALL_STATE(738)] = 33038,
  [SMALL_STATE(739)] = 33096,
  [SMALL_STATE(740)] = 33171,
  [SMALL_STATE(741)] = 33244,
  [SMALL_STATE(742)] = 33301,
  [SMALL_STATE(743)] = 33358,
  [SMALL_STATE(744)] = 33433,
  [SMALL_STATE(745)] = 33490,
  [SMALL_STATE(746)] = 33545,
  [SMALL_STATE(747)] = 33600,
  [SMALL_STATE(748)] = 33653,
  [SMALL_STATE(749)] = 33706,
  [SMALL_STATE(750)] = 33763,
  [SMALL_STATE(751)] = 33836,
  [SMALL_STATE(752)] = 33886,
  [SMALL_STATE(753)] = 33936,
  [SMALL_STATE(754)] = 33986,
  [SMALL_STATE(755)] = 34036,
  [SMALL_STATE(756)] = 34086,
  [SMALL_STATE(757)] = 34136,
  [SMALL_STATE(758)] = 34186,
  [SMALL_STATE(759)] = 34236,
  [SMALL_STATE(760)] = 34286,
  [SMALL_STATE(761)] = 34336,
  [SMALL_STATE(762)] = 34410,
  [SMALL_STATE(763)] = 34460,
  [SMALL_STATE(764)] = 34510,
  [SMALL_STATE(765)] = 34560,
  [SMALL_STATE(766)] = 34610,
  [SMALL_STATE(767)] = 34660,
  [SMALL_STATE(768)] = 34710,
  [SMALL_STATE(769)] = 34770,
  [SMALL_STATE(770)] = 34820,
  [SMALL_STATE(771)] = 34870,
  [SMALL_STATE(772)] = 34920,
  [SMALL_STATE(773)] = 34970,
  [SMALL_STATE(774)] = 35020,
  [SMALL_STATE(775)] = 35070,
  [SMALL_STATE(776)] = 35120,
  [SMALL_STATE(777)] = 35170,
  [SMALL_STATE(778)] = 35242,
  [SMALL_STATE(779)] = 35292,
  [SMALL_STATE(780)] = 35342,
  [SMALL_STATE(781)] = 35392,
  [SMALL_STATE(782)] = 35442,
  [SMALL_STATE(783)] = 35492,
  [SMALL_STATE(784)] = 35542,
  [SMALL_STATE(785)] = 35616,
  [SMALL_STATE(786)] = 35666,
  [SMALL_STATE(787)] = 35716,
  [SMALL_STATE(788)] = 35770,
  [SMALL_STATE(789)] = 35820,
  [SMALL_STATE(790)] = 35870,
  [SMALL_STATE(791)] = 35920,
  [SMALL_STATE(792)] = 35970,
  [SMALL_STATE(793)] = 36020,
  [SMALL_STATE(794)] = 36070,
  [SMALL_STATE(795)] = 36120,
  [SMALL_STATE(796)] = 36170,
  [SMALL_STATE(797)] = 36220,
  [SMALL_STATE(798)] = 36270,
  [SMALL_STATE(799)] = 36320,
  [SMALL_STATE(800)] = 36370,
  [SMALL_STATE(801)] = 36430,
  [SMALL_STATE(802)] = 36480,
  [SMALL_STATE(803)] = 36530,
  [SMALL_STATE(804)] = 36580,
  [SMALL_STATE(805)] = 36630,
  [SMALL_STATE(806)] = 36680,
  [SMALL_STATE(807)] = 36750,
  [SMALL_STATE(808)] = 36822,
  [SMALL_STATE(809)] = 36876,
  [SMALL_STATE(810)] = 36926,
  [SMALL_STATE(811)] = 36976,
  [SMALL_STATE(812)] = 37026,
  [SMALL_STATE(813)] = 37076,
  [SMALL_STATE(814)] = 37126,
  [SMALL_STATE(815)] = 37176,
  [SMALL_STATE(816)] = 37226,
  [SMALL_STATE(817)] = 37276,
  [SMALL_STATE(818)] = 37348,
  [SMALL_STATE(819)] = 37398,
  [SMALL_STATE(820)] = 37478,
  [SMALL_STATE(821)] = 37528,
  [SMALL_STATE(822)] = 37578,
  [SMALL_STATE(823)] = 37630,
  [SMALL_STATE(824)] = 37680,
  [SMALL_STATE(825)] = 37730,
  [SMALL_STATE(826)] = 37802,
  [SMALL_STATE(827)] = 37852,
  [SMALL_STATE(828)] = 37922,
  [SMALL_STATE(829)] = 37972,
  [SMALL_STATE(830)] = 38022,
  [SMALL_STATE(831)] = 38072,
  [SMALL_STATE(832)] = 38122,
  [SMALL_STATE(833)] = 38174,
  [SMALL_STATE(834)] = 38224,
  [SMALL_STATE(835)] = 38273,
  [SMALL_STATE(836)] = 38322,
  [SMALL_STATE(837)] = 38371,
  [SMALL_STATE(838)] = 38420,
  [SMALL_STATE(839)] = 38469,
  [SMALL_STATE(840)] = 38540,
  [SMALL_STATE(841)] = 38589,
  [SMALL_STATE(842)] = 38638,
  [SMALL_STATE(843)] = 38687,
  [SMALL_STATE(844)] = 38736,
  [SMALL_STATE(845)] = 38785,
  [SMALL_STATE(846)] = 38854,
  [SMALL_STATE(847)] = 38903,
  [SMALL_STATE(848)] = 38952,
  [SMALL_STATE(849)] = 39003,
  [SMALL_STATE(850)] = 39074,
  [SMALL_STATE(851)] = 39123,
  [SMALL_STATE(852)] = 39172,
  [SMALL_STATE(853)] = 39221,
  [SMALL_STATE(854)] = 39270,
  [SMALL_STATE(855)] = 39319,
  [SMALL_STATE(856)] = 39368,
  [SMALL_STATE(857)] = 39417,
  [SMALL_STATE(858)] = 39466,
  [SMALL_STATE(859)] = 39525,
  [SMALL_STATE(860)] = 39574,
  [SMALL_STATE(861)] = 39623,
  [SMALL_STATE(862)] = 39672,
  [SMALL_STATE(863)] = 39721,
  [SMALL_STATE(864)] = 39770,
  [SMALL_STATE(865)] = 39819,
  [SMALL_STATE(866)] = 39886,
  [SMALL_STATE(867)] = 39935,
  [SMALL_STATE(868)] = 39984,
  [SMALL_STATE(869)] = 40035,
  [SMALL_STATE(870)] = 40084,
  [SMALL_STATE(871)] = 40133,
  [SMALL_STATE(872)] = 40182,
  [SMALL_STATE(873)] = 40231,
  [SMALL_STATE(874)] = 40280,
  [SMALL_STATE(875)] = 40329,
  [SMALL_STATE(876)] = 40378,
  [SMALL_STATE(877)] = 40427,
  [SMALL_STATE(878)] = 40476,
  [SMALL_STATE(879)] = 40525,
  [SMALL_STATE(880)] = 40574,
  [SMALL_STATE(881)] = 40623,
  [SMALL_STATE(882)] = 40672,
  [SMALL_STATE(883)] = 40721,
  [SMALL_STATE(884)] = 40790,
  [SMALL_STATE(885)] = 40839,
  [SMALL_STATE(886)] = 40888,
  [SMALL_STATE(887)] = 40937,
  [SMALL_STATE(888)] = 40986,
  [SMALL_STATE(889)] = 41035,
  [SMALL_STATE(890)] = 41084,
  [SMALL_STATE(891)] = 41133,
  [SMALL_STATE(892)] = 41182,
  [SMALL_STATE(893)] = 41241,
  [SMALL_STATE(894)] = 41290,
  [SMALL_STATE(895)] = 41339,
  [SMALL_STATE(896)] = 41388,
  [SMALL_STATE(897)] = 41455,
  [SMALL_STATE(898)] = 41504,
  [SMALL_STATE(899)] = 41553,
  [SMALL_STATE(900)] = 41602,
  [SMALL_STATE(901)] = 41651,
  [SMALL_STATE(902)] = 41702,
  [SMALL_STATE(903)] = 41751,
  [SMALL_STATE(904)] = 41800,
  [SMALL_STATE(905)] = 41849,
  [SMALL_STATE(906)] = 41898,
  [SMALL_STATE(907)] = 41957,
  [SMALL_STATE(908)] = 42006,
  [SMALL_STATE(909)] = 42055,
  [SMALL_STATE(910)] = 42104,
  [SMALL_STATE(911)] = 42153,
  [SMALL_STATE(912)] = 42202,
  [SMALL_STATE(913)] = 42251,
  [SMALL_STATE(914)] = 42310,
  [SMALL_STATE(915)] = 42359,
  [SMALL_STATE(916)] = 42410,
  [SMALL_STATE(917)] = 42468,
  [SMALL_STATE(918)] = 42526,
  [SMALL_STATE(919)] = 42578,
  [SMALL_STATE(920)] = 42626,
  [SMALL_STATE(921)] = 42674,
  [SMALL_STATE(922)] = 42732,
  [SMALL_STATE(923)] = 42790,
  [SMALL_STATE(924)] = 42848,
  [SMALL_STATE(925)] = 42906,
  [SMALL_STATE(926)] = 42956,
  [SMALL_STATE(927)] = 43009,
  [SMALL_STATE(928)] = 43056,
  [SMALL_STATE(929)] = 43113,
  [SMALL_STATE(930)] = 43160,
  [SMALL_STATE(931)] = 43207,
  [SMALL_STATE(932)] = 43254,
  [SMALL_STATE(933)] = 43301,
  [SMALL_STATE(934)] = 43348,
  [SMALL_STATE(935)] = 43395,
  [SMALL_STATE(936)] = 43448,
  [SMALL_STATE(937)] = 43495,
  [SMALL_STATE(938)] = 43542,
  [SMALL_STATE(939)] = 43589,
  [SMALL_STATE(940)] = 43636,
  [SMALL_STATE(941)] = 43683,
  [SMALL_STATE(942)] = 43740,
  [SMALL_STATE(943)] = 43787,
  [SMALL_STATE(944)] = 43834,
  [SMALL_STATE(945)] = 43881,
  [SMALL_STATE(946)] = 43936,
  [SMALL_STATE(947)] = 43983,
  [SMALL_STATE(948)] = 44038,
  [SMALL_STATE(949)] = 44085,
  [SMALL_STATE(950)] = 44132,
  [SMALL_STATE(951)] = 44179,
  [SMALL_STATE(952)] = 44226,
  [SMALL_STATE(953)] = 44273,
  [SMALL_STATE(954)] = 44320,
  [SMALL_STATE(955)] = 44375,
  [SMALL_STATE(956)] = 44422,
  [SMALL_STATE(957)] = 44469,
  [SMALL_STATE(958)] = 44516,
  [SMALL_STATE(959)] = 44563,
  [SMALL_STATE(960)] = 44610,
  [SMALL_STATE(961)] = 44657,
  [SMALL_STATE(962)] = 44704,
  [SMALL_STATE(963)] = 44761,
  [SMALL_STATE(964)] = 44808,
  [SMALL_STATE(965)] = 44855,
  [SMALL_STATE(966)] = 44908,
  [SMALL_STATE(967)] = 44955,
  [SMALL_STATE(968)] = 45002,
  [SMALL_STATE(969)] = 45049,
  [SMALL_STATE(970)] = 45096,
  [SMALL_STATE(971)] = 45153,
  [SMALL_STATE(972)] = 45205,
  [SMALL_STATE(973)] = 45251,
  [SMALL_STATE(974)] = 45297,
  [SMALL_STATE(975)] = 45343,
  [SMALL_STATE(976)] = 45393,
  [SMALL_STATE(977)] = 45447,
  [SMALL_STATE(978)] = 45493,
  [SMALL_STATE(979)] = 45541,
  [SMALL_STATE(980)] = 45589,
  [SMALL_STATE(981)] = 45637,
  [SMALL_STATE(982)] = 45691,
  [SMALL_STATE(983)] = 45743,
  [SMALL_STATE(984)] = 45789,
  [SMALL_STATE(985)] = 45841,
  [SMALL_STATE(986)] = 45895,
  [SMALL_STATE(987)] = 45941,
  [SMALL_STATE(988)] = 45998,
  [SMALL_STATE(989)] = 46043,
  [SMALL_STATE(990)] = 46088,
  [SMALL_STATE(991)] = 46133,
  [SMALL_STATE(992)] = 46178,
  [SMALL_STATE(993)] = 46223,
  [SMALL_STATE(994)] = 46268,
  [SMALL_STATE(995)] = 46313,
  [SMALL_STATE(996)] = 46358,
  [SMALL_STATE(997)] = 46403,
  [SMALL_STATE(998)] = 46448,
  [SMALL_STATE(999)] = 46493,
  [SMALL_STATE(1000)] = 46538,
  [SMALL_STATE(1001)] = 46583,
  [SMALL_STATE(1002)] = 46628,
  [SMALL_STATE(1003)] = 46673,
  [SMALL_STATE(1004)] = 46718,
  [SMALL_STATE(1005)] = 46763,
  [SMALL_STATE(1006)] = 46808,
  [SMALL_STATE(1007)] = 46853,
  [SMALL_STATE(1008)] = 46898,
  [SMALL_STATE(1009)] = 46943,
  [SMALL_STATE(1010)] = 46988,
  [SMALL_STATE(1011)] = 47033,
  [SMALL_STATE(1012)] = 47078,
  [SMALL_STATE(1013)] = 47123,
  [SMALL_STATE(1014)] = 47168,
  [SMALL_STATE(1015)] = 47213,
  [SMALL_STATE(1016)] = 47258,
  [SMALL_STATE(1017)] = 47315,
  [SMALL_STATE(1018)] = 47360,
  [SMALL_STATE(1019)] = 47405,
  [SMALL_STATE(1020)] = 47450,
  [SMALL_STATE(1021)] = 47495,
  [SMALL_STATE(1022)] = 47540,
  [SMALL_STATE(1023)] = 47585,
  [SMALL_STATE(1024)] = 47630,
  [SMALL_STATE(1025)] = 47675,
  [SMALL_STATE(1026)] = 47720,
  [SMALL_STATE(1027)] = 47765,
  [SMALL_STATE(1028)] = 47810,
  [SMALL_STATE(1029)] = 47855,
  [SMALL_STATE(1030)] = 47911,
  [SMALL_STATE(1031)] = 47955,
  [SMALL_STATE(1032)] = 47999,
  [SMALL_STATE(1033)] = 48043,
  [SMALL_STATE(1034)] = 48091,
  [SMALL_STATE(1035)] = 48137,
  [SMALL_STATE(1036)] = 48181,
  [SMALL_STATE(1037)] = 48225,
  [SMALL_STATE(1038)] = 48271,
  [SMALL_STATE(1039)] = 48315,
  [SMALL_STATE(1040)] = 48359,
  [SMALL_STATE(1041)] = 48403,
  [SMALL_STATE(1042)] = 48447,
  [SMALL_STATE(1043)] = 48491,
  [SMALL_STATE(1044)] = 48535,
  [SMALL_STATE(1045)] = 48579,
  [SMALL_STATE(1046)] = 48623,
  [SMALL_STATE(1047)] = 48667,
  [SMALL_STATE(1048)] = 48711,
  [SMALL_STATE(1049)] = 48767,
  [SMALL_STATE(1050)] = 48811,
  [SMALL_STATE(1051)] = 48859,
  [SMALL_STATE(1052)] = 48902,
  [SMALL_STATE(1053)] = 48945,
  [SMALL_STATE(1054)] = 48992,
  [SMALL_STATE(1055)] = 49035,
  [SMALL_STATE(1056)] = 49090,
  [SMALL_STATE(1057)] = 49133,
  [SMALL_STATE(1058)] = 49188,
  [SMALL_STATE(1059)] = 49231,
  [SMALL_STATE(1060)] = 49274,
  [SMALL_STATE(1061)] = 49317,
  [SMALL_STATE(1062)] = 49362,
  [SMALL_STATE(1063)] = 49407,
  [SMALL_STATE(1064)] = 49454,
  [SMALL_STATE(1065)] = 49497,
  [SMALL_STATE(1066)] = 49540,
  [SMALL_STATE(1067)] = 49585,
  [SMALL_STATE(1068)] = 49628,
  [SMALL_STATE(1069)] = 49671,
  [SMALL_STATE(1070)] = 49714,
  [SMALL_STATE(1071)] = 49757,
  [SMALL_STATE(1072)] = 49800,
  [SMALL_STATE(1073)] = 49845,
  [SMALL_STATE(1074)] = 49888,
  [SMALL_STATE(1075)] = 49931,
  [SMALL_STATE(1076)] = 49974,
  [SMALL_STATE(1077)] = 50017,
  [SMALL_STATE(1078)] = 50060,
  [SMALL_STATE(1079)] = 50102,
  [SMALL_STATE(1080)] = 50144,
  [SMALL_STATE(1081)] = 50186,
  [SMALL_STATE(1082)] = 50228,
  [SMALL_STATE(1083)] = 50270,
  [SMALL_STATE(1084)] = 50312,
  [SMALL_STATE(1085)] = 50354,
  [SMALL_STATE(1086)] = 50396,
  [SMALL_STATE(1087)] = 50438,
  [SMALL_STATE(1088)] = 50484,
  [SMALL_STATE(1089)] = 50526,
  [SMALL_STATE(1090)] = 50568,
  [SMALL_STATE(1091)] = 50610,
  [SMALL_STATE(1092)] = 50652,
  [SMALL_STATE(1093)] = 50696,
  [SMALL_STATE(1094)] = 50738,
  [SMALL_STATE(1095)] = 50780,
  [SMALL_STATE(1096)] = 50824,
  [SMALL_STATE(1097)] = 50866,
  [SMALL_STATE(1098)] = 50912,
  [SMALL_STATE(1099)] = 50954,
  [SMALL_STATE(1100)] = 51000,
  [SMALL_STATE(1101)] = 51042,
  [SMALL_STATE(1102)] = 51084,
  [SMALL_STATE(1103)] = 51125,
  [SMALL_STATE(1104)] = 51166,
  [SMALL_STATE(1105)] = 51217,
  [SMALL_STATE(1106)] = 51258,
  [SMALL_STATE(1107)] = 51309,
  [SMALL_STATE(1108)] = 51350,
  [SMALL_STATE(1109)] = 51391,
  [SMALL_STATE(1110)] = 51432,
  [SMALL_STATE(1111)] = 51473,
  [SMALL_STATE(1112)] = 51524,
  [SMALL_STATE(1113)] = 51565,
  [SMALL_STATE(1114)] = 51606,
  [SMALL_STATE(1115)] = 51647,
  [SMALL_STATE(1116)] = 51688,
  [SMALL_STATE(1117)] = 51729,
  [SMALL_STATE(1118)] = 51770,
  [SMALL_STATE(1119)] = 51811,
  [SMALL_STATE(1120)] = 51862,
  [SMALL_STATE(1121)] = 51903,
  [SMALL_STATE(1122)] = 51944,
  [SMALL_STATE(1123)] = 51984,
  [SMALL_STATE(1124)] = 52022,
  [SMALL_STATE(1125)] = 52062,
  [SMALL_STATE(1126)] = 52099,
  [SMALL_STATE(1127)] = 52136,
  [SMALL_STATE(1128)] = 52173,
  [SMALL_STATE(1129)] = 52210,
  [SMALL_STATE(1130)] = 52247,
  [SMALL_STATE(1131)] = 52284,
  [SMALL_STATE(1132)] = 52321,
  [SMALL_STATE(1133)] = 52358,
  [SMALL_STATE(1134)] = 52395,
  [SMALL_STATE(1135)] = 52432,
  [SMALL_STATE(1136)] = 52466,
  [SMALL_STATE(1137)] = 52500,
  [SMALL_STATE(1138)] = 52534,
  [SMALL_STATE(1139)] = 52564,
  [SMALL_STATE(1140)] = 52592,
  [SMALL_STATE(1141)] = 52640,
  [SMALL_STATE(1142)] = 52688,
  [SMALL_STATE(1143)] = 52736,
  [SMALL_STATE(1144)] = 52784,
  [SMALL_STATE(1145)] = 52832,
  [SMALL_STATE(1146)] = 52880,
  [SMALL_STATE(1147)] = 52928,
  [SMALL_STATE(1148)] = 52976,
  [SMALL_STATE(1149)] = 53024,
  [SMALL_STATE(1150)] = 53072,
  [SMALL_STATE(1151)] = 53120,
  [SMALL_STATE(1152)] = 53168,
  [SMALL_STATE(1153)] = 53216,
  [SMALL_STATE(1154)] = 53264,
  [SMALL_STATE(1155)] = 53312,
  [SMALL_STATE(1156)] = 53360,
  [SMALL_STATE(1157)] = 53408,
  [SMALL_STATE(1158)] = 53456,
  [SMALL_STATE(1159)] = 53504,
  [SMALL_STATE(1160)] = 53552,
  [SMALL_STATE(1161)] = 53600,
  [SMALL_STATE(1162)] = 53648,
  [SMALL_STATE(1163)] = 53696,
  [SMALL_STATE(1164)] = 53744,
  [SMALL_STATE(1165)] = 53792,
  [SMALL_STATE(1166)] = 53831,
  [SMALL_STATE(1167)] = 53870,
  [SMALL_STATE(1168)] = 53909,
  [SMALL_STATE(1169)] = 53948,
  [SMALL_STATE(1170)] = 53987,
  [SMALL_STATE(1171)] = 54025,
  [SMALL_STATE(1172)] = 54061,
  [SMALL_STATE(1173)] = 54099,
  [SMALL_STATE(1174)] = 54137,
  [SMALL_STATE(1175)] = 54175,
  [SMALL_STATE(1176)] = 54211,
  [SMALL_STATE(1177)] = 54249,
  [SMALL_STATE(1178)] = 54287,
  [SMALL_STATE(1179)] = 54325,
  [SMALL_STATE(1180)] = 54361,
  [SMALL_STATE(1181)] = 54399,
  [SMALL_STATE(1182)] = 54437,
  [SMALL_STATE(1183)] = 54473,
  [SMALL_STATE(1184)] = 54511,
  [SMALL_STATE(1185)] = 54549,
  [SMALL_STATE(1186)] = 54587,
  [SMALL_STATE(1187)] = 54625,
  [SMALL_STATE(1188)] = 54661,
  [SMALL_STATE(1189)] = 54699,
  [SMALL_STATE(1190)] = 54737,
  [SMALL_STATE(1191)] = 54775,
  [SMALL_STATE(1192)] = 54808,
  [SMALL_STATE(1193)] = 54841,
  [SMALL_STATE(1194)] = 54874,
  [SMALL_STATE(1195)] = 54907,
  [SMALL_STATE(1196)] = 54940,
  [SMALL_STATE(1197)] = 54973,
  [SMALL_STATE(1198)] = 55006,
  [SMALL_STATE(1199)] = 55039,
  [SMALL_STATE(1200)] = 55072,
  [SMALL_STATE(1201)] = 55105,
  [SMALL_STATE(1202)] = 55138,
  [SMALL_STATE(1203)] = 55171,
  [SMALL_STATE(1204)] = 55204,
  [SMALL_STATE(1205)] = 55235,
  [SMALL_STATE(1206)] = 55268,
  [SMALL_STATE(1207)] = 55301,
  [SMALL_STATE(1208)] = 55334,
  [SMALL_STATE(1209)] = 55367,
  [SMALL_STATE(1210)] = 55400,
  [SMALL_STATE(1211)] = 55440,
  [SMALL_STATE(1212)] = 55480,
  [SMALL_STATE(1213)] = 55520,
  [SMALL_STATE(1214)] = 55560,
  [SMALL_STATE(1215)] = 55600,
  [SMALL_STATE(1216)] = 55624,
  [SMALL_STATE(1217)] = 55654,
  [SMALL_STATE(1218)] = 55694,
  [SMALL_STATE(1219)] = 55734,
  [SMALL_STATE(1220)] = 55769,
  [SMALL_STATE(1221)] = 55804,
  [SMALL_STATE(1222)] = 55839,
  [SMALL_STATE(1223)] = 55865,
  [SMALL_STATE(1224)] = 55885,
  [SMALL_STATE(1225)] = 55907,
  [SMALL_STATE(1226)] = 55931,
  [SMALL_STATE(1227)] = 55953,
  [SMALL_STATE(1228)] = 55975,
  [SMALL_STATE(1229)] = 56001,
  [SMALL_STATE(1230)] = 56023,
  [SMALL_STATE(1231)] = 56049,
  [SMALL_STATE(1232)] = 56083,
  [SMALL_STATE(1233)] = 56105,
  [SMALL_STATE(1234)] = 56127,
  [SMALL_STATE(1235)] = 56147,
  [SMALL_STATE(1236)] = 56167,
  [SMALL_STATE(1237)] = 56200,
  [SMALL_STATE(1238)] = 56233,
  [SMALL_STATE(1239)] = 56266,
  [SMALL_STATE(1240)] = 56299,
  [SMALL_STATE(1241)] = 56324,
  [SMALL_STATE(1242)] = 56344,
  [SMALL_STATE(1243)] = 56364,
  [SMALL_STATE(1244)] = 56390,
  [SMALL_STATE(1245)] = 56410,
  [SMALL_STATE(1246)] = 56438,
  [SMALL_STATE(1247)] = 56464,
  [SMALL_STATE(1248)] = 56484,
  [SMALL_STATE(1249)] = 56510,
  [SMALL_STATE(1250)] = 56530,
  [SMALL_STATE(1251)] = 56556,
  [SMALL_STATE(1252)] = 56576,
  [SMALL_STATE(1253)] = 56596,
  [SMALL_STATE(1254)] = 56616,
  [SMALL_STATE(1255)] = 56643,
  [SMALL_STATE(1256)] = 56670,
  [SMALL_STATE(1257)] = 56697,
  [SMALL_STATE(1258)] = 56724,
  [SMALL_STATE(1259)] = 56743,
  [SMALL_STATE(1260)] = 56770,
  [SMALL_STATE(1261)] = 56797,
  [SMALL_STATE(1262)] = 56816,
  [SMALL_STATE(1263)] = 56843,
  [SMALL_STATE(1264)] = 56870,
  [SMALL_STATE(1265)] = 56897,
  [SMALL_STATE(1266)] = 56916,
  [SMALL_STATE(1267)] = 56934,
  [SMALL_STATE(1268)] = 56962,
  [SMALL_STATE(1269)] = 56979,
  [SMALL_STATE(1270)] = 56996,
  [SMALL_STATE(1271)] = 57017,
  [SMALL_STATE(1272)] = 57044,
  [SMALL_STATE(1273)] = 57071,
  [SMALL_STATE(1274)] = 57092,
  [SMALL_STATE(1275)] = 57111,
  [SMALL_STATE(1276)] = 57130,
  [SMALL_STATE(1277)] = 57147,
  [SMALL_STATE(1278)] = 57165,
  [SMALL_STATE(1279)] = 57183,
  [SMALL_STATE(1280)] = 57209,
  [SMALL_STATE(1281)] = 57227,
  [SMALL_STATE(1282)] = 57253,
  [SMALL_STATE(1283)] = 57271,
  [SMALL_STATE(1284)] = 57289,
  [SMALL_STATE(1285)] = 57307,
  [SMALL_STATE(1286)] = 57325,
  [SMALL_STATE(1287)] = 57341,
  [SMALL_STATE(1288)] = 57359,
  [SMALL_STATE(1289)] = 57375,
  [SMALL_STATE(1290)] = 57395,
  [SMALL_STATE(1291)] = 57413,
  [SMALL_STATE(1292)] = 57433,
  [SMALL_STATE(1293)] = 57451,
  [SMALL_STATE(1294)] = 57466,
  [SMALL_STATE(1295)] = 57487,
  [SMALL_STATE(1296)] = 57512,
  [SMALL_STATE(1297)] = 57537,
  [SMALL_STATE(1298)] = 57558,
  [SMALL_STATE(1299)] = 57579,
  [SMALL_STATE(1300)] = 57594,
  [SMALL_STATE(1301)] = 57609,
  [SMALL_STATE(1302)] = 57624,
  [SMALL_STATE(1303)] = 57647,
  [SMALL_STATE(1304)] = 57670,
  [SMALL_STATE(1305)] = 57685,
  [SMALL_STATE(1306)] = 57710,
  [SMALL_STATE(1307)] = 57735,
  [SMALL_STATE(1308)] = 57748,
  [SMALL_STATE(1309)] = 57771,
  [SMALL_STATE(1310)] = 57794,
  [SMALL_STATE(1311)] = 57809,
  [SMALL_STATE(1312)] = 57825,
  [SMALL_STATE(1313)] = 57839,
  [SMALL_STATE(1314)] = 57855,
  [SMALL_STATE(1315)] = 57871,
  [SMALL_STATE(1316)] = 57889,
  [SMALL_STATE(1317)] = 57911,
  [SMALL_STATE(1318)] = 57933,
  [SMALL_STATE(1319)] = 57955,
  [SMALL_STATE(1320)] = 57971,
  [SMALL_STATE(1321)] = 57987,
  [SMALL_STATE(1322)] = 58009,
  [SMALL_STATE(1323)] = 58025,
  [SMALL_STATE(1324)] = 58039,
  [SMALL_STATE(1325)] = 58053,
  [SMALL_STATE(1326)] = 58071,
  [SMALL_STATE(1327)] = 58090,
  [SMALL_STATE(1328)] = 58109,
  [SMALL_STATE(1329)] = 58128,
  [SMALL_STATE(1330)] = 58147,
  [SMALL_STATE(1331)] = 58158,
  [SMALL_STATE(1332)] = 58171,
  [SMALL_STATE(1333)] = 58182,
  [SMALL_STATE(1334)] = 58201,
  [SMALL_STATE(1335)] = 58216,
  [SMALL_STATE(1336)] = 58235,
  [SMALL_STATE(1337)] = 58254,
  [SMALL_STATE(1338)] = 58271,
  [SMALL_STATE(1339)] = 58290,
  [SMALL_STATE(1340)] = 58309,
  [SMALL_STATE(1341)] = 58324,
  [SMALL_STATE(1342)] = 58343,
  [SMALL_STATE(1343)] = 58356,
  [SMALL_STATE(1344)] = 58375,
  [SMALL_STATE(1345)] = 58394,
  [SMALL_STATE(1346)] = 58413,
  [SMALL_STATE(1347)] = 58432,
  [SMALL_STATE(1348)] = 58451,
  [SMALL_STATE(1349)] = 58470,
  [SMALL_STATE(1350)] = 58481,
  [SMALL_STATE(1351)] = 58492,
  [SMALL_STATE(1352)] = 58509,
  [SMALL_STATE(1353)] = 58528,
  [SMALL_STATE(1354)] = 58545,
  [SMALL_STATE(1355)] = 58556,
  [SMALL_STATE(1356)] = 58575,
  [SMALL_STATE(1357)] = 58594,
  [SMALL_STATE(1358)] = 58609,
  [SMALL_STATE(1359)] = 58628,
  [SMALL_STATE(1360)] = 58643,
  [SMALL_STATE(1361)] = 58656,
  [SMALL_STATE(1362)] = 58675,
  [SMALL_STATE(1363)] = 58690,
  [SMALL_STATE(1364)] = 58709,
  [SMALL_STATE(1365)] = 58724,
  [SMALL_STATE(1366)] = 58743,
  [SMALL_STATE(1367)] = 58760,
  [SMALL_STATE(1368)] = 58775,
  [SMALL_STATE(1369)] = 58794,
  [SMALL_STATE(1370)] = 58813,
  [SMALL_STATE(1371)] = 58826,
  [SMALL_STATE(1372)] = 58841,
  [SMALL_STATE(1373)] = 58856,
  [SMALL_STATE(1374)] = 58872,
  [SMALL_STATE(1375)] = 58888,
  [SMALL_STATE(1376)] = 58904,
  [SMALL_STATE(1377)] = 58920,
  [SMALL_STATE(1378)] = 58936,
  [SMALL_STATE(1379)] = 58952,
  [SMALL_STATE(1380)] = 58962,
  [SMALL_STATE(1381)] = 58972,
  [SMALL_STATE(1382)] = 58986,
  [SMALL_STATE(1383)] = 59000,
  [SMALL_STATE(1384)] = 59016,
  [SMALL_STATE(1385)] = 59028,
  [SMALL_STATE(1386)] = 59038,
  [SMALL_STATE(1387)] = 59054,
  [SMALL_STATE(1388)] = 59070,
  [SMALL_STATE(1389)] = 59084,
  [SMALL_STATE(1390)] = 59100,
  [SMALL_STATE(1391)] = 59114,
  [SMALL_STATE(1392)] = 59130,
  [SMALL_STATE(1393)] = 59146,
  [SMALL_STATE(1394)] = 59162,
  [SMALL_STATE(1395)] = 59178,
  [SMALL_STATE(1396)] = 59194,
  [SMALL_STATE(1397)] = 59206,
  [SMALL_STATE(1398)] = 59218,
  [SMALL_STATE(1399)] = 59230,
  [SMALL_STATE(1400)] = 59240,
  [SMALL_STATE(1401)] = 59256,
  [SMALL_STATE(1402)] = 59272,
  [SMALL_STATE(1403)] = 59288,
  [SMALL_STATE(1404)] = 59301,
  [SMALL_STATE(1405)] = 59314,
  [SMALL_STATE(1406)] = 59327,
  [SMALL_STATE(1407)] = 59340,
  [SMALL_STATE(1408)] = 59353,
  [SMALL_STATE(1409)] = 59362,
  [SMALL_STATE(1410)] = 59375,
  [SMALL_STATE(1411)] = 59388,
  [SMALL_STATE(1412)] = 59401,
  [SMALL_STATE(1413)] = 59412,
  [SMALL_STATE(1414)] = 59421,
  [SMALL_STATE(1415)] = 59434,
  [SMALL_STATE(1416)] = 59447,
  [SMALL_STATE(1417)] = 59458,
  [SMALL_STATE(1418)] = 59471,
  [SMALL_STATE(1419)] = 59484,
  [SMALL_STATE(1420)] = 59497,
  [SMALL_STATE(1421)] = 59506,
  [SMALL_STATE(1422)] = 59519,
  [SMALL_STATE(1423)] = 59532,
  [SMALL_STATE(1424)] = 59545,
  [SMALL_STATE(1425)] = 59558,
  [SMALL_STATE(1426)] = 59571,
  [SMALL_STATE(1427)] = 59584,
  [SMALL_STATE(1428)] = 59597,
  [SMALL_STATE(1429)] = 59610,
  [SMALL_STATE(1430)] = 59623,
  [SMALL_STATE(1431)] = 59636,
  [SMALL_STATE(1432)] = 59649,
  [SMALL_STATE(1433)] = 59658,
  [SMALL_STATE(1434)] = 59667,
  [SMALL_STATE(1435)] = 59676,
  [SMALL_STATE(1436)] = 59687,
  [SMALL_STATE(1437)] = 59696,
  [SMALL_STATE(1438)] = 59709,
  [SMALL_STATE(1439)] = 59722,
  [SMALL_STATE(1440)] = 59735,
  [SMALL_STATE(1441)] = 59748,
  [SMALL_STATE(1442)] = 59759,
  [SMALL_STATE(1443)] = 59772,
  [SMALL_STATE(1444)] = 59783,
  [SMALL_STATE(1445)] = 59796,
  [SMALL_STATE(1446)] = 59805,
  [SMALL_STATE(1447)] = 59818,
  [SMALL_STATE(1448)] = 59831,
  [SMALL_STATE(1449)] = 59844,
  [SMALL_STATE(1450)] = 59853,
  [SMALL_STATE(1451)] = 59866,
  [SMALL_STATE(1452)] = 59879,
  [SMALL_STATE(1453)] = 59892,
  [SMALL_STATE(1454)] = 59905,
  [SMALL_STATE(1455)] = 59918,
  [SMALL_STATE(1456)] = 59931,
  [SMALL_STATE(1457)] = 59944,
  [SMALL_STATE(1458)] = 59957,
  [SMALL_STATE(1459)] = 59970,
  [SMALL_STATE(1460)] = 59983,
  [SMALL_STATE(1461)] = 59996,
  [SMALL_STATE(1462)] = 60007,
  [SMALL_STATE(1463)] = 60020,
  [SMALL_STATE(1464)] = 60033,
  [SMALL_STATE(1465)] = 60046,
  [SMALL_STATE(1466)] = 60059,
  [SMALL_STATE(1467)] = 60072,
  [SMALL_STATE(1468)] = 60085,
  [SMALL_STATE(1469)] = 60098,
  [SMALL_STATE(1470)] = 60111,
  [SMALL_STATE(1471)] = 60124,
  [SMALL_STATE(1472)] = 60137,
  [SMALL_STATE(1473)] = 60150,
  [SMALL_STATE(1474)] = 60163,
  [SMALL_STATE(1475)] = 60176,
  [SMALL_STATE(1476)] = 60185,
  [SMALL_STATE(1477)] = 60198,
  [SMALL_STATE(1478)] = 60211,
  [SMALL_STATE(1479)] = 60224,
  [SMALL_STATE(1480)] = 60237,
  [SMALL_STATE(1481)] = 60250,
  [SMALL_STATE(1482)] = 60263,
  [SMALL_STATE(1483)] = 60276,
  [SMALL_STATE(1484)] = 60289,
  [SMALL_STATE(1485)] = 60302,
  [SMALL_STATE(1486)] = 60315,
  [SMALL_STATE(1487)] = 60328,
  [SMALL_STATE(1488)] = 60341,
  [SMALL_STATE(1489)] = 60352,
  [SMALL_STATE(1490)] = 60365,
  [SMALL_STATE(1491)] = 60378,
  [SMALL_STATE(1492)] = 60391,
  [SMALL_STATE(1493)] = 60404,
  [SMALL_STATE(1494)] = 60417,
  [SMALL_STATE(1495)] = 60430,
  [SMALL_STATE(1496)] = 60439,
  [SMALL_STATE(1497)] = 60452,
  [SMALL_STATE(1498)] = 60465,
  [SMALL_STATE(1499)] = 60478,
  [SMALL_STATE(1500)] = 60491,
  [SMALL_STATE(1501)] = 60504,
  [SMALL_STATE(1502)] = 60517,
  [SMALL_STATE(1503)] = 60530,
  [SMALL_STATE(1504)] = 60543,
  [SMALL_STATE(1505)] = 60556,
  [SMALL_STATE(1506)] = 60569,
  [SMALL_STATE(1507)] = 60582,
  [SMALL_STATE(1508)] = 60595,
  [SMALL_STATE(1509)] = 60608,
  [SMALL_STATE(1510)] = 60621,
  [SMALL_STATE(1511)] = 60634,
  [SMALL_STATE(1512)] = 60647,
  [SMALL_STATE(1513)] = 60658,
  [SMALL_STATE(1514)] = 60671,
  [SMALL_STATE(1515)] = 60684,
  [SMALL_STATE(1516)] = 60697,
  [SMALL_STATE(1517)] = 60710,
  [SMALL_STATE(1518)] = 60723,
  [SMALL_STATE(1519)] = 60732,
  [SMALL_STATE(1520)] = 60745,
  [SMALL_STATE(1521)] = 60755,
  [SMALL_STATE(1522)] = 60765,
  [SMALL_STATE(1523)] = 60775,
  [SMALL_STATE(1524)] = 60785,
  [SMALL_STATE(1525)] = 60793,
  [SMALL_STATE(1526)] = 60803,
  [SMALL_STATE(1527)] = 60813,
  [SMALL_STATE(1528)] = 60823,
  [SMALL_STATE(1529)] = 60833,
  [SMALL_STATE(1530)] = 60841,
  [SMALL_STATE(1531)] = 60849,
  [SMALL_STATE(1532)] = 60857,
  [SMALL_STATE(1533)] = 60867,
  [SMALL_STATE(1534)] = 60877,
  [SMALL_STATE(1535)] = 60887,
  [SMALL_STATE(1536)] = 60897,
  [SMALL_STATE(1537)] = 60907,
  [SMALL_STATE(1538)] = 60917,
  [SMALL_STATE(1539)] = 60927,
  [SMALL_STATE(1540)] = 60937,
  [SMALL_STATE(1541)] = 60947,
  [SMALL_STATE(1542)] = 60957,
  [SMALL_STATE(1543)] = 60967,
  [SMALL_STATE(1544)] = 60977,
  [SMALL_STATE(1545)] = 60987,
  [SMALL_STATE(1546)] = 60997,
  [SMALL_STATE(1547)] = 61007,
  [SMALL_STATE(1548)] = 61017,
  [SMALL_STATE(1549)] = 61027,
  [SMALL_STATE(1550)] = 61035,
  [SMALL_STATE(1551)] = 61045,
  [SMALL_STATE(1552)] = 61055,
  [SMALL_STATE(1553)] = 61065,
  [SMALL_STATE(1554)] = 61075,
  [SMALL_STATE(1555)] = 61085,
  [SMALL_STATE(1556)] = 61095,
  [SMALL_STATE(1557)] = 61105,
  [SMALL_STATE(1558)] = 61115,
  [SMALL_STATE(1559)] = 61125,
  [SMALL_STATE(1560)] = 61133,
  [SMALL_STATE(1561)] = 61143,
  [SMALL_STATE(1562)] = 61151,
  [SMALL_STATE(1563)] = 61161,
  [SMALL_STATE(1564)] = 61169,
  [SMALL_STATE(1565)] = 61179,
  [SMALL_STATE(1566)] = 61189,
  [SMALL_STATE(1567)] = 61199,
  [SMALL_STATE(1568)] = 61207,
  [SMALL_STATE(1569)] = 61215,
  [SMALL_STATE(1570)] = 61225,
  [SMALL_STATE(1571)] = 61235,
  [SMALL_STATE(1572)] = 61245,
  [SMALL_STATE(1573)] = 61255,
  [SMALL_STATE(1574)] = 61263,
  [SMALL_STATE(1575)] = 61271,
  [SMALL_STATE(1576)] = 61281,
  [SMALL_STATE(1577)] = 61291,
  [SMALL_STATE(1578)] = 61301,
  [SMALL_STATE(1579)] = 61311,
  [SMALL_STATE(1580)] = 61321,
  [SMALL_STATE(1581)] = 61331,
  [SMALL_STATE(1582)] = 61341,
  [SMALL_STATE(1583)] = 61351,
  [SMALL_STATE(1584)] = 61361,
  [SMALL_STATE(1585)] = 61371,
  [SMALL_STATE(1586)] = 61381,
  [SMALL_STATE(1587)] = 61391,
  [SMALL_STATE(1588)] = 61401,
  [SMALL_STATE(1589)] = 61411,
  [SMALL_STATE(1590)] = 61419,
  [SMALL_STATE(1591)] = 61429,
  [SMALL_STATE(1592)] = 61439,
  [SMALL_STATE(1593)] = 61449,
  [SMALL_STATE(1594)] = 61459,
  [SMALL_STATE(1595)] = 61469,
  [SMALL_STATE(1596)] = 61479,
  [SMALL_STATE(1597)] = 61489,
  [SMALL_STATE(1598)] = 61499,
  [SMALL_STATE(1599)] = 61509,
  [SMALL_STATE(1600)] = 61519,
  [SMALL_STATE(1601)] = 61529,
  [SMALL_STATE(1602)] = 61539,
  [SMALL_STATE(1603)] = 61549,
  [SMALL_STATE(1604)] = 61559,
  [SMALL_STATE(1605)] = 61569,
  [SMALL_STATE(1606)] = 61579,
  [SMALL_STATE(1607)] = 61589,
  [SMALL_STATE(1608)] = 61599,
  [SMALL_STATE(1609)] = 61609,
  [SMALL_STATE(1610)] = 61619,
  [SMALL_STATE(1611)] = 61627,
  [SMALL_STATE(1612)] = 61635,
  [SMALL_STATE(1613)] = 61645,
  [SMALL_STATE(1614)] = 61655,
  [SMALL_STATE(1615)] = 61665,
  [SMALL_STATE(1616)] = 61673,
  [SMALL_STATE(1617)] = 61683,
  [SMALL_STATE(1618)] = 61693,
  [SMALL_STATE(1619)] = 61703,
  [SMALL_STATE(1620)] = 61713,
  [SMALL_STATE(1621)] = 61723,
  [SMALL_STATE(1622)] = 61733,
  [SMALL_STATE(1623)] = 61743,
  [SMALL_STATE(1624)] = 61753,
  [SMALL_STATE(1625)] = 61763,
  [SMALL_STATE(1626)] = 61773,
  [SMALL_STATE(1627)] = 61783,
  [SMALL_STATE(1628)] = 61793,
  [SMALL_STATE(1629)] = 61803,
  [SMALL_STATE(1630)] = 61813,
  [SMALL_STATE(1631)] = 61823,
  [SMALL_STATE(1632)] = 61833,
  [SMALL_STATE(1633)] = 61843,
  [SMALL_STATE(1634)] = 61853,
  [SMALL_STATE(1635)] = 61863,
  [SMALL_STATE(1636)] = 61873,
  [SMALL_STATE(1637)] = 61883,
  [SMALL_STATE(1638)] = 61893,
  [SMALL_STATE(1639)] = 61903,
  [SMALL_STATE(1640)] = 61911,
  [SMALL_STATE(1641)] = 61919,
  [SMALL_STATE(1642)] = 61929,
  [SMALL_STATE(1643)] = 61939,
  [SMALL_STATE(1644)] = 61949,
  [SMALL_STATE(1645)] = 61957,
  [SMALL_STATE(1646)] = 61967,
  [SMALL_STATE(1647)] = 61977,
  [SMALL_STATE(1648)] = 61987,
  [SMALL_STATE(1649)] = 61997,
  [SMALL_STATE(1650)] = 62007,
  [SMALL_STATE(1651)] = 62017,
  [SMALL_STATE(1652)] = 62027,
  [SMALL_STATE(1653)] = 62037,
  [SMALL_STATE(1654)] = 62047,
  [SMALL_STATE(1655)] = 62057,
  [SMALL_STATE(1656)] = 62067,
  [SMALL_STATE(1657)] = 62077,
  [SMALL_STATE(1658)] = 62087,
  [SMALL_STATE(1659)] = 62097,
  [SMALL_STATE(1660)] = 62107,
  [SMALL_STATE(1661)] = 62117,
  [SMALL_STATE(1662)] = 62127,
  [SMALL_STATE(1663)] = 62137,
  [SMALL_STATE(1664)] = 62147,
  [SMALL_STATE(1665)] = 62157,
  [SMALL_STATE(1666)] = 62165,
  [SMALL_STATE(1667)] = 62175,
  [SMALL_STATE(1668)] = 62185,
  [SMALL_STATE(1669)] = 62195,
  [SMALL_STATE(1670)] = 62205,
  [SMALL_STATE(1671)] = 62215,
  [SMALL_STATE(1672)] = 62225,
  [SMALL_STATE(1673)] = 62235,
  [SMALL_STATE(1674)] = 62245,
  [SMALL_STATE(1675)] = 62255,
  [SMALL_STATE(1676)] = 62263,
  [SMALL_STATE(1677)] = 62273,
  [SMALL_STATE(1678)] = 62283,
  [SMALL_STATE(1679)] = 62293,
  [SMALL_STATE(1680)] = 62303,
  [SMALL_STATE(1681)] = 62313,
  [SMALL_STATE(1682)] = 62321,
  [SMALL_STATE(1683)] = 62331,
  [SMALL_STATE(1684)] = 62341,
  [SMALL_STATE(1685)] = 62351,
  [SMALL_STATE(1686)] = 62361,
  [SMALL_STATE(1687)] = 62371,
  [SMALL_STATE(1688)] = 62381,
  [SMALL_STATE(1689)] = 62391,
  [SMALL_STATE(1690)] = 62401,
  [SMALL_STATE(1691)] = 62411,
  [SMALL_STATE(1692)] = 62421,
  [SMALL_STATE(1693)] = 62431,
  [SMALL_STATE(1694)] = 62439,
  [SMALL_STATE(1695)] = 62447,
  [SMALL_STATE(1696)] = 62457,
  [SMALL_STATE(1697)] = 62465,
  [SMALL_STATE(1698)] = 62475,
  [SMALL_STATE(1699)] = 62485,
  [SMALL_STATE(1700)] = 62495,
  [SMALL_STATE(1701)] = 62502,
  [SMALL_STATE(1702)] = 62509,
  [SMALL_STATE(1703)] = 62516,
  [SMALL_STATE(1704)] = 62523,
  [SMALL_STATE(1705)] = 62530,
  [SMALL_STATE(1706)] = 62537,
  [SMALL_STATE(1707)] = 62544,
  [SMALL_STATE(1708)] = 62551,
  [SMALL_STATE(1709)] = 62558,
  [SMALL_STATE(1710)] = 62565,
  [SMALL_STATE(1711)] = 62572,
  [SMALL_STATE(1712)] = 62579,
  [SMALL_STATE(1713)] = 62586,
  [SMALL_STATE(1714)] = 62593,
  [SMALL_STATE(1715)] = 62600,
  [SMALL_STATE(1716)] = 62607,
  [SMALL_STATE(1717)] = 62614,
  [SMALL_STATE(1718)] = 62621,
  [SMALL_STATE(1719)] = 62628,
  [SMALL_STATE(1720)] = 62635,
  [SMALL_STATE(1721)] = 62642,
  [SMALL_STATE(1722)] = 62649,
  [SMALL_STATE(1723)] = 62656,
  [SMALL_STATE(1724)] = 62663,
  [SMALL_STATE(1725)] = 62670,
  [SMALL_STATE(1726)] = 62677,
  [SMALL_STATE(1727)] = 62684,
  [SMALL_STATE(1728)] = 62691,
  [SMALL_STATE(1729)] = 62698,
  [SMALL_STATE(1730)] = 62705,
  [SMALL_STATE(1731)] = 62712,
  [SMALL_STATE(1732)] = 62719,
  [SMALL_STATE(1733)] = 62726,
  [SMALL_STATE(1734)] = 62733,
  [SMALL_STATE(1735)] = 62740,
  [SMALL_STATE(1736)] = 62747,
  [SMALL_STATE(1737)] = 62754,
  [SMALL_STATE(1738)] = 62761,
  [SMALL_STATE(1739)] = 62768,
  [SMALL_STATE(1740)] = 62775,
  [SMALL_STATE(1741)] = 62782,
  [SMALL_STATE(1742)] = 62789,
  [SMALL_STATE(1743)] = 62796,
  [SMALL_STATE(1744)] = 62803,
  [SMALL_STATE(1745)] = 62810,
  [SMALL_STATE(1746)] = 62817,
  [SMALL_STATE(1747)] = 62824,
  [SMALL_STATE(1748)] = 62831,
  [SMALL_STATE(1749)] = 62838,
  [SMALL_STATE(1750)] = 62845,
  [SMALL_STATE(1751)] = 62852,
  [SMALL_STATE(1752)] = 62859,
  [SMALL_STATE(1753)] = 62866,
  [SMALL_STATE(1754)] = 62873,
  [SMALL_STATE(1755)] = 62880,
  [SMALL_STATE(1756)] = 62887,
  [SMALL_STATE(1757)] = 62894,
  [SMALL_STATE(1758)] = 62901,
  [SMALL_STATE(1759)] = 62908,
  [SMALL_STATE(1760)] = 62915,
  [SMALL_STATE(1761)] = 62922,
  [SMALL_STATE(1762)] = 62929,
  [SMALL_STATE(1763)] = 62936,
  [SMALL_STATE(1764)] = 62943,
  [SMALL_STATE(1765)] = 62950,
  [SMALL_STATE(1766)] = 62957,
  [SMALL_STATE(1767)] = 62964,
  [SMALL_STATE(1768)] = 62971,
  [SMALL_STATE(1769)] = 62978,
  [SMALL_STATE(1770)] = 62985,
  [SMALL_STATE(1771)] = 62992,
  [SMALL_STATE(1772)] = 62999,
  [SMALL_STATE(1773)] = 63006,
  [SMALL_STATE(1774)] = 63013,
  [SMALL_STATE(1775)] = 63020,
  [SMALL_STATE(1776)] = 63027,
  [SMALL_STATE(1777)] = 63034,
  [SMALL_STATE(1778)] = 63041,
  [SMALL_STATE(1779)] = 63048,
  [SMALL_STATE(1780)] = 63055,
  [SMALL_STATE(1781)] = 63062,
  [SMALL_STATE(1782)] = 63069,
  [SMALL_STATE(1783)] = 63076,
  [SMALL_STATE(1784)] = 63083,
  [SMALL_STATE(1785)] = 63090,
  [SMALL_STATE(1786)] = 63097,
  [SMALL_STATE(1787)] = 63104,
  [SMALL_STATE(1788)] = 63111,
  [SMALL_STATE(1789)] = 63118,
  [SMALL_STATE(1790)] = 63125,
  [SMALL_STATE(1791)] = 63132,
  [SMALL_STATE(1792)] = 63139,
  [SMALL_STATE(1793)] = 63146,
  [SMALL_STATE(1794)] = 63153,
  [SMALL_STATE(1795)] = 63160,
  [SMALL_STATE(1796)] = 63167,
  [SMALL_STATE(1797)] = 63174,
  [SMALL_STATE(1798)] = 63181,
  [SMALL_STATE(1799)] = 63188,
  [SMALL_STATE(1800)] = 63195,
  [SMALL_STATE(1801)] = 63202,
  [SMALL_STATE(1802)] = 63209,
  [SMALL_STATE(1803)] = 63216,
  [SMALL_STATE(1804)] = 63223,
  [SMALL_STATE(1805)] = 63230,
  [SMALL_STATE(1806)] = 63237,
  [SMALL_STATE(1807)] = 63244,
  [SMALL_STATE(1808)] = 63251,
  [SMALL_STATE(1809)] = 63258,
  [SMALL_STATE(1810)] = 63265,
  [SMALL_STATE(1811)] = 63272,
  [SMALL_STATE(1812)] = 63279,
  [SMALL_STATE(1813)] = 63286,
  [SMALL_STATE(1814)] = 63293,
  [SMALL_STATE(1815)] = 63300,
  [SMALL_STATE(1816)] = 63307,
  [SMALL_STATE(1817)] = 63314,
  [SMALL_STATE(1818)] = 63321,
  [SMALL_STATE(1819)] = 63328,
  [SMALL_STATE(1820)] = 63335,
  [SMALL_STATE(1821)] = 63342,
  [SMALL_STATE(1822)] = 63349,
  [SMALL_STATE(1823)] = 63356,
  [SMALL_STATE(1824)] = 63363,
  [SMALL_STATE(1825)] = 63370,
  [SMALL_STATE(1826)] = 63377,
  [SMALL_STATE(1827)] = 63384,
  [SMALL_STATE(1828)] = 63391,
  [SMALL_STATE(1829)] = 63398,
  [SMALL_STATE(1830)] = 63405,
  [SMALL_STATE(1831)] = 63412,
  [SMALL_STATE(1832)] = 63419,
  [SMALL_STATE(1833)] = 63426,
  [SMALL_STATE(1834)] = 63433,
  [SMALL_STATE(1835)] = 63440,
  [SMALL_STATE(1836)] = 63447,
  [SMALL_STATE(1837)] = 63454,
  [SMALL_STATE(1838)] = 63461,
  [SMALL_STATE(1839)] = 63468,
  [SMALL_STATE(1840)] = 63475,
  [SMALL_STATE(1841)] = 63482,
  [SMALL_STATE(1842)] = 63489,
  [SMALL_STATE(1843)] = 63496,
  [SMALL_STATE(1844)] = 63503,
  [SMALL_STATE(1845)] = 63510,
  [SMALL_STATE(1846)] = 63517,
  [SMALL_STATE(1847)] = 63524,
  [SMALL_STATE(1848)] = 63531,
  [SMALL_STATE(1849)] = 63538,
  [SMALL_STATE(1850)] = 63545,
  [SMALL_STATE(1851)] = 63552,
  [SMALL_STATE(1852)] = 63559,
  [SMALL_STATE(1853)] = 63566,
  [SMALL_STATE(1854)] = 63573,
  [SMALL_STATE(1855)] = 63580,
  [SMALL_STATE(1856)] = 63587,
  [SMALL_STATE(1857)] = 63594,
  [SMALL_STATE(1858)] = 63601,
  [SMALL_STATE(1859)] = 63608,
  [SMALL_STATE(1860)] = 63615,
  [SMALL_STATE(1861)] = 63622,
  [SMALL_STATE(1862)] = 63629,
  [SMALL_STATE(1863)] = 63636,
  [SMALL_STATE(1864)] = 63643,
  [SMALL_STATE(1865)] = 63650,
  [SMALL_STATE(1866)] = 63657,
  [SMALL_STATE(1867)] = 63664,
  [SMALL_STATE(1868)] = 63671,
  [SMALL_STATE(1869)] = 63678,
  [SMALL_STATE(1870)] = 63685,
  [SMALL_STATE(1871)] = 63692,
  [SMALL_STATE(1872)] = 63699,
  [SMALL_STATE(1873)] = 63706,
  [SMALL_STATE(1874)] = 63713,
  [SMALL_STATE(1875)] = 63720,
  [SMALL_STATE(1876)] = 63727,
  [SMALL_STATE(1877)] = 63734,
  [SMALL_STATE(1878)] = 63741,
  [SMALL_STATE(1879)] = 63748,
  [SMALL_STATE(1880)] = 63755,
  [SMALL_STATE(1881)] = 63762,
  [SMALL_STATE(1882)] = 63769,
  [SMALL_STATE(1883)] = 63776,
  [SMALL_STATE(1884)] = 63783,
  [SMALL_STATE(1885)] = 63790,
  [SMALL_STATE(1886)] = 63797,
  [SMALL_STATE(1887)] = 63804,
  [SMALL_STATE(1888)] = 63811,
  [SMALL_STATE(1889)] = 63818,
  [SMALL_STATE(1890)] = 63825,
  [SMALL_STATE(1891)] = 63832,
  [SMALL_STATE(1892)] = 63839,
  [SMALL_STATE(1893)] = 63846,
  [SMALL_STATE(1894)] = 63853,
  [SMALL_STATE(1895)] = 63860,
  [SMALL_STATE(1896)] = 63867,
  [SMALL_STATE(1897)] = 63874,
  [SMALL_STATE(1898)] = 63881,
  [SMALL_STATE(1899)] = 63888,
  [SMALL_STATE(1900)] = 63895,
  [SMALL_STATE(1901)] = 63902,
  [SMALL_STATE(1902)] = 63909,
  [SMALL_STATE(1903)] = 63916,
  [SMALL_STATE(1904)] = 63923,
  [SMALL_STATE(1905)] = 63930,
  [SMALL_STATE(1906)] = 63937,
  [SMALL_STATE(1907)] = 63944,
  [SMALL_STATE(1908)] = 63951,
  [SMALL_STATE(1909)] = 63958,
  [SMALL_STATE(1910)] = 63965,
  [SMALL_STATE(1911)] = 63972,
  [SMALL_STATE(1912)] = 63979,
  [SMALL_STATE(1913)] = 63986,
  [SMALL_STATE(1914)] = 63993,
  [SMALL_STATE(1915)] = 64000,
  [SMALL_STATE(1916)] = 64007,
  [SMALL_STATE(1917)] = 64014,
  [SMALL_STATE(1918)] = 64021,
  [SMALL_STATE(1919)] = 64028,
  [SMALL_STATE(1920)] = 64035,
  [SMALL_STATE(1921)] = 64042,
  [SMALL_STATE(1922)] = 64049,
  [SMALL_STATE(1923)] = 64056,
  [SMALL_STATE(1924)] = 64063,
  [SMALL_STATE(1925)] = 64070,
  [SMALL_STATE(1926)] = 64077,
  [SMALL_STATE(1927)] = 64084,
  [SMALL_STATE(1928)] = 64091,
  [SMALL_STATE(1929)] = 64098,
  [SMALL_STATE(1930)] = 64105,
  [SMALL_STATE(1931)] = 64112,
  [SMALL_STATE(1932)] = 64119,
  [SMALL_STATE(1933)] = 64126,
  [SMALL_STATE(1934)] = 64133,
  [SMALL_STATE(1935)] = 64140,
  [SMALL_STATE(1936)] = 64147,
  [SMALL_STATE(1937)] = 64154,
  [SMALL_STATE(1938)] = 64161,
  [SMALL_STATE(1939)] = 64168,
  [SMALL_STATE(1940)] = 64175,
  [SMALL_STATE(1941)] = 64182,
  [SMALL_STATE(1942)] = 64189,
  [SMALL_STATE(1943)] = 64196,
  [SMALL_STATE(1944)] = 64203,
  [SMALL_STATE(1945)] = 64210,
  [SMALL_STATE(1946)] = 64217,
  [SMALL_STATE(1947)] = 64224,
  [SMALL_STATE(1948)] = 64231,
  [SMALL_STATE(1949)] = 64238,
  [SMALL_STATE(1950)] = 64245,
  [SMALL_STATE(1951)] = 64252,
  [SMALL_STATE(1952)] = 64259,
  [SMALL_STATE(1953)] = 64266,
  [SMALL_STATE(1954)] = 64273,
  [SMALL_STATE(1955)] = 64280,
  [SMALL_STATE(1956)] = 64287,
  [SMALL_STATE(1957)] = 64294,
  [SMALL_STATE(1958)] = 64301,
  [SMALL_STATE(1959)] = 64308,
  [SMALL_STATE(1960)] = 64315,
  [SMALL_STATE(1961)] = 64322,
  [SMALL_STATE(1962)] = 64329,
  [SMALL_STATE(1963)] = 64336,
  [SMALL_STATE(1964)] = 64343,
  [SMALL_STATE(1965)] = 64350,
  [SMALL_STATE(1966)] = 64357,
  [SMALL_STATE(1967)] = 64364,
  [SMALL_STATE(1968)] = 64371,
  [SMALL_STATE(1969)] = 64378,
  [SMALL_STATE(1970)] = 64385,
  [SMALL_STATE(1971)] = 64392,
  [SMALL_STATE(1972)] = 64399,
  [SMALL_STATE(1973)] = 64406,
  [SMALL_STATE(1974)] = 64413,
  [SMALL_STATE(1975)] = 64420,
  [SMALL_STATE(1976)] = 64427,
  [SMALL_STATE(1977)] = 64434,
  [SMALL_STATE(1978)] = 64441,
  [SMALL_STATE(1979)] = 64448,
  [SMALL_STATE(1980)] = 64455,
  [SMALL_STATE(1981)] = 64462,
  [SMALL_STATE(1982)] = 64469,
  [SMALL_STATE(1983)] = 64476,
  [SMALL_STATE(1984)] = 64483,
  [SMALL_STATE(1985)] = 64490,
  [SMALL_STATE(1986)] = 64497,
  [SMALL_STATE(1987)] = 64504,
  [SMALL_STATE(1988)] = 64511,
  [SMALL_STATE(1989)] = 64518,
  [SMALL_STATE(1990)] = 64525,
  [SMALL_STATE(1991)] = 64532,
  [SMALL_STATE(1992)] = 64539,
  [SMALL_STATE(1993)] = 64546,
  [SMALL_STATE(1994)] = 64553,
  [SMALL_STATE(1995)] = 64560,
  [SMALL_STATE(1996)] = 64567,
  [SMALL_STATE(1997)] = 64574,
  [SMALL_STATE(1998)] = 64581,
  [SMALL_STATE(1999)] = 64588,
  [SMALL_STATE(2000)] = 64595,
  [SMALL_STATE(2001)] = 64602,
  [SMALL_STATE(2002)] = 64609,
  [SMALL_STATE(2003)] = 64616,
  [SMALL_STATE(2004)] = 64623,
  [SMALL_STATE(2005)] = 64630,
  [SMALL_STATE(2006)] = 64637,
  [SMALL_STATE(2007)] = 64644,
  [SMALL_STATE(2008)] = 64651,
  [SMALL_STATE(2009)] = 64658,
  [SMALL_STATE(2010)] = 64665,
  [SMALL_STATE(2011)] = 64672,
  [SMALL_STATE(2012)] = 64679,
  [SMALL_STATE(2013)] = 64686,
  [SMALL_STATE(2014)] = 64693,
  [SMALL_STATE(2015)] = 64700,
  [SMALL_STATE(2016)] = 64707,
  [SMALL_STATE(2017)] = 64714,
  [SMALL_STATE(2018)] = 64721,
  [SMALL_STATE(2019)] = 64728,
  [SMALL_STATE(2020)] = 64735,
  [SMALL_STATE(2021)] = 64742,
  [SMALL_STATE(2022)] = 64749,
  [SMALL_STATE(2023)] = 64756,
  [SMALL_STATE(2024)] = 64763,
  [SMALL_STATE(2025)] = 64770,
  [SMALL_STATE(2026)] = 64777,
  [SMALL_STATE(2027)] = 64784,
  [SMALL_STATE(2028)] = 64791,
  [SMALL_STATE(2029)] = 64798,
  [SMALL_STATE(2030)] = 64805,
  [SMALL_STATE(2031)] = 64812,
  [SMALL_STATE(2032)] = 64819,
  [SMALL_STATE(2033)] = 64826,
  [SMALL_STATE(2034)] = 64833,
  [SMALL_STATE(2035)] = 64840,
  [SMALL_STATE(2036)] = 64847,
  [SMALL_STATE(2037)] = 64854,
  [SMALL_STATE(2038)] = 64861,
  [SMALL_STATE(2039)] = 64868,
  [SMALL_STATE(2040)] = 64875,
  [SMALL_STATE(2041)] = 64882,
  [SMALL_STATE(2042)] = 64889,
  [SMALL_STATE(2043)] = 64896,
  [SMALL_STATE(2044)] = 64903,
  [SMALL_STATE(2045)] = 64910,
  [SMALL_STATE(2046)] = 64917,
  [SMALL_STATE(2047)] = 64924,
  [SMALL_STATE(2048)] = 64931,
  [SMALL_STATE(2049)] = 64938,
  [SMALL_STATE(2050)] = 64945,
  [SMALL_STATE(2051)] = 64952,
  [SMALL_STATE(2052)] = 64959,
  [SMALL_STATE(2053)] = 64966,
  [SMALL_STATE(2054)] = 64973,
  [SMALL_STATE(2055)] = 64980,
  [SMALL_STATE(2056)] = 64987,
  [SMALL_STATE(2057)] = 64994,
  [SMALL_STATE(2058)] = 65001,
  [SMALL_STATE(2059)] = 65008,
  [SMALL_STATE(2060)] = 65015,
  [SMALL_STATE(2061)] = 65022,
  [SMALL_STATE(2062)] = 65029,
  [SMALL_STATE(2063)] = 65036,
  [SMALL_STATE(2064)] = 65043,
  [SMALL_STATE(2065)] = 65050,
  [SMALL_STATE(2066)] = 65057,
  [SMALL_STATE(2067)] = 65064,
  [SMALL_STATE(2068)] = 65071,
  [SMALL_STATE(2069)] = 65078,
  [SMALL_STATE(2070)] = 65085,
  [SMALL_STATE(2071)] = 65092,
  [SMALL_STATE(2072)] = 65099,
  [SMALL_STATE(2073)] = 65106,
  [SMALL_STATE(2074)] = 65113,
  [SMALL_STATE(2075)] = 65120,
  [SMALL_STATE(2076)] = 65127,
  [SMALL_STATE(2077)] = 65134,
  [SMALL_STATE(2078)] = 65141,
  [SMALL_STATE(2079)] = 65148,
  [SMALL_STATE(2080)] = 65155,
  [SMALL_STATE(2081)] = 65162,
  [SMALL_STATE(2082)] = 65169,
  [SMALL_STATE(2083)] = 65176,
  [SMALL_STATE(2084)] = 65183,
  [SMALL_STATE(2085)] = 65190,
  [SMALL_STATE(2086)] = 65197,
  [SMALL_STATE(2087)] = 65204,
  [SMALL_STATE(2088)] = 65211,
  [SMALL_STATE(2089)] = 65218,
  [SMALL_STATE(2090)] = 65225,
  [SMALL_STATE(2091)] = 65232,
  [SMALL_STATE(2092)] = 65239,
  [SMALL_STATE(2093)] = 65246,
  [SMALL_STATE(2094)] = 65253,
  [SMALL_STATE(2095)] = 65260,
  [SMALL_STATE(2096)] = 65267,
  [SMALL_STATE(2097)] = 65274,
  [SMALL_STATE(2098)] = 65281,
  [SMALL_STATE(2099)] = 65288,
  [SMALL_STATE(2100)] = 65295,
  [SMALL_STATE(2101)] = 65302,
  [SMALL_STATE(2102)] = 65309,
  [SMALL_STATE(2103)] = 65316,
  [SMALL_STATE(2104)] = 65323,
  [SMALL_STATE(2105)] = 65330,
  [SMALL_STATE(2106)] = 65337,
  [SMALL_STATE(2107)] = 65344,
  [SMALL_STATE(2108)] = 65351,
  [SMALL_STATE(2109)] = 65358,
  [SMALL_STATE(2110)] = 65365,
  [SMALL_STATE(2111)] = 65372,
  [SMALL_STATE(2112)] = 65379,
  [SMALL_STATE(2113)] = 65386,
  [SMALL_STATE(2114)] = 65393,
  [SMALL_STATE(2115)] = 65400,
  [SMALL_STATE(2116)] = 65407,
  [SMALL_STATE(2117)] = 65414,
  [SMALL_STATE(2118)] = 65421,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(156),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1190),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1199),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1317),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(654),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2072),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2071),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1260),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1418),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2058),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2054),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1535),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1540),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(562),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1255),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1393),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1547),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1548),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1550),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1551),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1553),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1412),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2034),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2033),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(46),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(449),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [95] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__value, 1, 0, 0),
  [97] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__value, 1, 0, 0),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, 0, 0),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(633),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(626),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1902),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1989),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2085),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1256),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1481),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2005),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2086),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1528),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1556),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1262),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1389),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1645),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1606),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1647),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1649),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1655),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2007),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2008),
  [213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1247),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1252),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2044),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2019),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1253),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1241),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1249),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1927),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(482),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1904),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1829),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1369),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [247] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_script_block, 3, 0, 0),
  [249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_script_block, 2, 0, 0),
  [251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_literal, 3, 0, 0),
  [253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_literal, 3, 0, 0),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1003),
  [257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(128),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(902),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [267] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(127),
  [270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(156),
  [273] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1190),
  [276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1199),
  [279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(124),
  [282] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1139),
  [285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1369),
  [288] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(654),
  [291] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(125),
  [294] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(420),
  [297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(266),
  [300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0),
  [302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(37),
  [305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2085),
  [308] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1256),
  [311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1481),
  [314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2005),
  [317] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2086),
  [320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1528),
  [323] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1556),
  [326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(562),
  [329] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(254),
  [332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1262),
  [335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1389),
  [338] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1645),
  [341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1606),
  [344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1647),
  [347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1649),
  [350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1655),
  [353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(954),
  [356] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1412),
  [359] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2007),
  [362] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2008),
  [365] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(655),
  [368] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(648),
  [371] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(65),
  [374] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(46),
  [377] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(449),
  [380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1251),
  [382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1232),
  [384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(120),
  [386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(431),
  [390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(958),
  [392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_list, 1, 0, 0),
  [396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1019),
  [398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1229),
  [404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(854),
  [408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(379),
  [414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1223),
  [418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(833),
  [420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1342),
  [422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(891),
  [424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_list, 1, 0, 0),
  [426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0),
  [428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(478),
  [431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2071),
  [434] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1260),
  [437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1418),
  [440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2058),
  [443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2054),
  [446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1535),
  [449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1540),
  [452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1255),
  [455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1393),
  [458] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1547),
  [461] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1548),
  [464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1550),
  [467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1551),
  [470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1553),
  [473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2034),
  [476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2033),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(602),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(597),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(605),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1991),
  [515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2092),
  [517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1257),
  [519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2048),
  [523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2093),
  [525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1527),
  [527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1536),
  [529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1254),
  [531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1377),
  [533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1545),
  [535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1592),
  [537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1542),
  [539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1541),
  [541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1538),
  [543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2050),
  [545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2051),
  [547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(638),
  [553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1965),
  [559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2098),
  [561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1263),
  [563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1499),
  [565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2067),
  [567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2099),
  [569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1523),
  [571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1534),
  [573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1259),
  [575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1395),
  [577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1618),
  [579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1579),
  [581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1619),
  [583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1620),
  [585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1621),
  [587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2069),
  [589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2070),
  [591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_access, 3, 0, 0),
  [593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_access, 3, 0, 0),
  [595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_block_expression, 3, 0, 0),
  [597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_script_block_expression, 3, 0, 0),
  [599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable, 1, 0, 0),
  [601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable, 1, 0, 0),
  [603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_block_expression, 4, 0, 0),
  [605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_script_block_expression, 4, 0, 0),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invokation_expression, 1, 0, 0),
  [611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invokation_expression, 1, 0, 0),
  [613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 15),
  [615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 15),
  [617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pre_decrement_expression, 2, 0, 0),
  [619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pre_decrement_expression, 2, 0, 0),
  [621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expandable_here_string_literal, 2, 0, 0),
  [623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expandable_here_string_literal, 2, 0, 0),
  [625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expandable_string_literal, 2, 0, 0),
  [627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expandable_string_literal, 2, 0, 0),
  [629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sub_expression, 3, 0, 8),
  [631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sub_expression, 3, 0, 8),
  [633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_name, 1, 0, 0),
  [635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_name, 1, 0, 0),
  [637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_post_increment_expression, 2, 0, 0),
  [641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_post_increment_expression, 2, 0, 0),
  [643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_literal_expression, 3, 0, 0),
  [645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_literal_expression, 3, 0, 0),
  [647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_literal_expression, 2, 0, 0),
  [649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_literal_expression, 2, 0, 0),
  [651] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__literal, 1, 0, 0), REDUCE(sym_member_name, 1, 0, 0),
  [654] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__literal, 1, 0, 0), REDUCE(sym_member_name, 1, 0, 0),
  [657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2, 0, 0),
  [659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2, 0, 0),
  [661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expandable_here_string_literal, 3, 0, 0),
  [663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expandable_here_string_literal, 3, 0, 0),
  [665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_post_decrement_expression, 2, 0, 0),
  [667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_post_decrement_expression, 2, 0, 0),
  [669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [671] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invokation_foreach_expression, 3, 0, 0),
  [675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invokation_foreach_expression, 3, 0, 0),
  [677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expandable_string_literal, 4, 0, 0),
  [679] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expandable_string_literal, 4, 0, 0),
  [681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sub_expression, 2, 0, 0),
  [683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sub_expression, 2, 0, 0),
  [685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 1, 0, 0),
  [687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 1, 0, 0),
  [689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_integer_literal, 1, 0, 0),
  [691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_integer_literal, 1, 0, 0),
  [693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 2, 0, 0),
  [695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 2, 0, 0),
  [697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expandable_string_literal, 3, 0, 0),
  [699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expandable_string_literal, 3, 0, 0),
  [701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 3, 0, 8),
  [703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 3, 0, 8),
  [705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_access, 4, 0, 0),
  [707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_element_access, 4, 0, 0),
  [709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invokation_expression, 4, 0, 0),
  [711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invokation_expression, 4, 0, 0),
  [713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 1, 0, 0),
  [715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 1, 0, 0),
  [717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_with_unary_operator, 1, 0, 0),
  [719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_with_unary_operator, 1, 0, 0),
  [721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_with_unary_operator, 2, 0, 0),
  [723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_with_unary_operator, 2, 0, 0),
  [725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 2, 0, 0),
  [727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 2, 0, 0),
  [729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pre_increment_expression, 2, 0, 0),
  [731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pre_increment_expression, 2, 0, 0),
  [733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(691),
  [741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(699),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(698),
  [763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_literal_expression, 1, 0, 0),
  [767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_literal_expression, 1, 0, 0),
  [769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_literal_expression, 3, 0, 0),
  [771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_literal_expression, 3, 0, 0),
  [773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 1, 0, 0),
  [775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 1, 0, 0),
  [777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 3, 0, 0),
  [781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 3, 0, 0),
  [783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_expression, 3, 0, 0),
  [787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_expression, 3, 0, 0),
  [789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_expression, 1, 0, 0),
  [793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_expression, 1, 0, 0),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multiplicative_expression, 1, 0, 0),
  [799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multiplicative_expression, 1, 0, 0),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multiplicative_expression, 3, 0, 0),
  [805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multiplicative_expression, 3, 0, 0),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_additive_expression, 3, 0, 0),
  [811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_additive_expression, 3, 0, 0),
  [813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_additive_expression, 1, 0, 0),
  [819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_additive_expression, 1, 0, 0),
  [821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(558),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comparison_expression, 1, 0, 0),
  [827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comparison_expression, 1, 0, 0),
  [829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(551),
  [833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comparison_expression, 3, 0, 0),
  [835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comparison_expression, 3, 0, 0),
  [837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(768),
  [841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1176),
  [843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1191),
  [845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(771),
  [847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1365),
  [849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(799),
  [853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(35),
  [857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(669),
  [859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(670),
  [861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(47),
  [863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitwise_expression, 1, 0, 0),
  [869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bitwise_expression, 1, 0, 0),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1123),
  [875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(644),
  [879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(657),
  [883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(795),
  [885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(906),
  [887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1183),
  [889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1197),
  [891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(796),
  [893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1326),
  [895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(659),
  [897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(31),
  [903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(660),
  [905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(593),
  [915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(592),
  [917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(591),
  [919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitwise_expression, 3, 0, 0),
  [921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bitwise_expression, 3, 0, 0),
  [923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(671),
  [927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(588),
  [933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(587),
  [935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(629),
  [937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__command_argument, 1, 0, 0),
  [939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(847),
  [943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1181),
  [947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1200),
  [949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(846),
  [951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1347),
  [953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(600),
  [955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(863),
  [957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(34),
  [961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(598),
  [963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(594),
  [965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(903),
  [973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(858),
  [975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1198),
  [979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(850),
  [981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1328),
  [983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(680),
  [985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(870),
  [987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(285),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(681),
  [993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(48),
  [999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [1001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(640),
  [1003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(645),
  [1005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(678),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(924),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(676),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(677),
  [1015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1058),
  [1017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__command_argument, 1, 0, 0),
  [1019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(922),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(662),
  [1023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [1025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(667),
  [1027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(683),
  [1029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(621),
  [1031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(650),
  [1033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1084),
  [1035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1083),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(932),
  [1039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [1045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [1047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [1051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [1053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [1055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(959),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [1061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(635),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [1067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [1073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [1077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(612),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [1083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(997),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [1093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [1099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [1101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1028),
  [1103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [1107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [1109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [1113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [1115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [1117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [1119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [1121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(617),
  [1125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [1127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [1131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1170),
  [1133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1201),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [1137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1333),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [1141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [1143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(607),
  [1147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [1151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [1153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [1155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1048),
  [1157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1185),
  [1159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1202),
  [1161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [1163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1338),
  [1165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1129),
  [1167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(280),
  [1169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [1171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(616),
  [1173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(615),
  [1175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [1177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(44),
  [1179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(473),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [1183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1673),
  [1185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(241),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1679),
  [1189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(244),
  [1191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1554),
  [1193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(245),
  [1195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1674),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(240),
  [1199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1662),
  [1201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [1203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1572),
  [1205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(237),
  [1207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1597),
  [1209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [1211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1669),
  [1213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [1215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1539),
  [1217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [1219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1648),
  [1221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [1223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1635),
  [1225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(231),
  [1227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1632),
  [1229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1587),
  [1231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1577),
  [1233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1630),
  [1235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1671),
  [1237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1685),
  [1239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1600),
  [1241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1684),
  [1243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [1245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1612),
  [1247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1578),
  [1249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1584),
  [1251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1616),
  [1253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1629),
  [1255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1691),
  [1257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1654),
  [1259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1623),
  [1261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [1263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1184),
  [1265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1195),
  [1267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [1269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1358),
  [1271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(271),
  [1273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(32),
  [1275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [1277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1441),
  [1279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(627),
  [1281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(634),
  [1283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [1285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [1287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [1289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_flow_control_statement, 1, 0, 0),
  [1291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(704),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [1295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [1299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [1303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [1307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [1313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, 0, 0),
  [1315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1341),
  [1317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1699),
  [1319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 14),
  [1321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2091),
  [1323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1642),
  [1325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_command_argument_sep_repeat1, 2, 0, 0),
  [1327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_argument_sep_repeat1, 2, 0, 0), SHIFT_REPEAT(298),
  [1330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [1332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [1334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [1336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_argument_sep_repeat1, 2, 0, 0), SHIFT_REPEAT(305),
  [1339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_command_argument_sep_repeat1, 2, 0, 0),
  [1341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_argument_sep, 1, 0, 0),
  [1343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [1345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_argument_sep, 1, 0, 0),
  [1347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [1349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, 0, 0),
  [1351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1345),
  [1353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1657),
  [1355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 14),
  [1357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1707),
  [1359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1695),
  [1361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [1367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [1369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_elseif_clauses_repeat1, 2, 0, 0),
  [1371] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_elseif_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(2091),
  [1374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [1376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_argument_sep_repeat1, 2, 0, 0), SHIFT_REPEAT(322),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [1381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clauses, 1, 0, 0),
  [1383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_param_block, 5, 0, 0),
  [1385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_param_block, 5, 0, 0),
  [1387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_script_block_repeat1, 2, 0, 0),
  [1389] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_script_block_repeat1, 2, 0, 0), SHIFT_REPEAT(326),
  [1392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_clauses, 1, 0, 0),
  [1394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [1396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [1398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [1400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_param_block, 3, 0, 0),
  [1402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_param_block, 3, 0, 0),
  [1404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_catch_clauses_repeat1, 2, 0, 0),
  [1406] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_catch_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(1341),
  [1409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_argument_sep_repeat1, 2, 0, 0), SHIFT_REPEAT(333),
  [1412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [1414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [1416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [1418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [1420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_param_block, 4, 0, 0),
  [1422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_param_block, 4, 0, 0),
  [1424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [1426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [1428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [1430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [1432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [1434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [1436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_catch_clauses_repeat1, 2, 0, 0),
  [1438] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_catch_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(1345),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [1443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clauses, 1, 0, 0),
  [1445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elseif_clauses, 1, 0, 0),
  [1447] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [1449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_script_block_repeat1, 1, 0, 0),
  [1451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_elseif_clauses_repeat1, 2, 0, 0),
  [1453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_elseif_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(1707),
  [1456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 2, 0, 0),
  [1458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 3, 0, 12),
  [1460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_argument_expression, 3, 0, 0),
  [1462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_argument_expression, 3, 0, 0),
  [1464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 3, 0, 0),
  [1466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_argument_expression, 3, 0, 0),
  [1468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_argument_expression, 3, 0, 0),
  [1470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [1472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_argument_expression, 1, 0, 0),
  [1474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_argument_expression, 1, 0, 0),
  [1476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 16),
  [1478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [1480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_clause, 5, 0, 14),
  [1482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, 0, 0),
  [1484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, 0, 0),
  [1486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_argument_expression, 1, 0, 0),
  [1488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_argument_expression, 1, 0, 0),
  [1490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [1492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multiplicative_argument_expression, 3, 0, 0),
  [1494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multiplicative_argument_expression, 3, 0, 0),
  [1496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [1498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 16),
  [1500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 2, 0, 0),
  [1502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 3, 0, 12),
  [1504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [1506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elseif_clause, 5, 0, 14),
  [1508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_argument_sep_repeat1, 2, 0, 0), SHIFT_REPEAT(399),
  [1511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 3, 0, 0),
  [1513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multiplicative_argument_expression, 1, 0, 0),
  [1515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multiplicative_argument_expression, 1, 0, 0),
  [1517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_argument_sep_repeat1, 2, 0, 0), SHIFT_REPEAT(403),
  [1520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(399),
  [1522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, 0, 0),
  [1524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, 0, 0),
  [1526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 5, 0, 0),
  [1528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [1530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [1532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [1534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [1536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [1538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(666),
  [1540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [1542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [1544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [1546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [1548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10, 0, 23),
  [1550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10, 0, 25),
  [1552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [1554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10, 0, 24),
  [1556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, 0, 23),
  [1558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_statement, 8, 0, 0),
  [1560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 18),
  [1562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 21),
  [1564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_additive_argument_expression, 1, 0, 0),
  [1566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_additive_argument_expression, 1, 0, 0),
  [1568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [1570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 22),
  [1572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, 0, 0),
  [1574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_statement, 8, 0, 0),
  [1576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_statement, 7, 0, 0),
  [1578] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trap_statement, 3, 0, 0),
  [1580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 18),
  [1582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 21),
  [1584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_statement, 7, 0, 0),
  [1586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_data_statement, 3, 0, 0),
  [1588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, 0, 20),
  [1590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2, 0, 0),
  [1592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_statement, 6, 0, 0),
  [1594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_statement, 6, 0, 0),
  [1596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 6, 0, 19),
  [1598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 12, 0, 26),
  [1600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [1602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 4, 0, 0),
  [1604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, 0, 18),
  [1606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 2, 0, 0),
  [1608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [1610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, 0, 0),
  [1612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 17),
  [1614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_statement, 2, 0, 0),
  [1616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_statement, 5, 0, 0),
  [1618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_statement, 5, 0, 0),
  [1620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 4, 0, 0),
  [1622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_statement, 5, 0, 0),
  [1624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_statement, 4, 0, 0),
  [1626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parallel_statement, 2, 0, 0),
  [1628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [1630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, 0, 0),
  [1632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inlinescript_statement, 2, 0, 0),
  [1634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, 0, 0),
  [1636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, 0, 14),
  [1638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trap_statement, 2, 0, 0),
  [1640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 2, 0, 0),
  [1642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 3, 0, 0),
  [1644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [1646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_additive_argument_expression, 3, 0, 0),
  [1648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_additive_argument_expression, 3, 0, 0),
  [1650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_data_statement, 4, 0, 0),
  [1652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_statement, 4, 0, 0),
  [1654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_statement, 4, 0, 0),
  [1656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [1658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inlinescript_statement, 2, 0, 0),
  [1660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, 0, 0),
  [1662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, 0, 0),
  [1664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_statement, 4, 0, 0),
  [1666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, 0, 0),
  [1668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 4, 0, 0),
  [1670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, 0, 14),
  [1672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_statement, 6, 0, 0),
  [1674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_statement, 5, 0, 0),
  [1676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [1678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(557),
  [1680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2, 0, 0),
  [1682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 20),
  [1684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 2, 0, 0),
  [1686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_statement, 7, 0, 0),
  [1688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 4, 0, 0),
  [1690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trap_statement, 3, 0, 0),
  [1692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_statement, 4, 0, 0),
  [1694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 21),
  [1696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 18),
  [1698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_literal_body, 1, 0, 0),
  [1700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_statement, 3, 0, 0),
  [1702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 2, 0, 0),
  [1704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_statement, 6, 0, 0),
  [1706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_statement, 7, 0, 0),
  [1708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_statement, 8, 0, 0),
  [1710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 22),
  [1712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 21),
  [1714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 6, 0, 19),
  [1716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 18),
  [1718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, 0, 18),
  [1720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_statement, 4, 0, 0),
  [1722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, 0, 0),
  [1724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trap_statement, 2, 0, 0),
  [1726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_statement, 5, 0, 0),
  [1728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_statement, 8, 0, 0),
  [1730] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_hash_literal_body_repeat1, 2, 0, 0), SHIFT_REPEAT(932),
  [1733] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hash_literal_body_repeat1, 2, 0, 0), SHIFT_REPEAT(932),
  [1736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hash_literal_body_repeat1, 2, 0, 0), SHIFT_REPEAT(1295),
  [1739] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hash_literal_body_repeat1, 2, 0, 0), SHIFT_REPEAT(1170),
  [1742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hash_literal_body_repeat1, 2, 0, 0), SHIFT_REPEAT(1201),
  [1745] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hash_literal_body_repeat1, 2, 0, 0), SHIFT_REPEAT(930),
  [1748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hash_literal_body_repeat1, 2, 0, 0), SHIFT_REPEAT(1920),
  [1751] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hash_literal_body_repeat1, 2, 0, 0), SHIFT_REPEAT(1352),
  [1754] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hash_literal_body_repeat1, 2, 0, 0), SHIFT_REPEAT(666),
  [1757] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hash_literal_body_repeat1, 2, 0, 0), SHIFT_REPEAT(959),
  [1760] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_hash_literal_body_repeat1, 2, 0, 0), SHIFT_REPEAT(959),
  [1763] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hash_literal_body_repeat1, 2, 0, 0), SHIFT_REPEAT(279),
  [1766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hash_literal_body_repeat1, 2, 0, 0), SHIFT_REPEAT(36),
  [1769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_hash_literal_body_repeat1, 2, 0, 0),
  [1771] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_hash_literal_body_repeat1, 2, 0, 0), SHIFT_REPEAT(666),
  [1774] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hash_literal_body_repeat1, 2, 0, 0), SHIFT_REPEAT(664),
  [1777] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hash_literal_body_repeat1, 2, 0, 0), SHIFT_REPEAT(663),
  [1780] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hash_literal_body_repeat1, 2, 0, 0), SHIFT_REPEAT(63),
  [1783] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hash_literal_body_repeat1, 2, 0, 0), SHIFT_REPEAT(56),
  [1786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hash_literal_body_repeat1, 2, 0, 0), SHIFT_REPEAT(454),
  [1789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 17),
  [1791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 3, 0, 0),
  [1793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 12, 0, 26),
  [1795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, 0, 23),
  [1797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_statement, 5, 0, 0),
  [1799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_statement, 2, 0, 0),
  [1801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parallel_statement, 2, 0, 0),
  [1803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10, 0, 24),
  [1805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10, 0, 25),
  [1807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10, 0, 23),
  [1809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, 0, 0),
  [1811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_statement, 4, 0, 0),
  [1813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [1815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [1817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(651),
  [1819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [1821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [1823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [1825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [1827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [1829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [1831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [1833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(619),
  [1835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [1837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [1839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignement_operator, 1, 0, 0),
  [1841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [1843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(544),
  [1845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [1847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [1849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [1851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [1853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [1855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [1857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comparison_argument_expression, 3, 0, 0),
  [1859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comparison_argument_expression, 3, 0, 0),
  [1861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [1863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [1865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comparison_argument_expression, 1, 0, 0),
  [1867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comparison_argument_expression, 1, 0, 0),
  [1869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitwise_argument_expression, 3, 0, 0),
  [1871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitwise_argument_expression, 1, 0, 0),
  [1873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [1875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [1877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [1879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [1881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [1883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [1885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [1887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [1889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [1891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [1893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [1895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [1897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [1899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [1901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [1903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [1905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [1907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [1909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [1911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [1913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [1915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [1917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [1919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [1921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [1923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [1925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [1927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [1929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [1931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [1933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [1935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [1937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [1939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [1941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [1943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [1945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [1947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [1949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [1951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [1953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [1955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [1957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [1959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [1961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [1963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [1965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [1967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [1969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [1971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [1973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [1975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [1977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [1979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [1981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [1983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [1985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [1987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [1989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [1991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [1993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [1995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [1997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [1999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [2001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [2003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [2005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [2007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [2009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [2011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [2013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [2015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [2017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [2019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [2021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [2023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [2025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [2027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [2029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [2031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [2033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [2035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [2037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [2039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [2041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [2043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [2045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [2047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [2049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [2051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [2053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [2055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [2057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [2059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [2061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [2063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [2065] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__value, 1, 0, 0), REDUCE(aux_sym_path_command_name_repeat1, 1, 0, 0),
  [2068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_path_command_name_repeat1, 1, 0, 0),
  [2070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__value, 1, 0, 0), REDUCE(aux_sym_path_command_name_repeat1, 1, 0, 0),
  [2073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [2075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1348),
  [2077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1215),
  [2079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [2081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1246),
  [2083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [2085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1363),
  [2087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [2089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(736),
  [2091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [2093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [2095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [2097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [2099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [2101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1339),
  [2103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [2105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(976),
  [2107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [2109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(921),
  [2111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [2113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(335),
  [2115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [2117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1335),
  [2119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [2121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(971),
  [2123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [2125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1305),
  [2127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1846),
  [2129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(493),
  [2131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [2133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [2135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1368),
  [2137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [2139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(487),
  [2141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1936),
  [2143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(962),
  [2145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [2147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [2149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2047),
  [2151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [2153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [2155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [2157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [2159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [2161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(516),
  [2163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(970),
  [2165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [2167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [2169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_clauses, 1, 0, 0),
  [2171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(932),
  [2174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(1305),
  [2177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(1170),
  [2180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(1201),
  [2183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(930),
  [2186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(1348),
  [2189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(959),
  [2192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(1846),
  [2195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(279),
  [2198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(36),
  [2201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_switch_clauses_repeat1, 2, 0, 0),
  [2203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(63),
  [2206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(56),
  [2209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(454),
  [2212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_path_command_name_repeat1, 2, 0, 0),
  [2214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_path_command_name_repeat1, 2, 0, 0), SHIFT_REPEAT(814),
  [2217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_path_command_name_repeat1, 2, 0, 0), SHIFT_REPEAT(735),
  [2220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_path_command_name_repeat1, 2, 0, 0),
  [2222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_path_command_name, 1, 0, 0),
  [2224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(788),
  [2226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(738),
  [2228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_path_command_name, 1, 0, 0),
  [2230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(814),
  [2232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [2234] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_path_command_name_repeat1, 2, 0, 0), SHIFT_REPEAT(788),
  [2237] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_path_command_name_repeat1, 2, 0, 0), SHIFT_REPEAT(738),
  [2240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1138),
  [2242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1089),
  [2244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [2246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command, 2, 0, 6),
  [2248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command, 2, 0, 6),
  [2250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [2252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [2254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command, 1, 0, 1),
  [2256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(871),
  [2258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(742),
  [2260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_path_command_name_repeat1, 2, 0, 0), SHIFT_REPEAT(871),
  [2263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_path_command_name_repeat1, 2, 0, 0), SHIFT_REPEAT(742),
  [2266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command, 1, 0, 1),
  [2268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [2270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(749),
  [2272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [2274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [2276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_path_command_name_repeat1, 2, 0, 0), SHIFT_REPEAT(869),
  [2279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_path_command_name_repeat1, 2, 0, 0), SHIFT_REPEAT(749),
  [2282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1103),
  [2284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(849),
  [2286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [2288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(751),
  [2290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [2292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [2294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [2296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [2298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_elements, 1, 0, 0),
  [2300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_elements, 1, 0, 0),
  [2302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [2304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [2306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [2308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(752),
  [2310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [2312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [2314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [2316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1114),
  [2318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [2320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [2322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1306),
  [2324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1817),
  [2326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_elements_repeat1, 2, 0, 0), SHIFT_REPEAT(1138),
  [2329] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_elements_repeat1, 2, 0, 0), SHIFT_REPEAT(1089),
  [2332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_elements_repeat1, 2, 0, 0), SHIFT_REPEAT(825),
  [2335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_command_elements_repeat1, 2, 0, 0),
  [2337] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_elements_repeat1, 2, 0, 0), SHIFT_REPEAT(306),
  [2340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_elements_repeat1, 2, 0, 0), SHIFT_REPEAT(335),
  [2343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_command_elements_repeat1, 2, 0, 0),
  [2345] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_elements_repeat1, 2, 0, 0), SHIFT_REPEAT(1093),
  [2348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_elements_repeat1, 2, 0, 0), SHIFT_REPEAT(827),
  [2351] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_elements_repeat1, 2, 0, 0), SHIFT_REPEAT(309),
  [2354] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_elements_repeat1, 2, 0, 0), SHIFT_REPEAT(321),
  [2357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_elements_repeat1, 2, 0, 0), SHIFT_REPEAT(1103),
  [2360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_elements_repeat1, 2, 0, 0), SHIFT_REPEAT(839),
  [2363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_elements_repeat1, 2, 0, 0), SHIFT_REPEAT(320),
  [2366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_elements_repeat1, 2, 0, 0), SHIFT_REPEAT(359),
  [2369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_elements_repeat1, 2, 0, 0), SHIFT_REPEAT(1114),
  [2372] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_elements_repeat1, 2, 0, 0), SHIFT_REPEAT(845),
  [2375] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_elements_repeat1, 2, 0, 0), SHIFT_REPEAT(336),
  [2378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_elements_repeat1, 2, 0, 0), SHIFT_REPEAT(369),
  [2381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_expression, 3, 0, 0),
  [2383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_expression, 3, 0, 0),
  [2385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [2387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(839),
  [2389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [2391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(895),
  [2393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [2395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [2397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [2399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_left_assignment_expression, 1, 0, 0),
  [2401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [2403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [2405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [2407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipeline, 1, 0, 0),
  [2409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_expression, 1, 0, 0),
  [2411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_expression, 1, 0, 0),
  [2413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [2415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(845),
  [2417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(352),
  [2419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [2421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [2423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [2425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [2427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [2429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [2431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [2433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [2435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_name_expr, 1, 0, 0),
  [2437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_name_expr, 1, 0, 0),
  [2439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_redirected_file_name, 1, 0, 0),
  [2441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_redirected_file_name, 1, 0, 0),
  [2443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [2445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [2447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(686),
  [2449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [2451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_name, 1, 0, 0),
  [2453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(935),
  [2455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1167),
  [2457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [2459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_name, 2, 0, 0),
  [2461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(965),
  [2463] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_name_repeat1, 2, 0, 0), SHIFT_REPEAT(945),
  [2466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_command_name_repeat1, 2, 0, 0),
  [2468] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_name_repeat1, 2, 0, 0), SHIFT_REPEAT(945),
  [2471] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_name_repeat1, 2, 0, 0), SHIFT_REPEAT(1165),
  [2474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_command_name_repeat1, 2, 0, 0),
  [2476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [2478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(945),
  [2480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1165),
  [2482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_name, 2, 0, 0),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [2486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(947),
  [2488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_name, 1, 0, 0),
  [2490] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_name_repeat1, 2, 0, 0), SHIFT_REPEAT(965),
  [2493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_name_repeat1, 2, 0, 0), SHIFT_REPEAT(965),
  [2496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_name_repeat1, 2, 0, 0), SHIFT_REPEAT(1167),
  [2499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [2501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(982),
  [2503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1169),
  [2505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expandable_string_literal_immediate, 3, 0, 0),
  [2507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expandable_string_literal_immediate, 3, 0, 0),
  [2509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expandable_string_literal_immediate, 2, 0, 0),
  [2511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expandable_string_literal_immediate, 2, 0, 0),
  [2513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [2515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [2517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(981),
  [2519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1168),
  [2521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0),
  [2523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0),
  [2525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [2527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [2529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [2531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(985),
  [2533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [2535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(984),
  [2537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_name_repeat1, 2, 0, 0), SHIFT_REPEAT(984),
  [2540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_name_repeat1, 2, 0, 0), SHIFT_REPEAT(984),
  [2543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_name_repeat1, 2, 0, 0), SHIFT_REPEAT(1169),
  [2546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_name_repeat1, 2, 0, 0), SHIFT_REPEAT(985),
  [2549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_name_repeat1, 2, 0, 0), SHIFT_REPEAT(985),
  [2552] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_name_repeat1, 2, 0, 0), SHIFT_REPEAT(1168),
  [2555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [2557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [2559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [2561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(689),
  [2563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [2565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [2567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [2569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [2571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [2573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [2575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [2577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [2579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(684),
  [2581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [2583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__command_element, 1, 0, 0),
  [2585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [2587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__command_element, 1, 0, 0),
  [2589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__command_argument, 2, 0, 0),
  [2591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(649),
  [2593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__command_argument, 2, 0, 0),
  [2595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(673),
  [2597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [2599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [2601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(344),
  [2603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [2605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(643),
  [2607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(608),
  [2609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(314),
  [2611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(679),
  [2613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(630),
  [2615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_redirection, 2, 0, 0),
  [2617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_redirection, 2, 0, 0),
  [2619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__command_element, 2, 0, 0),
  [2621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__command_element, 2, 0, 0),
  [2623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_redirection, 1, 0, 0),
  [2625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_redirection, 1, 0, 0),
  [2627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_entry, 5, 0, 0),
  [2629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_entry, 5, 0, 0),
  [2631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [2633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_merging_redirection_operator, 1, 0, 0),
  [2635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_merging_redirection_operator, 1, 0, 0),
  [2637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(586),
  [2639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(604),
  [2641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_script_block_repeat1, 2, 0, 0),
  [2643] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_script_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1097),
  [2646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_entry, 4, 0, 0),
  [2648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_entry, 4, 0, 0),
  [2650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [2652] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_redirections_repeat1, 2, 0, 0), SHIFT_REPEAT(1138),
  [2655] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_redirections_repeat1, 2, 0, 0), SHIFT_REPEAT(1138),
  [2658] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_redirections_repeat1, 2, 0, 0), SHIFT_REPEAT(1125),
  [2661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_redirections_repeat1, 2, 0, 0),
  [2663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_redirections, 1, 0, 0),
  [2665] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_redirections_repeat1, 2, 0, 0), SHIFT_REPEAT(1132),
  [2668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [2670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comparison_operator, 1, 0, 0),
  [2672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comparison_operator, 1, 0, 0),
  [2674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [2676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_clause, 3, 0, 0),
  [2678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [2680] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_script_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1136),
  [2683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_clause, 4, 0, 0),
  [2685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1136),
  [2687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_file_redirection_operator, 1, 0, 0),
  [2689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_file_redirection_operator, 1, 0, 0),
  [2691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_invokation_operator, 1, 0, 0),
  [2693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2107),
  [2695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [2697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [2699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1265),
  [2701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [2703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [2705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [2707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [2709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [2711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [2713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [2715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [2717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [2719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [2721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [2723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [2725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [2727] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_statement_repeat2, 2, 0, 0), SHIFT_REPEAT(2107),
  [2730] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_statement_repeat2, 2, 0, 0), SHIFT_REPEAT(1318),
  [2733] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_statement_repeat2, 2, 0, 0), SHIFT_REPEAT(125),
  [2736] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_statement_repeat2, 2, 0, 0), SHIFT_REPEAT(125),
  [2739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_statement_repeat2, 2, 0, 0),
  [2741] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_statement_repeat2, 2, 0, 0), SHIFT_REPEAT(1265),
  [2744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [2746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [2748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [2750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [2752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [2754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [2756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [2758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1182),
  [2760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1516),
  [2762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(977),
  [2764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(69),
  [2766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1179),
  [2768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [2770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1323),
  [2772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1175),
  [2774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1410),
  [2776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(983),
  [2778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1187),
  [2780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1496),
  [2782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [2784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1171),
  [2786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1426),
  [2788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(991),
  [2790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [2792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [2794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [2796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(969),
  [2798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1224),
  [2800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [2802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1204),
  [2804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1421),
  [2806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(990),
  [2808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1203),
  [2810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [2812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1020),
  [2814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(851),
  [2816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [2818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1423),
  [2820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(974),
  [2822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [2824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [2826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [2828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(760),
  [2830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1173),
  [2832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [2834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(867),
  [2836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1448),
  [2838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1324),
  [2840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [2842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1189),
  [2844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [2846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(842),
  [2848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [2850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(973),
  [2852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1188),
  [2854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [2856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [2858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1186),
  [2860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [2862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [2864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1172),
  [2866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [2868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1023),
  [2870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [2872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [2874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [2876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [2878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [2880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1174),
  [2882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [2884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [2886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [2888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1206),
  [2890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [2892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1226),
  [2894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [2896] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expandable_here_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(1192),
  [2899] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_expandable_here_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(1192),
  [2902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_expandable_here_string_literal_repeat1, 2, 0, 0),
  [2904] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_expandable_here_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(1226),
  [2907] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_expandable_here_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(62),
  [2910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [2912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1192),
  [2914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [2916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [2918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [2920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1196),
  [2922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [2924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [2926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [2928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1193),
  [2930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [2932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [2934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1208),
  [2936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [2938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [2940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1207),
  [2942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [2944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [2946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1205),
  [2948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [2950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [2952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [2954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [2956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [2958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [2960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [2962] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_expandable_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(1203),
  [2965] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expandable_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(1203),
  [2968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_expandable_string_literal_repeat1, 2, 0, 0),
  [2970] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_expandable_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(1224),
  [2973] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_expandable_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(52),
  [2976] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__expandable_string_literal_immediate_repeat1, 2, 0, 0), SHIFT_REPEAT(1235),
  [2979] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__expandable_string_literal_immediate_repeat1, 2, 0, 0), SHIFT_REPEAT(1204),
  [2982] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__expandable_string_literal_immediate_repeat1, 2, 0, 0),
  [2984] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__expandable_string_literal_immediate_repeat1, 2, 0, 0), SHIFT_REPEAT(69),
  [2987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [2989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [2991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [2993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [2995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [2997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [2999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [3001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [3003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [3005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [3007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [3009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_path_command_name_repeat1, 1, 0, 0),
  [3011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [3013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [3015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1741),
  [3017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [3019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1832),
  [3021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_statement_repeat2, 2, 0, 0),
  [3023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [3025] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_expandable_string_literal_repeat1, 1, 0, 0),
  [3027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_expandable_string_literal_repeat1, 1, 0, 0),
  [3029] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_expandable_string_literal_repeat1, 1, 0, 0), REDUCE(aux_sym_expandable_string_literal_repeat2, 1, 0, 0),
  [3032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_statement_repeat2, 3, 0, 0),
  [3034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_statement_repeat2, 3, 0, 0),
  [3036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [3038] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_script_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1230),
  [3041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [3043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [3047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [3049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_property_definition_repeat1, 2, 0, 0),
  [3051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_property_definition_repeat1, 2, 0, 0),
  [3053] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_property_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(1265),
  [3056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_method_definition, 7, 0, 0),
  [3058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_method_definition, 7, 0, 0),
  [3060] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1321),
  [3063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_list_repeat1, 2, 0, 0),
  [3065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attribute_list_repeat1, 2, 0, 0),
  [3067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_method_definition, 10, 0, 0),
  [3069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_method_definition, 10, 0, 0),
  [3071] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_attribute, 1, 0, 0), SHIFT(1832),
  [3074] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_attribute, 1, 0, 0), SHIFT(125),
  [3077] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_attribute, 1, 0, 0), SHIFT(125),
  [3080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 1, 0, 0),
  [3082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [3084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1266),
  [3086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [3088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_method_definition, 8, 0, 0),
  [3090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_method_definition, 8, 0, 0),
  [3092] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_path_command_name_repeat1, 2, 0, 0), SHIFT_REPEAT(1266),
  [3095] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_path_command_name_repeat1, 2, 0, 0), SHIFT_REPEAT(1266),
  [3098] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_path_command_name_repeat1, 2, 0, 0), SHIFT_REPEAT(1248),
  [3101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_method_definition, 9, 0, 0),
  [3103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_method_definition, 9, 0, 0),
  [3105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_list, 1, 0, 0),
  [3107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_list, 1, 0, 0),
  [3109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_method_definition, 5, 0, 0),
  [3111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_method_definition, 5, 0, 0),
  [3113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_method_definition, 6, 0, 0),
  [3115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_method_definition, 6, 0, 0),
  [3117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [3119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [3121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [3123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [3125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [3127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [3129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [3131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [3133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [3135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [3137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [3139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 5, 0, 0),
  [3141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 5, 0, 0),
  [3143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [3145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [3147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [3149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [3151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 6, 0, 0),
  [3153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 6, 0, 0),
  [3155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [3157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [3159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [3163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_attribute, 1, 0, 0),
  [3165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_attribute, 1, 0, 0),
  [3167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [3169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [3171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [3173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1512),
  [3175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1416),
  [3177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [3179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_parameters_repeat1, 2, 0, 0),
  [3181] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(1307),
  [3184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_parameters, 1, 0, 0),
  [3186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(697),
  [3188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [3190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(687),
  [3192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [3194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [3196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_block_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1989),
  [3199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_block_list_repeat1, 2, 0, 0),
  [3201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [3203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_block_list, 1, 0, 0),
  [3205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [3207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [3209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [3211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [3213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(688),
  [3215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [3217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [3219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1298),
  [3221] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_name_repeat1, 2, 0, 0), SHIFT_REPEAT(1298),
  [3224] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_name_repeat1, 2, 0, 0), SHIFT_REPEAT(1298),
  [3227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_name_repeat1, 2, 0, 0), SHIFT_REPEAT(1166),
  [3230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [3232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [3234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [3236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1569),
  [3238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [3240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [3242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_clause_condition, 1, 0, 0),
  [3244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_filename, 1, 0, 0),
  [3246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_parameter, 1, 0, 0),
  [3248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [3250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [3252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [3254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1676),
  [3256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_command, 2, 0, 5),
  [3258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [3260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [3262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_foreach_command_repeat1, 2, 0, 0), SHIFT_REPEAT(39),
  [3265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_foreach_command_repeat1, 2, 0, 0),
  [3267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1325),
  [3269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_verbatim_command_argument, 2, 0, 0),
  [3271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_verbatim_command_argument, 2, 0, 0),
  [3273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [3275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1322),
  [3277] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_foreach_command_repeat1, 2, 0, 0), SHIFT_REPEAT(33),
  [3280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__verbatim_command_argument_chars, 2, 0, 0), SHIFT_REPEAT(1322),
  [3283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__verbatim_command_argument_chars, 2, 0, 0),
  [3285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__verbatim_command_argument_chars, 2, 0, 0), SHIFT_REPEAT(1325),
  [3288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__verbatim_command_argument_chars, 2, 0, 0),
  [3290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [3292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_block, 2, 0, 0),
  [3294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_expression, 1, 0, 0),
  [3296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [3298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_argument_expression, 1, 0, 0),
  [3300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [3302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_foreach_command_repeat1, 2, 0, 0), SHIFT_REPEAT(37),
  [3305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [3307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [3309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [3311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 1, 0, 0),
  [3313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_argument_expression, 3, 0, 0),
  [3315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_elseif_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(2103),
  [3318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 3, 0, 0),
  [3320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [3322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [3324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [3326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_spec, 1, 0, 0),
  [3328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [3330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_catch_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(1329),
  [3333] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_elseif_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(2097),
  [3336] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_catch_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(1355),
  [3339] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_foreach_command_repeat1, 2, 0, 0), SHIFT_REPEAT(32),
  [3342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [3344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [3346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [3348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [3350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [3352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [3354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [3356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_statement_repeat1, 3, 0, 0),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [3360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_parameter, 1, 0, 0),
  [3362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [3364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1319),
  [3366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [3368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [3370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_parameter, 2, 0, 0),
  [3372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_statement_repeat1, 2, 0, 0),
  [3374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [3376] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1546),
  [3379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [3381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [3383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [3385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [3387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1315),
  [3389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [3391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [3393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(242),
  [3395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1608),
  [3397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [3399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [3401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(911),
  [3403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pipeline_tail, 2, 0, 0), SHIFT_REPEAT(1271),
  [3406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pipeline_tail, 2, 0, 0),
  [3408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipeline, 3, 0, 0),
  [3410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command, 3, 0, 10),
  [3412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [3414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1565),
  [3416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [3418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [3420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [3422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [3424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [3426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_arguments_repeat1, 2, 0, 0),
  [3428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_arguments_repeat1, 2, 0, 0), SHIFT_REPEAT(297),
  [3431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipeline, 2, 0, 0),
  [3433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [3435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [3437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [3439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [3441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1687),
  [3443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [3445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [3447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [3449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [3451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [3453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command, 2, 0, 7),
  [3455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_spec, 3, 0, 0),
  [3457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(252),
  [3459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1628),
  [3461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [3463] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dimension_repeat1, 2, 0, 0), SHIFT_REPEAT(1440),
  [3466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dimension_repeat1, 2, 0, 0),
  [3468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [3470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type_arguments, 2, 0, 0),
  [3472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [3474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_argument, 1, 0, 0),
  [3476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [3478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command, 1, 0, 0),
  [3480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [3482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [3484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [3486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [3488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expandable_string_literal_repeat2, 2, 0, 0), SHIFT_REPEAT(1452),
  [3491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_expandable_string_literal_repeat2, 2, 0, 0),
  [3493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_method_parameter_list, 2, 0, 0),
  [3495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [3497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [3499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(239),
  [3501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1637),
  [3503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [3505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [3507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [3509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1571),
  [3511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [3513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_arguments, 1, 0, 0),
  [3515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [3517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [3519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(235),
  [3521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1651),
  [3523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [3525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type_name, 2, 0, 0),
  [3527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_name, 2, 0, 0),
  [3529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [3531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_expression_list_repeat1, 2, 0, 0),
  [3533] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_expression_list_repeat1, 2, 0, 0), SHIFT_REPEAT(390),
  [3536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [3538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_commands_list, 2, 0, 0),
  [3540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [3542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_type_list, 2, 0, 0),
  [3544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [3546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [3548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [3550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [3552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [3554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(228),
  [3556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1598),
  [3558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [3560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(248),
  [3562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1670),
  [3564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [3566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [3568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_type_list, 1, 0, 0),
  [3570] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pipeline_tail, 2, 0, 0), SHIFT_REPEAT(1272),
  [3573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_spec, 2, 0, 0),
  [3575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [3577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimension, 1, 0, 0),
  [3579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(905),
  [3581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [3583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0),
  [3585] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1231),
  [3588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [3590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_arguments, 2, 0, 0),
  [3592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [3594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type_arguments, 1, 0, 0),
  [3596] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_type_arguments_repeat1, 2, 0, 0), SHIFT_REPEAT(1344),
  [3599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_type_arguments_repeat1, 2, 0, 0),
  [3601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_commands_list, 1, 0, 0),
  [3603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [3605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_expression_list, 1, 0, 0),
  [3607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [3609] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_catch_type_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1609),
  [3612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_catch_type_list_repeat1, 2, 0, 0),
  [3614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [3616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [3618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1678),
  [3620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [3622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_commands_list_repeat1, 2, 0, 0), SHIFT_REPEAT(714),
  [3625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_data_commands_list_repeat1, 2, 0, 0),
  [3627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [3629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [3631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [3633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(247),
  [3635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1580),
  [3637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [3639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_method_parameter_list, 1, 0, 0),
  [3641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 1, 0, 0),
  [3643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(776),
  [3645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [3647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1808),
  [3650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_statement_repeat1, 2, 0, 0),
  [3652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(996),
  [3654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [3656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1672),
  [3658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [3660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [3662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_expression_list, 2, 0, 0),
  [3664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [3666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_method_parameter_list_repeat1, 2, 0, 0),
  [3668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_method_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1264),
  [3671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [3673] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__expandable_string_literal_immediate_repeat2, 2, 0, 0), SHIFT_REPEAT(1519),
  [3676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__expandable_string_literal_immediate_repeat2, 2, 0, 0),
  [3678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_name, 1, 0, 0),
  [3680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [3682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [3684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [3686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [3688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [3690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [3692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_property_definition, 1, 0, 0),
  [3694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1574),
  [3696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [3698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member, 1, 0, 0),
  [3700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [3702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_command, 1, 0, 0),
  [3704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [3706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_parameter_default, 2, 0, 0),
  [3708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [3710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [3712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [3714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [3716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_parameter, 3, 0, 0),
  [3718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_name, 1, 0, 0),
  [3720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_name, 1, 0, 0),
  [3722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [3724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [3726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [3728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [3730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [3732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_property_definition, 4, 0, 0),
  [3734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [3736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [3738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [3740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_method_parameter, 2, 0, 0),
  [3742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [3744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_property_definition, 2, 0, 0),
  [3746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [3748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [3750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [3752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_property_definition, 3, 0, 0),
  [3754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [3756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [3758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_argument, 3, 0, 0),
  [3760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_method_parameter, 1, 0, 0),
  [3762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [3764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [3766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [3768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [3770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [3772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [3774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [3776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [3778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [3780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [3782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [3784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [3786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, 0, 9),
  [3788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [3790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [3792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [3794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [3796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [3798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [3800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [3802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [3804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [3806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [3808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [3810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [3812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [3814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [3816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [3818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [3820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [3822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [3824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [3826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [3828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [3830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [3832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [3834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [3836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [3838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [3840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [3842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [3844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [3846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [3848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [3850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [3852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [3854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [3856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [3858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [3860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [3862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [3864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [3866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [3868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [3870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [3872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [3874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [3876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [3878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [3880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [3882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [3884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [3886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [3888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member, 3, 0, 0),
  [3890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [3892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [3894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [3896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [3898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [3900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [3902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [3904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_condition, 1, 0, 0),
  [3906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [3908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [3910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [3912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [3914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [3916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_initializer, 1, 0, 0),
  [3918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [3920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [3922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [3924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [3926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [3928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [3930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [3932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [3934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [3936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [3938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [3940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [3942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [3944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [3946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [3948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [3950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [3952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [3954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [3956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [3958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [3960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [3962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [3964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [3966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [3968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [3970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [3972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [3974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [3976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [3978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [3980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [3982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_condition, 2, 0, 0),
  [3984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [3986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [3988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [3990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [3992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [3994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [3996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [3998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [4000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [4002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [4004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [4006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [4008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [4010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [4012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [4014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [4016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [4018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [4020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [4022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [4024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [4026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_property_definition, 5, 0, 0),
  [4028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_block, 3, 0, 11),
  [4030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_condition, 3, 0, 0),
  [4032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [4034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [4036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [4038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [4040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [4042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [4044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [4046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [4048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [4050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [4052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [4054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [4056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_property_definition, 6, 0, 0),
  [4058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [4060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [4062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [4064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [4066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [4068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [4070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [4072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [4074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [4076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [4078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [4080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [4082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [4084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [4086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [4088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [4090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_condition, 1, 0, 0),
  [4092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [4094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_iterator, 1, 0, 0),
  [4096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [4098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2, 0, 0),
  [4100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [4102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [4104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [4106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [4108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [4110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [4112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [4114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [4116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_key_expression, 1, 0, 0),
  [4118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [4120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [4122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [4124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [4126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [4128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [4130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameter_declaration, 2, 0, 0),
  [4132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [4134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [4136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [4138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [4140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [4142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [4144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_flow_control_statement, 2, 0, 0),
  [4146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [4148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_label_expression, 1, 0, 0),
  [4150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_commands_allowed, 2, 0, 0),
  [4152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [4154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_block, 4, 0, 13),
  [4156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [4158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [4160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_parameter, 1, 0, 0),
  [4162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [4164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [4166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [4168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [4170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [4172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [4174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [4176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [4178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [4180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [4182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [4184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [4186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_block_body, 1, 0, 4),
  [4188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [4190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_block_body, 1, 0, 3),
  [4192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_block, 1, 0, 2),
  [4194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [4196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_name, 1, 0, 0),
  [4198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [4200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [4202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [4204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [4206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [4208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [4210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [4212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [4214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [4216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [4218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [4220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [4222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [4224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [4226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [4228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [4230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [4232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [4234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [4236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [4238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1, 0, 0),
  [4240] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [4242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [4244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [4246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [4248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [4250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [4252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [4254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [4256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [4258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [4260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [4262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [4264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [4266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [4268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [4270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [4272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [4274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [4276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [4278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [4280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [4282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [4284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [4286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [4288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [4290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [4292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [4294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [4296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [4298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [4300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [4302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [4304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [4306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [4308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [4310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [4312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [4314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [4316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [4318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1981),
  [4320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [4322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [4324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [4326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [4328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [4330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [4332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [4334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [4336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [4338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [4340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [4342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [4344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [4346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [4348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [4350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [4352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [4354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [4356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [4358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [4360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [4362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameter_declaration, 3, 0, 0),
  [4364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [4366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [4368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [4370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__statement_terminator = 0,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__statement_terminator] = sym__statement_terminator,
};

static const bool ts_external_scanner_states[2][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__statement_terminator] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_powershell_external_scanner_create(void);
void tree_sitter_powershell_external_scanner_destroy(void *);
bool tree_sitter_powershell_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_powershell_external_scanner_serialize(void *, char *);
void tree_sitter_powershell_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_powershell(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_powershell_external_scanner_create,
      tree_sitter_powershell_external_scanner_destroy,
      tree_sitter_powershell_external_scanner_scan,
      tree_sitter_powershell_external_scanner_serialize,
      tree_sitter_powershell_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
