#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 599
#define LARGE_STATE_COUNT 14
#define SYMBOL_COUNT 162
#define ALIAS_COUNT 0
#define TOKEN_COUNT 87
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 11
#define MAX_ALIAS_SEQUENCE_LENGTH 7
#define PRODUCTION_ID_COUNT 15

enum ts_symbol_identifiers {
  anon_sym_LBRACE = 1,
  anon_sym_RBRACE = 2,
  anon_sym_class = 3,
  anon_sym_LPAREN = 4,
  anon_sym_COMMA = 5,
  anon_sym_RPAREN = 6,
  anon_sym_EQ = 7,
  anon_sym_inherits = 8,
  anon_sym_node = 9,
  anon_sym_define = 10,
  anon_sym_type = 11,
  anon_sym_PLUS_EQ = 12,
  anon_sym_DASH_GT = 13,
  anon_sym_TILDE_GT = 14,
  anon_sym_PIPE = 15,
  anon_sym_function = 16,
  anon_sym_GT_GT = 17,
  anon_sym_AT = 18,
  anon_sym_AT_AT = 19,
  anon_sym_SEMI = 20,
  anon_sym_COLON = 21,
  anon_sym_EQ_GT = 22,
  anon_sym_require = 23,
  anon_sym_include = 24,
  anon_sym_tag = 25,
  anon_sym_if = 26,
  anon_sym_elsif = 27,
  anon_sym_else = 28,
  anon_sym_unless = 29,
  anon_sym_case = 30,
  anon_sym_default = 31,
  anon_sym_LT_LT_PIPE = 32,
  anon_sym_LT_PIPE = 33,
  anon_sym_PIPE_GT_GT = 34,
  anon_sym_PIPE_GT = 35,
  anon_sym_QMARK = 36,
  anon_sym_Boolean = 37,
  anon_sym_Integer = 38,
  anon_sym_Float = 39,
  anon_sym_String = 40,
  anon_sym_Array = 41,
  anon_sym_Hash = 42,
  anon_sym_Regexp = 43,
  anon_sym_Variant = 44,
  anon_sym_Data = 45,
  anon_sym_Undef = 46,
  anon_sym_Default = 47,
  anon_sym_File = 48,
  anon_sym_LBRACK = 49,
  anon_sym_RBRACK = 50,
  anon_sym_EQ_EQ = 51,
  anon_sym_BANG_EQ = 52,
  anon_sym_BANG = 53,
  anon_sym_DASH = 54,
  anon_sym_STAR = 55,
  anon_sym_or = 56,
  anon_sym_and = 57,
  anon_sym_GT = 58,
  anon_sym_GT_EQ = 59,
  anon_sym_LT_EQ = 60,
  anon_sym_LT = 61,
  anon_sym_LT_LT = 62,
  anon_sym_PLUS = 63,
  anon_sym_SLASH = 64,
  anon_sym_PERCENT = 65,
  anon_sym_EQ_TILDE = 66,
  anon_sym_BANG_TILDE = 67,
  anon_sym_in = 68,
  anon_sym_DOT = 69,
  anon_sym_DOLLAR = 70,
  sym_number = 71,
  sym_float = 72,
  anon_sym_DQUOTE = 73,
  anon_sym_SQUOTE = 74,
  sym__double_string_content = 75,
  sym__single_string_content = 76,
  aux_sym__escape_sequence_token1 = 77,
  sym_escape_sequence = 78,
  anon_sym_DOLLAR_LBRACE = 79,
  sym_regex = 80,
  anon_sym_true = 81,
  anon_sym_false = 82,
  sym_undef = 83,
  anon_sym_COLON_COLON = 84,
  sym_identifier = 85,
  sym_comment = 86,
  sym_source_file = 87,
  sym_statement = 88,
  sym_block = 89,
  sym_class_definition = 90,
  sym_parameter_list = 91,
  sym_parameter = 92,
  sym_class_inherits = 93,
  sym_node_definition = 94,
  sym_node_name = 95,
  sym_defined_resource_type = 96,
  sym_type_declaration = 97,
  sym_assignment = 98,
  sym_relation = 99,
  sym_lambda = 100,
  sym_function_declaration = 101,
  sym_resource_declaration = 102,
  sym__resource_block = 103,
  sym_attribute = 104,
  sym_require_statement = 105,
  sym_include_statement = 106,
  sym_tag_statement = 107,
  sym_if_statement = 108,
  sym_elsif_statement = 109,
  sym_else_statement = 110,
  sym_unless_statement = 111,
  sym_case_statement = 112,
  sym_case_item = 113,
  sym_default_case = 114,
  sym_iterator_statement = 115,
  sym_resource_collector = 116,
  sym_resource_default = 117,
  sym_selector = 118,
  sym_type = 119,
  sym_builtin_type = 120,
  sym_composite_type = 121,
  sym_attribute_type = 122,
  sym_attribute_type_entry = 123,
  sym_array_type = 124,
  sym_search_expression = 125,
  sym_expression = 126,
  sym_unary_expression = 127,
  sym_binary_expression = 128,
  sym_parenthesized_expression = 129,
  sym_function_call = 130,
  sym_field_expression = 131,
  sym_variable = 132,
  sym_array = 133,
  sym_hash = 134,
  sym_literal = 135,
  sym_resource_reference = 136,
  sym_string = 137,
  sym__escape_sequence = 138,
  sym_interpolation = 139,
  sym_boolean = 140,
  sym_default = 141,
  sym__identifier = 142,
  sym_class_identifier = 143,
  aux_sym_source_file_repeat1 = 144,
  aux_sym_parameter_list_repeat1 = 145,
  aux_sym_node_definition_repeat1 = 146,
  aux_sym_lambda_repeat1 = 147,
  aux_sym_resource_declaration_repeat1 = 148,
  aux_sym__resource_block_repeat1 = 149,
  aux_sym_include_statement_repeat1 = 150,
  aux_sym_tag_statement_repeat1 = 151,
  aux_sym_if_statement_repeat1 = 152,
  aux_sym_case_statement_repeat1 = 153,
  aux_sym_case_item_repeat1 = 154,
  aux_sym_composite_type_repeat1 = 155,
  aux_sym_attribute_type_repeat1 = 156,
  aux_sym_array_type_repeat1 = 157,
  aux_sym_resource_reference_repeat1 = 158,
  aux_sym_string_repeat1 = 159,
  aux_sym_string_repeat2 = 160,
  aux_sym_class_identifier_repeat1 = 161,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_class] = "class",
  [anon_sym_LPAREN] = "(",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [anon_sym_EQ] = "=",
  [anon_sym_inherits] = "inherits",
  [anon_sym_node] = "node",
  [anon_sym_define] = "define",
  [anon_sym_type] = "type",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_TILDE_GT] = "~>",
  [anon_sym_PIPE] = "|",
  [anon_sym_function] = "function",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_AT] = "@",
  [anon_sym_AT_AT] = "@@",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_require] = "require",
  [anon_sym_include] = "include",
  [anon_sym_tag] = "tag",
  [anon_sym_if] = "if",
  [anon_sym_elsif] = "elsif",
  [anon_sym_else] = "else",
  [anon_sym_unless] = "unless",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_LT_LT_PIPE] = "<<|",
  [anon_sym_LT_PIPE] = "<|",
  [anon_sym_PIPE_GT_GT] = "|>>",
  [anon_sym_PIPE_GT] = "|>",
  [anon_sym_QMARK] = "\?",
  [anon_sym_Boolean] = "Boolean",
  [anon_sym_Integer] = "Integer",
  [anon_sym_Float] = "Float",
  [anon_sym_String] = "String",
  [anon_sym_Array] = "Array",
  [anon_sym_Hash] = "Hash",
  [anon_sym_Regexp] = "Regexp",
  [anon_sym_Variant] = "Variant",
  [anon_sym_Data] = "Data",
  [anon_sym_Undef] = "Undef",
  [anon_sym_Default] = "Default",
  [anon_sym_File] = "File",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG] = "!",
  [anon_sym_DASH] = "-",
  [anon_sym_STAR] = "*",
  [anon_sym_or] = "or",
  [anon_sym_and] = "and",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_LT] = "<",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_PLUS] = "+",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_EQ_TILDE] = "=~",
  [anon_sym_BANG_TILDE] = "!~",
  [anon_sym_in] = "in",
  [anon_sym_DOT] = ".",
  [anon_sym_DOLLAR] = "$",
  [sym_number] = "number",
  [sym_float] = "float",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_SQUOTE] = "'",
  [sym__double_string_content] = "string_content",
  [sym__single_string_content] = "string_content",
  [aux_sym__escape_sequence_token1] = "_escape_sequence_token1",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [sym_regex] = "regex",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [sym_undef] = "undef",
  [anon_sym_COLON_COLON] = "::",
  [sym_identifier] = "identifier",
  [sym_comment] = "comment",
  [sym_source_file] = "source_file",
  [sym_statement] = "statement",
  [sym_block] = "block",
  [sym_class_definition] = "class_definition",
  [sym_parameter_list] = "parameter_list",
  [sym_parameter] = "parameter",
  [sym_class_inherits] = "class_inherits",
  [sym_node_definition] = "node_definition",
  [sym_node_name] = "node_name",
  [sym_defined_resource_type] = "defined_resource_type",
  [sym_type_declaration] = "type_declaration",
  [sym_assignment] = "assignment",
  [sym_relation] = "relation",
  [sym_lambda] = "lambda",
  [sym_function_declaration] = "function_declaration",
  [sym_resource_declaration] = "resource_declaration",
  [sym__resource_block] = "_resource_block",
  [sym_attribute] = "attribute",
  [sym_require_statement] = "require_statement",
  [sym_include_statement] = "include_statement",
  [sym_tag_statement] = "tag_statement",
  [sym_if_statement] = "if_statement",
  [sym_elsif_statement] = "elsif_statement",
  [sym_else_statement] = "else_statement",
  [sym_unless_statement] = "unless_statement",
  [sym_case_statement] = "case_statement",
  [sym_case_item] = "case_item",
  [sym_default_case] = "default_case",
  [sym_iterator_statement] = "iterator_statement",
  [sym_resource_collector] = "resource_collector",
  [sym_resource_default] = "resource_default",
  [sym_selector] = "selector",
  [sym_type] = "type",
  [sym_builtin_type] = "builtin_type",
  [sym_composite_type] = "composite_type",
  [sym_attribute_type] = "attribute_type",
  [sym_attribute_type_entry] = "attribute_type_entry",
  [sym_array_type] = "array_type",
  [sym_search_expression] = "search_expression",
  [sym_expression] = "expression",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_function_call] = "function_call",
  [sym_field_expression] = "field_expression",
  [sym_variable] = "variable",
  [sym_array] = "array",
  [sym_hash] = "hash",
  [sym_literal] = "literal",
  [sym_resource_reference] = "resource_reference",
  [sym_string] = "string",
  [sym__escape_sequence] = "_escape_sequence",
  [sym_interpolation] = "interpolation",
  [sym_boolean] = "boolean",
  [sym_default] = "default",
  [sym__identifier] = "_identifier",
  [sym_class_identifier] = "class_identifier",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym_node_definition_repeat1] = "node_definition_repeat1",
  [aux_sym_lambda_repeat1] = "lambda_repeat1",
  [aux_sym_resource_declaration_repeat1] = "resource_declaration_repeat1",
  [aux_sym__resource_block_repeat1] = "_resource_block_repeat1",
  [aux_sym_include_statement_repeat1] = "include_statement_repeat1",
  [aux_sym_tag_statement_repeat1] = "tag_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_case_item_repeat1] = "case_item_repeat1",
  [aux_sym_composite_type_repeat1] = "composite_type_repeat1",
  [aux_sym_attribute_type_repeat1] = "attribute_type_repeat1",
  [aux_sym_array_type_repeat1] = "array_type_repeat1",
  [aux_sym_resource_reference_repeat1] = "resource_reference_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_class_identifier_repeat1] = "class_identifier_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_inherits] = anon_sym_inherits,
  [anon_sym_node] = anon_sym_node,
  [anon_sym_define] = anon_sym_define,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_TILDE_GT] = anon_sym_TILDE_GT,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_AT_AT] = anon_sym_AT_AT,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_require] = anon_sym_require,
  [anon_sym_include] = anon_sym_include,
  [anon_sym_tag] = anon_sym_tag,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_elsif] = anon_sym_elsif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_unless] = anon_sym_unless,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_LT_LT_PIPE] = anon_sym_LT_LT_PIPE,
  [anon_sym_LT_PIPE] = anon_sym_LT_PIPE,
  [anon_sym_PIPE_GT_GT] = anon_sym_PIPE_GT_GT,
  [anon_sym_PIPE_GT] = anon_sym_PIPE_GT,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_Boolean] = anon_sym_Boolean,
  [anon_sym_Integer] = anon_sym_Integer,
  [anon_sym_Float] = anon_sym_Float,
  [anon_sym_String] = anon_sym_String,
  [anon_sym_Array] = anon_sym_Array,
  [anon_sym_Hash] = anon_sym_Hash,
  [anon_sym_Regexp] = anon_sym_Regexp,
  [anon_sym_Variant] = anon_sym_Variant,
  [anon_sym_Data] = anon_sym_Data,
  [anon_sym_Undef] = anon_sym_Undef,
  [anon_sym_Default] = anon_sym_Default,
  [anon_sym_File] = anon_sym_File,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_EQ_TILDE] = anon_sym_EQ_TILDE,
  [anon_sym_BANG_TILDE] = anon_sym_BANG_TILDE,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [sym_number] = sym_number,
  [sym_float] = sym_float,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [sym__double_string_content] = sym__double_string_content,
  [sym__single_string_content] = sym__double_string_content,
  [aux_sym__escape_sequence_token1] = aux_sym__escape_sequence_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [anon_sym_DOLLAR_LBRACE] = anon_sym_DOLLAR_LBRACE,
  [sym_regex] = sym_regex,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [sym_undef] = sym_undef,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [sym_identifier] = sym_identifier,
  [sym_comment] = sym_comment,
  [sym_source_file] = sym_source_file,
  [sym_statement] = sym_statement,
  [sym_block] = sym_block,
  [sym_class_definition] = sym_class_definition,
  [sym_parameter_list] = sym_parameter_list,
  [sym_parameter] = sym_parameter,
  [sym_class_inherits] = sym_class_inherits,
  [sym_node_definition] = sym_node_definition,
  [sym_node_name] = sym_node_name,
  [sym_defined_resource_type] = sym_defined_resource_type,
  [sym_type_declaration] = sym_type_declaration,
  [sym_assignment] = sym_assignment,
  [sym_relation] = sym_relation,
  [sym_lambda] = sym_lambda,
  [sym_function_declaration] = sym_function_declaration,
  [sym_resource_declaration] = sym_resource_declaration,
  [sym__resource_block] = sym__resource_block,
  [sym_attribute] = sym_attribute,
  [sym_require_statement] = sym_require_statement,
  [sym_include_statement] = sym_include_statement,
  [sym_tag_statement] = sym_tag_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_elsif_statement] = sym_elsif_statement,
  [sym_else_statement] = sym_else_statement,
  [sym_unless_statement] = sym_unless_statement,
  [sym_case_statement] = sym_case_statement,
  [sym_case_item] = sym_case_item,
  [sym_default_case] = sym_default_case,
  [sym_iterator_statement] = sym_iterator_statement,
  [sym_resource_collector] = sym_resource_collector,
  [sym_resource_default] = sym_resource_default,
  [sym_selector] = sym_selector,
  [sym_type] = sym_type,
  [sym_builtin_type] = sym_builtin_type,
  [sym_composite_type] = sym_composite_type,
  [sym_attribute_type] = sym_attribute_type,
  [sym_attribute_type_entry] = sym_attribute_type_entry,
  [sym_array_type] = sym_array_type,
  [sym_search_expression] = sym_search_expression,
  [sym_expression] = sym_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_function_call] = sym_function_call,
  [sym_field_expression] = sym_field_expression,
  [sym_variable] = sym_variable,
  [sym_array] = sym_array,
  [sym_hash] = sym_hash,
  [sym_literal] = sym_literal,
  [sym_resource_reference] = sym_resource_reference,
  [sym_string] = sym_string,
  [sym__escape_sequence] = sym__escape_sequence,
  [sym_interpolation] = sym_interpolation,
  [sym_boolean] = sym_boolean,
  [sym_default] = sym_default,
  [sym__identifier] = sym__identifier,
  [sym_class_identifier] = sym_class_identifier,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_parameter_list_repeat1] = aux_sym_parameter_list_repeat1,
  [aux_sym_node_definition_repeat1] = aux_sym_node_definition_repeat1,
  [aux_sym_lambda_repeat1] = aux_sym_lambda_repeat1,
  [aux_sym_resource_declaration_repeat1] = aux_sym_resource_declaration_repeat1,
  [aux_sym__resource_block_repeat1] = aux_sym__resource_block_repeat1,
  [aux_sym_include_statement_repeat1] = aux_sym_include_statement_repeat1,
  [aux_sym_tag_statement_repeat1] = aux_sym_tag_statement_repeat1,
  [aux_sym_if_statement_repeat1] = aux_sym_if_statement_repeat1,
  [aux_sym_case_statement_repeat1] = aux_sym_case_statement_repeat1,
  [aux_sym_case_item_repeat1] = aux_sym_case_item_repeat1,
  [aux_sym_composite_type_repeat1] = aux_sym_composite_type_repeat1,
  [aux_sym_attribute_type_repeat1] = aux_sym_attribute_type_repeat1,
  [aux_sym_array_type_repeat1] = aux_sym_array_type_repeat1,
  [aux_sym_resource_reference_repeat1] = aux_sym_resource_reference_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym_class_identifier_repeat1] = aux_sym_class_identifier_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inherits] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_node] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_define] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_include] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_tag] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elsif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unless] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Integer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_String] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Array] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Hash] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Regexp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Variant] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Data] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Undef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_File] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym__double_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym__single_string_content] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__escape_sequence_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [sym_undef] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_class_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_class_inherits] = {
    .visible = true,
    .named = true,
  },
  [sym_node_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_node_name] = {
    .visible = true,
    .named = true,
  },
  [sym_defined_resource_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_relation] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_resource_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__resource_block] = {
    .visible = false,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_require_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_include_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_tag_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elsif_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_unless_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_default_case] = {
    .visible = true,
    .named = true,
  },
  [sym_iterator_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_resource_collector] = {
    .visible = true,
    .named = true,
  },
  [sym_resource_default] = {
    .visible = true,
    .named = true,
  },
  [sym_selector] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_builtin_type] = {
    .visible = true,
    .named = true,
  },
  [sym_composite_type] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_type] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_type_entry] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_search_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_call] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_hash] = {
    .visible = true,
    .named = true,
  },
  [sym_literal] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_resource_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym__escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean] = {
    .visible = true,
    .named = true,
  },
  [sym_default] = {
    .visible = true,
    .named = true,
  },
  [sym__identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_class_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_node_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_lambda_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_resource_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__resource_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_include_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tag_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_item_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_composite_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_resource_reference_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_identifier_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_argument = 1,
  field_exported = 2,
  field_iterator = 3,
  field_left = 4,
  field_name = 5,
  field_operator = 6,
  field_right = 7,
  field_title = 8,
  field_type = 9,
  field_value = 10,
  field_virtual = 11,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_argument] = "argument",
  [field_exported] = "exported",
  [field_iterator] = "iterator",
  [field_left] = "left",
  [field_name] = "name",
  [field_operator] = "operator",
  [field_right] = "right",
  [field_title] = "title",
  [field_type] = "type",
  [field_value] = "value",
  [field_virtual] = "virtual",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 2},
  [2] = {.index = 2, .length = 3},
  [3] = {.index = 5, .length = 1},
  [4] = {.index = 6, .length = 2},
  [5] = {.index = 8, .length = 1},
  [6] = {.index = 9, .length = 2},
  [7] = {.index = 11, .length = 1},
  [8] = {.index = 12, .length = 3},
  [9] = {.index = 15, .length = 3},
  [10] = {.index = 18, .length = 1},
  [11] = {.index = 19, .length = 3},
  [12] = {.index = 22, .length = 2},
  [13] = {.index = 24, .length = 4},
  [14] = {.index = 28, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_argument, 1},
    {field_operator, 0},
  [2] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [5] =
    {field_type, 0},
  [6] =
    {field_name, 0},
    {field_value, 2},
  [8] =
    {field_iterator, 0},
  [9] =
    {field_title, 2, .inherited = true},
    {field_type, 0},
  [11] =
    {field_title, 0},
  [12] =
    {field_title, 3, .inherited = true},
    {field_type, 1},
    {field_virtual, 0},
  [15] =
    {field_exported, 0},
    {field_title, 3, .inherited = true},
    {field_type, 1},
  [18] =
    {field_title, 1, .inherited = true},
  [19] =
    {field_title, 2, .inherited = true},
    {field_title, 3, .inherited = true},
    {field_type, 0},
  [22] =
    {field_title, 0, .inherited = true},
    {field_title, 1, .inherited = true},
  [24] =
    {field_title, 3, .inherited = true},
    {field_title, 4, .inherited = true},
    {field_type, 1},
    {field_virtual, 0},
  [28] =
    {field_exported, 0},
    {field_title, 3, .inherited = true},
    {field_title, 4, .inherited = true},
    {field_type, 1},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 3,
  [6] = 4,
  [7] = 3,
  [8] = 4,
  [9] = 4,
  [10] = 3,
  [11] = 4,
  [12] = 12,
  [13] = 3,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 29,
  [32] = 26,
  [33] = 28,
  [34] = 30,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 16,
  [82] = 17,
  [83] = 15,
  [84] = 48,
  [85] = 17,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 18,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 22,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 16,
  [104] = 104,
  [105] = 40,
  [106] = 106,
  [107] = 107,
  [108] = 15,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 18,
  [119] = 21,
  [120] = 120,
  [121] = 22,
  [122] = 122,
  [123] = 20,
  [124] = 72,
  [125] = 19,
  [126] = 126,
  [127] = 127,
  [128] = 128,
  [129] = 129,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 141,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 48,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 40,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 19,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 182,
  [184] = 184,
  [185] = 185,
  [186] = 186,
  [187] = 187,
  [188] = 188,
  [189] = 186,
  [190] = 190,
  [191] = 182,
  [192] = 187,
  [193] = 185,
  [194] = 184,
  [195] = 187,
  [196] = 185,
  [197] = 182,
  [198] = 187,
  [199] = 185,
  [200] = 185,
  [201] = 201,
  [202] = 187,
  [203] = 190,
  [204] = 204,
  [205] = 182,
  [206] = 206,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 211,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 208,
  [216] = 216,
  [217] = 217,
  [218] = 30,
  [219] = 66,
  [220] = 220,
  [221] = 221,
  [222] = 217,
  [223] = 223,
  [224] = 37,
  [225] = 209,
  [226] = 221,
  [227] = 212,
  [228] = 29,
  [229] = 213,
  [230] = 68,
  [231] = 211,
  [232] = 212,
  [233] = 210,
  [234] = 214,
  [235] = 213,
  [236] = 40,
  [237] = 209,
  [238] = 223,
  [239] = 207,
  [240] = 240,
  [241] = 241,
  [242] = 241,
  [243] = 214,
  [244] = 28,
  [245] = 240,
  [246] = 216,
  [247] = 223,
  [248] = 223,
  [249] = 241,
  [250] = 240,
  [251] = 26,
  [252] = 207,
  [253] = 253,
  [254] = 241,
  [255] = 209,
  [256] = 207,
  [257] = 216,
  [258] = 240,
  [259] = 48,
  [260] = 217,
  [261] = 210,
  [262] = 262,
  [263] = 216,
  [264] = 210,
  [265] = 213,
  [266] = 212,
  [267] = 267,
  [268] = 217,
  [269] = 63,
  [270] = 20,
  [271] = 62,
  [272] = 24,
  [273] = 21,
  [274] = 27,
  [275] = 41,
  [276] = 43,
  [277] = 47,
  [278] = 35,
  [279] = 56,
  [280] = 64,
  [281] = 46,
  [282] = 61,
  [283] = 39,
  [284] = 72,
  [285] = 38,
  [286] = 36,
  [287] = 65,
  [288] = 45,
  [289] = 49,
  [290] = 57,
  [291] = 42,
  [292] = 60,
  [293] = 44,
  [294] = 54,
  [295] = 53,
  [296] = 52,
  [297] = 75,
  [298] = 70,
  [299] = 73,
  [300] = 51,
  [301] = 74,
  [302] = 55,
  [303] = 58,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 308,
  [309] = 309,
  [310] = 310,
  [311] = 311,
  [312] = 312,
  [313] = 313,
  [314] = 314,
  [315] = 26,
  [316] = 30,
  [317] = 30,
  [318] = 318,
  [319] = 319,
  [320] = 29,
  [321] = 28,
  [322] = 28,
  [323] = 26,
  [324] = 29,
  [325] = 325,
  [326] = 326,
  [327] = 327,
  [328] = 327,
  [329] = 329,
  [330] = 327,
  [331] = 327,
  [332] = 327,
  [333] = 333,
  [334] = 334,
  [335] = 329,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 339,
  [340] = 338,
  [341] = 341,
  [342] = 342,
  [343] = 343,
  [344] = 344,
  [345] = 345,
  [346] = 345,
  [347] = 52,
  [348] = 348,
  [349] = 55,
  [350] = 54,
  [351] = 53,
  [352] = 52,
  [353] = 75,
  [354] = 348,
  [355] = 70,
  [356] = 73,
  [357] = 51,
  [358] = 74,
  [359] = 359,
  [360] = 59,
  [361] = 361,
  [362] = 74,
  [363] = 51,
  [364] = 73,
  [365] = 70,
  [366] = 75,
  [367] = 53,
  [368] = 54,
  [369] = 55,
  [370] = 370,
  [371] = 348,
  [372] = 372,
  [373] = 58,
  [374] = 58,
  [375] = 375,
  [376] = 48,
  [377] = 377,
  [378] = 40,
  [379] = 379,
  [380] = 22,
  [381] = 381,
  [382] = 382,
  [383] = 383,
  [384] = 384,
  [385] = 385,
  [386] = 386,
  [387] = 387,
  [388] = 388,
  [389] = 389,
  [390] = 389,
  [391] = 388,
  [392] = 392,
  [393] = 393,
  [394] = 388,
  [395] = 395,
  [396] = 396,
  [397] = 386,
  [398] = 385,
  [399] = 399,
  [400] = 400,
  [401] = 389,
  [402] = 393,
  [403] = 403,
  [404] = 404,
  [405] = 405,
  [406] = 406,
  [407] = 407,
  [408] = 17,
  [409] = 16,
  [410] = 15,
  [411] = 411,
  [412] = 412,
  [413] = 18,
  [414] = 122,
  [415] = 22,
  [416] = 416,
  [417] = 417,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 421,
  [422] = 422,
  [423] = 423,
  [424] = 19,
  [425] = 417,
  [426] = 421,
  [427] = 77,
  [428] = 428,
  [429] = 429,
  [430] = 417,
  [431] = 418,
  [432] = 421,
  [433] = 76,
  [434] = 434,
  [435] = 435,
  [436] = 15,
  [437] = 17,
  [438] = 16,
  [439] = 435,
  [440] = 78,
  [441] = 441,
  [442] = 442,
  [443] = 435,
  [444] = 435,
  [445] = 445,
  [446] = 446,
  [447] = 447,
  [448] = 448,
  [449] = 449,
  [450] = 450,
  [451] = 451,
  [452] = 452,
  [453] = 18,
  [454] = 454,
  [455] = 455,
  [456] = 456,
  [457] = 457,
  [458] = 458,
  [459] = 459,
  [460] = 458,
  [461] = 461,
  [462] = 462,
  [463] = 463,
  [464] = 464,
  [465] = 461,
  [466] = 22,
  [467] = 467,
  [468] = 468,
  [469] = 469,
  [470] = 470,
  [471] = 471,
  [472] = 472,
  [473] = 473,
  [474] = 474,
  [475] = 475,
  [476] = 476,
  [477] = 477,
  [478] = 478,
  [479] = 479,
  [480] = 480,
  [481] = 481,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 485,
  [486] = 486,
  [487] = 487,
  [488] = 488,
  [489] = 489,
  [490] = 490,
  [491] = 491,
  [492] = 492,
  [493] = 493,
  [494] = 494,
  [495] = 495,
  [496] = 496,
  [497] = 491,
  [498] = 472,
  [499] = 499,
  [500] = 500,
  [501] = 501,
  [502] = 62,
  [503] = 503,
  [504] = 504,
  [505] = 469,
  [506] = 494,
  [507] = 507,
  [508] = 508,
  [509] = 509,
  [510] = 510,
  [511] = 511,
  [512] = 512,
  [513] = 513,
  [514] = 480,
  [515] = 500,
  [516] = 516,
  [517] = 87,
  [518] = 518,
  [519] = 503,
  [520] = 520,
  [521] = 521,
  [522] = 516,
  [523] = 489,
  [524] = 469,
  [525] = 525,
  [526] = 526,
  [527] = 527,
  [528] = 528,
  [529] = 529,
  [530] = 530,
  [531] = 469,
  [532] = 532,
  [533] = 533,
  [534] = 469,
  [535] = 535,
  [536] = 536,
  [537] = 537,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 541,
  [542] = 542,
  [543] = 543,
  [544] = 544,
  [545] = 545,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 549,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 553,
  [554] = 554,
  [555] = 555,
  [556] = 556,
  [557] = 557,
  [558] = 538,
  [559] = 559,
  [560] = 560,
  [561] = 561,
  [562] = 562,
  [563] = 547,
  [564] = 542,
  [565] = 565,
  [566] = 566,
  [567] = 567,
  [568] = 568,
  [569] = 569,
  [570] = 570,
  [571] = 571,
  [572] = 572,
  [573] = 573,
  [574] = 574,
  [575] = 568,
  [576] = 573,
  [577] = 573,
  [578] = 578,
  [579] = 579,
  [580] = 580,
  [581] = 574,
  [582] = 582,
  [583] = 583,
  [584] = 584,
  [585] = 574,
  [586] = 573,
  [587] = 587,
  [588] = 568,
  [589] = 589,
  [590] = 568,
  [591] = 591,
  [592] = 592,
  [593] = 568,
  [594] = 573,
  [595] = 595,
  [596] = 596,
  [597] = 574,
  [598] = 574,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(62);
      ADVANCE_MAP(
        '!', 124,
        '"', 159,
        '#', 311,
        '$', 151,
        '%', 144,
        '\'', 160,
        '(', 66,
        ')', 68,
        '*', 128,
        '+', 141,
        ',', 67,
        '-', 126,
        '.', 149,
        '/', 143,
        '0', 153,
        ':', 88,
        ';', 86,
        '<', 136,
        '=', 71,
        '>', 133,
        '?', 105,
        '@', 84,
        'A', 283,
        'B', 270,
        'D', 188,
        'F', 246,
        'H', 185,
        'I', 265,
        'R', 209,
        'S', 298,
        'U', 259,
        'V', 194,
        '[', 118,
        '\\', 28,
        ']', 119,
        'a', 264,
        'c', 189,
        'd', 222,
        'e', 252,
        'f', 197,
        'i', 231,
        'n', 273,
        'o', 278,
        'r', 210,
        't', 190,
        'u', 260,
        '{', 63,
        '|', 81,
        '}', 64,
        '~', 27,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(56);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (('C' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        '!', 122,
        '"', 159,
        '#', 311,
        '$', 150,
        '\'', 160,
        '(', 66,
        ')', 68,
        '*', 128,
        '-', 127,
        '/', 17,
        '0', 153,
        '[', 118,
        ']', 119,
        'f', 198,
        't', 279,
        'u', 269,
        '{', 63,
        '}', 64,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(1);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 2:
      ADVANCE_MAP(
        '!', 122,
        '"', 159,
        '#', 311,
        '$', 150,
        '\'', 160,
        '(', 66,
        '*', 128,
        '-', 127,
        '/', 17,
        '0', 153,
        '=', 24,
        '[', 118,
        'd', 230,
        'f', 198,
        't', 279,
        'u', 269,
        '{', 63,
        '}', 64,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(2);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 3:
      ADVANCE_MAP(
        '!', 122,
        '"', 159,
        '#', 311,
        '$', 150,
        '\'', 160,
        '(', 66,
        '*', 128,
        '-', 127,
        '/', 17,
        '0', 153,
        '[', 118,
        'f', 198,
        'i', 233,
        't', 279,
        'u', 269,
        '{', 63,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 4:
      ADVANCE_MAP(
        '!', 22,
        '#', 311,
        '%', 144,
        '(', 66,
        ')', 68,
        '*', 128,
        '+', 141,
        ',', 67,
        '-', 125,
        '.', 149,
        '/', 142,
        ':', 88,
        ';', 86,
        '<', 137,
        '=', 71,
        '>', 133,
        '?', 105,
        '[', 118,
        ']', 119,
        'a', 36,
        'e', 35,
        'i', 37,
        'o', 39,
        '{', 63,
        '|', 80,
        '}', 64,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(4);
      END_STATE();
    case 5:
      ADVANCE_MAP(
        '!', 22,
        '#', 311,
        '%', 144,
        '(', 66,
        ')', 68,
        '*', 128,
        '+', 141,
        ',', 67,
        '-', 125,
        '.', 149,
        '/', 142,
        ':', 87,
        ';', 86,
        '<', 137,
        '=', 72,
        '>', 133,
        '?', 105,
        '[', 118,
        ']', 119,
        'a', 36,
        'i', 37,
        'o', 39,
        '{', 63,
        '|', 81,
        '}', 64,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(5);
      END_STATE();
    case 6:
      ADVANCE_MAP(
        '!', 22,
        '#', 311,
        '%', 144,
        '(', 66,
        ')', 68,
        '*', 128,
        '+', 140,
        ',', 67,
        '-', 125,
        '.', 149,
        '/', 142,
        ':', 88,
        ';', 86,
        '<', 137,
        '=', 23,
        '>', 133,
        '?', 105,
        '[', 118,
        ']', 119,
        'a', 36,
        'i', 37,
        'o', 39,
        '{', 63,
        '|', 80,
        '}', 64,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(6);
      END_STATE();
    case 7:
      ADVANCE_MAP(
        '"', 159,
        '#', 311,
        '$', 150,
        '\'', 160,
        '(', 66,
        '/', 17,
        '0', 154,
        ':', 21,
        ';', 86,
        '|', 26,
        '}', 64,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(7);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(155);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 8:
      ADVANCE_MAP(
        '"', 159,
        '#', 311,
        '$', 150,
        '\'', 160,
        ')', 68,
        '/', 16,
        '0', 154,
        'A', 283,
        'B', 270,
        'D', 188,
        'F', 246,
        'H', 185,
        'I', 265,
        'R', 209,
        'S', 298,
        'U', 259,
        'V', 194,
        '[', 118,
        ']', 119,
        '{', 63,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(8);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(155);
      if (('C' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 9:
      if (lookahead == '"') ADVANCE(159);
      if (lookahead == '#') ADVANCE(311);
      if (lookahead == '\'') ADVANCE(160);
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == 'd') ADVANCE(230);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(9);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 10:
      if (lookahead == '"') ADVANCE(159);
      if (lookahead == '#') ADVANCE(166);
      if (lookahead == '$') ADVANCE(151);
      if (lookahead == '/') ADVANCE(164);
      if (lookahead == ':') ADVANCE(165);
      if (lookahead == '\\') ADVANCE(28);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(161);
      if (lookahead != 0) ADVANCE(167);
      END_STATE();
    case 11:
      ADVANCE_MAP(
        '#', 311,
        '$', 150,
        '/', 16,
        '0', 154,
        'A', 283,
        'B', 270,
        'D', 188,
        'F', 246,
        'H', 185,
        'I', 265,
        'R', 209,
        'S', 298,
        'U', 259,
        'V', 194,
        '[', 118,
        ']', 119,
        'd', 230,
        '{', 63,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(11);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(155);
      if (('C' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 12:
      ADVANCE_MAP(
        '#', 311,
        '(', 66,
        '/', 16,
        ':', 21,
        '>', 25,
        'e', 35,
        'i', 38,
        '{', 63,
        '}', 64,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(12);
      END_STATE();
    case 13:
      if (lookahead == '#') ADVANCE(172);
      if (lookahead == '\'') ADVANCE(160);
      if (lookahead == '/') ADVANCE(171);
      if (lookahead == '\\') ADVANCE(28);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(168);
      if (lookahead != 0) ADVANCE(173);
      END_STATE();
    case 14:
      if (lookahead == '*') ADVANCE(14);
      if (lookahead == '/') ADVANCE(310);
      if (lookahead != 0) ADVANCE(15);
      END_STATE();
    case 15:
      if (lookahead == '*') ADVANCE(14);
      if (lookahead != 0) ADVANCE(15);
      END_STATE();
    case 16:
      if (lookahead == '*') ADVANCE(15);
      END_STATE();
    case 17:
      if (lookahead == '*') ADVANCE(15);
      if (lookahead != 0) ADVANCE(20);
      END_STATE();
    case 18:
      if (lookahead == '-') ADVANCE(46);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(158);
      END_STATE();
    case 19:
      if (lookahead == '.') ADVANCE(157);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(19);
      END_STATE();
    case 20:
      if (lookahead == '/') ADVANCE(180);
      if (lookahead != 0) ADVANCE(20);
      END_STATE();
    case 21:
      if (lookahead == ':') ADVANCE(184);
      END_STATE();
    case 22:
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '~') ADVANCE(146);
      END_STATE();
    case 23:
      if (lookahead == '=') ADVANCE(120);
      if (lookahead == '>') ADVANCE(89);
      if (lookahead == '~') ADVANCE(145);
      END_STATE();
    case 24:
      if (lookahead == '>') ADVANCE(89);
      END_STATE();
    case 25:
      if (lookahead == '>') ADVANCE(83);
      END_STATE();
    case 26:
      if (lookahead == '>') ADVANCE(104);
      END_STATE();
    case 27:
      if (lookahead == '>') ADVANCE(79);
      END_STATE();
    case 28:
      if (lookahead == 'U') ADVANCE(176);
      if (lookahead == 'u') ADVANCE(44);
      if (lookahead == 'x') ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(175);
      if (lookahead == '"' ||
          lookahead == '\'' ||
          lookahead == '?' ||
          lookahead == '\\' ||
          lookahead == 'a' ||
          lookahead == 'b' ||
          lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          ('t' <= lookahead && lookahead <= 'v')) ADVANCE(177);
      if (lookahead != 0) ADVANCE(174);
      END_STATE();
    case 29:
      if (lookahead == 'd') ADVANCE(131);
      END_STATE();
    case 30:
      if (lookahead == 'e') ADVANCE(96);
      if (lookahead == 'i') ADVANCE(32);
      END_STATE();
    case 31:
      if (lookahead == 'e') ADVANCE(40);
      END_STATE();
    case 32:
      if (lookahead == 'f') ADVANCE(94);
      END_STATE();
    case 33:
      if (lookahead == 'h') ADVANCE(31);
      END_STATE();
    case 34:
      if (lookahead == 'i') ADVANCE(43);
      END_STATE();
    case 35:
      if (lookahead == 'l') ADVANCE(41);
      END_STATE();
    case 36:
      if (lookahead == 'n') ADVANCE(29);
      END_STATE();
    case 37:
      if (lookahead == 'n') ADVANCE(147);
      END_STATE();
    case 38:
      if (lookahead == 'n') ADVANCE(33);
      END_STATE();
    case 39:
      if (lookahead == 'r') ADVANCE(129);
      END_STATE();
    case 40:
      if (lookahead == 'r') ADVANCE(34);
      END_STATE();
    case 41:
      if (lookahead == 's') ADVANCE(30);
      END_STATE();
    case 42:
      if (lookahead == 's') ADVANCE(73);
      END_STATE();
    case 43:
      if (lookahead == 't') ADVANCE(42);
      END_STATE();
    case 44:
      if (lookahead == '{') ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(50);
      END_STATE();
    case 45:
      if (lookahead == '}') ADVANCE(177);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(45);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(158);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(177);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(156);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(45);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(47);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(50);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(54);
      END_STATE();
    case 56:
      if (eof) ADVANCE(62);
      ADVANCE_MAP(
        '!', 124,
        '"', 159,
        '#', 311,
        '$', 151,
        '%', 144,
        '\'', 160,
        '(', 66,
        ')', 68,
        '*', 128,
        '+', 141,
        ',', 67,
        '-', 126,
        '.', 149,
        '/', 143,
        '0', 153,
        ':', 88,
        ';', 86,
        '<', 136,
        '=', 71,
        '>', 133,
        '?', 105,
        '@', 84,
        'A', 283,
        'B', 270,
        'D', 188,
        'F', 246,
        'H', 185,
        'I', 265,
        'R', 209,
        'S', 298,
        'U', 259,
        'V', 194,
        '[', 118,
        ']', 119,
        'a', 264,
        'c', 189,
        'd', 222,
        'e', 252,
        'f', 197,
        'i', 231,
        'n', 273,
        'o', 278,
        'r', 210,
        't', 190,
        'u', 260,
        '{', 63,
        '|', 81,
        '}', 64,
        '~', 27,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(56);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (('C' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 57:
      if (eof) ADVANCE(62);
      ADVANCE_MAP(
        '!', 124,
        '"', 159,
        '#', 311,
        '$', 150,
        '%', 144,
        '\'', 160,
        '(', 66,
        ')', 68,
        '*', 128,
        '+', 141,
        ',', 67,
        '-', 126,
        '.', 149,
        '/', 143,
        '0', 153,
        ':', 21,
        '<', 136,
        '=', 71,
        '>', 133,
        '?', 105,
        '@', 84,
        '[', 118,
        ']', 119,
        'a', 264,
        'c', 189,
        'd', 225,
        'f', 197,
        'i', 231,
        'n', 273,
        'o', 278,
        'r', 210,
        't', 190,
        'u', 260,
        '{', 63,
        '|', 80,
        '}', 64,
        '~', 27,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(57);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 58:
      if (eof) ADVANCE(62);
      ADVANCE_MAP(
        '!', 124,
        '"', 159,
        '#', 311,
        '$', 150,
        '%', 144,
        '\'', 160,
        '(', 66,
        '*', 128,
        '+', 141,
        '-', 126,
        '.', 149,
        '/', 143,
        '0', 153,
        ':', 21,
        '<', 137,
        '=', 72,
        '>', 133,
        '?', 105,
        '@', 84,
        '[', 118,
        'a', 264,
        'c', 189,
        'd', 225,
        'f', 197,
        'i', 231,
        'n', 273,
        'o', 278,
        'r', 210,
        't', 190,
        'u', 260,
        '{', 63,
        '|', 80,
        '}', 64,
        '~', 27,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(58);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 59:
      if (eof) ADVANCE(62);
      ADVANCE_MAP(
        '!', 124,
        '"', 159,
        '#', 311,
        '$', 150,
        '%', 144,
        '\'', 160,
        '(', 66,
        '*', 128,
        '+', 140,
        ',', 67,
        '-', 126,
        '.', 149,
        '/', 143,
        '0', 153,
        '<', 137,
        '=', 23,
        '>', 133,
        '?', 105,
        '@', 84,
        '[', 118,
        ']', 119,
        'a', 264,
        'c', 189,
        'd', 225,
        'f', 197,
        'i', 231,
        'n', 273,
        'o', 278,
        'r', 210,
        't', 190,
        'u', 260,
        '{', 63,
        '|', 81,
        '}', 64,
        '~', 27,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(59);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 60:
      if (eof) ADVANCE(62);
      ADVANCE_MAP(
        '!', 123,
        '"', 159,
        '#', 311,
        '$', 150,
        '\'', 160,
        '(', 66,
        ')', 68,
        '*', 128,
        ',', 67,
        '-', 126,
        '/', 17,
        '0', 153,
        ':', 88,
        ';', 86,
        '=', 70,
        '>', 25,
        '?', 105,
        '@', 84,
        '[', 118,
        ']', 119,
        'c', 189,
        'd', 225,
        'f', 197,
        'i', 232,
        'n', 273,
        'r', 210,
        't', 190,
        'u', 260,
        '{', 63,
        '|', 80,
        '}', 64,
        '~', 27,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(60);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 61:
      if (eof) ADVANCE(62);
      ADVANCE_MAP(
        '!', 122,
        '"', 159,
        '#', 311,
        '$', 150,
        '\'', 160,
        '(', 66,
        ')', 68,
        '*', 128,
        ',', 67,
        '-', 126,
        '/', 17,
        '0', 153,
        '=', 69,
        '@', 84,
        '[', 118,
        'c', 189,
        'd', 225,
        'e', 252,
        'f', 197,
        'i', 232,
        'n', 273,
        'r', 210,
        't', 190,
        'u', 260,
        '{', 63,
        '|', 26,
        '}', 64,
        '~', 27,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(61);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(152);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_class);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(120);
      if (lookahead == '>') ADVANCE(89);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(120);
      if (lookahead == '>') ADVANCE(89);
      if (lookahead == '~') ADVANCE(145);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(120);
      if (lookahead == '~') ADVANCE(145);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_inherits);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_node);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_define);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_type);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_TILDE_GT);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '>') ADVANCE(104);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_function);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '@') ADVANCE(85);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_AT_AT);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(184);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_require);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_include);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_tag);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_if);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_elsif);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_elsif);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_else);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_unless);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_case);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_default);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_LT_LT_PIPE);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_LT_PIPE);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_PIPE_GT_GT);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_PIPE_GT);
      if (lookahead == '>') ADVANCE(103);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_Boolean);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_Integer);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_Float);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_String);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_Array);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_Hash);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_Regexp);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_Variant);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_Data);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_Undef);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_Default);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_File);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(121);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '~') ADVANCE(146);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(78);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(19);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(19);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_or);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_and);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(134);
      if (lookahead == '>') ADVANCE(83);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(139);
      if (lookahead == '=') ADVANCE(135);
      if (lookahead == '|') ADVANCE(102);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(138);
      if (lookahead == '=') ADVANCE(135);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '|') ADVANCE(101);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(77);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead != 0 &&
          lookahead != '*') ADVANCE(20);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_BANG_TILDE);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'c') ADVANCE(254);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '{') ADVANCE(179);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(157);
      if (lookahead == '_') ADVANCE(155);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(152);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(157);
      if (lookahead == 'x') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(19);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'x') ADVANCE(48);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(155);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(156);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'e') ADVANCE(18);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(157);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_float);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(158);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym__double_string_content);
      if (lookahead == '#') ADVANCE(166);
      if (lookahead == '/') ADVANCE(164);
      if (lookahead == ':') ADVANCE(165);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(161);
      if (lookahead != 0 &&
          (lookahead < '"' || '$' < lookahead) &&
          lookahead != '\\') ADVANCE(167);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(sym__double_string_content);
      if (lookahead == '*') ADVANCE(162);
      if (lookahead == '/') ADVANCE(167);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\') ADVANCE(163);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym__double_string_content);
      if (lookahead == '*') ADVANCE(162);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\') ADVANCE(163);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym__double_string_content);
      if (lookahead == '*') ADVANCE(163);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\') ADVANCE(167);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym__double_string_content);
      if (lookahead == ':') ADVANCE(167);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\') ADVANCE(167);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym__double_string_content);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(167);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\') ADVANCE(166);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym__double_string_content);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\') ADVANCE(167);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym__single_string_content);
      if (lookahead == '#') ADVANCE(172);
      if (lookahead == '/') ADVANCE(171);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(168);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(173);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym__single_string_content);
      if (lookahead == '*') ADVANCE(169);
      if (lookahead == '/') ADVANCE(173);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(170);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym__single_string_content);
      if (lookahead == '*') ADVANCE(169);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(170);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym__single_string_content);
      if (lookahead == '*') ADVANCE(170);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(173);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym__single_string_content);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(173);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(172);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym__single_string_content);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(173);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(aux_sym__escape_sequence_token1);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(aux_sym__escape_sequence_token1);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(178);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(aux_sym__escape_sequence_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(55);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(177);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_regex);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_true);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_false);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_undef);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(286);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(308);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(114);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(238);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(291);
      if (lookahead == 'l') ADVANCE(193);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(241);
      if (lookahead == 'r') ADVANCE(304);
      if (lookahead == 'y') ADVANCE(276);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(303);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(294);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(290);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(282);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(262);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(267);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(258);
      if (lookahead == 'u') ADVANCE(261);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(258);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(305);
      if (lookahead == 'i') ADVANCE(268);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(305);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(254);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(300);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd') ADVANCE(132);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd') ADVANCE(215);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd') ADVANCE(220);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd') ADVANCE(223);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd') ADVANCE(224);
      if (lookahead == 'l') ADVANCE(229);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd') ADVANCE(224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(243);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(277);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(117);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(307);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(99);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(97);
      if (lookahead == 'i') ADVANCE(236);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(74);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(181);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(76);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(182);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(91);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(90);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(234);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(235);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(237);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(239);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(281);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(195);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(244);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(292);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(240);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(93);
      if (lookahead == 'n') ADVANCE(148);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(93);
      if (lookahead == 'n') ADVANCE(201);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(93);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(199);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(115);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(95);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(183);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(191);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(251);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(200);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'g') ADVANCE(92);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'g') ADVANCE(109);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'g') ADVANCE(212);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'g') ADVANCE(226);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h') ADVANCE(111);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(253);
      if (lookahead == 'l') ADVANCE(271);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(272);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(285);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(266);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(196);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(268);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(287);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(211);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(306);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(295);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(297);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(227);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(293);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(206);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(207);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(202);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(106);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(82);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(203);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(301);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(242);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(296);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(219);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(208);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(274);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(192);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(263);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(204);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(257);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p') ADVANCE(112);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p') ADVANCE(217);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'q') ADVANCE(302);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(130);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(304);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(249);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(107);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(250);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(284);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(186);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(221);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(245);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(214);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(65);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(288);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(213);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(289);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(218);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(108);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(116);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(113);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(100);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(280);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(187);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(247);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(228);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u') ADVANCE(248);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u') ADVANCE(255);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u') ADVANCE(216);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u') ADVANCE(256);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u') ADVANCE(205);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'x') ADVANCE(275);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'y') ADVANCE(110);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(309);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(311);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 60},
  [2] = {.lex_state = 60},
  [3] = {.lex_state = 60},
  [4] = {.lex_state = 60},
  [5] = {.lex_state = 60},
  [6] = {.lex_state = 60},
  [7] = {.lex_state = 60},
  [8] = {.lex_state = 60},
  [9] = {.lex_state = 60},
  [10] = {.lex_state = 60},
  [11] = {.lex_state = 60},
  [12] = {.lex_state = 60},
  [13] = {.lex_state = 60},
  [14] = {.lex_state = 60},
  [15] = {.lex_state = 57},
  [16] = {.lex_state = 57},
  [17] = {.lex_state = 57},
  [18] = {.lex_state = 57},
  [19] = {.lex_state = 57},
  [20] = {.lex_state = 59},
  [21] = {.lex_state = 59},
  [22] = {.lex_state = 58},
  [23] = {.lex_state = 58},
  [24] = {.lex_state = 59},
  [25] = {.lex_state = 57},
  [26] = {.lex_state = 57},
  [27] = {.lex_state = 59},
  [28] = {.lex_state = 57},
  [29] = {.lex_state = 57},
  [30] = {.lex_state = 57},
  [31] = {.lex_state = 57},
  [32] = {.lex_state = 57},
  [33] = {.lex_state = 57},
  [34] = {.lex_state = 57},
  [35] = {.lex_state = 57},
  [36] = {.lex_state = 57},
  [37] = {.lex_state = 57},
  [38] = {.lex_state = 57},
  [39] = {.lex_state = 57},
  [40] = {.lex_state = 57},
  [41] = {.lex_state = 57},
  [42] = {.lex_state = 57},
  [43] = {.lex_state = 57},
  [44] = {.lex_state = 57},
  [45] = {.lex_state = 57},
  [46] = {.lex_state = 57},
  [47] = {.lex_state = 57},
  [48] = {.lex_state = 57},
  [49] = {.lex_state = 57},
  [50] = {.lex_state = 57},
  [51] = {.lex_state = 57},
  [52] = {.lex_state = 57},
  [53] = {.lex_state = 57},
  [54] = {.lex_state = 57},
  [55] = {.lex_state = 57},
  [56] = {.lex_state = 57},
  [57] = {.lex_state = 57},
  [58] = {.lex_state = 57},
  [59] = {.lex_state = 57},
  [60] = {.lex_state = 57},
  [61] = {.lex_state = 57},
  [62] = {.lex_state = 57},
  [63] = {.lex_state = 57},
  [64] = {.lex_state = 57},
  [65] = {.lex_state = 57},
  [66] = {.lex_state = 57},
  [67] = {.lex_state = 57},
  [68] = {.lex_state = 57},
  [69] = {.lex_state = 57},
  [70] = {.lex_state = 57},
  [71] = {.lex_state = 57},
  [72] = {.lex_state = 57},
  [73] = {.lex_state = 57},
  [74] = {.lex_state = 57},
  [75] = {.lex_state = 57},
  [76] = {.lex_state = 61},
  [77] = {.lex_state = 61},
  [78] = {.lex_state = 61},
  [79] = {.lex_state = 2},
  [80] = {.lex_state = 2},
  [81] = {.lex_state = 60},
  [82] = {.lex_state = 60},
  [83] = {.lex_state = 60},
  [84] = {.lex_state = 61},
  [85] = {.lex_state = 4},
  [86] = {.lex_state = 60},
  [87] = {.lex_state = 61},
  [88] = {.lex_state = 60},
  [89] = {.lex_state = 60},
  [90] = {.lex_state = 60},
  [91] = {.lex_state = 60},
  [92] = {.lex_state = 60},
  [93] = {.lex_state = 60},
  [94] = {.lex_state = 60},
  [95] = {.lex_state = 60},
  [96] = {.lex_state = 60},
  [97] = {.lex_state = 60},
  [98] = {.lex_state = 2},
  [99] = {.lex_state = 60},
  [100] = {.lex_state = 60},
  [101] = {.lex_state = 60},
  [102] = {.lex_state = 60},
  [103] = {.lex_state = 4},
  [104] = {.lex_state = 60},
  [105] = {.lex_state = 61},
  [106] = {.lex_state = 60},
  [107] = {.lex_state = 60},
  [108] = {.lex_state = 4},
  [109] = {.lex_state = 60},
  [110] = {.lex_state = 60},
  [111] = {.lex_state = 60},
  [112] = {.lex_state = 60},
  [113] = {.lex_state = 60},
  [114] = {.lex_state = 60},
  [115] = {.lex_state = 60},
  [116] = {.lex_state = 60},
  [117] = {.lex_state = 60},
  [118] = {.lex_state = 4},
  [119] = {.lex_state = 60},
  [120] = {.lex_state = 60},
  [121] = {.lex_state = 4},
  [122] = {.lex_state = 60},
  [123] = {.lex_state = 60},
  [124] = {.lex_state = 60},
  [125] = {.lex_state = 60},
  [126] = {.lex_state = 1},
  [127] = {.lex_state = 60},
  [128] = {.lex_state = 60},
  [129] = {.lex_state = 60},
  [130] = {.lex_state = 60},
  [131] = {.lex_state = 1},
  [132] = {.lex_state = 60},
  [133] = {.lex_state = 60},
  [134] = {.lex_state = 60},
  [135] = {.lex_state = 1},
  [136] = {.lex_state = 60},
  [137] = {.lex_state = 60},
  [138] = {.lex_state = 60},
  [139] = {.lex_state = 1},
  [140] = {.lex_state = 60},
  [141] = {.lex_state = 60},
  [142] = {.lex_state = 60},
  [143] = {.lex_state = 60},
  [144] = {.lex_state = 60},
  [145] = {.lex_state = 1},
  [146] = {.lex_state = 60},
  [147] = {.lex_state = 60},
  [148] = {.lex_state = 60},
  [149] = {.lex_state = 60},
  [150] = {.lex_state = 60},
  [151] = {.lex_state = 60},
  [152] = {.lex_state = 60},
  [153] = {.lex_state = 1},
  [154] = {.lex_state = 60},
  [155] = {.lex_state = 1},
  [156] = {.lex_state = 60},
  [157] = {.lex_state = 60},
  [158] = {.lex_state = 60},
  [159] = {.lex_state = 60},
  [160] = {.lex_state = 60},
  [161] = {.lex_state = 60},
  [162] = {.lex_state = 60},
  [163] = {.lex_state = 1},
  [164] = {.lex_state = 60},
  [165] = {.lex_state = 60},
  [166] = {.lex_state = 60},
  [167] = {.lex_state = 60},
  [168] = {.lex_state = 60},
  [169] = {.lex_state = 60},
  [170] = {.lex_state = 60},
  [171] = {.lex_state = 60},
  [172] = {.lex_state = 60},
  [173] = {.lex_state = 4},
  [174] = {.lex_state = 60},
  [175] = {.lex_state = 60},
  [176] = {.lex_state = 60},
  [177] = {.lex_state = 60},
  [178] = {.lex_state = 60},
  [179] = {.lex_state = 60},
  [180] = {.lex_state = 60},
  [181] = {.lex_state = 3},
  [182] = {.lex_state = 1},
  [183] = {.lex_state = 1},
  [184] = {.lex_state = 1},
  [185] = {.lex_state = 1},
  [186] = {.lex_state = 1},
  [187] = {.lex_state = 1},
  [188] = {.lex_state = 1},
  [189] = {.lex_state = 1},
  [190] = {.lex_state = 1},
  [191] = {.lex_state = 1},
  [192] = {.lex_state = 1},
  [193] = {.lex_state = 1},
  [194] = {.lex_state = 1},
  [195] = {.lex_state = 1},
  [196] = {.lex_state = 1},
  [197] = {.lex_state = 1},
  [198] = {.lex_state = 1},
  [199] = {.lex_state = 1},
  [200] = {.lex_state = 1},
  [201] = {.lex_state = 1},
  [202] = {.lex_state = 1},
  [203] = {.lex_state = 1},
  [204] = {.lex_state = 1},
  [205] = {.lex_state = 1},
  [206] = {.lex_state = 1},
  [207] = {.lex_state = 1},
  [208] = {.lex_state = 1},
  [209] = {.lex_state = 1},
  [210] = {.lex_state = 1},
  [211] = {.lex_state = 1},
  [212] = {.lex_state = 1},
  [213] = {.lex_state = 1},
  [214] = {.lex_state = 1},
  [215] = {.lex_state = 1},
  [216] = {.lex_state = 1},
  [217] = {.lex_state = 1},
  [218] = {.lex_state = 4},
  [219] = {.lex_state = 5},
  [220] = {.lex_state = 1},
  [221] = {.lex_state = 1},
  [222] = {.lex_state = 1},
  [223] = {.lex_state = 1},
  [224] = {.lex_state = 4},
  [225] = {.lex_state = 1},
  [226] = {.lex_state = 1},
  [227] = {.lex_state = 1},
  [228] = {.lex_state = 4},
  [229] = {.lex_state = 1},
  [230] = {.lex_state = 5},
  [231] = {.lex_state = 1},
  [232] = {.lex_state = 1},
  [233] = {.lex_state = 1},
  [234] = {.lex_state = 1},
  [235] = {.lex_state = 1},
  [236] = {.lex_state = 4},
  [237] = {.lex_state = 1},
  [238] = {.lex_state = 1},
  [239] = {.lex_state = 1},
  [240] = {.lex_state = 1},
  [241] = {.lex_state = 1},
  [242] = {.lex_state = 1},
  [243] = {.lex_state = 1},
  [244] = {.lex_state = 4},
  [245] = {.lex_state = 1},
  [246] = {.lex_state = 1},
  [247] = {.lex_state = 1},
  [248] = {.lex_state = 1},
  [249] = {.lex_state = 1},
  [250] = {.lex_state = 1},
  [251] = {.lex_state = 4},
  [252] = {.lex_state = 1},
  [253] = {.lex_state = 1},
  [254] = {.lex_state = 1},
  [255] = {.lex_state = 1},
  [256] = {.lex_state = 1},
  [257] = {.lex_state = 1},
  [258] = {.lex_state = 1},
  [259] = {.lex_state = 4},
  [260] = {.lex_state = 1},
  [261] = {.lex_state = 1},
  [262] = {.lex_state = 1},
  [263] = {.lex_state = 1},
  [264] = {.lex_state = 1},
  [265] = {.lex_state = 1},
  [266] = {.lex_state = 1},
  [267] = {.lex_state = 1},
  [268] = {.lex_state = 1},
  [269] = {.lex_state = 4},
  [270] = {.lex_state = 6},
  [271] = {.lex_state = 4},
  [272] = {.lex_state = 4},
  [273] = {.lex_state = 6},
  [274] = {.lex_state = 4},
  [275] = {.lex_state = 4},
  [276] = {.lex_state = 4},
  [277] = {.lex_state = 4},
  [278] = {.lex_state = 4},
  [279] = {.lex_state = 4},
  [280] = {.lex_state = 4},
  [281] = {.lex_state = 4},
  [282] = {.lex_state = 4},
  [283] = {.lex_state = 4},
  [284] = {.lex_state = 4},
  [285] = {.lex_state = 4},
  [286] = {.lex_state = 4},
  [287] = {.lex_state = 4},
  [288] = {.lex_state = 4},
  [289] = {.lex_state = 4},
  [290] = {.lex_state = 4},
  [291] = {.lex_state = 4},
  [292] = {.lex_state = 4},
  [293] = {.lex_state = 4},
  [294] = {.lex_state = 4},
  [295] = {.lex_state = 4},
  [296] = {.lex_state = 4},
  [297] = {.lex_state = 4},
  [298] = {.lex_state = 4},
  [299] = {.lex_state = 4},
  [300] = {.lex_state = 4},
  [301] = {.lex_state = 4},
  [302] = {.lex_state = 4},
  [303] = {.lex_state = 4},
  [304] = {.lex_state = 5},
  [305] = {.lex_state = 8},
  [306] = {.lex_state = 8},
  [307] = {.lex_state = 11},
  [308] = {.lex_state = 8},
  [309] = {.lex_state = 8},
  [310] = {.lex_state = 11},
  [311] = {.lex_state = 8},
  [312] = {.lex_state = 8},
  [313] = {.lex_state = 8},
  [314] = {.lex_state = 8},
  [315] = {.lex_state = 4},
  [316] = {.lex_state = 4},
  [317] = {.lex_state = 4},
  [318] = {.lex_state = 6},
  [319] = {.lex_state = 8},
  [320] = {.lex_state = 4},
  [321] = {.lex_state = 4},
  [322] = {.lex_state = 4},
  [323] = {.lex_state = 4},
  [324] = {.lex_state = 4},
  [325] = {.lex_state = 4},
  [326] = {.lex_state = 4},
  [327] = {.lex_state = 4},
  [328] = {.lex_state = 4},
  [329] = {.lex_state = 4},
  [330] = {.lex_state = 4},
  [331] = {.lex_state = 4},
  [332] = {.lex_state = 4},
  [333] = {.lex_state = 4},
  [334] = {.lex_state = 6},
  [335] = {.lex_state = 4},
  [336] = {.lex_state = 8},
  [337] = {.lex_state = 4},
  [338] = {.lex_state = 4},
  [339] = {.lex_state = 8},
  [340] = {.lex_state = 4},
  [341] = {.lex_state = 6},
  [342] = {.lex_state = 8},
  [343] = {.lex_state = 4},
  [344] = {.lex_state = 4},
  [345] = {.lex_state = 4},
  [346] = {.lex_state = 4},
  [347] = {.lex_state = 4},
  [348] = {.lex_state = 4},
  [349] = {.lex_state = 4},
  [350] = {.lex_state = 4},
  [351] = {.lex_state = 4},
  [352] = {.lex_state = 4},
  [353] = {.lex_state = 4},
  [354] = {.lex_state = 4},
  [355] = {.lex_state = 4},
  [356] = {.lex_state = 4},
  [357] = {.lex_state = 4},
  [358] = {.lex_state = 4},
  [359] = {.lex_state = 4},
  [360] = {.lex_state = 4},
  [361] = {.lex_state = 4},
  [362] = {.lex_state = 4},
  [363] = {.lex_state = 4},
  [364] = {.lex_state = 4},
  [365] = {.lex_state = 4},
  [366] = {.lex_state = 4},
  [367] = {.lex_state = 4},
  [368] = {.lex_state = 4},
  [369] = {.lex_state = 4},
  [370] = {.lex_state = 4},
  [371] = {.lex_state = 4},
  [372] = {.lex_state = 4},
  [373] = {.lex_state = 4},
  [374] = {.lex_state = 4},
  [375] = {.lex_state = 2},
  [376] = {.lex_state = 2},
  [377] = {.lex_state = 2},
  [378] = {.lex_state = 2},
  [379] = {.lex_state = 1},
  [380] = {.lex_state = 60},
  [381] = {.lex_state = 7},
  [382] = {.lex_state = 7},
  [383] = {.lex_state = 7},
  [384] = {.lex_state = 7},
  [385] = {.lex_state = 7},
  [386] = {.lex_state = 7},
  [387] = {.lex_state = 7},
  [388] = {.lex_state = 10},
  [389] = {.lex_state = 10},
  [390] = {.lex_state = 10},
  [391] = {.lex_state = 10},
  [392] = {.lex_state = 7},
  [393] = {.lex_state = 7},
  [394] = {.lex_state = 10},
  [395] = {.lex_state = 7},
  [396] = {.lex_state = 7},
  [397] = {.lex_state = 7},
  [398] = {.lex_state = 7},
  [399] = {.lex_state = 7},
  [400] = {.lex_state = 7},
  [401] = {.lex_state = 10},
  [402] = {.lex_state = 7},
  [403] = {.lex_state = 10},
  [404] = {.lex_state = 7},
  [405] = {.lex_state = 7},
  [406] = {.lex_state = 7},
  [407] = {.lex_state = 7},
  [408] = {.lex_state = 10},
  [409] = {.lex_state = 10},
  [410] = {.lex_state = 10},
  [411] = {.lex_state = 9},
  [412] = {.lex_state = 9},
  [413] = {.lex_state = 10},
  [414] = {.lex_state = 60},
  [415] = {.lex_state = 10},
  [416] = {.lex_state = 7},
  [417] = {.lex_state = 13},
  [418] = {.lex_state = 7},
  [419] = {.lex_state = 13},
  [420] = {.lex_state = 7},
  [421] = {.lex_state = 13},
  [422] = {.lex_state = 7},
  [423] = {.lex_state = 7},
  [424] = {.lex_state = 10},
  [425] = {.lex_state = 13},
  [426] = {.lex_state = 13},
  [427] = {.lex_state = 12},
  [428] = {.lex_state = 10},
  [429] = {.lex_state = 7},
  [430] = {.lex_state = 13},
  [431] = {.lex_state = 7},
  [432] = {.lex_state = 13},
  [433] = {.lex_state = 12},
  [434] = {.lex_state = 12},
  [435] = {.lex_state = 7},
  [436] = {.lex_state = 12},
  [437] = {.lex_state = 12},
  [438] = {.lex_state = 12},
  [439] = {.lex_state = 7},
  [440] = {.lex_state = 12},
  [441] = {.lex_state = 60},
  [442] = {.lex_state = 7},
  [443] = {.lex_state = 7},
  [444] = {.lex_state = 7},
  [445] = {.lex_state = 60},
  [446] = {.lex_state = 7},
  [447] = {.lex_state = 60},
  [448] = {.lex_state = 12},
  [449] = {.lex_state = 60},
  [450] = {.lex_state = 7},
  [451] = {.lex_state = 7},
  [452] = {.lex_state = 60},
  [453] = {.lex_state = 12},
  [454] = {.lex_state = 60},
  [455] = {.lex_state = 7},
  [456] = {.lex_state = 7},
  [457] = {.lex_state = 60},
  [458] = {.lex_state = 7},
  [459] = {.lex_state = 60},
  [460] = {.lex_state = 7},
  [461] = {.lex_state = 7},
  [462] = {.lex_state = 7},
  [463] = {.lex_state = 7},
  [464] = {.lex_state = 60},
  [465] = {.lex_state = 7},
  [466] = {.lex_state = 12},
  [467] = {.lex_state = 60},
  [468] = {.lex_state = 7},
  [469] = {.lex_state = 60},
  [470] = {.lex_state = 60},
  [471] = {.lex_state = 60},
  [472] = {.lex_state = 60},
  [473] = {.lex_state = 60},
  [474] = {.lex_state = 12},
  [475] = {.lex_state = 60},
  [476] = {.lex_state = 60},
  [477] = {.lex_state = 60},
  [478] = {.lex_state = 60},
  [479] = {.lex_state = 60},
  [480] = {.lex_state = 60},
  [481] = {.lex_state = 60},
  [482] = {.lex_state = 60},
  [483] = {.lex_state = 60},
  [484] = {.lex_state = 60},
  [485] = {.lex_state = 60},
  [486] = {.lex_state = 60},
  [487] = {.lex_state = 12},
  [488] = {.lex_state = 60},
  [489] = {.lex_state = 60},
  [490] = {.lex_state = 60},
  [491] = {.lex_state = 60},
  [492] = {.lex_state = 60},
  [493] = {.lex_state = 12},
  [494] = {.lex_state = 60},
  [495] = {.lex_state = 60},
  [496] = {.lex_state = 60},
  [497] = {.lex_state = 60},
  [498] = {.lex_state = 60},
  [499] = {.lex_state = 60},
  [500] = {.lex_state = 60},
  [501] = {.lex_state = 61},
  [502] = {.lex_state = 61},
  [503] = {.lex_state = 60},
  [504] = {.lex_state = 60},
  [505] = {.lex_state = 60},
  [506] = {.lex_state = 60},
  [507] = {.lex_state = 60},
  [508] = {.lex_state = 60},
  [509] = {.lex_state = 60},
  [510] = {.lex_state = 60},
  [511] = {.lex_state = 60},
  [512] = {.lex_state = 60},
  [513] = {.lex_state = 60},
  [514] = {.lex_state = 60},
  [515] = {.lex_state = 60},
  [516] = {.lex_state = 60},
  [517] = {.lex_state = 12},
  [518] = {.lex_state = 60},
  [519] = {.lex_state = 60},
  [520] = {.lex_state = 60},
  [521] = {.lex_state = 60},
  [522] = {.lex_state = 60},
  [523] = {.lex_state = 60},
  [524] = {.lex_state = 60},
  [525] = {.lex_state = 60},
  [526] = {.lex_state = 60},
  [527] = {.lex_state = 60},
  [528] = {.lex_state = 60},
  [529] = {.lex_state = 60},
  [530] = {.lex_state = 60},
  [531] = {.lex_state = 60},
  [532] = {.lex_state = 12},
  [533] = {.lex_state = 60},
  [534] = {.lex_state = 60},
  [535] = {.lex_state = 60},
  [536] = {.lex_state = 60},
  [537] = {.lex_state = 61},
  [538] = {.lex_state = 60},
  [539] = {.lex_state = 60},
  [540] = {.lex_state = 61},
  [541] = {.lex_state = 60},
  [542] = {.lex_state = 60},
  [543] = {.lex_state = 60},
  [544] = {.lex_state = 60},
  [545] = {.lex_state = 60},
  [546] = {.lex_state = 60},
  [547] = {.lex_state = 60},
  [548] = {.lex_state = 60},
  [549] = {.lex_state = 60},
  [550] = {.lex_state = 60},
  [551] = {.lex_state = 60},
  [552] = {.lex_state = 60},
  [553] = {.lex_state = 60},
  [554] = {.lex_state = 60},
  [555] = {.lex_state = 60},
  [556] = {.lex_state = 60},
  [557] = {.lex_state = 60},
  [558] = {.lex_state = 60},
  [559] = {.lex_state = 60},
  [560] = {.lex_state = 60},
  [561] = {.lex_state = 60},
  [562] = {.lex_state = 60},
  [563] = {.lex_state = 60},
  [564] = {.lex_state = 60},
  [565] = {.lex_state = 60},
  [566] = {.lex_state = 60},
  [567] = {.lex_state = 61},
  [568] = {.lex_state = 7},
  [569] = {.lex_state = 60},
  [570] = {.lex_state = 60},
  [571] = {.lex_state = 60},
  [572] = {.lex_state = 60},
  [573] = {.lex_state = 60},
  [574] = {.lex_state = 7},
  [575] = {.lex_state = 7},
  [576] = {.lex_state = 60},
  [577] = {.lex_state = 60},
  [578] = {.lex_state = 60},
  [579] = {.lex_state = 60},
  [580] = {.lex_state = 60},
  [581] = {.lex_state = 7},
  [582] = {.lex_state = 60},
  [583] = {.lex_state = 60},
  [584] = {.lex_state = 60},
  [585] = {.lex_state = 7},
  [586] = {.lex_state = 60},
  [587] = {.lex_state = 60},
  [588] = {.lex_state = 7},
  [589] = {.lex_state = 61},
  [590] = {.lex_state = 7},
  [591] = {.lex_state = 60},
  [592] = {.lex_state = 2},
  [593] = {.lex_state = 7},
  [594] = {.lex_state = 60},
  [595] = {.lex_state = 2},
  [596] = {.lex_state = 60},
  [597] = {.lex_state = 7},
  [598] = {.lex_state = 7},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_node] = ACTIONS(1),
    [anon_sym_define] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_TILDE_GT] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_AT_AT] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_include] = ACTIONS(1),
    [anon_sym_tag] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_elsif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_unless] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1),
    [anon_sym_LT_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_GT_GT] = ACTIONS(1),
    [anon_sym_PIPE_GT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_Boolean] = ACTIONS(1),
    [anon_sym_Integer] = ACTIONS(1),
    [anon_sym_Float] = ACTIONS(1),
    [anon_sym_String] = ACTIONS(1),
    [anon_sym_Array] = ACTIONS(1),
    [anon_sym_Hash] = ACTIONS(1),
    [anon_sym_Regexp] = ACTIONS(1),
    [anon_sym_Variant] = ACTIONS(1),
    [anon_sym_Data] = ACTIONS(1),
    [anon_sym_Undef] = ACTIONS(1),
    [anon_sym_Default] = ACTIONS(1),
    [anon_sym_File] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_EQ_TILDE] = ACTIONS(1),
    [anon_sym_BANG_TILDE] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [aux_sym__escape_sequence_token1] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [sym_regex] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [sym_undef] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_source_file] = STATE(569),
    [sym_statement] = STATE(179),
    [sym_class_definition] = STATE(170),
    [sym_node_definition] = STATE(170),
    [sym_defined_resource_type] = STATE(170),
    [sym_type_declaration] = STATE(170),
    [sym_assignment] = STATE(120),
    [sym_relation] = STATE(170),
    [sym_function_declaration] = STATE(170),
    [sym_resource_declaration] = STATE(170),
    [sym_require_statement] = STATE(170),
    [sym_include_statement] = STATE(170),
    [sym_tag_statement] = STATE(170),
    [sym_if_statement] = STATE(170),
    [sym_unless_statement] = STATE(170),
    [sym_case_statement] = STATE(170),
    [sym_iterator_statement] = STATE(170),
    [sym_resource_collector] = STATE(170),
    [sym_resource_default] = STATE(170),
    [sym_selector] = STATE(170),
    [sym_expression] = STATE(370),
    [sym_unary_expression] = STATE(287),
    [sym_binary_expression] = STATE(287),
    [sym_parenthesized_expression] = STATE(287),
    [sym_function_call] = STATE(50),
    [sym_field_expression] = STATE(287),
    [sym_variable] = STATE(23),
    [sym_array] = STATE(287),
    [sym_hash] = STATE(50),
    [sym_literal] = STATE(287),
    [sym_resource_reference] = STATE(71),
    [sym_string] = STATE(69),
    [sym_boolean] = STATE(230),
    [sym__identifier] = STATE(67),
    [sym_class_identifier] = STATE(67),
    [aux_sym_source_file_repeat1] = STATE(12),
    [ts_builtin_sym_end] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_class] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_node] = ACTIONS(13),
    [anon_sym_define] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_AT] = ACTIONS(21),
    [anon_sym_AT_AT] = ACTIONS(23),
    [anon_sym_require] = ACTIONS(25),
    [anon_sym_include] = ACTIONS(27),
    [anon_sym_tag] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_unless] = ACTIONS(33),
    [anon_sym_case] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_BANG] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_STAR] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(43),
    [sym_number] = ACTIONS(45),
    [sym_float] = ACTIONS(47),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_SQUOTE] = ACTIONS(51),
    [sym_regex] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [sym_undef] = ACTIONS(45),
    [sym_identifier] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
  },
  [2] = {
    [sym_statement] = STATE(179),
    [sym_class_definition] = STATE(170),
    [sym_node_definition] = STATE(170),
    [sym_defined_resource_type] = STATE(170),
    [sym_type_declaration] = STATE(170),
    [sym_assignment] = STATE(120),
    [sym_relation] = STATE(170),
    [sym_function_declaration] = STATE(170),
    [sym_resource_declaration] = STATE(170),
    [sym_require_statement] = STATE(170),
    [sym_include_statement] = STATE(170),
    [sym_tag_statement] = STATE(170),
    [sym_if_statement] = STATE(170),
    [sym_unless_statement] = STATE(170),
    [sym_case_statement] = STATE(170),
    [sym_iterator_statement] = STATE(170),
    [sym_resource_collector] = STATE(170),
    [sym_resource_default] = STATE(170),
    [sym_selector] = STATE(170),
    [sym_expression] = STATE(370),
    [sym_unary_expression] = STATE(287),
    [sym_binary_expression] = STATE(287),
    [sym_parenthesized_expression] = STATE(287),
    [sym_function_call] = STATE(50),
    [sym_field_expression] = STATE(287),
    [sym_variable] = STATE(23),
    [sym_array] = STATE(287),
    [sym_hash] = STATE(50),
    [sym_literal] = STATE(287),
    [sym_resource_reference] = STATE(71),
    [sym_string] = STATE(69),
    [sym_boolean] = STATE(230),
    [sym__identifier] = STATE(67),
    [sym_class_identifier] = STATE(67),
    [aux_sym_source_file_repeat1] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_RBRACE] = ACTIONS(59),
    [anon_sym_class] = ACTIONS(64),
    [anon_sym_LPAREN] = ACTIONS(67),
    [anon_sym_node] = ACTIONS(70),
    [anon_sym_define] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(76),
    [anon_sym_function] = ACTIONS(79),
    [anon_sym_AT] = ACTIONS(82),
    [anon_sym_AT_AT] = ACTIONS(85),
    [anon_sym_require] = ACTIONS(88),
    [anon_sym_include] = ACTIONS(91),
    [anon_sym_tag] = ACTIONS(94),
    [anon_sym_if] = ACTIONS(97),
    [anon_sym_unless] = ACTIONS(100),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(106),
    [anon_sym_BANG] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(112),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(115),
    [sym_number] = ACTIONS(118),
    [sym_float] = ACTIONS(121),
    [anon_sym_DQUOTE] = ACTIONS(124),
    [anon_sym_SQUOTE] = ACTIONS(127),
    [sym_regex] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(130),
    [anon_sym_false] = ACTIONS(130),
    [sym_undef] = ACTIONS(118),
    [sym_identifier] = ACTIONS(133),
    [sym_comment] = ACTIONS(57),
  },
  [3] = {
    [sym_statement] = STATE(179),
    [sym_class_definition] = STATE(170),
    [sym_node_definition] = STATE(170),
    [sym_defined_resource_type] = STATE(170),
    [sym_type_declaration] = STATE(170),
    [sym_assignment] = STATE(120),
    [sym_relation] = STATE(170),
    [sym_function_declaration] = STATE(170),
    [sym_resource_declaration] = STATE(170),
    [sym_require_statement] = STATE(170),
    [sym_include_statement] = STATE(170),
    [sym_tag_statement] = STATE(170),
    [sym_if_statement] = STATE(170),
    [sym_unless_statement] = STATE(170),
    [sym_case_statement] = STATE(170),
    [sym_iterator_statement] = STATE(170),
    [sym_resource_collector] = STATE(170),
    [sym_resource_default] = STATE(170),
    [sym_selector] = STATE(170),
    [sym_expression] = STATE(370),
    [sym_unary_expression] = STATE(287),
    [sym_binary_expression] = STATE(287),
    [sym_parenthesized_expression] = STATE(287),
    [sym_function_call] = STATE(50),
    [sym_field_expression] = STATE(287),
    [sym_variable] = STATE(23),
    [sym_array] = STATE(287),
    [sym_hash] = STATE(50),
    [sym_literal] = STATE(287),
    [sym_resource_reference] = STATE(71),
    [sym_string] = STATE(69),
    [sym_boolean] = STATE(230),
    [sym__identifier] = STATE(67),
    [sym_class_identifier] = STATE(67),
    [aux_sym_source_file_repeat1] = STATE(2),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(136),
    [anon_sym_class] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_node] = ACTIONS(13),
    [anon_sym_define] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_AT] = ACTIONS(21),
    [anon_sym_AT_AT] = ACTIONS(23),
    [anon_sym_require] = ACTIONS(25),
    [anon_sym_include] = ACTIONS(27),
    [anon_sym_tag] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_unless] = ACTIONS(33),
    [anon_sym_case] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_BANG] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_STAR] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(43),
    [sym_number] = ACTIONS(45),
    [sym_float] = ACTIONS(47),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_SQUOTE] = ACTIONS(51),
    [sym_regex] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [sym_undef] = ACTIONS(45),
    [sym_identifier] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
  },
  [4] = {
    [sym_statement] = STATE(179),
    [sym_class_definition] = STATE(170),
    [sym_node_definition] = STATE(170),
    [sym_defined_resource_type] = STATE(170),
    [sym_type_declaration] = STATE(170),
    [sym_assignment] = STATE(120),
    [sym_relation] = STATE(170),
    [sym_function_declaration] = STATE(170),
    [sym_resource_declaration] = STATE(170),
    [sym_require_statement] = STATE(170),
    [sym_include_statement] = STATE(170),
    [sym_tag_statement] = STATE(170),
    [sym_if_statement] = STATE(170),
    [sym_unless_statement] = STATE(170),
    [sym_case_statement] = STATE(170),
    [sym_iterator_statement] = STATE(170),
    [sym_resource_collector] = STATE(170),
    [sym_resource_default] = STATE(170),
    [sym_selector] = STATE(170),
    [sym_expression] = STATE(370),
    [sym_unary_expression] = STATE(287),
    [sym_binary_expression] = STATE(287),
    [sym_parenthesized_expression] = STATE(287),
    [sym_function_call] = STATE(50),
    [sym_field_expression] = STATE(287),
    [sym_variable] = STATE(23),
    [sym_array] = STATE(287),
    [sym_hash] = STATE(50),
    [sym_literal] = STATE(287),
    [sym_resource_reference] = STATE(71),
    [sym_string] = STATE(69),
    [sym_boolean] = STATE(230),
    [sym__identifier] = STATE(67),
    [sym_class_identifier] = STATE(67),
    [aux_sym_source_file_repeat1] = STATE(3),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(138),
    [anon_sym_class] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_node] = ACTIONS(13),
    [anon_sym_define] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_AT] = ACTIONS(21),
    [anon_sym_AT_AT] = ACTIONS(23),
    [anon_sym_require] = ACTIONS(25),
    [anon_sym_include] = ACTIONS(27),
    [anon_sym_tag] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_unless] = ACTIONS(33),
    [anon_sym_case] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_BANG] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_STAR] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(43),
    [sym_number] = ACTIONS(45),
    [sym_float] = ACTIONS(47),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_SQUOTE] = ACTIONS(51),
    [sym_regex] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [sym_undef] = ACTIONS(45),
    [sym_identifier] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
  },
  [5] = {
    [sym_statement] = STATE(179),
    [sym_class_definition] = STATE(170),
    [sym_node_definition] = STATE(170),
    [sym_defined_resource_type] = STATE(170),
    [sym_type_declaration] = STATE(170),
    [sym_assignment] = STATE(120),
    [sym_relation] = STATE(170),
    [sym_function_declaration] = STATE(170),
    [sym_resource_declaration] = STATE(170),
    [sym_require_statement] = STATE(170),
    [sym_include_statement] = STATE(170),
    [sym_tag_statement] = STATE(170),
    [sym_if_statement] = STATE(170),
    [sym_unless_statement] = STATE(170),
    [sym_case_statement] = STATE(170),
    [sym_iterator_statement] = STATE(170),
    [sym_resource_collector] = STATE(170),
    [sym_resource_default] = STATE(170),
    [sym_selector] = STATE(170),
    [sym_expression] = STATE(370),
    [sym_unary_expression] = STATE(287),
    [sym_binary_expression] = STATE(287),
    [sym_parenthesized_expression] = STATE(287),
    [sym_function_call] = STATE(50),
    [sym_field_expression] = STATE(287),
    [sym_variable] = STATE(23),
    [sym_array] = STATE(287),
    [sym_hash] = STATE(50),
    [sym_literal] = STATE(287),
    [sym_resource_reference] = STATE(71),
    [sym_string] = STATE(69),
    [sym_boolean] = STATE(230),
    [sym__identifier] = STATE(67),
    [sym_class_identifier] = STATE(67),
    [aux_sym_source_file_repeat1] = STATE(2),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(140),
    [anon_sym_class] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_node] = ACTIONS(13),
    [anon_sym_define] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_AT] = ACTIONS(21),
    [anon_sym_AT_AT] = ACTIONS(23),
    [anon_sym_require] = ACTIONS(25),
    [anon_sym_include] = ACTIONS(27),
    [anon_sym_tag] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_unless] = ACTIONS(33),
    [anon_sym_case] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_BANG] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_STAR] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(43),
    [sym_number] = ACTIONS(45),
    [sym_float] = ACTIONS(47),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_SQUOTE] = ACTIONS(51),
    [sym_regex] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [sym_undef] = ACTIONS(45),
    [sym_identifier] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
  },
  [6] = {
    [sym_statement] = STATE(179),
    [sym_class_definition] = STATE(170),
    [sym_node_definition] = STATE(170),
    [sym_defined_resource_type] = STATE(170),
    [sym_type_declaration] = STATE(170),
    [sym_assignment] = STATE(120),
    [sym_relation] = STATE(170),
    [sym_function_declaration] = STATE(170),
    [sym_resource_declaration] = STATE(170),
    [sym_require_statement] = STATE(170),
    [sym_include_statement] = STATE(170),
    [sym_tag_statement] = STATE(170),
    [sym_if_statement] = STATE(170),
    [sym_unless_statement] = STATE(170),
    [sym_case_statement] = STATE(170),
    [sym_iterator_statement] = STATE(170),
    [sym_resource_collector] = STATE(170),
    [sym_resource_default] = STATE(170),
    [sym_selector] = STATE(170),
    [sym_expression] = STATE(370),
    [sym_unary_expression] = STATE(287),
    [sym_binary_expression] = STATE(287),
    [sym_parenthesized_expression] = STATE(287),
    [sym_function_call] = STATE(50),
    [sym_field_expression] = STATE(287),
    [sym_variable] = STATE(23),
    [sym_array] = STATE(287),
    [sym_hash] = STATE(50),
    [sym_literal] = STATE(287),
    [sym_resource_reference] = STATE(71),
    [sym_string] = STATE(69),
    [sym_boolean] = STATE(230),
    [sym__identifier] = STATE(67),
    [sym_class_identifier] = STATE(67),
    [aux_sym_source_file_repeat1] = STATE(5),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(142),
    [anon_sym_class] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_node] = ACTIONS(13),
    [anon_sym_define] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_AT] = ACTIONS(21),
    [anon_sym_AT_AT] = ACTIONS(23),
    [anon_sym_require] = ACTIONS(25),
    [anon_sym_include] = ACTIONS(27),
    [anon_sym_tag] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_unless] = ACTIONS(33),
    [anon_sym_case] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_BANG] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_STAR] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(43),
    [sym_number] = ACTIONS(45),
    [sym_float] = ACTIONS(47),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_SQUOTE] = ACTIONS(51),
    [sym_regex] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [sym_undef] = ACTIONS(45),
    [sym_identifier] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
  },
  [7] = {
    [sym_statement] = STATE(179),
    [sym_class_definition] = STATE(170),
    [sym_node_definition] = STATE(170),
    [sym_defined_resource_type] = STATE(170),
    [sym_type_declaration] = STATE(170),
    [sym_assignment] = STATE(120),
    [sym_relation] = STATE(170),
    [sym_function_declaration] = STATE(170),
    [sym_resource_declaration] = STATE(170),
    [sym_require_statement] = STATE(170),
    [sym_include_statement] = STATE(170),
    [sym_tag_statement] = STATE(170),
    [sym_if_statement] = STATE(170),
    [sym_unless_statement] = STATE(170),
    [sym_case_statement] = STATE(170),
    [sym_iterator_statement] = STATE(170),
    [sym_resource_collector] = STATE(170),
    [sym_resource_default] = STATE(170),
    [sym_selector] = STATE(170),
    [sym_expression] = STATE(370),
    [sym_unary_expression] = STATE(287),
    [sym_binary_expression] = STATE(287),
    [sym_parenthesized_expression] = STATE(287),
    [sym_function_call] = STATE(50),
    [sym_field_expression] = STATE(287),
    [sym_variable] = STATE(23),
    [sym_array] = STATE(287),
    [sym_hash] = STATE(50),
    [sym_literal] = STATE(287),
    [sym_resource_reference] = STATE(71),
    [sym_string] = STATE(69),
    [sym_boolean] = STATE(230),
    [sym__identifier] = STATE(67),
    [sym_class_identifier] = STATE(67),
    [aux_sym_source_file_repeat1] = STATE(2),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(144),
    [anon_sym_class] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_node] = ACTIONS(13),
    [anon_sym_define] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_AT] = ACTIONS(21),
    [anon_sym_AT_AT] = ACTIONS(23),
    [anon_sym_require] = ACTIONS(25),
    [anon_sym_include] = ACTIONS(27),
    [anon_sym_tag] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_unless] = ACTIONS(33),
    [anon_sym_case] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_BANG] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_STAR] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(43),
    [sym_number] = ACTIONS(45),
    [sym_float] = ACTIONS(47),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_SQUOTE] = ACTIONS(51),
    [sym_regex] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [sym_undef] = ACTIONS(45),
    [sym_identifier] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
  },
  [8] = {
    [sym_statement] = STATE(179),
    [sym_class_definition] = STATE(170),
    [sym_node_definition] = STATE(170),
    [sym_defined_resource_type] = STATE(170),
    [sym_type_declaration] = STATE(170),
    [sym_assignment] = STATE(120),
    [sym_relation] = STATE(170),
    [sym_function_declaration] = STATE(170),
    [sym_resource_declaration] = STATE(170),
    [sym_require_statement] = STATE(170),
    [sym_include_statement] = STATE(170),
    [sym_tag_statement] = STATE(170),
    [sym_if_statement] = STATE(170),
    [sym_unless_statement] = STATE(170),
    [sym_case_statement] = STATE(170),
    [sym_iterator_statement] = STATE(170),
    [sym_resource_collector] = STATE(170),
    [sym_resource_default] = STATE(170),
    [sym_selector] = STATE(170),
    [sym_expression] = STATE(370),
    [sym_unary_expression] = STATE(287),
    [sym_binary_expression] = STATE(287),
    [sym_parenthesized_expression] = STATE(287),
    [sym_function_call] = STATE(50),
    [sym_field_expression] = STATE(287),
    [sym_variable] = STATE(23),
    [sym_array] = STATE(287),
    [sym_hash] = STATE(50),
    [sym_literal] = STATE(287),
    [sym_resource_reference] = STATE(71),
    [sym_string] = STATE(69),
    [sym_boolean] = STATE(230),
    [sym__identifier] = STATE(67),
    [sym_class_identifier] = STATE(67),
    [aux_sym_source_file_repeat1] = STATE(7),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_node] = ACTIONS(13),
    [anon_sym_define] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_AT] = ACTIONS(21),
    [anon_sym_AT_AT] = ACTIONS(23),
    [anon_sym_require] = ACTIONS(25),
    [anon_sym_include] = ACTIONS(27),
    [anon_sym_tag] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_unless] = ACTIONS(33),
    [anon_sym_case] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_BANG] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_STAR] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(43),
    [sym_number] = ACTIONS(45),
    [sym_float] = ACTIONS(47),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_SQUOTE] = ACTIONS(51),
    [sym_regex] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [sym_undef] = ACTIONS(45),
    [sym_identifier] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
  },
  [9] = {
    [sym_statement] = STATE(179),
    [sym_class_definition] = STATE(170),
    [sym_node_definition] = STATE(170),
    [sym_defined_resource_type] = STATE(170),
    [sym_type_declaration] = STATE(170),
    [sym_assignment] = STATE(120),
    [sym_relation] = STATE(170),
    [sym_function_declaration] = STATE(170),
    [sym_resource_declaration] = STATE(170),
    [sym_require_statement] = STATE(170),
    [sym_include_statement] = STATE(170),
    [sym_tag_statement] = STATE(170),
    [sym_if_statement] = STATE(170),
    [sym_unless_statement] = STATE(170),
    [sym_case_statement] = STATE(170),
    [sym_iterator_statement] = STATE(170),
    [sym_resource_collector] = STATE(170),
    [sym_resource_default] = STATE(170),
    [sym_selector] = STATE(170),
    [sym_expression] = STATE(370),
    [sym_unary_expression] = STATE(287),
    [sym_binary_expression] = STATE(287),
    [sym_parenthesized_expression] = STATE(287),
    [sym_function_call] = STATE(50),
    [sym_field_expression] = STATE(287),
    [sym_variable] = STATE(23),
    [sym_array] = STATE(287),
    [sym_hash] = STATE(50),
    [sym_literal] = STATE(287),
    [sym_resource_reference] = STATE(71),
    [sym_string] = STATE(69),
    [sym_boolean] = STATE(230),
    [sym__identifier] = STATE(67),
    [sym_class_identifier] = STATE(67),
    [aux_sym_source_file_repeat1] = STATE(13),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(148),
    [anon_sym_class] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_node] = ACTIONS(13),
    [anon_sym_define] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_AT] = ACTIONS(21),
    [anon_sym_AT_AT] = ACTIONS(23),
    [anon_sym_require] = ACTIONS(25),
    [anon_sym_include] = ACTIONS(27),
    [anon_sym_tag] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_unless] = ACTIONS(33),
    [anon_sym_case] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_BANG] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_STAR] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(43),
    [sym_number] = ACTIONS(45),
    [sym_float] = ACTIONS(47),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_SQUOTE] = ACTIONS(51),
    [sym_regex] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [sym_undef] = ACTIONS(45),
    [sym_identifier] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
  },
  [10] = {
    [sym_statement] = STATE(179),
    [sym_class_definition] = STATE(170),
    [sym_node_definition] = STATE(170),
    [sym_defined_resource_type] = STATE(170),
    [sym_type_declaration] = STATE(170),
    [sym_assignment] = STATE(120),
    [sym_relation] = STATE(170),
    [sym_function_declaration] = STATE(170),
    [sym_resource_declaration] = STATE(170),
    [sym_require_statement] = STATE(170),
    [sym_include_statement] = STATE(170),
    [sym_tag_statement] = STATE(170),
    [sym_if_statement] = STATE(170),
    [sym_unless_statement] = STATE(170),
    [sym_case_statement] = STATE(170),
    [sym_iterator_statement] = STATE(170),
    [sym_resource_collector] = STATE(170),
    [sym_resource_default] = STATE(170),
    [sym_selector] = STATE(170),
    [sym_expression] = STATE(370),
    [sym_unary_expression] = STATE(287),
    [sym_binary_expression] = STATE(287),
    [sym_parenthesized_expression] = STATE(287),
    [sym_function_call] = STATE(50),
    [sym_field_expression] = STATE(287),
    [sym_variable] = STATE(23),
    [sym_array] = STATE(287),
    [sym_hash] = STATE(50),
    [sym_literal] = STATE(287),
    [sym_resource_reference] = STATE(71),
    [sym_string] = STATE(69),
    [sym_boolean] = STATE(230),
    [sym__identifier] = STATE(67),
    [sym_class_identifier] = STATE(67),
    [aux_sym_source_file_repeat1] = STATE(2),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(150),
    [anon_sym_class] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_node] = ACTIONS(13),
    [anon_sym_define] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_AT] = ACTIONS(21),
    [anon_sym_AT_AT] = ACTIONS(23),
    [anon_sym_require] = ACTIONS(25),
    [anon_sym_include] = ACTIONS(27),
    [anon_sym_tag] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_unless] = ACTIONS(33),
    [anon_sym_case] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_BANG] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_STAR] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(43),
    [sym_number] = ACTIONS(45),
    [sym_float] = ACTIONS(47),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_SQUOTE] = ACTIONS(51),
    [sym_regex] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [sym_undef] = ACTIONS(45),
    [sym_identifier] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
  },
  [11] = {
    [sym_statement] = STATE(179),
    [sym_class_definition] = STATE(170),
    [sym_node_definition] = STATE(170),
    [sym_defined_resource_type] = STATE(170),
    [sym_type_declaration] = STATE(170),
    [sym_assignment] = STATE(120),
    [sym_relation] = STATE(170),
    [sym_function_declaration] = STATE(170),
    [sym_resource_declaration] = STATE(170),
    [sym_require_statement] = STATE(170),
    [sym_include_statement] = STATE(170),
    [sym_tag_statement] = STATE(170),
    [sym_if_statement] = STATE(170),
    [sym_unless_statement] = STATE(170),
    [sym_case_statement] = STATE(170),
    [sym_iterator_statement] = STATE(170),
    [sym_resource_collector] = STATE(170),
    [sym_resource_default] = STATE(170),
    [sym_selector] = STATE(170),
    [sym_expression] = STATE(370),
    [sym_unary_expression] = STATE(287),
    [sym_binary_expression] = STATE(287),
    [sym_parenthesized_expression] = STATE(287),
    [sym_function_call] = STATE(50),
    [sym_field_expression] = STATE(287),
    [sym_variable] = STATE(23),
    [sym_array] = STATE(287),
    [sym_hash] = STATE(50),
    [sym_literal] = STATE(287),
    [sym_resource_reference] = STATE(71),
    [sym_string] = STATE(69),
    [sym_boolean] = STATE(230),
    [sym__identifier] = STATE(67),
    [sym_class_identifier] = STATE(67),
    [aux_sym_source_file_repeat1] = STATE(10),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(152),
    [anon_sym_class] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_node] = ACTIONS(13),
    [anon_sym_define] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_AT] = ACTIONS(21),
    [anon_sym_AT_AT] = ACTIONS(23),
    [anon_sym_require] = ACTIONS(25),
    [anon_sym_include] = ACTIONS(27),
    [anon_sym_tag] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_unless] = ACTIONS(33),
    [anon_sym_case] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_BANG] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_STAR] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(43),
    [sym_number] = ACTIONS(45),
    [sym_float] = ACTIONS(47),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_SQUOTE] = ACTIONS(51),
    [sym_regex] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [sym_undef] = ACTIONS(45),
    [sym_identifier] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
  },
  [12] = {
    [sym_statement] = STATE(179),
    [sym_class_definition] = STATE(170),
    [sym_node_definition] = STATE(170),
    [sym_defined_resource_type] = STATE(170),
    [sym_type_declaration] = STATE(170),
    [sym_assignment] = STATE(120),
    [sym_relation] = STATE(170),
    [sym_function_declaration] = STATE(170),
    [sym_resource_declaration] = STATE(170),
    [sym_require_statement] = STATE(170),
    [sym_include_statement] = STATE(170),
    [sym_tag_statement] = STATE(170),
    [sym_if_statement] = STATE(170),
    [sym_unless_statement] = STATE(170),
    [sym_case_statement] = STATE(170),
    [sym_iterator_statement] = STATE(170),
    [sym_resource_collector] = STATE(170),
    [sym_resource_default] = STATE(170),
    [sym_selector] = STATE(170),
    [sym_expression] = STATE(370),
    [sym_unary_expression] = STATE(287),
    [sym_binary_expression] = STATE(287),
    [sym_parenthesized_expression] = STATE(287),
    [sym_function_call] = STATE(50),
    [sym_field_expression] = STATE(287),
    [sym_variable] = STATE(23),
    [sym_array] = STATE(287),
    [sym_hash] = STATE(50),
    [sym_literal] = STATE(287),
    [sym_resource_reference] = STATE(71),
    [sym_string] = STATE(69),
    [sym_boolean] = STATE(230),
    [sym__identifier] = STATE(67),
    [sym_class_identifier] = STATE(67),
    [aux_sym_source_file_repeat1] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(154),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_class] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_node] = ACTIONS(13),
    [anon_sym_define] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_AT] = ACTIONS(21),
    [anon_sym_AT_AT] = ACTIONS(23),
    [anon_sym_require] = ACTIONS(25),
    [anon_sym_include] = ACTIONS(27),
    [anon_sym_tag] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_unless] = ACTIONS(33),
    [anon_sym_case] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_BANG] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_STAR] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(43),
    [sym_number] = ACTIONS(45),
    [sym_float] = ACTIONS(47),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_SQUOTE] = ACTIONS(51),
    [sym_regex] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [sym_undef] = ACTIONS(45),
    [sym_identifier] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
  },
  [13] = {
    [sym_statement] = STATE(179),
    [sym_class_definition] = STATE(170),
    [sym_node_definition] = STATE(170),
    [sym_defined_resource_type] = STATE(170),
    [sym_type_declaration] = STATE(170),
    [sym_assignment] = STATE(120),
    [sym_relation] = STATE(170),
    [sym_function_declaration] = STATE(170),
    [sym_resource_declaration] = STATE(170),
    [sym_require_statement] = STATE(170),
    [sym_include_statement] = STATE(170),
    [sym_tag_statement] = STATE(170),
    [sym_if_statement] = STATE(170),
    [sym_unless_statement] = STATE(170),
    [sym_case_statement] = STATE(170),
    [sym_iterator_statement] = STATE(170),
    [sym_resource_collector] = STATE(170),
    [sym_resource_default] = STATE(170),
    [sym_selector] = STATE(170),
    [sym_expression] = STATE(370),
    [sym_unary_expression] = STATE(287),
    [sym_binary_expression] = STATE(287),
    [sym_parenthesized_expression] = STATE(287),
    [sym_function_call] = STATE(50),
    [sym_field_expression] = STATE(287),
    [sym_variable] = STATE(23),
    [sym_array] = STATE(287),
    [sym_hash] = STATE(50),
    [sym_literal] = STATE(287),
    [sym_resource_reference] = STATE(71),
    [sym_string] = STATE(69),
    [sym_boolean] = STATE(230),
    [sym__identifier] = STATE(67),
    [sym_class_identifier] = STATE(67),
    [aux_sym_source_file_repeat1] = STATE(2),
    [anon_sym_LBRACE] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(156),
    [anon_sym_class] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_node] = ACTIONS(13),
    [anon_sym_define] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_function] = ACTIONS(19),
    [anon_sym_AT] = ACTIONS(21),
    [anon_sym_AT_AT] = ACTIONS(23),
    [anon_sym_require] = ACTIONS(25),
    [anon_sym_include] = ACTIONS(27),
    [anon_sym_tag] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_unless] = ACTIONS(33),
    [anon_sym_case] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(37),
    [anon_sym_BANG] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_STAR] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(43),
    [sym_number] = ACTIONS(45),
    [sym_float] = ACTIONS(47),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_SQUOTE] = ACTIONS(51),
    [sym_regex] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [sym_undef] = ACTIONS(45),
    [sym_identifier] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 37,
    ACTIONS(7), 1,
      anon_sym_LBRACE,
    ACTIONS(9), 1,
      anon_sym_class,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      anon_sym_node,
    ACTIONS(15), 1,
      anon_sym_define,
    ACTIONS(17), 1,
      anon_sym_type,
    ACTIONS(19), 1,
      anon_sym_function,
    ACTIONS(21), 1,
      anon_sym_AT,
    ACTIONS(23), 1,
      anon_sym_AT_AT,
    ACTIONS(25), 1,
      anon_sym_require,
    ACTIONS(27), 1,
      anon_sym_include,
    ACTIONS(29), 1,
      anon_sym_tag,
    ACTIONS(31), 1,
      anon_sym_if,
    ACTIONS(33), 1,
      anon_sym_unless,
    ACTIONS(35), 1,
      anon_sym_case,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(41), 1,
      anon_sym_DASH,
    ACTIONS(43), 1,
      anon_sym_DOLLAR,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(55), 1,
      sym_identifier,
    ACTIONS(57), 1,
      sym_comment,
    STATE(23), 1,
      sym_variable,
    STATE(69), 1,
      sym_string,
    STATE(71), 1,
      sym_resource_reference,
    STATE(120), 1,
      sym_assignment,
    STATE(133), 1,
      sym_statement,
    STATE(230), 1,
      sym_boolean,
    STATE(370), 1,
      sym_expression,
    ACTIONS(39), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(50), 2,
      sym_function_call,
      sym_hash,
    STATE(67), 2,
      sym__identifier,
      sym_class_identifier,
    STATE(287), 6,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_field_expression,
      sym_array,
      sym_literal,
    STATE(170), 17,
      sym_class_definition,
      sym_node_definition,
      sym_defined_resource_type,
      sym_type_declaration,
      sym_relation,
      sym_function_declaration,
      sym_resource_declaration,
      sym_require_statement,
      sym_include_statement,
      sym_tag_statement,
      sym_if_statement,
      sym_unless_statement,
      sym_case_statement,
      sym_iterator_statement,
      sym_resource_collector,
      sym_resource_default,
      sym_selector,
  [139] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(162), 1,
      anon_sym_COLON_COLON,
    STATE(15), 1,
      aux_sym_class_identifier_repeat1,
    ACTIONS(160), 27,
      anon_sym_class,
      anon_sym_EQ,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(158), 31,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [211] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(169), 1,
      anon_sym_COLON_COLON,
    STATE(17), 1,
      aux_sym_class_identifier_repeat1,
    ACTIONS(167), 27,
      anon_sym_class,
      anon_sym_EQ,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(165), 31,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [283] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(169), 1,
      anon_sym_COLON_COLON,
    STATE(15), 1,
      aux_sym_class_identifier_repeat1,
    ACTIONS(173), 27,
      anon_sym_class,
      anon_sym_EQ,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(171), 31,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(160), 27,
      anon_sym_class,
      anon_sym_EQ,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(158), 32,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
      anon_sym_COLON_COLON,
  [422] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(177), 27,
      anon_sym_class,
      anon_sym_EQ,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(175), 31,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [488] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(181), 27,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_PIPE,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_PIPE_GT,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(179), 30,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_EQ_GT,
      anon_sym_PIPE_GT_GT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(185), 27,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_PIPE,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_PIPE_GT,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(183), 30,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_EQ_GT,
      anon_sym_PIPE_GT_GT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [618] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(187), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(189), 27,
      anon_sym_class,
      anon_sym_EQ,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [683] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(200), 1,
      anon_sym_EQ,
    ACTIONS(202), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(206), 1,
      anon_sym_QMARK,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
    ACTIONS(210), 1,
      anon_sym_DASH,
    ACTIONS(197), 2,
      anon_sym_LPAREN,
      anon_sym_STAR,
    ACTIONS(213), 7,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_in,
    ACTIONS(193), 11,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(204), 11,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
    ACTIONS(195), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(215), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_PIPE_GT_GT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(217), 27,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_PIPE,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_PIPE_GT,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [823] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
    ACTIONS(219), 2,
      anon_sym_LT_LT_PIPE,
      anon_sym_LT_PIPE,
    ACTIONS(187), 24,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(189), 26,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [891] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_PIPE,
    STATE(46), 1,
      sym_lambda,
    STATE(49), 1,
      sym_block,
    ACTIONS(223), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(221), 26,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_PIPE_GT_GT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(229), 27,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_PIPE,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_PIPE_GT,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [1021] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_PIPE,
    STATE(41), 1,
      sym_lambda,
    STATE(49), 1,
      sym_block,
    ACTIONS(233), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(231), 26,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [1089] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_PIPE,
    STATE(43), 1,
      sym_lambda,
    STATE(49), 1,
      sym_block,
    ACTIONS(237), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(235), 26,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [1157] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 1,
      anon_sym_PIPE,
    STATE(45), 1,
      sym_lambda,
    STATE(49), 1,
      sym_block,
    ACTIONS(241), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(239), 26,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [1225] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(43), 1,
      sym_lambda,
    STATE(49), 1,
      sym_block,
    ACTIONS(237), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(235), 26,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [1290] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(46), 1,
      sym_lambda,
    STATE(49), 1,
      sym_block,
    ACTIONS(223), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(221), 26,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [1355] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(41), 1,
      sym_lambda,
    STATE(49), 1,
      sym_block,
    ACTIONS(233), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(231), 26,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [1420] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(45), 1,
      sym_lambda,
    STATE(49), 1,
      sym_block,
    ACTIONS(241), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(239), 26,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [1485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(245), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(243), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [1545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(249), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(247), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [1605] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
    ACTIONS(187), 25,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(189), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [1669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(253), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(251), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [1729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(257), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(255), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [1789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(261), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(259), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [1849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(237), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(235), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [1909] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(265), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(263), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [1969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(241), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(239), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [2029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(269), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(267), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [2089] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(271), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [2149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(233), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(231), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [2209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(277), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(275), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [2269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(281), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(279), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [2329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(285), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(283), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [2389] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(210), 1,
      anon_sym_DASH,
    ACTIONS(197), 2,
      anon_sym_LPAREN,
      anon_sym_STAR,
    ACTIONS(213), 6,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
    ACTIONS(193), 12,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(204), 12,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
    ACTIONS(195), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [2456] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_in,
    ACTIONS(295), 1,
      anon_sym_DOT,
    ACTIONS(287), 24,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(289), 24,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [2521] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_in,
    ACTIONS(295), 1,
      anon_sym_DOT,
    ACTIONS(297), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(287), 22,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(289), 24,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [2588] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_in,
    ACTIONS(295), 1,
      anon_sym_DOT,
    ACTIONS(301), 1,
      anon_sym_SLASH,
    ACTIONS(297), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(299), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(287), 20,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(289), 23,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [2659] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_in,
    ACTIONS(295), 1,
      anon_sym_DOT,
    ACTIONS(301), 1,
      anon_sym_SLASH,
    ACTIONS(305), 1,
      anon_sym_DASH,
    ACTIONS(307), 1,
      anon_sym_PLUS,
    ACTIONS(297), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(299), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(303), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(287), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(289), 22,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [2736] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_in,
    ACTIONS(295), 1,
      anon_sym_DOT,
    ACTIONS(301), 1,
      anon_sym_SLASH,
    ACTIONS(305), 1,
      anon_sym_DASH,
    ACTIONS(307), 1,
      anon_sym_PLUS,
    ACTIONS(297), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(299), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(287), 19,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(289), 22,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [2811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(309), 26,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [2870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(315), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(313), 26,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [2929] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_LPAREN,
    ACTIONS(295), 1,
      anon_sym_DOT,
    ACTIONS(317), 24,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(319), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [2992] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_in,
    ACTIONS(295), 1,
      anon_sym_DOT,
    ACTIONS(301), 1,
      anon_sym_SLASH,
    ACTIONS(305), 1,
      anon_sym_DASH,
    ACTIONS(307), 1,
      anon_sym_PLUS,
    ACTIONS(327), 1,
      anon_sym_or,
    ACTIONS(329), 1,
      anon_sym_and,
    ACTIONS(297), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(299), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(303), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(325), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(331), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(333), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(321), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(323), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [3079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(337), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(335), 26,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [3138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(341), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(339), 26,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [3197] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
    ACTIONS(343), 25,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(345), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [3258] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
    ACTIONS(204), 25,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(213), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [3319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(349), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(347), 26,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [3378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(213), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(204), 26,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [3437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(351), 26,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [3496] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(210), 1,
      anon_sym_DASH,
    ACTIONS(355), 1,
      anon_sym_LBRACE,
    ACTIONS(197), 2,
      anon_sym_LPAREN,
      anon_sym_STAR,
    ACTIONS(213), 6,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
    ACTIONS(193), 11,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(204), 12,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
    ACTIONS(195), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [3565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(345), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(343), 26,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [3624] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(360), 1,
      anon_sym_DASH,
    ACTIONS(357), 2,
      anon_sym_LPAREN,
      anon_sym_STAR,
    ACTIONS(345), 6,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
    ACTIONS(193), 12,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(343), 12,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
    ACTIONS(195), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [3691] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_in,
    ACTIONS(295), 1,
      anon_sym_DOT,
    ACTIONS(301), 1,
      anon_sym_SLASH,
    ACTIONS(305), 1,
      anon_sym_DASH,
    ACTIONS(307), 1,
      anon_sym_PLUS,
    ACTIONS(297), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(299), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(303), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(325), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(331), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(333), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(287), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(289), 20,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_and,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [3774] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
    ACTIONS(360), 1,
      anon_sym_DASH,
    ACTIONS(363), 1,
      anon_sym_LBRACE,
    ACTIONS(357), 2,
      anon_sym_LPAREN,
      anon_sym_STAR,
    ACTIONS(345), 6,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
    ACTIONS(193), 10,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(343), 12,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
    ACTIONS(195), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [3845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(365), 26,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [3904] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_in,
    ACTIONS(295), 1,
      anon_sym_DOT,
    ACTIONS(301), 1,
      anon_sym_SLASH,
    ACTIONS(305), 1,
      anon_sym_DASH,
    ACTIONS(307), 1,
      anon_sym_PLUS,
    ACTIONS(297), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(299), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(303), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(325), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(287), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(289), 22,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [3983] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_LPAREN,
    ACTIONS(295), 1,
      anon_sym_DOT,
    ACTIONS(287), 24,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_GT_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(289), 25,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_in,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [4046] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_in,
    ACTIONS(295), 1,
      anon_sym_DOT,
    ACTIONS(301), 1,
      anon_sym_SLASH,
    ACTIONS(305), 1,
      anon_sym_DASH,
    ACTIONS(307), 1,
      anon_sym_PLUS,
    ACTIONS(329), 1,
      anon_sym_and,
    ACTIONS(297), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(299), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(303), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(325), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(331), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(333), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(287), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(289), 19,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_BANG,
      anon_sym_or,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [4131] = 7,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(373), 1,
      anon_sym_elsif,
    ACTIONS(375), 1,
      anon_sym_else,
    STATE(150), 1,
      sym_else_statement,
    STATE(78), 2,
      sym_elsif_statement,
      aux_sym_if_statement_repeat1,
    ACTIONS(369), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(371), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [4185] = 7,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(373), 1,
      anon_sym_elsif,
    ACTIONS(375), 1,
      anon_sym_else,
    STATE(169), 1,
      sym_else_statement,
    STATE(76), 2,
      sym_elsif_statement,
      aux_sym_if_statement_repeat1,
    ACTIONS(377), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(379), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [4239] = 5,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(385), 1,
      anon_sym_elsif,
    STATE(78), 2,
      sym_elsif_statement,
      aux_sym_if_statement_repeat1,
    ACTIONS(381), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(383), 19,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_else,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [4288] = 22,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(390), 1,
      anon_sym_RBRACE,
    ACTIONS(392), 1,
      anon_sym_default,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(326), 1,
      sym_expression,
    STATE(587), 1,
      sym_default_case,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(98), 2,
      sym_case_item,
      aux_sym_case_statement_repeat1,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [4370] = 22,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(392), 1,
      anon_sym_default,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(406), 1,
      anon_sym_RBRACE,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(326), 1,
      sym_expression,
    STATE(571), 1,
      sym_default_case,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(79), 2,
      sym_case_item,
      aux_sym_case_statement_repeat1,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [4452] = 5,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(408), 1,
      anon_sym_COLON_COLON,
    STATE(82), 1,
      aux_sym_class_identifier_repeat1,
    ACTIONS(165), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(167), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [4500] = 5,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(408), 1,
      anon_sym_COLON_COLON,
    STATE(83), 1,
      aux_sym_class_identifier_repeat1,
    ACTIONS(171), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(173), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [4548] = 5,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(410), 1,
      anon_sym_COLON_COLON,
    STATE(83), 1,
      aux_sym_class_identifier_repeat1,
    ACTIONS(158), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(160), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [4596] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(279), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(281), 20,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [4639] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(413), 1,
      anon_sym_COLON_COLON,
    STATE(108), 1,
      aux_sym_class_identifier_repeat1,
    ACTIONS(173), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
    ACTIONS(171), 28,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [4686] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(415), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(417), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [4729] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(419), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(421), 20,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [4772] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(423), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(425), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [4815] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(427), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(429), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [4858] = 5,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(435), 1,
      anon_sym_COMMA,
    STATE(114), 1,
      aux_sym_include_statement_repeat1,
    ACTIONS(431), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(433), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [4905] = 5,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(441), 1,
      anon_sym_COMMA,
    STATE(115), 1,
      aux_sym_tag_statement_repeat1,
    ACTIONS(437), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(439), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [4952] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(158), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
      anon_sym_COLON_COLON,
    ACTIONS(160), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [4995] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(443), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(445), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [5038] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(447), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(449), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [5081] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(451), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(453), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [5124] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(455), 1,
      anon_sym_COLON_COLON,
    ACTIONS(187), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(189), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [5169] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(457), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(459), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [5212] = 21,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(461), 1,
      anon_sym_LBRACE,
    ACTIONS(464), 1,
      anon_sym_RBRACE,
    ACTIONS(466), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_default,
    ACTIONS(471), 1,
      anon_sym_LBRACK,
    ACTIONS(477), 1,
      anon_sym_DASH,
    ACTIONS(480), 1,
      anon_sym_DOLLAR,
    ACTIONS(489), 1,
      anon_sym_DQUOTE,
    ACTIONS(492), 1,
      anon_sym_SQUOTE,
    ACTIONS(498), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(326), 1,
      sym_expression,
    ACTIONS(474), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    ACTIONS(483), 2,
      sym_number,
      sym_undef,
    ACTIONS(486), 2,
      sym_float,
      sym_regex,
    ACTIONS(495), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(98), 2,
      sym_case_item,
      aux_sym_case_statement_repeat1,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [5291] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(501), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(503), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [5334] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(505), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(507), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [5377] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(509), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(511), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [5420] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(513), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(515), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [5463] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(413), 1,
      anon_sym_COLON_COLON,
    STATE(85), 1,
      aux_sym_class_identifier_repeat1,
    ACTIONS(167), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
    ACTIONS(165), 28,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [5510] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(517), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(519), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [5553] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(259), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(261), 20,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [5596] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(521), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(523), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [5639] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(525), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(527), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [5682] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      anon_sym_COLON_COLON,
    STATE(108), 1,
      aux_sym_class_identifier_repeat1,
    ACTIONS(160), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
    ACTIONS(158), 28,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [5729] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(532), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(534), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [5772] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(536), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(538), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [5815] = 5,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(544), 1,
      anon_sym_COMMA,
    STATE(111), 1,
      aux_sym_tag_statement_repeat1,
    ACTIONS(540), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(542), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [5862] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(547), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(549), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [5905] = 5,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(555), 1,
      anon_sym_COMMA,
    STATE(113), 1,
      aux_sym_include_statement_repeat1,
    ACTIONS(551), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(553), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [5952] = 5,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(435), 1,
      anon_sym_COMMA,
    STATE(113), 1,
      aux_sym_include_statement_repeat1,
    ACTIONS(558), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(560), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [5999] = 5,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(441), 1,
      anon_sym_COMMA,
    STATE(111), 1,
      aux_sym_tag_statement_repeat1,
    ACTIONS(562), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(564), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [6046] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(551), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(553), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [6088] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(540), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(542), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [6130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(160), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
    ACTIONS(158), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [6172] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(183), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(185), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [6214] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(206), 1,
      anon_sym_QMARK,
    ACTIONS(193), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(195), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [6258] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(566), 1,
      anon_sym_COLON_COLON,
    ACTIONS(189), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
    ACTIONS(187), 28,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [6302] = 5,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(455), 1,
      anon_sym_COLON_COLON,
    ACTIONS(568), 1,
      anon_sym_LBRACK,
    ACTIONS(525), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(527), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [6348] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(179), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(181), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [6390] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(365), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(367), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [6432] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(175), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(177), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [6474] = 24,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(45), 1,
      sym_undef,
    ACTIONS(47), 1,
      sym_float,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(570), 1,
      anon_sym_RBRACE,
    ACTIONS(572), 1,
      sym_number,
    ACTIONS(574), 1,
      sym_regex,
    ACTIONS(576), 1,
      sym_identifier,
    STATE(230), 1,
      sym_boolean,
    STATE(271), 1,
      sym_resource_reference,
    STATE(334), 1,
      sym_variable,
    STATE(341), 1,
      sym_string,
    STATE(361), 1,
      sym_expression,
    STATE(479), 1,
      sym_attribute,
    STATE(481), 1,
      sym__resource_block,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [6558] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(578), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(580), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [6599] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(582), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(584), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [6640] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(586), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(588), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [6681] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(590), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(592), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [6722] = 20,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(594), 1,
      anon_sym_RBRACE,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(361), 1,
      sym_expression,
    STATE(554), 1,
      sym__resource_block,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [6797] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(596), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(598), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [6838] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(600), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(602), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [6879] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(604), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(606), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [6920] = 20,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(608), 1,
      anon_sym_RBRACE,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(361), 1,
      sym_expression,
    STATE(554), 1,
      sym__resource_block,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [6995] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(610), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(612), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [7036] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(614), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(616), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [7077] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(618), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(620), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [7118] = 20,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(622), 1,
      anon_sym_RBRACE,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(361), 1,
      sym_expression,
    STATE(554), 1,
      sym__resource_block,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [7193] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(624), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(626), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [7234] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(628), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(630), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [7275] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(632), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(634), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [7316] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(636), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(638), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [7357] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(640), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(642), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [7398] = 20,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(271), 1,
      sym_resource_reference,
    STATE(304), 1,
      sym_variable,
    STATE(333), 1,
      sym_expression,
    STATE(482), 1,
      sym_selector,
    STATE(591), 1,
      sym_assignment,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [7473] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(644), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(646), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [7514] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(648), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(650), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [7555] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(652), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(654), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [7596] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(656), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(658), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [7637] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(660), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(662), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [7678] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(664), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(666), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [7719] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(668), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(670), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [7760] = 20,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(672), 1,
      anon_sym_RBRACE,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(361), 1,
      sym_expression,
    STATE(554), 1,
      sym__resource_block,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [7835] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(674), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(676), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [7876] = 20,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(678), 1,
      anon_sym_RBRACE,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(361), 1,
      sym_expression,
    STATE(554), 1,
      sym__resource_block,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [7951] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(680), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(682), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [7992] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(684), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(686), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [8033] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(688), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(690), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [8074] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(692), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(694), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [8115] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(279), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(281), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [8156] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(696), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(698), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [8197] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(700), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(702), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [8238] = 20,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(704), 1,
      anon_sym_RBRACE,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(361), 1,
      sym_expression,
    STATE(554), 1,
      sym__resource_block,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [8313] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(706), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(708), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [8354] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(259), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(261), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [8395] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(710), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(712), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [8436] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(714), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(716), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [8477] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(720), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [8520] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(369), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(371), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [8561] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(193), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(195), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [8602] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(724), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(726), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [8643] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(728), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(730), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [8684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(177), 4,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
    ACTIONS(175), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [8725] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(732), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(734), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [8766] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(736), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(738), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [8807] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(740), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(742), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [8848] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(744), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(746), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [8889] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(748), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(750), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [8930] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(756), 2,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
    ACTIONS(752), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(754), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [8973] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(758), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_TILDE_GT,
      anon_sym_AT_AT,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
    ACTIONS(760), 18,
      anon_sym_class,
      anon_sym_node,
      anon_sym_define,
      anon_sym_type,
      anon_sym_function,
      anon_sym_AT,
      anon_sym_require,
      anon_sym_include,
      anon_sym_tag,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_case,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
  [9014] = 20,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(762), 1,
      anon_sym_if,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(359), 1,
      sym_expression,
    STATE(596), 1,
      sym_if_statement,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [9089] = 19,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(764), 1,
      anon_sym_RPAREN,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(325), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [9161] = 19,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(766), 1,
      anon_sym_RPAREN,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(325), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [9233] = 19,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(768), 1,
      anon_sym_RBRACK,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(335), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [9305] = 19,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(770), 1,
      anon_sym_RPAREN,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(331), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [9377] = 19,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(772), 1,
      anon_sym_RBRACK,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(325), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [9449] = 19,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(774), 1,
      anon_sym_RPAREN,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(325), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [9521] = 19,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(361), 1,
      sym_expression,
    STATE(554), 1,
      sym__resource_block,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [9593] = 19,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(776), 1,
      anon_sym_RBRACK,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(325), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [9665] = 19,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(778), 1,
      anon_sym_RBRACK,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(325), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [9737] = 19,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(780), 1,
      anon_sym_RPAREN,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(325), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [9809] = 19,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(782), 1,
      anon_sym_RPAREN,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(325), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [9881] = 19,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(784), 1,
      anon_sym_RPAREN,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(327), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [9953] = 19,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(786), 1,
      anon_sym_RBRACK,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(329), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [10025] = 19,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(788), 1,
      anon_sym_RPAREN,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(325), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [10097] = 19,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(790), 1,
      anon_sym_RPAREN,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(332), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [10169] = 19,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(792), 1,
      anon_sym_RPAREN,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(325), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [10241] = 19,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(794), 1,
      anon_sym_RPAREN,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(325), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [10313] = 19,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(796), 1,
      anon_sym_RPAREN,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(328), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [10385] = 19,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(798), 1,
      anon_sym_RPAREN,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(330), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [10457] = 19,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(361), 1,
      sym_expression,
    STATE(511), 1,
      sym__resource_block,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [10529] = 19,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(800), 1,
      anon_sym_RPAREN,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(325), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [10601] = 19,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(802), 1,
      anon_sym_RBRACK,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(325), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [10673] = 19,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(361), 1,
      sym_expression,
    STATE(510), 1,
      sym__resource_block,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [10745] = 19,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(804), 1,
      anon_sym_RPAREN,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(325), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [10817] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(343), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [10886] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(808), 1,
      anon_sym_DASH,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(367), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(806), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [10955] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(808), 1,
      anon_sym_DASH,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(338), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(806), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [11024] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(41), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(358), 1,
      sym_expression,
    ACTIONS(39), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [11093] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(808), 1,
      anon_sym_DASH,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(363), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(806), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [11162] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(808), 1,
      anon_sym_DASH,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(345), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(806), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [11231] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(808), 1,
      anon_sym_DASH,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(364), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(806), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [11300] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(808), 1,
      anon_sym_DASH,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(365), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(806), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [11369] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(354), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [11438] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(808), 1,
      anon_sym_DASH,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(340), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(806), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [11507] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(808), 1,
      anon_sym_DASH,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(366), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(806), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [11576] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(808), 1,
      anon_sym_DASH,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(347), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(806), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [11645] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_LBRACE,
    ACTIONS(812), 1,
      anon_sym_PIPE,
    STATE(288), 1,
      sym_lambda,
    STATE(289), 1,
      sym_block,
    ACTIONS(241), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(239), 25,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [11692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 4,
      anon_sym_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(351), 27,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_GT_GT,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [11731] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(337), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [11800] = 18,
    ACTIONS(7), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DOLLAR,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(814), 1,
      anon_sym_LPAREN,
    ACTIONS(816), 1,
      anon_sym_LBRACK,
    ACTIONS(820), 1,
      anon_sym_DASH,
    ACTIONS(828), 1,
      sym_identifier,
    STATE(59), 1,
      sym_expression,
    STATE(62), 1,
      sym_resource_reference,
    STATE(63), 1,
      sym_variable,
    ACTIONS(818), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    ACTIONS(822), 2,
      sym_number,
      sym_undef,
    ACTIONS(824), 2,
      sym_float,
      sym_regex,
    ACTIONS(826), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(68), 2,
      sym_string,
      sym_boolean,
    STATE(65), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [11869] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(296), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [11938] = 18,
    ACTIONS(7), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DOLLAR,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(814), 1,
      anon_sym_LPAREN,
    ACTIONS(816), 1,
      anon_sym_LBRACK,
    ACTIONS(820), 1,
      anon_sym_DASH,
    ACTIONS(828), 1,
      sym_identifier,
    STATE(58), 1,
      sym_expression,
    STATE(62), 1,
      sym_resource_reference,
    STATE(63), 1,
      sym_variable,
    ACTIONS(818), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    ACTIONS(822), 2,
      sym_number,
      sym_undef,
    ACTIONS(824), 2,
      sym_float,
      sym_regex,
    ACTIONS(826), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(68), 2,
      sym_string,
      sym_boolean,
    STATE(65), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [12007] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(566), 1,
      anon_sym_COLON_COLON,
    ACTIONS(830), 1,
      anon_sym_LBRACK,
    ACTIONS(189), 3,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(187), 26,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [12050] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(808), 1,
      anon_sym_DASH,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(362), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(806), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [12119] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(360), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [12188] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(41), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(356), 1,
      sym_expression,
    ACTIONS(39), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [12257] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_LBRACE,
    ACTIONS(812), 1,
      anon_sym_PIPE,
    STATE(276), 1,
      sym_lambda,
    STATE(289), 1,
      sym_block,
    ACTIONS(237), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(235), 25,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [12304] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(298), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [12373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(345), 4,
      anon_sym_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(343), 27,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_GT_GT,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [12412] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(808), 1,
      anon_sym_DASH,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(346), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(806), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [12481] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(299), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [12550] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(300), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [12619] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(371), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [12688] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(41), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(355), 1,
      sym_expression,
    ACTIONS(39), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [12757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(261), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(259), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [12796] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(301), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [12865] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(41), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(373), 1,
      sym_expression,
    ACTIONS(39), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [12934] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(295), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [13003] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(41), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(349), 1,
      sym_expression,
    ACTIONS(39), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [13072] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(41), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(350), 1,
      sym_expression,
    ACTIONS(39), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [13141] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(294), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [13210] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(348), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [13279] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_LBRACE,
    ACTIONS(812), 1,
      anon_sym_PIPE,
    STATE(275), 1,
      sym_lambda,
    STATE(289), 1,
      sym_block,
    ACTIONS(233), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(231), 25,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [13326] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(302), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [13395] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(297), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [13464] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(303), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [13533] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(808), 1,
      anon_sym_DASH,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(374), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(806), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [13602] = 18,
    ACTIONS(7), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DOLLAR,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(814), 1,
      anon_sym_LPAREN,
    ACTIONS(816), 1,
      anon_sym_LBRACK,
    ACTIONS(820), 1,
      anon_sym_DASH,
    ACTIONS(828), 1,
      sym_identifier,
    STATE(54), 1,
      sym_expression,
    STATE(62), 1,
      sym_resource_reference,
    STATE(63), 1,
      sym_variable,
    ACTIONS(818), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    ACTIONS(822), 2,
      sym_number,
      sym_undef,
    ACTIONS(824), 2,
      sym_float,
      sym_regex,
    ACTIONS(826), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(68), 2,
      sym_string,
      sym_boolean,
    STATE(65), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [13671] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(808), 1,
      anon_sym_DASH,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(369), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(806), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [13740] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_LBRACE,
    ACTIONS(812), 1,
      anon_sym_PIPE,
    STATE(281), 1,
      sym_lambda,
    STATE(289), 1,
      sym_block,
    ACTIONS(223), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(221), 25,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [13787] = 18,
    ACTIONS(7), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DOLLAR,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(814), 1,
      anon_sym_LPAREN,
    ACTIONS(816), 1,
      anon_sym_LBRACK,
    ACTIONS(820), 1,
      anon_sym_DASH,
    ACTIONS(828), 1,
      sym_identifier,
    STATE(53), 1,
      sym_expression,
    STATE(62), 1,
      sym_resource_reference,
    STATE(63), 1,
      sym_variable,
    ACTIONS(818), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    ACTIONS(822), 2,
      sym_number,
      sym_undef,
    ACTIONS(824), 2,
      sym_float,
      sym_regex,
    ACTIONS(826), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(68), 2,
      sym_string,
      sym_boolean,
    STATE(65), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [13856] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(808), 1,
      anon_sym_DASH,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(344), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(806), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [13925] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(808), 1,
      anon_sym_DASH,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(368), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(806), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [13994] = 18,
    ACTIONS(7), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DOLLAR,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(814), 1,
      anon_sym_LPAREN,
    ACTIONS(816), 1,
      anon_sym_LBRACK,
    ACTIONS(820), 1,
      anon_sym_DASH,
    ACTIONS(828), 1,
      sym_identifier,
    STATE(62), 1,
      sym_resource_reference,
    STATE(63), 1,
      sym_variable,
    STATE(74), 1,
      sym_expression,
    ACTIONS(818), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    ACTIONS(822), 2,
      sym_number,
      sym_undef,
    ACTIONS(824), 2,
      sym_float,
      sym_regex,
    ACTIONS(826), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(68), 2,
      sym_string,
      sym_boolean,
    STATE(65), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [14063] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(41), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(351), 1,
      sym_expression,
    ACTIONS(39), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [14132] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(41), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(353), 1,
      sym_expression,
    ACTIONS(39), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [14201] = 18,
    ACTIONS(7), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DOLLAR,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(814), 1,
      anon_sym_LPAREN,
    ACTIONS(816), 1,
      anon_sym_LBRACK,
    ACTIONS(820), 1,
      anon_sym_DASH,
    ACTIONS(828), 1,
      sym_identifier,
    STATE(55), 1,
      sym_expression,
    STATE(62), 1,
      sym_resource_reference,
    STATE(63), 1,
      sym_variable,
    ACTIONS(818), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    ACTIONS(822), 2,
      sym_number,
      sym_undef,
    ACTIONS(824), 2,
      sym_float,
      sym_regex,
    ACTIONS(826), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(68), 2,
      sym_string,
      sym_boolean,
    STATE(65), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [14270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(281), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(279), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [14309] = 18,
    ACTIONS(7), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DOLLAR,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(814), 1,
      anon_sym_LPAREN,
    ACTIONS(816), 1,
      anon_sym_LBRACK,
    ACTIONS(820), 1,
      anon_sym_DASH,
    ACTIONS(828), 1,
      sym_identifier,
    STATE(52), 1,
      sym_expression,
    STATE(62), 1,
      sym_resource_reference,
    STATE(63), 1,
      sym_variable,
    ACTIONS(818), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    ACTIONS(822), 2,
      sym_number,
      sym_undef,
    ACTIONS(824), 2,
      sym_float,
      sym_regex,
    ACTIONS(826), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(68), 2,
      sym_string,
      sym_boolean,
    STATE(65), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [14378] = 18,
    ACTIONS(7), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DOLLAR,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(814), 1,
      anon_sym_LPAREN,
    ACTIONS(816), 1,
      anon_sym_LBRACK,
    ACTIONS(820), 1,
      anon_sym_DASH,
    ACTIONS(828), 1,
      sym_identifier,
    STATE(51), 1,
      sym_expression,
    STATE(62), 1,
      sym_resource_reference,
    STATE(63), 1,
      sym_variable,
    ACTIONS(818), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    ACTIONS(822), 2,
      sym_number,
      sym_undef,
    ACTIONS(824), 2,
      sym_float,
      sym_regex,
    ACTIONS(826), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(68), 2,
      sym_string,
      sym_boolean,
    STATE(65), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [14447] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_DASH,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(325), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(394), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [14516] = 18,
    ACTIONS(7), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DOLLAR,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(814), 1,
      anon_sym_LPAREN,
    ACTIONS(816), 1,
      anon_sym_LBRACK,
    ACTIONS(820), 1,
      anon_sym_DASH,
    ACTIONS(828), 1,
      sym_identifier,
    STATE(62), 1,
      sym_resource_reference,
    STATE(63), 1,
      sym_variable,
    STATE(75), 1,
      sym_expression,
    ACTIONS(818), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    ACTIONS(822), 2,
      sym_number,
      sym_undef,
    ACTIONS(824), 2,
      sym_float,
      sym_regex,
    ACTIONS(826), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(68), 2,
      sym_string,
      sym_boolean,
    STATE(65), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [14585] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(41), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(357), 1,
      sym_expression,
    ACTIONS(39), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [14654] = 18,
    ACTIONS(7), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DOLLAR,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(814), 1,
      anon_sym_LPAREN,
    ACTIONS(816), 1,
      anon_sym_LBRACK,
    ACTIONS(820), 1,
      anon_sym_DASH,
    ACTIONS(828), 1,
      sym_identifier,
    STATE(62), 1,
      sym_resource_reference,
    STATE(63), 1,
      sym_variable,
    STATE(70), 1,
      sym_expression,
    ACTIONS(818), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    ACTIONS(822), 2,
      sym_number,
      sym_undef,
    ACTIONS(824), 2,
      sym_float,
      sym_regex,
    ACTIONS(826), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(68), 2,
      sym_string,
      sym_boolean,
    STATE(65), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [14723] = 18,
    ACTIONS(7), 1,
      anon_sym_LBRACE,
    ACTIONS(43), 1,
      anon_sym_DOLLAR,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(814), 1,
      anon_sym_LPAREN,
    ACTIONS(816), 1,
      anon_sym_LBRACK,
    ACTIONS(820), 1,
      anon_sym_DASH,
    ACTIONS(828), 1,
      sym_identifier,
    STATE(62), 1,
      sym_resource_reference,
    STATE(63), 1,
      sym_variable,
    STATE(73), 1,
      sym_expression,
    ACTIONS(818), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    ACTIONS(822), 2,
      sym_number,
      sym_undef,
    ACTIONS(824), 2,
      sym_float,
      sym_regex,
    ACTIONS(826), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(68), 2,
      sym_string,
      sym_boolean,
    STATE(65), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [14792] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    ACTIONS(808), 1,
      anon_sym_DASH,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(372), 1,
      sym_expression,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(806), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [14861] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(37), 1,
      anon_sym_LBRACK,
    ACTIONS(41), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_DOLLAR,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      sym_identifier,
    STATE(269), 1,
      sym_variable,
    STATE(271), 1,
      sym_resource_reference,
    STATE(352), 1,
      sym_expression,
    ACTIONS(39), 2,
      anon_sym_BANG,
      anon_sym_STAR,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(230), 2,
      sym_string,
      sym_boolean,
    STATE(287), 10,
      sym_unary_expression,
      sym_binary_expression,
      sym_parenthesized_expression,
      sym_function_call,
      sym_field_expression,
      sym_array,
      sym_hash,
      sym_literal,
      sym__identifier,
      sym_class_identifier,
  [14930] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(830), 1,
      anon_sym_LBRACK,
    ACTIONS(213), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(204), 27,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [14970] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(181), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(179), 28,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [15008] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(830), 1,
      anon_sym_LBRACK,
    ACTIONS(345), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(343), 27,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [15048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(217), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(215), 28,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [15086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(185), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(183), 28,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [15124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(229), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(227), 28,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [15162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(237), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(235), 27,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [15199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(241), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(239), 27,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [15236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(277), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(275), 27,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [15273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(245), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(243), 27,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [15310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(309), 27,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [15347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(349), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(347), 27,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [15384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(233), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(231), 27,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [15421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(341), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(339), 27,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [15458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(257), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(255), 27,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [15495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(367), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(365), 27,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [15532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(251), 27,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [15569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(249), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(247), 27,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [15606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(213), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(204), 27,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [15643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(271), 27,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [15680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(285), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(283), 27,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [15717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(315), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(313), 27,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [15754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(265), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(263), 27,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [15791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(337), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(335), 27,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [15828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(269), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(267), 27,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [15865] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_in,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(289), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(834), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(836), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(840), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(838), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(287), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [15914] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_in,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(289), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(840), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(838), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(287), 17,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
  [15959] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_in,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(289), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(840), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(287), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [16002] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_in,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(848), 1,
      anon_sym_and,
    ACTIONS(834), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(836), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(840), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(846), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(850), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(852), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(838), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(287), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_or,
  [16057] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_in,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(834), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(836), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(840), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(846), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(850), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(852), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(838), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(287), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_or,
      anon_sym_and,
  [16110] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_in,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(289), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(834), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(836), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(840), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(846), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(838), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(287), 11,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [16161] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_in,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(289), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(287), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16202] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LPAREN,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(289), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(287), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
  [16241] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_in,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(289), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(836), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(840), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(838), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(287), 15,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
  [16288] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LPAREN,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(319), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(317), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
  [16327] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(206), 1,
      anon_sym_QMARK,
    ACTIONS(830), 1,
      anon_sym_LBRACK,
    ACTIONS(854), 1,
      anon_sym_EQ,
    ACTIONS(856), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(213), 3,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
    ACTIONS(204), 20,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [16370] = 12,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(858), 1,
      anon_sym_LBRACE,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(864), 1,
      anon_sym_DOLLAR,
    ACTIONS(866), 1,
      sym_number,
    ACTIONS(868), 1,
      sym_identifier,
    STATE(478), 1,
      sym_type,
    STATE(545), 1,
      sym_string,
    STATE(107), 5,
      sym_builtin_type,
      sym_composite_type,
      sym_attribute_type,
      sym_array_type,
      sym_class_identifier,
    ACTIONS(860), 12,
      anon_sym_Boolean,
      anon_sym_Integer,
      anon_sym_Float,
      anon_sym_String,
      anon_sym_Array,
      anon_sym_Hash,
      anon_sym_Regexp,
      anon_sym_Variant,
      anon_sym_Data,
      anon_sym_Undef,
      anon_sym_Default,
      anon_sym_File,
  [16422] = 12,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(858), 1,
      anon_sym_LBRACE,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(864), 1,
      anon_sym_DOLLAR,
    ACTIONS(868), 1,
      sym_identifier,
    ACTIONS(870), 1,
      anon_sym_RBRACK,
    STATE(513), 1,
      sym_type,
    STATE(561), 1,
      sym_string,
    STATE(107), 5,
      sym_builtin_type,
      sym_composite_type,
      sym_attribute_type,
      sym_array_type,
      sym_class_identifier,
    ACTIONS(860), 12,
      anon_sym_Boolean,
      anon_sym_Integer,
      anon_sym_Float,
      anon_sym_String,
      anon_sym_Array,
      anon_sym_Hash,
      anon_sym_Regexp,
      anon_sym_Variant,
      anon_sym_Data,
      anon_sym_Undef,
      anon_sym_Default,
      anon_sym_File,
  [16474] = 12,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(858), 1,
      anon_sym_LBRACE,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(864), 1,
      anon_sym_DOLLAR,
    ACTIONS(868), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_default,
    ACTIONS(874), 1,
      anon_sym_RBRACK,
    ACTIONS(876), 1,
      sym_number,
    STATE(459), 1,
      sym_type,
    STATE(484), 1,
      sym_default,
    STATE(107), 5,
      sym_builtin_type,
      sym_composite_type,
      sym_attribute_type,
      sym_array_type,
      sym_class_identifier,
    ACTIONS(860), 12,
      anon_sym_Boolean,
      anon_sym_Integer,
      anon_sym_Float,
      anon_sym_String,
      anon_sym_Array,
      anon_sym_Hash,
      anon_sym_Regexp,
      anon_sym_Variant,
      anon_sym_Data,
      anon_sym_Undef,
      anon_sym_Default,
      anon_sym_File,
  [16526] = 12,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(858), 1,
      anon_sym_LBRACE,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(864), 1,
      anon_sym_DOLLAR,
    ACTIONS(868), 1,
      sym_identifier,
    ACTIONS(878), 1,
      anon_sym_RBRACK,
    STATE(513), 1,
      sym_type,
    STATE(561), 1,
      sym_string,
    STATE(107), 5,
      sym_builtin_type,
      sym_composite_type,
      sym_attribute_type,
      sym_array_type,
      sym_class_identifier,
    ACTIONS(860), 12,
      anon_sym_Boolean,
      anon_sym_Integer,
      anon_sym_Float,
      anon_sym_String,
      anon_sym_Array,
      anon_sym_Hash,
      anon_sym_Regexp,
      anon_sym_Variant,
      anon_sym_Data,
      anon_sym_Undef,
      anon_sym_Default,
      anon_sym_File,
  [16578] = 11,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(858), 1,
      anon_sym_LBRACE,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(868), 1,
      sym_identifier,
    ACTIONS(880), 1,
      anon_sym_RPAREN,
    ACTIONS(882), 1,
      anon_sym_DOLLAR,
    STATE(496), 1,
      sym_parameter,
    STATE(499), 1,
      sym_type,
    STATE(501), 1,
      sym_variable,
    STATE(107), 5,
      sym_builtin_type,
      sym_composite_type,
      sym_attribute_type,
      sym_array_type,
      sym_class_identifier,
    ACTIONS(860), 12,
      anon_sym_Boolean,
      anon_sym_Integer,
      anon_sym_Float,
      anon_sym_String,
      anon_sym_Array,
      anon_sym_Hash,
      anon_sym_Regexp,
      anon_sym_Variant,
      anon_sym_Data,
      anon_sym_Undef,
      anon_sym_Default,
      anon_sym_File,
  [16627] = 11,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(858), 1,
      anon_sym_LBRACE,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(864), 1,
      anon_sym_DOLLAR,
    ACTIONS(868), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_default,
    ACTIONS(884), 1,
      sym_number,
    STATE(520), 1,
      sym_type,
    STATE(559), 1,
      sym_default,
    STATE(107), 5,
      sym_builtin_type,
      sym_composite_type,
      sym_attribute_type,
      sym_array_type,
      sym_class_identifier,
    ACTIONS(860), 12,
      anon_sym_Boolean,
      anon_sym_Integer,
      anon_sym_Float,
      anon_sym_String,
      anon_sym_Array,
      anon_sym_Hash,
      anon_sym_Regexp,
      anon_sym_Variant,
      anon_sym_Data,
      anon_sym_Undef,
      anon_sym_Default,
      anon_sym_File,
  [16676] = 11,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(858), 1,
      anon_sym_LBRACE,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(868), 1,
      sym_identifier,
    ACTIONS(882), 1,
      anon_sym_DOLLAR,
    ACTIONS(886), 1,
      anon_sym_RPAREN,
    STATE(499), 1,
      sym_type,
    STATE(501), 1,
      sym_variable,
    STATE(553), 1,
      sym_parameter,
    STATE(107), 5,
      sym_builtin_type,
      sym_composite_type,
      sym_attribute_type,
      sym_array_type,
      sym_class_identifier,
    ACTIONS(860), 12,
      anon_sym_Boolean,
      anon_sym_Integer,
      anon_sym_Float,
      anon_sym_String,
      anon_sym_Array,
      anon_sym_Hash,
      anon_sym_Regexp,
      anon_sym_Variant,
      anon_sym_Data,
      anon_sym_Undef,
      anon_sym_Default,
      anon_sym_File,
  [16725] = 11,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(858), 1,
      anon_sym_LBRACE,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(864), 1,
      anon_sym_DOLLAR,
    ACTIONS(868), 1,
      sym_identifier,
    STATE(447), 1,
      sym_type,
    STATE(488), 1,
      sym_string,
    STATE(107), 5,
      sym_builtin_type,
      sym_composite_type,
      sym_attribute_type,
      sym_array_type,
      sym_class_identifier,
    ACTIONS(860), 12,
      anon_sym_Boolean,
      anon_sym_Integer,
      anon_sym_Float,
      anon_sym_String,
      anon_sym_Array,
      anon_sym_Hash,
      anon_sym_Regexp,
      anon_sym_Variant,
      anon_sym_Data,
      anon_sym_Undef,
      anon_sym_Default,
      anon_sym_File,
  [16774] = 11,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(858), 1,
      anon_sym_LBRACE,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(868), 1,
      sym_identifier,
    ACTIONS(882), 1,
      anon_sym_DOLLAR,
    ACTIONS(888), 1,
      anon_sym_RPAREN,
    STATE(499), 1,
      sym_type,
    STATE(501), 1,
      sym_variable,
    STATE(553), 1,
      sym_parameter,
    STATE(107), 5,
      sym_builtin_type,
      sym_composite_type,
      sym_attribute_type,
      sym_array_type,
      sym_class_identifier,
    ACTIONS(860), 12,
      anon_sym_Boolean,
      anon_sym_Integer,
      anon_sym_Float,
      anon_sym_String,
      anon_sym_Array,
      anon_sym_Hash,
      anon_sym_Regexp,
      anon_sym_Variant,
      anon_sym_Data,
      anon_sym_Undef,
      anon_sym_Default,
      anon_sym_File,
  [16823] = 11,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(858), 1,
      anon_sym_LBRACE,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(864), 1,
      anon_sym_DOLLAR,
    ACTIONS(868), 1,
      sym_identifier,
    STATE(513), 1,
      sym_type,
    STATE(561), 1,
      sym_string,
    STATE(107), 5,
      sym_builtin_type,
      sym_composite_type,
      sym_attribute_type,
      sym_array_type,
      sym_class_identifier,
    ACTIONS(860), 12,
      anon_sym_Boolean,
      anon_sym_Integer,
      anon_sym_Float,
      anon_sym_String,
      anon_sym_Array,
      anon_sym_Hash,
      anon_sym_Regexp,
      anon_sym_Variant,
      anon_sym_Data,
      anon_sym_Undef,
      anon_sym_Default,
      anon_sym_File,
  [16872] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(812), 1,
      anon_sym_PIPE,
    STATE(281), 1,
      sym_lambda,
    STATE(289), 1,
      sym_block,
    ACTIONS(223), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(221), 19,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [16910] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_LBRACE,
    STATE(288), 1,
      sym_lambda,
    STATE(289), 1,
      sym_block,
    ACTIONS(241), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(239), 19,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [16948] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(812), 1,
      anon_sym_PIPE,
    STATE(288), 1,
      sym_lambda,
    STATE(289), 1,
      sym_block,
    ACTIONS(241), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(239), 19,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [16986] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(566), 1,
      anon_sym_COLON_COLON,
    ACTIONS(830), 1,
      anon_sym_LBRACK,
    ACTIONS(890), 1,
      anon_sym_EQ_GT,
    ACTIONS(189), 3,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(187), 18,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [17024] = 10,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(858), 1,
      anon_sym_LBRACE,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(868), 1,
      sym_identifier,
    ACTIONS(882), 1,
      anon_sym_DOLLAR,
    STATE(499), 1,
      sym_type,
    STATE(501), 1,
      sym_variable,
    STATE(553), 1,
      sym_parameter,
    STATE(107), 5,
      sym_builtin_type,
      sym_composite_type,
      sym_attribute_type,
      sym_array_type,
      sym_class_identifier,
    ACTIONS(860), 12,
      anon_sym_Boolean,
      anon_sym_Integer,
      anon_sym_Float,
      anon_sym_String,
      anon_sym_Array,
      anon_sym_Hash,
      anon_sym_Regexp,
      anon_sym_Variant,
      anon_sym_Data,
      anon_sym_Undef,
      anon_sym_Default,
      anon_sym_File,
  [17070] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(812), 1,
      anon_sym_PIPE,
    STATE(276), 1,
      sym_lambda,
    STATE(289), 1,
      sym_block,
    ACTIONS(237), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(235), 19,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [17108] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_LBRACE,
    STATE(275), 1,
      sym_lambda,
    STATE(289), 1,
      sym_block,
    ACTIONS(233), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(231), 19,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [17146] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(812), 1,
      anon_sym_PIPE,
    STATE(275), 1,
      sym_lambda,
    STATE(289), 1,
      sym_block,
    ACTIONS(233), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(231), 19,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [17184] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_LBRACE,
    STATE(281), 1,
      sym_lambda,
    STATE(289), 1,
      sym_block,
    ACTIONS(223), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(221), 19,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [17222] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_LBRACE,
    STATE(276), 1,
      sym_lambda,
    STATE(289), 1,
      sym_block,
    ACTIONS(237), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(235), 19,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [17260] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_in,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(848), 1,
      anon_sym_and,
    ACTIONS(894), 1,
      anon_sym_or,
    ACTIONS(834), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(836), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(840), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(846), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(850), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(852), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(838), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(892), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [17314] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_in,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(848), 1,
      anon_sym_and,
    ACTIONS(894), 1,
      anon_sym_or,
    ACTIONS(896), 1,
      anon_sym_COMMA,
    ACTIONS(898), 1,
      anon_sym_COLON,
    STATE(525), 1,
      aux_sym_case_item_repeat1,
    ACTIONS(834), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(836), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(840), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(846), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(850), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(852), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(838), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [17371] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_in,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(848), 1,
      anon_sym_and,
    ACTIONS(894), 1,
      anon_sym_or,
    ACTIONS(900), 1,
      anon_sym_COMMA,
    ACTIONS(902), 1,
      anon_sym_RPAREN,
    STATE(524), 1,
      aux_sym_case_item_repeat1,
    ACTIONS(834), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(836), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(840), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(846), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(850), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(852), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(838), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [17428] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_in,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(848), 1,
      anon_sym_and,
    ACTIONS(894), 1,
      anon_sym_or,
    ACTIONS(904), 1,
      anon_sym_COMMA,
    ACTIONS(906), 1,
      anon_sym_RPAREN,
    STATE(531), 1,
      aux_sym_case_item_repeat1,
    ACTIONS(834), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(836), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(840), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(846), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(850), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(852), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(838), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [17485] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_in,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(848), 1,
      anon_sym_and,
    ACTIONS(894), 1,
      anon_sym_or,
    ACTIONS(908), 1,
      anon_sym_COMMA,
    ACTIONS(910), 1,
      anon_sym_RBRACK,
    STATE(491), 1,
      aux_sym_case_item_repeat1,
    ACTIONS(834), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(836), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(840), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(846), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(850), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(852), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(838), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [17542] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_in,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(848), 1,
      anon_sym_and,
    ACTIONS(894), 1,
      anon_sym_or,
    ACTIONS(912), 1,
      anon_sym_COMMA,
    ACTIONS(914), 1,
      anon_sym_RPAREN,
    STATE(469), 1,
      aux_sym_case_item_repeat1,
    ACTIONS(834), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(836), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(840), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(846), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(850), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(852), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(838), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [17599] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_in,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(848), 1,
      anon_sym_and,
    ACTIONS(894), 1,
      anon_sym_or,
    ACTIONS(916), 1,
      anon_sym_COMMA,
    ACTIONS(918), 1,
      anon_sym_RPAREN,
    STATE(505), 1,
      aux_sym_case_item_repeat1,
    ACTIONS(834), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(836), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(840), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(846), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(850), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(852), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(838), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [17656] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_in,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(848), 1,
      anon_sym_and,
    ACTIONS(894), 1,
      anon_sym_or,
    ACTIONS(920), 1,
      anon_sym_COMMA,
    ACTIONS(922), 1,
      anon_sym_RPAREN,
    STATE(534), 1,
      aux_sym_case_item_repeat1,
    ACTIONS(834), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(836), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(840), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(846), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(850), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(852), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(838), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [17713] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_in,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(848), 1,
      anon_sym_and,
    ACTIONS(894), 1,
      anon_sym_or,
    ACTIONS(834), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(836), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(840), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(846), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(850), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(852), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(838), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(924), 3,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [17766] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(830), 1,
      anon_sym_LBRACK,
    ACTIONS(890), 1,
      anon_sym_EQ_GT,
    ACTIONS(213), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(204), 19,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [17801] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_in,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(848), 1,
      anon_sym_and,
    ACTIONS(894), 1,
      anon_sym_or,
    ACTIONS(926), 1,
      anon_sym_COMMA,
    ACTIONS(928), 1,
      anon_sym_RBRACK,
    STATE(497), 1,
      aux_sym_case_item_repeat1,
    ACTIONS(834), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(836), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(840), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(846), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(850), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(852), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(838), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [17858] = 8,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(858), 1,
      anon_sym_LBRACE,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(864), 1,
      anon_sym_DOLLAR,
    ACTIONS(868), 1,
      sym_identifier,
    STATE(536), 1,
      sym_type,
    STATE(107), 5,
      sym_builtin_type,
      sym_composite_type,
      sym_attribute_type,
      sym_array_type,
      sym_class_identifier,
    ACTIONS(860), 12,
      anon_sym_Boolean,
      anon_sym_Integer,
      anon_sym_Float,
      anon_sym_String,
      anon_sym_Array,
      anon_sym_Hash,
      anon_sym_Regexp,
      anon_sym_Variant,
      anon_sym_Data,
      anon_sym_Undef,
      anon_sym_Default,
      anon_sym_File,
  [17898] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_in,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(848), 1,
      anon_sym_and,
    ACTIONS(894), 1,
      anon_sym_or,
    ACTIONS(834), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(836), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(840), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(846), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(850), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(852), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(930), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(838), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [17950] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      anon_sym_LPAREN,
    ACTIONS(944), 1,
      anon_sym_or,
    ACTIONS(946), 1,
      anon_sym_and,
    ACTIONS(954), 1,
      anon_sym_in,
    STATE(87), 1,
      sym_block,
    ACTIONS(936), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(938), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(940), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(948), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(950), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(952), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(942), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18004] = 8,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(858), 1,
      anon_sym_LBRACE,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(956), 1,
      anon_sym_DOLLAR,
    ACTIONS(958), 1,
      sym_identifier,
    STATE(168), 1,
      sym_type,
    STATE(107), 5,
      sym_builtin_type,
      sym_composite_type,
      sym_attribute_type,
      sym_array_type,
      sym_class_identifier,
    ACTIONS(860), 12,
      anon_sym_Boolean,
      anon_sym_Integer,
      anon_sym_Float,
      anon_sym_String,
      anon_sym_Array,
      anon_sym_Hash,
      anon_sym_Regexp,
      anon_sym_Variant,
      anon_sym_Data,
      anon_sym_Undef,
      anon_sym_Default,
      anon_sym_File,
  [18044] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_LBRACE,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(934), 1,
      anon_sym_LPAREN,
    ACTIONS(944), 1,
      anon_sym_or,
    ACTIONS(946), 1,
      anon_sym_and,
    ACTIONS(954), 1,
      anon_sym_in,
    STATE(517), 1,
      sym_block,
    ACTIONS(936), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(938), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(940), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(948), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(950), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(952), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(942), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18098] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(890), 1,
      anon_sym_EQ_GT,
    ACTIONS(345), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(343), 19,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
      anon_sym_DOT,
  [18130] = 8,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(858), 1,
      anon_sym_LBRACE,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(864), 1,
      anon_sym_DOLLAR,
    ACTIONS(868), 1,
      sym_identifier,
    STATE(509), 1,
      sym_type,
    STATE(107), 5,
      sym_builtin_type,
      sym_composite_type,
      sym_attribute_type,
      sym_array_type,
      sym_class_identifier,
    ACTIONS(860), 12,
      anon_sym_Boolean,
      anon_sym_Integer,
      anon_sym_Float,
      anon_sym_String,
      anon_sym_Array,
      anon_sym_Hash,
      anon_sym_Regexp,
      anon_sym_Variant,
      anon_sym_Data,
      anon_sym_Undef,
      anon_sym_Default,
      anon_sym_File,
  [18170] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_in,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(848), 1,
      anon_sym_and,
    ACTIONS(894), 1,
      anon_sym_or,
    ACTIONS(834), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(836), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(840), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(846), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(850), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(852), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(960), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(838), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18222] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(934), 1,
      anon_sym_LPAREN,
    ACTIONS(944), 1,
      anon_sym_or,
    ACTIONS(946), 1,
      anon_sym_and,
    ACTIONS(954), 1,
      anon_sym_in,
    ACTIONS(962), 1,
      anon_sym_LBRACE,
    STATE(174), 1,
      sym_block,
    ACTIONS(936), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(938), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(940), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(948), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(950), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(952), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(942), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18276] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(934), 1,
      anon_sym_LPAREN,
    ACTIONS(944), 1,
      anon_sym_or,
    ACTIONS(946), 1,
      anon_sym_and,
    ACTIONS(954), 1,
      anon_sym_in,
    STATE(77), 1,
      sym_block,
    ACTIONS(936), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(938), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(940), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(948), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(950), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(952), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(942), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18330] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_LBRACE,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(934), 1,
      anon_sym_LPAREN,
    ACTIONS(944), 1,
      anon_sym_or,
    ACTIONS(946), 1,
      anon_sym_and,
    ACTIONS(954), 1,
      anon_sym_in,
    STATE(427), 1,
      sym_block,
    ACTIONS(936), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(938), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(940), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(948), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(950), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(952), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(942), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18384] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(934), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_in,
    ACTIONS(289), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(952), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(287), 14,
      anon_sym_LBRACE,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18421] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_in,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(848), 1,
      anon_sym_and,
    ACTIONS(894), 1,
      anon_sym_or,
    ACTIONS(964), 1,
      anon_sym_RPAREN,
    ACTIONS(834), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(836), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(840), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(846), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(850), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(852), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(838), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18472] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(966), 1,
      anon_sym_LPAREN,
    ACTIONS(974), 1,
      anon_sym_in,
    ACTIONS(289), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(968), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(972), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(287), 9,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
  [18513] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(966), 1,
      anon_sym_LPAREN,
    ACTIONS(974), 1,
      anon_sym_in,
    ACTIONS(289), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(968), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(972), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(976), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(287), 7,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [18556] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(966), 1,
      anon_sym_LPAREN,
    ACTIONS(974), 1,
      anon_sym_in,
    ACTIONS(289), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(972), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(287), 11,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
  [18595] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(966), 1,
      anon_sym_LPAREN,
    ACTIONS(974), 1,
      anon_sym_in,
    ACTIONS(289), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(972), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(287), 14,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18632] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(966), 1,
      anon_sym_LPAREN,
    ACTIONS(974), 1,
      anon_sym_in,
    ACTIONS(980), 1,
      anon_sym_and,
    ACTIONS(287), 2,
      anon_sym_PIPE,
      anon_sym_or,
    ACTIONS(968), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(972), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(976), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(978), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(982), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(984), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18681] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_in,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(848), 1,
      anon_sym_and,
    ACTIONS(894), 1,
      anon_sym_or,
    ACTIONS(986), 1,
      anon_sym_RPAREN,
    ACTIONS(834), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(836), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(840), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(846), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(850), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(852), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(838), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18732] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(966), 1,
      anon_sym_LPAREN,
    ACTIONS(974), 1,
      anon_sym_in,
    ACTIONS(968), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(972), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(976), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(978), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(982), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(984), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(287), 3,
      anon_sym_PIPE,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18779] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(966), 1,
      anon_sym_LPAREN,
    ACTIONS(974), 1,
      anon_sym_in,
    ACTIONS(289), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(968), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(972), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(976), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(978), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(287), 5,
      anon_sym_PIPE,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [18824] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(966), 1,
      anon_sym_LPAREN,
    ACTIONS(974), 1,
      anon_sym_in,
    ACTIONS(289), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(287), 16,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18859] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(966), 1,
      anon_sym_LPAREN,
    ACTIONS(289), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(287), 17,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
  [18892] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_in,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(848), 1,
      anon_sym_and,
    ACTIONS(894), 1,
      anon_sym_or,
    ACTIONS(988), 1,
      anon_sym_RBRACE,
    ACTIONS(834), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(836), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(840), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(846), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(850), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(852), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(838), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18943] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(321), 1,
      anon_sym_QMARK,
    ACTIONS(832), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_in,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(848), 1,
      anon_sym_and,
    ACTIONS(894), 1,
      anon_sym_or,
    ACTIONS(834), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(836), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(840), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(846), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(850), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(852), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(838), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18994] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_in,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(848), 1,
      anon_sym_and,
    ACTIONS(894), 1,
      anon_sym_or,
    ACTIONS(990), 1,
      anon_sym_COLON,
    ACTIONS(834), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(836), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(840), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(846), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(850), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(852), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(838), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [19045] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(934), 1,
      anon_sym_LPAREN,
    ACTIONS(289), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(287), 17,
      anon_sym_LBRACE,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
  [19078] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(934), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_in,
    ACTIONS(289), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(287), 16,
      anon_sym_LBRACE,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19113] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(934), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_in,
    ACTIONS(289), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(936), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(938), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(940), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(952), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(942), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(287), 5,
      anon_sym_LBRACE,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [19158] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(934), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_in,
    ACTIONS(936), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(938), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(940), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(948), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(950), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(952), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(287), 3,
      anon_sym_LBRACE,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(942), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [19205] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(934), 1,
      anon_sym_LPAREN,
    ACTIONS(946), 1,
      anon_sym_and,
    ACTIONS(954), 1,
      anon_sym_in,
    ACTIONS(287), 2,
      anon_sym_LBRACE,
      anon_sym_or,
    ACTIONS(936), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(938), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(940), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(948), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(950), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(952), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(942), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [19254] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(934), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_in,
    ACTIONS(289), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(952), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(942), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(287), 11,
      anon_sym_LBRACE,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
  [19293] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(934), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_in,
    ACTIONS(289), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(936), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(940), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(952), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(942), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(287), 7,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [19336] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(934), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_in,
    ACTIONS(289), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(940), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(952), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(942), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(287), 9,
      anon_sym_LBRACE,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
  [19377] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(974), 1,
      anon_sym_in,
    ACTIONS(980), 1,
      anon_sym_and,
    ACTIONS(992), 1,
      anon_sym_LPAREN,
    ACTIONS(994), 1,
      anon_sym_PIPE,
    ACTIONS(996), 1,
      anon_sym_or,
    ACTIONS(968), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(972), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(976), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(978), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(982), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(984), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [19428] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_in,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(848), 1,
      anon_sym_and,
    ACTIONS(894), 1,
      anon_sym_or,
    ACTIONS(998), 1,
      anon_sym_RPAREN,
    ACTIONS(834), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(836), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(840), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(846), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(850), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(852), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(838), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [19479] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(934), 1,
      anon_sym_LPAREN,
    ACTIONS(944), 1,
      anon_sym_or,
    ACTIONS(946), 1,
      anon_sym_and,
    ACTIONS(954), 1,
      anon_sym_in,
    ACTIONS(1000), 1,
      anon_sym_LBRACE,
    ACTIONS(936), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(938), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(940), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(948), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(950), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(952), 2,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(942), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [19530] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(966), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(317), 17,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
  [19563] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_DOT,
    ACTIONS(934), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(317), 17,
      anon_sym_LBRACE,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_in,
  [19596] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1004), 7,
      anon_sym_default,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(1002), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [19622] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(281), 7,
      anon_sym_default,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(279), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [19648] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1008), 7,
      anon_sym_default,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(1006), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [19674] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(261), 7,
      anon_sym_default,
      anon_sym_DASH,
      sym_number,
      anon_sym_true,
      anon_sym_false,
      sym_undef,
      sym_identifier,
    ACTIONS(259), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_BANG,
      anon_sym_STAR,
      anon_sym_DOLLAR,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex,
  [19700] = 12,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_DOLLAR,
    ACTIONS(1012), 1,
      sym_identifier,
    STATE(502), 1,
      sym_resource_reference,
    STATE(567), 1,
      sym_literal,
    STATE(578), 1,
      sym_variable,
    ACTIONS(45), 2,
      sym_number,
      sym_undef,
    ACTIONS(47), 2,
      sym_float,
      sym_regex,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(230), 2,
      sym_string,
      sym_boolean,
  [19741] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(189), 1,
      anon_sym_EQ,
    ACTIONS(191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(187), 9,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [19762] = 8,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_DOLLAR,
    STATE(483), 1,
      sym_attribute,
    ACTIONS(1014), 2,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    STATE(592), 2,
      sym_variable,
      sym_string,
    ACTIONS(1016), 3,
      sym_number,
      sym_regex,
      sym_identifier,
  [19791] = 8,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_DOLLAR,
    STATE(483), 1,
      sym_attribute,
    ACTIONS(1018), 2,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    STATE(592), 2,
      sym_variable,
      sym_string,
    ACTIONS(1016), 3,
      sym_number,
      sym_regex,
      sym_identifier,
  [19820] = 8,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_DOLLAR,
    STATE(464), 1,
      sym_attribute,
    ACTIONS(1020), 2,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    STATE(592), 2,
      sym_variable,
      sym_string,
    ACTIONS(1016), 3,
      sym_number,
      sym_regex,
      sym_identifier,
  [19849] = 7,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1022), 1,
      anon_sym_LPAREN,
    ACTIONS(1024), 1,
      anon_sym_DOLLAR,
    ACTIONS(1026), 1,
      anon_sym_DQUOTE,
    ACTIONS(1028), 1,
      anon_sym_SQUOTE,
    ACTIONS(1030), 1,
      sym_identifier,
    STATE(91), 5,
      sym_parenthesized_expression,
      sym_variable,
      sym_string,
      sym__identifier,
      sym_class_identifier,
  [19875] = 8,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_DOLLAR,
    ACTIONS(1032), 1,
      anon_sym_RBRACE,
    STATE(483), 1,
      sym_attribute,
    STATE(592), 2,
      sym_variable,
      sym_string,
    ACTIONS(1016), 3,
      sym_number,
      sym_regex,
      sym_identifier,
  [19903] = 8,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_DOLLAR,
    ACTIONS(1034), 1,
      anon_sym_RBRACE,
    STATE(483), 1,
      sym_attribute,
    STATE(592), 2,
      sym_variable,
      sym_string,
    ACTIONS(1016), 3,
      sym_number,
      sym_regex,
      sym_identifier,
  [19931] = 7,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1022), 1,
      anon_sym_LPAREN,
    ACTIONS(1024), 1,
      anon_sym_DOLLAR,
    ACTIONS(1026), 1,
      anon_sym_DQUOTE,
    ACTIONS(1028), 1,
      anon_sym_SQUOTE,
    ACTIONS(1030), 1,
      sym_identifier,
    STATE(117), 5,
      sym_parenthesized_expression,
      sym_variable,
      sym_string,
      sym__identifier,
      sym_class_identifier,
  [19957] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1036), 1,
      anon_sym_DOLLAR,
    ACTIONS(1038), 1,
      anon_sym_DQUOTE,
    ACTIONS(1040), 1,
      sym__double_string_content,
    ACTIONS(1044), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(1042), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(389), 4,
      sym_variable,
      sym__escape_sequence,
      sym_interpolation,
      aux_sym_string_repeat1,
  [19983] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1036), 1,
      anon_sym_DOLLAR,
    ACTIONS(1044), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(1046), 1,
      anon_sym_DQUOTE,
    ACTIONS(1048), 1,
      sym__double_string_content,
    ACTIONS(1050), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(403), 4,
      sym_variable,
      sym__escape_sequence,
      sym_interpolation,
      aux_sym_string_repeat1,
  [20009] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1036), 1,
      anon_sym_DOLLAR,
    ACTIONS(1044), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(1048), 1,
      sym__double_string_content,
    ACTIONS(1052), 1,
      anon_sym_DQUOTE,
    ACTIONS(1050), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(403), 4,
      sym_variable,
      sym__escape_sequence,
      sym_interpolation,
      aux_sym_string_repeat1,
  [20035] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1036), 1,
      anon_sym_DOLLAR,
    ACTIONS(1044), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(1054), 1,
      anon_sym_DQUOTE,
    ACTIONS(1056), 1,
      sym__double_string_content,
    ACTIONS(1058), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(401), 4,
      sym_variable,
      sym__escape_sequence,
      sym_interpolation,
      aux_sym_string_repeat1,
  [20061] = 8,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_DOLLAR,
    ACTIONS(1060), 1,
      anon_sym_RBRACE,
    STATE(483), 1,
      sym_attribute,
    STATE(592), 2,
      sym_variable,
      sym_string,
    ACTIONS(1016), 3,
      sym_number,
      sym_regex,
      sym_identifier,
  [20089] = 8,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_DOLLAR,
    ACTIONS(1062), 1,
      anon_sym_RBRACE,
    STATE(489), 1,
      sym_attribute,
    STATE(592), 2,
      sym_variable,
      sym_string,
    ACTIONS(1016), 3,
      sym_number,
      sym_regex,
      sym_identifier,
  [20117] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1036), 1,
      anon_sym_DOLLAR,
    ACTIONS(1044), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(1064), 1,
      anon_sym_DQUOTE,
    ACTIONS(1066), 1,
      sym__double_string_content,
    ACTIONS(1068), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(390), 4,
      sym_variable,
      sym__escape_sequence,
      sym_interpolation,
      aux_sym_string_repeat1,
  [20143] = 8,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_DOLLAR,
    ACTIONS(1070), 1,
      anon_sym_RBRACE,
    STATE(483), 1,
      sym_attribute,
    STATE(592), 2,
      sym_variable,
      sym_string,
    ACTIONS(1016), 3,
      sym_number,
      sym_regex,
      sym_identifier,
  [20171] = 8,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(570), 1,
      anon_sym_RBRACE,
    ACTIONS(1010), 1,
      anon_sym_DOLLAR,
    STATE(479), 1,
      sym_attribute,
    STATE(592), 2,
      sym_variable,
      sym_string,
    ACTIONS(1016), 3,
      sym_number,
      sym_regex,
      sym_identifier,
  [20199] = 8,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_DOLLAR,
    ACTIONS(1072), 1,
      anon_sym_RBRACE,
    STATE(483), 1,
      sym_attribute,
    STATE(592), 2,
      sym_variable,
      sym_string,
    ACTIONS(1016), 3,
      sym_number,
      sym_regex,
      sym_identifier,
  [20227] = 8,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_DOLLAR,
    ACTIONS(1074), 1,
      anon_sym_RBRACE,
    STATE(483), 1,
      sym_attribute,
    STATE(592), 2,
      sym_variable,
      sym_string,
    ACTIONS(1016), 3,
      sym_number,
      sym_regex,
      sym_identifier,
  [20255] = 8,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_DOLLAR,
    ACTIONS(1076), 1,
      anon_sym_RBRACE,
    STATE(521), 1,
      sym_attribute,
    STATE(592), 2,
      sym_variable,
      sym_string,
    ACTIONS(1016), 3,
      sym_number,
      sym_regex,
      sym_identifier,
  [20283] = 8,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_DOLLAR,
    ACTIONS(1078), 1,
      anon_sym_RBRACE,
    STATE(483), 1,
      sym_attribute,
    STATE(592), 2,
      sym_variable,
      sym_string,
    ACTIONS(1016), 3,
      sym_number,
      sym_regex,
      sym_identifier,
  [20311] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1036), 1,
      anon_sym_DOLLAR,
    ACTIONS(1044), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(1048), 1,
      sym__double_string_content,
    ACTIONS(1080), 1,
      anon_sym_DQUOTE,
    ACTIONS(1050), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(403), 4,
      sym_variable,
      sym__escape_sequence,
      sym_interpolation,
      aux_sym_string_repeat1,
  [20337] = 8,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_DOLLAR,
    ACTIONS(1082), 1,
      anon_sym_RBRACE,
    STATE(523), 1,
      sym_attribute,
    STATE(592), 2,
      sym_variable,
      sym_string,
    ACTIONS(1016), 3,
      sym_number,
      sym_regex,
      sym_identifier,
  [20365] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1084), 1,
      anon_sym_DOLLAR,
    ACTIONS(1087), 1,
      anon_sym_DQUOTE,
    ACTIONS(1089), 1,
      sym__double_string_content,
    ACTIONS(1095), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(1092), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(403), 4,
      sym_variable,
      sym__escape_sequence,
      sym_interpolation,
      aux_sym_string_repeat1,
  [20391] = 8,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_DOLLAR,
    ACTIONS(1098), 1,
      anon_sym_RBRACE,
    STATE(483), 1,
      sym_attribute,
    STATE(592), 2,
      sym_variable,
      sym_string,
    ACTIONS(1016), 3,
      sym_number,
      sym_regex,
      sym_identifier,
  [20419] = 7,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_DOLLAR,
    STATE(483), 1,
      sym_attribute,
    STATE(592), 2,
      sym_variable,
      sym_string,
    ACTIONS(1016), 3,
      sym_number,
      sym_regex,
      sym_identifier,
  [20444] = 6,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1024), 1,
      anon_sym_DOLLAR,
    ACTIONS(1026), 1,
      anon_sym_DQUOTE,
    ACTIONS(1028), 1,
      anon_sym_SQUOTE,
    ACTIONS(1030), 1,
      sym_identifier,
    STATE(116), 4,
      sym_variable,
      sym_string,
      sym__identifier,
      sym_class_identifier,
  [20466] = 6,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1024), 1,
      anon_sym_DOLLAR,
    ACTIONS(1026), 1,
      anon_sym_DQUOTE,
    ACTIONS(1028), 1,
      anon_sym_SQUOTE,
    ACTIONS(1030), 1,
      sym_identifier,
    STATE(90), 4,
      sym_variable,
      sym_string,
      sym__identifier,
      sym_class_identifier,
  [20488] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(171), 1,
      sym__double_string_content,
    ACTIONS(1100), 1,
      anon_sym_COLON_COLON,
    STATE(410), 1,
      aux_sym_class_identifier_repeat1,
    ACTIONS(173), 5,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
      anon_sym_DOLLAR_LBRACE,
  [20508] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(165), 1,
      sym__double_string_content,
    ACTIONS(1100), 1,
      anon_sym_COLON_COLON,
    STATE(408), 1,
      aux_sym_class_identifier_repeat1,
    ACTIONS(167), 5,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
      anon_sym_DOLLAR_LBRACE,
  [20528] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(158), 1,
      sym__double_string_content,
    ACTIONS(1102), 1,
      anon_sym_COLON_COLON,
    STATE(410), 1,
      aux_sym_class_identifier_repeat1,
    ACTIONS(160), 5,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
      anon_sym_DOLLAR_LBRACE,
  [20548] = 7,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(872), 1,
      anon_sym_default,
    ACTIONS(1105), 1,
      sym_identifier,
    STATE(457), 1,
      sym_node_name,
    STATE(565), 2,
      sym_string,
      sym_default,
  [20571] = 7,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(872), 1,
      anon_sym_default,
    ACTIONS(1105), 1,
      sym_identifier,
    STATE(562), 1,
      sym_node_name,
    STATE(565), 2,
      sym_string,
      sym_default,
  [20594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(158), 1,
      sym__double_string_content,
    ACTIONS(160), 6,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_COLON_COLON,
  [20609] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(568), 1,
      anon_sym_LBRACK,
    ACTIONS(525), 5,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
  [20626] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(187), 1,
      sym__double_string_content,
    ACTIONS(1107), 1,
      anon_sym_COLON_COLON,
    ACTIONS(189), 5,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
      anon_sym_DOLLAR_LBRACE,
  [20643] = 6,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(956), 1,
      anon_sym_DOLLAR,
    ACTIONS(1026), 1,
      anon_sym_DQUOTE,
    ACTIONS(1028), 1,
      anon_sym_SQUOTE,
    ACTIONS(1030), 1,
      sym_identifier,
    STATE(161), 3,
      sym_string,
      sym__identifier,
      sym_class_identifier,
  [20664] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1038), 1,
      anon_sym_SQUOTE,
    ACTIONS(1109), 1,
      sym__single_string_content,
    ACTIONS(1111), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(421), 2,
      sym__escape_sequence,
      aux_sym_string_repeat2,
  [20682] = 6,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_DOLLAR,
    ACTIONS(1113), 1,
      sym_identifier,
    STATE(498), 2,
      sym_variable,
      sym_string,
  [20702] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 1,
      anon_sym_SQUOTE,
    ACTIONS(1117), 1,
      sym__single_string_content,
    ACTIONS(1120), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(419), 2,
      sym__escape_sequence,
      aux_sym_string_repeat2,
  [20720] = 7,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1123), 1,
      anon_sym_RBRACE,
    ACTIONS(1125), 1,
      sym_identifier,
    STATE(530), 1,
      sym_attribute_type_entry,
    STATE(595), 1,
      sym_string,
  [20742] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1046), 1,
      anon_sym_SQUOTE,
    ACTIONS(1127), 1,
      sym__single_string_content,
    ACTIONS(1129), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(419), 2,
      sym__escape_sequence,
      aux_sym_string_repeat2,
  [20760] = 7,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1125), 1,
      sym_identifier,
    ACTIONS(1131), 1,
      anon_sym_RBRACE,
    STATE(541), 1,
      sym_attribute_type_entry,
    STATE(595), 1,
      sym_string,
  [20782] = 7,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1125), 1,
      sym_identifier,
    ACTIONS(1133), 1,
      anon_sym_RBRACE,
    STATE(541), 1,
      sym_attribute_type_entry,
    STATE(595), 1,
      sym_string,
  [20804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      sym__double_string_content,
    ACTIONS(177), 5,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
      anon_sym_DOLLAR_LBRACE,
  [20818] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1064), 1,
      anon_sym_SQUOTE,
    ACTIONS(1135), 1,
      sym__single_string_content,
    ACTIONS(1137), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(426), 2,
      sym__escape_sequence,
      aux_sym_string_repeat2,
  [20836] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1052), 1,
      anon_sym_SQUOTE,
    ACTIONS(1127), 1,
      sym__single_string_content,
    ACTIONS(1129), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(419), 2,
      sym__escape_sequence,
      aux_sym_string_repeat2,
  [20854] = 6,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(377), 1,
      anon_sym_RBRACE,
    ACTIONS(1139), 1,
      anon_sym_elsif,
    ACTIONS(1141), 1,
      anon_sym_else,
    STATE(169), 1,
      sym_else_statement,
    STATE(433), 2,
      sym_elsif_statement,
      aux_sym_if_statement_repeat1,
  [20874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1145), 1,
      sym__double_string_content,
    ACTIONS(1143), 5,
      anon_sym_DOLLAR,
      anon_sym_DQUOTE,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
      anon_sym_DOLLAR_LBRACE,
  [20888] = 6,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_DOLLAR,
    ACTIONS(1147), 1,
      sym_identifier,
    STATE(566), 2,
      sym_variable,
      sym_string,
  [20908] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1054), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      sym__single_string_content,
    ACTIONS(1151), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(432), 2,
      sym__escape_sequence,
      aux_sym_string_repeat2,
  [20926] = 6,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_DOLLAR,
    ACTIONS(1153), 1,
      sym_identifier,
    STATE(472), 2,
      sym_variable,
      sym_string,
  [20946] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1080), 1,
      anon_sym_SQUOTE,
    ACTIONS(1127), 1,
      sym__single_string_content,
    ACTIONS(1129), 2,
      aux_sym__escape_sequence_token1,
      sym_escape_sequence,
    STATE(419), 2,
      sym__escape_sequence,
      aux_sym_string_repeat2,
  [20964] = 6,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(369), 1,
      anon_sym_RBRACE,
    ACTIONS(1139), 1,
      anon_sym_elsif,
    ACTIONS(1141), 1,
      anon_sym_else,
    STATE(150), 1,
      sym_else_statement,
    STATE(440), 2,
      sym_elsif_statement,
      aux_sym_if_statement_repeat1,
  [20984] = 7,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(962), 1,
      anon_sym_LBRACE,
    ACTIONS(1155), 1,
      anon_sym_LPAREN,
    ACTIONS(1157), 1,
      anon_sym_inherits,
    STATE(148), 1,
      sym_block,
    STATE(448), 1,
      sym_parameter_list,
    STATE(550), 1,
      sym_class_inherits,
  [21006] = 5,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(864), 1,
      anon_sym_DOLLAR,
    ACTIONS(1159), 1,
      sym_identifier,
    STATE(19), 2,
      sym__identifier,
      sym_class_identifier,
  [21023] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1161), 1,
      anon_sym_COLON_COLON,
    STATE(436), 1,
      aux_sym_class_identifier_repeat1,
    ACTIONS(158), 3,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_inherits,
  [21038] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1164), 1,
      anon_sym_COLON_COLON,
    STATE(436), 1,
      aux_sym_class_identifier_repeat1,
    ACTIONS(171), 3,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_inherits,
  [21053] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1164), 1,
      anon_sym_COLON_COLON,
    STATE(437), 1,
      aux_sym_class_identifier_repeat1,
    ACTIONS(165), 3,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_inherits,
  [21068] = 5,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(566), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1166), 1,
      anon_sym_DOLLAR,
    ACTIONS(1168), 1,
      sym_identifier,
    STATE(173), 2,
      sym__identifier,
      sym_class_identifier,
  [21085] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1170), 1,
      anon_sym_elsif,
    ACTIONS(381), 2,
      anon_sym_RBRACE,
      anon_sym_else,
    STATE(440), 2,
      sym_elsif_statement,
      aux_sym_if_statement_repeat1,
  [21100] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_COMMA,
    STATE(441), 1,
      aux_sym_case_item_repeat1,
    ACTIONS(892), 3,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [21115] = 6,
    ACTIONS(49), 1,
      anon_sym_DQUOTE,
    ACTIONS(51), 1,
      anon_sym_SQUOTE,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1125), 1,
      sym_identifier,
    STATE(541), 1,
      sym_attribute_type_entry,
    STATE(595), 1,
      sym_string,
  [21134] = 5,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(191), 1,
      anon_sym_COLON_COLON,
    ACTIONS(864), 1,
      anon_sym_DOLLAR,
    ACTIONS(1176), 1,
      sym_identifier,
    STATE(19), 2,
      sym__identifier,
      sym_class_identifier,
  [21151] = 5,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(455), 1,
      anon_sym_COLON_COLON,
    ACTIONS(956), 1,
      anon_sym_DOLLAR,
    ACTIONS(1030), 1,
      sym_identifier,
    STATE(125), 2,
      sym__identifier,
      sym_class_identifier,
  [21168] = 6,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(962), 1,
      anon_sym_LBRACE,
    ACTIONS(1155), 1,
      anon_sym_LPAREN,
    ACTIONS(1178), 1,
      anon_sym_GT_GT,
    STATE(178), 1,
      sym_block,
    STATE(512), 1,
      sym_parameter_list,
  [21187] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(864), 1,
      anon_sym_DOLLAR,
    ACTIONS(1159), 1,
      sym_identifier,
    STATE(589), 2,
      sym__identifier,
      sym_class_identifier,
  [21201] = 5,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_LBRACK,
    ACTIONS(1180), 1,
      anon_sym_COMMA,
    ACTIONS(1182), 1,
      anon_sym_RBRACK,
    STATE(475), 1,
      aux_sym_composite_type_repeat1,
  [21217] = 5,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(962), 1,
      anon_sym_LBRACE,
    ACTIONS(1157), 1,
      anon_sym_inherits,
    STATE(177), 1,
      sym_block,
    STATE(560), 1,
      sym_class_inherits,
  [21233] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1186), 1,
      anon_sym_COMMA,
    STATE(449), 1,
      aux_sym__resource_block_repeat1,
    ACTIONS(1184), 2,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [21247] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(864), 1,
      anon_sym_DOLLAR,
    ACTIONS(1159), 1,
      sym_identifier,
    STATE(445), 2,
      sym__identifier,
      sym_class_identifier,
  [21261] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(864), 1,
      anon_sym_DOLLAR,
    ACTIONS(1159), 1,
      sym_identifier,
    STATE(580), 2,
      sym__identifier,
      sym_class_identifier,
  [21275] = 5,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(962), 1,
      anon_sym_LBRACE,
    ACTIONS(1189), 1,
      anon_sym_COMMA,
    STATE(180), 1,
      sym_block,
    STATE(507), 1,
      aux_sym_node_definition_repeat1,
  [21291] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(158), 4,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_inherits,
      anon_sym_COLON_COLON,
  [21301] = 5,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(962), 1,
      anon_sym_LBRACE,
    ACTIONS(1155), 1,
      anon_sym_LPAREN,
    STATE(176), 1,
      sym_block,
    STATE(555), 1,
      sym_parameter_list,
  [21317] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(864), 1,
      anon_sym_DOLLAR,
    ACTIONS(1159), 1,
      sym_identifier,
    STATE(579), 2,
      sym__identifier,
      sym_class_identifier,
  [21331] = 5,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1191), 1,
      anon_sym_PIPE_GT_GT,
    ACTIONS(1193), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1195), 1,
      sym_identifier,
    STATE(540), 1,
      sym_search_expression,
  [21347] = 5,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(962), 1,
      anon_sym_LBRACE,
    ACTIONS(1189), 1,
      anon_sym_COMMA,
    STATE(162), 1,
      sym_block,
    STATE(452), 1,
      aux_sym_node_definition_repeat1,
  [21363] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1166), 1,
      anon_sym_DOLLAR,
    ACTIONS(1168), 1,
      sym_identifier,
    STATE(280), 2,
      sym__identifier,
      sym_class_identifier,
  [21377] = 5,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_LBRACK,
    ACTIONS(1197), 1,
      anon_sym_COMMA,
    ACTIONS(1199), 1,
      anon_sym_RBRACK,
    STATE(473), 1,
      aux_sym_array_type_repeat1,
  [21393] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(864), 1,
      anon_sym_DOLLAR,
    ACTIONS(1176), 1,
      sym_identifier,
    STATE(64), 2,
      sym__identifier,
      sym_class_identifier,
  [21407] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1201), 1,
      anon_sym_DOLLAR,
    ACTIONS(1203), 1,
      sym_identifier,
    STATE(424), 2,
      sym__identifier,
      sym_class_identifier,
  [21421] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(864), 1,
      anon_sym_DOLLAR,
    ACTIONS(1159), 1,
      sym_identifier,
    STATE(572), 2,
      sym__identifier,
      sym_class_identifier,
  [21435] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(864), 1,
      anon_sym_DOLLAR,
    ACTIONS(1159), 1,
      sym_identifier,
    STATE(454), 2,
      sym__identifier,
      sym_class_identifier,
  [21449] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1207), 1,
      anon_sym_COMMA,
    STATE(467), 1,
      aux_sym__resource_block_repeat1,
    ACTIONS(1205), 2,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [21463] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(864), 1,
      anon_sym_DOLLAR,
    ACTIONS(1159), 1,
      sym_identifier,
    STATE(19), 2,
      sym__identifier,
      sym_class_identifier,
  [21477] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1209), 1,
      anon_sym_COLON_COLON,
    ACTIONS(187), 3,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_inherits,
  [21489] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1211), 1,
      anon_sym_COMMA,
    STATE(449), 1,
      aux_sym__resource_block_repeat1,
    ACTIONS(1018), 2,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [21503] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1213), 1,
      anon_sym_DOLLAR,
    ACTIONS(1215), 1,
      sym_identifier,
    STATE(434), 2,
      sym__identifier,
      sym_class_identifier,
  [21517] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(766), 1,
      anon_sym_RPAREN,
    ACTIONS(1217), 1,
      anon_sym_COMMA,
    STATE(441), 1,
      aux_sym_case_item_repeat1,
  [21530] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1070), 1,
      anon_sym_RBRACE,
    ACTIONS(1219), 1,
      anon_sym_COMMA,
    STATE(449), 1,
      aux_sym__resource_block_repeat1,
  [21543] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_DOLLAR,
    ACTIONS(1221), 1,
      anon_sym_PIPE,
    STATE(477), 1,
      sym_variable,
  [21556] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1223), 1,
      anon_sym_COMMA,
    ACTIONS(1225), 1,
      anon_sym_RBRACK,
    STATE(519), 1,
      aux_sym_resource_reference_repeat1,
  [21569] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1197), 1,
      anon_sym_COMMA,
    ACTIONS(1227), 1,
      anon_sym_RBRACK,
    STATE(526), 1,
      aux_sym_array_type_repeat1,
  [21582] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1229), 3,
      anon_sym_LBRACE,
      anon_sym_inherits,
      anon_sym_GT_GT,
  [21591] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(878), 1,
      anon_sym_RBRACK,
    ACTIONS(1231), 1,
      anon_sym_COMMA,
    STATE(518), 1,
      aux_sym_composite_type_repeat1,
  [21604] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1233), 1,
      anon_sym_RBRACE,
    ACTIONS(1235), 1,
      anon_sym_COMMA,
    STATE(476), 1,
      aux_sym_attribute_type_repeat1,
  [21617] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_COMMA,
    ACTIONS(1240), 1,
      anon_sym_PIPE,
    STATE(527), 1,
      aux_sym_lambda_repeat1,
  [21630] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_LBRACK,
    ACTIONS(1242), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [21641] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_RBRACE,
    ACTIONS(1246), 1,
      anon_sym_COMMA,
    STATE(528), 1,
      aux_sym__resource_block_repeat1,
  [21654] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_COMMA,
    ACTIONS(1248), 1,
      anon_sym_PIPE,
    STATE(495), 1,
      aux_sym_lambda_repeat1,
  [21667] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_RBRACE,
    ACTIONS(1252), 1,
      anon_sym_SEMI,
    STATE(529), 1,
      aux_sym_resource_declaration_repeat1,
  [21680] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(924), 3,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [21689] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1184), 3,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [21698] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1197), 1,
      anon_sym_COMMA,
    ACTIONS(1199), 1,
      anon_sym_RBRACK,
    STATE(473), 1,
      aux_sym_array_type_repeat1,
  [21711] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1254), 1,
      anon_sym_COMMA,
    ACTIONS(1257), 1,
      anon_sym_RPAREN,
    STATE(485), 1,
      aux_sym_parameter_list_repeat1,
  [21724] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1259), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [21733] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1261), 3,
      anon_sym_LBRACE,
      anon_sym_inherits,
      anon_sym_GT_GT,
  [21742] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1180), 1,
      anon_sym_COMMA,
    ACTIONS(1182), 1,
      anon_sym_RBRACK,
    STATE(475), 1,
      aux_sym_composite_type_repeat1,
  [21755] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1263), 1,
      anon_sym_RBRACE,
    ACTIONS(1265), 1,
      anon_sym_COMMA,
    STATE(494), 1,
      aux_sym__resource_block_repeat1,
  [21768] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1133), 1,
      anon_sym_RBRACE,
    ACTIONS(1267), 1,
      anon_sym_COMMA,
    STATE(476), 1,
      aux_sym_attribute_type_repeat1,
  [21781] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(776), 1,
      anon_sym_RBRACK,
    ACTIONS(1269), 1,
      anon_sym_COMMA,
    STATE(441), 1,
      aux_sym_case_item_repeat1,
  [21794] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1271), 1,
      anon_sym_RBRACE,
    ACTIONS(1273), 1,
      anon_sym_SEMI,
    STATE(492), 1,
      aux_sym_resource_declaration_repeat1,
  [21807] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1276), 3,
      anon_sym_LBRACE,
      anon_sym_inherits,
      anon_sym_GT_GT,
  [21816] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1072), 1,
      anon_sym_RBRACE,
    ACTIONS(1278), 1,
      anon_sym_COMMA,
    STATE(449), 1,
      aux_sym__resource_block_repeat1,
  [21829] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1280), 1,
      anon_sym_COMMA,
    ACTIONS(1283), 1,
      anon_sym_PIPE,
    STATE(495), 1,
      aux_sym_lambda_repeat1,
  [21842] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1285), 1,
      anon_sym_COMMA,
    ACTIONS(1287), 1,
      anon_sym_RPAREN,
    STATE(504), 1,
      aux_sym_parameter_list_repeat1,
  [21855] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(772), 1,
      anon_sym_RBRACK,
    ACTIONS(1289), 1,
      anon_sym_COMMA,
    STATE(441), 1,
      aux_sym_case_item_repeat1,
  [21868] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1223), 1,
      anon_sym_COMMA,
    ACTIONS(1291), 1,
      anon_sym_RBRACK,
    STATE(503), 1,
      aux_sym_resource_reference_repeat1,
  [21881] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_LBRACK,
    ACTIONS(1010), 1,
      anon_sym_DOLLAR,
    STATE(537), 1,
      sym_variable,
  [21894] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_COMMA,
    ACTIONS(1293), 1,
      anon_sym_PIPE,
    STATE(480), 1,
      aux_sym_lambda_repeat1,
  [21907] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1297), 1,
      anon_sym_EQ,
    ACTIONS(1295), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [21918] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
    ACTIONS(343), 1,
      anon_sym_PIPE_GT_GT,
    ACTIONS(345), 1,
      anon_sym_PIPE_GT,
  [21931] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1223), 1,
      anon_sym_COMMA,
    ACTIONS(1299), 1,
      anon_sym_RBRACK,
    STATE(508), 1,
      aux_sym_resource_reference_repeat1,
  [21944] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(888), 1,
      anon_sym_RPAREN,
    ACTIONS(1301), 1,
      anon_sym_COMMA,
    STATE(485), 1,
      aux_sym_parameter_list_repeat1,
  [21957] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(780), 1,
      anon_sym_RPAREN,
    ACTIONS(1303), 1,
      anon_sym_COMMA,
    STATE(441), 1,
      aux_sym_case_item_repeat1,
  [21970] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1034), 1,
      anon_sym_RBRACE,
    ACTIONS(1305), 1,
      anon_sym_COMMA,
    STATE(449), 1,
      aux_sym__resource_block_repeat1,
  [21983] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1307), 1,
      anon_sym_LBRACE,
    ACTIONS(1309), 1,
      anon_sym_COMMA,
    STATE(507), 1,
      aux_sym_node_definition_repeat1,
  [21996] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1312), 1,
      anon_sym_COMMA,
    ACTIONS(1315), 1,
      anon_sym_RBRACK,
    STATE(508), 1,
      aux_sym_resource_reference_repeat1,
  [22009] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_LBRACK,
    ACTIONS(962), 1,
      anon_sym_LBRACE,
    STATE(157), 1,
      sym_block,
  [22022] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1317), 1,
      anon_sym_RBRACE,
    ACTIONS(1319), 1,
      anon_sym_SEMI,
    STATE(535), 1,
      aux_sym_resource_declaration_repeat1,
  [22035] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1321), 1,
      anon_sym_RBRACE,
    ACTIONS(1323), 1,
      anon_sym_SEMI,
    STATE(533), 1,
      aux_sym_resource_declaration_repeat1,
  [22048] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(962), 1,
      anon_sym_LBRACE,
    ACTIONS(1325), 1,
      anon_sym_GT_GT,
    STATE(171), 1,
      sym_block,
  [22061] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_LBRACK,
    ACTIONS(1327), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [22072] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_COMMA,
    ACTIONS(1329), 1,
      anon_sym_PIPE,
    STATE(495), 1,
      aux_sym_lambda_repeat1,
  [22085] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_COMMA,
    ACTIONS(1331), 1,
      anon_sym_PIPE,
    STATE(514), 1,
      aux_sym_lambda_repeat1,
  [22098] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_DOLLAR,
    ACTIONS(1333), 1,
      anon_sym_PIPE,
    STATE(515), 1,
      sym_variable,
  [22111] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(419), 3,
      anon_sym_RBRACE,
      anon_sym_elsif,
      anon_sym_else,
  [22120] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1327), 1,
      anon_sym_RBRACK,
    ACTIONS(1335), 1,
      anon_sym_COMMA,
    STATE(518), 1,
      aux_sym_composite_type_repeat1,
  [22133] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1223), 1,
      anon_sym_COMMA,
    ACTIONS(1338), 1,
      anon_sym_RBRACK,
    STATE(508), 1,
      aux_sym_resource_reference_repeat1,
  [22146] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_LBRACK,
    ACTIONS(1340), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [22157] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1342), 1,
      anon_sym_RBRACE,
    ACTIONS(1344), 1,
      anon_sym_COMMA,
    STATE(470), 1,
      aux_sym__resource_block_repeat1,
  [22170] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_DOLLAR,
    ACTIONS(1346), 1,
      anon_sym_PIPE,
    STATE(500), 1,
      sym_variable,
  [22183] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1348), 1,
      anon_sym_RBRACE,
    ACTIONS(1350), 1,
      anon_sym_COMMA,
    STATE(506), 1,
      aux_sym__resource_block_repeat1,
  [22196] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_RPAREN,
    ACTIONS(1352), 1,
      anon_sym_COMMA,
    STATE(441), 1,
      aux_sym_case_item_repeat1,
  [22209] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(896), 1,
      anon_sym_COMMA,
    ACTIONS(1354), 1,
      anon_sym_COLON,
    STATE(441), 1,
      aux_sym_case_item_repeat1,
  [22222] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1340), 1,
      anon_sym_RBRACK,
    ACTIONS(1356), 1,
      anon_sym_COMMA,
    STATE(526), 1,
      aux_sym_array_type_repeat1,
  [22235] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1238), 1,
      anon_sym_COMMA,
    ACTIONS(1359), 1,
      anon_sym_PIPE,
    STATE(495), 1,
      aux_sym_lambda_repeat1,
  [22248] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1060), 1,
      anon_sym_RBRACE,
    ACTIONS(1361), 1,
      anon_sym_COMMA,
    STATE(449), 1,
      aux_sym__resource_block_repeat1,
  [22261] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1363), 1,
      anon_sym_RBRACE,
    ACTIONS(1365), 1,
      anon_sym_SEMI,
    STATE(492), 1,
      aux_sym_resource_declaration_repeat1,
  [22274] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1367), 1,
      anon_sym_RBRACE,
    ACTIONS(1369), 1,
      anon_sym_COMMA,
    STATE(490), 1,
      aux_sym_attribute_type_repeat1,
  [22287] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(804), 1,
      anon_sym_RPAREN,
    ACTIONS(1371), 1,
      anon_sym_COMMA,
    STATE(441), 1,
      aux_sym_case_item_repeat1,
  [22300] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1373), 3,
      anon_sym_LBRACE,
      anon_sym_inherits,
      anon_sym_GT_GT,
  [22309] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1375), 1,
      anon_sym_RBRACE,
    ACTIONS(1377), 1,
      anon_sym_SEMI,
    STATE(492), 1,
      aux_sym_resource_declaration_repeat1,
  [22322] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(792), 1,
      anon_sym_RPAREN,
    ACTIONS(1379), 1,
      anon_sym_COMMA,
    STATE(441), 1,
      aux_sym_case_item_repeat1,
  [22335] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1381), 1,
      anon_sym_RBRACE,
    ACTIONS(1383), 1,
      anon_sym_SEMI,
    STATE(492), 1,
      aux_sym_resource_declaration_repeat1,
  [22348] = 4,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_LBRACK,
    ACTIONS(962), 1,
      anon_sym_LBRACE,
    STATE(138), 1,
      sym_block,
  [22361] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1387), 1,
      anon_sym_EQ,
    ACTIONS(1385), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [22372] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1389), 1,
      anon_sym_LBRACE,
    STATE(42), 1,
      sym_block,
  [22382] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(962), 1,
      anon_sym_LBRACE,
    STATE(151), 1,
      sym_block,
  [22392] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1391), 1,
      anon_sym_PIPE_GT_GT,
    ACTIONS(1393), 1,
      anon_sym_PIPE_GT,
  [22402] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1233), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [22410] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1389), 1,
      anon_sym_LBRACE,
    STATE(47), 1,
      sym_block,
  [22420] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(962), 1,
      anon_sym_LBRACE,
    STATE(167), 1,
      sym_block,
  [22430] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1395), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [22438] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1242), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [22446] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(962), 1,
      anon_sym_LBRACE,
    STATE(570), 1,
      sym_block,
  [22456] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1389), 1,
      anon_sym_LBRACE,
    STATE(44), 1,
      sym_block,
  [22466] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1397), 1,
      anon_sym_LBRACE,
    STATE(375), 1,
      sym_block,
  [22476] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1397), 1,
      anon_sym_LBRACE,
    STATE(377), 1,
      sym_block,
  [22486] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(962), 1,
      anon_sym_LBRACE,
    STATE(177), 1,
      sym_block,
  [22496] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(962), 1,
      anon_sym_LBRACE,
    STATE(144), 1,
      sym_block,
  [22506] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_DOLLAR,
    STATE(557), 1,
      sym_variable,
  [22516] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1257), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [22524] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1399), 2,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [22532] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(962), 1,
      anon_sym_LBRACE,
    STATE(128), 1,
      sym_block,
  [22542] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(962), 1,
      anon_sym_LBRACE,
    STATE(143), 1,
      sym_block,
  [22552] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1283), 2,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [22560] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_LBRACE,
    STATE(291), 1,
      sym_block,
  [22570] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1340), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [22578] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(962), 1,
      anon_sym_LBRACE,
    STATE(158), 1,
      sym_block,
  [22588] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1327), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [22596] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1307), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
  [22604] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_LBRACE,
    STATE(293), 1,
      sym_block,
  [22614] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_LBRACE,
    STATE(277), 1,
      sym_block,
  [22624] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1401), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
  [22632] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1315), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [22640] = 3,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1403), 1,
      anon_sym_PIPE_GT_GT,
    ACTIONS(1405), 1,
      anon_sym_PIPE_GT,
  [22650] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1407), 1,
      sym_identifier,
  [22657] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1409), 1,
      ts_builtin_sym_end,
  [22664] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1411), 1,
      anon_sym_RBRACE,
  [22671] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(390), 1,
      anon_sym_RBRACE,
  [22678] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1413), 1,
      anon_sym_LBRACE,
  [22685] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(455), 1,
      anon_sym_COLON_COLON,
  [22692] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1415), 1,
      sym_identifier,
  [22699] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1417), 1,
      sym_identifier,
  [22706] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(566), 1,
      anon_sym_COLON_COLON,
  [22713] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_COLON_COLON,
  [22720] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
  [22727] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1421), 1,
      anon_sym_LBRACE,
  [22734] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1423), 1,
      anon_sym_LBRACE,
  [22741] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1425), 1,
      sym_identifier,
  [22748] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1427), 1,
      anon_sym_LBRACE,
  [22755] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1429), 1,
      anon_sym_COLON,
  [22762] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1431), 1,
      anon_sym_RBRACK,
  [22769] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1433), 1,
      sym_identifier,
  [22776] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1209), 1,
      anon_sym_COLON_COLON,
  [22783] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1435), 1,
      anon_sym_RBRACE,
  [22790] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1437), 1,
      sym_identifier,
  [22797] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1439), 1,
      anon_sym_EQ,
  [22804] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1441), 1,
      sym_identifier,
  [22811] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(206), 1,
      anon_sym_QMARK,
  [22818] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(890), 1,
      anon_sym_EQ_GT,
  [22825] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1443), 1,
      sym_identifier,
  [22832] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(191), 1,
      anon_sym_COLON_COLON,
  [22839] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_EQ_GT,
  [22846] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(988), 1,
      anon_sym_RBRACE,
  [22853] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1447), 1,
      sym_identifier,
  [22860] = 2,
    ACTIONS(57), 1,
      sym_comment,
    ACTIONS(1449), 1,
      sym_identifier,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(14)] = 0,
  [SMALL_STATE(15)] = 139,
  [SMALL_STATE(16)] = 211,
  [SMALL_STATE(17)] = 283,
  [SMALL_STATE(18)] = 355,
  [SMALL_STATE(19)] = 422,
  [SMALL_STATE(20)] = 488,
  [SMALL_STATE(21)] = 553,
  [SMALL_STATE(22)] = 618,
  [SMALL_STATE(23)] = 683,
  [SMALL_STATE(24)] = 761,
  [SMALL_STATE(25)] = 823,
  [SMALL_STATE(26)] = 891,
  [SMALL_STATE(27)] = 959,
  [SMALL_STATE(28)] = 1021,
  [SMALL_STATE(29)] = 1089,
  [SMALL_STATE(30)] = 1157,
  [SMALL_STATE(31)] = 1225,
  [SMALL_STATE(32)] = 1290,
  [SMALL_STATE(33)] = 1355,
  [SMALL_STATE(34)] = 1420,
  [SMALL_STATE(35)] = 1485,
  [SMALL_STATE(36)] = 1545,
  [SMALL_STATE(37)] = 1605,
  [SMALL_STATE(38)] = 1669,
  [SMALL_STATE(39)] = 1729,
  [SMALL_STATE(40)] = 1789,
  [SMALL_STATE(41)] = 1849,
  [SMALL_STATE(42)] = 1909,
  [SMALL_STATE(43)] = 1969,
  [SMALL_STATE(44)] = 2029,
  [SMALL_STATE(45)] = 2089,
  [SMALL_STATE(46)] = 2149,
  [SMALL_STATE(47)] = 2209,
  [SMALL_STATE(48)] = 2269,
  [SMALL_STATE(49)] = 2329,
  [SMALL_STATE(50)] = 2389,
  [SMALL_STATE(51)] = 2456,
  [SMALL_STATE(52)] = 2521,
  [SMALL_STATE(53)] = 2588,
  [SMALL_STATE(54)] = 2659,
  [SMALL_STATE(55)] = 2736,
  [SMALL_STATE(56)] = 2811,
  [SMALL_STATE(57)] = 2870,
  [SMALL_STATE(58)] = 2929,
  [SMALL_STATE(59)] = 2992,
  [SMALL_STATE(60)] = 3079,
  [SMALL_STATE(61)] = 3138,
  [SMALL_STATE(62)] = 3197,
  [SMALL_STATE(63)] = 3258,
  [SMALL_STATE(64)] = 3319,
  [SMALL_STATE(65)] = 3378,
  [SMALL_STATE(66)] = 3437,
  [SMALL_STATE(67)] = 3496,
  [SMALL_STATE(68)] = 3565,
  [SMALL_STATE(69)] = 3624,
  [SMALL_STATE(70)] = 3691,
  [SMALL_STATE(71)] = 3774,
  [SMALL_STATE(72)] = 3845,
  [SMALL_STATE(73)] = 3904,
  [SMALL_STATE(74)] = 3983,
  [SMALL_STATE(75)] = 4046,
  [SMALL_STATE(76)] = 4131,
  [SMALL_STATE(77)] = 4185,
  [SMALL_STATE(78)] = 4239,
  [SMALL_STATE(79)] = 4288,
  [SMALL_STATE(80)] = 4370,
  [SMALL_STATE(81)] = 4452,
  [SMALL_STATE(82)] = 4500,
  [SMALL_STATE(83)] = 4548,
  [SMALL_STATE(84)] = 4596,
  [SMALL_STATE(85)] = 4639,
  [SMALL_STATE(86)] = 4686,
  [SMALL_STATE(87)] = 4729,
  [SMALL_STATE(88)] = 4772,
  [SMALL_STATE(89)] = 4815,
  [SMALL_STATE(90)] = 4858,
  [SMALL_STATE(91)] = 4905,
  [SMALL_STATE(92)] = 4952,
  [SMALL_STATE(93)] = 4995,
  [SMALL_STATE(94)] = 5038,
  [SMALL_STATE(95)] = 5081,
  [SMALL_STATE(96)] = 5124,
  [SMALL_STATE(97)] = 5169,
  [SMALL_STATE(98)] = 5212,
  [SMALL_STATE(99)] = 5291,
  [SMALL_STATE(100)] = 5334,
  [SMALL_STATE(101)] = 5377,
  [SMALL_STATE(102)] = 5420,
  [SMALL_STATE(103)] = 5463,
  [SMALL_STATE(104)] = 5510,
  [SMALL_STATE(105)] = 5553,
  [SMALL_STATE(106)] = 5596,
  [SMALL_STATE(107)] = 5639,
  [SMALL_STATE(108)] = 5682,
  [SMALL_STATE(109)] = 5729,
  [SMALL_STATE(110)] = 5772,
  [SMALL_STATE(111)] = 5815,
  [SMALL_STATE(112)] = 5862,
  [SMALL_STATE(113)] = 5905,
  [SMALL_STATE(114)] = 5952,
  [SMALL_STATE(115)] = 5999,
  [SMALL_STATE(116)] = 6046,
  [SMALL_STATE(117)] = 6088,
  [SMALL_STATE(118)] = 6130,
  [SMALL_STATE(119)] = 6172,
  [SMALL_STATE(120)] = 6214,
  [SMALL_STATE(121)] = 6258,
  [SMALL_STATE(122)] = 6302,
  [SMALL_STATE(123)] = 6348,
  [SMALL_STATE(124)] = 6390,
  [SMALL_STATE(125)] = 6432,
  [SMALL_STATE(126)] = 6474,
  [SMALL_STATE(127)] = 6558,
  [SMALL_STATE(128)] = 6599,
  [SMALL_STATE(129)] = 6640,
  [SMALL_STATE(130)] = 6681,
  [SMALL_STATE(131)] = 6722,
  [SMALL_STATE(132)] = 6797,
  [SMALL_STATE(133)] = 6838,
  [SMALL_STATE(134)] = 6879,
  [SMALL_STATE(135)] = 6920,
  [SMALL_STATE(136)] = 6995,
  [SMALL_STATE(137)] = 7036,
  [SMALL_STATE(138)] = 7077,
  [SMALL_STATE(139)] = 7118,
  [SMALL_STATE(140)] = 7193,
  [SMALL_STATE(141)] = 7234,
  [SMALL_STATE(142)] = 7275,
  [SMALL_STATE(143)] = 7316,
  [SMALL_STATE(144)] = 7357,
  [SMALL_STATE(145)] = 7398,
  [SMALL_STATE(146)] = 7473,
  [SMALL_STATE(147)] = 7514,
  [SMALL_STATE(148)] = 7555,
  [SMALL_STATE(149)] = 7596,
  [SMALL_STATE(150)] = 7637,
  [SMALL_STATE(151)] = 7678,
  [SMALL_STATE(152)] = 7719,
  [SMALL_STATE(153)] = 7760,
  [SMALL_STATE(154)] = 7835,
  [SMALL_STATE(155)] = 7876,
  [SMALL_STATE(156)] = 7951,
  [SMALL_STATE(157)] = 7992,
  [SMALL_STATE(158)] = 8033,
  [SMALL_STATE(159)] = 8074,
  [SMALL_STATE(160)] = 8115,
  [SMALL_STATE(161)] = 8156,
  [SMALL_STATE(162)] = 8197,
  [SMALL_STATE(163)] = 8238,
  [SMALL_STATE(164)] = 8313,
  [SMALL_STATE(165)] = 8354,
  [SMALL_STATE(166)] = 8395,
  [SMALL_STATE(167)] = 8436,
  [SMALL_STATE(168)] = 8477,
  [SMALL_STATE(169)] = 8520,
  [SMALL_STATE(170)] = 8561,
  [SMALL_STATE(171)] = 8602,
  [SMALL_STATE(172)] = 8643,
  [SMALL_STATE(173)] = 8684,
  [SMALL_STATE(174)] = 8725,
  [SMALL_STATE(175)] = 8766,
  [SMALL_STATE(176)] = 8807,
  [SMALL_STATE(177)] = 8848,
  [SMALL_STATE(178)] = 8889,
  [SMALL_STATE(179)] = 8930,
  [SMALL_STATE(180)] = 8973,
  [SMALL_STATE(181)] = 9014,
  [SMALL_STATE(182)] = 9089,
  [SMALL_STATE(183)] = 9161,
  [SMALL_STATE(184)] = 9233,
  [SMALL_STATE(185)] = 9305,
  [SMALL_STATE(186)] = 9377,
  [SMALL_STATE(187)] = 9449,
  [SMALL_STATE(188)] = 9521,
  [SMALL_STATE(189)] = 9593,
  [SMALL_STATE(190)] = 9665,
  [SMALL_STATE(191)] = 9737,
  [SMALL_STATE(192)] = 9809,
  [SMALL_STATE(193)] = 9881,
  [SMALL_STATE(194)] = 9953,
  [SMALL_STATE(195)] = 10025,
  [SMALL_STATE(196)] = 10097,
  [SMALL_STATE(197)] = 10169,
  [SMALL_STATE(198)] = 10241,
  [SMALL_STATE(199)] = 10313,
  [SMALL_STATE(200)] = 10385,
  [SMALL_STATE(201)] = 10457,
  [SMALL_STATE(202)] = 10529,
  [SMALL_STATE(203)] = 10601,
  [SMALL_STATE(204)] = 10673,
  [SMALL_STATE(205)] = 10745,
  [SMALL_STATE(206)] = 10817,
  [SMALL_STATE(207)] = 10886,
  [SMALL_STATE(208)] = 10955,
  [SMALL_STATE(209)] = 11024,
  [SMALL_STATE(210)] = 11093,
  [SMALL_STATE(211)] = 11162,
  [SMALL_STATE(212)] = 11231,
  [SMALL_STATE(213)] = 11300,
  [SMALL_STATE(214)] = 11369,
  [SMALL_STATE(215)] = 11438,
  [SMALL_STATE(216)] = 11507,
  [SMALL_STATE(217)] = 11576,
  [SMALL_STATE(218)] = 11645,
  [SMALL_STATE(219)] = 11692,
  [SMALL_STATE(220)] = 11731,
  [SMALL_STATE(221)] = 11800,
  [SMALL_STATE(222)] = 11869,
  [SMALL_STATE(223)] = 11938,
  [SMALL_STATE(224)] = 12007,
  [SMALL_STATE(225)] = 12050,
  [SMALL_STATE(226)] = 12119,
  [SMALL_STATE(227)] = 12188,
  [SMALL_STATE(228)] = 12257,
  [SMALL_STATE(229)] = 12304,
  [SMALL_STATE(230)] = 12373,
  [SMALL_STATE(231)] = 12412,
  [SMALL_STATE(232)] = 12481,
  [SMALL_STATE(233)] = 12550,
  [SMALL_STATE(234)] = 12619,
  [SMALL_STATE(235)] = 12688,
  [SMALL_STATE(236)] = 12757,
  [SMALL_STATE(237)] = 12796,
  [SMALL_STATE(238)] = 12865,
  [SMALL_STATE(239)] = 12934,
  [SMALL_STATE(240)] = 13003,
  [SMALL_STATE(241)] = 13072,
  [SMALL_STATE(242)] = 13141,
  [SMALL_STATE(243)] = 13210,
  [SMALL_STATE(244)] = 13279,
  [SMALL_STATE(245)] = 13326,
  [SMALL_STATE(246)] = 13395,
  [SMALL_STATE(247)] = 13464,
  [SMALL_STATE(248)] = 13533,
  [SMALL_STATE(249)] = 13602,
  [SMALL_STATE(250)] = 13671,
  [SMALL_STATE(251)] = 13740,
  [SMALL_STATE(252)] = 13787,
  [SMALL_STATE(253)] = 13856,
  [SMALL_STATE(254)] = 13925,
  [SMALL_STATE(255)] = 13994,
  [SMALL_STATE(256)] = 14063,
  [SMALL_STATE(257)] = 14132,
  [SMALL_STATE(258)] = 14201,
  [SMALL_STATE(259)] = 14270,
  [SMALL_STATE(260)] = 14309,
  [SMALL_STATE(261)] = 14378,
  [SMALL_STATE(262)] = 14447,
  [SMALL_STATE(263)] = 14516,
  [SMALL_STATE(264)] = 14585,
  [SMALL_STATE(265)] = 14654,
  [SMALL_STATE(266)] = 14723,
  [SMALL_STATE(267)] = 14792,
  [SMALL_STATE(268)] = 14861,
  [SMALL_STATE(269)] = 14930,
  [SMALL_STATE(270)] = 14970,
  [SMALL_STATE(271)] = 15008,
  [SMALL_STATE(272)] = 15048,
  [SMALL_STATE(273)] = 15086,
  [SMALL_STATE(274)] = 15124,
  [SMALL_STATE(275)] = 15162,
  [SMALL_STATE(276)] = 15199,
  [SMALL_STATE(277)] = 15236,
  [SMALL_STATE(278)] = 15273,
  [SMALL_STATE(279)] = 15310,
  [SMALL_STATE(280)] = 15347,
  [SMALL_STATE(281)] = 15384,
  [SMALL_STATE(282)] = 15421,
  [SMALL_STATE(283)] = 15458,
  [SMALL_STATE(284)] = 15495,
  [SMALL_STATE(285)] = 15532,
  [SMALL_STATE(286)] = 15569,
  [SMALL_STATE(287)] = 15606,
  [SMALL_STATE(288)] = 15643,
  [SMALL_STATE(289)] = 15680,
  [SMALL_STATE(290)] = 15717,
  [SMALL_STATE(291)] = 15754,
  [SMALL_STATE(292)] = 15791,
  [SMALL_STATE(293)] = 15828,
  [SMALL_STATE(294)] = 15865,
  [SMALL_STATE(295)] = 15914,
  [SMALL_STATE(296)] = 15959,
  [SMALL_STATE(297)] = 16002,
  [SMALL_STATE(298)] = 16057,
  [SMALL_STATE(299)] = 16110,
  [SMALL_STATE(300)] = 16161,
  [SMALL_STATE(301)] = 16202,
  [SMALL_STATE(302)] = 16241,
  [SMALL_STATE(303)] = 16288,
  [SMALL_STATE(304)] = 16327,
  [SMALL_STATE(305)] = 16370,
  [SMALL_STATE(306)] = 16422,
  [SMALL_STATE(307)] = 16474,
  [SMALL_STATE(308)] = 16526,
  [SMALL_STATE(309)] = 16578,
  [SMALL_STATE(310)] = 16627,
  [SMALL_STATE(311)] = 16676,
  [SMALL_STATE(312)] = 16725,
  [SMALL_STATE(313)] = 16774,
  [SMALL_STATE(314)] = 16823,
  [SMALL_STATE(315)] = 16872,
  [SMALL_STATE(316)] = 16910,
  [SMALL_STATE(317)] = 16948,
  [SMALL_STATE(318)] = 16986,
  [SMALL_STATE(319)] = 17024,
  [SMALL_STATE(320)] = 17070,
  [SMALL_STATE(321)] = 17108,
  [SMALL_STATE(322)] = 17146,
  [SMALL_STATE(323)] = 17184,
  [SMALL_STATE(324)] = 17222,
  [SMALL_STATE(325)] = 17260,
  [SMALL_STATE(326)] = 17314,
  [SMALL_STATE(327)] = 17371,
  [SMALL_STATE(328)] = 17428,
  [SMALL_STATE(329)] = 17485,
  [SMALL_STATE(330)] = 17542,
  [SMALL_STATE(331)] = 17599,
  [SMALL_STATE(332)] = 17656,
  [SMALL_STATE(333)] = 17713,
  [SMALL_STATE(334)] = 17766,
  [SMALL_STATE(335)] = 17801,
  [SMALL_STATE(336)] = 17858,
  [SMALL_STATE(337)] = 17898,
  [SMALL_STATE(338)] = 17950,
  [SMALL_STATE(339)] = 18004,
  [SMALL_STATE(340)] = 18044,
  [SMALL_STATE(341)] = 18098,
  [SMALL_STATE(342)] = 18130,
  [SMALL_STATE(343)] = 18170,
  [SMALL_STATE(344)] = 18222,
  [SMALL_STATE(345)] = 18276,
  [SMALL_STATE(346)] = 18330,
  [SMALL_STATE(347)] = 18384,
  [SMALL_STATE(348)] = 18421,
  [SMALL_STATE(349)] = 18472,
  [SMALL_STATE(350)] = 18513,
  [SMALL_STATE(351)] = 18556,
  [SMALL_STATE(352)] = 18595,
  [SMALL_STATE(353)] = 18632,
  [SMALL_STATE(354)] = 18681,
  [SMALL_STATE(355)] = 18732,
  [SMALL_STATE(356)] = 18779,
  [SMALL_STATE(357)] = 18824,
  [SMALL_STATE(358)] = 18859,
  [SMALL_STATE(359)] = 18892,
  [SMALL_STATE(360)] = 18943,
  [SMALL_STATE(361)] = 18994,
  [SMALL_STATE(362)] = 19045,
  [SMALL_STATE(363)] = 19078,
  [SMALL_STATE(364)] = 19113,
  [SMALL_STATE(365)] = 19158,
  [SMALL_STATE(366)] = 19205,
  [SMALL_STATE(367)] = 19254,
  [SMALL_STATE(368)] = 19293,
  [SMALL_STATE(369)] = 19336,
  [SMALL_STATE(370)] = 19377,
  [SMALL_STATE(371)] = 19428,
  [SMALL_STATE(372)] = 19479,
  [SMALL_STATE(373)] = 19530,
  [SMALL_STATE(374)] = 19563,
  [SMALL_STATE(375)] = 19596,
  [SMALL_STATE(376)] = 19622,
  [SMALL_STATE(377)] = 19648,
  [SMALL_STATE(378)] = 19674,
  [SMALL_STATE(379)] = 19700,
  [SMALL_STATE(380)] = 19741,
  [SMALL_STATE(381)] = 19762,
  [SMALL_STATE(382)] = 19791,
  [SMALL_STATE(383)] = 19820,
  [SMALL_STATE(384)] = 19849,
  [SMALL_STATE(385)] = 19875,
  [SMALL_STATE(386)] = 19903,
  [SMALL_STATE(387)] = 19931,
  [SMALL_STATE(388)] = 19957,
  [SMALL_STATE(389)] = 19983,
  [SMALL_STATE(390)] = 20009,
  [SMALL_STATE(391)] = 20035,
  [SMALL_STATE(392)] = 20061,
  [SMALL_STATE(393)] = 20089,
  [SMALL_STATE(394)] = 20117,
  [SMALL_STATE(395)] = 20143,
  [SMALL_STATE(396)] = 20171,
  [SMALL_STATE(397)] = 20199,
  [SMALL_STATE(398)] = 20227,
  [SMALL_STATE(399)] = 20255,
  [SMALL_STATE(400)] = 20283,
  [SMALL_STATE(401)] = 20311,
  [SMALL_STATE(402)] = 20337,
  [SMALL_STATE(403)] = 20365,
  [SMALL_STATE(404)] = 20391,
  [SMALL_STATE(405)] = 20419,
  [SMALL_STATE(406)] = 20444,
  [SMALL_STATE(407)] = 20466,
  [SMALL_STATE(408)] = 20488,
  [SMALL_STATE(409)] = 20508,
  [SMALL_STATE(410)] = 20528,
  [SMALL_STATE(411)] = 20548,
  [SMALL_STATE(412)] = 20571,
  [SMALL_STATE(413)] = 20594,
  [SMALL_STATE(414)] = 20609,
  [SMALL_STATE(415)] = 20626,
  [SMALL_STATE(416)] = 20643,
  [SMALL_STATE(417)] = 20664,
  [SMALL_STATE(418)] = 20682,
  [SMALL_STATE(419)] = 20702,
  [SMALL_STATE(420)] = 20720,
  [SMALL_STATE(421)] = 20742,
  [SMALL_STATE(422)] = 20760,
  [SMALL_STATE(423)] = 20782,
  [SMALL_STATE(424)] = 20804,
  [SMALL_STATE(425)] = 20818,
  [SMALL_STATE(426)] = 20836,
  [SMALL_STATE(427)] = 20854,
  [SMALL_STATE(428)] = 20874,
  [SMALL_STATE(429)] = 20888,
  [SMALL_STATE(430)] = 20908,
  [SMALL_STATE(431)] = 20926,
  [SMALL_STATE(432)] = 20946,
  [SMALL_STATE(433)] = 20964,
  [SMALL_STATE(434)] = 20984,
  [SMALL_STATE(435)] = 21006,
  [SMALL_STATE(436)] = 21023,
  [SMALL_STATE(437)] = 21038,
  [SMALL_STATE(438)] = 21053,
  [SMALL_STATE(439)] = 21068,
  [SMALL_STATE(440)] = 21085,
  [SMALL_STATE(441)] = 21100,
  [SMALL_STATE(442)] = 21115,
  [SMALL_STATE(443)] = 21134,
  [SMALL_STATE(444)] = 21151,
  [SMALL_STATE(445)] = 21168,
  [SMALL_STATE(446)] = 21187,
  [SMALL_STATE(447)] = 21201,
  [SMALL_STATE(448)] = 21217,
  [SMALL_STATE(449)] = 21233,
  [SMALL_STATE(450)] = 21247,
  [SMALL_STATE(451)] = 21261,
  [SMALL_STATE(452)] = 21275,
  [SMALL_STATE(453)] = 21291,
  [SMALL_STATE(454)] = 21301,
  [SMALL_STATE(455)] = 21317,
  [SMALL_STATE(456)] = 21331,
  [SMALL_STATE(457)] = 21347,
  [SMALL_STATE(458)] = 21363,
  [SMALL_STATE(459)] = 21377,
  [SMALL_STATE(460)] = 21393,
  [SMALL_STATE(461)] = 21407,
  [SMALL_STATE(462)] = 21421,
  [SMALL_STATE(463)] = 21435,
  [SMALL_STATE(464)] = 21449,
  [SMALL_STATE(465)] = 21463,
  [SMALL_STATE(466)] = 21477,
  [SMALL_STATE(467)] = 21489,
  [SMALL_STATE(468)] = 21503,
  [SMALL_STATE(469)] = 21517,
  [SMALL_STATE(470)] = 21530,
  [SMALL_STATE(471)] = 21543,
  [SMALL_STATE(472)] = 21556,
  [SMALL_STATE(473)] = 21569,
  [SMALL_STATE(474)] = 21582,
  [SMALL_STATE(475)] = 21591,
  [SMALL_STATE(476)] = 21604,
  [SMALL_STATE(477)] = 21617,
  [SMALL_STATE(478)] = 21630,
  [SMALL_STATE(479)] = 21641,
  [SMALL_STATE(480)] = 21654,
  [SMALL_STATE(481)] = 21667,
  [SMALL_STATE(482)] = 21680,
  [SMALL_STATE(483)] = 21689,
  [SMALL_STATE(484)] = 21698,
  [SMALL_STATE(485)] = 21711,
  [SMALL_STATE(486)] = 21724,
  [SMALL_STATE(487)] = 21733,
  [SMALL_STATE(488)] = 21742,
  [SMALL_STATE(489)] = 21755,
  [SMALL_STATE(490)] = 21768,
  [SMALL_STATE(491)] = 21781,
  [SMALL_STATE(492)] = 21794,
  [SMALL_STATE(493)] = 21807,
  [SMALL_STATE(494)] = 21816,
  [SMALL_STATE(495)] = 21829,
  [SMALL_STATE(496)] = 21842,
  [SMALL_STATE(497)] = 21855,
  [SMALL_STATE(498)] = 21868,
  [SMALL_STATE(499)] = 21881,
  [SMALL_STATE(500)] = 21894,
  [SMALL_STATE(501)] = 21907,
  [SMALL_STATE(502)] = 21918,
  [SMALL_STATE(503)] = 21931,
  [SMALL_STATE(504)] = 21944,
  [SMALL_STATE(505)] = 21957,
  [SMALL_STATE(506)] = 21970,
  [SMALL_STATE(507)] = 21983,
  [SMALL_STATE(508)] = 21996,
  [SMALL_STATE(509)] = 22009,
  [SMALL_STATE(510)] = 22022,
  [SMALL_STATE(511)] = 22035,
  [SMALL_STATE(512)] = 22048,
  [SMALL_STATE(513)] = 22061,
  [SMALL_STATE(514)] = 22072,
  [SMALL_STATE(515)] = 22085,
  [SMALL_STATE(516)] = 22098,
  [SMALL_STATE(517)] = 22111,
  [SMALL_STATE(518)] = 22120,
  [SMALL_STATE(519)] = 22133,
  [SMALL_STATE(520)] = 22146,
  [SMALL_STATE(521)] = 22157,
  [SMALL_STATE(522)] = 22170,
  [SMALL_STATE(523)] = 22183,
  [SMALL_STATE(524)] = 22196,
  [SMALL_STATE(525)] = 22209,
  [SMALL_STATE(526)] = 22222,
  [SMALL_STATE(527)] = 22235,
  [SMALL_STATE(528)] = 22248,
  [SMALL_STATE(529)] = 22261,
  [SMALL_STATE(530)] = 22274,
  [SMALL_STATE(531)] = 22287,
  [SMALL_STATE(532)] = 22300,
  [SMALL_STATE(533)] = 22309,
  [SMALL_STATE(534)] = 22322,
  [SMALL_STATE(535)] = 22335,
  [SMALL_STATE(536)] = 22348,
  [SMALL_STATE(537)] = 22361,
  [SMALL_STATE(538)] = 22372,
  [SMALL_STATE(539)] = 22382,
  [SMALL_STATE(540)] = 22392,
  [SMALL_STATE(541)] = 22402,
  [SMALL_STATE(542)] = 22410,
  [SMALL_STATE(543)] = 22420,
  [SMALL_STATE(544)] = 22430,
  [SMALL_STATE(545)] = 22438,
  [SMALL_STATE(546)] = 22446,
  [SMALL_STATE(547)] = 22456,
  [SMALL_STATE(548)] = 22466,
  [SMALL_STATE(549)] = 22476,
  [SMALL_STATE(550)] = 22486,
  [SMALL_STATE(551)] = 22496,
  [SMALL_STATE(552)] = 22506,
  [SMALL_STATE(553)] = 22516,
  [SMALL_STATE(554)] = 22524,
  [SMALL_STATE(555)] = 22532,
  [SMALL_STATE(556)] = 22542,
  [SMALL_STATE(557)] = 22552,
  [SMALL_STATE(558)] = 22560,
  [SMALL_STATE(559)] = 22570,
  [SMALL_STATE(560)] = 22578,
  [SMALL_STATE(561)] = 22588,
  [SMALL_STATE(562)] = 22596,
  [SMALL_STATE(563)] = 22604,
  [SMALL_STATE(564)] = 22614,
  [SMALL_STATE(565)] = 22624,
  [SMALL_STATE(566)] = 22632,
  [SMALL_STATE(567)] = 22640,
  [SMALL_STATE(568)] = 22650,
  [SMALL_STATE(569)] = 22657,
  [SMALL_STATE(570)] = 22664,
  [SMALL_STATE(571)] = 22671,
  [SMALL_STATE(572)] = 22678,
  [SMALL_STATE(573)] = 22685,
  [SMALL_STATE(574)] = 22692,
  [SMALL_STATE(575)] = 22699,
  [SMALL_STATE(576)] = 22706,
  [SMALL_STATE(577)] = 22713,
  [SMALL_STATE(578)] = 22720,
  [SMALL_STATE(579)] = 22727,
  [SMALL_STATE(580)] = 22734,
  [SMALL_STATE(581)] = 22741,
  [SMALL_STATE(582)] = 22748,
  [SMALL_STATE(583)] = 22755,
  [SMALL_STATE(584)] = 22762,
  [SMALL_STATE(585)] = 22769,
  [SMALL_STATE(586)] = 22776,
  [SMALL_STATE(587)] = 22783,
  [SMALL_STATE(588)] = 22790,
  [SMALL_STATE(589)] = 22797,
  [SMALL_STATE(590)] = 22804,
  [SMALL_STATE(591)] = 22811,
  [SMALL_STATE(592)] = 22818,
  [SMALL_STATE(593)] = 22825,
  [SMALL_STATE(594)] = 22832,
  [SMALL_STATE(595)] = 22839,
  [SMALL_STATE(596)] = 22846,
  [SMALL_STATE(597)] = 22853,
  [SMALL_STATE(598)] = 22860,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(468),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(211),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(267),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(25),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [59] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0),
  [61] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(402),
  [64] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(468),
  [67] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(243),
  [70] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(411),
  [73] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(463),
  [76] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(446),
  [79] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(450),
  [82] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(455),
  [85] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(462),
  [88] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(416),
  [91] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(407),
  [94] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(384),
  [97] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(211),
  [100] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(253),
  [103] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(267),
  [106] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(194),
  [109] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(238),
  [112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(238),
  [115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(443),
  [118] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(230),
  [121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(230),
  [124] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(391),
  [127] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(430),
  [130] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(219),
  [133] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(25),
  [136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1, 0, 0),
  [156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_identifier_repeat1, 2, 0, 0),
  [160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_identifier_repeat1, 2, 0, 0),
  [162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(574),
  [165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_identifier, 3, 0, 0),
  [167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_identifier, 3, 0, 0),
  [169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_identifier, 4, 0, 0),
  [173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_identifier, 4, 0, 0),
  [175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable, 2, 0, 0),
  [177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable, 2, 0, 0),
  [179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2, 0, 0),
  [181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2, 0, 0),
  [183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3, 0, 0),
  [185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3, 0, 0),
  [187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier, 1, 0, 0),
  [189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__identifier, 1, 0, 0),
  [191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0),
  [195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, 0, 0),
  [197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0), REDUCE(sym_expression, 1, 0, 0),
  [200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [210] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_statement, 1, 0, 0), REDUCE(sym_expression, 1, 0, 0),
  [213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_reference, 4, 0, 0),
  [217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_resource_reference, 4, 0, 0),
  [219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call, 3, 0, 0),
  [223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_call, 3, 0, 0),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_reference, 5, 0, 0),
  [229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_resource_reference, 5, 0, 0),
  [231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call, 4, 0, 0),
  [233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_call, 4, 0, 0),
  [235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call, 5, 0, 0),
  [237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_call, 5, 0, 0),
  [239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call, 6, 0, 0),
  [241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_call, 6, 0, 0),
  [243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash, 4, 0, 0),
  [245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash, 4, 0, 0),
  [247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash, 3, 0, 0),
  [249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash, 3, 0, 0),
  [251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash, 5, 0, 0),
  [253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash, 5, 0, 0),
  [255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash, 2, 0, 0),
  [257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash, 2, 0, 0),
  [259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2, 0, 0),
  [261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2, 0, 0),
  [263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 3, 0, 0),
  [265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 3, 0, 0),
  [267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 4, 0, 0),
  [269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 4, 0, 0),
  [271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call, 7, 0, 0),
  [273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_call, 7, 0, 0),
  [275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 5, 0, 0),
  [277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 5, 0, 0),
  [279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3, 0, 0),
  [281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3, 0, 0),
  [283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 1, 0, 0),
  [285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 1, 0, 0),
  [287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 2),
  [289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 2),
  [291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(252),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3, 0, 0),
  [311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3, 0, 0),
  [313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 4, 0, 0),
  [315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 4, 0, 0),
  [317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 1),
  [319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 1),
  [321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3, 0, 0),
  [323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment, 3, 0, 0),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 5, 0, 0),
  [337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 5, 0, 0),
  [339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2, 0, 0),
  [341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2, 0, 0),
  [343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal, 1, 0, 0),
  [345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal, 1, 0, 0),
  [347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, 0, 0),
  [349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, 0, 0),
  [351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean, 1, 0, 0),
  [353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean, 1, 0, 0),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [357] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0), REDUCE(sym_literal, 1, 0, 0),
  [360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_statement, 1, 0, 0), REDUCE(sym_literal, 1, 0, 0),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 0),
  [371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 0),
  [373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, 0, 0),
  [379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, 0, 0),
  [381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 0),
  [383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 0),
  [385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(208),
  [388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(247),
  [398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(597),
  [413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_selector, 6, 0, 0),
  [417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_selector, 6, 0, 0),
  [419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elsif_statement, 3, 0, 0),
  [421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elsif_statement, 3, 0, 0),
  [423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0),
  [425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 3, 0, 0),
  [427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_type, 3, 0, 0),
  [429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_type, 3, 0, 0),
  [431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_include_statement, 2, 0, 0),
  [433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_include_statement, 2, 0, 0),
  [435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tag_statement, 2, 0, 0),
  [439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tag_statement, 2, 0, 0),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_selector, 5, 0, 0),
  [445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_selector, 5, 0, 0),
  [447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_type, 4, 0, 0),
  [449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_type, 4, 0, 0),
  [451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_composite_type, 4, 0, 0),
  [453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_composite_type, 4, 0, 0),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0),
  [459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 4, 0, 0),
  [461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(393),
  [464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0),
  [466] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(243),
  [469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0),
  [471] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(194),
  [474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(247),
  [477] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(247),
  [480] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(439),
  [483] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(230),
  [486] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(230),
  [489] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(388),
  [492] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(417),
  [495] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(219),
  [498] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(224),
  [501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_selector, 7, 0, 0),
  [503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_selector, 7, 0, 0),
  [505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0),
  [507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 2, 0, 0),
  [509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_type, 2, 0, 0),
  [511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_type, 2, 0, 0),
  [513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_builtin_type, 1, 0, 0),
  [515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_builtin_type, 1, 0, 0),
  [517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_composite_type, 6, 0, 0),
  [519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_composite_type, 6, 0, 0),
  [521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_selector, 4, 0, 0),
  [523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_selector, 4, 0, 0),
  [525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, 0, 0),
  [527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 1, 0, 0),
  [529] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(585),
  [532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_type, 5, 0, 0),
  [534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_type, 5, 0, 0),
  [536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_composite_type, 5, 0, 0),
  [538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_composite_type, 5, 0, 0),
  [540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tag_statement_repeat1, 2, 0, 0),
  [542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_tag_statement_repeat1, 2, 0, 0),
  [544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tag_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(387),
  [547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0),
  [549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 5, 0, 0),
  [551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_include_statement_repeat1, 2, 0, 0),
  [553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_include_statement_repeat1, 2, 0, 0),
  [555] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_include_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(406),
  [558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_include_statement, 3, 0, 0),
  [560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_include_statement, 3, 0, 0),
  [562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tag_statement, 3, 0, 0),
  [564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tag_statement, 3, 0, 0),
  [566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(318),
  [578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_default, 3, 0, 3),
  [580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_resource_default, 3, 0, 3),
  [582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defined_resource_type, 4, 0, 0),
  [584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defined_resource_type, 4, 0, 0),
  [586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_collector, 3, 0, 0),
  [588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_resource_collector, 3, 0, 0),
  [590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 6, 0, 0),
  [592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 6, 0, 0),
  [594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_declaration, 6, 0, 14),
  [598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_resource_declaration, 6, 0, 14),
  [600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relation, 3, 0, 0),
  [602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_relation, 3, 0, 0),
  [604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_declaration, 6, 0, 9),
  [606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_resource_declaration, 6, 0, 9),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_declaration, 6, 0, 13),
  [612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_resource_declaration, 6, 0, 13),
  [614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_declaration, 6, 0, 8),
  [616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_resource_declaration, 6, 0, 8),
  [618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 0),
  [620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, 0, 0),
  [622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_declaration, 5, 0, 11),
  [626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_resource_declaration, 5, 0, 11),
  [628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_declaration, 5, 0, 6),
  [630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_resource_declaration, 5, 0, 6),
  [632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_default, 5, 0, 3),
  [634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_resource_default, 5, 0, 3),
  [636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iterator_statement, 6, 0, 5),
  [638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iterator_statement, 6, 0, 5),
  [640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iterator_statement, 5, 0, 5),
  [642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iterator_statement, 5, 0, 5),
  [644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_default, 6, 0, 3),
  [646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_resource_default, 6, 0, 3),
  [648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_declaration, 6, 0, 11),
  [650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_resource_declaration, 6, 0, 11),
  [652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 3, 0, 0),
  [654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 3, 0, 0),
  [656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 5, 0, 0),
  [658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 5, 0, 0),
  [660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 0),
  [662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 0),
  [664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_statement, 2, 0, 0),
  [666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_statement, 2, 0, 0),
  [668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_declaration, 7, 0, 13),
  [670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_resource_declaration, 7, 0, 13),
  [672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_declaration, 5, 0, 9),
  [676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_resource_declaration, 5, 0, 9),
  [678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_declaration, 5, 0, 8),
  [682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_resource_declaration, 5, 0, 8),
  [684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 0),
  [686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 0),
  [688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 5, 0, 0),
  [690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 5, 0, 0),
  [692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_declaration, 7, 0, 14),
  [694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_resource_declaration, 7, 0, 14),
  [696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_require_statement, 2, 0, 0),
  [698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_require_statement, 2, 0, 0),
  [700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_node_definition, 3, 0, 0),
  [702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_node_definition, 3, 0, 0),
  [704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_declaration, 4, 0, 6),
  [708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_resource_declaration, 4, 0, 6),
  [710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_default, 4, 0, 3),
  [712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_resource_default, 4, 0, 3),
  [714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iterator_statement, 4, 0, 5),
  [716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iterator_statement, 4, 0, 5),
  [718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 4, 0, 0),
  [720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_declaration, 4, 0, 0),
  [722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, 0, 0),
  [726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, 0, 0),
  [728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 4, 0, 0),
  [730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 4, 0, 0),
  [732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unless_statement, 3, 0, 0),
  [734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unless_statement, 3, 0, 0),
  [736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_collector, 4, 0, 0),
  [738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_resource_collector, 4, 0, 0),
  [740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defined_resource_type, 3, 0, 0),
  [742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defined_resource_type, 3, 0, 0),
  [744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 4, 0, 0),
  [746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 4, 0, 0),
  [748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 3, 0, 0),
  [750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 3, 0, 0),
  [752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1, 0, 0),
  [754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1, 0, 0),
  [756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_node_definition, 4, 0, 0),
  [760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_node_definition, 4, 0, 0),
  [762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(231),
  [764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(248),
  [810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(68),
  [824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_item_repeat1, 2, 0, 0),
  [894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, 0, 4),
  [926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 4, 0, 0),
  [932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, 0, 0),
  [962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [1000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [1002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_item, 4, 0, 0),
  [1004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_item, 4, 0, 0),
  [1006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_item, 3, 0, 0),
  [1008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_item, 3, 0, 0),
  [1010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [1012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [1014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__resource_block, 5, 0, 7),
  [1016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [1018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__resource_block, 4, 0, 7),
  [1020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__resource_block, 2, 0, 7),
  [1022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [1024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [1026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [1028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [1030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [1032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [1034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [1036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [1038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(270),
  [1040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [1042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(389),
  [1044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(181),
  [1046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [1048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [1050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [1052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [1054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20),
  [1056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [1058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [1060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [1062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [1064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [1066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [1068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [1070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [1072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [1074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [1076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [1078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [1080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(21),
  [1082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [1084] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(461),
  [1087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0),
  [1089] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(403),
  [1092] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(403),
  [1095] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(181),
  [1098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [1100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(598),
  [1102] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(598),
  [1105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(565),
  [1107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [1109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [1111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [1113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [1115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2, 0, 0),
  [1117] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2, 0, 0), SHIFT_REPEAT(419),
  [1120] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2, 0, 0), SHIFT_REPEAT(419),
  [1123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [1125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [1127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [1133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [1135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [1137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [1139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [1143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 3, 0, 0),
  [1145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 3, 0, 0),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [1151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(432),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [1159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [1161] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(581),
  [1164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [1166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [1168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [1170] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(215),
  [1173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_item_repeat1, 2, 0, 0), SHIFT_REPEAT(262),
  [1176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [1178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [1180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [1182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [1184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__resource_block_repeat1, 2, 0, 0),
  [1186] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__resource_block_repeat1, 2, 0, 0), SHIFT_REPEAT(405),
  [1189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [1191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [1193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [1197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [1199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [1201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [1203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [1205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__resource_block, 3, 0, 7),
  [1207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [1211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [1229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 5, 0, 0),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [1233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_type_repeat1, 2, 0, 0),
  [1235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_type_repeat1, 2, 0, 0), SHIFT_REPEAT(442),
  [1238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [1240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [1242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_type_entry, 3, 0, 4),
  [1244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [1246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [1248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [1250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [1252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [1254] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(319),
  [1257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0),
  [1259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default, 1, 0, 0),
  [1261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4, 0, 0),
  [1263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [1271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_resource_declaration_repeat1, 2, 0, 12),
  [1273] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_resource_declaration_repeat1, 2, 0, 12), SHIFT_REPEAT(188),
  [1276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [1278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [1280] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_lambda_repeat1, 2, 0, 0), SHIFT_REPEAT(552),
  [1283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_lambda_repeat1, 2, 0, 0),
  [1285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [1287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [1289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [1295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 0),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [1307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_node_definition_repeat1, 2, 0, 0),
  [1309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_node_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(412),
  [1312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_resource_reference_repeat1, 2, 0, 0), SHIFT_REPEAT(429),
  [1315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_resource_reference_repeat1, 2, 0, 0),
  [1317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [1321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [1323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [1327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_composite_type_repeat1, 2, 0, 0),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [1331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [1335] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_composite_type_repeat1, 2, 0, 0), SHIFT_REPEAT(314),
  [1338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [1340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_type_repeat1, 2, 0, 0),
  [1342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [1344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [1346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [1348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [1350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [1352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [1354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [1356] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_type_repeat1, 2, 0, 0), SHIFT_REPEAT(310),
  [1359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [1361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [1367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [1369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [1373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3, 0, 0),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [1383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [1385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 2, 0, 0),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [1393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [1399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_resource_declaration_repeat1, 2, 0, 10),
  [1401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_node_name, 1, 0, 0),
  [1403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_search_expression, 3, 0, 0),
  [1405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_search_expression, 3, 0, 0),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [1409] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [1411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_case, 3, 0, 0),
  [1413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [1417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [1421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [1423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_inherits, 2, 0, 0),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_puppet(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
